README file for PREACT Module

Prepared by C.Ludescher-Furth -- 08/03/00

****************
REVISION HISTORY
****************
      date         Description

  Aug. 03, 2000  -- Created

----------------------------------------------------------------


Index:
   1. CONTENTS
   2. UNPACKING INSTRUCTIONS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. TESTING INSTRUCTIONS
   6. FINAL INSTALLATION
   7. RE-INITIALIZING REACTION TABLES
   8. DOCUMENTATION

************
1. CONTENTS:
************
This directory should contain the following files:

README_Preact:  This file.  Brief descriptions of the other files, and
                instructions for compiling, testing and installing the
                preact library libpreact.a and its test drivers
                testpreact and testf77layer. 

Makefile:       NOTE, "GNU make" must be used
                (usually in /usr/gnu/bin or /usr/local/bin).
		Main Makefile to envoke Makefile(s) in subdirectories.  

-- in subdirectory adpak:
   Makefile 
   Sources to build libadpak.a, an internally used library
	to calculate ionization and radiation rates.        

-- in subdirectory aladdinsub:
   Makefile 
   Sources to build libaladdinsub.a, an internally used library
	for Aladdin format.        
     
-- in subdirectory comput:
   Makefile 
   Sources to build libcomput.a, an internally used library 
	with transformation/interpolation routines.

-- in subdirectory cppsub:
   Makefile 
   Sources to build libcppsub.a, a fortran-c++ wrapper

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing.

-- in subdirectory fpreact:
   Makefile 
   Sources to build libfpreact.a, the f90 interface.

-- in subdirectory include:
	ALCOM		Common block for Aladdin cross-section database.
	ALPCOM  	Common block for Alpack standard Aladdin entry parsing.
	SIGTABL	        Common block for cross-section computation routines.
	SIGTABL_Z	Common block for modified cross-section computation.
	ULOGICAL	Common block for 'UREAD' logical function declarations.

-- in subdirectory include/fpreproc:
   *.h files for source pre-processing.

-- in subdirectory include/preact:
   *.h Interfaces for F77 reaction routines and Macros for reaction classes.

-- in subdirectory portlib:
   Makefile
   Sources to build internally used portability library libportlib.a.


-- in subdirectory preact:
   README: Copy of README_preact
   Makefile		   To compile libraries and programs
   ORNL6086.DAT		   Aladdin cross-section data.
   USERGUIDE               Detailed description of code.
   Sources to build the library libpreact.a
       *.cpp               Implementation of reaction classes
       *_z.f               Modified sources from TRANSP comput and sigsub
       icode_preact.f      Return code.

   Sources for programs:
	fpreact_test.f90   Test driver for F90 layer atop PREACT module.
	preact_change.cpp  Changes the parameters of a reaction table.
	preact_init.cpp	   Initializes table parameters for each reaction.
	preact_list.cpp	   Lists table parameters for a particular reaction.
	testpreact.cpp	   Test driver for F77 layer atop PREACT module.
	testf77layer.f	   Test driver for PREACT module.

   preactinit	           Script clears and re-initializes reaction tables.
   fpreact_test.output     Sample output from fpreact_test

-- in subdirectory prefpp:
   Makefile 
   Sources to build prefpp and postfpp, the Fortran pre- and post-processors.


-- in subdirectory share:
   Make.flags:        Include file for Makefile, to setup Flags, etc.
   Make.local.sample: Include file for Makefile, to setup non-conventional,
                      site specific locations.

-- in subdirectory sigsub:
   Makefile 
   Sources to build libsigsub.a, an internally used
	library with cross-section routines for atomic and nuclear
        reactions.
   

**************************
2. UNPACKING INSTRUCTIONS:
**************************
for tarfiles:
  > gunzip trread.tar.gz
  > tar xvf trread.tar

or, for zip archives:
  > unzip trread.zip


****************
3. DESTINATIONS:
****************
Or where do the files go?
(this refers to building and testing; see FINAL INSTALLATION for end result) 


When you extract the tar file you get sub directories:

./adpak             --  to calculate ionization and radiation rates
./aladdinsub        --  ORNL Atomic Physics Data Center
./comput            --  low level TRANSP routines
./cppsub            --  fortran c++ wrapper
./fpreproc          --  scripts for pre-processing of fortran
./include           --  include files for sigsub and alladinsub
./include/preact    --  *.h files for preact
./include/fpreproc  --  *.h files for cpp
./portlib           --  internally used portability library
./preact            --  sources and Makefile
./prefpp            --  Fortran pre/post processor
./share             --  include file Make.flags, Make.local.sample
./sigsub            --  atomic/nuclear cross sections integration



The makefile will create more sub directories,

${OBJ}/lib	     	for the libraries
${OBJ}/obj/*	   	for compiled objects and pre-processed sources
${OBJ}/test   		for the test programs and utilities
${PREACTDIR}/data       for Aladdin cross-section data.
${PREACTDIR}/tables/*  	Directory structure for precomputed reaction tables.

You must define the environment PREACTDIR. The data and tables are
independent of architecture, so everyone can access the same tables. 

By default ${OBJ} is  ./<MACHINE>, which is determined by Make.flags.
e.g.: if you are running Linux, and the tar file resides in $HOME/foo,
      the directories would be in
      $HOME/foo/LINUX/...

Note: ${OBJ} is platform dependent, whereas ${PREACTDIR} is not.
 
You can overwrite the destination by defining OBJ, as an environment
variable (e.g. export OBJ=/dir1/dir2),
or with make (e.g. "make all OBJ=.").
If OBJ is defined, the destinations will be
$OBJ/lib and $OBJ/test.
If OBJ is defined as "." then, in the example above, the destination
would be $HOME/foo/lib.

The rationale behind <MACHINE> is to facilitate building for various platforms.

Note: If you define OBJ as option to gmake, you have to consistently do so;
      e.g: gmake clean OBJ=., gmake install OBJ=.

 
*************************
4. BUILDING INSTRUCTIONS:
*************************

>>> Note <<<
To compile this code, you'll need gcc 3.X or a reasonable C++ compiler.


Building libraries, proprams and tables
---------------------------------------

Choose or create the root directory where you wish to build the 
Plasma Reaction Tables. Set the environment variable PREACTDIR to be
the full pathname of the directory where the Tables will be stored.
The Makefile will initialize the Tables after buiding the test programs.

From the top directory (where you extracted the {tar,zip} file):
 
> gmake            -- to compile libraries, link all test programs
                      and initialize tables

> gmake clean      -- to remove objects
> gmake realclean  -- to remove objects and library


Compiling on Linux:
-------------------

By default the Makefile will select Fujitsu f95.

To select a different compiler define
FORTRAN_VARIANT to "Portland"  "NagWare"  "Fujitsu" or "Absoft"

e.g.:
setenv FORTRAN_VARIANT Portland (csh)
FORTRAN_VARIANT=Portland; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=Portland

To use vastf90:
> gmake VAST90=y

To use NAG90: 
> gmake NAG90=y

Note: By default the test programs, nubeam_test and nubeam_driver,
      are linked with lf95. If you encounter a problem, try linking with g++:

> gmake USEFC=N 


Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefor the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


Compiling on SUN:
-----------------
The Makefile specifies the " -fast " option which includes -dalign.
Therefor the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.



************************
5. TESTING INSTRUCTIONS:
************************

directory $OBJ/test  -or-  <MACHINE>/test  will contain:

    preact_change	Changes the parameters of a particular reaction table.
    preact_init		Initializes table parameters for each reaction.
    preact_list		Lists table parameters for a particular reaction.
    testpreact		C++ test driver for PREACT module.
    testf77layer	Test driver for F77 layer atop PREACT module.
    fpreact_test	F90 test driver using the fpreact interface.
    fpreact_test.output Sample output of fpreact_test

To run tests:
-----------

(a) If PREACTDIR was defined during Step 4. go to (b). 
    If you did not define PREACTDIR during step 4., you must now define it
    and manually initialize the Tables with
	cd <MACHINE>/test
	preactinit


(b) Test
cd <MACHINE>/test

   - to run the C++ test driver
	./testpreact

   - to run the fortran test driver
	./testf77layer

Both programs perform identical tasks, creating/reading a subset of tables.
The 1st time run, it will be slow, since the tables have to be created.
The 2nd time should be quite fast, since it is only reading.

   - to run the fortran 90 test driver
	./fpreact_test

This program is similar to the other two.
You can compare the output (when run the 2nd time) to fpreact_test.output.


For details see USERGUIDE, included in this distribution.


**********************
6. FINAL INSTALLATION:
**********************

There are two distinct parts to be installed:

 ->  The Plasma Reaction Tables (in ascii format) in $PREACTDIR.
 ->  The architecture dependent libraries and utilities in $PREFIX.

(a) $PREACTDIR
    Choose or create the root directory where you wish to build the 
    Plasma Reaction Tables. Set the environment variable PREACTDIR to be
    the full pathname of the directory where the Tables will be stored.  
    For example, if you want to keep it in a subdirectory 'preact' of your
    home directory, then you should define PREACTDIR $HOME/preact.

    The tables will be created in:
	$PREACTDIR/data
	$PREACTDIR/tables/{cx,ii,fs}/*/*

    Note: The installation is not going to build all the tables, it is only
          creating a scelleton. The Tables will be created on demand.
          Therefore PREACTDIR must grant write access to all potential users. 

(b) $PREFIX
    Choose or create the root directory where you wish to install the 
    libraries, executables and man page. Common locations would be 
    $HOME/<architecture> or /usr/ntcc, but installation can occur in any 
    directory where you have appropriate permissions.

    You define your choice of root directory via PREFIX.
    The default for PREFIX is /usr/ntcc.

    The assumptions are:

    libraries in:       $PREFIX/lib        = $LIBDIR
    executables in:     $PREFIX/bin        = $BINDIR
    scripts in:         $PREFIX/etc        = $ETCDIR
    man pages in:       $PREFIX/man/man3   = $MANDIR/man3

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

>   gmake install  
    to install into /usr/ntcc/...

>   gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

If you want things elsewhere, you can overwrite the default with
> gmake install LIBDIR=/xxx BINDIR=yyy MANDIR=zzz

NOTE:
-----
Users should link with:

-L<PREFIX>/lib -lpreact -lsigsub -laladdinsub -lpreact -lportlib

Make sure users know what <PREFIX> is.

After you have installed the software, you can delete the entire tree
with
> cd ..
> rm -r foo
   assuming the previous example.


**********************************
7. RE-INITIALIZING REACTION TABLES
**********************************

To initalize new tables, you can run the script preactinit.
You need to provide the location of the Aladdin cross-section data,
ORNL6086.DAT, that came with the package in the preact directory.

1. define $PREACTDIR (see Section 6. FINAL INSTALLATION)

2. run preactinit 
   preactinit will run preact_init, so if both are in your PATH, 
   type:
   > preactinit DATA <dir of ORNL6086.DAT>
 
   If preact_init is not in your PATH, type
   > preactinit DATA $HOME/ntcc/preact PATH <path of preact_init>

   for options see also: 
   > preact help

   Note: you can re-use ORNL6086.DAT from a previous installation,
   by specifying "DATA <old_preactdir>/data"

************************
8. DOCUMENTATION:
************************

See USERGUIDE, part of this distribution.

PREACT Home Page:
http://w3.pppl.gov/NTCC/PREACT

NTCC Home Page:
http://w3.pppl.gov/NTCC



----------------------------------------------------------------------------

IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT EITHER:

        TRANSP Support - transp_support@pppl.gov

	Princeton Plasma Physics Laboratory

README file for Frantic Module

Prepared by C.Ludescher -- ludescher@pppl.gov 12/04/02

****************
REVISION HISTORY
****************
      date          Description

  Dec 04, 2002  --  Created

----------------------------------------------------------------


Index:
   1. CONTENTS
   2. UNPACKING INSTRUCTIONS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. TESTING INSTRUCTIONS
   6. DOCUMENTATION
   7. FINAL INSTALLATION


************
1. CONTENTS:
************
The directory into which frantic{zip,tar.gz} was extracted, should contain
the following files:

For FRANTIC:
===========
README_Frantic: This file.  Brief descriptions of the other files, and
                instructions for compiling, testing and installing the
                frantic library libfrantic.a and its test drivers
                test_frantic and geqxpl{2} and the utility plot_frantic. 

Makefile:       NOTE, "GNU make" must be used
                (usually in /usr/gnu/bin or /usr/local/bin).
		Main Makefile to envoke Makefile(s) in subdirectories.  

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing:

-- in subdirectory include/fpreproc:
   *.h files for source pre-processing.

-- in subdirectory frantic:
   README: Copy of README_frantic
   USERGUIDE
   Makefile
   Sources to build the library libfrantic.a
   Sources for test program:
   	frantic_test.f90 

   Sample input/output files for test:
  	 *.cdf *.ref

-- in subdirectory portlib:
   Makefile
   Sources to build internally used library libportlib.a.

-- in subdirectory prefpp:
   Makefile 
   Sources to build prefpp and postfpp, the Fortran pre- and post-processors.

-- in subdirectory share:
   Make.flags:        Include file for Makefile, to setup Flags, etc.
   Make.local.sample: Include file for Makefile, to setup non-conventional,
                      site specific locations.
   
For PREACT:
==========
-- in subdirectory adpak:
   Makefile 
   Sources to build libadpak.a, an internally used library
	to calculate ionization and radiation rates.        

-- in subdirectory aladdinsub:
   Makefile 
   Sources to build libaladdinsub.a, an internally used library
	for Aladdin format.        
     
-- in subdirectory comput:
   Makefile 
   Sources to build libcomput.a, an internally used library 
	with transformation/interpolation routines.

-- in subdirectory cppsub:
   Makefile 
   Sources to build libcppsub.a, a fortran-c++ wrapper

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing.

-- in subdirectory fpreact:
   Makefile 
   Sources to build libfpreact.a, the f90 interface.

-- in subdirectory include:
	ALCOM		Common block for Aladdin cross-section database.
	ALPCOM  	Common block for Alpack standard Aladdin entry parsing.
	SIGTABL	        Common block for cross-section computation routines.
	SIGTABL_Z	Common block for modified cross-section computation.

-- in subdirectory include/fpreproc:
   *.h files for source pre-processing.

-- in subdirectory include/preact:
   *.h Interfaces for F77 reaction routines and Macros for reaction classes.

-- in subdirectory portlib:
   Makefile
   Sources to build internally used portability library libportlib.a.


-- in subdirectory preact:
   README
   Makefile		   To compile libraries and programs
   ORNL6086.DAT		   Aladdin cross-section data.
   USERGUIDE               Detailed description of code.
   Sources to build the library libpreact.a
       *.cpp               Implementation of reaction classes
       *_z.f               Modified sources from TRANSP comput and sigsub
       icode_preact.f      Return code.

   Sources for programs:
	fpreact_test.f90   Test driver for F90 layer atop PREACT module.
	preact_change.cpp  Changes the parameters of a reaction table.
	preact_init.cpp	   Initializes table parameters for each reaction.
	preact_list.cpp	   Lists table parameters for a particular reaction.
	testpreact.cpp	   Test driver for F77 layer atop PREACT module.
	testf77layer.f	   Test driver for PREACT module.

   preactinit	           Script clears and re-initializes reaction tables.
   fpreact_test.output     Sample output from fpreact_test

-- in subdirectory sigsub:
   Makefile 
   Sources to build libsigsub.a, an internally used
	library with cross-section routines for atomic and nuclear
        reactions.
   

Fore PSPLINE:
============
-- in subdirectory ezcdf:
   Makefile
   Sources to build the library libezcdf.a
 
-- in subdirectory pspline:
   Makefile
   Sources to build the library libpspline.a

**************************
2. UNPACKING INSTRUCTIONS:
**************************
Note: Download the module(s) into an empty directory.

for tarfiles:
  > gunzip frantic.tar.gz
  > tar xvf frantic.tar

or, for zip archives:
  > unzip frantic.zip


****************
3. DESTINATIONS:
****************
Or where do the files go?
(this refers to building and testing; see FINAL INSTALLATION for end result) 


When you extract the tar file you get sub directories:
For Frantic
./fpreproc          --  scripts for pre-processing of fortran
./frantic           --  1d neutral gas transport for tokamak core plasmas
./include/fpreproc  --  *.h files for cpp
./prefpp            --  Fortran pre/post processor
./portlib           --  portability routines
./share             --  include file Make.flags, Make.local.sample

For preact
./adpak             --  to calculate ionization and radiation rates
./aladdinsub        --  ORNL Atomic Physics Data Center
./comput            --  low level TRANSP routines
./cppsub            --  fortran c++ wrapper
./include           --  include files for sigsub and alladinsub
./include/fpreproc  --  *.h files for cpp
./include/preact    --  *.h files for preact
./preact            --  sources and Makefile
./prefpp            --  Fortran pre/post processor
./r8slatec          --  double precision "Fullerton" functions
./sigsub            --  atomic/nuclear cross sections integration

For pspline
./pspline          --  Spline and Hermite Cubic Interpolation 
./ezcdf            --  Easy Interface for netCDF Routines

The makefile will create more sub directories,

lib:     for the library, libfrantic.a
mod:     for the f90 modules
obj/*:   for compiled objects and pre-processed sources
test:    for the test program and the sample output file.

By default these directories are created in  
./<MACHINE>, which is determined by Make.flags.
e.g.: if you are running Linux, and the tar file resides in $HOME/foo,
      the directories would be in
      $HOME/foo/LINUX/...

You can overwrite the destination by defining OBJ, as an environment
variable (e.g. export OBJ=/dir1/dir2),
or with make (e.g. "make all OBJ=.").
If OBJ is defined, the destinations will be
$OBJ/lib and $OBJ/test.
If OBJ is defined as "." then, in the example above, the destination
would be $HOME/foo/lib.

The rationale behind <MACHINE> is to facilitate building for various platforms.

Note: If you define OBJ as option to gmake, you have to consistently do so;
      e.g: gmake clean OBJ=., gmake install OBJ=.

 
*************************
4. BUILDING INSTRUCTIONS:
*************************

Required Libraries:
===================
           netCDF         -  network Common Data Form

Check with your systems administrator where these libraries and modules are.


netCDF
------
netCDF is assumed to be in /usr/local/lib,
if not, you can specify the location with LIBROOT,

e.g.: "gmake LIBROOT=/usr/contrib".

Alternatively you can modify Make.local.sample
and rename it to Make.local.

pspline and preact
------------------
If your site already has pspline and preact libraries installed,
specify their location (library and modules) with PREFIX, 

e.g. "gmake PREFIX=/usr/ntcc"

At PPPL these libraries are in /usr/ntcc.

Note: the Makefile will re-build pspline and preact only if your
      existing version is older.  


Building libraries and programs
-------------------------------- 
> gmake            -- to compile library and link all test programs

> gmake checklibs  -- tells you what the makefile will do
                      (without any action);
                      it says which libraries it will make and
                      which ones it already found and where.
 
> gmake clean      -- to remove objects
> gmake realclean  -- to remove objects and library

> gmake show_makeflags -- to see what flags, definitions Make will use

Compiling on Linux:
-------------------

By default the Makefile will select LaheyFujitsu.

To select a different compiler define
FORTRAN_VARIANT to "Portland"  "NagWare"  "Fujitsu" or "Absoft"

e.g.:
setenv FORTRAN_VARIANT Portland (csh)
FORTRAN_VARIANT=Portland; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=Portland

To use vastf90:
> gmake VAST90=y

To use NAG90: 
> gmake NAG90=y


Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


Compiling on SUN:
-----------------
The Makefile specifies the " -fast " option which includes -dalign.
Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.



************************
5. TESTING INSTRUCTIONS:
************************

directory $OBJ/test  -or-  <MACHINE>/test  will contain the following
frantic related files:

frantic_test              :  test driver for frantic
frantic_src_0{1,2}.cdf    :  test data
frantic_output_0{1,2}.ref : reference output

To run test:
============
The location of the fusion reaction tables, PREACTDIR, must
be defined and the tables must be initialized.
See http://w3.pppl.gov/NTCC/PREACT
or preact/USERGUIDE and REDAME (included in the preact module).

cd <MACHINE>/test
./frantic_test frantic_src_01.cdf > my_01.out

diff my_01.out frantic_output_01.ref

same with 2nd example.

For instructions on how to use the library routines in your own code
see USERGUIDE (supplied with distribution, or on web
http://w3.pppl.gov/NTCC/FRANTIC/USERGUIDE).


************************
6. DOCUMENTATION:
************************

FRANTIC Home Page:
http://w3.pppl.gov/NTCC/FRANTIC


NTCC Home Page:
http://w3.pppl.gov/NTCC


**********************
7. FINAL INSTALLATION:
**********************

Choose or create the root directory in which you wish to install the software.
A common location would be /usr/ntcc, but installation can occur in any
directory where you have appropriate permissions.

You define your choice of root directory via PREFIX.
The default for PREFIX is /usr/ntcc.

The assumptions are:

libraries in:       $PREFIX/lib        = $LIBDIR
f90 modules in:     $PREFIX/mod        = $MODDIR
man pages in:       $PREFIX/man/man3   = $MANDIR/man3

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

> gmake install  
    to install into /usr/ntcc/...

> gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

If you want things elsewhere, you can overwrite the default with
> gmake install LIBDIR=/xxx MODDIR=yyy MANDIR=zzz

NOTE:
-----
To link a program, you need all frantic, pspline and preact libraries.
e.g:

-L<PREFIX>/lib -lfrantic -lfpreact -lpreact \
         -lsigsub -laladdinsub -adpak -cppsub \
	 -lpspline -lezcdf -lcomput -lportlib

Make sure users know what <PREFIX> is.

After you have installed the software, you can delete the entire tree
with
> cd ..
> rm -r foo
   assuming the previous example.

----------------------------------------------------------------------------

IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT EITHER:


        Doug McCune, Princeton University
                dmccune@pppl.gov
        or

        Christiane Ludescher, Princeton University
                cludescher@pppl.gov
        or      
                ntcc_webmaster@pppl.gov

EZcdf, Easy Interface to netCDF Routine Calls
=============================================

The module is available through the NTCC Webpage,
w3.pppl.gov/NTTC  under "Modules Library", as compressed
tarfile, ezcdf.tar.gz, and as zip archive, ezcdf.zip.
Alternatively it can be obtained from ftp.pppl.gov
in pub/NTCC/.


o AUTHORS 

Conceived 7/98 by Sunitinder Sekhon
Modified by J. Menard 12/98 to run on Cray C90
Completely re-written by C.Ludescher-Furth 2/99 
Added complex support (64 and 128 bit) by A. Pletzer 5/01 
Added Logicals and reworked interface (Steve Hirshman)


o CONTACT
  
  C. Ludescher-Furth cludescher@pppl.gov
  A. Pletzer         pletzer@noaa.gov


o REVISION HISTORY

      date         Description

  Februar 1999  -- Created 
  April   2000  -- A. Pletzer: Added R4
  May 01, 2000  -- C. Ludescher-Furth: Simplified by adding module ezcdf
  May 17, 2001  -- A. Pletzer: Added C8 and C16
  Oct 2,  2002  -- S. Hirshman: added LOG and reworked interface

-------------------------------------------------------------------------- 

Index:
   1. UNPACKING INSTRUCTIONS
   2. CONTENTS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. TESTING
   6. FINAL INSTALLATION

**************************
1. UNPACKING INSTRUCTIONS:
**************************

for tarfiles:
  > gunzip ezcdf.tar.gz
  > tar xvf ezcdf.tar

or, for zip archives:
  > unzip ezcdf.zip


************
2. CONTENTS:
************

Makefile: NOTE, "GNU make" must be used
               (usually in /usr/gnu/bin or /usr/local/bin).
	       Main Makefile to invoke Makefile(s) in subdirectories. 

README_Ezcdf:  This file.  Brief descriptions of the other files, and
               instructions for compiling libezcdf.a  and a test.

--in subdirectory ezcdf:

README:        This file. A copy of README_Ezcdf from above. 

Makefile:      to build library and test program.

USERGUIDE:     Detailed User Guide

Sources to build libezcdf.a and f90 modules:
   ezcdf.f90         ezcdf_genget.f90  ezcdf_inqvar.f90
   ezcdf_attrib.f90  ezcdf_genput.f90  ezcdf_opncls.f90
   handle_err.f90

Test programs:
   eztest.F90 and its sample output EZsample.nc
   eztest2.cc, ezcdf.hh: This is an example how to call ezcdf
                         from a C++ program.

-- in subdirectory share:
     
   Make.flags:        Include file for Makefile, to setup Flags, etc.

   Make.local.sample: Include file for Makefile, to setup non-conventional,
                   site specific locations.

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing.

****************
3. DESTINATIONS:
****************
Or where do the files go?
(this refers to building and testing; see FINAL INSTALLATION for end result) 

When you extract the tar file you get a sub directory:
./ezcdf  --  Sources, Documents and Makefile
./share  --  Make include files  

The makefile will create the following sub directories,
lib:   for the library, libezcdf.a
mod:   for the f90 modules
test:  for EZtest and the sample output.
obj/ezcdf:   for preprocessed sources and objects

By default these directories are created in  
./<MACHINE>, which is determined by the Makefile.
e.g.: if you are running Linux, and the tar file resides in $HOME/foo,
      the directories would be
      $HOME/foo/ezcdf
      $HOME/foo/LINUX/lib
etc.


You can overwrite the destination by defining OBJ, as an environment
variable (e.g. in your login setup, export OBJ=/dir1/dir2),
or with make (e.g. "make OBJ=.").
If OBJ is defined, the destinations will be $OBJ/{lib,mod,obj,test}.
If OBJ is defined as "." then in the example above, the destination
would be $HOME/foo/{lib,mod,obj,test}.

The rational behind <MACHINE> is to facilitate building for various platforms.


*************************
4. BUILDING INSTRUCTIONS:
************************* 

NOTE:  For linking the netCDF library is required.

Check with your systems administer where these libraries are.

netCDF is assumed to be in /usr/local,
if not, you can specify the location with LIBROOT,

e.g.: "gmake LIBROOT=/usr/contrib".

Alternatively you can modify share/Make.local.sample
and rename it to share/Make.local.

Building libezcdf.a and test propram
------------------------------------

>  gmake            -- to build/link library and eztest

>  gmake checklibs  -- tells you what the makefile will do
                       (without any action);
                       it sais which libraries it will make and
                       which ones it already found and where.
                       It also tells you how to rebuild an existing library.

>  gmake clean      -- to remove all .o files
>  gmake realclean  -- to remove everything but sources.




Compiling on Linux:
-------------------

At present, there is no native Linux  fortran 90 compiler. However, many
vendors offer good quality compilers. The following

-Fujitsu f95
-PGI pgf90
-Nag f95

have been successfully used to build ezcdf.

By default the Makefile will select Lahey Fujitsu f95.

To select a different compiler define
FORTRAN_VARIANT to "Portland"  "NagWare"  "Fujitsu"  "Absoft" or "Intel"

e.g.:
setenv FORTRAN_VARIANT Portland (csh)
FORTRAN_VARIANT=Portland; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=Portland

To use vastf90:
> gmake VAST90=y

Caveat: Be careful to use the same compiler for all objects and libraries.


Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefor the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


Compiling on SUN:
-----------------
The Makefile specifies the " -fast " option which includes -dalign.
Therefore the calling user software must also be compiled with this
option, or else edit share/Make.flags to remove the option.


***********
5. TESTING:
***********

cd <MACHINE>/test  or  cd $OBJ/test

./eztest
eztest will write and re-read a simple netCDF file EZtest.nc and 
write/re-read a large file, bigFile.nc and check for errors.
The contents of EZtest.nc should be the same as of EZsample.nc,
which is included in the distribution.

./eztest2
C++ version of eztest

For details see USERGUIDE or http://w3.pppl.gov/NTCC/EZcdf

**********************
6. FINAL INSTALLATION:
**********************

Choose or create the root directory in which you wish to install the software.
A common location would be /usr/ntcc, but installation
can occur in any directory where you have appropriate permissions.

You define your choice of root directory via PREFIX.
There is "no default" for PREFIX.

The assumptions are:

libraries in:   $PREFIX/lib        = $LIBDIR       
f90 modules in: $PREFIX/mod        = $MODDIR       
man pages in:   $PREFIX/man/man3   = $MANDIR/man3

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

>  gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

>   gmake install
    if you are using share/Make.local


If you want things elsewhere, you can overwrite the default with
> gmake install MODDIR=/xxx LIBDIR=/yyy MANDIR=/zzz

NOTE:
-----
The library is installed as libezcdf.a
Users should link with

-L<PREFIX>/lib -lezcdf 

Make sure users know what <PREFIX> is.

See 4. BUILDING INSTRUCTIONS about other required libraries.

After you have installed the software, you can delete the entire tree
with
> cd ..
> rm -r foo
   assuming the previous example.

README file for Scientific Graphics Library SGlib.

****************
REVISION HISTORY
****************
      date         Description

    June, 1998  -- portability upgrade
    July, 2000  -- Use "global Makefile"

----------------------------------------------------------

Index:
   1. CONTENTS
   2. UNPACKING INSTRUCTIONS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. USER GUIDE
   6. FINAL INSTALLATION

************
1. CONTENTS:
************
The directory into which sglib{zip,tar.gz} was extracted,
should contain the following files:

README_sglib: This file.  Brief descriptions of the other files, and
              instructions for compiling, testing and installing 
              libsg.a, libjc.a libraries and xplot. 

Makefile:     NOTE, "GNU make" must be used
              (usually in /usr/gnu/bin or /usr/local/bin).
              Main Makefile to invoke Makefile(s) in subdirectories
              (allows for several modules to be built with one step).

-- in subdirectory share:
   Make.flags:        Include file for Makefile, to setup Flags, etc.
   Make.local.sample: Include file for Makefile, to setup non-conventional,
                      site specific locations.

-- in subdirectory sglib:
   README: Copy of README_sglib
   Makefile
   Sources to build the libraries, xplot and test programs.

-- in subdirectory portlib:
   Makefile
   Sources to build internally used library libportlib.a.

**************************
2. UNPACKING INSTRUCTIONS:
**************************
for tarfiles:
  > gunzip sglib.tar.gz
  > tar xvf sglib.tar

or, for zip archives:
  > unzip sglib.zip


****************
3. DESTINATIONS:
****************
Or where do the files go?
(this refers to building and testing; see FINAL INSTALLATION for end result) 


When you extract the tar file you get these subdirectories:
./sglib    --  sources and Makefile
./share    --  include files for Makefile
./portlib  --  sources and Makefile for internally used portlib
./fpreproc --  for preprocessing
./include  --  include files for preprocessing

The makefile will create more sub directories,
lib:       for libraries 
obj/sglib: for compiled objects
test:      for xplot and test programs


These object directories go:

If $LOCAL is defined (for TRANSP users):
----------------------------------------
$LOCAL/other/      (instead of /lib)
$LOCAL/exe/        (instead of /test)
$LOCAL/obj/sglib/

If $LOCAL is not defined (non-TRANSP users):
--------------------------------------------
By default these directories are created in  
./<MACHINE>, which is determined by Make.flags.
e.g.: if you are running Linux, and the tar file resides in $HOME/foo,
      the directories would be in
      $HOME/foo/LINUX/...

You can overwrite the destination by defining LOCAL, as an environment
variable (e.g. export LOCAL=/dir1/dir2),
or with make (e.g. "gmake all LOCAL=..").
If LOCAL is defined, the destinations will be
$LOCAL/other/ and $LOCAL/exe.
If LOCAL is defined as ".." then, in the example above, the destination
would be $HOME/foo/exe.

The rationale behind <MACHINE> is to facilitate building for various platforms.
 
Note: If you define LOCAL as option to gmake, you have to consistently do so;
      e.g: gmake clean LOCAL=.., gmake install LOCAL=..

 
*************************
4. BUILDING INSTRUCTIONS:
*************************

Building SG Library and XPLOT:
==============================

Some SUN systems require the GNU C compiler available as gcc.
Ignore the "%LOC function treated as LOC" and other warnings.

To build the SG/JC libraries and the XPLOT display program
         and TSTP10 and TSTCON test programs:
	> gmake 


To build  TSTONE / TSTISO / TSTOPT programs in local directory:
	> cd sglib
	> gmake "name"

To build Debug version:
-----------------------
	> gmake DEBUG=y

To remove objects and library
	> gmake realclean

Compiling on Linux:
-------------------

By default the Makefile will select Fujitsu f95.

To select a different compiler define
FORTRAN_VARIANT to "GCC" "Intel" "Portland" or "PathScale"

e.g.:
setenv FORTRAN_VARIANT PathScale (csh)
FORTRAN_VARIANT=PathScale; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=GCC

To use NAG90: 
> gmake NAG90=y

NOTE for Portland:
     You might need to compile jctic.f with "DEBUG=Y"

Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


Compiling on SUN:
-----------------
The Makefile specifies the " -fast " option which includes -dalign.
Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


**************
5. USER GUIDE:
**************


1) set the environment variable TERMINAL_TYPE

  If you are using xterm:
	> setenv TERMINAL_TYPE XTERM

  If you are using a terminal emulator such as VersaTerm(PRO) on a Macintosh:
	> setenv TERMINAL_TYPE MAC

  If you are using XTC:
	> setenv TERMINAL_TYPE XTC
  To avoid acknowledging each plot in XTC:
	> setenv TERMINAL_INPUT NONE


2) set the environment variable PLOT

  To route plot output to your terminal:
	> unsetenv PLOT

  To route all plot output to the file "file.plt":
	> setenv PLOT file.plt

  To display plots on your terminal and save only those pages in the
  file "file.plt" where you type a "D" (or "d") at the beep:
	> setenv PLOT ",file.plt"

  To view the plots in "file.plt" on your terminal, if you have set PLOT
  to "file.plt" or ",file.plt":
	> xplot

  To view the plots in "file.plt" if you haven't set PLOT:
	> xplot file.plt

3) printing of *.plt files 
   
   Use xtc or tek2ps, which are available in the NTCC XtcTek module.


For more inforamtion see web sites:
   http://w3.pppl.gov/transp
     or
   http://w3.pppl.gov/NTCC/Ufiles/ufiles.html 

    	SGLIB Help
    	XPLOT Help
    	XTC Help
    	TEK2PS Help
	
===========================
How to test the SG library:
===========================

Run the TSTP10 test program:
   For TRANSP users:
   -----------------
        You should have $LOCAL/exe in your PATH, which you need
        for rplot, etc.
        In this case just type: 
        > tstp10
        
        Otherwise you have to specify the full pathname:
        > $LOCAL/exe/tstp10

   For NON-TRANSP users:
   --------------------
	> cd <MACHINE>/test
      or, if you did define LOCAL, > cd $LOCAL/exe
	> tstp10

   tstp10 will prompt you for input:
	plot number (zero for all, -1 to quit)[0] ?0
	plot number (zero for all, -1 to quit)[0] ?-1
   After the "0" command, the program should output several plots.


**********************
6. FINAL INSTALLATION:
**********************

Choose or create the root directory in which you wish to install the software.
A common location would be /usr/ntcc, but installation can occur in any 
directory where you have appropriate permissions.

Make sure users add this directory to their PATH.

You define your choice of root directory via PREFIX.
The default for PREFIX is /usr/ntcc.

The assumptions are:

libraries in: $PREFIX/lib          = $LIBDIR       
xplot in:     $PREFIX/bin          = $BINDIR       
man pages in: $PREFIX/man/man{1,3} = $MANDIR/man{1,3}

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

> gmake install  
    to install into /usr/ntcc/...

> gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

If you want things elsewhere, you can overwrite the default with
> gmake install LIBDIR=/yyy MANDIR=/zzz

NOTE:
-----
Libraries are installed as libsg.a and libjc.a
Users should link with

-L<PREFIX>/lib -lsg -ljc

Make sure users know what <PREFIX> is.

After you have installed the software, and manually copied above files,
you can delete the entire tree with
> cd ..
> rm -r foo
   (assuming the previous example).

--------------------------------------------------------------------

IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT EITHER:

    ntcc_webmaster@pppl.gov

C******************** START FILE DPSYST.FOR ; GROUP DPLOTT *************
C-----------------------------------------------------------
C  SET SYMBOL TYPE AND SIZE FOR DPLOT1 OR DPLOTK
C
      SUBROUTINE DPSYST(M,ISYM,SIZE)
C
      INCLUDE 'GFTIC'
C
      if(.not.init_gftic) call gftic0
C
      CALL LINE(-4)
C
C  INPUT M SHOULD BE BTW. 13 AND 17 DUE TO HISTORY OF SGLIB/GFLIB!
C
      IM=MAX0(13,MIN0(17,M))-13
C
C  COMMON CONTROL KSYMTP EXERTS MODULO CONTROL ON SYMBOL SELECTION
C
      IMM=IM+KSYMTP
      IF(IMM.GT.4) IMM=IMM-5
C
      INDX=IMM+1
      ISYM=LSYSTL(INDX)
C
C  COMMON USER CONTROL SGSYSZ * SYMBOL SPECIFIC FUDGE FACTOR
C
      ISI=MAX(1,MIN(IGFTSYMS,IABS(ISYM)))
      SIZE=SYSZVC(ISI)*SGSYSZ
C
      CALL SIZES(SIZE)
      CALL SYMBL(ISYM)
C
      RETURN
      END
C******************** END FILE DPSYST.FOR ; GROUP DPLOTT ***************
C
      SUBROUTINE DPSYST0(M,ISYM,SIZE)
C set small size symbol for individual points
C
      INCLUDE 'GFTIC'
C
      if(.not.init_gftic) call gftic0
C
      CALL LINE(-4)
C
C  INPUT M SHOULD BE BTW. 13 AND 17 DUE TO HISTORY OF SGLIB/GFLIB!
C
      IM=MAX0(13,MIN0(17,M))-13
C
C  COMMON CONTROL KSYMTP EXERTS MODULO CONTROL ON SYMBOL SELECTION
C
      IMM=IM+KSYMTP
      IF(IMM.GT.4) IMM=IMM-5
C
      INDX=IMM+1
      ISYM=LSYSTL(INDX)
C
C  COMMON USER CONTROL SGSYSZ * SYMBOL SPECIFIC FUDGE FACTOR
C
      ISI=MAX(1,MIN(IGFTSYMS,IABS(ISYM)))
! this line differ from DPSYST
      SIZE=SYSZVC(ISI)*SGSYSZ/100.
C
      CALL SIZES(SIZE)
      CALL SYMBL(ISYM)
C
      RETURN
      END
C******************** END FILE DPSYST.FOR ; GROUP DPLOTT ***************

C---------------------------------------------------------------
      SUBROUTINE UFAXCOM(ILUNC,IXUN,ZXCONA,ZXCONB,
     >     IYUN,ZYCONA,ZYCONB,IZUN,ZZCONA,ZZCONB)
C
C DMC JAN 1986
C
C  RECORD COMMENTS RE TRANSFORMATION OF DATA AXIS
C   ILUNC - OPEN LUN FOR COMMENTS
C
C   IXUN,ZXCONA,ZXCONB - TRANSFORMATION INFO FOR "X" AXIS AS OUTPUT
C                        BY UCHUNS (UFILES) SUBROUTINE
C   IYUN,ZYCONA,ZYCONB - TRANSFORMATION INFO FOR "Y" AXIS AS OUTPUT
C                        BY UCHUNS
C   IZUN,ZZCONA,ZZCONB - TRANSFORMATION INFO FOR "Z" AXIS AS OUTPUT
C                        BY UCHUNS
C
      CHARACTER*1 ZCHAR
C
      ZCHAR='X'
      IF(IXUN.EQ.1) THEN
        WRITE(ILUNC,4011) ZCHAR,ZXCONA,ZXCONB
      ELSE IF(IXUN.EQ.2) THEN
        WRITE(ILUNC,4012) ZCHAR,ZCHAR,ZXCONB,ZCHAR,ZXCONA
      ENDIF
C
      ZCHAR='Y'
      IF(IYUN.EQ.1) THEN
        WRITE(ILUNC,4011) ZCHAR,ZYCONA,ZYCONB
      ELSE IF(IYUN.EQ.2) THEN
        WRITE(ILUNC,4012) ZCHAR,ZCHAR,ZYCONB,ZCHAR,ZYCONA
      ENDIF
C
      ZCHAR='Z'
      IF(IZUN.EQ.1) THEN
        WRITE(ILUNC,4011) ZCHAR,ZZCONA,ZZCONB
      ELSE IF(IZUN.EQ.2) THEN
        WRITE(ILUNC,4012) ZCHAR,ZCHAR,ZZCONB,ZCHAR,ZZCONA
      ENDIF
C
 4011 FORMAT(' "',A,'" AXIS TRANSFORMED:'/
     >  '    CONVERSION FACTOR (NEW/OLD):  ',1PE11.4/
     >  '    OFFSET (ADDED TO OLD DATA):   ',1PE11.4)
 4012 FORMAT(' "',A,'" AXIS TRANSFORMED:'/
     >  '  ',A,'(NEW)=',1PE11.4,'*[',A,'(OLD)]**',1PE11.4)
C
      RETURN
      END

C----------------------------------------------------------------
C  GFTICX - SET SG TIC OPTIONS CONTROLLED FROM GFTIC BLOCK
C
      SUBROUTINE GFTICX
C
C  EXECUTE AFTER BINITT CALL; AFTER CHECK/DISPLAY OR INITIAL GRID CALL
C  DRAW THE AXES AND TICS ON THE FAR SIDE OF THE GRAPH
C
      INCLUDE 'GFTIC'
C
C  SUPPRESS FARSIDE TIC LABELING
C
      if(.not.init_gftic) call gftic0
C
      IF(KFRACX.GT.0) THEN
C
        CALL XLAB(0)
C
        CALL XLOCTP(0)  ! TOP HORIZ. LINE
C
        CALL XFRM(KFRACX)
C
        CALL XMFRM(KFRMCX)
C
      ENDIF
C
C-------------
C
      IF(KFRACY.GT.0) THEN
C
        CALL YLAB(0)
C
        CALL YLOCRT(0)  ! RIGHTSIDE VERT. LINE
C
        CALL YFRM(KFRACY)
C
        CALL YMFRM(KFRMCY)
C
      ENDIF
C
      IF((KFRACX.GT.0).OR.(KFRACY.GT.0)) CALL GRID
C
      RETURN
      END

 
      SUBROUTINE SHOWFILE(IFILNAME,DEVNAM,LDEV,DIRNAM,LDIR)
C
C  GET THE CURRENT DEFAULT DISK AND DIRECTORY BY PARSING A DUMMY
C  FILENAME WITH THE RMS SERVICE CALL
C  DMC:  FOLLOWING HINTS BY M. THOMPSON
C
        CHARACTER*(*) IFILNAME  ! INPUT FILENAME
      CHARACTER*(*) DEVNAM  ! OUTPUT DEVICE NAME
      CHARACTER*(*) DIRNAM  ! OUTPUT DIRECTORY NAME
 
      INTEGER LDEV	      ! OUTPUT LENGTH OF DEVICE NAME
      INTEGER LDIR	      ! OUTPUT LENGTH OF DIRECTORY NAME
 
      RETURN
      END

C******************** START FILE UFSCDF.FOR ; GROUP UFSCLK ******************
C---------------------------------------------------------------
C  UFSCDF
C  DEFINE DIFFERENCES IN 2 SCALAR KEYWORD LISTS
C  PUT DIFFERENCES IN THIRD LIST
C
      SUBROUTINE UFSCDF(ZLIST,ZVAL,IORD,NDIM,NUM,ITYP,ISEL)
C
      CHARACTER*10 ZLIST(3,NDIM,3)
      REAL ZVAL(NDIM,3)
      INTEGER NUM(3),IORD(NDIM,3)
C
C  ZLIST-- LIST ELEMENT LABELS/KEYWORDS
C   ROW 1-- COMPARISON LIST 1
C   ROW 2-- COMPARISON LIST 2 (1 AND 2 ARE INPUT)
C   ROW 3-- DIFFERENCES LIST (OUTPUT)
C  ZVAL-- LIST ELEMENT VALUES
C  IORD-- ALPHABETIC ORDERING ON LISTS (ALREADY CALCULATED INPUT)
C  NDIM-- LIST ELEMENT ARRAY SIZES-- MAX # OF ELEMENTS
C  NUM-- NUMBER OF DEFINED ELEMENTS IN EACH LIST
C  ITYP-- COMPARISON TYPE SELECT
C   ITYP=1 - GEN LIST OF ALL KEYWORD ELEMENTS IN LIST 1 BUT NOT LIST 2
C       =2 - GEN LIST OF ALL KEYWORD ELEMENTS IN LIST 2 BUT NOT LIST 1
C       =3 - GEN LIST OF ALL ELEMENTS WITH SAME KEYWORD BUT DIFFERENT
C            LABELS IN THE TWO LISTS
C       =4 - GEN LIST OF ALL ELEMENTS WITH SAME KEYWORD BUT DIFFERENT
C            VALUES IN THE TWO LISTS
C   ISEL-- LIST SELECT; MEANINGFUL ONLY FOR ITYP=3 OR 4:
C       INSERT IN DIFFERENCES LIST ELEMENTS FROM LIST 1 IF ISEL=1,
C       INSERT ELEMENTS FROM LIST 2 IF ISEL=2
C
      NUM(3)=0
      GO TO (100,100,300,300) ITYP
C  LIST WHATS IN LIST L=ITYP, NOT IN THE OTHER LIST LC
 100  CONTINUE
      L=ITYP
      LC=3-ITYP
      IF(NUM(L).EQ.0) RETURN
      INL=NUM(L)
      DO 150 I=1,INL
C  PTR TO NEXT ALPHABETIC ENTRY IN LIST 1
      IPT=IORD(I,L)
      IF(NUM(LC).EQ.0) GO TO 140
C  LOCATE IN LIST LC
      ILOC2=
     >     IUFSLO(ZLIST(1,IPT,L),NUM(LC),ZLIST(1,1,LC),IORD(1,LC),IEQ)
      IF(IEQ.EQ.1) GO TO 150
C  ENTRY NOT PRESENT IN LIST LC
 140  CONTINUE
      NUM(3)=NUM(3)+1
      ZVAL(NUM(3),3)=ZVAL(IPT,L)
      DO 145 IJ=1,3
      ZLIST(IJ,NUM(3),3)=ZLIST(IJ,IPT,L)
 145  CONTINUE
      IORD(NUM(3),3)=NUM(3)
 150  CONTINUE
      RETURN
C  LABELS COMPARE
 300  CONTINUE
      IF(NUM(1).EQ.0) RETURN
      IF(NUM(2).EQ.0) RETURN
      L=ISEL
      LC=3-ISEL
      INL=NUM(L)
C  SCAN ENTRIES IN LIST L
      DO 350 I=1,INL
C  POINTER TO NEXT IN ALPHABETIC ORDER
      IPT=IORD(I,L)
      ILOC2=
     >     IUFSLO(ZLIST(1,IPT,L),NUM(LC),ZLIST(1,1,LC),IORD(1,LC),IEQ)
C  KEYWORD IN BOTH LISTS?
      IF(IEQ.EQ.0) GO TO 350
C  LABELS OR VALUES  AGREE?
      IPTLC=IORD(ILOC2,LC)
      IF(ITYP.EQ.3) GO TO 320
C  TEST VALUES
      IF(ZVAL(IPT,L).NE.ZVAL(IPTLC,LC)) GO TO 340
      GO TO 350
C  TEST LABELS
 320  CONTINUE
      DO 330 IJ=2,3
      IF(ZLIST(IJ,IPT,L).NE.ZLIST(IJ,IPTLC,LC)) GO TO 340
 330  CONTINUE
C  LABELS AGREE.
      GO TO 350
C  LABELS OR VALUES  DISAGREE:
 340  CONTINUE
      NUM(3)=NUM(3)+1
      ZVAL(NUM(3),3)=ZVAL(IPT,L)
      DO 345 IJ=1,3
      ZLIST(IJ,NUM(3),3)=ZLIST(IJ,IPT,L)
 345  CONTINUE
      IORD(NUM(3),3)=NUM(3)
 350  CONTINUE
      RETURN
      END
C******************** END FILE UFSCDF.FOR ; GROUP UFSCLK ******************

C----------------------------------------------------------------------
C  GFTICI - CONTROL TICMARK/FRAME CHARACTERISTICS OF 2D PLOTS
C
      SUBROUTINE GFTICI
C
C  DMC NOV 1990 -- ADDITIONAL CONTROL OF SYMBOLS AND LINE STYLES ADDED
C
C  CONTROL BLOCK:
C
      INCLUDE 'GFTIC'
C
C---------------------------
C
      LOGICAL LCHAR
      LOGICAL LXOUT
      LOGICAL LYES
C
      logical, save :: loc_init
      integer, save :: klintp_save
C
C => GFTICI               BEGIN DATA BLOCK
C => LISMAK 12-APR-88  MOVED DATA STATEMENTS
      DATA IMAX/4/  ! LINE STYLE CONTROL CODE LIMIT
      DATA IMAXS/4/ ! SYMBOL SELECT CONTROL CODE LIMIT
      DATA ZS1/0.001/ ! MIN SYMBOL SIZE CONTROL
      DATA ZS2/3.0/ ! MAX SYMBOL SIZE CONTROL
C => END DATA BLOCK
C ====================
C
      if(.not.init_gftic) call gftic0
C
      if(.not.loc_init) then
         loc_init=.TRUE.
         klintp_save = max(0,klintp)
      endif
C
      LUNTRM=LNOUT(0)
C
 10   CONTINUE
      CALL NEUPAG
C
      IF(LXOUT(0)) THEN
        CALL GFTICL('A','X/YNEAT ','BIGGER --> NEATER',
     >	    KNEATX,KNEATY,KNEAT0,KNEATMIN,KNEATMAX)
        CALL GFTICL('B','X/YFRM  ','.GE.5 DRAWS GRID LINES',
     >	    KFRAMX,KFRAMY,KFRAM0,KFRAMMIN,KFRAMMAX)
        CALL GFTICL('C','X/YMFRM ',' AT MINOR TIC MARKS',
     >	    KFRMMX,KFRMMY,KFRMM0,KFRMMMIN,KFRMMMAX)
        CALL GFTICL('D','X/YFRM 2',' FARSIDE AXIS MAJOR TICS 0=OFF',
     >	    KFRACX,KFRACY,KFRAC0,KFRACMIN,KFRACMAX)
        CALL GFTICL('E','X/YMFRM2',' FARSIDE AXIS MINOR TICS',
     >	    KFRMCX,KFRMCY,KFRMC0,KFRMCMIN,KFRMCMAX)
C
        WRITE(LUNTRM,1002)
 1002   FORMAT(' ----------------------'/
     >' ADDITIONAL MISCELLANEOUS CONTROL OPTIONS:'/
     >' 0 - **RESTORE ALL DEFAULTS**'/
     >' 1 - SET PLOT GRID SIZE FOR 2D PLOT (NOT INCLUDING MULTIGRAPHS)'/
     >' 2 - SET PLOT LINE STYLE OR SUBSTITUTE SYMBOL FOR LINE PLOTTING'/
     >' 3 - SET PLOT SYMBOL TYPE AND SIZE'/
     >' 4 - MAKE ALL SYMBOLS INVISIBLE AND MAKE ALL LINES SOLID')
      ENDIF
C
      CALL UREAD('GFTICI:  ENTER OPCODE OR "Q":$$')
C-----------------------------------
C  NUMERIC OPTIONS HANDLED... (DMC AUG 1987)
      IF(LCHAR('0')) THEN
        CALL GFTIC0
        GO TO 10
      ELSE IF(LCHAR('1')) THEN
        CALL NEUPAG
        WRITE(LUNTRM,1003) NXR1,NXR2,NYR1,NYR2
        IF(LXOUT(0)) WRITE(LUNTRM,1004)
 1003   FORMAT(/
     >' CURRENT 2D PLOT X RASTER LIMITS:  ',2I10/
     >' CURRENT 2D PLOT Y RASTER LIMITS:  ',2I10)
 1004   FORMAT(/
     >'  *WARNING* THESE CONTROLS EFFECT ONLY THE LOCATION OF THE'/
     >'  PLOT GRID/AXES AND TIC LABELS, NOT AUXILLIARY LABELS'/
     >'  THESE CONTROLS HAVE NO EFFECT ON "MULTIPLOTS"'/
     >'  NO CHECK IS MADE THAT USER INPUT IS "REASONABLE" FOR A'/
     >'  GIVEN PLOTTING DEVICE.  CAVEAT EMPTOR!'/)
        IXR1=NXR1
        CALL UREADI('GFTICI:  X RASTER LOWER BOUND:$$',IXR1)
        IXR2=NXR2
        CALL UREADI('GFTICI:  X RASTER UPPER BOUND:$$',IXR2)
        IYR1=NYR1
        CALL UREADI('GFTICI:  Y RASTER LOWER BOUND:$$',IYR1)
        IYR2=NYR2
        CALL UREADI('GFTICI:  Y RASTER UPPER BOUND:$$',IYR2)
        WRITE(LUNTRM,1003) IXR1,IXR2,IYR1,IYR2
        CALL UREAD('GFTICI:  ENTER "Y" TO VERIFY RASTER LIMITS:$$')
        IF(LYES(0)) THEN
          NXR1=IXR1
          NXR2=IXR2
          NYR1=IYR1
          NYR2=IYR2
        ENDIF
        GO TO 10
      ELSE IF(LCHAR('2')) THEN
        CALL NEUPAG
        IF(LXOUT(0)) WRITE(LUNTRM,1010) KLINTP,IMAX
 1010   FORMAT(/
     >' CURRENT LINE TYPE CONTROL CODE: ',I2/
     >' SELECT CONTROL CODE BTW. 0 AND ',I2,' TO "PERMUTE" LINE STYLES'/
     >' SELECT CONTROL CODE = -1 TO SUBSTITUTE SYMBOL PLOTTING FOR'/
     >'     LINE PLOTTING IN ALL 2D GRAPHS'/
     >' SELECT CODE = -2 TO ACTUALLY MODIFY SG LINE STYLE CODES USED')
        CALL UREADI('GFTICI:  ENTER LINE TYPE CONTROL CODE:$$',ILINTP)
        ILINTP=MIN0(IMAX,MAX0(-2,ILINTP))
        IF(ILINTP.EQ.-2) THEN
C  MODIFY LINE STYLE CODES
          CALL GFTCLS
        ELSE IF(ILINTP.EQ.-1) THEN
C  SUBSTITUTE SYMBOL PLOTTING FOR LINE PLOTTING
          KLINTP=ILINTP
          WRITE(LUNTRM,1011)
 1011   FORMAT(/' %FOR SYMBOLS USED TO REPLACE LINE PLOTTING:')
          IF(LXOUT(0)) WRITE(LUNTRM,1012) KSYLTP,IMAXS,SGSLSZ,ZS1,ZS2
 1012   FORMAT(/' CURRENT SYMBOL SELECT CODE:  ',I2/
     >' ...LEGAL VALUES BTW 0 AND ',I2,' FOR "PERMUTATION" OF SYMBOLS'/
     >' CURRENT SYMBOL SIZE SETTING:  ',1PE11.4/
     >' ...LEGAL RANGE ',1PE11.4,' TO ',1PE11.4/
     >' **> ENTER -1 TO ACTUALLY MODIFY (RATHER THAN JUST PERMUTE) THE'/
     >'     SG SYMBOL SELECTION CODES')
          CALL UREADI('GFTICI:  ENTER SYMBOL SELECT CODE:$$',ISYLTP)
          IF(ISYLTP.EQ.-1) THEN
C  SELECTION OF NEW SYMBOLS FOR PLOTTING
            CALL GFTCSS
          ELSE
            KSYLTP=MIN0(IMAXS,MAX0(0,ISYLTP))
            CALL UREADF('GFTICI:  ENTER SYMBOL SIZE CONTROL:$$',
     >		SGSLSZ)
            SGSLSZ=AMIN1(ZS2,AMAX1(ZS1,SGSLSZ))
          ENDIF
        ELSE
C  "PERMUTATION" OF EXISTING STYLES
          KLINTP=ILINTP
        ENDIF
        GO TO 10
C
      ELSE IF(LCHAR('3')) THEN
        IF(LXOUT(0)) WRITE(LUNTRM,1012) KSYMTP,IMAXS,SGSYSZ,ZS1,ZS2
        CALL UREADI('GFTICI:  ENTER SYMBOL SELECT CODE:$$',ISYMTP)
        IF(ISYMTP.EQ.-1) THEN
C  SELECTION OF NEW SYMBOLS FOR PLOTTING
          CALL GFTCSS
        ELSE
          KSYMTP=MIN0(IMAXS,MAX0(0,ISYMTP))
          CALL UREADF('GFTICI:  ENTER SYMBOL SIZE CONTROL:$$',SGSYSZ)
          SGSYSZ=AMIN1(ZS2,AMAX1(ZS1,SGSYSZ))
        ENDIF
        GO TO 10
C
      ELSE IF(LCHAR('4')) THEN
C  BLOW AWAY SYMBOLS AND MAKE ALL LINES SOLID -- FOR THE MAC
        SGSYSZ=ZS1
        DO 19 I=1,IGFTMAXL
          LNSTYL(I)=0
 19     CONTINUE
        GO TO 10
      ENDIF
C-----------------------------------
      IANS=IXUOPC('QABCDES$')
      IF(IANS.LE.0) THEN
        CALL UERMSG('?GFTICI:  UNRECOGNIZED OPCODE',' ',-1)
        GO TO 10
      ENDIF
C
      IF(IANS.EQ.1) THEN
        RETURN
      ELSE IF(IANS.EQ.2) THEN
        CALL GFTICJ('X/YNEAT ',KNEATX,KNEATY,KNEAT0,KNEATMIN,KNEATMAX)
      ELSE IF(IANS.EQ.3) THEN
        CALL GFTICJ('X/YFRM  ',KFRAMX,KFRAMY,KFRAM0,KFRAMMIN,KFRAMMAX)
      ELSE IF(IANS.EQ.4) THEN
        CALL GFTICJ('X/YMFRM ',KFRMMX,KFRMMY,KFRMM0,KFRMMMIN,KFRMMMAX)
      ELSE IF(IANS.EQ.5) THEN
        CALL GFTICJ('X/YFRM 2',KFRACX,KFRACY,KFRAC0,KFRACMIN,KFRACMAX)
      ELSE IF(IANS.EQ.6) THEN
        CALL GFTICJ('X/YMFRM2',KFRMCX,KFRMCY,KFRMC0,KFRMCMIN,KFRMCMAX)

      else if(IANS.eq.7) then
c
c  new DMC July 2008 -- simplified options
c
         do
            if(lxout(0)) then
               write(lnout(0),*) ' Simplified menu: '
               write(lnout(0),*) ' ================ '
               write(lnout(0),*) ' "S" for symbol plotting'
               write(lnout(0),*) ' "L" for line plotting'
               write(lnout(0),*) ' "G" for grid lines'
               write(lnout(0),*) ' "N" for no grid lines'
               write(lnout(0),*) ' "Q" to exit with no changes.'
               write(lnout(0),*) ' '
               write(lnout(0),*) 
     >       '     (selections apply to subsequent plots until reset).'
               write(lnout(0),*) ' '
            endif

            call uread('GFTICI simplified menu option S/L/G/N/Q:$')

            if(lchar('Q')) then
               exit

            else if(lchar('L')) then
               klintp = max(0,klintp_save)
               exit

            else if(lchar('G')) then
               kframx=5
               kframy=5
               exit

            else if(lchar('N')) then
               kframx=kfram0
               kframy=kfram0
               exit

            else
               call uermsg('GFTICI: unrecognized option.',' ',0)
            endif
         enddo
         return
      ENDIF
C
      GO TO 10
C
      END

subroutine split_imp(zimpm1,zimpm2,izimp1,izimp2,f1,f2,ierr)

  !  split an "average Z" impurity (Zimp) into two integer-Z impurities
  !  (izimp1), (izimp2) such that 

  !     f1*izimp1 +    f2*izimp2    = <Z> = zimpm1
  !     f1*izimp1**2 + f2*izimp2**2 = <Z**2> = zimpm2

  !  if:  izimp1 < min(<Z>,<Z**2>) < max(<Z>,<Z**2>) < izimp2  it can be
  !  shown that the fractions will be positive

  !  ierr=1 is set if min(f1,f2) = 0
  !  ierr=2 is set if min(f1,f2) < 0
  !  ierr=3 is set if izimp1=izimp2
  !  ierr=4 if min(iZimp1,iZimp2) < 1

  !  answer is:
  !     f1 = [<Z**2>-izimp2*<Z>]/[iZimp1*(iZimp1-iZimp2)]
  !     f2 = [<Z**2>-izimp2*<Z>]/[iZimp2*(iZimp2-iZimp1)]

  !  This can be used to create a pair of densities n1,n2 each associated
  !  with integer Z values, such that an "amalgum" of impurities with total
  !  density nimp and satisfying sum(Zx*nx)/nimp = <Z> and
  !  sum(Zx**2*nx)/nimp = <Z**2> can be represented as two densities n1,n2
  !  with Z values iZimp1 & iZimp2 respectively, and, contribution to Zeff 
  !  and quasineutrality are conserved;  n1=f1*nimp; n2=f2*nimp.
  !
  !  In the arguments of this routine the impurity density (nimp) is 
  !  normalized out; f1 and f2 are dimensionless.

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit none

  !--------------------------------------
  real(fp), intent(in) :: Zimpm1,Zimpm2
  integer, intent(in) :: iZimp1,iZimp2

  real(fp), intent(out) :: f1,f2
  integer, intent(out) :: ierr
  !--------------------------------------

  ierr = 0

  f1 = ZERO
  f2 = ZERO

  if(izimp1.eq.izimp2) then
    ierr=3
    return
  endif

  if(min(iZimp1,iZimp2).lt.1) then
    ierr=4
    return
  endif

  f1 = (Zimpm2-iZimp2*Zimpm1)/(iZimp1*(iZimp1-iZimp2))
  f2 = (Zimpm2-iZimp1*Zimpm1)/(iZimp2*(iZimp2-iZimp1))

  if(min(f1,f2).le.ZERO) then
    if(min(f1,f2).eq.ZERO) then
      ierr=1
    else
      ierr=2
    endif
  endif

end subroutine split_imp

! real*8 interface generated by r8igen.csh --
! ...in /home/dmccune/troot/tmp/trgraf
! csh -f r8igen.csh r8_grf4f1 foo.msg
 
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  GRF4F1
      SUBROUTINE R8_GRF4F1(
     > R8_F,NF1,NF2,R8_X,NX,R8_Y,NY,R8_Z,NZ,FLAB,XLAB,YLAB,ZLAB,FUNS,
     > XUNS,YUNS,ZUNS,ZTITLE,IPROC)
 
      external GRF4F1
 
! argument declarations
      INTEGER NF1
      INTEGER NF2
      INTEGER NX
      INTEGER NY
      INTEGER NZ
      CHARACTER*(*) FLAB
      CHARACTER*(*) XLAB
      CHARACTER*(*) YLAB
      CHARACTER*(*) ZLAB
      CHARACTER*(*) FUNS
      CHARACTER*(*) XUNS
      CHARACTER*(*) YUNS
      CHARACTER*(*) ZUNS
      CHARACTER*(*) ZTITLE
      INTEGER IPROC
 ! floating type, input/output:
      REAL*8 R8_F(NF1,NF2,NZ)
 
 ! floating type, input/output:
      REAL*8 R8_X(NX)
 
 ! floating type, input/output:
      REAL*8 R8_Y(NY)
 
 ! floating type, input/output:
      REAL*8 R8_Z(NZ)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:,:,:)
      REAL, allocatable :: F_ref(:,:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: Z_act(:)
      REAL, allocatable :: Z_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(NF1,NF2,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1 -- F_act ALLOCATE error!')
      ALLOCATE(F_ref(NF1,NF2,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1 -- F_ref ALLOCATE error!')
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1 -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1 -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1 -- Z_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=R8_F
      F_ref=R8_F
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
! call to original routine:  GRF4F1
 
      CALL GRF4F1(
     > F_act(1,1,1),NF1,NF2,X_act(1),NX,Y_act(1),NY,Z_act(1),NZ,FLAB,
     > XLAB,YLAB,ZLAB,FUNS,XUNS,YUNS,ZUNS,ZTITLE,IPROC)
 
! copy back outputs if modified.
 
      where(F_act.ne.F_ref)
         R8_F = F_act
      end where
      DEALLOCATE(F_act)
      DEALLOCATE(F_ref)
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  GRF4F1_FIX
      SUBROUTINE R8_GRF4F1_FIX(
     > SLBL,XLBL,XUNS,R8_X,NX,IXFIX,ZLABEL)
 
      external GRF4F1_FIX
 
! argument declarations
      CHARACTER*(*) SLBL
      CHARACTER*(*) XLBL
      CHARACTER*(*) XUNS
      INTEGER NX
      INTEGER IXFIX
      CHARACTER*(*) ZLABEL
 ! floating type, input/output:
      REAL*8 R8_X(NX)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1_FIX -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF4F1_FIX -- X_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
! call to original routine:  GRF4F1_FIX
 
      CALL GRF4F1_FIX(
     > SLBL,XLBL,XUNS,X_act(1),NX,IXFIX,ZLABEL)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
! exit
      return
      end

      subroutine tr_qpsrt(limit,last,maxerr,ermax,elist,iord,nrmax)
c***begin prologue  qpsrt
c***refer to  qage,qagie,qagpe,qagse,qawce,qawse,qawoe
c***routines called  (none)
c***keywords  sequential sorting
c***description
c
c 1.        qpsrt
c           ordering routine
c              standard fortran subroutine
c              real version
c
c 2.        purpose
c              this routine maintains the descending ordering
c              in the list of the local error estimates resulting from
c              the interval subdivision process. at each call two error
c              estimates are inserted using the sequential search
c              method, top-down for the largest error estimate
c              and bottom-up for the smallest error estimate.
c
c 3.        calling sequence
c              call qpsrt(limit,last,maxerr,ermax,elist,iord,nrmax)
c
c           parameters (meaning at output)
c              limit  - integer
c                       maximum number of error estimates the list
c                       can contain
c
c              last   - integer
c                       number of error estimates currently
c                       in the list
c
c              maxerr - integer
c                       maxerr points to the nrmax-th largest error
c                       estimate currently in the list
c
c              ermax  - real
c                       nrmax-th largest error estimate
c                       ermax = elist(maxerr)
c
c              elist  - real
c                       vector of dimension last containing
c                       the error estimates
c
c              iord   - integer
c                       vector of dimension last, the first k
c                       elements of which contain pointers
c                       to the error estimates, such that
c                       elist(iord(1)),... , elist(iord(k))
c                       form a decreasing sequence, with
c                       k = last if last.le.(limit/2+2), and
c                       k = limit+1-last otherwise
c
c              nrmax  - integer
c                       maxerr = iord(nrmax)
c
c 4.        no subroutines or functions needed
c***end prologue  qpsrt
c
      real elist,ermax,errmax,errmin
      integer i,ibeg,ido,iord,isucc,j,jbnd,jupbn,k,last,limit,maxerr,
     *  nrmax
      dimension elist(last),iord(last)
c
c           check whether the list contains more than
c           two error estimates.
c
c***first executable statement  qpsrt
      if(last.gt.2) go to 10
      iord(1) = 1
      iord(2) = 2
      go to 90
c
c           this part of the routine is only executed
c           if, due to a difficult integrand, subdivision
c           increased the error estimate. in the normal case
c           the insert procedure should start after the
c           nrmax-th largest error estimate.
c
   10 errmax = elist(maxerr)
      if(nrmax.eq.1) go to 30
      ido = nrmax-1
      do 20 i = 1,ido
        isucc = iord(nrmax-1)
c ***jump out of do-loop
        if(errmax.le.elist(isucc)) go to 30
        iord(nrmax) = isucc
        nrmax = nrmax-1
   20    continue
c
c           compute the number of elements in the list to
c           be maintained in descending order. this number
c           depends on the number of subdivisions still
c           allowed.
c
   30 jupbn = last
      if(last.gt.(limit/2+2)) jupbn = limit+3-last
      errmin = elist(last)
c
c           insert errmax by traversing the list top-down,
c           starting comparison from the element elist(iord(nrmax+1)).
c
      jbnd = jupbn-1
      ibeg = nrmax+1
      if(ibeg.gt.jbnd) go to 50
      do 40 i=ibeg,jbnd
        isucc = iord(i)
c ***jump out of do-loop
        if(errmax.ge.elist(isucc)) go to 60
        iord(i-1) = isucc
   40 continue
   50 iord(jbnd) = maxerr
      iord(jupbn) = last
      go to 90
c
c           insert errmin by traversing the list bottom-up.
c
   60 iord(i-1) = maxerr
      k = jbnd
      do 70 j=i,jbnd
        isucc = iord(k)
c ***jump out of do-loop
        if(errmin.lt.elist(isucc)) go to 80
        iord(k+1) = isucc
        k = k-1
   70 continue
      iord(i) = last
      go to 90
   80 iord(k+1) = last
c
c           set maxerr and ermax.
c
   90 maxerr = iord(nrmax)
      ermax = elist(maxerr)
      return
      end
! 15Oct2002 fgtok -s qag.table "quadpack renames for imbedding in TRANSP system"

Subroutine fort_flush(iu)

  ! flush output on sequential file on FORTRAN unit iu

  implicit none
  Integer, intent(in) :: iu

#if __IBM || __RS6000 || __AIX__ || HAVE_FC_INTRINSIC_FLUSH_
  Call flush_(iu)
#else
  Call flush(iu)
#endif

End subroutine fort_flush

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_add_node(node, usage, stat)
      implicit none
      character*(*) node, usage
      integer stat
      mds_add_node = -1
      return
      end
#else
      integer function mds_add_node(node, usage, stat)
C Create a MDSplus Node
C Check first if node already exists
      implicit none
      character*(*) node
      character*(*) usage
      integer       stat
 
      integer   mds__long, mds__cstring
 
      integer   IDTYPE_CSTRING
      parameter(IDTYPE_CSTRING=14)
 
      integer  descr, mdsvalue
      integer  nid
      integer  cmd_sts, cmd_sts2, retl
      integer  i,       add
      integer dsc, dsc2, ndsc, cdsc, nl, ulen
      character*4097 strarg
      character*1    bcks
      volatile nid, cmd_sts, cmd_sts2
C---------------------------------------------------------------------------
      bcks=char(92)                 ! x5c = '\'
 
C  /* Check if node already exists */
 
      nid=0
      ndsc = descr(mds__long(), nid, 0)
      nl=index(node,' ')-1
      if (nl .le. 0) nl=len(node)
      cdsc=descr(IDTYPE_CSTRING,node,0,nl)
      stat = MdsValue("getnci($,'NID_NUMBER')",cdsc,ndsc,0,retl)
 
      if (mod(stat,2) .eq. 1) then
         mds_add_node=nid
         return
      endif
 
      add=1
      i=0
      do while ( i .le. 1 .and. add .eq. 1)
         i=i+1
C Add Node
         dsc = descr(mds__long(), cmd_sts, 0)
         if (node(1:1).eq.bcks) then
            strarg = 'tcl("add node ' // bcks // node(1:nl) //
     >           '/usage=' // usage // '")' //CHAR(0)
         else
            strarg = 'tcl("add node ' // node(1:nl) //
     >           '/usage=' // usage // '")' //CHAR(0)
         endif
         stat = MdsValue(strarg, dsc, 0, retl)
         if (mod(stat,2) .ne. 1) then
            mds_add_node = -1
            print*,'?MdsValue(tcl("add node error',node(1:nl),stat
            return
         else
C Check status of tcl add
            if (mod(cmd_sts,2) .eq. 1) then
               mds_add_node = 1
               add = 0
C           not open for edit: open
            else if (cmd_sts .eq.  265388274 ) then
               print*,"  -- NOT OPEN FOR EDIT"
               cmd_sts2 = 0
               dsc2 = descr(mds__long(), cmd_sts2, 0)
               stat = MdsValue("TreeOpenEdit($EXPT,$SHOT)",
     >              dsc2,0,retl)
C               print*,"TreeOpenEdit cmd_sts.. ",cmd_sts2,retl,stat
C check status of MdsValue
               if (mod(stat,2) .ne. 1) then
                  print*,"?mds_add_node -- TreeOpenEdit Error ",stat
                  mds_add_node = -1
                  return
C check status of TreeOpenEdit
               else if ( mod(cmd_sts2,2) .ne. 1) then
                  print*,"?mds_add_node -- TreeOpenEdit cmd_sts.. ",
     >                   cmd_sts2
C     no Privilege
                  if (cmd_sts2 .eq. 265392034) then
                     print*,"?mds_add_node -- No Priv to edit",cmd_sts2
                  else
                     print*,"?mds_add_node --TreeOpenEdit Error ",
     >                      cmd_sts2
                  endif
                  mds_add_node = -1
                  return
               endif ! end TreeOpenEdit
            else if (cmd_sts .eq. 265388168) then
               print*,'?mds_add_node: already there ',node(1:nl)
               mds_add_node=1
               return
            else
               print*,'?mds_add_node error ',stat,cmd_sts
               mds_add_node = 0
               return
            endif ! end not open for edit
         endif
      enddo
      return
      end
#endif

!
! construct a contour from line and circle limiters
!
! The algorithm finds the pairwise intersections between all the limiters which 
! are not outside the other limiters.  Segments between these intersections form the 
! the limiter boundary.
!

module lincir_contour_mod

contains

  subroutine lincir_contour(r0, z0,   &
       nlinlm, alnlmr, alnlmy, alnlmt, &
       ncirlm, crlmr1, crlmy1, crlmrd, &
       rout, zout, ier, cseg, debug,   &
       urmin, urmax, uzmin, uzmax)

    use iso_c_binding, only: fp => c_double
    implicit none

    real(fp), parameter :: LARGE_R = 25._fp   ! bound limiters in R to less then this factor of r0
    real(fp), parameter :: SMALL_R = .0001_fp ! bound limiters in R to more then this factor of r0
    real(fp), parameter :: LARGE_Z = 25._fp   ! bound limiters in Z to less then this magnitude of r0

    real(fp), intent(in) :: r0                 ! reference R inside all limiters
    real(fp), intent(in) :: z0                 ! reference Z inside all limiters

    integer,  intent(in) :: nlinlm             ! number of line limiters
    real(fp), intent(in) :: alnlmr(nlinlm)     ! reference R of line limiter
    real(fp), intent(in) :: alnlmy(nlinlm)     ! reference Z of line limiter
    real(fp), intent(in) :: alnlmt(nlinlm)     ! angle in degrees from -R axis upward for line limiter

    integer,  intent(in) :: ncirlm             ! number of circle limiters
    real(fp), intent(in) :: crlmr1(ncirlm)     ! R of center of circle limiter
    real(fp), intent(in) :: crlmy1(ncirlm)     ! Z of center of circle limiter
    real(fp), intent(in) :: crlmrd(ncirlm)     ! radius of circle limiter

    real(fp), pointer    :: rout(:)  ! will be dimensioned and filled with R of contour
    real(fp), pointer    :: zout(:)  ! will be dimensioned and filled with Z of contour
    integer,  intent(out):: ier      ! nonzero on error

    real(fp), intent(in), optional :: cseg    ! maximum segment size on a circle limiter or 0. to use default
    logical,  intent(in), optional :: debug   ! .true. for some debugging output, specifically a gnuplottable file

    real(fp), intent(in), optional :: urmin   ! make bounding min R limiter at this value, overrides LARGE_R
    real(fp), intent(in), optional :: urmax   ! make bounding max R limiter at this value, overrides SMALL_R
    real(fp), intent(in), optional :: uzmin   ! make bounding min Z limiter at this value, overrides LARGE_Z
    real(fp), intent(in), optional :: uzmax   ! make bounding max Z limiter at this value, overrides -LARGE_Z
    !
    ! -------------------------- types --------------------------
    !
    ! identifies an intersection point and one of the limiters
    !
    type interpoint
      integer :: iptr  ! intersection point index
      integer :: ix    ! index 1 or 2 for limiter involved in intersection
    end type interpoint

    !
    ! stupid fortran
    !
    type pinterpoint
      type(interpoint), pointer :: ptr
    end type pinterpoint

    !
    ! at an intersection point this describes the limiter and where
    ! on the limiter it was intersected.  Also contains an interpoint for
    ! forming a linked list
    !
    type interlim
      integer          :: index   ! limiter index >0 for line, <0 for circle
      real(fp)         :: dist    ! distance along limiter 
      type(interpoint) :: next    ! linked list
    end type interlim

    !
    ! describes the intersection between two limiters which lies on the limiter boundary
    !
    type intersect
      real(fp)       :: r,z      ! coordinates of intersection point
      type(interlim) :: lim(2)   ! limiters involved in intersection

      integer :: seg1    ! segment index for segment containing this point
      integer :: seg2    ! segment index for second segment containing this point
    end type intersect

    !
    ! a segment between two intersect points which lies on the limiter boundary
    !
    type segment
      integer  :: a      ! intersect point
      integer  :: b      ! intersect point
      real(fp) :: r      ! if >0. this is the R of the midpoint on a circle 
      real(fp) :: z      ! if >0. this is the Z of the midpoint on a circle 
    end type segment
    !
    ! ------------------------------------------------------------------------
    !
    logical :: isopen               ! .true. when debug file is open
    logical :: gdebug               ! .true. for debugging

    integer :: nlines               ! number of line limiters
    integer :: ncircs               ! number of circle limiters
    integer :: ntot                 ! total number of limiters
    integer :: maxint               ! maximum number of pairwise intersections
    integer :: i,j,k,is,ic,imin     ! temp
    integer :: nc                   ! number of limiter intersections
    integer :: nseg                 ! number of segments
    integer :: ncont                ! number of contour points
    integer :: ifirst,icur,iprev    ! first intersect point, current and last intersect point added to contour
    integer :: i1(1)                ! stupid fortran
    integer :: idir                 ! step along rcont,zcont in ccw direction
    integer :: imaxR,imaxZ,iminZ    ! rcont,zcont indices which achieve R,Z limits

    real(fp) :: csegx               ! maximum segment size on a circle limiter
    real(fp) :: q                   ! temp
    real(fp) :: det                 ! determinant,descriminant
    real(fp) :: dr,dz,delta         ! delta R,Z,distance
    real(fp) :: rx,zx,rc,zc         ! intersection and computed points
    real(fp) :: li,lj               ! distance along line from reference point
    real(fp) :: pi,pj               ! limiter radii
    real(fp) :: n2i,d2i,n2j,d2j     ! numerator,denominator terms
    real(fp) :: olphai,olphaj       ! circle intersection angles relative to center-center vector
    real(fp) :: dalphai,dalphaj     ! angle of delta vector with respect to each circle limiter
    real(fp) :: alphai(2),alphaj(2) ! circle intersection angles relative to R for two intersection points
    real(fp) :: smid,pmid2          ! distance along line to midpoint of intersections, circle radius of midpoint
    real(fp) :: s(2)                ! distance along line to intersections
    real(fp) :: xpi                 ! constant named for a desert
    real(fp) :: twopi               ! ?
    real(fp) :: rmin,rmax,zmin,zmax ! bounding box of final contour


    real(fp), allocatable :: rline(:),zline(:)  ! point on line limiters
    real(fp), allocatable :: uline(:),vline(:)  ! unit direction vector for line limiter
    real(fp), allocatable :: sline(:),scirc(:)  ! +-1, sign of side of r0,z0

    real(fp), allocatable :: rcirc(:),zcirc(:)  ! center of circle limiter
    real(fp), allocatable :: pcirc(:)           ! radius of circle limiter
    integer,  allocatable :: kcirc(:)           ! count number of intersections with other limiters

    real(fp), allocatable :: sdist(:),sindex(:) ! for one limiter, distance to intersect point and index of intersect point
    real(fp), allocatable :: rcont(:),zcont(:)  ! R,Z contour

    type(interpoint) :: sptr                    ! temp pointer to intersection point

    type(interpoint),  allocatable, target :: ptrline(:), ptrcirc(:) ! point to first intersect point in linked list for limiter

    type(pinterpoint), allocatable         :: ltrline(:), ltrcirc(:) ! points to last interpoint in linked list for limiter
    type(intersect),   allocatable, target :: inter(:)               ! list of limiter intersections which are on boundary
    type(segment),     allocatable :: seg(:)                 ! segments between boundary point intercepts


    ier=0
    if (associated(rout)) deallocate(rout)
    if (associated(zout)) deallocate(zout)

    if (r0<=0._fp) then
      print *, '?lincir_contour: r0<=0. not allowed'
      ier=1 ; return
    end if

    xpi   = 4._fp*atan(1._fp)
    twopi = 2._fp*xpi
    isopen = .false.

    csegx = 0.1_fp*r0
    if (present(cseg)) then
      if (cseg>0._fp) csegx=cseg
    end if

    gdebug=.false.
    if (present(debug)) gdebug=debug

    ! -- allocate and add extra bounding line limiters --
    nlines = nlinlm+4
    ncircs = ncirlm

    ntot = nlines+ncircs

    maxint = nlines*(nlines-1)/2 + ncircs*(ncircs-1) + 2*nlines*ncircs

    allocate(rline(nlines),zline(nlines), uline(nlines), vline(nlines))
    allocate(sline(nlines), ptrline(nlines), ltrline(nlines))
    allocate(rcirc(ncircs), zcirc(ncircs), pcirc(ncircs))
    allocate(scirc(ncircs), ptrcirc(ncircs), kcirc(ncircs),ltrcirc(ncircs))
    allocate(inter(maxint), sdist(maxint), sindex(maxint), seg(maxint))
    allocate(rcont(maxint), zcont(maxint))

    rline(1:nlinlm) = alnlmr(1:nlinlm)
    zline(1:nlinlm) = alnlmy(1:nlinlm)
    uline(1:nlinlm) = -cos(alnlmt(1:nlinlm)*xpi/180._fp)
    vline(1:nlinlm) =  sin(alnlmt(1:nlinlm)*xpi/180._fp)

    rline(nlinlm+1) = LARGE_R*r0
    if (present(urmax)) rline(nlinlm+1)=urmax
    zline(nlinlm+1) = z0
    uline(nlinlm+1) = 0._fp
    vline(nlinlm+1) = 1._fp

    rline(nlinlm+2) = SMALL_R*r0
    if (present(urmin)) rline(nlinlm+2)=max(urmin,SMALL_R*r0)  ! prevent <0
    zline(nlinlm+2) = z0
    uline(nlinlm+2) = 0._fp
    vline(nlinlm+2) = 1._fp

    rline(nlinlm+3) = r0
    zline(nlinlm+3) = z0 + LARGE_Z*r0
    if (present(uzmax)) zline(nlinlm+3) = uzmax
    uline(nlinlm+3) = 1._fp
    vline(nlinlm+3) = 0._fp

    rline(nlinlm+4) = r0
    zline(nlinlm+4) = z0 - LARGE_Z*r0
    if (present(uzmin)) zline(nlinlm+4) = uzmin
    uline(nlinlm+4) = 1._fp
    vline(nlinlm+4) = 0._fp

    rcirc = crlmr1(1:ncirlm)
    zcirc = crlmy1(1:ncirlm)
    pcirc = crlmrd(1:ncirlm)
    kcirc = 0

    ! -- pick a side of the limiters --
    do i=1, nlines
      q = -(r0-rline(i))*vline(i) + (z0-zline(i))*uline(i)
      if (q==0._fp) then
        print *, '?lincir_contour: r0,z0 lies on line limiter ',i
        ier=1 ; goto 500
      end if
      sline(i) = sign(1.0_fp,q)
      ptrline(i)%iptr=0
      ptrline(i)%ix  =0
      ltrline(i)%ptr => ptrline(i)
    end do

    do i=1, ncircs
      q = ((r0-rcirc(i))**2 + (z0-zcirc(i))**2) - pcirc(i)**2
      if (q==0._fp) then
        print *, '?lincir_contour: r0,z0 lies on circle limiter ',i
        ier=1 ; goto 500
      end if
      scirc(i) = sign(1.0_fp,q)
      ptrcirc(i)%iptr=0
      ptrcirc(i)%ix  =0
      ltrcirc(i)%ptr => ptrcirc(i)
    end do

    if (gdebug) then
      !
      ! open debug file and write out lines and circle limiters
      !
      open(unit=47,file="lincir.dat",status="replace")
      isopen = .true.

      write(47,'(a)') "# plot 'lincir.dat' index 0 title 'limiters', '' index 2 lt 3 " &
           // "title 'contour', '' index 1 with points pt 4 ps 2 title 'intersects'"

      do i=1, nlines
        write(47,'(a,i3)') '# line limiter ',i
        q = 2._fp*max(r0, rline(i), abs(zline(i)))
        write(47,'(2(es14.6,1x))') rline(i)-q*uline(i), zline(i)-q*vline(i)
        write(47,'(2(es14.6,1x))') rline(i), zline(i)
        write(47,'(2(es14.6,1x))') rline(i)+q*uline(i), zline(i)+q*vline(i)
        write(47,'(a)') ' '
      end do

      do i=1, ncircs
        write(47,'(a,i3)') '# circle limiter ',i
        is = max(6,int(twopi*pcirc(i)/csegx))
        do k=0,is
          dr = rcirc(i) + pcirc(i)*cos((twopi*k)/is)
          dz = zcirc(i) + pcirc(i)*sin((twopi*k)/is)
          write(47,'(2(es14.6,1x))') dr, dz
        end do
        write(47,'(a)') ' '
      end do
    end if

    ! -- find intersections on boundary --
    nc = 0                      ! count number of intersections

    do i = 1, nlines-1          ! line-line
      do j = i+1, nlines
        det = vline(i)*uline(j)-uline(i)*vline(j)
        if (abs(det)<1.e-10_fp) cycle   ! parallel lines

        dr  = rline(j) - rline(i)
        dz  = zline(j) - zline(i)
        li  = (-vline(j)*dr + uline(j)*dz)/det
        lj  = (-vline(i)*dr + uline(i)*dz)/det

        rx = rline(i) + li*uline(i)
        zx = zline(i) + li*vline(i)

        rc = rline(j) + lj*uline(j)
        zc = zline(j) + lj*vline(j)

        if (max(abs(rx-rc),abs(zx-zc))>1.e-8_fp*r0) then
          print *, '?lincir_contour: logic error in line intersection'
          ier=1 ; goto 500
        end if

        if (.not. inside_limiter(rx,zx,i,j)) cycle   ! only the boundary intersections

        nc = nc+1
        if (nc>maxint) goto 490

        inter(nc)%r = rx
        inter(nc)%z = zx
        inter(nc)%seg1 = 0
        inter(nc)%seg2 = 0
        inter(nc)%lim(1)%index     = i
        inter(nc)%lim(1)%dist      = li
        inter(nc)%lim(1)%next%iptr = 0
        inter(nc)%lim(1)%next%ix   = 0
        inter(nc)%lim(2)%index     = j
        inter(nc)%lim(2)%dist      = lj
        inter(nc)%lim(2)%next%iptr = 0
        inter(nc)%lim(2)%next%ix   = 0

        ltrline(i)%ptr%iptr = nc
        ltrline(i)%ptr%ix   = 1
        ltrline(i)%ptr      => inter(nc)%lim(1)%next

        ltrline(j)%ptr%iptr = nc
        ltrline(j)%ptr%ix   = 2
        ltrline(j)%ptr      => inter(nc)%lim(2)%next
      end do
    end do

    do i = 1, ncircs-1          ! circle-circle
      do j = i+1, ncircs
        dr = rcirc(j) - rcirc(i)
        dz = zcirc(j) - zcirc(i)

        delta = sqrt(dr**2+dz**2)
        pi = pcirc(i)
        pj = pcirc(j)

        if ((pi+pj)<delta .or. delta<abs(pi-pj)) cycle  ! circles do not intersect

        n2i = pj**2 - (delta-pi)**2
        d2i = (delta+pi)**2 - pj**2

        n2j = pi**2 - (delta-pj)**2
        d2j = (delta+pj)**2 - pi**2

        if (n2i<0._fp .or. d2i<0._fp .or. n2j<0._fp .or. d2j<0._fp) cycle  ! do not intersect numerically

        olphai = 2._fp*atan2(sqrt(n2i),sqrt(d2i))   ! angles relative to delta
        olphaj = 2._fp*atan2(sqrt(n2j),sqrt(d2j))

        dalphai = atan2(dz,dr)      ! theta of delta
        dalphaj = dalphai + xpi     ! atan2(-dz,-dr)
        if (dalphaj>=twopi) dalphaj=dalphaj-twopi

        alphai(1) = dalphai - olphai
        alphaj(1) = dalphaj + olphaj

        alphai(2) = dalphai + olphai
        alphaj(2) = dalphaj - olphaj

        do k = 1, 2                 ! loop over intersection points
          if (k==2 .and. min(abs(olphai),abs(olphaj))<1.e-8_fp) then
            print *, '!lincir_contour: tangential circle-circle limiters'
            cycle 
          end if

          rx = rcirc(i) + pi*cos(alphai(k))
          zx = zcirc(i) + pi*sin(alphai(k))

          rc = rcirc(j) + pj*cos(alphaj(k))
          zc = zcirc(j) + pj*sin(alphaj(k))

          if (max(abs(rx-rc),abs(zx-zc))>1.e-8_fp*r0) then
            print *, '?lincir_contour: logic error in circle-circle intersection'
            ier=1 ; goto 500
          end if

          if (.not. inside_limiter(rx,zx,-i,-j)) cycle   ! only the boundary intersections

          nc = nc+1
          if (nc>maxint) goto 490

          inter(nc)%r    = rx
          inter(nc)%z    = zx
          inter(nc)%seg1 = 0
          inter(nc)%seg2 = 0
          inter(nc)%lim(1)%index     = -i
          inter(nc)%lim(1)%dist      = alphai(k)
          inter(nc)%lim(1)%next%iptr = 0
          inter(nc)%lim(1)%next%ix   = 0
          inter(nc)%lim(2)%index     = -j
          inter(nc)%lim(2)%dist      = alphaj(k)
          inter(nc)%lim(2)%next%iptr = 0
          inter(nc)%lim(2)%next%ix   = 0

          ltrcirc(i)%ptr%iptr = nc
          ltrcirc(i)%ptr%ix   = 1
          ltrcirc(i)%ptr      => inter(nc)%lim(1)%next

          ltrcirc(j)%ptr%iptr = nc
          ltrcirc(j)%ptr%ix   = 2
          ltrcirc(j)%ptr      => inter(nc)%lim(2)%next

          kcirc(j) = kcirc(j)+1
          kcirc(i) = kcirc(i)+1
        end do
      end do
    end do

    do i = 1, nlines          ! line-circle
      do j = 1, ncircs
        dr = rcirc(j) - rline(i)
        dz = zcirc(j) - zline(i)

        smid  = uline(i)*dr + vline(i)*dz
        pmid2 = max(0._fp,dr**2+dz**2-smid**2)    ! should be >0.
        det   = pcirc(j)**2 - pmid2

        if (det<0._fp) cycle   ! does not intersect
        det = sqrt(det)

        s(1) = smid - det
        s(2) = smid + det

        do k = 1, 2            ! loop over two intersection points
          if (k==2 .and. abs(s(2)-s(1))<1.e-8_fp*r0) then
            print *, '!lincir_contour: tangential line-circle limiters'
            cycle 
          end if

          rx = rline(i) + s(k)*uline(i)
          zx = zline(i) + s(k)*vline(i)

          delta = (rx-rcirc(j))**2 + (zx-zcirc(j))**2 - pcirc(j)**2

          if (abs(delta)>1.e-8_fp*r0) then
            print *, '?lincir_contour: logic error in line-circle intersection'
            ier=1 ; goto 500
          end if

          if (.not. inside_limiter(rx,zx,i,-j)) cycle   ! only the boundary intersections

          nc = nc+1
          if (nc>maxint) goto 490

          inter(nc)%r    = rx
          inter(nc)%z    = zx
          inter(nc)%seg1 = 0
          inter(nc)%seg2 = 0
          inter(nc)%lim(1)%index     = i
          inter(nc)%lim(1)%dist      = s(k)
          inter(nc)%lim(1)%next%iptr = 0
          inter(nc)%lim(1)%next%ix   = 0
          inter(nc)%lim(2)%index     = -j
          inter(nc)%lim(2)%dist      = atan2(zx-zcirc(j),rx-rcirc(j))
          inter(nc)%lim(2)%next%iptr = 0
          inter(nc)%lim(2)%next%ix   = 0

          ltrline(i)%ptr%iptr = nc
          ltrline(i)%ptr%ix   = 1
          ltrline(i)%ptr      => inter(nc)%lim(1)%next

          ltrcirc(j)%ptr%iptr = nc
          ltrcirc(j)%ptr%ix   = 2
          ltrcirc(j)%ptr      => inter(nc)%lim(2)%next

          kcirc(j) = kcirc(j)+1
        end do
      end do
    end do

    if (gdebug) then
      if (nc>0) write(47,'(/a)') '# intersect points '
      do i = 1, nc
        write(47,'(2(es14.6,1x))') inter(i)%r, inter(i)%z
      end do
      write(47,'(a)') ' '
    end if

    !
    ! --- find segments ----
    ! A segment is on the limter boundary if its midpoint is inside all the other limiters
    !
    nseg = 0

    do i = 1, nlines
      sptr = ptrline(i)
      do is = 1, maxint
        if (sptr%iptr==0) goto 100
        if ((sptr%ix/=1 .and. sptr%ix/=2) .or. sptr%iptr<0 .or. sptr%iptr>nc) then
          print *, '?lincir_contour: logic error, bad limiter or point index'
          ier=1 ; goto 500
        end if
        if (inter(sptr%iptr)%lim(sptr%ix)%index /= i) then
          print *, '?lincir_contour: logic error, mismatch in line linked list'
          ier=1 ; goto 500
        end if

        sdist(is)  = inter(sptr%iptr)%lim(sptr%ix)%dist
        sindex(is) = sptr%iptr
        sptr       = inter(sptr%iptr)%lim(sptr%ix)%next
      end do
      print *, '?lincir_contour: too many intersections'
      ier=1 ; goto 500

100   continue
      is = is-1
      if (is>1) then
        call tr_dsort(sdist,sindex,is,2)
        do k=1,is-1      ! loop over segments on this limiter
          smid = (sdist(k)+sdist(k+1))/2._fp

          rx = rline(i) + smid*uline(i)   ! midpoint, will test to see if segment is inside or outside all limiters
          zx = zline(i) + smid*vline(i)

          if (inside_limiter(rx,zx,i,0)) then
            call addseg(int(sindex(k)+0.1_fp), int(sindex(k+1)+0.1_fp), 0._fp, 0._fp)  ! it's a boundary segment
            if (ier/=0) goto 500
          end if
        end do
      end if
    end do


    do i = 1, ncircs
      sptr = ptrcirc(i)
      do is = 1, maxint-1             ! will add one more point later
        if (sptr%iptr==0) goto 120
        if ((sptr%ix/=1 .and. sptr%ix/=2) .or. sptr%iptr<0 .or. sptr%iptr>nc) then
          print *, '?lincir_contour: logic error, bad limiter or point index'
          ier=1 ; goto 500
        end if
        if (inter(sptr%iptr)%lim(sptr%ix)%index /= -i) then
          print *, '?lincir_contour: logic error, mismatch in circle linked list'
          ier=1 ; goto 500
        end if

        sdist(is)  = inter(sptr%iptr)%lim(sptr%ix)%dist
        sindex(is) = sptr%iptr
        sptr       = inter(sptr%iptr)%lim(sptr%ix)%next
      end do
      print *, '?lincir_contour: too many intersections'
      ier=1 ; goto 500

120   continue
      is = is-1
      if (is>0) then
        imin = 1
        do k = 1, is
          do while (sdist(k)>=twopi) 
            sdist(k) = sdist(k)-twopi
          end do
          do while(sdist(k)<0._fp)
            sdist(k) = sdist(k)+twopi
          end do
          if (sdist(k)<sdist(imin)) imin=k
        end do

        is = is+1
        sdist(is)  = sdist(imin)+twopi   ! closes last segment on circle
        sindex(is) = sindex(imin)

        call tr_dsort(sdist,sindex,is,2)
        do k=1,is-1      ! loop over segments on this limiter
          smid = (sdist(k)+sdist(k+1))/2._fp

          rx = rcirc(i) + pcirc(i)*cos(smid)   ! midpoint
          zx = zcirc(i) + pcirc(i)*sin(smid)

          if (inside_limiter(rx,zx,-i,0)) then
            call addseg(int(sindex(k)+0.1_fp), int(sindex(k+1)+0.1_fp), rx, zx)
            if (ier/=0) goto 500
          end if
        end do
      end if
    end do

    ! --- build contour ---

    ncont = 0
    rcont = 0._fp
    zcont = 0._fp

    if (nseg>0) then
      is     = 1
      ifirst = seg(is)%a
      iprev  = ifirst
      icur   = 0
      call addcont(ifirst) ; if (ier/=0) goto 500
      do 
        if (seg(is)%a==iprev) then        ! current point is other point in segment
          icur = seg(is)%b
        else if (seg(is)%b==iprev) then
          icur = seg(is)%a
        else
          print *, '?lincir_contour: logic error in segment -> point order'
          ier=1 ; goto 500
        end if
        if (icur<=0 .or. icur>nc) then
          print *, '?lincir_contour: unset point in segment'
          ier=1 ; goto 500
        end if

        if (seg(is)%r>0._fp) then
          ! add circular segment which goes from iprev to icur through seg%r,seg%z
          !call addcont(r=seg(is)%r,z=seg(is)%z)
          call addcirseg(                      &
               inter(iprev)%r, inter(iprev)%z, &
               seg(is)%r,      seg(is)%z,      &
               inter(icur)%r,  inter(icur)%z)
          if (ier/=0) goto 500
        end if

        if (icur==ifirst) exit           ! yeah, it worked!

        call addcont(icur) ; if (ier/=0) goto 500

        if (inter(icur)%seg1==is) then   ! next segment is other segment attached to point
          is = inter(icur)%seg2
        else if (inter(icur)%seg2==is) then
          is = inter(icur)%seg1
        else
          print *, '?lincir_contour: logic error in point -> segment order'
          ier=1 ; goto 500
        end if
        if (is<=0 .or. is>nseg) then
          print *, '?lincir_contour: unset segment in point'
          ier=1 ; goto 500
        end if
        iprev = icur
      end do
    else
      !
      ! no intersections so find innermost circle containing r0,z0
      !
      if (ncircs==0) then
        print *, '?lincir_contour: no segments and no circles?'
        ier=1 ; goto 500
      end if

      imin = 1        ! innermost circle
      det  = 1.e20_fp
      do i=1,ncircs
        q = pcirc(i) - sqrt((r0-rcirc(i))**2+(z0-zcirc(i))**2) ! distance to edge
        if (q>=0._fp .and. q<det) then
          imin = i
          det  = q
        end if
      end do

      k = max(6,int(twopi*pcirc(imin)/csegx))
      do j=0,k
        rx = rcirc(imin) + pcirc(imin)*cos((twopi*j)/k)
        zx = zcirc(imin) + pcirc(imin)*sin((twopi*j)/k)

        call addcont(r=rx,z=zx) ; if (ier/=0) goto 500
      end do

      kcirc(imin) = kcirc(imin)+1     ! so this circle is not checked against contour
    end if

    ! -- copy to output arrays --
    i1 = maxloc(rcont(1:ncont)) ; imaxR = i1(1)
    i1 = maxloc(zcont(1:ncont)) ; imaxZ = i1(1)
    i1 = minloc(zcont(1:ncont)) ; iminZ = i1(1)

    if (imaxZ<imaxR) imaxZ=imaxZ+ncont
    if (iminZ<imaxR) iminZ=iminZ+ncont

    if (iminZ<imaxZ) then
      idir = -1    ! cw so change to ccw
    else
      idir =  1    ! ccw
    end if

    allocate(rout(ncont+1),zout(ncont+1))            ! one extra point to close the contour
    do i = 1, ncont+1
      ic = mod(ncont+(i-1)*idir+imaxR-1,ncont)+1    ! start from larges R and go ccw looping around array ends
      rout(i) = rcont(ic)
      zout(i) = zcont(ic)
    end do

    if (gdebug) then
      write(47,'(/a)') '# contour'
      do i = 1, ncont+1
        write(47,'(2(es14.6,1x))') rout(i),zout(i)
      end do
      write(47,'(a)') ' '
    end if

    rmax = maxval(rout)
    rmin = minval(rout)
    zmax = maxval(zout)
    zmin = minval(zout)

    do i = 1, ncircs
      if (kcirc(i)==0) then
        !
        ! this circle does not have any intersections.  If it is outside all the other limiters
        ! then it can be ignored.  If it is inside the other limiters and contains r0,z0 then it should 
        ! have been caught as the limiter boundary.  If it does not contain r0,z0 but is
        ! inside all the other limiters then it is a floater.
        !
        k = 50     ! check a few points to see if they are inside the other limiters
        ic = 0     ! number of circle points which are inside the other limiters
        do j = 0,k
          rx = rcirc(i)+pcirc(i)*cos((twopi*j)/k)
          zx = zcirc(i)+pcirc(i)*sin((twopi*j)/k)
          if (inside_limiter(rx,zx,-i,0)) ic = ic+1
        end do

        if (ic==0) then
          cycle                  ! probably outside limiter boundary
        else if (ic==(k+1)) then
          if (scirc(i)<0._fp) then
            print *, '?lincir_contour: logic error, inner circle without intersections containing r0,z0 not the limiter?'
          else
            print *, '?lincir_contour: circle limiter ',i,' does not intersect any other limiters'
            print *, '                 but floats inside other limiters and does not contain r0,z0'
          end if
          ier=1 ; goto 500
        else if (ic>0) then
          print *, '?lincir_contour: logic error, circle limiter without intersections has points inside and outside contour'
          ier=1 ; goto 500
        end if
      end if
    end do

    goto 500     ! ok exit

490 continue
    print *, '?lincir_contour: logic error, exceeded intersection storage'
    ier=1 ; goto 500

500 continue
    if (isopen) then
      if (ier==0) then
        write(47,'(a)') '# Ok'
      else
        write(47,'(a)') '# ERROR'
      end if
      close(47)
    end if

    deallocate(rline, zline, uline, vline)
    deallocate(sline, ptrline, ltrline)
    deallocate(rcirc, zcirc, pcirc)
    deallocate(scirc, ptrcirc, kcirc, ltrcirc)
    deallocate(inter, sdist, sindex, seg)
    deallocate(rcont, zcont)

  contains
    !
    ! ------ addcirseg -------
    ! add a circular segment to the contour list
    !
    subroutine addcirseg(r0,z0,r1,z1,r2,z2)
      real(fp),intent(in) :: r0,z0,r1,z1,r2,z2  ! threee points on segment in order of traversal

      integer  :: idir              ! direction of theta for arc from 0 to 1 to 2
      integer  :: kt                ! number of segments to put on an arc
      integer  :: k                 ! temp

      real(fp) :: rm,zm,rp,zp       ! midpoints of line segments connecting first two and last two points
      real(fp) :: drm,dzm,drp,dzp   ! unit vectors orthogonl to line segments
      real(fp) :: dm,dp             ! length of line segments
      real(fp) :: det               ! temp
      real(fp) :: lm,lp             ! distance from midpoints to circle center
      real(fp) :: rc,zc             ! center of circle containing three points
      real(fp) :: dr0,dr1,dr2       ! delta R from center to points
      real(fp) :: dz0,dz1,dz2       ! delta Z from center to points
      real(fp) :: p0,p1,p2          ! radius from center to points
      real(fp) :: t0,t1,t2          ! thetas of three points
      real(fp) :: dt                ! delta theta

      ! -- find center --
      rm = (r0+r1)/2._fp  ; drm = -(z1-z0)
      zm = (z0+z1)/2._fp  ; dzm =  (r1-r0)
      rp = (r1+r2)/2._fp  ; drp = -(z2-z1)
      zp = (z1+z2)/2._fp  ; dzp =  (r2-r1)

      dm = sqrt(drm**2+dzm**2)
      dp = sqrt(drp**2+dzp**2)
      if (dm<1.e-8_fp*r0 .or. dp<1.e-8_fp*r0) then
        print *, '?lincir_contour: coincident points on circular segment'
        ier=1 ; return
      end if

      drm = drm/dm ; dzm = dzm/dm
      drp = drp/dp ; dzp = dzp/dp

      det = dzm*drp-drm*dzp
      if (abs(det)<1.e-8_fp) then
        print *, '?lincir_contour: linear points on circular segment'
        ier=1 ; return
      end if

      lm = (-dzp*(rp-rm)+drp*(zp-zm))/det
      lp = (-dzm*(rp-rm)+drm*(zp-zm))/det

      rc = rm + lm*drm
      zc = zm + lm*dzm

      ! -- establish directions --
      dr0 = r0-rc ; dz0 = z0-zc ; p0 = sqrt(dr0**2+dz0**2)
      dr1 = r1-rc ; dz1 = z1-zc ; p1 = sqrt(dr1**2+dz1**2)
      dr2 = r2-rc ; dz2 = z2-zc ; p2 = sqrt(dr2**2+dz2**2)

      if (abs(p0-p1)>1.e-8*r0 .or. abs(p0-p2)>1.e-8*r0) then
        print *, '?lincir_contour: logic error, bad center'
        ier=1 ; return
      end if

      det = dr0*dz1-dr1*dz0    ! (r0,z0) X (r1,z1)  establishes arc direction
      if (det>0._fp) then
        idir=1
      else
        idir=-1
      end if

      ! -- arc from r0,z0 to r1,z1 --
      t0 = atan2(dz0,dr0)
      t1 = atan2(dz1,dr1)
      if (idir*t1<idir*t0) t1=t1+idir*twopi
      kt = max(1,int(p0*abs(t1-t0)/csegx))
      dt = idir*abs(t1-t0)/kt
      do k = 1, kt-1
        call addcont(r=rc+p0*cos(t0+k*dt),z=zc+p0*sin(t0+k*dt))
        if (ier/=0) return
      end do

      call addcont(r=r1,z=z1) ; if (ier/=0) return

      ! -- arc from r1,z1 to r2,z2 --
      t1 = atan2(dz1,dr1)
      t2 = atan2(dz2,dr2)
      if (idir*t2<idir*t1) t2=t2+idir*twopi
      kt = max(1,int(p0*abs(t2-t1)/csegx))
      dt = idir*abs(t2-t1)/kt
      do k = 1, kt-1
        call addcont(r=rc+p1*cos(t1+k*dt),z=zc+p1*sin(t1+k*dt)) 
        if (ier/=0) return
      end do
    end subroutine addcirseg


    !
    ! ------ addcont -------
    ! add a point to the contour either by intersection point index or by R,Z
    subroutine addcont(i, r, z)
      integer, intent(in),optional :: i    ! intersection point index
      real(fp),intent(in),optional :: r,z  ! point to add

      real(fp) :: rs,zs    ! actual point to add
      real(fp),allocatable :: t(:)  ! temp

      if (present(i) .and. (present(r).or.present(z))) then
        print *, '?lincir_contour: too many arguments to addcont'
        ier=1 ; return
      end if

      if (present(i)) then
        rs = inter(i)%r
        zs = inter(i)%z
      else if (present(r) .and. present(z)) then
        rs = r
        zs = z
      else
        print *, '?lincir_contour: only r or z given to addcont'
        ier=1 ; return
      end if

      ncont = ncont+1
      if (ncont>size(rcont)) then
        allocate(t(size(rcont)))        ! expand rcont,zcont
        t = rcont
        deallocate(rcont)
        allocate(rcont((13*ncont)/10))
        rcont(1:size(t)) = t

        t = zcont
        deallocate(zcont)
        allocate(zcont(size(rcont)))
        zcont(1:size(t)) = t
        deallocate(t)
      end if

      rcont(ncont) = rs
      zcont(ncont) = zs
    end subroutine addcont


    !
    ! ----- addseg -----
    ! create a new segment on the limiter boundary
    !
    subroutine addseg(a,b,r,z)
      integer, intent(in) :: a     ! intersect index of one point on segment
      integer, intent(in) :: b     ! intersect index of second point on segment
      real(fp),intent(in) :: r,z   ! >0. then this is the circle midpoint

      nseg = nseg+1
      if (nseg>size(seg)) then
        print *, '?lincir_contour: too many segments'
        ier=1 ; return
      end if

      seg(nseg)%a = a
      seg(nseg)%b = b
      seg(nseg)%r = r
      seg(nseg)%z = z

      if (inter(a)%seg1==0) then
        inter(a)%seg1=nseg
      else if (inter(a)%seg2==0) then
        inter(a)%seg2=nseg
      else
        goto 25
      end if

      if (inter(b)%seg1==0) then
        inter(b)%seg1=nseg
      else if (inter(b)%seg2==0) then
        inter(b)%seg2=nseg
      else
        goto 25
      end if
      return

25    continue
      print *, '?lincir_contour: logic error, too many segments attach to one point'
      ier=1 
    end subroutine addseg

    !
    ! ------------ inside_limiter -----------
    ! return true if the r,z point is inside or on the limiter
    ! iex,jex >0 indices of line limiters to skip
    ! iex,jex <0 -indices of circle limiters to skip
    !
    function inside_limiter(r,z,iex,jex) result (isin)
      real(fp),  intent(in) :: r,z      ! coordinates of point
      integer, intent(in) :: iex,jex  ! exclude these limiters 
      logical             :: isin     ! .true. if inside all tested limiters

      integer  :: i
      real(fp) :: q

      isin = .false.
      do i=1, nlines
        if (i==iex .or. i==jex) cycle
        q = -(r-rline(i))*vline(i) + (z-zline(i))*uline(i)
        if (sline(i)*q<0._fp) return
      end do

      do i=1, ncircs
        if (i==-iex .or. i==-jex) cycle
        q = ((r-rcirc(i))**2 + (z-zcirc(i))**2) - pcirc(i)**2
        if (scirc(i)*q<0._fp) return
      end do

      isin = .true.
    end function inside_limiter

  end subroutine lincir_contour

end module lincir_contour_mod

C******************** START FILE UBINIT.FOR ; GROUP UPAUST *************
C--------------------------------------------------------------
C&  UBINIT  TTY DEPENDENT INTERFACE TO SG LIB CALL BINITT
C
C  INTERFACE TO SG BINITT -
C   PREPARE FOR NEW GRAPH PAGE
C
      SUBROUTINE UBINIT(IDUM)
C
      USE USERIO
C
C------------------------------------------
C
      IF(NTTYP.GE.0) THEN
C
        NPLOTD=NPLOTD+1
C
        IF(NPLOTD.EQ.1) WRITE(LUNTRM,1001)
 1001   FORMAT(' [ GFLIB/SGLIB -- output to plot screen or file ]')
C
        CALL INITT(0)
 
        CALL BINITT
 
        IOUT=2
        CALL AGSEEF(IOUT,IDUM1,IDUM2,IDUM3)
C
C  CLEAR GRAPHICS SCREEN IN OUTPUT IF TO A TERMINAL
C    OR IF TO A FILE AND THIS IS NOT THE FIRST PLOT
C
        IF((NPLOTD.GT.0).OR.(IOUT.GE.2)) CALL NEWPAG
C
      ENDIF
C
      RETURN
      END
C******************** END FILE UBINIT.FOR ; GROUP UPAUST ***************

real(fp) function r8_shafnl(Delprime)
  ! Returns the nonlinear Shafranov shift derivative "ShafNL",
  ! given the linear Shafranov shift derivative "Delprime".
  ! ShafNL is related to Delprime by the equation:
  !	ShafNL = Delprime * (1-ShafNL**2)**(3/2)
  ! This insures that -1 <= ShafNL <= 1.  Delprime may lie outside this
  ! interval, in which case the flux surfaces would nonsensically overlap
  ! if the nonlinear correction were not used.  SMP was used to solve the
  ! above cubic equation.
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: delprime,b,xprs
  real(fp) :: third = (1._fp/3._fp)
 
  logical :: shafnl_flag
  data shafnl_flag /.true./ ! .false. = always use linear shift!
 
  ! For extremely small values of Delprime, the linear formula is perfectly
  ! O.K., while the nonlinear formula suffers from round-off errors.
 
  if(abs(Delprime) .le. 0.001_fp .or. .not. shafnl_flag) then
    r8_shafnl=Delprime
    return
  end if

  b=abs(Delprime)
  xprs=(-27.0_fp/b**2+(729.0_fp/b**4+108.0_fp/b**6)**0.5_fp)**third
  r8_shafnl=1.0_fp-2.0_fp**third/b**2/xprs + xprs/3/2**third

  r8_shafnl=sqrt(r8_shafnl)*SIGN (1.0_fp, Delprime)

  return
end function r8_shafnl 

C-----------------------------------------------------------------------
C LIMPLOTR -- PLOT PLASMA BDY AND LIMITERS -- FOR DEBUGGING
C
      SUBROUTINE LIMPLOTR(RUNID,ZTIME, RMCB,YMCB,MIMOM,NMOMD,
     1    NONLIN,MILIM,
     2    NLINLM,ALNLMR,ALNLMY,ALNLMT,
     3    NCIRLM,CRLMR1,CRLMY1,CRLMRD,
     4    mnlim,rpts,ypts,irflim,rpts_rf,ypts_rf,
     5    nant,nrz_ant,namax,ranta,yanta)
C
C  PASSED:
C
      CHARACTER*(*) RUNID   ! TRANSP RUNID
      REAL ZTIME            ! TIME OF PLOT
      REAL RMCB(0:MIMOM,2),YMCB(0:MIMOM,2)   ! BDY CONTOUR
      INTEGER NMOMD         ! NO. OF ACTIVE MOMENTS IN BDY CONTOUR
C
      INTEGER NONLIN        ! I/O CHANNEL
      INTEGER NLINLM,NCIRLM ! LIMITER COUNTS (LINEAR, CIRCULAR)
C  LINE LIMITERS (AS IN TRANSP COMMON TRCOM):
      REAL ALNLMR(MILIM),ALNLMY(MILIM),ALNLMT(MILIM)
C  CIRCLE LIMITERS (AS IN TRANSP COMMON TRCOM):
      REAL CRLMR1(MILIM),CRLMY1(MILIM),CRLMRD(MILIM)
c
c  contour limiter -- instead of circles & lines if MNLIM > 1:
c
      integer :: MNLIM
      real :: rpts(MNLIM),ypts(MNLIM)
C
C  RF limiter
C
      integer :: irflim
      real :: rpts_rf(irflim),ypts_rf(irflim)
C
C  RF antennas
C
      integer :: nant
      integer :: nrz_ant(nant)
      integer :: namax
      real :: ranta(namax,nant),yanta(namax,nant)
C
C  LOCAL:
C
      PARAMETER (IMAXPL=15)
      PARAMETER (INPTS=500)
      REAL ZRPLOT(INPTS,IMAXPL),ZYPLOT(INPTS,IMAXPL),ZZ(IMAXPL)
      INTEGER INC(IMAXPL),ISEL(IMAXPL),inum
C
      CHARACTER*80 MNLAB(3)
      CHARACTER*20 KYLAB(5)
      CHARACTER*12 ZXLAB(15)
C
      DATA TWOPI/6.283185/
C
C-----------------------------------------------------------------------
C
      if(irflim.gt.1) then
         incr = 1
      else
         incr = 0
      endif

      if(mnlim.le.1) then

         INTOT=NLINLM+NCIRLM+incr
         WRITE(NONLIN,1001) INTOT
 1001    FORMAT(' %LIMPLOT:  NAMELIST SPECIFIES ',I2,' LIMITERS.')
C
         IF(INTOT.GE.IMAXPL) THEN
            IMM1=IMAXPL-1
            ILASL=INTOT-IMM1+1
            WRITE(NONLIN,1002) IMM1,ILASL
 1002       FORMAT(' %LIMPLOT:  CAN ONLY PLOT ',I2,' LIMITERS.'/
     >           '  MUST RESTRICT RANGE OF LIMITERS TO PLOT;'/
     >           '  ENTER # OF 1st LIMITER TO PLOT BTW. 1 AND ',I2,':')
            IPLOT1=1
            CALL UREADI('LIMPLOT: ENTER NO. OF FIRST LIMITER TO PLOT:$',
     >           IPLOT1)
            IPLOT1=MAX(1,MIN(ILASL,IPLOT1))
            IPLOT2=IPLOT1+IMM1-1-incr
         ELSE
            IPLOT1=1
            IPLOT2=INTOT
         ENDIF
      endif
C
C  SET UP PLOTTING DATA
C
      ZRMIN=1.e20
      ZRMAX=-1.e20
      zymin=1.e20
      zymax=-1.e20
C
      DO ITH=1,INPTS
C  PLASMA BDY DATA
        ZTH=TWOPI*FLOAT(ITH-1)/FLOAT(INPTS-1)
        ZR=0.0
        ZY=0.0
        DO IMOM=0,NMOMD
           ZCS=COS(IMOM*ZTH)
           ZSN=SIN(IMOM*ZTH)
           ZR=ZR+RMCB(IMOM,1)*ZCS+RMCB(IMOM,2)*ZSN
           ZY=ZY+YMCB(IMOM,1)*ZCS+YMCB(IMOM,2)*ZSN
        ENDDO
        ZRPLOT(ITH,1)=ZR
        ZYPLOT(ITH,1)=ZY
        ZRMIN=AMIN1(ZR,ZRMIN)
        ZRMAX=AMAX1(ZR,ZRMAX)
        ZYMIN=AMIN1(ZY,ZYMIN)
        ZYMAX=AMAX1(ZY,ZYMAX)
      ENDDO
C
      INC(1)=INPTS
      ISEL(1)=1
      ZZ(1)=1.0
      ZXLAB(1)='PLASMA BDY'
C
C  RF vacuum vessel contour (if any)
C
      if(irflim.gt.1) then
         inc(2)=min(inpts,irflim)
         isel(2)=2
         zz(2)=2.0
         zxlab(2)='RF VV BDY'
         zrplot(1:inc(2),2)=rpts_rf(1:inc(2))
         zyplot(1:inc(2),2)=ypts_rf(1:inc(2))
      endif
C
      IPLOT=incr
      IZ=1+incr
C
      if(mnlim.le.1) then
         DO ILIM=1,NCIRLM
            IPLOT=IPLOT+1
            IF((IPLOT1.LE.IPLOT).AND.(IPLOT.LE.IPLOT2)) THEN
C     PLOT THIS CIRCULAR LIMITER
               IZ=IZ+1
               DO ITH=1,INPTS
                  ZTH=TWOPI*FLOAT(ITH-1)/FLOAT(INPTS-1)
                  ZRPLOT(ITH,IZ)=CRLMR1(ILIM)+CRLMRD(ILIM)*COS(ZTH)
                  ZYPLOT(ITH,IZ)=CRLMY1(ILIM)+CRLMRD(ILIM)*SIN(ZTH)
               ENDDO
               INC(IZ)=INPTS
               ISEL(IZ)=IZ
               ZZ(IZ)=IZ
               WRITE(ZXLAB(IZ),'(''CRLM#'',I2)') ILIM
            ENDIF
         ENDDO
C
         ZLEN=3.0*max((ZYMAX-ZYMIN),(ZRMAX-ZRMIN))
C
         DO ILIM=1,NLINLM
            IPLOT=IPLOT+1
            IF((IPLOT1.LE.IPLOT).AND.(IPLOT.LE.IPLOT2)) THEN
C  PLOT THIS LINE LIMITER
               IZ=IZ+1
               ZTH=TWOPI*ALNLMT(ILIM)/360.0
               ZRPLOT(1,IZ)=ALNLMR(ILIM)-ZLEN*COS(ZTH)
               ZYPLOT(1,IZ)=ALNLMY(ILIM)+ZLEN*SIN(ZTH)
               ZRPLOT(2,IZ)=ALNLMR(ILIM)
               ZYPLOT(2,IZ)=ALNLMY(ILIM)
               ZRPLOT(3,IZ)=ALNLMR(ILIM)+ZLEN*COS(ZTH)
               ZYPLOT(3,IZ)=ALNLMY(ILIM)-ZLEN*SIN(ZTH)
               INC(IZ)=3
               ISEL(IZ)=IZ
               ZZ(IZ)=IZ
               WRITE(ZXLAB(IZ),'(''LNLM#'',I2)') ILIM
            ENDIF
         ENDDO
      else
         IZ=2+incr
         inum=min(INPTS,mnlim)
         INC(IZ)=inum
         ISEL(IZ)=IZ
         ZZ(IZ)=IZ
         zxlab(iz)='LIMITER'
         ZRPLOT(:,IZ)=0
         ZYPLOT(:,IZ)=0
         ZRPLOT(1:inum,IZ)=rpts(1:inum)
         ZYPLOT(1:inum,IZ)=ypts(1:inum)
      endif
C
      do ia=1,nant
         if((nrz_ant(ia).gt.0).and.(iz.lt.15)) then
            iz=iz+1
            inum=nrz_ant(ia)
            inc(iz)=inum
            isel(iz)=iz
            zz(iz)=iz
            zxlab(iz)=' '
            write(zxlab(iz),'("RF Ant.#",i2)') ia
            ZRPLOT(:,IZ)=0
            ZYPLOT(:,IZ)=0
            ZRPLOT(1:inum,IZ)=ranta(1:inum,ia)
            ZYPLOT(1:inum,IZ)=yanta(1:inum,ia)
         endif
      enddo

      MNLAB(1)='RUN '//RUNID//' PLOT OF PLASMA BDY AND LIMITERS'
      MNLAB(2)='GENERATED BY SUBROUTINE LIMPLOTR.FOR'
      WRITE(MNLAB(3),'('' TIME OF PLOT:  '',1PE11.4,'' SECONDS.'')')
     >    ZTIME
C
      KYLAB(1)='CONTOUR#1: BDY'
      if(mnlim.le.1) then
         KYLAB(2)='CIRC. LIMITERS'
         KYLAB(3)='LINE LIMITERS'
      else
         KYLAB(2)='limiter contour'
         KYLAB(3)=' '
      endif
      KYLAB(4)='RF Vacuum Vessel'
      KYLAB(5)='RF Antennas'
C
      CALL GRFMM1(ZRPLOT,ZYPLOT,INPTS,INC,IZ,ZZ,IZ,ISEL,IZ,
     >    'CM','CM',MNLAB,KYLAB,ZXLAB)
C
      RETURN
      END

!==============================================================================
!
SUBROUTINE SIGVBB_Z(SIG, A, B, COS_THETA,&
     EDUMMY, T1DUMMY, T2DUMMY, ZEXPDUMMY, NTHETA, NREACT)
!
!   THIS COMPUTES THE VALUE OF V*SIGMA(V), WHERE V IS THE
!   RELATIVE VELOCITY.
!
!	SIGMA(V) COMES FROM HARRY TOWNER'S FUNCTION "SIGMA"
!	for source see TOWNER$:[FUSION]SIGMA.FOR, for literature
!   see George H. Miley, Harry Towner, and Nenad Ivich, Report C00-2218-17,
!       University of Illinois. (3/8/77 ? )
!
!   Please note that, here, A and B are in eV, and SIG is in Barns*cm/sec.
!   Also note that SIGMA returns SIGMA in units of m**2, but it takes the
!   incident particle energy to be in keV.  Also note that, in the reaction
!   T(D,N)He4, it is the T which is stationary and the D which is incident.
!
! ------------------------------------------------------------------------
!   SIGE(E) replaces old computation			12/5/90  HF
!	E in kev,  SIGE returns m**2
! ------------------------------------------------------------------------
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : zero,two,zev2kev
  IMPLICIT NONE
  INTEGER ntheta,i
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) a,b,edummy,t1dummy,t2dummy,zexpdummy,e,sigtmp,sige_z,v
  real(fp),dimension(NTHETA) :: sig,cos_theta
!============
!!---> idecl moved declarations:
  INTEGER		NREACT	    !WHICH REACTION TO COMPUTE
!
!
!
!...NREACT  Tells what reaction you want:
!
!	  =1 you get the cross section for the reaction  T(D,N)HE4
!	  =2 you get the cross section for the reaction  HE3(D,P)HE4
!	  =3 you get the cross section for the reaction  D(D,P)T
!	  =4 you get the cross section for the reaction  D(D,N)HE3
!	  =5 you get the cross section for the reaction  T(T,2N)HE4
!	  =12 you get the cross section for the reaction  T(T,2N)HE4 !DPC fit 06/2018
!	  =6 you get the cross section for the reaction  T(HE3,X)Y
!
!	    N.B.: The reaction convention is
!		TARGET (INCIDENT, SMALL_PRODUCT) LARGE_PRODUCT
!
  real(fp) :: AMU_PROJECTILE(12)   !ATOMIC MASS UNITS OF PROJECTILE SPECIES
!
  DATA AMU_PROJECTILE/two,two,two,two,3.0_fp,3.0_fp,5*zero,3.0_fp/ !D,D,D,D,T,HE3, 5 none, T
!
!==============================================================================
!
  DO I = 1, NTHETA
     E = A - B*COS_THETA(I)    !I assume B.LE.A
     E = max(zero, E)	!DON'T TRUST COS(THETA)!
!
!   NOW FIX THE UNITS TO BE BARNS*CM/SEC INSTEAD OF BARNS*SQRT(EV)
!
!	Note that we are computing SIGMA(E)*V(E), not SIGMA(E)
!	V = CONST*SQRT(2*E/(A*Mp))  where A is the atomic number & Mp is the
!				    proton mass (grams), E is the projectile
!				    energy in eV, CONST is a conversion factor
!				    V is the projectile velocity in cm/sec.
!	V = SQRT(E)*CONST*SQRT(2/(A*Mp))
!	V = SQRT(E)*CON
!	    CON = CONST*SQRT(2/(A*Mp)) = 9.786E5 for D projectile
!
!  For reactions where D is not the projectile CON=>CON*SQRT(2/A)
!
!	BOLTZMAN'S CONST K = 1.3807E-16 ERG/DEG(K) = 1/(11605 DEG(K)/eV)
!	SO THERE ARE 1.3807*1.1605E-12 ERG/EV = 1.6022E-12 ERG/EV
!	MULT BY 2 AND DIVIDE BY MP GIVING 1.9158E12. TAKE SQRT
!	GIVING 1.384E6 CM/SEC FOR 1 EV FOR A PROTON OR DIV BY SQRT(2)
!	GIVING 9.786E5 CM/SEC FOR D.
!
! ---  SIGE argument in kev, returns  m**2   (1 barn = 1.e-28 x m**2)
     SIGTMP=zero		!   	SIGE not set for very low E
     SIGTMP=1.e+28_fp*SIGE_Z(zev2kev*E)
     V = SQRT(1.9158e+12_fp*E/AMU_PROJECTILE(NREACT))	!   cm/sec
     SIG(I) = SIGTMP*V		!    barns*cm/sec
  enddo
!
  RETURN
!
END SUBROUTINE SIGVBB_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

subroutine f90_delay_r4(zdelay,zflops)

  !  REAL (usually real*4) interface to f90_delay which has a REAL*8
  !  interface.

  implicit NONE
  real, intent(in) :: zdelay   ! desired delay (seconds)
  real, intent(out) :: zflops  ! REAL*8 FLOPS executed to create this delay

  real*8 :: zdelay_r8,zflops_r8

  zdelay_r8 = zdelay
  call f90_delay(zdelay_r8,zflops_r8)
  zflops = zflops_r8

end subroutine f90_delay_r4

subroutine f90_delay(zdelay,zflops)

  implicit NONE
  real*8, intent(in) :: zdelay   ! desired delay (seconds)
  real*8, intent(out) :: zflops  ! REAL*8 FLOPS executed to create this delay

  !  Count by adding 1.0 to zflops repeatedly until a specified delay
  !  time (zdelay, seconds) has ellapsed.

  !  Use f90 intrinsic routine system_clock to get information on the 
  !  system clock; if there is no clock, get a delay (in seconds) using
  !  "gosleep" and set zflops = 0.0_R8

  integer :: i,j,icount0,icount,icount_rate,icount_max
  integer :: idelay,iincr,itarget,iwrap,jwrap,ierr

  !---------------------------------------

  call system_clock(icount0,icount_rate,icount_max)

  if(icount_max.gt.0) then
     iincr = 1 + zdelay*icount_rate
     if((icount_max/iincr).lt.10) then
        ierr=1
     else
        ierr=0
        itarget = icount0+iincr
        if(itarget.gt.icount_max) then
           iwrap = 1
           itarget = iincr - (icount_max-icount0) + 1
        else
           iwrap = 0
        endif
     endif
  else
     ierr=1
  endif

  if(ierr.eq.1) then
     zflops = -1.0d0
     idelay = 1 + zdelay
     call gosleep(idelay)
     return
  endif

  zflops = 0.0d0

  i=0
  idelay=10000

  do 

     i=i+1
     call system_clock(icount,icount_rate,icount_max)
     if(icount.lt.icount0) then
        jwrap=1
     else
        jwrap=0
     endif

     if((jwrap.ge.iwrap).and.(icount.ge.itarget)) exit

     do j=1,idelay
        zflops=zflops+1.0d0
     enddo

  enddo

end subroutine f90_delay

      subroutine ubrfcmp(ilun,zvals,numvals,ier)
C
C  UFILES low level i/o routine -- read compressed real array
C   data.
C
      use UFILES
C
      real zvals(numvals)
C
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(4)    ! small local buffer
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
C
C-----------------------------------------------------
C
      ier=0
C
      CALL UFLCHK(ILUN,'ubrfcmp   ',ICHAN,IER)
      IF(IER.NE.0) go to 999
C
      ilenb=4
      call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,ilenb)
#ifdef __CRAY
      itype=ichar(ilbuf(1))
#else
      itype=ilbuf(1)
#endif
      if((itype.lt.4).or.(itype.gt.5)) then
         write(6,'('' ?ubrfcmp:  unexpected data type code.'')')
         go to 999
      endif
C
      call ubi3dcod(ilbuf,2,inum)
C
      if(inum.ne.numvals) then
         write(6,'('' ?ubrfcmp:  unexpected data count.'')')
         go to 999
      endif
C
C---------------
C
C  loop through fp numbers, 1 block at a time
C
      do iblk=1,numvals,ufmaxr
         ilim=min(iblk+ufmaxr-1,numvals)
         inum=ilim-iblk+1
C
C  IEEE conversion or copy
C
         if(itype.eq.4) then
C  uncompressed read
            ibytes=4*inum
            call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ufieee,ibytes)
            call packordr(ufieee,inum,0)
         else
C  read and decompress
            call ubrfi2(ilun,ichan,uffhi,'hi',inum)
            call ubrfi2(ilun,ichan,ufflo,'lo',inum)
C  reassemble
            call repki2(ufieee,uffhi,ufflo,inum)
         endif
C
C  convert to floating pt (if needed) and store in output array
C
         call vmsieee(6,zvals(iblk),ilim-iblk+1,ufieee,0)
C
      enddo
      go to 1000
C
C  errors
C
 999  continue
      ier=1
      write(6,'('' ?UFLIB:  ubrfcmp low level i/o routine:  error.'')')
C
C  exit
C
 1000 continue
      return
      end

      subroutine bad_exit
C
#ifdef __MPI
      write(6,*) 
     >' %bad_exit:  generic f77 error exit call (errset_mpi status 999)'
#else
      write(6,*) 
     >' %bad_exit:  generic f77 error exit call (errset status 999)'
#endif
C
      call err_end
      call fort_flush(6)
C
      call errset_mpi(-1,999)
C
      STOP                              ! this line not reached.
      END

C***********************************************************************
      SUBROUTINE TERM_OUT(BUFFER,NBYTES)
C
      implicit none
C
#include "fpreproc/byte_declare.h"
C
C...This routine was written by Harry H. Towner of the Princeton
C...Plasma Physics Lab. This routine is similar to John Coonrod's
C...routine JC_LINE. This routine will output NBYTES of array BUFFER
C...to the user's terminal
C
C...Parameters:
C*..BUFFER	- Array of NBYTES to be sent to ther user's terminal.
C*..NBYTES	- The number of bytes to be sent to the terminal
C
C***********************************************************************
C
      integer nbytes
      byte_declare BUFFER(NBYTES)
C
      INTEGER ITEMP,ISTAT,I,ZPUTC
C
      DO I=1,NBYTES
#if __CRAY || __SX
        ITEMP=ichar(BUFFER(I))
#else	
        ITEMP=BUFFER(I)
#endif	
        ISTAT=ZPUTC(ITEMP)
      END DO
C
      RETURN
      END
C-----------------------
      subroutine term_str_out(str)
      implicit none
C
      character*(*) str
C
      integer NBSIZ
      parameter (NBSIZ=128)
C
      byte_declare BUFFER(NBSIZ)
C
      integer ilen,ic0,ice,inb,i,ic
C
      ilen=len_trim(str)
C
      do ic0=1,ilen,NBSIZ
         ice=min(ilen,(ic0+NBSIZ-1))
         inb=ice-ic0+1
         do i=1,inb
            ic=ic0+i-1
#if __CRAY || __SX
            buffer(i)=str(ic:ic)
#else
            buffer(i)=ichar(str(ic:ic))
#endif
         enddo
C
         call term_out(buffer,inb)
      enddo
C
      return
      end

!******************** START FILE SEVALI.FOR ; GROUP TRKRLIB *************
!  MOD DMC SUMMER 1987 JET/GARCHING
!   ROUTINE MAY EVALUATE LINEAR INSTEAD OF SPLINE INTERPOLATION, if
!   COMMON SWITCH ILIN IS SET ***
!....................................................
real(fp) FUNCTION r8_sevali(N, U, X, Y, B, C, D, dx)
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: iput,ilin
  integer :: N
  real(fp) :: U
  real(fp), dimension(N) :: X, Y, B, C, D
  real(fp) :: dx
  !
  !  THIS subroutine EVALUATES THE CUBIC SPLINE FUNCTION
  !
  !    SEVALI = Y(I) + B(I)*(U-X(I)) + C(I)*(U-X(I))**2 + D(I)*(U-X(I))**3
  !
  !    WHERE  X(I) .LT. U .LT. X(I+1), USING HORNER'S RULE
  !
  !  if  U .LT. X(1) THEN  I = 1  IS USED.
  !  if  U .GE. X(N) THEN  I = N  IS USED.
  !
  !  INPUT..
  !
  !    N = THE NUMBER OF DATA POINTS
  !    U = THE ABSCISSA AT WHICH THE SPLINE IS TO BE EVALUATED
  !    X,Y = THE ARRAYS OF DATA ABSCISSAS AND ORDINATES
  !    B,C,D = ARRAYS OF SPLINE COEFFICIENTS COMPUTED BY SPLINE
  !
  !  if  U  IS NOT IN THE SAME INTERVAL AS THE PREVIOUS CALL, THEN A
  !  BINARY SEARCH IS PERFORMED TO DETERMINE THE PROPER INTERVAL.
  !
  !  DMC GARCHING OCT 1985 KLUGE
  COMMON/ZSEVALI/ IPUT,ILIN
  !  RETURN ZONE INDEX TO CALLER VIA THIS COMMON BLOCK ***
  !
  integer :: I, J, K
  real(fp) :: zslop
  DATA I/1/
  SAVE I

  if ( I .GE. N ) I = 1
  if ( U .LT. X(I) ) GO TO 10
  if ( U .LE. X(I+1) ) GO TO 30
  !
  !  BINARY SEARCH
  !
10 I = 1
  J = N+1
20 K = (I+J)/2
  if ( U .LT. X(K) ) J = K
  if ( U .GE. X(K) ) I = K
  if ( J .GT. I+1 ) GO TO 20
  !
  !  EVALUATE SPLINE
  !
30 DX = U - X(I)
  if(ILIN.EQ.0) then
    r8_sevali = Y(I) + DX*(B(I) + DX*(C(I) + DX*D(I)))
  else
    if(I.EQ.N) then
      ZSLOP=(Y(N)-Y(N-1))/(X(N)-X(N-1))
    else
      ZSLOP=(Y(I+1)-Y(I))/(X(I+1)-X(I))
    end if
    r8_sevali=Y(I)+DX*ZSLOP
  end if
  !
  IPUT=I
  !
  return
END FUNCTION r8_sevali

      subroutine ubwchar(ilun,zchar)
C
C  UFILES low level i/o routine
C  write short uncompressed character data string
C  ...see also ubrchar
C
      use UFILES
C
      character*(*) zchar
C
      parameter (ilblen=128)
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(ilblen),ibyte    ! small local buffer
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
      integer iz
c
C
C-----------------------------------------------------
C
      CALL UFLCHK(ILUN,'ubwchar   ',ICHAN,IER)
      IF(IER.NE.0) go to 999
C
      ioff=4  ! space needed as data header
C
      ilen=len(zchar)
      if(ilen.gt.ilblen-ioff) then
         write(6,'('' ?ubwchar -- input string too long.'')')
         go to 999
      endif
C
      call ubcflush(ichan)   ! flush compressed character output buffer
C
C  load the first byte with the code for uncompressed char:
C
#ifdef __CRAY
      ibyte = char(2)
#else
      ibyte=2
#endif
      ilbuf(1)=ibyte
C
C  preload buffer with the code for blanks.
#ifdef __CRAY
      ibyte = ' '
#else
      ibyte=ichar(' ')
#endif
      do i=1,ilblen-ioff
         ilbuf(i+ioff)=ibyte
      enddo
C
C  load the buffer from the passed string.  Suppress control characters
C  except for ^I (horizontal tab, code 9).  Suppress write of trailing
C  blanks
C
      ilenb=ioff+1
      do i=1,ilen
#ifdef __CRAY
         iz=ichar(zchar(i:i))
         if((iz.eq.9).or.(iz.gt.32)) then
            ilbuf(ioff+i)=zchar(i:i)
#else
         ibyte=ichar(zchar(i:i))
         if((ibyte.eq.9).or.(ibyte.gt.32)) then
            ilbuf(ioff+i)=ibyte
#endif
            ilenb=ioff+i
         endif
      enddo
C
C  transfer the buffer
C
      call ubi3ncod(ilenb-ioff,ilbuf,2)
      call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,ilenb)
C
      go to 1000
C
C  errors
C
 999  continue
      write(6,'('' ?UFLIB:  ubwchar low level i/o routine:  error.'')')
C
C  exit
C
 1000 continue
      return
      end

c-----------------------------------------------------------------------
c mds_addblanks
c replace null with trailing blanks in string
c
c 04/06/1999 ler
c-----------------------------------------------------------------------
      subroutine mds_addblanks(string)
      implicit none
 
      character*(*) string
      integer i, is, l
 
      l = len(string)
      is = index(string, char(0))
      if (is.ne.0) then
        do i=is,l
           string(i:i) = ' '
        end do
      end if
 
      end

      subroutine ufmtsel(iformat)
C
C  dmc 6 Nov 1997:
C
C  this routine prompts the user to select a Ufile output format.
C  the format code is suitable as use as argument to a UFCMPR call.
C
C  iformat = 0 -- ascii
C          = 2 -- portable loss free compressed binary
C          = 3 -- HDF
C          = 4 -- NetCDF
C
C  if the user quits out, iformat is returned *unchanged*
C  provided it came in with a legal value.
C
      logical lxout,lchar
C
      character*7 zfmt(0:4)
C
      data zfmt/'ascii','??????','binary','HDF','NetCDF'/
C------------------------------------------------
C
C  set default value -- depends on value coming in --
C
      if(iformat .eq. -1) then
         print*,'ufmtsel: can not change MDSplus'
         return
      endif
      if(iformat.lt.0) iformat=0
      if(iformat.gt.4) iformat=4
      if(iformat.eq.1) iformat=2
C
C  user options
C
 10   continue
      if(lxout(0)) then
         write(lnout(0),1001) zfmt(iformat)
 1001    format(/
     >' current Ufile output format:  ',a//
     >' format select options:'/
     >'  A -- Ascii'/
     >'  B -- Binary (loss-free, compressed, portable Ufile format)'/
     >'  C -- NetCDF'/
     >'  D -- HDF'/
     >'  Q -- quit without changing format setting.')
      endif
C
      call uread('ufmtsel:  enter format option A/B/C/D/Q:$')
      if(lchar('Q')) then
         return
      else if(lchar('A')) then
         iformat=0
      else if(lchar('B')) then
         iformat=2
      else if(lchar('C')) then
         iformat=4                      ! yes, 4 for NetCDF
      else if(lchar('D')) then
         iformat=3                      ! yes, 3 for HDF
      else
         call uermsg('unrecognized format code',' ',0)
         go to 10
      endif
C
      if(lxout(0)) write(lnout(0),1002) zfmt(iformat)
 1002 format(' %ufmtsel:  format set to:  ',a)
C
      return
      end

C******************** START FILE UACKNL.FOR ; GROUP UPAUST *************
C& UACKNL (UREAD/UPAUST) REQUEST USER ACKNOWLEDGEMENT AFTER ERROR
C
      SUBROUTINE UACKNL
C
C  REQUEST USER ACKNOWLEDGEMENT
C
      USE USERIO
C
      CHARACTER*1 ZDUM,ZBELL
C
C--------------------------------------
C
      ZBELL=char(7)
C
      IF(IBATCH.EQ.1) RETURN
      IF(NLJAVA) RETURN
C
      WRITE(LUNTRM,9001) ZBELL,ZBELL
 9001 FORMAT(1X,A1,'[USER ACKNOWLEDGE - HIT ANY KEY]',A1)
C
      CALL TERM_CHAR_IN(ZDUM)
C
      RETURN
      END
C******************** END FILE UACKNL.FOR ; GROUP UPAUST ***************

      subroutine trmds_parse(zbuf,mds_server,mds_tree,mds_id1,mds_id2,
     >   mds_tstr,ierr)
c
c  parse an MDS+ tree id string
c  of form
c
c     <server_name>:<tree_name>(<id1>[,<id2>][;t=<time_val>])
c
c  where
c
c      server_name -- is an MDSplus server path with possible port no.
c          examples:
c                     local
c                     birch
c                     birch.pppl.gov
c                     europa.pppl.gov:8501
c                     cmoda.psfc.mit.edu
c
c      tree_name -- an MDSplus tree name
c
c      id1,id2 -- if id2 is absent, id1 = MDSplus shot no.
c                 if id2 is present, id1 = (TRANSP) tok.yy code
c                                    id2 = (TRANSP) runid
c
c      time_val -- if ;t=<time_val> qualifier is present, time_val
c                                    is the time of interest, seconds.
c
      implicit NONE
c
c  input:
c
      character*(*) zbuf                ! string to parse
c
c  output:
c
      character*(*) mds_server          ! server
      character*(*) mds_tree            ! tree name
      character*(*) mds_id1             ! id1 -- shot# or tok.yy if id2 present
      character*(*) mds_id2             ! id2 -- runid (if present) or blank
      character*(*) mds_tstr            ! time_val-- time, seconds, if nonblank
c
      integer ierr                      ! completion code, 0=OK, else parse err
c
c-----------------------------------------------------------
      integer ilz,icln,ilparen,icomma,isemi,ieqs,i
      integer is1,is2,it1,it2,ia1,ia2
      integer str_length
      character*10 zwd
c-----------------------------------------------------------
c
      mds_server=' '
      mds_tree=' '
      mds_id1=' '
      mds_id2=' '
      mds_tstr=' '
c
c  find length, left parenthesis (must be present)
c
      ilz=str_length(zbuf)
      ilparen=index(zbuf,'(')
      if(ilparen.eq.0) then
         ierr=91
         return
      endif
c
c  find terminating right parenthesis (must be present)
c
      if(zbuf(ilz:ilz).ne.')') then
         ierr=99
         return
      endif
c
c  find right terminus of server string
c
      do i=ilparen,2,-1
         if(zbuf(i:i).eq.':') then
            icln=i
            go to 100
         endif
      enddo
c
c  no server string found
c
      ierr=92
      return
c
 100  continue
c
c  server name...
      call trmds_pshrink(zbuf,1,icln-1,is1,is2,ierr)
      if(ierr.ne.0) return
      mds_server=zbuf(is1:is2)
      call uupper(mds_server)
c
c  tree name...
      call trmds_pshrink(zbuf,icln+1,ilparen-1,it1,it2,ierr)
      if(ierr.ne.0) return
      mds_tree=zbuf(it1:it2)
      call uupper(mds_tree)
c
c  optional time-of-interest
c
      isemi=index(zbuf(ilparen:ilz),';')
      if(isemi.ne.0) then
         isemi=isemi+ilparen-1
         call trmds_pshrink(zbuf,isemi+1,ilz-1,it1,it2,ierr)
         if(ierr.ne.0) return
c
c  zbuf(it1:it2) contains non-blank string between ; and closing paren
c    this string must have form "t = <value>"
c
         ieqs=index(zbuf(it1:it2),'=')
         if(ieqs.eq.0) then
            ierr=93
            return
         endif
         ieqs=it1+ieqs-1
c
c  LHS
         call trmds_pshrink(zbuf,it1,ieqs-1,ia1,ia2,ierr)
         if(ierr.ne.0) return
         zwd=zbuf(ia1:ia2)
         call uupper(zwd)
         if((zwd.ne.'T').and.(zwd.ne.'TIME')) then
            ierr=94
            return
         endif
c
c  RHS
c
         call trmds_pshrink(zbuf,ieqs+1,it2,ia1,ia2,ierr)
         if(ierr.ne.0) return
c
         mds_tstr=zbuf(ia1:ia2)
         call uupper(mds_tstr)
c
         ilz=isemi
      endif
c
c  tree id args
c
      icomma=index(zbuf(ilparen:ilz),',')
      if(icomma.eq.0) then
         call trmds_pshrink(zbuf,ilparen+1,ilz-1,ia1,ia2,ierr)
         if(ierr.ne.0) return
         mds_id1=zbuf(ia1:ia2)
         call uupper(mds_id1)
      else
         icomma=ilparen+icomma-1
         call trmds_pshrink(zbuf,ilparen+1,icomma-1,ia1,ia2,ierr)
         if(ierr.ne.0) return
         mds_id1=zbuf(ia1:ia2)
         call uupper(mds_id1)
         call trmds_pshrink(zbuf,icomma+1,ilz-1,ia1,ia2,ierr)
         if(ierr.ne.0) return
         mds_id2=zbuf(ia1:ia2)
         call uupper(mds_id2)
      endif
c
      return
      end
c-----------------------------------------------
      subroutine trmds_pshrink(zbuf,ilim1,ilim2,iact1,iact2,ierr)
c
c  parsing primitive
c  ...find first and last non-blank in zbuf(ilim1:ilim2)
c  ...return ierr.eq.0 if successful
c  ...return ierr.eq.1 if ilim1.gt.ilim2 or ilim1.lt.1 or
c     ilim2.gt.len(zbuf)
c
c  ...non-blank range returned in iact1,iact2
c
      implicit NONE
c
      character*(*) zbuf
      integer ilim1,ilim2
      integer iact1,iact2
      integer ierr
c
c--------------------
c
      ierr=1
      if(ilim1.gt.ilim2) return
      if(ilim1.lt.1) return
      if(ilim2.gt.len(zbuf)) return
c
      if(zbuf(ilim1:ilim2).eq.' ') return
c
c  ok, valid range, non-blanks are present
c
      ierr=0
      do iact1=ilim1,ilim2
         if(zbuf(iact1:iact1).ne.' ') go to 10
      enddo
 10   continue
      do iact2=ilim2,ilim1,-1
         if(zbuf(iact2:iact2).ne.' ') go to 20
      enddo
 20   continue
c
      return
      end

subroutine sigvte_reco(te,n,sigv)
 
  use hatom_mod
  implicit NONE
 
  !  e-,H+ --> H0
  !  recombination <sigma*v>(Te)
  !  via table lookup
 
  integer, intent(in) :: n     ! vector size
  real*8, intent(in) :: te(n)  ! electron temperature(s)  KeV
 
  real*8, intent(out) :: sigv(n)  ! <sigma*v> value(s) returned  m**3/sec
 
  !-----------------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  call ei_sigvte_sigmatimesv(Lreco_H_e,te,sigv,n)
 
end subroutine sigvte_reco

subroutine frantic_gmat
  !  THIS ROUTINE WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
  !  PLASMA PHYSICS LAB.  THIS ROUTINE WILL CALCULATE THE CHARGE
  !  EXCHANGE RATE IN EACH ZONE DUE TO NEUTRALS BORN IN ALL ZONES
  !  AND FROM THE WALL BY INTEGRATING ALONG EACH TRAJECTORY AND
  !  SUMMING OVER ALL TRAJECTORIES.
  !-------------------------------
  !
  !  TBT Jun, 1991  Added NINLDX as the pointer to the lightest gas in
  !                 BACKZ for this source.
  !
  !-----------------------------
  !
  !   T.B. Terpstra - Adding INDEX because of mixed H and He plasma.
  !   May 20, 1991
  !
  !   D. MC CUNE THIS ROUTINE MODifIED TO INCLUDE FLUX(R)
  !  CALCULATION
  !   JUNE 3 1981
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, two
  use frantic_module
  implicit none
  !
  integer :: izmid,ik,idirw,ishfw,i,iza,izf,idir,ishf,j,izb
  real(fp) :: zx,frantic_zh3x,zdeltr,zx1,zdisti,ztaub,zx2
  real(fp) :: zh3x1,zh3x2,ztaua,zts1,ztauc,zts2
  real(fp), parameter :: zpid2 = 1.570796327_fp
  !
  IZMID=NZCROS(MID)
  ZDELTR=RBOUND(IZMID+1)-RBOUND(IZMID)
  !  I NOW TRACK FROM LEFT TO RIGHT AND CALCULATE THE WALL FLUX
  !  WHICH CHARGE EXCHANGES IN ZONE I AND THE FRACTION WHICH GETS
  !  TRANSMITTED TO THE RIGHT.
  !
  !  IDIR(W)=1 INDICATES INGOING PTCL, IDIR(W)=2 INDICATES
  !   OUTGOING PTCL.  D. MC CUNE 3 JUNE 1981
  !
  do IK=1,NNEUT
    !  INITIALIZE FLUX(R) DUE TO 1ST. GEN. NEUTS. CALCULATION
    IDIRW=1
    ISHFW=-1
    !  INCOMING FLUX FROM WALL
    if(ESFLAG) PRWFLX(NZONEC,IK,IDIRW)= &
         PRWFLX(NZONEC,IK,IDIRW)+ZPID2*ZDELTR
    !
    ZX1=ZERO
    do I=1,NBCROS
      IZA=NZCROS(I)
      ZDISTI=DIST(I)
      if(.NOT.ESFLAG) GO TO 10
      ZTAUB=BETAT(IZA,IK)*ZDISTI
      ZX2=ZX1+ZTAUB
      !	    if(X2.GT.87.5E00) GO TO 10  !CHECK
      ZH3X1=ZH3(ZX1)
      ZH3X2=ZH3(ZX2)
      !CC  S0COLD(IZA,1,   IK)=S0COLD(IZA,1,   IK)+
      S0COLD(IZA,NINLDX,IK)=S0COLD(IZA,NINLDX,IK)+ &  ! TBT 5/20/91
           (ZH3X1-ZH3X2)*ZDELTR
      ZX1=ZX2
      !  CHECK FOR SWITCH FROM IN- TO OUT-GOING FLUX (WALL NEUTS ONLY)
      if(I.NE.MID) GO TO 5
      IDIRW=2
      ISHFW=0
5     continue
      !
      !  WALL NEUTS CONTRIBUTION TO FLUX(J)
      IZF=IZA+ISHFW
      PRWFLX(IZF,IK,IDIRW)=PRWFLX(IZF,IK,IDIRW)+ZH3X2*ZDELTR
      !
10    continue
      if(.NOT.MCFLAG) GO TO 40
      !  THE ATTENUATION IN ZONE IZA DUE TO ATOMS BORN IN THE
      !  SAME ZONE IS NOW FOUND.
      ZTAUA=ZDISTI*ALPHAT(IZA,IZA,IK)
      ZTS1=ZPID2-ZH3(ZTAUA)
      !CC GFUN(IZA,IZA,1,IK)= &
      !CC    GFUN(IZA,IZA,1,IK)+(2.0*ZTAUA-ZTS1)*ZDELTR
      GFUN(IZA,IZA,NINLDX,IK)= &
           GFUN(IZA,IZA,NINLDX,IK)+(TWO*ZTAUA-ZTS1)*ZDELTR   ! TBT 5/91
      if(I.EQ.NBCROS) GO TO 30
      !  THE ATTENUATION IN EACH ZONE IZB, TO THE RIGHT OF ZONE
      !  IZA, DUE TO ATOMS BORN IN ZONE IZA AND THE FRACTION TRANSMITTED
      !  TO THE NEXT ZONE IS NOW CALCULATED.
      ZTAUC=ZERO
      !  INITIALIZE FLUX CALCULATION FOR THIS PART OF TRAJECTORY
      IDIR=1
      ISHF=-1
      if(I.LT.MID) GO TO 15
      IDIR=2
      ISHF=0
15    continue
      IZF=IZA+ISHF
      PRFLUX(IZA,IZF,IK,IDIR)=PRFLUX(IZA,IZF,IK,IDIR)+ZTS1*ZDELTR
      !
      do J=I+1,NBCROS
        IZB=NZCROS(J)
        ZTAUC=ZTAUC+DIST(J)*ALPHAT(IZB,IZA,IK)
        ZTS2=ZH3(ZTAUC)-ZH3(ZTAUC+ZTAUA)
        !CCC GFUN(IZB,IZA,1,   IK)=GFUN(IZB,IZA,1,   IK)+
        GFUN(IZB,IZA,NINLDX,IK)=GFUN(IZB,IZA,NINLDX,IK)+ &   ! TBT 5/91
             (ZTS1-ZTS2)*ZDELTR
        ZTS1=ZTS2
        !  FLUX(R) CALCULATION
        if(J.NE.MID) GO TO 25
        IDIR=2
        ISHF=0
25      continue
        if(J.EQ.NBCROS) GO TO 20
        IZF=IZB+ISHF
        PRFLUX(IZA,IZF,IK,IDIR)=PRFLUX(IZA,IZF,IK,IDIR)+ &
             ZTS1*ZDELTR
20      continue
      end do
      !  ATOMS BORN IN IZA WHICH GET ALL THE WAY TO THE WALL.
30    WALL(IZA,IK)=WALL(IZA,IK)+ZTS1*ZDELTR
      PRFLUX(IZA,NZONEC,IK,2)=PRFLUX(IZA,NZONEC,IK,2)+ &
           ZTS1*ZDELTR
40    continue
    end do
    if(ESFLAG) WWALL(IK)=WWALL(IK)+ZH3X2*ZDELTR
  end do
  return

  contains

    ! DEFINE THE H3 FUNCTION
    real(fp) function zh3(zx)
      real(fp), intent(in) :: zx
      real(fp), external :: frantic_zh3x
      zh3 = frantic_zh3x(zx)
      return
    end function zh3

end subroutine frantic_gmat

subroutine frantic_editr
  !
  !  THIS ROUTINE WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
  !  PLASMA PHYSICS LAB.  THIS ROUTINE WILL CONSTRUCT THE OUTPUT
  !  RESULTS OF DNEUT, TNEUT, EDEP, RdoT AND SPECTRUM.
  !
  !  Mod TBT 5/1/91 added NINLDX as index to lowest atomic #.
  !  MOD DMC AUG85 FOR TRANSP ROTATION BAL. CALCULATION
  
  !-------------------------------
  !
  !  TBT Jun, 1991  Added NINLDX as the pointer to the lightest gas in
  !                 BACKZ for this source.
  !
  !-----------------------------
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one
  use frantic_module
  implicit none
  real(fp), parameter :: CEPS30 = 1.0e-30_fp
  integer :: ik,innk,i,inl,ilp1,j
  real(fp) :: ztska,zvwall,zsum2,zsum3,zsum4,zvneut,zgf,zts2
  real(fp) :: zts4,ztotln
  real(fp), parameter :: zcon2 = 2.8945365e15_fp
  !
  !  CON2 = 3*C*C/(KEV/AMU)


  ! I NOW LOOP OVER ALL ORGINAL NEUTRAL SPECIES.
  do IK=1,NNEUT
    INNK=NSPEC(IK)
    ZTSKA=APLAS(INNK)
    ! I NOW FIND THE WALL VELOCITY FOR THIS SPECIES.
    ZVWALL=SQRT(ZCON2*TWALL(IK)/ZTSKA)
    ! I NOW LOOP OVER ALL ZONES
    do I=1,NZONEC
      ! I NOW LOOP OVER ALL CHARGED PARTICLES WHICH COULD
      ! RESULT IN AN INTERACTION.
      if(ESFLAG) then
        !CC TBT	 DCOLD(I,IK)=S0COLD(I,1,IK)/(BETAX(I,1,IK)*ZVWALL)
        DCOLD(I,IK)=S0COLD(I,NINLDX,IK)/ &
             (BETAX(I,NINLDX,IK)*ZVWALL)
        if(ABS(DCOLD(I,IK)).LT.EPSLON) DCOLD(I,IK)=ZERO
      end if
      ! INL=1
      INL= NINLDX      ! TBT  5/1/91
      ILP1=NSPEC(INL)
      ZSUM2=ZERO
      ZSUM3=ZERO
      !AUG86
      ZSUM4=ZERO
      !
      !-----------------
      !  I NOW LOOP OVER ALL BIRTH ZONES
      do J=1,NZONEC
        ZVNEUT=SQRT(ZCON2*TEMP(J,INNK)/ZTSKA)
        ! I NOW FIND THE SOURCE RATE
        ZGF=-GFUN(I,J,INL,IK)
        if(J.EQ.I.AND.INL.EQ.IK) ZGF=ZGF+ONE
        !  TS2 CONTAINS THE SOURCE RATE OF NEUTRALS NL IN ZONE I
        !  DUE TO NEUTRALS OF TYPE K BORN IN ZONE J CHARGE EXCHANGING
        !  ON CHARGED PARTICLE L.
        ZTS2=ZGF*TSTOR1(J,IK)
        !  TS4 IS THE NUMBER OF MULTI-GENERATION NEUTRALS IN ZONE I DUE
        !  TO NEUTRAL K BORN IN ZONE J INTERACTING WITH CHARGED PARTICLE
        !  L.
        ZTS4=ZTS2/(ALPHAX(I,J,INL,IK)*ZVNEUT)
        ZSUM2=ZSUM2+ZTS4
        ZSUM3=ZSUM3+ZTS4*TEMP(J,ILP1)
        ZSUM4=ZSUM4+ZTS4*VPHIZ(J,ILP1)
      end do
      !-----------------
      DNEUT(I,IK)=ZSUM2
      TNEUT(I,IK)=ZSUM3
      !AUG86
      VPHI0F(I,IK)=ZSUM4
    end do
    !-----------------
  end do
  !-----------------
  if(.NOT.ESFLAG) GO TO 60
  !
  !-----------------
  do IK=1,NNEUT
    do I=1,NZONEC
      ZTOTLN=DNEUT(I,IK)+DCOLD(I,IK)
      if(ZTOTLN.LT.CEPS30) GO TO 40
      TNEUT(I,IK)=(TNEUT(I,IK)+DCOLD(I,IK)*TWALL(IK))/ZTOTLN
      !AUG86
      VPHI0F(I,IK)=(VPHI0F(I,IK)+DCOLD(I,IK)*vphi_wall(ik))/ZTOTLN
40    continue
    end do
  end do
  GO TO 90
  !
  !-----------------
60 continue
  do IK=1,NNEUT
    do I=1,NZONEC
      TNEUT(I,IK)=TNEUT(I,IK)/DNEUT(I,IK)
      !AUG86
      VPHI0F(I,IK)=VPHI0F(I,IK)/DNEUT(I,IK)
    end do
  end do
  !
  !-----------------
90 return
end subroutine frantic_editr

!
!  real*8 interface -- thermonuclear fusion
!
!  collection of functions for evaluating fusion reaction rate coefficients
!  <<sigma*v>> from pretabulated data
!
!  for all functions:  input plasma temperature, KeV
!  receive <<sigma*v>>, m**3/sec
!
!  DD rate is then nd*nd*<<sigma*v>>DDn
!  DT rate is then nd*nt*<<sigma*v>>DT
!
subroutine fusn_thermo_DDp(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_DDp, tplasma, answer, n)
 
end subroutine fusn_thermo_DDp
!
subroutine fusn_thermo_DDn(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
  call fs_thermonuclear_sigmatimesv(Lfs_DDn, tplasma, answer, n)
end subroutine fusn_thermo_DDn
!
subroutine fusn_thermo_DT(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_DT, tplasma, answer, n)
 
end subroutine fusn_thermo_DT
!
subroutine fusn_thermo_TD(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_TD, tplasma, answer, n)
 
end subroutine fusn_thermo_TD
!
subroutine fusn_thermo_TT(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_TT, tplasma, answer, n)
 
end subroutine fusn_thermo_TT
!
subroutine fusn_thermo_dpcTT(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_dpcTT, tplasma, answer, n)
 
end subroutine fusn_thermo_dpcTT
!
subroutine fusn_thermo_D3(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_D3, tplasma, answer, n)
 
end subroutine fusn_thermo_D3
!
subroutine fusn_thermo_3D(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_3D, tplasma, answer, n)
 
end subroutine fusn_thermo_3D
!
subroutine fusn_thermo_T3(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_T3, tplasma, answer, n)
 
end subroutine fusn_thermo_T3
!
subroutine fusn_thermo_3T(tplasma,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: tplasma(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_thermonuclear_sigmatimesv(Lfs_3T, tplasma, answer, n)
 
end subroutine fusn_thermo_3T

 
 
      subroutine ufascio(lun,f,n,code,iend,ierr)
 
 
 
C 08/22/94  TBT  Put in internal read to buffer to decide input format.
C                Some lines have a blank in the first position (1st line)
C                others have no blank.
 
C  portable 1PE13.6 decode routine -- 6 fp#s per line
C
C   -- experience has shown that format statement loops that span
C      multiple lines work differently on different machines; to
C      avoid this portability problem UFLIB uses this routine, based
C      on line by line decoding
C
C  arguments:
      integer lun             ! fortran i/o unit number
      real f(n)               ! data to read or write
      character*1 code        ! "W" to write, "R" to read
      integer iend            ! set to 1 if EOF occurs on read
      integer ierr            ! set to 1 if i/o error occurs
C
      Character*80 Zbuffer
C---------------------------------
C
C
      iend=0
      ierr=0
C
      ilines=(n-1)/6 + 1
      do il=1,ilines
         iadr1=(il-1)*6 + 1
         iadr2=min(n,(iadr1+5))
         if(code.eq.'W') then
            write(lun,3009) (f(iadr),iadr=iadr1,iadr2)
         else
            read(lun,3001,end=8000,err=9000) Zbuffer
 
          Ir=0
          Do 50 Ia=1,80
C              Find first period (.)
               If (Zbuffer(Ia:Ia) .eq. '.') Then
                  Ir=Ia
      	  Go to 51
               End If
   50       Continue
   51       Continue
 
            If (Ir .Eq. 4) Then
C              Decimal point in column 4 - leading blank.
               read(Zbuffer,3009,end=8000,err=9000)
     1             (f(iadr),iadr=iadr1,iadr2)
            Else If (Ir .Eq. 3) Then
C              Decimal point in column 3
               read(Zbuffer,3010,end=8000,err=9000)
     1             (f(iadr),iadr=iadr1,iadr2)
            Else
C              .Unrecognized Format
               Go to 9000
            End If
 
         endif
      enddo
C
 3001 Format(A80)
 3009 format(1x,6(1pe13.6))    ! Old First line in data read
 3010 Format(   6(1pe13.6))    ! Subsequent lines in data read
C
      return
C
 8000 continue
      iend=1
      return
C
 9000 continue
      ierr=1
      return
C
      end

C******************** START FILE UAHEAD.FOR ; GROUP URDUTS ******************
C-------------------------------
C& UAHEAD  ENABLE UREAD TYPEAHEAD
C  SET "TYPE-AHEAD"
C
      SUBROUTINE UAHEAD
      USE USERIO
C
      NLHOLD=.FALSE.
      RETURN
      END
C******************** END FILE UAHEAD.FOR ; GROUP URDUTS ******************

!====================
!
!  09/28/94  TBT  Added capabilities for Li to HE and H.
!
!  D. MC CUNE 2 JUNE 1981
!    THIS VERSION OF FRANTIC FOR USE WITH TRANSP *****
!
!  DMC OCT 1988 -- USE TRANSP STANDARD SIGMA*V ROUTINES
!
!    FRANTIC IS 2 SPECIES GENERALIZED FAST NEUTRAL TRANSPORT
!  ALGORITHM BASED ON 1 SPECIES ALGORITHM BY S. TAMOR, GENERALIZED
!  BY HH TOWNER AT PPPL.
!    CONVERTED FOR USE WITH TRANSP BY D. MC CUNE.
!    (1)  VARIABLE NAMES OLYMPUSIZED:  ALL LOCAL VARIABLES BEGIN
!    WITH Z (REAL) OR I OR J (integer).
!    (2)  NEUTRAL ESCAPE COEFFICIENTS AND AVG ESCAPING NEUTRALS'
!         ENERGIES ARE DEFINED IN TRANSP COMMON ARRAYS
!         OUTFLX(JG,NSRC), EESCAV(JG,NSRC); JG=NEUTRAL HYDROGENIC
!         SPECIES, NSRC= NEUTRAL SOURCE NUMBER.
!      >>THE CALCULATION IS VALID ONLY if MODELING
!         ONE SPECIES AND TYPE OF NEUTRAL SOURCE
!         AT A TIME, AND EDGE OR VOLUME BUT NOT BOTH TYPE
!         SOURCES SIMULTANEOUSLY.  THIS RESTRICTION APPLIES
!         FOR RENORMALIZATION OF OUTFLX, EESCAV, AND RADIAL
!         IN/OUT FLUX ARRAYS TO BE VALID ********
!=======================================
! SO >> USE THIS VERSION WITH [TRANSP]SORCE1.FOR AS CALLING ROUTINE
!=======================================
!    (3)  THE PTCL OUTFLUX CALCULATION IS GENERALIZED TO ALLOW
!         CALCULATION OF NEUTRAL PTCL AND ENERGY IN/OUT FLUXES
!         AT ALL RADIAL ZONE BOUNDARIES.  THE CORRESPONDING
!         FRANTIC-INTERNAL PROBABILITY ARRAYS ARE PRWFLX(J,IK,IDIR)
!         WHICH INDICATES THE PROBABILITY THAT A SPECIES IK WALL
!         NEUTRAL CONTRIBUTES TO THE FLUX BETWEEN ZONES J,J+1 IN
!         DIRECTION IDIR=1:INFLUX, OR IDIR=2:OUTFLUX
!            AND PRFLUX(I,J,IK,IDIR) INDICATES THE PROBABILITY
!         THAT A NEUTRAL SPECIE IK BORN IN ZONE I WILL CONTRIBUTE
!         TO THE DIRECTION IDIR NEUTRAL FLUX AT THE BDY. BETWEEN
!         ZONES J AND J+1, IDIR AS WITH PRWFLX ARRAY.
!            FROM THESE QUANTITIES THE TRANSP DIVERGENCE-OF IN/OUT
!         PTCL/ENERGY NEUTRAL FLUX ARRAYS SFLX0M,PFLX0M(IDIR,J,NSRC)
!         ARE CALCULATED; NOTE THESE ARE SUMMED OVER ALL NEUTRAL
!         SPECIES.
!                      ... D. MC CUNE 2 JUNE 1981
!
!
subroutine frantic_alpha
  !
  !  AUG 1986 - MOD DMC
  !  INCLUDE DifFERENCE IN ROTATION VELOCITY AS PART OF INTERACTION
  !  ENERGY FOR COLLISIONS-- FOR ROTATION SUPPORTING VSN OF FRANTIC
  !
  !  THIS subroutine WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
  !  PLASMA PHYSICS LAB.  THIS ROUTINE WILL CALCULATE THE FOLLOWING:
  !  ALPHAX(I,J,NL,K) - CHARGE EXCHANGE ABSORPTION COEFFICIENT IN ZONE I
  !                  FOR HYDROGENIC NEUTRAL SPECIE K BORN IN ZONE J
  !		   CREATING HYDROGENIC NEUTRAL SPECIES NL IN
  !		   ZONE I.
  !  ALPHAT(I,J,K) - TOTAL ABSORPTION COEFFICIENT IN ZONE I FOR
  !                  HYDROGENIC NEUTRAL SPECIE K BORN IN ZONE J
  !		   INTERACTING WITH ALL CHARGED SPECIES IN ZONE I.
  !  BETAX(I,NL,K)    - CHARGE EXCHANGE ABSORPTION COEFFICIENT IN ZONE I
  !                  FOR HYDROGENIC NEUTRAL SPECIES K BORN AT THE WALL
  !                  CREATING HYDROGENIC NEUTRAL SPECIES NL IN
  !                  ZONE I.
  !  BETAT(I,K)    - TOTAL ABSORPTION COEFFICIENT IN ZONE I FOR
  !                  HYDROGENIC NEUTRAL SPECIE K BORN AT THE WALL
  !		   INTERACTING WITH ALL CHARGED SPECIES IN ZONE I.
  !
  !
  use iso_c_binding, only: fp => c_double
  use fpreact_parameters
  use frantic_module
  use adas_mod, only : adas_zstop_sigvz, adas_sigv, &
       adas_sigvte_ioniz
  implicit none
  real(fp), parameter :: C10TH = 0.1_fp
  real(fp), parameter :: C20TH = 0.05_fp
  real(fp), parameter :: C3OV2 = 1.5_fp
  !
  integer :: ik,izneut,i,ink,il,ilm1,izplas,j,inl,ierr
  real(fp) :: zdsvel,ztskz,ztska,zewall,zvwall,ztsla
  real(fp) :: ztslz,zeborn,zecl,zvborn,zvphij,zvphil,zerelw
  real(fp), dimension(:), allocatable :: zeova
  real(fp), dimension(:,:), allocatable :: z_erel,zsigv,zsigv_cx
  real(fp) :: ztswbi,ztswbx,zec,zvphii,zdvphi
  real(fp) :: ztsmbi,ztsmbx,zvphi_wall
  logical :: il_li ! .true. if Li is a neutral

  !============
  !xxx      DIMENSION ZDSVEL(MJ,MIG)
  !
  !xxx      EQUIVALENCE (ZDSVEL(1,1),TSTOR1(1,1))
  !
  real(fp), parameter :: zcon1 = 1.929691e15_fp

  !  CON1= 2*C*C/(KEV/AMU)
  !
  !  I NOW FILL TEMPORARY STORAGE ARRAY TSTOR1 WITH DENE*<SIGMA*V>EL
  !  AT ALL ZONE LOCATIONS.
  if(allocated(zeova)) deallocate(zeova)
  allocate(zeova(nzonec))
  zeova=0.0_fp

  if(MCFLAG) then

    if(allocated(zsigv)) deallocate(zsigv)
    allocate(zsigv(nzonec,nzonec))
    zsigv=0.0_fp

    if(allocated(zsigv_cx)) deallocate(zsigv_cx)
    allocate(zsigv_cx(nzonec,nzonec))
    zsigv_cx=0.0_fp

    if(allocated(z_erel)) deallocate(z_erel)
    allocate(z_erel(nzonec,nzonec))
    z_erel=0.0_fp
  else
    if(allocated(zsigv)) deallocate(zsigv)
    allocate(zsigv(1,nzonec))
    zsigv=0.0_fp

    if(allocated(zsigv_cx)) deallocate(zsigv_cx)
    allocate(zsigv_cx(1,nzonec))
    zsigv_cx=0.0_fp

  end if

  do IK=1,NNEUT
    ZTSKZ=XZPLAS(NSPEC(IK))
    izneut=ztskz+C20TH
    if((FRANTIC_ATOMIC.eq.1).or.(FRANTIC_ATOMIC.eq.3)) then !PREACT ground state atomic physics
      call sigvte_ioniz(izneut,temp(1:NZONEC,1),NZONEC, &
           zsigv(1,1:nzonec))
    elseif((FRANTIC_ATOMIC.eq.2).or.(FRANTIC_ATOMIC.eq.4)) then
      call adas_sigvte_ioniz(izneut,temp(1:NZONEC,1),NZONEC, &
           zsigv(1,1:nzonec),ierr)
    end if
    TSTOR1(1:NZONEC,IK)=DEN(1:NZONEC,1)*1.0e6_fp* &
         zsigv(1,1:NZONEC)
  end do

  !
  !  I NOW LOOP OVER THE DIFFERENT NEUTRAL SPECIES.
  do IK=1,NNEUT
    !  I NOW DEFINE THE MASS, Z, AND WALL VELOCITY FOR THIS NEUTRAL SPECIES.
    INK=NSPEC(IK)
    ZTSKA=APLAS(INK)
    ZTSKZ=XZPLAS(INK)
    izneut=ztskz+C10TH
    !  CHECK TO SEE if NEUTRAL IS HYDROGEN OR HELIUM  or Lithium
    il_li=.false.
    if(izneut.gt.3) go to 90
    if((izneut.eq.3).and.((frantic_atomic.eq.2).or. &
         (frantic_atomic.eq.4)))then
      !     ADAS atomic physics does not support Li
      WRITE(LUN6,101) IK
101   FORMAT(T2, &
           ' !FRANTIC_ALPHA: ADAS dataset does not support Li', &
           ' NEUTRAL SPECIES ',I2, &
           ' IS NOT AN ISOTOPE OF HYDROGEN OR HELIUM.', &
           ' PREACT WILL BE USED FOR Li')
      il_li=.true.
    end if
    ZEWALL=C3OV2*TWALL(IK)
    ZVWALL=SQRT(ZCON1*ZEWALL/ZTSKA)
    zvphi_wall=vphi_wall(ik)
    !  I NOW LOOP OVER ALL SPECIES WHICH THIS NEUTRAL CAN INTERACT WITH.
    do IL=2,NPLAS
      ILM1=IL-1
      ZTSLA=APLAS(IL)
      ZTSLZ=XZPLAS(IL)
      izplas=ztslz+C10TH
      !  I NOW LOOP OVER THE BIRTH ZONES OF THE MULTI-GENERATION NEUTRALS.
      !  NOTE THAT THIS SAME LOOP WILL BE USED AS DEATH ZONES FOR WALL
      !  NEUTRALS.
      do J=1,NZONEC
        !  I NOW FIND THE ENERGY AND VELOCITY OF THE BIRTH NEUTRAL.
        ZEBORN=C3OV2*TEMP(J,INK)
        ZECL=C3OV2*TEMP(J,IL)
        ZVBORN=SQRT(ZCON1*ZEBORN/ZTSKA)
        !AUG86  ROTATION VELOCITY OF NEUTRAL SPECIE K, ZONE J
        ZVPHIJ=VPHIZ(J,INK)
        !  I NOW FIND THE CREATED NEUTRAL'S INDEX.
        INL=LISPEC(ILM1)
        if(.NOT.ESFLAG) GO TO 30
        !  I NOW FIND THE RELATIVE ENERGY AND VELOCITY BETWEEN A WALL NEUTRAL
        !  OF SPECIES K AND AN ION OF SPECIE L AT LOCATION J.
        !AUG86  INCLUDE ROTATION IN REL. ENERGY
        ZVPHIL=VPHIZ(J,IL)
        if(lzpflag.and.(izplas.gt.3)) then
          ZTSLA=aimpj(j)           ! dmc Nov 2002: A(r) profiles
        end if
        zdvphi=zvphil-zvphi_wall
        ZERELW=ZEWALL+ZTSKA*ZECL/ZTSLA+ZTSKA*ZdVPHI**2/ZCON1
        !  I NOW FIND (SIGMA)LOSS AND (SIGMA)CX FOR THE WALL NEUTRAL
        !  INTERACTING AT ZONE J
        zeova(j)=ZERELW/ZTSKA
30      if(.NOT.MCFLAG) GO TO 60
        do I=1,NZONEC
          !  I NOW FIND THE ENERGY OF THE ION IN THIS ZONE AND CALCULATE
          !  THE RELATIVE ENERGY AND VELOCITY BETWEEN THIS ION AND THE
          !  NEUTRAL FROM ZONE J.
          ZEC=C3OV2*TEMP(I,IL)
          !AUG86 INCLUDE ROTATION
          ZVPHII=VPHIZ(I,IL)
          ZDVPHI=ZVPHII-ZVPHIJ
          if(lzpflag.and.(izplas.gt.3)) then
            ZTSLA=aimpj(i)         ! dmc Nov 2002: A(r) profiles
          end if
          !  I NOW FIND (SIGMA)LOSS AND (SIGMA)CX FOR THE NEUTRAL
          !  BORN IN ZONE J INTERACTING WITH THE IONS IN ZONE I.
          z_erel(j,i)=(ZEBORN+ZTSKA*ZEC/ZTSLA+ZTSKA*ZDVPHI**2/ZCON1) &
               /ZTSKA
50        continue
        end do
60      continue
      end do

      if(.NOT.ESFLAG) GO TO 31

      if(izplas.le.3) then
        if((FRANTIC_ATOMIC.eq.1).or.(FRANTIC_ATOMIC.eq.3).or.il_li) &
             then          !PREACT ground state atomic physics
          call hatom_sigv(fpreact_CX,zeova,nzonec,izneut,izplas, &
               zsigv_cx(1,1:nzonec),ierr)
          call hatom_sigv(fpreact_II,zeova,nzonec,izneut,izplas, &
               zsigv(1,1:nzonec),ierr)

        elseif((FRANTIC_ATOMIC.eq.2.and..not.il_li).or. &
             (FRANTIC_ATOMIC.eq.4.and..not.il_li)) then !ADAS ground state atomic physics

          call adas_sigv(fpreact_CX,zeova,nzonec,izneut,izplas, &
               zsigv_cx(1,1:nzonec),ierr)
          if(ierr.eq.10) then
            write(LUN6,*) &
                 ' ?FRANTIC_ALPHA: ADAS data is requested but not found'

            call frantic_dealloc
            call bad_exit
          end if
          call adas_sigv(fpreact_II,zeova,nzonec,izneut,izplas, &
               zsigv(1,1:nzonec),ierr)

          if(ierr.eq.10) then
            write(LUN6,*) &
                 ' ?FRANTIC_ALPHA: ADAS data is requested but not found'

            call frantic_dealloc
            call bad_exit
          end if
        end if
        zsigv(1,1:nzonec)=zsigv_cx(1,1:nzonec)+zsigv(1,1:nzonec)
      else
        if(lzpflag) then
          do j=1,nzonec
            ztslz=xzimpj(j)
            if((FRANTIC_ATOMIC.eq.1).or.(FRANTIC_ATOMIC.eq.4).or.il_li) &
                 then    !PREACT impurity stopping rates
              call zstop_sigvz(izneut,ztslz, &
                   zeova(j),1,zsigv(1,j))
            elseif((FRANTIC_ATOMIC.eq.2.and..not.il_li).or. &
                 (FRANTIC_ATOMIC.eq.3.and..not.il_li)) then
              call adas_zstop_sigvz(izneut,ztslz, &
                   zeova(j:j),1,zsigv(1,j:j),ierr)
              if(ierr.eq.10) then
                write(LUN6,*) &
                     ' ?FRANTIC_ALPHA: ADAS data is requested but not found'

                call frantic_dealloc
                call bad_exit
              end if
            end if
          end do
        else
          if((FRANTIC_ATOMIC.eq.1).or.(FRANTIC_ATOMIC.eq.4).or. &
               il_li) then !PREACT impurity stopping rates
            call zstop_sigvz(izneut,ztslz, &
                 zeova,nzonec,zsigv(1,1:nzonec))
          elseif((FRANTIC_ATOMIC.eq.2.and..not.il_li).or. &
               (FRANTIC_ATOMIC.eq.3.and..not.il_li)) then
            call adas_zstop_sigvz(izneut,ztslz, &
                 zeova,nzonec,zsigv(1,1:nzonec),ierr)
            if(ierr.eq.10) then
              write(LUN6,*) &
                   ' ?FRANTIC_ALPHA: ADAS data is requested but not found'

              call frantic_dealloc
              call bad_exit
            end if
          end if
        end if
      end if
      if(izplas.gt.3) go to 20
      !  WE CAN CHARGE EXCHANGE OFF A HYDROGEN OR HELIUM SPECIE.
      !  I NOW CHECK if THIS IS AN ALLOWED NEUTRAL.
      if(INL.EQ.0) GO TO 20
      BETAX(1:nzonec,INL,IK)=DEN(1:nzonec,il)*1.0e6_fp* &
           zsigv_cx(1,1:nzonec)/ZVWALL
20    if(IL.EQ.2) then
        BETAT(1:NZONEC,IK)=(TSTOR1(1:NZONEC,IK)+BII(1:NZONEC,IK)+ &
             BCX(1:NZONEC,IK))/ZVWALL
      end if
      BETAT(1:NZONEC,IK)=DEN(1:NZONEC,il)*1.0e6_fp* &
           zsigv(1,1:NZONEC)/ZVWALL+BETAT(1:NZONEC,IK)
      !     I NOW LOOP OVER ALL INTERACTION ZONES.
31    if(MCFLAG) then
        do j=1,nzonec
          if(izplas.le.3) then
            if((FRANTIC_ATOMIC.eq.1).or.(FRANTIC_ATOMIC.eq.3) &
                 .or.il_li) &
                 then    !PREACT ground state atomic physics
              call hatom_sigv(fpreact_CX,z_erel(j,1:NZONEC), &
                   nzonec,izneut,izplas,zsigv_cx(j,1:NZONEC), &
                   ierr)
              call hatom_sigv(fpreact_II,z_erel(j,1:NZONEC), &
                   nzonec,izneut,izplas,zsigv(j,1:NZONEC),ierr)
            elseif((FRANTIC_ATOMIC.eq.2.and..not.il_li).or. &
                 (FRANTIC_ATOMIC.eq.4.and..not.il_li) &
                 )then !ADAS ground state atomic physics
              call adas_sigv(fpreact_CX,z_erel(j,1:NZONEC), &
                   nzonec,izneut,izplas,zsigv_cx(j,1:NZONEC),ierr)

              if(ierr.eq.10) then
                write(LUN6,*) &
                     ' ?FRANTIC_ALPHA: ADAS data is requested but not found'
                call frantic_dealloc
                call bad_exit
              end if
              call adas_sigv(fpreact_II,z_erel(j,1:NZONEC), &
                   nzonec,izneut,izplas,zsigv(j,1:NZONEC),ierr)

              if(ierr.eq.10) then
                write(LUN6,*) &
                     ' ?FRANTIC_ALPHA: ADAS data is requested but not found'

                call frantic_dealloc
                call bad_exit
              end if
            end if
            zsigv(j,1:NZONEC)=zsigv_cx(j,1:NZONEC)+zsigv(j,1:NZONEC)
          else
            if(lzpflag)then
              do i=1,nzonec
                ztslz=xzimpj(i)
                if((FRANTIC_ATOMIC.eq.1).or.(FRANTIC_ATOMIC.eq. &
                     4).or.il_li) then !PREACT impurity stopping rates
                  call zstop_sigvz(izneut,ztslz, &
                       z_erel(j,I),1,zsigv(j,I))
                elseif((FRANTIC_ATOMIC.eq.2.and..not.il_li).or. &
                     (FRANTIC_ATOMIC.eq.3.and..not.il_li)) then
                  call adas_zstop_sigvz(izneut,ztslz, &
                       z_erel(j,I:I),1,zsigv(j,I:I),ierr)
                  if(ierr.eq.10) then
                    write(LUN6,*) &
                         ' ?FRANTIC_ALPHA: ADAS data is requested but not found'
                    call frantic_dealloc
                    call bad_exit
                  end if
                end if
              end do
            else
              if((FRANTIC_ATOMIC.eq.1).or.(FRANTIC_ATOMIC.eq.4).or.il_li) &
                   then !PREACT impurity stopping rates
                call zstop_sigvz(izneut,ztslz, &
                     z_erel(j,1:NZONEC),nzonec, &
                     zsigv(j,1:NZONEC))
              elseif((FRANTIC_ATOMIC.eq.2.and..not.il_li).or. &
                   (FRANTIC_ATOMIC.eq.3.and..not.il_li))then
                call adas_zstop_sigvz(izneut,ztslz, &
                     z_erel(j,1:NZONEC),nzonec, &
                     zsigv(j,1:NZONEC),ierr)
                if(ierr.eq.10) then
                  write(LUN6,*) &
                       ' ?FRANTIC_ALPHA: ADAS data is requested but not found'
                  call frantic_dealloc
                  call bad_exit
                end if
              end if
            end if
          end if
          if(izplas.gt.3) go to 40
          !  WE CAN CHARGE EXCHANGE OFF OF HYDROGEN OR HELIUM.
          if(INL.EQ.0) GO TO 40
          ALPHAX(1:NZONEC,J,INL,IK)=DEN(1:NZONEC,IL)*1.0e6_fp* &
               zsigv_cx(j,1:NZONEC)/ &
               SQRT(ZCON1*C3OV2*TEMP(J,INK)/ZTSKA)
40        if(IL.EQ.2) then
            ALPHAT(1:NZONEC,J,IK)=(TSTOR1(1:NZONEC,IK)+ &
                 BII(1:NZONEC,IK)+BCX(1:NZONEC,IK))/ &
                 SQRT(ZCON1*C3OV2*TEMP(J,INK)/ZTSKA)
          end if
          ALPHAT(1:NZONEC,J,IK)=DEN(1:NZONEC,il)*1.0e6_fp* &
               zsigv(j,1:NZONEC)/ &
               SQRT(ZCON1*C3OV2*TEMP(J,INK)/ZTSKA) &
               +ALPHAT(1:NZONEC,J,IK)
        end do
      end if

    end do
  end do

  call frantic_dealloc
  return
  !----------------------------------------------------------------------
90 WRITE(LUN6,100) IK
100 FORMAT(T2, &
       'NEUTRAL SPECIES ',I2,' IS NOT AN ISOTOPE OF HYDROGEN OR HELIUM', &
       ' or Lithium' )

  call frantic_dealloc
  CALL BAD_EXIT

contains

  subroutine frantic_dealloc
    if(allocated(zeova)) deallocate(zeova)
    if(allocated(z_erel)) deallocate(z_erel)
    if(allocated(zsigv)) deallocate(zsigv)
    if(allocated(zsigv_cx)) deallocate(zsigv_cx)
    return
  end subroutine frantic_dealloc

end subroutine frantic_alpha

C******************** START FILE UFOPRD.FOR ; GROUP UFILES *************
C------------------------------------------------------------
C  UFOPRD
C  OPEN FILE FOR READ
C   ARGUMENTS-- ILUN-- FILE LOGICAL UNIT NUMBER
C     for netcdf file ilun will be changed and coresponds to file ID
C     ISHOT-- DATA SHOT NUMBER (5 DIGITS)
C     IER-- (input = kludge for trdat) if 77: MDS already connected
C     IER-- (OUTPUT) ERROR RETURN CODE
C      0=NORMAL
C      1=FILE NOT OPENED
C      2=FILE NOT OPENED-- TRIED FROM JUKEBOX WITHOUT SUCCESS
C
C  DMC/Dick Wieland 10 Sep 1991 -- Unix portability changes
C    Jukebox interface not available on the Unix workstations
C
C-------------------------------------------
C
      SUBROUTINE UFOPRD(ILUN,ISHOT,IER)
C
      USE UFILES
C
#include "fpreproc/byte_declare.h"
      byte_declare ibhdr(12),ibref(12)
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
C
      CHARACTER*128 ZFILE
      integer       ikludge
C
C
#ifdef __CRAY
      data ibref/char(0),char(127),char(0),char(127),
     >          char(0),char(127),char(0),char(127),
     >          char(0),char(0),char(0),char(2)/
#elif __SX
      data ibref/'00'x, '7F'x,'00'x, '7F'x,'00'x,'7F'x,'00'x,'7F'x,
     >           '00'x, '00'x,'00'x, '02'x,/
#else
      data ibref/0,127,0,127,0,127,0,127,0,0,0,2/
#endif
C------------------------------------------------------------------
C 12/14/01:CAL
C If called from trdat (mds_connect - troprd):
C           ier=77 = do not re-connect to MDSplus
C           pass to ufopen_mds
C
      if (ier .eq. 77) then
         ikludge=ier
      else
         ikludge=0
      endif
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UFOPRD    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 1000
      IF(UFSTAT(ICHAN).NE.0) THEN
        CALL UERSTA(ICHAN,'UFOPRD    ')
        GO TO 190
      ENDIF
C
      if(ufcprs(ichan).eq.-1) then
         ier=ikludge
         call ufopen_mds(ichan,ishot,ier,1)
         if(ier.ne.0) then
            go to 190
         else
            go to 1000
         endif
      endif
C
      CALL UFSNAM(ISHOT,ZFILE,IER,ILUN)
      IF(IER.NE.0) GO TO 1000
      IF((UFILEV-10*(UFILEV/10)).GE.1)
     >     CALL UFSND0(UFELUN,'NAMED FILE',ZFILE)
C
      UFCPRS(ICHAN)=-1  ! inquire ascii or binary in UFOPEN:
      CALL UFOPEN(UFLUN(ICHAN),ZFILE,1,IER,UFCPRS(ICHAN))
      IF(IER.NE.0) GO TO 100
C If netCDF : ufopen does not open it
      if (UFCPRS(ICHAN) .eq. 4) then
         call cdfopen(UFLUN(ICHAN),zfile,0,ios)
!         ilun=ufid(ICHAN)
!         UFLUN(ICHAN)=ilun
         IF(IER.NE.0) GO TO 100
      end if
C
      go to 800  ! check binary header if appropriate
C--
C  ERRORS
 100  CONTINUE
      IF(IER.EQ.IERFNOF(UFLUN(ICHAN))) THEN   !File not found on disk
C
         IER=1
         CALL UFSND0(UFELUN,
     >      '%UFOPRD:  not found on unix magnetic disk: ',ZFILE)
      end if
 
      CLOSE(UNIT=UFLUN(ICHAN),ERR=190)
C
C  after an error...
C
 190  CONTINUE
 
      CALL UFPAUS(1)
      go to 1000
C-------------------------------
C  file open successful, check binary file header
C
 800  continue
C
C  check header if new binary format detected.
C
      niobuf(ichan)=0
      nchbuf(ichan)=0
      if(ufcprs(ichan).eq.2) then
         call ubufi(uflun(ichan),uiobuf(1,ichan),niobuf(ichan),
     >                ibhdr,12)
         do ii=1,12
            if(ibhdr(ii).ne.ibref(ii)) then
      	 ier=1
      	 CALL UFSND0(UFELUN,
     >	'%UFOPRD:  byte stream header error',ZFILE)
      	 go to 190
            endif
         enddo
      endif
      UFSTAT(ICHAN)=3
      GO TO 1000
C-------------------------------
C  exit
C
 1000 continue
      RETURN
        END
C--------------------------------------------------------------------------

C  open a file for write using UFOPEN.
C  on a unix system, first remove any existing file that might be
C  in the way.
C
C  careful, misuse of this routine can be dangerous to your health
C  it deletes files!
C
      subroutine xfopen(ilun,zfile,ier,ibin)
C
      implicit NONE
C
      integer ilun               ! fortran logical unit number (input)
      character*(*) zfile        ! filename (input)
      integer ier                ! ufopen completion code (output)
      integer ibin               ! ufopen format argument (input)
C
      open(unit=ilun,file=zfile,status='old',err=10)
C
C  no error:  delete file!
C
      close(unit=ilun,status='DELETE')
 10   continue
C
C   hardwire "2" for write access only.
C
      call ufopen(ilun,zfile,2,ier,ibin)
C
      return
      end
 

C******************** START FILE GSCMMX.FOR ; GROUP GSCALE ***********
C-----------------------------------------------------------
C  GSCMMX    FIND MIN AND MAX OF DATA FCNS
C
C  MOD DMC 2/86 - X AXIS MONOTONICITY ASSUMPTION REVOKED
C     HOWEVER THERE IS ONLY ONE X AXIS AND ONE N FOR UP TO 2 FCNS HERE!
C
C  MOD DMC 2/86 - CODE REMOVED FROM SUBROUTINE GSCSET
C
      SUBROUTINE GSCMMX(X,NX,Y,Y2,I2,NY,
     >     IX1,INCX,IY1,INCY,N,ZXLIM1,ZXLIM2,IYONLY)
C
C    X(NX) X DATA
C    Y(NY) Y DATA
C    Y2(NY) 2NDRY Y DATA (OPTIONAL - PRESENT IF I2.NE.0 )
C
C    IX1 - ADDR. FIRST X PT
C    INCX - SPACING BTW X PTS
C    IY1 - ADDR. FIRST Y PT(S)
C    INCY - SPACING BTW Y PTS
C    N - NUMBER OF X,Y PAIRS TO EXAMINE
C
C    ZLIMX1,ZLIMX2 - CONSTRAIN MIN/MAX SEARCH TO THIS X RANGE
C    IYONLY=1  ONLY DO Y AXIS SEARCH
C
C  AXES TYPES COMMON --
C
      INCLUDE 'GAXES_BLK'
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
C  X IN ANY ORDER
C
      DIMENSION X(NX),Y(NY),Y2(NY)
C
      DATA ZINFIN/1.0E37/
      DATA ZSMALL/1.0E-37/
C
      ZMINX=ZXLIM2
      ZMAXX=ZXLIM1
C
C  SAVE PREV. SETTINGS
C
      ZGMINY=GMINY
      ZGMAXY=GMAXY
C
      GMINY=ZINFIN
      GMAXY=-GMINY
C
C  FIND MIN,MAX OF FCN, AND MIN POSITIVE VALUES
C
      ZMINXP=0.0
      GMINYP=0.0
C
      IFND=0
C
      DO 10 I=1,N
C
      IX=IX1+(I-1)*INCX
      IF((X(IX).LT.ZXLIM1).OR.(X(IX).GT.ZXLIM2)) GO TO 10
C
      IFND=I
C
      IY=IY1+(I-1)*INCY
      GMINY=AMIN1(GMINY,Y(IY))
      GMAXY=AMAX1(GMAXY,Y(IY))
      ZMINX=AMIN1(ZMINX,X(IX))
      ZMAXX=AMAX1(ZMAXX,X(IX))
C
      IF(I2.NE.0) GMINY=AMIN1(GMINY,Y2(IY))
      IF(I2.NE.0) GMAXY=AMAX1(GMAXY,Y2(IY))
C
      IF(X(IX).LE.0.0) GO TO 4
C
      IF(ZMINXP.EQ.0.0) ZMINXP=X(IX)
      ZMINXP=AMIN1(ZMINXP,X(IX))
C
 4    CONTINUE
C
      IF(Y(IY).LE.0.0) GO TO 5
      IF(GMINYP.EQ.0.0) GMINYP=Y(IY)
      GMINYP=AMIN1(GMINYP,Y(IY))
C
 5    CONTINUE
C
      IF(I2.EQ.0) GO TO 6
      IF(Y2(IY).LE.0.0) GO TO 6
      IF(GMINYP.EQ.0.0) GMINYP=Y2(IY)
      GMINYP=AMIN1(GMINYP,Y2(IY))
C
 6    CONTINUE
C
 10   CONTINUE
C
C  FOUND ANY DATA?
C
      IF(IFND.NE.0) GO TO 100
C
C  NOTHING IN BOUNDS
C
      ZXMIN=ZXLIM1
      ZXMAX=ZXLIM2
C
      ZXA=0.5*(ZXMAX+ZXMIN)
      ZDIST=ABS(ZXA-X(IX1))
C
      DO 20 I=1,N
        IX=IX1+(I-1)*INCX
        ZD=ABS(ZXA-X(IX))
        IF(ZD.LE.ZDIST) THEN
          ZDIST=ZD
          IDMIN=I
        ENDIF
 20   CONTINUE
C
      IM1=MAX0(1,(IDMIN-1))
      IP1=MIN0(N,(IDMIN+1))
C
      IY=IY1+(IDMIN-1)*INCY
      IYP=IY1+(IP1-1)*INCY
      IYM=IY1+(IM1-1)*INCY
C
      GMINY=AMIN1(Y(IY),Y(IYP),Y(IYM))
      GMAXY=AMAX1(Y(IY),Y(IYP),Y(IYM))
C
 100  CONTINUE
C
C  CHECK ON LIMITS
C
      ZMINXP=AMAX1(ZSMALL,ZMINXP)
      GMINYP=AMAX1(ZSMALL,GMINYP)
C
      IF(IYONLY.NE.1) THEN
        GMINXP=ZMINXP
        GMINX=ZMINX
        GMAXX=ZMAXX
      ENDIF
C
      RETURN
      END

C******************** START FILE UF2RUT2.FOR ; GROUP UFILES ******************
C---------------------------------------------------------------------
C  UF2RUT2
C  READ 2D DATA IN CONSECUTIVELY
C
 
      SUBROUTINE UF2RUT2(ILUN,F,N,Iformat,IERR)
      DIMENSION F(N)
C
C  Updated:
C  08/24/93 TBT - Created from UF2RUT - added Iformat
C
C	Input:
C         Iformat - 0 => Old format
C                   1 => 8/93 format
 
 
      If (Iformat .Eq. 0) Then
        READ(ILUN,3008,END=9000,ERR=9000) (F(IJ),IJ=1,N)
      Else If (Iformat .Eq. 1) Then
        call ufascio(ilun,f,n,'R',iend,ierr)
        if((iend.eq.1).or.(ierr.eq.1)) go to 9000
      Else
        Go To 9000
      End If   ! Iformat
 
 3008 FORMAT(6(1X,1PE11.4))  ! old format, 5 digit accuracy
 
      IERR=0
      RETURN
C
 9000 CONTINUE
      IERR=1
      RETURN
C
      END
C******************** END FILE UF2RUT2.FOR ; GROUP UFILES ******************

C******************** START FILE UF1DRE.FOR ; GROUP UFILES ******************
C--------------------------------------------------------------
C  UF1DRE
C
C  SIMPLIFIED READ ROUTINE FOR 1D DATA.  LABELS FOR DATA ARE
C  NOT RETURNED, ONLY THE DATA ITSELF.  THE DATA LABELS
C  ARE PRINTED ON UNIT LUNO
C
C  ACTUAL READ IS PERFORMED BY UF1DRD, WHICH MAY BE USED
C  DIRECTLY IF LABELS ARE DESIRED.  PURPOSE OF THIS ROUTINE
C  IS TO HAVE A 1D READ ROUTINE WITH AS SIMPLE A LIST OF CALLING
C  ARGUMENTS AS POSSIBLE.
C
        SUBROUTINE UF1DRE(ILUN,X,F,NDIM,NACT,IER,LUNO)
C
C  ILUN (INPUT) - FILE LOGICAL UNIT NUMBER
C    FILENAME WILL HAVE BEEN CONSTRUCTED (SRS. UFSETR,UFOPEN)
C  AND FILE OPENED (SR. UFOPRD) BEFORE THIS ROUTINE IS CALLED
C
C  X  ARRAY FOR INDEPENDENT VARIABLE (RETURNED FROM FILE)
C  F  ARRAY FOR DEPENDENT VARIABLE (RETURNED FROM FILE)
C  NDIM  (INPUT) DIMENSION OF X,F ARRAYS
C  NACT  ACTUAL NUMBER OF X,F POINTS IN FILE
C       ERROR OCCURS IF NACT .GT. NDIM
C  IER   ERROR RETURN CODE 0= NORMAL SUCCESSFUL COMPLETION
C  LUNO  (INPUT) OPEN I/O CHANNEL FOR OUTPUT OF FILE
C        DATA LABELS
C        (OUTPUT SUPPRESSED IF LUNO=0)
C
C---
        USE UFILES
C
        REAL X(NDIM),F(NDIM)
      REAL ZVAL(UFPASC)
      CHARACTER*30 ZLAB(UFPASC)
        CHARACTER*10 ZSDATE
        CHARACTER*30 XLAB,FLAB
      CHARACTER*4 IDEV
C
C$r8real_output: x,f
C
C  READ THE DATA
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF1DRE    ',ICHAN,IER)
        CALL UF1DRD(ILUN,IDEV,ZSDATE,X,F,NDIM,NACT,IPROC,
     >     XLAB,FLAB,UFPASC,IVGOT,ZVAL,ZLAB,IER)
C
      IF(LUNO.LE.0) RETURN
C
C  ECHO LABEL; RESULTS INFO
        WRITE(LUNO,1001) IER
 1001   FORMAT(' =============================================='/
     >  ' DATA READ FROM FILE:  IER=',I3,' (0 IS NORMAL)'/)
c
        call ufsnmd(luno,' Ufile Name',ilun)
c
        WRITE(LUNO,1002) ILUN,IDEV,ZSDATE
 1002   FORMAT(' UFILES LOGICAL UNIT NO. ',I2,'  TOKAMAK:  ',A4,
     >  ' SHOT DATE:  ',A10/)
        WRITE(LUNO,1003) NACT,XLAB,FLAB
 1003   FORMAT(1X,I5,' DATA POINTS READ'/
     >  ' X LABEL:  "',A30,'"'/' F LABEL:  "',A30,'"'/)
        IF((IPROC.EQ.1).OR.(IPROC.EQ.3)) WRITE(LUNO,1004)
        IF((IPROC.EQ.2).OR.(IPROC.EQ.3)) WRITE(LUNO,1005)
 1004   FORMAT(' DATA WAS AVERAGED')
 1005   FORMAT(' DATA WAS SMOOTHED')
      IF(IVGOT.EQ.0) GO TO 100
      DO 96 I=1,IVGOT
        WRITE(LUNO,1006) ZVAL(I),ZLAB(I)
 1006   FORMAT(' ASSOCIATED QUANTITY VALUE:  ',1PE12.5/
     >         '                     LABEL:  ',A30/)
 96   CONTINUE
C
 100  CONTINUE
        RETURN
                END
C******************** END FILE UF1DRE.FOR ; GROUP UFILES ******************

C******************** START FILE uf0cap.FOR ; GROUP UFILS0 ******************
C-----------------------------------------------------------------
C  D. MC CUNE NOV 12 1981
C& uf0cap   CAPITALIZE ALL LETTERS IN PASSED STRING
C
      SUBROUTINE uf0cap(ZSTR)
      CHARACTER*(*) ZSTR
      CHARACTER*52 ZCAP
      DATA ZCAP/
     >  'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C
      ILEN=LEN(ZSTR)
      IF(ILEN.EQ.0) RETURN
      DO 101 I=1,ILEN
      DO 100 IC=1,26
      IF(ZSTR(I:I).NE.ZCAP(IC:IC)) GO TO 100
      ICP=IC+26
      ZSTR(I:I)=ZCAP(ICP:ICP)
      GO TO 101
 100  CONTINUE
 101  CONTINUE
      RETURN
      	END
C******************** END FILE uf0cap.FOR ; GROUP UFILS0 ******************

C******************** START FILE UFG2DA.FOR ; GROUP UFCMPR ******************
C-------------------------------------------------------------------
C  UFG2DA
C
C  TRANSFER WORDS FROM 3D ARRAY TO 1D ARRAY FOR PROCESSING
C
C  MOD DMC APR 1986 - INCREASED FROM 2D TO 3D
C
      SUBROUTINE UFG2DA(A3D,NA3D1,NA3D2,NZ,NX,NY,INUM0,A1D,N)
C
      REAL A3D(NA3D1,NA3D2,NZ),A1D(N)
C
C  ARGUMENTS
C   A3D - 3D INPUT DATA ARRAY
C     NOTE 1ST DIMENSION NA3D1 2ND DIM NA3D2
C
C   NX,NY-- NUMBER OF ROWS AND COLUMNS IN A2D CONTAINING "USEFUL" DATA.
C     NX MAY BE .LT. NA3D1  SIM. FOR NY, NA3D2
C
C   A1D - 1D OUTPUT DATA ARRAY
C     N = A1D DIMENSION = NUMBER OF DATA WORDS TO TRANSFER
C
C   INUM0 - PTS TO THE WORD PRECEDING THE FIRST WORD TO TRANSFER.
C
      IL=INUM0
C
      DO II=1,N
        IL=IL+1
        I3=(IL-1)/(NX*NY)+1
        ILI=IL-(I3-1)*NX*NY
        I2=(ILI-1)/NX+1
        I1=ILI-(I2-1)*NX
C
        A1D(II)=A3D(I1,I2,I3)
C
      ENDDO
C
      RETURN
      END
C******************** END FILE UFG2DA.FOR ; GROUP UFCMPR ******************

!============================================================
!  USERIO.BLK   VERSION 2 ... MAY 9 1980 ... D. MC CUNE
!
!  JAB Feb 2021 -- Convert from COMMON blocks to MODULE
!  TBT May 1995 -- Increase length of XFILE to 130 from 64.
!  DMC JAN 1985 -- MODIFIED TO SUPPORT UREAD5 FEATURES
!   SOFT CODED COMMAND CHARACTERS
!    E.G. MFILI (DFLT "@") INDIRECT INPUT FILE CHARACTER
!
!   OUTPUT LUN STACK FOR MULTIPLE SIMULTANEOUS INDIRECT FILES
!    OPEN FOR OUTPUT-- RECORDING OF PROMPTS/INSTRUCTIONS.
!
!   TYPEAHEAD BUFFER STACK TO ALLOW TYPEAHEAD PAST INDIRECT
!    INPUT FILENAMES
!
!  character buffers:  size:
!
!============
MODULE USERIO
  IMPLICIT NONE

  INTEGER, PARAMETER :: urdbufl=512

  INTEGER, DIMENSION(10) :: luntin,ncmnd,nplc
  INTEGER, DIMENSION(3)  :: nchbfp
  INTEGER ncbufp,lpunct,lprbuf,nprbuf,nvidch,ncpwd, &
       nlunin,lunido,luntrm,maxlin,nchara,ncp1a,ncp2a,ncharc,ncp1c, &
       nlunio,lbuff,lfiln,lpnam,lpval,luword,nbline,ibatch,nttyp,nclear, &
       nplotd,lready,lpmmsg,lmarkn,levcmd,lcmdin,nsaved,npgmax, &
       nplmax,npgc
!
!  ** note ** if urdbufl changes then see also fldlim.for, iscmp0.for,
!     and numfld.for in the ureadsub library...
!
!    NLUINI=.TRUE. IF BLOCK HAS BEEN INITIALIZED VIA CALL USINIT
!  COMMON BLOCK CONTAINING BUFFERS AND INFORMATION USEFUL
!   FOR CARRYING OUT USER-COMPUTER INTERACTION
!
!  CBUFF  -- (urdbufl) CHARACTER BUFFER  PACKED   - COMMAND INPUT
!  CBUFFP -- RECORD OF RECENT INPUT LINES - CAPACITY NCBUFP
!   NCHBFP CHARACTERS IN EACH ENTRY OF CBUFFP
!  DBUFF  -- (urdbufl) CHARACTER BUFFER UNPACKED  - COMMAND INPUT
!  BBUFF  -- (urdbufl) CHARACTER BUFFER UNPACKED  - PROGRAM PROMPT
!   NCHAR-- # OF CHARACTERS BEFORE "$" IN BBUFF
!  NCPWD  -- # OF CHARACTERS PER WORD
!
!  MSEMI  -- ASCII SEMICOLON
!  MDOLLR -- ASCII DOLLAR SIGN "$"
!  MCAROT -- ASCII ">"
!  MIDAT  -- ASCII "@"
!
!  NLINDI -- LOGICAL FLAG  .TRUE.==> USING INDIRECT FILE AS INPUT
!   NEW AUG 1981
!    NLXPER  -- LOGICAL FLAG  .TRUE. ==> PROGRAM USER IS EXPERT
!      SUPPRESS EXTRA PROMPTS
!    NLXOUT  -- LOGICAL FLAG  .TRUE. ==> PRINT EXTRA PROMPTS
!      NLXOUT = (.NOT.NLXPER).AND.(.NOT.NLINDI)
!  NLINDO -- LOGICAL FLAG  .TRUE.==> CREATING INDIRECT FILE AS OUTPUT
!
!  LUNTIN -- STACK OF INPUT L.U.N. S
!  MAXLIN -- MAX # OF INPUT UNITS (EQUALS MAX LEVEL OF
!             INDIRECT FILES)
!  NLUNIN -- POINTS TO CURRENT INPUT LINE
!
!  LUNIDO -- POINTS TO OUTPUT DEVICE LUN FOR CREATING INDIRECT FILE
!  LUNTRM --- LUN OF TERMINAL FOR OUTPUT
!  IBATCH --- =1 IF IN BATCH, 0 OTHERWISE.
!    IBATCH SET BY: CALL ISBATCH(IBATCH);  [JOD]ISBATCH.OBJ
!
!  XFILE-- LIST OF INDIRECT FILE NAMES FOR TRACE-BACK
!  NCMND-- LIST OF COMMAND COUNTS FOR TRACEBACK
!
!  " EDITOR " COMMON:
!    NLEDIT = .TRUE. IF EDITOR IN EFFECT
!    NLCOPI = .TRUE. TO COPY TERMINAL INPUT TO OUTPUT FILE
!    NLSWIN = .TRUE. IF CHANGING INPUT CHANNEL DUE TO EDIT COMMAND
!    NSAVED = # OF FILE INPUT LINES SAVED PRIOR TO PROCESSING
!    MSTAR = '*' SPECIAL CHARACTER USED TO INVOKE SPECIAL FUNCTIONS
!
!    LURCAP = .TRUE. for uppercase script filenames
!             .FALSE. for lowercase filenames -- unix option
!
!-----
!  23 JAN 1982
!   NLNULL - FLAG TO UREAD - PERMIT NULL LINE ANSWER TO PROMPT
!     NLCRI -- VALUE OF NLNULL TO USE FOR COMMAND INPUT MODE
!     (SET VIA ROUTINE URDCRI)
!   nlcmd -- .TRUE. to enable * commands 
!   NL1LIN - FLAG TO UPROMT - PROMPT AND ANSWER ON ONE LINE
!   NLHOLD - FLAG TO UREAD UTILITIES
!     IF NLHOLD=.TRUE. (INITIAL DEFAULT) DO NOT DELETE STRING FROM
!   INPUT BUFFER AFTER DECODING (IDCODE,FDCODE,IXUOPC, ETC.)
!     IF NLHOLD .FALSE. DO DELETE STRING AND RE-JUSTIFY INPUT BUFFER
!   ALLOWS STACKING OF MULTIPLE COMMANDS ON LINE
!     TO SET NLHOLD CALL UHOLD; TO CLEAR CALL UFREE
!
!     NCLEAR - PAGE CLEARING COUNT
!     NPLOTD - SGLIB PLOT DISPLAY COUNT
!-----
!-----
!  STRING PARAMETER BLOCKS--
!   (DEC. 1980  D. MC CUNE)  ALLOWS "LOCAL" AND "GLOBAL" STRING
!   PARAMETER DEFINITION; THESE MAY IN EFFECT BE INPUT ARGUMENTS
!   FROM HIGHER-LEVEL TO LOWER LEVEL INDIRECT INPUT FILES.
!    E.G. LINE "@FILE.TMI/NSHOT=12345" WILL EXECUTE INDIRECT
!   FILE "FILE.TMI"; ANY OCCURENCE OF THE STRING "=NSHOT" IN
!   "FILE.TMI" WILL BE REPLACED BY THE SPECIFIED STRING "12345"
!     LOCAL-- PARMS DEFINED IN @FILE LINE
!     GLOBAL-- PARMS DEFINED IN LINE OF FORM /NAME=VALUE
!       / IN *FIRST* CHARACTER POSITION.
!   WHEREVER STRING =(PARM. NAME) OCCURS IN INPUT STREAM, BOTH
!   LOCAL AND GLOBAL VALUE TABLES ARE SEARCHED; IF SEARCH FAILS,
!   USER IS PROMPTED TO SUPPLY VALUE; IF IN BATCH AND VALUE
!   IS NOT FOUND, CODE HALTS.
!     GLOBAL ARRAYS-- PGLNAM(1500),PGLVAL(1500),NPGMAX(=1500),NPGC
!     LOCAL ARRAYS-- PLCNAM(300,10),PLCVAL(300,10),NPLC(10)
!       NPLMAX(=300)  (ALSO MAX # OF LEVS = MAXLIN = 10)
!     INCL. PARAMETER NAMES,VALUES, AND COUNTERS
!
!
!  REV. DEC. 1980-- ADD 3 CHARACTER VARIABLE "FILEXT"
!     DEFAULT FILENAME EXTENSION FOR CONSTRUCTING NAMES OF INDIRECT
!     INPUT FILES, 3 CHARACTERS
!
!----
!  CHARACTER*8 UTTYP - USER TTY TYPE (HHT SYSTEM - VAX)
!  INTEGER     NTTYP - DITTO INTEGER CODE (HHT SYSTEM - VAX)
!    CF [NBEAM.TERMCTL]TERMCTL SUBROUTINE LIBRARY -
!      READS LOGICAL SYMBOL "TERMINAL_TYPE" FROM JOB LOGIN.COM
!  (DMC - NOV 1984)
!
!----
!  DMC FEB 1989
!  UPUNCT(1:LPUNCT) CONTAINS LIST OF USER DEFINED "PUNCTUATION
!  CHARACTERS" WHICH DELIMIT UREAD INPUT WORDS AND ARE VISIBLE AS
!  WORDS TO THE APPLICATION.  INITIAL DEFAULT WILL BE LPUNCT=0,
!  NO PUNCTUATION DEFINED.
!
!  DMC FEB 1989
!  UPCHAR -- CHARACTER ENTERED BY USER TO ACKNOWLEDGE "UPAUSE" CALL
!  *INTERACTIVE JOBS ONLY*
!
!
!  ADDED MAXIMUM LENGTHS OF ELEMENTS DMC MAY 86
!   LBUFF - LENGTH (CHARACTERS) OF INPUT LINE BUFFER
!   LFILN - LENGTH (CHARACTERS) OF UREAD FILENAME
!   LPNAM - LENGTH (CHARACTERS) OF UREAD STRING PARAMETER NAME
!   LPVAL - LENGTH (CHARACTERS) OF UREAD STRING PARAMETER VALUE
!      ... SEE USINIT.FOR
!
!
!   NBLINE-- NO. OF BLANK LINES TO TYPE BEFORE EACH PROMPT
!
!
!  DMC JAN 1985
!    LEVCMD=1 CMD INPUT  =2 TEXT INPUT (NO UPPERCASE CONVERSION...)
!    LCMDIN=1 TTY/FILE INPUT  =2 USER PROGRAM CALL
!
  INTEGER NCPRM(2)
  LOGICAL LURCAP,NLEDIT,NLSKIP,NLCOPI,NLECHO,NLUINI,NLJAVA
  CHARACTER*1 MSTAR,MFILI,MFILO,MBRNCH,MTARGT,MCOMMT, &
       MPARAM,MSUB1,MSUB2(2),MCMD,MQMARK,MCOLON,M1QUOT,M2QUOT,MLBRAK,MRBRAK
  CHARACTER*128 ABUFF,USRCMD
  CHARACTER*(urdbufl) CBUFF,CBUFFP(3),AHDBUF(10),UWORD,PREBUF(8)
  LOGICAL NLUSRC,NLSSUB
  CHARACTER*130 URFILE
  CHARACTER*64 URMARK
  Character*1   T1buff(urdbufl)
  Character*(urdbufl) T2buff
  Character*64  T1File, T2File
  CHARACTER*1 BBUFF(urdbufl),DBUFF(urdbufl),MSEMI,MCAROT,MIDAT,MDOLLR
  CHARACTER*1 MSLASH,MEQS,MDOT
  CHARACTER*8 UTTYP,VIDCHS
  CHARACTER*16 UPUNCT
  CHARACTER*1 UPCHAR
  LOGICAL NLINDI,NLINDO,NLXPER,NLXOUT,NLRVID
  LOGICAL NLNULL,NL1LIN,NLHOLD,NLCRI,nlcmd
  CHARACTER*130 XFILE(10)
  CHARACTER*3 FILEXT
!
!  if the sizes of these arrays change, update definitions of
!  NPGMAX and NPLMAX in ureadsub/usinit.for
!
  CHARACTER*16 PGLNAM(1500),PLCNAM(300,10)
  CHARACTER*96 PGLVAL(1500),PLCVAL(300,10),PRMSUB
!
  integer levdflt

  data NLUINI/.FALSE./
  data levdflt/1/
!
END MODULE USERIO

subroutine urd_getprog(zprognam)

  ! get UREAD program name

  use urd_progmod
  implicit NONE

  character*(*), intent(out) :: zprognam

  !--------------------------

  if(progname.eq.' ') then
     ! try to get as command line arg[0] -- works in unix environments
     call get_arg(0,progname)
     call ulower(progname)
  endif

  zprognam = progname

end subroutine urd_getprog

!******************** START FILE FLINT_Z.FOR ; GROUP SIGS2 ********************
!==============================================================================
!
!  FLINT_Z
!   INTERPOLATE ON A 2D ARRAY
!
SUBROUTINE FLINT_Z(X,Y,F,N,MTX,XMIN,XMAX,XLR,NX,YMIN,YMAX,YLR,&
     NY,IWARN)
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER n,nx,ny,it,iwarn,ix,iy,ixp1,iyp1
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) xmin,xmax,xlr,ymin,ymax,ylr,zx,zy,zzx,zlogx,&
       zzy,zlogy,zf00,zf01,zf10,zf11
!============
  real(fp) MTX(NX,NY)
  real(fp),DIMENSION(n) :: X,Y,F
!
! Interpolates the table MTX(NX,NY) to find the value at (x,y).
! If XLR>0, then the X grid is equally spaced on a logarithmic scale:
!
!   X(i) = XMIN * (exp(XLR)) ** ( (i-1)/(NX-1) )
!
!   So X(i) ranges from XMIN to XMIN*exp(XLR), and XLR=log(xmax/xmin).
!
! For XLR<=0, the X grid is equally spaced on a linear scale from
! XMIN to XMAX.
!
! For YLR>0, Y is logarithmically spaced from YMIN to YMIN*exp(YLR)
! and for YLR<=0, Y is linearly spaced from YMIN to YMAX.
!
! Modified 7/26/00 (PCR) - vectorized.
!
  iwarn=0
!
  do it=1,n
!
     ZX=X(it)
     ZY=Y(it)
!
     if(zx .lt. xmin) then
        zzx=0.0_fp
     else
        IF(XLR.GT.0.0_fp) THEN
           ZLOGX=log(ZX/XMIN)
           ZZX=1.0_fp+ZLOGX/XLR * (NX-1)
        ELSE
           ZZX=1.0_fp+(ZX-XMIN)/(XMAX-XMIN) * (NX-1)
        ENDIF
     endif
!
     if(zy .lt. ymin) then
        zzy=0.0_fp
     else
        IF(YLR.GT.0.0_fp) THEN
           ZLOGY=log(ZY/YMIN)
           ZZY=1.0_fp+ZLOGY/YLR * (NY-1)
        ELSE
           ZZY=1.0_fp+(ZY-YMIN)/(YMAX-YMIN) * (NY-1)
        ENDIF
     endif
!
     IX=ZZX
     IY=ZZY
!  CHECK FOR POINT OUT OF BOUNDS OF ARRAY
     IF(IX.GE.1) GO TO 10
!
     IF(ZX.LT.(XMIN - 5.0e-7_fp)) THEN
        IWARN=1
     ENDIF
     IX=1
     ZZX=1.0_fp
!
10   CONTINUE
     IF(IY.GE.1) GO TO 20
!
     IF(ZY.LT.(YMIN - 5.0e-7_fp)) THEN
        IWARN=1
     ENDIF
     IY=1
     ZZY=1.0_fp
!
20   CONTINUE
     IF(IX.LT.NX) GO TO 30
!
     IF(ZX.GT.(XMAX + 5.0e-7_fp)) THEN
        IWARN=1
     ENDIF
     IX=NX-1
     ZZX=NX
!
30   CONTINUE
     IF(IY.LT.NY) GO TO 40
!
     IF(ZY.GT.(YMAX + 5.0e-7_fp)) THEN
        IWARN=1
     ENDIF
     IY=NY-1
     ZZY=NY
!
!---------------------------
!  OK
!
40   CONTINUE
     IXP1=IX+1
     IYP1=IY+1
     ZZX=ZZX-IX
     ZZY=ZZY-IY
     ZF00=(1._fp-ZZX)*(1._fp-ZZY)
     ZF01=(1._fp-ZZX)*ZZY
     ZF10=ZZX*(1._fp-ZZY)
     ZF11=ZZX*ZZY
!
!  INTERPOLATE
!
     F(it)=ZF00*MTX(IX,IY)+ZF01*MTX(IX,IYP1)+&
          ZF10*MTX(IXP1,IY)+ZF11*MTX(IXP1,IYP1)
!
  enddo
!
!
END SUBROUTINE FLINT_Z
!
!******************** END FILE FLINT.FOR ; GROUP SIGS2 ************************
! 26Jul2000 fgtok -s r8_precision.sub "r8con.csh conversion"

      subroutine ufncap(icap)
C
C  set default capitalization switch for Ufile filenames
C
      use UFILES
C
      integer icap  ! =1 for capitalized names, =0 for lower case names
C
C---------------
C
      call ufinit
      if(icap.eq.1) then
         LUFCAP=1
      else if(icap.eq.0) then
         LUFCAP=0
      else if(icap.eq.2) then
         LUFCAP=2
      else
         write(6,1001) icap
 1001    format(' ?ufncap:  invalid argument value icap=',i6)
      endif
C
      return
      end

C******************** START FILE UNAMF.FOR ; GROUP UREAD5 ******************
 
      SUBROUTINE UNAMF(ZFILE)
 
 
C  Modifications:
C  05/15/95 tbt Made Zfile C*(*) to be compatible with lisfile.
C               this is only called by source/lismak_sub/lisfile.for
 
C--------------------------------------------------------------
C&  UNAMF CONSTRUCT UREAD FILENAME (W/ DEFAULT EXTENSION OPTION)
C          ...      D. MC CUNE 3 FEB 1981
C  ROUTINE TO CONSTRUCT FILENAME FROM UNPACKED USER SPECIFICATION
C  IN CHAR*1 ARRAY DBUFF*** WHICH IS ASSUMED TO BE PRESENT;
C  I.E. THIS ROUTINE IS CALLED AFTER
C  "CALL UREAD('SUB:  ENTER FILENAME (MAX 30 CHARS):$')"
C  TO PACK USER ANSWER IN 30 CHAR VARIABLE SUITABLE FOR USE
C  AS ARGUMENT IN OPEN COMMAND
 
      USE USERIO
 
CCC	CHARACTER*64  ZFILE    ! tbt
      Character*(*) ZFILE
C
      CHARACTER*16 ZPUNCT
C
      IPUNCT=0
C  TEMPORARILY REMOVE ANY USER PUNCTUATION THAT MIGHT BE PART OF
C  A FILENAME
      IF(LPUNCT.GT.0) THEN
        IPUNCT=LPUNCT
        CALL URPUNC(ZPUNCT)
        ICC=0
        DO 5 IC=1,LPUNCT
          IF(INDEX(':[]<>.;',ZPUNCT(IC:IC)).EQ.0) THEN
            ICC=ICC+1
            IF(ICC.LT.IC) UPUNCT(ICC:ICC)=ZPUNCT(IC:IC)
          ENDIF
 5      CONTINUE
        LPUNCT=ICC
      ENDIF
C
      ILFILN=LEN(ZFILE)
C
      IBLANK=0
      IJ=0
      ZFILE = ' '     ! Initialize tbt 5/95
C
      DO 110 J=1,LBUFF-1
          CALL UDELIM(DBUFF(J),IDELIM)
          IF((IBLANK.EQ.1).AND.((IDELIM.EQ.1).OR.
     >	       (IDELIM.EQ.2))) GO TO 120
          IF((IBLANK.EQ.0).AND.((IDELIM.LT.1)
     >	       .OR.(IDELIM.GT.2))) IBLANK=1
          IF(IBLANK.EQ.0) GO TO 110
          IJ=IJ+1
          ZFILE(IJ:IJ)=DBUFF(J)
          IF(IJ.GE.ILFILN) GO TO 120
 110  CONTINUE
C
      J=LBUFF-1
 120  CONTINUE
      JP1=J+1
      IEFLG=0
      CALL UDELIM(DBUFF(JP1),IDELIM)
      IF((IJ.GE.ILFILN).AND.((IDELIM.LT.1).AND.
     >     (IDELIM.GT.2))) THEN
         CALL UERMSG('% UNAMF: FILENAME TOO LONG',CBUFF(1:JP1),2)
         IEFLG=1
      ENDIF
C
      IF(IJ.GE.ILFILN) GO TO 140
C
      IJP1=IJ+1
      DO 130 JJ=IJP1,ILFILN
          ZFILE(JJ:JJ)=' '
 130  CONTINUE
C
 140  CONTINUE
C
C  FOR TYPEAHEAD, ROTATE NAME OUT OF BUFFER
      IF(IEFLG.EQ.0) CALL UROTOR(J)
C
C  RESTORE APPLICATION PUNCTUATION
      IF(IPUNCT.GT.0) CALL USPUNC(ZPUNCT(1:IPUNCT))
      RETURN
      END
C******************** END FILE UNAMF.FOR ; GROUP UREAD5 ******************

C******************** START FILE IUFORD.FOR ; GROUP UFILS0 ******************
C--------------------------------------------------------------
C  IUFORD
C  INTEGER ORDERING FUNCTION ON 10 CHAR KEYWORDS
C  (ALPHABETIC)
C
      INTEGER FUNCTION IUFORD(ZKEY1,ZKEY2)
C
      CHARACTER*10 ZKEY1,ZKEY2
      CHARACTER*10 ZTES1,ZTES2
C
C  IN FIGURING ORDER, DO NOT INCLUDE TERMINATING ":"
C  RETURN IUFORD=0 IF ZKEY1=ZKEY2 ALPHABETICALLY
C    IUFORD=-1 IF ZKEY1<ZKEY2 ALPHABETICALLY
C    IUFORD=+1 IF ZKEY1>ZKEY2 ALPHABETICALLY
C
      IC=INDEX(ZKEY1,':')-1
      IF(IC.LE.0) IC=10
      ZTES1=ZKEY1(1:IC)
      IC=INDEX(ZKEY2,':')-1
      IF(IC.LE.0) IC=10
      ZTES2=ZKEY2(1:IC)
C  TEST
      IF(ZTES1.EQ.ZTES2) THEN
        IUFORD=0
      ELSEIF(ZTES1.GT.ZTES2) THEN
        IUFORD=1
      ELSE
        IUFORD=-1
      ENDIF
      RETURN
      END
C******************** END FILE IUFORD.FOR ; GROUP UFILS0 ******************

! real*8 interface generated by r8igen.csh --
! ...in /transp/users/dmccune/troot/tmp/trgraf
! csh -f r8igen.csh r8_trangr.for foo.msg
 
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GMMSELB
      SUBROUTINE R8_GMMSELB(
     > R8_R,R8_Y,ND1,NC,R8_Z,NZ,RUN,YUN,ZLAB,ZUN,MNLAB)
 
      external GMMSELB
 
! argument declarations
      REAL*8 R8_R(ND1,NZ)
      REAL*8 R8_Y(ND1,NZ)
      INTEGER ND1
      INTEGER NC
      REAL*8 R8_Z(NZ)
      INTEGER NZ
      CHARACTER*(*) RUN
      CHARACTER*(*) YUN
      CHARACTER*(*) ZLAB
      CHARACTER*(*) ZUN
      CHARACTER*(*) MNLAB(3)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: R_act(:,:)
      REAL, pointer :: R_ref(:,:)
      REAL, pointer :: Y_act(:,:)
      REAL, pointer :: Y_ref(:,:)
      REAL, pointer :: Z_act(:)
      REAL, pointer :: Z_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(R_act(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSELB -- R_act ALLOCATE error!')
      ALLOCATE(R_ref(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSELB -- R_ref ALLOCATE error!')
      ALLOCATE(Y_act(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSELB -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSELB -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSELB -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSELB -- Z_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      R_act=R8_R
      R_ref=R8_R
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
! call to original routine:  GMMSELB
 
      CALL GMMSELB(
     > R_act(1,1),Y_act(1,1),ND1,NC,Z_act(1),NZ,RUN,YUN,ZLAB,ZUN,MNLAB)
 
! copy back outputs if modified.
 
      where(R_act.ne.R_ref)
         R8_R = R_act
      end where
      DEALLOCATE(R_act)
      DEALLOCATE(R_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFASYM
      SUBROUTINE R8_GRFASYM(
     > R8_RCX,R8_YCX,MTBL,MIMOM,LCENTR,JMAX,NMOM,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRFASYM
 
! argument declarations
      REAL*8 R8_RCX(MTBL,0:MIMOM,2)
      REAL*8 R8_YCX(MTBL,0:MIMOM,2)
      INTEGER MTBL
      INTEGER MIMOM
      INTEGER LCENTR
      INTEGER JMAX
      INTEGER NMOM
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: RCX_act(:,:,:)
      REAL, pointer :: RCX_ref(:,:,:)
      REAL, pointer :: YCX_act(:,:,:)
      REAL, pointer :: YCX_ref(:,:,:)
 
! allocation of working arrays...
 
      ALLOCATE(RCX_act(MTBL,0:MIMOM,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFASYM -- RCX_act ALLOCATE error!')
      ALLOCATE(RCX_ref(MTBL,0:MIMOM,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFASYM -- RCX_ref ALLOCATE error!')
      ALLOCATE(YCX_act(MTBL,0:MIMOM,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFASYM -- YCX_act ALLOCATE error!')
      ALLOCATE(YCX_ref(MTBL,0:MIMOM,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFASYM -- YCX_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      RCX_act=R8_RCX
      RCX_ref=R8_RCX
 
      YCX_act=R8_YCX
      YCX_ref=R8_YCX
 
! call to original routine:  GRFASYM
 
      CALL GRFASYM(
     > RCX_act(1,0,1),YCX_act(1,0,1),MTBL,MIMOM,LCENTR,JMAX,NMOM,XUN,
     > YUN,LBL1,LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(RCX_act.ne.RCX_ref)
         R8_RCX = RCX_act
      end where
      DEALLOCATE(RCX_act)
      DEALLOCATE(RCX_ref)
 
      where(YCX_act.ne.YCX_ref)
         R8_YCX = YCX_act
      end where
      DEALLOCATE(YCX_act)
      DEALLOCATE(YCX_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFASYM2
      SUBROUTINE R8_GRFASYM2(
     > R8_RCX,R8_YCX,MIMOM,MTBL,NMOM,JMAX,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRFASYM2
 
! argument declarations
      REAL*8 R8_RCX(0:MIMOM,2,MTBL)
      REAL*8 R8_YCX(0:MIMOM,2,MTBL)
      INTEGER MIMOM
      INTEGER MTBL
      INTEGER NMOM
      INTEGER JMAX
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: RCX_act(:,:,:)
      REAL, pointer :: RCX_ref(:,:,:)
      REAL, pointer :: YCX_act(:,:,:)
      REAL, pointer :: YCX_ref(:,:,:)
 
! allocation of working arrays...
 
      ALLOCATE(RCX_act(0:MIMOM,2,MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFASYM2 -- RCX_act ALLOCATE error!')
      ALLOCATE(RCX_ref(0:MIMOM,2,MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFASYM2 -- RCX_ref ALLOCATE error!')
      ALLOCATE(YCX_act(0:MIMOM,2,MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFASYM2 -- YCX_act ALLOCATE error!')
      ALLOCATE(YCX_ref(0:MIMOM,2,MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFASYM2 -- YCX_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      RCX_act=R8_RCX
      RCX_ref=R8_RCX
 
      YCX_act=R8_YCX
      YCX_ref=R8_YCX
 
! call to original routine:  GRFASYM2
 
      CALL GRFASYM2(
     > RCX_act(0,1,1),YCX_act(0,1,1),MIMOM,MTBL,NMOM,JMAX,XUN,YUN,LBL1,
     > LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(RCX_act.ne.RCX_ref)
         R8_RCX = RCX_act
      end where
      DEALLOCATE(RCX_act)
      DEALLOCATE(RCX_ref)
 
      where(YCX_act.ne.YCX_ref)
         R8_YCX = YCX_act
      end where
      DEALLOCATE(YCX_act)
      DEALLOCATE(YCX_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFSSYM
      SUBROUTINE R8_GRFSSYM(
     > R8_R0,R8_RCX,R8_YCX,MTBL,MIMOM,LCENTR,JMAX,NMOM,XUN,YUN,LBL1,
     > LBL2,LBL3)
 
      external GRFSSYM
 
! argument declarations
      REAL*8 R8_R0(MTBL)
      REAL*8 R8_RCX(MTBL,MIMOM)
      REAL*8 R8_YCX(MTBL,MIMOM)
      INTEGER MTBL
      INTEGER MIMOM
      INTEGER LCENTR
      INTEGER JMAX
      INTEGER NMOM
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: R0_act(:)
      REAL, pointer :: R0_ref(:)
      REAL, pointer :: RCX_act(:,:)
      REAL, pointer :: RCX_ref(:,:)
      REAL, pointer :: YCX_act(:,:)
      REAL, pointer :: YCX_ref(:,:)
 
! allocation of working arrays...
 
      ALLOCATE(R0_act(MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM -- R0_act ALLOCATE error!')
      ALLOCATE(R0_ref(MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM -- R0_ref ALLOCATE error!')
      ALLOCATE(RCX_act(MTBL,MIMOM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM -- RCX_act ALLOCATE error!')
      ALLOCATE(RCX_ref(MTBL,MIMOM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM -- RCX_ref ALLOCATE error!')
      ALLOCATE(YCX_act(MTBL,MIMOM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM -- YCX_act ALLOCATE error!')
      ALLOCATE(YCX_ref(MTBL,MIMOM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM -- YCX_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      R0_act=R8_R0
      R0_ref=R8_R0
 
      RCX_act=R8_RCX
      RCX_ref=R8_RCX
 
      YCX_act=R8_YCX
      YCX_ref=R8_YCX
 
! call to original routine:  GRFSSYM
 
      CALL GRFSSYM(
     > R0_act(1),RCX_act(1,1),YCX_act(1,1),MTBL,MIMOM,LCENTR,JMAX,NMOM,
     > XUN,YUN,LBL1,LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(R0_act.ne.R0_ref)
         R8_R0 = R0_act
      end where
      DEALLOCATE(R0_act)
      DEALLOCATE(R0_ref)
 
      where(RCX_act.ne.RCX_ref)
         R8_RCX = RCX_act
      end where
      DEALLOCATE(RCX_act)
      DEALLOCATE(RCX_ref)
 
      where(YCX_act.ne.YCX_ref)
         R8_YCX = YCX_act
      end where
      DEALLOCATE(YCX_act)
      DEALLOCATE(YCX_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFSSYM2
      SUBROUTINE R8_GRFSSYM2(
     > R8_R0,R8_RCX,R8_YCX,MIMOM,MTBL,NMOM,JMAX,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRFSSYM2
 
! argument declarations
      REAL*8 R8_R0(MTBL)
      REAL*8 R8_RCX(MIMOM,MTBL)
      REAL*8 R8_YCX(MIMOM,MTBL)
      INTEGER MIMOM
      INTEGER MTBL
      INTEGER NMOM
      INTEGER JMAX
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: R0_act(:)
      REAL, pointer :: R0_ref(:)
      REAL, pointer :: RCX_act(:,:)
      REAL, pointer :: RCX_ref(:,:)
      REAL, pointer :: YCX_act(:,:)
      REAL, pointer :: YCX_ref(:,:)
 
! allocation of working arrays...
 
      ALLOCATE(R0_act(MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM2 -- R0_act ALLOCATE error!')
      ALLOCATE(R0_ref(MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM2 -- R0_ref ALLOCATE error!')
      ALLOCATE(RCX_act(MIMOM,MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM2 -- RCX_act ALLOCATE error!')
      ALLOCATE(RCX_ref(MIMOM,MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM2 -- RCX_ref ALLOCATE error!')
      ALLOCATE(YCX_act(MIMOM,MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM2 -- YCX_act ALLOCATE error!')
      ALLOCATE(YCX_ref(MIMOM,MTBL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFSSYM2 -- YCX_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      R0_act=R8_R0
      R0_ref=R8_R0
 
      RCX_act=R8_RCX
      RCX_ref=R8_RCX
 
      YCX_act=R8_YCX
      YCX_ref=R8_YCX
 
! call to original routine:  GRFSSYM2
 
      CALL GRFSSYM2(
     > R0_act(1),RCX_act(1,1),YCX_act(1,1),MIMOM,MTBL,NMOM,JMAX,XUN,YUN,
     > LBL1,LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(R0_act.ne.R0_ref)
         R8_R0 = R0_act
      end where
      DEALLOCATE(R0_act)
      DEALLOCATE(R0_ref)
 
      where(RCX_act.ne.RCX_ref)
         R8_RCX = RCX_act
      end where
      DEALLOCATE(RCX_act)
      DEALLOCATE(RCX_ref)
 
      where(YCX_act.ne.YCX_ref)
         R8_YCX = YCX_act
      end where
      DEALLOCATE(YCX_act)
      DEALLOCATE(YCX_ref)
 
! exit
      return
      end

C-------------------------------------------------------------------
C  GRF3F2  CONTROL ROUTINE, VARIOUS PLOTS OF F(X,T)
c
c  mod dmc 8 July 1997 -- reuse of "IPROC" --
c  specify IPROC=-1 to identify Z1 as "error bars" for Z2,
c  specify IPROC=-2 to identify Z2 as "error bars" for Z1,
c    otherwise presume neither Z1 nor Z2 are "error bars" or
c      measure of std deviation...
C
C  BASED ON OLD GRF3, WITH STREAMLINED INTERFACE, CHARACTER*(*)
C  LABEL PASSING MECHANISM, AND GRF3OP MENU SUBROUTINE
C
      SUBROUTINE GRF3F2(X,Z,Z2,Y,WK,NX,NY,NZ1,
     >                    XLAB,ZLAB,ZLAB2,YLAB,
     >                    XUN,ZUN,YUN,
     >                    ZTITLE,ZLABEL,IPROC)
C
      LOGICAL, EXTERNAL :: LCHAR,LXOUT,LYES,LYESC
C
      REAL X(NX)	! 1ST INDEP. COORD OF FCN TO BE PLOTTED
      REAL Z(NZ1,NY)	! FCN TO BE PLOTTED
      REAL Z2(NZ1,NY)	! 2ND FCN TO BE PLOTTED
      REAL Y(NY)	! 2ND INDEP. COORD OF FCN TO BE PLOTTED
      REAL WK(NY,2)	! ** WORKSPACE ** MUST BE PROVIDED
C
C  X AND Y MUST BE IN ASCENDING ORDER.
C  CAREFULLY NOTE DIMENSIONING OF Z
C
C  WK WILL BE OVERWRITTEN ON CALL TO THIS ROUTINE
C
C  RECOMMENDED NOT LONGER THAN CA. 30 CHARACTERS...
      CHARACTER*(*) XLAB  ! LABEL FOR 1ST INDEP. COORDINATE
      CHARACTER*(*) ZLAB  ! LABEL FOR FCN BEING PLOTTED
      CHARACTER*(*) ZLAB2 ! LABEL FOR 2ND FCN BEING PLOTTED
      CHARACTER*(*) YLAB  ! LABEL FOR 2ND INDEP. COORDINATE
C
C  RECOMMENDED NOT LONGER THAN CA. 20 CHARACTERS...
      CHARACTER*(*) XUN   ! UNITS LABEL FOR 1ST INDEP COORDINATE
      CHARACTER*(*) ZUN   ! UNITS LABEL FOR FCN BEING PLOTTED
      CHARACTER*(*) YUN   ! UNITS LABEL FOR 2ND INDEP. COORDINATE
C
C  RECOMMENDED NOT LONGER THAN CA. 45 CHARACTERS...
      CHARACTER*(*) ZTITLE	! TITLE LABEL FOR PLOTS
C
C  RECOMMENDED NOT LONGER THAN CA. 15 CHARACTERS
      CHARACTER*(*) ZLABEL	! GENERIC LABEL FOR PLOTS
C
C  PROCESSING FLAG (FOR LABELING ONLY)
      INTEGER IPROC	    ! 0=NOTHING, 1=AVG'D, 2=SMOOTHED, ETC...
C
C---------------------------------
C
C  THIS ROUTINE PRESENTS AN INTERACTIVE (UREAD) MENU VIA SUBROUTINE
C  GRF3OP, ALLOWING THE USER TO SELECT
C    1)  3D ISOMETRIC PLOTS
C    2)  2D SIMPLE SLICE PLOTS
C    3)  CONTOUR PLOTS
C    4)  2D SLICE MULTIPLOTS
C  OF THE PASSED LABELED DATA.
C
C  NOTE THE WORKSPACE ARRAY IS NEEDED TO BUILD SOME SLICE PLOTS AND
C  WILL BE OVERWRITTEN ON CALL TO THIS ROUTINE
C
C  ALL OTHER ARGUMENTS TO THIS ROUTINE ARE INPUT ONLY
C
C  ALL LABELS ARE OF ELASTIC LENGTH; HOWEVER, FOR SOME NONBLANK LENGTH
C  THE LABELS WILL START TO NOT FIT IN THE GENERATED TEKTRONIX DISPLAYS
C  WITHOUT LINE WRAPPING
C
C---------------------------------
C  LOCAL
C
      CHARACTER*25 ZLPROC
C
      CHARACTER*132 MNLAB(3)
C
      CHARACTER*12 ZENCOD
C
C---------------------------------
C  EXECUTABLE CODE -- SET UP PROCESSING LABEL
C
      ZLPROC=' '
      IF(IPROC.EQ.1) THEN
        ZLPROC(2:)='(AVERAGED)'
      ELSE IF(IPROC.EQ.2) THEN
        ZLPROC(2:)='(SMOOTHED)'
      ELSE IF(IPROC.EQ.3) THEN
        ZLPROC(2:)='(AVERAGED, SMOOTHED)'
      ELSE IF(IPROC.EQ.4) THEN
        ZLPROC(2:)='(PROCESSED)'
      ENDIF
C
C  error bar control
C
      if(iproc.lt.0) then
         ieb=min(2,-iproc)
      else
         ieb=0
      endif
C
C  TTY LUN
C
      LUNTRM=LNOUT(0)
C
      IPAGE=0
C
      ifun=0
C-------------------
C
C  USER OPTION MENU
C
 10   CONTINUE
C
      ifunp=ifun
      CALL GRF3OP(ZLABEL,ZTITLE,
     >    XLAB,ZLAB,ZLAB2,YLAB,'X',IMAIN,ISUB,2,IFUN)
c
      if(imain.eq.-3) then
         ieb=isub			! error bar mod
         ifun=ifunp
         goto 10
      endif
C
C  BRANCH
C
      if((imain.ne.1).and.(imain.ne.5).and.(imain.ne.8)) ifun=ifunp
      GO TO (100,200,300,400,500,600,700,800) IMAIN
C
C-------------------
C
 100  CONTINUE
C
C  3D ISOMETRIC PLOT
C
      IF(IFUN.EQ.1) THEN
C
         CALL TGRF3D(X,Z,Y,NX,NY,NZ1,
     >	    XLAB,YLAB,ZLAB,
     >	    XUN,YUN,ZUN,
     >	    ZTITLE,IPROC,
     >	    ZLABEL,0,' ',
     >	    IPAGE,' ',' ',0.0,IRET)
      ELSE
C
         CALL TGRF3D(X,Z2,Y,NX,NY,NZ1,
     >	    XLAB,YLAB,ZLAB2,
     >	    XUN,YUN,ZUN,
     >	    ZTITLE,IPROC,
     >	    ZLABEL,0,' ',
     >	    IPAGE,' ',' ',0.0,IRET)
      ENDIF
C
      IF(IRET.EQ.1) GO TO 400
C
      GO TO 10
C
C-------------------
C
C  2D GRAPH OF VARIABLE VS. 1ST INDEPENDANT VARIABLE, 2ND IN-
C  DEPENDANT VARIABLE HELD CONSTANT TO USER SPECIFIED
C  VALUE.
C
 200  CONTINUE
C
C  GET USER SPECIFIED Y VALUE
C
 1200 FORMAT('  ...PLOT VS ',A/'  AT FIXED ',A,', ',A)
C
      IF(LXOUT(0)) WRITE(LUNTRM,1200) XLAB,YLAB,YUN
      CALL UREAD(' GRF3SG:  ENTER FIXED PARAMETER:$$')
      IF(LCHAR('Q')) GOTO 10
C
      YFIX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 200
C
      DYMIN=ABS(YFIX-Y(1))
      IMIN=1
C
      DO 210 I=1,NY
        DY=ABS(YFIX-Y(I))
        IF(DY.GT.DYMIN) GO TO 210
        IMIN=I
        DYMIN=DY
 210  CONTINUE
C
C  SPECIFY FIXED PT DATA IN PLOT LABEL
C
      WRITE(ZENCOD,'(1PE12.5)') Y(IMIN)
C
C  MAKE GRAPH  (GRFAH0 WILL SET SCALE, ETC.)
C
      if(ieb.eq.0) then
c  2 fcn plot
         CALL GRAFX2(X,Z(1,IMIN),Z2(1,IMIN),NX,XUN,ZUN,
     1     ZLABEL//' '//ZTITLE,
     2     'FIXED: '//YLAB//' = '//ZENCOD//' '//YUN,
     3     ZLAB//' & '//ZLAB2//' '//ZLPROC//' VS '//XLAB)
c
      else if(ieb.eq.1) then
c  f1 error bars on f2 plot
         call grafxe(x,z2(1,imin),nx,x,z2(1,imin),nx,0,wk,1,z(1,imin),
     1     xun,zun,
     1     ZLABEL//' '//ZTITLE,
     2     'FIXED: '//YLAB//' = '//ZENCOD//' '//YUN,
     3     ZLAB//' & '//ZLAB2//' '//ZLPROC//' VS '//XLAB)
c
      else if(ieb.eq.2) then
c  f2 error bars on f1 plot
         call grafxe(x,z(1,imin),nx,x,z(1,imin),nx,0,wk,1,z2(1,imin),
     1     xun,zun,
     1     ZLABEL//' '//ZTITLE,
     2     'FIXED: '//YLAB//' = '//ZENCOD//' '//YUN,
     3     ZLAB//' & '//ZLAB2//' '//ZLPROC//' VS '//XLAB)
c
      endif
C
      GO TO 10
C
C------------------
C
C  2D GRAPH OF DEPENDANT VARIABLE VS. 2ND INDEPENDANT VARIABLE
C  WITH USER SPECIFYING FIXED VALUE FOR 1ST INDEPENDANT VARIABLE.
C
 300  CONTINUE
C
C   GET USER SPECIFIED X VALUE
C
      IF(LXOUT(0)) WRITE(LUNTRM,1200) YLAB,XLAB,XUN
      CALL UREAD(' GRF3SG:  ENTER FIXED PARAMETER:$$')
      IF(LCHAR('Q')) GOTO 10
C
      XFIX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 300
C
      DXMIN=ABS(X(1)-XFIX)
      IMIN=1
C
      DO 310 I=1,NX
        DX=ABS(X(I)-XFIX)
        IF(DX.GT.DXMIN) GO TO 310
        DXMIN=DX
        IMIN=I
 310  CONTINUE
C
C  WILL PLOT COLUMN OF Z POINTS CLOSEST TO SPECIFIED X
C  VALUE.  USE WK ARRAY: GRFADH REQUIRES POINTS BEING GRAPHED
C  TO BE IN CONTIGUOUS CORE SPACE
C
      DO 315 I=1,NY
        WK(I,1)=Z(IMIN,I)
        WK(I,2)=Z2(IMIN,I)
 315  CONTINUE
C
C  SPECIFY FIXED PT DATA IN PLOT LABEL
C
      WRITE(ZENCOD,'(1PE12.5)') X(IMIN)
C
C  MAKE GRAPH  (GRFAH0 WILL SET SCALE, ETC.)
C
      if(ieb.eq.0) then
c  2 fcn plot
         CALL GRAFX2(Y,WK(1,1),WK(1,2),NY,YUN,ZUN,
     1     ZLABEL//' '//ZTITLE,
     2     'FIXED: '//XLAB//' = '//ZENCOD//' '//XUN,
     3     ZLAB//' & '//ZLAB2//' '//ZLPROC//' VS '//YLAB)
c
      else if(ieb.eq.1) then
c  f1 error bars on f2 plot
         call grafxe(y,wk(1,2),ny,y,wk(1,2),ny,0,wk,1,wk(1,1),yun,zun,
     1     ZLABEL//' '//ZTITLE,
     2     'FIXED: '//XLAB//' = '//ZENCOD//' '//XUN,
     3     ZLAB//' & '//ZLAB2//' '//ZLPROC//' VS '//YLAB)
c
      else if(ieb.eq.2) then
c  f2 error bars on f1 plot
         call grafxe(y,wk(1,1),ny,y,wk(1,1),ny,0,wk,1,wk(1,2),yun,zun,
     1     ZLABEL//' '//ZTITLE,
     2     'FIXED: '//XLAB//' = '//ZENCOD//' '//XUN,
     3     ZLAB//' & '//ZLAB2//' '//ZLPROC//' VS '//YLAB)
c
      endif
C
C
      GO TO 10
C
C------------------------------
C  ** EXIT
 400  CONTINUE
C
      RETURN
C
C------------------------------
C  ** CONTOUR PLOTTING
C
 500  CONTINUE
C
      IF(IFUN.EQ.1) THEN
        IF(ISUB.EQ.0) THEN
          CALL CONCTR(X,Z,Y,NX,NZ1,NY,
     >		   XLAB,ZLAB,YLAB,XUN,ZUN,YUN,ZLABEL,
     >		   0,IPROC,IPAGE)
        ELSE
          CALL CONCTS(X,Z,Y,NX,NZ1,NY,
     >		   XLAB,ZLAB,YLAB,XUN,ZUN,YUN,ZLABEL,
     >		   0,IPROC,IPAGE,1,1,1)
        ENDIF
      ELSE
        IF(ISUB.EQ.0) THEN
          CALL CONCTR(X,Z2,Y,NX,NZ1,NY,
     >		   XLAB,ZLAB2,YLAB,XUN,ZUN,YUN,ZLABEL,
     >		   0,IPROC,IPAGE)
        ELSE
          CALL CONCTS(X,Z2,Y,NX,NZ1,NY,
     >		   XLAB,ZLAB2,YLAB,XUN,ZUN,YUN,ZLABEL,
     >		   0,IPROC,IPAGE,1,1,1)
        ENDIF
      ENDIF
C
      GO TO 10
C
C------------------------------
C  CHANGE DEFAULT PLOT TYPE
C
 600  CONTINUE
      CALL GAXSET(ISEL,1)
      GO TO 10
C
C------------------------------
C  CHANGE SCALING DEFAULTS
C
 700  CALL GSCDEF
      GO TO 10
C
C------------------------------
C
C  SLICE MULTIPLOTS--
C
 800  CONTINUE
C
      MNLAB(1)=ZLABEL//' '//ZLPROC
C
      MNLAB(2)=ZTITLE
C
      MNLAB(3)=' '
C
C  USER CHOOSE X AXIS, SET OF FIXED Y, AND MAKE GRAPH
      IF(IFUN.EQ.1) THEN
        CALL G3MSEL(Z,NZ1,X,NX,Y,NY,WK,
     >	     XLAB,XUN,YLAB,YUN,ZLAB,ZUN,MNLAB)
      ELSE
        CALL G3MSEL(Z2,NZ1,X,NX,Y,NY,WK,
     >	     XLAB,XUN,YLAB,YUN,ZLAB2,ZUN,MNLAB)
      ENDIF
C
      ifun=ifunp
      GO TO 10
C
      	END

c  common blocks for xplot/vplot
c
	integer   mfbuf,maxfn  
	parameter (mfbuf = 512)
	parameter (maxfn=50)
#ifdef __f90
	character*1 fbuf(mfbuf)
	integer     fnlist(maxfn)
#else
	byte fbuf(mfbuf)
	integer*2 fnlist(maxfn)
#endif
	logical li4105,lo4105,ldiff
	integer kescm,kalfm,kvecm,kpntm,knull
	parameter (kescm=0,kalfm=1,kvecm=2,kpntm=3,knull=4)
	integer kmode		!graphics mode
	common /buffer/ fbuf,li4105,lo4105,ldiff,kmode
c
	integer    maxtx
	parameter (maxtx=1)
	character*16 txlist(maxtx)
	logical lstop,lttyo,ltemp,lkeep,lwait
	integer iosave,nfn,nftop,ntx
	integer lwid
c
	common /search/ iosave,fnlist,nfn,nftop,txlist,ntx,
     >		lstop,lttyo,ltemp,lkeep,lwait,lwid
c
	integer kskip,lskip,kpage,lpage
        integer	incnt,inblk,inptr
	integer maxpage
	parameter (maxpage=3200)
	integer spage(2,maxpage)
	common /skips/ kskip,lskip,kpage,lpage,spage,
     >		incnt,inblk,inptr

	program test
	character*20 dsknam
	integer ldnam
	data ldnam /0/
	call usr$trnlog(' ','PLOT',dsknam,ldnam,igood)
	if(ldnam.eq.0) dsknam='stdout'//char(0)
!	type '(a)', dsknam
	call initt(240)
	call movabs(100,100)
	call drwabs(600,100)
	call drwabs(600,600)
	call drwabs(100,600)
	call drwabs(100,100)
	call movabs(350,650)
	call anstr(3,'box')
	call upause(0)
	call finitt(0)
	end

C******************** START FILE UFCPRD.FOR ; GROUP UFCMPR ******************
C--------------------------------------------------------------------
C  UFCPRD
C
C  MODIF DMC APR 1984-- TREAT ALL ARRAYS AS 2D.  SUPPORT READ/WRITE
C  OF 2D DATA THAT IS NOT CONTIGUOUSLY STORED
C
C  MODIF DMC APR 1985-- CHECK FOR UNCOMPRESSED BINARY RECORDS
C   (SEE UFCPWR ROUTINE - OUTPUT OF NOISY RECORDS WHICH DO NOT COMPRESS
C    SATISFACTORILY)
C
C  MODIF DMC APR 1986-- 3D ARRAY READ CAPABILITY.  NEW PASSED ARGS.
C
C  READ COMPRESSED DATA FROM ILUN AND CONVERT TO A 1-D ARRAY
C  UTILITY ROUTINE FOR UF1DRD AND UF2DRD
C
      SUBROUTINE UFCPRD(ILUN,ARRAY,NA1,NA2,NA3,NAA1,NAA2,IERR)
C
C  ILUN-- LOGICAL UNIT NUMBER ON WHICH TO WRITE
C  ARRAY-- 1D ARRAY CONTAINING DATA TO BE COMPRESSED AND WRITTEN
C  NA1  -  ARRAY 1ST DIMENSION
C  NA2  -  ARRAY 2ND DIMENSION
C  NA3  -  ARRAY 3RD DIMENSION
C  NAA1  -  NUMBER OF PTS ACTIVE IN ARRAY 1ST DIMENSION
C  NAA2  -  NUMBER OF PTS ACTIVE IN ARRAY 2ND DIMENSION
C  IERR--  RETURNED ERROR CODE; 0 IF OK
C
      USE UFILES
C
      REAL ARRAY(NA1,NA2,NA3)
C
      COMMON /UFTPACKU/ TUNPK,TPACK,CDATA,CTEST
      INTEGER*2 TUNPK(UFMAXR)	!UNPACKED INTEGERS
      INTEGER*4 TPACK(UFMAXR)	!PACKED INTEGERS
      REAL CDATA(UFMAXR),CTEST(UFMAXR)
C
      INTEGER IBITR             !BITS FOR REAL-TO-INTEGER
      INTEGER IBITS             !BITS FOR INTEGER COMPRESS
C
      CHARACTER*64 ERRSTR
C
      data ibitr/15/
      data ibits/16/
C------------------------------------------------------------------
C
      NAACT=NAA1*NAA2*NA3
C
      ERRSTR='COMPRESSED DATA RECORD HEADER'
      READ(ILUN,ERR=8900,END=8900) ZOFFS,ZSCAL,IMONO
      IF(IMONO.EQ.1) THEN
C
C  DMC -- READ UNCOMPRESSED X COORDINATE DATA -- DMC Aug 1994
C
         IF((NA2.GT.1).OR.(NA3.GT.1)) THEN
            WRITE(UFELUN,9900)
 9900       FORMAT(
     >' ?UFCPRD -- MONOTONICITY FLAG ON DEPENDENT COORD DATA')
            GO TO 8900
         ENDIF
         READ(ILUN,ERR=8900,END=8900) (ARRAY(IX,1,1),IX=1,NA1)
         IERR=0
         RETURN
      ENDIF
C
C  ok, not monotonic indep. coordinate data ...
C  proceed as before (dmc Aug 1994)
C
      READ(ILUN,ERR=8900,END=8900) IMAXU,IWRDS,IMONO
C
      IF(IMAXU.GT.UFMAXR) THEN
        IMAX=UFMAXR
        WRITE(UFELUN,9901) IMAXU,IMAX
 9901 FORMAT(' ?UFCPRD - COMPRESSED UFILE RECORD SIZE= ',I8/
     >'  TOO LARGE!  MAXIMUM SIZE (UFILES COMMON) = ',I8)
        IMAXU=IMAX
        GO TO 9000
      ENDIF
C
      IWROT=IMAXU
      IMAXU=MAX0(1,IMAXU)
C
      DO IDON=0,NAACT-1,IMAXU
C
        IF(IDON.GT.0) THEN
          ERRSTR='COMPRESSED DATA RECORD HEADER'
          READ(ILUN,ERR=8900,END=8900) ZOFFS,ZSCAL,IMONO
          READ(ILUN,ERR=8900,END=8900) IWROT,IWRDS,IMONO
        ENDIF
C
        IF (IWROT.EQ.0) THEN
C
C  DATA STORED WAS START, STEP SIZE (1D INDEPENDENT AXES ONLY)
          ZSTART = ZOFFS
          ZDELT = ZSCAL
          ARRAY(1,1,1) = ZSTART
          DO II=2,NAA1
            ARRAY(II,1,1) = ZSTART+(II-1)*ZDELT
          ENDDO
          GO TO 8000
        ENDIF
C
        ICOMP=MIN(NAACT-IDON,IMAXU)
        IF(IWROT.NE.ICOMP) THEN
          WRITE(UFELUN,9701) IWROT,ICOMP
 9701     FORMAT(' ? UFCPRD - FOUND ',I4,' WORDS, EXPECTED ',I4)
          GO TO 9000
        ENDIF
C
C  DECOMPRESS INTEGERS
CX	  READ(ILUN,3016) (TPACK(JJ),JJ=1,IWRDS)
CX 3016	  FORMAT(8Z9)
C  DATA WAS WRITTEN COMPRESSED?
C
        IF(IWRDS.GT.0) THEN
          ERRSTR='COMPRESSED BINARY DATA RECORD'
          READ(ILUN,ERR=8900,END=8900) (TPACK(JJ),JJ=1,IWRDS)
C
          ILOCB = 0
          CALL XPANDI(IBITS,TPACK,ILOCB,TUNPK,1,IWROT,IERR)
          IF (IERR.NE.0) THEN
            WRITE(UFELUN,9700) IERR
 9700       FORMAT(' ? DATA WONT DECOMPRESS, REASON=',I3)
            GO TO 9000
          ENDIF
        ELSE
          ERRSTR='UNCOMPRESSED BINARY DATA RECORD'
          READ(ILUN,ERR=8900,END=8900) (TUNPK(JJ),JJ=1,IWROT)
        ENDIF
C
C  CONVERT BACK TO REAL
        DO II=1,IWROT
          CTEST(II) = (ZSCAL * TUNPK(II)) + ZOFFS
        ENDDO
C  SORT AND PUT IN (2D) OUTPUT ARRAY
      CALL UFP2DA(ARRAY,NA1,NA2,NA3,NAA1,NAA2,IDON,CTEST,IWROT)
C
      ENDDO
C
 8000 CONTINUE
      IERR = 0
      RETURN
C
 8900 CONTINUE
      WRITE(UFELUN,8901) ERRSTR
 8901 FORMAT(' ? ERROR READING UFILES COMPRESSED BINARY DATA:'/6X,A)
      IERR = 1
      RETURN
C
 9000 IERR = 3
      RETURN
      END
C******************** END FILE UFCPRD.FOR ; GROUP UFCMPR ******************

!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGCLINS
      SUBROUTINE R4_AGCLINS(
     > R4_ZDATA,MXD,R4_X,NX,R4_Y,NY,R4_CL,NCL)

      implicit none
      external AGCLINS

! argument declarations
      INTEGER MXD
      INTEGER NX
      INTEGER NY
      INTEGER NCL

! >>> from sgnco_mod
      integer   :: nlm
      parameter (nlm=40)
  
 ! floating type, input/output:
      REAL R4_ZDATA(:,:)
  
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  
 ! floating type, input/output:
      REAL R4_CL(NLM)
  

! local (automatic array) declarations

      integer alloc_stat, dim, dim2
      REAL, allocatable :: ZDATA_act(:,:)
      REAL, allocatable :: ZDATA_ref(:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: CL_act(:)
      REAL, allocatable :: CL_ref(:)

! allocation of working arrays...

      dim2=size(R4_ZDATA,dim=2)
      ALLOCATE(ZDATA_act(MXD,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLINS -- ZDATA_act ALLOCATE error!')
      ALLOCATE(ZDATA_ref(MXD,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLINS -- ZDATA_ref ALLOCATE error!')

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLINS -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLINS -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLINS -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLINS -- Y_ref ALLOCATE error!')

      ALLOCATE(CL_act(NLM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLINS -- CL_act ALLOCATE error!')
      ALLOCATE(CL_ref(NLM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLINS -- CL_ref ALLOCATE error!')

! executable code:  copy for input

      ZDATA_act=R4_ZDATA
      ZDATA_ref=R4_ZDATA

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

      CL_act=R4_CL
      CL_ref=R4_CL

! call to original routine:  AGCLINS

      CALL AGCLINS(
     > ZDATA_act(1,1),MXD,X_act(1),NX,Y_act(1),NY,CL_act(1),NCL)

! copy back outputs if modified.

      where(ZDATA_act.ne.ZDATA_ref)
         R4_ZDATA = ZDATA_act
      end where
      DEALLOCATE(ZDATA_act)
      DEALLOCATE(ZDATA_ref)

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(CL_act.ne.CL_ref)
         R4_CL = CL_act
      end where
      DEALLOCATE(CL_act)
      DEALLOCATE(CL_ref)

! exit
      return
      end
! r4real -- generated (f90 fixed form) REAL interface to:  AGCXGET
      SUBROUTINE R4_AGCXGET(
     > R4_XIND,R4_FXX,R4_X,NXS)

      external AGCXGET

! argument declarations
 ! floating type, input/output:
      REAL R4_XIND
  
 ! floating type, input/output:
      REAL R4_FXX
  
      INTEGER NXS
 ! floating type, input/output:
      REAL R4_X(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL :: XIND_act
      REAL :: XIND_ref
      REAL :: FXX_act
      REAL :: FXX_ref
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCXGET -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCXGET -- X_ref ALLOCATE error!')

! executable code:  copy for input

      XIND_act=R4_XIND
      XIND_ref=R4_XIND

      FXX_act=R4_FXX
      FXX_ref=R4_FXX

      X_act=R4_X
      X_ref=R4_X

! call to original routine:  AGCXGET

      CALL AGCXGET(
     > XIND_act,FXX_act,X_act(1),NXS)

! copy back outputs if modified.

      if(XIND_act.ne.XIND_ref) then
         R4_XIND = XIND_act
      endif

      if(FXX_act.ne.FXX_ref) then
         R4_FXX = FXX_act
      endif

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGCYGET
      SUBROUTINE R4_AGCYGET(
     > R4_YIND,R4_FYY,R4_Y,NYS)

      external AGCYGET

! argument declarations
 ! floating type, input/output:
      REAL R4_YIND
  
 ! floating type, input/output:
      REAL R4_FYY
  
      INTEGER NYS
 ! floating type, input/output:
      REAL R4_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL :: YIND_act
      REAL :: YIND_ref
      REAL :: FYY_act
      REAL :: FYY_ref
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCYGET -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCYGET -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      YIND_act=R4_YIND
      YIND_ref=R4_YIND

      FYY_act=R4_FYY
      FYY_ref=R4_FYY

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  AGCYGET

      CALL AGCYGET(
     > YIND_act,FYY_act,Y_act(1),NYS)

! copy back outputs if modified.

      if(YIND_act.ne.YIND_ref) then
         R4_YIND = YIND_act
      endif

      if(FYY_act.ne.FYY_ref) then
         R4_FYY = FYY_act
      endif

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
! r4real -- generated (f90 fixed form) REAL interface to:  AGCPLST
      SUBROUTINE R4_AGCPLST(
     > R4_PL1,R4_PL2,KPL,R4_X,R4_Y)

      external AGCPLST

! argument declarations
      INTEGER KPL
 ! floating type, input/output:
      REAL R4_X
  
 ! floating type, input/output:
      REAL R4_Y
  
 ! floating type, input/output:
      REAL R4_PL1(:)
  
 ! floating type, input/output:
      REAL R4_PL2(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: PL1_act(:)
      REAL, allocatable :: PL1_ref(:)
      REAL, allocatable :: PL2_act(:)
      REAL, allocatable :: PL2_ref(:)
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...

      dim=size(R4_PL1)
      ALLOCATE(PL1_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCPLST -- PL1_act ALLOCATE error!')
      ALLOCATE(PL1_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCPLST -- PL1_ref ALLOCATE error!')

      dim=size(R4_PL2)
      ALLOCATE(PL2_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCPLST -- PL2_act ALLOCATE error!')
      ALLOCATE(PL2_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCPLST -- PL2_ref ALLOCATE error!')

! executable code:  copy for input

      PL1_act=R4_PL1
      PL1_ref=R4_PL1

      PL2_act=R4_PL2
      PL2_ref=R4_PL2

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  AGCPLST

      CALL AGCPLST(
     > PL1_act(1),PL2_act(1),KPL,X_act,Y_act)

! copy back outputs if modified.

      where(PL1_act.ne.PL1_ref)
         R4_PL1 = PL1_act
      end where
      DEALLOCATE(PL1_act)
      DEALLOCATE(PL1_ref)

      where(PL2_act.ne.PL2_ref)
         R4_PL2 = PL2_act
      end where
      DEALLOCATE(PL2_act)
      DEALLOCATE(PL2_ref)

      if(X_act.ne.X_ref) then
         R4_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R4_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGNCOF
      SUBROUTINE R4_AGNCOF(
     > R4_XCS,R4_YCS,NCS,IAI,IAG,NAI)

      external AGNCOF

! argument declarations
      INTEGER NCS
      INTEGER NAI
 ! floating type, input/output:
      REAL R4_XCS(:)
  
 ! floating type, input/output:
      REAL R4_YCS(:)
  
      INTEGER IAI(*)
      INTEGER IAG(*)

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: XCS_act(:)
      REAL, allocatable :: XCS_ref(:)
      REAL, allocatable :: YCS_act(:)
      REAL, allocatable :: YCS_ref(:)

! allocation of working arrays...

      dim=size(R4_XCS)
      ALLOCATE(XCS_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGNCOF -- XCS_act ALLOCATE error!')
      ALLOCATE(XCS_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGNCOF -- XCS_ref ALLOCATE error!')

      dim=size(R4_YCS)
      ALLOCATE(YCS_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGNCOF -- YCS_act ALLOCATE error!')
      ALLOCATE(YCS_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGNCOF -- YCS_ref ALLOCATE error!')

! executable code:  copy for input

      XCS_act=R4_XCS
      XCS_ref=R4_XCS

      YCS_act=R4_YCS
      YCS_ref=R4_YCS

! call to original routine:  AGNCOF

      CALL AGNCOF(
     > XCS_act(1),YCS_act(1),NCS,IAI,IAG,NAI)

! copy back outputs if modified.

      where(XCS_act.ne.XCS_ref)
         R4_XCS = XCS_act
      end where
      DEALLOCATE(XCS_act)
      DEALLOCATE(XCS_ref)

      where(YCS_act.ne.YCS_ref)
         R4_YCS = YCS_act
      end where
      DEALLOCATE(YCS_act)
      DEALLOCATE(YCS_ref)

! exit
      return
      end
!---------------------------------------------------------------------------
      SUBROUTINE R4_RCONTR(
     > K1,R4_C,K2,R4_A,MAXA,R4_XARRAY,IMIN,IMAX,ISTEP,R4_YARRAY,JMIN,
     > JMAX,JSTEP)

      external RCONTR

! argument declarations
      INTEGER K1
      INTEGER K2
      INTEGER MAXA
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
 ! floating type, input/output:
      REAL R4_C(:)
  
 ! floating type, input/output:
      REAL R4_A(:,:)
  
 ! floating type, input/output:
      REAL R4_XARRAY(:)
  
 ! floating type, input/output:
      REAL R4_YARRAY(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim, dim2
      REAL, allocatable :: C_act(:)
      REAL, allocatable :: C_ref(:)
      REAL, allocatable :: A_act(:,:)
      REAL, allocatable :: A_ref(:,:)
      REAL, allocatable :: XARRAY_act(:)
      REAL, allocatable :: XARRAY_ref(:)
      REAL, allocatable :: YARRAY_act(:)
      REAL, allocatable :: YARRAY_ref(:)

! allocation of working arrays...

      dim=size(R4_C)
      ALLOCATE(C_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_RCONTR -- C_act ALLOCATE error!')
      ALLOCATE(C_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_RCONTR -- C_ref ALLOCATE error!')

      dim2=size(R4_A,dim=2)
      ALLOCATE(A_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_RCONTR -- A_act ALLOCATE error!')
      ALLOCATE(A_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_RCONTR -- A_ref ALLOCATE error!')

      dim=size(R4_XARRAY)
      ALLOCATE(XARRAY_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_RCONTR -- XARRAY_act ALLOCATE error!')
      ALLOCATE(XARRAY_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_RCONTR -- XARRAY_ref ALLOCATE error!')

      dim=size(R4_YARRAY)
      ALLOCATE(YARRAY_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_RCONTR -- YARRAY_act ALLOCATE error!')
      ALLOCATE(YARRAY_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_RCONTR -- YARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      C_act=R4_C
      C_ref=R4_C

      A_act=R4_A
      A_ref=R4_A

      XARRAY_act=R4_XARRAY
      XARRAY_ref=R4_XARRAY

      YARRAY_act=R4_YARRAY
      YARRAY_ref=R4_YARRAY

! call to original routine:  RCONTR

      CALL RCONTR(
     > K1,C_act(1),K2,A_act(1,1),MAXA,XARRAY_act(1),IMIN,IMAX,ISTEP,
     > YARRAY_act(1),JMIN,JMAX,JSTEP)

! copy back outputs if modified.

      where(C_act.ne.C_ref)
         R4_C = C_act
      end where
      DEALLOCATE(C_act)
      DEALLOCATE(C_ref)

      where(A_act.ne.A_ref)
         R4_A = A_act
      end where
      DEALLOCATE(A_act)
      DEALLOCATE(A_ref)

      where(XARRAY_act.ne.XARRAY_ref)
         R4_XARRAY = XARRAY_act
      end where
      DEALLOCATE(XARRAY_act)
      DEALLOCATE(XARRAY_ref)

      where(YARRAY_act.ne.YARRAY_ref)
         R4_YARRAY = YARRAY_act
      end where
      DEALLOCATE(YARRAY_act)
      DEALLOCATE(YARRAY_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  CONTUR
      SUBROUTINE R4_CONTUR(
     > K1,R4_C,K2,R4_A,MAXA,R4_XARRAY,IMIN,IMAX,ISTEP,R4_YARRAY,JMIN,
     > JMAX,JSTEP)

      external CONTUR

! argument declarations
      INTEGER K1
      INTEGER K2
      INTEGER MAXA
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
 ! floating type, input/output:
      REAL R4_C(:)
  
 ! floating type, input/output:
      REAL R4_A(:,:)
  
 ! floating type, input/output:
      REAL R4_XARRAY(:,:)
  
 ! floating type, input/output:
      REAL R4_YARRAY(:,:)
  

! local (automatic array) declarations

      integer alloc_stat, dim, dim2
      REAL, allocatable :: C_act(:)
      REAL, allocatable :: C_ref(:)
      REAL, allocatable :: A_act(:,:)
      REAL, allocatable :: A_ref(:,:)
      REAL, allocatable :: XARRAY_act(:,:)
      REAL, allocatable :: XARRAY_ref(:,:)
      REAL, allocatable :: YARRAY_act(:,:)
      REAL, allocatable :: YARRAY_ref(:,:)

! allocation of working arrays...

      dim=size(R4_C)
      ALLOCATE(C_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CONTUR -- C_act ALLOCATE error!')
      ALLOCATE(C_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CONTUR -- C_ref ALLOCATE error!')

      dim2=size(R4_A,dim=2)
      ALLOCATE(A_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CONTUR -- A_act ALLOCATE error!')
      ALLOCATE(A_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CONTUR -- A_ref ALLOCATE error!')

      dim2=size(R4_XARRAY,dim=2)
      ALLOCATE(XARRAY_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CONTUR -- XARRAY_act ALLOCATE error!')
      ALLOCATE(XARRAY_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CONTUR -- XARRAY_ref ALLOCATE error!')

      dim2=size(R4_YARRAY,dim=2)
      ALLOCATE(YARRAY_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CONTUR -- YARRAY_act ALLOCATE error!')
      ALLOCATE(YARRAY_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CONTUR -- YARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      C_act=R4_C
      C_ref=R4_C

      A_act=R4_A
      A_ref=R4_A

      XARRAY_act=R4_XARRAY
      XARRAY_ref=R4_XARRAY

      YARRAY_act=R4_YARRAY
      YARRAY_ref=R4_YARRAY

! call to original routine:  CONTUR

      CALL CONTUR(
     > K1,C_act(1),K2,A_act(1,1),MAXA,XARRAY_act(1,1),IMIN,IMAX,ISTEP,
     > YARRAY_act(1,1),JMIN,JMAX,JSTEP)

! copy back outputs if modified.

      where(C_act.ne.C_ref)
         R4_C = C_act
      end where
      DEALLOCATE(C_act)
      DEALLOCATE(C_ref)

      where(A_act.ne.A_ref)
         R4_A = A_act
      end where
      DEALLOCATE(A_act)
      DEALLOCATE(A_ref)

      where(XARRAY_act.ne.XARRAY_ref)
         R4_XARRAY = XARRAY_act
      end where
      DEALLOCATE(XARRAY_act)
      DEALLOCATE(XARRAY_ref)

      where(YARRAY_act.ne.YARRAY_ref)
         R4_YARRAY = YARRAY_act
      end where
      DEALLOCATE(YARRAY_act)
      DEALLOCATE(YARRAY_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGCLXY
      SUBROUTINE R4_AGCLXY(
     > R4_XAR,NX,IMIN)

      external AGCLXY

! argument declarations
      INTEGER NX
      INTEGER IMIN
 ! floating type, input/output:
      REAL R4_XAR(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: XAR_act(:)
      REAL, allocatable :: XAR_ref(:)

! allocation of working arrays...

      dim=size(R4_XAR)
      ALLOCATE(XAR_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLXY -- XAR_act ALLOCATE error!')
      ALLOCATE(XAR_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCLXY -- XAR_ref ALLOCATE error!')

! executable code:  copy for input

      XAR_act=R4_XAR
      XAR_ref=R4_XAR

! call to original routine:  AGCLXY

      CALL AGCLXY(
     > XAR_act(1),NX,IMIN)

! copy back outputs if modified.

      where(XAR_act.ne.XAR_ref)
         R4_XAR = XAR_act
      end where
      DEALLOCATE(XAR_act)
      DEALLOCATE(XAR_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGCUSET
      SUBROUTINE R4_AGCUSET(
     > R4_XARRAY,R4_YARRAY,MAXA,NX,NY)

      external AGCUSET

! argument declarations
      INTEGER MAXA
      INTEGER NX
      INTEGER NY
 ! floating type, input/output:
      REAL R4_XARRAY(:,:)
  
 ! floating type, input/output:
      REAL R4_YARRAY(:,:)
  

! local (automatic array) declarations

      integer alloc_stat, dim2
      REAL, allocatable :: XARRAY_act(:,:)
      REAL, allocatable :: XARRAY_ref(:,:)
      REAL, allocatable :: YARRAY_act(:,:)
      REAL, allocatable :: YARRAY_ref(:,:)

! allocation of working arrays...

      dim2=size(R4_XARRAY,dim=2)
      ALLOCATE(XARRAY_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCUSET -- XARRAY_act ALLOCATE error!')
      ALLOCATE(XARRAY_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCUSET -- XARRAY_ref ALLOCATE error!')

      dim2=size(R4_YARRAY,dim=2)
      ALLOCATE(YARRAY_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCUSET -- YARRAY_act ALLOCATE error!')
      ALLOCATE(YARRAY_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCUSET -- YARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      XARRAY_act=R4_XARRAY
      XARRAY_ref=R4_XARRAY

      YARRAY_act=R4_YARRAY
      YARRAY_ref=R4_YARRAY

! call to original routine:  AGCUSET

      CALL AGCUSET(
     > XARRAY_act(1,1),YARRAY_act(1,1),MAXA,NX,NY)

! copy back outputs if modified.

      where(XARRAY_act.ne.XARRAY_ref)
         R4_XARRAY = XARRAY_act
      end where
      DEALLOCATE(XARRAY_act)
      DEALLOCATE(XARRAY_ref)

      where(YARRAY_act.ne.YARRAY_ref)
         R4_YARRAY = YARRAY_act
      end where
      DEALLOCATE(YARRAY_act)
      DEALLOCATE(YARRAY_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGCULEV
      SUBROUTINE R4_AGCULEV(
     > K1,R4_C,K2,R4_ZAR,NZ,R4_CL,NCL)

      external AGCULEV

! argument declarations
      INTEGER K1
      INTEGER K2
      INTEGER NZ
      INTEGER NCL
 ! floating type, input/output:
      REAL R4_C(:)
  
 ! floating type, input/output:
      REAL R4_ZAR(:)
  
 ! floating type, input/output:
      REAL R4_CL(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: C_act(:)
      REAL, allocatable :: C_ref(:)
      REAL, allocatable :: ZAR_act(:)
      REAL, allocatable :: ZAR_ref(:)
      REAL, allocatable :: CL_act(:)
      REAL, allocatable :: CL_ref(:)

! allocation of working arrays...

      dim=size(R4_C)
      ALLOCATE(C_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCULEV -- C_act ALLOCATE error!')
      ALLOCATE(C_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCULEV -- C_ref ALLOCATE error!')

      dim=size(R4_ZAR)
      ALLOCATE(ZAR_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCULEV -- ZAR_act ALLOCATE error!')
      ALLOCATE(ZAR_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCULEV -- ZAR_ref ALLOCATE error!')

      dim=size(R4_CL)
      ALLOCATE(CL_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCULEV -- CL_act ALLOCATE error!')
      ALLOCATE(CL_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCULEV -- CL_ref ALLOCATE error!')

! executable code:  copy for input

      C_act=R4_C
      C_ref=R4_C

      ZAR_act=R4_ZAR
      ZAR_ref=R4_ZAR

      CL_act=R4_CL
      CL_ref=R4_CL

! call to original routine:  AGCULEV

      CALL AGCULEV(
     > K1,C_act(1),K2,ZAR_act(1),NZ,CL_act(1),NCL)

! copy back outputs if modified.

      where(C_act.ne.C_ref)
         R4_C = C_act
      end where
      DEALLOCATE(C_act)
      DEALLOCATE(C_ref)

      where(ZAR_act.ne.ZAR_ref)
         R4_ZAR = ZAR_act
      end where
      DEALLOCATE(ZAR_act)
      DEALLOCATE(ZAR_ref)

      where(CL_act.ne.CL_ref)
         R4_CL = CL_act
      end where
      DEALLOCATE(CL_act)
      DEALLOCATE(CL_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGRCFR
      SUBROUTINE R4_AGRCFR(
     > R4_X,IMIN,IMAX,ISTEP,R4_Y,JMIN,JMAX,JSTEP,IGRID)

      external AGRCFR

! argument declarations
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
      INTEGER IGRID
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGRCFR -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGRCFR -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGRCFR -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGRCFR -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  AGRCFR

      CALL AGRCFR(
     > X_act(1),IMIN,IMAX,ISTEP,Y_act(1),JMIN,JMAX,JSTEP,IGRID)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGCFRAM
      SUBROUTINE R4_AGCFRAM(
     > R4_X,NX,R4_Y,NY,IGRID)

      external AGCFRAM

! argument declarations
      INTEGER NX
      INTEGER NY
      INTEGER IGRID
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCFRAM -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCFRAM -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCFRAM -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGCFRAM -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  AGCFRAM

      CALL AGCFRAM(
     > X_act(1),NX,Y_act(1),NY,IGRID)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end

C******************** START FILE UFJMSG.FOR ; GROUP UFILS0 ******************
C--------------------------------------------------------------------
C  UFJMSG
C   RETRIEVE INFORMATIVE AND ERROR MESSAGE OUTPUT LEVELS
C    SEE ROUTINES UFEMSG AND UFIMSG
C
C   *THIS ROUTINE HAS NO AFFECT ON OUTPUT OF ERROR MESSAGES*
C   *THIS ROUTINE HAS NO AFFECT ON OUTPUT OF INFORMATIVE MESSAGES*
C
C   IT JUST RETURNS THE CURRENTLY STORED MESSAGE LEVEL FLAGS
C   IN FORM THAT THEY MAY BE PASSED BACK INTO UFIMSG AND UFEMSG
C   ROUTINES AS ARGUMENTS
C
      SUBROUTINE UFJMSG(IILEV,IELEV)
C
C  OUTPUTS:
C   IILEV - INFORMATIONAL MSG LEVEL (CF ARGUMENT TO UFIMSG)
C   IELEV - ERROR MESSAGE LEVEL (CF ARGUMENT TO UFEMSG)
C
      USE UFILES
C
      CALL UFINIT
C
C  ONES DIGIT OF UFILEV IS INFORMATIONAL MESSAGE FLAG
C  TENS DIGIT OF UFILEV IS ERROR MESSAGE FLAG
C
      IELEV=UFILEV/10
      IILEV=UFILEV-10*IELEV
C
      RETURN
      END
C******************** END FILE UFJMSG.FOR ; GROUP UFILS0 ******************

C--------------------------------------------------------------------
C  GFTICL - DISPLAY CONTROL CODE VALUES / LIMITS
C
      SUBROUTINE GFTICL(ZOPC,ZSG,ZREM,IVALX,IVALY,IDFLT,IMIN,IMAX)
C
      CHARACTER*(*) ZREM
      CHARACTER*1 ZOPC
      CHARACTER*8 ZSG
C
      WRITE(LNOUT(0),1001) ZOPC,ZSG,IVALX,IVALY,IDFLT,IMIN,IMAX,ZREM
 1001   FORMAT(
     >1X,A1,2X,A8,3X,I2,2X,I2,2X,I2,7X,I2,3X,I2,3X,A)
C
      RETURN
      END

C******************** START FILE URECHO.FOR ; GROUP UREAD5 ******************
C------------------------------------------------------
C& URECHO  ECHO LINE READ TO OUTPUT FILE AND/OR TTY
C  IF FLAGS ARE SET
C
      SUBROUTINE URECHO(INPUTL)
      USE USERIO
C
C
C  ECHO LINE TO INDIRECT OUTPUT FILE IF IT IS USER INPUT
C  AND IF WE ARE MAKING AN INDIRECT OUTPUT FILE
C
C  AND IF A LINE WAS READ IN ON THIS CALL TO UREAD
C
      ICHARC=MAX0(1,NCHARC)
C
      IF((.NOT.NLINDI).AND.(NLINDO).AND.(INPUTL.EQ.1)) THEN
        WRITE(LUNIDO,5000) CBUFF(1:ICHARC)
 5000   FORMAT(A)
        call fort_flush(lunido)
      ENDIF

C  ECHO LINE TO TERMINAL IF FLAG IS SET
      IF(NLECHO.AND.(.NOT.NLSKIP)) THEN
        WRITE(LUNTRM,5001) CBUFF(1:ICHARC)
 5001   FORMAT(1X,A)
        call fort_flush(luntrm)
      ENDIF

      RETURN
      END
C******************** END FILE URECHO.FOR ; GROUP UREAD5 ******************

C******************** START FILE CONLBL.FOR ; GROUP CONCTR ******************
C=============================================================
C  CONLBL     D. MC CUNE  23-MAY-1980
C
C  LABEL A CONTOUR PLOT.
C   (1) MARK CONTOURS THEMSELVES (PRESUMED ALREADY DRAWN)
C       WITH PASSED CHARACTER CODE
C   (2) GENERATE KEY RELATING CONTOUR CHARACTER CODES TO
C       NUMERIC VALUE OF CONTOUR
C   (3) LABEL X, Y, AXIS AND UNITS, FUNCTION CONTOUR-PLOTTED,
C       AND THE RUN #
C
C  ARGUMENTS:
C   X(NX)     X-AXIS INDEP. VARIABLE ARRAY
C   Z(NZ1,NY) FUNCTION BEING PLOTTED
C   Y(NY)     Y-AXIS INDEP. VARIABLE ARRAY
C   NX,NZ1,NY ARRAY DIMENSIONS
C   XLAB      CHAR LABEL FOR X-AXIS VARIABLE
C   ZLAB      CHAR LABEL FOR FUNCTION
C   YLAB      CHAR LABEL FOR Y-AXIS VARIABLE
C   XUN       CHAR UNITS FOR X
C   ZUN       CHAR UNITS FOR FUNCTION
C   YUN       CHAR UNITS FOR Y
C   RLAB      CHAR LABEL FOR RUN
C   IINT      FUNCTION INTEGRATION CODE: 0  - NOT INTEGRATED
C            				 1  - VOL. INTEGRATED
C    					 2  - FLUX INTEGRATED
C					 3  - AREA INTEGRATED
C   ISMOO    ISMOO=1 MEANS DATA HAS BEEN SMOOTHED
C   ZCNTR     LOCATION (FUNCTION UNITS) OF CONTOURS
C   ACNTR     1-CHAR IDENTIFICATION CODE, UNIQUE FOR EACH CONTOUR
C   NC        # OF CONTOURS
C  NPAGE-- PAGE # WITH WHICH TO LABEL GRAPH (FIRST INCREMENT)
C=========
C
      SUBROUTINE CONLBL(X,Z,Y,NX,NZ1,NY,XLAB,ZLAB,YLAB,
     >              XUN,ZUN,YUN,RLAB,IINT,ISMOO,ZCNTR,ACNTR,NC,NPAGE)
C
C  LOCAL DECLARATIONS
      PARAMETER (NSUP0=8)
      PARAMETER (NCY0=1)
C   PASSED ARGS:
      DIMENSION X(NX),Z(NZ1,NY),Y(NY),ZCNTR(NC)
      CHARACTER*(*) XLAB,ZLAB,YLAB,XUN,YUN,ZUN,RLAB
      CHARACTER*1 ACNTR(NC)
C  LOCAL
C
      DIMENSION YFIX(NSUP0)
      INTEGER INDY(NSUP0)
      CHARACTER*10 ZBL10,ZSMLAB
      CHARACTER*12 ZENCOD
      CHARACTER*75 MNLAB,MNLAB2
c
c
      DIMENSION IOFFL(5)
C
      DATA ZSMLAB/' SMOOTHED '/
      DATA ZBL10/'          '/
C
C  INCLUDE INTEGRATION LABELS
C
      INCLUDE 'INTLAB'
C     
C  START OF EXECUTABLE CODE
C
C  (1)  MARK CONTOURS
C     ALG:  SEVERAL LINES OF CONST. Y ARE CHOSEN;
C          THE INTERSECTION OF Z WITH CONTOURS ALONG THESE
C          LINES ARE CALCULATED; EVERY NCY'TH SUCH INTERSECTION
C          IS MARKED WITH THE LETTER CODE FOR THE CONTOUR
C          INTERSECTED
C
      IF(NY.LE.1) RETURN
      IF(NY.LT.(NSUP0+2)) GO TO 5
      J0=2
      JL=NY-1
      JN=NY-2
      GO TO 10
 5    CONTINUE
      J0=1
      JL=NY
      JN=NY
 10   CONTINUE
C  NSUP= # OF LINES OF CONST. Y
C  NCY=  1+ # OF CONTOURS TO SKIP BETWEEN MARKED CONTOURS
      NSUP=MIN0(NSUP0,JN)
      NCY=MIN0(NCY0,NSUP)
C
      DELY=Y(JL)-Y(J0)
      YFIX(1)=Y(J0)
      YINTVL=DELY/(NSUP-1)
      DO 20 I=2,NSUP
        IM1=I-1
        YFIX(I)=YFIX(IM1)+YINTVL
 20   CONTINUE
C  FIND INDICES TO SET OF LINES OF CONST Y
      CALL LMVRTI(Y(J0),Y(JL),J0,JL,YFIX,INDY,NSUP)
C
C  MARK EVERY NCY'TH CONTOUR ALONG EACH LINE OF CONST. Y
C
      ISKIP0=1
      DO 50 IROW=1,NSUP
        ISKIP0=ISKIP0-1
        IF(ISKIP0.LT.0) ISKIP0=NCY-1
        X0=X(1)
        Z0=Z(1,INDY(IROW))
        ISKIP=ISKIP0
C
C  START OF LOOP FOR A SINGLE LINE
 40     CONTINUE
          IF(X0.GE.X(NX)) GO TO 50
C  FIND NEXT CONTOUR INTERCEPT
          CALL FNEXC(X,Z(1,INDY(IROW)),NX,ZCNTR,NC,X0,Z0,IRET)
          IF(IRET.EQ.0) GO TO 40
          ISKIP=ISKIP-1
          IF(ISKIP.GE.0) GO TO 40
          ISKIP=NCY-1
          CALL PUTCHR(X0,Y(INDY(IROW)),ACNTR(IRET))
        GO TO 40
 50   CONTINUE
C
C  (2)   GENERATE KEY TO EQUATE CONTOUR CHARACTER SYMBOLS
C        TO NUMERIC VALUES
C
C  DRAW KEY FRAME
      IX1=750
      IX2=1000
      IY1=125
      IY2=700
      IYL=IY2
      IXL=IX1+20
      IDY=28
C
      CALL DPLOFR(IX1,IX2,IY1,IY2,0)
C
      IYL=IYL-IDY
      CALL GRFLBL(IXL,IYL,'CONTOURS:',16,0,0)
C
      IYL=IYL-IDY
      CALL GRFLBL(IXL,IYL,ZUN,16,0,0)
C
      DO 70 IJ=1,NC
        WRITE(ZENCOD,7003) ZCNTR(IJ)
 7003 FORMAT(1PE11.4,1X)
        IYL=IYL-IDY
        CALL GRFLBL(IXL,IYL,ACNTR(IJ)//' = '//ZENCOD,16,0,0)
 70   CONTINUE
C
C  (3)  LABEL X,Y AXES
C
      CALL GRFLBL(800,70,XUN,0,-1,0)
C
      CALL GRFLBL(30,680,YUN,0,-1,1)
C
      IJINT=1
      IF(IINT.GT.0) IJINT=2
      JINT=max(1,(IINT+5))
C
      MNLAB=trim(ZLINT(JINT))//' '//trim(ZLAB)//' VS '//
     >   trim(XLAB)//' & '//trim(YLAB)
      CALL GRFLBL(50,18,MNLAB,0,0,0)
C
C  INCREMENT AND LABEL PAGE #
      NPAGE=NPAGE+1
      ilrlab=min(38,len_trim(rlab))
      IF(ISMOO.NE.1) WRITE(MNLAB2,8007) RLAB(1:ILRLAB),ZBL10,NPAGE
      IF(ISMOO.EQ.1) WRITE(MNLAB2,8007) RLAB(1:ILRLAB),ZSMLAB,NPAGE
 8007 FORMAT(A,1X,A,1X,'page ',I4,1X)
      CALL GRFLBL(150,727,MNLAB2,0,0,0)
C
      RETURN
      END
C******************** END FILE CONLBL.FOR ; GROUP CONCTR ******************

!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCLINS
      SUBROUTINE R8_AGCLINS(
     > R8_ZDATA,MXD,R8_X,NX,R8_Y,NY,R8_CL,NCL)

      implicit none
      external AGCLINS

! argument declarations
      INTEGER MXD
      INTEGER NX
      INTEGER NY
      INTEGER NCL

! >>> from sgnco_mod
      integer   :: nlm
      parameter (nlm=40)
  
 ! floating type, input/output:
      REAL*8 R8_ZDATA(:,:)
  
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  
 ! floating type, input/output:
      REAL*8 R8_CL(NLM)
  

! local (automatic array) declarations

      integer alloc_stat, dim, dim2
      REAL, allocatable :: ZDATA_act(:,:)
      REAL, allocatable :: ZDATA_ref(:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: CL_act(:)
      REAL, allocatable :: CL_ref(:)

! allocation of working arrays...

      dim2=size(R8_ZDATA,dim=2)
      ALLOCATE(ZDATA_act(MXD,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLINS -- ZDATA_act ALLOCATE error!')
      ALLOCATE(ZDATA_ref(MXD,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLINS -- ZDATA_ref ALLOCATE error!')

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLINS -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLINS -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLINS -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLINS -- Y_ref ALLOCATE error!')

      ALLOCATE(CL_act(NLM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLINS -- CL_act ALLOCATE error!')
      ALLOCATE(CL_ref(NLM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLINS -- CL_ref ALLOCATE error!')

! executable code:  copy for input

      ZDATA_act=R8_ZDATA
      ZDATA_ref=R8_ZDATA

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      CL_act=R8_CL
      CL_ref=R8_CL

! call to original routine:  AGCLINS

      CALL AGCLINS(
     > ZDATA_act(1,1),MXD,X_act(1),NX,Y_act(1),NY,CL_act(1),NCL)

! copy back outputs if modified.

      where(ZDATA_act.ne.ZDATA_ref)
         R8_ZDATA = ZDATA_act
      end where
      DEALLOCATE(ZDATA_act)
      DEALLOCATE(ZDATA_ref)

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(CL_act.ne.CL_ref)
         R8_CL = CL_act
      end where
      DEALLOCATE(CL_act)
      DEALLOCATE(CL_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCLGEN
      SUBROUTINE R8_AGCLGEN(
     > R8_Z,MXD,NX,NY,R8_CCLO,R8_CHI,R8_CINC,R8_CL,NCL,ICNST)

      external AGCLGEN

!
      integer   nlm
      parameter (nlm=40)

! argument declarations
      INTEGER MXD
      INTEGER NX
      INTEGER NY
 ! floating type, input/output:
      REAL*8 R8_CCLO
  
 ! floating type, input/output:
      REAL*8 R8_CHI
  
 ! floating type, input/output:
      REAL*8 R8_CINC
  
      INTEGER NCL
      INTEGER ICNST
 ! floating type, input/output:
      REAL*8 R8_Z(MXD,NY)
  
 ! floating type, input/output:
      REAL*8 R8_CL(NLM)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: Z_act(:,:)
      REAL, allocatable :: Z_ref(:,:)
      REAL :: CCLO_act
      REAL :: CCLO_ref
      REAL :: CHI_act
      REAL :: CHI_ref
      REAL :: CINC_act
      REAL :: CINC_ref
      REAL, allocatable :: CL_act(:)
      REAL, allocatable :: CL_ref(:)

! allocation of working arrays...

      ALLOCATE(Z_act(MXD,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLGEN -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(MXD,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLGEN -- Z_ref ALLOCATE error!')
      ALLOCATE(CL_act(NLM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLGEN -- CL_act ALLOCATE error!')
      ALLOCATE(CL_ref(NLM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLGEN -- CL_ref ALLOCATE error!')

! executable code:  copy for input

      Z_act=R8_Z
      Z_ref=R8_Z

      CCLO_act=R8_CCLO
      CCLO_ref=R8_CCLO

      CHI_act=R8_CHI
      CHI_ref=R8_CHI

      CINC_act=R8_CINC
      CINC_ref=R8_CINC

      CL_act=R8_CL
      CL_ref=R8_CL

! call to original routine:  AGCLGEN

      CALL AGCLGEN(
     > Z_act(1,1),MXD,NX,NY,CCLO_act,CHI_act,CINC_act,CL_act(1),NCL,
     > ICNST)

! copy back outputs if modified.

      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)

      if(CCLO_act.ne.CCLO_ref) then
         R8_CCLO = CCLO_act
      endif

      if(CHI_act.ne.CHI_ref) then
         R8_CHI = CHI_act
      endif

      if(CINC_act.ne.CINC_ref) then
         R8_CINC = CINC_act
      endif

      where(CL_act.ne.CL_ref)
         R8_CL = CL_act
      end where
      DEALLOCATE(CL_act)
      DEALLOCATE(CL_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCSTLN
      SUBROUTINE R8_AGCSTLN(
     > R8_Z,LL,MM,NN,R8_CONV,IR)

      external AGCSTLN

! argument declarations
      INTEGER LL
      INTEGER MM
      INTEGER NN
 ! floating type, input/output:
      REAL*8 R8_CONV
  
 ! floating type, input/output:
      REAL*8 R8_Z(LL,NN)
  
      INTEGER IR(*)

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: Z_act(:,:)
      REAL, allocatable :: Z_ref(:,:)
      REAL :: CONV_act
      REAL :: CONV_ref

! allocation of working arrays...

      ALLOCATE(Z_act(LL,NN)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCSTLN -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(LL,NN)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCSTLN -- Z_ref ALLOCATE error!')

! executable code:  copy for input

      Z_act=R8_Z
      Z_ref=R8_Z

      CONV_act=R8_CONV
      CONV_ref=R8_CONV

! call to original routine:  AGCSTLN

      CALL AGCSTLN(
     > Z_act(1,1),LL,MM,NN,CONV_act,IR)

! copy back outputs if modified.

      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)

      if(CONV_act.ne.CONV_ref) then
         R8_CONV = CONV_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCDRLN
      SUBROUTINE R8_AGCDRLN(
     > R8_Z,L,MM,NN,IR)

      external AGCDRLN

! argument declarations
      INTEGER L
      INTEGER MM
      INTEGER NN
 ! floating type, input/output:
      REAL*8 R8_Z(L,NN)
  
      INTEGER IR(*)

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: Z_act(:,:)
      REAL, allocatable :: Z_ref(:,:)

! allocation of working arrays...

      ALLOCATE(Z_act(L,NN)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCDRLN -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(L,NN)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCDRLN -- Z_ref ALLOCATE error!')

! executable code:  copy for input

      Z_act=R8_Z
      Z_ref=R8_Z

! call to original routine:  AGCDRLN

      CALL AGCDRLN(
     > Z_act(1,1),L,MM,NN,IR)

! copy back outputs if modified.

      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCXGET
      SUBROUTINE R8_AGCXGET(
     > R8_XIND,R8_FXX,R8_X,NXS)

      external AGCXGET

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_XIND
  
 ! floating type, input/output:
      REAL*8 R8_FXX
  
      INTEGER NXS
 ! floating type, input/output:
      REAL*8 R8_X(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL :: XIND_act
      REAL :: XIND_ref
      REAL :: FXX_act
      REAL :: FXX_ref
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCXGET -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCXGET -- X_ref ALLOCATE error!')

! executable code:  copy for input

      XIND_act=R8_XIND
      XIND_ref=R8_XIND

      FXX_act=R8_FXX
      FXX_ref=R8_FXX

      X_act=R8_X
      X_ref=R8_X

! call to original routine:  AGCXGET

      CALL AGCXGET(
     > XIND_act,FXX_act,X_act(1),NXS)

! copy back outputs if modified.

      if(XIND_act.ne.XIND_ref) then
         R8_XIND = XIND_act
      endif

      if(FXX_act.ne.FXX_ref) then
         R8_FXX = FXX_act
      endif

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCYGET
      SUBROUTINE R8_AGCYGET(
     > R8_YIND,R8_FYY,R8_Y,NYS)

      external AGCYGET

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_YIND
  
 ! floating type, input/output:
      REAL*8 R8_FYY
  
      INTEGER NYS
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL :: YIND_act
      REAL :: YIND_ref
      REAL :: FYY_act
      REAL :: FYY_ref
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCYGET -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCYGET -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      YIND_act=R8_YIND
      YIND_ref=R8_YIND

      FYY_act=R8_FYY
      FYY_ref=R8_FYY

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  AGCYGET

      CALL AGCYGET(
     > YIND_act,FYY_act,Y_act(1),NYS)

! copy back outputs if modified.

      if(YIND_act.ne.YIND_ref) then
         R8_YIND = YIND_act
      endif

      if(FYY_act.ne.FYY_ref) then
         R8_FYY = FYY_act
      endif

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCFRST
      SUBROUTINE R8_AGCFRST(
     > R8_X,R8_Y)

      external AGCFRST

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  AGCFRST

      CALL AGCFRST(
     > X_act,Y_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCPLST
      SUBROUTINE R8_AGCPLST(
     > R8_PL1,R8_PL2,KPL,R8_X,R8_Y)

      external AGCPLST

! argument declarations
      INTEGER KPL
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
 ! floating type, input/output:
      REAL*8 R8_PL1(:)
  
 ! floating type, input/output:
      REAL*8 R8_PL2(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: PL1_act(:)
      REAL, allocatable :: PL1_ref(:)
      REAL, allocatable :: PL2_act(:)
      REAL, allocatable :: PL2_ref(:)
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...

      dim=size(R8_PL1)
      ALLOCATE(PL1_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCPLST -- PL1_act ALLOCATE error!')
      ALLOCATE(PL1_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCPLST -- PL1_ref ALLOCATE error!')

      dim=size(R8_PL2)
      ALLOCATE(PL2_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCPLST -- PL2_act ALLOCATE error!')
      ALLOCATE(PL2_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCPLST -- PL2_ref ALLOCATE error!')

! executable code:  copy for input

      PL1_act=R8_PL1
      PL1_ref=R8_PL1

      PL2_act=R8_PL2
      PL2_ref=R8_PL2

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  AGCPLST

      CALL AGCPLST(
     > PL1_act(1),PL2_act(1),KPL,X_act,Y_act)

! copy back outputs if modified.

      where(PL1_act.ne.PL1_ref)
         R8_PL1 = PL1_act
      end where
      DEALLOCATE(PL1_act)
      DEALLOCATE(PL1_ref)

      where(PL2_act.ne.PL2_ref)
         R8_PL2 = PL2_act
      end where
      DEALLOCATE(PL2_act)
      DEALLOCATE(PL2_ref)

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGNCOF
      SUBROUTINE R8_AGNCOF(
     > R8_XCS,R8_YCS,NCS,IAI,IAG,NAI)

      external AGNCOF

! argument declarations
      INTEGER NCS
      INTEGER NAI
 ! floating type, input/output:
      REAL*8 R8_XCS(:)
  
 ! floating type, input/output:
      REAL*8 R8_YCS(:)
  
      INTEGER IAI(*)
      INTEGER IAG(*)

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: XCS_act(:)
      REAL, allocatable :: XCS_ref(:)
      REAL, allocatable :: YCS_act(:)
      REAL, allocatable :: YCS_ref(:)

! allocation of working arrays...

      dim=size(R8_XCS)
      ALLOCATE(XCS_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGNCOF -- XCS_act ALLOCATE error!')
      ALLOCATE(XCS_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGNCOF -- XCS_ref ALLOCATE error!')

      dim=size(R8_YCS)
      ALLOCATE(YCS_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGNCOF -- YCS_act ALLOCATE error!')
      ALLOCATE(YCS_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGNCOF -- YCS_ref ALLOCATE error!')

! executable code:  copy for input

      XCS_act=R8_XCS
      XCS_ref=R8_XCS

      YCS_act=R8_YCS
      YCS_ref=R8_YCS

! call to original routine:  AGNCOF

      CALL AGNCOF(
     > XCS_act(1),YCS_act(1),NCS,IAI,IAG,NAI)

! copy back outputs if modified.

      where(XCS_act.ne.XCS_ref)
         R8_XCS = XCS_act
      end where
      DEALLOCATE(XCS_act)
      DEALLOCATE(XCS_ref)

      where(YCS_act.ne.YCS_ref)
         R8_YCS = YCS_act
      end where
      DEALLOCATE(YCS_act)
      DEALLOCATE(YCS_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCUTRN
      SUBROUTINE R8_AGCUTRN(
     > UFXY,R8_X,R8_Y,R8_FXX,R8_FYY)

      external AGCUTRN

! argument declarations
      INTEGER UFXY
      EXTERNAL UFXY
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
 ! floating type, input/output:
      REAL*8 R8_FXX
  
 ! floating type, input/output:
      REAL*8 R8_FYY
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref
      REAL :: FXX_act
      REAL :: FXX_ref
      REAL :: FYY_act
      REAL :: FYY_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      FXX_act=R8_FXX
      FXX_ref=R8_FXX

      FYY_act=R8_FYY
      FYY_ref=R8_FYY

! call to original routine:  AGCUTRN

      CALL AGCUTRN(
     > UFXY,X_act,Y_act,FXX_act,FYY_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

      if(FXX_act.ne.FXX_ref) then
         R8_FXX = FXX_act
      endif

      if(FYY_act.ne.FYY_ref) then
         R8_FYY = FYY_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  RCONTR
      SUBROUTINE R8_RCONTR(
     > K1,R8_C,K2,R8_A,MAXA,R8_XARRAY,IMIN,IMAX,ISTEP,R8_YARRAY,JMIN,
     > JMAX,JSTEP)

      external RCONTR

! argument declarations
      INTEGER K1
      INTEGER K2
      INTEGER MAXA
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
 ! floating type, input/output:
      REAL*8 R8_C(:)
  
 ! floating type, input/output:
      REAL*8 R8_A(:,:)
  
 ! floating type, input/output:
      REAL*8 R8_XARRAY(:)
  
 ! floating type, input/output:
      REAL*8 R8_YARRAY(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim, dim2
      REAL, allocatable :: C_act(:)
      REAL, allocatable :: C_ref(:)
      REAL, allocatable :: A_act(:,:)
      REAL, allocatable :: A_ref(:,:)
      REAL, allocatable :: XARRAY_act(:)
      REAL, allocatable :: XARRAY_ref(:)
      REAL, allocatable :: YARRAY_act(:)
      REAL, allocatable :: YARRAY_ref(:)

! allocation of working arrays...

      dim=size(R8_C)
      ALLOCATE(C_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RCONTR -- C_act ALLOCATE error!')
      ALLOCATE(C_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RCONTR -- C_ref ALLOCATE error!')

      dim2=size(R8_A,dim=2)
      ALLOCATE(A_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RCONTR -- A_act ALLOCATE error!')
      ALLOCATE(A_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RCONTR -- A_ref ALLOCATE error!')

      dim=size(R8_XARRAY)
      ALLOCATE(XARRAY_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RCONTR -- XARRAY_act ALLOCATE error!')
      ALLOCATE(XARRAY_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RCONTR -- XARRAY_ref ALLOCATE error!')

      dim=size(R8_YARRAY)
      ALLOCATE(YARRAY_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RCONTR -- YARRAY_act ALLOCATE error!')
      ALLOCATE(YARRAY_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RCONTR -- YARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      C_act=R8_C
      C_ref=R8_C

      A_act=R8_A
      A_ref=R8_A

      XARRAY_act=R8_XARRAY
      XARRAY_ref=R8_XARRAY

      YARRAY_act=R8_YARRAY
      YARRAY_ref=R8_YARRAY

! call to original routine:  RCONTR

      CALL RCONTR(
     > K1,C_act(1),K2,A_act(1,1),MAXA,XARRAY_act(1),IMIN,IMAX,ISTEP,
     > YARRAY_act(1),JMIN,JMAX,JSTEP)

! copy back outputs if modified.

      where(C_act.ne.C_ref)
         R8_C = C_act
      end where
      DEALLOCATE(C_act)
      DEALLOCATE(C_ref)

      where(A_act.ne.A_ref)
         R8_A = A_act
      end where
      DEALLOCATE(A_act)
      DEALLOCATE(A_ref)

      where(XARRAY_act.ne.XARRAY_ref)
         R8_XARRAY = XARRAY_act
      end where
      DEALLOCATE(XARRAY_act)
      DEALLOCATE(XARRAY_ref)

      where(YARRAY_act.ne.YARRAY_ref)
         R8_YARRAY = YARRAY_act
      end where
      DEALLOCATE(YARRAY_act)
      DEALLOCATE(YARRAY_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  CONTUR
      SUBROUTINE R8_CONTUR(
     > K1,R8_C,K2,R8_A,MAXA,R8_XARRAY,IMIN,IMAX,ISTEP,R8_YARRAY,JMIN,
     > JMAX,JSTEP)

      external CONTUR

! argument declarations
      INTEGER K1
      INTEGER K2
      INTEGER MAXA
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
 ! floating type, input/output:
      REAL*8 R8_C(:)
  
 ! floating type, input/output:
      REAL*8 R8_A(:,:)
  
 ! floating type, input/output:
      REAL*8 R8_XARRAY(:,:)
  
 ! floating type, input/output:
      REAL*8 R8_YARRAY(:,:)
  

! local (automatic array) declarations

      integer alloc_stat, dim, dim2
      REAL, allocatable :: C_act(:)
      REAL, allocatable :: C_ref(:)
      REAL, allocatable :: A_act(:,:)
      REAL, allocatable :: A_ref(:,:)
      REAL, allocatable :: XARRAY_act(:,:)
      REAL, allocatable :: XARRAY_ref(:,:)
      REAL, allocatable :: YARRAY_act(:,:)
      REAL, allocatable :: YARRAY_ref(:,:)

! allocation of working arrays...

      dim=size(R8_C)
      ALLOCATE(C_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CONTUR -- C_act ALLOCATE error!')
      ALLOCATE(C_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CONTUR -- C_ref ALLOCATE error!')

      dim2=size(R8_A,dim=2)
      ALLOCATE(A_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CONTUR -- A_act ALLOCATE error!')
      ALLOCATE(A_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CONTUR -- A_ref ALLOCATE error!')

      dim2=size(R8_XARRAY,dim=2)
      ALLOCATE(XARRAY_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CONTUR -- XARRAY_act ALLOCATE error!')
      ALLOCATE(XARRAY_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CONTUR -- XARRAY_ref ALLOCATE error!')

      dim2=size(R8_YARRAY,dim=2)
      ALLOCATE(YARRAY_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CONTUR -- YARRAY_act ALLOCATE error!')
      ALLOCATE(YARRAY_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CONTUR -- YARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      C_act=R8_C
      C_ref=R8_C

      A_act=R8_A
      A_ref=R8_A

      XARRAY_act=R8_XARRAY
      XARRAY_ref=R8_XARRAY

      YARRAY_act=R8_YARRAY
      YARRAY_ref=R8_YARRAY

! call to original routine:  CONTUR

      CALL CONTUR(
     > K1,C_act(1),K2,A_act(1,1),MAXA,XARRAY_act(1,1),IMIN,IMAX,ISTEP,
     > YARRAY_act(1,1),JMIN,JMAX,JSTEP)

! copy back outputs if modified.

      where(C_act.ne.C_ref)
         R8_C = C_act
      end where
      DEALLOCATE(C_act)
      DEALLOCATE(C_ref)

      where(A_act.ne.A_ref)
         R8_A = A_act
      end where
      DEALLOCATE(A_act)
      DEALLOCATE(A_ref)

      where(XARRAY_act.ne.XARRAY_ref)
         R8_XARRAY = XARRAY_act
      end where
      DEALLOCATE(XARRAY_act)
      DEALLOCATE(XARRAY_ref)

      where(YARRAY_act.ne.YARRAY_ref)
         R8_YARRAY = YARRAY_act
      end where
      DEALLOCATE(YARRAY_act)
      DEALLOCATE(YARRAY_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCLXY
      SUBROUTINE R8_AGCLXY(
     > R8_XAR,NX,IMIN)

      external AGCLXY

! argument declarations
      INTEGER NX
      INTEGER IMIN
 ! floating type, input/output:
      REAL*8 R8_XAR(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: XAR_act(:)
      REAL, allocatable :: XAR_ref(:)

! allocation of working arrays...

      dim=size(R8_XAR)
      ALLOCATE(XAR_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLXY -- XAR_act ALLOCATE error!')
      ALLOCATE(XAR_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCLXY -- XAR_ref ALLOCATE error!')

! executable code:  copy for input

      XAR_act=R8_XAR
      XAR_ref=R8_XAR

! call to original routine:  AGCLXY

      CALL AGCLXY(
     > XAR_act(1),NX,IMIN)

! copy back outputs if modified.

      where(XAR_act.ne.XAR_ref)
         R8_XAR = XAR_act
      end where
      DEALLOCATE(XAR_act)
      DEALLOCATE(XAR_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCUSET
      SUBROUTINE R8_AGCUSET(
     > R8_XARRAY,R8_YARRAY,MAXA,NX,NY)

      external AGCUSET

! argument declarations
      INTEGER MAXA
      INTEGER NX
      INTEGER NY
 ! floating type, input/output:
      REAL*8 R8_XARRAY(:,:)
  
 ! floating type, input/output:
      REAL*8 R8_YARRAY(:,:)
  

! local (automatic array) declarations

      integer alloc_stat, dim2
      REAL, allocatable :: XARRAY_act(:,:)
      REAL, allocatable :: XARRAY_ref(:,:)
      REAL, allocatable :: YARRAY_act(:,:)
      REAL, allocatable :: YARRAY_ref(:,:)

! allocation of working arrays...

      dim2=size(R8_XARRAY,dim=2)
      ALLOCATE(XARRAY_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCUSET -- XARRAY_act ALLOCATE error!')
      ALLOCATE(XARRAY_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCUSET -- XARRAY_ref ALLOCATE error!')

      dim2=size(R8_YARRAY,dim=2)
      ALLOCATE(YARRAY_act(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCUSET -- YARRAY_act ALLOCATE error!')
      ALLOCATE(YARRAY_ref(MAXA,dim2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCUSET -- YARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      XARRAY_act=R8_XARRAY
      XARRAY_ref=R8_XARRAY

      YARRAY_act=R8_YARRAY
      YARRAY_ref=R8_YARRAY

! call to original routine:  AGCUSET

      CALL AGCUSET(
     > XARRAY_act(1,1),YARRAY_act(1,1),MAXA,NX,NY)

! copy back outputs if modified.

      where(XARRAY_act.ne.XARRAY_ref)
         R8_XARRAY = XARRAY_act
      end where
      DEALLOCATE(XARRAY_act)
      DEALLOCATE(XARRAY_ref)

      where(YARRAY_act.ne.YARRAY_ref)
         R8_YARRAY = YARRAY_act
      end where
      DEALLOCATE(YARRAY_act)
      DEALLOCATE(YARRAY_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCUXYI
      SUBROUTINE R8_AGCUXYI(
     > R8_XARRAY,R8_YARRAY,MAXA,NX,NY,R8_XRAW,R8_YRAW,R8_XDAT,R8_YDAT)

      external AGCUXYI

! argument declarations
      INTEGER MAXA
      INTEGER NX
      INTEGER NY
 ! floating type, input/output:
      REAL*8 R8_XRAW
  
 ! floating type, input/output:
      REAL*8 R8_YRAW
  
 ! floating type, input/output:
      REAL*8 R8_XDAT
  
 ! floating type, input/output:
      REAL*8 R8_YDAT
  
 ! floating type, input/output:
      REAL*8 R8_XARRAY(MAXA,NX)
  
 ! floating type, input/output:
      REAL*8 R8_YARRAY(MAXA,NY)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: XARRAY_act(:,:)
      REAL, allocatable :: XARRAY_ref(:,:)
      REAL, allocatable :: YARRAY_act(:,:)
      REAL, allocatable :: YARRAY_ref(:,:)
      REAL :: XRAW_act
      REAL :: XRAW_ref
      REAL :: YRAW_act
      REAL :: YRAW_ref
      REAL :: XDAT_act
      REAL :: XDAT_ref
      REAL :: YDAT_act
      REAL :: YDAT_ref

! allocation of working arrays...

      ALLOCATE(XARRAY_act(MAXA,NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCUXYI -- XARRAY_act ALLOCATE error!')
      ALLOCATE(XARRAY_ref(MAXA,NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCUXYI -- XARRAY_ref ALLOCATE error!')
      ALLOCATE(YARRAY_act(MAXA,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCUXYI -- YARRAY_act ALLOCATE error!')
      ALLOCATE(YARRAY_ref(MAXA,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCUXYI -- YARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      XARRAY_act=R8_XARRAY
      XARRAY_ref=R8_XARRAY

      YARRAY_act=R8_YARRAY
      YARRAY_ref=R8_YARRAY

      XRAW_act=R8_XRAW
      XRAW_ref=R8_XRAW

      YRAW_act=R8_YRAW
      YRAW_ref=R8_YRAW

      XDAT_act=R8_XDAT
      XDAT_ref=R8_XDAT

      YDAT_act=R8_YDAT
      YDAT_ref=R8_YDAT

! call to original routine:  AGCUXYI

      CALL AGCUXYI(
     > XARRAY_act(1,1),YARRAY_act(1,1),MAXA,NX,NY,XRAW_act,YRAW_act,
     > XDAT_act,YDAT_act)

! copy back outputs if modified.

      where(XARRAY_act.ne.XARRAY_ref)
         R8_XARRAY = XARRAY_act
      end where
      DEALLOCATE(XARRAY_act)
      DEALLOCATE(XARRAY_ref)

      where(YARRAY_act.ne.YARRAY_ref)
         R8_YARRAY = YARRAY_act
      end where
      DEALLOCATE(YARRAY_act)
      DEALLOCATE(YARRAY_ref)

      if(XRAW_act.ne.XRAW_ref) then
         R8_XRAW = XRAW_act
      endif

      if(YRAW_act.ne.YRAW_ref) then
         R8_YRAW = YRAW_act
      endif

      if(XDAT_act.ne.XDAT_ref) then
         R8_XDAT = XDAT_act
      endif

      if(YDAT_act.ne.YDAT_ref) then
         R8_YDAT = YDAT_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCULEV
      SUBROUTINE R8_AGCULEV(
     > K1,R8_C,K2,R8_ZAR,NZ,R8_CL,NCL)

      external AGCULEV

! argument declarations
      INTEGER K1
      INTEGER K2
      INTEGER NZ
      INTEGER NCL
 ! floating type, input/output:
      REAL*8 R8_C(:)
  
 ! floating type, input/output:
      REAL*8 R8_ZAR(:)
  
 ! floating type, input/output:
      REAL*8 R8_CL(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: C_act(:)
      REAL, allocatable :: C_ref(:)
      REAL, allocatable :: ZAR_act(:)
      REAL, allocatable :: ZAR_ref(:)
      REAL, allocatable :: CL_act(:)
      REAL, allocatable :: CL_ref(:)

! allocation of working arrays...

      dim=size(R8_C)
      ALLOCATE(C_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCULEV -- C_act ALLOCATE error!')
      ALLOCATE(C_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCULEV -- C_ref ALLOCATE error!')

      dim=size(R8_ZAR)
      ALLOCATE(ZAR_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCULEV -- ZAR_act ALLOCATE error!')
      ALLOCATE(ZAR_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCULEV -- ZAR_ref ALLOCATE error!')

      dim=size(R8_CL)
      ALLOCATE(CL_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCULEV -- CL_act ALLOCATE error!')
      ALLOCATE(CL_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCULEV -- CL_ref ALLOCATE error!')

! executable code:  copy for input

      C_act=R8_C
      C_ref=R8_C

      ZAR_act=R8_ZAR
      ZAR_ref=R8_ZAR

      CL_act=R8_CL
      CL_ref=R8_CL

! call to original routine:  AGCULEV

      CALL AGCULEV(
     > K1,C_act(1),K2,ZAR_act(1),NZ,CL_act(1),NCL)

! copy back outputs if modified.

      where(C_act.ne.C_ref)
         R8_C = C_act
      end where
      DEALLOCATE(C_act)
      DEALLOCATE(C_ref)

      where(ZAR_act.ne.ZAR_ref)
         R8_ZAR = ZAR_act
      end where
      DEALLOCATE(ZAR_act)
      DEALLOCATE(ZAR_ref)

      where(CL_act.ne.CL_ref)
         R8_CL = CL_act
      end where
      DEALLOCATE(CL_act)
      DEALLOCATE(CL_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGRAPH
      SUBROUTINE R8_AGRAPH(
     > MINX,MAXX,MINY,MAXY,R8_XMIN,R8_XMAX,R8_YMIN,R8_YMAX,XLABL,YLABL)

      external AGRAPH

! argument declarations
      INTEGER MINX
      INTEGER MAXX
      INTEGER MINY
      INTEGER MAXY
 ! floating type, input/output:
      REAL*8 R8_XMIN
  
 ! floating type, input/output:
      REAL*8 R8_XMAX
  
 ! floating type, input/output:
      REAL*8 R8_YMIN
  
 ! floating type, input/output:
      REAL*8 R8_YMAX
  
      CHARACTER*(*) XLABL
      CHARACTER*(*) YLABL

! local (automatic array) declarations

      integer alloc_stat
      REAL :: XMIN_act
      REAL :: XMIN_ref
      REAL :: XMAX_act
      REAL :: XMAX_ref
      REAL :: YMIN_act
      REAL :: YMIN_ref
      REAL :: YMAX_act
      REAL :: YMAX_ref

! allocation of working arrays...


! executable code:  copy for input

      XMIN_act=R8_XMIN
      XMIN_ref=R8_XMIN

      XMAX_act=R8_XMAX
      XMAX_ref=R8_XMAX

      YMIN_act=R8_YMIN
      YMIN_ref=R8_YMIN

      YMAX_act=R8_YMAX
      YMAX_ref=R8_YMAX

! call to original routine:  AGRAPH

      CALL AGRAPH(
     > MINX,MAXX,MINY,MAXY,XMIN_act,XMAX_act,YMIN_act,YMAX_act,XLABL,
     > YLABL)

! copy back outputs if modified.

      if(XMIN_act.ne.XMIN_ref) then
         R8_XMIN = XMIN_act
      endif

      if(XMAX_act.ne.XMAX_ref) then
         R8_XMAX = XMAX_act
      endif

      if(YMIN_act.ne.YMIN_ref) then
         R8_YMIN = YMIN_act
      endif

      if(YMAX_act.ne.YMAX_ref) then
         R8_YMAX = YMAX_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGRCFR
      SUBROUTINE R8_AGRCFR(
     > R8_X,IMIN,IMAX,ISTEP,R8_Y,JMIN,JMAX,JSTEP,IGRID)

      external AGRCFR

! argument declarations
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
      INTEGER IGRID
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGRCFR -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGRCFR -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGRCFR -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGRCFR -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  AGRCFR

      CALL AGRCFR(
     > X_act(1),IMIN,IMAX,ISTEP,Y_act(1),JMIN,JMAX,JSTEP,IGRID)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGCFRAM
      SUBROUTINE R8_AGCFRAM(
     > R8_X,NX,R8_Y,NY,IGRID)

      external AGCFRAM

! argument declarations
      INTEGER NX
      INTEGER NY
      INTEGER IGRID
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCFRAM -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCFRAM -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCFRAM -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGCFRAM -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  AGCFRAM

      CALL AGCFRAM(
     > X_act(1),NX,Y_act(1),NY,IGRID)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end

C******************** START FILE GRFUF1.FOR ; GROUP GRFUF1 *************
C  GRAFXE - DMC - REWRITTEN BASIC F(X) FIT GRAPHICS INTERFACE ROUTINE
C    THIS ROUTINE CONTROLS DRAWING AND LABELING OF A 1 PAGE PLOT
C    OF A SINGLE FUNCTION F(X), AND GENERATION OF A REPLOT/RESCALE
C    (UREAD) OPTION MENU
C
C  PLOT A NUMERIC FIT CURVE (SOLID LINE)
C   PLOT ORIGINAL DATA (PT SYMBOLS)
C   PLOT OPTIONAL ERROR BARS ABOUT EACH ORIG. DATA PT
C
C
C    A NEW CALLING ARGUMENT LIST IS PROVIDED
C
      SUBROUTINE GRAFXE(X,Y,N,X2,Y2,N2,IX2E,X2E,IY2E,Y2E,
     >                    XUN,YUN,LBL1,LBL2,LBL3)
C
C  DATA:
      REAL X(N),Y(N)  ! NUMERIC FIT DATA CURVE (SOLID LINE)
      REAL X2(N2),Y2(N2)  ! "ORIGINAL" DATA (POINT PLOT)
C
      REAL X2E(N2)  ! HORIZ. ERROR BARS ON ORIG DATA PTS (OPTIONAL)
      REAL Y2E(N2)  ! VERT. ERROR BARS ON ORIG DATA PTS (OPTIONAL)
C
C    IX2E .GT. 0 IF HORIZ. ERROR BARS ARE TO BE PLOTTED
C    IY2E .GT. 0 IF VERT. ERROR BARS ARE TO BE PLOTTED
C
C      IF .GT. 0 THE NUMBER MAX(IX2E,IY2E)
C    INDICATES THE MAXIMUM NUMBER OF PTS WITH
C    ERROR BARS TO BE DRAWN
C
C   *ERROR BAR DATA* X2E(J) = +/- DELTA(X) UNCERTAINTY ABOUT X2(J)
C           *NOT PLOTTED* IF .LE. 0.0
C
C   *ERROR BAR DATA* Y2E(J) = +/- DELTA(Y) UNCERTAINTY ABOUT Y2(J)
C           *NEITHER X NOR Y ERROR BAR PLOTTED* IF .LE. 0.0
C
C  LABELS:
      CHARACTER*(*) XUN,YUN,LBL1,LBL2,LBL3
C
C  LOCAL
      REAL XERRB(2),YERRB(2)
C
C  CONTROL:
      INTEGER IMENU
C
C  IF IMENU=1 JUMP DIRECTLY TO REPLOT MENU (DO NOT DRAW GRAPH 1ST)
C
      integer icounter
      integer ie_counter
      character*10 zext
      integer, save :: iopcod=0
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      DATA IMENU/0/
C
C-------------------------------------------------------------
C
      icounter=0
C-------------------------------------------------------------
C  SCALE SET SWITCHE CLEARED:
C
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
C
      CALL GAXGDF(ISEL)
C
      IF(IMENU.EQ.1) GO TO 200
C
C----------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(X,Y,Y,0,N)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(X,N,Y,Y,0,N,1,1,1,1,N,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD) ! AXIS (LOG/LIN) CHECK
C
      CALL GSCREC  ! RECORD PLOT SCALE IN MEMORY
C
      CALL DPLOT1(X,Y,N,ICOD) ! DRAW GRID AND F(X) SOLID CURVE
C
C  IF ALL ERROR BAR PLOTTING IS OFF-- JUST DRAW FIT PT PLOT
      INUM=MAX0(IX2E,IY2E)
      IF(INUM.LE.0) THEN
        CALL DPLOT1(X2,Y2,N2,16)  ! INDIV. DATA POINTS PLOT
      ELSE
C  DRAW INUM PTS WITH ERROR BAR PLOTTING
        CALL GRFCNT(X2,N2,XMIN,XMAX,ICNT)
        INUM=MAX0(25,MIN0(INUM,ICNT))
        ZDX=0.333333*(XMAX-XMIN)/(INUM+1)
        ZDY=0.333333*(YMAX-YMIN)/(INUM+1)
        ZXSEP=2.05*ZDX
C
        XNEXT=XMIN+ZXSEP
        IPREV=0
C
C  PT. PLOT LOOP
        ie_counter=0
 150    CONTINUE
          IF(XNEXT.GT.XMAX) GO TO 160
          CALL GRFNEX(X2,N2,XNEXT,IPREV)
          IF(IPREV.GT.N2) GO TO 160
          XNEXT=X2(IPREV)+ZXSEP
C
          CALL DPLOT1(X2(IPREV),Y2(IPREV),1,16)  ! PLOT PT SYMBOL
C
          IF((IX2E.GT.0).AND.(X2E(IPREV).GT.0.0)) THEN
             ie_counter=ie_counter+1
             call make_zext
             CALL GRFEBX(X2(IPREV),Y2(IPREV),X2E(IPREV),ZDY)
          ENDIF
C
          IF((IY2E.GT.0).AND.(Y2E(IPREV).GT.0.0)) THEN
             ie_counter=ie_counter+1
             call make_zext
             CALL GRFEBY(X2(IPREV),Y2(IPREV),Y2E(IPREV),ZDX)
          ENDIF
C  LOOP END
          GO TO 150
 160    CONTINUE
      ENDIF
C
      CALL GRALBL(XUN,YUN,LBL1,LBL2,LBL3)  ! LABEL THE PLOT
C
      CALL UPAUST(2)  ! PAUSE AFTER PLOT
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SA',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         RETURN
      ENDIF
C
      CALL UERMSI(' ?GRAFXE *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      contains
         subroutine make_zext

         zext=' '
         if(ie_counter.le.9) then
            write(zext,'(I1)') ie_counter
         else if(ie_counter.le.99) then
            write(zext,'(I2)') ie_counter
         else if(ie_counter.le.999) then
            write(zext,'(I3)') ie_counter
         else if(ie_counter.le.9999) then
            write(zext,'(I4)') ie_counter
         else if(ie_counter.le.99999) then
            write(zext,'(I5)') ie_counter
         else if(ie_counter.le.999999) then
            write(zext,'(I6)') ie_counter
         endif

         end subroutine make_zext
      END

C******************** START FILE UEXITA.FOR ; GROUP USINIT *************
C=============================================
C&  UEXITA EXIT PROGRAM W/TTY-DEPENDENT PAGE CLEAR
C
C  EXIT A PROGRAM WHICH USED SG LIBRARY
C
      SUBROUTINE UEXITA(IDUM)
C
      USE USERIO
C
      IF(NTTYP.GE.0) THEN
        CALL NEUPAG
        CALL AGFCLOS(CBUFF)
      ENDIF
C
      call good_exit  ! a normal exit, stop, status 0.
C
      STOP
      END
C******************** END FILE UEXITA.FOR ; GROUP USINIT ***************

      subroutine fdelete(filename,ier)
C
C  dmc 18 June 1996 -- delete file
C
      character*(*) filename  ! file to delete...
C
C  ** delete a file **
C
C  return error code
C    ier=0 -- success
C    ier=1 -- error
C
C
#include "fpreproc/byte_declare.h"
      byte_declare fnbuf(500)
      integer cdelete
C----------------------------------
C
      ier=0
C
      ilf=len_trim(filename)
      if(ilf.eq.0) then
         write(6,*) ' ?fdelete:  filename argument is blank.'
         ier=1
         return
      endif
C
      call cstring(filename(1:ilf),fnbuf,'2C')
      ier=cdelete(fnbuf)
C
      return
      end

      program adas_init
! use to initialize adas tables, write tableParameters into $ADASDIR/tables/<reaction type>/...
!Energy and Temperature -- [KeV/amu]
!density -- [1/cm**3]
        use ezcdf
        implicit none
        INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
        character*40  :: adas_tables_file
        character*2, dimension(4)   :: react_type =(/ 'cx', 'ii', 'ei','sv' /)
        integer, dimension(2) :: izneut=(/1,2/) ! atomic charge of primary   particle {1, 2}
        integer, dimension(2,10) :: izion  ! atomic charge of secondary particle {1, ..., 10}
        character*9 :: cizneut, cizion    ! character if izneut and izion to creat filename
        character*240 :: filename         ! filename
        real*8, dimension(4,2,10,4) :: axis_param_coldTarget !axis parameter for table: min, max values,
                                                        ! number of points,specification 0 for LOG, 1 for LIN
        real*8, dimension(4,2,10,8) :: axis_param_warmTarget !axis parameter for table: min, max values, number of points,
                                                        !specification 0 for LOG, 1 for LIN
        real*8, dimension(4,2,10,8) :: axis_param_energyAvg_perAMU!axis parameter for table: min, max values,
                                                        ! number of points,specification 1 for LOG, 0 for LIN
        real*8, dimension(4,2,10,8) :: axis_param_average_vDotNorm!axis parameter for table: min, max values,
                                                        ! number of points,specification 0 for LOG, 1 for LIN
        real*8, dimension(10,12) :: axis_param_excite  !axis parameter for table: min, max values,
                                                        ! number of points,specification 0 for LOG, 1 for LIN
        integer :: i, ii, ij
        integer :: icdf,fErr

        izion(1,:)=(/1,2,3,4,5,6,7,8,9,10/) !available reaction for H CX, see adas_ion
        izion(2,:)=(/1,2,0,4,0,6,0,8,0,0/)  !available reaction for He CX, see adas_ion

        ! create table filename
        axis_param_coldTarget=0._R8
        axis_param_warmTarget=0._R8
        axis_param_energyAvg_perAMU=0._R8
        axis_param_average_vDotNorm=0._R8
        axis_param_excite=0._R8

!Charge-Exchange
! H->H(cx)
        axis_param_coldTarget(1,1,1,:)= (/1e-3_R8, 1e3_R8, 400._R8, 0._R8/)
        axis_param_warmTarget(1,1,1,:)= (/1e-3_R8, 1e3_R8, 192._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
        axis_param_energyAvg_perAMU(1,1,1,:)= (/1e-3_R8, 1e3_R8, 64._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
        axis_param_average_vDotNorm(1,1,1,:)= (/1e-3_R8, 1e3_R8, 64._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
! H+->He0x
        axis_param_coldTarget(1,2,1,:)= (/1e-3_R8, 2.5e4_R8, 400._R8, 0._R8/)
        axis_param_warmTarget(1,2,1,:)= (/1e-2_R8, 1e4_R8, 64._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
        axis_param_energyAvg_perAMU(1,2,1,:)= (/1e-2_R8, 1e4_R8, 64._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
        axis_param_average_vDotNorm(1,2,1,:)= (/1e-2_R8, 1e4_R8, 64._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
! He++>Hex
        axis_param_coldTarget(1,2,2,:)= (/1e-3_R8, 1e3_R8, 400._R8, 0._R8/)
        axis_param_warmTarget(1,2,2,:)= (/1e-3_R8, 1e3_R8, 64._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
        axis_param_energyAvg_perAMU(1,2,2,:)= (/1e-3_R8, 1e3_R8, 64._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
        axis_param_average_vDotNorm(1,2,2,:)= (/1e-3_R8, 1e3_R8, 64._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
! Ionization
        do ii=1,2
           do ij=1,10
              if (izion(ii,ij).eq.0) cycle
              axis_param_coldTarget(2,ii,ij,:)= (/1e-3_R8, 2.5e4_R8, 400._R8, 0._R8/)
              axis_param_warmTarget(2,ii,ij,:)= (/1e-3_R8, 1e4_R8, 96._R8, 0._R8, 1e-3_R8, 2e2_R8, 64._R8, 0._R8/)
           enddo
        enddo
! H+H II
        axis_param_warmTarget(2,1,1,:)= (/1e-3_R8, 1e4_R8, 192._R8, 0._R8, 1e-3_R8, 2e2_R8, 32._R8, 0._R8/)
!H,e- -> H+,e-  impact ionization
        axis_param_coldTarget(3,1,1,:)= (/1e-3_R8, 2.5e4_R8, 400._R8, 0._R8/)
!H stopping on impurities {1,..,10}
        do ij=1,10
           axis_param_coldTarget(4,1,ij,:)= (/1e-3_R8, 2.5e4_R8, 400._R8, 0._R8/)
        enddo

!H stopping on impurities {1,..,10} excited state
        goto 332
        do ij=1,10
           axis_param_excite(ij,:)= (/1e-3_R8, 2.5e4_R8, 48._R8, 0._R8,1.000E+12_R8,1.000E+15_R8,50._R8, 1._R8,&
                &1e-3_R8, 2e2_R8, 192._R8, 1._R8/)
        enddo
332     continue

        do i=1,4  !"cx", "ii", "ei", "sv"
           ! write tableParameters file with dummy data
           adas_tables_file=trim('tables/')//trim(react_type(i))//'/'//'tableParameters.cdf'
           call UFILNAM('ADASDIR',adas_tables_file,filename)
           call cdf_open(icdf,trim(filename),'w',fErr)
           call cdf_define(icdf,'axis_param_coldTarget',axis_param_coldTarget(i,1,1,1:4)) 
           call cdf_define(icdf,'axis_param_warmTarget',axis_param_warmTarget(i,1,1,1:8)) 
           call cdf_define(icdf,'axis_param_energyAvg_perAMU',&
                &axis_param_energyAvg_perAMU(i,1,1,1:8))   
           call cdf_define(icdf,'axis_param_average_vDotNorm',&
                &axis_param_average_vDotNorm(i,1,1,1:8)) 
           call cdf_write(icdf,'axis_param_coldTarget',axis_param_coldTarget(i,1,1,1:4)) 
           call cdf_write(icdf,'axis_param_warmTarget',axis_param_warmTarget(i,1,1,1:8)) 
           call cdf_write(icdf,'axis_param_energyAvg_perAMU',&
                &axis_param_energyAvg_perAMU(i,1,1,1:8))   
           call cdf_write(icdf,'axis_param_average_vDotNorm',&
                &axis_param_average_vDotNorm(i,1,1,1:8))
           call cdf_close(icdf)
           do  ii=1,2
              write(cizneut,'(i5)') izneut(ii)
              do ij=1,10
                 if(axis_param_coldTarget(i,ii,ij,1).eq.0._R8) cycle  ! reaction not available
                 write(cizion,'(i5)') izion(ii,ij)
                 adas_tables_file=trim('tables/')//trim(react_type(i))//'/'//trim(react_type(i))//'_'//&
                      & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'_'//'tableParameters.cdf'
                 if(i.eq.3) then  !for electron impact ionization
                    adas_tables_file=trim('tables/')//trim(react_type(i))//'/'//trim(react_type(i))//'_'//&
                         & trim(adjustl(cizneut))//'_'//'tableParameters.cdf'
                 endif
                    
                 call UFILNAM('ADASDIR',adas_tables_file,filename)
                 call cdf_open(icdf,trim(filename),'w',fErr)
                 if(fErr.ne.0) then
                    write(6,*) ' ?adas_init: open failure: ',trim(filename)
                    stop
                 endif
                 call cdf_define(icdf,'axis_param_coldTarget',axis_param_coldTarget(i,ii,ij,1:4)) 
                 if(i.lt.3) then
                    call cdf_define(icdf,'axis_param_warmTarget',axis_param_warmTarget(i,ii,ij,1:8)) 
                    if(i.lt.2) then
                       call cdf_define(icdf,'axis_param_energyAvg_perAMU',&
                            &axis_param_energyAvg_perAMU(i,ii,ij,1:8))   
                       call cdf_define(icdf,'axis_param_average_vDotNorm',&
                            &axis_param_average_vDotNorm(i,ii,ij,1:8)) 
                    endif
                 endif
                 call cdf_write(icdf,'axis_param_coldTarget',axis_param_coldTarget(i,ii,ij,1:4)) 
                 if(i.lt.3) then
                    call cdf_write(icdf,'axis_param_warmTarget',axis_param_warmTarget(i,ii,ij,1:8)) 
                    if(i.lt.2) then
                       call cdf_write(icdf,'axis_param_energyAvg_perAMU',&
                            &axis_param_energyAvg_perAMU(i,ii,ij,1:8))
                       call cdf_write(icdf,'axis_param_average_vDotNorm',&
                            &axis_param_average_vDotNorm(i,ii,ij,1:8)) 
                    endif
                 endif
                 call cdf_close(icdf)
             enddo !end loop for izion
           enddo !end loop for izneut
        enddo !end loop for reaction type
!sv from excited states
        goto 333
        adas_tables_file=trim('tables/sv/')//'ex_tableParameters.cdf'
        call UFILNAM('ADASDIR',adas_tables_file,filename)
        call cdf_open(icdf,trim(filename),'w',fErr)
        call cdf_define(icdf,'axis_param_excite',axis_param_excite(1,1:12)) 
        call cdf_write(icdf,'axis_param_excite',axis_param_excite(1,1:12)) 
        call cdf_close(icdf)
        do  ii=1,1
           write(cizneut,'(i5)') izneut(ii)
           do ij=1,10
              write(cizion,'(i5)') izion(ii,ij)
              adas_tables_file=trim('tables/sv/ex')//'_'//&
                   & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'_'//'tableParameters.cdf'
              call UFILNAM('ADASDIR',adas_tables_file,filename)
              call cdf_open(icdf,trim(filename),'w',fErr)
              call cdf_define(icdf,'axis_param_excite',axis_param_excite(ij,1:12)) 
              call cdf_write(icdf,'axis_param_excite',axis_param_excite(ij,1:12)) 
              call cdf_close(icdf)
           enddo
        enddo

333     continue
        
        stop
      end program adas_init

C******************** START FILE INORD.FOR ; GROUP INORD ***************
C------------------------------------------------------------
C  INORD - INPUT A LIST OF NUMBERS - SORT IN ORDER
C
C  ******************************************************
C  *  INORD.FOR -- just input numbers from tty          *
C  *  INORDU.FOR -- input numbers from tty or Ufile     *
C  *    routines linked from different libraries        *
C  *    DMC 18 Sept 1992                                *
C  ******************************************************
C
      SUBROUTINE INORD(X,WK,NDIM,NUM,LABEL,IDUPL)
C
      CHARACTER*(*) LABEL
      REAL X(NDIM),WK(NDIM)
C
C  X(NDIM) - LIST OF INPUT FLOATING PT NUMBERS (MAY BE MODIFIED)
C   NUM    - NUMBER OF ENTRIES IN LIST (MAY BE MODIFIED)
C  LABEL --- FOR USER PROMPT (INPUT) (JUST A FEW CHARS)
C  IDUPL --- =1 TO ALLOW DUPLICATE VALUES IN LIST (INPUT)
C
C
      LOGICAL LCHAR
      LOGICAL LXOUT
C
      LUNT=LNOUT(0)
 10   CONTINUE
      CALL NEUPAG
 11   CONTINUE
      IF(LXOUT(0)) THEN
        WRITE(LUNT,1001) LABEL
 1001 FORMAT(' INORD (ORDERED LIST "',A,'" INPUT) OPTIONS:'/
     >' type a NUMBER to add a value to the list, OR:'/
     >' C TO CLEAR LIST '/
     >' D <NUMBER> TO REMOVE <NUMBER> FROM LIST'/
     >' R <NUMBER1> <NUMBER2> TO REMOVE RANGE OF NUMBERS FROM LIST'/
     >' L TO TYPE OUT LIST CONTENTS   '/' Q TO QUIT')
        IF(NUM.EQ.0) THEN
          WRITE(LUNT,1002)
        ELSE IF(NUM.EQ.1) THEN
          WRITE(LUNT,1003) X(1)
        ELSE
          WRITE(LUNT,1004) NUM,X(1),X(NUM)
        ENDIF
 1002 FORMAT(' % CURRENTLY LIST IS EMPTY')
 1003 FORMAT(' % 1 ENTRY IN LIST:  ',1PE13.6)
 1004 FORMAT(' % ',I4,' ENTRIES IN LIST, RANGE:  ',
     >1PE13.6,' TO ',1PE13.6)
      ENDIF
C
      CALL UREAD(
     >'INORD:  ENTER NEW ITEM OR OPTION FOR LIST "'//LABEL//'":$')
      IF(LCHAR('Q')) THEN
        RETURN
      ELSE IF(LCHAR('C')) THEN
        NUM=0
        GO TO 11
      ELSE IF(LCHAR('L')) THEN
        IF(NUM.EQ.0) GO TO 10
        WRITE(LUNT,1010) (X(IX),IX=1,NUM)
 1010 FORMAT(4(2X,1PE13.6))
        CALL UPAUST(1)
        GO TO 11
      ELSE IF(LCHAR('D')) THEN
        IF(NUM.EQ.0) GO TO 10
        CALL UREAD('INORD:  SELECT VALUE (DELETE BY CLOSEST MATCH):$')
          IF(LCHAR('Q')) GO TO 10
          XDEL=FDCOD(IER)
          IF(IER.NE.0) GO TO 11
C  DETERMINE ENTRY SELECTED FOR DELETION
          IDEL=1
          IF(NUM.GT.1) THEN
            DXDEL=ABS(X(1)-XDEL)
            DO IX=2,NUM
              DX=ABS(X(IX)-XDEL)
              IF(DX.LT.DXDEL) THEN
                IDEL=IX
                DXDEL=DX
              ENDIF
            ENDDO
          ENDIF
C  DELETE SELECTED ENTRY
          IF(NUM.EQ.IDEL) THEN
            NUM=NUM-1
          ELSE
            IDP1=IDEL+1
            DO IX=IDP1,NUM
              X(IX-1)=X(IX)
            ENDDO
            NUM=NUM-1
          ENDIF
        GO TO 10
      ELSE IF(LCHAR('R')) THEN
        IF(NUM.EQ.0) GO TO 10
        CALL UREAD('INORD:  SELECT DELETE RANGE VALUE 1::$')
          IF(LCHAR('Q')) GO TO 10
          XR1=FDCOD(IER)
          IF(IER.NE.0) GO TO 11
        CALL UREAD('INORD:  SELECT DELETE RANGE VALUE 2::$')
          IF(LCHAR('Q')) GO TO 10
          XR2=FDCOD(IER)
          IF(IER.NE.0) GO TO 11
C  ASSURE XR1.LE.XR2
        IF(XR1.GT.XR2) THEN
          XRTEMP=XR1
          XR1=XR2
          XR2=XRTEMP
        ENDIF
C  FIND INDEX RANGE TO DELETE
        IRDEL=0
        DO IR1=1,NUM
          IF(XR1.LE.X(IR1)) GO TO 15
        ENDDO
        GO TO 19
 15     CONTINUE
        DO IR2=IR1,NUM
          IF(XR2.LT.X(IR2)) GO TO 18
        ENDDO
        IR2=NUM+1
 18     CONTINUE
        IR2=IR2-1
        IRDEL=IR2-IR1+1
 19     CONTINUE
        CALL NEUPAG
        WRITE(LUNT,1015) IRDEL
 1015   FORMAT(/' % ',I5,' LIST ENTRIES DELETED'/)
        IF(IRDEL.EQ.0) GO TO 11
C  DELETE THEM
        IF(IR2.LT.NUM) THEN
          INUM=NUM-IRDEL
          DO I=IR1,INUM
            IOLD=I+IRDEL
            X(I)=X(IOLD)
          ENDDO
        ENDIF
        NUM=NUM-IRDEL
        GO TO 10
      ELSE
C  NEW ENTRY?
        XNEW=FDCOD(IER)
        IF(IER.NE.0) GO TO 11
C  CHECK LIMIT
        IF(NUM.EQ.NDIM) THEN
          CALL UERMSI(' % LIST FULL, NUMBER OF ENTRIES',NDIM,-1)
          GO TO 11
        ENDIF
C  INSERT IN ORDER
        IF(NUM.EQ.0) THEN
          NUM=1
          X(NUM)=XNEW
        ELSE IF(XNEW.GT.X(NUM)) THEN
          NUM=NUM+1
          X(NUM)=XNEW
        ELSE
          DO IX=1,NUM
            IF(XNEW.LE.X(IX)) GO TO 20
          ENDDO
 20       CONTINUE
          IF((XNEW.EQ.X(IX)).AND.(IDUPL.NE.1)) THEN
            CALL UERMSF(' % DUPLICATE ENTRY',XNEW,-1)
            GO TO 11
          ENDIF
          INS=IX
          DO IX=NUM,INS,-1
            X(IX+1)=X(IX)
          ENDDO
          X(INS)=XNEW
          NUM=NUM+1
        ENDIF
        GO TO 10
      ENDIF
      END
C******************** END FILE INORD.FOR ; GROUP INORD *****************

!------------------------------------------------------------------------------
!
!  SIGALAD1_Z -- READ A CROSS SECTION FIT FROM ALADDIN DATA FILE
!
SUBROUTINE SIGALAD1_Z(KSTR,IER_ALAD)
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod   
  use alpcom_mod
  use alcom_mod
  IMPLICIT NONE
  INTEGER ier_alad,ier
!============
! idecl:  explicitize implicit REAL declarations:
 real(fp) ze,zep,zeav,zsigma,zsigmap,zsigav,zem,zsigmam
!============
 CHARACTER*(*) KSTR    ! REACTION LABEL
!
!  IER_ALAD = 0 ON OUTPUT IF COMPLETION IS SUCCESSFUL
!           OTHERWISE .NE. 0
!
!  USED TO LOAD COMMON FOR SIGTAB PROGRAM, SO THAT DESIRED FITS MAY BE
!  COMPUTED.
!
!------------------------------------------------------------------------------
!
 NUMALAD=NUMALAD+1
 IF(NUMALAD.GT.MAXALADR) THEN
    WRITE(6,'(//'' ?SIGALAD1_Z -- TOO MANY REACTIONS:  ''/)')
    ALADFLAG=.FALSE.
    return
 ENDIF
!
 ALADRLBL(NUMALAD)=KSTR
 CALL ALAD_FIND_Z(1,ALADRLBL(NUMALAD),' ',' ',IER_ALAD)
 IF(IER_ALAD.NE.0) THEN
    WRITE(6,'(//'' ?SIGALAD1_Z -- ERROR ON REACTION:  '',A/)')&
         ALADRLBL(NUMALAD)
    ALADFLAG=.FALSE.
    return
 ENDIF
!
 NALPCF(NUMALAD)=NCF
 ALPCF(1:ncf,NUMALAD)=CF(1:ncf)
 CALL ALAD_ELIM(ALEMIN(NUMALAD),ALEMAX(NUMALAD),IER_ALAD)
!  BE CONSERVATIVE...
 ALEMIN(NUMALAD)=1.000001_fp*ALEMIN(NUMALAD)
 ALEMAX(NUMALAD)=0.999999_fp*ALEMAX(NUMALAD)
!
 IF(IER_ALAD.NE.0) THEN
    WRITE(6,'(//'' ?SIGALAD1_Z -- ERROR ON REACTION:  '',A/)')&
         ALADRLBL(NUMALAD)
    ALADFLAG=.FALSE.
    return
 ENDIF
! 
 CALL ALAD_EVAL_Z(ALEMIN(NUMALAD),ALAMIN(NUMALAD),1,IER_ALAD)
 IF(IER_ALAD.NE.0) THEN
    WRITE(6,'(//'' ?SIGALAD1_Z -- ERROR ON REACTION:  '',A/)')&
         ALADRLBL(NUMALAD)
    ALADFLAG=.FALSE.
    return
 ENDIF
!
 CALL ALAD_EVAL_Z(ALEMAX(NUMALAD),ALAMAX(NUMALAD),1,IER_ALAD)
 IF(IER_ALAD.NE.0) THEN
    WRITE(6,'(//'' ?SIGALAD1_Z -- ERROR ON REACTION:  '',A/)')&
         ALADRLBL(NUMALAD)
    ALADFLAG=.FALSE.
    return
 ENDIF
!
 ZE=ALEMIN(NUMALAD)
 ZEP=1.0001_fp*ZE
 ZEAV=0.5_fp*(ZE+ZEP)
!
 ZSIGMA=ALAMIN(NUMALAD)
 CALL ALAD_EVAL_Z(ZEP,ZSIGMAP,1,IER)
 ZSIGAV=0.5_fp*(ZSIGMA+ZSIGMAP)
!
 ALSMIN(NUMALAD)=ZEAV*(ZSIGMAP-ZSIGMA)/&
      (ZSIGAV*(ZEP-ZE))
!
 ZE=ALEMAX(NUMALAD)
 ZEM=0.9999_fp*ZE
 ZEAV=0.5_fp*(ZE+ZEM)
!
 ZSIGMA=ALAMAX(NUMALAD)
 CALL ALAD_EVAL_Z(ZEM,ZSIGMAM,1,IER)
 ZSIGAV=0.5_fp*(ZSIGMA+ZSIGMAM)
!
 ALSMAX(NUMALAD)=ZEAV*(ZSIGMA-ZSIGMAM)/&
      (ZSIGAV*(ZE-ZEM))
!
 RETURN
END SUBROUTINE SIGALAD1_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
 
 
 
 
 
 
 
 
 
 
 
 

C---------------------------------------------------------------------
C  UPSINX  FIND NEXT INLINE SUBSTITUTION CHARACTER
C
C  NOT COUNTED IF INSIDE ""-DELIMITERS
C
      SUBROUTINE UPSINX(ZBUFF,ISC,IEVEN)
C
C  ZBUFF -- INPUT STRING
C  ISC -- PTS TO SEARCH START PT. -1
C         ON OUTPUT PTS TO FOUND CHARACTER IF FOUND
C         OTHERWISE NOT MODIFIED
C  IEVEN-- =1 IF OUTSIDE, =0 IF INSIDE "" PAIR
C         MODIFIED BY ENCOUNTER OF " CHARACTER
C
      USE USERIO
C
      CHARACTER*(*) ZBUFF
C
C---------------------
C
      IL=LEN(ZBUFF)
      IC=ISC
C
 10   CONTINUE
      IC=IC+1
      IF(IC.GT.IL) GO TO 100
C
      IF(ZBUFF(IC:IC).EQ.'"') THEN
        IEVEN=1-IEVEN
      ELSE IF(ZBUFF(IC:IC).EQ.MSUB2(1)) THEN
        IF(IEVEN.EQ.1) THEN
          ISC=IC
          GO TO 100
        ENDIF
      ENDIF
C
      GO TO 10
C
 100  CONTINUE
      RETURN
      END

C******************** START FILE IFIXR.FOR ; GROUP CONCTR ******************
C-----------------
C  FIX FLOATING PT TO INTEGER
C
C    -1/2 BECOMES -1
C    3.7 BECOMES 3
C
      INTEGER FUNCTION IFIXR(Z)
C
      REAL Z
C
      IFIXR=Z
      IF(Z.LT.0.0) IFIXR=IFIXR-1
      RETURN
      	END
C******************** END FILE IFIXR.FOR ; GROUP CONCTR ******************

	
      Subroutine UFstuffZ ( F3d, F2d, Imax, Jmax, Kmax, IQ)
 
C	Stuff F3d(1:Imax, 1:Jmax, Iq) into F2d(1:Imax,1:Jmax)
 
      Real F3d(*)
      Real F2d(*)
 
 
      Do 300 J=1,Jmax
        Do 200 I=1,Imax
 
          Ind3 = I + (J-1)*Imax + (Iq-1)*(Imax*Jmax)
          Ind2 = I + (J-1)*Imax
 
          F2d(Ind2) = F3d(Ind3)
 
  200   Continue
  300   Continue
 
      Return
      End

subroutine plot_fp_cx(n1,n2,evec1,fvec1,evec2,tvec2,wkvec,farr)

  ! plot CX data from fpreact
  use adas_mod, only : adas_sigv,adas_btsigv
  use fpreact_parameters
  use iso_c_binding, only: fp => c_double

  implicit NONE

  ! data buffers -- uninitialized!

  integer, intent(in) :: n1,n2  ! dimension info

  real(fp) :: evec1(n1)             ! E/A-vector for f(E) plot
  real(fp) :: fvec1(n1)             ! for f(E) plot
  real(fp) :: evec2(n2),tvec2(n2)   ! E/A,T/A for f(E,T) plot
  real(fp) :: wkvec(max(n1,n2),2)
  real(fp) :: farr(n2,n2)

  !----------------------------------
  integer luntrm,lnout
  logical lxout,lchar

  integer izneut,izion,ihandle,idum1,idum2,iopt,i

  real(fp) :: erange1,erange2,trange1,trange2

  character*60 zlbl1,zlbl2,zlbl3

  character*30 flbl,flbl2
  character*15 funs
  character*10 zbzi

  real(fp), dimension(:,:), allocatable :: farr2
  real(fp), dimension(:), allocatable :: fvec1_adas
  real(fp), dimension(:), allocatable :: tevec1 ! T/A-vector for f(E) or f(E,T) plot
  integer fadas_CX,ii
  integer, parameter :: NEUTRAL=1, ION=2 ! beam type: =neutral or =ion
!----------------------------------
  luntrm=lnout(0)

  zlbl1='preact/fpreact "CX" database'
  zlbl2='[sigma*v](E/A) charge exchange rate coefficient'

  luntrm=lnout(0)
  if(lxout(0)) write(luntrm,1001)
1001 format(/ &
         'plot of charge exchange of selected neutral specie as a'/ &
         'function of interaction energy-per-nucleon (E/A), or...'/ &
         'beam-target <sigma*v>(Eb/Ab,Ti/Ai) table, or...'/ &
         '<Eav> (average energy sampled from Maxwellian by cx), or...'/ &
         '<fd>=<vb.vtarg/(|vb|*vth), normalized average component of v'/ &
         'sampled in the direction of the beam; vth=sqrt(kTi/Ai).'/ &
         '(hit "," to exit)'/)

  izion=0
  do
     izneut=0
     call ureadi('select neutral (beam) specie: 1 for H, 2 for He:$',izneut)
     if(izneut.eq.0) exit
     izneut=max(1,min(2,izneut))
     izion=izneut
     if(izneut.gt.1) then
        call ureadi('select ion specie: 1 for H+, 2 for He++:$',izion)
        izion=max(1,min(izneut,izion))
     endif

     if(lxout(0)) write(luntrm,*) '"2" for <Eav>, "3" for <fd>'
     if(lxout(0)) write(luntrm,*) &
          '"4" to compare <sigma*v>(Eb/Ai,Ti/Ai) with sigma(Er)*v(Er)'
     if(lxout(0)) write(luntrm,*) 'where Er=Eb/Ai+1.5*Ti/Ai.'

     if(allocated(farr2)) deallocate(farr2)

     call uread('enter "0" for cold target plot; "1" for beam-target table:$')

     iopt=0
     if(lchar('0')) then

        ! get [sigma*v] table range
        call hatom_handle(fpreact_CX,izneut,izion,ihandle)
        call cx_coldtarget_erange(ihandle,erange1,erange2,idum1,idum2)

        call plot_fp_mkvec(erange1,erange2,n1,evec1)
        if(lxout(0)) write(luntrm,*) &
             ' A -- ADAS [sigma*v]' 
        if(lxout(0)) write(luntrm,*) &
             ' P -- PREACT [sigma*v]' 
        if(lxout(0)) write(luntrm,*) &
             ' C -- COMPARE ADAS and PREACT ' 
        if(lxout(0)) write(luntrm,*) &
             ' hit "," to exit' 
        call uread('select option:$')
        if(izneut.eq.1) then
           zlbl3='charge exchange of H+ and H0, vs. Erel/A'
        else if(izneut.eq.2) then
           if(izion.eq.1) then
              zlbl3='charge exchange of H+ and He0, vs. Erel/A'
           else
              zlbl3='charge exchange of He++ and He0, vs. Erel/A'
           endif
        endif
        if(lchar('P')) then !PREACT DATA
           zlbl1='preact/fpreact "CX" database'
           call hatom_sigv(fpreact_CX,evec1,n1,izneut,izion,fvec1,idum1)
           call gaxspc(3) ! log-log
           call r8_grafx1(evec1,fvec1,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
           call gaxspc(1) ! restore default

        elseif(lchar('A')) then !ADAS DATA
           zlbl1='ADAS "CX" database'
           fadas_CX=1
           call adas_sigv(fadas_CX,evec1,n1,izneut,dble(izion),fvec1,idum1)

           call gaxspc(3) ! log-log
           call r8_grafx1(evec1,fvec1,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
           call gaxspc(1) ! restore default

        elseif(lchar('C')) then !ADAS vs PREACT  DATA
           zlbl1='PREACT/ADAS "CX" database'
           flbl2='CX sigma*v: Er=Eb/Ab+1.5*Ti/Ai'
           if(allocated(fvec1_adas)) deallocate(fvec1_adas)
           allocate(fvec1_adas(n1))
           fvec1_adas=0.0_fp
           call hatom_sigv(fpreact_CX,evec1,n1,izneut,izion, &
                fvec1,idum1)
           fadas_CX=1
           call adas_sigv(fadas_CX,evec1,n1,izneut,dble(izion),fvec1_adas,idum1)
           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izion
           call gaxspc(3) ! log-log
           call r8_grafx2(evec1,fvec1,fvec1_adas,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
           call gaxspc(1) ! restore default

        endif

     else if(lchar('1')) then

        iopt=fpreact_CX  ! cx beam target table

     else if(lchar('2')) then

        iopt=fpreact_EAV  ! <Eav> table

     else if(lchar('3')) then

        iopt=fpreact_FD   ! <fd> table

     else if(lchar('4')) then

        iopt=fpreact_CX  ! cx beam target table
        allocate(farr2(n2,n2))
        flbl2='CX sigma*v: Er=Eb/Ab+1.5*Ti/Ai'
     else
        call uermsg('plot_fp_ii: invalid option.',' ',0)
     endif

     if(iopt.gt.0) then
        ! get table range information
        call hatom_handle(iopt,izneut,izion,ihandle)
        if(iopt.eq.fpreact_CX) then
           call cx_warmtarget_erange(ihandle,erange1,erange2, &
                idum1,idum2)
           call cx_warmtarget_trange(ihandle,trange1,trange2, &
                idum1,idum2)
           flbl='<sigma*v> charge exchange'
           funs='m**3/sec'
        else if(iopt.eq.fpreact_EAV) then
           call cx_energyavg_peramu_erange(ihandle,erange1,erange2, &
                idum1,idum2)
           call cx_energyavg_peramu_trange(ihandle,trange1,trange2, &
                idum1,idum2)
           flbl='<Ei/Ai> charge exchange'
           funs='KeV'
        else if(iopt.eq.fpreact_FD) then
           call cx_average_vdotnorm_erange(ihandle,erange1,erange2, &
                idum1,idum2)
           call cx_average_vdotnorm_trange(ihandle,trange1,trange2, &
                idum1,idum2)
           flbl='<vb.vi/(|vb|*vth)>cx'
           funs=' '
        endif
        call plot_fp_mkvec(erange1,erange2,n2,evec2)
        call plot_fp_mkvec(trange1,trange2,n2,tvec2)
        if(lxout(0)) write(luntrm,*) &
             ' A -- ADAS <sigma*v>' 
        if(lxout(0)) write(luntrm,*) &
             ' P -- PREACT <sigma*v>' 
        if(lxout(0)) write(luntrm,*) &
             ' C -- COMPARE ADAS and PREACT ' 
        if(lxout(0)) write(luntrm,*) &
             ' hit "," to exit' 
        call uread('select option:$')
        if(lchar('P'))then
           farr=0.0_fp
           zlbl1='PREACT "CX" database'
           do i=1,n2
              wkvec(1:n2,1)=tvec2(i)
              wkvec(1:n2,2)=1.5_fp*tvec2(i)+evec2
              call hatom_btsigv(iopt,fpreact_NEUTRAL_BEAM, &
                   evec2,wkvec(1:n2,1),n2,izneut,izion, &
                   farr(1:n2,i),idum1)
              if(allocated(farr2)) then
                 call hatom_sigv(fpreact_CX,wkvec(1:n2,2),n2,izneut,izion, &
                      farr2(1:n2,i),idum1)
              endif
           enddo
           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izion
           if(allocated(farr2)) then
              call r8_grf3f2(evec2,farr,farr2,tvec2,wkvec,n2,n2,n2, &
                   'beam Eb/Ab',flbl,flbl2,'target Ti/Ai', &
                   'KeV(Eb/Ab)',funs,'KeV(Ti/Ai)',zlbl1,zbzi,0)
           else
              call r8_grf3f1(evec2,farr,tvec2,wkvec,n2,n2,n2, &
                   'beam Eb/Ab',flbl,'target Ti/Ai', &
                   'KeV(Eb/Ab)',funs,'KeV(Ti/Ai)',zlbl1,zbzi,0)
           endif
        else if(lchar('A'))then
           zlbl1='ADAS "CX" database'
           fadas_CX=1
           if(allocated(tevec1)) deallocate(tevec1)
           allocate(tevec1(n2))
           farr=0.0_fp
           do i=1,n2
              wkvec(1:n2,1)=tvec2(i)
              tevec1(1:n2)=tvec2(i)
              wkvec(1:n2,2)=1.5_fp*tvec2(i)+evec2
              call adas_btsigv(fadas_CX,NEUTRAL,evec2,tevec1,n2,izneut,dble(izion),farr(1:n2,i),idum1)
!           ikey=2 ! for FOR BEAM TARGET <sig*v>
              if(allocated(farr2)) then
                 call adas_sigv(fadas_CX,wkvec(1:n2,2),n2,izneut,dble(izion),fvec1(1:n2),idum1)
                 farr2(1:n2,i)=fvec1(1:n2)
              endif
           enddo
           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izion
           if(allocated(farr2)) then
              call r8_grf3f2(evec2,farr,farr2,tvec2,wkvec,n2,n2,n2, &
                   'beam Eb/Ab',flbl,flbl2,'target Ti/Ai', &
                   'KeV(Eb/Ab)',funs,'KeV(Ti/Ai)',zlbl1,zbzi,0)
           else
              call r8_grf3f1(evec2,farr,tvec2,wkvec,n2,n2,n2, &
                   'beam Eb/Ab',flbl,'target Ti/Ai', &
                   'KeV(Eb/Ab)',funs,'KeV(Ti/Ai)',zlbl1,zbzi,0)
           endif
        else if(lchar('C'))then
           farr=0.0_fp
           zlbl1='PREACT/ADAS "CX" database'
           fadas_CX=1 !cx
           wkvec(1:n2,2)=evec2
           do i=1,n2
              wkvec(1:n2,1)=tvec2(i)
              call hatom_btsigv(iopt,fpreact_NEUTRAL_BEAM, &
                   evec2,wkvec(1:n2,1),n2,izneut,izion, &
                   farr(1:n2,i),idum1)
           enddo
           if(allocated(tevec1)) deallocate(tevec1)
           allocate(tevec1(n2))
           if(allocated(farr2)) deallocate(farr2)
           allocate(farr2(n2,n2))
           farr2=0.0_fp
           wkvec(1:n2,1)=tvec2(1:n2)
           do i=1,n2
              tevec1=tvec2(i)
              call adas_btsigv(fadas_CX,NEUTRAL,evec2,tevec1,n2,izneut,dble(izion),farr2(1:n2,i),idum1)
!           ikey=2 ! for FOR BEAM TARGET <sig*v>
           enddo
           flbl='PREACT: <sigma*v> CX'
           flbl2='ADAS: <sigma*v> CX'
           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izion
           call r8_grf3f2(evec2,farr,farr2,tvec2,wkvec,n2,n2,n2, &
                'beam Eb/Ab',flbl,flbl2,'target Ti/Ai', &
                'KeV(Eb/Ab)',funs,'KeV(Ti/Ai)',zlbl1,zbzi,0)
           

        endif
     endif

  enddo

end subroutine plot_fp_cx

C  Get all dimensions of a HDF U-file
C
C Scalar Values -> 1st Variables
C Data
C
C 08/14/97 CAL
C--------------------------------------------------------------------------
      subroutine ucdfdim(lun,ndim,dims,nsc,iproc,retn)
C
      use UFILES
      implicit none
 
      include "netcdf.inc"
C Input:
      integer lun
      integer ndim
C Output:
      integer nsc
      integer dims(ndim)
      integer iproc
      integer retn
 
C Definitions for processing
      integer       ichan, file_id
      integer       i
      character*10  dimnam(3)
      integer       nvars, ngatts, unlimid
      integer       rank
C
C-------------------------------------------------------------------------
C
C get file name
      call uflchk(lun,'uhdfdim',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
C---------------------------------------------------------------------------
C
C Inquire about file
         retn = nf_inq(file_id, rank, nvars, ngatts, unlimid)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9000) NF_STRERROR(retn)
 9000       format(' % UCDFDIM: nf_inq'/,
     >           '     ',a)
            return
         else
            if (unlimid .gt. 1) rank = rank - 1
C            type *,'rank =',rank
         end if
C Get number of scalors
C
      retn = nf_get_att_int(file_id,NF_GLOBAL,'num_scalars',nsc)
      if (retn .ne. 0) then
         write(ufelun,9001) NF_STRERROR(retn)
 9001    format(' % UCDFDIM: nf_get_att_in -- num_scalars '/,
     >       '     ',a)
         return
      end if
C
C Inquire dimensions
         do i=1,rank
            retn = nf_inq_dim(file_id,i,dimnam(i),dims(i))
            if (retn .ne. NF_NOERR) then
               write(ufelun,9002) i, NF_STRERROR(retn)
 9002          format(' % UCDFDIM: nf_inq_dim',i2/,
     >              '     ',a)
               return
            end if
C            type *,dimnam(i),dims(i)
         end do
      return
      end
 
 
 
 

C Close a netCDF Ufile
      subroutine cdfclos(file_id)
C
      use UFILES
      implicit none
C
      include "netcdf.inc"
C
C Input
      integer file_id
      integer ierr
C
C---------------------------------------------------------------------
C
      ierr = nf_close(file_id)
 
      if (ierr .ne. NF_NOERR) then
         write(ufelun,9000) NF_STRERROR(IERR)
 9000    format(' ? CDFCLOS: nf_close '/,'     ',A)
      end if
      return
      end
 

subroutine r8jaceval(DR0DRO,DRMDRO,DYMDRO,RMSPL,YMSPL, &
     ZSNTHTK,ZCSTHTK,NMOM,ZJAC)
  !
  !  evaluate 2x2 jacobian using moments and derivatives
  !    ** symmetric formula **
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: nmom,imul
  real(fp) :: rmspl(nmom),ymspl(nmom)
  real(fp) :: dr0dro,drmdro(nmom),dymdro(nmom)
  real(fp) :: zcsthtk(nmom),zsnthtk(nmom)
  !
  real(fp) :: zjac(2,2)
  !
  !--------------------------------
  !
  ZJAC(1,1)=DR0DRO
  ZJAC(1,2)=0.0_fp
  !
  ZJAC(2,1)=0.0_fp
  ZJAC(2,2)=0.0_fp
  !
  do IMUL=1,NMOM
    ZJAC(1,1)=ZJAC(1,1)+DRMDRO(IMUL)*ZCSTHTK(IMUL)
    ZJAC(1,2)=ZJAC(1,2)-RMSPL(IMUL)*IMUL*ZSNTHTK(IMUL)
    !
    ZJAC(2,1)=ZJAC(2,1)+DYMDRO(IMUL)*ZSNTHTK(IMUL)
    ZJAC(2,2)=ZJAC(2,2)+YMSPL(IMUL)*IMUL*ZCSTHTK(IMUL)
  end do
  !
  return
end subroutine r8jaceval

c---------------------------------------------------------/UTKSET
c     Set terminal to reverse, bold, underline or normal.
C  MOD DMC-- CODE BY J. MURPHY ADAPTED FOR USE IN UREAD LIBRARY
C  UREAD COMMON INSTEAD OF TK COMMON USED FOR DETERMINING TERMINAL
C  TYPE
C
C  DMC OCT 1991 -- modified to support UNIX systems
c
      subroutine UTKSET(set,ichange)
c
c  DMC -- FORMERLY TK_SET_TERM -- I ADDED AN ARGUMENT AND CHANGED THE
c  NAME TO FIT BETTER INTO THE UREADSUB SUBROUTINE NAMING TRADITION.
c
c     SET is 'R', 'B', 'U', 'N' for reverse, bold, underline, normal.
c
      use USERIO
c
      character*(*)   set
c
#include "fpreproc/byte_declare.h"
c
      byte_declare outbuf(4)
c
      character*1    reverse(4), bold(4), underline(4), off(4)
c
      data reverse   / ' ', '[', '7', 'm'/
      data bold      / ' ', '[', '1', 'm'/
      data underline / ' ', '[', '4', 'm'/
      data off       / ' ', '[', '0', 'm'/
c
      character*1    command
c
c  RETURN ARGUMENT:
c
      integer ichange  ! set 0 for no action
c			 ! set 1 for tty attributes changed
c
c----------------------------
c recoded for portability... (instead of '1B'x in data stmt)
c
      reverse(1)=char(27)
      bold(1)=char(27)
      underline(1)=char(27)
      off(1)=char(27)
 
      ichange = 0
C
C  UREAD COMMON-- TESTS FOR EXECUTION
C
      IF(IBATCH.EQ.1) RETURN  ! not for BATCH jobs
      IF(NTTYP.EQ.0) RETURN   ! tty type must be specified
C
C  SUPPORTED TERMINAL TYPES:
      IF((UTTYP(1:4).EQ.'V550').OR.(UTTYP(1:3).EQ.'MAC').OR.
     >   (UTTYP(1:5).EQ.'XTERM').OR.(UTTYP(1:3).EQ.'XTC')) THEN
c
         COMMAND=SET(1:1)
         CALL USPCAP(COMMAND)
         IF(COMMAND.EQ.'R') THEN
            ichange = 1
            DO I=1,4
#if __CRAY || __SX
               OUTBUF(I)=REVERSE(I)
#else
               OUTBUF(I)=ichar(REVERSE(I))
#endif
            END DO
         ENDIF
         IF(COMMAND.EQ.'B') THEN
            ichange = 1
            DO I=1,4
#if __CRAY || __SX
               OUTBUF(I)=BOLD(I)
#else
               OUTBUF(I)=ichar(BOLD(I))
#endif
            END DO
         ENDIF
         IF(COMMAND.EQ.'U') THEN
            ichange = 1
            DO I=1,4
#if __CRAY || __SX
               OUTBUF(I)=UNDERLINE(I)
#else
               OUTBUF(I)=ichar(UNDERLINE(I))
#endif
            END DO
         ENDIF
         IF(COMMAND.EQ.'N') THEN
            ichange = 1
            DO I=1,4
#if __CRAY || __SX
               OUTBUF(I)=OFF(I)
#else
               OUTBUF(I)=ichar(OFF(I))
#endif
            END DO
         ENDIF
C
         call term_out(outbuf,4)
c
      end if  ! SUPPORTED TTY TYPE BLOCK
c
      return
      end

C---------------------------------------------------------------
C  GSCRSC - RESCUSCITATE PREVIOUSLY USED PLOT SCALE
C
C  ALLOW USER TO SELECT SCALE FROM A PREVIOUSLY DRAWN GRAPH
C
      SUBROUTINE GSCRSC(ISET)
C
C  OUTPUT ISET=0 IF SCALE IS *NOT* SELECTED
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      ISET=0
      IF(NSCPRV.EQ.0) THEN
        CALL UERMSG(
     >' ? GSCRSC - NO PRIOR PLOTS; CANNOT RESET SCALE',' ',1)
        RETURN
      ENDIF
C
 10   CONTINUE
C
      IF(LXOUT(0)) THEN
        CALL NEUPAG
        WRITE(LNOUT(0),1001)
 1001 FORMAT(' *SCALES OF RECENTLY DRAWN GRAPHS (1 = MOST RECENT)'/
     >'   N   XMIN        XMAX        YMIN        YMAX'/
     >'  --  ----------- ----------- ----------- -----------')
        DO 20 ISC=1,NSCPRV
          IN0=NCURSC+MXSPRV-ISC
          IND=MOD(IN0,MXSPRV)+1
          WRITE(LNOUT(0),1002) ISC,XMINP(IND),XMAXP(IND),
     >             YMINP(IND),YMAXP(IND)
 1002 FORMAT(2X,I2,1X,4(1X,1PE11.4))
 20     CONTINUE
      ENDIF
C
      CALL UREAD(
     >'GSCRSC:  ENTER NUMBER N TO SELECT SCALE OR "Q" TO QUIT:$$')
      IF(LCHAR('Q')) RETURN
C
      ID=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 10
      IF((ID.LE.0).OR.(ID.GT.NSCPRV)) THEN
        CALL UERMSI('?GSCRSC - INPUT OUT OF RANGE',ID,1)
        GO TO 10
      ENDIF
C
      IN0=NCURSC+MXSPRV-ID
      ISET=MOD(IN0,MXSPRV)+1
C
      XMIN=XMINP(ISET)
      XMAX=XMAXP(ISET)
C
      YMIN=YMINP(ISET)
      YMAX=YMAXP(ISET)
C
      RETURN
      END

subroutine zstop_sigvz(izneut,zimp,eova,n,sigv)
 
  use hatom_mod
  implicit NONE
 
  !  neutral stopping rate coefficient (cx + ii) for neutral atom
  !  (Z=izneut) striking an impurity population with relative energy
  !  per amu EovA (KeV/nucleon) -- or mp*vrel**2/2 expressed in KeV
  !  via table lookup
  !
  !  tables provided for H,He,Li
  !         interacting with C and O
  !         other Zimp => interpolation or scaling by Z of C and/or O
  !         rate coefficients
  !
  !  note that Zimp is a floating point number... some codes use
  !  "model impurities" representing an aggregate population and with
  !  non-integer average Z value.
 
  integer, intent(in) :: izneut   ! Z of neutral atom (1, 2 or 3)
  real*8, intent(in) :: zimp      ! Z of (fully stripped light) impurity ion
  integer, intent(in) :: n        ! vector size
  real*8, intent(in) :: EovA(n)   ! rel. energy / nucleon, KeV/AMU
 
  real*8, intent(out) :: sigv(n)  ! <sigma*v> value(s) returned  m**3/sec
 
  real*8, parameter :: out_of_range=0.0  ! sigv to use when out of range

  !
  !  if iZneut is out of range, sigv(:)= out_of_range is returned...
  !
  !-----------------------
  ! local
 
  real*8 zsvc(n),zsvo(n)
  integer iok
 
  !-----------------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  iok=1
  if(zimp.lt.3) then
 
     sigv = out_of_range          ! Zimp.ge.3 required...
     iok=0
 
  else if(zimp.le.6) then
 
     ! scale down from C
 
     if(izneut.eq.1) then
 
        call sv_coldtarget_sigmatimesv(Lst_H0_C6,eova,zsvc,n)
 
     else if(izneut.eq.2) then
 
        call sv_coldtarget_sigmatimesv(Lst_He0_C6,eova,zsvc,n)
 
     else if(izneut.eq.3) then
 
        call sv_coldtarget_sigmatimesv(Lst_Li0_C6,eova,zsvc,n)
 
     else
        sigv = out_of_range
        iok=0
     endif
 
     if(iok.eq.1) sigv=(zimp/6)*zsvc
 
  else if(zimp.ge.8) then
 
     ! scale up from O
 
     if(izneut.eq.1) then
 
        call sv_coldtarget_sigmatimesv(Lst_H0_O8,eova,zsvo,n)
 
     else if(izneut.eq.2) then
 
        call sv_coldtarget_sigmatimesv(Lst_He0_O8,eova,zsvo,n)
 
     else if(izneut.eq.3) then
 
        call sv_coldtarget_sigmatimesv(Lst_Li0_O8,eova,zsvo,n)
 
     else
        sigv = out_of_range
        iok=0
     endif
 
     if(iok.eq.1) sigv=(zimp/8)*zsvo
 
  else
 
     ! interpolate btw C and O
 
     if(izneut.eq.1) then
 
        call sv_coldtarget_sigmatimesv(Lst_H0_C6,eova,zsvc,n)
        call sv_coldtarget_sigmatimesv(Lst_H0_O8,eova,zsvo,n)
 
     else if(izneut.eq.2) then
 
        call sv_coldtarget_sigmatimesv(Lst_He0_C6,eova,zsvc,n)
        call sv_coldtarget_sigmatimesv(Lst_He0_O8,eova,zsvo,n)
 
     else if(izneut.eq.3) then
 
        call sv_coldtarget_sigmatimesv(Lst_Li0_C6,eova,zsvc,n)
        call sv_coldtarget_sigmatimesv(Lst_Li0_O8,eova,zsvo,n)
 
     else
        sigv = out_of_range
        iok=0
     endif
 
     if(iok.eq.1) sigv=((zimp-6)*zsvo+(8-zimp)*zsvc)/2
 
  endif
 
end subroutine zstop_sigvz

subroutine f_upwind0(UPWIND0,zdiffus,zdravi,zveloc,zphip1,zphi)

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, one
  implicit none

  !  evaluate upwind adjustment
  !  on output:  zphip1=0.5, zphi=0.5 => no upwind adjustment
  !  on output:  zphip1=0.0, zphi=1.0 => full upwind adjustment (outflow)
  !  on output:  zphip1=1.0, zphi=0.0 => full upwind adjustment (inflow)
  !    intermediate adjustments possible; zphi+zphip1 = 1.0 always.

  !-------------------------------------------

  real(fp), intent(in) :: UPWIND0   ! upwind parameter (dimensionless)

  !  roughly, this limits fluctuations df/f that can occur due to lack
  !  of upwind differencing; the smaller the value set, the stronger
  !  the upwind adjustment that will be made

  !  the following dimensional quanties can be cgs or mks but choose
  !  one or the other

  real(fp), intent(in) :: zdiffus   ! diffusivity  (cm2/sec) or (m2/sec)  .ge. 0
  real(fp), intent(in) :: zdravi    ! <1/dr> (1/cm) or (1/m) -- surface spacing
  real(fp), intent(in) :: zveloc    ! flow velocity (cm/sec) or (m/sec)

  !  output

  real(fp), intent(out) :: zphip1   ! weight on outward zone
  real(fp), intent(out) :: zphi     ! weight on inward zone

  !---------------------------------------
  ! local:
  real(fp) :: zalph
  !---------------------------------------

  if(zdiffus.eq.zero) then

    !  special case: DIFFUSIVITY = ZERO

    if(zveloc.gt.zero) then
      zphi=one
      zphip1=0.0

    else if(zveloc.lt.zero) then
      zphi=0.0
      zphip1=one

    else
      zphi=half
      zphip1=half
    endif

    return

  endif

  if(zveloc.eq.zero) then

    !  special case: VELOCITY = ZERO

    zphi=half
    zphip1=half

    return

  endif

  !  normal case:  both D and v are non-zero; look at ratio...
  !  normalizing factor UPWIND0 from TRANSP namelist...

  zalph = min(one, UPWIND0*zdiffus*zdravi/abs(zveloc) )

  if(zveloc.gt.zero) then

    zphip1=zalph*half
    zphi=one-zphip1

  else

    zphi=zalph*half
    zphip1=one-zphi

  endif

  return
end subroutine f_upwind0

module namerefs

  implicit none
  save

  !  expandable array of names
  character(len=64), dimension(:), pointer :: clist,clist_tmp

  !  work strings
  character(len=64) :: wk1,wk2,wk3

  !  expandable ordering array
  integer, dimension(:), pointer :: chord,chord_tmp

  !  expandable reference counter arrays
  integer, dimension(:), pointer :: nrefs,nrefs_tmp

  !  list size (in use, available space) (starts at zero)
  integer :: nsize = 0
  integer :: nmax = 0

  integer :: iupper = 1  ! set to zero to make upper/lower case distinct

contains

  subroutine expand

    integer :: init1

    if(nmax.eq.0) then
       init1=1          ! initial list -- length 64
       nmax=64
       allocate(clist(nmax))
       allocate(chord(nmax))
       allocate(nrefs(nmax))
    else
       init1=nmax       ! expand list by factor of 2
       nmax=4*nmax
       allocate(clist_tmp(nmax))
       allocate(chord_tmp(nmax))
       allocate(nrefs_tmp(nmax))
       clist_tmp(1:init1)=clist
       chord_tmp(1:init1)=chord
       nrefs_tmp(1:init1)=nrefs
       deallocate(clist,chord,nrefs)
       clist => clist_tmp
       chord => chord_tmp
       nrefs => nrefs_tmp
       nullify(clist_tmp)
       nullify(chord_tmp)
       nullify(nrefs_tmp)
       init1=init1+1
    endif

    clist(init1:nmax)=' '
    chord(init1:nmax)=0
    nrefs(init1:nmax)=0

  end subroutine expand

end module namerefs

subroutine r8bsmoo_init(imj,icentr,iedge,zsmoo,zxi)
  use iso_c_binding, only: fp => c_double
  use r8bsmoo_mod
  implicit none

  integer, intent(in) :: imj   ! grid array size
  integer, intent(in) :: icentr,iedge   ! active grid limits
  real(fp), intent(in) :: zsmoo    ! smoothing parameter
  real(fp), intent(in) :: zxi(imj,2)        ! the grid (TRCOM style)

  !  ***** initialize the module *****

  mj=imj
  lcentr=icentr
  ledge=iedge

  if(allocated(xi)) deallocate(xi)
  allocate(xi(mj,2))

  xi = zxi

  dxbsmoo = zsmoo

  lcp1 = lcentr+1
  lep1 = ledge+1

  nzones = ledge-lcentr + 1

  return
end subroutine r8bsmoo_init
 
subroutine r8bsmoo_get(zsmoo)
  use iso_c_binding, only: fp => c_double
  use r8bsmoo_mod

  implicit none

  real(fp), intent(out) :: zsmoo

  zsmoo = dxbsmoo

  return
end subroutine r8bsmoo_get

!------------------------------------------------------------------------------
!
!  SIGALAD_Z -- READ CROSS SECTION FIT COEFFICIENTS FROM ALADDIN DATA FILE
!
SUBROUTINE SIGALAD_Z
!
!
!  Modified:
!  10/07/94 TBT added Lithium.
!   6/13/00 PCR where indicated.
!
!  USED TO LOAD COMMON FOR SIGTAB PROGRAM, SO THAT DESIRED FITS MAY BE
!  COMPUTED.
!
!
!  ** CAUTION **
!  ALADDIN LABELS FOR REACTIONS ARE HARD CODED HERE AND USED TO IDENTIFY
!  THE REACTION WANTED.  THE LABELS ARE ALSO CODED IN SUBROUTINE SIGALL
!  WHICH CALLS ROUTINES TO ACTUALLY EVALUATE THE FITS.  ** IF A REACTION
!  LABEL CHANGES IT NEEDS TO CHANGE IN BOTH PLACES **
!
!
!  ALADDIN COMMON:
!
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod   
  use alpcom_mod   
  use alcom_mod   
  IMPLICIT NONE
!
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER ila,ier_alad
!============
  LUNALAD=87
  ALADFLAG=.TRUE.              ! PCR - Aladdin data included
!
!  PCR - new Aladdin data location...
  call UFILNAM('PREACTDIR','data/ORNL6086.DAT',ALADFILE)
!
  ILA=len_trim(ALADFILE)
  CALL ALAD_INIT_Z(LUNALAD,ALADFILE,IER_ALAD)
  IF(IER_ALAD.NE.0) THEN
     WRITE(6,'(//'' ?SIGALAD_Z -- ALADDIN FILE ACCESS FAILED.''/)')
     ALADFLAG=.FALSE.
     return
  ENDIF
!
  NUMALAD=0
!
!  GET INDIVIDUAL REACTIONS
!
  CALL SIGALAD1_Z('CX H [+1] H [+0] H [+0] H [+1]',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('ION H [+1] H [+0] H [+1] H [+1] e',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('CX2 He [+2] He [+0] He [+0] He [+2]',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z(&
       'ION  He [+2] He [+0]  He [+2] He [+1] e',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z(&
       'ION2  He [+2] He [+0]  He [+2] He [+2] 2e',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('CX  He [+2] He [+0]  He [+1] He [+1]',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('CX  He [+2] H [+0]  He [+1] H [+1]',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('ION  He [+2] H [+0]  He [+2] H [+1] e',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('CX  H [+1] He [+0]  H [+0] He [+1]',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('ION H [+1] He [+0]  H [+1] He [+1] e',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!       ------------------------ Lithium    tbt --------------------------
!
  CALL SIGALAD1_Z('CX  H [+1] Li [+0]  H [+0] Li [+1]',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('CX  He [+2] Li [+0]  He [+1] Li [+1]',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('CX2  He [+2] Li [+0]  He [+0] Li [+2]',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z('ION  H [+1] Li [+0]  H [+1] Li [+1] e',IER_ALAD)
  IF(IER_ALAD.NE.0) return
!
  CALL SIGALAD1_Z(&
       'ION  He [+2] Li [+0]  He [+2] Li [+1] e',IER_ALAD)
  IF(IER_ALAD.NE.0) return
  
  RETURN
END SUBROUTINE SIGALAD_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C------------------------------------------------------------
C  GSCREC - RECORD SCALE OF PLOT ABOUT TO BE DRAWN IN GSCALE COMMON
C
C   RECORDED SCALE MAY BE RETRIEVED FOR A FUTURE PLOT
C
      SUBROUTINE GSCREC
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      CHARACTER*8 ZSCLNM(4)  ! UREAD PARAMETER NAMES  - PLOT SCALE
      CHARACTER*12 ZSCLVL(4)  ! UREAD PARAMETER VALUES - PLOT SCALE
C
C  STRING PARAMETER NAMES-- SAVE SCALE OF LAST PLOT AS
C  UREAD STRING PARAMETERS ACCESSIBLE TO USER PROCEDURES
C
      DATA ZSCLNM/'/XMINP==','/XMAXP==','/YMINP==','/YMAXP=='/
C
C  CHECK FOR INITIAL CALL
C
      IF(NSCPRV.EQ.0) THEN
        NSCPRV=1
        NCURSC=1
      ELSE
C  CHECK IF THERE IS NO SCALE CHANGE FROM PREV. PLOT
        IF((XMINP(NCURSC).EQ.XMIN).AND.(XMAXP(NCURSC).EQ.XMAX).AND.
     >       (YMINP(NCURSC).EQ.YMIN).AND.(YMAXP(NCURSC).EQ.YMAX)) RETURN
C  CHECK FOR INCREMENT OF NUMBER OF SAVED SCALES
        IF(NSCPRV.LT.MXSPRV) THEN
          NSCPRV=NSCPRV+1
          NCURSC=NCURSC+1
        ELSE
C  IF OUT OF SPACE OVERWRITE OLDEST SAVED SCALE
          NCURSC=NCURSC+1
          IF(NCURSC.GT.MXSPRV) NCURSC=1
        ENDIF
      ENDIF
C
      XMINP(NCURSC)=XMIN
      XMAXP(NCURSC)=XMAX
      YMINP(NCURSC)=YMIN
      YMAXP(NCURSC)=YMAX
C
C  COMPATIBILITY FEATURE...
C  DMC MAR 1984-- WRITE UREAD STRING PARAMETERS RECORDING SCALE
C  OF LATEST PLOT.
C
 6001 FORMAT(1PE12.5)
      WRITE(ZSCLVL(1),6001) XMIN
      WRITE(ZSCLVL(2),6001) XMAX
      WRITE(ZSCLVL(3),6001) YMIN
      WRITE(ZSCLVL(4),6001) YMAX
C
      DO 801 IL=1,4
        CALL URDCMI(ZSCLNM(IL)//ZSCLVL(IL),IER)
 801  CONTINUE
C
      RETURN
      END

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SIGCX_Z(EREL,ANEUT)
!
!  3/28/79
!  THIS FUNCTION WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
!  PLASMA PHYSICS LAB.	THIS FUNCTION WILL CALCULATE THE CHARGE
!  EXCHANGE CROSS SECTION AS GIVEN BY EQ. 4 OF RIVIERE'S PAPER.
!
!  PARAMETER LIST:
!  EREL	  - THE RELATIVE ENERGY BETWEEN THE NEUTRAL AND THE CHARGED
!	    PARTICLE.  (KEV)
!	    EG. WNEUT+ANEUT*1.5*TI/APLASMA.
!  ANEUT  - THE ATOMIC WEIGHT OF THE NEUTRAL PARTICLE. (amu)
!
!  Units of SIGCX_Z is m**2
!
!  EE IS THE RELATIVE ENERGY (IN EV) PER AMU.
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : one,zkev2ev,zcm2tom2
  IMPLICIT NONE
  real(fp) erel,aneut,ee,al10
!============
  EE=EREL*zkev2ev/ANEUT
!  THE CROSS-SECTION IS NOW EVALUATED.
  AL10=log10(EE)
  SIGCX_Z=(1.6666e-16_fp*AL10-2.1505e-15_fp)*AL10+.6937e-14_fp
  SIGCX_Z=SIGCX_Z*zcm2tom2/(one+.1112e-14_fp*EE**3.3_fp)
  RETURN
END FUNCTION SIGCX_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

module mpi_env_mod

  ! module to contain environment information, to be shared across MPI
  ! processes perhaps.

  use mpi_proc_data
#ifdef __MPI
  use mpi
#endif
  IMPLICIT NONE

  PUBLIC
  SAVE

  ! this module is local or "private" to the portlib library.  It is only
  ! meant to be accessed by select portlib fortran routines.

  ! this module implements an MPI shared "environment".  The head node is
  ! to establish $cwd, command line arguments, and "environment variables"
  ! all stored in the memory of this module.  Then, MPI_BCAST is used to
  ! distribute this information to the child nodes.

  ! see the portlib library routines that use this module:

  ! mpi_env_comm_set(icomm) ! set MPI communicator: default is MPI_COMM_WORLD
  ! mpi_env_comm_get(icomm) ! return MPI communicator.

  ! mpi_sget_env(name,value,ierr)
  !   if name is in module, return corresponding value
  !   if not, get from environment using sget_env; store result in module.
  !   ierr-- reteurn code; 0 for normal

  ! mpi_sset_env(name,value,ierr)
  !   put name and value in module; if name already there, replace value.

  ! mpi_share_env(myid,ierr)
  !   head node (myid.eq.0): broadcast module contents;
  !   compute nodes (myid.ne.0): receive module contents.
  !   if no MPI: this routine does nothing.

  ! mpi_printenv(ilun)
  !   print environment on unit (ilun)

  ! automatic environment: on first call, the current working directory
  ! is stored under the name "_cwd", command line argument count as "_nargs",
  ! and arguments as "_argv_1", "_argv_2", etc.  These values can be 
  ! overwritten by subsequent mpi_sset_env calls.

  ! NOTE: arguments from MPICH, I attempt to screen out...

  !------------------------
  ! *** distributed error handling ***
  !     removed-- errset_mpi just calls MPI_ABORT(...)
  !     portlib routine "bad_exit" calls errset_mpi(...)
  !       errmsg_exit calls bad_exit.

  !------------------------
  ! ierr return codes:

  integer, parameter :: mpi_env_normal = 0

  integer, parameter :: mpi_env_name_error = 1
  ! name error, name rules: alphanumeric + "_" only; names are case sensitive
  !                         no imbedded blanks or control characters
  !                         non-blank length <= maxlen_name

  integer, parameter :: mpi_env_val_error = 2
  ! value error, value rules: no null or control characters.
  !                         non-blank length <= maxlen_val

  logical, parameter :: mdebug = .FALSE.  ! set .TRUE. for extra output

  !------------------------
  ! maxlen parameters

  integer, parameter :: maxlen_name = 32
  integer, parameter :: maxlen_val = 180

  !------------------------
  ! variables 

#ifdef __MPI
  integer :: mpi_env_comm = MPI_COMM_WORLD
#else
  integer :: mpi_env_comm = -1
#endif

  integer :: n_alloc_names = 0
  integer :: n_active_names = 0

  character*(maxlen_name), dimension(:), allocatable :: mpi_env_names
  character*(maxlen_val),  dimension(:), allocatable :: mpi_env_vals

  integer :: loc_myid = -1
  integer :: num_procs= -1
  !------------------------

CONTAINS

  subroutine get_loc_myid

    integer :: idum

    if(loc_myid.eq.-1) then
#ifdef __MPI
       call MPI_COMM_RANK(mpi_env_comm,loc_myid,idum)
       call MPI_COMM_SIZE(mpi_env_comm,num_procs,idum)
#else
       loc_myid = 0
       num_procs= 1
#endif
    endif
  end subroutine get_loc_myid

  subroutine legal_name(namstr,ilen,ierr)
    character*(*), intent(in) :: namstr
    integer, intent(out) :: ilen
    integer, intent(out) :: ierr

    ! determine if name is legal; return non-blank length

    !------------------------
    character*63, parameter :: lchars = &
         '0123456789abcdefghijklmnopqrstuvwxyz_ABCDEFGHIJKLMNOPQRSTUVWXYZ'

    integer :: ic,iloc
    !------------------------

    ilen = len(trim(namstr))

    if((ilen.eq.0).or.(ilen.gt.maxlen_name)) then
       ! illegal length
       ierr = mpi_env_name_error
       return

    else
       ierr = mpi_env_normal
    endif

    iloc = index(lchars,namstr(1:1))
    if(iloc.le.10) then
       ! digit or illegal character in 1st character position
       ierr = mpi_env_name_error
       return
    endif

    do ic=2,ilen
       iloc = index(lchars,namstr(ic:ic))
       if(iloc.le.0) then

          ierr = mpi_env_name_error
          exit
       endif
    enddo

  end subroutine legal_name

  subroutine legal_val(valstr,ilen,ierr)
    character*(*), intent(in) :: valstr
    integer, intent(out) :: ilen
    integer, intent(out) :: ierr

    ! determine if value is legal; return non-blank length

    !------------------------
    integer :: ic,ichv
    !------------------------

    ilen = len(trim(valstr))
    ierr = mpi_env_normal

    do ic=1,ilen
       ichv = ichar(valstr(ic:ic))
       ! if ASCII code is 127 or < 32, it is an unprintable character,
       ! deemed illegal for value strings
       if((ichv.lt.32).or.(ichv.ge.127)) then
          ierr=mpi_env_val_error
          exit
       endif
    enddo

  end subroutine legal_val

  subroutine lookup_alloc(name_in,iadr,inew)

    character*(*), intent(in) :: name_in
    integer, intent(out) :: iadr
    logical, intent(out) :: inew

    ! find slot for name (which should already have been checked for legality).

    ! allocate space if necessary
    ! if first call, create _cwd name-value pair

    !-------------------------
    integer :: ia,ifound,ialloc,nargs,ibrk,idum,ierloc
    character*(maxlen_name), dimension(:), allocatable :: tmp_names
    character*(maxlen_val),  dimension(:), allocatable :: tmp_vals
    character*(maxlen_val) :: argval
    !-------------------------

    if(n_alloc_names.eq.0) then

       ! first call

       ierloc = 0

       call get_loc_myid

       if(ierloc.ne.0) then
          write(0,*) ' ??? mpi_env_mod: get_loc_myid module call failed! '
       endif

       if(mdebug) then
          write(0,*) ' mpi_env_mod:LOOKUP_ALLOC: 1st call, loc_myid=',loc_myid
       endif

       call get_arg_count(nargs)
       nargs=max(0,min(99,nargs))

       !  screen MPICH process args...
       !  these seem to come after user args...

       ibrk=0
       do ia=1,nargs
          call get_arg(ia,argval)
          if(argval.eq.'-p4pg') then
             ibrk=ia
             exit
          endif
       enddo

       if(ibrk.gt.0) nargs=ibrk-1

       n_alloc_names=4
       do
          if(n_alloc_names.ge.(nargs+3)) exit
          n_alloc_names = n_alloc_names*2
       enddo

       allocate(mpi_env_names(n_alloc_names),mpi_env_vals(n_alloc_names))
       if(mdebug) then
          write(0,*) ' LOOKUP_ALLOC 1st call: loc_myid=',loc_myid, &
               ' n_alloc_names = ',n_alloc_names
       endif

       n_active_names=2
       mpi_env_names(1)='_cwd'
       mpi_env_names(2:)=' '
       mpi_env_vals(:)=' '

       call sget_cwd(mpi_env_vals(1))

       mpi_env_names(2)='_nargs'
       if(nargs.le.9) then
          write(mpi_env_vals(2),'(I1)') nargs
       else if(nargs.le.99) then
          write(mpi_env_vals(2),'(I2)') nargs
       endif

       do ia=1,nargs
          if(ia.le.9) then
             write(mpi_env_names(ia+2),'(a,i1)') "_argv_",ia
          else if(ia.le.99) then
             write(mpi_env_names(ia+2),'(a,i2)') "_argv_",ia
          endif

          call get_arg(ia,mpi_env_vals(ia+2))
          n_active_names = n_active_names + 1
       enddo
       if(mdebug) then
          write(0,*) ' LOOKUP_ALLOC 1st call: loc_myid=',loc_myid, &
               ' n_active_names = ',n_active_names
       endif
             
    endif

    ifound = 0
    do ia=1,n_active_names
       if(name_in.eq.mpi_env_names(ia)) then
          ifound=ia
          exit
       endif
    enddo

    if(ifound.gt.0) then
       iadr = ifound
       inew = .FALSE.
       return
    endif

    ! new name
    n_active_names = n_active_names + 1

    if(n_active_names.gt.n_alloc_names) then
       ! need to provide space
       ! copy data to temp arrays; reallocate with more space & copy back

       ialloc = n_alloc_names
       n_alloc_names = n_alloc_names*2

       if(mdebug) then
          write(0,*) ' mpi_env_mod(LOOKUP_ALLOC): loc_myid = ',loc_myid
          write(0,*) ' LOOKUP_ALLOC(',loc_myid, &
               '): expand table: size ',ialloc,' to ', &
               n_alloc_names
       endif

       allocate(tmp_names(ialloc),tmp_vals(ialloc))

       do ia=1,ialloc
          tmp_names(ia) = mpi_env_names(ia)
          tmp_vals(ia) = mpi_env_vals(ia)
       enddo
       
       deallocate(mpi_env_names,mpi_env_vals)
       allocate(mpi_env_names(n_alloc_names),mpi_env_vals(n_alloc_names))

       do ia=1,ialloc
          mpi_env_names(ia) = tmp_names(ia)
          mpi_env_vals(ia) = tmp_vals(ia)
       enddo
       do ia=ialloc+1,n_alloc_names
          mpi_env_names(ia) = ' '
          mpi_env_vals(ia) = ' '
       enddo
       if(mdebug) then
          write(0,*) ' LOOKUP_ALLOC(',loc_myid, &
               '): expansion done, n_active_names = ',n_active_names
       endif

    endif

    inew = .TRUE.
    iadr = n_active_names
    mpi_env_names(iadr) = name_in
       
    ! NOTE: value not yet set.

  end subroutine lookup_alloc
end module mpi_env_mod

C------------------------------------------------------------------
C  URDEXT  SET UREAD INDIRECT INPUT FILENAME EXTENSION
C
      SUBROUTINE URDEXT(ZFILEX)
C
C	Update:
C  TBT Aug 1993 - Changed ZFILEX to C*(*)
  
      USE USERIO
C
C	CHARACTER*3 ZFILEX
      CHARACTER*(*) ZFILEX
C
      FILEXT=ZFILEX
C
      RETURN
      END

C******************** START FILE UFSCIN.FOR ; GROUP UFILS0 ******************
C------------------------------------------------------------------
C  UFSCIN
C  INSERT NEW ENTRY IN ORDER ARRAY
C
      SUBROUTINE UFSCIN(ILOC,IPREV,NDIM,IORDER)
C
      INTEGER IORDER(NDIM)
C
C  IPREV- PREVIOUS DEFINED NUMBER OF ENTRIES IN IORDER
C  ILOC-- LOCATION TO INSERT NEW ENTRY
C
      INS=IPREV+1
C
      DO 10 I=IPREV,ILOC,-1
        IORDER(I+1)=IORDER(I)
 10   CONTINUE
C
      IORDER(ILOC)=INS
      RETURN
      END
C******************** END FILE UFSCIN.FOR ; GROUP UFILS0 ******************

C******************** START FILE UPROMT.FOR ; GROUP UREAD5 *************
C-------------------------------------------------------------
C& UPROMT  UREAD SEND PROMPT TO TTY IF INPUT IS TO BE READ FROM TTY
C
C  WRITE PROMPT TO TERMINAL IF--
C   ECHO FEATURE FOR DEBUGGING INDIRECT INPUT IS ON, OR,
C   TERMINAL USER HAS INTERACTIVE CONTROL OF MAIN PROGRAM
C
C  ECHO PROMPT TO INDIRECT OUTPUT FILE IS ONE IS BEING MADE
C
      SUBROUTINE UPROMT
      USE USERIO
C
      IF(NCHARA.LE.0) RETURN
C
C  DMC FEB 1989 -- THIS ROUTINE IS CALLED IF THE TYPEAHEAD BUFFER
C  IS EMPTY.  IF THE USER IS TO SUPPLY INPUT OR THE ECHO FLAG IS
C  SET, SEND THE PROMPT TO THE SCREEN.
C
      IF(((.NOT.NLINDI).AND.(NPRBUF.EQ.0)).OR.NLECHO) THEN
        DO 10 IL=1,NBLINE
          WRITE(LUNTRM,1999)
 10     CONTINUE
 1999   FORMAT(1X)
        CALL UPROMTX(ABUFF,NCHARA)
      ENDIF
C
      RETURN
      END
C******************** END FILE UPROMT.FOR ; GROUP UREAD5 ***************

      subroutine jacevala(DRMDROC,DYMDROC,DRMDROS,DYMDROS,
     >                    RMSPLC,YMSPLC,RMSPLS,YMSPLS,
     >                    ZSNTHTK,ZCSTHTK,NMOM,ZJAC)
c
c  evaluate 2x2 jacobian using moments and derivatives
c    ** asymmetric formula **
c
c  evaluate moments position:  asymmetric eq. moments formula
c
      real rmsplc(0:nmom),ymsplc(0:nmom),rmspls(0:nmom),ymspls(0:nmom)
      real drmdroc(0:nmom),dymdroc(0:nmom)
      real drmdros(0:nmom),dymdros(0:nmom)
      real zcsthtk(nmom),zsnthtk(nmom)
c
      real zjac(2,2)
c
c--------------------------------
c
      ZJAC(1,1)= DRMDROC(0)
      ZJAC(1,2)= 0.0
C
      ZJAC(2,1)= DYMDROC(0)
      ZJAC(2,2)= 0.0
C
      DO 151 IMUL=1,NMOM
C
         ZC = ZCSTHTK(IMUL)
         ZS = ZSNTHTK(IMUL)
C
         ZJAC(1,1) = ZJAC(1,1) + DRMDROC(IMUL)*ZC
     >      + DRMDROS(IMUL)*ZS
         ZJAC(1,2) = ZJAC(1,2) - RMSPLC(IMUL)*IMUL*ZS
     >      + RMSPLS(IMUL)*IMUL*ZC
C
         ZJAC(2,1) = ZJAC(2,1) + DYMDROC(IMUL)*ZC
     >      + DYMDROS(IMUL)*ZS
         ZJAC(2,2) = ZJAC(2,2) - YMSPLC(IMUL)*IMUL*ZS
     >      + YMSPLS(IMUL)*IMUL*ZC
C
 151  CONTINUE
C
      return
      end
 

subroutine read_word(filename,aword,ier)
 
  !  read a word from a file.  Word is terminated by a blank or null
  !  or EOF or any non-printable character.  No FORTRAN LUN is used.
 
  character*(*), intent(in) :: filename
  character*(*), intent(out) :: aword
  integer, intent(out) :: ier             ! =0: OK, otherwise "C" errno code.
 
  ! --------------------------
 
#include "fpreproc/byte_declare.h"
 
  byte_declare cfname(1+len(filename))
  byte_declare cword(1+len(aword))
 
  ! --------------------------
 
  call cstring(filename(1:len_trim(filename)),cfname,'2C')
 
  call portlib_readword(cfname,cword,len(aword)+1,ier)

  call cstring(aword,cword,'2F')
 
  return
 
end subroutine read_word

C******************** START FILE IXUOPW.FOR ; GROUP URDUTS ******************
C---------------------------------------------
C&  IXUOPW  UREAD INTEGER FCN SET IF INPUT MATCHES PASSED WORD LIST
C
      INTEGER FUNCTION IXUOPW(ZLIST,INUM)
C
      USE USERIO
C
      CHARACTER*(*) ZLIST(INUM)
C
      CHARACTER*40 ZLISTL,ZINPUT
C
C  FIND FIRST FIELD IN BUFFER
C
      ZINPUT=' '
      CALL URWORD(CBUFF,1,IC,ID)
      IF(IC.GT.0) CALL URWRDL(CBUFF(1:IC),ZINPUT,ILINP)
      call uspcap(zinput)
      ILINP=len_trim(zinput)
C
C  CHECK LIST
C
      DO 10 I=1,INUM
        ZLISTL=' '
        ILN=LEN(ZLIST(I))
        ZLISTL(1:ILN)=ZLIST(I)(1:ILN)
        CALL USPCAP(ZLISTL)
        IL=ILNURD(ZLISTL)  ! LENGTH, NOT. INCL. TRAILING BLANKS
        IF(IL.NE.ILINP) GO TO 10
C  LENGTH OF ITH ELEMENT IS CORRECT
        IF(ILINP.EQ.0) GO TO 20
        IF(ZINPUT(1:ILINP).EQ.ZLISTL(1:ILINP)) GO TO 20
C  END OF LOOP
 10   CONTINUE
C  NO MATCH IF FALL THRU
      IXUOPW=0
      RETURN
C
C  MATCH
C
 20   CONTINUE
      IXUOPW=I
C  ROTATE OUT OF BUFFER
      CALL UROTOR(ID)
C
      RETURN
      END
C******************** END FILE IXUOPW.FOR ; GROUP URDUTS ******************

subroutine plot_fp_sv(n1,n2,evec1,fvec1)

  ! plot SV data from fpreact and adas
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, zm3tocm3
  use fpreact_parameters
  use adas_mod, only : adas_zstop_sigvz,adas_btsigv,adas_bms
  implicit NONE

  ! data buffers -- uninitialized!

  integer, intent(in) :: n1,n2     ! dimension info

  real(fp) :: evec1(n1)             ! E-vector for f(E) plot
  real(fp) :: fvec1(n1),fvec(n1)             ! for f(E) plot
  real(fp), dimension(:), allocatable :: evec2, tvec2,rhvec2   ! E-vector, T-vector for f(E,T) plot
  real(fp), dimension(:,:,:), allocatable :: farr       ! real8for f(E,T) plot
  real(fp), dimension(:,:), allocatable :: wkvec   !work vector
  !----------------------------------
  integer luntrm,lnout
  logical lxout,lchar

  integer izneut,izimp,ihandle,idum1,idum2,ierr,i,ii
  integer, dimension(1) :: izimp_ar
  real(fp) erange1,erange2,trange1,trange2
  real(fp) :: targ_density1,targ_density2,targ_temp1,targ_temp2
  real(fp), dimension(:), allocatable :: conc       ! for impurity concentration from 0 to 1
  real(fp) :: targdensity(1)  ! for electron (target) density
  real(fp), dimension(1) :: targtemp  ! for target temperature
  real(fp), dimension(1) :: beam_energy ! for beam_energy
  real*4 :: r4_beam_energy !do not change real*4 to real(fp)
  character*60 zlbl1,zlbl2,zlbl3
  character*10 zbzi
  real(fp) zamu !impurit mass [amu]
  real(fp) zeova,zte,ztiova,zne,zz,zzf,ztxova
  character*140  :: adas_tables_file
  character*240 :: filename
  character*9 :: cizneut, cizion                !character izneut and izion

  luntrm=lnout(0)
  !----------------------------------
  if(lxout(0)) write(luntrm,*) &
       ' A -- ADAS [sigma*v](E/A,T/A,Ne) impurity stopping rate coefficient' 
  if(lxout(0)) write(luntrm,*) &
       ' P -- PREACT [sigma*v](E/A) impurity stopping rate coefficient' 
  if(lxout(0)) write(luntrm,*) &
       ' C -- COMPARE ADAS and PREACT impurity stopping rate coefficient' 
  if(lxout(0)) write(luntrm,*) &
       ' X -- ADAS/Excited state [sigma*v](E/A,T/A,Ne) impurity stopping rate coefficient' 
  if(lxout(0)) write(luntrm,*) &
       ' hit "," to exit' 
  call uread('select option:$')

if(lchar('P')) then !PREACT DATA
  zlbl1='preact/fpreact "SV" database'
  zlbl2='[sigma*v](E/A) impurity stopping rate coefficient'

  luntrm=lnout(0)
  write(luntrm,1001)
1001 format(/ &
         'plot of PREACT impurity-stopping of selected neutral specie as a'/ &
         'function of interaction energy-per-nucleon (E/A)'/ &
         ' hit "," to exit'/)

  izimp=6
  do
     izneut=0
     call ureadi('select neutral specie: 1 for H, 2 for He, 0 -- to exit:$',izneut)
     if(izneut.eq.0) exit
     izneut=max(1,min(2,izneut))

     call ureadi('select impurity specie: 6 for C+6, 8 for O+8:$',izimp)
     if((izimp.ne.6).and.(izimp.ne.8)) then
        call uermsi('Must select 6 or 8 for Zimp',izimp,0)
        cycle
     endif

     call zstop_handle(izneut,izimp,ihandle)
     call sv_coldtarget_erange(ihandle,erange1,erange2,idum1,idum2)
     call plot_fp_mkvec(erange1,erange2,n1,evec1)

     call zstop_sigv(izneut,izimp,evec1,n1,fvec1)

     zlbl3='stopping  impact, vs. Erel/A'
     if(izimp.eq.6) then
        if(izneut.eq.fpreact_Z_H) then
           zlbl3='stopping of H0 by C+6 impact, vs. Erel/A'
        else
           zlbl3='stopping of He0 by C+6 impact, vs. Erel/A'
        endif
     else if(izimp.eq.8) then
        if(izneut.eq.fpreact_Z_H) then
           zlbl3='stopping of H0 by O+8 impact, vs. Erel/A'
        else
           zlbl3='stopping of He0 by O+8 impact, vs. Erel/A'
        endif
     endif

     call gaxspc(3) ! log-log
     call r8_grafx1(evec1,fvec1,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
     call gaxspc(1) ! restore default

  enddo
elseif(lchar('A')) then !ADAS DATA
   zlbl1='ADAS "SV" database'
   zlbl2='[sigma*v](E/A) impurity stopping rate coefficient'
   zlbl3='stopping  impact, vs. Erel/A'
  do
     izneut=0
     call ureadi('select neutral specie: 1 for H, 2 for He, 0 -- to exit:$',izneut)
     if(izneut.eq.0) exit
     izneut=max(1,min(2,izneut))
     
     if(izneut.eq.1) then
        call ureadi('select impurity specie: from 1 for H+1 to 10 Ne+10 or more:$',izimp)
     elseif(izneut.eq.2) then
        call ureadi('select impurity specie: 1 - H+1, 2 - HE++, 4 - Be+4, 6 - C+6, 8 - O+8 :$',izimp)
     endif
     
     erange1=1.0E-3_fp
     erange2=25000._fp
     call plot_fp_mkvec(erange1,erange2,n1,evec1)
     fvec1=zero
     
     call adas_zstop_sigvz(izneut,dble(izimp),evec1,n1,fvec1,ierr)
     
     call gaxspc(3) ! log-log
     call r8_grafx1(evec1,fvec1,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
     call gaxspc(1) ! restore default
     
  enddo
elseif(lchar('C')) then !ADAS vs PREACT  DATA
   zlbl1='PREACT/ADAS "SV" database'
   zlbl2='[sigma*v](E/A) impurity stopping rate coefficient'
   zlbl3='stopping  impact, vs. Erel/A'
   izimp=6
   do
      izneut=0
     call ureadi('select neutral specie: 1 for H, 2 for He, 0 -- to exit:$',izneut)
     if(izneut.eq.0) exit
     izneut=max(1,min(2,izneut))
     
     if(izneut.eq.1) then
        call ureadi('select impurity specie: from 1 for H+1 to 10 Ne+10:$',izimp)
        if((izimp.gt.10).or.(izimp.lt.1)) then
           call uermsi('Must select from 1 to 10 for Zimp',izimp,0)
           cycle
        endif
     elseif(izneut.eq.2) then
        call ureadi('select impurity specie: 1 - H+1, 2 - HE++, 4 - Be+4, 6 - C+6, 8 - O+8 :$',izimp)
        if((izimp.ne.1).and.(izimp.ne.2).and.(izimp.ne.4).and.(izimp.ne.6).and.(izimp.ne.8)) then
           call uermsi('Must select: 1 - H+1, 2 - HE++, 4 - Be+4, 6 - C+6, 8 - O+8 ',izimp,0)
           cycle
        endif
     endif
      
      call zstop_handle(izneut,izimp,ihandle)
      call sv_coldtarget_erange(ihandle,erange1,erange2,idum1,idum2)
      call plot_fp_mkvec(erange1,erange2,n1,evec1)
      
      if(izimp.le.6) then 
         call zstop_sigv(izneut,6,evec1,n1,fvec1)
         fvec1=fvec1*izimp/6
      elseif(izimp.ge.8) then 
         call zstop_sigv(izneut,8,evec1,n1,fvec1)
         fvec1=fvec1*izimp/8
      else
         call zstop_sigv(izneut,6,evec1,n1,fvec)
         fvec=fvec*(8-izimp)/2
         call zstop_sigv(izneut,8,evec1,n1,fvec1)
         fvec1=fvec1*(izimp-6)/2
         fvec1=fvec1+fvec
      endif
      fvec=0.0_fp
      call adas_zstop_sigvz(izneut,dble(izimp),evec1,n1,fvec,ierr)
      
      call gaxspc(3) ! log-log
      call r8_grafx2(evec1,fvec1,fvec,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
      call gaxspc(1) ! restore default
   enddo

else  if(lchar('X')) then !ADAS data/excited state impurity stopping rate coefficient
  luntrm=lnout(0)
  zlbl1='ADAS "SV-CX" database'
  izimp=6
  do
     izneut=0
     if(lxout(0)) write(luntrm,*)'   %fp_SV: ADAS data available only for H (06/23/09)'
     call ureadi('select neutral specie: 1 for H, 0 -- to exit:$',izneut)
     if(izneut.eq.0) exit
     izneut=1
     !MG     izneut=max(1,min(2,izneut))
     
     call ureadi('select impurity specie: from 1 for H+1 to 10 Ne+10:$',izimp)
     if((izimp.gt.10).and.(izimp.lt.1)) then
        call uermsi('Must select from 1 to 10 for Zimp',izimp,0)
        cycle
     endif
     write(cizneut,'(i5)') izneut
     write(cizion,'(i5)') izimp
     
!in[KeV/amu]     
     erange1=1.e-3_fp
     erange2=2.5e4_fp
![cm**-3]
     targ_density1=1.e12_fp
     targ_density2=1.e16_fp
!in[KeV/amu]     
     targ_temp1=1.1e-3_fp
     targ_temp2=1.e2_fp
     
     
     
     
     if(allocated(evec2))deallocate(evec2)
     allocate(evec2(n2))
     if(allocated(conc))deallocate(conc)
     allocate(conc(n2))
        
     call plot_fp_mkvec(erange1,erange2,n2,evec2)
     
     conc = one !only one species
     
     if(lxout(0)) write(luntrm,1002)
1002 format(/&
          & '    enter "E" -- for FUNCTION VS. target Ti/Ai AND target Ne, fixed beam energy/amu'/&
          & '    enter "N" -- for FUNCTION VS. beam Erel/Ab AND target Ti/Ai, fixed elecron density,'/&
          & '    enter "T" -- for FUNCTION VS. beam Erel/Ab AND target Ne, fixed target temperature/amu.'/)
     call uread('  %fp_SV: ENTER OPTION: $')
     
     if(lchar('N')) then
        
        zlbl2='<sigma*v>(Erel/Ab,Ti/Ai) impurity stopping rate coefficient'
        
        if(allocated(tvec2))deallocate(tvec2)
        allocate(tvec2(n2))
        if(allocated(farr))deallocate(farr)
        allocate(farr(n2,1,n2))
        
        
           if(lxout(0)) write(luntrm,*)'   %fp_SV: electron density range [cm^-3]: ',&
                &targ_density1,targ_density2
           call ureadf('  %fp_SV: enter elecron density [cm^-3]: $',targdensity(1))
           if(targdensity(1).lt.targ_density1.or.targdensity(1).gt.targ_density2) then
              call uermsf('Must select density from: ',targ_density1,0)
              call uermsf('                      to: ',targ_density2,0)
              cycle
           endif
           
           call plot_fp_mkvec(targ_temp1,targ_temp2,n2,tvec2)
           
           if(allocated(wkvec))deallocate(wkvec)
           allocate(wkvec(n2,2))
           izimp_ar=izimp
           call adas_bms(evec2(1:n2),n2, izneut,conc(1:1),tvec2(1:n2),n2-1+1,&
                &              dble(izimp_ar),targdensity(1:1),1,&
                &              farr(1:n2,1:1,1:n2), iERR)!compute not only diagonal elements
           !        farr(1:n2,1,1:n2) !m**3/sec
           !        tvec2 !temperature, keV/amu
           !        evec2 !energy, keV/amu
           wkvec(1:n2,1)=tvec2 !temperature, keV/amu
           wkvec(1:n2,2)=evec2 !energy kev/amu
           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izimp
           !     call gaxspc(3) ! log-log
           call r8_grf3f1(evec2,farr,tvec2,wkvec,n2,n2,n2, &
                'beam Erel/Ab','Impurity stop.rate ','target Ti/Ai', &
                'KeV(Erel/Ab)','m**3/sec','KeV(Ti/Ai)',zlbl1,zbzi,0)
           !     call gaxspc(1) ! restore default
        else if(lchar('T')) then
           zlbl2='<sigma*v>(Erel/Ab, Ne) impurity stopping rate coefficient'
           if(allocated(tvec2))deallocate(tvec2)
           allocate(tvec2(n2))
           
           if(allocated(farr))deallocate(farr)
           allocate(farr(n2,n2,1))
           
           if(lxout(0)) write(luntrm,*)'   %fp_SV: target temperature range [KeV/amu]: ',&
                &targ_temp1,targ_temp2
           call ureadf('  %fp_SV: enter target temperature [KeV/amu]: $',targtemp(1))
           !       targtemp(1) ![KeV/amu]
           if(targtemp(1).lt.targ_temp1.or.targtemp(1).gt.targ_temp2) then
              call uermsf('Must select temperature from: ',targ_temp1,0)
              call uermsf('                          to: ',targ_temp2,0)
              cycle
           endif
           
           call plot_fp_mkvec(targ_density1,targ_density2,n2,tvec2)
           if(allocated(wkvec))deallocate(wkvec)
           allocate(wkvec(n2,2))
           
           izimp_ar=izimp
           do i=1,n2   
              wkvec(1:n2,1)=tvec2(i) !ne density [cm**-3]
              wkvec(1:n2,2)=evec2(i) ! energy [KeV]
           enddo
           call adas_bms(evec2,n2,izneut,conc,targtemp,1,&
                &              dble(izimp_ar),tvec2,n2,&
                &              farr, iERR)!compute not only diagonal elements
           ! farr(1:n2,1:n2,1) m**3/sec
           tvec2=tvec2*zm3tocm3 !ne density [m**-3]
           evec2=evec2 !energy, keV/amu
           wkvec(1:n2,1)=tvec2 !ne density [m**-3]
           wkvec(1:n2,2)=evec2 !energy kev/amu
           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izimp
           !     call gaxspc(3) ! log-log
           call r8_grf3f1(evec2,farr,tvec2,wkvec,n2,n2,n2, &
                'beam Erel/Ab','Impurity stop.rate','dens. Ne', &
                'KeV(Erel/Ab)','m**3/sec','1/m**3(density)',zlbl1,zbzi,0)
           !     call gaxspc(1) ! restore default
           
        else if(lchar('E')) then
           zlbl2='<sigma*v>(Ti/Ai, Ne) impurity stopping rate coefficient'
           if(allocated(rhvec2))deallocate(rhvec2)
           allocate(rhvec2(n2))
           
           if(allocated(tvec2))deallocate(tvec2)
           allocate(tvec2(n2))
           
           if(allocated(farr))deallocate(farr)
           allocate(farr(1,n2,n2))
           
           if(lxout(0)) write(luntrm,*)'   %fp_SV: beam energy range [KeV/amu]: ',&
                &erange1,erange2
           call ureadf('  %fp_SV:  beam energy range [KeV/amu]: $',r4_beam_energy)
           beam_energy(1)=r4_beam_energy*1.0_fp
           if(beam_energy(1).lt.erange1.or.beam_energy(1).gt.erange2) then
              call uermsf('Must select temperature from: ',erange1,0)
              call uermsf('                          to: ',erange2,0)
              cycle
           endif
           
           call plot_fp_mkvec(targ_temp1,targ_temp2,n2,tvec2) !temperature
           call plot_fp_mkvec(targ_density1,targ_density2,n2,rhvec2) !density
           if(allocated(wkvec))deallocate(wkvec)
           allocate(wkvec(n2,2))
           
           izimp_ar=izimp
           do ii=1,n2   
              wkvec(1:n2,2)=tvec2(ii) !temperature, KeV/amu
              do i=1,n2   
                 wkvec(1:n2,1)=rhvec2(i) !ne density [cm**-3]
              enddo
           enddo
           call adas_bms(beam_energy,1,izneut,conc,tvec2,n2,&
                &              dble(izimp_ar),rhvec2,n2,&
                &              farr,iERR)
           ! farr(1,1:n2,1:n2)  m**3/sec
           tvec2=tvec2 !temperature, keV/amu
           rhvec2=rhvec2*zm3tocm3 !ne density [m**-3]
           wkvec(1:n2,1)=rhvec2 !ne density [m**-3]
           wkvec(1:n2,2)=tvec2 !temperature,kev/amu
           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izimp
           !     call gaxspc(3) ! log-log
           call r8_grf3f1(tvec2,farr,rhvec2,wkvec,n2,n2,n2, &
                'Ti/Ai','Impurity stop.rate','dens. Ne', &
                'KeV(Ti/Ai)','m**3/sec','1/m**3(density)',zlbl1,zbzi,0)
           !     call gaxspc(1) ! restore default
           
        endif
     enddo
     
  endif

end subroutine plot_fp_sv

subroutine tr_r8qelg(n,epstab,reslt,abserr,res3la,nres)
  !***begin prologue  dqelg
  !***refer to  dqagie,dqagoe,dqagpe,dqagse
  !***routines called  d1mach
  !***revision date  830518   (yymmdd)
  !***keywords  epsilon algorithm, convergence acceleration,
  !             extrapolation
  !***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
  !           de doncker,elise,appl. math & progr. div. - k.u.leuven
  !***purpose  the routine determines the limit of a given sequence of
  !            approximations, by means of the epsilon algorithm of
  !            p.wynn. an estimate of the absolute error is also given.
  !            the condensed epsilon table is computed. only those
  !            elements needed for the computation of the next diagonal
  !            are preserved.
  !***description
  !
  !           epsilon algorithm
  !           standard fortran subroutine
  !           double precision version
  !
  !           parameters
  !              n      - integer
  !                       epstab(n) contains the new element in the
  !                       first column of the epsilon table.
  !
  !              epstab - double precision
  !                       vector of dimension 52 containing the elements
  !                       of the two lower diagonals of the triangular
  !                       epsilon table. the elements are numbered
  !                       starting at the right-hand corner of the
  !                       triangle.
  !
  !              reslt - double precision
  !                       resulting approximation to the integral
  !
  !              abserr - double precision
  !                       estimate of the absolute error computed from
  !                       result and the 3 previous results
  !
  !              res3la - double precision
  !                       vector of dimension 3 containing the last 3
  !                       results
  !
  !              nres   - integer
  !                       number of calls to the routine
  !                       (should be zero at first call)
  !
  !***end prologue  dqelg
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: abserr,abs,delta1,delta2,delta3,max,d1mach, &
       epmach,epsinf,error,err1,err2,err3,e0,e1,e1abs,e2,e3, &
       oflow,res,reslt,ss,tol1,tol2,tol3
  integer :: i,ib,ib2,ie,indx,k1,k2,k3,limexp,n,newelm,nres,num
  real(fp), dimension(52) :: epstab
  real(fp), dimension(3) :: res3la
  !
  !           list of major variables
  !           -----------------------
  !
  !           e0     - the 4 elements on which the computation of a new
  !           e1       element in the epsilon table is based
  !           e2
  !           e3                 e0
  !                        e3    e1    new
  !                              e2
  !           newelm - number of elements to be computed in the new
  !                    diagonal
  !           error  - error = abs(e1-e0)+abs(e2-e1)+abs(new-e2)
  !           reslt - the element in the new diagonal with least value
  !                    of error
  !
  !           machine dependent constants
  !           ---------------------------
  !
  !           epmach is the largest relative spacing.
  !           oflow is the largest positive magnitude.
  !           limexp is the maximum number of elements the epsilon
  !           table can contain. if this number is reached, the upper
  !           diagonal of the epsilon table is deleted.
  !
  !***first executable statement  dqelg
  epmach = d1mach(4)
  oflow = d1mach(2)
  nres = nres+1
  abserr = oflow
  reslt = epstab(n)
  if(n.lt.3) go to 100
  limexp = 50
  epstab(n+2) = epstab(n)
  newelm = (n-1)/2
  epstab(n) = oflow
  num = n
  k1 = n
  do i = 1,newelm
    k2 = k1-1
    k3 = k1-2
    res = epstab(k1+2)
    e0 = epstab(k3)
    e1 = epstab(k2)
    e2 = res
    e1abs = abs(e1)
    delta2 = e2-e1
    err2 = abs(delta2)
    tol2 = max(abs(e2),e1abs)*epmach
    delta3 = e1-e0
    err3 = abs(delta3)
    tol3 = max(e1abs,abs(e0))*epmach
    if(err2.gt.tol2.or.err3.gt.tol3) go to 10
    !
    !           if e0, e1 and e2 are equal to within machine
    !           accuracy, convergence is assumed.
    !           reslt = e2
    !           abserr = abs(e1-e0)+abs(e2-e1)
    !
    reslt = res
    abserr = err2+err3
    ! ***jump out of do-loop
    go to 100
10  e3 = epstab(k1)
    epstab(k1) = e1
    delta1 = e1-e3
    err1 = abs(delta1)
    tol1 = max(e1abs,abs(e3))*epmach
    !
    !           if two elements are very close to each other, omit
    !           a part of the table by adjusting the value of n
    !
    if(err1.le.tol1.or.err2.le.tol2.or.err3.le.tol3) go to 20
    ss = 0.1E+01_fp/delta1+0.1E+01_fp/delta2-0.1E+01_fp/delta3
    epsinf = abs(ss*e1)
    !
    !           test to detect irregular behaviour in the table, and
    !           eventually omit a part of the table adjusting the value
    !           of n.
    !
    if(epsinf.gt.0.1E-03_fp) go to 30
20  n = i+i-1
    ! ***jump out of do-loop
    go to 50
    !
    !           compute a new element and eventually adjust
    !           the value of result.
    !
30  res = e1+0.1E+01_fp/ss
    epstab(k1) = res
    k1 = k1-2
    error = err2+abs(res-e2)+err3
    if(error.gt.abserr) go to 40
    abserr = error
    reslt = res
40  continue
  end do
  !
  !           shift the table.
  !
50 if(n.eq.limexp) n = 2*(limexp/2)-1
  ib = 1
  if((num/2)*2.eq.num) ib = 2
  ie = newelm+1
  do i=1,ie
    ib2 = ib+2
    epstab(ib) = epstab(ib2)
    ib = ib2
  end do
  if(num.eq.n) go to 80
  indx = num-n+1
  do i = 1,n
    epstab(i)= epstab(indx)
    indx = indx+1
  end do
80 if(nres.ge.4) go to 90
  res3la(nres) = reslt
  abserr = oflow
  go to 100
  !
  !           compute error estimate
  !
90 abserr = abs(reslt-res3la(3))+abs(reslt-res3la(2)) &
        +abs(reslt-res3la(1))
  res3la(1) = res3la(2)
  res3la(2) = res3la(3)
  res3la(3) = reslt
100 abserr = max(abserr,0.5E+01_fp*epmach*abs(reslt))
  return
end subroutine tr_r8qelg

C******************** START FILE UROTOR.FOR ; GROUP URDUTS ******************
C-------------------------------------------------------------
C&  UROTOR  ROTATE USED INPUT OUT OF UREAD TYPEAHEAD BUFFER.
C
C  IF "TYPE-AHEAD" IS SET, ROTATE OUT ALREADY PROCESSED PART OF
C  INPUT BUFFER; OTHERWISE CLEAR ENTIRE BUFFER
C
      SUBROUTINE UROTOR(IC)
      USE USERIO
C
      IF(NLHOLD) THEN
        CALL UCLEAR
      ELSE
        CALL NUMCLR(IC)
      ENDIF
      RETURN
      END
C******************** END FILE UROTOR.FOR ; GROUP URDUTS ******************

C-----------------------------------------------------------------------
C  USPUNC -- SET NEW USER PUNCTUATION STRING
C
      SUBROUTINE USPUNC(ZPUNCT)
C
      USE USERIO
C
      CHARACTER*(*) ZPUNCT
C
      CHARACTER*1 ZNULL,ZBLANK,ZTAB
      CHARACTER*65 ZBAD
C
      DATA ZBLANK/' '/
      DATA ZTAB/'	'/
      DATA ZBAD/'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_$0
     >123456789"'/
C---------------------------------------
C
      ZNULL=CHAR(0)
C
      IF(ZPUNCT.EQ.' ') THEN
        LPUNCT=0
        RETURN
      ENDIF
C
      IC=0
      ILEN=LEN(ZPUNCT)
      IF((ILEN.EQ.0).OR.(ILEN.GT.16)) GO TO 910
C
C  CHECK LEGALITY OF PASSED PUNCTUATION CHARACTERS
      DO 10 IC=1,ILEN
        IF(ZPUNCT(IC:IC).EQ.ZBLANK) GO TO 900
        IF(ZPUNCT(IC:IC).EQ.ZTAB) GO TO 900
        IF(ZPUNCT(IC:IC).EQ.ZNULL) GO TO 900
        IF(INDEX(ZBAD,ZPUNCT(IC:IC)).NE.0) GO TO 900
 10   CONTINUE
C
      LPUNCT=ILEN
      UPUNCT=ZPUNCT
      RETURN
C
C------------
C  ERRORS
C
 900  CONTINUE
      WRITE(LUNTRM,9001) ZPUNCT,IC
 9001 FORMAT('?USPUNC -- ILLEGAL CHARACTER FOR PUNCTUATION'/
     >'  INPUT STRING IS "',A,'" AT CHARACTER POSITION ',I2)
      RETURN
C
 910  CONTINUE
      WRITE(LUNTRM,9101) ILEN
 9101 FORMAT(' ?USPUNC -- ARGUMENT LENGTH ERROR, ILEN=',I10)
      RETURN
      END

c  sgext.for - set/examine bppcom common
c
c
c  may-79	create module [jane murphy]
c
c  mar-86	revise slimx, slimy for 4096 resolution [met]
c
c  mar-87	add agyband, hbarst, vbarst; reorder routines. [met]
c
c  jun-88	modify slim/dlim/xlen/ylen for 4096; f77 changes.
c		add agccurv, agcgrid, agctext.  [met]
c
c  jan-90	make y routines entries of x routines to speed linking. [met]
c
c  oct-90	add agsteps, agnpts; error in agbasx if > one time base.
c		allow upper or lower case ascii argument in place.
c		set minor tick form on call to xfrm/yfrm. [met]
c
c  feb-92	reorder and make many more subroutines into entries.
c		remove x/ylabnd (set flag that was always overwritten). [met]
c
c  may-00       if CRAY use "numarg()" [cal]
c-----------------------------------------------------------/dlimx/dlimy
c * set data limits for the x/y axis
c
	subroutine dlimx(xmin,xmax)
	implicit none
c
	real    xmin, xmax, ymin, ymax
	integer ixmin,ixmax, iymin,iymax  
	include 'sgcopr_inc'
	integer is, ic, kfac, i4105, nbase
	integer ibasex, ibasey          ! Function
c
	call comset(ibasex(11),xmin)	!cxdmin, cxdmax
	call comset(ibasex(12),xmax)
	return
c
	entry dlimy(ymin,ymax)
	call comset(ibasey(11),ymin)	!cydmin, cydmax
	call comset(ibasey(12),ymax)
	return
c%
c-----------------------------------------------------------/slimx/slimy
c * set screen limits for the x/y axis
c
	entry slimx(ixmin,ixmax)
	call agseet(i4105,kfac,ic,is)
cx should check 0<ixmin<4096, 0<ixmax<4096
	call comset(ibasex(13),float(ixmin*kfac))	!cxsmin
	call comset(ibasex(14),float(ixmax*kfac))	!cxsmax
	return
c
	entry slimy(iymin,iymax)
	call agseet(i4105,kfac,ic,is)
	call comset(ibasey(13),float(iymin*kfac))	!cysmin
	call comset(ibasey(14),float(iymax*kfac))	!cysmax
	return
c%
c----------------------------------------------------------/dinitx/dinity
c * reinitialize axis variables
c
	entry dinitx
	nbase=ibasex(0)
	call comset(nbase+11,0.)	!data limits
	call comset(nbase+12,0.)
	call comset(nbase+5,0.)		!label width
	call comset(nbase+17,0.)	!number of ticks
	call comset(nbase+10,0.)	!number of decimal places
	call comset(nbase+18,0.)	!label expenent
	call comset(nbase+8,0.)		!number of minor tick marks
	return
c
	entry dinity
	nbase=ibasey(0)
	call comset(nbase+11,0.)	!data limits
	call comset(nbase+12,0.)
	call comset(nbase+5,0.)		!label width
	call comset(nbase+17,0.)	!number of ticks
	call comset(nbase+10,0.)	!number of decimal places
	call comset(nbase+18,0.)	!label exponent
	call comset(nbase+8,0.)		!number of minor tick marks
	return
	end
c%
c------------------------------------------------------------/xfrm/yfrm
c * set form of axis major tick mark (short ticks or grid lines)
c
	subroutine xfrm(ivalue)
	implicit none
	integer ivalue, irast
	real comget(80)
	common /bppcom/ comget
	integer mform(0:6)
	data mform /0,1,2,3,4,2,3/
	integer is, ic, kfac, i4105, nbase
	integer ibasex, ibasey ! Functions
	integer  max, min
	integer iloc
 
	if(ivalue.ge.0 .and. ivalue.le.6) then
	  call comset(ibasex(7),float(ivalue))		!cxfrm
	  call comset(ibasex(9),float(mform(ivalue)))	!cxmfrm
	endif
	return
c
	entry yfrm(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.6) then
	  call comset(ibasey(7),float(ivalue))		!cyfrm
	  call comset(ibasey(9),float(mform(ivalue)))	!cymfrm
	endif
	return
c%
c-----------------------------------------------------------/xmfrm/ymfrm
c * set form of axis minor tick marks
c
	entry xmfrm(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.6) then
	  call comset(ibasex(9),float(ivalue))	!cxmfrm
	endif
	return
c
	entry ymfrm(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.6) then
	  call comset(ibasey(9),float(ivalue))	!cymfrm
	endif
	return
c%
c------------------------------------------------------------/xlab/ylab
c * set which tick marks to label (0=none, 1=all major, 2=ends only)
c
	entry xlab(ivalue)
	call comset(ibasex(3),float(ivalue))	!cxlab
	return
c
	entry ylab(ivalue)
	call comset(ibasey(3),float(ivalue))	!cylab
	return
c%
cxc----------------------------------------------------------/xlabnd/ylabnd
cxc * set flag to label end ticks only
cxc
cx	entry xlabnd(ivalue)
cx	call comset(ibasex(3),2.)	!was ibasex(28)=float(ivalue)
cx	return
cxc
cx	entry ylabnd(ivalue)
cx	call comset(ibasey(3),2.)	!was ibasey(28)=float(ivalue)
cx	return
cxc%
c------------------------------------------------------------/xlen/ylen
c * set length of major tick marks
c
	entry xlen(ivalue)
	call agseet(i4105,kfac,ic,is)
	if(ivalue.ge.0) then
	  call comset(ibasex(6),float(ivalue*kfac))	!cxlen
	endif
	return
c
	entry ylen (ivalue)
	call agseet(i4105,kfac,ic,is)
	if(ivalue.ge.0) then
	  call comset(ibasey(6),float(ivalue*kfac))	!cylen
	endif
	return
c%
c------------------------------------------------------------/xloc/yloc
c * set axis location
c
	entry xloc(ivalue)
	call agseet(i4105,kfac,ic,is)
	call comset(ibasex(2),float(ivalue*kfac))	!cxloc
	return
c
	entry yloc(ivalue)
	call agseet(i4105,kfac,ic,is)
	call comset(ibasey(2),float(ivalue*kfac))	!cyloc
	return
c%
c----------------------------------------------------------/xloctp/ylocrt
c * set axis location relative to the top/right edge
c
	entry xloctp(irast)
	max = ibasey(14)
	min = ibasey(13)
	iloc = abs(comget(max)-comget(min))
	call agseet(i4105,kfac,ic,is)
	call comset(ibasex(2),float(iloc+irast*kfac))
	return
c
	entry ylocrt(irast)
	max = ibasex(14)
	min = ibasex(13)
	iloc = abs(comget(max)-comget(min))
	call agseet(i4105,kfac,ic,is)
	call comset(ibasey(2),float(iloc+irast*kfac))
	return
c%
c-----------------------------------------------------------/xneat/yneat
c * set axis "neatness" (0=fit data exactly, 1=extend to next minor tick,
c *			2=to next major tick)
c
	entry xneat(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.2) then
	  call comset(ibasex(0),float(ivalue))	!cxneat
	endif
	return
c
	entry yneat(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.2) then
	  call comset(ibasey(0),float(ivalue))	!cyneat
	endif
	return
c%
c-----------------------------------------------------------/xtype/ytype
c * set type of data (0=linear, 1=log)
c
	entry xtype(ivalue)
	if(ivalue.ge.1 .and. ivalue.le.2) then
	  call comset(ibasex(15),float(ivalue))	!cxtype
	endif
	return
c
	entry ytype(ivalue)
	if(ivalue.ge.1 .and. ivalue.le.2) then
	  call comset(ibasey(15),float(ivalue))	!cytype
	endif
	return
	end
c%
c-----------------------------------------------------------/xtics/ytics
c * set number of tick mark intervals
c
	subroutine xtics(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.19) then
	  call comset(ibasex(5),float(ivalue))	!cxtics
	endif
	return
c
	entry ytics(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.19) then
	  call comset(ibasey(5),float(ivalue))	!cytics
	endif
	return
c%
c-----------------------------------------------------------/xmtcs/ymtcs
c * set number of minor tick mark intervals
c
	entry xmtcs(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.19) then
	  call comset(ibasex(8),float(ivalue))	!cxmtcs
	endif
	return
c
	entry ymtcs(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.19) then
	  call comset(ibasey(8),float(ivalue))	!cymtcs
	endif
	return
c%
c-----------------------------------------------------------/xwdth/ywdth
c * set max number of characters in tick mark labels
c  if ivalue < 5, sets the max characters in the tick label
c  if ivalue >=5, sets the min value of the tick remote exponent
c
	entry xwdth(ivalue)
	if(ivalue.ge.1 .and. ivalue.le.8) then
	  call comset(ibasex(16),float(ivalue))	!cxwdth
	endif
	return
c
	entry ywdth(ivalue)
	if(ivalue.ge.1 .and. ivalue.le.8) then
	  call comset(ibasey(16),float(ivalue))	!cywdth
	endif
	return
c%
c-----------------------------------------------------------/xzero/yzero
c * set flag to force axis to include origin
c
	entry xzero(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.1) then
	  call comset(ibasex(1),float(ivalue))	!cxzero
	endif
	return
c
	entry yzero(ivalue)
	if(ivalue.ge.0 .and. ivalue.le.1) then
	  call comset(ibasey(1),float(ivalue))	!cyzero
	endif
	return
	end
c%
c------------------------------------------------------------/line
c * set type of line to draw
c
	subroutine line(ivalue)
	implicit none
	integer ivalue, ivalx, ivaly, ivals, ivali , nbase
	real    value
	integer ibasec, ibasey     ! function
	call comset(ibasec(0),float(ivalue))
	return
c%
c------------------------------------------------------------/npts/agnpts
c * set number of points in the data array
c
	entry npts(ivalue)
	call comset(ibasec(4),float(ivalue))	!npty
	call comset(ibasec(14),float(ivalue))	!nptx
	return
c
	entry agnpts(ivalx,ivaly)
	call comset(ibasec(4),float(ivaly))	!npty
	call comset(ibasec(14),float(ivalx))	!nptx
	return
c%
c-----------------------------------------------------------/sizes
c * set the size of the data point symbol
c
	entry sizes(value)
	call comset(ibasec(7),value)	!sizes
	return
c%
c-----------------------------------------------------------/stepl
c * set increment between data points for line connections
c
	entry stepl(ivalue)
	call comset(ibasec(5),float(ivalue))	!cstepl
	return
c%
c-----------------------------------------------------------/steps/agsteps
c * set increment between data point symbols (and offset to first symbol)
c
	entry steps(ivalue)
	call comset(ibasec(2),float(ivalue))	!csteps	call comset(ibasec(6),0.)	!cfrsts
	return
c
	entry agsteps(ivals,ivali)
	call comset(ibasec(2),float(ivals))	!csteps
	call comset(ibasec(6),float(ivali))	!cfrsts
	return
c%
c-----------------------------------------------------------/symbl
c * set type of data point symbol to draw
c
	entry symbl(ivalue)
	call comset(ibasec(1),float(ivalue))	!symbl
	return
	end
c%
c----------------------------------------------------------/hbarst/vbarst
c * set line type to horizontal/vertical bar
c
	subroutine hbarst(ishade,iwbar,idbar)
	implicit none
	integer ishade,iwbar,idbar
	real comget(80)
	common /bppcom/ comget
	real ticfrm
	integer nbase
	integer ibasec, ibasey, ibasex   ! Function

	nbase=ibasec(0)
	call comset(nbase,-3.)
	if(ishade.ge.0 .and. ishade.le.15) then
	  call comset(nbase+1,float(ishade))
	endif
	call comset(nbase+8,float(iwbar))
	call comset(nbase+7,float(idbar))
c * alter tick mark specification to prevent lines thru bars
	nbase=ibasey(0)
	ticfrm=comget(nbase+7)
	if(ticfrm.eq.5.) ticfrm=2.
	if(ticfrm.eq.6.) ticfrm=1.
	call comset(nbase+7,ticfrm)
	return
c
	entry vbarst(ishade,iwbar,idbar)
	nbase=ibasec(0)
	call comset(nbase,-2.)
	if(ishade.ge.0 .and. ishade.le.15) then
	  call comset(nbase+1,float(ishade))
	endif
	call comset(nbase+8,float(iwbar))
	call comset(nbase+7,float(idbar))
c * alter tick mark specification to prevent lines thru bars
	nbase=ibasex(0)
	ticfrm=comget(nbase+7)
	if(ticfrm.eq.5.) ticfrm=2.
	if(ticfrm.eq.6.) ticfrm=1.
	call comset(nbase+7,ticfrm)
	return
	end
c%
c-----------------------------------------------------------/place
c * set the screen window from ascii location
c
	subroutine place(code)
	implicit none
	character code*3
	character*3 litary(13),ucode
	integer i, kfac
	real screen(4,13)
	integer i4105, if, ic, is
c * table of ascii names for locations
	data litary/'STD','UPH','LOH','UL4','UR4','LL4','LR4','UL6',
     >  'UC6','UR6','LL6','LC6','LR6'/
c * table of co-ordinates for locations (xmin,xmax,ymin,ymax)
	data screen/150.,900.,125.,700.,
     1		 150.,850.,525.,700.,
     2		 150.,850.,150.,325.,
     3		 150.,450.,525.,700.,
     4		 650.,950.,525.,700.,
     5		 150.,450.,150.,325.,
     6		 650.,950.,150.,325.,
     7		 150.,325.,525.,700.,
     8		 475.,650.,525.,700.,
     9		 800.,975.,525.,700.,
     1		 150.,325.,150.,325.,
     2		 475.,650.,150.,325.,
     3		 800.,975.,150.,325./

	integer ibasex, ibasey  ! Functions

c * convert to upper case
	call iag_upcase(ucode,code)
c * search for a literal match
	do i=1,13
	  if(ucode.eq.litary(i)) go to 200
	enddo
c * see if it is an integer index
	i=ichar(code(1:1))
c * default to full screen
	if(i.le.0 .or. i.gt.13) i=1
c
200	call agseet(i4105,kfac,ic,is)
c * set the screen co-ordinates into common
	call comset(ibasex(13),screen(1,i)*kfac)
	call comset(ibasex(14),screen(2,i)*kfac)
	call comset(ibasey(13),screen(3,i)*kfac)
	call comset(ibasey(14),screen(4,i)*kfac)
	return
	end
c%
c---------------------------------------------------------/agccurv
c * set the curve color for 4105 output
c
	subroutine agccurv(ivalue)
	implicit none
	integer ivalue
	integer i4105, if, ic, is
	integer ibasec   ! Function
	call agseet(i4105,if,ic,is)
	if(i4105.ne.0) call comset(ibasec(10),float(ivalue))
	return
c
c---------------------------------------------------------/agcgrid
c * set the grid color for 4105 output
c
	entry agcgrid(ivalue)
	call agseet(i4105,if,ic,is)
	if(i4105.ne.0) call comset(ibasec(11),float(ivalue))
	return
c
c---------------------------------------------------------/agctext
c * set the text color for 4105 output
c
	entry agctext(ivalue)
	call agseet(i4105,if,ic,is)
	if(i4105.ne.0) call comset(ibasec(12),float(ivalue))
	return
	end
c%
c----------------------------------------------------------/agbasx
c * set the number of bases in the data array
c
	subroutine agbasx(ivalue)
	implicit none
	integer ivalue
	real    value
	integer ibasec, ibasey   ! Function

	if(ivalue.gt.1) then
	  call agsalf
c	  type *, 'agbasx: multiple bases no longer allowed'
	  call at_msg('agbasx: multiple bases no longer allowed')
	  call agsgrf
	endif
	call comset(ibasec(9),float(ivalue))	!agbasx
	return
c%
c-----------------------------------------------------------/infin
c * specify largest acceptable floating point number
c
	entry infin(value)
	if(value.gt.0.) call comset(ibasec(3),value)
	return
c%
c---------------------------------------------------------/agyband
c * set max variation for fast cplot "straight" line as percent of window
c
	entry agyband(value)
	if(value.ge.0 .and. value.le.20.) then
	  call comset(ibasey(21),value)	!cyband
	endif
	return
	end
c%
cxc-----------------------------------------------------------/sizel
cxc * set width of line
cxc
cx	entry sizel(value)
cx	call comset(ibasec(8),value)	!sizel
cx	return
cx	end
cxc
c%
c  sgtxt.for - text routines
c
c  jan-82	written by jane murphy
c
c  mar-82	change agths/agtvs/agtlng so string can be char or integer.
c		(jm)
c
c  apr-84	move remote exponent to end of x-axis label. (jam)
c
c  jun-85	add agvcur. (met)
c
c  apr-86	modify agtlng to get length from char string descriptor
c		if a character variable. (met)
c
c  nov-86	add local string astrin and center argument to agtlng to
c		drop leading blanks if centering. (met)
c
c  oct-87	add agtmrs/agtrs; set text color in 4105 mode. (met)
c		write vertical strings at 90 rotation in 4105 mode.
c		check for log(0) in agtcvs/agtmvs.
c
c  jun-88	fix 4096 resolution (my*kfac) for agtchs/agtmhs/agtcgt. (met)
c
c  may-90	fix bug - agtcgt not centering string.
c		move 4105 vertical strings to the left.
c
c  jan-91	scale offsets based on character size.
c		revise logic in agtchs,agtcvs to match label.
c
c  may-91	dont drop trailing blanks if string is $ terminated. [met]
c
c--------------------------------------------------------/agtchs
c * center string on x axis
c
#ifdef _CRAY
   	subroutine AGTCHS(string,length) 
#else
	subroutine agtchsl(string,length) !   
#endif
	implicit none
	integer length, ix, iy
	character string*(*)
	real comget(80)
	common /bppcom/ comget
	character astrin*80
	logical noout(0:6)	!no part of tick outside axis
	data noout /.true.,.true.,.false.,.true.,.false.,.false.,.true./
	integer nchars
	
	integer nbasex, near,  nfar, maxis, ihorz, ivert, ihalf,mx
	integer lend, iloc, lmaj, lform, iexp, loff, ilbpos
	integer my, maxscr, ic, kfac, i4105, is,  linwdt, if, itext
	integer ii, ich
	integer ibasec, ibasex, ibasey   ! Functions
c
#ifdef _CRAY
   	nchars=len_trim(string)
	if (numarg().gt.1) nchars=length  
#else
	nchars=length		!   
#endif

c  copy to astrin and get number of characters, centered
	call agtlng(string,.true.,astrin,nchars)
c  calculate center position
	nbasex=ibasex(0)
	near=comget(nbasex+13)
	nfar=comget(nbasex+14)
	maxis=(nfar-near)/2+near
c  half string length
	call csize(ihorz,ivert)
	ihalf=(nchars*ihorz)/2
	mx=maxis-ihalf
c if only end ticks are labeled, push unit label between tick labels
	lend=comget(nbasex+3)		!label ends only
	iloc=comget(nbasex+2)		!top/bottom
	lmaj=comget(nbasex+6)		!tick length
	lform=comget(nbasex+7)		!tick form
	if(noout(lform)) lmaj=7
	iexp=comget(nbasex+18)		!remote exponent
	if(iloc.le.0) then		!x bottom
	  loff=-ivert*(1.1+1.4)		!was *2.6
	  if(lend.eq.2) then		!if tick labels only at ends
	    loff=-ivert*(1.1+.5)	!push up between labels
	  elseif(iexp.ne.0) then	!if remote exponent
	    loff=loff-ivert/3		!move down to level of exponent
	    mx=mx-(4*ihorz/2)		!shorten space by exp length
	  endif
	  lmaj=-lmaj
	else				!x top
	  loff=ivert*(.45+1.5)		!was *2.0
	endif
	ilbpos=comget(ibasey(13))
	my=ilbpos+iloc+lmaj+loff
c  keep label on screen
	call agseet(i4105,kfac,ic,maxscr)
	my=min(max(my,0),maxscr*3/4)
c  move and output horizontal string
	call movabs(mx,my)
	go to 1000
c
c---------------------------------------------------------/agtmhs
c * move and output horizontal string
c
#ifdef _CRAY
   	entry AGTMHS(ix,iy,string,length)
   	nchars=len_trim(string)
	if (numarg().gt.3) nchars=length   
#else
	entry agtmhsl(ix,iy,string,length) !   
	nchars=length  !   
#endif

	go to 200
c
	entry agxmhs(ix,iy,string)
	nchars=0
 200	continue
	call agseet(i4105,kfac,ic,is)
	call movabs(ix*kfac,iy*kfac)
	go to 400
c
c--------------------------------------------------------/agtcgt
c * output centered graph title
c
#ifdef _CRAY
	entry AGTCGT(iy,string,length)
   	nchars=len_trim(string)
	if (numarg().gt.2) nchars=length
#else
	entry agtcgtl(iy,string,length)  !   
	nchars=length  !   
#endif

	call agtlng(string,.true.,astrin,nchars)
c  calculate center position
	nbasex=ibasex(0)
	near=comget(nbasex+13)
	nfar=comget(nbasex+14)
	maxis=(nfar-near)/2+near
c  half string length
	ihalf=(nchars*linwdt(1))/2
	mx=maxis-ihalf
	call agseet(i4105,kfac,ic,is)
	my=iy*kfac
	if(my.eq.0) my=ifix(comget(ibasey(14)))+15*kfac
c  move and output horizontal string
	call movabs(mx,my)
	go to 1000
c
c---------------------------------------------------------/agths
c * output horizontal string
c
#ifdef _CRAY
   	entry AGTHS(string,length)
   	nchars=len_trim(string)
	if (numarg().gt.1) nchars=length   
#else
	entry agthsl(string,length)  !   
	nchars=length  !   
#endif

	go to 400
c
	entry agxhs(string)
	nchars=0
 400	continue
c  copy to astrin and get length in nchars, not centered
	call agtlng(string,.false.,astrin,nchars)
c
 1000	continue
c  set text color
	call agseet(i4105,if,ic,is)
	if(i4105.ne.0) then
	  itext=comget(ibasec(12))
	  call agtxclr(itext)	!set text color
	  call cmdout('LT')
	  call intout(nchars)
	else
	  call alfmod		! enter ascii mode
	endif
c  output string
	do ii=1,nchars
	  ich=ichar(astrin(ii:ii))
	  call toutpt(ich)
	enddo
c  update beam position (for next character)
	call movrel(linwdt(nchars),0)
	return
	end
c%
c--------------------------------------------------------/agtcvs
c * center string on y-axis
c
#ifdef _CRAY
   	subroutine agtcvs(string,length)
#else
	subroutine agtcvsl(string,length)  !   
#endif
	implicit none
	integer length
	character string*(*)
	integer nchars, nbasey, near, nfar, maxis, if, is
	integer ihorz,ivert, ihalf, my, iwidth, iloc, lend, lmaj
	integer lform, ioff, ilbpos, mx, iy, ix, linhgt, linwdt
	integer i4105, kfac, ic, maxscr, itext
	integer ii, ich
	real comget(80)
	common /bppcom/ comget
	logical noout(0:6)	!no part of tick outside axis
	data noout /.true.,.true.,.false.,.true.,.false.,.false.,.true./
	character astrin*80
	integer ibasey, ibasex, ibasec       ! Function
c
#ifdef _CRAY
   	nchars=len_trim(string)
	if (numarg().gt.1) nchars=length 
#else
	nchars=length  !   
#endif

	call agtlng(string,.true.,astrin,nchars)
c  calculate center position
	nbasey=ibasey(0)
	near=comget(nbasey+13)
	nfar=comget(nbasey+14)
	maxis=(nfar-near)/2+near
	call agseet(i4105,if,ic,is)
c  half character length
	call csize(ihorz,ivert)
	if(i4105.ne.0) then
	  ihalf=(nchars*ihorz)/2
	else
	  ihalf=(nchars*ivert)/2
	endif
	my=(maxis+ihalf)+4
	iwidth=comget(nbasey+17)	!tick label width
c  compute x position
	iloc=comget(nbasey+2)		!top/bottom
	lend=comget(nbasey+3)		!label ends only
	lmaj=comget(nbasey+6)		!tick length
	lform=comget(nbasey+7)		!tick form
	if(noout(lform)) lmaj=7
	if(iloc.le.0) then		!bottom
	  iwidth=-iwidth
	  ioff=-ihorz*2.6
	  if(lend.eq.2) ioff=-ihorz	!was (iwidth=-1)
	  lmaj=-lmaj
	else				!top
	  ioff=ihorz*2.0
	endif
	ilbpos=comget(ibasex(13))
	mx=ilbpos+iloc+lmaj+iwidth*ihorz+ioff
	mx=max(mx,0)			!keep label on screen
	if(i4105.ne.0) mx=max(mx,ihorz/2)
	call agseet(i4105,if,ic,maxscr)
	mx=min(mx,maxscr-ihorz)
c  move and output vertical string
	call movabs(mx,my)
	go to 1000
c
c---------------------------------------------------------/agtmvs
c * move and output vertical string
c
#ifdef _CRAY
   	entry agtmvs(ix,iy,string,length)  !   
   	nchars=len_trim(string)
	if (numarg().gt.3) nchars=length
#else
	entry agtmvsl(ix,iy,string,length)  !   
	nchars=length		!   
#endif
	go to 200
c
	entry agxmvs(ix,iy,string)
	nchars=0
 200	continue
	call agseet(i4105,kfac,ic,maxscr)
	call movabs(ix*kfac,iy*kfac)
	go to 400
c
c---------------------------------------------------------/agtvs
c * output vertical string
c
#ifdef _CRAY
   	entry agtvs(string,length)
   	nchars=len_trim(string)
	if (numarg().gt.1) nchars=length 
#else
	entry agtvsl(string,length)  !   
	nchars=length		!   
#endif

	go to 400
c
	entry agxvs(string)
	nchars=0
 400	continue
	call agtlng(string,.false.,astrin,nchars)
c
 1000	continue
	ivert=linhgt(1)		! get character height
c see if can draw label vertically
	call agseet(i4105,if,ic,is)
	if(i4105.ne.0) then
c at top of string - move down length of string
	  call movrel(0,-linwdt(nchars))
	  call movrel(ivert,0)
	  itext=comget(ibasec(12))
	  call agtxclr(itext)	!set text color
	  call agtxrot(90)	!set rotation
	  call cmdout('LT')	!declare text string
	  call intout(nchars)
	endif
c loop over characters
	  do ii=1,nchars
	    if(i4105.eq.0) then
	      call movrel(0,-ivert)	! move down 1 character height
	      call toutpt(31)	  	! ascii mode
	    endif
	    ich = ichar(astrin(ii:ii))
	    call toutpt(ich)
	  enddo
c  update beam position (for next character)
	  if(i4105.eq.0) then
	    call movrel(0,-ivert)
cx	    call alfmod
	  endif
	  if(i4105.ne.0) then
	    call agtxrot(0)		!clear rotation
	  endif
cx	endif
	return
	end
c%
c---------------------------------------------------------/agtmrs
c * move and output rotated string
c
#ifdef _CRAY
   	subroutine agtmrs(ix,iy,irot,string,length)
#else
	subroutine agtmrsl(ix,iy,irot,string,length)  !   
#endif
	implicit none
	integer ix,iy,irot,length
	character string*(*)
	character astrin*80
	integer nchars, maxscr, i4105, kfac, ic, is, if
	integer itext, ii, ich
	integer ibasec   ! Function
	real    comget   ! Function
c
#ifdef _CRAY
   	nchars=len_trim(string)
	if (numarg().gt.4) nchars=length  
#else
	nchars=length  !   
#endif

	call agseet(i4105,kfac,ic,maxscr)
	call movabs(ix*kfac,iy*kfac)
	go to 400
c
c---------------------------------------------------------/agtrs
c * output rotated string
c
#ifdef _CRAY
   	entry agtrs(irot,string,length)
   	nchars=len_trim(string)
	if (numarg().gt.2) nchars=length 
#else
	entry agtrsl(irot,string,length)  !   
	nchars=length  !   
#endif

c
 400	continue
	call agtlng(string,.false.,astrin,nchars)
c
c see if 4105
	call agseet(i4105,if,ic,is)
	if(i4105.ne.0) then
	  itext=comget(ibasec(12))
	  call agtxclr(itext)	!set text color
	  call agtxrot(irot)	!set rotation
	  call cmdout('LT')	!declare text string
	  call intout(nchars)
	endif
c
c loop over characters
	do ii=1,nchars
	  ich = ichar(astrin(ii:ii))
	  call toutpt(ich)
	enddo
	if(i4105.ne.0) then
	  call agtxrot(0)	!clear rotation
	endif
	return
	end
c%
c---------------------------------------------------------/agtlng
c * determine length of string
c
	subroutine agtlng(string,center,astrin,nchars)
	implicit none
	integer nchars
	character string*(*)
	logical center		!true if string is to be centered
	character astrin*80
	character chr*1
	integer nloop, i, nc
c
	nloop=nchars		!user specified length
	if(nloop.eq.0) nloop=len(string)
	if(nloop.le.0) return	!error if still nothing
cx	  call lib$signal
	nloop=min(nloop,80)
c  count the characters
	nc=0
	do i=1,nloop
	  chr=string(i:i)
	  if(ichar(chr).eq.0) go to 2000
	  if(chr.eq.'$' .and. nchars.eq.0) then
c				!if ends in $, drop $,
	    nchars=nc-1		! but not trailing blanks
	    go to 2000
	  endif
	  if(center .and. nc.eq.0 .and. chr.eq.' ') then
c				!drop leading spaces if center
	  else
	    nc=nc+1
	    astrin(nc:nc) = chr
	  endif
	enddo
 2000	continue
c		!drop trailing spaces if center or no user length
	if(center .or. nchars.eq.0) then
	  do while (nc.gt.0 .and. astrin(nc:nc).eq.' ')
	    nc=nc-1
	  enddo
	endif
	nchars = nc
	return
	end
c%
c---------------------------------------------------------/agvcur
c * get cursor location and ascii char
c
	subroutine agvcur(uch,x,y)
	implicit none
	real x, y
	character*1 uch
	integer ich, ixa, iya
c
	call scursr(ich,ixa,iya)
	call revcot(ixa,iya,x,y)
	uch = char(ich)
	return
	end
c%
c  sgerr.for - error bar routines
c
c
c  feb-82	create new routine names. (jam)
c
c  oct-85	clip negative log error bars. (jane murphy)
c
c  jul-88	set line color for y bars.  (met)
c		remove obsolete entry names.
c
c  nov-88	get common variables only once for ageya/agexa. (met)
c		set line color for x bars.
c		handle unclipped log data - get type before checking iclip.
c
c  aug-90	make common noshr. (met)
c
c  nov-90	get data values same as in cplot (allow all data formats)
c		  in ageya/agexa. (met)
c
c  feb-91	use char width as width of tick instead of constant. [met]
c
c  feb-92	add agexsr/ageysr, single error bars of unequal lengths. [met]
c
c----------------------------------------------------------------/ageya
c * draw an array of y error bars
c
	subroutine ageya(x,y,e)
	implicit none
c
	real x(*), y(*), e(*)
	integer kxtype,kytype,iclip
	real    xmin,xmax,ymin,ymax
	common /sgerr/ kxtype,kytype,xmin,xmax,ymin,ymax,iclip

	integer isym, istepl, icurv, ifastx, ifasty, limit
	integer i, ii
	real    xfirs, xdelt, xpoint, ypoint, ebar
	integer ibasec, ibasex, ibasey, icclip   ! Functions
	real     comget                   ! function
c
	isym=comget(ibasec(1))
	istepl=comget(ibasec(5))
	icurv=comget(ibasec(10))
	call linclr(icurv)	!if(icurv.ne.1)
	call agkeys(x,y,ifastx,ifasty,limit)
	if(ifastx.eq.-1) then
	  xfirs=x(3)
	  xdelt=x(4)
	elseif(ifastx.eq.-2) then
	  xfirs=x(2)
	  xdelt=x(3)
	endif
	if(limit.eq.0) return
c
	iclip=icclip(0)		!get params once for entire array
	if(iclip.eq.0) then
	  kxtype=comget(ibasex(15))	!if clipping on, need to check x
	  xmin=comget(ibasex(26))
	  xmax=comget(ibasex(27))
	  if(kxtype.eq.2) then
	    xmin=10**xmin
	    xmax=10**xmax
	  endif
	endif
	kytype=comget(ibasey(15))	!always need to check y
	ymin=comget(ibasey(26))
	ymax=comget(ibasey(27))
	if(kytype.eq.2) then
	  ymin=10**ymin
	  ymax=10**ymax
	endif

	do i=1,limit,istepl
	  if(ifastx.gt.0) then
	    xpoint=x(ifastx)
	    ifastx=ifastx+istepl
	  else	!if(ifastx.lt.0) then
	    xpoint=xfirs+xdelt*float(i-1)
	  endif
	  if(ifasty.gt.0) then
	    ypoint=y(ifasty)
	    ebar=e(ifasty)
	    ifasty=ifasty+istepl
	  else	!if(ifasty.lt.0) then
	    ypoint=y(3)+y(4)*float(i-1)
	    ebar=e(3)+e(4)*float(i-1)
	  endif
	  call agey1(xpoint,ypoint,ebar)
	  if(isym.ne.0) call bsyms(xpoint,ypoint,isym)
	enddo
c
	return
	end
c%
c----------------------------------------------------------------/agexa
c * draw an array of x error bars
c
	subroutine agexa(x,y,e)
	implicit none
c
	real x(*), y(*), e(*)
	integer kxtype,kytype,iclip
	real    xmin,xmax,ymin,ymax
	common /sgerr/ kxtype,kytype,xmin,xmax,ymin,ymax,iclip
	integer isym, istepl, icurv, ifastx, ifasty, limit
	integer i
	real    xfirs, xdelt, xpoint, ypoint, ebar
	integer ibasec, ibasex, ibasey, icclip         ! Functions
	real    comget

c
	isym=comget(ibasec(1))
	istepl=comget(ibasec(5))
	icurv=comget(ibasec(10))
	call linclr(icurv)	!if(icurv.ne.1)
	call agkeys(x,y,ifastx,ifasty,limit)
	if(ifastx.eq.-1) then
	  xfirs=x(3)
	  xdelt=x(4)
	elseif(ifastx.eq.-2) then
	  xfirs=x(2)
	  xdelt=x(3)
	endif
	if(limit.eq.0) return
c
	iclip=icclip(0)		!get params once for entire array
	kxtype=comget(ibasex(15))	!always need to check x
	xmin=comget(ibasex(26))
	xmax=comget(ibasex(27))
	if(kxtype.eq.2) then
	  xmin=10**xmin
	  xmax=10**xmax
	endif
	if(iclip.eq.0) then
	  kytype=comget(ibasey(15))	!if clipping on, need to check y
	  ymin=comget(ibasey(26))
	  ymax=comget(ibasey(27))
	  if(kytype.eq.2) then
	    ymin=10**ymin
	    ymax=10**ymax
	  endif
	endif
c
	do i=1,limit,istepl
	  if(ifastx.gt.0) then
	    xpoint=x(ifastx)
	    ifastx=ifastx+istepl
	  else	!if(ifastx.lt.0) then
	    xpoint=xfirs+xdelt*float(i-1)
	  endif
	  if(ifasty.gt.0) then
	    ypoint=y(ifasty)
	    ebar=e(ifasty)
	    ifasty=ifasty+istepl
	  else	!if(ifasty.lt.0) then
	    ypoint=y(3)+y(4)*float(i-1)
	    ebar=e(3)+e(4)*float(i-1)
	  endif
	  call agex1(xpoint,ypoint,ebar)
	  if(isym.ne.0) call bsyms(xpoint,ypoint,isym)
	enddo
c
	return
	end
c%
c----------------------------------------------------------------/ageys
c * draw a single y error bar
c
	subroutine ageys(x,y,e)
	implicit none
c
	integer kxtype,kytype,iclip
	real    xmin,xmax,ymin,ymax
	common /sgerr/ kxtype,kytype,xmin,xmax,ymin,ymax,iclip
	real    x, y, e, em, ep, elo, ehi
	integer ltic, linwdt
	real    ym,   yp
	integer icclip, ibasey, ibasex   ! Functions
	real    comget                   ! Function
c
	em=e
	ep=e
	go to 100
c----------------------------------------------------------------/ageysr
c * draw single y error bar with unequal lengths
c
	entry ageysr(x,y,elo,ehi)
c
	em=elo
	ep=ehi
c
 100	continue
	iclip=icclip(0)
	if(iclip.eq.0) then
	  kxtype=comget(ibasex(15))
	  xmin=comget(ibasex(26))
	  xmax=comget(ibasex(27))
	  if(kxtype.eq.2) then
	    xmin=10**xmin
	    xmax=10**xmax
	  endif
	endif
	kytype=comget(ibasey(15))
	ymin=comget(ibasey(26))
	ymax=comget(ibasey(27))
	if(kytype.eq.2) then
	  ymin=10**ymin
	  ymax=10**ymax
	endif
	ym=y-em
	yp=y+ep
	go to 200
c
	entry agey1(x,y,e)
c
	ym=y-e
	yp=y+e
c
 200	continue
c
	if(iclip.eq.0) then
	  if(x.lt.xmin .or. x.gt.xmax) return	!x out of range
	  if(ym.le.ymin .and. yp.le.ymin) return	!off bottom
	  if(ym.ge.ymax .and. yp.ge.ymax) return	!off top
	endif
	ltic=linwdt(1)
c
	if(yp.le.ymax .or. iclip.ne.0) then
	  call movea(x,yp)		!cross tick at top
	  call movrel(-ltic,0)
	  call drwrel(ltic*2,0)
	endif
	call movea(x,yp)		!draw vertical line
	call drawa(x,ym)		!movea/drawa do clipping
c
	if(ym.ge.ymin .or. iclip.ne.0) then
	  call movrel(-ltic,0)		!cross tick at bottom
	  call drwrel(ltic*2,0)
	  call movea(x,y)
	endif
c
	return
	end
c%
c----------------------------------------------------------------/agexs
c * draw a single x error bar
c
	subroutine agexs(x,y,e)
	implicit none
c
	integer kxtype,kytype,iclip
	real    xmin,xmax,ymin,ymax
	common /sgerr/ kxtype,kytype,xmin,xmax,ymin,ymax,iclip
	real    x, y, e, em, ep, elo, ehi
	integer ltic, linwdt
	real    ym, yp, xm, xp
	integer icclip, ibasex, ibasey   ! Functions
	real    comget                   ! Function
c
	em=e
	ep=e
	go to 100
c----------------------------------------------------------------/agexs
c * draw single x error bar with unequal lengths
c
	entry agexsr(x,y,elo,ehi)
c
	em=elo
	ep=ehi
c
 100	continue
	iclip=icclip(0)
	kxtype=comget(ibasex(15))
	xmin=comget(ibasex(26))
	xmax=comget(ibasex(27))
	if(kxtype.eq.2) then
	  xmin=10**xmin
	  xmax=10**xmax
	endif
	if(iclip.eq.0) then
	  kytype=comget(ibasey(15))
	  ymin=comget(ibasey(26))
	  ymax=comget(ibasey(27))
	  if(kytype.eq.2) then
	    ymin=10**ymin
	    ymax=10**ymax
	  endif
	endif
	xm=x-em
	xp=x+ep
	go to 200
c
	entry agex1(x,y,e)
c
	xm=x-e
	xp=x+e
c
 200	continue
	if(iclip.ne.0) then
	  if(y.lt.ymin .or. y.gt.ymax) return	!y out of range
	  if(xm.le.xmin .and. xp.le.xmin) return	!off left
	  if(xm.ge.xmax .and. xp.ge.xmax) return	!off right
	endif
c
	ltic=linwdt(1)
	if(xp.le.xmax .or. iclip.ne.0) then
	  call movea(xp,y)		!cross tick at right
	  call movrel(0,-ltic)
	  call drwrel(0,ltic*2)
	endif
	call movea(xp,y)		!draw horizontal line
	call drawa(xm,y)		!movea/drawa do clipping
c
	if(xm.ge.xmin .or. iclip.ne.0) then
	  call movrel(0,-ltic)		!cross tick at bottom
	  call drwrel(0,ltic*2)
	  call movea(x,y)
	endif
c
	return
	end

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SGPLIX(ZE)
 
!       Lithium Fudge  tbt 10/94
!
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER i
!============
! idecl:  explicitize implicit real(fp) declarations:
  real(fp) ze2,zemin,zemax,zeuse,zle,zls,zlss,zle2,za2,zans
!============
  real(fp) ZE
!
!  ZE IN EV
!  SGPHEX IN !M**2
!
!  JANEV-LANGER-EVANS-POST,
!  ELEMENTARY PROCESSES IN HYDROGEN-HELIUM PLASMAS
!  FIT FOR REACTION 3.3.1,  H+ + HE --> H + HE+
!    CHARGE EXCHANGE
!
!  FIT TABLE IN SS 8.1, P. 252
!
  real(fp) A331(9)
  DATA A331/-4.88373464e+01_fp,-7.86457732_fp,&
       1.05151860e+01_fp,&
       -4.73160090_fp, 1.16983075_fp,&
       -1.75034491e-01_fp,&
       1.57493444e-02_fp,-7.78484946e-04_fp,&
       1.61195349e-05_fp/
!
  LOGICAL EXTRAP
!
  EXTRAP=.FALSE.
!
  ZE2=ZE
!
  ZEMIN=17.3_fp
  ZEMAX=100000.0_fp
  IF((ZE2.LT.ZEMIN).OR.(ZE2.GT.ZEMAX)) EXTRAP=.TRUE.
!
  ZEUSE=min(ZEMAX,max(ZEMIN,ZE2))
!
  ZLE=log(ZEUSE)
!
  ZLS=A331(9)
  IF(EXTRAP) ZLSS=8.0_fp*A331(9)
!
  DO I=8,1,-1
     ZLS=ZLS*ZLE+A331(I)
     IF(EXTRAP.AND.(I.GE.2)) ZLSS=ZLSS*ZLE+(I-1)*A331(I)
  enddo
!
  IF(EXTRAP) THEN
     ZLE2=log(ZE2)
     ZA2=0.0_fp
     IF(ZE2.LT.ZEMIN) ZLS=ZLS-ZLSS*(ZLE-ZLE2)
     IF(ZE2.GT.ZEMAX) ZLS=ZLS+(ZLE2-ZLE)*(ZLSS-ZA2*(ZLE2-ZLE))
  ENDIF
!
  ZANS = EXP(min(50.0_fp,ZLS))
!
  SGPLIX=ZANS
!
  RETURN
END FUNCTION SGPLIX
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok

C--------------------------------------------------------------------
C  GSCGT1 - GRAOPT SUBROUTINE - GET A SCALE NUMBER FROM THE USER
C
      SUBROUTINE GSCGT1(ZSUB,ZNAME,ZVAL,ZDEFLT,IRET,XTRA)
C
      CHARACTER*(*) ZSUB
      CHARACTER*(*) ZNAME
      CHARACTER*(*) XTRA
C
C  ZSUB - NAME OF CALLING SUBROUTINE, USED IN UREAD PROMPT
C
C  ZNAME - NAME OF QUANTITY TO READ E.G. "XMIN"
C   ZVAL - VALUE READ IN
C  ZDEFLT- DEFAULT VALUE TO USE IF USER TYPES IN "X"
C
C  IRET = -1 USER TYPED "Q"
C       = 0  USER TYPED IN A VALID FLOATING PT NUMBER
C       = 1  USER TYPED IN SOMETHING INCOMPREHENSIBLE
C       = 1+INDEX(XTRA,user option letter) IF USER TYPED IN AN
C          "XTRA" OPCODE
C
C  XTRA - EXTRA OPTIONS BEYOND "X", "Q" THAT THE USER MAY TYPE IN
C   **XTRA** SHOULD NOT CONTAIN NUMERAL CHARACTERS - ONLY
C   LETTERS OR BLANKS
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
           CALL UREAD(ZSUB//'>> ENTER NEW '//ZNAME//':$$')
           IF(LCHAR('Q')) THEN
             IRET=-1
           ELSE IF(LCHAR('X')) THEN
             IRET=0
             ZVAL=ZDEFLT
           ELSE
C  CHECK XTRA
             IRET=0
             IL=LEN(XTRA)
             DO 10 I=1,IL
               IF(XTRA(I:I).EQ.' ') GO TO 10
               IF(LCHAR(XTRA(I:I))) IRET=1+I
 10          CONTINUE
C  IF LETTER OPTION NOT TYPED, DECODE FLOATING PT ANSWER
             IF(IRET.EQ.0) ZVAL=FDCOD(IRET)
           ENDIF
C
           RETURN
      END

subroutine plot_fpreact

  ! main routine for uread/sglib `fpreact' data plotting tool.

  ! this routine sets up some temporary storage buffers, with
  ! user controllable sizing, and then calls a plotting routine for
  ! each type of atomic or nuclear table as requested by the user

  !  Mods
  !     20-Apr-2009  jim.conboy@jet.uk   to build Sat Jan 24 04:30:36 EST 2009
  !                  BUGFIX - wkvec is rank 2 !
  !     ----------------------------------------------------------------------

  use iso_c_binding, only: fp => c_double
  implicit NONE

  real(fp), dimension(:), allocatable :: &
       evec1, & ! Erel or Erel/A vector for 1d plots
       tvec1, & ! Te or Ti or Ti/Ai vector for 1d plots
       evec2, & ! Erel or Erel/A vector for 2d plots
       tvec2, & ! Ti or Ti/Ai vector for 2d plots
       fvec1    ! result vector for 1d plots
  real(fp), dimension(:,:), allocatable :: &
       wkvec    ! work vector

  real(fp), dimension(:,:), allocatable :: &
       farr    ! result array for 2d plots

  integer :: n1=501
  integer :: n2=201

  logical lxout,lchar
  integer luntrm,lnout

  save n1,n2

  luntrm=lnout(0)

  do

     if(allocated(evec1)) deallocate( &
          evec1,tvec1,evec2,tvec2,fvec1,wkvec,farr)

     allocate(evec1(n1),tvec1(n1),evec2(n2),tvec2(n2), &
          fvec1(n1),wkvec(max(n1,n2),2),farr(n2,n2))

     if(lxout(0)) write(luntrm,1001) n1,n2
1001 format(/ &
          ' 1d tables are dimensioned (N1), N1=',i7/ &
          ' 2d tables are dimensioned (N2,N2), N2=',i6 // &
          ' options:'/ &
          '  N -- change table dimensioning'/ &
          '  C -- plot charge exchange (cx) rate data'/ &
          '  I -- plot ion impact ionization (ii) rate data'/ &
          '  R -- plot impurity radiation and related data'/ &
          '  F -- plot fusion (fs) rate data'/ &
          '  E -- plot electron impact ionization (ei) rate data'/ &
          '  S -- plot impurity impact ionization (sv) rate data'/ &
          '  Q -- quit'/)

     call uread('plot_fpreact: select option:$')

     if(lchar('N')) then
        call ureadi('enter N1, in range [10:1000001]:$',n1)
        n1=max(10,min(1000001,n1))
        call ureadi('enter N2, in range [10:5001]:$',n2)
        n2=max(10,min(5001,n2))
     else if(lchar('C')) then
        call plot_fp_cx(n1,n2,evec1,fvec1,evec2,tvec2,wkvec,farr)
     else if(lchar('I')) then
        call plot_fp_ii(n1,n2,evec1,fvec1,evec2,tvec2,wkvec,farr)
     else if(lchar('R')) then
        call plot_fp_ce(n1,n2) !coronal equilibrium
     else if(lchar('F')) then
        call plot_fp_fs(n1,n2,evec1,tvec1,fvec1,evec2,tvec2,wkvec,farr)
     else if(lchar('E')) then
        call plot_fp_ei(n1,tvec1,fvec1)
     else if(lchar('S')) then
        call plot_fp_sv(n1,n2,evec1,fvec1)
     else if(lchar('Q')) then
        exit
     else
        call uermsg(' %plot_fpreact: unrecognized option',' ',0)
     endif

  enddo

  if(allocated(evec1)) deallocate( &
       evec1,tvec1,evec2,tvec2,fvec1,wkvec,farr)

end subroutine plot_fpreact

C******************** START FILE GAXES0.FOR ; GROUP GAXES ******************
C-------------------------------------------------------------------
C  GAXES
C  SET OF SUBROUTINES TO ALLOW USER TO ESTABLISH DEFAULTS ON AXIS
C  TYPES FOR 1-D (F(X) TYPE) PLOTS, AND TO CHECK THAT A PLOT'S SCALE
C  IS CONSISTANT WITH LOG SCALING ON THAT AXIS (I.E. NO NONPOSITIVE
C  NUMBERS)
C
C----------------------------------------------------------
C  INITIALIZATION SUBROUTINE -- INITIALIZES AXES TYPE CONTROL COMMON
C  SET UP LOCAL COMMON BLOCK FOR SETTING UP AXES TYPES OF A PLOT1
C  F(X) TYPE PLOTTING CALL
C
C  IGXINI -- FLAG THAT COMMON HAS BEEN INITIALIZED
C    IGXINI=0 MEANS NOT YET INITIALIZED-- IT IS ASSUMED THAT
C    THIS VALUE IS THE VALUE OF IGXINI AT LOAD TIME
C
      SUBROUTINE GAXES0
C
C  AXES COMMON
C
      INCLUDE 'GAXES_BLK'
C
C  CHECK FLAG
      IF(IGXINI.EQ.1) RETURN
      IGXINI=1
C
C  10 CHAR NAMES OF X,Y AXES TYPE PAIRS
      IAXNAM(1)='LINEAR    '
      IAXNAM(2)='SEMI-LOG:Y'
      IAXNAM(3)='LOG-LOG   '
      IAXNAM(4)='SEMI-LOG:X'
C
C  CODE GIVEN TO DPLOT1 (PLOT1) SUBROUTINE TO MAKE THAT AXIS PAIR
C
C  LINEAR:
      IAXCOD(1)=-11
C  SEMILOG
      IAXCOD(2)=-15
C  LOG-LOG
      IAXCOD(3)=-30
C  LOG(X)
      IAXCOD(4)=-40
C
C  MAPS =1 INDICATES AXIS IS LOGARITHMIC FOR CURRENT VALUE OF IAXSEL
      IXXMAP(1)=0
      IXXMAP(2)=0
      IXXMAP(3)=1
      IXXMAP(4)=1
C
      IXYMAP(1)=0
      IXYMAP(2)=1
      IXYMAP(3)=1
      IXYMAP(4)=0
C
C  DEFAULT SELECTION (1,2,3, OR 4)
C  DEFAULT IS LINEAR
      IAXSEL=1
C  DEFAULT MAX NUMBER OF DECADES DESIRED (RATIO XMAX/XMIN OR
C  YMAX/YMIN MAXIMUM ALLOWED FOR CORRESPONDING AXIS)
      XMXDEC=1.E3
      YMXDEC=1.E3
C
      RETURN
      END
C******************** END FILE GAXES0.FOR ; GROUP GAXES ******************

C******************** START FILE IUFKEY.FOR ; GROUP UFILS0 ******************
C------------------------------------------------------
C  IUFKEY  IDENTIFY INDEX TO ASSOCIATED SCALAR BY
C          KEYWORD
C
      INTEGER FUNCTION IUFKEY(ZKEYI,ZSCLIS,NSC)
C
C  ZKEY-- 10 CHARACTER KEYWORD
C  ZSCLIS-- LIST OF 30 CHARACTER LABELS ASSOCIATED WITH SCALAR
C    QUANTITIES.  THE FIRST 10 CHARACTERS ARE RESERVED KEYWORD
C  NSC-- NUMBER OF ENTRIES IN LIST
C	DO NOT CALL IF NSC=0
C
C  IUFKEY=INDEX TO LIST ENTRY MATCHING KEYWORD
C        =INDEX TO CORRESPONDING SCALAR QUANTITY
C        =0 IF NOT FOUND
C
      CHARACTER*(*) ZKEYI
      CHARACTER*10 ZKEY
      CHARACTER*30 ZSCLIS(NSC)
C
C  CAPITALIZE INPUT KEYWORD (UFILES KEYWORDS CAPITILIZED AT UREAD
C  FILE READ TIME)
C
      CALL UF0CAP(ZKEYI)
C
      ILEN=LEN(ZKEYI)
      ICLN=INDEX(ZKEYI,':')
      IF(ICLN.GT.0) THEN
        ZKEY=ZKEYI(1:ICLN)
      ELSE
 15     CONTINUE
          IF((ILEN.GT.1).AND.ZKEYI(ILEN:ILEN).EQ.' ') THEN
            ILEN=ILEN-1
            GO TO 15
          ENDIF
        ZKEY=ZKEYI(1:ILEN)
        ILP1=ILEN+1
        IF(ILP1.LE.10) ZKEY(ILP1:ILP1)=':'
      ENDIF
C
      DO 17 I=1,NSC
        IF(ZKEY.EQ.ZSCLIS(I)(1:10)) GO TO 20
 17   CONTINUE
C  NOT FOUND
      IUFKEY=0
      RETURN
C  FOUND
 20   CONTINUE
      IUFKEY=I
      RETURN
      	END
C******************** END FILE IUFKEY.FOR ; GROUP UFILS0 ******************

      subroutine ufsclab_ck(sclab,nsca)
c
c  check scalar labels after read
c  issue warning and patch if there is an error
c
      use UFILES
c
      integer, intent(in) :: nsca
      character*30, intent(inout) :: sclab(nsca)
c
      character*10 ztest
c
      integer i,j,iok,iblank,ilen
c-------------------
c
      do i=1,nsca
         ztest=sclab(i)(1:10)
         ilen=len_trim(ztest)
         iok=1
         iblank=0
         do j=1,ilen
            if(ichar(ztest(j:j)).lt.32) iok=0
            if(ztest(j:j).eq.' ') iblank=j
         enddo
         if(iok.eq.0) then
            write(ufelun,*) ' %ufsclab_ck: Ufile scalar #',i,
     >         ' label contains unprintable characters.'
         else
            if(ztest(ilen:ilen).ne.':') then
               write(ufelun,*) ' %ufsclab_ck: Ufile scalar #',i,
     >            ' keyword label lacks ":".'
               iok=0
            endif
            if(iblank.gt.0) then
               write(ufelun,*) ' %ufsclab_ck: Ufile scalar #',i,
     >            ' keyword label has imbedded blanks.'
               iok=0
            endif
c
c  patch keyword label...
c
            if(iok.eq.0) then
               write(ufelun,*) ' keyword: "',ztest,
     >            '" label: "',sclab(i)(11:20),'" units: "',
     >            sclab(i)(21:30),'" -- patched.'
c
               if(ztest(ilen:ilen).ne.':') then
                  if(ilen.eq.10) ilen=ilen-1
                  ilen=ilen+1
                  ztest(ilen:ilen)=':'
                  sclab(i)(ilen:ilen)=':'
               endif
c
               if(iblank.gt.0) then
                  do j=1,ilen
                     if(ztest(j:j).eq.' ') sclab(i)(j:j)='_'
                  enddo
               endif
c
            endif                       ! end patch
c
         endif                          ! label characters check
c
      enddo                             ! loop over scalar labels
c
      return
      end
 

C  dmc-- force byte(4)/integer equivalence through subroutine
C        call interface; NagWare won't let me use EQUIVALENCE
C
#include "fpreproc/byte_declare.h"
C--------------
      subroutine copyint4(intb4,intout)
      implicit NONE
      integer*4 intb4,intout
C
      intout=intb4
      return
      end
C--------------
      subroutine byte4out(byte4,ii,byteo)
C
      implicit NONE
      integer ii
      byte_declare byte4(4),byteo
C
      byteo=byte4(ii)
      return
      end

      subroutine sset_env(varname,value,ierr)
C
C  set the value of an environment variable (UNIX)
C
C Mods
C    22Dec2009    Jim.Conboy@cffe.ac.uk
C                 remove trim from cstring arg list ( fails debug compilation )
C
      implicit NONE
C
      character*(*), intent(in) :: varname
      character*(*), intent(in) :: value
      integer, intent(out) :: ierr    ! completion code (0=OK)
C
C-------------------------
#include "fpreproc/byte_declare.h"
C
      integer :: ilenvar,ilenval
C
      byte_declare, dimension(:), allocatable :: cvar,cval
      integer :: f77_setenv
C-------------------------
C
      ilenvar = len(trim(varname))
      ilenval = len(trim(value))
C
      allocate(cvar(ilenvar+1),cval(ilenval+1))  ! leave room for trailing null
C
C-      call cstring(trim(varname),cvar,'2C')
C-      call cstring(trim(value),cval,'2C')
C
      call cstring(varname(:ilenvar),cvar,'2C')
      call cstring(value(:ilenval)  ,cval,'2C')
C
      ierr = f77_setenv(cvar,cval)
      ierr = abs(ierr)
C
      return
      end

c-----------------------------------------------------------------------
c mds__copywnull
c copy source string into new string with trailing blanks removed and
c  null appended
c
c Input
c   source    -- source string to copy
c Output
c   newstring -- where to put string with null
c
c 1999-04-26 ler
c-----------------------------------------------------------------------
c Rationale:
c
c This is in support of avoiding: "string(1:l) // char(0)"
c Run-time concatenation is not supported in g77.
c
c Example of use:
c
c     integer mds_open(tree, shot)
c     character*(*) tree
c     integer shot
c     character*4097 newstring
c     call mds_copywnull(newstring, tree)
c     mds_open = MdsOpen(newstring, shot)
c     end
c
c Note: dynamic arrays not used to avoid tripping over potential
c       lack of consistency between fortran compilers
c-----------------------------------------------------------------------
      subroutine mds__copywnull(newstring, source)
      implicit none
 
      character*(*) newstring
      character*(*) source
 
      integer i, l, n
 
      newstring = source
 
      l = len(newstring)
      n = l
      do i=l,1,-1
         if (newstring(i:i).ne.' ') then
            goto 100
         else
            n = n - 1
         end if
      end do
 100  continue
 
      n = min(n,l-1)
      newstring(n+1:n+1) = char(0)
 
      end

c  sgarea.for   area fill routines derived from ncar libarary
c
c  xx-xxx-89	created module from
c
c----------------------------------------------------------------/aredam
	subroutine aredam (iam,xca,yca,lca,igi,idl,idr)
	implicit none
c
	integer  lca,igi,idl,idr
	integer iam(*)
	real    xca(*),yca(*)
	include  'sgarea_inc'
	integer iare, ixn,iyn,ign,iln,irn
	common /ncocom/ iare
	common /arecom/ ixn,iyn,ign,iln,irn
	logical more
	real    ffl,ffr,ffb,fft,ful,fur,fub,fut
	integer ill,ilx,ily,ipx
	integer lam, ipn, ixl, iyl, igl, ica
c
c the routine aredam allows the caller to add an edge, separating two
c areas from each other, to an existing area map.  the input arguments
c are as follows:
c
c iam is an integer array (dimensioned as specified by a prior call to
c the routine arinam) in which resides the area map to which an edge is
c to be added.  the user should make no direct changes in the area map;
c only routines in the package areas should be allowed to modify it.
c
c xca is an array of x coordinates of edge points.
c
c yca is an array of y coordinates of edge points.
c
c lca is the number of edge points defined by xca and yca.
c
c igi is the identifier of the group to which this edge belongs.
c
c idl is the identifier of the area to the left of the new edge.
c
c idr is the identifier of the area to the right of the new edge.
c
c upon return from aredam, all arguments are unchanged except iam, which
c contains the augmented area map.
c
c pull out the length of the area map and do a simple consistency check.
c
	lam=iam(1)
	if (iam(lam).ne.lam) then
	  call ageset ('aredam: area buffer uninitialized',1,1)
	  return
	endif
c
c pull out the current value of the pointer ipx.
c
	ipx=iam(3)
c
c use getset to set up parameters allowing us to map x and y coordinates
c from the user system to the local integer system.
c
	call getset (ffl,ffr,ffb,fft,ful,fur,fub,fut,ill)
	ilx=(ill-1)/2
	ily=mod(ill-1,2)
c
c add the group identifier to the list at the end of the area map (if
c it's not already there) and set ign to its index.  if the identifier
c is a new one, provide a boundary rectangle.
c
	ign=lam
	more=.true.
	do while (more)
	  ign=ign-1
	  if (ign.ge.iam(6)) then
	    if (mod(iam(ign),2).eq.0.and.iam(ign)/2.eq.igi) more=.false.
	  else
	    if (ign.le.iam(5)) then
	    call ageset ('aredam: area buffer overflow',2,1)
	    return
	    endif
	    iam(6)=ign
	    iam(ign)=igi*2
	    iln=-1
	    irn=0
	    ixn=0
	    iyn=0
	    call arisub1(iam,ipn,ipx)
	    if(iare.ne.0) return
	    iam(ipn+7)=0
	    iam(ipn+8)=0
	    iyn=int(lc)
	    call arisub1(iam,ipn,ipx)
	    if(iare.ne.0) return
	    ixn=int(lc)
	    call arisub1(iam,ipn,ipx)
	    if(iare.ne.0) return
	    iyn=0
	    call arisub1(iam,ipn,ipx)
	    if(iare.ne.0) return
	    ixn=0
	    call arisub1(iam,ipn,ipx)
	    if(iare.ne.0) return
	    iam(7)=iam(7)+1
	    more=.false.
	  endif
	enddo
c
c add the area identifiers to the list at the end of the area map (if
c they're not already there) and set iln and irn to their indices.
c
	if (idl.le.0) then
	  iln=idl
	else
	  iln=lam
	  more=.true.
	  do while (more)
	    iln=iln-1
	    if (iln.ge.iam(6)) then
	      if (mod(iam(iln),2).eq.1.and.iam(iln)/2.eq.idl)more=.false.
	    else
	      if (iln.le.iam(5)) then
	      call ageset ('aredam: area buffer overflow',3,1)
	      return
	      endif
	      iam(6)=iln
	      iam(iln)=idl*2+1
	      more=.false.
	    endif
	  enddo
	endif
c
	if (idr.le.0) then
	  irn=idr
	else
	  irn=lam
	  more=.true.
	  do while(more)
	    irn=irn-1
	    if (irn.ge.iam(6)) then
	      if (mod(iam(irn),2).eq.1.and.iam(irn)/2.eq.idr)more=.false.
	    else
	      if (irn.le.iam(5)) then
	      call ageset ('aredam: area buffer overflow',4,1)
	      return
	      endif
	      iam(6)=irn
	      iam(irn)=idr*2+1
	      more=.false.
	    endif
	  enddo
	endif
c
c proceed with adding the user's edge to the area map.  ixl and iyl are
c the coordinates of the last point inserted in the area map.  igl is
c the group identifier of the last point.
c
	ixl=iam(iam(22)+1)
	iyl=iam(iam(22)+2)
	igl=iam(iam(22)+7)
c
c loop through the points in the user list.
c
	do ica=1,lca
c
c get the x and y coordinates of the next point.
c
	if (ilx.eq.0) then
	  ixn=max(0,min(int(lc),
     +	  int(lc*(ffl+(ffr-ffl)*(xca(ica)-ful)/(fur-ful))+.5)))
	else
	  ixn=max(0,min(int(lc),
     +	  int(lc*(ffl+(ffr-ffl)*(alog(xca(ica))-alog(ful))/
     +	  (alog(fur)-alog(ful)))+.5)))
	endif
	if (ily.eq.0) then
	  iyn=max(0,min(int(lc),
     +	  int(lc*(ffb+(fft-ffb)*(yca(ica)-fub)/(fut-fub))+.5)))
	else
	  iyn=max(0,min(int(lc),
     +	  int(lc*(ffb+(fft-ffb)*(alog(yca(ica))-alog(fub))/
     +	  (alog(fut)-alog(fub)))+.5)))
	endif
c
c if the point to be inserted is distinct from the old point, add it.
c if it's the first point, zero its group and area identifiers.  update
c the descriptors of the last point.
c
	if (ixn.ne.ixl.or.iyn.ne.iyl.or.ign.ne.igl) then
	  call arisub1(iam,ipn,ipx)
	  if(iare.ne.0) return
	  if (ica.eq.1) then
	    iam(ipn+7)=0
	    iam(ipn+8)=0
	    iam(ipn+9)=0
	  endif
	  ixl=ixn
	  iyl=iyn
	  igl=ign
	endif
c
	enddo
c
c restore the value of the pointer ipx to its position in the area map.
c
	iam(3)=ipx
c
c set the map state to say that an edge has been entered.
c
	iam(4)=0
c
	return
	end
c
	subroutine arisub1(iam,ipn,ipx)
c
c this internal procedure adds a new point to the area map.
c
	implicit none
	integer ipn,ipx
	integer iam(*)
	include  'sgarea_inc'
	integer iyn, ixn, iare, irn, iln, ign
	common /ncocom/ iare
	common /arecom/ ixn,iyn,ign,iln,irn
	logical more,morf
c
	ipn=iam(5)+1
	if (iam(5)+10.ge.iam(6)) then
	call ageset ('aredam: area buffer overflow',5,1)
	return
	endif
	iam(5)=iam(5)+10
	iam(ipn)=iam(iam(22))+4
	iam(ipn+1)=ixn
	iam(ipn+2)=iyn
	iam(ipn+3)=18
	iam(ipn+4)=iam(22)
	iam(iam(22)+3)=ipn
	iam(22)=ipn
	more=.true.
	do while (more)
	  if (iam(ipn+1).lt.iam(ipx+1)) then
	    ipx=iam(ipx+6)
	  elseif (iam(ipn+1).gt.iam(iam(ipx+5)+1)) then
	    ipx=iam(ipx+5)
	  else
	    morf=.true.
	    do while (morf)
	    if (iam(ipn+1).eq.iam(ipx+1).and.
     &                            iam(ipn+2).lt.iam(ipx+2)) then
	      ipx=iam(ipx+6)
	    elseif (iam(ipn+1).eq.iam(iam(ipx+5)+1).and.
     +	  	  iam(ipn+2).gt.iam(iam(ipx+5)+2)) then
	      ipx=iam(ipx+5)
	    else
	      morf=.false.
	    endif
	    enddo
	    more=.false.
	  endif
	enddo
	iam(ipn+5)=iam(ipx+5)
	iam(ipn+6)=iam(iam(ipx+5)+6)
	iam(iam(ipx+5)+6)=ipn
	iam(ipx+5)=ipn
	iam(ipn+7)=ign
	iam(ipn+8)=iln
	iam(ipn+9)=irn
	return
c
	end
c
c
c----------------------------------------------------------------/arinam
	subroutine arinam (iam,lam)
c
	implicit none
	integer lam
	integer iam(lam)
	include  'sgarea_inc'
	integer iare
	common /ncocom/ iare

c
c the routine arinam is called to initialize a given area map.  it must
c be called prior to any aredam call for that area map.  input arguments
c are as follows:
c
c iam is the integer array in which an area map is to be initialized.
c
c lam is the length of the array iam.
c
c on output, elements of iam have been changed.
c
c
c  clear the error code.
c log an error if the user's array is too small.
c
	iare=0
	if (lam.le.27) then
	  call ageset ('arinam: area buffer is too small',1,1)
	  return
	endif
c
c proceed with initialization.  store the length of the array as its
c first element and as its last; this allows for later error checking.
c
	iam(1)=lam
	iam(lam)=lam
c
c zero the maximum-distance parameter.
c
	iam(2)=0
c
c initialize the value of ipx, which preserves from call to call the
c approximate position of the last node with which we did anything.
c
	iam(3)=8
c
c initialize the map state.
c
	iam(4)=0
c
c set the pointers indicating the locations of the last cells used at
c the beginning and end of the area buffer.
c
	iam(5)=27
	iam(6)=lam
c
c zero the number of groups.
c
	iam(7)=0
c
c set up two dummy nodes to serve as "anchors", preventing searches
c from going past them.
c
	iam(8)=0
	iam(9)=-1
	iam(10)=-1
	iam(11)=18
	iam(12)=0
	iam(13)=18
	iam(14)=0
	iam(15)=0
	iam(16)=0
	iam(17)=0
c
	iam(18)=0
	iam(19)=lc+1.
	iam(20)=lc+1.
	iam(21)=0
	iam(22)=8
	iam(23)=0
	iam(24)=8
	iam(25)=0
	iam(26)=0
	iam(27)=0
c
c done.
c
	return
	end
c
c
c----------------------------------------------------------------/arpram
	subroutine arpram (iam,if1,if2,if3)
c
	implicit none
	integer iam(*)
	integer if1,if2,if3
	include  'sgarea_inc'

	integer iare
	integer kf1,isx,isy,iqb,iqe
	common /ncocom/ iare
	common /arpcom/ kf1,isx,isy,iqb,iqe
	logical lloop,ledge
	integer kf3, ipx, nxl, ipt, ixl, ipi, ndo, iyl
	real    fxd, fyd
	integer i, ix0, iy0, ipn, isu, lam
	integer isp, iqt, ix1, iy1, ix2, iy2, iql, iqu
	real    dsq, xci, yci, yco, ytm
	integer isl, isr, isd, ip1, ip2, isq, ilw, igi
	integer ipu, ipq, ipr, ips, ipm, ipv, iph, ipp
	integer iof, iax, iai, iap, iaq
c
c examine the area map.  find points of intersection, delete redundant
c edge segments, and adjust the area identifiers.
c
c iam is the array which holds an area map previously initialized by a
c call to arinam and augmented by calls to aredam.
c
c if1 specifies what kind of search is made for intersections.  if if1
c is zero, all pairs of edge segments which could possibly intersect
c are examined for actual intersection, a very time-consuming process.
c if if1 is one, a pair is examined only if one of its members has a
c left or a right identifier less than or equal to zero; this saves a
c lot of time and is intended for use with contour lines.
c
c if2 specifies what kind of action is taken to remove unclosed edges.
c if if2 is zero, a search is made for such edges and they are simply
c removed from the area map.  if if2 is one, no such search is made;
c all edges are assumed closed.
c
c if3 specifies what kind of search is made for area identifiers to be
c changed.  if if3 is zero, all edges of all subareas are examined in
c complete detail, a very time-consuming process.  if if3 is one, only
c those edges having a zero or negative area identifier are examined
c (all others being assumed correct) and holes are ignored, which saves
c a lot of time; this is intended for use with contour lines.
c
c
c
c declare certain variables to be real or double precision.
c
	real ang,ant,apq,aqr,fxl,fx1,fx2,fy1,fy2,tmp,fsx,fsy
c
c pull out the length of the area map and do a simple consistency check.
c
	lam=iam(1)
	if (iam(lam).ne.lam) then
	  call ageset ('arpram: area buffer uninitialized',1,1)
	  return
	endif
c
c copy the fast-path flags to internal variables.
c
	kf1=if1
cx	kf2=if2
	kf3=if3
c
c initialize the pointer used in determining the coordinate ordering of
c new nodes.
c
	ipx=8
c
c first, find the average length of the projection on the x axis of the
c line segments in the area map.
c
	nxl=0
	fxl=zero
	ipt=8
	do while(iam(ipt+3).ne.18)
	  ipt=iam(ipt+3)
	  if (iam(ipt+7).ne.0) then
	    nxl=nxl+1
	    fxl=fxl+real(abs(iam(ipt+1)-iam(iam(ipt+4)+1)))
	  endif
	enddo
	if (nxl.eq.0) then
	  call ageset ('arpram: no edges in area map',2,1)
	  return
	endif
	ixl=int(fxl/real(nxl))
c
c decide what the maximum such length should be and save it.  adjust
c the x and y coordinates in the dummy nodes at the ends of the list.
c
	iam(2)=max(2,min(int(lc), 2*ixl))
	iam(9)=-(iam(2)+1)
	iam(10)=-(iam(2)+1)
	iam(19)=int(lc)+(iam(2)+1)
	iam(20)=int(lc)+(iam(2)+1)
c
c now, break up any edge segments whose projections on the x axis are
c greater than the maximum.
c
	ipi=8
	do while(iam(ipi+3).ne.18)
	  ipi=iam(ipi+3)
	  if (iam(ipi+7).ne.0) then
	    ndo=1+(abs(iam(ipi+1)-iam(iam(ipi+4)+1))-1)/iam(2)
	    if (ndo.gt.1) then
	      ixl=iam(iam(ipi+4)+1)
	      iyl=iam(iam(ipi+4)+2)
	      fxd=real(iam(ipi+1)-ixl)/real(ndo)
	      fyd=real(iam(ipi+2)-iyl)/real(ndo)
	      do i=1,ndo-1
		ix0=ixl+int(real(i)*fxd+.5)
		iy0=iyl+int(real(i)*fyd+.5)
		call arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
		if(iare.ne.0) return
	      enddo
	    endif
	  endif
	enddo
c
c
c now, look for points of intersection between edges.  the algorithm
c used should run in o(nlogn) time, rather than o(n**2) time.  a
c vertical sweep line is passed over the plane from left to right.
c a list is kept of all the edge segments intersected by the sweep
c line, sorted in order of increasing y coordinate.  whenever a new
c edge segment is added to the list, a check is made for intersection
c of it with the edge segments on either side of it.  whenever an edge
c segment is removed from the list, a check is made for intersection
c of the edge segments which were on either side of it.  there are
c various complications, mostly having to do with the fact that points
c of intersection are incorporated in the area map as they are found
c and that we are working with a discrete grid, rather than with the
c classic euclidean plane.
c
c the list is kept at the upper end of the area map.  each five-word
c node in it represents one edge segment intersecting the sweep line
c and has the following format:
c
c   word 0:  a pointer to the next node in the list (0 if no more).
c   word 1:  a pointer to the last node in the list (0 if no more).
c   word 2:  a pointer to the left end of the edge segment.
c   word 3:  a pointer to the right end of the edge segment.
c   word 4:  a pointer to the drawing end of the edge segment.
c
  101 continue
c
c save the index of the last element used at the upper end of the area
c map.
c
	isu=iam(6)
c
c iqb points to the beginning of the edge-segment list and iqe to a
c linked list of nodes removed from the edge-segment list and available
c for re-use.  both start out empty.
c
	iqb=0
	iqe=0
c
c isp points to the node in the area map defining the current position
c of the sweep line.
c
	isp=8
c
c a while loop moves the sweep line, one point position at a time,
c across the area map.
c
	do while (iam(isp+5).ne.18)	!sweep
c
	isp=iam(isp+5)
c
c pull out the x and y coordinates of the point defining the current
c position of the sweep line.
c
	isx=iam(isp+1)
	fsx=real(isx)
	isy=iam(isp+2)
	fsy=real(isy)
c
c interpolate the new point along any line segment which passes within
c one unit of it and, at the same time, remove any line segment having
c the current point, or any with the same coordinates, as a right
c endpoint.
c
	iqt=iqb
	do while (iqt.ne.0)
c
	  ix1=iam(iam(iqt+2)+1)
	  fx1=real(ix1)
	  iy1=iam(iam(iqt+2)+2)
	  fy1=real(iy1)
	  ix2=iam(iam(iqt+3)+1)
	  fx2=real(ix2)
	  iy2=iam(iam(iqt+3)+2)
	  fy2=real(iy2)
c
	  tmp=max(zero,min(one,
     +	    ((fsx-fx1)*(fx2-fx1)+(fsy-fy1)*(fy2-fy1))/
     +	    ((fx2-fx1)*(fx2-fx1)+(fy2-fy1)*(fy2-fy1))))
	  dsq=(fx1+(fx2-fx1)*tmp-fsx)**2+(fy1+(fy2-fy1)*tmp-fsy)**2
	  if ((dsq.lt.1.).and.(ix1.ne.isx.or.iy1.ne.isy).and.
     +	    (ix2.ne.isx.or.iy2.ne.isy)) then
	    ipi=iam(iqt+4)
	    ix0=isx
	    iy0=isy
	    call arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
	    if(iare.ne.0) return
	    iam(iqt+3)=ipn
	    if (iam(iqt+4).ne.iam(iqt+2)) iam(iqt+4)=ipn
	  endif
c
	  if (iam(iam(iqt+3)+1).eq.isx.and.iam(iam(iqt+3)+2).eq.isy) then
	  if (iam(iqt+1).eq.0) then
	    iqb=iam(iqt)
	    if (iqb.ne.0) iam(iqb+1)=0
	    iam(iqt)=iqe
	    iqe=iqt
	    iqt=iqb
	  elseif (iam(iqt).eq.0) then
	    iam(iam(iqt+1))=0
	    iam(iqt)=iqe
	    iqe=iqt
	    iqt=0
	  else
	    iql=iam(iqt+1)
	    iqu=iam(iqt)
	    iam(iql)=iqu
	    iam(iqu+1)=iql
	    iam(iqt)=iqe
	    iqe=iqt
	    if (iam(iam(iqu+3)+1).ne.isx.or.iam(iam(iqu+3)+2).ne.isy)
     +           then
	    call arpsub2(iam,iql,iqu,ipi,ipn,ipx)
	    if(iare.ne.0) return
	    endif
	    iqt=iqu
	  endif
	else
	  iqt=iam(iqt)
	endif
c
	enddo
c
c add line segments having the current point as a left endpoint.
c
	if (iam(isp+7).ne.0.and.(iam(isp+1).lt.iam(iam(isp+4)+1).or.
     +	    (iam(isp+1).eq.iam(iam(isp+4)+1).and.
     +	    iam(isp+2).lt.iam(iam(isp+4)+2)))) then
	  isl=isp
	  isr=iam(isp+4)
	  isd=isp
	  call arpsub3(iam,ipi,ipn,ipx,isl,isr,isd)
	  if(iare.ne.0) return
	endif
c
	if (iam(iam(isp+3)+7).ne.0.and.(iam(isp+1).lt.iam(iam(isp+3)+1)
     +	    .or.(iam(isp+1).eq.iam(iam(isp+3)+1)
     +	    .and.iam(isp+2).lt.iam(iam(isp+3)+2)))) then
	  isl=isp
	  isr=iam(isp+3)
	  isd=isr
	  call arpsub3(iam,ipi,ipn,ipx,isl,isr,isd)
	  if(iare.ne.0) return
	endif
c
	enddo	!sweep
c
c restore the index of the last element used at the upper end of the
c area map.
c
	iam(6)=isu
c
c now look for coincident line segments in the list and remove them.
c
	isp=8
	do while (iam(isp+5).ne.18)
	isp=iam(isp+5)
	if (iam(isp+7).ne.0) then
	if (iam(iam(isp+3)+7).ne.0.and.
     +     iam(iam(isp+3)+1).eq.iam(iam(isp+4)+1)
     +	  .and.iam(iam(isp+3)+2).eq.iam(iam(isp+4)+2)) then
	  ip1=isp
	  ip2=iam(isp+3)
	  call arpsub4(iam,ip1,ip2)
	endif
	isq=iam(isp+5)
	do while (iam(isq+1).eq.iam(isp+1).and.iam(isq+2).eq.iam(isp+2)
     +	    .and.iam(isp+7).ne.0)
	if (iam(isq+7).ne.0.and.iam(iam(isq+4)+1).eq.iam(iam(isp+4)+1)
     +	    .and.iam(iam(isq+4)+2).eq.iam(iam(isp+4)+2)) then
	  ip1=isp
	  ip2=isq
	  call arpsub4(iam,ip1,ip2)
	endif
	if (iam(iam(isq+3)+7).ne.0.and.
     +       iam(iam(isq+3)+1).eq.iam(iam(isp+4)+1)
     +	    .and.iam(iam(isq+3)+2).eq.iam(iam(isp+4)+2)) then
	  ip1=isp
	  ip2=iam(isq+3)
	  call arpsub4(iam,ip1,ip2)
	endif
	isq=iam(isq+5)
	enddo
	endif
	if (iam(iam(isp+3)+7).ne.0) then
	isq=iam(isp+5)
	do while (iam(isq+1).eq.iam(isp+1).
     +      and.iam(isq+2).eq.iam(isp+2).and.
     +	    iam(iam(isp+3)+7).ne.0)
	if (iam(isq+7).ne.0.and.
     +    iam(iam(isq+4)+1).eq.iam(iam(isp+3)+1).and.
     +	  iam(iam(isq+4)+2).eq.iam(iam(isp+3)+2)) then
	  ip1=iam(isp+3)
	  ip2=isq
	  call arpsub4(iam,ip1,ip2)
	endif
	if (iam(iam(isq+3)+7).ne.0.and.
     +    iam(iam(isq+3)+1).eq.iam(iam(isp+3)+1)
     +	  .and.iam(iam(isq+3)+2).eq.iam(iam(isp+3)+2)) then
	  ip1=iam(isp+3)
	  ip2=iam(isq+3)
	  call arpsub4(iam,ip1,ip2)
	endif
	isq=iam(isq+5)
	enddo
	endif
	enddo
cf2c
cf2c look for unclosed edges, if that is to be done.
cf2c
cf2	if (kf2eq.0) then
cf210043 continue
cf2	npf=0
cf2	ipt=8
cf210044 continue
cf2	if (.not.(iam(ipt+3).ne.18)) go to 10045
cf2	ipt=iam(ipt+3)
cf2	if (iam(ipt+7).ne.0.and.iam(iam(ipt+4)+7).eq.0) then
cf2	igi=abs(iam(ipt+7))
cf2	ip1=iam(ipt+4)
cf2	ip2=ip1
cf210046 continue
cf2	if (.not.(iam(iam(ip2+6)+1).eq.iam(ip1+1).and.iam(iam(ip2+6)+2).eq
cf2     +.iam(ip1+2))) go to 10047
cf2	ip2=iam(ip2+6)
cf2	go to 10046
cf210047 continue
cf2	ipf=0
cf210048 continue
cf2	if (ip2.ne.ip1.and.(abs(iam(ip2+7)).eq.igi.or.abs(iam(iam(ip2+3)+7
cf2     +)).eq.igi)) then
cf2	ipf=1
cf2	go to 10049
cf2	endif
cf2	ip2=iam(ip2+5)
cf2	if (iam(ip2+1).ne.iam(ip1+1).or.iam(ip2+2).ne.iam(ip1+2))
cf2     +go to 10049
cf2	go to 10048
cf210049 continue
cf2	if (ipf.eq.0) then
cf2	iam(ipt+7)=0
cf2	npf=npf+1
cf2	endif
cf2	endif
cf2	go to 10044
cf210045 continue
cf2	ipt=18
cf210050 continue
cf2	if (.not.(iam(ipt+4).ne.8)) go to 10051
cf2	ipt=iam(ipt+4)
cf2	if (iam(ipt+7).ne.0.and.iam(iam(ipt+3)+7).eq.0) then
cf2	igi=abs(iam(ipt+7))
cf2	ip1=ipt
cf2	ip2=ip1
cf210052 continue
cf2	if (.not.(iam(iam(ip2+6)+1).eq.iam(ip1+1).and.iam(iam(ip2+6)+2).eq
cf2     +.iam(ip1+2))) go to 10053
cf2	ip2=iam(ip2+6)
cf2	go to 10052
cf210053 continue
cf2	ipf=0
cf210054 continue
cf2	if (ip2.ne.ip1.and.(abs(iam(ip2+7)).eq.igi.or.abs(iam(iam(ip2+3)+7
cf2     +)).eq.igi)) then
cf2	ipf=1
cf2	go to 10055
cf2	endif
cf2	ip2=iam(ip2+5)
cf2	if (iam(ip2+1).ne.iam(ip1+1).or.iam(ip2+2).ne.iam(ip1+2))
cf2     +go to 10055
cf2	go to 10054
cf210055 continue
cf2	if (ipf.eq.0) then
cf2	iam(ipt+7)=0
cf2	npf=npf+1
cf2	endif
cf2	endif
cf2	go to 10050
cf210051 continue
cf2	if (.not.(npf.eq.0)) go to 10043
cf2	endif
c
c adjust the area identifiers for all edge segments in the map.  we
c first make a pass over the entire area map, looking for holes and
c eliminating them by the insertion of some temporary connecting lines.
c
c save the pointer to the last word of the last node, so that we can
c remove the nodes implementing the temporary connecting lines before
c returning to the caller.
c
	ilw=iam(5)
c
c each pass through the following loop traces the boundary of one
c connected loop.  in some cases (for contour maps, for example),
c this step can be omitted; in those cases, there is a small chance
c of failure, in which case we have to come back and force the step
c to occur.
c
  104 if (kf3.eq.0) then
c
	ipt=8
c
	lloop=.true.
	do while (lloop)
c
c move to the right across the area map, looking for an edge segment
c that has not yet been completely processed.  if no such segment can
c be found, all subareas have been done.
c
	do while (mod(iam(ipt),4).eq.3.or.abs(iam(ipt+7)).lt.iam(6))
	  ipt=iam(ipt+5)
	  if (ipt.eq.18) go to 10059	!exit lloop
	enddo
c
c pull out the group identifier for the segment.
c
	igi=abs(iam(ipt+7))
c
c decide whether to scan the subarea to the left of the edge being
c traced (ipu=1) or the one to the right (ipu=2).
c
	if (mod(iam(ipt),2).eq.0) then
	  ipu=1
	else
	  ipu=2
	endif
c
c ipq points to the node defining the beginning of the edge segment,
c ipr to the node defining the end of the edge segment, and ips to
c the node defining the beginning of the edge, so that we can tell
c when we've gone all the way around it.
c
	ipq=iam(ipt+4)
	ipr=ipt
	ips=ipq
	ipm=ipr
	ipv=ipu
c
c aqr holds the angle which the current edge segment makes with the
c positive x axis.
c
	aqr=atan2(real(iam(ipr+2)-iam(ipq+2)),
     +    real(iam(ipr+1)-iam(ipq+1)))
c
c we need to keep track of the highest point found along the loop and
c the total change in direction.  initialize the variables involved.
c
	iph=ipq
	ant=zero
c
c each pass through the following loop moves one step along the edge of
c the subarea.
c
	ledge=.true.
	do while (ledge)
c
c update the pointer to the highest point found along the loop.
c
	if (iam(ipr+2).gt.iam(iph+2)) iph=ipr
c
c move ipq to ipp, ipr to ipq, and aqr to apq.  adjust the range of apq.
c
	ipp=ipq
	ipq=ipr
	apq=aqr
	if (apq.lt.-pi) apq=apq+tp
	if (apq.gt.+pi) apq=apq-tp
c
c back up ipr to the beginning of the group of nodes which have the
c same x and y coordinates as it does.
c
	do while (iam(ipr+1).eq.iam(iam(ipr+6)+1).and.
     +	    iam(ipr+2).eq.iam(iam(ipr+6)+2))
	  ipr=iam(ipr+6)
	enddo
c
c go through the group of nodes, examining all the possible ways to
c move from the current position to a new one.  pick the direction
c which is leftmost (if ipu=1) or rightmost (if ipu=2).
c
	ip1=ipr
	ip2=ipr
	ipr=0
	if (ipu.eq.1) then
	  aqr=apq-pi
	else
	  aqr=apq+pi
	endif
c
	do while (iam(ip2+1).eq.iam(ip1+1).and.iam(ip2+2).eq.iam(ip1+2))
	if (abs(iam(iam(ip2+3)+7)).eq.igi.
     +    and.(iam(iam(ip2+3)+1).ne.iam(ipp+1)
     +	  .or.iam(iam(ip2+3)+2).ne.iam(ipp+2))) then
	ang=atan2(real(iam(iam(ip2+3)+2)-iam(ip2+2)),
     +	  real(iam(iam(ip2+3)+1)-iam(ip2+1)))
	if (ang.lt.apq-pi) ang=ang+tp
	if (ang.gt.apq+pi) ang=ang-tp
	if (ipu.eq.1) then
	  if (ang.gt.aqr.and.ang.lt.apq+pi) then
	    ipr=iam(ip2+3)
	    aqr=ang
	    ipm=ipr
	    ipv=1
	  endif
	else
	  if (ang.lt.aqr.and.ang.gt.apq-pi) then
	    ipr=iam(ip2+3)
	    aqr=ang
	    ipm=ipr
	    ipv=2
	  endif
	endif
	endif
	if (abs(iam(ip2+7)).eq.igi.and.(iam(iam(ip2+4)+1).ne.iam(ipp+1)
     +	  .or.iam(iam(ip2+4)+2).ne.iam(ipp+2))) then
	ang=atan2(real(iam(iam(ip2+4)+2)-iam(ip2+2)),
     +	  real(iam(iam(ip2+4)+1)-iam(ip2+1)))
	if (ang.lt.apq-pi) ang=ang+tp
	if (ang.gt.apq+pi) ang=ang-tp
	if (ipu.eq.1) then
	  if (ang.gt.aqr.and.ang.lt.apq+pi) then
	    ipr=iam(ip2+4)
	    aqr=ang
	    ipm=ip2
	    ipv=2
	  endif
	else
	  if (ang.lt.aqr.and.ang.gt.apq-pi) then
	    ipr=iam(ip2+4)
	    aqr=ang
	    ipm=ip2
	    ipv=1
	  endif
	endif
	endif
	ip2=iam(ip2+5)
	enddo
c
c if no possible exit was found, reverse direction.
c
	  if (ipr.eq.0) then
	  ipr=ipp
	  ipv=3-ipv
	  if (ipu.eq.1) then
	    aqr=apq-pi
	  else
	    aqr=apq+pi
	  endif
	endif
c
c update the total angular change.
c
	ant=ant+aqr-apq
c
c set the marker for the edge segment picked.  if the marker is set
c already, either go back and do a slow-path intersection search or
c log an error.
c
	if (ipv.eq.1.and.mod(iam(ipm),2).eq.0) then
	iam(ipm)=iam(ipm)+1
	elseif (ipv.eq.2.and.mod(iam(ipm)/2,2).eq.0) then
	iam(ipm)=iam(ipm)+2
	else
	ipt=iam(5)-9
	do while (ipt.gt.ilw)
	  iam(iam(ipt+4)+3)=iam(ipt+3)
	  iam(iam(ipt+3)+4)=iam(ipt+4)
	  iam(iam(ipt+6)+5)=iam(ipt+5)
	  iam(iam(ipt+5)+6)=iam(ipt+6)
	  ipt=ipt-10
	enddo
	iam(5)=ilw
	do ipt=8,iam(5)-9,10
	  iam(ipt)=4*(iam(ipt)/4)
	enddo
	if (kf1.ne.0) then
	  kf1=0
	  go to 101
	else
	  call ageset ('arpram: algorithm failure',4,1)
	  return
	endif
	endif
c
c exit if we're passing the start of the subarea.
c
	if (iam(ipq+1).eq.iam(ips+1).and.iam(ipq+2).eq.iam(ips+2)
     +	    .and.iam(ipr+1).eq.iam(ipt+1).and.iam(ipr+2).eq.iam(ipt+2))
     +	    ledge=.false.
c
	enddo	!ledge
c
c if the closed loop just traced was a hole, insert a temporary
c connecting line to get rid of the hole.
c
	if ((ipu.eq.1.and.ant.lt.zero).or.
     +     (ipu.eq.2.and.ant.gt.zero)) then
	iof=0
	xci=real(iam(iph+1))
	yci=real(iam(iph+2))
	yco=lc+1.
	ip1=iph
	do while (iam(iam(ip1+5)+1).eq.iam(iph+1))
	  ip1=iam(ip1+5)
	enddo
	do while (iam(ip1+1).ge.iam(iph+1)-iam(2))
	  if (abs(iam(ip1+7)).eq.igi.and.iam(iam(ip1+4)+1).gt.iam(ip1+1)
     +	    .and.iam(iam(ip1+4)+1).ge.iam(iph+1)) then
	  ytm=real(iam(ip1+2))+(xci-real(iam(ip1+1)))*
     +	    (real(iam(iam(ip1+4)+2)-iam(ip1+2))/
     +	    real(iam(iam(ip1+4)+1)-iam(ip1+1)))
	  if (ytm.gt.yci.and.ytm.lt.yco) then
	    iof=ip1
	    yco=ytm
	  endif
	  endif
	  if (abs(iam(iam(ip1+3)+7)).eq.igi.and.
     + iam(iam(ip1+3)+1).gt.iam(ip1+1)
     +	    .and.iam(iam(ip1+3)+1).ge.iam(iph+1)) then
	  ytm=real(iam(ip1+2))+(xci-real(iam(ip1+1)))*
     +	    (real(iam(iam(ip1+3)+2)-iam(ip1+2))/
     +	    real(iam(iam(ip1+3)+1)-iam(ip1+1)))
	  if (ytm.gt.yci.and.ytm.lt.yco) then
	    iof=iam(ip1+3)
	    yco=ytm
	  endif
	  endif
	  ip1=iam(ip1+6)
	enddo
	if (iof.ne.0) then
	  ix0=iam(iph+1)
	  iy0=iam(iph+2)
	  if (int(yco).ne.iy0) then
	  ipi=18
	  call arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
	  if(iare.ne.0) return
	  iam(ipn+7)=0
	  iam(ipn+8)=0
	  iam(ipn+9)=0
	  iy0=int(yco)
	  call arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
	  if(iare.ne.0) return
	  iam(ipn+7)=lam-igi
	  iam(ipn+8)=0
	  iam(ipn+9)=0
	endif
	if ((ix0.ne.iam(iof+1).or.iy0.ne.iam(iof+2)).and.
     +	    (ix0.ne.iam(iam(iof+4)+1).or.iy0.ne.iam(iam(iof+4)+2))) then
	  ipi=iof
	  call arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
	  if(iare.ne.0) return
	endif
	endif
c
	endif
c
	enddo	!lloop
10059 continue
c
c zero the lower bits in the markers in all the nodes.
c
	do ipt=8,iam(5)-9,10
	  iam(ipt)=4*(iam(ipt)/4)
	enddo
c
	endif
c
c now, make another pass through the area map, tracing one subarea at a
c time and setting the area identifiers in each.
c
c each pass through the following loop traces the boundary of one
c subarea.
c
c
	ipt=8
c
	lloop=.true.
	do while (lloop)
c
c move to the right across the area map, looking for an edge segment
c that has not yet been completely processed.  if no such segment can
c be found, all subareas have been done.
c
	do while (mod(iam(ipt),4).eq.3.or.abs(iam(ipt+7)).lt.iam(6).or.
     +	  (kf3.ne.0.and.((mod(iam(ipt),2).ne.0.or.iam(ipt+8).gt.0).and.
     +	  (mod(iam(ipt)/2,2).ne.0.or.iam(ipt+9).gt.0))))
	  ipt=iam(ipt+5)
	  if (ipt.eq.18) go to 10080	!exit lloop
	enddo
c
c pull out the group identifier for the segment.
c
	igi=abs(iam(ipt+7))
c
c decide whether to scan the subarea to the left of the edge being
c traced (ipu=1) or the one to the right (ipu=2) and initialize the
c area identifier.
c
	if (mod(iam(ipt),2).eq.0.and.(kf3.eq.0.or.iam(ipt+8).le.0)) then
	  ipu=1
	else
	  ipu=2
	endif
c
	iax=0
	iai=0
	iap=0
c
c ipq points to the node defining the beginning of the edge segment,
c ipr to the node defining the end of the edge segment, and ips to
c the node defining the beginning of the edge, so that we can tell
c when we've gone all the way around it.
c
	ipq=iam(ipt+4)
	ipr=ipt
	ips=ipq
	ipm=ipr
	ipv=ipu
c
c aqr holds the angle which the current edge segment makes with the
c positive x axis.  for the sake of efficiency, during this pass, its
c value is only computed when absolutely necessary.
c
	aqr=tenten
c
c each pass through the following loop moves one step along the edge of
c the subarea.
c
	ledge=.true.
	do while (ledge)
c
c move ipq to ipp, ipr to ipq, and aqr to apq.
c
	ipp=ipq
	ipq=ipr
	apq=aqr
c
c back up ipr to the beginning of the group of nodes which have the
c same x and y coordinates as it does.
c
	do while (iam(ipr+1).eq.iam(iam(ipr+6)+1).and.
     +	  iam(ipr+2).eq.iam(iam(ipr+6)+2))
	  ipr=iam(ipr+6)
	enddo
c
c if there is only one node in the group, the exit path is obvious.
c
	if (iam(ipr+1).ne.iam(iam(ipr+5)+1).or.
     +	    iam(ipr+2).ne.iam(iam(ipr+5)+2)) then
	if (iam(iam(ipr+3)+1).ne.iam(ipp+1).or.
     +	    iam(iam(ipr+3)+2).ne.iam(ipp+2)) then
	if (iam(iam(ipr+3)+7).eq.lam-igi.or.
     +	    abs(iam(iam(ipr+3)+7)).eq.igi) then
	  ipm=iam(ipr+3)
	  ipr=ipm
	  ipv=ipu
	  aqr=tenten
	else
	  ipr=0
	endif
	else
	if (iam(ipr+7).eq.lam-igi.or.abs(iam(ipr+7)).eq.igi) then
	  ipm=ipr
	  ipr=iam(ipr+4)
	  ipv=3-ipu
	  aqr=tenten
	else
	  ipr=0
	endif
	endif
c
c otherwise, go through the group of nodes, examining all the possible
c ways to move from the current position to a new one.  pick the
c direction which is leftmost (if ipu=1) or rightmost (if ipu=2).
c
	else
c
	ip1=ipr
	ip2=ipr
	ipr=0
	if (apq.eq.tenten) then
	  apq=atan2(real(iam(ipq+2)-iam(ipp+2)),
     +	    real(iam(ipq+1)-iam(ipp+1)))
	endif
	if (apq.lt.-pi) apq=apq+tp
	if (apq.gt.+pi) apq=apq-tp
	if (ipu.eq.1) then
	  aqr=apq-pi
	else
	  aqr=apq+pi
	endif
c
	do while (iam(ip2+1).eq.iam(ip1+1).and.iam(ip2+2).eq.iam(ip1+2))
	if ((iam(iam(ip2+3)+7).eq.lam-igi.or.
     +      abs(iam(iam(ip2+3)+7)).eq.igi)
     +	    .and.(iam(iam(ip2+3)+1).ne.iam(ipp+1).or.
     +	    iam(iam(ip2+3)+2).ne.iam(ipp+2))) then
	ang=atan2(real(iam(iam(ip2+3)+2)-iam(ip2+2)),
     +	  real(iam(iam(ip2+3)+1)-iam(ip2+1)))
	if (ang.lt.apq-pi) ang=ang+tp
	if (ang.gt.apq+pi) ang=ang-tp
	if (ipu.eq.1) then
	  if (ang.gt.aqr.and.ang.lt.apq+pi) then
	    ipr=iam(ip2+3)
	    aqr=ang
	    ipm=ipr
	    ipv=1
	  endif
	else
	  if (ang.lt.aqr.and.ang.gt.apq-pi) then
	    ipr=iam(ip2+3)
	    aqr=ang
	    ipm=ipr
	    ipv=2
	  endif
	endif
	endif
	if ((iam(ip2+7).eq.lam-igi.or.abs(iam(ip2+7)).eq.igi).and.
     +	    (iam(iam(ip2+4)+1).ne.iam(ipp+1).or.
     +	    iam(iam(ip2+4)+2).ne.iam(ipp+2))) then
	ang=atan2(real(iam(iam(ip2+4)+2)-iam(ip2+2)),
     + real(iam(iam(ip2+4)+1)-iam(ip2+1)))
	if (ang.lt.apq-pi) ang=ang+tp
	if (ang.gt.apq+pi) ang=ang-tp
	if (ipu.eq.1) then
	if (ang.gt.aqr.and.ang.lt.apq+pi) then
	ipr=iam(ip2+4)
	aqr=ang
	ipm=ip2
	ipv=2
	endif
	else
	if (ang.lt.aqr.and.ang.gt.apq-pi) then
	ipr=iam(ip2+4)
	aqr=ang
	ipm=ip2
	ipv=1
	endif
	endif
	endif
	ip2=iam(ip2+5)
	enddo
c
	endif
c
c if no possible exit was found, reverse direction.
c
	if (ipr.eq.0) then
	  ipr=ipp
	  ipv=3-ipv
	  aqr=tenten
	endif
c
c update the markers for the edge segment picked.
c
	if (ipv.eq.1.and.mod(iam(ipm),2).eq.0) then
	  iam(ipm)=iam(ipm)+1
	  iaq=ipm+8
	elseif (ipv.eq.2.and.mod(iam(ipm)/2,2).eq.0) then
	  iam(ipm)=iam(ipm)+2
	  iaq=ipm+9
	else
	  call ageset ('arpram: algorithm failure',5,1)
	  return
	endif
c
	if (iam(iaq).le.0.or.iam(iaq).ge.iam(6)) then
	if (iam(iaq).lt.0) then
	  iai=-1
	  iax=lam*4
	elseif (iam(iaq).ge.iam(6).and.iam(ipm).gt.iax) then
	  iai=iam(iaq)
	  iax=iam(ipm)
	endif
	iam(iaq)=iap
	iap=iaq
	endif
c
c exit if we're passing the start of the subarea.
c
	if (iam(ipq+1).eq.iam(ips+1).and.iam(ipq+2).eq.iam(ips+2).and.
     +	    iam(ipr+1).eq.iam(ipt+1).and.iam(ipr+2).eq.iam(ipt+2))
     +	    ledge=.false.
c
	enddo	!ledge
c
c go through the chain of area identifiers, updating them.
c
	do while (iap.ne.0)
	  iaq=iam(iap)
	  iam(iap)=iai
	  iap=iaq
	enddo
c
c if a zero identifier was selected for the area, see if the search for
c holes was suppressed and, if so, re-do it.
c
	if (iai.eq.0.and.kf3.ne.0) then
	  do ipt=8,iam(5)-9,10
	    iam(ipt)=4*(iam(ipt)/4)
	  enddo
	  kf3=0
	  go to 104
	endif
c
	enddo	!lloop
10080 continue
c
c delete the nodes used to put in the temporary connecting lines.
c
	ipt=iam(5)-9
	do while (ipt.gt.ilw)
	  iam(iam(ipt+4)+3)=iam(ipt+3)
	  iam(iam(ipt+3)+4)=iam(ipt+4)
	  iam(iam(ipt+6)+5)=iam(ipt+5)
	  iam(iam(ipt+5)+6)=iam(ipt+6)
	  ipt=ipt-10
	enddo
	iam(5)=ilw
c
c zero the markers in all the remaining nodes.
c
	do ipt=8,iam(5)-9,10
	  iam(ipt)=0
	enddo
c
c update the map state.
c
	iam(4)=1
c
c done.
c
	return
	end
c
	subroutine arpsub4(iam,ip1,ip2)
	implicit none
	integer iam(*)
	integer ip1,ip2
	integer ip3
c
c this internal procedure processes coincident pairs of segments found.
c if both members of the pair belong to the same group, the earlier one
c is deleted.  if they belong to different groups, they are marked in
c such a way as to avoid algorithmic problems.
c
	if (iam(ip1).lt.iam(ip2)) then
	  ip3=ip1
	else
	  ip3=ip2
	endif
	if (abs(iam(ip1+7)).eq.abs(iam(ip2+7))) then
	  iam(ip1+8)=0
	  iam(ip1+9)=0
	  iam(ip2+8)=0
	  iam(ip2+9)=0
	  iam(ip3+7)=0
	else
	  iam(ip3+7)=-abs(iam(ip3+7))
	endif
	return
	end
c
	subroutine arpsub3(iam,ipi,ipn,ipx,isl,isr,isd)
	implicit none
	integer iam(*)
	integer ipi,ipn,ipx,isl,isr,isd
	include  'sgarea_inc'
	integer iare
	common /ncocom/ iare
	integer kf1,isx,isy,iqb,iqe
	common /arpcom/ kf1,isx,isy,iqb,iqe
	integer iqs, iqt, ilx, iqi, iql, iqu
	real    rly, sll, slp, rty
c
c this internal procedure adds a segment to the list.  it also
c checks for intersection of that segment with the segments on either
c side of it in the list.
c
	iqs=0
	iqt=iqb
	ilx=iam(isl+1)
	rly=real(iam(isl+2))
c
	if (iam(isl+1).ne.iam(isr+1)) then
	  sll=real(iam(isr+2)-iam(isl+2))/real(iam(isr+1)-iam(isl+1))
	else
	  sll=lc+1.
	endif
c
	do while (iqt.ne.0)
	  if (iam(iam(iqt+2)+1).ne.iam(iam(iqt+3)+1)) then
	    slp=real(iam(iam(iqt+3)+2)-iam(iam(iqt+2)+2))/
     +	        real(iam(iam(iqt+3)+1)-iam(iam(iqt+2)+1))
	    rty=real(iam(iam(iqt+2)+2))+real(ilx-iam(iam(iqt+2)+1))*slp
	  else
	    slp=lc+1.
	    rty=real(iam(iam(iqt+2)+2))
	  endif
	  if (rly.lt.rty.or.(rly.eq.rty.and.sll.lt.slp)) go to 10021
	  iqs=iqt
	  iqt=iam(iqt)
	enddo
10021 continue
c
	if (iqe.ne.0) then
	  iqi=iqe
	  iqe=iam(iqe)
	else
	  if (iam(6)-5.le.iam(5)) then
	  call ageset ('arpram: area buffer overflow',3,1)
	  return
	  endif
	  iqi=iam(6)-5
	  iam(6)=iqi
	endif
c
	iam(iqi)=iqt
	iam(iqi+1)=iqs
	iam(iqi+2)=isl
	iam(iqi+3)=isr
	iam(iqi+4)=isd
c
	if (iqs.ne.0) iam(iqs)=iqi
	if (iqt.ne.0) iam(iqt+1)=iqi
c
	if (iqb.eq.iqt) iqb=iqi
c
	if (iqs.ne.0) then
	  iql=iqs
	  iqu=iqi
	  call arpsub2(iam,iql,iqu,ipi,ipn,ipx)
	  if(iare.ne.0) return
	  if(iare.ne.0) return
	endif
c
	if (iqt.ne.0) then
	  iql=iqi
	  iqu=iqt
	  call arpsub2(iam,iql,iqu,ipi,ipn,ipx)
	  if(iare.ne.0) return
	  if(iare.ne.0) return
	endif
c
	return
	end
c
	subroutine arpsub2(iam,iql,iqu,ipi,ipn,ipx)
	integer iam(*)
	integer iql,iqu,ipi,ipn,ipx
	include  'sgarea_inc'
	integer iare
	integer kf1,isx,isy,iqb,iqe
	common /ncocom/ iare
	common /arpcom/ kf1,isx,isy,iqb,iqe
	integer ix1, ix2, ix3, ix4, iy1, iy2, iy3, iy4
	integer ix0, iy0
	real    fy1, fy2, fy3, fy4, fx1, fx2, fx3, fx4, fx0, fy0
c
c this internal procedure looks for intersection between the
c segments identified by the pointers iql and iqu.  when such points of
c intersection are found, they are interpolated along the intersecting
c line segments and any line segments which pass within one unit.
c
	if (kf1.eq.0.or.iam(iam(iql+4)+8).le.0.or.iam(iam(iql+4)+9).le.0
     +	  .or.iam(iam(iqu+4)+8).le.0.or.iam(iam(iqu+4)+9).le.0) then
c
	  ix1=iam(iam(iql+2)+1)
	  fx1=real(ix1)
	  iy1=iam(iam(iql+2)+2)
	  fy1=real(iy1)
	  ix2=iam(iam(iql+3)+1)
	  fx2=real(ix2)
	  iy2=iam(iam(iql+3)+2)
	  fy2=real(iy2)
	  ix3=iam(iam(iqu+2)+1)
	  fx3=real(ix3)
	  iy3=iam(iam(iqu+2)+2)
	  fy3=real(iy3)
	  ix4=iam(iam(iqu+3)+1)
	  fx4=real(ix4)
	  iy4=iam(iam(iqu+3)+2)
	  fy4=real(iy4)
c
	  tmp=(fx4-fx3)*(fy1-fy2)-(fx2-fx1)*(fy3-fy4)
c
	  if (abs(tmp).gt.tenth) then
c
	  ix0=int(((fx4-fx3)*(fx2*fy1-fx1*fy2)
     +	  -(fx2-fx1)*(fx4*fy3-fx3*fy4))/tmp+half)
	  iy0=int(((fy4-fy3)*(fx2*fy1-fx1*fy2)
     +	  -(fy2-fy1)*(fx4*fy3-fx3*fy4))/tmp+half)
c
	  if (ix0.eq.isx.and.iy0.lt.isy) ix0=ix0+1
c
	  fx0=real(ix0)
	  fy0=real(iy0)
c
	  if ((fx0-fx1)*(fx0-fx2).le.zero
     +	  .and.(fy0-fy1)*(fy0-fy2).le.zero
     +	  .and.(fx0-fx3)*(fx0-fx4).le.zero
     +	  .and.(fy0-fy3)*(fy0-fy4).le.zero) then
c
	  inp=0
c
	  if ((ix0.ne.ix1.or.iy0.ne.iy1).and.(ix0.ne.ix2.or.iy0.ne.iy2))
     +	  then
	    inp=1
	    ipi=iam(iql+4)
	    call arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
	    if(iare.ne.0) return
	    if(iare.ne.0) return
	    iam(iql+3)=ipn
	    if (iam(iql+4).ne.iam(iql+2)) iam(iql+4)=ipn
	  endif
c
	  if ((ix0.ne.ix3.or.iy0.ne.iy3).and.(ix0.ne.ix4.or.iy0.ne.iy4))
     +	  then
	    inp=1
	    ipi=iam(iqu+4)
	    call arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
	    if(iare.ne.0) return
	  if(iare.ne.0) return
	    iam(iqu+3)=ipn
	    if (iam(iqu+4).ne.iam(iqu+2)) iam(iqu+4)=ipn
	  endif
c
	if (inp.ne.0) then
	iqt=iqb
	do while (iqt.ne.0)
	  ix1=iam(iam(iqt+2)+1)
	  fx1=real(ix1)
	  iy1=iam(iam(iqt+2)+2)
	  fy1=real(iy1)
	  ix2=iam(iam(iqt+3)+1)
	  fx2=real(ix2)
	  iy2=iam(iam(iqt+3)+2)
	  fy2=real(iy2)
	  tmp=max(zero,min(one,
     +	    ((fx0-fx1)*(fx2-fx1)+(fy0-fy1)*(fy2-fy1))/
     +	    ((fx2-fx1)*(fx2-fx1)+(fy2-fy1)*(fy2-fy1))))
	  dsq=(fx1+(fx2-fx1)*tmp-fx0)**2+(fy1+(fy2-fy1)*tmp-fy0)**2
	  if ((dsq.lt.1.).and.(ix1.ne.ix0.or.iy1.ne.iy0).and.
     +	    (ix2.ne.ix0.or.iy2.ne.iy0)) then
	    ipi=iam(iqt+4)
	    call arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
	    if(iare.ne.0) return
	  if(iare.ne.0) return
	    iam(iqt+3)=ipn
	    if (iam(iqt+4).ne.iam(iqt+2)) iam(iqt+4)=ipn
	  endif
	  iqt=iam(iqt)
	enddo
	endif
c
	endif
c
	endif
c
	endif
c
	return
	end
c
	subroutine arpsub1(iam,ix0,iy0,ipi,ipn,ipx)
	implicit none
	integer ix0,iy0,ipi,ipn,ipx
	integer iam(*)
	integer iare
	common /ncocom/ iare
	logical more,morf
c
c this internal procedure adds a new point in the existing part of the
c area map.  note that add-a-point puts a new point which has the same
c coordinates as an old point after the old point in the area map (in
c coordinate order); this is important.
c
	ipn=iam(5)+1
	if (iam(5)+10.ge.iam(6)) then
	  call ageset ('arpram: area buffer overflow',6,1)
	  return
	endif
	iam(5)=iam(5)+10
	iam(ipn)=iam(ipi)
	iam(ipn+1)=ix0
	iam(ipn+2)=iy0
	iam(ipn+3)=ipi
	iam(ipn+4)=iam(ipi+4)
	iam(iam(ipi+4)+3)=ipn
	iam(ipi+4)=ipn
	more=.true.
	do while (more)
	if (iam(ipn+1).lt.iam(ipx+1)) then
	  ipx=iam(ipx+6)
	elseif (iam(ipn+1).gt.iam(iam(ipx+5)+1)) then
	  ipx=iam(ipx+5)
	else
	  morf=.true.
	  do while (morf)
	    if (iam(ipn+1).eq.iam(ipx+1).and.
     +        iam(ipn+2).lt.iam(ipx+2)) then
	      ipx=iam(ipx+6)
	    elseif (iam(ipn+1).eq.iam(iam(ipx+5)+1).and.
     +		iam(ipn+2).gt.iam(iam(ipx+5)+2)) then
	      ipx=iam(ipx+5)
	    else
	      do while (iam(iam(ipx+5)+1).eq.iam(ipn+1).and.
     +		iam(iam(ipx+5)+2).eq.iam(ipn+2))
	        ipx=iam(ipx+5)
	      enddo
	      morf=.false.
	    endif
	  enddo	  !morf
	  more=.false.
	endif
	enddo	!more
c
	iam(ipn+5)=iam(ipx+5)
	iam(ipn+6)=iam(iam(ipx+5)+6)
	iam(iam(ipx+5)+6)=ipn
	iam(ipx+5)=ipn
	iam(ipn+7)=iam(ipi+7)
	iam(ipn+8)=iam(ipi+8)
	iam(ipn+9)=iam(ipi+9)
	return
	end
c
c----------------------------------------------------------------/arscam
c
	subroutine arscam (iam,xcs,ycs,mcs,iai,iag,mai,apr)
c
	implicit none
	integer mai, mcs
	integer iam(*),iai(mai),iag(mai)
	real    xcs(mcs),ycs(mcs)
	include  'sgarea_inc'
	integer iare
	common /ncocom/ iare
	logical lloop,ledge
	external apr
	integer lam, ill, ipx, ilw, ipt, ipu, ipq, ips, ipm, ipv
	integer iph, ipp, ip1, ip2, iof, ix0, iy0, ipi, ipn, iaq
	integer nai, iaf, ncs, idu, ixc, igi, ip3, ipr
	real    fut, fub, fur, ful, fft, ffb, ffr, ffl, xci, yci
	real    yco, ytm, xco
c
c the routine arscam is called to scan an area map created by calls to
c arinam and aredam.  for each subarea of the map, the user routine apr
c is called.
c
c iam is the array holding the area map, created by prior calls to the
c routines arinam and aredam.
c
c the arrays xcs and ycs are used, in a call to apr, to hold the x
c and y coordinates of the points defining a particular subarea.  each
c is dimensioned mcs.
c
c the arrays iag and iai are used, in a call to apr, to hold the
c group and area identifiers of the subarea defined by xcs and ycs.
c each is dimensioned mai.
c
c apr is the user's area-processing routine.  it must be declared in
c an external statement in the routine which calls arscam.  it will be
c called using a fortran statement like
c
c       call apr (xcs,ycs,ncs,iai,iag,nai)
c
c where xcs and ycs hold the normalized device coordinates of ncs points
c defining a single subarea (point number ncs being a duplicate of point
c number 1) and iai and iag hold nai area-identifier/group-identifier
c pairs for that subarea.
c
c
c declare certain variables to be real or double precision.
c
	real ang,ant,apq,aqr
c
c pull out the length of the area map and do a simple consistency check.
c
	lam=iam(1)
c
	if (iam(lam).ne.lam) then
	  call ageset ('arscam: area buffer uninitialized',1,1)
	  return
	endif
c
c save the current user-system mapping and reset it as required for
c calls to apr.
c
	call getset (ffl,ffr,ffb,fft,ful,fur,fub,fut,ill)
cgks	call set (0.,1.,0.,1.,0.,1.,0.,1.,1)
c
c initialize ipx, which is used to position nodes in coordinate order.
c
	ipx=8
c
c if it has not already been done, find points of intersection and
c incorporate them into the map and then adjust area identifiers.
c
	if (iam(4).eq.0) call arpram(iam,0,0,0)
c
c we first make a pass over the entire area map, looking for holes and
c eliminating them by the insertion of some temporary connecting lines.
c
c save the pointer to the last word of the last node, so that we can
c remove the nodes implementing the temporary connecting lines before
c returning to the caller.
c
	ilw=iam(5)
c
c each pass through the following loop traces the boundary of one
c connected loop.
c
	ipt=8
c
	lloop=.true.
	do while (lloop)
c
c move to the right across the area map, looking for an edge segment
c that has not yet been completely processed.  if no such segment can
c be found, all subareas have been done.
c
	do while (iam(ipt).ge.3.or.iam(ipt+7).le.1)
	  ipt=iam(ipt+5)
	  if (ipt.eq.18) go to 10003	!exit lloop
	enddo
c
c decide whether to scan the subarea to the left of the edge being
c traced (ipu=1) or the one to the right (ipu=2).
c
	if (iam(ipt).eq.0.or.iam(ipt).eq.2) then
	  ipu=1
	else
	  ipu=2
	endif
c
c ipq points to the node defining the beginning of the edge segment,
c ipr to the node defining the end of the edge segment, and ips to
c the node defining the beginning of the edge, so that we can tell
c when we've gone all the way around it.
c
	ipq=iam(ipt+4)
	ipr=ipt
	ips=ipq
	ipm=ipr
	ipv=ipu
c
c aqr holds the angle which the current edge segment makes with the
c positive x axis.
c
	aqr=atan2(real(iam(ipr+2)-iam(ipq+2)),
     +            real(iam(ipr+1)-iam(ipq+1)))
c
c we need to keep track of the highest point found along the loop and
c the total change in direction.  initialize the variables involved.
c
	iph=ipq
	ant=zero
c
c each pass through the following loop moves one step along the edge of
c the subarea.
c
	ledge=.true.
	do while (ledge)
c
c update the pointer to the highest point found along the loop.
c
	if (iam(ipr+2).gt.iam(iph+2)) iph=ipr
c
c move ipq to ipp, ipr to ipq, and aqr to apq.  adjust the range of apq.
c
	ipp=ipq
	ipq=ipr
	apq=aqr
	if (apq.lt.-pi) apq=apq+tp
	if (apq.gt.+pi) apq=apq-tp
c
c back up ipr to the beginning of the group of nodes which have the
c same x and y coordinates as it does.
c
	do while (iam(ipr+1).eq.iam(iam(ipr+6)+1).and.
     +	    iam(ipr+2).eq.iam(iam(ipr+6)+2))
	  ipr=iam(ipr+6)
	enddo
c
c go through the group of nodes, examining all the possible ways to
c move from the current position to a new one.  pick the direction
c which is leftmost (if ipu=1) or rightmost (if ipu=2).
c
	ip1=ipr
	ip2=ipr
	ipr=0
	if (ipu.eq.1) then
	aqr=apq-pi
	else
	aqr=apq+pi
	endif
c
	do while (iam(ip2+1).eq.iam(ip1+1).and.iam(ip2+2).eq.iam(ip1+2))
	if (iam(iam(ip2+3)+7).gt.1.and.(iam(iam(ip2+3)+1).ne.iam(ipp+1)
     +	    .or.iam(iam(ip2+3)+2).ne.iam(ipp+2))) then
	ang=atan2(real(iam(iam(ip2+3)+2)-iam(ip2+2)),
     +	  real(iam(iam(ip2+3)+1)-iam(ip2+1)))
	if (ang.lt.apq-pi) ang=ang+tp
	if (ang.gt.apq+pi) ang=ang-tp
	if (ipu.eq.1) then
	if (ang.gt.aqr.and.ang.lt.apq+pi) then
	ipr=iam(ip2+3)
	aqr=ang
	ipm=ipr
	ipv=1
	endif
	else
	if (ang.lt.aqr.and.ang.gt.apq-pi) then
	ipr=iam(ip2+3)
	aqr=ang
	ipm=ipr
	ipv=2
	endif
	endif
	endif
	if (iam(ip2+7).gt.1.and.(iam(iam(ip2+4)+1).ne.iam(ipp+1).or.
     +	    iam(iam(ip2+4)+2).ne.iam(ipp+2))) then
	ang=atan2(real(iam(iam(ip2+4)+2)-iam(ip2+2)),
     +	  real(iam(iam(ip2+4)+1)-iam(ip2+1)))
	if (ang.lt.apq-pi) ang=ang+tp
	if (ang.gt.apq+pi) ang=ang-tp
	  if (ipu.eq.1) then
	  if (ang.gt.aqr.and.ang.lt.apq+pi) then
	    ipr=iam(ip2+4)
	    aqr=ang
	    ipm=ip2
	    ipv=2
	    endif
	  else
	  if (ang.lt.aqr.and.ang.gt.apq-pi) then
	    ipr=iam(ip2+4)
	    aqr=ang
	    ipm=ip2
	    ipv=1
	  endif
	endif
	endif
	ip2=iam(ip2+5)
	enddo
c
c if no possible exit was found, reverse direction.
c
	if (ipr.eq.0) then
	  ipr=ipp
	  ipv=3-ipv
	  if (ipu.eq.1) then
	    aqr=apq-pi
	  else
	    aqr=apq+pi
	  endif
	endif
c
c update the total angular change.
c
	ant=ant+aqr-apq
c
c update the markers for the edge segment picked.
c
	if (ipv.eq.1) then
	  if (mod(iam(ipm),2).eq.0) then
	    iam(ipm)=iam(ipm)+1
	  else
	    call ageset ('arscam: algorithm failure',2,1)
	    go to 10010
	  endif
	else
	  if (mod(iam(ipm)/2,2).eq.0) then
	    iam(ipm)=iam(ipm)+2
	  else
	    call ageset ('arscam: algorithm failure',3,1)
	    go to 10010
	  endif
	endif
c
c exit if we're passing the start of the subarea.
c
	if (iam(ipq+1).eq.iam(ips+1).and.iam(ipq+2).eq.iam(ips+2).and.
     +	    iam(ipr+1).eq.iam(ipt+1).and.iam(ipr+2).eq.iam(ipt+2))
     +	     ledge=.false.
c
	enddo	!ledge
c
c if the closed loop just traced was a hole, insert a temporary
c connecting line to get rid of the hole.
c
	if ((ipu.eq.1.and.ant.lt.zero).or.
     +       (ipu.eq.2.and.ant.gt.zero)) then
	iof=0
	xci=real(iam(iph+1))
	yci=real(iam(iph+2))
	yco=lc+1.
	ip1=iph
	do while (iam(iam(ip1+5)+1).eq.iam(iph+1))
	  ip1=iam(ip1+5)
	enddo
	do while (iam(ip1+1).ge.iam(iph+1)-iam(2))
	if (iam(ip1+7).gt.1.and.iam(iam(ip1+4)+1).gt.iam(ip1+1).and.
     +	    iam(iam(ip1+4)+1).ge.iam(iph+1)) then
	  ytm=real(iam(ip1+2))+(xci-real(iam(ip1+1)))*
     +	    (real(iam(iam(ip1+4)+2)-iam(ip1+2))/
     +	    real(iam(iam(ip1+4)+1)-iam(ip1+1)))
	  if (ytm.gt.yci.and.ytm.lt.yco) then
	    iof=ip1
	    yco=ytm
	  endif
	endif
	if (iam(iam(ip1+3)+7).gt.1.and.iam(iam(ip1+3)+1).gt.iam(ip1+1)
     +	    .and.iam(iam(ip1+3)+1).ge.iam(iph+1)) then
	  ytm=real(iam(ip1+2))+(xci-real(iam(ip1+1)))*
     +	    (real(iam(iam(ip1+3)+2)-iam(ip1+2))/
     +	    real(iam(iam(ip1+3)+1)-iam(ip1+1)))
	  if (ytm.gt.yci.and.ytm.lt.yco) then
	    iof=iam(ip1+3)
	    yco=ytm
	  endif
	endif
	ip1=iam(ip1+6)
	enddo
	if (iof.ne.0) then
	  ix0=iam(iph+1)
	  iy0=iam(iph+2)
	  if (int(yco).ne.iy0) then
	  ipi=18
	  call arssub1(iam,ix0,iy0,ipi,ipn,ipx)
	  if(iare.ne.0) return
	  iy0=int(yco)
	  call arssub1(iam,ix0,iy0,ipi,ipn,ipx)
	  if(iare.ne.0) return
	  iam(ipn+7)=1
	endif
	if ((ix0.ne.iam(iof+1).or.iy0.ne.iam(iof+2)).and.
     +	    (ix0.ne.iam(iam(iof+4)+1).or.iy0.ne.iam(iam(iof+4)+2))) then
	  ipi=iof
	  call arssub1(iam,ix0,iy0,ipi,ipn,ipx)
	  if(iare.ne.0) return
	  iam(ipn)=iam(ipi)
	  iam(ipn+7)=iam(ipi+7)
	  iam(ipn+8)=iam(ipi+8)
	  iam(ipn+9)=iam(ipi+9)
	endif
	endif
c
	endif
c
	enddo	!lloop
10003 continue
c
c zero the markers for all the nodes.
c
	do ipt=8,iam(5)-9,10
	  iam(ipt)=0
	enddo
c
c now, make a pass through the area map, tracing one subarea at a time
c and calling the routine apr to do with it what the user wants.
c
c each pass through the following loop traces the boundary of one
c subarea.
c
	ipt=8
c
	lloop=.true.
	do while (lloop)
c
c move to the right across the area map, looking for an edge segment
c that has not yet been completely processed.  if no such segment can
c be found, all subareas have been done.
c
	do while (iam(ipt).ge.3.or.iam(ipt+7).le.1)
	  ipt=iam(ipt+5)
	  if (ipt.eq.18) go to 10025	!exit lloop
	enddo
c
c decide whether to scan the subarea to the left of the edge being
c traced (ipu=1) or the one to the right (ipu=2).
c
	if (iam(ipt).eq.0.or.iam(ipt).eq.2) then
	  ipu=1
	  iaq=ipt+8
	else
	  ipu=2
	  iaq=ipt+9
	endif
c
c store the first group identifier and area identifier for the subarea
c and clear the flag that is set when all identifiers have been found.
c
	nai=1
	iai(nai)=iam(iaq)
	if (iai(nai).ge.iam(6)) iai(nai)=iam(iai(nai))/2
	iag(nai)=iam(iam(ipt+7))/2
	iaf=0
c
c ipq points to the node defining the beginning of the edge segment,
c ipr to the node defining the end of the edge segment, and ips to
c the node defining the beginning of the edge, so that we can tell
c when we've gone all the way around it.
c
	ipq=iam(ipt+4)
	ipr=ipt
	ips=ipq
	ipm=ipr
	ipv=ipu
c
c aqr holds the angle which the current edge segment makes with the
c positive x axis.  for the sake of efficiency, during this pass, its
c value is only computed when absolutely necessary.
c
	aqr=tenten
c
c put the first point in the list defining this subarea.
c
	ncs=1
	xcs(1)=real(iam(ipq+1))/lc
	ycs(1)=real(iam(ipq+2))/lc
c
c each pass through the following loop moves one step along the edge of
c the subarea.
c
	ledge=.true.
	do while (ledge)
c
c add the end of the current segment to the description of the subarea.
c
	if (ncs.lt.mcs) then
	  ncs=ncs+1
	  xcs(ncs)=real(iam(ipr+1))/lc
	  ycs(ncs)=real(iam(ipr+2))/lc
	else
	  call ageset ('arscam: pl buffer overflow',4,1)	!mcs too small
	  go to 10010
	endif
c
c if the group/area identifier information is incomplete and the current
c edge segment spans a portion of the x axis of non-zero length, scan
c outwards from the subarea for group/area identifier information.
c
	if (iaf.eq.0.and.iam(ipq+1).ne.iam(ipr+1)) then
c
	if (iam(ipq+1).lt.iam(ipr+1)) then
	  ip1=ipq
	  ip2=ipr
	  idu=3-ipu
	else
	  ip1=ipr
	  ip2=ipq
	  idu=ipu
	endif
c
	ixc=int(.5*(real(iam(ip1+1))+real(iam(ip2+1))))
	xco=real(ixc)+.5
	yco=real(iam(ip1+2))+(xco-real(iam(ip1+1)))*
     +	  (real(iam(ip2+2)-iam(ip1+2))/real(iam(ip2+1)-iam(ip1+1)))
c
	igi=lam
c
	do while (igi.gt.iam(6))
	igi=igi-1
	if (mod(iam(igi),2).eq.0.and.iam(ipt+7).ne.igi) then
	iaf=0
	if (idu.eq.1) then
	yci=lc+1.
	else
	yci=-1.
	endif
	ip3=iam(ip2+6)
	do while (iam(ip3+1)+iam(2).gt.ixc)
	if (iam(ip3+1).le.ixc) then
	if (abs(iam(ip3+7)).eq.igi.and.iam(ip3+1).lt.iam(iam(ip3+4)+1)
     +	    .and.ixc.lt.iam(iam(ip3+4)+1)) then
	ytm=real(iam(ip3+2))+(xco-real(iam(ip3+1)))*
     +	  (real(iam(iam(ip3+4)+2)-iam(ip3+2))/
     +	  real(iam(iam(ip3+4)+1)-iam(ip3+1)))
	if (idu.eq.1.and.ytm.lt.yci.and.ytm.ge.yco) then
	iaf=ip3
	iaq=iaf+8
	yci=ytm
	endif
	if (idu.eq.2.and.ytm.gt.yci.and.ytm.le.yco) then
	iaf=ip3
	iaq=iaf+9
	yci=ytm
	endif
	endif
	if (abs(iam(iam(ip3+3)+7)).eq.igi.and.
     +  iam(ip3+1).lt.iam(iam(ip3+3)+1)
     +	    .and.ixc.lt.iam(iam(ip3+3)+1)) then
	ytm=real(iam(ip3+2))+(xco-real(iam(ip3+1)))*
     +	  (real(iam(iam(ip3+3)+2)-iam(ip3+2))/
     +	  real(iam(iam(ip3+3)+1)-iam(ip3+1)))
	if (idu.eq.1.and.ytm.lt.yci.and.ytm.ge.yco) then
	iaf=iam(ip3+3)
	iaq=iaf+9
	yci=ytm
	endif
	if (idu.eq.2.and.ytm.gt.yci.and.ytm.le.yco) then
	iaf=iam(ip3+3)
	iaq=iaf+8
	yci=ytm
	endif
	endif
	endif
	ip3=iam(ip3+6)
	enddo
	if (iaf.ne.0) then
	if (nai.lt.mai) then
	nai=nai+1
	if (iam(iaq).lt.iam(6)) then
	iai(nai)=iam(iaq)
	else
	iai(nai)=iam(iam(iaq))/2
	endif
	iag(nai)=iam(igi)/2
	else
	call ageset ('arscam: mai too small',5,1)
	go to 10010
	endif
	endif
	endif
	enddo
	iaf=1
c
	endif
c
c move ipq to ipp, ipr to ipq, and aqr to apq.
c
	ipp=ipq
	ipq=ipr
	apq=aqr
c
c back up ipr to the beginning of the group of nodes which have the
c same x and y coordinates as it does.
c
	do while (iam(ipr+1).eq.iam(iam(ipr+6)+1).and.
     +		iam(ipr+2).eq.iam(iam(ipr+6)+2))
	  ipr=iam(ipr+6)
	enddo
c
c if there is only one node in the group, the exit path is obvious.
c
	if (iam(ipr+1).ne.iam(iam(ipr+5)+1).or.
     +	    iam(ipr+2).ne.iam(iam(ipr+5)+2)) then
	if (iam(iam(ipr+3)+1).ne.iam(ipp+1).or.
     +	    iam(iam(ipr+3)+2).ne.iam(ipp+2)) then
	if (iam(iam(ipr+3)+7).gt.0) then
	  ipm=iam(ipr+3)
	  ipr=ipm
	  ipv=ipu
	  aqr=tenten
	else
	  ipr=0
	endif
	else
	if (iam(ipr+7).gt.0) then
	  ipm=ipr
	  ipr=iam(ipr+4)
	  ipv=3-ipu
	  aqr=tenten
	else
	  ipr=0
	endif
	endif
c
c otherwise, go through the group of nodes, examining all the possible
c ways to move from the current position to a new one.  pick the
c direction which is leftmost (if ipu=1) or rightmost (if ipu=2).
c
	else
c
	ip1=ipr
	ip2=ipr
	ipr=0
	if (apq.eq.tenten) then
	  apq=atan2(real(iam(ipq+2)-iam(ipp+2)),
     +    real(iam(ipq+1)-iam(ipp+1)))
	endif
	if (apq.lt.-pi) apq=apq+tp
	if (apq.gt.+pi) apq=apq-tp
	if (ipu.eq.1) then
	  aqr=apq-pi
	else
	  aqr=apq+pi
	endif
c
	do while (iam(ip2+1).eq.iam(ip1+1).and.iam(ip2+2).eq.iam(ip1+2))
	if (iam(iam(ip2+3)+7).gt.0.and.
     +     (iam(iam(ip2+3)+1).ne.iam(ipp+1).or.
     +	  iam(iam(ip2+3)+2).ne.iam(ipp+2))) then
	ang=atan2(real(iam(iam(ip2+3)+2)-iam(ip2+2)),
     +	  real(iam(iam(ip2+3)+1)-iam(ip2+1)))
	if (ang.lt.apq-pi) ang=ang+tp
	if (ang.gt.apq+pi) ang=ang-tp
	if (ipu.eq.1) then
	  if (ang.gt.aqr.and.ang.lt.apq+pi) then
	    ipr=iam(ip2+3)
	    aqr=ang
	    ipm=ipr
	    ipv=1
	  endif
	else
	  if (ang.lt.aqr.and.ang.gt.apq-pi) then
	    ipr=iam(ip2+3)
	    aqr=ang
	    ipm=ipr
	    ipv=2
	  endif
	endif
	endif
	if (iam(ip2+7).gt.0.and.(iam(iam(ip2+4)+1).ne.iam(ipp+1)
     +	    .or.iam(iam(ip2+4)+2).ne.iam(ipp+2))) then
	ang=atan2(real(iam(iam(ip2+4)+2)-iam(ip2+2)),
     +	     real(iam(iam(ip2+4)+1)-iam(ip2+1)))
	if (ang.lt.apq-pi) ang=ang+tp
	if (ang.gt.apq+pi) ang=ang-tp
	if (ipu.eq.1) then
	  if (ang.gt.aqr.and.ang.lt.apq+pi) then
	    ipr=iam(ip2+4)
	    aqr=ang
	    ipm=ip2
	    ipv=2
	  endif
	else
	  if (ang.lt.aqr.and.ang.gt.apq-pi) then
	    ipr=iam(ip2+4)
	    aqr=ang
	    ipm=ip2
	    ipv=1
	  endif
	endif
	endif
	ip2=iam(ip2+5)
	enddo
c
	endif
c
c if no possible exit was found, reverse direction.
c
	if (ipr.eq.0) then
	ipr=ipp
	ipv=3-ipv
	aqr=tenten
	endif
c
c update the markers for the edge segment picked.
c
	if (ipv.eq.1) then
	if (mod(iam(ipm),2).eq.0) then	!?iand(iam(ipm),1)
	  iam(ipm)=iam(ipm)+1
	else
	  call ageset ('arscam: algorithm failure',6,1)
	  go to 10010
	endif
	else
	if (mod(iam(ipm)/2,2).eq.0) then
	  iam(ipm)=iam(ipm)+2
	else
	  call ageset ('arscam: algorithm failure',7,1)
	  go to 10010
	endif
	endif
c
c exit if we're passing the start of the subarea.
c
	if (iam(ipq+1).eq.iam(ips+1).and.iam(ipq+2).eq.iam(ips+2).and.
     +	    iam(ipr+1).eq.iam(ipt+1).and.iam(ipr+2).eq.iam(ipt+2))
     +	    ledge=.false.
c
	enddo 	!ledge
c
c a complete subarea has been found.  let the user do what he wants
c with it.
c
	if (nai.eq.iam(7)) then
	  call apr (xcs,ycs,ncs,iai,iag,nai)
	else
	  call ageset ('arscam: algorithm failure',8,1)
	  go to 10010
	endif
c
	enddo	!lloop
10025 continue
c
c delete the nodes used to put in the temporary connecting lines.
c
	ipt=iam(5)-9
	do while (ipt.gt.ilw)
	  iam(iam(ipt+4)+3)=iam(ipt+3)
	  iam(iam(ipt+3)+4)=iam(ipt+4)
	  iam(iam(ipt+6)+5)=iam(ipt+5)
	  iam(iam(ipt+5)+6)=iam(ipt+6)
	  ipt=ipt-10
	enddo
	iam(5)=ilw
c
c zero the markers in all the remaining nodes.
c
	do ipt=8,iam(5)-9,10
	  iam(ipt)=0
	enddo
c
c restore the original set parameters and return to the caller.
c
10010 continue
cgks	call set (ffl,ffr,ffb,fft,ful,fur,fub,fut,ill)
	return
	end
c
	subroutine arssub1(iam,ix0,iy0,ipi,ipn,ipx)
	implicit none
	integer ix0,iy0,ipi,ipn,ipx
	integer iam(*)
	logical more,morf
c
c this internal procedure adds a new point in the existing part of the
c area map.
c
	ipn=iam(5)+1
	if (iam(5)+10.ge.iam(6)) then
	  call ageset ('arscam: area buffer overflow',9,1)
	  return	!go to 10010
	endif
	iam(5)=iam(5)+10
	iam(ipn)=0
	iam(ipn+1)=ix0
	iam(ipn+2)=iy0
	iam(ipn+3)=ipi
	iam(ipn+4)=iam(ipi+4)
	iam(iam(ipi+4)+3)=ipn
	iam(ipi+4)=ipn
	more=.true.
	do while (more)
	  if (iam(ipn+1).lt.iam(ipx+1)) then
	    ipx=iam(ipx+6)
	  elseif (iam(ipn+1).gt.iam(iam(ipx+5)+1)) then
	    ipx=iam(ipx+5)
	  else
	    morf=.true.
	    do while (morf)
	      if (iam(ipn+1).eq.iam(ipx+1).and.
     +        iam(ipn+2).lt.iam(ipx+2)) then
		ipx=iam(ipx+6)
	      elseif (iam(ipn+1).eq.iam(iam(ipx+5)+1).and.
     +		  iam(ipn+2).gt.iam(iam(ipx+5)+2)) then
		ipx=iam(ipx+5)
	      else
	        morf=.false.
	      endif
	    enddo
	    more=.false.
	  endif
	enddo
	iam(ipn+5)=iam(ipx+5)
	iam(ipn+6)=iam(iam(ipx+5)+6)
	iam(iam(ipx+5)+6)=ipn
	iam(ipx+5)=ipn
	iam(ipn+7)=0
	iam(ipn+8)=0
	iam(ipn+9)=0
	return
	end
c
	subroutine ageset(stext,i1,i2)
	implicit none
	integer i1, i2
	character stext*(*),gtext*(*),text*72
	integer iare
	common /ncocom/ iare
	save text
	integer ierr, narg
c
	call agtmhs(100,20,stext)
	text=stext
	iare=i1
	return
c
	entry ageget(narg,ierr,gtext)
c
	ierr=iare
	if(narg.gt.1) gtext=text
	end
c
	subroutine getset(ffl,ffr,ffb,fft,ful,fur,fub,fut,ill)
	implicit none
	real    ffl,ffr,ffb,fft,ful,fur,fub,fut
	integer ill
	real    xmin,xmax,ymin,ymax

	ffl=0.
	ffr=1.
	ffb=0.
	fft=1.
	call seedw(xmin,xmax,ymin,ymax)
	ful=xmin	!minx
	fur=xmax	!maxx
	fub=ymin	!miny
	fut=ymax	!maxy
	ill=1
	end
c
cgks	subroutine set
cgks	end

      subroutine ugetrng(zminv,zmaxv,prompt,zvalue)
C
C  prompt for a value -- enforce range constraints
C
C    zminv.le.zvalue  &  zvalue.le.zmaxv
C
      real zminv,zmaxv                  ! range limits (input)
      character*(*) prompt              ! Uread prompt (input)
      real zvalue                       ! value returned (default is input)
C
C---------------------------------------
C
 10   continue
      zlocl=zvalue
      call ureadf(prompt,zlocl)
      if((zlocl.lt.zminv).or.(zlocl.gt.zmaxv)) then
         write(lnout(0),1001) zlocl,zminv,zmaxv
 1001    format(' %ugetrng:  the input value ',1pe13.6/
     >      '  is not in range ',1pe13.6,' to ',1pe13.6,'.')
         call uclear
         go to 10
      endif
C
      zvalue=zlocl
C
      return
      end

      subroutine add0duf(lun,signam,nscd,nsca,scval,sclab,ier)
 
C Add Scalars to MDSplus
C 02/09/01 CAL
C
      implicit none
C
      integer       lun          ! lun for error messages
      character*(*) signam
      integer       nscd,nsca    ! size of array / actual
      real          scval(nscd)  ! Scalar values
      character*30  sclab(nscd)  ! scalar labels
      integer       ier
 
C For MDSplus
      integer       mds_create_node
      integer       MdsPut,  idescr_floatarr
      integer       idescr_cstring, idescr_cstringarr
      character*90  expr
      integer       stat
 
C-------------------------------------------------------------------
      ier = 0
 
C Create SCVAL
      stat=mds_create_node(signam//':SCVAL',
     >     'numeric')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then  ! TreeALREADY_THERE
            call mdsmsg(lun,signam//':SCVAL create status:  ',stat)
            ier=1
            go to 9000
         endif
      endif
C Write SCVAL
      if (nsca .gt.0) then
         expr=signam//':SCVAL'//CHAR(0)
         stat=MdsPut(expr,'$'//char(0),
     >        idescr_floatarr(scval,nsca,1),0)
         if (mod(stat,2).ne.1) then
            call mdsmsg(lun,expr//' put status:  ',stat)
            ier=1
         endif
      endif
 
C Create SCLAB
      stat=mds_create_node(signam//':SCLAB','text')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then ! TreeALREADY_THERE
            call mdsmsg(lun,signam//':SCLAB create status:  ',stat)
            ier=1
            go to 9000
         endif
      endif
C Write SCLAB
      if (nsca .gt.0) then
         expr=signam//':SCLAB'//CHAR(0)
         stat=MdsPut(expr,'$'//char(0),
     >        idescr_cstringarr(sclab,nsca,1),0)
         if (mod(stat,2).ne.1) then
            call mdsmsg(lun,expr//' put status:  ',stat)
            ier=1
            go to 9000
         endif
      endif
 
      return
C
 9000 continue
      return
      end

C******************** START FILE ZEROIN.FOR ; GROUP TRKRLIB ************
CC
      REAL FUNCTION ZEROIN(AX,BX,F,TOL,EPSLON)
C
      REAL AX,BX,F,TOL
      EXTERNAL F
C
C      A ZERO OF THE FUNCTION  F(X)  IS COMPUTED IN THE INTERVAL AX,BX .
C
C  INPUT..
C
C  AX     LEFT ENDPOINT OF INITIAL INTERVAL
C  BX     RIGHT ENDPOINT OF INITIAL INTERVAL
C  F      FUNCTION SUBPROGRAM WHICH EVALUATES F(X) FOR ANY X IN
C         THE INTERVAL  AX,BX
C  TOL    DESIRED LENGTH OF THE INTERVAL OF UNCERTAINTY OF THE
C         FINAL RESULT ( .GE. 0.0)
C
C
C  OUTPUT..
C
C  ZEROIN ABCISSA APPROXIMATING A ZERO OF  F  IN THE INTERVAL AX,BX
C
C
C      IT IS ASSUMED  THAT   F(AX)   AND   F(BX)   HAVE  OPPOSITE  SIGNS
C  WITHOUT  A  CHECK.  ZEROIN  RETURNS A ZERO  X  IN THE GIVEN INTERVAL
C  AX,BX  TO WITHIN A TOLERANCE  4*MACHEPS*ABS(X) + TOL, WHERE MACHEPS
C  IS THE RELATIVE MACHINE PRECISION.
C      THIS FUNCTION SUBPROGRAM IS A SLIGHTLY  MODIFIED  TRANSLATION  OF
C  THE ALGOL 60 PROCEDURE  ZERO  GIVEN IN  RICHARD BRENT, ALGORITHMS FOR
C  MINIMIZATION WITHOUT DERIVATIVES, PRENTICE - HALL, INC. (1973).
C
C  dmc 10 Nov 1998 -- added a test to enforces AX.le.ZEROIN.le.BX
C    or AX.ge.ZEROIN.ge.BX on exit
C
C
      REAL  A,B,C,D,E,EPS,FA,FB,FC,TOL1,XM,P,Q,R,S
C
C  COMPUTE EPS, THE RELATIVE MACHINE PRECISION
C
C      EPS = 1.0
C   10 EPS = EPS/2.0
C      TOL1 = 1.0 + EPS
C      IF (TOL1 .GT. 1.0) GO TO 10
       EPS = EPSLON
C
C INITIALIZATION
C
      A = AX
      B = BX
      FA = F(A)
      FB = F(B)
C
C BEGIN STEP
C
   20 C = A
      FC = FA
      D = B - A
      E = D
   30 IF (ABS(FC) .GE. ABS(FB)) GO TO 40
      A = B
      B = C
      C = A
      FA = FB
      FB = FC
      FC = FA
C
C CONVERGENCE TEST
C
   40 TOL1 = 2.0*EPS*ABS(B) + 0.5*TOL
      XM = .5*(C - B)
      IF (ABS(XM) .LE. TOL1) GO TO 90
      IF (FB .EQ. 0.0) GO TO 90
C
C IS BISECTION NECESSARY
C
      IF (ABS(E) .LT. TOL1) GO TO 70
      IF (ABS(FA) .LE. ABS(FB)) GO TO 70
C
C IS QUADRATIC INTERPOLATION POSSIBLE
C
      IF (A .NE. C) GO TO 50
C
C LINEAR INTERPOLATION
C
      S = FB/FA
      P = 2.0*XM*S
      Q = 1.0 - S
      GO TO 60
C
C INVERSE QUADRATIC INTERPOLATION
C
   50 Q = FA/FC
      R = FB/FC
      S = FB/FA
      P = S*(2.0*XM*Q*(Q - R) - (B - A)*(R - 1.0))
      Q = (Q - 1.0)*(R - 1.0)*(S - 1.0)
C
C ADJUST SIGNS
C
   60 IF (P .GT. 0.0) Q = -Q
      P = ABS(P)
C
C IS INTERPOLATION ACCEPTABLE
C
      IF ((2.0*P) .GE. (3.0*XM*Q - ABS(TOL1*Q))) GO TO 70
      IF (P .GE. ABS(0.5*E*Q)) GO TO 70
      E = D
      D = P/Q
      GO TO 80
C
C BISECTION
C
   70 D = XM
      E = D
C
C COMPLETE STEP
C
   80 A = B
      FA = FB
      IF (ABS(D) .GT. TOL1) B = B + D
      IF (ABS(D) .LE. TOL1) B = B + SIGN(TOL1, XM)
      FB = F(B)
      IF ((FB*(FC/ABS(FC))) .GT. 0.0) GO TO 20
      GO TO 30
C
C DONE
C
   90 continue
      zansr = B                    ! dmc -- guarantee answer is in range
      zansr = max(zansr,min(ax,bx))
      zansr = min(zansr,max(ax,bx))
      ZEROIN = zansr
C
      RETURN
      END
C******************** END FILE ZEROIN.FOR ; GROUP TRKRLIB **************

C******************** START FILE JIDCOD.FOR ; GROUP URDUTS *************
C------------------------------------------------------------
C& JIDCOD  UREAD CHARACTER STRING TO INTEGER DECODE
C
      INTEGER FUNCTION JIDCOD(STR,LENW,LENR,ICOD)
C
C  1ST THREE ARGUMENTS-- SEE URWORD
C   ICOD-- COMPLETION CODE
C    =0 NORMAL DECODE SUCCESSFUL
C    =-1 NULL WORD
C    =1 DECODE ERROR
C
      IMPLICIT NONE
      CHARACTER*(*) STR
C
C  DECODE BUFFER
C
      CHARACTER*20 ZDCOD,ZDCODL
C
C  LIMITS OF WORD, PRESUMED INTEGER
C
C
      integer :: LENW,LENR,ICOD,ILW,I
      ZDCOD='                    '
      ZDCODL='                    '
C
      CALL URWORD(STR,1,LENW,LENR)
C
      ILW=LENW
      IF(ILW.GT.0) CALL URWRDL(STR(1:ILW),ZDCODL,LENW)
C
      IF(LENW.EQ.0) THEN
        ICOD=-1
        JIDCOD=0
        RETURN
      ELSE IF(LENW.GT.20) THEN
        ICOD=1
        JIDCOD=0
        RETURN
      ENDIF
C
      ILW=20-LENW+1
      ZDCOD(ILW:20)=ZDCODL(1:LENW)
C  ATTEMPT DECODE
      READ(ZDCOD,1000,ERR=900) I
 1000 FORMAT(I20)
C
C  SUCCESS
      JIDCOD=I
      ICOD=0
      RETURN
C
 900  CONTINUE
C  ERROR
      ICOD=1
      JIDCOD=0
      RETURN
      END
C******************** END FILE JIDCOD.FOR ; GROUP URDUTS ***************

      subroutine ufsc_lbck(zsdate_i,zsdate,idev_i,idev,
     >     sclab_i,sclab,nsc)
c
c  standardize labels:  length & remove nulls or other unprintable
c    characters
c
      integer nsc
      character*(*) zsdate_i,zsdate,idev_i,idev
      character*30 sclab_i(*),sclab(*)
c
c-------------------------
      character*12 lbck_lbl
c-------------------------
c
      call uf_lbck('shot-date',zsdate_i,zsdate)
      call uf_lbck('device',idev_i,idev)
c
      do i=1,nsc
         write(lbck_lbl,1001) i
 1001    format('sclab(',i5,')')
         call uf_lbck(lbck_lbl,sclab_i(i),sclab(i))
      enddo
c
      return
      end

      subroutine ubcpwr(ilun,data,dlbl,nd1,nd2,nz,nx,ny,ier)
C
C  write Ufile floating point data in loss free compressed binary format.
C
C  the data array is as dimensioned; the portion
C
C    (((data(i,j,k),i=1,nx),j=1,ny),k=1,nz) will be written.
C
C  if nx=nd1 and ny=nd2, then the whole array is written, in the order
C  stored.
C
C  dlbl is passed for debugging purposes -- a name for the array being
C  written.
C
C  write on UFILES channel ilun.
C
C----------------------------------
C
      use UFILES
C
      real data(nd1,nd2,nz)
      character*(*) dlbl
C
      real zarray(UFMAXR)               ! local buffer
C
C-----------------------------------
C
      ipts=nx*ny*nz                     ! no. of pts to actually write
C
      imaxu=ufmaxr                      ! buffer size
      call ubw3int(ilun,imaxu)
C
      zsum=0.0
      do idon=0,ipts-1,imaxu            ! take data in buffer size chunks
         iget=min(ipts-idon,imaxu)
C
C  get a buffer full:
         call ufg2da(data,nd1,nd2,nz,nx,ny,idon,zarray,iget)
C
C  write it out:
         call ubwfcmp(ilun,zarray,iget,zavrat)
C
         zsum=zsum+zavrat*iget
      enddo
C
      ilen=len(dlbl)
      zavrat=zsum/float(max(1,ipts))
      write(ufelun,1001) dlbl(1:1),zavrat
 1001 format(' %ubcpwr:  loss free compression storage ratio for "',
     >              a,'":',1pe10.3)
C
      return
      end
 

      subroutine chkargs(min_num,max_num,args,
     >   max_bool,bool_list,
     >   max_a1op,a1op_list,
     >   max_lsop,lsop_list,
     >   ierr)
C
C  check unix style command line arguments -- simplified context.
C
C  context is that the command line can have three types of items:
C     arguments
C     boolean options  -xyz                            ... bool_list
C     1-argument options   -abc [argument]             ... a1op_list
C     list options  -jik arg1 arg2 arg3 ... -          ... lsop_list
C        (list options can have zero or more arguments, lists are
C        terminated by the next -option or a single "-"
C
C  the number of arguments (not associated with a - option) should be
C  between min_num and max_num; any boolean option should be in bool_list
C  (elements 1 to max_bool); any option with character argument should
C  be on a1op_list (elements 1 to max_a1op) and the argument must in fact
C  be present.
C
C
C ** input **
C
      integer min_num                   ! minimum no. of args not incl. options
      integer max_num                   ! max no. of args not incl. options
C
      character*(*) args(*)             ! the arguments found
C
      integer max_bool                  ! no. of defined boolean options
      character*(*) bool_list(*)        ! list of option codes (w/ "-" char.)
C
      integer max_a1op                  ! no. of defined char arg. options
      character*(*) a1op_list(*)        ! list of option codes (w/ "-" char.)
C
      integer max_lsop                  ! no. of defined char arg. options
      character*(*) lsop_list(*)        ! list of option codes (w/ "-" char.)
C
C ** output **
C
      integer ierr                      ! exit code, 0=OK
C
C-----------------------------------------------------
C  local:
C
      character*128 zarg
C
C-----------------------------------------------------
C
      ierr=0
C
      igot=0
C
      call get_arg_count(inum)
C
      iarg=0
 100  continue
      iarg=iarg+1
      if(iarg.gt.inum) go to 500
C
      call get_arg(iarg,zarg)
C
      if(zarg.eq.'-') go to 100
C
      if(zarg(1:1).eq.'-') then
C  option; must be on one of the lists...
         do ii=1,max_lsop
            if(zarg.eq.lsop_list(ii)) go to 110 ! check list arguments
         enddo
C
         do ii=1,max_a1op
            if(zarg.eq.a1op_list(ii)) go to 150 ! check single argument
         enddo
C
         do ii=1,max_bool
            if(zarg.eq.bool_list(ii)) go to 100 ! automatic OK if on this list
         enddo
C
C  not on any list
C
         ierr=1
         go to 900
C
 110     continue
         iarg=iarg+1
         if(iarg.gt.inum) go to 500
         call get_arg(iarg,zarg)
         if(zarg(1:1).eq.'-') then
            iarg=iarg-1
            go to 100
         else
            go to 110
         endif
C
 150     continue
         if(iarg.eq.inum) then
            ierr=1                      ! last item => missing argument
            go to 900
         endif
         iarg=iarg+1
         call get_arg(iarg,zarg)
         if(zarg(1:1).eq.'-') then
            ierr=1                      ! argument must be non-option
            go to 900
         endif
C
      else
C
C  regular argument (not associated with a -option).
C
         igot=igot+1
         if(igot.le.max_num) args(igot)=zarg
      endif
C
C  next argument item on command line...
C
      go to 100
C
C----------------------------
C  end of list
C
 500  continue
      if((min_num.le.igot).and.(igot.le.max_num)) then
         ierr=0
      else
         ierr=1
      endif
C
C  exit
C
 900  continue
      return
      end

C******************** START FILE UF3DWR.FOR ; GROUP UFILES ******************
C--------------------------------------------------------------
C  UF3DWR
C  COMPRESS AND WRITE 2-DIMENSIONAL DATA TO ASCII FILE
C
 
      SUBROUTINE UF3DWR(ILUN,IDEV_I,ZSDATE_I,
     >     F_i,NF1,NF2,X_i,NX,Y_i,NY,Z_i,NZ,IPROC,
     >     FLAB_I,XLAB_I,YLAB_I,ZLAB_I,
     >     NSC,SCVAL,SCLAB_I,
     >     IER)
 
 
C  Updated:
C    08/05/97 CAL - Add HDF / netCDF
C    08/24/93 TBT - Added call to UFAHED2 and use new format for data.
C
C  ILUN-- FILE LOGICAL UNIT NUMBER
C  IDEV-- 4 LETTER TOKAMAK DEV. CODE ("PLT ", ETC.)
C  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
C  X(NX),F(NF1,NF2,NZ),Y(NY),Z(NZ)-- REAL NUMERIC DATA TO BE WRITTEN
C   ARRAYS AND DIMENSIONS
C  IPROC- PROCESS CODE 0= "RAW", 1= AVERAGED
C    2= SMOOTHED, 3=AVERAGED AND SMOOTHED
C  XLAB-- 30 CHARACTER LABEL FOR X
C   FIRST 20 CHARACTERS-- NAME OF X
C   LAST 10 CHARACTERS--  PHYSICAL UNITS OF X
C     E.G. XLAB = 'MAJOR RADIUS        CM        '
C  FLAB-- 30 CHARACTER LABEL FOR F - SAME FORMAT AS XLAB
C  YLAB-- 30 CHARACTER LABEL FOR Y - SAME FORMAT AS XLAB
C  ZLAB-- 30 CHARACTER LABEL FOR Z - SAME FORMAT AS XLAB
C
C  NSC-- NUMBER OF ASSOCIATED SCALARS TO WRITE
C   ** NOTE NSC=0 IS ALLOWED **
C  SCVAL- VALUE(S) OF ASSOCIATED SCALARS
C  SCLAB- ASSOCIATED SCALARS KEYWORDS, LABELS, PHYS. UNITS.
C
C*  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
C
C* DENOTES OUTPUT VARIABLE
 
      USE UFILES
      implicit none
C
      character*(*) IDEV_I,ZSDATE_I
      character*(*) xlab_i(3),ylab_i(3),zlab_i(3),flab_i(3)
      CHARACTER*30 SCLAB_I(*)
C
      integer    nx, ny, nz ,nf1, nf2, nsc
      REAL X_i(NX),F_i(NF1,NF2,NZ),Y_i(NY),Z_i(NZ),SCVAL(*)
      CHARACTER*10 ZSDATE,ZDATE
      CHARACTER*30 XLAB,FLAB,YLAB,ZLAB,SCLAB(max(1,nsc))
      CHARACTER*4 IDEV
      integer     iproc, ier
 
      integer jproc
      integer ilnurd
      Integer Iformat
      integer nf,   ilun, ichan, idim,  kmprs, iendw
      integer ierh, ierr, ierrw, iluj,  l,     iflag
      real    ztol
C
      integer i,j
      real, dimension(:), allocatable :: x,y,z
      real, dimension(:,:,:), allocatable :: f
C
C$r8real_input: f_i,x_i,y_i,z_i,scval
C--------------------------------------------------------------------
C  dmc -- guard against ieee underflows... to prevent problems downstream
c
      call ufck_reset
      allocate(x(nx),y(ny),z(nz),f(nf1,nf2,nz)); f=0
      call ufck_under(ufelun,'x',x_i,x,nx)
      call ufck_under(ufelun,'y',y_i,y,ny)
      call ufck_under(ufelun,'z',z_i,z,nz)
      do j=1,nz
         do i=1,ny
            call ufck_under(ufelun,'f',f_i(1,i,j),f(1,i,j),nx)
         enddo
      enddo
c
C	----------------------------------------------------------------
C  standardize labels
C
      call ufsc_lbck(zsdate_i,zsdate,idev_i,idev,sclab_i,sclab,nsc)
C
      if(len(xlab_i(1)).ne.10) then
         call uf_lbck('xlab',xlab_i,xlab)
      else
         call uf_lbck('xlab',xlab_i(1)//xlab_i(2)//xlab_i(3),xlab)
      endif
      if(len(ylab_i(1)).ne.10) then
         call uf_lbck('ylab',ylab_i,ylab)
      else
         call uf_lbck('ylab',ylab_i(1)//ylab_i(2)//ylab_i(3),ylab)
      endif
      if(len(zlab_i(1)).ne.10) then
         call uf_lbck('zlab',zlab_i,zlab)
      else
         call uf_lbck('zlab',zlab_i(1)//zlab_i(2)//zlab_i(3),zlab)
      endif
      if(len(flab_i(1)).ne.10) then
         call uf_lbck('flab',flab_i,flab)
      else
         call uf_lbck('flab',flab_i(1)//flab_i(2)//flab_i(3),flab)
      endif
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF3DWR    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.1) THEN
        CALL UERSTA(ICHAN,'UF3DWR    ')
        GO TO 9000
      ENDIF
C
C  DIMENSION CHECK
C
      IF(NX.GT.NF1) THEN
        WRITE(UFELUN,9011) NX,NF1
 9011   FORMAT(' ? DIMENSION OF X ARRAY EXCEEDS FIRST DIMENSION OF'/
     >       '   F ARRAY --UF3DWR-- NX=',I10,' NF1=',I10/)
        GO TO 9000
      ENDIF
C
      IF(NY.GT.NF2) THEN
        WRITE(UFELUN,9012) NY,NF2
 9012   FORMAT(' ? DIMENSION OF Y ARRAY EXCEEDS 2ND DIMENSION OF'/
     >       '   F ARRAY --UF3DWR-- NY=',I10,' NF2=',I10/)
        GO TO 9000
      ENDIF
C
C
      IDIM=3
      CALL C9DATE(ZDATE)
      KMPRS = UFCPRS(ICHAN)
      if(kmprs.eq.-1) then
         write(ufelun,'('' ?UF3DWR:  MDS+ write'')')
         l=index(mds_node(ichan),' ')-1
         nf=nf1*nf2*nz
         call add3duf(ufelun,mds_node(ichan)(1:l),
     >        f,nf,x,nx,y,ny,z,nz,iproc,
     >        nx,ny,nz,iflag,flab,xlab,ylab,zlab,
     >        nsc,nsc,scval,sclab,ier)
         if (ier .eq. 0) then
            call uf_fin(ufelun,mds_node(ichan)(1:l),IDEV,ZDATE,
     >          iproc,ier)
            if (ier .eq. 0) go to 1000
         endif
         go to 9000
      endif
C
C  ** MOD APR 1984 -- ALL WRITES SWITCHED FOR BINARY COMPRESS OPTION
      IF(KMPRS.EQ.0) THEN
        CALL UFAHED2(ILUN,UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE,1,
     >       Iformat,IERH)
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE
      else if(kmprs.eq.2) then
         call ufbhed(ilun,ufshot(ichan),idev,idim,kmprs,zdate,zsdate,
     >       1,ierh)
C      else if (kmprs.eq.3) then
C         call uhdfhed(ilun,ufshot(ichan),idev,idim,kmprs,zdate,zsdate,
C     >        1,ierh)
      else if (kmprs.eq.4) then
         call ucdfhed(ilun,ufshot(ichan),idev,idim,kmprs,zdate,zsdate,
     >       1,ierh)
      ENDIF
C
C  WRITE THE ASSOCIATED SCALARS
      CALL UF0WRT(ILUN,SCVAL,SCLAB,NSC,IER)
      IF(IER.NE.0) GO TO 9000
C
      IF(KMPRS.EQ.0) THEN
        WRITE(ILUN,3003) XLAB
 3003 FORMAT(1X,A30,T32,';-INDEPENDENT VARIABLE LABEL: X-')
C
        WRITE(ILUN,3013) YLAB
 3013 FORMAT(1X,A30,T32,';-INDEPENDENT VARIABLE LABEL: Y-')
C
        WRITE(ILUN,3014) ZLAB
 3014 FORMAT(1X,A30,T32,';-INDEPENDENT VARIABLE LABEL: Z-')
C
        WRITE(ILUN,3004) FLAB
 3004 FORMAT(1X,A30,T32,';-DEPENDENT VARIABLE LABEL-')
C
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) XLAB,YLAB,ZLAB,FLAB
      else if(kmprs.eq.2) then
         call ubwchar(ilun,xlab)
         call ubwchar(ilun,ylab)
         call ubwchar(ilun,zlab)
         call ubwchar(ilun,flab)
C
C HDF ?
C      else if (kmprs .eq. 3) then
C         call uhdf3w(ilun,f,nf1,nf2,x,nx,y,ny,z,nz,iproc,
C     >                 flab,xlab,ylab,zlab,ier)
C         if (ier .ne. 0) go to 9000
C netCDF ?
      else if (kmprs .eq. 4) then
         call ucdf3w(ilun,f,nf1,nf2,x,nx,y,ny,z,nz,iproc,
     >       flab,xlab,ylab,zlab,ier)
         if (ier .ne. 0) go to 9000
      ENDIF
C
      IF(KMPRS.EQ.0) THEN
        jproc=max(0,min(9,iproc))
        WRITE(ILUN,3006) jproc
 3006 FORMAT(1X,I1,T32,';-PROC CODE- 0:RAW 1:AVG 2:SM 3:AVG+SM')
C
        WRITE(ILUN,3007) NX,NY,NZ
 3007 FORMAT(1X,I10,T32,';-# OF X PTS-'/
     >       1X,I10,T32,';-# OF Y PTS-'/
     >       1X,I10,T32,';-# OF Z PTS- X,Y,F(X,Y) DATA FOLLOW:')
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) IPROC,NX,NY,NZ
      else if(kmprs.eq.2) then
         call ubw3int(ilun,iproc)
         call ubw3int(ilun,nx)
         call ubw3int(ilun,ny)
         call ubw3int(ilun,nz)
      ENDIF
C
C
C  CONVERT INDEPENDENT DATA TO INTEGER*2 AND COMPRESS
C
      LFCLUN=.FALSE.
      if(kmprs.eq.2) then
C
         call ubcpwr(ilun,x,'x',nx,1,1,nx,1)
         call ubcpwr(ilun,y,'y',ny,1,1,ny,1)
         call ubcpwr(ilun,z,'z',nz,1,1,nz,1)
         call ubcpwr(ilun,f,'f',nf1,nf2,nz,nx,ny)
 
      else IF(KMPRS.EQ.1) THEN
C------------------------------------------/ * COMPRESSED DATA WRITES *
C ERROR LOG FILE--
C
         ILUJ=ILNURD(UJUNKA)
         CALL UFOPEN(UFCLUN,UJUNKA(1:ILUJ)//'ZUFCMPRI.ERR',2,IER,0)
         IF(IER.NE.0) GO TO 9000
         LFCLUN=.TRUE.
C
         ZTOL=UFCTOL(ICHAN)
         CALL UFSTEP(ILUN,X,'X',NX,IERR)
         IF (IERR.NE.0) THEN
            CALL UFCPWR(ILUN,X,'X',NX,1,1,NX,1,ZTOL,IERR)
         ENDIF
         CALL UFSTEP(ILUN,Y,'Y',NY,IERR)
         IF (IERR.NE.0) THEN
            CALL UFCPWR(ILUN,Y,'Y',NY,1,1,NY,1,ZTOL,IERR)
         ENDIF
         CALL UFSTEP(ILUN,Z,'Z',NZ,IERR)
         IF (IERR.NE.0) THEN
            CALL UFCPWR(ILUN,Z,'Z',NZ,1,1,NZ,1,ZTOL,IERR)
         ENDIF
C
         CALL UFCPWR(ILUN,F,'F',NF1,NF2,NZ,NX,NY,ZTOL,IERR)
C------------------------------------------/ * UNCOMPRESSED WRITES *
      ELSE IF(KMPRS.EQ.0) THEN
C
         LFCLUN=.FALSE.
C
         call ufascio(ilun,x,nx,'W',iendw,ierrw)
         call ufascio(ilun,y,ny,'W',iendw,ierrw)
         call ufascio(ilun,z,nz,'W',iendw,ierrw)
         call ufascio3(ilun,f,nf1,nf2,nx,ny,nz,'W',iendw,ierrw)
C
      ENDIF
C
      IF(KMPRS.EQ.0) WRITE(ILUN,3010)
 3010 FORMAT(' ;----END-OF-DATA-----------------COMMENTS:-----------')
C
 1000 IER=0
      UFSTAT(ICHAN)=2
C
C  IF COMPRESSION WARNING ERRORS OCCURRED, SPOOL TO TTY AND OUTPUT FILE
C
      IF(LFCLUN) THEN
        REWIND UFCLUN
        CALL USPOOL(UFCLUN,ILUN)
C
CX	 IF((UFILEV-10*(UFILEV/10)).GE.1) THEN
CX	  REWIND UFCLUN
CX	  CALL USPOOL(UFCLUN,UFELUN)
C
CX	  CALL UFPAUS(1)
CX	 ENDIF
C
        CLOSE(UNIT=UFCLUN,STATUS='DELETE')
      ENDIF
C
      goto 9999
C----------
C  ERRORS
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ? DATA NOT WRITTEN DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      UFSTAT(ICHAN)=2
      IER=1

 9999 continue
      deallocate(x,y,z,f)
      RETURN
      END
C******************** END FILE UF3DWR.FOR ; GROUP UFILES ******************

C******************** START FILE USINGL.FOR ; GROUP URDUTS ******************
C----------------------------------
C& USINGL  SUPPRESS UREAD TYPE-AHEAD
C
      SUBROUTINE USINGL
C
      USE USERIO
C
      NLHOLD=.TRUE.
      RETURN
      END
C******************** END FILE USINGL.FOR ; GROUP URDUTS ******************

      MODULE sgInt_mod

! 03/09/99 C.Ludescher
!
!      INTERFACE 
!	subroutine agcuxyi(xarray,yarray,maxa,nx,ny,xraw,yraw,xdat,ydat)
!	implicit none
!	integer maxa,nx,ny 
!	real, dimension(:,:), pointer ::  xarray, yarray
!	real xraw,yraw,xdat,ydat
!        end subroutine agcuxyi
!      END INTERFACE

      INTERFACE
	subroutine agclins(zdata,mxd,x,nx,y,ny,cl,ncl)
        implicit none
	integer :: mxd, nx, ny, ncl
	real, dimension(:), target :: x
	real, dimension(:), target :: y
	real, dimension(:,:) :: zdata
	real cl(:)
        end subroutine agclins
      END INTERFACE 

      END MODULE sgInt_mod

C******************** START FILE UCLEAR.FOR ; GROUP URDUTS ******************
C-------------------------------------------------------------
C&  UCLEAR  CLEAR UREAD TYPEAHEAD BUFFER E.G. AFTER ERROR
C  CLEAR LINE INPUT BUFFER AND CHECK OUTPUT (PROMPTING) STATUS
C
      SUBROUTINE UCLEAR
C
      USE USERIO
C
      NCHARC=0
      CBUFF = '                                        '//
     >          '                                        '//
     >          '                                        '//
     >          '        '
C
      LUWORD=0
      UWORD = '                                        '//
     >          '                                        '//
     >          '                                        '//
     >          '        '
C
      CALL CHXOUT
      RETURN
      END
C******************** END FILE UCLEAR.FOR ; GROUP URDUTS ******************

!-----------------------------------------------------------------------
!  CATFUSLIS -- PROVIDE DATA ON FUSION BY FUSION PRODUCT
!
!  modified (dmc Feb 2002 -- catfuslis.for -- now based on arguments
!  instead of COMMON).  Coordinate any changes with comput/catfus*.*
!
!  FUSION REACTION INDEXING IS AS DESCRIBED IN COMMENTS OF subroutine
!  FUSION (***** see nubeam/fusion.for comments *****).
!  see also comput/catfus*.*
!
!  Caution:  Feb 2002 (dmc):  although catfus has a notion of a "D"
!  RF minority, it is not supported here.
!
!  THIS ROUTINE RECEIVES AS ARGUMENT THE INDEX TO A FAST ION SPECIES
!  USED TO MODEL FUSION PRODUCT FAST IONS.  WHICH SPECIES INDICATES
!  THE FUSION PRODUCT AND THUS ONE OR MORE FUSION REACTIONS INVOLVED.
!
!  THIS ROUTINE GIVES AN ESTIMATE OF THE INITIAL ENERGY OF THE FUSION
!  PRODUCT ** DMC SEPT 1990 ** THIS SHOULD BE CONSISTENT WITH THE MAX
!  ENERGY SET IN S.R. DATCHK FOR THE FUSION PRODUCT SPECIES' COMPUTED
!  DISTRIBUTION FUNCTION.
!
!  ENERGY DATA IS FROM THE NRL PLASMA FORMULARY ... DMC SEPT 1990
!
subroutine CATFUSLIS_r8(IDENT,ILREACT,ZEREACT,idim, &
     nlftrit,nlfhe3,nlrfdeut,nlrftrit,nlrfhe3,ierr)
  !
  use iso_c_binding, only: fp => c_double
  use catfus_mod
  implicit none
  !
  !  input:
  character(len=*) :: ident            ! fusion product ID
  !             "P" "T" "He3" "He4" "Alpha"
  !
  integer :: idim                      ! dimension of output arrays
  !
  logical :: nlftrit                   ! TRUE if fusion product T present
  logical :: nlfhe3                    ! TRUE if fusion product He3 present
  !
  logical :: nlrfdeut                  ! TRUE if rf minority D present
  logical :: nlrftrit                  ! TRUE if rf minority T present
  logical :: nlrfhe3                   ! TRUE if rf minority He3 present
  !
  !  OUTPUT:
  !
  !  SET .TRUE. FOR REACTIONS THAT PRODUCE A DESIRED FUSION PRODUCT:
  logical, dimension(idim) :: ILREACT
  !
  !  INITIAL ENERGY (EV) OF FUSION PRODUCT SO PRODUCED:
  real(fp), dimension(idim) :: ZEREACT
  !
  integer ierr                      ! completion code: 0=OK
  !
  !-------------------------------------------------------------
  character(len=6) :: test
  !-------------------------------------------------------------
  !
  !  INPUT:
  !
  !    IDENT = FUSION PRODUCT INDEX (MUST BE NON-ZERO)
  !
  test=ident
  call uupper(test)                 ! uppercase conversion
  !
  ierr=0
  ilreact=.FALSE.
  zereact=0.0_fp
  !
  if(idim.lt.nreact) then
    write(6,*) ' ?CatFusLis:  idim = ',idim,' too small.'
    write(6,*) '  idim .ge. nreact = ',nreact,' was expected.'
    ierr=1
    return
  end if
  !
  if(test.eq.'T') then
    !
    !  TRITIUM COMES FROM THE D+D REACTION (PROTON BRANCH)
    !
    ILREACT(3)=.TRUE.
    ZEREACT(3)=1.01e6_fp
    !
  else if (test.eq.'P') then
    !
    !  Proton COMES FROM THE D+D REACTION (PROTON BRANCH)
    !
    ilreact(3) = .true.
    zereact(3) = 3.02e6_fp
    !
  else if (test.eq.'P14') then
    !  D+HE3 AND HE3+D (He3 thermal)

    ilreact(2) = .true.
    zereact(2) = 14.7e6_fp
    ilreact(8) = .true.
    zereact(8) = 14.7e6_fp

    if(NLFHE3) then
      !  fusion product He3 -- He3+D burnup reactions
      ILREACT(10)=.TRUE.
      ZEREACT(10)=14.7e6_fp          ! proton energy
    end if
    !
    if(NLRFHE3) then
      !  RF minority He3
      !  He3 + D target
      ILREACT(12)=.TRUE.
      ZEREACT(12)=14.7e6_fp          ! proton energy
    end if
    !
  else if(test.eq.'HE3') then
    !
    !  HELIUM-3 COMES FROM THE D+D REACTION (NEUTRON BRANCH)
    !
    ILREACT(4)=.TRUE.
    ZEREACT(4)=0.82e6_fp
    !
  else if((test.eq.'HE4').or.(test.eq.'ALPHA')) then
    !
    !  HELIUM-4 COMES FROM D+T, D+HE3, AND T+T REACTIONS
    !
    !  D+T AND T+D --
    ILREACT(1)=.TRUE.
    ZEREACT(1)=3.5e6_fp
    ILREACT(7)=.TRUE.
    ZEREACT(7)=3.5e6_fp
    !
    !  D+HE3 AND HE3+D
    ILREACT(2)=.TRUE.
    ZEREACT(2)=3.6e6_fp
    ILREACT(8)=.TRUE.
    ZEREACT(8)=3.6e6_fp
    !
    !  T+T (ACTUALLY I doN'T KNOW WHAT ENERGY TO GIVE ...)
    !
    ILREACT(5)=.TRUE.
    ZEREACT(5)=3.75e6_fp
    !
    if(NLFTRIT) then
      !  fusion product T -- T+D burnup reactions
      ILREACT(9)=.TRUE.
      ZEREACT(9)=3.5e6_fp
    end if
    !
    if(NLFHE3) then
      !  fusion product He3 -- He3+D burnup reactions
      ILREACT(10)=.TRUE.
      ZEREACT(10)=3.6e6_fp
    end if
    !
    if(NLRFTRIT) then
      !  RF minority T -- T+D burnup reactions
      ILREACT(11)=.TRUE.
      ZEREACT(11)=3.5e6_fp
    end if
    !
    if(NLRFHE3) then
      !  RF minority He3 -- He3+D burnup reactions
      ILREACT(12)=.TRUE.
      ZEREACT(12)=3.6e6_fp
    end if
    !
    if(NLRFDEUT) then
      !  RF minority D -- D+T burnup reactions
      ILREACT(13)=.TRUE.
      ZEREACT(13)=3.5e6_fp
      !  RF minority D -- D+He3 burnup reactions
      ILREACT(14)=.TRUE.
      ZEREACT(14)=3.6e6_fp
    end if
  else
    ierr=2
    write(6,*) ' ?CatFusLis:  ident="',ident,'" not recognized.'
  end if
  !
  return
end subroutine CATFUSLIS_r8

!--------------------------------------------
!  REAL interface
!
subroutine catfuslis(IDENT,ILREACT,ZEREACT,idim, &
     nlftrit,nlfhe3,nlrfdeut,nlrftrit,nlrfhe3,ierr)
  !
  use iso_c_binding, only: fp => c_double, sp => c_float
  implicit none
  !
  !  input:
  character(len=*) :: ident            ! fusion product ID
  !             "P" "T" "He3" "He4" "Alpha"
  !
  integer :: idim                      ! dimension of output arrays
  !
  logical :: nlftrit                   ! TRUE if fusion product T present
  logical :: nlfhe3                    ! TRUE if fusion product He3 present
  !
  logical :: nlrfdeut                  ! TRUE if rf minority D present
  logical :: nlrftrit                  ! TRUE if rf minority T present
  logical :: nlrfhe3                   ! TRUE if rf minority He3 present
  !
  !  OUTPUT:
  !
  !  SET .TRUE. FOR REACTIONS THAT PRODUCE A DESIRED FUSION PRODUCT:
  logical, dimension(idim) :: ILREACT
  !
  !  INITIAL ENERGY (EV) OF FUSION PRODUCT SO PRODUCED:
  real(sp), dimension(idim) :: ZEREACT
  !
  integer :: ierr                      ! completion code: 0=OK
  !
  !-------------------------------------------------
  real(fp), dimension(idim) :: zereact_r8
  !-------------------------------------------------
  !
  zereact_r8=0.0_fp
  !
  call catfuslis_r8(IDENT,ILREACT,ZEREACT_R8,idim, &
       nlftrit,nlfhe3,nlrfdeut,nlrftrit,nlrfhe3,ierr)

  zereact = zereact_r8
  !
  return
end subroutine catfuslis

!******************* START FILE FSVCX_Z.FOR ; GROUP FSVINT ********************
!
real(fp) FUNCTION FSVCX_Z(V)
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) v,zans,fsvgen_z
!============
  ZANS=FSVGEN_Z(V,1,0)
  FSVCX_Z=ZANS
  RETURN
END FUNCTION FSVCX_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

subroutine c9date(zdate)
  implicit none
  character, intent(out) :: zdate*9
  character :: zbuf*24
!
!  get a 9 character ddmmmyyyy
!
  call fdate(zbuf)
  if(zbuf(9:9).eq.' ')zbuf(9:9)=char(48)
  zdate=zbuf(9:10)//zbuf(5:7)//zbuf(21:24)
  return
end subroutine c9date

      subroutine ubcprd(ilun,data,dlbl,nd1,nd2,nz,nx,ny,ier)
C
C  read Ufile floating point data in loss free compressed binary format.
C
C  the data array is as dimensioned; the portion
C
C    (((data(i,j,k),i=1,nx),j=1,ny),k=1,nz) will be read.
C
C  if nx=nd1 and ny=nd2, then the whole array is written, in the order
C  stored.
C
C  dlbl is passed for debugging purposes -- a name for the array being
C  written.
C
C  read on UFILES channel ilun.
C
C----------------------------------
C
      use UFILES
C
      integer ier
      real data(nd1,nd2,nz)
      character*(*) dlbl
C
      real zarray(UFMAXR)               ! local buffer
C
C-----------------------------------
C
      ier=0
      ipts=nx*ny*nz                     ! no. of pts to actually read
C
      call ubr3int(ilun,imaxu,ier)      ! buffer size
      if(ier.gt.0) then
         write(6,
     >   '('' ?ubcprd:  '',a,'' buffer size read error.'')') dlbl
         go to 999
      endif
      if(imaxu.gt.ufmaxr) then
         imax=ufmaxr
         write(6,9901) dlbl,imaxu,imax
 9901    format(
     >' ?ubcprd:  ',a,' buffer size recorded in file = ',i10/
     >'  exceeds program limit = ',i10)
         go to 999
      endif
C
      do idon=0,ipts-1,imaxu            ! take data in buffer size chunks
         iget=min(ipts-idon,imaxu)
C
C  get a buffer full:
         call ubrfcmp(ilun,zarray,iget,ier)
         if(ier.ne.0) then
            write(6,'('' ?ubcprd:  '',a,'' read error.'')') dlbl
            go to 999
         endif
C  copy into output array:
         call ufp2da(data,nd1,nd2,nz,nx,ny,idon,zarray,iget)
C
      enddo
C
 999  continue
      return
      end
 

!-----------------------------------------------------------------------
!  PSGHCI -- CROSS SECTION OF C+6 + H --> C+6 + H+
!
real(fp) FUNCTION psghci8(ZE)
!
! INPUT
!  ZE -- COLLISION ENERGY **PER NUCLEON**  EV/AMU
!
! OUTPUT
!  PSGHCI -- CROSS SECTION, CM**2
!
! REFERENCE
!  ORNL-6090/V5, ATOMIC DATA FOR FUSION, VOLUME V,
!    "COLLISIONS OF CARBON AND OXYGEN IONS WITH ELECTRONS, H, H2, & He"
!    R.A. PHANEUF, R.K. JANEV, M.S. PINDZOLA
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) ze,emin,emax,zans,psgchvx8
!============
  real(fp) CCHEV(9)
!
  DATA EMIN/2.9e+4_fp/
  DATA EMAX/2.2e+7_fp/
!
  DATA CCHEV/&
       -7.15608e+01_fp,-1.11477_fp,-1.07011_fp,&
       4.59309e-1_fp,-1.48900e-1_fp,-5.09294e-3_fp,&
       1.97146e-2_fp,-2.52812e-2_fp,-2.71728e-2_fp/
!
  ZANS=psgchvx8(2,ZE,EMIN,EMAX,CCHEV)
  psghci8=ZANS
!
  RETURN
END FUNCTION psghci8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

      subroutine ufbhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,
     >                  iwrite,ier)
c
c  Ufiles i/o
c  read/write header -- portable binary format
C
C  ILUN - UNIT TO READ/WRITE
C  ISHOT - UP TO 6 DIGIT SHOT NUMBER
C  IDEV - 4 CHAR TOKAMAK CODE
C  IDIM - UFILES FILE DIMENSIONALITY
C  IKMPRS - DATA COMPRESSION CODE
C  ZWDATE - FILE WRITE DATE
C  ZSDATE - SHOT (DATA ORIGIN) DATE
C
C  IWRITE: = 0 ** READ **
C          = 1 ** WRITE **
C
C  OUTPUT IER ERROR CODE 0=NORMAL, 1=ERROR
C   ROUTINE NOW CHECKS FOR ERROR ON READ
C
c
      character*4 idev
      character*10 zwdate,zsdate
c
      ier=0
C
      if(iwrite.eq.1) then
         call ubw3int(ilun,ishot)
         call ubwchar(ilun,idev)
         call ubw3int(ilun,idim)
         ikmprs=2
         call ubw3int(ilun,ikmprs)
         call ubwchar(ilun,zwdate)
         call ubwchar(ilun,zsdate)
      else if(iwrite.eq.0) then
         call ubr3int(ilun,ishot,ier)
         if(ier.ne.0) go to 8999
         call ubrchar(ilun,idev,ier)
         if(ier.ne.0) go to 8999
         call ubr3int(ilun,idim,ier)
         if(ier.ne.0) go to 8999
         call ubr3int(ilun,ikmprs,ier)
         if(ier.ne.0) go to 8999
         call ubrchar(ilun,zwdate,ier)
         if(ier.ne.0) go to 8999
         call ubrchar(ilun,zsdate,ier)
         if(ier.ne.0) go to 8999
      endif
C
      return
C
 8999 continue
      ier=1
      return
C
      end

      subroutine add_inf(lun, runid, ier)
C Read TR.INF to get date, user, comment
C 02/14/01 C.Ludescher
C
C History:
C
      implicit none
C Input
      integer         lun           ! for error messages
      character*(*)   runid
C Return
      integer         ier
 
      character*12    user
      character*120   expr
      character*132   line, zline
      character*60    infnam
      character*9     date
      character*1     zap
      integer         i, l, l1, l2, l3, ios, stat, ier1
      logical         ex, badinf, no_date_began
      character*132   text(100)
      character*1,    allocatable :: text2(:) 
      integer         MdsPut, MdsValue
      integer         idescr_cstring, idescr_long
      integer         descr, dsc, mdsstat, size
      integer         nlines, maxl, ii, jt
C------------------------------------------------------------------
C clear text array
      do i=1,100
         text(i) = ' '
      end do

      ier = 0
      ier1= 0
      badinf = .false.
      no_date_began=.false.
      zap=char(39)
 
C open TR.INF file
C-------------------
      infnam = runid//'TR.INF'
CXX      print *,infnam
      open (29,file=infnam,status='OLD',iostat=ios,err=1001,
     >      action="read")
      read(29,'(a)',iostat=ios,err=102,end=106)line
      l2 = len_trim(line)
CXX      print*,'line=',l2, line
 
C get DATE_BEGAN
      l=0
      do while (l .le. 0)
          l = index(line,'D=')
CXX          print *,'l=',l
C     Check if screwed up
          if (l .gt. 0) then
CXX           print *,'D=',l
              l1 = index(line,'-') ! date format: dd-mmm-yy
CXX           print *,'l1=',l1
              if (l1 .le. 0) then
C check if unix date
CXX               print *,'try unix'
                  l1 = index(line(l:),' ') ! date on unix: ddMmmyyyy
                  if (l1 .le. 0) then
                      l=0
                  else
                      l = l1-8
                      date = line(l:l+8)
                  endif
              else
                  if (l .gt. l1) l=l1-4
                  date = line(l+2:l+10)
              endif
          endif
 
         if (l .le. 0) then
             read(29,'(a)',iostat=ios,err=102,end=106)line
             l2 = len_trim(line)
CXX          print*,'line=',l2, line
         endif
      end do
 
      print*,'date =',date
      stat=MdsPut('DATE_BEGAN'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(date),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?add_inf: put DATE_BRGAN - stat:  ',stat)
      end if
 
C
C get USER_ID
 
C Note could be  ' BY' or ' BY:'
      l1 = index(line,' BY') +4
CXX   print *,'l1=',l1
      do while (l1 .le. 4 .and. .not. badinf)
         read(29,'(a)',iostat=ios,err=102,end=106)line
         l2 = len_trim(line)
CXX      print*,'line=',l2,line
         l1 = index(line,' BY') +4
CXX      print *,'l1=',l1
         if (index(line,'<*=*>') .gt. 0) then
            badinf=.true.
CXX         print *,'%add_inf -- premature <*=*>'
         endif
      end do
      do while (line(l1:l1) .eq. ' ')
         l1=l1+1
      end do
      l2 = index(line(l1:),' ') +l1-2
CXX   print *,'user: ',line(l1:l2),l1,l2
      if (line(l1:l2+7) .eq. 'TRANSP SYSTEM') then
          badinf = .true.
CXX       print *,'%add_inf -- TR.INF looks peculiar !!'
      endif
      user=line(l1:l2)
      stat=MdsPut('USER_ID'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(user(1:l2-l1+1)),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?add_inf: put USER_ID - stat:  ',stat)
      end if
 
C
      read(29,'(a)',iostat=ios,err=102,end=106)line
C
C Don't get comment if TR.INF is not normal
      if (badinf) goto 3000
C
c get COMMENT
      nlines=1
      read(29,'(a)',iostat=ios,err=102,end=106)line
      if (line(1:18) .eq. '# User comments on' .or.
     >    line(1:19) .eq. ' # User comments on' ) then
         read(29,'(a)',iostat=ios,err=102,end=106)line
      endif
 2000 continue
      maxl=0

C      l3=1
      do while (index(line,'<*=*>') .eq. 0)
         l2 = index(line,zap)
         if (l2 .gt. 0) then
             zline=line(1:l2-1)//zap//line(l2:)
             l=len_trim(zline)
             line=zline(1:l)
         else
             l=len_trim(line)
         endif
         if (l .gt. maxl) maxl=l 
         do ii=1,l
            text(nlines)(ii:ii) = line(ii:ii)
         end do
         
CXX      print *,l3,' ',text(1:l3)
         read(29,'(a)',iostat=ios,end=1002,err=102)line
         nlines=nlines+1
         l = len_trim(line)
CXX      print*,'line',nlines,'=',l, line
      end do
 1002 continue
C     Only write Comment of non-zero
      if (nlines .gt. 0 .and. maxl .gt. 0) then
         allocate(text2(nlines*maxl),stat=stat)
         if (stat .ne. 0) then
            write(lun,'(" ?add_inf -- error allocating text2(",i8,")",
     >        i6)') nlines*maxl,stat
            ier=1
            return
         endif
         jt=1
         do i=1,nlines
            do ii=1,maxl
               text2(jt)=text(i)(ii:ii)
               jt=jt+1
            enddo
         enddo
         dsc = descr(14,text2,nlines,0,maxl)
         stat = MdsPut('COMMENT'//CHAR(0), '$'//CHAR(0),
     >        dsc,0)
         if(mod(stat,2).ne.1) then
            call mdsmsg(lun,'?add_inf: -- put comment stat:  ',stat)
            ier = 1
         endif
         deallocate(text2)
      endif
C
C get EXPERT module
C only used if EX.FOR exists
 3000 l=len_trim(infnam)
      infnam(l-5:l)='ex.for'
      print*,'check for ', infnam
      inquire(file=infnam,exist=ex,iostat=ios)
      if (.not. ex) then
         infnam(l-5:l)='ex.f90'
         print*,'check for ', infnam
         inquire(file=infnam,exist=ex,iostat=ios)
      end if         
      if (ex) then
         print*,'add EXPERT_CODE'
C add EXPERT_CODE
         call add_file(lun,runid,'EXPERT_CODE',
     >        ' ',' ',0,' ',ier1)
      endif
      ier = ier + ier1
      return
C----------------------------------------------
C Try reading <runid>CC.TMP
 1001 continue
CXX   print *,'error opening ',infnam
      infnam = runid//'CC.TMP'
      print *,'try  ',infnam
      open (29,file=infnam,status='OLD',iostat=ios,err=1003,
     >      action="read")
      read(29,'(a)',iostat=ios,err=102,end=106)line
C Get username
C Check if <runid>.OWNER exists
      infnam = runid//'.OWNER'
CXX   print *,'try  ',infnam
      open (28,file=infnam,status='OLD',iostat=ios,action="read")
      if (ios .eq. 0) then
         read(28,'(a)',iostat=ios,err=102,end=106)user
         close(28)
         print*,'user from file = ',user
      else
         call sget_user(user)
         print*,user
      endif

C Get date
      call c9date(date)
C
C Write Nodes
 1004 stat=MdsPut('USER_ID'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(user),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?add_inf: put USER_ID - stat:  ',stat)
      end if
      if ( .not. no_date_began) then
        stat=MdsPut('DATE_BEGAN'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(date),0,size)
        if (mod(stat,2).ne.1) then
           call mdsmsg(lun,
     >        '?add_inf: put DATE_BEGAN - stat:  ',stat)
        end if
      endif
 
C Read Comment
      nlines=1
C      read(29,'(a)',iostat=ios,err=102,end=106)line
      if (line(1:18) .eq. '# User comments on' .or.
     >    line(1:19) .eq. ' # User comments on' ) then
         read(29,'(a)',iostat=ios,err=102,end=1002)line
      endif
      goto 2000
C---------------------------------------------------------------------------
C For Re-writes
 1003 continue
      infnam = runid//'.COMMENT'
      print *,'try  ',infnam
      open (29,file=infnam,status='OLD',iostat=ios,err=101,
     >      action="read")
      read(29,'(a)',iostat=ios,err=102,end=106)line
C Get username
      infnam = runid//'.USER_ID'
      print *,'try  ',infnam
      open (28,file=infnam,status='OLD',iostat=ios,err=101,
     >      action="read")
      read(28,'(a)',iostat=ios,err=102,end=106)user
      print*,user
      close(28)
C Get date began
      infnam = runid//'.DATE_BEGAN'
      print *,'try  ',infnam
      open (28,file=infnam,status='OLD',iostat=ios,err=105,
     >      action="read")
      read(28,'(a)',iostat=ios,err=102,end=106)date
      print*,date
      close(28)
      no_date_began=.false.
      goto 1004
C-----------------------------------------------------------------------------
 101  print *,'error opening ',infnam
      ier=-1
      return
 102  print *,'error reading ',infnam
      ier=1
      return
 103  print *,'error writing ',ios
      ier=1
      return
 104  print *,'error writing ',ios
      ier=1
      return
 105  print *,'error opening ',infnam
      no_date_began=.true.
      goto 1004
 106  print *,'error end of file ',infnam
      ier=1
      return
      end
 
 
 

C******************** START FILE URDCHR.FOR ; GROUP USINIT ******************
C--------------------------------------------------
C& URDCHR  ACTIVATE COMMAND AND PARAMETER CONTROL CHARACTERS
C
      SUBROUTINE URDCHR
      USE USERIO
C
      CHARACTER*1 ZNULL
C
      ZNULL=CHAR(0)
C
      if(levcmd.eq.1) then
         MPARAM=MSLASH
      else
         MPARAM=ZNULL
      endif
      MCMD=MSTAR
C
      RETURN
      END

C--------------------------------------------------------------
C  GRALBL - LABEL A 2D PLOT WITH UNITS AND MAJOR PLOT LABELS
C
C   * CALL AFTER THE PLOT HAS BEEN DRAWN; BEFORE UPAUSE CALL *
C
      SUBROUTINE GRALBL(XUN,YUN,LBL1,LBL2,LBL3)
C
c--------------------
c  allow for raising of lower edge...
      use bottoms_up
c--------------------

      CHARACTER*(*) XUN ! X (HORIZ. AXIS) UNITS LABEL
      CHARACTER*(*) YUN ! Y (VERT. AXIS) UNITS LABEL
C
      CHARACTER*(*) LBL1 ! MAIN PLOT LABEL (TOP OF GRAPH)
      CHARACTER*(*) LBL2 ! MAIN PLOT LABEL (JUST UNDER LBL1)
      CHARACTER*(*) LBL3 ! MAIN PLOT LABEL (BOTTOM OF GRAPH)
C
      CALL GRFLBL(720,50+ibu_raise*idybu,XUN,0,-1,0)  ! x units label
      CALL GRFLBL(30,680,YUN,0,-1,1)   ! VERTICAL LABEL (y units)
C
      CALL GRFLBL(180,750,LBL1,60,-1,0)
C
      if(len(trim(lbl1)).eq.0) then
        CALL GRFLBL(180,727,LBL2,60,0,0)  ! CTR LONE LABEL AT TOP
      ELSE
        CALL GRFLBL(180,727,LBL2,60,-1,0) ! RIGHT JUSTIFY 2 LBLS @TOP
      ENDIF
C
      if(ibrk_lbl3.eq.0) then
         CALL GRFLBL(100,20,LBL3,60,0,0) ! CTR AT BOTTOM
      else
         ! center both parts
         CALL GRFLBL(100,20+idybu,LBL3(1:ibrk_lbl3),60,0,0)
         CALL GRFLBL(100,20,LBL3(ibrk_lbl3+1:),60,0,0)
      endif
C
      RETURN
      END

subroutine rfx_antcen(nant,ra,za,rcen,zcen,hh)

  ! compute antenna center and half-height from array info
  ! hh = (zmax-zmin)/2; rcen = r value of location in ra(:),za(:) closest to
  !                            center of structure

  ! mod DMC May 2008: hh is now half the distance btw end pts; 
  !   (rcen,zcen) is the center -- allow off-midplane antenna.

  use iso_c_binding, only: fp => c_double
  implicit none

  !---------
  integer, intent(in) :: nant
  real(fp), intent(in) :: ra(nant),za(nant)
  real(fp), intent(out) :: rcen,zcen
  real(fp), intent(out) :: hh

  !---------
  real(fp) :: zcmin,zctest,zrr,zzz
  integer :: k,icmin

  !---------

  zcmin=(ra(nant)-ra(1))**2 + (za(nant)-za(1))**2
  hh = zcmin/2

  icmin=1

  do k=2,nant
    zctest = (ra(1)+ra(nant)-2*ra(k))**2 + (za(1)+za(nant)-2*za(k))**2
    if(zctest.lt.zcmin) then
      zcmin=zctest
      icmin=k
    endif
  enddo

  rcen=ra(icmin)
  zcen=za(icmin)

  return
end subroutine rfx_antcen

C------------------------------------------------------------
C  GAXGDF - FETCH DEFAULT 2D GRAPH AXES TYPE CONTROL CODE
C   4 VALUES SPECIFYING VARIOUS COMBINATIONS OF LOG/LIN
C   X AND Y AXES
C
      SUBROUTINE GAXGDF(ISEL)
C
      INCLUDE 'GAXES_BLK'
C
      IF(IGXINI.EQ.0) CALL GAXES0
      ISEL=IAXSEL
C
      RETURN
      END

C******************** START FILE UFESET.FOR ; GROUP UFILS0 ******************
C---------------------------------------------------------------------
C  UFESET - SET LOGICAL UNIT FOR ERROR MESSAGES FROM UFILES
C
      SUBROUTINE UFESET(ILUN)
C
      USE UFILES
C
      CALL UFINIT
C
      UFELUN=ILUN
C
      RETURN
      END
C******************** END FILE UFESET.FOR ; GROUP UFILS0 ******************

      MODULE agcGet_mod
      INTERFACE 
        subroutine agcxget(xind,fxx,x,nxs)
        implicit none
        real, dimension(:), pointer  :: x
        real     xind, fxx
        integer  nxs
        end subroutine agcxget
      END INTERFACE

      INTERFACE 
 	subroutine agcyget(yind,fyy,y,nys)
	implicit none
	real, dimension(:), pointer     :: y
	real  yind, fyy
	integer  nys
        end subroutine agcyget
      END INTERFACE 

      END MODULE agcGet_mod

C******************** START FILE DPLOFR.FOR ; GROUP DPLOTT *************
C=========================================================
C  DPLOFR   DRAW FRAME; RASTER LOCATION OF CORNERS PASSED
C           D. MC CUNE   21 MAY 80
C
C  INIT-- =1==> CLEAR SCREEN AND CALL UBINIT
C
      SUBROUTINE DPLOFR(IX1,IX2,IY1,IY2,INIT)
C
      DIMENSION ZHOLD(4),ZMMAX(4),XBOX(5),YBOX(5),XMMAX(4)
      INCLUDE 'PLOT1MMXB'
C
      EQUIVALENCE (XMMAX(1),XBND1)
C
      DATA ZMMAX/0.0,1.0,0.0,1.0/
      DATA XBOX/0.0,1.0,1.0,0.0,0.0/
      DATA YBOX/0.0,0.0,1.0,1.0,0.0/
C
C  SAVE AND RESET XMIN,XMAX FOR DRAWING FRAME
      DO 4 I=1,4
        ZHOLD(I)=XMMAX(I)
        XMMAX(I)=ZMMAX(I)
 4    CONTINUE
C  INITIALIZE IF INIT=1
      IF(INIT.EQ.1) THEN
        CALL UBINIT
      ENDIF
C
      CALL SLIMX(IX1,IX2)
      CALL SLIMY(IY1,IY2)
      CALL XTYPE(1)
      CALL YTYPE(1)
      CALL DLIMX(XBND1,XBND2)
      CALL DLIMY(YBND1,YBND2)
      CALL XFRM(2)
      CALL YFRM(2)
C  DRAW FRAME
      CALL NPTS(5)
       CALL LINE(0)
      CALL CHECK(XBOX,YBOX)
      CALL SETWIN
      CALL CPLOT(XBOX,YBOX)
C  RESTORE XMIN,XMAX,YMIN,YMAX
      DO 5 I=1,4
      XMMAX(I)=ZHOLD(I)
 5    CONTINUE
      CALL DLIMX(XBND1,XBND2)
      CALL DLIMY(YBND1,YBND2)
C
      RETURN
      	END
C******************** END FILE DPLOFR.FOR ; GROUP DPLOTT ******************

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SVTH_Z(TEMP,EPS,ITER,NREACT,KK,IW)
!	3/8/77
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod, only :A,HOLD=>B,CON1=>CON,EPS1=>EPS,ITER1=>ITER,IW1=>IW
  use physconst_mod, only : two,sqpi,VC
  IMPLICIT NONE
  INTEGER iter,nreact,kk,iw
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) temp,eps,con,bmass,tmass,dummy,&
       rm,sigma_z,svthe_z
!============
  con=two*sqrt(two)/sqpi*VC
!	CON - =SQRT(8/PI)*C (m/sec)
!	THIS FUNCTION WAS WRITTEN BY HARRY H. TOWNER OF THE
!	PRINCETON PLASMA PHYSICS LAB.  THIS FUNCTION
!	WILL CALCULATE <SIGMA*V> FOR A GIVEN REACTION.	THIS FUNCTION
!	ASSUMES A MAWELLIAN DISTRIBUTION FOR EACH OF THE PARTICIPANTS.
!	THIS ROUTINE IS USED TO INITIALIZE SIGMA AND STORE VALUES
!	IN COMMON BLOCK CSVTH.	IT THEN CALLS FUNCTION SVTHE AND
!	CALCULATES <SIGMA*V> FOR THE GIVEN REACTION.  NOTE THAT IF THE
!	TEMPERATURE IS THE ONLY PARAMETER WHICH VARIES THEN SVTHE
!	SHOULD BE USED AFTER AN INITIALIZING CALL TO SVTH IS MADE.
!	PARAMETERS:
!	TEMP - THE TEMPERATURE AT WHICH YOU WANT <SIGMA*V>  (IN KEV)
!	EPS - THE DESIRED RELATIVE ERROR IN THE REACTIVITY
!	ITER - THE MAXIMUM NUMBER OF ITERATIONS TO BE TAKEN IN ORDER
!		TO ACHIEVE THE DESIRED RELATIVE ERROR (EPS).
!	NREACT - TELLS WHICH REACTION YOU WANT
!	  =1 YOU GET <SIGMAV> FOR THE REACTION	T(D,N)HE4
!	  =2 YOU GET <SIGMAV> FOR THE REACTION	HE3(D,P)HE4
!	  =3 YOU GET <SIGMAV> FOR THE REACTION	D(D,P)T
!	  =4 YOU GET <SIGMAV> FOR THE REACTION	D(D,N)HE3
!	  =5 YOU GET <SIGMAV> FOR THE REACTION	T(T,2N)HE4
!	  =12 YOU GET <SIGMAV> FOR THE REACTION	T(T,2N)HE4 DPC fit 06/2018
!	  =6 YOU GET <SIGMAV> FOR THE REACTION	T(HE3,X)Y
!	KK - IF KK=1 THAN YOU GET THE REVERSE REACTION IE IF N=1 AND
!	     KK=1 YOU GET <SIGMA*V> FOR THE REACTION D(T,N)HE4
!	IW - THE LOGICAL UNIT USED FOR PRINTING.
!	PARAMETER LIST FOR COMMON BLOCK CSVTH.
!	A - =RMASS/TMASS
!	HOLD - A PLACE HOLDER IN COMMON BLOCK CSVTH.
!	CON1 - =CON*A**1.5/SQRT(TMASS)
!	EPS1 - EPS
!	ITER1 - ITER
!	IW1 - IW
!	I NOW FIND THE MASSES FOR THE GIVEN REACTION.
  CALL RMASS_Z(NREACT,KK,BMASS,TMASS,DUMMY,DUMMY)
!	THE REDUCED MASS IS NOW CALCULATED.
  RM=TMASS*BMASS/(TMASS+BMASS)
!	I NOW INITIALIZE THE FUSION CROSS SECTION.
  DUMMY=SIGMA_Z(NREACT,KK,IW,100.0_fp)
!	I NOW FILL IN VALUES FOR COMMON BLOCK CSVTH.
  A=RM/TMASS
  CON1=CON*A**1.5_fp/SQRT(TMASS)
  EPS1=EPS
  ITER1=ITER
  IW1=IW
!	I NOW FIND <SIGMA*V> (M**3/SEC) FOR THE REACTION.
  SVTH_Z=SVTHE_Z(TEMP)
  RETURN
END FUNCTION SVTH_Z
!
!------------------------------------------------------------------------------
 
 
 
 
 
 
 
 
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

      subroutine ck_sepseg(xsegs,nsegs,norder,iorder)
c
      implicit NONE
      integer, intent(in) :: nsegs      ! no. of segments
      real, intent(in) :: xsegs(2,nsegs) ! segments; xsegs(1,i).le.xsegs(2,i)
      integer, intent(out) :: norder    ! ordering flag
                                        ! +1 -- ordering OK
                                        !  0 -- segments not disjoint
                                        ! -1 -- invalid segment
      integer, intent(out) :: iorder(nsegs) ! ordering
c
c  returning ordering of disjoint segments if possible
c  a segment is a pair of numbers x1,x2 satisfying x1.le.x2
c  (x1a,x2a) is disjoint from (x1b,x2b) if x1a.gt.x2b or x2a.lt.x1b
c
c  if all segments are disjoint, their ordering is returned in iorder(...)
c  so that xsegs(1:2,iorder(1)) is the segment with lowest values,
c          xsegs(1:2,iorder(2)) the next lowest, etc.
c
c  caution: N^2 algorithm is used, number of segments is assumed to be small!
c
      integer ii,jj,inside,iord(nsegs)
c--------------------------
c
      norder=-1
      do ii=1,nsegs
         if(xsegs(1,ii).gt.xsegs(2,ii)) return  ! invalid segment
      enddo
c
c  simple answer if only one segment
c
      if(nsegs.eq.1) then
         norder=1
         iorder(norder)=1
         return
      endif
c
c  scan multiple segments -- n**2 algorithm
c
      norder=0
      iord=1
      inside=0
c
      do jj=1,nsegs
         do ii=1,nsegs
            if(ii.eq.jj) cycle
            if((xsegs(2,jj).lt.xsegs(1,ii)).or.
     >         (xsegs(1,jj).gt.xsegs(2,ii))) then
               if(xsegs(1,jj).gt.xsegs(2,ii)) then
                  iord(jj)=iord(jj)+1
               endif
            else
               inside=ii
               exit
            endif
         enddo
         if(inside.ne.0) exit
      enddo
c
      if(inside.ne.0) then
         continue                       ! not disjoint
      else
         norder=nsegs
         iorder=iord
      endif
c
      return
      end

!
! --- getLog2Int1 ---
!
! fetch the integer 2**k+1>=ix for the smallest integer k>=2
!
function getLog2Int1(ix) result (kk)
  integer,intent(in) :: ix    ! target value
  
  integer :: kk    ! 2**k+1
  
  kk = 5
  do while(kk<ix)
     kk = 2*kk-1
  end do
end function getLog2Int1

      subroutine pbinrd(lun_warn,ichan,zfile,zdata,ndata,ngot,ier)
c
c  read a portable binary file, with given name,
c  containing zdata(1:ngot) -- single precision.
c  ngot, also read from file, must be .le. ndata = size of array passed
c
      implicit NONE
c
c  input arguments:
c
      integer lun_warn                  ! fortran lun for messages
c
      integer ichan                     ! i/o channel number, btw 0 and 100
c
c  note ichan is not a fortran lun -- the underlying i/o code is in C.
c
      character*(*) zfile               ! filename -- existing file
c
      integer ndata                     ! max number of data points
      real zdata(ndata)                 ! the data...
c
c  ndata must be a positive integer that will fit in 3 bytes, i.e.
c  ndata must be .le. 2**24 - 1  ~ 16,000,000
c
c  output arguments:
c
      integer ngot                      ! actual number of data pts in file
c
      integer ier                       ! completion code: 0 = normal
c--------------------------------------
c
      integer idum,nbuf,ibytes,ifmt
c
#include "fpreproc/byte_declare.h"
c
      byte_declare buf(512)             ! i/o buffer
      byte_declare ilbuf(4)             ! local buffer
c
      real fieee(ndata)                 ! floating data converted to ieee
c
c--------------------------------------
c
      call genopen(ichan,zfile,'OLD','BLOCKD',idum,ier)
      if(ier.ne.0) return
c
      nbuf=0
c
      ibytes=4                          ! byte size of local buffer
      call ubufi(ichan,buf,nbuf,ilbuf,ibytes)
c
#if __CRAY || __SX
      ifmt=ichar(ilbuf(1))              ! =4:  code for "no compression"
#else
      ifmt=ilbuf(1)                     ! =4:  code for "no compression"
#endif
      if(ifmt.ne.4) then
         write(lun_warn,*) ' ?pbinrd:  unexpected format code:  ',ifmt
         ier=1
         go to 1000
      endif
c
c  get data size and check...
c
      call ubi3dcod(ilbuf,2,ngot)       ! data size, in ilbuf(2:4).
      if(ngot.gt.ndata) then
         write(lun_warn,*) ' ?pbinrd:  passed array too small:'
         write(lun_warn,*) '  passed size = ',ndata,' need = ',ngot
         ier=1
         go to 1000
      endif
c
c  read data...
c
      ibytes=4*ngot
      call ubufi(ichan,buf,nbuf,fieee,ibytes)
c
c  reassemble byte ordering
c
      call packordr(fieee,ngot,0)
c
c  vms conversion of ieee floating point data (in unix: just copy)
c
      call vmsieee(lun_warn,zdata,ngot,fieee,0)
c
 1000 continue
c
c  close file
c
      call cftclose(ichan)
c
      return
      end

C******************** START FILE GRFUF1.FOR ; GROUP GRFUF1 *************
C  GRAFXF - DMC - REWRITTEN BASIC F(X) FIT GRAPHICS INTERFACE ROUTINE
C    THIS ROUTINE CONTROLS DRAWING AND LABELING OF A 1 PAGE PLOT
C    OF A SINGLE FUNCTION F(X), AND GENERATION OF A REPLOT/RESCALE
C    (UREAD) OPTION MENU
C
C  PLOT A NUMERIC FIT CURVE (SOLID LINE)
C   PLOT ORIGINAL DATA (PT SYMBOLS)
C
C  PLOT SCALE DETERMINED BY FIT DATA
C   NORMALLY THE FIT, DRAWN AS A SOLID CURVE, SHOULD HAVE A NORMAL
C   (SORTED ASCENDING) X AXIS
C
C  THE ORIG. DATA (PT PLOT) MAY BE (X,Y) PAIRS IN ANY ORDER
C
C
C    A NEW CALLING ARGUMENT LIST IS PROVIDED
C
      SUBROUTINE GRAFXF(X,Y,N,X2,Y2,N2,
     >                    XUN,YUN,LBL1,LBL2,LBL3)
C
C  DATA:
      REAL X(N),Y(N)  ! NUMERIC FIT DATA CURVE (SOLID LINE)
      REAL X2(N2),Y2(N2)  ! "ORIGINAL" DATA (POINT PLOT)
C
C
C  LABELS:
      CHARACTER*(*) XUN,YUN,LBL1,LBL2,LBL3
C
C  LOCAL
      REAL XERRB(2),YERRB(2)
      integer n_sc
      real, dimension(:), allocatable :: x_sc,y_sc
C
C  CONTROL:
      INTEGER IMENU
C
C  IF IMENU=1 JUMP DIRECTLY TO REPLOT MENU (DO NOT DRAW GRAPH 1ST)
C
      integer icounter
      integer, save :: iopcod=0
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      DATA IMENU/0/
C
C-------------------------------------------------------------
C
      icounter=0
C---------------------------------------------------------------
C
      n_sc=n+n2
      allocate(x_sc(n_sc),y_sc(n_sc))
      x_sc(1:n)=x
      x_sc(n+1:n+n2)=x2
      y_sc(1:n)=y
      y_sc(n+1:n+n2)=y2
C
C  SCALE SET SWITCH CLEARED:
C
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
C
      CALL GAXGDF(ISEL)
C
      IF(IMENU.EQ.1) GO TO 200
C
C----------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(x_sc,y_sc,y_sc,0,n_sc)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(x_sc,n_sc,y_sc,y_sc,0,n_sc,1,1,1,1,n_sc,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD) ! AXIS (LOG/LIN) CHECK
C
      CALL GSCREC  ! RECORD PLOT SCALE IN MEMORY
C
      CALL DPLOT1(X,Y,N,ICOD) ! DRAW GRID AND F(X) SOLID CURVE
C
      CALL DPLOT1(X2,Y2,N2,16)  ! INDIV. DATA POINTS PLOT
C
      CALL GRALBL(XUN,YUN,LBL1,LBL2,LBL3)  ! LABEL THE PLOT
C
      CALL UPAUST(2)  ! PAUSE AFTER PLOT
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SA',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         deallocate(x_sc,y_sc)
         RETURN
      ENDIF
C
      CALL UERMSI(' ?GRAFXF *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      END
C******************** START FILE GRFUF1.FOR ; GROUP GRFUF1 *************
C  GRAFXF - DMC - REWRITTEN BASIC F(X) FIT GRAPHICS INTERFACE ROUTINE
C    THIS ROUTINE CONTROLS DRAWING AND LABELING OF A 1 PAGE PLOT
C    OF A SINGLE FUNCTION F(X), AND GENERATION OF A REPLOT/RESCALE
C    (UREAD) OPTION MENU
C
C  PLOT A NUMERIC FIT CURVE (SOLID LINE)
C   PLOT ORIGINAL DATA (PT SYMBOLS)
C
C  PLOT SCALE DETERMINED BY FIT DATA
C   NORMALLY THE FIT, DRAWN AS A SOLID CURVE, SHOULD HAVE A NORMAL
C   (SORTED ASCENDING) X AXIS
C
C  THE ORIG. DATA (PT PLOT) MAY BE (X,Y) PAIRS IN ANY ORDER
C
C
C    A NEW CALLING ARGUMENT LIST IS PROVIDED
C
      SUBROUTINE GRAFXF_icod(X,Y,N,X2,Y2,N2,
     >                    XUN,YUN,LBL1,LBL2,LBL3,icdd)
C
C  DATA:
      REAL X(N),Y(N)  ! NUMERIC FIT DATA CURVE (SOLID LINE)
      REAL X2(N2),Y2(N2)  ! "ORIGINAL" DATA (POINT PLOT)
C
C
C  LABELS:
      CHARACTER*(*) XUN,YUN,LBL1,LBL2,LBL3
C
C  LOCAL
      REAL XERRB(2),YERRB(2)
      integer n_sc
      real, dimension(:), allocatable :: x_sc,y_sc
C
C  CONTROL:
      INTEGER IMENU
C
C  IF IMENU=1 JUMP DIRECTLY TO REPLOT MENU (DO NOT DRAW GRAPH 1ST)
C
      integer icounter
      integer, save :: iopcod=0
      integer :: icdd
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      DATA IMENU/0/
C
C-------------------------------------------------------------
C
      icounter=0
C---------------------------------------------------------------
C
      n_sc=n+n2
      allocate(x_sc(n_sc),y_sc(n_sc))
      x_sc(1:n)=x
      x_sc(n+1:n+n2)=x2
      y_sc(1:n)=y
      y_sc(n+1:n+n2)=y2
C
C  SCALE SET SWITCH CLEARED:
C
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
C
      CALL GAXGDF(ISEL)
C
      IF(IMENU.EQ.1) GO TO 200
C
C----------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(x_sc,y_sc,y_sc,0,n_sc)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(x_sc,n_sc,y_sc,y_sc,0,n_sc,1,1,1,1,n_sc,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD) ! AXIS (LOG/LIN) CHECK
C
      CALL GSCREC  ! RECORD PLOT SCALE IN MEMORY
C
      CALL DPLOT1(X,Y,N,ICOD) ! DRAW GRID AND F(X) SOLID CURVE
C
      CALL DPLOT1(X2,Y2,N2,icdd)  ! INDIV. DATA POINTS PLOT
C
      CALL GRALBL(XUN,YUN,LBL1,LBL2,LBL3)  ! LABEL THE PLOT
C
      CALL UPAUST(2)  ! PAUSE AFTER PLOT
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SA',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         deallocate(x_sc,y_sc)
         RETURN
      ENDIF
C
      CALL UERMSI(' ?GRAFXF *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      END
C------------------------------------------------------------
      SUBROUTINE GRAFXF_icod0(X,Y,N,X2,Y2,N2,
     >                    XUN,YUN,LBL1,LBL2,LBL3,icdd)
C same as GRAFXF_icod but with small size of individual points
C
C  DATA:
      REAL X(N),Y(N)  ! NUMERIC FIT DATA CURVE (SOLID LINE)
      REAL X2(N2),Y2(N2)  ! "ORIGINAL" DATA (POINT PLOT)
C
C
C  LABELS:
      CHARACTER*(*) XUN,YUN,LBL1,LBL2,LBL3
C
C  LOCAL
      REAL XERRB(2),YERRB(2)
      integer n_sc
      real, dimension(:), allocatable :: x_sc,y_sc
C
C  CONTROL:
      INTEGER IMENU
C
C  IF IMENU=1 JUMP DIRECTLY TO REPLOT MENU (DO NOT DRAW GRAPH 1ST)
C
      integer icounter
      integer, save :: iopcod=0
      integer :: icdd
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      DATA IMENU/0/
C
C-------------------------------------------------------------
C
      icounter=0
C---------------------------------------------------------------
C
      n_sc=n+n2
      allocate(x_sc(n_sc),y_sc(n_sc))
      x_sc(1:n)=x
      x_sc(n+1:n+n2)=x2
      y_sc(1:n)=y
      y_sc(n+1:n+n2)=y2
C
C  SCALE SET SWITCH CLEARED:
C
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
C
      CALL GAXGDF(ISEL)
C
      IF(IMENU.EQ.1) GO TO 200
C
C----------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(x_sc,y_sc,y_sc,0,n_sc)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(x_sc,n_sc,y_sc,y_sc,0,n_sc,1,1,1,1,n_sc,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD) ! AXIS (LOG/LIN) CHECK
C
      CALL GSCREC  ! RECORD PLOT SCALE IN MEMORY
C
      CALL DPLOT1(X,Y,N,ICOD) ! DRAW GRID AND F(X) SOLID CURVE
C
      CALL DPLOT10(X2,Y2,N2,icdd)  ! INDIV. DATA POINTS PLOT
C
      CALL GRALBL(XUN,YUN,LBL1,LBL2,LBL3)  ! LABEL THE PLOT
C
      CALL UPAUST(2)  ! PAUSE AFTER PLOT
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SA',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         deallocate(x_sc,y_sc)
         RETURN
      ENDIF
C
      CALL UERMSI(' ?GRAFXF *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      END

subroutine trgraf_slist_dlimit(inum)

  ! return display limit (max no. of profiles or curves in a display)
  ! stored here

  implicit NONE

  integer, intent(out) :: inum

  integer, parameter :: display_limit = 15

  !--------------------

  inum = display_limit

end subroutine trgraf_slist_dlimit

subroutine trgraf_slist_num(inum_orig,inum_slist)

  ! return the original list length or the display limit, whichever is lower

  implicit NONE

  integer, intent(in) :: inum_orig   ! orig. list length
  integer, intent(out) :: inum_slist ! returned list length

  !------------------

  integer :: inum  ! display limit

  integer :: luntrm,lnout

  !------------------

  call trgraf_slist_dlimit(inum)

  inum_slist = min(inum_orig,inum)

  if(inum_slist.lt.inum_orig) then

     luntrm = lnout(0)
     write(luntrm,*) ' '
     write(luntrm,*) ' %trgraf_slist: dataset count exceeds display limit;'
     write(luntrm,*) '  the first ',inum_slist, &
          ' items are displayed out of ',inum_orig,'.'
     write(luntrm,*) '  => use post-plot menu option "+" to change the', &
          ' selected display subset.'
     write(luntrm,*) ' '

  endif

end subroutine trgraf_slist_num

subroutine trgraf_slist_init(inum_orig,isel_orig,lbl_orig,tshif_orig, &
     inum_slist,isel_slist,lbl_slist,tshif_slist)

  ! initialize the sublist (a) to be the whole list if the sizes are the
  ! same, or (b) be the first (inum_slist) values, if inum_slist < inum_orig.

  ! it is expected that inum_slist.le.inum_orig

  implicit NONE

  integer, intent(in) :: inum_orig
  integer, intent(in) :: isel_orig(inum_orig)
  character*(*), intent(in) :: lbl_orig(inum_orig)
  real, intent(in) :: tshif_orig(inum_orig)

  integer, intent(in) :: inum_slist
  integer, intent(out) :: isel_slist(inum_slist)
  character*(*), intent(out) :: lbl_slist(inum_slist)
  real, intent(out) :: tshif_slist(inum_slist)

  !---------------------------------
  integer :: ii
  !---------------------------------

  if(inum_slist.gt.inum_orig) then
     write(6,*) ' ?trgraf_slist: inum_slist > inum_orig unexpected:'
     write(6,*) '  inum_orig = ',inum_orig,'  inum_slist = ',inum_slist
     isel_slist(inum_orig+1:inum_slist) = 0
     lbl_slist(inum_orig+1:inum_slist) = ' '
     tshif_slist(inum_orig+1:inum_slist) = 0.0
  endif

  do ii=1,inum_slist
     isel_slist(ii) = isel_orig(ii)
     lbl_slist(ii) = lbl_orig(ii)
     tshif_slist(ii) = tshif_orig(ii)
  enddo

end subroutine trgraf_slist_init

subroutine trgraf_slist_edit(inum_orig,isel_orig,lbl_orig,tshif_orig, &
     inum_slist,isel_slist,lbl_slist,tshif_slist,inum_cur)

  ! interactive routine to edit the display sublist
  ! ordering is preserved: if item J comes after item I in the ORIG list
  ! and both are in the sublist SLIST, then J comes after I in SLIST also.

  ! it is expected that inum_slist.le.inum_orig -- if not, exit w/warning.

  implicit NONE

  integer, intent(in) :: inum_orig
  integer, intent(in) :: isel_orig(inum_orig)
  character*(*), intent(in) :: lbl_orig(inum_orig)
  real, intent(in) :: tshif_orig(inum_orig)

  integer, intent(in) :: inum_slist
  integer, intent(inout) :: isel_slist(inum_slist)
  character*(*), intent(inout) :: lbl_slist(inum_slist)
  real, intent(inout) :: tshif_slist(inum_slist)
  integer, intent(out) :: inum_cur

  !---------------------------
  integer :: lnout,luntrm
  logical :: lchar,lxout
  logical :: idisplay(inum_orig)
  logical :: iadd

  integer :: ii,jj,imatch,indx

  character*20 test1,test2
  character*10 :: digits = '0123456789'
  !---------------------------

  luntrm = lnout(0)
  if(inum_slist.gt.inum_orig) then
     write(luntrm,*) ' ?trgraf_slist: inum_slist > inum_orig unexpected:'
     write(luntrm,*) '  inum_orig = ',inum_orig,'  inum_slist = ',inum_slist
     write(luntrm,*) '  EDIT operation skipped.'
     inum_cur=inum_orig
     return
  endif

5 continue

  idisplay=.FALSE.

  ! small lists, do not worry abount O(N^2) algorithms...

  do ii=1,inum_orig
     do jj=1,inum_slist
        if(isel_orig(ii).eq.isel_slist(jj)) then
           idisplay(ii)=.TRUE.
           exit
        endif
     enddo
  enddo

  do
     call idisp_count(inum_cur)

     if(lxout(0)) then
        write(luntrm,*) ' '
        do ii=1,inum_orig
           if(idisplay(ii)) then
              write(luntrm,1001) ii,lbl_orig(ii)
           else
              write(luntrm,1002) ii,lbl_orig(ii)
           endif
        enddo
1001    format(4x,i2,'. ',a,' Display=True.')
1002    format(4x,i2,'. ',a,' Display=FALSE.')
        write(luntrm,*) ' '
        write(luntrm,*) ' minimum number of displayed items on exit: 1'
        write(luntrm,*) ' maximum number of displayed items on exit: ', &
             inum_slist
        write(luntrm,*) ' current number of displayed items: ',inum_cur
        write(luntrm,*) ' '
        write(luntrm,*) ' enter name or number to ADD item to list;'
        write(luntrm,*) ' enter -name or -number to REMOVE item from list;'
        write(luntrm,*) ' enter "D" to REMOVE everything from the list;'
        write(luntrm,*) ' enter "I" to re-initialize list;'
        write(luntrm,*) ' enter "Q" to exit.'
        write(luntrm,*) ' '
     endif

     test1=' '
     call ureadw('trgraf_slist_edit option or item name to add/remove:', &
          test1)
     call uupper(test1)

     ! collective operations:

     if(test1.eq.'D') then
        idisplay = .FALSE.
        cycle

     else if(test1.eq.'I') then
        call trgraf_slist_init(inum_orig,isel_orig,lbl_orig,tshif_orig, &
             inum_slist,isel_slist,lbl_slist,tshif_slist)
        go to 5

     else if(test1.eq.'Q') then
        if(inum_cur.eq.0) then
           call uermsg('%trgraf_slist: at least one item must be selected.', &
                ' ',0)
           cycle
        else if(inum_cur.gt.inum_slist) then
           call uermsg('%trgraf_slist: too many display items: remove some.', &
                ' ',0)
           cycle
        else
           exit
        endif
     endif

     ! operation on individual item (apparently)

     iadd=.TRUE.
     if(test1(1:1).eq.'-') then
        iadd=.FALSE.
        test1 = trim(test1(2:))
     endif

     imatch = 0

     ! try name recognition

     do ii=1,inum_orig
        test2=lbl_orig(ii)
        if(index(' +-',test2(1:1)).gt.0) test2=lbl_orig(ii)(2:)
        call uupper(test2)
        if(test1.eq.test2) then
           imatch=ii
           exit
        endif
     enddo

     if(imatch.eq.0) then

        ! try integer decode

        do jj=1,len(trim(test1))
           indx=index(digits,test1(jj:jj))
           if(indx.lt.1) then
              imatch=0
              exit  ! not an integer
           else
              ! OK digit
              imatch = 10*imatch + (indx-1)
           endif
        enddo

        if(imatch.gt.inum_orig) then
           call uermsi('%trgraf_slist: integer out of range:',imatch,0)
           cycle
        else if(imatch.le.0) then
           call uermsg('%trgraf_slist: item identifier unrecognized:', &
                test1,0)
           cycle
        endif
     endif

     if(iadd) then
        idisplay(imatch)=.TRUE.
     else
        idisplay(imatch)=.FALSE.
     endif

  enddo

  ! OK, assemble sublist

  jj = 0
  do ii=1,inum_orig
     if(idisplay(ii)) then
        jj=jj + 1
        lbl_slist(jj) = lbl_orig(ii)
        isel_slist(jj) = isel_orig(ii)
        tshif_slist(jj) = tshif_orig(ii)
     endif
  enddo

  inum_cur = jj

CONTAINS
  subroutine idisp_count(icount)

    integer, intent(out) :: icount

    ! count number of TRUE display flags

    icount = 0
    do ii=1,inum_orig
       if(idisplay(ii)) icount = icount + 1
    enddo

  end subroutine idisp_count

end subroutine trgraf_slist_edit

C******************** START FILE UFLCHK.FOR ; GROUP UFILS0 ******************
C==================================================================
C  UFILS0.FOR
C  UTILITY SUBROUTINES FOR UFILES FILE SYSTEM
C
C-------------
C  UFLCHK
C
C  CHECK STATUS OF PASSED LOGICAL UNIT NUMBER
C   IF IT IS KNOWN RETURN THE INTERNAL CHANNEL NUMBER ASSOCIATED
C  WITH IT.  IF IT IS NOT KNOWN PRINT AN ERROR MESSAGE, SET FLAG
C  AND EXIT
C
      SUBROUTINE UFLCHK(ILUN,ZNAME,ICHAN,IER)
C
      USE UFILES
      CHARACTER*10 ZNAME
C
C  ILUN-- LOGICAL UNIT NUMBER TO CHECK
C   A CALL TO UFSETR SHOULD HAVE BEEN MADE FIRST
C  ZNAME-- NAME OF SUBROUTINE CALLING UFLCHK
C  ICHAN-- OUTPUT INTERNAL CHANNEL NUMBER WITH WHICH ILUN IS
C   ASSOCIATED
C  IER-- RETURN CODE, 0 DENOTES SUCCESS
C
      IER=0
      ICHAN=IUXCHA(ILUN)
      IF(ICHAN.NE.0) RETURN
      IER=1
      WRITE(UFELUN,9001) ZNAME,ILUN
 9001 FORMAT(
     >  ' ? ',A10,' -- ATTEMPT TO USE UNASSIGNED LOGICAL UNIT NUMBER:',
     >  2X,I3/'   CALL UFSETR(LUN,...) FIRST'/)
      IER=1
      RETURN
      	END
C******************** END FILE UFLCHK.FOR ; GROUP UFILS0 ******************

C-------------------------------------------------------------------
      subroutine vprotec(tokstr,istat)
C
C  vprotec -- verify access permission
C
C    dmc Mar 1995 -- except at PPPL this routine should not do anything!
C      here at PPPL it is requested to use this to prevent general
C      TRANSP user access to JT60 data.
C
C    rewritten DMC Nov 1996 -- access list now in a file.
C      assume wide open if cannot find file.
C
      implicit NONE
C
C-------------------------------------
C
      character*(*) tokstr  ! tok or tok.yy string, input
      integer istat         ! status code, output. istat=0:  OK
C
C-------------------------------------
C
      integer numacl,icln,il,itok,ilnb
C
      character*80 zbuff,zline
C
      character*4 tokacl(100)
      logical     grantd(100)
C
      integer str_length,ilen
C
      data numacl/-1/
C
      save tokacl
      save grantd
C
C-------------------------------------
C
      istat=0
C
      return
      end

C******************** START FILE GET1FF.FOR ; GROUP UTL2D ******************
C------------------------------------------------------------------
C  GET1FF - ACCEPT REAL FIXED PARAMETER; DETERMINE NEAREST INTEGER
C  AND CALL GET1F2
C
      SUBROUTINE GET1FF(IDIM,IFIX,ZFIXD,X,NX,Y,NY,F,NF1,ZWK,NWK)
C
      REAL X(NX),Y(NY),F(NF1,NY),ZWK(NWK)
C
      CALL WKCHK(NWK,NX,'GET1FF (X)',IER1)
      CALL WKCHK(NWK,NY,'GET1FF (Y)',IER2)
C
      IF((IER1.NE.0).OR.(IER2.NE.0)) RETURN
C
C  FIND NEAREST INDEX IN FIXED DATA DIMENSION
C
      IF(IDIM.EQ.1) THEN
        IFIX=1
        ZDIF=ABS(ZFIXD-Y(1))
        DO IY=1,NY
          ZTES=ABS(ZFIXD-Y(IY))
          IF(ZTES.LT.ZDIF) THEN
            IFIX=IY
            ZDIF=ZTES
          ENDIF
        ENDDO
      ELSE IF(IDIM.EQ.2) THEN
        IFIX=1
        ZDIF=ABS(ZFIXD-X(1))
        DO IX=1,NX
          ZTES=ABS(ZFIXD-X(IX))
          IF(ZTES.LT.ZDIF) THEN
            IFIX=IX
            ZDIF=ZTES
          ENDIF
        ENDDO
      ENDIF
C
C  EXTRACT THE WORK VECTOR
C
      CALL GET1F2(IDIM,IFIX,F,NX,NY,NF1,ZWK,NWK)
C
      RETURN
      END
C******************** END FILE GET1FF.FOR ; GROUP UTL2D ******************

C******************** START FILE CDCOD.FOR ; GROUP URDUTS ******************
C------------------
C&  CDCOD   UREAD RETURN CHAR STRING OUT OF TYPEAHEAD TO CALLER
C           UPPERCASE forced
C
      subroutine cdcod(zstrng)
      character*(*), intent(out) :: zstrng

      CALL CDCODI(zstrng,1)

      return
      end
C------------------
C&  CDCODL   UREAD RETURN CHAR STRING OUT OF TYPEAHEAD TO CALLER
C           do NOT enforce UPPERCASE
C
      subroutine cdcodL(zstrng)
      character*(*), intent(out) :: zstrng

      CALL CDCODI(zstrng,0)

      return
      end
C------------------
C  RETURN A CHARACTER STRING TO CALLER FROM INPUT LINE BUFFER
C  iup controls whether uppercase is forced on non-quoted characters
C
      SUBROUTINE CDCODI(ZSTRNG,iup)
C
      USE USERIO
C
      CHARACTER*(*), intent(out) :: ZSTRNG
C
      ILEN=LEN(ZSTRNG)
C
C  CLEAR ZSTRNG
C
      DO 10 IC=1,ILEN
        ZSTRNG(IC:IC)=' '
 10   CONTINUE
C
C  FIND FIRST FIELD IN BUFFER
C
      CALL URWORD(CBUFF,iup,IC,ID)
C
      IF(IC.GT.0) CALL URWRDL(CBUFF(1:IC),ZSTRNG,ILNB)
C
      CALL UROTOR(ID)
C
      RETURN
      END
C******************** END FILE CDCOD.FOR ; GROUP URDUTS ******************

subroutine r8splcrd (ZXI99, IJACI, &
     LCENTR, MIMOM, NMOM, MTBL, XIBLO, &
     RMB0,RMB0S,RMB2,RMB2S,YMB2,YMB2S, &
     ZRMB0X, ZRMB2X, ZYMB2X, &
     ZRMB0P, ZRMB2P, ZYMB2P)
  !
  !  dmc 24 Dec 1996:  this version does not depend on TRCOM
  !  ** updown symmetric SPLCRD **
  !
  !  call from MOMRY/MOMRZ; caller does arg error checking!
  !
  !  input args:
  !
  !   ZXI99 -- "xi" (radial coordinate) **** must be in range ****
  !     ==> interpolate moments set to "xi"
  !   IJACI -- IJAC flag as input (see below)
  !
  !   LCENTR -- 1 + index offset in XIBLO, RMB0, RMB2, YMB2, rel. to.
  !      RMB0S,RMB2S,YMB2S
  !      (for TRANSP compatibility; set to 1 if all arrays are on
  !      the same indexing grid)
  !
  !   MIMOM -- max no. of moments (array dimension)
  !   NMOM  -- actual no. of moments in use
  !   MTBL --- max no. of radial points including "bloat" (array dimension)
  !
  !   XIBLO(..) -- "xi" grid points, including bloat region beyond plasma bdy
  !
  !   RMB0(..) -- 0'th R moment array
  !   RMB0S(..) -- 0'th R moment spline coeffs
  !   RMB2(..) -- higher R moments array
  !   RMB2S(..) -- higher R moment spline coeffs
  !   YMB2(..) -- higher Y moments array
  !   YMB2S(..) -- higher Y moment spline coeffs
  !
  !  output args:
  !   ZRMB0X -- interpolated 0'th R moment
  !   ZRMB2X(..) -- interpolated higher R moments
  !   ZYMB2X(..) -- interpolated higher Y moments
  !  (if IJAC set):
  !   ZRMB0P -- 0'th R moment dR0/dxi
  !   ZRMB2P(..) -- higher R moments derivatives w.r.t. xi
  !   ZYMB2P(..) -- higher Y moments derivatives w.r.t. xi
  !
  !	EVALUATE SPLINE COEFFICIENTS DIRECTLY ... GIVEN A RADIAL
  !	COORD "ZXI99", RETURN THE MHD FOURIER COEFFICIENTS (AND THEIR
  !	DERIVATIVES) DESCRIBING THE PLASMA SURFACE ON THAT COORD.
  !
  !  MOD DMC APRIL 1990 -- LINEAR INTERPOLATION OPTION
  !
  !  if IJAC=0 OR IJAC=1 USE THE SPLINES
  !  if IJAC=2 OR IJAC=3 do LINEAR INTERPOLATION INSTEAD
  !
  !  if IJAC=1 OR IJAC=3 EVALUATE DATA FOR THE JACOBIAN
  !
  !   input arrays:
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: ijaci,lcentr,mimom,nmom,mtbl,ijac,is,isl1,j,isp1
  real(fp) :: zrmb0x,zrmb0p,zxi99,zdxii
  real(fp) :: zdx99,zdx99i
  real(fp) :: RMB0(MTBL),RMB0S(MTBL,3),XIBLO(MTBL)
  real(fp) :: RMB2(MTBL,MIMOM),RMB2S(MTBL,MIMOM,3)
  real(fp) :: YMB2(MTBL,MIMOM),YMB2S(MTBL,MIMOM,3)
  !   output arrays:
  real(fp), dimension(mimom) :: zrmb2x,zymb2x
  real(fp), dimension(mimom) :: zrmb2p,zymb2p
  !
  !-------------------------------------
  !
  IJAC=abs(IJACI)
  !
  ZDXII= 1.0_fp/ (XIBLO(LCENTR+1)-XIBLO(LCENTR))
  IS = ZXI99 * ZDXII + 1
  !
20 continue
  ISL1=IS+LCENTR-1
  if(zxi99.le.xiblo(isl1)) then
    is=is-1
    go to 20
  end if
  if(zxi99.gt.xiblo(isl1+1)) then
    is=is+1
    go to 20
  end if
  !
  ZDX99 = ZXI99 - XIBLO(ISL1)
  !
  !  EVALUATE MOMENTS INTERPOLATION
  !
  if(IJAC.LE.1) THEN
    
    !	EVALUATE SPLINE
    !
    !	  R0(X)
    !
    ZRMB0X = RMB0(ISL1) + ZDX99*(RMB0S(IS,1) + &
         ZDX99*(RMB0S(IS,2) + &
         ZDX99*RMB0S(IS,3)))

    do J = 1, NMOM
      !	      RM(X)
      ZRMB2X(J) = RMB2(ISL1,J) + ZDX99*(RMB2S(IS,J,1) + &
           ZDX99*(RMB2S(IS,J,2) + ZDX99*RMB2S(IS,J,3)))
      !	      YM(X)
      ZYMB2X(J) = YMB2(ISL1,J) + ZDX99*(YMB2S(IS,J,1) + &
           ZDX99*(YMB2S(IS,J,2) + ZDX99*YMB2S(IS,J,3)))
    end do

  else
    !
    !  EVALUATE BY LINEAR INTERPOLATION
    !
    ISP1=ISL1+1
    ZDX99I=ZDX99*ZDXII
    !
    ZRMB0X=RMB0(ISL1)+ZDX99I*(RMB0(ISP1)-RMB0(ISL1))
    !
    do J = 1, NMOM
      ZRMB2X(J)= RMB2(ISL1,J)+ZDX99I*(RMB2(ISP1,J)-RMB2(ISL1,J))
      ZYMB2X(J)= YMB2(ISL1,J)+ZDX99I*(YMB2(ISP1,J)-YMB2(ISL1,J))
    end do

  end if

  !.................................. 
  if (IJAC.EQ.0) RETURN
  if (IJAC.EQ.2) RETURN
  !..................................

  !
  !  EVALUATE DERIVATIVES
  !
 
  if(IJAC.LE.1) THEN
    !
    !  SPLINES
    !
    !	  D[R0(X)]/DX
    ZRMB0P = RMB0S(IS,1) + ZDX99*(2._fp*RMB0S(IS,2) + &
         3._fp*ZDX99*RMB0S(IS,3))

    do J = 1, NMOM
      !	  D[RM(X)]/DX
      ZRMB2P(J) = RMB2S(IS,J,1) + ZDX99*(2._fp*RMB2S(IS,J,2) + &
           3._fp*ZDX99*RMB2S(IS,J,3))
      !	  D[YM(X)]/DX
      ZYMB2P(J) = YMB2S(IS,J,1) + ZDX99*(2._fp*YMB2S(IS,J,2) + &
           3._fp*ZDX99*YMB2S(IS,J,3))
    end do

  else
    !
    !  LINEAR INTERPOLATION
    !
    ZRMB0P=(RMB0(ISP1)-RMB0(ISL1))*ZDXII
    !
    do J = 1, NMOM
      ZRMB2P(J) = (RMB2(ISP1,J)-RMB2(ISL1,J))*ZDXII
      ZYMB2P(J) = (YMB2(ISP1,J)-YMB2(ISL1,J))*ZDXII
    end do

  end if

  return
end subroutine r8splcrd

      SUBROUTINE TRDATE(RUNDAT,ORDATE,FILNAM,MODE)
C
C  mod dmc 3 feb 1992 -- standardize the fortran i/o
C
C  --------------------------------------------------------------------------
C
C  MODE=1 :
C ---  Translate date for ordering
C     dd-mmm-yyyy  -->  yyyy-mm-dd   where mm is numerical order of month
C
C  MODE=2 :
C ---  Reverse
C     yyyy-mm-dd  -->  dd-mmm-yyyy
C
C
C  --------------------------------------------------------------------------
C
      CHARACTER  MONUC(12)*3, MONLC(12)*3, NMON*2, RUNDAT*11,
     >           ORDATE*12, FILNAM*(*)
      DATA  MONUC /'JAN','FEB','MAR','APR','MAY','JUN',
     >		     'JUL','AUG','SEP','OCT','NOV','DEC'/
      DATA  MONLC /'jan','feb','mar','apr','may','jun',
     >		     'jul','aug','sep','oct','nov','dec'/
C
      IF(MODE.EQ.1)   THEN
        DO I=1,12
          IF(   RUNDAT(4:6) .EQ. MONUC(I) .OR.
     >            RUNDAT(4:6) .EQ. MONLC(I))  THEN
            WRITE(NMON,'(I2)',ERR=700)  I
            IF(I.LE.9)  NMON='0'//NMON(2:2)
            GO TO 100
          ENDIF
        ENDDO
        WRITE(6,9001) FILNAM,RUNDAT
 9001   FORMAT(' TRDATE:  File ',A,' date translation error ',A)
        call BAD_EXIT
C
  100   IF(RUNDAT(1:1).EQ.' ')  RUNDAT(1:2)='0'//RUNDAT(2:2)
        ORDATE=RUNDAT(8:11)//'-'//NMON//'-'//RUNDAT(1:2)
        RETURN
      ELSE IF(MODE.EQ.2) THEN
C***	  DECODE(2,'(I2)',ORDATE(6:7))  I
        Read(ORDATE(6:7),'(I2)')  I     !*** jpj@JET Apr-1995
        RUNDAT=ORDATE(9:10)//'-'//MONUC(I)//'-'//ORDATE(1:4)
        RETURN
      ENDIF
C
      WRITE(6,9002) MODE
 9002 FORMAT(' TRDATE:  bad MODE value',I5)
      call BAD_EXIT
C
C
  700 WRITE(6,'('' TRDATE:  internal write error'')')
      call BAD_EXIT
      END

c
c========================================================================
c
      subroutine cmprs2(bitems, nitems, pack, maxp, bit, ierr)
c
#include "fpreproc/byte_declare.h"
c
c dmc 27 mar 1996
c  this is a variant on cmprsi, for a portable compressed binary
c  ufile application.  The input stream is in bytes rather than I*2,
c  to avoid byte ordering dependencies.  The input stream is always
c  2 bytes (16 bits) wide -- not controllable as was the case for
c  cmprsi.  Also, "bit" is taken to be zero on entry.
c
c  the output stream is also a byte sequence -- 4 bytes wide.
c  standardize the byte ordering of the encoding here, for portability.
c
c marilee's original comments:
c
c+an algorithm to compress waveforms by expressing them
c as differences and storing only the number of bits needed
c to express the values over a power of two range.
c look ahead is limited to two levels but
c rescan is restarted with each output
c
c bitems  byte stream input, 2 x nitems bytes.
c nitems  number of value-pairs to be packed
c pack	  output packed array
c maxp	  dimension of pack
c bit	  starting left-to-right bit number in pack
c	  returns last occupied (starts at 0)
c	  assumed 0 on entry, pack is zeroed; note values are ored into pack
c ierr	  returned error code (0 = ok)
c	  15 if  unpacked value too large to store
c	  14 if  dimension of pack too small
c
c*25-mar-83 ---cmprsi.for, xpandi.for---
c*16-nov-83  m. thompson (ppl) - return error if nbits > 16 rather than stop
c	check dimension of pack
c*24-jan-84  m. thompson (ppl) - store count word in 16 bits vs 12
c	check for data values too large to store
c*18-jan-93  m. thompson (ppl) - rearrange logic in cmprsi
c*26-feb-92  m. thompson (ppl) - replace macro packi/unpki with in-line
c	code using shifts and masks; increment bit size by 2 (vs 1)
c
c*27-mar-96  dmc -- cmprs2/xpand2 variants
c
c-----------------------------------------------------------------------
c
      implicit integer(a-z)
c
      parameter (shift=16)	!was 12 (2/93, met)
      parameter (two=2*shift,ko256=shift+256)
c
      byte_declare bitems(2,nitems)
c
      integer pack(maxp)
c
      integer*4 iold,it
c
      integer power(17)
c
      integer sig(65)
c
      integer*2 is(ko256)		! stored differences
c
      integer*4 masks(0:16)
c
      data power/
     >    0,1,2,4,8,16,32,64,128,256,512,
     >    1024,2048,4096,8192,16384,32768/
      data sig/
     >    0,2,2,2*4,4*4,8*6,16*6,32*7/
#if __F90 || __NAGWARE
      data masks/ Z"00000000",
     >	  Z"00000001",Z"00000003",Z"00000007",Z"0000000f",
     >	  Z"0000001f",Z"0000003f",Z"0000007f",Z"000000ff",
     >	  Z"000001ff",Z"000003ff",Z"000007ff",Z"00000fff",
     >	  Z"00001fff",Z"00003fff",Z"00007fff",Z"0000ffff"/
#else
      data masks/ '00000000'x,
     >	  '00000001'x,'00000003'x,'00000007'x,'0000000f'x,
     >	  '0000001f'x,'0000003f'x,'0000007f'x,'000000ff'x,
     >	  '000001ff'x,'000003ff'x,'000007ff'x,'00000fff'x,
     >	  '00001fff'x,'00003fff'x,'00007fff'x,'0000ffff'x/
#endif
c-----------------------------------------------------------------------
c
#if __CRAY || __SX
      print*,'CMPRS2 not implemented on CRAY and SX'
#else
      nb=16  ! always 16 in this variant
      bit=0  ! assumed 0 initially
c
      if(bit.eq.0) then
        do ii=1,maxp
          pack(ii)=0
        enddo
      endif
c
c first difference to remove most of value
      offset=power(nb+1)
      mask=2*offset-1
      imask=mask
      x0=0
      iold=0
      kptr=bit/32+1
      kpos=mod(bit,32)
      kpos=32-kpos
c loop 1 to nitems+1, limited to 256 items
      do while (x0.lt.nitems)
        nn = min(nitems-x0,ko256)
        y1=-1		!number of bits
        y2=-1
        y12=0
        x2=0		!count at this bit size
        do x3=0,nn
          if(x3.eq.nn) then
c hit the count wall
            y3=64
            go to 7
          endif
c significance
c  dmc -- form integer from byte pair
C#if __CRAY
C          bytehi=ichar(bitems(1,x3+x0+1))
C          bytelo=ichar(bitems(2,x3+x0+1))
C#else
          bytehi=bitems(1,x3+x0+1)
          bytelo=bitems(2,x3+x0+1)
C#endif
          if(bytehi.lt.0) bytehi=bytehi+256
          if(bytelo.lt.0) bytelo=bytelo+256
          it=256*bytehi+bytelo
c
          if(abs(it).gt.imask) then
            ierr=15
            go to 90
          endif
          i=iand(it-iold+offset,mask)-offset
          iold=it
          is(x3+1)=i
          if(i.le.0) i=not(i)
          if(i.lt.64) then
c speed up for small differences
            y3=sig(i+2)
          else
            y3=8
            do while (y3.le.nb .and. i.ge.power(y3+1))
      	y3=y3+2	!was +1 (2/93, met)
            enddo
          endif
 7        y32=y3-y2
          if(y32.eq.0) go to 20	!cycle
          if(y12.eq.0) go to 18
          if(y12.lt.0) then
            if(y32.gt.0) then
c rise
      	x32=min(x3-x2,shift)
      	x20=min(x2,shift)
c low mid high --> mid high, low high
      	if(x20*y12+x32*y32.lt.0) then
      	  y2=y3
      	  y12=y1-y2
      	endif
            endif
c output if good enough
            if(y12*x2+shift.lt.0) go to 21
            y1=y2
            go to 18
          endif
c
          if(y32.lt.0) then
c drop
            if(y12*(x3-x2)+y12.gt.two) go to 21
c high mid low --> high low or high mid
            if(y12*(x3-x2)+y32.ge.0) go to 20
          else	!y32.gt.0
c dip
            if(y32.gt.y12) y32=y12
            y32=(x3-x2)*y32
            if(y32.gt.two) go to 21
            if(y32.gt.shift .and. x3.gt.256) go to 21
c high low mid --> high mid
c mid low high --> mid high
            if(y3-y1.lt.0) go to 19
          endif
 18       x2=x3
 19       y2=y3
          y12=y1-y2
 20     enddo
c
        if(y1.lt.0) then
          y1=y2
          x2=nn
        endif
 21     x2=min(x2,256)
        if((y1*x2+bit)/32.gt.maxp) then
          ierr=14
          go to 90
        endif
        if(y1.gt.16) then
          ierr=13
          go to 90
        endif
        ival=x2-1		!low order byte = count (max 255)
        ival=ior(ival,ishft(y1,8))	!high order byte = size
        ipak=pack(kptr)
        kpos=kpos-16
        itmp=0
        if(kpos.lt.0) itmp=ishft(ival,kpos+32)	!shift left
        if(kpos.ne.0) ival=ishft(ival,kpos)	!+=left, -=right
        if(kpos.gt.0) then
          ipak=ior(ipak,ival)
        else
          pack(kptr)=ior(ipak,ival)
          kptr=kptr+1
          ipak=itmp
          kpos=kpos+32
        endif
        pack(kptr)=ipak
        bit=bit+16
        if(y1.eq.0) go to 80
        kbits=y1
        do k=1,x2	!n=x2
          ival=is(k)
          ival=iand(ival,masks(kbits))	!drop sign extension
          kpos=kpos-kbits
          itmp=0
          if(kpos.lt.0) itmp=ishft(ival,kpos+32)	!shift left
          if(kpos.ne.0) ival=ishft(ival,kpos)	!+=left, -=right
          if(kpos.gt.0) then
            ipak=ior(ipak,ival)
          else
            pack(kptr)=ior(ipak,ival)
            kptr=kptr+1
            ipak=itmp
            kpos=kpos+32
          endif
          pack(kptr)=ipak
        enddo
        bit=bit+kbits*x2
 80     continue
        x0=x0+x2
c
c  extract byte pair (dmc)
C#if __CRAY
C        bytehi=ichar(bitems(1,x0))
C        bytelo=ichar(bitems(2,x0))
C#else
        bytehi=bitems(1,x0)
        bytelo=bitems(2,x0)
C#endif
       if(bytehi.lt.0) bytehi=bytehi+256
        if(bytelo.lt.0) bytelo=bytelo+256
        iold=256*bytehi+bytelo
c
      enddo
      ierr=0
c
      iwords=bit/32+1
      call packordr(pack,iwords,1)	! standardize byte order
c
#endif
 90   return
      end
c
      subroutine xpand2(pack,npack,bunpack,first,last,ierr)
c
c+expand compressed data, inverse of cmprs2
c
c   dmc 27 mar 1996 -- variant on cmprsi/xpandi, for portable binary
c     application.  see comments, cmprs2 suboutine
c
c pack	  is packed array
c bunpack  is unpacked array (byte stream, in byte pairs)
c first	  is index(1,n) of item to place in unpack(1)
c last	  is index of last item placed in unpack
c ierr	  is returned error code (0=ok)
c	  13 if  invalid data (internal nbits > 16)
c
c=======================================================================
c
      implicit integer(a-z)
c
      byte_declare bunpack(2,last)
c
      integer pack(npack)
c
      integer power(18)
c
      integer*4 masks(0:16)
c
      data power/
     >	  0,1,2,4,8,16,32,64,128,256,512,
     >    1024,2048,4096,8192,16384,32768,65536/
#if __F90 || __NAGWARE
      data masks/ Z"00000000",
     >	  Z"00000001",Z"00000003",Z"00000007",Z"0000000f",
     >	  Z"0000001f",Z"0000003f",Z"0000007f",Z"000000ff",
     >	  Z"000001ff",Z"000003ff",Z"000007ff",Z"00000fff",
     >	  Z"00001fff",Z"00003fff",Z"00007fff",Z"0000ffff"/
#else
      data masks/ '00000000'x,
     >	  '00000001'x,'00000003'x,'00000007'x,'0000000f'x,
     >	  '0000001f'x,'0000003f'x,'0000007f'x,'000000ff'x,
     >	  '000001ff'x,'000003ff'x,'000007ff'x,'00000fff'x,
     >	  '00001fff'x,'00003fff'x,'00007fff'x,'0000ffff'x/
#endif
c
c-----------------------------------------------------------------------
c
#if __CRAY || __SX
	print *,'XPAND2 not implemented on CRAY or SX'
	return
#else
      lowmask=masks(8)
c
c  create local byte ordering for pack array
c
      call packordr(pack,npack,0)
c
      bit=0
      nb=16
c
      index=0
      ii=0
      value=0
      lower=0
      modulo=power(nb+2)
      upper=lower+modulo-1
      ierr=0
      do while(index.lt.last)
C				!get next 16 bits
        kptr=bit/32+1		!ptr into pack
        kpos=mod(bit,32)	!offset in word
        kpos=kpos+16
        if(kpos.lt.32) then
          ival=ishft(pack(kptr),-(32-kpos))	!shift right
          ival=iand(ival,masks(16))
        else
          kpos=kpos-32
          ival=iand(pack(kptr),masks(16-kpos))
          kptr=kptr+1
          if(kpos.gt.0) then
            ntx=ishft(pack(kptr),-(32-kpos))	!shift right
            ntx=iand(ntx,masks(kpos))
            ival=ior(ishft(ival,kpos),ntx)	!shift left
          endif
        endif
        bit=bit+16
        bits=ishft(ival,-8)		!high order byte = size
        bits=-bits
        n=iand(ival,lowmask)+1		!low order byte = count
        n=min(n,last-index)
        if(bits.gt.16) then
          ierr=13
          return
        endif
        if(bits.eq.0) then
          do k=1,n
          index=index+1
          if(index.ge.first) then
            ii=ii+1
            unpack=value
            bytehi=unpack/256
            bytelo=unpack-256*bytehi
C#if __CRAY
C            bunpack(1,ii)=char(bytehi)
C            bunpack(2,ii)=char(bytelo)
C#else
            bunpack(1,ii)=bytehi
            bunpack(2,ii)=bytelo
C#endif
          endif
          enddo
          go to 80
        endif
        kbits=abs(bits)
        do k=1,n
          kpos=kpos+kbits
          if(kpos.lt.32) then
            ival=ishft(pack(kptr),-(32-kpos))	!shift right
            ival=iand(ival,masks(kbits))
          else
            kpos=kpos-32
            ival=iand(pack(kptr),masks(kbits-kpos))
            kptr=kptr+1
            if(kpos.gt.0) then
      	ntx=ishft(pack(kptr),-(32-kpos))	!shift right
      	ntx=iand(ntx,masks(kpos))
      	ival=ior(ishft(ival,kpos),ntx)	!shift left
            endif
          endif
cx	    if(bits.lt.0) then	!bits is always negative
            imask=not(masks(kbits-1))		!extend sign bit
            if(iand(imask,ival).ne.0) ival=ior(ival,imask)
cx	    endif
          value=value+ival
          if(value.lt.lower) value=value+modulo
          if(value.gt.upper) value=value-modulo
          index=index+1
          if(index.ge.first) then
            ii=ii+1
            unpack=iand(value,masks(16))
            bytehi=unpack/256
            bytelo=unpack-256*bytehi
C#if __CRAY
C            bunpack(1,ii)=char(bytehi)
C            bunpack(2,ii)=char(bytelo)
C#else
            bunpack(1,ii)=bytehi
            bunpack(2,ii)=bytelo
C#endif
          endif
        enddo
        bit=bit+kbits*n
 80   continue
      enddo
c
 90   return
#endif
      end
c
C----------------------------------
C  new dmc 27 Mar 1996
C
C  standardize byte ordering of 4-wide byte stream
C
      subroutine packordr(pack,npack,idir)
C
      implicit NONE
C
      integer npack
      integer*4 pack(npack)  ! the data
      integer idir           ! =1 => standard, =0 => local ordering
C
      character*50 zdbg
C
      integer*4 jwork,ibyte,jbyte
      byte_declare bwork(4)
C
      integer ipack,ii,ishf
C
      integer*4, save :: masks(4)
      logical :: initflag = .FALSE.
      integer :: ibit,ibiti,indx
C
C  store in order:  hi byte ... lo byte
C
C  DMC -- get rid of non-portable code; use IBSET
C #if __F90 || __NAGWARE
C       data masks/Z"ff000000",Z"00ff0000",Z"0000ff00",Z"000000ff"/
C #else
C       data masks/'ff000000'x,'00ff0000'x,'0000ff00'x,'000000ff'x/
C #endif
C
      if(.not.initflag) then

         initflag = .TRUE.

         do ibit =0,31
            indx = 1 + ibit/8
            ibiti = 31-ibit

            masks(indx) = ibset(masks(indx),ibiti)
CCCC            write(6,*) ibit,ibiti,indx,masks
         enddo

      endif
C
C  loop through the data pack
C
      do ipack=1,npack
         if(idir.eq.1) then
C  standardize order  hi -> lo
            do ii=1,4
               ibyte=iand(pack(ipack),masks(ii))
               ishf=8*(ii-4)
               if(ishf.ne.0) then
                  jbyte=ishft(ibyte,ishf)
               else
                  jbyte=ibyte
               endif
#if __CRAY || __SX
               bwork(ii)=char(jbyte)
#else
               bwork(ii)=jbyte
#endif
            enddo
            call copyint4(bwork,pack(ipack))
         else
C  create locally desired ordering
            jwork=0
            do ii=1,4
               call byte4out(pack(ipack),ii,bwork(ii))
#if __CRAY || __SX
               ibyte=ichar(bwork(ii))
#else
               ibyte=bwork(ii)
#endif
               if(ibyte.lt.0) ibyte=ibyte+256
               ishf=8*(4-ii)
               if(ishf.ne.0) then
                  jbyte=ishft(ibyte,ishf)
               else
                  jbyte=ibyte
               endif
               jwork=ior(jwork,jbyte)
            enddo
            pack(ipack)=jwork
         endif
      enddo
C
      return
      end
 
 
 
 
 
 
 
 
 
 
 
 
 

!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  DLIMX
      SUBROUTINE R8_DLIMX(
     > R8_XMIN,R8_XMAX)

      external DLIMX

! argument declarations
 ! floating type, input:
      REAL*8 R8_XMIN
  
 ! floating type, input:
      REAL*8 R8_XMAX
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: XMIN_act
      REAL :: XMAX_act

! allocation of working arrays...


! executable code:  copy for input

      XMIN_act=R8_XMIN

      XMAX_act=R8_XMAX

! call to original routine:  DLIMX

      CALL DLIMX(
     > XMIN_act,XMAX_act)

! exit
      return
      end

      SUBROUTINE R8_DLIMY(
     > R8_XMIN,R8_XMAX)

      external DLIMY

! argument declarations
 ! floating type, input:
      REAL*8 R8_XMIN
  
 ! floating type, input:
      REAL*8 R8_XMAX
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: XMIN_act
      REAL :: XMAX_act

! allocation of working arrays...

! executable code:  copy for input

      XMIN_act=R8_XMIN

      XMAX_act=R8_XMAX

! call to original routine:  DLIMY

      CALL DLIMY(
     > XMIN_act,XMAX_act)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGVCUR
      SUBROUTINE R8_AGVCUR(
     > UCH,R8_X,R8_Y)

      external AGVCUR

! argument declarations
      CHARACTER*1 UCH
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  AGVCUR

      CALL AGVCUR(
     > UCH,X_act,Y_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGEYA
      SUBROUTINE R8_AGEYA(
     > R8_X,R8_Y,R8_E)

      external AGEYA

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  
 ! floating type, input/output:
      REAL*8 R8_E(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: E_act(:)
      REAL, allocatable :: E_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEYA -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEYA -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEYA -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEYA -- Y_ref ALLOCATE error!')

      dim=size(R8_E)
      ALLOCATE(E_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEYA -- E_act ALLOCATE error!')
      ALLOCATE(E_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEYA -- E_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      E_act=R8_E
      E_ref=R8_E

! call to original routine:  AGEYA

      CALL AGEYA(
     > X_act(1),Y_act(1),E_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(E_act.ne.E_ref)
         R8_E = E_act
      end where
      DEALLOCATE(E_act)
      DEALLOCATE(E_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGEXA
      SUBROUTINE R8_AGEXA(
     > R8_X,R8_Y,R8_E)

      external AGEXA

! argument declarations
 ! floating type, input/output:
      REAL*8 :: R8_X(:)
  
 ! floating type, input/output:
      REAL*8 :: R8_Y(:)
  
 ! floating type, input/output:
      REAL*8 :: R8_E(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: E_act(:)
      REAL, allocatable :: E_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEXA -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEXA E-- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEXA -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEXA -- Y_ref ALLOCATE error!')

      dim=size(R8_E)
      ALLOCATE(E_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEXA -- E_act ALLOCATE error!')
      ALLOCATE(E_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGEXA -- E_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      E_act=R8_E
      E_ref=R8_E

! call to original routine:  AGEXA

      CALL AGEXA(
     > X_act(1),Y_act(1),E_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(E_act.ne.E_ref)
         R8_E = E_act
      end where
      DEALLOCATE(E_act)
      DEALLOCATE(E_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGEYS
      SUBROUTINE R8_AGEYS(
     > R8_X,R8_Y,R8_E)

      external AGEYS

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
 ! floating type, input/output:
      REAL*8 R8_E
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref
      REAL :: E_act
      REAL :: E_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      E_act=R8_E
      E_ref=R8_E

! call to original routine:  AGEYS

      CALL AGEYS(
     > X_act,Y_act,E_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

      if(E_act.ne.E_ref) then
         R8_E = E_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGEXS
      SUBROUTINE R8_AGEXS(
     > R8_X,R8_Y,R8_E)

      external AGEXS

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
 ! floating type, input/output:
      REAL*8 R8_E
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref
      REAL :: E_act
      REAL :: E_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      E_act=R8_E
      E_ref=R8_E

! call to original routine:  AGEXS

      CALL AGEXS(
     > X_act,Y_act,E_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

      if(E_act.ne.E_ref) then
         R8_E = E_act
      endif

! exit
      return
      end
      SUBROUTINE R8_AGEXSR(
     > R8_X,R8_Y,R8_ELO, R8_EHI)

      external AGEXSR

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
 ! floating type, input/output:
      REAL*8 R8_ELO
      REAL*8 R8_EHI
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref
      REAL :: ELO_act
      REAL :: ELO_ref
      REAL :: EHI_act
      REAL :: EHI_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      ELO_act=R8_ELO
      ELO_ref=R8_ELO
      EHI_act=R8_EHI
      EHI_ref=R8_EHI

! call to original routine:  AGEXSR

      CALL AGEXSR(
     > X_act,Y_act,ELO_act,EHI_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

      if(ELO_act.ne.ELO_ref) then
         R8_ELO = ELO_act
      endif
      if(EHI_act.ne.EHI_ref) then
         R8_EHI = EHI_act
      endif

! exit
      return
      end

C******************** START FILE UINDOP.FOR ; GROUP UREAD5 ******************
C=============================================================
C&  UINDOP   OPEN INDIRECT FILE FOR UREAD INPUT
C    ... SUBSTITUTE FOR
C           USER; CHECK THAT INVOKATION OF INDIRECT FILE OCCURS
C           AT CORRECT NODE OF CALLING PROGRAM
C
C  BBUFF    80A1  NODE/PROMPT FROM MAIN PROGRAM; INDIRECT FILE
C  NCHARA    # OF CHARACTERS TO "$" DELIMITER IN BBUFF
C           FIRST LINE MUST MATCH THIS FOR ACCESS TO BE ALLOWED
C  ZFILE    ASCII FILENAME
C  IER      ERROR RETURN CODE 0=NORMAL 1=ERROR,FILE CLOSED
C
C----
 
 
      SUBROUTINE UINDOP(ZFILE,IER,IFLAG)
 
 
C  Modifications:
C  05/15/95  tbt  Increased length of zfile to 130 from 64.
 
 
c  if iflag=2 buffered internal open is performed -- no file i/o
c  see subroutine ufiget
C *** BBUFF NOW IN COMMON ***
C
      USE USERIO
C
      CHARACTER*130  ZFILE        ! 130 arbitrary tbt
C
      ILFILN=INDEX(ZFILE,' ')-1
      IF(ILFILN.LE.0) ILFILN=LFILN
      IF((iflag.ne.2).and.(NLECHO.OR.(.NOT.NLINDI))) THEN
         if(ibatch.eq.0) WRITE(LUNTRM,2001) ZFILE(1:ILFILN)
 2001    FORMAT(' @FILENAME=',A)
      ENDIF
      IER=0
      JLUN=MAX0(NLUNIN,NLUNIO)+1
      IF(JLUN.LE.MAXLIN-1) GO TO 205  ! was MAXLIN; see uread_freelun below
      WRITE(LUNTRM,9001)
 9001 FORMAT(' ? TOO MANY INDIRECT FILES')
      IER=1
      RETURN
 205  CONTINUE
C  OPEN INDIRECT
      if(iflag.ne.2) THEN
        CALL URDOPEN(LUNTIN(JLUN),ZFILE,1,IERR)
        IF(IERR.NE.0) GO TO 207
      ENDIF
      GO TO 210
C  OPEN ERROR
 207  CONTINUE
      WRITE(LUNTRM,9002) ZFILE(1:ILFILN)
 9002 FORMAT(' ? ERROR TRYING TO OPEN INDIRECT FILE : ',A)
      CLOSE(UNIT=LUNTIN(JLUN),ERR=208)
 208  CONTINUE
      IER=1
      RETURN
C
 210  CONTINUE
C  OK
 216  CONTINUE
CXXX	IF(.NOT.NLINDI) CALL NEUPAG
      NLINDI=.TRUE.
      NLUNIN=JLUN
      XFILE(NLUNIN)=ZFILE
      CALL CHXOUT
      RETURN
C
      	END
C
C--------------------------------------------------------------------------
      subroutine uread_freelun(ilun)
C
      use USERIO
C
      integer :: ilun
C
C  return a FREE LUN for temporary file i/o use...
C
      ilun = luntin(maxlin)
C
      return
      end
C******************** END FILE UINDOP.FOR ; GROUP UREAD5 ******************

C******************** START FILE TKBNDR.FOR ; GROUP TKBLOAT ******************
C-- END FILE #TKBMRY# ************************************
CFORMFEEDC-- START FILE #TKBNDR# ************************************
C--------------------------------------------------------------
C  RETURN NUMERIC NORMAL DERIVATIVE
C
      SUBROUTINE TKBNDR(ITH,ZRM1,ZYM1,ZRM2,ZYM2,
     >                    ZDERV,ZDERVN,ZANGN,ZANGS,I1,I2)
C
C  INPUT - ITH = PT NUMBER
C    ARRAYS ZRM1,ZYM1 - DESCRIBE NEAREST CLOSED SURFACE
C    ARRAYS ZRM2,ZYM2 - DESCRIBE NEXT SURFACE IN
C
C  OUTPUT - ZDERVN - "NORMAL DERIVATIVE";  NORM DOT (DL VECTOR ALONG
C   LINE OF CONST. THETA GOING FROM #2 SURFACE TO #1 SURFACE, I.E.
C     ( (ZRM1(ITH)-ZRM2(ITH)), (ZYM1(ITH)-ZYM2(ITH)) )
C
C  ZANGN - ANGLE IN (R,Y) SPACE OF DL VECTOR
C  ZANGS(2) - CONSTRAINT ANGLES DUE TO SURFACE ELEMENT ON #1
C    ABOUT POINT ITH
C
      include 'tkbparm.inc'
C
      REAL ZRM1(NTK),ZYM1(NTK),ZRM2(NTK),ZYM2(NTK),ZANGS(2)
C  STATEMENT FUNCTION
      ITHM(I)=MOD((I+NTK-1),NTK)+1
C
      ZDR1=ZRM1(ITH)-ZRM2(ITH)
      ZDY1=ZYM1(ITH)-ZYM2(ITH)
C
      ZANGN=FPOLAR(ZDR1,ZDY1)
C
      I1=ITHM(ITH+1)
      I2=ITHM(ITH-1)
C
      ZDR2=ZRM1(I2)-ZRM1(I1)
      ZDY2=ZYM1(I2)-ZYM1(I1)
C
      ZANGSP=FPOLAR(ZDR2,ZDY2)
      IF(ZANGSP.LT.ZANGN) THEN
        IDIR=1
      ELSE
        IDIR=-1
      ENDIF
C
 10   CONTINUE
      ZANGSN=ZANGSP+IDIR*3.141593
      IF((ZANGN-ZANGSP)*(ZANGN-ZANGSN).GT.0.0) THEN
        ZANGSP=ZANGSN
        GO TO 10
      ELSE                    !Avoid a CIVIC bug
        GO TO 20		!Avoid a CIVIC bug
      ENDIF
20    CONTINUE		!Avoid a CIVIC bug
C
C  CONSTRAINT ANGLES FOR NEXT STEP OF THETA LINE - AVOID SINGULARITY
      ZANGS(1)=AMIN1(ZANGSN,ZANGSP)
      ZANGS(2)=AMAX1(ZANGSN,ZANGSP)
C
      Z=ZDR1*ZDY2-ZDY1*ZDR2
      ZD2=SQRT(ZDR2**2+ZDY2**2)
C
      ZDERVN=ABS(Z)/ZD2
C
      ZDERV=SQRT(ZDR1**2+ZDY1**2)
C
      RETURN
      END
C******************** END FILE TKBNDR.FOR ; GROUP TKBLOAT ******************

subroutine execsystem_test
  use execsystem

  integer      :: ier
  character*64 :: arg               ! single argument
  character*32 :: env0(0), env3(5)  ! new environments
  character*64 :: marg(6)           ! multiple arguments
  character*16 :: exec              ! executable

  ! -- initialize --
  EXEC_VERBOSE = -1   ! verbose messages to stderr

  env3(1) = "  DOG=RUN_AWAY"
  env3(2) = " NO_VALUE=  "
  env3(3) = "   CAT=mouse/meow"
  env3(4) = "=NO_KEY "
  env3(5) = "MOUSE=/time/to/roar"
     
  ! -- test --
  EXEC_STATIC  = 1
  arg = "  echo 'hello world with static arguments'"
  ier = jsystem(arg)
  print '(a,i5)', '%ptest: hello result = ',ier
  if (ier/=0) call bad_exit
   
  EXEC_STATIC  = 0
  arg = "  echo 'hello world with heap arguments'"
  ier = jsystem(arg)
  print '(a,i5)', '%ptest: hello result = ',ier
  if (ier/=0) call bad_exit
   
  exec    = "ls"
  marg(1) = "ls"
  marg(2) = "-rt"

  ier = jexec(exec, 2, marg)
  print '(a,i5)', '%ptest: ls result = ',ier
  if (ier/=0) call bad_exit

  exec    = "printenv"
  marg(1) = "printenv"

  ier = jexec(exec,1,marg,size(env3),env3)
  print '(a,i5)', '%ptest: exec printenv result = ',ier
  if (ier/=0) call bad_exit

  EXEC_VERBOSE = 0   ! turn off verbose messages
end subroutine execsystem_test

!
!  return handles for electron impact reactions
!
!  H+,e- -> H0 (recombination
 
subroutine sigvte_reco_handle(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle     ! preact handle
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle = Lreco_H_e
 
end subroutine sigvte_reco_handle
 
subroutine sigvte_ioniz_handle(izneut,ihandle)
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: izneut   ! Z of neutral atom (1, 2 or 3)
  integer, intent(out) :: ihandle   ! preact handle
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=0
 
  if(izneut.eq.1) then
     ihandle=Lei_H0
 
  else if(izneut.eq.2) then
     ihandle=Lei_HE0
 
  else if(izneut.eq.3) then
     ihandle=Lei_LI0
 
  endif
 
end subroutine sigvte_ioniz_handle

subroutine r8ryeval(r0spl,rmspl,ymspl,zsnthtk,zcsthtk,nmom,zr99,zy99)
  !
  ! evaluate moments position:  symmetric eq. moments formula
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: nmom, imul
  real(fp) :: zr99, zy99
  real(fp) :: r0spl
  real(fp), dimension(nmom) :: rmspl, ymspl
  real(fp), dimension(nmom) :: zcsthtk, zsnthtk
  !
  !--------------------------------
  !
  ZR99=R0SPL
  ZY99 = 0.0_fp
  do IMUL=1,NMOM
    ZR99=ZR99+RMSPL(IMUL)*ZCSTHTK(IMUL)
    ZY99=ZY99+YMSPL(IMUL)*ZSNTHTK(IMUL)
  end do
  return
end subroutine r8ryeval

! real*8 interface generated by r8igen.csh --
! ...in /transp/users/dmccune/troot/tmp/trgraf2
! csh -f r8igen.csh r8_trgraf.for foo.msg
 
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GMMSEL
      SUBROUTINE R8_GMMSEL(
     > R8_R,R8_Y,ND1,NC,R8_Z,NZ,RUN,YUN,ZLAB,ZUN,MNLAB,KYLAB,FZLAB)
 
      external GMMSEL
 
! argument declarations
      REAL*8 R8_R(ND1,NZ)
      REAL*8 R8_Y(ND1,NZ)
      INTEGER ND1
      INTEGER NC
      REAL*8 R8_Z(NZ)
      INTEGER NZ
      CHARACTER*(*) RUN
      CHARACTER*(*) YUN
      CHARACTER*(*) ZLAB
      CHARACTER*(*) ZUN
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) KYLAB(5)
      CHARACTER*(*) FZLAB(15)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: R_act(:,:)
      REAL, pointer :: R_ref(:,:)
      REAL, pointer :: Y_act(:,:)
      REAL, pointer :: Y_ref(:,:)
      REAL, pointer :: Z_act(:)
      REAL, pointer :: Z_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(R_act(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSEL -- R_act ALLOCATE error!')
      ALLOCATE(R_ref(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSEL -- R_ref ALLOCATE error!')
      ALLOCATE(Y_act(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSEL -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSEL -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSEL -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GMMSEL -- Z_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      R_act=R8_R
      R_ref=R8_R
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
! call to original routine:  GMMSEL
 
      CALL GMMSEL(
     > R_act(1,1),Y_act(1,1),ND1,NC,Z_act(1),NZ,RUN,YUN,ZLAB,ZUN,MNLAB,
     > KYLAB,FZLAB)
 
! copy back outputs if modified.
 
      where(R_act.ne.R_ref)
         R8_R = R_act
      end where
      DEALLOCATE(R_act)
      DEALLOCATE(R_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFC2
      SUBROUTINE R8_GRAFC2(
     > R8_X,R8_Y,N,R8_X2,R8_Y2,N2,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRAFC2
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      REAL*8 R8_X2(N2)
      REAL*8 R8_Y2(N2)
      INTEGER N2
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: X2_act(:)
      REAL, pointer :: X2_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC2 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC2 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC2 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC2 -- Y_ref ALLOCATE error!')
      ALLOCATE(X2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC2 -- X2_act ALLOCATE error!')
      ALLOCATE(X2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC2 -- X2_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC2 -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC2 -- Y2_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      X2_act=R8_X2
      X2_ref=R8_X2
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
! call to original routine:  GRAFC2
 
      CALL GRAFC2(
     > X_act(1),Y_act(1),N,X2_act(1),Y2_act(1),N2,XUN,YUN,LBL1,LBL2,
     > LBL3)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(X2_act.ne.X2_ref)
         R8_X2 = X2_act
      end where
      DEALLOCATE(X2_act)
      DEALLOCATE(X2_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFC3
      SUBROUTINE R8_GRAFC3(
     > R8_X,R8_Y,N,R8_X2,R8_Y2,N2,R8_X3,R8_Y3,N3,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRAFC3
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      REAL*8 R8_X2(N2)
      REAL*8 R8_Y2(N2)
      INTEGER N2
      REAL*8 R8_X3(N3)
      REAL*8 R8_Y3(N3)
      INTEGER N3
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: X2_act(:)
      REAL, pointer :: X2_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
      REAL, pointer :: X3_act(:)
      REAL, pointer :: X3_ref(:)
      REAL, pointer :: Y3_act(:)
      REAL, pointer :: Y3_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- Y_ref ALLOCATE error!')
      ALLOCATE(X2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- X2_act ALLOCATE error!')
      ALLOCATE(X2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- X2_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- Y2_ref ALLOCATE error!')
      ALLOCATE(X3_act(N3)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- X3_act ALLOCATE error!')
      ALLOCATE(X3_ref(N3)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- X3_ref ALLOCATE error!')
      ALLOCATE(Y3_act(N3)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- Y3_act ALLOCATE error!')
      ALLOCATE(Y3_ref(N3)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFC3 -- Y3_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      X2_act=R8_X2
      X2_ref=R8_X2
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
      X3_act=R8_X3
      X3_ref=R8_X3
 
      Y3_act=R8_Y3
      Y3_ref=R8_Y3
 
! call to original routine:  GRAFC3
 
      CALL GRAFC3(
     > X_act(1),Y_act(1),N,X2_act(1),Y2_act(1),N2,X3_act(1),Y3_act(1),
     > N3,XUN,YUN,LBL1,LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(X2_act.ne.X2_ref)
         R8_X2 = X2_act
      end where
      DEALLOCATE(X2_act)
      DEALLOCATE(X2_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
      where(X3_act.ne.X3_ref)
         R8_X3 = X3_act
      end where
      DEALLOCATE(X3_act)
      DEALLOCATE(X3_ref)
 
      where(Y3_act.ne.Y3_ref)
         R8_Y3 = Y3_act
      end where
      DEALLOCATE(Y3_act)
      DEALLOCATE(Y3_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFWC
      SUBROUTINE R8_GRAFWC(
     > R8_X,R8_Y,R8_Y2,N,XUN,YUN,LBL1,LBL2,LBL3,JCUT,R8_X5,R8_Y5)
 
      external GRAFWC
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      REAL*8 R8_Y2(N)
      INTEGER N
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
      INTEGER JCUT(2)
      REAL*8 R8_X5(5)
      REAL*8 R8_Y5(5)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
      REAL, pointer :: X5_act(:)
      REAL, pointer :: X5_ref(:)
      REAL, pointer :: Y5_act(:)
      REAL, pointer :: Y5_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- Y_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- Y2_ref ALLOCATE error!')
      ALLOCATE(X5_act(5)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- X5_act ALLOCATE error!')
      ALLOCATE(X5_ref(5)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- X5_ref ALLOCATE error!')
      ALLOCATE(Y5_act(5)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- Y5_act ALLOCATE error!')
      ALLOCATE(Y5_ref(5)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFWC -- Y5_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
      X5_act=R8_X5
      X5_ref=R8_X5
 
      Y5_act=R8_Y5
      Y5_ref=R8_Y5
 
! call to original routine:  GRAFWC
 
      CALL GRAFWC(
     > X_act(1),Y_act(1),Y2_act(1),N,XUN,YUN,LBL1,LBL2,LBL3,JCUT,
     > X5_act(1),Y5_act(1))
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
      where(X5_act.ne.X5_ref)
         R8_X5 = X5_act
      end where
      DEALLOCATE(X5_act)
      DEALLOCATE(X5_ref)
 
      where(Y5_act.ne.Y5_ref)
         R8_Y5 = Y5_act
      end where
      DEALLOCATE(Y5_act)
      DEALLOCATE(Y5_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFX1
      SUBROUTINE R8_GRAFX1(
     > R8_X,R8_Y,N,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRAFX1
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX1 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX1 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX1 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX1 -- Y_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
! call to original routine:  GRAFX1
 
      CALL GRAFX1(
     > X_act(1),Y_act(1),N,XUN,YUN,LBL1,LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFX2
      SUBROUTINE R8_GRAFX2(
     > R8_X,R8_Y,R8_Y2,N,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRAFX2
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      REAL*8 R8_Y2(N)
      INTEGER N
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX2 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX2 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX2 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX2 -- Y_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX2 -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX2 -- Y2_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
! call to original routine:  GRAFX2
 
      CALL GRAFX2(
     > X_act(1),Y_act(1),Y2_act(1),N,XUN,YUN,LBL1,LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFX3
      SUBROUTINE R8_GRAFX3(
     > R8_X,R8_Y,R8_Y2,R8_Y3,N,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRAFX3
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      REAL*8 R8_Y2(N)
      REAL*8 R8_Y3(N)
      INTEGER N
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
      REAL, pointer :: Y3_act(:)
      REAL, pointer :: Y3_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX3 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX3 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX3 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX3 -- Y_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX3 -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX3 -- Y2_ref ALLOCATE error!')
      ALLOCATE(Y3_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX3 -- Y3_act ALLOCATE error!')
      ALLOCATE(Y3_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX3 -- Y3_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
      Y3_act=R8_Y3
      Y3_ref=R8_Y3
 
! call to original routine:  GRAFX3
 
      CALL GRAFX3(
     > X_act(1),Y_act(1),Y2_act(1),Y3_act(1),N,XUN,YUN,LBL1,LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
      where(Y3_act.ne.Y3_ref)
         R8_Y3 = Y3_act
      end where
      DEALLOCATE(Y3_act)
      DEALLOCATE(Y3_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFX4
      SUBROUTINE R8_GRAFX4(
     > R8_X,R8_Y,R8_Y2,R8_Y3,R8_Y4,N,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRAFX4
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      REAL*8 R8_Y2(N)
      REAL*8 R8_Y3(N)
      REAL*8 R8_Y4(N)
      INTEGER N
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
      REAL, pointer :: Y3_act(:)
      REAL, pointer :: Y3_ref(:)
      REAL, pointer :: Y4_act(:)
      REAL, pointer :: Y4_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- Y_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- Y2_ref ALLOCATE error!')
      ALLOCATE(Y3_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- Y3_act ALLOCATE error!')
      ALLOCATE(Y3_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- Y3_ref ALLOCATE error!')
      ALLOCATE(Y4_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- Y4_act ALLOCATE error!')
      ALLOCATE(Y4_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFX4 -- Y4_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
      Y3_act=R8_Y3
      Y3_ref=R8_Y3
 
      Y4_act=R8_Y4
      Y4_ref=R8_Y4
 
! call to original routine:  GRAFX4
 
      CALL GRAFX4(
     > X_act(1),Y_act(1),Y2_act(1),Y3_act(1),Y4_act(1),N,XUN,YUN,LBL1,
     > LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
      where(Y3_act.ne.Y3_ref)
         R8_Y3 = Y3_act
      end where
      DEALLOCATE(Y3_act)
      DEALLOCATE(Y3_ref)
 
      where(Y4_act.ne.Y4_ref)
         R8_Y4 = Y4_act
      end where
      DEALLOCATE(Y4_act)
      DEALLOCATE(Y4_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFXE
      SUBROUTINE R8_GRAFXE(
     > R8_X,R8_Y,N,R8_X2,R8_Y2,N2,IX2E,R8_X2E,IY2E,R8_Y2E,XUN,YUN,LBL1,
     > LBL2,LBL3)
 
      external GRAFXE
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      REAL*8 R8_X2(N2)
      REAL*8 R8_Y2(N2)
      INTEGER N2
      INTEGER IX2E
      REAL*8 R8_X2E(N2)
      INTEGER IY2E
      REAL*8 R8_Y2E(N2)
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: X2_act(:)
      REAL, pointer :: X2_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
      REAL, pointer :: X2E_act(:)
      REAL, pointer :: X2E_ref(:)
      REAL, pointer :: Y2E_act(:)
      REAL, pointer :: Y2E_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- Y_ref ALLOCATE error!')
      ALLOCATE(X2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- X2_act ALLOCATE error!')
      ALLOCATE(X2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- X2_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- Y2_ref ALLOCATE error!')
      ALLOCATE(X2E_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- X2E_act ALLOCATE error!')
      ALLOCATE(X2E_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- X2E_ref ALLOCATE error!')
      ALLOCATE(Y2E_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- Y2E_act ALLOCATE error!')
      ALLOCATE(Y2E_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXE -- Y2E_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      X2_act=R8_X2
      X2_ref=R8_X2
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
      X2E_act=R8_X2E
      X2E_ref=R8_X2E
 
      Y2E_act=R8_Y2E
      Y2E_ref=R8_Y2E
 
! call to original routine:  GRAFXE
 
      CALL GRAFXE(
     > X_act(1),Y_act(1),N,X2_act(1),Y2_act(1),N2,IX2E,X2E_act(1),IY2E,
     > Y2E_act(1),XUN,YUN,LBL1,LBL2,LBL3)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(X2_act.ne.X2_ref)
         R8_X2 = X2_act
      end where
      DEALLOCATE(X2_act)
      DEALLOCATE(X2_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
      where(X2E_act.ne.X2E_ref)
         R8_X2E = X2E_act
      end where
      DEALLOCATE(X2E_act)
      DEALLOCATE(X2E_ref)
 
      where(Y2E_act.ne.Y2E_ref)
         R8_Y2E = Y2E_act
      end where
      DEALLOCATE(Y2E_act)
      DEALLOCATE(Y2E_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFXF
      SUBROUTINE R8_GRAFXF(
     > R8_X,R8_Y,N,R8_X2,R8_Y2,N2,XUN,YUN,LBL1,LBL2,LBL3)
 
      external GRAFXF
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      REAL*8 R8_X2(N2)
      REAL*8 R8_Y2(N2)
      INTEGER N2
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: X2_act(:)
      REAL, pointer :: X2_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y_ref ALLOCATE error!')
      ALLOCATE(X2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X2_act ALLOCATE error!')
      ALLOCATE(X2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X2_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y2_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      X2_act=R8_X2
      X2_ref=R8_X2
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
! call to original routine:  GRAFXF
 
      CALL GRAFXF(
     > X_act(1),Y_act(1),N,X2_act(1),Y2_act(1),N2,XUN,YUN,LBL1,LBL2,
     > LBL3)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(X2_act.ne.X2_ref)
         R8_X2 = X2_act
      end where
      DEALLOCATE(X2_act)
      DEALLOCATE(X2_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFXF
      SUBROUTINE R8_GRAFXF_icod(
     > R8_X,R8_Y,N,R8_X2,R8_Y2,N2,XUN,YUN,LBL1,LBL2,LBL3,icdd)
 
      external GRAFXF
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      REAL*8 R8_X2(N2)
      REAL*8 R8_Y2(N2)
      INTEGER N2
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: X2_act(:)
      REAL, pointer :: X2_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
      integer :: icdd
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y_ref ALLOCATE error!')
      ALLOCATE(X2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X2_act ALLOCATE error!')
      ALLOCATE(X2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X2_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y2_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      X2_act=R8_X2
      X2_ref=R8_X2
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
! call to original routine:  GRAFXF
 
      CALL GRAFXF_icod(
     > X_act(1),Y_act(1),N,X2_act(1),Y2_act(1),N2,XUN,YUN,LBL1,LBL2,
     > LBL3,icdd)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(X2_act.ne.X2_ref)
         R8_X2 = X2_act
      end where
      DEALLOCATE(X2_act)
      DEALLOCATE(X2_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRAFXF
      SUBROUTINE R8_GRAFXF_icod0(
     > R8_X,R8_Y,N,R8_X2,R8_Y2,N2,XUN,YUN,LBL1,LBL2,LBL3,icdd)
! same as R8_GRAFXF_icod but with small size of individual points
 
      external GRAFXF
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      REAL*8 R8_X2(N2)
      REAL*8 R8_Y2(N2)
      INTEGER N2
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) LBL1
      CHARACTER*(*) LBL2
      CHARACTER*(*) LBL3
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: X2_act(:)
      REAL, pointer :: X2_ref(:)
      REAL, pointer :: Y2_act(:)
      REAL, pointer :: Y2_ref(:)
      integer :: icdd
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y_ref ALLOCATE error!')
      ALLOCATE(X2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X2_act ALLOCATE error!')
      ALLOCATE(X2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- X2_ref ALLOCATE error!')
      ALLOCATE(Y2_act(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y2_act ALLOCATE error!')
      ALLOCATE(Y2_ref(N2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRAFXF -- Y2_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      X2_act=R8_X2
      X2_ref=R8_X2
 
      Y2_act=R8_Y2
      Y2_ref=R8_Y2
 
! call to original routine:  GRAFXF
 
      CALL GRAFXF_icod0(
     > X_act(1),Y_act(1),N,X2_act(1),Y2_act(1),N2,XUN,YUN,LBL1,LBL2,
     > LBL3,icdd)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(X2_act.ne.X2_ref)
         R8_X2 = X2_act
      end where
      DEALLOCATE(X2_act)
      DEALLOCATE(X2_ref)
 
      where(Y2_act.ne.Y2_ref)
         R8_Y2 = Y2_act
      end where
      DEALLOCATE(Y2_act)
      DEALLOCATE(Y2_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRF3
      SUBROUTINE R8_GRF3(
     > R8_X,R8_Z,R8_Y,R8_Z2,NX,NY,NZ1,XLAB,YLAB,ZLAB,XUN,YUN,ZUN,ZTITLE,
     > ITITLE,IDIR,ISF,IDEV,NSHOT,IAVTYP,NSHOT2,NS2,ISMTYP)
 
      external GRF3
 
! argument declarations
      REAL*8 R8_X(NX)
      REAL*8 R8_Z(NZ1,NY)
      REAL*8 R8_Y(NY)
      REAL*8 R8_Z2(NY)
      INTEGER NX
      INTEGER NY
      INTEGER NZ1
      CHARACTER*10 XLAB
      CHARACTER*10 YLAB
      CHARACTER*10 ZLAB(2)
      CHARACTER*10 XUN
      CHARACTER*10 YUN
      CHARACTER*10 ZUN
      CHARACTER*10 ZTITLE(3)
      INTEGER ITITLE
      INTEGER IDIR
      INTEGER ISF
      CHARACTER*4 IDEV
      INTEGER NSHOT
      INTEGER IAVTYP
      INTEGER NSHOT2(NS2)
      INTEGER NS2
      INTEGER ISMTYP
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Z_act(:,:)
      REAL, pointer :: Z_ref(:,:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: Z2_act(:)
      REAL, pointer :: Z2_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3 -- X_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3 -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3 -- Z_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3 -- Y_ref ALLOCATE error!')
      ALLOCATE(Z2_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3 -- Z2_act ALLOCATE error!')
      ALLOCATE(Z2_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3 -- Z2_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Z2_act=R8_Z2
      Z2_ref=R8_Z2
 
! call to original routine:  GRF3
 
      CALL GRF3(
     > X_act(1),Z_act(1,1),Y_act(1),Z2_act(1),NX,NY,NZ1,XLAB,YLAB,ZLAB,
     > XUN,YUN,ZUN,ZTITLE,ITITLE,IDIR,ISF,IDEV,NSHOT,IAVTYP,NSHOT2,NS2,
     > ISMTYP)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Z2_act.ne.Z2_ref)
         R8_Z2 = Z2_act
      end where
      DEALLOCATE(Z2_act)
      DEALLOCATE(Z2_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRF3F1
      SUBROUTINE R8_GRF3F1(
     > R8_X,R8_Z,R8_Y,R8_WK,NX,NY,NZ1,XLAB,ZLAB,YLAB,XUN,ZUN,YUN,ZTITLE,
     > ZLABEL,IPROC)
 
      external GRF3F1
 
! argument declarations
      REAL*8 R8_X(NX)
      REAL*8 R8_Z(NZ1,NY)
      REAL*8 R8_Y(NY)
      REAL*8 R8_WK(NY)
      INTEGER NX
      INTEGER NY
      INTEGER NZ1
      CHARACTER*(*) XLAB
      CHARACTER*(*) ZLAB
      CHARACTER*(*) YLAB
      CHARACTER*(*) XUN
      CHARACTER*(*) ZUN
      CHARACTER*(*) YUN
      CHARACTER*(*) ZTITLE
      CHARACTER*(*) ZLABEL
      INTEGER IPROC
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Z_act(:,:)
      REAL, pointer :: Z_ref(:,:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: WK_act(:)
      REAL, pointer :: WK_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F1 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F1 -- X_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F1 -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F1 -- Z_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F1 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F1 -- Y_ref ALLOCATE error!')
      ALLOCATE(WK_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F1 -- WK_act ALLOCATE error!')
      ALLOCATE(WK_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F1 -- WK_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      WK_act=R8_WK
      WK_ref=R8_WK
 
! call to original routine:  GRF3F1
 
      CALL GRF3F1(
     > X_act(1),Z_act(1,1),Y_act(1),WK_act(1),NX,NY,NZ1,XLAB,ZLAB,YLAB,
     > XUN,ZUN,YUN,ZTITLE,ZLABEL,IPROC)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(WK_act.ne.WK_ref)
         R8_WK = WK_act
      end where
      DEALLOCATE(WK_act)
      DEALLOCATE(WK_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRF3F2
      SUBROUTINE R8_GRF3F2(
     > R8_X,R8_Z,R8_Z2,R8_Y,R8_WK,NX,NY,NZ1,XLAB,ZLAB,ZLAB2,YLAB,XUN,
     > ZUN,YUN,ZTITLE,ZLABEL,IPROC)
 
      external GRF3F2
 
! argument declarations
      REAL*8 R8_X(NX)
      REAL*8 R8_Z(NZ1,NY)
      REAL*8 R8_Z2(NZ1,NY)
      REAL*8 R8_Y(NY)
      REAL*8 R8_WK(NY,2)
      INTEGER NX
      INTEGER NY
      INTEGER NZ1
      CHARACTER*(*) XLAB
      CHARACTER*(*) ZLAB
      CHARACTER*(*) ZLAB2
      CHARACTER*(*) YLAB
      CHARACTER*(*) XUN
      CHARACTER*(*) ZUN
      CHARACTER*(*) YUN
      CHARACTER*(*) ZTITLE
      CHARACTER*(*) ZLABEL
      INTEGER IPROC
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Z_act(:,:)
      REAL, pointer :: Z_ref(:,:)
      REAL, pointer :: Z2_act(:,:)
      REAL, pointer :: Z2_ref(:,:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: WK_act(:,:)
      REAL, pointer :: WK_ref(:,:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- X_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- Z_ref ALLOCATE error!')
      ALLOCATE(Z2_act(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- Z2_act ALLOCATE error!')
      ALLOCATE(Z2_ref(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- Z2_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- Y_ref ALLOCATE error!')
      ALLOCATE(WK_act(NY,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- WK_act ALLOCATE error!')
      ALLOCATE(WK_ref(NY,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3F2 -- WK_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
      Z2_act=R8_Z2
      Z2_ref=R8_Z2
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      WK_act=R8_WK
      WK_ref=R8_WK
 
! call to original routine:  GRF3F2
 
      CALL GRF3F2(
     > X_act(1),Z_act(1,1),Z2_act(1,1),Y_act(1),WK_act(1,1),NX,NY,NZ1,
     > XLAB,ZLAB,ZLAB2,YLAB,XUN,ZUN,YUN,ZTITLE,ZLABEL,IPROC)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
      where(Z2_act.ne.Z2_ref)
         R8_Z2 = Z2_act
      end where
      DEALLOCATE(Z2_act)
      DEALLOCATE(Z2_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(WK_act.ne.WK_ref)
         R8_WK = WK_act
      end where
      DEALLOCATE(WK_act)
      DEALLOCATE(WK_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRF3X2
      SUBROUTINE R8_GRF3X2(
     > R8_X,R8_Z,R8_Z2,R8_Y,R8_ZWK,NX,NY,NZ1,XLAB,YLAB,ZLAB1,ZLAB2,XUN,
     > YUN,ZUN,ZTITLE,ITITLE,IDIR,ISF,IDEV,NSHOT,IAVTYP,NSHOT2,NS2,
     > ISMTYP)
 
      external GRF3X2
 
! argument declarations
      REAL*8 R8_X(NX)
      REAL*8 R8_Z(NZ1,NY)
      REAL*8 R8_Z2(NZ1,NY)
      REAL*8 R8_Y(NY)
      REAL*8 R8_ZWK(NY,2)
      INTEGER NX
      INTEGER NY
      INTEGER NZ1
      CHARACTER*10 XLAB
      CHARACTER*10 YLAB
      CHARACTER*10 ZLAB1(2)
      CHARACTER*10 ZLAB2(2)
      CHARACTER*10 XUN
      CHARACTER*10 YUN
      CHARACTER*10 ZUN
      CHARACTER*10 ZTITLE(3)
      INTEGER ITITLE
      INTEGER IDIR
      INTEGER ISF
      CHARACTER*4 IDEV
      INTEGER NSHOT
      INTEGER IAVTYP
      INTEGER NSHOT2(NS2)
      INTEGER NS2
      INTEGER ISMTYP
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Z_act(:,:)
      REAL, pointer :: Z_ref(:,:)
      REAL, pointer :: Z2_act(:,:)
      REAL, pointer :: Z2_ref(:,:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL, pointer :: ZWK_act(:,:)
      REAL, pointer :: ZWK_ref(:,:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- X_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- Z_ref ALLOCATE error!')
      ALLOCATE(Z2_act(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- Z2_act ALLOCATE error!')
      ALLOCATE(Z2_ref(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- Z2_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- Y_ref ALLOCATE error!')
      ALLOCATE(ZWK_act(NY,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- ZWK_act ALLOCATE error!')
      ALLOCATE(ZWK_ref(NY,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRF3X2 -- ZWK_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
      Z2_act=R8_Z2
      Z2_ref=R8_Z2
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      ZWK_act=R8_ZWK
      ZWK_ref=R8_ZWK
 
! call to original routine:  GRF3X2
 
      CALL GRF3X2(
     > X_act(1),Z_act(1,1),Z2_act(1,1),Y_act(1),ZWK_act(1,1),NX,NY,NZ1,
     > XLAB,YLAB,ZLAB1,ZLAB2,XUN,YUN,ZUN,ZTITLE,ITITLE,IDIR,ISF,IDEV,
     > NSHOT,IAVTYP,NSHOT2,NS2,ISMTYP)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
      where(Z2_act.ne.Z2_ref)
         R8_Z2 = Z2_act
      end where
      DEALLOCATE(Z2_act)
      DEALLOCATE(Z2_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(ZWK_act.ne.ZWK_ref)
         R8_ZWK = ZWK_act
      end where
      DEALLOCATE(ZWK_act)
      DEALLOCATE(ZWK_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFAH0
      SUBROUTINE R8_GRFAH0(
     > R8_X,R8_Y,N,XLAB,YLAB,ZTITL,IFIXD,ZFIXD)
 
      external GRFAH0
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      CHARACTER*30 XLAB
      CHARACTER*30 YLAB
      CHARACTER*(*) ZTITL
      INTEGER IFIXD
      CHARACTER*(*) ZFIXD
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFAH0 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFAH0 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFAH0 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFAH0 -- Y_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
! call to original routine:  GRFAH0
 
      CALL GRFAH0(
     > X_act(1),Y_act(1),N,XLAB,YLAB,ZTITL,IFIXD,ZFIXD)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFFIT
      SUBROUTINE R8_GRFFIT(
     > R8_X,R8_Y,N,IPROC,LBLY,LBLX,ISHOT,IDEV,ZDATE,NXTR,R8_XTRVAL,
     > XTRLAB,NDPT,R8_XDPT,R8_YDPT)
 
      external GRFFIT
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      INTEGER IPROC
      CHARACTER*10 LBLY(3)
      CHARACTER*10 LBLX(3)
      INTEGER ISHOT
      CHARACTER*4 IDEV
      CHARACTER*10 ZDATE
      INTEGER NXTR
      REAL*8 R8_XTRVAL
      CHARACTER*10 XTRLAB(3)
      INTEGER NDPT
      REAL*8 R8_XDPT(NDPT)
      REAL*8 R8_YDPT(NDPT)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL :: XTRVAL_act
      REAL :: XTRVAL_ref
      REAL, pointer :: XDPT_act(:)
      REAL, pointer :: XDPT_ref(:)
      REAL, pointer :: YDPT_act(:)
      REAL, pointer :: YDPT_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFFIT -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFFIT -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFFIT -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFFIT -- Y_ref ALLOCATE error!')
      ALLOCATE(XDPT_act(NDPT)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFFIT -- XDPT_act ALLOCATE error!')
      ALLOCATE(XDPT_ref(NDPT)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFFIT -- XDPT_ref ALLOCATE error!')
      ALLOCATE(YDPT_act(NDPT)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFFIT -- YDPT_act ALLOCATE error!')
      ALLOCATE(YDPT_ref(NDPT)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFFIT -- YDPT_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      XTRVAL_act=R8_XTRVAL
      XTRVAL_ref=R8_XTRVAL
 
      XDPT_act=R8_XDPT
      XDPT_ref=R8_XDPT
 
      YDPT_act=R8_YDPT
      YDPT_ref=R8_YDPT
 
! call to original routine:  GRFFIT
 
      CALL GRFFIT(
     > X_act(1),Y_act(1),N,IPROC,LBLY,LBLX,ISHOT,IDEV,ZDATE,NXTR,
     > XTRVAL_act,XTRLAB,NDPT,XDPT_act(1),YDPT_act(1))
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      if(XTRVAL_act.ne.XTRVAL_ref) then
         R8_XTRVAL = XTRVAL_act
      endif
 
      where(XDPT_act.ne.XDPT_ref)
         R8_XDPT = XDPT_act
      end where
      DEALLOCATE(XDPT_act)
      DEALLOCATE(XDPT_ref)
 
      where(YDPT_act.ne.YDPT_ref)
         R8_YDPT = YDPT_act
      end where
      DEALLOCATE(YDPT_act)
      DEALLOCATE(YDPT_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFMF1
      SUBROUTINE R8_GRFMF1(
     > R8_F,NF1,R8_X1,NX1,R8_X2,NX2,R8_ZW,ISELX,ISELF,NSEL,FUNS,XUNS,
     > MNLAB,KYLAB,LBSEL)
 
      external GRFMF1
 
! argument declarations
      REAL*8 R8_F(NF1,NX2)
      INTEGER NF1
      REAL*8 R8_X1(NX1)
      INTEGER NX1
      REAL*8 R8_X2(NX2)
      INTEGER NX2
      REAL*8 R8_ZW(NX2)
      INTEGER ISELX
      INTEGER ISELF(NSEL)
      INTEGER NSEL
      CHARACTER*(*) FUNS
      CHARACTER*(*) XUNS
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) KYLAB(5)
      CHARACTER*(*) LBSEL(NSEL)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: F_act(:,:)
      REAL, pointer :: F_ref(:,:)
      REAL, pointer :: X1_act(:)
      REAL, pointer :: X1_ref(:)
      REAL, pointer :: X2_act(:)
      REAL, pointer :: X2_ref(:)
      REAL, pointer :: ZW_act(:)
      REAL, pointer :: ZW_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(NF1,NX2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMF1 -- F_act ALLOCATE error!')
      ALLOCATE(F_ref(NF1,NX2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMF1 -- F_ref ALLOCATE error!')
      ALLOCATE(X1_act(NX1)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMF1 -- X1_act ALLOCATE error!')
      ALLOCATE(X1_ref(NX1)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMF1 -- X1_ref ALLOCATE error!')
      ALLOCATE(X2_act(NX2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMF1 -- X2_act ALLOCATE error!')
      ALLOCATE(X2_ref(NX2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMF1 -- X2_ref ALLOCATE error!')
      ALLOCATE(ZW_act(NX2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMF1 -- ZW_act ALLOCATE error!')
      ALLOCATE(ZW_ref(NX2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMF1 -- ZW_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=R8_F
      F_ref=R8_F
 
      X1_act=R8_X1
      X1_ref=R8_X1
 
      X2_act=R8_X2
      X2_ref=R8_X2
 
      ZW_act=R8_ZW
      ZW_ref=R8_ZW
 
! call to original routine:  GRFMF1
 
      CALL GRFMF1(
     > F_act(1,1),NF1,X1_act(1),NX1,X2_act(1),NX2,ZW_act(1),ISELX,ISELF,
     > NSEL,FUNS,XUNS,MNLAB,KYLAB,LBSEL)
 
! copy back outputs if modified.
 
      where(F_act.ne.F_ref)
         R8_F = F_act
      end where
      DEALLOCATE(F_act)
      DEALLOCATE(F_ref)
 
      where(X1_act.ne.X1_ref)
         R8_X1 = X1_act
      end where
      DEALLOCATE(X1_act)
      DEALLOCATE(X1_ref)
 
      where(X2_act.ne.X2_ref)
         R8_X2 = X2_act
      end where
      DEALLOCATE(X2_act)
      DEALLOCATE(X2_ref)
 
      where(ZW_act.ne.ZW_ref)
         R8_ZW = ZW_act
      end where
      DEALLOCATE(ZW_act)
      DEALLOCATE(ZW_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFMM1
      SUBROUTINE R8_GRFMM1(
     > R8_R,R8_Y,ND1,NC,NNC,R8_Z,NZ,ISELF,NSEL,RUN,YUN,MNLAB,KYLAB,
     > LBSEL)
 
      external GRFMM1
 
! argument declarations
      REAL*8 R8_R(ND1,NZ)
      REAL*8 R8_Y(ND1,NZ)
      INTEGER ND1
      INTEGER NC(NNC)
      INTEGER NNC
      REAL*8 R8_Z(NZ)
      INTEGER NZ
      INTEGER ISELF(NSEL)
      INTEGER NSEL
      CHARACTER*(*) RUN
      CHARACTER*(*) YUN
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) KYLAB(5)
      CHARACTER*(*) LBSEL(NSEL)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: R_act(:,:)
      REAL, pointer :: R_ref(:,:)
      REAL, pointer :: Y_act(:,:)
      REAL, pointer :: Y_ref(:,:)
      REAL, pointer :: Z_act(:)
      REAL, pointer :: Z_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(R_act(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1 -- R_act ALLOCATE error!')
      ALLOCATE(R_ref(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1 -- R_ref ALLOCATE error!')
      ALLOCATE(Y_act(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1 -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1 -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1 -- Z_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      R_act=R8_R
      R_ref=R8_R
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
! call to original routine:  GRFMM1
 
      CALL GRFMM1(
     > R_act(1,1),Y_act(1,1),ND1,NC,NNC,Z_act(1),NZ,ISELF,NSEL,RUN,YUN,
     > MNLAB,KYLAB,LBSEL)
 
! copy back outputs if modified.
 
      where(R_act.ne.R_ref)
         R8_R = R_act
      end where
      DEALLOCATE(R_act)
      DEALLOCATE(R_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFMM1B
      SUBROUTINE R8_GRFMM1B(
     > R8_R,R8_Y,ND1,NC,NNC,R8_Z,NZ,ISELF,NSEL,RUN,YUN,MNLAB)
 
      external GRFMM1B
 
! argument declarations
      REAL*8 R8_R(ND1,NZ)
      REAL*8 R8_Y(ND1,NZ)
      INTEGER ND1
      INTEGER NC(NNC)
      INTEGER NNC
      REAL*8 R8_Z(NZ)
      INTEGER NZ
      INTEGER ISELF(NSEL)
      INTEGER NSEL
      CHARACTER*(*) RUN
      CHARACTER*(*) YUN
      CHARACTER*(*) MNLAB(3)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: R_act(:,:)
      REAL, pointer :: R_ref(:,:)
      REAL, pointer :: Y_act(:,:)
      REAL, pointer :: Y_ref(:,:)
      REAL, pointer :: Z_act(:)
      REAL, pointer :: Z_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(R_act(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1B -- R_act ALLOCATE error!')
      ALLOCATE(R_ref(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1B -- R_ref ALLOCATE error!')
      ALLOCATE(Y_act(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1B -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(ND1,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1B -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1B -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFMM1B -- Z_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      R_act=R8_R
      R_ref=R8_R
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
! call to original routine:  GRFMM1B
 
      CALL GRFMM1B(
     > R_act(1,1),Y_act(1,1),ND1,NC,NNC,Z_act(1),NZ,ISELF,NSEL,RUN,YUN,
     > MNLAB)
 
! copy back outputs if modified.
 
      where(R_act.ne.R_ref)
         R8_R = R_act
      end where
      DEALLOCATE(R_act)
      DEALLOCATE(R_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GRFUF1
      SUBROUTINE R8_GRFUF1(
     > R8_X,R8_Y,N,IPROC,LBLY,LBLX,ISHOT,IDEV,ZDATE,NXTR,R8_XTRVAL,
     > XTRLAB)
 
      external GRFUF1
 
! argument declarations
      REAL*8 R8_X(N)
      REAL*8 R8_Y(N)
      INTEGER N
      INTEGER IPROC
      CHARACTER*10 LBLY(3)
      CHARACTER*10 LBLX(3)
      INTEGER ISHOT
      CHARACTER*4 IDEV
      CHARACTER*10 ZDATE
      INTEGER NXTR
      REAL*8 R8_XTRVAL
      CHARACTER*10 XTRLAB(3)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL :: XTRVAL_act
      REAL :: XTRVAL_ref
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFUF1 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFUF1 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFUF1 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_GRFUF1 -- Y_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      XTRVAL_act=R8_XTRVAL
      XTRVAL_ref=R8_XTRVAL
 
! call to original routine:  GRFUF1
 
      CALL GRFUF1(
     > X_act(1),Y_act(1),N,IPROC,LBLY,LBLX,ISHOT,IDEV,ZDATE,NXTR,
     > XTRVAL_act,XTRLAB)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      if(XTRVAL_act.ne.XTRVAL_ref) then
         R8_XTRVAL = XTRVAL_act
      endif
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GSCGDF
      SUBROUTINE R8_GSCGDF(
     > IAX,ISEL,R8_ZARG1,R8_ZARG2)
 
      external GSCGDF
 
! argument declarations
      INTEGER IAX
      INTEGER ISEL
      REAL*8 R8_ZARG1
      REAL*8 R8_ZARG2
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL :: ZARG1_act
      REAL :: ZARG1_ref
      REAL :: ZARG2_act
      REAL :: ZARG2_ref
 
! allocation of working arrays...
 
 
! executable code:  copy for input
 
      ZARG1_act=R8_ZARG1
      ZARG1_ref=R8_ZARG1
 
      ZARG2_act=R8_ZARG2
      ZARG2_ref=R8_ZARG2
 
! call to original routine:  GSCGDF
 
      CALL GSCGDF(
     > IAX,ISEL,ZARG1_act,ZARG2_act)
 
! copy back outputs if modified.
 
      if(ZARG1_act.ne.ZARG1_ref) then
         R8_ZARG1 = ZARG1_act
      endif
 
      if(ZARG2_act.ne.ZARG2_ref) then
         R8_ZARG2 = ZARG2_act
      endif
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GSCGT1
      SUBROUTINE R8_GSCGT1(
     > ZSUB,ZNAME,R8_ZVAL,R8_ZDEFLT,IRET,XTRA)
 
      external GSCGT1
 
! argument declarations
      CHARACTER*(*) ZSUB
      CHARACTER*(*) ZNAME
      REAL*8 R8_ZVAL
      REAL*8 R8_ZDEFLT
      INTEGER IRET
      CHARACTER*(*) XTRA
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL :: ZVAL_act
      REAL :: ZVAL_ref
      REAL :: ZDEFLT_act
      REAL :: ZDEFLT_ref
 
! allocation of working arrays...
 
 
! executable code:  copy for input
 
      ZVAL_act=R8_ZVAL
      ZVAL_ref=R8_ZVAL
 
      ZDEFLT_act=R8_ZDEFLT
      ZDEFLT_ref=R8_ZDEFLT
 
! call to original routine:  GSCGT1
 
      CALL GSCGT1(
     > ZSUB,ZNAME,ZVAL_act,ZDEFLT_act,IRET,XTRA)
 
! copy back outputs if modified.
 
      if(ZVAL_act.ne.ZVAL_ref) then
         R8_ZVAL = ZVAL_act
      endif
 
      if(ZDEFLT_act.ne.ZDEFLT_ref) then
         R8_ZDEFLT = ZDEFLT_act
      endif
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  GSCSPC
      SUBROUTINE R8_GSCSPC(
     > IAX,ISEL,R8_ZARG1,R8_ZARG2)
 
      external GSCSPC
 
! argument declarations
      INTEGER IAX
      INTEGER ISEL
      REAL*8 R8_ZARG1
      REAL*8 R8_ZARG2
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL :: ZARG1_act
      REAL :: ZARG1_ref
      REAL :: ZARG2_act
      REAL :: ZARG2_ref
 
! allocation of working arrays...
 
 
! executable code:  copy for input
 
      ZARG1_act=R8_ZARG1
      ZARG1_ref=R8_ZARG1
 
      ZARG2_act=R8_ZARG2
      ZARG2_ref=R8_ZARG2
 
! call to original routine:  GSCSPC
 
      CALL GSCSPC(
     > IAX,ISEL,ZARG1_act,ZARG2_act)
 
! copy back outputs if modified.
 
      if(ZARG1_act.ne.ZARG1_ref) then
         R8_ZARG1 = ZARG1_act
      endif
 
      if(ZARG2_act.ne.ZARG2_ref) then
         R8_ZARG2 = ZARG2_act
      endif
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  LIMPLOTR
      SUBROUTINE R8_LIMPLOTR(
     > RUNID,R8_ZTIME,R8_RMCB,R8_YMCB,MIMOM,NMOMD,NONLIN,MILIM,NLINLM,
     > R8_ALNLMR,R8_ALNLMY,R8_ALNLMT,NCIRLM,R8_CRLMR1,R8_CRLMY1,
     > R8_CRLMRD,mnlim,r8_rpts,r8_ypts,irflim,r8_rrf,r8_yrf,
     > nant,nrz_ant,namax,r8_ranta,r8_yanta)
 
      external LIMPLOTR
 
! argument declarations
      CHARACTER*(*) RUNID
      REAL*8 R8_ZTIME
      REAL*8 R8_RMCB(0:MIMOM,2)
      REAL*8 R8_YMCB(0:MIMOM,2)
      INTEGER MIMOM
      INTEGER NMOMD
      INTEGER NONLIN
      INTEGER MILIM
      INTEGER NLINLM
      REAL*8 R8_ALNLMR(MILIM)
      REAL*8 R8_ALNLMY(MILIM)
      REAL*8 R8_ALNLMT(MILIM)
      INTEGER NCIRLM
      REAL*8 R8_CRLMR1(MILIM)
      REAL*8 R8_CRLMY1(MILIM)
      REAL*8 R8_CRLMRD(MILIM)

      integer mnlim
      real*8 r8_rpts(mnlim),r8_ypts(mnlim)
 
      integer irflim
      real*8 r8_rrf(irflim),r8_yrf(irflim)

! hand modified:
      integer nant
      integer nrz_ant(nant)

      integer namax
      real*8 r8_ranta(namax,nant),r8_yanta(namax,nant)

! local (automatic array) declarations
 
      integer alloc_stat
      REAL :: ZTIME_act
      REAL :: ZTIME_ref
      REAL, pointer :: RMCB_act(:,:)
      REAL, pointer :: RMCB_ref(:,:)
      REAL, pointer :: YMCB_act(:,:)
      REAL, pointer :: YMCB_ref(:,:)
      REAL, pointer :: ALNLMR_act(:)
      REAL, pointer :: ALNLMR_ref(:)
      REAL, pointer :: ALNLMY_act(:)
      REAL, pointer :: ALNLMY_ref(:)
      REAL, pointer :: ALNLMT_act(:)
      REAL, pointer :: ALNLMT_ref(:)
      REAL, pointer :: CRLMR1_act(:)
      REAL, pointer :: CRLMR1_ref(:)
      REAL, pointer :: CRLMY1_act(:)
      REAL, pointer :: CRLMY1_ref(:)
      REAL, pointer :: CRLMRD_act(:)
      REAL, pointer :: CRLMRD_ref(:)
 
      real, dimension(:), allocatable :: rpts,ypts,rf_rpts,rf_ypts

      real, dimension(:,:), allocatable :: ranta,yanta
! allocation of working arrays...
 
      ALLOCATE(RMCB_act(0:MIMOM,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- RMCB_act ALLOCATE error!')
      ALLOCATE(RMCB_ref(0:MIMOM,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- RMCB_ref ALLOCATE error!')
      ALLOCATE(YMCB_act(0:MIMOM,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- YMCB_act ALLOCATE error!')
      ALLOCATE(YMCB_ref(0:MIMOM,2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- YMCB_ref ALLOCATE error!')
      ALLOCATE(ALNLMR_act(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- ALNLMR_act ALLOCATE error!')
      ALLOCATE(ALNLMR_ref(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- ALNLMR_ref ALLOCATE error!')
      ALLOCATE(ALNLMY_act(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- ALNLMY_act ALLOCATE error!')
      ALLOCATE(ALNLMY_ref(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- ALNLMY_ref ALLOCATE error!')
      ALLOCATE(ALNLMT_act(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- ALNLMT_act ALLOCATE error!')
      ALLOCATE(ALNLMT_ref(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- ALNLMT_ref ALLOCATE error!')
      ALLOCATE(CRLMR1_act(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- CRLMR1_act ALLOCATE error!')
      ALLOCATE(CRLMR1_ref(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- CRLMR1_ref ALLOCATE error!')
      ALLOCATE(CRLMY1_act(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- CRLMY1_act ALLOCATE error!')
      ALLOCATE(CRLMY1_ref(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- CRLMY1_ref ALLOCATE error!')
      ALLOCATE(CRLMRD_act(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- CRLMRD_act ALLOCATE error!')
      ALLOCATE(CRLMRD_ref(MILIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LIMPLOTR -- CRLMRD_ref ALLOCATE error!')
 
      allocate(rpts(mnlim),ypts(mnlim))
      allocate(rf_rpts(irflim),rf_ypts(irflim))

      allocate(ranta(namax,nant),yanta(namax,nant))

! executable code:  copy for input
 
      ZTIME_act=R8_ZTIME
      ZTIME_ref=R8_ZTIME
 
      RMCB_act=R8_RMCB
      RMCB_ref=R8_RMCB
 
      YMCB_act=R8_YMCB
      YMCB_ref=R8_YMCB
 
      ALNLMR_act=R8_ALNLMR
      ALNLMR_ref=R8_ALNLMR
 
      ALNLMY_act=R8_ALNLMY
      ALNLMY_ref=R8_ALNLMY
 
      ALNLMT_act=R8_ALNLMT
      ALNLMT_ref=R8_ALNLMT
 
      CRLMR1_act=R8_CRLMR1
      CRLMR1_ref=R8_CRLMR1
 
      CRLMY1_act=R8_CRLMY1
      CRLMY1_ref=R8_CRLMY1
 
      CRLMRD_act=R8_CRLMRD
      CRLMRD_ref=R8_CRLMRD
 
      rpts = r8_rpts
      ypts = r8_ypts

      rf_rpts = r8_rrf
      rf_ypts = r8_yrf

      ranta = r8_ranta
      yanta = r8_yanta

! call to original routine:  LIMPLOTR
 
      CALL LIMPLOTR(
     > RUNID,ZTIME_act,RMCB_act(0,1),YMCB_act(0,1),MIMOM,NMOMD,NONLIN,
     > MILIM,NLINLM,ALNLMR_act(1),ALNLMY_act(1),ALNLMT_act(1),NCIRLM,
     > CRLMR1_act(1),CRLMY1_act(1),CRLMRD_act(1),
     >     mnlim,rpts,ypts, irflim,rf_rpts,rf_ypts, 
     >     nant,nrz_ant,namax,ranta,yanta)
 
! copy back outputs if modified.
 
      if(ZTIME_act.ne.ZTIME_ref) then
         R8_ZTIME = ZTIME_act
      endif
 
      where(RMCB_act.ne.RMCB_ref)
         R8_RMCB = RMCB_act
      end where
      DEALLOCATE(RMCB_act)
      DEALLOCATE(RMCB_ref)
 
      where(YMCB_act.ne.YMCB_ref)
         R8_YMCB = YMCB_act
      end where
      DEALLOCATE(YMCB_act)
      DEALLOCATE(YMCB_ref)
 
      where(ALNLMR_act.ne.ALNLMR_ref)
         R8_ALNLMR = ALNLMR_act
      end where
      DEALLOCATE(ALNLMR_act)
      DEALLOCATE(ALNLMR_ref)
 
      where(ALNLMY_act.ne.ALNLMY_ref)
         R8_ALNLMY = ALNLMY_act
      end where
      DEALLOCATE(ALNLMY_act)
      DEALLOCATE(ALNLMY_ref)
 
      where(ALNLMT_act.ne.ALNLMT_ref)
         R8_ALNLMT = ALNLMT_act
      end where
      DEALLOCATE(ALNLMT_act)
      DEALLOCATE(ALNLMT_ref)
 
      where(CRLMR1_act.ne.CRLMR1_ref)
         R8_CRLMR1 = CRLMR1_act
      end where
      DEALLOCATE(CRLMR1_act)
      DEALLOCATE(CRLMR1_ref)
 
      where(CRLMY1_act.ne.CRLMY1_ref)
         R8_CRLMY1 = CRLMY1_act
      end where
      DEALLOCATE(CRLMY1_act)
      DEALLOCATE(CRLMY1_ref)
 
      where(CRLMRD_act.ne.CRLMRD_ref)
         R8_CRLMRD = CRLMRD_act
      end where
      DEALLOCATE(CRLMRD_act)
      DEALLOCATE(CRLMRD_ref)
 
      deallocate(rpts,ypts,rf_rpts,rf_ypts)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) real*8 interface to:  TGRF3D
      SUBROUTINE R8_TGRF3D(
     > R8_X,R8_Z,R8_Y,NX,NY,NZ1,XLAB,YLAB,ZLAB,XUN,YUN,ZUN,ZTITLE,IPROC,
     > ZRNLBL,IINT,ZINT,NPAGE,ZLLAB,ZLLUN,R8_ZX0,IRET)
 
      external TGRF3D
 
! argument declarations
      REAL*8 R8_X(NX)
      REAL*8 R8_Z(NZ1,NY)
      REAL*8 R8_Y(NY)
      INTEGER NX
      INTEGER NY
      INTEGER NZ1
      CHARACTER*(*) XLAB
      CHARACTER*(*) YLAB
      CHARACTER*(*) ZLAB
      CHARACTER*(*) XUN
      CHARACTER*(*) YUN
      CHARACTER*(*) ZUN
      CHARACTER*(*) ZTITLE
      INTEGER IPROC
      CHARACTER*(*) ZRNLBL
      INTEGER IINT
      CHARACTER*(*) ZINT
      INTEGER NPAGE
      CHARACTER*(*) ZLLAB
      CHARACTER*(*) ZLLUN
      REAL*8 R8_ZX0
      INTEGER IRET
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, pointer :: X_act(:)
      REAL, pointer :: X_ref(:)
      REAL, pointer :: Z_act(:,:)
      REAL, pointer :: Z_ref(:,:)
      REAL, pointer :: Y_act(:)
      REAL, pointer :: Y_ref(:)
      REAL :: ZX0_act
      REAL :: ZX0_ref
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_TGRF3D -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_TGRF3D -- X_ref ALLOCATE error!')
      ALLOCATE(Z_act(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_TGRF3D -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NZ1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_TGRF3D -- Z_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_TGRF3D -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_TGRF3D -- Y_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      X_ref=R8_X
 
      Z_act=R8_Z
      Z_ref=R8_Z
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
      ZX0_act=R8_ZX0
      ZX0_ref=R8_ZX0
 
! call to original routine:  TGRF3D
 
      CALL TGRF3D(
     > X_act(1),Z_act(1,1),Y_act(1),NX,NY,NZ1,XLAB,YLAB,ZLAB,XUN,YUN,
     > ZUN,ZTITLE,IPROC,ZRNLBL,IINT,ZINT,NPAGE,ZLLAB,ZLLUN,ZX0_act,IRET)
 
! copy back outputs if modified.
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
      if(ZX0_act.ne.ZX0_ref) then
         R8_ZX0 = ZX0_act
      endif
 
! exit
      return
      end

C******************** START FILE SEVALI.FOR ; GROUP TRKRLIB *************
C  MOD DMC SUMMER 1987 JET/GARCHING
C   ROUTINE MAY EVALUATE LINEAR INSTEAD OF SPLINE INTERPOLATION, IF
C   COMMON SWITCH ILIN IS SET ***
C....................................................
      REAL FUNCTION SEVALI(N, U, X, Y, B, C, D, dx)
      INTEGER N
      REAL  U, X(N), Y(N), B(N), C(N), D(N)
C
CCCCCCCCCCCCCCC
CCCCCCCCCCCCCCC
C  THIS SUBROUTINE EVALUATES THE CUBIC SPLINE FUNCTION
C
C    SEVALI = Y(I) + B(I)*(U-X(I)) + C(I)*(U-X(I))**2 + D(I)*(U-X(I))**3
C
C    WHERE  X(I) .LT. U .LT. X(I+1), USING HORNER'S RULE
C
C  IF  U .LT. X(1) THEN  I = 1  IS USED.
C  IF  U .GE. X(N) THEN  I = N  IS USED.
C
C  INPUT..
C
C    N = THE NUMBER OF DATA POINTS
C    U = THE ABSCISSA AT WHICH THE SPLINE IS TO BE EVALUATED
C    X,Y = THE ARRAYS OF DATA ABSCISSAS AND ORDINATES
C    B,C,D = ARRAYS OF SPLINE COEFFICIENTS COMPUTED BY SPLINE
C
C  IF  U  IS NOT IN THE SAME INTERVAL AS THE PREVIOUS CALL, THEN A
C  BINARY SEARCH IS PERFORMED TO DETERMINE THE PROPER INTERVAL.
C
C  DMC GARCHING OCT 1985 KLUGE
      COMMON/ZSEVALI/ IPUT,ILIN
C  RETURN ZONE INDEX TO CALLER VIA THIS COMMON BLOCK ***
c   nb dmc -- return dx as passed argument
c   prep for real*8 conversion
C
      INTEGER I, J, K
      REAL DX
      DATA I/1/
      SAVE I
 
      IF ( I .GE. N ) I = 1
      IF ( U .LT. X(I) ) GO TO 10
      IF ( U .LE. X(I+1) ) GO TO 30
C
C  BINARY SEARCH
C
   10 I = 1
      J = N+1
   20 K = (I+J)/2
      IF ( U .LT. X(K) ) J = K
      IF ( U .GE. X(K) ) I = K
      IF ( J .GT. I+1 ) GO TO 20
C
C  EVALUATE SPLINE
C
   30 DX = U - X(I)
      IF(ILIN.EQ.0) THEN
        SEVALI = Y(I) + DX*(B(I) + DX*(C(I) + DX*D(I)))
      ELSE
        IF(I.EQ.N) THEN
          ZSLOP=(Y(N)-Y(N-1))/(X(N)-X(N-1))
        ELSE
          ZSLOP=(Y(I+1)-Y(I))/(X(I+1)-X(I))
        ENDIF
        SEVALI=Y(I)+DX*ZSLOP
      ENDIF
C
      IPUT=I
C
      RETURN
      END
C******************** END FILE SEVALI.FOR ; GROUP TRKRLIB ***************

subroutine ps_namrd_ilist_chk(listname,nmax,list,nfound,iout,ierr)

  ! determine length of list by number of non-blank elements in the list
  ! once a blank element is detected, all subsequent elements must also
  ! be blank, or, an error flag is set.

  implicit none

  !-----------------
  ! arguments:

  character(len=*), intent(in) :: listname   ! name of list (for error message)
  integer, intent(in) :: nmax                ! size of list array
  character(len=*), intent(in) :: list(nmax) ! the list itself

  integer, intent(out) :: nfound          ! address of last non-blank element

  integer, intent(in) :: iout             ! I/O unit for error messages
  integer, intent(out) :: ierr            ! exit status (0=OK)

  !------------------
  ! local:

  integer :: ii,iblank
  !------------------

  nfound=0
  ierr=0

  iblank=0
  do ii=1,nmax
     if(list(ii).eq.' ') then
        if(iblank.eq.0) iblank=ii
     else
        if(iblank.gt.0) then
           write(iout,*) ' ?ps_namrd_ilist_chk: in list "'//trim(listname)//'":'
           write(iout,*) '  non-blank element #',ii, &
                ' follows blank element #',iblank
           ierr=1
           exit
        endif
     endif
  enddo

  if(ierr.eq.0) then
     nfound = iblank - 1
  endif

end subroutine ps_namrd_ilist_chk

C------------------------------------------------------------------
C  UBLINE - SET NO. OF LEADING BLANK LINES BEFORE EACH PROMPT
C
C   SEE UREAD SUBROUTINE UPROMT.FOR
C
      SUBROUTINE UBLINE(ILINES)
C
      USE USERIO
C
      NBLINE=ILINES
C
      RETURN
      END

C-----------------------------------------------------------------------
C  ufilnam -- form complete unix file specification
C
      subroutine ufilnam(envroot,filnam,fullname)
c
#ifdef __NAGWARE
      use f90_unix_env
#endif
c
      character*(*) envroot     ! input -- directory name
      character*(*) filnam      ! input -- filename
C
      character*(*) fullname	  ! output -- full filename
C
C
C  this routine essentially concatenates envroot and filnam, inserting
C  an intervening "/" if needed, to create the full filename.
C
C  envroot, or the first word before "/" in envroot, can be an
C  environment variable which gets translated here.
C
C-----------------------------------------------------------------------
C
      if(envroot.eq.' ') then
        fullname=filnam
        go to 1000
c
      else if((envroot(1:1).eq.'/').or.(envroot(1:1).eq.'~')) then
        fullname=envroot
        go to 500
c
      else
        fullname=' '
        ilen=len_trim(envroot)
        ilenv=index(envroot,'/')-1
        if(ilenv.lt.0) ilenv=ilen
        ist=1
        if(envroot(1:1).eq.'$') ist=2
        call mpi_sget_env(envroot(ist:ilenv),fullname,iertmp)
        if(fullname.eq.' ') then
          fullname=envroot
        else
          if(ilenv.lt.ilen) then
            ilbl=index(fullname,' ')
            fullname(ilbl:)=envroot(ilenv+1:ilen)
          endif
        endif
        go to 500
      endif
C
 500  continue
      ilnb=index(fullname,' ')-1
      if(fullname(ilnb:ilnb).ne.'/') then
        ilnb=ilnb+1
        fullname(ilnb:ilnb)='/'
      endif
C
      fullname(ilnb+1:)=filnam
C
 1000 continue
      return
      end

!
! defines a submsg type which can be used for returning a multi-line error message from
! a fortran 90 subroutine.  A default submsg is defined with C accessor functions.
!
! Mods
!    22Dec2009    Jim.Conboy@cffe.ac.uk
!                 cstring(trim(),  => cstr_2C(trim(), 
!                 [ Former invalid under debug compilation ]
!
module submsg_mod
  implicit none

  integer, parameter     :: nsubmsg = 132   ! size of one line of the msg
  character(len=nsubmsg) :: mline           ! single line for temporary use in external code

  !
  ! --- submsg type ---
  !
  type :: submsg
    private 
    integer :: num = -1                                          ! number of logical lines or -1 for unallocated memory
    character(len=nsubmsg), pointer, dimension(:) :: msg => null()  ! the message
  end type submsg

  !
  ! --- default submsg ---
  !
  logical,private,save              :: igot=.false.   ! true when default_msg has been constructed
  type(submsg),pointer,private,save :: default_msg    ! default message for passing to C routines

  !
  ! --- interfaces ---
  !
  interface add_msg
    module procedure add_msg_char, add_msg_msg
  end interface add_msg

  interface copy_msg
    module procedure copy_msg_char, copy_msg_msg
  end interface copy_msg

contains
  !
  ! ----- new_msg -------
  ! initializes a new submsg type -- use this right after declaration or allocation.
  ! The optional 'ns' argument is a desired storage size -- the default is unallocated.
  !
  ! Update: not needed anymore because of fortran 95 initialization of types
  !
  subroutine new_msg(m, ns)
    type(submsg), intent(inout)   :: m   ! message
    integer, optional, intent(in) :: ns  ! optional initial size as the number of lines

    if (present(ns)) then
      if (ns>0) call resize_msg(m,ns)
    end if
  end subroutine new_msg

  !
  ! ------- size_msg ------
  ! return the logical size of the message
  !
  function size_msg(m) result(n)
    type(submsg),intent(in) :: m    ! message
    integer :: n                    ! logical size

    n = max(0, m%num)    ! unallocated returns 0
  end function size_msg

  !
  ! ---- resize_msg ----
  ! force the internal storage of a submsg to a fixed size.  The logical
  ! size in submsg%num is not changed unless the physical size drops
  ! below the logical size.  If the ns size argument is nonnegative, use this
  ! as the final size of the storage.  If the ns size argument is negative, ensure
  ! the storage has at least |ns| free spaces.
  !
  subroutine resize_msg(m, ns)
    type(submsg),intent(inout) :: m    ! message
    integer,     intent(in)    :: ns   ! ns>=0 -> new size of the storage
    ! ns<0  -> need at least |ns| free spaces

    integer :: n                                     ! required size
    integer :: k                                     ! overlap between old and new storage
    character(len=nsubmsg), pointer, dimension(:) :: p  ! new storage

    ! find n
    if (ns>=0) then
      n = ns
    else
      if (m%num<=0) then
        n = abs(ns)
      else
        n = m%num + abs(ns)            ! minimum required size of storage
        if (n<=size(m%msg)) return     ! there is at least |ns| free lines
        n = max(n+3,4*n/3)             ! need to increase the storage with some slop
      end if
    end if

    if (m%num<0) then
      !print *, 'allocated new ',n
      allocate(m%msg(max(0,n)))     ! get at least something
      m%num=0                       ! logically empty
    else
      if (n==size(m%msg)) return    ! nothing to do
      allocate(p(n))
      !print *, 'allocated ',n
      k = min(size(p),m%num) 
      p(1:k) = m%msg(1:k)           ! copy old lines over
      deallocate(m%msg)             ! free up old storage
      m%msg => p
      m%num = k                     ! might chop lines off
    end if
  end subroutine resize_msg

  !
  ! ------ trim_msg ------
  ! remove lines by reducing the logical size of the message
  !
  subroutine trim_msg(m, ns)
    type(submsg), intent(inout) :: m    ! message
    integer,      intent(in)    :: ns   ! number of lines to trim

    if (m%num<=0 .or. ns<=0) return
    m%num = max(0,m%num-ns)
  end subroutine trim_msg

  !
  ! ------- clear_msg --------
  ! empty the submsg deallocating the memory if necessary
  !
  subroutine clear_msg(m)
    type(submsg), intent(inout) :: m    ! message

    if (m%num>=0) then
      deallocate(m%msg)   ! only when allocated
      m%num=-1
    end if
  end subroutine clear_msg

  !
  ! -------- add_msg_char --------
  ! append a new string to the message
  !
  subroutine add_msg_char(m, c)
    type(submsg),  intent(inout) :: m    ! message
    character(len=*), intent(in)    :: c    ! string to add to message
    integer :: n   ! new size

    call resize_msg(m,-1)
    n = m%num+1
    m%msg(n) = c
    m%num = n
  end subroutine add_msg_char


  !
  ! -------- add_msg_msg --------
  ! append all the strings in one message to the target
  !
  subroutine add_msg_msg(m, mc)
    type(submsg), intent(inout) :: m     ! target message
    type(submsg), intent(in)    :: mc    ! source of strings to add to message

    integer :: i,n     ! temps

    if (mc%num<=0) return    ! empty source
    call resize_msg(m,-mc%num)

    do i=1, mc%num
      n = m%num+1
      m%msg(n) = mc%msg(i)
      m%num = n
    end do
  end subroutine add_msg_msg

  !
  ! -------- copy_msg_char --------
  ! set the message argument to the single string
  !
  subroutine copy_msg_char(m, c)
    type(submsg),  intent(inout) :: m     ! target message
    character(len=*), intent(in)    :: c     ! string to add to message

    if (m%num<=0) call resize_msg(m,-1)
    m%msg(1) = c
    m%num = 1
  end subroutine copy_msg_char

  !
  ! -------- copy_msg_msg --------
  ! set the message argument to the source message
  !
  subroutine copy_msg_msg(m, mc)
    type(submsg),  intent(inout) :: m     ! target message
    type(submsg),  intent(in)    :: mc    ! source of strings to copy to message

    integer :: i    ! loop variable

    if (mc%num<=0) then
      if (m%num>0) m%num=0    ! gone
    else
      if (m%num<mc%num) call resize_msg(m,mc%num)
      do i=1,mc%num
        m%msg(i) = mc%msg(i)
      end do
      m%num = mc%num
    end if
  end subroutine copy_msg_msg

  !
  ! ------- line_msg -------
  ! return a single line in the msg
  !
  subroutine line_msg(m, i, line)
    type(submsg), intent(in)    :: m     ! target message
    integer,      intent(in)    :: i     ! desired line
    character(len=*),intent(inout) :: line  ! return line here

    integer :: n                     ! number of available lines
    character(len=nsubmsg) :: errmsg    ! errormsg

    n = max(0,m%num)
    if (i<=0 .or. i>n) then
      write(errmsg,'(a,i4,a,i4,a)') '?line_msg: index ',i,' is out of the fortran range [1:',n,']'
      line = errmsg
    else
      line = trim(m%msg(i))
    end if
  end subroutine line_msg

  !
  ! ------- write_msg -------
  ! write a message to a logical unit number
  !
  subroutine write_msg(m, n)
    type(submsg), intent(in) :: m     ! target message
    integer,      intent(in) :: n     ! logical unit number for write
    integer  :: i   ! loop variable

    if (m%num<=0) return
    do i = 1, m%num
      write(n,'(a)') trim(m%msg(i))
    end do
  end subroutine write_msg

  !
  ! ------- print_msg -------
  ! write a message using the print statment
  !
  subroutine print_msg(m)
    type(submsg), intent(in) :: m     ! target message
    integer  :: i   ! loop variable

    if (m%num<=0) return
    do i = 1, m%num
      print '(a)', trim(m%msg(i))
    end do
  end subroutine print_msg

  !
  ! ---------- get_defmsg() ----------
  ! returns a pointer to the default message
  !
  function get_defmsg() result(m)
    type(submsg), pointer :: m

    if (.not. igot) then
      allocate(default_msg)
      call new_msg(default_msg)
      igot = .true.
    end if
    m => default_msg
  end function get_defmsg

  !
  ! ---------- replace_defmsg() ----------
  ! replace the default message with the values in the argument
  !
  subroutine replace_defmsg(m) 
    type(submsg), intent(in) :: m

    if (.not. igot) then
      allocate(default_msg)
      call new_msg(default_msg)
      igot = .true.
    end if
    call clear_msg(default_msg)
    call copy_msg(default_msg,m)
  end subroutine replace_defmsg

end module submsg_mod


!
! =================================== C ============================
!
! C callable routines for getting to the default message returned by 
! get_defmsg() in submsg_mod.  The way to structure the C interface to
! your fortran code is as follows,
!   subroutine c_mycode(ier)
!     use submsg_mod
!
!     integer :: ier
!     type(submsg), pointer :: errmsg
!
!     errmsg => get_defmsg()
!     call mycode(errmsg, ier)
!   end subroutine c_mycode
!
! And then the C++ caller would
!   void do_mycode() {
!     int ier=0 ;
!     c_mycode(ier) ;
!     if (ier!=0) c_print_defmsg() ;   // or construct an error message and throw an exception
!   } ;
!
! ---- c_clear_defmsg ---
! extern "C" void F77NAME(c_clear_defmsg)() ;
!
! clear out the default message
!
subroutine c_clear_defmsg
  use submsg_mod
  implicit none
  type(submsg),pointer :: d    ! default message

  d => get_defmsg()
  call clear_msg(d)
end subroutine c_clear_defmsg

!
! ---- c_print_defmsg ---
! extern "C" void F77NAME(c_print_defmsg)() ;
!
! print out the default message
!
subroutine c_print_defmsg
  use submsg_mod
  implicit none
  type(submsg),pointer :: d    ! default message

  d => get_defmsg()
  call print_msg(d)
end subroutine c_print_defmsg

!
! ---- c_size_defmsg ----
! extern "C" int F77NAME(c_size_defmsg)() ;
!
! return the logical size of the default message
!
function c_size_defmsg() result(n)
  use submsg_mod
  implicit none
  integer :: n                 ! size of the default
  type(submsg),pointer :: d    ! default message

  d => get_defmsg()
  n = size_msg(d)
end function c_size_defmsg

!
! ---- c_size_line ----
! extern "C" int F77NAME(c_size_line)() ;
!
! return the maximum line size nsubmsg
!
function c_size_line() result(n)
  use submsg_mod
  implicit none
  integer :: n                 ! size of the default
  n = nsubmsg
end function c_size_line

!
! ----- c_resize_defmsg ----
! extern "C" void F77NAME(c_resize_defmsg)(int*) ;
!
! resize the default message, see resize_msg() subroutine
!
subroutine c_resize_defmsg(ns)
  use submsg_mod
  implicit none
  integer :: ns                        ! ns>=0  -> new size of the storage
                                       ! ns<0   -> need at least |ns| free spaces
  type(submsg),pointer :: d            ! default message

  d => get_defmsg()
  call resize_msg(d, ns)
end subroutine c_resize_defmsg

!
! ----- c_trim_defmsg ----
! extern "C" void F77NAME(c_trim_defmsg)(int*) ;
!
! remove lines from the default message
!
subroutine c_trim_defmsg(ns)
  use submsg_mod
  implicit none
  integer :: ns                        ! number of lines to remove
  type(submsg),pointer :: d            ! default message

  d => get_defmsg()
  call trim_msg(d, ns)
end subroutine c_trim_defmsg


!
! ----- c_line_defmsg ----
! extern "C" void F77NAME(c_line_defmsg)(int*, int*, char*) ;
!
! fetch the i'th line in the default message -- uses "C" indexing !!!
!
subroutine c_line_defmsg(i, n, c)
  use submsg_mod
  implicit none
#include "fpreproc/byte_declare.h"
  integer       :: i       ! C index of line which is desired
  integer       :: n       ! size of character buffer not including end 0, must be >0
  BYTE_DECLARE  :: c(*)    ! will contain null terminated string on output

  character(len=nsubmsg)  :: p     ! buffer
  type(submsg),pointer :: d     ! default message

  if (n<=0) return

  d => get_defmsg()
  call line_msg(d,i+1,p)
  call cstr_2C(trim(p(1:n)), c, "2C")
end subroutine c_line_defmsg

!
! ---- c_add_defmsg ---
! extern "C" void F77NAME(c_add_defmsg)(char*) ;
!
! add a null terminated character string to the default message
!
subroutine c_add_defmsg(c)
  use submsg_mod
  implicit none
#include "fpreproc/byte_declare.h"
  BYTE_DECLARE :: c(*)    ! will contain null terminated string on output

  character(len=nsubmsg)  :: p     ! buffer
  type(submsg),pointer :: d     ! default message

  call cstring(p,c,"2F")

  d => get_defmsg()
  call add_msg(d,p)
end subroutine c_add_defmsg

C---------------------------------------------------------------------
C  UJUNK - CHECK LOGICAL NAME FOR A JUNK FILE DIRECTORY
C
      SUBROUTINE UJUNK(ZLNAME,ZAREA,IER)
c
#ifdef __NAGWARE
      use f90_unix_env
#endif
c
C  ZLNAME (INPUT)  LOGICAL NAME POINTING TO "JUNK AREA"
C    WHERE TEMPORARY FILES MAY BE WRITTEN
C
C  ZAREA (OUTPUT)  IF ENVIRONMENT NAME IS DEFINED,
C    THE STRING "name_translation/" IS RETURNED; OTHERWISE "/tmp/"
C    IS RETURNED
C
C  OUTPUT:
C  IER = 0  -- LOGICAL NAME IS DEFINED, RETURNED
C  IER = 1  -- "SYS$LOGIN:" RETURNED
C  IER = 3 OR 4  LENGTH ERROR IN OUTPUT STRING ZAREA
C
      CHARACTER*(*) ZLNAME
      CHARACTER*(*) ZAREA
C
      CHARACTER*80 ZBUFF
C
C--------------------------------
C
      ILNAME=len_trim(ZLNAME)
C
      ILAREA=LEN(ZAREA)
C
      ZAREA=' '
C
      ier=0
      call sget_env(zlname,zbuff)
      ilen=len_trim(zbuff)
 
      ilname = ilen
      IF(ilname.eq.0) THEN
         IER=1
         if(ilarea.ge.5) then
            zarea(ilarea-4:ilarea)='/tmp/'
         else
            ier=4
         endif
      else
         IF(ILAREA.GT.ilname) THEN
            ILAM9=ILAREA-ilname
            ZAREA(ILAM9:ILAREA)=zbuff(1:ilname)//'/'
         ELSE
            IER=4
         ENDIF
      ENDIF
 
 1000 CONTINUE
      RETURN
      END

!
! --------- alphabeta_to_thetaphi----------
! This is the formula that should be used for ITER. NOTE: called in expert files
! NOTE: consider deleting this
!
subroutine alphabeta_to_thetaphi(zalpha, zbeta, ztheta, zphi)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: rad2deg
  implicit none

  real(fp), intent(in)  :: zalpha, zbeta  ! xpoldeg,xtordeg as input to namelist
  real(fp), intent(out) :: ztheta, zphi   ! xpoldeg,xtordeg as input to floatinbeam(2),floatinbeam(1) 

  ztheta = rad2deg * asin(cos(zbeta/rad2deg)*sin(zalpha/rad2deg))
  zphi   = rad2deg * (-atan(tan(zbeta/rad2deg)/cos(zalpha/rad2deg)))

  return
end subroutine alphabeta_to_thetaphi

!
! --------- thetaphi_to_alphabeta ----------
! This does the inverse of the conversion of xpoldeg,xtordeg as done for ITER
! So it allows constructing the alpha,beta needed given the desired theta, phi.
! NOTE: consider deleting this
!
subroutine thetaphi_to_alphabeta(ztheta, zphi, zalpha, zbeta)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: rad2deg, zero, one, two
  implicit none

  real(fp), intent(in)  :: ztheta, zphi   ! xpoldeg,xtordeg as input to floatinbeam(2),floatinbeam(1) 
  real(fp), intent(out) :: zalpha, zbeta  ! xpoldeg,xtordeg as input to namelist

  zalpha = rad2deg * acos(cos(ztheta/rad2deg)/sqrt(one+(tan(zphi/rad2deg)*sin(ztheta/rad2deg))**two))
  if (ztheta<zero) zalpha=-zalpha

  zbeta  = rad2deg * (-atan(cos(zalpha/rad2deg)*tan(zphi/rad2deg)))

  return
end subroutine thetaphi_to_alphabeta

!
! ---------- psangle_to_thetaphi ---------
! go from plasma state aiming angles to theta and phi desired by torbeam
!
subroutine psangle_to_thetaphi(ztheta_ec, zphi_ec, ztheta, zphi)
  use iso_c_binding, only: fp => c_double
  implicit none

  real(fp), intent(in)  :: ztheta_ec, zphi_ec  ! plasma state aiming angles
  real(fp), intent(out) :: ztheta, zphi        ! xpoldeg,xtordeg as input to floatinbeam(2),floatinbeam(1) 

  ztheta = ztheta_ec - 90._fp
  zphi   = -zphi_ec  + 180._fp

  if (zphi>270._fp) zphi=zphi-360._fp

  return
end subroutine psangle_to_thetaphi

!
! ---------- thetaphi_to_psangle ----------
! go from torbeam theta and phi to plasma state aiming angles
subroutine thetaphi_to_psangle(ztheta, zphi, ztheta_ec, zphi_ec)
  use iso_c_binding, only: fp => c_double
  implicit none

  real(fp), intent(in)  :: ztheta, zphi        ! xpoldeg,xtordeg as input to floatinbeam(2),floatinbeam(1) 
  real(fp), intent(out) :: ztheta_ec, zphi_ec  ! plasma state aiming angles

  ztheta_ec = ztheta + 90._fp
  zphi_ec   = -zphi  +180._fp

  if (zphi_ec>270._fp) zphi_ec=zphi_ec-360._fp

  return
end subroutine thetaphi_to_psangle

!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  CHECK
      SUBROUTINE R4_CHECK(
     > R4_X,R4_Y)

      external CHECK

! argument declarations
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CHECK -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CHECK -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CHECK -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CHECK -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  CHECK

      CALL CHECK(
     > X_act(1),Y_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  DSPLAY
      SUBROUTINE R4_DSPLAY(
     > R4_X,R4_Y)

      external DSPLAY

! argument declarations
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_DSPLAY -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_DSPLAY -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_DSPLAY -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_DSPLAY -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  DSPLAY

      CALL DSPLAY(
     > X_act(1),Y_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGDSPL
      SUBROUTINE R4_AGDSPL(
     > R4_X,R4_Y)

      external AGDSPL

! argument declarations
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGDSPL -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGDSPL -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGDSPL -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGDSPL -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  AGDSPL

      CALL AGDSPL(
     > X_act(1),Y_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGMNMX
      SUBROUTINE R4_AGMNMX(
     > R4_ARRAY,R4_AMIN,R4_AMAX,NPTA,ITYPE)

      external AGMNMX

! argument declarations
 ! floating type, input/output:
      REAL R4_AMIN
  
 ! floating type, input/output:
      REAL R4_AMAX
  
      INTEGER NPTA
      INTEGER ITYPE
 ! floating type, input/output:
      REAL R4_ARRAY(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: ARRAY_act(:)
      REAL, allocatable :: ARRAY_ref(:)
      REAL :: AMIN_act
      REAL :: AMIN_ref
      REAL :: AMAX_act
      REAL :: AMAX_ref

! allocation of working arrays...

      dim=size(R4_ARRAY)
      ALLOCATE(ARRAY_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGMNMX -- ARRAY_act ALLOCATE error!')
      ALLOCATE(ARRAY_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGMNMX -- ARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      ARRAY_act=R4_ARRAY
      ARRAY_ref=R4_ARRAY

      AMIN_act=R4_AMIN
      AMIN_ref=R4_AMIN

      AMAX_act=R4_AMAX
      AMAX_ref=R4_AMAX

! call to original routine:  AGMNMX

      CALL AGMNMX(
     > ARRAY_act(1),AMIN_act,AMAX_act,NPTA,ITYPE)
      go to 100

!-------------------------------------------------------

      ENTRY R4_mnmx(R4_array,R4_amin,R4_amax)

! allocation of working arrays...

      dim=size(R4_ARRAY)
      ALLOCATE(ARRAY_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGMNMX -- ARRAY_act ALLOCATE error!')
      ALLOCATE(ARRAY_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGMNMX -- ARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      ARRAY_act=R4_ARRAY
      ARRAY_ref=R4_ARRAY

      AMIN_act=R4_AMIN
      AMIN_ref=R4_AMIN

      AMAX_act=R4_AMAX
      AMAX_ref=R4_AMAX

! call to original routine:  AGMNMX

      CALL MNMX(
     > ARRAY_act(1),AMIN_act,AMAX_act)

!----------------------------------------------------------------------
! copy back outputs if modified.
 100     continue
      where(ARRAY_act.ne.ARRAY_ref)
         R4_ARRAY = ARRAY_act
      end where
      DEALLOCATE(ARRAY_act)
      DEALLOCATE(ARRAY_ref)

      if(AMIN_act.ne.AMIN_ref) then
         R4_AMIN = AMIN_act
      endif

      if(AMAX_act.ne.AMAX_ref) then
         R4_AMAX = AMAX_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  CPLOT
      SUBROUTINE R4_CPLOT(
     > R4_X,R4_Y)

      external CPLOT

! argument declarations
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CPLOT -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CPLOT -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CPLOT -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_CPLOT -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  CPLOT

      CALL CPLOT(
     > X_act(1),Y_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGKEYS
      SUBROUTINE R4_AGKEYS(
     > R4_X,R4_Y,IFASTX,IFASTY,LIMIT)

      external AGKEYS

! argument declarations
      INTEGER IFASTX
      INTEGER IFASTY
      INTEGER LIMIT
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGKEYS -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGKEYS -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGKEYS -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGKEYS -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

! call to original routine:  AGKEYS

      CALL AGKEYS(
     > X_act(1),Y_act(1),IFASTX,IFASTY,LIMIT)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------

C-----------------------------------------------------------------------
C  UPROMTX -- DO PROMPTING OUTPUT, WITH REVERSE VIDEO IF FLAG IS SET
C
      SUBROUTINE UPROMTX(ZBUFF,ILENP)
C
      USE USERIO
C
      CHARACTER*(*) ZBUFF	  ! STRING TO USE FOR PROMPTING
C
      INTEGER ILENP		  ! PASSED LENGTH (IF .GT. 0)
C
C
      character*12 zfmt,zadvance
C--------------------------------------
C
      ILEN=LEN(ZBUFF)
      IF((ILENP.GT.0).AND.(ILENP.LT.ILEN)) ILEN=ILENP
C
C  REVERSE VIDEO OPTION
C
      ICHNG=0
      IF(NLRVID) CALL UTKSET(VIDCHS(1:NVIDCH),ICHNG)
C
CXX      if(nl1lin) then
CXX         zadvance="NO"
CXX      else
CXX         zadvance="YES"
CXX      endif
C
C  dmc: zadvance="NO" -- too many portability problems...
C
      zadvance="YES"            ! always
C
      zfmt = '(A)'
C
      WRITE(LUNTRM,zfmt,ADVANCE=zadvance) ZBUFF(1:ILEN)
      call fort_flush(luntrm)
C
      IF(NLRVID) then
         CALL UTKSET('N',ICHNG)
CXX         if(zadvance.eq.'NO') write(luntrm,'(1x)',ADVANCE="NO")
      endif
C
      RETURN
      END

      subroutine ubi3dcod(ilbuf,istart,ivalue)
C
C  decode a 3 byte sequence as an integer, hi order bits first
C
      implicit NONE
C
      integer ivalue
 
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(*)
 
      integer istart,ibyte(3)
C
      integer ict,is
C
      ict=0
      do is=istart,istart+2
         ict=ict+1
#if __CRAY || __SX
         if(ichar(ilbuf(is)).lt.0) then
            ibyte(ict)=256+ichar(ilbuf(is))
         else
            ibyte(ict)=ichar(ilbuf(is))
         endif
#else
         if(ilbuf(is).lt.0) then
            ibyte(ict)=256+ilbuf(is)
         else
            ibyte(ict)=ilbuf(is)
         endif
#endif
      enddo
C
      ivalue=256*(256*ibyte(1)+ibyte(2))+ibyte(3)
C
      return
      end

C******************** START FILE GRFUF1.FOR ; GROUP GRFUF1 *************
C  dmc 11 Aug 1994
C   plot the bloated coordinate system used in TRANSP / fast ion code
C   pass the moments arrays; expend them here
C
      SUBROUTINE GRFASYM(rcx,ycx,mtbl,mimom,lcentr,jmax,nmom
     >      ,XUN,YUN,LBL1,LBL2,LBL3)
C
C  DATA:
      REAL rcx(mtbl,0:mimom,2),ycx(mtbl,0:mimom,2)
      integer mtbl,mimom,lcentr,jmax,nmom
C
C  LABELS:
      CHARACTER*(*) XUN,YUN,LBL1,LBL2,LBL3
C
C  CONTROL:
      INTEGER IMENU
C
C  IF IMENU=1 JUMP DIRECTLY TO REPLOT MENU (DO NOT DRAW GRAPH 1ST)
C
      integer icounter,ict
      character*15 zext
C
C  local arrays for contours plotted
C
      parameter(icmax=250)
      parameter(nthmax=50)
      real zrlocl(icmax),zylocl(icmax)
      integer, save :: iopcod=0
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      DATA IMENU/0/
C
C--------------------------------------------------------------
C
      icounter=0
C-------------------------------------------------------------
C  SCALE SET SWITCHE CLEARED:
C
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
C
      CALL GAXGDF(ISEL)
C
      IF(IMENU.EQ.1) GO TO 200
C
C----------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
      ict=1
      call zxpnd_grfasym(rcx,ycx,mtbl,mimom,jmax,nmom,
     >        zrlocl,zylocl,icmax)
C
      N=icmax
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(zrlocl,zylocl,zylocl,0,N)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(zrlocl,N,zylocl,zylocl,0,N,1,1,1,1,N,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD) ! AXIS (LOG/LIN) CHECK
C
      CALL GSCREC  ! RECORD PLOT SCALE IN MEMORY
C
      CALL DPLOT1(zrlocl,zylocl,N,ICOD) ! DRAW GRID AND F(X) CURVE
      do j=jmax-1,lcentr+1,-1
         ict=ict+1
         call zxpnd_grfasym(rcx,ycx,mtbl,mimom,j,nmom,
     >           zrlocl,zylocl,N)
         call dplot1(zrlocl,zylocl,N,1)
      enddo
C
      N2=jmax-lcentr+1
      ict=0
      do ith=1,nthmax
         zth=float(ith-1)*6.283185/float(nthmax)
         call zxpn2_grfasym(rcx,ycx,mtbl,mimom,lcentr,jmax,nmom,
     >            zth,zrlocl,zylocl,N2)
         call dplot1(zrlocl,zylocl,N2,1)
      enddo
C
      CALL GRALBL(XUN,YUN,LBL1,LBL2,LBL3)  ! LABEL THE PLOT
C
      CALL UPAUST(2)  ! PAUSE AFTER PLOT
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SA',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         RETURN
      ENDIF
C
      CALL UERMSI(' ?GRFASYM *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      contains
         subroutine make_zext(zpre)
         character*(*), intent(in) :: zpre

         zext=' '
         if(ict.le.9) then
            write(zext,'(a,I1)') trim(zpre),ict
         else if(ict.le.99) then
            write(zext,'(a,I2)') trim(zpre),ict
         else if(ict.le.999) then
            write(zext,'(a,I3)') trim(zpre),ict
         else if(ict.le.9999) then
            write(zext,'(a,I4)') trim(zpre),ict
         else if(ict.le.99999) then
            write(zext,'(a,I5)') trim(zpre),ict
         else if(ict.le.999999) then
            write(zext,'(a,I6)') trim(zpre),ict
         endif

         end subroutine make_zext

      END
c---------------
      subroutine zxpnd_grfasym(rcx,ycx,mtbl,mimom,isurf,nmom,
     >    zr,zy,N)
      real rcx(mtbl,0:mimom,2),ycx(mtbl,0:mimom,2)
      real zr(N),zy(N)
c
      real zsn(100),zcs(100)
c
      do ith=1,N
         zth=float(ith-1)*6.283185/float(N-1)
         call sincos(zth,nmom,zsn,zcs)
         zr(ith)=rcx(isurf,0,1)
         zy(ith)=ycx(isurf,0,1)
         do im=1,nmom
            zr(ith)=zr(ith)+rcx(isurf,im,1)*zcs(im)+
     >                        rcx(isurf,im,2)*zsn(im)
            zy(ith)=zy(ith)+ycx(isurf,im,1)*zcs(im)+
     >                        ycx(isurf,im,2)*zsn(im)
         enddo
      enddo
c
      return
      end
c
      subroutine zxpn2_grfasym(rcx,ycx,mtbl,mimom,lcentr,jmax,nmom,
     >    zth,zr,zy,N)
      real rcx(mtbl,0:mimom,2),ycx(mtbl,0:mimom,2)
      real zr(N),zy(N)
c
      real zsn(100),zcs(100)
c
      call sincos(zth,nmom,zsn,zcs)
c
      do isurf=lcentr,jmax
         ind=isurf-lcentr+1
         zr(ind)=rcx(isurf,0,1)
         zy(ind)=ycx(isurf,0,1)
         do im=1,nmom
            zr(ind)=zr(ind)+rcx(isurf,im,1)*zcs(im)+
     >                        rcx(isurf,im,2)*zsn(im)
            zy(ind)=zy(ind)+ycx(isurf,im,1)*zcs(im)+
     >                        ycx(isurf,im,2)*zsn(im)
         enddo
      enddo
c
      return
      end

c  communication block between sgvgds and sgiof
c
	integer iovgds	!vgds code: 0=not called, 1=file, 2=tty
c			!3=file+tty
	integer typdc	!char typed by user to upause
	integer lgdsk	!length of gdsdsk
	character gdsdsk*64	!disk name constructed by agvgds
	integer lxnam
	character xpndsk*124	!expanded file name
	integer lxtrm	!length of xpntrm
	character xpntrm*16	!translated terminal name
	common /gds_com/ iovgds,typdc,lgdsk,lxnam,lxtrm
     >		,gdsdsk,xpndsk,xpntrm
cdec$	psect /gds_com/ noshr
c
c  communication block between sgvgds and vgds server
c
	character myterm*8,user*12
	integer   ipid, nd
	common /gds_lis/ nd,ipid,myterm,user !
cdec$	psect /gds_lis/ noshr

C******************** START FILE FPOLAR.FOR ; GROUP TKBNDRY ******************
C.....................................................................
C  REV DMC -- REMOVED TRANSP COMMON
C   SO I CAN USE THIS IN RPLOT
C
C  REV BB / MAY 94 -- USE ATAN2 INSTEAD OF ATAN TO EVALUATE FPOLAR
C
C   output in range [0,twopi] instead of range [-pi,pi]
C   atan2 and fpolar are the same in the upper half plane; fpolar
C   is twopi greater in the lower half plane.
C
      REAL FUNCTION FPOLAR ( ZR77, ZZ77 )
C
C	CALC. THE POLAR ANGLE DEFINED BY TAN(THETA)=ZZ77/ZR77
C
      DATA TWOPI/6.2831853071795862E+00/
      DATA PI/3.1415926535897931E+00/
C
C--------------------------------------------
C
      if (zz77 .ge. 0.0) then
C
C  upper half plane  --  including z=0 line
C
       IF (ZR77 .NE. 0.) THEN
C
          FPOLAR = ATAN2 ( ZZ77 , ZR77 )
C
       ELSE
C
C  on the vertical axis, at or above the z=0 line
C
        FPOLAR = PI*0.5
C
       END IF
C
      else
C
C  lower half plane  --  excluding z=0 line
C
          FPOLAR = ATAN2 ( ZZ77 , ZR77 ) + TWOPI
C
      endif
C
      RETURN
      END
C******************** END FILE FPOLAR.FOR ; GROUP TKBNDRY ******************

subroutine urd_setprog(zprognam)

  ! set UREAD program name

  use urd_progmod
  implicit NONE

  character*(*), intent(in) :: zprognam

  !--------------------------

  progname = zprognam
  call ulower(progname)  ! enforce lower case letters

end subroutine urd_setprog

      subroutine ufmds_3rd(icode,znode,zf,nf1,nf2,nz,zx,zy,zz,
     >           nxact,nyact,nzact,iflag,ier)
C
C---------------------------------
C History:
C 02/07/01 CAL
C
C  icode = 1: get size only
C        = 2: read 3d array with dimensions
C        = 3: read dimensions only
C  return error code ier, 0 = normal
C
C------------------------------
      use UFILES
      implicit none
 
C Input:
      integer       icode
      character*(*) znode
      integer       nf1,nf2,nz
      real          zf(nf1,nf2,nz)
      real          zx(*), zy(*), zz(*)
      integer       iflag
C Output
      integer       nxact,nyact,nzact
      integer       ier
C
      character*128 zerrmsg
C
      integer       mds_value
      integer       idescr_floatarr, iretl
      integer       istat,  iln, ilm
      integer       idims(3),        ntot
C
C----------------------------------
C
 
      ier=0
C     iln=max(1,len_trim(znode))
      iln=index(znode,' ')-1
      if (iln .le. 0) iln=len(znode)
C
      if (icode .eq. 1) then
C Get size of dimensions
         call ufmds_size(znode(1:iln),1,nxact,ier)
         if(ier.ne.0) go to 9000
         call ufmds_size(znode(1:iln),2,nyact,ier)
         if(ier.ne.0) go to 9000
         call ufmds_size(znode(1:iln),3,nzact,ier)
         if(ier.ne.0) go to 9000
         return
      else
C
C Read 3D array
C
         if (iflag .ne. 1) then
            idims(1)=nxact
            idims(2)=nyact
            idims(3)=nzact
            istat=mds_value(znode(1:iln),
     >           idescr_floatarr(zf,idims,3),iretl)
 
            if(istat.ne.1) then
               call ufmds_err('UFMDS_3RD',istat,ier,zerrmsg,ilm)
               write(ufelun,9510) znode(1:iln),zerrmsg(1:ilm)
               ier=1
               return
 9510          format('  reading MDS+ signal data: ',a/2x,a)
            endif
         endif
C
C Read Dimensions
C
         call ufmds_read('dim_of('//znode(1:iln)//',0)',zx,nxact,
     1	   ier)
         if(ier.ne.0) go to 9000
         call ufmds_read('dim_of('//znode(1:iln)//',1)',zy,nyact,
     1	   ier)
         if(ier.ne.0) go to 9000
         call ufmds_read('dim_of('//znode(1:iln)//',2)',zz,nzact,
     1	   ier)
         if(ier.ne.0) go to 9000
      endif
C
      return
C
 9000 ier=1
      return
      end

      subroutine uf_fin(lun,signam,device,date,iproc,ier)
 
C Add date/device and write
C 10/19/01 CAL
C
      implicit none
      integer ilnurd   ! VAXONLY
C
      integer       lun          ! lun for error messages
      character*(*) signam
      character*(*) device, date
      integer       iproc
      integer       ier
 
C For MDSplus
      integer       mds_create_node
      integer       MdsPut,  MdsValue, idescr_long
      integer       dsc, idescr_cstring
      character*90  expr
      integer       mdsstat, stat, size, l
 
C-------------------------------------------------------------------
      ier = 0
 
C Create DEVICE
      stat=mds_create_node(signam//':DEVICE',
     >     'text')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then  ! TreeALREADY_THERE
            call mdsmsg(lun,'?uf_fin: '//signam//
     >           ':DEVICE create status:  ',stat)
            ier=1
            go to 9000
         endif
      endif
 
C Add DEVICE
      stat=MdsPut(signam//':DEVICE'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(device),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?uf_fin: put '//signam//':DEVICE - stat:  ',stat)
      end if
C Create PROC_CODE
      stat=mds_create_node(signam//':PROC_CODE',
     >     'numeric')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then  ! TreeALREADY_THERE
            call mdsmsg(lun,'?uf_fin: '//signam//
     >           ':PROC_CODE create status:  ',stat)
            ier=1
            go to 9000
         endif
      endif
C Add PROC_CODE
      stat=MdsPut(signam//':PROC_CODE'//CHAR(0),'$'//CHAR(0),
     >     idescr_long(iproc),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?uf_fin: put PROC_CODE - stat:  ',stat)
      end if
 
C
C Create DATE
      stat=mds_create_node(signam//':DATE','text')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then ! TreeALREADY_THERE
            call mdsmsg(lun,'?uf_fin: '//signam//
     >           ':DATE create status:  ',stat)
            ier=1
            go to 9000
         endif
      endif
C Write DATE
      stat=MdsPut(signam//':DATE'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(date),0 ,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?uf_fin: put '//signam//':DATE - stat:  ',stat)
      end if
 
C
C Write/close tree
C
 9000 continue
      expr = 'tcl("WRITE")' // CHAR(0)
      l=ilnurd(expr)
      print*, '...',expr(1:l)
      dsc = idescr_long(mdsstat)
      stat = MdsValue(expr, dsc, 0, size)
      if(mod(mdsstat,2).ne.1) go to 9001
      expr = 'tcl("CLOSE")' // CHAR(0)
      l=ilnurd(expr)
      print*, '...',expr(1:l)
      dsc = idescr_long(mdsstat)
      stat = MdsValue(expr, dsc, 0, size)
      if(mod(mdsstat,2).ne.1) go to 9001
      return
 
 9001 ier = 1
      call mdsmsg(lun,
     >     '?uf_fin: '//signam//' write/close - stat:  ',stat)
      return
      end

C******************** START FILE IUFSLO.FOR ; GROUP UFILS0 ******************
C----------------------------------------------------------
C  IUFSLO
C  LOCATE ALPHABETIC POSITION OF KEYWORD IN LIST
C
      INTEGER FUNCTION IUFSLO(ZKEY,LISLEN,ZLIST,IORDER,IEQ)
      INTEGER IORDER(LISLEN)
      CHARACTER*10 ZKEY
      CHARACTER*30 ZLIST(LISLEN)
C
C  ZKEY-- KEYWORD (10 CHARS) WHOSE ORDER IS TO BE LOCATED
C  ZLIST-- LIST OF KEYWORDS IS IN FIRST COL. OF ZLIST
C  IORDER-- ALPHABETIC ORDER OF ZLIST
C  LISLEN-- LENGTH OF LIST,IORDER
C
C  IEQ-- OUTPUT FLAG-- IEQ=1 IF ZKEY = ZLIST(IORDER(ILOC))
C    OTHERWISE SHOULD BE INSERTED BEFORE THE INDICATED ELEMENT
C    TO MAINTAIN ALPHABETIC ORDER
C  UTILIZE BINARY SEARCH ALGORITHM
C  ASSUME THAT ZKEY=ZLIST(J) FOR SOME J NOT POSSIBLE
C  (CHECK AGAINST SCALAR KEYWORD DUPLICATION IS PROVIDED IN
C  SUBROUTINE UF0RDR FOR UFILES FILES)
C
C  USE INTEGER SUBFUNCTION IUFORD(KEY1,KEY2)
C   =0  IF KEY1=KEY2
C   =-1 IF KEY1<KEY2
C   =+1 IF KEY1>KEY2
C
C
C  CHECK IF ENTRY GOES AT END OF LIST
      IEQ=0
      IUFSLO=LISLEN+1
      IOL=IUFORD(ZKEY,ZLIST(IORDER(LISLEN)))
C  SEE IF GOES AT END OF LIST
      IF(IOL.GT.0) GO TO 8000
      IMID=LISLEN
      IF(IOL.EQ.0) GO TO 500
C
C  BINARY SEARCH TO LOCATE ENTRY BEFORE WHICH TO INSERT ZKEY
C
      ITOP=1
      IBOT=LISLEN
C
 110  CONTINUE
      IMID=(ITOP+IBOT)/2
      IOL=IUFORD(ZKEY,ZLIST(IORDER(IMID)))
      IF(IOL.EQ.0) GO TO 500
      IF(IOL.LT.0) THEN
C  ZKEY GOES HIGHER IN LIST
        IBOT=IMID
C  DONE?
        IF(IBOT.EQ.ITOP) GO TO 200
      ELSE
C  ZKEY GOES LOWER IN LIST
        ITOP=IMID+1
      ENDIF
      GO TO 110
C  POSITION LOCATED
 200  CONTINUE
      IUFSLO=ITOP
      RETURN
C  POSITION LOCATED-- ZKEY IS A DUPLICATE
 500  CONTINUE
      IUFSLO=IMID
      IEQ=1
8000  CONTINUE
      RETURN
      END
C******************** END FILE IUFSLO.FOR ; GROUP UFILS0 ******************

C******************** START FILE GFCTRS.FOR ; GROUP GRFLBL ******************
C--------------------------------------------------------------
C  GFCTRS - CTR A STR  E.G. "XXX  " OR "  XXX" BECOME " XXX "
C   SPECIFY A PASSED LENGTH OR USE THE STRING LENGTH IF DEFAULTED
C
      SUBROUTINE GFCTRS(STR,ILEN)
      CHARACTER*(*) STR
C
      IF(ILEN.LE.0) THEN
        IL=LEN(STR)
      ELSE
        IL=MIN0(LEN(STR),ILEN)
      ENDIF
C
      DO IC=1,IL
        IF(STR(IC:IC).NE.' ') GO TO 10
      ENDDO
      RETURN
C
 10   CONTINUE
      I1=IC
      DO IC=IL,I1,-1
        IF(STR(IC:IC).NE.' ') GO TO 20
      ENDDO
 20   CONTINUE
C
      I2=IC
      INUM=I2-I1+1
C
      IMARG=(IL-INUM)/2
C
      I1NEW=1+IMARG
C
      IF(I1.EQ.I1NEW) RETURN
      IDIF=I1-I1NEW
C
      IF(IDIF.GT.0) THEN
        DO IC=I1NEW,IL
          IOLD=IC+IDIF
          IF(IOLD.GT.IL) THEN
            STR(IC:IC)=' '
          ELSE
            STR(IC:IC)=STR(IOLD:IOLD)
          ENDIF
        ENDDO
      ELSE
        DO IC=I1NEW+INUM-1,1,-1
          IOLD=IC+IDIF
          IF(IOLD.LE.0) THEN
            STR(IC:IC)=' '
          ELSE
            STR(IC:IC)=STR(IOLD:IOLD)
          ENDIF
        ENDDO
      ENDIF
C
      RETURN
      END
C******************** END FILE GFCTRS.FOR ; GROUP GRFLBL ******************

C******************** START FILE LBLCMP.FOR ; GROUP UFILES ******************
C-----------------------------------------------------------
C  LBLCMP
C  LOGICAL FUNCTION
C  COMPARE TWO 30 CHARACTER LABELS
C  RETURN .TRUE. IF THEY ARE THE SAME
C
      LOGICAL FUNCTION LBLCMP(ZLAB1,ZLAB2)
      CHARACTER*30 ZLAB1,ZLAB2
C
CX	LBLCMP=.FALSE.
CX	IF(ZLAB1.EQ.ZLAB2) LBLCMP=.TRUE.
      LBLCMP=(ZLAB1.EQ.ZLAB2)
      RETURN
      END
C******************** END FILE LBLCMP.FOR ; GROUP UFILES ******************

C******************** START FILE UTRAHD.FOR ; GROUP URDUTS ******************
C---------------------------------------------------------------
C& UTRAHD  ECHO TYPEAHEAD BUFFER STACK ELEMENT J
C
      SUBROUTINE UTRAHD(ZBUFF)
C
      CHARACTER*(*) ZBUFF
C
      ILEN=LEN(ZBUFF)
      DO 10 IC=ILEN,1,-1
        IF(ZBUFF(IC:IC).NE.' ') GO TO 20
 10   CONTINUE
C  NO TYPEAHEAD HERE
      RETURN
C
 20   CONTINUE
      IF(IC.LE.50) THEN
        WRITE(LNOUT(0),1000) ZBUFF(1:IC)
      ELSE
        WRITE(LNOUT(0),1001) ZBUFF(1:IC)
      ENDIF
C
 1000 FORMAT(' [TYPEAHEAD PENDING:  ',A,']')
 1001 FORMAT(' [TYPEAHEAD PENDING:  '/2X,A,']')
C
      RETURN
      END
C******************** END FILE UTRAHD.FOR ; GROUP URDUTS ******************

c
c RGA: the lines with '#' followed by '@' are script comments scanned by trman
c
C Create_pulse
c
C#@! Fortran Subroutine -- Create an MDS Pulse
c
c#@usage create_pulse(mds_server,mds_socket,mds_tree,mds_shot,runid,device,nshot,year,stat)
c
c#@arg mds_server mdsplus server already opened
c#@arg mds_socket socket connection or -1 for local
c#@arg mds_tree   name of mdsplus tree
c#@arg mds_shot   pulse number
c#@arg runid      runid
c#@arg device     tokamak
c#@arg nshot      shot number
c#@arg year       er, year
c#@arg stat       returned stat value
c#@begin
c
c     22May2007    jim.conboy@jet.uk
c     ifdef __JET 
c          Dont add Ufiles to the output tree, if it is named TRJOB 
c          [ JET data is in separate TRDATA tree, created by local 
c            web application                                      ]
c-------------------------------------------------------------------

      subroutine create_pulse(mds_server,mds_socket,mds_tree,
     >           mds_shot,runid,device,nshot,year,stat)
      implicit none
      integer ilnurd   ! VAXONLY
 
 
      character*(*)  mds_server
      integer        mds_socket
      character*(*)  mds_tree
      integer        mds_shot
      character*(*)  runid
      character*(*)  device
      integer        nshot
      integer        year
      integer        stat
 
      integer        genex_tcl
C MDSplus
      integer        MdsValue, MdsPut, idescr_long, idescr_cstring
      integer        MdsSetSocket,      dsc,         mdsstat
C Local
      character*64  mds_path
      character*100 expr
      character*10  cshot
      integer       size
      integer       ierr, l, lp, ld
      character*7   devyr
      integer       lun
      character*12  code, zenv
      character*2   zy
      integer       option
C---------------------------------------------------------------
      lun = 6
      option=0
C Check if ierr = 77 = steering: add only Namelist and Ufiles
      if (stat .eq. 77) then
         stat=0
         option=2
         print*,'%create_pulse: steering'
         goto 1000
      endif

C#@! Add Source_Shot
      call mds_wr_source_shot(device,nshot,stat)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?create_pulse: put SOURCE_SHOT - stat:  ',stat)
      end if
      print *,'create pulse: did source_shot'
C#@! Add Shot_Idate
      stat=MdsPut('SHOT_IDATE'//CHAR(0),'$'//CHAR(0),
     >     idescr_long(year),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?create_pulse: put SHOT_IDATE - stat:  ',stat)
      end if
 
C#@! Add RUNID
      stat=MdsPut('RUNID'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(runid),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?create_pulse: put RUNID - stat:  ',stat)
      end if
 
C#@! Add NAME_OF_CODE
c#@use env $TRANSP_MDSPLUS set this to BEAST to have the name of the code be TRANSP-BEAST
      call sget_env('TRANSP_MDSPLUS',zenv)
      if(zenv.eq.'BEAST') then
         code = 'TRANSP-BEAST'
         l=12
      else
         code = 'TRANSP'
         l=6
      endif
      stat=MdsPut('NAME_OF_CODE'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(code(1:l)),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?create_pulse: put NAME_OF_CODE - stat:  ',stat)
      end if
      print*,'call ',DEVICE 
C#@! Add DEVICE
      stat=MdsPut('DEVICE'//CHAR(0),'$'//CHAR(0),
     >     idescr_cstring(device),0,size)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,
     >        '?create_pulse: put DEVICE - stat:  ',stat)
      end if
C
      ld=index(device,' ')-1
      if (ld .lt. 0) ld=len(device)
      write(devyr,'(a,".",i2.2)',iostat=ierr) device(1:ld),year
      ld=ld+3
      print*,devyr(1:ld)
 
C
C#@! Add Miscellaneous, filled in from add_inf() includes DATE_BEGAN, USER_ID, COMMENT
c#@! add EXPERT_CODE file
c#@call add_inf lun runid ierr
c#@use file @{$5}TR.INF read to get date, user, comment if it exists
c#@use file @{$5}CC.TMP comment file from tr_start.pl
c#@call add_file lun $5 EXPERT_CODE 0 ier1
c#@use file @{$5}EX.FOR expert code file if it exists
C ------------------
c
 1000  continue
          print *,' Call add_inf(',runid,')'
          call add_inf(lun,runid,ierr)
          if(ierr .ne. 0) then
              print *,'Error adding comment, etc...'
          endif
c
C#@! Add NameList
c#@call add_file lun $5 NAME_LIST $1 $3 $4 <path> ierr
c#@use file @{$5}TR.DAT namelist file
C#@! <path> = PPPL@<tok.yr>@<runid> for BIRCH else .INPUTS
c#@! replace namelist variables with mdsplus pointers to @{$1},@{$3},@{$4}, and <path>
c
          if (mds_server .eq. 'BIRCH.PPPL.GOV' .and.
     >        mds_tree .eq. 'TRANSP') then
             mds_path='PPPL@'//devyr(1:ld)//'@'//runid
          else
             mds_path='.INPUTS'
          endif
          lp=index(mds_path,' ')-1
          if (lp .lt. 0) lp=len(mds_path)
          call add_file(lun,runid,'NAME_LIST',mds_server,
     >    mds_tree,mds_shot,mds_path(1:lp),ierr)
          if(ierr .ne. 0) then
              print *,'?create_pulse: Error adding NAME_LIST'
              stat=0
              return
          endif
c
C#@! Add Ufiles unless the @{$3}==TRLOOK_*
C#@call add_ufnodes lun $5 $2 $3 $4 %6 ierr
C#@! ------------
C
#ifdef __JET
          if (mds_tree(1:5) .ne. 'TRJOB'  ) then
#else
          if (mds_tree(1:7) .ne. 'TRLOOK_') then
#endif
             print *,' Call add_ufnodes(',runid,')'
             call add_ufnodes(lun,runid,mds_socket,mds_tree,
     >            mds_shot,device,ierr)
C
C Check if need to add template namelist
             call add_tmplt(lun,runid, 1, ierr)
             if(ierr .ne. 0) then
                print *,'?create_pulse: Error adding template'
             endif
C
             if (mds_socket .gt. 0) stat = MdsSetSocket(mds_socket)
          else
             print *,'?create_pulse: add_ufnodes not called for '
     >              ,trim(mds_tree)
          endif
C
C#@! TCL(WRITE)
C#@modify tree $3
c
          expr = 'tcl("WRITE")' // CHAR(0)
          l=ilnurd(expr)
          print*, '...',expr(1:l)
          dsc = idescr_long(mdsstat)
          stat = MdsValue(expr, dsc, 0, size)
          if(mod(mdsstat,2).ne.1) go to 9001
          expr = 'tcl("CLOSE")' // CHAR(0)
          l=ilnurd(expr)
          print*, '...',expr(1:l)
          dsc = idescr_long(mdsstat)
          stat = MdsValue(expr, dsc, 0, size)
          if(mod(mdsstat,2).ne.1) go to 9001
          if (ierr .eq. 0) then
              stat=1
          else
              stat=0
          endif
 
      return
 
 9000 call mdsmsg(lun,'?create_pulse: '//expr(1:l)//
     >   ' mdsstat:  ',mdsstat)
      stat = 0
      return
 9001 call mdsmsg(lun,'?create_pulse: '//expr(1:l)//
     >   ' mdsstat:  ',mdsstat)
      stat = 0
      return
      end
 

C-----------------------------------------------------------------------
C  UAMODE -- UREAD SET TERMINAL INTO ALPHABETIC TEXT (VT100) MODE
C
      SUBROUTINE UAMODE
C
      USE USERIO
C
      CALL AGSALF
C
      RETURN
      END

C******************** START FILE UF2DRD.FOR ; GROUP UFILES ******************
C--------------------------------------------------------------
C  UF2DRD
C  READ 2-DIMENSIONAL DATA FROM ASCII FILE
C   ...dmc... adding MDS+ access capability ... 17 Dec 1998
C
 
      SUBROUTINE UF2DRD(ILUN,IDEV,ZSDATE,
     >     F,NF1,X,NX,Y,NY,IPROC,
     >     NXACT,NYACT,IFLAG,
     >     FLAB,XLAB,YLAB,
     >     NSCD,NSCA,SCVAL,SCLAB,
     >     IER)
 
 
C  Updated:
C  07/17/97 cal - Add HDF file option
C  08/24/93 tbt - Changed format to E13.6 - Call UFAHED2.
C
C*  ILUN-- FILE LOGICAL UNIT NUMBER
C   IDEV-- TOKAMAK DEVICE CODE (4 LETTERS E.G. "PLT ")
C  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
C  X(NX),F(NF1,NY),Y(NY)-- REAL NUMERIC DATA TO BE READ
C   ARRAYS AND DIMENSIONS
C  IPROC-- PROCESS CODE 0= RAW, 1 = AVERAGED
C   2= SMOOTHED, 3= AVERAGED AND SMOOTHED
C*   NX,NF1,NY ARE INPUT
C  NXACT,NYACT ARE THE ACTUAL DIMENSIONS OF THE
C  X AND Y ARRAYS IN THE FILE ***
C*  IFLAG:
C   ---> IF IFLAG=1 THE DATA IS READ CONSECUTIVELY INTO THE
C   F ARRAY; IF IFLAG .NE. 1, THE DATA IS READ BY
C   READ ((F(IJ,IK),IJ=1,NXACT),IK=1,NYACT)
C  XLAB-- 30 CHARACTER LABEL FOR X
C   FIRST 20 CHARACTERS-- NAME OF X
C   LAST 10 CHARACTERS--  PHYSICAL UNITS OF X
C     E.G. XLAB = 'MAJOR RADIUS        CM        '
C  FLAB-- 30 CHARACTER LABEL FOR F - SAME FORMAT AS XLAB
C  YLAB-- 30 CHARACTER LABEL FOR Y - SAME FORMAT AS XLAB
C
C*  NSCD-- SPACE ALLOCATED FOR ASSOCIATED SCALARS
C  NSCA-- RETURNED ACTUAL NUMBER OF SCALARS IN FILE
C    ** NOTE ** NSCD MAY = 0 IN WHICH CASE THESE ARE DUMMIES:
C  SCVAL-- LIST OF ASSOCIATED SCALAR VALUES READ
C  SCLAB-- LIST OF ASSOCIATED SCALAR KEYWORD/LABELS READ
C    FORMAT OF SCLAB: 30 CHARS, 10 CHAR KEYWORD BLOCK, 10 CHAR LABEL,
C      10 CHAR PHYS. UNITS-- SEE SUBROUTINE UF0WRT, FILE UFILS0.FOR
C
C  IER=0 ON RETURN IF READ WAS SUCCESSFUL
C
C* DENOTES INPUT VARIABLE
      USE UFILES
C
      REAL X(NX),F(NF1,NY),Y(NY),SCVAL(*)
      CHARACTER*10 ZSDATE,ZWDATE
      CHARACTER*30 XLAB,YLAB,FLAB,SCLAB(*)
      CHARACTER*4 IDEV
C
      character*128 znode
C
      CHARACTER*64 ERRSTR
 
      Integer IFORMAT
C
C$r8real_output: x,f,y,scval
C----------------------------------------------------------------------
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF2DRD    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.3) THEN
        CALL UERSTA(ICHAN,'UF2DRD    ')
        GO TO 9000
      ENDIF
C
C  SWITCH FOR COMPRESSED BINARY OR ASCII READ DETERMINED AT OPEN TIME
C
      KMPRS=UFCPRS(ICHAN)
C
      ERRSTR='HEADER DATA'
      if(KMPRS.eq.-1) then
         ikmprs=-1
C----------------------------------------
C  MDS+ data access
C
         call ufmds_rhdr(ichan,idev,zsdate,ishot,idim,znode,iln,
     >        iproc, ier)
         if(ier.eq.1) go to 9000
C
C----------------------------------------
      endif
C
      IF(KMPRS.EQ.0) THEN
        IKMPRS=0
        CALL UFAHED2(ILUN,ISHOT,IDEV,IDIM,KMPRS,ZWDATE,ZSDATE,0,
     1                 IFORMAT,IERH)
        IF(IERH.NE.0) GO TO 8999
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999)
     >      ISHOT,IDEV,IDIM,IKMPRS,ZWDATE,ZSDATE
        IF((UFILEV-10*(UFILEV/10)).GE.1) WRITE(UFELUN,8001) ZWDATE
 8001   FORMAT(' % READING 2D COMPRESSED BINARY DATA WRITTEN ',A)
      else if(kmprs.eq.2) then
        call ufbhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
        if(ierh.ne.0) go to 8999
C      else if(kmprs.eq.3) then
C        call uhdfhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
C        if(ierh.ne.0) go to 8999
      else if(kmprs.eq.4) then
        call ucdfhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
        if(ierh.ne.0) go to 8999
      ENDIF
C
      IF(KMPRS.NE.IKMPRS) THEN
        WRITE(UFELUN,9008) KMPRS,IKMPRS
 9008   FORMAT(' % UF2DRD INTERNAL FLAG ERROR KMPRS, IKMPRS =',
     >2(I2,1X))
      ENDIF
C
C  SHOT CHECK
C
      if(lshotn(ichan)) then
         IF(ISHOT.NE.UFSHOT(ICHAN)) THEN
            IF((UFILEV/10).GE.1)
     >          WRITE(UFELUN,9011) ISHOT,UFSHOT(ICHAN)
 9011       FORMAT(
     >  ' % SHOT NUMBER ',I6,' IN FILE NOT SAME AS SHOT NUMBER ',I6,
     >  ' IN FILENAME')
         ENDIF
      endif
C
C  DIMENSION CHECK
C
      IF(IDIM.NE.2) THEN
        WRITE(UFELUN,9010) IDIM
 9010   FORMAT(
     >  ' ? DIMENSIONALITY OF INPUT FILE = ',I1,' IS INCORRECT',
     >  ' FOR UF2DRD')
        IER=1
        GO TO 9000
      ENDIF
C
C    READ ASSOCIATED SCALAR QUANTITIES
      ERRSTR='ASSOCIATED SCALAR DATA'
      if (KMPRS.EQ.-1) then            ! MDSplus
         call ufmds_0rd(ICHAN,SCVAL,SCLAB,NSCD,NSCA,znode(1:iln),IER)
         IF(IER.NE.0) GO TO 8999
C      else if (KMPRS.EQ.3) then
C         call uhdf0r(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
C         IF(IER.NE.0) GO TO 8999
      else if (KMPRS.EQ. 4) then
         call ucdf0r(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
         IF(IER.NE.0) GO TO 8999
      else
         CALL UFNSRD(KMPRS,ILUN,NSCA,IERR)
         IF(IERR.NE.0) GO TO 8999
         IF(NSCA.GT.0) THEN
            CALL UF0RDR(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
            IF(IER.NE.0) GO TO 8999
         ENDIF
      end if
 
      if(nsca.gt.0) call ufsclab_ck(sclab,nsca)
C
      IF(NSCD.GT.0 .AND. NSCD.LT.NSCA) THEN
        WRITE(UFELUN,9052) NSCD,NSCA
 9052 FORMAT(' % UF2DRD WARNING-- INSUFFICIENT SPACE FOR SCALARS:'/
     >  '   SPACE ALLOCATED=',I3,' NEED:',I3/)
      ENDIF
C
      ERRSTR='DATA COORDINATE LABELS'
      if(kmprs.eq.-1) then
C----------------------------------------
C  MDS+ data access -- labels
C
         call ufmds_lbl(ichan,znode(1:iln),flab,1,znode(1:iln),ier)
         if(ier.ne.0) go to 9000
C
         call ufmds_lbl(ichan,'dim_of('//znode(1:iln)//',0)',xlab,0,
     1	'(dim 0)',ier)
         if(ier.ne.0) go to 9000
C
         call ufmds_lbl(ichan,'dim_of('//znode(1:iln)//',1)',ylab,0,
     1	'(dim 1)',ier)
         if(ier.ne.0) go to 9000
C
C----------------------------------------
      else IF(KMPRS.EQ.0) THEN
        READ(ILUN,3003,END=8999,ERR=8999) XLAB
 3003 FORMAT(1X,A30)
C
        READ(ILUN,3003,END=8999,ERR=8999) YLAB
C
        READ(ILUN,3003,END=8999,ERR=8999) FLAB
C
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999) XLAB,YLAB,FLAB
      else if(kmprs.eq.2) then
        call ubrchar(ilun,xlab,ier)
        if(ier.ne.0) go to 8999
        call ubrchar(ilun,ylab,ier)
        if(ier.ne.0) go to 8999
        call ubrchar(ilun,flab,ier)
        if(ier.ne.0) go to 8999
      ENDIF
C
      ERRSTR='DATA PROCESSING CODE + NUMBER OF POINTS'
      if(kmprs.eq.-1) then
         call ufmds_size2(znode(1:iln),f,nf1*ny,x,nx,
     1	nxact,nyact,iskip1,
     1	xlab,ier)
         if(ier.ne.0) go to 9000
      else IF(KMPRS.EQ.0) THEN
        READ(ILUN,3006,END=8999,ERR=8999) IPROC
 3006   FORMAT(1X,I1)
        READ(ILUN,3017,END=8999,ERR=8999) NXACT,NYACT
 3017   FORMAT(1X,I10/1X,I10)
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999) IPROC,NXACT,NYACT
      else if(kmprs.eq.2) then
        call ubr3int(ilun,iproc,ier)
        if(ier.ne.0) go to 8999
        call ubr3int(ilun,nxact,ier)
        if(ier.ne.0) go to 8999
        call ubr3int(ilun,nyact,ier)
        if(ier.ne.0) go to 8999
C      else if(kmprs .eq. 3) then
C         call uhdf2r(ilun,1,
C     &            f,nf1,x,nx,y,ny,iproc,
C     &            nxact, nyact, iflag,
C     &            flab,xlab,ylab,ier)
C         if(ier.ne.0) go to 8999
      else if(kmprs .eq. 4) then
         call ucdf2r(ilun,1,
     &            f,nf1,x,nx,y,ny,iproc,
     &            nxact, nyact, iflag,
     &            flab,xlab,ylab,ier)
         if(ier.ne.0) go to 8999
      ENDIF
C
C  CHECK FEASIBILITY OF DIMENSIONS
C  CHECK NXACT,NYACT INDIVIDUALLY
C
      IER=0
      IF(NX.LT.NXACT) THEN
        WRITE(UFELUN,9903) NX,NXACT
 9903   FORMAT(' ? UF2DRD - X ARRAY TOO SMALL:  SIZE=',I10,
     >       ' NEED=',I10)
        IER=1
      ENDIF
      IF(NY.LT.NYACT) THEN
        WRITE(UFELUN,9904) NY,NYACT
 9904   FORMAT(' ? UF2DRD - Y ARRAY TOO SMALL:  SIZE=',I10,
     >       ' NEED=',I10)
        IER=1
      ENDIF
C
      IF(IFLAG.NE.1) THEN
        IF(NF1.LT.NXACT) THEN
          WRITE(UFELUN,9905) NF1,NXACT
 9905     FORMAT(' ? UF2DRD - 1ST DIMENSION OF F ARRAY TOO SMALL'/
     >         '   SIZE = ',I10,' NEED = ',I10)
          IER=1
        ENDIF
C
      ELSE
        ITOTA=NF1*NY
        ITOTD=NXACT*NYACT
        IF(ITOTA.LT.ITOTD) THEN
          WRITE(UFELUN,9906) ITOTA,ITOTD
 9906     FORMAT(' ? UF2DRD - F ARRAY TOO SMALL'/
     >         '   TOTAL WORDS = ',I10,' NEED = ',I10)
          IER=1
        ENDIF
      ENDIF
C
      IF(IER.NE.0) THEN
C
        WRITE(UFELUN,9907)
 9907   FORMAT(
     >     /' ? UF2DRD - ARRAYS PROVIDED TOO SMALL FOR DATA REQUESTED'/)
        GO TO 9000
      ENDIF
C
      if(kmprs.eq.-1) then
C----------------------------------------
C  MDS+ data access
C
         call ufmds_read(znode(1:iln),f,nxact*nyact,ier)
         if(ier.ne.0) go to 9000
         if((iflag.ne.1).and.(nf1.gt.nxact)) then
            call ufmds_fmov(f,nxact,nyact,f,nf1)
         endif
C
         if(iskip1.ne.1) then
            call ufmds_read('dim_of('//znode(1:iln)//',0)',x,nxact,
     1	   ier)
            if(ier.ne.0) go to 9000
         endif
         call ufmds_read('dim_of('//znode(1:iln)//',1)',y,nyact,ier)
         if(ier.ne.0) go to 9000
C
C----------------------------------------
      else if(kmprs.eq.4) then         ! netCDF
         call ucdf2r(ilun,2,f,nf1,x,nx,y,ny,
     >                 iproc,nxact,nyact,iflag,
     >                 flab,xlab,ylab,ier)
         if(ier.ne.0) go to 8999
C      else if(kmprs.eq.3) then         ! HDF
C         call uhdf2r(ilun,2,f,nf1,x,nx,y,ny,
C     >                 iproc,nxact,nyact,iflag,
C     >                 flab,xlab,ylab,ier)
C         if(ier.ne.0) go to 8999
      else if(kmprs.eq.2) then
         call ubcprd(ilun,x,'x',nxact,1,1,nxact,1,ier)
         if(ier.ne.0) go to 8999
         call ubcprd(ilun,y,'y',nyact,1,1,nyact,1,ier)
         if(ier.ne.0) go to 8999
         if(iflag.eq.1) then
            inx1=nxact
         else
            inx1=nf1
         endif
         ERRSTR='DEPENDENT COORDINATE (F) DATA'
         call ubcprd(ilun,f,'f',inx1,nyact,1,nxact,nyact,ier)
         if(ier.ne.0) go to 8999
      else IF(KMPRS.EQ.1) THEN
C
C  READ COMPRESSED ARRAYS, DECOMPRESS, AND CONVERT TO REAL
        ERRSTR='INDEPENDENT COORDINATE (X) DATA'
        CALL UFCPRD(ILUN,X,NXACT,1,1,NXACT,1,IERR)
        IF(IERR.NE.0) GO TO 8999
C
        ERRSTR='INDEPENDENT COORDINATE (Y) DATA'
        CALL UFCPRD(ILUN,Y,NYACT,1,1,NYACT,1,IERR)
        IF(IERR.NE.0) GO TO 8999
C
        IF(IFLAG.EQ.1) THEN
          INX1=NXACT
        ELSE
          INX1=NF1
        ENDIF
        ERRSTR='DEPENDENT COORDINATE (F) DATA'
        CALL UFCPRD(ILUN,F,INX1,NYACT,1,NXACT,NYACT,IERR)
        IF(IERR.NE.0) GO TO 8999
C
      ELSE IF(KMPRS.EQ.0) THEN
C
C  READ UNCOMPRESSED DATA
          ErrStr = 'ASCII Data Format'
        if ((iformat.lt.0).or.(iformat.gt.1)) go to 8999
 
        ERRSTR='INDEPENDENT COORDINATE (X) DATA'
        if(iformat.eq.0) then
           READ(ILUN,3008,END=8999,ERR=8999) (X(IJ),IJ=1,NXACT)
        else
           call ufascio(ilun,x,nxact,'R',iend,ierr)
           if((iend.ne.0).or.(ierr.ne.0)) go to 8999
        endif
 
        ERRSTR='INDEPENDENT COORDINATE (Y) DATA'
        if(iformat.eq.0) then
           READ(ILUN,3008,END=8999,ERR=8999) (Y(IJ),IJ=1,NYACT)
        else
           call ufascio(ilun,y,nyact,'R',iend,ierr)
           if((iend.ne.0).or.(ierr.ne.0)) go to 8999
        endif
 
        ERRSTR='DEPENDENT COORDINATE (F) DATA'
        IF(IFLAG.NE.1) THEN
          if(iformat.eq.0) then
             READ(ILUN,3008,END=8999,ERR=8999)
     >             ((F(IJ,IK),IJ=1,NXACT),IK=1,NYACT)
          else
             call ufascio2(ilun,f,nf1,nxact,nyact,'R',iend,ierr)
             if((iend.ne.0).or.(ierr.ne.0)) go to 8999
          endif
 3008     FORMAT(6(1X,1PE11.4))       ! Old format
        ELSE
          CALL UF2RUT2(ILUN,F,ITOTD,Iformat,IERR)
          IF(IERR.NE.0) GO TO 8999
        ENDIF
      ENDIF
C
C  READ PAST DUMMY LINE AT END ("--END-OF-DATA--...")
      ERRSTR='TRAILER RECORD'
      IF(KMPRS.EQ.0) READ(ILUN,3099,END=8999,ERR=8999) IDUMMY
 3099 FORMAT(A1)
C
      UFSTAT(ICHAN)=5
      IER=0
      RETURN
C----------
C  ERRORS
C
 8999 CONTINUE
      WRITE(UFELUN,9899) ERRSTR
 9899 FORMAT(' ? *FATAL* END OF FILE OR READ ERROR ON UFILE READ:'/
     >    6X,A)
C
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ? DATA NOT READ DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      IER=1
      UFSTAT(ICHAN)=5
      RETURN
      	END
C------------------------------
C  move data from contiguous to non-contiguous storage -- carefully,
C  because usually fin and fout are the same arrays!
C
      subroutine ufmds_fmov(fin,nxin,ny,fout,nxout)
C
      real fin(nxin,ny),fout(nxout,ny)
C
C  work by looping down in row index, overwrite avoided because
C  "to address" is always bigger than "from address"
C
C  nxout.gt.nxin is assumed!
C
      do iy=ny,1,-1
         do ix=nxin,1,-1
            fout(ix,iy)=fin(ix,iy)
         enddo
      enddo
C
      do iy=1,ny
         do ix=nxin+1,nxout
            fout(ix,iy)=0.0
         enddo
      enddo
C
      return
      end
C******************** END FILE UF2DRD.FOR ; GROUP UFILES ******************

C***********************************************************************
      SUBROUTINE TERM_CHECK(MODEL,COMCHR)
C
C...This routine was written by Harry H. Towner of the Princeton
C...Plasma physics Lab.  This routine will check what model
C...the terminal is.
C
      CHARACTER MODEL*(*), COMCHR*(*), NAME*64
C
      INTEGER LEN
C
C...Check if TERMINAL_TYPE is assigned.
C
      CALL UTRNLOG(' ','TERMINAL_TYPE',NAME,LEN,ICODE)
C
C...If ICODE .EQ. 1 then terminal type has been defined.
C
      IF (ICODE .NE. 1) GO TO 2000
C
C...Check for command character.
C
      LCC = INDEX(NAME,'_')
      IF (LCC .GT. 0) THEN
C
C...Test that MODEL is less then 6 characters and that
C...COMCHR is only one character.
C
        LCCP1 = LCC + 1
        IF (LCC .GT. 7 .OR. LEN .GT. LCCP1) GO TO 2000
        MODEL = NAME(1:LCC-1)
        COMCHR = NAME(LCCP1:LEN)
      ELSE
C
C...Check that MODEL is less then 6 characters.
C
        IF (LEN .GT. 6) GO TO 2000
        MODEL = NAME(1:LEN)
      END IF
      RETURN
C
2000  MODEL = 'XTERM'
      COMCHR = ' '
      RETURN
      END

C******************** START FILE UPDISP.FOR ; GROUP USPARM ******************
C---------------------------
C&  UPDISP    DISPLAY UREAD STRING PARAMETERS ON TTY
C     (DEBUG-- TEMPORARY SUBROUTINE)
C
      SUBROUTINE UPDISP
C
      USE USERIO
C
      CALL NEUPAG
      WRITE(LUNTRM,2001)
 2001 FORMAT(/'  *** GLOBAL USER PARAMETERS ***'/)
      IF(NPGC.LE.0) GO TO 20
      WRITE(LUNTRM,2002)
 2002 FORMAT('  NAME             TRANSLATION'/
     >         '  ---------------- -------------------------------')
      DO 10 I=1,NPGC
      WRITE(LUNTRM,2003) PGLNAM(I),trim(PGLVAL(I))
 2003 FORMAT(2X,A16,1X,A)
 10   CONTINUE
C
      GO TO 50
C
 20   CONTINUE
      WRITE(LUNTRM,2004)
 2004 FORMAT(' NONE.'/)
C
C
 50   CONTINUE
      INLUN=MAX0(NLUNIN,NLUNIO)
      WRITE(LUNTRM,2005) INLUN
 2005 FORMAT(/'  ***  LOCAL USER PARAMETERS ***     LEVEL = ',I2/)
      ILPC=NPLC(MAX0(NLUNIN,NLUNIO))
      IF(ILPC.LE.0) GO TO 70
C
      WRITE(LUNTRM,2002)
      INLUN=MAX0(NLUNIN,NLUNIO)
      DO 60 I=1,ILPC
      WRITE(LUNTRM,2003) PLCNAM(I,INLUN),PLCVAL(I,INLUN)
 60   CONTINUE
C
      GO TO 100
C
 70   CONTINUE
      WRITE(LUNTRM,2004)
C
 100  CONTINUE
      WRITE(LUNTRM,2009)
 2009 FORMAT(/)
      CALL UPAUST(1)
      RETURN
      	END
C******************** END FILE UPDISP.FOR ; GROUP USPARM ******************

subroutine is_ascii(filename,iascii,ier)
 
  !  determine if a file is ascii
 
  character*(*), intent(in) :: filename
  integer, intent(out) :: iascii          ! =1: ascii, =0: no, =-1: error
  integer, intent(out) :: ier             ! =0: OK, otherwise "C" errno code.
 
  ! --------------------------
 
#include "fpreproc/byte_declare.h"
 
  byte_declare cfname(1+len(filename))
 
  ! --------------------------
 
  call cstring(filename(1:len_trim(filename)),cfname,'2C')
 
  call portlib_isascii(cfname,iascii,ier)   ! call the "C" routine to do it...
 
  return
 
end subroutine is_ascii

!
!  real*8 interface -- fusion -- sigma*v(Eb)
!
!  collection of functions for evaluating fusion reaction rate coefficients
!  sigma*v from pretabulated data -- mono-energetic beam hitting a
!  stationary target; beam energy is Eb, KeV.
!
!  for all functions:  input Eb, KeV
!  receive sigma*v, m**3/sec
!
!  **note** usually it is better to use the beam-target, thermonuclear,
!  or beam-beam gyro averaged tables!
!
!  **warning**
!  the following have the same reactivity
!     DT  --  D beam, T cold target  50 KeV D beam
!     TD  --  T beam, D cold target  75 KeV T beam
!  the energy is must be measured in the rest frame of the target!
!  (similar issue for D3/3D and T3/3T).
!
subroutine fusn_coldtarget_DDp(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_DDp, Eb, answer, n)
 
end subroutine fusn_coldtarget_DDp
!
subroutine fusn_coldtarget_DDn(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_DDn, Eb, answer, n)
 
end subroutine fusn_coldtarget_DDn
!
subroutine fusn_coldtarget_DT(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_DT, Eb, answer, n)
 
end subroutine fusn_coldtarget_DT
!
subroutine fusn_coldtarget_TD(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_TD, Eb, answer, n)
 
end subroutine fusn_coldtarget_TD
!
subroutine fusn_coldtarget_TT(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_TT, Eb, answer, n)
 
end subroutine fusn_coldtarget_TT
!
subroutine fusn_coldtarget_dpcTT(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_dpcTT, Eb, answer, n)
 
end subroutine fusn_coldtarget_dpcTT
!
subroutine fusn_coldtarget_D3(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_D3, Eb, answer, n)
 
end subroutine fusn_coldtarget_D3
!
subroutine fusn_coldtarget_3D(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_3D, Eb, answer, n)
 
end subroutine fusn_coldtarget_3D
!
subroutine fusn_coldtarget_T3(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_T3, Eb, answer, n)
 
end subroutine fusn_coldtarget_T3
!
subroutine fusn_coldtarget_3T(Eb,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: Eb(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_coldtarget_sigmatimesv(Lfs_3T, Eb, answer, n)
 
end subroutine fusn_coldtarget_3T

!
!  return preact "handles" for fusion codes.
!  caller can use handles to access preact calls; e.g. change policy
!  for out of rante table interpolation attempts
!
subroutine fusn_handle_DDp(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_DDp
end subroutine fusn_handle_DDp
 
subroutine fusn_handle_DDn(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_DDn
end subroutine fusn_handle_DDn
 
subroutine fusn_handle_DT(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_DT
end subroutine fusn_handle_DT
 
subroutine fusn_handle_TD(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_TD
end subroutine fusn_handle_TD
 
subroutine fusn_handle_TT(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_TT
end subroutine fusn_handle_TT
  
subroutine fusn_handle_dpcTT(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_dpcTT
end subroutine fusn_handle_dpcTT

subroutine fusn_handle_D3(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_D3
end subroutine fusn_handle_D3
 
subroutine fusn_handle_3D(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_3D
end subroutine fusn_handle_3D
 
subroutine fusn_handle_T3(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_T3
end subroutine fusn_handle_T3
 
subroutine fusn_handle_3T(ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(out) :: ihandle   ! preact handle for this reaction
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=Lfs_3T
end subroutine fusn_handle_3T

program fpreact_test
 
  ! test code for fpreact -- fortran interface to preact module
  ! this code tests a sampling of reaction tables; it  tests
  ! all tables
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: mp_Kg,qe_eV,zero,one
  use adas_mod
  use periodic_table_mod
  use fpreact_parameters

  implicit NONE
 
  ! note that the fpreact calls are generally vectorized, so we
  ! create vectors here -- even if only of length 1.
 
  integer, parameter  :: jZimp_lbound = 3 , jZimp_ubound = 74 !3 <= Z impurity <=74  and  58,59,60 has some  
                                                              !problems with neutral radiation numerics,
                                                              !so they are forbidden.
  integer  :: jZimp  ! Z for impurity
  
  integer i               ! loop variable 

  real(fp) enr8(1)          ! energy or energy/nucleon (KeV or KeV/AMU)
  real(fp) tr8(1)           ! temperature or T/nuclean (KeV or KeV/AMU)
  real(fp) ansr(1),ansrr(1)          ! result returned (usually <sigma*v>, m**3/sec)
  real(fp) var8(1)          ! variation parameter (for beam-beam fusion table)

  real(fp), dimension(:,:), allocatable :: rioniz8, rrecom8, rcoron8, rrad8 ! impurity rates 
 
  
  integer :: izbeam,iztarg
  integer ierr,ihandle,idum1,idum2
  integer, dimension(2) :: izimp =(/6,8/)        !SV reaction is available only for C+6, and O+8
  integer, dimension(3) :: izneut = (/1,2,3/)    !SV reaction. Neutrals are H0, He0 and LiO
  integer :: iimp,ineut
  real(fp) ranger8(2)
  real(fp) aa,aa1,aa2,aa3
  integer iz,ic
  real(fp) :: zz
  character*16 tmp_r8
  character(len=5) :: fusion_type
  iz=2
  aa=zero
  do iz=1,109
     write(*,*)'tr_species_convert ',iz 
     call tr_species_convert(iz,1,iz*2,aa,aa1,aa2,ic)
     call tr_species_convert(iz,1,int(aa2),aa,aa1,aa2,ic)
     zz= aa2/mp_Kg
     if(iz.eq.3) then 
        zz=6.9610_fp
        call tr_species_convert(iz,1,int(zz),aa,aa1,aa2,ic)
     endif
     call tr_species_convert(iz,1,zz,aa,aa1,aa3,ic)
     if(aa2.ne.aa3) write(*,*)'tr_species_convert',aa2/mp_Kg,aa3/mp_Kg
  enddo
  tmp_r8=to_periodic_table(3,6.88_fp,1,1)
  write(*,*)'to_pseudo_periodic_table ',tmp_r8
  tmp_r8=to_periodic_table(3,6.01_fp,1,1)
  write(*,*)'to_pseudo_periodic_table ',tmp_r8
  tmp_r8=to_pseudo_periodic_table(1,3,6.88_fp,1,1)
  write(*,*)'to_pseudo_periodic_table ',tmp_r8
  tmp_r8=to_pseudo_periodic_table(1,3,6.01_fp,1,1)
  write(*,*)'to_pseudo_periodic_table ',tmp_r8
  tmp_r8=to_pseudo_periodic_table(1,3,6.96_fp,1,1)
  write(*,*)'to_pseudo_periodic_table ',tmp_r8
  tmp_r8=to_pseudo_periodic_table(1,3,6.88_fp,1,1)
  write(*,*)'to_pseudo_periodic_table ',tmp_r8
  tmp_r8=to_pseudo_periodic_table(1,3,6.01_fp,1,1)
  write(*,*)'to_pseudo_periodic_table ',tmp_r8
  tmp_r8=to_pseudo_periodic_table(1,3,6.96_fp,1,1)
  write(*,*)'to_pseudo_periodic_table ',tmp_r8
 
  enr8 = 10.00_fp         ! KeV
  
  tr8 = 3.00_fp           ! KeV
  write(6,*) ' '
  write(6,*) ' -->fpreact_test:  atomic reaction tests...............'
  write(6,*) 'IMPURITY STOPPING CROSS_SECTION'
  !-------------------
  ! test: SV  impurity stopping cross-section
  !
 
 
  iimp=5
  do ineut=1,size(izneut)
     do iimp=jZimp_lbound, jZimp_ubound
        call zstop_sigv(izneut(ineut),iimp,enr8,1,ansr)
        call zstop_sigv(izneut(ineut),dble(iimp),enr8,1,ansrr)
        
        write(6,1001) izneut(ineut),iimp,enr8,ansr,ansrr
        call zstop_handle(ineut,iimp,ihandle)
        call sv_coldtarget_erange(ihandle,ranger8(1),ranger8(2),idum1,idum2)
     enddo
  enddo
1001 format(/ &
          ' ** impurity stopping sigma*v ** '/ &
          ' Z(neutral atom) = ',i1,' Z(impurity) = ',i2,' E/A = ',f10.2, &
          ' KeV/AMU'/ &
          ' -->real(fp) sigma*v = ',1pe20.13,/ &
          ' -->real(fp) sigma*v = ',1pe20.13 / )
1021 format(/ &
          ' ** impurity stopping table energy limits'/ &
          ' Z(neutral atom) = ',i1,' Z(impurity) = ',i2,' E/A_min = ',1pe20.13, &
          ' KeV/AMU'/ &
          ' E/A_max = ',1pe20.13, &
          ' KeV/AMU'/ )
  !-------------------
  ! test:  electron impact ionization
  !
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) 'ELECTRON IMPACT IONIZATION'
  do ineut=1,size(izneut)
     call sigvte_ioniz(izneut(ineut),tr8,1,ansr)
     
     write(6,1002) izneut(ineut),tr8,ansr

        call sigvte_ioniz_handle(izneut(ineut),ihandle)
        call ei_sigvte_trange(ihandle,ranger8(1),ranger8(2),idum1,idum2)
  enddo
  
1002 format(/ &
          ' ** electron impact ionization <sigma*v> ** '/ &
          ' Z(neutral atom) = ',i1,' electron temperature = ',f10.2,' KeV'/ &
          ' -->real(fp) <sigma*v> = ',1pe20.13)
 

 
2001 format(/' electron ionization Z=',i1,' table limits (Te, KeV):'/ &
          ' (preact ei_sigvte_trange call,  real(fp)):  ',2(1x,1pe20.13))

  !-------------------
  !-------------------
 
  enr8 = 100.00_fp         ! KeV (beam energy/nucleon)
  
  tr8 = 10.00_fp           ! KeV (target temperature/nucleon)
  
  !-------------------
  ! test:  impact ionization
  !
  write(6,*)' '
  write(6,*)' '
  write(6,*)'IMPACT IONIZATION NEUTRAL_BEAM '
  do ineut=1,size(izneut)
     do iimp=1,size(izneut)
        izbeam=ineut
        iztarg=iimp
        call hatom_btsigv(fpreact_II,fpreact_NEUTRAL_BEAM, &
             enr8,tr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_btsigv returned an error code!')
        
        write(6,1003) ' ** ion impact ionization <sigma*v> ** ', &
             izbeam,iztarg,enr8,tr8,ansr
           call hatom_handle(2,izbeam,iztarg,ihandle)
           call ii_warmtarget_erange(ihandle,ranger8(1),ranger8(2),idum1,idum2)
           call ii_coldtarget_erange(ihandle,ranger8(1),ranger8(2),idum1,idum2)
     enddo
  enddo
1023 format(/ &
          ' **  II warm target table energy limits'/ &
          ' Z(neutral atom) = ',i1,' Z(target) = ',i2,' E/A_min = ',1pe20.13, &
          ' KeV/AMU'/ &
          ' E/A_max = ',1pe20.13, &
          ' KeV/AMU'/ )
1024 format(/ &
          ' **  II cold target table energy limits'/ &
          ' Z(neutral atom) = ',i1,' Z(target) = ',i2,' E/A_min = ',1pe20.13, &
          ' KeV/AMU'/ &
          ' E/A_max = ',1pe20.13, &
          ' KeV/AMU'/ )

  write(6,*)' '
  write(6,*)' '
  write(6,*)'IMPACT IONIZATION ION_BEAM '
  do ineut=1,size(izneut)
     do iimp=1,size(izneut)
        izbeam=ineut
        iztarg=iimp
        call hatom_btsigv(fpreact_II,fpreact_ION_BEAM, &
             enr8,tr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_btsigv returned an error code!')
        
        write(6,1003) ' ** ion impact ionization <sigma*v> ** ', &
             izbeam,iztarg,enr8,tr8,ansr
     enddo
  enddo
     

  !-------------------
  ! test:  charge exchange rate coefficient
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE RATE COEFFICIENT NEUTRAL_BEAM'
  !
  do ineut=1,size(izneut)
     do iimp=1,ineut
        izbeam=ineut
        iztarg=iimp
 
        call hatom_btsigv(fpreact_CX,fpreact_NEUTRAL_BEAM, &
             enr8,tr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_btsigv returned an error code!')
        
        write(6,1003) ' ** charge exchange <sigma*v> ** ', &
             izbeam,iztarg,enr8,tr8,ansr
           call hatom_handle(1,izbeam,iztarg,ihandle)
           call cx_warmtarget_erange(ihandle,ranger8(1),ranger8(2),idum1,idum2)
           call cx_coldtarget_erange(ihandle,ranger8(1),ranger8(2),idum1,idum2)
     enddo
  enddo
1025 format(/ &
          ' **  CX warm target table energy limits'/ &
          ' Z(neutral atom) = ',i1,' Z(target) = ',i2,' E/A_min = ',1pe20.13, &
          ' KeV/AMU'/ &
          ' E/A_max = ',1pe20.13, &
          ' KeV/AMU'/ )
1026 format(/ &
          ' **  CX cold target table energy limits'/ &
          ' Z(neutral atom) = ',i1,' Z(target) = ',i2,' E/A_min = ',1pe20.13, &
          ' KeV/AMU'/ &
          ' E/A_max = ',1pe20.13, &
          ' KeV/AMU'/ )
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE RATE COEFFICIENT ION_BEAM'
  !
  do ineut=1,size(izneut)
     do iimp=1,ineut
        izbeam=iimp
        iztarg=ineut
 
        call hatom_btsigv(fpreact_CX,fpreact_ION_BEAM, &
             enr8,tr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_btsigv returned an error code!')
        
        write(6,1003) ' ** charge exchange <sigma*v> ** ', &
             izbeam,iztarg,enr8,tr8,ansr
     enddo
  enddo
  
  !-------------------
  ! test:  charge exchange Eav rate coefficient
  !
  
  
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE Eav RATE COEFFICIENT NEUTRAL_BEAM'
  do ineut=1,size(izneut)
     do iimp=1,ineut
        izbeam=ineut
        iztarg=iimp
        call hatom_btsigv(fpreact_EAV,fpreact_NEUTRAL_BEAM, &
             enr8,tr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_btsigv returned an error code!')
        
        write(6,1003) ' ** charge exchange <Eav> of target reagent ** ', &
             izbeam,iztarg,enr8,tr8,ansr
     enddo
  enddo
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE Eav RATE COEFFICIENT ION_BEAM'
  do ineut=1,size(izneut)
     do iimp=1,ineut
        izbeam=iimp
        iztarg=ineut
        call hatom_btsigv(fpreact_EAV,fpreact_ION_BEAM, &
             enr8,tr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_btsigv returned an error code!')
        
        write(6,1003) ' ** charge exchange <Eav> of target reagent ** ', &
             izbeam,iztarg,enr8,tr8,ansr
     enddo
  enddo
  
  !-------------------
  ! test:  charge exchange rate coefficient
  !
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE Fd RATE COEFFICIENT NEUTRAL_BEAM'
  do ineut=1,size(izneut)
     do iimp=1,ineut
        izbeam=ineut
        iztarg=iimp

        call hatom_btsigv(fpreact_FD,fpreact_NEUTRAL_BEAM, &
             enr8,tr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_btsigv returned an error code!')
        
        write(6,1003) ' ** charge exchange <fd> (normalized <vb.vtarg>) ** ', &
             izbeam,iztarg,enr8,tr8,ansr
     enddo
  enddo
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE Fd RATE COEFFICIENT ION_BEAM '
  do ineut=1,size(izneut)
     do iimp=1,ineut
        izbeam=iimp
        iztarg=ineut

        call hatom_btsigv(fpreact_FD,fpreact_ION_BEAM, &
             enr8,tr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_btsigv returned an error code!')
        
        write(6,1003) ' ** charge exchange <fd> (normalized <vb.vtarg>) ** ', &
             izbeam,iztarg,enr8,tr8,ansr
     enddo
  enddo
 
 1003 format(/,A,/ &
          ' Z(neutral beam) = ',i1,'  Z(target plasma) = ',i1/ &
          ' E(beam) = ',f10.2,' KeV/AMU;  T(target) = ',f10.2,' KeV/AMU'/ &
          ' -->real(fp) result = ',1pe20.13)
  
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE sigma*v  COEFFICIENT'
  do ineut=1,size(izneut)  !neutrals
     do iimp=1,ineut       !ion species
        izbeam=ineut
        iztarg=iimp

        call hatom_sigv(fpreact_CX,enr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_sigv returned an error code!')
        
        write(6,1013) ' ** charge exchange sigma*v (m**3/sec) **', &
             izbeam,iztarg,enr8,ansr
     enddo
  enddo
  write(6,*)' '
  write(6,*)' '
  write(6,*)' IMPACT IONIZATION sigma*v  COEFFICIENT'
  do ineut=1,size(izneut)  !neutrals
     do iimp=1,size(izneut)!ion species
        izbeam=ineut
        iztarg=iimp

        call hatom_sigv(fpreact_II,enr8,1,izbeam,iztarg, ansr,ierr)
        
        if(ierr.ne.0) call errmsg_exit(' ?hatom_sigv returned an error code!')
        
        write(6,1013) ' ** impact ionization  sigma*v (m**3/sec) **', &
             izbeam,iztarg,enr8,ansr
     enddo
  enddo
 
 1013 format(/,A,/ &
          ' Z(neutral beam) = ',i1,'  Z(ion species) = ',i1/ &
          ' E(beam) = ',f10.2,' KeV/AMU'/ &
          ' -->real(fp) result = ',1pe20.13)
   

 
 !-------------------
  ! test:  electron, H recombination
  !
  write(6,*)' '
  write(6,*)' '
  write(6,*)'ELECTRON H RECOMBINATION'

  call sigvte_reco(tr8,1,ansr)
 
  write(6,1004) tr8,ansr
1004 format(/ &
          ' ** <sigma*v> e-,H+ recombination, for Te = ',f10.2,' KeV:'/ &
          ' -->real(fp) result = ',1pe20.13)
  !-------------------
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) 'COLD TARGET  FUSION REACTION'
  !-------------------
  ! test:  COLD TARGET  fusion
  !  the following have the same reactivity
  !     DT  --  D beam, T cold target  50 KeV D beam
  !     TD  --  T beam, D cold target  75 KeV T beam
  !  the energy is must be measured in the rest frame of the target!
  !  (similar issue for D3/3D and T3/3T).
  ! 
  ! The results will be not the same but close to each other, because each reaction
  ! has own table. So it is matter of an interpolation.

  tr8=50.0_fp
  !  DT   -- DT fusion:  D beam, T target 
  fusion_type=' DT '
  call fusn_coldtarget_DT(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr
  
  !  TD   -- TD fusion:  T beam, D target 
  tr8=75.0_fp
  fusion_type=' TD '
  call fusn_coldtarget_TD(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr
  tr8=50.0_fp
 !  D3   -- D-He3 fusion:  D beam, He3 target
  fusion_type='DHe3'
  call fusn_coldtarget_D3(tr8,ansr,1)
   
  write(6,1015) fusion_type,tr8,ansr
  tr8=75.0_fp
 
  !  3D   -- He3-D fusion:  He3 beam, D target
  fusion_type='He3D'
  call fusn_coldtarget_3D(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr
  tr8=50.0_fp
  !  T3   -- T-He3 fusion:  D beam, T target
  fusion_type='THe3'
  call fusn_coldtarget_T3(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr
  
  !  3T   -- He3-T fusion:  T beam, T target
  fusion_type='He3T'
  call fusn_coldtarget_3T(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr
  
  !  DDp  -- DD fusion --> p,T
  fusion_type=' DDp'
  call fusn_coldtarget_DDp(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr
  
  !  DDn  -- DD fusion --> n,He3
  fusion_type=' DDn'
  call fusn_coldtarget_DDn(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr
  
  !  TT   -- TT fusion --> 2n,He4
  fusion_type=' TT '
  call fusn_coldtarget_TT(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr

  !  TT   -- TT fusion --> 2n,He4 DPC fit, 06/2018
  fusion_type='dpcTT '
  call fusn_coldtarget_dpcTT(tr8,ansr,1)
  
  write(6,1015) fusion_type,tr8,ansr
  
1015 format(/ &
          ' ** sigma*v[m**3/sec]',1x,a,1x,'cold target  fusion, beam energy = ',f10.2,' KeV:'/ &
          ' -->real(fp) result = ',1pe20.13)
  !-------------------
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) 'THERMONUCLEAR FUSION REACTION'
  !-------------------
  ! test:  thermonuclear fusion
  !    --thermonuclear rate coefficients (vs. Temperature) 


  !  DT   -- DT fusion:  D beam, T target 
  fusion_type=' DT '
  call fusn_thermo_DT(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  
  !  TD   -- TD fusion:  T beam, D target 
  fusion_type=' TD '
  call fusn_thermo_TD(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  
  !  DDp  -- DD fusion --> p,T
  fusion_type=' DDp'
  call fusn_thermo_DDp(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  
  !  DDn  -- DD fusion --> n,He3
  fusion_type=' DDn'
  call fusn_thermo_DDn(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  
  !  TT   -- TT fusion --> 2n,He4
  fusion_type=' TT '
  call fusn_thermo_TT(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr

   !  TT   -- TT fusion --> 2n,He4 DPC fit 06/2018
  fusion_type=' dpcTT '
  call fusn_thermo_dpcTT(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  
 
  !  D3   -- D-He3 fusion:  D beam, He3 target
  fusion_type='DHe3'
  call fusn_thermo_D3(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  
  !  3D   -- He3-D fusion:  He3 beam, D target
  fusion_type='He3D'
  call fusn_thermo_3D(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  !  T3   -- T-He3 fusion:  D beam, T target
  fusion_type='THe3'
  call fusn_thermo_T3(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  
  !  3T   -- He3-T fusion:  T beam, T target
  fusion_type='He3T'
  call fusn_thermo_3T(tr8,ansr,1)
  
  write(6,1005) fusion_type,tr8,ansr
  
1005 format(/ &
          ' ** <<sigma*v>> [m**3/sec]',1x,a,1x,'thermonuclear fusion, Ti = ',f10.2,' KeV:'/ &
          ' -->real(fp) result = ',1pe20.13)
  
  
  !-------------------
  ! test:  beam-target fusion
  !
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) 'BEAM-TARGET FUSION .'
  fusion_type=' DT '
  call fusn_btsigv_DT(enr8,tr8,ansr,1)
  
  write(6,1006) fusion_type,'D',enr8,'T',tr8,ansr
  
  fusion_type=' TD '
  call fusn_btsigv_TD(enr8,tr8,ansr,1)
  
  write(6,1006) fusion_type,'T',enr8,'D',tr8,ansr
  
  
  
  fusion_type=' DDp'
  call fusn_btsigv_DDp(enr8,tr8,ansr,1)
  
  write(6,1006) fusion_type,'D',enr8,'D',tr8,ansr
  
  
  fusion_type=' DDn'
  call fusn_btsigv_DDn(enr8,tr8,ansr,1)
  
  write(6,1006)  fusion_type,'D',enr8,'D',tr8,ansr
  
  fusion_type=' TT '
  
  call fusn_btsigv_TT(enr8,tr8,ansr,1)
  
  write(6,1006) fusion_type,'T',enr8,'T',tr8,ansr

  fusion_type='dpcTT ' !DPC fit, 06.2018
  
  call fusn_btsigv_dpcTT(enr8,tr8,ansr,1)
  
  write(6,1006) fusion_type,'T',enr8,'T',tr8,ansr
  
  fusion_type='DHe3'
  call fusn_btsigv_D3(enr8,tr8,ansr,1)
  
  write(6,1006) fusion_type,'D',enr8,'He3',tr8,ansr
 
  fusion_type='He3D'
  call fusn_btsigv_3D(enr8,tr8,ansr,1)
   
  write(6,1006) fusion_type,'He3',enr8,'D',tr8,ansr
  
  fusion_type='THe3'
  call fusn_btsigv_T3(enr8,tr8,ansr,1)
  
  write(6,1006) fusion_type,'T',enr8,'He3',tr8,ansr
  
  fusion_type='He3T'
  call fusn_btsigv_3T(enr8,tr8,ansr,1)
  
  write(6,1006) fusion_type,'He3',enr8,'T',tr8,ansr
 
 1006 format(/ &
          ' ** <sigma*v> ',1x,a,1x,' beam-target fusion **'/ &
          1x,a,1x,' beam energy = ',f10.2,'KeV',1x,a,1x,' target Ti = ',f10.2,' KeV:'/ &
          ' -->real(fp) result = ',1pe20.13)
 
  !-------------------
  ! test:  beam-beam fusion
  !
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) ' BEAM-BEAM FUSION '

  tr8=0.50_fp          !fractional beam energy variation in the target frame
  
  fusion_type=' DT '
  call fusn_bbsigv_DT(enr8,tr8,ansr,1)
  
  write(6,1007) fusion_type,'D',enr8,'T',tr8,ansr
  
!  fusion_type=' TD '
!  call fusn_bbsigv_TD(enr8,tr8,ansr,1)
!  write(6,1007) fusion_type,'T',enr8,'D',tr8,ansr
  

  fusion_type=' DDp'
  call fusn_bbsigv_DDp(enr8,tr8,ansr,1)
  
  write(6,1007) fusion_type,'D',enr8,'D',tr8,ansr
  
  
  fusion_type=' DDn'
  call fusn_bbsigv_DDn(enr8,tr8,ansr,1)

  write(6,1007)  fusion_type,'D',enr8,'D',tr8,ansr
  
  fusion_type=' TT '
  
  call fusn_bbsigv_TT(enr8,tr8,ansr,1)
  
  write(6,1007) fusion_type,'T',enr8,'T',tr8,ansr
  
  fusion_type='dpcTT ' !DPC fit, 06/2018
  
  call fusn_bbsigv_dpcTT(enr8,tr8,ansr,1)
  
  write(6,1007) fusion_type,'T',enr8,'T',tr8,ansr
  
  fusion_type='DHe3'
  call fusn_bbsigv_D3(enr8,tr8,ansr,1)
  
  write(6,1007) fusion_type,'D',enr8,'He3',tr8,ansr
  
!  fusion_type='He3D'
!  call fusn_bbsigv_3D(enr8,tr8,ansr,1)
  
!  write(6,1007) fusion_type,'He3',enr8,'D',tr8,ansr
  
  fusion_type='THe3'
  call fusn_bbsigv_T3(enr8,tr8,ansr,1)
  
  write(6,1007) fusion_type,'T',enr8,'He3',tr8,ansr
  
!  fusion_type='He3T'
!  call fusn_bbsigv_3T(enr8,tr8,ansr,1)
  
!  write(6,1007) fusion_type,'He3',enr8,'T',tr8,ansr
  
1007 format(/ &
          ' ** <<sigma*v>>',1x,a,1x,'beam-beam fusion **'/ &
          1x,a,1x,'beam energy = ',f10.2,'KeV',1x,a,1x,', variation fraction = ',f10.2,':'/ &
          ' -->real(fp) result = ',1pe20.13)
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) 'IMPURITY REACTION '
  
  ! ------------------
  ! test: impurity radiation rate
  !
  tr8(1)  = .1_fp        ! Te in keV
  var8(1) = 1.e19_fp     ! Ne in m-3
!  call imptable_def_brem(0) default
! -- ionization --
  do jZimp = jZimp_lbound, jZimp_ubound   !allowed range forZ impurity
     impurity: if( jZimp /= 58 .and. jZimp /= 59 .and.  jZimp /= 60) then 


        allocate( rioniz8(jZimp+1,1))
        allocate( rrecom8(jZimp+1,1))
        allocate( rcoron8(jZimp+1,1))
        allocate( rrad8(jZimp+1,1))
        call imptable_ioniz_r8(jZimp, 1, tr8, var8, jZimp+1, rioniz8)
        
        write(6,1101) ' ** <sigma*v*ne> Impurity ionization rate ' // &
             trim(name_pseudo_periodic_table(0,jZimp,0.)) // ' **',  &
             jZimp, tr8(1), var8(1)
        
        do i = 1, jZimp+1
           write(6,1102) (i-1), rioniz8(i,1)
        end do
        

! -- recombination --
        call imptable_recom_r8(jZimp, 1, tr8, var8, jZimp+1, rrecom8)
        
        write(6,1101) ' ** <sigma*v*ne> Impurity recombination rate ' // &
             trim(name_pseudo_periodic_table(0,jZimp,0.)) // ' **',  &
             jZimp, tr8(1), var8(1)
        
        do i = 1, jZimp+1
           write(6,1102) (i-1), rrecom8(i,1)
        end do
! -- bremsstrahlung --
        call imptable_brem_r8(jZimp, 1, tr8, var8, jZimp+1, rrad8)
        
        write(6,1101) ' ** <sigma*v*ne> Impurity bremsstrahlung ' // &
             trim(name_pseudo_periodic_table(0,jZimp,0.)) // ' **',  &
             jZimp, tr8(1), var8(1)
        
        do i = 1, jZimp+1
           write(6,1102) (i-1), rrad8(i,1)
        end do
        rrad8=zero
! -- radiation (no bremsstrahlung) --
        call imptable_rad_r8(jZimp, 1, tr8, var8, jZimp+1, rrad8)
        
        write(6,1101) ' ** <sigma*v*ne> Impurity radiation rate (no bremsstrahlung) ' // &
             trim(name_pseudo_periodic_table(0,jZimp,0.)) // ' **',  &
             jZimp, tr8(1), var8(1)
        
        do i = 1, jZimp+1
           write(6,1102) (i-1), rrad8(i,1)
        end do
        
        
! -- coronal equilibrium --
        call impreaction_coronal_r8(jZimp, 1, rioniz8, rrecom8, jZimp+1, rcoron8)
       
        write(6,1101) ' ** <sigma*v*ne> Impurity coronal equilibrium ' // &
             trim(name_pseudo_periodic_table(0,jZimp,0.)) // ' **',  &
             jZimp, tr8(1), var8(1)
        
        do i = 1, jZimp+1
           write(6,1102) (i-1), rcoron8(i,1)
        end do
! -- coronal equilibrium radiaiton --
        call impreaction_coronal_rad_r8(jZimp, 1, rcoron8, rrad8, jZimp+1, enr8)
        aa=zero
        write(6,1101) ' ** <sigma*v*ne> Impurity coronal equilibrium radiation (no bremsstrahlung) ' // &
             trim(name_pseudo_periodic_table(0,jZimp,aa)) // ' **',  &
             jZimp, tr8(1), var8(1)
        
        write(6,1103) enr8(1)
        
        write(6,'(//)') 

        deallocate( rioniz8 )
        deallocate( rrecom8 )
        deallocate( rcoron8 )
        deallocate( rrad8 )
        
!        call imptable_print(jZimp)
     else 
        write(6,'(//)') 
        write(6,*)' -->fpreact_test:  abnormal exit:  Z impurity out of range or .eq. forbidden numbers :58, 59, 60'
        
     endif impurity
  enddo
  
1101 format(/,A,/ &
          ' Z(impurity) = ',i2,'  Te = ',f10.2,' KeV',&
          '  Ne = ',es10.3, ' m-3')
  
1102 format(' charge = ',i2,' -->real(fp) result = ',1pe20.13,/12x)
1103 format(' -->real(fp) result = ',1pe20.13)

  aa=12.0107_fp
  tmp_r8=to_periodic_table(6,aa,-1,1)
  write(*,*) 'to periodic r8 ',tmp_r8
  call inv_periodic_table('C',    .true.,  iz, aa, ic)
  write(*,*) 'r8 ',iz, aa, ic
  tmp_r8= name_periodic_table (iz,aa)
  write(*,*) 'name r8 ',tmp_r8
  aa=one
  tmp_r8=to_pseudo_periodic_table(1,1,aa,-1,1)
 write(*,*) 'to pseudo periodic r8 ',tmp_r8
  
  call inv_pseudo_periodic_table(1,'H',    .true.,  iz, aa, ic)
  write(*,*) 'pseudo r8 ',iz, aa, ic
  call standard_amu(6,aa)
  write(*,*) 'r8 A=',aa
  iz=11.8
  write(*,*)'iz= ',iz
  iz=11.8+0.01_fp
  write(*,*)'iz= ',iz
  iz=11.8+0.5_fp
  write(*,*)'iz= ',iz
  iz=11.1
  write(*,*)'iz= ',iz
  iz=11.1+0.01_fp
  write(*,*)'iz= ',iz
  iz=11.1+0.5_fp
  write(*,*)'iz= ',iz
  call tr_species_convert(6,5,12,aa1,aa,aa2,ic)
  aa2=aa2/mp_Kg
  aa1=aa1/qe_eV
  aa=aa/qe_eV

  write(*,*)aa1,aa,aa2,ic
  call tr_species_convert(3,3,6,aa1,aa,aa2,ic)
  aa2=aa2/mp_Kg
  aa1=aa1/qe_eV
  aa=aa/qe_eV

  write(*,*)aa1,aa,aa2,ic
  
  
  
end program fpreact_test

!******************* START FILE TFUN_Z.FOR ; GROUP TESZIG *********************
!==============================================================================
!
!  EVALUATE VARIOUS MAXWELLIAN INTEGRALS
!
real(fp) FUNCTION TFUN_Z(W0,TI)
!
!------------------------------------------------------------------------------
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : zero,half,two,sqpi,VC,zm2tocm2 
  use sigtabl_mod, only : VCFAC,ifun,VI,T,B2
  IMPLICIT NONE
  INTEGER iter,nreact,kk,ierr,j
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) w0,ti,eps,tmass,bmass,c2,b,&
       vmin,vmax,anorm,fsvcx_z,ans,fsvii_z,fsvcxv_z,fsviiv_z,&
       fsvcxp_z
!
!  ** DMC ** JUNE 1989
!
!    IFUN=2 AND IFUN=3 ARE INTERCHANGEABLE -- SIGMA*V INTEGRAND
!    IFUN=4 AND IFUN=5 ARE INTERCHANGEABLE -- SIGMA*V*V**2 INTEGRAND
!    IFUN=6                                -- SIGMA*V*VX INTEGRAND
!
!    THIS ROUTINE IS PART OF THE SIGTAB PROGRAM; THE ATOMIC REACTION
!  UNDER CONSIDERATION IS NOW STORED IN SIGTAB COMMON; IFUN CONTROLS
!  ONLY THE TYPE OF INTEGRATION BEING DONE.  IFUN DOES *NOT* CONTROL
!  THE REACTION UNDER CONSIDERATION, THOUGH THIS IS LESS THAN OBVIOUS
!  FROM LOOKING AT THE CODE.
!
!    THE CODE STRUCTURE HERE IS RICH WITH HISTORY, AS THESE ROUTINES
!  USED TO BE PART OF THE OBSOLETE TESZIG PROGRAM.  HELIUM ATOMIC
!  PHYSICS HAS SINCE BEEN ADDED TO THE SYSTEM.  SEE SUBROUTINE
!  FSVGEN AND ITS CALLERS E.G. FSVCX AND FSVII WHICH NOW FUNCTION
!  EQUIVALENTLY.
!
!    CROSS-SECTIONS ARE NOW ULTIMATELY FOUND IN THE SUBROUTINE SIGALL
!  FROM THE SIGSUB SUBROUTINE LIBRARY ...
!------------------------------------------------------------------------------
  EXTERNAL FSVCX_Z,FSVII_Z,FSVCXV_Z,FSVIIV_Z,FSVCXP_Z
!
!------------------------------------------------------------------------------
  DATA EPS,ITER,NREACT,KK,IERR/3.e-5_fp,256,4,0,6/
  DATA TMASS,BMASS/938.2592e+3_fp,938.2592e+3_fp/
!
!------------------------------------------------------------------------------
!
  c2=VC*VC*zm2tocm2 
  VI=SQRT(two*C2*W0/TMASS)
  T=half*TMASS/C2
  B2=BMASS/(two*C2*TI)
  B=SQRT(B2)
  VMIN=zero
  VMAX=10.0_fp
  VCFAC=VMAX/(VI+13.42_fp/B)
  ANORM=B/(SQPI*VI)   / VCFAC
  TFUN_Z=zero
!
  IF(IFUN.GT.6) GO TO 5
!
  GO TO(5,200,300,400,500,600) IFUN
!      =================================
!..............
5 CONTINUE
  WRITE(6,10) IFUN
10 FORMAT(1X,'IMPROPER IFUN  IFUN=',I2)
  write(6,1009)
1009 FORMAT(/'  ?? (SIGSUB) ABORT subroutine called ...')
  call bad_exit
!..............
200 CALL GAUS6_Z(VMIN,VMAX,FSVCX_Z,ANS,EPS,ITER,J,IERR)
  TFUN_Z=TFUN_Z+ANS*ANORM
  RETURN
!..............
300 CALL GAUS6_Z(VMIN,VMAX,FSVII_Z,ANS,EPS,ITER,J,IERR)
  TFUN_Z=TFUN_Z+ANS*ANORM
  RETURN
!..............
400 CALL GAUS6_Z(VMIN,VMAX,FSVCXV_Z,ANS,EPS,ITER,J,IERR)
  TFUN_Z=TFUN_Z+ANS*ANORM
  RETURN
!..............
500 CALL GAUS6_Z(VMIN,VMAX,FSVIIV_Z,ANS,EPS,ITER,J,IERR)
  TFUN_Z=TFUN_Z+ANS*ANORM
  RETURN
!..............
600 CALL GAUS6_Z(VMIN,VMAX,FSVCXP_Z,ANS,EPS,ITER,J,IERR)
  TFUN_Z=TFUN_Z+ANS*ANORM
!..............
  RETURN
END FUNCTION TFUN_Z
!
!******************* END FILE TFUN_Z.FOR ; GROUP TESZIG ***********************
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C******************** START FILE CHXOUT.FOR ; GROUP URDUTS ******************
C----------------------------------
C&  CHXOUT  SET UREAD INFO/MENU DISPLAY OUTPUT FLAG
C
C  SET EXTRA (EXPLANATORY) OUTPUT FLAG
C   NLXOUT
C
C  SUCH OUTPUT SHOULD BE MADE BY CALLER PROGRAM TO HELP NOVICE
C  USER WHEN INPUT IS DIRECT
C
      SUBROUTINE CHXOUT
      USE USERIO
C
      NLXOUT=.FALSE.
      IF(((.NOT.NLINDI).OR.NLECHO).AND.(.NOT.NLXPER)) NLXOUT=.TRUE.
      RETURN
      	END
C******************** END FILE CHXOUT.FOR ; GROUP URDUTS ******************

C******************** START FILE GSCSPC.FOR ; GROUP GSCALE ******************
C-------------
C  GSCSPC
C   NON-INTERACTIVE SPECIFICATION OF SCALING DEFAULTS[
C
C  IAX=1:  X-AXIS SCALING;  IAX=2:  Y-AXIS SCALING
C   ISEL:  1,2,3,4, OR 5 TO SELECT OPTION AS IN SUBROUTINE GSCDEF
C    IF ISEL=3, ZARG1 AND ZARG2 ARE THE LOWER AND UPPER FIXED LIMITS
C    IF ISEL=4 OR 5, ZARG1 IS THE MULTIPLIER
C   FOR OTHER VALUES OF ISEL ZARG1 AND ZARG2 ARE IGNNORED
C
      SUBROUTINE GSCSPC(IAX,ISEL,ZARG1,ZARG2)
C
      INCLUDE 'GSCALE_BLK'
C
      IF(IGSINI.EQ.0) CALL GSCINI
C
      GO TO (100,200) IAX
C  X AXIS
 100  CONTINUE
      NOPTX=ISEL
      GO TO (500,500,110,120,120) ISEL
C
 110  CONTINUE
      XMIN00=ZARG1
      XMAX00=ZARG2
      GO TO 500
C
 120  CONTINUE
      XRAT00=ZARG1
      GO TO 500
C  Y AXIS
 200  CONTINUE
      NOPTY=ISEL
      GO TO (500,500,210,220,220) ISEL
C
 210  CONTINUE
      YMIN00=ZARG1
      YMAX00=ZARG2
      GO TO 500
C
 220  CONTINUE
      YRAT00=ZARG1
      GO TO 500
C----
C EXIT
 500  CONTINUE
      RETURN
      END
C******************** END FILE GSCSPC.FOR ; GROUP GSCALE ******************

subroutine ps_namel_strip(ifile,ps_tmpfile,luntmp,iout,ierr)

  ! strip comments from commented namelist
  !   commented namelist: ifile (to be read on luni)
  !   stripped namelist: ps_tmpfile (to be written on luntmp)

  ! The following are comments:  (a) strings to the right of the
  ! exclamation point "!" comment character (not imbedded in quotes);
  ! (b) lines that are all blank after "!" comments are stripped.

  !--------------
  ! arguments:

  character(len=*), intent(in) :: ifile ! file containing unstripped namelist.

  character(len=*), intent(in) :: ps_tmpfile ! file to contain stripped namelist.

  integer, intent(out) :: luntmp     ! I/O unit number OUTPUT of open
  !  file containing fortran-readable namelist

  integer, intent(in) :: iout        ! I/O unit for error messages
  integer, intent(out) :: ierr       ! status code (0=OK)

  !--------------
  ! local:

  character(len=150) :: buf
  character(len=200) :: my_tmpfile
  character(len=1), parameter :: squot = "'"
  character(len=1), parameter :: dquot = '"'
  character(len=1), parameter :: cchar = "!"
  character(len=1) :: cquot

  integer :: ic,icmt,ilnb,ilz
  integer :: luni

  !--------------
  !  MOD DMC: if input ps_tmpfile is blank, generate a temporary filename here
  !--------------

  if(ps_tmpfile.eq.' ') then
    call tmpfile('ps_namel_strip_',my_tmpfile,ilz)
  else
    my_tmpfile = ps_tmpfile
  endif

  luntmp=-1

  call find_io_unit(luni)
  open(unit=luni,file=ifile,status='old',iostat=ierr)
  if(ierr.ne.0) then
    write(iout,*) ' ?ps_namel_strip: namelist input file open failure.'
    write(iout,*) '  filename was: '//trim(ifile)
    return
  endif

  call find_io_unit(luntmp)
  open(unit=luntmp,file=trim(my_tmpfile),status='unknown',position='rewind',iostat=ierr)
  if(ierr.ne.0) then
    write(iout,*) ' ?ps_namel_strip: stripped namelist output file open failure.'
    write(iout,*) '  filename was: '//trim(my_tmpfile)
    return
  endif

  cquot=' '

  do 
    read(luni,'(A)',end=100) buf
    ilnb = len(trim(buf))
    if(ilnb.eq.0) cycle  ! all blank

    icmt=0
    do ic=1,ilnb
      if(cquot.ne.' ') then
        ! looking for closing quote
        if(buf(ic:ic).eq.cquot) then
          cquot=' '
        endif
        ! replace NULLs or other unprintables inside quotes
        if((ichar(buf(ic:ic)).lt.ichar(' ')).or. &
             (ichar(buf(ic:ic)).eq.127)) buf(ic:ic)=' '
      else
        ! looking for "!"
        if(buf(ic:ic).eq.cchar) then
          icmt=ic
          exit
        else if(buf(ic:ic).eq.squot) then
          cquot=squot
        else if(buf(ic:ic).eq.dquot) then
          cquot=dquot
        endif
      endif
    enddo

    if(icmt.gt.0) then
      buf(icmt:ilnb)=' '
      ilnb = len(trim(buf))
      if(ilnb.eq.0) cycle  ! all blank after removal of comment
    endif

    if(cquot.ne.' ') then
      ! insert closing quote
      ic=min(len(buf),ilnb+1)
      buf(ic:ic)=cquot
    endif
    write(luntmp,'(A)') buf(1:ilnb)
  enddo

100 continue

  close(unit=luni)

  rewind(unit=luntmp)   ! position this file to be read by caller...

  return
end subroutine ps_namel_strip

C******************** START FILE IDCOD.FOR ; GROUP URDUTS ******************
C-------------------------------
C&  IDCOD  UREAD INTEGER DECODE AND ERROR CHECK W/MESSAGE
C   FRONT FOR IDCODE -- CALL AFTER UREAD WITHOUT NEEDING TO
C  INCLUDE COMMON VARIABLES
C
      INTEGER FUNCTION IDCOD(IER)
C  IER - RETURN CODE .NE. 0 IF DECODING OF INTEGER FAILED
      USE USERIO
C
      IDCOD=IDCODE(DBUFF,IER)
      RETURN
      END
C******************** END FILE IDCOD.FOR ; GROUP URDUTS ******************

C******************** START FILE UFCLOS.FOR ; GROUP UFILES ******************
C--------------------------------------------------------
C  UFCLOS
C  CLOSE FILE ASSOCIATED WITH PASSED CHANNEL NUMBER
C
      SUBROUTINE UFCLOS(ILUN_IN)
C
      USE UFILES
c
#include "fpreproc/byte_declare.h"
C
C  CAL 28 May 2003:   If ILUN_IN < 0: disconnect from MDS
c                     should only be called if one is done with all Ufiles
c 
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
C
      integer ilun, ilun_in
c
c-----------------------------------------
c
      CALL UFINIT
      ilun = abs(ilun_in)
      CALL UFLCHK(ILUN,'UFCLOS    ',ICHAN,IER)
      IF(IER.NE.0) RETURN
      ISTAT=UFSTAT(ICHAN)
      IF(ISTAT.EQ.0) WRITE(UFELUN,9001) ILUN
 9001 FORMAT(' % UFCLOS: ATTEMPT TO CLOSE IMPROPERLY OPENED FILE:'/
     >  '   UNIT=',I5)
      IF(ISTAT.EQ.1) WRITE(UFELUN,9002) ILUN
 9002 FORMAT(' % UFCLOS: CLOSING FILE BEFORE DATA WRITE'/
     >  '   UNIT= ',I3)
C
      if(ufcprs(ichan).eq.2) then
C  flush output buffer
         if((istat.eq.1).or.(istat.eq.2)) then
            call ubcflush(ichan)
            call ubufo(uflun(ichan),uiobuf(1,ichan),niobuf(ichan),
     >                   uiobuf(1,ichan),0)
         endif
C
         call cftclose(uflun(ichan))
         go to 100
C
      else if(ufcprs(ichan).eq.4) then     ! netCDF
         call cdfclos(ufid(ichan))
         go to 100
      endif
C
      CLOSE(UNIT=ILUN,ERR=100)
 100  CONTINUE
C 
C check if should disconnect from MDS
      if (ilun_in .lt. 0 .and. mds_socket(ichan) .ne. 0) then
         write(ufelun,*)'%ufclos: disconnect ',mds_socket(ichan)
         istat = MdsSetSocket(mds_socket(ichan))
         Call MdsCacheDisconnect
         mds_socket(ichan)=0
      endif
      UFSTAT(ICHAN)=0
      mds_shot(ichan)=0
C  CLEAR COMPRESSED BINARY DATA WRITE FLAG
      if(ufcprs(ichan).gt.0) UFCPRS(ICHAN)=0
C
      RETURN
      	END
C******************** END FILE UFCLOS.FOR ; GROUP UFILES ******************

! real*8 interface generated by r8igen.csh --
! ...in /home/tshare/scratch/tshare/work/tmp/ufiles/src
! csh -f r8igen.csh r8_ufiles.for r8_ufiles.sub
!
! then **by hand** patched up SCVAL(*) args (dmc Jan 2003 -- TESTED). 
!
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  LARCMP
      LOGICAL FUNCTION R8_LARCMP(
     > R8_X1,NX1,R8_X2,NX2,R8_ZABS,R8_ZREL,IPT)
 
      external LARCMP
      LOGICAL LARCMP
 
! argument declarations
      INTEGER NX1
      INTEGER NX2
 ! floating type, input only:
      REAL*8 R8_ZABS
 
 ! floating type, input only:
      REAL*8 R8_ZREL
 
      INTEGER IPT
 ! floating type, input only:
      REAL*8 R8_X1(NX1)
 
 ! floating type, input only:
      REAL*8 R8_X2(NX2)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: X1_act(:)
      REAL, allocatable :: X2_act(:)
      REAL :: ZABS_act
      REAL :: ZREL_act
 
! allocation of working arrays...
 
      ALLOCATE(X1_act(NX1)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LARCMP -- X1_act ALLOCATE error!')
      ALLOCATE(X2_act(NX2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_LARCMP -- X2_act ALLOCATE error!')
 
! executable code:  copy for input
 
      X1_act=R8_X1
      X2_act=R8_X2
      ZABS_act=R8_ZABS
      ZREL_act=R8_ZREL
! call to original routine:  LARCMP
 
      R8_LARCMP=LARCMP(
     > X1_act(1),NX1,X2_act(1),NX2,ZABS_act,ZREL_act,IPT)
 
! copy back outputs if modified.
      DEALLOCATE(X1_act)
      DEALLOCATE(X2_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF0DRD
      SUBROUTINE R8_UF0DRD(
     > ILUN,IDEV,ZSDATE,R8_SCVAL,SCLAB,NDIM,NSC,IER)
 
      external UF0DRD
 
! argument declarations
      INTEGER ILUN
      CHARACTER*4 IDEV
      CHARACTER*10 ZSDATE
      INTEGER NDIM
      INTEGER NSC
      INTEGER IER
 ! floating type, output only:
      REAL*8 R8_SCVAL(*)
 
      CHARACTER*30 SCLAB(*)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(SCVAL_act(max(1,NDIM))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF0DRD -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      SCVAL_act=0
! call to original routine:  UF0DRD
 
      CALL UF0DRD(
     > ILUN,IDEV,ZSDATE,SCVAL_act(1),SCLAB,NDIM,NSC,IER)
 
! copy back outputs if modified.
      if(NDIM.gt.0) R8_SCVAL(1:NDIM) = SCVAL_act
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF0DWR
      SUBROUTINE R8_UF0DWR(
     > ILUN,IDEV_I,ZSDATE_I,R8_SCVAL,SCLAB_I,NSC,IER)
 
      external UF0DWR
 
! argument declarations
      INTEGER ILUN
      CHARACTER*(*) IDEV_I
      CHARACTER*(*) ZSDATE_I
      INTEGER NSC
      INTEGER IER
 ! floating type, input only:
      REAL*8 R8_SCVAL(*)
 
      CHARACTER*30 SCLAB_I(*)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(SCVAL_act(max(1,NSC))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF0DWR -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      if(nsc.ge.1) then
         SCVAL_act=R8_SCVAL(1:NSC)
      else
         SCVAL_ACT=0
      endif

! call to original routine:  UF0DWR
 
      CALL UF0DWR(
     > ILUN,IDEV_I,ZSDATE_I,SCVAL_act(1),SCLAB_I,NSC,IER)
 
! copy back outputs if modified.
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF1DRD
      SUBROUTINE R8_UF1DRD(
     > ILUN,IDEV,ZSDATE,R8_X,R8_F,NDIM,NACT,IPROC,XLAB,FLAB,NSCD,NSCA,
     > R8_SCVAL,SCLAB,IER)
 
      external UF1DRD
 
! argument declarations
      INTEGER ILUN
      CHARACTER*4 IDEV
      CHARACTER*10 ZSDATE
      INTEGER NDIM
      INTEGER NACT
      INTEGER IPROC
      CHARACTER*30 XLAB
      CHARACTER*30 FLAB
      INTEGER NSCD
      INTEGER NSCA
      INTEGER IER
 ! floating type, output only:
      REAL*8 R8_X(NDIM)
 
 ! floating type, output only:
      REAL*8 R8_F(NDIM)
 
 ! floating type, output only:
      REAL*8 R8_SCVAL(*)
 
      CHARACTER*30 SCLAB(*)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: F_act(:)
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1DRD -- X_act ALLOCATE error!')
      ALLOCATE(F_act(NDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1DRD -- F_act ALLOCATE error!')
      ALLOCATE(SCVAL_act(max(1,NSCD))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1DRD -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=0
      F_act=0
      SCVAL_act=0
! call to original routine:  UF1DRD
 
      CALL UF1DRD(
     > ILUN,IDEV,ZSDATE,X_act(1),F_act(1),NDIM,NACT,IPROC,XLAB,FLAB,
     > NSCD,NSCA,SCVAL_act(1),SCLAB,IER)
 
! copy back outputs if modified.
      R8_X = X_act
      DEALLOCATE(X_act)
      R8_F = F_act
      DEALLOCATE(F_act)
      if(nscd.gt.0) R8_SCVAL(1:NSCD) = SCVAL_act
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF1DRE
      SUBROUTINE R8_UF1DRE(
     > ILUN,R8_X,R8_F,NDIM,NACT,IER,LUNO)
 
      external UF1DRE
 
! argument declarations
      INTEGER ILUN
      INTEGER NDIM
      INTEGER NACT
      INTEGER IER
      INTEGER LUNO
 ! floating type, output only:
      REAL*8 R8_X(NDIM)
 
 ! floating type, output only:
      REAL*8 R8_F(NDIM)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: F_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1DRE -- X_act ALLOCATE error!')
      ALLOCATE(F_act(NDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1DRE -- F_act ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=0
      F_act=0
! call to original routine:  UF1DRE
 
      CALL UF1DRE(
     > ILUN,X_act(1),F_act(1),NDIM,NACT,IER,LUNO)
 
! copy back outputs if modified.
      R8_X = X_act
      DEALLOCATE(X_act)
      R8_F = F_act
      DEALLOCATE(F_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF1DWR
      SUBROUTINE R8_UF1DWR(
     > ILUN,IDEV_I,ZSDATE_I,R8_X,R8_F,N,IPROC,XLAB_I,FLAB_I,NSC,
     > R8_SCVAL,SCLAB_I,IER)
 
      external UF1DWR
 
! argument declarations
      INTEGER ILUN
      CHARACTER*(*) IDEV_I
      CHARACTER*(*) ZSDATE_I
      INTEGER N
      INTEGER IPROC
      INTEGER NSC
      INTEGER IER
 ! floating type, input only:
      REAL*8 R8_X(N)
 
 ! floating type, input only:
      REAL*8 R8_F(N)
 
      CHARACTER*(*) XLAB_I(3)
      CHARACTER*(*) FLAB_I(3)
 ! floating type, input only:
      REAL*8 R8_SCVAL(*)
 
      CHARACTER*30 SCLAB_I(*)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: F_act(:)
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1DWR -- X_act ALLOCATE error!')
      ALLOCATE(F_act(N)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1DWR -- F_act ALLOCATE error!')
      ALLOCATE(SCVAL_act(max(1,NSC))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1DWR -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      X_act=R8_X
      F_act=R8_F
      if(nsc.ge.1) then
         SCVAL_act=R8_SCVAL(1:NSC)
      else
         SCVAL_ACT=0
      endif

! call to original routine:  UF1DWR
 
      CALL UF1DWR(
     > ILUN,IDEV_I,ZSDATE_I,X_act(1),F_act(1),N,IPROC,XLAB_I,FLAB_I,NSC,
     > SCVAL_act(1),SCLAB_I,IER)
 
! copy back outputs if modified.
      DEALLOCATE(X_act)
      DEALLOCATE(F_act)
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF1XTR
      SUBROUTINE R8_UF1XTR(
     > LUN,TDEV,SHDATE,R8_TIME,R8_DTAVE,R8_X,R8_F,NMAX,N,IPROC,XLAB,
     > FLAB,NSCMAX,NSC,R8_SCVAL,SCLAB,IER)
 
      external UF1XTR
 
! argument declarations
      INTEGER LUN
      CHARACTER*4 TDEV
      CHARACTER*10 SHDATE
 ! floating type, input only:
      REAL*8 R8_TIME
 
 ! floating type, input only:
      REAL*8 R8_DTAVE
 
      INTEGER NMAX
      INTEGER N
      INTEGER IPROC
      CHARACTER*30 XLAB
      CHARACTER*30 FLAB
      INTEGER NSCMAX
      INTEGER NSC
      INTEGER IER
 ! floating type, output only:
      REAL*8 R8_X(NMAX)
 
 ! floating type, output only:
      REAL*8 R8_F(NMAX)
 
 ! floating type, output only:
      REAL*8 R8_SCVAL(NSCMAX)
 
      CHARACTER*10 SCLAB(3,NSCMAX)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL :: TIME_act
      REAL :: DTAVE_act
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: F_act(:)
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(X_act(NMAX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1XTR -- X_act ALLOCATE error!')
      ALLOCATE(F_act(NMAX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1XTR -- F_act ALLOCATE error!')
      ALLOCATE(SCVAL_act(NSCMAX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF1XTR -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      TIME_act=R8_TIME
      DTAVE_act=R8_DTAVE
      X_act=0
      F_act=0
      SCVAL_act=0
! call to original routine:  UF1XTR
 
      CALL UF1XTR(
     > LUN,TDEV,SHDATE,TIME_act,DTAVE_act,X_act(1),F_act(1),NMAX,N,
     > IPROC,XLAB,FLAB,NSCMAX,NSC,SCVAL_act(1),SCLAB,IER)
 
! copy back outputs if modified.
      R8_X = X_act
      DEALLOCATE(X_act)
      R8_F = F_act
      DEALLOCATE(F_act)
      R8_SCVAL = SCVAL_act
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  EXTR_X
      SUBROUTINE R8_EXTR_X(
     > R8_WORK,NX,NY,R8_X_I,R8_F,R8_TIME,R8_DTAVE)
 
      external EXTR_X
 
! argument declarations
      INTEGER NX
      INTEGER NY
 ! floating type, input only:
      REAL*8 R8_TIME
 
 ! floating type, input only:
      REAL*8 R8_DTAVE
 
 ! floating type, input only:
      REAL*8 R8_WORK(NX,NY)
 
 ! floating type, input only:
      REAL*8 R8_X_I(NX)
 
 ! floating type, output only:
      REAL*8 R8_F(NY)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: WORK_act(:,:)
      REAL, allocatable :: X_I_act(:)
      REAL, allocatable :: F_act(:)
      REAL :: TIME_act
      REAL :: DTAVE_act
 
! allocation of working arrays...
 
      ALLOCATE(WORK_act(NX,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_EXTR_X -- WORK_act ALLOCATE error!')
      ALLOCATE(X_I_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_EXTR_X -- X_I_act ALLOCATE error!')
      ALLOCATE(F_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_EXTR_X -- F_act ALLOCATE error!')
 
! executable code:  copy for input
 
      WORK_act=R8_WORK
      X_I_act=R8_X_I
      F_act=0
      TIME_act=R8_TIME
      DTAVE_act=R8_DTAVE
! call to original routine:  EXTR_X
 
      CALL EXTR_X(
     > WORK_act(1,1),NX,NY,X_I_act(1),F_act(1),TIME_act,DTAVE_act)
 
! copy back outputs if modified.
      DEALLOCATE(WORK_act)
      DEALLOCATE(X_I_act)
      R8_F = F_act
      DEALLOCATE(F_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  EXTR_Y
      SUBROUTINE R8_EXTR_Y(
     > R8_WORK,NX,NY,R8_Y_I,R8_F,R8_TIME,R8_DTAVE)
 
      external EXTR_Y
 
! argument declarations
      INTEGER NX
      INTEGER NY
 ! floating type, input only:
      REAL*8 R8_TIME
 
 ! floating type, input only:
      REAL*8 R8_DTAVE
 
 ! floating type, input only:
      REAL*8 R8_WORK(NX,NY)
 
 ! floating type, input only:
      REAL*8 R8_Y_I(NY)
 
 ! floating type, output only:
      REAL*8 R8_F(NX)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: WORK_act(:,:)
      REAL, allocatable :: Y_I_act(:)
      REAL, allocatable :: F_act(:)
      REAL :: TIME_act
      REAL :: DTAVE_act
 
! allocation of working arrays...
 
      ALLOCATE(WORK_act(NX,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_EXTR_Y -- WORK_act ALLOCATE error!')
      ALLOCATE(Y_I_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_EXTR_Y -- Y_I_act ALLOCATE error!')
      ALLOCATE(F_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_EXTR_Y -- F_act ALLOCATE error!')
 
! executable code:  copy for input
 
      WORK_act=R8_WORK
      Y_I_act=R8_Y_I
      F_act=0
      TIME_act=R8_TIME
      DTAVE_act=R8_DTAVE
! call to original routine:  EXTR_Y
 
      CALL EXTR_Y(
     > WORK_act(1,1),NX,NY,Y_I_act(1),F_act(1),TIME_act,DTAVE_act)
 
! copy back outputs if modified.
      DEALLOCATE(WORK_act)
      DEALLOCATE(Y_I_act)
      R8_F = F_act
      DEALLOCATE(F_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF2DRD
      SUBROUTINE R8_UF2DRD(
     > ILUN,IDEV,ZSDATE,R8_F,NF1,R8_X,NX,R8_Y,NY,IPROC,NXACT,NYACT,
     > IFLAG,FLAB,XLAB,YLAB,NSCD,NSCA,R8_SCVAL,SCLAB,IER)
 
      external UF2DRD
 
! argument declarations
      INTEGER ILUN
      CHARACTER*4 IDEV
      CHARACTER*10 ZSDATE
      INTEGER NF1
      INTEGER NX
      INTEGER NY
      INTEGER IPROC
      INTEGER NXACT
      INTEGER NYACT
      INTEGER IFLAG
      CHARACTER*30 FLAB
      CHARACTER*30 XLAB
      CHARACTER*30 YLAB
      INTEGER NSCD
      INTEGER NSCA
      INTEGER IER
 ! floating type, output only:
      REAL*8 R8_F(NF1,NY)
 
 ! floating type, output only:
      REAL*8 R8_X(NX)
 
 ! floating type, output only:
      REAL*8 R8_Y(NY)
 
 ! floating type, output only:
      REAL*8 R8_SCVAL(*)
 
      CHARACTER*30 SCLAB(*)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(NF1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DRD -- F_act ALLOCATE error!')
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DRD -- X_act ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DRD -- Y_act ALLOCATE error!')
      ALLOCATE(SCVAL_act(max(1,NSCD))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DRD -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=0
      X_act=0
      Y_act=0
      SCVAL_act=0
! call to original routine:  UF2DRD
 
      CALL UF2DRD(
     > ILUN,IDEV,ZSDATE,F_act(1,1),NF1,X_act(1),NX,Y_act(1),NY,IPROC,
     > NXACT,NYACT,IFLAG,FLAB,XLAB,YLAB,NSCD,NSCA,SCVAL_act(1),SCLAB,
     > IER)
 
! copy back outputs if modified.
      R8_F = F_act
      DEALLOCATE(F_act)
      R8_X = X_act
      DEALLOCATE(X_act)
      R8_Y = Y_act
      DEALLOCATE(Y_act)
      if(nscd.gt.0) R8_SCVAL(1:NSCD) = SCVAL_act
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UFMDS_FMOV
      SUBROUTINE R8_UFMDS_FMOV(
     > R8_FIN,NXIN,NY,R8_FOUT,NXOUT)
 
      external UFMDS_FMOV
 
! argument declarations
      INTEGER NXIN
      INTEGER NY
      INTEGER NXOUT
 ! floating type, input/output:
      REAL*8 R8_FIN(NXIN,NY)
 
 ! floating type, input/output:
      REAL*8 R8_FOUT(NXOUT,NY)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: FIN_act(:,:)
      REAL, allocatable :: FIN_ref(:,:)
      REAL, allocatable :: FOUT_act(:,:)
      REAL, allocatable :: FOUT_ref(:,:)
 
! allocation of working arrays...
 
      ALLOCATE(FIN_act(NXIN,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFMDS_FMOV -- FIN_act ALLOCATE error!')
      ALLOCATE(FIN_ref(NXIN,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFMDS_FMOV -- FIN_ref ALLOCATE error!')
      ALLOCATE(FOUT_act(NXOUT,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFMDS_FMOV -- FOUT_act ALLOCATE error!')
      ALLOCATE(FOUT_ref(NXOUT,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFMDS_FMOV -- FOUT_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      FIN_act=R8_FIN
      FIN_ref=R8_FIN
 
      FOUT_act=R8_FOUT
      FOUT_ref=R8_FOUT
 
! call to original routine:  UFMDS_FMOV
 
      CALL UFMDS_FMOV(
     > FIN_act(1,1),NXIN,NY,FOUT_act(1,1),NXOUT)
 
! copy back outputs if modified.
 
      where(FIN_act.ne.FIN_ref)
         R8_FIN = FIN_act
      end where
      DEALLOCATE(FIN_act)
      DEALLOCATE(FIN_ref)
 
      where(FOUT_act.ne.FOUT_ref)
         R8_FOUT = FOUT_act
      end where
      DEALLOCATE(FOUT_act)
      DEALLOCATE(FOUT_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF2DRE
      SUBROUTINE R8_UF2DRE(
     > ILUN,R8_F,NF1,R8_X,NX,R8_Y,NY,NXACT,NYACT,IFLAG,IER,LUNO)
 
      external UF2DRE
 
! argument declarations
      INTEGER ILUN
      INTEGER NF1
      INTEGER NX
      INTEGER NY
      INTEGER NXACT
      INTEGER NYACT
      INTEGER IFLAG
      INTEGER IER
      INTEGER LUNO
 ! floating type, output only:
      REAL*8 R8_F(NF1,NY)
 
 ! floating type, output only:
      REAL*8 R8_X(NX)
 
 ! floating type, output only:
      REAL*8 R8_Y(NY)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: Y_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(NF1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DRE -- F_act ALLOCATE error!')
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DRE -- X_act ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DRE -- Y_act ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=0
      X_act=0
      Y_act=0
! call to original routine:  UF2DRE
 
      CALL UF2DRE(
     > ILUN,F_act(1,1),NF1,X_act(1),NX,Y_act(1),NY,NXACT,NYACT,IFLAG,
     > IER,LUNO)
 
! copy back outputs if modified.
      R8_F = F_act
      DEALLOCATE(F_act)
      R8_X = X_act
      DEALLOCATE(X_act)
      R8_Y = Y_act
      DEALLOCATE(Y_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF2DWR
      SUBROUTINE R8_UF2DWR(
     > ILUN,IDEV_I,ZSDATE_I,R8_F,NF1,R8_X,NX,R8_Y,NY,IPROC,FLAB_I,
     > XLAB_I,YLAB_I,NSC,R8_SCVAL,SCLAB_I,IER)
 
      external UF2DWR
 
! argument declarations
      INTEGER ILUN
      CHARACTER*(*) IDEV_I
      CHARACTER*(*) ZSDATE_I
      INTEGER NF1
      INTEGER NX
      INTEGER NY
      INTEGER IPROC
      INTEGER NSC
      INTEGER IER
 ! floating type, input only:
      REAL*8 R8_F(NF1,NY)
 
 ! floating type, input only:
      REAL*8 R8_X(NX)
 
 ! floating type, input only:
      REAL*8 R8_Y(NY)
 
      CHARACTER*(*) FLAB_I(3)
      CHARACTER*(*) XLAB_I(3)
      CHARACTER*(*) YLAB_I(3)
 ! floating type, input only:
      REAL*8 R8_SCVAL(*)
 
      CHARACTER*30 SCLAB_I(*)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(NF1,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DWR -- F_act ALLOCATE error!')
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DWR -- X_act ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DWR -- Y_act ALLOCATE error!')
      ALLOCATE(SCVAL_act(max(1,NSC))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF2DWR -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=R8_F
      X_act=R8_X
      Y_act=R8_Y
      if(nsc.ge.1) then
         SCVAL_act=R8_SCVAL(1:NSC)
      else
         SCVAL_ACT=0
      endif

! call to original routine:  UF2DWR
 
      CALL UF2DWR(
     > ILUN,IDEV_I,ZSDATE_I,F_act(1,1),NF1,X_act(1),NX,Y_act(1),NY,
     > IPROC,FLAB_I,XLAB_I,YLAB_I,NSC,SCVAL_act(1),SCLAB_I,IER)
 
! copy back outputs if modified.
      DEALLOCATE(F_act)
      DEALLOCATE(X_act)
      DEALLOCATE(Y_act)
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF3DRD
      SUBROUTINE R8_UF3DRD(
     > ILUN,IDEV,ZSDATE,R8_F,NF1,NF2,R8_X,NX,R8_Y,NY,R8_Z,NZ,IPROC,
     > NXACT,NYACT,NZACT,IFLAG,FLAB,XLAB,YLAB,ZLAB,NSCD,NSCA,R8_SCVAL,
     > SCLAB,IER)
 
      external UF3DRD
 
! argument declarations
      INTEGER ILUN
      CHARACTER*4 IDEV
      CHARACTER*10 ZSDATE
      INTEGER NF1
      INTEGER NF2
      INTEGER NX
      INTEGER NY
      INTEGER NZ
      INTEGER IPROC
      INTEGER NXACT
      INTEGER NYACT
      INTEGER NZACT
      INTEGER IFLAG
      CHARACTER*30 FLAB
      CHARACTER*30 XLAB
      CHARACTER*30 YLAB
      CHARACTER*30 ZLAB
      INTEGER NSCD
      INTEGER NSCA
      INTEGER IER
 ! floating type, output only:
      REAL*8 R8_F(NF1,NF2,NZ)
 
 ! floating type, output only:
      REAL*8 R8_X(NX)
 
 ! floating type, output only:
      REAL*8 R8_Y(NY)
 
 ! floating type, output only:
      REAL*8 R8_Z(NZ)
 
 ! floating type, output only:
      REAL*8 R8_SCVAL(*)
 
      CHARACTER*30 SCLAB(*)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:,:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Z_act(:)
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(NF1,NF2,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRD -- F_act ALLOCATE error!')
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRD -- X_act ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRD -- Y_act ALLOCATE error!')
      ALLOCATE(Z_act(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRD -- Z_act ALLOCATE error!')
      ALLOCATE(SCVAL_act(max(1,NSCD))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRD -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=0
      X_act=0
      Y_act=0
      Z_act=0
      SCVAL_act=0
! call to original routine:  UF3DRD
 
      CALL UF3DRD(
     > ILUN,IDEV,ZSDATE,F_act(1,1,1),NF1,NF2,X_act(1),NX,Y_act(1),NY,
     > Z_act(1),NZ,IPROC,NXACT,NYACT,NZACT,IFLAG,FLAB,XLAB,YLAB,ZLAB,
     > NSCD,NSCA,SCVAL_act(1),SCLAB,IER)
 
! copy back outputs if modified.
      R8_F = F_act
      DEALLOCATE(F_act)
      R8_X = X_act
      DEALLOCATE(X_act)
      R8_Y = Y_act
      DEALLOCATE(Y_act)
      R8_Z = Z_act
      DEALLOCATE(Z_act)
      if(nscd.gt.0) R8_SCVAL(1:NSCD) = SCVAL_act
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF3DRE
      SUBROUTINE R8_UF3DRE(
     > ILUN,R8_F,NF1,NF2,R8_X,NX,R8_Y,NY,R8_Z,NZ,NXACT,NYACT,NZACT,
     > IFLAG,IER,LUNO)
 
      external UF3DRE
 
! argument declarations
      INTEGER ILUN
      INTEGER NF1
      INTEGER NF2
      INTEGER NX
      INTEGER NY
      INTEGER NZ
      INTEGER NXACT
      INTEGER NYACT
      INTEGER NZACT
      INTEGER IFLAG
      INTEGER IER
      INTEGER LUNO
 ! floating type, output only:
      REAL*8 R8_F(NF1,NF2,NZ)
 
 ! floating type, output only:
      REAL*8 R8_X(NX)
 
 ! floating type, output only:
      REAL*8 R8_Y(NY)
 
 ! floating type, output only:
      REAL*8 R8_Z(NZ)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:,:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Z_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(NF1,NF2,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRE -- F_act ALLOCATE error!')
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRE -- X_act ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRE -- Y_act ALLOCATE error!')
      ALLOCATE(Z_act(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DRE -- Z_act ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=0
      X_act=0
      Y_act=0
      Z_act=0
! call to original routine:  UF3DRE
 
      CALL UF3DRE(
     > ILUN,F_act(1,1,1),NF1,NF2,X_act(1),NX,Y_act(1),NY,Z_act(1),NZ,
     > NXACT,NYACT,NZACT,IFLAG,IER,LUNO)
 
! copy back outputs if modified.
      R8_F = F_act
      DEALLOCATE(F_act)
      R8_X = X_act
      DEALLOCATE(X_act)
      R8_Y = Y_act
      DEALLOCATE(Y_act)
      R8_Z = Z_act
      DEALLOCATE(Z_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UF3DWR
      SUBROUTINE R8_UF3DWR(
     > ILUN,IDEV_I,ZSDATE_I,R8_F,NF1,NF2,R8_X,NX,R8_Y,NY,R8_Z,NZ,IPROC,
     > FLAB_I,XLAB_I,YLAB_I,ZLAB_I,NSC,R8_SCVAL,SCLAB_I,IER)
 
      external UF3DWR
 
! argument declarations
      INTEGER ILUN
      CHARACTER*(*) IDEV_I
      CHARACTER*(*) ZSDATE_I
      INTEGER NF1
      INTEGER NF2
      INTEGER NX
      INTEGER NY
      INTEGER NZ
      INTEGER IPROC
      INTEGER NSC
      INTEGER IER
 ! floating type, input only:
      REAL*8 R8_F(NF1,NF2,NZ)
 
 ! floating type, input only:
      REAL*8 R8_X(NX)
 
 ! floating type, input only:
      REAL*8 R8_Y(NY)
 
 ! floating type, input only:
      REAL*8 R8_Z(NZ)
 
      CHARACTER*(*) FLAB_I(3)
      CHARACTER*(*) XLAB_I(3)
      CHARACTER*(*) YLAB_I(3)
      CHARACTER*(*) ZLAB_I(3)
 ! floating type, input only:
      REAL*8 R8_SCVAL(*)
 
      CHARACTER*30 SCLAB_I(*)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:,:,:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Z_act(:)
      REAL, allocatable :: SCVAL_act(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(NF1,NF2,NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DWR -- F_act ALLOCATE error!')
      ALLOCATE(X_act(NX)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DWR -- X_act ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DWR -- Y_act ALLOCATE error!')
      ALLOCATE(Z_act(NZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DWR -- Z_act ALLOCATE error!')
      ALLOCATE(SCVAL_act(max(1,NSC))
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UF3DWR -- SCVAL_act ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=R8_F
      X_act=R8_X
      Y_act=R8_Y
      Z_act=R8_Z
      if(nsc.ge.1) then
         SCVAL_act=R8_SCVAL(1:NSC)
      else
         SCVAL_ACT=0
      endif

! call to original routine:  UF3DWR
 
      CALL UF3DWR(
     > ILUN,IDEV_I,ZSDATE_I,F_act(1,1,1),NF1,NF2,X_act(1),NX,Y_act(1),
     > NY,Z_act(1),NZ,IPROC,FLAB_I,XLAB_I,YLAB_I,ZLAB_I,NSC,
     > SCVAL_act(1),SCLAB_I,IER)
 
! copy back outputs if modified.
      DEALLOCATE(F_act)
      DEALLOCATE(X_act)
      DEALLOCATE(Y_act)
      DEALLOCATE(Z_act)
      DEALLOCATE(SCVAL_act)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UFSWXY2
      SUBROUTINE R8_UFSWXY2(
     > R8_F,R8_FB,ISIZ,R8_X,NX,R8_Y,NY,XLAB,YLAB,XUNITS,YUNITS)
 
      external UFSWXY2
 
! argument declarations
      INTEGER ISIZ
      INTEGER NX
      INTEGER NY
      CHARACTER*(*) XLAB
      CHARACTER*(*) YLAB
      CHARACTER*(*) XUNITS
      CHARACTER*(*) YUNITS
 ! floating type, input/output:
      REAL*8 R8_F(ISIZ)
 
 ! floating type, input/output:
      REAL*8 R8_FB(ISIZ)
 
 ! floating type, input/output:
      REAL*8 R8_X(ISIZ)
 
 ! floating type, input/output:
      REAL*8 R8_Y(ISIZ)
 
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:)
      REAL, allocatable :: F_ref(:)
      REAL, allocatable :: FB_act(:)
      REAL, allocatable :: FB_ref(:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY2 -- F_act ALLOCATE error!')
      ALLOCATE(F_ref(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY2 -- F_ref ALLOCATE error!')
      ALLOCATE(FB_act(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY2 -- FB_act ALLOCATE error!')
      ALLOCATE(FB_ref(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY2 -- FB_ref ALLOCATE error!')
      ALLOCATE(X_act(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY2 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY2 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY2 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY2 -- Y_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=R8_F
      F_ref=R8_F
 
      FB_act=R8_FB
      FB_ref=R8_FB
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
! call to original routine:  UFSWXY2
 
      CALL UFSWXY2(
     > F_act(1),FB_act(1),ISIZ,X_act(1),NX,Y_act(1),NY,XLAB,YLAB,XUNITS,
     > YUNITS)
 
! copy back outputs if modified.
 
      where(F_act.ne.F_ref)
         R8_F = F_act
      end where
      DEALLOCATE(F_act)
      DEALLOCATE(F_ref)
 
      where(FB_act.ne.FB_ref)
         R8_FB = FB_act
      end where
      DEALLOCATE(FB_act)
      DEALLOCATE(FB_ref)
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  UFSWXY
      SUBROUTINE R8_UFSWXY(
     > R8_F,R8_FB,ISIZ,R8_X,NX,R8_Y,NY,XLAB,YLAB)
 
      external UFSWXY
 
! argument declarations
      INTEGER ISIZ
      INTEGER NX
      INTEGER NY
 ! floating type, input/output:
      REAL*8 R8_F(ISIZ)
 
 ! floating type, input/output:
      REAL*8 R8_FB(ISIZ)
 
 ! floating type, input/output:
      REAL*8 R8_X(ISIZ)
 
 ! floating type, input/output:
      REAL*8 R8_Y(ISIZ)
 
      CHARACTER*10 XLAB(3)
      CHARACTER*10 YLAB(3)
 
! local (automatic array) declarations
 
      integer alloc_stat
      REAL, allocatable :: F_act(:)
      REAL, allocatable :: F_ref(:)
      REAL, allocatable :: FB_act(:)
      REAL, allocatable :: FB_ref(:)
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
 
! allocation of working arrays...
 
      ALLOCATE(F_act(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY -- F_act ALLOCATE error!')
      ALLOCATE(F_ref(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY -- F_ref ALLOCATE error!')
      ALLOCATE(FB_act(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY -- FB_act ALLOCATE error!')
      ALLOCATE(FB_ref(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY -- FB_ref ALLOCATE error!')
      ALLOCATE(X_act(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(ISIZ)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_UFSWXY -- Y_ref ALLOCATE error!')
 
! executable code:  copy for input
 
      F_act=R8_F
      F_ref=R8_F
 
      FB_act=R8_FB
      FB_ref=R8_FB
 
      X_act=R8_X
      X_ref=R8_X
 
      Y_act=R8_Y
      Y_ref=R8_Y
 
! call to original routine:  UFSWXY
 
      CALL UFSWXY(
     > F_act(1),FB_act(1),ISIZ,X_act(1),NX,Y_act(1),NY,XLAB,YLAB)
 
! copy back outputs if modified.
 
      where(F_act.ne.F_ref)
         R8_F = F_act
      end where
      DEALLOCATE(F_act)
      DEALLOCATE(F_ref)
 
      where(FB_act.ne.FB_ref)
         R8_FB = FB_act
      end where
      DEALLOCATE(FB_act)
      DEALLOCATE(FB_ref)
 
      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)
 
      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)
 
! exit
      return
      end

c file: sgiso.for	isometric routines for sglib		31-mar-82
c
c
c  mar-82	modify agilya to handle character or numeric strings.
c		change many routines to permit hidden line removal
c		 in logarithmic plots. [j-murphy].
c
c  mar-86	revise y tick labeling to prevent blowups [met]
c
c  nov-87	modify y tick label routine to support 4105; change agicrv
c		 to move, not draw, to first point.  [met]
c		fix agiso0 so tick labels are along y axis, not at z=0.
c		 y axis rather than at z=0.
c		restructure many if's and do's to f77. [met]
c
c  feb-89	always draw in agidvs if idraw<0 to match setting in agishc.
c		set curve color in agishc for 4105.
c		test for hidden in agifrm; delete agifrh (frame hidden).
c		use grid color for frame.
c		don't mark upper/lower for skirt, frame, or contour lines.
c		try nint function in agidvs to calculate my.
c		in agish, if x is dense, draw constant y lines then
c		 call agidvs to mark upper/lower.
c		convert label arguments to character variables.
c		add agimsu/agidsu entries for 4096 resolution; fix frame/
c		 surface/contour for 4096; sort of fix y axis routines.
c		make all setup routines entries of aginit.
c		calculate klengy in agisly if argument = 0.
c		more f77 changes. [met]
c
c  sep-89	update agidvs from newest draws in ncar library -
c		 use ltemp to set upper/lower.
c		don't use nint to calculate my - didn't help.
c		always process constant y lines 1->nx in agishc/agish (agidvs
c		 draws left to right).
c		do vis1 loop in reverse order so my correct on exit.
c		put steep in common (could allow setup to modify it).
c		halve dy if (nx2-nx1)=1.  [met]
c
c  jan-90	convert to lower case.
c		move duplicated initialization from agisoc/agisom to agiso0.
c		for constant x lines, go back to processing left to right if
c		 theta>90, right to left if theta<90.
c		use agish for non-hidden with no contour lines; drop agicrv.
c		use dzmin for z log data values <=0.
c		[note: y log option probably doesn't work.]
c		slide y axis remote exponent left if theta>90.
c		allow y axis labels to be in reverse order. [met]
c
c  nov-90	add new argument to mnmx calls.
c		fix x/y clipping in agisom by restricting data indices.
c		make first step smaller in agisom if agistx/agisty called
c		 so surface line is drawn at last index.
c		combine agish and agishc.
c		change agidvs to "walk" along line drawing each visible
c		 segment instead of just checking the end points.
c		fix processing of "steep" lines in agidvs. [met]
c
c  dec-90	fix test for whether data should be plotted for log mode.
c
c  jan-91	make 2 passes across each line of constant y, drawing on
c		  on first, mark on second, instead of draw from min to max.
c		major rewrite of slanted axis tick/label code to match
c		  sggrf routines.
c		allow reversed y axis (from max to min). [met]
c
c  jul-91	draw contours in color.
c		modify juster/notate to match changes in sggrf. [met]
c
c  nov-91	fix bottom view test (undefined lower=1024, not 0). [met]
c
c  feb-93	put bppcom in each routine instead of calling comget. [met]
c
c-------------------------------------------------------------/aginit
c * initialize ag and isometric common
c
	subroutine aginit
	implicit none
	include 'sgcopr_inc'
	include 'sgiso_inc'
c
	logical hide
	real c(*)
	logical clipz
	logical xskirt, yskirt
c
	integer ic, is, nc, ixtype, iytype, iztype, ixstep, iystep
	integer n, minx, maxx, leny, minz, maxz, iside, iround
	real cmin, cmax, dc, xmin, xmax, ymin, ymax,zmin,zmax
	real theta

	call binitt
c
	dxmin=0.
	dxmax=0.
	dymin=0.
	dymax=0.
	dzmin=0.
	dzmax=0.
	kxtype=1
	kytype=1
	kztype=1
	kxstep=1
	kystep=1
	ksxmin=150
	ksxmax=590
	thetad=45.
	klengy=440
	kszmin=120
	kszmax=465
	refx=.false.
	refy=.false.
	hidden=.false.
	khside=0
	ncont=0
	zclip=.true.
	kyrond=3
	steep=3.
	call agseet(i4105,kfac,ic,is)
	return
c%
c-------------------------------------------------------------/agihid
c * set hidden flag
c
	entry agihid(hide)
c
	hidden=hide
	return
c%
c-------------------------------------------------------------/agiszc
c * set contours
c
	entry agiszc(nc,c)
c
c equally spaced contours
	if(nc.lt.0) then
	  cmin=c(1)
	  cmax=c(2)
	  if(cmin.eq.cmax) then
c  must set cont after zmin,zmax determined
	    ncont=nc
	  else
c  user specified range
	    ncont=min(max(2,abs(nc)),41)
	    dc=(cmax-cmin)/(ncont-1)
	    do n=1,ncont
	      cont(n)=cmin+n*dc	!was n-1
	    enddo
	  endif
c
c  user set contours
	elseif(nc.gt.0) then
	  ncont=min(nc,41)
	  do n=1,ncont
	    cont(n)=c(n)
	  enddo
c
c no contours
	else	!(nc.eq.0)
	  ncont=nc
	endif
	return
c%
c-------------------------------------------------------------/agisid
c * set side flag
c
	entry agisid(iside)
c
	khside=iside
	return
c%
c-------------------------------------------------------------/agidlx
c * set x data limits
c
	entry agidlx(xmin,xmax)
c
	dxmin=xmin
	dxmax=xmax
	return
c%
c-------------------------------------------------------------/agidly
c * set y data limits
c
	entry agidly(ymin,ymax)
c
	dymin=ymin
	dymax=ymax
	return
c%
c-------------------------------------------------------------/agidlz
c * set z data limits
c
	entry agidlz(zmin,zmax)
c
	dzmin=zmin
	dzmax=zmax
	return
c%
c-------------------------------------------------------------/agizcl
c * clip z
c
	entry agizcl(clipz)	!true or false
c
	zclip=clipz
	return
c%
c-------------------------------------------------------------/agixty
c * set x transformation type
c
	entry agixty(ixtype)	!1 linear, 2 log
c
	kxtype=ixtype
	return
c%
c-------------------------------------------------------------/agiyty
c * set y transformation type
c
	entry agiyty(iytype)	!1 linear, 2 log
c
	kytype=iytype
	return
c%
c-------------------------------------------------------------/agizty
c * set z transformation type
c
	entry agizty(iztype)	!1 linear, 2 log
c
	kztype=iztype
	return
c%
c-------------------------------------------------------------/agistx
c * set x increment
c
	entry agistx(ixstep)
c
	kxstep=max(ixstep,1)
	return
c%
c-------------------------------------------------------------/agisty
c * set y increment
c
	entry agisty(iystep)
c
	kystep=max(iystep,1)
	return
c%
c-------------------------------------------------------------/agislx
c * set x screen limits
c
	entry agislx(minx,maxx)
c
	ksxmin=minx
	ksxmax=maxx
	return
c%
c-------------------------------------------------------------/agisly
c * set y screen limits - theta in degrees; y axis length in screen units
c
	entry agisly(theta,leny)
c
	thetad=theta
	if(leny.gt.0) then
	  klengy=leny
	else
	  klengy=(ksxmax-ksxmin)*.7071068/cos(theta/57.29578)	!cos(45)
	  klengy=abs(klengy)
	endif
	return
c%
c-------------------------------------------------------------/agislz
c * set z screen limits
c
	entry agislz(minz,maxz)
c
	kszmin=minz
	kszmax=maxz
	return
c%
c-------------------------------------------------------------/agiskt
c * set flag to draw skirt to x,y plane
c
	entry agiskt(xskirt,yskirt)	!true or false
c
	refx=xskirt
	refy=yskirt
	return
c%
c-------------------------------------------------------------/agixnt
c * set x rounding option
c
	entry agixnt(iround)
c
	call xneat(iround)
	return
c%
c-------------------------------------------------------------/agiynt
c * set y rounding option
c
	entry agiynt(iround)
c
	kyrond=iround+1.5
	return
c%
c-------------------------------------------------------------/agiznt
c * set z rounding option
c
	entry agiznt(iround)
c
	call yneat(iround)
	return
	end
c%
c-------------------------------------------------------------/agisoc
c * isometric with option for hidden line removal and contours
c
	subroutine agisoc(x,y,z,nxdim,nx,ny,xu,yu,zu,m)
	implicit none
	integer nxdim,nx,ny
	include 'sgiso_inc'
	real x(nxdim), y(ny), z(nxdim,ny), m(2,nx,ny)
	character*(*) xu,yu,zu
c
c draw isometric
	call agiso0(x,y,z,nxdim,nx,ny,xu,yu,zu)
c
c draw surface, then frame
	call agishc(x,y,z,nxdim,nx,ny,m)
	call agifrm
c
	return
	end
c%
c-------------------------------------------------------------/agisom
c * isometric with option for hidden line removal
c
	subroutine agisom(x,y,z,nxdim,nx,ny,xu,yu,zu)
	implicit none
	include 'sgiso_inc'
	integer nxdim,nx,ny
	real x(nxdim), y(ny), z(nxdim,ny)
	character*(*) xu,yu,zu
c
c draw isometric
	call agiso0(x,y,z,nxdim,nx,ny,xu,yu,zu)
c
c draw surface, then frame
	call agish(x,y,z,nxdim,nx,ny)
	call agifrm
c
	return
	end
c%
c-------------------------------------------------------------/agish
c * draw surface with options for hidden line removal
c
	subroutine agish(x,y,z,nxdim,nx,ny)
	implicit none
	integer nxdim,nx,ny
	real x(nxdim), y(ny), z(nxdim,ny), m(2,nx,ny)
	include 'sgiso_inc'
	logical lcont,dcont
	integer ibasec
	parameter (ibasec=1)
	integer j
	real comget
	common /bppcom/ comget(80)
	
	real yymin, ynorm, yymax, yins, zmin, dc
	real xxmin, xxmax
	integer ihide, mark, ipos, icurv, n, i, jn1, jny, jxx
	integer in1, inx, ixx, ixinc, ixbeg, ixend, ix, iy1
	integer ix1, ix2, iy2, jx, jdraw, ih, im, jj


c  function to allow y data to be in reverse order
	yins(j) = ((yymax-y(j))*ynorm)*((yymin-y(j))*ynorm)
c
	ncont=0			!guarantee no contours
	lcont=.false.
	go to 100
c
	entry agishc(x,y,z,nxdim,nx,ny,m)
c
	lcont=.true.
 100	continue
c
	zmin=dzmin
	if(kztype.eq.2) zmin=10.**zmin
c
c set whether to do hidden line removal
	if(hidden) then
	  ihide=1		!draw visible segments
	  mark=1		!mark upper/lower arrays
	else
	  ihide=-1		!draw all segments
	  mark=0		!dont mark arrays
	endif
c
c initialize height arrays
	do ipos=1,1024
	  upper(ipos)=0
	  lower(ipos)=1024
	enddo
c
c set line color for curves/skirt
	icurv=-1
	if(i4105.ne.0) then
	  icurv=comget(ibasec+10)
	  call linclr(icurv)
	endif
c
c set contour levels if user requested z span option
	if(ncont.lt.0) then
	  ncont=min(abs(ncont),41)	!max(2,abs(ncont))
	  dc=(dzmax-dzmin)/(ncont-1)	!was ncont+1
	  do n=1,ncont
	    cont(n)=dzmin+n*dc
	  enddo
	endif
c
c map z(i,j) to ix(i,j),iy(i,j)
	if(lcont) then
	  do j=1,ny
	    do i=1,nx
	      call agicau(x(i),y(j),z(i,j),m(1,i,j),m(2,i,j))
	    enddo
	  enddo
	endif
c
c restrict to y limits
	yymin=dymin
	yymax=dymax
	if(kytype.eq.2) then
	  yymin=10.**yymin
	  yymax=10.**yymax
	endif
	if(yymin.ne.yymax) then
	  ynorm=1./(yymax-yymin)
	else
	  ynorm=1.
	endif
	jn1=1
	do while (yins(jn1).gt.0. .and. jn1.le.ny)
	  jn1=jn1+1
	enddo
	jny=ny
	do while (yins(jny).gt.0. .and. jny.ge.jn1)
	  jny=jny-1
	enddo
	if(jny.le.jn1) then
cx	  call agseter()
	  return
	endif
	jxx=mod((jny-jn1),kystep)
	if(jxx.eq.0) jxx=kystep	!get to a multiple of kystep
c
c restrict to x limits
	xxmin=dxmin
	xxmax=dxmax
	if(kxtype.eq.2) then
	  xxmin=10.**xxmin
	  xxmax=10.**xxmax
	endif
	in1=1
	do while (xxmin.gt.x(in1) .and. in1.le.nx)
	  in1=in1+1
	enddo
	inx=nx
	do while (xxmax.lt.x(inx) .and. inx.ge.in1)
	  inx=inx-1
	enddo
	if(inx.le.in1) then
cx	  call agseter()
	  return
	endif
	ixx=mod((inx-in1),kxstep)	!get to a multiple of kxstep
	if(ixx.eq.0) ixx=kxstep
c
c set which side to draw x skirt
	if(thetad.gt.90.) then
	  ixinc=1
	  ixbeg=in1
	  ixend=inx
	else	!thetad <= 90
	  ixinc=-1
	  ixbeg=inx
	  ixend=in1
	endif
c
c draw skirt lines to the x axis using grid color
	if(refx) then
	  ix=ixx		!first incr goes to kxstep
	  i=in1
	  do while (i.le.inx)
	    call agicau(x(i),y(jn1),zmin,ix1,iy1)	!from zmin
	    if(lcont) then
	      ix2=m(1,i,jn1)
	      iy2=m(2,i,jn1)
	    else
	      call agicau(x(i),y(jn1),z(i,jn1),ix2,iy2)	!to z at x,y
	    endif
	    if(iy1.ne.iy2) call agidvs(ix1,iy1,ix2,iy2,ihide,0)
	    i=i+ix
	    ix=kxstep
	  enddo
	endif
c
c draw skirt lines to the y axis
	if(refy) then
	  jx=jxx		!first incr goes to kystep
	  j=jn1
	  do while (j.le.jny)
	    call agicau(x(ixbeg),y(j),zmin,ix1,iy1)
	    if(lcont) then
	      ix2=m(1,ixbeg,j)
	      iy2=m(2,ixbeg,j)
	    else
	      call agicau(x(ixbeg),y(j),z(ixbeg,j),ix2,iy2)
	    endif
	    if(iy1.ne.iy2) call agidvs(ix1,iy1,ix2,iy2,ihide,0)
	    j=j+jx
	    jx=kystep
	  enddo
	endif
c
c draw surface with lines of constant x and y
	j=jn1
	jdraw=jn1
	do while (j.le.jny)
	  if(j.eq.jn1) then
	    jdraw=jdraw+jxx
	  else
	    jdraw=jdraw+kystep
	  endif
	  ih=ihide		!draw first time, mark second time
	  do im=0,mark		!loop twice if hidden, once if not
c
c draw constant y line (for y fixed, draw x vs z from in1 to inx)
	  if(lcont) then
	    ix1=m(1,in1,j)
	    iy1=m(2,in1,j)
	  else
	    call agicau(x(in1),y(j),z(in1,j),ix1,iy1)	!i=in1
	  endif
	  do i=in1+1,inx	!was kxstep
	    if(lcont) then
	      ix2=m(1,i,j)
	      iy2=m(2,i,j)
	    else
	      call agicau(x(i),y(j),z(i,j),ix2,iy2)
	    endif
	    call agidvs(ix1,iy1,ix2,iy2,ih,im)
	    ix1=ix2
	    iy1=iy2
	  enddo
	  ih=0			!dont draw second time thru
	  enddo
c
c draw constant x lines (for each x, draw y vs z from j to jdraw)
	  if(j.lt.jny) then
	    if(ixinc.gt.0) then	!first i increment
	      ix=ixx
	    else
	      ix=kxstep
	    endif
	    i=ixbeg
	    do while ((ixend-i)*ixinc.ge.0)
	      ih=ihide
	      dcont=ncont.gt.0 .and. i.lt.inx
	      do im=0,mark
	      if(lcont) then
		ix1=m(1,i,j)
		iy1=m(2,i,j)
	      else
		call agicau(x(i),y(j),z(i,j),ix1,iy1)
	      endif
	      do jj=j+1,jdraw
	      if(lcont) then
		ix2=m(1,i,jj)
		iy2=m(2,i,jj)
	      else
		call agicau(x(i),y(jj),z(i,jj),ix2,iy2)
	      endif
	      call agidvs(ix1,iy1,ix2,iy2,ih,im)
	      if(dcont) then
		call agidzc(z,nxdim,nx,ny,m,i,jj-1,cont,ncont)
	      endif
	      ix1=ix2
	      iy1=iy2
	      enddo
	      ih=0
	      dcont=.false.
	      enddo
	      i=i+ix*ixinc
	      ix=kxstep
	      if(ixinc.lt.0 .and. (i-ix).lt.ixend) ix=ixx
	    enddo
	  endif
	  j=jdraw
c
	enddo
c
	return
	end
c%
c-------------------------------------------------------------/agiso0
c * ag ii isometric graph (internal)
c
	subroutine agiso0(x,y,z,nxdim,nx,ny,xu,yu,zu)
	implicit none
	integer nxdim,nx,ny
	real x(nxdim), y(ny), z(nxdim,ny)
	character*(*) xu,yu,zu
	include 'sgiso_inc'
	integer j
	real     gran, dtic
	real     finfin, agisym
	integer  nbase, ibasex, ibasey, ix0, ix1, kount
	integer  i, ntics
	real     toff
	integer  k1,k2,nmod,ibeg
	common /sgaxi/ k1(2),k2(2),nmod(2),gran(2),ibeg(2),dtic(2)
	integer ibasec
	parameter (ibasec=1)
	real comget
	common /bppcom/ comget(80)
c
	if(dzmin.eq.0. .and. dzmax.eq.0.) then
	  finfin=comget(ibasec+3)
	  dzmin=finfin
	  dzmax=-finfin
	  do j=1,ny
	    call agmnmx(z(1,j),dzmin,dzmax,nx,kztype)
	  enddo
	endif
c
c  draw grid for x vs z @ymin
	call npts(nx)
	call slimx(ksxmin,ksxmax)	!screen/data limits
	call slimy(kszmin,kszmax)
	call dlimx(dxmin,dxmax)
	call dlimy(dzmin,dzmax)
	call yfrm(2)		!ticks out, no grid
	call xfrm(2)
	call xtype(kxtype)	!linear/log flag
	call ytype(kztype)
	if(thetad.gt.90.) call ylocrt(0)	!position z axis
	call check(x,z)
	call agdspl(x,y)
	call agtchs(xu,0)	!labels on x,z axes
	call agtcvs(zu,0)
c
c  set isometric scales
	nbase=ibasex(0)
	dxmin=comget(nbase+26)
	dxmax=comget(nbase+27)
	agisxm=float(ksxmax-ksxmin)/(dxmax-dxmin)
	agisxb=float(ksxmin)-agisxm*dxmin
c
	nbase=ibasey(0)
	dzmin=comget(nbase+26)
	dzmax=comget(nbase+27)
	agiszm=float(kszmax-kszmin)/(dzmax-dzmin)
	agiszb=float(kszmin)-agiszm*dzmin
c
c scale y
	call slimy(kszmin,kszmin+klengy)
	call dlimy(dymin,dymax)		!if dymin<>0 or dymax<>0
	call npts(ny)
	call ytype(kytype)
	call yneat(kyrond-1)
	call rgchek(nbase,y)		!calc data range
	call loptim(nbase,2)		!calc endpoints, # ticks
	dymin=comget(nbase+26)
	dymax=comget(nbase+27)
c
c  position of y axis endpoint
	agicth=cos(thetad/57.29578)
	agisth=sin(thetad/57.29578)
	agisym=klengy/(dymax-dymin)
	xslope=agisym*agicth
	zslope=agisym*agisth
	ksymxx=ksxmin+ifix(klengy*agicth)
	ksymxz=kszmin+ifix(klengy*agisth)
c
c  compute axis endpoints
	if(thetad.le.90.) then
	  ix0=ksxmax
	  ix1=ksymxx+ksxmax-ksxmin
cx	  xpos=dxmax
	else
	  ix0=ksxmin
	  ix1=ksymxx
cx	  xpos=dxmin
	endif
cx	iz0=kszmin
cx	iz1=ksymxz
c
c  draw axis line
	call agimsu(ix0,kszmin)
	call agidsu(ix1,ksymxz)
c
c draw ticks with labels
	call agidya(ix0,kszmin,ix1)
c
c  output y unit label
	call agilya(ix0,kszmin,ix1,yu)
c
c  set the z tick values in common for contour values
	call agizc(ix0,kszmin,ix1)
	if(ncont.eq.-1 .or. ncont.eq.-2) then
	  kount=0
	  do i=1,nztics
	    if(ncont.eq.-2 .or. lzmjmn(i)) then
	    kount=kount+1
	    cont(kount)=vztics(i)
	    endif
	  enddo
	  ncont=kount
	endif
	return
	end
c%
c-------------------------------------------------------------/agizc
c * internal contour setting routine
c
	subroutine agizc(ix0,iz0,ix1)
	implicit none
c
c  call after the z axis has been drawn (i.e. after dsplay)
c  the lzmjmn array is logical and corresponds to vztics.
c  if the level is a major tick, lzmjmn will be true.
c
	integer ix0,iz0,ix1
	include 'sgiso_inc'
	real dtic2, y, x, toff
	integer kount, ntics
	integer k1, k2, nmod, ibeg
	real    gran, dtic
	common /sgaxi/ k1(2),k2(2),nmod(2),gran(2),ibeg(2),dtic(2)
	real tablog(9)
	data tablog/  0.,
     *		0.30103, 0.47712, 0.60206, 0.69897,
     *		0.77815, 0.84510, 0.90309, 0.95424/
	logical logm
	integer isign, k, i, iyl, ixl, izl
	real comget
	common /bppcom/ comget(80)
c
	logm=(nmod(2).eq.3 .or. nmod(2).eq.9)
	isign=1
cx	if(k2(2).lt.k1(2)) isign=-1	!draw ticks in reverse order (1/90)
	dtic2=isign*dtic(2)
	kount=0
	ntics=0
	do k=k1(2),k2(2)	!,isign
c  tick interval
	  i=mod(k,nmod(2))
	  iyl=(ibeg(2)+ifix(ntics*dtic2))/kfac-iz0
	  ixl=ix0+ifix(iyl*agicth)
	  izl=iz0+ifix(iyl*agisth)
	  if(i.eq.0 .or. .not.logm) then	!major tick or minor linear
	    call revcot(ixl,izl,x,y)
	    if(kztype.eq.2) y=log10(y)
	    if(kount.ge.41) go to 200
	    kount=kount+1
	    vztics(kount)=y
	    lzmjmn(kount)=(i.eq.0)
	    ntics=ntics+1
	  else			!minor log
	    if(nmod(2).eq.9) then
	      toff=tablog(i+1)
	    elseif(i.eq.1) then
	      toff=tablog(2)
	    else
	      toff=tablog(5)
	    endif
	    iyl=(ibeg(2)+ifix((ntics-1+toff)*dtic2))/kfac-iz0
	    ixl=ix0+ifix(iyl*agicth)
	    izl=iz0+ifix(iyl*agisth)
	    call revcot(ixl,izl,x,y)
	    if(kztype.eq.2) y=log10(y)
	    if(kount.ge.41) go to 200
	    kount=kount+1
	    vztics(kount)=y
	    lzmjmn(kount)=.false.
	  endif
	enddo
c
 200	nztics=kount
	return
	end
c%
c-------------------------------------------------------------/agigzc
c * return tick values (in user units) of the z axis
c * and show whether each is a major or minor tick (in lvltic).
c * if lvltic is true, it's major; if false, it's minor.
c * the number of values is returned in nc and will be.le.41.
c
	subroutine agigzc(nc,c,lvltic)
	implicit none
	real c(*)
	logical lvltic(*)
	integer nc 
	include 'sgiso_inc'
	integer i
c
	nc=nztics
	do i=1,nc
	  c(i)=vztics(i)
	  lvltic(i)=lzmjmn(i)
	enddo
c
	return
	end
c%
c-------------------------------------------------------------/agidya
c * draw slanted y axis
c
	subroutine agidya(ix0,iz0,ix1)
	implicit none
	integer ix0,iz0,ix1
	integer i, isign, nbase, mbase,lmaj, ivert,  ihorz
	integer ih2, lmin, iwidth, iexp
	real dmin, dtic2, comget, fac, valab, toff
	integer ntics, k, iyl, ixl, izl, iypos, ixpos
	integer len
c
	include 'sgiso_inc'
	character clabl*12
	real tablog(9)
	logical logm
	integer k1(2),k2(2),nmod(2),ibeg(2)
	real    gran(2),dtic(2)
	common /sgaxi/ k1,k2,nmod,gran,ibeg,dtic
	real    roundd, roundu         ! functions
	integer ibasey, ibasex         ! functions
c
	data tablog/ 0.,
     *	0.30103, 0.47712, 0.60206, 0.69897,
     *	0.77815, 0.84510, 0.90309, 0.95424/
c
	logm=(nmod(2).eq.3 .or. nmod(2).eq.9)
	if(logm) then
	  dmin=dymin			!value of first tick
	  dmin=roundu(dmin,1.)
	endif
	isign=1	!sign(1,k2(2)-k1(2))
	if(k2(2).lt.k1(2)) isign=-1	!draw ticks in reverse order (1/90)
	dtic2=isign*dtic(2)
c
	nbase=ibasey(0)
	mbase=ibasex(0)
	lmaj=comget(mbase+6)		!use x axis tick lengths
	call csize(ihorz,ivert)
	ih2=ihorz/2
	if(ix1.lt.ix0) then		!direction of ticks and labels
	  lmaj=-lmaj
	  ih2=-ih2
	endif
	lmin=lmaj/2			! for y, too
	iwidth=comget(nbase+17)		!width of axis labels
	iexp=comget(nbase+18)		!remote exponent
	fac=10.**(-iexp)
c
	ntics=0
	do k=k1(2),k2(2),isign
c  tick interval
	  i=mod(k,nmod(2))
	  iyl=(ibeg(2)+ifix(ntics*dtic2))/kfac-iz0
	  ixl=ix0+ifix(iyl*agicth)
	  izl=iz0+ifix(iyl*agisth)
	  if(i.eq.0) then	!major tick (linear or log)
	    call agimsu(ixl,izl)
	    call drwrel(lmaj,0)
	    call movrel(ih2,-ivert/3)
	    call seeloc(ixpos,iypos)
	    if(.not.logm) then
	      valab=k*gran(2)*fac
	    else
	      valab=dmin+ntics
	    endif
	    len=iwidth
	    call numset(valab,nbase,clabl,len)
	    call movabs(ixpos,iypos)
	    call juster(clabl,len,-lmaj)
	    ntics=ntics+1
	  elseif(logm) then	!minor tick log
	    if(nmod(2).eq.9) then
	      toff=tablog(i+1)
	    elseif(i.eq.1) then
	      toff=tablog(2)
	    else
	      toff=tablog(5)
	    endif
	    iyl=(ibeg(2)+ifix((ntics-1+toff)*dtic2))/kfac-iz0
	    ixl=ix0+ifix(iyl*agicth)
	    izl=iz0+ifix(iyl*agisth)
	    call agimsu(ixl,izl)
	    call drwrel(lmin,0)
	  else			!minor tick linear
	    call agimsu(ixl,izl)
	    call drwrel(lmin,0)
	    ntics=ntics+1
	  endif
	enddo
c
	if(iexp.ne.0) then	!.and. itype.ne.2
	  iyl=(ibeg(2)+ifix(ntics*dtic2))/kfac-iz0
	  ixl=ix0+ifix(iyl*agicth)
	  izl=iz0+ifix(iyl*agisth)
	  if(thetad.gt.90) ixl=ixl-ihorz*3
	  call remlab(nbase,+1,0,ixl*kfac,izl*kfac)
	endif
	return
	end
c%
c-------------------------------------------------------------/agilya
c * label y axis
c
	subroutine agilya(ix0,iz0,ix1,string)
	implicit none
	integer  ix0,iz0,ix1
c
	include 'sgiso_inc'
	character string*(*)
	character*80 astrin
	integer nchar, nbase
	integer iwidth, ldir, ixc
	real    xchar
	integer ibasec
	parameter (ibasec=1)
	real comget
	common /bppcom/ comget(80)
	integer iyc,linhgt,linwdt,itext,j
	real    vert,horz,w,h
	integer ibasey                ! function
c
	nchar=0
	call agtlng(string,.false.,astrin,nchar)
	if(nchar.eq.0) return
c
	nbase=ibasey(0)
cx	iytype=comget(nbase+15)
	iwidth=comget(nbase+17)
	ldir=1
	if(ix1-ix0.lt.0) ldir=-1
c
	xchar=nchar
	if(ldir.lt.0) then
	  xchar=xchar-1.8
	  iwidth=iwidth+1	!was 0.8
	endif
	iwidth=iwidth+1
c
	ixc=ix0+klengy*agicth*0.5	!midpoint of axis
	iyc=iz0+klengy*agisth*0.5
	vert=linhgt(1)/kfac
	horz=linwdt(1)/kfac
	w=agicth*vert*ldir
	h=agisth*vert*ldir
	ixc=ixc-0.5*xchar*w+ldir*(35+iwidth*horz)+agicth*vert
	iyc=iyc-0.5*xchar*h-agisth*vert
c
	if(i4105.ne.0) then
	  itext=comget(ibasec+12)
	  call agtxclr(itext)
	endif
	do j=1,nchar
	  call agimsu(ixc,iyc)
	  call agths(astrin(j:j),1)
	  ixc=ixc+w
	  iyc=iyc+h
	enddo
	return
	end
c%
c-------------------------------------------------------------/agifrm
c * draw the frame, with inside lines hidden
c
	subroutine agifrm
	implicit none
	include 'sgiso_inc'
	integer lx, lz, icurv
	integer ibasec
	parameter (ibasec=1)
	real comget
	common /bppcom/ comget(80)
c
	icurv=-1
	if(i4105.ne.0) then
	  icurv=comget(ibasec+11)	!grid color
	  call linclr(icurv)
	endif
c
	lx=ksxmax-ksxmin
	lz=kszmax-kszmin
	if(thetad.le.90.) then
c
	  call agimsu(ksxmin,kszmax)	!front,top,left
	  call agidsu(ksymxx,ksymxz+lz)	!back,top,left
	  call agidsu(ksymxx+lx,ksymxz+lz)	!back,top,right
	  call agidsu(ksymxx+lx,ksymxz)	!back,bottom,right
c
	  if(hidden) then
	  call agidvs(ksymxx+lx,ksymxz,ksymxx,ksymxz,1,0)	!was 1,1
	  call agidvs(ksymxx,ksymxz,ksymxx,ksymxz+lz,1,0)
	  call agidvs(ksxmin,kszmin,ksymxx,ksymxz,1,0)
c
	  else
	  call agidsu(ksymxx,ksymxz)	!back,bottom,left
	  call agidsu(ksymxx,ksymxz+lz)	!back,top,left
	  call agimsu(ksymxx,ksymxz)
	  call agidsu(ksxmin,kszmin)	!front,bottom,left
	  endif
c
	else		!thetad.gt.90.
c
	  call agimsu(ksxmax,kszmax)
	  call agidsu(ksymxx+lx,ksymxz+lz)
	  call agidsu(ksymxx,ksymxz+lz)
	  call agidsu(ksymxx,ksymxz)
c
	  if(hidden) then
	  call agidvs(ksymxx+lx,ksymxz,ksymxx,ksymxz,1,0)
	  call agidvs(ksymxx+lx,ksymxz,ksymxx+lx,ksymxz+lz,1,0)
	  call agidvs(ksymxx+lx,ksymxz,ksxmax,kszmin,1,0)
	  else
c
	  call agidsu(ksymxx+lx,ksymxz)
	  call agidsu(ksymxx+lx,ksymxz+lz)
	  call agimsu(ksymxx+lx,ksymxz)
	  call agidsu(ksxmax,kszmin)
	  endif
c
	endif
cx	if(icurv.ge.0) call linclr(1)	!reset
c
	return
	end
c%
c-------------------------------------------------------------/agidvs
c * draw visible part of surface line
c
	subroutine agidvs (mx1,my1,mx2,my2,idraw,imark)
c
c draw the visible part of the line connecting (mx1,my1) and (mx2,my2).
c if idraw.gt.0, the visible part of the line is drawn.
c if idraw.eq.0, the line is not drawn
c if idraw.lt.0, the entire line is drawn.
c if imark.ne.0, the visibility array is marked.
c if khside.eq.0, both top and bottom sides are drawn
c if khside.lt.0, the lower side is drawn.
c if khside.gt.0, the upper side is drawn.
c
	logical vis1,vis2
	include 'sgiso_inc'
c
	if (khside.lt.0) go to 180
	imrk = iabs(imark)
c
c draw/mark upper side.
c make line left to right.
	if (mx1.le.mx2) then
	  nx1 = mx1
	  ny1 = my1
	  nx2 = mx2
	  ny2 = my2
	else
	  nx1 = mx2
	  ny1 = my2
	  nx2 = mx1
	  ny2 = my1
	endif
	if (idraw.le.0) then
	  call agidm(nx1,ny1,nx2,ny2,idraw,imrk)	!draw and mark
	  go to 180
	endif
c
c check visibility.
	vis1 = ny1.ge.(upper(nx1))
 20	continue
c
c process vertical line.
	if (nx1.eq.nx2) then
	  vis2 = ny2.ge.(upper(nx2))
	  if (.not.(vis1 .or. vis2)) go to 180	!invisible
	  if (vis1 .and. (.not.vis2)) ny2 = upper(nx1)
	  if ((.not.vis1) .and. vis2) ny1 = upper(nx1)
	  call agidm(nx1,ny1,nx2,ny2,idraw,imrk)
	  go to 180
	endif
c
	dy = float(ny2-ny1)/float(nx2-nx1)
	if (vis1) then
c (nx1,ny1) visible, find last visible point along connecting line.
	  mx = nx1
	  my = ny1
	  do mxx=nx1+1,nx2
	    myy = ny1+ifix((mxx-nx1)*dy) !float(ny1)+float(k)*dy
	    vis2 = myy.ge.upper(mxx)	!check this point
	    if (.not.vis2) then		!if not visible
	      if(dy.lt.-steep .and. upper(mxx).gt.0) then
		mx=mxx
		my=upper(mxx)
	      endif
	      call agidm(nx1,ny1,mx,my,idraw,imrk)	!draw to (mx,my)
	      nx1 = mxx			!reset nx1,ny1
	      ny1 = myy
	      vis1 = vis2
	      go to 20			!start over
	    endif
	    mx = mxx
	    my = myy
	  enddo
	  call agidm(nx1,ny1,nx2,ny2,idraw,imrk)	!draw to (nx2,ny2)
c
	else
c (nx1,ny1) not visible, find next visible point along connecting line.
	  do mxx=nx1+1,nx2
	    myy = ny1+ifix((mxx-nx1)*dy) !float(ny1)+float(k)*dy
	    vis2 = myy.ge.upper(mxx)	!check this point
	    if (vis2) then		!if visible
	      if(dy.gt.steep .and. upper(mxx).gt.0) myy = upper(mxx)
	      nx1 = mxx			!reset nx1,ny1
	      ny1 = myy
	      vis1 = vis2
	      go to 20			!start over
	    endif
	  enddo
	endif
c
  180	if (khside.gt.0) go to 380
	imrk = -imrk
c
c draw/mark lower side.
	if (mx1.le.mx2) then
	  nx1 = mx1
	  ny1 = my1
	  nx2 = mx2
	  ny2 = my2
	else
	  nx1 = mx2
	  ny1 = my2
	  nx2 = mx1
	  ny2 = my1
	endif
	if (idraw.le.0) then
	  call agidm(nx1,ny1,nx2,ny2,idraw,imrk)	!draw and mark
	  go to 380
	endif
c
c check visibility.
	vis1 = ny1.le.(lower(nx1))
 320	continue
c
c process vertical line.
	if (nx1.eq.nx2) then
	  vis2 = ny2.le.(lower(nx2))
	  if (.not.(vis1 .or. vis2)) go to 380	!invisible
	  if (vis1 .and. (.not.vis2)) ny2 = lower(nx1)
	  if ((.not.vis1) .and. vis2) ny1 = lower(nx1)
	  call agidm(nx1,ny1,nx2,ny2,idraw,imrk)
	  go to 380
	endif
c
	dy = float(ny2-ny1)/float(nx2-nx1)
	if (vis1) then
c (nx1,ny1) visible, find last visible point along connecting line.
	  mx = nx1
	  my = ny1
	  do mxx=nx1+1,nx2
	    myy = ny1+ifix((mxx-nx1)*dy) !float(ny1)+float(k)*dy
	    vis2 = myy.le.lower(mxx)	!check this point
	    if (.not.vis2) then		!if not visible
	      if(dy.gt.steep .and. lower(mxx).lt.1024) then
		mx=mxx
		my=lower(mxx)
	      endif
	      call agidm(nx1,ny1,mx,my,idraw,imrk)	!draw to (mx,my)
	      nx1 = mxx			!reset nx1,ny1
	      ny1 = myy
	      vis1 = vis2
	      go to 320			!start over
	    endif
	    mx = mxx
	    my = myy
	  enddo
	  call agidm(nx1,ny1,nx2,ny2,idraw,imrk)	!draw to (nx2,ny2)
c
	else
c (nx1,ny1) not visible, find next visible point along connecting line.
	  do mxx=nx1+1,nx2
	    myy = ny1+ifix((mxx-nx1)*dy) !float(ny1)+float(k)*dy
	    vis2 = myy.le.lower(mxx)	!check this point
	    if (vis2) then		!if visible
	      if(dy.lt.-steep .and. lower(mxx).lt.1024) myy = lower(mxx)
	      nx1 = mxx			!reset nx1,ny1
	      ny1 = myy
	      vis1 = vis2
	      go to 320			!start over
	    endif
	  enddo
	endif
c
  380	return
	end
c%
c-------------------------------------------------------------/agidm
	subroutine agidm(nx1,ny1,nx2,ny2,idraw,imark)
c
	include 'sgiso_inc'
c
c draw visible part of line.
	if (idraw.ne.0) then
	  call agimsu(nx1,ny1)
	  call agidsu(nx2,ny2)
	endif
c
c set visibility (upper/lower) array.
	if (imark.gt.0) then
	  if (nx1.eq.nx2) then
	    ltemp = max(ny1,ny2)
	    upper(nx1) = max(upper(nx1),ltemp)
	  else
	    dy = float(ny2-ny1)/float(nx2-nx1)
	    do k=nx1,nx2
	      ltemp = ny1+ifix((k-nx1)*dy)	!float(ny1)+float(k-nx1)*dy
	      upper(k) = max(upper(k),ltemp)
	    enddo
	  endif
	elseif (imark.lt.0) then
	  if (nx1.eq.nx2) then
	    ltemp = min(ny1,ny2)
	    lower(nx1) = min(lower(nx1),ltemp)
	  else
	    dy = float(ny2-ny1)/float(nx2-nx1)
	    do k=nx1,nx2
	      ltemp = ny1+ifix((k-nx1)*dy)	!float(ny1)+float(k-nx1)*dy
	      lower(k) = min(lower(k),ltemp)
	    enddo
	  endif
	endif
	end
c%
c-------------------------------------------------------------/agimsu
c * move screen units
c
	subroutine agimsu(kxs,kzs)
	include 'sgiso_inc'
c
	call movabs(kxs*kfac,kzs*kfac)
	return
	end
c%
c-------------------------------------------------------------/agidsu
c * draw absolute user units
c
	subroutine agidsu(kxs,kzs)
	include 'sgiso_inc'
c
	call drwabs(kxs*kfac,kzs*kfac)
	return
	end
c%
c-------------------------------------------------------------/agicau
c * convert user to screen
c
	subroutine agicau(xxcoor,yycoor,zzcoor,ixs,izs)
	implicit none
	real xxcoor,yycoor,zzcoor
	integer ixs,izs

	include 'sgiso_inc'

	real    xcoor, ycoor, zcoor
	real    xs, zs, ys
c
	xcoor=xxcoor
	ycoor=yycoor
	zcoor=zzcoor
c log
	if(kxtype.eq.2) then
	  if(xcoor.gt.0) then
	    xcoor=log10(xcoor)
	  else
	    xcoor=(dxmin)		!log10 of user value in dlimx
	  endif
	endif
	if(kytype.eq.2) then
	  if(ycoor.gt.0) then
	    ycoor=log10(ycoor)
	  else
	    ycoor=log10(dymin)
	  endif
	endif
	if(kztype.eq.2) then
	  if(zcoor.gt.0) then
	    zcoor=log10(zcoor)
	  else
	    zcoor=(dzmin)		!log10 of user value in dlimy
	  endif
	endif
c
	if(zclip) then
	  zcoor=max(zcoor,dzmin)
	  zcoor=min(zcoor,dzmax)
	endif
c
	xs=xcoor*agisxm+agisxb
	zs=zcoor*agiszm+agiszb
	ys=ycoor-dymin
	ixs=xs+ys*xslope
	izs=zs+ys*zslope
	return
	end
c%
c-------------------------------------------------------------/agidzc
c * compute lines of constant z (contour lines)
c
	subroutine agidzc (z,mx,nx,ny,m,i0,j0,cl,ncl)
	implicit none
	include 'sgiso_inc'
c
c compute lines of constant z (contour lines) in one cell of the array z
c z,mx,nx,ny are the same as in srface.
c m	     by the time agidzc is first called, m contains
c	     the two-space plotter location of each z point.
c	     u(z(i,j))=m(1,i,j).  v(z(i,j))=m(2,i,j)
c i0,j0      the cell z(i0,j0) to z(i0+1,j0+1) is the one to
c	     be contoured.
c
	integer mx,nx,ny,i0,j0,ncl
	integer m(2,nx,ny)
	real    z(mx,ny), cl(ncl)
	integer kmap(6)
	integer ibasec
	parameter (ibasec=1)
	real comget
	common /bppcom/ comget(80)
	data kmap /2,3,4,5,6,7/
	integer i1, i1p1, j1, j1p1, is, ic, icurv, idub, k, kindx
	integer k1, k2, k3, k4, jump, mua
	real    ra
	integer h1, h2, h3, h4
	real    cv, rb
	integer mva, mub, mvb

C 7/16/07:CLF to mak it compile
	real r(100,100)
c ???????
C	r(ho,hu) = (ho-cv)/(ho-hu)
c ??????
	r(1,1) = 1.
	print *,'agidzc not implemented'
	if (r(1,1) .eq. 1.) return
c
	i1 = i0
	i1p1 = i1+1
	j1 = j0
	j1p1 = j1+1
	h1 = z(i1,j1)
	h2 = z(i1,j1p1)
	h3 = z(i1p1,j1p1)
	h4 = z(i1p1,j1)
	if(kztype.eq.2) then
C	  if(h1.gt.0.) h1=log10(h1)
C	  if(h2.gt.0.) h2=log10(h2)
C	  if(h3.gt.0.) h3=log10(h3)
C	  if(h4.gt.0.) h4=log10(h4)
	endif
	if (min(h1,h2,h3,h4).gt.cl(ncl)) return
	call agseet(i4105,kfac,ic,is)
	icurv=comget(ibasec+10)		!get current color (??seeclr)
	icurv=max(icurv,1)
	idub = 0
	do k=1,ncl
c
c for each contour level, decide which of the 16 basic sit-
c uations exists, then interpolate in two-space to find the
c end points of the contour line segment within this cell.
c
	  if(i4105.ne.0) then
	    kindx = mod(k,6)+1
	    call linclr(kmap(kindx))
	  endif
	  cv = cl(k)
	  k1 = (ifix(sign(1.,h1-cv))+1)/2
	  k2 = (ifix(sign(1.,h2-cv))+1)/2
	  k3 = (ifix(sign(1.,h3-cv))+1)/2
	  k4 = (ifix(sign(1.,h4-cv))+1)/2
	  jump = 1+k1+k2*2+k3*4+k4*8
	  go to (120, 30, 50, 60, 70, 20, 80, 90, 90, 80,
     1		 40, 70, 60, 50, 30,110), jump
c
   20	  idub = 1
   30	  ra = r(h1,h2)
	  mua = real(m(1,i1,j1))+ra*(m(1,i1,j1p1)-m(1,i1,j1))
	  mva = real(m(2,i1,j1))+ra*(m(2,i1,j1p1)-m(2,i1,j1))
	  rb = r(h1,h4)
	  mub = real(m(1,i1,j1))+rb*(m(1,i1p1,j1)-m(1,i1,j1))
	  mvb = real(m(2,i1,j1))+rb*(m(2,i1p1,j1)-m(2,i1,j1))
	  go to 100
   40	  idub = -1
   50	  ra = r(h2,h1)
	  mua = real(m(1,i1,j1p1))+ra*(m(1,i1,j1)-m(1,i1,j1p1))
	  mva = real(m(2,i1,j1p1))+ra*(m(2,i1,j1)-m(2,i1,j1p1))
	  rb = r(h2,h3)
	  mub = real(m(1,i1,j1p1))+rb*(m(1,i1p1,j1p1)-m(1,i1,j1p1))
	  mvb = real(m(2,i1,j1p1))+rb*(m(2,i1p1,j1p1)-m(2,i1,j1p1))
	  go to 100
   60	  ra = r(h2,h3)
	  mua = real(m(1,i1,j1p1))+ra*(m(1,i1p1,j1p1)-m(1,i1,j1p1))
	  mva = real(m(2,i1,j1p1))+ra*(m(2,i1p1,j1p1)-m(2,i1,j1p1))
	  rb = r(h1,h4)
	  mub = real(m(1,i1,j1))+rb*(m(1,i1p1,j1)-m(1,i1,j1))
	  mvb = real(m(2,i1,j1))+rb*(m(2,i1p1,j1)-m(2,i1,j1))
	  go to 100
   70	  ra = r(h3,h2)
	  mua = real(m(1,i1p1,j1p1))+ra*(m(1,i1,j1p1)-m(1,i1p1,j1p1))
	  mva = real(m(2,i1p1,j1p1))+ra*(m(2,i1,j1p1)-m(2,i1p1,j1p1))
	  rb = r(h3,h4)
	  mub = real(m(1,i1p1,j1p1))+rb*(m(1,i1p1,j1)-m(1,i1p1,j1p1))
	  mvb = real(m(2,i1p1,j1p1))+rb*(m(2,i1p1,j1)-m(2,i1p1,j1p1))
	  idub = 0
	  go to 100
   80	  ra = r(h2,h1)
	  mua = real(m(1,i1,j1p1))+ra*(m(1,i1,j1)-m(1,i1,j1p1))
	  mva = real(m(2,i1,j1p1))+ra*(m(2,i1,j1)-m(2,i1,j1p1))
	  rb = r(h3,h4)
	  mub = real(m(1,i1p1,j1p1))+rb*(m(1,i1p1,j1)-m(1,i1p1,j1p1))
	  mvb = real(m(2,i1p1,j1p1))+rb*(m(2,i1p1,j1)-m(2,i1p1,j1p1))
	  go to 100
   90	  ra = r(h4,h1)
	  mua = real(m(1,i1p1,j1))+ra*(m(1,i1,j1)-m(1,i1p1,j1))
	  mva = real(m(2,i1p1,j1))+ra*(m(2,i1,j1)-m(2,i1p1,j1))
	  rb = r(h4,h3)
	  mub = real(m(1,i1p1,j1))+rb*(m(1,i1p1,j1p1)-m(1,i1p1,j1))
	  mvb = real(m(2,i1p1,j1))+rb*(m(2,i1p1,j1p1)-m(2,i1p1,j1))
	  idub = 0
  100	  call agidvs(mua,mva,mub,mvb,1,0)	!was 1,1
	  if(idub.lt.0) go to 90
	  if(idub.gt.0) go to 70
  110	enddo
  120	continue
	if(i4105.ne.0) then
	  call linclr(icurv)		!reset color
	endif
	return
	end
c%

C******************** START FILE GSCSET.FOR ; GROUP GSCALE ******************
C-----------------------------------------------------------
C  GSCSET    SET SCALE IN ACCORDANCE WITH CONTROLS IN
C            GSC001 COMMON
C
C  MOD DMC 2/86 - BROKEN UP INTO SUBROUTINES CF GSCMMX, GSCST0
C
      SUBROUTINE GSCSET(X,Y,Y2,I2,N)
C
C    X,Y,N   DATA TO BE GRAPHED
C    X,Y2,N   2ND SET OF DATA TO BE GRAPHED IF I2 .NE. 0
C
C       GRAPHICS BY "DPLOT1.FOR" USING DPLOT1 COMMON TO
C   CONTROL SCALE OF GRAPH
C
C  AXIS TYPES COMMON--
C
      INCLUDE 'GAXES_BLK'
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
C  X IN ASCENDING ORDER
      DIMENSION X(N),Y(N),Y2(N)
C
      INCLUDE 'PLOT1MMX'
C
C  START OF EXECUTABLE CODE
C
      DATA ZINFIN/1.E38/
C
C  FIND MIN/MAX OF DATA X, Y (FOR AUTOSCALING)
C
      IF(IGSINI.EQ.0) CALL GSCINI
      IF(IGXINI.EQ.0) CALL GAXES0
C
C  COMPUTE AUTOSCALE
C
      ZINFNN=-ZINFIN
      CALL GSCMMX(X,N,Y,Y2,I2,N,1,1,1,1,N,ZINFNN,ZINFIN,0)
C
C  SAVE AUTOSCALE
C
      CALL GSCSV0
C
C  SET X AXIS SCALE
C
      CALL GSCXDF(0)
C
C  IF SCALE WAS REDUCED FROM X AXIS MIN/MAX, RESET VERT AUTOSCALE
C  DATA
C
      IF((XMIN.NE.GMINX).OR.(XMAX.NE.GMAXX))
     >       CALL GSCMMX(X,N,Y,Y2,I2,N,1,1,1,1,N,XMIN,XMAX,1)
C
C  SET Y AXIS SCALE
C
      CALL GSCYDF(0)
C
      RETURN
      END

subroutine frantic_trackr(ZELEV)
  !
  !  THIS ROUTINE WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
  !  PLASMA PHYSICS LAB.  THIS ROUTINE WILL TRACK A GIVEN
  !  TRAJECTORY THROUGH THE MESH FOR A GIVEN Y.  IT WILL CALCULATE
  !  THE NUMBER OF BOUNDARIES CROSSED (NBCROS), THE NUMBER OF
  !  THE ZONE CROSSED FROM LEFT TO RIGHT (NZCROS(I)) AND THE
  !  PATH LENGTH IN EACH ZONE (DIST(I)).
  !
  !  parameter:
  !  ELEV  - THE DISTANCE OF CLOSEST APPROACHED.  (CM)
  !
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: two
  use frantic_module
  implicit none
  !
  ! Argument variables:
  real(fp), intent(in) :: zelev
  ! Locat variables:
  integer :: i,ic,imzone,ip,im,imzp1
  real(fp) :: zelev2,zrb,zdistm,zdistp,zxdist
  ZELEV2=ZELEV*ZELEV
  !  I NOW LOOP OVER ALL BOUNDARIES TO FIND THE BOUNDARY WHICH
  !  IS GREATER THAN Y.
  do I=2,NBOUND
    IC=I
    ZRB=RBOUND(I)
    if(ZRB.GE.ZELEV) GO TO 20
  end do
  !  MZONE CONTAINS THE ZONE NUMBER FOR THE CENTER REGION.
20 IMZONE=IC-1
  !  NBCROS CONTAINS THE NUMBER OF BOUNDARIES CROSSED = NUMBER OF ZONES
  !  TRAJECTORY PASSED THROUGH.
  NBCROS=2*(NZONEC-IMZONE)+1
  !  I NOW FIND THE ARRAY ELEMENT FOR THE MID ZONE.
  MID=NBCROS/2+1
  !  I NOW FILL NZCROS AND DIST FOR THE CENTER REGION.
  NZCROS(MID)=IMZONE
  ZDISTM=SQRT(ZRB*ZRB-ZELEV2)
  DIST(MID)=TWO*ZDISTM
  if(MID.EQ.1) GO TO 40
  !  DUE TO SYMMETRY I NOW ONLY HAVE TO LOOP OVER MID-1 POINTS
  !  TO FILL UP DIST AND NZCROS ARRAYS
  do I=1,MID-1
    IP=MID+I
    IM=MID-I
    IMZP1=IMZONE+I
    ZDISTP=SQRT(RBOUND(IC+I)**2-ZELEV2)
    ZXDIST=ZDISTP-ZDISTM
    ZDISTM=ZDISTP
    NZCROS(IP)=IMZP1
    NZCROS(IM)=IMZP1
    DIST(IP)=ZXDIST
    DIST(IM)=ZXDIST
  end do
40 continue
  return
end subroutine frantic_trackr

subroutine frantic_radius(ispline,inxb_user,zxb_user,zvolxb_user,zrmajxb_user)

  use iso_c_binding, only: fp => c_double
  use ezspline_type, only: ezspline1
  use ezspline, only: ezspline_init, ezspline_free, ezspline_setup, ezspline_interp
  use frantic_module

  !  set up FRANTIC radial grid, based on zone volumes...

  implicit none

  integer, intent(in) :: ispline     ! =1 for splines of Vol(x), Rmaj(x)
  ! =0 for Hermite.
  ! if =1 enforce Vol'(0)=0, Rmaj'(0)=0.

  integer, intent(in) :: inxb_user   ! no. of user grid bdys
  real(fp), intent(in) :: zxb_user(inxb_user)  ! grid bdys (asdending in [0,1])
  real(fp), intent(in) :: zvolxb_user(inxb_user)  ! volumes inside bdys (m**3)
  real(fp), intent(in) :: zRmajxb_user(inxb_user) ! major radius at bdys (m)

  !--------------------------------------
  ! local

  real(fp) :: zpi,zr0vec(nzonec+1)
  integer :: iok,j,bcs(2)

  type(ezspline1) :: spline_vol   ! V(x) spline
  type(ezspline1) :: spline_rmj   ! R(x) spline

  zpi = 3.1415926535897931_fp

  !--------------------------------------
  !  allocate module arrays & copy data

  nxb_user = inxb_user
  nx_user = nxb_user - 1
  allocate(x_user(nx_user),xb_user(nxb_user))
  allocate(volxb_user(nxb_user),Rmajxb_user(nxb_user))

  xb_user = zxb_user
  x_user = (xb_user(1:nxb_user-1)+xb_user(2:nxb_user))/2
  volxb_user = zvolxb_user*1.0e6_fp   ! cm**3 inside FRANTIC
  Rmajxb_user = zRmajxb_user*1.0e2_fp ! cm inside FRANTIC

  !--------------------------------------
  !  create splines of Vol(x) and Rmaj(x)

  if(ispline.eq.1) then
    bcs = (/1, 0/)
  else
    bcs = (/0, 0/)
  end if

  call ezspline_init(spline_vol,nxb_user,bcs,iok)
  if(iok.ne.0) call errmsg_exit(' ?ezspline_init error in frantic.')
  call ezspline_init(spline_rmj,nxb_user,bcs,iok)
  if(iok.ne.0) call errmsg_exit(' ?ezspline_init error in frantic.')

  if(ispline.eq.1) then
    spline_vol%bcval1min=0  ! dV/dx = 0
    spline_rmj%bcval1min=0  ! dR/dx = 0
  else
    spline_vol%isHermite=1
    spline_rmj%isHermite=1
  end if

  spline_vol%x1 = xb_user
  spline_rmj%x1 = xb_user

  call ezspline_setup(spline_vol,volxb_user,iok)
  if(iok.ne.0) call errmsg_exit(' ?ezspline_setup error in frantic.')
  call ezspline_setup(spline_rmj,rmajxb_user,iok)
  if(iok.ne.0) call errmsg_exit(' ?ezspline_setup error in frantic.')

  !--------------------------------------

  call ezspline_interp(spline_vol,nzonec+1,xb,tvol,iok)
  if(iok.ne.0) call errmsg_exit('?frantic_radius: ezspline_interp error(vol).')

  call ezspline_interp(spline_rmj,nzonec+1,xb,zr0vec,iok)
  if(iok.ne.0) call errmsg_exit('?frantic_radius: ezspline_interp error(rmj).')

  rbound(1)=0
  do j=1,nzonec
    rbound(j+1)=sqrt(tvol(j+1)/(zpi*2*zpi*zr0vec(j+1)))
    ! minor radii of surfaces...(cm) ~ sqrt ( [V/(2*pi*R)]/pi )
    VOL(j)=zpi*(RBOUND(j+1)*RBOUND(j+1)-RBOUND(j)*RBOUND(j))
  end do

  aminor = rbound(nzonec+1)

  !  Radius at zone centers-- for angular momentum treatment

  call ezspline_interp(spline_rmj,nzonec,x,rmjrmp,iok)
  if(iok.ne.0) call errmsg_exit('?frantic_radius: ezspline_interp error(rmj).')

  call ezspline_free(spline_rmj,iok)
  if(iok.ne.0) call errmsg_exit('?frantic_radius: ezspline_free error(rmj).')
  call ezspline_free(spline_vol,iok)
  if(iok.ne.0) call errmsg_exit('?frantic_radius: ezspline_free error(vol).')

  return
end subroutine frantic_radius

subroutine frantic_profile_set(indx,spline_n,spline_t,spline_v)

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  use ezspline, only: ezspline_interp
  use ezspline_type, only: ezspline1
  use frantic_module

  !  set up FRANTIC density temperature and velocity profile for
  ! indicated specie:
  !    indx=0 for ELECTRONS
  !    indx=ig for thermal specie #ig
  !    indx=mig+ix for IMPURITY

  implicit none

  integer, intent(in) :: indx       ! specie index
  type(ezspline1), intent(in) :: spline_n   ! n(x) spline
  type(ezspline1), intent(in) :: spline_t   ! T(x) spline
  type(ezspline1), intent(in) :: spline_v   ! v(x) spline

  !-----------------------------------

  integer :: iok,indu,indux,i
  logical :: impur,irenorm
  real(fp) :: zbuf(nzonec),zbufn(nzonec),znlim
  real(fp), parameter :: C100TH = 0.010_fp

  !-----------------------------------
  if(indx.eq.0) then
    indu=1  ! electron data
    impur=.FALSE.
  else if(indx.le.mig) then
    indu=indx+2  ! non-impurity ion data
    impur=.FALSE.
  else if(indx.le.mix-2) then
    indu=2       ! impurity data
    indux=indx+2
    impur=.TRUE.
  else
    write(lun6,*) ' %FRANTIC -- frantic_profile_set warning: ', &
         'unexpected specie index: ',indx
    return
  end if

  if(impur) then
    if(npro_set(indux)) then
      write(lun6,*) ' %FRANTIC -- frantic_profile_set warning: ', &
           'profiles already set for impurity: ',indux
      return
    end if
  else
    if(npro_set(indu)) then
      write(lun6,*) ' %FRANTIC -- frantic_profile_set warning: ', &
           'profiles already set for specie: ',indx
      return
    end if
  end if

  call ezspline_interp(spline_n,nzonec,x,zbufn,iok)  ! in m**-3
  if(iok.ne.0) call errmsg_exit( &
       '?frantic_profile_set: ezspline_interp error on spline_n')
  if(impur) then
    lzpflag=.TRUE.
    zbufn=1.0e-6_fp*zbufn
    den(1:nzonec,2)=den(1:nzonec,2)+zbufn
    xzimpj(1:nzonec)=xzimpj(1:nzonec)+xzplas(indux)*zbufn
    aimpj(1:nzonec)=aimpj(1:nzonec)+aplas(indux)*zbufn
  else
    den(1:nzonec,indu)=1.0e-6_fp*zbufn               ! convert to cm**-3
    if(nimp.eq.0) den(1:nzonec,2)=0
  end if

  call ezspline_interp(spline_t,nzonec,x,zbuf,iok) ! in KeV
  if(iok.ne.0) call errmsg_exit( &
       '?frantic_profile_set: ezspline_interp error on spline_t')
  if(impur) then
    temp(1:nzonec,indu)=temp(1:nzonec,indu)+zbufn*zbuf
  else
    temp(1:nzonec,indu)=zbuf
    if(nimp.eq.0) temp(1:nzonec,2)=zbuf
  end if

  call ezspline_interp(spline_v,nzonec,x,zbuf,iok) ! in m/sec
  if(iok.ne.0) call errmsg_exit( &
       '?frantic_profile_set: ezspline_interp error on spline_v')
  if(impur) then
    vphiz(1:nzonec,indu)=vphiz(1:nzonec,indu)+100.0_fp*zbuf*zbufn
  else
    vphiz(1:nzonec,indu)=100.0_fp*zbuf             ! convert to cm/sec
    if(nimp.eq.0) vphiz(1:nzonec,2)=100.0_fp*zbuf
  end if

  if(impur) then
    npro_set(indux)=.TRUE.
    irenorm=.TRUE.
    do i=mig+3,mig+2+nimp
      irenorm=irenorm.AND.npro_set(i)
    end do
    if(irenorm) then
      npro_set(indu)=.TRUE.  ! impurity data all in hand now
      do i=1,nzonec
        if(den(i,indu).le.0) then
          temp(i,indu)=1
          vphiz(i,indu)=0
          xzimpj(i)=8.888888888_fp
          aimpj(i)=2*xzimpj(i)
        else
          temp(i,indu)=temp(i,indu)/den(i,indu)
          vphiz(i,indu)=vphiz(i,indu)/den(i,indu)
          xzimpj(i)=xzimpj(i)/den(i,indu)
          aimpj(i)=aimpj(i)/den(i,indu)
        end if
      end do
    end if
  else
    npro_set(indu)=.TRUE.
  end if

  !
  ! set limits on temperature
  !
  temp(1:nzonec,indu) = max(C100TH, temp(1:nzonec,indu))  ! limit by 10 eV

  !
  ! set limits on density
  !
  znlim = 1.e-4*max(ZERO, maxval(den(1:nzonec,indu)))    ! max dynamic range = 1.e-4
  den(1:nzonec,indu) = max(znlim, den(1:nzonec,indu))

  return
end subroutine frantic_profile_set

subroutine frantic_impurity_zaprof(spline_Z,spline_A,ierr)

  use iso_c_binding, only: fp => c_double
  use ezspline_type, only: ezspline1
  use ezspline, only: ezspline_interp
  use frantic_module

  !  set up FRANTIC impurity avg Z and avg A profiles

  implicit none

  type(ezspline1), intent(in) :: spline_Z   ! Z(x) spline
  type(ezspline1), intent(in) :: spline_A   ! A(x) spline
  integer, intent(out) :: ierr

  !-----------------------------------

  integer iok

  !-----------------------------------

  ierr=0

  if(nimp.ne.1) then
    write(lun6,*) ' ?frantic_impurity_zaprof:  Nimp = ',nimp
    write(lun6,*) '  this routine can only be used if the number ', &
         'of impurities is exactly one.'
    ierr=99
    return
  end if

  call ezspline_interp(spline_Z,nzonec,x,xzimpj(1:nzonec),iok)
  if(iok.ne.0) call errmsg_exit( &
       '?frantic_impurity_zaprof: ezspline_interp error on spline_Z')

  call ezspline_interp(spline_A,nzonec,x,aimpj(1:nzonec),iok)
  if(iok.ne.0) call errmsg_exit( &
       '?frantic_impurity_zaprof: ezspline_interp error on spline_A')

  if((aimpj(1).lt.1.5*xzimpj(1)).or.xzimpj(1)<1.) then
    write(lun6,*) ' ?frantic_impurity_zaprof:  A < 1.5*Z on axis:'
    write(lun6,*) '  aimpj(1)=',aimpj(1),'  xzimpj(1)=',xzimpj(1)
    write(lun6,*) ' ***> likely error in profile spline arguments <*** '
    ierr=1
  else
    lzpflag = .TRUE.   ! signals presence of Z & A impurity profile data.
    xzplas(2)=6.66666666666666_fp
    aplas(2)=2*xzplas(2)
  end if

  return
end subroutine frantic_impurity_zaprof

subroutine frantic_neutral_specie(z0,a0,i0map)

  use iso_c_binding, only: fp => c_double
  use frantic_module

  implicit none

  !  define species of neutral source;
  !  return table indicating which neutral species will be created
  !  (via charge exchange) due to this source...

  real(fp), intent(in) :: z0           ! Z of neutral specie
  real(fp), intent(in) :: a0           ! A of neutral specie

  integer, intent(out) :: i0map(mig) ! list of neutral species:

  !  if i0map(ig)=0 on output, then, gas specie (ig) does not have
  !     neutrals created due to this neutral source (because Z(ig) > z0).
  !  if i0map(ig)=ik then gas specie (ig) is the ik'th neutal specie
  !     created due to this neutral source.

  !-------------------------------------------------

  integer ig,ik,iz0
  real(fp) zgmin

  real(fp), parameter :: zsmall = 0.1_fp

  !-------------------------------------------------

  i0map=0

  nspec=0
  ik=0

  ninldx=0
  zgmin=999999  ! a big atomic number

  nneut_s0p=nneut_s0
  do ig=1,mig
    if(xzplas(ig+2).le.(z0+zsmall)) then
      ik=ik+1
      i0map(ig)=ik
      nspec(ik)=ig+2  ! corresponding ion specie index
      if(xzplas(ig+2).lt.zgmin) then
        zgmin=xzplas(ig+2)
        ninldx=ik    ! index to lowest Z neutral specie
      end if
      if((abs(xzplas(ig+2)-z0).le.zsmall).and. &
           (abs(aplas(ig+2)-a0).le.zsmall)) then
        nneut_s0=ik
      end if
    end if
  end do

  nneut=ik

  iz0=z0+zsmall

  if((nneut_s0p.ne.nneut_s0).or.(nneut_z0p.ne.iz0)) then
    mcflag=.TRUE.  ! update transfer matrix
  else
    mcflag=.FALSE.
  end if

  nneut_z0p=iz0

  ! clear fast ion rate arrays

  bcx=0; bcxs=0; bii=0

  return
end subroutine frantic_neutral_specie

subroutine frantic_bsink_ii(ik,spline_bii)

  use iso_c_binding, only: fp => c_double
  use ezspline_type, only: ezspline1
  use ezspline, only: ezspline_interp
  use frantic_module

  implicit none

  !  set up ionization sink due to effect of fast ions
  !  this quantity summed over all fast ion species

  integer, intent(in) :: ik    ! neutral specie index
  type (ezspline1), intent(in) :: spline_bii   ! bii(x) spline

  integer :: iok  ! error flag

  !-------------------------------------------------------

  call ezspline_interp(spline_bii,nzonec,x,bii(1:nzonec,ik),iok)
  if(iok.ne.0) call errmsg_exit('?frantic_bsink: ezspline_interp (bii) error!')

  return
end subroutine frantic_bsink_ii

subroutine frantic_bsink_cx(ik,isb,spline_bcx)

  use iso_c_binding, only: fp => c_double
  use ezspline_type, only: ezspline1
  use ezspline, only: ezspline_interp
  use frantic_module

  implicit none

  !  set up cx neutral sink due to effect of a single fast ion specie

  integer, intent(in) :: ik,isb    ! neutral specie index; fast specie index
  type (ezspline1), intent(in) :: spline_bcx   ! bcx(x) spline

  integer :: iok  ! error flag

  !-------------------------------------------------------

  call ezspline_interp(spline_bcx,nzonec,x,bcxs(1:nzonec,ik,isb),iok)
  if(iok.ne.0) call errmsg_exit('?frantic_bsink: ezspline_interp (bcx) error!')

  ! compute sum

  bcx(1:nzonec,ik)=bcx(1:nzonec,ik)+bcxs(1:nzonec,ik,isb)

  return
end subroutine frantic_bsink_cx

subroutine frantic_edge_source(zflux,zengy)

  use iso_c_binding, only: fp => c_double
  use frantic_module

  implicit none

  !  set up edge source

  real(fp), intent(in) :: zflux   ! ptcls/m**2/sec
  real(fp), intent(in) :: zengy   ! "Temperature" (KeV) of source

  !------------------------------------------------

  esflag=.TRUE.
  vsflag=.FALSE.

  fluxi0=0
  twall=zengy
  vphi_wall=0
  volsor=0

  fluxi0(nneut_s0)=zflux*1.0e-4_fp   ! ptcls/cm**2/sec in FRANTIC

  return
end subroutine frantic_edge_source

subroutine frantic_edge_vphi(zveloc)

  use iso_c_binding, only: fp => c_double
  use frantic_module

  implicit none

  !  set edge source v_phi
  !  This routine to be called IMMEDIATELY AFTER call to frantic_edge_source
  !  If it is not called, the edge source v_phi is left at zero.

  real(fp), intent(in) :: zveloc  ! toroidal velocity, m/sec

  !------------------------------------------------

  vphi_wall = 100.0_fp*zveloc  ! cm/sec in FRANTIC

  return
end subroutine frantic_edge_vphi

subroutine frantic_volume_source(zflux,spline_volsor)

  use iso_c_binding, only: fp => c_double
  use ezspline_type, only: ezspline1
  use ezspline, only: ezspline_interp
  use frantic_module

  implicit none

  ! set up volume source

  real(fp), intent(in) :: zflux   ! ptcls/m**2/sec edge flux equivalent
  ! to this volume source
  ! if zflux<=0, consider spline_volsor
  ! to already be normalized;

  type(ezspline1), intent(in) :: spline_volsor  
  ! volume source profile shape
  ! renormalized to zflux if zflux > 0
  ! if zflux <= 0, the profile is not
  ! renormalized: units of #/m^3/sec expected!

  !------------------------------------------------

  integer :: iok  ! spline error flag
  integer :: ik,i

  real(fp) :: zvoli,zsumi,zpi,zfac

  !------------------------------------------------
  !  set up volume source

  esflag=.FALSE.
  vsflag=.TRUE.

  fluxi0=0
  twall=0
  volsor=0

  fluxi0(nneut_s0)=zflux*1.0e-4_fp   ! ptcls/cm**2/sec in FRANTIC
  ! normalized equivalent volume source

  ik=nneut_s0

  call ezspline_interp(spline_volsor,nzonec,x,volsor(1:nzonec,ik),iok)
  if(iok.ne.0) call errmsg_exit('?frantic_volume_source: ezspline error.')

  ! renormalize the profile

  zsumi=0
  do i=1,nzonec
    zvoli=vol(i)  ! volume per unit length in cylinder...
    zsumi=zsumi+zvoli*volsor(i,ik)
  end do
  zsumi=zsumi/(aminor*6.2831853071795862_fp) ! convert to edge flux...

  zfac=0.0_fp
  if(zflux.gt.0.0_fp) then
    if(zsumi.gt.0) zfac = fluxi0(nneut_s0)/zsumi
    volsor(1:nzonec,ik)=zfac*volsor(1:nzonec,ik)
  else
    ! NOT renormalized to zflux
    zfac=1.0e-6_fp  ! so convert now to #/cm^3/sec
    volsor(1:nzonec,ik)=zfac*volsor(1:nzonec,ik)
    fluxi0(nneut_s0)=zsumi*zfac
  end if

  return
end subroutine frantic_volume_source

subroutine frantic_source_echo(zA,zZ,zFlux,zEngy,zVphi,ivs_flag,ik)

  use iso_c_binding, only: fp => c_double
  use frantic_module

  implicit none

  real(fp), intent(out) :: zA,zZ   ! specie of neutral source (AMU,Atomic #)
  real(fp), intent(out) :: zFlux   ! magnitude of source (#/m**2/sec)
  real(fp), intent(out) :: zEngy   ! <energy> of source (KeV)
  real(fp), intent(out) :: zVphi   ! toroidal velocity (m/sec)
  logical, intent(out) :: ivs_flag ! volume source flag (T/F)
  integer, intent(out) :: ik     ! index to source neutral specie

  !----------------------------------------

  integer :: i,ink

  real(fp) :: zpi,zvoli,zVsum

  !----------------------------------------

  ik=nneut_s0
  ink=nspec(ik)
  zA=aplas(ink)
  zZ=xzplas(ink)
  zFlux=fluxi0(ik)*1.0e4_fp  ! to MKS

  ivs_flag=vsflag

  if(.not.ivs_flag) then
    zEngy=1.5_fp*twall(ik)
    zVphi=0.01_fp*vphi_wall(ik)  ! to m/s
  else
    zEngy=0
    zVphi=0
    zVsum=0
    do i=1,nzonec
      zvoli=tvol(i+1)-tvol(i)
      zVsum=zVsum+zvoli*volsor(i,ik)
      zEngy=zEngy+zvoli*volsor(i,ik)*1.5_fp*temp(i,ink)
      zVphi=zVphi+zvoli*volsor(i,ik)*vphiz(i,ink)*0.01_fp  ! v_phi -> m/s
    end do
    if(zVsum.gt.0) then
      zEngy=zEngy/zVsum
      zVphi=zVphi/zVsum
    else
      zEngy=0
      zVphi=0
    end if
  end if

  return
end subroutine frantic_source_echo

subroutine frantic_nneut_echo(ineut)

  !  return number of neutral species

  use frantic_module
  implicit none

  integer, intent(out) :: ineut  ! the number

  ineut = nneut

  return
end subroutine frantic_nneut_echo

subroutine frantic_iindx_echo(ik,ink)

  !  return ion species index, given neutral species index

  use frantic_module
  implicit none

  integer, intent(in) :: ik         ! selected neutral specie
  integer, intent(out) :: ink       ! corresponding ion specie returned

  !-----------------------------

  if((ik.ge.1).and.(ik.le.nneut)) then
    ink=nspec(ik)
  else
    ink=0
  end if

  return
end subroutine frantic_iindx_echo

subroutine frantic_za_echo(ik,zA,zZ,zFlux)

  !  return A,Z, flux of indicated neutral specie

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  integer, intent(in) :: ik         ! selected neutral specie
  real(fp), intent(out) :: zA,zZ    ! A & Z
  real(fp), intent(out) :: zFlux    ! inFlux (0 except for source specie)

  integer :: ink

  !------------------------------

  if((ik.ge.1).and.(ik.le.nneut)) then
    ink=nspec(ik)

    zA=Aplas(ink)
    zZ=xZplas(ink)

    zFlux=fluxi0(ik)*1.0e4_fp  ! to MKS

  else
    zA=0
    zZ=0
    zFlux=0
  end if

  return
end subroutine frantic_za_echo

subroutine frantic_get_nx_user(izones)

  use frantic_module
  implicit none
  integer, intent(out) :: izones  ! no. of user zones

  ! this is the number of zones in FRANTIC output profiles
  ! after interpolation

  izones = nx_user

  return
end subroutine frantic_get_nx_user

subroutine frantic_set_atomic(i_atomicdata)
! set frantic module with frantic_atomic data model
! default frantic_atomic=1 -- legacy of PREACT atomic physics
!
                        ! 2 -- ADAS atomic physics for H and He beams.
                        !      He beam -- only ground state model available
                        ! 3 -- PREACT ground state atomic physics
                        !      ADAS interaction with impurities
                        ! 4 -- ADAS ground state atomic physics
                        !      PREACT interaction with impurities

  use frantic_module
  implicit none
  integer, intent(in) :: i_atomicdata

  frantic_atomic=i_atomicdata

  return
end subroutine frantic_set_atomic

!
! C callable versions of the periodic table routines.  Only the pseudo-periodic table
! versions are implemented here.  The C++ declarations are in periodic_table.h
!
 
#include "fpreproc/byte_declare.h"
 
!
! ---------------------- cignore_user_amu ---------------
! set get periodic_table::ignore_user_AMU

subroutine cignore_user_amu(i)
  use periodic_table_mod
  implicit none

  integer :: i    ! -1 -> return ignore_user_AMU
                  !  0 -> set ignore_user_AMU=.false.
                  !  1 -> set ignore_user_AMU=.true.

  if (i>=0) then
     ignore_user_AMU = i>0
  end if

  if (ignore_user_AMU) then
     i=1
  else
     i=0
  end if
end subroutine cignore_user_amu

!
! ---------------------- cignore_electron_amu ---------------
! set get periodic_table::ignore_electron_AMU

subroutine cignore_electron_amu(i)
  use periodic_table_mod
  implicit none

  integer :: i    ! -1 -> return ignore_electron_AMU
                  !  0 -> set ignore_electron_AMU=.false.
                  !  1 -> set ignore_electron_AMU=.true.

  if (i>=0) then
     ignore_electron_AMU = i>0
  end if

  if (ignore_electron_AMU) then
     i=1
  else
     i=0
  end if
end subroutine cignore_electron_amu

!
! ---------------------- cps_params ---------------
! set get periodic_table::ps_params

subroutine cps_params(i)
  use periodic_table_mod
  implicit none

  integer :: i    ! -1 -> return ps_params
                  !  0 -> set ps_params=.false.
                  !  1 -> set ps_params=.true.

  if (i>=0) then
    ps_params = i>0
  end if

  if (ps_params) then
    i=1
  else
    i=0
  end if

  return
end subroutine cps_params

!
! --------------------- cto_periodic_table ---------------------
! return the periodic table symbol except the isotopes of hydrogen
! are returned as H,D,T if ipseudo/=0
!
! cout = null terminated char* with space for at least 12 characters+null
!
! extern "C" void cto_periodic_table(const int& ipseudo, const int& z, const float& a,
!                                    const int& charge,  const int& isymbol, char* cout)
!
subroutine cto_periodic_table(ipseudo, z, a, charge, isymbol, cout)
  use periodic_table_mod
  implicit none
 
  integer, intent(in) :: ipseudo ! 0 -> standard periodic table
                                 ! 1  -> return H,D,T for hydrogen isotopes
  integer, intent(in) :: z       ! the atomic number of the element
  real(fp), intent(in) :: a      ! the atomic weight of the element
  integer, intent(in) :: charge  ! the charge on the element
  integer, intent(in) :: isymbol ! symbol to use to separate element name and charge
                                 ! 0 -> _  this is an underscore
                                 ! 1 -> +
 
  byte_declare, intent(out) :: cout(13) ! the null terminated symbol returned
                                        ! from to_pseudo_periodic_table
 
  character(len=12) :: cin              ! buffer for fortran symbol
 
  cin = to_pseudo_periodic_table(ipseudo, z, a, charge, isymbol)
 
  call cstring(cin,cout,'2C')

  return
end subroutine cto_periodic_table
 
 
!
! --------------------- cinv_periodic_table ---------------------
!
! return the inv_periodic_table data where the hydrogen isotopes
! are given by H,D,T if ipseudo/=0
!
! symbol = null terminated char* with no more then 12 characters
!
! extern "C" void cinv_periodic_table(const int& ipseudo, const char* symbol,
!                                     const int& idefault, int& z, float& a, int& charge)
!
subroutine cinv_periodic_table(ipseudo, symbol, idefault, z, a, charge)
  use periodic_table_mod
  implicit none
 
  integer, intent(in)      :: ipseudo   ! 0 -> standard periodic table
                                        ! 1 -> use H,D,T for hydrogen isotopes
  byte_declare, intent(in) :: symbol    ! null terminated string containing element (e.g. 'C12+4 ')
                                        ! must be left justified
  integer, intent(in)      :: idefault  ! nonzero to return an atomic weight even
                                        ! if data is not contained in the string
 
  integer, intent(out) :: z             ! atomic number of the element
  real(fp), intent(out) :: a            ! atomic weight of the element
  integer, intent(out) :: charge        ! charge state of the element
 
  logical           :: default
  character(len=12) :: fsymbol
 
  default = (idefault/=0)
  call cstring(fsymbol,symbol,'2F')
  call inv_pseudo_periodic_table(ipseudo, fsymbol, default, z, a, charge)

  return
end subroutine cinv_periodic_table
 
!
! -------------------- cname_periodic_table --------------------
!
! return the name of the element with the atomic number if A>0,
! the hydrogen isotopes will be returned as their name if ipseudo>0
!
! cout = null terminated char* with space for at least 16 characters+null
!
! extern "C" void cname_periodic_table(const int& ipseudo, const int& z, const float& a, char* cout)
!
subroutine cname_periodic_table(ipseudo, z, a, cout)
  use periodic_table_mod
  implicit none
 
  integer, intent(in) :: ipseudo ! 0 -> standard periodic table
                                 ! 1  -> return H,D,T for hydrogen isotopes
  integer, intent(in) :: z       ! the atomic number of the element
  real(fp), intent(in) :: a      ! the atomic weight of the element
 
  byte_declare, intent(out) :: cout(16) ! the null terminated symbol returned
                                        ! from name_pseudo_periodic_table
 
  character(len=16) :: cin       ! buffer for fortran name
 
  cin = name_pseudo_periodic_table(ipseudo, z, a)
 
  call cstring(cin,cout,'2C')

  return
end subroutine cname_periodic_table

!
! -------------------- cname_periodic_table --------------------
!
! return the name of the element with the atomic number if A>0,
! the hydrogen isotopes will be returned as their name if ipseudo>0
!
! cout = null terminated char* with space for at least 16 characters+null
!
! extern "C" void cname_periodic_table(const int& ipseudo, const int& z, const float& a, char* cout)
!
subroutine ctr_species_convert_r8(iZatom, iZcharge, zAMU, qatom, qcharge, mass, ierr)
  use periodic_table_mod
  implicit none
 
  integer :: iZatom    ! atomic number: 1 for H, 2 for He, ...

  integer :: iZcharge  ! ionic charge btw 1 and iZatom

  REAL*8  :: zAMU      ! atomic weight in AMU, nearest integer

  REAL*8  :: qatom     ! charge of fully stripped ion
  REAL*8  :: qcharge   ! actual charge
  REAL*8  :: mass      ! mass in kg

  integer :: ierr      ! status code, 0=OK

  integer :: i,j

  !
  !Used to create element_index() array
  !
  !do i=1, 109
  !   write(*,'(i3,a)',advance='no') j,', '
  !end do

  call tr_species_convert_r8(iZatom, iZcharge, zAMU, qatom, qcharge, mass,ierr)
end subroutine ctr_species_convert_r8

C----------------------------------------------------------------
C  GFTIC0:  SET UP DEFAULT VALUES, GFTIC BLOCK
C
      SUBROUTINE GFTIC0
C
      INCLUDE 'GFTIC'
C
C  TIC MARK NEAT CONTROLS
C
      KNEAT0=1
      KNEATX=KNEAT0
      KNEATY=KNEAT0
      KNEATMIN=0
      KNEATMAX=2
C
C  MAJOR TIC MARK TYPE CONTROLS
C
      KFRAM0=2
      KFRAMX=KFRAM0
      KFRAMY=KFRAM0
      KFRAMMIN=1
      KFRAMMAX=6
C
C  MINOR TIC MARK TYPE CONTROLS
C
      KFRMM0=2
      KFRMMX=KFRMM0
      KFRMMY=KFRMM0
      KFRMMMIN=1
      KFRMMMAX=6
C
C  MAJOR TIC MARK DENSITY CONTROLS
C
      KFRAC0=3
      KFRACX=KFRAC0
      KFRACY=KFRAC0
      KFRACMIN=0
      KFRACMAX=4
C
C  MINOR TIC MARK DENSITY CONTROLS
C
      KFRMC0=3
      KFRMCX=KFRMC0
      KFRMCY=KFRMC0
      KFRMCMIN=1
      KFRMCMAX=4
C
C---------------------------------------------
C  2D PLOT SIZE (GRFUF1/UGRAF1 PLOTS ONLY, NOT MULTIGRAPHS
C
      NXR1=150
      NXR2=950
      NYR1=125
      NYR2=700
      NRSET=1
C
C  LINE/SYMBOL TYPE SELECTION CODES
      KLINTP=0
      KSYMTP=0
      KSYLTP=0
C
C  USER ADJUSTABLE SYMBOL SIZE CONTROLS
      SGSYSZ=1.2
      SGSLSZ=0.6
C
C  LINE STYLE CODES
      LNSTYL(1)=0
      LNSTYL(2)=14
      LNSTYL(3)=34
      LNSTYL(4)=54
      LNSTYL(5)=74
      LNSTYL(6)=2
      LNSTYL(7)=5414
      LNSTYL(8)=7414
      LNSTYL(9)=7434
      LNSTYL(10)=56
C
C  SYMBOL CODES
      LSYSTL(1)=1
      LSYSTL(2)=3
      LSYSTL(3)=2
      LSYSTL(4)=4
      LSYSTL(5)=5
C
C  SYMBOL SIZE FUDGE FACTORS (NOT USER ADJUSTABLE)
CX	SYSZVC(1)=0.8
CX	SYSZVC(2)=1.0
CX	SYSZVC(3)=0.9
CX	SYSZVC(4)=0.9
CX	SYSZVC(5)=1.0
CX	SYSZVC(6)=0.9
CX	SYSZVC(7)=1.0
CX	SYSZVC(8)=1.0
CX	SYSZVC(9)=1.0
CX	SYSZVC(10)=1.0
CX	SYSZVC(11)=0.9
C
C DMC 16 NOV 1990 -- THESE FACTORS NOW IN SGLIB ITSELF
C
      SYSZVC(1)=0.8
      SYSZVC(2)=0.8
      SYSZVC(3)=0.8
      SYSZVC(4)=0.8
      SYSZVC(5)=0.8
      SYSZVC(6)=0.8
      SYSZVC(7)=0.8
      SYSZVC(8)=0.8
      SYSZVC(9)=0.8
      SYSZVC(10)=0.8
      SYSZVC(11)=0.8
C
      init_gftic = .TRUE.
C
      RETURN
      END

c----------------------------------------------------------
      block data cgftici_init

      include 'GFTIC'

      data init_gftic/.FALSE./

      end
c----------------------------------------------------------

      subroutine mds_getnum(lun,node,fname,type,ier)
C Extract a numerical node from MDSplus and write into file
C
      implicit none
C Input
      integer        lun
      character*(*)  node      ! mds node name
      character*(*)  fname     ! file name (to be written)
      integer        type      ! 1 = Integer
C return
      integer        ier       !  0 = success
C                              ! -1 = Node does not exist
C                              !  1 = any other error
C MDSplus
      integer       Mds_Value, idescr_long
      integer       descr, mds__long
      integer       nid, ndsc
C Local
      integer, dimension(2) :: idims
      integer :: l,  retl
      integer :: ivalue
C
      integer        stat,  ios
      character*100  expr
C
      integer        ilnurd
C----------------------------------------------------------------
! Check if node exists
      nid=0
      ndsc = descr(mds__long(), nid, 0)
      expr='getnci("'//node//'","NID_NUMBER")'
      l=ilnurd(expr)
      stat = Mds_Value(expr(1:l),ndsc,retl)
      if (mod(stat,2) .ne. 1) then
         if (stat .ne. 265388144) then     !  Node Not Found
            call mdsmsg(lun, 'MdsValue('//expr(1:l)//')', stat)
         endif
         ier = -1
         return
      endif
!

! Get Value
      if (type .eq. 1) then
         stat = Mds_Value(node,idescr_long(ivalue),retl)
      endif
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun, 'Mds_Value('//node//')',
     &        stat)
         ier=1
         go to 9000
      else
cxx   print*,'write ',fname
! Write file
         open(7,STATUS='replace',iostat=ier,
     >        file=fname)
         if(ier.eq.0) then
            if (type .eq. 1) then
               if (ivalue .gt. 9999999) then
                  write(7,'(i11)',iostat=ier) ivalue
               else
                  write(7,'(i7)',iostat=ier) ivalue
               endif
            endif
            if (ier .ne. 0) then
               close(7,status='delete')
            else
               close(7)
            endif
         endif
         if(ier.ne.0) then
            print*,'%mds_getnum: Error writing '//fname
            go to 9000
         endif
      endif
      return
C
 9000 continue
      return
      end

C-----------------------------------------------------------------------
C  unixpath -- accept input to determine path to user named unix file
C
C  input may be either a literal directory specification, or,
C  a directory specification where the first clause is an environment
C  variable, which is translated.
C
C  the caller supplies the current or default (untranslated) value
C  via the argument zpath; zpath can be modified here by user action.
C
C  the output upath(1:lupath) is a literal path string that can be
C  used to form a filename string for an OPEN statement.
C
C  lupath=0 is returned if the user takes the "d " option; this is
C  supposed to mean, use files in the current working directory.
 
C  Modifications:
C  05/15/95  tbt Increased file name length to 130.
 
 
      subroutine unixpath(zpath,upath,lupath)
 
 
 
      character*(*) zpath  ! untranslated pathname (input/output)
C
      character*(*) upath  ! translated pathname (output)
C
      integer lupath       ! nonblank length of upath (output)
C
C  local:
C
      character*130 zvalue     ! 130 is arbitrary but the same as zpath
C
      logical lxout
C
C-----------------------------------------------------------------------
C
        luntrm = lnout(0)
        call urdmod_get(imod)
 
 10     continue
 
        ilz=index(zpath,' ')-1
        if(ilz.eq.0) ilz=1
 
        if(zpath.eq.' ') then
          upath=' '
          lupath=0
        else if((zpath(1:1).eq.'/').or.(zpath(1:1).eq.'~')) then
          upath=zpath
          lupath=ilz
        else
          ilenv=index(zpath,'/')-1
          if(ilenv.lt.0) ilenv=ilz
          ist=1
          if(zpath(1:1).eq.'$') ist=2
          call sget_env(zpath(ist:ilenv),zvalue)
          if(zvalue.eq.' ') then
            upath=zpath
          else
            ilbl=index(zvalue,' ')-1
            upath=zvalue(1:ilbl)//zpath(ilenv+1:ilz+1)
          endif
          lupath=index(upath,' ')-1
        endif
 
        if(lxout(0)) write(luntrm,1001)
     >      zpath(1:ilz),upath(1:max(1,lupath))
 
 1001   format(
     >' Unixpath:  current path:  "',a,'"'/
     >'         translated path:  "',a,'"'/
     >' (blank means default, use current working directory)'//
     >' Enter "d" or "D" to use default,'/
     >' enter "a" or "A" to append to current path,'/
     >' enter "q" or "Q" to use current setting,'/
     >' or enter a path string to specify a new path.  If the first'/
     >' character of the path string is neither "/" nor "~" then the'/
     >' first word of the path string may be taken as an environment'/
     >' variable, to be translated on output.'/)
 
        zvalue = zpath

        call urdtch
        call ureadLw('unixpath:  enter path string or option code:$',
     >      zvalue)
        if(imod.lt.2) call urdchr
 
        if((zvalue(1:2).eq.'q ').or.(zvalue(1:2).eq.'Q ')) then
          go to 100
        else if((zvalue(1:2).eq.'d ').or.(zvalue(1:2).eq.'D ')) then
          zpath=' '
          go to 10
        else if((zvalue(1:2).eq.'a ').or.(zvalue(1:2).eq.'A ')) then
          call ureadLw(
     >          'unixpath: enter sub-directory to current path:$',
     >          zvalue)
          zpath = trim(zpath)//'/'//trim(zvalue)
          go to 10
        else
          zpath = zvalue
          go to 10
        endif
 
 
 100  continue
      return
      end

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_create_node(node, usage)
      implicit none
      character*(*) node, usage
      mds_create_node = 0
      return
      end
#else
c-----------------------------------------------------------------------
c mds_create_node
c add mdsplus node
c
c input
c   node   -- character
c   usage  -- integer
c returns
c   1          -- on success
c   odd number -- on error
c
c               TREE$K_USAGE_ANY       0
c               TREE$K_USAGE_STRUCTURE 1
c               TREE$K_USAGE_ACTION    2
c               TREE$K_USAGE_DEVICE    3
c               TREE$K_USAGE_DISPATCH  4
c               TREE$K_USAGE_NUMERIC   5
c               TREE$K_USAGE_SIGNAL    6
c               TREE$K_USAGE_TASK      7
c               TREE$K_USAGE_TEXT      8
c               TREE$K_USAGE_WINDOW    9
c               TREE$K_USAGE_AXIS     10
c               TREE$K_USAGE_SUBTREE  11
c               TREE$K_USAGE_COMPOUND_DATA 12
c
c 03/24/1999 ler converted to Unix
c 05/23/1999 ler *** ERROR IN CODE
C 12/14/1999 cal make it work
c-----------------------------------------------------------------------
      integer function mds_create_node(node, usage)
      implicit none
      character*(*) node, usage
 
      integer     status, cmd_status, cmd_stat2
      integer     dsc_cmd_status, dsc_cmd_stat2
      integer     retlen
 
      integer istat, icmdstat
      character*4097 strarg
 
      integer descr, MdsValue, mds__long
      integer mdsdclfdo
      integer nl, nu, nn
      character*1    bcks
      volatile      cmd_status,     cmd_stat2
C---------------------------------------------------------------------------
      bcks=char(92)                 ! x5c = '\'
 
c      write(cusage,'(i2)',err=99) usage
      status = 0
      cmd_status = 0
      dsc_cmd_status = descr(mds__long(), cmd_status, 0)
C Check if open for edit
      strarg = 'GETDBI("OPEN_FOR_EDIT")' // CHAR(0)
cxx      print*,'mds_create_node: ',strarg(1:28)
      status = MdsValue(strarg, dsc_cmd_status, 0, retlen)
cxx      print *,'status =',status,',cmd_status =',cmd_status
      istat    = mod(status, 2)
      icmdstat = mod(cmd_status, 2)
 
      if (istat .ne. 1 .or. icmdstat .ne. 1) then
         print *,'?mds_create_node: GETDBI sts = ',status
         print *,'?mds_create_node: GETDBI cmd_sts = ',
     >            cmd_status
      endif
      if (istat.eq.1 .or. status.eq.265388200) then
C If failure, open for edit:
         cmd_stat2 = 0
         if (icmdstat.ne.1) then
            dsc_cmd_stat2 = descr(mds__long(), cmd_stat2, 0)
            strarg = 'tcl("EDIT "//$EXPT//"/shot="//$SHOTNAME)'
     >               // CHAR(0)
            print*,'mds_create_node: ',strarg(1:28)
            status = MdsValue(strarg, dsc_cmd_stat2, 0, retlen)
            print *,'status =',status,',cmd_stat2 =',cmd_stat2
            istat    = mod(status, 2)
            icmdstat = mod(cmd_stat2, 2)
         endif
         nl=len_trim(node)
         nu=len_trim(usage)


         if ((istat.eq.1) .and. (icmdstat.eq.1)) then
            if (node(1:1).eq.bcks) then
               strarg = 'tcl("add node ' // bcks // node //
     >              '/usage=' // usage // '")' //CHAR(0)
            else
               strarg = 'tcl("add node ' // node(1:nl) //
     >              '/usage=' // usage(1:nu) // '")' //CHAR(0)
            endif
            nn=len_trim(strarg)
            status = MdsValue(strarg(1:nn), dsc_cmd_status, 0, retlen)
cxx            print *,'status =',status,', cmd_status =',cmd_status
            istat    = mod(status, 2)
            icmdstat = mod(cmd_status, 2)
            if (istat.eq.1) then
               status = cmd_status
            endif
         else
            print *,'?mds_create_node: failed on: ',strarg(1:60)
            print *,'?mds_create_node: EDIT status = ',status
            print *,'?mds_create_node: EDIT cmd_stat = ',cmd_stat2
         endif
      endif
      go to 100
C 99   continue
C      write(6,*) '?mds_create_node:  illegal usage argument:  ',usage
 100  continue
 
      mds_create_node = status
 
      return
      end
 
#endif

      subroutine ubwfcmp(ilun,zvals,numvals,zavrat)
C
C  UFILES low level i/o routine -- write real array
C   write with compression if more that 25 words long
C
      use UFILES
C
      real zvals(numvals)
C
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(4)    ! small local buffer
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
C
C-----------------------------------------------------
C
      CALL UFLCHK(ILUN,'ubwfcmp   ',ICHAN,IER)
      IF(IER.NE.0) go to 999
C
      call ubcflush(ichan)   ! flush compressed character output buffer
C
      if(numvals.gt.50) then
         itype=5  ! compress
      else
         itype=4  ! don't compress
      endif
#ifdef __CRAY
      ilbuf(1)=char(itype)
#else
      ilbuf(1)=itype
#endif
      call ubi3ncod(numvals,ilbuf,2)
      ilenb=4
C
C  transfer the buffer -- no. of floating pt words to follow ...
C
      call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,ilenb)
C
C---------------
C
C  loop through fp numbers, 1 block at a time
C
      iwarnuf=0
      iwarnof=0
C
      zsumrat=0.0
      znorm=0.0
C
      do iblk=1,numvals,ufmaxr
         ilim=min(iblk+ufmaxr-1,numvals)
         inum=ilim-iblk+1
C
C  IEEE conversion or copy
C
         call vmsieee(6,zvals(iblk),ilim-iblk+1,ufieee,1)
C
C  data now in ufieee[1 to inum]
C
         if(itype.eq.4) then
C  uncompressed write
C   standardized byte order
            call packordr(ufieee,inum,1)
            ibytes=4*inum
            call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ufieee,ibytes)
         else
C  setup for compression:  break into two I*2 streams
            call unpki2(ufieee,uffhi,ufflo,inum)
C  compress and write
            call ubwfi2(ilun,ichan,uffhi,'hi',inum,zrat)
            zsumrat=zsumrat+float(inum)*zrat
            znorm=znorm+float(inum)
            call ubwfi2(ilun,ichan,ufflo,'lo',inum,zrat)
            zsumrat=zsumrat+float(inum)*zrat
            znorm=znorm+float(inum)
         endif
      enddo
      go to 1000
C
C  errors
C
 999  continue
      write(6,'('' ?UFLIB:  ubwfcmp low level i/o routine:  error.'')')
C
C  exit
C
 1000 continue
      if(znorm.gt.0.0) then
         zavrat=zsumrat/znorm
      else
         zavrat=1.0
      endif
C
      return
      end

#include "fpreproc/f77_dcomplx.h"
      subroutine namels(iZ,iA,cname)
c names an element with charge and mass iZ and iA
c  (dmc 26 Apr 2001:  use Rob Andre's impurity labeler.  Note:  do not
c  REAL*8 convert this routine!)

      use periodic_table_mod

C============
C idecl:  explicitize implicit REAL declarations:
!
      IMPLICIT NONE
      REAL*8, PARAMETER :: ONE = 1.0d0
!
C============
      integer iZ  ! charge of the element
      integer iA  ! mass of the element
      real   r4A  ! atomic mass (real*4)  ! real*4 for periodic table software
      character cname*(*) ! character string name of the element

c default:  from periodic table...
      character*12 tmp

      integer iAmin,iZnum
      REAL   Astd  ! real*4 for periodic table software

c check: standard mass

      if(iZ .gt. 2) then

         iZnum=iZ
         do
            call standard_amu(iZnum,Astd)
            iAmin=Astd+ONE
            if(iAmin.ge.iA) exit
            iZnum=iZnum+1
         enddo

c impurity label

         r4A = iA
         tmp = to_periodic_table(iZnum,r4A,iZ,0)
         cname = tmp

      endif

c identify hydrogen isotopes:

      if(iZ .eq. 1)then
          if(iA .eq. 1) cname = 'H'
          if(iA .eq. 2) cname = 'D'
          if(iA .eq. 3) cname = 'T'
      endif

      if(iZ .eq. 2)then
          if(iA .eq. 3) cname = 'He3'
          if(iA .eq. 4) cname = 'He4'
      endif

      return
      end

C******************** START FILE NEUPAG.FOR ; GROUP URDUTS *************
C===============================================================
C&  NEUPAG  UREAD SWITCHED TERMINAL SCREEN CLEAR
C           -- CLEAR TEKTRONIX SCOPE WITH FORTRAN WRITE
C           FOR USER I/O-- KEEP "NEW PAGES" OUT OF
C           VERSATEC PLOTTING FILE
C
      SUBROUTINE NEUPAG
      USE USERIO
c
c  dmc -- disable screen clears -- these are anachronisms from
c         the tk4006 days of the 1970s -- and the generated
c         escape sequences in CLEAR_ALPHA have been hazardous
c         to scripted use of uread-based software...
c
C
C  ROUTINE TO CLEAR SCREEN WITHOUT OUTPUT TO VERSATEC FILE
C
C  UREAD4 PAGE-CLEAR CHECKS
C  NO PAGE CLEAR IN BATCH
C  NO PAGE CLEAR DURING INDIRECT FILE INPUT.
C  IF ECHO SWITCH IS SET (USER IS EXAMINING I/O OF INDIRECT INPUT
C  FILE AND PROGRAM FLOW CONTROL) CLEAR VIA UPAUST
C  IF OUTPUT FLAG IS FALSE DONT LET PAGE CLEAR COUNT EXCEED 1
C  (REMOVES MULTIPLE PAGE CLEAR DURING PROCESSING OF TYPE-AHEAD LINE
C
C  REV DMC NOV 1984 - INCORPORATE H TOWNER SYSTEM FOR DEVICE-DEPENDENT
C  PAGE CLEARING
C
C  rev DMC Sep 1991 -- alpha (text) page clear suppressed for scrolling
C  terminals (MACs and XTERM and XTC = XTERM w/XTC graphics)
C
      IF(NTTYP.LT.0) RETURN
C
cxx      ICLEAR=0
      IF(NLECHO.AND.(IBATCH.NE.1)) THEN
        CALL UPAUST(0)
cxx        ICLEAR=1
      ENDIF
      NCLEAR=NCLEAR+1
cxx      IF((IBATCH.NE.1).AND.(NCLEAR.LE.1)) ICLEAR=1
cxx      IF(ICLEAR.EQ.1) THEN
C  TTY-DEPENDENT PAGE CLEAR
C    UNKNOWN TTY TYPE ==> CALL NEWPAG AS OF OLD
cxx        IF(NTTYP.EQ.0) THEN
cxx          CALL CLEAR_ALPHA('TK4006')
cxx        ELSE
cxx          IF((UTTYP(1:3).NE.'MAC').AND.(UTTYP(1:5).NE.'XTERM').AND.
cxx     >         (UTTYP(1:3).NE.'XTC')) CALL CLEAR_ALPHA(UTTYP)
cxx        ENDIF
cxx      ENDIF
C
      RETURN
      	END
C******************** END FILE NEUPAG.FOR ; GROUP URDUTS ***************

C******************** START FILE UPSINL.FOR ; GROUP UPSINL ******************
C--------------------------------------------------------
C&  UPSINL  PERFORM UREAD STRING PARAMETER SUBSTITUTION INLINE
C
C  PERFORM IN-LINE PARAMETER SUBSTITUTION
C
C  SUBSTITUTION CHARACTER IS SINGLE QUOTE (') - MSUB1 IN
C   USERIO COMMON
C
C  MODIF DMC JAN 1985
C   SECOND INLINE SUBSTITUTION TECHNIQUE - PAIR OF COMPLIMENTARY
C  CHARACTERS MSUB2(1),MSUB2(2) (WIGGLY BRACKETS) - RECURSIVE TECHNIQUE
C  I.E. MAY SUBSTITUTE A PARAM. TO FORM A NAME WHICH IN TURN GETS
C  REPLACED WITH THE FINAL VALUE-- MAKING PARAMETERS WORK LIKE
C  ARRAYS
C   BRACKETS MAY NOT APPEAR IN LINE UNLESS A SUBSTITUTION IS TO BE
C  PERFORMED
C
C
C  SUBSTITUTION REQUEST IS IGNORED IF STRING BETWEEN 2 SINGLE
C  QUOTES IS NOT A LEGAL PARAMETER NAME OR IF THE PARAMETER NAME
C  IS NOT RECOGNIZED.
C
C  SUBSTITUTION IS PERFORMED IN CBUFF ARRAY-- ERROR IF THERE IS
C  NOT SUFFICIENT SPACE
C
      SUBROUTINE UPSINL(IER)
C
      USE USERIO
C
      CHARACTER*16 ZNAM,ZNAM2
      CHARACTER*1 ZNAM1(16)
      CHARACTER*96 ZVAL
C
C-----------------------------------------
C  LOOK FOR SUBSTITUTION CHARACTER
C
      IER=0
C
      ILNAM=LEN(ZNAM)
      ILVAL=LEN(ZVAL)
C
      ISUB=0
C
      ILEV=1
C  SKIP IF A COMMENT
      IF(CBUFF(1:1).EQ.MCOMMT) GO TO 1000
C  SKIP IF SUBSTITUTION CHARACTER IS BLANKED
      IF(MSUB2(1).EQ.' ') GO TO 9
C
      ILEN=LEN(CBUFF)
 1    CONTINUE
C  ANY MORE SUBSTITUTIONS?
      IEVEN=1
      ISC=0
      CALL UPSINX(CBUFF,ISC,IEVEN)
      IF(ISC.EQ.0) GO TO 9
C  FIND LAST OCCURANCE OF SUBSTITUTION CHARACTER
 2    CONTINUE
      ISCP=ISC+1
      IF(ISCP.GT.ILEN) GO TO 1900
      IS=ISC
      CALL UPSINX(CBUFF,IS,IEVEN)
      IF(IS.EQ.ISC) GO TO 3
      ISC=IS
      GO TO 2
C  FOUND; FIND SUBSTITUTION TERMINATION CHARACTER
 3    CONTINUE
      ISC2=INDEX(CBUFF(ISCP:ILEN),MSUB2(2))+ISC
      IF(ISC2.LE.(ISC+1)) GO TO 1900
C
      ISUB1=ISC
      ISUB2=ISC2
      INM1=ISC+1
      INM2=ISC2-1
      INL=INM2-INM1+1
C
C
C  GO TO PERFORM SUBSTITUTION
C
      GO TO 30
C
 9    CONTINUE
C  SINGLE QUOTE SUBSTITUTION...
      IF(MSUB1.EQ.' ') GO TO 1000
      ILEV=2
      ISC=0
      IEVEN=1
C
 10   CONTINUE
      ISC=ISC+1
      IF(ISC.GT.ILEN) GO TO 1000
      IF(CBUFF(ISC:ISC).EQ.'"') IEVEN=1-IEVEN
      IF(CBUFF(ISC:ISC).NE.MSUB1) GO TO 10
C  FIRST QUOTE FOUND-- LOOK FOR MATCHING SECOND QOUTE; ABORT IF
C  END OF LINE WITHOUT FINDING SECOND QUOTE
      INC1=0
      IF(IEVEN.EQ.0) THEN
C  INSIDE DBL QUOTES, *2* CONSECUTIVE SNGL QUOTES NEEDED FOR SUBSTITUTION
        IF(ISC.EQ.ILEN) GO TO 1000
        ISCPL=ISC+1
        IF(CBUFF(ISCPL:ISCPL).NE.MSUB1) GO TO 10
        ISC=ISCPL
        INC1=1
      ENDIF
      ISC2=ISC
 20   CONTINUE
      ISC2=ISC2+1
      IF(ISC2.GT.ILEN) GO TO 1000
      IF(CBUFF(ISC2:ISC2).NE.MSUB1) GO TO 20
C  2ND QUOTE FOUND-- CHECK LENGTH OF NAME STRING INBETWEEN
      ISUB1=ISC-INC1
      INM1=ISC+1
      INM2=ISC2-1
      INL=INM2-INM1+1
      IF(INL.EQ.0) THEN
C  NOT A NAME BUT A "''".  RESUME SEARCH
        ISC=ISC2
        GO TO 20
      ENDIF
      ISUB2=ISC2
      IF((IEVEN.EQ.0).AND.(ISC2.LT.ILEN)) THEN
        ISCPL=ISC2+1
        IF(CBUFF(ISCPL:ISCPL).EQ.MSUB1) ISUB2=ISUB2+1
      ENDIF
      GO TO 30
C--------------------------------------------------
C  PARAMETER NAME FOUND FOR SUBSTITUTION
 30   CONTINUE
C  EXTRACT NAME
      INL=MIN0(LPNAM,INL)
      INM2=INM1+INL-1
C
      ZNAM='                '
      ZNAM(1:INL)=CBUFF(INM1:INM2)
      call uspcap(ZNAM)
      DO 31 IC=1,ILNAM
        ZNAM1(IC)=ZNAM(IC:IC)
 31   CONTINUE
C
      I1=1
      IINL=INL
      CALL USPLNM(ZNAM1,ILNAM,I1,IINL,ZNAM2,IER)
      IF(IER.NE.0) RETURN  ! *** NAME FIELD ERROR REPORTED
C
C  GET VALUE OF NAMED PARAMETER- SUPPLIED BY USER IF UNDEFINED
      CALL USPGET(ZNAM,ZVAL,IERL)
      ILENS=0
      IF(IERL.NE.0) CALL UPQUER(ZNAM,DBUFF,ILEN,ZVAL)
C
      DO 40 IC=ILVAL,1,-1
        IF(ZVAL(IC:IC).NE.' ') GO TO 42
 40   CONTINUE
      IC=1
 42   CONTINUE
      ILENS=IC
C  PERFORM SUBSTITUTION
 50   CONTINUE
      ISUB=1
      IF(NLECHO) THEN
        IF(ILENS.EQ.0) WRITE(LUNTRM,2001) CBUFF(INM1:INM2)
        IF(ILENS.GT.0)
     >    WRITE(LUNTRM,2002) CBUFF(INM1:INM2),ZVAL(1:ILENS)
 2001 FORMAT(' % UPSINL-- INLINE SUBSTITUTION'/
     >  '   ''',A,''' REPLACED BY NULL STRING')
 2002 FORMAT(' % UPSINL-- INLINE SUBSTITUTION'/
     >  '   ''',A,''' REPLACED BY STRING PARAMETER VALUE "',A,'"')
      ENDIF
C  CHECK AGAINST LINE OVERFLOW
      IDIF=ILENS-(ISUB2-ISUB1+1)
      IF(IDIF.LE.0) GO TO 60
      ILOSS=ILEN-IDIF+1
      DO 55 IL=ILOSS,ILEN
        IF(CBUFF(IL:IL).NE.' ') GO TO 59
 55   CONTINUE
C  OK
      GO TO 60
C  ERROR
 59   CONTINUE
      CALL UERMSG('? INLINE PARAMETER SUBSTITUTION OVERFLOWS LINE',
     >     ZVAL,1)
      IER=1
      RETURN
C
 60   CONTINUE
      ISP0=ISUB2+1
      ISP1=ISP0+IDIF
      IF(IDIF.GT.0) THEN
C  SHIFT OUT REMAINDER OF LINE TO MAKE ROOM FOR SUBSTITUTION
        DO 62 IP=ILEN,ISP0,-1
          INLOC=IP+IDIF
          IF(INLOC.GT.ILEN) GO TO 62
          CBUFF(INLOC:INLOC)=CBUFF(IP:IP)
 62     CONTINUE
      ELSE IF (IDIF.LT.0) THEN
C  SHIFT IN REMAINDER OF LINE, PAD WITH BLANKS
        DO 64 IP=ISP1,ILEN
          IOLOC=IP-IDIF
          CBUFF(IP:IP)=' '
          IF(IOLOC.LE.ILEN) CBUFF(IP:IP)=CBUFF(IOLOC:IOLOC)
 64     CONTINUE
      ENDIF
C  NOW SUBSTITUTE THE PARAMETER ITSELF
      ILS=ISUB2+IDIF
      CBUFF(ISUB1:ILS)=ZVAL(1:ILENS)
C
      ISC=ISUB1
C  RESUME SEARCH
      GO TO (1,10) ILEV
C
      CALL URDABO
C
C  NORMAL EXIT
C
 1000 CONTINUE
C
C  IF SUBSTITUTION WAS PERFORMED RESET LINE CHARACTER COUNT
C
      IF(ISUB.GT.0) CALL UDECOD
      RETURN
C
C  ERROR
C
 1900 CONTINUE
      CALL UERMSG(
     >'? INVALID USE OF RECURSIVE INLINE SUBSTITUTION CHARACTER',
     >MSUB2(1),1)
      IER=1
      RETURN
C
      END
C******************** END FILE UPSINL.FOR ; GROUP UPSINL ******************

subroutine tr_r8qpsrt(limit,last,maxerr,ermax,elist,iord,nrmax)
  !***begin prologue  dqpsrt
  !***refer to  dqage,dqagie,dqagpe,dqawse
  !***routines called  (none)
  !***revision date  810101   (yymmdd)
  !***keywords  sequential sorting
  !***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
  !           de doncker,elise,appl. math. & progr. div. - k.u.leuven
  !***purpose  this routine maintains the descending ordering in the
  !            list of the local error estimated resulting from the
  !            interval subdivision process. at each call two error
  !            estimates are inserted using the sequential search
  !            method, top-down for the largest error estimate and
  !            bottom-up for the smallest error estimate.
  !***description
  !
  !           ordering routine
  !           standard fortran subroutine
  !           double precision version
  !
  !           parameters (meaning at output)
  !              limit  - integer
  !                       maximum number of error estimates the list
  !                       can contain
  !
  !              last   - integer
  !                       number of error estimates currently in the list
  !
  !              maxerr - integer
  !                       maxerr points to the nrmax-th largest error
  !                       estimate currently in the list
  !
  !              ermax  - double precision
  !                       nrmax-th largest error estimate
  !                       ermax = elist(maxerr)
  !
  !              elist  - double precision
  !                       vector of dimension last containing
  !                       the error estimates
  !
  !              iord   - integer
  !                       vector of dimension last, the first k elements
  !                       of which contain pointers to the error
  !                       estimates, such that
  !                       elist(iord(1)),...,  elist(iord(k))
  !                       form a decreasing sequence, with
  !                       k = last if last.le.(limit/2+2), and
  !                       k = limit+1-last otherwise
  !
  !              nrmax  - integer
  !                       maxerr = iord(nrmax)
  !
  !***end prologue  dqpsrt
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: ermax,errmax,errmin
  integer :: i,ibeg,ido,isucc,j,jbnd,jupbn,k,last,limit,maxerr,nrmax
  real(fp), dimension(last) :: elist
  integer, dimension(last) :: iord
  !
  !           check whether the list contains more than
  !           two error estimates.
  !
  !***first executable statement  dqpsrt
  if(last.gt.2) go to 10
  iord(1) = 1
  iord(2) = 2
  go to 90
  !
  !           this part of the routine is only executed if, due to a
  !           difficult integrand, subdivision increased the error
  !           estimate. in the normal case the insert procedure should
  !           start after the nrmax-th largest error estimate.
  !
10 errmax = elist(maxerr)
  if(nrmax.eq.1) go to 30
  ido = nrmax-1
  do i = 1,ido
    isucc = iord(nrmax-1)
    ! ***jump out of do-loop
    if(errmax.le.elist(isucc)) go to 30
    iord(nrmax) = isucc
    nrmax = nrmax-1
  end do
  !
  !           compute the number of elements in the list to be maintained
  !           in descending order. this number depends on the number of
  !           subdivisions still allowed.
  !
30 jupbn = last
  if(last.gt.(limit/2+2)) jupbn = limit+3-last
  errmin = elist(last)
  !
  !           insert errmax by traversing the list top-down,
  !           starting comparison from the element elist(iord(nrmax+1)).
  !
  jbnd = jupbn-1
  ibeg = nrmax+1
  if(ibeg.gt.jbnd) go to 50
  do i=ibeg,jbnd
    isucc = iord(i)
    ! ***jump out of do-loop
    if(errmax.ge.elist(isucc)) go to 60
    iord(i-1) = isucc
  end do
50 iord(jbnd) = maxerr
  iord(jupbn) = last
  go to 90
  !
  !           insert errmin by traversing the list bottom-up.
  !
60 iord(i-1) = maxerr
  k = jbnd
  do j=i,jbnd
    isucc = iord(k)
    ! ***jump out of do-loop
    if(errmin.lt.elist(isucc)) go to 80
    iord(k+1) = isucc
    k = k-1
  end do
  iord(i) = last
  go to 90
80 iord(k+1) = last
  !
  !           set maxerr and ermax.
  !
90 maxerr = iord(nrmax)
  ermax = elist(maxerr)
  return
end subroutine tr_r8qpsrt

c  xvplot.for	subroutines for both xplot and vplot
c
c----------------------------------------------------------------/set_input
	subroutine set_input(fspec,fname,l4105,linit)
	implicit none

	integer linit
	character*(*) fspec
	character fname*(*)

	include 'xplot_inc'
	character fopts*64
	character match*16
	character*1 back
	logical lfile,l4105

        integer lf, ibrak, idot, ios, lq, lpo, lpc
	integer num,lx,    iopt
	integer jc_trim

	data fopts	/' '/
c
	lfile = .false.		!no input file yet
	fopts = ' '
	fname = ' '
c
	do while (.not.lfile)	!get a good input file
	  if(fspec.eq.' ')
     >    call at_text('input plot file',fspec)
	  if(fspec.eq.' ') go to 110
	  lf = index(fspec,' ')
	  if(fspec(lf:).ne.' ') then
	    call at_msg(' ** enter as  PLOTFILE.PLT[/F=n1,..]')
	    fspec = ' '
	    go to 110
	  endif
	  if(lf.gt.1) lf = lf-1
	  if(fspec(1:1).eq.',') then
	    fspec = fspec(2:)		!check for ",xxx" or "xxx,"
	  elseif(fspec(lf:lf).eq.',') then
	    fspec(lf:) = ' '
	  endif
	  lf = index(fspec,'/')-1	!strip off options
	  if(lf.le.0) lf = jc_trim(fspec)
	  fname = fspec(1:lf)
	  fopts = fspec(lf+2:)
	  call set_open(fname,ios)
	  if(ios.ne.0) then
	    fspec = ' '
	    call at_reset
	  else
	    lfile = .true.
	  endif
 110	enddo
c
	ibrak = index(fname,']')
	idot = index(fname(ibrak+1:),'.')+ibrak
	l4105 = .false.
	linit = 10		!length of initialization sequence
	if(idot.ne.0) then
	  if(fname(idot+1:idot+4).eq.'4105') then
	    l4105 = .true.
	    linit =  100
	  endif
	endif
	inblk = 0
c
 120	nfn = 0
	if(fopts.eq.' ') go to 200
	call at__upcase(fopts,fopts)
	iopt = index('FT',fopts(1:1))	!convert option letter to index
	if(iopt.eq.0) then
	  call at_msg(' ** file options are: /F=n1[,n2..] or /T')
	  call at_text('enter option',fopts)
	  go to 120
	endif
	lq = index(fopts,'=')
	if(lq.eq.0) then
	  fopts = ' '
	else
	  fopts = fopts(lq+1:)
	endif
c
	lpo = index(fopts,'(')
	if(lpo.ne.0) fopts(lpo:lpo) = ' '
	lpc = index(fopts,')')
	if(lpc.ne.0) fopts(lpc:lpc) = ' '
c
	lf = jc_trim(fopts)
	if(fopts.ne.' ') then
	  if(iopt.eq.1) then	!for frame numbers
	  call at_macro('/B')	!will get this after user input
	  endif
	  call at_macro(fopts(1:lf))
	endif
c
	nftop = 0
	if(iopt.eq.1) then	!select frame numbers
	  num = 1
	  call at_bint('enter frame number(s)',num,back)
	  do while(back.eq.' ')
	    if(num.gt.0) then
	    nfn = nfn+1
	    fnlist(nfn) = num
	    if(lstop) nftop = max(nftop,num)
	    endif
	    call at_bint('next frame (/B to end)',num,back)
	    if(nfn.ge.maxfn-1) back = 'B'
	  enddo
	  if(nfn.eq.0) then
	    call at_msg(' ** frame list empty - will process all frames')
	  endif
	elseif(iopt.eq.2) then
	  nfn = -1		!match text
	  ntx = 0
	  match = ' '
	  do while(match.eq.' ')
	    call at_text('enter text',match)
	    lx = jc_trim(match)
	  enddo
	  ntx = ntx+1
	  txlist(ntx) = match
	  fnlist(ntx) = lx
	endif
 200	return
c
	entry get_input
	return
	end
c
	subroutine set_open(fname,ios)
	character fname*(*)
	character fopen*64
	logical igood
c
	lf = jc_trim(fname)
	ibrak = index(fname,']')
	idot = index(fname(ibrak+1:),'.')+ibrak
	if(idot.eq.0) then
	  call usr_trnlog(' ',fname(:lf),fopen,lf,igood)
	  if(.not.igood) fopen = fname
	else
	  fopen = fname
	endif
c
	lf = jc_trim(fopen)
	call tname_disk(fopen(1:lf))  !   
	call tview_disk  !   
	ios=0  !   
	return
	end
c
	subroutine set_temp(ifr,lwout)
	implicit none
c
	logical lwout
	include 'xplot_inc'
	include 'sgvgds_inc'
	integer ifr, ii, istat
c
	if(nfn.gt.0) then	!wait for frame match
	  ltemp = .false.	!dont create vgds temp file
	  if(nftop.gt.0 .and. ifr.gt.nftop) then
	    kpage = 99999	!if at end of list, all done
	    return
	  endif
	  do ii=1,nfn		!see if frame number in list
	    if(ifr.eq.fnlist(ii)) ltemp = .true.
	  enddo
	  lkeep = ltemp
	elseif(nfn.eq.0) then	!no frame/text match, or found text match
	  ltemp = .true.
	  lkeep = .true.
	  if(nftop.gt.0 .and. ifr.gt.nftop) kpage = 99999
	else !nfn.lt.0		!wait for text match
	  ltemp = .true.	!create vgds temp file
	  if(lttyo) ltemp = .false.	!delay if only to tty
	  lkeep = .false.
	endif
	if(ltemp) then
	  iovgds = iosave
	  if(.not.lttyo) then
	    call ag_inio('VGDS',istat)
	  endif
	  lwout = .true.
	else
	  iovgds = 0		!throw away frame
	  lwout = .false.
	endif
	end
c
	subroutine get_char(khar,ios)
	implicit none

	include 'xplot_inc'
	integer hex0, khar
	integer i, ngot, ios
	data hex0/z'00'/	
c
	if(inptr.gt.incnt) then		!if buffer empty, fill it
	  do i=1,mfbuf
#ifdef __f90
	     fbuf(i)=char(hex0)
#else
	     fbuf(i) = 0
#endif
	  enddo
	  inblk = inblk+1
	  call tread_disk(fbuf,mfbuf,inblk,ngot)  !   
c	  call tread_disk(fbuf,%val(mfbuf),%val(inblk),ngot)  !   
	  ios = 0  !   
	  if(ngot.eq.0) ios = -1 !   
	  if(ios.eq.36) ios = -1	!no such block => eof
	  if(ios.lt.0) return	!?ios.ne.0
c				!reset ptr unless set by vskip
	  if(inptr.eq.incnt+1) inptr = 1
	  incnt = mfbuf		!recalc incnt
#ifdef __f90
	  do while (fbuf(incnt).eq. char(hex0))
#else
	  do while (fbuf(incnt).eq.0)
#endif
	    incnt = incnt-1
	  enddo
	endif
#ifdef __f90	
	khar = ichar(fbuf(inptr))
#else
	khar = fbuf(inptr)
#endif
	inptr = inptr+1
	return
	end
c
	subroutine ck_match(khar,nfo,lwout)
	implicit none
c
	logical lwout
	include 'xplot_inc'
	integer  nfo, ii, khar, jj

#ifdef __f90
	integer(1) mbuf(16)
#else
	byte mbuf(16)		!match buffer
#endif
c
	if(nfo.eq.0) then
	  do ii=1,16
	    mbuf(ii) = 0
	  enddo
	endif
	do ii=2,16		!shuffle buffer left  !   
	  mbuf(ii-1)=mbuf(ii)  !   
	enddo  !   
	mbuf(16) = khar		!store new character
	do jj=1,ntx		!compare bytes in plot file to user text
	  do ii=1,fnlist(jj)
	    if(mbuf(ii).ne. ichar(txlist(jj)(ii:ii))) go to 100	!cycle
	  enddo
	  lkeep = .true.	!have a match
	  if(lstop) nftop = kpage	!stop after this frame
	  nfn = 0		!stop text search
c				!if no output yet to tty
	  if(lttyo .and. (.not.ltemp)) then
	  inblk = spage(1,kpage)-1	!back up to start of frame
	  inptr = spage(2,kpage)
	  incnt = 0		!force read
	  call set_temp(kpage,lwout)	!enable output
	  nfo = 0
	  endif
	  go to 200	!leave
 100	enddo
 200	continue
	end
c
c
	subroutine xout(khar)
	implicit none
	include 'xplot_inc'
	character eseq*120
	integer ls, is, lt, khar, irot, ix, linhgt, iy
	integer linwdt, ksize, iff, ihalf, ii, ip
	integer iang, idiam, ic30, is30
	real    rod
	integer ipos(8)
	logical is_cap

	save ls,ip,irot,ix,iy

	data eseq/' '/
c
	if(li4105 .and. (.not.lo4105)) then
c					!input=4105, output=4014
	  if(kmode.eq.kescm) then		!escape mode
	    if(khar.ge.ichar(' ').and.ls.lt.120) then
	      ls = ls+1		!collect bytes until ctrl char
	      eseq(ls:ls) = char(khar)
	      return
	    else
	    if(ls.eq.0) then		!if empty
	      call toutpt(27)		!just output esc
	      kmode=kalfm
	    elseif(eseq(1:2).eq.'LT') then	!text
	      is = 3
	      call getint(eseq,is,lt)	!get length
	      call resets
	      if(irot.eq.0) then
	      call xoutst(eseq(is:),lt,lo4105)	!min(lt,ls-is)
	      else
	      call movabs(ix-linhgt(1),iy+linwdt(lt))
	      call agtvs(eseq(is:),lt)
	      endif
	      ls = 0
	    elseif(eseq(1:2).eq.'MC') then	!char size
	      is = 3
	      call getint(eseq,is,ksize)
	      if(ksize.lt.33) then	!51*.68 = 34
		call chrsiz(3)		!small
	      else
		call chrsiz(1)		!large
	      endif
	      ls = 0
	    elseif(eseq(1:2).eq.'MR') then	!rotation
	      is = 3
	      call getint(eseq,is,irot)
	      if(irot.eq.180) irot=0
	      ls = 0
	    elseif(eseq(1:2).eq.'DA') then	!maccircle
	      is = 3
	      call getint(eseq,is,iff)	!1=frame,2=fill,3=both
	      call getint(eseq,is,iang)	!angle = 0 to 360
	      call getint(eseq,is,iang)
	      call getint(eseq,is,idiam)	!4*rod
	      call getint(eseq,is,idiam)
	      ls = 0
	      rod=real(idiam)*.25
	      ic30=nint(rod*.8660254)
	      is30=nint(rod*.5)
	      ihalf=nint(rod)
	      call resets
	      call movabs(ix,iy)
	      call movrel(ihalf,0)
	      call drwrel(ic30-ihalf,is30)
	      call drwrel(is30-ic30,ic30-is30)
	      call drwrel(-is30,ihalf-ic30)
	      call drwrel(-is30,ic30-ihalf)
	      call drwrel(-ic30+is30,is30-ic30)
	      call drwrel(-ihalf+ic30,-is30)
	      call drwrel(-ic30+ihalf,-is30)
	      call drwrel(-is30+ic30,-ic30+is30)
	      call drwrel(is30,-ihalf+ic30)
	      call drwrel(is30,-ic30+ihalf)
	      call drwrel(ic30-is30,-is30+ic30)
	      call drwrel(ihalf-ic30,0+is30)
	      call movabs(ix,iy)
	    elseif(eseq(1:2).eq.'LP') then	!panel = filled symbol
	      call toutpt(kvecm)	!vector mode
	      do ii=5,ls		!output moves
		call toutpt(ichar(eseq(ii:ii)))
	      enddo
	      ls = 0
	    elseif(.not.is_cap(ichar(eseq(1:1)))) then	!4014 cmd
	      call toutpt(27)		!replace esc
	      do ii=1,ls		!output string
		call toutpt(ichar(eseq(ii:ii)))
	      enddo
	      ls = 0
	    endif
	    kmode=kalfm
	    ls=0
	    endif
	  elseif(kmode.eq.kvecm) then
	    ip = ip+1
	    ipos(ip) = khar
c	    if((khar/'40'o).eq.2) then
	    if((khar/32).eq.2) then
	      call getxy(ipos,ip,ix,iy)
	      ip = 0
	    endif
	  endif
	elseif((.not.li4105) .and. lo4105) then
c					!input=4014, output=4105
	  if(kmode.eq.kescm) then
	    if(khar.eq.27) return	!after esc ff
	    kmode=kvecm
	    if(khar.gt.55 .and. khar.le.59) then
	      call chrsiz(khar-55)	!set character size
	      return
	    endif		!96-104 = dash type
	    call toutpt(27)		!replace esc
	  elseif(kmode.eq.kalfm) then
	    if(khar.ge.ichar(' ')) then
	      ls=ls+1
	      eseq(ls:ls)=char(khar)
	      return
	    elseif(ls.gt.0) then
	      call xoutst(eseq,ls,lo4105)
	      ls=0
	    endif
	  endif
	endif
c
	if(khar.eq.31) then
	  kmode = kalfm		!US -> alpha mode
	elseif(khar.eq.29) then
	  kmode = kvecm		!GS -> vector mode
	  ip = 0
	elseif(khar.eq.28) then
	  kmode = kpntm		!FS -> point mode
	elseif(khar.eq.27) then
	  kmode = kescm		!ECS -> escape mode
	endif
c
	if(khar.eq.07) then
c		!ignore bell
	elseif(ldiff .and. kmode.eq.kescm) then
c		!hold escape seqs
	else
	  call toutpt(khar)
	endif
	return
	end
c
	subroutine getint(str,is,int)
	implicit none

	character str*(*)
	integer is,int
	integer khar

	int = 0
	khar = ichar(str(is:is))
	is = is+1
	if(khar.gt.64) then
	  int = khar-64
	  khar = ichar(str(is:is))
	  is = is+1
	endif
	int = int*16 + (khar-48)
	return
	end
c
	subroutine getxy(ipos,lp,ix,iy)
	implicit integer (a-z)
	integer ipos(*)
	logical noy
c
c init pieces
c	highx=ix/'40'O
	highx=ix/32
	highy=iy/32
c	lowx=ix.and.'37'O
	lowx=iand(ix,31)
	lowy=iand(iy,31)
	noy=.true.
	ip=0
c  get next nibble
 100	continue
	ip=ip+1	!?check ip<lp
	ich=ipos(ip)
c  high 2 bits are indicator, low 5 bits are address
	msb=ich/32
	lsb=iand(ich,31)
	if(msb.eq.1.and.noy) then
	  highy=lsb
	  noy=.false.
	  go to 100
	elseif(msb.eq.3) then
	  lowy=lsb
	  noy=.false.
	  go to 100
	elseif(msb.eq.1) then
	  highx=lsb
	  go to 100
	elseif(msb.eq.2) then
	  lowx=lsb
	endif
c  compute new coordinates
	ix=highx*32 + lowx
	iy=highy*32 + lowy
	if(ix.gt.1024) ix=1024
	if(iy.gt.780)  iy=780
	return
	end
c
	subroutine xoutst(str,ns,l4105)
	implicit none
        integer ns
	character str*(*)
	logical l4105
	integer ii

	if(l4105) then
	  call cmdout('LT')
	  call intout(ns)
	else
	  call toutpt(31)	!US
	endif
	do ii=1,ns
	  call toutpt(ichar(str(ii:ii)))
	enddo
	return
	end
c
	subroutine resets
	implicit none

	include 'sgtcs_inc'
        integer ii

	do ii=1,4
	  kpchar(ii)=-1
	enddo
	end

	logical function is_cap(khar)
 	is_cap = (khar.ge.ichar('A') .and. khar.le.ichar('Z'))
	return
	end
c
	subroutine at_vaxer(msg,icode)
	implicit none

	integer       icode
	character*(*) msg
	character*80 text
	integer  lx, ltext, ierr

	write(text,'(i2)',iostat=ierr) icode  !   
	ltext = 2  !   
	call at_msg('  '//msg)
	call at_msg('  '//text(1:ltext))
	end

c========================================================================
c
      subroutine rtoi(linlog, nbits, lauto, cmin, cmax, nwords, chan
     >	    ,scale, offset, ichan, ierr)
c
c routine to convert an array of real*4 words into integer*2 words of
c    given bit significance
c  the transformation is of the form:
c	r = s * i + o	(linear), or
c	r = s * 10**i + o	(log)
c  where s is the scale factor, i is the integer datum, o is the offset,
c    and r is the resultant real number.
c
c*15-nov-83 ---rtoi.for, itor.for---  r. wieland
c*14-aug-89  m. thompson: renamed rtoi->rtoi,etc.
c
c  arguments:
c  =========
c  linlog	(input) integer flag
c		0 for linear transformation
c		1 for log transformation
c  nbits	(input) number of significant bits in integer i
c  lauto	(input) auto scale flag
c		0 to allow rtoi to find min/max of the data
c		1 to make rtoi use the values cmin/cmax for the range
c  cmin	(input) lower limit of data - if lauto=1
c  cmax	(input) upper limit of data - if lauto=1
c  nwords	(input) length of input array
c  chan	(input) array of real*4 data items [r]
c		(output) changed if any points lie outside the auto scale
c		range provided
c  ichan	(output) array of integer*2 data [i]
c  nclip	(output) number of values clipped
c  scale	(output) resulting scale factor [s]
c  offset	(output) resulting offset [o]
c  ierr		(output) error flag
c		0 if everything ok
c		3 if data outside of (-1.e36,+1.e36)
c
c-----------------------------------------------------------------------
c
      integer linlog, nbits, lauto
      real*4  cmin, cmax
      real*4  chan(*)
      real*4  scale, offset
      integer*2 ichan(*)
      integer   nclip
      integer ierr
c
c------------------------------------------------------------------------
c
#ifdef __CRAY
      print *,'RTOI not implemented for CRAY'
#else
      lclip = lauto
      go to 100
c
c----------------------------------------------------------------------
c
      entry rtoi_c (linlog, nbits, nclip, cmin, cmax, nwords, chan
     >	    ,scale, offset, ichan, ierr)
c
c----------------------------------------------------------------------
c
      lclip = -1
 100  ierr = 0
      nscale = 2**nbits - 1
      scale = 1.
      offset = 0.
      if(nwords.eq.0) go to 8000
c
c  find range
c
      if(lclip.ne.0) then
c				cmin/cmax provided - clip data
        ncl = 0
        dmin = cmax
        dmax = cmin
        do ii=1,nwords
          if(chan(ii).gt.cmax .or. chan(ii).lt.cmin) ncl = ncl+1
          chan(ii) = min(chan(ii),cmax)
          chan(ii) = max(chan(ii),cmin)
          dmin = min(dmin,chan(ii))
          dmax = max(dmax,chan(ii))
        enddo
        if(lclip.lt.0) nclip = ncl
      else
c				calculate dmin/dmax
        dmin = chan(1)
        dmax = dmin
        do ii=2,nwords
          dmax = max(dmax,chan(ii))
          dmin = min(dmin,chan(ii))
        enddo
        if(dmin.eq.0 .and. dmax.eq.0) go to 400
      endif
c
      if(abs(dmax).gt.1.e+36) then
cx     >	.or. (abs(dmin).gt.0. .and. abs(dmin).lt.1.e-36)) then
        ierr = 3
        return
      endif
c
c  set scale and offset
c
      if(linlog.eq.0) then
c				linear
        offset = dmin
        range = dmax-dmin
        scale = range/float(nscale)
      else
c				log
        if(dmin.gt.0.) then
          offset = 0.
        elseif(dmin.eq.0.) then
          offset = -1.
        else
          offset = dmin*10.
        endif
        range = log(dmax-offset)
        scale = range/float(nscale)
      endif
c
c  convert data
c
 400  continue
      if(scale.ne.0.) then
        scin = 1./scale
      else
        scin = 1.
      endif
c
      if(linlog.eq.0) then
        do ii=1,nwords
          ichan(ii) = (chan(ii)-offset) * scin
        enddo
      else
        do ii=1,nwords
          ichan(ii) = log(chan(ii)-offset) * scin
        enddo
      endif
c
#endif
 8000 return
      end
c
c========================================================================
c
      subroutine itor(linlog, ichan, nwords, scale, offset, chan, ierr)
c
c  takes an array of integer*2 words and converts them to an array of
c    real*4 words, using the transformation given for rtoi.
c
c  arguments:
c  =========
c  linlog	(input) integer flag
c		0 for linear transformation
c		1 for log transformation
c  nwords	(input) length of input array
c  ichan	(input) array of integer*4 data [i]
c  scale	(input) resulting scale factor [s]
c  offset	(input) resulting offset [o]
c  chan		(output) array of real*4 data items [r]
c  ierr		(output) error flag
c		0 if everything ok
c
c-----------------------------------------------------------------------
c
      integer linlog
      integer*2 ichan(*)
      real    scale, offset
      real	chan(*)
c
      real	aln10
c
      data aln10/2.302585/
c
c-----------------------------------------------------------------------
c
#ifdef __CRAY
      print *,'ITOR not implemented for CRAY'
#else
      ierr=0
c
c  convert from integer to real
c
      if(linlog.eq.0) then
        do ii=1,nwords
          chan(ii) = scale*ichan(ii) + offset
        enddo
c
      else
        do ii=1,nwords
          chan(ii) = exp(scale*ichan(ii)) + offset
        enddo
      endif
c
#endif
      return
      end
c
c========================================================================
c
      subroutine cmprsi(nbits, nitems, pack, items, bit, maxp, ierr)
c
c+an algorithm to compress waveforms by expressing them
c as differences and storing only the number of bits needed
c to express the values over a power of two range.
c look ahead is limited to two levels but
c rescan is restarted with each output
c
c nbits	  number of significant bits in each item
c	  negative for sign extension on expansion
c pack	  output packed array
c items	  input packed array
c nitems  number of values to be packed
c bit	  starting left-to-right bit number in pack
c	  returns last occupied (starts at 0)
c	  if 0 on entry, pack is zeroed; note values are ored into pack
c maxp	  dimension of pack
c ierr	  returned error code (0 = ok)
c	  16 if  nbits > 16 or nbits = 0
c	  15 if  unpacked value too large to store
c	  14 if  dimension of pack too small
c
c*25-mar-83 ---cmprsi.for, xpandi.for---
c*16-nov-83  m. thompson (ppl) - return error if nbits > 16 rather than stop
c	check dimension of pack
c*24-jan-84  m. thompson (ppl) - store count word in 16 bits vs 12
c	check for data values too large to store
c*18-jan-93  m. thompson (ppl) - rearrange logic in cmprsi
c*26-feb-92  m. thompson (ppl) - replace macro packi/unpki with in-line
c	code using shifts and masks; increment bit size by 2 (vs 1)
c
c-----------------------------------------------------------------------
c

      implicit integer(a-z)
c
      parameter (shift=16)	!was 12 (2/93, met)
      parameter (two=2*shift,ko256=shift+256)
c
      integer pack(*)
      integer*2 items(*)
      integer*4 iold,it
c
      integer power(17)
      integer sig(65)
      integer*2 is(ko256)
c
      integer*4 masks(0:16)
c
      data power/
     >    0,1,2,4,8,16,32,64,128,256,512,
     >    1024,2048,4096,8192,16384,32768/
      data sig/
     >    0,2,2,2*4,4*4,8*6,16*6,32*7/
#if __F90 || __NAGWARE
      data masks/ Z"00000000",
     >	  Z"00000001",Z"00000003",Z"00000007",Z"0000000f",
     >	  Z"0000001f",Z"0000003f",Z"0000007f",Z"000000ff",
     >	  Z"000001ff",Z"000003ff",Z"000007ff",Z"00000fff",
     >	  Z"00001fff",Z"00003fff",Z"00007fff",Z"0000ffff"/
#else
      data masks/ '00000000'x,
     >	  '00000001'x,'00000003'x,'00000007'x,'0000000f'x,
     >	  '0000001f'x,'0000003f'x,'0000007f'x,'000000ff'x,
     >	  '000001ff'x,'000003ff'x,'000007ff'x,'00000fff'x,
     >	  '00001fff'x,'00003fff'x,'00007fff'x,'0000ffff'x/
#endif
c-----------------------------------------------------------------------
c
#ifdef __CRAY
      print *,'CMPRSI not implemented for CRAY'
#else

      nb=abs(nbits)
      if(nb.gt.16 .or. nb.eq.0) then
       ierr = 16
       go to 90
      endif
c
      if(bit.eq.0) then
        do ii=1,maxp
          pack(ii)=0
        enddo
      endif
c first difference to remove most of value
      offset=power(nb+1)
      mask=2*offset-1
      imask=mask
      if(nbits.lt.0) imask=imask/2
      x0=0
      iold=0
      kptr=bit/32+1
      kpos=mod(bit,32)
      kpos=32-kpos
c loop 1 to nitems+1, limited to 256 items
      do while (x0.lt.nitems)
        nn = min(nitems-x0,ko256)
        y1=-1		!number of bits
        y2=-1
        y12=0
        x2=0		!count at this bit size
        do x3=0,nn
          if(x3.eq.nn) then
c hit the count wall
            y3=64
            go to 7
          endif
c significance
          it=items(x3+x0+1)
          if(abs(it).gt.imask) then
            ierr=15
            go to 90
          endif
          i=iand(it-iold+offset,mask)-offset
          iold=it
          is(x3+1)=i
          if(i.le.0) i=not(i)
          if(i.lt.64) then
c speed up for small differences
            y3=sig(i+2)
          else
            y3=8
            do while (y3.le.nb .and. i.ge.power(y3+1))
      	y3=y3+2	!was +1 (2/93, met)
            enddo
          endif
 7        y32=y3-y2
          if(y32.eq.0) go to 20	!cycle
          if(y12.eq.0) go to 18
          if(y12.lt.0) then
            if(y32.gt.0) then
c rise
      	x32=min(x3-x2,shift)
      	x20=min(x2,shift)
c low mid high --> mid high, low high
      	if(x20*y12+x32*y32.lt.0) then
      	  y2=y3
      	  y12=y1-y2
      	endif
            endif
c output if good enough
            if(y12*x2+shift.lt.0) go to 21
            y1=y2
            go to 18
          endif
c
          if(y32.lt.0) then
c drop
            if(y12*(x3-x2)+y12.gt.two) go to 21
c high mid low --> high low or high mid
            if(y12*(x3-x2)+y32.ge.0) go to 20
          else	!y32.gt.0
c dip
            if(y32.gt.y12) y32=y12
            y32=(x3-x2)*y32
            if(y32.gt.two) go to 21
            if(y32.gt.shift .and. x3.gt.256) go to 21
c high low mid --> high mid
c mid low high --> mid high
            if(y3-y1.lt.0) go to 19
          endif
 18       x2=x3
 19       y2=y3
          y12=y1-y2
 20     enddo
c
        if(y1.lt.0) then
          y1=y2
          x2=nn
        endif
 21     x2=min(x2,256)
        if((y1*x2+bit)/32.gt.maxp) then
          ierr=14
          go to 90
        endif
        if(y1.gt.16) then
          ierr=13
          go to 90
        endif
        ival=x2-1		!low order byte = count (max 255)
        ival=ior(ival,ishft(y1,8))	!high order byte = size
        ipak=pack(kptr)
        kpos=kpos-16
        itmp=0
        if(kpos.lt.0) itmp=ishft(ival,kpos+32)	!shift left
        if(kpos.ne.0) ival=ishft(ival,kpos)	!+=left, -=right
        if(kpos.gt.0) then
          ipak=ior(ipak,ival)
        else
          pack(kptr)=ior(ipak,ival)
          kptr=kptr+1
          ipak=itmp
          kpos=kpos+32
        endif
        pack(kptr)=ipak
        bit=bit+16
        if(y1.eq.0) go to 80
        kbits=y1
        do k=1,x2	!n=x2
          ival=is(k)
          ival=iand(ival,masks(kbits))	!drop sign extension
          kpos=kpos-kbits
          itmp=0
          if(kpos.lt.0) itmp=ishft(ival,kpos+32)	!shift left
          if(kpos.ne.0) ival=ishft(ival,kpos)	!+=left, -=right
          if(kpos.gt.0) then
            ipak=ior(ipak,ival)
          else
            pack(kptr)=ior(ipak,ival)
            kptr=kptr+1
            ipak=itmp
            kpos=kpos+32
          endif
          pack(kptr)=ipak
        enddo
        bit=bit+kbits*x2
 80     continue
        x0=x0+x2
        iold=items(x0)
      enddo
      ierr=0
c
#endif
 90   return
      end
c
      subroutine xpandi(nbits, pack, start, unpack, first, last, ierr)
c
c+expand compressed data, inverse of cmprsi
c
c nbits	  is number of bits maximum per item
c pack	  is packed array
c start	  is starting bit (0,...) in pack
c unpack  is unpacked array
c first	  is index(1,n) of item to place in unpack(1)
c last	  is index of last item placed in unpack
c ierr	  is returned error code (0=ok)
c	  16 if  bits > 16 or bits = 0
c	  13 if  invalid data (internal nbits > 16)
c
c=======================================================================
c
      implicit integer(a-z)
c
      integer*2 unpack(*)
      integer pack(*)
c
      integer power(18)
c
      integer*4 masks(0:16)
c
      data power/
     >	  0,1,2,4,8,16,32,64,128,256,512,
     >    1024,2048,4096,8192,16384,32768,65536/
c
#if __F90 || __NAGWARE
      data masks/ Z"00000000",
     >	  Z"00000001",Z"00000003",Z"00000007",Z"0000000f",
     >	  Z"0000001f",Z"0000003f",Z"0000007f",Z"000000ff",
     >	  Z"000001ff",Z"000003ff",Z"000007ff",Z"00000fff",
     >	  Z"00001fff",Z"00003fff",Z"00007fff",Z"0000ffff"/
#else
      data masks/ '00000000'x,
     >	  '00000001'x,'00000003'x,'00000007'x,'0000000f'x,
     >	  '0000001f'x,'0000003f'x,'0000007f'x,'000000ff'x,
     >	  '000001ff'x,'000003ff'x,'000007ff'x,'00000fff'x,
     >	  '00001fff'x,'00003fff'x,'00007fff'x,'0000ffff'x/
#endif
c-----------------------------------------------------------------------
c
#ifdef __CRAY
      print *,'EXPANDI not implemented for CRAY'
#else

      lowmask=masks(8)
c
      bit=start
      nb=abs(nbits)
      if(nb.gt.16 .or. nb.eq.0) then
        ierr=16
        go to 90
      endif
      index=0
      ii=0
      value=0
      lower=0
      modulo=power(nb+2)
      if(nbits.lt.0) lower=-power(nb+1)
      upper=lower+modulo-1
      ierr=0
      do while(index.lt.last)
C				!get next 16 bits
        kptr=bit/32+1		!ptr into pack
        kpos=mod(bit,32)	!offset in word
        kpos=kpos+16
        if(kpos.lt.32) then
          ival=ishft(pack(kptr),-(32-kpos))	!shift right
          ival=iand(ival,masks(16))
        else
          kpos=kpos-32
          ival=iand(pack(kptr),masks(16-kpos))
          kptr=kptr+1
          if(kpos.gt.0) then
            ntx=ishft(pack(kptr),-(32-kpos))	!shift right
            ntx=iand(ntx,masks(kpos))
            ival=ior(ishft(ival,kpos),ntx)	!shift left
          endif
        endif
        bit=bit+16
        bits=ishft(ival,-8)		!high order byte = size
        bits=-bits
        n=iand(ival,lowmask)+1		!low order byte = count
        n=min(n,last-index)
        if(bits.gt.16) then
          ierr=13
          return
        endif
        if(bits.eq.0) then
          do k=1,n
          index=index+1
          if(index.ge.first) then
            ii=ii+1
            unpack(ii)=value
          endif
          enddo
          go to 80
        endif
        kbits=abs(bits)
        do k=1,n
          kpos=kpos+kbits
          if(kpos.lt.32) then
            ival=ishft(pack(kptr),-(32-kpos))	!shift right
            ival=iand(ival,masks(kbits))
          else
            kpos=kpos-32
            ival=iand(pack(kptr),masks(kbits-kpos))
            kptr=kptr+1
            if(kpos.gt.0) then
      	ntx=ishft(pack(kptr),-(32-kpos))	!shift right
      	ntx=iand(ntx,masks(kpos))
      	ival=ior(ishft(ival,kpos),ntx)	!shift left
            endif
          endif
cx	    if(bits.lt.0) then	!bits is always negative
            imask=not(masks(kbits-1))		!extend sign bit
            if(iand(imask,ival).ne.0) ival=ior(ival,imask)
cx	    endif
          value=value+ival
          if(value.lt.lower) value=value+modulo
          if(value.gt.upper) value=value-modulo
          index=index+1
          if(index.ge.first) then
            ii=ii+1
            unpack(ii)=iand(value,masks(16))
          endif
        enddo
        bit=bit+kbits*n
 80   continue
      enddo
c
#endif
 90   return
      end

subroutine hatom_sigv(irtype,Eova,n,izneut,izchrg, sigv, istat)
 
  use iso_c_binding, only: fp => c_double
  use hatom_mod
 
  implicit NONE
 
  !  get sigma*v of a charge exchange or impact ionization reaction
  !  between two colliding beams of light neutral atoms with light
  !  fully stripped ions [H,HE,LI]x[H+,HE++,LI+++], where the interaction
  !  energy "per nucleon" is Eova = mp*vrel**2/2, in KeV.
  !
  !    ---caution-- as of June 2001, the atomic physics database does
  !                 not have all good data on LI.
  !
  !  here, "charge exchange" refers to an ion-neutral reaction, in which
  !  charges are exchanged ***and the ion is neutralized***; a reaction
  !  in which an electron is exchanged but the receiving particle is
  !  not neutralized, should be counted as an impact ionization event.
  !  The rationale:  this routine is intended for use in modeling of
  !  high temperature plasmas; a partially stripped light impurity is
  !  quickly fully stripped, so that the net result of a partial
  !  charge exchange reaction is two fully stripped ions, same as
  !  a "pure" impact ionization reaction.
  !
  !  if charge exchange is requested,
  !  a result of ZERO is returned if there is no neutralizing
  !  charge exchange reaction (e.g He++ cannot be neutralized by cx
  !  with an H neutral beam)
  !
  !  a result of ERROR (-1) is returned if invalid arguments
  !  are passed.
 
  integer, parameter :: CX=1, II=2
 
  integer, parameter :: H=1, HE=2, LI=3
 
  real*8, parameter :: ZERO=0.0d0, ERROR=-1.0D0
  integer, parameter :: IZERO=-1, IERROR=-2
 
  !--------------------------------------------
  !  **subroutine arguments**
 
  integer, intent(in) :: irtype   ! reaction type: =cx or =ii
 
  integer, intent(in) :: n        ! **vector size**
  real(fp), intent(in) :: eova(n)   ! E/A, KeV/nucleon, rel. energy  **vector**
 
  integer, intent(in)  :: izneut  ! Z of neutral species
  integer, intent(in)  :: izchrg  ! Z of ion species
 
  !  **result**
 
  real(fp), intent(out) :: sigv(n)  ! sigma*v, m**3/sec  **vector**
 
  integer, intent(out) :: istat   ! completion code; 0 = normal
 
  !  istat = 2:  irtype argument invalid
  !  istat = 3:  izneut or izchrg invalid
  !
  !--------------------------------------------
  !  local
 
  integer :: lreact   ! reaction handle
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  istat = 0
  lreact = IZERO
 
  if(irtype.eq.CX) then
 
     !  ---------> (neutralizing) charge exchange
 
     if(izneut.eq.H) then
        if(izchrg.eq.H) then
           lreact = Lcx_H0_H
        else if(izchrg.eq.HE) then
           lreact = IZERO          ! cannot neutralize HE
        else if(izchrg.eq.LI) then
           lreact = IZERO          ! cannot neutralize LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else if(izneut.eq.HE) then
        if(izchrg.eq.H) then
           lreact = Lcx_HE0_H
        else if(izchrg.eq.HE) then
           lreact = Lcx_HE0_HE
        else if(izchrg.eq.LI) then
           lreact = IZERO          ! cannot neutralize LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else if(izneut.eq.LI) then
        if(izchrg.eq.H) then
           lreact = Lcx_LI0_H
        else if(izchrg.eq.HE) then
           lreact = Lcx_LI0_HE
        else if(izchrg.eq.LI) then
           lreact = Lcx_LI0_LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else
 
        istat = 3
        lreact = IERROR
 
     endif
 
  else if(irtype.eq.II) then
 
     !  ---------> impact ionization
     !      or, sum of impact ionization and partial charge exchange
 
     if(izneut.eq.H) then
        if(izchrg.eq.H) then
           lreact = Lii_H0_H
        else if(izchrg.eq.HE) then
           lreact = Lii_H0_HE
        else if(izchrg.eq.LI) then
           lreact = Lii_H0_LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else if(izneut.eq.HE) then
        if(izchrg.eq.H) then
           lreact = Lii_HE0_H
        else if(izchrg.eq.HE) then
           lreact = Lii_HE0_HE
        else if(izchrg.eq.LI) then
           lreact = Lii_HE0_LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else if(izneut.eq.LI) then
        if(izchrg.eq.H) then
           lreact = Lii_LI0_H
        else if(izchrg.eq.HE) then
           lreact = Lii_LI0_HE
        else if(izchrg.eq.LI) then
           lreact = Lii_LI0_LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else
 
        istat = 3
        lreact = IERROR
 
     endif
 
  else
     istat = 2
     lreact = IERROR
  endif
 
  if(lreact.eq.IZERO) then
 
     sigv = ZERO
 
  else if(lreact.eq.IERROR) then
 
     sigv = ERROR
 
  else
 
     if(irtype.eq.CX) then
 
        call cx_coldtarget_sigmatimesv(lreact, eova, sigv, n)
 
     else if(irtype.eq.II) then
 
        call ii_coldtarget_sigmatimesv(lreact, eova, sigv, n)
 
     endif
 
  endif
 
end subroutine hatom_sigv

!-----------------------------------------------
!  utility subroutine for blims -- find min/max singularity
!  use parabolic fit from 3 data pts
!
subroutine r8_blims_mmx(zth0,zdth,zbm,zb0,zbp,zbsing,zthsing)
  !
  ! input:
  !  zth0 -- theta of ctrmost data pt (zb0)
  !  zdth -- delta(theta) from zth0 to zbm (-) and zbp (+) data points
  !  zbm,zb0,zbp -- sequence of three B field data pts
  !
  !  expected:  either zbm.ge.zb0.and.zbp.ge.zb0
  !               or   zbm.le.zb0.and.zbp.le.zb0
  !
  ! output:
  !  zbsing -- min (or max) B based on parabolic fit
  !  zthsing -- theta location (normalized to range (-pi,pi)) of the
  !            singularity.
  !
  ! fit:
  !
  !  th from zth0-zdth to zth0+zdth
  !
  !  f(th) = zb0 + (zbp-zbm)/(2*zdth) * (th-zth0)
  !              + (zbp+zbm-2*zb0)/(2*zdth**2) * (th-zth0)**2
  !
  !  f'(th) = (zbp-zbm)/(2*zdth) + (zbp+zbm-2*zb0)/(zdth**2) * (th-zth0)
  !
  !  solve f'(th)=0 to find zthsing; evaluate f(zthsing).
  !
  !-------------------
  !  1st check for degenerate case
  !
  !============
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: xpi => pi, twopi
  implicit none
  real(fp) :: zdth,zbm,zb0,zbp,zbsing,zthsing,zth0,zanum
  real(fp) :: za,zb,zdelth
  !
  zanum=(zbp+zbm-2*zb0)
  if(zanum.eq.0.0D0) then
    zbsing=zb0
    zthsing=zth0
    go to 10
  end if
  !
  za=zanum/(2*zdth**2)
  zb=(zbp-zbm)/(2*zdth)
  !
  zdelth = -zdth*zb/(2*za)
  zthsing= zth0 + zdelth
  !
  zbsing = zb0 + zb*zdelth + za*zdelth**2
  !
  !  standardize zthsing range
  !
10 continue
  if(zthsing.lt.-xpi) then
    zthsing=min(xpi,zthsing+twopi)
    go to 10
  else if(zthsing.gt.xpi) then
    zthsing=max(-xpi,zthsing-twopi)
    go to 10
  end if
  !
  return
end subroutine r8_blims_mmx

!
! defines a single overloaded function for computing an integer hash from input data.  The
! floating point hashes include the first 12 digits or so and the exponent.
! 
!  hashCode(f,ihash)
!     f     - integer or real(fp) scalar or array data to hash
!     ihash - hash code input and output
!
module plasma_hash_code
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one
  implicit none

  interface hashCode
    module procedure hashCodeF0,hashCodeF1,hashCodeF2,hashCodeF3,hashCodeF4
    module procedure hashCodeI0,hashCodeI1,hashCodeI2,hashCodeI3,hashCodeI4
    module procedure hashCodeCn0,hashCodeCn1
    module procedure hashCdblF0,hashCdblF1,hashCdblF2,hashCdblF3,hashCdblF4
    module procedure hashCdblI0,hashCdblI1,hashCdblI2,hashCdblI3,hashCdblI4
    module procedure hashCdblCn0,hashCdblCn1
  end interface hashCode

  integer, parameter :: imax = 123456789  ! keep hash below this maximum
  private
  public hashCode

contains

  subroutine hashCodeCn0(cstr,k)
    character(len=*), intent(in) :: cstr
    integer,intent(inout) :: k   ! hash code

    integer :: ilen,i
    integer, dimension(:), allocatable :: iwk

    ilen = len(trim(cstr))
    allocate(iwk(ilen+1))

    iwk(1)=-ilen
    do i=1,ilen
      iwk(1+i)=ichar(cstr(i:i))
    enddo

    call hashCode_I32(ilen+1,iwk,k)
    deallocate(iwk)
  end subroutine hashCodeCn0

  subroutine hashCodeCn1(astr,k)
    character(len=*), intent(in), dimension(:) :: astr
    integer,intent(inout) :: k   ! hash code

    integer :: ilen,ilentot,isize,i,j
    integer, dimension(:), allocatable :: iwk

    ilentot = 0
    isize=size(astr)
    do j=1,isize
      ilen = len(trim(astr(j)))
      ilentot = ilentot + ilen + 1
    enddo

    allocate(iwk(ilentot))

    ilentot = 0
    do j=1,isize
      ilen = len(trim(astr(j)))
      iwk(ilentot+1) = -ilen
      do i=1,ilen
        iwk(ilentot+1+i)=ichar(astr(j)(i:i))
      enddo
    enddo

    call hashCode_I32(ilen+1,iwk,k)
    deallocate(iwk)
  end subroutine hashCodeCn1

  subroutine hashCodeF0(f,k)
    real(fp), intent(in)    :: f   ! data
    integer,intent(inout) :: k   ! hash code

    call hashCode_F64(1,(/f/),k)
  end subroutine hashCodeF0

  subroutine hashCodeF1(f,k)
    real(fp), intent(in)    :: f(:)   ! data
    integer,intent(inout) :: k      ! hash code

    call hashCode_F64(size(f),f,k)
  end subroutine hashCodeF1

  subroutine hashCodeF2(f,k)
    real(fp), intent(in)    :: f(:,:)   ! data
    integer,intent(inout) :: k        ! hash code
    integer :: n

    n = size(f,1)*size(f,2)

    call hashCode_F64(n,reshape(f,(/n/)),k)
  end subroutine hashCodeF2

  subroutine hashCodeF3(f,k)
    real(fp), intent(in)    :: f(:,:,:)   ! data
    integer,intent(inout) :: k          ! hash code
    integer :: n

    n = size(f,1)*size(f,2)*size(f,3)

    call hashCode_F64(n,reshape(f,(/n/)),k)
  end subroutine hashCodeF3

  subroutine hashCodeF4(f,k)
    real(fp), intent(in)    :: f(:,:,:,:)   ! data
    integer,intent(inout) :: k            ! hash code
    integer :: n

    n = size(f,1)*size(f,2)*size(f,3)*size(f,4)

    call hashCode_F64(n,reshape(f,(/n/)),k)
  end subroutine hashCodeF4

  subroutine hashCodeI0(f,k)
    integer,intent(in)    :: f   ! data
    integer,intent(inout) :: k   ! hash code

    call hashCode_I32(1,(/f/),k)
  end subroutine hashCodeI0

  subroutine hashCodeI1(f,k)
    integer,intent(in)    :: f(:)   ! data
    integer,intent(inout) :: k      ! hash code

    call hashCode_I32(size(f),f,k)
  end subroutine hashCodeI1

  subroutine hashCodeI2(f,k)
    integer,intent(in)    :: f(:,:)   ! data
    integer,intent(inout) :: k        ! hash code
    integer :: n

    n = size(f,1)*size(f,2)

    call hashCode_I32(n,reshape(f,(/n/)),k)
  end subroutine hashCodeI2

  subroutine hashCodeI3(f,k)
    integer,intent(in)    :: f(:,:,:)   ! data
    integer,intent(inout) :: k          ! hash code
    integer :: n

    n = size(f,1)*size(f,2)*size(f,3)

    call hashCode_I32(n,reshape(f,(/n/)),k)
  end subroutine hashCodeI3

  subroutine hashCodeI4(f,k)
    integer,intent(in)    :: f(:,:,:,:)   ! data
    integer,intent(inout) :: k            ! hash code
    integer :: n

    n = size(f,1)*size(f,2)*size(f,3)*size(f,4)

    call hashCode_I32(n,reshape(f,(/n/)),k)
  end subroutine hashCodeI4

  !-------------------------------------------

  subroutine hashCdblCn0(cstr,k1,k2)
    character(len=*), intent(in) :: cstr
    integer,intent(inout) :: k1,k2   ! hash code

    integer :: ilen,i
    integer, dimension(:), allocatable :: iwk

    ilen = len(trim(cstr))
    allocate(iwk(ilen+1))

    iwk(1)=-ilen
    do i=1,ilen
      iwk(1+i)=ichar(cstr(i:i))
    enddo

    call hashCdbl_I32(ilen+1,iwk,k1,k2)
    deallocate(iwk)
  end subroutine hashCdblCn0

  subroutine hashCdblCn1(astr,k1,k2)
    character(len=*), intent(in), dimension(:) :: astr
    integer,intent(inout) :: k1,k2   ! hash code

    integer :: ilen,ilentot,isize,i,j
    integer, dimension(:), allocatable :: iwk

    ilentot = 0
    isize=size(astr)
    do j=1,isize
      ilen = len(trim(astr(j)))
      ilentot = ilentot + ilen + 1
    enddo

    allocate(iwk(ilentot))

    ilentot = 0
    do j=1,isize
      ilen = len(trim(astr(j)))
      iwk(ilentot+1) = -ilen
      do i=1,ilen
        iwk(ilentot+1+i)=ichar(astr(j)(i:i))
      enddo
    enddo

    call hashCdbl_I32(ilen+1,iwk,k1,k2)
    deallocate(iwk)
  end subroutine hashCdblCn1

  subroutine hashCdblF0(f,k1,k2)
    real(fp), intent(in)    :: f      ! data
    integer,intent(inout) :: k1,k2  ! hash code

    call hashCdbl_F64(1,(/f/),k1,k2)
  end subroutine hashCdblF0

  subroutine hashCdblF1(f,k1,k2)
    real(fp), intent(in)    :: f(:)   ! data
    integer,intent(inout) :: k1,k2  ! hash code

    call hashCdbl_F64(size(f),f,k1,k2)
  end subroutine hashCdblF1

  subroutine hashCdblF2(f,k1,k2)
    real(fp), intent(in)    :: f(:,:)   ! data
    integer,intent(inout) :: k1,k2    ! hash code
    integer :: n

    n = size(f,1)*size(f,2)

    call hashCdbl_F64(n,reshape(f,(/n/)),k1,k2)
  end subroutine hashCdblF2

  subroutine hashCdblF3(f,k1,k2)
    real(fp), intent(in)    :: f(:,:,:)   ! data
    integer,intent(inout) :: k1,k2      ! hash code
    integer :: n

    n = size(f,1)*size(f,2)*size(f,3)

    call hashCdbl_F64(n,reshape(f,(/n/)),k1,k2)
  end subroutine hashCdblF3

  subroutine hashCdblF4(f,k1,k2)
    real(fp), intent(in)    :: f(:,:,:,:)   ! data
    integer,intent(inout) :: k1,k2        ! hash code
    integer :: n

    n = size(f,1)*size(f,2)*size(f,3)*size(f,4)

    call hashCdbl_F64(n,reshape(f,(/n/)),k1,k2)
  end subroutine hashCdblF4

  subroutine hashCdblI0(f,k1,k2)
    integer,intent(in)    :: f      ! data
    integer,intent(inout) :: k1,k2  ! hash code

    call hashCdbl_I32(1,(/f/),k1,k2)
  end subroutine hashCdblI0

  subroutine hashCdblI1(f,k1,k2)
    integer,intent(in)    :: f(:)   ! data
    integer,intent(inout) :: k1,k2  ! hash code

    call hashCdbl_I32(size(f),f,k1,k2)
  end subroutine hashCdblI1

  subroutine hashCdblI2(f,k1,k2)
    integer,intent(in)    :: f(:,:)   ! data
    integer,intent(inout) :: k1,k2    ! hash code
    integer :: n

    n = size(f,1)*size(f,2)

    call hashCdbl_I32(n,reshape(f,(/n/)),k1,k2)
  end subroutine hashCdblI2

  subroutine hashCdblI3(f,k1,k2)
    integer,intent(in)    :: f(:,:,:)   ! data
    integer,intent(inout) :: k1,k2      ! hash code
    integer :: n

    n = size(f,1)*size(f,2)*size(f,3)

    call hashCdbl_I32(n,reshape(f,(/n/)),k1,k2)
  end subroutine hashCdblI3

  subroutine hashCdblI4(f,k1,k2)
    integer,intent(in)    :: f(:,:,:,:)   ! data
    integer,intent(inout) :: k1,k2        ! hash code
    integer :: n

    n = size(f,1)*size(f,2)*size(f,3)*size(f,4)

    call hashCdbl_I32(n,reshape(f,(/n/)),k1,k2)
  end subroutine hashCdblI4

  !-------------------------------------------
  ! private routines...

  subroutine hashCode_F64(n, f, k)
    integer, intent(in)    :: n     ! number of elements
    real(fp),  intent(in)    :: f(:)  ! data
    integer, intent(inout) :: k     ! hash

    integer, parameter :: im8  = 100000000   

    integer :: ke, i8, i
    real(fp)  :: frac, f8

    k = mod(k,imax)
    do i=1, n
      ke = exponent(f(i))
      k  = mod(7*k+ke+imax,imax)

      frac = fraction(f(i))
      if (frac<zero) then
        k  = mod(7*k+1,imax)
        frac=abs(frac+one)
      end if

      f8 = frac*im8
      i8 = floor(f8)
      k  = mod(7*k+i8,imax)

      f8 = (f8-i8)*im8
      i8 = floor(f8)
      k  = mod(7*k+i8,imax)
      k  = abs(k)
    end do
  end subroutine hashCode_F64

  subroutine hashCode_I32(n, f, k)
    integer, intent(in)    :: n     ! number of elements
    integer, intent(in)    :: f(:)  ! data
    integer, intent(inout) :: k     ! hash

    integer, parameter :: im6  = 1000000   

    integer :: ke, i6, i
    integer :: frac, f6

    k = mod(k,imax)
    do i=1, n
      frac = f(i)
      if (frac<0) then
        k  = mod(7*k+1,imax)
        frac=abs(frac+imax)  ! make positive
      end if

      i6 = mod(frac,im6)      ! lower 6 digits
      k  = mod(7*k+i6,imax)

      i6 = frac/im6
      if (i6>0) then
        k = mod(7*k+i6,imax)
      end if
      k = abs(k)
    end do
  end subroutine hashCode_I32

  !-------------------------------------------

  subroutine hashCdbl_F64(n, f, k1,k2)
    integer, intent(in)    :: n     ! number of elements
    real(fp),  intent(in)    :: f(:)  ! data
    integer, intent(inout) :: k1,k2 ! hash

    integer, parameter :: im8  = 100000000   

    integer :: ke, i8, i, j
    real(fp)  :: frac, f8

    k1 = mod(k1,imax)
    k2 = mod(k2,imax)
    do i=1, n
      ke = exponent(f(i))
      k1  = mod(7*k1+ke+imax,imax)

      frac = fraction(f(i))
      if (frac<zero) then
        k1 = mod(7*k1+1,imax)
        frac=abs(frac+one)
      end if

      f8 = frac*im8
      i8 = floor(f8)
      k1 = mod(7*k1+i8,imax)

      f8 = (f8-i8)*im8
      i8 = floor(f8)
      k1 = mod(7*k1+i8,imax)
      k1 = abs(k1)

      j = n + 1 - i           ! scan in reverse order
      ke = exponent(f(j))
      k2  = mod(7*k2+ke+imax,imax)

      frac = fraction(f(j))
      if (frac<zero) then
        k2 = mod(7*k2+1,imax)
        frac=abs(frac+one)
      end if

      f8 = frac*im8
      i8 = floor(f8)
      k2 = mod(7*k2+i8,imax)

      f8 = (f8-i8)*im8
      i8 = floor(f8)
      k2 = mod(7*k2+i8,imax)
      k2 = abs(k2)
    end do
  end subroutine hashCdbl_F64

  subroutine hashCdbl_I32(n, f, k1,k2)
    integer, intent(in)    :: n     ! number of elements
    integer, intent(in)    :: f(:)  ! data
    integer, intent(inout) :: k1,k2 ! hash

    integer, parameter :: im6  = 1000000   

    integer :: ke, i6, i,j
    integer :: frac, f6

    k1 = mod(k1,imax)
    k2 = mod(k2,imax)
    do i=1, n
      frac = f(i)
      if (frac<0) then
        k1 = mod(7*k1+1,imax)
        frac=abs(frac+imax)  ! make positive
      end if

      i6 = mod(frac,im6)      ! lower 6 digits
      k1  = mod(7*k1+i6,imax)

      i6 = frac/im6
      if (i6>0) then
        k1 = mod(7*k1+i6,imax)
      end if
      k1 = abs(k1)

      j = n + 1 - i           ! scan in reverse order
      frac = f(j)
      if (frac<0) then
        k2 = mod(7*k2+1,imax)
        frac=abs(frac+imax)  ! make positive
      end if

      i6 = mod(frac,im6)      ! lower 6 digits
      k2  = mod(7*k2+i6,imax)

      i6 = frac/im6
      if (i6>0) then
        k2 = mod(7*k2+i6,imax)
      end if
      k2 = abs(k2)
    end do
  end subroutine hashCdbl_I32

end module plasma_hash_code

C******************** START FILE UPQUER.FOR ; GROUP USPARM *************
C--------------------------------------------------------------
C&  UPQUER    QUERY USER AS TO VALUE OF UNIDENTIFIED PARAMETER
C
C   ZNAME-- 10 CHAR UNIDENTIFIED PARAMETER NAME (INPUT)
C   ZLINE-- 80 CHAR UNPACKED SPACE TO RECIEVE ANSWER (WHICH
C       MAY BE USED BY MAIN PROG (UREAD CALLER) FOR INPUT
C   LLINE-- LENGTH OF ZLINE (NORM. 80 CHARS.)
C   ZVAL--  OUTPUT PACKED 96 CHAR VALUE SPECIFIED
 
 
      SUBROUTINE UPQUER(ZNAME,ZLINE,LLINE,ZVAL)

      USE USERIO
C
      CHARACTER*16 ZNAME
      CHARACTER*96 ZVAL
      CHARACTER*1 ZLINE(LLINE),ZC1,ZC2
C
      logical il1lin
C
C-----------------------------------
C
      ILINE=LEN(ZVAL)+1
C
      IF(IBATCH.EQ.1) GO TO 80
C  IN INTERACTIVE MODE QUERY TOP LEVEL (USER) FOR PARAMETER VALUE
      ILNAM=ILNURD(ZNAME)
 70   WRITE(LUNTRM,7001) ZNAME(1:ILNAM)
 7001 FORMAT(
     >' % UPQUER: *** UNDEFINED UREAD STRING PARAMETER "',
     1  A,'" ENCOUNTERED.')
C
      CALL UPROMTX('   ENTER VALUE (MAX 96 CHARACTERS): ',0)
      CALL URDSTT('PARAMETER VALUE',ZVAL)
C
      ZLINE(ILINE)=' '
      DO I=1,ILINE-1
        ZLINE(I)=ZVAL(I:I)
      ENDDO
      IND1=1
      IND2=ILINE
      CALL USPLVL(ZLINE,ILINE,IND1,IND2,ZVAL,IER)
      IF(IER.NE.0) GO TO 70
      CALL UPSADL(ZNAME,ZVAL)
      NCLEAR=0
      CALL NEUPAG
      RETURN
C  BATCH MODE: QUERY TOP LEVEL (BATCH CONTROL FILE) FOR MISSING
C  PARAMETER VALUE; ACCEPT ANSWER IFF 1ST TWO CHARACTERS ARE "/="
C
 80   CONTINUE
      WRITE(LUNTRM,7001) ZNAME
      READ(LUNTIN(1),'(A1,A1,A)',ERR=85) ZC1,ZC2,ZVAL
      ZLINE(ILINE)=' '
      DO I=1,ILINE-1
        ZLINE(I)=ZVAL(I:I)
      ENDDO
      IF((ZC1.EQ.MSLASH).AND.(ZC2.EQ.MEQS)) GO TO 90
C  REJECT
 85   WRITE(LUNTRM,7002)
 7002 FORMAT(' ? UNANTICIPATED RESPONSE, PROGRAM EXECUTION'/
     >  '   HALTED, FORTRAN SUBROUTINE UPQUER ("USPARM.FOR")'///)
      CALL URDABO
C  OK
 90   CONTINUE
      IND1=1
      IND2=ILINE
      CALL USPLVL(ZLINE,ILINE,IND1,IND2,ZVAL,IER)
      IF(IER.NE.0) GO TO 85
      CALL UPSADL(ZNAME,ZVAL)
      RETURN
      	END
C******************** END FILE UPQUER.FOR ; GROUP USPARM ***************

!******************** START FILE UFWRCDF_AEP.F90 ; GROUP UFILES ******************
!--------------------------------------------------------------
!  UFCDFRD_AEP
! READ Multi-DIMENSIONAL DATA TO NetCdf FILE for AEP model (Mario Pdesta)
!
SUBROUTINE UFCDFRD_AEP_DIM(nlun,ilun,icdf,NPACK,NK,NT,NDEMAX,NDPMAX,&
     NEMAX,NPMAX,NMUMAX,IER)
! 
!  MG  03/13/2014 
!  nk -- terms # in Mario Pdesta series
!  nt -- # of points in time grig TM
!  ndemax -- max(1,maxval(nde))
!  ndpmax -- max(1,maxval(ndp))
!  nemax -- max(1,maxval(ne))
!  npmax -- max(1,maxval(np))
!  nmumax -- max(1,maxval(nmu))
!  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
!
  use netcdf
  use UFILES, only : ufid
  implicit none
  integer :: ierr,ier
  integer,intent(in) :: ilun !channel ID
  integer,intent(in) :: nlun ! output file ID
  integer,intent(out) :: icdf !NetCdf ID
  integer :: i_dim       
  character*30 :: cvar
  integer,intent(out) :: nk,nt,NDEMAX,NDPMAX,NEMAX,NPMAX,NMUMAX,npack
  integer :: ichan
! it is related to include 'UFILES' for more details see inclshare/UFILES
!-----------------------------------------
!
!  WRITE ***
!
! sanitary check
  ier=0
  CALL UFINIT
  CALL UFLCHK(ILUN,'UFCDFRDAEP',ICHAN,IER)
  IF(ier.NE.0) THEN
     write(nlun,*) ' ?ufcdfrd_aep error: trying to read wrong file'
!     CALL UERSTA(ICHAN,'UFCDFRDAEP')
     ier=1
     return
  ENDIF

  icdf=ufid(ichan)
  ierr=0

  cvar='NK'
  nk=0
  call check_inq_dim(icdf,cvar,i_dim,ierr)
  if(ierr.eq.0) then
     nk=i_dim
  endif
  if(nk.le.0.or.nk.gt.10) then
     write(nlun,*) ' ?ufcdfrd_aep error: nk for AEP has not been set correctly'
     ier=ier+1
  endif

  cvar='NT'
  NT=0
  call check_inq_dim(icdf,cvar,i_dim,ierr)
  if(ierr.eq.0) then
     NT=i_dim
  endif
  if(NT.le.0) then
     write(nlun,*) ' ?ufcdfrd_aep error: NT for AEP has not been set correctly'
     ier=ier+1
  endif

  cvar='NDEMAX'
  Ndemax=0
  call check_inq_dim(icdf,cvar,i_dim,ierr)
  if(ierr.eq.0) then
     Ndemax=i_dim
  endif
  if(Ndemax.le.0) then
     write(nlun,*) ' ?ufcdfrd_aep error: Ndemax for AEP has not been set correctly'
     ier=ier+1
  endif

  cvar='NDPMAX'
  NDPMAX=0
  call check_inq_dim(icdf,cvar,i_dim,ierr)
  if(ierr.eq.0) then
     NDPMAX=i_dim
  endif
  if(NDPMAX.le.0) then
     write(nlun,*) ' ?ufcdfrd_aep error: NDPMAX for AEP has not been set correctly'
     ier=ier+1
  endif

  cvar='NEMAX'
  NEMAX=0
  call check_inq_dim(icdf,cvar,i_dim,ierr)
  if(ierr.eq.0) then
     NEMAX=i_dim
  endif
  if(NEMAX.le.0) then
     write(nlun,*) ' ?ufcdfrd_aep error: NEMAX for AEP has not been set correctly'
     ier=ier+1
  endif

  cvar='NPMAX'
  Npmax=0
  call check_inq_dim(icdf,cvar,i_dim,ierr)
  if(ierr.eq.0) then
     Npmax=i_dim
  endif
  if(Npmax.le.0) then
     write(nlun,*) ' ?ufcdfrd_aep error: Npmax for AEP has not been set correctly'
     ier=ier+1
  endif

  cvar='NMUMAX'
  Nmumax=0
  call check_inq_dim(icdf,cvar,i_dim,ierr)
  if(ierr.eq.0) then
     Nmumax=i_dim
  endif
  if(Nmumax.le.0) then
     write(nlun,*) ' ?ufcdfrd_aep error: Nmumax for AEP has not been set correctly'
     ier=ier+1
  endif

  cvar='NPACK'
  npack=0
  call check_inq_dim(icdf,cvar,i_dim,ierr)
  if(ierr.eq.0) then
     npack=i_dim
  endif
  if(npack.lt.0) then
     write(nlun,*) ' ?ufcdfrd_aep_dim error: npack for AEP has not been set correctly'
     ier=ier+1
  endif
  if(ier.gt.0) then
     ierr = nf90_close(icdf)
     ier=ier+ierr
  endif
  RETURN

contains 
  
  subroutine check_inq_dim(i_cdf,varnam,idim,ierrcdf) 
    integer,intent(in) :: i_cdf
    integer,intent(out) :: ierrcdf 
    character*(*),intent(in) :: varnam ! dimension name input 
    integer, intent(out) :: idim        ! dimension size returned 
    integer ::idd !var ID 
    ierrcdf = nf90_inq_dimid(i_cdf,trim(adjustl(varnam)),idd) 
    if(ierrcdf.ne.0) then 
       if(trim(adjustl(varnam)).eq.'NPACK') then
          ierrcdf=0
          idim=0
          return
       else
          write(nlun,*) ' ?ufcdfrd_aep_dim error: NO such dim='//trim(varnam)
          ier=ier+1
          return
       endif
    endif 
    ierrcdf = nf90_inquire_dimension(i_cdf,idd,len=idim) 
    if(ierrcdf.ne.0) then 
       write(nlun,*) ' ?ufcdfrd_aep error:'//nf90_strerror(ierrcdf)//'for var.'//trim(varnam) 
       ier=ier+1
    endif 
  end subroutine check_inq_dim

END SUBROUTINE UFCDFRD_AEP_DIM

!******************** START FILE UFWRCDF_AEP.F90 ; GROUP UFILES ******************
!--------------------------------------------------------------
!  UFCDFRD_AEP
! READ Multi-DIMENSIONAL DATA TO NetCdf FILE for AEP model (Mario Pdesta)
!
SUBROUTINE UFCDFRD_AEP(nlun,icdf,inshot,aep_sp,&
     NK,NT,NDEMAX,NDPMAX,NEMAX,NPMAX,NMUMAX,&
     TM,AAEP,TSTEP,DE,DP,E,P,ZMU,PAEP,ctunits,ceunits,IER)
! 
!  MG  03/13/2014 
!  ISHOT -- ISHOT # ("139048")
!  IDEV-- 4 LETTER TOKAMAK DEV. CODE ("PLT ", ETC.)
!  nk -- terms # in Mario Pdesta series
!  iaep_sp(NK) -- code # of species with which mode (nk) will have intercation
!  species code #
!  0                  ;ALL fast ion SPECIES in this run (in NUBEAM)
!  1                  ;deuterium
!  2                  ;tritium
!  3                  ;HE3
!  4                  ;HE4
!  5                  ;protons          
!
!  AAEP(NT,NK) -- Mode amplitude. Aaep_k_specie(time)
!  nt -- # of points in time grig TM
!  TM(nt) -- time grid in ms
!  Tstep(nk) -- time step used to investigate AEP mode
!  demin(NK), demax(NK) -- left and right boundaries for a linear grid, function of nk (# of terms in MP series)
!  dpmin(NK), dpmax(NK) -- same as above
!  emin(NK), emax(NK) -- same as above
!  pmin(NK), pmax(NK) -- same as above
!  mumin(NK), mumax(NK) -- same as above
!  PAEP(ndemax,ndpmax,nemax,npmax,nmumax,nk)  -- probability matrix
!  ndemax -- max(1,maxval(nde))
!  ndpmax -- max(1,maxval(ndp))
!  nemax -- max(1,maxval(ne))
!  npmax -- max(1,maxval(np))
!  nmumax -- max(1,maxval(nmu))
!  PROCESS CODE 0 = "RAW" raw data are saved
!  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
!
  use iso_c_binding, only: fp => c_double
  use netcdf
  implicit none
  integer,intent(in) :: inshot !SHOT no
  integer,intent(in) :: icdf   !NetCdf ID 
  integer,intent(in) :: nlun   !output file ID 
  integer,intent(in) :: nk,nt,NDEMAX,NDPMAX,NEMAX,NPMAX,NMUMAX
  character*9, intent(out):: ctunits,ceunits !units for Time and Energy from Ufile
  real(fp),dimension(nk) :: aep_sp !species code # to which AEP mode will be applied
  integer,dimension(nk) :: iaep_sp !species code # to which AEP mode will be applied
  integer :: ierr,ier
  integer :: ishot
  integer :: id      
  character*30 :: cvar
  real(fp) :: TM(nt),AAEP(nt,nk),Tstep(nk),DE(nk,3),DP(nk,3),E(nk,3),P(nk,3),ZMU(nk,3)
  real(fp) :: NDE(nk),NDP(nk),NE(nk),NP(nk),NMU(nk),PAEP(NDEMAX,NDPMAX,NEMAX,NPMAX,NMUMAX,NK)
  character (len=80) :: ctime_units,cenergy_units
  integer :: ilunits,maxlen_u,i
!-----------------------------------------
!
!  WRITE ***
!
! sanitary check
  ier=0
  ierr=0
!OK now write netcdf file, raw data
!  IPROC = 0 
!  KMPRS = 4 !CDF file 
!  cvar='DEVLBL'
!  ilbl=4
!  call check(nf90_def_dim(icdf,cvar,ilbl,id_lbl),cvar)
  cvar='SHOT'
  ishot=0
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ishot),cvar)
  endif
  if(ishot.ne.inshot) then
     write(nlun,*) ' !ufcdfrd_aep warning: inconsistency in shot no. found in Ufile'
  endif
!  cvar='DEVICE'
!  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl/),id_dev),cvar)
!  cvar='UFLBL'
!  ilbl1=10
!  call check(nf90_def_dim(icdf,cvar,ilbl1,id_lbl1),cvar)
!  cvar = 'UFLABEL'  !UF label
!  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_uf),cvar)
!  cvar = 'ZSDATE'   !SHOT (DATA ORIGIN) DATE
! call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_zsdate),cvar)
!  cvar = 'ZDATE'    !FILE WRITE DATE
!  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_zdate),cvar)

  iaep_sp=-1 ! initialization
  cvar = 'IAEP_SP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,iaep_sp(:)),cvar)
     aep_sp(:)=real(iaep_sp(:),fp)
  endif
  cvar='TM'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,TM(:)),cvar)
     ierr = nf90_get_att(icdf,id,cvar,ctime_units)
     ctunits=' '
     if(ierr.eq.0) then
        ilunits=len(ctime_units)
        do i=1,ilunits
           if(ctime_units(i:i).eq.',') then
              maxlen_u=min(9,ilunits-i) ! written by ufcdfwr_aep, but may be truncated by netcdf
              ctunits(1:maxlen_u)=ctime_units(i+1:i+maxlen_u)
              exit
           endif
        enddo
     endif
  endif
! get attribute to find units
  
  
  cvar='AAEP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,AAEP(:,:)),cvar)
  endif
  cvar='TSTEP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,TSTEP(:)),cvar)
     ierr = nf90_get_att(icdf,id,cvar,ctime_units)
     ctunits=' '
     if(ierr.eq.0) then
        ilunits=len(ctime_units)
        do i=1,ilunits
           if(ctime_units(i:i).eq.',') then
              maxlen_u=min(9,ilunits-i) ! written by ufcdfwr_aep, but may be truncated by netcdf
              ctunits(1:maxlen_u)=ctime_units(i+1:i+maxlen_u)
              exit
           endif
        enddo
     endif
  endif
  
  cvar='DEMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,DE(:,2)),cvar)
     ierr = nf90_get_att(icdf,id,cvar,cenergy_units)
     ceunits=' '
     if(ierr.eq.0) then
        ilunits=len(cenergy_units)
        do i=1,ilunits
           if(cenergy_units(i:i).eq.',') then
              maxlen_u=min(9,ilunits-i) ! written by ufcdfwr_aep, but may be truncated by netcdf
              ceunits(1:maxlen_u)=cenergy_units(i+1:i+maxlen_u)
              exit
           endif
        enddo
     endif
  endif
  cvar='DEMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,DE(:,3)),cvar)
  endif

  cvar='DPMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,DP(:,2)),cvar)
  endif
  cvar='DPMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,DP(:,3)),cvar)
  endif

  cvar='EMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,E(:,2)),cvar)
  endif
  cvar='EMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,E(:,3)),cvar)
  endif

  cvar='PMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,P(:,2)),cvar)
  endif
  cvar='PMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,P(:,3)),cvar)
  endif

  cvar='MUMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ZMU(:,2)),cvar)
  endif
  cvar='MUMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ZMU(:,3)),cvar)
  endif

  cvar = 'NDE'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,nde(:)),cvar)
     DE(:,1)=REAL(nde(:),fp) 
  endif

  cvar = 'NDP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ndp(:)),cvar)
     DP(:,1)=REAL(ndp(:),fp) 
  endif

  cvar = 'NE'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ne(:)),cvar)
     E(:,1)=REAL(ne(:),fp) 
  endif

  cvar = 'NP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,np(:)),cvar)
     P(:,1)=REAL(np(:),fp) 
  endif

  cvar = 'NMU'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,nmu(:)),cvar)
      ZMU(:,1)=REAL(nmu(:),fp) 
   endif

  cvar='PAEP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,PAEP(:,:,:,:,:,:)),cvar)
  endif
!MG  ierr = nf90_close(icdf)

  ier=ier+ierr

  RETURN

contains 
  
  subroutine check(status,varnam)
    integer, intent ( in) :: status 
    character*(*),intent(in) :: varnam ! dimension name input 
    
    if(status /= nf90_noerr) then 
       write(nlun,*)' ?UFCDFRD_AEP: error:'& 
            &// trim(nf90_strerror(status))//' for var.= '//trim(varnam)
       ierr=ierr+1
    end if
  end subroutine check

  subroutine check_inq(i_cdf,varnam,id,ierrcdf)
    integer,intent(in) :: i_cdf
    integer,intent(out) :: id,ierrcdf
    character*(*),intent(in) :: varnam 
    ierrcdf = nf90_inq_varid(i_cdf,trim(varnam),id) 
    if(ierrcdf.ne.0) then 
       write(nlun,*) ' ?ufcdfrd_aep error: invalid var.: '//trim(varnam)
       ier=ier+1
    endif
  end subroutine check_inq

END SUBROUTINE UFCDFRD_AEP

!******************** START FILE UFWRCDF_AEP_PACK.F90 ; GROUP UFILES ******************
!--------------------------------------------------------------
!  UFCDFRD_AEP_PACK
! READ Multi-DIMENSIONAL DATA TO NetCdf FILE for AEP model (Mario Pdesta)
!
SUBROUTINE UFCDFRD_AEP_PACK(nlun,icdf,inshot,aep_sp,&
     NPACK, NK,NT,&
     TM,AAEP,TSTEP,DE,DP,E,P,ZMU,IDIFF_MAP,PAEP,ctunits,ceunits,IER)
! 
!  MG  03/13/2014 
!  ISHOT -- ISHOT # ("139048")
!  IDEV-- 4 LETTER TOKAMAK DEV. CODE ("PLT ", ETC.)
!  nk -- terms # in Mario Pdesta series
!  iaep_sp(NK) -- code # of species with which mode (nk) will have intercation
!  species code #
!  0                  ;ALL fast ion SPECIES in this run (in NUBEAM)
!  1                  ;deuterium
!  2                  ;tritium
!  3                  ;HE3
!  4                  ;HE4
!  5                  ;protons          
!
!  AAEP(NT,NK) -- Mode amplitude. Aaep_k_specie(time)
!  nt -- # of points in time grig TM
!  TM(nt) -- time grid in ms
!  Tstep(nk) -- time step used to investigate AEP mode
!  demin(NK), demax(NK) -- left and right boundaries for a linear grid, function of nk (# of terms in MP series)
!  dpmin(NK), dpmax(NK) -- same as above
!  emin(NK), emax(NK) -- same as above
!  pmin(NK), pmax(NK) -- same as above
!  mumin(NK), mumax(NK) -- same as above
!  PAEP(npack)  -- packed probability matrix
!  PROCESS CODE 0 = "RAW" raw data are saved
!  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
!
  use iso_c_binding, only: fp => c_double
  use netcdf
  implicit none
  integer,intent(in) :: inshot !SHOT no
  integer,intent(in) :: icdf   !NetCdf ID 
  integer,intent(in) :: nlun   !output file ID 
  integer,intent(in) :: nk,nt,npack
  character*9, intent(out):: ctunits,ceunits !units for Time and Energy from Ufile
  real(fp),dimension(nk) :: aep_sp !species code # to which AEP mode will be applied
  integer,dimension(nk) :: iaep_sp !species code # to which AEP mode will be applied
  integer,dimension(npack) :: idiff_map ! indecies for non-zeros in probability martix 
  integer :: ierr,ier
  integer :: ishot
  integer :: id      
  character*30 :: cvar
  real(fp) :: TM(nt),AAEP(nt,nk),Tstep(nk),DE(nk,3),DP(nk,3),E(nk,3),P(nk,3),ZMU(nk,3)
  real(fp) :: NDE(nk),NDP(nk),NE(nk),NP(nk),NMU(nk),PAEP(npack)
  character (len=80) :: ctime_units,cenergy_units
  integer :: ilunits,maxlen_u,i
!-----------------------------------------
!
!  WRITE ***
!
! sanitary check
  ier=0
  ierr=0
!OK now write netcdf file, raw data
!  IPROC = 0 
!  KMPRS = 4 !CDF file 
!  cvar='DEVLBL'
!  ilbl=4
!  call check(nf90_def_dim(icdf,cvar,ilbl,id_lbl),cvar)
  cvar='SHOT'
  ishot=0
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ishot),cvar)
  endif
  if(ishot.ne.inshot) then
     write(nlun,*) ' !ufcdfrd_aep_pack warning: inconsistency in shot no. found in Ufile'
  endif
  iaep_sp=-1 ! initialization
  cvar = 'IAEP_SP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,iaep_sp(:)),cvar)
     aep_sp(:)=real(iaep_sp(:),fp)
  endif
  cvar='TM'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,TM(:)),cvar)
     ierr = nf90_get_att(icdf,id,cvar,ctime_units)
     ctunits=' '
     if(ierr.eq.0) then
        ilunits=len(ctime_units)
        do i=1,ilunits
           if(ctime_units(i:i).eq.',') then
              maxlen_u=min(9,ilunits-i) ! written by ufcdfwr_aep, but may be truncated by netcdf
              ctunits(1:maxlen_u)=ctime_units(i+1:i+maxlen_u)
              exit
           endif
        enddo
     endif
  endif
! get attribute to find units

  cvar='AAEP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,AAEP(:,:)),cvar)
  endif
 
  cvar='TSTEP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,TSTEP(:)),cvar)
     ierr = nf90_get_att(icdf,id,cvar,ctime_units)
     ctunits=' '
     if(ierr.eq.0) then
        ilunits=len(ctime_units)
        do i=1,ilunits
           if(ctime_units(i:i).eq.',') then
              maxlen_u=min(9,ilunits-i) ! written by ufcdfwr_aep, but may be truncated by netcdf
              ctunits(1:maxlen_u)=ctime_units(i+1:i+maxlen_u)
              exit
           endif
        enddo
     endif
  endif
  
  cvar='DEMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,DE(:,2)),cvar)
     ierr = nf90_get_att(icdf,id,cvar,cenergy_units)
     ceunits=' '
     if(ierr.eq.0) then
        ilunits=len(cenergy_units)
        do i=1,ilunits
           if(cenergy_units(i:i).eq.',') then
              maxlen_u=min(9,ilunits-i) ! written by ufcdfwr_aep, but may be truncated by netcdf
              ceunits(1:maxlen_u)=cenergy_units(i+1:i+maxlen_u)
              exit
           endif
        enddo
     endif
  endif
 
  cvar='DEMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,DE(:,3)),cvar)
  endif

  cvar='DPMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,DP(:,2)),cvar)
  endif

  cvar='DPMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,DP(:,3)),cvar)
  endif

  cvar='EMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,E(:,2)),cvar)
  endif

  cvar='EMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,E(:,3)),cvar)
  endif

  cvar='PMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,P(:,2)),cvar)
  endif

  cvar='PMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,P(:,3)),cvar)
  endif

  cvar='MUMIN'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ZMU(:,2)),cvar)
  endif

  cvar='MUMAX'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ZMU(:,3)),cvar)
  endif

  cvar = 'NDE'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,nde(:)),cvar)
     DE(:,1)=REAL(nde(:),fp) 
  endif

  cvar = 'NDP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ndp(:)),cvar)
     DP(:,1)=REAL(ndp(:),fp) 
  endif

  cvar = 'NE'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,ne(:)),cvar)
     E(:,1)=REAL(ne(:),fp) 
  endif

  cvar = 'NP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,np(:)),cvar)
     P(:,1)=REAL(np(:),fp) 
  endif

  cvar = 'NMU'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,nmu(:)),cvar)
      ZMU(:,1)=REAL(nmu(:),fp) 
   endif

  cvar='IDIFF_MAP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,idiff_map(:)),cvar)
  endif

  cvar='PAEP'
  call check_inq(icdf,cvar,id,ierr)
  if(ierr.eq.0) then
     call check(nf90_get_var(icdf,id,PAEP(:)),cvar)
  endif

  ier=ier+ierr

  RETURN

contains 
  
  subroutine check(status,varnam)
    integer, intent ( in) :: status 
    character*(*),intent(in) :: varnam ! dimension name input 
    
    if(status /= nf90_noerr) then 
       write(nlun,*)' ?UFCDFRD_AEP_PACK: error:'& 
            &// trim(nf90_strerror(status))//' for var.= '//trim(varnam)
       ierr=ierr+1
    end if
  end subroutine check

  subroutine check_inq(i_cdf,varnam,id,ierrcdf)
    integer,intent(in) :: i_cdf
    integer,intent(out) :: id,ierrcdf
    character*(*),intent(in) :: varnam 
    ierrcdf = nf90_inq_varid(i_cdf,trim(varnam),id) 
    if(ierrcdf.ne.0) then 
       write(nlun,*) ' ?ufcdfrd_aep_pack error: invalid var.: '//trim(varnam)
       ier=ier+1
    endif
  end subroutine check_inq

END SUBROUTINE UFCDFRD_AEP_PACK

SUBROUTINE UFCDFRD_AEP_DATA(nlun,icdf,inshot,NPACK,MKAEP,MTAEP,&
     MdEAEP,MdpAEP,MEAEP,MpAEP,MmuAEP,&
     isiza,dat_buf,ctunits,ceunits,ier)
!  read data from already open file with ID=icdf
  use iso_c_binding, only: fp => c_double
  use netcdf
  implicit none
  integer,intent(in) :: inshot !SHOT no
  integer,intent(in) :: icdf   !NetCdf ID 
  integer,intent(in) :: nlun   !output file ID 
  integer,intent(in) :: NPACK,MKAEP,MTAEP,MdEAEP,MdpAEP,MEAEP,MpAEP,MmuAEP !dimensions
  integer,intent(in) :: isiza
  real(fp), dimension(:), allocatable :: tmpT,tmpTstep
  real(fp), dimension(:,:), allocatable :: DATA_tmpA,tmpDE,tmpDP,tmpE,tmpP,tmpMU
  integer, dimension(:), allocatable :: idiff_map
  real(fp), dimension(:), allocatable :: DATA_tmpP
  real(fp), dimension(3) :: AEPSP 
  character*9 :: ctunits,ceunits !units for Time and Energy from Ufile  
  integer :: ier      ! local error status variable
  integer :: il,ik,ide,idp,ie,ip,imu
  real dat_buf(isiza)  
  !
  ier = 0
  !  allocate AEP arrays 
  if(allocated(tmpT)) deallocate(tmpT)
  allocate(tmpT(MTAEP))
  tmpT=0.0_fp
  if(allocated(DATA_tmpA)) deallocate(DATA_tmpA)
  allocate(DATA_tmpA(MTAEP,MKAEP))
  DATA_tmpA=0.0_fp
  if(allocated(tmpTstep)) deallocate(tmpTstep)
  allocate(tmpTstep(MKAEP))
  tmpTstep=0.0_fp
  if(allocated(tmpDE)) deallocate(tmpDE)
  allocate(tmpDE(MKAEP,3))
  tmpDE=0.0_fp
  if(allocated(tmpDP)) deallocate(tmpDP)
  allocate(tmpDP(MKAEP,3))
  tmpDP=0.0_fp
  if(allocated(tmpE)) deallocate(tmpE)
  allocate(tmpE(MKAEP,3))
  tmpE=0.0_fp
  if(allocated(tmpP)) deallocate(tmpP)
  allocate(tmpP(MKAEP,3))
  tmpP=0.0_fp
  if(allocated(tmpMU)) deallocate(tmpMU)
  allocate(tmpMU(MKAEP,3))
  tmpMU=0.0_fp
  if(allocated(DATA_tmpP)) deallocate(DATA_tmpP)
  allocate(DATA_tmpP(npack))
  DATA_tmpP=0.0_fp
  if(allocated(idiff_map)) deallocate(idiff_map)
  allocate(idiff_map(npack))
  idiff_map=0
  ! read expantion for AEP operator, close netcdf file  
  call ufcdfrd_aep_pack(nlun,icdf,iNSHOT,AEPSP,NPACK,&
       MKAEP,MTAEP,&
       tmpT,DATA_tmpA,tmpTstep,tmpDE,tmpDP,tmpE,tmpP,&
       tmpMU,IDIFF_MAP,DATA_tmpP,ctunits,ceunits,ier)
  if(ier.gt.0)then
     return
  endif
  dat_buf=0.0
  il=1
  dat_buf(il)=real(MKAEP)
  il=il+1
  dat_buf(il)=real(MTAEP)
  il=il+1
  dat_buf(il)=real(MdEAEP)
  il=il+1
  dat_buf(il)=real(MdpAEP)
  il=il+1
  dat_buf(il)=real(MEAEP)
  il=il+1
  dat_buf(il)=real(MpAEP)
  il=il+1
  dat_buf(il)=real(MmuAEP)
  il=il+1
  dat_buf(il)=real(npack)
  il=il+1
  dat_buf(il:il+MKAEP-1)=real(AEPSP(1:MKAEP))
  il=il+MKAEP
  dat_buf(il:il+MTAEP-1)=real(tmpT(1:MTAEP))
  il=il+MTAEP
  do ik=1,MKAEP
     dat_buf(il:il+MTAEP-1)=real(DATA_tmpA(1:MTAEP,ik))
     il=il+MTAEP
  enddo
  dat_buf(il:il+MKAEP-1)=real(tmpTstep(1:MKAEP))
  il=il+MKAEP
  do ik=1,3
     dat_buf(il:il+MKAEP-1)=real(tmpDE(1:MKAEP,ik))
     il=il+MKAEP
  enddo
  do ik=1,3
     dat_buf(il:il+MKAEP-1)=real(tmpDP(1:MKAEP,ik))
     il=il+MKAEP
  enddo
  do ik=1,3
     dat_buf(il:il+MKAEP-1)=real(tmpE(1:MKAEP,ik))
     il=il+MKAEP
  enddo
  do ik=1,3
     dat_buf(il:il+MKAEP-1)=real(tmpP(1:MKAEP,ik))
     il=il+MKAEP
  enddo
  do ik=1,3
     dat_buf(il:il+MKAEP-1)=real(tmpMU(1:MKAEP,ik))
     il=il+MKAEP
  enddo
  dat_buf(il:il+npack-1)=real(idiff_map(1:npack))
  il=il+npack
  dat_buf(il:il+npack-1)=real(DATA_tmpP(1:npack))
  il=il+npack
  if(allocated(tmpT)) then
     deallocate(tmpT,idiff_map,DATA_tmpP,DATA_tmpA,tmpDE,tmpDP,tmpE,tmpP,tmpMU)
  endif
  return
end SUBROUTINE UFCDFRD_AEP_DATA

!******************** END FILE UFCDFRD_AEP.F90 ; GROUP UFILES ******************

C******************** START FILE XINTZB.FOR ; GROUP IXCALC ******************
C-------------------------------------------------------------
C  XINTZB
C
C  INTERPOLATE ZONE-CENTERED VARIABLE TO ZONE BOUNDARY VALUES
C
C  ONE SLIGHT EXTRAPOLATION AT OUTER EDGE
C
      SUBROUTINE XINTZB(FZC,FZB,N)
C
      REAL FZC(N),FZB(N)
C
      INM1=N-1
      DO 10 I=1,INM1
         IP1=I+1
         FZB(I)=0.5*(FZC(I)+FZC(IP1))
 10   CONTINUE
 
C       Linear EXTRAPOLATION AT EDGE
      FZB(N)=FZC(N)+0.5*(FZC(N)-FZC(INM1))
C
      RETURN
      END
C******************** END FILE XINTZB.FOR ; GROUP IXCALC ******************

C******************** START FILE UFSCAV.FOR ; GROUP UFILS0 ******************
C---------------------------------------------------------------
C  UFSCAV
C  AVERAGE TOGETHER TWO SCALAR LISTS
C  LIST1 CONTAINS CUMMULATIVE AVG OF SCALARS FROM NSHOTS SHOTS
C   ACCUMULATED "AVERAGING WEIGHT" ZWGHT1
C  LIST2 CONTAINS SCALARS FROM A NEW SHOT TO BE AVERAGED IN
C   INCREMENTAL NEW WEIGHT ZWGHT2
C  ANY SCALAR QUANTITY OCCURRING IN LIST2 BUT NOT IN LIST1 IS
C  INSERTED IN LIST1
C  IF THERE ARE SCALAR QUANTITIES IN LIST1 BUT NOT IN LIST2
C  THOSE QUANTITIES ARE NOT AFFECTED
C
C--------------------------------------------
C  MOD DMC - WEIGHTING SCHEME GENERALIZED
C   CALLING ARGUMENTS CHANGED 16 JULY 1982
C   FIND ARGUMENTS ZWGHT1,ZWGHT2
C    IN PLACE OF OLD ARGUMENT NSHOTS
C--------------------------------------------
C
      SUBROUTINE UFSCAV(ZLIS1,ZVAL1,IORD1,NL1,
     >     ZLIS2,ZVAL2,IORD2,NL2,ZWGHT1,ZWGHT2,NDIM)
C
      USE UFILES
C
      CHARACTER*30 ZLIS1(NDIM),ZLIS2(NDIM)
      REAL ZVAL1(NDIM),ZVAL2(NDIM)
      INTEGER IORD1(NDIM),IORD2(NDIM)
C
C  CALCULATE ORDER ON EACH LIST
C
      IF(NL2.EQ.0) RETURN
      IF(NL1.GT.0) THEN
        CALL UFSCOR(NL1,ZLIS1,IORD1)
        CALL UFSCOR(NL2,ZLIS2,IORD2)
      ELSE
        DO 40 I=1,NL2
C  IF NO PRIOR AVG DATA DON'T CHANGE ORDER OF INPUT DATA
        IORD2(I)=I
 40     CONTINUE
      ENDIF
C
C  SCAN THRU LIST 2.  CHECK FOR OCCURANCE OF EACH KEY IN LIST 2 IN
C  LIST 1.  IF THE KEY OCCURS AVG THE TWO CORRESPONDING VALUES
C  WEIGHTING BY NSHOTS.  IF THE KEY DOES NOT OCCUR IN LIST 1 ADD THE
C  KEY AND VALUE TO LIST 1.
C
      DO 100 ISC2=1,NL2
        IP2=IORD2(ISC2)
        IF(NL1.EQ.0) GO TO 80
        ILOC1=IUFSLO(ZLIS2(IP2),NL1,ZLIS1,IORD1,IEQ)
        IP1=IORD1(ILOC1)
        IF(IEQ.NE.1) GO TO 80
C  ELEMENT FOUND
        ZW1=ZWGHT1/(ZWGHT1+ZWGHT2)
        ZW2=1.0-ZW1
        ZVAL1(IP1)=ZW1*ZVAL1(IP1)+ZW2*ZVAL2(IP2)
        GO TO 100
C  ELEMENT NOT FOUND:  ADD IT TO THE LIST
 80     CONTINUE
        IL1=NL1
        NL1=NL1+1
        IF(NL1.GT.NDIM) GO TO 9000
        ZVAL1(NL1)=ZVAL2(IP2)
        ZLIS1(NL1)=ZLIS2(IP2)
        IF(NL1.EQ.1) IORD1(NL1)=NL1
        IF(NL1.GT.1) CALL UFSCIN(ILOC1,IL1,NDIM,IORD1)
 100  CONTINUE
      RETURN
C  ERROR-- NOT ENOUGH ARRAY SPACE
 9000 CONTINUE
      WRITE(UFELUN,9001) NDIM
 9001 FORMAT(' % UFSCAV WARNING-- RAN OUT OF ARRAY SPACE TRYING'/
     >'   TO ADD ELEMENT "',A10,'" TO AVERAGED DATA SCALAR LIST'/
     >'   ARRAY DIMENSION NDIM= ',I3,' NOT ADEQUATE; SCALAR DATA LOST'/
     >'   HIT CARRIAGE RETURN--')
      CALL UFPAUS(1)
      NL1=NL1-1
      RETURN
      END
C******************** END FILE UFSCAV.FOR ; GROUP UFILS0 ******************

!--------------------------------------------------------------
!
!  UFILES MODULE
!
!  J. Breslau   18 Feb 2021 -- converted from common blocks to module
!  D. McCune    21 Jun 1999 -- removed declaration of byte arrays
!                              (portability issue)
!  C. Ludescher 13 Aug 1997 -- Added ufid(ufpach) for netCDF file id
!  T. Terpstra  20 Aug 1993 -- Changed Uextnd from C*3 to C*16
!  D. MC CUNE   19 NOV 1981
!  M. THOMPSON, 28 MAR 1984
!
! MODIF DMC MAR 1985 - EXPANDING FILENAME ELEMENTS
!  STORING NONBLANK LENGTH OF EACH NAME ELEMENT
!  SUPPORTING FILENAME FORMS WHICH DO NOT INCL. A SHOT NUMBER
!
!  COMMON BLOCKS FOR ASCII DATA FILE SYSTEM
!  PARAMETERS:  UFPACH-- MAX NO. OF LUN "CHANNELS"
!   =MAX NO. OF CALLS TO UFSETR WITH DISTINCT LUNS.
!               UFPASC-- NUMBER OF SCALARS TO READ, UF1DRE, UF2DRE
!
!  MOD DMC - ADDED VARIABLE UFILES COMPRESSED RECORD SIZE UFRSIZ
!   ADDED PARAMETER UFMAXR = MAX COMPRESSED RECORD SIZE
!   6/86
MODULE ufiles
  IMPLICIT NONE
  SAVE
!
  INTEGER, PARAMETER :: UFMAXR=8192  ! MAX COMPRESSED UFILE RECORD SIZE
  INTEGER, PARAMETER :: UFPACH=64    ! max no. of UFILE channels
  INTEGER, PARAMETER :: UFPASC=300   ! max no. of scalars for UFnDRE...
  INTEGER, PARAMETER :: UFBBUF=512   ! byte stream i/o buffer size
  INTEGER, PARAMETER :: UFCBUF=2048  ! char buffer size
!
  CHARACTER*16 UPRFIX(UFPACH)
  CHARACTER*16 UEXTND(UFPACH)
  CHARACTER*16 UDEV(UFPACH),UDDEV
  CHARACTER*128 UFDIR(UFPACH)
  CHARACTER*60 UJUNKA

!
!  dmc 15 Dec 1998 -- MDS+ data access option
!
  character*50 mds_server(ufpach)  !mds+ server
  character*20 mds_tree(ufpach)    !mds+ tree name
  character*120 mds_path(ufpach)   !mds+ path name
  character*20 mds_node(ufpach)    !mds+ node name
  integer      mds_socket(ufpach)  !mds+ server socket
  integer      mds_shot(ufpach)    !mds+ pulse number

!
  LOGICAL LUFSET(UFPACH),LSHOTN(UFPACH),LFCLUN
  INTEGER, DIMENSION(UFPACH) :: UFLUN,UFSTAT,UFSHOT,UFCPRS,LFDIR,LDEV,  &
                                LPRFIX,LEXTND,ufid
  INTEGER LUFCAP,UFCHAN,UFELUN,UFCLUN,UFILEV,LDDEV,UFRSIZ
  REAL UFCTOL(UFPACH)

!
!  new stuff added dmc 18 Mar 1996 -- support new compressed binary
!  format, loss-free compression & binary portability.
!
  integer niobuf(ufpach)      ! i/o buffer count
  integer nchbuf(ufpach)      ! char buffer count
!
  real ufieee(ufmaxr)         ! IEEE floating pt buffer
  integer*2 uffhi(ufmaxr)     ! IEEE fp compression buffer
  integer*2 ufflo(ufmaxr)     ! IEEE fp compression buffer
  integer ufpack(ufmaxr)      ! generic compression buffer
!
!  LUFSET(ICHAN)=.TRUE. ONLY IF CHANNEL HAS BEEN INITIALIZED
!   (SEE SUBROUTINE UFSETR, UFILES.FOR)
!  UPRFIX,UEXTND,UFDIR, AND UDEV ARE FILENAME PARTS, DEVICES
!   AND FILE DIRECTORY FOR EACH CHANNEL
!  UDDEV-- DEFAULT DEVICE (DISK) FOR FILES - SEE BLOCK DATA
!  UFLUN(ICHAN)= LOGICAL UNIT NUMBER ASSOCIATED WITH CHANNEL ICHAN
!  UFSTAT(ICHAN)= CHANNEL STATUS:
!   0-- CHANNEL CLOSED
!   1-- CHANNEL (FILE) OPEN FOR WRITE, NO DATA WRITTEN
!   2-- CHANNEL (FILE) OPEN FOR WRITE,DATA HAS BEEN WRITTEN
!   3-- CHANNEL (FILE) OPEN FOR READ ONLY
!   4-- open as temporary ascii file for comment spooling
!   5-- CHANNEL (FILE) OPEN FOR READ, DATA HAS BEEN READ.
!  UFCPRS-- COMPRESSION FLAG: 0=NO COMPRESSION,
!   1= LSL COMPRESSION OF INTERGIZED DATA
!  UFCTOL-- USED IF COMPRESSION FLAG IS SET.  ISSUE WARNING IF REAL
!   TO INTEGER CONVERSION RESULTS IN RELATIVE ERROR EXCEEDING UFCTOL
!   DUE TO LINEAR RANGE DIGITIZATION OF FLOATING POINT NUMBER.
!   IMBED WARNING IN COMMENTS OF OUTPUT FILE
!  UFCHAN-- # OF CHANNELS AVAILABLE-- SEE BLOCK DATA IN UFILES.FOR
!
!  UFELUN-- CHANNEL FOR ERROR MESSAGE OUTPUT
!  UFCLUN-- CHANNEL FOR INTERNALLY GENERATED COMMENTS TO SPOOL TO
!   END OF UFILES OUTPUT FILE
!  LFCLUN-- FLAG INDICATING PRESENCE OF INTERNALLY GENERATED COMMENTS.
!-----------
!  MAR 1985
!  LPRFIX - CHARACTER LENGTH OF FILENAME PREFIX
!  LEXTND - CHARACTER LENGTH OF FILENAME .EXT EXTENSION
!  LFDIR - CHARACTER LENGTH OF FILENAME DIRECTORY SPECIFICATION
!  LDEV - CHARACTER LENGTH OF FILE DEVICE SPECIFICATION
!  LDDEV - DITTO FOR DEFAULT DEVICE
!
!  LSHOTN - .TRUE. TO ENCODE SHOT NO. IN FILENAME
!  LUFCAP - =1 for capitalized filename NAME#####.EXT (default)
!           =0 for lower case name#####.ext.  Unix option.
!           =2 for fully user specified capitalization in name & ext
!
!----------------------------------------------------------------
END MODULE ufiles

C******************** START FILE UTTECH.FOR ; GROUP UREAD5 ******************
C------------------------------------
C&  UTTECH ECHO PARAMETER/CONDITIONAL STRING SUBSTITUTION (ECHO MODE)
C
C  ECHO SUBSTITUTION OF NEW LINE FROM PARAMETER OR CONDITIONAL LINE
C  - ECHO MODE ONLY
C
      SUBROUTINE UTTECH
      USE USERIO
C
      IF(.NOT.NLECHO) RETURN
      WRITE(LUNTRM,5001) CBUFF(1:NCHARC)
 5001 FORMAT(' % LINE SUBSTITUTION PERFORMED:'/1X,A)
      RETURN
      END
C******************** END FILE UTTECH.FOR ; GROUP UREAD5 ******************

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SVTHE_Z(TEMP)
!	3/8/77
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod, only :A,B,CON,EPS,ITER,IW
  IMPLICIT NONE
  INTEGER j
!============
! idecl:  explicitize implicit REAL declarations:
 real(fp) temp,emin,emax,fsvth_z,ans
 EXTERNAL FSVTH_Z
!	THIS FUNCTION WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
!	PLASMA PHYSICS LAB.  THIS ROUTINE WILL INTEGRATE FUNCTION
!	FSVTH AND CALCULATE <SIGMA*V> FOR THERMAL REACTIONS.  NOTE
!	THAT THIS ROUTINE ASSUMES THAT FUNCTION SVTH WAS PREVIOUSLY
!	CALLED IN ORDER TO INITIALIZE PARAMETERS.
!	PARAMETERS:
!	TEMP - THE TEMPERATRUE AT WHICH YOU WANT <SIGMA*V>.  (KEV)
!	PARAMETER LIST FOR COMMON BLOCK CSVTH.
!	A - =RMASS/TMASS.  (SEE SVTH)
!	B - = A/TEMP
!	CON1 - =CON*A**1.5/SQRT(TMASS).  (SEE SVTH)
!	EPS - THE DESIRED RELATIVE ERROR IN THE REACTIVITY
!	ITER - THE MAXIMUM NUMBER OF ITERATIONS TO BE TAKEN IN ORDER
!	IW - THE LOGICAL UNIT USED FOR PRINTING.
 SVTHE_Z=0.0_fp
 IF(TEMP.LT.0.1_fp) return
!	I NOW CALCULATE B.
 B=A/TEMP
 EMIN=0.0_fp
 EMAX=180.0_fp/B
!	I NOW INTEGRATE FSVTH IN ORDER TO FIND <SIGMA*V>.
 CALL GAUS32_Z(EMIN,EMAX,FSVTH_Z,ANS,EPS,ITER,J,IW)
!  J is output from gaus32_z
!	I NOW COMPUTE <SIGMA*V> (M**3/SEC).
 SVTHE_Z=CON*ANS/TEMP**1.5_fp
 RETURN
END FUNCTION SVTHE_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C******************** START FILE URDEOF.FOR ; GROUP UREAD5 ******************
C------------------------------------------------------
C&  URDEOF-- PROCESS END-OF-FILE ON UREAD INDIRECT INPUT FILE
C
      SUBROUTINE URDEOF(IEOFL)
      USE USERIO
C
C  FORMERLY PART OF UREAD SUBROUTINE
C
C  END OF UREAD INDIRECT INPUT OR OUTPUT FILE --
C  IF E-O-F DURING MARKER SEARCH, ALLOW ONE REWIND TO SEARCH TOP
C  HALF OF FILE
C
      IF(NLSKIP.AND.(LMARKN.GT.0)) THEN
C
        ieofl=ieofl+1
        if(ieofl.gt.2) THEN
C  END-OF-FILE WITHOUT FINDING MARKER; PRINT WARNING
          WRITE(LUNTRM,9310) URMARK(1:LMARKN)
 9310 FORMAT(' % END OF FILE WITHOUT FINDING "SKIPTO" MARKER:  ',A)
          LMARKN=0
          NLSKIP=.FALSE.
          GO TO 600
        ENDIF
C
c  try closing file and reopening, reading from the top,
c  before giving up.
C  REWIND FIRST THE BUFFER THEN THE WHOLE FILE
C
        if(ieofl.eq.1) call ufiget(urfile,4,ier,ieof)
        if(ieofl.eq.2) call ufiget(urfile,5,ier,ieof)
        RETURN
      ENDIF
C
 600  CONTINUE
C  CLOSE I/O FILE
      JLEV=MAX0(NLUNIN,NLUNIO)
      JLM1=JLEV-1
      IF(JLEV.EQ.NLUNIN) THEN
C  CLOSING AN INPUT FILE
        IF(NLECHO.OR.((IBATCH.EQ.0).AND.(JLM1.EQ.1)))
     >      WRITE(LUNTRM,7001) XFILE(NLUNIN)
 7001 FORMAT(' % END OF INPUT FILE:  ',A)
        call ufiget(urfile,3,ier,ieof)
        NLUNIN=NLUNIN-1
        IF(NLUNIN.EQ.MAX0(1,NLUNIO)) THEN
C  RETURN CONTROL TO SYS$INPUT
          NLUNIN=1
          NLINDI=.FALSE.
          NLSKIP=.FALSE.
        ENDIF
      ELSE
C  CLOSING AN OUTPUT FILE
        CLOSE(UNIT=LUNTIN(NLUNIO))
        ILFILN=INDEX(XFILE(NLUNIO),' ')
        IF(ILFILN.LE.0) ILFILN=LFILN
        WRITE(LUNTRM,7004) XFILE(NLUNIO)(1:ILFILN)
 7004 FORMAT(' % OUTPUT FILE "',A,'" CLOSED')
        IF(JLM1.EQ.1) WRITE(LUNTRM,7003)
 7003 FORMAT(' % NO MORE OUTPUT FILES OPEN')
        NLUNIO=NLUNIO-1
        IF(NLUNIO.EQ.1) THEN
C  NO MORE OUTPUT FILES
          NLUNIO=0
          LUNIDO=0
          NLINDO=.FALSE.
        ELSE
          LUNIDO=LUNTIN(NLUNIO)
        ENDIF
      ENDIF
C  DELETE LOCAL PARMS
      IF(NPLC(JLEV).EQ.0) GO TO 607
      DO 603 I=1,NPLC(JLEV)
          PLCNAM(I,JLEV)='                '
          PLCVAL(I,JLEV)=
     >         '                                                '
 603  CONTINUE
      NPLC(JLEV)=0
 607  CONTINUE
C
C  POP TYPEAHEAD BUFFER STACK
      CBUFF=AHDBUF(JLM1)
      CALL UDECOD
      IF(NCHARC.EQ.0) THEN
C  NO SAVED TYPEAHEAD...
        IF(.NOT.NLINDI) THEN
CXX	    CALL UPROMR
          CALL CHXOUT
        ENDIF
C  RECORD PROMPT IN OUTPUT FILE IF THERE IS ONE
        CALL UREADY(0)
        CALL UPROMX
      ELSE
C  PROCESS SAVED TYPEAHEAD FROM PREVIOUS INPUT LEVEL...
        IF(NLECHO) WRITE(LUNTRM,7005) CBUFF(1:NCHARC)
 7005 FORMAT(' %PREVIOUS TYPEAHEAD RESTORED FROM STACK:'/1X,A)
        CALL UREADY(1)
      ENDIF
C  EXIT
      RETURN
      END
C******************** END FILE URDEOF.FOR ; GROUP UREAD5 ******************

c...................................................................
C	LOGICAL FUNCTION IN_ING_LIST
 
      logical function in_ing_list(word, token_list, ntokens, iptr)
 
 
C      PROGRAM DESCRIPTION:
C
C	THIS ROUTINE IS A GENERAL TEST OF THE QUESTION:
C	"DOES THE TOKEN <word> APPEAR AS ONE OF THE TOKENS
C	IN THE LIST <token_list> (MADE UP OF <ntokens> ITEMS) ?? "
C	>> IN_ING_LIST is true/false depending on whether it is there or not;
C	>> IPTR tells you where in the list it is.
C
C
C      AUTHORS:
C
C		R.M. WIELAND
C
C      CREATION DATE: 	PRE-1987
C
C
C                      C H A N G E   L O G
C
C      Date     | Name  | Description
C---------------+-------+-----------------------------------------------------
C     8-APR-1987 WIE     GO OVER TO CASE INSENSITIVE CHECKS
C
C    29-MAY-1992 DMC     use STR_CBC instead of STR$CASE_BLIND_COMPARE
C                        because the latter is not in the Unix RTL
C                        STR_CBC is in the TRANSP library VAXONLY
C
C
      integer the_same
        parameter               (THE_SAME=0)
 
      character*(*)		word
      character*(*)		token_list(*)
      integer			ntokens
      integer			iptr
 
C	FUNCTION DECLARATION
      integer	str_cbc
 
      if ( ntokens .eq. 0) go to 150
 
      do 100 k = 1, ntokens
      iptr = k
        IF (str_cbc(
     >            token_list(k)(1:len_trim(token_list(k))),
     >            word)
     >    .eq.THE_SAME) THEN
c..........found a match
         in_ing_list = .true.
         return
        END IF
100   continue
 
c..	fall thru; no match
150   in_ing_list = .false.
      iptr = 0
 
        return
      end
 
 

      subroutine ryeval(r0spl,rmspl,ymspl,zsnthtk,zcsthtk,nmom,
     >                   zr99,zy99)
c
c  evaluate moments position:  symmetric eq. moments formula
c
      real r0spl,rmspl(nmom),ymspl(nmom)
      real zcsthtk(nmom),zsnthtk(nmom)
c
c--------------------------------
c
      ZR99=R0SPL
      ZY99 = 0.
      DO 50 IMUL=1,NMOM
         ZR99=ZR99+RMSPL(IMUL)*ZCSTHTK(IMUL)
         ZY99=ZY99+YMSPL(IMUL)*ZSNTHTK(IMUL)
 50   CONTINUE
c
      return
      end

C******************** START FILE CONDOM.FOR ; GROUP CONCTR ******************
C===============================
C  CONDOM   SELECT INDEX-DOMAIN FOR CONTOUR PLOT
C           D. MC CUNE  21 MAY 80
C  X(NX)    ARRAY OF X VALUES
C  Y(NY)     ARRAY OF Y VALUES
C    (X,Y ARE INDEP VARS WITH RESPECT TO WHICH A 2D FCN Z IS
C     DEFINED)
C    (X,Y ARE INPUT)
C
C  IMIN,IMAX:  OUTPUT, INDICES S.T. X(IMIN-1)<XMIN<=X(IMIN)
C  JMIN,JMAX:  SAME THING FOR Y
C
C  XMIN,XMAX,YMIN,YMAX ARE PASSED THROUGH COMMON
C
C  XMIN,XMAX,YMIN,YMAX ARE RESET TO X(IMIN),X(IMAX),Y(JMIN),
C    Y(JMAX) AT END
C
C  AN ATTEMPT IS MADE TO PATCH FOR 'PATHOLOGICAL' XMIN,XMAX,
C   YMIN,YMAX
C
C
      SUBROUTINE CONDOM(X,NX,Y,NY,IMIN,IMAX,JMIN,JMAX)
C
      DIMENSION X(NX),Y(NY)
C
      INCLUDE 'PLOT1MMX'
C
C-------------------
C
C  X AXIS
      CALL CONDM0(X,NX,IMIN,IMAX,XMIN,XMAX)
C  Y AXIS
      CALL CONDM0(Y,NY,JMIN,JMAX,YMIN,YMAX)
C
      RETURN
      	END
C******************** END FILE CONDOM.FOR ; GROUP CONCTR ******************

c	TIC -- John Coonrod's version of the CICADA TIC routines	!01/15/85
C
c	This package provides three levels of TIC routines:
c	1. Normal	at_xxxx
c	2. Backspace	at_bxxxx
c	3. Limit-check	at_lxxxx
c	4. Limit/Back	at_blxxxx
C
	subroutine at_int(prompt,ival)		!integer value		!11/09/84
	implicit none
	character prompt*(*),string*12,back*(*)
	character istrin*12
	logical needb,lims
	integer ival, ihi, ilo, ios, i

	needb=.false.
	lims=.false.
	go to 100
c
	entry at_bint(prompt,ival,back)
	needb=.true.
	lims=.false.
	back=' '
	go to 100
c
	entry at_lint(prompt,ival,ilo,ihi)
	needb=.false.
	lims=.true.
	go to 100
c
	entry at_blint(prompt,ival,ilo,ihi,back)
	needb=.true.
	lims=.true.
	back=' '
 100	continue
	call jc__cint(ival,istrin)	!Convert integer to string
	ios=1
	do while(ios.ne.0)		!Repeat until a good value appears
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  read(string,'(bn,i12)',iostat=ios) i
	  if(ios.ne.0) then
	    call at__error(string,'Integer')
	  elseif(lims) then
	    if(i.lt.ilo .or. i.gt.ihi) then
	      write(*,*)'Sorry, integer out of range',ilo,ihi
	      ios=-1
	    endif
	  endif
	enddo
	ival=i
	end
	subroutine at_hex(prompt,ival)		!hex value		!11/09/84
	implicit none
	character prompt*(*),string*8,back*(*)
	character istrin*8
	logical needb,lims
	integer ival, ihi, ilo, ios, i
	real val
	needb=.false.
	lims=.false.
	go to 100
c
	entry at_bhex(prompt,ival,back)
	needb=.true.
	lims=.false.
	back=' '
	go to 100
c
	entry at_lhex(prompt,ival,ilo,ihi)
	needb=.false.
	lims=.true.
 100	continue
	write(istrin,'(z8)')ival	!Convert to hex
	ios=1
	do while(ios.ne.0)
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  read(string,'(bn,z8)',iostat=ios) i
	  if(ios.ne.0) then
	    call at__error(string,'Hex')
	  elseif(lims) then
	    if(i.lt.ilo .or. i.gt.ihi) then
	      write(*,*)'Sorry, hex value out of range',ilo,ihi
	      ios=-1
	    endif
	  endif
	enddo
	ival=i
	end
	subroutine at_real(prompt,val)		!real value		!11/09/84
	implicit none
	real val
	character prompt*(*),string*20,back*(*),sval*(*)
	character istrin*20
	logical needb,lims,spchk
	external setr,chkr
	real rhi, rlo, y
	integer ios

	needb=.false.
	lims=.false.
	spchk=.false.
	go to 100
c
	entry at_breal(prompt,val,back)
	needb=.true.
	lims=.false.
	back=' '
	spchk=.false.
	go to 100
c
	entry at_lreal(prompt,val,rlo,rhi)
	needb=.false.
	lims=.true.
	spchk=.false.
	go to 100
c
	entry at_blreal(prompt,val,rlo,rhi,back)
	needb=.true.
	lims=.true.
	back=' '
	spchk=.false.
	go to 100
c
	entry at_sreal(prompt,val,setr,chkr,sval)
	needb=.false.
	lims=.false.
	spchk=.true.
c
 100	continue
	istrin=' '
	if(spchk) then
	  call setr(istrin,val,sval)
	endif
	if(istrin.eq.' ') then
	  call jc__creal(val,istrin)	!convert real to short string
	endif
	ios=1
	do while(ios.ne.0)
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  if(spchk) then
	    call chkr(string,y,sval)
	  endif
	  if(ios.ne.0) then
	    read(string,'(bn,e20.0)',iostat=ios) y
	    if(ios.ne.0) then
	      call at__error(string,'Real')
	    elseif(lims) then
	      if(y.lt.rlo*.9999999 .or. y.gt.rhi) then
		write(*,*)'Sorry, real out of range',rlo,rhi
		ios=-1
	      endif
	    endif
	  endif
	enddo
	val=y
	end
	subroutine at_dbl(prompt,dval)		!doubl precision	!11/09/84
	implicit none
	character prompt*(*),string*30,back*(*)
	character istrin*30
	real*8 dval,y,dlo,dhi
	logical needb,lims
	integer ios
	needb=.false.
	lims=.false.
	go to 100
c
	entry at_bdbl(prompt,dval,back)
	needb=.true.
	lims=.false.
	back=' '
	go to 100
c
	entry at_ldbl(prompt,dval,dlo,dhi)
	needb=.false.
	lims=.true.
 100	continue
	ios=1
c	write(istrin,'(D)') dval
	write(istrin,'(bn,d30.0)') dval
	do while(ios.ne.0)
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  read(string,'(bn,d30.0)',iostat=ios) y
	  if(ios.ne.0) then
	    call at__error(string,'Double Precision')
	    elseif(lims) then
	      if(y.lt.dlo .or. y.gt.dhi) then
		write(*,*)'Sorry, real*8 out of range',dlo,dhi
		ios=-1
	      endif
	    endif
	enddo
	dval=y
	end
	subroutine at_log(prompt,val)		!logical value 		!02/13/85
	implicit none
	character prompt*(*),string*1,back*(*)
	character istrin*1
	logical val,needb
	integer ios, nlist, i

	needb=.false.
	go to 100
c
	entry at_blog(prompt,val,back)
	needb=.true.
	back=' '
 100	continue
	ios=1
	istrin='N'
	if(val) istrin='Y'
	do while(ios.ne.0)
	  string=istrin
	  if(needb) then
	    call at_bchar(prompt,string,back)
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)
	  endif
	  if(index('TY1FN0',string).ne.0) then
	val=.false.
	    if(index('TY1',string).ne.0) val=.true.
	    ios=0
	  else
	    call at__error(string,'Logical')
	  endif
	enddo
	end
	subroutine at_bchar(prompt,ans,back)	!string			!11/09/84
	implicit none
	character*(*) prompt,ans,back	!Given the prompt, input the answer
	include 'jcticcom'
cx	character tans*2	!in case ans is length 1
	integer nlist, i, nc, jc_trim, j, ierr
	back=' '
	if(lmenu) then
	  call at_char('<M>'//prompt,ans)
	elseif(lhelp) then
	  call at_char('<H>'//prompt,ans)
	else
	  call at_char(prompt,ans)
	endif
	if(ans.eq.'?') then
	  back='H'
	  ans='0'
	elseif(ans(1:1).eq.'/' .and. index('BH',ans(2:2)).ne.0) then
	  back=ans(2:2)
	  ans='0'
	endif
	end
	subroutine at_lchar(prompt,ans,clist,nlist) !legal string	!11/09/84
	implicit none
	integer nlist
	character*(*) prompt,ans,clist(nlist),back
	character string*72
	logical nomatch,needb
	integer i, jc_trim, j, ierr, nc

	needb=.false.
	go to 100
c
	entry at_blchar(prompt,ans,clist,nlist,back)
	needb=.true.
	back=' '
100	continue
	nomatch=.true.
	do while(nomatch)
	  string=ans	!copy ans to temporary
	  if(needb) then
	    call at_bchar(prompt,string,back)	!string
	    if(back.ne.' ') return
	  else
	    call at_char(prompt,string)		!string
	  endif
	  i=0
	  do while(i.lt.nlist .and. nomatch)
	    i=i+1
	    nc=jc_trim(clist(i))
	    if(index(clist(i),'*').ne.0) then
	      nomatch=.false.
	      j=0
	      do while (j.lt.nc .and. .not.nomatch)
		j=j+1
		if(string(j:j).ne.clist(i)(j:j) .and. clist(i)(j:j).ne.'*')
     >		  nomatch=.true.
	      enddo
	    else
	      nomatch=string(1:nc).ne.clist(i)(1:nc)
	    endif
	  enddo
	  if(nomatch) then
	    write(*,*)'The legal input strings are:'
	    write(*,*)(clist(i),' ',i=1,nlist)	!//
	  else
	    ans=string
	  endif
	enddo
	end
	subroutine at_error(ierr,string)	!user called error msg	!06/20/88
	implicit none
	integer ierr
	character string*(*),istrin*12
	integer nc, jc_trim

	call jc__cint(ierr,istrin)
	nc=jc_trim(string)
	call at_msg(string(1:nc)//': '//istrin)
	end

	subroutine at_msg(string)		!output text string	!02/08/85
	implicit none
	character*(*) string,istrin*12
	integer nrem, nc, jc_trim, ival
	real rhi, rlo

	go to 100
	entry at_msgf(string)
	call at_stkln(nrem)
	if(nrem.ne.0) return
 100	continue
	nc=jc_trim(string)
	write(*,*)string(1:nc)
	return
	entry at_msgi(string,ival)	!text followed by intgr	!01/08/90
	call jc__cint(ival,istrin)
	nc=jc_trim(string)
	write(*,*)string(1:nc),' ',istrin	!//
	end
	subroutine at_rlimits(prompt,rlo,rhi)			!03/26/85
	implicit none
	real rlo, rhi
	character*(*) prompt
	call at_real(prompt//', low limit',rlo)
	call at_real(prompt//', high limit',rhi)
	end
	subroutine at_ucmmd(opt,ierr)
	implicit none
	integer ierr
	character opt*(*),op*1,opx*4
	integer ngot
	real opt1

	op=opt(2:2)
	if(op.eq.'N') op=opt(3:3)
	if(index('CE',op).gt.0) then	!allow /E,/NE,/C,/NC
	  call at_switch(opx,opt1,ngot)
	endif
cx	/T  = always output prompt (for batch jobs)
cx	/NT = no typeahead prompt
	end
	subroutine at_pause
	implicit none
	include 'jcticcom'
	character cdum*1
	logical lsave
	if(level.eq.1) then
	  lsave=lcrok
	  lcrok=.true.			!allow CR
	  call at_char('Hit <CR> to continue',cdum)
	  lcrok=lsave
	endif
	end
	subroutine at__error(string,kind)	!Internal error routine	!04/03/85
	implicit none
	character*(*) string,kind
	integer jc_trim
	call at_reset
	write(*,*)'Sorry, ',string(1:jc_trim(string)),' is not a valid ',
     >		kind,' input.'
	end

      subroutine ufmds_lbl(ichan,arg,lbl,kdep,default,ier)
C
C  get label information from MDS+ node, in so far as possible
C
C---------------------------------
C History:
C 11/18/99 CAL: new calling arguments for mds_value
C
C------------------------------
      use UFILES
      implicit none
 
      integer ichan             ! Ufiles channel id
      character*(*) arg         ! node pathname or expression (input)
      character*(*) lbl         ! 20/10 char Ufile style label/units (output)
      integer kdep              ! independent var. flag (input)
      character*(*) default     ! default label (input) (use if nothing better)
      integer       ier
C
      character*128 zerrmsg
C
      character*40 zunits
C
      integer      mds_value
      integer      idescr_cstring, iretl, iretl_zunits
      integer      ilen,  ilenp, ilent, ilend, ila,   ilz, istat
      integer      ilm,   ifind, ifinp, ifint, istt, istp, istd
      integer      isum2, isum3
      logical      tr_run
C
C  if kdep=1, label is for function itself;
C  if kdep=0, label os for an independent coordinate.
C
C-----------------------------------
C
      ier=0
      lbl=' '
      ilen=len(lbl)
      if(ilen.lt.30) then
         write(ufelun,9503) ilen
 9503    format(' ?UFMDS_LBL:  programming error, len(lbl).lt.30:',i4)
         ier=1
         return
      endif
C
      ila=max(1,len_trim(arg))
      istat=mds_value('units('//arg(1:ila)//')',
     >      idescr_cstring(zunits),iretl_zunits)
      if(istat.ne.1) then
         call ufmds_err('UFMDS_LBL',istat,ier,zerrmsg,ilm)
         write(ufelun,9504) arg(1:ila),zerrmsg(1:ilm)
 9504    format('  seeking units of MDS+ signal: ',a/2x,a)
         if(ier.eq.1) go to 9000
      endif
C
C  figuring out the labeling well ... is going to be hairy.
C
      if (mds_tree(ichan)(1:6).eq.'TRANSP' .or.
     >   mds_tree(ichan)(1:3).eq.'JET' .or.
     >   mds_tree(ichan)(1:5).eq.'BEAST') then
         tr_run = .true.
      else
         tr_run = .false.
      endif
      if((kdep.eq.1).and.
     >    (tr_run .or. mds_tree(ichan)(1:3) .eq. 'TRW')) then
         istat=mds_value(arg(1:ila)//':LABEL',
     >      idescr_cstring(lbl),iretl)
         lbl(21:) = zunits(1:iretl_zunits)
      else if((kdep.eq.0).and.((zunits.eq.'s').or.(zunits.eq.'S')
     >     .or.(zunits(1:3).eq.'sec').or.(zunits(1:3).eq.'SEC')
     >     .or.(zunits(1:3).eq.'Sec'))) then
         lbl = 'time                seconds   '
      else if((kdep.eq.0).and.(zunits.eq.'r/a')) then
         lbl = 'x                   r/a       '
      else
         ilz=max(1,len_trim(zunits))
         if(ilz.le.10) then
            call ufmds_lword(default,ilend,istd,ifind)
            if(kdep.eq.1) then
               call ufmds_lword(mds_tree(ichan),ilent,istt,ifint)
               call ufmds_lword(mds_path(ichan),ilenp,istp,ifinp)
            else
               ilent=1000
               ilenp=1000
            endif
C
            isum3=ilent+ilenp+ilend
            isum2=ilent+ilend
            if(isum3.le.16) then
               lbl=mds_tree(ichan)(istt:ifint)//'...'//
     >              mds_path(ichan)(istp:ifinp)//':'//
     >              default(istd:ifind)
            else if(isum3.le.18) then
               lbl=mds_tree(ichan)(istt:ifint)//'>'//
     >              mds_path(ichan)(istp:ifinp)//':'//
     >              default(istd:ifind)
            else if(isum2.le.17) then
               lbl=mds_tree(ichan)(istt:ifint)//'...'//
     >              default(istd:ifind)
            else if(isum2.le.19) then
               lbl=mds_tree(ichan)(istt:ifint)//'>'//
     >              default(istd:ifind)
            else
               lbl=default(istd:ifind)
            endif
C
            lbl(21:30)=zunits
C
         else
            lbl=zunits
         endif
      endif
C
 9000 continue
      return
      end
C--------------------------------------
      subroutine ufmds_lword(dstr,ilen,ist,ifin)
C
C  find last "clause" in passed string
C
      character*(*) dstr
C
      ild=max(1,len_trim(dstr))
      ifin=ild
      if(dstr(ifin:ifin).eq.':') ifin=ifin-1
      if(dstr(ifin:ifin).eq.'.') ifin=ifin-1
C
      ilimd=1
      do id=ifin,ilimd,-1
         if(dstr(id:id).eq.'.') go to 10
         if(dstr(id:id).eq.':') go to 10
      enddo
      id=ilimd-1
 10   continue
      ist=id+1
C
      ilen=ifin-ist+1
C
      return
      end

!---------------------------------------------------------------------
! adas_mog.f90: by M.Gorelenkova                                      
!               created 07/2009                                       
!               based on Michael Kraus routines                       
!                                                                     
!  Module which computes reaction rate coefficient tables once and stores these as files;
!  once a table is computed, it is not recomputed, but simply read in
!  for interpolation.  
!  All energies & temperatures in KeV/amu
!  All rate coefficients <sigma*v> in m**3/sec.
!
! subroutine adas_btsigv -- calculates beam-target maxwellian average <sig*v> (Eb/Ab,Ti/Ai)
!                           for neutralizing CX and II reactions, available for H and He. 

!
! subroutine adas_adas_sigvte_ioniz  --  calculates ionization of neutrals by electron impact
!                                        rate coefficients <sigma*v> averaged over Maxwellian electron
!                                        distribution characterized by temperature Te (KeV),
!                                        available only for H. 
!
! subroutine adas_zstop_sigvz -- calculates sig*v tables of neutral stopping   
!                                on fully stripped light impurities (vs. Erel only); 
!                                as a sum of sig*v for ionization (includes non-neutralazing CX). 
!                                Data for H and He neutral atoms are available.
!
! subroutine adas_sigv -- calculates sig*v(Eb/Ab) for neutralizing charge-exchange reaction 
!                         and impact ionization which includes  non-neutralizing 
!                         charge-exchange reaction. Data for H and He neutral atoms are available.
!
! subroutine adas_sigv --  creates tables for  CX and ionization cross section sig(Eb/Ab). 
!                          Data for H and He neutral atoms are available. 
!
! subroutine adas_bms  -- computes beam stopping rate coefficient on impurities for H - beam.
!                         Routine uses  EQUIVALENT of  Electron Density [cm**-3]
!                         N_el*SUM(Z_imp^2* N_imp)/SUM(Z_imp * N_imp)/Z_imp, where
!                         N_el -- electron density and impurity density 
!                         N_imp -- impurity density 
!                         for details see [1],p.794
!
! All routines try to open pre-computed tables for an asking reaction in $ADASDIR/tables/...
! directory. If these tables had been created early then data will be read and interpolated, if
! not then table will be computed and wrote to the $ADASDIR/tables/... first.
!
! References:                                                         
!                                                                     
!    1. H. Anderson et al. (2000)                                     
!       "Neutral beam stopping and emission in fusion plasmas I"      
!       Plasma Physics and Controlled Fusion Vol. 42, pp 781-806      
!                                                                     
!    2. H. P. Summers (2004)                                          
!       "The ADAS User Manual v2.6"                                   
!       http://www.adas.ac.uk/manual.php                              
!                                                                     
!---------------------------------------------------------------------
Module adas_mod

  use iso_c_binding, only: fp => c_double
  use ezcdf
  implicit none
! 
  character*140  :: adas_tables_file            !file name for table
  character*9 :: cizneut, cizion                !character izneut and izion
  character*8 nctype                            !for ezcdf
  integer IDIMS(10)                             !for ezcdf
  real(fp), dimension(8) :: axis_param_warmTarget !axis parameters(E[KeV/amu],T[KeV/amu]) for table: 
                                                !min, max values, number of points,
                                                !specification 0 for LOG, 1 for LIN
!
  real(fp),SAVE,dimension(4) :: axis_param_coldTarget !axis parameters(E[KeV/amu]) for table: 
                                                !min, max values, number of points,
                                                !specification 0 for LOG, 1 for LIN
  integer,SAVE :: npts                               ! number of points for table
  real(fp),SAVE, dimension(:,:),allocatable :: sigv_table_prev ! tabulated sig*v  
  character*240, SAVE :: filename_prev(2)=(/'NONE','NONE'/)   ! filename from prev call
  integer, SAVE :: npts_prev(2)
  real(fp) :: xlr                                 ! If XLR>0, then the X grid is equally spaced on a logarithmic scale:
                                                ! LINEAR IF XLR .LE. 0.0
  integer :: fadas_CX, fadas_II                 !reaction type, convetrted to adas routine: 3,4  ='CX', 1,2 = 'II'
  integer :: iwarn_adas, fErr, icdf, ilen, iopen_file
!
  PUBLIC :: check_data_react
  PUBLIC :: adas_btsigv
  PUBLIC :: adas_sigvte_ioniz
  PUBLIC :: adas_zstop_sigvz
  PUBLIC :: adas_sigv
  PUBLIC :: adas_sig
  PUBLIC :: adas_bms
!
  interface adas_btsigv
     module procedure adas_btsigv_int_int,adas_btsigv_int_r8,adas_btsigv_r8_r8,adas_btsigv_r8_int
  end interface
!
  interface adas_sigvte_ioniz
     module procedure adas_sigvte_ioniz_r8,adas_sigvte_ioniz_int
  end interface
!
  interface adas_zstop_sigvz
     module procedure adas_zstop_sigvz_int_int,adas_zstop_sigvz_int_r8,adas_zstop_sigvz_r8_int,adas_zstop_sigvz_r8_r8
  end interface
!
  interface adas_sigv
     module procedure adas_sigv_int_int,adas_sigv_int_r8,adas_sigv_r8_int,adas_sigv_r8_r8
  end interface
!
  interface adas_sig
     module procedure adas_sig_int_int,adas_sig_int_r8,adas_sig_r8_int,adas_sig_r8_r8
  end interface
!
  interface adas_bms
     module procedure adas_bms3d_int_int,adas_bms3d_int_r8,adas_bms3d_r8_int,adas_bms3d_r8_r8
     module procedure adas_bms1d_int_int,adas_bms1d_int_r8,adas_bms1d_r8_int,adas_bms1d_r8_r8
     module procedure adas_bms2d_int_int,adas_bms2d_int_r8,adas_bms2d_r8_int,adas_bms2d_r8_r8
  end interface

contains
!
!---------------------------------------------------------------------
!
  subroutine adas_bms3d_int_r8(EB, Nevec, ZB, CONC, TI,Ntvec, ZI_r8, NE, Ndvec, &
      &            SIGVI, iERR)
      
    use adas_bms_splines

    implicit none
!
!Compute beam stopping rate coefficient on impurity
!
! Function Parameters
!
!     EB(nvec) : Beam Energy                                     [KeV/amu]
!     nevec     : energy vector size
!     ZB       : Beam Particle Nuclear Charge Number             
!   CONC(ndvec): target species fraction
!              : Z_imp * N_imp/SUM(Z_imp*N_imp) (0 < conc(i) <= 1)
!              : where,
!              : Z_imp -- Particle Nuclear Charge Number 
!              : N_imp -- impurity density
!     TI    : Target Temperatures                             [KeV/amu]
!     ntvec     : Temperature vector size
!     ZI_r8    : Target Nuclear Charge Number                    
!     NE    : EQUIVALENT of  Electron Density                         [cm**-3]
!                N_el*SUM(Z_imp^2* N_imp)/SUM(Z_imp * N_imp)/Z_imp
!     ndvec     : Density  vector size
!     SIGVI(nvec,ndvec,ntvec) : Beam Stopping Rate Coefficient     [m**3 / s]
!     iERR     : Error Code (0 = OK,                             
!                            1 = unsupported beam species
!                            2 = unsupported target species
!                            3 = input data corrupted (negative beam energy, densities or temperatures)
!                            4 = input data out of range
!                            5 = adas file reading error
!                            6 = spline output data invalid (negative)
!                            7 = spline error
!                            8 = array allocation error
!                            9 = array initialisation error)
!
    real(fp),intent(in)  :: EB(nevec)
    integer,intent(in) :: ZB
    integer,intent(in) :: nevec,ndvec,ntvec
    real(fp),intent(in)  :: TI(ntvec), NE(ndvec)
    real(fp),intent(in)  ::  ZI_r8(1)
    real(fp),intent(out)  :: SIGVI(nevec,ndvec,ntvec)
    real(fp),intent(in) :: conc(ndvec)
    
    integer :: iERR
    real(fp) ::   SIGVI_wrk
    !
    !local
    integer i,ii,ij,iz 
    integer :: npts_e, npts_d, npts_t ! number of points for table
    real(fp), dimension(:,:,:),allocatable :: sigv_table ! tabulated sig*v  
    real(fp), dimension(:),allocatable :: e_vec, d_vec, t_vec
    real(fp), dimension(12) :: axis_param_excite !axis parameters (E[KeV/amu],Ne[cm-3],T[KeV/amu])
                                               !for table: min, max values, 
                                               !number of points,specification 0 for LOG, 1 for LIN
    real(fp) conc_dummy(1)
    INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
    integer :: iZI(2),n_use !iZi - integer Zimp used to calculate sigv, n_use - 
                           !number of tables to be used, could be 1 or 2
    character*240 :: filename, filename_param    ! filename
!
    integer, parameter :: nspec = 10 ! nspec : number of plasma species in adas archive
    integer, parameter :: npts_e_param = 73, npts_d_param = 49 , npts_t_param = 73 ! number of points for table, 
                                                                                   !set by Michael Kraus, 09/14/09
    logical :: il_extrp=.true.
    integer:: npts_e_min
    character (len=4)  :: species_list(nspec)
	
    data species_list / 'h1', 'he2', 'li3', 'be4', 'b5', 'c6', 'n7', 'o8', 'f9', 'ne10' /
!

    ierr=0
    SIGVI=0.0_fp
    if(zb.gt.1) then !only H abailable
       ierr=3
       return
    endif
    call check_data_react(3,1,ZB,ZI_r8(1),iZI,n_use,ierr)!'SV' excited
    SIGVI=0.0_fp
    if(ierr.gt.0) then !error input data
       return
    endif
!
    npts_e=npts_e_param
    npts_d=npts_d_param
    npts_t=npts_t_param
!    
    write(cizneut,'(i5)') ZB
    do iz=1,n_use
       write(cizion,'(i5)') izi(iz)
       
       adas_tables_file=trim('tables/sv/ex')//'_'//&
            & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'.cdf'
       !
       call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename)
       !
       ! try to open filename in tables directory
       call cdf_open(icdf,trim(filename),'r',fErr)
       if (fErr.ne.0) then !no table has been created
          write(6,*)' ?adas_bms3d: no lookup tables found'
          write(6,*)' ?adas_bms3d: create tables first'
          ierr=1
          return
       endif
       !tables already computed, read data 
       call cdfInqVar(icdf,'sigv_excite',idims,nctype)
       npts_e=idims(1)
       npts_d=idims(2)
       npts_t=idims(3)
       if(allocated(sigv_table))deallocate(sigv_table)
       allocate(sigv_table(npts_e,npts_d,npts_t))
       ! allocate  energy, density and temperature  vectors
       if(allocated(e_vec)) deallocate(e_vec)
       allocate(e_vec(npts_e))
       if(allocated(d_vec)) deallocate(d_vec)
       allocate(d_vec(npts_d))
       if(allocated(t_vec)) deallocate(t_vec)
       allocate(t_vec(npts_t))
       !
       call cdf_read(icdf,'sigv_excite',sigv_table(1:npts_e,1:npts_d,1:npts_t)) 
       call cdfInqVar(icdf,'energy_vec',idims,nctype)
       call cdf_read(icdf,'energy_vec',e_vec(1: npts_e))
       call cdfInqVar(icdf,'density_vec',idims,nctype)
       call cdf_read(icdf,'density_vec',d_vec(1: npts_d))
       call cdfInqVar(icdf,'temp_vec',idims,nctype)
       call cdf_read(icdf,'temp_vec',t_vec(1: npts_t))
       call cdf_close(icdf)

       !interpolate 3D table
       call adas_setSplineData3(npts_e,npts_d,npts_t,e_vec,d_vec,t_vec,sigv_table,iErr)
       do ij=1,ntvec
          do ii=1,ndvec
             do i=1,nevec
                sigvi_wrk=0.0_fp
                
                if((conc(ii).eq.0.0_fp).or.(eb(i).eq.0.0_fp).or.(ne(ii).eq.0.0_fp).or.(ti(ij).eq.0.0_fp)) cycle
                
                call adas_evalSpline3(eb(i),ne(ii),ti(ij),sigvi_wrk,il_extrp,ierr) 
                sigvi_wrk=sigvi_wrk*conc(ii) !take into accoutnt impurity fraction
                
                if(n_use.eq.2) then
                   sigvi(i,ii,ij)=sigvi(i,ii,ij)+abs(zi_r8(1)-izi(n_use-iz+1))*sigvi_wrk/2.
                elseif(n_use.eq.1) then
                   sigvi(i,ii,ij)=zi_r8(1)/izi(1)*sigvi_wrk  
                   !scale to Zimp >10 (for H beam) or to Zimp >8 (for He beam)
                endif
                
             enddo
          enddo
       enddo
    enddo !iz
    
  end subroutine adas_bms3d_int_r8

!
!---------------------------------------------------------------------
!
  subroutine adas_bms1d_int_r8(EB, Nevec, ZB, CONC, TI, ZI_r8, NE, &
      &            SIGVI,iERR)
      
    use adas_bms_splines

    implicit none
!
!  same as  adas_bms3d_int_r8 but nvec = ntvec = ndvec, SIGVI(nevec)
!
!Compute beam stopping rate coefficient on impurity
!
! Function Parameters
!
!     EB(nvec) : Beam Energy                                     [KeV/amu]
!     nevec     : energy vector size
!     ZB       : Beam Particle Nuclear Charge Number             
!   CONC(ndvec): target species fraction
!              : Z_imp * N_imp/SUM(Z_imp*N_imp) (0 < conc(i) <= 1)
!              : where,
!              : Z_imp -- Particle Nuclear Charge Number 
!              : N_imp -- impurity density
!     TI    : Target Temperatures                             [KeV/amu]
!     ntvec     : Temperature vector size
!     ZI_r8    : Target Nuclear Charge Number                    
!     NE    : EQUIVALENT of  Electron Density                         [cm**-3]
!                N_el*SUM(Z_imp^2* N_imp)/SUM(Z_imp * N_imp)/Z_imp
!     ndvec     : Density  vector size
!     SIGVI(nvec) : Beam Stopping Rate Coefficient     [m**3 / s]
!     iERR     : Error Code (0 = OK,                             
!                            1 = unsupported beam species
!                            2 = unsupported target species
!                            3 = input data corrupted (negative beam energy, densities or temperatures)
!                            4 = input data out of range
!                            5 = adas file reading error
!                            6 = spline output data invalid (negative)
!                            7 = spline error
!                            8 = array allocation error
!                            9 = array initialisation error)
!
    real(fp),intent(in)  :: EB(nevec)
    integer,intent(in) :: ZB
    integer,intent(in) :: nevec
    real(fp),intent(in)  :: TI(nevec), NE(nevec)
    real(fp),intent(in)  ::  ZI_r8(1)
    real(fp),intent(out)  :: SIGVI(nevec)
    real(fp),intent(in) :: conc(nevec)
    integer :: iERR
    real(fp) ::   SIGVI_wrk
    !
    !local
    integer i,ii,ij,iz
    integer :: npts_e, npts_d, npts_t ! number of points for table
    real(fp), dimension(:,:,:),allocatable :: sigv_table ! tabulated sig*v  
    real(fp), dimension(:),allocatable :: e_vec, d_vec, t_vec
    real(fp), dimension(12) :: axis_param_excite !axis parameters (E[KeV/amu],Ne[cm-3],T[KeV/amu])
                                               !for table: min, max values, 
                                               !number of points,specification 0 for LOG, 1 for LIN
    real(fp) conc_dummy(1)
    INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
    integer :: iZI(2),n_use !iZi - integer Zimp used to calculate sigv, n_use - 
                           !number of tables to be used, could be 1 or 2
    character*240 :: filename, filename_param    ! filename
!
    integer, parameter :: nspec = 10 ! nspec : number of plasma species in adas archive
    integer, parameter :: npts_e_param = 73, npts_d_param = 49 , npts_t_param = 73 ! number of points for table, 
                                                                                   !set by Michael Kraus, 09/14/09
    logical :: il_extrp=.true.
    integer:: npts_e_min
    character (len=4)  :: species_list(nspec)

	
    data species_list / 'h1', 'he2', 'li3', 'be4', 'b5', 'c6', 'n7', 'o8', 'f9', 'ne10' /
!

    ierr=0
    SIGVI=0.0_fp
    if(zb.gt.1) then !only H abailable
       ierr=3
       return
    endif
    call check_data_react(3,1,ZB,ZI_r8(1),iZI,n_use,ierr)!'SV' excited
    SIGVI=0.0_fp
    if(ierr.gt.0) then !error input data
       return
    endif
!
    npts_e=npts_e_param
    npts_d=npts_d_param
    npts_t=npts_t_param
!    
    write(cizneut,'(i5)') ZB
    do iz=1,n_use
       write(cizion,'(i5)') izi(iz)
       
       adas_tables_file=trim('tables/sv/ex')//'_'//&
            & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'.cdf'
       !
       call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename)
       !
       ! try to open filename in tables directory
       call cdf_open(icdf,trim(filename),'r',fErr)
       if (fErr.ne.0) then !no table has been created
          write(6,*)' ?adas_bms1d: no lookup tables found'
          write(6,*)' ?adas_bms1d: create tables first'
          ierr=1
          return
       endif
       !tables already computed, read data 
       call cdfInqVar(icdf,'sigv_excite',idims,nctype)
       npts_e=idims(1)
       npts_d=idims(2)
       npts_t=idims(3)
       if(allocated(sigv_table))deallocate(sigv_table)
       allocate(sigv_table(npts_e,npts_d,npts_t))
       ! allocate  energy, density and temperature  vectors
       if(allocated(e_vec)) deallocate(e_vec)
       allocate(e_vec(npts_e))
       if(allocated(d_vec)) deallocate(d_vec)
       allocate(d_vec(npts_d))
       if(allocated(t_vec)) deallocate(t_vec)
       allocate(t_vec(npts_t))
       !
       call cdf_read(icdf,'sigv_excite',sigv_table(1:npts_e,1:npts_d,1:npts_t)) 
       call cdfInqVar(icdf,'energy_vec',idims,nctype)
       call cdf_read(icdf,'energy_vec',e_vec(1: npts_e))
       call cdfInqVar(icdf,'density_vec',idims,nctype)
       call cdf_read(icdf,'density_vec',d_vec(1: npts_d))
       call cdfInqVar(icdf,'temp_vec',idims,nctype)
       call cdf_read(icdf,'temp_vec',t_vec(1: npts_t))
       call cdf_close(icdf)

       !interpolate 3D table
       call adas_setSplineData3(npts_e,npts_d,npts_t,e_vec,d_vec,t_vec,sigv_table,iErr)
       do i=1,nevec
          sigvi_wrk=0.0_fp
          if((conc(i).eq.0.0_fp).or.(eb(i).eq.0.0_fp).or.(ne(i).eq.0.0_fp).or.(ti(i).eq.0.0_fp)) cycle
          
          call adas_evalSpline3(eb(i),ne(i),ti(i),sigvi_wrk,il_extrp,ierr) 
          sigvi_wrk=sigvi_wrk*conc(i) !take into accoutnt impurity fraction
          
          if(n_use.eq.2) then
             sigvi(i)=sigvi(i)+abs(zi_r8(1)-izi(n_use-iz+1))*sigvi_wrk/2.
          elseif(n_use.eq.1) then
             sigvi(i)=zi_r8(1)/izi(1)*sigvi_wrk  !scale to Zimp >10 (for H beam) or to Zimp >8 (for He beam)
          endif
          
       enddo
    enddo !iz
    
  end subroutine adas_bms1d_int_r8
!
!---------------------------------------------------------------------
!
  subroutine adas_bms2d_int_r8(EB, Nevec, ZB, CONC, TI,Ntvec, ZI_r8, NE,  &
      &            SIGVI, iERR)
      
    use adas_bms_splines

    implicit none
!
!  same as  adas_bms3d_int_r8 but ntvec = ndvec, SIGVI(nevec,ntvec)
!
!Compute beam stopping rate coefficient on impurity
!
! Function Parameters
!
!     EB(nvec) : Beam Energy                                     [KeV/amu]
!     nevec     : energy vector size
!     ZB       : Beam Particle Nuclear Charge Number             
!   CONC(ntvec): target species fraction
!              : Z_imp * N_imp/SUM(Z_imp*N_imp) (0 < conc(i) <= 1)
!              : where,
!              : Z_imp -- Particle Nuclear Charge Number 
!              : N_imp -- impurity density
!     TI    : Target Temperatures                             [KeV/amu]
!     ntvec     : Temperature vector size
!     ZI_r8    : Target Nuclear Charge Number                    
!     NE    : EQUIVALENT of  Electron Density                         [cm**-3]
!                N_el*SUM(Z_imp^2* N_imp)/SUM(Z_imp * N_imp)/Z_imp
!     ntvec     : Density  vector size
!     SIGVI(nvec,ntvec) : Beam Stopping Rate Coefficient     [m**3 / s]
!     iERR     : Error Code (0 = OK,                             
!                            1 = unsupported beam species
!                            2 = unsupported target species
!                            3 = input data corrupted (negative beam energy, densities or temperatures)
!                            4 = input data out of range
!                            5 = adas file reading error
!                            6 = spline output data invalid (negative)
!                            7 = spline error
!                            8 = array allocation error
!                            9 = array initialisation error)
!
    real(fp),intent(in)  :: EB(nevec)
    integer,intent(in) :: ZB
    integer,intent(in) :: nevec,ntvec
    real(fp),intent(in)  :: TI(ntvec), NE(ntvec)
    real(fp),intent(in)  ::  ZI_r8(1)
    real(fp),intent(out)  :: SIGVI(nevec,ntvec)
    real(fp),intent(in) :: conc(ntvec)
    integer :: iERR
    real(fp) ::   SIGVI_wrk
    !
    !local
    integer i,ii,ij,iz 
    integer :: npts_e, npts_d, npts_t ! number of points for table
    real(fp), dimension(:,:,:),allocatable :: sigv_table ! tabulated sig*v  
    real(fp), dimension(:),allocatable :: e_vec, d_vec, t_vec
    real(fp), dimension(12) :: axis_param_excite !axis parameters (E[KeV/amu],Ne[cm-3],T[KeV/amu])
                                               !for table: min, max values, 
                                               !number of points,specification 0 for LOG, 1 for LIN
    real(fp) conc_dummy(1)
    INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
    integer :: iZI(2),n_use !iZi - integer Zimp used to calculate sigv, n_use - 
                           !number of tables to be used, could be 1 or 2
    character*240 :: filename, filename_param    ! filename
!
    integer, parameter :: nspec = 10 ! nspec : number of plasma species in adas archive   x1r8=dble(x1)

    integer, parameter :: npts_e_param = 73, npts_d_param = 49 , npts_t_param = 73 ! number of points for table, 
                                                                                   !set by Michael Kraus, 09/14/09
    logical :: il_extrp=.true.
    integer:: npts_e_min
    character (len=4)  :: species_list(nspec)
	
    data species_list / 'h1', 'he2', 'li3', 'be4', 'b5', 'c6', 'n7', 'o8', 'f9', 'ne10' /
!

    ierr=0
    SIGVI=0.0_fp
    if(zb.gt.1) then !only H abailable
       ierr=3
       return
    endif
    call check_data_react(3,1,ZB,ZI_r8(1),iZI,n_use,ierr)!'SV' excited
    SIGVI=0.0_fp
    if(ierr.gt.0) then !error input data
       return
    endif
!
    npts_e=npts_e_param
    npts_d=npts_d_param
    npts_t=npts_t_param
!    
    write(cizneut,'(i5)') ZB
    do iz=1,n_use
       write(cizion,'(i5)') izi(iz)
       
       adas_tables_file=trim('tables/sv/ex')//'_'//&
            & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'.cdf'
       !
       call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename)
       !
       ! try to open filename in tables directory
       call cdf_open(icdf,trim(filename),'r',fErr)
       if (fErr.ne.0) then !no table has been created
          write(6,*)' ?adas_bms2d: no lookup tables found'
          write(6,*)' ?adas_bms2d: create tables first'
          ierr=1
          return
       endif
       !tables already computed, read data 
       call cdfInqVar(icdf,'sigv_excite',idims,nctype)
       npts_e=idims(1)
       npts_d=idims(2)
       npts_t=idims(3)
       if(allocated(sigv_table))deallocate(sigv_table)
       allocate(sigv_table(npts_e,npts_d,npts_t))
       ! allocate  energy, density and temperature  vectors
       if(allocated(e_vec)) deallocate(e_vec)
       allocate(e_vec(npts_e))
       if(allocated(d_vec)) deallocate(d_vec)
       allocate(d_vec(npts_d))
       if(allocated(t_vec)) deallocate(t_vec)
       allocate(t_vec(npts_t))
       !
       call cdf_read(icdf,'sigv_excite',sigv_table(1:npts_e,1:npts_d,1:npts_t)) 
       call cdfInqVar(icdf,'energy_vec',idims,nctype)
       call cdf_read(icdf,'energy_vec',e_vec(1: npts_e))
       call cdfInqVar(icdf,'density_vec',idims,nctype)
       call cdf_read(icdf,'density_vec',d_vec(1: npts_d))
       call cdfInqVar(icdf,'temp_vec',idims,nctype)
       call cdf_read(icdf,'temp_vec',t_vec(1: npts_t))
       call cdf_close(icdf)

       !interpolate 3D table
       call adas_setSplineData3(npts_e,npts_d,npts_t,e_vec,d_vec,t_vec,sigv_table,iErr)
       do ij=1,ntvec
          do i=1,nevec
             sigvi_wrk=0.0_fp
             
             if((conc(ij).eq.0.0_fp).or.(eb(i).eq.0.0_fp).or.(ne(ij).eq.0.0_fp).or.(ti(ij).eq.0.0_fp)) cycle
             
             call adas_evalSpline3(eb(i),ne(ij),ti(ij),sigvi_wrk,il_extrp,ierr) 
             sigvi_wrk=sigvi_wrk*conc(ij) !take into accoutnt impurity fraction
             
             if(n_use.eq.2) then
                sigvi(i,ij)=sigvi(i,ij)+abs(zi_r8(1)-izi(n_use-iz+1))*sigvi_wrk/2.
             elseif(n_use.eq.1) then
                sigvi(i,ij)=zi_r8(1)/izi(1)*sigvi_wrk  
                !scale to Zimp >10 (for H beam) or to Zimp >8 (for He beam)
             endif
             
          enddo
       enddo
    enddo !iz
    
  end subroutine adas_bms2d_int_r8

!
!---------------------------------------------------------------------
!
  subroutine adas_bms3d_int_int(EB, Nevec, ZB, CONC, TI,Ntvec, ZI, NE, Ndvec, &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    integer,intent(in) :: ZB
    integer,intent(in) :: nevec,ndvec,ntvec
    real(fp),intent(in)  :: TI(ntvec), NE(ndvec)
    integer,intent(in)  ::  ZI(1)
    real(fp),intent(out)  :: SIGVI(nevec,ndvec,ntvec)
    real(fp),intent(in) :: conc(ndvec)
    
    integer :: iERR
    real(fp)  ::  ZI_r8(1)
    ZI_r8=dble(zi)
    call adas_bms3d_int_r8(EB, Nevec, ZB, CONC, TI,Ntvec, ZI_r8, NE, Ndvec, &
      &            SIGVI, iERR)
  end subroutine adas_bms3d_int_int
!
!---------------------------------------------------------------------
!
  subroutine adas_bms3d_r8_int(EB, Nevec, ZB_r8, CONC, TI,Ntvec, ZI, NE, Ndvec, &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    real(fp),intent(in) :: ZB_r8
    integer,intent(in) :: nevec,ndvec,ntvec
    real(fp),intent(in)  :: TI(ntvec), NE(ndvec)
    integer ,intent(in)  ::  ZI(1)
    real(fp),intent(out)  :: SIGVI(nevec,ndvec,ntvec)
    real(fp),intent(in) :: conc(ndvec)
    
    integer :: iERR
    integer :: ZB
    real(fp)  ::  ZI_r8(1)
    zi_r8=dble(zi)
    zb=zb_r8
    call adas_bms3d_int_r8(EB, Nevec, ZB, CONC, TI,Ntvec, ZI_r8, NE, Ndvec, &
         &            SIGVI, iERR)
  end subroutine adas_bms3d_r8_int
!
!---------------------------------------------------------------------
!
  subroutine adas_bms3d_r8_r8(EB, Nevec, ZB_r8, CONC, TI,Ntvec, ZI_r8, NE, Ndvec, &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    real(fp),intent(in) :: ZB_r8
    integer,intent(in) :: nevec,ndvec,ntvec
    real(fp),intent(in)  :: TI(ntvec), NE(ndvec)
    real(fp) ,intent(in)  ::  ZI_r8(1)
    real(fp),intent(out)  :: SIGVI(nevec,ndvec,ntvec)
    real(fp),intent(in) :: conc(ndvec)
    
    integer :: iERR
    integer :: ZB
    zb=zb_r8
    call adas_bms3d_int_r8(EB, Nevec, ZB, CONC, TI,Ntvec, ZI_r8, NE, Ndvec, &
         &            SIGVI, iERR)
  end subroutine adas_bms3d_r8_r8
!
!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
!
  subroutine adas_bms1d_int_int(EB, Nevec, ZB, CONC, TI, ZI, NE, &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    integer,intent(in) :: ZB
    integer,intent(in) :: nevec
    real(fp),intent(in)  :: TI(nevec), NE(nevec)
    integer,intent(in)  ::  ZI(1)
    real(fp),intent(out)  :: SIGVI(nevec)
    real(fp),intent(in) :: conc(nevec)
    
    integer :: iERR
    real(fp)  ::  ZI_r8(1)
    ZI_r8=dble(zi)
    call adas_bms1d_int_r8(EB, Nevec, ZB, CONC, TI,ZI_r8, NE,  &
      &            SIGVI, iERR)
  end subroutine adas_bms1d_int_int
!
!---------------------------------------------------------------------
!
  subroutine adas_bms1d_r8_int(EB, Nevec, ZB_r8, CONC, TI, ZI, NE, &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    real(fp),intent(in) :: ZB_r8
    integer,intent(in) :: nevec
    real(fp),intent(in)  :: TI(nevec), NE(nevec)
    integer ,intent(in)  ::  ZI(1)
    real(fp),intent(out)  :: SIGVI(nevec)
    real(fp),intent(in) :: conc(nevec)
    
    integer :: iERR
    integer :: ZB
    real(fp)  ::  ZI_r8(1)
    zi_r8=dble(zi)
    zb=zb_r8
    call adas_bms1d_int_r8(EB, Nevec, ZB, CONC, TI, ZI_r8, NE,  &
         &            SIGVI, iERR)
  end subroutine adas_bms1d_r8_int
!
!---------------------------------------------------------------------
!
  subroutine adas_bms1d_r8_r8(EB, Nevec, ZB_r8, CONC, TI, ZI_r8, NE,  &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    real(fp),intent(in) :: ZB_r8
    integer,intent(in) :: nevec
    real(fp),intent(in)  :: TI(nevec), NE(nevec)
    real(fp) ,intent(in)  ::  ZI_r8(1)
    real(fp),intent(out)  :: SIGVI(nevec)
    real(fp),intent(in) :: conc(nevec)
    
    integer :: iERR
    integer :: ZB
    zb=zb_r8
    call adas_bms1d_int_r8(EB, Nevec, ZB, CONC, TI, ZI_r8, NE,  &
         &            SIGVI, iERR)
  end subroutine adas_bms1d_r8_r8
!
!---------------------------------------------------------------------
!
!---------------------------------------------------------------------
!
  subroutine adas_bms2d_int_int(EB, Nevec, ZB, CONC, TI,Ntvec, ZI, NE,  &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    integer,intent(in) :: ZB
    integer,intent(in) :: nevec,ntvec
    real(fp),intent(in)  :: TI(ntvec), NE(nevec)
    integer,intent(in)  ::  ZI(1)
    real(fp),intent(out)  :: SIGVI(nevec,ntvec)
    real(fp),intent(in) :: conc(nevec)
    
    integer :: iERR
    real(fp)  ::  ZI_r8(1)
    ZI_r8=dble(zi)
    call adas_bms2d_int_r8(EB, Nevec, ZB, CONC, TI,Ntvec, ZI_r8, NE,  &
      &            SIGVI, iERR)
  end subroutine adas_bms2d_int_int
!
!---------------------------------------------------------------------
!
  subroutine adas_bms2d_r8_int(EB, Nevec, ZB_r8, CONC, TI,Ntvec, ZI, NE,  &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    real(fp),intent(in) :: ZB_r8
    integer,intent(in) :: nevec,ntvec
    real(fp),intent(in)  :: TI(ntvec), NE(nevec)
    integer ,intent(in)  ::  ZI(1)
    real(fp),intent(out)  :: SIGVI(nevec,ntvec)
    real(fp),intent(in) :: conc(nevec)
    
    integer :: iERR
    integer :: ZB
    real(fp)  ::  ZI_r8(1)
    zi_r8=dble(zi)
    zb=zb_r8
    call adas_bms2d_int_r8(EB, Nevec, ZB, CONC, TI,Ntvec, ZI_r8, NE, &
         &            SIGVI, iERR)
  end subroutine adas_bms2d_r8_int
!
!---------------------------------------------------------------------
!
  subroutine adas_bms2d_r8_r8(EB, Nevec, ZB_r8, CONC, TI,Ntvec, ZI_r8, NE,  &
      &            SIGVI, iERR)
      
    real(fp),intent(in)  :: EB(nevec)
    real(fp),intent(in) :: ZB_r8
    integer,intent(in) :: nevec,ntvec
    real(fp),intent(in)  :: TI(ntvec), NE(nevec)
    real(fp) ,intent(in)  ::  ZI_r8(1)
    real(fp),intent(out)  :: SIGVI(nevec,ntvec)
    real(fp),intent(in) :: conc(nevec)
    
    integer :: iERR
    integer :: ZB
    zb=zb_r8
    call adas_bms2d_int_r8(EB, Nevec, ZB, CONC, TI,Ntvec, ZI_r8, NE,  &
         &            SIGVI, iERR)
  end subroutine adas_bms2d_r8_r8
!
!---------------------------------------------------------------------
!
!---------------------------------------------------------------------!
! adas_ion.f90:                                                       !
!     by Michael Kraus (michael.kraus@ipp.mpg.de)                     !
!     created 2009/06/24                                              !
!                                                                     !
!     reads ion collision cross sections from adas adf02 data tables  !
!     applies spline interpolation within the data range and          !
!     logarithmic extrapolation beyond                                !
!                                                                     !
!                                                                     !
! References:                                                         !
!                                                                     !
!    1. H. P. Summers (2004)                                          !
!       "The ADAS User Manual v2.6"                                   !
!       http://www.adas.ac.uk/manual.php                              !
!                                                                     !
!    2. NTCC PSPLINE Module                                           !
!       http://w3.pppl.gov/ntcc/PSPLINE/                              !
!                                                                     !
!---------------------------------------------------------------------!

 subroutine adas_ion(Erel_KeV, N, Z1, Z2, react, SIG, iErr)
      use EZspline_obj
      use EZspline
      
      implicit none

! Function Parameters
!
!     Erel_Kev(N)  : collision energies                              [KeV/amu]
!     N        : number of energy values
!     Z1       : atomic charge of primary   particle {1, 2}
!     Z2       : atomic charge of secondary particle {1, ..., 10}
!     react    : reaction type (
!                               1 = single ion impact ionisation (e.g. H +0 + H +1 => H +1 + H +1 + e)
!                               2 = full   ion impact ionisation (e.g. He+0 + H +1 => He+2 + H +1 + 2e)
!                               3 = single charge exchang        (e.g. He+0 + H +1 => He+1 + H +0)
!                               4 = full   charge exchang        (e.g. He+0 + He+2 => He+2 + He+0)
!                              )
!     SIG(N)   : requested cross sections                        [cm**2]
!     iErr     : error code    (0 = OK,                          
!                               1 = energy invalid
!                               2 = unsupported primary   species
!                               3 = unsupported secondary species
!                               4 = unsupported reaction type
!                               5 = reaction data unavailable
!                               6 = adas file reading error
!                               7 = spline error
!                               8 = 
!                              )
!
      integer,intent(in) :: N
      real(fp) ,intent(in) :: Erel_Kev(N)
      integer,intent(in) :: Z1, Z2, react 
      integer,intent(out) ::iErr
      real(fp) ,intent(out) ::sig(n)      
! Local Parameters
!
! nReact   : number of supported reactions
! nZ1      : number of supported primary   species
! nZ2      : number of supported secondary species
! maxn     : max number of entries per data table
!
! csIndex  : cross section table index in data file (0 means data not available)
! csi      : selected cross section index
!
! ferel(maxn) : Erel  from file
! fsig(maxn)  : sigma from file
! fn          : size of data table in file
! i, ie, is   : loop indices
!
! sig_ezspl   : EzSpline object for sigma
! bcs_sig     : boundary conditions for sigma spline
! serr        : spline error code
!
! tape             : data file identifier adas archive file
! outdbg           : data file identifier debug output
! fErr             : file reading error code
! nsel             : number of reactions in file
! adas_ion_data(2) : atomic data archive file names (adf02)
! filename         : complete path of adas archive file
! line             : temporary string for file input
!
      real(fp) :: Erel(N)
      integer, parameter :: nReact = 4
      integer, parameter :: nZ1  = 2
      integer, parameter :: nZ2  = 10
      integer, parameter :: maxn = 25
      
      integer :: csIndex(nReact, nZ1, nZ2)
      integer :: csi
      
      real(fp)  :: ferel(maxn), fsigma(maxn)
      real(fp)  :: logferel(maxn), logfsigma(maxn), logSIG(N)
      integer :: fn
      integer :: i, ie, is,ierr_extrapol
      
      type(EZspline1)    :: sig_ezspl
      integer            :: bcs_sig(2)
      integer            :: sErr
      
      integer, parameter :: tape   = 74
      integer, parameter :: outdbg = 75
      integer            :: fErr
      integer            :: nsel
      
      character*40  :: adas_ion_data(2)
      character*240 :: filename
      character*80  :: line
      real(fp)  :: x_tables(3),f_tables(3)

      csIndex(1,1,:)=(/11, 12, 13, 14, 15, 16, 17, 18, 19, 20/)   !   react = 1 (II), Z1 = 1 (H),  Z2 = {1, ..., 10}  (H +0 + X+Z2 => H +1  + X+Z2 + e)
      csIndex(1,2,:)=(/24, 28,  0, 31,  0, 34,  0, 37,  0,  0/)   !   react = 1 (II), Z1 = 2 (He), Z2 = {1, ..., 10}  (He+0 + X+Z2 => He+1  + X+Z2 + e)
      csIndex(2,1,:)=(/11, 12, 13, 14, 15, 16, 17, 18, 19, 20/)   !   react = 2 (II), Z1 = 1 (H),  Z2 = {1, ..., 10}  (H +0 + X+Z2 => H +Z1 + X+Z2 + Z1*e)
      csIndex(2,2,:)=(/43, 46,  0, 48,  0, 50,  0, 52,  0,  0/)   !   react = 2 (II), Z1 = 2 (He), Z2 = {1, ..., 10}  (He+0 + X+Z2 => He+Z1 + X+Z2 + Z1*e)
      csIndex(3,1,:)=(/ 1,  2,  3,  4,  5,  6,  7,  8,  9, 10/)   !   react = 3 (CX), Z1 = 1 (H),  Z2 = {1, ..., 10}  (H +0 + X+Z2 => H +1  + X+Z2-1 )
      csIndex(3,2,:)=(/ 1,  5,  0,  8, 11, 12, 15, 16,  0, 19/)   !   react = 3 (CX), Z1 = 2 (He), Z2 = {1, ..., 10}  (He+0 + X+Z2 => He+1  + X+Z2-1 )
      csIndex(4,1,:)=(/ 1,  2,  3,  4,  5,  6,  7,  8,  9, 10/)   !   react = 4 (CX), Z1 = 1 (H),  Z2 = {1, ..., 10}  (H +0 + X+Z2 => H +Z1 + X+Z2-Z1)
      csIndex(4,2,:)=(/ 1, 20,  0, 21,  0, 22,  0, 23,  0,  0/)   !   react = 4 (CX), Z1 = 2 (He), Z2 = {1, ..., 10}  (He+0 + X+Z2 => He+Z1 + X+Z2-Z1)
      
      adas_ion_data(1)='data/adf02/sia#h/sia#h_j99#h.dat'        ! H  data archive
      adas_ion_data(2)='data/adf02/sia#he/sia#he_j91#he.dat'     ! He data archive
      
      iErr = 0
      Erel=Erel_KeV*1e+3_fp !convert to [eV/amu]
      
! check if input data meets requirements and is valid
      ! check if collision energy is positive
      do i=1,N
         if (Erel(i) .le. 0.0) then
            iErr = 1
            return
         endif
      enddo
      
      ! check if primary species is in {H, He}
      if (Z1 .lt. 1 .AND. Z1 .gt. nZ1) then
         iErr = 2
         return
      endif
      
      ! check if secondary species Z in {1, ..., 10}
      if (Z2 .lt. 1 .OR. Z2 .gt. nZ2) then
         iErr = 3
         return
      endif
      
      ! check if reaction type is valid
      if (react .lt. 1 .OR. react .gt. nReact) then
         iErr = 4
         return
      endif
      
      ! check if requested cross section is available
      csi = csIndex(react, Z1, Z2)
      if (csi .eq. 0) then
         iErr = 5
         return
      endif

      
! read data from archive (refer to ADAS adf21 file format documentation at [2])
      call UFILNAM('ADASDIR',adas_ion_data(Z1),filename)
      open(unit=tape,file=filename,action='read', iostat=fErr)
      if (fErr .ne. 0) then                       ! check if file could be opened
         iErr = 6
         return
      endif
      read(tape,1000) nsel
      do i = 1,nsel
         read(tape,1001) fn
         read(tape,1002) (ferel(ie), ie=1,fn)
         read(tape,1002) (fsigma(is),is=1,fn)
         if (i .eq. csi) exit
      enddo
      close(tape) 
      
      if (i .gt. nsel) then
         iErr = 6
         return
      endif
      
      if (fn .lt. 3) then
         iErr = 6
         return
      endif
      
1000  format(i5)
1001  format(13x,i2)
1002  format(6(1x,E9.3E2),/,6(1x,E9.3E2))
      
      
! output adas data for debugging
   
!      if (react .eq. 1 .OR. react .eq. 2) filename = 'ii'
!      if (react .eq. 3 .OR. react .eq. 4) filename = 'cx'
      
!      filename = "adas_ion_" // trim(filename) // "_dbg.dat"
      
!      open(unit = outdbg, file = filename)
!      do i=1,fn
!         write(outdbg,'(5g20.10,5g20.10)') ferel(i), fsigma(i)
!      enddo
!      close(unit = outdbg)
      
      
      
! apply log on data
      
      do i=1,fn
         logferel(i)  = log(ferel(i))
         logfsigma(i) = log(fsigma(i))
      enddo
      
      
! create EzSpline object and put data into it
      
      bcs_sig = (/0, 0/)     ! not-a-knot boundary conditions
      
      call EZspline_init(sig_ezspl, fn, bcs_sig, sErr)      ! initialise spline object grid and boundary conditions
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 7
         return
      endif
      sig_ezspl%x1 = logferel(1:fn)                         ! set grid points
      call EZspline_setup(sig_ezspl, logfsigma(1:fn), sErr) ! initialise spline data
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 7
         return
      endif
      
      
! evaluate spline object with Erel values
      do i=1,N
         ! check if requested collision energy is within the available domain
         call EZspline_isInDomain(sig_ezspl, log(Erel(i)), sErr)
!         call EZspline_error(sErr)
         if (sErr .eq. 0) then
            ! requested value in range, evaluate spline
            call EZspline_interp(sig_ezspl, log(Erel(i)), logSIG(i), sErr)
            call EZspline_error(sErr)
            if (sErr .ne. 0) then
               iErr = 7
               return
            endif
            SIG(i) = exp(logSIG(i))
         else
            ! requested value out of range, extrapolate
            if (log(Erel(i)) .le. sig_ezspl%x1min) then

               call linear_interp(log(erel(i)),logferel(1:2),logfsigma(1:2),logSIG(i),ierr_extrapol)

               if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
                 
               SIG(i) = exp(logSIG(i))
            else if (log(Erel(i)) .ge. sig_ezspl%x1max) then
               do ie=1,3
                  x_tables(ie)=logferel(fn-ie+1)
                  f_tables(ie)=logfsigma(fn-ie+1)
               enddo

               call linear_interp (log(erel(i)),x_tables(1:2),f_tables(1:2),logSIG(i),ierr_extrapol)            

                if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
 
              SIG(i) = exp(logSIG(i))
            else
               iErr = 7
               return
            endif
         endif
      enddo
!mg      call r8_grafxf(erel(42:79),sig(42:79),38,ferel,fsigma,fn,' ',' ',' ',' ',' ')
      
      
      return
    end subroutine adas_ion
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sig_int_int(evec,n1,izneut,izion,fadas_type,sig_adas,istat)
!
! creates tables for  CX and ionization cross section sig using  ADAS data
!
  integer, intent(in) :: fadas_type    !marks reaction type used in adas_ion
!                               1 = single ion impact ionisation (e.g. H +0 + H +1 => H +1 + H +1 + e)
!                               2 = full   ion impact ionisation (e.g. He+0 + H +1 => He+2 + H +1 + 2e)
!                               3 = single charge exchange        (e.g. He+0 + H +1 => He+1 + H +0)
!                               4 = full   charge exchange        (e.g. He+0 + He+2 => He+2 + He+0)
!                               5 = Impact ionization = single II + full II + non-neutralaizing CX
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  integer, intent(in) :: izneut  !atomic charge of primary   particle {1, 2}
  integer, intent(in) :: izion  !atomic charge of secondary particle {1, ..., 10}
  INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  real(fp), dimension(n1), intent(out) :: sig_adas !sigma*v [m**2]
  real(fp) :: zion  !atomic charge of secondary particle {1, ..., 10}
  zion=dble(izion)
  call adas_sig_int_r8(evec,n1,izneut,zion,fadas_type,sig_adas,istat)
end subroutine adas_sig_int_int
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sig_r8_int(evec,n1,zneut,izion,fadas_type,sig_adas,istat)
! creates tables for  CX and ionization cross section sig using  ADAS data
  integer, intent(in) :: fadas_type    !marks reaction type used in adas_ion
!                               1 = single ion impact ionisation (e.g. H +0 + H +1 => H +1 + H +1 + e)
!                               2 = full   ion impact ionisation (e.g. He+0 + H +1 => He+2 + H +1 + 2e)
!                               3 = single charge exchang        (e.g. He+0 + H +1 => He+1 + H +0)
!                               4 = full   charge exchang        (e.g. He+0 + He+2 => He+2 + He+0)
!                               5 = Impact ionization = single II + full II + non-neutralaizing CX
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), intent(in) :: zneut  !atomic charge of primary   particle {1, 2}
  integer, intent(in) :: izion  !atomic charge of secondary particle {1, ..., 10}
  INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  real(fp), dimension(n1), intent(out) :: sig_adas !sigma*v [m**2]
  real(fp) :: zion  !atomic charge of secondary particle {1, ..., 10}
  integer :: izneut  !atomic charge of primary   particle {1, 2}
  izneut=zneut
  zion=dble(izion)
  call adas_sig_int_r8(evec,n1,izneut,zion,fadas_type,sig_adas,istat)
end subroutine adas_sig_r8_int
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sig_r8_r8(evec,n1,zneut,zion,fadas_type,sig_adas,istat)
! creates tables for  CX and ionization cross section sig using  ADAS data
  integer, intent(in) :: fadas_type    !marks reaction type used in adas_ion
!                               1 = single ion impact ionisation (e.g. H +0 + H +1 => H +1 + H +1 + e)
!                               2 = full   ion impact ionisation (e.g. He+0 + H +1 => He+2 + H +1 + 2e)
!                               3 = single charge exchang        (e.g. He+0 + H +1 => He+1 + H +0)
!                               4 = full   charge exchang        (e.g. He+0 + He+2 => He+2 + He+0)
!                               5 = Impact ionization = single II + full II + non-neutralaizing CX
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), intent(in) :: zneut  !atomic charge of primary   particle {1, 2}
  real(fp), intent(in) :: zion  !atomic charge of secondary particle {1, ..., 10}
  INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  real(fp), dimension(n1), intent(out) :: sig_adas !sigma*v [m**2]
  integer :: izneut  !atomic charge of primary   particle {1, 2}
  izneut=zneut
  call adas_sig_int_r8(evec,n1,izneut,zion,fadas_type,sig_adas,istat)
end subroutine adas_sig_r8_r8
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sig_int_r8(evec,n1,izneut,zion,fadas_type,sig_adas,istat)
! creates tables for  CX and ionization cross section sig using  ADAS data
  integer, intent(in) :: fadas_type    !marks reaction type used in adas_ion
!                               1 = single ion impact ionisation (e.g. H +0 + H +1 => H +1 + H +1 + e)
!                               2 = full   ion impact ionisation (e.g. He+0 + H +1 => He+2 + H +1 + 2e)
!                               3 = single charge exchang        (e.g. He+0 + H +1 => He+1 + H +0)
!                               4 = full   charge exchang        (e.g. He+0 + He+2 => He+2 + He+0)
!                               5 = Impact ionization = single II + full II + non-neutralaizing CX
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  integer, intent(in) :: izneut  !atomic charge of primary   particle {1, 2}
  real(fp), intent(in) :: zion  !atomic charge of secondary particle {1, ..., 10}
  INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  real(fp), dimension(n1), intent(out) :: sig_adas !sigma [m**2]
  integer, dimension(5) :: react_type= (/2,2,1,1,2/)   !reaction type: 1  ='CX', 2 = 'II'
  character*2, dimension(5) :: creact_type= (/'ii','ii','cx','cx','ii'/)   
  integer :: iZI(2),n_use !iZi - integer Zimp used to calculate sigv, n_use - 
                         !number of tables to be used, could be 1 or 2
  character*9 :: cfadas_type
  character*240 :: filename, filename_param    ! filename
  real(fp), dimension(:),pointer :: e_axis ! axis grid
  real(fp), dimension(:),allocatable :: sig_table, sig_table_wrk ! tabulated sig*v  
  real(fp), dimension(n1) :: sig_adas_wrk !work array sigma [m**2]
  integer :: iz, ierr
  istat=0
  
  call check_data_react(react_type(fadas_type),1,izneut,zion,iZI,n_use,istat)
  sig_adas=0._fp
  sig_adas_wrk=0._fp
  if(istat.gt.0) then !some error in input data, do not proceed
     return
  endif
  write(cizneut,'(i5)') izneut
  write(cfadas_type,'(i5)') fadas_type
  do iz=1, n_use
     write(cizion,'(i5)') izi(iz)
     ! create table's filename
     !
     adas_tables_file=trim('tables/')//trim(adjustl(creact_type(fadas_type)))//&
          &'/'//trim(adjustl(creact_type(fadas_type)))//trim(adjustl(cfadas_type))//'_'//&
          & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'.cdf'
     call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename)
     !
     ! try to open filename in tables directory
     call cdf_open(icdf,trim(filename),'r',fErr)
     
     if (fErr.ne.0) then !no table has been created
        write(6,*)' %adas_sig: OK table data being recomputed'
        
        !compute and write table         
        !open file and read axis parameters
        adas_tables_file=trim('tables/')//trim(adjustl(creact_type(fadas_type)))//&
             &'/'//trim(adjustl(creact_type(fadas_type)))//'_'//&
             & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'_'//'tableParameters.cdf'
        call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename_param)
        call cdf_open(icdf,trim(filename_param),'r',fErr)
        if (fErr.ne.0) then 
           write(6,*)' %adas_sig: OK trying to read dummy data'
           !tables have not been initialized, try to read dummy data
           call UFILNAM('ADASDIR',trim('tables/')//trim(adjustl(creact_type(fadas_type)))//&
                &'/'//'tableParameters.cdf',filename_param)
           call cdf_open(icdf,trim(filename_param),'r',fErr)
           if(ferr.gt.0) then
              write(6,*)' ?adas_sig: faild to read table data'
              istat = 10
              return
           endif
        endif
        call cdfInqVar(icdf,'axis_param_coldTarget',idims,nctype)
        call cdf_read(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:idims(1)))
        call cdf_close(icdf)
        !
!        write(*,*)' %adas_sig computed table'
        call compute_axis(e_axis,axis_param_coldTarget)
        !     
        npts=int(axis_param_coldTarget(3))
        if(allocated(sig_table))deallocate(sig_table)
        allocate(sig_table(npts))
        if(allocated(sig_table_wrk))deallocate(sig_table_wrk)
        allocate(sig_table_wrk(npts))
        sig_table=0.0_fp
        sig_table_wrk=0.0_fp
        if(fadas_type.le.4) then
           call adas_ion(e_axis,npts,izneut,izi(iz),fadas_type,sig_table,ierr)
        elseif(fadas_type.eq.5) then !Impact ionization = single II + full II + non-neutralaizing CX
           fadas_II=1 ! single ionizataion
           sig_table_wrk=0.0_fp
           call adas_ion(e_axis,npts,izneut,izi(iz),fadas_II,sig_table_wrk,ierr)
           sig_table=sig_table+sig_table_wrk
           if(izi(iz).gt.1) then
              fadas_CX=3 ! converted to adas_ion routine for non-neutralizing CX 
              sig_table_wrk=0.0_fp
              call adas_ion(e_axis,npts,izneut,izi(iz),fadas_CX,sig_table_wrk,ierr)
              sig_table=sig_table+sig_table_wrk
              if(izneut.gt.1) then
                 fadas_II=2 ! converted to adas_ion routine  for full ionizataion
                 sig_table_wrk=0.0_fp
                 call adas_ion(e_axis,npts,izneut,izi(iz),fadas_II,sig_table_wrk,ierr)
                 sig_table=sig_table+sig_table_wrk
                 if(izi(iz).gt.izneut) then
                    fadas_CX=4 ! converted to adas_ion routine for non-neutralized CX 
                    sig_table_wrk=0.0_fp
                   call adas_ion(e_axis,npts,izneut,izi(iz),fadas_CX,sig_table_wrk,ierr)
                    sig_table=sig_table+sig_table_wrk
                 endif
              endif
           endif
        endif
        if(ierr.gt.0) return !do not write table
        call cdf_open(icdf,trim(filename),'w',fErr)
        call cdf_define(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:4)) 
        call cdf_define(icdf,'sig',sig_table(1:npts)) 
        call cdf_write(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:4))
        call cdf_write(icdf,'sig',sig_table(1:npts)) 
        call cdf_close(icdf)  
        deallocate(e_axis)
        call cdf_open(icdf,trim(filename),'r',fErr)
     endif
     !tables already computed, read data 
     call cdfInqVar(icdf,'sig',idims,nctype)
     npts=idims(1)
     if(allocated(sig_table))deallocate(sig_table)
     allocate(sig_table(npts))
     call cdf_read(icdf, 'sig',sig_table(1:npts))
     call cdfInqVar(icdf,'axis_param_coldTarget',idims,nctype)
     call cdf_read(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:idims(1))) 
     call cdf_close(icdf)
     !interpolate 1D table
     xlr=log(axis_param_coldTarget(2)/axis_param_coldTarget(1))
     call FLIN1_Z(evec,sig_adas_wrk,n1,sig_table,axis_param_coldTarget(1),axis_param_coldTarget(2),&
          &xlr,npts,iwarn_adas)
     if(n_use.eq.2) then
        sig_adas=sig_adas+abs(zion-izi(n_use-iz+1))*sig_adas_wrk/2.
     elseif(n_use.eq.1) then
        sig_adas=zion/izi(1)*sig_adas_wrk !scale to Zimp >10 (for H beam) or to Zimp >8 (for He beam)
     endif
  enddo !iz

end subroutine adas_sig_int_r8
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sigv_int_int(freact_type,evec,n1,izneut,izion,sigv_adas,istat)
!
!this subroutine calculates sig*v for neutralizing charge-exchange reaction using ADAS data
!and impact ionization which includes  non-neutralizing charge-exchange reaction using ADAS data
!
  integer, intent(in) :: freact_type    !reaction type: 1  ='CX', 2 = 'II'
  integer, intent(in) :: izneut  !atomic charge of primary   particle {1, 2}
  integer, intent(in) :: izion  !atomic charge of secondary particle {1, ..., 10}
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
 real(fp) :: zion  !atomic charge of secondary particle {1, ..., 10}
  zion=dble(izion)
  call adas_sigv_int_r8(freact_type,evec,n1,izneut,zion,sigv_adas,istat)
end subroutine adas_sigv_int_int
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sigv_r8_int(freact_type,evec,n1,zneut,izion,sigv_adas,istat)
!
!this subroutine calculates sig*v for neutralizing charge-exchange reaction using ADAS data
!and impact ionization which inclides  non-neutralizing charge-exchange reaction using ADAS data
!
  integer, intent(in) :: freact_type    !reaction type: 1  ='CX', 2 = 'II'
  real(fp), intent(in) :: zneut  !atomic charge of primary   particle {1, 2}
  integer, intent(in) :: izion  !atomic charge of secondary particle {1, ..., 10}
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  integer :: izneut  !atomic charge of primary   particle {1, 2}
  real(fp) ::zion
  zion=dble(izion)
  izneut=zneut
  call adas_sigv_int_r8(freact_type,evec,n1,izneut,zion,sigv_adas,istat)
end subroutine adas_sigv_r8_int
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sigv_r8_r8(freact_type,evec,n1,zneut,zion,sigv_adas,istat)
!
!this subroutine calculates sig*v for neutralizing charge-exchange reaction using ADAS data
!and impact ionization which inclides  non-neutralizing charge-exchange reaction using ADAS data
!
  integer, intent(in) :: freact_type    !reaction type: 1  ='CX', 2 = 'II'
  real(fp), intent(in) :: zneut  !atomic charge of primary   particle {1, 2}
  real(fp), intent(in) :: zion  !atomic charge of secondary particle {1, ..., 10}
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
 integer :: izneut  !atomic charge of primary   particle {1, 2}
  izneut=zneut
  call adas_sigv_int_r8(freact_type,evec,n1,izneut,zion,sigv_adas,istat)
end subroutine adas_sigv_r8_r8
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sigv_int_r8(freact_type,evec,n1,izneut,zion,sigv_adas,istat)
!
!this subroutine calculates sig*v for neutralizing charge-exchange reaction using ADAS data
!and impact ionization which inclides  non-neutralizing charge-exchange reaction using ADAS data
!
!  use sigprep_mod
  integer, intent(in) :: freact_type    !reaction type: 1  ='CX', 2 = 'II'
  integer, intent(in) :: izneut  !atomic charge of primary   particle {1, 2}
  real(fp), intent(in) :: zion  !atomic charge of secondary particle {1, ..., 10}
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  INTEGER :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  INTEGER, parameter :: ikey=1 !key for the
                               ! KEY=1 FOR THERMONUCLEAR <SIGMA*V>
                               ! key  = 2  for FOR BEAM TARGET <sig*v>
                               ! key  = 3 for <E/A>
                               ! key = 4 for <fd>
                               ! key = 5  TRANSP BEAM BEAM GYRO INTEGRALS  See: preact/comptabl_z.for
!
  real(fp) vrel                  ! relative velocity [m/sec]
  real(fp) eevec                 ! energy vector
  real(fp) sigall_z
  integer i,iz
  integer, parameter :: tape   = 74
  character*2, dimension(2)   :: react_type=(/'cx','ii'/)
  real(fp), dimension(:),pointer :: e_axis ! axis grid
  real(fp),dimension(:),allocatable :: sigv_table ! tabulated sig*v  
  integer :: iZI(2),n_use !iZi - integer Zimp used to calculate sigv, n_use - 
                         !number of tables to be used, could be 1 or 2
  real(fp), dimension(n1) :: sigv_adas_wrk !work array sigma*v [m**3/sec]
  character*240 :: filename, filename_param    ! filename
  real(fp),SAVE,dimension(4,2) :: axis_param_coldTarget_prev !axis parameters(E[KeV/amu]) for table: 
                                                !min, max values, number of points,
                                                !specification 0 for LOG, 1 for LIN
!
!checking input data for availability
  istat=0
  call check_data_react(freact_type,1,izneut,zion,iZI,n_use,istat)
  sigv_adas=0._fp
  sigv_adas_wrk=0._fp
  if(istat.gt.0) then !some error in input data, do not proceed
     return
  endif
  
        
  write(cizneut,'(i5)') izneut
  do iz=1, n_use
     write(cizion,'(i5)') izi(iz)
     ! create table's filename
     !
     adas_tables_file=trim('tables/')//trim(react_type(freact_type))//&
          &'/'//trim(react_type(freact_type))//'_'//&
          & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'_'//'coldTarget.cdf'
     !
     call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename)
     if(trim(adjustl(filename_prev(iz))).ne.trim(adjustl(filename))) then
     !
     ! try to open filename in tables directory
     call cdf_open(icdf,trim(filename),'r',fErr)
     
     if (fErr.ne.0) then !no table has been created
        write(6,*)' %adas_sigv: OK table data being recomputed'
        
        !compute and write table         
        !open file and read axis parameters
        ilen=len(trim(filename))
        filename_param= filename(1:ilen-14)//trim('tableParameters.cdf')
        call cdf_open(icdf,trim(filename_param),'r',fErr)
        if (fErr.ne.0) then 
           write(6,*)' %adas_sigv: OK trying to read dummy data'
           !tables have not been initialized, try to read dummy data
           call UFILNAM('ADASDIR',trim('tables/')//trim(react_type(freact_type))//&
                &'/'//'tableParameters.cdf',filename_param)
           call cdf_open(icdf,trim(filename_param),'r',fErr)
           if(ferr.gt.0) then
              write(6,*)' !adas_sigv: faild to read table data'
              istat = 10
              return
           endif
        endif
        call cdfInqVar(icdf,'axis_param_coldTarget',idims,nctype)
        call cdf_read(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:idims(1)))
        call cdf_close(icdf)
        !
        call compute_axis(e_axis,axis_param_coldTarget)
        !     
        npts=int(axis_param_coldTarget(3))
        if(allocated(sigv_table))deallocate(sigv_table)
        allocate(sigv_table(npts))
        sigv_table=0.0_fp
        ! set reaction key
        if(freact_type.eq.1) then !CX
           fadas_CX=4 ! converted to adas_ion routine for neutralizing CX 
           call sigprep_adas_z(fadas_CX,izneut,izi(iz),ikey)
           do i=1,npts
              eevec=e_axis(i)
              sigv_table(i)=sigall_z(eevec,vrel)*vrel
           enddo
        elseif(freact_type.eq.2) then !II
           fadas_II=5 ! converted to adas_ion routine for total ionizataions
           call sigprep_adas_z(fadas_II,izneut,izi(iz),ikey)
           do i=1,npts
              eevec=e_axis(i)
              sigv_table(i)=sigall_z(eevec,vrel)*vrel
           enddo
        endif
        call cdf_open(icdf,trim(filename),'w',fErr)
        call cdf_define(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:4)) 
        call cdf_define(icdf,'sigv',sigv_table(1:npts)) 
        call cdf_write(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:4))
        call cdf_write(icdf,'sigv',sigv_table(1:npts)) 
        call cdf_close(icdf)  
        deallocate(e_axis)
        call cdf_open(icdf,trim(filename),'r',fErr)
     endif
     
     !tables already computed, read data 
     call cdfInqVar(icdf,'sigv',idims,nctype)
     npts=idims(1)
     if(allocated(sigv_table))deallocate(sigv_table)
     allocate(sigv_table(npts))
     call cdf_read(icdf, 'sigv',sigv_table(1:npts))
     call cdfInqVar(icdf,'axis_param_coldTarget',idims,nctype)
     call cdf_read(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:idims(1))) 
     call cdf_close(icdf)
     filename_prev(iz)=filename
     axis_param_coldTarget_prev(:,iz)=axis_param_coldTarget(:)
     npts_prev(iz)=npts
     
     if(allocated(sigv_table_prev)) then
        if(size(sigv_table_prev,dim=2).ge.iz) then
           if(size(sigv_table_prev(:,iz)).lt.npts) then
              if(iz.eq.1) then
                 deallocate(sigv_table_prev)
                 allocate(sigv_table_prev(npts,n_use))
                 sigv_table_prev=0.0_fp
              else ! extend
                 call extend(iz,n_use)
              endif
           endif
        else
           call extend(iz,n_use)
        endif
     else
        allocate(sigv_table_prev(npts,n_use))
     endif
     sigv_table_prev(1:npts,iz)=sigv_table(1:npts)
  else
     npts=npts_prev(iz)
     if(allocated(sigv_table)) then
        if(size(sigv_table).ne.npts) then
           deallocate(sigv_table)
           allocate(sigv_table(npts))
        endif
     else
        allocate(sigv_table(npts))
     endif
     sigv_table(1:npts)=sigv_table_prev(1:npts,iz)
     axis_param_coldTarget(:)=axis_param_coldTarget_prev(:,iz)
 endif
     !interpolate 1D table
     xlr=log(axis_param_coldTarget(2)/axis_param_coldTarget(1))
     call FLIN1_Z(evec,sigv_adas_wrk,n1,sigv_table,axis_param_coldTarget(1),axis_param_coldTarget(2),&
          &xlr,npts,iwarn_adas)
     if(n_use.eq.2) then
        sigv_adas=sigv_adas+abs(zion-izi(n_use-iz+1))*sigv_adas_wrk/2.
     elseif(n_use.eq.1) then
        sigv_adas=zion/izi(1)*sigv_adas_wrk !scale to Zimp >10 (for H beam) or to Zimp >8 (for He beam)
     endif
  enddo !iz

  
end subroutine adas_sigv_int_r8
!
!---------------------------------------------------------------------
!
subroutine adas_zstop_sigvz_int_int(izneut,izion,evec,n1,sigv_adas,istat)
!
!this subroutine calculates sig*v tables for impurity stopping 
!on fully stripped light impurities (vs. Erel only) using ADAS data
!as a sum of sig*v for ionization (includes non-neutralazing CX) and neuralazing CX reactions.
!
  integer, intent(in) :: izneut  !atomic charge of primary   particle {1, 2} and
  integer, intent(in) :: izion     !atomic charge of secondary particle {1, ..., 10}
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  integer, intent(out) :: istat
  real(fp) :: zion     !atomic charge of secondary particle {1, ..., 10}
  zion=dble(izion)
  call adas_zstop_sigvz_int_r8(izneut,zion,evec,n1,sigv_adas,istat)
end subroutine adas_zstop_sigvz_int_int
!
!---------------------------------------------------------------------
!
subroutine adas_zstop_sigvz_r8_int(zneut,izion,evec,n1,sigv_adas,istat)
!
!this subroutine calculates sig*v tables for for impurity stopping 
!on fully stripped light impurities (vs. Erel only) using ADAS data
!as a sum of sig*v for ionization (includes non-neutralazing CX) and neuralazing CX reactions.
!
  real(fp), intent(in) :: zneut  !atomic charge of primary   particle {1, 2} and
  integer, intent(in) :: izion     !atomic charge of secondary particle {1, ..., 10}
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  integer, intent(out) :: istat
  real(fp) :: zion     !atomic charge of secondary particle {1, ..., 10}
  integer :: izneut  !atomic charge of primary   particle {1, 2} and
  zion=dble(izion)
  izneut=zneut
  call adas_zstop_sigvz_int_r8(izneut,zion,evec,n1,sigv_adas,istat)
end subroutine adas_zstop_sigvz_r8_int
!
!---------------------------------------------------------------------
!
subroutine adas_zstop_sigvz_r8_r8(zneut,zion,evec,n1,sigv_adas,istat)
!
!this subroutine calculates sig*v tables for for impurity stopping 
!on fully stripped light impurities (vs. Erel only) using ADAS data
!as a sum of sig*v for ionization (includes non-neutralazing CX) and neuralazing CX reactions.
!
  real(fp), intent(in) :: zneut  !atomic charge of primary   particle {1, 2} and
  real(fp), intent(in) :: zion     !atomic charge of secondary particle {1, ..., 10}
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  integer, intent(out) :: istat
  integer :: izneut  !atomic charge of primary   particle {1, 2} and
  izneut=zneut
  call adas_zstop_sigvz_int_r8(izneut,zion,evec,n1,sigv_adas,istat)
end subroutine adas_zstop_sigvz_r8_r8
!
!---------------------------------------------------------------------
!
subroutine adas_zstop_sigvz_int_r8(izneut,zion,evec,n1,sigv_adas,istat)
!
!this subroutine calculates sig*v tables for for impurity stopping 
!on fully stripped light impurities (vs. Erel only) using ADAS data
!as a sum of sig*v for ionization (includes non-neutralazing CX) and neuralazing CX reactions.
!
!  use sigprep_mod
  integer, intent(in) :: izneut  !atomic charge of primary   particle {1, 2} and
  real(fp), intent(in) :: zion     !atomic charge of secondary particle {1, ..., 10}
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  integer, intent(in) :: n1 !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
!
  integer :: freact_type  ! reaction type
  real(fp), dimension(:),pointer :: e_axis ! axis grid
  real(fp), dimension(:),allocatable :: sigv_table ! tabulated sig*v  
  real(fp), dimension(:),allocatable :: sigv_table_wrk ! wrk. tabulated sig*v  
  integer, intent(out) :: istat
  INTEGER ::  iz
                                !  istat = 10:  ADAS data is requested but not found
  integer :: iZI(2),n_use !iZi - integer Zimp used to calculate sigv, n_use - 
                         !number of tables to be used, could be 1 or 2
  real(fp), dimension(n1) :: sigv_adas_wrk !sigma*v [m**3/sec]
  character*240 :: filename, filename_param    ! filename
  real(fp),SAVE,dimension(4,2) :: axis_param_coldTarget_prev !axis parameters(E[KeV/amu]) for table: 
                                                !min, max values, number of points,
                                                !specification 0 for LOG, 1 for LIN
!
!checking input data for availability
  istat=0
  call check_data_react(2,1,izneut,zion,iZI,n_use,istat)
  sigv_adas=0._fp
  sigv_adas_wrk=0._fp
  if(istat.gt.0) then !some error in input data, do not proceed
     return
  endif
  write(cizneut,'(i5)') izneut
  do iz=1,n_use
     write(cizion,'(i5)') izi(iz)
     !
     ! create table's filename
     adas_tables_file=trim('tables/sv/sv')//'_'//&
          & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'_'//'coldTarget.cdf'
     call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename)
     if(trim(adjustl(filename_prev(iz))).ne.trim(adjustl(filename))) then
     !
     ! try to open filename in tables directory
     call cdf_open(icdf,trim(filename),'r',fErr)
     if (fErr.ne.0) then !no table has been created
        write(6,*)' %adas_zstop_sigvz: OK table data being recomputed'
        ilen=len(trim(filename))
        filename_param= filename(1:ilen-14)//trim('tableParameters.cdf')
        call cdf_open(icdf,trim(filename_param),'r',fErr)
        if (fErr.ne.0) then 
           write(6,*)' %adas_zstop_sigvz: OK trying to read dummy data'
           !tables have not been initialized, try to read dummy data
           call UFILNAM('ADASDIR',trim('tables/sv/tableParameters.cdf'),filename_param)
           call cdf_open(icdf,trim(filename_param),'r',fErr)
           if(ferr.gt.0) then
              write(6,*)' !adas_zstop_sigvz: faild to read table data'
              istat = 10
              return
           endif
        endif
        call cdfInqVar(icdf,'axis_param_coldTarget',idims,nctype)
        call cdf_read(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:idims(1)))
        call cdf_close(icdf)
        
        call compute_axis(e_axis,axis_param_coldTarget)
        
        npts=int(axis_param_coldTarget(3))
        if(allocated(sigv_table))deallocate(sigv_table)
        allocate(sigv_table(npts))
        if(allocated(sigv_table_wrk))deallocate(sigv_table_wrk)
        allocate(sigv_table_wrk(npts))
        sigv_table=0.0_fp
        sigv_table_wrk=0._fp
        freact_type=1 !CX reaction
        iopen_file=0 
        call adas_sigv(freact_type,e_axis,npts,izneut,dble(izi(iz)),sigv_table,istat)
        iopen_file=iopen_file+istat !iopen_file <4 means that tables are opened
        freact_type=2 !II reaction
        call adas_sigv(freact_type,e_axis,npts,izneut,dble(izi(iz)),sigv_table_wrk,istat)
        iopen_file=iopen_file+istat !iopen_file <4 means that tables are opened
        sigv_table=sigv_table+sigv_table_wrk !stopping rate= CX+II
        if(iopen_file.gt.3) then !errors appear in both part: CX and II. => sigv_table=0
           !do not open table
           sigv_adas=0._fp
           return
        endif
        call cdf_open(icdf,trim(filename),'w',fErr)
        call cdf_define(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:4)) 
        call cdf_define(icdf,'sigv',sigv_table(1:npts)) 
        call cdf_write(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:4))
        call cdf_write(icdf,'sigv',sigv_table(1:npts)) 
        call cdf_close(icdf)  
        deallocate(e_axis)
        call cdf_open(icdf,trim(filename),'r',fErr)
     endif
     !tables already computed, read data 
     call cdfInqVar(icdf,'sigv',idims,nctype)
     npts=idims(1)
     if(allocated(sigv_table))deallocate(sigv_table)
     allocate(sigv_table(npts))
     call cdf_read(icdf, 'sigv',sigv_table(1:npts))
     call cdfInqVar(icdf,'axis_param_coldTarget',idims,nctype)
     call cdf_read(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:idims(1))) 
     call cdf_close(icdf)
     filename_prev(iz)=filename
     axis_param_coldTarget_prev(:,iz)=axis_param_coldTarget(:)
     npts_prev(iz)=npts

     if(allocated(sigv_table_prev)) then
        if(size(sigv_table_prev,dim=2).ge.iz) then
           if(size(sigv_table_prev(:,iz)).lt.npts) then
              if(iz.eq.1) then
                 deallocate(sigv_table_prev)
                 allocate(sigv_table_prev(npts,n_use))
                 sigv_table_prev=0.0_fp
              else ! extend
                 call extend(iz,n_use)
              endif
           endif
        else
           call extend(iz,n_use)
        endif
     else
        allocate(sigv_table_prev(npts,n_use))
     endif
     sigv_table_prev(1:npts,iz)=sigv_table(1:npts)
  else
     npts=npts_prev(iz)
     if(allocated(sigv_table)) then
        if(size(sigv_table).ne.npts) then
           deallocate(sigv_table)
           allocate(sigv_table(npts))
        endif
     else
        allocate(sigv_table(npts))
     endif
     sigv_table(1:npts)=sigv_table_prev(1:npts,iz)
     axis_param_coldTarget(:)=axis_param_coldTarget_prev(:,iz)
  endif
     
     !interpolate 1D table
     xlr=log(axis_param_coldTarget(2)/axis_param_coldTarget(1))
     call FLIN1_Z(evec,sigv_adas_wrk,n1,sigv_table,axis_param_coldTarget(1),axis_param_coldTarget(2),&
          &xlr,npts,iwarn_adas)
     if(n_use.eq.2) then
        sigv_adas=sigv_adas+abs(zion-izi(n_use-iz+1))*sigv_adas_wrk/2.
     elseif(n_use.eq.1) then
        sigv_adas=zion/izi(1)*sigv_adas_wrk !scale to Zimp >10 (for H beam) or to Zimp >8 (for He beam)
     endif
  enddo !iz
  
end subroutine adas_zstop_sigvz_int_r8
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_btsigv_int_int(freact_type,beamchrg,evec,tevec,n1,izneut_in,izion_in,sigv_adas,istat)
!this subroutine calculates maxwellian average <sig*v> for CX and II reactions
  integer, intent(in) :: freact_type    !reaction type: 1 -- "CX" and 2  -- 'II'
  integer, intent(in) :: izneut_in        !     izneut       : atomic charge of primary   particle {1, 2}
  integer, intent(in) :: izion_in           !     izion        : atomic charge of secondary particle {1, ..., 10}

  INTEGER :: istat  ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  real(fp), dimension(n1), intent(in) :: tevec !vector temperature [KeV]
  integer, intent(in) :: n1  !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  integer, intent(in) :: beamchrg ! beam type: =neutral or =ion
  real(fp) :: zion_in  
  zion_in=dble(izion_in)
  call adas_btsigv_int_r8(freact_type,beamchrg,evec,tevec,n1,izneut_in,zion_in,sigv_adas,istat)
end subroutine adas_btsigv_int_int
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_btsigv_r8_r8(freact_type,beamchrg,evec,tevec,n1,zneut_in,zion_in,sigv_adas,istat)
!this subroutine calculates maxwellian average <sig*v>
  integer, intent(in) :: freact_type    !reaction type: 1 -- "CX" and 2  -- 'II'
  real(fp), intent(in) :: zneut_in        !     izneut       : atomic charge of primary   particle {1, 2}
  real(fp), intent(in) :: zion_in           !     izion        : atomic charge of secondary particle {1, ..., 10}

  INTEGER :: istat  ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  real(fp), dimension(n1), intent(in) :: tevec !vector temperature [KeV]
  integer, intent(in) :: n1  !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  integer, intent(in) :: beamchrg ! beam type: =neutral or =ion
  integer :: izneut_in        !     izneut       : atomic charge of primary   particle {1, 2}
  izneut_in=zneut_in
  call adas_btsigv_int_r8(freact_type,beamchrg,evec,tevec,n1,izneut_in,zion_in,sigv_adas,istat)
end subroutine adas_btsigv_r8_r8
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_btsigv_r8_int(freact_type,beamchrg,evec,tevec,n1,zneut_in,izion_in,sigv_adas,istat)
!this subroutine calculates maxwellian average <sig*v>
  integer, intent(in) :: freact_type    !reaction type: 1 -- "CX" and 2  -- 'II'
  real(fp), intent(in) :: zneut_in        !     izneut       : atomic charge of primary   particle {1, 2}
  integer, intent(in) :: izion_in           !     izion        : atomic charge of secondary particle {1, ..., 10}

  INTEGER :: istat  ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  real(fp), dimension(n1), intent(in) :: tevec !vector temperature [KeV]
  integer, intent(in) :: n1  !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  integer, intent(in) :: beamchrg ! beam type: =neutral or =ion
  integer :: izneut_in        !     izneut       : atomic charge of primary   particle {1, 2}
  real(fp) :: zion_in
  izneut_in=zneut_in
  zion_in=dble(izion_in)
  call adas_btsigv_int_r8(freact_type,beamchrg,evec,tevec,n1,izneut_in,zion_in,sigv_adas,istat)
end subroutine adas_btsigv_r8_int
!
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_btsigv_int_r8(freact_type,beamchrg,evec,tevec,n1,izneut_in,zion_in,sigv_adas,istat)
!this subroutine calculates maxwellian average <sig*v>
!  use sigprep_mod
  integer, intent(in) :: freact_type    !reaction type: 1 -- "CX" and 2  -- 'II'
  integer, intent(in) :: izneut_in        !     izneut       : atomic charge of primary   particle {1, 2}
  real(fp), intent(in) :: zion_in           !     izion        : atomic charge of secondary particle {1, ..., 10}

  INTEGER :: istat  ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
                                !  istat = 10:  ADAS data is requested but not found
  real(fp), dimension(n1), intent(in) :: evec !vector energy [KeV/amu]
  real(fp), dimension(n1), intent(in) :: tevec !vector temperature [KeV]
  integer, intent(in) :: n1  !vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  integer, intent(in) :: beamchrg ! beam type: =neutral or =ion
!
  integer, parameter :: NEUTRAL=1, ION=2
  integer :: izneut        !     izneut       : atomic charge of primary   particle {1, 2}
  real(fp)  :: zion          !     izion        : atomic charge of secondary particle {1, ..., 10}
  INTEGER, parameter :: ikey=2 !key for the
                               ! KEY=1 FOR THERMONUCLEAR <SIGMA*V>
                               ! key  = 2  for FOR BEAM TARGET <sig*v>
                               ! key  = 3 for <E/A>
                               ! key = 4 for <fd>
                               ! key = 5  TRANSP BEAM BEAM GYRO INTEGRALS  See: preact/comptabl_z.for
  character*2, dimension(2)   :: react_type=(/'cx','ii'/)
  integer :: npts_e, npts_t ! number of points for table
  real(fp), dimension(:,:),allocatable :: sigv_table     ! tabulated sig*v  
  integer i, ier, iz
  real(fp), dimension(:),pointer :: e_axis,t_axis ! axis grid
  real(fp), dimension(:),allocatable :: wrk ! work array
  real(fp) :: xlr_t ! If XLR>0, then the X grid is equally spaced on a logarithmic scale:
                  ! LINEAR IF XLR .LE. 0.0
  integer :: iZI(2),n_use !iZi - integer Zimp used to calculate sigv, n_use - 
                         !number of tables to be used, could be 1 or 2
  real(fp), dimension(n1) :: sigv_adas_wrk !sigma*v [m**3/sec]
  character*240 :: filename, filename_param    ! filename
!
!checking input data for availability
  istat=0
  sigv_adas=0._fp
  sigv_adas_wrk=0._fp
  if(beamchrg.eq.NEUTRAL) then
     !  ---------> Neutral Beam, charged particle target
     
     izneut = izneut_in
     zion = zion_in
     
  else if(beamchrg.eq.ION) then
     izneut = zion_in
     zion = dble(izneut_in)
     
  else
     
     istat = 1
     return
     
  endif
 
  call check_data_react(freact_type,beamchrg,izneut,zion,iZI,n_use,istat)
  if(istat.gt.0) then !some error in input data, do not proceed
     return
  endif
  write(cizneut,'(i5)') izneut
  do iz=1,n_use
     write(cizion,'(i5)') izi(iz)
     !
     ! create table's filename
     adas_tables_file=trim('tables/')//trim(react_type(freact_type))//&
          &'/'//trim(react_type(freact_type))//'_'//&
          & trim(adjustl(cizneut))//'_'//trim(adjustl(cizion))//'_'//'warmTarget.cdf'
     !
     call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename)
     !
     ! try to open filename in tables directory
     call cdf_open(icdf,trim(filename),'r',fErr)
     !   
     if (fErr.ne.0) then !no table has been created
        write(6,*)' %adas_btsigv: OK table data being recomputed'
        !compute and write table         
        !open file and read axis parameters
        ilen=len(trim(filename))
        filename_param= filename(1:ilen-14)//trim('tableParameters.cdf')
        call cdf_open(icdf,trim(filename_param),'r',fErr)
        if (fErr.ne.0) then 
           !tables have not been initialized, try to read dummy data
           write(6,*)' %adas_btsigv: OK trying to read dummy data'
           call UFILNAM('ADASDIR',trim('tables/')//trim(react_type(freact_type))//&
                &'/'//'tableParameters.cdf',filename_param)
           call cdf_open(icdf,trim(filename_param),'r',fErr)
           if(ferr.gt.0) then
              write(6,*)' !adas_btsigv: faild to read table data'
              istat = 10
              return
           endif
        endif
        call cdfInqVar(icdf,'axis_param_warmTarget',idims,nctype)
        call cdf_read(icdf,'axis_param_warmTarget',axis_param_warmTarget(1:idims(1)))
        call cdf_close(icdf)
        !compute axis
!        write(*,*)'  %adas_btsigv : computing tables: ',trim(adas_tables_file)
        call compute_axis(e_axis,axis_param_warmTarget(1:4))
        call compute_axis(t_axis,axis_param_warmTarget(5:8))
        !     
        npts_e=int(axis_param_warmTarget(3))
        npts_t=int(axis_param_warmTarget(7))
        if(allocated(sigv_table))deallocate(sigv_table)
        allocate(sigv_table(npts_e,npts_t))
        if(allocated(wrk))deallocate(wrk)
        allocate(wrk(npts_e))
        sigv_table=0.0_fp
        wrk=0.0_fp
        ! set reaction key
        if(freact_type.eq.1) then !CX
           fadas_CX=4 ! converted to adas_ion routine for neutralizing CX 
           call sigprep_adas_z(fadas_CX,izneut,izi(iz),ikey)
           call comptabl_z(wrk,sigv_table,e_axis,t_axis,npts_e,npts_t,ier)
           
        elseif(freact_type.eq.2) then !II
           fadas_II=5 ! converted to adas_ion routine for total ionizataion
           call sigprep_adas_z(fadas_II,izneut,izi(iz),ikey)
           call comptabl_z(wrk,sigv_table,e_axis,t_axis,npts_e,npts_t,ier)
        endif
        call cdf_open(icdf,trim(filename),'w',fErr)
        call cdf_define(icdf,'axis_param_warmTarget',axis_param_warmTarget(1:8)) 
        call cdf_define(icdf,'btsigv',sigv_table(1:npts_e,1:npts_t)) 
        call cdf_write(icdf,'axis_param_warmTarget',axis_param_warmTarget(1:8))
        call cdf_write(icdf,'btsigv',sigv_table(1:npts_e,1:npts_t)) 
        call cdf_close(icdf)  
        deallocate(e_axis,t_axis)
        call cdf_open(icdf,trim(filename),'r',fErr)
     endif
     
     !tables already computed, read data 
     call cdfInqVar(icdf,'btsigv',idims,nctype)
     npts_e=idims(1)
     npts_t=idims(2)
     if(allocated(sigv_table))deallocate(sigv_table)
     allocate(sigv_table(npts_e,npts_t))
     call cdf_read(icdf, 'btsigv',sigv_table(1:npts_e,1:npts_t))
     call cdfInqVar(icdf,'axis_param_warmTarget',idims,nctype)
     call cdf_read(icdf,'axis_param_warmTarget',axis_param_warmTarget(1:idims(1))) 
     call cdf_close(icdf)
     !interpolate 2D table
     xlr=log(axis_param_warmTarget(2)/axis_param_warmTarget(1))
     xlr_t=log(axis_param_warmTarget(6)/axis_param_warmTarget(5))
     call FLINT_Z(evec,tevec,sigv_adas_wrk,n1,sigv_table,axis_param_warmTarget(1),axis_param_warmTarget(2),&
          &xlr,npts_e,axis_param_warmTarget(5),axis_param_warmTarget(6),&
          &xlr_t,npts_t,iwarn_adas)
     if(n_use.eq.2) then
        sigv_adas=sigv_adas+abs(zion-izi(n_use-iz+1))*sigv_adas_wrk/2.
     elseif(n_use.eq.1) then
        sigv_adas=zion/izi(1)*sigv_adas_wrk !scale to Zimp >10 (for H beam) or to Zimp >8 (for He beam)
     endif
  enddo !iz
  
end subroutine adas_btsigv_int_r8
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sigvte_ioniz_r8(zneut,tevec,n1,sigv_adas,istat)
! calculates <sig*v> electron impact ionization
  real(fp), intent(in) :: zneut                   ! atomic charge of primary   particle {1}, available only for H
  real(fp), dimension(n1), intent(in) :: tevec      ! vector electron temperature [KeV]
  integer, intent(in) :: n1                       ! vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
  integer, intent(out) :: istat
  integer :: izneut
  izneut=zneut
  call adas_sigvte_ioniz_int(izneut,tevec,n1,sigv_adas,istat)
end subroutine adas_sigvte_ioniz_r8
!
!-----------------------------------------------------------------------------------------
!
subroutine adas_sigvte_ioniz_int(izneut,tevec,n1,sigv_adas,istat)
! calculates <sig*v> electron impact ionization
  integer, intent(in) :: izneut                   ! atomic charge of primary   H and He
  real(fp), dimension(n1), intent(in) :: tevec      ! vector electron temperature [KeV]
  integer, intent(in) :: n1                       ! vector's size
  real(fp), dimension(n1), intent(out) :: sigv_adas !sigma*v [m**3/sec]
!local
  character*2 :: react_type='ei'
  real(fp), dimension(:),pointer :: t_axis ! axis grid
  integer :: ier 
  integer, intent(out) :: istat
  real(fp), dimension(:),allocatable :: sigv_table ! tabulated sig*v  
  character*240 :: filename, filename_param    ! filename
!
!check input data
  istat = 0
  sigv_adas=0._fp
  if(izneut.gt.2) then !error in input data, do not proceed
     istat = 1
     return
  endif
  write(cizneut,'(i5)') izneut
  ! create table's filename
  !
  adas_tables_file=trim('tables/')//trim(react_type)//&
       &'/'//trim(react_type)//'_'//&
       & trim(adjustl(cizneut))//'_'//'coldTarget.cdf'
  !
  call UFILNAM('ADASDIR',trim(adjustl(adas_tables_file)),filename)
  if(trim(adjustl(filename_prev(1))).ne.trim(adjustl(filename))) then
  !
  ! try to open filename in tables directory
  call cdf_open(icdf,trim(filename),'r',fErr)
  
  if (fErr.ne.0) then !no table has been created
     write(6,*)' %adas_sigvte_ioniz: OK table data being recomputed'
     !compute and write table         
     !open file and read axis parameters
     ilen=len(trim(filename))
     filename_param= filename(1:ilen-14)//trim('tableParameters.cdf')
     call cdf_open(icdf,trim(filename_param),'r',fErr)
     if (fErr.ne.0) then 
        write(6,*)' %adas_sigvte_ioniz: trying to read dummy data'
        !tables have not been initialized, try to read dummy data
        call UFILNAM('ADASDIR',trim('tables/')//trim(react_type)//&
             &'/'//'tableParameters.cdf',filename_param)
        call cdf_open(icdf,trim(filename_param),'r',fErr)
        if(ferr.gt.0) then
           write(6,*)' %adas_sigvte_ioniz: faild to read table data'
           istat = 10
           return
        endif
     endif
     call cdfInqVar(icdf,'axis_param_coldTarget',idims,nctype)
     call cdf_read(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:idims(1)))
     call cdf_close(icdf)
     !compute axis
     call compute_axis(t_axis,axis_param_coldTarget)
     !     
     npts=int(axis_param_coldTarget(3))
     if(allocated(sigv_table))deallocate(sigv_table)
     allocate(sigv_table(npts))
     sigv_table=0.0_fp
     if(izneut.eq.1) then
        call adas_ei_h(t_axis,npts,sigv_table,ier)
     elseif(izneut.eq.2) then
        call adas_ei_he(t_axis,npts,sigv_table,ier)
     endif

!write table to file
     call cdf_open(icdf,trim(filename),'w',fErr)
     call cdf_define(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:4)) 
     call cdf_define(icdf,'sigv',sigv_table(1:npts)) 
     call cdf_write(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:4))
     call cdf_write(icdf,'sigv',sigv_table(1:npts)) 
     call cdf_close(icdf)  
     deallocate(t_axis)
     call cdf_open(icdf,trim(filename),'r',fErr)
  endif
  !tables already computed, read data 
  call cdfInqVar(icdf,'sigv',idims,nctype)
  npts=idims(1)
  if(allocated(sigv_table))deallocate(sigv_table)
  allocate(sigv_table(npts))
  call cdf_read(icdf, 'sigv',sigv_table(1:npts))
  call cdfInqVar(icdf,'axis_param_coldTarget',idims,nctype)
  call cdf_read(icdf,'axis_param_coldTarget',axis_param_coldTarget(1:idims(1))) 
  call cdf_close(icdf)
  filename_prev(1)=filename
  
  if(allocated(sigv_table_prev)) then
     if(size(sigv_table_prev(:,1)).ne.npts) then
        deallocate(sigv_table_prev)
        allocate(sigv_table_prev(npts,1))
        sigv_table_prev(:,1)=0.0_fp
     endif
  else
     allocate(sigv_table_prev(npts,1))
     sigv_table_prev(:,1)=0.0_fp
  endif
  sigv_table_prev(1:npts,1)=sigv_table(1:npts)
  else
     if(allocated(sigv_table)) then
        if(size(sigv_table).ne.npts) then
           deallocate(sigv_table)
           allocate(sigv_table(npts))
        endif
     else
        allocate(sigv_table(npts))
     endif
     sigv_table(1:npts)=sigv_table_prev(1:npts,1)
  endif
  
  !interpolate 1D table
  xlr=log(axis_param_coldTarget(2)/axis_param_coldTarget(1))
  call FLIN1_Z(tevec,sigv_adas,n1,sigv_table,axis_param_coldTarget(1),axis_param_coldTarget(2),&
       &xlr,npts,iwarn_adas)
     
end subroutine adas_sigvte_ioniz_int
!---------------------------------------------------------------------!
! adas_ei.f90:                                                        !
!     by Michael Kraus (michael.kraus@ipp.mpg.de)                     !
!     created 2009/06/24                                              !
!                                                                     !
!     reads H0 electron impact ionisation rate coefficients from adas    !
!     adf07 data tables applies spline interpolation within the data  !
!     range and logarithmic extrapolation beyond                      !
!                                                                     !!                                                                     !
!---------------------------------------------------------------------!
subroutine adas_ei_h(Te, N, SIGV, iErr)
      use EZspline_obj
      use EZspline
      
      implicit none

! Function Parameters
!
!     Te(N)    : electron temperature                            [KeV]
!     N        : number of temperature values
!     SIGV(N)  : requested rate coefficients                     [m**3/s]
!     iErr     : error code    (0 = OK,                          
!                               1 = temperature invalid
!                               2 = adas file reading error
!                               3 = spline error
!                               4 = 
!                              )
!
      integer :: N
      real(fp)  :: Te(N), SIGV(N)
      integer :: iErr
      
      
! Local Parameters
!
! maxn         : max number of entries per data table
!
! fte1(maxn)   : Te    from file (low  temperature part)
! fsigv1(maxn) : sigma from file (low  temperature part)
! fte2(maxn)   : Te    from file (high temperature part)
! fsigv2(maxn) : sigma from file (high temperature part)
! fte(2*maxn)  : Te    from file (accumulated data)
! fsigv(2*maxn): sigma from file (accumulated data)
! fn           : size of data table in file
! i, it, is    : loop indices
!
! sigv_ezspl   : EzSpline object for <sigmav>
! bcs_sigv     : boundary conditions for <sigmav> spline
! serr         : spline error code
!
! tape         : data file identifier adas archive file
! outdbg       : data file identifier debug output
! fErr         : file reading error code
! nsel         : number of tables in file
!
! adas_ei_data : atomic data archive file name (adf07)
! filename     : complete path of adas archive file
! line         : temporary string for file input
!
      integer, parameter :: maxn    = 25
      
      real(fp)  :: fte1(maxn),  fsigv1(maxn)
      real(fp)  :: fte2(maxn),  fsigv2(maxn)
      real(fp)  :: fte(2*maxn), fsigv(2*maxn)
      real(fp)  :: logfte(2*maxn), logfsigv(2*maxn)
      real(fp)  :: logSIGV(N)
      integer :: fn1, fn2, fn, fn1stop
      integer :: i, it, is
      
      type(EZspline1)    :: sigv_ezspl
      integer            :: bcs_sigv(2)
      integer            :: sErr
      
      integer, parameter :: tape   = 74
      integer, parameter :: outdbg = 75
      integer            :: fErr
      integer            :: nsel
      
      character*40,  parameter :: adas_ei_data = 'data/adf07/szd93#h/szd93#h_h.dat'
      character*240 :: filename
      character*80  :: line
      
      iErr = 0
      Te=Te*1.e+3_fp !convert to [eV]
      
! check if input data meets requirements and is valid
      ! check if collision energy is positive
      do i=1,N
         if (Te(i) .le. 0.0) then
            iErr = 1
            return
         endif
      enddo
      
      
! read data from archive (refer to ADAS adf21 file format documentation at [2])
      call UFILNAM('ADASDIR',adas_ei_data,filename)
      open(unit=tape,file=filename,action='read', iostat=fErr)
      ! check if file could be opened
      if (fErr .ne. 0) then
         iErr = 2
         return
      endif
      
      ! read number of tables in file
      read(tape,1000) nsel
      if (nsel .lt. 3) then
         iErr = 2
         return
      endif
      
     ! read first table (low temperature)
      read(tape,1001) fn1
      read(tape,1002) (fte1(it),it=1,fn1)
      read(tape,1002) (fsigv1(is),is=1,fn1)
      
      ! skip second table (very low temperature)
      do i=1,9
         read(tape,'(a)') line
      enddo
      
      ! read third table (high temperature)
      read(tape,1001) fn2
      read(tape,1002) (fte2(it),it=1,fn2)
      read(tape,1002) (fsigv2(is),is=1,fn2)
      
      close(tape) 
      
1000  format(i5)
1001  format(15x,i2)
1002  format(6(1x,E9.3E2),/,6(1x,E9.3E2))
      
      
      ! merge tables
      do i=1,fn1
         if (fte1(i) .ge. fte2(1)) then
            exit
         else
            fte(i)   = fte1(i)
            fsigv(i) = fsigv1(i)
         endif
      enddo
      fn1stop = i-1
      
      do i=1,fn2
         fte  (fn1stop+i) = fte2(i)
         fsigv(fn1stop+i) = fsigv2(i)
      enddo
      
      fn = fn1stop + fn2
      
      
      if (fn .lt. 3) then
         iErr = 2
         return
      endif
      
! output adas data for debugging
   
!      filename = "adas_ei_dbg.dat"
!      open(unit = outdbg, file = filename)
!      do i=1,fn
!         write(outdbg,'(5g20.10,5g20.10)') fte(i), fsigv(i)
!      enddo
!      close(unit = outdbg)
      
      
! calculate log of spline data
     do i=1,fn
         logfte(i)   = dlog(fte(i))
         logfsigv(i) = dlog(fsigv(i))
      enddo
      

! output log data for debugging
   
!      filename = "adas_ei_dbglog.dat"
!      open(unit = outdbg, file = filename)
!      do i=1,fn
!         write(outdbg,'(5g20.10,5g20.10)') logfte(i), logfsigv(i)
!      enddo
!      close(unit = outdbg)
      
      
! create EzSpline object and put data into it
      
      bcs_sigv = (/0, 0/)     ! not-a-knot boundary conditions
      
      call EZspline_init(sigv_ezspl, fn, bcs_sigv, sErr)    ! initialise spline object grid and boundary conditios
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 3
         return
      endif
      sigv_ezspl%x1 = logfte(1:fn)                          ! set grid points
      call EZspline_setup(sigv_ezspl, logfsigv(1:fn), sErr) ! initialise spline data
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 3
         return
      endif
      
      
! evaluate spline object with Erel values
      do i=1,N
         ! check if requested collision energy is within the available domain
         call EZspline_isInDomain(sigv_ezspl, dlog(te(i)), sErr)
!         call EZspline_error(sErr)
         if (sErr .eq. 0) then
            ! requested value in range, evaluate spline
            call EZspline_interp(sigv_ezspl, dlog(te(i)), logSIGV(i), sErr)
            call EZspline_error(sErr)
            if (sErr .ne. 0) then
               iErr = 3
               return
            endif
            SIGV(i) = dexp(logSIGV(i))
         else
            ! requested value out of range, extrapolate
            if (dlog(te(i)) .lt. sigv_ezspl%x1min) then
               logSIGV(i) = logfsigv(1) + (dlog(te(i)) - logfte(1))            &
               &                        / (logfte(2)   - logfte(1))            &
               &                        * (logfsigv(2) - logfsigv(1))
               SIGV(i) = exp(logSIGV(i))
            else if (dlog(te(i)) .gt. sigv_ezspl%x1max) then
               logSIGV(i) = logfsigv(fn) + (dlog(te(i))    - logfte(fn))       &
               &                         / (logfte(fn-1)   - logfte(fn))       &
               &                         * (logfsigv(fn-1) - logfsigv(fn))
               SIGV(i) = dexp(logSIGV(i))
            else
               iErr = 3
               return
            endif
         endif
      enddo

      SIGV=SIGV*1.e-6_fp !convert from cm**3/sec to m**3/sec
      
      return
end subroutine adas_ei_h
!---------------------------------------------------------------------!
! adas_ei.f90:                                                        !
!     by MG                  !
!     created 2012/05/08                                              !
!                                                                     !
!     reads He electron impact ionisation rate coefficients from adas    !
!     adf07 data tables applies spline interpolation within the data  !
!     range and logarithmic extrapolation beyond                      !
!                                                                     !!                                                                     !
!---------------------------------------------------------------------!
subroutine adas_ei_he(Te, N, SIGV, iErr)
      use EZspline_obj
      use EZspline
      
      implicit none

! Function Parameters
!
!     Te(N)    : electron temperature                            [KeV]
!     N        : number of temperature values
!     SIGV(N)  : requested rate coefficients                     [m**3/s]
!     iErr     : error code    (0 = OK,                          
!                               1 = temperature invalid
!                               2 = adas file reading error
!                               3 = spline error
!                               4 = 
!                              )
!
      integer :: N
      real(fp)  :: Te(N), SIGV(N)
      integer :: iErr
      
      
! Local Parameters
!
! maxn         : max number of entries per data table
!
! fte1(maxn)   : Te    from file (low  temperature part)
! fsigv1(maxn) : sigma from file (low  temperature part)
! fte2(maxn)   : Te    from file (high temperature part)
! fsigv2(maxn) : sigma from file (high temperature part)
! fte(2*maxn)  : Te    from file (accumulated data)
! fsigv(2*maxn): sigma from file (accumulated data)
! fn           : size of data table in file
! i, it, is    : loop indices
!
! sigv_ezspl   : EzSpline object for <sigmav>
! bcs_sigv     : boundary conditions for <sigmav> spline
! serr         : spline error code
!
! tape         : data file identifier adas archive file
! outdbg       : data file identifier debug output
! fErr         : file reading error code
! nsel         : number of tables in file
!
! adas_ei_data : atomic data archive file name (adf07)
! filename     : complete path of adas archive file
! line         : temporary string for file input
!
      integer, parameter :: maxn    = 25
      
      real(fp)  :: fte(maxn), fsigv(maxn)
      real(fp)  :: logfte(maxn), logfsigv(maxn)
      real(fp)  :: logSIGV(N)
      integer ::  fn
      integer :: i, it, is
      
      type(EZspline1)    :: sigv_ezspl
      integer            :: bcs_sigv(2)
      integer            :: sErr
      
      integer, parameter :: tape   = 74
      integer, parameter :: outdbg = 75
      integer            :: fErr
      integer            :: nsel
      
      character*40,  parameter :: adas_ei_data = 'data/adf07/szd93#he/szd93#he_he.dat'
      character*240 :: filename
      character*80  :: line
      
      iErr = 0
      Te=Te*1.e+3_fp !convert to [eV]
      
! check if input data meets requirements and is valid
      ! check if collision energy is positive
      do i=1,N
         if (Te(i) .le. 0.0) then
            iErr = 1
            return
         endif
      enddo
      
      
! read data from archive (refer to ADAS adf21 file format documentation at [2])
      call UFILNAM('ADASDIR',adas_ei_data,filename)
      open(unit=tape,file=filename,action='read', iostat=fErr)
      ! check if file could be opened
      if (fErr .ne. 0) then
         iErr = 2
         return
      endif
      
      ! read number of tables in file
      read(tape,1000) nsel
      if (nsel .lt. 3) then
         iErr = 2
         return
      endif
      
     ! read first table (low temperature)
      read(tape,1001) fn
      read(tape,1002) (fte(it),it=1,fn)
      read(tape,1002) (fsigv(is),is=1,fn)
      
      close(tape) 
      
1000  format(i5)
1001  format(15x,i2)
1002  format(6(1x,E9.3E2),/,6(1x,E9.3E2))
      
      
      
! calculate log of spline data
     do i=1,fn
         logfte(i)   = dlog(fte(i))
         logfsigv(i) = dlog(fsigv(i))
      enddo
      

! output log data for debugging
   
!      filename = "adas_ei_dbglog.dat"
!      open(unit = outdbg, file = filename)
!      do i=1,fn
!         write(outdbg,'(5g20.10,5g20.10)') logfte(i), logfsigv(i)
!      enddo
!      close(unit = outdbg)
      
      
! create EzSpline object and put data into it
      
      bcs_sigv = (/0, 0/)     ! not-a-knot boundary conditions
      
      call EZspline_init(sigv_ezspl, fn, bcs_sigv, sErr)    ! initialise spline object grid and boundary conditios
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 3
         return
      endif
      sigv_ezspl%x1 = logfte(1:fn)                          ! set grid points
      call EZspline_setup(sigv_ezspl, logfsigv(1:fn), sErr) ! initialise spline data
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 3
         return
      endif
      
      
! evaluate spline object with Erel values
      do i=1,N
         ! check if requested collision energy is within the available domain
         call EZspline_isInDomain(sigv_ezspl, dlog(te(i)), sErr)
!         call EZspline_error(sErr)
         if (sErr .eq. 0) then
            ! requested value in range, evaluate spline
            call EZspline_interp(sigv_ezspl, dlog(te(i)), logSIGV(i), sErr)
            call EZspline_error(sErr)
            if (sErr .ne. 0) then
               iErr = 3
               return
            endif
            SIGV(i) = dexp(logSIGV(i))
         else
            ! requested value out of range, extrapolate
            if (dlog(te(i)) .lt. sigv_ezspl%x1min) then
               logSIGV(i) = logfsigv(1) + (dlog(te(i)) - logfte(1))            &
               &                        / (logfte(2)   - logfte(1))            &
               &                        * (logfsigv(2) - logfsigv(1))
               SIGV(i) = exp(logSIGV(i))
            else if (dlog(te(i)) .gt. sigv_ezspl%x1max) then
               logSIGV(i) = logfsigv(fn) + (dlog(te(i))    - logfte(fn))       &
               &                         / (logfte(fn-1)   - logfte(fn))       &
               &                         * (logfsigv(fn-1) - logfsigv(fn))
               SIGV(i) = dexp(logSIGV(i))
            else
               iErr = 3
               return
            endif
         endif
      enddo

      SIGV=SIGV*1.e-6_fp !convert from cm**3/sec to m**3/sec
      
      return
end subroutine adas_ei_he

subroutine compute_axis(e_vec,e_vec_range)
  ! calculate axis grid, LOG or LIN
  implicit none
  real(fp), dimension(4), intent(in) :: e_vec_range ! min and max val, npts, specification 0 for LOG, 1 fog LIN
  real(fp), dimension(:), pointer :: e_vec ! output grid
  integer :: spec,i
  real(fp) :: t
  spec=int( e_vec_range(4))
  npts=int( e_vec_range(3))

  allocate(e_vec(npts))

  if(spec.eq.0) then
     t = log(e_vec_range(2) / e_vec_range(1))
     do i=1,npts
        e_vec(i)=e_vec_range(1)*exp(dble(i-1)*t/dble(npts-1))
     enddo
     e_vec(npts)=e_vec_range(2)
  elseif (spec.eq.1) then
     t = e_vec_range(2)- e_vec_range(1)
     do i=1,npts
        e_vec(i)=e_vec_range(1)+(dble(i-1)*t/dble(npts-1))
     enddo
     e_vec(npts)=e_vec_range(2)
  endif
end subroutine compute_axis
!
!-----------------------------------------------------------------------------------------
!
subroutine check_data_react(freact_type,beamchrg,izneut,zion,izion_use,n_use,istat)
!
!checking input data for available reaction in ADAS lib
!
  integer, intent(in) :: freact_type    !reaction type: 1  ='CX', 2 = 'II', 3 = 'SV' for excited states
  integer, intent(in) :: izneut  !atomic charge of primary   particle {1, 2}
  real(fp), intent(in) :: zion   !atomic charge of secondary particle {1, ..., 10}
  integer, intent(in) :: beamchrg !beam type neutral  = 1 or ion =2 
 INTEGER, intent(out) :: istat ! completion code; 0 = normal
                                !  istat = 2:  irtype argument invalid
                                !  istat = 3:  izneut or izchrg invalid
  integer, intent(out) ::  izion_use(2) !izion will be used to calculate sigv, then scale to izion
  integer, intent(out) :: n_use !number sigv need to be calculated to get sigv for a given zion
!
  integer, parameter :: NEUTRAL=1, ION=2
  integer, dimension(2,10) :: izchrg 
  integer izion, iz0,iz1
  real(fp) remaind
!
  !available reaction for H CX,II see adas_ion 
  !available reaction for He CX,II see adas_ion
  ! atomic charge of secondary particle {1, ..., 10}
  izchrg(1,:)=(/1,2,3,4,5,6,7,8,9,10/)
  izchrg(2,:)=(/1,2,0,4,0,6,0,8,0,0/)  
  istat=0
  izion=int(zion)
  remaind=mod(zion,1._fp)
  izion_use=izion
  n_use=1
  if(beamchrg.eq.ION) then !ION beam
     if (freact_type.gt.2) then  !(neutralizing) charge exchange
        istat = 3 ! beamchrg cannot be used for this reaction
        return
     endif
  endif
  if(izneut.gt.2) then
     istat = 3 ! invalid izneut, izion
     return
  endif
  if(freact_type.lt.1.or.freact_type.gt.3) then
     istat = 2
     return
  endif
  if (freact_type.eq.1) then  !(neutralizing) charge exchange
        if(zion.gt.dble(izneut)) then
           istat = 3 ! izneut cannot neutralize izion
           return
        endif
  endif
  if (freact_type.eq.3) then  ! SV reaction
     if(izneut.gt.1) then
        istat = 3 ! invalid izneut
        return
     endif
  endif
  if(izneut.eq.1) then
     if(izion.gt.10) then
        izion_use(1)=10
        n_use=1
     elseif((izion.lt.10).and.(remaind.gt.0.0_fp)) then
        izion_use(1)=izion
        izion_use(2)=izion+1        
        n_use=2
     endif
  elseif(izneut.eq.2) then
     if(izion.gt.8) then
        izion_use=8
        n_use=1
     elseif((izion.lt.8)) then
        n_use=1
        iz0=izion
        do
           if(izchrg(2,iz0).eq.0) then
              iz0=max(1,iz0-1)
           else
              izion_use(1)=iz0
              exit
           endif
        enddo

        if(remaind.gt.0.0_fp)then
           n_use=2
           iz1=izion+1
           do
              if(izchrg(2,iz1).eq.0) then
                 iz1= min(8,iz1+1)   
              else
                 izion_use(2)=iz1 
                 exit
              endif
           enddo
        endif
     endif
  endif
  
end subroutine check_data_react
!
!-----------------------------------------------------------------------------------------
!
subroutine extend(i_z,nuse)
  implicit none
  integer :: i_z,nuse
  real(fp), dimension(:),allocatable :: tmp! wrk.
  allocate(tmp(npts))
  tmp=0.0_fp
  tmp(1:npts_prev(i_z-1))=sigv_table_prev(1:npts_prev(i_z-1),i_z-1)
  deallocate(sigv_table_prev)
  allocate(sigv_table_prev(maxval(npts_prev(:)),nuse))
  sigv_table_prev=0.0_fp
  sigv_table_prev(1:npts_prev(i_z-1),i_z-1)=tmp(1:npts_prev(i_z-1))
  deallocate(tmp)
end subroutine extend

end module adas_mod

C******************** START FILE UFAHED.FOR ; GROUP UFILES ******************
C----------------------------------------------------------------------
C  UFAHED - READ/WRITE ASCII FILE HEADER
 
 
 
C  OBSOLETE - 8/24/93 TBT  Use UFAHED2.for to get Ascii data format Info
C  ________
 
C
C  DMC 14 NOV 1984-- SUPPORT 6 DIGIT SHOT NUMBER BUT READ OLD FILES
C    WITHOUT ERROR
C
      SUBROUTINE UFAHED(ILUN,ISHOT,IDEV,IDIM,KMPRS,ZDATE,ZSDATE,
     >                    IWRITE,IERH)
C
C  ILUN - UNIT TO READ/WRITE
C  ISHOT - UP TO 6 DIGIT SHOT NUMBER
C  IDEV - 4 CHAR TOKAMAK CODE
C  IDIM - UFILES FILE DIMENSIONALITY
C  KMPRS - DATA COMPRESSION CODE
C  ZDATE - FILE WRITE DATE
C  ZSDATE - SHOT (DATA ORIGIN) DATE
C
C  IWRITE: = 0 ** READ **
C          = 1 ** WRITE **
C
C  OUTPUT IERH ERROR CODE 0=NORMAL, 1=ERROR
C   ROUTINE NOW CHECKS FOR ERROR ON READ
C
      CHARACTER*4 IDEV
      CHARACTER*10 ZDATE,ZSDATE
      CHARACTER*6 ZZSHOT
      CHARACTER*8 ZZBUF
C
C-----------------------------------------
C
C  WRITE ***
C
      IERH=1000
      write(6,'('' ?ufiles:  obsolete "ufahed" call.'')')
      RETURN
C
      END
C******************** END FILE UFAHED.FOR ; GROUP UFILES ******************

!------------------------------------------------------------------------------
!
SUBROUTINE GAUS32_Z(A,B,FUN,TEST2,EPS,MAX,J,IPUNIT)
!	5/10/76
!	THIS SUBROUTINE WAS WRITTEN BY HARRY H TOWNER OF THE
!	PRINCETON PLASMA PHYSICS LAB.  THIS SUBROUTINE
!	WILL INTEGRATE THE FUNCTION FUN(X) BETWEEN THE LIMITS A AND B BY
!	USING 32-POINT GAUSS-LEGENDRE QUADRATURE ITERATIVELY.
!	A - THE LOWER LIMIT OF INTEGRATION
!	B - THE UPPER LIMIT OF INTEGRATION
!	FUN - THE FUNCTION TO BE INTEGRATED.  MUST BE DECLARED EXTERNAL
!	      IN THE CALLING PROGRAM.
!	TEST2 - THE VALUE OF THE INTEGRAL AFTER THE JTH ITERATION
!	EPS - THE ACCURACY TO WHICH YOU WANT THE VALUE.
!	   = ABS((NEW-OLD)/NEW).
!	MAX - MAXIMUM NUMBER OF ITERATIONS TO BE TAKEN.
!	J - TELLS THE NUMBER OF ITERATIONS TAKEN.
!	IPUNIT - THE LOGICAL UNIT FOR PRINTING.
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER j,ipunit,k,i,max
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) b,test2,eps,a,e00,xlow,test1,sum,xhigh,c1,c0,z,fun,re
!============
  external FUN
!
  real(fp), DIMENSION(16) :: X,W
!	ARRAY X CONTAINS THE ROOTS OF THE LEGENDRE PLOYNOMIAL.
!	ARRAY W CONTAINS THE WEIGHT FACTORS.
  DATA X/.04830766568773832_fp,.1444719615827965_fp,&
       .2392873622521371_fp,.3318686022821276_fp,.4213512761306353_fp,&
       .5068999089322294_fp,.5877157572407623_fp,.6630442669302152_fp,&
       .7321821187402897_fp,.7944837959679424_fp,.8493676137325610_fp,&
       .8963211557660521_fp,.9349060759377397_fp,.9647622555875064_fp,&
       .9856115115452683_fp,.9972638618494816_fp/
  DATA W/.09654008851472780_fp,.09563872007927486_fp,&
       .09384439908080457_fp,.09117387869576388_fp,.08765209300440381_fp,&
       .08331192422694676_fp,.07819389578707031_fp,.07234579410884851_fp,&
       .06582222277636185_fp,.05868409347853555_fp,.05099805926237618_fp,&
       .04283589802222668_fp,.03427386291302143_fp,.02539206530926206_fp,&
       .01627439473090567_fp,.007018610009470097_fp/
!
!  DMC Jan 2009: limit the warnings...
  integer, save :: iwarn = 0
!
  integer, parameter :: iwarn_max = 10
!
!	J COUNTS THE NUMBER OF ITERATIONS.
  J=1
  TEST2=0._fp
200 XLOW=A
  TEST1=TEST2
  SUM=0._fp
  DO K=1,J
     XHIGH=XLOW+(B-A)/J
     C1=(XHIGH-XLOW)*.5_fp
     C0=C1+XLOW
     DO I=1,16
        Z=C1*X(I)
        SUM=SUM+C1*W(I)*(FUN(Z+C0)+FUN(-Z+C0))
     enddo
     XLOW=XHIGH
  enddo
  TEST2=SUM
  IF(TEST2.EQ.0._fp) RETURN
  RE=ABS((TEST2-TEST1)/TEST2)
  IF(RE.LE.EPS) return
  J=J*2
  IF(J.LE.MAX) GO TO 200
  J=J/2
!
  if((ipunit.gt.0).and.((iwarn.lt.iwarn_max).or.(RE.gt.0.1_fp))) then
     WRITE(IPUNIT,10) J,RE
10   FORMAT(1X,'AFTER',I4,' ITERATIONS INTEGRAL HAS NOT CONVERGED ',&
          'RE=',1PE13.5,' GAUS32_Z')
     iwarn = iwarn + 1
     if(iwarn.eq.iwarn_max) then
        write(ipunit,*) &
             ' [gaus32_z: suppressed further warnings w/ RE < 0.1]'
        write(ipunit,*) ' [gaus32_z: as can generally be ignored.]'
     endif
  end if
!
  RETURN
END SUBROUTINE GAUS32_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

c  ufcchd -- write a header line for a "concatenated" Ufile
c    same arguments as "ufsetr" + shot number.
c
      subroutine ufcchd(ilun,zpre,zext,zdevi,zfdir,ishot,ier)
c
c  all arguments are input except ier:
c    ilun gives the the unit number of an ascii file already open
c         for write.
c
c    zpre,zext,zdevi,zfdir -- have the same meaning as for ufsetr,
c         but here they give the naming info of a Ufile that exists and
c         is about to be rewritten into the concatenated Ufile on unit
c         ilun
c
c    ishot -- the ufile shot number of the existing file.
c
c    ier (output) -- completion code, 0 = normal
c
c    this routine writes a header record and then sets up Ufiles COMMON
c    so that an ordinary ascii uf?dwr call can be invoked to write the
c    data into the concatenated Ufile.
c
C------------------------------------------------------
C
      USE UFILES
C
      CHARACTER*(*) ZPRE
C
      CHARACTER*(*) ZEXT
      CHARACTER*(*) ZFDIR
      CHARACTER*(*) ZDEVI
C
        integer ishot
c
c--------------------------------------
c
        ier=0
        call ufinit
        ichan=iuxcha(ilun)
        if(ichan.eq.0) then
           call ufsetr(ilun,zpre,zext,zdevi,zfdir)
           ichan=iuxcha(ilun)
           if(ichan.eq.0) then
              ier=1
              return
           endif
        endif
c
        ufstat(ichan)=0
        mds_shot(ichan)=0
        lufset(ichan)=.true.
        call ufcmpr(ilun,0)             ! ascii
        ufshot(ichan)=ishot             ! shot no.
        if(ishot.lt.0) call ufnsho(ilun)
        ufstat(ichan)=1                 ! ready to write
c
c  write header line
c
        ilpre=index(zpre,' ')-1
        if(ilpre.lt.0) ilpre=len(zpre)
        if(ilpre.eq.0) ilpre=1
        ilext=index(zext,' ')-1
        if(ilext.lt.0) ilext=len(zext)
        if(ilext.eq.0) ilext=1
        ildevi=index(zdevi,' ')-1
        if(ildevi.lt.0) ildevi=len(zdevi)
        if(ildevi.eq.0) ildevi=1
        ilfdir=index(zfdir,' ')-1
        if(ilfdir.lt.0) ilfdir=len(zfdir)
        if(ilfdir.eq.0) ilfdir=1
c
        write(ilun,1001) zpre(1:ilpre),ishot,zext(1:ilext),
     >     zdevi(1:ildevi),zfdir(1:ilfdir)
 1001   format('>>ufcchd: pre=',a,', shot=',i6,', ext=',a,
     >     ', dev=',a,', dir=',a)
c
        return
        end
 
 

!
!  INTERPOLATE ZONE-CENTERED VARIABLE TO ZONE BOUNDARY VALUES
!
!  ONE SLIGHT EXTRAPOLATION AT OUTER EDGE
!
subroutine R8_XINTZB(FZC,FZB,N)
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: n,inm1,i,ip1
  real(fp), dimension(N) :: FZC, FZB

  INM1=N-1
  do I=1,INM1
    IP1=I+1
    FZB(I)=0.5_fp*(FZC(I)+FZC(IP1))
  end do

  ! Linear EXTRAPOLATION AT EDGE
  FZB(N) = FZC(N) + 0.5_fp*(FZC(N)-FZC(INM1))

  return
end subroutine R8_XINTZB

      subroutine inclopt(list_max,list_cur,list,tfile)
C
C implement "-I" option -- for list of INCLUDE file search directories.
C
      integer list_max                  ! max list size (input)
      integer list_cur                  ! actual list size (output)
      character*(*) list(list_max)      ! the actual list (output)
      character*(*) tfile               ! "template" file specification
C                                       !   -- skip if blank
C
C the template filename contains a directory specification that is to
C be included on the list.
C
C the list includes the current working directory, the template file's
C directory (if a nonblank filename is specified), and all additional
C specifications given via a -I option on the command line.
C
C--------------------------
C
      character*128 zarg
C
C
C--------------------------
C  1.  the current working directory
C
      call sget_cwd(zarg)
      list_cur=1
      list(1)=zarg
C
C  2.  tfile directory
C
      if(tfile.ne.' ') then
         ilt=len_trim(tfile)
         do ic=ilt,1,-1
            if((tfile(ic:ic).eq.']').or.
     >         (tfile(ic:ic).eq.'>').or.
     >         (tfile(ic:ic).eq.':').or.
     >         (tfile(ic:ic).eq.'/')) then
               list_cur=list_cur+1
               list(list_cur)=tfile(1:ic)
               go to 10
            endif
         enddo
      endif
C
C  3.  supplement list from command line
C
 10   continue
      call listopt(list_max,list_cur,list,'-I')
C
C  be sure that all directory specs are properly decorated...
C
      do id=1,list_cur
         ild=len_trim(list(id))
         if(list(id)(ild:ild).ne.'/') then
            ic=ild+1
            list(id)(ic:ic)='/'
         endif
      enddo
C
      return
      end

C******************** START FILE UFSETR.FOR ; GROUP UFILES *************
C---------------------------------------------------------------------
C  UFSETR
C  SET/RESET FILE-NAMING CONVENTIONS, DEFAULT DEVICE, DIRECTORY
C
      SUBROUTINE UFSETR(ILUN,ZPRE,ZEXT,ZDEVI,ZFDIR)
C
C  SAMPLE CALL (VAX):
C	CALL UFSETR(24,'T','PCR','HX3:','TRANSP.PDX')
C  ASSOCIATING LOGICAL UNIT NUMBER 24 AND FILENAME PARTS
C  TO ACCESS FILES WITH NAMES OF FORM HX3:[TRANSP.PDX]T#####.PCR
C  WHERE ##### IS A STANDARD SHOT NUMBER
C
C  mod dmc Sep 1994 -- (a) the old LTSS cray code is deleted
C                      (b) the trailing "/" in unix directory specs
C                          is no longer required.
C
C  MOD DMC MAY 1990 -- THE COLON ":" IS NO LONGER REQUIRED TO TERMINATE
C  THE DEVICE ARGUMENT ZDEVI
C
C------------------------------------------------------
C
      USE UFILES
C
      CHARACTER*(*) ZPRE
C
      CHARACTER*(*) ZEXT
      CHARACTER*(*) ZFDIR
      CHARACTER*(*) ZDEVI
C
      character*6 ztest
      CHARACTER*15 ZERRL
C
      integer      i1, i2, i3, m1, lzfdir
      character*10 zpulse
C
C  ERROR LABEL
      DATA ZERRL/'UFILES>UFSETR: '/
C
C--------------------------------------------
C
      CALL UFINIT
      ICHAN=IUXCHA(ILUN)
      ier=0
      IF(ICHAN.EQ.0) CALL UFXCHL(ILUN,ICHAN,IER)
      IF(IER.NE.0) THEN
C
C  ERROR-- ASSIGNMENT TABLE OVERFLOW
        WRITE(UFELUN,9001) ILUN,UFCHAN
 9001   FORMAT(' ? UFSETR-- TABLE OVERFLOW ON L.U.N. ',I5/
     >       '   UFILES L.U.N. ASSIGNMENT FAILED'/
     >       '   MAXIMUM NUMBER OF L.U.N. ASSIGNMENTS: ',I3/)
        CALL UFPAUS(1)
        RETURN
      ENDIF
C
      IF(.NOT.LUFSET(ICHAN)) GO TO 20
      IF(UFSTAT(ICHAN).NE.0) THEN
        WRITE(UFELUN,9002) ILUN
 9002   FORMAT(' ? UFSETR-- ATTEMPT TO RESET OPEN L.U.N.:  ',I5/
     >       '   CALL UFCLOS TO CLOSE UNIT FIRST BEFORE REASSIGNMENT')
        RETURN
      ENDIF
C
 20   CONTINUE
      LUFSET(ICHAN)=.FALSE.
C
C  dmc 15 Dec 1998 -- test for MDS+ specification
C
      mds_shot(ichan)=0
      imx=min(6,len(zpre))
      ztest=zpre(1:imx)
      call uupper(ztest)
      if(ztest.eq.'MDS+::') go to 500
 
C
C  dmc -- resume old code
C
C  GET LENGTHS OF FILENAME ELEMENTS.
C  CHECK INPUT FILENAME PARTS:  LEFT JUSTIFIED, NO IMBEDDED BLANKS,
      LPRFIX(ICHAN)=IUFTRM(ZPRE,ZERRL//'PREFIX',IER1)
      LEXTND(ICHAN)=IUFTRM(ZEXT,ZERRL//'.EXT',IER2)
C
C  DEVICE NAME SHOULD END IN ":" BUT WILL LIVE IF NOT...
      ILDEV=IUFTRM(ZDEVI,ZERRL//'DEVICE NAME',IER3)
      ICOLON=1
      IF(ILDEV.GT.0) THEN
        IF(ZDEVI(ILDEV:ILDEV).NE.':') THEN
          ILDEV=ILDEV+1
            ICOLON=0
          ENDIF
      ENDIF
      LDEV(ICHAN)=ILDEV
C
      ILDIR=IUFTRM(ZFDIR,ZERRL//'DIRECTORY NAME',IER4)
      ISLASH=1
      IF(ILDIR.GT.0) THEN
        IF(ZFDIR(ILDIR:ILDIR).NE.'/') THEN
          ILDIR=ILDIR+1
          ISLASH=0
        ENDIF
      ENDIF
      LFDIR(ICHAN)=ILDIR
      IF((IER1+IER2+IER3+IER4).GT.0) RETURN
C
C  CHECK LENGTHS:  IF OK, INSERT NAMES IN COMMON
C
      CALL UFNPAD(
     >ZPRE,LPRFIX(ICHAN),UPRFIX(ICHAN),ZERRL//'PREFIX',IER1)
C
      CALL UFNPAD(
     >ZEXT,LEXTND(ICHAN),UEXTND(ICHAN),ZERRL//'.EXT',IER2)
C
      IF(ICOLON.EQ.1) THEN
        CALL UFNPAD(
     >ZDEVI,LDEV(ICHAN),UDEV(ICHAN),ZERRL//'DEVICE NAME',IER3)
      ELSE
        IL=ILDEV-1
        CALL UFNPAD(
     >      ZDEVI(1:IL)//':',
     >      LDEV(ICHAN),UDEV(ICHAN),ZERRL//'DEVICE NAME',IER3)
      ENDIF
C
      IF(ISLASH.EQ.1) THEN
        CALL UFNPAD(
     >ZFDIR,LFDIR(ICHAN),UFDIR(ICHAN),ZERRL//'DIRECTORY NAME',IER4)
      ELSE
        IL=ILDIR-1
        CALL UFNPAD(
     >      ZFDIR(1:IL)//'/',
     >      LFDIR(ICHAN),UFDIR(ICHAN),ZERRL//'DIRECTORY NAME',IER4)
      ENDIF
C
      IF((IER1+IER2+IER3+IER4).GT.0) RETURN
C
      imds=0
      go to 800
C
 500  continue
C
C  MDS+ coding
C
      lprfix(ichan)=iuftrm(zpre,zerrl//'mds_server',ier1)-6
C If TRANSP run (from add_ufnodes) mds_path = .INPUTS
      if (zdevi(1:5) .eq. 'PPPL@') then
         ldev(ichan)  =iuftrm('.INPUTS',zerrl//'mds_path',ier3)
      else
         ldev(ichan)  =iuftrm(zdevi,zerrl//'mds_path',ier3)
      endif
      lfdir(ichan) =iuftrm(zfdir,zerrl//'mds_node',ier4)
      lzfdir=lfdir(ichan)  ! save for PPPL TRANSP
      if((IER1+IER3+IER4).GT.0) RETURN
C
C check if TRANSP run Input
C zdevi = PPPL@<tok.yr>@<runid>    : Read from TRANSP Tree (add_ufnodes)
C zext  = <tree>@<tok.yr>@<runid>  : TRANSP
C         <tree>@<runid>           : BEAST/JET
C         <tree>(shot)             : encoded shot (e.g. from add_ufnodes)
C
      i1 = index(zext,'@')+1
      m1 = index(zext,'(')+1
      if (i1 .gt. 1) then
         i2=index(zext(i1:),'@')
         i3=index(zext,' ')-1
         if (i3 .lt. 0) i3=len(zext)
C TRANSP:  pass ufdir = PPPL@<tok.yr>@<runid> to ufopen_mds
         if (i2 .gt. 0) then     !  TRANSP run
            call mkbeastid(zext(i1+i2:i3),mds_shot(ichan),zpulse)
C BEAST/JET: translate now
         else                   ! BEAST/JET
            call mkbeastid(zext(i1:i3),mds_shot(ichan),zpulse)
         endif
         zext(i1-1:)=' '
C Encoded shot: extract
      else if (m1 .gt. 1) then
         i2 = index(zext,')')-1
          read(zext(m1:i2),'(i10)',iostat=ios)mds_shot(ichan)
          zext(m1-1:)=' '
      else
C Read from TRANSP Tree (add_ufnodes): zdevi = PPPL@<tok.yr>@<runid>
         if (zdevi(1:5) .eq. 'PPPL@') then
            ufdir(ichan) = zdevi
            lfdir(ichan) = ldev(ichan)
         else
            ufdir(ichan)='mds+'
         endif
      endif
      lextnd(ichan)=iuftrm(zext,zerrl//'mds_tree',ier2)
      if(IER2.GT.0) RETURN
      uprfix(ichan)='mds+'
      uextnd(ichan)='mds+'
      udev(ichan)='mds+'
 
C
      if(lprfix(ichan).le.0) then
         lprfix(ichan)=5
         mds_server(ichan)='local'
      else
         ilpr=lprfix(ichan)+6
         call ufnpad(zpre(7:ilpr),lprfix(ichan),mds_server(ichan),
     1	zerrl//'mds_server',ier1)
      endif
      call uupper(mds_tree(ichan))
      call ufnpad(zext,lextnd(ichan),mds_tree(ichan),
     1    zerrl//'mds_tree',ier2)
C If TRANSP run (from add_ufnodes) mds_path = .INPUTS
      if (zdevi(1:5) .eq. 'PPPL@') then
         call ufnpad('.INPUTS',ldev(ichan),mds_path(ichan),
     1    zerrl//'mds_path',ier3)
      else
         call ufnpad(zdevi,ldev(ichan),mds_path(ichan),
     1    zerrl//'mds_path',ier3)
      endif
      call ufnpad(zfdir,lzfdir,mds_node(ichan),
     1    zerrl//'mds_node',ier4)
      if((IER1+IER2+IER3+IER4).GT.0) RETURN
C
      imds=1
      go to 800
C
 800  continue
C  EVERYTHING OK
      LUFSET(ICHAN)=.TRUE.
      UFLUN(ICHAN)=ILUN
      UFSTAT(ICHAN)=0
C  CLEAR COMPRESSED BINARY DATA WRITE FLAG
      if(imds.eq.0) then
         UFCPRS(ICHAN)=0
      else
         UFCPRS(ICHAN)=-1
      endif
C  DEFAULT: FILE NAME INCLUDES ENCODED SHOT NO.:
      LSHOTN(ICHAN)=.TRUE.
C
C  enforce name capitalization
C
      IF(LUFCAP.eq.1) THEN
         CALL UFUPPER(ILUN)
      ELSE IF(LUFCAP.eq.0) THEN
         CALL UFLOWER(ILUN)
      ENDIF
C
      RETURN
      END
C******************** END FILE UFSETR.FOR ; GROUP UFILES ***************

C******************** START FILE USPCAP.FOR ; GROUP USPARM *************
C-----------------------------------------------------------------
C  D. MC CUNE NOV 12 1981
C& USPCAP   CAPITALIZE ALL LETTERS IN PASSED STRING
C	    CONVERT TABS TO BLANKS
C
C  DMC 1988 -- **DO NOT** CONVERT STUFF BTW DBL QUOTES " xxx "
C
      SUBROUTINE USPCAP(ZSTR)
C
      CHARACTER*(*) ZSTR
C
      CHARACTER*2 ZFDLIM
      CHARACTER*52 ZCAP
C
      DATA ZFDLIM/'  '/	! TAB AND SPACE
      DATA ZCAP/
     >  'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C
      IUP=1  ! used for quote checking
      zfdlim(2:2)=char(9) ! make sure it is a tab
C
      ILEN=LEN(ZSTR)
      IF(ILEN.EQ.0) RETURN
      DO I=1,ILEN
C  CHECK FOR DBL QUOTE TO SUPPRESS CAPITALIZATION
         IF(ZSTR(I:I).EQ.'"') IUP=1-IUP
C  CHECK FOR TAB
         IF(ZSTR(I:I).EQ.ZFDLIM(2:2)) THEN
            ZSTR(I:I)=ZFDLIM(1:1)
         ENDIF
         IF(IUP.eq.1) THEN
C  CHECK FOR LOWER CASE LETTER
            DO IC=1,26
               IF(ZSTR(I:I).EQ.ZCAP(IC:IC)) then
                  ICP=IC+26
                  ZSTR(I:I)=ZCAP(ICP:ICP)
                  exit
               endif
            enddo
         ENDIF
      enddo

      RETURN
      END
C******************** END FILE USPCAP.FOR ; GROUP USPARM ***************

module r8bsmoo_mod
  use iso_c_binding, only: fp => c_double

  SAVE

  !  mock up the part of TRCOM used by bsmoo.for,bsmooh.for,bsmoox.for
  !  which are being made independent of TRCOM

  integer mj                  ! grid array size
  integer lcentr,ledge        ! active grid limits
  integer lcp1,lep1           ! as above, +1
  integer nzones              ! no. of active zones

  !  the normalized grid

  real(fp), dimension(:,:), allocatable :: xi

  !  the smoothing parameter

  real(fp) :: dxbsmoo

end module r8bsmoo_mod

C******************** START FILE UFNSHO.FOR ; GROUP UFILES ******************
C-----------------------------------------------------------
C  UFNSHO - TURN OFF SHOT NO. ENCODING IN FILENAMING
C
      SUBROUTINE UFNSHO(ILUN)
C
      USE UFILES
C
      CALL UFLCHK(ILUN,'UFNSHO    ',ICHAN,IER)
      IF(IER.NE.0) RETURN
C
      LSHOTN(ICHAN)=.FALSE.
C
      RETURN
      END
C******************** END FILE UFNSHO.FOR ; GROUP UFILES ******************

      subroutine txtblok_out(lun,filename,txtarray,nsize,istat)
c
c  write a file from a text array in memory out to disk
c
      implicit NONE
c
c input:
      integer lun                       ! logical unit no. for i/o
      character*(*) filename            ! filename to write
c
      integer nsize                     ! size of text arrary
      character*(*) txtarray(nsize)     ! text array
c
c output:
c
      integer istat                     ! status code on exit
c
c  istat = 0  -- normal
c
c  istat = 1  -- file open error
c
      integer ier,i,iln,ilnurd
c
c----------------------------------------
c
      istat=0
c
      call ufopen(lun,filename,2,ier,0)
      if(ier.ne.0) then
         istat=1
         return
      endif
c
      do i=1,nsize
         iln=ilnurd(txtarray(i))
         write(lun,'(A)') txtarray(i)(1:iln)
      enddo
c
      close(unit=lun)
      return
      end

C******************** START FILE IPNBLK.FOR ; GROUP USPARM ******************
C-------------------------------------------------------------
C& IPNBLK  FIND LAST NON-BLANK CHARACTER IN UNPACKED LINE
C
C
      INTEGER FUNCTION IPNBLK(ZLINE,LLINE,ISTART)
C
      CHARACTER*1 ZLINE(LLINE)
C
      IST=ISTART
 10   CONTINUE
      IST=IST-1
      IF(IST.LE.0) GO TO 100
      IF(ZLINE(IST).NE.' ') GO TO 100
      GO TO 10
C
 100  CONTINUE
      IPNBLK=MAX0(0,IST)
      RETURN
      END
C******************** END FILE IPNBLK.FOR ; GROUP USPARM ******************

C******************** START FILE ugbuf0.FOR ; GROUP UREAD5 ******************
c--------------------------------------------------------------
c&  ugbuf0 load uread multi-line buffer from indirect input file
c  read in the buffer
c  if istart=1, reading first page fresh after open.  if entire
c  file fits in buffer set flag itotal
c
      subroutine ugbuf0(istart,zbuff,isiz,ilasl,itotal,iendl)
c
      USE USERIO
      logical itotal
      character*(urdbufl) zbuff(isiz)
c
c  ilasl-- location of last line read
c  iendl-- location of end-of-file or 0 if e-o-f not found
c
      iendl=0
      itotal=.false.
c
      i0=1
      if(ilasl.lt.isiz) i0=ilasl+1
c
      do 50 i=i0,isiz
          read(luntin(nlunin),5001,end=60) zbuff(i)
          call urd_cln_input(zbuff(i))
c
c 	  check for indirect input file symbol-- break
          ind1=index(zbuff(i),'@')
          if(ind1.eq.0) then
c	  mod dmc June 1986 - ">" also an input file symbol if followed
c	  immediately by a non-delimitter character
            ind1=index(zbuff(i),'>')
            if(ind1.gt.0) then
      	ind1p=ind1+1
      	if(index('	 ,',zbuff(i)(ind1p:ind1p)).ne.0) ind1=0
            endif
          endif
          indcom=index(zbuff(i),MSEMI)
          if(indcom.eq.0) indcom=len(zbuff(1))+1
          if((ind1.gt.0).and.(ind1.lt.indcom)) go to 100
 50   continue
c
      istart=2
      ilasl=isiz
      return
c
c e-o-f detected
 60   continue
      ilasl=i-1
      iendl=i
      if(istart.eq.1) itotal=.true.
      return
c
c  indirect file reference break pt detected
 100  continue
      ilasl=i
      return
 5001 format(a)
c
      end
C******************** END FILE ugbuf0.FOR ; GROUP UREAD5 ******************

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_close(tree, shot)
      implicit none
      character*(*) tree
      integer       shot
      mds_close = 0
      end
#else
c-----------------------------------------------------------------------
c mds_close
c close a tree
c
c Returns:
c   1          on succcess
c   odd number on failure
c
c 03/17/1999 ler Converting to unix usable
c-----------------------------------------------------------------------
      integer function mds_close(tree, shot)
      implicit none
 
      character*(*) tree
      integer       shot
 
      integer status
      character*4097 strarg
 
      integer MdsClose

      call mds__copywnull(strarg, tree)
      status = MdsClose(strarg, shot)
      mds_close = status
 
      return
      end
#endif
 

      real function shafnl(Delprime)
! Returns the nonlinear Shafranov shift derivative "ShafNL",
! given the linear Shafranov shift derivative "Delprime".
! ShafNL is related to Delprime by the equation:
!	ShafNL = Delprime * (1-ShafNL**2)**(3/2)
! This insures that -1 <= ShafNL <= 1.  Delprime may lie outside this
! interval, in which case the flux surfaces would nonsensically overlap
! if the nonlinear correction were not used.  SMP was used to solve the
! above cubic equation.
 
      logical shafnl_flag
      data shafnl_flag /.true./ ! .false. = always use linear shift!
 
! For extremely small values of Delprime, the linear formula is perfectly
! O.K., while the nonlinear formula suffers from round-off errors.
      if(abs(Delprime) .le. .01 .or. .not. shafnl_flag) then
      shafnl=Delprime
      return
      endif
 
      b=abs(Delprime)
      xprs=(-27.0/b**2+(729.0/b**4+108.0/b**6)**0.5)**(1./3.)
      shafnl=1.0-2.0**(1./3.)/b**2/xprs + xprs/3/2**(1./3.)
 
      shafnl=Sqrt(shafnl)*SIGN (1.0, Delprime)
      return
      end
 
 

subroutine vnewton(xmin,xmax,ffpsub,nvec,xvec,fvec,tol,nauxi,auxi, &
     nauxo,auxo,ier)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit none

  ! compute a set of solutions { f(xvec(j))=fvec(j) }

  real(fp), intent(in) :: xmin,xmax  ! (xmin,xmax) as 2-vector, xmax .ne. xmin

  external ffpsub  ! f,f' function evaluation routine (see description below)

  integer, intent(in) :: nvec      ! solution vector size
  real(fp), intent(inout) :: xvec(nvec)! initial/final solution estimates(in/out)
  real(fp), intent(in) :: fvec(nvec) ! function values sought

  real(fp), intent(in) :: tol        ! completion criterion:
  !   change in x < tol*(xmax-xmin)

  !  for ffpsub:

  integer :: nauxi                 ! # of auxilliary inputs per vector element
  real(fp), intent(in) :: auxi(nauxi,nvec)

  integer :: nauxo                 ! # of auxilliary outputs per vector element
  real(fp), intent(in) :: auxo(nauxo,nvec)

  integer, intent(out) :: ier      ! completion code (0=OK)

  !-----------------
  !  user provides:
  !  subroutine <fppsub>(nvec,xvec,feval,dfdx,nauxi,auxi,nauxo,auxo)
  !    (nvec,xvec,nauxi,auxi,nauxo,auxo) as declared above).
  !    real(fp) feval(nvec)  ! f evaluation at each pt (to compare with fvec).
  !    real(fp) dfdx(nvec)   ! df/dx at each evaluation point.
  !-----------------

  real(fp) :: xlo(nvec),xhi(nvec),fxlo(nvec),fxhi(nvec)
  real(fp) :: feval(nvec),dfdx(nvec)

  real(fp) :: dxmaxa,df,dx(nvec),ftest

  integer, parameter :: itmax=50

  integer :: i,iter,isplit
  logical ihave_lims

  !-------------------------------------------------------
  !  rudimentary error checks

  ier=0

  if(xmax.le.xmin) then
    ier=1
    return
  endif

  do i=1,nvec
    if((xvec(i).lt.xmin).or.(xvec(i).gt.xmax)) ier=2
  enddo
  if(ier.gt.0) return

  xlo=xmin
  xhi=xmax

  iter=0

  do
    ! evaluate vector of f, df/dx

    call ffpsub(nvec,xvec,feval,dfdx,nauxi,auxi,nauxo,auxo)

    ! compute Newton steps & maximum step; recover from out of range steps

    dxmaxa=ZERO

    do i=1,nvec
      isplit=0
      df=fvec(i)-feval(i)
      if(df.eq.ZERO) cycle
      if((xmax-xmin)*abs(dfdx(i)).lt.abs(df)) then
        isplit=1
      else
        dx(i)=df/dfdx(i)
        if(xvec(i)+dx(i).gt.xhi(i)) then
          isplit=1
        else if(xvec(i)-dx(i).lt.xlo(i)) then
          isplit=1
        else
          dxmaxa=max(dxmaxa,abs(dx(i)))
        endif
      endif

      if(isplit.eq.1) then

        ! Newton step out of range, fall back to binary search

        if(.not.ihave_lims) then
          ihave_lims=.TRUE.
          call ffpsub(nvec,xlo,fxlo,dfdx,nauxi,auxi,nauxo,auxo)
          call ffpsub(nvec,xhi,fxhi,dfdx,nauxi,auxi,nauxo,auxo)
        endif
        ftest=(fvec(i)-fxlo(i))*df
        if(ftest.eq.ZERO) then
          dx(i)=xlo(i)-xvec(i)  ! match at lo endpoint
          cycle
        else if(ftest.lt.ZERO) then

          ! target lies between last evaluation point and xlo
          xhi(i)=xvec(i)

        else

          ftest=df*(fvec(i)-fxhi(i))
          if(ftest.eq.ZERO) then
            dx(i)=xhi(i)-xvec(i)  ! match at hi endpoint
            cycle
          else

            ! target lies between last evaluation point and xhi
            xlo(i)=xvec(i)

          endif
        endif
        dx(i)=(xlo(i)+xhi(i))/2 - xvec(i)
        dxmaxa=max(dxmaxa,abs(dx(i)))
      endif

    enddo

    ! OK ready for next step...

    if(dxmaxa.gt.tol*(xmax-xmin)) then

      iter=iter+1
      if(iter.gt.itmax) then

        ier=3  ! convergence failure
        return

      endif

      xvec = xvec + dx

    else

      exit  ! convergence OK

    endif

  enddo  ! end of Newton convergence loop

  return
end subroutine vnewton
 
subroutine vnewton_error(lun,ier)

  implicit none

  !  echo error message (immediate exit, no message, iff ier=0)

  integer, intent(in) :: lun   ! Fortran LUN where to write message
  integer, intent(in) :: ier   ! error code

  if(ier.eq.0) then
    return

  else if(ier.eq.1) then
    write(lun,*) &
         ' ?vnewton: xmax .le. xmin'

  else if(ier.eq.2) then
    write(lun,*) &
         ' ?vnewton: one or more xvec(...) values outside range [xmin,xmax]'

  else if(ier.eq.3) then
    write(lun,*) &
         ' ?vnewton: for one or more xvec(...) max iteration count exceeded.'

  else
    write(lun,*) ' ?vnewton:  error (unspecified).'
  endif

  write(lun,*) '  (error code ',ier,')'

  return
end subroutine vnewton_error

      SUBROUTINE GET_TERM_INT(TERMINAL_TYPE,ITERM)
C
C  THIS ROUTINE RETURNS ITERM=0 IF TERMINAL_TYPE(1:4) IS BLANK OR
C  NULL OR 'UNKN'own; RETURNS ITERM=1 OTHERWISE
C
C  IF TERMINAL_TYPE STRING IS TOO SHORT ITERM=0 IS ALSO RETURNED
C
      CHARACTER*(*) TERMINAL_TYPE  ! INPUT STRING
      INTEGER ITERM                ! OUTPUT INTEGER
C
      CHARACTER*1 ZBLANK
      CHARACTER*1 ZNULL
C
      PARAMETER (ZBLANK = ' ')
      PARAMETER (ZNULL = CHAR(0))
C
C---------------------------------------------
C
      ITERM=0
      IL=LEN(TERMINAL_TYPE)
      IF(IL.LT.4) RETURN
C
      IF(TERMINAL_TYPE(1:4).EQ.'UNKN') RETURN
C
      DO IC=1,4
        IF((TERMINAL_TYPE(IC:IC).NE.ZBLANK).AND.
     >	     (TERMINAL_TYPE(IC:IC).NE.ZNULL)) GO TO 100
      ENDDO
C
C  NO CHARACTERS ...
C
      RETURN
C
C  FOUND A STRING
C
 100  CONTINUE
C
      ITERM=1
C
      RETURN
C
      END

C Read Scalars from netCDF Ufiles
C
C 08/13/97 CAL
C
C---------------------------------------------------------------------------
      subroutine ucdf0r(lun, scval, sclab, n_sc, nsc, retn)
 
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Input
      integer       lun, n_sc
C Return
      integer nsc
      character*10  sclab(3,n_sc)
      real          scval(n_sc)
      integer retn
 
 
C Definitions for processing
      integer ichan, file_id
      integer i,     j
      character*10   nam
C
C-----------------------------------------------------------------------
C get file name
      call uflchk(lun,'uhdf0r',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
C
C Get number of scalars
C
      retn = nf_get_att_int(file_id,NF_GLOBAL,'num_scalars',nsc)
      if (retn .ne. 0) then
         write(ufelun,9003) NF_STRERROR(retn)
 9003    format(' % UCDF0R: nf_get_att_in -- num_scalars '/,
     >       '     ',a)
         return
      end if
C
C Get Scalar Names
C Assume scalars have been written first
      do i=1,nsc
         retn = nf_inq_varname(file_id, i, nam)
         if (retn .ne. 0) then
            write(ufelun,9001) i,NF_STRERROR(retn)
            return
         end if
         retn = nf_get_att_text(file_id, i, 'long_name',sclab(2,i))
         if (retn .ne. 0) then
            write(ufelun,9002) i,NF_STRERROR(retn)
            return
         end if
         retn = nf_get_att_text(file_id, i, 'units',sclab(3,i))
         if (retn .ne. 0) then
            write(ufelun,9002) i,NF_STRERROR(retn)
            return
         end if
         j = index(nam,' ')
         sclab(1,i) = nam(1:j-1)
         sclab(1,i)(j:j) = ':'
      end do
 9001 format(' % UCDF0R: nf_inq_varname - sclab',i3/,
     >       '     ',a)
 9002 format(' % UCDF0R: nf_get_att_text - sclab',i3/,
     >       '     ',a)
C
C Read Scalars
      do i=1,nsc
         retn = nf_get_var_real(file_id, i, scval(i))
         if (retn .ne. 0) then
            write(ufelun,9000) i,NF_STRERROR(retn)
            return
         end if
C      type *,sclab(1,i),scval(i),' ',sclab(2,i),sclab(3,i)
      end do
 9000 format(' % UCDF0R: nf_get_var_real - scval',i3/,
     >       '     ',a)
C
      return
      end
 
 
 
 
 
 
 
 

subroutine frantic_neuts(ierr)
  !
  !  THIS ROUTINE WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
  !  PLASMA PHYSICS LAB.  THIS ROUTINE WILL DETERMINE THE NEUTRAL
  !  DENSITY FOR MULTIPLE SPECIES. THE BASIC ALGORITHEM USED
  !  IS THAT DEVELOPED BY STEVE TAMOR IN HIS ANTIC CODE.
  
  !-------------------------------
  !
  !  TBT Jun, 1991  Added NINLDX as the pointer to the lightest gas in
  !                 BACKZ for this source.
  !-----------------------------
  !
  !  TBT May 1991 - Added INDX for H and He plasmas.
  !  DMC AUG 1986 - GEN. FOR ROTATION BALANCE
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  use frantic_module
  implicit none
  !
  integer, intent(out) :: ierr   ! completion code (0=OK)
  real(fp), parameter :: C4TH = 0.25_fp
  real(fp), parameter :: CEPS4 = 1.0e-4_fp
  !
  integer :: inn1,ik,i,j,ip1,ineut,idir,jstart,inl,istart,j1,i1
  integer :: irow,jcol,il,ioff
  real(fp) :: zrpi,zrpi2,zr,zvlt,zvlm,zts,zsigv
  real(fp), dimension(MJ*MIG,MJ*MIG+1) :: zdd
  real(fp), dimension(MJ*MIG) :: zstor1
  real(fp), parameter :: zpi = 3.141592654_fp

  ierr=0
  if(.not.allocated(bii)) then
    write(lun6,*) ' ?FRANTIC: unallocated arrays detected.'
    write(lun6,*) '  call FRANTIC_SPECIES_ZA and ', &
         'FRANTIC_PROFILE_ALLOC first.'
    ierr=88
    return
  end if

  if(.not.allocated(x_user)) then
    write(lun6,*) ' ?FRANTIC: geometry information missing.'
    write(lun6,*) '  call FRANTIC_RADIUS first.'
    ierr=99
    return
  end if

  if(nneut_s0.eq.0) then
    ierr=ierr+1
    write(lun6,*) ' ?FRANTIC: no neutral source specified.'
  end if

  do ik=1,nplas
    if(.not.npro_set(ik)) then
      ierr=ierr+1
      write(lun6,*) ' ?FRANTIC: density and temperature ', &
           'profiles not set for species:'
      if(ik.eq.1) write(lun6,*) '  --> electrons.'
      if(ik.eq.2) write(lun6,*) '  --> impurities.'
      if(ik.gt.2) then
        write(lun6,8881) xzplas(ik),aplas(ik)
8881    format('  --> ions, Z=',1pd10.3,' A=',1pd10.3)
      end if
    end if
  end do

  if(ierr.gt.0) return

  !	---------------
  !
  INN1=MJ*MIG
  if(.NOT.ESFLAG.AND..NOT.VSFLAG.AND..NOT.RCFLAG) GO TO 280
  !
  if(LBFLAG) GO TO 30
  !------------------
  do IK=1,NNEUT
    do I=1,NZONEC
      BII(I,IK)=ZERO
      BCX(I,IK)=ZERO
    end do
  end do
!------------------
30 continue
  do I=1,NZONEC
    PCX(I)=ZERO
    PII(I)=ZERO
    PCXSF(I)=ZERO
    PIISF(I)=ZERO
    TQCX(I)=ZERO
    TQII(I)=ZERO
    PRC(I)=ZERO
    SORE(I)=ZERO
    SCX(I)=ZERO
  end do
  !------------------
  do J=1,NNEUT
    do I=1,NZONEC
      SORI(I,J)=ZERO
      SORN(I,J)=ZERO
      DCOLD(I,J)=ZERO
    end do
  end do
  !------------------
  if(MSFLAG) GO TO 70
  if(LNFLAG.AND.MCFLAG) GO TO 70
  !------------------
  WRITE(LUN6,60)
60 FORMAT(T2,'NO MATRIX CALCULATED.  DOING INITIALIZATION', &
        ' WITH MATRIX CALCULATION')
  LNFLAG=.TRUE.
  MCFLAG=.TRUE.
  !------------------
70 if(.NOT.LNFLAG) GO TO 120
  !  I NOW FILL ISPEC ARRAY
  do I=1,NPLAS-1
    IP1=I+1
    do J=1,NNEUT
      INEUT=J
      if(NSPEC(J).EQ.IP1) GO TO 90
    end do
    LISPEC(I)=0
    GO TO 100
90  LISPEC(I)=INEUT
100 continue
  end do
  !------------------
  !  I NOW FIND THE BOUNDARY VALUES FOR EACH ZONE. NOTE THAT ZONE
  !  CENTER I LIES BETWEEN ZONE BOUNDARY I AND I+1.
  NBOUND=NZONEC+1
  do I=1,NZONEC
    VOL(I)=ZPI*(RBOUND(I+1)*RBOUND(I+1)-RBOUND(I)*RBOUND(I))
  end do
  !------------------
  !  I NOW INITALIZE ALPHA AND BETA ARRAYS
120 if(MCFLAG.OR.ESFLAG) call frantic_alpha
  if(.NOT.LNFLAG) GO TO 150
  !  I NOW FIND ARRAY Y WHICH CONTAINS THE DISTANCE OF CLOSEST
  !  APPOACH. SEE PROGRAM WRITE UP FOR DETAILS.
  YLOC(1)=RBOUND(2)*0.6189908923_fp
  do I=2,NZONEC
    ZRPI=RBOUND(I+1)
    ZRPI2=ZRPI*ZRPI
    ZR=RBOUND(I)
    ZVLT=C4TH*ZPI*ZRPI2
    ZVLM=ZERO
    do J=1,I-1
      ZVLM=ZVLM+(RBOUND(J+1)-RBOUND(J))*SQRT(ZRPI2-YLOC(J)**2)
    end do
    ZTS=(ZVLT-ZVLM)/(ZRPI-ZR)
    YLOC(I)=SQRT(ZRPI2-ZTS*ZTS)
  end do
  !------------------
  !  I NOW INITIALIZE SOME ARRAYS.
150 if(.NOT.ESFLAG.AND..NOT.MCFLAG) GO TO 180
  do IK=1,NNEUT
    WWALL(IK)=ZERO
    do I=1,NZONEC
      if(MCFLAG) WALL(I,IK)=ZERO
      !CC	    if(ESFLAG) S0COLD(I,1,     IK)=0.E00
      if(ESFLAG) S0COLD(I,NINLDX,IK)=ZERO  ! TBT 5/91
      if(ESFLAG) PRWFLX(I,IK,1)=ZERO
      if(ESFLAG) PRWFLX(I,IK,2)=ZERO
      if(.NOT.MCFLAG) GO TO 158
      !
      do J=1,NZONEC
        !CC GFUN(J,I,1,     IK)=0.E00
        GFUN(J,I,NINLDX,IK)=ZERO  ! TBT 5/91
        do IDIR=1,2
          PRFLUX(J,I,IK,IDIR)=ZERO
        end do
      end do
158   continue
    end do
  end do
  !------------------
  !  I NOW LOOP OVER ALL TRAJECTORIES
  do I=1,NZONEC
    call frantic_trackr(YLOC(I))
    call frantic_gmat
  end do
  !------------------
  call frantic_kernel
  MSFLAG=.TRUE.
  !------------------
  !  I NOW MAKE A COPY OF 4-D ARRAY GFUN + S0COLD SO THAT
  !  THE SOLUTION VECTOR CAN BE FOUND.
  !  I NOW LOOP OVER THE NEUTRAL WHICH WILL DIE IN ZONE I.
180 continue
  do IK=1,NNEUT
    JSTART=NZONEC*(IK-1)
    !  I NOW LOOP OVER THE NEUTRAL CREATED IN ZONE I.
    do INL=1,NNEUT
      ISTART=NZONEC*(INL-1)
      !  I NOW LOOP OVER ALL BIRTH ZONES OF THE K NEUTRAL.
      do J=1,NZONEC
        J1=JSTART+J
        !  I NOW LOOP OVER ALL DEATH ZONES OF THE K NEUTRAL.
        do I=1,NZONEC
          I1=ISTART+I
          ZDD(I1,J1)=GFUN(I,J,INL,IK)
        end do
      end do
    end do
  end do
  !------------------
  !  I NOW ATTACH THE SOLUTION VECTOR.
  IROW=NZONEC*NNEUT
  JCOL=IROW+1
  do I=1,IROW
    ZDD(I,JCOL)=ZERO
  end do
  if(.NOT.ESFLAG) GO TO 220
  !------------------
  do IK=1,NNEUT
    do INL=1,NNEUT
      ISTART=NZONEC*(INL-1)
      do I=1,NZONEC
        I1=ISTART+I
        ZDD(I1,JCOL)=S0COLD(I,INL,IK)+ZDD(I1,JCOL)
      end do
    end do
  end do
!------------------
220 if(.NOT.VSFLAG) GO TO 240
  do INL=1,NNEUT
    ISTART=NZONEC*(INL-1)
    do I=1,NZONEC
      I1=ISTART+I
      ZDD(I1,JCOL)=VOLSOR(I,INL)+ZDD(I1,JCOL)
    end do
  end do
!------------------
240 if(.NOT.RCFLAG) GO TO 270
  !  I NOW FILL UP ARRAY SVRC
  do I=1,NZONEC
    call sigvte_reco(temp(i,1),1,zsigv)  ! <sigma*v> recomb., m**3/sec
    SVRC(I)=DEN(I,1)*1.0e6_fp*zsigv
  end do
  do INL=1,NNEUT
    IL=NSPEC(INL)
    ISTART=NZONEC*(INL-1)
    do I=1,NZONEC
      I1=ISTART+I
      ZDD(I1,JCOL)=SVRC(I)*DEN(I,IL)+ZDD(I1,JCOL)
    end do
  end do
  !------------------
  !  I NOW CALL GAUSSE TO SOLVE THE EQUATIONS
270 continue
  if(IROW.GT.INN1) GO TO 9000
  call frantic_gausse(ZDD,INN1,IROW,JCOL,ZSTOR1,CEPS4,6)
  !------------------
  !  PUT ANSWER (NET SCE RATE) IN COMMON ARRAY -- D. MC CUNE 8 JUN 81
  TSTOR1=0.0
  do IK=1,NNEUT
    do I=1,NZONEC
      IOFF=(IK-1)*NZONEC+I
      if(abs(ZSTOR1(IOFF)).gt.EPSLON) TSTOR1(I,IK)=ZSTOR1(IOFF) !MG fixed 12/19/2013
    end do
  end do
  !------------------
  call frantic_editr
  call frantic_edits
  !------------------
  return
  !------------------
  !------------------
280 WRITE(LUN6,290)
290 FORMAT(T2,'NO SOURCES MEANS NO NEUTRALS MEANS NO WORK.  NEUTS')
  call BAD_EXIT
  !------------------
  !------------------
9000 continue
  WRITE(LUN6,9001)
9001 FORMAT(T2,'DIMENSIONALITY OF PROBLEM TOO LARGE.  NEUTS')
  call BAD_EXIT
  !------------------
  !------------------
end subroutine frantic_neuts

C----------------------------------------------------------------------
C  GFTICJ  ACCEPT CONTROL VALUE FROM TERMINAL
C
      SUBROUTINE GFTICJ(ZSG,IVALX,IVALY,IDFLT,IMIN,IMAX)
C
      CHARACTER*8 ZSG
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      LUNTRM=LNOUT(0)
C
 5    CONTINUE
C
      IF(LXOUT(0)) WRITE(LUNTRM,1001)
 1001   FORMAT(
     >' %ENTER CONTROL CODE VALUE; "D" FOR DEFAULT VALUE SELECTION'/
     >'  "Q" TO QUIT WITHOUT SPECIFYING NEW VALUE.'/
     >'  PROMPT TO APPLY TO X AXIS, Y AXIS, OR BOTH, WILL FOLLOW'/)
C
 10   CONTINUE
      CALL UREAD(
     >'GFTICI:  ENTER '//ZSG//' CONTROL CODE NEW VALUE, OR "Q":$$')
      IF(LCHAR('Q')) THEN
        GO TO 1000
      ELSE IF(LCHAR('D')) THEN
        IVAL=IDFLT
      ELSE
        IVAL=IDCOD(IERT)
        IF(IERT.NE.0) GO TO 10
        IF((IMIN.GT.IVAL).OR.(IMAX.LT.IVAL)) THEN
          CALL UERMSI(
     >'%GFTICI - CONTROL CODE VALUE OUT OF RANGE',IVAL,0)
          GO TO 10
        ENDIF
      ENDIF
C
      IF(LXOUT(0)) WRITE(LUNTRM,1003) ZSG,IVAL
 1003   FORMAT(' % NEW ',A,' VALUE = ',I2,
     >           '; ENTER "Q" TO ABORT CHANGE')
C
      CALL UREAD(
     >'GFTICI:  ENTER "X" TO APPLY TO X AXIS, "Y" FOR Y AXIS, "B" FOR'//
     >'BOTH:$')
C
      IF(LCHAR('Q')) THEN
        GO TO 1000
      ELSE IF(LCHAR('X')) THEN
        IVALX=IVAL
      ELSE IF(LCHAR('Y')) THEN
        IVALY=IVAL
      ELSE IF(LCHAR('B')) THEN
        IVALX=IVAL
        IVALY=IVAL
      ELSE
        CALL UERMSG('GFTICI:  WHAT?',' ',0)
        GO TO 5
      ENDIF
C
 1000   CONTINUE
      RETURN
      END

C******************** START FILE GRFAH0.FOR ; GROUP GRFAH0 ******************
C  GRFAH0 - MAKE SCALED LABELED PLOT OF 1 OR 2 FCNS F(X)
C
C  REWRITTEN DMC FEB 1986 TO MAKE STANDARDIZED SUBROUTINE CALL
C
      SUBROUTINE GRFAH0(X,Y,N,XLAB,YLAB,ZTITL,IFIXD,ZFIXD)
C
      REAL X(N),Y(N)  ! PLOT DATA
C
C  UFILES STYLE LABELS FOR X, Y:  1ST 20 CHARS -- DATA LABEL;
C    LAST 10 CHARS -- PHYS. UNITS
C
      CHARACTER*30 XLAB,YLAB
C
C  PLOT TITLE LABEL
C
      CHARACTER*(*) ZTITL
C
C  FIXED PT DATA LABEL (OPTIONAL, PRESENT IF IFIXD=1)
C
      CHARACTER*(*) ZFIXD
C
      IF(IFIXD.EQ.1) THEN
        CALL GRAFX1(X,Y,N,XLAB(21:30),YLAB(21:30),
     >                ZTITL,ZFIXD,YLAB(1:20)//' VS. '//XLAB(1:20) )
      ELSE
        CALL GRAFX1(X,Y,N,XLAB(21:30),YLAB(21:30),
     >                ZTITL,' ',YLAB(1:20)//' VS. '//XLAB(1:20) )
      ENDIF
C
      RETURN
      END
C
C******************** END FILE GRFAH0.FOR ; GROUP GRFAH0 ******************

C-----------------------------------------------------------------------
C  UGMODE -- UREAD SET TERMINAL INTO TEKTRONIX GRAPHICS MODE
C
      SUBROUTINE UGMODE
C
      USE USERIO
C
      CALL AGSGRF
C
      RETURN
      END

module fpreact_parameters
 
  !  these are standard values for argument of `hatom_btsigv/
 
  !  "irtype" -- reaction table selection
  integer, parameter :: fpreact_CX = 1    ! <sigma*v>cx
  integer, parameter :: fpreact_II = 2    ! <sigma*v>ii
  integer, parameter :: fpreact_EAV = 3   ! <Eav>cx
  integer, parameter :: fpreact_FD = 4    ! <vb.vtarg>/|vb*vth|
 
  !  "beamchrg" -- whether beam is neutral and target is ionized, or
  !                vice versa
 
  integer, parameter :: fpreact_NEUTRAL_BEAM = 1
  integer, parameter :: fpreact_ION_BEAM = 2
 
  !  common Z's of elements...
 
  integer, parameter :: fpreact_Z_H = 1
  integer, parameter :: fpreact_Z_He = 2
  integer, parameter :: fpreact_Z_Li = 3
  integer, parameter :: fpreact_Z_C = 6
  integer, parameter :: fpreact_Z_O = 8
 
end module fpreact_parameters

C******************** START FILE FLINT.FOR ; GROUP SIGS2 ******************
C================================================================
C
C  FLINT
C   INTERPOLATE ON A 2D ARRAY
C
      REAL FUNCTION FLINT(NOUT,ARRAY,X,Y,IDENT,
     >   XMIN,XMAX,XLR,NX,YMIN,YMAX,YLR,NY)
C
      DIMENSION ARRAY(NX,NY)
c
c Interpolates the table ARRAY(NX,NY) to find the value at (x,y).
c If XLR>0, then the X grid is equally spaced on a logarithmic scale:
c
c   X(i) = XMIN * (exp(XLR)) ** ( (i-1)/(NX-1) )
c
c   So X(i) ranges from XMIN to XMIN*exp(XLR), and XLR=log(xmax/xmin).
c
c For XLR<=0, the X grid is equally spaced on a linear scale from
c XMIN to XMAX.
c
c For YLR>0, Y is logarithmically spaced from YMIN to YMIN*exp(YLR)
c and for YLR<=0, Y is linearly spaced from YMIN to YMAX.
c
c NOUT is the fortran unit to write error messages to.
c IDENT is a code identifying the table ARRAY in error messages.
C
      COMMON/ZFLINT/ ZX,ZY,JDENT,IPXL,IPYL,IPXH,IPYH
C
      external zcflnt                   ! block data initialization
C
C
      ZX=X
      ZY=Y
C
      if(zx .lt. xmin) then
          zzx=0.0
      else
 
      IF(XLR.GT.0.0) THEN
        ZLOGX=ALOG(ZX/XMIN)
        ZZX=1.0+ZLOGX/XLR * (NX-1)
      ELSE
        ZZX=1.0+(ZX-XMIN)/(XMAX-XMIN) * (NX-1)
      ENDIF
 
      endif
C
      if(zy .lt. ymin) then
          zzy=0.0
      else
 
      IF(YLR.GT.0.0) THEN
        ZLOGY=ALOG(ZY/YMIN)
        ZZY=1.0+ZLOGY/YLR * (NY-1)
      ELSE
        ZZY=1.0+(ZY-YMIN)/(YMAX-YMIN) * (NY-1)
      ENDIF
 
      endif
C
      IX=ZZX
      IY=ZZY
C  CHECK FOR POINT OUT OF BOUNDS OF ARRAY
      IF(IX.GE.1) GO TO 10
C
      IPXL=IPXL-1
      IF(IPXL.GE.0) WRITE(NOUT, 9001) IDENT,X,Y
 9001 FORMAT(/////' *************************************'/
     >  '  ATTEMPT TO INTERPOLATE OUT OF BOUNDS    IDENT=',I8/
     >  '  FLINT SIGMA*V TABLE LOOKUP, STANDARD FIXUP TAKEN'/
     >  '  ARGUMENTS:  X=',1PE10.3,'  Y=',1PE10.3/
     >  ' **************************************'//////)
      IX=1
      ZZX=1.0
C
 10   CONTINUE
      IF(IY.GE.1) GO TO 20
      IPYL=IPYL-1
      IF(IPYL.GE.0) WRITE(NOUT, 9001) IDENT,X,Y
      IY=1
      ZZY=1.0
C
 20   CONTINUE
      IF(IX.LT.NX) GO TO 30
      IX=NX-1
      ZZX=NX
C
      IF(ZX.GT.XMAX) THEN
        write(nout,9001) ident,x,y
        CALL BAD_EXIT  ! DEEMED FATAL - DMC 1988
      ENDIF
C
 30   CONTINUE
      IF(IY.LT.NY) GO TO 40
      IY=NY-1
      ZZY=NY
C
      IF(ZY.GT.YMAX) THEN
        write(nout,9001) ident,x,y
        CALL BAD_EXIT  ! DEEMED FATAL - DMC 1988
      ENDIF
C
C---------------------------
C  OK
C
 40   CONTINUE
      IXP1=IX+1
      IYP1=IY+1
      ZZX=ZZX-IX
      ZZY=ZZY-IY
      ZF00=(1.-ZZX)*(1.-ZZY)
      ZF01=(1.-ZZX)*ZZY
      ZF10=ZZX*(1.-ZZY)
      ZF11=ZZX*ZZY
C
C  INTERPOLATE
C
      FLINT=ZF00*ARRAY(IX,IY)+ZF01*ARRAY(IX,IYP1)+
     >        ZF10*ARRAY(IXP1,IY)+ZF11*ARRAY(IXP1,IYP1)
C
      RETURN
      	END
C
C******************** END FILE FLINT.FOR ; GROUP SIGS2 ******************

C******************** START FILE UDECOP.FOR ; GROUP URDUTS ******************
c--------------------------------------------------
C&  UDECOP   UNPACK UREAD PROMPT
C
      SUBROUTINE UDECOP(ABUFFI)
C
      USE USERIO
C
      CHARACTER*(*) ABUFFI
C
C  MOD DMC-- IGNORE LACK OF TRAILING "$" IN PROMPT -- JAN 1988
C
C  also limit the length of program prompts to 130 characters
      integer, parameter :: ilbuf = 130
C
C----------------------------------------------------
C
      ILEN=LEN(ABUFFI)
C
      NL1LIN=.FALSE.
C
C---------------
C  FIND LAST CHAR WHICH IS NEITHER BLANK NOR MDOLLR
C
      INBLANK=0
      DO 5 IC=ILEN,1,-1
        IF(ABUFFI(IC:IC).NE.' ') INBLANK=1
        IF((INBLANK.EQ.1).AND.(ABUFFI(IC:IC).NE.MDOLLR))
     >      GO TO 6
 5    CONTINUE
      IC=0
 6    CONTINUE
C
      ICTES=MIN0(ILEN,(IC+1))
C
      IF(ABUFFI(ICTES:ICTES).NE.MDOLLR) THEN
        INDOL=0
      ELSE
        INDOL=ICTES
      ENDIF
C
      IF(INDOL.GT.0) GO TO 10
C
      INDOL=ILEN+1
      GO TO 15
C
C---------------------------------
 10   CONTINUE
C  CHECK FOR DOUBLE "$" FOR ONE LINE PROMPT/ANSWER COMBO
      IF(ILEN.GT.INDOL) THEN
        IDP=INDOL+1
        IF(ABUFFI(IDP:IDP).EQ.MDOLLR) NL1LIN=.TRUE.
      ENDIF
C
 15   CONTINUE
      IF(INDOL.LE.ILBUF) GO TO 20
C
        WRITE(LUNTRM,9002) ILBUF
 9002   FORMAT(' ? PROMPT PASSED TO SUBROUTINE UREAD'/
     >           '   EXCEEDS LIMIT OF ',I3,' CHARACTERS -- TRUNCATED')
C
        INDOL=ILBUF
C
 20   CONTINUE
C
      NCHARA=INDOL-1
C
      ICHARA=MAX0(1,NCHARA)
      DO 60 I=ICHARA,LBUFF
        BBUFF(I)=' '
 60   CONTINUE
C
      IF(NCHARA.EQ.0) GO TO 100
C
      READ(ABUFFI,1002) (BBUFF(I),I=1,ICHARA)
 1002 FORMAT(132A1)
C
 100  CONTINUE
C
      NCP1A=NCHARA+1
      NCP2A=NCHARA+2
C  INSERT '$'
      BBUFF(NCP1A)=MDOLLR
C  DEFINE ABUFF
      ABUFF = ' '
      WRITE(ABUFF,1002) (BBUFF(IJ),IJ=1,NCP1A)
C
      RETURN
      	END
C******************** END FILE UDECOP.FOR ; GROUP URDUTS ******************

C******************** START FILE UFIMSG.FOR ; GROUP UFILS0 ******************
C--------------------------------------------------------------------
C  UFIMSG
C   SET INFORMATIVE MESSAGE OUTPUT LEVEL
C    =-LUN  *NEW FEB 1986*  IF A NEGATIVE NUMBER IS SPECIFIED,
C      IT IS ASSUMED TO BE THE LUN FOR A FILE TO RECEIVE ALL UFILES
C      INFORMATIONAL AND ERROR MESSAGES; UPAUST CALL IS TURNED OFF
C      ALL MESSAGES ARE TURNED ON
C      *CALLER RESPONSIBILITY TO OPEN A FILE ON UNIT LUN*
C
C    =0:  NO MESSAGES
C    =1:  ALL MESSAGES (DEFAULT)
C
C   *THIS ROUTINE HAS NO AFFECT ON OUTPUT OF ERROR MESSAGES*
C    INFORMATIVE MESSAGES ONLY
C
      SUBROUTINE UFIMSG(IARG)
C
      USE UFILES
C
      CALL UFINIT
C
      IF(IARG.GE.0) THEN
C
        ILEV=IARG
C
C  ONES DIGIT OF UFILEV IS INFORMATIONAL MESSAGE FLAG
C  TENS DIGIT OF UFILEV IS ERROR MESSAGE FLAG
C
C  SET ONES DIGIT
C
        UFILEV=10*(UFILEV/10) + ILEV
C
      ELSE
        UFILEV=11
        UFELUN=-IARG
      ENDIF
C
      RETURN
      END
C******************** END FILE UFIMSG.FOR ; GROUP UFILS0 ******************

      subroutine add_file(lun,runid,node,mds_server,
     >           mds_tree,mds_shot,mds_path,ier)
C add a file, e.g. TR.DAT namelist or TR.EXE to TRANSP Tree
C
C    Mods
C        24Oct2003  James.Conboy@jet.uk  ( if __JET
C                   Dont override the namelist MDS spec if 
C                   creating a TRJOB tree
C        22Aug2007  CLF: Handle commented out/missing mdsplus defs
C-----------------------------------------------------------------
C
      implicit none
 
      integer        lun          ! to write error messages
      character*(*)  runid        ! no trailing blanks
      character*(*)  node         ! no trailing blanks (where to put file)
      character*(*)  mds_server   ! namelist only
                                  ! filename if NODE=.NML:
      character*(*)  mds_tree     ! namelist only
      integer        mds_shot     ! namelist only
      character*(*)  mds_path     ! namelist only
      integer        ier
 
      integer        descr, MdsValue, MdsPut
      integer        stat, dsc, size
 
      character*240  filnam
      integer        ios, i,  ii, j, l, k, k1
      integer        i1,  i2, jj, n, icom
      integer        ll,  m,  k2, k3,   kk,  kz

      integer        nlines, linsert, total, ninsert
      logical        nml
      logical        a_kmds, a_shot, a_path, a_tree, a_srv
      logical        c_kmds, c_shot, c_path, c_tree, c_srv
      logical        iex90

      character*132  line, temp
      character*1    q
      character*1,   allocatable :: text(:)
 
C--------------------------------------------------------
C
      q = char(39)
      a_kmds = .false.
      a_shot = .false.
      a_tree = .false.
      a_path = .false.
      a_srv  = .false.
      c_kmds = .false.
      c_shot = .false.
      c_tree = .false.
      c_path = .false.
      c_srv  = .false.
      iex90  = .false.
      linsert = 0
      ninsert = 0
      if (node .eq. 'NAME_LIST') then
         filnam = runid//'TR.DAT'
         nml = .true.
      else if (node .eq. 'EXPERT_CODE') then
         filnam = runid//'ex.for'
         nml = .false.
         inquire(file=filnam, exist=iex90)
         if (iex90) then
            iex90 = .false.  ! use ex.for file as is
         else
            filnam = runid//'ex.f90'
            inquire(file=filnam, exist=iex90)
            if (.not. iex90) then
               write(lun,'(a)') '?add_file -- unable to find '
     &              //runid//'ex.for or '//runid//'ex.f90'
               ier=1 ; return
            end if
         end if
      else if (node .eq. 'CONTENTS') then
         filnam = runid//'TF.PLN'
         nml = .false.
      else if (node .eq. 'NB_NAMELIST') then
         filnam = runid//'_nubeam_init.dat'
         nml = .false.
      else if (node .eq. 'COMMENT') then
         call sget_env('QSHARE',filnam)
         ll = len_trim(filnam)+1
         filnam(ll:) = '/CC/'//runid//'CC.TMP'
         nml = .false.
      else if (node(1:5) .eq. '.NML:') then
         filnam = mds_server
         nml = .false.
      endif
 
C open file, read to get size
      print *,'open ',filnam
      open (29,file=filnam,status='OLD',iostat=ios,err=101,
     >      action="read")
      nlines = 0
      size = 0
C
      do while (ios .eq. 0)
         line=' '
         read(29,'(a)',iostat=ios,end=105,err=104)line
         nlines=nlines+1
         l = len_trim(line)
         if (l .gt. size) size = l
         if (iex90 .and. nlines==1) then
            line = adjustl(line)
            iex90 = (line /= '!f90!')   ! do not add marker if already there
         end if
         if (nml) then
            call uupper(line)
            j=index(line(1:l),'$TRDATA')
            if (j .gt. 0) then
               icom=index(line(1:l),'!') ! check if in comment
               if (icom.eq.0 .or. icom.gt.j) linsert = nlines
            endif
            j=index(line(1:l),'KMDSPLUS')
            if (j .gt. 0) then
               icom=index(line(1:l),'!') ! check if in comment
               if (icom.eq.0 .or. icom.gt.j) then
                  a_kmds = .true.
               else
                  c_kmds = .true.
               endif
            endif
            j=index(line(1:l),'MDS_')
            if (j .gt. 0) then
               icom=index(line(1:l),'!') ! check if in comment
               if (line(j:j+7) .eq. "MDS_SHOT") then
                  if (icom.eq.0 .or. icom.gt.j) then
                     a_shot=.true.
                  else
                     c_shot=.true.
                  endif
               else if (line(j:j+9) .eq. "MDS_SERVER") then
                  if (icom.eq.0 .or. icom.gt.j) then
                     a_srv=.true.
                  else
                     c_srv=.true.
                  endif
               else if (line(j:j+7) .eq. "MDS_PATH") then
                  if (icom.eq.0 .or. icom.gt.j) then
                     a_path=.true.
                  else
                     c_path=.true.
                  endif
               else if (line(j:j+7) .eq. "MDS_TREE") then
                  if (icom.eq.0 .or. icom.gt.j) then
                     a_tree=.true.
                  else
                     c_tree=.true.
                  endif
               endif
            endif
            j=index(line(1:l),'EXPERT_FILE')
            if (j .gt. 0) then
               icom=index(line(1:l),'!')     ! check if in comment
               if (icom.eq.0 .or. icom.gt.j) then
                  size = max(size,l+1)       ! not in comment but will be
               end if
            end if
         endif
      end do
      if (ios .eq. -1) go to 105
 104  close(29)
         write(lun,'(" ?add_file -- error reading ",a,i6)')
     >        filnam,ios
         ier = 1
         return
 105  close(29)
      print*,' add_file: ',nlines,' lines -',size

C Allocate text array
C--------------------
      size=max(size,(len(mds_server)+13))
      size=max(size,40)
      ninsert=0
      if (nml) then                ! namelist
         total = nlines*size
         if (a_kmds .or. c_kmds) then
            if (a_kmds) c_kmds=.false.
         else
            ninsert=ninsert+1
         endif
         if (a_shot .or. c_shot) then
            if (a_shot) c_shot=.false.
         else
            ninsert=ninsert+1
         endif
         if (a_srv .or. c_srv) then
            if (a_srv) c_srv=.false.
         else
            ninsert=ninsert+1
         endif
         if (a_tree .or. c_tree) then
            if (a_tree) c_tree=.false.
         else
            ninsert=ninsert+1
         endif
         if (a_path .or. c_path) then
            if (a_path) c_path=.false.
         else
            ninsert=ninsert+1
         endif
         nlines=nlines+ninsert
         total=total + ninsert*size
      else if (iex90) then
         ninsert = 1
         nlines  = nlines+ninsert
         total   = nlines*size 
      else                        ! other file
         total = nlines*size
      endif
      allocate(text(total),stat=stat)
      if (stat .ne. 0) then
         write(lun,'(" ?add_file -- error allocating text(",i8,")",
     >        i6)') nlines*size,stat
         ier=1
         return
      else
C clear allocated array
         do i=1,(nlines*size)
            text(i) = ' '
         end do
      endif
 
      if (nml) then
C Check if found $TRDATA
         if (ninsert .gt. 0 .and. linsert .le. 1) then
            write(lun,'(" ?add_file --  missing $TRDATA ")')
C            ier = 1
C            return
            linsert = 20
         endif
      endif
 
C open file again, to read into text array
C------------------------------------------
      open (29,file=filnam,status='OLD',iostat=ios,err=101,
     >      action="read")
      if (ninsert .gt. 0  .and. nml) then
         i1=1
         i2=linsert
         n=2
      else
         i1=1
         i2=nlines
         n=1
      endif
      do jj=1,n
         do i=i1,i2
            j=(i-1)*size+1
            if (i==1 .and. iex90) then
               line = '!f90!'
            else
               read(29,'(a)',iostat=ios,err=103)line
            end if
            l = len_trim(line)
C Namelist:
            if (nml) then
               temp=line(1:l)
               call uupper(temp)
               icom=index(temp(1:l),'!')   ! check if in comment
               if (a_kmds .or. c_kmds) then 
                  kk=index(temp(1:l),'KMDSPLUS') ! force kmdsplus=1 
               else
                  kk=0
               endif
               k=index(temp(1:l),'MDS_')   ! Input Tree -> Run Tree
               k1=index(temp(1:l),'EXT')   ! EXT -> TRANSP Label
               if (kk.gt.0 )then
                  if ( c_kmds .or. (icom.eq.0 .or. kk.lt.icom)) then
                     line = ' kmdsplus=1' ! force kmdsplus=1
                     l = len_trim(line)
                  endif
               else if (k.gt.0 ) then
C        Replace with Run MDSplus
#ifdef __JET
                 if( mds_tree(1:5) .ne. "TRJOB" )       then
#endif
                  if (temp(k:k+7) .eq. "MDS_SHOT") then
                     if (c_shot .or. (icom.eq.0 .or. k.lt.icom)) then 
                        write(line,'(" mds_shot=",i10)')mds_shot
                     endif
                  else if (temp(k:k+9) .eq. "MDS_SERVER") then
                     if (c_srv .or. (icom.eq.0 .or. k.lt.icom)) then 
                        line = ' mds_server='//q//mds_server//q
                     endif
                  else if (temp(k:k+7) .eq. "MDS_TREE") then
                     if (c_tree .or. (icom.eq.0 .or. k.lt.icom)) then 
                        line = ' mds_tree='//q//mds_tree//q
                     endif
                  else if (temp(k:k+7) .eq. "MDS_PATH") then
                     if (c_path .or. (icom.eq.0 .or. k.lt.icom)) then 
                        line = ' mds_path='//q//mds_path//q
                     endif
                  endif
#ifdef __JET
                 endif
#endif
                  l = len_trim(line)
               else if (k1.gt.0 .and. (icom.eq.0 .or. k1.lt.icom)) then
C        Replace EXT with TRANSP Label = MDS Node Name
                  k=index(line(1:l),'=')
C        Leave ZZZZZZ unchanged
                  kz=index(line(k+1:l),'ZZZZZZZZ')
                  if (kz .le. 0 .and. k .gt. 0) then
                     temp = line
                     line = temp(1:k)//q//temp(k1+3:k1+5)
                     ll = len_trim(line)+1
C Check for multiple SIM
C Form: extsim(i) = 'ext1'
                     k2=index(temp(1:k),'(')+1
                     if (k2 .gt. 1) then
                        k3=index(temp(1:k),')')-1
                        do n=k2,k3
                           if (temp(n:n) .ne. ' ') m=ichar(temp(n:n))
                        enddo
                     else
C Form: extsim = 'ext1', 'ext2'
                        if (icom .gt. 0) l=icom
                        m=0
                        k2=index(temp(k:l),',')
                        do while (k2 .gt.0 .and. k2 .le. l)
                           if (m .eq. 0) m=49
                           line(ll:) = '0'//char(m)//q//','//q//
     >                          temp(k1+3:k1+5)
                           ll=ll+8
                           k=k+k2
                           k2=index(temp(k:l),',')
                           m=m+1
                        enddo
                     endif
                     if (m .gt. 0) then
                        line(ll:) = '0'//char(m)//q
                        ll=ll+2
                     else
                        line(ll:ll)=q
                     endif
C 05/28/04 CAL: bugfix
                     l=ll
                     print*,line(1:l)
                  endif
               endif
C 10/22/13 RGA: comment out expert_file namelist variable
               ii=index(adjustl(temp(1:l)),'EXPERT_FILE')
               if (ii .eq. 1) then
                  line(2:l+1)=line(1:l)
                  line(1:1) = '!'
                  l=l+1
               end if
               
            endif
            do ii=1,l
               text(j) = line(ii:ii)
               j=j+1
            end do
         end do
C Add MDSplus specifications
         if (jj .eq. 1 .and. n .eq. 2) then
            do i=1,5
               line=' '
               if (i .eq. 1) then
                  if (.not. a_kmds .and. .not. c_kmds) 
     &               line = ' kmdsplus=1'
               else if (i .eq. 2) then
                  if (.not. a_shot .and. .not. c_shot) 
     &               write(line,'(" mds_shot=",i10)')mds_shot
               else if (i .eq. 3) then
                  if (.not. a_srv .and. .not. c_srv) 
     &               line = ' mds_server='//q//mds_server//q
               else if (i .eq. 4) then
                  if (.not. a_tree .and. .not. c_tree) 
     &               line = ' mds_tree='//q//mds_tree//q
               else if (i .eq. 5) then
                  if (.not. a_path .and. .not. c_path) 
     &               line = ' mds_path='//q//mds_path//q
               endif
               if (line .ne. ' ') then
                  l = len_trim(line)
                  linsert=linsert+1
                  j=(linsert-1)*size+1
                  do ii=1,l
                     text(j) = line(ii:ii)
                     j=j+1
                  end do
               endif
            end do
         endif
         i1 = linsert+1
         i2 = nlines
      end do
 
 103  if (ios .eq. 0 .or. ios .eq. -1) then
         dsc = descr(14,text,nlines,0,size)
         stat = MdsPut(node//CHAR(0), '$'//CHAR(0),
     >        dsc,0)
         if(mod(stat,2).ne.1) then
            call mdsmsg(lun,'?add_file -- put '//node//
     >   ' status:  ',stat)
         endif
      else
         ier = 1
         write(lun,'(" ?add_file -- error reading ",a,i6)')
     >          filnam,ios
         go to 200
      endif
 
      ier = 0
 
 200  deallocate(text)
      return
 
 101  ier = 1
      write(lun,'(" ?add_file -- error opening ",a, i6)')
     >      filnam, ios
      return
      end
 

C******************** START FILE G3INX1.FOR ; GROUP G3MSEL ******************
C-------------------------------------------------------------
C  G3INX1
C
C  INSERT PROFILE
C  GIVEN INDEPENDANT VARIABLE VALUE ZVAL FIND NEAREST INDEX
C  LOCATION AND CORRESPONDING INDEXED IND. VAR. VALUE.  CHECK
C  AGAINST DUPLICATION AND INSERT IN LIST
C
      SUBROUTINE G3INX1(ZVAL,ISELX,X,NX,Y,NY,ISELF,ZSELF,NDIM,NSEL)
C
      REAL X(NX),Y(NY),ZSELF(NDIM)
      INTEGER ISELF(NDIM)
C
      IF(NSEL.LT.NDIM) GO TO 10
      CALL UERMSG('? EXCEEDED MAX NUMBER OF SLICES',' ',2)
      RETURN
C
 10   CONTINUE
C  LOCATE NEAREST PT.
      IF(ISELX.EQ.2) GO TO 20
        ZDMIN=AMAX1(ABS(ZVAL-Y(1)),ABS(ZVAL-Y(NY)))
        INUM=NY
        GO TO 50
C
 20   CONTINUE
        ZDMIN=AMAX1(ABS(ZVAL-X(1)),ABS(ZVAL-X(NX)))
        INUM=NX
C
 50   CONTINUE
      DO 60 I=1,INUM
      IF(ISELX.EQ.1) ZD=ABS(ZVAL-Y(I))
      IF(ISELX.EQ.2) ZD=ABS(ZVAL-X(I))
      IF(ZD.GT.ZDMIN) GO TO 60
      IMIN=I
      ZDMIN=ZD
 60   CONTINUE
C
C  CHECK FOR DUPLICATION
C
      IF(NSEL.EQ.0) GO TO 100
      DO 70 J=1,NSEL
      IF(IMIN.EQ.ISELF(J)) GO TO 90
 70   CONTINUE
      GO TO 100
C  DUPLICATE
 90   CONTINUE
      RETURN
C
 100  CONTINUE
      NSEL=NSEL+1
      ISELF(NSEL)=IMIN
      IF(ISELX.EQ.1) ZSELF(NSEL)=Y(IMIN)
      IF(ISELX.EQ.2) ZSELF(NSEL)=X(IMIN)
      RETURN
      END
C******************** END FILE G3INX1.FOR ; GROUP G3MSEL ******************

      subroutine ubi3ncod(ivalue,ilbuf,istart)
C
C  encode a non-negative integer (btw 0 and 16M) in 3 bytes,
C   hi order bits stored first.
C
      implicit NONE
C
      integer ivalue
 
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(*)
 
      integer byte1,byte2,byte3
      integer istart
C
      integer i2to8,i2to16,jvalue
C
      data i2to8/256/
      data i2to16/65536/
C-----------------------------------
C
      jvalue=ivalue
      if(jvalue.lt.0) then
         write(6,'('' ?ubi3ncod:  negative value passed.'')')
         go to 999
      endif
C
      byte1=jvalue/i2to16
      if(byte1.gt.255) then
         write(6,'('' ?ubi3ncod:  passed value too large.'')')
         go to 999
      endif
C
      jvalue=jvalue-i2to16*byte1
C
      byte2=jvalue/i2to8
C
      jvalue=jvalue-i2to8*byte2
C
      byte3=jvalue
C
C-----------
C
#if __CRAY || __SX
      if(byte1.le.127) then
         ilbuf(istart)=char(byte1)
      else
         ilbuf(istart)=char(byte1-256)
      endif
C
      if(byte2.le.127) then
         ilbuf(istart+1)=char(byte2)
      else
         ilbuf(istart+1)=char(byte2-256)
      endif
C
      if(byte3.le.127) then
         ilbuf(istart+2)=char(byte3)
      else
         ilbuf(istart+2)=char(byte3-256)
      endif
#else
      if(byte1.le.127) then
         ilbuf(istart)=byte1
      else
         ilbuf(istart)=byte1-256
      endif
C
      if(byte2.le.127) then
         ilbuf(istart+1)=byte2
      else
         ilbuf(istart+1)=byte2-256
      endif
C
      if(byte3.le.127) then
         ilbuf(istart+2)=byte3
      else
         ilbuf(istart+2)=byte3-256
      endif
#endif
C
C debugging:
cx      call ubi3dcod(ilbuf,istart,kvalue)
cx      write(6,'('' ubi3ncod:  '',2(1x,i15))') ivalue,kvalue
C
      go to 1000
C
 999  continue
C
 1000 continue
      return
      end

#include "fpreproc/f77_dcomplx.h"
!------------------------------------------------------------------------------
!
!  SIGPREP_Z -- SET ARGUMENTS FOR HARRY'S SIGMA ROUTINE FROM SIGTAB
!               REACTION NUMBER
!
SUBROUTINE SIGPREP_Z(IREACT)
!
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod
  IMPLICIT NONE
!
!  Modified:
!  10/09/94 tbt Lithium Ireact=17-21.
!
!  ARGUMENT IREACT LABELS REACTION AS IN SUBROUTINE NAMREACT
!  IN SIGTAB SUBROUTINE LIBRARY; HERE THIS IS CONVERTED TO THE
!  CONVENTION USED IN HARRY TOWNER'S FUSION CROSS SECTION ROUTINES
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER ireact
!============
  IF(IREACT.EQ.1) THEN
     KREACT=-1                      ! H0,H+ cx
     KK=-1
  ELSE IF(IREACT.EQ.2) THEN
     KREACT=-2                      ! H0,H+ ii
     KK=-1
  ELSE IF(IREACT.EQ.3) THEN
     KREACT=4                       ! DD(n,He3) fusion
     KK=0
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.4) THEN
     KREACT=3                       ! DD(p,T) fusion
     KK=0
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.5) THEN
     KREACT=1                       ! DT fusion (D beam, T target)
     KK=0
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.6) THEN
     KREACT=1                       ! DT fusion (T beam, D target)
     KK=1
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.7) THEN
     KREACT=2                       ! DHe3 fusion (D beam, He3 target)
     KK=0
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.8) THEN
     KREACT=2                       ! DHe3 fusion (He3 beam, D target)
     KK=1
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.9) THEN
     KREACT=5                       ! TT(2n,He4) fusion
     KK=0
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.25) THEN
     KREACT=12                       ! TT(2n,He4) fusion DPC fit 06/2018
     KK=0
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.10) THEN
     KREACT=6                       ! THe3 fusion (T beam, He3 target)
     KK=1
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.11) THEN
     KREACT=6                       ! THe3 fusion (He3 beam, T target)
     KK=0
     CALL RMASS_Z(KREACT,KK,AMASS1,AMASS2,AMASS3,AMASS4)
  ELSE IF(IREACT.EQ.12) THEN
     KREACT=-3                      ! H+,He0 cx
     KK=-1
  ELSE IF(IREACT.EQ.13) THEN
     KREACT=-4                      ! H+,He0 ii
     KK=-1
  ELSE IF(IREACT.EQ.14) THEN
     KREACT=-5                      ! He++,H0 ii
     KK=-1
  ELSE IF(IREACT.EQ.15) THEN
     KREACT=-6                      ! He++,He0 cx
     KK=-1
  ELSE IF(IREACT.EQ.16) THEN
     KREACT=-7                      ! He++,He0 ii
     KK=-1
  ELSE IF(IREACT.EQ.17) THEN
     KREACT=-8                      ! H+,Li0 cx (fake cross section!)
     KK=-1
  ELSE IF(IREACT.EQ.18) THEN
     KREACT=-9                      ! H+,Li0 ii (fake cross section!)
     KK=-1
  ELSE IF(IREACT.EQ.19) THEN
     KREACT=-10                     ! He++,Li0 cx (fake cross section!)
     KK=-1
  ELSE IF(IREACT.EQ.20) THEN
     KREACT=-11                     ! He++,Li0 ii (fake cross section!)
     KK=-1
  ELSE IF(IREACT.EQ.21) THEN
     KREACT=-12                     ! Li+++,H0 ii (fake cross section!)
     KK=-1
  ELSE IF(IREACT.EQ.22) THEN
     KREACT=-13                     ! Li+++,He0 ii (fake cross section!)
     KK=-1
  ELSE IF(IREACT.EQ.23) THEN
     KREACT=-14                     ! Li+++,Li0 cx (fake cross section!)
     KK=-1
  ELSE IF(IREACT.EQ.24) THEN
     KREACT=-15                     ! Li+++,Li0 ii (fake cross section!)
     KK=-1
  ELSE
     !  DIE!
     call errmsg_exit('?sigprep_z: invalid IREACT argument value!')
  ENDIF
!
  RETURN
END SUBROUTINE SIGPREP_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 30Jun2000 fgtok

      subroutine mkbeastid(runid,ipulse,cpulse)
C make BEAST pulse number from runid
C Try-Character of runid is replaced by integer
C A=1,..., Z=26
C
C 03/02/01 C.Ludescher
C
      implicit none
      character*(*)   runid
C output
      integer         ipulse  ! mds pulse number as integer
      character*10    cpulse  ! mds pulse number as charcater
C local
      integer         lr, ls, ios
      integer         runi
      character*2     runc
 
 
      call checkid(runid,lr,ls)
      if (lr==0) then
         cpulse = " " 
         ipulse = 0
         return
      end if

      if (lr .eq. ls ) then      !  old style runid
         cpulse = runid(1:lr)
         if (lr .eq. 5) then
           read(cpulse,'(i5)',iostat=ios) ipulse
         else
           read(cpulse,'(i4)',iostat=ios) ipulse
         endif
      else
         runi=ichar(runid(ls+1:ls+1))-64
         runc=char(runi/10+48) // char(mod(runi,10)+48)
C drop leading zero
         if (runid(1:1) .eq. '0') then
            cpulse = runid(2:ls)//runc//runid(ls+2:lr)
         else
            cpulse = runid(1:ls)//runc//runid(ls+2:lr)
         endif
         read(cpulse,'(i10)',iostat=ios) ipulse
      endif
 
      if (ios .ne. 0) ipulse=0
      return
      end

C---------------------------------------
C  these are single precision REAL trig routines
C  sindr,cosdr,tandr -- arguments in degrees
C  asindr,acosdr,atandr -- inverse routines -- result in degrees
C
C  these are intended as (single precision only) substitutes for the
C  non-standard f77 intrinsic functions sind,cosd,tand,asind,acosd,atand
C  the latter not being available on all machines.
C
C  dmc 23 June 1999
C
C---------------------------------------
      real function sindr(zdeg)
      real zdeg
c
c  sine, arg in degrees, single precision
c
      data zpi/3.14159265/
 
      zrad=zdeg*zpi/180.0
      sindr=sin(zrad)
 
      return
      end
C---------------------------------------
      real function cosdr(zdeg)
      real zdeg
c
c  cosine, arg in degrees, single precision
c
      data zpi/3.14159265/
 
      zrad=zdeg*zpi/180.0
      cosdr=cos(zrad)
 
      return
      end
C---------------------------------------
      real function tandr(zdeg)
      real zdeg
c
c  tangent, arg in degrees, single precision
c
      data zpi/3.14159265/
 
      zrad=zdeg*zpi/180.0
      tandr=tan(zrad)
 
      return
      end
C---------------------------------------
      real function asindr(zarg)
c
c  arcsine, returned in degrees, single precision
c
      real zarg
 
      data zpi/3.14159265/
 
      zrad = asin(zarg)
      zdeg = zrad*180.0/zpi
 
      asindr = zdeg
      return
      end
C---------------------------------------
      real function acosdr(zarg)
c
c  arc-cosine, returned in degrees, single precision
c
      real zarg
 
      data zpi/3.14159265/
 
      zrad = acos(zarg)
      zdeg = zrad*180.0/zpi
 
      acosdr = zdeg
      return
      end
C---------------------------------------
      real function atandr(zarg)
c
c  arctangent, returned in degrees, single precision
c
      real zarg
 
      data zpi/3.14159265/
 
      zrad = atan(zarg)
      zdeg = zrad*180.0/zpi
 
      atandr = zdeg
      return
      end

C******************** START FILE URDMOD.FOR ; GROUP USINIT ******************
C---------------------------------------------
C&  URDMOD  SPECIFY UREAD INPUT MODE: COMMAND OR TEXT
C
      SUBROUTINE URDMOD(IMOD)
C
      USE USERIO
C
c  mod dmc Mar 2004 -- IMOD=0 and IMOD=1 have the same effect
c  automatic case conversion no longer done by UREAD system; 
c  uppercase conversion deferred to data conversion routiens
c  as needed...
c
c--------------------------------------------------------------
c
      LEVCMD=IMOD		! SWITCH IN COMMON BLOCK
C
      IF((IMOD.EQ.1).or.(IMOD.EQ.0)) THEN
C  COMMAND MODE
        CALL UAHEAD		! ENABLE TYPEAHEAD
        NLNULL=NLCRI  	! NULL LINES ACCEPTED IFF NLCRI SET
        CALL URDCHR		! FULL CONTROL CHARACTER SET
      ELSE IF(IMOD.EQ.2) THEN
        CALL USINGL		! DISABLE TYPEAHEAD
        NLNULL=.TRUE.		! NULL LINES ARE ACCEPTED
        CALL URDTCH		! TEXT MODE CHARACTER SET
      ELSE
        CALL UERMSI(' ? URDMOD:  ILLEGAL INPUT MODE:',IMOD,1)
        CALL URDABO
      ENDIF
C
      RETURN
      END
C******************** END FILE URDMOD.FOR ; GROUP USINIT ******************

      subroutine urdmod_get(IMOD)

      !  return current LEVCMD value

      use USERIO

      IMOD = LEVCMD

      return
      end

C******************** START FILE UF0DWR.FOR ; GROUP UFILS0 ******************
C--------------------------------------------------------------
C  UF0DWR
C  WRITE 0-DIMENSIONAL (SCALAR) DATA TO ASCII FILE
C
      SUBROUTINE UF0DWR(ILUN,IDEV_I,ZSDATE_I,
     >     SCVAL,SCLAB_I,NSC,IER)
C
C  ILUN-- LOGICAL UNIT NUMBER ON WHICH TO WRITE
C  IDEV-- TOKAMAK DEVICE -- (4 LETTERS) "PDX ","PLT ", ETC.
C  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
C  SCVAL-- A SERIES OF NSC SCALAR NUMBERS - DATA TO BE WRITTEN
C  SCLAB-- 30 CHARACTER LABEL FOR EACH ELEMENT OF SCVAL
C    E.G. SCVAL = A TIME IN SECONDS, AND
C         SCLAB = "T0:       LASER TIME SECONDS  "
C     THE FIRST 10 CHARS ARE RESERVED FOR THE KEYWORD
C  WHICH IS TERMINATED BY A ":"; THE SECOND 10 CHARACTERS ARE
C  A LABEL; THE FINAL 10 CHARS ARE A UNITS LABEL
C  NSC-- THE NUMBER OF SCALAR ELEMENTS (AND ASSOCIATED LABELS)
C
C*  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
C
C* DENOTES OUTPUT VARIABLE
      USE UFILES
C
      character*(*) IDEV_I,ZSDATE_I
      CHARACTER*30 SCLAB_I(*)
C
      CHARACTER*10 ZSDATE,ZDATE
      REAL SCVAL(*)
      character*30 sclab(max(1,nsc))
      CHARACTER*4 IDEV
C
C$r8real_input: scval
C
C  CHECK CHANNEL STATUS
C
      call ufsc_lbck(zsdate_i,zsdate,idev_i,idev,sclab_i,sclab,nsc)
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF0CWR ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.1) THEN
        CALL UERSTA(ICHAN,'UF0CWR    ')
        GO TO 9000
      ENDIF
C
C  CHANNEL STATUS OK
C
      IDIM=0
      CALL C9DATE(ZDATE)
C
C  MOD APR 1984 - SUPPORT BINARY WRITE
C
      KMPRS=UFCPRS(ICHAN)
      if(kmprs.eq.-1) then
         write(ufelun,'('' ?UF0DWR:  MDS+ write not supported.'')')
         go to 9000
      endif
C
      IF(KMPRS.EQ.0) THEN
        CALL UFAHED2(ILUN,UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE,
     >      1,iformat,IERH)
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE
      else if(kmprs.eq.2) then
         ishot=ufshot(ichan)
         call ufbhed(ilun,ishot,idev,idim,ikmprs,zdate,zsdate,1,ierh)
      ENDIF
C
C  WRITE OUT THE NUMBER OF SCALARS TO BE WRITTEN IN THE FILE
C  WRITE OUT THE SCALARS AND ASSOCIATED LABELS
C
      CALL UF0WRT(ILUN,SCVAL,SCLAB,NSC,IER)
      IF(IER.NE.0) GO TO 9000
C
      IF(KMPRS.EQ.0) WRITE(ILUN,3010)
 3010 FORMAT(' ;----END-OF-DATA-----------------COMMENTS:-----------')
C
      IER=0
      UFSTAT(ICHAN)=2
      RETURN
C
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ? DATA NOT WRITTEN DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      IER=1
      UFSTAT(ICHAN)=2
      RETURN
      	END
C******************** END FILE UF0DWR.FOR ; GROUP UFILS0 ******************

      subroutine ubrchar(ilun,zchar,ier)
C
C  UFILES low level i/o routine
C  read short uncompressed character data string
C  ...written by ubwchar
C
      use UFILES
C
      character*(*) zchar
C
      parameter (ilblen=128)
 
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(ilblen),ibyte    ! small local buffer
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
C-----------------------------------------------------
C
      ier=0
C
      CALL UFLCHK(ILUN,'ubrchar   ',ICHAN,IER)
      IF(IER.NE.0) go to 999
C
      ioff=4  ! space needed as data header
C
      zchar=' '
      ilen=len(zchar)
C
      imaxl=ilblen-ioff
C
C  read and check the length of the string
C
      call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,4)
#ifdef __CRAY
      if(ilbuf(1).ne. char(2)) then
#else
      if(ilbuf(1).ne.2) then
#endif
         write(6,'('' ?ubrchar:  expected uncompressed char.'')')
         go to 999
      endif
C
      call ubi3dcod(ilbuf,2,ilenb)
C
      if(ilenb.gt.imaxl) then
         write(6,'('' ?ubrchar -- data string exceeds buffer.'')')
         go to 999
      endif
C
      if(ilenb.gt.ilen) then
         write(6,'('' ?ubrchar -- data string too long for arg.'')')
         go to 999
      endif
C
C  read the string data
C
      call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,ilenb)
C
C  place in output string
C
      do i=1,ilenb
#ifdef __CRAY
         zchar(i:i)=ilbuf(i)
#else
         zchar(i:i)=char(ilbuf(i))
#endif
      enddo
      go to 1000
C
C  errors
C
 999  continue
      ier=1
      write(6,'('' ?UFLIB:  ubrchar low level i/o routine:  error.'')')
C
C  exit
C
 1000 continue
      return
      end

! 05may1999 fgtok -impno -s r8_precision.sub foo.sub "r8con.csh conversion"
      subroutine ugr8rng(zminv,zmaxv,prompt,zvalue)
C
C  prompt for a value -- enforce range constraints
C
C    zminv.le.zvalue  &  zvalue.le.zmaxv
C
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER lnout
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 zlocl
C============
      REAL*8 zminv,zmaxv                  ! range limits (input)
      character*(*) prompt              ! Uread prompt (input)
      REAL*8 zvalue                       ! value returned (default is input)
C
C---------------------------------------
C
 10   continue
      zlocl=zvalue
      call ureadr8(prompt,zlocl)
      if((zlocl.lt.zminv).or.(zlocl.gt.zmaxv)) then
         write(lnout(0),1001) zlocl,zminv,zmaxv
 1001    format(' %ugetrng:  the input value ',1pd18.11/
     >      '  is not in range ',1pd18.11,' to ',1pd18.11,'.')
         call uclear
         go to 10
      endif
C
      zvalue=zlocl
C
      return
      end

      subroutine build_date( cvsn_date, istat )
*.. build_date                          return transp common build date, 
*                                       from $TRANSP_BUILD_DATE, if set,
*                                       else from source/misc/build_date
*
*
*     Author                            jim.conboy@jet.uk
*     Version                           1.00,  26May2006
*     Modifications
*
*     1.00  26May2006                   jim.conboy@jet.uk
*                                       Extracted from mdsplot.for
*----_^---------------------------------=========================================|
      implicit  none
*
*
*..Arguments
*
      character(len=24),intent(out)  :: cvsn_date      ! transp common build date
      integer, intent(out)           :: istat          ! return status, 0=OK
*
*..local
      integer                        :: i,             ! loop index 
     +                                  iop,           ! file open opt
     +                                  luntrm=6       ! IO unit
*
      character(len=256)             :: zfile          ! file name buffer
*
      character(len=*),parameter     :: zcr='build_date'
*----_^------------------------------::================!.........................|
*
C
C  get TRANSP code vsn date string - may be provided in environment,
C                                    if we are lucky
C
      call sget_env( 'TRANSP_BUILD_DATE', cvsn_date )
      if(len_trim(cvsn_date) > 20 )                     then
         istat  =  0 ;                                 return
                                                       endif
*
*--    never mind, do it the hard way..
*
      write(luntrm,*) zcr,': call sget_env'
      call sget_env('CODESYSDIR',zfile)
      i=index(zfile,' ')-1
      write(luntrm,*) zcr,': call ufopen xshare_build.dat'
      iop = 1
      call ufopen(99,zfile(1:i)//'/source/misc/xshare_build.date',
     >     iop, istat, 0)
      if(istat.ne.0) call ufopen(99,'xshare_build.date',iop,istat,0)
      if(istat.ne.0) then
         if (i .gt. 1) then
            write(luntrm,*)
     1           'open failure:  source_misc:xshare_build.date'
            call bad_exit
         else
            write(luntrm,*) zcr,':  build date unknown.'
            cvsn_date = 'unknown'
         endif
      else
         read(99,'(A)') cvsn_date
         close(unit=99)
      endif
*
      end subroutine build_date

      subroutine ufilx(zfile,ilf)
C
      use USERIO
C
      character*(*) zfile
C
C  rewritten dmc 6 May 1997
C  add the default extension to the filename if it is needed
C
C  input -- zfile, filename as specified in input line
C           ilf, nonblank length of zfile
C
C output -- zfile, modified if necessary with filename .ext appended
C
C-------------------------------------
C
      character*4 zdelim
      data zdelim/':]>/'/
C
      do ic=ilf,1,-1
         if(zfile(ic:ic).eq.mdot) go to 100
         if(index(zdelim,zfile(ic:ic)).gt.0) go to 200
      enddo
      go to 200
C
C  .ext already in filename
C
 100  continue
      return
C
C  want to add .ext to filename
C
 200  continue
      zfile(ilf+1:)=mdot//filext
      return
C
      end

C******************** START FILE USPDLO.FOR ; GROUP USPARM ******************
C================================================================
C&  USPDLO    DELETE LOCAL UREAD PARAMETER BY NUMBER
C
      SUBROUTINE USPDLO(NP)
C
      USE USERIO
C
      NPT=NPLC(MAX0(NLUNIN,NLUNIO))
      IF(NP.EQ.NPT) GO TO 20
      NPTM1=NPT-1
C
      DO 10 J=NP,NPTM1
      JP1=J+1
      PLCNAM(J,MAX0(NLUNIN,NLUNIO))=PLCNAM(JP1,MAX0(NLUNIN,NLUNIO))
      PLCVAL(J,MAX0(NLUNIN,NLUNIO))=PLCVAL(JP1,MAX0(NLUNIN,NLUNIO))
 10   CONTINUE
C
 20   CONTINUE
      NPLC(MAX0(NLUNIN,NLUNIO))=NPT-1
      PLCNAM(NPT,MAX0(NLUNIN,NLUNIO))=' '
      PLCVAL(NPT,MAX0(NLUNIN,NLUNIO))=' '
C
      RETURN
      END
C******************** END FILE USPDLO.FOR ; GROUP USPARM ******************

subroutine wait_for_file(luntmp,filename,luntty,idelete,istry,iswarn,isfail, &
     istat)

  ! look for a file "filename" every "istry" seconds.
  ! if not found, issue warning every "iswarn" seconds.
  ! time out after "isfail" seconds.
  !
  ! if idelete=1, delete the file when it is found.
  ! if idelete=0, the file is left open on exit.
  !
  ! return istat=0 if file was found; istat=1 if timed out.

  ! defaults:  istry = 0 => try once per second
  !            iswarn = 0 => warn once every 60 seconds
  !            isfail = 0 => timeout after 300 seconds

  implicit NONE

  !----------------
  !  arguments
  integer, intent(in) :: luntmp           ! Fortran LUN for opening "filename".
  character*(*), intent(in) :: filename   ! name of file sought
  integer, intent(in) :: luntty           ! Fortran LUN for messages
  integer, intent(in) :: idelete          ! =1 to delete file once found
  integer, intent(in) :: istry            ! try every "istry" seconds
  integer, intent(in) :: iswarn           ! warn every "iswarn" seconds
  integer, intent(in) :: isfail           ! time out after "isfail" seconds

  integer, intent(out) :: istat           ! completion status, 0=OK, 1=time out

  !----------------
  !  local
  character*160 file_list(1)
  integer, parameter :: inlist = 1
  integer :: igot

  !----------------

  file_list(1)=filename

  call wait_for_file_list(luntmp,inlist,file_list, &
       luntty,idelete,istry,iswarn,isfail,igot,istat)

end subroutine wait_for_file

subroutine wait_for_file_list(luntmp,inlist,file_list, &
     luntty,idelete,istry,iswarn,isfail, &
     igot,istat)

  ! look for any of a list of files every "istry" seconds.
  ! if not found, issue warning every "iswarn" seconds.
  ! time out after "isfail" seconds.
  !
  ! if idelete=1, delete the file when it is found.
  ! if idelete=0, the file is left open on exit.
  !
  ! return igot=<index to file that was opened> or 0 if timed out
  ! return istat=0 if file was found; istat=1 if timed out.

  ! defaults:  istry = 0 => try once per second
  !            iswarn = 0 => warn once every 60 seconds
  !            isfail = 0 => timeout after 300 seconds

  implicit NONE

  !----------------
  !  arguments
  integer, intent(in) :: luntmp           ! Fortran LUN for opening "filename".
  integer, intent(in) :: inlist           ! #of files in list
  character*(*), intent(in) :: file_list(inlist)   ! names of files sought
  integer, intent(in) :: luntty           ! Fortran LUN for messages
  integer, intent(in) :: idelete          ! =1 to delete file once found
  integer, intent(in) :: istry            ! try every "istry" seconds
  integer, intent(in) :: iswarn           ! warn every "iswarn" seconds
  integer, intent(in) :: isfail           ! time out after "isfail" seconds

  integer, intent(out) :: igot            ! # of file that was opened, or 0
  integer, intent(out) :: istat           ! completion status, 0=OK, 1=time out

  !----------------
  !  local

  integer :: ilist,itry,iwarn,ifail,ictot,icwarn,io
  !----------------

  itry=max(0,istry); if(itry.eq.0) itry=1
  iwarn=max(0,iswarn); if(iwarn.eq.0) iwarn=60
  ifail=max(0,isfail); if(ifail.eq.0) ifail=300

  igot=0
  istat=0
  close(unit=luntmp,iostat=io)

  ictot=-1
  icwarn=-1
  do
     ictot=ictot+1
     icwarn=icwarn+1

     do ilist=1,inlist
        open(unit=luntmp,file=trim(file_list(ilist)),status='old',iostat=io)
        if(io.eq.0) exit
     enddo
     if(io.eq.0) exit

     close(unit=luntmp,iostat=io)
  
     if(ictot.eq.ifail) then
        write(luntty,*) ' %wait_for_file_list: after ',ifail,' seconds:'
        write(luntty,*) '  TIMED OUT waiting for file: exiting!'
        istat=1
        igot=0
        io=999
        exit
     endif

     if((icwarn.eq.iwarn).or.(ictot.le.3)) then
        if(icwarn.eq.iwarn) icwarn=0
        if(ictot.eq.0) then
           write(luntty,*) ' %wait_for_file_list: looking for any of the following files:'
           do ilist=1,inlist
              write(luntty,*) '    ',ilist,'.  ',trim(file_list(ilist))
           enddo
        else
           write(luntty,*) '  still waiting after ',ictot,' seconds...'
        endif
     endif

     call gosleep(itry) ! wait before retry

  enddo

  if((istat.eq.0).and.(io.eq.0)) then
     igot=ilist
     if(idelete.eq.1) then
        close(unit=luntmp,status='delete')
     endif
  endif

end subroutine wait_for_file_list

C******************** START FILE UFSWXY.FOR ; GROUP UFSWXY ******************
C-------------------------------------------------------------
C  UFSWXY
C  SWITCH X AND Y INDEP. VARIABLE DIMENSIONS OF 2D ARRAY
C  AND REVERSE INDEXING OF DATA ARRAY
C
      SUBROUTINE UFSWXY(F,FB,ISIZ,X,NX,Y,NY,XLAB,YLAB)
C
C  F-- 2D FUNCTION ARRAY TO BE REINDEXED
C  FB-- WORKSPACE SAME SIZE AS F
C  ISIZ- SIZE OF F, FB
C  X(NX) X INDEPENDANT VARIABLE ARRAY
C  Y(NY) Y INDEPENDANT VARIABLE ARRAY
C  XLAB X LABEL
C  YLAB Y LABEL
C
      REAL F(ISIZ),FB(ISIZ),X(ISIZ),Y(ISIZ)
      CHARACTER*10 XLAB(3),YLAB(3),ZLTEM
C
C  CLEAR FB
C
      DO 10 I=1,ISIZ
      FB(I)=0.0
 10   CONTINUE
C
C  INVERT F
C
      DO 20 IY=1,NY
      DO 20 IX=1,NX
      IP1=(IY-1)*NX+IX
      IP2=(IX-1)*NY+IY
      FB(IP2)=F(IP1)
 20   CONTINUE
C  COPY BACK
      CALL UCOPYF(FB,F,ISIZ)
C  SWITCH X,Y ARRAYS
      IMAX=MAX0(NX,NY)
      DO 30 I=1,IMAX
      ZTEM=X(I)
      X(I)=Y(I)
      Y(I)=ZTEM
 30   CONTINUE
      ITEM=NX
      NX=NY
      NY=ITEM
C  SWITCH LABELS
      DO 50 I=1,3
      ZLTEM=XLAB(I)
      XLAB(I)=YLAB(I)
      YLAB(I)=ZLTEM
 50   CONTINUE
      RETURN
      END
C******************** END FILE UFSWXY.FOR ; GROUP UFSWXY ******************

C------------------------------------------------------------
C  GAXCUR - SET 2D GRAPH AXES TYPE CONTROL CODE FOR NEXT PLOT...
C   4 VALUES SPECIFYING VARIOUS COMBINATIONS OF LOG/LIN
C   X AND Y AXES
C
      SUBROUTINE GAXCUR(ISEL)
C
      INCLUDE 'GAXES_BLK'
C
      IF(IGXINI.EQ.0) CALL GAXES0
      IAXCUR=ISEL
C
      RETURN
      END

C******************** START FILE URWORD.FOR ; GROUP URDUTS ******************
C---------------------------------------------------------------
C& URWORD FIND THE LIMITS OF A "WORD" FOR UREAD INPUT
C
      SUBROUTINE URWORD(STR,iup,LENW,LENR)
C
      CHARACTER*(*) STR
C
C  COMMAS AND/OR BLANKS DELIMIT WORDS
C   STR - INPUT STRING WITH WORD LEFT JUSTIFIED
C   IUP -  =1: convert unquoted lowercase letters to uppercase
C          =0: do not convert
C   LENW - OUTPUT LOCATION OF LAST CHARACTER OF WORD
C   LENR - OUTPUT LOCATION OF LAST CHARACTER PRECEDING
C     WORD AFTER LEFTMOST WORD (IF ANY), OR LENGTH OF INPUT
C     STRING.
C
C  SAMPLE INPUT:  "123456 GO"
C                       ^^
C             LENW______||_____LENR
C
C  LENR IS SUITABLE FOR CALL UROTOR ARGUMENT IF INPUT IS UREAD
C  TYPEAHEAD BUFFER.
C
C  LENW IS SUITABLE EG AS AN ARGUMENT FOR INTEGER OR FLOATING PT
C  DECODER ROUTINE
C
C  MOD DMC JAN 1988-- STRINGS IN DBL QUOTES ARE PASSED AS WORDS
C   CONTAINING IMBEDDED BLANKS, COMMAS, ETC.
C
C--------------------
C  REV DMC APR 1988
C  THE NEXT WORD STARTS AT THE FIRST NONBLANK CHARACTER AFTER THE
C  CURRENT WORD.  THE ONLY EXCEPTION IS THAT A COMMA "," IMMEDIATELY
C  FOLLOWING THE CURRENT WORD IS INTERPRETED AS ONLY BEING THE
C  DELIMITER FOR THE CURRENT WORD.
C
C  "12345, ZORK"
C       ^  ^             1 - END CURRENT WORD
C       1  2             2 - START NEXT WORD
C
C  "12345 , ZORK"
C       ^ ^
C       1 2
C
C  (PREVIOUSLY, THE COMMA IN THIS LAST EXAMPLE WOULD HAVE BEEN IGNORED)
C
C-------------
C  REV DMC FEB 1989
C  USER DEFINED PUNCTUATION INSTALLED.  IF USER SETS "," AND ";" AS
C  USER DEFINED PUNCTUATION, THEN, THE APPLICATION SEES THE FOLLOWING
C  AS START ADDRESSES OF (GENERALIZED) WORDS:
C
C  "12345, A,; B"
C   ^    ^ ^^^ ^
C   1    2 345 6
C
C  PUNCTUATION ITEMS ARE SEEN AS WORD STRINGS BY THE APPLICATION AND
C  MUST BE PROCESSED AT THE APPLICATIONS LEVEL.
C
C--------------------
C  EXECUTABLE CODE:
C
C  CHECK FOR INITIAL DBL QUOTE -- 2 CONSECUTIVE DBL QUOTES DO
C  NOT COUNT AS DELIMITERS
C
      ILEN=LEN(STR)
C
      CALL UWORDL(STR,-iup,IDUM,LENW,ICODE)
C
      IF(LENW.EQ.ILEN) THEN
        LENR=LENW
        GO TO 500
      ENDIF
C
      INEX=LENW+1
      IF(ICODE.EQ.2) THEN     ! TRAILING COMMA (OLD UREAD MEANING)
        IF(INEX.EQ.ILEN) THEN
          LENR=LENW
          GO TO 500
        ENDIF
        INEX=INEX+1
      ENDIF
C
      DO 10 ID=INEX,ILEN
        IF(STR(ID:ID).NE.' ') GO TO 20
 10   CONTINUE
C
      LENR=ILEN
      GO TO 500
C
 20   CONTINUE
      LENR=ID-1
C
 500  CONTINUE
C
      RETURN
C
      END
C******************** END FILE URWORD.FOR ; GROUP URDUTS ******************

      subroutine uflower(ilun)
C
C  set the filename and .ext to lower case -- for unix filenames,
C  case control option (dmc 26 Sep 1994)
C
      use UFILES
C
      integer ilun
C
C------------------------------------
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UFLOWER   ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.0) THEN
        CALL UERSTA(ICHAN,'UFLOWER   ')
        GO TO 9000
      ENDIF
C
C  OK
C
        call ulower(uprfix(ichan))
        call ulower(uextnd(ichan))
C
 9000   continue
        return
        end

C******************** START FILE GFPAKS.FOR ; GROUP GRFLBL ******************
C--------------------------------------------------------------
C  GFPAKS - PACK A LABEL STRING
C
      SUBROUTINE GFPAKS(STR1,STR2,ILEN,IFLAG)
      implicit none
C
      CHARACTER*(*) STR1,STR2
      integer       ILEN,IFLAG
      integer       IL1, IL2, ic1, ic2, idir, iblank
C
C  STR1 - INPUT STRING
C  STR2 - OUTPUT "PACKED, JUSTIFIED" STRING
C   ILEN - LENGTH IN STR2 TO USE; IF DEFAULTED USE ALL OF STR2
C
C  IFLAG = -1:  LEFT JUSTIFY
C  IFLAG = 0     CENTER
C  IFLAG = 1    RIGHT JUSTIFY ... THE OUTPUT STRING
C
C  PACKING HERE JUST MEANS REMOVAL OF "EXTRA" BLANKS; I.E. NO MORE
C  THAN ONE BLANK CHAR ALLOWED BETWEEN NON-BLANK CHARACTERS.
C
      IL1=LEN(STR1)
C
      IF(ILEN.LE.0) THEN
        IL2=LEN(STR2)
      ELSE
        IL2=MIN0(LEN(STR2),ILEN)
      ENDIF
C
      IF(IFLAG.EQ.-1) THEN
        IC2=0
        IC1=0
        IDIR=1
      ELSE
        IC2=IL2+1
        IC1=IL1+1
        IDIR=-1
      ENDIF
C
      IBLANK=1
 10   CONTINUE
C      print*,'ic..',ic1,ic2
      IC1=IC1+IDIR
C  CHECK FOR EXIT
      IF((IC1.LE.0).OR.(IC1.GT.IL1)) GO TO 100
C  CHECK NEXT CHAR; IGNORE BLANKS WHEN IBLANK=1 IS SET
      IF(STR1(IC1:IC1).EQ.' ') THEN
        IF(IBLANK.EQ.1) GO TO 10
        IBLANK=1
      ELSE
        IBLANK=0
      ENDIF
      IC2=IC2+IDIR
      IF((IC2.LE.0).OR.(IC2.GT.IL2)) GO TO 100
      STR2(IC2:IC2)=STR1(IC1:IC1)
      GO TO 10
C
C  EXIT
C
 100  CONTINUE
C  CTR THE PACKED STRING
      IF(IFLAG.EQ.0) CALL GFCTRS(STR2,IL2)
      RETURN
      END
C******************** END FILE GFPAKS.FOR ; GROUP GRFLBL ******************

!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  CHECK
      SUBROUTINE R8_CHECK(
     > R8_X,R8_Y)

      external CHECK

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CHECK -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CHECK -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CHECK -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CHECK -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  CHECK

      CALL CHECK(
     > X_act(1),Y_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  DSPLAY
      SUBROUTINE R8_DSPLAY(
     > R8_X,R8_Y)

      external DSPLAY

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_DSPLAY -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_DSPLAY -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_DSPLAY -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_DSPLAY -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  DSPLAY

      CALL DSPLAY(
     > X_act(1),Y_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGDSPL
      SUBROUTINE R8_AGDSPL(
     > R8_X,R8_Y)

      external AGDSPL

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGDSPL -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGDSPL -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGDSPL -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGDSPL -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  AGDSPL

      CALL AGDSPL(
     > X_act(1),Y_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  RGCHEK
      SUBROUTINE R8_RGCHEK(
     > NBASE,R8_ARRAY)

      external RGCHEK

! argument declarations
      INTEGER NBASE
 ! floating type, input/output:
      REAL*8 R8_ARRAY(2)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: ARRAY_act(:)
      REAL, allocatable :: ARRAY_ref(:)

! allocation of working arrays...

      ALLOCATE(ARRAY_act(2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RGCHEK -- ARRAY_act ALLOCATE error!')
      ALLOCATE(ARRAY_ref(2)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_RGCHEK -- ARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      ARRAY_act=R8_ARRAY
      ARRAY_ref=R8_ARRAY

! call to original routine:  RGCHEK

      CALL RGCHEK(
     > NBASE,ARRAY_act(1))

! copy back outputs if modified.

      where(ARRAY_act.ne.ARRAY_ref)
         R8_ARRAY = ARRAY_act
      end where
      DEALLOCATE(ARRAY_act)
      DEALLOCATE(ARRAY_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGLINT
      SUBROUTINE R8_AGLINT(
     > R8_DMIN,R8_DMAX,R8_SLNGTH,IROUND,R8_GRAN,NMOD,K1,K2)

      external AGLINT

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_DMIN
  
 ! floating type, input/output:
      REAL*8 R8_DMAX
  
 ! floating type, input/output:
      REAL*8 R8_SLNGTH
  
      INTEGER IROUND
 ! floating type, input/output:
      REAL*8 R8_GRAN
  
      INTEGER NMOD
      INTEGER K1
      INTEGER K2

! local (automatic array) declarations

      integer alloc_stat
      REAL :: DMIN_act
      REAL :: DMIN_ref
      REAL :: DMAX_act
      REAL :: DMAX_ref
      REAL :: SLNGTH_act
      REAL :: SLNGTH_ref
      REAL :: GRAN_act
      REAL :: GRAN_ref

! allocation of working arrays...


! executable code:  copy for input

      DMIN_act=R8_DMIN
      DMIN_ref=R8_DMIN

      DMAX_act=R8_DMAX
      DMAX_ref=R8_DMAX

      SLNGTH_act=R8_SLNGTH
      SLNGTH_ref=R8_SLNGTH

      GRAN_act=R8_GRAN
      GRAN_ref=R8_GRAN

! call to original routine:  AGLINT

      CALL AGLINT(
     > DMIN_act,DMAX_act,SLNGTH_act,IROUND,GRAN_act,NMOD,K1,K2)

! copy back outputs if modified.

      if(DMIN_act.ne.DMIN_ref) then
         R8_DMIN = DMIN_act
      endif

      if(DMAX_act.ne.DMAX_ref) then
         R8_DMAX = DMAX_act
      endif

      if(SLNGTH_act.ne.SLNGTH_ref) then
         R8_SLNGTH = SLNGTH_act
      endif

      if(GRAN_act.ne.GRAN_ref) then
         R8_GRAN = GRAN_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGLOGT
      SUBROUTINE R8_AGLOGT(
     > R8_DMIN,R8_DMAX,R8_SLNGTH,IROUND,R8_GRAN,NMOD,K1,K2)

      external AGLOGT

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_DMIN
  
 ! floating type, input/output:
      REAL*8 R8_DMAX
  
 ! floating type, input/output:
      REAL*8 R8_SLNGTH
  
      INTEGER IROUND
 ! floating type, input/output:
      REAL*8 R8_GRAN
  
      INTEGER NMOD
      INTEGER K1
      INTEGER K2

! local (automatic array) declarations

      integer alloc_stat
      REAL :: DMIN_act
      REAL :: DMIN_ref
      REAL :: DMAX_act
      REAL :: DMAX_ref
      REAL :: SLNGTH_act
      REAL :: SLNGTH_ref
      REAL :: GRAN_act
      REAL :: GRAN_ref

! allocation of working arrays...


! executable code:  copy for input

      DMIN_act=R8_DMIN
      DMIN_ref=R8_DMIN

      DMAX_act=R8_DMAX
      DMAX_ref=R8_DMAX

      SLNGTH_act=R8_SLNGTH
      SLNGTH_ref=R8_SLNGTH

      GRAN_act=R8_GRAN
      GRAN_ref=R8_GRAN

! call to original routine:  AGLOGT

      CALL AGLOGT(
     > DMIN_act,DMAX_act,SLNGTH_act,IROUND,GRAN_act,NMOD,K1,K2)

! copy back outputs if modified.

      if(DMIN_act.ne.DMIN_ref) then
         R8_DMIN = DMIN_act
      endif

      if(DMAX_act.ne.DMAX_ref) then
         R8_DMAX = DMAX_act
      endif

      if(SLNGTH_act.ne.SLNGTH_ref) then
         R8_SLNGTH = SLNGTH_act
      endif

      if(GRAN_act.ne.GRAN_ref) then
         R8_GRAN = GRAN_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGMNMX
      SUBROUTINE R8_AGMNMX(
     > R8_ARRAY,R8_AMIN,R8_AMAX,NPTA,ITYPE)

      external AGMNMX

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_AMIN
  
 ! floating type, input/output:
      REAL*8 R8_AMAX
  
      INTEGER NPTA
      INTEGER ITYPE
 ! floating type, input/output:
      REAL*8 R8_ARRAY(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: ARRAY_act(:)
      REAL, allocatable :: ARRAY_ref(:)
      REAL :: AMIN_act
      REAL :: AMIN_ref
      REAL :: AMAX_act
      REAL :: AMAX_ref

! allocation of working arrays...

      dim=size(R8_ARRAY)
      ALLOCATE(ARRAY_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGMNMX -- ARRAY_act ALLOCATE error!')
      ALLOCATE(ARRAY_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGMNMX -- ARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      ARRAY_act=R8_ARRAY
      ARRAY_ref=R8_ARRAY

      AMIN_act=R8_AMIN
      AMIN_ref=R8_AMIN

      AMAX_act=R8_AMAX
      AMAX_ref=R8_AMAX

! call to original routine:  AGMNMX

      CALL AGMNMX(
     > ARRAY_act(1),AMIN_act,AMAX_act,NPTA,ITYPE)
      go to 100

!-------------------------------------------------------

      ENTRY R8_mnmx(R8_array,R8_amin,R8_amax)

! allocation of working arrays...

      dim=size(R8_ARRAY)
      ALLOCATE(ARRAY_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGMNMX -- ARRAY_act ALLOCATE error!')
      ALLOCATE(ARRAY_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGMNMX -- ARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      ARRAY_act=R8_ARRAY
      ARRAY_ref=R8_ARRAY

      AMIN_act=R8_AMIN
      AMIN_ref=R8_AMIN

      AMAX_act=R8_AMAX
      AMAX_ref=R8_AMAX

! call to original routine:  AGMNMX

      CALL MNMX(
     > ARRAY_act(1),AMIN_act,AMAX_act)

!----------------------------------------------------------------------
! copy back outputs if modified.
 100     continue
      where(ARRAY_act.ne.ARRAY_ref)
         R8_ARRAY = ARRAY_act
      end where
      DEALLOCATE(ARRAY_act)
      DEALLOCATE(ARRAY_ref)

      if(AMIN_act.ne.AMIN_ref) then
         R8_AMIN = AMIN_act
      endif

      if(AMAX_act.ne.AMAX_ref) then
         R8_AMAX = AMAX_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  CPLOT
      SUBROUTINE R8_CPLOT(
     > R8_X,R8_Y)

      external CPLOT

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CPLOT -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CPLOT -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CPLOT -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_CPLOT -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  CPLOT

      CALL CPLOT(
     > X_act(1),Y_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGKEYS
      SUBROUTINE R8_AGKEYS(
     > R8_X,R8_Y,IFASTX,IFASTY,LIMIT)

      external AGKEYS

! argument declarations
      INTEGER IFASTX
      INTEGER IFASTY
      INTEGER LIMIT
 ! floating type, input/output:
      REAL*8 R8_X(:)
  
 ! floating type, input/output:
      REAL*8 R8_Y(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)

! allocation of working arrays...

      dim=size(R8_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGKEYS -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGKEYS -- X_ref ALLOCATE error!')

      dim=size(R8_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGKEYS -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGKEYS -- Y_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  AGKEYS

      CALL AGKEYS(
     > X_act(1),Y_act(1),IFASTX,IFASTY,LIMIT)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGBDGT
      REAL*8 FUNCTION R8_AGBDGT(
     > R8_XBASE,NXBASE,I)

      external AGBDGT
      REAL AGBDGT

! argument declarations
      INTEGER NXBASE
      INTEGER I
 ! floating type, input/output:
      REAL*8 R8_XBASE(3,NXBASE)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: XBASE_act(:,:)
      REAL, allocatable :: XBASE_ref(:,:)

! allocation of working arrays...

      ALLOCATE(XBASE_act(3,NXBASE)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGBDGT -- XBASE_act ALLOCATE error!')
      ALLOCATE(XBASE_ref(3,NXBASE)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGBDGT -- XBASE_ref ALLOCATE error!')

! executable code:  copy for input

      XBASE_act=R8_XBASE
      XBASE_ref=R8_XBASE

! call to original routine:  AGBDGT

      R8_AGBDGT=AGBDGT(
     > XBASE_act(1,1),NXBASE,I)

! copy back outputs if modified.

      where(XBASE_act.ne.XBASE_ref)
         R8_XBASE = XBASE_act
      end where
      DEALLOCATE(XBASE_act)
      DEALLOCATE(XBASE_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGBMNX
      SUBROUTINE R8_AGBMNX(
     > R8_ARRAY,R8_AMIN,R8_AMAX,NXBASE)

      external AGBMNX

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_AMIN
  
 ! floating type, input/output:
      REAL*8 R8_AMAX
  
      INTEGER NXBASE
 ! floating type, input/output:
      REAL*8 R8_ARRAY(3,NXBASE)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: ARRAY_act(:,:)
      REAL, allocatable :: ARRAY_ref(:,:)
      REAL :: AMIN_act
      REAL :: AMIN_ref
      REAL :: AMAX_act
      REAL :: AMAX_ref

! allocation of working arrays...

      ALLOCATE(ARRAY_act(3,NXBASE)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGBMNX -- ARRAY_act ALLOCATE error!')
      ALLOCATE(ARRAY_ref(3,NXBASE)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGBMNX -- ARRAY_ref ALLOCATE error!')

! executable code:  copy for input

      ARRAY_act=R8_ARRAY
      ARRAY_ref=R8_ARRAY

      AMIN_act=R8_AMIN
      AMIN_ref=R8_AMIN

      AMAX_act=R8_AMAX
      AMAX_ref=R8_AMAX

! call to original routine:  AGBMNX

      CALL AGBMNX(
     > ARRAY_act(1,1),AMIN_act,AMAX_act,NXBASE)

! copy back outputs if modified.

      where(ARRAY_act.ne.ARRAY_ref)
         R8_ARRAY = ARRAY_act
      end where
      DEALLOCATE(ARRAY_act)
      DEALLOCATE(ARRAY_ref)

      if(AMIN_act.ne.AMIN_ref) then
         R8_AMIN = AMIN_act
      endif

      if(AMAX_act.ne.AMAX_ref) then
         R8_AMAX = AMAX_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  ROUNDD
      REAL*8 FUNCTION R8_ROUNDD(
     > R8_VALUE,R8_FINT)

      external ROUNDD
      REAL ROUNDD

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_VALUE
  
 ! floating type, input/output:
      REAL*8 R8_FINT
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: VALUE_act
      REAL :: VALUE_ref
      REAL :: FINT_act
      REAL :: FINT_ref

! allocation of working arrays...


! executable code:  copy for input

      VALUE_act=R8_VALUE
      VALUE_ref=R8_VALUE

      FINT_act=R8_FINT
      FINT_ref=R8_FINT

! call to original routine:  ROUNDD

      R8_ROUNDD=ROUNDD(
     > VALUE_act,FINT_act)

! copy back outputs if modified.

      if(VALUE_act.ne.VALUE_ref) then
         R8_VALUE = VALUE_act
      endif

      if(FINT_act.ne.FINT_ref) then
         R8_FINT = FINT_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  ROUNDU
      REAL*8 FUNCTION R8_ROUNDU(
     > R8_VALUE,R8_FINT)

      external ROUNDU
      REAL ROUNDU

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_VALUE
  
 ! floating type, input/output:
      REAL*8 R8_FINT
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: VALUE_act
      REAL :: VALUE_ref
      REAL :: FINT_act
      REAL :: FINT_ref

! allocation of working arrays...


! executable code:  copy for input

      VALUE_act=R8_VALUE
      VALUE_ref=R8_VALUE

      FINT_act=R8_FINT
      FINT_ref=R8_FINT

! call to original routine:  ROUNDU

      R8_ROUNDU=ROUNDU(
     > VALUE_act,FINT_act)

! copy back outputs if modified.

      if(VALUE_act.ne.VALUE_ref) then
         R8_VALUE = VALUE_act
      endif

      if(FINT_act.ne.FINT_ref) then
         R8_FINT = FINT_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  BSYMS
      SUBROUTINE R8_BSYMS(
     > R8_X,R8_Y,ISYM)

      external BSYMS

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
      INTEGER ISYM

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  BSYMS

      CALL BSYMS(
     > X_act,Y_act,ISYM)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  SYMOUT
      SUBROUTINE R8_SYMOUT(
     > ISYM,R8_FACTR)

      external SYMOUT

! argument declarations
      INTEGER ISYM
 ! floating type, input/output:
      REAL*8 R8_FACTR
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: FACTR_act
      REAL :: FACTR_ref

! allocation of working arrays...


! executable code:  copy for input

      FACTR_act=R8_FACTR
      FACTR_ref=R8_FACTR

! call to original routine:  SYMOUT

      CALL SYMOUT(
     > ISYM,FACTR_act)

! copy back outputs if modified.

      if(FACTR_act.ne.FACTR_ref) then
         R8_FACTR = FACTR_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  TEKSYM
      SUBROUTINE R8_TEKSYM(
     > ISYM,R8_AMULT)

      external TEKSYM

! argument declarations
      INTEGER ISYM
 ! floating type, input/output:
      REAL*8 R8_AMULT
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: AMULT_act
      REAL :: AMULT_ref

! allocation of working arrays...


! executable code:  copy for input

      AMULT_act=R8_AMULT
      AMULT_ref=R8_AMULT

! call to original routine:  TEKSYM

      CALL TEKSYM(
     > ISYM,AMULT_act)

! copy back outputs if modified.

      if(AMULT_act.ne.AMULT_ref) then
         R8_AMULT = AMULT_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  BAR
      SUBROUTINE R8_BAR(
     > R8_X,R8_Y,LINE)

      external BAR

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
      INTEGER LINE

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  BAR

      CALL BAR(
     > X_act,Y_act,LINE)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  NUMSET
      SUBROUTINE R8_NUMSET(
     > R8_FNUM,NBASE,CLABL,IWIDTH)

      external NUMSET

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_FNUM
  
      INTEGER NBASE
      CHARACTER*12 CLABL
      INTEGER IWIDTH

! local (automatic array) declarations

      integer alloc_stat
      REAL :: FNUM_act
      REAL :: FNUM_ref

! allocation of working arrays...


! executable code:  copy for input

      FNUM_act=R8_FNUM
      FNUM_ref=R8_FNUM

! call to original routine:  NUMSET

      CALL NUMSET(
     > FNUM_act,NBASE,CLABL,IWIDTH)

! copy back outputs if modified.

      if(FNUM_act.ne.FNUM_ref) then
         R8_FNUM = FNUM_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  COMGET
      REAL*8 FUNCTION R8_COMGET(
     > ITEM)

      external COMGET
      REAL COMGET

! argument declarations
      INTEGER ITEM

! local (automatic array) declarations

      integer alloc_stat

! allocation of working arrays...


! executable code:  copy for input

! call to original routine:  COMGET

      R8_COMGET=COMGET(
     > ITEM)

! copy back outputs if modified.

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  COMSET
      SUBROUTINE R8_COMSET(
     > ITEM,R8_VALUE)

      external COMSET

! argument declarations
      INTEGER ITEM
 ! floating type, input/output:
      REAL*8 R8_VALUE
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: VALUE_act
      REAL :: VALUE_ref

! allocation of working arrays...


! executable code:  copy for input

      VALUE_act=R8_VALUE
      VALUE_ref=R8_VALUE

! call to original routine:  COMSET

      CALL COMSET(
     > ITEM,VALUE_act)

! copy back outputs if modified.

      if(VALUE_act.ne.VALUE_ref) then
         R8_VALUE = VALUE_act
      endif

! exit
      return
      end
      

C******************** START FILE UFXCHL.FOR ; GROUP UFILS0 ******************
C---------------------------------------------------------------
C  UFXCHL
C  FIND FIRST FREE CHANNEL
C  OR RETURN IER.NE.0 IF NONE AVAILABLE
C
      SUBROUTINE UFXCHL(ILUN,ICHAN,IER)
C
      USE UFILES
C
      CALL UFINIT
      IER = 0
      DO 10 ICHAN=1,UFCHAN
        IF(.NOT.LUFSET(ICHAN)) RETURN
C  CHANNEL ICHAN IS FREE
 10   CONTINUE
C
      IER=1
      RETURN
      	END
C******************** END FILE UFXCHL.FOR ; GROUP UFILS0 ******************

C  GRFMM1B
C
C  J F Schivell  23 Aug 95  -- based on GRFMM1; removed key
C
C  SET SCALE AND
C  PLOT MULTIPLOT VIA CALL TO MULFDR AND ALLOW REPEAT OF PLOT
C  ON DIFFERENT SCALE
C
C  ** PLOTTING MOMENTS FLUX SURFACE CONTOURS** THE SCALE IS MADE
C  "SQUARE" SO THAT (R,Y) SPACE OF THE POLOIDAL PLANE IS NOT
C  DISTORTED
C    RESCALE OPTION ALLOWS USER TO SPECIFY (R,Y) OF LOWER LEFT HAND
C  CORNER OF SQUARE AND LENGTH OF EDGE
C
C  ** MOD DMC 6 JUL 1992 **
C  SQUARE SCALE PLOTTING CAN BE DISABLED BY KLUGE:  SET THE FIRST
C  ELEMENT OF THE INPUT ARRAY ISELF NEGATIVE ***; THE ABSOLUTE
C  VALUE IS USED IN THE CODE LOGIC TO ADDRESS THE CURVE TO BE
C  PLOTTED, AS BEFORE.
C
C  PLOT 1 GRAPH IMMEDIATELY ON CALL WITH ESTABLISHED DEFAULTS
C  THEN GIVE OPPORTUNITY TO USER TO CHANGE SCALING/AXIS DEFAULTS
C  OR JUST ON THE FUNCTION BEING PLOTTED WITHOUT AFFECTING DEFAULTS
C  ON FUTURE CALLS.
C  USE UREAD I/O SUBROUTINE
C
C  AXES SELECTION (LOG/LINEAR FOR EITHER/BOTH/NEITHER AXES)
C  SOFTWARE IN "GAXES.FOR" IS USED
C
C  FEB 1986 - DMC
C   REWRITTEN TO USE STANDARDIZED SCALE SETTING AND POST-PLOT RESCALE
C  MENU OPTIONS
C
      SUBROUTINE GRFMM1B(R,Y,ND1,NC,NNC,Z,NZ,ISELF,NSEL,
     >     RUN,YUN,MNLAB)
C
C  ARGUMENTS -- SAME AS SUBROUTINE MULCDR (MULCDR.FOR) EXCEPT
C   ARGUMENT "IAXSEL" IS DETERMINED HERE
C
      implicit NONE
      integer nd1,nz,nsel,nnc
      REAL R(ND1,NZ),Y(ND1,NZ),Z(NZ)
      INTEGER ISELF(NSEL)
      INTEGER NC(NNC)       ! NO. OF PTS / CONTOUR
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) RUN,YUN
c
c  local
c
      integer insel,ilocsc,isel,i,ind,itot,luntrm,lnout,icod
      real zdx,zdy,zd2
      integer, save :: iopcod=0
C
C---------------------------------------------
C
      Integer, Parameter :: jmsurf = 201
      INTEGER IPTR(jmsurf),LPTR(jmsurf),JSELF(jmsurf)
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      LOGICAL ISQUARE
C
C---------------------------------------------
C
      integer icounter
C
C-------------------------------------------------------------
C
      icounter=0
C
C---------------------------------------------
C
      INSEL = NSEL
 
      IF(ISELF(1).GT.0) THEN
        ISQUARE=.TRUE.
      ELSE
        ISQUARE=.FALSE.
      ENDIF
C
C  LOCAL DEFAULT OVERRIDE SWITCHES CLEARED:
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
      CALL GAXGDF(ISEL)
C
C  SET UP INDICES FOR SCALE CALCULATION
C
      DO 5 I=1,INSEL
        JSELF(I)=IABS(ISELF(I))
        IND=JSELF(I)
        IPTR(I)=1+(IND-1)*ND1
        LPTR(I)=NC(MIN0(I,NNC))
 5    CONTINUE
C
C-------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
C  SET SCALE
C
      ITOT=ND1*NZ
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSMG(R,Y,ITOT,ITOT,IPTR,1,IPTR,1,LPTR,INSEL)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCSM0(R,Y,ITOT,ITOT,IPTR,1,IPTR,1,
     >                  LPTR,INSEL,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
C  MAKE IT A "SQUARE" SCALE
C
      IF(ISQUARE) THEN
        ZDX=XMAX-XMIN
        ZDY=YMAX-YMIN
        ZD2=0.5*ABS(ZDX-ZDY)
        IF(ZDX.GT.ZDY) THEN
          YMIN=YMIN-ZD2
          YMAX=YMAX+ZD2
        ELSE IF(ZDY.GT.ZDX) THEN
          XMIN=XMIN-ZD2
          XMAX=XMAX+ZD2
        ENDIF
      ENDIF
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD)
C
      CALL GSCREC  ! RECORD SCALE OF UPCOMING PLOT IN GSCALE COMMON
C
      CALL MULCDRB(
     >   R,Y,ND1,NC,NNC,Z,NZ,JSELF,INSEL,ICOD,
     >   RUN,YUN,MNLAB)
C
      GO TO 200
C
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      IF(ISQUARE) THEN
        CALL GRAOPT('SQA',ISEL,ILOCSC,IOPCOD,GRADUM)
      ELSE
        CALL GRAOPT('SA',ISEL,ILOCSC,IOPCOD,GRADUM)
      ENDIF
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         RETURN
      ENDIF
C
      CALL UERMSI(' ?GRFMM1 *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      	END

c	general purpose 2-d extractor.  Will extract a profile
c	at a specified time (with an averaging window) from a 2-D UFile
c
c  ** UFILE HAS BEEN OPENED BY CALLER **
c
c	M.C. Zarnstorff		Jan. 1985
c ************************************************************************
      subroutine uf1xtr(
     1	LUN,	! log. unit number to UFile
     2	tdev,	! tokamak name
     3	shdate,	! date
     5	time,	! time to extract at
     6	dtave,	! delta time to average over
     4	x,	! array to contain independent variable of data
     5	f,	! array to contain dependent variable ( data )
     6	nmax,	! size of X and F arrays.
     7	n,	! number of points of function read in
     8	iproc,	! process code
     9	xlab,	! label for X axis
     1	flab,	! label for function
     1	nscmax,	! max number of scalers
     2	nsc,	! actual number of scalers read
     3	scval,	! scaler values
     4	sclab,	! scaler labels
     7	ier)	! returned error code
 
      implicit none
 
      integer max_x
      parameter (max_x = 16384)
 
      integer iproc, ier, nsc, nscmax, n, nmax, lun
      character*10 shdate
      character*4 tdev
 
      real time, dtave
 
      real scval(nscmax)
      real x(nmax), f(nmax)
      character*10	sclab(3,nscmax)
      character*30    xlab, flab
 
      real work(40*max_x)
      real x_i(max_x), y_i(max_x)
      character*30	ylab
      integer nx, ny
      integer i,j

c$r8real_input: time,dtave
c$r8real_output: x,f,scval
 
c	go get the raw data
      call uf2drd(lun, tdev, shdate, work, 40, x_i, max_x, y_i, max_x,
     1	iproc, nx, ny, 1, flab, xlab, ylab,
     2	nscmax, nsc, scval, sclab, ier)
 
      if( ier .eq. 0) then
 
        do i=1, nmax
      	f(i) = 0.0
        enddo
 
        if( xlab(1:4) .eq. 'TIME' .or. xlab(1:4) .eq. 'time') then
          xlab = ylab
          n = ny
 
          if( n .gt. nmax) then
      	ier = 1
 
          else
      	do i=1, n
      	  x(i) = y_i(i)
      	enddo
 
              call extr_x(work,nx,ny,x_i,f, time, dtave)
          endif
        else if( ylab(1:4) .eq. 'TIME' .or. ylab(1:4) .eq. 'time')then
          n = nx
 
          if( n .gt. nmax) then
      	ier = 1
 
          else
      	do i=1, n
      	  x(i) = x_i(i)
      	enddo
 
              call extr_y(work,nx,ny,y_i,f, time, dtave)
          endif
 
        else
          ier = 1
 
        endif
 
      endif
 
      return
      end
c ********************************************************************
      subroutine extr_x(work,nx,ny,x_i,f, time, dtave)
 
      implicit none
      integer nx, ny
 
      real work(nx,ny)
      real x_i(nx), f(ny)
 
      integer count, i, j
      real time, dtave

c$r8real_input: work,x_i,time,dtave
c$r8real_output: f 
 
      count = 0
 
      do j=1, ny
        f(j) = 0.0
      enddo
 
      do i=1, nx
        if(  abs(x_i(i) - time) .le. dtave ) then
          count = count + 1
 
          do j=1, ny
             f(j) = f(j) + work(i,j)
          enddo
        endif
 
      enddo
 
      if( count .ne. 0) then
        do j=1, ny
          f(j) = f(j)/count
        enddo
      endif
 
      return
      end
c ********************************************************************
      subroutine extr_y(work,nx,ny,y_i,f, time, dtave)
 
      implicit none
      integer nx, ny
 
      real work(nx,ny)
      real y_i(ny), f(nx)
 
      integer count, i, j
      real time, dtave
 
c$r8real_input: work,y_i,time,dtave
c$r8real_output: f 
 
      count = 0
 
      do j=1, nx
        f(j) = 0.0
      enddo
 
      do i=1, ny
        if(  abs(y_i(i) - time) .le. dtave ) then
          count = count + 1
 
          do j=1, nx
             f(j) = f(j) + work(j,i)
          enddo
        endif
 
      enddo
 
      if( count .ne. 0) then
        do j=1, nx
          f(j) = f(j)/count
        enddo
      endif
 
      return
      end

C-----------------------------------------------------------------------
C  CHECKID -- PARSE OUT TRANSP RUN ID AND TOKAMAK FROM COMBINED INPUT
C
C History:
C 10/16/96 CAL : Support RunId with 4 - 6 digit shot number
C                                   2 - 3 digit run  number
C 01/07/97 CAL : Fix lrid
C 01/06/98 CAL : Fix extracting shot number
C
C
      SUBROUTINE CHECKID(STRING, lrid, lshot)
C
      implicit NONE
C
      CHARACTER*(*) STRING	! INPUT STRING E.G. "12345A01PBXM"
C				! COULD BE OLD STYLE "1234TFTR"
C                               ! e.g. 123456A123TFTR
      INTEGER  lrid, lshot              ! return values: length of RunId/Shot
C
      CHARACTER*10 ZDIGIT
C
C-------------------------
      integer ilen,idig,ic,i1,i2
C-------------------------
C
C  TWO RUN ID "STYLES" ARE SUPPORTED, THE OLD 4 DIGIT RUN NUMBER STYLE
C  AND THE NEW 8 CHARACTER nnnnnAmm SHOT-TRY NOMENCLATURE
C
C------------------------------------
C
      lshot = 0
      ZDIGIT='0123456789'
C
C
      ILEN=INDEX(STRING,' ')-1
      IF(ILEN.LE.0) ILEN=LEN(STRING)
C	type 1,  string(1:ilen), ilen
C 1	format(1x,a20,i3)
      if (ilen .eq. 4 ) go to 1200
      if (ilen .eq. 5 ) go to 1300
C
C  TEST FOR OLD VS. NEW STYLE IS WHETHER THE 5TH CHARACTER OF THE INPUT
C  STRING IS A DIGIT:  DIGIT INDICATES NEW STYLE
C
C
C  CHECK valid Shot Number
C
          idig = 1
        ic = 0
        DO 20 while (idig .ne. 0 .and. ic .lt. ilen)
          ic = ic+1
          IDIG = INDEX(ZDIGIT,STRING(IC:IC))
 20     CONTINUE
        i1 = ic - 1
C	  if (i1 .eq. 4 .and. i1 .eq. ILEN) go to 1100
        if (ic .eq. 4 ) go to 1200
        if (i1 .eq. 4 ) go to 1100
        if (i1 .lt. 5 .or. i1 .gt. 6) go to 1000
          if (i1 .eq. 6 .and. string(1:1) .eq. '0') go to 1000
 
C
C Check valid Run Number
        idig = 1
        DO 21 while (idig .ne. 0 .and. ic .lt. ilen)
          ic = ic+1
          IDIG = INDEX(ZDIGIT,STRING(IC:IC))
 21     CONTINUE
        if (ic .eq. ilen .and. idig .ne. 0) ic = ic+1
        i2 = ic - i1 - 2
        if (i2 .lt. 2 .or. i2 .gt. 3)  go to 1000
C
 1100 lrid = ic - 1
      lshot = i1
        return
 
 1200 lrid = 4
      lshot = 4
        return

 1300 lrid = 5
      lshot = 5
        return
 
 1000 lrid = 0
      RETURN
      END
 
 
 
 
 

C******************** START FILE UREAD.FOR ; GROUP UREAD5 ******************
C==============================================================
C& UREAD  ACCEPT PROGRAM PROMPT, FETCH PROGRAM INPUT
C
C  UREAD          D. MC CUNE APR 1980
C  UREAD2  -- JULY 1981 D. MC CUNE.  DELETED REFERENCES TO
c  uread3 -- January 1982  buffered indirect file input
C    **ALSO ADDED "SKIPTO" FEATURE LINES 300 FF.
C  UREAD4 -- RE-ORGANIZED MAIN-- BROKE OFF SPECIAL FUNCTIONS INTO
C     SEPERATE SUBROUTINES FOR BETTER MAINTAINABILITY
C  UREAD5 -- FURTHER BREAK UP OF UREAD MAIN
C     ADD SYSTEM FEATURES-- FOREIGN COMMAND SUPPORT FOR TYPEAHEAD
C     INTO UREAD PROGRAMS FROM DCL
C        SOFT-CODED UREAD COMMANDS THAT CAN BE TURNED OFF;
C     MAKE IT POSSIBLE TO TURN OFF UPPERCASE CONVERSION OF INPUT
C       >>TYPEAHEAD BUFFER STACK TO SUPPORT TYPEAHEAD THRU
C         MULTIPLE LEVELS OF COMMAND INPUT
C       >>OUTPUT LUN STACK SO THAT MULTIPLE LEVELS OF COMMAND
C         OUTPUT FILES MAY BE CREATED SIMULTANEOUSLY
C
C----------------------------------------------------------------------
C  DMC JAN 1988
C
C  UREAD IS NOW FULLY BROKEN UP, ONE SOURCE FILE / SUBROUTINE, AND
C  STORED IN THE PPLCC VAX TRANSP CMS/MMS SYSTEM, WITH OBJECTS MAPPED
C  TO LIBRARY GFLIB
C
C  NEW FEATURES
C
C  *ROUTINES TO SUPPORT RECONSTRUCTION OF TYPEAHEAD BUFFER FOR
C   ERROR MESSAGES-- EXAMPLE OF USE, SEE SUBROUTINE UERMSG
C
C  *OPTION TO ALLOW (CARRIAGE RETURN) WITHOUT ANYTHING ELSE AS
C   A USER RESPONSE TO PROGRAM PROMPTS.  THIS IS NOT ENABLED BY
C   DEFAULT
C     CALL URDCRI(1) ENABLES ACCEPTANCE OF BLANK LINES/ CARRIAGE RETURN
C                    INPUT
C     CALL URDCRI(0) DISABLES ACCEPTANCE OF BLANK LINES/ CARRIAGE RETURN
C
C   IF ENABLED, CALL TO LOGICAL FUNCTION LCHAR WITH BLANK ARGUMENT WILL
C   TEST-- E.G.
C     IF(LCHAR(' ')) THEN ... ! USER ENTERED BLANK LINE
C
C   BECAUSE ALL NON-BLANK INPUT IS LEFT JUSTIFIED, LCHAR(' ') IS TRUE
C   IF AND ONLY IF THE ENTIRE LINE IS BLANK
C
C  *THE UREAD COMMENT CHARACTER MAY BE CONTROLLED VIA THE URDCMC ROUTINE
C
C  *UREAD PROMPT MATCH CHECKING ALGORITHM MAY BE CONTROLLED VIA THE
C   URDPMA ROUTINE-- DEFAULT IS CHECK 1ST FOUR WORDS OF PROMPT FOR
C   MATCH WITH COPY OF PROMPT IN INPUT FILE
C
C  *UREAD CHARACTERISTICS HANDLING "WORD" INPUT MAY CHANGE
C   ENCLOSING A STRING IN DBL QUOTES (") WILL THE WHOLE STRING A
C   "WORD" AND SUPPRESS CASE CONVERSION.
C
C  *BLANK OR COMMA DELIMITTERS ON INPUT "WORDS" WILL NOW BE REQUIRED
C   TRUNCATION DUE TO WORD LONGER THAN PASSED STRING FROM APPLICATIONS
C   PROGRAM WILL BE REPORTED.  THE APPLICATIONS PROGRAM WILL NO LONGER
C   SEE THE REMAINDER OF THE TRUNCATED WORD IN THE NEXT WORD VIA
C   TYPEAHEAD...
C
C  ---
C  DMC FEB 1989
C
C   1)  USER DEFINED VISIBLE WORD DELIMITERS -- "PUNCTUATION" NOW
C  AVAILABLE.  APPLICATION SEES WORDS AND THE PUNCTUATION ITSELF.
C  BLANKS ARE WORD DELIMITERS NOT SEEN BY THE APPLICATION, IN THIS
C  MODE OF OPERATION.  IF NO USER DEFINED PUNCTUATION IS SPECIFIED,
C  THE BEHAVIOUR DESCRIBED ABOVE (JAN 1988) OBTAINS.
C
C   2)  A LINE PRE-BUFFER IS CREATED.  THIS ALLOWS THE APPLICATION TO
C  CREATE INPUT LINES TO THE UREAD/ APPLICATION COMMAND LINE INTERPRETER
C  THESE INPUT LINES WILL ECHO TO AN OUTPUT (SCRIPT) FILE
C  UP TO 8 LINES MAY BE CREATED IN ADVANCE (CF COMMON: NPRBUF,PREBUF)
C
C----------------------------------------------------------------------
C
C  I/O STACK IS
C   LUNTIN(1) -- TTY OR BATCH .COM FILE -- SYS$INPUT
C     IN CONTROL WHEN NLUNIN=1
C   LUNTIN(2...NLUNIO) -- UREAD OUTPUT FILE -- ECHO PROGRAM
C     PROMPTS AND LUNTIN(1) LEVEL USER RESPONSES TO ASCII FILE
C     WHICH CAN LATER BE READ BACK IN AS UREAD "INDIRECT" INPUT FILE
C           IF AN OUTPUT FILE IS OPEN, NLINDO = .TRUE.
C   LUNTIN(MAX0(2,(NLUNIO+1))...NLUNIN) -- UREAD INDIRECT INPUT FILE --
C     CONTROL PROGRAM IN LIEU OF DIRECT USER (SYS$INPUT) INPUT
C          IF AN INPUT FILE OTHER THAN SYS$INPUT IS OPEN,
C          NLINDI = .TRUE.
C
C   ASSOCIATED IN USERIO COMMON WITH EACH INPUT LEVEL IS
C     .A TYPEAHEAD BUFFER (AHDBUF(I))
C     .A SET OF "LOCAL" STRING PARAMETERS (PLCNAM(..,I),PLCVAL(..,I))
C     .A FILENAME (XFILE(I))
C     .A RECORD COUNT (NCMND(I))
C
C  EACH TIME THE I/O LEVEL IS CHANGED WITH AN ">" OR "@" COMMAND,
C   A NEW "CONTEXT" CONSISTING OF THE ABOVE FOUR ITEMS IS ESTABLISHED
C
C
C ----
c
c  rev 7-jan-81  D. Mc Cune --- all lower case letters
c     in input line converted to upper case
C
C   ROUTINE TO WRITE PROMPT AND READ USER RESPONSE AT
C  TERMINAL.  SPECIAL FEATURES:
C
C  IF USER LINE COMMENCES WITH ";" (SEMICOLON), THE ROUTINE
C  IGNORES THE LINE AND READS IN THE NEXT LINE
C
C  IF USER LINE COMMENCES WITH "@" ("AT") THE ROUTINE SWITCHES
C  THE INPUT DEVICE FROM THE TERMINAL TO THE FILE <FILNAM>
C  REFERENCED; E.G. FULL USER LINE IS "@<FILNAM>";
C  FILE <FILNAM> CONTAINING RECORDED INSTRUCTIONS THAT
C  WILL BE CORRECTLY INTERPRETED BY THE CALLER
C  AT E.O.F., THE TERMINAL IS RESTORED AS INPUT DEVICE
C
C  IF USER LINE IS ">[FILNAM]" THE ROUTINE CREATES THE FILE
C  NAMED AND RECORDS USER-PROGRAM INTERACTION IN THE
C  FILE UNTIL A LINE ">[C.R.]" IS ENCOUNTERED.  PROGRAM
C  MESSAGES ARE WRITTEN OUT COMMENCING WITH ";".
C  IF THE CALLING PROGRAM USES THIS ROUTINE THROUGHOUT,
C  THESE FILES MAY BE REFERENCED LATER AS INDIRECT INPUT FILES
C
C  CALLING PROGRAM SENDS PROMPTS THROUGH PASSED ARGUMENT "ABUFF"
C  WHICH ARE WRITTEN HERE WITH A PRECEDING ";".
C
C
C   >>>> IF INPUT STRING IS 'CLOSE$', ANY INDIRECT FILES ARE CLOSED
C        AND CONTROL RETURNED TO MAIN
C
C
      SUBROUTINE UREAD(ABUFFI)
C
C  THE PROMPT IN ABUFFI IS TERMINATED WITH A "$"
C
C  COMMON BLOCKS ---
C
      USE USERIO
C
C  LOCAL --
C
      CHARACTER*(*) ABUFFI
      CHARACTER*8 UCNTRL
C
C  START OF EXECUTABLE CODE --
C
C  INITIALIZE USER I/O COMMON IF NECESSARY
C
      CALL USICHK
C
C  CLEAR END-OF-FILE COUNTER (USED IN BRANCHING)
      IEOFL=0
C
C  PASS COUNTER
      IPASS=0
C
C  INPUT WORD
      LUWORD=0
C
C-----------------------------------------------/SEND THE PROMPT
 100  CONTINUE
      IPASS=IPASS+1
C  FLAG IF A PROMPT HAS BEEN TRIED
      IPRMTD=0
C  FLAG THAT AN INPUT LINE HAS BEEN READ
      INPUTL=0
C
      LCMDIN=1
C  CALLER REQUESTS INPUT-- PREPARE TO READ ANOTHER LINE
C  STRING PARAMETER INPUT CLEARED
      PRMSUB='                                                '
C
C  IF INLINE TYPE-AHEAD NOT IN EFFECT, CLEAR LINE-BUFFER
      IF(NLHOLD) CALL UCLEAR
C  IF TYPEAHEAD BUFFER IS NOT EMPTY, SUPPRESS PROMPT MATCH CHECKING
      IF(NCHARC.GT.0) CALL UREADY(1)
C
C     UNPACK PROGRAM PROMPT (ABUFFI) --
C     FIND LENGTH OF PROMPT (NCHARA) CHECK FOR NULL PROMPT
C     PROMPT IS STORED IN COMMON AS ABUFF
C
      IF(IPASS.EQ.1) CALL UDECOP(ABUFFI)
C
C  IF NULL PROMPT, SET READY TO ACCEPT COMMAND INPUT
      IF(NCHARA.EQ.0) CALL UREADY(1)
C
C  CHECK PROMPT; ECHO TO OUTPUT FILE IF ONE IS OPEN
      IF(IPASS.GT.1) GO TO 105
C
C  CHECK FOR CALL UREAD('CLOSE$')
      ICLOSE=ISCMP0(BBUFF,'CLOSE',1,5,IDUM)
      IF(ICLOSE.EQ.1) THEN
        IF(NLINDI) CALL URDERR(3)
        RETURN
      ENDIF
C  WRITE PROMPT TO TERMINAL AND/OR OUTPUT FILE IF NECESSARY
 105  CONTINUE
C  DONT PROMPT IF TYPEAHEAD BUFFER IS NOT EMPTY
      IF(NCHARC.GT.0) THEN
        IF(NLECHO) CALL UPROMT  ! ECHO TO TTY (DEBUG MODE)
        GO TO 200
      ENDIF
C  PROMPT...
      IPRMTD=1
      CALL UPROMT               ! SEND TO TTY
      CALL UPROMX               ! SEND TO OUTPUT FILE IF OPEN
C
C---------------------------------------/ACCEPT INPUT/--------------
 200  CONTINUE
C  DONT READ LINE FROM TTY OR FILE, IF LINE BUFFER IS NOT EMPTY
      IF(NCHARC.EQ.0) THEN
        NLSSUB=.FALSE.  ! new line; no "/" parameter substitution done.
C  READ INPUT LINE OR USER RESPONSE
        CALL URGET1(IER,IEOF)
        INPUTL=1
        IF(.NOT.NLINDI) NCLEAR=0
C  ERROR CHECKING
        IF(IER.NE.0) THEN
          CALL URDERR(1)
          GO TO 100
        ELSE IF(IEOF.NE.0) THEN
          CALL URDEOF(IEOFL)
          GO TO 100
        ENDIF
      ENDIF
C
C  UNPACK INPUT LINE
C
      CALL UDECOD
C  CHECK FOR ALL BLANKS
      IF(NCHARC.EQ.0) THEN
C  NULL LINE -- HAS USER HAD A CHANCE TO FILL IT?
        IF(IPRMTD.EQ.0) GO TO 105
C  NULL LINE ACCEPTABLE?
        IF(.NOT.NLNULL) THEN
C  REPEAT PROMPT-- BLANK LINES IGNORED
          CALL UPROMT
          GO TO 200
        ENDIF
      ENDIF
C---
C  ECHO INPUT LINE IF NECESSARY
      CALL URECHO(INPUTL)
C  PERFORM INLINE PARAMETER SUBSTITUTION ON NEWLY READ LINE
      IF((.NOT.NLSKIP).AND.(INPUTL.EQ.1)) THEN
        CALL UPSINL(IER)
C  IF THIS RESULTS IN AN ERROR...
        IF(IER.NE.0) THEN
          CALL UPROMT
          GO TO 200
        ENDIF
      ENDIF
C---------------------------------------------------
C  CHECK FIRST CHARACTER
C  BRANCH TO SPECIAL FUNCTION CODING ****
 222  CONTINUE
C  GENERATE SPECIAL CHARACTER STRING
      CALL URCSTR(UCNTRL)
C  CHECK AGAINST USER INPUT
      ISELEC=JXUOPC(UCNTRL,DBUFF(1))
      IF(ISELEC.NE.0) THEN
        CALL URDSPC(ISELEC,IRET,IEOFL,IERC)
        IF((IRET.LT.4).AND.(IRET.GT.0)) GO TO (222,100,500) IRET
      ELSE
        GO TO 500
      ENDIF
C  ERROR TO DROP THRU TO HERE
      IARGHH=1/IARGHH
C
C=============================/ RETURN INPUT TO CALLER /============
C
C  INPUT TO BE INTERPRETED BY CALLING PROGRAM
C
C  CHECK FOR PROMPT MATCH ERROR
C
 500  CONTINUE
C  IF SKIP FLAG SET, THROW AWAY LINE AND GET A NEW ONE (E.G. LOOKING
C  FOR BRANCH TARGET MARKER)
      IF(NLSKIP) THEN
        CALL UCLEAR
        GO TO 200
      ENDIF
C  LREADY=0 INDICATES PROMPT MATCH ERROR:  INDIRECT FILE INPUT WHICH
C   WAS NOT PRECEDED BY A COPY OF THE CORRECT PROMPT SENT FROM
C   THE MAIN PROGRAM
C  NB DMC JAN 1988:  IF LPMMSG.LT.0 THIS ERROR IS IGNORED AND THERE
C  IS NO PROMPT MATCH CHECKING
      IF((LREADY.EQ.0).AND.(LPMMSG.GE.0)) THEN
C  PROMPT ERROR MESSAGE SUPPRESION?
        IF(LPMMSG.EQ.1) THEN
          IF(NLECHO) CALL UPAUST(1)
          WRITE(LUNTRM,9050)
 9050 FORMAT(
     >' ? UREAD PROMPT MISMATCH; FILE INPUT LINE OUT OF SEQUENCE'/)
C  TRACEBACK INDIRECT INPUT FILES
          CALL UTRACE
          WRITE(LUNTRM,5050) (BBUFF(IJ),IJ=1,NCHARA)
 5050 FORMAT(/' FILE INPUT EXECUTION SUSPENDED UNTIL',
     >   ' NEXT PROMPT MATCH'/
     >   ' PROGRAM PROMPT IS:'/(1X,79A1)/)
C  DUMP RECENT RESPONSES
          CALL UCBUFX
          CALL UPAUST(1)
C
        ENDIF
C  LOOK FOR MATCHING PROMPT BEFORE PROCEEDING
C  (EVEN IF ERROR MESSAGE WAS SUPPRESSED)
        NLSKIP=.TRUE.
        CALL UCLEAR
        GO TO 200
      ENDIF
C
C  COMMAND ACCEPTED -- NORMAL EXIT -- CLEAR READY FLAG
C
      CALL UREADY(0)
C
      RETURN
C
      END
C******************** END FILE UREAD.FOR ; GROUP UREAD5 ******************

      subroutine r8rcpuf(bufreal,bufr8,isize)
C
C  copy a real array to a real*8 array.
C  caution-- these are likely to be at the same address!  so, copy
C  in reverse order to accomodate expansion w/o overwrite.
C
      real bufreal(isize)
      real*8 bufr8(isize)
C
      do i=isize,1,-1
         bufr8(i)=bufreal(i)
      enddo
C
      return
      end

C******************** START FILE UERJMP.FOR ; GROUP URDUTS ******************
C----------------------------------------------------------
C&  UERJMP  UREAD PAUSE AND JUMP AFTER ERROR
C
C  AFTER PROGRAM DETECTS ERROR AND OUTPUTS ERROR MESSAGE,
C  UERJMP WILL CALL UPAUST, FLUSH INPUT LINE BUFFER AND
C  CARRY OUT A BRANCH RETURN
C
C  IARG -- SEE URSTOP ROUTINE
C
      SUBROUTINE UERJMP(IARG,*)
C
      CALL URSTOP(IARG)
      RETURN 1
      END
C******************** END FILE UERJMP.FOR ; GROUP URDUTS ******************

      subroutine ck_ufpath(path,device,dirname,fname,sts)
C Check if file exists - or need to modify path
C 1. check for path
C 2. look for $DATADIR/device/dirname/fname
C
C 05/08/02 C. Ludescher
C
C Input
      character*(*) path        ! full path
      character*(*) device      ! tokamak
      character*(*) dirname     ! directory
      character*(*) fname       ! filename
      integer       sts
C Processing
      logical       ex
      integer       ierr,  lp0, lp, ldir, lf, lzp, lzp1
      character     zpath*150, zdir*100
C------------------------------------------------
      sts = 0
      lp0 = len(path)
      lp = len_trim(path)
      ldir=len_trim(dirname)
      lf  =len_trim(fname)
C check if file exists as passed
      inquire(file=path(1:lp),exist=ex, iostat=ierr)
      if (ex) return
C Check if file is in DATADIR
      call sget_env('DATADIR',zpath)
      lzp1 = len_trim(zpath)+1
      if (lzp1 .lt. 2) then
         print *,'? ck_ufpath: DATADIR not defined'
         sts = 1
         return
      endif
      if (dirname(1:1).eq.'/') then
         zpath(lzp1:) = '/'//device//'/'//fname(1:lf)
      else
         zpath(lzp1:) = '/'//device//'/'//dirname//fname(1:lf)
      endif
      lzp = len_trim(zpath)
      inquire(file=zpath(1:lzp),exist=ex,iostat=ierr)
C Check if dirname should be lower case
      if (.not. ex) then
         print *, '% ck_ufpath: try lower case'
         zdir = dirname
         call ulower(zdir(1:ldir))
         zpath(lzp1:) = '/'//device//'/'//zdir(1:ldir)//fname(1:lf)
         print *,zpath(1:lzp)
         inquire(file=zpath(1:lzp),exist=ex,iostat=ierr)
      endif
      if (ex) then
         if (lzp .le. lp0) then
            path = zpath(1:lzp)
            return
         else
            print *,'? ck_ufpath: path too short for expanded filename'
         endif
      else
         print *,'? ck_ufpath: ',path(1:lp),' does not exist'
      endif
      sts = 1
      return
      end

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SGPHEI(ZE)
!
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER i
!============
! idecl:  explicitize implicit real(fp) declarations:
  real(fp) ze2,zemin,zemax,zeuse,zle,zls,zlss,zle2,za2,zans
!============
  real(fp) ZE
!
!  ZE IN EV
!  SGPHEI IN CM**2
!
!  JANEV-LANGER-EVANS-POST,
!  ELEMENTARY PROCESSES IN HYDROGEN-HELIUM PLASMAS
!  FIT FOR REACTION 3.3.2,  H+ + HE --> H+ + HE+ + E-
!    IMPACT IONIZATION
!
!  FIT TABLE IN SS 8.1, P. 252
!
  real(fp) A332(9)
  DATA A332/ 4.62487177e+03_fp,-4.74569253e+03_fp,&
       2.08150865e+03_fp,&
       -5.15098782e+02_fp, 7.87208777e+01_fp,&
       -7.61176657_fp,&
       4.54958944e-01_fp,-1.53751100e-02_fp,&
       2.25017020e-04_fp/
!
  LOGICAL EXTRAP
!
  EXTRAP=.FALSE.
!
  ZE2=ZE
!
  ZEMIN=200.0_fp
  ZEMAX=100000.0_fp
  IF((ZE2.LT.ZEMIN).OR.(ZE2.GT.ZEMAX)) EXTRAP=.TRUE.
!
  ZEUSE=min(ZEMAX,max(ZEMIN,ZE2))
!
  ZLE=log(ZEUSE)
!
  ZLS=A332(9)
  IF(EXTRAP) ZLSS=8._fp*A332(9)
!
  DO I=8,1,-1
     ZLS=ZLS*ZLE+A332(I)
     IF(EXTRAP.AND.(I.GE.2)) ZLSS=ZLSS*ZLE+(I-1)*A332(I)
  enddo
!
  IF(EXTRAP) THEN
     ZLE2=log(ZE2)
     ZA2=0.8_fp
     IF(ZE2.LT.ZEMIN) ZLS=ZLS-ZLSS*(ZLE-ZLE2)
     IF(ZE2.GT.ZEMAX) ZLS=ZLS+(ZLE2-ZLE)*(ZLSS-ZA2*(ZLE2-ZLE))
  ENDIF
!
  ZANS = EXP(min(50.0_fp,ZLS))
!
  SGPHEI=ZANS
!
  RETURN
END FUNCTION SGPHEI
!
!------------------------------------------------------------------------------
 
 
 
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok

!------------------------------------------------------------------------------
!
!              **************************************************
!              *                 A L P A C K                    *
!              *                                                *
!              * ALADDIN STANDARD INTERFACE SUBROUTINE PACKAGE  *
!              **************************************************
!
!                  VERSION 1.0    30/04/1989
!
!     ORIGINAL VERSION DESIGNED AND WRITTEN BY R. A. HULSE, OF THE
!     PRINCETON UNIVERSITY, PLASMA PHYSICS LABORATORY.
!     (PAPER TO BE SUBMITTED TO THE JOURNAL OF COMPUTATIONAL PHYSICS
!      COMMUNICATIONS)
!
!------------------------------------------------------------------------------
!
!     REV. 2/03/89 BY J.J.SMITH IAEA ATOMIC AND MOLECULAR DATA UNIT
!          MAXIMUM LABEL LENGTH CHANGED FROM 20 TO 40 CHARACTERS
!          VARIABLE ILABEL MODIFIED
!
!##############################################################################
!
SUBROUTINE ALREAD_Z(KLUDF, KESEQN, KEOF, KERMSG)
!
!                        ************************
!                        * READ ENTRY FROM FILE *
!                        ************************
!
!     FIND AND READ THE NEXT ENTRY IN DATA FILE (LOGICAL UNIT NUMBER KLUDF)
!     INTO THE ENTRY BUFFER ARRAY EBUFF.  ALL LINES IN THE DATA FILE MUST BE
!     VALID ALADDIN FORMAT ENTRY LINES, EXCEPT THAT LINES AT THE START OF
!     THE FILE ARE IGNORED UNTIL THE FIRST VALID ALADDIN ENTRY IS FOUND,
!     BEGINNING WITH A "$" IN COLUMN 1.  THESE FIRST LINES CAN THUS BE USED AS
!     HEADER COMMENTS FOR THE DATA FILE.  ONCE READ INTO THE EBUFF BUFFER
!     ARRAY, THE ENTRY IS PARSED BY CALLING THE STANDARD PARSING ROUTINE ALPARS
!
!     THE ENTRY SEQUENCE NUMBER KESEQN IS AUTOMATICALLY INCREMENTED BY THIS
!     ROUTINE, BUT MUST BE INITIALIZED AS ZERO BY THE CALLING ROUTINE AT THE
!     START OF A DATA FILE.  KESEQN .NE. 0 ON ENTRY IMPLIES THAT THIS IS A
!     SUBSEQUENT READ ON A DATA FILE ALREADY READ BY THIS ROUTINE, AND HENCE
!     THE ENTRY LINE DATA ARRAY EBUFF HAS THE FIRST LINE OF THE NEXT ENTRY
!     AVAILABLE AT POSTION NELN + 1.  ENCOUNTERING AN END OF FILE TERMINATING
!     THE CURRENT ENTRY IS NOTED BY SETTING THE STORED FIRST LINE OF THE
!     "NEXT ENTRY" AS THE STRING '$EOF'.  CALLS TO READ THE NEXT ENTRY WITH
!     THIS FLAG PRESENT CAUSE A RETURN WITH THE LAST ENTRY STILL IN PLACE AND
!     KEOF SET .TRUE.  ERROR MESSAGES ARE RETURNED THROUGH THE STRING KERMSG;
!     KERMSG = ' ' INDICATES NO ERRORS.
!
!------------------------------------------------------------------------------
!
!     NOTE: THIS IS A STANDARD ALADDIN ROUTINE; IT INTERFACES ONLY THROUGH
!           THE SUBROUTINE CALL PASSED VARIABLES AND COMMON / ALENT /.
!
!------------------------------------------------------------------------------
!
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use alpcom_mod
  IMPLICIT NONE
  INTEGER keseqn,kludf,irderr
!============
  CHARACTER*(*) KERMSG
  CHARACTER*40 ILABEL
  LOGICAL KEOF
!******************************************************************************
!
!     IF THE ENTRY SEQUENCE NUMBER IS ZERO, THIS IS THE FIRST READ
!     OF A NEW DATA FILE.  SKIP POSSIBLE HEADER COMMENTS TO FIND FIRST
!     LINE OF FIRST ENTRY.  OTHERWISE, SHIFT THE PREVIOUSLY READ FIRST
!     LINE OF THE NEXT ENTRY INTO THE FIRST LINE POSITION.
!
  KEOF = .FALSE.
!
  IF(KESEQN .EQ. 0) THEN
!
100  READ(KLUDF, '(A)', IOSTAT=IRDERR, END=110) EBUFF(1)
110  CONTINUE
!
     IF(IRDERR .NE. 0) THEN
        KERMSG = ' NO ENTRIES IN FILE OR OTHER READ ERROR'
        RETURN
     ENDIF
!
     IF(EBUFF(1)(1:1) .NE. '$') GO TO 100
!
  ELSE IF(EBUFF(NELN+1) .EQ. '$EOF') THEN
     KEOF = .TRUE.
     KERMSG = ' '
     RETURN
!
  ELSE
!
!       MOVE FIRST LINE OF NEXT ENTRY (BUFFERED IN AT END OF CURRENT ENTRY)
!       INTO FIRST LINE POSITION BEFORE READING REST OF ENTRY FROM FILE
!
     EBUFF(1) = EBUFF(NELN+1)
!
  ENDIF
!
!     THE FIRST LINE OF THE NEW ENTRY IS NOW IN PLACE;
!     INCREMENT THE ENTRY SEQUENCE NUMBER AND INTIALIZE THE ENTRY LINE COUNTER
!
  KESEQN = KESEQN + 1
  NELN = 1
!
!     LOOP TO ADD ALL LINES FOR THIS ENTRY INTO EBUFF, PLUS THE FIRST
!     LINE OF THE NEXT ENTRY IS READ IN ORDER TO FIND THE '$' LABEL.
!     THIS EXTRA LINE IS HELD IN ORDER JUST AFTER THIS ENTRY IN EBUFF(NELN+1).
!     OCCURENCE OF AN END OF FILE IS FLAGGED BY SPECIAL LINE ENTRY '$EOF'
!
200 IF(NELN .GE. NELNMX) THEN
     KERMSG = ' ENTRY DATA LINE ARRAY OVERFLOW'
     RETURN
  ENDIF
!
  NELN = NELN + 1
!
  READ(KLUDF, '(A)', IOSTAT=IRDERR, END=220) EBUFF(NELN)
  220 CONTINUE
!
  IF(IRDERR .GT. 0) THEN
     KERMSG = ' DATA FILE READ ERROR'
     RETURN
  ENDIF
!
  IF(IRDERR .LT. 0) EBUFF(NELN) = '$EOF'
!
!     IF '$' IN !OLUMN 1 THIS IS THE FIRST LINE OF THE NEXT ENTRY
!
  IF(EBUFF(NELN)(1:1) .NE. '$') GO TO 200
!
!     DECREMENT NELN TO POINT TO LAST LINE OF THIS ENTRY
!
  NELN = NELN - 1
!
!------------------------------------------------------------------------------
!
!     USE STANDARD ALADDIN PARSER TO PARSE THIS ENTRY INTO STANDARD
!     LABELS AND POINTERS; NOTE THAT THESE CAN BE RE-INTERPRETED OR
!     THE ENTRY RE-READ DIFFERENTLY LATER BY NON-STANDARD ACCESS ROUTINES.
!
  CALL ALPARS_Z(KERMSG)
!
  RETURN
END SUBROUTINE ALREAD_Z
!
!##############################################################################
!
      SUBROUTINE ALPARS_Z(KERMSG)
!
!                      ***************************
!                      * ALADDIN STANDARD PARSER *
!                      ***************************
!
!     PARSE THE DATABASE FILE ENTRY LINES CONTAINED IN THE BUFFER EBUFF
!     INTO HIERARCHICAL LABELS AND BOOLEAN LABELS, PLUS POINTERS TO
!     POSSIBLE COMMENT LINES AND THE COEFFICIENT LINES IN THE ENTRY.
!     KERMSG RETURNS ERROR MESSAGES; KERMSG = ' ' INDICATES NO ERRORS.
!
!------------------------------------------------------------------------------
!
!     NOTE: THIS IS A ALADDIN STANDARD ROUTINE, WHICH INTERFACES ONLY THROUGH
!           THE SUBROUTINE CALL PASSED VARIABLE AND COMMON / ALENT /.
!
!------------------------------------------------------------------------------
!     REV. 2/03/89 BY J.J.SMITH IAEA ATOMIC AND MOLECULAR DATA UNIT
!          MAXIMUM LABEL LENGTH CHANGED FROM 20 TO 40 CHARACTERS
!          VARIABLE ILABEL MODIFIED
!
!------------------------------------------------------------------------------
!
  use alpcom_mod
  IMPLICIT NONE
!
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER ilptr,icptr,ilblnc,iflag
!============
  CHARACTER*(*) KERMSG
  CHARACTER*40 ILABEL
!
!------------------------------------------------------------------------------
!
!     INITIALIZE LINE AND CHARACTER POINTERS AT THE START OF THE ENTRY
!
  ILPTR = 1
  ICPTR = 1
!
!     INITIALIZE RETURN QUANTITIES
!
  NHL = 0
  NBL = 0
  NCMLN = 0
  NCFLN = 0
  KERMSG = ' '
!
!------------------------------------------------------------------------------
!
!     THE ACCESS LABEL (WITH '$' PREFIX) IS ALWAYS FIRST BOOLEAN LABEL
!
  CALL ALXLBL_Z(EBUFF, NELN, ILPTR, ICPTR, ILABEL, ILBLNC, IFLAG)
!
  IF(IFLAG .NE. 0 .OR. ILABEL(1:1) .NE. '$') THEN
     KERMSG = ' INVALID ACCESS LABEL LINE'
     RETURN
  ENDIF
!
  NBL = 1
  BL(1) = ILABEL
!
!------------------------------------------------------------------------------
!
!     HIERARCHICAL LABEL SEARCH AND STORE LOOP
!
100 CALL ALXLBL_Z(EBUFF, NELN, ILPTR, ICPTR, ILABEL, ILBLNC, IFLAG)
!
!     ACT ON HIERACRCHICAL LABEL SEARCH ERROR FLAGS
!
!     0 = OK
!     -1 = LABEL TRUNCATED; ERROR RETURN
!     1 = END OF ENTRY REACHED WHILE STILL IN HL FIELD; ERROR RETURN
!
  IF(IFLAG .EQ. -1) THEN
     KERMSG = ' HIERARCHICAL LABEL "'//ILABEL//'" TRUNCATED'
     RETURN
  ENDIF
!
  IF(IFLAG .EQ. 1) THEN
!       KERMSG = ' PREMATURE END OF ENTRY, HIERARCHICAL LABEL FIELD'
     RETURN
  ENDIF
!
!     IF '&' OR '#' PREFIX HAS BEEN FOUND, MOVE TO BOOLEAN LABEL PROCESSING
!
  IF(ILABEL .EQ. '&') GO TO 200
  IF(ILABEL(1:1) .EQ. '#') GO TO 250
!
!     THIS IS ANOTHER HIERARCHICAL LABEL; STORE AND LOOP FOR NEXT LABEL
!
  IF(NHL .GE. NHLMX) THEN
     KERMSG = ' HIERARCHICAL LABEL ARRAY OVERFLOW'
     RETURN
  ENDIF
!
  NHL = NHL + 1
  HL(NHL) = ILABEL
  GO TO 100
!
!------------------------------------------------------------------------------
!
!     BOOLEAN LABEL SEARCH AND STORE LOOP
!
!     NOTE THAT ACCESS LABEL HAS ALREADY BEEN STORED AS BL(1)
!
200 CALL ALXLBL_Z(EBUFF, NELN, ILPTR, ICPTR, ILABEL, ILBLNC, IFLAG)
!
!     ACT ON BOOLEAN LABEL SEARCH ERROR FLAGS
!
!     0 = OK
!     -1 = LABEL TRUNCATED; ERROR RETURN
!     1 = END OF ENTRY REACHED, ERROR RETURN
!
  IF(IFLAG .EQ. -1) THEN
     KERMSG = ' BOOLEAN LABEL "'//ILABEL//'" TRUNCATED'
     RETURN
  ENDIF
!
  IF(IFLAG .EQ. 1) THEN
     KERMSG = ' PREMATURE END OF ENTRY IN BOOLEAN LABEL FIELD'
     RETURN
  ENDIF
!
!     THIS IS ANOTHER BOOLEAN LABEL; STORE AND LOOP FOR NEXT LABEL
!
250 IF(NBL .GE. NBLMX) THEN
     KERMSG = ' BOOLEAN LABEL ARRAY OVERFLOW'
     RETURN
  ENDIF
!
  NBL = NBL + 1
  BL(NBL) = ILABEL
!
!     IF THIS WAS A '#' PREFIX LABEL, END OF BOOLEAN FIELD;
!     MOVE TO COMMENT LINE PROCESSING
!
!     NOTE THAT THE EVALUATION LABEL (INCLUDING '#' PREFIX) IS ALWAYS
!     STORED AS THE LAST BOOLEAN LABEL
!
  IF(ILABEL(1:1) .NE. '#') GO TO 200
!
!------------------------------------------------------------------------------
!
!     LOOK FOR COMMENT LINES, FLAGGED BY '!' IN COLUMN 1
!
  LCMPTR = ILPTR + 1
300 ILPTR = ILPTR + 1
!
  IF(ILPTR .GT. NELN) THEN
!
!     NOTE THAT IT IS LEGAL TO HAVE NO COEFFICIENTS IN AN ENTRY
!
     NCMLN = NELN - LCMPTR + 1
     NCFLN = 0
     RETURN
  ENDIF
!
  IF(EBUFF(ILPTR)(1:1) .EQ. '!') GO TO 300
!
  LCFPTR = ILPTR
  NCMLN = LCFPTR - LCMPTR
  NCFLN = NELN - LCFPTR + 1
!
  RETURN
END SUBROUTINE ALPARS_Z
!
!##############################################################################
!
SUBROUTINE ALXLBL_Z(KLINE, KNL, KLPTR, KCPTR,&
     KLABEL, KLBLNC, KFLAG)
!
!                     *********************************
!                     * EXTRACT BLANK-DELIMITED LABEL *
!                     *********************************
!
!     SEARCH FOR THE NEXT BLANK-DELIMITED LABEL STRING TO BE FOUND IN THE
!     CHARACTER DATA ARRAY KLINE (KNL LINES LONG), BEGINNING AT CHARACTER
!     POSITION KCPTR OF LINE KLPTR.  THE NEXT LABEL MAY START AT KCPTR OR
!     MAY BE PRECEEDED BY ANY NUMBER OF BLANKS.  IF KCPTR .GT. LEN(KLINE),
!     THE ROUTINE WILL START AT THE BEGINNING OF THE NEXT LINE.  THE
!     LABEL IS RETURNED IN KLABEL, ALONG WITH ITS NUMBER OF CHARACTERS, KLBLNC.
!     THE KLPTR AND KCPTR POINTERS ARE RETURNED POSITIONED READY FOR THE NEXT
!     CALL, 2 CHARACTERS AFTER THE END OF THE FOUND LABEL.  KFLAG = 0 FOR
!     NORMAL RETURNS, KFLAG = 1 WHEN NO MORE LABELS EXIST BEFORE THE END OF
!     THE KLINE ARRAY, KFLAG = -1 FOR LABEL TRUNCATED TO KLBLNC = LEN(KLABEL)
!     CHARACTERS TO FIT INTO KLABEL.
!
!------------------------------------------------------------------------------
!
!     NOTE: THIS IS AN ALADDIN STANDARD SUBROUTINE, WHICH INTERFACES ONLY
!           THROUGH THE PASSED VARIABLES IN THE SUBROUTINE CALL.
!
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  IMPLICIT NONE
  INTEGER klptr,kcptr,klblnc,kflag,knl,ibindx,ieptr
!============
  CHARACTER*(*) KLINE(KNL)
  CHARACTER*(*) KLABEL
!
!------------------------------------------------------------------------------
!
!     MOVE TO NEXT LINE IF KCPTR POINTS BEYOND END OF THIS LINE;
!     RETURN WITH KFLAG = 1 IF THIS WOULD GO BEYOND END OF KLINE ARRAY
!
100 IF(KCPTR .GT. LEN(KLINE(1))) THEN
     IF(KLPTR .LT. KNL) THEN
        KLPTR = KLPTR + 1
        KCPTR = 1
     ELSE
        KFLAG = 1
        RETURN
     ENDIF
  ENDIF
!
!------------------------------------------------------------------------------
!
!     SEARCH FOR NEXT BLANK CHARACTER IN FIELD BEGINNING AT POINTER POSITION
!
  IBINDX= INDEX(KLINE(KLPTR)(KCPTR:), ' ')
!
  IF(IBINDX .EQ. 1) THEN
!
!     LEADING BLANK AT FIRST SEARCHED POSITION; INCREMENT POINTER AND TRY AGAIN
!
     KCPTR = KCPTR + 1
     GO TO 100
!
  ELSE IF(IBINDX .EQ. 0) THEN
!
!       NO BLANKS FOUND; LABEL MUST EXTEND TO END OF LINE, POSITION
!       END OF LABEL POINTER AT END OF LINE
!
     IEPTR = LEN(KLINE(KLPTR))
!
  ELSE
!
!       TRAILING BLANK FOUND AFTER LABEL; POSITION END OF LABEL POINTER
!       AT LAST CHARACTER OF LABEL, JUST BEFORE TRAILING BLANK
!
     IEPTR = KCPTR + IBINDX - 2
!
  ENDIF
!
!------------------------------------------------------------------------------
!
!     LABEL FOUND; STARTS AT KCPTR, ENDS AT IEPTR
!
  KLABEL = KLINE(KLPTR)(KCPTR:IEPTR)
  KLBLNC = IEPTR - KCPTR + 1
!
!     FLAG SUCCESSFUL RETURN, OR -1 IF LABEL WAS TRUNCATED TO FIT IN KLABEL
!
  IF(KLBLNC .LE. LEN(KLABEL)) THEN
     KFLAG = 0
  ELSE
     KLBLNC = LEN(KLABEL)
     KFLAG = -1
  ENDIF
!
!     POSITION CHARACTER POINTER FOR EXIT AT POSITION JUST BEYOND THE
!     TRAILING BLANK; NOTE THAT IF THIS IS BEYOND THE END OF THE LINE,
!     THE NEXT CALL WILL SHIFT THE POINTERS AS REQUIRED
!
  KCPTR = IEPTR + 2
!
  RETURN
END SUBROUTINE ALXLBL_Z
!
!##############################################################################
!
SUBROUTINE ALCOMP_Z(KHSL, KNHSL, KBASL, KNBASL,&
     KBNSL, KNBNSL, KMATCH)
!
!                 *************************************
!                 * ALADDIN STANDARD LABEL COMPARATOR *
!                 *************************************
!
!     THIS ROUTINE TAKES THE SUPPLIED SEARCH LABELS AND DETERMINES IF
!     THE PARSED ENTRY CURRENTLY IN COMMON / ALENT / MATCHES THIS
!     SEARCH CRITERION.  IN ORDER TO DO SO, THE HIERARCHICAL LABELS
!     MUST MATCH EXACTLY, EXCEPT THAT "*" AS A SEARCH LABEL ACTS AS A
!     WILDCARD, MATCHING ANY ENTRY LABEL IN THAT POSITION.  THE "**"
!     WILDCARD EXTENDS THE WILDCARD MATCH TO ANY NUMBER OF HIERARCHICAL
!     LABELS TO THE RIGHT OF THAT POSITION.  BOOLEAN .AND. SEARCH LABELS
!     MUST APPEAR IN THE ENTRY BOOLEAN FIELD FOR A MATCH TO BE SUCCESSFUL,
!     WHILE BOOLEAN .NOT. SEARCH LABELS MUST *NOT* APPEAR IN THE ENTRY
!     FOR A SUCCESFUL MATCH.
!
!     NOTE: LABEL COMPARISONS ARE UPPER-CASE/LOWER-CASE INSENSITIVE, USING
!           THE LOGICAL FUNCTION ALCIEQ INSTEAD OF THE .EQ. OPERATOR
!
!     KHSL   HIERARCHICAL SEARCH LABELS
!     KNHSL  NUMBER OF HIERARCHICAL SEARCH LABELS
!     KBASL  BOOLEAN .AND. SEARCH LABELS
!     KNBASL NUMBER OF BOOLEAN .AND. SEARCH LABELS
!     KBNSL  BOOLEAN .NOT. SEARCH LABELS
!     KNBNSL NUMBER OF BOOLEAN .NOT. SEARCH LABELS
!
!     KMATCH LOGICAL .TRUE./.FALSE. RETURN ON A SUCCESFUL MATCH
!
!------------------------------------------------------------------------------
!
!     NOTE: THIS IS AN ALADDIN STANDARD SUBROUTINE.  IT INTERFACES ONLY
!           THROUGH THE SUBROUTINE CALL PASSED VARIABLES AND COMMON / ALENT/.
!
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use alpcom_mod
  IMPLICIT NONE
  INTEGER knbasl,knbnsl,knhsl,jhsl,jbasl,jbl,jbnsl
!============
  CHARACTER*(*) KHSL(*), KBASL(*), KBNSL(*)
  LOGICAL KMATCH
  LOGICAL ALCIEQ_Z
  EXTERNAL ALCIEQ_Z
!
!     INITIALIZE RETURN SUCCESS FLAG AS FALSE TO SIMPLIFY RETURNS
!
  KMATCH = .FALSE.
!
!     DO HIERARCHICAL SEARCH LABEL COMPARISON IF THERE
!     ARE ANY HSL'S
!
  IF(KNHSL .GT. 0) THEN
     DO JHSL = 1, KNHSL
!
!     '*' IN A HIERARCHICAL SEARCH LABEL POSITION IS A WILD CARD MATCH
!
        IF(KHSL(JHSL) .EQ. '*') cycle
!
!     '**' IN A HIERARCHICAL SEARCH LABEL POSITION IS WILD CARD MATCH
!     TO REST OF HIERACHICAL SEARCH LABEL FIELD; PROCEED TO BOOLEAN SEARCH
!
        IF(KHSL(JHSL) .EQ. '**') GO TO 150
!
!     IF THIS POSITION DOES NOT MATCH, OR DOES NOT EXIST IN ENTRY,
!     THEN THIS ENTRY IS REJECTED; GET NEXT ENTRY
!
        IF(JHSL .GT. NHL) RETURN
        IF( .NOT. ALCIEQ_Z(KHSL(JHSL), HL(JHSL)) ) RETURN
!
     enddo
  ENDIF
!
!     ALL HIERARCHICAL SEARCH LABELS MATCH; HOWEVER, WITHOUT A "**" WILDCARD,
!     REJECT ENTRY IF IT HAS MORE HL THAN IN SEARCH REQUEST
!
  IF(NHL .GT. KNHSL) RETURN
!
!     ENTRY HAS MATCHED HIERARCHICAL SEARCH LABELS; PROCEED TO BOOLEAN SEARCH
!     SEARCH FAILS IF THERE ARE .AND. SEARCH LABELS AND NO ENTRY BL'S
!     SEARCH AUTOMATICALLY SUCCEEDS IF THER ARE NO SEARCH LABELS INPUT
!
150 IF(KNBASL .GT. 0 .AND. NBL .EQ. 0) RETURN
  IF(KNBASL .GT. 0 .AND. NBL .GT. 0) THEN
!
     DO JBASL = 1, KNBASL
!
        DO JBL = 1, NBL
           IF( ALCIEQ_Z(KBASL(JBASL), BL(JBL)) ) cycle
        enddo
!
!     COMPLETING .AND. LOOP WITHOUT A MATCH MEANS THIS ENTRY IS REJECTED
!
        RETURN
     enddo
  ENDIF
!
  IF(KNBNSL .GT. 0 .AND. NBL .GT. 0) THEN
     DO JBNSL = 1, KNBNSL
!
        DO JBL = 1, NBL
!
!     A MATCH WITH A BOOLEAN .NOT. LABEL CAUSES REJECTION OF THIS ENTRY
           !
           IF( ALCIEQ_Z(KBNSL(JBNSL), BL(JBL)) ) RETURN
        enddo
!
     enddo
  ENDIF
!
!     THIS ENTRY SATISFIES ALL SEARCH CRITERIA
!
  KMATCH = .TRUE.
!
  RETURN
END SUBROUTINE ALCOMP_Z
!
LOGICAL FUNCTION ALCIEQ_Z(KA, KB)
!
!     CASE-INSENSITIVE CHARACTER STRING .EQ. FUNCTION
!
!     NOTE: INPUT STRINGS KA AND KB ARE LEFT UNCHANGED BY THIS ROUTINE
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  IMPLICIT NONE
  INTEGER j,idx
!============
  CHARACTER*(*) KA, KB
  CHARACTER*132 IUCA, IUCB
  CHARACTER*26 IUC, ILC
!
  IUC = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
  ILC = 'abcdefghijklmnopqrstuvwxyz'
!
!     CONVERT BOTH STRINGS TO UPPER CASE AND THEN COMPARE
!
  IUCA = KA
  DO J = 1, LEN(KA)
     IDX = INDEX(ILC, KA(J:J))
     IF(IDX .NE. 0) IUCA(J:J) = IUC(IDX:IDX)
  enddo

  IUCB = KB
  DO J = 1, LEN(KB)
     IDX = INDEX(ILC, KB(J:J))
     IF(IDX .NE. 0) IUCB(J:J) = IUC(IDX:IDX)
  enddo
!
  ALCIEQ_Z = IUCA .EQ. IUCB
!
  RETURN
END FUNCTION ALCIEQ_Z
!
!##############################################################################
!
SUBROUTINE ALRECF_Z(PCF, KNCF, KNCFMX, KERMSG)
!
!                  ****************************************
!                  * CONVERT COEFFICIENTS TO REAL NUMBERS *
!                  ****************************************
!
!     USING THE COEFFICIENT FIELD POINTERS IN COMMON / ALENT /,
!     PARSE THE COEFFICIENT LINES INTO REAL NUMBERS IN THE OUTPUT
!     ARRAY PCF.  KNCF RETURNS THE NUMBER OF COEFFICIENTS FOUND, WHILE
!     KNCFMX IS THE SUPPLIED DIMENSIONED LENGTH OF THE PCF ARRAY.
!     PROCESSING ERROR MESSAGES ARE RETURNED VIA KERMSG, WITH KERMSG = ' '
!     INDICATING NO ERRORS.
!
!                               **NOTE**
!
!     THE INDIVIDUAL COEFFICIENT VALUES ARE PARSED FROM THE COEFFICIENT
!     FIELD LINES AS BLANK-DELIMITED LABELS, USING THE ALXLBL ROUTINE.
!     THEREFORE, INDIVIDUAL DATA VALUES MUST BE BLANK DELIMITED (E.G.,
!     COMMAS ARE NOT VALID), AND MUST *NOT* CONTAIN ANY INTERNAL
!     BLANKS, OTHERWISE READ ERRORS WILL OCCUR !
!
!------------------------------------------------------------------------------
!
!     NOTE: THIS IS AN ALADDIN STANDARD SUBROUTINE.  IT INTERFACES USING
!           ONLY THE SUBROUTINE CALL PASSED VARIABLES AND COMMON / ALENT /.
!
!------------------------------------------------------------------------------
!
!     REV. 2/03/89 BY J.J.SMITH IAEA ATOMIC AND MOLECULAR DATA UNIT
!          PCF CHANGED FROM SINGLE TO DOUBLE PRECISION
!
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
 use iso_c_binding, only: fp => c_double
 use alpcom_mod
 IMPLICIT NONE
 INTEGER kncfmx,kncf,ilptr,icptr,ilblnc,iflag,icferr
!============
 real(fp) PCF(*)
 CHARACTER*(*) KERMSG
 CHARACTER*40 ILABEL
!
 KERMSG = ' '
 KNCF = 0
 FEXTN = .TRUE.
!
 IF(NCFLN .EQ. 0) RETURN
!
 ILPTR = LCFPTR
 ICPTR = 1
!
400 CALL ALXLBL_Z(EBUFF, NELN, ILPTR, ICPTR, ILABEL, ILBLNC, IFLAG)
!
!     ACT ON LABEL SEARCH ERROR FLAGS
!
!     0 = OK
!     -1 = COEFFICIENT STRING TRUNCATED; ERROR RETURN
!     1 = END OF ENTRY REACHED PREMATURELY; ERROR RETURN
!
 IF(IFLAG .EQ. -1) THEN
    KERMSG = ' COEFFICIENT "'//ILABEL//'" TRUNCATED'
    RETURN
 ENDIF
!
 IF(IFLAG .EQ. 1) THEN
    IF(ILPTR .NE. NELN)&
         KERMSG = ' PREMATURE END OF COEFFICIENT FIELD'
    RETURN
 ENDIF
!
!     CONVERT THIS 'LABEL' TO A REAL NUMBER
!
 IF(KNCF .GE. KNCFMX) THEN
    KERMSG = ' COEFFICIENT ARRAY OVERFLOW'
    RETURN
 ENDIF
!
!     CHECK FOR THE LENGTH OF THE COEFFICIENT IF > 12 SET THE NUMBER
!     LENGTH FLAG TO TRUE.
!
 IF (ILBLNC .GT. 12) FEXTN =.FALSE.
!
 KNCF = KNCF + 1
 READ(ILABEL, '(BN,F20.0)', IOSTAT=ICFERR) PCF(KNCF)
!
!     IF NOT INTERNAL READ ERROR, LOOP BACK FOR NEXT COEFFICIENT
!     OTHERWISE, ERROR RETURN
!
 IF(ICFERR .EQ. 0) GO TO 400
!
 KERMSG = ' READ ERROR FOR COEFFICIENT "'//ILABEL//'"'
 RETURN
END SUBROUTINE ALRECF_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

      SUBROUTINE PLCENTR (R,Z,N,RCENTR,ZCENTR)
 
      IMPLICIT NONE 
 
C     USE GREEN'S THEOREM TO CALCULATE CENTROIDS
C     DICK WIELAND
C
C     RGA: Jun2010, switch to centroid of inscribed polygon
C
      REAL R(*),Z(*),RCENTR,ZCENTR
      INTEGER N
 
      REAL AREA,LINT,MR,MZ
      INTEGER I
 
C     CALCULATE AREA ENCLOSED
      AREA = 0.
      MR   = 0.
      MZ   = 0.
      DO I = 1,N-1
          LINT = R(I)*Z(I+1)-R(I+1)*Z(I)
          AREA = AREA + LINT
          MR   = MR + (R(I)+R(I+1))*LINT
          MZ   = MZ + (Z(I)+Z(I+1))*LINT
      END DO
      AREA = AREA/2.

      if (abs(AREA)>1.e-10) then
         MR = MR/(6.*AREA)
         MZ = MZ/(6.*AREA)
      else
         MR=0.
         MZ=0.
         do i = 1, N
            MR = MR+R(I)
            MZ = MZ+Z(I)
         end do
         MR = MR/max(1,N)
         MZ = MZ/max(1,N)
      end if

      RCENTR = MR
      ZCENTR = MZ
 
      RETURN
      END
 

      subroutine gosleep(isecs)
C
#ifdef __NAGWARE
      use f90_unix_proc
#endif
C
      integer isecs                     ! number of seconds to sleep
C
C  this subroutine causes the program to go to sleep for `isecs' seconds!
C
      call csleep( max(0,isecs) )
      return
      end

      subroutine fcopy(oldname,newname,ier)
C
C  dmc 15 June 2011 -- copy file w/o system (shell) call out
C
      implicit NONE
C
      character*(*), intent(in) :: oldname   ! old filename
      character*(*), intent(in) :: newname   ! new filename
      integer, intent(out) :: ier  ! completion status, 0=OK
C
C  ** copy a file **
C
C  return error code
C    ier=0 -- success
C    ier=1 -- error
C
C  cccopy.c writes a message on stdout if there is an error opening
C    oldname or newname files
C
      integer ilo,iln,cccopy
C
#include "fpreproc/byte_declare.h"
C
      byte_declare fnbuf1(500),fnbuf2(500)
C----------------------------------
C
      ier=0
C
      ilo=len_trim(oldname)
      iln=len_trim(newname)
      if(min(ilo,iln).le.0) then
         write(6,*) ' ?fcopy:  filename argument is blank.'
         ier=1
         return
      endif
C
      call cstring(oldname(1:ilo),fnbuf1,'2C')
      call cstring(newname(1:iln),fnbuf2,'2C')

      ier=cccopy(fnbuf1,fnbuf2)
      if(ier.ne.0) ier=1
C
      return
      end

C******************** START FILE ILNURD.FOR ; GROUP URDUTS ******************
C--------------------------------------------------------------
C&  ILNURD  INTEGER FCN (UREAD) LEN OF STRING W/O TRAILING BLANKS
C
      INTEGER FUNCTION ILNURD(STR)
C
      implicit NONE
C
      CHARACTER*(*) STR
C
      integer str_length
C
C---------------------------------------
C  replace legacy code with portlib call -- dmc Oct 2002
C
      ilnurd=max(1,str_length(str))
C
      END
C******************** END FILE ILNURD.FOR ; GROUP URDUTS ******************

C******************** START FILE USPCHK.FOR ; GROUP USPARM *************
C----------------------------------------------------------------
C& USPCHK  SCAN UREAD STRING PARAMETER ASSIGN/USE/PASS LINE
C
      SUBROUTINE USPCHK(ZLINE,LLINE,ISTART,IFIN1,INDEQ,IFINA)
C
C  THIS ROUTINE ADDED TO AID TYPEAHEAD - FIND CHARACTER LIMITS OF
C  STRING PARAMETER STUFF
C
C
C  INPUT - UNPACKED LINE ZLINE(LLINE)
C  ISTART- WHERE TO START SCAN
C
C  OUTPUT- IFIN1 END OF FIRST "GRAMMATIC UNIT" (PARAMETER
C          ASSIGNMENT OR USE)
C          INDEQ - LOCN OF = SIGN IF FIRST UNIT IS ASSIGNMENT
C            (0 OTHERWISE)
C          IFINA - LAST CHAR INVOLVING UREAD STRING PARAMETER
C
      CHARACTER*1 ZLINE(LLINE),MBLANK,MSLASH,MEQS,MCOMMA,MSEMI
C
      DATA MCOMMA/','/
      DATA MBLANK/' '/
      DATA MEQS/'='/
      DATA MSLASH/'/'/
      DATA MSEMI/';'/
C
C--------------------------------------------
C
      IST = 0         ! RGA, was undefined
      ISEMI=IST
      CALL UFCHAR(ZLINE,MSEMI,ISEMI,LLINE)
      IF(ISEMI.GT.0) THEN
        ILINE=ISEMI-1
      ELSE
        ILINE=LLINE
      ENDIF
C
      IPASS=0
      INDEQ=0
      IST=ISTART
      IFIN1=IST
C
 10   CONTINUE
      IFINA=IST
      IF(IST.GE.ILINE) RETURN
      ISTP1=IST+1
      IPASS=IPASS+1
C
      IBL=IST
      CALL UFCHAR(ZLINE,MBLANK,IBL,ILINE)
C  IF BLANK FOLLOWS IMMEDIATELY, EXIT
      IF(IBL.EQ.ISTP1) RETURN
C
      ICL=IST
      CALL UFCHAR(ZLINE,MCOMMA,ICL,ILINE)
C  IF COMMA FOLLOWS IMMEDIATELY, EXIT
      IF(ICL.EQ.ISTP1) RETURN
      ISL=ISTP1
      CALL UFCHAR(ZLINE,MSLASH,ISL,ILINE)
C  IF SLASH FOLLOWS IMMEDIATELY, EXIT
      IF(ISL.EQ.ISTP1) RETURN
C
      IEL=IST+2
      IF(IEL.LT.ILINE) THEN
        CALL UFCHAR(ZLINE,MEQS,IEL,ILINE)
C  CHK FOR DBL "=="
        IF((IEL.GT.0).AND.(IEL.LT.ILINE)) THEN
          IF(ZLINE(IEL+1).EQ.MEQS) THEN
            IELP=IEL+1
          ELSE
            IELP=IEL
          ENDIF
C  CHK 1ST NONBLANK AFTER "=" -- IF A SLASH, EXTEND GRAMMATICAL UNIT
C  TO ALLOW "DELAYED" PARAMETER DEFN "/NAME=/NAME2=VALUE"
          DO IC=IELP+1,ILINE
            IF(ZLINE(IC).NE.MBLANK) THEN
      	IF(ZLINE(IC).EQ.MSLASH) THEN
      	  ISL=IC+1
      	  CALL UFCHAR(ZLINE,MSLASH,ISL,ILINE)
      	ENDIF
      	GO TO 15
            ENDIF
          ENDDO
 15       CONTINUE
        ENDIF
      ELSE
        IEL=0
      ENDIF
C
      IF(IBL.EQ.0) IBL=ILINE+1
      IF(ICL.EQ.0) ICL=ILINE+1
      IF(ISL.EQ.0) ISL=ILINE+1
      IF(IEL.EQ.0) IEL=ILINE+1
C
C  END OF NAME FIELD
C
      INLIM=MIN0(IBL,ICL,ISL,IEL)-1
      INLP1=INLIM+1
C
C  CHECK WHAT'S AFTER NAMEFIELD
 20   CONTINUE
      IF(INLP1.GT.ILINE) THEN
        IFINA=ILINE
        IF(IPASS.EQ.1) IFIN1=IFINA
        RETURN
      ELSE IF(INLP1.EQ.ICL) THEN
C  COMMA TERMINATES
        IFINA=INLIM
        IF(IPASS.EQ.1) IFIN1=IFINA
        RETURN
      ELSE IF(INLP1.EQ.ISL) THEN
C  SLASH ENDS "GRAMMATICAL UNIT" AND STARTS NEW ONE
        IF(IPASS.EQ.1) IFIN1=INLIM
        IST=INLP1
        GO TO 10
      ELSE IF(INLP1.EQ.IEL) THEN
C  EQUAL SIGN INDICATES ASSIGNMENT-- TERMINATED ONLY BY ANOTHER SLASH
        IF(IPASS.EQ.1) INDEQ=IEL
        IF(ISL.GT.ILINE) THEN
          INLP1=ISL
          GO TO 20
        ELSE
C  SLASH ALSO STARTS NEW "UNIT"
          IF(IPASS.EQ.1) IFIN1=ISL-1
          IST=ISL
          GO TO 10
        ENDIF
C  ELSE BLANK... INDETERMINATE,
      ELSE IF(INLP1.EQ.IBL) THEN
C  FIND A NONBLANK
        DO 30 IC=INLP1,ILINE
          IF(ZLINE(IC).NE.' ') GO TO 40
 30     CONTINUE
C  NO NONBLANK
        INLP1=ILINE+1
        GO TO 20
C
 40     CONTINUE
        IF((IC.EQ.ISL).OR.(IC.EQ.IEL).OR.(IC.EQ.ICL)) THEN
          INLP1=IC
          GO TO 20
        ENDIF
C BLANK ENDS PARAMETER STRING UNITS
        IFINA=INLP1
        IF(IPASS.EQ.1) IFIN1=IFINA
        RETURN
      ENDIF
C
C  ERROR IF FELL THRU
C
      IARGHH=1/IARGHH
      RETURN
      END
C******************** END FILE USPCHK.FOR ; GROUP USPARM ***************

C******************** START FILE GRFFIT.FOR ; GROUP GRFFIT ******************
C----------------------GRFUF1 SUBMODULE-----------------------
C  D. MC CUNE 23 SEP 1985 AT GARCHING
C       MAKE NEW ROUTINE "GRFFIT" BASED ON GRFUF1.
C       PLOT "FIT" CURVE, THEN INDIVIDUAL POINTS "DATA FROM
C       WHICH FIT WAS GENERATED".
C       CURRENT VERSION PLOTS THE POINTS ONLY.  FUTURE:  ERROR BARS?
C         THE NUMBER AND LOCATION OF DATA POINTS MAY BE DIFFERENT FROM
C         NO. AND LOC. OF FIT POINTS.
C
C  REWRITTEN TO USE NEW STANDARDIZED PLOTTING SUBROUTINE CALLS - DMC
C   FEB 1986
C
C
      SUBROUTINE GRFFIT(X,Y,N,IPROC,LBLY,
     1                 LBLX,ISHOT,IDEV,ZDATE,NXTR,XTRVAL,XTRLAB,
     1                 NDPT,XDPT,YDPT)
C
C   *ARGUMENTS SAME AS IN GRFUF1 WITH FOLLOWING ADDITIONS*
C
C  XDPT,YDPT  ARRAYS OF LENGTH NDPT
C    FIT DATA POINTS
C
      DIMENSION X(N),Y(N)
C
      DIMENSION XDPT(NDPT),YDPT(NDPT)
C
      CHARACTER*4 IDEV
      CHARACTER*10 LBLY(3),LBLX(3),ZDATE,XTRLAB(3)
      character*15 zshot
      CHARACTER*10 ZLBL(4),LNSMOO,LYSMOO,LYAVER,LOTHER
C
      CHARACTER*25 ZLPROC
      CHARACTER*12 ZSCVAL
C
      DATA LNSMOO/'          '/
      DATA LYSMOO/' SMOOTHED.'/
      DATA LYAVER/' AVERAGED.'/
      DATA LOTHER/' PROCESSED'/
C
C  PREPARE CERTAIN LABELS
      ZLPROC='                         '
      IF((IPROC.EQ.1).OR.(IPROC.EQ.3)) ZLPROC(2:11)=LYAVER
      IF((IPROC.EQ.2).OR.(IPROC.EQ.3)) ZLPROC(14:23)=LYSMOO
      IF(IPROC.EQ.4) ZLPROC(2:11)=LOTHER
C
      WRITE(ZSHOT,7701) IDEV,ISHOT
 7701 FORMAT(A4,I11)
C
C  CALL COMMON PLOTTING/INTERFACE SUBROUTINE - CONSTRUCT LABELS
C   ENCODE ATTACHED SCALAR DATA ITEM IF NECESSARY
C
      IF(NXTR.EQ.0) THEN
        CALL GRAFXF(X,Y,N,XDPT,YDPT,NDPT,
     >      LBLX(3),LBLY(3),' ',
     >      ZSHOT//' '//ZDATE//' '//ZLPROC,
     >      LBLY(1)//LBLY(2)//' VS. '//LBLX(1)//LBLX(2) )
      ELSE
C
        WRITE(ZSCVAL,1003) XTRVAL
        IF(ZSCVAL(1:1).EQ.' ') ZSCVAL(1:1)='+'
 1003 FORMAT(1PE12.5)
C
        CALL GRAFXF(X,Y,N,XDPT,YDPT,NDPT,
     >      ZSHOT//' '//ZDATE//' '//ZLPROC,
     >      '['//ZSCVAL//'] '//XTRLAB(1)//XTRLAB(2)//' '//XTRLAB(3),
     >      LBLY(1)//LBLY(2)//' VS. '//LBLX(1)//LBLX(2) )
      ENDIF
C
      RETURN
      	END

C******************** START FILE UFCPWR.FOR ; GROUP UFCMPR ******************
C---------------------------------------------------------------------
C  UFCPWR
C
C  mod dmc Aug 1994 -- write monotonic independent coordinates without
C    compression -- burn some space to avoid errors that trash
C    monotonicity
C
C  MODIF DMC APR 1984-- TREAT ALL ARRAYS AS 2D.  SUPPORT READ/WRITE
C  OF 2D DATA THAT IS NOT CONTIGUOUSLY STORED
C
C  MODIF DMC APR 1984-- ADD ERROR CHECKING
C
C  MODIF DMC APR 1986-- 3D ARRAY CAPACITY ADDED
C   CALLING ARGUMENTS MODIFIED ***
C
C  CONVERT A 1-D ARRAY TO INTEGER, COMPRESS IT AND WRITE TO ILUN
C  UTILITY ROUTINE FOR UF1DWR AND UF2DWR
C
      SUBROUTINE UFCPWR(ILUN,ARRAY,ANAME,NA1,NA2,NA3,
     >     NAA1,NAA2,ZTOL,IERR)
C
C  ILUN-- LOGICAL UNIT NUMBER ON WHICH TO WRITE
C  ARRAY-- 1D ARRAY CONTAINING DATA TO BE COMPRESSED AND WRITTEN
C  ANAME-- TEXT IDENTIFYING ARRAY (X,Y,F)
C  NA1  -  1ST DIMENSION OF ARRAY
C  NA2  -  2ND DIMENSION OF ARRAY
C  NA3  -  3RD DIMENSION OF ARRAY
C  NAA1 -  NUMBER OF PTS "ACTIVE" IN ARRAY 1ST DIMENSION
C  NAA2 -  NUMBER OF PTS "ACTIVE" IN ARRAY 2ND DIMENSION
C
C  ZTOL -  THRESHOLD FOR WARNING ERROR IN RTOI CONVERSION
C  IERR--  RETURNED ERROR CODE; 0 IF OK
C
      USE UFILES
C
      REAL ARRAY(NA1,NA2,NA3)
      CHARACTER*1 ANAME
C
      COMMON /UFTPACKU/ TUNPK,TPACK,CDATA,CTEST
      INTEGER*2 TUNPK(UFMAXR)	!UNPACKED INTEGERS
      INTEGER*4 TPACK(UFMAXR)	!PACKED INTEGERS
      REAL CDATA(UFMAXR),CTEST(UFMAXR)
C
      INTEGER IBITR             !BITS FOR REAL-TO-INTEGER
      INTEGER IBITS             !BITS FOR INTEGER COMPRESS
C
      data ibitr/15/
      data ibits/16/
C------------------------------------------------------------------
C  DUMMY FLAG PUT IN FILE FOR POSSIBLE LATER USE--
C
CXXX	DATA IDUMF/0/  -- replaced by IMONO
C
C-----
C  determine monotonicity
C
      IMONO=1
      IF((NA2.NE.1).OR.(NA3.NE.1)) IMONO=0
      IF(IMONO.EQ.1) THEN
         IF((ANAME.NE.'X').AND.(ANAME.NE.'Y').AND.
     >        (ANAME.NE.'Z')) IMONO=0
      ENDIF
C
      IF(IMONO.EQ.1) THEN
         DO IX=2,NA1
            IXM1=IX-1
            IF(ARRAY(IXM1,1,1).GE.ARRAY(IX,1,1)) THEN
      	 IMONO=0
      	 GO TO 10
            ENDIF
         ENDDO
      ELSE
         GO TO 10  ! IMONO=0
      ENDIF
C
C  WRITE MONOTONIC INDEP. COORD. DATA OUT UNCOMPRESSED
C
C  IMONO=1 HERE
C
      ZOFFS=0.0
      ZSCAL=0.0
      WRITE(ILUN) ZOFFS,ZSCAL,IMONO
      WRITE(ILUN) (ARRAY(IX,1,1),IX=1,NA1)
      ierr=0
      RETURN
C
C  IMONO = 0 from here on down
C
C  INITIALIZE ERROR CHECKING
C
 10   CONTINUE
      ZMIN=ARRAY(1,1,1)
      ZMAX=ARRAY(1,1,1)
C  MIN AND MAX OF ARRAY
      DO I3=1,NA3
       DO I2=1,NAA2
        DO I1=1,NAA1
          Z=ARRAY(I1,I2,I3)
          ZMIN=AMIN1(ZMIN,Z)
          ZMAX=AMAX1(ZMAX,Z)
        ENDDO
       ENDDO
      ENDDO
C
      ZZAMAX=AMAX1(ABS(ZMIN),ABS(ZMAX))
      ZZAMIN=AMIN1(ABS(ZMIN),ABS(ZMAX))
      IF(((SIGN(1.0,ZMIN)*SIGN(1.0,ZMAX)).LE.0.0) .OR.
     >      ((ZZAMIN*10.0).LT.ZZAMAX)) THEN
        IRELE2=1
        ZR2LIM=0.1*ZZAMAX
        RL2ERR=0.0
        RL2AVG=0.0
        ICTE2=0
      ELSE
        IRELE2=0
      ENDIF
C
      RELERR=0.0
      RELAVG=0.0
      ABSERR=0.0
      ABSAVG=0.0
C
      NAACT=NAA1*NAA2*NA3
C
      WRITE(UFCLUN,8001) ANAME,NAACT,ZMIN,ZMAX
 8001 FORMAT(1x,'"',a,'" data compression, n = ',i7,' range = ',
     >1pe11.4,' to ',1pe11.4/
     >' >error classification        maximum value   average value')
C
C  SUM UP POST-COMPRESSION NO. OF WORDS
      ITWDS=0
C
      IMAXU=UFRSIZ
      DO IDON=0,NAACT-1,IMAXU	!TAKE DATA IN CHUNKS OF IMAXU WORDS
C
        ICOMP=MIN(NAACT-IDON,IMAXU)
        CALL UFG2DA(ARRAY,NA1,NA2,NA3,NAA1,NAA2,IDON,CDATA,ICOMP)
        CALL UFRTOI(IBITR,ICOMP,CDATA,
     >              TUNPK,ZSCAL,ZOFFS,IERR)
C
CX	  WRITE(ILUN,3012) ZOFFS,ZSCAL,ANAME
CX 3012	  FORMAT(1X,2(E14.7),T32,';-OFFSET, SCALE FOR ',A,' RTOI-')
        WRITE(ILUN) ZOFFS,ZSCAL,IMONO
C
C  BIT COMPRESS INTEGERS
        ILOCB=0	  	  !BIT OFFSET IN TUNPK ARRAY
        DO JJ=1,IMAXU
          TPACK(JJ) = 0
        ENDDO
        CALL CMPRSI(IBITS,ICOMP,TPACK,TUNPK,ILOCB,IMAXU,IERR)
        IF (IERR.NE.0) THEN
          WRITE(UFELUN,9700) IERR
 9700     FORMAT(' ? DATA WONT COMPRESS, REASON=',I3)
          GO TO 9000
        ENDIF
C
        IWRDS = ILOCB/32 + 1
        IWRDS2 = 2*IWRDS
C
C  MODIF DMC APR 1985 - IF COMPRESSION BIT STREAM IS LONGER THAN THE
C    UNCOMPRESSED DATA STREAM, WRITE THE UNCOMPRESSED STREAM.
C    FLAG THIS BY WRITING A NEGATIVE WORD COUNT.  SEE CORRESPONDING
C    CHANGES IN READ ROUTINE
C
C---------------------------------------
      IF(IWRDS2.LE.ICOMP) THEN
C
CX	  WRITE(ILUN,3014) ICOMP, IWRDS
CX 3014	  FORMAT(1X,2I10,T32,';-# WORDS BEFORE,AFTER COMPRESSION')
        WRITE(ILUN) ICOMP,IWRDS,IMONO
C
        ITWDS=ITWDS+IWRDS
C
CX	  WRITE(ILUN,3016) (TPACK(JJ),JJ=1,IWRDS)
CX 3016	  FORMAT(8Z9)
        WRITE(ILUN) (TPACK(IJ),IJ=1,IWRDS)
C
C ERROR STATS-- DECOMPRESS AND COMPARE DATA
C
        IWROT=IWRDS
C
        ILOCB = 0
        CALL XPANDI(IBITS,TPACK,ILOCB,TUNPK,1,IWROT,IERR)
        IF (IERR.NE.0) THEN
          WRITE(UFELUN,9701) IERR
 9701     FORMAT(' ? DATA WONT DECOMPRESS, REASON=',I3)
        GO TO 9000
        ENDIF
C------------------------------------
      ELSE
C
C  WRITE DATA UNCOMPRESSED WITH WARNING MESSAGE-- NO GAIN FROM
C  FROM COMPRESSION.  THIS USUALLY INDICATES EXTREMELY NOISY DATA
C
        IWROT=ICOMP
        IWDS2=IWRDS
        IWRDS=-IWRDS
        WRITE(ILUN) ICOMP,IWRDS,IMONO
C
        IWDS1=(ICOMP+1)/2
        ITWDS=ITWDS+IWDS1
C
        WRITE(ILUN) (TUNPK(IJ),IJ=1,ICOMP)
C
C  WARNING MESSAGE IF THIS IS NOT A SHORT TRAILER RECORD
C
        IF(IWROT.GT.IMAXU/10) THEN
          WRITE(UFELUN,9009) IWDS1,IWDS2
 9009 FORMAT(' % HIGH VARIANCE DATA:  ',
     >'COMPRESSION NOT USED:  NIN=',i7,' NOUT=',i7)
        ENDIF
C
      ENDIF
C----------------------------------------
C
C  CONVERT BACK TO REAL - ERROR CHECKING
C
        DO II=1,IWROT
          CTEST(II) = (ZSCAL * TUNPK(II)) + ZOFFS
        ENDDO
C
C  COMPARE TO ORIGINAL DATA
C
        DO II=1,IWROT
          ERR1 = ABS (CTEST(II) - CDATA(II))
          ERR2 = 0.0
C  EVALUATE ABSOLUTE AND RELATIVE ERROR PT BY PT.
          IF(ERR1.NE.0.0) THEN
            DENOM = 0.5 * ABS(CTEST(II) + CDATA(II))
            IF(DENOM.EQ.0.0) THEN
              ERR2=1.0
            ELSE
              ERR2=AMIN1(1.0,ERR1/DENOM)
            ENDIF
          ENDIF
C
          ABSERR=AMAX1(ABSERR,ERR1)
          RELERR=AMAX1(RELERR,ERR2)
          ABSAVG=ABSAVG+ERR1
          RELAVG=RELAVG+ERR2
C  RELATIVE ERROR FOR PTS BOUNDED AWAY FROM ZERO
          IF(IRELE2.EQ.1) THEN
            IF(CDATA(II).GT.0.1*ZZAMAX) THEN
              RL2ERR=AMAX1(RL2ERR,ERR2)
              RL2AVG=RL2AVG+ERR2
              ICTE2=ICTE2+1
            ENDIF
          ENDIF
        ENDDO
C  END OF MAIN COMPRESSION LOOP
      ENDDO
C
C  WRITE ERROR STATS
C
      ABSAVG=ABSAVG/NAACT
      RELAVG=RELAVG/NAACT
C
      IF(IRELE2.EQ.1) THEN
        RL2AVG=RL2AVG/MAX(1,ICTE2)
      ELSE
        RL2ERR=RELERR
        RL2AVG=RELAVG
      ENDIF
C
      WRITE(UFCLUN,8002) ABSERR,ABSAVG,RELERR,RELAVG,RL2ERR,RL2AVG,
     >        ITWDS
 8002 FORMAT(5x,'absolute',t30,1pe11.4,5x,1pe11.4/
     >         5x,'relative',t30,1pe11.4,5x,1pe11.4/
     >         5x,'rel (|data| > 0.1*|max|)',t30,1pe11.4,5x,1pe11.4/
     >  10x,' ... number of words after compression:  ',i7)
C
      IERR = 0
      RETURN
C
 9000 IERR = 3
      RETURN
      END
C******************** END FILE UFCPWR.FOR ; GROUP UFCMPR ******************

      subroutine uinitg(progname)
      implicit NONE
c
c  initialize TRGRAF & UREAD
c
      character*(*), intent(in) :: progname  ! name of program

c-------------------------------
c
      call uinita(0)
      call initvis(progname)
c
      return
      end

      

C******************** START FILE UFNSRD.FOR ; GROUP UFILS0 ******************
C------------------------------------------------------------
C  UFNSRD
C  READ NUMBER OF SCALARS IN FILE
C
      SUBROUTINE UFNSRD(KMPRS,ILUN,NSC,IERR)
C
      USE UFILES
C
C---------------------
C
      IERR=0
C
      IF(KMPRS.EQ.0) THEN
        READ(ILUN,1000,ERR=9000,END=9000) NSC
 1000 FORMAT(1X,I3)
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,ERR=9000,END=9000) NSC
      else if(kmprs.eq.2) then
         call ubr3int(ilun,nsc,ier)
         if(ier.ne.0) go to 9000
      ENDIF
C
      RETURN
C---------------------
C  ERROR EXIT
 9000 CONTINUE
      IERR=1
      RETURN
C
      END
C******************** END FILE UFNSRD.FOR ; GROUP UFILS0 ******************

C******************** START FILE UFRTOI.FOR ; GROUP UFCMPR ******************
C--------------------------------------------------------------------
        SUBROUTINE UFRTOI(NBITS,NWORDS,CHAN,
     >		ICHAN,SCALE,OFFSET,IER)
c
c	This routine takes an array of real*4 words and
c	converts them to an array of integer*2 words of
c	given bit significance.
c	The transformation is of the form:
c		R = S * I + O		(linear)
c
c	INPUT:
c		NBITS	the number of significant bits in the integer I.
c		NWORDS	the length of the input array.
c		CHAN	the input array of real*4 data items [R];
c	OUTPUT:
c		ICHAN	the output array of integer*2 data items [I]
c		SCALE	the resulting scale factor [S]
c		OFFSET	the resulting offset [O]
c		IER	=0 for everything OK
c			=2 for data all zeros.
C
      REAL*4 CHAN(*)
      INTEGER*2 ICHAN(*)
C
      ZFULLS = 2**NBITS - 1
C
C--	FIND RANGE; SET SCALE & OFFSET:: R = SCALE * I + OFFSET
C
      CMAX = CHAN(1)
      CMIN = CMAX
C
      DO I = 2,NWORDS
        CMAX = MAX(CMAX,CHAN(I))
        CMIN = MIN(CMIN,CHAN(I))
      ENDDO
C
      OFFSET = CMIN
      RANGE = CMAX - CMIN
      SCALE = RANGE / ZFULLS
      IF (RANGE.NE.0.) THEN
        SCALI = ZFULLS / RANGE
      ELSE
        SCALI = 1.0
      ENDIF
C
      DO I=1,NWORDS
C
        RIN = CHAN(I)
        ICHAN(I) = (RIN - OFFSET) * SCALI  + 0.5
      ENDDO
C
      IER = 0
C
 8000 CONTINUE
      RETURN
      END
C******************** END FILE UFRTOI.FOR ; GROUP UFCMPR ******************

      SUBROUTINE R8_AGIDLX(
     > R8_XMIN,R8_XMAX)

      external AGIDLX

 ! floating type, input/output:
      REAL*8 R8_XMIN
      REAL*8 R8_XMAX

      REAL :: XMIN_act
      REAL :: XMIN_ref
      REAL :: XMAX_act
      REAL :: XMAX_ref

      XMIN_act=R8_XMIN
      XMIN_ref=R8_XMIN
      XMAX_act=R8_XMAX
      XMAX_ref=R8_XMAX

      call agidlx(XMIN_act,XMAX_act)
      if (XMIN_act .ne. XMIN_ref) R8_XMIN=XMIN_act
      if (XMAX_act .ne. XMAX_ref) R8_XMAX=XMAX_act
      return
      end

      SUBROUTINE R8_AGIDLY(
     > R8_YMIN,R8_YMAX)

      external AGIDLY

 ! floating type, input/output:
      REAL*8 R8_YMIN
      REAL*8 R8_YMAX

      REAL :: YMIN_act
      REAL :: YMIN_ref
      REAL :: YMAX_act
      REAL :: YMAX_ref

      YMIN_act=R8_YMIN
      YMIN_ref=R8_YMIN
      YMAX_act=R8_YMAX
      YMAX_ref=R8_YMAX

      call agidly(YMIN_act,YMAX_act)
      if (YMIN_act .ne. YMIN_ref) R8_YMIN=YMIN_act
      if (YMAX_act .ne. YMAX_ref) R8_YMAX=YMAX_act
      return
      end

      SUBROUTINE R8_AGIDLZ(
     > R8_ZMIN,R8_ZMAX)

      external AGIDLZ

 ! floating type, input/output:
      REAL*8 R8_ZMIN
      REAL*8 R8_ZMAX

      REAL :: ZMIN_act
      REAL :: ZMIN_ref
      REAL :: ZMAX_act
      REAL :: ZMAX_ref

      ZMIN_act=R8_ZMIN
      ZMIN_ref=R8_ZMIN
      ZMAX_act=R8_ZMAX
      ZMAX_ref=R8_ZMAX

      call agidlz(ZMIN_act,ZMAX_act)
      if (ZMIN_act .ne. ZMIN_ref) R8_ZMIN=ZMIN_act
      if (ZMAX_act .ne. ZMAX_ref) R8_ZMAX=ZMAX_act
      return
      end

!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGISOC

      SUBROUTINE R8_AGISOC(
     > R8_X,R8_Y,R8_Z,NXDIM,NX,NY,XU,YU,ZU,M)

      external AGISOC

! argument declarations
      INTEGER NXDIM
      INTEGER NX
      INTEGER NY
      CHARACTER*(*) XU
      CHARACTER*(*) YU
      CHARACTER*(*) ZU
 ! floating type, input/output:
      REAL*8 R8_X(NXDIM)
  
 ! floating type, input/output:
      REAL*8 R8_Y(NY)
  
 ! floating type, input/output:
      REAL*8 R8_Z(NXDIM,NY)
  
      INTEGER M(2,NX,NY)

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: Z_act(:,:)
      REAL, allocatable :: Z_ref(:,:)

! allocation of working arrays...

      ALLOCATE(X_act(NXDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOC -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NXDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOC -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOC -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOC -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NXDIM,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOC -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NXDIM,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOC -- Z_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      Z_act=R8_Z
      Z_ref=R8_Z

! call to original routine:  AGISOC

      CALL AGISOC(
     > X_act(1),Y_act(1),Z_act(1,1),NXDIM,NX,NY,XU,YU,ZU,M)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGISOM
      SUBROUTINE R8_AGISOM(
     > R8_X,R8_Y,R8_Z,NXDIM,NX,NY,XU,YU,ZU)

      external AGISOM

! argument declarations
      INTEGER NXDIM
      INTEGER NX
      INTEGER NY
      CHARACTER*(*) XU
      CHARACTER*(*) YU
      CHARACTER*(*) ZU
 ! floating type, input/output:
      REAL*8 R8_X(NXDIM)
  
 ! floating type, input/output:
      REAL*8 R8_Y(NY)
  
 ! floating type, input/output:
      REAL*8 R8_Z(NXDIM,NY)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: Z_act(:,:)
      REAL, allocatable :: Z_ref(:,:)

! allocation of working arrays...

      ALLOCATE(X_act(NXDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOM -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NXDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOM -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOM -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOM -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NXDIM,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOM -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NXDIM,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISOM -- Z_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      Z_act=R8_Z
      Z_ref=R8_Z

! call to original routine:  AGISOM

      CALL AGISOM(
     > X_act(1),Y_act(1),Z_act(1,1),NXDIM,NX,NY,XU,YU,ZU)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGISH
      SUBROUTINE R8_AGISH(
     > R8_X,R8_Y,R8_Z,NXDIM,NX,NY)

      external AGISH

! argument declarations
      INTEGER NXDIM
      INTEGER NX
      INTEGER NY
 ! floating type, input/output:
      REAL*8 R8_X(NXDIM)
  
 ! floating type, input/output:
      REAL*8 R8_Y(NY)
  
 ! floating type, input/output:
      REAL*8 R8_Z(NXDIM,NY)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: Z_act(:,:)
      REAL, allocatable :: Z_ref(:,:)

! allocation of working arrays...

      ALLOCATE(X_act(NXDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISH -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NXDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISH -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISH -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISH -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NXDIM,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISH -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NXDIM,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISH -- Z_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      Z_act=R8_Z
      Z_ref=R8_Z

! call to original routine:  AGISH

      CALL AGISH(
     > X_act(1),Y_act(1),Z_act(1,1),NXDIM,NX,NY)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGISO0
      SUBROUTINE R8_AGISO0(
     > R8_X,R8_Y,R8_Z,NXDIM,NX,NY,XU,YU,ZU)

      external AGISO0

! argument declarations
      INTEGER NXDIM
      INTEGER NX
      INTEGER NY
      CHARACTER*(*) XU
      CHARACTER*(*) YU
      CHARACTER*(*) ZU
 ! floating type, input/output:
      REAL*8 R8_X(NXDIM)
  
 ! floating type, input/output:
      REAL*8 R8_Y(NY)
  
 ! floating type, input/output:
      REAL*8 R8_Z(NXDIM,NY)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: Z_act(:,:)
      REAL, allocatable :: Z_ref(:,:)

! allocation of working arrays...

      ALLOCATE(X_act(NXDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISO0 -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(NXDIM)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISO0 -- X_ref ALLOCATE error!')
      ALLOCATE(Y_act(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISO0 -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISO0 -- Y_ref ALLOCATE error!')
      ALLOCATE(Z_act(NXDIM,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISO0 -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(NXDIM,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGISO0 -- Z_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

      Z_act=R8_Z
      Z_ref=R8_Z

! call to original routine:  AGISO0

      CALL AGISO0(
     > X_act(1),Y_act(1),Z_act(1,1),NXDIM,NX,NY,XU,YU,ZU)

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R8_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R8_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGIGZC
      SUBROUTINE R8_AGIGZC(
     > NC,R8_C,LVLTIC)

      external AGIGZC

! argument declarations
      INTEGER NC
 ! floating type, input/output:
      REAL*8 R8_C(1)
  
      LOGICAL LVLTIC(1)

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: C_act(:)
      REAL, allocatable :: C_ref(:)

! allocation of working arrays...

      ALLOCATE(C_act(1)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGIGZC -- C_act ALLOCATE error!')
      ALLOCATE(C_ref(1)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGIGZC -- C_ref ALLOCATE error!')

! executable code:  copy for input

      C_act=R8_C
      C_ref=R8_C

! call to original routine:  AGIGZC

      CALL AGIGZC(
     > NC,C_act(1),LVLTIC)

! copy back outputs if modified.

      where(C_act.ne.C_ref)
         R8_C = C_act
      end where
      DEALLOCATE(C_act)
      DEALLOCATE(C_ref)

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGICAU
      SUBROUTINE R8_AGICAU(
     > R8_XXCOOR,R8_YYCOOR,R8_ZZCOOR,IXS,IZS)

      external AGICAU

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_XXCOOR
  
 ! floating type, input/output:
      REAL*8 R8_YYCOOR
  
 ! floating type, input/output:
      REAL*8 R8_ZZCOOR
  
      INTEGER IXS
      INTEGER IZS

! local (automatic array) declarations

      integer alloc_stat
      REAL :: XXCOOR_act
      REAL :: XXCOOR_ref
      REAL :: YYCOOR_act
      REAL :: YYCOOR_ref
      REAL :: ZZCOOR_act
      REAL :: ZZCOOR_ref

! allocation of working arrays...


! executable code:  copy for input

      XXCOOR_act=R8_XXCOOR
      XXCOOR_ref=R8_XXCOOR

      YYCOOR_act=R8_YYCOOR
      YYCOOR_ref=R8_YYCOOR

      ZZCOOR_act=R8_ZZCOOR
      ZZCOOR_ref=R8_ZZCOOR

! call to original routine:  AGICAU

      CALL AGICAU(
     > XXCOOR_act,YYCOOR_act,ZZCOOR_act,IXS,IZS)

! copy back outputs if modified.

      if(XXCOOR_act.ne.XXCOOR_ref) then
         R8_XXCOOR = XXCOOR_act
      endif

      if(YYCOOR_act.ne.YYCOOR_ref) then
         R8_YYCOOR = YYCOOR_act
      endif

      if(ZZCOOR_act.ne.ZZCOOR_ref) then
         R8_ZZCOOR = ZZCOOR_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  AGIDZC
      SUBROUTINE R8_AGIDZC(
     > R8_Z,MX,NX,NY,M,I0,J0,R8_CL,NCL)

      external AGIDZC

! argument declarations
      INTEGER MX
      INTEGER NX
      INTEGER NY
      INTEGER I0
      INTEGER J0
      INTEGER NCL
 ! floating type, input/output:
      REAL*8 R8_Z(MX,NY)
  
      INTEGER M(2,NX,NY)
 ! floating type, input/output:
      REAL*8 R8_CL(NCL)
  

! local (automatic array) declarations

      integer alloc_stat
      REAL, allocatable :: Z_act(:,:)
      REAL, allocatable :: Z_ref(:,:)
      REAL, allocatable :: CL_act(:)
      REAL, allocatable :: CL_ref(:)

! allocation of working arrays...

      ALLOCATE(Z_act(MX,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGIDZC -- Z_act ALLOCATE error!')
      ALLOCATE(Z_ref(MX,NY)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGIDZC -- Z_ref ALLOCATE error!')
      ALLOCATE(CL_act(NCL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGIDZC -- CL_act ALLOCATE error!')
      ALLOCATE(CL_ref(NCL)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R8_AGIDZC -- CL_ref ALLOCATE error!')

! executable code:  copy for input

      Z_act=R8_Z
      Z_ref=R8_Z

      CL_act=R8_CL
      CL_ref=R8_CL

! call to original routine:  AGIDZC

      CALL AGIDZC(
     > Z_act(1,1),MX,NX,NY,M,I0,J0,CL_act(1),NCL)

! copy back outputs if modified.

      where(Z_act.ne.Z_ref)
         R8_Z = Z_act
      end where
      DEALLOCATE(Z_act)
      DEALLOCATE(Z_ref)

      where(CL_act.ne.CL_ref)
         R8_CL = CL_act
      end where
      DEALLOCATE(CL_act)
      DEALLOCATE(CL_ref)

! exit
      return
      end

subroutine r8_trirad(p1,p2,p3,p0,rad,ier)
  !
  !  given 3 verticies of a triangle (in a plane), return the center point
  !  and radius of a circle which passes through these points.
  !
  !  if the points are colinear, return ier=1 -- no circle with finite
  !  radius exists
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit none
  !
  real(fp), dimension(2), intent(in) :: p1,p2,p3    ! the verticies
  real(fp), dimension(2), intent(out) :: p0         ! center of the circle
  real(fp), intent(out) :: rad                      ! radius of circle
  !
  integer, intent(out) :: ier    ! completion code: 0=OK, 1=no circle exists
  !
  !-----------------------------------------------------
  !
  real(fp) :: delx21,delx31,dely21,dely31,avx21,avx31,avy21,avy31
  real(fp) :: pcross
  !
  !-----------------------------------------------------
  !
  p0 = zero
  rad = zero
  !
  delx21 = p2(1) - p1(1)
  delx31 = p3(1) - p1(1)
  dely21 = p2(2) - p1(2)
  dely31 = p3(2) - p1(2)
  !
  pcross=(delx21*dely31-dely21*delx31)
  if(pcross.eq.zero) then
    ier=1      ! colinear points
    return
  else
    ier=0
  endif
  !
  avx21 = (p2(1)+p1(1))/2
  avx31 = (p3(1)+p1(1))/2
  avy21 = (p2(2)+p1(2))/2
  avy31 = (p3(2)+p1(2))/2
  !
  p0(1) = (delx21*dely31*avx21 + dely21*dely31*avy21 &
          -delx31*dely21*avx31 - dely31*dely21*avy31)/pcross
  !
  p0(2) =-(delx21*delx31*avx21 + dely21*delx31*avy21 &
          -delx31*delx21*avx31 - dely31*delx21*avy31)/pcross
  !
  rad = sqrt((p1(1)-p0(1))**2+(p1(2)-p0(2))**2)
  !
  !debug  write(6,*) 'p0= ',p0
  !debug  write(6,*) 'rad=',rad
  !debug  write(6,*) 'rad=',sqrt((p2(1)-p0(1))**2+(p2(2)-p0(2))**2)
  !debug  write(6,*) 'rad=',sqrt((p3(1)-p0(1))**2+(p3(2)-p0(2))**2)
  !
  return
end subroutine r8_trirad

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_delete_node(node)
      implicit none
      character*(*) node
      mds_delete_node = 0
      return
      end
#else
c-----------------------------------------------------------------------
c mds_delete_node
c
c input
c   node       -- character
c returns
c   1          -- on success
c   odd number -- on error
c
c-----------------------------------------------------------------------
      integer function mds_delete_node(node)
      implicit none
      character*(*) node
 
      integer       stat
 
      integer   mds__long, mds__cstring
 
      integer   IDTYPE_CSTRING
      parameter(IDTYPE_CSTRING=14)
 
      integer  descr, mdsvalue
      integer  nid,   cmd_sts
      integer  ndsc, cdsc, nl, retl
      character*4097 strarg

      volatile nid, cmd_sts

! Check if node exists 
 
      nid=0
      ndsc = descr(mds__long(), nid, 0)
      nl=len_trim(node)
      cdsc=descr(IDTYPE_CSTRING,node,0,nl)
      stat = MdsValue("getnci($,'NID_NUMBER')",cdsc,ndsc,0,retl)
! node exists: delete 
      if (mod(stat,2) .eq. 1) then
         ndsc = descr(mds__long(), cmd_sts, 0)
         strarg = 'tcl("delete node ' // node(1:nl) //
     >           '/NOCONFIRM")' //CHAR(0)
         stat = MdsValue(strarg, ndsc, 0, retl)         
         if (mod(stat,2) .ne. 1) then
            mds_delete_node = -1
            print*,'?mds_delete_node -E- MdsValue staus= ',stat
            print*,'     command=',strarg(1:len_trim(strarg)-1)
            return
         else
! Check status of tcl delete
            if (mod(cmd_sts,2) .eq. 1) then
               mds_delete_node = 1
            else
               mds_delete_node = cmd_sts
               print*,'?mds_delete_node -E- failed to delete'//
     &             node(1:nl) // ' status = ',stat
            endif
         endif         
      else 
! node doesn't exist
         mds_delete_node = 1
      endif
      return
      end
 
#endif

C******************** START FILE LXOUT.FOR ; GROUP URDUTS ******************
C
C------------------
C&  LXOUT  -- UREAD LOGICAL FUNCTION .TRUE. FOR INFORMATIONAL OUTPUT
C            I.E. FETCH OUT OF COMMON
      LOGICAL FUNCTION LXOUT(IDUM)
C
      USE USERIO
C
      LXOUT=NLXOUT
      RETURN
      END
C******************** END FILE LXOUT.FOR ; GROUP URDUTS ******************

C******************** START FILE UFCMPR.FOR ; GROUP UFILES ******************
C--------------------------------------------------------------
C  UFCMPR
C
C  SET FLAG TO WRITE DATA IN COMPRESSED (NON-TRANSPORTABLE)
C  FORM ON SPECIFIED CHANNEL
C
C  EFFECTIVE ONLY IF THE CHANNEL IS USED TO WRITE DATA
C
      SUBROUTINE UFCMPR(ILUN,ICMPR)
C
      USE UFILES
C
C  ARGUMENTS-- ILUN - UFILES ASSIGNED UNIT NUMBER
C   ICMPR-- WRITE CODE
C    0 FOR STANDARD (UNCOMPRESSED FORMATTED ASCII)
C    1 FOR COMPRESSED (BINARY 16 BIT INTEGERIZED COMPRESSED)
C    2 FOR PORTABLE LOSS FREE COMPRESSED BINARY UFILE FORMAT
C    3 for HDF format
C    4 for NetCDF format
C
C
C  ** CALLING SEQUENCE **
C   UFCMPR MUST BE CALLED AFTER UFSETR, BEFORE UFOPWR
C
C    UFSETR AND UFCLOS ROUTINES CLEAR THE COMPRESSION FLAG--
C  SO THIS ROUTINE MUST BE CALLED PRIOR TO EACH UFOPWR CALL FOR
C  WHICH COMPRESSED DATA WRITE IS EXPECTED TO FOLLOW-- NOT JUST ONCE
C  FOR A UFSETR CHANNEL.
C
C  CHECK CALLING SEQUENCE
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UFCMPR    ',ICHAN,IER)
      IF(IER.NE.0) RETURN
      IF(UFSTAT(ICHAN).NE.0) THEN
        WRITE(UFELUN,9001)
 9001 FORMAT(
     >' ? UFCMPR - SET COMPRESSION FLAG *PRIOR* TO UFOPWR CALL')
        CALL UERSTA(ICHAN,'UFCMPR    ')
        RETURN
      ENDIF
C
C  SET FLAG
C
      if (UFCPRS(ICHAN) .eq. -1) then
         write(ufelun,'('' %UFCMPR -- can not reset MDSplus  '')')
         ier=0
         return
      endif
      IF(ICMPR .ge. 0 .and. ICMPR .le. 4) then
         ier=0
         UFCPRS(ICHAN) = ICMPR
      else
         write(ufelun,'('' %UFCMPR -- invalid argument:  '',i4)')
     1	icmpr
         ier=1
      ENDIF
C
      if(ier.eq.1) call uersta(ichan,'UFCMPR    ')
C
      RETURN
      END
C******************** END FILE UFCMPR.FOR ; GROUP UFILES ******************

c-------------------------------------------------------------------/str_length
c	This routine determines the length of the string, excluding
c	trailing blanks.  (Dick Wieland)
C
C  DMC OCT 1991 -- PIRATED FROM DICK'S STRUTIL.FOR AND PLACED IN
C  THE TRANSP CMSMMS LIBRARY VAXONLY -- TO RESOLVE THE REFERENCES
C  FROM UFLIB ON THE DECSTATION WITHOUT HAVING TO PULL IN ALL OF
C  STRUTIL
 
      integer function str_length(mainstr)
 
      character*(*)	mainstr
      integer		mlen
      integer		null
      integer		blank
 
      data null/0/
      data blank/32/
 
c-      fortran 90 can zero length strings
      if (len(mainstr)==0) then
         str_length=0
         return
      end if
c-	if the first character is NUL, assume an empty string;
      if ( ichar(mainstr(1:1)) .eq. 0 )   then
         str_length = 0
         return
      end if
 
c-	start the leftward moving test for blanks or NULs
      mlen = len(mainstr)
      do while ((mlen.gt.1).and.(ichar(mainstr(mlen:mlen)).eq.blank
     >		       .or. ichar(mainstr(mlen:mlen)).eq.null))
      	mlen = mlen - 1
      end do
 
c-	MLEN=1 a special case:
      if ( mlen .eq. 1 .and. (ichar(mainstr(1:1)) .eq. blank .or.
     >		       ichar(mainstr(mlen:mlen)).eq.null)) mlen = 0
 
      str_length = mlen
 
      return
      end

!------------------------------------------------------------------------------
!
!  DOSIG2_Z -- EVALUATE A CROSS SECTION FROM ALADDIN DATA -- SUM OF 2
!
real(fp) FUNCTION DOSIG2_Z(ZEREL,INDXR,ZLBL1,ZLBL2)
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod   
  use alpcom_mod
  use alcom_mod
  IMPLICIT NONE
  INTEGER isigind_z,ix,ier
!============
! idecl:  explicitize implicit REAL declarations:
 real(fp) zerel,zsum,zsigma,dosigx_z
!============
 INTEGER INDXR(2)
 CHARACTER*(*) ZLBL1
 CHARACTER*(*) ZLBL2
!
!  INPUT ZEREL = REL. ENERGY AT WHICH TO EVALUATE CROSS SECTION
!        INDXR = REACTION INDICES (IF ALREADY KNOWN) OR ZERO
!        ZLBL1,ZLBL2 = REACTION LABELS (USED IF INDEX NOT KNOWN)
!
!  OUTPUT INDXR = NONZERO REACTION INDICES (IF INDXR=0 ON INPUT)
!         DOSIG2 = CROSS SECTION (INTERPOLATED OR EXTRAPOLATED FROM
!                 ALADDIN DATA)
!
!------------------------------------------------------------------------------
!
 IF(INDXR(1).EQ.0) THEN
    INDXR(1)=ISIGIND_Z(ZLBL1)
    INDXR(2)=ISIGIND_Z(ZLBL2)
 ENDIF
!
 ZSUM = 0.0_fp
!
 DO IX=1,2
    IF((ALEMIN(INDXR(IX)).LE.ZEREL).AND.&
         (ZEREL.LE.ALEMAX(INDXR(IX)))) THEN
!
!  IN RANGE -- USE FIT
       NCF=NALPCF(INDXR(IX))
       CF(1:ncf)=ALPCF(1:ncf,INDXR(IX))
       CALL ALAD_EVAL_Z(ZEREL,ZSIGMA,1,IER)
    ELSE
!
!  OUT OF RANGE -- USE EXTRAPOLATION
       ZSIGMA=DOSIGX_Z(ZEREL,INDXR(IX))
    ENDIF
!
    ZSUM=ZSUM+ZSIGMA
 enddo
 DOSIG2_Z=ZSUM
!
 RETURN
END FUNCTION DOSIG2_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C******************** START FILE UFSND0.FOR ; GROUP UFILES ******************
C-------------------------------------------------------------
C  UFSND0 - DISPLAY UFILES FILENAME WITH LABEL OR MESSAGE
C
      SUBROUTINE UFSND0(LUNO,ZLABL,ZFILE)
      CHARACTER*(*) ZLABL
      CHARACTER*(*) ZFILE
C
      ILENF=IUFTRM(ZFILE,'UFSND0 FILENAME',IER)
      ILENL=LEN(ZLABL)
      IF((ILENF+ILENL).LE.64) THEN
        WRITE(LUNO,1001) ZLABL(1:ILENL),ZFILE(1:ILENF)
      ELSE IF(ILENF.LE.71) THEN
        WRITE(LUNO,1002) ZLABL(1:ILENL),ZFILE(1:ILENF)
      ELSE
        WRITE(LUNO,1001) ZLABL(1:ILENL),ZFILE(1:ILENF)
      ENDIF
 1001 FORMAT(1X,A,':  ',A)
 1002 FORMAT(1X,A,':'/1X,A)
 1003 FORMAT(1X,A,':'/1X,A/1X,A)
      RETURN
      END
C******************** END FILE UFSND0.FOR ; GROUP UFILES ******************

C------------------------------------------------------------------------------
c  dmc 14 Apr 1997 -- identify portion of input line that specifies a filename
c     and so should be protected from uppercase conversion
c
      subroutine urdfcap(zbuff,lcap,inbuf)
c
      character*1 zbuff(inbuf)  ! characters (input)
      logical lcap(inbuf)       ! cap flags (output)
c
      character*1 zblank
      character*1 ztab
      character*1 zquot
c
      logical iunix
c--------------------------------
c  goal is to limit the automatic capitalization in ulosup.for
c    ...to protect unix case sensitive filenames
c  input: xyz @foon/zork.ifi @foon/zork2.ifi/input=7
c   want: XYZ @foon/zork.ifi @foon/zork2.ifi/INPUT=7
c
      zblank=' '
      ztab=char(9)
      zquot='"'
c
      do i=1,inbuf
         lcap(i)=.true.
      enddo
c
      iunix=.true.              !unix
c
      iquot=0
      iblpre=1
      istart=1
c
 10   continue
c
      do i=istart,inbuf-1
         if(zbuff(i).eq.zquot) then
            iquot=1-iquot
         else if(iquot.eq.0) then
            if((zbuff(i).eq.'@').or.(zbuff(i).eq.'>')) then
               if((iquot.eq.0).and.(iblpre.eq.1)) then
                  ifiln=i+1
                  go to 20
               endif
            endif
            if((zbuff(i).ne.zblank).and.(zbuff(i).ne.ztab).and.
     >           (zbuff(i).ne.',')) then
               iblpre=0
            else
               iblpre=1
            endif
         endif
      enddo
c
c  no more filenames:  done
c
      return
c
c  filename detected (syntax)
c  if not quoted, protect from case conversion
c  if quoted, only the quoted string following is taken as the filename
c
c    @/u/mccune/foo.ifi/input=7  --> /u/mccune/foo.ifi is filename,
c    @"/u/mccune/foo.ifi"/zork/grom --> same filename, zork & grom are
c       arguments.
c
c    filenames to be protected against case conversion
c
 20   continue
c
      if(zbuff(ifiln).ne.zquot) go to 24
      lcap(ifiln)=.false.
      do ic=ifiln+1,inbuf
         lcap(ic)=.false.
         if(zbuff(ic).eq.zquot) then
            iscan=ic+1
            go to 110
         endif
      enddo
      iscan=inbuf+1
      go to 110
c
 24   continue
      islash=0
      iscan=ifiln-1
 25   continue
      iscan=iscan+1
      if(iscan.gt.inbuf) go to 100   ! terminate with end of buffer
      if(zbuff(iscan).eq.zblank) go to 100   ! or blank
      if(zbuff(iscan).eq.ztab) go to 100     ! or tab
      if(zbuff(iscan).eq.',') go to 100      ! or comma
      if((.not.iunix).and.(zbuff(iscan).eq.'/')) go to 100
      if(iunix.and.(iscan.lt.inbuf)) then
         if((zbuff(iscan).eq.'/').and.(zbuff(iscan+1).eq.'$')) then
            go to 100           ! /$ and unix
         endif
      endif
c
      if(zbuff(iscan).eq.zquot) go to 300    ! skip stuff btw dbl quotes
c
      if(islash.gt.0) then
         if(zbuff(iscan).eq.'=') then
            iscan=islash
            go to 100                    ! /name=val syntax detected
         endif
      endif
c
      if(zbuff(iscan).eq.'/') islash=iscan
      go to 25
c
c  end of filename detected
c
 100  continue
      do i=ifiln,iscan-1
         lcap(i)=.false.    ! protect filename against capitalization
      enddo
c
 110  continue
      istart=iscan          ! look for more filenames
      iblpre=0
      go to 10
c--------------------------------------------------------
c  skip ahead to next quot & resume scan loop
 300  continue
      do i=iscan+1,inbuf
         if(zbuff(i).eq.zquot) go to 310
      enddo
      i=inbuf
 310  continue
      iscan=i
      go to 25
c
      end

!******************** START FILE FPOLAR.FOR ; GROUP TKBNDRY ******************
!.....................................................................
!  REV DMC -- REMOVED TRANSP COMMON
!   SO I CAN USE THIS IN RPLOT
!
!  REV BB / MAY 94 -- USE ATAN2 INSTEAD OF ATAN TO EVALUATE FPOLAR
!
!   output in range [0,twopi] instead of range [-pi,pi]
!   atan2 and fpolar are the same in the upper half plane; fpolar
!   is twopi greater in the lower half plane.
!
real(fp) function r8_fpolar ( ZR77, ZZ77 )
  !
  !	CALC. THE POLAR ANGLE DEFINED BY TAN(THETA)=ZZ77/ZR77
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, pi, twopi 
  implicit none
  real(fp) :: zz77, zr77
  !
  !--------------------------------------------
  !
  if (zz77 .ge. zero) then
    !
    !  upper half plane  --  including z=0 line
    !
    if (ZR77 .NE. zero) THEN
      !
      r8_fpolar = ATAN2 ( ZZ77 , ZR77 )
      !
    else
      !
      !  on the vertical axis, at or above the z=0 line
      !
      r8_fpolar = PI*half
      !
    end if
    !
  else
    !
    !  lower half plane  --  excluding z=0 line
    !
    r8_fpolar = ATAN2 ( ZZ77 , ZR77 ) + TWOPI
    !
  end if
  !
  return
end function r8_fpolar

      subroutine mkquin2(sub,x,nx,th,nth,fquin)
C
C  create a data set for interpolation, from evaluation of function and
C  derivatives & 2nd derivatives
C
      external sub                      ! passed subroutine (x,th,output)
      real x(nx)                        ! x coordinate array
      real th(nth)                      ! th coordinate array
C
      real fquin(0:5,nx,nth)            ! function data / spline coeff array
C
C
C  sub's interface:  subroutine sub(xi,th,ra(6))
C    ra(1) -- value of fcn f
C    ra(2) -- df/dx
C    ra(3) -- df/dth
C    ra(4) -- d2f/dx2
C    ra(5) -- d2f/dth2
C    ra(6) -- d2f/dx.dth
C
C----------------------------
C
      do ix=1,nx
         do ith=1,nth
            call sub(x(ix),th(ith),fquin(0,ix,ith))
         enddo
      enddo
C
      return
      end

      subroutine fgetline(prompt,answer,lenans)
c
c  send prompt, get answer.
c  use C routine (with command line editing) if this is available
c  otherwise revert to fortran i/o
c
      implicit NONE
c
      character*(*) prompt              ! prompt to send (blank for none)
      character*(*) answer              ! answer returned
      integer lenans                    ! non-blank length of answer
c
c  return lenans=-1 on EOF
c
c--------------------------------------------
c
      integer :: status = 0
c
c  0 -- availability of C routine unknown
c  1 -- C routine available
c  2 -- revert to fortran i/o
c
      integer :: ichars
c
c
c--------------------------------------------
c
#include "fpreproc/byte_declare.h"
c
      byte_declare :: bzero
      byte_declare, allocatable :: bprompt(:)
      byte_declare, allocatable :: banswer(:)
c
c--------------------------------------------
c
      answer=' '
      lenans=0
#if __CRAY || __SX
	bzero = char(0)
#else
	bzero = 0
#endif
c
      if(status.ne.2) then
c
         allocate(banswer(len(answer)+1))
c
         if(prompt.ne.' ') then
            allocate(bprompt(len(prompt)+1))
            call cstring(prompt,bprompt,'2C')
            call getline(bprompt,banswer,ichars)
            deallocate(bprompt)
         else
            call getline(bzero,banswer,ichars)
         endif
c
         if(ichars.eq.-99) then
            if(status.eq.0) write(6,*)
     >         '[fgetline:  no command line editing available]'
            status = 2                  ! dummy C routine
         else
            status = 1
            if(ichars.eq.-1) then
               lenans=-1                ! end of file
            else
c  normal result:  a line is read.
               call cstring(answer,banswer,'2F')
               lenans = len_trim(answer)
            endif
         endif
c
         deallocate(banswer)
         if(status.ne.2) return
      endif
c
c------------------------
c  fallthru:  fortran i/o
c
      if(prompt.ne.' ') then
         ichars=len_trim(prompt)
         write(6,*) prompt(1:ichars)
      endif
      read(5,'(A)',end=99) answer
      lenans = len_trim(answer)
      return
c
 99   continue
      lenans=-1
      return
c
      end

C******************** START FILE FILFAS.FOR ; GROUP FILFAS ******************
C---------------------------------------------------------------
C  FILFAS   D. Mc Cune  pppl 4 dec 1981
C  A FAST MOVING TRIANGULAR WEIGHTED AVERAGE SMOOTHING ROUTINE
C
        SUBROUTINE FILFAS(F,FSM,N,NWA)
C
        DIMENSION F(N),FSM(N)
C
C  INPUT:
C   F(N) DATA TO BE SMOOTHED
C   NWA-- NUMBER OF POINTS ON EITHER SIDE OF F(J) TO AVERAGE
C         WITH TRIANGULAR WEIGHTING TO COMPUTE FSM(J)
C
C  OUTPUT:
C   FSM(N): SMOOTHED DATA
C
C
C  ALGORITHM:
C  FSM(J) IS A WEIGHTED AVERAGE OF F(J-NWA),F(J-NWA+1),...,
C                                  F(J),...,F(J+NWA-1),F(J+NWA)
C  THE WEIGHTING FACTOR FOR
C  F(J+K) IS W(K)=(NWA+1-IABS(K))/(NWA+1)**2
C   NOTE THAT SUM[K= -NWA TO +NWA]W(K) = 1.0 EXACTLY
C
C  W(K) IS A STEP FUNCTION APPROXIMATION TO A TRIANGULAR WEIGHTING
C  FUNCTION
C
C  END CONDITIONS:  IF THE INDEX (J+K) IS .LT. 1 IT IS
C   REPLACED BY 1; IF (J+K) .GT. N IT IS REPLACED BY N.
C  THUS THE END POINTS ARE MORE HEAVILY WEIGHTED IN THE REGIONS NEAR THE
C  ENDPOINTS OF THE DATA BEING SMOOTHED
C
C  EXECUTABLE CODE
C
        IF(NWA.LE.0) GO TO 200
        INWA=NWA+1
        FAC=1.0/(INWA**2)
C  START LOOP OVER DATA POINTS
        DO 100 J=1,N
C  INITIATE SUM FOR POINT J
        SUM=F(J)*INWA
C  LOOP OVER POINTS TO AVERAGE
        DO 90 K=1,NWA
        IW=INWA-K
        IPT1=MAX0(1,(J-K))
        IPT2=MIN0(N,(J+K))
        SUM=SUM+IW*(F(IPT1)+F(IPT2))
 90     CONTINUE
        FSM(J)=SUM*FAC
 100    CONTINUE
        RETURN
C  NWA < 0: JUST COPY DATA
 200    CONTINUE
        DO 210 J=1,N
        FSM(J)=F(J)
 210    CONTINUE
        RETURN
        END
C******************** END FILE FILFAS.FOR ; GROUP FILFAS ******************

C******************** START FILE GSCSEP.FOR ; GROUP GSCSEP *************
C---------------------------------------------------------------
C  GSCSEP
C
C  MAKE SURE THAT TWO NUMBERS ZMIN AND ZMAX, (PRESUMED TO BE
C  THE HORIZ. OR VERTICAL REAL SCALE ON AN UPCOMING GRAPH) ARE
C  IN PROPER ORDER AND NOT EQUAL
C
      SUBROUTINE GSCSEP(ZMIN,ZMAX)
C
C  MOD DMC 17 JUNE 1991 -- "EQUAL" REDEFINED IN TERMS OF SMALL NUMBERS
C  ON OUR MACHINES
C
      REAL ZEPS
      DATA ZEPS/1.0E-30/
C
C----------------------------------------------------------------
C
      ZZMIN=ZMIN
      ZZMAX=ZMAX
C
      ZMIN=AMIN1(ZZMIN,ZZMAX)
      ZMAX=AMAX1(ZZMIN,ZZMAX)
C
C
C  EQUALITY DISALLOWED
C
      IF((ZMAX-ZMIN).LT.ZEPS) THEN
        ZAVG=0.5*(ZMAX+ZMIN)
        ZSS=SIGN(1.0,ZMAX)*SIGN(1.0,ZMIN)
        IF((ZMIN.EQ.0.0).OR.(ZMAX.EQ.0.0)) ZSS=0.0
        IF(ZSS.LE.0.0) THEN
          ZMIN=-0.1
          ZMAX=0.1
        ELSE IF(ZMAX.LT.0.0) THEN
          ZMIN=AMIN1(1.01*ZMIN,(ZAVG-0.5*ZEPS))
          ZMAX=AMAX1(0.99*ZMAX,(ZAVG+0.5*ZEPS))
        ELSE IF(ZMIN.GT.0.0) THEN
          ZMIN=AMIN1(0.99*ZMIN,(ZAVG-0.5*ZEPS))
          ZMAX=AMAX1(1.01*ZMAX,(ZAVG+0.5*ZEPS))
        ENDIF
      ENDIF
C
      RETURN
      END
C******************** END FILE GSCSEP.FOR ; GROUP GSCSEP ***************

C******************** START FILE URDCHR.FOR ; GROUP USINIT ******************
C--------------------------------------------------
C& URDCHR  DEFINED DEFAULT SET OF UREAD CONTROL CHARACTERS
C
      SUBROUTINE URDCH0
C
      USE USERIO
C
C  INITIALIZE DEFAULT SET OF UREAD SPECIAL CHARACTERS
      CALL URDCMC(';')  ! SET SEMICOLON AS COMMENT CHARACTER
C                         ! MSEMI AND MCOMMT SET IN URDCMC
      MDOLLR='$'
      MSLASH='/'
      MDOT='.'
      MEQS='='
      MCAROT='>'
      MIDAT='@'
      MSTAR='*'
C
      MQMARK='?'
      MCOLON=':'
      M1QUOT=''''
      M2QUOT='"'
      MLBRAK='{'
      MRBRAK='}'
C
      MFILI=MIDAT
      MFILO=MCAROT
      MBRNCH=MQMARK
      MTARGT=MCOLON
      MSUB1=M1QUOT
      MSUB2(1)=MLBRAK
      MSUB2(2)=MRBRAK
C
C  MPARAM AND MCMD SET IN URDCHR OR URDTCH ROUTINES ...
C
      RETURN
      END
C******************** END FILE URDCHR.FOR ; GROUP USINIT ******************

!******************* START FILE GAUS6_Z.FOR ; GROUP GAUS6 *********************
!
SUBROUTINE GAUS6_Z(A,B,FUN,TEST2,EPS,MAX,J,IPUNIT)
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER j,ipunit,k,i,max
!============
! idecl:  explicitize implicit REAL declarations:
 real(fp) b,test2,eps,a,e00,xlow,test1,sum,xhigh,c1,c0,z,fun,re
 real(fp),DIMENSION(3) :: X,W
!============
 EXTERNAL FUN
!
!	5/10/76
!	THIS PROGRAM WAS WRITTEN BY HARRY H. TOWNER OF THE NUCLEAR
!	ENGINEERING DEPT. UNIVERSITY OF ILLINOIS.  THIS PROGRAM WILL
!	INTEGRATE THE FUNCTION -FUN- BETWEEN THE LIMITS A AND B BY
!	USING 6-POINT GAUSS-LEGENDRE QUADRATURE.
!	PARAMETERS.
!	A=LOWER LIMIT OF INTEGRATION.
!	B=UPPER LIMIT OF INTEGRATION.
!	FUN=FUNCTION TO BE INTEGRATED.
!	TEST2=VALUE OF INTEGRAL.
!	EPS=RELATIVE ERROR OF INTEGRAL.
!	MAX=MAXIMUM NUMBER OF ITERATIONS.
!	J=NUMBER OF ITERATIONS TAKEN.
!	IPUNIT=LOGICAL UNIT USED FOR PRINTING.
!	NOTE THAT FUN IS PASSED BY MEANS OF AN EXTERNAL STATEMENT IN THE
!	CALLING PROGRAM
!	ARRAY X CONTAINS THE ROOTS OF THE LEGENDRE POLYNOMIAL.
!	ARRAY W CONTAINS THE WEIGHT FACTORS.
 DATA X/.238619186083197_fp,.661209386466265_fp,&
      .932469514203152_fp/
 DATA W/.467913934572691_fp,.360761573048139_fp,&
      .171324492379170_fp/
!
!  DMC Jan 2009: limit the warnings...
 integer, save :: iwarn = 0
!
 integer, parameter :: iwarn_max = 10
!------------------------------------------------------------------------------
!
 J=1
!	J TELLS HOW MENY TIMES TO APPLY QUADRATURE TO INTERVAL.
 TEST2=0._fp
200 XLOW=A
 TEST1=TEST2
 SUM=0.0_fp
 DO K=1,J
    XHIGH=XLOW+(B-A)/J
    C1=(XHIGH-XLOW)*.5_fp
    C0=C1+XLOW
    DO I=1,3
       Z=C1*X(I)
       SUM=SUM+C1*W(I)*(FUN(Z+C0)+FUN(-Z+C0))
    enddo
    XLOW=XHIGH
 enddo
 TEST2=SUM
 IF(TEST2.EQ.0._fp) RETURN
 RE=ABS((TEST2-TEST1)/TEST2)
 IF(RE.LE.EPS) return
 J=J*2
 IF(J.LE.MAX) GO TO 200
 J=J/2
 
 if((iwarn.lt.iwarn_max).or.(RE.gt.0.1_fp)) then
    WRITE(IPUNIT,20) J,RE
20  FORMAT(1X,'AFTER',I4,' ITERATIONS INTEGRAL HAS NOT CONVERGED',&
         ' RE=',1PE12.5,' GAUS6_Z')
    iwarn = iwarn + 1
    if(iwarn.eq.iwarn_max) then
       write(ipunit,*) &
            ' [gaus6_z: suppressed further warnings w/ RE < 0.1]'
       write(ipunit,*) ' [gaus6_z: as can generally be ignored.]'
    endif
 endif

 RETURN
END SUBROUTINE GAUS6_Z
!
!******************** END FILE GAUS6.FOR ; GROUP GAUS6 ************************
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

c  sgtcs.for	sg terminal control routines (vax)
c
C  Dec-95       Ed Lazarus changes for labeling and post-script
C               enhancements. Put in repository by T.B. Terpstra
c
c  mar-82	change initt and finitt to service terminal types.
c		add termck to obtain the terminal type.
c		move iowait,tinput,toutpt to agiod.mar
c
c  aug-83	revise xycnvt, movea, drawa, pointa, dasha, agcsca and
c		 ivclip to do all clipping in screen units.
c
c  nov-84	update wincot to avoid integer overflow. [hht]
c
c  feb-85	change finitt to put mac terminal into alpha mode.  [hht]
c
c  jun-85	reorder subroutines; replace termck with ag_inio.  [met]
c
c  nov-86	add calls to aggsend and tclos_disk to finitt.
c		change initt not to call newpag if ibaud=0.
c		change finitt not to call movabs if args = 0,0.
c		add agsalf and agsgrf routines.  [met]
c
c  oct-87	update vecmod,dshmod,movabs,drwabs for 4105.
c		restore pntmod routine (for marker lines).
c		add tminit,linclr,cmdout,intout,intray from new plot-10.
c		add agmark,agtxrot,agtxclr,agpnclr.
c		translate terminal_4105 in initt and call tminit if yes.
c		handle 4105 screen switch; do all switches by calling by
c		 agsalf and agsgrf.
c		do 4105 text output in anstr; toutst,toutpt still 4014 only.
c		add agseet to access k4105,kfactr,kmaxsc. [met]
c
c  jul-88	call erase before reset in initt (no extra blank page on
c		 QMS printer); more initialization in reset.
c		change screen switch for (Versaterm) mac 4105 -> VT100.
c		add support for graph-on (terminal_type GO).
c		add iaghres,iaglres. [met]
c
c  nov-88	move check for log of zero/negative to wincot (from rescal).
c		convert source to lower case.
c		test bytes rather than bits in ivclip (faster).
c		fix length of comstr in agsgrf for 4025.
c		non-mac 4105 -> VT100 switch supports Intecolor.
c		replace recovx with alfmod in scursr.
c		purge typeahead (agtpurg) on first call to scursr after initt.
c		mac VT100 -> 4014 switch overrides 4105 in VTPRO. [met]
c
c  sep-89	on log of zero/neg, set to data min instead of 0 (log(1)).
c		always purge typeahead on entry to scursr.
c		enable broadcast trapping in agsgrf, disable in agsalf and
c		 type out any buffered messages. [met]
c
c  jan-90	put ksizef in common so returned ok in agseet.
c		tminit just set flag; initt do all initialization.
c		in 4105 mode, init text precision, line width.
c		add kscrn to common to avoid screen switch when already there.
c		flush tty buffer in agsgrf so user sees switch immediately.
c		save ksres in common so only do translate once.
c		move reset into initt; for 4014, call alfmod first (US),
c		 then erase, then chrsiz.
c		add XTERM, VS3100 terminal types. [met]
c
c  jan-91	add klcolr,ktcolr to common; always reset colors in initt.
c		init bypass cancel, error threshold, panel color in INIT.
c		redefine kterm: 2=sw dashes/pts, 3=hw; hw points in 4105.
c		remove kin,kcm (factors wrong in any case).
c		add MODGRF, DW4125 terminal types; remove ADM3M.
c		add agsmodl (see model). [met]
c
c  aug-91	add TK4107 terminal type; convert some subs to entries.
c		remove vwindo, recovx. [met]
c
c  feb-92	change size of csize 3/4 to fit new Versaterm.
c		only translate terminal_4105 if tminit not called.
c		revise agidds per MAC version; move into dshmod.
c		only set kkmode=4 for hardware dash, not software dash.
c		convert byte variables to integer; more subs to entries.
c		convert ainst from byte to character string.
c		add kmovef=-1 so move, then draw to same location = point.
c		comment out reset. [met]
c  sep-93	go to alfmod from vecmod before going to pntmod (some
c		  emulators think vecmod->pntmod is special point plot). [met]
c  aug-97	replace "abs(xi)" in wincot to speed execution.
c		revert to bit test in ivclip (faster on RISC).  [met]
c
C  jul-98       Ed Lazarus changes (from Dec. 1995) for labeling and post-script
C               enhancements. Put in repository by T.B. Terpstra
c               These changes are for use in Unix for TEK2PS stream file printing.
c               If the changes are not there, there is a font error after the first 
c               of printing.
c
c----------------------------------------------------------------/sgtcsblk
	block data sgtcsblk
	include 'sgtcs_inc'
	data k4105 /-1/
	data kfactr /4/	!in case initt not linked
	end
c----------------------------------------------------------------/initt
c * initialization routine
c
	subroutine initt(ibaud)
	implicit none

	include 'sgcopr_inc'
	include 'sgtcs_inc'
	character scres*4
	integer   icolmp(32)
	integer   istat
	integer   isgood
	integer   ibaud, lsres, ios, ii
	external  sgtcsblk

	data icolmp /		!color map (?tek version has triplets)
     >	 0,000,00,000, 1,00,100,000,	!black, white
     >	 2,120,50,100, 3,240,50,100,	!red, green
     >	 4,000,50,100, 5,300,50,100,	!blue, cyan
     >	 6,060,50,100, 7,180,50,100/	!magenta, yellow

c
c * kkmode  0=alfmod (text), 1=vecmod (move,draw), 2=pntmod, 4=dshmod
c * kmovef  1=need a move (after text), 0=just did a move, -1=did a draw
c * kterm   <3=software dash lines/points, 3=hardware dashes/points
c
	kterm=2			!software dash lines
	kfactr=4		!=4 for 1024 screen size; =1 for 4096
c * set screen resolution if terminal_res is defined
	call usr_trnlog(' ','TERMINAL_RES',scres,lsres,isgood)
	if (isgood .eq. 1) then
	   if (lsres .eq. 4) then
	      read(scres(1:lsres),'(bn,i4)',iostat=ios) ksres
	   else if (lsres .eq. 3) then
	      read(scres(1:lsres),'(bn,i3)',iostat=ios) ksres
	   else
	      read(scres(1:lsres),'(bn,i5)',iostat=ios) ksres
	   end if
	   if(ksres.eq.4096) then
	      kfactr=1
	   endif
	endif
	kmxscr=4095/kfactr
c * set hardware dash line if terminal_dash is defined
	call usr_trnlog(' ','TERMINAL_DASH',scres,lsres,isgood)
	if (isgood .eq. 1) then
	   if(scres(1:lsres).eq.'YES') kterm=3
	endif
c * set 4105 mode if terminal_4105 is defined
	if(k4105.lt.0) then
	  call usr_trnlog(' ','TERMINAL_4105',scres,lsres,isgood)
	  k4105=0
	  if (isgood .eq. 1) then
	     if(scres(1:lsres).eq.'YES') k4105=1
	  endif
	endif
c * open output device(s)
	call ag_inio(' ',istat)	!get device type, etc.
	if(istat .eq. 0) call good_exit 
cx	call tmark_disk(0)	!back up over header
	call agsgrf		!switch to graph screen, output us (alfmod)
c
	kbeamx=-1		!initialize xycnvt
	kbeamy=-1
	do ii=1,4
	  kpchar(ii)=-1
	enddo
c * output 4105 header
	if(k4105.ne.0) then
	  call cmdout('KC')	!cancel (mode,queues)
c set error threshold to suppress most messages
	  call cmdout('KT')	!set error threshold level (no 4510)
	  call intout(3)	!for DW4125
c set bypass cancel for DW4125 GIN report
	  call cmdout('NU')	!set bypass cancel character
	  call intout(0)	!null = disable bypass
c set view window to default
	  kbeamx=0
	  kbeamy=0
	  call cmdout('RW')	!set view window
	  call xycnvt		!first corner = 0,0
	  call xycnvt		!second corner
c set a default color map (4105, 8 colors)
	  call cmdout('TG')	!set surface color map
	  call intout(1)	!surface number
	  call intray(32,icolmp)
c set graphtext writing mode to overstrike
cx	  call cmdout('MG')	!set graphtext writing mode (no 4510)
cx	  call intout(1)
c page clear resets text/line params in 4510 so do it now
	  if(ibaud.gt.0) call erase
c set graphtext rotation to 0
	  call agtxrot(0)
c set line width
	  call cmdout('MW')
	  call intout(0)	!1 pixel
c set graphtext precision to stroke
	  call cmdout('MQ')
	  call intout(2)	!1=string, 2=stroke
c set marker type to dot
	  call cmdout('MM')	!set marker type
	  call intout(0)
c set line index to white (black if on white screen)
	  klcolr=-1
	  call linclr(1)	!assumes black screen
c set text index to white
	  ktcolr=-1
	  call agtxclr(1)	!set text color
c set panel index to white
	  kpcolr=-256
	  call agpnclr(-256)	!set panel color
	else		!k4105.eq.0
c
	  if(ibaud.gt.0) call erase
	endif
c
cx	call dshmod(0)		!clear hardware dash line
	call chrsiz(1)		!set character size
	call tmark_disk		!end of header
c
	kdasht=0		!dash parameters
	kclip=0			!set default to clip
c
	tvsmx=1.		!transform factors
	tvsmy=1.
	tmintx=0.
	tminty=0.
c
	kminsx=0
	kmaxsx=0		!4095/kfactr
	kminsy=0
	kmaxsy=0		!3120/kfactr
	tminvx=0.
	tmaxvx=kmaxsx
	tminvy=0.
	tmaxvy=kmaxsy
c
	kxtype=1		!set default linear, linear
	kytype=1
c
	return
	end
c%
c----------------------------------------------------------------/tminit
c * set 4105 flag
c
	subroutine tminit(iterm)
	implicit none
	integer iterm
	include 'sgtcs_inc'
	if (iterm.eq.1) then
	  k4105=1
	else
	  k4105=0
	endif
	return
	end
c%
c----------------------------------------------------------------/finitt
c * finish plotting
c
	subroutine finitt(ix,iy)
	implicit none
	integer ix,iy
c
	call agsalf		!switch screen to alpha, dump buffer
	return
	end
c%
c----------------------------------------------------------------/reset
c * initialize tcs common
c
	subroutine reset
	implicit none
	return
	end
c%
c----------------------------------------------------------------/agsalf
c * switch to alpha screen for various terminal types
c
	subroutine agsalf
	implicit none
c
	include 'sgtcs_inc'
	integer ii, lmsg
	character comstr*16
	character*120 msg
c
	if(kscrn.eq.0) return	!already on alpha
	call agfoff		!turn off file output
	if(kkmode.ne.0) call alfmod
c..device dependent actions
	call toutpt(24)		!reset v550
	if(k4105.ne.0) then	!4105 sequences
	  if(model.eq.'VS3100' .or. model.eq.'MAC') then
c				!leave visibility off
	  else
	    call cmdout('LV')	!set dialog area visibility
	    call intout(1)	!on
	  endif
	  if(model.eq.'MAC') then
	    call cmdout('LI')	!set dialog area index
	    call intout(1)	!so VT100 will become front window
	    call intout(0)
	    call intout(1)	!opaque
	    call cmdout('%!')	!select code
	    call intout(1)	!ansi
	  elseif(model.eq.'V550') then	!also IBM emulator
	    call cmdout('%!')	!select code
	    call intout(2)	!vt100
	  elseif(model.eq.'TK4107') then
	    call cmdout('%!')	!select code
	    call intout(0)	!dialog
	  else			!DW4125, ColorTrend
	    call cmdout('%!')	!select code
	    call intout(1)	!1=ansi; 2=edit (VT100)
	  endif
	else			!4014 sequences
	  if(model.eq.'MAC') then
	    call toutpt(24)	!extra can for versaterm
	  elseif(model.eq.'GO') then
	    call toutpt(0)	!null for graph-on
	  endif
	endif
c
c  these terminals dont support 4105 so always do 4014 sequence
c
	if (model.eq.'TK4025') then
	  comstr = '  '//comchr//'MON 34 H K'//char(13)	!return
	  do ii=1,len(comstr)
	    call toutpt(ichar(comstr(ii:ii)))
	  enddo
	elseif(model.eq.'VT240') then
	  comstr = char(27)//'[?38l'	!esc [ ? 3 8 l
	  do ii=1,6
	    call toutpt(ichar(comstr(ii:ii)))
	  enddo
	elseif(model.eq.'XTERM') then
	  comstr = char(27)//char(3)	!esc etx
	  do ii=1,2
	    call toutpt(ichar(comstr(ii:ii)))
	  enddo
	endif
	call agfonn
c
	call tsend		!dump the output buffer
c..type out any broadcast messages and deassign terminal (drop mailbox).
	lmsg=1
	do while(lmsg.gt.0)
	  call agtgbm(msg,lmsg)
	  if(lmsg.gt.0) write(*,'(1x,a)') msg(1:lmsg)
	enddo
	call tclos_term
c
	kscrn = 0		!on alpha screen
	return
	end
c%

c----------------------------------------------------------------/ixitblk
	block data ixitblk
	integer ixit_blok(4)
	integer ixit_cond
	common /ixit/ ixit_blok,ixit_cond
	data ixit_blok /0,0,1,0/
	end 
c----------------------------------------------------------------/agsgrf
c * switch to graphics screen for various terminal types
c
	subroutine agsgrf
	implicit none
c
	include 'sgtcs_inc'
	character*24 comstr
	integer igood, ii

	integer usr_dclexh  
	integer ixit_blok(4)	
	integer ixit_cond
	common /ixit/ ixit_blok,ixit_cond

	external ixitblk
c
	if(kscrn.eq.1) return	!already on graph screen
	call agfoff		!turn off file output
c..declare exit handler
	if(ixit_blok(2).eq.0) then
	  igood = usr_dclexh(ixit_blok)
	endif
c..device dependent actions
	if(k4105.ne.0) then	!4105 sequences
	  call cmdout('%!')	!select code
	  call intout(0)	!tek
	  if(model.eq.'VS3100') then
	  else
	    call cmdout('LV')	!set dialog area visibility
	    call intout(0)	!off
	  endif
	else			!4014 sequences
	  if(model.eq.'MAC') then
	    call cmdout('%!')	!force mac from 4105 to 4014
	    call intout(8)
	  endif
	endif
c
c  these terminals dont support 4105 so always do 4014 sequence
c
	if (model.eq.'TK4025') then
	  comstr = comchr//'WOR 33 H'//comchr//'GRA 1,35'//comchr//
     >		'SHR'//char(13)	!return
	  do ii=1,len(comstr)
	    call toutpt(ichar(comstr(ii:ii)))
	  enddo
c
	elseif(model.eq.'VT240' .or. model.eq.'XTERM') then
	  comstr = char(27)//'[?38h'
	  do ii=1,6
	    call toutpt(ichar(comstr(ii:ii)))
	  enddo
	endif
c
	call tsend_term		!dump terminal buffer
	call agfonn
c
	call alfmod		!if(kkmode.eq.1)
	kscrn = 1		!on graph screen
	return
	end
c%
c======routines that do alpha output====================
c
c----------------------------------------------------------------/alfmod
c * set terminal to alphanumeric mode
c
	subroutine alfmod
	include 'sgtcs_inc'
c
	kkmode=0		!a/n mode
	call toutpt(31)		!us sets a/n mode
	return
	end
c%
c----------------------------------------------------------------/anmode
c * set terminal to alphanumeric mode and flush buffer
c
	subroutine anmode
	implicit none
	include 'sgtcs_inc'
c
	kkmode=0		!a/n mode
	call toutpt(31)		!us sets a/n mode
	call tsend_term		!flush tty output buffer
	return
	end
c%
c----------------------------------------------------------------/anstr
c * output a string stored as integers
c
	subroutine anstr(nchar,str) !   
	character*(*) str	!   
	include 'sgtcs_inc'
	integer nchar

cx This routine should be converted to accept a character string argument.
cx However the Andrew Holland routines used by John Schivell expect an
cx integer array.
c
	call alfmod
	if(k4105.ne.0) then
	  call cmdout('LT')
	  call intout(nchar)
	endif
	do j=1,nchar
          call toutpt(ichar(str(j:j))) !   
	enddo
	kbeamx=kbeamx+(nchar*khorsz+kfactr/2)/kfactr
	return
	end
c%
c----------------------------------------------------------------/toutst
c * output text 1 char/word
c
	subroutine toutst(len,iade)
	include 'sgtcs_inc'
	integer iade(*)
c
	do i=1,len
	  call toutpt(iade(i))
	enddo
	return
	end
c%
c----------------------------------------------------------------/erase
c * erase page
c
	subroutine erase
	implicit none
	include 'sgtcs_inc'
	integer ii
c
	call toutpt(27)		!escape
	call toutpt(12)		!form feed
	call iowait(9)		!wait .9 seconds
c
	do ii=1,4
	  kpchar(ii)=-1
	enddo
	kmovef=1
	return
	end
c%
c----------------------------------------------------------------/newpag
c * erase page and move
c
	subroutine newpag_old
	implicit none
c
	call erase
	call movabs(0,767)		!top/left
	return
	end
c%
c----------------------------------------------------------------/newpag
c * erase page and move
c
	subroutine newpag
	implicit none
        character*12 usernm,pname*31,id*72,formats*72
C CAL 08/06/98 Cant do datebuf=fdate() on IBM
C        character*24 datebuf,fdate, one*2
        character*26 datebuf, one*2
	integer init
	integer l1, l2
	integer  i, j, lenstr
	
        data init/1/
	save id

        if(init.gt.0)then
CCC      call get_arg(0,pname)
        call get_arg(0,id)
        l1=0
        l2=0
        do i=len(id),1,-1
        if(l2.eq.0.and.id(i:i).ne.' ')l2=i
        if(l1.eq.0.and.id(i:i).eq.'/')l1=i
        end do
        l2=min0(l2,len(pname))
        pname=id(l1+1:l2)

c         call getlog(usernm)
         call sget_user(usernm)
c         call fdate(datebuf)
         call FDATE(datebuf)
         formats='(1x,a'
         write(one(1:2),fmt='(i2.2)')lenstr(pname)
         formats=formats(1:lenstr(formats))//one(1:2)
         formats=formats(1:lenstr(formats))//',14h generated by ,'
         write(one(1:2),fmt='(i2.2)')lenstr(usernm)
         formats=formats(1:lenstr(formats))//'a'//one(1:2)
         formats=formats(1:lenstr(formats))//',4h on ,a24,1h$)'
         write(id,fmt=formats)pname,usernm,datebuf
         init=0
        endif
C
C        print*,'id = ',id,lenstr(id)
C
        call csize(i,j)
	call erase
        call chrsiz(4)
        call agtmhs(0,0,id)
        if(j.eq.22)then
         call chrsiz(1)
        elseif(j.eq.20)then
         call chrsiz(2)
        elseif(j.eq.13)then
         call chrsiz(3)
        elseif(j.eq.12)then
         call chrsiz(4)
        else
         call chrsiz(1)
        endif
	call movabs(0,767)		!top/left
	return
	end
c%
        integer function lenstr(c)
	implicit none
        character*(*) c
	integer i

        do i=len(c),1,-1
        lenstr=i
        if(c(i:i).ne.' ')return
        end do
        return
        end

c%
c----------------------------------------------------------------/bell
c * ring bell at terminal
c
	subroutine bell
	implicit none
c
	call toutpt(7)
	return
	end
c%
c----------------------------------------------------------------/ainst
c * read input string 4 chars/word
c
	subroutine ainst(nchar,string)
	implicit none
	character string*(*)
	integer len, kchar
	integer nchar, maxlen, ii
	data maxlen/72/
c
	len=min(nchar,maxlen)
	do ii=1,len
	  if(ii.gt.1) call agtpurg(.false.)
	  call tinput(kchar)
	  string(ii:ii)=char(kchar)
	enddo
	return
	end
c%
c----------------------------------------------------------------/tinstr
c * read input characters one/word
c
	subroutine tinstr(nchar,iade)
	implicit none
	integer iade(*)
	integer nchar, i, kchar
c
	do i=1,nchar
	  call tinput(kchar)
	  iade(i)=kchar
	enddo
	return
	end
c%
c----------------------------------------------------------------/scursr
c * get cursor position in screen units
c
	subroutine scursr(ichr,ix,iy)
	implicit none
	include 'sgtcs_inc'
	integer ichr,ix,iy
	character instr*8
c	integer*2 ini(6)
	integer ini(6)
	integer nchar, ii
	integer   hex1f
	data hex1f /z'1f'/
c
c * output (esc) (sub) to turn on cursor
	call agfoff		!turn off file output
	call toutpt(27)		!escape
	call toutpt(26)		!sub
	call tsend
c * flush any type-ahead
cx	call agtpurg(.true.)
c * determine how many chars to input
	nchar=5
cx	if(model.eq.'GO') nchar=5	!graph-on
	if(model.eq.'TK4025') nchar=5
	if(model.eq.'XTERM') nchar=5
	if(model.eq.'DW4125') nchar=6
	if(model.eq.'MAC')  nchar=6
	if(model.eq.'MODGRF') nchar=6
	if(model.eq.'TK4107') nchar=6	!??
	if(model.eq.'VS3100') nchar=6
	if(model.eq.'VT240') nchar=6	!if setup is GIN term=CR
	if(model.eq.'XTC') nchar=6
	if(model.eq.'V550') nchar=7
c
	call ainst(nchar,instr)
c * restore the terminal status
	call agfonn
	call alfmod
	ichr=ichar(instr(1:1))
c * convert coordinates to integer
	do ii=2,5
	  ini(ii)=iand(ichar(instr(ii:ii)),hex1f)
	enddo
c * decode screen co-ordinates
	ix=int(ini(2))*32+ini(3)
	iy=int(ini(4))*32+ini(5)
c * apply screen scale factor
	ix=ix*(4/kfactr)
	iy=iy*(4/kfactr)
	return
	end
c%
c----------------------------------------------------------------/dcursr
c * read graphics cursor in screen coordinates
c
	subroutine dcursr(ichar,ix,iy)
	implicit none
	integer ichar,ix,iy
c
	call scursr(ichar,ix,iy)
	return
	end
c%
c----------------------------------------------------------------/vcursr
c * get cursor position in virtual units
c
	subroutine vcursr(ichar,x,y)
	implicit none
        integer ichar, ixa,iya
	real x,y
c
	call scursr(ichar,ixa,iya)
	call revcot(ixa,iya,x,y)
	return
	end
c%
c----------------------------------------------------------------/hdcopy
c * make a hardcopy of the screen
c
	subroutine hdcopy
	implicit none
c
	call agfoff		!turn off file output
	call toutpt(27)		!escape
	call toutpt(23)		!etb
	call tsend_term		!flush output buffer
	call iowait(180)	!wait 18 seconds
	call agfonn
	return
	end
c%
c======routines that do graphic output====================
c
c----------------------------------------------------------------/vecmod
c * set terminal to graphics mode
c
	subroutine vecmod
	implicit none
	include 'sgtcs_inc'
	integer ii
c
	if(kkmode.ne.1) then
c * output (us) to enter a/n mode and reset for vector mode
	  if(kkmode.ne.0) call alfmod
	  do ii=1,4
	    kpchar(ii)=-1
	  enddo
	  kkmode=1	  	!vector mode
	endif
c * output (gs) to enter vector mode
	call toutpt(29)		!send gs
	kmovef=1		!need a move
	return
	end
c%
c----------------------------------------------------------------/movea
c * move beam (virtual, absolute)
c
	subroutine movea(x,y)
	implicit none
	include 'sgtcs_inc'
	real x,y
	real dx, dy
	integer ivclip
c
	trealx=x		!update unclipped coords
	trealy=y
	go to 100
c
c----------------------------------------------------------------/mover
c * move beam (virtual, relative)
c
	entry mover(dx,dy)
c
	trealx=trealx+dx
	trealy=trealy+dy
 100	continue		!convert to screen coord
	call wincot(trealx,trealy,krealx,krealy)
	if(kclip.eq.0) then	!quit if outside
	  if(ivclip(krealx,krealy).ne.0) return
	endif
	call movabs(krealx,krealy)	!move
	return
	end
c%
c----------------------------------------------------------------/movabs
c * move beam (screen, absolute)
c
	subroutine movabs(ix,iy)
	implicit none
	include 'sgtcs_inc'
	integer ix,iy,ibx,iby,idx,idy
c
	ibx=ix
	iby=iy
	go to 100
c
c----------------------------------------------------------------/movrel
c * move beam (screen, relative)
c
	entry movrel(idx,idy)
c
	ibx=kbeamx+idx
	iby=kbeamy+idy
 100	continue
	if(kdasht.ne.0) call dshmod(0)	!clear dash line type
	if(kmovef.le.0) then	!last output move or draw
	  if(kbeamx.eq.ibx .and. kbeamy.eq.iby) return !already here
	endif
	call vecmod
	kbeamx=ibx		!update coordinates
	kbeamy=iby
	call xycnvt		! and send them
	return
	end
c%
c----------------------------------------------------------------/drawa
c * draw line (virtual, relative)
c
	subroutine drawa(x,y)
	implicit none
        real x, y
	include 'sgtcs_inc'

        integer itx, ity, ix,iy,iclast, ivclip, lout
	real    dx, dy


	trealx=x		!update unclipped coords
	trealy=y
	go to 100
c
c----------------------------------------------------------------/drawr
c * draw line (virtual, relative)
c
	entry drawr(dx,dy)
c
	trealx=trealx+dx
	trealy=trealy+dy
 100	continue
	itx=krealx		!get previous point
	ity=krealy
	call wincot(trealx,trealy,ix,iy)	!convert this point
	krealx=ix		!save unclipped coords
	krealy=iy
	if(kclip.eq.0) then	!if clip option
	  iclast=ivclip(itx,ity)	!check previous point
	  call agcsca(itx,ity,ix,iy,lout)	!move either/both
	  if(lout.ne.0) return		!quit if both outside
c * if last was outside, move to clipped coordinates
	  if(iclast.ne.0) call movabs(itx,ity)
	endif
c * draw to new coordinates
	call drwabs(ix,iy)
	return
	end
c%
c----------------------------------------------------------------/drwabs
c * draw line (screen, absolute)
c
	subroutine drwabs(ix,iy)
	implicit none
	include 'sgtcs_inc'
	integer ix, iy, ibx, iby, idx, idy
c
	ibx=ix
	iby=iy
	go to 100
c
c----------------------------------------------------------------/drwrel
c * draw line (screen, relative)
c
	entry drwrel(idx,idy)
c
	ibx=kbeamx+idx
	iby=kbeamy+idy
 100	continue
	if(kkmode.ne.1) call vecmod
	if(kmovef.eq.-1) then	!last output draw
	  if(kbeamx.eq.ibx .and. kbeamy.eq.iby) return !already here
	endif
	if(kmovef.eq.1) call xycnvt
	kbeamx=ibx		!update coordinates
	kbeamy=iby
	call xycnvt		!send coordinates
	kmovef=-1		!last output draw
	return
	end
c%
c----------------------------------------------------------------/pntmod
c * set terminal to point mode
c
	subroutine pntmod
	implicit none
	include 'sgtcs_inc'
	integer ii
c
	if(kkmode.eq.4) call alfmod
	if(kkmode.eq.1) call alfmod
	do ii=1,4
	  kpchar(ii)=-1
	enddo
	kkmode=2		!point mode
	if(kterm.ge.3 .or. k4105.gt.0) then
c * output (fs) to enter point mode
	  call toutpt(28)	!set hardware point
cx	  kpoins=-1
	  kmovef=1
	endif
c
	return
	end
c%
c----------------------------------------------------------------/pointa
c * put point (virtual, absolute)
c
	subroutine pointa(x,y)
	implicit none
	real x, y
	include 'sgtcs_inc'
	real dx, dy
	integer ivclip
c
	trealx=x		!update unclipped coords
	trealy=y
	go to 100
c
c----------------------------------------------------------------/pointr
c * put point (virtual, relative)
c
	entry pointr(dx,dy)
c
	trealx=trealx+dx
	trealy=trealy+dy
 100	continue
	call wincot(trealx,trealy,krealx,krealy)
	if(kclip.eq.0) then
	  if(ivclip(krealx,krealy).ne.0) return
	endif
 	call pntabs(krealx,krealy)
	return
	end
c%
c----------------------------------------------------------------/pntabs
c * put point (screen, absolute)
c
	subroutine pntabs(ix,iy)
	implicit none
	integer ix,iy
	include 'sgtcs_inc'
	integer ibx, iby, idx, idy
c
	ibx=ix
	iby=iy
	go to 100
c
c----------------------------------------------------------------/pntrel
c * put point (screen, relative)
c
	entry pntrel(idx,idy)
c
	ibx=kbeamx+idx
	iby=kbeamy+idy
 100	continue
	if(kkmode.ne.2) call pntmod
	if(kmovef.le.0) then	!last output move or draw
	  if(kbeamx.eq.ibx .and. kbeamy.eq.iby) return !already here
	endif
	kbeamx=ibx
	kbeamy=iby
	if(kterm.lt.3 .and. k4105.le.0) then
	  call toutpt(29)	!move to point (gs)
	  call xycnvt
	endif
cx	do ii=1,4
cx	  kpchar(ii)=-1
cx	enddo
	call xycnvt		!draw to same to make a point
	kmovef=-1
	return
	end
c%
c----------------------------------------------------------------/dshmod
c * set terminal to dash mode
c
	subroutine dshmod(ldash)
	implicit none
	include 'sgtcs_inc'
	integer ldash, idash, irem, j, isub
	integer itable(4)
	data itable/ 5,10,25,50/
c
	if(kkmode.eq.2) call alfmod	!point mode -> alpha
	if(ldash.eq.0) then		!if no dash
	  if(kdasht.ne.0) then
	  call toutpt(27)		!clear hardware dash
	  call toutpt(96)
	  kdasht=0
	  endif
cx	  call vecmod
	  return
	endif
	if(kkmode.eq.0) then		!if a/n mode
	  call toutpt(29)		!vector mode
	  call xycnvt			!move to this spot
	endif
c
	if(kterm.ge.3 .and. ldash.gt.0 .and. ldash.le.7) then
	  kkmode=4			!dash mode
	  call toutpt(27)		!set hardware dash
	  kdasht=ldash
	  call toutpt(96+kdasht)	!dash code
	  kdashs=-1		!flag for hardware dash
	  kmovef=1
	  return
	endif
c
	if(ldash.ne.kdasht) then
c * determine dash type, then decode
	  idash = ldash
	  if(idash.lt.0) idash=1
	  kdasht=idash
	  if(idash.ge.11) go to 500
	  kmdash(0)=1		!draw
	  kmdash(1)=0		!move
	  kmdash(2)=1		!draw
	  kmdash(3)=0		!move
	  go to (100,200,300,400,100,100,100,100,1000,100),idash
c * dot
  100	  idash=1
	  kdash(0)=1		!dot
	  kdash(1)=10		!space
	  kdash(2)=1		!dot
	  kdash(3)=10		!space
	  go to 1000
c * dot dash
  200	  kdash(0)=1		!dot
	  kdash(1)=10		!space
	  kdash(2)=15		!dash
	  kdash(3)=10		!space
	  go to 1000
c * short dash
  300	  kdash(0)=15		!dash
	  kdash(1)=15		!space
	  kdash(2)=15		!dash
	  kdash(3)=15		!space
	  go to 1000
c * long dash
  400	  kdash(0)=35		!dash
	  kdash(1)=10		!space
	  kdash(2)=35		!dash
	  kdash(3)=10		!space
	  go to 1000
c * decode integer dash specification string
  500	  irem=idash		!process digits from
	  do j=3,0,-1		! right to left (low to high)
	    if(irem.eq.0) then	!duplicate earlier pattern
	      kdash(j)=kdash(j+2)
	      kmdash(j)=kmdash(j+2)
	    else
	      isub=mod(irem,10)
	      irem=irem/10
	      kdash(j)=itable((isub+1)/2)	!dash length
	      kmdash(j)=iand(isub,1)	!even=move, odd=draw
	    endif
	  enddo
c
 1000	  continue
	  kdashs=3		!init dash step and
	  tdashr=0.		! remaining dash length
	endif
	return
	end
c%
c----------------------------------------------------------------/dasha
c * draw dash line (virtual, absolute)
c
	subroutine dasha(x,y,ldash)
	implicit none
	include 'sgtcs_inc'
	integer  itx, ity, ix, iy, iclast, ivclip, lout, ldash
	real     x, y, dx, dy
c
 	trealx=x		!update unclipped coords
	trealy=y
	go to 100
c
c----------------------------------------------------------------/dashr
c * draw dash line (virtual, relative)
c
	entry dashr(dx,dy,ldash)
c
	trealx=trealx+dx
	trealy=trealy+dy
 100	continue
	itx=krealx		!get previous point
	ity=krealy
	call wincot(trealx,trealy,ix,iy)	!convert this point
	krealx=ix		!save unclipped coords
	krealy=iy
	if(kclip.eq.0) then	!if clip option
	  iclast=ivclip(itx,ity)	!check previous point
	  call agcsca(itx,ity,ix,iy,lout)	!move either/both
	  if(lout.ne.0) return		!quit if both outside
c * if last was outside, move to clipped coordinates
	  if(iclast.ne.0) call movabs(itx,ity)
	endif
c * draw to new coordinates
 	call dshabs(ix,iy,ldash)
	return
	end
c%
c----------------------------------------------------------------/dshabs
c * draw dash line (screen, absolute)
c
	subroutine dshabs(ix,iy,ldash)
	include 'sgtcs_inc'
c
	ibx=ix
	iby=iy
	go to 100
c
c----------------------------------------------------------------/dshrel
c * draw dash line (screen, relative)
c
	entry dshrel(idx,idy,ldash)
c
	ibx=kbeamx+idx
	iby=kbeamy+idy
 100	continue
	if(ldash.eq.0) then	!if no dash pattern
	  call drwabs(ibx,iby)	!draw solid line
	  return
	endif
	if(ldash.ne.kdasht) call dshmod(ldash)	!init dashed vector
	if(kdashs.lt.0) then	!if hardware dash
	  kkmode=1
	  call drwabs(ibx,iby)	!draw line
	  kkmode=4
	  return
	endif
	if(ldash.eq.9) then	!alternate move,draw
	  if(kdashs.eq.0) then
	    kdashs=1		!set to draw next time
	    call movabs(ibx,iby)	!move
	  else
	    kdashs=0		!set to move next time
	    call drwabs(ibx,iby)	!draw
	  endif
	  return
	endif
c dashed vector
	dx=ibx-kbeamx
	dy=iby-kbeamy
	d0=sqrt(dx*dx+dy*dy)		!distance
	kkmode=1
	d=d0
	do while(d.ne.0.)		!loop until distance exhausted
c
	  if(tdashr.eq.0.) then		!get next
	    kdashs=mod(kdashs+1,4)	! move or draw and its
	    tdashr=kdash(kdashs)	! dash length from dash spec
	  endif
c
	  if(d.ge.tdashr) then		!remaining
	    d=d-tdashr			! distance to point
	    tdashr=0.			! use total dash
	  else
	    tdashr=tdashr-d		!unused dash fragment
	    d=0.			! with no distance left
	  endif
c
	  dod0=d/d0			!with fraction
	  jx=ibx-ifix(dod0*dx)		! of distance being drawn
	  jy=iby-ifix(dod0*dy)		! update coordinates
	  if(kmdash(kdashs).eq.0) then
	    call toutpt(29)		!move
	    kbeamy=jy
	    kbeamx=jx
	    call xycnvt
	  else
	    call drwabs(jx,jy)		!draw
	  endif
	enddo
	return
	end
c%
c----------------------------------------------------------------/linclr
c * set the line color
c
	subroutine linclr(idx)
	implicit none

	include 'sgtcs_inc'
	integer idx
	if(idx.eq.klcolr) return
	klcolr=idx
	if(k4105.ne.0 .and. idx.ge.0) then
	  call cmdout('ML')
	  call intout(idx)
	endif
	return
	end
c%
c----------------------------------------------------------------/agpnclr
c * set the panel color (-7 to 0 are solid colors)
c
	subroutine agpnclr(idx)
	implicit none
	include 'sgtcs_inc'
	integer idx

	if(idx.eq.kpcolr) return
	kpcolr=idx
	if(k4105.ne.0 .and. idx.ge.-255) then
	  call cmdout('MP')
	  call intout(idx)
	endif
	return
	end
c%
c----------------------------------------------------------------/agtxclr
c * set the text color
c
	subroutine agtxclr(idx)
	implicit none
	integer idx
	include 'sgtcs_inc'
	if(idx.eq.ktcolr) return
	ktcolr=idx
	if(k4105.ne.0 .and. idx.ge.0) then
	  call cmdout('MT')
	  call intout(idx)
	endif
	return
	end
c%
c----------------------------------------------------------------/agtxrot
c * set the text rotation
c
	subroutine agtxrot(iangl)
	implicit none
	include 'sgtcs_inc'
	integer iangl

	if(k4105.ne.0) then
	call cmdout('MR')
	call intout(iangl)
	call intout(0)
	endif
	return
	end
c%
c----------------------------------------------------------------/agmark
c * output a marker
c
	subroutine agmark(lmark)
	implicit none
c
	include 'sgtcs_inc'
	integer lmark

	if(k4105.eq.0) return
	call cmdout('MM')
	call intout(lmark)
	return
	end
c%
c======graphic support and clipping routines==================
c
c----------------------------------------------------------------/vbgpnl
c * begin panel with virtual coordinates
c
	subroutine vbgpnl(x,y,ibound)
	implicit none
	real x,y
	integer ibound
	include 'sgtcs_inc'

	call cmdout('LP')
	call wincot(x,y,kbeamx,kbeamy)
	call xycnvt
	call intout(ibound)
	return
	end
c
c----------------------------------------------------------------/begpnl
c * begin panel with screen coordinates
c
	subroutine begpnl(ix,iy,ibound)
	implicit none
	include 'sgtcs_inc'
	integer ix,iy,ibound

	kbeamx=ix
	kbeamy=iy
c
c * begin panel at screen location
	entry agbgpnl(ibound)
	call cmdout('LP')
	call xycnvt
	call intout(ibound)
	return
	end
c
c----------------------------------------------------------------/endpnl
c * end panel
c
	subroutine endpnl
	call cmdout('LE')
	return
	end
c
c----------------------------------------------------------------/cmdout
c * output a 4105 command (esc,char,char)
c
	subroutine cmdout(cmd)
	implicit none
	character cmd*2

	call toutpt(27)
	call toutpt(ichar(cmd(1:1)))
	call toutpt(ichar(cmd(2:2)))
	return
	end
c
c----------------------------------------------------------------/intray
c * output an array of 4105 command integers
c
	subroutine intray(len,iray)
	implicit none
	integer iray(*), len
	integer i
	
	call intout(len)
	if (len.le.0) return
	do i=1,len
	  call intout(iray(i))
	enddo
	return
	end
c%
c----------------------------------------------------------------/intout
c * output an integer as part of a 4105 command
c
	subroutine intout(int)
	implicit none
	integer int, jint, jhi1, jhi2, jloi
c * find the absolute value
	jint=abs(int)
c * compute the two hi-i is and the lo-i
	jhi1=jint/1024+64
	jhi2=mod(jint/16,64)+64
	jloi=mod(jint,16)+32
	if (int.ge.0) jloi=jloi+16
c * see if hi-i is needed
	if (jhi1.ne.64) go to 10
	if (jhi2.ne.64) go to 30
	go to 50
 10	call toutpt(jhi1)
c * insert second hi-i
 30	call toutpt(jhi2)
c * insert lo-i
 50	call toutpt(jloi)
c * send the string
	return
	end
c%
c----------------------------------------------------------------/iaghres
c * convert 1024 coordinate to 4096 resolution
c
	integer function iaghres(ixy)
	implicit none
	include 'sgtcs_inc'
	integer ixy
c
	iaghres=ixy*4/kfactr
	return
	end
c%
c----------------------------------------------------------------/iaglres
c * convert 4096 resolution to 1024 coordinates
c
	integer function iaglres(ixy)
	implicit none
	integer ixy
	include 'sgtcs_inc'
c
	iaglres=ixy*kfactr/4
	return
	end
c%
c----------------------------------------------------------------/agcsca
c * determine if need to clip
c
	subroutine agcsca(ix1,iy1,ix2,iy2,lout)
	implicit none
	include 'sgtcs_inc'
	integer ix1,iy1,ix2,iy2,lout
	logical swap
	integer ic1,ic2
	integer isleft, isright, isbelow, isabove
	integer ivclip, iz

c	parameter (isleft ='01'x)	!bit mask to move left
c	parameter (isright='02'x)	! move right
c	parameter (isbelow='04'x)	! move down
c	parameter (isabove='08'x)	! move up
	parameter (isleft =1)	!bit mask to move left
	parameter (isright=2)	! move right
	parameter (isbelow=4)	! move down
	parameter (isabove=8)	! move up
c  Cohen/Sutherland clipping algorithm.  Newman and Sproull,
c  Principles of Interactive Computer Graphics.  pp 123-124.
c
	swap=.false.
	do while (.true.)
	  ic2=ivclip(ix2,iy2)		!compute clip code for
	  ic1=ivclip(ix1,iy1)		! each endpoint
c  line entirely inside
	  if(ic1.eq.0 .and. ic2.eq.0) go to 1000
c  line entirely outside
	  if(iand(ic1,ic2).ne.0) then
	    lout=1
	    return
	  endif
c
	  if(ic1.eq.0) then
	    swap=.not.swap
	    ic1=ic2
	    ic2=0
	    iz=ix1
	    ix1=ix2
	    ix2=iz
	    iz=iy1
	    iy1=iy2
	    iy2=iz
	  endif
c
	  if(iand(ic1,isleft ).ne.0) then	!push toward left edge
	    iy1=iy1+(iy2-iy1)*(kminsx-ix1)/(ix2-ix1)
	    ix1=kminsx
	  elseif(iand(ic1,isright).ne.0) then	!push toward right edge
	    iy1=iy1+(iy2-iy1)*(kmaxsx-ix1)/(ix2-ix1)
	    ix1=kmaxsx
	  elseif(iand(ic1,isbelow).ne.0) then	!push toward bottom edge
	    ix1=ix1+(ix2-ix1)*(kminsy-iy1)/(iy2-iy1)
	    iy1=kminsy
	  elseif(iand(ic1,isabove).ne.0) then	!push toward top edge
	    ix1=ix1+(ix2-ix1)*(kmaxsy-iy1)/(iy2-iy1)
	    iy1=kmaxsy
	  endif
	enddo
c
 1000	if(swap) then
	  iz=ix1
	  ix1=ix2
	  ix2=iz
	  iz=iy1
	  iy1=iy2
	  iy2=iz
	endif
	lout=0
	return
	end
c%
c----------------------------------------------------------------/ivclip
c  inout=ivclip(ix,iy)
c
	integer function ivclip(ix,iy)
	implicit none
	integer  ix,iy
	include 'sgtcs_inc'
	integer ivcl
	integer isleft, isright, isbelow, isabove
	parameter (isleft =1)	!bit mask to move left
	parameter (isright=2)	! move right
	parameter (isbelow=4)	! move down
	parameter (isabove=8)	! move up
c
	ivcl=0			!inside
	if(ix.lt.kminsx) then
	  ivcl=ior(ivcl,isleft )	!left
	elseif(ix.gt.kmaxsx) then
	  ivcl=ior(ivcl,isright)	!right
	endif
	if(iy.lt.kminsy) then
	  ivcl=ior(ivcl,isbelow)	!below
	elseif(iy.gt.kmaxsy) then
	  ivcl=ior(ivcl,isabove)	!above
	endif
	ivclip=ivcl
	return
	end
c%
c----------------------------------------------------------------/wincot
c * transform from virtual window to screen coordinates
c
	subroutine wincot(x,y,ix,iy)
	implicit none
	real x,y
	integer ix,iy
	include 'sgtcs_inc'
	real xx, yy, xi, yi
c
	xx=x
	yy=y
	if(kxtype.eq.2) then
	  if(xx.le.0.) then
	    xx = log10(tminvx)	!avoid logzerneg problems
	  else
	    xx = log10(xx)
	  endif
	endif
	if(kytype.eq.2) then
	  if(yy.le.0.) then
	    yy = log10(tminvy)	!avoid logzerneg problems
	  else
	    yy = log10(yy)
	  endif
	endif
c transform to screen coordinates
	xi = xx*tvsmx+tvsbx
	yi = yy*tvsmy+tvsby
cx	if(abs(xi).gt.3.e4) xi=sign(3.e4,xi)
cx	if(abs(yi).gt.3.e4) yi=sign(3.e4,yi)
	xi = min(xi,+3.e4)		!avoid float->int error
	xi = max(xi,-3.e4)
	yi = min(yi,+3.e4)
	yi = max(yi,-3.e4)
	ix = xi
	iy = yi
	return
	end
c%
c----------------------------------------------------------------/revcot
c * transform from screen to virtual window coordinates
c
	subroutine revcot(ix,iy,x,y)
	implicit none
	integer ix,iy
	real x,y
	include 'sgtcs_inc'

c
	x=float(ix-kminsx)/tvsmx+tmintx
	y=float(iy-kminsy)/tvsmy+tminty
	if(kxtype.eq.2) x=10**x
	if(kytype.eq.2) y=10**y
	return
	end
c%
c----------------------------------------------------------------/xycnvt
c * convert x/y coordinates to tektronix beam commands
c
	subroutine xycnvt
	implicit none
	include 'sgtcs_inc'
c  see 4010 maintenance manual (6-33) graphic vector description
	integer hix,hiy,lsb,lox,loy
	integer kx, ky
	integer hex1f, hex03
	data hex1f,hex03 /z'1f', z'03'/
c
c * clip off screen data
	kbeamx=min(kbeamx,kmxscr)
	kbeamx=max(kbeamx,0)
	kbeamy=min(kbeamy,kmxscr)	!?780
	kbeamy=max(kbeamy,0)
c * decode coordinates for reduced data transmission
	kx=kbeamx*kfactr
	ky=kbeamy*kfactr
	hiy=iand(ky/128,hex1f)+32
	lsb=iand(ky,hex03)*4+iand(kx,hex03)+96
	loy=iand(ky/4,hex1f)+96
	hix=iand(kx/128,hex1f)+32
	lox=iand(kx/4,hex1f)+64
c * send coordinates
	if(hiy.ne.kpchar(1)) then
	  kpchar(1)=hiy
	  call toutpt(hiy)
	endif
	if(lsb.ne.kpchar(2)) then	!.and. kterm.gt.1
	  kpchar(2)=lsb
	  call toutpt(lsb)
	  kpchar(3)=-1
	endif
	if(loy.ne.kpchar(3) .or. hix.ne.kpchar(4)) then
	  kpchar(3)=loy
	  call toutpt(loy)
	endif
	if(hix.ne.kpchar(4)) then
	  kpchar(4)=hix
	  call toutpt(hix)
	endif
	call toutpt(lox)
	kmovef=0
	return
	end
c%
c======routines that get/set values in common===============
c
c----------------------------------------------------------------/term
c * set (tektronix) terminal type and screen resolution
c
	subroutine term(iterm,iscal)
	implicit none
	integer iterm,iscal
	include 'sgtcs_inc'
c * set term type up, but not down
	if(iterm.ge.kterm) kterm=iterm
c * default iscal = 1024
	if(iscal.gt.0) kfactr=4	!1024 screen
c * set screen resolution unless override by terminal_res
	if(iscal.gt.1024 .and. ksres.ne.1024) kfactr=1
	kmxscr=4095/kfactr
cx	call reset
	return
	end
c%
c----------------------------------------------------------------/dwindo
c * set the virtual window
c
	subroutine dwindo(xmin,xmax,ymin,ymax)
	include 'sgtcs_inc'
c
	tminvx=xmin
	tmaxvx=xmax
	tminvy=ymin
	tmaxvy=ymax
	go to 100
c%
c----------------------------------------------------------------/swindo
c * set the screen window
c
	entry swindo(minx,lx,miny,ly)
c
	kminsx=minx
	kmaxsx=minx+lx
	kminsy=miny
	kmaxsy=miny+ly
	go to 100
c%
c----------------------------------------------------------------/twindo
c * set the screen window
c
	entry twindo(minx,maxx,miny,maxy)
c
	kminsx=minx
	kmaxsx=maxx
	kminsy=miny
	kmaxsy=maxy
	!go to 100
c%
c----------------------------------------------------------------/rescal
c * set virtual to screen windown transformation
c
	entry rescal
c
 100	continue
	tmintx=tminvx
	tmaxtx=tmaxvx
	tminty=tminvy
	tmaxty=tmaxvy
c * if log mode, transform user space to log
	if(kxtype.eq.2) then	!log x
	  if(tmintx.gt.0.) tmintx=log10(tmintx)
	  if(tmaxtx.gt.0.) tmaxtx=log10(tmaxtx)
	endif
	if(kytype.eq.2) then	!log y
	  if(tminty.gt.0.) tminty=log10(tminty)
	  if(tmaxty.gt.0.) tmaxty=log10(tmaxty)
	endif
c
	dtx=tmaxtx-tmintx
	if(dtx.eq.0.) dtx=1.
	dty=tmaxty-tminty
	if(dty.eq.0.) dty=1.
c  set user to screen transformation
	tvsmx=float(kmaxsx-kminsx)/dtx
	tvsbx=float(kminsx)-tvsmx*tmintx
	tvsmy=float(kmaxsy-kminsy)/dty
	tvsby=float(kminsy)-tvsmy*tminty
	return
	end
c%
c----------------------------------------------------------------/csize
c * return character size in raster units from common
c
	subroutine csize(ihorz,ivert)
	implicit none
	integer ihorz,ivert
	include 'sgtcs_inc'
c
	if(kfactr.eq.0) then
	  stop 'STOP in sglib csize: initt not called'
	endif
	ihorz=(khorsz+kfactr/2)/kfactr
	ivert=(kversz+kfactr/2)/kfactr
	return
	end
c%
c----------------------------------------------------------------/aglnlg
c * communicate between agii and tcs common blocks
c
	subroutine aglnlg(ixtype,iytype)
	implicit none
	integer ixtype,iytype
	include 'sgtcs_inc'
c
	kxtype=ixtype
	kytype=iytype
	return
	end
c%
c----------------------------------------------------------------/setclp
c * set clip parameter in common
c
	subroutine setclp(ivalue)
	implicit none
	integer ivalue
	include 'sgtcs_inc'
c
	kclip=ivalue
	return
c
c----------------------------------------------------------------/agclip
c
	entry agclip
c
	kclip=0		!clipping on
	return
c
c----------------------------------------------------------------/agnclp
c
	entry agnclp
c
	kclip=1		!clipping off
	return
	end
c%
c----------------------------------------------------------------/seetrm
c * return terminal parameters from common
c
	subroutine seetrm(ibaud,iterm,icsize,maxscr)
	implicit none
	integer ibaud,iterm,icsize,maxsc
	include 'sgtcs_inc'
	integer maxscr
c
	ibaud=0		!baud no longer stored
	iterm=kterm
	icsize=ksizef
	maxscr=kmxscr
	return
	end
c%
c----------------------------------------------------------------/agseet
c * return terminal parameters from common
c
	subroutine agseet(i4105,ifactr,icsize,maxscr)
	implicit none
	integer i4105,ifactr,icsize,maxscr
	include 'sgtcs_inc'
c 04/15/99 CAL: moved to block data
c	data kfactr /4/	!in case initt not linked
c
	i4105=k4105
	ifactr=4/kfactr
	icsize=ksizef
	maxscr=kmxscr
	return
	end
c%
c----------------------------------------------------------------/agsmodl
c * return terminal model from common
c
	subroutine agsmodl(cmodel)
	implicit none
	character cmodel*(*)
	include 'sgtcs_inc'
c
	cmodel=model
	return
	end
c%
c----------------------------------------------------------------/seeloc
c * return screen position from common
c
	subroutine seeloc(ix,iy)
	implicit none
	integer ix,iy
	include 'sgtcs_inc'
c
	ix=kbeamx	!*kfactr/4
	iy=kbeamy	!*kfactr/4
	return
	end
c%
c----------------------------------------------------------------/seetw
c * return screen window from common
c
	subroutine seetw(minx,maxx,miny,maxy)
	implicit none
	integer minx,maxx,miny,maxy
	include 'sgtcs_inc'
c
	minx=kminsx	!*kfactr/4
	maxx=kmaxsx	!*kfactr/4
	miny=kminsy	!*kfactr/4
	maxy=kmaxsy	!*kfactr/4
	return
	end
c%
c----------------------------------------------------------------/seedw
c * return virtual window from common
c
	subroutine seedw(xmin,xmax,ymin,ymax)
	implicit none
	integer xmin,xmax,ymin,ymax

	include 'sgtcs_inc'
c
	xmin=tminvx
	xmax=tmaxvx
	ymin=tminvy
	ymax=tmaxvy
	return
	end
c%
c----------------------------------------------------------------/linwdt
c * return width of character string in raster units
c
	integer function linwdt(numchr)
	implicit none
	integer numchr

	include 'sgtcs_inc'
c
	linwdt=(khorsz*numchr+kfactr/2)/kfactr
	return
	end
c%
c----------------------------------------------------------------/linhgt
c * return height of vertical string in raster units
c
	integer function linhgt(numlin)
	implicit none
	integer  numlin
	include 'sgtcs_inc'
c
	linhgt=(kversz*numlin+kfactr/2)/kfactr
	return
	end
c%
c----------------------------------------------------------------/chrsiz
c * set character size
c
	subroutine chrsiz(k)
	implicit none
	integer k
	include 'sgtcs_inc'
	integer ispc, iwid, ihgt, icode
	integer ichrtb(2,4,2)

	data ichrtb /
     >	  56,88, 51,82, 34,53, 31,48,	!4014 sizes
     >	  51,88, 51,88, 31,51, 31,51 /	!4105 sizes
c
	ksizef=k
	ksizef=max(ksizef,1)
	ksizef=min(ksizef,4)
	if(k4105.ne.0) then
	  khorsz=ichrtb(1,ksizef,2)
	  kversz=ichrtb(2,ksizef,2)
c * only height is used by VT, 4510; but set spacing for good measure
	  ispc=16
	  iwid=.69*khorsz	!default is 40 for 41xx, 39 for 4510
	  ihgt=.69*kversz	!default is 60 for 41xx, 59 for 4510
	  call cmdout('MC')
	  call intout(iwid)	!width
	  call intout(ihgt)	!height
	  call intout(ispc)	!spacing
	else
	  khorsz=ichrtb(1,ksizef,1)
	  kversz=ichrtb(2,ksizef,1)
	  icode=55+ksizef
	  call toutpt(27)
	  call toutpt(icode)
	endif
	return
	end
c%
c----------------------------------------------------------------/icclip
c * return clip parameter from common
c
	integer function icclip(idum)
	implicit none
	integer idum
	include 'sgtcs_inc'
c
	icclip=kclip
	return
	end
c%
c%

C---------------------------------------------------------------------
C  URDBUF  - RETURN CONTENTS OF TYPEAHEAD BUFFER TO CALLER
C
      SUBROUTINE URDBUF(ZBUFF,ILEN,ICALL)
C
C  ICALL=1 -- RE-INSERT LAST ITEM POPPED OFF BUFFER STACK
C  ICALL=0 -- DON'T RE-INSERT LAST ITEM
C
      USE USERIO
C
      CHARACTER*(*) ZBUFF
C
C--------------------------------
C
      ILEN=LEN(ZBUFF)
C
      ICT=1
      IF(ICALL.NE.1) GO TO 100
C
      ICT=ICT-1
C
 10   CONTINUE
        ICT=ICT+1
        IF(ICT.GT.ILEN) GO TO 500
        IF(ICT.GT.LUWORD) GO TO 100
        ZBUFF(ICT:ICT)=UWORD(ICT:ICT)
      GO TO 10
C
 100  CONTINUE
      ICT=ICT-1
      ICL=0
 110  CONTINUE
        ICT=ICT+1
        IF(ICT.GT.ILEN) GO TO 500
        ICL=ICL+1
        IF(ICL.GT.NCHARC) GO TO 200
        ZBUFF(ICT:ICT)=CBUFF(ICL:ICL)
      GO TO 110
C
 200  CONTINUE
      ICT=ICT-1
      DO 210 IC=ICT+1,ILEN
        ZBUFF(IC:IC)=' '
 210  CONTINUE
      ILEN=ICT
C
 500  CONTINUE
      RETURN
      END

      subroutine ubrfi2(ilun,ichan,i2array,ilbl,inum)
C
C  read and possibly decompress an integer*2 stream
C  check that number expected = number read.
C
      use UFILES
C
C-------------------------------
C
      integer ilun                      ! i/o unit
      integer ichan                     ! ufiles channel no.
      integer*2 i2array(inum)           ! i2 data, dimensioned.
      character*(*) ilbl                ! label (for debugging)
      integer inum                      ! array dimension
C
C  local:
C
      logical ipkd
C
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(4)    ! small local buffer
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
C
C-------------------------------
C
      call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,4)
#ifdef __CRAY
      if(ilbuf(1).eq. char(0)) then
#else
      if(ilbuf(1).eq.0) then
#endif
         ipkd=.false.                   ! uncompressed data
         call ubi3dcod(ilbuf,2,ibytes2)
         if(ibytes2.ne.2*inum) then
            write(6,'('' ?ubrfi2:  uncompressed data length error'')')
            go to 999
         endif
         call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),i2array,ibytes2)
      else
         ipkd=.true.                    ! compressed data
         call ubi3dcod(ilbuf,2,iwords)
         ibytes=4*iwords
C  read:
         call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ufpack,ibytes)
C  decompress:
         call xpand2(ufpack,iwords,i2array,1,inum,ierr)
         if(ierr.ne.0) then
            write(6,1902) ilbl,ierr
 1902       format(' ?ubrfi2:  ',a,' data decompress ierr=',i2)
            go to 999
         endif
      endif
C
      go to 1000
C
 999  continue
C
 1000 continue
      return
      end

!------------------------------------------------------------------------------
!
!  SIGALL_Z -- SIGTAB GENERIC CROSS SECTION ROUTINE
!
real(fp) FUNCTION SIGALL_Z(EREL,VREL)
!
!  INPUT EREL -- ** KEV **
!                ** KEV / AMU for atomic reactions **
!  OUTPUT
!        SIGALL_Z -- M**2
!        VREL     -- M/SEC
!
!  Mod tbt Dec 1994 -- Changed Li+++>Lx Charge exchange to
!                      1.E-35 from 0.0
!  Mod tbt Oct 1994 -- Added Lithium.
!  MOD DMC DEC 1990 -- INSTALL ALADDIN INTERFACE FOR ATOMIC PHYSICS
!   CAUTION -- THE ROUTINES DOSIG,DOSIG2,DOSIG3 TAKE THE ALADDIN
!   REACTION LABELS AS ARGUMENTS, BUT DO NOT READ THE ALADDIN FILE
!   FOR REASONS OF SPEED.  THE ALADDIN FILE DATA WAS READ IN BY
!   SUBROUTINE SIGALAD.  ** THE REACTION LABELS ARE CODED IN TWO
!   PLACES:  HERE, AND IN SUBROUTINE SIGALAD **
! 
!
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod   
  use physconst_mod, only : zcmtom,zcm2tom2,zkev2ev,mp_g,zero,one,two
  use adas_mod, only : adas_sig
  IMPLICIT NONE
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) d
!============
!
!----------------------
!  THESE LOCALS STORE THE REACTION INDICES CORRESPONDING TO REACTION
!  LABELS READ IN BY SIGALAD/SIGALAD1; SET TO ZERO AND THEN COMPUTED
!  ONLY ONCE ON THE FIRST CALL FOR A GIVEN REACTION.
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER isavhcx,isavhii,isavxhhe,isavihhe,isavhecx,isavxhl,&
       isavihli,isavxhel,ilun
!============
!Q idecl:  explicitize implicit REAL declarations:
  real(fp) vrel,erel,zsig,dosig_z,sigcx_z,sigion_z,sgphex,&
       sgphei,dosig2_z,sghehi,sghecx,dosig3_z,sgheii,&
       sgplix,sgplii,sglicx,sglihi,sgliii,sigma_z,zamu
!============
! for adas calls
  real(fp), dimension(1)::erel_adas, sig_adas
  integer iErr
!
  INTEGER ISAVIHEH(2),ISAVHEII(3)
  INTEGER ISAVIHEL(2),ISAVILIH(2), ISAVILHE(3), ISAVILIL(3)
!
  DATA ISAVHCX/0/
  DATA ISAVHII/0/
  DATA ISAVXHHE/0/
  DATA ISAVIHHE/0/
  DATA ISAVIHEH/0,0/
  DATA ISAVHECX/0/
  DATA ISAVHEII/0,0,0/
  DATA ISAVXHL/0/
  DATA ISAVIHLI/0/
  DATA ISAVXHEL/0/
  DATA ISAVIHEL/0,0/
  DATA ISAVILIH/0,0/
  DATA ISAVILHE/0,0,0/
  DATA ISAVILIL/0,0,0/
  Save ISAVXHL,  ISAVIHLI, ISAVXHEL
  Save ISAVIHEL, ISAVILIH, ISAVILHE, ISAVILIL
!
!
  SAVE ISAVHCX,ISAVHII,ISAVXHHE,ISAVIHHE,ISAVIHEH,&
       ISAVHECX,ISAVHEII
!
!------------------------------------------------------------------------------
! initialize ADAS arrays
!
  Erel_adas=erel ![Kev/Amu]
  sig_adas=zero
!
  IF(KREACT.LT.0)&
       VREL=zcmtom*SQRT(two*1.6029e-12_fp*EREL*zkev2ev/mp_g)
!
  IF(KREACT.EQ.-1) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG_Z(zkev2ev*EREL,ISAVHCX,&
             'CX H [+1] H [+0] H [+0] H [+1]')
     ELSE
        ZSIG=SIGCX_Z(EREL,one)
     ENDIF
  ELSE IF(KREACT.EQ.-2) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG_Z(zkev2ev*EREL,ISAVHII,&
             'ION H [+1] H [+0] H [+1] H [+1] e')
     ELSE
        ZSIG=SIGION_Z(EREL,one)
     ENDIF
  ELSE IF(KREACT.EQ.-3) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG_Z(zkev2ev*EREL,ISAVXHHE,&
             'CX  H [+1] He [+0]  H [+0] He [+1]')
     ELSE
        ZSIG=zcm2tom2*SGPHEX(EREL*zkev2ev)
     ENDIF
  ELSE IF(KREACT.EQ.-4) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG_Z(zkev2ev*EREL,ISAVIHHE,&
             'ION H [+1] He [+0]  H [+1] He [+1] e')
     ELSE
        ZSIG=zcm2tom2*SGPHEI(EREL*zkev2ev)
     ENDIF
  ELSE IF(KREACT.EQ.-5) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG2_Z(zkev2ev*EREL,ISAVIHEH,&
             'CX  He [+2] H [+0]  He [+1] H [+1]',&
             'ION  He [+2] H [+0]  He [+2] H [+1] e')
     ELSE
        ZSIG=zcm2tom2*SGHEHI(EREL*4.0e+3_fp)  ! HELIUM ION
     ENDIF
  ELSE IF(KREACT.EQ.-6) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG_Z(zkev2ev*EREL,ISAVHECX,&
             'CX2 He [+2] He [+0] He [+0] He [+2]')
     ELSE
        ZSIG=zcm2tom2*SGHECX(EREL*4.0e+3_fp)  ! HELIUM ION
     ENDIF
  ELSE IF(KREACT.EQ.-7) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG3_Z(zkev2ev*EREL,ISAVHEII,&
             'ION  He [+2] He [+0]  He [+2] He [+1] e',&
             'ION2  He [+2] He [+0]  He [+2] He [+2] 2e',&
             'CX  He [+2] He [+0]  He [+1] He [+1]')
     ELSE
        ZSIG=zcm2tom2*SGHEII(EREL*4.0e+3_fp)  ! HELIUM ION
     ENDIF
!
! ----- Lithium Fudge  tbt ----------------------------------------------------
  ELSE IF(KREACT.EQ.-8) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG_Z(zkev2ev*EREL,ISAVXHL,&
        'CX  H [+1] Li [+0]  H [+0] Li [+1]')
     ELSE
        ZSIG=zcm2tom2*SGPLIX(EREL*zkev2ev)
     ENDIF
  ELSE IF(KREACT.EQ.-9) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG_Z(zkev2ev*EREL,ISAVIHLI,&
             'ION  H [+1] Li [+0]  H [+1] Li [+1] e')
     ELSE
        ZSIG=zcm2tom2*SGPLII(EREL*zkev2ev)
     ENDIF
  ELSE IF(KREACT.EQ.-10) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG_Z(zkev2ev*EREL,ISAVXHEL,&
             'CX2  He [+2] Li [+0]  He [+0] Li [+2]')
     ELSE
        ZSIG=zcm2tom2*SGLICX(EREL*4.0e+3_fp)  ! HELIUM ION
     ENDIF
  ELSE IF(KREACT.EQ.-11) THEN
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG2_Z(zkev2ev*EREL,ISAVIHEL,&
             'CX  He [+2] Li [+0]  He [+1] Li [+1]',&
             'ION  He [+2] Li [+0]  He [+2] Li [+1] e')
     ELSE
        ZSIG=zcm2tom2*SGLIHI(EREL*4.0e+3_fp)  ! HELIUM ION
     ENDIF
  ELSE IF(KREACT.EQ.-12) THEN    ! Lithium Fudge - use He until later
     IF(ALADFLAG) THEN            ! Li+++>H
        ZSIG=zcm2tom2*DOSIG2_Z(zkev2ev*EREL,ISAVILIH,&
             'CX  He [+2] H [+0]  He [+1] H [+1]',&
             'ION  He [+2] H [+0]  He [+2] H [+1] e')
     ELSE
        ZSIG=zcm2tom2*SGHEHI(EREL*4.0e+3_fp)  ! HELIUM ION
     ENDIF
!
     ZSIG=1.5_fp*ZSIG          ! ** scale up by 3/2 **
!
  ELSE IF(KREACT.EQ.-13) THEN      ! Lithium fudge - use He for a while
     IF(ALADFLAG) THEN
        ZSIG=zcm2tom2*DOSIG3_Z(zkev2ev*EREL,ISAVILHE,&
             'ION  He [+2] He [+0]  He [+2] He [+1] e',&
             'ION2  He [+2] He [+0]  He [+2] He [+2] 2e',&
             'CX  He [+2] He [+0]  He [+1] He [+1]')
     ELSE
        ZSIG=zcm2tom2*SGHEII(EREL*4.0e+3_fp)  ! HELIUM ION
     ENDIF
!
     ZSIG=1.5_fp*ZSIG          ! ** scale up by 3/2 **
!
  ELSE IF(KREACT.EQ.-14) THEN      ! Li+++>Li cx = 0.
     ZSIG=1.e-35_fp   ! zero gives bomb later  tbt  12/94
  ELSE IF(KREACT.EQ.-15) THEN      ! Lithium Fudge  tbt using He instead
     IF(ALADFLAG) THEN              ! Li+++>Li
        ZSIG=zcm2tom2*DOSIG3_Z(zkev2ev*EREL,ISAVILIL,&
             'ION  He [+2] He [+0]  He [+2] He [+1] e',&
             'ION2  He [+2] He [+0]  He [+2] He [+2] 2e',&
             'CX  He [+2] He [+0]  He [+1] He [+1]')
     ELSE
        ZSIG=zcm2tom2*SGLIII(EREL*4.0e+3_fp)  ! HELIUM ION
     ENDIF
!
     ZSIG=1.5_fp*ZSIG          ! ** scale up by 3/2 **
!
 
!   End Lithium ***********************************************
  ELSE IF(KREACT.EQ.-16) THEN ! H0,H+ ii ! ADAS: csIndex(2,1,1)=11
     call adas_sig(Erel_adas, 1, 1, one, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-17) THEN ! He++,H0 ii !ADAS:csIndex(2,1,2)=12
     call adas_sig(Erel_adas, 1, 1, two, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-18) THEN ! H+,He0 ii !ADAS: csIndex(2,2,1)=43
     call adas_sig(Erel_adas, 1, 2, one, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-19) THEN ! He++,He0 ii!ADAS: csIndex(2,2,2)=46
     call adas_sig(Erel_adas, 1, 2, two, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2] 
  ELSE IF(KREACT.EQ.-20) THEN ! H0,H+ cx !ADAS: csIndex(4,1,1)=1
     call adas_sig(Erel_adas, 1, 1, one, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-21) THEN ! H+,He0 cx !ADAS: csIndex(4,2,1)=1
     call adas_sig(Erel_adas, 1, 2, one, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-22) THEN  ! He++,He0 cx !ADAS: csIndex(4,2,2)=20    
     call adas_sig(Erel_adas, 1, 2, two, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-23) THEN  ! He+,He0 II !ADAS: csIndex(1,2,2)=28    
     call adas_sig(Erel_adas, 1, 2, two, 1, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-24) THEN  ! Li+3 H0 ii!ADAS:csIndex(2,1,3)=13    
     call adas_sig(Erel_adas, 1, 1, 3._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-25) THEN ! Be+4,H0 ii !ADAS:csIndex(2,1,4)=14    
     call adas_sig(Erel_adas, 1, 1, 4._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-26) THEN  ! B+5,H0 ii !ADAS:csIndex(2,1,5)=15  
     call adas_sig(Erel_adas, 1, 1, 5._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-27) THEN  ! C+6,H0 ii !ADAS:csIndex(2,1,6)=16  
     call adas_sig(Erel_adas, 1, 1, 6._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-28) THEN  ! N+7,H0 ii !ADAS:csIndex(2,1,7)=17
     call adas_sig(Erel_adas, 1, 1, 7._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-29) THEN  ! O+8,H0 ii !ADAS:csIndex(2,1,8)=18
     call adas_sig(Erel_adas, 1, 1, 8._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-30) THEN  ! F+9,H0 ii !ADAS:csIndex(2,1,9)=19
     call adas_sig(Erel_adas, 1, 1, 9._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-31) THEN ! Ne+10,H0 ii !ADAS:csIndex(2,1,10)=20
     call adas_sig(Erel_adas, 1, 1, 10._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-32) THEN ! Be+4,He0 ii!ADAS: csIndex(2,2,4)=48
     call adas_sig(Erel_adas, 1, 2, 4._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-33) THEN ! C+6,He0 ii!ADAS: csIndex(2,2,6)=50
     call adas_sig(Erel_adas, 1, 2, 6._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-34) THEN ! O+8,He0 ii!ADAS: csIndex(2,2,8)=52
     call adas_sig(Erel_adas, 1, 2, 8._fp, 2, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-35) THEN ! H0,He+2 cx !ADAS: csIndex(4,1,2)=2
     call adas_sig(Erel_adas, 1, 1, two, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-36) THEN ! H0,Li+3 cx !ADAS: csIndex(4,1,3)=3
     call adas_sig(Erel_adas, 1, 1, 3._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-37) THEN ! H0,Be+4 cx !ADAS: csIndex(4,1,4)=4
     call adas_sig(Erel_adas, 1, 1, 4._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-38) THEN ! H0,B+5 cx !ADAS: csIndex(4,1,5)=5
     call adas_sig(Erel_adas, 1, 1, 5._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-39) THEN ! H0,C+6 cx !ADAS: csIndex(4,1,6)=6
     call adas_sig(Erel_adas, 1, 1, 6._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-40) THEN ! H0,N+7 cx !ADAS: csIndex(4,1,7)=7
     call adas_sig(Erel_adas, 1, 1, 7._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-41) THEN ! H0,O+8 cx !ADAS: csIndex(4,1,8)=8
     call adas_sig(Erel_adas, 1, 1, 8._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-42) THEN ! H0,F+9 cx !ADAS: csIndex(4,1,9)=9
     call adas_sig(Erel_adas, 1, 1, 9._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-43) THEN ! H0,Ne+10 cx !ADAS: csIndex(4,1,10)=10
     call adas_sig(Erel_adas, 1, 1, 10._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-44) THEN ! Be+4,He0 cx !ADAS: csIndex(4,2,4)=21
     call adas_sig(Erel_adas, 1, 2, 4._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-45) THEN ! C+6,He0 cx !ADAS: csIndex(4,2,6)=22
     call adas_sig(Erel_adas, 1, 2, 6._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-46) THEN ! O+8,He0 cx !ADAS: csIndex(4,2,8)=23
     call adas_sig(Erel_adas, 1, 2, 8._fp, 4, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-47) THEN  ! He+,He0 non neutr. CX !ADAS: csIndex(3,2,2)=5    
     call adas_sig(Erel_adas, 1, 2, two, 3, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-48) THEN  ! H+,He0 II !ADAS: csIndex(1,2,1)=24    
     call adas_sig(Erel_adas, 1, 2, one, 1, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-49) THEN  ! Be+4,He0 II !ADAS: csIndex(1,2,4)=31    
     call adas_sig(Erel_adas, 1, 2, 4._fp, 1, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-50) THEN  ! C+6,He0 II !ADAS: csIndex(1,2,6)=34    
     call adas_sig(Erel_adas, 1, 2, 6._fp, 1, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-51) THEN  ! O+8,He0 II !ADAS: csIndex(1,2,8)=37    
     call adas_sig(Erel_adas, 1, 2, 8._fp, 1, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-52) THEN  ! Be+4,He0 CX transfer !ADAS: csIndex(3,2,4)=8    
     call adas_sig(Erel_adas, 1, 2, 4._fp, 3, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-53) THEN  ! B+5,He0 CX transfer !ADAS: csIndex(3,2,5)=11    
     call adas_sig(Erel_adas, 1, 2, 5._fp, 3, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-54) THEN  ! C+6,He0 CX transfer !ADAS: csIndex(3,2,6)=12    
     call adas_sig(Erel_adas, 1, 2, 6._fp, 3, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-55) THEN  ! N+7,He0 CX transfer !ADAS: csIndex(3,2,7)=15    
     call adas_sig(Erel_adas, 1, 2, 7._fp, 3, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-56) THEN ! O+8,He0 CX transfer !ADAS: csIndex(3,2,8)=16    
     call adas_sig(Erel_adas, 1, 2, 8._fp, 3, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-57) THEN ! Ne+10,He0 CX transfer !ADAS: csIndex(3,2,10)=19    
     call adas_sig(Erel_adas, 1, 2, 10._fp, 3, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
     
     
     
  ELSE IF(KREACT.EQ.-58) THEN ! H+,H0 ii !ADAS:csIndex(2,1,2)=12
     call adas_sig(Erel_adas, 1, 1, one, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-59) THEN ! He++,H0 ii !ADAS:csIndex(2,1,2)=12
     call adas_sig(Erel_adas, 1, 1, two, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-60) THEN  ! Li+3 H0 ii!ADAS:csIndex(2,1,3)=13    
     call adas_sig(Erel_adas, 1, 1, 3._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-61) THEN ! Be+4,H0 ii !ADAS:csIndex(2,1,4)=14    
     call adas_sig(Erel_adas, 1, 1, 4._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-62) THEN  ! B+5,H0 ii !ADAS:csIndex(2,1,5)=15  
     call adas_sig(Erel_adas, 1, 1, 5._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-63) THEN  ! C+6,H0 ii !ADAS:csIndex(2,1,6)=16  
     call adas_sig(Erel_adas, 1, 1, 6._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-64) THEN  ! N+7,H0 ii !ADAS:csIndex(2,1,7)=17
     call adas_sig(Erel_adas, 1, 1, 7._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-65) THEN  ! O+8,H0 ii !ADAS:csIndex(2,1,8)=18
     call adas_sig(Erel_adas, 1, 1, 8._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-66) THEN  ! F+9,H0 ii !ADAS:csIndex(2,1,9)=19
     call adas_sig(Erel_adas, 1, 1, 9._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-67) THEN ! Ne+10,H0 ii !ADAS:csIndex(2,1,10)=20
     call adas_sig(Erel_adas, 1, 1, 10._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-68) THEN  ! H+,He0 II !ADAS: csIndex(1,2,1)=24    
     call adas_sig(Erel_adas, 1, 2, one, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-69) THEN  ! He+,He0 II !ADAS: csIndex(1,2,2)=28    
     call adas_sig(Erel_adas, 1, 2, two, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-70) THEN  ! Be+4,He0 II !ADAS: csIndex(1,2,4)=31    
     call adas_sig(Erel_adas, 1, 2, 4._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-71) THEN  ! C+6,He0 II !ADAS: csIndex(1,2,6)=34    
     call adas_sig(Erel_adas, 1, 2, 6._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  ELSE IF(KREACT.EQ.-72) THEN  ! O+8,He0 II !ADAS: csIndex(1,2,8)=37    
     call adas_sig(Erel_adas, 1, 2, 8._fp, 5, SIG_adas, iErr)
     ZSIG=SIG_adas(1)*zcm2tom2 ![m**2]
  else
     
!  NUCLEAR REACTION, ISOTOPES ARE FIXED, ENERGIES ARE NOT /AMU
     ZSIG=SIGMA_Z(KREACT,KK,ILUN,EREL)
     ZAMU=1.073559e-6_fp*AMASS2 ! BEAM PTCL MASS IN AMU
     VREL=zcmtom*SQRT(two*1.6029e-12_fp*EREL*zkev2ev/(ZAMU*mp_g))
  ENDIF
!
      
  SIGALL_Z=ZSIG
!
  RETURN
END FUNCTION SIGALL_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok

C******************** START FILE UCHKOP.FOR ; GROUP URDUTS ******************
C----------------------------------------------------------
C
C& UCHKOP   UREAD CHECK OPCODE, GENERATE ERROR MESSAGE IF BAD
C
      SUBROUTINE UCHKOP(IOPCOD,IERCOD,ILIML,ILIMH,ICTL,*)
C
      USE USERIO
C
      IF((IERCOD.EQ.0).AND.(IOPCOD.GE.ILIML).AND.(IOPCOD.LE.ILIMH))
     >     RETURN
      CALL UERMSG('% ILLEGAL OPCODE',' ',ICTL)
      RETURN 1
      END
C******************** END FILE UCHKOP.FOR ; GROUP URDUTS ******************

!
! compute various flux surface parameters derived from the position of 
! the flux surface on the R,Z grid
!
! the midplane intercepts are defined as the major radiaus at the height of the
! centroid of the flux surface.
!
! notes from gelong:
!c
!c> Date: Wed, 22 Sep 1999 11:59:40 -0400
!c> From: Glenn Bateman <bateman@fusion.physics.lehigh.edu>
!c> 	Consider a toroidal magnetic surface (also called a flux surface).
!c> Use the following variables
!c>
!c> R_out   = major radius to the outboard edge of the flux surface
!c>           that is, the largest value of major radius anywhere on the surface
!c> R_in    = major radius to the inboard edge (ie, smallest value of major
!c> radius)
!c> R_top   = major radius to the top edge of the flux surface
!c>           that is, to the highest point on the flux surface cross section
!c> R_bottom = major radius to the lowest point on the flux surface
!c> height  = distance between the elevations of the highest point
!c>           and the lowest point
!c> R_dent_in  = major radius to the most indented inboard part of the surface
!c>           in cases where the flux surface is bean shaped
!c>           with a dent on the inboard edge
!c>           Note: R_dent_in = R_in whenever the flux surface is not indented
!c> R_dent_out = major radius to the most indented outboard part of the surface
!c>
!c> r_minor = half width = (R_out - R_in ) / 2     (usually called minor radius)
!c> r_major = ( R_out + R_in ) / 2                 (usually called major radius)
!c>
!c> elongation:	kappa = height / ( R_out - R_in )
!c>
!c> tiangularity:	delta = ( r_major - min ( R_top, R_bottom ) ) / r_minor
!c>
!c> indentation:	indent = max ( ( R_dent_in - R_in ) / rminor ,
!c> 			       ( R_dent_out - R_out ) / rminor )
!c>
!c> 	Note: for normal convex surfaces, indent = 0.0
!c> For bean-shaped surfaces with indentation on the inboard edge, indent > 0
!c> For bean-shaped surfaces with indentation on the outboard edge, indent < 0
!c>
!c> 	For surfaces with the point of the triangle facing outward,
!c> delta > 0.0, while if the triangle points inward, delta < 0.0
!c>
!c> 	For vertically elongated surfaces, kappa > 1.0
!c> For horizontally elongated surfaces, kappa < 1.0.
!c>
!c> squareness based on Holcomb Phys. Plasmas 16, 056116 (2009), see fig. 1
!c>
!c> Z_rmax = elevation where R==R_out
!c>
!c> Gyro squareness attempts to match the GYRO moment representation
!c>
!c>    R = Rmajor + Rminor*cos(theta + asin(triang)sin(theta))
!c>    Z = Zrmax  + elong*Rminor*sin(theta + square*sin(2*theta))
!c>
!c> by finding the point Rmk = R(pi/4.), interpolating from the boundary
!c> data to Zmk and then using the moment representation at Z(pi/4.) to
!c> derive the squareness.
!c>
!c>
!c>
!
subroutine surfgeo(itheta, ivec, ar, az, &
     elong, triang, indent, zmidp, rmnmidp, rmjmidp, nlim, limits, &
     idebug, mline, ier)

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, one, two, twopi, pio4
  implicit none

  integer, intent(in) :: itheta           ! number of poloidal points, first and last R,Z points in theta must be the same
  integer, intent(in) :: ivec             ! number of radial points
  real(fp),  intent(in) :: ar(itheta, ivec) ! R(theta,rho)
  real(fp),  intent(in) :: az(itheta, ivec) ! Z(theta,rho)

  real(fp),  intent(out) :: elong(ivec)    ! surface elongation
  real(fp),  intent(out) :: triang(ivec)   ! triangularity
  real(fp),  intent(out) :: indent(ivec)   ! indentation

  real(fp),  intent(out) :: zmidp (ivec)   ! height of flux surface centroid
  real(fp),  intent(out) :: rmnmidp(ivec)  ! inner midplane intercept at centroid height
  real(fp),  intent(out) :: rmjmidp(ivec)  ! outer midplane intercept at centroid height

  integer, intent(in)  :: nlim              ! number of limits to return
  real(fp),  intent(out) :: limits(nlim,ivec) ! surface limits used for elong,triang,indent
  ! 1  -> R_in
  ! 2  -> R_out
  ! 3  -> R_top
  ! 4  -> Z_top
  ! 5  -> R_bottom
  ! 6  -> Z_bottom
  ! 7  -> R_dent_in
  ! 8  -> R_dent_out
  ! 9  -> R_centroid
  ! 10 -> Z_centroid
  ! 11 -> lower Holcomb squareness
  ! 12 -> upper Holcomb squareness
  ! 13 -> Z_rmax
  ! 14 -> Rmk_lowo
  ! 15 -> Zmk_lowo
  ! 16 -> lower outer Gyro squareness
  ! 17 -> Rmk_uppo
  ! 18 -> Zmk_uppo
  ! 19 -> upper outer Gyro squareness
  ! 20 -> Rmk_lowi
  ! 21 -> Zmk_lowi
  ! 22 -> lower inner Gyro squareness
  ! 23 -> Rmk_uppi
  ! 24 -> Zmk_uppi
  ! 25 -> upper inner Gyro squareness

  logical,          intent(in)  :: idebug ! .true. for some debug output
  character(len=*), intent(out) :: mline  ! error message
  integer,          intent(out) :: ier    ! nonzero on error

  real(fp),  parameter :: RMINAXIS   = 1.e-6_fp   ! threshold of zrminor/zrmajor for an axis surface

  real(fp),  allocatable :: zr(:),zz(:)

  integer :: kaxis       ! index of last surface which is axis like
  integer :: i,ipt,k,iv  ! loop variable
  integer :: mlim        ! number of limits to return

  real(fp)  :: zrcentr, zzcentr     ! centroid
  real(fp)  :: tr,tz,trp,tzp        ! points in centroid loop
  real(fp)  :: zytest               ! >0 when segment spans midplane
  real(fp)  :: zrans                ! radius at midplane crossing
  real(fp)  :: zrmin,zrmax          ! limits of R around surface
  real(fp)  :: zymin,zymax          ! limits of Z around surface
  real(fp)  :: zrymin, zrymax       ! R values at Z limits
  real(fp)  :: zrminor, zrmajor     ! estimate from R major limits
  real(fp)  :: zyrmax               ! Y value at Rmax limit
  real(fp)  :: zra(3),zya(3)        ! three points around target
  real(fp)  :: xlimits(25)          ! actual limits on a single surface
  real(fp)  :: zzR0,zzAR,zzBR,zzY0  ! temps
  real(fp)  :: zzAY,zzBY,zx,zrx,zyx ! temps
  real(fp)  :: zryx,zyrx,z          ! temps

  logical :: o_bound                   ! temporary
  logical :: o_inside, o_outside       ! .true. if tm,tp bound the inboard and outboard sides
  real(fp)  :: tm,tp                     ! theta indices bounding top and bottom
  real(fp)  :: tymin,tymax,trmin,trmax   ! normalized theta indices where limits are achieved
  integer :: iext(2)                   ! number of mimnimum and maximum extremum
  real(fp), allocatable :: text(:,:)     ! normalized theta indices of min,max extremums  (2,itheta)
  real(fp), allocatable :: rext(:,:)     ! min,max extremums (2,itheta)
  real(fp)  :: zrindent_in, zrindent_out ! indetation on inboard and outboard side
  real(fp)  :: zt                        ! normalized theta index

  integer :: ith                ! number of previous points encountered

  real(fp) :: sqlow, squpp        ! lower and upper squareness
  real(fp) :: th0, th, thp        ! target angle, and angle of current and prvious points
  real(fp) :: a,b,ak,bk,ap,bp     ! R,Z of enclosing rectangle and current and previous points relative to ellipse center
  real(fp) :: asq, bsq            ! a,b interpolated to th0
  real(fp) :: ab,ad,ac,cd         ! see Hocomb, fig 1.

  integer :: imk                ! index closest to Gyro R squareness
  integer :: i0,i1,i2           ! closest indices to Millelsen R
  integer :: ii,jj              ! temp
  integer :: i47,i48            ! I/O units, if idebug=.TRUE.

  integer, parameter :: nsamp = 10 ! for debugging, surface sample #

  integer :: indxn(nsamp)         ! Surface indices for debug output
  real(fp) ::  rhoxn(nsamp)         ! Corresponding rho values

  real(fp) :: sqmk_low, sqmk_upp  ! Gyro lower and upper outer squareness
  real(fp) :: sqmk_lowi,sqmk_uppi ! Gyro lower and upper inner squareness
  real(fp) :: klow, kupp          ! lower and upper elongation
  real(fp) :: dlow, dupp          ! lower and upper triangularity
  real(fp) :: rmklow, rmkupp      ! value of R at pi/4 of moment representation
  real(fp) :: zmklow, zmkupp      ! value of Z corresponding to rmklow, rmkupp
  real(fp) :: rmklowi, rmkuppi    ! value of R at 3*pi/4 of moment representation
  real(fp) :: zmklowi, zmkuppi    ! value of Z corresponding to rmklowi, rmkuppi

  real(fp) :: zsq

  !---------------------------------------------
  ! allocate temporary storage
  !
  ier   = 0
  mline = " "

  if (itheta<3) then
    mline = "?surfgeo: not enough theta points"
    ier=1 ; return
  end if

  ! debug output setup
  if(idebug) then
    call find_io_unit_list(2,indxn(1:2))
    i47=indxn(1)
    i48=indxn(2)
    if(ivec.gt.nsamp) then
      open(unit=i48,file='eq_RZout.dat',status='replace')
      write(i48,*) '#  Ntheta, Nsurf'
      write(i48,'(1x,2i6)') itheta,nsamp
      write(i48,*) '#  No., Orig. Index, rho value (est.)'
      do ii=1,nsamp
        indxn(ii) = ((ivec-1)*ii)/nsamp + 1
        rhoxn(ii) = ((indxn(ii)-1)*one)/(ivec-1)
        write(i48,'(1x,2i6,1x,f6.3)') ii,indxn(ii),rhoxn(ii)
      enddo
      write(i48,*) '#  iTheta, iSurf, Rgyro, Zgyro, Rorig, Zorig'
    endif
  endif

  allocate(zr(itheta), zz(itheta))
  allocate(text(2,itheta),rext(2,itheta))

  mlim   = min(nlim, size(xlimits))
  limits = zero     ! make sure all elements are set
  kaxis  = 0

  !
  ! all exits through 999
  !

  jj=1  ! for debug sampling

  do iv = 1, ivec    ! loop over surfaces
    zr = ar(:,iv)
    zz = az(:,iv)

    if (max(abs(zr(itheta)-zr(1)),abs(zz(itheta)-zz(1)))>1.e-10_fp*max(1.e-6_fp,maxval(zr))) then
      mline = "?surfgeo: R,Z surfaces are not closed"
      ier=1 ; goto 999
    end if

    zr(itheta) = zr(1)   ! i=itheta is the same point as i=1
    zz(itheta) = zz(1)

    !
    ! --- centroid ---
    !
    call r8_plcentr(zr, zz, itheta, zrcentr, zzcentr)

    zmidp(iv) = zzcentr

    !
    ! snatched from r8_getmpa
    ! find approximate midplane intercept locations
    !
    rmnmidp(iv)=zrcentr  ! in case at magnetic axis
    rmjmidp(iv)=zrcentr
    tr=zr(1)
    tz=zz(1)
    zx=1.e-8_fp*abs(zrcentr) ! really small

    do i=2,itheta
      trp=tr
      tzp=tz
      tr=zr(i)
      tz=zz(i)

      zytest=(tz-zzcentr)*(zzcentr-tzp)
      if(zytest.ge.zero) then
        if (abs(tz-tzp)>zx) then
          zrans=(tr*(zzcentr-tzp)+trp*(tz-zzcentr))/(tz-tzp)  ! linear interpolation
          if(zrans.gt.zrcentr) then
            rmjmidp(iv)=zrans
          else
            rmnmidp(iv)=zrans
          endif
        end if
      endif
    enddo

    !
    ! --- elongation,triangulation,indentation,limits ---
    ! snatched from gelong
    !
    zrmin=zr(1)
    zrmax=zr(1)
    zymin=zz(1)
    zymax=zz(1)
    zrymin=zr(1)
    zrymax=zr(1)
    zyrmax=zz(1)

    !
    ! the 't' indices are the floating point equivalent of 'i' going from 0 to itheta-1
    ! on the surface.  The 't' domain is [0.,itheta-1) and theta=2.*pi*t/(itheta-1).
    !
    tymin=zero
    tymax=zero
    trmin=zero
    trmax=zero
    iext=0
    ipt=1
    do i=-1,itheta-1                     ! i=0,i=itheta-1  corresponds to theta=0.
      k = mod(i+itheta-1,itheta-1)      ! i restricted to the range [0,itheta-2]
      tr = zr(k+1)
      tz = zz(k+1)

      if (tr<zrmin) then
        zrmin=tr
        trmin=k
      end if
      if (tr>zrmax) then
        zrmax=tr
        zyrmax=tz
        trmax=k
      end if
      if(tz.lt.zymin) then
        zymin=tz
        zrymin=tr
        tymin=k
      endif
      if(tz.gt.zymax) then
        zymax=tz
        zrymax=tr
        tymax=k
      endif

      if(i.le.0) then
        ipt=ipt+1
        zra(ipt)=tr                 ! ipt=2, then 3, ...
        zya(ipt)=tz
      else
        zra(1)=zra(2)               ! i=1 is first real point
        zra(2)=zra(3)
        zra(3)=tr
        zya(1)=zya(2)
        zya(2)=zya(3)
        zya(3)=tz
        !        
        !  parabolic fitting of 3 pt sequence to improve estimate of min,max.
        !
        zzR0=zra(2)
        zzAR=(zra(3)-zra(1))*half
        zzBR=(zra(3)+zra(1))*half-zzR0

        zzY0=zya(2)
        zzAY=(zya(3)-zya(1))*half
        zzBY=(zya(3)+zya(1))*half-zzY0

        if((zra(2).ge.max(zra(1),zra(3))).and. &
             (zra(2).gt.1.000001_fp*min(zra(1),zra(3)))) then
          zx=-zzAR/(two*zzBR)
          zrx=zzR0+zx*(zzAr+ zx*zzBR)
          zyrx=zzY0+zx*(zzAy+ zx*zzBY)
          zt=k+zx-1
          if (zrx>ZRMAX) then
            ZRMAX=zrx
            ZYRMAX=zyrx
            trmax=zt
          end if

          iext(2) = iext(2)+1    ! store this R maximum
          text(2,iext(2))=zt
          rext(2,iext(2))=zrx
        endif

        if((zra(2).le.min(zra(1),zra(3))).and. &
             (zra(2).lt.0.999999_fp*max(zra(1),zra(3)))) then
          zx=-zzAR/(two*zzBR)
          zrx=zzR0+zx*(zzAr+ zx*zzBR)
          zt=k+zx-1
          if (zrx<ZRMIN) then
            ZRMIN=zrx
            trmin=zt
          end if

          iext(1) = iext(1)+1    ! store this R minimum
          text(1,iext(1))=zt
          rext(1,iext(1))=zrx
        endif

        if((zya(2).ge.max(zya(1),zya(3))).and. &
             (zya(2).gt.1.000001_fp*min(zya(1),zya(3)))) then
          zx=-zzAY/(two*zzBY)
          zyx=zzY0+zx*(zzAy+ zx*zzBY)
          zryx=zzR0+zx*(zzAr+ zx*zzBR)
          zt=k+zx-1
          if(zyx.gt.ZYMAX) then
            ZYMAX=zyx
            ZRYMAX=zryx
            tymax=zt
          endif
        endif

        if((zya(2).le.min(zya(1),zya(3))).and. &
             (zya(2).lt.0.999999_fp*max(zya(1),zya(3)))) then
          zx=-zzAY/(two*zzBY)
          zyx=zzY0+zx*(zzAy+ zx*zzBY)
          zryx=zzR0+zx*(zzAr+ zx*zzBR)
          zt=k+zx-1
          if(zyx.lt.ZYMIN) then
            ZYMIN=zyx
            ZRYMIN=zryx
            tymin=zt
          endif
        endif

      endif
    enddo
    !
    !  elongation
    !
    elong(iv) = (zymax-zymin)/max(zrmax-zrmin, 1.e-30_fp)

    !
    ! triangularity
    !
    zrmajor=half*(zrmin+zrmax)
    zrminor=max(half*(zrmax-zrmin), 1.e-30_fp)

    if (zrminor<RMINAXIS*zrmajor) kaxis=iv

    triang(iv) = (zrmajor-min(zrymin,zrymax))/zrminor
    !ztriangU=(zrmajor-zrymax)/zrminor
    !ztriangL=(zrmajor-zrymin)/zrminor

    !
    ! indentation
    !
    zrindent_in  = zrmin   ! defaults will give zero indentation
    zrindent_out = zrmax
    trmin=tnorm(trmin)
    trmax=tnorm(trmax)
    tymin=tnorm(tymin)
    tymax=tnorm(tymax)
    if (tymin/=tymax) then
      tm = min(tymin,tymax)  ! define interval between top and bottom
      tp = max(tymin,tymax)

      o_bound   = (tm==trmin .or. tp==trmin .or. tm==trmax .or. tp==trmax)
      o_inside  = (tm<trmin .and. trmin<tp)  ! true if tm,tp bounds inboard side
      o_outside = (tm<trmax .and. trmax<tp)  ! true if tm,tp bounds outboard side

      if ((o_inside .neqv. o_outside) .and. (.not. o_bound)) then
        ! there is sufficient separation of points to evaluate indentation
        do i = 1, iext(1)                  ! loop over minimum extremums
          zt = tnorm(text(1,i))           ! index at extremum
          if (zt==tm .or. zt==tp) cycle   ! skip if near the top or bottom
          o_bound = (tm<zt .and. zt<tp)   ! .true. if within tm,tp limits
          if (o_bound .eqv. o_outside) then
            zrindent_out = min(zrindent_out, rext(1,i))
          end if
        end do
        do i = 1, iext(2)                  ! loop over maximum extremums
          zt = tnorm(text(2,i))           ! index at extremum
          if (zt==tm .or. zt==tp) cycle   ! skip if near the top or bottom
          o_bound = (tm<zt .and. zt<tp)   ! .true. if within tm,tp limits
          if (o_bound .eqv. o_inside) then
            zrindent_in = max(zrindent_in, rext(2,i))
          end if
        end do
      end if
    end if

    indent(iv) = max ( (zrindent_in-zrmin)/zrminor, (zrindent_out-zrmax)/zrminor )

    !
    ! -- upper squareness --
    !
    squpp     = zero
    sqmk_upp  = zero
    sqmk_uppi = zero

    a = zrmax - zrymax
    b = zymax - zyrmax

    kupp = b/max(zrminor, 1.e-30_fp)
    dupp = min(one, max(-one,(zrmajor-zrymax)/max(zrminor, 1.e-30_fp)))

    th0 = atan2(b,a)

    ith = 0
    do k=-1, itheta
      i = k + int(trmax+half) - 2
      i = mod(i+itheta-1,itheta-1) + 1   ! [1,itheta-1]

      if (ith>0) then
        ap  = ak
        bp  = bk
        thp = th
      end if

      ak = zr(i)-zrymax
      bk = zz(i)-zyrmax

      if (ak<=zero) then
        ith=0 ; cycle
      end if

      th  = atan2(bk,ak)
      ith = ith+1

      if (ith>1 .and. th0>=thp .and. th0<=th .and. th>thp) then
        z = (th0-thp)/(th-thp)

        asq = ap + z*(ak-ap)
        bsq = bp + z*(bk-bp)

        ab = sqrt(asq**2+bsq**2)
        ad = sqrt(a**2+b**2)
        ac = ad/sqrt(two)
        cd = ad-ac
        squpp = (ab-ac)/cd
        exit
      end if
    end do

    ! -- upper outer gyro squareness --
    rmkupp = zrmajor + zrminor*cos(pio4 + asin(dupp)/sqrt(two))
    zmkupp = zero

    imk = 1
    do i= 1, itheta-1
      if (zz(i)<zyrmax .or. zr(i)<zrymax) cycle        ! outside ellipse quadrant
      if (abs(zr(i)-rmkupp)<abs(zr(imk)-rmkupp)) imk=i
    end do

    i0 = mod(imk-1 +itheta-2,itheta-1) + 1
    i1 = mod(imk   +itheta-2,itheta-1) + 1
    i2 = mod(imk+1 +itheta-2,itheta-1) + 1

    !if (iv>1 .and. iv==ivec) then
    !   print *, 'at upp ivec'
    !end if

    if (rmkupp>=zr(i2) .and. rmkupp<=zr(i0)) then  ! only do this if in bounds
      call zsolve(rmkupp, zmkupp, ii)
      if (ii==0) then
        a = (zmkupp-zyrmax)/max(kupp*zrminor,1.e-30_fp)
        if (abs(a)<=one) then
          sqmk_upp = asin(a)-pio4
        end if
      end if
    end if

    ! -- upper inner gyro squareness --
    rmkuppi = zrmajor + zrminor*cos(3.0_fp*pio4 + asin(dupp)/sqrt(two))
    zmkuppi = zero

    imk = 1
    do i= 1, itheta-1
      if (zz(i)<zyrmax .or. zr(i)>zrymax) cycle        ! outside ellipse quadrant
      if (abs(zr(i)-rmkuppi)<abs(zr(imk)-rmkuppi)) imk=i
    end do

    i0 = mod(imk-1 +itheta-2,itheta-1) + 1
    i1 = mod(imk   +itheta-2,itheta-1) + 1
    i2 = mod(imk+1 +itheta-2,itheta-1) + 1

    !if (iv>1 .and. iv==ivec) then
    !   print *, 'at upp ivec'
    !end if

    if (rmkuppi>=zr(i2) .and. rmkuppi<=zr(i0)) then  ! only do this if in bounds
      call zsolve(rmkuppi, zmkuppi, ii)
      if (ii==0) then
        a = (zmkuppi-zyrmax)/max(kupp*zrminor,1.e-30_fp)
        if (abs(a)<=one) then
          sqmk_uppi = asin(a)-pio4
        end if
      end if
    end if

    !
    ! -- lower squareness --
    !
    sqlow     = zero
    sqmk_low  = zero
    sqmk_lowi = zero

    a = zrmax - zrymin
    b = zymin - zyrmax  ! <0

    klow = -b/max(zrminor, 1.e-30_fp)
    dlow = min(one, max(-one,(zrmajor-zrymin)/max(zrminor, 1.e-30_fp)))

    th0 = atan2(b,a)

    ith = 0
    do k=-1, itheta
      i = -k + int(trmax+half)
      i = mod(i+2*itheta-2,itheta-1) + 1   ! [1,itheta-1]

      if (ith>0) then
        ap  = ak
        bp  = bk
        thp = th
      end if

      ak = zr(i)-zrymin
      bk = zz(i)-zyrmax

      if (ak<=zero) then
        ith=0 ; cycle
      end if

      th  = atan2(bk,ak)
      ith = ith+1

      if (ith>1 .and. th0<=thp .and. th0>=th .and. th<thp) then
        z = (th0-thp)/(th-thp)

        asq = ap + z*(ak-ap)
        bsq = bp + z*(bk-bp)

        ab = sqrt(asq**2+bsq*bsq)
        ad = sqrt(a**2+b*b)
        ac = ad/sqrt(two)
        cd = ad-ac
        sqlow = (ab-ac)/cd
        exit
      end if
    end do

    ! -- lower outer gyro squareness --
    rmklow = zrmajor + zrminor*cos(-pio4 - asin(dlow)/sqrt(two))
    zmklow = zero

    imk = 1
    do i= 1, itheta-1
      if (zz(i)>zyrmax .or. zr(i)<zrymin) cycle        ! outside ellipse quadrant
      if (abs(zr(i)-rmklow)<abs(zr(imk)-rmklow)) imk=i
    end do

    i0 = mod(imk-1 +itheta-2,itheta-1) + 1
    i1 = mod(imk   +itheta-2,itheta-1) + 1
    i2 = mod(imk+1 +itheta-2,itheta-1) + 1

    !if (iv>1 .and. iv==ivec) then
    !   print *, 'at low ivec'
    !end if

    if (rmklow>=zr(i0) .and. rmklow<=zr(i2)) then  ! only do this if in bounds
      call zsolve(rmklow, zmklow, ii)
      if (ii==0) then
        a = (zmklow-zyrmax)/max(klow*zrminor,1.e-30_fp)
        if (abs(a)<=one) then
          sqmk_low = -asin(a)-pio4
        end if
      end if
    end if

    ! -- lower inner gyro squareness ---
    rmklowi = zrmajor + zrminor*cos(-3.0_fp*pio4 - asin(dlow)/sqrt(two))
    zmklowi = zero

    imk = 1
    do i= 1, itheta-1
      if (zz(i)>zyrmax .or. zr(i)>zrymin) cycle        ! outside ellipse quadrant
      if (abs(zr(i)-rmklowi)<abs(zr(imk)-rmklowi)) imk=i
    end do

    i0 = mod(imk-1 +itheta-2,itheta-1) + 1
    i1 = mod(imk   +itheta-2,itheta-1) + 1
    i2 = mod(imk+1 +itheta-2,itheta-1) + 1

    !if (iv>1 .and. iv==ivec) then
    !   print *, 'at low ivec'
    !end if

    if (rmklowi>=zr(i0) .and. rmklowi<=zr(i2)) then  ! only do this if in bounds
      call zsolve(rmklowi, zmklowi, ii)
      if (ii==0) then
        a = (zmklowi-zyrmax)/max(klow*zrminor,1.e-30_fp)
        if (abs(a)<=one) then
          sqmk_lowi = -asin(a)-pio4
        end if
      end if
    end if

    !
    ! limits
    !
    xlimits = (/zrmin,    zrmax,       zrymax,       zymax,    zrymin,  &
         zymin,    zrindent_in, zrindent_out, zrcentr,  zzcentr, &
         sqlow,    squpp,       zyrmax,       rmklow,   zmklow,  &
         sqmk_low, rmkupp,      zmkupp,       sqmk_upp, rmklowi, &
         zmklowi,  sqmk_lowi,   rmkuppi,      zmkuppi,  sqmk_uppi /)

    limits(1:mlim,iv) = xlimits(1:mlim)

    if (idebug .and. iv>1 .and. iv==ivec) then
      !
      !plot 'eq_bdy.dat' using 3:4 with lines title 'bdy points', 'eq_mom.dat' using 3:4 with lines title 'moments', \
      !'eq_pts.dat' index 0 with points title 'R0,Z0', '' index 1 with points title 'upper pi/4', '' index 2 with points title 'lower pi/4'
      !
      write(6,*) ' **surgeo.f90** debug output files:'
      write(6,*) '   eq_bdy.dat, eq_mom.dat, eq_pts.dat, eq_RZout.dat'
      call find_io_unit(i47)
      open(unit=i47, file="eq_bdy.dat", status="replace")

      do i=1, itheta
        if (zz(i)>=zyrmax) then
          ak = zr(i)-zrymax
          bk = zz(i)-zyrmax
        else
          ak = zr(i)-zrymin
          bk = zz(i)-zyrmax
        end if

        th = atan2(bk,ak)

        write(i47,'(i5,3(1x,es14.6))') i, th, zr(i), zz(i)
      end do
      close(i47)

      open(unit=i47, file="eq_mom.dat", status="replace")

      do i=1, itheta
        th0 = twopi*(i-1)/real(itheta-1,fp)

        if (th0<=twopi/two) then
          ak = zrmajor + zrminor*cos(th0 + asin(dupp)*sin(th0))
          bk = zyrmax  + kupp*zrminor*sin(th0 + sqmk_upp*sin(two*th0))
        else
          ak = zrmajor + zrminor*cos(th0 + asin(dlow)*sin(th0))
          bk = zyrmax  + klow*zrminor*sin(th0 + sqmk_low*sin(two*th0))
        end if

        th = atan2(bk,ak)

        write(i47,'(i5,4(1x,es14.6))') i, th, ak, bk, th0
      end do
      close(i47)

      open(unit=i47, file="eq_pts.dat", status="replace")
      write(i47,'(2(1x,es14.6)//)') zrmajor, zyrmax
      write(i47,'(2(1x,es14.6)//)') rmkupp, zmkupp
      write(i47,'(2(1x,es14.6)//)') rmklow, zmklow
      close(i47)
    end if

    if(idebug.AND.(indxn(jj).eq.iv)) then

      do i=1, itheta
        th0 = twopi*(i-1)/real(itheta-1,fp)

        zsq = half*(sqmk_upp+sqmk_low)

        ak = zrmajor + zrminor*cos(th0 + asin(triang(iv))*sin(th0))
        bk = zyrmax  + elong(iv)*zrminor*sin(th0 + zsq*sin(two*th0))

        write(i48,'(1x,2i6,4(1x,1pe14.7))') i,jj,ak,bk,zr(i),zz(i)
      enddo

      jj=min(nsamp,jj+1)
    endif
  end do

  if (kaxis>0 .and. kaxis<ivec) then   ! replace metrics which have no meaning at the axis
    elong(1:kaxis)  = elong(kaxis+1)
    triang(1:kaxis) = triang(kaxis+1)
    indent(1:kaxis) = indent(kaxis+1)

    if (nlim>=11) limits(11,1:kaxis) = limits(11,kaxis+1)
    if (nlim>=12) limits(12,1:kaxis) = limits(12,kaxis+1)
    if (nlim>=16) limits(16,1:kaxis) = limits(16,kaxis+1)
    if (nlim>=19) limits(19,1:kaxis) = limits(19,kaxis+1)
    if (nlim>=22) limits(22,1:kaxis) = limits(22,kaxis+1)
    if (nlim>=25) limits(25,1:kaxis) = limits(25,kaxis+1)
  end if

  !
  ! exit after allocation
  !
999 continue
  deallocate(zr,zz)
  deallocate(text,rext)

  if(idebug) then
    close(unit=i48)
  endif

contains
  !
  ! restrict the argument to the range [0,itheta-1)
  !
  function tnorm(x) result(t)
    real(fp), intent(in) :: x    ! normalized theta index
    real(fp) :: t                ! restricted domain
    real(fp) :: p                ! itheta-1
    p = itheta-1
    t = x
    do while (t<zero)
      t = t+p
    end do

    do while (t>=p)
      t = t-p
    end do
  end function tnorm

  !
  ! given indices i0,i1,i2 and target rtar, return the corrsponding ztar
  ! which is on the quadratic curve through i0,i1,i2 of zr(),zz().  Based
  ! on interpolation over angle from (Rmajor, Zrmax).
  !
  subroutine zsolve(rtar, ztar, ii)
    real(fp),  intent(in)  :: rtar     ! target R
    real(fp),  intent(out) :: ztar     ! returned Z
    integer, intent(out) :: ii       ! nonzero on error

    real(fp) :: r0,r1,r2   ! R at i0,i1,i2 relative to Rmajor
    real(fp) :: z0,z1,z2   ! Z at i0,i1,i2 relative to Z at Rmax
    real(fp) :: d0,d1,d2   ! theta at i0,i1,i2
    real(fp) :: rt         ! Rtar relative to Rmajor

    real(fp) :: del1,del2         ! (theta1-theta0), (theta2-theta0)
    real(fp) :: d                 ! temp
    real(fp) :: m11,m12,m21, m22  ! inverse matrix

    real(fp) :: ar,br,az,bz       ! quadratic coefficients for R,Z equation
    real(fp) :: da,db             ! del solutions

    ii=0

    r0 = zr(i0)-zrmajor ; z0 = zz(i0)-zyrmax ; d0 = btan2(z0,r0)
    r1 = zr(i1)-zrmajor ; z1 = zz(i1)-zyrmax ; d1 = btan2(z1,r1)
    r2 = zr(i2)-zrmajor ; z2 = zz(i2)-zyrmax ; d2 = btan2(z2,r2)
    rt = rtar-zrmajor

    del1 = d1-d0
    del2 = d2-d0

    d = del1*del2*(del1-del2)

    if (d==zero) goto 100

    m11 =  del2/d
    m12 = -del1/d
    m21 = -del2*del2/d
    m22 =  del1*del1/d

    ar = m11*(r1-r0) + m12*(r2-r0)
    br = m21*(r1-r0) + m22*(r2-r0)

    az = m11*(z1-z0) + m12*(z2-z0)
    bz = m21*(z1-z0) + m22*(z2-z0)

    d = br*br-4.0_fp*ar*(r0-rt)

    if (d<zero .or. ar==zero) goto 100

    d = sqrt(d)

    da = (-br + d)/(two*ar)
    db = (-br - d)/(two*ar)

    if (abs(db-del1)<abs(da-del1)) da=db

    ztar = da*(da*az+bz) + z0 + zyrmax

    return

100 continue
    ii=1
  end subroutine zsolve

  function btan2(z,r) result(b)
    real(fp), intent(in) :: z,r
    real(fp) :: b

    if (z==zero .and. r==zero) then
      b = zero
    else
      b = atan2(z,r)
    end if
  end function btan2
end subroutine surfgeo

real(fp) function get_j_from_jdotb(rbt,r2iav,b2av,riav,jdotb)
  !
  !  in axisymmetric toroidal system...
  !  convert from <j dot B> to <Jt>a
  !
  !     toroidal current = sum [ dArea * <Jt>a ]
  !
  !     < > means differential volume average over flux surface
  !     < >a means differential area average over flux surface
  !
  !  <Jt>a = <Jt/R>/<1/R> = (R*Bt)*<1/R**2>/(<B**2><1/R>) * <j dot B>
  !
  !  this routine is 0d -- does just one point location.
  !
  !  user's choice of units (but be consistent)
 
  use iso_c_binding, only: fp => c_double
  implicit none
 
  real(fp), intent(in) ::  rbt           ! R*Bt, e.g. Tesla*meter
  real(fp), intent(in) ::  r2iav         ! <1/R**2>, e.g. meter**-2
  real(fp), intent(in) ::  b2av          ! <B**2>, e.g. Tesla**2
  real(fp), intent(in) ::  riav          ! <1/R>, e.g. meter**-1
 
  real(fp), intent(in) ::  jdotb         ! <j dot B>, e.g. Tesla * Amps/meter**2
 
  !  output (function value):  <Jt>a (same units as j in jdotb)
  !------------------------------------------------------------
 
  get_j_from_jdotb = jdotb * (rbt*r2iav)/(b2av*riav)
 
  !------------------------------------------------------------
 
end function get_j_from_jdotb
 
real(fp) function get_jdotb_from_j(rbt,r2iav,b2av,riav,jta)

  !
  !  in axisymmetric toroidal system...
  !  convert from <j dot B> to <Jt>a
  !
  !     toroidal current = sum [ dArea * <Jt>a ]
  !
  !     < > means differential volume average over flux surface
  !     < >a means differential area average over flux surface
  !
  !  <Jt>a = <Jt/R>/<1/R> = (R*Bt)*<1/R**2>/(<B**2><1/R>) * <j dot B>
  !
  !  this routine is 0d -- does just one point location.
  !
  !  user's choice of units (but be consistent)

  use iso_c_binding, only: fp => c_double
  implicit none

  real(fp), intent(in) ::  rbt           ! R*Bt, e.g. Tesla*meter
  real(fp), intent(in) ::  r2iav         ! <1/R**2>, e.g. meter**-2
  real(fp), intent(in) ::  b2av          ! <B**2>, e.g. Tesla**2
  real(fp), intent(in) ::  riav          ! <1/R>, e.g. meter**-1

  real(fp), intent(in) ::  jta           ! <Jt>a, e.g. Amps/meter**2

  !  output (function value):  <J dot B>  ! units derived from above
  !------------------------------------------------------------

  get_jdotb_from_j = jta * (b2av*riav)/(rbt*r2iav)

  !------------------------------------------------------------

end function get_jdotb_from_j

!******************** START FILE FLIN1_Z.FOR ; GROUP SIGS2 ********************
!==============================================================================
!
!  FLIN1_Z
!   INTERPOLATE ON A 1D ARRAY
!
SUBROUTINE FLIN1_Z(X,F,N,VTR,XMIN,XMAX,XLR,NX,IWARN)
!
! Interpolates the table VTR(NX) to find the value at x.
! If XLR>0, then the X grid is equally spaced on a logarithmic scale:
!
!   X(i) = XMIN * (exp(XLR)) ** ( (i-1)/(NX-1) )
!
!   So X(i) ranges from XMIN to XMIN*exp(XLR), and XLR=log(xmax/xmin).
!
! For XLR<=0, the X grid is equally spaced on a linear scale from
! XMIN to XMAX.
!
! Modified 7/26/00 (PCR) - vectorized.
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER n,nx,it,iwarn,ix,ixp1
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) xmin,xmax,xlr,zx,zy,zzx,zlogx
!============
  real(fp) VTR(NX)
  real(fp), DIMENSION(n) :: X,F
!
!  INTERPOLATE TO X  LOGARITHMIC SPACING IN X
!     LINEAR IF XLR .LE. 0.0
!
!
  iwarn=0
!
  do it=1,n
!
     ZX=X(it)
!
     if(zx .lt. xmin) then
        zzx=0.0_fp
     else
        IF(XLR.GT.0.0_fp) THEN
           ZLOGX=log(ZX/XMIN)
           ZZX=1.0_fp+ZLOGX/XLR * (NX-1)
        ELSE
           ZZX=1.0_fp+(ZX-XMIN)/(XMAX-XMIN) * (NX-1)
        ENDIF
     endif
!
     IX=ZZX
!
!  CHECK FOR POINT OUT OF BOUNDS OF ARRAY
     IF(IX.GE.1) GO TO 10
!
     IF(ZX.LT.(XMIN - 5.0e-7_fp)) THEN
        IWARN=1
     ENDIF
     IX=1
     ZZX=1.0_fp
!
10   CONTINUE
!
     IF(IX.LT.NX) GO TO 30
!
     IF(ZX.GT.(XMAX + 5.0e-7_fp)) THEN
        IWARN=1
     ENDIF
     IX=NX-1
     ZZX=NX
!
!---------------------------
!  OK
!
30   CONTINUE
!
     IXP1=IX+1
     ZZX=ZZX-IX
!
!  INTERPOLATE
!
     F(it)=(1.0_fp-ZZX)*VTR(IX)+ZZX*VTR(IXP1)
!
  enddo
!
!
END SUBROUTINE FLIN1_Z
!
!******************** END FILE FLIN1.FOR ; GROUP SIGS2 ************************
! 26Jul2000 fgtok -s r8_precision.sub "r8con.csh conversion"

subroutine frantic_prinsum(ilun)

  ! printout FRANTIC info on specified grid
  ! acquire the data via output routines; do not use frantic module

  use iso_c_binding, only: fp => c_double
  implicit none

  integer, intent(in) :: ilun    ! print on this Fortran LUN

  !----------------------------------------------------
  real(fp) :: zA,zZ,zFlux,zFluxOut,zEngy,zv_phi,zSce
  logical :: ivs_flag
  integer :: i,ik,ineut,inx

  real(fp), dimension(:), allocatable :: zn0,zT0,zvphi0,zpcx,zpii

  !  for balance checks:
  real(fp), dimension(:), allocatable :: zs,zflx,zioniz,zcx,zchk,dvols
  real(fp), dimension(:), allocatable :: zflx1,zflx2,ztmp
  real(fp) :: zssum,zflxsum,zinzsum,zcxsum,zchksum,zflxa,zflxb,zflxc,zflxd
  !----------------------------------------------------

  call frantic_get_nx_user(inx)
  allocate(zn0(inx),zT0(inx),zvphi0(inx),zpcx(inx),zpii(inx))
  allocate(zs(inx),zflx(inx),zioniz(inx),zcx(inx),zchk(inx),dvols(inx))
  allocate(zflx1(inx),zflx2(inx),ztmp(inx))

  call frantic_source_echo(zA,zZ,zFlux,zEngy,zv_phi,ivs_flag,ik)
  zFlux=1.0e-4_fp*zFlux
  zv_phi=100.0e0_fp*zv_phi

  write(ilun,*) ' '
  write(ilun,*) ' ================================================= '

  call frantic_get_inps(zflxa)
  if(ivs_flag) then
    write(ilun,'(1x,a)') ' VOLUME source (profile) '
  else
    write(ilun,'(1x,a,1x,1pe12.5)') ' EDGE source (atoms/sec): ',zflxa
  end if

  write(ilun,1001) zA,zZ,zFlux,zEngy,zv_phi
1001 format(/1x,'A=',1pd9.2,' Z=',1pd9.2,' Flux(#/cm**2/sec)=',1pd13.6, &
       ' <E>(KeV)=',1pd13.6/' <v_phi>(cm/sec)=',1pd13.6// &
       1x,'  # n0            T0            vphi0         pcx           pii'/ &
       1x,'    cm**-3        KeV           cm/sec        W/cm**3       W/cm**3'/)
1002 format(1x,i3,5(1x,1pd13.6))

  call frantic_get_n0(ik,zn0); zn0=1.0e-6_fp*zn0
  call frantic_get_t0(ik,zt0)
  call frantic_get_vphi0(ik,zvphi0); zvphi0=1.0e2_fp*zvphi0

  call frantic_get_pcx(zpcx); zpcx=1.0e-6_fp*zpcx
  call frantic_get_pii(zpii); zpii=1.0e-6_fp*zpii

  do i=1,inx
    write(ilun,1002) i,zn0(i),zt0(i),zvphi0(i),zpcx(i),zpii(i)
  end do

  write(ilun,1008)

1008 format(/1x,' neutral species summary:'/ &
       1x,' #  A         Z         influx        outflux       Source        <E>out'/ &
       1x,'                        #/cm2/sec     #/cm2/sec     #/cm2/sec     KeV'/)
1009 format(1x,i2,2(1x,1pd9.2),4(1x,1pd13.6))

  call frantic_nneut_echo(ineut)
  zflxb=0.0_fp
  zflxc=0.0_fp
  zflxd=0.0_fp
  do ik=1,ineut
    call frantic_za_echo(ik,zA,zZ,zFlux)
    zFlux=1.0e-4_fp*zFlux
    zflxb=zflxb+zZ*zFlux
    zflxd=zflxb+zFlux
    call frantic_get_outflux(ik,zFluxOut,zEngy)
    zFluxout=1.0e-4_fp*zFluxout
    zflxc=zflxc+zZ*zFluxout
    call frantic_get_totalSce(ik,Zsce)
    zSce=1.0d-4*zSce
    write(ilun,1009) ik,zA,zZ,zFlux,zFluxOut,zSce,zEngy
  end do

  if(.not.ivs_flag) then
    zZ=zflxb/zflxd
    zflxd = zz*zflxa*(1.0e0_fp-zflxc/zflxb)
    write(ilun,'(1x,a,1pe12.5)') ' estimated net electron influx: ',zflxd
  end if

  ! balance information (sums over neutral species)

  call frantic_get_dvol(dvols); dvols = dvols*1.0e6_fp  ! -> cm^3

  !---------------
  ! e-ptcl bal

  call frantic_get_vsor_Z(zs); zs = zs*1.0e-6_fp

  call frantic_get_sflx01(zflx1); zflx1 = zflx1*1.0e-6_fp
  call frantic_get_sflx02(zflx2); zflx2 = zflx2*1.0e-6_fp
  zflx = zflx2 - zflx1

  call frantic_get_se(zioniz); zioniz = zioniz*1.0e-6_fp
  call frantic_get_seb(zcx); zcx = zcx*1.0e-6_fp

  zssum = 0; zflxsum = 0; zinzsum = 0; zcxsum = 0; zchksum = 0

  write(ilun,1101)
1101 format(/6x,'Integrated Ptcl bal (Z-weighted sum over neutral species):'/ &
       6x,'chk = vol_sourceZ0 - flux - e_source - e_bcx  (electrons/sec)'/ &
       1x,'    vol_sourceZ0 = Z0*[neutral source]'/ &
       1x,'    flux = [Z0 weighted sum of all neutral species fluxes]'/ &
       1x,'    e_source = [electron source due to neutrals ionizations]'/ &
       1x,'    e_bcx = [electrons -> beam fast neutrals by charge exch.]'/& 
       1x,'  # vol_sourceZ0  flux          e_source      e_bcx         chk')

  do i=1,inx
    zssum = zssum + zs(i)*dvols(i)
    zflxsum = zflxsum + zflx(i)*dvols(i)
    zinzsum = zinzsum + zioniz(i)*dvols(i)
    zcxsum = zcxsum + zcx(i)*dvols(i)
    zchksum = zssum - zflxsum - zinzsum - zcxsum

    write(ilun,1002) i,zssum,zflxsum,zinzsum,zcxsum,zchksum
  end do

  !----------------
  ! power balance

  call frantic_get_vsor_en(zs); zs = zs*1.0e-6_fp

  call frantic_get_pflx01(zflx1); zflx1 = zflx1*1.0e-6_fp
  call frantic_get_pflx02(zflx2); zflx2 = zflx2*1.0e-6_fp
  zflx = zflx2 - zflx1

  call frantic_get_pii(zioniz); zioniz = zioniz*1.0e-6_fp
  call frantic_get_piisf(ztmp); ztmp = ztmp*1.0e-6_fp
  zioniz = zioniz + ztmp

  call frantic_get_pcx(zcx); zcx = zcx*1.0e-6_fp
  call frantic_get_pcxsf(ztmp); ztmp = ztmp*1.0e-6_fp
  zcx = zcx - ztmp

  zssum = 0; zflxsum = 0; zinzsum = 0; zcxsum = 0; zchksum = 0

  write(ilun,1102)
1102 format(/6x,'Integrated Power Balance, all neutral species, plasma frame (Watts):'/ &
       6x,'chk = vol_source + Pcx - flux - Pii'/ &
       1x,'  # vol_source    Pcx           flux          Pii           chk')

  do i=1,inx
    zssum = zssum + zs(i)*dvols(i)
    zcxsum = zcxsum + zcx(i)*dvols(i)
    zflxsum = zflxsum + zflx(i)*dvols(i)
    zinzsum = zinzsum + zioniz(i)*dvols(i)
    zchksum = zssum +zcxsum - zflxsum - zinzsum

    write(ilun,1002) i,zssum,zcxsum,zflxsum,zinzsum,zchksum
  end do

  !----------------
  ! momentum balance

  call frantic_get_vsor_mo(zs); zs = zs*1.0e-6_fp

  call frantic_get_tqflx01(zflx1); zflx1 = zflx1*1.0e-6_fp
  call frantic_get_tqflx02(zflx2); zflx2 = zflx2*1.0e-6_fp
  zflx = zflx2 - zflx1

  call frantic_get_tqii(zioniz); zioniz = zioniz*1.0e-6_fp

  call frantic_get_tqcx(zcx); zcx = zcx*1.0e-6_fp

  zssum = 0; zflxsum = 0; zinzsum = 0; zcxsum = 0; zchksum = 0

  write(ilun,1103)
1103 format(/6x,'Integrated Angular Momentum Balance (Nt*m):'/ &
       6x,'chk = vol_source + Tqcx - flux - Tqii'/ &
       1x,'  # vol_source    Tqcx          flux          Tqii          chk')

  do i=1,inx
    zssum = zssum + zs(i)*dvols(i)
    zcxsum = zcxsum + zcx(i)*dvols(i)
    zflxsum = zflxsum + zflx(i)*dvols(i)
    zinzsum = zinzsum + zioniz(i)*dvols(i)
    zchksum = zssum +zcxsum - zflxsum - zinzsum

    write(ilun,1002) i,zssum,zcxsum,zflxsum,zinzsum,zchksum
  end do

  write(ilun,*) ' '

  deallocate(zn0,zT0,zvphi0,zpcx,zpii)
  deallocate(zs,zflx,zioniz,zcx,zchk,dvols)
  deallocate(zflx1,zflx2,ztmp)

  return
end subroutine frantic_prinsum

!------------------------------------------------------------------------------
!  ALAD_FIND_Z  FIND ALADDIN DATA ENTRY, BASED ON LABEL KEYS
!
SUBROUTINE ALAD_FIND_Z(ICTRL,ZHLBL,ZBLBL,ZNBLBL,IER)
!
!  INPUT:
!============
! idecl:  explicitize implicit INTEGER declarations:
  use alpcom_mod
  use alcom_mod
  IMPLICIT NONE
  INTEGER ilptr,icptr,iflag
!============
  INTEGER ICTRL		  ! CONTROL FLAG
!  ICTRL=1:  REWIND FILE AT START
  CHARACTER*(*) ZHLBL	  ! HIERARCHICHAL LABEL
  CHARACTER*(*) ZBLBL         ! BOOLEAN .AND. LABEL
  CHARACTER*(*) ZNBLBL	  ! BOOLEAN .NOT. LABEL
!
!  OUTPUT:
  INTEGER IER		  ! COMPLETION CODE, 0 = SUCCESS
!
!------------------------------------------------------------------------------
!  THIS ROUTINE TRIES TO FIND AN ENTRY IN THE CURRENT ALADDIN DATABASE
!  MATCHING THE PASSED KEY LABEL SPECIFICATIONS
!  THESE LABEL SPECS ARE THE SAME ONES THAT ONE TYPES IN WHEN RUNNING
!  ALADDIN INTERACTIVELY USING THE "SL" COMMAND -- CF EXE:ALADDIN.EXE
!  AND THE ALADDIN USER'S MANUAL
!
!  IF A MATCHING ENTRY IS FOUND, THE FUNCTION EVALUATION COEFFICIENTS
!  FOR THE ENTRY ARE READ IN.
!
!  THE CODE FOR THIS ROUTINE IS ESSENTIALLY STOLEN FROM THE ALADDIN
!  INTERACTIVE DRIVER CODE, ESP. ROUTINES ALL, ALS, AND ALEV, WITH
!  MINOR MODIFICATIONS -- DMC 1 JUNE 1990
!
!  A COPY OF ALADDIN IS IN TRANSP SOURCE:ALADDIN.FOR
!------------------------------------------------------------------------------
!
!
  CHARACTER*1 ZNULL
!
  ZNULL=CHAR(0)
!
  IF((DFNAME.EQ.'**NONE**').OR.(DFNAME(1:1).EQ.ZNULL)) THEN
     IER=1
     LUTOUT=6
     WRITE(LUTOUT,1001)
1001 FORMAT(/&
          ' ALAD_FIND_Z:  ALADDIN FILE NOT OPEN-- CALL ALAD_INIT_Z FIRST')
     RETURN
  ENDIF
!
!      WRITE(LUTOUT,'('' **ENTERING ALAD_FIND_Z** (ORNL ALADDIN) '')')
!        Write(LUtout,9234) ZHLBL
! 9234   Format(1x, A)
!
  IER=1
!
  IF(ICTRL.EQ.1) THEN
     REWIND LUDF
!      	  WRITE(LUTOUT, '('' DATA FILE REWOUND'')' )
     LESEQN = 0
     EOF = .FALSE.
  ENDIF
!
!  PARSE PASSED LABELS INTO ALADDIN COMMON (AS IN ALADDIN.FOR SUBROUTINE
!  ALL) USING PASSED INPUT INSTEAD OF KEYBOARD INPUT
!
!---------------------------
!  HIERARCHICAL LABEL
!
  IF(ZHLBL.EQ.' ') THEN
     CMND='.'
  ELSE
     IF(INDEX(ZHLBL,'.').EQ.0) THEN
        CMND=ZHLBL//' .'
     ELSE
        CMND=ZHLBL
     ENDIF
  ENDIF
!
  NHSL = 0
!
  ILPTR = 1
  ICPTR = 1
  200 CALL ALXLBL_Z(CMND, 1, ILPTR, ICPTR, LABEL, NCHLBL, IFLAG)
!
  IF(IFLAG .EQ. -1) THEN
     WRITE(LUTOUT, '(''ALAD_FIND_Z: H.LABEL "'', A, ''" TOOLONG'')' )&
          LABEL
     RETURN
  ENDIF
!
  IF(IFLAG .EQ. 1) THEN
     WRITE(LUTOUT, '(''ALAD_FIND_Z: H.LABEL "'', A, ''" INVALID'')' )&
          LABEL
     RETURN
  ENDIF
!
  IF(IFLAG .EQ. 0 .AND. LABEL .NE. '.') THEN
     NHSL = NHSL + 1
     HSL(NHSL) = LABEL
     GO TO 200
  ENDIF
!
!---------------------------
!  BOOLEAN .AND. LABEL
!
  IF(ZBLBL.EQ.' ') THEN
     CMND='.'
  ELSE
     IF(INDEX(ZBLBL,'.').EQ.0) THEN
        CMND=ZBLBL//' .'
     ELSE
        CMND=ZBLBL
     ENDIF
  ENDIF
!
  NBASL = 0
!
  ILPTR = 1
  ICPTR = 1
400 CALL ALXLBL_Z(CMND, 1, ILPTR, ICPTR, LABEL, NCHLBL, IFLAG)
!
  IF(IFLAG .EQ. -1) THEN
     WRITE(LUTOUT, '(''ALAD_FIND_Z: B.LABEL "'', A, ''" TOOLONG'')' )&
          LABEL
     RETURN
  ENDIF
!
  IF(IFLAG .EQ. 1) THEN
     WRITE(LUTOUT, '(''ALAD_FIND_Z: B.LABEL "'', A, ''" INVALID'')' )&
          LABEL
     RETURN
  ENDIF
!
  IF(IFLAG .EQ. 0 .AND. LABEL .NE. '.') THEN
     NBASL = NBASL + 1
     BASL(NBASL) = LABEL
     GO TO 400
  ENDIF
!
!---------------------------
!  BOOLEAN .NOT. LABEL
!
  IF(ZNBLBL.EQ.' ') THEN
     CMND='.'
  ELSE
     IF(INDEX(ZNBLBL,'.').EQ.0) THEN
        CMND=ZNBLBL//' .'
     ELSE
        CMND=ZNBLBL
     ENDIF
  ENDIF
!
  NBNSL = 0
!
  ILPTR = 1
  ICPTR = 1
600 CALL ALXLBL_Z(CMND, 1, ILPTR, ICPTR, LABEL, NCHLBL, IFLAG)
!
  IF(IFLAG .EQ. -1) THEN
     WRITE(LUTOUT, '(''ALAD_FIND_Z: N.LABEL "'', A, ''" TOOLONG'')' )&
          LABEL
     RETURN
  ENDIF
!
  IF(IFLAG .EQ. 1) THEN
     WRITE(LUTOUT, '(''ALAD_FIND_Z: N.LABEL "'', A, ''" INVALID'')' )&
          LABEL
     RETURN
  ENDIF
!
  IF(IFLAG .EQ. 0 .AND. LABEL .NE. '.') THEN
     NBNSL = NBNSL + 1
     BNSL(NBNSL) = LABEL
     GO TO 600
  ENDIF
!
!------------------------------------------------------------------------------
!
!
!      WRITE(LUTOUT,
!     & '(/'' ALAD_FIND_Z: STARTING SEARCH AT ENTRY SEQ. NUMBER '',I6)' )
!     &     LESEQN+1
!
700 CALL ALREAD_Z(LUDF, LESEQN, EOF, ERRMSG)
!
  IF(EOF) THEN
     WRITE(LUTOUT,&
          '(/'' ***** END OF FILE REACHED, NO MATCH FOUND *****'')' )
     WRITE(LUTOUT,&
          '(/'' NOW AT LAST ENTRY IN FILE, SEQUENCE NUMBER '',I6)' )&
          LESEQN
     RETURN
  ENDIF
!
  IF(ERRMSG .NE. ' ') THEN
     WRITE(LUTOUT, '('' ERROR: '', A)' ) ERRMSG
     RETURN
  ENDIF
!
  CALL ALCOMP_Z(HSL, NHSL, BASL, NBASL, BNSL, NBNSL, MATCH)
  IF(.NOT. MATCH) GO TO 700
!
!      WRITE(LUTOUT,
!     &   '(/'' MATCH FOUND AT ENTRY SEQUENCE NUMBER '', I6)')LESEQN
!
!------------------------------------------------------------------------------
!
!      BEGIN SUBROUTINE SWITCH TO SELECT CORRECT SUBROUTINE TO CALL
!      IN ORDER TO EVALUATE THIS ENTRY, BASED ON THE EVALUATION
!      FUNCTION LABEL FROM THE ENTRY.  THIS LABEL IS STORED AS THE
!      LAST BOOLEAN LABEL.
!
!------------------------------------------------------------------------------
!
  IF(BL(NBL) .EQ. '#MEWE') THEN
     WRITE(LUTOUT,&
          '(/'' MEWE SPECTRAL LINE EXCITATION RATE COEFF. (cm3/s)'')' )
     WRITE(LUTOUT,&
          '(/'' AS FUNCTION OF ELECTRON TEMPERATURE (keV)'')')
!
!--------------  RETREIVE NUMERIC COEFFICIENTS
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(NCF .NE. 8 .AND. ERRMSG .EQ. ' ')&
          ERRMSG = 'INCORRECT NUMBER OF COEFFICIENTS'
     IF (ERRMSG .NE.  ' ') THEN
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#BELI') THEN
     WRITE(LUTOUT,&
          '(/'' ELECTRON IMPACT IONIZATION CROSS SECTION cm[2]'')' )
     WRITE(LUTOUT,&
          '(/'' AS FUNCTION OF ELECTRON ENERGY (eV)'')')
!
!--------------  RETREIVE NUMERIC COEFFICIENTS
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(NCF.EQ.0) THEN
        WRITE(LUTOUT,&
             '(/'' NO FITTING PARAMETERS   EV FUNCTION TERMINATED'')' )
        RETURN
     ENDIF
     IF(ERRMSG .EQ. ' ') THEN
        CONTINUE
     ELSE
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#CHEB') THEN
!        WRITE(LUTOUT,
!     &       '(/'' ORNL:CFADC CHEBYSHEV POLYNOMIAL FIT'')' )
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
!
     IF(NCF .NE. 11 .AND. ERRMSG .EQ. ' ')&
          ERRMSG = 'INCORRECT NUMBER OF COEFFICIENTS'
     IF(ERRMSG .EQ. ' ') THEN
        CONTINUE
     ELSE
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#KINGEX') THEN
     WRITE(LUTOUT,&
          '(/'' POLYNOMIAL FIT OF EXCITATION RATE COEFFICIENT (cm3/s)'')')
     WRITE(LUTOUT,&
          '(/'' AS FUNCTION OF ELECTRON TEMPERATURE (eV)'')')
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(ERRMSG .EQ. ' ') THEN
        CONTINUE
     ELSE
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
!------
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#JAN1') THEN
     WRITE(LUTOUT,&
          '(/'' LOG(N) POLYNOMIAL FIT '')' )
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(NCF .NE. 11 .AND. ERRMSG .EQ. ' ')&
          ERRMSG = 'INCORRECT NUMBER OF COEFFICIENTS'
     IF(ERRMSG .EQ. ' ') THEN
        CONTINUE
     ELSE
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
!------
!
!------
!
!      OTHER EVALUATION LABELS GO HERE IN STRUCTURE OF THE FORM:
!
!      ELSE IF(BL(NBL) .EQ. '#{EVALUATION LABEL}') THEN
!             CALL {APPROPRIATE SUBROUTINE TO DO INTERACTIVE
!                    EVALUATION}
!
!      FOR 1-D DATA TYPES WITH SUBROUTINES IN PROPER FORM, ALTB1D CAN
!      BE USED TO CALL THE EVALUATION SUBROUTINE DIRECTLY BY NAME, WITH NO
!      NO SEPARATE ROUTINE NEEDED FOR ALEV TO INTERACT WITH THE
!      TERMINAL ETC.
!
!      IF ALTB1D CANNOT BE USED, THE TYPICAL STRUCTURE OF SUBROUTINE
!      CALLED BY ALEV FOR INTERACTIVE EVALUATION OF A DATA ENTRY CON
!      CONTAINS:
!
!          {CODING TO CONVERT COEFFICIENT FIELD AS REQUIRED}
!          {CODING TO OBTAIN REQUIRED INDEPENDENT VARIABLE(S) FOR THIS
!           DATA TYPE}
!          {CODING TO CALL EVALUATION FUNCTION SUBROUTINE}
!          {CODING TO OUTPUT RESULTING DATA POINT VALUE(S)}
!          {LOOP BACK FOR MORE EVALUATIONS OR RETURN}
!
!------
!
!          CATCH-ALL FOR ENTRIES WITH EVALUATION LABELS NOT CURRENTLY IN
!          THIS VERSION OF ALADDIN
!
  ELSE
     WRITE(LUTOUT,&
          '(/'' ALAD_FIND_Z:  EVALUATION CURRENTLY UNAVAILABLE'')')
     IER=1
     RETURN
!
!------
!
  ENDIF
!
!  MADE IT!  INFO TO EVALUATE CROSS SECTION HAS BEEN LOADED
!  DMC 1 JUN 1990 -- BASED ON ALEV.FOR
!
!  EVALUATION FUNCTIONS REQUIRING ADDITIONAL USER INPUT WERE
!  CENSORED OUT OF THIS CODE
!
!  MODIFIED:
!      6/13/00 PCR - MINOR CHANGES
!
  IER=0
!
  RETURN
!
END SUBROUTINE ALAD_FIND_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

!-----------------------------------------------------------------------
!  ALAD_EVAL -- EVALUATE ALADDIN CROSS SECTION FIT
!
SUBROUTINE ALAD_EVAL_Z(ZX,ZY,INUM,IER)
  use iso_c_binding, only: fp => c_double
  use alpcom_mod
  use alcom_mod
  implicit none
!
  integer ier,inum
  real(fp) ZX(INUM)  ! INPUT EVALUATION POINTS
  real(fp) ZY(INUM)  ! OUTPUT EVALUATION RESULTS
  EXTERNAL ALMEWE_Z, ALCHEB_Z, ALKING_Z, ALPHACX_Z
  EXTERNAL ALJAN1_Z, ALBELI_Z
  real(fp) PERUNC, ZX1, ZX2
  real(fp) ETH
!
!-----  GAMMA, CLINE, CTARGT, CION ARE VARIABLES
!-----         FOR FUNCTION TABSPY
!
  real(fp) GAMMA
  CHARACTER*2  CTARGT, CION
!
!-----  Q, ELOW AND EHIGH ARE VARAIABLES FOR FUNCTION ALPHACX
!
  real(fp) Q, ELOW, EHIGH
!
  real(fp) XRANGE(10)
!
!-------------------------------------------------------------------
!
  IF(BL(NBL) .EQ. '#MEWE') THEN
     CALL ALAD_EVXY_Z(ALMEWE_Z,ZX,ZY,INUM)
  ELSE IF(BL(NBL) .EQ. '#BELI') THEN
     CALL ALAD_EVXY_Z(ALBELI_Z,ZX,ZY,INUM)
  ELSE IF(BL(NBL) .EQ. '#CHEB') THEN
     CALL ALAD_EVXY_Z(ALCHEB_Z,ZX,ZY,INUM)
  ELSE IF(BL(NBL) .EQ. '#KINGEX') THEN
     CALL ALAD_EVXY_Z(ALKING_Z,ZX,ZY,INUM)
  ELSE IF(BL(NBL) .EQ. '#JAN1') THEN
     CALL ALAD_EVXY_Z(ALJAN1_Z,ZX,ZY,INUM)
  ELSE
     WRITE(LUTOUT,&
          '(/'' ALAD_EVAL:  EVALUATION CURRENTLY UNAVAILABLE'')')
     IER=1
     return
  ENDIF
!
  IER=0
!
!------------------------------------
!
  RETURN
!
END SUBROUTINE ALAD_EVAL_Z

C******************** START FILE UF3DRE.FOR ; GROUP UFILES ******************
C--------------------------------------------------------------
C  UF3DRE
C
C  SIMPLIFIED READ ROUTINE FOR 3D DATA.  LABELS FOR DATA ARE
C  NOT RETURNED, ONLY THE DATA ITSELF.  THE DATA LABELS
C  ARE PRINTED ON UNIT LUNO
C
C  ACTUAL READ IS PERFORMED BY UF3DRD, WHICH MAY BE USED
C  DIRECTLY IF LABELS ARE DESIRED.  PURPOSE OF THIS ROUTINE
C  IS TO HAVE A 3D READ ROUTINE WITH AS SIMPLE A LIST OF CALLING
C  ARGUMENTS AS POSSIBLE.
C
        SUBROUTINE UF3DRE(ILUN,F,NF1,NF2,X,NX,Y,NY,Z,NZ,
     >     NXACT,NYACT,NZACT,IFLAG,IER,LUNO)
C
C  ILUN (INPUT) - FILE LOGICAL UNIT NUMBER
C    FILENAME WILL HAVE BEEN CONSTRUCTED (SRS. UFSETR,UFOPEN)
C  AND FILE OPENED (SR. UFOPRD) BEFORE THIS ROUTINE IS CALLED
C
C  X  ARRAY FOR 1ST INDEPENDENT VARIABLE (RETURNED FROM FILE)
C  Y  ARRAY FOR 2ND INDEPENDENT VARIABLE (RETURNED FROM FILE)
C  Z  ARRAY FOR 3RD INDEPENDENT VARIABLE (RETURNED FROM FILE)
C  F  ARRAY FOR DEPENDENT VARIABLE (RETURNED FROM FILE)
C  NF1,NX,NY (INPUT) SIZES OF X,Y,F ARRAYS - SEE DECLARATIONS
C     NF1 FOR 1ST DIM. OF F ARRAY (DOUBLY SUBSCRIPTED)
C     ERROR WILL OCCUR IF ARRAY SIZES ARE INSUFFICIENT TO
C     ACCOMODATE DATA IN FILE BEING READ.
C  NXACT,NYACT - THE ACTUAL SIZES OF THE X AND Y DATA ARRAYS
C     IN THE FILE.  THE F ARRAY WILL THEN CONTAIN NXACT*NYACT PTS.
C  IFLAG (INPUT) - IF IFLAG=1 THE DATA IS READ CONSECUTIVELY INTO
C     THE F ARRAY; IF IFLAG=0, THE DATA IS READ
C     VIA "READ (..) ((F(IJ,IK),IJ=1,NXACT),IK=NYACT)
C     WHICH MAY RESULT IN THE DATA NOT BEING CONTIGUOUSLY STORED.
C
C  IER   ERROR RETURN CODE 0= NORMAL SUCCESSFUL COMPLETION
C  LUNO  (INPUT) OPEN I/O CHANNEL FOR OUTPUT OF FILE
C        DATA LABELS (OUTPUT SUPPRESSED IF LUNO.LE.0)
C
C---
        USE UFILES
C
        REAL X(NX),F(NF1,NF2,NZ),Y(NY),Z(NZ),ZVAL(UFPASC)
        CHARACTER*10 ZSDATE
        CHARACTER*30 XLAB,FLAB,YLAB,ZLAB,ZSCLAB(UFPASC)
      CHARACTER*4 IDEV
C
C$r8real_output: f,x,y,z
C
C  READ THE DATA
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF3DRE    ',ICHAN,IER)
        CALL UF2DRD(ILUN,IDEV,ZSDATE,F,NF1,NF2,X,NX,Y,NY,Z,NZ,IPROC,
     >     NXACT,NYACT,NZACT,IFLAG,
     >     FLAB,XLAB,YLAB,ZLAB,UFPASC,IVGOT,ZVAL,ZSCLAB,IER)
C
      IF(LUNO.LE.0) RETURN
C
C  ECHO LABEL; RESULTS INFO
        WRITE(LUNO,1001) IER
 1001   FORMAT(' =============================================='/
     >  ' DATA READ FROM FILE:  IER=',I3,' (0 IS NORMAL)'/)
c
        call ufsnmd(luno,' Ufile Name',ilun)
c
        WRITE(LUNO,1002) ILUN,IDEV,ZSDATE
 1002   FORMAT(' UFILES LOGICAL UNIT: ',I3,' TOKAMAK:  ',A4,
     >  ' SHOT DATE:  ',A10/)
        WRITE(LUNO,1003) NXACT,XLAB,NYACT,YLAB,NZACT,ZLAB,FLAB
 1003   FORMAT(1X,I4,' X PTS:  "',A30,'"'/1X,I4,' Y PTS:  "',A30,'"'/
     >         1X,I4,' Z PTS:  "',A30,'"'/'   DATA PTS:  "',A30,'"'/)
        IF((IPROC.EQ.1).OR.(IPROC.EQ.3)) WRITE(LUNO,1004)
        IF((IPROC.EQ.2).OR.(IPROC.EQ.3)) WRITE(LUNO,1005)
 1004   FORMAT(' DATA WAS AVERAGED')
 1005   FORMAT(' DATA WAS SMOOTHED')
C
      IF(IVGOT.EQ.0) GO TO 100
      DO 96 I=1,IVGOT
        WRITE(LUNO,1006) ZVAL(I),ZSCLAB(I)
 1006   FORMAT(' ASSOCIATED QUANTITY VALUE:  ',1PE12.5/
     >       '	  	       LABEL:  ',A30/)
 96   CONTINUE
C
 100  CONTINUE
        RETURN
                END
C******************** END FILE UF3DRE.FOR ; GROUP UFILES ******************

      subroutine urdprlev(ilev)
C
C  call URDPRLEV(0) before call UINITA(0) to suppress case conversion
C  even on the command input line arguments
C
      use USERIO
C
C-----------------------------
C
      if(ilev.lt.0) return
      levdflt=ilev
C
      return
      end

C******************** START FILE CDCOD.FOR ; GROUP URDUTS ******************
C------------------
C&  URCHAR  UREAD INTERNAL, GET SINGLE CHAR STRING OUT OF TYPEAHEAD
C
      SUBROUTINE URCHAR(ZCHAR,iup,ID,IER)
C
      USE USERIO
C
      CHARACTER*1 ZCHAR
C
      CHARACTER*10 ZSTRNG
C
C--------------------
C
      IER=0
C
C
C  QUOTE STRING-- PROCESS AS WORD OF LENGTH 1
C
      IF(CBUFF(1:1).EQ.'"') THEN
        ZCHAR=' '
C
        CALL URWORD(CBUFF,0,IC,ID)
C
        ILNB=0
        IF(IC.GT.0) THEN
          IF(IC.LT.5) THEN
            CALL URWRDL(CBUFF(1:IC),ZSTRNG,ILNB)
          ELSE
            ILNB=2  ! QUOTE STRING .GT. 1 CHAR LONG
          ENDIF
        ENDIF
C
        IF(ILNB.EQ.1) THEN
          ZCHAR=ZSTRNG(1:1)
        ELSE IF(ILNB.GT.1) THEN
C IF THE QUOTE STRING CONTAINS .GT. 1 CHARACTER ...
          ZCHAR='?'
          IER=1
        ENDIF
C
      ELSE
C  ANY OTHER CHARACTER...
        ZCHAR=CBUFF(1:1)
        if(iup.eq.1) call uspcap(zchar)
        ID=1
      ENDIF
C
      RETURN
      END
C******************** END FILE CDCOD.FOR ; GROUP URDUTS ******************

C******************** START FILE CONCTR.FOR ; GROUP CONCTR ******************
C============================================================
C  CONCTR    D. MC CUNE MAY 21 1980 -- INTERACTIVE MAIN
C
C  CONTROL GENERATION OF CONTOUR PLOT OF 2D GRID
C  FUNCTION
C
C  PROGRAM USES "UREAD.FOR[GOLD.TRANSP]" AND "UEDIT.FOR[GOLD.TRANSP]"
C
C  USER OPTIONS: GET PLOT
C                CHANGE CONTOUR SELECTION DEFAULTS
C                CHANGE FUNCTION SUBDOMAIN SELECTION DEFAULTS
C                EXIT
C
C  ARGUMENTS:
C    X(NX)    INDEP. VAR ALONG 1ST DIMENSION OF FUNCTION
C    Z(NZ1,NY)  2D FUNCTION TO BE PLOTTED
C    Y(NY)    INDEP VAR. ALONG 2ND DIMENSION OF FUNCTION
C    XLAB     CHAR LABEL FOR X
C    ZLAB     CHAR LABEL FOR Z
C    YLAB     CHAR LABEL FOR Y
C    XUN      CHAR. PHYS. UNITS FOR X TERMINATED WITH "$"
C    ZUN      DITTO FOR Z
C    YUN      DITTO FOR Y
C    RLAB     CHAR. RUN LABEL , E.G. "RUN # 1234"
C             (SHOULDNT BE TERMINATED WITH "$")
C    IINT     FCN INTEGRATION CODE:
C             0 -- NOT INTEGRATED
C             1 -- VOL. INTEGRATED
C             2 -- FLUX. INTEGRATED
C             3 -- AREA INTEGRATED
C    ISMOO    IF ISMOO=1, DATA HAS BEEN SMOOTHED
C                (FOR LABELING)
C    NPAGE  INCREMENTS BY ONE TO YIELD PAGE # OF GRAPH TO BE
C           DRAWN; PAGE # IS ADDL LABEL ON GRAPH
C
      SUBROUTINE CONCTR(X,Z,Y,NX,NZ1,NY,XLAB,ZLAB,YLAB,
     >                    XUN,ZUN,YUN,RLAB,IINT,ISMOO,NPAGE)
C  DECLARATIONS
C   PARAMETER:  MAX # OF CONTOURS
C    LIMITED BY CONTOUR LABELING, SPACE IN KEY
      PARAMETER (NCMAX0=18)
C
C  PASSED ARGS
C
      DIMENSION X(NX),Z(NZ1,NY),Y(NY)
      CHARACTER*(*) XLAB,ZLAB,YLAB,RLAB,XUN,YUN,ZUN
C
C   LOCAL
CX	CHARACTER*128 ZBUFF
C
C  ARRAY OF CONTOUR VALUES
      DIMENSION ZCNTR1(NCMAX0),ZCNTR0(NCMAX0),ZWRK(NCMAX0)
C  CONTOUR ID CHARACTERS
      CHARACTER*1 ACNTR1(NCMAX0)
C
      CHARACTER*3 AONOFF(2)
c
      CHARACTER*10 FLAB,CLAB
c
C  INITIAL DEFAULT FLAG VALUES--
C   SET MIN,MAX CONTOUR LIMITS TO FUNCTION MIN,MAX
C
      LOGICAL NLZMMX,ILZMMX
C   SET  DOMAIN TO ENTIRE DOMAIN OF FUNCTION
      LOGICAL NLXMMX
      LOGICAL NLYMMX
C   SET EQUAL SPACING OF CONTOURS
      LOGICAL NLLOGC
C  SET DEFAULT AXES TYPES TO BE LINEAR
C
C  SET MAX # OF CONTOURS INITIALLY TO PROGRAM LIIMIT
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR,LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C => CONCTR               BEGIN DATA BLOCK
C => LISMAK 12-APR-88  MOVED DATA STATEMENTS
      DATA ACNTR1/'A','B','C','D','E','F','G','H','J','K',
     >              'L','M','N','P','Q','R','S','T'/
      DATA AONOFF/'ON ','OFF'/
      DATA FLAB/'FUNCTION  '/
      DATA CLAB/'CONTOUR   '/
      DATA NLZMMX/.TRUE./
      DATA NLXMMX/.TRUE./
      DATA NLYMMX/.TRUE./
      DATA NLLOGC/.FALSE./
      DATA ITYPX0/1/
      DATA ITYPY0/1/
      DATA NCMAX/NCMAX0/
C => END DATA BLOCK
C ====================
C
C  START OF EXECUTABLE CODE-- PRESENT USER OPTIONS
C
C  CHECK FOR MIN. NX, NY
C
      LUNTRM=LNOUT(0)
C
      IF((NX.GT.1).AND.(NY.GT.1)) GO TO 10
        WRITE(LUNTRM,9009) NX,NY
 9009   FORMAT('  NX=',I3,'  NY=',I3/
     >	  '  TOO FEW X OR Y PTS FOR CONTOUR PLOTTING ***')
        CALL UPAUST(1)
        RETURN
C
 10   CONTINUE
      CALL NEUPAG
 11   IF(LXOUT(0)) WRITE(LUNTRM,1001)
 1001 FORMAT(' *CONTOUR PLOTS CONTROLLER* OPTIONS:'/
     >         '  (1) MAKE DEFAULT PLOT'/
     >         '  (2) CHANGE DEFAULTS'/
     >         '  (3) MAKE NON-DEFAULT GRAPH'/
     >         '  (4) EXIT'/)
C
      CALL UREAD(' SUB:CONCTR >> ENTER OPTION #:$')
      if(lchar('Q')) return
C
      IANS=IDCOD(ITERR)
      CALL UCHKOP(IANS,ITERR,1,4,-1,*11)
      IF(IANS.EQ.4) RETURN
C
      IF(IANS.EQ.2) GO TO 200
C
C  MAKE PLOT
C
 100  CONTINUE
C  SET DEFAULTS
C  SET CURRENT MAX # OF CONTOURS
      NCTRY=NCMAX
C
C  SET DOMAIN LIMITS
      IF(NLXMMX) GO TO 140
        XMIN=XMIN0
        XMAX=XMAX0
        GO TO 150
C  TO MIN,MAX OF X
 140  CONTINUE
        XMIN=X(1)
        XMAX=X(NX)
        CALL SPREDM(XMIN,XMAX,XMIN,XMAX)
 150  CONTINUE
C
      IF(NLYMMX) GO TO 160
        YMIN=YMIN0
        YMAX=YMAX0
        GO TO 170
C
 160  CONTINUE
        YMIN=Y(1)
        YMAX=Y(NY)
        CALL SPREDM(YMIN,YMAX,YMIN,YMAX)
 170  CONTINUE
C
C  CONTOUR LIMITS
      IF(NLZMMX) GO TO 110
        CMIN=CMIN0
        CMAX=CMAX0
        IF((CMIN.EQ.0.0).AND.(CMAX.EQ.0.0)) THEN
          DO 109 IC=1,NCTRY
            ZCNTR1(IC)=ZCNTR0(IC)
 109      CONTINUE
        ENDIF
        GO TO 130
 110  CONTINUE
C  SET TO MIN,MAX OF FCN
        IFND=0
        DO 120 IY=1,NY
          IF((Y(IY).LT.YMIN).OR.(Y(IY).GT.YMAX)) GO TO 120
          DO 119 IX=1,NX
            IF((X(IX).LT.XMIN).OR.(X(IX).GT.XMAX)) GO TO 119
            IFND=IFND+1
            IF(IFND.EQ.1) CMIN=Z(IX,IY)
            IF(IFND.EQ.1) CMAX=Z(IX,IY)
            CMIN=AMIN1(CMIN,Z(IX,IY))
            CMAX=AMAX1(CMAX,Z(IX,IY))
 119      CONTINUE
 120    CONTINUE
        CALL SPREDM(CMIN,CMAX,CMIN,CMAX)
C
 130  CONTINUE
C  SET LOG/LIN FLAG
      ILOGC=1
      IF(NLLOGC) ILOGC=2
C  SET AXES TYPES
      ITYPX=ITYPX0
      ITYPY=ITYPY0
C
C  DRAW CONTOURS
C
      ILZMMX=NLZMMX
      IF(IANS.EQ.3) GO TO 300
C
C-------------------------
C  THE PLOT ITSELF...
C
 180  CONTINUE
      CALL CONPLT(X,Z,Y,NX,NZ1,NY,XLAB,ZLAB,YLAB,
     >       XUN,ZUN,YUN,RLAB,IINT,ISMOO,ITYPX,ITYPY,
     >       XMIN,XMAX,CMIN,CMAX,YMIN,YMAX,NCTRY,ILOGC,NLZMMX,
     >       ZCNTR1,ACNTR1,NPAGE)
C
      NLZMMX=ILZMMX
      GO TO 10
C
C-------------------------
C
C  CHANGE DEFAULTS
C
 200  CONTINUE
C
      CALL NEUPAG
C
C  DISPLAY CURRENT SETTINGS
      WRITE(LUNTRM,2001) XLAB,YLAB,ZLAB
 2001 FORMAT(/
     >' X = ',A/
     >' Y = ',A/
     >' dependent data = ',A/)
      IVAL=ILVAL(NLZMMX)
      IF(LXOUT(0)) CALL UDISP1(0,1,AONOFF(IVAL),'NO ',
     >     'SET CONTOUR LIMITS TO DEPENDENT DATA MIN,MAX$')
C
      IVAL=ILVAL(NLXMMX)
      IF(LXOUT(0)) CALL UDISP1(1,2,AONOFF(IVAL),'NO ',
     >     'SET X AXIS LIMITS TO DATA MIN,MAX$')
C
      IVAL=ILVAL(NLYMMX)
      IF(LXOUT(0)) CALL UDISP1(1,3,AONOFF(IVAL),'NO ',
     >     'SET Y AXIS LIMITS TO DATA MIN,MAX$')
C
      IVAL=ILVAL(NLLOGC)
      IF(LXOUT(0)) CALL UDISP1(1,4,AONOFF(IVAL),'NO ',
     >   'SET LOGARITHMIC SPACING FOR CONTOURS$')
C
C  GET USER RESPONSE
      IF(LXOUT(0)) WRITE(LUNTRM,2002)
 2002 FORMAT(/' ENTER SWITCH # TO TOGGLE SWITCH VALUE;'/
     >          ' OR "G" TO GO ON')
      CALL UREAD(' SUB:CONCTR >> CHANGE DEFAULT:$')
C
      IF(LCHAR('G')) GO TO 250
      if(lchar('Q')) goto 10
C
      ISW=IDCOD(ITERR)
      CALL UCHKOP(ISW,ITERR,1,4,1,*200)
      GO TO (210,220,230,240) ISW
C
C  CONTOUR MIN/MAX SWITCH
 210  CONTINUE
        NLZMMX=.NOT.NLZMMX
        GO TO 200
C XMIN,XMAX SWITCH
 220  CONTINUE
        NLXMMX=.NOT.NLXMMX
        GO TO 200
C  YMIN,YMAX SWITCH
 230  CONTINUE
        NLYMMX=.NOT.NLYMMX
        GO TO 200
C  LOG.LIN FLAG
 240  CONTINUE
        NLLOGC=.NOT.NLLOGC
        GO TO 200
C
C   END OF DEFAULTS SECTION:  GET NEW MAX # OF CONTOURS
C    AND OTHER VALUES TO BE SET BY USER
C
 250  CONTINUE
      CALL NEUPAG
      IF(LXOUT(0)) WRITE(LUNTRM,2501)
 2501 FORMAT(/' ENTER "X" NOT TO CHANGE THE VALUE OF A PARAMETER'/
     >	        ' ENTER "L" TO ENTER LIST OF CONTOUR TEST VALUES'/
     >          '    INSTEAD OF MIN/MAX LIMITS CMIN,CMAX'/)
      IERT=0
      IF(NLZMMX) GO TO 260
 251    CALL UREAD(' SUB:CONCTR >> ENTER NEW DEFAULT CMIN:$')
        IERT=0
        IF(LCHAR('Q')) GOTO 250
        IF(LCHAR('L')) GOTO 255
        ZMIN0=CMIN0
        IF(.NOT.LCHAR('X')) ZMIN0=FDCOD(IERT)
        IF(IERT.NE.0) GO TO 251
 252    CALL UREAD(' SUB:CONCTR >> ENTER NEW DEFAULT CMAX:$')
        IERT=0
        IF(LCHAR('Q')) GOTO 250
        IF(LCHAR('L')) GOTO 255
        ZMAX0=CMAX0
        IF(.NOT.LCHAR('X')) ZMAX0=FDCOD(IERT)
        IF(IERT.NE.0) GO TO 252
C
        CALL SPREDM(ZMIN0,ZMAX0,CMIN0,CMAX0)
        ZDC=CMAX0-CMIN0
        CMAX0=CMAX0+.0001*ZDC
        CMIN0=CMIN0-.0001*ZDC
        GO TO 260
C
 255    CONTINUE
C  GET A SORTED LIST OF CONTOUR TEST VALUES
        CMIN0=0.0
        CMAX0=0.0
        IRET=0
        CALL INORD(ZCNTR0,ZWRK,NCMAX0,IRET,
     >      'DEFAULT CONTOUR TEST VALUES',0)
        IF(IRET.EQ.0) GOTO 250
        NCMAX=IRET
C
 260  CONTINUE
      IF(NLXMMX) GO TO 270
 261    CALL UREAD(' SUB:CONCTR >> ENTER NEW DEFAULT XMIN:$')
        IERT=0
        IF(LCHAR('Q')) GOTO 280
        ZMIN0=XMIN0
        IF(.NOT.LCHAR('X')) ZMIN0=FDCOD(IERT)
        IF(IERT.NE.0) GO TO 261
 262    CALL UREAD(' SUB:CONCTR >> ENTER NEW DEFAULT XMAX:$')
        IERT=0
        IF(LCHAR('Q')) GOTO 280
        ZMAX0=XMAX0
        IF(.NOT.LCHAR('X')) ZMAX0=FDCOD(IERT)
        IF(IERT.NE.0) GO TO 262
C
        CALL SPREDM(ZMIN0,ZMAX0,XMIN0,XMAX0)
C
 270  CONTINUE
      IF(NLYMMX) GO TO 280
 271    CALL UREAD(' SUB:CONCTR >> ENTER NEW DEFAULT YMIN:$')
        IERT=0
        IF(LCHAR('Q')) GOTO 280
        ZMIN0=YMIN0
        IF(.NOT.LCHAR('X')) ZMIN0=FDCOD(IERT)
        IF(IERT.NE.0) GO TO 271
 272    CALL UREAD(' SUB:CONCTR >> ENTER NEW DEFAULT YMAX:$')
        IERT=0
        IF(LCHAR('Q')) GOTO 280
        ZMAX0=YMAX0
        IF(.NOT.LCHAR('X')) ZMAX0=FDCOD(IERT)
        IF(IERT.NE.0) GO TO 272
C
        CALL SPREDM(ZMIN0,ZMAX0,YMIN0,YMAX0)
C
 280  CONTINUE
      IF((CMIN0.NE.0.0).OR.(CMAX0.NE.0.0)) THEN
        ILMIN=2
        ILMAX=NCMAX0
        IF(LXOUT(0)) WRITE(LUNTRM,2020) ILMIN,ILMAX,NCMAX
 2020   FORMAT(/' PROGRAM''S MIN # OF CONTOURS = ',I3/
     >		  ' PROGRAM''S MAX # OF CONTOURS = ',I3/
     >		  ' CURRENT    MAX # OF CONTOURS = ',I3)
 281    CALL UREAD(
     >	  ' SUB:CONCTR >> ENTER MAX # OF CONTOURS YOU WANT TO SEE:$')
        ICMAX=NCMAX
        if(lchar('Q')) GOTO 10
        IERT=0
        IF(.NOT.LCHAR('X')) ICMAX=IDCOD(IERT)
        IF(IERT.NE.0) GO TO 281
        IF((ICMAX.LT.ILMIN).OR.(ICMAX.GT.ILMAX)) GO TO 280
        NCMAX=ICMAX
      ENDIF
C
C  AXES TYPES
 282  CONTINUE
      CALL NEUPAG
      IF(LXOUT(0)) WRITE(LUNTRM,2025) ITYPX0,ITYPY0
 2025 FORMAT(/' AXES TYPE CODES: 1-- LINEAR, 2-- LOG'/
     >  ' CURRENT DEFAULT SETTINGS:  X AXIS:  ',I1/
     >  '                            Y AXIS:  ',I1/)
 283  CALL UREAD(
     >  ' SUB:CONCTR >> ENTER NEW DEFAULT X AXIS TYPE:$')
      IF(LCHAR('X')) GO TO 284
      if(lchar('Q')) GOTO 10
      IANS=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 283
      IF((IANS.LE.0).OR.(IANS.GT.2)) GO TO 282
      ITYPX0=IANS
 284  CALL UREAD(
     >  ' SUB:CONCTR >> ENTER NEW DEFAULT Y AXIS TYPE:$')
      IF(LCHAR('X')) GO TO 289
      if(lchar('Q')) GOTO 10
      IANS=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 284
      IF((IANS.LE.0).OR.(IANS.GT.2)) GO TO 284
      ITYPY0=IANS
 289  CONTINUE
C
      GO TO 10
C
C  MAKE NON-DEFAULT PLOT:  GET ALL CONTROLS EXPLICITLY FROM USER
C
 300  CONTINUE
      CALL CONRDF(X,Z,Y,NX,NZ1,NY,ITYPX,ITYPY,
     >              XLAB,XUN,YLAB,YUN,ZUN,NLZMMX,
     >     XMIN,XMAX,CMIN,CMAX,YMIN,YMAX,NCTRY,ILOGC,
     >     ZCNTR1,ZWRK,NCMAX0)
      GO TO 180
      END
C******************** END FILE CONCTR.FOR ; GROUP CONCTR ******************

C******************** START FILE GAXCHK.FOR ; GROUP GAXES ******************
C==================
C  GAXCHK       GIVEN XMIN,XMAX,YMIN,YMAX OF GRAPH VIA PLOT1 COMMON,
C   CHECK THAT SPECIFIED GRAPH TYPE IS OK FOR GIVEN GRAPH LIMITS
C   AND AXIS TYPE
C  PASSED VARIABLES-- LUNTRM-- I/O CHANNEL FOR ERROR MESSAGE
C    IPTYP-- PLOT TYPE CODE (1=LINEAR, 2=SEMI-LOG (Y), ETC., AS
C       IN GAXES COMMON)
C       IF IPTYP=0 USE DEFAULT SELECTION IAXSEL IN GAXES COMMON
C
C  ICOD-- OUTPUT CODE TO PASS TO PLOT1 DPLOT1 SUBROUTINE TO GET
C   DESIRED AXIS TYPES.  MODIFIED IF ERROR CONDITION OCCURS
C
      SUBROUTINE GAXCHK(LUNTRM,IPTYP,ICOD)
C
      CHARACTER*1 ZXA1,ZYA1
C
      INCLUDE 'PLOT1MMX'
C
C  AXES COMMON
      INCLUDE 'GAXES_BLK'
C
      INCLUDE 'GSCALE_BLK'
C
      DATA ZXA1/'X'/
      DATA ZYA1/'Y'/
C
      IF(IGXINI.EQ.0) CALL GAXES0
C
      ISEL=IPTYP
      IF((ISEL.LE.0).OR.(ISEL.GT.4)) ISEL=IAXSEL
C
      IXC=IXXMAP(ISEL)
      IYC=IXYMAP(ISEL)
C
 10   CONTINUE
      IF((IXC.EQ.0).AND.(IYC.EQ.0)) GO TO 40
C
      IF(IXC.EQ.0) GO TO 20
C  CHECK X AXIS LIMITS
      IF((XMIN.LE.0.).AND.(XMAX.LE.0.)) GO TO 50
C
      IF(XMIN.LE.0.) WRITE(LUNTRM,1002) ZXA1
      IF(XMIN.LE.0) XMIN=GMINXP
C
 1002 FORMAT(' % ',A1,' LIMITS NOT SUITABLE FOR LOG PLOT'/
     >         '   STANDARD FIXUP TAKEN')
C
 20   CONTINUE
C
      IF(IYC.EQ.0) GO TO 40
C  CHECK Y-LIMITS
      IF((YMIN.LE.0.).AND.(YMAX.LE.0.)) GO TO 50
C
      IF(YMIN.LE.0.0) WRITE(LUNTRM,1002) ZYA1
      IF(YMIN.LE.0.0) YMIN=GMINYP
C
 40   CONTINUE
      ICOD=IAXCOD(ISEL)
      LOGX=IXXMAP(ISEL).eq.1
      LOGY=IXYMAP(ISEL).eq.1
      RETURN
C
C  BOTH LIMITS NEGATIVE
 50   CONTINUE
C
      WRITE(LUNTRM,1003) IAXNAM(ISEL)
 1003 FORMAT(' ? FUNCTION LIMITS NOT SUITABLE FOR ',A10,' PLOT.')
      ICOD=IAXCOD(1)
      LOGX=.FALSE.
      LOGY=.FALSE.
C
      RETURN
      	END
C******************** END FILE GAXCHK.FOR ; GROUP GAXES ******************

      subroutine ubr3int(ilun,ivalue,ier)
C
C  UFILES low level i/o routine
C  read 3 byte unsigned integer
C
      use UFILES
C
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(4)    ! small local buffer
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
C-----------------------------------------------------
C
      ier=0
C
      ivalue=0
C
      CALL UFLCHK(ILUN,'ubr3int   ',ICHAN,IER)
      IF(IER.NE.0) go to 999
C
      call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,4)
#ifdef __CRAY
      if(ilbuf(1).ne. char(1)) then
#else
      if(ilbuf(1).ne.1) then
#endif
         write(6,'('' ?ubr3int:  expected integer not found.'')')
         go to 999
      endif
      call ubi3dcod(ilbuf,2,ivalue)
C
      go to 1000
C
C  errors
C
 999  continue
      write(6,'('' ?UFLIB:  ubr3int low level i/o routine:  error.'')')
      ier=1
C
C  exit
C
 1000 continue
      return
      end

C-----------------------------------------------------------------------
C  URDTTY -- INSERT LINE OF TEXT IN APPLICATION TTY INPUT STREAM
C     THIS LINE OF TEXT WILL BE TAKEN AS IF TYPED IN BY THE USER, AND
C     WILL BE ECHOED OUT TO THE OUTPUT SCRIPT FILE IF AN OUTPUT SCRIPT
C     FILE IS OPEN
C
      SUBROUTINE URDTTY(ZSTR)
C
      USE USERIO
C
      CHARACTER*(*) ZSTR
C
C----------------------------------------
C
      IF(NPRBUF.EQ.0) LPRBUF=0
C
      NPRBUF=NPRBUF+1
      LPRBUF=LPRBUF+1
C
      PREBUF(LPRBUF)=ZSTR
C
      ILENZ=LEN(ZSTR)
      ILENP=LEN(PREBUF(LPRBUF))
C
      IF(ILENZ.GT.ILENP) THEN
        CALL UERMSG(
     >      '?URDTTY -- INPUT STRING TRUNCATED',PREBUF(LPRBUF),0)
      ENDIF
C
C  CHECK OUTPUT FLAG
      CALL URXOUT
C
      RETURN
      END

! 05may1999 fgtok -impno -s r8_precision.sub foo.sub "r8con.csh conversion"
C******************** START FILE UFDCOD.FOR ; GROUP URDUTS ******************
C------------------------------------------------------------
C& UFDCOD  UREAD CHARACTER STRING TO FLOATING POINT DECODE
C
      REAL*8 FUNCTION ur8dcod(STR,LENW,LENR,ICOD)
C
C  1ST THREE ARGUMENTS-- SEE URWORD
C   ICOD-- COMPLETION CODE
C    =0 NORMAL DECODE SUCCESSFUL
C    =-1 NULL WORD
C    =1 DECODE ERROR
C
      IMPLICIT NONE
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER ilen,lenw,lenr,ilw1,ilw,icod
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 z
C============
      CHARACTER*(*) STR
C
C  DECODE BUFFER
C
      CHARACTER*20 ZDCOD,ZDCODL
      CHARACTER*1 ZCHAR,ZCHAR0
C
C  LIMITS OF WORD, PRESUMED INTEGER
C
      ILEN=LEN(STR)
C
      ZDCOD=' '
      ZDCODL=' '
C
      ZCHAR0=STR(1:1)
      IF((STR(1:1).EQ.'+').OR.(STR(1:1).EQ.'-')) STR(1:1)='z'
      CALL URWORD(STR,1,LENW,LENR)
C
C  CHECK IF FLOATING POINT WORD IS PROPERLY DELIMITTED; I.E. IF USER
C  HAS "+" OR "-" AS DELIMITER, WELL THIS MIGHT BE PART OF THE EXPONENT
C  HERE!
C
      IF(LENW.LT.ILEN) THEN
        ILW1=LENW+1
        IF((STR(ILW1:ILW1).EQ.'+').OR.(STR(ILW1:ILW1).EQ.'-')) THEN
          ZCHAR=STR(LENW:LENW)
          IF((ZCHAR.EQ.'D').OR.(ZCHAR.EQ.'E').OR.(ZCHAR.EQ.'d').OR.
     >         (ZCHAR.EQ.'e')) THEN
C  AN EXPONENT!
            ZCHAR=STR(ILW1:ILW1)
            STR(ILW1:ILW1)='x'  ! TEMPORARY PLACEHOLDER
            CALL URWORD(STR,1,LENW,LENR)  ! RECOMPUTE WORD LIMITS
            STR(ILW1:ILW1)=ZCHAR  ! RESTORE EXPONENT SIGN
          ENDIF
        ENDIF
      ENDIF
C
      STR(1:1)=ZCHAR0
C
      ILW=LENW
      IF(ILW.GT.0) CALL URWRDL(STR(1:ILW),ZDCODL,LENW)
C
      IF(LENW.EQ.0) THEN
        ICOD=-1
        ur8dcod=0.0D0
        RETURN
      ELSE IF(LENW.GT.20) THEN
        ICOD=1
        ur8dcod=0.0D0
        RETURN
      ENDIF
C
      ILW=20-LENW+1
      ZDCOD(ILW:20)=ZDCODL(1:LENW)
C  ATTEMPT DECODE
      READ(ZDCOD,1000,ERR=900) Z
 1000 FORMAT(G20.0)
C
C  SUCCESS
      ur8dcod=Z
      ICOD=0
      RETURN
C
 900  CONTINUE
C  ERROR
      ICOD=1
      ur8dcod=0.0D0
      RETURN
      END
C******************** END FILE UFDCOD.FOR ; GROUP URDUTS ******************

real(fp) FUNCTION SGLICX(ZE)
  use iso_c_binding, only: fp => c_double
!  ZE IN EV
!  SGHECX IN CM**2
!
!  JANEV-LANGER-EVANS-POST,
!  ELEMENTARY PROCESSES IN HYDROGEN-HELIUM PLASMAS
!  FIT FOR REACTION 6.3.1, HE + HE++ <--> HE++ + HE DBL CHARGE EXCHANGE
!
!  FIT TABLE IN SS 8.1, P. 255
!
  real(fp) A631(9)
  DATA A631/-3.459818E+01_fp,-8.748942E-02_fp,-2.445604E-02_fp,&
       2.392295E-03_fp, 9.876388E-04_fp,-2.282013E-04_fp,&
       3.598361E-06_fp, 1.940270E-06_fp,-1.105795E-07_fp/
!
  ZLE=ALOG(ZE)
!
  ZLS=A631(9)
  DO I=8,1,-1
     ZLS=ZLS*ZLE+A631(I)
  enddo
!
  SGLICX=EXP(ZLS)
!
  RETURN
END FUNCTION SGLICX

C******************** START FILE XINTZ0.FOR ; GROUP IXCALC ******************
C-----------------------------------------------------------------
C  XINTZ0
C
C  INTERPOLATE ZONE BDY FCN TO VALUES AT ZONE CENTER.
C   Assume value is 0.0 at very center FZB(0) (if it existed)
C     tbt 6/1
 
 
      SUBROUTINE XINTZ0(FZB,FZC,N)
 
 
C	Updates:
C	tbt 06/01/95  At GA. Copied from XintzC
 
C	-----------------
      REAL FZC(N),FZB(N)
      Real Zfactor
C	-----------------
 
C       Interpolation AT CENTER - assume = 0
        FZB0 = 0.0
 
      FZC(1)= 0.5*(FZB0+FZB(1))
C
      DO 20 I=2,N
      IM1=I-1
      FZC(I)=0.5*(FZB(IM1)+FZB(I))
 20   CONTINUE
      RETURN
      END
C******************** END FILE XINTZ0.FOR ; GROUP IXCALC ******************

subroutine int_bcast(ival,icomm)

  ! broadcast a single integer -- follow with MPI_BARRIER, to be sure
  ! (in a paranoid way) that all processes have received the data.
  ! sender: CPU0; receiver: all others

#ifdef __MPI
  use mpi
#endif
  implicit NONE
  integer :: ival   ! broadcast value (input on cpu0, output on others)
  integer, intent(in) :: icomm   ! MPI communicator

#ifdef __MPI

  integer :: ierr

  call MPI_BCAST(ival,1, MPI_INTEGER, 0, icomm, ierr)
  if(ierr.ne.0) then
     call errmsg_exit(' ?int_bcast: MPI_BCAST error detected!')
  endif

  call MPI_BARRIER(icomm, ierr)
  if(ierr.ne.0) then
     call errmsg_exit(' ?int_bcast: MPI_BARRIER error detected!')
  endif

#endif

end subroutine int_bcast

subroutine intvec_bcast(ivals,numvals,icomm)

  ! broadcast an integer vector -- follow with MPI_BARRIER, to be sure
  ! (in a paranoid way) that all processes have received the data.
  ! sender: CPU0; receiver: all others

#ifdef __MPI
  use mpi
#endif
  implicit NONE
  integer, intent(in) :: numvals ! number of integer values to send/receive
  integer :: ivals(numvals) ! broadcast value (input on cpu0, output on others)
  integer, intent(in) :: icomm   ! MPI communicator

#ifdef __MPI

  integer :: ierr

  call MPI_BCAST(ivals,numvals, MPI_INTEGER, 0, icomm, ierr)
  if(ierr.ne.0) then
     call errmsg_exit(' ?int_bcast: MPI_BCAST error detected!')
  endif

  call MPI_BARRIER(icomm, ierr)
  if(ierr.ne.0) then
     call errmsg_exit(' ?int_bcast: MPI_BARRIER error detected!')
  endif

#endif

end subroutine intvec_bcast

C& UREADI  ISSUE UREAD PROMPT, RETURN INTEGER
C
      SUBROUTINE UREADI(PROMPT,I)
c
c  original code DMC -- probably from VAX, ca. 1980
c
      USE USERIO
C
      CHARACTER*(*) PROMPT
      INTEGER I
C
      IF(NLXOUT) WRITE(LUNTRM,1001) I
 1001 FORMAT(' [OLD VALUE:  ',I10,']')
C  SAVE DEFAULT VALUE
      II=I
C
 10   CONTINUE
C  RESTORE DEFAULT VALUE AFTER ERROR
      I=II
C
      CALL UREAD(PROMPT)
C
C  ACCEPT DEFAULT (OLD VALUE)?
      IDFLT=IXUOPC('QX,$')
      IF(IDFLT.NE.0) THEN
        IF(NLXOUT) WRITE(LUNTRM,1002)
 1002 FORMAT(' % OLD VALUE RETAINED')
        GO TO 20
      ENDIF
C
      I=IDCOD(IER)
      IF(IER.NE.0) GO TO 10
C
 20   CONTINUE
      RETURN
      END

c--------------------

      subroutine ureadi_nrun(prompt,irun)
c
c  prompt for an integer run number; but also allow translation
c  of a string of form nnnnnAmm -> nnnnn01mm
c
c  this routine does not include 'USERIO'...

      implicit NONE

      character*(*), intent(in) :: prompt
      integer, intent(inout) :: irun     ! old value may be retained

c----------------
      integer :: ii  ! old value, saved...
      character*26 :: alphab = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      character*20 :: input_word,zincod
      character*2 :: zi2
      integer :: ic,id,ilen,lnout,ialph,istat,ixuopc,idflt
      logical :: lxout
c----------------

      ii=irun  ! save old value

      IF(LXOUT(0)) WRITE(LNOUT(0),1001) II
 1001 FORMAT(' [OLD VALUE:  ',I10,']'//
     >     '  "runid" translations to integer are supported:'/
     >     '  nnnnnAmm -> nnnnn01mm, nnnnnBmm -> nnnnn02mm, etc.'/)

      do
         irun=ii  ! restore old value (e.g. after error)

         CALL UREAD(PROMPT)
C
C  ACCEPT DEFAULT (OLD VALUE)?
         IDFLT=IXUOPC('QX,$')
         IF(IDFLT.NE.0) THEN
            IF(LXOUT(0)) WRITE(LNOUT(0),1002)
 1002       FORMAT(' % OLD VALUE RETAINED')
            exit
         ENDIF
C
C  user input -- try to parse...
C
         call cdcod(input_word)
C
         ilen=len(trim(input_word))
         if(ilen.gt.15) then
            call uermsg('"RUNID" number too long',input_word,0)
            cycle
         endif
C
         ialph=0
         zincod=' '
         id=21

         do ic=ilen,1,-1
            if(ic.lt.(ilen-3)) ialph=99  ! set if too late for letter code
            if((ialph.gt.0).or.(ic.ge.(ilen-1))) then
                                ! just copy character
               id=id-1
               zincod(id:id)=input_word(ic:ic)
            else
               ialph=index(alphab,input_word(ic:ic))
               if(ialph.eq.0) then
                                ! just copy character
                  id=id-1
                  zincod(id:id)=input_word(ic:ic)
               else
                                ! encode letter
                  write(zi2,'(I2.2)') ialph
                  zincod(id-2:id-1)=zi2
                  id=id-2
                                ! ialph remains set; just 1 letter allowed.
               endif
            endif
         enddo

         read(zincod,'(I20)',iostat=istat) irun
         if(istat.ne.0) then
            call uermsg('"RUNID" integer decode error',input_word,0)
            cycle
         endif

         exit
      enddo

      return
      end

subroutine urunid(itype,file_path,runid,mds_server,tree_name,tokyy,shotno, &
     trread_id,ierr)
!
!  prompt user, get enough information for full identification of a TRANSP
!  run, either filename or MDS+ path
!
  implicit NONE
!
! arguments (all output; input is from terminal or script)
!
!   on exit:  itype=-1  -- user quit without giving runid
!                  =0   -- user gave file path & runid
!                  =1   -- user gave server, tree & shot no.
!                  =2   -- user gave server, tree, tok.yy & runid
!
  integer itype
!
  character*(*) file_path
  character*(*) runid
  character*(*) mds_server
  character*(*) tree_name
  character*(*) tokyy
  integer shotno
!
  character*(*) trread_id  ! composite id for trread kconnect subroutine...
!
  integer ierr  ! completion code:  0 if a runid was acquired.
!
! *** caution *** this routine does not check validity of runid entered!
!
!------------------------------------
!
  logical lchar,lxout
  integer ilunt,lnout
  integer il,ilr,ils,ilt,ila,ily
  integer i,iok,iert,idcod,iservr
!
  character*10 ashot
!
  integer, parameter :: iservrs = 3
  integer, dimension(iservrs) :: itypes
  character*40, dimension(iservrs) :: servrs
  character*2 cab
!
  servrs(1)='TRANSPGRID.PPPL.GOV'
  itypes(1)=2                ! treename="TRANSP", tok.yy & runid
  servrs(2)='ALFA60.PSFC.MIT.EDU'
  itypes(2)=1                ! variable treename, shot no.
  servrs(3)='ATLAS.GAT.COM'
  itypes(3)=2                ! treename="TRANSP", tok.yy & runid
!
  cab='AB'
!
!------------------------------------
!
  ilunt=lnout(0)
!
  ierr=0
  file_path=' '
  runid=' '
  mds_server=' '
  tree_name=' '
  tokyy=' '
  shotno=0
  trread_id=' '
!
  call uread( &
       'urunid:  enter "F" for TRANSP data files, "M" for MDS+, "Q" to quit:$')
  if(lchar('Q')) then
     ierr=1
     itype=-1
  else if(lchar('F')) then
     itype=0
     call unixfile('urunid:  path to directory containing run',file_path)
     il=len_trim(file_path)
     if(file_path(il:il).ne.'/') then
        il=il+1
        file_path(il:il)=':'
     endif
     call ureadw('urunid:  specify TRANSP runid:$',runid)
     ilr=len_trim(runid)
!
     trread_id='FILE:'//file_path(1:il)//runid(1:ilr)
!
  else if(lchar('M')) then
     iok=0
     do while(iok.eq.0)
        if(lxout(0)) then
           write(ilunt,*) &
             ' type A servers:  transp runs identified by tree name & shot no.'
           write(ilunt,*) &
             ' type B servers:  transp runs identified by tok.yy & runid.'
           write(ilunt,*) ' '
           write(ilunt,*) ' known servers:'
           write(ilunt,*) ' #   type   name'
           do i=1,iservrs
              write(ilunt,'(1x,i2,t7,a1,4x,a)') i,cab(itypes(i):itypes(i)), &
                   servrs(i)
           enddo
           write(ilunt,*) ' '
           write(ilunt,*) ' enter server #  --OR--'
           write(ilunt,*) ' enter "S" to specify a different server  --OR--'
           write(ilunt,*) ' enter "Q" to quit.'
           write(ilunt,*) ' '
        endif
        call uread('urunid:  server option:$')
        if(lchar('Q')) then
           ierr=1
           itype=-1
           iok=1
        else if(lchar('S')) then
           call ureadw('urunid:  specify server name:$',mds_server)
           if(lxout(0)) then
              write(ilunt,*) &
             ' type A servers:  transp runs identified by tree name & shot no.'
              write(ilunt,*) &
             ' type B servers:  transp runs identified by tok.yy & runid.'
           endif
           call uread('urunid:  server type code "A" or "B":')
           if(lchar('A')) then
              itype=1
              iok=2
           else if(lchar('B')) then
              itype=2
              iok=2
           else
              call uermsg('?urunid -- unrecognized server type code',' ',0)
              iok=0
           endif
        else
           iservr=idcod(iert)
           if(iert.eq.0) then
              if((iservr.gt.0).and.(iservr.le.iservrs)) then
                 mds_server=servrs(iservr)
                 itype=itypes(iservr)
                 iok=2
              endif
           endif
        endif
!
        if(iok.eq.2) then
           if(itype.eq.1) then
              call ureadw('urunid:  TRANSP tree name:$',tree_name)
              call ureadi('urunid:  shot number:$',shotno)
              ils=len_trim(mds_server)
              ilt=len_trim(tree_name)
              ashot=' '
              write(ashot,'(i10)') shotno
              ila=len_trim(ashot)
              do i=1,ila
                 if(ashot(i:i).ne.' ') exit
              enddo
              trread_id='MDS+:'//mds_server(1:ils)//':'// &
                   tree_name(1:ilt)//'('//ashot(i:ila)//')'
           else
              tree_name='TRANSP'
              call ureadw('urunid:  tok.yy code (e.g. "TFTR.95"):$',tokyy)
              call ureadw('urunid:  runid:$',runid)
              ils=len_trim(mds_server)
              ilt=len_trim(tree_name)
              ily=len_trim(tokyy)
              ilr=len_trim(runid)
              trread_id='MDS+:'//mds_server(1:ils)//':'// &
                   tree_name(1:ilt)//'('//tokyy(1:ily)//','// &
                   runid(1:ilr)//')'
           endif
        endif
!
     enddo
  endif
!
  if(itype.ge.0) write(ilunt,*) &
       ' urunid:  run path:  ',trread_id(1:len_trim(trread_id))
  return
end subroutine urunid

C---------------------------------------
C  repack 2 i*2 streams into an i*4 stream
C  final step in IEEE FP decompression
C
      subroutine repki2(iray,i2hi,i2lo,ibuf)
C
      integer*2 i2hi(ibuf),i2lo(ibuf)
      integer*2 iray(2,ibuf)
C
      do i=1,ibuf
         iray(1,i)=i2hi(i)
         iray(2,i)=i2lo(i)
      enddo
C
      call packordr(iray,ibuf,0)  ! local byte order
C
      return
      end
C---------------------------------------

C******************** START FILE URDCMI.FOR ; GROUP UREAD5 *************
C
C-------------------------------------------------------------------
C&  URDCMI   EXECUTE UREAD COMMAND (PROGRAM CALLABLE)
C
      SUBROUTINE URDCMI(ZSTR,IER)
C
      USE USERIO
C
      CHARACTER*(*) ZSTR	! COMMAND STRING
C
      CHARACTER*8 UCNTRL	! COMMAND CONTROL STRING
      CHARACTER*(urdbufl) ZCBUFF  ! TEMPORARY STORAGE FOR TYPEAHEAD BUFFER
C
      LOGICAL ILHOLD		! HOLD TYPEAHEAD SWITCH
C
C  SET COMMON SWITCH INDICATING PROGRAM REQUESTED COMMAND EXECUTION
      LCMDIN=2
C
C  CHECK INPUT LENGTH
      IL=LEN(ZSTR)
      IF((IL.LT.1).OR.(IL.GT.LBUFF)) THEN
        CALL UERMSI(
     >'?CALL URDCMI(commmand,istat) COMMAND STRING LENGTH ERROR',IL,1)
        IER=1
        RETURN
      ENDIF
C
C  SAVE TYPEAHEAD BUFFER
      ZCBUFF=CBUFF
C
C  INSERT COMMAND STRING IN TYPEAHEAD BUFFER
      CALL UCBCLR
      CBUFF(1:IL)=ZSTR
C
C  ENABLE MULTIPLE COMMANDS ON LINE
      ILHOLD=NLHOLD
      NLHOLD=.FALSE.
C
C  CHECK COMMAND - GENERATE CONTROL STRING - MULTICOMMAND LOOP
 10   CONTINUE
      CALL URCSTR(UCNTRL)
C
C  WHICH COMMAND?
      CALL UDECOD
      ICMD=JXUOPC(UCNTRL,DBUFF(1))
C
      IF(ICMD.EQ.0) THEN
        CALL UERMSG(
     >' ? CALL URDCMI(command,istat) ERROR:  INVALID COMMAND',ZSTR,1)
        IER=1
        RETURN
      ENDIF
C
C  EXECUTE COMMAND
C
      CALL URDSPC(ICMD,IRET,IDUM,IER)
C
      IF(IER.NE.0) THEN
        CALL UERMSG(
     >' ? CALL URDCMI(command,istat) DETECTED ERROR, COMMAND:',ZSTR,1)
        NLHOLD=ILHOLD
        RETURN
      ELSE IF(IRET.EQ.3) THEN
        CALL UERMSG(
     >' ? CALL URDCMI(command,istat) INVALID "*" COMMAND:',ZSTR,1)
        NLHOLD=ILHOLD
        RETURN
      ENDIF
C
C  COMMAND MORE COMMANDS?
C
      IF(NCHARC.GT.0) GO TO 10
C
C  RESTORE TYPEAHEAD BUFFER
C
      NLHOLD=ILHOLD
      CBUFF=ZCBUFF
      CALL UDECOD
C  RECHECK OUTPUT FLAG
      CALL URXOUT
C
      IF(NLECHO.AND.(IER.EQ.0)) WRITE(LUNTRM,3001) ZSTR
 3001 FORMAT(
     >' % COMMAND(S) EXECUTED BY CALL URDCMI, INPUT STRING:'/1X,A)
C
      RETURN
      END
C******************** END FILE URDCMI.FOR ; GROUP UREAD5 ***************

      subroutine ufmds_size(znode,idimn,nact,ier)
      use UFILES
C
C  get size of dimension
C
      character*(*) znode       ! signal path (input)
      integer idimn             ! dimension # (input)  1,2,... (see note)
C
      integer nact              ! size of dimension (output)
      integer ier               ! return code, 0 = normal (output)
C
C  note:  ufmds_size counts 1 as 1st dim of signal, 2 as 2nd dim, ...
C  but MDS+ counts from 0!
C
C---------------------------------
C History:
C 11/18/99 CAL: new calling arguments for mds_value
C
C------------------------------
C
      character*128 zerrmsg
      character*1 zdimn
      integer     idescr_long, iretl
C
C------------------------------
C
      ier=0
      iln=max(1,len_trim(znode))
      idimc=idimn-1
      if((idimc.lt.0).or.(idimc.gt.9)) then
         ier=1
         write(ufelun,9507) idimn
 9507    format(' ?UFMDS_SIZE:  programming error, idimn=',i9)
         return
      endif
C
      write(zdimn,'(i1)') idimc
C
      istat=mds_value(
     +     'size(dim_of('//znode(1:iln)//','//zdimn//'))',
     +     idescr_long(nact),iretl)
      if(mod(istat,2).ne.1) then
         call ufmds_err('UFMDS_SIZE',istat,ier,zerrmsg,ilm)
         write(ufelun,9508) idimc,znode(1:iln),zerrmsg(1:ilm)
 9508    format('  seeking size of MDS+ dim ',i1,': ',a/2x,a)
      endif
C
      return
      end
 

C	                             UFLastNb.for
 
      Subroutine UFLastNb(Cstring, Inb)
 
 
C	Return in INB the position of the last non-blank character in
C	string Cstring.
 
      Character*(*) Cstring
      Integer Inb
      Integer Ilenc, I, Ij
 
 
      INB = 0
      IlenC = Len(Cstring)
 
      If (IlenC .Gt. 0)  Then
        Do 100 I=1,IlenC
          Ij = IlenC-1+1
          If (Cstring(Ij:Ij) .Ne. ' ')  Then
      	Inb = Ij
      	Go To 900
          End If   ! Cstring
  100   Continue
      End If   ! IlenC
 
  900   Continue
      Return
      End

      subroutine fwc_delete1(path_expr,ier)
C
C  access to fwc_delete, with single argument of form <path>/<wc-expr>
C  break the string argument into two pieces; "*" must be in the filename
C  tail; no support yet for wildcard in directory path
C
      implicit NONE
C
      character*(*), intent(in) :: path_expr
C
      integer, intent(out) :: ier
C
C---------------------
      integer :: ilen,ic,ipath_end
C---------------------
      ier = 0

      ilen = len(trim(path_expr))
      if(ilen.eq.0) then
         write(6,*) ' ?fwc_delete1 -- path_expr argument is blank.'
         ier = 1
         return
      endif
C
      ipath_end=0
      do ic=ilen,1,-1
         if(path_expr(ic:ic).eq.'/') then
            ipath_end=ic
            exit
         endif
      enddo
C
      if(ipath_end.eq.ilen) then
         call fwc_delete(path_expr(1:ilen),' ',ier)
      else if(ipath_end.eq.0) then
         call fwc_delete(' ',path_expr(1:ilen),ier)
      else
         call fwc_delete(path_expr(1:ipath_end),
     >        path_expr(ipath_end+1:ilen),ier)
      endif
C
      return
      end
C------------------------------------------------------------------------
      subroutine fwc_delete(path,expr,ier)
C
C  dmc 16 June 2011 -- clean out selected files in a directory
C    (hidden files & subdirectories not included)
C
C    expr = * -- remove all files
C    expr = <prefix>* -- remove all files starting w/string <prefix>
C    expr = *<suffix> -- remove all files ending w/string <suffix>
C    expr = <prefix>*<suffix> -- remove all files starting & ending
C           w/strings <prefix> and <suffix> respectively
C
C  wild card symbol "*" must appear exactly once in expr
C
      implicit NONE
C
      character*(*), intent(in) :: path  ! directory to be cleaned...
      character*(*), intent(in) :: expr  ! wildcard expression
      integer, intent(out) :: ier        ! completion status, 0=normal
C
C  if (path) is blank, remove files in $cwd !!
C
C  return error code
C    ier=0 -- success
C    ier=1 -- error
C
      integer ilp,ilw,istar,nstar,ii
C
      character*200 :: zexpr
C
#include "fpreproc/byte_declare.h"
      byte_declare cpath(500),cprefix(100),csuffix(100)
      integer cclean_dir,cwc_delete
C
C----------------------------------
C
      ier=0
C
      ilp=len_trim(path)
C
      if(index(path(1:ilp),'*').gt.0) then
         write(6,*) ' ?fwc_delete:  wildcard in directory path: ',
     >        ' not supported.'
         write(6,*) '  '//path(1:ilp)
         ier = 1
         return
      endif
C
      if(len(adjustl(trim(expr))).gt.len(zexpr)) then
         write(6,*) ' ?fwc_delete:  wildcard expression too long: ',
     >        trim(expr)
         ier=1
         return
      endif
C
      zexpr = adjustl(trim(expr))
C
      ilw=len_trim(zexpr)
      if(ilw.eq.0) then
         write(6,*) ' ?fwc_delete:  wildcard expression is blank.'
         ier=1
         return
      endif
C
      nstar=0
      do ii=1,ilw
         if(zexpr(ii:ii).eq.'*') then
            nstar=nstar+1
            istar=ii
         endif
      enddo
C
      if(nstar.eq.0) then
         write(6,*) ' ?fwc_delete: "*" missing in wildcard expression:',
     >        ' '//trim(zexpr)
         ier=1
         return
      endif
C
      if(nstar.gt.1) then
         write(6,*) ' ?fwc_delete: multiple "*" symbols in ',
     >        'wildcard expression: '//trim(zexpr)
         ier=1
         return
      endif
C
      if(ilp.eq.0) then
         call cstring('./',cpath,'2C')
      else if(path(ilp:ilp).ne.'/') then
         call cstring(path(1:ilp)//'/',cpath,'2C')
      else
         call cstring(path(1:ilp),cpath,'2C')
      endif
C
      if(ilw.eq.1) then
         !  bare "*": use cclean_dir(cpath), delete all files...
         ier=cclean_dir(cpath)
      else
C
C  prefix is zexpr(1:istar-1); suffix is zexpr(istar+1:ilw)
C  (can be null)
C
#if __CRAY || __SX
         cprefix(1)=char(0)
         csuffix(1)=char(0)
#else
         cprefix(1)=0
         csuffix(1)=0
#endif
         if(istar.gt.1) then
            call cstring(zexpr(1:istar-1),cprefix,'2C')
         endif
         if(istar.lt.ilw) then
            call cstring(zexpr(istar+1:ilw),csuffix,'2C')
         endif
C
         ier=cwc_delete(cpath,cprefix,csuffix)
      endif
C
      return
      end

   module mmpi
!. mmpi                              basic MPI quantities
!
!
!  Author                            jim.conboy@jet.uk
!  Version                           1.00,  28Nov2011
!  Modifications
!
!  1.00  28Nov2011                   Jim.Conboy@ccfe.ac.uk
!                                    Written
!----_^---------------------------------=========================================|
!
!
   use logmod
#ifdef __MPI
   use mpi
#endif
   implicit  none
   private
   public  :: mmpi_init         &
             ,mmpi_end          &
             ,cmpitag
!
   public  :: mpi_id            &
             ,mpi_np            &
             ,mpi_cw            &
             ,iam_0, not_0      &
             ,mpi_run           &
             ,not_mpi
!
!..GLOBAL
!  variable                          :: name                ! description!
   integer  :: mpi_id    = 0     & ! process id
              ,mpi_np    = 0     & ! # processes     
              ,mpi_CW    = 0       ! mpi_comm_world
!
   logical  :: iam_0   = .true.  & ! process 0
              ,not_0   = .false. & ! not ..
              ,mpi_run = .false. & ! MPI active
              ,not_mpi = .true.    !     inactive
!
   character(len=8)  :: cmpi_id             ! id as char string
   contains

  subroutine mmpi_init( istat )
  !.. mmpi_init                        initialise mpi & mmpi
  !                                    codesys/source/portlib/mmpi.mmpi_init.
  !
  !
  !  Author                            Jim.Conboy@ccfe.ac.uk
  !  Version                           1.00,  28Nov2011
  !  Modifications
  !
  !  1.00  28Nov2011                   Jim.Conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..Arguments
  !
  integer, intent(out)  :: istat          !  return status, 0=OK
  !
  !..local
  integer  :: i              ! loop index 
  !
  character(len=*),parameter  :: cSr='portlib/mmpi.mmpi_init'
  !----------------------------------::================!.........................|
  !
  istat = 0
  if( mpi_np /= 0 )  return
  !
#ifdef __MPI
  call MPI_INIT( istat )
  if( istat /= 0 )  then
!     call errorlog( cSr, ' error from MPI_INIT ' )
     call bad_exit()
  endif
  !
  mpi_CW  =  MPI_COMM_WORLD
  call MPI_COMM_RANK( mpi_CW, mpi_id, istat )
  call MPI_COMM_SIZE( mpi_CW, mpi_np, i     )
  istat = max( istat, i )
  if( istat /= 0 )  then
!     call warnlog( cSr, istat,' from MPI_COMM_Rank or SIZE  ' )
  endif
  !
  iam_0 = mpi_id == 0
  not_0 = mpi_id /= 0
  mpi_run = .true.
  not_mpi = .false.
  write(cmpi_id,'(i8)') mpi_id
  cmpi_id = ' '//adjustl( cmpi_id)
  !
#else
!  call warnlog( cSr//' called but not MPI version ' )
  mpi_id = 0
  mpi_np = 1    ! it had better be..
  mpi_run = .false.  
  not_mpi = .true.
  !
#endif
  write(6,'(2a,i4,a,i4)')  &
    cSr,' -I- MPI ID ', mpi_id,' # proc =', mpi_np
  !
  end subroutine mmpi_init

  subroutine mmpi_end( istat, labort )
  !.. mmpi_end                         Terminate mpi run
  !                                    codesys/source/portlib/mmpi.mmpi_end.
  !
  !
  !  Author                            Jim.Conboy@ccfe.ac.uk
  !  Version                           1.00,  12Dec2011
  !  Modifications
  !
  !  1.00  12Dec2011                   Jim.Conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..Arguments
  !
  integer, intent(out)  :: istat          !  return status, 0=OK
  logical, intent(in), optional  :: labort         ! call mpi_abort, if .T
  !
  !..local
  integer  :: i              ! loop index 
  !
  character(len=*),parameter  :: cSr='portlib/mmpi.mmpi_end'
  !----------------------------------::================!.........................|
  !
#ifdef __MPI
  if( present( labort ))  then
     if( labort )  then
!        call warnlog( cSr, cmpi_id//' calling MPI_ABORT' )
        call MPI_ABORT( mpi_CW, istat, istat )
  return
  endif
  endif
  !
!  call infolog( cSr, cmpi_id//' calling MPI_FINALIZE ' )
  write(6,*) cSr, ' -I- ID',cmpi_id//' calling MPI_FINALIZE '
  call MPI_BARRIER( mpi_CW, istat )
  call MPI_FINALIZE( istat )
  !
#endif
  end subroutine mmpi_end


      function cMPItag( id  )
  !.. cMPItag                             Return character string ( mpi_nnnn ) for MPI 
  !                                       process id
  !                                       codesys/source/portlib/mmpi.cMPItagcMPItag.
  !
  !
  !     Author                            Jim.Conboy@ccfe.ac.uk
  !     Version                           1.00,  01Dec2011
  !     Modifications
  !
  !     1.01  21May2012                   Jim.Conboy@ccfe.ac.uk
  !                                       Change Serial tag ( to agree with csh scripts )
  !     1.00  01Dec2011                   Jim.Conboy@ccfe.ac.uk
  !                                       Written
  !----_^---------------------------------=========================================|
  !
      implicit  none
  !
  !..GLOBAL
  !--   variable                       :: name           ! description
  !
  !..Arguments
  !
      character(len=8)  :: cMPItag         ! 
      integer, intent(in)  :: id 
  !
      character(len=*),parameter  :: cFn='portlib/mmpi.cMPItag'
  !----_^------------------------------::================!.........................|
  !
#ifdef __MPI
  if( abs(id) < 1000 )  then
    write(cMPItag,'(a,i4.4)')   'mpi_',abs(id)
  else
    write(cMPItag,'(a,i6.6)')   'm_',abs(id)
  endif
  !
#else
  cMPItag = 'ser-0'
#endif
   end function cMPItag

   end module mmpi

!-----------------------------------------------------------------------
!  PSGCHEV -- EVALUATE A CHEBYCHEV FIT TO A CROSS-SECTION
!
real(fp) FUNCTION psgchev8(ZE,EMIN,EMAX,CCHEV)
!
!
!  INPUT
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER nterms,k
!============
! idecl:  explicitize implicit DOUBLE PRECISION declarations:
  real(fp) eminl,emaxl,prev2,cheb,el,xnorm,twox,prev
!============
  real(fp) ZE		! INPUT ENERGY, BTW. EMIN AND EMAX INCL.
  real(fp) EMIN,EMAX	! ENERGY RANGE OF FIT -- ERROR IF OUTSIDE
!
  real(fp) CCHEV(9)	! CHEBYCHEV POLYNOMIAL FIT COEFFICIENTS
!
!  OUTPUT PSGCHEV = FIT VALUE RETURNED
!
!  ERROR MESSAGE AND ABORT ROUTINE CALLED IF ZE IS OUT OF RANGE
!
!  REF:  ALGORITHM COPIED FROM FORTRAN SOURCE EXAMPLE, APPENDIX A OF
!    ORNL-6090/V5, ATOMIC DATA FOR FUSION, VOLUME V,
!    "COLLISIONS OF CARBON AND OXYGEN IONS WITH ELECTRONS, H, H2, & He"
!    R.A. PHANEUF, R.K. JANEV, M.S. PINDZOLA
!
!-------------------------------------------------------------------
!
!  ERROR CHECK
!
  IF((ZE.LT.EMIN).OR.(ZE.GT.EMAX)) THEN
     WRITE(6,9001) ZE,EMIN,EMAX
     CALL bad_exit
9001 FORMAT(&
          ' ?PSGCHEV -- PASSED ENERGY ARGUMENT ZE=',1PE11.4/&
          '  NOT IN RANGE BETWEEN EMIN=',1PE11.4,' AND EMAX=',1PE11.4)
  ENDIF
!
!------------------------
!
  NTERMS=9
!
  EMINL=log(EMIN)
  EMAXL=log(EMAX)
!
  K=NTERMS
!
  PREV2=0.0_fp
  CHEB=CCHEV(K)
  K=K-1
!
  EL=log(ZE)
!
!  THIS NUMBER MAPS LOG(ZE) TO RANGE -1 TO 1 AS ZE RANGES FROM
!  EMIN TO EMAX
!
  XNORM=(2.0_fp*EL-EMINL-EMAXL)/(EMAXL-EMINL)
!
  TWOX=2.0_fp*XNORM
!
!  LOOP
!
10 CONTINUE
!
  PREV=CHEB
  IF(K.EQ.1) GO TO 20
!
  CHEB=CCHEV(K)+TWOX*PREV-PREV2
  PREV2=PREV
  K=K-1
!
  GO TO 10
!
20 CONTINUE
!
  CHEB=0.5_fp*CCHEV(1)+XNORM*PREV-PREV2
!
  CHEB=EXP(CHEB)
  psgchev8=CHEB
!
  RETURN
END FUNCTION psgchev8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

  subroutine mkdir( cdir, istat )
  !.. mkdir                            Create a directory ( tree); definition may
  !                                    contain environment variables
  !                                    codesys/source/portlib/mkdir.f90
  !
  !                                    fpopen is used to expand the directory name using 
  !                                    echo, so reproducing the (Bourne) shell syntax 
  !                                    
  !  Author                            jim.conboy@ccfe.ac.uk
  !  Version                           1.00,  20May2011
  !  Modifications
  !
  !  1.00  20May2011                   jim.conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  character(len=*), intent(inout)    :: cdir           ! the directory name
  integer, intent(out)               :: istat          ! return status, 0=OK
  !
  !..local
  logical                            :: lexist
  character(len=1)                   :: char
  character(len=256)                 :: cdir_ex &
                                       ,cbuf
  !
  character(len=*),parameter         :: cSr='portlib/mkdir'
  !----------------------------------::================!.........................|
  !
  !
  call fpopen( 'echo '//cdir//char(0), cdir_ex )             ! expand string
  print *,cSr,' -I- ',trim(cdir_ex )
  !
  call fpopen( 'mkdir -vp '//trim(cdir_ex)//char(0), cbuf )  ! & create directory
  !
  !   Test for success - a test that the file is in fact a directory
  !                      would be better
  !
  inquire( file=trim(cdir_ex), exist=lexist )                ! .. did we ?
  if( lexist )  then
    istat = 0
    cdir = cdir_ex
  else
    print *,cSr,' -E- could not create ',trim(cdir)
    istat = 1
  endif
  !
  return
  end subroutine mkdir

module bottoms_up

  ! trgraf-local module to control raising of lower portion of graph
  ! display to make room for an extra one or two lines of labels

  ! bottoms_up_sub.f90 contains routine for accessing this module data

  integer, parameter :: idybu = 23  ! raster count per line

  integer :: ibrk_lbl3 = 0  ! break point in "lbl3" passed to some graphs 

  integer :: ibu_raise = 0  ! #text lines by which to raise bottom portion

end module bottoms_up

module catfus_mod
 
  ! Fusion reaction indexing data
  ! the categorization comes originally from TRANSP at PPPL
  ! (http://w3.pppl.gov/transp)
 
  integer, parameter :: nreact=16    ! no. of indexed reactions
 
  ! reagents isotope species:
 
  character(len=3), parameter, dimension(nreact) :: r1 = &
       (/ 'D  ','D  ','D  ','D  ','T  ','T  ','T  ','HE3', &
       'T  ','HE3','T  ','HE3','D  ','D  ','D  ','D  '   /)
 
  character(len=3), parameter, dimension(nreact) :: r2 = &
       (/ 'T  ','HE3','D:P','D:N','T  ','HE3','D  ','D  ', &
       'D  ','D  ','D  ','D  ','T  ','HE3','D:P','D:N'   /)
 
  ! reagent categories:
  ! 0->thermal, 1->beam, 2->fusion product, 3->RF tail
 
  ! valid reagent1 categories, by reaction index  (lower indicies 
  ! allow beam or thermal;
  ! higher indices are special purpose, generally speaking).
 
  integer, parameter, dimension(nreact) :: typmin = &
       (/  0,  0,    0,    0,    0,  0,    1,  1,   &
       2,  2,    3,  3,    3,  3,    3,  3    /)
 
  integer, parameter, dimension(nreact) :: typmax = &
       (/  1,  1,    1,    1,    1,  1,    1,  1,   &
       2,  2,    3,  3,    3,  3,    3,  3    /)
 
  ! maximum valid reagent2 categories (1 means beam or thermal; 
  ! 0 means thermal only).
 
  integer, parameter, dimension(nreact) :: typ2max = &
       (/  1,  1,    1,    1,    1,  1,    0,  0,   &
       1,  1,    1,  1,    1,  1,    1,  1    /)
 
end module catfus_mod

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_remove_tag(tag)
      implicit none
      character*(*) tag
      mds_remove_tag = 0
      return
      end
#else
c-----------------------------------------------------------------------
c mds_remove_tag
c remove mdsplus tag
c
c input
c   tag   -- character
c returns
c   1          -- on success
c   odd number -- on error
c
c-----------------------------------------------------------------------
      integer function mds_remove_tag(tag)
      implicit none
      character*(*) tag
 
      integer     status, cmd_status, cmd_stat2
      integer     dsc_cmd_status, dsc_cmd_stat2
      integer     retlen
 
      integer istat, icmdstat
      character*4097 strarg
 
      integer descr, MdsValue, mds__long
      integer mdsdclfdo
      character*1    bcks
 
      bcks=char(92)                 ! x5c = '\'
 
      status = 0
 
      dsc_cmd_status = descr(mds__long(), cmd_status, 0)
C Check if open for edit
      strarg = 'GETDBI("OPEN_FOR_EDIT")' // CHAR(0)
      status = MdsValue(strarg, dsc_cmd_status, 0, retlen)
      istat    = mod(status, 2)
      icmdstat = mod(cmd_status, 2)
 
      if (istat.eq.1) then
C If failure, open for edit:
         if (cmd_status.ne.1) then
             dsc_cmd_stat2 = descr(mds__long(), cmd_stat2, 0)
C           strarg = 'tcl("edit $EXPT/shot=$SHOT")'//CHAR(0)
            print *,
     >      ' ?mds_remove_tag - Error: tree not open for edit'
            status = MdsValue(strarg, dsc_cmd_stat2, 0, retlen)
            istat    = mod(status, 2)
            icmdstat = mod(cmd_stat2, 2)
         endif
         if ((istat.eq.1) .and. (icmdstat.eq.1)) then
               strarg = 'tcl("remove tag ' //
     >                  tag // ' ")' //CHAR(0)
C     print *,strarg(1:80)
            status = MdsValue(strarg, dsc_cmd_status, 0, retlen)
            istat    = mod(status, 2)
            icmdstat = mod(cmd_status, 2)
            if (istat.eq.1) then
               status = cmd_status
            endif
         endif
      endif
      go to 100
 
 100  continue
 
      mds_remove_tag = status
 
      return
      end
 
#endif

subroutine r8bsmoo(zprof,zoption)
  !
  !  smooth radial profile -- triangular smooth
  !  (sum of cubics i.e. definite integrals of products of linear pieces).
  !
  !     *** smoothing half-width (in xi):  namelist control DXBSMOO ***
  !
  !  weighting fcn about each point x0 is:
  !
  !   w(x)=
  !     zero for |x-x0| >= dxbsmoo
  !     (1/dxbsmoo)-|x-x0|/(dxbsmoo*dxbsmoo) for |x-x0| <= dxbsmoo
  !
  !  this makes a symmetrical triangle of area 1 centered on x0 and with base
  !  2*dxbsmoo wide, height 1/dxbsmoo.
  !
  !  the smoothed function is treated as a sequence of linear segments.
  !
  !  f(x) = f(j)-x(j)*S + x*S    ... for x btw x(j) and x(j+1)
  !                                  and S = (f(j+1)-f(j))/(x(j+1)-x(j))
  !
  !  piecewise integration of w(x)*f(x) (quadratic pieces) btw data pts
  !  yields a sum of cubics evaluated as definite integrals.
  !
  !  curve will be "normalized" via znorm factor, prior to smooth, then
  !  "un-normalized" on the way back out.  Allows user to control the "units"
  !  of the space in which the smooth operation is carried out
  !
  !  zprof(...) -- profile to be smoothed
  !  zoption(...) -- if zoption(lcentr).gt.0.0 then
  !                    ...copy whole array into znorm
  !                    ...use dxbsmoo as smoothing parameter
  !                  if zoption(lcentr).le.0.0 then
  !                    ...set znorm to 1.0
  !                    ...set iopt = -zoption(lcentr)
  !                       ...iopt = 0 means standard bdy conditions
  !                       ...iopt = 1 means:  use reflection to fix point
  !                          at outer bdy, position lep1.
  !                    ...use zoption(lcp1) as smoothing parameter
  !
  !
  !
  !----------
  !
  use iso_c_binding, only: fp => c_double
  use r8bsmoo_mod
  !
  implicit none
  integer :: iopt,j,inzp1,in3zp1,iz
  integer :: ii,icen,ism,iamdone
  !============
  ! idecl:  explicitize implicit REAL declarations:
  real(fp) :: zxsmoo,zedge,zdpt,zdiff,zdbxi,zdbx2,zxcen
  real(fp) :: zx1b,zx2b,zf1b,zf2b,zx1a,zx2a,zf1a,zf2a,zfac,zdelx
  real(fp) :: zsumx,zsmx2,zslope,zcns,za,zb,zc,zans
  !============
  real(fp) :: zprof(MJ)                    ! in:  unsmoothed, out:  smoothed
  real(fp) :: zoption(MJ)                  ! controls
  !
  real(fp) :: znorm(MJ)                    ! presmooth normalization
  !
  real(fp) :: zwork(MJ)                    ! workspace
  real(fp) :: zworkx(3*MJ)
  real(fp) :: zworkf(3*MJ)
  !
  !-----------------------------
  ! check the smoothing parameter
  !
  if(zoption(lcentr).gt.0.0_fp) then
    ! beam code output smooth
    if(dxbsmoo.le.0.0_fp) return
    dxbsmoo=max(0.01_fp,min(0.2_fp,dxbsmoo))
    zxsmoo=dxbsmoo
    iopt=0
    do j=1,mj
      znorm(j)=zoption(j)
    end do
  else
    ! NCLASS code input smooth
    iopt=-zoption(lcentr)
    zxsmoo=zoption(lcp1)
    if(zxsmoo.le.0.0_fp) return
    zxsmoo=max(0.01_fp,min(0.2_fp,zxsmoo))
    do j=1,mj
      znorm(j)=1.0_fp
    end do
  end if
  !
  !----------------
  !
  !  boundary conditions:
  !    extrapolation by symmetric reflection at center
  !    flat extrapolation at edge
  !
  inzp1=nzones+1
  in3zp1=3*nzones+1
  do iz=1,nzones
    j=iz+lcentr-1
    zworkf(iz+nzones)=zprof(j)/znorm(j)
    zworkf(inzp1-iz) =zprof(j)/znorm(j)     ! reflection
    zworkf(in3zp1-iz)=zprof(ledge)/znorm(ledge)  ! flat extrap.
    zworkx(iz+nzones)=xi(j,2)
    zworkx(inzp1-iz)=-xi(j,2)
    zworkx(in3zp1-iz)=2*xi(lep1,1)-xi(j,2)
  end do
  !
  if(iopt.eq.1) then
    zedge=zprof(lep1)/znorm(lep1)
    zworkf(2*nzones+1)=zedge
    !  anti-symmetric reflection beyond edge point; this causes the
    !  symmetric smoothing operator to fix the edge point.
    do ii=2,nzones
      j=ledge+2-ii
      zdpt=zprof(j)/znorm(j)
      zdiff=zdpt-zedge
      zworkf(2*nzones+ii)=zedge-zdiff
    end do
  end if
  !
  !  working from zworkf & zworkx compute smoothed results and store
  !  back in zprof
  !
  zdbxi=1.0_fp/zxsmoo
  zdbx2=zdbxi*zdbxi
  !
  do iz=1,nzones
    j=iz+lcentr-1
    zprof(j)=0.0_fp  ! clear the sum
    icen=iz+nzones
    zxcen=zworkx(icen)
    zx1b=0.0_fp
    zx2b=0.0_fp
    zf1b=zworkf(icen)
    zf2b=zf1b
    do ism=1,nzones
      zx1a=zx1b
      zx2a=zx2b
      zf1a=zf1b
      zf2a=zf2b
      zx1b=zxcen-zworkx(icen-ism) ! reflected, for convenience
      zx2b=zworkx(icen+ism)-zxcen
      zf1b=zworkf(icen-ism)
      zf2b=zworkf(icen+ism)
      iamdone=0
      !
      !  deal with crossing left edge of weighting triangle
      if(zx1b.ge.zxsmoo) then
        iamdone=iamdone+1
        zfac=(zxsmoo-zx1a)/(zx1b-zx1a)
        zf1b=zf1a+(zf1b-zf1a)*zfac
        zx1b=zxsmoo
      end if
      !
      !  deal with crossing right edge of weighting triangle
      if(zx2b.ge.zxsmoo) then
        iamdone=iamdone+1
        zfac=(zxsmoo-zx2a)/(zx2b-zx2a)
        zf2b=zf2a+(zf2b-zf2a)*zfac
        zx2b=zxsmoo
      end if
      !
      !  add in left piece
      if(zx1a.lt.zxsmoo) then
        zdelx=zx1b-zx1a
        zsumx=zx1b+zx1a
        zsmx2=zx1b*zx1b+zx1b*zx1a+zx1a*zx1a
        zslope=(zf1b-zf1a)/zdelx
        zcns=(zf1a-zx1a*zslope)
        za=zcns*zdbxi
        zb=0.5_fp*(zslope*zdbxi-zcns*zdbx2)
        zc=-0.33333333333333333_fp*zslope*zdbx2
        zans=zdelx*(za+ zsumx*zb +zsmx2*zc)
        zprof(j)=zprof(j)+zans
      end if
      !
      !  add in right piece
      if(zx2a.lt.zxsmoo) then
        zdelx=zx2b-zx2a
        zsumx=zx2b+zx2a
        zsmx2=zx2b*zx2b+zx2b*zx2a+zx2a*zx2a
        zslope=(zf2b-zf2a)/zdelx
        zcns=(zf2a-zx2a*zslope)
        za=zcns*zdbxi
        zb=0.5_fp*(zslope*zdbxi-zcns*zdbx2)
        zc=-0.33333333333333333_fp*zslope*zdbx2
        zans=zdelx*(za+ zsumx*zb +zsmx2*zc)
        zprof(j)=zprof(j)+zans
      end if
      !
      !  test if done with this triangle
      if(iamdone.eq.2) go to 100
    end do                          ! ism, triangle piece loop
100 continue
    zprof(j)=zprof(j)*znorm(j)     ! un-normalize
  end do                             ! iz, profile zone loop
  !
  !  all done
  !
  return
end subroutine r8bsmoo

C-------------------------------------------------------------------
C  GSCSM0 - AUTOSCALE EVALUATION FOR MULTIPLOT DATA
C
C   USE GSCSET SUBROUTINE TO EVALUATE AUTOSCALE FOR EACH INDIVIDUAL
C   CONTOUR IN MULTIPLOT DATA; TAKE THE EXTREMA OF SCALES TO BE THE
C   AUTOSCALE FOR THE UPCOMING PLOT
C
      SUBROUTINE GSCSM0(XDATA,YDATA,NDATAX,NDATAY,
     >     IPTRX,IINCX,IPTRY,IINCY,LPTR,NPTR,ZLIM1,ZLIM2,IYONLY)
C
C
      REAL XDATA(NDATAX),YDATA(NDATAY)
C
C   XDATA(NDATAX)  STORAGE FOR "X" DATA IN (X,Y) PAIRS
C   YDATA(NDATAY)  STORAGE FOR "Y" DATA IN (X,Y) PAIRS
C
      INTEGER IPTRX(NPTR),IPTRY(NPTR),LPTR(NPTR)
C
C   LPTR(I)  NUMBER OF (X,Y) PTS IN I'TH CONTOUR
C   IPTRX(I)  ADDRESS IN XDATA OF 1ST X PT, I'TH CONTOUR
C    IINCX    SPACING BTW SUCCESSIVE X PTS
C   IPTRY(I)  ADDRESS IN YDATA OF 1ST Y PT, I'TH CONTOUR
C    IINCY    SPACING BTW SUCCESSIVE Y PTS
C
C   FOR I = 1 TO NPTR
C
C   ZLIM1,ZLIM2 - A PRIORI CONSTRAINTS ON X
C   IYONLY = 1 FOR MODIFICATION OF Y SCALE ONLY (NOT X)
C  ** SEE GSCMMX SUBROUTINE **
C
C  SCALE SETTING COMMON BLOCKS --
C
C    GMINX, GMAXX, GMINY, GMAXX -- OUTPUT COMPUTED AUTOSCALE ***
C
      INCLUDE 'GSCALE_BLK'
C
      DATA ZINFIN/1.E38/
C
C  START OF EXECUTABLE CODE
C
C  COMPUTE AUTOSCALE
C
      ZMINX=ZINFIN
      ZMAXX=-ZINFIN
      ZMINY=ZINFIN
      ZMAXY=-ZINFIN
C
      ZMINXP=0.0
      ZMINYP=0.0
C
      DO 10 I=1,NPTR
        IX=IPTRX(I)
        IY=IPTRY(I)
C
C  COMPUTE AUTOSCALE ( (X,Y) DATA MIN/MAX) FOR THIS ONE CURVE OUT OF
C  THE MULTIPLOT
C
        CALL GSCMMX(XDATA,NDATAX,YDATA,YDATA,0,NDATAY,
     >                IX,IINCX,IY,IINCY,LPTR(I),
     >                ZLIM1,ZLIM2,0)
C
C  TAKE THE MIN/MAX OF THE COMPUTED CURVE AUTOSCALES
C  AS THE MULTIPLOT AUTOSCALE
C
C  USE THE MIN-POSITIVE INFORMATION IF THE TRACE HAD
C  ANY POSITIVE NUMBERS IN IT
C
        IF(GMAXX.GT.0.0) THEN
          IF(ZMINXP.EQ.0.0) THEN
            ZMINXP=GMINXP
          ELSE
            ZMINXP=AMIN1(GMINXP,ZMINXP)
          ENDIF
        ENDIF
C
        IF(GMAXY.GT.0.0) THEN
          IF(ZMINYP.EQ.0.0) THEN
            ZMINYP=GMINYP
          ELSE
            ZMINYP=AMIN1(GMINYP,ZMINYP)
          ENDIF
        ENDIF
C
        ZMINX=AMIN1(ZMINX,GMINX)
        ZMAXX=AMAX1(ZMAXX,GMAXX)
        ZMINY=AMIN1(ZMINY,GMINY)
        ZMAXY=AMAX1(ZMAXY,GMAXY)
C
 10   CONTINUE
C
      GMINX=ZMINX
      GMAXX=ZMAXX
      GMINY=ZMINY
      GMAXY=ZMAXY
C
      GMINXP=ZMINXP
      GMINYP=ZMINYP
C
      RETURN
      END

C******************** START FILE GRF3X2.FOR ; GROUP GRF3X2 ******************
C============================================================
C  MOD DMC JUN 1988 - MADE THIS A SHELL FOR GRF3F2
C  REORGANIZING/ MODULARIZING THESE 3D PLOT INTERFACE ROUTINES
C
C  MOD DMC FEB 1986 - MAINTENANCE
C   *REMOVE ENCODE STATEMENTS
C   *IMPROVE 2D GRAPHICS LABELING
C   *REPLACE OBSOLETE "AGX" LABELING OF 3D ISOMETRIC PLOT
C   *GENERAL CLEANUP
C
C  *AG SECTION NOT CLEANED UP -- LOOKING TO CREATE NEW COMMON ROUTINE
C  TOO SHARE W/ GRF3 AND RPLOT VSN GRF3 ... SOMETIME SOON
C
C ====>>> COMPARITIVE GRAPHICS ****
C   COMPARE 2 FUNCTIONS OF 2 INDEPENDANT VARIABLES.
C   3D PLOTS OF EITHER FUNCTION INDEPENDANTLY;
C   2D PLOTS OF BOTH FUNCTIONS SIMULTANEOUSLY
C    BASED ON 1-FCN VERSION "GRF3TR.FOR"
C    D. MC CUNE 20 OCT 1980
C
C
C
C
      SUBROUTINE GRF3X2(X,Z,Z2,Y,ZWK,NX,NY,NZ1,
     >                  XLAB,YLAB,ZLAB1,ZLAB2,
     >                  XUN,YUN,ZUN,
     >                  ZTITLE,ITITLE,
     >                  IDIR,ISF,
     >                  IDEV,NSHOT,IAVTYP,NSHOT2,NS2,ISMTYP)
C
C  INTERACTIVE ROUTINE TO CONTROL PRODUCTION OF TWO AND
C  THREE DIMENSIONAL GRAPHS OF DATA FUNCTION OF TWO
C  INDEPENDANT VARIABLES.
C    3-D GRAPHS:  LABELING AND TITLEING CONTROLLED BY PASSED
C                 VARIABLES
C                 USER MAY SPECIFY SUBSET OF X-Y DOMAIN, AND
C                 # OF LINES OF CONSTANT X AND Y TO DRAW
C                 BY INTERACTIVE I/O.
C    2-D GRAPHS:  LABELING AND TITLEING CONTROLLED BY PASSED
C                 VARIABLES;
C                 USER HAS CONTROL OF HORIZONTAL AND VERTICAL
C                 SCALE BY INTERACTIVE I/O.
C                 USER SPECIFIES X CONSTANT WHILE Y VARIES OR
C                 VICE VERSA, BY INTERACTIVE I/O.
C
C  INPUT VARIABLES:
C    X       1ST INDEPENDANT VARIABLE VALUES, IN ASCENDING ORDER
C            CORRESPONDS TO FIRST DIMENSION OF Z ARRAY
C    Z,Z2    2-D ARRAYS OF DEPENDANT VARIABLES VALUES
C    Y       2ND INDEPENDANT VARIABLE VALUES, IN ASCENDING ORDER
C            CORRESNPONDS TO SECOND DIMENSION OF Z ARRAY.
C    Z(I,J) = Z AT (X(I),Y(J))
C
C    NX      # OF X VALUES
C    NY      # OF Y VALUES
C    NZ1     FIRST DIMENSION OF Z
C
C    XLAB    NAME OF FIRST INDEP. VARIABLE (E.G. 'RADIUS    ')
C            10 CHARACTERS ASCII.
C    YLAB    NAME OF SECOND INDP. VARIABLE (E.G. 'TIME      ')
C            10 CHARACTERS ASCII
C    ZLAB1,ZLAB2    NAMES OF DEPENDANT VARIABLES
C            (E.G. 'ELECTRON TEMPERATURE')
C            20 CHARACTERS ASCII
C    XUN     UNITS OF FIRST INDEP. VARIABLE (E.G. 'CM       $')
C            9 CHARACTERS ASCII TERMINATED BY '$' REQUIRED BY
C            FS ROUTINES.
C    YUN     UNITS OF SECOND INDEP. VARIABLE (E.G. 'SECONDS  $')
C    ZUN     UNITS OF DEPENDANT VARIABLE (E.G. 'EV       $')
C
C    ZTITLE  30 CHARACTER TITLE TO GO ON TOP OF 3-D GRAPH
C    ITITLE  WRITE ZTITLE IFF ITITLE=1
C
C    IDIR    =0==>X-AXIS ALONG BOTTOM OF SCREEN, Y-AXIS GOING
C                 'INTO' SCREEN FOR 3-D PLOTS.
C            =1==>INTERCHANGE X AND Y AXES.
C
C    ISF     FORMAT FLAG FOR SHOT NUMBERS TO BE DISPLAYED:
C            =0==> INTEGER   =1==> ASCII (A5)
C
C    NSHOT   5 DIGIT SINGLE SHOT NUMBER FOR DISPLAY ON 2-D
C            GRAPHS AND ON 3-D GRAPHS IF IAVTYP.EQ.0
C    IAVTYP  =0==> DATA IS DERIVED FROM A SINGLE SHOT
C            =1==> DATA IS AVERAGED FROM SEVERAL SHOTS
C
C    NSHOT2  LIST OF 5 DIGIT SHOT NUMBERS GOING INTO DATA AVG
C            IF IAVTYP.EQ.1
C    NS2     # OF SHOT NUMBERS IN NSHOT2
C
C    ISMTYP  =0==> DATA IS 'RAW' (NOT SMOOTHED)
C            =1==> DATA IS SMOOTHED.
C
C    ZWK      WORKSPACE OF DIMENSION 2 * NY AT LEAST.
C---------------------------
C
C  EXTERNAL REFERENCES:
C   3-D GRAFICS:  EZISUS    [MILLER.EZ]
C   2-D GRAFICS:  GRFHX2    (LOAD GRFHX2.FOR[TRANSP],
C                            DPLOT1.FOR)
C
C----------------------------
C
C  AUTHOR:  D. MC CUNE    15-MAY-79
C
C  REVISIONS:
C
C
C
C
C
C
C----------------------------
C   DECLARATIONS:
C
      DIMENSION X(NX),Y(NY),ZWK(NY,2),Z(NZ1,NY),NSHOT2(NS2)
      DIMENSION Z2(NZ1,NY)
      CHARACTER*10 ZLAB1(2),ZLAB2(2),ZTITLE(3),ZLAB(2),
     >     YLAB,XLAB,XUN,YUN,ZUN
      CHARACTER*4 IDEV
C--------------------------------------------------------------
C  DMC - MAINTENANCE - FEB 1986 - NEW LABELING BUFFERS
C
      CHARACTER*30 ZTITL
      CHARACTER*15 ZSHOT
C
C--------------------------------------------------------------
C
C DMC FEB 1986 - FIX LABELS
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LYES
      LOGICAL LYESC
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C ====================
C  START OF EXECUTABLE CODE
C
      LUNTRM=LNOUT(0)
C
      IF(ITITLE.EQ.1) THEN
        ZTITL=ZTITLE(1)//ZTITLE(2)//ZTITLE(3)
      ELSE
        ZTITL='                              '
      ENDIF
C
      zshot=' '
      IF((ISF.LE.1).AND.(NSHOT.NE.0)) THEN
         if(nshot.le.999999) then
            WRITE(ZSHOT,8005) IDEV,NSHOT
         else
            write(zshot,80051) idev,nshot
         endif
      ELSE IF(ISF.EQ.2) THEN
         WRITE(ZSHOT,80041) NSHOT
      ENDIF
C
 8005 FORMAT(A4,1x,I6)
80051 format(a4,1x,i10)
80041 FORMAT('RUN # ',I4)
C
      IPROC=0
      IPROC=IPROC+IAVTYP+2*ISMTYP
C
      CALL GRF3F2(X,Z,Z2,Y,ZWK,NX,NY,NZ1,
     >    XLAB,ZLAB1(1)//ZLAB1(2),ZLAB2(1)//ZLAB2(2),YLAB,
     >    XUN,ZUN,YUN,ZTITL,ZSHOT,IPROC)
C
      RETURN
      END

      SUBROUTINE gpreset
	
	
C      FUNCTIONAL DESCRIPTION:
C
C              give menu to set plot scale and axes defaults for
C	    subsequent 2d plots
C
C      DUMMY ARGUMENTS:
C
C              none
C
C      IMPLICIT INPUTS:
C
C              tty (UREAD)
C
C      IMPLICIT OUTPUTS:
C
C              GFLIB common via subroutine calls
C
C
C      SIDE EFFECTS:
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C------------------------
C
 10   CONTINUE
C
      IF(LXOUT(0)) WRITE(LNOUT(0),2001)
 2001   FORMAT(/' *NEW* ENTER "T" FOR 2D PLOT TIC/GRID/FRAME OPTIONS')
C
      CALL UREAD(
     >'GPRESET: TYPE "A" FOR AXES, "S" FOR SCALING DEFAULTS, OR "Q":$$')
C
        IF(LCHAR('A')) THEN
          CALL GAXSET(ISEL,1)
        ELSE IF(LCHAR('S')) THEN
          CALL GSCDEF
        ELSE IF(LCHAR('T')) THEN
          CALL GFTICI
        ELSE IF(LCHAR('Q')) THEN
          RETURN
        ELSE
          CALL UERMSG('GPRESET:  WHAT?',' ',0)
        ENDIF
C
      GO TO 10
C
      END

C******************** START FILE GRF3.FOR ; GROUP GRF3SG ******************
C============================================================
C
C  MOD DMC FEB 1986 - MAINTENANCE
C   *REMOVE ENCODE STATEMENTS
C   *IMPROVE 2D GRAPHICS LABELING
C   *REPLACE OBSOLETE "AGX" LABELING OF 3D ISOMETRIC PLOT
C   *GENERAL CLEANUP
C
C   *NOTE CLEANUP *NOT DONE* ON AG PLOT - WILL CHECK FOR CONSOLIDATION
C   OF INTERFACE W/ RPLOT VSN!
C
C-------------------------------
C  DMC JUNE 1988
C   THIS ROUTINE MADE A SHELL FOR THE NEW, STREAMLINED GRF3F1
C
C   NOTE SOME OF THE OLD ARGUMENTS TO GRF3 NO LONGER HAVE ANY EFFECT,
C   BUT ARE RETAINED FOR HISTORICAL REASONS ***
C     IDIR
C     NSHOT2(1..NS2)
C
C   IT IS SUGGESTED THAT NEW CODE USE THE GRF3F1 ROUTINE DIRECTLY
C
C-------------------------------
C
C  GRF3 "SG" VERSION
C  THIS VERSION USES THE NEW SG PACKAGE FOR 3D ISOMETRIC AND
C  ALL OTHER PLOTS, INSTEAD OF OLD AG/ EZIS KLUGE.
C  ALSO A NEW ARGUMENT IS ADDED:  IDEV = 4 CHARACTER DEVICE
C  CODE (I.E. PDX, PLT, TFTR ...)
C   THIS ROUTINE IS ORIENTED TOWARDS PLOTTING DIAGNOSTIC DATA FROM
C  TOKAMAK DEVICES BUT IDEV COULD BE "RUN " AND NSHOT COULD BE A
C  "RUN NUMBER" (MAX 5 DIGITS) ... BUT SEE ALSO ARGUMENT ISF
C
      SUBROUTINE GRF3(X,Z,Y,Z2,NX,NY,NZ1,
     >                  XLAB,YLAB,ZLAB,
     >                  XUN,YUN,ZUN,
     >                  ZTITLE,ITITLE,
     >                  IDIR,ISF,
     >                  IDEV,NSHOT,IAVTYP,NSHOT2,NS2,ISMTYP)
C
C  INTERACTIVE ROUTINE TO CONTROL PRODUCTION OF TWO AND
C  THREE DIMENSIONAL GRAPHS OF DATA FUNCTION OF TWO
C  INDEPENDANT VARIABLES.
C    3-D GRAPHS:  LABELING AND TITLEING CONTROLLED BY PASSED
C                 VARIABLES
C                 USER MAY SPECIFY SUBSET OF X-Y DOMAIN, AND
C                 # OF LINES OF CONSTANT X AND Y TO DRAW
C                 BY INTERACTIVE I/O.
C    2-D GRAPHS:  LABELING AND TITLEING CONTROLLED BY PASSED
C                 VARIABLES;
C                 USER HAS CONTROL OF HORIZONTAL AND VERTICAL
C                 SCALE BY INTERACTIVE I/O.
C                 USER SPECIFIES X CONSTANT WHILE Y VARIES OR
C                 VICE VERSA, BY INTERACTIVE I/O.
C
C  INPUT VARIABLES:
C    X       1ST INDEPENDANT VARIABLE VALUES, IN ASCENDING ORDER
C            CORRESPONDS TO FIRST DIMENSION OF Z ARRAY
C    Z       2-D ARRAY OF DEPENDANT VARIABLE VALUES
C    Y       2ND INDEPENDANT VARIABLE VALUES, IN ASCENDING ORDER
C            CORRESNPONDS TO SECOND DIMENSION OF Z ARRAY.
C    Z(I,J) = Z AT (X(I),Y(J))
C
C    NX      # OF X VALUES
C    NY      # OF Y VALUES
C    NZ1     FIRST DIMENSION OF Z
C
C    XLAB    NAME OF FIRST INDEP. VARIABLE (E.G. 'RADIUS    ')
C            10 CHARACTERS ASCII.
C    YLAB    NAME OF SECOND INDP. VARIABLE (E.G. 'TIME      ')
C            10 CHARACTERS ASCII
C    ZLAB    NAME OF DEPENDANT VARIABLE
C            (E.G. 'ELECTRON TEMPERATURE')
C            20 CHARACTERS ASCII
C    XUN     UNITS OF FIRST INDEP. VARIABLE (E.G. 'CM       $')
C            9 CHARACTERS ASCII TERMINATED BY '$' REQUIRED BY
C            FS ROUTINES.
C    YUN     UNITS OF SECOND INDEP. VARIABLE (E.G. 'SECONDS  $')
C    ZUN     UNITS OF DEPENDANT VARIABLE (E.G. 'EV       $')
C
C    ZTITLE  30 CHARACTER TITLE TO GO ON TOP OF 3-D GRAPH
C    ITITLE  WRITE ZTITLE IFF ITITLE=1
C
C    IDIR    =0==>X-AXIS ALONG BOTTOM OF SCREEN, Y-AXIS GOING
C                 'INTO' SCREEN FOR 3-D PLOTS.
C            =1==>INTERCHANGE X AND Y AXES.
C
C    ISF  CODE INDENTIFYING INTEGER IDENTIFIERS:
C   ISF=0 OR 1, THEN NSHOT/NSHOT2 ARE 5 DIGIT INTEGER "SHOT NUMBERS"
C   ISF=2, THEN NSHOT/NSHOT2 ARE 4 DIGIT "RUN NUMBERS"
C    IF ISF=0 OR 1 THEN A LABEL IS BUILT UTILIZING THE 4 CHAR
C     DEVICE CODE (E.G. "PDX "); IF ISF =2 THE LABEL BUILT IS
C     OF FORM "RUN ####"
C (NEW 17 MAR 1982):
C    IDEV 4 CHARACTER TOKAMAK DEVICE CODE/ ID CODE FOR PLOT
C    E.G. "PLT ", "PDX ", ...
C    NSHOT   5 DIGIT SINGLE SHOT NUMBER FOR DISPLAY ON 2-D
C            GRAPHS AND ON 3-D GRAPHS IF IAVTYP.EQ.0
C    IAVTYP  =0==> DATA IS DERIVED FROM A SINGLE SHOT
C            =1==> DATA IS AVERAGED FROM SEVERAL SHOTS
C
C    NSHOT2  LIST OF 5 DIGIT SHOT NUMBERS GOING INTO DATA AVG
C            IF IAVTYP.EQ.1
C    NS2     # OF SHOT NUMBERS IN NSHOT2
C
C    ISMTYP  =0==> DATA IS 'RAW' (NOT SMOOTHED)
C            =1==> DATA IS SMOOTHED.
C
C    Z2      WORKSPACE OF DIMENSION NY AT LEAST.
C---------------------------
C
C  EXTERNAL REFERENCES:
C   3-D GRAFICS:  FSISU3  (LOAD @PLTFSB[66,600],@PLTSUB[66,600]
C                                  @PLTUSR[66,600])
C   2-D GRAFICS:  GRFAH0    (LOAD GRFAH0.FOR[GOLD.TRANSP],
C                            DPLOT1.FOR)
C
C----------------------------
C
C  AUTHOR:  D. MC CUNE    15-MAY-79
C
C
C----------------------------
C   DECLARATIONS:
C
C
      DIMENSION X(NX),Y(NY),Z2(NY),Z(NZ1,NY),NSHOT2(NS2),ZL(20)
      CHARACTER*10 ZLAB(2),YLAB,XLAB,XUN,YUN,ZUN
      CHARACTER*(*) ZTITLE(3)
      CHARACTER*4 IDEV
C--------------------------------------------------------------
C  DMC - MAINTENANCE - FEB 1986 - NEW LABELING BUFFERS
C
      CHARACTER*45 ZTITL
      CHARACTER*15 ZSHOT
C
C--------------------------------------------------------------
C DMC FEB 1986 - FIX LABELS
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LYES
      LOGICAL LYESC
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C ====================
C  START OF EXECUTABLE CODE
C
      LUNTRM=LNOUT(0)
C
      IF(ITITLE.EQ.1) THEN
        ZTITL=ZTITLE(1)//ZTITLE(2)//ZTITLE(3)
      ELSE
        ZTITL='                              '
      ENDIF
C
      zshot=' '
      IF((ISF.LE.1).AND.(NSHOT.NE.0)) THEN
         if(nshot.le.999999) then
            WRITE(ZSHOT,8005) IDEV,NSHOT
         else
            write(zshot,80051) idev,nshot
         endif
      ELSE IF(ISF.EQ.2) THEN
         WRITE(ZSHOT,80041) NSHOT
      ENDIF
C
 8005 FORMAT(A4,1x,I6)
80051 format(a4,1x,i10)
80041 FORMAT('RUN # ',I4)
C
      IPROC=0
      IPROC=IPROC+IAVTYP+2*ISMTYP
C
      CALL GRF3F1(X,Z,Y,Z2,NX,NY,NZ1,
     >    XLAB,ZLAB(1)//ZLAB(2),YLAB,XUN,ZUN,YUN,ZTITL,ZSHOT,IPROC)
C
      RETURN
      END

      subroutine ubcget(ichan,ieod)
C
      use UFILES
#include "fpreproc/byte_declare.h"
C
C uncompress and
C  read character buffer; set flag if end of data detected.
C
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
C local buffer for length information
C
      byte_declare ilbuf(8)
      byte_declare bi2buf(2,ufcbuf)
      byte_declare eod, eod2, eod3
C
C----------------------------------------
C
#ifdef __CRAY
      integer hex1/z'81'/
      integer hex2/z'82'/
      eod  = char(hex1)
      eod2 = char(hex2)
      eod3 = char(3)
#else
      eod  = -1
      eod2 = -2
      eod3 = 3
#endif
      ioed=0
C
C  peek at next byte; flag if its eod code (-1)
C
      if(uiobuf(niobuf(ichan),ichan) .eq. eod) then
         ieod=1
         go to 1000
      endif
C
C  OK there is some data to get.
C
      ilun=uflun(ichan)
C
      call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,8)
C
      if(ilbuf(1).eq. eod) then
         ieod=1
         go to 1000  ! end of file
      endif
C
      if(ilbuf(1).ne.eod3) then
         write(6,'('' ?ubcget:  expected compressed char data'')')
         go to 999
      endif
C
C  get the unpacked length expected (bytes)
C
      call ubi3dcod(ilbuf,2,ilenb)
C
C  get the compressed data length (words)
C
      call ubi3dcod(ilbuf,6,iwords)
      ilenc=iwords*4
C
C  read the compressed data
C
      call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ufpack,ilenc)
C
C  decompress the data
C
      call xpand2(ufpack,iwords,bi2buf,1,ilenb,ierr)
      if(ierr.ne.0) then
         write(6,'('' ?ubcget:  decompress error, ierr='',i3)') ierr
         go to 999
      endif
C
      do i=1,ilenb
         uchbuf(i,ichan)=bi2buf(2,i)
      enddo
      if(ilenb.lt.ufcbuf) uchbuf(ilenb+1,ichan)=eod2  ! mark end of buffer
      nchbuf(ichan)=1
C
      go to 1000
C
 999  continue
C
 1000 continue
      return
      end

      subroutine listopt(list_max,list_cur,list,option)
C
C  fetch list argument values for a selected command line option; append
C  these to list.
C
C  input:  list(1),... list(list_cur) -- the list on input
C          option -- the option code which flags additional list values
C
C  output:  list_cur updated (but not past list_max)
C          list(1),... list(list_cur) -- the updated list.
C
C  list elements are appended in the order found within the command line.
C
C  example:  suppose "-I" flags arguments specifying directories to search
C      for "include" files.  Suppose that on input, list_cur=1 and list(1)='.';
C      option='-I'; list_max=10
C
C      the command line contains "... -I /usr/include  /usr/local/include"
C
C  then... /usr/include and /usr/local/include ... are appended to the list.
C  and list_cur is increased to 3.
C
C
      integer list_max                  ! max list length (input)
      integer list_cur                  ! current list length (input, updated)
      character*(*) list(list_max)      ! list of values (input, updated)
      character*(*) option              ! option flag (input)
C
C---------------------
C
      character*128 zarg
C
C---------------------
C
      if(option(1:1).ne.'-') then
         write(6,*) ' %listopt:  call error, option=',option,
     >      ' does not start with "-".'
         return
      endif
C
      call get_arg_count(inum)
C
      ii=0
 100  continue
C
      ii=ii+1
      if(ii.gt.inum) go to 500
C
C  find option code
C
      call get_arg(ii,zarg)
      if(zarg(1:1).ne.'-') go to 100
      if(zarg.ne.option) go to 100
C
C  found.
C
 120  continue
C
      ii=ii+1
      if(ii.gt.inum) go to 500
C
      call get_arg(ii,zarg)
      if(zarg(1:1).eq.'-') then
         ii=ii-1
         go to 100
      endif
C
C  element found; check for duplication
C
      idup=0
      do i=1,list_cur
         if(zarg.eq.list(i)) idup=1
      enddo
C
      if(idup.eq.0) then
C
C  add to list
C
         if(list_cur.lt.list_max) then
            list_cur=list_cur+1
            list(list_cur)=zarg
         else
            write(6,*) ' %listopt -- max list length = ',list_max,
     >         ' exceeded.'
         endif
      endif
      go to 120
C
 500  continue
      return
      end
 

      subroutine pbinwr(lun_warn,ichan,zfile,zdata,ndata,ier)
c
c  write a portable binary file, with given name,
c  containing zdata(1:ndata) -- single precision.
c
      implicit NONE
c
c  input arguments:
c
      integer lun_warn                  ! fortran lun for messages
c
      integer ichan                     ! i/o channel number, btw 0 and 100
c
c  note ichan is not a fortran lun -- the underlying i/o code is in C.
c
      character*(*) zfile               ! filename -- new file
c
      integer ndata                     ! number of data points
      real zdata(ndata)                 ! the data...
c
c  ndata must be a positive integer that will fit in 3 bytes, i.e.
c  ndata must be .le. 2**24 - 1  ~ 16,000,000
c
c  output argument:
c
      integer ier                       ! completion code: 0 = normal
c--------------------------------------
c
      integer idum,nbuf,ibytes,ifmt
c
#include "fpreproc/byte_declare.h"
c
      byte_declare buf(512)             ! i/o buffer
      byte_declare ilbuf(4)             ! local buffer
c
      real fieee(ndata)                 ! floating data converted to ieee
c
c--------------------------------------
c
      idum=256*256*256 - 1
      if(ndata.gt.idum) then
         write(lun_warn,*) ' ?pbinwr:  data size limit exceeded.'
         write(lun_warn,*) '  ndata = ',ndata,' size limit = ',idum
         ier=1
         return
      endif
c
      call genopen(ichan,zfile,'NEW','BLOCKD',idum,ier)
      if(ier.ne.0) return
c
      nbuf=0
c
      ibytes=4                          ! byte size of local buffer
      ifmt=4                            ! =4:  code for "no compression"
#if __CRAY || __SX
      ilbuf(1)=char(ifmt)
#else
      ilbuf(1)=ifmt
#endif
      call ubi3ncod(ndata,ilbuf,2)      ! data size, in ilbuf(2:4).
c
c  transfer to output buffer
c
      call ubufo(ichan,buf,nbuf,ilbuf,ibytes)
c
c  ieee conversion of floating point data (in unix: just copy)
c
      call vmsieee(lun_warn,zdata,ndata,fieee,1)
c
c  standardize byte order for write
c
      call packordr(fieee,ndata,1)
c
c  write via buffer...
c
      ibytes=4*ndata
      call ubufo(ichan,buf,nbuf,fieee,ibytes)
c
c  flush buffer
c
      call ubufo(ichan,buf,nbuf,fieee,0)
c
c  close file
c
      call cftclose(ichan)
c
      return
      end

!
! Based on a tokamak name and possibly some other parameter, return
! the name of the appropriate Isolver state file.  Usually this state file
! will be found in the $ISOLVERDIR directory.  This subroutine is
! placed here to avoid a dependency on Isolver.  It must be hand maintained.
!
! The config argument can have different formats
!   ''                ->  iso_<tok>.nc, this is the default tokamak state file
!   'name: <name>'    ->  save file will have name iso_<tok>-<name>.nc
!   'shot: <n>'       ->  return a save file appropriate for this shot number, <n> can be empty to use shot=999999999
!   'date: <date>'    ->  return a save file appropriate for the tokamak at this date
!                         <date> -> YY,        two digit year
!                                -> YYYY,      four digit year
!                                -> MmmYYYY,   month and year as in Apr2010
!                                -> ddMmmYYYY, day, month and year  01Ap2010
!   'file: <file>'    -> save file will have the file name <file>, ignore the tokamak
!   '<name>'          -> same as 'name: <name>', iso_<tok>-<name>.nc
!
! The tokamak configurations are defined in $JCODESYSDIR/src/transp/main/jython/isolver/toks
! See also ../isoTokamakConfig.py and the config member in isoTokamakConfig and its subclasses
!
subroutine isolver_config(tok, config, savename, ier)
  implicit none

  character*(*), intent(in)  :: tok       ! name of the tokamak
  character*(*), intent(in)  :: config    ! possibly empty configuration
  character*(*), intent(out) :: savename  ! save file name or a short error message if there was an error
  integer,       intent(out) :: ier       ! nonzero on error

  character(len=len(tok))    :: ltok  ! lower case tokamak
  character(len=len(config)) :: fig   ! left adjusted config
  character*10               :: tag   ! stuff up to the colon in lower case
  character*9                :: cshot ! shot number as character

  logical :: nstu     ! true for nstu
  integer :: ix       ! index of :
  integer :: iy       ! index after : which is not beyond the string
  integer :: ic       ! tag, 0->name:, 1->shot:, 2->date:
  integer :: ishot    ! shot number
  integer :: dd       ! day
  integer :: mm       ! month
  integer :: year     ! four digit year
  integer :: k        ! temp

  ier = 0

  ltok = adjustl(tok)
  call ulower(ltok)

  nstu = ltok=='nstu'
  if (nstu) ltok = 'nstx'

  fig = adjustl(config)

  if (nstu .and. len_trim(fig)==0) then
     fig = 'upgrade'    ! nstx with upgrade
  end if

  if (len_trim(fig)==0) then                
     goto 100                 ! no configuration, use default 
  end if
   
  !
  ! --- generic extraction of config info ---
  !
  ic = 0
  
  dd=1
  mm=1
  year=1

  ix = index(fig,':')

  if (ix>0) then
     ! -- fig has a colon tag --
     tag = fig(1:ix)
     
     call ulower(tag)

     iy = min(len(fig), ix+1)

     if (tag == "name:") then
        ic  = 0
        fig = adjustl(fig(iy:))
        
        if (nstu .and. len_trim(fig)==0) then
           fig = 'upgrade'    ! nstx with upgrade
        end if
     else if (tag == "shot:") then
        ic    = 1
        cshot = adjustl(fig(iy:))

        if (len_trim(cshot)==0) then
           ishot = 999999999          !  'shot: ' is equivalent to last shot
        else
           read(cshot,'(i9)',err=200) ishot
        end if

     else if (tag == "date:") then
        ic  = 2
        fig = adjustl(fig(iy:))

        k = len_trim(fig)
        
        if (k<2) then          ! use default
           goto 100      
  
        else if (k==2) then    ! YY
           mm = 1
           dd = 1
           read(fig(1:2),'(i2)',err=200) year

           if (year<70) then
              year = 2000+year
           else
              year = 1900+year
           end if

        else if (k==4) then    ! YYYY
           mm = 1
           dd = 1
           read(fig(1:4),'(i4)',err=200) year

        else if (k==7) then    ! MmmYYYY
           dd = 1

           mm = getMonth(fig(1:3))
           if (mm==0) goto 200

           read(fig(4:7),'(i4)',err=200) year

        else if (k==9) then    ! ddMmmYYY
           read(fig(1:2),'(i2)',err=200) dd

           mm = getMonth(fig(3:5))
           if (mm==0) goto 200

           read(fig(6:9),'(i4)',err=200) year

        else
           savename = "bad date"
           ier=1 ; return
        end if

     else if (tag == "file:") then
        savename = adjustl(fig(iy:))
        return

     else
        savename = "unknown config tag"
        ier=1 ; return
     end if
  else
     ! -- fig is the name for the name: tag --
     ic = 0
  end if

  ! -- name: <fig> ---
  if (ic==0) then
     call ulower(fig)  ! always lower case, see isoTokamakConfig.py

     if (nstu) then
        if (fig=='pass') fig='upgrade_pass'
     end if

     savename = "iso_"//trim(ltok)//"-"//trim(fig)//".nc"
     return
  end if

  ! --- tokamak specific ---
  if (ltok=="rga" .and. (ic==1 .or. ic==2)) then  
     !
     ! dummy tokamak for testing and as an example for future additions
     ! go backward in time
     !
     if ((ic==1 .and. ishot>=212005) .or. (ic==2 .and. isAfter(7,4,2010))) then
        savename = "iso_rga.nc"             ! tokamak configuration after last upgrade 07Apr2010 and current configuration
        
     else if ((ic==1 .and. ishot>=127042) .or. (ic==2 .and. isAfter(24,10,2000))) then
        savename = "iso_rga-upgrade1.nc"    ! tokamak configuration after first upgrade 24Oct2000
        
     else
        savename = "iso_rga-orig.nc"        ! tokamak as originally built
     end if
     return
  else if (ltok=="nstx" .and. (ic==1 .or. ic==2)) then  
     !
     ! NSTX
     ! go backward in time
     !
     if ((ic==1 .and. ishot>=142633) .or. (ic==2 .and. isAfter(1,1,2013))) then
        savename = "iso_nstx-upgrade.nc"  ! tokamak configuration after upgrade 31Dec2013 
     else
        savename = "iso_nstx-orig.nc"     ! tokamak as originally built
     end if
     return
  end if
  
  goto 100  ! use default


  ! -- default --
100 continue
  if (ltok=="nstx") then
     if (nstu) goto 200
     savename = "iso_"//trim(ltok)//"-orig.nc"     ! NSTX default
  else if (ltok=="fnsf") then
     savename = "iso_"//trim(ltok)//"-r16v18.nc"   ! FNSF default
  else
     savename = "iso_"//trim(ltok)//".nc"
  end if
  return

  ! -- error during read --
200 continue
  ier = 1
  savename = "config read error"
  return
  
contains
  !
  ! ----- getMonth -----
  ! convert the three letter month in the format Ccc such as Apr to the integer month
  !
  integer function getMonth(ccc)
    character*3, intent(in) :: ccc  ! three letter month
    
    character*3  :: c
    character*36 :: mmm="janfebmaraprmayjunjulaugsepoctnovdec"
    
    integer :: i

    c = ccc
    call ulower(c)

    i = index(mmm,c)
    if (i>0) then
       getMonth = (i-1)/3 + 1
    else
       getMonth = 0
    end if
  end function getMonth
  
  !
  ! ----- isAfter -----
  ! Return true if the configure date dd,mm,year is after or equal to the
  ! argument epoch edd, emm, eyear
  !
  logical function isAfter(edd, emm, eyear)
     integer, intent(in) :: edd   ! day of month at epoch
     integer, intent(in) :: emm   ! month at epoch
     integer, intent(in) :: eyear ! yeat at epoch
     
     if (year>eyear)  then
        isAfter = .true.  ; return
     else if (year<eyear) then
        isAfter = .false. ; return
     end if
     
     if (mm>emm) then
        isAfter = .true.  ; return
     else if (mm<emm) then
        isAfter = .false. ; return
     end if
     
     if (dd>=edd) then
        isAfter = .true.
     else
        isAfter = .false.
     end if
  end function isAfter
end subroutine isolver_config

      subroutine boolopts(nopts,opts,present)
C
C  set flag(s) if boolean option(s) is(are) present in the command
C  line, otherwise clear flag(s)
C
C  all options are expected, as per the unix convention, to start with "-".
C
C  example:  nopts=1, opts="-toggle" command line contains "-toggle"
C            then present(1)=TRUE is returned.
C
C  input:
      integer nopts                     ! number of defined Boolean options
      character*(*) opts(nopts)         ! the option strings-- "-xyz"
C
C output:
      logical present(nopts)            ! T if option is found, F otherwise
C
C---------------------
C
      character*128 zarg
C
C---------------------
C
      do i=1,nopts
         present(i)=.false.
         if(opts(i)(1:1).ne.'-') then
            write(6,*) ' %boolopts:  call error, opts(',i,')=',
     >         opts(i),' does not start with "-".'
         endif
      enddo
C
      call get_arg_count(inum)
C
      do ii=1,inum
         call get_arg(ii,zarg)
         if(zarg(1:1).eq.'-') then
            do i=1,nopts
               if(zarg.eq.opts(i)) present(i)=.true.
            enddo
         endif
      enddo
C
      return
      end

C-----------------------------------------------------------------------
C  LXASC -- STRING COMPARE UTILITY
C
C    THIS ROUTINE WAS CREATED AT THE REQUEST OF J.P. JERAL AT JET, TO
C  AID IN THE PORTABILITY OF TRANSP AND RELATED CODE WHICH INVOLVES
C  STRING COMPARISONS FOR LEXICAL ORDERING.
C
C    THE PROBLEM IS THAT THE IBM EBCDIC CHARACTER CODE IS NOT ORDERED,
C  AND THE USE OF OPERATORS ".GT.", etc., IN FORTRAN DO NOT HAVE THE
C  EXPECTED RESULTS ON THE IBM.
C
C    THIS ROUTINE DOES NOT GIVE A PORTABLE SOLUTION, BUT, IT SHOULD
C  BE "PLUG COMPATIBLE" WITH THE IBM VERSION OF LXASC DEVELOPED BY
C  JEAN-PAUL.
C
      logical function LXASC(str1,oper,str2)
C
      implicit NONE
      character*(*) str1,str2
      character*2 oper
C
C-----------------------------------------------
C
      IF(OPER.EQ.'GT') THEN
        LXASC = str1.GT.str2
      ELSE IF(OPER.EQ.'GE') THEN
        LXASC = str1.GE.str2
      ELSE IF(OPER.EQ.'EQ') THEN
        LXASC = str1.EQ.str2
      ELSE IF(OPER.EQ.'LE') THEN
        LXASC = str1.LE.str2
      ELSE IF(OPER.EQ.'LT') THEN
        LXASC = str1.LT.str2
      ELSE IF(OPER.EQ.'NE') THEN
        LXASC = str1.NE.str2
      ELSE
        LXASC = .FALSE.
        WRITE(6,'('' ?LXASC:  OPERATOR "'',A,''" NOT RECOGNIZED'')')
     >      OPER
      ENDIF
C
      RETURN
      END

C  Read Scalars of a MDSplus U-file
C
C 02/05/01 CAL
C History:
C 01/18/02 CAL: fix "check" for TRANSP handling
C--------------------------------------------------------------------------
      subroutine ufmds_0rd(ichan,scval,sclab,n_sc,nsca,znode,ier)
C
      use UFILES
      implicit none
 
C Input:
      integer ichan             ! Ufiles channel id
      integer n_sc              ! size of scalar data buffers
      character*30  sclab(n_sc)
      real          scval(n_sc)
      character*(*) znode
 
C Output:
      integer nsca              ! Number of scalars
      integer ier
C
      integer mds_value
      integer idescr_long, idescr_floatarr, idescr_cstringarr
C C Local
      character*30  zsclab2(200)
      integer       nsca2
      character*10  zsclab(3,200)
      integer       idims(2)
      character*128 zerrmsg
      integer       istat, iretl
      integer       j,  i,     ilm
      logical       transp
      character*128 zunode
C-------------------------------------------------------------------------
      ier=0
      transp=.false.
 
      istat=mds_value('size('//znode//':SCVAL)',
     >      idescr_long(nsca),iretl)
      if (mod(istat,2).ne.1) then
         if (istat .ne. 265388144 .and.   ! TREE$-W-NNF
     >       istat .ne. 265388258 .and.   ! TreeNODATA
     >       istat .ne. 0 ) then          ! SS_FACILITY Error
            call ufmds_err('UFMDS_0RD',istat,ier,zerrmsg,ilm)
            write(ufelun,7701) znode,zerrmsg(1:ilm)
 7701       format('  seeking MDS+ size(',a,':SCVAL ',/2x,a)
         endif
         nsca = 0
         return
      endif
      zunode = znode
      call uupper(zunode)
      if (nsca .eq. 0) return
      if (mds_server(ichan) .eq. 'BIRCH.PPPL.GOV' .and.
     >    mds_tree(ichan) .eq. 'TRANSP' ) transp = .true.
C TRANSP stores "methodes" instead of actual data
C mdsvalue' returned "size" is misleading
C      if (index(zunode,'.INPUTS:') .gt. 0) transp=.true.
C      if (transp) then  ! TRANSP is written different
C         if (nsca .eq. 1) then  ! no scalars
C            nsca = 0
C            return
C         endif
C         nsca=nsca/3
C      endif
 
      istat=mds_value(znode//':SCVAL',
     >      idescr_floatarr(scval,nsca,1),iretl)
      if (mod(istat,2).ne.1) then
         call ufmds_err('UFMDS_0RD',istat,ier,zerrmsg,ilm)
         write(ufelun,7702) znode,zerrmsg(1:ilm)
 7702    format('  seeking MDS+ ',a,':SCVAL ',/2x,a)
      endif
       
      if (transp) then  ! TRANSP is written different
         zsclab(1,1) = ' '
         idims(1) = 3
         idims(2) = nsca
         istat=mds_value(znode//':SCLAB',
     >        idescr_cstringarr(zsclab,idims,2),iretl)
      else
         istat=mds_value(znode//':SCLAB',
     >        idescr_cstringarr(sclab,nsca,1),iretl)
      endif
      if (mod(istat,2).ne.1) then
         call ufmds_err('UFMDS_0RD',istat,ier,zerrmsg,ilm)
         write(ufelun,7703) znode,zerrmsg(1:ilm)
 7703    format('  seeking MDS+ ',a,':SCLAB ',/2x,a)
      endif
C check if bad sclab
      if (nsca .gt. 1) then
         j=0
         nsca2 = (nsca+2)/3+1
         do i=nsca2,nsca
            if (sclab(i)(1:10) .eq. ':         ') j=j+1
         end do
         if (j .gt. 0)  write(ufelun,*) 
     >    '%ufmds_0rd: looks like incorrect SCLAB'
         if (j .eq. nsca-nsca2+1) then
            write(ufelun,*) '   ...correcting SCLAB'

            do i=1,nsca2-1
               zsclab2(i) = sclab(i)
            enddo
C            istat=mds_value(znode//':SCLAB',
C     >           idescr_cstringarr(zsclab2,nsca2-1,1),iretl)
C            if (mod(istat,2).ne.1) then
C               call ufmds_err('UFMDS_0RD',istat,ier,zerrmsg,ilm)
C               write(ufelun,7703) znode,zerrmsg(1:ilm)
C               nsca = 0
C               return
C            endif
            j=0
            do i=1,nsca2-1
               j=j+1
               sclab(j)=zsclab2(i)(1:10)
               j=j+1
               sclab(j)=zsclab2(i)(11:20)
               j=j+1
               sclab(j)=zsclab2(i)(21:30)
            enddo         
         endif
      endif
      if (transp) then  ! TRANSP is written different
C                       ! returns size = 1 if it is really 0
         if (nsca .eq. 1 .and. zsclab(1,1) .eq. ' '
     >       .and. scval(1) .eq. 0.0) then
            nsca = 0
            return
         endif
         do i=1,nsca
            sclab(i)(1:10)=zsclab(1,i)
            sclab(i)(11:20)=zsclab(2,i)
            sclab(i)(21:30)=zsclab(3,i)
         enddo
      endif
C
      return
      end
 
 
 
 

C******************** START FILE INNBLK.FOR ; GROUP USPARM ******************
C
C-------------------------------------------------------------
C& INNBLK   FIND NEXT NON-BLANK CHARACTER IN UNPACKED LINE
C
C
      INTEGER FUNCTION INNBLK(ZLINE,LLINE,ISTART)
C
      CHARACTER*1 ZLINE(LLINE)
C
      IST=ISTART
 10   CONTINUE
      IST=IST+1
      IF(IST.GT.LLINE) GO TO 100
      IF(ZLINE(IST).NE.' ') GO TO 100
      GO TO 10
C
 100  CONTINUE
      INNBLK=IST
      RETURN
      END
C******************** END FILE INNBLK.FOR ; GROUP USPARM ******************

      subroutine UTRNLOG(table,loglnam,physnam,lphys,istat)
c
#ifdef __NAGWARE
      use f90_unix_env
#endif
c
c  translate logical name to physical name
c
c  arguments:
      character*(*) table	!table to search
      character*(*) loglnam	!logical name to be translated
      character*(*) physnam	!(return) physical name
      integer       lphys	!(return) length of physical name
      integer       istat	!(return) status code
C
C  ISTAT=1 DENOTES SUCCESS
C
C  on UNIX system:
C   table is ignored
C   loglnam is the environment variable name
C   physnam is the value returned
C   lphys is the length w/o trailing blanks of the value returned
C   istat is 1 unless lphys=0, in which case istat is 2 on exit.
C
      ist=1
      if(loglnam(1:1).eq.'$') ist=2
      call mpi_sget_env(loglnam(ist:),physnam,iertmp)
      lphys=len_trim(physnam)
      if(lphys.eq.0) then
        istat=2
      else
        istat=1
      endif
C
      return
C
      end

      subroutine ufck_under(luntty,lbl,data_in,data_out,n)
c
c  uflib utility -- prevent denormal numbers
c  anything with absolute value < 1e-38 set to zero
c  dmc 7 Aug 2003
c
      implicit NONE

      integer, intent(in) :: luntty     ! unit for warning message
      character*(*), intent(in) :: lbl  ! for warning message

      integer, intent(in) :: n          ! array dimension

      real, intent(in) :: data_in(n)    ! raw data
      real, intent(out) :: data_out(n)  ! data with denormals removed
c
c-------------------
c
      integer, parameter :: nwmax=6

      integer iwarn
      common/ufck_under_common/ iwarn

      integer i,jwarn
      real, parameter :: ZERO = 0.0
      real, parameter :: ZMIN = 2.0e-38
c
c-------------------
c
      jwarn=0
      do i=1,n
         if(data_in(i).eq.ZERO) then
            data_out(i)=ZERO
         else if(abs(data_in(i)).ge.ZMIN) then
            data_out(i)=data_in(i)
         else
            !  underflow reset...
            data_out(i)=ZERO
            if(jwarn.eq.0) then
               jwarn=1
               iwarn=iwarn+1
               if(iwarn.le.nwmax) then
                  write(luntty,*) 
     >               ' %ufck_under -- underflow cleared to zero in "',
     >               trim(lbl),'".'
               endif
            endif
         endif
      enddo

      return
      end
c-----------------------------------------------------
      subroutine ufck_reset
c
c  clear COMMON warning counter to zero; should be done before first
c  call to ufck_under
c

      integer iwarn
      common/ufck_under_common/ iwarn

c
c-----------------
c
      iwarn=0

      return
      end

C******************** START FILE UPSART.FOR ; GROUP USPARM ******************
C-------------------------------------------------------------
C&  UPSART  UREAD STRING PARAMETER ARITHMETIC
C
C  REDEFINE PARAMETER BY ARITHMETIC OPERATION
C  ZNAM-- PARAMETER NAME
C  ZVALP-- PARAMETER'S OLD VALUE
C     FIRST OPERAND OF ARITHMETIC OPERATION
C  ZVAL-- SECOND OPERAND OF ARITHMETIC OPERATION
C   RESULTANT VALUE = ZVALP  (OP)  ZVAL
C  WHERE OP = + (ADDITION) IF IOP=1
C             - (SUBTRACTION) IF IOP=2
C             * (MULTIPLICATION) IF IOP=3
C             / (DIVISION) IF IOP=4
C  IGLOBL-- FLAG WHETHER RESULT IS TO BE SAVED AS LOCAL OR GLOBAL
C  PARAMETER
C
      SUBROUTINE UPSART(ZNAM,ZVALP,ZVAL,IOP,IGLOBL)
C
      CHARACTER*16 ZNAM
      CHARACTER*96 ZVALP,ZVAL,ZANS
C
C  CHECK THAT OPERANDS ARE LEGAL INTEGERS
C
      LPVAL=LEN(ZVAL)
C
      IOP1=INTUSP(ZVALP,IER)
      IF(IER.NE.0) GO TO 900
      IOP2=INTUSP(ZVAL,IER)
      IF(IER.NE.0) GO TO 900
C  PERFORM OPERATION
      GO TO (100,200,300,400) IOP
C  ADDITION
 100  CONTINUE
      IANS=IOP1+IOP2
      GO TO 1000
C  SUBTRACTION
 200  CONTINUE
      IANS=IOP1-IOP2
      GO TO 1000
C  MULTIPLICATION
 300  CONTINUE
      IANS=IOP1*IOP2
      GO TO 1000
C  DIVISION-- CHECK
 400  CONTINUE
      IF(IOP2.EQ.0) THEN
        CALL UERMSG('PARAMETER ARITHMETIC - DIV BY ZERO ATTEMPTED',
     >      ZVAL,1)
        GO TO 900
      ENDIF
      IANS=IOP1/IOP2
      GO TO 1000
C
C  ERROR
C
 900  CONTINUE
C  NO ASSIGNMENT-- PARAMETER REMAINS UNDEFINED
      RETURN
C
C  NORMAL EXIT-- CARRY OUT PARAMETER ASSIGNMENT
C
 1000 CONTINUE
      ZANS='                                                '
      WRITE(ZANS,1001) IANS
 1001 FORMAT(I15)
C  LEFT-JUSTIFY
      ICT=0
      DO 1010 IC=1,LPVAL
          IF(ZANS(IC:IC).EQ.' ') GO TO 1010
          ICT=ICT+1
          ZANS(ICT:ICT)=ZANS(IC:IC)
 1010 CONTINUE
C
      ICTP1=ICT+1
          DO 1020 IC=ICTP1,LPVAL
          ZANS(IC:IC)=' '
 1020 CONTINUE
C
C  CARRY OUT ASSIGNMENT
C
      IF(IGLOBL.EQ.1) CALL UPSADG(ZNAM,ZANS)
      IF(IGLOBL.NE.1) CALL UPSADL(ZNAM,ZANS)
C
      RETURN
      END
C******************** END FILE UPSART.FOR ; GROUP USPARM ******************

C-------------------------------------------------------------
C GRFEBX - PLOT HORIZONTAL (X) ERROR BAR
C
      SUBROUTINE GRFEBX(X0,Y0,XEB,ZDY,zdname)
C
C  (X0,Y0) PT ABOUT WHICH ERROR BAR IS DRAWN
C  XEB  X ERROR (UNCERTAINTY) +/- XEB ABOUT X0
C  ZDY  HALF-HEIGHT OF "T" END OF ERROR BAR TO DRAW
C
C    |----X----|
C
      REAL XPERR(2),YPERR(2)
      character*(*) zdname
C
      ILINE=1
C
      XPERR(1)=X0-XEB
      XPERR(2)=X0+XEB
C
      YPERR(1)=Y0
      YPERR(2)=Y0
C
      CALL DPLOT1(XPERR,YPERR,2,ILINE)
C
      XPERR(1)=X0-XEB
      XPERR(2)=X0-XEB
C
      YPERR(1)=Y0-ZDY
      YPERR(2)=Y0+ZDY
C
      CALL DPLOT1(XPERR,YPERR,2,ILINE)
C
      XPERR(1)=X0+XEB
      XPERR(2)=X0+XEB
C
      CALL DPLOT1(XPERR,YPERR,2,ILINE)
C
      RETURN
      END

!----------------------------------------------------------
!----------------------------------------------------------
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGEYA
      SUBROUTINE R4_AGEYA(
     > R4_X,R4_Y,R4_E)

      external AGEYA

! argument declarations
 ! floating type, input/output:
      REAL R4_X(:)
  
 ! floating type, input/output:
      REAL R4_Y(:)
  
 ! floating type, input/output:
      REAL R4_E(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: E_act(:)
      REAL, allocatable :: E_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEYA -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEYA -- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEYA -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEYA -- Y_ref ALLOCATE error!')

      dim=size(R4_E)
      ALLOCATE(E_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEYA -- E_act ALLOCATE error!')
      ALLOCATE(E_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEYA -- E_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

      E_act=R4_E
      E_ref=R4_E

! call to original routine:  AGEYA

      CALL AGEYA(
     > X_act(1),Y_act(1),E_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(E_act.ne.E_ref)
         R4_E = E_act
      end where
      DEALLOCATE(E_act)
      DEALLOCATE(E_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGEXA
      SUBROUTINE R4_AGEXA(
     > R4_X,R4_Y,R4_E)

      external AGEXA

! argument declarations
 ! floating type, input/output:
      REAL :: R4_X(:)
  
 ! floating type, input/output:
      REAL :: R4_Y(:)
  
 ! floating type, input/output:
      REAL :: R4_E(:)
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL, allocatable :: X_act(:)
      REAL, allocatable :: X_ref(:)
      REAL, allocatable :: Y_act(:)
      REAL, allocatable :: Y_ref(:)
      REAL, allocatable :: E_act(:)
      REAL, allocatable :: E_ref(:)

! allocation of working arrays...

      dim=size(R4_X)
      ALLOCATE(X_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEXA -- X_act ALLOCATE error!')
      ALLOCATE(X_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEXA E-- X_ref ALLOCATE error!')

      dim=size(R4_Y)
      ALLOCATE(Y_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEXA -- Y_act ALLOCATE error!')
      ALLOCATE(Y_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEXA -- Y_ref ALLOCATE error!')

      dim=size(R4_E)
      ALLOCATE(E_act(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEXA -- E_act ALLOCATE error!')
      ALLOCATE(E_ref(dim)
     >   ,stat=alloc_stat)
      if(alloc_stat.ne.0) call errmsg_exit(
     >  ' ?R4_AGEXA -- E_ref ALLOCATE error!')

! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

      E_act=R4_E
      E_ref=R4_E

! call to original routine:  AGEXA

      CALL AGEXA(
     > X_act(1),Y_act(1),E_act(1))

! copy back outputs if modified.

      where(X_act.ne.X_ref)
         R4_X = X_act
      end where
      DEALLOCATE(X_act)
      DEALLOCATE(X_ref)

      where(Y_act.ne.Y_ref)
         R4_Y = Y_act
      end where
      DEALLOCATE(Y_act)
      DEALLOCATE(Y_ref)

      where(E_act.ne.E_ref)
         R4_E = E_act
      end where
      DEALLOCATE(E_act)
      DEALLOCATE(E_ref)

! exit
      return
      end
!----------------------------------------------------------
! r4real -- generated (f90 fixed form) REAL interface to:  AGEYS
      SUBROUTINE R4_AGEYS(
     > R4_X,R4_Y,R4_E)

      external AGEYS

! argument declarations
 ! floating type, input/output:
      REAL R4_X
  
 ! floating type, input/output:
      REAL R4_Y
  
 ! floating type, input/output:
      REAL R4_E
  

! local (automatic array) declarations

      integer alloc_stat, dim
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref
      REAL :: E_act
      REAL :: E_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R4_X
      X_ref=R4_X

      Y_act=R4_Y
      Y_ref=R4_Y

      E_act=R4_E
      E_ref=R4_E

! call to original routine:  AGEYS

      CALL AGEYS(
     > X_act,Y_act,E_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R4_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R4_Y = Y_act
      endif

      if(E_act.ne.E_ref) then
         R4_E = E_act
      endif

! exit
      return
      end
!----------------------------------------------------------

C******************** START FILE LCHAR.FOR ; GROUP URDUTS ******************
C-----------------------------------------------------
C&  LCHAR  UREAD LOGICAL FCN, CHECK INPUT AGAINST SPECIFIED CHAR
C  LOGICAL FUNCTION, .TRUE. IF USER ASWER IS "CHAR"
C  FALSE OTHERWISE
C   USE IXUOPC - ROTATE ANSWER ONLY IF TEST IS .TRUE.
C
      LOGICAL FUNCTION LCHAR(CHAR)
      CHARACTER*1 CHAR
      CHARACTER*2 ITES
      DATA ITES/' $'/
C
      ITES(1:1)=CHAR
C
      IANS=IXUOPC(ITES)
      LCHAR=.FALSE.
      IF(IANS.EQ.1) LCHAR=.TRUE.
      RETURN
      END
C******************** END FILE LCHAR.FOR ; GROUP URDUTS ******************

C******************** START FILE ILVAL.FOR ; GROUP CONCTR ******************
C================
C  ILVAL   D. MC CUNE MAY 21 1980
C   CONVERT LOGICAL TO INTEGER:
C    .TRUE.==> ILVAL=1
C    .FALSE.==> ILVAL=2
C
      INTEGER FUNCTION ILVAL(LLVAL)
      LOGICAL LLVAL
C
      ILVAL=2
      IF(LLVAL) ILVAL=1
      RETURN
      	END
C******************** END FILE ILVAL.FOR ; GROUP CONCTR ******************

      subroutine mdserr(lun, zstr, stat)
 
      implicit none
 
      character*(*) zstr        ! context message string
      integer stat              ! mdsplus status code
      integer lun               ! lun
 
      integer MDS_ERRSTR
C
      integer il, istat
      character*128 mds_msg
C
      write(lun,*) zstr,stat,':'
      istat=mds_errstr(stat,mds_msg)
      il=len_trim(mds_msg)
      write(lun,*) mds_msg(1:il)
C
      return
      end

!------------------------------------------------------------------------------
!
!  DOSIG3_Z -- EVALUATE A CROSS SECTION FROM ALADDIN DATA -- SUM OF 3
!
real(fp) FUNCTION DOSIG3_Z(ZEREL,INDXR,ZLBL1,ZLBL2,ZLBL3)
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : zero
  use sigtabl_mod   
  use alpcom_mod
  use alcom_mod
  IMPLICIT NONE
  INTEGER isigind_z,ix,i,ier
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) zerel,zsum,zsigma,dosigx_z
!============
  INTEGER INDXR(3)
  CHARACTER*(*) ZLBL1
  CHARACTER*(*) ZLBL2
  CHARACTER*(*) ZLBL3
!
!  INPUT ZEREL = REL. ENERGY AT WHICH TO EVALUATE CROSS SECTION
!        INDXR = REACTION INDICES (IF ALREADY KNOWN) OR ZERO
!        ZLBL1,ZLBL2,ZLBL3 = REACTION LABELS (USED IF INDEX NOT KNOWN)
!
!  OUTPUT INDXR = NONZERO REACTION INDICES (IF INDXR=0 ON INPUT)
!         DOSIG3 = CROSS SECTION (INTERPOLATED OR EXTRAPOLATED FROM
!                 ALADDIN DATA)
!
!------------------------------------------------------------------------------
!
  IF(INDXR(1).EQ.0) THEN
     INDXR(1)=ISIGIND_Z(ZLBL1)
     INDXR(2)=ISIGIND_Z(ZLBL2)
     INDXR(3)=ISIGIND_Z(ZLBL3)
  ENDIF
!
  ZSUM = zero
!
  DO IX=1,3
     IF((ALEMIN(INDXR(IX)).LE.ZEREL).AND.&
          (ZEREL.LE.ALEMAX(INDXR(IX)))) THEN
!
!  IN RANGE -- USE FIT
        NCF=NALPCF(INDXR(IX))
        CF(1:ncf)=ALPCF(1:ncf,INDXR(IX))
        CALL ALAD_EVAL_Z(ZEREL,ZSIGMA,1,IER)
     ELSE
!
!  OUT OF RANGE -- USE EXTRAPOLATION
        ZSIGMA=DOSIGX_Z(ZEREL,INDXR(IX))
     ENDIF
!
     ZSUM=ZSUM+ZSIGMA
  enddo
  DOSIG3_Z=ZSUM
  RETURN
END FUNCTION DOSIG3_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

      subroutine sget_cwd(cwd)
      character*(*) cwd
C
C  get current working directory
C
      character*32 zdisk
      integer ilen,ilenc
C
      call showdefl(zdisk,ildisk,cwd,ilcwd)
      if(zdisk.ne.' ') then
         ilen=len_trim(zdisk)
         if(zdisk(ilen:ilen).ne.':') then
            ilen=ilen+1
            zdisk(ilen:ilen)=':'
         endif
         ilenc=len_trim(cwd)
         do i=min(len(cwd),ilenc+ilen),ilen+1,-1
            cwd(i:i)=cwd(i-ilen:i-ilen)
         enddo
         cwd(1:ilen)=zdisk(1:ilen)
      endif
C
      return
      end

C******************** START FILE USPCLL.FOR ; GROUP USPARM ******************
C---------------------------------------------------------------
C&  USPCLL  DELETE ALL LOCAL UREAD PARAMETERS AT CURRENT LEVEL
C
      SUBROUTINE USPCLL
C
      USE USERIO
C
      NPT=NPLC(MAX0(NLUNIN,NLUNIO))
      DO 10 J=NPT,1,-1
      CALL USPDLO(J)
 10   CONTINUE
C
      RETURN
      END
C******************** END FILE USPCLL.FOR ; GROUP USPARM ******************

c  sgnco.for	new contour routines derived from ncar library
c
c  oct-89	created module from conrec,clgen,stline,drline
c
c  feb-93	fix calculation of dashed vs solid lines in agculev.
c		modify agcxget/agcyget [met]
c
c  jan-98 CAL   Adapt to TRANSP
c  Apr-99 CAL   make portable
C
C  Sep-00 CAL   pointers / entry need rework for f90
c----------------------------------------------------------------/agclini
c
	subroutine agclini(liru,lplu,lamu)
c
#ifdef __f90
	USE sgnco_mod
	implicit none
#else
	implicit none
	include 'sgnco_inc'
#endif
	integer i,   j
	integer liru,lplu,lamu
	integer nklr,ifill
	integer nums,istep
	integer numd
	integer iklrs(*),isyms(*),idshs(*)
c

	integer ufxy  !
c
	kfill=0
	nsym=0		!no symbols
	do i=1,nlm
	  kmap(i)=1	!init all colors to black
	  kdsh(i)=0	!all solid lines
	  ksym(i)=0	!no symbols
	enddo
	jufxy=0
c
	nir=max(0,liru)
	npl=max(0,lplu)
	lam=80000
	if(lamu.gt.0) lam=lamu
	return
c
	entry agcolrs(nklr,iklrs,ifill)
c
c  nklr=0  to turn off color lines and color fill
c       > 0  is number of entries in the color sequence
c  iklrs      contains the sequence of color codes
c  ifill > 0 to turn on color fill
c
	if(nklr.gt.0) then
	  kmap(1)=0	!base color is white
	  do i=2,nlm
	    j=mod(i-2,nklr)+1
	    kmap(i)=iklrs(j)
	  enddo
	endif
	kfill=ifill
	return
c
	entry agcsymb(nums,isyms,istep)
c
c  isymb	is symbol code
c  istep	is step between symbols
c
	nsym=nums
	if(nums.gt.0) then
	  do i=1,nlm
	    j=mod(i-1,nums)+1
	    ksym(i)=isyms(j)
	  enddo
	  call agsteps(istep,istep/2)
	endif
	return
c
	entry agcdash(numd,idshs)
c
c  idshs	is array of dash codes
c
	if(numd.gt.0) then
	  do i=1,nlm
	    j=mod(i-1,numd)+1
	    kdsh(i)=idshs(j)
	  enddo
	endif
	return
c
	entry agctran(ufxy)
c
	jufxy=1                 !  Dummy for unix code
	return
	end
c%
c----------------------------------------------------------------/agclins
c
	subroutine agclins(zdata,mxd,x,nx,y,ny,cl,ncl)
#ifdef __f90
	USE sgnco_mod
	implicit none
#else
	implicit none
	include 'sgnco_inc'
#endif
	integer mxd, nx, ny, ncl
#ifdef __f90
	real, dimension(:), target :: x
	real, dimension(:), target :: y
	real, dimension(:,:)       :: zdata
	real, dimension(:)         :: cl
	integer, dimension(:), allocatable :: ir
#else
	real x(*),y(*)
	integer ir(*)
	pointer (iir,ir)
	real zdata(mxd,*)
	real cl(nlm)	!,rwork(nlm)
#endif

	integer ince
cdec$	psect  /conrer/ noshr
	common /conrer/ ince

	integer iai(nlm),iag(nlm)
	real xfram(5),yfram(5)
	integer lvir,lvpl
	save lvir,lvpl
	character ctemp*12
	logical igood,lib_get_vm

	integer  jx,   jy,  lc, lrsize, i, ios
	integer  i4105,kfac,ic
	integer  kolor
	real     xdir, ydir
	real     contr
	integer  nfloat_size
	external agncof
c
c arguments
c	mxd	first (x) dimension of zdata
c	nx	number of data values to be contoured in the x-direction
c	ny	number of data values to be contoured in the y-direction
c
	ince=0		!no error
	xdir=sign(1.,x(2)-x(1))
	jx=3
	do while (ince.eq.0 .and. jx.le.nx)
	  if(sign(1.,x(jx)-x(jx-1)).ne.xdir) then
	    call ageset('agclins: x vector not monotonic',5,1)
	    go to 800
	  endif
	  jx=jx+1
	enddo
	ydir=sign(1.,y(2)-y(1))
	jy=3
	do while (ince.eq.0 .and. jy.le.ny)
	  if(sign(1.,y(jy)-y(jy-1)).ne.ydir) then
	    call ageset('agclins: y vector not monotonic',5,1)
	    go to 800
	  endif
	  jy=jy+1
	enddo
c
	if(lvir.eq.0) then
	  call usr_trnlog(' ','SG_IR_BUFFER',ctemp,lc,igood)
	  read(ctemp,'(bn,i12)',iostat=ios) lvir
	  if(lvir.eq.0) lvir=-1		!no translation
	  call usr_trnlog(' ','SG_PL_BUFFER',ctemp,lc,igood)
	  read(ctemp,'(bn,i12)',iostat=ios) lvpl
	  if(lvpl.eq.0) lvpl=-1		!no translation
	endif
c
	if(nir.eq.0) then
	  nir=max(nx,ny)*4
	  nir=max(nir,nx*ny/16)
	  nir=max(nir,1024)
	  if(lvir.gt.0) nir=lvir
	endif
#ifdef __f90
	igood = .true.
	allocate (ir(nir), stat=i)
	if (i .ne. 0) igood=.false.
#else
	igood=lib_get_vm(nir*4,iir)
	if (.not.igood) then
	  call ageset('agclins: no virtual memory',6,1)
	  return	!?go to 800
	endif
#endif
c
c set x,y scaling
	xorg=x(1)
	xrang=1.
	if(nx.gt.1) xrang=xrang/float(nx-1)
	xscal=(x(nx)-x(1))
	nxs=nx
	yorg=y(1)
	yrang=1.
	if(ny.gt.1) yrang=yrang/float(ny-1)
	yscal=(y(ny)-y(1))
	nys=ny
#ifdef __f90
	lax => x
	lay => y
#else
	lax=loc(x)  !   
	lay=loc(y)  !   
	ipl1=0
#endif
cx	call xneat(0)
cx	call yneat(0)
	call dlimx(x(1),x(nx))
	call dlimy(y(1),y(ny))
c
	call agseet(i4105,kfac,ic,is)
	if (i4105.eq.0) kfill=0

	if(kfill.ne.0 .or. nsym.ne.0) then
	  if(npl.eq.0) then
	    npl=max(nx,ny)*4
	    npl=max(npl,512)
	    if(lvpl.gt.0) npl=lvpl
	  endif
#ifdef __f90
	  igood=.true.
	  allocate (pl1(npl), stat=i)
	  allocate (pl2(npl), stat=i)
	  if (i .ne. 0) igood=.false.
#else
	  lrsize=nfloat_size()	!   
	  igood=lib_get_vm(npl*lrsize,ipl1)
	  igood=lib_get_vm(npl*lrsize,ipl2)
#endif
	  if (.not.igood) then
	    call ageset('agclins: no virtual memory',6,1)
	    go to 800
	  endif
	endif
#ifdef __f90
	if (kfill.ne.0) then
	   igood=.true.
	   allocate (am(lam), stat=i)
	   if (i .ne. 0) igood=.false.
#else
	iam=0
	if (kfill.ne.0) then
	  igood=lib_get_vm(lam*4,iam)
#endif
	  if (.not.igood) then
	    call ageset('agclins: no virtual memory',6,1)
	    go to 800
	  endif
c
	  call arinam(am,lam)
	  call ageget(1,ince,0)
	  if(ince.gt.0) go to 800
	  xfram(1)=x(1)	!define frame counterclockwise
	  xfram(2)=x(1)
	  xfram(3)=x(nx)
	  xfram(4)=x(nx)
	  xfram(5)=xfram(1)
	  yfram(1)=y(1)
	  yfram(2)=y(ny)
	  yfram(3)=y(ny)
	  yfram(4)=y(1)
	  yfram(5)=yfram(1)
c		!outside (left) is -1, inside (right) is area 0
	  call aredam(am,xfram,yfram,5,1,-1,0)
	else
	endif
c
	ince=0		!no error
c
c find major and minor lines - removed
c
cx	nml=0
cx	if(ilag.ne.0) then
cx	  call reord(cl,ncl,rwork,nml,nulbll+1)
cx	endif
c
c process each level
c
cx	fpart=.5
	mir=0		!high water mark for ir
	mpl=0		!high water mark for pl
	do i=1,ncl
	  contr=cl(i)
	  if (i4105.ne.0) then
	    kolor=max(kmap(i),1)
	    call linclr(kolor)
	    call agccurv(kolor)
	  endif
	  call symbl(ksym(i))
	  call line(kdsh(i))
	  igr=i		!group
	  iar=0		!area
c
c draw all lines at this level
c
	  call agcstln(zdata,mxd,nx,ny,contr,ir)
	  if(ince.gt.0) go to 800
	enddo
c
c  find relative minimums and maximums and mark values - removed
c
cx	if(nhi.eq.0) then
cx	  call minmax(zdata,mxd,nx,ny,isizem,ash,ioffdt)
cx	elseif(nhi.gt.0) then
cx	  call minmax(zdata,mxd,nx,ny,isizem,-ash,ioffdt)
cx	endif
c
	if (kfill.ne.0) then
	  call arpram(am,1,1,1)
	  call ageget(1,ince,0)
	  if(ince.gt.0) go to 800
	  npu=0
	  call arscam(am,pl1,pl2,npl,iai,iag,nlm,agncof)
	endif
	if (i4105.ne.0) then
	  call linclr(1)	!black
	endif
c
 800	continue
#ifdef __f90
	deallocate (ir)
	if (allocated(pl1)) then
	  deallocate(pl1)
	  deallocate(pl2)
	endif
	  if (allocated(am)) deallocate(am)
#else
	call lib_free_vm(nir*4,iir)
	if(ipl1.ne.0) then
	  call lib_free_vm(npl*lrsize,ipl1)
	  call lib_free_vm(npl*lrsize,ipl2)
	endif
	if(iam.ne.0) then
	  call lib_free_vm(lam*4,iam)
	endif
#endif
	return
	end
c----------------------------------------------------------------/agclgen
c
	subroutine agclgen(z,mxd,nx,ny,cclo,chi,cinc,cl,ncl,icnst)
	implicit none
cx	save
	integer   mxd,nx,ny,ncl,icnst
	real      cclo,chi,cinc
	integer   nlm, nla
	parameter (nlm=40)
	parameter (nla=16)
	real cl(nlm), z(mxd,ny)

	real      clo, glo, ha, fanc, crat, p, cc
	integer   i,   j,  k,    kk
c
c agclgen puts the values of the contour levels in cl.
c variable names match those in conrec, with the following additions.
c	flo	value of lowest contour level; if flo=fhi=0., a value
c		rounded up from the minimum zdata is generated
c	fhi	value of highest contour level
c	finc	>0 => increment between contour levels
c		=0 => "nice" value (between 10 and 30) generated
c		<0 => abs(finc)=number of levels
c         ncl     -number of contour levels put in cl.
c         icnst   -flag to tell conrec if a constant field was detected.
c                 .icnst=0 means non-constant field.
c                 .icnst non-zero means constant field.
c
c to produce non-uniform contour level spacing, replace the code in this
c routine with code to produce whatever spacing is desired.
c
	icnst=0
	clo=cclo
	glo=clo
	ha=chi
	fanc=cinc
	crat=nla
	if(ha.lt.glo) then
	  glo=ha
	  ha=clo
	elseif(ha.eq.glo) then
	  if (glo.ne.0.) then
	    cl(1)=glo
	    ncl=1
	    return
	  endif
	  glo=z(1,1)
	  ha=z(1,1)
	  do j=1,ny
	    do i=1,nx
	      glo=min(z(i,j),glo)
	      ha=max(z(i,j),ha)
	    enddo
	  enddo
	  if (glo.ge.ha) then
	    icnst=1
	    ncl=1
	    cclo=glo
	    return
	  endif
	endif
	if (fanc.lt.0) crat=max(1.,-fanc)
	if (fanc.le.0) then
	  fanc=(ha-glo)/crat
	  p=10.**(ifix(alog10(fanc)+5000.)-5000)
	  fanc=max(aint(fanc/p),1.)*p
	endif
c
	if (chi.eq.clo) then
	  glo=aint(glo/fanc)*fanc
	  ha=aint(ha/fanc)*fanc*(1.+sign(1.e-6,ha))
	endif
	do k=1,nlm
	  cc=glo+float(k-1)*fanc
	  if (cc.gt.ha) go to 118
	  kk=k
	  cl(k)=cc
	enddo
  118	ncl=kk
	cclo=cl(1)
	chi=cl(ncl)
	cinc=fanc
	return
	end
c----------------------------------------------------------------/agcstln
c
	subroutine agcstln(z,ll,mm,nn,conv,ir)
#ifdef __f90
	USE sgnco_mod
	implicit none
	integer ll, mm, nn
#else
	implicit none
	include 'sgnco_inc'
	integer ll, mm, nn
#endif
	real    z(ll,nn)
	integer ir(*)
	real    conv

c
c this routine finds the beginnings of all contour lines at level conv.
c first the edges are searched for lines intersecting the edge (open
c lines) then the interior is searched for lines which do not intersect
c the edge (closed lines).  beginnings are stored in ir to prevent
c retracing of lines.  if ir is filled, an error is output.
c
cdec$	psect  /conrer/ noshr
	integer ince
	common /conrer/ ince
	integer iybits
	parameter (iybits=16)	!?12
	logical drawh
	integer i,j,l,m,n
	integer ixypak, ixx, iyy
	integer jp1, ixy, ip1
	integer inn

	ixypak(ixx,iyy)=ishft(ixx,iybits)+iyy	!ishift
c
	l=ll
	m=mm
	n=nn
	cv=conv
	kir=0
	iss=.true.	!lines intersect frame
	drawh=n.le.m	!draw horizontally if wider than higher
	inir=7
	if(drawh) inir=1
c
	do jp1=2,n		!bottom edge, left to right
 	  if (z(1,jp1).lt.cv .and. z(1,jp1-1).ge.cv) then
	    ix=1
	    iy=jp1-1
	    is=3
	    call agcdrln(z,l,m,n,ir)
	  endif
	  if(ince.gt.0) return
	enddo
	do ip1=2,m		!right edge, bottom to top
	  if (z(ip1,n).lt.cv .and. z(ip1-1,n).ge.cv) then
	    ix=ip1-1
	    iy=n
	    is=5
	    call agcdrln(z,l,m,n,ir)
	  endif
	  if(ince.gt.0) return
	enddo
	do jp1=n,2,-1		!top edge, right to left
	  if (z(m,jp1-1).lt.cv .and. z(m,jp1).ge.cv) then
	    ix=m
	    iy=jp1
	    is=7
	    call agcdrln(z,l,m,n,ir)
	  endif
	  if(ince.gt.0) return
	enddo
	do ip1=m,2,-1		!left edge, top to bottom
	  if (z(ip1-1,1).lt.cv .and. z(ip1,1).ge.cv) then
	    ix=ip1
	    iy=1
	    is=1
	    call agcdrln(z,l,m,n,ir)
	  endif
	  if(ince.gt.0) return
	enddo
	iss=.false.	!lines will close inside

	if(drawh) then
	do j=n-1,2,-1		!vertical
	  do ip1=m,2,-1		!horizontal
	  if (z(ip1-1,j).lt.cv .and. z(ip1,j).ge.cv) then
	    ixy=ixypak(ip1,j)
	    call agcirck(ir,kir,ixy,inn)
	    if(inn.gt.0) go to 107		!cycle
	    call agcirst(ir,kir,nir,ixy,ince)
	    if(ince.gt.0) return
	    mir=max(mir,kir)
	    ix=ip1
	    iy=j
	    is=1
	    call agcdrln(z,l,m,n,ir)
	    if(ince.gt.0) return
	  endif
 107	  enddo
	enddo

	else	!(.not.drawh)
	do i=m-1,2,-1		!horizontal
	  do jp1=n,2,-1		!vertical
	  if (z(i,jp1-1).lt.cv .and. z(i,jp1).ge.cv) then
	    ixy=ixypak(i,jp1)
	    call agcirck(ir,kir,ixy,inn)
	    if(inn.gt.0) go to 109		!cycle
	    call agcirst(ir,kir,nir,ixy,ince)
	    if(ince.gt.0) return
	    mir=max(mir,kir)
	    ix=i
	    iy=jp1
	    is=7
	    call agcdrln(z,l,m,n,ir)
	    if(ince.gt.0) return
	  endif
 109	  enddo
	enddo
	endif
	return
	end
c----------------------------------------------------------------/agcdrln
c
	subroutine agcdrln(z,l,mm,nn,ir)
#ifdef __f90
	USE sgnco_mod
	USE agcGet_mod
	implicit none
#else
	implicit none
	include 'sgnco_inc'
#endif
	integer  l,mm,nn
	real z(l,nn)
	integer ir(*)
c
c this routine traces a contour line when given the beginning by agcstln.
c transformations can be added by deleting the statement functions for
c fx and fy in agcdrln and minmax and adding external functions.
c x=1. at z(1,j), x=float(m) at z(m,j). x takes on non-integer values.
c y=1. at z(i,1), y=float(n) at z(i,n). y takes on non-integer values.
c
cdec$	psect  /conrer/ noshr
	integer ince, iybits
	common /conrer/ ince
	integer inx(8),iny(8)
	data inx /-1,-1,0,1,1,1,0,-1/
	data iny /0,1,1,1,0,-1,-1,-1/
	logical insect,closed
c
	integer ixypak,ixx,iyy 
	integer m,n,ix0,iy0,idx,idy, ix2,iy2,is0
	real    y,x, fxx, fyy
	parameter (iybits=16)	!?12
	real    c, p1, p2

	ixypak(ixx,iyy)=ishft(ixx,iybits)+iyy	!ishift
	c(p1,p2)=(p1-cv)/(p1-p2)
c
	m=mm
	n=nn
	ix0=ix
	iy0=iy
	is0=is
	idx=inx(is)
	idy=iny(is)
	if (idx.ne.0) then
	  y=iy
	  x=c(z(ix,iy),z(ix+idx,iy))*float(idx)+float(ix)
	else
	  x=ix
	  y=c(z(ix,iy),z(ix,iy+idy)) *float(idy)+float(iy)
	endif
	if(linx) then
	  fxx=xorg + (x-1.)*xrang*xscal
	else
#ifdef __f90
	  call agcxget(x,fxx,lax,nxs)
#else
	  call agcxget(x,fxx,xarr,nxs)
#endif
	endif
	if(liny) then
	  fyy=yorg + (y-1.)*yrang*yscal
	else
#ifdef __f90
	  call agcyget(y,fyy,lay,nys)
#else
	  call agcyget(y,fyy,yarr,nys)
#endif
	endif
	if(jufxy.ne.0) then
	  x=fxx
	  y=fyy
	  call agcutrn(uufxy,x,y,fxx,fyy)
	endif
	call agcfrst (fxx,fyy)
	closed=.false.
	insect=.false.
	do while (.not.closed .and. .not.insect)
	  is=is+1
	  if (is.gt.8) is=is-8
	  idx=inx(is)
	  idy=iny(is)
	  ix2=ix+idx
	  iy2=iy+idy
	  if (iss) then		!if frame
	    insect=ix2.gt.m .or. iy2.gt.n .or. ix2.lt.1 .or. iy2.lt.1
	    if (insect) go to 120	!leave
	  endif
	  if (cv.le.z(ix2,iy2)) then
	    is=is+4
	    ix=ix2
	    iy=iy2
	    go to 106	!cycle
	  endif
	  if (is/2*2.eq.is) go to 106	!cycle
	  if (idx.ne.0) then
	    y=iy
	    x=c(z(ix,iy),z(ix+idx,iy))*float(idx)+float(ix)
	  else
	    x=ix
	    y=c(z(ix,iy),z(ix,iy+idy))*float(idy)+float(iy)
	  endif
	  if(linx) then
	    fxx=xorg + (x-1.)*xrang*xscal
	  else
#ifdef __f90
	  call agcxget(x,fxx,lax,nxs)
#else
          call agcxget(x,fxx,xarr,nxs)
#endif
	  endif
	  if(liny) then
	    fyy=yorg + (y-1.)*yrang*yscal
	  else
#ifdef __f90
	     call agcyget(y,fyy,lay,nys)
#else
	     call agcyget(y,fyy,yarr,nys)
#endif
	  endif
	  if(jufxy.ne.0) then
	    x=fxx
	    y=fyy
	  call agcutrn(uufxy,x,y,fxx,fyy)
	  endif
	  call agcvect (fxx,fyy)
	  if(ince.gt.0) return
	  if (is.eq.inir) then
	    call agcirst(ir,kir,nir,ixypak(ix,iy),ince)
	    if(ince.gt.0) return
	    mir=max(mir,kir)
	  endif
	  if (.not.iss) then
	    closed=ix.eq.ix0 .and. iy.eq.iy0 .and. is.eq.is0
cx	    if (closed) go to 120	!leave
	  endif
 106	enddo
c
c end of line
c
 120	continue
	iar=iar+1		!area number
	if (closed.or.insect) then
	  ilft=0
	  irgt=iar
	else
	  ilft=iar
	  irgt=0
	endif
	call agclast
	return
	end
c
c----------------------------------------------------------------/agcxget
	subroutine agcxget(xind,fxx,x,nxs)
	implicit none
#ifdef __f90
	real     xind, fxx
	integer  nxs
	real, dimension(:), pointer :: x
#else
	real     xind, fxx
	integer  nxs
	real x(*)
#endif
	integer ixx,ixn
c
	ixx=xind		!1<=xind<=nxs
	ixn=ixx+1
	if(ixn.le.1) then
	  fxx=x(1)
	elseif(ixx.ge.nxs) then
	  fxx=x(nxs)
	else
	  fxx=x(ixx)+(xind-float(ixx))*(x(ixn)-x(ixx))
	endif
	return
	end
c
	subroutine agcyget(yind,fyy,y,nys)
	implicit none
#ifdef __f90
	real     yind, fyy
	integer  nys
	real, dimension(:), pointer :: y
#else
	real     yind, fyy
	integer  nys
	real y(*)
#endif
	integer iyy,iyn
c
	iyy=yind		!1<=yind<=nys
	iyn=iyy+1
	if(iyn.le.1) then
	  fyy=y(1)
	elseif(iyy.ge.nys) then
	  fyy=y(nys)
	else
	  fyy=y(iyy)+(yind-float(iyy))*(y(iyn)-y(iyy))
	endif
	return
	end
c
c----------------------------------------------------------------/agcfrst
	subroutine agcfrst(x,y)
c
#ifdef __f90
	USE sgnco_mod
	implicit none
#else
	implicit none
	include 'sgnco_inc'
#endif
cdec$	psect  /conrer/ noshr
	integer ince
	common /conrer/ ince
	real    comget(80)
	common /bppcom/ comget
	integer ibasec
	data ibasec /1/
	real    x,   y
	integer kpl
	integer line, i, in
	save kpl, line
c
	if (kfill.ne.0 .or. nsym.ne.0) then
	  kpl=0
c	  !? store ix,iy instead of x,y
	  kpl=kpl+1
	  pl1(kpl)=x
	  pl2(kpl)=y
	  mpl=max(mpl,kpl)
	else
	  line=comget(ibasec)
	  call movea(x,y)
	  kpl=0
	endif
	return
c----------------------------------------------------------------/agcvect
c
	entry agcvect(x,y)
	if(kpl.gt.0) then
	  if(kpl.ge.npl) then
	    call ageset('agcdrln: pl buffer overflow',4,1)
	    ince=4	!call ageget(1,ince,0)
	    return
	  endif
	  kpl=kpl+1
	  pl1(kpl)=x
	  pl2(kpl)=y
	  mpl=max(mpl,kpl)
	else
	  if(line.le.0) then
	  call drawa(x,y)
	  else
	  call dasha(x,y,line)
	  endif
	endif
	return
c----------------------------------------------------------------/agclast
c
	entry agclast
	if(kpl.gt.0) then
	  call npts(kpl)
	  call cplot(pl1,pl2)
	  if(kfill.ne.0) then
	  call aredam(am,pl1,pl2,kpl,igr,ilft,irgt)
	  call ageget(1,ince,0)
	  endif
	endif
	return
	end
c
	subroutine agcirst(ir,kir,nir,ixy,ince)
	implicit none
	integer ir(*)
	character cnir*40
	integer kir,nir,ixy,ince, ios, in, i

	if (kir.ge.nir) then
	  write(cnir,'("agclins: ir buffer overflow",i12)',
     >          iostat=ios) nir
	  call ageset(cnir,2,1)
	  ince=2
	  return
	endif
	kir=kir+1
	ir(kir)=ixy
	return
c
	entry agcirck(ir,kir,ixy,in)
	do i=1,kir
	  if(ir(i).eq.ixy) then
	    in=1
	    return
	  endif
	enddo
	in=0
	return
	end
c
	subroutine agcplst(pl1,pl2,kpl,x,y)
	implicit none
	real    pl1(*),pl2(*)
	real    x,     y
	integer kpl
	kpl=kpl+1
	pl1(kpl)=x
	pl2(kpl)=y
	end
c
	subroutine agncof(xcs,ycs,ncs,iai,iag,nai)
#ifdef __f90
	USE sgnco_mod
	implicit none
#else
	implicit none
	include 'sgnco_inc'
#endif
	integer ncs
	real xcs(*),ycs(*)
	integer iai(*),iag(*),nai
	integer i, kolor, itop
	integer minx,maxx,miny,maxy,ixt,iyt
c
	itop=0
	do i=1,nai
	  if(iai(i).gt.0) itop=max(itop,iag(i))
	enddo
	if(itop.eq.0) return
	kolor=kmap(itop)
	if(kolor.eq.0) return
	if(npu.eq.0) call seetw(minx,maxx,miny,maxy)
	ixt=nint(xcs(1)*float(maxx-minx)+float(minx))
	iyt=nint(ycs(1)*float(maxy-miny)+float(miny))
	call agpnclr(-kolor)
	call begpnl(ixt,iyt,0)
	do i=2,ncs
	  ixt=nint(xcs(i)*float(maxx-minx)+float(minx))
	  iyt=nint(ycs(i)*float(maxy-miny)+float(miny))
	  call movabs(ixt,iyt)
	enddo
	call endpnl
	npu=max(npu,ncs)
	return
	end
c%
	subroutine agcutrn(ufxy,x,y,fxx,fyy)
#ifdef __f90
	USE  agcu_mod
#endif
	implicit none
	real x,y,fxx,fyy

	integer  ufxy           !   
	call agcuxy(x,y,fxx,fyy) !    -c@s

	end
c%
c----------------------------------------------------------------/rcontr
	subroutine rcontr(k1,c,k2,a,maxa,xarray,imin,imax,istep,
     >	  yarray,jmin,jmax,jstep)
#ifdef __f90
	use sgint_mod
#endif
	implicit none
	integer nlm,maxa,k1,k2,imin,imax,istep,jmin,jmax,jstep
	real a(maxa,*),c(*),xarray(*),yarray(*)
	parameter (nlm=40)
	real cl(nlm)
#ifdef __f90
	real, dimension(:),   allocatable, target :: xar, yar
	real, dimension(:,:), allocatable  :: zar
	integer :: istat
#else
	real xar(*),yar(*),zar(*)
	pointer (lxar,xar), (lyar,yar), (lzar,zar)
#endif
	logical igood,lib_get_vm
	integer  nfloat_size
	integer nx,ny,nxy,i,ii,i9,j,jj,j9,lrsize,ncl

c  assumes that a(i,j)=fcn(xarray(i),yarray(j))
	nx=(imax-imin+istep)/istep
	ny=(jmax-jmin+jstep)/jstep
	nxy=nx*ny
#ifdef __f90
	allocate(zar(nx,ny),stat=istat)
	allocate(xar(nx),stat=istat)
	allocate(yar(ny), stat=istat)
#else
	lrsize=nfloat_size()	!   
	igood=lib_get_vm(nxy*lrsize,lzar)
	igood=lib_get_vm(nx*lrsize,lxar)
	igood=lib_get_vm(ny*lrsize,lyar)
#endif
	ii=0
	do i=imin,imax,istep
	  ii=ii+1
	  xar(ii)=xarray(i)
	enddo
	jj=0
	do j=jmin,jmax,jstep
	  jj=jj+1
	  yar(jj)=yarray(j)
	enddo
	ii=0
	j9=0
	do j=jmin,jmax,jstep
	   j9=j9+1
	   i9=0
	  do i=imin,imax,istep
#ifdef __f90
	     i9=i9+1
	     zar(i9,j9)=a(i,j)
#else
	    ii=ii+1
	    zar(ii)=a(i,j)
#endif
	  enddo
	enddo
c
	call agclini(0,0,0)
	call agculev(k1,c,k2,zar,nxy,cl,ncl)
	call agclins(zar,nx,xar,nx,yar,ny,cl,ncl)
c
#ifdef __f90
	deallocate(xar)
	deallocate(yar)
	deallocate(zar)
#else
	call lib_free_vm(nxy*lrsize,lzar)
	call lib_free_vm(ny*lrsize,lyar)
	call lib_free_vm(nx*lrsize,lxar)
#endif
	end
c%
c----------------------------------------------------------------/contur
	subroutine contur(k1,c,k2,a,maxa,xarray,imin,imax,istep,
     >	  yarray,jmin,jmax,jstep)
#ifdef __f90
	USE sgInt_mod
	USE agcu_mod
#endif
	implicit none
	integer nlm,k1,k2,maxa,imin,imax,istep,jmin,jmax,jstep
	real a(maxa,*),c(*)
	parameter (nlm=40)
	real cl(nlm)
	real xarray(maxa,jmax),yarray(maxa,jmax)
#ifdef __f90
	real, dimension(:),   allocatable :: xar, yar
	real, dimension(:,:), allocatable :: zar
#else
	real xar(*),yar(*),zar(*)
	pointer (lxar,xar), (lyar,yar), (lzar,zar)
	external agcuxy
#endif
	logical igood,lib_get_vm
	integer nx,ny,nxy,i,ii,i9,j,j9,lrsize,ncl
	integer istat
	integer nfloat_size

c  assumes that a(i,j)=fcn(xarray(i,j),yarray(i,j))
	nx=(imax-imin+istep)/istep
	ny=(jmax-jmin+jstep)/jstep
	nxy=nx*ny
#ifdef __f90
	allocate(zar(nx,ny),stat=istat)
	allocate(xar(nx),stat=istat)
	allocate(yar(ny),stat=istat)
#else
	lrsize=nfloat_size() !   
	igood=lib_get_vm(nxy*lrsize,lzar)
	igood=lib_get_vm(nx*lrsize,lxar)
	igood=lib_get_vm(ny*lrsize,lyar)
#endif
	call agclxy(xar,nx,imin)
	call agclxy(yar,ny,jmin)
	ii=0
	j9=0
	do j=jmin,jmax,jstep
	   i9=0
	   j9=j9+1
	  do i=imin,imax,istep
#ifdef __f90
	     i9=i9+1
	     zar(i9,j9) = a(i,j)
#else
	    ii=ii+1
	    zar(ii)=a(i,j)
#endif
	  enddo
	enddo
	call agcuset(xarray,yarray,maxa,nx,ny)
c
	call agclini(0,0,0)
	call agculev(k1,c,k2,zar,nxy,cl,ncl)
#ifdef __f90
	call agctran(0)
#else
	call agctran(agcuxy)
#endif
	call agclins(zar,nx,xar,nx,yar,ny,cl,ncl)
c
#ifdef __f90
	deallocate(xar)
	deallocate(yar)
	deallocate(zar)
#else
	call lib_free_vm(nxy*lrsize,lzar)
	call lib_free_vm(nx*lrsize,lxar)
	call lib_free_vm(ny*lrsize,lyar)
#endif
	return
	end
c%
	subroutine agclxy(xar,nx,imin)
	real xar(*)
	do i=1,nx
	  xar(i)=i+imin-1	!?*istep
	enddo
	end
c%
	subroutine agcuset(xarray,yarray,maxa,nx,ny)
#ifdef __f90
	USE sgInt_mod
	implicit none
	integer :: maxa,nx,ny
	real, dimension(maxa,*), target :: xarray
	real, dimension(maxa,*), target :: yarray
	real, dimension(:,:), allocatable, save :: arrx
	real, dimension(:,:), allocatable, save :: arry
	integer :: i,j,maxy
#else
	implicit none
	integer maxa,nx,ny
	real arrx(*),arry(*)
	pointer (xara,arrx),(yara,arry)
	real xarray(maxa,*),yarray(maxa,*)
	save xara,yara
#endif
	integer nxx,nyy,maxaa
	real xraw,yraw,xdat,ydat
	save nxx,nyy,maxaa

	nxx=nx
	nyy=ny
	maxaa=maxa
#ifdef __f90
	if (allocated (arrx)) deallocate(arrx)
	if (allocated (arry)) deallocate(arry)
	maxy=ny
	allocate(arrx(maxa,maxy))
	allocate(arry(maxa,maxy))
	do i=1,nx
	   do j=1,maxy
	      arrx(i,j) = xarray(i,j)
	      arry(i,j) = yarray(i,j)
	   end do
	end do
#else
	xara=loc(xarray)  !   
	yara=loc(yarray)  !   
#endif

	return
c
	entry agcuxy(xraw,yraw,xdat,ydat)
	call agcuxyi(arrx,arry,maxaa,nxx,nyy,xraw,yraw,xdat,ydat)
	return
	end
c%
	subroutine agcuxyi(xarray,yarray,maxa,nx,ny,xraw,yraw,xdat,ydat)
#ifdef __f90
	implicit none
	integer maxa,nx,ny 
	real, dimension(maxa,*) :: xarray
	real, dimension(maxa,*) :: yarray
	real xraw,yraw,xdat,ydat
#else
	implicit none
	integer maxa,nx,ny 
	real xarray(maxa,nx),yarray(maxa,ny)
	real xraw,yraw,xdat,ydat
#endif
	integer ix,iy,ixn,iyn
	real    xfrac,yfrac,xdat1,xdat2,ydat1, ydat2

	ix=max(int(xraw),1)
	iy=max(int(yraw),1)
	ixn=min(ix+1,nx)
	iyn=min(iy+1,ny)
	xfrac=xraw-float(ix)
	yfrac=yraw-float(iy)
	xdat1=xarray(ix,iy)*(1.-xfrac)+xarray(ixn,iy)*(xfrac)
	xdat2=xarray(ix,iyn)*(1.-xfrac)+xarray(ixn,iyn)*(xfrac)
	xdat=xdat1*(1.-yfrac)+xdat2*yfrac
	ydat1=yarray(ix,iy)*(1.-yfrac)+yarray(ix,iyn)*(yfrac)
	ydat2=yarray(ixn,iy)*(1.-yfrac)+yarray(ixn,iyn)*(yfrac)
	ydat=ydat1*(1.-xfrac)+ydat2*xfrac
	end
c%
	subroutine agculev(k1,c,k2,zar,nz,cl,ncl)
	implicit none
	integer k1,k2,nz,ncl
	real c(*),zar(*),cl(*)
	integer nlm
	parameter (nlm=40)
	integer idash(nlm)
	integer i, nsolid, ndashd
	real    cmin,cmax,dff

	if(k1.eq.0) then	!user specified levels
	  cmin=1.e32
	  cmax=-1.e32
	  call agmnmx(zar,cmin,cmax,nz,1)
	  ncl=0
	  nsolid=nint((cmax-c(1))/c(2))
	  nsolid=min(nsolid,nlm-1)
	  ndashd=nint((c(1)-cmin)/c(2))
	  ndashd=min(ndashd,nlm-1-nsolid)
	  do i=ndashd,1,-1
	    ncl=ncl+1
	    cl(ncl)=c(1)-(i)*c(2)
	    idash(ncl)=1
	  enddo
	  do i=0,nsolid
	    ncl=ncl+1
	    cl(ncl)=c(1)+(i)*c(2)
	    idash(ncl)=0
	  enddo
	  call agcdash(ncl,idash)
	elseif(k1.gt.0) then
	  ncl=min(k1,nlm)
	  do i=1,ncl
	    cl(i)=c(i)
	  enddo
	  if(k2.gt.0) then
	    do i=1,k2-1
	      idash(i)=1
	    enddo
	    do i=k2,ncl
	      idash(i)=0
	    enddo
	    call agcdash(ncl,idash)
	  endif
	else		!k1.lt.0
	  ncl=min(-k1,40)
	  dff=(c(2)-c(1))/(ncl-1)
	  do i=1,ncl
	    cl(i)=c(1)+(i-1)*dff
	  enddo
cx	  cl(ncl)=c(2)
	  do i=2,ncl
	    c(i)=cl(i)
	  enddo
	endif
	end
c%
c%
c----------------------------------------------------------------/agraph
c  draw graph and map virtual space for contour plot
c
	subroutine agraph(minx,maxx,miny,maxy,xmin,xmax,ymin,ymax,
     >	  xlabl,ylabl)
	implicit none
	integer minx,maxx,miny,maxy
	real    xmin,xmax,ymin,ymax
	character xlabl*(*), ylabl*(*)
	real x(2), y(2)
c
	call binitt
	call xfrm(2)		!short ticks
	call yfrm(2)
	call xneat(0)		!frame data exactly
	call yneat(0)
	call slimx(minx,maxx)	!screen limits
	call slimy(miny,maxy)
	call dlimx(xmin,xmax)	!data limits
	call dlimy(ymin,ymax)
	call npts(0)
	call check(x,y)
	call agdspl(x,y)	!draw left/bottom axes, label ticks
	call xloctp(0)		!setup for top/right axes
	call ylocrt(0)
	call grid		!put ticks on top/right, no tick labels
	call xloc(0)		!back to bottom/left for agt routines
	call yloc(0)
	call agtchs(xlabl,0)	!put user labels
	call agtcvs(ylabl,0)
	return
	end
c%
c----------------------------------------------------------------/agrcfr
c  draw grid with ticks which just encloses a contour plot
c
	subroutine agrcfr(x,imin,imax,istep,y,jmin,jmax,jstep,igrid)
	implicit none
	real    x(*), y(*)
	integer imin,imax,istep,jmin,jmax,jstep,igrid
	real    xx(2),yy(2)
	integer irem

	call xfrm(2)		!short ticks, outside
	call yfrm(2)
	call xneat(0)		!frame data exactly
	call yneat(0)
	call npts(2)
	xx(1)=x(imin)		!first x value
	irem=mod((imax-imin),istep)
	xx(2)=x(imax-irem)
	yy(1)=y(jmin)
	irem=mod((jmax-jmin),jstep)
	yy(2)=y(jmax-irem)
	call check(xx,yy)
	call agdspl(xx,yy)	!draw grid&ticks, label ticks
	if(igrid.eq.2) then
	  call xloctp(0)	!set up for top/right grid
	  call ylocrt(0)
	  call grid		!draw grid&ticks, no tick labels
	  call xloc(0)		!back to bottom/left for agt routines
	  call yloc(0)
	else
	  call frame		!just draw box
	endif
	return
	end
c----------------------------------------------------------------/agcfram
c  draw grid with ticks which just encloses a contour plot
	subroutine agcfram(x,nx,y,ny,igrid)
	implicit none
	real x(*),y(*)
	real xx(2),yy(2)
	integer nx,ny,igrid 

	call xfrm(2)		!short ticks, outside
	call yfrm(2)
	call xneat(0)		!frame data exactly
	call yneat(0)
	call npts(2)
	xx(1)=x(1)		!first x value
	xx(2)=x(nx)
	yy(1)=y(1)
	yy(2)=y(ny)
	call check(xx,yy)
	call agdspl(xx,yy)	!draw grid, ticks, labels
	if(igrid.eq.2) then
	  call xloctp(0)	!set up for right/top grid
	  call ylocrt(0)
	  call grid		!draw grid/ticks (no tick labels)
	  call xloc(0)		!back to bottom/left for agt routines
	  call yloc(0)
	else
	  call frame		!just draw box
	endif
	return
	end

Module alpcom_mod
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
!----------------------------------------------------------------------
!  SIGTAB -- COMMON FOR SIGTAB PROGRAM
!    INTEGRATION OF ATOMIC AND NUCLEAR REACTION CROSS SECTIONS FOR
!  OBTAINING REACTION RATES OF INTEREST
!
  public
  SAVE
!
!----------------------------------------------------------------------
! FROM ALPCOM
!------------------------------------------------------------------------------
!
!     COMMON BLOCK FOR ALPACK STANDARD ALADDIN ENTRY PARSING
!
!     ORIGINAL STRUCTURE DEFINED BY  R. A. HULSE, PRINCETON UNIVERSITY,
!     PLASMA PHYSICS LABORATORY.
!     (PAPER TO BE SUBMITTED TO THE JOURNAL OF COMPUTATIONAL PHYSICS
!      COMMUNICATIONS)
!
!------------------------------------------------------------------------------
!
!     REV: 2/02/89 BY J.J. SMITH IAEA ATOMIC AND MOLECULAR DATA UNIT
!          ALL LABEL LENGTHS INCREASED FROM 20 CHARACTERS TO 40
!          THE FLAG FEXN HAS BEEN ADDED TO COMUNICATE WHETHER
!          COEFFICIENTS CAN BE PRINTED IN 1PE13.6 FORMAT
!
!------------------------------------------------------------------------------
!
!     NOTE: CHARACTER VARIABLES ARE IN A SEPARATE COMMON BLOCK TO ACCOMODATE
!           FORTRAN COMPILERS WHICH REQUIRE THIS SEPARATION OF VARIABLE TYPES
!
!     NELMX   DIMENSIONED MAXIMUM NUMBER OF LINES IN ENTRY BUFFER
!     NHLMX   DIMENSIONED MAXIMUM NUMBER OF HIERARCHICAL LABELS
!     NBLMX   DIMENSIONED MAXIMUM NUMBER OF BOOLEAN LABELS
!
!     LESEQN  ENTRY SEQUENCE NUMBER (0 = NO ENTRY CURRENTLY IN BUFFER)
!     EBUFF   BUFFER FOR CURRENT ENTRY LINES, PLUS FIRST LINE OF NEXT ENTRY
!     NELN    NUMBER OF LINES IN THIS ENTRY
!     HL      HIERARCHICAL LABELS
!     BL      BOOLEAN LABELS
!     NHL     NUMBER OF HIERARCHICAL LABELS
!     NBL     NUMBER OF BOOLEAN LABELS
!     LCMPTR  POINTER TO FIRST COMMENT LINE IN EBUFF
!     NCMLN   NUMBER OF COMMENT LINES IN EBUFF
!     LCFPTR  POINTER TO FIRST LINE OF COEFFICIENT FIELD IN EBUFF
!     NCFLN   NUMBER OF COEFFICIENT FIELD LINES
!
!     FEXTN   .FALSE. IF COEFFICIENTS CANNOT BE PRINTED IN 1PE13.6
!              FORMAT
!
!------------------------------------------------------------------------------
!
  INTEGER, PARAMETER :: NELNMX=100, NHLMX=100, NBLMX=100
  INTEGER leseqn,neln,nhl,nbl,lcmptr,ncmln,&
       lcfptr,ncfln
  CHARACTER*80 EBUFF(NELNMX)
  CHARACTER*40 HL(NHLMX), BL(NBLMX)
  LOGICAL FEXTN
! COMMON /ALENT/LESEQN,NELN,NHL,NBL,LCMPTR,NCMLN,LCFPTR,NCFLN,FEXTN
! COMMON /ALENTL/EBUFF,HL,BL
end Module alpcom_mod

!------------------------------------------------------------------------------
!  ALAD_INIT_Z -- INITIALIZE ALADDIN SYSTEM TO ACCESS NAMED FILE
!
SUBROUTINE ALAD_INIT_Z(LUNALAD,FILALAD,IER)
!
!  INPUT LUNALAD = LUN TO USE FOR FILE I/O
!        FILALAD = NAME OF FILE CONTAINING DATA IN ALADDIN FORMAT
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use alpcom_mod
  use alcom_mod
  IMPLICIT NONE
  INTEGER ier,lunalad,ioperr
!============
  CHARACTER*(*) FILALAD
!
! OUTPUT IER = COMPLETION CODE, 0= NORMAL
!
!------------------------------------------------------------------------------
!  DMC JUNE 1990
!    SEE SOURCE:ALADDIN.FOR -- COPY OF ALADDIN INTERACTIVE INTERFACE
!  FROM ORNL ATOMIC DATA CENTER (R. PHANEUF ET AL) FEB 1990
!
!------------------------------------------------------------------------------
!
!     INITIALIZE
!
  LUTIN = 5
  LUTOUT = 6
  LUDF = LUNALAD
  DFNAME = FILALAD
  LUOF = 71
  OFNAME = '**NONE**'
  LUQF = 72
  QFNAME = '**NONE**'
  LUEF = 73
  EFNAME = '**NONE**'
!
  NHSL = 0
  NBASL = 0
  NBNSL = 0
!
!------------------------------------------------------------------------------
!
  IER=0
!
!  CLOSE OLD FILE (IF ANY)
!
  CLOSE(UNIT=LUNALAD,ERR=5)
5 CONTINUE
!
!
  OPEN(UNIT=LUDF, FILE=DFNAME, STATUS='OLD', IOSTAT=IOPERR)
!
  IF(IOPERR .NE. 0) THEN
     WRITE(LUTOUT,&
          '('' ALAD_INIT_Z:  ERROR OPENING INPUT DATA FILE:'')' )
     WRITE(LUTOUT,'(1X,A)') DFNAME
     DFNAME = '**NONE**'
     OK = .FALSE.
     IER=1
     RETURN
  ENDIF
!
  OK = .TRUE.
  LESEQN = 0
  EOF = .FALSE.
!
  RETURN
END SUBROUTINE ALAD_INIT_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C******************** START FILE UPPASS.FOR ; GROUP USPARM ******************
C----------------------------------------------------------------
C&  UPPASS      PASS SPECIFIED LOCAL PARAMETERS TO LOWER LEVEL
C              INDIRECT INPUT FILE
C
C   ZLINE-- INPUT LINE CONTAINING SPECIFICATIONS OF PARAMETERS TO
C           BE PASSED
C   ISTART- INDEX LOCATION IN ZLINE AT WHICH TO START SCAN
C   LLINE-- LENGTH OF INPUT LINE
C
      SUBROUTINE UPPASS(ZLINE,ISTART,LLINE)
      USE USERIO
C
      PARAMETER (INOPS=4)
      CHARACTER*1 ZLINE(LLINE),ZTEMP(96),ZBLANK,ZOPS(INOPS)
      CHARACTER*16 ZNAM
      CHARACTER*96 ZVAL
C
      DATA ZBLANK/' '/
      DATA ZOPS/'+','-','*','|'/
C
      IST2=ISTART
C
C  LOOP:
 10   CONTINUE
      IST=IST2
C  EXIT:
      IF((IST.LE.0).OR.(IST.GE.LLINE)) GO TO 500
      IST2=IST+1
 12   CALL UFCHAR(ZLINE,MSLASH,IST2,LLINE)
      INIT=IST+1
      IFIN=LLINE
      IF(IST2.NE.0) IFIN=IPNBLK(ZLINE,LLINE,IST2)
C  CHECK FOR "/" USED AS ARITHMETIC DIVISOR
CX	IF((IST2.NE.0).AND.(ZLINE(IFIN).EQ.'=')) THEN
CX	  IST2=IST2+1
CX	  GO TO 12
CX	ENDIF
      IFND=INIT
      CALL UFCHAR(ZLINE,MEQS,IFND,IFIN)
C  CHECK FOR "=" ASSIGNMENT FORMAT
      IOP=0
      IF(IFND.EQ.0) GO TO 16
C  ARITHMETIC OPTION TRANSFERRED TO LOWER LEVEL ALLOWED
      IFNDP1=INNBLK(ZLINE,LLINE,IFND)
      IF(IFNDP1.GT.(LLINE-1)) GO TO 10
      DO 15 IOP=1,INOPS
      IF((ZLINE(IFNDP1).EQ.'.').AND.(ZLINE(IFNDP1+1).EQ.ZOPS(IOP)))
     >    GO TO 16
 15   CONTINUE
C  ASSIGNMENT WITHOUT ARITHMETIC HANDLED IN UPMASG-- GO ON
      GO TO 10
C  CHECK AND PACK NAME SPECIFICATION
 16   CONTINUE
      INIT2=INIT
      IFIN2=IFIN
      IF(IOP.GT.0) IFIN2=IFND-1
      CALL USPLNM(ZLINE,LLINE,INIT2,IFIN2,ZNAM,IER)
      IF(IER.EQ.0) GO TO 20
C  ILLEGAL NAME
      WRITE(LUNTRM,9001) (ZLINE(I),I=1,MIN(128,LLINE)),INIT,IFIN
 9001 FORMAT(/' % ILLEGAL PARAMETER NAME IN LINE:'/
     >  1X,128A1/'   IGNORED.  CHARACTERS ',I2,' TO ',I2,1H./)
      CALL UCLEAR
      GO TO 100
C  LEGAL NAME.  RECOGNIZED FROM PREVIOUS LEVEL?
 20   CONTINUE
      INLUNI=NLUNIN
      INLUNO=NLUNIO
      NLUNIO=1
      NLUNIN=MAX0(INLUNI,INLUNO)-1
      CALL USPGET(ZNAM,ZVAL,IER)
      IF(IER.EQ.0) THEN
        NLUNIN=INLUNI
        NLUNIO=INLUNO
        GO TO 50
      ELSE IF(IOP.GT.0) THEN
C  NOT RECOGNIZED:  QUERY USER-- UNLESS ARITHMETIC ASSIGNMENT FORMAT
C  IS USED IN WHICH CASE A DEFAULT ARITHMETIC VALUE IS ASSIGNED
        GO TO 50
      ENDIF
      CALL UPQUER(ZNAM,ZTEMP,96,ZVAL)
      NLUNIN=INLUNI
      NLUNIO=INLUNO
      GO TO 50
C  IS RECOGNIZED PARAMETER LOCAL ?
 50   CONTINUE
      CALL USPLOC(ZNAM,ITYPE,INUM)
CT	IF(ITYPE.EQ.2) GO TO 100
C  PASS PARAMETER TO NEXT LOWER LEVEL
 70   CONTINUE
      CALL UPSADL(ZNAM,ZVAL)
C  DELETE PARAMETER REFERENCE AND "/" FROM ZLINE
 100  CONTINUE
      IF(IOP.GT.0) GO TO 10
      INM1=INIT-1
      DO 110 I=INM1,IFIN
      ZLINE(I)=ZBLANK
 110  CONTINUE
C  GO ON TO NEXT PARAMETER
      GO TO 10
C---
C EXIT:
 500  CONTINUE
      RETURN
      	END
C******************** END FILE UPPASS.FOR ; GROUP USPARM ******************

C******************** START FILE GRFUF1.FOR ; GROUP GRFUF1 *************
C  GRAFX1 - DMC - REWRITTEN BASIC F(X) GRAPHICS INTERFACE ROUTINE
C    THIS ROUTINE CONTROLS DRAWING AND LABELING OF A 1 PAGE PLOT
C    OF A SINGLE FUNCTION F(X), AND GENERATION OF A REPLOT/RESCALE
C    (UREAD) OPTION MENU
C
C    A NEW CALLING ARGUMENT LIST IS PROVIDED
C
      SUBROUTINE GRAFX1(X,Y,N,XUN,YUN,LBL1,LBL2,LBL3)
C
C  DATA:
      REAL X(N),Y(N)
C  LABELS:
      CHARACTER*(*) XUN,YUN,LBL1,LBL2,LBL3
C
C  CONTROL:
      INTEGER IMENU
C
C  IF IMENU=1 JUMP DIRECTLY TO REPLOT MENU (DO NOT DRAW GRAPH 1ST)
C
      integer icounter
      integer, save :: iopcod=0
C
      character*128 zfile
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      DATA IMENU/0/
C-------------------------------------------------------------
C
      icounter=0
C-------------------------------------------------------------
C  SCALE SET SWITCHE CLEARED:
C
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
C
      CALL GAXGDF(ISEL)
C
      IF(IMENU.EQ.1) GO TO 200
C
C----------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
        CALL GSCSET(X,Y,Y,0,N)
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        CALL GSCMMX(X,N,Y,Y,0,N,1,1,1,1,N,XMIN,XMAX,1)
        CALL GSCYDF(1)
      ENDIF
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD) ! AXIS (LOG/LIN) CHECK
C
      CALL GSCREC  ! RECORD PLOT SCALE IN MEMORY
C
      CALL DPLOT1(X,Y,N,ICOD) ! DRAW GRID AND F(X) CURVE
C
      CALL GRALBL(XUN,YUN,LBL1,LBL2,LBL3)  ! LABEL THE PLOT
C
      CALL UPAUST(2)  ! PAUSE AFTER PLOT
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SAO',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         RETURN
      else if(iopcod.eq.13) then
         call unixfile('filename for 2 column ascii output file',zfile)
         call uread_freelun(ilun)
         open(unit=ilun,file=zfile,status='unknown',iostat=istat)
         if(istat.ne.0) then
            call uermsg('?GRAFX1: file open failure: ',trim(zfile),0)
            close(unit=ilun,iostat=istat)
         else
            write(ilun,8001) 'LBL1',trim(lbl1)
            write(ilun,8001) 'LBL2',trim(lbl2)
            write(ilun,8001) 'LBL3',trim(lbl3)
            write(ilun,8001) 'XUN',trim(xun)
            write(ilun,8001) 'YUN',trim(yun)
            write(ilun,8002) n
            do ii=1,n
               write(ilun,8003) x(ii),y(ii)
            enddo
 8001       format(1x,a,' = "',a,'"')
 8002       format(1x,'N = ',i6,'; x in col.1, y in col.2:')
 8003       format(1x,1pe13.6,1x,1pe13.6)
            close(unit=ilun)
         endif
         go to 200
      ENDIF
C
      CALL UERMSI(' ?GRAFX1 *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      END

C******************** START FILE UPROMX.FOR ; GROUP UREAD5 ******************
C
C& UPROMX  RECORD PROGRAM PROMPT IN UREAD OUTPUT FILE
      SUBROUTINE UPROMX
      USE USERIO
      IF(NCHARA.LE.0) RETURN
      IF(NLINDO.AND.(.NOT.NLINDI)) then
         icp1a=min(131,NCP1A)
         WRITE(LUNIDO,5000) MSEMI,(BBUFF(IJ),IJ=1,icp1a)
      endif
 5000 FORMAT(132A1)
      RETURN
      END
C******************** END FILE UPROMX.FOR ; GROUP UREAD5 ******************

!******************** START FILE GAUSSE.FOR ; GROUP FRSUBS ******************
!-------------------------------------
!  THIS FILE WILL HOLD subroutineS OF FRANTIC NEUTRALS CODE
!  WHICH doN'T USE COMMON BLOCKS AND WHICH THEREFORE MAY BE
!  EXCLUDED FROM THE "OLYMPUSIZATION" PROCESS FOR NOW, ANYWAY.
!     D. MC CUNE  15 MAY 1981
!-------------------------------------
subroutine r8_gausse(A,IROW,N,M,X,EPS,IW)
  !	11/7/76
  !	THIS PROGRAM WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
  !	PLASMA PHYSICS LAB.  THIS ROUTINE WILL SOLVE A SYSTEM OF LINEAR
  !	EQUATIONS BY USING GAUSS ELIMATION AND BACKWORD SUBSITUTION.
  !	PARAMETER LIST:
  !	A - THE N BY M AUGMENTED MATRIX WITH THE RIGHT HAND VECTOR
  !		IN COLUMN M.
  !	IROW - THE ROW DIMENSION OF A AS DEFINED BY THE CALLING PROGRAM.
  !	N - THE # EQUATIONS.
  !	M - N+1.
  !	X - SOLUTION VECTOR WITH N ELEMENTS.
  !	EPS - EVERY PIVOT ELEMENT MUST BE GREATER THAN EPS.  if
  !		A PIVOT ELEMENT IS SMALLER THE EQUATIONS ARE
  !		DECLARED SINGULAR.
  !	IW - THE LOGICAL UNIT USED FOR PRINTING.
  !	NOTE THAT THE MATRIX A IS DESTROYED.
  !============
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, pi, twopi 
  implicit none
  integer :: irow,n,m,iw,nn,j,maxrow,i,jj,k,l1
  real(fp) :: eps,amax,absa,store,anorm,asub,sum
  real(fp), dimension(irow,m) :: a
  real(fp), dimension(n) :: x
  !============
  NN=N-1
  !	I FIRST REDUCE MATRIX A.
  do J=1,NN
    !	MAXROW WILL GIVE THE ROW IN WHICH THE MAXIMUM ELEMENT WAS FOUND.
    MAXROW=J
    AMAX=zero
    !	I NOW SEARCH FOR THE MAXIMUM ELEMENT IN ROW J AND GREATER.
    do I=J,N
      ABSA=ABS(A(I,J))
      if(ABSA-AMAX) 270,270,260
260   AMAX=ABSA
      MAXROW=I
270   continue
    end do
    !	NOW THE MAXIMUM ELEMENT IN COL. J HAS THE VALUE OF AMAX AND
    !	IS IN ROW=MAXROW.
    !	I NOW CHECK TO SEE if EQUATIONS ARE SINGULAR.
    if(AMAX.GT.EPS) GO TO 275
    WRITE(IW,50) MAXROW,J
50  FORMAT(1X,'A PIVOT ELEMENT WAS FOUND TO BE LESS THAN EPS', &
         ' THE ELEMENT IS (',I3,',',I3,')')
    !  INSERT CALL TO TRANSP abort ROUTINE
    write(iw,*) ' [... error in GAUSSE ...]'
    call bad_exit
    !	if MAXROW doES NOT EQUAL J SWITCH ROWS.
275 if(MAXROW.EQ.J) GO TO 290
    do I=J,M
      STORE=A(J,I)
      A(J,I)=A(MAXROW,I)
      A(MAXROW,I)=STORE
    end do
    !	ROWS ARE NOW SWITCHED.
    !	I NOW NORMALIZE ROW J SO THAT A(J,J)=1.
290 ANORM=A(J,J)
    do I=J,M
      A(J,I)=A(J,I)/ANORM
    end do
    !	I NOW SUBTRACT ROW J FROM ROWS GREATER THEN J SUCH THAT
    !	THERE ARE ZEROS IN COLUMN J.
    JJ=J
300 JJ=JJ+1
    ASUB=A(JJ,J)
    do I=J,M
      A(JJ,I)=A(JJ,I)-A(J,I)*ASUB
    end do
    if(JJ.LT.N) GO TO 300
  end do
  !	I NOW PREFORM BACKWARD SUBSITION.
  X(N)=A(N,M)/A(N,N)
  do K=1,NN
    SUM=zero
    L1=N-K
    do I=1,K
      SUM=SUM+A(L1,L1+I)*X(L1+I)
    end do
    X(L1)=A(L1,M)-SUM
  end do
  RETURN
END subroutine r8_gausse

C******************** START FILE IUXCHA.FOR ; GROUP UFILS0 ******************
C----------------------------------------------------------------
C  IUXCHA  INTEGER FUNCTION
C  RETURN INTEGER CHANNEL NUMBER CORRESPONDING TO PASSED UNIT
C  NUMBER OR ZERO IF NOT FOUND
C
      INTEGER FUNCTION IUXCHA(ILUN)
C
      USE UFILES
C
      DO 10 ICHAN=1,UFCHAN
        IF (LUFSET(ICHAN) .AND. UFLUN(ICHAN).EQ.ILUN) THEN
C  FOUND
          IUXCHA = ICHAN
          RETURN
        ENDIF
 10   CONTINUE
C  NOT FOUND
      IUXCHA=0
      RETURN
      	END
C******************** END FILE IUXCHA.FOR ; GROUP UFILS0 ******************

C******************** START FILE IMMNB.FOR ; GROUP MULCDR ******************
C----------------------------------------------------------
C  INTEGER FCN IMMNB - COUNT NUMBER OF PTS IN PLOT WINDOW
C
      INTEGER FUNCTION IMMNB(X,Y,N)
C
      INCLUDE 'PLOT1MMX'
C
      REAL X(N),Y(N)
C
      ICT=0
      DO I=1,N
        IF((XMIN.LE.X(I)).AND.(XMAX.GE.X(I)).AND.
     >       (YMIN.LE.Y(I)).AND.(YMAX.GE.Y(I))) ICT=ICT+1
      ENDDO
C
      IMMNB=ICT
      RETURN
      END
C******************** END FILE IMMNB.FOR ; GROUP MULCDR ******************

      real function erf(realarg)
C
C  single precision error function
C     simply making use of intrinsic double precision function
C
      intrinsic derf

      real realarg
C
      double precision darg,dans
C
      darg=realarg
      dans=derf(darg)
C
      erf=dans
      return
      end

      subroutine str_pad(str)
C
C  replace nulls in str with blanks
C
      character*(*) str
C
      ilen=len(str)
      do il=1,ilen
         if(ichar(str(il:il)).eq.0) str(il:il)=' '
      enddo
C
      return
      end

C******************** START FILE UINITA.FOR ; GROUP USINIT *************
C
C=============================================
C&  UINITA  COMBINED UREAD/SG INITIALIZATION ROUTINE
C
C  INITIALIZE A PROGRAM TO USE SG AND GF LIBRARIES WITH TYPE-AHEAD
C  ENABLED
C
      SUBROUTINE UINITA(ILUN)
C
      USE USERIO
C
C-------------------------------------------
C
      IF(NLUINI) RETURN
C
      call err_ini  ! init fp excetion handling (SUNs)
C
C  CONTROL UREAD I/O LUNS (OPTIONAL - ZERO RESULTS IN DEFAULT)
      CALL ULUN00(ILUN)
C
      CALL USINIT
C
      CALL NEUPAG
C
      RETURN
      END
C******************** END FILE UINITA.FOR ; GROUP USINIT ***************

C ucdfhed - Read/Write netCDF - Ufile Header
C
C 08/14/97 C.Ludescher
C
      subroutine ucdfhed(lun,ishot,tdev,rank,ftype,zdate,zsdate,
     &                   rw,retn)
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Definitions for CDF
 
C Input:
      integer      lun      !
      integer      rw       ! 0: read
C                           ! 1: write
C Return:
      integer      retn
      integer      rank     ! number dimensions
      integer      ishot    ! shot number
      integer      ftype    ! file type : netCDF = 4
      character*4  tdev     ! 4 char tokamak code
      character*10 zdate    ! File write date
      character*10 zsdate   ! shot (original) date
 
 
C Definitions for processing
      integer ichan
      integer file_id
 
      integer nvars, ngatts, unlimid
C---------------------------------------------------------------------------
C
C get file name
      call uflchk(lun,'ucdfhed',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
C
C Read
C------
      if (rw .eq. 0) then       ! Read
C Inquire about file
         retn = nf_inq(file_id, rank, nvars, ngatts, unlimid)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9004) NF_STRERROR(retn)
 9004       format(' ? UCDFHED: nf_inq',A)
            return
         end if
         if (unlimid .gt. 1) rank = rank -1
C         type *,'rank =',rank
C         type *,'n.. =',nvars, ngatts, unlimid
 
         retn = nf_get_att_int(file_id,NF_GLOBAL,'shot',ishot)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9005) NF_STRERROR(retn)
 9005       format(' ? UCDFHED: nf_put_get_int -- shot'/,'     ',A)
            return
         end if
 
         retn = nf_get_att_text(file_id,NF_GLOBAL,'date',zdate)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9006) NF_STRERROR(retn)
 9006       format(' ? UCDFHED: nf_get_att_int -- date '/,
     >             '     ',A)
            return
         end if
         retn = nf_get_att_text(file_id,NF_GLOBAL,'sdate',zsdate)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9007) NF_STRERROR(retn)
 9007       format(' ? UCDFHED: nf_get_att_text -- sdate '/,
     >             '     ',A)
            return
         end if
         retn = nf_get_att_text(file_id,NF_GLOBAL,'machine',tdev)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9008) NF_STRERROR(retn)
 9008       format(' ? UCDFHED: nf_get_att_text -- tdev '/,
     >             '     ',A)
            return
         end if
         ftype = 4
C
      else
C Write Header
C----------------------
C Define global Attributes
         retn = nf_put_att_int(file_id,NF_GLOBAL,'shot',NF_INT,1,ishot)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9000) NF_STRERROR(retn)
 9000       format(' ? UCDFHED: nf_put_att_int -- shot'/,'     ',A)
            return
         end if
 
         retn = nf_put_att_text(file_id,NF_GLOBAL,'date',10,zdate)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9001) NF_STRERROR(retn)
 9001       format(' ? UCDFHED: nf_put_att_int -- date '/,
     >             '     ',A)
            return
         end if
         retn = nf_put_att_text(file_id,NF_GLOBAL,'sdate',10,zsdate)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) NF_STRERROR(retn)
 9002       format(' ? UCDFHED: nf_put_att_text -- sdate '/,
     >             '     ',A)
            return
         end if
         retn = nf_put_att_text(file_id,NF_GLOBAL,'machine',4,tdev)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9003) NF_STRERROR(retn)
 9003       format(' ? UCDFHED: nf_put_att_text -- tdev '/,
     >             '     ',A)
            return
         end if
      end if
      return
      end
 
 
 
 
 
 
 

c  xplot.for	display a plot file on a terminal
c
c
c  06/10/98  CAL: On unix, use XPLOT_OUTPUT (can not include "$")
c 
c  jan-89	build program from macro predecessor.
c		accept plot file, frame selection (opt), destination
c		list (opt), and display frame(s) on tty; allow user to
c		skip or goto a specified frame. [met]
c
c  accept plot file, frame selection (opt), destination list (opt)
c    display frame(s) to screen and allow user to skip or goto a
c    specified frame
c
c----------------------------------------------------------------/xplot
	program xplot
	implicit none
c
	include 'xplot_inc'
	integer hex7f, hexdf
	character fspec*128
	character fname*64
	character dests*255
	character optc*1 	!   
	data optc       /'-'/	!   
	character plout*64
	character c4105*4
	logical lnoq,lwout,lplot
	logical lnews,igood

	integer na, ld, ls, ll, le, ios
	integer linit, lout, lx, istat, kstat, nfo, khar
	integer ierr, itypd, k4105, if, ic, is
	integer jc_trim

	data hex7f /z'7f'/, hexdf /z'df'/
	data fspec	/' '/
	data dests	/' '/

c
c  process command line switches
	call at_msg('XPLOT - 01/10/94; help xplot for info')
	lstop = .false.		!xplot mode
	lnoq = .false.		!query at end of file
	lwait = .false.		!wait for vgds screen
	lttyo = .true.		!output only to tty
c
	fspec = ' '		!get command line and strip options
	call lib_get_foreign(fspec,na,ld)
	do while(fspec(1:1).eq.optc)	!check for /noquery /wait /lwid
	  ls = index(fspec,' ')
	  ll = index(fspec(2:ls),optc)
	  if(ll.gt.0) ls = ll
	  if(fspec(2:4).eq.'NOQ') then
	    lnoq = .true.
	  elseif(fspec(2:5).eq.'WAIT') then
	    lwait = .true.
	  elseif(fspec(2:3).eq.'LW') then
	    le = index(fspec,'=')+1
	    if(le.gt.1) read(fspec(le:le),'(i1)',iostat=ios) lwid
	  else
	    call at_msg(' ** invalid option ignored: '//fspec(1:ls))
	  endif
	  fspec = fspec(ls+1:)
	enddo
c
	lplot = .false.
	if(fspec.eq.' ') then	!if no file on command line
	  fspec = 'PLOT'	!use logical PLOT
	  lplot = .true.
	endif
	  call at_reset		!prevent TIC from calling get_foreign
	ls = index(fspec,optc)-1	!translate input file name
	if(ls.le.0) ls = jc_trim(fspec)
	call usr_trnlog(' ',fspec(:ls),dests,ld,igood)
	if(igood) then
	  fspec = dests(:ld)//fspec(ls+1:)
	elseif(lplot) then
	  fspec = ' '
	endif
c
c  process file spec
 80	continue
	call set_input(fspec,fname,li4105,linit)
	if(lwait) nfn = 0	!if slaved, ignore /F /T
c
	call usr_trnlog(' ','XPLOT_OUTPUT',plout,lout,igood) !   
	if(.not.igood) plout='stdout' !   
	call usr_trnlog(' ','TERMINAL_4105',c4105,lx,igood)
c
	call rinitt(plout,istat)	!override PLOT
	if(li4105 .and. c4105.ne.'NO') call tminit(1)
	kstat = 0	!0=vt100, 1=Tek during header, 2=past header
c
c  start new file
 100	continue
	incnt = 0		!read pointer
	inptr = 1		!write pointer (incnt+1)
	inblk = 0
	nfo = 0			!number of chars output
	kpage = 1		!frame being processed
	kskip = 0
	lpage = 99999
	spage(1,1) = 1		!disk address of first frame
	spage(2,1) = 1
	call set_temp(kpage,lwout)
	if(kpage.ge.99999) go to 8000
	ios = 0
	kmode=kalfm		!start in alf mode
c
c  process next character
	do while (ios.ge.0)
	  lnews = .false.		!not a new screen
	  call get_char(khar,ios)
	  if(ios.lt.0) then
	    lpage = kpage		!eof - set marker
	    nfn = 0
	    ios = 0			!ignore error for now
	    incnt = 0
	    if(lwait) then		!if slaved wait for next file
	      call tsend
	      call set_open(fname,ierr)
	      go to 100
	    endif
	    lnews = .true.
	    go to 320			!dont set spage
	  endif
c
	  if(kmode.eq.kescm .and. khar.eq.12) then	!have a form feed
	    itypd = 0			!assume throw away
	    if(nfo.le.linit) then	!empty buffer
cx	      call agfkeep(0)		!throw buffer away
	      spage(1,kpage) = inblk	!save ptr to ff
	      spage(2,kpage) = inptr
	      nfo = 0
	      go to 380
	    endif
	    if(kpage.lt.lpage) kpage = kpage+1
	    spage(1,kpage) = inblk	!save ptr to ff
	    spage(2,kpage) = inptr
	    lnews = .true.
	    go to 320

	  else			!anything but a form feed
	    if(kpage.ge.kskip .and. lwout) then
	      if(kstat.eq.0) then
		call initt(0)		!open term, screen switch
		kstat = 1
		call agseet(k4105,if,ic,is)
		lo4105=(k4105.eq.1)
		ldiff=lo4105.neqv.li4105
		if(lo4105 .and. lwid.gt.0) then
		endif
	      endif
	      if(nfo.eq.0) then
		call erase		!resets line width,style,color
		if(lwid.gt.0) then	!if for HC0 printer
		call cmdout('MW')	!set line width
		call intout(lwid)
		call cmdout('MQ')	!set string precision (vs stroke)
		call intout(1)
		endif
	      endif
	      call xout(khar)
	    endif
	    nfo = nfo+1
	    if(nfn.eq.-1 .and. .not.lkeep) then	!?.and. nfo.gt.linit
	      call ck_match(khar,nfo,lwout)
	    endif
	    if(khar.eq.27) kmode = kescm
	  endif
c
 320	  if(lnews) then		!new screen
	    if(ltemp .and. kpage.gt.kskip) then
	      call movabs(0,0)		!put cursor at bottom
	      call upause(0)
	      call upauch(itypd)
	    endif
c			!turn off /f= when frame is found
	    if(ltemp .or. kpage.ge.lpage) nfn = 0
c			!convert to upper case
	    itypd = iand(itypd,hex7f)	!drop parity
	    if(iand(itypd,64).ne.0) itypd = iand(itypd,hexdf)
c			!if "D" and output open, process as CR
	    if(itypd.eq.ichar('D') .and. lout.gt.0) itypd = 13
c			!if at eof, process CR same as alpha character
	    if(kpage.ge.lpage .and. itypd.lt.ichar(' '))
     >		 itypd = ichar(' ')
c			!if noquery, just stop
	    if(kpage.ge.lpage .and. lnoq .and. lttyo) go to 400
c			!if alpha char, ask user what to do
	    if(lttyo .and. itypd.ge.ichar(' ')) then
	      call finitt(0,0)
	      kstat=0
	      call set_frame(itypd)	!ask user what to do
	      if(kpage.ge.99999) go to 400	!leave
	      if(kpage.eq.99998) then
		fspec=' '
		go to 80
	      endif
	    endif
c
	    call set_temp(kpage,lwout)
	    if(kpage.ge.99999) go to 400	!leave
	    nfo = 0
	    kmode = 0
	  endif
c
 380	enddo
 400	continue
 8000	continue
	end
c
	subroutine set_frame(itypd)
	implicit none
c
	include 'xplot_inc'
	character cmd*1,ucmd*1
	integer   itypd, igo, kk

	data ucmd /'X'/
c
	if(kpage.eq.lpage)
     >		call at_msgi(' ** at end of file; page',lpage)
	call iag_upcase(cmd,char(itypd))
	igo = 0
	do while (igo.eq.0)
	  igo = index('FBTXNS',cmd)
	  if(igo.eq.5) then	!new file
	    kpage = 99998
	    return
	  elseif(igo.eq.4) then	!exit
	    kpage = 99999
	    return
	  elseif(igo.eq.3) then	!To frame
	    call at_int(' to frame number',kskip)
	    go to 120	!leave
	  elseif(igo.eq.2) then
	    call at_int(' back # frames',kskip)
	    kskip = kpage - kskip-1
	    go to 120	!leave
	  elseif(igo.eq.1 .or. igo.eq.6) then
	    call at_int(' skip # frames',kskip)
	    kskip = kpage + kskip
	    go to 120	!leave
	  endif
	  call at_char(
     >      'skip Forward, Backward, To frame, New file, eXit',
     >      ucmd)
	  cmd = ucmd
	enddo
 120	continue
	kskip=max(kskip,1)
	kskip=min(kskip,lpage)
	if(kskip.gt.maxpage) then
	  call at_msgi(' ** setting page to maxpage =',maxpage)
	  kskip = maxpage
	endif
	if(spage(1,kskip).ne.0) then
	  inblk = spage(1,kskip)-1
	  inptr = spage(2,kskip)
	  incnt = 0		!force read
	  kpage = kskip
	  kskip = 0
	elseif(kskip.gt.kpage) then
	  kk=kskip-1		!go to last page read
	  do while (kk.ge.kpage .and. spage(1,kk).eq.0)
	    kk=kk-1
	  enddo
	  if(kk.gt.kpage) then
	    inblk = spage(1,kk)-1
	    inptr = spage(2,kk)
	    incnt = 0
	    kpage = kk
	  endif
	endif
	end
c

!-----------------------------------------------------------------------
!  PSGHEC -- CROSS SECTION OF C+6 + HE --> C+5 + HE+ OR C+6 + HE+
!    I.E. SUM OF CROSS SECTIONS OF IONIZATION OF HE BY C+6 IMPURITY
!    IMPACT, EITHER BY CHARGE EXCHANGE OR BY IMPACT IONIZATION
!
real(fp) FUNCTION psghec8(ZE)
!
! INPUT
!  ZE -- COLLISION ENERGY **PER NUCLEON**  EV/AMU
!
! OUTPUT
!  PSGHEC -- CROSS SECTION, CM**2
!
! REFERENCE
!  ORNL-6090/V5, ATOMIC DATA FOR FUSION, VOLUME V,
!    "COLLISIONS OF CARBON AND OXYGEN IONS WITH ELECTRONS, H, H2, & He"
!    R.A. PHANEUF, R.K. JANEV, M.S. PINDZOLA
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) ze,zcx,psghecx8,zii,psgheci8
!============
  ZCX=psghecx8(ZE)
  ZII=psgheci8(ZE)
!
  psghec8=ZCX+ZII
!
  RETURN
END FUNCTION psghec8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"

C--------------------------------------------------------------------
C  UREADY - FLAG PROMPT MATCH CONDITION-- READY TO ACCEPT INPUT
C
      SUBROUTINE UREADY(IREADY)
C
      USE USERIO
C
C  IREADY=1 --> READY TO ACCEPT INPUT
C  IREADY=0 --> NOT READY
C
C  PASSED ARGUMENT OVERRIDDEN IF COMMON ARGUMENTS SPECIFY NO MATCH
C  CHECKING-- SEE UREAD LOGICAL FUNCTION LCMPPR
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCMPPR
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      LREADY=IREADY
      IF(.NOT.LCMPPR(IW1,IW2)) LREADY=1
C
C  MAKE DATA AVAILABLE TO USER CONTROL FILE
C
      DO 10 IG=1,NPGC
        IF(PGLNAM(IG)(1:8).EQ.'$MATCH  ') GO TO 20
 10   CONTINUE
C
      CALL URDABO
C
 20   CONTINUE
      IF(LREADY.EQ.1) THEN
        PGLVAL(IG)(1:5)='TRUE  '
      ELSE
        PGLVAL(IG)(1:5)='FALSE '
      ENDIF
C
      RETURN
      END

c file: tstp10.for	sglib demo plots
c
c  *********************************************
c  demo plots from tektronix ag manual for sglib
c  *********************************************
c
	program tstp10
        implicit none
	character back*1
	integer ip
c
	ip=0
	do while (ip.ge.0 .and. ip.le.7)
	  call at_bint('plot number (zero for all, -1 to quit)',ip,back)
	  if(back.ne.' ') then
	    call at_msg(
     >	    ' 1=ticval,2=enlarg,3=tclip,4=loglin,5=dual,6=bars,7=rc')
	    go to 100		!cycle
	  endif
	  if(ip.eq.0.or.ip.eq.1) call ticval	! tic density test
	  if(ip.eq.0.or.ip.eq.2) call enlarg	! plot with an enlargement
	  if(ip.eq.0.or.ip.eq.3) call tclip	! two curves, one is clipped
	  if(ip.eq.0.or.ip.eq.4) call loglin	! log & linear on same plot
	  if(ip.eq.0.or.ip.eq.5) call dual	! dual scales (uses dinity)
	  if(ip.eq.0.or.ip.eq.6) call bars	! bar charts graph
	  if(ip.eq.0.or.ip.eq.7) call rc	! rc circuit program
 100	enddo
	call tclos_disk
	end
c%
	subroutine ticval
        implicit none
c
c-- tic neat test
c
	real xdata(4), ydata(7)
	data xdata/-1.,6.,22.,2.5/
	data ydata/6.,211.,114.,306.,354.,291.,325./
c
	call initt(240)
	call binitt
	call agtmhs(200,760,'TICVAL:  TICK NEAT ROUTINES$',0)
	call xneat(0)	!to raw data
	call yneat(1)	!to minor tics
	call check(xdata,ydata)
	call dsplay(xdata,ydata)
	call frame
	call upause(0)
c	call bell	! ring the tty bell
c	call tinput(i)
	call finitt(0,0)
	return
	end
c%
	subroutine enlarg
        implicit none
c
c-- make plot with enlargement
c
	real xpts2(15),ypts2(15)
	data xpts2/14.,-1.52,-1.21,-1.05,-.81,-.62,-.60,-.57,-.41,-.32,
     1  -.09,.1,.3,.5,.7/
	data ypts2/14.,-.70,-.27,-.12,.17,.28,.31,.32,.20,.18,.10,-.08,
     1  -.35,-.71,-1.22/
c
c--- the main curve
	call initt(240)
	call binitt
c	call agtmhs(200,760,'ENLARG: A PLOT AND AN ENLARGEMENT$',0)
	call slimx(100,400)
	call slimy(200,600)
	call ylab(2)		!label ends only
	call check(xpts2,ypts2)
	call dsplay(xpts2,ypts2)
	call agtcvs('THE LABEL',0)
	call agtchs('THE PLOT$',0)
c--- draw box around part to be enlarged
	call movea(-.8,.2)
	call drawa(-.4,.2)
	call drawa(-.4,.4)
	call drawa(-.8,.4)
	call drawa(-.8,.2)
	call anmode
c----- the enlargement
	call binitt
	call dlimx(-.8,-.4)
	call dlimy(.2,.4)
	call xlab(2)	!label ends only
	call slimx(500,950)
	call slimy(200,700)
	call check(xpts2,ypts2)
	call dsplay(xpts2,ypts2)
	call agtchs('THE ENLARGEMENT$',0)
	call upause(0)
c	call bell	! ring the tty bell
c	call tinput(i)
	call finitt(0,0)
	return
	end
c%
	subroutine tclip
        implicit none
c
c-- two curves, one is clipped
c
	real xdata3(4), ydata3(7), ydata4(7)
	data xdata3/-1.,6.,1.,1./
	data ydata3/6.,211.,114.,306.,354.,291.,325./
	data ydata4/6.,367.,458.,168.,238.,620.,210./
c
	call initt(240)
	call binitt
	call agtmhs(200,760,'TCLIP: TWO CURVES, ONE IS CLIPPED$',0)
	call check(xdata3,ydata3)
	call dsplay(xdata3,ydata3)
	call line(34)
	call cplot(xdata3,ydata4)
	call upause(0)
c	call bell	! ring the tty bell
c	call tinput(i)
	call finitt(0,0)
	return
	end
c%                  
	subroutine loglin
        implicit none
c
c-- make log and linear on same plot
c
	real xpts(11),ypts(11)
	integer i
c
	xpts(1)=10
	ypts(1)=10
	do i=2,11
	  xpts(i)=float(i-1)
	  ypts(i)=float(i-1)**3
	enddo
c
	call initt(240)
	call chrsiz(3)
	call binitt
	call check(xpts,ypts)
	call dsplay(xpts,ypts)
	call agtchs('AGTCHS',6)
	call agtcvs('AGTCVS',6)
	call symbl(1)
	call dlimy(0.,0.)
	call yfrm(2)
	call ytype(2)
	call ylocrt(0)
	call xlab(0)
	call xfrm(0)
	call check(xpts,ypts)
	call dsplay(xpts,ypts)
	call chrsiz(1)
	call agtmhs(700,10,'AGTMHS(700,10)',0)
	call agtcgt(760,'LOGLIN: LOG AND LINEAR PLOTS.  '//
     >	'AGTCGT',0)
	call upause(0)
c	call bell	! ring the tty bell
c	call tinput(i)
	call finitt(0,0)
	return
	end
c%
	subroutine dual
        implicit none
c
c---	dual scales (uses dinity)
c
	real xdual(7), y1dual(7), y2dual(7)
	data xdual/6.,22.0,24.5,27.0,29.5,32.0,34.5/
	data y1dual/6.,211.,114.,306.,354.,291.,325./
	data y2dual/6.,366.,458.,198.,235.,620.,478./
c
	call initt(240)
	call term(2,4096)
	call binitt
	call agtmhs(200,760,'DUAL: DUAL SCALES  4096 RESOLUTION',0)
	call slimx(200,800)
	call check(xdual,y1dual)
	call dsplay(xdual,y1dual)
c---- the second curve has a different y range. reinitialize.
	call dinitx
	call dinity
	call xloctp(0)
	call xlab(0)	!no numbers on top x ticks
	call ylocrt(0)
	call line(34)
	call check(xdual,y2dual)
	call dsplay(xdual,y2dual)
	call upause(0)
c	call bell	! ring the tty bell
c	call tinput(i)
	call finitt(0,0)
	return
	end
c%
	subroutine bars
        implicit none
c
c-- draw a bar chart
c
	real xdata(4),ydata(13)
	real xmin, xmax
	data xdata /-1.,12.,1.,1./
	data ydata /12.,328.,632.,421.,780.,632.,472.,390.,562.,
     >		680.,852.,729.,645./
c
	call initt(240)
	call binitt
	call vbarst(8,0,0)
	call xfrm(1)
	call xneat(0)	!to raw data
	xmin=1.e10
	xmax=0.
	call mnmx(xdata,xmin,xmax)
	call dlimx(xmin,xmax+.5)
	call xzero(0)	!include zero
	call check(xdata,ydata)
	call dsplay(xdata,ydata)
	call agtmhs(200,740,'BARS: BAR CHART$')
	call upause(0)
c	call bell	! ring the tty bell
c	call tinput(i)
	call finitt(0,0)
	return
	end
c%
	block data comblk
	real em,r,c,omega,xlamda,ec
	common/com/em,r,c,omega,xlamda,ec
	data ec/0.0/
	end

	subroutine rc
        implicit none
c
c-- real user program written by dale herron  03-sep-79
c  sample use of deq on 1st order eqn, solves rc series circuit
c   with a diode in the circuit and an input em*sin(wt+lamda).
c
	external der300
	external comblk
	real y(2),yp(2),temp(2),w(1000,10),xt(1000),xy(1000),
     >	  xe(1000),xm(1000)
	integer nn, idx, ntx, i
        real t, prnt, h,tfin, freq, tx, test
	real em,r,c,omega,xlamda,ec
	common/com/em,r,c,omega,xlamda,ec
	data temp,t,y,yp/7*0.0/

c
	em=100.
	r=100.
	c=.0001
	prnt=.01
	h=.001
	tfin=1.0
	freq=60.
	xlamda=0.
	omega = 6.2832*freq
	xlamda = xlamda*(3.14159/180.)
	w(1,1)=0.0
	w(1,2)=0.0
	w(1,3)=0.0
	w(1,4)=0.0
	y(1)=0.0
	yp(1)=0.0
	idx=0
	nn=2
	tx=tfin/prnt+1.5
	ntx=ifix(tx)
	t=0.
	call deqset
150     idx=idx+1
	test=idx*prnt-(0.5*h)
	do while (t.lt.test)
	  call deq1(t,h,2,y,yp,temp,der300)
	enddo
	w(nn,1)=t
	w(nn,2)= ec
	w(nn,3)= em * sin(omega*t + xlamda)
	w(nn,4) = y(1)
	nn=nn+1
	if(nn.le.ntx .and. t.lt.tfin) go to 150
	xt(1) = w(1,1)
	xy(1) = w(1,2)
	xe(1) = w(1,4)
	xm(1) = w(1,3)
	do i=2,ntx
	  xt(i) = w(i,1)
	  xy(i) = w(i,2)
	  xe(i) = w(i,4)
	  xm(i) = w(i,3)
	enddo
	if (ntx .lt. 1000) then
	   print*,'ntx =',ntx
	   do i=ntx+1, 1000
	      xt(i)=0.
	      xy(i)=0.
	      xe(i)=0.
	      xm(i)=0.
	   enddo
	endif
c
c---- this is the plot-10 code.
	call initt(240)
	call term(2,1024)
	call binitt
	call xtics(5)	!ticks at .2 intervals
	call ytics(9)	!guarantee same # ticks on each side
	call ywdth(4)	!limit tic label width
	call agyband(10.)
	call npts(ntx)
	call check(xt,xy)
	call dsplay(xt,xy)
	call agtcvs('CAP VOLTAGE IN VOLTS$')
	call agtchs('TIME IN SECONDS$')
	call dinity
	call ylocrt(0)
	call line(12)
	call xlab(0)
	call xfrm(0)
	call ytics(9)
	call ywdth(4)
	call check(xt,xe)
	call dsplay(xt,xe)
	call agtcgt(0,'R C CIRCUIT RESPONSE$')
	call agtcvs('CURRENT IN AMPS$')
	call upause(0)
c	call bell	! ring the tty bell
c	call tinput(i)
	call finitt(0,800)
	return
	end
c
c---- these subroutines are used by the 'rc' subroutine above.
	subroutine deq1(x,h,n,y,yp,q,der)
        implicit none
	real x,h
	integer n
	real y(n),yp(n),q(n)
	real a(4),b(4),c(4)
	data a/.5e0,.2928932188,1.707106781,.1666666666/
     >	  ,b/1.e0,.2928932188,1.707106781,.33333333333/
     >	  ,c/.5e0,.2928932188,1.707106781,.5e0/
	integer kgo, i, j
	real d, r, qx
	data kgo /0/
	external der
	save qx

	do j=1,4
	  call der(x,y,yp)
	  if(kgo.eq.0) then
	    qx=0.0e0
	    do i=1,n
	      q(i)=0.0
	    enddo
	    kgo=1
	    return
	  endif
	  do i=1,n
	    d=h*yp(i)
	    r=d*a(j)-b(j)*q(i)
	    y(i)=y(i)+r
	    q(i)=q(i)+3.0*r-c(j)*d
	  enddo
	  r=h*a(j)-b(j)*qx
	  x=x+r
	  qx=qx+3.0*r-c(j)*h
	enddo
	return
c
	entry deqset
	kgo=0
	return
	end

	subroutine der300(t,y,yp)
        implicit none
	real t, y(*),yp(*)
	real em,r,c,omega,xlamda,ec
	common/com/ em,r,c,omega,xlamda,ec
	ec	 = (em*sin(omega*t+xlamda) - y(1))/ r
	if (ec .lt. 0.0) ec= 0.0
	yp(1)  = ec / c
	return
	end

c  common blocks for sgiof for flags and buffers
c
	integer outflg	!0 if output undefined
c			!else > 0
	integer inflg	!0 if input undefined
c			!1 if tty, 2 if disk, 3 if none, 5 if mbx
	integer outdsk	!0 if no disk output
c			!-1 if need to open, 1 if open
c			!-2 if turned off for terminal only stuff
	integer outtrm	!0 if no tty output
c			!-1 if need to open, 1 if open
	integer outaux	!0 if no auxiliary output
c			!-1 if need to open, 1 if open
	integer outps	!0 if tektronix *.plt file
c			!1 if postscript *.ps file

#if __X1
	common /sg_flag_/ outflg,inflg,outdsk,outtrm,outaux,outps
#else
	common /SG_FLAG/ outflg,inflg,outdsk,outtrm,outaux,outps
#endif
c
#ifdef __f90
	character*1, dimension(2048) :: tbuff
	character*1, dimension(512)  :: dbuff
#else
	byte tbuff(*)		!tty buffer
	pointer (tbufa,tbuff)	!pointer to tty buffer
	byte dbuff(*)		!disk buffer
	pointer (dbufa,dbuff)	!pointer to disk buffer
#endif
	integer maxtb		!size of tty buffer
	integer maxdb		!size of disk buffer in bytes
	integer ktptr		!index into tty buffer
	integer kdptr		!index into disk buffer
	integer ktqio		!qio channel for terminal output
	integer ktmbx		!mailbox channel for terminal broadcasts
	integer kxqio		!qio channels for auxil tty output
	integer kdqio		!qio channel for disk output
	integer kdsav(2)	!disk address of start of last frame
	integer keepc		!character to "keep" a disk frame

#ifdef __f90
#if __X1 
	common /sg_buff_/ maxtb,maxdb,ktptr,kdptr,
     >		ktqio,ktmbx,kxqio,kdqio,kdsav,keepc,tbuff,dbuff
#else
	common /sg_buff/ maxtb,maxdb,ktptr,kdptr,
     >		ktqio,ktmbx,kxqio,kdqio,kdsav,keepc,tbuff,dbuff
#endif
#else
	common /sg_buff/ tbufa,dbufa,maxtb,maxdb,ktptr,kdptr,
     >		ktqio,ktmbx,kxqio,kdqio,kdsav,keepc
#endif

C******************** START FILE LYES.FOR ; GROUP URDUTS ******************
C------------------------------------------------
C& LYES  UREAD LOGICAL FUNCTION .TRUE. IF INPUT IS "Y" FOR YES
C  FALSE OTHERWISE.
C
      LOGICAL FUNCTION LYES(IDUM)
      USE USERIO
C
      CHARACTER*1 ZCHAR
C
      CALL URCHAR(ZCHAR,1,ID,IER)
C
      LYES=.FALSE.
      IF(ZCHAR.EQ.'Y') LYES=.TRUE.
      CALL UROTOR(ID)
      RETURN
      END
C******************** END FILE LYES.FOR ; GROUP URDUTS ******************

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SGHEII(ZE)
!
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER i
!============
! idecl:  explicitize implicit real(fp) declarations:
  real(fp) ze2,zemin,zemax,zeuse,zle,zls,zlss,zle2,za2,zans
!============
  real(fp) ZE
!
!  ZE IN EV
!  SGHEII IN CM**2
!
!  JANEV-LANGER-EVANS-POST,
!  ELEMENTARY PROCESSES IN HYDROGEN-HELIUM PLASMAS
!  FIT FOR REACTION 6.3.2,  HE++ + HE --> HE++ + HE+ + E-
!    IMPACT IONIZATION
!
!  FIT TABLE IN SS 8.1, P. 255
!
  real(fp) A632(9)
  DATA A632/ 1.41674080e+06_fp,-1.11900817e+06_fp,&
       3.85796505e+05_fp,&
       -7.58381353e+04_fp, 9.29745057e+03_fp,&
       -7.27967598e+02_fp,&
       3.55515426e+01_fp,-9.90175555e-01_fp,&
       1.20425183e-02_fp/
!
  LOGICAL EXTRAP
!
  EXTRAP=.FALSE.
!
  ZE2=ZE
!
  ZEMIN=4750.0_fp
  ZEMAX=100000.0_fp
  IF((ZE2.LT.ZEMIN).OR.(ZE2.GT.ZEMAX)) EXTRAP=.TRUE.
!
  ZEUSE=min(ZEMAX,max(ZEMIN,ZE2))
!
  ZLE=log(ZEUSE)
!
  ZLS=A632(9)
  IF(EXTRAP) ZLSS=8.0_fp*A632(9)
!
  DO I=8,1,-1
     ZLS=ZLS*ZLE+A632(I)
     IF(EXTRAP.AND.(I.GE.2)) ZLSS=ZLSS*ZLE+(I-1)*A632(I)
  enddo
!
  IF(EXTRAP) THEN
     ZLE2=log(ZE2)
     ZA2=0.8_fp
     IF(ZE2.LT.ZEMIN) ZLS=ZLS-ZLSS*(ZLE-ZLE2)
     IF(ZE2.GT.ZEMAX) ZLS=ZLS+(ZLE2-ZLE)*(ZLSS-ZA2*(ZLE2-ZLE))
  ENDIF
!
  ZANS = EXP(min(50.0_fp,ZLS))
!
  SGHEII=ZANS
!
  RETURN
END FUNCTION SGHEII
!
!------------------------------------------------------------------------------
 
 
 
 
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok

C******************** START FILE LCMPPR.FOR ; GROUP UREAD5 ******************
C--------------------------------------------------------------
C&  LCMPPR COMPARE PROGRAM PROMPT WITH RECORD FROM INPUT FILE
C
C  UREAD INTERNAL-- IS PROMPT MATCH CHECKING IN EFFECT ?
C
      LOGICAL FUNCTION LCMPPR(IW1,IW2)
C
      USE USERIO
C
C  APPLICATION CONTROLS WHAT WORD RANGE IN PROMPT TO CHECK
C  VIA COMMON ARRAY NCPRM WHICH IS SET BY "CALL URDPMA(I,J)"
C  E.G. "CALL URDPMA(1,3)" SAYS DEFINE PROMPTS TO MATCH IF THE
C  FIRST 3 WORDS AGREE
C
C  CALL URDPMA(2,4) SAYS CHECK WORDS 2--4 FOR MATCH
C
C  CALL URDPMA(0,0) WILL TURN OFF ALL PROMPT MATCH CHECKING FEATURES
C  SO WILL CALL URDPMA(2,1)
C
      IW1=MAX0(1,NCPRM(1))
      IW2=NCPRM(2)
C
C  IF A NULL RANGE IS SPECIFIED, A PROMPT MATCH IS ASSUMED W/O CHECKING
C
      IF(IW2.LT.IW1) THEN
        LCMPPR=.FALSE.
      ELSE
        LCMPPR=.TRUE.
      ENDIF
C
      RETURN
      END
C---------------------------

c  file: sgiof.for	low level i/o routines for sglib
c
c  feb-85	write ag_inio (originally called io_init). [met]
c  may-85	add tinput, iowait (previously in agiod.mar). [met]
c  jun-85	add toutpt from agiod.  [met]
c  oct-85	add rinitt. 	 [met]
c  nov-85	add simultaneous disk/terminal output. [met]
c  nov-86	move file open and close from ag_inio to tsend.
c		modify ag_inio and tsend to support sggds.  [met]
c  jan-87	add vgds support; add agfkeep,agfclos. [met]
c  apr-87	add sg_term common; add disk file /keep switch.
c		delay opening disk file until first output. [met]
c  dec-87	add tclos_term; add workstation (WT) support.
c		add typed character argument to upause. [met]
c
c  mar-88	change disk buffer to 3 blocks.
c		move commons to sgiof.inc.
c		change ag_inio to look for terminal name if comma. [met]
c
c  dec-88	usr_getdvi return klass=5 for null device; error (klass=0)
c		 if nothing from getdvi and no dot.
c		drop leading spaces for both parts of comma separated PLOT.
c		support VGDS upgrade; drop support for GDS.
c		add iag_ljust.
c		agfkeep(0) to toss frame; (-1) to keep frame.
c		add io$m_escape flag to tinput instead of doing second qio
c		 when get an esc (generated by enter from VT).
c		bypass qio if outtrm is null device (5). [met]
c
c sep-89	agtpurg sets flag for tinput to do qio with m_purge instead
c		 of nowait qio.
c		modify tsend_term to buffer broadcast messages during plot;
c		 dont use yet - cant spawn with mbx attached to tty. [met]
c
c jan-90	print symbionts no longer need US as first char of file.
c		add topen_term; only assign terminal (with broadcast mbx)
c		  while on graphics screen; turn on broadcast trapping.
c		add exit handler to close terminal and disk and mbx.
c		dont close terminal in agfclos, only file.
c		set outdsk to -2 in agfoff, reset in agfonn only if -2.
c		fix return code in usr_trnlog, add case_blind option.
c		logical TERMINAL_TRAP controls broadcast trapping.
c		close files in ag_inio if called from agvgds (like rinitt)
c		 so logicals are reevaluated.
c		add agseef to return outflg.
c		dynamically allocate term/disk buffers; size set by logicals.
c		fix bug restricting disk name to 24 characters.
c		add tmark_disk so always keep frame header. [met]
c
c  aug-91	add istat argument to ag_inio.
c		make separate XTC version. [met]
c
c  feb-92	return from rinitt on error if istat arg present.
c		get device type for each item in PLOT definition.
c		allow mbx output (for XTC) or second tty output.
c		translate XTC_GIN... in tinput; allow mbx input in tinput.
c		translate TERMINAL_INPUT before SYS$COMMAND in tinput.
c		use SYS$LOGIN:<user>.PLT if SYS$OUTPUT in batch job.
c		change default disk buffer from 3 blocks to 30 (for DAS).
c		output to auxiliary in no-wait mode.
c		move cursor to corner in UPAUSE if both disk and tty output.
c		move ag_info,iag_trim here from sgvgds; add ag_swit. [met]
c
c  feb-92	translate XTC_GIN_n_user in tinput.
c		always purge first in tinput except between characters
c		in ainst/tinst. [met]
c
c  aug-93	add upauch entry and iag_upcase; revise ag_swit. [met]
c
c  jan-94	rename sg_narg to iargcount. [met]
c
c-----------------------------------------------------------------/toutpt
	subroutine toutpt(ichr)
c
	implicit none
	include 'sgcopr_inc'
	include 'sgiof_inc'	!sg_flag, sg_buff
	integer istat, ii
        integer ichr, jchr
	integer hex7f,hex0
	data hex7f /z'7f'/, hex0/z'00'/
c
	jchr = iand(ichr,hex7f)		!drop parity bit
c
	if(outflg.eq.0) then
	  call ag_inio(' ',istat)	!exit on error
	  if(istat.ne.1) call bad_exit
	endif
c
	if(outdsk.eq.-1) then
#ifdef __f90
	  call topen_disk(0)
#else
	  call topen_disk(1)		!need to open disk file
#endif
	endif
c
	if(outdsk.gt.0) then	!disk output
	  if(kdptr.eq.0) then
	    do ii=1,maxdb
#ifdef __f90
	      dbuff(ii)=char(hex0)
#else
	      dbuff(ii)=0
#endif
	    enddo
	  endif
	  kdptr=kdptr+1
#ifdef __f90
	    dbuff(kdptr)=char(jchr)
#else
	    dbuff(kdptr)=jchr
#endif
	  if(kdptr.eq.maxdb) then
	    call tsend_disk
	  endif
	endif
c
	if(outtrm.eq.-1) then		!need to open terminal
#ifdef __f90
	  call topen_term(0)
#else
	  call topen_term(1)
#endif
	endif
c
	if(outaux.eq.-1) then		!need to open aux term
#ifdef __f90
	  call topen_auxl(0)
#else
	  call topen_auxl(1)
#endif
	endif
c
	if(outtrm.eq. 1 .or. outaux.eq.1) then	!terminal output
	  ktptr=ktptr+1
c	  !tbufo(ktptr)=jchr
#ifdef __f90
	  tbuff(ktptr)=char(jchr)
#else
	  tbuff(ktptr)=jchr
#endif
	  if(ktptr.eq.maxtb) then
	    call tsend_term
	  endif
	endif
c
	return
	end
c%
c-----------------------------------------------------------------/upause
	subroutine upause(krase)
c
c  beep, wait until user types a character, and clear screen
c    if krase is non-zero or omitted
c
	implicit none

	include 'sgiof_inc'	!sg_flag, sg_buff
	logical lrase
	integer nargs, krase, ich, iin, inch
	integer hexdf
	data    hexdf /z'df'/
	save ich
c
	nargs = 1  !   
	lrase = .true.
	if(nargs.gt.0) lrase = krase.ne.0
c
cx	if(nargs.eq.0) then
cx	  call agsalf
cx	  type *, 'Call to UPAUSE with no arguments, use UPAUSE(1)'
cx	  call agsgrf
cx	endif
	if(outflg.eq.0) then
	  write(*,*) 'call to UPAUSE with no INITT'
	  return
	endif
c
	if(outtrm.eq. 1 .or. outaux.eq.1) then	!terminal only stuff
	  if(outdsk.ne.0) call movabs(0,0)	!move to a corner
	  call agfoff
	  call alfmod		!set alpha mode
	  call toutpt(07)	!bell
	  call tinput(ich)	!get a character
	  iin = iand(ich,hexdf)		!take upper case
	  if(char(iin).eq.'C') call hdcopy
	  call agfonn
	  call agfkeep(iin)
	endif
c
	if(lrase) then
	  call toutpt(27)	!escape
	  call toutpt(12)	!form feed to clear screen
	  call iowait(10)	!wait 1 second
	endif
c
	return
c
	entry upauch(inch)
c
	inch = ich
	end
c%

c-----------------------------------------------------------------/sg_flagblk
	block data sg_flagblk
	include 'sgiof_inc'
	include 'sgvgds_inc'	
	data outflg,inflg /2*0/
	data outdsk,outtrm,outaux,outps /4*0/
	data maxtb /2048/, maxdb /512/
	data myterm,user /'  ', '  '/
	end
c-----------------------------------------------------------------/rinitt
	subroutine rinitt(uname,istat)
c
c  determine output device from logical translation of plot/sys$output
c    initialize output device/chan
c    set model and comchr from logical translation of terminal_type
c
c  entry rinitt permits user to redefine the output device
c
c  entry ag_inio is called by initt
c
	implicit none
	integer istat
	character*(*) uname
	external sg_flagblk
c
	include 'sgtcs_inc'	!model,comchr
	include 'sgiof_inc'     !sg_flag, sg_buff
	include 'sgvgds_inc'    !iovgds,xpndsk,myterm
c
	character*64 dsknam,trmnam,auxnam
	integer      maxnam
	parameter (maxnam=3)
	character*64 outnam(maxnam)
	character*08 nodnam
	character*04 trmtrp
	character*64 tmpnam
	character*12 sysout !   
	data sysout /'stdout'/ !   
	integer outsav
	integer ivgdsk
	logical closup,addon,iopt
	integer ss_normal 
	integer igood

	integer nargs, ltnam, ldnam, mode
	integer iag_trim
	integer i, lcom, iexit, klass, lt, lu, lm, lcc
	integer lnam, la, ld
	integer kext, ksiz, kfac, kscr
	integer iout,ix,iy,iz
	integer sts
	data nodnam	/' '/

	data outsav /0/
	data ivgdsk	/-1/
	data ss_normal /z'0001'/
c
	nargs = 1  !   
	closup = .true.
c
	call usr_trnlog(' ',uname,tmpnam,ltnam,igood)
	if(igood .eq. 0) tmpnam = uname
	iopt = .true.
	go to 200
c
c-----------------------------------------------------------------/ag_inio
	entry ag_inio(uname,istat)
c
	nargs = 2  !   
	closup = uname.eq.'VGDS'	!close everything if VGDS
c				!check if output already open
	if(outflg.ne.0 .and. .not.closup) go to 8000
	tmpnam=' '
	xpndsk=' '
	lxnam=0
c				!set output for vgds
	if(iovgds.ne.0 .and. iovgds.ne.2) then
	  if(lgdsk.gt.0) then
	    if(ivgdsk.lt.0) then	!only translate first time thru
	      call usr_trnlog(' ','VGDS_SCRATCH',tmpnam,ltnam,igood)
	      if(igood .eq. 0) then
	      write(*,*) ' No VGDS_SCRATCH area'
	      call bad_exit
	      endif
	    endif
	    tmpnam = 'VGDS_SCRATCH:'//gdsdsk(1:lgdsk)
	  else
	    tmpnam = 'NL:'
	  endif
	  if(iovgds.eq.3) then		!disk and terminal
	    ldnam = iag_trim(tmpnam)
	    tmpnam(ldnam+1:) = ','
	  endif
	endif
c				!if not vgds, use logical name PLOT
	iopt = .false.
	if(iovgds.eq.0) then
	  call usr_trnlog(' ','PLOT',tmpnam,ltnam,igood)
	  iopt = .true.		!do check for options in tmpnam
	endif
c				!if nothing, use sysout
	if(tmpnam.eq.' ') then
	  tmpnam = sysout !   
	endif
c
c----------code common to ag_inio and rinitt
c
 200	continue
	if(closup) then
	  if(outdsk.gt.0) then	!if disk file open
	    call tsend_disk	!dump buffer
	    call tclos_disk	!close file
	  endif
c
	  if(outtrm.eq.1 .or. outaux.eq.1) then	!if terminal open
	    call tsend_term	!dump buffer
	    call tclos_term
	  endif
	endif
c..get essential info first time through
	if(nodnam.eq.' ') then
	  call ag_info(mode,ipid,myterm,user)
	endif
c..separate comma delimited list
	do i=1,maxnam
	  call iag_ljust(tmpnam)
	  lcom=index(tmpnam,',')
	  if(lcom.eq.0) then
	    outnam(i)=tmpnam
	    tmpnam=' '
	  else				!have a comma
	    outnam(i)=tmpnam(1:lcom-1)
	    if(outnam(i).eq.' ' .and. mode.eq.3)	!if interactive
     >		outnam(i)=sysout	!?myterm
	    tmpnam=tmpnam(lcom+1:)
	    if(tmpnam.eq.' ' .and. mode.eq.3)
     >		tmpnam=sysout		!?myterm
	  endif
	enddo
c..get device class for each name
	dsknam=' '
	trmnam=' '
	auxnam=' '
	outdsk = 0
	outtrm = 0
	outaux = 0
	outps = 0
	iexit = 0
	do i=1,maxnam
	  if(outnam(i).eq.' ') go to 120
	  call usr_trnlog(' ',outnam(i),tmpnam,ltnam,igood)
	  if(igood.eq.0) tmpnam=outnam(i)
	  call usr_getdvi(tmpnam,klass,igood)
	  if(igood.eq. 0) then
	    write(*,*) 'INITT/RINITT: invalid output device '//tmpnam
	    iexit=0
	    go to 120
	  endif
	  if(klass.eq.1) then		!disk
	    lt=iag_trim(tmpnam)
	    if(tmpnam(lt:lt).eq.':') then
	      lu=iag_trim(user)
	      tmpnam='$HOME/'//user(1:lu)//'.PLT' !   
	      write(*,*) 'INITT/RINITT: creating plot file '//tmpnam
	    endif
	    if(dsknam.ne.' ') then
	      write(*,*) 'INITT/RINITT: multiple output disk files'
	      go to 120
	    endif
	    dsknam=tmpnam
	    outdsk = -1
	  elseif(klass.eq.2) then	!terminal
	    lm=iag_trim(myterm)
	    lt=iag_trim(tmpnam)
	    if(lt.eq.0 .or. tmpnam(1:lt).eq.myterm(1:lm)) then !   
	      trmnam=tmpnam
	      outtrm = -1
	    else
	      auxnam=tmpnam
	      outaux = -1
	    endif
	  elseif(klass.eq.5) then	!mailbox(XTC or NL:)/socket
	    auxnam=tmpnam
	    outaux = -1
	  endif
 120	enddo
c..check at least one valid output device
	outflg = abs(outtrm+outdsk+outaux)
	if(outflg.eq.0) then
	  write(*,*) 'INITT/RINITT: no valid output devices'
	  if(nargs.le.1)  call bad_exit
	  istat = iexit
	  return
	endif
	xpntrm = trmnam
	if(xpntrm.eq.' ') xpntrm = auxnam
c					!drop node if same as SYS$NODE
	keepc = 0		!value if disk only or vgds
	addon = .false.
	if(iopt) then
	  call ag_swit(dsknam,addon,keepc,outps)
	endif
c..set keepc=d, for vgds keepc=0
	if((outtrm.ne.0 .or. outaux.ne.0) .and. outdsk.ne.0) then
	  if(keepc.eq.0 .and. iovgds.eq.0) keepc = ichar('D')
	endif
	model = 'NONE'
c..open terminal
	comchr = ' '
	ktptr=0
	if(outtrm.lt.0) then
	  lt=iag_trim(trmnam)
	  call tname_term(trmnam(1:lt))
c
	  call usr_trnlog(' ','TERMINAL_TYPE',tmpnam,ltnam,igood)
	  if(igood .ne. 0) then
	    ltnam = min(ltnam,6)
	    lcc = index(tmpnam,'_')
	    if(lcc.ne.0) then
	      comchr = tmpnam(lcc+1:)
	      ltnam = lcc-1
	    endif
c
	    model = tmpnam(1:ltnam)
	  else
c Make XTERM default
	    model = 'XTERM '
	  endif
c
	  call usr_trnlog(' ','TERMINAL_TRAP',trmtrp,lnam,igood)
	  call agtrap(.not.(trmtrp.eq.'NO'))
	endif
c..open auxiliary terminal
	if(outaux.lt.0) then
	  la=iag_trim(auxnam)
	  call tname_auxl(auxnam(1:la))
	  if(model.eq.'NONE') model = 'XTC'
	endif
c..establish disk file name, but dont open it yet
	if(outdsk.lt.0) then
	  call agseet(k4105,kfac,ksiz,kscr)
	  if(k4105.gt.0) then	!force 4105 file extension to .4105
	    kext = index(dsknam,'.PLT')
	    if(kext.ne.0) then
	      dsknam(kext:) = '.4105'
	      write(*,*) 'File name extension changed to .4105'
	    endif
	  endif
	  ld=iag_trim(dsknam)
	  call tname_disk(dsknam(1:ld))
c
	endif
c
 8000	continue
	if(nargs.gt.1) istat = ss_normal
	return
c
c-----------------------------------------------------------------/agfoff
	entry agfoff
c
	outsav = outdsk
	outdsk = -2
	return
c
c-----------------------------------------------------------------/agfonn
	entry agfonn
c
	if(outdsk.eq.-2) outdsk = outsav
	return
c
c-----------------------------------------------------------------/agseef
	entry agseef(iout,ix,iy,iz)
c
	iout = outflg
c?	ix = error code
	end
c
c-----------------------------------------------------------------/agfclos
	subroutine agfclos(uname)
c
c  close any disk file, return file name to user if arg uname exists
c
	implicit none

	character*(*) uname
	include 'sgiof_inc'	!sg_flag, sg_buff
	include 'sgvgds_inc'	!iovgds,xpndsk
	integer lu, lsnam
c
c  if lenth of string is < 2, assume string is a constant
	lu=len(uname)
	if(lu.gt.2) uname = ' '	!assume error - no file
	if(outdsk.gt.0) then
	  call tsend_disk
	  call tclos_disk	!close the disk file
	  if(lu.gt.2) then	!return the file name to caller
	    lsnam = index(xpndsk,']')+1
	    if(lxnam.gt.0) uname = xpndsk(lsnam:lxnam)
	  endif
	endif
c
	return
	end
c
c-----------------------------------------------------------------/agfkeep
	subroutine agfkeep(iin)
c
c * decide whether to keep this frame in the disk file or back up to its start
c
	implicit none

	integer iin	!char typed by user
c			!if -1, keep; if 0, toss
c
	include 'sgiof_inc'	!sg_flag, sg_buff
	include 'sgvgds_inc'	!iovgds,xpndsk
c
	logical saveit
c
	if(outflg.eq.0) return
	if(outdsk.le.0) return
c
	typdc = iin
	if(typdc.eq.0) then
	  saveit = .false.	!toss if agfkeep(0)
	elseif(typdc.eq.-1) then
	  saveit = .true.	!keep if agfkeep(-1)
	elseif(keepc.gt.0 .and. keepc.ne.typdc) then
	  saveit = .false.	!toss if doesnt match /keep
	elseif(keepc.le.0 .and. -keepc.eq.typdc) then
	  saveit = .false.	!toss if does match /nokeep
	else
	  saveit = .true.	!keep
	endif
c
	if(saveit) then
	  call tsend_disk
	  call tkeep_disk	!update start of frame address
	else
	  call tback_disk	!back up disk address
	endif

	return
	end
c
c-------------------------------------------------------------/iag_ljust
	subroutine iag_ljust(str)
c
c left justify a character string
c
	implicit none

	character str*(*)
	integer   js

	js=1
	do while(str(js:).ne.' ' .and. str(js:js).eq.' ')
	  js = js+1
	enddo
	if(js.gt.1) str = str(js:)
	end
c
c-------------------------------------------------------------/iag_trim
	integer function iag_trim(str)
c  return length of a character string minus any trailing blanks
c  if string is blank, returned length is 0
	implicit none

	character str*(*)
	integer   jt, jl

	jt=0			!trimmed length
	jl=len(str)		!allocated length
	do while (jl.gt.jt)
	  if(ichar(str(jl:jl)).gt.ichar(' ')) jt=jl
	  jl=jl-1
	enddo
	iag_trim=jt
	end
c%
c-------------------------------------------------------------/ag_swit
	subroutine ag_swit(dsknam,addon,keepc,outps)
	implicit none

	character dsknam*(*)
	logical addon
	integer keepc, outps
	integer is, no, ik, ld

	character optc*1 	!   
	data optc /'-'/	        !   
	character opts*4	!option string

c
	addon=.false.
	keepc=0
c..see if there is an option (-xx for unix)
	is = index(dsknam,optc)	!check for option character
	do while(is.gt.0)
	  no = 1		!assume no no
	  ik = is+1
	  call iag_upcase(opts,dsknam(ik:ik+3))
	  if(opts(1:2).eq.'NO') then
	    no = -1		!have a no
	    ik = ik+2
	    call iag_upcase(opts,dsknam(ik:ik+3))
	  endif
	  if(opts(1:3).eq.'APP') then	    !append to file
	    addon=.true.
	  elseif(opts(1:2).eq.'PS') then    !postscript
	    outps=1
c..if user specifies /keep=x, set keepc=x; if /keep, set keepc=<cr>
	  elseif(opts(1:4).eq.'KEEP') then
	    ik = ik+4
	    if(dsknam(ik:ik).eq.'=') then	!if =, use that char
	      ik = ik+1
	      call iag_upcase(opts,dsknam(ik:ik))
	      keepc = ichar(opts(1:1))*no
	    else		!if not, use cr
	      keepc = 10*no	!+/- cr  on UNIX cr=A
	    endif
	  endif
	  opts = ' ,'//optc		!look for blank,comma,optc
	  ld=len(dsknam)
	  do while(ik.le.ld .and. index(opts,dsknam(ik:ik)).eq.0)
	    ik = ik+1
	  enddo
	  dsknam(is:ik-1) = ' '		!blank out this switch
	  is = index(dsknam,optc)
	enddo
	end
c%
c-------------------------------------------------------------/iag_upcase
	subroutine iag_upcase(upstr,lostr)
	implicit none

	character upstr*(*),lostr*(*)
	integer   i, icode
	integer hex7f, hexdf
	data hex7f /z'7f'/, hexdf /z'df'/ 

	upstr=lostr
	do i=1,len(upstr)
	  icode=iand(ichar(upstr(i:i)),hex7f)	!drop parity
c?	  if(icode.ge.'61'x .and. icode.le.'7b'x) then	!for 'a' to 'z'
	  if(iand(icode,64).ne.0) then	!if alpha x40 = 64
	  upstr(i:i)=char(iand(icode,hexdf))	!mask out '20'x
	  endif
	enddo
	end

subroutine r8_getmpa(zrmc,zymc,mimom,imom,zrin,zrout,zymp)
  !
  !  DMC 18 March 1994:
  !  given the updown asymmetric moments of a surface, define an
  !  approximate midplane to the surface.  Return the inner and
  !  outer R intercepts of this midplane with the surface, and
  !  return the height of the surface above y=0.
  !
  !  rev dmc 25 Mar 1994:  use
  !
  !============
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, twopi
  implicit none
  integer :: imom,mimom,imm,ith
  real(fp) :: zth,zr,zy
  real(fp), dimension(0:mimom,2) :: zrmc  ! R moments
  real(fp), dimension(0:mimom,2) :: zymc  ! Y moments
  !
  !  mimom gives the moments 1st array dimension; imom gives the number
  !   of *active* moments; imom.le.mimom ...
  !
  real(fp) :: zrin            ! inner intercept R (output)
  real(fp) :: zrout           ! outer intercept R (output)
  real(fp) :: zymp            ! midplane vertical displacement (output)
  !
  integer, parameter :: inth = 400
  real(fp), dimension(inth) :: zrcon, zycon
  real(fp), dimension(0:imom) :: zcos,zsin
  !---------------------------------------------------------------------
  !
  zcos(0)=1
  zsin(0)=0
  do ith=1,inth-1
    zth=(twopi*(ith-1))/(inth-1)
    zr=zero
    zy=zero
    call r8sincos(zth,imom,zsin(1:imom),zcos(1:imom))
    do imm=0,imom
      zr=zr+zrmc(imm,1)*zcos(imm)+zrmc(imm,2)*zsin(imm)
      zy=zy+zymc(imm,1)*zcos(imm)+zymc(imm,2)*zsin(imm)
    end do
    zrcon(ith)=zr
    zycon(ith)=zy
  end do
  !
  zrcon(inth)=zrcon(1)
  zycon(inth)=zycon(1)
  !
  call r8_getmpa_ry(zrcon,zycon,inth,zrin,zrout,zymp)
  !
  return
end subroutine r8_getmpa
!---------------------------------------------------------------------
!
subroutine r8_getmpa_ry(zrcon,zycon,inth,zrin,zrout,zymp)
  !
  !  find midplane elevation and R intercepts based on centroid, starting
  !  from a closed contour of (R,Y) pairs
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit none

  integer, intent(in) :: inth
  real(fp), intent(in) :: zrcon(inth),zycon(inth)  ! closed contour

  real(fp), intent(out) :: zrin,zrout    ! midplane intercepts (approx.)
  real(fp), intent(out) :: zymp          ! midplane elevation (centroid)
  !
  !  local:
  !
  real(fp) :: zrmp,zr,zy,zrp,zyp,zytest,zrans
  integer :: ith
  !
  !  find centroid
  !
  call r8_plcentr(zrcon,zycon,inth,zrmp,zymp)
  !
  !  find approximate midplane intercept locations
  !
  zr=zrcon(1)
  zy=zycon(1)
  !
  do ith=2,inth
    !
    zrp=zr
    zyp=zy
    zr=zrcon(ith)
    zy=zycon(ith)
    !
    zytest=(zy-zymp)*(zymp-zyp)
    if(zytest.ge.zero) then
      zrans=(zr*(zymp-zyp)+zrp*(zy-zymp))/(zy-zyp)
      if(zrans.gt.zrmp) then
        zrout=zrans
      else
        zrin=zrans
      end if
    end if
  end do
  !
  return
end subroutine r8_getmpa_ry

!DECK TR_IR8SORT
subroutine TR_IR8SORT (IDX, DY, N, KFLAG)
  !***BEGIN PROLOGUE  TR_IR8SORT
  !***PURPOSE  Sort an array and optionally make the same interchanges in
  !            an auxiliary array.  The array may be sorted in increasing
  !            or decreasing order.  A slightly modified QUICKSORT
  !            algorithm is used.
  !
  !  >> modified version (dmc) -- sort by integer key; carry real(fp) DY array
  !
  !***LIBRARY   SLATEC
  !***CATEGORY  N6A2B
  !***TYPE      doUBLE PRECISION (SSORT-S, TR_DSORT-D, ISORT-I)
  !***KEYWORDS  SINGLETON QUICKSORT, SORT, SORTING
  !***AUTHOR  Jones, R. E., (SNLA)
  !           Wisniewski, J. A., (SNLA)
  !***DESCRIPTION
  !
  !   TR_IR8SORT sorts array IDX and optionally makes the same interchanges in
  !   array DY.  The array IDX may be sorted in increasing order or
  !   decreasing order.  A slightly modified quicksort algorithm is used.
  !
  !   Description of Parameters
  !      IDX - array of values to be sorted   (usually abscissas)
  !      DY - array to be (optionally) carried along
  !      N  - number of values in array IDX to be sorted
  !      KFLAG - control parameter
  !            =  2  means sort IDX in increasing order and carry DY along.
  !            =  1  means sort IDX in increasing order (ignoring DY)
  !            = -1  means sort IDX in decreasing order (ignoring DY)
  !            = -2  means sort IDX in decreasing order and carry DY along.
  !
  !***REFERENCES  R. C. Singleton, Algorithm 347, An efficient algorithm
  !                 for sorting with minimal storage, Communications of
  !                 the ACM, 12, 3 (1969), pp. 185-187.
  !***ROUTINES CALLED  XERMSG
  !***REVISION HISTORY  (YYMMDD)
  !   761101  DATE WRITTEN
  !   761118  Modified to use the Singleton quicksort algorithm.  (JAW)
  !   890531  Changed all specific intrinsics to generic.  (WRB)
  !   890831  Modified array declarations.  (WRB)
  !   891009  Removed unreferenced statement labels.  (WRB)
  !   891024  Changed category.  (WRB)
  !   891024  REVISION DATE from Version 3.2
  !   891214  Prologue converted to Version 4.0 format.  (BAB)
  !   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
  !   901012  Declared all variables; changed X,Y to DX,DY; changed
  !           code to parallel SSORT. (M. McClain)
  !   920501  Reformatted the REFERENCES section.  (DWL, WRB)
  !   920519  Clarified error messages.  (DWL)
  !   920801  Declarations section rebuilt and code restructured to use
  !           if-THEN-else-end if.  (RWC, WRB)
  !***END PROLOGUE  TR_IR8SORT
  !     .. Scalar Arguments ..
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  !
  integer KFLAG, N
  !     .. Array Arguments ..
  integer IDX(*)
  real(fp) DY(*)
  !     .. Local Scalars ..
  real(fp) R, TTY, TY
  integer T, TT
  integer I, IJ, J, K, KK, L, M, NN
  !     .. Local Arrays ..
  integer IL(21), IU(21)
  !     .. External Subroutines ..
  !     .. Intrinsic Functions ..
  INTRINSIC ABS, INT
  !***FIRST EXECUTABLE STATEMENT  TR_IR8SORT
  NN = N
  if (NN .LT. 1) THEN
    write(6,*) ' ?tr_ir8sort:  n.gt.0 expected, n = ',n
    RETURN
  end if
  !
  KK = ABS(KFLAG)
  if (KK.NE.1 .AND. KK.NE.2) THEN
    write(6,*) ' ?tr_ir8sort: kflag = ',kflag,' not in {-2,-1,1,2}'
    RETURN
  end if
  !
  !     Alter array IDX to get decreasing order if needed
  !
  if (KFLAG .LE. -1) THEN
    do I=1,NN
      IDX(I) = -IDX(I)
    end do
  end if
  !
  if (KK .EQ. 2) GO TO 100
  !
  !     Sort IDX only
  !
  M = 1
  I = 1
  J = NN
  R = 0.375D0
  !
20 if (I .EQ. J) GO TO 60
  if (R .LE. 0.5898437_fp) THEN
    R = R+3.90625e-2_fp
  else
    R = R-0.21875_fp
  end if
  !
30 K = I
  !
  !     Select a central element of the array and save it in location T
  !
  IJ = I + INT((J-I)*R)
  T = IDX(IJ)
  !
  !     If first element of array is greater than T, interchange with T
  !
  if (IDX(I) .GT. T) THEN
    IDX(IJ) = IDX(I)
    IDX(I) = T
    T = IDX(IJ)
  end if
  L = J
  !
  !     If last element of array is less than than T, interchange with T
  !
  if (IDX(J) .LT. T) THEN
    IDX(IJ) = IDX(J)
    IDX(J) = T
    T = IDX(IJ)
    !
    !        If first element of array is greater than T, interchange with T
    !
    if (IDX(I) .GT. T) THEN
      IDX(IJ) = IDX(I)
      IDX(I) = T
      T = IDX(IJ)
    end if
  end if
  !
  !     Find an element in the second half of the array which is smaller
  !     than T
  !
40 L = L-1
  if (IDX(L) .GT. T) GO TO 40
  !
  !     Find an element in the first half of the array which is greater
  !     than T
  !
50 K = K+1
  if (IDX(K) .LT. T) GO TO 50
  !
  !     Interchange these elements
  !
  if (K .LE. L) THEN
    TT = IDX(L)
    IDX(L) = IDX(K)
    IDX(K) = TT
    GO TO 40
  end if
  !
  !     Save upper and lower subscripts of the array yet to be sorted
  !
  if (L-I .GT. J-K) THEN
    IL(M) = I
    IU(M) = L
    I = K
    M = M+1
  else
    IL(M) = K
    IU(M) = J
    J = L
    M = M+1
  end if
  GO TO 70
  !
  !     Begin again on another portion of the unsorted array
  !
60 M = M-1
  if (M .EQ. 0) GO TO 190
  I = IL(M)
  J = IU(M)
  !
70 if (J-I .GE. 1) GO TO 30
  if (I .EQ. 1) GO TO 20
  I = I-1
  !
80 I = I+1
  if (I .EQ. J) GO TO 60
  T = IDX(I+1)
  if (IDX(I) .LE. T) GO TO 80
  K = I
  !
90 IDX(K+1) = IDX(K)
  K = K-1
  if (T .LT. IDX(K)) GO TO 90
  IDX(K+1) = T
  GO TO 80
  !
  !     Sort IDX and carry DY along
  !
100 M = 1
  I = 1
  J = NN
  R = 0.375D0
  !
110 if (I .EQ. J) GO TO 150
  if (R .LE. 0.5898437_fp) THEN
    R = R+3.90625e-2_fp
  else
    R = R-0.21875_fp
  end if
  !
120 K = I
  !
  !     Select a central element of the array and save it in location T
  !
  IJ = I + INT((J-I)*R)
  T = IDX(IJ)
  TY = DY(IJ)
  !
  !     If first element of array is greater than T, interchange with T
  !
  if (IDX(I) .GT. T) THEN
    IDX(IJ) = IDX(I)
    IDX(I) = T
    T = IDX(IJ)
    DY(IJ) = DY(I)
    DY(I) = TY
    TY = DY(IJ)
  end if
  L = J
  !
  !     If last element of array is less than T, interchange with T
  !
  if (IDX(J) .LT. T) THEN
    IDX(IJ) = IDX(J)
    IDX(J) = T
    T = IDX(IJ)
    DY(IJ) = DY(J)
    DY(J) = TY
    TY = DY(IJ)
    !
    !        If first element of array is greater than T, interchange with T
    !
    if (IDX(I) .GT. T) THEN
      IDX(IJ) = IDX(I)
      IDX(I) = T
      T = IDX(IJ)
      DY(IJ) = DY(I)
      DY(I) = TY
      TY = DY(IJ)
    end if
  end if
  !
  !     Find an element in the second half of the array which is smaller
  !     than T
  !
130 L = L-1
  if (IDX(L) .GT. T) GO TO 130
  !
  !     Find an element in the first half of the array which is greater
  !     than T
  !
140 K = K+1
  if (IDX(K) .LT. T) GO TO 140
  !
  !     Interchange these elements
  !
  if (K .LE. L) THEN
    TT = IDX(L)
    IDX(L) = IDX(K)
    IDX(K) = TT
    TTY = DY(L)
    DY(L) = DY(K)
    DY(K) = TTY
    GO TO 130
  end if
  !
  !     Save upper and lower subscripts of the array yet to be sorted
  !
  if (L-I .GT. J-K) THEN
    IL(M) = I
    IU(M) = L
    I = K
    M = M+1
  else
    IL(M) = K
    IU(M) = J
    J = L
    M = M+1
  end if
  GO TO 160
  !
  !     Begin again on another portion of the unsorted array
  !
150 M = M-1
  if (M .EQ. 0) GO TO 190
  I = IL(M)
  J = IU(M)
  !
160 if (J-I .GE. 1) GO TO 120
  if (I .EQ. 1) GO TO 110
  I = I-1
  !
170 I = I+1
  if (I .EQ. J) GO TO 150
  T = IDX(I+1)
  TY = DY(I+1)
  if (IDX(I) .LE. T) GO TO 170
  K = I
  !
180 IDX(K+1) = IDX(K)
  DY(K+1) = DY(K)
  K = K-1
  if (T .LT. IDX(K)) GO TO 180
  IDX(K+1) = T
  DY(K+1) = TY
  GO TO 170
  !
  !     Clean up
  !
190 if (KFLAG .LE. -1) THEN
    do I=1,NN
      IDX(I) = -IDX(I)
    end do
  end if
  RETURN
end subroutine TR_IR8SORT

C  add 3D ufile to MDSplus
C  01/26/01 C.Ludescher
 
      subroutine add3duf(lun,signam,
     >     F,NF,X,NX,Y,NY,z,nz,IPROC,
     >     NXACT,NYACT,nzact,IFLAG,
     >     FLAB,XLAB,YLAB,zlab,
     >     NSCD,NSCA,SCVAL,SCLAB,
     >     IER)
 
      implicit none
 
      integer       lun
      character*(*) signam
      integer       NF, NX, NY, nz, IPROC
      integer       NXACT,NYACT,nzact,IFLAG
      REAL          X(NX),F(NF),Y(NY),z(nz),SCVAL(*)
      CHARACTER*30  XLAB, YLAB, zlab, FLAB, SCLAB(*)
      integer       NSCD, NSCA
      integer       ier
C
C For MDSplus
      integer       MdsPut,  idescr_floatarr
      integer       mds_create_node,  idescr_cstring
      integer       idims(3)
      integer       size
      character*10  uf, ux, uy, uz
      character*21  zunits
      character*120 expr
      integer       stat
 
 
 
C-----------------------------------------------------
 
C Create signal node in .INPUTS
      stat=mds_create_node(signam,'signal')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then   ! TreeALREADY_THERE
            call mdsmsg(lun,signam//' node create status:  ',stat)
            ier=1
            go to 9000
         endif	
      endif
C Create Label
      stat=mds_create_node(signam//':LABEL','text')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then   ! TreeALREADY_THERE
            call mdsmsg(lun,signam//':LABEL create status:  ',stat)
            ier=1
            go to 9000
         endif
      endif	
      expr=signam//':LABEL'//CHAR(0)
      stat=MdsPut(expr,'$'//char(0),
     >     idescr_cstring(flab(1:20)),0)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,expr//' put status:  ',stat)
      endif
 
C Create Comment
      stat=mds_create_node(signam//
     >     ':COMMENT','text')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then   ! TreeALREADY_THERE
            call mdsmsg(lun,signam//':COMMENT create status:  ',stat)
            ier=1
            go to 9000
         endif
      endif	
 
C Create FILENAME
      stat=mds_create_node(signam//':FILENAME','text')
      if (mod(stat,2).ne.1) then
         if (stat .ne. 265388168) then   ! TreeALREADY_THERE
            call mdsmsg(lun,signam//':FILENAME create status:  ',stat)
            ier=1
            go to 9000
         endif
      endif	
 
C Write data
      idims(1)=nxact
      idims(2)=nyact
      idims(3)=nzact
      uf=flab(21:30)
      ux=xlab(21:30)
      uy=ylab(21:30)
      uz=zlab(21:30)
 
      zunits='build_with_units($,$)'
      expr='build_signal('//zunits//',*,'//zunits//','//zunits//
     >          ','//zunits// ')' //CHAR(0)
 
	stat=MdsPut(signam//CHAR(0),expr,
     >       idescr_floatarr(f,idims,3),idescr_cstring(uf),
     >	     idescr_floatarr(x,idims,1),idescr_cstring(ux),
     >       idescr_floatarr(y,idims(2),1),idescr_cstring(uy),
     >       idescr_floatarr(z,idims(3),1),idescr_cstring(uz),0)
 
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,expr//' put status:  ',stat)
      endif
C
C Add scalars
      call add0duf(lun,signam,nscd,nsca,scval,sclab,ier)
      return
C
 9000  continue
       return
      end
 
 
 
 
 
 

C Write Scalars to netCDF Ufiles
C
C 08/13/97 CAL
C
C---------------------------------------------------------------------------
      subroutine ucdf0w(lun, option, nsca, scval, sclab, retn)
 
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Input
      integer       lun, nsca
      integer       option          ! 1 = number of scalars only
C                                   ! 2 = write scalars
      character*10  sclab(3,nsca)
      real          scval(nsca)
C Return
      integer retn
 
 
C Definitions for processing
      integer n_sc, nsc
      parameter(n_sc = 200)
      integer ichan, file_id
      integer i,     j
      integer sc_id(n_sc)
C
C-----------------------------------------------------------------------
C get file name
      call uflchk(lun,'uhdf0w',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
C
C
      nsc = nsca
      if (nsca .gt. n_sc) then
         nsc = n_sc
         write(ufelun,9006) nsca, nsc
 9006    format(
     > ' % UCDF0W: --Warning-- Number of Scalars truncated from',
     >   i4,' to',i4)
      end if
 
C Write Number of scalars as global attribute
C
      if (option .eq. 1) then
         retn = nf_put_att_int(file_id,NF_GLOBAL,'num_scalars',
     &        NF_INT,1,nsc)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9004) NF_STRERROR(retn)
 9004       format(' % UCDF0W: nf_put_att_int - num_scalars'/,
     >       '     ',a)
         end if
         if (nsc .gt. 0) return
C
C if no scalars:
C Enter Data Mode
         retn = nf_enddef(file_id)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9003) NF_STRERROR(retn)
            return
         end if
         return
      end if
C
C---------------------------------------------------------------------------
C
C Write Scalars as variables
C===========================
C       Label is broken up in :
C        1:10  =  Variable name
C       11:20  =  attribute long-name
C       21:30  =  attribute units
C
C Enter Define Mode
C      retn = nf_redef(file_id)
C      if (retn .ne. NF_NOERR) then
C            write(ufelun,9005) NF_STRERROR(retn)
C 9005       format(' % UCDF0W: nf_redef -- ',a)
C         return
C      end if
C
 
C Write Scalar Names
      do i=1,nsc
         j = index(sclab(1,i),':')-1
         retn = nf_def_var(file_id, sclab(1,i)(1:j), NF_FLOAT,
     >        0, 0, sc_id(i))
         if (retn .ne. 0) then
            write(ufelun,9001) i,NF_STRERROR(retn)
            return
         end if
         retn = nf_put_att_text(file_id,sc_id(i),'long_name',10,
     >        sclab(2,i))
         if (retn .ne. 0) then
            write(ufelun,9002) i,NF_STRERROR(retn)
            return
         end if
         retn = nf_put_att_text(file_id,sc_id(i),'units',10,
     >        sclab(3,i))
         if (retn .ne. 0) then
            write(ufelun,9002) i,NF_STRERROR(retn)
            return
         end if
      end do
 9001 format(' % UCDF0W: nf_def_var - sclab',i3/,
     >     '     ',a)
 9002 format(' % UCDF0W: nf_put_att_text - sclab',i3/,
     >     '     ',a)
 
C
C Write Scalar Values
C-----------------------
C Enter Data Mode
      retn = nf_enddef(file_id)
      if (retn .ne. NF_NOERR) then
            write(ufelun,9003) NF_STRERROR(retn)
 9003       format(' % UCDF0W: nf_enddef -- ',a)
         return
      end if
C
      do i=1,nsc
         retn = nf_put_var_real(file_id, sc_id(i), scval(i))
         if (retn .ne. 0) then
            write(ufelun,9000) i,NF_STRERROR(retn)
            return
         end if
      end do
 9000 format(' % UCDF0W: nf_put_var_real - scval',i3/,
     >     '     ',a)
C
      return
      end
 
 
 
 
 
 
 
 

      subroutine mds_rdwr(lunerr, tr_socket, tr_tree, tr_pulse,
     >                    signam, zfile, device, opt, ier)
C Read a ufile and write into MDSplus
C 02/09/01 CAL
C
      implicit none
C Input
      integer       lunerr    ! lun for error messages
      integer       tr_socket ! TRANSP-run mds_socket
      character*(*) tr_tree   ! TRANSP-run Tree name
      integer       tr_pulse  ! TRANSP-run mds_pulse
      character*(*) signam    ! MDS signal name path
      character*(*) zfile     ! Ufile Name
      character*(*) device    ! Tokamak
      integer       opt       ! 1 = 1st time: connect to server
C                             ! 0 = don't connect
C Output
      integer       ier       ! = 0 success
C                             ! = 2 Ufile read error
C                             ! = 4 Ufile Write error
C                             ! other = error
C
      character*20  label     ! output = TRDAT Label
 
      integer       ilnurd    ! vaxonly function
C
C  OUTPUT from UFHDCK
C    INFO -- INFORMATION BLOCK
C    INFO(1)=FILE DIMENSIONALITY
C    INFO(2)=TOTAL # OF WORDS IN DEPENDENT DATA ARRAY
C    INFO(3)=SIZE OF FIRST DIMENSION OF DATA ARRAY
C    INFO(4)=SIZE OF SECOND DIMENSION OF DATA ARRAY (IF APPLICABLE)
C     ...
C    INFO(8)=NUMBER OF SCALARS IN DATA FILE
C
C    IER = 0 IF ROUTINE COMPLETES EXECUTION SUCCESSFULLY
      integer info(8)
 
      character*50  zdev,zpre,zext
      character*128 zdir
 
      integer ilun,icdf
      integer ishot
 
C to read ufile
      integer  maxsc, maxd, maxx, maxz
      parameter(maxsc=200)
      parameter(maxx=300000)
      parameter(maxz=200)
      parameter(maxd=8000000)
c
      real         scval(maxsc)
      character*30 sclab(maxsc)
c
      real         f(maxd), x(maxx), y(maxx), z(maxz)
      character*30 xlab, ylab, zlab, flab
c
      integer      iproc
      character*10 shdate
      character*4  tokdev
      !AEP related
      integer :: isiza,npack,MKAEP,MTAEP
      integer :: MdEAEP,MdpAEP,MEAEP,MpAEP,MmuAEP !dimensions for AEP
      real, dimension(:), allocatable :: dat_buf
      character*30 ::  sclab_buf(3)
      character*9 :: ctunits,ceunits !units for Time and Energy from Ufile  
 
      integer max1, inx, iny, inz, iflag, l, stat
C MDSplus
      integer      MdsSetSocket
C-----------------------------------------------------------------------
c
C  initialize
C
      call uinita(0)
C
      call ufinit
      call ufncap(2)
      call ufnpars(zfile,zdev,zdir,zpre,ishot,zext,ier)
      if(ier.ne.0) return
C
      ilun=97
C
C Open file
      call ufsetr(ilun,zpre,zext,zdev,zdir)
      if(ishot.lt.0) call ufnsho(ilun)
C MDSplus
      if (zpre(1:4) .eq. 'MDS+') then
         if (opt .eq. 1) then                ! 1st time connect to server
            call ufoprd(ilun,max(0,ishot),ier)
         else                                ! follow up
            call ufoprd(ilun,min(ishot,-ishot),ier)
         endif
         if(ier.ne.0) then
             print '(1x,a,'':  open error'')', zfile
             ier=-77
             return
         endif
C NOT MDSplus
      else
          call ufoprd(ilun,max(0,ishot),ier)
          if(ier.ne.0) then
C Ripple file
              if (zext .eq. 'RPL' .or. zext .eq. 'rpl') then
                  call ufsetr(ilun,zpre,zext,' ',' ')
                  call ufnsho(ilun)
                  call ufoprd(ilun,min(ishot,-ishot),ier)
              endif
          endif
          if(ier.ne.0) then
              print '(1x,a,'':  open error'')', zfile
              return
          endif
      endif
C
C Read Header
      if (zext .eq. 'AEP' .or. zext .eq. 'aep') then
!AEP operator  spcial treatment
!  read data
!  get dimensions, netcdf Ufile will be closed if an error occured
         call ufcdfrd_aep_dim(lunerr,ilun,icdf,npack,MKAEP,MTAEP,MdEAEP,
     >        MdpAEP,MEAEP,MpAEP,MmuAEP,ier)
         if(ier.gt.0)then
            return
         endif
         isiza = 8 + MTAEP + MKAEP*(17+MTAEP) + 2*npack
         if(allocated(dat_buf)) deallocate(dat_buf)
         allocate(dat_buf(isiza))
         sclab_buf(1)="AEP operator"
         !get AEP data into a buffer and close ilun file
         call UFCDFRD_AEP_DATA(lunerr,icdf,ishot,npack,MKAEP,MTAEP,
     >        MdEAEP,MdpAEP,MEAEP,MpAEP,MmuAEP,isiza,dat_buf,
     >        ctunits,ceunits,ier) 
         sclab_buf(2)=ctunits
         sclab_buf(3)=ceunits
         if(ier.ne.0) then
            print '(1x,a,'':  open error'')', zfile
            ier=2
            return
         endif
         info(1)=0
!MG         goto 101
      else
         call ufhdck(ilun,info,ier)
      endif
      if(ier.ne.0) then
          print '(1x,a,'':  read error'')', zfile
          goto 100
      endif
      flab=' '
      if (info(1) .eq. 1) then
	  call uf1drd(ilun,tokdev,shdate,
     >      x,y,maxx,inx,iproc,xlab,ylab,
     >      maxsc,info(8),scval,sclab,ier)
      else if (info(1) .eq. 2) then
	  iflag=1
	  max1=maxd/maxx
	  call uf2drd(ilun,tokdev,shdate,
     >      f,max1,x,maxx,y,maxx,iproc,
     >      inx,iny,iflag,flab,xlab,ylab,
     >      maxsc,info(8),scval,sclab,ier)
      else if (info(1) .eq. 3) then
	  iflag=1
	  max1=maxd/maxz/maxz
	  call uf3drd(ilun,tokdev,shdate,
     >      f,max1,maxz,x,maxx,y,maxx,z,maxz,iproc,
     >      inx,iny,inz,iflag,flab,xlab,ylab,zlab,
     >      maxsc,info(8),scval,sclab,ier)
      endif
      if(ier .ne.0) then
         print*,'uf*drd error #',ier
         call ufclos(ilun)
         ier=2
         return
      endif
      l=1
      do while (l .le. 20 .and. flab(l:l) .lt. char(48))
         l=l+1
      end do
      if (l.lt.20) label= flab(l:20)
 100  call ufclos(ilun)
      if (ier .ne. 0) return
C
C re-set socket for TRANSP Tree
C
 101  stat = MdsSetSocket(tr_socket)
 
      if (info(1) .eq. 1) then
         call add1duf(lunerr,signam,
     >      x,y,maxx,iproc,
     >      inx, iflag, xlab,ylab,
     >      maxsc,info(8),scval,sclab,ier)
      else if (info(1) .eq. 2) then
         call add2duf(lunerr,signam,
     >      f,max1,x,maxx,y,maxx,iproc,
     >      inx,iny,iflag,flab,xlab,ylab,
     >      maxsc,info(8),scval,sclab,ier)
      else if (info(1) .eq. 3) then
         call add3duf(lunerr,signam,
     >      f,maxd,x,maxx,y,maxx,z,maxz,iproc,
     >      inx,iny,inz,iflag,flab,xlab,ylab,zlab,
     >      maxsc,info(8),scval,sclab,ier)
      else if (info(1) .eq. 0.and.
     >        (zext .eq. 'AEP' .or. zext .eq. 'aep')) then
         call addaepuf(lunerr,signam,isiza,isiza,dat_buf,sclab_buf,ier)
         if(allocated(dat_buf)) deallocate(dat_buf)
      endif
 
C
      if(ier .ne.0) then
         print*,'add*duf error #',ier
         ier = 4
      endif
      return
      end
 
 
 
 
 

C Read 1D CDF U-file
C Called from uf1drd
C
C 07/25/97 CAL
C
C----------------------------------------------------------------------------
      subroutine ucdf1r(lun,option,
     &            f, x, n_x, nx, iproc,
     &            flab, xlab,
     &            retn)
C
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Input:
      integer lun
      integer option   ! 1 = get Dimensions
C                      ! 2 = get data arrays
      integer n_x
C Return:
      integer      nx, iproc
      character*30 flab, xlab
      real         x(n_x), f(n_x)
      integer retn
 
C Definitions for CDF
      integer dims
      integer rank
      integer nvars, ngatts, unlimid, nsc
      integer var_id
      integer nvdims
      character*10 dimnam
 
C Definitions for processing
      integer       file_id,  ichan
      character*20  fl,   xl
      character*10  fu,   xu
      integer       i,    ierr, l
 
      save    rank
C--------------------------------------------------------
C
C get file name
      call uflchk(lun,'ucdf1r',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
 
C
      if (option .eq. 1) then       ! get Dimensions
 
C Inquire about file
         retn = nf_inq(file_id, rank, nvars, ngatts, unlimid)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9000) NF_STRERROR(retn)
 9000       format(' % UCDF1R: nf_inq'/,
     >           '     ',a)
            return
         end if
C
C Inquire dimensions
 
         retn = nf_inq_dim(file_id,1,dimnam,dims)
         if (retn .ne. NF_NOERR) then
            i=1
            write(ufelun,9001) i, NF_STRERROR(retn)
 9001       format(' % UCDF1R: nf_inq_dim',i2/,
     >           '     ',a)
            return
         end if
C         type *,dimnam,dims
         nx = dims
C-----------------------------------------------------------------------
      else if (option .eq. 2) then
C
 
C Get data attributes
         nsc = nvars - rank - 1
         var_id = nsc+1
         retn = nf_get_att_text(file_id,var_id,'long_name',fl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
 9002       format(' % UCDF1R: nf_get_att_text id =',i3/,
     >           '     ',a)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',fu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         flab=fl(1:20)//fu(1:10)
C Get X attributes
         var_id = var_id + 1
         retn = nf_get_att_text(file_id,var_id,'long_name',xl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',xu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         else
            xlab=xl(1:20)//xu(1:10)
         end if
C
C Read X
         var_id =  nsc+2
         retn = nf_get_var_real(file_id, var_id, x)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
 
C get array data
         var_id = nsc + 1          ! Data is 1st variable after Scalars
         retn = nf_get_var_real(file_id, var_id, f)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9003) var_id, NF_STRERROR(retn)
 9003       format(' % UCDF1R: nf_get_var_real id =',i3/,
     >           '     ',a)
            return
         end if
      end if
      return
      end
 
 
 
 
 
 

C******************** START FILE UPSADL.FOR ; GROUP USPARM *************
C---------------------------------------------------------------
C&  UPSADL   ADD DEFINITION OF A LOCAL UREAD STRING PARAMETER
C     ARGUMENTS-- ZVAL 96 CHAR VALUE
C                 ZNAM  16 CHAR NAME
C
C     ZNAM forced to uppercase
C     ZVAL NOT forced to uppercase
C
      SUBROUTINE UPSADL(ZNAM,ZVAL)
 
C  Updated:
C	 5/20/92 TBT Melt "\" in value line.
C        6/18/92 DMC -- bugfix in "\" melt code
 
      USE USERIO
 
      CHARACTER*16 ZNAM
      CHARACTER*96 ZVAL
      Character*1 Backslsh
 
      Data Backslsh /'\\'/  !unix needs escaped backslash
 
C	.Loop in case more than one "\".  "\\" yields "\"
      Indy = 0
      Do 100 I=1,96
          Indp = Indy                                      !dmc
          Indy = Indy + INDEX (ZVAL(Indy+1:96), Backslsh)  !dmc
          If (Indy .EQ. Indp) GO TO 101                    !dmc
C	    .Melt Backslash
          ZVAL(Indy:96) = ZVAL(Indy+1:96)
 100  Continue
 101  Continue
 
C
      CALL USPCAP(ZNAM)
      IF(NPLC(MAX0(NLUNIN,NLUNIO)).GE.NPLMAX) GO TO 500
      NPLC(MAX0(NLUNIN,NLUNIO))=NPLC(MAX0(NLUNIN,NLUNIO))+1
      NP=NPLC(MAX0(NLUNIN,NLUNIO))
      PLCVAL(NP,MAX0(NLUNIN,NLUNIO))=ZVAL
      PLCNAM(NP,MAX0(NLUNIN,NLUNIO))=ZNAM
      IF(NLECHO) WRITE(LUNTRM,7001) ZNAM,ZVAL
 7001 FORMAT(' LOCAL PARAMETER ASSIGNMENT SUCCESSFUL:'/
     >  '  "',A,'" = "',A,'"')
      RETURN
C
 500  CONTINUE
      WRITE(LUNTRM,9001) ZNAM
 9001 FORMAT(' % MAXIMUM LOCAL PARAMETER COUNT EXCEEDED'/
     >  '   PARAMETER "',A16,'" LOST'/)
      CALL UPAUST(1)
      RETURN
      		END
C******************** END FILE UPSADL.FOR ; GROUP USPARM ***************

!
! --------------------- adp_reset ----------------------
! calls adpak's adset initialization routine ADSET() only if the 
! parameters have changed since the last call.  If the kldrmlt
! parameter is nonzero then the appropriate dielectronic
! input values should have been set in adpak_mod.
!
subroutine adp_reset(knucz, kladen, kladtip, kleci, kldrmlt, ier)
  use adpak_mod
  implicit none

  integer, intent(in) :: knucz   ! atomic number of impurity
  integer, intent(in) :: kladen  ! -1 -> do not change
                                 !  0 -> use H. MAYER SHIELDING CONSTANTS
                                 !  1 -> use R. MORE REVISED SHIELDING CONSTANTS
  integer, intent(in) :: kladtip ! -1 -> do not change
                                 !  0 -> do not use tabulated ionization potentials
                                 !  1 -> use the tabulated ionization potentials
  integer, intent(in) :: kleci   ! switch for selecting formula to use for electron collisional ionization rate
                                 ! -1 -> do not change
                                 !  1 -> USE XSNQ DERIVED IONIZATION RATE CALCULATION
                                 !  2 -> USE BELFAST GROUP LIGHT ELEMENT RATE FITS
                                 !  3 -> USE YOUNGER'S RATES FOR AVAILABLE ELEMENTS AND SHELLS
                                 !       XSNQ RATES OTHERWISE ON A CHARGE STATE-BY-CHARGE STATE BASIS
  integer, intent(in) :: kldrmlt ! setup DIELECTRONIC RECOMBINATION RATE COEFFICIENT ARRAYS CDNN,CDNM
                                 ! -1 -> do not change
                                 !  0 -> USE CDNN, CDNM ARRAYS AS GIVEN
                                 !  1 -> CDNN, CDNM ARRAYS SET TO 1.0
                                 !  2 -> USE Y. HAHN FACTORS TO SETUP CDNN, CDNM
  integer, intent(out) :: ier    ! nonzero if there was an error setting up adpak

  ier=0
  if (knucz /= nucz) goto 10
  if (kladen>=0 .and. kladen/=laden) goto 10
  if (kladtip>=0 .and. kladtip/=ladtip) goto 10
  if (kleci>=0 .and. kleci/=leci) goto 10
  if (kldrmlt>=0 .and. kldrmlt/=ldrmlt) goto 10

  return  ! do nothing

10 continue
  ! -- update --
  if (kladen>=0)  laden  = kladen
  if (kladtip>=0) ladtip = kladtip
  if (kleci>=0)   leci   = kleci
  if (kldrmlt>=0) ldrmlt = kldrmlt

  ! write(*,'(a,5(i3,1x))') 'adreset = ', knucz, kladen, kladtip, kleci, kldrmlt
  call adset(knucz,ier)   ! get error code

end subroutine adp_reset

subroutine r8splcrda (ZXI99, IJACI, &
     LCENTR, MIMOM, NMOM, MTBL, XIBLO, &
     RMCX,RMCXS,YMCX,YMCXS, &
     ZRMCX1,ZRMCX2,ZYMCX1,ZYMCX2, &
     ZRMCXP1,ZRMCXP2,ZYMCXP1,ZYMCXP2)
  !
  !  B.BALET - JET  MAR 1994 : MODifIED VERSION OF SPLCRD.FOR TO SUPPORT
  !                            UP-doWN ASYMMETRIC CASE; SHOULD BE CALLED
  !                            ONLY if LEVGEO = 6 or 7 or 8 or 9 (NLSYM = F)
  !
  !  dmc 24 Dec 1996:  this version does not depend on TRCOM:  all args passed.
  !  ** updown asymmetric SPLCRDA **
  !
  !  call from MOMRY/MOMRZ; caller does arg error checking!
  !
  !  input args:
  !
  !   ZXI99 -- "xi" (radial coordinate) **** must be in range ****
  !     ==> interpolate moments set to "xi"
  !   IJACI -- IJAC flag as input (see below)
  !
  !   LCENTR -- 1 + index offset in XIBLO, RMB0, RMB2, YMB2, rel. to.
  !      RMB0S,RMB2S,YMB2S
  !      (for TRANSP compatibility; set to 1 if all arrays are on
  !      the same indexing grid)
  !
  !   MIMOM -- max no. of moments (array dimension)
  !   NMOM  -- actual no. of moments in use
  !   MTBL --- max no. of radial points including "bloat" (array dimension)
  !
  !   XIBLO(..) -- "xi" grid points, including bloat region beyond plasma bdy
  !
  !   RMCX(..) -- R moments array
  !   RMCXS(..) -- R moments spline coeffs
  !   YMCX(..) -- Y moments array
  !   YMCXS(..) -- Y moments spline coeffs
  !
  !  output args:
  !   ZRMCX1(..) -- R cos moments interpolated
  !   ZRMCX2(..) -- R sin moments interpolated
  !   ZYMCX1(..) -- Y cos moments interpolated
  !   ZYMCX2(..) -- Y sin moments interpolated
  !  (if IJAC set):  derivatives w.r.t. xi:
  !   ZRMCXP1(..) -- R cos moments derivative
  !   ZRMCXP2(..) -- R sin moments derivative
  !   ZYMCXP1(..) -- Y cos moments derivative
  !   ZYMCXP2(..) -- Y sin moments derivative
  !
  !
  !	EVALUATE SPLINE COEFFICIENTS DIRECTLY ... GIVEN A RADIAL
  !	COORD "ZXI99", RETURN THE MHD FOURIER COEFFICIENTS (AND THEIR
  !	DERIVATIVES) DESCRIBING THE PLASMA SURFACE ON THAT COORD.
  !
  !  MOD DMC APRIL 1990 -- LINEAR INTERPOLATION OPTION
  !
  !  if IJAC=0 OR IJAC=1 USE THE SPLINES
  !  if IJAC=2 OR IJAC=3 do LINEAR INTERPOLATION INSTEAD
  !
  !  if IJAC=1 OR IJAC=3 EVALUATE DATA FOR THE JACOBIAN
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  !   input arrays:
  integer :: ijaci,lcentr,mimom,nmom,mtbl,ijac,is,isl1,j,isp1
  real(fp) :: zxi99,zdxii,zdx99,zdx99i
  real(fp) :: XIBLO(MTBL)
  real(fp) :: RMCX(MTBL,0:MIMOM,2),RMCXS(MTBL,0:MIMOM,2,3)
  real(fp) :: YMCX(MTBL,0:MIMOM,2),YMCXS(MTBL,0:MIMOM,2,3)

  !   output arrays:
  real(fp), dimension(0:mimom) :: zrmcx1,zrmcx2
  real(fp), dimension(0:mimom) :: zymcx1,zymcx2
  real(fp), dimension(0:mimom) :: zrmcxp1,zrmcxp2
  real(fp), dimension(0:mimom) :: zymcxp1,zymcxp2
  !
  !-------------------------------------
  !
  IJAC=abs(IJACI)
  !
  ZDXII= 1.0D0/ (XIBLO(LCENTR+1)-XIBLO(LCENTR))
  IS = ZXI99 * ZDXII + 1
  !
20 continue
  ISL1=IS+LCENTR-1
  if(zxi99.le.xiblo(isl1)) then
    is=is-1
    go to 20
  end if
  if(zxi99.gt.xiblo(isl1+1)) then
    is=is+1
    go to 20
  end if
  !
  ZDX99 = ZXI99 - XIBLO(ISL1)
  !
  if(IJAC.LE.1) THEN
 
    !	EVALUATE SPLINE
    !
    do J = 0, NMOM

      !	      RM(X) :
      !
      ZRMCX1(J) = RMCX(ISL1,J,1) + ZDX99*(RMCXS(IS,J,1,1) + &
           ZDX99*(RMCXS(IS,J,1,2) + ZDX99*RMCXS(IS,J,1,3)))
      ZRMCX2(J) = RMCX(ISL1,J,2) + ZDX99*(RMCXS(IS,J,2,1) + &
           ZDX99*(RMCXS(IS,J,2,2) + ZDX99*RMCXS(IS,J,2,3)))
      !
      !	      YM(X) :
      !
      ZYMCX1(J) = YMCX(ISL1,J,1) + ZDX99*(YMCXS(IS,J,1,1) + &
           ZDX99*(YMCXS(IS,J,1,2) + ZDX99*YMCXS(IS,J,1,3)))
      ZYMCX2(J) = YMCX(ISL1,J,2) + ZDX99*(YMCXS(IS,J,2,1) + &
           ZDX99*(YMCXS(IS,J,2,2) + ZDX99*YMCXS(IS,J,2,3)))

    end do

  else
    !
    !  EVALUATE BY LINEAR INTERPOLATION
    !
    ISP1=ISL1+1
    ZDX99I=ZDX99*ZDXII
    !
    do J = 0, NMOM

      ZRMCX1(J)= RMCX(ISL1,J,1) + &
           ZDX99I*(RMCX(ISP1,J,1)-RMCX(ISL1,J,1))
      ZRMCX2(J)= RMCX(ISL1,J,2) + &
           ZDX99I*(RMCX(ISP1,J,2)-RMCX(ISL1,J,2))
      ZYMCX1(J)= YMCX(ISL1,J,1) + &
           ZDX99I*(YMCX(ISP1,J,1)-YMCX(ISL1,J,1))
      ZYMCX2(J)= YMCX(ISL1,J,2) + &
           ZDX99I*(YMCX(ISP1,J,2)-YMCX(ISL1,J,2))

    end do

  end if
 
  !..................................
  if (IJAC.EQ.0) RETURN
  if (IJAC.EQ.2) RETURN
  !..................................

  if(IJAC.LE.1) THEN
    !
    !  SPLINES
    !
    do J = 0, NMOM

      !     D[RM(X)]/DX
      ZRMCXP1(J) = RMCXS(IS,J,1,1) + &
           ZDX99*(2._fp*RMCXS(IS,J,1,2) + &
           3._fp*ZDX99*RMCXS(IS,J,1,3))
      ZRMCXP2(J) = RMCXS(IS,J,2,1) + &
           ZDX99*(2._fp*RMCXS(IS,J,2,2) + &
           3._fp*ZDX99*RMCXS(IS,J,2,3))
 
      !     D[YM(X)]/DX
      ZYMCXP1(J) = YMCXS(IS,J,1,1) + &
           ZDX99*(2._fp*YMCXS(IS,J,1,2) + &
           3._fp*ZDX99*YMCXS(IS,J,1,3))
      ZYMCXP2(J) = YMCXS(IS,J,2,1) + &
           ZDX99*(2._fp*YMCXS(IS,J,2,2) + &
           3._fp*ZDX99*YMCXS(IS,J,2,3))
 
    end do
 
  else
    !
    !  LINEAR INTERPOLATION
    !
    do J = 0, NMOM
 
      ZRMCXP1(J) = (RMCX(ISP1,J,1)-RMCX(ISL1,J,1))*ZDXII
      ZRMCXP2(J) = (RMCX(ISP1,J,2)-RMCX(ISL1,J,2))*ZDXII
      ZYMCXP1(J) = (YMCX(ISP1,J,1)-YMCX(ISL1,J,1))*ZDXII
      ZYMCXP2(J) = (YMCX(ISP1,J,2)-YMCX(ISL1,J,2))*ZDXII

    end do

  end if
  !
  RETURN
END subroutine r8splcrda

subroutine frantic_input_restore(filename,izones,ierr)

  !  restore the state of a frantic calcution -- i.e. just before
  !  re-executing the calculation in `frantic_test.f90'.

  use ezcdf
  implicit none

  character(len=*), intent(in) :: filename ! NetCDF filename
  integer, intent(out) :: izones           ! number of user zones
  integer, intent(out) :: ierr             ! completion code, 0=OK

  !-----------------------------------------------

  integer ncid

  !-----------------------------------------------
  !  open the file and read...

  call frantic_module_read(filename,ierr)
  if(ierr.ne.0) then
    ierr=4
    return
  end if

  call frantic_get_nx_user(izones)

  return
end subroutine frantic_input_restore

!
!  return preact handle for selected impact ionization or
!  neutralizing charge exchange reaction
!
subroutine hatom_handle(irtype,izneut,izchrg,ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, parameter :: CX=1, II=2
 
  integer, parameter :: H=1, HE=2, LI=3
 
  integer, intent(in) :: irtype   ! reaction type: =cx or =ii
  integer, intent(in)  :: izneut  ! Z of neutral species
  integer, intent(in)  :: izchrg  ! Z of ion species
 
  integer, intent(out) :: ihandle ! preact handle of selected reaction
 
  !  ihandle = 0 returned if reaction is not known...
  !------------------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  ihandle = 0
 
  if(irtype.eq.CX) then
 
     !  ---------> (neutralizing) charge exchange
 
     if(izneut.eq.H) then
        if(izchrg.eq.H) then
           ihandle = Lcx_H0_H
        endif
 
     else if(izneut.eq.HE) then
        if(izchrg.eq.H) then
           ihandle = Lcx_HE0_H
        else if(izchrg.eq.HE) then
           ihandle = Lcx_HE0_HE
        endif
 
     else if(izneut.eq.LI) then
        if(izchrg.eq.H) then
           ihandle = Lcx_LI0_H
        else if(izchrg.eq.HE) then
           ihandle = Lcx_LI0_HE
        else if(izchrg.eq.LI) then
           ihandle = Lcx_LI0_LI
        endif
 
     endif
 
  else if(irtype.eq.II) then
 
     !  ---------> impact ionization
     !      or, sum of impact ionization and partial charge exchange
 
     if(izneut.eq.H) then
        if(izchrg.eq.H) then
           ihandle = Lii_H0_H
        else if(izchrg.eq.HE) then
           ihandle = Lii_H0_HE
        else if(izchrg.eq.LI) then
           ihandle = Lii_H0_LI
        endif
 
     else if(izneut.eq.HE) then
        if(izchrg.eq.H) then
           ihandle = Lii_HE0_H
        else if(izchrg.eq.HE) then
           ihandle = Lii_HE0_HE
        else if(izchrg.eq.LI) then
           ihandle = Lii_HE0_LI
        endif
 
     else if(izneut.eq.LI) then
        if(izchrg.eq.H) then
           ihandle = Lii_LI0_H
        else if(izchrg.eq.HE) then
           ihandle = Lii_LI0_HE
        else if(izchrg.eq.LI) then
           ihandle = Lii_LI0_LI
        endif
 
     endif
 
  endif
 
end subroutine hatom_handle

!
! Calls the appropriate adpak routines for calculating ionization,
! recombination and radiation rates.  Calling all three will result
! in duplicate calls to ADDREC and ADRREC.  If this is a problem,
! then you may want to call ADERC directly.
!
!
! -------------- adp_ioniz_r8 ------------------
! return the electron ionization rate due to electron ionization
!
! adset or adreset must have been called before this subroutine
!
subroutine adp_ioniz_r8(te, ane, telion)
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  implicit none
  save

  real(fp), intent(in)    :: te     ! electron temperature in KeV
  real(fp), intent(in)    :: ane    ! electron density in m-3

  real(fp), intent(out)   :: telion(*) ! ionization rate (sec-1)

  real(fp)    :: pte    ! electron temperature in KeV
  real(fp)    :: pne    ! electron density in cm-3
  integer :: jspc   ! loop variable

  !
  ! calculate rates in adpak
  !  
  pte = te
  pne = 1.e-6_fp*ane     ! convert from m-3 to cm-3
  call ADECI(PTE,PNE) ! fill RCLION, CIZLOS

  do jspc = 1, nspc
     telion(jspc) = rclion(jspc)
  end do
end subroutine adp_ioniz_r8

!
! --------------- adp_recom_r8 --------------
! return the recombination rate due to radiative and
! dielectronic recombination
!
! adset or adreset must have been called before this subroutine
!
subroutine adp_recom_r8(te, ane, telrec)
  use adpak_mod

  implicit none
  save

  real(fp), intent(in)    :: te     ! electron temperature in KeV
  real(fp), intent(in)    :: ane    ! electron density in m-3

  real(fp), intent(out)   :: telrec(*)   ! recombination rate (sec-1)

  real(fp)    :: pte    ! electron temperature in KeV
  real(fp)    :: pne    ! electron density in cm-3
  integer :: jspc   ! loop variable

  !
  ! calculate rates in adpak
  !  
  pte = te
  pne = 1.e-6_fp*ane    ! convert from m-3 to cm-3
  CALL ADDREC(PTE,PNE) ! fill RDIREC, RADDRC
  CALL ADRREC(PTE,PNE) ! fill RRAREC, RADRRC

  do jspc = 1, nspc
     telrec(jspc) = RRAREC(JSPC) + RDIREC(JSPC)
  end do
end subroutine adp_recom_r8

!
! --------------- adp_rad_r8 --------------
! return the radiation rate due to radiative and
! dielectronic recombination and collisional excitation
! and optionally brem...
!
! adset or adreset must have been called before this subroutine
!
subroutine adp_rad_r8(te, ane, ibrem, telrad)
  use adpak_mod

  implicit none
  save

  real(fp), intent(in)    :: te     ! electron temperature in KeV
  real(fp), intent(in)    :: ane    ! electron density in m-3
  integer, intent(in)   :: ibrem  ! 0-> do not include brem...
                                  ! 1-> include brem...

  real(fp), intent(out)   :: telrad(*)   ! radiation rate (joule/sec)

  real(fp)    :: pte    ! electron temperature in KeV
  real(fp)    :: pne    ! electron density in cm-3
  integer :: jspc   ! loop variable

  !
  ! calculate rates in adpak
  !  
  pte = te
  pne = 1.e-6_fp*ane      ! convert from m-3 to cm-3
  CALL ADDREC(PTE,PNE) ! fill RDIREC, RADDRC
  CALL ADRREC(PTE,PNE) ! fill RRAREC, RADRRC
  CALL ADECEX(PTE,PNE) ! fill RADCLX

  do jspc = 1, nspc
     telrad(jspc) = radrrc(jspc) + raddrc(jspc) + radclx(jspc)   
  end do

  if (ibrem/=0) then
     call ADBREM(PTE,PNE) ! fill RADBRM
     do jspc = 1, nspc
        telrad(jspc) = telrad(jspc) + radbrm(jspc)
     end do
  end if
end subroutine adp_rad_r8

!
! --------------- adp_brem_r8 --------------
! return the radiation rate due to brem...
!
! adset or adreset must have been called before this subroutine
!
subroutine adp_brem_r8(te, ane, telbrem)
  use adpak_mod

  implicit none
  save

  real(fp), intent(in)    :: te     ! electron temperature in KeV
  real(fp), intent(in)    :: ane    ! electron density in m-3

  real(fp), intent(out)   :: telbrem(*)   ! radiation rate (joule/sec)

  real(fp)    :: pte    ! electron temperature in KeV
  real(fp)    :: pne    ! electron density in cm-3
  integer :: jspc   ! loop variable

  !
  ! calculate rates in adpak
  !  
  pte = te
  pne = 1.e-6_fp*ane      ! convert from m-3 to cm-3
  call ADBREM(PTE,PNE) ! fill RADBRM
  do jspc = 1, nspc
     telbrem(jspc) = radbrm(jspc)
  end do
end subroutine adp_brem_r8

subroutine r8ryevala(rmsplc,ymsplc,rmspls,ymspls, &
     zsnthtk,zcsthtk,nmom,zr99,zy99)
  !
  !  evaluate moments position:  asymmetric eq. moments formula
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: nmom, imul
  real(fp) :: zr99, zy99
  real(fp), dimension(0:nmom) :: rmsplc, ymsplc, rmspls, ymspls
  real(fp), dimension(nmom) :: zcsthtk, zsnthtk
  !
  !--------------------------------
  !
  ZR99 = RMSPLC(0)
  ZY99 = YMSPLC(0)
  do IMUL=1,NMOM
    ZR99 = ZR99 + RMSPLC(IMUL)*ZCSTHTK(IMUL) &
         + RMSPLS(IMUL)*ZSNTHTK(IMUL)
    ZY99 = ZY99 + YMSPLC(IMUL)*ZCSTHTK(IMUL) &
         + YMSPLS(IMUL)*ZSNTHTK(IMUL)
  end do
  !
  return
end subroutine r8ryevala

subroutine r8jacevala(DRMDROC,DYMDROC,DRMDROS,DYMDROS, &
     RMSPLC,YMSPLC,RMSPLS,YMSPLS,ZSNTHTK,ZCSTHTK,NMOM,ZJAC)
  !
  !  evaluate 2x2 jacobian using moments and derivatives
  !    ** asymmetric formula **
  !
  !  evaluate moments position:  asymmetric eq. moments formula
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  integer nmom,imul
  real(fp) :: zc,zs
  real(fp) :: rmsplc(0:nmom),ymsplc(0:nmom),rmspls(0:nmom),ymspls(0:nmom)
  real(fp) :: drmdroc(0:nmom),dymdroc(0:nmom)
  real(fp) :: drmdros(0:nmom),dymdros(0:nmom)
  real(fp) :: zcsthtk(nmom),zsnthtk(nmom)
  real(fp) :: zjac(2,2)
  !
  ZJAC(1,1)= DRMDROC(0)
  ZJAC(1,2)= 0.0_fp
  !
  ZJAC(2,1)= DYMDROC(0)
  ZJAC(2,2)= 0.0_fp
  !
  do IMUL=1,NMOM
    ZC = ZCSTHTK(IMUL)
    ZS = ZSNTHTK(IMUL)
    !
    ZJAC(1,1) = ZJAC(1,1) + DRMDROC(IMUL)*ZC + DRMDROS(IMUL)*ZS
    ZJAC(1,2) = ZJAC(1,2) - RMSPLC(IMUL)*IMUL*ZS + RMSPLS(IMUL)*IMUL*ZC
    !
    ZJAC(2,1) = ZJAC(2,1) + DYMDROC(IMUL)*ZC + DYMDROS(IMUL)*ZS
    ZJAC(2,2) = ZJAC(2,2) - YMSPLC(IMUL)*IMUL*ZS + YMSPLS(IMUL)*IMUL*ZC
  end do
  !
  return
end subroutine r8jacevala

subroutine integ_wts(x,w)

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: half
  implicit none

  !  return x evaluation points and weights for 
  !  a definite integral over the region [0,1].
  !  Note the x evaluation points returned are not in ascending order.

  real(fp), dimension(10), intent(out) :: x
  real(fp), dimension(10), intent(out) :: w

  !----------------
  real(fp), dimension(5) :: x1
  real(fp), dimension(5) :: w10

  ! gauss-kronrod-patterson quadrature coefficients for use in
  ! quadpack routine qng.  these coefficients were calculated with
  ! 101 decimal digit arithmetic by l. w. fullerton, bell labs, nov 1981.

  data x1    (  1) / 0.973906528517171720077964012084452_fp/
  data x1    (  2) / 0.865063366688984510732096688423493_fp/
  data x1    (  3) / 0.679409568299024406234327365114874_fp/
  data x1    (  4) / 0.433395394129247190799265943165784_fp/
  data x1    (  5) / 0.148874338981631210884826001129720_fp/

  data w10   (  1) / 0.066671344308688137593568809893332_fp/
  data w10   (  2) / 0.149451349150580593145776339657697_fp/
  data w10   (  3) / 0.219086362515982043995534934228163_fp/
  data w10   (  4) / 0.269266719309996355091226921569469_fp/
  data w10   (  5) / 0.295524224714752870173892994651338_fp/
  !----------------

  integer :: ii
  real(fp) :: xinc,ww

  do ii=1,5
    xinc = x1(ii)*HALF
    x(ii) = HALF + xinc
    x(5+ii) = HALF - xinc
    ww = w10(ii)*HALF
    w(ii) = ww
    w(5+ii) = ww
  end do

  return
end subroutine integ_wts

#include "fpreproc/f77_dcomplx.h"
!==============================================================================
!
SUBROUTINE INTEG_Z(A, MAXA, B, MAXB, KER, NREACT)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : pi,two
!
!   THIS INTEGRATES SIGVBB_Z(SIG,A,B,THETA) W.R.T. THETA
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  IMPLICIT NONE
  INTEGER maxb,maxa,i,j,k
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) delth,deltab
!============
  INTEGER,PARAMETER :: MAXTH = 101	!ODD FOR SIMPSON'S RULE
!
  real(fp) A(MAXA), B(MAXB)
  real(fp) KER(MAXA, MAXB)
!
  real(fp) SIG(MAXTH)
  real(fp) COS_THETA(MAXTH)
  real(fp) E(MAXTH),T1(MAXTH),T2(MAXTH),ZEXP(MAXTH)
!
  INTEGER NREACT	!WHICH REACTION TO COMPUTE (PASS TO SIGVBB_Z)
!
!==============================================================================
!
  DELTH = PI/AREAL(MAXTH-1)
!
!   THE INTEGRAL IS SYMMETRIC, SO 2*INTEG(0 TO PI) IS OK
!
  DO I = 1, MAXTH
     COS_THETA(I) = COS(AREAL(I-1)*DELTH)	!Only compute these once
  enddo

!
  DO I = 1, MAXA	!LOOP OVER A(I)
!
!   NOW CREATE THE B VALUES FROM 0 TO A(I) EQUALLY SPACED
!
     DELTAB = A(I)/AREAL(MAXB-1)
!
!   BEWARE E(I) = 0.0 IN SIGVBB_Z! ... I THINK I FIXED THAT...B**2
!
     DO J = 1, MAXB
        B(J) = AREAL(J-1)*DELTAB
        B(J) = min( B(J), A(I) )
     enddo
!
!   NOW GET THE INTEGRAND VALUES FOR EACH A(I) AND B(J)
!
     DO J = 1, MAXB
        CALL SIGVBB_Z(SIG, A(I), B(J), COS_THETA, E, T1, T2, ZEXP,&
             MAXTH, NREACT)
!
!   NOW DO A SIMPSON'S RULE INTEGRATION
!
        KER(I,J) = SIG(1) + SIG(MAXTH)
!
        DO K = 2, MAXTH-1, 2
           KER(I,J) = KER(I,J) + 4.0_fp*SIG(K)
        enddo
!
        DO  K = 3, MAXTH-2, 2
           KER(I,J) = KER(I,J) + two*SIG(K)
        enddo
!
        KER(I,J) = DELTH*KER(I,J)/3.0_fp
!
!   NOW MULTIPLY BY 2.0 TO RE!OVER THE FULL INTEGRAL
!
        KER(I,J) = two*KER(I,J)
!
!   NOW DIVIDE BY 2*PI TO RECOVER THE GYROPHASE AVERAGE
!
        KER(I,J) = KER(I,J)/(two*PI)
!
     enddo
  enddo
!
  RETURN
END SUBROUTINE INTEG_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 30Jun2000 fgtok

C----------------------------------------------------------------------
C  UFRWND  -- REWIND OPEN UFILE AND RESET INTERNAL STATUS
C
      SUBROUTINE UFRWND(ILUN,IER)
C
      USE UFILES
C
      CALL UFINIT
C
C  KNOWN CHANNEL?
      CALL UFLCHK(ILUN,'UFRWND    ',ICHAN,IER)
C
      IF(IER.NE.0) GO TO 9000
C
C  FILE MUST BE OPEN...
C
      ISTAT=UFSTAT(ICHAN)
      IF((ISTAT.NE.5).AND.(ISTAT.NE.3)) THEN
        CALL UERSTA(ICHAN,'UFRWND    ')
        GO TO 9000
      ENDIF
C
C  OK
      UFSTAT(ICHAN)=3
      call ufrwnd_do(ilun,ichan,ufcprs(ichan),ier)
C
      IER=0
C
      RETURN
C
C----------
C  ERRORS
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ? DATA NOT REWOUND DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      IER=1
      UFSTAT(ICHAN)=5
      RETURN
      	END
C-------------------------------------------------------
      subroutine ufrwnd_do(ilun,ichan,kmprs,ier)
C
      use UFILES
C
#include "fpreproc/byte_declare.h"
      byte_declare ibhdr(12)
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
C  do a rewind
C
      if((ufcprs(ichan).lt.2).and.(ufcprs(ichan).ge.0)) then
C  ascii or old binary format
         REWIND ILUN
      else if(ufcprs(ichan).eq.2) then
C  new binary format
         call cftrewnd(ilun,ier)
C  reset buffers
         niobuf(ichan)=0
         nchbuf(ichan)=0
C  reread the first 12 bytes (don't bother checking again)
         call ubufi(ilun,uiobuf(1,ichan),niobuf(ichan),ibhdr,12)
      endif
C
      return
      end

C******************** START FILE G3MSEL.FOR ; GROUP G3MSEL ******************
C----------------------------------------------------------------
C  G3MSEL
C    CONTROL GENERATION OF MULTIPLOT CONSISTING OF MULTIPLE
C  SLICES OF FUNCTION OF 2 INDEPENDANT VARIABLES.
C    TITLE LABELING SET UP BY CALLER; ONLY THAT LABELING WHICH
C  DEPENDS ON USER CHOICE OF SLICES IS SET UP HERE.
C    CALLING SUBROUTINE - GRF3
C
C  DMC 12/87 -- ADDING A DIGIT OF PRECISION TO THE SLICE LABELS
C    NOW 11 CHARACTERS USED
C    CF FURTHER EXPANSION WILL REQUIRE CHANGE TO DPLOTK ROUTINE
C    AND RE-MAPPING OUT OF KEY BOX RASTER COORDS ...
C
      SUBROUTINE G3MSEL(Z,NZ1,X,NX,Y,NY,ZWK,
     >     XLAB,XUN,YLAB,YUN,ZLAB,ZUN,MNLAB)
C
C  Z(NZ1,NY)  DATA TO BE PLOTTED
C  X(NX)      FIRST DIMENSION INDEPENDANT VAR. OF Z
C  Y(NY)      SECOND DIMENSION INDEPENDANT. VAR. OF Z
C  ZWK(NY)    WORKSPACE FOR MULTIPLOT SUBROUTINE
C
C  XLAB       CHAR LABEL FOR X
C  XUN        CHAR UNITS FOR X
C  YLAB       CHAR LABEL FOR Y
C  YUN        CHAR UNITS FOR Y
C  ZLAB       CHAR LABEL FOR Z
C  ZUN        CHAR UNITS FOR Z
C
C  MNLAB      3 CA. 60 CHAR "MAIN" LABELS FOR MULTIPLOT
C
C  3RD MAIN LABEL, KEY LABELS 1 AND 2, AND
C  ALL SLICE LABELS SET UP HERE.
C
C  SEE SUBROUTINES GRFMF1 AND MULFDR
C
      DIMENSION Z(NZ1,NY),X(NX),Y(NY),ZWK(NY)
C
      CHARACTER*(*) XLAB,XUN,YLAB,YUN,ZLAB,ZUN
      CHARACTER*(*) MNLAB(3)
C
      CHARACTER*12 FNLAB(15)
C
      CHARACTER*20 KYLAB(5)
C
      INTEGER ISELF(15)
C
      REAL ZSELF(15)
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C  EXECUTABLE CODE
C
      LUNTRM=LNOUT(0)
C
 10   CONTINUE
C
      CALL NEUPAG
C
      IF(LXOUT(0)) WRITE(LUNTRM,1001) XLAB,YLAB
 1001 FORMAT(/'  DIMENSION #1: ',A,'  DIMENSION #2: ',A/)
C
 11   CONTINUE
      CALL UREAD(
     >  'G3MSEL:  CHOOSE DIMENSION FOR X AXIS (1 OR 2):$')
      IF(LCHAR('Q')) GO TO 500
C
      ISELX=IDCOD(IERT)
      IF((ISELX.LE.0).OR.(ISELX.GT.2)) THEN
        CALL UERMSI(' % CHOOSE DIMENSION 1 OR 2 ONLY',ISELX,0)
        GO TO 11
      ENDIF
C
      IF(ISELX.EQ.1) THEN
        MNLAB(3)=ZLAB//' VS '//XLAB
        KYLAB(1)=YLAB
        KYLAB(2)=YUN
C
        ZX1=X(1)
        ZX2=X(NX)
        INX=NX
C
        ZY1=Y(1)
        ZY2=Y(NY)
        INY=NY
C
      ELSE
        MNLAB(3)=ZLAB//' VS '//YLAB
        KYLAB(1)=XLAB
        KYLAB(2)=XUN
C
        ZX1=Y(1)
        ZX2=Y(NY)
        INX=NY
C
        ZY1=X(1)
        ZY2=X(NX)
        INY=NX
C
      ENDIF
C
      KYLAB(3)=' '
      KYLAB(4)=' '
      KYLAB(5)=' '
C
 50   CONTINUE
      CALL NEUPAG
 51   IF(LXOUT(0)) WRITE(LUNTRM,1002) INY,KYLAB(1),ZY1,ZY2,KYLAB(2)
 1002 FORMAT(/1X,I6,' SLICES OF ',A,' AVAILABLE FROM'/
     >  1X,1PE12.5,' TO ',1PE12.5,1X,A,' NO INTERPOLATIONS.'//
     >  ' OPTIONS--'/
     >  '  A:  SPECIFY ALL SLICES'/
     >  '  B:  SPECIFY STARTING SLICE, SPACING INTERVAL AND NUMBER'/
     >  '  C:  SPECIFY STARTING SLICE INDEX, NUMBER AND INCREMENT'/
     >  '  X:  SWITCH X AXIS'/
     >  '  Q:  QUIT'/)
C
      CALL UREAD('G3MSEL:  ENTER SLICE OPCODE (A/B/C/X/Q):$')
      IANS=IXUOPC('ABCXQ$')
      CALL UCHKOP(IANS,0,1,100,-1,*51)
      GO TO (100,200,300,10,500) IANS
C
C  ALL SLICES SPECIFIED
C
 100  CONTINUE
C
      NSEL=0
 101  CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1003) KYLAB(1),KYLAB(2)
 1003 FORMAT(' SPECIFY ',A,' VALUES IN ',A)
      IF(LXOUT(0)) WRITE(LUNTRM,1004)
 1004 FORMAT(
     >  ' ENTER LIST OF VALUES, TERMINATE WITH AN "X"'/
     >  ' NEAREST AVAILABLE SLICE WILL BE TAKEN'/)
C
 105  CALL UREAD('$')
      IF(LCHAR('X')) GO TO 190
      if(lchar('Q')) goto 50
      ZVAL=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 101
C
      CALL G3INX1(ZVAL,ISELX,X,NX,Y,NY,ISELF,ZSELF,15,NSEL)
      GO TO 105
C
 190  CONTINUE
      IF(NSEL.EQ.0) GO TO 50
      GO TO 1000
C-----
 200  CONTINUE
C
      IF(LXOUT(0)) WRITE(LUNTRM,1003) KYLAB(1),KYLAB(2)
      CALL UREAD('G3MSEL:  ENTER START VALUE:$')
      if(lchar('Q')) goto 50
      ZV1=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 200
C
 210  CONTINUE
      CALL UREAD('G3MSEL:  ENTER INTERVAL:$')
      IF(LCHAR('Q')) GO TO 50
      ZVI=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 210
C
 220  CONTINUE
      CALL UREAD('G3MSEL:  ENTER NUMBER OF SLICES (INTEGER):$')
      IF(LCHAR('Q')) GO TO 50
      INSEL=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 220
      INSEL=MAX0(1,MIN0(15,INSEL))
C
      ZV=ZV1-ZVI
      NSEL=0
      DO 230 I=1,INSEL
        ZV=ZV+ZVI
        CALL G3INX1(ZV,ISELX,X,NX,Y,NY,ISELF,ZSELF,15,NSEL)
 230  CONTINUE
      GO TO 1000
C-----
 300  CONTINUE
C
      CALL UREAD('G3MSEL:  ENTER START INDEX:$')
      IF(LCHAR('Q')) GO TO 50
      ISTART=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 50
C
 310  CONTINUE
      CALL UREAD('G3MSEL:  ENTER NUMBER OF SLICES TO PLOT (MAX 15):$')
      IF(LCHAR('Q')) GO TO 50
      INSEL=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 310
      INSEL=MAX0(1,MIN0(15,INSEL))
C
 320  CONTINUE
      CALL UREAD(
     >  'G3MSEL:  ENTER INTERVAL (E.G. 2 FOR ALTERNATE SLICES):$')
      IF(LCHAR('Q')) GO TO 50
      INTVL=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 320
      INTVL=MAX0(1,INTVL)
C
      IND=ISTART-INTVL
      NSEL=0
      DO 350 I=1,INSEL
        IND=IND+INTVL
        IF(ISELX.EQ.1) ZV=Y(MAX0(1,MIN0(NY,IND)))
        IF(ISELX.EQ.2) ZV=X(MAX0(1,MIN0(NX,IND)))
        CALL G3INX1(ZV,ISELX,X,NX,Y,NY,ISELF,ZSELF,15,NSEL)
 350  CONTINUE
      GO TO 1000
C
 500  CONTINUE
      RETURN
C
 1000 CONTINUE
      DO 1010 I=1,NSEL
        IF(ZSELF(I).LE.0.0) WRITE(FNLAB(I),2001) ZSELF(I)
        IF(ZSELF(I).GT.0.0) WRITE(FNLAB(I),2002) ZSELF(I)
 1010 CONTINUE
C
 2001 FORMAT(1PE11.4)
 2002 FORMAT(1PE11.5)
C
      IF(ISELX.EQ.1) THEN
        CALL GRFMF1(Z,NZ1,X,NX,Y,NY,ZWK,ISELX,ISELF,NSEL,
     >	     ZUN,XUN,MNLAB,KYLAB,FNLAB)
      ELSE
        CALL GRFMF1(Z,NZ1,X,NX,Y,NY,ZWK,ISELX,ISELF,NSEL,
     >	     ZUN,YUN,MNLAB,KYLAB,FNLAB)
      ENDIF
C
      GO TO 50
      END
C******************** END FILE G3MSEL.FOR ; GROUP G3MSEL ******************

	subroutine ufspec(fspec,fpref,fextn,fdisk,farea,fshot,jshot)
	character fspec*48,fpref*24,fextn*4,fdisk*24,farea*24,fshot*5
	logical first /.true./
	if(first) then
	  open(1,status='scratch',iostat=ios)
	  call ufemsg(0)
	  call ufimsg(-1)
	  first = .false.
	endif
	fpref=' '
	fextn=' '
	ixd=index(fspec,':')
	fdisk=fspec(1:ixd)
	ixd=ixd+1
	farea=' '
	if(fspec(ixd:ixd).eq.'[') then
	  ixa=index(fspec,']')
	  farea=fspec(ixd+1:ixa-1)
	  ixd=ixa+1
	endif
	ixp=index(fspec(ixd:),'.')+ixd-1
	fshot=fspec(ixp-5:ixp-1)
	fpref=fspec(ixd:ixp-6)
	fextn=fspec(ixp+1:)
	read(fshot,'(i10)',iostat=ios) jshot
	end

!-----------------------------------------------------------------------
!  PSGHCX -- CROSS SECTION OF C+6 + H --> C+5 + H+
!
real(fp) FUNCTION psghcx8(ZE)
!
! INPUT
!  ZE -- COLLISION ENERGY **PER NUCLEON**  EV/AMU
!
! OUTPUT
!  PSGHCX -- CROSS SECTION, CM**2
!
! REFERENCE
!  ORNL-6090/V5, ATOMIC DATA FOR FUSION, VOLUME V,
!    "COLLISIONS OF CARBON AND OXYGEN IONS WITH ELECTRONS, H, H2, & He"
!    R.A. PHANEUF, R.K. JANEV, M.S. PINDZOLA
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) ze,emin,emax,zans,psgchvx8
!============
  real(fp) CCHEV(9)
!
  DATA EMIN/1.0_fp/
  DATA EMAX/7.0e+5_fp/
!
  DATA CCHEV/&
       -7.50165e+01_fp, 4.93597e-1_fp,-4.53799_fp,&
       -1.79837_fp,-3.65368e-1_fp,-6.53312e-1_fp,&
       8.47562e-2_fp, 7.46099e-2_fp, 9.63594e-2_fp/
  !
  ZANS=psgchvx8(1,ZE,EMIN,EMAX,CCHEV)
  psghcx8=ZANS
!
  RETURN
END FUNCTION psghcx8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

subroutine r8_plcentr(R,Z,N,RCENTR,ZCENTR)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half
  implicit none

  ! 
  !     USE GREEN'S THEOREM TO CALCULATE CENTROIDS
  !     DICK WIELAND
  !
  !     RGA: Jun2010, switch to centroid of inscribed polygon
  !
  real(fp), dimension(*) :: R, Z
  real(fp) :: RCENTR, ZCENTR
  integer :: N

  real(fp) :: AREA,LINT,MR,MZ
  integer :: I

  !     CALCULATE AREA ENCLOSED
  AREA = zero
  MR   = zero
  MZ   = zero
  do I = 1,N-1
    LINT = R(I)*Z(I+1)-R(I+1)*Z(I)
    AREA = AREA + LINT
    MR   = MR + (R(I)+R(I+1))*LINT
    MZ   = MZ + (Z(I)+Z(I+1))*LINT
  end do
  AREA = half*AREA

  if (abs(AREA)>1.e-10_fp) then
    MR = MR/(6.0_fp*AREA)
    MZ = MZ/(6.0_fp*AREA)
  else
    MR=zero
    MZ=zero
    do i = 1, N
      MR = MR+R(I)
      MZ = MZ+Z(I)
    end do
    MR = MR/max(1,N)
    MZ = MZ/max(1,N)
  end if

  RCENTR = MR
  ZCENTR = MZ

  return
end subroutine r8_plcentr

C******************** START FILE UFHELP.FOR ; GROUP UFHELP *************
C---------------------------------------------------------
C& UFHELP  PROVIDE HELP TO UREAD USERS
C  UFHELP.FOR
C
C  ACCESS SPECIFIED ASCII FILE AND DISPLAY ON SCREEN USING
C  AGX CALLS SO THAT THE DISPLAY MAY BE PRINTED IN PLOT MODE
C  ON THE VERSATEC.
C
C  DMC JUN 88, AGX CALLS REPLACED WITH GRFLBL CALLS
C
C    FRAME IS DRAWN ABOUT EACH PAGE, AND HEADER LINE IS PRINTED
C  ON EACH PAGE, INCLUDING FILENAME AND PAGE NUMBER
C
C  THE INPUT FILE SHOULD BE ASCII SEQUENTIAL WITH NO LINES LONGER
C  THAN 72 CHARACTERS TO FIT ON PAGE
C
C  A LINE WHICH STARTS OUT WITH THE STRING
C  "<*=*>" IS A DELIMITER; CURRENT PAGE IS TERMINATED AND NEW PAGE
C  IS GENERATED; THE DELIMITER IS NOT PRINTED.
C
C  PASSED ARGUMENTS:  25 CHARACTER FILENAME
C     LUN TO USE FOR FILE INPUT
C
      SUBROUTINE UFHELP(LUN,ZFILE)
C
      CHARACTER*(*) ZFILE
C
      CHARACTER*80 ZLINE
      CHARACTER*80 ZBUF
C
C
C START OF EXECUTABLE CODE
C
      luntrm=lnout(0)
C

      OPEN(UNIT=LUN,FILE=ZFILE,ACCESS='SEQUENTIAL',STATUS='OLD',
     >       ERR=50)

      GO TO 90
C
C  ERROR EXIT
C
 50   CONTINUE
      WRITE(LUNTRM,5001) ZFILE
 5001 FORMAT(/' ? ERROR OPENING HELP FILE "',A,'"'/)
      CALL UPAUST(1)
      RETURN
C
 60   CONTINUE
      WRITE(LUNTRM,5002) ZFILE
 5002 FORMAT(/' ? HELP FILE "',A,'" IS EMPTY'/)
      GO TO 200
C
C  PRINT FILE
C
 90   CONTINUE
      CALL UINITA(0)
      IPAGE=0
 100  CONTINUE
        IF(IPAGE.GT.0) CALL UPAUST(2)
 105    CONTINUE
        ILINE=0
C  NEW PAGE
        IF((IPAGE.EQ.0).OR.(IDELIM.EQ.1))
     >		CALL UGLINE(ZLINE,LUN,IEND,IDELIM)
        IF(IDELIM.EQ.1) GO TO 105
        IF((IEND.EQ.1).AND.(IPAGE.EQ.0)) GO TO 60
        IF(.NOT.((IEND.EQ.1).AND.(IPAGE.GT.0))) GO TO 107
C---
        CLOSE(UNIT=LUN)
        RETURN
C---
 107    CONTINUE
        CALL UBINIT
        CALL DPLOFR(20,1020,10,770,0)
        IX=32
        ZY=740.0
        ZDY=-25.0
        IPAGE=IPAGE+1
        ZBUF=' '
        ilnb=index(zfile,' ')-1
        if(ilnb.le.0) ilnb=len(zfile)
        do istop=ilnb,1,-1
          if(zfile(istop:istop).eq.'/') go to 108
          if(zfile(istop:istop).eq.']') go to 108
          if(zfile(istop:istop).eq.'>') go to 108
          if(zfile(istop:istop).eq.':') go to 108
        enddo
        istop=0
 108    continue
        istop=istop+1
        WRITE(ZBUF,1001) ZFILE(istop:ilnb),IPAGE
 1001   FORMAT('  >>>HELP FILE "',A,T50,'" PAGE ',I2,1X)
        IY=ZY
        CALL GRFLBL(IX,IY,ZBUF,72,-1,0)
        ZY=ZY+2*ZDY
        IMAX=28
C  NEW LINE
 110    CONTINUE
          IF(ILINE.GT.0) CALL UGLINE(ZLINE,LUN,IEND,IDELIM)
          IF(IEND.EQ.1) GO TO 200
          IF(IDELIM.EQ.1) GO TO 100
          ILINE=ILINE+1
          IF(ILINE.GT.IMAX) GO TO 100
          ZBUF=ZLINE
          IY=ZY
          CALL GRFLBL(IX,IY,ZBUF,72,-1,0)
          ZY=ZY+ZDY
        GO TO 110
C
C  END-OF-FILE
C
 200  CONTINUE
      CALL UPAUST(2)
      CLOSE(UNIT=LUN)
      RETURN
      	END
C******************** END FILE UFHELP.FOR ; GROUP UFHELP ***************

C Menu to enter Server, Tree, etc.
C Used by mds_get_inf
C
C 02/13/03  C. Ludescher
C
      subroutine mds_menu(luntrm, mds_server,mds_tree,node,
     >           runid,device,year,mds_shot,nshot,devyr)
      implicit none
      integer       luntrm
      character*24  mds_tree
      character*64  mds_server
      character*10  runid, pulse
      character*20  node
      character*4   device
      character*7   devyr
      integer       mds_shot
      integer       nshot
      integer       year
 
C Local
      integer       mds_socket
      integer       ios, ier
      integer       ilt,  ils, ilr, iln, ls
C for uread
      LOGICAL LCHAR,  lxout
      integer ilnurd
 
C-----------------------------------------------------------
      call uinita(0)
 
      mds_tree='TRANSP_NSTX'
      mds_server='TRANSPGRID.PPPL.GOV'
C
      runid=' '
 
      mds_shot=0
      device='NSTX'
      year=0
      ils=index(mds_server,' ')-1
      if(ils.le.0) ils=len(mds_server)
      iln=index(node,' ')-1
 
C-----------------------------------------------------------------
C#@! prompt for server, tree, ... using uread
C#@! --------------------
C
 10   continue
      if (lxout(0)) then
         if (node .eq. 'NA' .or. node .eq. 'NONE') then
            write(luntrm,3002) mds_server(1:ils),mds_tree,mds_shot,
     >           runid, device, year
         else
            write(luntrm,3001) mds_server(1:ils),mds_tree,mds_shot,
     >           node, runid, device, year
         endif
 3001 format(/
     >        ' mds Server name:   ',a/
     >        ' mds Tree name:     ',a/
     >        ' mds pulse Number:  ',i10/
     >        ' Node:              ',a/
     >        ' Runid:             ',a/
     >        ' Experiment:        ',a/
     >        ' Year:              ',i2/
     >        ' options:'/
     >        '  S - set Server name'/
     >        '  T - set Tree name'/
     >        '  L - Nodename Label   (e.g. NAME_LIST, UFNAMES)'/
     >        '  N - set mds pulse Number (leave as 0 to assign)'/
     >        '  R - Runid'/
     >        '  E - Experiment'/
     >        '  Y - shot-Year'/
     >        '  Q - accept current settings'/
     >        '  X - quit/exit program'/)
 3002 format(/
     >        ' mds Server name:   ',a/
     >        ' mds Tree name:     ',a/
     >        ' mds pulse Number:  ',i10/
     >        ' Runid:             ',a/
     >        ' Experiment:        ',a/
     >        ' Year:              ',i2/
     >        ' options:'/
     >        '  S - set Server name'/
     >        '  T - set Tree name'/
     >        '  N - set mds pulse Number (leave as 0 to assign)'/
     >        '  R - Runid'/
     >        '  E - Experiment'/
     >        '  Y - shot-Year'/
     >        '  Q - accept current settings'/
     >        '  X - quit/exit program'/)
      endif
C
      call uread('mds_start:  run specs:$$')
      if(lchar('S')) then
         call ureadw('mdsrun:  server name:$$',mds_server)
         ils=index(mds_server,' ')-1
         if(ils.le.0) ils=len(mds_server)
      else if(lchar('T')) then
         call ureadw('mdsrun:  tree name:$$',mds_tree)
      else if(lchar('N')) then
         call ureadi('mdsrun:  pulse number:$$',mds_shot)
      else if(lchar('E')) then
         call ureadw('mdsrun:  Experiment:$$',device)
      else if(lchar('R')) then
         call ureadw('mdsrun:  RunId:$$',runid)
      else if(lchar('L')) then
         call ureadw('node:  Node Label:$$',node)
      else if(lchar('Y')) then
         call ureadi('mdsrun:  year:$$',year)
      else if(lchar('Q')) then
         go to 100
      else if(lchar('X')) then
         go to 9000
      else if(lchar('O')) then
         call ureadw('Option:  e.g.:CONTENTS:$$',node)
      else
         call uermsg('%mds_start:  invalid control option',' ',0)
      endif
      go to 10
 
C-----------------------------------------------------
 100  continue
      ilt=index(mds_tree,' ')-1
      if(ilt.le.0) ilt=len(mds_tree)
      call uupper(mds_tree)
C     extract shot from runid
      call checkid(runid,ilr,ls)
      read(runid(1:ls),'(i6)',iostat=ios) nshot
C      print*,'nshot = ',nshot
C
C Generate MDSplus pulse number
C -----------------------------
      if (mds_shot .eq. 0) then
         if (mds_tree(1:7) .eq. 'TRANSP_' .or.
     >        mds_tree(1:7) .eq. 'TRLOOK_' .or.
     >        mds_tree(1:ilt) .eq. 'JET') then
            call mkbeastid(runid,mds_shot,pulse)
            print*,'mds_shot = ',mds_shot
         endif
      endif
 
      ls=4
      if (device(4:4) .eq. ' ') ls=3
 
C TRANSP
      if (mds_shot .eq. 0) then
         write(devyr,'(a,".",i2.2)') device(1:ls),year
      endif
      return
 9000 call bad_exit
      return
      end
 
 
 
 

subroutine r8_mulgraf(file_label,nx,nf,x,f,units_x,units_f,f_label,nf_label)

  ! gen multiplot using GRFMM1
    
  implicit NONE

  character*(*), intent(in) :: file_label  ! data source label
  integer, intent(in) :: nx   ! no. of points in x axis and in each profile
  integer, intent(in) :: nf   ! no. of profiles
  real*8, intent(in) :: x(nx) ! x axis grid data
  real*8, intent(in) :: f(nx,nf)  ! the profile data
  character*(*), intent(in) :: units_x     ! physical units label for x axis
  character*(*), intent(in) :: units_f     ! physical units label for f data
  character*(*), intent(in) :: f_label     ! generalic label for f data & plot
  character*(*), intent(in) :: nf_label(nf) ! specific label for each profile

  !--------------------
  ! local (automatic)

  integer :: nxx(nf)
  real*8 :: xx(nx,nf)
  real*8 :: zz(nf)
  integer :: iself(nf)

  character*60 mnlab(3)
  character*17 kylab(5)

  integer :: ix,if
  !--------------------

  nxx=nx
  do if=1,nf
     nxx(if)=nx
     xx(1:nx,if)=x
     zz(if)=if
     iself(if)=if
  enddo
  iself(1)=-iself(1)  ! no "square scale"

  mnlab=' '
  kylab=' '

  kylab(1)=' profile labels '

  mnlab(1)=file_label
  mnlab(3)=f_label

  call r8_grfmm1(xx,f,nx,nxx,nf,zz,nf,iself,nf, &
       units_x,units_f,mnlab,kylab,nf_label)

end subroutine r8_mulgraf

C******************** START FILE PUT1F2.FOR ; GROUP UTL2D ******************
C------------------------------------------------------------------
C
      SUBROUTINE PUT1F2(IDIM,IFIX,F,NF1,NF2,N1USE,WK,NWK)
C
      REAL F(NF1,NF2),WK(NWK)
C
C  REPLACE A ROW OR COLUMN OF F (2D) WITH CONTENTS OF WORK ARRAY (1D)
C
      N2USE=NF2
C  ERROR CHECKING
      IF(IDIM.EQ.1) THEN
        CALL WKCHK(NWK,N1USE,'PUT1F2',IER)
        IF(IER.NE.0) RETURN
      ELSE IF(IDIM.EQ.2) THEN
        CALL WKCHK(NWK,N2USE,'PUT1F2',IER)
        IF(IER.NE.0) RETURN
      ENDIF
C
C  LOAD WORK VECTOR
      IF(IDIM.EQ.1) THEN
        DO IX=1,N1USE
          F(IX,IFIX)=WK(IX)
        ENDDO
      ELSE IF(IDIM.EQ.2) THEN
        DO IY=1,N2USE
          F(IFIX,IY)=WK(IY)
        ENDDO
      ENDIF
C
      RETURN
      END
C******************** END FILE PUT1F2.FOR ; GROUP UTL2D ******************

C-------------------------------------------------------------
C  GSCYDF - BASED ON DATA X,Y MIN MAX INFORMATION STORED IN COMMON,
C   AND OPTION SWITCH SETTINGS, ALSO IN COMMON,
C  DECIDE ON THE SCALE FOR THE *Y*  AXIS, UPCOMING PLOT
C  THIS MAY INCLUDE ASKING THE USER FOR INFORMATION
C
      SUBROUTINE GSCYDF(IOPT)
C
C  AXIS TYPES COMMON--
C
      INCLUDE 'GAXES_BLK'
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
C  PLOT1 COMMON
C
      INCLUDE 'PLOT1MMX'
C
C  START OF EXECUTABLE CODE
C
C  DMC - PASSED ARG OVERRIDE OPTION ADDED MAR 1986
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR,lxout
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      luntrm=lnout(0)

      IF(IOPT.EQ.0) THEN
        JOPTY=NOPTY
      ELSE
        JOPTY=IOPT
      ENDIF
C
 10   CONTINUE
C  DO Y AXIS
      GO TO (20,30,40,50,60) JOPTY
 20   CONTINUE
      YMIN=GMINY
      YMAX=GMAXY
      IF((IXYMAP(IAXCUR).EQ.1).AND.(GMINYP.GT.0.0)) THEN
        YMIN=GMINYP
        YMAX=AMAX1(YMAX,1.1*YMIN)
      ENDIF
C
      GO TO 90
C
 30   CONTINUE
      IF(lxout(0)) WRITE(LUNTRM,3001) GMINY,GMAXY
 3001 FORMAT(//'  DATA:'/
     >  '  MINIMUM Y:  ',1PE10.3,' MAXIMUM Y:  ',1PE10.3/
     >  '  ENTER "X" TO USE THE ABOVE LIMITS IN THE PLOT SCALE')
      CALL UREAD(' GSCSET >> ENTER YMIN FOR GRAPH:$')
      IF(.NOT.LCHAR('X')) YMIN=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 30
C
 35   CONTINUE
      CALL UREAD(' GSCSET >> ENTER YMAX FOR GRAPH:$')
      IF(.NOT.LCHAR('X')) YMAX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 35
      GO TO 90
C
 40   CONTINUE
      YMIN=YMIN00
      YMAX=YMAX00
      GO TO 90
C
 50   CONTINUE
      YMAX=GMAXY
      YMIN=YMAX*YRAT00
C
      GO TO 90
C
 60   CONTINUE
      YMIN=GMINY
      YMAX=YMIN*YRAT00
      GO TO 90
C
 90   CONTINUE
      IF(YMAX.LT.YMIN) THEN
        ZTMP=YMAX
        YMAX=YMIN
        YMIN=ZTMP
      ELSE IF(YMAX.EQ.YMIN) THEN
C  YMAX=YMIN
        ZDELY=ABS(.01*YMIN)
        ZYA=YMIN
        IF(ZDELY.EQ.0.0) ZDELY=0.1
        YMIN=ZYA-ZDELY
        YMAX=ZYA+ZDELY
      ENDIF
C
      RETURN
      END

C******************** START FILE UFOPCF.FOR ; GROUP UFILES *************
C------------------------------------------------------------
C  UFOPCF
C  OPEN TEMPORARY FILE FOR WRITE OF COMMENT RECORDS
C  *MOD DMC JAN 1987 - USE CONDITION HANDLER FOR ERROR CHECKING
C  *MOD DMC Sep 1993 -- Don't use condition handler -- portability
C  *Mod TBT Apr 1996 -- Took out filename in OPen with
C                       scratch to make ansi
C
C   ARGUMENTS-- ILUN=FILE LOGICAL UNIT NUMBER
C     IER-- (OUTPUT) ERROR RETURN CODE
C      0=NORMAL


      SUBROUTINE UFOPCF(ILUN,IER)

      USE UFILES
C
      CHARACTER*12 ZFILE
      CHARACTER*8 ZZBUF
C
      DATA ZFILE/'UFCMTF  .TMP'/
C
C------------------------------------------------------------
C
      IF((ILUN.LT.1).OR.(ILUN.GT.99)) THEN
        WRITE(UFELUN,9901) ILUN
 9901 FORMAT(' ? UFOPCF-- ILLEGAL UNIT NUMBER ',I5,', 1 TO 99 OK')
        CALL UFPAUS(1)
        IER=1
        RETURN
      ENDIF
C
      CALL UFINIT
C  FORM FILENAME
      WRITE(ZZBUF,8001) ILUN
 8001 FORMAT(I2,6X)
      ZFILE(7:8)=ZZBUF(1:2)
      IF(ZFILE(7:7).EQ.' ') ZFILE(7:7)='0'
C
      ICHAN=IUXCHA(ILUN)
      IF(ICHAN.EQ.0) THEN
        CALL UFXCHL(ILUN,ICHAN,IER)
        IF(IER.NE.0) THEN
C  ERROR-- ASSIGNMENT TABLE OVERFLOW
          WRITE(UFELUN,9001) ILUN,UFCHAN
 9001   FORMAT(' ? UFOPCF-- TABLE OVERFLOW ON L.U.N. ',I5/
     >         '   UFILES L.U.N. ASSIGNMENT FAILED'/
     >         '   MAXIMUM NUMBER OF L.U.N. ASSIGNMENTS: ',I3/)
          CALL UFPAUS(1)
          IER=1
          RETURN
        ENDIF
      ELSE
        IF(UFSTAT(ICHAN).NE.4) THEN
          WRITE(UFELUN,9903)
 9903 FORMAT(' ? UFOPCF-- USE UNASSIGNED L.U.N.')
          CALL UERSTA(ICHAN,'UFOPCF    ')
          IER=1
          RETURN
        ENDIF
        CLOSE(UNIT=ILUN,STATUS='DELETE')
      ENDIF
C
      LUFSET(ICHAN)=.TRUE.
      UFLUN(ICHAN)=ILUN
      UFCPRS(ICHAN)=0
      UFSTAT(ICHAN)=4
C
      IOS=0
      ILUJ=ILNURD(UJUNKA)
      OPEN(UNIT=ILUN, STATUS='SCRATCH',iostat=ios)
      if (ios .ne. 0) then
         print*,'?ufopcf: open ios=',ios
         if (ios .eq. 1) print*,'?ufopcf: Check TMPDIR!'
      endif
 
C
      IER=IOS
C
      RETURN
      END
C******************** END FILE UFOPCF.FOR ; GROUP UFILES ***************

C-----------------------------------------------------------------------
C  GFTCLS -- SET SG LINE STYLE CODES
C
      SUBROUTINE GFTCLS
C
      INCLUDE 'GFTIC'
C
      LOGICAL, EXTERNAL :: LCHAR,LXOUT,LYES,LYESC
C
C------------------------------
C
      if(.not.init_gftic) call gftic0
C
      LUNTRM=LNOUT(0)
C
      IMAXI=IGFTMAXL  ! MAXIMUM LINE STYLE CODE INDEX
C
      CALL NEUPAG
 10   CONTINUE
      IF(LXOUT(0)) THEN
        WRITE(LUNTRM,1000)
 1000   FORMAT(/' LINE STYLE CODES CURRENTLY IN EFFECT:')
        WRITE(LUNTRM,1001) (I,LNSTYL(I),I=1,IMAXI)
 1001   FORMAT(5(1X,I2,':  ',I6))
        WRITE(LUNTRM,1002) IMAXI
 1002   FORMAT(
     >    ' THE MEANING OF LINE STYLE CODES ARE DESCRIBED IN THE'/
     >    ' SGLIB HELP FILE.  LEGAL CODE VALUES RANGE FROM 0 ON UP'//
     >    ' OPTIONS:'/
     >    '  >ENTER A NUMBER BTW 1 AND ',I2,' TO MODIFY CORRESPONDING'/
     >    '      LINE STYLE CODE'/
     >    '  >ENTER "Q" TO QUIT (NO MORE CHANGES)'/)
      ENDIF
      CALL UREAD(
     >    'GFTCLS:  ENTER LINE STYLE CODE MODIFICATION OPTION:$')
      IF(LCHAR('Q')) RETURN
C
      INDX=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 10
C
      IF((INDX.LT.1).OR.(INDX.GT.IMAXI)) THEN
        CALL UERMSI(' LINE STYLE CODE INDEX OUT OF RANGE',INDX,1)
        GO TO 10
      ENDIF
C
      ICOD=LNSTYL(INDX)
      CALL UREADI(' ENTER NEW LINE STYLE CODE:$',ICOD)
C
      IF(ICOD.LT.0) THEN
        CALL UERMSI(' LINE STYLE CODE VALUE OUT OF RANGE',ICOD,1)
        GO TO 10
      ENDIF
C
      LNSTYL(INDX)=ICOD
C
      GO TO 10
      END

C******************** START FILE UF0WRT.FOR ; GROUP UFILS0 ******************
C-------------------------------------------------------------------
C  UF0WRT
C  WRITE THE SCALAR LABELS AND QUANTITIES
C  PARSE THE LABEL INTO 3 10 CHARACTER SECTORS:
C  FIRST 10 CHARACTERS: KEYWORD INCL. COLON (":")
C  SECOND 10 CHARACTERS: SCALAR LABEL
C  FINAL 10 CHARACTERS: SCALAR PHYSICAL UNITS
C
      SUBROUTINE UF0WRT(ILUN,SCVAL_I,SCLAB,NSC,IER)
C
C  ILUN-- L.U.N. ON WHICH TO WRITE-- HAS BEEN CHECKED OUT OK.
C*  SCVAL-- LIST OF SCALAR VALUES
C*  SCLAB-- LIST OF CORRESPONDING LABELS
C*  NSC-- NUMBER OF ELEMENTS IN SCVAL, LABELS IN SCLAB
C  IER-- RETURN CODE 0= SUCCESS, 1= LABEL ERROR
C
      USE UFILES
C
      REAL SCVAL_I(*)
      CHARACTER*30 SCLAB(*)
c
c--------------------------------------------------------
      real, dimension(:), allocatable :: scval
      real, parameter :: ZMIN = 2.0e-38
c
c  mod dmc -- guard against underflows...
c
      allocate(scval(max(1,nsc))); scval=0
      do i=1,nsc
         if(abs(scval_i(i)).ge.zmin) scval(i)=scval_i(i)
      enddo
c--------------------------------------------------------
C
C  SUPPORT COMPRESSED BINARY UFILES FORMAT ***
C
      ICHAN=IUXCHA(ILUN)
      KMPRS=UFCPRS(ICHAN)
      if(kmprs.eq.-1) then
         write(ufelun,'('' ?UF0WRT:  MDS+ write not supported.'')')
         goto 9999
      endif
C
C  WRITE THE NUMBER OF SCALAR QUANTITIES
      IF(KMPRS.EQ.0) THEN
        WRITE(ILUN,1000) NSC
 1000 FORMAT(1X,I3,T32,';-NUMBER OF ASSOCIATED SCALAR QUANTITIES-')
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) NSC
      else if(kmprs.eq.2) then
         call ubw3int(ilun,nsc)
      else if(kmprs.eq.4) then     ! netCDF
         call ucdf0w(ilun, 1, nsc, scval, sclab, ier)
      ENDIF
C
      IF(NSC.EQ.0) GOTO 9999
C
C  WRITE LOOP
      IER=1
      DO 100 ISC=1,NSC
C  CHECK THAT THERE IS A COLON TERMINATING THE KEYWORD
        IENDKY=INDEX(SCLAB(ISC)(1:10),':')
        IF(IENDKY.LE.1) THEN
          WRITE(UFELUN,9001) SCLAB(ISC)(1:10)
 9001     FORMAT(' ? UF0WRT - SCALAR KEYWORD ',A10,
     >         ' LACKS ":" OR IS BLANK')
          GOTO 9999
        ENDIF
C  CHECK AGAINST DUPLICATION OF KEYWORDS
        DO 50 I=1,ISC-1
          IF(SCLAB(I)(1:10).EQ.SCLAB(ISC)(1:10)) THEN
      	WRITE(UFELUN,9101) SCLAB(ISC)(1:10)
 9101 	FORMAT(' ? UF0WRT - DUPLICATE SCALAR KEYWORD:  "',A10,'"')
      	GOTO 9999
          ENDIF
 50     CONTINUE
C  WRITE THE SCALAR AND LABELS
        IF(KMPRS.EQ.1) THEN
          WRITE(ILUN) SCVAL(ISC),SCLAB(ISC)
        ELSE IF(KMPRS.EQ.0) THEN
          WRITE(ILUN,3019) SCVAL(ISC),SCLAB(ISC)
 3019     FORMAT(1X,1PE11.4,T32,';-SCALAR, LABEL FOLLOWS:'/1X,A30)
        else if(kmprs.eq.2) then
          call ubwfcmp(ilun,scval(isc),1,zavrat)
          call ubwchar(ilun,sclab(isc))
        ENDIF
C  END OF LOOP
 100  CONTINUE
      IER=0
C
C HDF ?
C      if (kmprs.eq.3) then
C         call uhdf0w(ilun, nsc, scval, sclab, ier)
C netCDF ?
      if (kmprs.eq.4) then
         call ucdf0w(ilun, 2, nsc, scval, sclab, ier)
      end if
 
 9999 continue
      deallocate(scval)

      RETURN
      	END
C******************** END FILE UF0WRT.FOR ; GROUP UFILS0 ******************
 

C Find_image_symbol - routine to call LIB$FIND_IMAGE_SYMBOL with the
C  sig_to_ret condtion handler.  This is done because lib$find_image_symbol
C  signals errors instead of returning them.
C
C  Josh Stillerman 12/5/94
C
      Integer*4 function Find_image_symbol(image, routine, addr)
 
      Integer*4 STATUS
 
      status = 0
 
      Find_image_symbol = status
      return
 
      end

  subroutine uread_arg_count( nargu, nargc )
  !.. uread_arg_count                  Returns count of args not used by uread
  !                                    codesys/source/ureadsub/uread_arg_count.
  !
  !  Usage :-
  !    call  uread_arg_count( nargu, nargc)
  !    l_arg: do iargc=nargu+1,nargc
  !      ..
  !    enddo l_arg
  !---------------------------------------------------------------------------------
  !
  !  Author                            Jim.Conboy@ccfe.ac.uk
  !  Version                           1.00,  20May2010
  !  Modifications
  !
  !  1.00  20May2010                   Jim.Conboy@ccfe.ac.uk
  !                                    Written
  !----_^---------------------------------=========================================|
  !
  implicit  none
  !
  !..GLOBAL
  !variable                          :: name           ! description
  !
  !..Arguments
  !
  integer, intent(out)               :: nargu &        ! argument index, terminates uread args
                                       ,nargc          ! total number of args
  !
  !..local
      character(len=2), parameter    :: carg_delim='-!'
  !                                     terminates uread args on command line

  character(len=255)                 :: carg           ! buffer for argument inspection
  !
  character(len=*),parameter         :: cSr='ureadsub/uread_arg_count'
  !----------------------------------::================!.........................|
  !
  call get_arg_count( nargc )
  if( nargc == 0 )   then
    nargu = 0
  else
    l_arg: do nargu=1,nargc
       call get_arg( nargu, carg )
       if( carg(1:2) == carg_delim )    exit l_arg
    enddo l_arg
  endif
#ifdef _DEBUG
  print *,cSr,' -D- nargu, nargc : ',nargu,nargc
#endif
  return
  end subroutine uread_arg_count

!
! ======================= ADPAK_MOD =======================
!
! This module replaces the common blocks in the adpak routines
!
module adpak_mod
  use iso_c_binding, only: fp => c_double
  implicit NONE
  save    ! save between subroutine calls

  !
  ! --- switches for controling the adpak package ---
  ! used in ADSET(), adp_reset() subroutines
  !
  integer :: LADEN  = 1    ! switch for energy level calculation
                           ! 0 -> use H. MAYER SHIELDING CONSTANTS
                           ! 1 -> use R. MORE REVISED SHIELDING CONSTANTS
  integer :: LADTIP = 1    ! switch to use tabulated ionization potentials (0 off, 1 on)
  integer :: LECI   = 2    ! switch for selecting formula to use for electron collisional ionization rate
                           ! 1 -> USE XSNQ DERIVED IONIZATION RATE CALCULATION
                           ! 2 -> USE BELFAST GROUP LIGHT ELEMENT RATE FITS
                           ! 3 -> USE YOUNGER'S RATES FOR AVAILABLE ELEMENTS AND SHELLS
                           !      XSNQ RATES OTHERWISE ON A CHARGE STATE-BY-CHARGE STATE BASIS
  integer :: LDRMLT = 1    ! setup DIELECTRONIC RECOMBINATION RATE COEFFICIENT ARRAYS CDNN,CDNM
                           ! 0 -> USE CDNN, CDNM ARRAYS AS GIVEN
                           ! 1 -> CDNN, CDNM ARRAYS SET TO 1.0
                           ! 2 -> USE Y. HAHN FACTORS TO SETUP CDNN, CDNM
  integer :: LADPOUT = 6   ! logical unit number for error messages

  !
  ! --- results of switch settings ---
  ! set by ADSET(), adp_reset() subroutines
  !
  integer :: LTIPOK        ! set to 1 if found and used tabulated ionization potential
  integer :: LECIOK        ! set to LECI actually used
  
  !
  ! --- DIELECTRONIC RECOMBINATION RATE COEFFICIENT ARRAYS ---
  ! see LDRMLT -- used in ADSET(), adp_reset() subroutines
  !
  real(fp)    :: CDNN(100)     ! input for LDRMLT=0
  real(fp)    :: CDNM(100)     ! input for LDRMLT=0
  real(fp)    :: YHNNA         ! input for LDRMLT=2, Y. HAHN FACTORS
  real(fp)    :: YHNNB
  real(fp)    :: YHNNC
  real(fp)    :: YHNMA
  real(fp)    :: YHNMB
  real(fp)    :: YHNMC
  
  !
  ! --- Internal ---
  ! data stored in the usual way, fortran index I = IONIZATION_STATE+1
  !
  integer :: NUCZ  = 0     ! atomic number of element = Z (0->uninitialized module)
  integer :: NSPC          ! number of species = Z+1
  real(fp)    :: APN(100,10)   ! NUMBER OF ELECTRONS IN SHELL JN FOR SPECIES WITH CHARGE JQ-1
  real(fp)    :: AQN(100,10)   ! (2.*JN**2 - APN(JQ,JN))/(2.*JN**2) IS THE FRACTIONAL VACANCY
  integer :: NVALNC(100)   ! PRINCIPAL QUANTUM NUMBER OF THE HIGHEST OCCUPIED ('VALENCE') SHELL
  real(fp)    :: SIGMA(10,10)  ! R. MORE SHIELDING CONSTANTS
  real(fp)    :: QN(100,10)    ! EFFECTIVE NUCLEAR CHARGE AT SHELL JN
  real(fp)    :: EN(100,10)    ! ENERGY LEVELS FOR RECOMBINATION OF THE GROUND STATE ION
  real(fp)    :: EIN(100,5)    ! IONIZATION POTENTIAL FOR ELECTRON IN SHELL JN
  real(fp)    :: ENM(100,5,10) ! EXCITATION ENERGY FROM SHELL JN UP TO SHELL JM
  real(fp)    :: FNM(100,5,10) ! ABSORPTION OSCILLATOR STRENGTHS 
  real(fp)    :: FNN(100)      ! ABSORPTION OSCILLATOR STRENGTHS FOR N-N TRANSITIONS
  real(fp)    :: ENN(100)      ! EQUIVALENT ENERGY FOR N-N (DELTA N EQUAL ZERO) TRANSITIONS
  
  !
  ! --- electron rates ---
  ! set by ADERC(), adp_ioniz(), adp_recom(), adp_rad() ... 
  ! see ADERC() for adpak routines which directly set these rates
  !
  real(fp)    :: RCLION(100)   ! COLLISIONAL IONIZATION RATES (SEC-1)
  real(fp)    :: RRAREC(100)   ! RADIATIVE RECOMBINATION RATES (SEC-1)
  real(fp)    :: RDIREC(100)   ! DIELECTRONIC RECOMBINATION RATES (SEC-1)
  real(fp)    :: CIZLOS(100)   ! IONIZATION ENERGY LOSS RATE
  real(fp)    :: RADRRC(100)   ! RADIATION DUE TO RADIATIVE RRECOMBINATION (JOUES/SEC)
  real(fp)    :: RADDRC(100)   ! RADIATION DUE TO DIELECTRONIC RECOMBINATION (JOULES/SEC)
  real(fp)    :: RADCLX(100)   ! RADIATION RATES DUE TO COLLISIONAL EXCITATION (JOULES/SEC)
  real(fp)    :: RADBRM(100)   ! BREMSSTRAHLUNG RADIATION (JOULE/SEC)
  
  !
  ! --- neutral rates ---
  ! set by ADBCXR()
  !
  real(fp)    :: RCXREC(100)   ! CHARGE EXCHANGE RECOMBINATION RATES (SEC-1)
  real(fp)    :: RADBCX(100)   ! RADIATION DUE TO CASCADE AFTER CHARGE EXCHANGE (JOULES/SEC)
   
  !
  ! --- coronal equilibrium ---
  ! set by ADCE(),ADCE2() call 
  !
  real(fp)    :: CEFRAC(100)   ! CORONAL EQUILIBRIUM FRACTION IN EACH IONIZATION STATE
  real(fp)    :: CEAVGZ        ! AVERAGE CHARGE IN CORONAL EQUILIBRIUM
  real(fp)    :: CERAD         ! RADIATION RATE IN CORONAL EQUILIBRIUM
end module adpak_mod

C******************** START FILE CONDM0.FOR ; GROUP CONCTR ******************
C=========================
C  SUBROUTINE CONDM0  DOES CONDOM FUNCTION ON ONE AXIS
C
      SUBROUTINE CONDM0(X,NX,IMIN,IMAX,XMIN,XMAX)
C
      DIMENSION X(NX)
C
C  X AXIS
C
      NXM1=NX-1
      IMIN=1
      IF(XMIN.LE.X(IMIN)) GO TO 20
      NXM2=NXM1-1
      DO 10 IJ=2,NXM2
        IF(XMIN.LE.X(IJ)) GO TO 15
 10   CONTINUE
      IJ=NXM1
 15   CONTINUE
      IMIN=MIN0(IJ,NXM1)
 20   CONTINUE
C  XMAX
      IMAX=NX
      IF(XMAX.GE.X(IMAX)) GO TO 40
      IF(IMIN.EQ.NXM1) GO TO 40
      IMP1=IMIN+1
      DO 30 IJ=NXM1,IMP1,-1
        IF(XMAX.GE.X(IJ)) GO TO 35
 30   CONTINUE
      IJ=IMP1
 35   CONTINUE
      IMAX=IJ
C
 40   CONTINUE
C
CX	XMIN=X(IMIN)
CX	XMAX=X(IMAX)
C
      RETURN
      	END
C******************** END FILE CONDM0.FOR ; GROUP CONCTR ******************

C-----------------------------------------------------------------------
C  SPREDM  -- SORT AND SEPARATE MIN,MAX INPUT PAIR
C
      SUBROUTINE SPREDM(XMIN0,XMAX0,XMIN,XMAX)
C
C  INPUT XMIN0,XMAX0 -- USER INPUT PAIR
C  OUTPUT XMIN,XMAX  -- XMIN=MIN(XMIN0,XMAX0)
C                       XMAX=MAX(XMIN0,XMAX0)
C
C    BUT THEN IF XMIN=XMAX, SEPARATE THEM SLIGHTLY SO THAT XMAX.GT.XMIN
C  GUARANTEED ON OUTPUT
C
        ZMIN=AMIN1(XMIN0,XMAX0)
        ZMAX=AMAX1(XMIN0,XMAX0)
        XMIN=ZMIN
        XMAX=ZMAX
        IF(XMIN.EQ.XMAX) THEN
          XMIN=XMIN-1.E-5*XMAX
          XMAX=XMAX+1.E-5*XMAX
          IF(XMIN.EQ.XMAX) THEN
C  MUST BE EQUAL AND ZERO ...
            XMIN=-0.1
            XMAX=+0.1
          ENDIF
        ENDIF
C
      RETURN
      END

! freeware integrator adapted for TRANSP: added auxilliary argument
! for integrand (dmc Apr 2003)
!
subroutine tr_r8qags(f,aux,a,b,epsabs,epsrel, &
     reslt,abserr,neval,ier, &
     limit,lenw,last,iwork,work)
  !***begin prologue  dqags
  !***date written   800101   (yymmdd)
  !***revision date  830518   (yymmdd)
  !***category no.  h2a1a1
  !***keywords  automatic integrator, general-purpose,
  !             (end-point) singularities, extrapolation,
  !             globally adaptive
  !***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
  !           de doncker,elise,appl. math. & prog. div. - k.u.leuven
  !***purpose  the routine calculates an approximation result to a given
  !            definite integral  i = integral of f over (a,b),
  !            hopefully satisfying following claim for accuracy
  !            abs(i-result).le.max(epsabs,epsrel*abs(i)).
  !***description
  !
  !        computation of a definite integral
  !        standard fortran subroutine
  !        double precision version
  !
  !
  !        parameters
  !         on entry
  !            f      - double precision
  !                     function subprogram defining the integrand
  !                     function f(x,aux). the actual name for f needs to be
  !                     declared e x t e r n a l in the driver program.
  !
  !            aux(*) - auxilliary arguments for f, passed thru
  !
  !            a      - double precision
  !                     lower limit of integration
  !
  !            b      - double precision
  !                     upper limit of integration
  !
  !            epsabs - double precision
  !                     absolute accuracy requested
  !            epsrel - double precision
  !                     relative accuracy requested
  !                     if  epsabs.le.0
  !                     and epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
  !                     the routine will end with ier = 6.
  !
  !         on return
  !            reslt - double precision
  !                     approximation to the integral
  !
  !            abserr - double precision
  !                     estimate of the modulus of the absolute error,
  !                     which should equal or exceed abs(i-reslt)
  !
  !            neval  - integer
  !                     number of integrand evaluations
  !
  !            ier    - integer
  !                     ier = 0 normal and reliable termination of the
  !                             routine. it is assumed that the requested
  !                             accuracy has been achieved.
  !                     ier.gt.0 abnormal termination of the routine
  !                             the estimates for integral and error are
  !                             less reliable. it is assumed that the
  !                             requested accuracy has not been achieved.
  !            error messages
  !                     ier = 1 maximum number of subdivisions allowed
  !                             has been achieved. one can allow more sub-
  !                             divisions by increasing the value of limit
  !                             (and taking the according dimension
  !                             adjustments into account. however, if
  !                             this yields no improvement it is advised
  !                             to analyze the integrand in order to
  !                             determine the integration difficulties. if
  !                             the position of a local difficulty can be
  !                             determined (e.g. singularity,
  !                             discontinuity within the interval) one
  !                             will probably gain from splitting up the
  !                             interval at this point and calling the
  !                             integrator on the subranges. if possible,
  !                             an appropriate special-purpose integrator
  !                             should be used, which is designed for
  !                             handling the type of difficulty involved.
  !                         = 2 the occurrence of roundoff error is detec-
  !                             ted, which prevents the requested
  !                             tolerance from being achieved.
  !                             the error may be under-estimated.
  !                         = 3 extremely bad integrand behaviour
  !                             occurs at some points of the integration
  !                             interval.
  !                         = 4 the algorithm does not converge.
  !                             roundoff error is detected in the
  !                             extrapolation table. it is presumed that
  !                             the requested tolerance cannot be
  !                             achieved, and that the returned result is
  !                             the best which can be obtained.
  !                         = 5 the integral is probably divergent, or
  !                             slowly convergent. it must be noted that
  !                             divergence can occur with any other value
  !                             of ier.
  !                         = 6 the input is invalid, because
  !                             (epsabs.le.0 and
  !                              epsrel.lt.max(50*rel.mach.acc.,0.5d-28)
  !                             or limit.lt.1 or lenw.lt.limit*4.
  !                             reslt, abserr, neval, last are set to
  !                             zero.except when limit or lenw is invalid,
  !                             iwork(1), work(limit*2+1) and
  !                             work(limit*3+1) are set to zero, work(1)
  !                             is set to a and work(limit+1) to b.
  !
  !         dimensioning parameters
  !            limit - integer
  !                    dimensioning parameter for iwork
  !                    limit determines the maximum number of subintervals
  !                    in the partition of the given integration interval
  !                    (a,b), limit.ge.1.
  !                    if limit.lt.1, the routine will end with ier = 6.
  !
  !            lenw  - integer
  !                    dimensioning parameter for work
  !                    lenw must be at least limit*4.
  !                    if lenw.lt.limit*4, the routine will end
  !                    with ier = 6.
  !
  !            last  - integer
  !                    on return, last equals the number of subintervals
  !                    produced in the subdivision process, detemines the
  !                    number of significant elements actually in the work
  !                    arrays.
  !
  !         work arrays
  !            iwork - integer
  !                    vector of dimension at least limit, the first k
  !                    elements of which contain pointers
  !                    to the error estimates over the subintervals
  !                    such that work(limit*3+iwork(1)),... ,
  !                    work(limit*3+iwork(k)) form a decreasing
  !                    sequence, with k = last if last.le.(limit/2+2),
  !                    and k = limit+1-last otherwise
  !
  !            work  - double precision
  !                    vector of dimension at least lenw
  !                    on return
  !                    work(1), ..., work(last) contain the left
  !                     end-points of the subintervals in the
  !                     partition of (a,b),
  !                    work(limit+1), ..., work(limit+last) contain
  !                     the right end-points,
  !                    work(limit*2+1), ..., work(limit*2+last) contain
  !                     the integral approximations over the subintervals,
  !                    work(limit*3+1), ..., work(limit*3+last)
  !                     contain the error estimates.
  !
  !***references  (none)
  !***routines called  dqagse,xerror
  !***end prologue  dqags
  !
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: a,abserr,b,epsabs,epsrel,f,reslt,aux(*)
  integer :: ier,last,lenw,limit,lvl,l1,l2,l3,neval
  !
  integer, dimension(limit) :: iwork
  real(fp), dimension(lenw) :: work
  !
  external f
  !
  !         check validity of limit and lenw.
  !
  !***first executable statement  dqags
  ier = 6
  neval = 0
  last = 0
  reslt = 0.0_fp
  abserr = 0.0_fp
  if(limit.lt.1.or.lenw.lt.limit*4) go to 10
  !
  !         prepare call for dqagse.
  !
  l1 = limit+1
  l2 = limit+l1
  l3 = limit+l2
  !
  call tr_r8qagse(f,aux,a,b,epsabs,epsrel,limit,reslt,abserr,neval, &
       ier,work(1),work(l1),work(l2),work(l3),iwork,last)
  !
  !         call error handler if necessary.
  !
  lvl = 0
10 if(ier.eq.6) lvl = 1
  !xx      if(ier.ne.0) call xerror(26habnormal return from dqags,26,ier,lvl)
  !xx      return
  return
end subroutine tr_r8qags


subroutine tr_r8qagse( &
     f,aux,a,b,epsabs,epsrel,limit,reslt,abserr,neval, &
     ier,alist,blist,rlist,elist,iord,last)
  !***begin prologue  dqagse
  !***date written   800101   (yymmdd)
  !***revision date  830518   (yymmdd)
  !***category no.  h2a1a1
  !***keywords  automatic integrator, general-purpose,
  !             (end point) singularities, extrapolation,
  !             globally adaptive
  !***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
  !           de doncker,elise,appl. math. & progr. div. - k.u.leuven
  !***purpose  the routine calculates an approximation result to a given
  !            definite integral i = integral of f over (a,b),
  !            hopefully satisfying following claim for accuracy
  !            abs(i-reslt).le.max(epsabs,epsrel*abs(i)).
  !***description
  !
  !        computation of a definite integral
  !        standard fortran subroutine
  !        double precision version
  !
  !        parameters
  !         on entry
  !            f      - double precision
  !                     function subprogram defining the integrand
  !                     function f(x,aux). the actual name for f needs to be
  !                     declared e x t e r n a l in the driver program.
  !
  !            aux(*) - auxilliary arguments for f, passed thru
  !
  !            a      - double precision
  !                     lower limit of integration
  !
  !            b      - double precision
  !                     upper limit of integration
  !
  !            epsabs - double precision
  !                     absolute accuracy requested
  !            epsrel - double precision
  !                     relative accuracy requested
  !                     if  epsabs.le.0
  !                     and epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
  !                     the routine will end with ier = 6.
  !
  !            limit  - integer
  !                     gives an upperbound on the number of subintervals
  !                     in the partition of (a,b)
  !
  !         on return
  !            reslt - double precision
  !                     approximation to the integral
  !
  !            abserr - double precision
  !                     estimate of the modulus of the absolute error,
  !                     which should equal or exceed abs(i-reslt)
  !
  !            neval  - integer
  !                     number of integrand evaluations
  !
  !            ier    - integer
  !                     ier = 0 normal and reliable termination of the
  !                             routine. it is assumed that the requested
  !                             accuracy has been achieved.
  !                     ier.gt.0 abnormal termination of the routine
  !                             the estimates for integral and error are
  !                             less reliable. it is assumed that the
  !                             requested accuracy has not been achieved.
  !            error messages
  !                         = 1 maximum number of subdivisions allowed
  !                             has been achieved. one can allow more sub-
  !                             divisions by increasing the value of limit
  !                             (and taking the according dimension
  !                             adjustments into account). however, if
  !                             this yields no improvement it is advised
  !                             to analyze the integrand in order to
  !                             determine the integration difficulties. if
  !                             the position of a local difficulty can be
  !                             determined (e.g. singularity,
  !                             discontinuity within the interval) one
  !                             will probably gain from splitting up the
  !                             interval at this point and calling the
  !                             integrator on the subranges. if possible,
  !                             an appropriate special-purpose integrator
  !                             should be used, which is designed for
  !                             handling the type of difficulty involved.
  !                         = 2 the occurrence of roundoff error is detec-
  !                             ted, which prevents the requested
  !                             tolerance from being achieved.
  !                             the error may be under-estimated.
  !                         = 3 extremely bad integrand behaviour
  !                             occurs at some points of the integration
  !                             interval.
  !                         = 4 the algorithm does not converge.
  !                             roundoff error is detected in the
  !                             extrapolation table.
  !                             it is presumed that the requested
  !                             tolerance cannot be achieved, and that the
  !                             returned result is the best which can be
  !                             obtained.
  !                         = 5 the integral is probably divergent, or
  !                             slowly convergent. it must be noted that
  !                             divergence can occur with any other value
  !                             of ier.
  !                         = 6 the input is invalid, because
  !                             epsabs.le.0 and
  !                             epsrel.lt.max(50*rel.mach.acc.,0.5d-28).
  !                             reslt, abserr, neval, last, rlist(1),
  !                             iord(1) and elist(1) are set to zero.
  !                             alist(1) and blist(1) are set to a and b
  !                             respectively.
  !
  !            alist  - double precision
  !                     vector of dimension at least limit, the first
  !                      last  elements of which are the left end points
  !                     of the subintervals in the partition of the
  !                     given integration range (a,b)
  !
  !            blist  - double precision
  !                     vector of dimension at least limit, the first
  !                      last  elements of which are the right end points
  !                     of the subintervals in the partition of the given
  !                     integration range (a,b)
  !
  !            rlist  - double precision
  !                     vector of dimension at least limit, the first
  !                      last  elements of which are the integral
  !                     approximations on the subintervals
  !
  !            elist  - double precision
  !                     vector of dimension at least limit, the first
  !                      last  elements of which are the moduli of the
  !                     absolute error estimates on the subintervals
  !
  !            iord   - integer
  !                     vector of dimension at least limit, the first k
  !                     elements of which are pointers to the
  !                     error estimates over the subintervals,
  !                     such that elist(iord(1)), ..., elist(iord(k))
  !                     form a decreasing sequence, with k = last
  !                     if last.le.(limit/2+2), and k = limit+1-last
  !                     otherwise
  !
  !            last   - integer
  !                     number of subintervals actually produced in the
  !                     subdivision process
  !
  !***references  (none)
  !***routines called  d1mach,dqelg,dqk21,dqpsrt
  !***end prologue  dqagse
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: a,abseps,abserr,area,area1,area12,area2,a1, &
       a2,b,b1,b2,correc,abs,defabs,defab1,defab2,d1mach,max, &
       dres,epmach,epsabs,epsrel,erlarg,erlast,errbnd,errmax, &
       error1,error2,erro12,errsum,ertest,f,oflow,resabs,reseps,reslt, &
       small,uflow,aux(*)
  integer id,ier,ierro,iroff1,iroff2,iroff3,jupbnd,k,ksgn, &
       ktmin,last,limit,maxerr,neval,nres,nrmax,numrl2
  logical extrap,noext
  !
  real(fp), dimension(limit) :: alist, blist, elist, rlist
  real(fp), dimension(3) :: res3la
  real(fp), dimension(52) :: rlist2
  integer, dimension(limit) :: iord
  !
  external f
  !
  !            the dimension of rlist2 is determined by the value of
  !            limexp in subroutine dqelg (rlist2 should be of dimension
  !            (limexp+2) at least).
  !
  !            list of major variables
  !            -----------------------
  !
  !           alist     - list of left end points of all subintervals
  !                       considered up to now
  !           blist     - list of right end points of all subintervals
  !                       considered up to now
  !           rlist(i)  - approximation to the integral over
  !                       (alist(i),blist(i))
  !           rlist2    - array of dimension at least limexp+2 containing
  !                       the part of the epsilon table which is still
  !                       needed for further computations
  !           elist(i)  - error estimate applying to rlist(i)
  !           maxerr    - pointer to the interval with largest error
  !                       estimate
  !           errmax    - elist(maxerr)
  !           erlast    - error on the interval currently subdivided
  !                       (before that subdivision has taken place)
  !           area      - sum of the integrals over the subintervals
  !           errsum    - sum of the errors over the subintervals
  !           errbnd    - requested accuracy max(epsabs,epsrel*
  !                       abs(reslt))
  !           *****1    - variable for the left interval
  !           *****2    - variable for the right interval
  !           last      - index for subdivision
  !           nres      - number of calls to the extrapolation routine
  !           numrl2    - number of elements currently in rlist2. if an
  !                       appropriate approximation to the compounded
  !                       integral has been obtained it is put in
  !                       rlist2(numrl2) after numrl2 has been increased
  !                       by one.
  !           small     - length of the smallest interval considered up
  !                       to now, multiplied by 1.5
  !           erlarg    - sum of the errors over the intervals larger
  !                       than the smallest interval considered up to now
  !           extrap    - logical variable denoting that the routine is
  !                       attempting to perform extrapolation i.e. before
  !                       subdividing the smallest interval we try to
  !                       decrease the value of erlarg.
  !           noext     - logical variable denoting that extrapolation
  !                       is no longer allowed (true value)
  !
  !            machine dependent constants
  !            ---------------------------
  !
  !           epmach is the largest relative spacing.
  !           uflow is the smallest positive magnitude.
  !           oflow is the largest positive magnitude.
  !
  !***first executable statement  dqagse
  epmach = d1mach(4)
  !
  !            test on validity of parameters
  !            ------------------------------
  ier = 0
  neval = 0
  last = 0
  reslt = 0.0_fp
  abserr = 0.0_fp
  alist(1) = a
  blist(1) = b
  rlist(1) = 0.0_fp
  elist(1) = 0.0_fp
  if(epsabs.le.0.0_fp.and. &
       epsrel.lt.max(0.5E+02_fp*epmach,0.5E-28_fp)) &
       ier = 6
  if(ier.eq.6) go to 999
  !
  !           first approximation to the integral
  !           -----------------------------------
  !
  uflow = d1mach(1)
  oflow = d1mach(2)
  ierro = 0
  call tr_r8qk21(f,aux,a,b,reslt,abserr,defabs,resabs)
  !
  !           test on accuracy.
  !
  dres = abs(reslt)
  errbnd = max(epsabs,epsrel*dres)
  last = 1
  rlist(1) = reslt
  elist(1) = abserr
  iord(1) = 1
  if(abserr.le.1.0E+02_fp*epmach*defabs.and.abserr.gt.errbnd) &
       ier = 2
  if(limit.eq.1) ier = 1
  if(ier.ne.0.or.(abserr.le.errbnd.and.abserr.ne.resabs).or. &
       abserr.eq.0.0_fp) go to 140
  !
  !           initialization
  !           --------------
  !
  rlist2(1) = reslt
  errmax = abserr
  maxerr = 1
  area = reslt
  errsum = abserr
  abserr = oflow
  nrmax = 1
  nres = 0
  numrl2 = 2
  ktmin = 0
  extrap = .false.
  noext = .false.
  iroff1 = 0
  iroff2 = 0
  iroff3 = 0
  ksgn = -1
  if(dres.ge.(0.1E+01_fp-0.5E+02_fp*epmach)*defabs) ksgn = 1
  !
  !           main do-loop
  !           ------------
  !
  do last = 2,limit
    !
    !           bisect the subinterval with the nrmax-th largest error
    !           estimate.
    !
    a1 = alist(maxerr)
    b1 = 0.5_fp*(alist(maxerr)+blist(maxerr))
    a2 = b1
    b2 = blist(maxerr)
    erlast = errmax
    call tr_r8qk21(f,aux,a1,b1,area1,error1,resabs,defab1)
    call tr_r8qk21(f,aux,a2,b2,area2,error2,resabs,defab2)
    !
    !           improve previous approximations to integral
    !           and error and test for accuracy.
    !
    area12 = area1+area2
    erro12 = error1+error2
    errsum = errsum+erro12-errmax
    area = area+area12-rlist(maxerr)
    if(defab1.eq.error1.or.defab2.eq.error2) go to 15
    if(abs(rlist(maxerr)-area12).gt.0.1E-04_fp*abs(area12) &
         .or.erro12.lt.0.99_fp*errmax) go to 10
    if(extrap) iroff2 = iroff2+1
    if(.not.extrap) iroff1 = iroff1+1
10  if(last.gt.10.and.erro12.gt.errmax) iroff3 = iroff3+1
15  rlist(maxerr) = area1
    rlist(last) = area2
    errbnd = max(epsabs,epsrel*abs(area))
    !
    !           test for roundoff error and eventually set error flag.
    !
    if(iroff1+iroff2.ge.10.or.iroff3.ge.20) ier = 2
    if(iroff2.ge.5) ierro = 3
    !
    !           set error flag in the case that the number of subintervals
    !           equals limit.
    !
    if(last.eq.limit) ier = 1
    !
    !           set error flag in the case of bad integrand behaviour
    !           at a point of the integration range.
    !
    if(max(abs(a1),abs(b2)).le.(0.1E+01_fp+0.1E+03_fp*epmach)* &
         (abs(a2)+0.1E+04_fp*uflow)) ier = 4
    !
    !           append the newly-created intervals to the list.
    !
    if(error2.gt.error1) go to 20
    alist(last) = a2
    blist(maxerr) = b1
    blist(last) = b2
    elist(maxerr) = error1
    elist(last) = error2
    go to 30
20  alist(maxerr) = a2
    alist(last) = a1
    blist(last) = b1
    rlist(maxerr) = area2
    rlist(last) = area1
    elist(maxerr) = error2
    elist(last) = error1
    !
    !           call subroutine dqpsrt to maintain the descending ordering
    !           in the list of error estimates and select the subinterval
    !           with nrmax-th largest error estimate (to be bisected next).
    !
30  call tr_r8qpsrt(limit,last,maxerr,errmax,elist,iord,nrmax)
    ! ***jump out of do-loop
    if(errsum.le.errbnd) go to 115
    ! ***jump out of do-loop
    if(ier.ne.0) go to 100
    if(last.eq.2) go to 80
    if(noext) go to 90
    erlarg = erlarg-erlast
    if(abs(b1-a1).gt.small) erlarg = erlarg+erro12
    if(extrap) go to 40
    !
    !           test whether the interval to be bisected next is the
    !           smallest interval.
    !
    if(abs(blist(maxerr)-alist(maxerr)).gt.small) go to 90
    extrap = .true.
    nrmax = 2
40  if(ierro.eq.3.or.erlarg.le.ertest) go to 60
    !
    !           the smallest interval has the largest error.
    !           before bisecting decrease the sum of the errors over the
    !           larger intervals (erlarg) and perform extrapolation.
    !
    id = nrmax
    jupbnd = last
    if(last.gt.(2+limit/2)) jupbnd = limit+3-last
    do k = id,jupbnd
      maxerr = iord(nrmax)
      errmax = elist(maxerr)
      ! ***jump out of do-loop
      if(abs(blist(maxerr)-alist(maxerr)).gt.small) go to 90
      nrmax = nrmax+1
    end do
    !
    !           perform extrapolation.
    !
60  numrl2 = numrl2+1
    rlist2(numrl2) = area
    call tr_r8qelg(numrl2,rlist2,reseps,abseps,res3la,nres)
    ktmin = ktmin+1
    if(ktmin.gt.5.and.abserr.lt.0.1E-02_fp*errsum) ier = 5
    if(abseps.ge.abserr) go to 70
    ktmin = 0
    abserr = abseps
    reslt = reseps
    correc = erlarg
    ertest = max(epsabs,epsrel*abs(reseps))
    ! ***jump out of do-loop
    if(abserr.le.ertest) go to 100
    !
    !           prepare bisection of the smallest interval.
    !
70  if(numrl2.eq.1) noext = .true.
    if(ier.eq.5) go to 100
    maxerr = iord(1)
    errmax = elist(maxerr)
    nrmax = 1
    extrap = .false.
    small = small*0.5_fp
    erlarg = errsum
    go to 90
80  small = abs(b-a)*0.375_fp
    erlarg = errsum
    ertest = errbnd
    rlist2(2) = area
90  continue
  end do
  !
  !           set final result and error estimate.
  !           ------------------------------------
  !
100 if(abserr.eq.oflow) go to 115
  if(ier+ierro.eq.0) go to 110
  if(ierro.eq.3) abserr = abserr+correc
  if(ier.eq.0) ier = 3
  if(reslt.ne.0.0_fp.and.area.ne.0.0_fp) go to 105
  if(abserr.gt.errsum) go to 115
  if(area.eq.0.0_fp) go to 130
  go to 110
105 if(abserr/abs(reslt).gt.errsum/abs(area)) go to 115
  !
  !           test on divergence.
  !
110 if(ksgn.eq.(-1).and.max(abs(reslt),abs(area)).le. &
         defabs*0.1E-01_fp) go to 130
  if(0.1E-01_fp.gt.(reslt/area).or.(reslt/area).gt.0.1E+03_fp &
       .or.errsum.gt.abs(area)) ier = 6
  go to 130
  !
  !           compute global integral sum.
  !
115 reslt = 0.0_fp
  do k = 1,last
    reslt = reslt+rlist(k)
  end do
  abserr = errsum
130 if(ier.gt.2) ier = ier-1
140 neval = 42*last-21
999 return
end subroutine tr_r8qagse


subroutine tr_r8qk21(f,aux,a,b,reslt,abserr,resabs,resasc)
  !***begin prologue  dqk21
  !***date written   800101   (yymmdd)
  !***revision date  830518   (yymmdd)
  !***category no.  h2a1a2
  !***keywords  21-point gauss-kronrod rules
  !***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
  !           de doncker,elise,appl. math. & progr. div. - k.u.leuven
  !***purpose  to compute i = integral of f over (a,b), with error
  !                           estimate
  !                       j = integral of abs(f) over (a,b)
  !***description
  !
  !           integration rules
  !           standard fortran subroutine
  !           double precision version
  !
  !           parameters
  !            on entry
  !              f      - double precision
  !                       function subprogram defining the integrand
  !                       function f(x,aux). the actual name for f needs to be
  !                       declared e x t e r n a l in the driver program.
  !
  !            aux(*) - auxilliary arguments for f, passed thru
  !
  !              a      - double precision
  !                       lower limit of integration
  !
  !              b      - double precision
  !                       upper limit of integration
  !
  !            on return
  !              reslt - double precision
  !                       approximation to the integral i
  !                       result is computed by applying the 21-point
  !                       kronrod rule (resk) obtained by optimal addition
  !                       of abscissae to the 10-point gauss rule (resg).
  !
  !              abserr - double precision
  !                       estimate of the modulus of the absolute error,
  !                       which should not exceed abs(i-result)
  !
  !              resabs - double precision
  !                       approximation to the integral j
  !
  !              resasc - double precision
  !                       approximation to the integral of abs(f-i/(b-a))
  !                       over (a,b)
  !
  !***references  (none)
  !***routines called  d1mach
  !***end prologue  dqk21
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) a,absc,abserr,b,centr,abs,dhlgth,max,min, &
       d1mach,epmach,f,fc,fsum,fval1,fval2,hlgth,resabs,resasc, &
       resg,resk,reskh,reslt,uflow,aux(*)
  integer j,jtw,jtwm1
  external f
  !
  real(fp), dimension(10) :: fv1, fv2
  real(fp), dimension(5) :: wg
  real(fp), dimension(11) :: wgk, xgk
  !
  !           the abscissae and weights are given for the interval (-1,1).
  !           because of symmetry only the positive abscissae and their
  !           corresponding weights are given.
  !
  !           xgk    - abscissae of the 21-point kronrod rule
  !                    xgk(2), xgk(4), ...  abscissae of the 10-point
  !                    gauss rule
  !                    xgk(1), xgk(3), ...  abscissae which are optimally
  !                    added to the 10-point gauss rule
  !
  !           wgk    - weights of the 21-point kronrod rule
  !
  !           wg     - weights of the 10-point gauss rule
  !
  !
  ! gauss quadrature weights and kronron quadrature abscissae and weights
  ! as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
  ! bell labs, nov. 1981.
  !
  data wg  (  1) / 0.066671344308688137593568809893332_fp/
  data wg  (  2) / 0.149451349150580593145776339657697_fp/
  data wg  (  3) / 0.219086362515982043995534934228163_fp/
  data wg  (  4) / 0.269266719309996355091226921569469_fp/
  data wg  (  5) / 0.295524224714752870173892994651338_fp/
  !
  data xgk (  1) / 0.995657163025808080735527280689003_fp/
  data xgk (  2) / 0.973906528517171720077964012084452_fp/
  data xgk (  3) / 0.930157491355708226001207180059508_fp/
  data xgk (  4) / 0.865063366688984510732096688423493_fp/
  data xgk (  5) / 0.780817726586416897063717578345042_fp/
  data xgk (  6) / 0.679409568299024406234327365114874_fp/
  data xgk (  7) / 0.562757134668604683339000099272694_fp/
  data xgk (  8) / 0.433395394129247190799265943165784_fp/
  data xgk (  9) / 0.294392862701460198131126603103866_fp/
  data xgk ( 10) / 0.148874338981631210884826001129720_fp/
  data xgk ( 11) / 0.000000000000000000000000000000000_fp/
  !
  data wgk (  1) / 0.011694638867371874278064396062192_fp/
  data wgk (  2) / 0.032558162307964727478818972459390_fp/
  data wgk (  3) / 0.054755896574351996031381300244580_fp/
  data wgk (  4) / 0.075039674810919952767043140916190_fp/
  data wgk (  5) / 0.093125454583697605535065465083366_fp/
  data wgk (  6) / 0.109387158802297641899210590325805_fp/
  data wgk (  7) / 0.123491976262065851077958109831074_fp/
  data wgk (  8) / 0.134709217311473325928054001771707_fp/
  data wgk (  9) / 0.142775938577060080797094273138717_fp/
  data wgk ( 10) / 0.147739104901338491374841515972068_fp/
  data wgk ( 11) / 0.149445554002916905664936468389821_fp/
  !
  !
  !           list of major variables
  !           -----------------------
  !
  !           centr  - mid point of the interval
  !           hlgth  - half-length of the interval
  !           absc   - abscissa
  !           fval*  - function value
  !           resg   - result of the 10-point gauss formula
  !           resk   - result of the 21-point kronrod formula
  !           reskh  - approximation to the mean value of f over (a,b),
  !                    i.e. to i/(b-a)
  !
  !
  !           machine dependent constants
  !           ---------------------------
  !
  !           epmach is the largest relative spacing.
  !           uflow is the smallest positive magnitude.
  !
  !***first executable statement  dqk21
  epmach = d1mach(4)
  uflow = d1mach(1)
  !
  centr = 0.5_fp*(a+b)
  hlgth = 0.5_fp*(b-a)
  dhlgth = abs(hlgth)
  !
  !           compute the 21-point kronrod approximation to
  !           the integral, and estimate the absolute error.
  !
  resg = 0.0_fp
  fc = f(centr,aux)
  resk = wgk(11)*fc
  resabs = abs(resk)
  do j=1,5
    jtw = 2*j
    absc = hlgth*xgk(jtw)
    fval1 = f(centr-absc,aux)
    fval2 = f(centr+absc,aux)
    fv1(jtw) = fval1
    fv2(jtw) = fval2
    fsum = fval1+fval2
    resg = resg+wg(j)*fsum
    resk = resk+wgk(jtw)*fsum
    resabs = resabs+wgk(jtw)*(abs(fval1)+abs(fval2))
  end do
  do j = 1,5
    jtwm1 = 2*j-1
    absc = hlgth*xgk(jtwm1)
    fval1 = f(centr-absc,aux)
    fval2 = f(centr+absc,aux)
    fv1(jtwm1) = fval1
    fv2(jtwm1) = fval2
    fsum = fval1+fval2
    resk = resk+wgk(jtwm1)*fsum
    resabs = resabs+wgk(jtwm1)*(abs(fval1)+abs(fval2))
  end do
  reskh = resk*0.5_fp
  resasc = wgk(11)*abs(fc-reskh)
  do j=1,10
    resasc = resasc+wgk(j)*(abs(fv1(j)-reskh)+abs(fv2(j)-reskh))
  end do
  reslt = resk*hlgth
  resabs = resabs*dhlgth
  resasc = resasc*dhlgth
  abserr = abs((resk-resg)*hlgth)
  if(resasc.ne.0.0_fp.and.abserr.ne.0.0_fp) &
       abserr = resasc* &
       min(0.1E+01_fp,(0.2E+03_fp*abserr/resasc)**1.5_fp)
  if(resabs.gt.uflow/(0.5E+02_fp*epmach)) abserr = max &
       ((epmach*0.5E+02_fp)*resabs,abserr)
  return
end subroutine tr_r8qk21

C******************** START FILE ulosup.FOR ; GROUP URDUTS ******************
c--------------------------------------------------------------
c&  ulosup  uread left justify
c
c  *** case conversion suppressed ***
c      case conversion deferred to output translation routines
c      dmc Mar 2004
c
C  REV-- JUL 81.  ALSO DROP LEADING BLANKS FROM LINE
C  RETURN LENGTH INUM OF STRING NOT INCL. TRAILING BLANKS AFTER
C  LEFT-JUSTIFICATION
c
C  REV DMC MAY 1986 - CONVERT TABS TO BLANKS
C
C  REV CAL July 97 -- need also to left justif urdfcap
c
      subroutine ulosup(zbuff,INBUF,INUM,ILEVCMD)
C
      use USERIO
C
      character*1 zbuff(INBUF)
      character*1 zupper(27),zlower(27)
      data zlower/'a','b','c','d','e','f','g',
     >         'h','i','j','k','l','m','n','o',
     >         'p','q','r','s','t','u','v',
     >         'w','x','y','z','	'/  ! tab char
      data zupper/'A','B','C','D','E','F','G',
     >         'H','I','J','K','L','M','N','O',
     >         'P','Q','R','S','T','U','V',
     >         'W','X','Y','Z',' '/
c------------------------------------------------------------------
c  executable code:
c
      zlower(27)=char(9)	! make sure it has a tab
c
      if(ilevcmd.gt.1) go to 50
c
      inblnk=0
      ict=0
C
      if(ilevcmd.eq.0) ilclim=27	! tab conversion only
      if(ilevcmd.eq.1) ilclim=27	! *always*
C
c  do not revive the old way-- other things have changed...
cccccccccc      if(ilevcmd.eq.1) ilclim=1	! uppercase and tab conversion
C
      IUP=1
      do 10 i=1,INBUF
        if((zbuff(i).ne.' ').AND.(zbuff(i).ne.char(9))) inblnk=1
        if(inblnk.eq.0) go to 10
        ict=ict+1
        zbuff(ict)=zbuff(i)
        IF(ZBUFF(ICT).EQ.'"') IUP=1-IUP
        IF(IUP.EQ.1) THEN
          ilp=ilclim
          do 9 j=ilp,27
            if(zbuff(ict).eq.zlower(j)) zbuff(ict)=zupper(j)
 9        continue
        ENDIF
c
 10   continue
c
c  fill up remainder of lines with blanks if necessary
      if(ict.ge.INBUF) GO TO 50
      icp1=ict+1
      do 20 i=icp1,INBUF
        zbuff(i)=' '
 20   continue
c
 50   CONTINUE
c
      DO 60 I=INBUF,1,-1
        INUM=I
        IF(ZBUFF(INUM).NE.' ') GO TO 70
 60   CONTINUE
      INUM=0
 70   CONTINUE
c
      RETURN
      end
C******************** END FILE ulosup.FOR ; GROUP URDUTS ******************

!-----------------------------------------------------------------------
!  PSGCHVX -- EVALUATE CHEBYCHEV FIT TO A CROSS-SECTION, W/EXTRAPOLATION
!
real(fp) FUNCTION psgchvx8(itype,ZE,EMIN,EMAX,CCHEV)
!
!  INPUT
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) zmin,zmax,zans,psgchev8,eminl,emaxl,zainc,ze1,zel1,zel2,&
       ze2,zsig1,zsig2,zlsig1,zlsig2,zs,zel,zlsig0,zlsdif,za,zb
!============
  integer itype     ! 1 for CX, 2 for II
  real(fp) ZE		! INPUT ENERGY EV
  real(fp) EMIN,EMAX	! ENERGY RANGE OF FIT EV
!
  real(fp) CCHEV(9)	! CHEBYCHEV POLYNOMIAL FIT COEFFICIENTS
!
!  OUTPUT PSGCHEV = FIT VALUE RETURNED
!
!  IF ZE IS IN RANGE, EVALUATE FIT VIA SUBROUTINE PSGCHEV
!
!  IF ZE IS OUT OF RANGE, PERFORM AN EXTRAPOLATION
!
!  MOD DMC JULY 1989 -- CHEBYCHEV VALID FIT RANGE DETERMINED TO START
!  ONLY AT 100 EV.  LOCAL VARIABLES ZMIN,ZMAX GIVE LOCALLY ACCEPTED
!  FIT RANGE, BUT ORIGINAL FIT RANGE EMIN,EMAX MUST BE PROVIDED TO
!  THE CHEBYCHEV FIT ROUTINE.
!
!  IF OUT OF RANGE HIGH, A LINEAR EXTRAPOLATION IS PERFORMED;
!
!  IF OUT OF RANGE LOW, A CUBIC INTERPOLATION IS PERFORMED BTW
!  MAX(100 EV, EMIN) AND 1 EV, USING (for cx, itype=1, 2.5e-18 =
!  the approximate H,C+6 cx coeff. at 1 eV) (for ii, itype=2, a
!  very small number, 2.5e-25).
!
!  IN THIS MANNER I HOPE TO REMOVE THE WILD VARIATIONS VS. Z THAT
!  OCCUR AT LOW ENERGY IN THE PHANEUF DATA WHEN EXTRAPOLATED ...
!
!-----------------------------------------------------------------------
!
  ZMIN=max(100.0_fp,EMIN)
  ZMAX=EMAX
!
  IF((ZE.GE.ZMIN).AND.(ZE.LE.ZMAX)) THEN
     ZANS=psgchev8(ZE,EMIN,EMAX,CCHEV)
!
  ELSE
!
!  OUT OF RANGE
!
     EMINL=log(ZMIN)
     EMAXL=log(ZMAX)
!
     ZAINC=0.005_fp*(EMAXL-EMINL)
     IF(ZE.LT.ZMIN) THEN
        ZE1=ZMIN
        ZEL1=EMINL
        ZEL2=EMINL+ZAINC
        ZE2=EXP(ZEL2)
     ELSE IF(ZE.GT.EMAX) THEN
        ZEL1=EMAXL-ZAINC
        ZE1=EXP(ZEL1)
        ZE2=ZMAX
        ZEL2=EMAXL
     ENDIF
!
     ZSIG1=psgchev8(ZE1,EMIN,EMAX,CCHEV)
     ZSIG2=psgchev8(ZE2,EMIN,EMAX,CCHEV)
!
     ZLSIG1=log(ZSIG1)
     ZLSIG2=log(ZSIG2)
!
!  EXTRAPOLATION
!
     ZS=(ZLSIG2-ZLSIG1)/(ZEL2-ZEL1)
     ZEL=log(ZE)
!
     IF(ZE.LT.ZMIN) THEN
!  LOW END - CUBIC
        ZEL=max(0.0_fp,ZEL)
        if(itype.eq.1) then
           zlsig0=log(2.5e-18_fp)
        else
           zlsig0=log(2.5e-25_fp)
        endif
        ZLSDIF=(ZLSIG1-ZLSIG0)/ZEL1
        ZA=(ZS-2.0_fp*ZLSDIF)/ZEL1**2
        ZB=(3.0_fp*ZLSDIF-ZS)/ZEL1
!
        ZANS=ZEL**2*(ZA*ZEL+ZB)+ZLSIG0
!
     ELSE IF(ZE.GT.ZMAX) THEN
!  HIGH END - LINEAR
        ZANS=ZLSIG2+ZS*(ZEL-ZEL2)
!
     ENDIF
!
     ZANS=EXP(ZANS)
!
  ENDIF
!
  psgchvx8=ZANS
!
  RETURN
END FUNCTION psgchvx8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

C******************** START FILE UF2DWR.FOR ; GROUP UFILES *************
C--------------------------------------------------------------
C  UF2DWR
C  COMPRESS AND WRITE 2-DIMENSIONAL DATA TO ASCII FILE
C
 
      SUBROUTINE UF2DWR(ILUN,IDEV_I,ZSDATE_I,
     >     F_i,NF1,X_i,NX,Y_i,NY,IPROC,
     >     FLAB_I,XLAB_I,YLAB_I,
     >     NSC,SCVAL,SCLAB_I,
     >     IER)
 
 
C  Updates:
C   22 Oct 2001  CAL - support MDS+
C   29 Jul 1997  CAL - Add HDF
C   23 Aug 1993  TbT - Changed format from (1X, 1PE11.4) - 1X,6(1PE13.6)
C
C  ILUN-- FILE LOGICAL UNIT NUMBER
C  IDEV-- 4 LETTER TOKAMAK DEV. CODE ("PLT ", ETC.)
C  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
C  X(NX),F(NF1,NY),Y(NY)-- REAL NUMERIC DATA TO BE WRITTEN
C   ARRAYS AND DIMENSIONS
C  IPROC- PROCESS CODE 0= "RAW", 1= AVERAGED
C    2= SMOOTHED, 3=AVERAGED AND SMOOTHED
C  XLAB-- 30 CHARACTER LABEL FOR X
C   FIRST 20 CHARACTERS-- NAME OF X
C   LAST 10 CHARACTERS--  PHYSICAL UNITS OF X
C     E.G. XLAB = 'MAJOR RADIUS        CM        '
C  FLAB-- 30 CHARACTER LABEL FOR F - SAME FORMAT AS XLAB
C  YLAB-- 30 CHARACTER LABEL FOR Y - SAME FORMAT AS XLAB
C
C  NSC-- NUMBER OF ASSOCIATED SCALARS TO WRITE
C   ** NOTE NSC=0 IS ALLOWED **
C  SCVAL- VALUE(S) OF ASSOCIATED SCALARS
C  SCLAB- ASSOCIATED SCALARS KEYWORDS, LABELS, PHYS. UNITS.
C
C*  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
C
C* DENOTES OUTPUT VARIABLE
 
      USE UFILES
      implicit none
C
      integer       nx,    nf1,   ny,    nsc,  ilun
      character*(*) IDEV_I,ZSDATE_I,xlab_i(3),ylab_i(3),flab_i(3)
      CHARACTER*30 SCLAB_I(*)
C
      REAL X_i(NX),F_i(NF1,NY),Y_i(NY),SCVAL(*)
      CHARACTER*10 ZSDATE,ZDATE
      CHARACTER*30 XLAB,FLAB,YLAB,SCLAB(max(1,nsc))
      CHARACTER*4 IDEV
 
      Integer Iformat
      integer l
      integer ilnurd
 
      integer ier,   idim,  kmprs, iproc, iflag, ierh, ilu, iluj
      integer ierr,  ierrw, iendw, ichan, jproc
      real    ztol
C
      integer i
      real, dimension(:), allocatable :: x,y
      real, dimension(:,:), allocatable :: f
C
C$r8real_input: x_i,f_i,y_i,scval
C--------------------------------------------------------------------
C  dmc -- guard against ieee underflows... to prevent problems downstream
c
      call ufck_reset
      allocate(x(nx),y(ny),f(nf1,ny)); f=0
      call ufck_under(ufelun,'x',x_i,x,nx)
      call ufck_under(ufelun,'y',y_i,y,ny)
      do i=1,ny
         call ufck_under(ufelun,'f',f_i(1,i),f(1,i),nx)
      enddo
c
C	----------------------------------------------------------------
C  standardize labels
C
      call ufsc_lbck(zsdate_i,zsdate,idev_i,idev,sclab_i,sclab,nsc)
C
      if(len(xlab_i(1)).ne.10) then
         call uf_lbck('xlab',xlab_i,xlab)
      else
         call uf_lbck('xlab',xlab_i(1)//xlab_i(2)//xlab_i(3),xlab)
      endif
      if(len(ylab_i(1)).ne.10) then
         call uf_lbck('ylab',ylab_i,ylab)
      else
         call uf_lbck('ylab',ylab_i(1)//ylab_i(2)//ylab_i(3),ylab)
      endif
      if(len(flab_i(1)).ne.10) then
         call uf_lbck('flab',flab_i,flab)
      else
         call uf_lbck('flab',flab_i(1)//flab_i(2)//flab_i(3),flab)
      endif
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF2DWR    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.1) THEN
        CALL UERSTA(ICHAN,'UF2DWR    ')
        GO TO 9000
      ENDIF
C
C  DIMENSION CHECK
C
      IF(NX.GT.NF1) THEN
        WRITE(UFELUN,9011) NX,NF1
 9011   FORMAT(' ? DIMENSION OF X ARRAY EXCEEDS FIRST DIMENSION OF'/
     >       '   F ARRAY --UF2DWR-- NX=',I10,' NF1=',I10/)
        GO TO 9000
      ENDIF
C
C
      IDIM=2
      CALL C9DATE(ZDATE)
      KMPRS = UFCPRS(ICHAN)
c MDSplus
      if(kmprs.eq.-1) then
         write(ufelun,'('' ?UF2DWR:  MDS+ write '')')
         l=index(mds_node(ichan),' ')-1
         call add2duf(ufelun,mds_node(ichan)(1:l),
     >        f,nf1,x,nx,y,ny,iproc,
     >        nx,ny,iflag,flab,xlab,ylab,
     >        nsc,nsc,scval,sclab,ier)
         if (ier .eq. 0) then
            call uf_fin(ufelun,mds_node(ichan)(1:l),IDEV,ZDATE,
     >          iproc,ier)
            if (ier .eq. 0) go to 1000
         endif
         goto 9000
      endif
C
C
C  ** MOD APR 1984 -- ALL WRITES SWITCHED FOR BINARY COMPRESS OPTION
      IF(KMPRS.EQ.0) THEN
        CALL UFAHED2(ILUN,UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE,1,
     >       Iformat,IERH)
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE
      else if(kmprs.eq.2) then
        call ufbhed(ilun,ufshot(ichan),idev,idim,kmprs,zdate,zsdate,1,
     >       ierh)
C      else if (kmprs.eq.3) then
C         call uhdfhed(ILUN,UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE,1,
C     >      IERH)
      else if (kmprs.eq.4) then
         call ucdfhed(ILUN,UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE,1,
     >       IERH)
      ENDIF
C
C  WRITE THE ASSOCIATED SCALARS
      CALL UF0WRT(ILUN,SCVAL,SCLAB,NSC,IER)
      IF(IER.NE.0) GO TO 9000
C
      IF(KMPRS.EQ.0) THEN
        WRITE(ILUN,3003) XLAB
 3003 FORMAT(1X,A30,T32,';-INDEPENDENT VARIABLE LABEL: X-')
C
        WRITE(ILUN,3013) YLAB
 3013 FORMAT(1X,A30,T32,';-INDEPENDENT VARIABLE LABEL: Y-')
C
        WRITE(ILUN,3004) FLAB
 3004 FORMAT(1X,A30,T32,';-DEPENDENT VARIABLE LABEL-')
C
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) XLAB,YLAB,FLAB
      else if(kmprs.eq.2) then
        call ubwchar(ilun,xlab)
        call ubwchar(ilun,ylab)
        call ubwchar(ilun,flab)
C
C HDF ?
C      else if (kmprs .eq. 3) then
C         call uhdf2w(ilun,f,nf1,x,nx,y,ny,iproc,
C     >                 flab,xlab,ylab,ier)
C         if (ier .ne. 0) go to 9000
C netCDF ?
      else if (kmprs .eq. 4) then
         call ucdf2w(ilun,f,nf1,x,nx,y,ny,iproc,
     >       flab,xlab,ylab,ier)
         if (ier .ne. 0) go to 9000
      ENDIF
C
      IF(KMPRS.EQ.0) THEN
        jproc=max(0,min(9,iproc))
        WRITE(ILUN,3006) jproc
 3006 FORMAT(1X,I1,T32,';-PROC CODE- 0:RAW 1:AVG 2:SM 3:AVG+SM')
C
        WRITE(ILUN,3007) NX,NY
 3007 FORMAT(1X,I10,T32,';-# OF X PTS-'/1X,I10,T32,
     >       ';-# OF Y PTS- X,Y,F(X,Y) DATA FOLLOW:')
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) IPROC,NX,NY
      else if(kmprs.eq.2) then
        call ubw3int(ilun,iproc)
        call ubw3int(ilun,nx)
        call ubw3int(ilun,ny)
      ENDIF
C
C
C  CONVERT INDEPENDENT DATA TO INTEGER*2 AND COMPRESS
C
      LFCLUN=.FALSE.
      if(kmprs.eq.2) then
C
         call ubcpwr(ilun,x,'x',nx,1,1,nx,1)
         call ubcpwr(ilun,y,'y',ny,1,1,ny,1)
         call ubcpwr(ilun,f,'f',nf1,ny,1,nx,ny)
C
      else IF(KMPRS.EQ.1) THEN
C------------------------------------------/ * COMPRESSED DATA WRITES *
C ERROR LOG FILE--
C
         ILUJ=ILNURD(UJUNKA)
         CALL UFOPEN(UFCLUN,UJUNKA(1:ILUJ)//'ZUFCMPRI.ERR',2,IER,0)
         IF(IER.NE.0) GO TO 9000
         LFCLUN=.TRUE.
C
         ZTOL=UFCTOL(ICHAN)
         CALL UFSTEP(ILUN,X,'X',NX,IERR)
         IF (IERR.NE.0) THEN
            CALL UFCPWR(ILUN,X,'X',NX,1,1,NX,1,ZTOL,IERR)
         ENDIF
         CALL UFSTEP(ILUN,Y,'Y',NY,IERR)
         IF (IERR.NE.0) THEN
            CALL UFCPWR(ILUN,Y,'Y',NY,1,1,NY,1,ZTOL,IERR)
         ENDIF
C
         CALL UFCPWR(ILUN,F,'F',NF1,NY,1,NX,NY,ZTOL,IERR)
C------------------------------------------/ * UNCOMPRESSED WRITES *
      ELSE IF(KMPRS.EQ.0) THEN
C
         LFCLUN=.FALSE.
C
         call ufascio(ilun,x,nx,'W',iendw,ierrw)
         call ufascio(ilun,y,ny,'W',iendw,ierrw)
         call ufascio2(ilun,f,nf1,nx,ny,'W',iendw,ierrw)
C
      ENDIF
C
      IF(KMPRS.EQ.0) WRITE(ILUN,3010)
 3010 FORMAT(' ;----END-OF-DATA-----------------COMMENTS:-----------')
C
 1000 IER=0
      UFSTAT(ICHAN)=2
C
C  IF COMPRESSION WARNING ERRORS OCCURRED, SPOOL TO TTY AND OUTPUT FILE
C
      IF(LFCLUN) THEN
        REWIND UFCLUN
        CALL USPOOL(UFCLUN,ILUN)
        CLOSE(UNIT=UFCLUN,STATUS='DELETE')
      ENDIF
C
      goto 9999
C----------
C  ERRORS
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ? DATA NOT WRITTEN DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      UFSTAT(ICHAN)=2
      IER=1

 9999 continue
      deallocate(x,y,f)
      RETURN
      END
C******************** END FILE UF2DWR.FOR ; GROUP UFILES ***************

subroutine unflatten(darray,nd)

  !--------------------------

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit none

  integer, intent(in) :: nd   ! size of darray
  real(fp), intent(inout) :: darray(nd)   ! data to be "unflattened"

  !--------------------------

  ! without affenting minval(darray) or maxval(darray), introduce
  ! slight tilts to any flat spots, to prevent any occurrence of
  ! darray(j)-darray(j-1) = 0 precisely.

  ! this can be useful as protection when communicating a profile
  ! from a "REAL" code to a "REAL(FP)" code which cannot tolerate
  ! flat spots or "zero gradient regions".  In this case, when
  ! there are differences between two successive REAL*4 numbers, there
  ! is lots of room for introducing a small tilt in REAL(FP) space.

  ! example of effect:

  ! 1.0000000 2.0000000 2.0000000 2.0000000 1.0000000
  !   becomes
  ! 1.0000000 1.9999999 2.0000000 1.9999999 1.0000000

  ! 1.0000000 2.0000000 2.0000000 2.0000000 3.0000000
  !   becomes
  ! 1.0000000 1.9999999 2.0000000 2.0000001 3.0000000

  !--------------------------
  ! local variables:

  real(fp) :: global_min,global_max,global_diff

  real(fp) :: anchor,end_right,end_left,local_diff,incr,incr1,incr2

  integer :: i,lflat,nflat,lanchor

  real(fp), parameter :: ZSMALL = 1.0e-5_fp
  real(fp), parameter :: ZTINY = 1.0e-9_fp

  !--------------------------
  ! executable code:

  global_max=maxval(darray)
  global_min=minval(darray)
  global_diff = global_max - global_min

  if(global_diff.eq.ZERO) return

  !--------------------------
  ! check left bdy region

  nflat=1
  i=1
  do
    i=i+1
    if(darray(i).ne.darray(i-1)) exit
    nflat=nflat+1
  enddo

  if(nflat.gt.1) then

    local_diff=darray(i)-darray(i-1)
    incr=ZSMALL*local_diff
    incr=min(ZTINY*global_diff,max(-ZTINY*global_diff,incr))/ &
         (nflat-1)

    do i=2,nflat
      darray(i)=darray(i-1)+incr
    enddo
  endif

  !--------------------------
  ! check right bdy region

  nflat=1
  i=nd
  do
    i=i-1
    if(darray(i).ne.darray(i+1)) exit
    nflat=nflat+1
  enddo

  if(nflat.gt.1) then

    local_diff=darray(i)-darray(i+1)
    incr=ZSMALL*local_diff
    incr=min(ZTINY*global_diff,max(-ZTINY*global_diff,incr))/ &
         (nflat-1)

    do i=nd-1,nd-nflat+1,-1
      darray(i)=darray(i+1)+incr
    enddo
  endif

  !--------------------------
  ! check for interior flat regions

  lflat=1
  do
    lflat=lflat+1
    if(lflat.ge.nd) exit

    if(darray(lflat).ne.darray(lflat+1)) cycle

    !----------------------------------
    ! start of flat region detected...
    !----------------------------------

    nflat=1
    i = lflat
    do
      i=i+1
      if(darray(i).ne.darray(i-1)) exit
      nflat=nflat+1
    enddo

    ! darray(lflat:lflat+nflat-1) is "flat"; nflat.ge.2 to get here...
    ! find "middle" of flat spot

    lanchor = lflat + nflat/2
    anchor=darray(lanchor)

    incr1=anchor-darray(lflat-1)      ! guaranteed non-zero
    incr2=darray(lflat+nflat)-anchor  ! ditto

    if(incr1*incr2.gt.zero) then

      ! incr1 & incr2 of same sign:
      ! flat point is an "inflection"

      if(incr1.gt.ZERO) then
        incr=min(incr1,incr2)  ! both positive, take smaller modulus
      else
        incr=max(incr1,incr2)  ! both negative, take smaller modulus
      endif
      incr=ZSMALL*incr
      incr=min(ZTINY*global_diff,max(-ZTINY*global_diff,incr))/ &
           (nflat/2)

      !  add a tilt to the flat region, in the direction set by the
      !  neighbouring points

      do i=lanchor-1,lflat,-1
        darray(i)=darray(i+1)-incr
      enddo

      do i=lanchor+1,lflat+nflat-1,1
        darray(i)=darray(i-1)+incr
      enddo

    else

      ! flat spot is local maximum (if incr1.gt.0) or minimum

      if(incr1.gt.ZERO) then
        incr=min(incr1,-incr2)         ! local maximum (incr > 0)
      else
        incr=max(incr1,-incr2)         ! local minimum (incr < 0)
      endif
      incr=ZSMALL*incr
      incr=min(ZTINY*global_diff,max(-ZTINY*global_diff,incr))/(nflat/2)

      !  from the anchor point tilt down/up in both directions according
      !  as this is a local maximum/minimum

      do i=lanchor-1,lflat,-1
        darray(i)=darray(i+1)-incr
      enddo

      do i=lanchor+1,lflat+nflat-1,1
        darray(i)=darray(i-1)-incr
      enddo

    endif

    lflat = lflat + nflat - 1

  enddo

  return
end subroutine unflatten

C******************** START FILE UFNPAD.FOR ; GROUP UFILES ******************
C-----------------------------------------------------------
C  UFNPAD
C  INSERT STR1 IN STR2 WITH BLANK PADDING
C  GENERATE ERROR IF STR1 IS TOO LONG TO FIT
C
      SUBROUTINE UFNPAD(ZSTR1,ILSTR1,ZSTR2,ZERMSG,IER)
C
      USE UFILES
C
      CHARACTER*(*) ZSTR1,ZSTR2,ZERMSG
C
C ILSTR1 - LENGTH (NOT INCL. TRAILING BLANKS) OF ZSTR1
C
C ZERMSG - LABEL FOR ERROR MESSAGE
C
      ILEN=LEN(ZSTR2)
      IF(ILSTR1.GT.ILEN) THEN
C  LENGTH ERROR
        WRITE(UFELUN,9001) ZERMSG,ZSTR1(1:ILSTR1),ILEN
 9001 FORMAT(' %',A,' STRING: "',A,'" ERROR:'/
     >'   TOO LONG FOR UFILES COMMON ELEMENT (MAX=',I2,')')
        IER=1
        RETURN
      ENDIF
C
C  OK
C
      IF(ILSTR1.GT.0) ZSTR2(1:ILSTR1)=ZSTR1(1:ILSTR1)
C
      IPP=ILSTR1+1
      IF(IPP.LE.ILEN) THEN
        DO 30 IC=IPP,ILEN
          ZSTR2(IC:IC)=' '
 30     CONTINUE
      ENDIF
C
      IER=0
      RETURN
      END
C******************** END FILE UFNPAD.FOR ; GROUP UFILES ******************

C-----------------------------------------------------------------------
C  URDSTR -- READ A STRING IN FROM THE VIRTUAL KEYBOARD
C
C    USE SMG ROUTINES -- INPUT FROM INTERACTIVE USER.  THIS ROUTINE
C  SHOULD ONLY BE CALLED FROM AN INTERACTIVE PROCESS -- IT IS THE
C  CALLER'S RESPONSIBILITY TO DECIDE THIS.
C
C    NB DON'T USE SMG ON UNIX SYSTEMS WHERE IT DOES NOT EXIST!
C  DMC OCT 1991
C
      SUBROUTINE URDSTR(ZSTR,IEOF,IERR)
C
      USE USERIO
C
      CHARACTER*(*) ZSTR    ! STRING TO BE READ IN
      INTEGER IEOF	      ! INTEGER END OF FILE = 1
      INTEGER IERR	      ! COMPLETION CODE NORMAL = 0
      CHARACTER*1 EOT
C
      CHARACTER*1 ZNULL
C
C--------------------------------------
C
      ZSTR=' '
      ZNULL=CHAR(0)
      IERR=0
      IEOF=0
      EOT = char(3)
C
c
c  unix
c
	if (NLJAVA) then
		write(*,*) EOT
	endif

        call fgetline(' ',zstr,ichars)
        if(ichars.eq.-1) ieof=1
c
C
      RETURN
      END

       LOGICAL FUNCTION LOKJACA
     >                  (RJC,RJS,DRCDXI,DRSDXI,YJC,YJS,DYCDXI,DYSDXI,NM)
C
C
C       B. BALET, JAN 1994 : MODIFICATIONS TO THE FUNCTION LOKJAC WRITTEN BY
C                            BOB MCCANN FOR THE UP-DOWN ASYMMETRIC CASE
C
C       --------
C       COMMENTS
C       --------
C
C
C	THIS CHECKS TO SEE IF THE JACOBIAN D(R<Y)/D(XI,XI) CHANGES SIGN
C    AROUND THE GIVEN FLUX SURFACE.  LOKJACA=.T. IF THE SIGN IS UNCHANGED,
C    AND LOKJACA=.F. IF THE SIGN CHANGES
C    (THE TRANSFORMATION WENT SINGULAR).
C
C
C       -------------------
C       GLOBAL DECLARATIONS
C       -------------------
C
C
C***
C
C
C       ---------------
C       INPUT VARIABLES
C       ---------------
C
C
      INTEGER	NM  		!# OF MOMENTS OF R, Y
C
C    THE FOLLOWING REFER TO A GIVEN FLUX SURFACE:
C
      REAL	RJC(0:NM) 	!J=0,NM MOMENTS OF R : COS TERMS
        REAL	RJS(0:NM) 	!J=0,NM MOMENTS OF R : SIN TERMS
      REAL	DRCDXI(0:NM)	!D(RJC)/DXI
      REAL	DRSDXI(0:NM)	!D(RJS)/DXI
C
        REAL    YJC(0:NM)         !J=0,NM MOMENTS OF Y : COS TERMS
        REAL    YJS(0:NM)         !J=0,NM MOMENTS OF Y : SIN TERMS
        REAL    DYCDXI(0:NM)      !D(YJC)/DXI
        REAL    DYSDXI(0:NM)      !D(YJS)/DXI
C
C
C       ----------------
C       OUTPUT VARIABLES
C       ----------------
C
C
C	LOGICAL LOKJACA	!=.T. IF THE TRANSFORMATION IS OK
C			!=.F. IF THE COORDINATES ARE SINGULAR
C
C
C       ------------------
C       LOCAL DECLARATIONS
C       ------------------
C
C
      PARAMETER	(NTH = 254)	!# ANGLES TO USE IN FINDING EXTREMA
C
      REAL	ZC(0:NTH)		!COS(J*TH) ASSUMING NM.LE.NTH
      REAL	ZS(0:NTH)         !SIN(J*TH) ASSUMING NM.LE.NTH
C
        REAL	ZR77		!R(TH)
      REAL	ZY77		!Y(TH)
      REAL	ZDRDTH		!DR/DTH
      REAL	ZDYDTH		!DY/DTH
      REAL	ZDRDXI		!DR/DXI
      REAL	ZDYDXI		!DY/DXI
      REAL	ZJ		!JACOBIAN
C
C
C       ---------------
C       DATA STATEMENTS
C       ---------------
C
C
C***
C
C
C       -------------------
C       STATEMENT FUNCTIONS
C       -------------------
C
C
C***
C
C
C=========================================
C
C
C       ----------------------
C       0.1     INITIALIZATION
C       ----------------------
C
C
      ZTWOPI = 8.0*ATAN(1.0)
C
C    LOOP OVER SOME ANGLES FROM 0 TO TWO*PI:
C
      DO 69000 I = 1, NTH
C
        ZTH = ZTWOPI*FLOAT(I-1)/FLOAT(NTH-1)
C
        DO 100 J = 0, NM
          ZC(J) = COS(J*ZTH)
          ZS(J) = SIN(J*ZTH)
100     CONTINUE
C
C
C	----------------------------------------------
C	1.0	COMPUTE VARIOUS DERIVATIVES OF R AND Y
C	----------------------------------------------
C
C
10000 CONTINUE
C
C    INITIALIZE THE MOMENTS LOOP
C
      ZR77 = 0.0
      ZDRDXI = 0.0
      ZDRDTH = 0.0
C
      ZY77 = 0.0
      ZDYDTH = 0.0
      ZDYDXI = 0.0
C
C    ADD UP THE CONTRIBUTION FROM EACH MOMENT
C
      DO 10100 J = 0, NM
C
        ZR77 = ZR77 + RJC(J)*ZC(J) + RJS(J)*ZS(J)
C
        ZDRDXI = ZDRDXI + DRCDXI(J)*ZC(J) + DRSDXI(J)*ZS(J)
        ZDRDTH =
     >    ZDRDTH - RJC(J)*FLOAT(J)*ZS(J) + RJS(J)*FLOAT(J)*ZC(J)
C
          ZY77 = ZY77 + YJC(J)*ZC(J) + YJS(J)*ZS(J)
C
          ZDYDXI = ZDYDXI + DYCDXI(J)*ZC(J) + DYSDXI(J)*ZS(J)
          ZDYDTH =
     >    ZDYDTH - YJC(J)*FLOAT(J)*ZS(J) + YJS(J)*FLOAT(J)*ZC(J)
C
10100 CONTINUE
C
C
C       -------------------------------------------------
C       2.0     COMPUTE THE JACOBIAN OF THIS FLUX SURFACE
C       -------------------------------------------------
C
C
20000   CONTINUE
C
      ZJ = ZDRDXI*ZDYDTH - ZDRDTH*ZDYDXI	!JACOBIAN
C
C
C	--------------------------------------------------
C	3.0	FIND THE MAXIMA AND MINIMA OF THE JACOBIAN
C	--------------------------------------------------
C
C
30000 CONTINUE
C
      IF(I.EQ.1)	THEN	!INITIALIZE MAX AND MIN
C
        ZJMIN = ZJ
        THJMIN = ZTH
        ZJMAX = ZJ
        THJMAX = ZTH
C
      ELSE			!FIND THE TRUE MIN AND MAX
C
        IF(ZJ.LT.ZJMIN)	THEN
          ZJMIN = ZJ
          THJMIN = ZTH
        ELSEIF(ZJ.GT.ZJMAX)	THEN
          ZJMAX = ZJ
          THJMAX = ZTH
        ENDIF
C
      ENDIF
C
69000 CONTINUE		!END OF ANGLE LOOP
C
C
C       ------------------------
C       7.0     CLEANUP & RETURN
C       ------------------------
C
C
70000   CONTINUE
C
C
      IF(ZJMIN*ZJMAX.GT.0.0)	THEN	!THEY HAVE THE SAME SIGN
          LOKJACA = .TRUE.
      ELSE
          LOKJACA = .FALSE.
      ENDIF
C
C
79000   CONTINUE        !ERROR RETURNS HERE
C
        RETURN
C
C
C       ----------------------
C       8.0     ERROR HANDLING
C       ----------------------
C
C
C***
C
C
        END
C******************** END FILE LOKJAC.FOR ; GROUP TKBLOAT ******************

C******************** START FILE GSCDEF.FOR ; GROUP GSCALE ******************
C-------------------------------------------------------------
C  GSCALE
C
C  INTERACTIVELY CONTROLLED SCALE-SETTING FOR 2-D GRAPHS
C
C   2 ROUTINES:  GSCDEF-- INTERACTIVELY DEFINE RULES FOR
C      SETTING SCALE OF GRAPH FOR ROUTINE "DPLOT1", I.E.
C      XMIN,XMAX,YMIN,YMAX
C
C                GSCSET-- SET SCALE FOR PARTICULAR GRAPH,
C      USING CONTROLS DEFINED IN GSCDEF.
C
C  ALSO INITIALIZATION ROUTINE GSCINI INITIALIZES CONTROLS TO
C  FOLLOWING:  MIN AND MAX OF GRAPH AUTOMATICALLY SET TO
C   MIN AND MAX OF DATA PASSED
C
C-------------------------------
C  GSCDEF   LET USER DEFINE RULES FOR SCALING 2D GRAPHS
C
C   FOR USE IN CONJUNCTION WITH ROUTINES SUCH AS
C   DPLOT1.FOR, GRFAH0.FOR,GRFADH.FOR,GRFHX2.FOR ...
C     UTILIZING STANDARD 2D AG4010 GRAPHICS UTILITIES
C
C   WHICH USE COMMON BLOCK
C    "DPLOT1" CONTAINING XMIN,XMAX,YMIN,YMAX OF GRAPH
C   ABOUT TO BE DRAWN.
C
C
      SUBROUTINE GSCDEF
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR,lxout
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C  START OF EXECUTABLE CODE
C
      luntrm=lnout(0)
C
      IF(IGSINI.EQ.0) CALL GSCINI
C  SAVE SETTINGS LOCALLY
        IOPTX=NOPTX
        IOPTY=NOPTY
        ZXMIN0=XMIN00
        ZXMAX0=XMAX00
        ZYMIN0=YMIN00
        ZYMAX0=YMAX00
        ZXRAT0=XRAT00
        ZYRAT0=YRAT00
C
 10   CONTINUE
C
      CALL NEUPAG
      IF(LXOUT(0)) WRITE(LUNTRM,1001)
 1001 FORMAT(//'  SCALING OPTIONS:'/
     >  ' (1)  FULLY AUTOMATIC: SCALE OF GRAPH SET TO INCLUDE'/
     >  '      MINIMUM AND MAXIMUM VALUES OF DATA BEING GRAPHED'/
     >  ' (2)  MANUAL:  MINIMUM AND MAXIMUM VALUES OF DATA ARE'/
     >  '      DISPLAYED; USER ENTERS SCALE FOR GRAPH'/
     >  ' (3)  FIXED:  ALL GRAPHS ARE SET TO SAME SCALE'/
     >  ' (4)  AUTOMATIC:  UPPER SCALE LIMIT SET TO MAXIMUM OF'/
     >  '      DATA;  LOWER LIMIT A FIXED MULTIPLE OF THE'/
     >  '      UPPER LIMIT (I.E. CONTROL # OF DECADES IN LOG PLOT)'/
     >  ' (5)  AUTOMATIC: LOWER SCALE LIMIT SET TO MINIMUM OF'/
     >  '      DATA; UPPER LIMIT A FIXED MULTIPLE OF THE '/
     >  '      LOWER LIMIT'//
     >  ' *** THESE OPTIONS ARE DEFINED INDEPENDANTLY FOR'/
     >  ' *** EACH AXIS'//)
C
 15   CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1002)
 1002 FORMAT(' *OR* ENTER "R" TO SET DEFAULT SCALE TO EQUAL THE'/
     >         '      SCALE OF A PREVIOUSLY DRAWN GRAPH')
      CALL UREAD(
     >  ' GSCDEF >> ENTER SCALING OPTION # FOR * X-AXIS *:$')
C
C  *NO SCALE DEFAULT CHANGES IF USER QUITS HERE*
      IF(LCHAR('Q')) RETURN
C
      IF(LCHAR('R')) THEN
        CALL GSCRSC(ISET)
        IF(ISET.EQ.0) GO TO 10
C  MAKE CHOSEN SCALE THE DEFAULT SCALE
        NOPTX=3
        XMIN00=XMIN
        XMAX00=XMAX
        NOPTY=3
        YMIN00=YMIN
        YMAX00=YMAX
        RETURN
      ENDIF
C
C  DECODE OLD STANDARD NUMERIC OPCODE
      IOPTX=IDCOD(IERT)
      IF((IOPTX.LT.1).OR.(IOPTX.GT.5).OR.(IERT.NE.0)) THEN
        CALL UERMSG('% ILLEGAL INTEGER OPCODE',' ',1)
        GO TO 10
      ENDIF
C
      GO TO (45,45,25,35,35) IOPTX
C
C  GET FIXED LIMITS
C
 25   CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1003) XMIN,XMAX
 1003 FORMAT(
     >' %ENTER "X"''S TO RETAIN XMIN=',1PE11.4,' AND/OR XMAX=',1PE11.4)
      CALL GSCGT1('GSCDEF','XMIN',ZXMIN0,XMIN,IRET,' ')
      IF(IRET) 10,26,25
 26   CONTINUE
      CALL GSCGT1('GSCDEF','XMAX',ZXMAX0,XMAX,IRET,' ')
      IF(IRET) 10,45,26
C
C  GET FIXED MULTIPLE FACTOR
C
 35   CONTINUE
      CALL UREAD(' GSCDEF >> ENTER FIXED X-MULTIPLIER (E10.):$')
      IF(LCHAR('Q')) GOTO 10
      ZXRAT0=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 35
C
      GO TO 45
C
C-------
C
 45   CONTINUE
C  NOW, THE Y AXIS
C
      CALL UREAD(
     >  ' GSCDEF >> ENTER SCALING OPTION # FOR * Y-AXIS *:$')
      IF(LCHAR('Q')) GOTO 10
      IOPTY=IDCOD(IERT)
      IF((IOPTY.LE.0).OR.(IOPTY.GT.5).OR.(IERT.NE.0)) THEN
        CALL UERMSG('% ILLEGAL INTEGER OPCODE',' ',2)
        IF(LXOUT(0)) WRITE(LUNTRM,1001)
        GO TO 45
      ENDIF
C
      GO TO (90,90,60,80,80) IOPTY
C
C  ENTER FIXED SCALE FACTORS
C
 60   CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1004) YMIN,YMAX
 1004 FORMAT(
     >' %ENTER "X"''S TO RETAIN YMIN=',1PE11.4,' AND/OR YMAX=',1PE11.4)
      CALL GSCGT1('GSCDEF','YMIN',ZYMIN0,YMIN,IRET,' ')
      IF(IRET) 10,65,60
 65   CONTINUE
      CALL GSCGT1('GSCDEF','YMAX',ZYMAX0,YMAX,IRET,' ')
      IF(IRET) 10,90,65
C
C  ENTER MULTIPLIER
C
 80   CONTINUE
      CALL UREAD(' GSCDEF >> ENTER FIXED Y-MULTIPLIER (E10.):$')
      IF(LCHAR('Q')) GOTO 10
      ZYRAT0=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 80
C
C  END OF ROUTINE - NORMAL EXIT; ALL SCALE CONTROLS RESET LOCALLY--
C   COPY TO COMMON
C
 90   CONTINUE
C
      NOPTX=IOPTX
      NOPTY=IOPTY
C
      XMIN00=ZXMIN0
      XMAX00=ZXMAX0
      YMIN00=ZYMIN0
      YMAX00=ZYMAX0
      XRAT00=ZXRAT0
      YRAT00=ZYRAT0
C
      RETURN
C
      	END
C******************** END FILE GSCDEF.FOR ; GROUP GSCALE ******************

      subroutine good_exit
C
C  normal exit from an f77 program
C
      call err_end                      ! turn off SUN fpe error handling msg
C
      stop  ! normal exit, stop, status = 0

      end

real(fp) function FUN(B,A2,A3,A4,A5,E)
!...E - THE ENERGY OF THE INCIDENT PARTICLE.  (KEV)
!...I NOW DEFINE THE FUNCTION USED TO EVALUATE SIGMA.
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp), intent(in) :: B,A2,A3,A4,A5,E      
  FUN=B*(A2/(1.0_fp+(A3*E-A4)**2)+A5)/(E*(1.0_fp-B))
  return
end function FUN

real(fp) function FBOSCH(E,A1,A2,A3,A4,A5,B1,B2,B3,B4)
!  NEW 11 SEP 1991
! FBOSCH is the analytic form of H.-S. Bosch's cross section fits.  
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp), intent(in) :: E,A1,A2,A3,A4,A5,B1,B2,B3,B4
  FBOSCH=(A1+E*(A2+E*(A3+E*(A4+E*A5))))/(1.0_fp+E*(B1+E*(B2+E*(B3+E*B4))))
  return
end function FBOSCH

real(fp) function FDPC(E,A0,A1,A2,A3,A4,A5,B1,B2,B3,B4,B5)
! 06/2018
! FDPC is the analytic form of H.-S. Bosch'sDPC cross section fits.
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp), intent(in) :: E,A0,A1,A2,A3,A4,A5,B1,B2,B3,B4,B5    
  FDPC=(A0+E*(A1+E*(A2+E*(A3+E*(A4+E*A5)))))/&
       (1.D0+E*(B1+E*(B2+E*(B3+E*(B4+E*B5)))))
  return
end function FDPC
real(fp) function FENDF(E,A2,A3,A4,B1,B2,B3)
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp), intent(in) :: E,A2,A3,A4,B1,B2,B3
  FENDF=E/(1.0_fp-E*(A2+E*(A3+E*A4))/(1.0_fp+E*(B1+E*(B2+E*B3)))) 
  return
end function FENDF

      subroutine tr_qelg(n,epstab,result,abserr,res3la,nres)
c***begin prologue  qelg
c***refer to  qagie,qagoe,qagpe,qagse
c***routines called  r1mach
c***revision date  830518   (yymmdd)
c***keywords  epsilon algorithm, convergence acceleration,
c             extrapolation
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math & progr. div. - k.u.leuven
c***purpose  the routine determines the limit of a given sequence of
c            approximations, by means of the epsilon algorithm of
c            p. wynn. an estimate of the absolute error is also given.
c            the condensed epsilon table is computed. only those
c            elements needed for the computation of the next diagonal
c            are preserved.
c***description
c
c           epsilon algorithm
c           standard fortran subroutine
c           real version
c
c           parameters
c              n      - integer
c                       epstab(n) contains the new element in the
c                       first column of the epsilon table.
c
c              epstab - real
c                       vector of dimension 52 containing the elements
c                       of the two lower diagonals of the triangular
c                       epsilon table. the elements are numbered
c                       starting at the right-hand corner of the
c                       triangle.
c
c              result - real
c                       resulting approximation to the integral
c
c              abserr - real
c                       estimate of the absolute error computed from
c                       result and the 3 previous results
c
c              res3la - real
c                       vector of dimension 3 containing the last 3
c                       results
c
c              nres   - integer
c                       number of calls to the routine
c                       (should be zero at first call)
c
c***end prologue  qelg
c
      real abserr,delta1,delta2,delta3,r1mach,
     *  epmach,epsinf,epstab,error,err1,err2,err3,e0,e1,e1abs,e2,e3,
     *  oflow,res,result,res3la,ss,tol1,tol2,tol3
      integer i,ib,ib2,ie,indx,k1,k2,k3,limexp,n,newelm,nres,num
      dimension epstab(52),res3la(3)
c
c           list of major variables
c           -----------------------
c
c           e0     - the 4 elements on which the
c           e1       computation of a new element in
c           e2       the epsilon table is based
c           e3                 e0
c                        e3    e1    new
c                              e2
c           newelm - number of elements to be computed in the new
c                    diagonal
c           error  - error = abs(e1-e0)+abs(e2-e1)+abs(new-e2)
c           result - the element in the new diagonal with least value
c                    of error
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           oflow is the largest positive magnitude.
c           limexp is the maximum number of elements the epsilon
c           table can contain. if this number is reached, the upper
c           diagonal of the epsilon table is deleted.
c
c***first executable statement  qelg
      epmach = r1mach(4)
      oflow = r1mach(2)
      nres = nres+1
      abserr = oflow
      result = epstab(n)
      if(n.lt.3) go to 100
      limexp = 50
      epstab(n+2) = epstab(n)
      newelm = (n-1)/2
      epstab(n) = oflow
      num = n
      k1 = n
      do 40 i = 1,newelm
        k2 = k1-1
        k3 = k1-2
        res = epstab(k1+2)
        e0 = epstab(k3)
        e1 = epstab(k2)
        e2 = res
        e1abs = abs(e1)
        delta2 = e2-e1
        err2 = abs(delta2)
        tol2 = amax1(abs(e2),e1abs)*epmach
        delta3 = e1-e0
        err3 = abs(delta3)
        tol3 = amax1(e1abs,abs(e0))*epmach
        if(err2.gt.tol2.or.err3.gt.tol3) go to 10
c
c           if e0, e1 and e2 are equal to within machine
c           accuracy, convergence is assumed.
c           result = e2
c           abserr = abs(e1-e0)+abs(e2-e1)
c
        result = res
        abserr = err2+err3
c ***jump out of do-loop
        go to 100
   10   e3 = epstab(k1)
        epstab(k1) = e1
        delta1 = e1-e3
        err1 = abs(delta1)
        tol1 = amax1(e1abs,abs(e3))*epmach
c
c           if two elements are very close to each other, omit
c           a part of the table by adjusting the value of n
c
        if(err1.le.tol1.or.err2.le.tol2.or.err3.le.tol3) go to 20
        ss = 0.1e+01/delta1+0.1e+01/delta2-0.1e+01/delta3
        epsinf = abs(ss*e1)
c
c           test to detect irregular behaviour in the table, and
c           eventually omit a part of the table adjusting the value
c           of n.
c
        if(epsinf.gt.0.1e-03) go to 30
   20   n = i+i-1
c ***jump out of do-loop
        go to 50
c
c           compute a new element and eventually adjust
c           the value of result.
c
   30   res = e1+0.1e+01/ss
        epstab(k1) = res
        k1 = k1-2
        error = err2+abs(res-e2)+err3
        if(error.gt.abserr) go to 40
        abserr = error
        result = res
   40 continue
c
c           shift the table.
c
   50 if(n.eq.limexp) n = 2*(limexp/2)-1
      ib = 1
      if((num/2)*2.eq.num) ib = 2
      ie = newelm+1
      do 60 i=1,ie
        ib2 = ib+2
        epstab(ib) = epstab(ib2)
        ib = ib2
   60 continue
      if(num.eq.n) go to 80
      indx = num-n+1
      do 70 i = 1,n
        epstab(i)= epstab(indx)
        indx = indx+1
   70 continue
   80 if(nres.ge.4) go to 90
      res3la(nres) = result
      abserr = oflow
      go to 100
c
c           compute error estimate
c
   90 abserr = abs(result-res3la(3))+abs(result-res3la(2))
     *  +abs(result-res3la(1))
      res3la(1) = res3la(2)
      res3la(2) = res3la(3)
      res3la(3) = result
  100 abserr = amax1(abserr,0.5e+01*epmach*abs(result))
      return
      end
! 15Oct2002 fgtok -s qag.table "quadpack renames for imbedding in TRANSP system"

      MODULE agcu_mod
      INTERFACE 
	subroutine agcuset(xarray,yarray,maxa,nx,ny) 
        implicit none
	integer :: maxa,nx,ny
	real, dimension(maxa,*), target :: xarray
	real, dimension(maxa,*), target :: yarray
        end subroutine agcuset

        subroutine agcuxy(xraw,yraw,xdat,ydat)
        implicit none
	real xraw,yraw,xdat,ydat
        end subroutine agcuxy
      END INTERFACE
      END MODULE agcu_mod

C******************** START FILE UFNPARS.FOR ; GROUP UFNPARS *************
C-----------------------------------------------------------
C  UFNPARS
C
C  parse a filename into its parts (dir, disk, prefix, shot no., suffix)
C
      SUBROUTINE UFNPARS(ZNAME,ZDEV,ZFDIR,ZPRE,ISHOT,ZEXT,IER)
C
      use UFILES
      implicit none
 
      character*(*) ZNAME   ! INPUT filename spec
      character*(*) ZDEV    ! OUTPUT disk spec
      character*(*) ZFDIR   ! OUTPUT dir spec
      character*(*) ZPRE    ! OUTPUT filename prefix
      integer ISHOT         ! OUTPUT shot no. in filename (-1 if none)
      character*(*) ZEXT    ! OUTPUT filename .ext
      integer IER           ! OUTPUT completion code, 0=OK
C
      character*10 zdigs
 
      integer  ILPRE, ILEXT,  ILDEV, ILDIR, ILNAME, ilminp, irbrk
      integer  ic,    IST,    IBLANK,IDLMAX,ILDOT,  IDLM,   jshot
      integer  idigs, idec,   idlm1, ick,   IL,     ICLN,   ilinp
      integer  ier1,  ier2,   ier3,  ier4
C
      data zdigs/'0123456789'/
C
C----------------------------------------------------
C
      ILPRE=LEN(ZPRE)
      ILEXT=LEN(ZEXT)
      ILDEV=LEN(ZDEV)
      ILDIR=LEN(ZFDIR)
C
      ILNAME=LEN(ZNAME)
C
C  defaults:
C
      zpre=' '
      zext=' '
      zdev=' '
      zfdir=' '
C
      ishot=-1
C
      ier=0
C
C-------------------------
C
      if (zname(1:4) .eq. 'MDS+') go to 5000
C
      ilminp=len(zname)
      irbrk=0
      do ic=ilminp,1,-1
        if(zname(ic:ic).eq.'/') then
          if(irbrk.eq.0) irbrk=ic
        endif
      enddo
      if(irbrk.gt.ildir) then
        call uermsg('%UFNPARS:  directory name too long',zname,1)
        go to 999
      else if(irbrk.eq.0) then
        CALL UFNPAD(' ',1,ZFDIR,'UFNPARS',IER)
        IST=1
      else
        CALL UFNPAD(' ',1,ZFDIR,'UFNPARS',IER)
        ZFDIR(1:IRBRK)=ZNAME(1:IRBRK)
        IST=IRBRK+1
      endif
C
C  PREFIX & SHOT NO.
      IBLANK=INDEX(ZNAME(IST:),' ')+IST-1
      IF(IBLANK.LT.IST) IBLANK=LEN(ZNAME)+1
C
      IDLMAX=IST-1
C
      ILDOT=INDEX(ZNAME(IST:),'.')+IST-1
      IDLMAX=MAX0(IDLMAX,ILDOT)
      IF(ILDOT.LT.IST) ILDOT=LEN(ZNAME)+1
C
      IDLM=MIN0(IBLANK,ILDOT)
C
C  decode shot number
C
      jshot=0
      idigs=0
      idec=1
C
 88   continue
      if(idlm.gt.1) then
         idlm1=idlm-1
         ick=index(zdigs,zname(idlm1:idlm1))
         if((ick.gt.0).and.(idigs.le.5)) then
            idigs=idigs+1
            idlm=idlm-1
            jshot=jshot+idec*(ick-1)
            idec=idec*10
            go to 88
         endif
      endif
C
      if(idigs.gt.0) then
         ishot=jshot
      endif
C
      IF(IDLM.LE.IST) THEN
        CALL UERMSG('%UFNPARS: UFILE NAME PREFIX NOT FOUND',ZNAME,1)
        GO TO 999
      ELSE IF((IDLM-IST).GT.ILPRE) THEN
        CALL UERMSG('%UFNPARS: UFILE NAME PREFIX LENGTH ERROR',ZNAME,1)
        GO TO 999
      ENDIF
      CALL UFNPAD(' ',1,ZPRE,'UFNPARS',IER)
      ZPRE(1:IDLM-IST)=ZNAME(IST:IDLM-1)
C
      IF(IDLM.EQ.IBLANK) then
         call uermsg('%UFNPARS:  no Ufile suffix',zname,1)
         GO TO 999
      endif
      IST=IDLMAX+1
C
C  SUFFIX
      IL=IBLANK-IST
      IF(IL.LE.0) then
         call uermsg('%UFNPARS:  no Ufile suffix',zname,1)
         GO TO 999
      endif
      IF(IL.GT.ILEXT) THEN
        CALL UERMSG('%UFNPARS: UFILE NAME .EXT LENGTH ERROR',ZNAME,1)
        GO TO 1000
      ENDIF
      CALL UFNPAD(' ',1,ZEXT,'UFNPARS',IER)
      ZEXT(1:IL)=ZNAME(IST:IBLANK-1)
C
      GO TO 1000
C
 999  CONTINUE
      ier=1
C
 1000 CONTINUE
C
      RETURN
C
 5000 continue
C MDSplus
C     pre            ext     dev               dir
C MDS+::<server>/Tree(shot)/path              /node
C MDS+::<server>/Tree      /pppl@tok.yr@runid/node
C Server = zpre
      idlm = index(zname,'/')-1
      call ufnpad(zname(1:idlm),idlm,zpre,'UFNPARS>mds: zpre',ier1)
C Tree = zext
      ist = idlm+2
      il = index(zname(ist:),'/') -1
      call ufnpad(zname(ist:ist+il-1),il,zext,
     >            'UFNPARS>mds: zext',ier2)
C path = zdev
      ist = ist+il+1
      icln = index(zname(ist:),'/') -1
      if (icln .le. 0) then      ! no path
         call ufnpad(' ',1,zdev,'UFNPARS>mds: zdev',ier3)
      else
         call ufnpad(zname(ist:ist+icln-1),icln,zdev,
     >        'UFNPARS>mds: zdev',ier3)
      endif
C node = zdir
      ist = ist+icln+1
      il = index(zname(ist:),' ')-1
      if (il .lt. 0) il=ilname
      call ufnpad(zname(ist:il),il-ist+1,zfdir,
     >            'UFNPARS>mds: zdir',ier4)
 
      if ((IER1+IER2+IER3+IER4).GT.0) go to 999
 
      goto 1000
 
      	END
C******************** END FILE UFNPARS.FOR ; GROUP UFNPARS ***************

C******************** START FILE UINDIN.FOR ; GROUP UREAD5 ******************
 
      SUBROUTINE UINDIN(ZFILE,IOUTPT,IER)
 
C----------------------------------------------------------
C& UINDIN   ESTABLISH CONNECTION WITH NEWLY NAMED INDIRECT I/O FILE
C  PARSE AND PASS DOWN PARAMETER VALUES IF ANY ARE SUPPLIED
C
C  FORM OF INPUT LINE IS
C  "@<FILENAME>"  (NO PARAMETERS)
C    OR
C  "@<FILENAME>/PARM1=VAL1/PARM2=VAL2/.../PARMN=VALN
C                 (N PARAMETERS)
C  THIS ROUTINE IS CALLED WHEN THE FIRST CHARACTER OF THE INPUT
C  FILE IS "@" (MIDAT)
C
C---
C  Mod tbt May 1995 -- Increased length of Filename to 130 from 64.
C  mod tbt May 1995 -- Want to allow for unix machines
C                      @"/u/terpstra/filename"/parm1=33/parm2=39
C
C                      Added code to ignore '/' inside ".../..."
C       -- corrected dmc 12 June:  only do this for leading clause
C          in dbl quotes; make it so @file/arg1=val1/arg2="a 2nd arg"
C          works correctly.
C---
C
C  MOD DMC DEC 1989 -- IF INPUT FILE REF HAS /$NEW APPENDED, E.G.
C    "@SCRIPT/$NEW/PARM1=VAL1"
C  THEN FORCE THE INPUT FILE TO BE READ FROM DISK, NOT FROM
C  INTERNAL MEMORY BUFFER.  NOTE THE /$NEW MUST IMMEDIATELY FOLLOW
C  THE FILENAME
C
C  IOUTPT=1:  THIS IS OUTPUT FILE (O.W. IS INPUT)
C
      USE USERIO
      CHARACTER*130 ZFILE               ! 130 arbitrary tbt 5/95
C
      character*1 zbuff(urdbufl)
      logical ilnf(urdbufl)
C
      logical :: ilindi,jlindi
C
C-----------------------------------------------
C
C  ERROR IF NOT FOLLOWED BY FILENAME
C   use urdcapl logical array to identify filename
C   urdcapl(j)=.false. --> cbuff(j:j) is part of filename
C
      zbuff=dbuff
      ilen=ilnurd(cbuff)+2
      ilen=min(urdbufl,ilen)
      ilnf=.TRUE.
      call urdfcap(zbuff,ilnf,ilen)
C
      if(ilnf(2)) then
        WRITE(LUNTRM,9591)
        IER=1
        RETURN
      ENDIF
 9591 FORMAT(' % ZERO LENGTH INDIRECT FILE NAME')
C
C  save NLINDI at entry to this routine
C
      ilindi = nlindi
C
C  find limits of filename
C
      ifnbeg=2
      do ic=2,ncharc
         if(ilnf(ic)) go to 10
      enddo
      ic=ncharc+1
 10   continue
      ifnend=ic-1
C
      ifna=ifnbeg
      ifnb=ifnend
      if(cbuff(ifna:ifna).eq.'"') ifna=min(ifnb,(ifna+1))
      if(cbuff(ifnb:ifnb).eq.'"') ifnb=max(ifna,(ifnb-1))
C
C  CHECK FOR LOCAL PARAMETER DEFINITIONS
      indsl=index(cbuff(ifnend+1:),mslash)
      if(indsl.gt.0) indsl=ifnend+indsl
C
      INEW=0
 
      IF(INDSL.GT.0) THEN
        ILAST=INDSL-1
C
C-------------
        INDSL2=INDEX(CBUFF(INDSL+1:),MSLASH)
        IF(INDSL2.GT.0) THEN
          INDSL2=INDSL+INDSL2
        ELSE
          INDSL2=NCHARC+1
        ENDIF
C  CHECK FOR /$NEW SWITCH
        DO 100 IC=INDSL+1,INDSL2-4
          IF(CBUFF(IC:IC).EQ.'$') GO TO 105
 100    CONTINUE
        GO TO 110
 105    CONTINUE
        IF(CBUFF(IC:IC+3).EQ.'$NEW') INEW=1
 110    CONTINUE
C
C-------------
      ELSE
        ILAST=NCHARC
      ENDIF
C
      INLUNP=MAX0(NLUNIN,NLUNIO)
C  CREATE FILENAME
      CALL URWORD(CBUFF,0,ILENF,ILENR)
      ILENF=MIN0(ILENF,ILAST)
      ILENR=MIN0(ILENR,ILAST)
C
      zfile=cbuff(ifna:ifnb)
      ilf=ifnb-ifna+1
      CALL UFILX(ZFILE,ilf)
C
C  TRY TO OPEN FILE; CHECK FOR PROMPT MISMATCH
C   IF OK RECORD INDIRECT REFERENCE IN OUTPUT FILE
C
      IF(IOUTPT.NE.1) THEN
C  INPUT FILE...
        IF(INEW.EQ.1) THEN
          call ufiget(zfile,-1,ier,ieof)
        ELSE
          call ufiget(zfile,1,ier,ieof)
        ENDIF
      ELSE
C  OUTPUT FILE...
        CALL UIOTOP(ZFILE,IER)
      ENDIF
      IF(IER.NE.0) RETURN
      INLUN=MAX0(NLUNIN,NLUNIO)
C  PARSE AND SAVE VALUES OF LOCAL PARAMETERS (IF ANY)
      IF(INLUN.EQ.INLUNP) THEN
        CALL UERMSG('? UINDIN/UFIGET - UREAD PROGRAMMING ERROR',' ',1)
        IER=1
        RETURN
      ENDIF
C
C  INLINE STRING PARAMETER SYNTAX?
      IF(INDSL.EQ.0) GO TO 250
C  MUST DIRECTLY FOLLOW FILENAME
      IF(INEW.EQ.1) THEN
        INDSL=INDSL2
        ILENR=INDSL2-1
        IF(INDSL.GT.NCHARC) GO TO 250
      ENDIF
      IF((ILENR+1).NE.INDSL) GO TO 250
C
C  DEAL WITH INLINE STRING PARAMETERS
      CALL USPCHK(DBUFF,LBUFF,INDSL,ID1,ID2,ILENR)
      CALL UPPASS(DBUFF,INDSL,ILENR)
      IF(DBUFF(ILENR).EQ.MSLASH) DBUFF(ILENR)=' '
      CALL UFCHAR(DBUFF,MSLASH,INDSL,ILENR)
      IF(INDSL.GT.0) THEN
C
C  if invocation is from command line, make inline parameter assignments global
C
         JLINDI=NLINDI
         NLINDI=ILINDI
         CALL UPMASG(DBUFF,INDSL,ILENR,IER)
         NLINDI=JLINDI
      ENDIF
C
C
C  ROTATE OUT FILENAME
 250  CONTINUE
      CALL UROTOR(ILENR)
C  PUSH REMAINDER OF LINE ONTO TYPEAHEAD BUFFER STACK FOR LATER
C  REFERENCE-- ASSOCIATED WITH PREVIOUS I/O CHANNEL
      AHDBUF(INLUNP)=CBUFF
      IF(NLECHO.AND.(NCHARC.GT.0)) THEN
        WRITE(LUNTRM,2001) AHDBUF(INLUNP)(1:NCHARC)
 2001   FORMAT(
     >' INDIRECT FILE SUCCESSFULLY OPENED, TYPEAHEAD SAVED ON STACK:'/
     >1X,A)
      ENDIF
C
C  CLEAR BUFFER FOR NEW FILE
      CALL UCLEAR
C
 260  CONTINUE
      RETURN
      END
C******************** END FILE UINDIN.FOR ; GROUP UREAD5 ******************

C******************** START FILE UPSSUB.FOR ; GROUP USPARM *************
C===============================================================
C  USPARM   LIBRARY OF SUBROUTINES FOR DEALING WITH 10 CHAR.
C           "STRING" PARAMETERS FOR USE WITH INDIRECT INPUT FILES
C           USED WITH "UREAD.FOR".  EACH PARAMETER IS IDENTIFIED
C           BY SPECIAL CHARACTER "/" FOLLOWED BY UP TO 10
C           ALPHANUMERIC CHARACTERS; EACH PARAMETER HAS A "VALUE"
C           OF UP TO 96 ASCII CHARACTERS; NULL STRING AND LEADING
C           BLANKS NOT ALLOWED
C  REV 10 AUG 81 D. MC CUNE.  MAX OF 96 CHARS IN PARAMETER VALUES
C   NOW SUPPORTED
C
C   EXAMPLE OF USAGE:
C
C   @ZFILE.TMI/NSHOT=12345/NRUN=9876
C
C   OPENS THE FILE "ZFILE.TMI" FOR INDIRECT INPUT, AND ASSOCIATES
C   THE VALUE "12345     " WITH PARAMETER "NSHOT     ", AND
C   "9876      " WITH PARAMETER "NRUN      ".
C
C   WHEN THE LINE
C
C   /NSHOT
C
C   IS ENCOUNTERED IN "ZFILE.TMI" THE SLASH & PARAMETER NAME
C   COMBINATION IS REPLACED BY THE PARAMETER VALUE STRING, AND
C   IT IS THIS VALUE WHICH IS PARSED AS INPUT TO THE MAIN CODE
C   WHICH IS USING "UREAD.FOR" AS INTERACTIVE I/O MANAGER.
C
C  FORMATS:
C   /(NAME)=(VALUE)    :  LOCAL VARIABLE ASSIGNMENT
C                    PARAMETER RECOGNIZED ONLY WHEN INPUT IS FROM
C                    SAME LEVEL (FILE) WHERE PARAMETER WAS DEFINED.
C   /(NAME)==(VALUE)   :  GLOBAL PARAMETER ASSIGNMENT
C                    PARAMETER RECOGNIZED UNTIL EXPLICITLY
C                    DELETED
C   /(NAME)=$DEL       :  DELETE SPECIFIED PARAMETER
C   /$DEL              :  DELETE ALL PARAMETERS (LOCAL + GLOBAL)
C   /$LIS              :  LIST ALL PARAMETERS (LOCAL + GLOBAL)
C
C   /(NAME)            :  FETCH NAMED PARAMETER'S VALUE AND
C                    INSERT INTO INPUT STREAM AT THIS POINT
C
C  D. MC CUNE DECEMBER 11 1980
C
C  AT THIS TIME, ALL PARAMETER REFERENCES OR DEFINITIONS MUST
C  BE INITIATED WITH THE "/" CHARACTER IN THE FIRST CHARACTER
C  POSITION OF AN INPUT LINE, OR DIRECTLY AFTER AN INDIRECT INPUT
C  FILENAME AS IN THE EXAMPLE "@ZFILE" ABOVE.
C
C  REVISIONS:
C    PASSING OF LOCAL PARAMETERS THROUGH INDIRECT INPUT FILE
C    LEVELS SUPPORTED; INVOKED BY FORMAT:
C
C   @ZFILE/PARM1/PARM2/PARM3=VALUE
C
C    IF "ZFILE" IS SUCCESSFULLY OPENED, PARM1 AND PARM2'S VALUES
C   ARE PASSED TO ZFILE'S LEVEL FOR USE THERE AS LOCAL PARAMETERS
C   PARM3'S VALUE IS DEFINED IN LINE AS ABOVE.  IF THE VALUE OF
C   A PARAMETER IS NOT KNOWN OR ASSIGNED IN-LINE, THE TOP-LEVEL
C   (USER OR BATCH CONTROL FILE) IS PROMPTED TO PROVIDE THE
C   MISSING PARAMETER VALUE.
C    PASSED PARAMETERS HANDLED SUBROUTINE "UPPASS"
C
C
C
C==============================================================
C&  UPSSUB   SUBSTITUTE STRING VALUE FOR SPECIFIED UREAD PARAMETER NAME
C
C            THIS ROUTINE CALLED WHEN "/(NAME) (CR)" FORMAT
C    IS DETECTED.   CHECK FOR "/$DEL" FORMAT REQUEST TO DELETE
C    ALL PARAMETERS
C
      SUBROUTINE UPSSUB(ZLINE,LLINE,IFLAG,ZVAL)
C
      USE USERIO
C
      CHARACTER*1 ZLINE(LLINE),ZC1,ZC2,ZBLANK
      CHARACTER*1 ZZLINE(132)
      CHARACTER*16 ZNAME
      CHARACTER*96 ZVAL
      CHARACTER*4 ZTES,ZDEL,ZLIS
      EQUIVALENCE(ZTES,ZNAME)
      DATA ZDEL/'$DEL'/
      DATA ZLIS/'$LIS'/
      DATA ZBLANK/' '/
C
      IFLAG=0
      IND1=2
      IND2=LLINE
      CALL USPLNM(ZLINE,LLINE,IND1,IND2,ZNAME,IER)
      IF(IER.NE.0) GO TO 500
C  CHECK FOR DELETION ORDER
      IF(ZTES.NE.ZDEL) GO TO 50
C  DELETE ALL SYMBOLS
      CALL USPCLR
      GO TO 500
C  NOT A DELETE; CHECK FOR RECOGNITION OF NAME
 50   CONTINUE
C  CHECK FOR LISTING REQUEST
      IF(ZTES.NE.ZLIS) GO TO 52
      CALL UPDISP
      GO TO 500
 52   CONTINUE
      CALL USPGET(ZNAME,ZVAL,IER)
C  FOUND VALUE ?
      IF(IER.EQ.0) GO TO 100
C  NO.  PROMPT USER; IN BATCH READ FROM TOP LEVEL (COMMAND FILE)
C       AND EXPECT ANSWER IN FORM "/=(VALUE)" OR HALT PROGRAM
C
      CALL UPQUER(ZNAME,ZZLINE,132,ZVAL)
      PRMSUB=ZNAME
      IFLAG=0
      RETURN
C------
C---------
C  NORMAL PATH:  PARAMETER SUCCESSFULLY TRANSLATED
C
 100  CONTINUE
      IFLAG=0
      PRMSUB=ZNAME
      RETURN
C---------
C  EXIT AFTER DELETION OF PARAMETERS ORDER
C
 500  CONTINUE
      IFLAG=1
C  TYPEAHEAD-- ROTATE OUT LIST/DELETE REQUEST
      CALL UROTOR(IND2)
      CALL UDECOD
C
      RETURN
      	END
C******************** END FILE UPSSUB.FOR ; GROUP USPARM ******************

subroutine frantic_gausse(A,IROW,N,M,X,EPS,IW)
  !	11/7/76
  !	THIS PROGRAM WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
  !	PLASMA PHYSICS LAB.  THIS ROUTINE WILL SOLVE A SYSTEM OF LINEAR
  !	EQUATIONS BY USING GAUSS ELIMATION AND BACKWORD SUBSITUTION.
  !	parameter LIST:
  !	A - THE N BY M AUGMENTED MATRIX WITH THE RIGHT HAND VECTOR
  !		IN COLUMN M.
  !	IROW - THE ROW DIMENSION OF A AS DEFINED BY THE CALLING PROGRAM.
  !	N - THE # EQUATIONS.
  !	M - N+1.
  !	X - SOLUTION VECTOR WITH N ELEMENTS.
  !	EPS - EVERY PIVOT ELEMENT MUST BE GREATER THAN EPS.  if
  !		A PIVOT ELEMENT IS SMALLER THE EQUATIONS ARE
  !		DECLARED SINGULAR.
  !	IW - THE LOGICAL UNIT USED FOR PRINTING.
  !	NOTE THAT THE MATRIX A IS DESTROYED.
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit none
  ! Argument variables:
  integer,  intent(in) :: irow ! The row dimension of A as defined by the calling program
  integer,  intent(in) :: n    ! The number of equations
  integer,  intent(in) :: m    ! The number of equations plus 1
  real(fp), intent(in) :: eps  ! Minimum value of a pivot point
  integer,  intent(in) :: iw   ! Unit number for printing
  real(fp), dimension(irow,m), intent(inout) :: A ! The n by m augmented matrix with right hand vector in column n
  real(fp), dimension(n),      intent(inout) :: x ! Solution vector with n elements
  ! Local variables:
  integer :: nn,j,maxrow,i,jj,k,l1
  real(fp) :: amax,absa,store,anorm,asub,sum
  !============
  NN=N-1
  !	I FIRST REDUCE MATRIX A.
  do J=1,NN
    !	MAXROW WILL GIVE THE ROW IN WHICH THE MAXIMUM ELEMENT WAS FOUND.
    MAXROW=J
    AMAX=ZERO
    !	I NOW SEARCH FOR THE MAXIMUM ELEMENT IN ROW J AND GREATER.
    do I=J,N
      ABSA=ABS(A(I,J))
      if(ABSA-AMAX) 270,270,260
260   AMAX=ABSA
      MAXROW=I
270   continue
    end do
    !	NOW THE MAXIMUM ELEMENT IN COL. J HAS THE VALUE OF AMAX AND
    !	IS IN ROW=MAXROW.
    !	I NOW CHECK TO SEE if EQUATIONS ARE SINGULAR.
    if(AMAX.GT.EPS) GO TO 275
    WRITE(IW,50) MAXROW,J
50  FORMAT(1X,'A PIVOT ELEMENT WAS FOUND TO BE LESS THAN EPS', &
         ' THE ELEMENT IS (',I3,',',I3,')')
    !  INSERT CALL TO TRANSP abort ROUTINE
    write(iw,*) ' [... error in GAUSSE ...]'
    call bad_exit
    !	if MAXROW doES NOT EQUAL J SWITCH ROWS.
275 if(MAXROW.EQ.J) GO TO 290
    do I=J,M
      STORE=A(J,I)
      A(J,I)=A(MAXROW,I)
      A(MAXROW,I)=STORE
    end do
!	ROWS ARE NOW SWITCHED.
!	I NOW NORMALIZE ROW J SO THAT A(J,J)=1.
290 ANORM=A(J,J)
    do I=J,M
      A(J,I)=A(J,I)/ANORM
    end do
    !	I NOW SUBTRACT ROW J FROM ROWS GREATER THEN J SUCH THAT
    !	THERE ARE ZEROS IN COLUMN J.
    JJ=J
300 JJ=JJ+1
    ASUB=A(JJ,J)
    do I=J,M
      A(JJ,I)=A(JJ,I)-A(J,I)*ASUB
    end do
    if(JJ.LT.N) GO TO 300
  end do
  !	I NOW PREFORM BACKWARD SUBSITION.
  X(N)=A(N,M)/A(N,N)
  do K=1,NN
    SUM=ZERO
    L1=N-K
    do I=1,K
      SUM=SUM+A(L1,L1+I)*X(L1+I)
    end do
    X(L1)=A(L1,M)-SUM
  end do
  return
end subroutine frantic_gausse

C******************** START FILE DPLNST.FOR ; GROUP DPLOTT *************
C-----------------------------------------------------------------
C  DPLNST
C  SET LINE TYPE FOR DPLOT1  SOLID (1) OR VARIOUS DASHED STYLES
C  SEE THE TEKTRONIX MANUALS (AG, TERMINAL CONTROL SYS)
C
C  MAY SUBSTITUTE SYMBOL PLOTTING FOR LINE PLOTTING (NEW 8/87 DMC)
C
C  INPUT M BTW 1 AND 10!  (SGLIB/GFLIB HISTORY)
C
      SUBROUTINE DPLNST(M,IVAL,ISYM,SIZE)
C
      INCLUDE 'GFTIC'
C
      if(.not.init_gftic) call gftic0
C
      IM=MIN0(10,MAX0(1,M))
      IF(KLINTP.GE.0) THEN
C
        IM=IM+KLINTP
        IF((M.GE.1).AND.(M.LE.5)) THEN
          IF(IM.GT.5) IM=IM-5
        ELSE
          IF(IM.GT.10) IM=IM-5
        ENDIF
C
        IM=MAX0(1,MIN0(10,IM))
        IVAL=LNSTYL(IM)
C
        CALL LINE(IVAL)
        ISYM=0
        SIZE=0.0
C
      ELSE
        IVAL=-4
        IF(IM.LE.5) THEN
          IM=12+IM
        ELSE
          IM=7+IM
        ENDIF
C
        ISYMTP=KSYMTP
        ZSIZE=SGSYSZ
        KSYMTP=KSYLTP
        SGSYSZ=SGSLSZ
C
        CALL DPSYST(IM,ISYM,SIZE)
C
        SGSYSZ=ZSIZE
        KSYMTP=ISYMTP
C
      ENDIF
C
      RETURN
      END
C******************** END FILE DPLNST.FOR ; GROUP DPLOTT ***************
C
      SUBROUTINE DPLNST0(M,IVAL,ISYM,SIZE)
C same as DPLNST but with small size for individual points
C
      INCLUDE 'GFTIC'
C
      if(.not.init_gftic) call gftic0
C
      IM=MIN0(10,MAX0(1,M))
      IF(KLINTP.GE.0) THEN
C
        IM=IM+KLINTP
        IF((M.GE.1).AND.(M.LE.5)) THEN
          IF(IM.GT.5) IM=IM-5
        ELSE
          IF(IM.GT.10) IM=IM-5
        ENDIF
C
        IM=MAX0(1,MIN0(10,IM))
        IVAL=LNSTYL(IM)
C
        CALL LINE(IVAL)
        ISYM=0
        SIZE=0.0
C
      ELSE
        IVAL=-4
        IF(IM.LE.5) THEN
          IM=12+IM
        ELSE
          IM=7+IM
        ENDIF
C
        ISYMTP=KSYMTP
        ZSIZE=SGSYSZ
        KSYMTP=KSYLTP
        SGSYSZ=SGSLSZ
C
        CALL DPSYST0(IM,ISYM,SIZE)
C
        SGSYSZ=ZSIZE
        KSYMTP=ISYMTP
C
      ENDIF
C
      RETURN
      END
C******************** END FILE DPLNST.FOR ; GROUP DPLOTT ***************

subroutine rf_egridtr(eminev,zdemin,egrmax,maxen,enerev)
  !
  !  real(fp) interface
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one
  implicit none
  real(fp), intent(in) :: eminev      ! min energy (eV) (usually zero)
  real(fp), intent(in) :: zdemin      ! energy step at eminev
  real(fp), intent(in) :: egrmax      ! max energy (eV)
  integer, intent(in) :: maxen      ! no. of grid zones
  real(fp), intent(out) :: enerev(0:maxen) ! energy zone *bdys*
  !
  !  note 0:maxen indexing of enerev!
  !
  !------------------------------------------
  !  for TRANSP (dmc Feb 96) control the max energy of the non-uniform
  !  grid -- mod dmc Jan 1997)
  !
  !  the energy grid is linearly spaced in steps of (zdemin) until the
  !  first step of a logarithmic spacing from the top of the linearly
  !  spaced region is larger than the linear step (zdemin) would be.
  !
  !------------------------------------------
  !
  real(fp) :: zEbase,zErat,deove,zlebase,zlemax,zle
  integer i,i0,ileft
  !
  !------------------------------------------
  !
  enerev(0)=max(ZERO,eminev)
  if(enerev(0).eq.ZERO) then
    enerev(1)=zdemin
    i0=1
  else
    i0=0
  end if

  !  linear part-- until log spacing yields bigger step...

  do
    zEbase=enerev(i0)
    zErat=egrmax/zEbase
    ileft=maxen-i0
    deove=exp(log(zErat)/ileft)
    if(zEbase*(deove-ONE).lt.zdemin) then
      enerev(i0+1)=enerev(i0)+zdemin
      i0=i0+1
    else
      exit
    end if
  end do

  zlebase = log(zEbase)
  zlemax = log(egrmax)
  do i=i0+1,maxen
    zle=(zlebase*(maxen-i)+zlemax*(i-i0))/(maxen-i0)
    enerev(i)=exp(zle)
  end do
!
  return
end subroutine rf_egridtr

!-----------------------------
subroutine rf_egridtr_real(eminev,zdemin,egrmax,maxen,enerev)
  !
  !  REAL interface
  !
  use iso_c_binding, only: dp => c_double, sp => c_float
  implicit none
  real(sp), intent(in) :: eminev        ! min energy (eV) (usually zero)
  real(sp), intent(in) :: zdemin        ! energy step at eminev
  real(sp), intent(in) :: egrmax        ! max energy (eV)
  integer, intent(in) :: maxen      ! no. of grid zones
  real(sp), intent(out) :: enerev(0:maxen) ! energy zone *bdys*
  !
  real(dp) :: zeminev,zegrmax,zzdemin
  real(dp) :: zenerev(0:maxen)
  !
  zeminev=eminev
  zzdemin=zdemin
  zegrmax=egrmax
  !
  call rf_egridtr(zeminev,zzdemin,zegrmax,maxen,zenerev)
  !
  enerev=zenerev
  !
  return
end subroutine rf_egridtr_real

      subroutine parcopy(npcopy_comm,myid,read_id,write_id,inputfile, &
           outputfile,ierr)

      implicit none

      integer :: npcopy_comm  ! MPI communicator
      integer :: myid         ! current process ID
      integer :: read_id      ! ID of process that should READ file
      integer :: write_id     ! ID of process that should WRITE file

      character*(*),intent(in) :: inputfile,outputfile  ! filenames

      integer, intent(out) :: ierr

      !---------------
      integer :: portlib_parcopy
      logical :: idebug = .FALSE.
      !---------------

#include "fpreproc/byte_declare.h"

      byte_declare cinput(1+len(inputfile))
      byte_declare coutput(1+len(outputfile))

      if(idebug) then
         if(myid.eq.read_id) then 
            write(0,*) ' I, ',myid,' am reader: '
            write(0,*) '     inputfile: '//trim(inputfile)
            write(0,*) '    outputfile: '//trim(outputfile)
         endif
         if(myid.eq.write_id) then 
            write(0,*) ' I, ',myid,' am writer: '
            write(0,*) '     inputfile: '//trim(inputfile)
            write(0,*) '    outputfile: '//trim(outputfile)
         endif
      endif

      call cstring(inputfile(1:len_trim(inputfile)),cinput,'2C')
      call cstring(outputfile(1:len_trim(outputfile)),coutput,'2C')

      ierr = portlib_parcopy(npcopy_comm,myid,read_id,write_id,cinput,coutput)

      return 
!     stop
      end
!

C******************** START FILE UFHDCK.FOR ; GROUP UFILES *************
C--------------------------------------------------------------
C  UFHDCK
C  READ HEADER OF UFILE AND RETURN STATISTICAL INFORMATION
C
 
      SUBROUTINE UFHDCK(ILUN,INFO,IER)
 
 
C  Updated:
C    10/12/12 CLF - Comment out HDF
C    07/30/97 CLF - Added hdf support
C    08/24/93 TBT - Added call to UFAHED2 for format - put in INFO(7)
C
C  INPUT:
C    ILUN -- L.U.N. OF A JUST - OPENED  UFILE
C
C  OUTPUT:
C    INFO -- INFORMATION BLOCK
C    INFO(1)=FILE DIMENSIONALITY
C    INFO(2)=TOTAL # OF WORDS IN DEPENDENT DATA ARRAY
C    INFO(3)=SIZE OF FIRST DIMENSION OF DATA ARRAY
C    INFO(4)=SIZE OF SECOND DIMENSION OF DATA ARRAY (IF APPLICABLE)
C     ...
C    Info(7)= 0 if Pre 8/93 Data format - =1 if 8/93 format.
C    INFO(8)=NUMBER OF SCALARS IN DATA FILE
C
C    IER = 0 IF ROUTINE COMPLETES EXECUTION SUCCESSFULLY
C
      USE UFILES
C
      INTEGER INFO(8)
C
      CHARACTER*10 ZSDATE,ZWDATE
      CHARACTER*4 IDEV
      CHARACTER*30 ZBUFL,ZBUFI(8)
C
      character*128 znode
C
      CHARACTER*64 ERRSTR
C
      Integer Iformat
C----------------------------------------------------------------------
C
      IER=0
      DO 5 I=1,8
        INFO(I)=0
 5    CONTINUE
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UFHDCK    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.3) THEN
        CALL UERSTA(ICHAN,'UFHDCK    ')
        GO TO 9000
      ENDIF
C
C  SWITCH FOR COMPRESSED BINARY OR ASCII READ DETERMINED AT OPEN TIME
C
      KMPRS=UFCPRS(ICHAN)
      if(kmprs.eq.-1) then
         ikmprs=-1
C----------------------------------------
C  MDS+ data access
C
         call ufmds_rhdr(ichan,idev,zsdate,ishot,idim,znode,iln,
     >        iproc, ier)
         if(ier.eq.1) go to 9000
C
C----------------------------------------
C
      else IF(KMPRS.EQ.0) THEN
        IKMPRS=0
        CALL UFAHED2(ILUN,ISHOT,IDEV,IDIM,KMPRS,ZWDATE,ZSDATE,0,
     1                 Iformat,IERH)
        Info(7) = Iformat
        IF(IERH.NE.0) GO TO 8999
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999)
     >      ISHOT,IDEV,IDIM,IKMPRS,ZWDATE,ZSDATE
      else if(kmprs.eq.2) then
         call ufbhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
         if(ierh.ne.0) go to 8999
C      else if(kmprs.eq. 3) then
C         call uhdfhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
C         if(ierh.ne.0) go to 8999
      else if(kmprs.eq. 4) then
         call ucdfhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
         if(ierh.ne.0) go to 8999
      ENDIF
C
      INFO(1)=IDIM
C
      IF(KMPRS.NE.IKMPRS) THEN
        WRITE(UFELUN,*) ' % UFHDCK INTERNAL FLAG ERROR KMPRS, IKMPRS =',
     >        KMPRS,IKMPRS
        go to 8999
      ENDIF
C
C  SHOT CHECK
C
      if(lshotn(ichan)) then
         IF(ISHOT.NE.UFSHOT(ICHAN)) THEN
            IF((UFILEV/10).GE.1)
     >          WRITE(UFELUN,9011) ISHOT,UFSHOT(ICHAN)
 9011       FORMAT(
     >  ' % SHOT NUMBER ',I6,' IN FILE NOT SAME AS SHOT NUMBER ',I6,
     >  ' IN FILENAME')
         ENDIF
      endif
C
C    READ ASSOCIATED SCALAR QUANTITIES
C
      ERRSTR='ASSOCIATED SCALAR DATA'
C
      if (kmprs .eq. -1) then
         call ufmds_dim(ichan,idim,info(3),nsca,znode(1:iln),ier)
         IF(IER.NE.0) GO TO 8999
         INFO(8)=NSCA
C      else if (kmprs .eq. 3) then
C         call uhdfdim(ilun,idim,info(3),nsca,iproc,ier)
C         IF(IER.NE.0) GO TO 8999
C         INFO(8)=NSCA
      else if (kmprs .eq. 4) then
         call ucdfdim(ilun,idim,info(3),nsca,iproc,ier)
         IF(IER.NE.0) GO TO 8999
         INFO(8)=NSCA
      else
         CALL UFNSRD(KMPRS,ILUN,NSCA,IERR)
         IF(IERR.NE.0) GO TO 8999
C
         INFO(8)=NSCA
C
         DO 100 ISC=1,NSCA
            IF(KMPRS.EQ.1) THEN
      	 READ(ILUN,ERR=9000,END=9000) ZVAL,ZBUFL
            ELSE IF(KMPRS.EQ.0) THEN
      	 READ(ILUN,3019,ERR=9000,END=9000) ZVAL,ZBUFL
 3019 	 FORMAT(1X,1PE11.4/1X,A30)
            else if(kmprs.eq.2) then
      	 call ubrfcmp(ilun,zval,1,ier)
      	 if(ier.ne.0) go to 9000
      	 call ubrchar(ilun,zbufl,ier)
      	 if(ier.ne.0) go to 9000
            ENDIF
 100     CONTINUE
      end if
C
      IF(INFO(1).EQ.0) GO TO 5000 ! DONE IF ITS A SCALAR UFILE
C
      ERRSTR='DATA COORDINATE LABELS'
C
      INAXES=INFO(1)+1
C
      IF(KMPRS.EQ.0) THEN
        DO 200 ID=1,INAXES
          READ(ILUN,3003,END=8999,ERR=8999) ZBUFL
 3003     FORMAT(1X,A30)
 200    CONTINUE
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999) (ZBUFI(IJ),IJ=1,INAXES)
      else if(kmprs.eq.2) then
         do id=1,inaxes
            call ubrchar(ilun,zbufl,ier)
            if(ier.ne.0) go to 8999
         enddo
      ENDIF
C
C  SIZES OF DIMENSIONS
C
      ERRSTR='DATA PROCESSING CODE + NUMBER OF POINTS'
      IF(KMPRS.EQ.0) THEN
        READ(ILUN,3006,END=8999,ERR=8999) IPROC
 3006   FORMAT(1X,I1)
        DO 250 ID=1,INFO(1)
          IDI=ID+2
          READ(ILUN,3017,END=8999,ERR=8999) INFO(IDI)
 3017     FORMAT(1X,I10)
 250    CONTINUE
      ELSE IF(KMPRS.EQ.1) THEN
        ID1=3
        ID2=2+INFO(1)
        READ(ILUN,END=8999,ERR=8999) IPROC,(INFO(IDI),IDI=ID1,ID2)
      else if(kmprs.eq.2) then
        call ubr3int(ilun,iproc,ier)
        if(ier.ne.0) go to 8999
        do id=1,info(1)
           idi=id+2
           call ubr3int(ilun,info(idi),ier)
           if(ier.ne.0) go to 8999
        enddo
      ENDIF
C
C  MULTIPLY OUT TOTAL NUMBER OF WORDS
C
      INFO(2)=1
      DO 300 ID=1,INFO(1)
        INFO(2)=INFO(2)*INFO(2+ID)
 300  CONTINUE
C
C----------
C  NORMAL EXIT
C
 5000 CONTINUE
C
      call ufrwnd_do(ilun,ichan,kmprs,ier)
C
      IER=0
C
C  return error if info(i)=0 for all i
C
      do i=1,8
         if(info(i).ne.0) go to 5100
      enddo
      ier=2
 5100 continue
C
      RETURN
C----------
C  ERRORS
C
 8999 CONTINUE
      WRITE(UFELUN,9899) ERRSTR
 9899 FORMAT(' ? *FATAL* END OF FILE OR READ ERROR ON UFILE READ:'/
     >    6X,A)
C
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ? DATA NOT READ DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      IER=1
      UFSTAT(ICHAN)=5
      RETURN
      	END
C******************** END FILE UFHDCK.FOR ; GROUP UFILES ******************

C&  URDSPF PROCESS UREAD SPECIAL FCNS ("* COMMAND LINES)
C
C  SPECIAL FUNCTIONS-- SET ECHO, CALL FOR HELP PACKAGE
C  SET EXPERT MODE, TURN OFF ECHO, TURN OFF EXPERT MODE
C
C  COMMAND FROM FILE:IER SET ONLY FOR UNRECOGNIZED COMMAND
C   THIS WILL BE RETURNED TO CALLER FOR PARSE
C
      SUBROUTINE URDSPF(IER)
c
#ifdef __NAGWARE
      use f90_unix_proc
#endif
c
      USE USERIO
C
      CHARACTER*1 ZATTY,ZACMD
C
      CHARACTER*4 ZZANS
C
      CHARACTER*16 ZKEYWD
      character(len=128) :: zcmd
C
      LOGICAL ILHOLD,il1lin
C
*** Add next variable - jpj@JET/PPPL 23-feb-1993
      Integer istatsys
C
C-----------------------------
C
      ILHOLD=NLHOLD
C
      IER=0
C
      NLHOLD=.FALSE.
C
      ILFILN=INDEX(XFILE(NLUNIN),' ')-1
      IF(ILFILN.LE.0) ILFILN=LFILN
C
C  CODE HERE MAKES IT SO THAT "* C" IS NOT SAME AS "*C"
C    NO IMBEDDED BLANKS IN COMMANDS
      ZACMD=CBUFF(2:2)
      call uupper(ZACMD)
      CALL UROTOR(1)
      CALL UDELIM(ZACMD,ISTAT)
      IF(ISTAT.GT.0) GO TO 20
C
      IFCN=JXUOPC('ACDEFXNHJRSTPU$',ZACMD)
      IF(IFCN.NE.0) GO TO 50
C-----
 20   CONTINUE
      IF(NLECHO) WRITE(LUNTRM,9001) ZACMD
 9001 FORMAT(
     >   ' % NOT A UREAD FUNCTION, "*',A1,'", TYPE "*H FOR HELP.')
C  REINSERT ASTERISK, RETURN TO CALLER
      IER=1
      CALL URDTTI('*')
      GO TO 2000
C-----
 50   CONTINUE
C
C              A  C  D   E   F   X   N   H   J   R   S   T
      GO TO (80,90,100,200,250,300,400,500,600,700,800,900,
     >         1000,1100) IFCN
C              P    U
C
 80   CONTINUE
      IF(LCMDIN.EQ.2) THEN
        IER=1
        GO TO 2000
      ENDIF
C
C immediate exit with no verification prompt: "*A!"
C
      IF(CBUFF(2:2).eq.'!') THEN
        CALL UEXITA(0)
        CALL URDABO
      ENDIF
C
C  *A [MSG]  ABORT REQUEST FROM INDIRECT INPUT FILE
C
      IF(NCHARC.GT.1) WRITE(LUNTRM,3901)
     >     XFILE(NLUNIN)(1:ILFILN),CBUFF(2:NCHARC)
      IF(IBATCH.EQ.1) THEN
        CALL UEXITA(0)
        CALL URDABO
      ENDIF
C
      CALL UPROMTX(
     >   ' "*A" INPUT REQUESTS PROGRAM HALT, ENTER "Y" TO VERIFY: ',0)
      CALL URDSTT('VERIFICATION (Y/N)',ZZANS)
C
      CALL UCLEAR
C
      ZATTY=ZZANS(1:1)
      IF((ZATTY.EQ.'Y').OR.(ZATTY.EQ.'y')) THEN
        CALL UEXITA(0)
        CALL URDABO
      ELSE
C  TREAT AS END OF INDIRECT INPUT FILE
        IF(NLINDI) CALL URDEOF(1)
      ENDIF
      GO TO 2000
C-------------------------------
C  *C  CREATE SUBPROCESS
C
 90   CONTINUE
      IF(NCHARC.GT.2) THEN
        WRITE(LUNTRM,3001) CBUFF(2:NCHARC)
 3001   FORMAT(' % UREAD (*C) CREATING SUBPROCESS "',A,'"')
        zcmd = 'csh '//CBUFF(2:NCHARC)
        call execute_command_line(zcmd,exitstat=istatsys)
        write(luntrm,'(1x)')
      ELSE
        IF((IBATCH.EQ.1).OR.(NLINDI).or.(NLJAVA)) THEN
          WRITE(LUNTRM,3002)
 3002     FORMAT(
     >' ? UREAD:  CANNOT SPAWN INTERACTIVE SUBPROCESS IN BATCH OR '/
     >'   FROM INDIRECT INPUT FILE OR FROM JAVA CLIENT')
        ELSE
          WRITE(LUNTRM,3003)
 3003     FORMAT(
     >' % UREAD (*C) CREATING INTERACTIVE SUBPROCESS'/
     >'   LOGOUT TO RETURN TO PROGRAM CONTROL')
          zcmd = 'csh -f'//char(0)
          call execute_command_line(zcmd,exitstat=istatsys)
          write(luntrm,'(1x)')
        ENDIF
      ENDIF
C
      CALL UCLEAR
      GO TO 2000
C
 100  CONTINUE
C  *D
      NLECHO=.FALSE.
      CALL UROTOR(1)
      IF(NLXOUT) WRITE(LUNTRM,2011)
 2011 FORMAT(' *D DEFAULT ECHO INVOKED (ECHO ONLY TTY INPUT)')
      GO TO 2000
C
C *E
 200  CONTINUE
      NLECHO=.TRUE.
      CALL UROTOR(1)
      IF(NLXOUT) WRITE(LUNTRM,2001)
 2001 FORMAT(' *E ECHO MODE INVOKED; ENTER *D TO TERMINATE IT')
      GO TO 2000
C
 250  CONTINUE
C
C  *F - OPEN FILES LIST COMMAND
      irotor=1
      CALL URSTAT
      CALL UROTOR(irotor)
      GO TO 2000
C
 300  CONTINUE
      IF(NLXOUT) WRITE(LUNTRM,2002)
 2002 FORMAT(' *X EXPERT MODE INVOKED; ENTER *N FOR NOVICE MODE')
      NLXPER=.TRUE.
      CALL UROTOR(1)
      GO TO 2000
C
 400  CONTINUE
      IF(NLXOUT) WRITE(LUNTRM,2002)
 2012 FORMAT(' *N MODE INVOKED; FULL MENU PROMPTING')
      NLXPER=.FALSE.
      CALL UROTOR(1)
      GO TO 2000
C
 500  CONTINUE
      WRITE(LUNTRM,'('' %URDSPF:  online help not available'')')
      write(luntrm,*) '  (point web browser at: ',
     >   'http://w3.pppl.gov/~pshare/help/uread_hlp.html )'
      CALL UROTOR(1)
      GO TO 2000
C
 600  CONTINUE
C
C  dmc DEC 2009: added *J:<var-name>:<filename> support
C    (echo value of variable to a file)
C
      if(cbuff(2:2).eq.':') then
         call urdspf_varout(cbuff(3:))
         call uclear
         go to 2000
      else
         GO TO 500
      endif
C
C  *R
 700  CONTINUE
      IF(NLECHO) WRITE(LUNTRM,2701)
 2701 FORMAT(' % PROMPT MISMATCH FULL ERROR MESSAGE RESTORED')
      LPMMSG=1
      CALL UROTOR(1)
      GO TO 2000
C
C  *S
 800  CONTINUE
      IF(CBUFF(1:2).EQ.'S*') THEN
        IF(NLXOUT) WRITE(LUNTRM,27021)
27021   FORMAT(
     >' % UREAD PROMPT MATCH CHECKING SUSPENDED, ENTER *R TO RESTORE')
        LPMMSG=-1
        CALL UROTOR(2)
      ELSE
        IF(NLECHO) WRITE(LUNTRM,2702)
 2702   FORMAT(' % PROMPT MISMATCH ERROR MESSAGE TURNED OFF')
        LPMMSG=0
        CALL UROTOR(1)
      ENDIF
      GO TO 2000
C
C  *T
 900  CONTINUE
      IF(LCMDIN.EQ.2) THEN
        WRITE(LUNTRM,3905) CBUFF(2:MAX0(2,NCHARC))
 3905   FORMAT(/' MESSAGE FROM UREAD COMMAND INPUT:'/3X,A/)
        CALL UCLEAR
        GO TO 2000
      ENDIF
      WRITE(LUNTRM,3901)
     >     XFILE(NLUNIN)(1:ILFILN),CBUFF(2:MAX0(2,NCHARC))
CT	CALL UPAUST(1)
      CALL UCLEAR
      GO TO 2000
 3901 FORMAT(' MESSAGE FROM:  "',A,'":'/3X,A/)
C
C------------------------------------
C
 1000 CONTINUE
C
C  *P  -- REASSIGN SGLIB PLOT DEVICE
      IF(NTTYP.LT.0) THEN
        CALL UERMSG(
     >'?UREAD/URDSPF - APPLICATION DOES NOT SUPPORT GRAPHICS I/O',' ',
     >    0)
      ELSE
C
        NPLOTD=0  ! CLEAR GRAPHICS PAGE COUNT
C
        IF(NCHARC.LE.2) THEN
C
C  *P COMMAND WITH NO ARGUMENT
          CALL RINITT('stdout',istatr)
          WRITE(LUNTRM,3101)
 3101 FORMAT(' %UREAD/URDSPF -- REASSIGNING SGLIB OUTPUT TO TTY')
          CALL UCLEAR
        ELSE
C
C  *P COMMAND HAS ARGUMENT - LEFT JUSTIFY
          CBUFF(1:1)=' '
          CALL UDECOD
          INDA=INDEX(CBUFF,' ')-1
          IF(INDA.LE.0) INDA=LEN(CBUFF)
          CALL RINITT(CBUFF(1:INDA),istatr)
          WRITE(LUNTRM,3102) CBUFF(1:INDA)
 3102 FORMAT(' %UREAD/URDSPF -- REASSIGNING SGLIB OUTPUT TO "',
     >         A,'"')
          CALL UROTOR(INDA)
        ENDIF
      ENDIF
      GO TO 2000
C
 1100 CONTINUE
C
C *U OPTION
C
      CALL UROTOR(1)
 1110 CONTINUE
      IF(NCHARC.LE.0) GO TO 2000
C
      CALL CDCOD(ZKEYWD)
C
      IF((ZKEYWD.EQ.'VIDEO').OR.(ZKEYWD.EQ.'REVERSE')) THEN
        CALL UPRSET('R')
      ELSE IF(ZKEYWD.EQ.'BOLD') THEN
        CALL UPRSET('B')
      ELSE IF(ZKEYWD.EQ.'UNDERLINE') THEN
        CALL UPRSET('U')
      ELSE IF(ZKEYWD(1:2).EQ.'NO') THEN
        CALL UPRSET('N')
      ELSE
        CALL UERMSG('%ITEM NOT RECOGNIZED AS *U COMMAND ARGUMENT',
     >      ZKEYWD,0)
      ENDIF
      GO TO 1110
C--------------------------------------------------------------
C
 2000 CONTINUE
      NLHOLD=ILHOLD
      IF(IER.EQ.0) THEN
        IF(NLHOLD) CALL UCLEAR
      ENDIF
      RETURN
      END

      subroutine urdspf_varout(znamf)
c
c  write value of indicated UREAD variable to file.
c    znamf is expected to have syntax <var-name> or <var-name>:<filename>
c    if the former syntax, echo to standard output
c
      use USERIO
c
      character*(*), intent(in) :: znamf
c
      character*16 varnam
      character*96 varval
      character*200 filenam
c
      logical :: ifile
c
      integer :: ilen,icolon,ilun_tmp
c
c--------------------------------
c
      ilen = len(trim(znamf))
      icolon = index(znamf,':')
c
      if(icolon.eq.1) then
         write(luntrm,*) ' ?urdspf "*J:" syntax error:'
         write(luntrm,*) ' *'//trim(cbuff)
         call uclear
         return
      endif
c
      ifile=.FALSE.
c
      if((icolon.gt.0).and.(icolon.lt.ilen)) then
         ifile=.TRUE.
         filenam = znamf(icolon+1:ilen)
         varnam = znamf(1:icolon-1)
         call find_io_unit(ilun_tmp)
      else if(icolon.eq.ilen) then
         varnam = znamf(1:icolon-1)
         ilun_tmp = luntrm
      else
         varnam = znamf(1:ilen)
         ilun_tmp = luntrm
      endif
c
      call uupper(varnam)
      call uspget(varnam,varval,ier)
      if(ier.ne.0) then
         write(luntrm,*) ' ?urdspf "*J:" syntax error:'
         write(luntrm,*) ' *'//trim(cbuff)
         write(luntrm,*) '   variable name unrecognized: '//trim(varnam)
         call uclear
         return
      endif
c
      if(ifile) then
         open(unit=ilun_tmp,file=filenam,status='UNKNOWN',iostat=ier)
         if(ier.ne.0) then
            write(luntrm,*) ' ?urdspf "*J:" syntax error:'
            write(luntrm,*) ' *'//trim(cbuff)
            write(luntrm,*) '   file open error: '//trim(filenam)
            call uclear
            return
         endif
      endif

      write(ilun_tmp,'(1x,a)') trim(varval)

      if(ifile) then
         close(unit=ilun_tmp)
      endif

      return
      end

C******************** START FILE URDERR.FOR ; GROUP UREAD5 ******************
C--------------------------------------------------------------
C&  URDERR  PROCESS READ ERROR IN UREAD INDIRECT INPUT FILE
C
C  ERROR ON READ-- CLOSE FILES
C   ITYP=3 CALL: JUST CLOSE FILES, FEW MESSAGES (CALLER DIRECTED
C   ABORT OF INPUT)
C   ITYP=1 CALL:  FILE READ ERROR
C   ITYP=2 CALL:  FILE OPEN ERROR (DETAILS PREVIOUSLY REPORTED)
C
      SUBROUTINE URDERR(ITYP)
      USE USERIO
C
C  FORMERLY PART OF UREAD SUBROUTINE
C
C  IF ERROR IS CALLED FROM MAIN VIA CALL UREAD('CLOSE$'), RETURN TO MAIN
C  IF ERROR IS DETECTED IN UREAD4 IN INTERACTIVE MODE, RETURN CONTROL
C  TO USER
C  IF IN BATCH MODE, STOP.
      IF(ITYP.EQ.3) THEN
        WRITE(LUNTRM,9501)
 9501 FORMAT(/
     >'  % INDIRECT FILES CLOSED BY CALL UREAD(''CLOSE$'') IN MAIN'/)
      ELSE
C
        IF(ITYP.EQ.1) WRITE(LUNTRM,9005) LUNTIN(NLUNIN)
 9005 FORMAT(' ? READ ERROR ON UNIT ',I3)
C
C=========
C  ERROR DURING INDIRECT READ-- FLUSH INPUT STACK AND RETURN
C  CONTROL TO USER
C
C  INDIRECT INPUT FILE TRACEBACK
        CALL UTRACE
        INUMO=NLUNIO-1
        IF(NLINDO) WRITE(LUNTRM,9503) INUMO
 9503 FORMAT(1X,I2,
     >' OPEN INDIRECT OUTPUT FILE(S) MAY CONTAIN ERROR **')
        CALL UREADY(1)
        IF(IBATCH.EQ.1) THEN
          ILIM=2
          WRITE(LUNTRM,9505)
 9505 FORMAT(' % BATCH MODE: PROGRAM HALTED, SUBR. UREAD'//)
        ELSE
          ILIM=NLUNIO+1
        ENDIF
      ENDIF
C  CLOSE ALL INPUT FILES
      DO 950 JLUN=NLUNIN,ILIM,-1
        CLOSE(UNIT=LUNTIN(JLUN))
 950  CONTINUE
C
      NLINDI=.FALSE.
      NLUNIN=1
      CALL UCLEAR
      IF((ITYP.EQ.2).OR.(IBATCH.EQ.0)) THEN
CXX	  CALL UPROMR
        RETURN
      ENDIF
C
      CALL URDABO
C
      	END
C******************** END FILE URDERR.FOR ; GROUP UREAD5 ******************

!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  VCURSR
      SUBROUTINE R8_VCURSR(
     > ICHAR,R8_X,R8_Y)

      external VCURSR

! argument declarations
      INTEGER ICHAR
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  VCURSR

      CALL VCURSR(
     > ICHAR,X_act,Y_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  MOVEA
      SUBROUTINE R8_MOVEA(
     > R8_X,R8_Y)

      external MOVEA

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
    

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  MOVEA

      CALL MOVEA(
     > X_act,Y_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
      SUBROUTINE R8_MOVER(
     > R8_X,R8_Y)

      external MOVER

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
    

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  MOVER

      CALL MOVER(
     > X_act,Y_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  DRAWA
      SUBROUTINE R8_DRAWA(
     > R8_X,R8_Y)
 
      external DRAWA

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  DRAWA

      CALL DRAWA(
     > X_act,Y_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
      SUBROUTINE R8_DRAWR(
     > R8_DX,R8_DY)
 
      external DRAWR

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_DX
  
 ! floating type, input/output:
      REAL*8 R8_DY
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: DX_act
      REAL :: DX_ref
      REAL :: DY_act
      REAL :: DY_ref

! allocation of working arrays...


! executable code:  copy for input

      DX_act=R8_DX
      DX_ref=R8_DX

      DY_act=R8_DY
      DY_ref=R8_DY

! call to original routine:  DRAWR

      CALL DRAWR(
     > DX_act,DY_act)

! copy back outputs if modified.

      if(DX_act.ne.DX_ref) then
         R8_DX = DX_act
      endif

      if(DY_act.ne.DY_ref) then
         R8_DY = DY_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  POINTA
      SUBROUTINE R8_POINTA(
     > R8_X,R8_Y)

      external POINTA

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  POINTA

      CALL POINTA(
     > X_act,Y_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  DASHA
      SUBROUTINE R8_DASHA(
     > R8_X,R8_Y,LDASH)

      external DASHA

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
      INTEGER LDASH

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  DASHA

      CALL DASHA(
     > X_act,Y_act,LDASH)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  VBGPNL
      SUBROUTINE R8_VBGPNL(
     > R8_X,R8_Y,IBOUND)

      external VBGPNL

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
      INTEGER IBOUND

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  VBGPNL

      CALL VBGPNL(
     > X_act,Y_act,IBOUND)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  WINCOT
      SUBROUTINE R8_WINCOT(
     > R8_X,R8_Y,IX,IY)

      external WINCOT

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  
      INTEGER IX
      INTEGER IY

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  WINCOT

      CALL WINCOT(
     > X_act,Y_act,IX,IY)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  REVCOT
      SUBROUTINE R8_REVCOT(
     > IX,IY,R8_X,R8_Y)

      external REVCOT

! argument declarations
      INTEGER IX
      INTEGER IY
 ! floating type, input/output:
      REAL*8 R8_X
  
 ! floating type, input/output:
      REAL*8 R8_Y
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: X_act
      REAL :: X_ref
      REAL :: Y_act
      REAL :: Y_ref

! allocation of working arrays...


! executable code:  copy for input

      X_act=R8_X
      X_ref=R8_X

      Y_act=R8_Y
      Y_ref=R8_Y

! call to original routine:  REVCOT

      CALL REVCOT(
     > IX,IY,X_act,Y_act)

! copy back outputs if modified.

      if(X_act.ne.X_ref) then
         R8_X = X_act
      endif

      if(Y_act.ne.Y_ref) then
         R8_Y = Y_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  DWINDO
      SUBROUTINE R8_DWINDO(
     > R8_XMIN,R8_XMAX,R8_YMIN,R8_YMAX)

      external DWINDO

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_XMIN
  
 ! floating type, input/output:
      REAL*8 R8_XMAX
  
 ! floating type, input/output:
      REAL*8 R8_YMIN
  
 ! floating type, input/output:
      REAL*8 R8_YMAX
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: XMIN_act
      REAL :: XMIN_ref
      REAL :: XMAX_act
      REAL :: XMAX_ref
      REAL :: YMIN_act
      REAL :: YMIN_ref
      REAL :: YMAX_act
      REAL :: YMAX_ref

! allocation of working arrays...


! executable code:  copy for input

      XMIN_act=R8_XMIN
      XMIN_ref=R8_XMIN

      XMAX_act=R8_XMAX
      XMAX_ref=R8_XMAX

      YMIN_act=R8_YMIN
      YMIN_ref=R8_YMIN

      YMAX_act=R8_YMAX
      YMAX_ref=R8_YMAX

! call to original routine:  DWINDO

      CALL DWINDO(
     > XMIN_act,XMAX_act,YMIN_act,YMAX_act)

! copy back outputs if modified.

      if(XMIN_act.ne.XMIN_ref) then
         R8_XMIN = XMIN_act
      endif

      if(XMAX_act.ne.XMAX_ref) then
         R8_XMAX = XMAX_act
      endif

      if(YMIN_act.ne.YMIN_ref) then
         R8_YMIN = YMIN_act
      endif

      if(YMAX_act.ne.YMAX_ref) then
         R8_YMAX = YMAX_act
      endif

! exit
      return
      end
!----------------------------------------------------------
! r8real -- generated (f90 fixed form) REAL*8 interface to:  SEEDW
      SUBROUTINE R8_SEEDW(
     > R8_XMIN,R8_XMAX,R8_YMIN,R8_YMAX)

      external SEEDW

! argument declarations
 ! floating type, input/output:
      REAL*8 R8_XMIN
  
 ! floating type, input/output:
      REAL*8 R8_XMAX
  
 ! floating type, input/output:
      REAL*8 R8_YMIN
  
 ! floating type, input/output:
      REAL*8 R8_YMAX
  

! local (automatic array) declarations

      integer alloc_stat
      REAL :: XMIN_act
      REAL :: XMIN_ref
      REAL :: XMAX_act
      REAL :: XMAX_ref
      REAL :: YMIN_act
      REAL :: YMIN_ref
      REAL :: YMAX_act
      REAL :: YMAX_ref

! allocation of working arrays...


! executable code:  copy for input

      XMIN_act=R8_XMIN
      XMIN_ref=R8_XMIN

      XMAX_act=R8_XMAX
      XMAX_ref=R8_XMAX

      YMIN_act=R8_YMIN
      YMIN_ref=R8_YMIN

      YMAX_act=R8_YMAX
      YMAX_ref=R8_YMAX

! call to original routine:  SEEDW

      CALL SEEDW(
     > XMIN_act,XMAX_act,YMIN_act,YMAX_act)

! copy back outputs if modified.

      if(XMIN_act.ne.XMIN_ref) then
         R8_XMIN = XMIN_act
      endif

      if(XMAX_act.ne.XMAX_ref) then
         R8_XMAX = XMAX_act
      endif

      if(YMIN_act.ne.YMIN_ref) then
         R8_YMIN = YMIN_act
      endif

      if(YMAX_act.ne.YMAX_ref) then
         R8_YMAX = YMAX_act
      endif

! exit
      return
      end

subroutine namerefs_upper

  use namerefs
  implicit none

  iupper=1  ! case blind compare of names (set to uppercase during compare)

  return
end subroutine namerefs_upper

subroutine namerefs_lower

  use namerefs
  implicit none

  iupper=0  ! case sensitive compare of names

  return
end subroutine namerefs_lower

subroutine namerefs_free

  use namerefs
  implicit none

  if(nmax.gt.0) then
    nmax=0
    nsize=0
    deallocate(clist,chord,nrefs)
  endif

  return
end subroutine namerefs_free

subroutine namerefs_cln(zstr,jlen)

  !  remove non-printable characters from zstr; left justify zstr

  implicit none
  character(len=*), intent(inout) :: zstr  ! string to be "cleaned"
  integer, intent(out) :: jlen          ! non-blank length

  integer i,ilen,iblank,i0,i1,i2

  ilen=len(zstr)
  iblank=ichar(' ')
  i0=0
  i1=0

  !  convert unprintables to blank; find limits of non-blank characters...
  do i=1,ilen

    if(ichar(zstr(i:i)).lt.iblank) then
      zstr(i:i)=' '
    endif

    if(zstr(i:i).ne.' ') then
      if(i0.eq.0) i0=i
      i1=i
    endif

  enddo

  !  length
  jlen=0
  if(i0.gt.0) then
    jlen=i1-i0+1
  endif

  !  left justification
  if(i0.gt.1) then
    do i=1,jlen
      i2=i0+i-1
      zstr(i:i)=zstr(i2:i2)
    enddo
    zstr(jlen+1:i1)=' '
  endif

  !  within the specified length, replace blanks with underscores
  do i=1,jlen
    if(zstr(i:i).eq.' ') zstr(i:i)='_'
  enddo

  return
end subroutine namerefs_cln

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SGLIHI(ZE)
!
!    	  Lithium fudge  tbt 10/94
 
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER i
!============
! idecl:  explicitize implicit real(fp) declarations:
  real(fp) ze2,zemin,zemax,zeuse,zle,zls,zlss,zle2,za2,zans1,zans2
!============
  real(fp) ZE
!
!  ZE IN EV
!  SGHEHI IN !M**2
!
!  JANEV-LANGER-EVANS-POST,
!  ELEMENTARY PROCESSES IN HYDROGEN-HELIUM PLASMAS
!  FIT FOR REACTION 6.1.3,  HE++ + H --> HE++ + H+ + E-
!    IMPACT IONIZATION
!
!  FIT TABLE IN SS 8.1, P. 254
!
!  FIT FOR REACTION 6.1.6,  HE++ + H --> HE+ + H+
!    CHARGE EXCHANGE IONIZATION OF H
!
!  FIT TABLE IN SS 8.1, P. 254
!
!
  real(fp) A613(9)
  real(fp) A616(9)
!
  DATA A613/-4.10809297e+05_fp, 3.53816283e+05_fp,&
       -1.32813190e+05_fp,&
       2.83763762e+04_fp,-3.77436481e+03_fp,&
       3.20045427e+02_fp,&
       -1.68956522e+01_fp, 5.07731711e-01_fp,&
       -6.65008430e-03_fp/
  !
  DATA A616/-4.31514508e+01_fp, 1.15390275e+00_fp,&
       -1.77060767e-03_fp,&
       -4.24923742e-02_fp, 2.55243094e-02_fp,&
       -6.61209712e-03_fp,&
       8.58753895e-04_fp,-5.50161227e-05_fp,&
       1.37393635e-06_fp/
!
!
  LOGICAL EXTRAP
!
!----------------------------------
!  REACTION 6.1.3.
!
  EXTRAP=.FALSE.
!
  ZE2=ZE
!
  ZEMIN=1340.0_fp
  ZEMAX=100000.0_fp
  IF((ZE2.LT.ZEMIN).OR.(ZE2.GT.ZEMAX)) EXTRAP=.TRUE.
!
  ZEUSE=min(ZEMAX,max(ZEMIN,ZE2))
!
  ZLE=log(ZEUSE)
!
  ZLS=A613(9)
  IF(EXTRAP) ZLSS=8.0_fp*A613(9)
!
  DO I=8,1,-1
     ZLS=ZLS*ZLE+A613(I)
     IF(EXTRAP.AND.(I.GE.2)) ZLSS=ZLSS*ZLE+(I-1)*A613(I)
  enddo
!
  IF(EXTRAP) THEN
     ZLE2=log(ZE2)
     ZA2=0.8_fp
     IF(ZE2.LT.ZEMIN) ZLS=ZLS-ZLSS*(ZLE-ZLE2)
     IF(ZE2.GT.ZEMAX) ZLS=ZLS+(ZLE2-ZLE)*(ZLSS-ZA2*(ZLE2-ZLE))
  ENDIF
!
  ZANS1 = EXP(min(50.0_fp,ZLS))
!
!----------------------------------
!  REACTION 6.1.6.
!
  EXTRAP=.FALSE.
!
  ZE2=ZE
!
  ZEMIN=0.6_fp
  ZEMAX=100000.0_fp
  IF((ZE2.LT.ZEMIN).OR.(ZE2.GT.ZEMAX)) EXTRAP=.TRUE.
!
  ZEUSE=min(ZEMAX,max(ZEMIN,ZE2))
!
  ZLE=log(ZEUSE)
!
  ZLS=A616(9)
  IF(EXTRAP) ZLSS=8.0_fp*A616(9)
!
  DO I=8,1,-1
     ZLS=ZLS*ZLE+A616(I)
     IF(EXTRAP.AND.(I.GE.2)) ZLSS=ZLSS*ZLE+(I-1)*A616(I)
  enddo
!
  IF(EXTRAP) THEN
     ZLE2=log(ZE2)
     ZA2=0.0_fp
     IF(ZE2.LT.ZEMIN) ZLS=ZLS-ZLSS*(ZLE-ZLE2)
     IF(ZE2.GT.ZEMAX) ZLS=ZLS+(ZLE2-ZLE)*(ZLSS-ZA2*(ZLE2-ZLE))
  ENDIF
!
  ZANS2 = EXP(min(50.0_fp,ZLS))
!
!------------------------------------------------------------------------------
!
  SGLIHI = ZANS1 + ZANS2  ! SUM OF THE TWO CROSS SECTIONS
!
  RETURN
END FUNCTION SGLIHI
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok

C******************** START FILE CONPLT.FOR ; GROUP CONCTR *************
C==========================================================
C  CONPLT
C    D. MC CUNE 21 MAY 1980
C  DRAW CONTOUR PLOT AND ALLOW USER TO RESCALE
C   USES RCONTR [NBEAM.AGII3] TO GENERATE CONTOURS
C
C  PROVIDES LABELING OF CONTOURS, AUTOSELECTION OF
C  CONTOURS, AND DOMAIN SELECTION
C
C  ARGUMENTS TO "XMIN" SAME AS SUBROUTINE CONCTR, ABOVE
C  ARGUMENS AFTER XMIN:
C   XMIN:   MIN X TO PLOT
C   YMIN:   MIN Y TO PLOT
C   XMAX:   MAX X TO PLOT
C   YMAX:   MAX Y TO PLOT
C   CMIN:   LOWER BOUND ON CONTOURS TO PLOT
C   CMAX:   UPPER BOUND ON CONTOURS TO PLOT
C   NMAX:   MAX # OF CONTOURS TO PLOT
C   ILOGC:  =1==> LINEAR SPACING OF CONTOURS
C   ILOGC:  =2==> PSEUDOLOGARITHMIC SPACING OF CONTOURS
C
C   ZCNTR   ARRAY OF CONTOUR VALUES
C   ACNTR   ARRAY OF 1-CHARACTER SYMBOLS FOR CONTOURS
C
C  ALL THESE VARIABLES EXCEPT ACNTR MAY BE CHANGED HERE.
C
C   NLZMMX-- SET CMIN,CMAX TO MIN , MAX OF FUNCTION ARRAY
C   WITHIN SUBDOMAIN BOUNDED BY XMIN,XMAX,YMIN,YMAX
C
C-------------------------------
C  DMC SEPT 1988 -- TRYING TO CODE AROUND AN RCONTR PROBLEM
C   OF NOT PLOTTING CONTOURS W/ TEST VALUES OF MOD LESS THAT
C   1.E-15 OR SO ...
C-------------------------------
C
      SUBROUTINE CONPLT(X,Z,Y,NX,NZ1,NY,XLAB,ZLAB,YLAB,
     >        XUN,ZUN,YUN,RLAB,IINT,ISMOO,ITYPX,ITYPY,
     >        XMIN,XMAX,CMIN,CMAX,YMIN,YMAX,NMAX,ILOGC,NLZMMX,
     >        ZCNTR,ACNTR,NPAGE)
C
C  DECLARATIONS:
C
C  PASSED ARGS
C
      DIMENSION X(NX),Z(NZ1,NY),Y(NY)
      CHARACTER*(*) XLAB,ZLAB,YLAB,RLAB,XUN,YUN,ZUN
      LOGICAL NLZMMX,LXOUT
C
c------------------  ! local copies...
      real :: zcntr_use(nmax)
      real*8 :: zcntr_r8(nmax)
      real, dimension(:,:), allocatable :: z_use
      real*8, dimension(:,:), allocatable :: z_r8
      real*8, dimension(:), allocatable :: x_r8,y_r8
c------------------
C
      REAL ZCNTR(NMAX)
      CHARACTER*1 ACNTR(NMAX)
C
C PLOT1 COMMON
C
      INCLUDE 'PLOT1MMXB'
C
      integer sts
C
C------------------------------------------
C  START OF EXECUTABLE CODE --
C
      if (allocated(z_use)) deallocate(z_use)
      allocate(z_use(nz1,ny),stat=sts)
      if (allocated(z_r8)) deallocate(z_r8)
      allocate(z_r8(nx,ny),stat=sts)
      if (allocated(x_r8)) deallocate(x_r8)
      allocate(x_r8(nx),stat=sts)
      if (allocated(y_r8)) deallocate(y_r8)
      allocate(y_r8(ny),stat=sts)

C
      if(nz1.gt.nx) then
         z_use(nx+1:nz1,1:ny)=0.0
      endif
      zcntr_use=0.0
      zcntr_r8=0.0d0
      x_r8=x
      y_r8=y
C
C  DMC SEPT 1988
      IMOD=0
      ZACMIN=AMIN1(ABS(CMIN),ABS(CMAX))
      ZACMAX=AMAX1(ABS(CMIN),ABS(CMAX))
      IF((ZACMIN.GT.0.0).AND.(ZACMIN.LT.1.E-15)) THEN
        ZFAC=1.E-15/ZACMIN
        IF(ZACMAX.LT.1.E15/ZFAC) IMOD=1
      ENDIF
C  END DMC SEPT 1988
C
      LUNTRM=LNOUT(0)
C
 10   CONTINUE
C
C  SELECT SET OF CONTOURS
      IF((CMIN.EQ.0.0).AND.(CMAX.EQ.0.0)) THEN
        NRET=NMAX
      ELSE
C  AUTOSELECT CONTOUR TEST VALUES
        CALL CONSEL(LUNTRM,ILOGC,CMIN,CMAX,NMAX,ZCNTR,NRET)
      ENDIF
C
C  FIND INDEX LIMITS RELATIVE TO XMAX,XMIN, ETC. IN DOMAIN
C
      XBND1=XMIN
      XBND2=XMAX
      YBND1=YMIN
      YBND2=YMAX
C
      CALL CONDOM(X,NX,Y,NY,IMIN,IMAX,JMIN,JMAX)
C
      IMINM=MAX(1,IMIN-1)
      IMAXM=MIN(NX,IMAX+1)
      JMINM=MAX(1,JMIN-1)
      JMAXM=MIN(NY,JMAX+1)
C
C  PERFORM CHECK IF LOG AXES
      IF(ITYPX.NE.2) GO TO 4
      IF(XMAX.GT.0) GO TO 3
      ITYPX=1
      GO TO 4
 3    CONTINUE
      IF(XMIN.LE.0) XMIN=1.E-5*XMAX
 4    CONTINUE
C
      IF(ITYPY.NE.2) GO TO 8
      IF(YMAX.GT.0) GO TO 7
      ITYPY=1
      GO TO 8
 7    CONTINUE
      IF(YMIN.LE.0) YMIN=1.E-5*YMAX
 8    CONTINUE
C
C  INITIALIZE PLOT
C
      CALL UBINIT
      CALL GFTICS
      CALL SLIMX(150,750)
      CALL DLIMX(XBND1,XBND2)
      CALL DLIMY(YBND1,YBND2)
      IF(ITYPX.EQ.2) CALL XTYPE(2)
      IF(ITYPY.EQ.2) CALL YTYPE(2)
      CALL CHECK(X,Y)
      CALL GRID
      CALL LABEL(IBASEX(0))
      CALL LABEL(IBASEY(0))
      CALL GFTICX
      CALL SETWIN
C
C  DMC SEPT 1988
C
      IF(IMOD.EQ.1) THEN
        ZZMIN=1.0E37
        ZZMAX=1.0E-37
        DO 20 IC=1,NRET
          IF(ZCNTR(IC).NE.0.0) ZZMIN=AMIN1(ABS(ZCNTR(IC)),ZZMIN)
          ZZMAX=AMAX1(ABS(ZCNTR(IC)),ZZMAX)
 20     CONTINUE
C
        DO 40 IY=1,NY
          DO 30 IX=1,NX
            IF(Z(IX,IY).NE.0.0) ZZMIN=AMIN1(ABS(Z(IX,IY)),ZZMIN)
            ZZMAX=AMAX1(ABS(Z(IX,IY)),ZZMAX)
 30       CONTINUE
 40     CONTINUE
C
        ZFAC=1.E-15/ZZMIN
        IF(ZFAC.LE.1.0) THEN
          IMOD=0
        ELSE
          IF(ZZMAX.GT.1.E38/ZFAC) IMOD=0
        ENDIF
      ENDIF
C
      IF(IMOD.EQ.1) THEN
         zcntr_use(1:nret)=ZFAC*zcntr(1:nret)
         z_use(1:nx,1:ny)=ZFAC*z(1:nx,1:ny)
      else
         zcntr_use=zcntr
         z_use(1:nx,1:ny)=z(1:nx,1:ny)
      ENDIF
      zcntr_r8=zcntr
      z_r8(1:nx,1:ny)=z(1:nx,1:ny)
C
C  END DMC SEPT 1988
C
C  DRAW CONTOURS
      K2=0
      CALL RCONTR(NRET,ZCNTR_use,K2,
     >     Z_use,NZ1,X,IMINM,IMAXM,1,Y,JMINM,JMAXM,1)
C
C  LABEL THE CONTOUR PLOT
      INX=IMAX-IMIN+1
      JNY=JMAX-JMIN+1
      CALL CONLBL(X(IMIN),Z_use(IMIN,JMIN),Y(JMIN),INX,NZ1,JNY,
     >              XLAB,ZLAB,YLAB,
     >              XUN,ZUN,YUN,
     >              RLAB,IINT,ISMOO,ZCNTR_use,ACNTR,NRET,NPAGE)
C
      CALL UPAUST(2)
C
      deallocate(z_use,z_r8)
      RETURN
      	END
C******************** END FILE CONPLT.FOR ; GROUP CONCTR ***************

C******************** START FILE UFDKEY.FOR ; GROUP UFILS0 ******************
C----------------------------------------------------------
C  UFDKEY
C  DELETE KEYWORD ENTRY INDICATED BY ARGUMENT KNDEX FROM KEYWORD
C  LIST.  I.E. USE INTEGER FCN IUFKEY (ABOVE) FIRST TO LOCATE
C  KEYWORD AND THEN CALL THIS ROUTINE
C
C  THE ENTRY IS DELETED FROM THE LIST AND THE LIST LENGTH (NSC)
C  IS DECREMENTED
C
C  NO ERROR MESSAGES
C
      SUBROUTINE UFDKEY(KNDEX,ZSCLIS,ZSCVAL,NSIZ,NSC)
C
      CHARACTER*30 ZSCLIS(NSIZ)
      REAL ZSCVAL(NSIZ)
C
      IF(NSC.LT.KNDEX) RETURN
      IF(KNDEX.LE.0) RETURN
C
      DO 10 I=KNDEX+1,NSC
        IM1=I-1
        ZSCVAL(IM1)=ZSCVAL(I)
        ZSCLIS(IM1)=ZSCLIS(I)
 10   CONTINUE
C
      NSC=NSC-1
      RETURN
      END
C******************** END FILE UFDKEY.FOR ; GROUP UFILS0 ******************

!-----------------------------------------------------------------------
!  PSGLSA -- CALL UP CROSS SECTION FIT FOR IMPURITY IMPACT IONIZATION/CX
!
real(fp) FUNCTION psglsa8(ZER,IZH,IZIMP)
 
 
! Modified:
! 09/29/94 TBT Added Lithium
!
!  INPUT
!   ZER -- COLLISION ENERGY IN EV/AMU
!   IZH -- ATOM TO BE IONIZED - 1 FOR HYDROGEN, 2 FOR HELIUM, 3 for Lithium
!   IZIMP -- ION DOING THE IONIZING -- 6 FOR CARBON, 8 FOR OXYGEN
!            FULLY STRIPPED LIGHT IMPURITIES -- SEE REFS IN CALLED
!            SUBFUNCTIONS
!
!  OUTPUT
!   PSGLSA -- CROSS SECTION, CM**2
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER izh,izimp
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) zer,zans,psghc8,psgho8,psghec8,psgheo8
!============
  IF(IZH.EQ.1) THEN
     IF(IZIMP.EQ.6) THEN
        ZANS=psghc8(ZER)
     ELSE IF(IZIMP.EQ.8) THEN
        ZANS=psgho8(ZER)
     ELSE
        CALL bad_exit ! ILLEGAL VALUE OF IZIMP
     ENDIF
  ELSE IF(IZH.EQ.2) THEN
     IF(IZIMP.EQ.6) THEN
        ZANS=psghec8(ZER)
     ELSE IF(IZIMP.EQ.8) THEN
        ZANS=psgheo8(ZER)
     ELSE
        CALL bad_exit ! ILLEGAL VALUE OF IZIMP
     ENDIF
  ELSE IF(IZH.EQ.3) THEN                  ! Fudge:  use H0 data!?!
     IF(IZIMP.EQ.6) THEN
        ZANS=psghc8(ZER)
     ELSE IF(IZIMP.EQ.8) THEN
        ZANS=psgho8(ZER)
     ELSE
        CALL bad_exit ! ILLEGAL VALUE OF IZIMP
     ENDIF
  ELSE
     CALL bad_exit ! ILLEGAL VALUE OF IZH
  ENDIF
  !
  psglsa8=ZANS
  RETURN
END FUNCTION psglsa8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

C******************** START FILE URDTCH.FOR ; GROUP USINIT ******************
C------------------------------------------------
C& URDTCH  SET UREAD CHARACTERS FOR TEXT MODE (SOME ARE BLANKED)
C
      SUBROUTINE URDTCH
C
      USE USERIO
C
      CHARACTER*1 ZNULL
C
      ZNULL=CHAR(0)
C
      MPARAM=ZNULL
      MCMD=ZNULL
C
      RETURN
      END
C******************** END FILE URDTCH.FOR ; GROUP USINIT ******************

subroutine get_namerefs(zname,iref)

  use namerefs
  implicit none

  character(len=*), intent(in) :: zname  ! input name
  integer, intent(out) :: iref           ! output reference count

  !  given name, return reference count.
  !  add to list if necessary...

  !--------------------------------------
  integer :: i,i1,i2,ihalf,indx,jlen
  !--------------------------------------

  wk1=zname
  call namerefs_cln(wk1,jlen)
  wk3=wk1

  if(nsize.eq.0) then

    call expand
    nsize=1
    clist(nsize)=wk1
    chord(nsize)=nsize
    nrefs(nsize)=1
    iref=nrefs(nsize)

  else
    wk2=clist(chord(nsize))
    if(iupper.eq.1) then 
      call uupper(wk1)  ! case blind compare...
      call uupper(wk2)
    endif

    ! now: wk1 = input string converted to UC if needed
    !      wk2 = last string in list converted to UC if needed
    !      wk3 = input string, cleaned but not converted to UC

    if(wk1.gt.wk2) then

      !  beyond last element in list
      if(nsize.eq.nmax) call expand
      nsize=nsize+1
      clist(nsize)=wk3
      chord(nsize)=nsize
      nrefs(nsize)=1
      iref=nrefs(nsize)

    else
      !  binary search to find matching element or element before which
      !  to insert a new name

      i1=1
      i2=nsize
      do
        ihalf = (i1+i2)/2
        indx=chord(ihalf)
        wk2=clist(indx)
        if(iupper.eq.1) call uupper(wk2)
        if(i1.eq.i2) exit

        if(wk1.le.wk2) then
          i2=ihalf
        else
          i1=ihalf+1
        endif
      enddo

      if(wk1.eq.wk2) then
        nrefs(indx)=nrefs(indx)+1  ! match: increment reference count
        iref=nrefs(indx)
      else
        if(nsize.eq.nmax) call expand
        nsize=nsize+1              ! add new entry to list
        clist(nsize)=wk3
        nrefs(nsize)=1
        iref=nrefs(nsize)
        do i=nsize,i1+1,-1         ! keep ordering
          chord(i)=chord(i-1)
        enddo
        chord(i1)=nsize
      endif

    endif
  endif

  return
end subroutine get_namerefs

subroutine get_namerefs_str(instr,iref,outstr)

  !  given input string <name> 
  !  return             <name>_#
  !    where # = reference count returned by get_namerefs

  use namerefs
  implicit none

  character(len=*), intent(in) :: instr   ! input string
  integer, intent(out) :: iref            ! reference count
  character(len=*), intent(out) :: outstr ! output string

  !---------------------------------------------
  integer :: ilen,idigs,jlen
  character(len=10) :: zdigs
  !---------------------------------------------

  call get_namerefs(instr,iref)

  outstr = ' '
  ilen=len(outstr)

  wk3=instr
  call namerefs_cln(wk3,jlen)
  !  namerefs'wk3 contains the string, "cleaned up..."; jlen=non-blank
  !  length after left justification...

  if(iref.le.9) then
     idigs=1; write(zdigs(1:idigs),'(I1)') iref
  else if(iref.le.99) then
     idigs=2; write(zdigs(1:idigs),'(I2)') iref
  else if(iref.le.999) then
     idigs=3; write(zdigs(1:idigs),'(I3)') iref
  else if(iref.le.9999) then
     idigs=4; write(zdigs(1:idigs),'(I4)') iref
  else if(iref.le.99999) then
     idigs=5; write(zdigs(1:idigs),'(I5)') iref
  else if(iref.le.999999) then
     idigs=6; write(zdigs(1:idigs),'(I6)') iref
  else if(iref.le.9999999) then
     idigs=7; write(zdigs(1:idigs),'(I7)') iref
  else if(iref.le.99999999) then
     idigs=8; write(zdigs(1:idigs),'(I8)') iref
  else if(iref.le.999999999) then
     idigs=9; write(zdigs(1:idigs),'(I9)') iref
  else
     idigs=10; write(zdigs(1:idigs),'(I10)') iref
  endif

  jlen=min(jlen,ilen-idigs-1)

  if(jlen.lt.0) then
     outstr='?'
  else if(jlen.eq.0) then
     outstr='_'//zdigs(1:idigs)
  else
     outstr=wk3(1:jlen)//'_'//zdigs(1:idigs)
  endif

  return
end subroutine get_namerefs_str

      subroutine grf4f1(f,nf1,nf2, x,nx, y,ny, z,nz,
     >   flab, xlab,ylab,zlab, funs, xuns,yuns,zuns,
     >   ztitle, iproc)
c
c  dmc 12 Aug 2000 -- trgraf "slicer" for f(x,y,z) gridded data
c
c  input:
      real f(nf1,nf2,nz)                ! the data
      real x(nx)                        ! x grid (1st dim.), nx.le.nf1
      real y(ny)                        ! y grid (2nd dim.), ny.le.nf2
      real z(nz)                        ! z grid (3rd dim.)
c
      character*(*) flab                ! data label (recommend <~20 chars)
      character*(*) xlab                ! x label (recommend <~10 chars)
      character*(*) ylab                ! y label (recommend <~10 chars)
      character*(*) zlab                ! z label (recommend <~10 chars)
c
      character*(*) funs                ! data units (recommend <~10 chars)
      character*(*) xuns                ! x units (recommend <~10 chars)
      character*(*) yuns                ! y units (recommend <~10 chars)
      character*(*) zuns                ! z units (recommend <~10 chars)
c
c 40 characters or so:
      character*(*) ztitle              ! general title label for all plots
c
c for Ufiles/grf3 compatibility.  if in doubt set iproc=0
c
      integer iproc               !0=NOTHING, 1=AVG'D, 2=SMOOTHED, ETC...
c
c output:
c
c  **sglib tekvec plots, via grf3f1**
c
c this routine asks the user to fix one coordinate, specify the order
c of the other two cordinates, and then calls grf3f1 to plot the resulting
c 2d slice-- usual menu of 1d slices, contour, isometric, ...
c
c automatic:
c
      real wk(max(nx,ny,nz))
c
      real, dimension(:), allocatable :: x1,x2
      real, dimension(:,:), allocatable :: fslice
c
      character*50 x1lab,x2lab,x1uns,x2uns,zlabel
c
      integer luntrm
      logical lxout,lchar
c-----------------------------
c
      luntrm=lnout(0)
c
      xmin=x(1)
      xmax=x(1)
c
      ymin=y(1)
      ymax=y(1)
c
      zmin=z(1)
      zmax=z(1)
c
      do i=1,nx
         xmin=min(xmin,x(i))
         xmax=max(xmax,x(i))
      enddo
c
      do i=1,ny
         ymin=min(ymin,y(i))
         ymax=max(ymax,y(i))
      enddo
c
      do i=1,nz
         zmin=min(zmin,z(i))
         zmax=max(zmax,z(i))
      enddo
c
 10   continue
c
      if(lxout(0)) then
         write(luntrm,*) ' grf4f1:  f(x,y,z) data:  ',flab,' ',funs
c
         write(luntrm,*) ' '
         write(luntrm,*) ' x axis:  ',nx,' points:  ',xlab,' ',xuns
         write(luntrm,*) '     xmin = ',xmin,' xmax = ',xmax
c
         write(luntrm,*) ' '
         write(luntrm,*) ' y axis:  ',ny,' points:  ',ylab,' ',yuns
         write(luntrm,*) '     ymin = ',ymin,' ymax = ',ymax
c
         write(luntrm,*) ' '
         write(luntrm,*) ' z axis:  ',nz,' points:  ',zlab,' ',zuns
         write(luntrm,*) '     zmin = ',zmin,' zmax = ',zmax
c
         write(luntrm,*) ' '
c
         write(luntrm,1001)
 1001    format(' grf4f1 options:'/
     >      ' enter "0" or "q" to quit, or:'//
     >      '   +1  for f(x,y) @fixed z'/
     >      '   -1  for f(y,x) @fixed z'//
     >      '   +2  for f(x,z) @fixed y'/
     >      '   -2  for f(z,x) @fixed y'//
     >      '   +3  for f(y,z) @fixed x'/
     >      '   -3  for f(z,y) @fixed x'/)
      endif
c
      call uread('grf4f1:  option code:$')
      if(lchar('Q')) return
      if(lchar('0')) return
c
      ians=idcod(iert)
      if(iert.ne.0) go to 10
      if(ians.eq.0) return
      if(abs(ians).gt.3) then
         call uermsi('?grf4f1:  invalid option:  ',ians,0)
         go to 10
      endif
c
      if(abs(ians).eq.1) then
         call grf4f1_fix('z axis',zlab,zuns,z,nz,izfix,zlabel)
         if(izfix.eq.0) go to 10
      else if(abs(ians).eq.2) then
         call grf4f1_fix('y axis',ylab,yuns,y,ny,iyfix,zlabel)
         if(iyfix.eq.0) go to 10
      else
         call grf4f1_fix('x axis',xlab,xuns,x,nx,ixfix,zlabel)
         if(ixfix.eq.0) go to 10
      endif
c
c  z fixed...
      if(ians.eq.1) then
         allocate (x1(nx))
         nx1=nx
         x1=x
         x1lab=xlab
         x1uns=xuns
c
         allocate (x2(ny))
         nx2=ny
         x2=y
         x2lab=ylab
         x2uns=yuns
c
         allocate (fslice(nx,ny))
         fslice=f(1:nx,1:ny,izfix)
      endif
c
      if(ians.eq.-1) then
         allocate (x1(ny))
         nx1=ny
         x1=y
         x1lab=ylab
         x1uns=yuns
c
         allocate (x2(nx))
         nx2=nx
         x2=x
         x2lab=xlab
         x2uns=xuns
c
         allocate (fslice(ny,nx))
         do i=1,ny
            fslice(i,1:nx)=f(1:nx,i,izfix)
         enddo
      endif
c
c  y fixed...
      if(ians.eq.2) then
         allocate (x1(nx))
         nx1=nx
         x1=x
         x1lab=xlab
         x1uns=xuns
c
         allocate (x2(nz))
         nx2=nz
         x2=z
         x2lab=zlab
         x2uns=zuns
c
         allocate (fslice(nx,nz))
         fslice=f(1:nx,iyfix,1:nz)
      endif
c
      if(ians.eq.-2) then
         allocate (x1(nz))
         nx1=nz
         x1=z
         x1lab=zlab
         x1uns=zuns
c
         allocate (x2(nx))
         nx2=nx
         x2=x
         x2lab=xlab
         x2uns=xuns
c
         allocate (fslice(nz,nx))
         do i=1,nz
            fslice(i,1:nx)=f(1:nx,iyfix,i)
         enddo
      endif
c
c  x fixed...
      if(ians.eq.3) then
         allocate (x1(ny))
         nx1=ny
         x1=y
         x1lab=ylab
         x1uns=yuns
c
         allocate (x2(nz))
         nx2=nz
         x2=z
         x2lab=zlab
         x2uns=zuns
c
         allocate (fslice(ny,nz))
         fslice=f(ixfix,1:ny,1:nz)
      endif
c
      if(ians.eq.-3) then
         allocate (x1(nz))
         nx1=nz
         x1=z
         x1lab=zlab
         x1uns=zuns
c
         allocate (x2(ny))
         nx2=ny
         x2=y
         x2lab=ylab
         x2uns=yuns
c
         allocate (fslice(nz,ny))
         do i=1,nz
            fslice(i,1:ny)=f(ixfix,1:ny,i)
         enddo
      endif
c
c  make plots
c
      call grf3f1(x1,fslice,x2,wk,nx1,nx2,nx1,
     >   x1lab,flab,x2lab,x1uns,funs,x2uns,
     >   ztitle,zlabel,iproc)
c
c  free arrays
c
      deallocate(fslice)
      deallocate(x1)
      deallocate(x2)
c
      go to 10
      end
c------------------------------------------
      subroutine grf4f1_fix(slbl,xlbl,xuns,x,nx,ixfix,zlabel)
c
c  choose a fixed value for the given axis
c
c  input:
      character*(*) slbl                ! short label
      character*(*) xlbl                ! axis label
      character*(*) xuns                ! axis units
      real x(nx)                        ! the axis
c
c  output:
      integer ixfix                     ! the selected value (or 0 to bail)
      character*(*) zlabel              ! corresponding label
c
c----------------
      logical lxout,lchar
c----------------
c
      zlabel=' '
      ixfix=0
c
      luntrm=lnout(0)
c
      if(lxout(0)) then
         write(luntrm,*) 'choosing fixed value for ',slbl,'.'
         write(luntrm,*) 'choose fixed value for axis:  ',xlbl,' ',xuns
         write(luntrm,*) 'nearest available point will be chosen.'
      endif
      call uread('grf4f1:  choose fixed value or "H" or "Q":$')
      if(lchar('H')) return             ! retype min/max info
      if(lchar('Q')) return
c
      zanswer=fdcod(iert)
      if(iert.ne.0) return
c
      imin=1
      ztest=abs(zanswer-x(imin))
      do i=2,nx
         ztesnew=abs(zanswer-x(i))
         if(ztesnew.lt.ztest) then
            ztest=ztesnew
            imin=i
         endif
      enddo
c
      write(luntrm,*) 'nearest point:  index=',imin,' value=',x(imin)
      ixfix=imin
c
      ilu=len_trim(xuns)
      ilb=len_trim(xlbl)
      if((ilu+ilb+16).gt.len(zlabel)) then
         write(zlabel,
     >      '(''fixed '',a,'' value:  '',1pe12.5)') trim(slbl),x(imin)
      else
         write(zlabel,'(a,'' = '',1pe12.5,'' '',a)') trim(xlbl),
     >        x(imin),trim(xuns)
      endif
c
      return
      end

C******************** START FILE UCBUFP.FOR ; GROUP UEDTS2 ******************
C---------------------------------------------------------------
C& UCBUFP  SAVE LAST 3 UREAD INPUT LINES FOR DEBUG PURPOSES
C
      SUBROUTINE UCBUFP
C
      USE USERIO
C
C  RELEVANT VARIABLES--
C   NLINDI=.TRUE. INDIRECT INPUT FILE IS OPEN, SO SAVE INPUT LINES
C   NSAVED= NUMBER SAVED SO FAR
C   NCBUFP= MAX CAPACITY TO SAVE LINES
C   CBUFF-- CURRENT INPUT LINE
C
      IF(.NOT.NLINDI) RETURN
C
      IF(NSAVED.EQ.NCBUFP) GO TO 10
      NSAVED=NSAVED+1
C
 10   CONTINUE
      IF(NSAVED.EQ.1) GO TO 30
      DO 20 I=NSAVED,2,-1
      IM1=I-1
      CBUFFP(I)=CBUFFP(IM1)
 20   CONTINUE
 30   CONTINUE
      CBUFFP(1)=CBUFF
      RETURN
      END
C******************** END FILE UCBUFP.FOR ; GROUP UEDTS2 ******************

C******************** START FILE UCMPPR.FOR ; GROUP UREAD5 ******************
C--------------------------------------------------------------
C&  UCMPPR COMPARE PROGRAM PROMPT WITH RECORD FROM INPUT FILE
C
C  COMPARE INPUT ";" CARD WITH PROMPT SENT TO UREAD CALLER FOR
C  A MATCH-- IF CARD MATCHES, THIS INDICATES THAT INDIRECT INPUT
C  FILE CONTROLLING THE MAIN PROGRAM IS IN LINE WITH PROGRAM PROMPTS.
C
C  IF A MATCH IS FOUND SET THE FLAG IREADY=1
C
      SUBROUTINE UCMPPR
C
      USE USERIO
C
      CHARACTER*10 ZWORDA,ZWORDC
C
C  PROMPT IS IN COMMON ("ABUFF(1:NCHARA)")
C  FILE INPUT IS IN COMMON ("CBUFF")
C
C  APPLICATION CONTROLS WHAT WORD RANGE IN PROMPT TO CHECK
C  VIA COMMON ARRAY NCPRM WHICH IS SET BY "CALL URDPMA(I,J)"
C  E.G. "CALL URDPMA(1,3)" SAYS DEFINE PROMPTS TO MATCH IF THE
C  FIRST 3 WORDS AGREE
C
C  CALL URDPMA(2,4) SAYS CHECK WORDS 2--4 FOR MATCH
C
C  CALL URDPMA(0,0) WILL TURN OFF ALL PROMPT MATCH CHECKING FEATURES
C  SO WILL CALL URDPMA(2,1)
C
C  CF UREAD LOGICAL FUNCITON LCMPPR
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCMPPR
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      IF(.NOT.LCMPPR(IW1,IW2)) GO TO 200
C
C---------------------------
C  INITIALIZE WORD SEARCH
C
      ISTARTA=1
      ISTARTC=INDEX(CBUFF,MSEMI)+1
C
      IENDA=NCHARA
C---------------
C  FIND LAST CHAR WHICH IS NEITHER BLANK NOR MDOLLR
C
      ILEN=LEN(CBUFF)
      INBLANK=0
      DO 5 IC=ILEN,1,-1
        IF(CBUFF(IC:IC).NE.' ') INBLANK=1
        IF((INBLANK.EQ.1).AND.(CBUFF(IC:IC).NE.MDOLLR))
     >      GO TO 6
 5    CONTINUE
      IC=0
 6    CONTINUE
C
      IENDC=IC
      IF(IENDC.LE.0) GO TO 300
C
      IWORD=0
C
      ISTA=ISTARTA-1
      ISTC=ISTARTC-1
C
 10   CONTINUE
      IWORD=IWORD+1
      IF(IWORD.GT.IW2) GO TO 200  ! MATCH ENOUGH WORDS YET?
C
      CALL UWORDL(ABUFF(1:IENDA),ISTA,I1A,I2A,ICODA)
      CALL UWORDL(CBUFF(1:IENDC),ISTC,I1C,I2C,ICODC)
C
      IAMIN=MIN0(I1A,I2A)
      ICMIN=MIN0(I1C,I2C)
C
      IF((ICODA.EQ.0).AND.(ICODC.EQ.0)) GO TO 200  ! SIMULTANEOUS END?
C
      IF((IAMIN.EQ.0).AND.(ICMIN.EQ.0)) GO TO 10   ! SIMULTANEOUS NULL
C
C  CHECK *THIS* WORD?
      IF(IWORD.LT.IW1) GO TO 20
C
      ZWORDA='          '
      IF(I2A.GE.MAX0(1,I1A)) THEN
        ILA=MIN0(10,(I2A-I1A+1))
        ZWORDA(1:ILA)=ABUFF(I1A:I1A+ILA-1)
        CALL USPCAP(ZWORDA)
      ENDIF
C
      ZWORDC='          '
      IF(I2C.GE.MAX0(1,I1C)) THEN
        ILC=MIN0(10,(I2C-I1C+1))
        ZWORDC(1:ILC)=CBUFF(I1C:I1C+ILC-1)
        CALL USPCAP(ZWORDC)
      ENDIF
C
      IF(ZWORDA.NE.ZWORDC) GO TO 300
C
 20   CONTINUE
      ISTA=MAX0(I1A,I2A)
      ISTC=MAX0(I1C,I2C)
      GO TO 10
C---------------------------
C  MATCH
 200  CONTINUE
      CALL UREADY(1)
      IF(NLSKIP.AND.(NLECHO.OR.(LPMMSG.EQ.1).OR.(IBATCH.EQ.1)))
     >     WRITE(LUNTRM,3200) NCMND(NLUNIN)
 3200 FORMAT(' PROMPT MATCH FOUND - CONTROL RESUMED AT RECORD ',I4)
      NLSKIP=.FALSE.
C---------------------------
C  EXIT (E.G. NO MATCH)
C
 300  CONTINUE
      RETURN
      END
C******************** END FILE UCMPPR.FOR ; GROUP UREAD5 ******************

C******************** START FILE URDTTI.FOR ; GROUP UREAD5 ******************
C
C--------------------------------------------------------------------
C&  URDTTI-- INSERT STRING IN UREAD TYPEAHEAD BUFFER
C
      SUBROUTINE URDTTI(STR)
C
      USE USERIO
C
      CHARACTER*(*) STR
C
      IN=LEN(STR)
      IF(IN.LT.1) RETURN
C  DO NOT COUNT TRAILING BLANKS
      DO 10 IC=IN,1,-1
        IF(STR(IC:IC).NE.' ') GO TO 20
 10   CONTINUE
      IC=-1
 20   IN=MIN0((IC+1),IN)
      IF(IN.LT.1) RETURN
C  CHECK
      ILC=LEN(CBUFF)
      IF((IN+NCHARC).GT.ILC) THEN
        WRITE(LUNTRM,9001) CBUFF(1:NCHARC),STR(1:IN)
 9001 FORMAT(' % TYPEAHEAD BUFFER OVERFLOW WHILE INSERTING STRING'/
     >'   BUFFER="',A,'"'/'   INSERTION STRING="',A,'"'/
     >' % PREVIOUS BUFFER CONTENTS REPLACED')
        CALL UCLEAR
      ELSE IF(NLECHO) THEN
        WRITE(LUNTRM,9002) STR(1:IN)
 9002   FORMAT(' % STRING INSERTED AT START OF TYPEAHEAD BUFFER:'
     >    /1X,A)
      ENDIF
C
      IN=MIN0(IN,ILC)
C  MAKE ROOM FOR STRING INSERTION
      IF(NCHARC.GT.0) THEN
        DO IC=NCHARC,1,-1
          IL=IC+IN
          CBUFF(IL:IL)=CBUFF(IC:IC)
        ENDDO
      ENDIF
C  INSERT STRING
      CBUFF(1:IN)=STR(1:IN)
C
      CALL UDECOD
C
      CALL URXOUT
C
      RETURN
      END
C******************** END FILE URDTTI.FOR ; GROUP UREAD5 ******************

C-----------------------------------------------------------------------
C  CKRESERV:  CHECK NODE RESERVATION STATUS
C
C   CALL TO SEE IF A GIVEN NODE IS RESERVED AND CANNOT BE USED BY
C   A GIVEN QUEUED TRANSP JOB
C
      SUBROUTINE CKRESERV(ZRESERV,ZNAME1,ZNAME2,ISTAT)
C
C  INPUT
C    ZRESERV -- RESERVATION STRING, BLANK MEANS NO RESERVATIONS
C        ZRESERV contains comma or blank delimitted list of NAMEs or ~NAMEs.
C        *caution* only one delimitter character btw names allowed!
C        *noted* dmc 10 Dec 1997
C    ZNAME1,ZNAME2 -- TOKAMAK AND OWNER NAME ASSOCIATED WITH CURRENT JOB
C
C    if ZRESERV is blank, any job can use node
C    if ZRESERV is non-blank, job's associated names must match one
C       of the NAMEs in ZRESERV, and must not match any of the ~NAMEs
C       in ZRESERV.
C
C  OUTPUT
C    ISTAT=0:  JOB IS FREE TO USE NODE
C    ISTAT=1:  JOB MAY NOT USE NODE -- RESERVED FOR OTHER OWNER OR
C                   TOKAMAK NAMES
C
      implicit NONE
C
      CHARACTER*(*) ZRESERV,ZNAME1,ZNAME2
C
      INTEGER ISTAT
C
C-----------------------------------
      integer istat1,ict1,istat2,ilen,ic,ilenb,ic1,ic2,ic1p
C-----------------------------------
C
      call uupper(zreserv)
      call uupper(zname1)
      call uupper(zname2)
C
      ISTAT=0
C
      IF(ZRESERV.EQ.' ') RETURN
C
C  NON-BLANK RESERVATION STRING; NODE MAY BE RESERVED
C
C  a name (ZNAME1 or ZNAME2) must match one of the names
C  (not starting with ~) in ZRESERV.  If there are such names
C  in ZRESERV, ICT1 gets incremented.  If one of these names
C  matches, ISTAT1 gets cleared.
C
      ISTAT1=1
        ICT1=0
C
C  a name (ZNAME1 or ZNAME2) must *not* match names given in the
C  form ~NAME in the ZRESERV string.  If a match of this type is
C  detected, ISTAT2 gets set
        ISTAT2=0
C
C  find, nonblank length of ZRESERV, store in ILENB
      ILEN=LEN(ZRESERV)
      DO IC=ILEN,1,-1
        IF(ZRESERV(IC:IC).NE.' ') GO TO 10
      ENDDO
C
 10   CONTINUE
      ILENB=IC
C
C-------------------
C  loop through names...
C
      IC1=1
 20   CONTINUE
      DO IC=IC1+1,ILENB
        IF(ZRESERV(IC:IC).EQ.',') GO TO 30
          IF(ZRESERV(IC:IC).EQ.' ') GO TO 30
      ENDDO
      IC=ILENB+1
C
 30   CONTINUE
      IC2=IC-1
C
        if(zreserv(ic1:ic1).ne.'~') then
           ict1=ict1+1
           IF(ZNAME1.EQ.ZRESERV(IC1:IC2)) ISTAT1=0
           IF(ZNAME2.EQ.ZRESERV(IC1:IC2)) ISTAT1=0
        else
           ic1p=ic1+1
           if(ic1p.le.ic2) then
              IF(ZNAME1.EQ.ZRESERV(IC1P:IC2)) ISTAT2=1
              IF(ZNAME2.EQ.ZRESERV(IC1P:IC2)) ISTAT2=1
           endif
        endif
C
      IC1=IC2+2
      IF(IC1.GT.ILENB) go to 100
C
      GO TO 20  ! re-enter loop
C
C---------------------
C  exit; return "LOGICAL AND" of both conditions:
C
 100    continue
C
        if(ict1.eq.0) istat1=0
        istat = istat1 + istat2
C
        return
C
      END

module physconst_mod

  use iso_c_binding, only: fp => c_double

  implicit none

  !-----------------------------------------
  real(fp), parameter :: zero = 0.0_fp
  real(fp), parameter :: half = 0.5_fp
  real(fp), parameter :: one  = 1.0_fp
  real(fp), parameter :: two  = 2.0_fp
  !-----------------------------------------

  real(fp), parameter :: pi   = atan2(0.0_fp,-1.0_fp)
  real(fp), parameter :: twopi= PI+PI
  real(fp), parameter :: pio2 = half*pi
  real(fp), parameter :: pio4 = half*pio2
  real(fp), parameter :: sqpi = sqrt(pi)
  real(fp), parameter :: kb_K = 1.38064852e-23_fp    !  J/K
  real(fp), parameter :: kb_eV = 1.60217653e-19_fp   !  J/eV
  real(fp), parameter :: kb_keV = 1.60217653e-16_fp  !  J/keV
  real(fp), parameter :: qe_eV  = 1.60217653e-19_fp  !  qe (eV) 
  real(fp), parameter :: e = 2.7182818285_fp
  real(fp), parameter :: me_Kg  = 9.10938215e-31_fp  ! electron mass (kg)
  real(fp), parameter :: mp_Kg  = 1.672621637e-27_fp ! proton mass (kg)
  real(fp), parameter :: mp_g   = 1.672621637e-24_fp ! proton mass (g)
  real(fp), parameter :: amu_g  = 1.660539066e-24_fp ! AMU_g 
  !-----------------------------------------
  ! Physics constants, based on CODATA 2006
  real(fp), parameter :: ZEL  = 4.803206799125e-10_fp !ELECTRON CHARGE (STATCOULOMBS)
  real(fp), parameter :: AEE  = 1.602176487e-19_fp ! elementary charge
  real(fp), parameter :: AME  = 9.10938215e-31_fp  ! electron mass (kg)
  real(fp), parameter :: AMP  = 1.672621637e-27_fp ! proton mass (kg)
  real(fp), parameter :: VC   = 2.99792458e8_fp    ! speed of light
  real(fp), parameter :: RMU0 = (4.0e-7_fp)*PI     ! permeability
  real(fp), parameter :: EPS0 = ONE/(VC*VC*RMU0)   ! permittivity
  real(fp), parameter :: usdp = rmu0
  real(fp), parameter :: aee_amp = 9.578833391e+7  ! electron_charge/proton_mass (C*kg^-1)
  real(fp), parameter :: evptocm_sec = 1.384112291e+6_fp !sqrt(2*kb_keV*10^7/mp_g) 
                         !cm/sec for 1eV proton, note J=10^7 erg
  !Define conversion factors
  real(fp), parameter :: zcmtom = 1.0e-2_fp  ! Centimeter to meter
  real(fp), parameter :: zmtocm = 1.0e+2_fp  ! meters to centimeters
  real(fp), parameter :: zcm2tom2 = 1.0e-4_fp  ! cm^2 to m^2
  real(fp), parameter :: zm2tocm2 = 1.0e+4_fp  ! m^2 to cm^2
  real(fp), parameter :: zcm3tom3 = 1.0e-6_fp  ! cm^3 to m^3 | 1/m^3 to 1/cm^3
  real(fp), parameter :: zm3tocm3 = 1.0e+6_fp  ! m^3 to cm^3 | 1/cm^3 to 1/m^3
  real(fp), parameter :: zwtomw = 1.0e-6_fp  ! Watts to Mega-watts
  real(fp), parameter :: zatoma = 1.0e-6_fp  ! Amperes to Mega-amperes
  real(fp), parameter :: zev2kev = 1.0e-3_fp ! eV to keV
  real(fp), parameter :: zkev2ev = 1.0e+3_fp ! keV to eV
  real(fp), parameter :: cgs2mks = 1.0E-7_fp ! CGS TO MKS
  real(fp), parameter :: t2gauss = 1.0E+4_fp ! Tesla to Gauss
  real(fp), parameter :: gauss2t = 1.0E-4_fp ! Gauss to Tesla

  real(fp), parameter :: rad2deg = 180.0_fp/pi
  real(fp), parameter :: deg2rad = pi/180.0_fp


  real(fp), parameter :: epslon = 1.0e-34_fp    ! small number
  real(fp), parameter :: epsinv = 1.0e+34_fp    ! large number

contains

  ! potential area for conversion utils etc

end module physconst_mod

      subroutine isbatch(iret)
C
C  DMC 9 SEP 1991
C
c
c  this fortran routine replaces the old macro "isbatch".  This routine
c  returns IRET=1 if the current process is a batch job or spawned
c  subprocess not receiving input from a terminal; it returns IRET=0
c  if an interactive terminal is in control.
c
      INTEGER FISATTY
C
      IANS=FISATTY(0)
C
      IF(IANS.EQ.1) THEN
        IRET = 0
      ELSE
        IRET = 1
      ENDIF
C
 9000 continue
      return
      end

C******************** START FILE DPLOTK.FOR ; GROUP DPLOTT *************
C------------------------------------------------------------------
C  DPLOTK
C   PLOT + LABEL 1 LINE OF THE KEY FOR A MULTIPLOT
C   USE PASSED RASTER LOCATIONS
C
C  MODIF DMC-- IF M(1)=0 SHOW SYMBOLS ONLY (NO LINES)
C
      SUBROUTINE DPLOTK(IYL,IXL,IYN,IXN,M,LBL)
C
      INCLUDE 'GFTIC'
C
      DIMENSION IXL(2),M(2)
      CHARACTER*(*) LBL
C
C  DRAW LINE-SYBOL COMBO
C
      if(.not.init_gftic) call gftic0
C
      CALL MOVABS(IXL(1),IYL)
      CALL DPSYST(M(2),ISYM,SIZE)
      CALL SYMOUT(ISYM,SIZE)
      IF(M(1).GT.0) THEN
C===============/DRAW LINE CONNECTING 2 SYMBOLS
        CALL DPLNST(M(1),ILINE,ISYM,SIZE)
        IF(ILINE.GE.0) THEN
          CALL DSHABS(IXL(2),IYL,ILINE)
        ELSE
          DO 10 IXSCN=1,5
            IXW1=5-IXSCN
            IXW2=4-IXW1
            IXA=(IXW1*IXL(1)+IXW2*IXL(2))/4
            CALL MOVABS(IXA,IYL)
            CALL SYMOUT(ISYM,SIZE)
 10       CONTINUE
        ENDIF
        CALL DPSYST(M(2),ISYM,SIZE)
        CALL SYMOUT(ISYM,SIZE)
C===============/DRAW 3 SYMBOLS IN A ROW
      ELSE
        IXA=(IXL(1)+IXL(2))/2
        CALL MOVABS(IXA,IYL)
        CALL SYMOUT(ISYM,SIZE)
        CALL MOVABS(IXL(2),IYL)
        CALL SYMOUT(ISYM,SIZE)
      ENDIF
C================
C
C  WRITE LABEL
      CALL GRFLBL(IXN,IYN,LBL,11,-1,0)
C
      RETURN
      END
C******************** END FILE DPLOTK.FOR ; GROUP DPLOTT ***************

!-----------------------------------------------------------------------
!  PSGHEOI -- CROSS SECTION OF O+8 + HE --> O+8 + HE+
!
real(fp) FUNCTION psgheoi8(ZE)
!
! INPUT
!  ZE -- COLLISION ENERGY **PER NUCLEON**  EV/AMU
!
! OUTPUT
!  PSGHEOI -- CROSS SECTION, CM**2
!
! REFERENCE
!  ORNL-6090/V5, ATOMIC DATA FOR FUSION, VOLUME V,
!    "COLLISIONS OF CARBON AND OXYGEN IONS WITH ELECTRONS, H, H2, & He"
!    R.A. PHANEUF, R.K. JANEV, M.S. PINDZOLA
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) ze,emin,emax,zans,psgchvx8
!============
  real(fp) CCHEV(9)
!
  DATA EMIN/1.0e+5_fp/
  DATA EMAX/1.0e+7_fp/
!
  DATA CCHEV/&
       -7.07000e+01_fp,-3.27532e-1_fp,-6.29127e-1_fp,&
       1.82069e-1_fp,-6.13708e-2_fp, 9.59603e-3_fp,&
       1.20755e-2_fp,-9.89337e-3_fp, 6.24973e-04_fp/
!
  ZANS=psgchvx8(2,ZE,EMIN,EMAX,CCHEV)
  psgheoi8=ZANS
!
  RETURN
END FUNCTION psgheoi8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
!
real(fp) FUNCTION FSVGEN_Z(V,IREACT,INTG)
!
!  DMC - ARGUMENT INTG DETERMINES WHICH INTEGRAL
!  <SIGMA*V>, <SIGMA*V*VX>, <SIGMA*V*V**2>
!     0          1             2
!
!      - ARGUMENT IREACT:
!        =1: CX
!        =2: II
!
!---------------------------
!
!  *** DMC JUNE 1989 ***
!  ARGUMENT IREACT IS NOW OBSOLETE, BUT IS RETAINED FOR COMPATIBILITY
!  FSVGEN AND OTHER CROSS-SECTION / REACTION RATE TABLE INTEGRATION
!  ROUTINES HAVE BEEN INTEGRATED INTO A SINGLE PROGRAM, SIGTAB, VIA
!  A SUBROUTINE LIBRARY, SIGSUB_LIB, WHICH HAS ITS OWN COMMON BLOCK
!  AND GENERAL CROSS SECTION ROUTINE, SIGALL.  THE ACTUAL REACTION
!  BEING CONSIDERED IS IDENTIFIED IN SIGSUB COMMON.  POSSIBILITIES
!  INCLUDE HELIUM REACTIONS, ETC. WHEREAS THE ORIGINAL VERSION OF
!  THIS ROUTINE ASSUMED HYDROGEN ONLY.
!
!---------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod, only : VCFAC,ifun,VI,T,B2
  IMPLICIT NONE
  INTEGER intg,ireact
!============
! idecl:  explicitize implicit DOUBLE PRECISION declarations:
!     DOUBLE PRECISION vi,t,b2,u,b2inv,d,d2,z,z2,e1,ee2,exp1,exp2,
!    > ee1,e2,zsig,zdum,zans
!============
  real(fp) u,b2inv,d,d2,z,z2,e1,ee2,exp1,exp2,ee1,e2,zsig,&
       zdum,zans
  real(fp) V,E
  real(fp) SIGALL_Z
!
!	COMMON PARAMETERS
!	VI - SPEED OF INJECTED PARTICLE (CM/SEC)
!	T=.5E00*TMASS/C**2
!	B2 - BMASS(2)/(2.E00*TEMP(2))
!
  U=V/VCFAC
  B2INV=1.0_fp/B2
  E=T*U**2
  D=VI-U
  D2=D*D
  Z=VI+U
  Z2=Z*Z
!
!  EXP(-B2*(VI-U)**2) TERM
  E1=-B2*D2
  IF(E1.LT.-180.0_fp) GO TO 2000
!
  IF(INTG.EQ.0) THEN
     EE2=1.0_fp
  ELSE IF(INTG.EQ.1) THEN
     EE2=D+1.0_fp/(2.0_fp*B2*VI)
  ELSE IF(INTG.EQ.2) THEN
     EE2=D2+B2INV
  ELSE
     write(6,9999) INTG
9999 FORMAT(' FSVGEN:  ILLEGAL INTG=',I10)
     call bad_exit
  ENDIF
!
  EXP1=exp(E1)
!
  EXP2=0.0_fp
  EE1=1.0_fp
!
  E2=-B2*Z2
  IF(E2.LT.-180.0_fp) GO TO 1000
!
!  EXP(-B2*(VI+U)**2) TERM
  EXP2=exp(E2)
!
  IF(INTG.EQ.0) THEN
     EE1=1.0_fp
  ELSE IF(INTG.EQ.1) THEN
     EE1=Z+1.0_fp/(2.0_fp*B2*VI)
  ELSE IF(INTG.EQ.2) THEN
     EE1=Z2+B2INV
  ENDIF
!-----------------------------------------
1000  CONTINUE
!
  ZSIG=1.e+4_fp*SIGALL_Z(E,ZDUM)
!
  ZANS=ZSIG*U*U*(EXP1*EE2-EXP2*EE1)
!
  FSVGEN_Z=ZANS
!
  RETURN
!-----------------------------------------
2000  FSVGEN_Z=0.0_fp
  RETURN
END FUNCTION FSVGEN_Z
!
!******************* END FILE FSVGEN_Z.FOR ; GROUP FSVINT *********************
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

      SUBROUTINE ULOWER(STR)
C
C  CONVERT STR TO LOWER CASE
C
      CHARACTER*(*) STR
C
      CHARACTER*26 ALPHAB(2)
C
      DATA ALPHAB/'abcdefghijklmnopqrstuvwxyz',
     >              'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C
C  EXECUTABLE CODE
C
      L=LEN(STR)
C
      DO 10 I=1,L
        IA=INDEX(ALPHAB(2),STR(I:I))
        IF(IA.NE.0) STR(I:I)=ALPHAB(1)(IA:IA)
 10   CONTINUE
C
      RETURN
      END

C******************** START FILE USPDGL.FOR ; GROUP USPARM ******************
C---------------------------------------------------------------
C&  USPDGL   DELETE GLOBAL UREAD PARAMETER BY NUMBER
C
      SUBROUTINE USPDGL(NP)
C
      USE USERIO
C
C--------------------
C  "$MATCH" CANNOT BE DELETED (DMC 1/88)
C
      IF(PGLNAM(NP)(1:8).EQ.'$MATCH  ') GO TO 50
C
      NPT=NPGC
      IF(NP.EQ.NPT) GO TO 20
C
      NPTM1=NPT-1
      DO 10 J=NP,NPTM1
      JP1=J+1
      PGLNAM(J)=PGLNAM(JP1)
      PGLVAL(J)=PGLVAL(JP1)
 10   CONTINUE
C
 20   CONTINUE
      NPGC=NPT-1
      PGLNAM(NPT)=' '
      PGLVAL(NPT)=' '
C
 50   CONTINUE
      RETURN
      END
C******************** END FILE USPDGL.FOR ; GROUP USPARM ******************

subroutine plot_fp_ce(n1)

  ! plot Coronal equilibtium data from fpreact
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one
  use periodic_table_mod
  implicit NONE
  ! data buffers -- uninitialized!

  integer, intent(in) :: n1  ! dimension info

  real(fp), dimension(:), allocatable :: te       ! Te in keV 
  real(fp), dimension(:), allocatable :: dens       ! Ne in m-3
  real(fp), dimension(:,:), allocatable :: rioniz      ! Impurity ionization rate
  real(fp), dimension(:,:), allocatable :: rrecom      ! Impurity  recombination rate
  real(fp), dimension(:,:), allocatable :: rrad        ! Impurity  radiation rate
  real(fp), dimension(:,:,:), allocatable :: rioniz3      ! Impurity ionization rate
  real(fp), dimension(:,:,:), allocatable :: rrecom3      ! Impurity  recombination rate
  real(fp), dimension(:,:,:), allocatable :: rrad3        ! Impurity  radiation rate
  real(fp), dimension(:,:), allocatable :: rcoron      ! Impurity  coronal equilibrium
  real(fp), dimension(:), allocatable :: rcorrad     ! Impurity  coronal  radiation
  real(fp), dimension(:,:), allocatable :: rcorrad3     ! Impurity  coronal  radiation
  real(fp), dimension(:,:,:), allocatable :: rcoron3      ! Impurity  coronal equilibrium
  real(fp), dimension(:), allocatable :: rcorrad_brem     ! Impurity  coronal  radiation (line+bremsstrahlung)
  real(fp), dimension(:,:), allocatable :: rcorrad_brem3  ! Impurity  coronal  radiation (line+bremsstrahlung)
  real(fp), dimension(:,:), allocatable :: rrad_brem        ! Impurity  radiation rate bremsstrahlung
  real(fp), dimension(:,:,:), allocatable :: rrad_brem3        ! Impurity  radiation rate bremsstrahlung
  real(fp), dimension(:,:), allocatable :: wk      !work array
  real(fp), dimension(:,:), allocatable :: fun,fun2    !array to be plotted
  real(fp), dimension(:), allocatable :: te_vec       ! Te in keV 

  !----------------------------------
  integer luntrm,lnout
  logical lxout,lchar

  integer izimp,jzimp
  real(fp) :: azimp
  real(fp) :: temin, temax,denmin, denmax !policy for max and min Te and Ne

  integer loglin(2) ! linear=1, log=2 -- spacing control
  logical :: ilplot,ilplot2
  integer :: iert,idcod,izch,i,iizch,jizch

  character*60 zlbl1
  character*10 zflbl,zlbl2
  character*60 zhlbl
  character*28 zhlbl1
  character*36 zhlbl2

!----------------------------------
  zlbl1='PREACT "ADPAK" database' 
  luntrm=lnout(0)
  loglin(1)=1
  loglin(2)=1
  if(lxout(0)) write(luntrm,1001)
1001 format(/ &
          'plot of coronal equilibrium of selected neutral specieimpurity as a'/ &
          'function of Te and Ne'/ &
          '(hit "," to exit)'/)
  
  do
     izimp=0
     iert=0
     if(lxout(0)) write(luntrm,*) ' enter Z impurity from 3 to 74 (58, 59, 60 not allowed)'
     !3 <= Z impurity <=74  and  58,59,60 has some  
     !problems with neutral radiation numerics,
     !so they are forbidden.
     if(lxout(0)) write(luntrm,*) ' Q -- to exit'
     call uread(' enter integer :$')
     izimp=idcod(iert)
     if(iert.ne.0) exit
     if( izimp.eq.58.or.izimp.eq.59.or.izimp.eq.60.or.izimp.lt.3.or.izimp.gt.74) then
        write(luntrm,'(a26,i3)')' You entered Z impurity = ',izimp
        write(luntrm,*)'Z impurity must be in range from 3 to 74 (58, 59, 60 not allowed).'
        cycle
     endif
     
     if(allocated(te)) deallocate(te)
     allocate(te(n1))
     if(allocated(te_vec)) deallocate(te_vec)
     allocate(te_vec(n1))
     if(allocated(dens)) deallocate(dens)
     allocate(dens(n1))
     
     call psmmx('Ne, 1/m3',denmin,denmax,dens,n1,n1,loglin(1),one,1.0E20_fp)
     
     call psmmx('Te KeV',temin, temax,te,n1,n1,loglin(2),0.01_fp,100.0_fp)
     
     if(allocated(rioniz)) deallocate(rioniz)
     allocate(rioniz(iZimp+1,n1))
     
     if(allocated(rioniz3)) deallocate(rioniz3)
     allocate(rioniz3(iZimp+1,n1,n1))
     
     if(allocated(rrecom)) deallocate(rrecom)
     allocate(rrecom(iZimp+1,n1))
     
     if(allocated(rrecom3)) deallocate(rrecom3)
     allocate(rrecom3(iZimp+1,n1,n1))
     
     if(allocated(rrad)) deallocate(rrad)
     allocate(rrad(iZimp+1,n1))
     
     if(allocated(rrad3)) deallocate(rrad3)
     allocate(rrad3(iZimp+1,n1,n1))
     
     if(allocated(rrad_brem)) deallocate(rrad_brem)
     allocate(rrad_brem(iZimp+1,n1))
     
     if(allocated(rrad_brem3)) deallocate(rrad_brem3)
     allocate(rrad_brem3(iZimp+1,n1,n1))
     
     if(allocated(rcoron)) deallocate(rcoron)
     allocate(rcoron(iZimp+1,n1))
     
     if(allocated(rcoron3)) deallocate(rcoron3)
     allocate(rcoron3(iZimp+1,n1,n1))
     
     if(allocated(rcorrad)) deallocate(rcorrad)
     allocate(rcorrad(n1))
     
     if(allocated(rcorrad3)) deallocate(rcorrad3)
     allocate(rcorrad3(n1,n1))
     
     if(allocated(rcorrad_brem)) deallocate(rcorrad_brem)
     allocate(rcorrad_brem(n1))
     
     if(allocated(rcorrad_brem3)) deallocate(rcorrad_brem3)
     allocate(rcorrad_brem3(n1,n1))
     
     if(allocated(fun)) deallocate(fun)
     allocate(fun(n1,n1))

     if(allocated(fun2)) deallocate(fun2)
     allocate(fun2(n1,n1))
     
     write(luntrm,'(i4,a36)') n1,' points are evaluating. Please wait.'
     do i=1,n1
        if(mod(i,100).eq.0) write(luntrm,'(i4,a36)')i,' points have been evaluated'
        te_vec(1:n1)=te(i)
        call imptable_ioniz_r8(iZimp, n1, te_vec, dens, iZimp+1, rioniz) !** <sigma*v*ne> Impurity ionization rate
        call imptable_recom_r8(iZimp, n1, te_vec, dens, iZimp+1, rrecom) !** <sigma*v*ne> Impurity recombination rate
        call imptable_rad_r8(iZimp, n1, te_vec, dens, iZimp+1, rrad) !** <sigma*v*ne> Impurity radiation rate (no bremsstrahlung)
        call imptable_brem_r8(iZimp, n1, te_vec, dens, iZimp+1, rrad_brem) !' ** <sigma*v*ne> Impurity bremsstrahlung ' 
        call impreaction_coronal_r8(iZimp, n1, rioniz, rrecom, iZimp+1, rcoron)
        call impreaction_coronal_rad_r8(iZimp, n1, rcoron, rrad, iZimp+1, rcorrad)
        call impreaction_coronal_rad_r8(iZimp, n1, rcoron, rrad+rrad_brem, iZimp+1, rcorrad_brem)
        rioniz3(1:izimp+1,i,1:n1)=rioniz(1:izimp+1,1:n1)
        rrecom3(1:izimp+1,i,1:n1)=rrecom(1:izimp+1,1:n1)
        rrad3(1:izimp+1,i,1:n1)=rrad(1:izimp+1,1:n1)
        rrad_brem3(1:izimp+1,i,1:n1)=rrad_brem(1:izimp+1,1:n1)
        rcoron3(1:izimp+1,i,1:n1)=rcoron(1:izimp+1,1:n1)
        rcorrad3(i,1:n1)=rcorrad(1:n1)
        rcorrad_brem3(i,1:n1)=rcorrad_brem(1:n1)
     enddo
     do
        if(lxout(0)) write(luntrm,*) &
             ' I -- ionization rate <sigma*v*ne>' 
        if(lxout(0)) write(luntrm,*) &
             ' R -- recombination rate' 
        if(lxout(0)) write(luntrm,*) &
             ' D -- radiation rate' 
        if(lxout(0)) write(luntrm,*) &
             ' C -- coronal equilibrium(CE) radiation rate' 
        if(lxout(0)) write(luntrm,*) &
             ' E -- coronal equilibrium(CE) density fraction' 
        if(lxout(0)) write(luntrm,*) &
             ' A -- coronal equilibrium(CE) average charge state' 
        if(lxout(0)) write(luntrm,*) &
             ' Q -- to exit' 
        call uread('select option:$')
        ilplot=.false. !do not make these plots
        ilplot2=.false. !do not make these plots
        if(lchar('I'))then
           zhlbl='<sigma*v*ne> ionization'
           zflbl='1/sec'
           call get_charge_state(iert)
           jizch=izch-1
           if(iert.eq.0) then
              ilplot=.true.
              fun(1:n1,1:n1)=rioniz3(izch,1:n1,1:n1)
           endif
        elseif(lchar('R'))then
           zhlbl='<sigma*v*ne> recombination rate '
           zflbl='1/sec'
           call get_charge_state(iert)
           jizch=izch-1
           if(iert.eq.0) then
              ilplot=.true.
              fun(1:n1,1:n1)=rrecom3(izch,1:n1,1:n1)
           endif
        elseif(lchar('D'))then
!radiation power per ion, if multiplying by the number ofions would give 
!actual power; multipying by the specie ion density would give radated 
!power density.
           if(lxout(0)) write(luntrm,*) &
                ' L -- line radiation rate' 
           if(lxout(0)) write(luntrm,*) &
                ' B -- line+bremsstrahlung radiation rate' 
           if(lxout(0)) write(luntrm,*) &
                ' C -- compare line and line+bremsstrahlung radiation rates' 
           if(lxout(0)) write(luntrm,*) &
                ' Q -- to exit' 
           call uread('select option:$')
           if(lchar('Q'))then
              exit
           elseif(lchar('L')) then
              zhlbl='line radiation rate'
              zflbl='watts/ion'
              call get_charge_state(iert)
              jizch=izch-1
              if(iert.eq.0) then
                 ilplot=.true.
                 fun(1:n1,1:n1)=rrad3(izch,1:n1,1:n1)
              endif
           elseif(lchar('B'))then
              zhlbl='line+brems radiation rate'
              zflbl='watts/ion'
              call get_charge_state(iert)
              jizch=izch-1
              if(iert.eq.0) then
                 ilplot=.true.
                 fun(1:n1,1:n1)=rrad_brem3(izch,1:n1,1:n1)+&
                      &rrad3(izch,1:n1,1:n1)
              endif
           elseif(lchar('C'))then
              ilplot2=.false.
              zhlbl1='line radiation rate'
              zhlbl2='line+brems radiation rate'
              zflbl='watts/ion'
              call get_charge_state(iert)
              jizch=izch-1
              if(iert.eq.0) then
                 ilplot2=.true.
                 fun(1:n1,1:n1)=rrad3(izch,1:n1,1:n1)
                 fun2(1:n1,1:n1)=rrad_brem3(izch,1:n1,1:n1)+&
                      &rrad3(izch,1:n1,1:n1)
              endif
              
           endif
        elseif(lchar('E'))then
           zhlbl='CE, density fraction'
           zflbl=' '
           call get_charge_state(iert)
           jizch=izch-1
           if(iert.eq.0) then
              ilplot=.true.
              fun(1:n1,1:n1)=rcoron3(izch,1:n1,1:n1)
           endif
        elseif(lchar('A'))then
           zhlbl='CE, average charge'
           jizch=-1
           zflbl=' '
           ilplot=.true.
           izch=1
           fun=zero
           do i=1,izimp
              fun(1:n1,1:n1)=fun(1:n1,1:n1)+i*rcoron3(i+1,1:n1,1:n1)
           enddo
        elseif(lchar('C'))then
           if(lxout(0)) write(luntrm,*) &
                ' L -- CE radiation rate, line only ' 
           if(lxout(0)) write(luntrm,*) &
                ' B -- CE radiation rate, line+bremsstrahlung ' 
           if(lxout(0)) write(luntrm,*) &
                ' C -- compare CE(line) and CE(line+bremsstrahlung) radiation rates' 
           if(lxout(0)) write(luntrm,*) &
                ' Q -- to exit' 
           call uread('select option:$')
           if(lchar('Q'))then
              exit
           elseif(lchar('L')) then
              zhlbl='CE radiation(line only)'
              zflbl='watts'
              izch=1
              jizch=-1
              ilplot=.true.
              fun(1:n1,1:n1)=rcorrad3(1:n1,1:n1)
           elseif(lchar('B'))then
              zhlbl='CE radiation rate(line+brems)'
              zflbl='watts'
              izch=1
              jizch=-1
              ilplot=.true.
              fun(1:n1,1:n1)=rcorrad_brem3(1:n1,1:n1)
           elseif(lchar('C'))then
              zhlbl1='CE radiation rate(line)'
              zhlbl2='CE radiation rate(line+brems)'
              zflbl='watts'
              izch=1
              jizch=-1
              ilplot2=.true.
              fun(1:n1,1:n1)=rcorrad3(1:n1,1:n1)
              fun2(1:n1,1:n1)=rcorrad_brem3(1:n1,1:n1)
           endif
        elseif(lchar('Q'))then
           exit
        endif

        if(ilplot.or.ilplot2) then

           if(allocated(wk))deallocate(wk)
           allocate(wk(n1,2))
           wk=zero
           ! find impurity atomic weight
           call inv_periodic_table(trim(to_periodic_table(izimp,0.,-1,1)),.true.,jzimp,azimp,iizch)
           
           zlbl2=trim(to_periodic_table(izimp,azimp,jizch,1))

        endif
        if(ilplot) then
           call r8_grf3f1(te,fun,dens,wk,n1,n1,n1,&
                & ' Te',zhlbl,' Ne','KeV' ,zflbl,'1/m3 ',zlbl1,zlbl2,0)
           cycle
        elseif(ilplot2) then
           call r8_grf3f2(te,fun,fun2,dens,wk,n1,n1,n1,&
                & ' Te',zhlbl1,zhlbl2,' Ne','KeV(Te)' ,zflbl,'1/m3(Ne)',zlbl1,zlbl2,0)
        else
           cycle
        endif
     enddo
  enddo
         


contains
  
  subroutine get_charge_state(ierr)
    integer :: ierr,iert
    ierr=1
    izch=0
22  write(luntrm,2011) izimp
2011 format(/&
          &' select charge state from 0 to ',i3/&
          &' Q -- to exit')     
    call uread(' enter integer :$')
    izch=idcod(iert)
    if(iert.ne.0) then
       ierr=1
       return
    else
       if(izch.lt.0.or.izch.gt.izimp) then
          write(luntrm,2012)izimp
2012      format(/&
               &' !wrong selected charge state'/&
               &' !must be in interval [0, ',i3,']')
          goto 22
       else
          ierr=0 
       endif
    endif
    izch=izch+1

  endsubroutine get_charge_state

end subroutine plot_fp_ce
!
subroutine psmmx(item,xmin,xmax,x,nx,nmax,loglin,xminmin,xmaxmax)
  !
  !============
  ! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER nmax,nx,iert,ix
  !============
  ! idecl:  explicitize implicit real declarations:
  real(fp) zmin,r8dcod,zmax,xrat
  !============
  character*(*) item   ! item whose limits are being set
  real(fp) xmin,xmax       ! the set limits (output)
  real(fp) x(nmax)         ! x array spanning the limits (output)
  integer loglin       ! linear=1, log=2 -- spacing control
  real(fp) xminmin         ! the min allowed lower limit (xmin)
  real(fp) xmaxmax         ! the max allowed upper limit (xmax)
  !
  logical lxout,lchar
  !
  character*12 cspc(2)
  data cspc/'linear      ','logarithmic '/
  !
  !--------------------------------------------
  !
5 continue
  if(lxout(0)) write(6,1000) item,xminmin,xmaxmax
1000 format(' hard ',a,' limits:  ',1pe11.4,' to ',1pe11.4)
  !
1001 format(/&
  &' %psmmx:  enter "L" to toggle log/linear spacing control.'/&
  &'  current setting:  ',a)
  !
10 continue
  if(lxout(0)) write(6,1001) cspc(loglin)
  call uread('plotsig:  enter '//item//' lower limit:$')
  if(lchar('L')) then
     loglin=3-loglin
     go to 10
  endif
  zmin=r8dcod(iert)
  if(iert.ne.0) go to 10
!
20 continue
  if(lxout(0)) write(6,1001) cspc(loglin)
  call uread('plotsig:  enter '//item//' upper limit:$')
  if(lchar('L')) then
     loglin=3-loglin
     go to 20
  endif
  zmax=r8dcod(iert)
  if(iert.ne.0) go to 10
  !
  xmin=min(zmin,zmax)
  xmax=max(zmin,zmax)
  !
  if((xmin.lt.xminmin).or.(xmax.gt.xmaxmax)) then
     call uermsg('?psmmx:  hard limits exceeded.',' ',0)
     go to 5
  endif
  !
  !------------------------------------
  !  get no. of pts.
  !
  nx = nmax
  !
  !-------------------------------------
  !  build x vector
  !
  if(loglin.eq.1) then
     !
     do ix=1,nx
        x(ix)=xmin+(ix-1)*(xmax-xmin)/(nx-1)
     enddo
     !
  else
     !
     x(1)=xmin
     xrat=xmax/xmin
     do ix=2,nx
        x(ix)=xmin*xrat**((ix-1)/(nx-1))
     enddo
     !
  endif
  !
  return
end subroutine psmmx

C******************** START FILE UPROMR.FOR ; GROUP UREAD5 ******************
C------
C& UPROMR  REPEAT PROGRAM PROMPT ON TTY FOR UREAD
C  REMIND USER OF PROMPT WHEN FURTHER INPUT IS EXPECTED
      SUBROUTINE UPROMR
C
      USE USERIO
C
      IF(NLINDI.OR.(LCMDIN.EQ.2).OR.((.NOT.NLHOLD).AND.(NCHARC.GT.0)))
     >     RETURN
C
      IF(NCHARA.LE.0) THEN
        WRITE(LUNTRM,7003)
 7003 FORMAT(' % AWAITING USER INPUT:')
      ELSE
        WRITE(LUNTRM,7002)
 7002 FORMAT(' % AWAITING USER INPUT, PROMPT IS:')
        CALL UPROMT
      ENDIF
C
      RETURN
C
      END
C******************** END FILE UPROMR.FOR ; GROUP UREAD5 ******************

!------------------------------------------------------------------------------
!
!  DOSIG_Z -- EVALUATE A CROSS SECTION FROM ALADDIN DATA
!
real(fp) FUNCTION DOSIG_Z(ZEREL,INDXR,ZLBL)
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod   
  use alpcom_mod
  use alcom_mod
  IMPLICIT NONE
  INTEGER indxr,isigind_z,ier
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) zerel,zsigma,dosigx_z
!============
  CHARACTER*(*) ZLBL
!
!  INPUT ZEREL = REL. ENERGY AT WHICH TO EVALUATE CROSS SECTION
!        INDXR = REACTION INDEX (IF ALREADY KNOWN) OR ZERO
!        ZLBL  = REACTION LABEL (USED IF INDEX NOT KNOWN)
!
!  OUTPUT INDXR = NONZERO REACTION INDEX (IF INDXR=0 ON INPUT)
!         DOSIG = CROSS SECTION (INTERPOLATED OR EXTRAPOLATED FROM
!                 ALADDIN DATA)
!
!------------------------------------------------------------------------------
!
  IF(INDXR.EQ.0) THEN
     INDXR=ISIGIND_Z(ZLBL)
  ENDIF
!
  IF((ALEMIN(INDXR).LE.ZEREL).AND.(ZEREL.LE.ALEMAX(INDXR))) THEN
!
!  IN RANGE -- USE FIT
     NCF=NALPCF(INDXR)
     CF(1:ncf)=ALPCF(1:ncf,INDXR)
     CALL ALAD_EVAL_Z(ZEREL,ZSIGMA,1,IER)
  ELSE
!
!  OUT OF RANGE -- USE EXTRAPOLATION
     ZSIGMA=DOSIGX_Z(ZEREL,INDXR)
  ENDIF
!
  DOSIG_Z=ZSIGMA
!
  RETURN
END FUNCTION DOSIG_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C-------------------------------------------------------------
C GRFEBY - PLOT HORIZONTAL (X) ERROR BAR
C
      SUBROUTINE GRFEBY(X0,Y0,YEB,ZDX)
C
C  (X0,Y0) PT ABOUT WHICH ERROR BAR IS DRAWN
C  YEB  Y ERROR (UNCERTAINTY) +/- YEB ABOUT X0
C  ZDX  HALF-HEIGHT OF "T" END OF ERROR BAR TO DRAW
C
C      ___
C       |
C       |
C       X
C       |
C       |
C      ---
C
      REAL XPERR(2),YPERR(2)
C
      ILINE=1
C
      YPERR(1)=Y0-YEB
      YPERR(2)=Y0+YEB
C
      XPERR(1)=X0
      XPERR(2)=X0
C
      CALL DPLOT1(XPERR,YPERR,2,ILINE)
C
      YPERR(1)=Y0-YEB
      YPERR(2)=Y0-YEB
C
      XPERR(1)=X0-ZDX
      XPERR(2)=X0+ZDX
C
      CALL DPLOT1(XPERR,YPERR,2,ILINE)
C
      YPERR(1)=Y0+YEB
      YPERR(2)=Y0+YEB
C
      CALL DPLOT1(XPERR,YPERR,2,ILINE)
C
      RETURN
      END

      subroutine mkfrid(runid, start, end)
C
C     Get start and end of runid
C
C     11/04/96 CAL
C
      implicit NONE
C
      character*(*) runid
      integer       start, end
 
      integer       ic, l
 
      l = len(runid)
      ic = 1
      do 10 while (runid(ic:ic) .eq. ' ' .and. ic .lt. l)
        ic = ic+1
 10   continue
      start = ic
C
      if (runid(l:l) .ne. ' ') then
         end = l
      else
         end = l-1
      end if
      return
      end
 
 
 

real(fp) FUNCTION R8_ZEROIN(AX,BX,F,TOL,EPSLON)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, one, two
  implicit none
  real(fp), parameter :: THREE = 3.0_fp
  real(fp) :: epslon,zansr
  real(fp) :: AX,BX,F,TOL
  external F
  !
  !      A ZERO OF THE FUNCTION  F(X)  IS COMPUTED IN THE INTERVAL AX,BX .
  !
  !  INPUT..
  !
  !  AX     LEFT ENDPOINT OF INITIAL INTERVAL
  !  BX     RIGHT ENDPOINT OF INITIAL INTERVAL
  !  F      FUNCTION SUBPROGRAM WHICH EVALUATES F(X) FOR ANY X IN
  !         THE INTERVAL  AX,BX
  !  TOL    DESIRED LENGTH OF THE INTERVAL OF UNCERTAINTY OF THE
  !         FINAL RESULT ( .GE. 0.0)
  !
  !
  !  OUTPUT..
  !
  !  R8_ZEROIN ABCISSA APPROXIMATING A ZERO OF  F  IN THE INTERVAL AX,BX
  !
  !
  !      IT IS ASSUMED  THAT   F(AX)   AND   F(BX)   HAVE  OPPOSITE  SIGNS
  !  WITHOUT  A  CHECK.  R8_ZEROIN  RETURNS A ZERO  X  IN THE GIVEN INTERVAL
  !  AX,BX  TO WITHIN A TOLERANCE  4*MACHEPS*ABS(X) + TOL, WHERE MACHEPS
  !  IS THE RELATIVE MACHINE PRECISION.
  !      THIS FUNCTION SUBPROGRAM IS A SLIGHTLY  MODifIED  TRANSLATION  OF
  !  THE ALGOL 60 PROCEDURE  ZERO  GIVEN IN  RICHARD BRENT, ALGORITHMS FOR
  !  MINIMIZATION WITHOUT DERIVATIVES, PRENTICE - HALL, INC. (1973).
  !
  !  dmc 10 Nov 1998 -- added a test to enforces AX.le.R8_ZEROIN.le.BX
  !    or AX.ge.R8_ZEROIN.ge.BX on exit
  !
  !
  real(fp) :: A,B,C,D,E,EPS,FA,FB,FC,TOL1,XM,P,Q,R,S
  !
  !  COMPUTE EPS, THE RELATIVE MACHINE PRECISION
  !
  !      EPS = 1.0
  !   10 EPS = EPS/2.0
  !      TOL1 = 1.0 + EPS
  !      if (TOL1 .GT. 1.0) GO TO 10
  EPS = EPSLON
  !
  ! INITIALIZATION
  !
  A = AX
  B = BX
  FA = F(A)
  FB = F(B)
  !
  ! BEGIN STEP
  !
20 C = A
  FC = FA
  D = B - A
  E = D
30 if (ABS(FC) .GE. ABS(FB)) GO TO 40
  A = B
  B = C
  C = A
  FA = FB
  FB = FC
  FC = FA
  !
  ! CONVERGENCE TEST
  !
40 TOL1 = TWO*EPS*ABS(B) + HALF*TOL
  XM = HALF*(C - B)
  if (ABS(XM) .LE. TOL1) GO TO 90
  if (FB .EQ. ZERO) GO TO 90
  !
  ! IS BISECTION NECESSARY
  !
  if (ABS(E) .LT. TOL1) GO TO 70
  if (ABS(FA) .LE. ABS(FB)) GO TO 70
  !
  ! IS QUADRATIC INTERPOLATION POSSIBLE
  !
  if (A .NE. C) GO TO 50
  !
  ! LINEAR INTERPOLATION
  !
  S = FB/FA
  P = TWO*XM*S
  Q = ONE- S
  GO TO 60
  !
  ! INVERSE QUADRATIC INTERPOLATION
  !
50 Q = FA/FC
  R = FB/FC
  S = FB/FA
  P = S*(TWO*XM*Q*(Q - R) - (B - A)*(R - ONE))
  Q = (Q - ONE)*(R - ONE)*(S - ONE)
  !
  ! ADJUST SIGNS
  !
60 if (P .GT. ZERO) Q = -Q
  P = ABS(P)
  !
  ! IS INTERPOLATION ACCEPTABLE
  !
  if ((TWO*P) .GE. (THREE*XM*Q - ABS(TOL1*Q))) GO TO 70
  if (P .GE. ABS(HALF*E*Q)) GO TO 70
  E = D
  D = P/Q
  GO TO 80
  !
  ! BISECTION
  !
70 D = XM
  E = D
  !
  ! COMPLETE STEP
  !
80 A = B
  FA = FB
  if (ABS(D) .GT. TOL1) B = B + D
  if (ABS(D) .LE. TOL1) B = B + SIGN(TOL1, XM)
  FB = F(B)
  if ((FB*(FC/ABS(FC))) .GT. ZERO) GO TO 20
  GO TO 30
  !
  ! DONE
  !
90 continue
  zansr = B                    ! dmc -- guarantee answer is in range
  zansr = max(zansr,min(ax,bx))
  zansr = min(zansr,max(ax,bx))
  R8_ZEROIN = zansr
  !
  RETURN
END FUNCTION R8_ZEROIN

C-----------------------------------------------------------------------
C  GFTCSS -- SET SG SYMBOL CODES
C
      SUBROUTINE GFTCSS
C
      INCLUDE 'GFTIC'
C
      LOGICAL, EXTERNAL :: LCHAR,LXOUT,LYES,LYESC
C
C------------------------------
C
      if(.not.init_gftic) call gftic0
C
      LUNTRM=LNOUT(0)
C
      IMAXI=IGFTMAXS  ! MAXIMUM SYMBOL CODE INDEX
C
      CALL NEUPAG
 10   CONTINUE
      IF(LXOUT(0)) THEN
        WRITE(LUNTRM,1001) (I,LSYSTL(I),I=1,IMAXI)
 1001   FORMAT(/' CURRENT SYMBOL SELECTION CODES:'/
     >    5(1X,I2,':  ',I2,4X)/)
        WRITE(LUNTRM,1002) IMAXI
 1002   FORMAT(
     >    ' THE MEANING OF SYMBOL SELECTION CODES ARE DESCRIBED IN THE'/
     >    ' SGLIB HELP FILE.  LEGAL CODE VALUES RANGE FROM -11 TO -1'/
     >    ' (FOR FILLED IN SYMBOLS) AND 1 TO 15 ("REGULAR" SYMBOLS).'//
     >    ' OPTIONS:'/
     >    '  >ENTER A NUMBER BTW 1 AND ',I2,' TO MODIFY CORRESPONDING'/
     >    '      SYMBOL SELECTION CODE'/
     >    '  >ENTER "Q" TO QUIT (NO MORE CHANGES)'/)
      ENDIF
      CALL UREAD('GFTCSS:  ENTER SYMBOL CODE MODIFICATION OPTION:$')
      IF(LCHAR('Q')) RETURN
C
      INDX=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 10
C
      IF((INDX.LT.1).OR.(INDX.GT.IMAXI)) THEN
        CALL UERMSI(' SYMBOL CODE INDEX OUT OF RANGE',INDX,1)
        GO TO 10
      ENDIF
C
      ICOD=LSYSTL(INDX)
      CALL UREADI(' ENTER NEW SYMBOL CODE:$',ICOD)
C
      IF((ICOD.LT.-11).OR.(ICOD.EQ.0).OR.(ICOD.GT.15)) THEN
        CALL UERMSI(' SYMBOL CODE VALUE OUT OF RANGE',ICOD,1)
        GO TO 10
      ENDIF
C
      LSYSTL(INDX)=ICOD
C
      GO TO 10
      END

C******************** START FILE IRNS.FOR ; GROUP RNG ******************
      FUNCTION IRNS(IDUMMY)
C  11/29/78
C  THIS FUNCTION WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON PLASMA
C  PHYSICS LAB.  IRNS WILL RETURN A UNIQUE INTEGER SUITABLE FOR SETTING
C  THE RANDOM NUMBER SEED.
c  5/01 RGA -- replace with f90 standard call
      integer iv(8)
      call date_and_time(values=iv)
      secnds = 60*(60*iv(5)+iv(6))+iv(7)+iv(8)/1000.
 
      IRNS=1.E4*SECNDS
      IRNS = 2*IRNS + 1	!MAKE SURE IT'S ODD, RTM 26 FEB 86
      RETURN
      END
C******************** END FILE IRNS.FOR ; GROUP RNG ******************

!---------------------------------------------------------------------!
! adas_bms_splines.f90:                                               !
!     by Michael Kraus (michael.kraus@ipp.mpg.de)                     !
!     created 2009/06/11                                              !
!                                                                     !
! EzSpline wrapper for adas beam stopping data                        !
! takes care of creating, evaluation and freeing of spline objects    !
!                                                                     !
! - spline objects stay in memory after creation                      !
! - saves beam and plasma species for checking if reloading data is   !
!   necessary                                                         !
! - at first adas_initSplines() must be called to allocate all        !
!   arrays with a size equivalent to the number of plasma species     !
!   and create the spline objects                                     !
! - then for each species adas_setSplineData() has to be called to    !
!   feed the splines with data                                        !
! - adas_evalSpline() evaluates the splines                           !
! - after finishing all data requests adas_closeSplines() should be   !
!   called to free splines and deallocate arrays                      !
! - for error codes see adas_bms.f90                                  !
!                                                                     !
!                                                                     !
! References:                                                         !
!                                                                     !
!    1. NTCC PSPLINE Module                                           !
!       http://w3.pppl.gov/ntcc/PSPLINE/                              !
!                                                                     !
!---------------------------------------------------------------------!

module adas_bms_splines
  use EZspline_obj
  use EZspline
  implicit none      
!
! beamE           : beam energy
! beamEA          : beam energy per nucleon
! beamZ           : beam atomic charge
!
! targetZ(N)      : target atomic charge
!
! sigvex_ezspl      : 3D EzSpline object for beam stopping coefficient S(EB,Ni,Ti)
! en_ezspl        : 2D EzSpline object for beam stopping coefficient S(EB,Ni)
! t_ezspl         : 1D EzSpline object for beam stopping coefficient S(Ti)
! bcs_e, bcs_n    : boundary conditions for en_ezspl spline object
! bcs_t           : boundary conditions for  t_ezspl spline object
!
! ebref(N)        : reference beam energy
! niref(N)        : reference target density
! tiref(N)        : reference target temperature
! svref(N)        : beam stopping coefficient at reference beam energy, target density and temperature SV(EB_ref, Ni_ref, Ti_ref)
!

      integer :: Nspl
      integer :: beamZ
      real(fp)  :: beamE, beamEA
      
      real(fp), ALLOCATABLE :: targetZ(:)
      real(fp), ALLOCATABLE :: svref(:), ebref(:), niref(:), tiref(:)
      
      type(EZspline3) :: sigvex_ezspl
      type(EZspline2), ALLOCATABLE :: en_ezspl(:)
      type(EZspline1), ALLOCATABLE :: t_ezspl(:)
      type(EZspline1) :: sigv1_ezspl
      
      integer :: bcs_e(2), bcs_n(2), bcs_t(2)
      
      save Nspl, beamZ, beamE, beamEA, targetZ
      save svref, ebref, niref, tiref
      save sigvex_ezspl, en_ezspl, t_ezspl,sigv1_ezspl, bcs_e, bcs_n, bcs_t
      
      
      
CONTAINS

! initialise spline object arrays and spline objects
subroutine adas_initSplines(tN, iErr)
      integer :: tN, iErr, tErr
      
      iErr = 0
      
      ! EzSpline boundary conditions
      bcs_e = (/0, 0/)     ! not-a-knot boundary conditions
      bcs_n = (/0, 0/)     ! not-a-knot boundary conditions
      bcs_t = (/0, 0/)     ! not-a-knot boundary conditions

      ! init arrays
      Nspl = tN
      
      
      ALLOCATE(targetZ(Nspl), STAT=tErr)
      if (tErr .gt. 0) then ! array could not be allocated
         iErr = 9
         write(*,*) "ADAS Error: could not allocate array 'targetZ'"
         return
      endif
      
      ALLOCATE(ebref(Nspl), STAT=tErr)
      if (tErr .gt. 0) then ! array could not be allocated
         iErr = 9
         write(*,*) "ADAS Error: could not allocate array 'ebref'"
         return
      endif
      
      ALLOCATE(niref(Nspl), STAT=tErr)
      if (tErr .gt. 0) then ! array could not be allocated
         iErr = 9
         write(*,*) "ADAS Error: could not allocate array 'niref'"
         return
      endif
      
      ALLOCATE(tiref(Nspl), STAT=tErr)
      if (tErr .gt. 0) then ! array could not be allocated
         iErr = 9
         write(*,*) "ADAS Error: could not allocate array 'tiref'"
         return
      endif
      
      ALLOCATE(svref(Nspl), STAT=tErr)
      if (tErr .gt. 0) then ! array could not be allocated
         iErr = 9
         write(*,*) "ADAS Error: could not allocate array 'svref'"
         return
      endif
      
      ALLOCATE(en_ezspl(Nspl), STAT=tErr)
      if (tErr .gt. 0) then ! array could not be allocated
         iErr = 9
         write(*,*) "ADAS Error: could not allocate array 'en_ezspl'"
         return
      endif
      
      ALLOCATE(t_ezspl(Nspl), STAT=tErr)
      if (tErr .gt. 0) then ! array could not be allocated
         iErr = 9
         write(*,*) "ADAS Error: could not allocate array 't_ezspl'"
         return
      endif
      
      return
    end subroutine adas_initSplines


! set spline data for species with index iSpl
subroutine adas_setSplineData(iSpl,                & 
           &                  nESpl, nNSpl, nTSpl, &
           &                  pESpl, pNSpl, pTSpl, &
           &                  dENSpl, dTSpl,       &
           &                  iErr)
      
      integer :: iSpl, nESpl, nNSpl, nTSpl, iErr, sErr
      real(fp)  :: tSVRef
      real(fp)  :: pESpl(nESpl), pNSpl(nNSpl), pTSpl(nTSpl)
      real(fp)  :: dENSpl(nESpl, nNSpl), dTSpl(nTSpl)
      real(fp)  :: logESpl(nESpl), logNSpl(nNSpl), logTSpl(nTSpl)
      real(fp)  :: logdENSpl(nESpl, nNSpl), logdTSpl(nTSpl)
     
      integer :: ie, in, it 
!
! iSpl            : species index
! iErr            : error code
!
! nESpl           : number of beam energy        grid points
! nNSpl           : number of target density     grid points
! nTSpl           : number of target temperature grid points
!
! pESpl(nESpl)    : beam energy        grid points
! pNSpl(nNSpl)    : target density     grid points
! pTSpl(nTSpl)    : target temperature grid points
!
! dENSpl(nESpl,nNSpl) : beam stopping coefficient data S(E,N)
! dTSpl(nTSpl)        : beam stopping coefficient data S(T)
!
! ie, in, it      : loop variables
!
      
      ! check if all data/spline arrays are allocated
      if (.NOT. (ALLOCATED(svref) .AND. ALLOCATED(en_ezspl) &
                &                 .AND. ALLOCATED(t_ezspl)) ) then
         iErr = 8
         return
      endif
      
      
      ! calculate logarithms
      do ie=1,nESpl
         logESpl(ie) = dlog(pESpl(ie))
      enddo
      
      do in=1,nNSpl
         logNSpl(in) = dlog(pNSpl(in))
      enddo
      
      do in=1,nNSpl
         do ie=1,nESpl
            logdENSpl(ie,in) = dlog(dENSpl(ie,in))
         enddo
      enddo
      
      do it=1,nTSpl
         logTSpl(it) = dlog(pTSpl(it))
         logdTSpl(it) = dlog(dTSpl(it))
      enddo
            
            
      ! S(EBA, NI)
      call EZspline_init(en_ezspl(iSpl), nESpl, nNSpl, bcs_e, bcs_n, sErr) ! initialise spline object grid and boundary conditions
      call EZspline_error(sErr)                            ! print error message
      if (sErr .ne. 0) then                                ! interrupt routine in case of error
         iERR = 7
         return
      endif
      en_ezspl(iSpl)%x1 = logESpl(1:nESpl)                    ! set grid points in x-direction
      en_ezspl(iSpl)%x2 = logNSpl(1:nNSpl)                    ! set grid points in y-direction
      call EZspline_setup(en_ezspl(iSpl), logdENSpl(1:nESpl,1:nNSpl), sErr)     ! set up coefficients
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 7
         return
      endif
      
      
      ! S(TIA)
      call EZspline_init(t_ezspl(iSpl), nTSpl, bcs_t, sErr) ! initialise spline object grid and boundary conditions
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 7
         return
      endif
      t_ezspl(iSpl)%x1 = logTSpl(1:nTSpl)                     ! set grid points
      call EZspline_setup(t_ezspl(iSpl), logdTSpl(1:nTSpl), sErr)       ! initialise spline data
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 7
         return
      endif
      
      return
    end subroutine adas_setSplineData
! set spline data for one species 
subroutine adas_setSplineData3(nESpl, nNSpl, nTSpl, &
           &                  pESpl, pNSpl, pTSpl, &
           &                  dENSpl, iErr)
      
      integer :: nESpl, nNSpl, nTSpl, iErr, sErr,tErr
      real(fp)  :: tSVRef
      real(fp)  :: pESpl(nESpl), pNSpl(nNSpl), pTSpl(nTSpl)
      real(fp)  :: dENSpl(nESpl, nNSpl, nTSpl)
      real(fp)  :: logESpl(nESpl), logNSpl(nNSpl), logTSpl(nTSpl)
      real(fp)  :: logdENSpl(nESpl, nNSpl, nTSpl)
     
      integer :: ie, in, it 
!
! iErr            : error code
!
! nESpl           : number of beam energy        grid points
! nNSpl           : number of target density     grid points
! nTSpl           : number of target temperature grid points
!
! pESpl(nESpl)    : beam energy        grid points
! pNSpl(nNSpl)    : target density     grid points
! pTSpl(nTSpl)    : target temperature grid points
!
! dENSpl(nESpl,nNSpl,nTSpl) : beam stopping coefficient data S(E,N,T)
!
! ie, in, it      : loop variables
!
      ! EzSpline boundary conditions
      bcs_e = (/0, 0/)     ! not-a-knot boundary conditions
      bcs_n = (/0, 0/)     ! not-a-knot boundary conditions
      bcs_t = (/0, 0/)     ! not-a-knot boundary conditions
      
      
      ! calculate logarithms
      do ie=1,nESpl
         logESpl(ie) = dlog(pESpl(ie))
      enddo
      
      do in=1,nNSpl
         logNSpl(in) = dlog(pNSpl(in))
      enddo
      
      do it=1,nTSpl
         logTSpl(it) = dlog(pTSpl(it))
         do in=1,nNSpl
            do ie=1,nESpl
               logdENSpl(ie,in,it) = dlog(dENSpl(ie,in,it))
            enddo
         enddo
      
      enddo
            
            
      ! S(EBA, NI, T)
      if(EZspline_allocated(sigvex_ezspl))then
         call EZspline_free(sigvex_ezspl, tErr)
         call EZspline_error(tErr)
      endif
      call EZspline_init(sigvex_ezspl, nESpl, nNSpl, nTSpl, bcs_e, bcs_n, bcs_t, sErr) ! initialise spline 
                                                                                           ! object grid and boundary 
                                                                                           ! conditions
      call EZspline_error(sErr)                            ! print error message
      if (sErr .ne. 0) then                                ! interrupt routine in case of error
         iERR = 7
         return
      endif
      sigvex_ezspl%x1 = logESpl(1:nESpl)                    ! set grid points in x-direction
      sigvex_ezspl%x2 = logNSpl(1:nNSpl)                    ! set grid points in y-direction
      sigvex_ezspl%x3 = logTSpl(1:nTSpl)                     ! set grid points
      call EZspline_setup(sigvex_ezspl, logdENSpl(1:nESpl,1:nNSpl,1:nTSpl), sErr)     ! set up coefficients
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 7
         return
      endif
      
      
      return
    end subroutine adas_setSplineData3
subroutine adas_setSplineData1(nESpl, pESpl,dENSpl, iErr)
      
      integer :: nESpl,  iErr, sErr, tErr
      real(fp)  :: pESpl(nESpl)
      real(fp)  :: dENSpl(nESpl)
      real(fp)  :: logESpl(nESpl)
      real(fp)  :: logdENSpl(nESpl)
     
      integer :: ie
!
! iErr            : error code
!
! nESpl           : number of beam energy        grid points
!
! pESpl(nESpl)    : beam energy        grid points
!
! dENSpl(nESpl) : beam stopping coefficient data S(E)
!
! ie    : loop variables
!
      ! EzSpline boundary conditions
      bcs_e = (/0, 0/)     ! not-a-knot boundary conditions
      
      
      ! calculate logarithms
      do ie=1,nESpl
         logESpl(ie) = dlog(pESpl(ie))
      enddo
      
      do ie=1,nESpl
         logdENSpl(ie) = dlog(dENSpl(ie))
      enddo
            
            
      ! S(EBA)
      if(EZspline_allocated(sigv1_ezspl))then
            call EZspline_free(sigv1_ezspl, tErr)
            call EZspline_error(tErr)
      endif
      call EZspline_init(sigv1_ezspl, nESpl, bcs_e, sErr) ! initialise spline 
                                                                                           ! object grid and boundary 
                                                                                           ! conditions
      call EZspline_error(sErr)                            ! print error message
      if (sErr .ne. 0) then                                ! interrupt routine in case of error
         iERR = 7
         return
      endif
      sigv1_ezspl%x1 = logESpl(1:nESpl)                    ! set grid points in x-direction
      call EZspline_setup(sigv1_ezspl, logdENSpl(1:nESpl), sErr)     ! set up coefficients
      call EZspline_error(sErr)                             ! print error message
      if (sErr .ne. 0) then                                 ! interrupt routine in case of error
         iERR = 7
         return
      endif
      
      
      return
    end subroutine adas_setSplineData1



! functions for reading min and max values

function minE(iSpl)
   real(fp)  :: minE
   integer :: iSpl
   minE = dexp(en_ezspl(iSpl)%x1min)
   return
end function

function maxE(iSpl)
   real(fp)  :: maxE
   integer :: iSpl
   maxE = dexp(en_ezspl(iSpl)%x1max)
   return
end function


function minN(iSpl)
   real(fp)  :: minN
   integer :: iSpl
   minN = dexp(en_ezspl(iSpl)%x2min)
   return
end function

function maxN(iSpl)
   real(fp)  :: maxN
   integer :: iSpl
   maxN = dexp(en_ezspl(iSpl)%x2max)
   return
end function


function minT(iSpl)
   real(fp)  :: minT
   integer :: iSpl
   minT = dexp(t_ezspl(iSpl)%x1min)
   return
end function

function maxT(iSpl)
   real(fp)  :: maxT
   integer :: iSpl
   maxT = dexp(t_ezspl(iSpl)%x1max)
   return
end function



! get interpolated value
subroutine adas_evalSpline(iSpl, reqEA, reqNeff, reqTi, &
           &               reqSV, iErr                  )
           
      real(fp)  :: reqEA, reqNeff, reqTi, reqSV
      real(fp)  :: rsven, rsvt, rsvratio
!mg real(fp)  ::  Tieff
      real(fp)  :: logEA, logNeff, logTi
      real(fp)  :: logSVen, logSVt
      real(fp)  :: logSVn1, logSVn2
      real(fp)  :: logSVn11, logSVn12,logSVn21, logSVn22
      real(fp)  :: logSVt1, logSVt2
      integer :: iSpl, iErr, sErr,ierr_extrapol
      real(fp)  :: x_tables(4),f_tables(2,2),x_point(2)
!
! iSpl            : spline index of requested species
! iErr            : error code
! sErr            : EzSpline error code
!
! reqEA           : requested beam energy per nucleon EB/Amu [eV/ami]
! reqNeff         : requested effective density [1/cm**3]
! reqTi           : requested target temperature [eV/ami]
! reqSV           : requested beam stopping coefficient
!
! rsven           : result of spline interpolation of S(EB,Ni)
! rsvt            : result of spline interpolation of S(Ti)
! rsvratio        : temperature correction factor (rsvt / svref)
!

      iErr     = 0
      
      ! check if all data/spline arrays are allocated
      if (.NOT. (ALLOCATED(svref) .AND. ALLOCATED(en_ezspl) &
                &                 .AND. ALLOCATED(t_ezspl)  &
                &                 .AND. ALLOCATED(targetZ)) ) then
         iErr = 8
         return
      endif
      
      
      ! scale target temperature by nuclear number of requested isotope
      ! up to now only for H-isotopes (H,D,T)
!mg      if (targetZ(iSpl) .eq. 1) then
         ! calculate ion temperature per nucleon TI(i)/AI(i)
!mg      else
!mg         Tieff = reqTi
!mg      endif
      if((reqEA.eq.0.0_fp).or.(reqTi.eq.0.0_fp).or.(reqNeff.eq.0.0_fp)) then
         reqSV    = 0.0_fp
         return
      else
         
         logEA   = dlog(reqEA)
         logTi   = dlog(reqTi)
         logNeff = dlog(reqNeff)
      endif
      
      ! check if requested beam energy and target density is within
      ! the available domain
      call EZspline_isInDomain(en_ezspl(iSpl), logEA, logNeff, sErr)
      if (sErr .ne. 0) then
         x_tables=0.0_fp
         f_tables=0.0_fp
         x_point=0.0_fp
         ! requested value out of range, extrapolate
         if (logNeff .le. en_ezspl(iSpl)%x2min) then
            if(logEA .le. en_ezspl(iSpl)%x1min) then
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(1), en_ezspl(iSpl)%x2(2),   logSVn12, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(2), en_ezspl(iSpl)%x2(1), logSVn21, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(2), en_ezspl(iSpl)%x2(2),   logSVn22, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(1), en_ezspl(iSpl)%x2(1), logSVn11, sErr)
               x_point(1)=logEA
               x_point(2)=logNeff
               x_tables(1)=en_ezspl(iSpl)%x1(1)
               x_tables(2)=en_ezspl(iSpl)%x1(2)
               x_tables(3)=en_ezspl(iSpl)%x2(1)
               x_tables(4)=en_ezspl(iSpl)%x2(2)
               f_tables(1,2)=logSVn12
               f_tables(2,1)=logSVn21
               f_tables(2,2)=logSVn22
               f_tables(1,1)=logSVn11
               call linear_interp_2d(x_point,x_tables,f_tables,logSVen,ierr_extrapol)
               if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
            else if(logEA .ge. en_ezspl(iSpl)%x1max) then
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1), &
                    &en_ezspl(iSpl)%x2(2),   logSVn12, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1-1), &
                    &en_ezspl(iSpl)%x2(1), logSVn21, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1-1), &
                    &en_ezspl(iSpl)%x2(2),   logSVn22, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1), &
                    &en_ezspl(iSpl)%x2(1), logSVn11, sErr)
               x_point(1)=logEA
               x_point(2)=logNeff
               x_tables(1)=en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1)
               x_tables(2)=en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1-1)
               x_tables(3)=en_ezspl(iSpl)%x2(1)
               x_tables(4)=en_ezspl(iSpl)%x2(2)
               f_tables(1,2)=logSVn12
               f_tables(2,1)=logSVn21
               f_tables(2,2)=logSVn22
               f_tables(1,1)=logSVn11
               call linear_interp_2d(x_point,x_tables,f_tables,logSVen,ierr_extrapol)
               if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
            endif
         else if (logNeff .ge. en_ezspl(iSpl)%x2max) then
            if(logEA .le. en_ezspl(iSpl)%x1min) then
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(1), en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2),   logSVn12, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(2), en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2-1), logSVn21, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(2), en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2),   logSVn22, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(1), en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2-1), logSVn11, sErr)
               x_point(1)=logEA
               x_point(2)=logNeff
               x_tables(1)=en_ezspl(iSpl)%x1(1)
               x_tables(2)=en_ezspl(iSpl)%x1(2)
               x_tables(3)=en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2)
               x_tables(4)=en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2-1)
               f_tables(1,2)=logSVn12
               f_tables(2,1)=logSVn21
               f_tables(2,2)=logSVn22
               f_tables(1,1)=logSVn11
               call linear_interp_2d(x_point,x_tables,f_tables,logSVen,ierr_extrapol)
               if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
            else if(logEA .ge. en_ezspl(iSpl)%x1max) then
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1), &
                    &en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2),   logSVn12, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1-1), &
                    &en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2-1), logSVn21, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1-1), &
                    &en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2),   logSVn22, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1), &
                    &en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2-1), logSVn11, sErr)
               x_point(1)=logEA
               x_point(2)=logNeff
               x_tables(1)=en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1)
               x_tables(2)=en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1-1)
               x_tables(3)=en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2)
               x_tables(4)=en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2-1)
               f_tables(1,2)=logSVn12
               f_tables(2,1)=logSVn21
               f_tables(2,2)=logSVn22
               f_tables(1,1)=logSVn11
               call linear_interp_2d(x_point,x_tables,f_tables,logSVen,ierr_extrapol)
               if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
            else !logEA inside the interval
               call EZspline_interp(en_ezspl(iSpl), logEA, en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2),   logSVn1, sErr)
               call EZspline_interp(en_ezspl(iSpl), logEA, en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2-1), logSVn2, sErr)
               x_tables(1)=en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2)
               x_tables(2)=en_ezspl(iSpl)%x2(en_ezspl(iSpl)%n2-1)
               f_tables(1,1)=logSVn1
               f_tables(1,2)=logSVn2
              
               call linear_interp (logNeff,x_tables(1:2),f_tables(1,1:2),logSVen,ierr_extrapol)            

               if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
            endif
         else !logNeff inside the interval
            if(logEA .le. en_ezspl(iSpl)%x1min) then
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(1), logNeff, logSVn1, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(2), logNeff, logSVn2, sErr)
               
               x_tables(1)=en_ezspl(iSpl)%x1(1)
               x_tables(2)=en_ezspl(iSpl)%x1(2)
               f_tables(1,1)=logSVn1
               f_tables(1,2)=logSVn2
               call linear_interp (logEA,x_tables(1:2),f_tables(1,1:2),logSVen,ierr_extrapol)            

               if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
            else if(logEA .ge. en_ezspl(iSpl)%x1max) then
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1), logNeff,  logSVn1, sErr)
               call EZspline_interp(en_ezspl(iSpl), en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1-1), logNeff, logSVn2, sErr)
               x_tables(1)=en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1)
               x_tables(2)=en_ezspl(iSpl)%x1(en_ezspl(iSpl)%n1-1)
               f_tables(1,1)=logSVn1
               f_tables(1,2)=logSVn2
               call linear_interp (logEA,x_tables(1:2),f_tables(1,1:2),logSVen,ierr_extrapol)            

               if(ierr_extrapol.ne.0) then !extrapolation error
                  iErr = 7
                  return
               endif
            endif
         endif
      else
         ! get interpolation of beam stopping coefficient S(EB,Ni)
         call EZspline_interp(en_ezspl(iSpl), logEA, logNeff, logSVen, sErr)
         call EZspline_error(sErr)
         if (sErr .ne. 0) then
            iErr = 7
            return
         endif
      endif
      
      ! check if requested target temperature is within the available domain
      call EZspline_isInDomain(t_ezspl(iSpl), logTi, sErr)
      if (sErr .ne. 0) then
         ! requested value out of range, extrapolate
         if (logTi .le. t_ezspl(iSpl)%x1min) then
            call EZspline_interp(t_ezspl(iSpl), t_ezspl(iSpl)%x1(1), logSVt1, sErr)
            call EZspline_interp(t_ezspl(iSpl), t_ezspl(iSpl)%x1(2), logSVt2, sErr)
            
            x_tables(1)=t_ezspl(iSpl)%x1(1)
            x_tables(2)=t_ezspl(iSpl)%x1(2)
            f_tables(1,1)=logSVt1
            f_tables(1,2)=logSVt2
            call linear_interp (logTi,x_tables(1:2),f_tables(1,1:2),logSVt,ierr_extrapol)            
            
            if(ierr_extrapol.ne.0) then !extrapolation error
               iErr = 7
               return
            endif
         else if (logTi .ge. t_ezspl(iSpl)%x1max) then
            call EZspline_interp(t_ezspl(iSpl), t_ezspl(iSpl)%x1(t_ezspl(iSpl)%n1),   logSVt1, sErr)
            call EZspline_interp(t_ezspl(iSpl), t_ezspl(iSpl)%x1(t_ezspl(iSpl)%n1-1), logSVt2, sErr)
            
            x_tables(1)=t_ezspl(iSpl)%x1(t_ezspl(iSpl)%n1)
            x_tables(2)=t_ezspl(iSpl)%x1(t_ezspl(iSpl)%n1-1)
            f_tables(1,1)=logSVt1
            f_tables(1,2)=logSVt2
            call linear_interp (logTi,x_tables(1:2),f_tables(1,1:2),logSVt,ierr_extrapol)            
            
            if(ierr_extrapol.ne.0) then !extrapolation error
               iErr = 7
               return
            endif
         else
            call EZspline_error(sErr)
            iErr = 7
            return
         endif
      else
         ! get interpolation of beam stopping coefficient S(Ti)
         call EZspline_interp(t_ezspl(iSpl), logTi, logSVt, sErr)
         call EZspline_error(sErr)
         if (sErr .ne. 0) then
            iErr = 7
            return
         endif
      endif
      
      rsven = dexp(logSVen)
      rsvt  = dexp(logSVt)
      
      ! check if interpolated values are sensible (positive)
      if (rsven .lt. 0.0 .OR. rsvt .lt. 0.0) then
         iErr = 6
         return
      endif
      
      ! scale S(EB,Ni) according to temperature
      rsvratio = rsvt / svref(iSpl)
      reqSV    = rsven * rsvratio
      
      return
    end subroutine adas_evalSpline
! get interpolated value
subroutine adas_evalSpline1( reqEA, reqSV, iErr  )
           
      real(fp)  :: reqEA,  reqSV
      real(fp)  :: logEA
      real(fp)  :: logSVen
      integer :: i 
      integer :: iErr, sErr, tErr
      
!
! iErr            : error code
! sErr            : EzSpline error code
!
! reqEA           : requested beam energy per nucleon 
! reqSV           : requested beam stopping coefficient
!
!
!

      iErr     = 0
      
      
      if((reqEA.eq.0.0_fp)) then
         reqSV    = 0.0_fp
         return
      else
         logEA   = dlog(reqEA)
      endif
      
      ! check if requested beam energy and target density is within
      ! the available domain
      call EZspline_isInDomain(sigv1_ezspl, logEA, sErr)
      if (sErr .ne. 0) then
         reqSV=0.0_fp
         return
      else  
         ! get interpolation of beam stopping coefficient S(EB)
         call EZspline_interp(sigv1_ezspl, logEA, logSVen, sErr)
         call EZspline_error(sErr)
         if (sErr .ne. 0) then
            reqSV =0.
            return
         endif
      endif
      
      reqSV    = dexp(logSVen)
      
      return
    end subroutine adas_evalSpline1
!
subroutine adas_evalSpline3( reqEA, reqNeff, reqTi, &
           &               reqSV, il_extrp, iErr                  )
           
      real(fp)  :: reqEA, reqNeff, reqTi, reqSV
      real(fp)  :: x_tables(2),logSVn(2)
      real(fp)  :: logEA, logNeff, logTi
      real(fp)  :: logSVen
      logical,intent(in) :: il_extrp !if .true. make an extrapolation
      integer :: i 
      integer :: iErr, sErr, tErr,ierr_extrapol
      logical :: il_E_min,il_N_min,il_T_min
      logical :: il_E_max,il_N_max,il_T_max
      
!
! iErr            : error code
! sErr            : EzSpline error code
!
! reqEA           : requested beam energy per nucleon 
! reqNeff         : requested effective density
! reqTi           : requested target temperature per nucleon
! reqSV           : requested beam stopping coefficient
!NOTE: in case if two or more variables out of range then
!      NO extrapolation will be done, ZERO will be return
!
!

      iErr     = 0
      
      
      if((reqEA.eq.0.0_fp).or.(reqTi.eq.0.0_fp).or.(reqNeff.eq.0.0_fp)) then
         reqSV    = 0.0_fp
         return
      else
         logEA   = dlog(reqEA)
         logTi   = dlog(reqTi)
         logNeff = dlog(reqNeff)
      endif
      
      ! check if requested beam energy and target density is within
      ! the available domain
      call EZspline_isInDomain(sigvex_ezspl, logEA, logNeff, logTi, sErr)
      il_E_min=(logEA.le.sigvex_ezspl%x1min)
      il_E_max=(logEA.ge.sigvex_ezspl%x1max)
      il_N_min=(logNeff.le.sigvex_ezspl%x2min)
      il_N_max=(logNeff.ge.sigvex_ezspl%x2max)
      il_T_min=(logTi.le.sigvex_ezspl%x3min)
      il_T_max=(logTi.ge.sigvex_ezspl%x3max)
      if (sErr .ne. 0) then
         if(.not.il_extrp) then
            reqSV=0.0_fp
            return
         endif
! get linear extrapolation if E out of range
         if(logEA .le. sigvex_ezspl%x1min) then
            if(il_N_min.or.il_N_max.or.il_T_min.or.il_T_max) then
               call EZspline_error(sErr)
               reqSV=0.0_fp
               return
            endif
            call EZspline_interp(sigvex_ezspl, sigvex_ezspl%x1(1), logNeff, logTi, logSVn(1), sErr)
            call EZspline_interp(sigvex_ezspl, sigvex_ezspl%x1(2), logNeff, logTi, logSVn(2), sErr)
            do i=1,2
               x_tables(i)=sigvex_ezspl%x1(i)
            enddo
! linear extrapolation            
            call linear_interp(logEA,x_tables(1:2),logSVn(1:2),logSVen,ierr_extrapol)
            if(ierr_extrapol.ne.0) then !extrapolation error
               iErr = 4
               return
            endif
            
         else if(logEA .ge. sigvex_ezspl%x1max) then
            if(il_N_min.or.il_N_max.or.il_T_min.or.il_T_max) then
               call EZspline_error(sErr)
               reqSV=0.0_fp
               return
            endif
            call EZspline_interp(sigvex_ezspl, sigvex_ezspl%x1(sigvex_ezspl%n1), logNeff, logTi, logSVn(1), sErr)
            call EZspline_interp(sigvex_ezspl, sigvex_ezspl%x1(sigvex_ezspl%n1-1), logNeff,logTi, logSVn(2), sErr)
            do i=1,2
               x_tables(i)=sigvex_ezspl%x1(sigvex_ezspl%n1-i+1)
            enddo
            ! linear extrapolation     
            call linear_interp(logEA,x_tables(1:2),logSVn(1:2),logSVen,ierr_extrapol)
            if(ierr_extrapol.ne.0) then !extrapolation error
               iErr = 4
               return
            endif
         else if(logTi .le. sigvex_ezspl%x3min) then
            if(il_N_min.or.il_N_max.or.il_E_min.or.il_E_max) then
               call EZspline_error(sErr)
               reqSV=0.0_fp
               return
            endif
! get linear extrapolation if T out of range
            call EZspline_interp(sigvex_ezspl, logEA, logNeff, sigvex_ezspl%x3(1), logSVn(1), sErr)
            call EZspline_interp(sigvex_ezspl, logEA, logNeff,  sigvex_ezspl%x3(2), logSVn(2), sErr)
            do i=1,2
               x_tables(i)=sigvex_ezspl%x3(i)
            enddo
            call linear_interp(logTi,x_tables(1:2),logSVn(1:2),logSVen,ierr_extrapol)
            if(ierr_extrapol.ne.0) then !extrapolation error
               iErr = 4
               return
            endif
         else if(logTi .ge. sigvex_ezspl%x3max) then
            if(il_N_min.or.il_N_max.or.il_E_min.or.il_E_max) then
               call EZspline_error(sErr)
               reqSV=0.0_fp
               return
            endif
! get linear extrapolation if T out of range
            call EZspline_interp(sigvex_ezspl, logEA, logNeff, sigvex_ezspl%x3(sigvex_ezspl%n3), logSVn(1), sErr)
            call EZspline_interp(sigvex_ezspl, logEA, logNeff, sigvex_ezspl%x3(sigvex_ezspl%n3-1),logSVn(2), sErr)
            do i=1,2
               x_tables(i)=sigvex_ezspl%x3(sigvex_ezspl%n3-i+1)
            enddo
            call linear_interp(logTi,x_tables(1:2),logSVn(1:2),logSVen,ierr_extrapol)
            if(ierr_extrapol.ne.0) then !extrapolation error
               iErr = 4
               return
            endif
         else 
            call EZspline_error(sErr)
            reqSV=0.0_fp
            iErr = 4
            write(*,'(3(A,E9.3))') " **EZspline** EB/Amu = ",reqEA,"   NEeff = ",reqNeff,"   NTi = ",reqTi
            return
            
         endif
      else 
         
         
         ! get interpolation of beam stopping coefficient S(EB,Ni,Ti)
         call EZspline_interp(sigvex_ezspl, logEA, logNeff,  logTi, logSVen, sErr)
         call EZspline_error(sErr)
         if (sErr .ne. 0) then
            reqSV=0.0_fp
            iErr = 7
            return
         endif
      endif
      
      reqSV    = dexp(logSVen)
      
      return
    end subroutine adas_evalSpline3


! free spline objects and data arrays
subroutine adas_closeSplines(iErr)
      integer :: i, iErr, tErr
      
      iErr = 0
      
      if (ALLOCATED(targetZ)) then
         DEALLOCATE(targetZ, STAT=tErr)
         if (tErr .gt. 0) then
            iErr = 8
            return
         endif
      endif

      if (ALLOCATED(ebref)) then
         DEALLOCATE(ebref, STAT=tErr)
         if (tErr .gt. 0) then
            iErr = 8
            return
         endif
      endif

      if (ALLOCATED(niref)) then
         DEALLOCATE(niref, STAT=tErr)
         if (tErr .gt. 0) then
            iErr = 8
            return
         endif
      endif

      if (ALLOCATED(tiref)) then
         DEALLOCATE(tiref, STAT=tErr)
         if (tErr .gt. 0) then
            iErr = 8
            return
         endif
      endif

      if (ALLOCATED(svref)) then
         DEALLOCATE(svref, STAT=tErr)
         if (tErr .gt. 0) then
            iErr = 8
            return
         endif
      endif

      if (ALLOCATED(en_ezspl)) then
         do i = 1,Nspl
            call EZspline_free(en_ezspl(i), tErr)
            call EZspline_error(tErr)
            if (tErr .gt. 0) iErr = 7
         enddo
         DEALLOCATE(en_ezspl, STAT=tErr)
         if (tErr .gt. 0) then
            iErr = 8
            return
         endif
      endif
      
      if (ALLOCATED(t_ezspl)) then
         do i = 1,Nspl
            call EZspline_free(t_ezspl(i), tErr)
            call EZspline_error(tErr)
            if (tErr .gt. 0) iErr = 7
         enddo
         DEALLOCATE(t_ezspl, STAT=tErr)
         if (tErr .gt. 0) then
            iErr = 8
            return
         endif
      endif
      
      return
end subroutine


end module

!------------------------------------------------------------------------------
!
!  DOSIGX_Z -- DO EXTRAPOLATIONS OF ALADDIN FITS -- SIGTAB/ALADDIN
!
real(fp) FUNCTION DOSIGX_Z(ZEREL,INDXR)
!
!  INPUT:  ZEREL -- REL. ENERGY INPUT (EV/AMU)
!          INDXR -- REACTION INDEX
!
!  ZEREL IS ALREADY KNOWN TO BE OUTSIDE THE FIT RANGE FOR THE INDICATED
!   REACTION.
!
!  OUTPUT:  DOSIGX_Z -- THE EXTRAPOLATED CROSS-SECTION, CM**2
!
!
!  SIGTAB COMMON:
!
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod   
  use physconst_mod, only : za2=>half
  IMPLICIT NONE
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER indxr
!===========
! idecl:  explicitize implicit REAL declarations:
  real(fp) zerel,zlss,zdle,zls,zlsx
!============
  IF(ZEREL.LE.ALEMIN(INDXR)) THEN
     ZLSS=ALSMIN(INDXR)
     ZDLE=log(ALEMIN(INDXR))-log(ZEREL)
     ZLS=log(ALAMIN(INDXR))
!
     ZLSX=ZLS-ZDLE*(ZLSS+ZDLE*ZA2)
!
  ELSE
!
     ZLSS=ALSMAX(INDXR)
     ZDLE=log(ZEREL)-log(ALEMAX(INDXR))
     ZLS=log(ALAMAX(INDXR))
!
     ZLSX=ZLS+ZDLE*(ZLSS-ZDLE*ZA2)
!
  ENDIF
!
  DOSIGX_Z=EXP(ZLSX)
!
  RETURN
END FUNCTION DOSIGX_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C  Get all dimensions of a MDSplus U-file
C
C 02/05/01 CAL
C--------------------------------------------------------------------------
      subroutine ufmds_dim(ichan,ndim,dims,nsca,znode,ier)
C
      use UFILES
      implicit none
 
C Input:
      integer ichan             ! Ufiles channel id
      integer ndim              ! rank of data signal
      character*(*) znode       ! full node path
C Output:
      integer nsca              ! Number of scalars
      integer dims(ndim)
      integer ier
C C Local
      integer       mds_value
      integer       idescr_long
      character*128 zerrmsg
      integer       istat, iretl
      integer       i,     ilm
C-------------------------------------------------------------------------
 
      do i=1,ndim
         call ufmds_size(znode,i,dims(i),ier)
      enddo
      istat=mds_value('size('//znode//':SCLAB)',
     >      idescr_long(nsca),iretl)
      if (mod(istat,2).ne.1) then
         if (istat .ne. 265388144 .and.   ! TREE$-W-NNF
     >       istat .ne. 265388258 .and.   ! TreeNODATA
     >       istat .ne. 0 ) then          ! SS_FACILITY Error
            call ufmds_err('UFMDS_DIM',istat,ier,zerrmsg,ilm)
            write(ufelun,7703) znode,zerrmsg(1:ilm)
 7703       format('  seeking MDS+ size(',a,':SCVAL ',/2x,a)
         endif
         nsca = 0
C 02/23/2010 CLF: we don't need this anymore since we write actual data
C                 this was to handle incorrect size of TDI function
C      else
C         if (nsca .eq. 1) then  ! no scalars
C            nsca = 0
C         else
C            nsca=nsca/3
C         endif
      endif
 
C
      return
      end
 
 
 
 

C******************** START FILE USINIT.FOR ; GROUP USINIT *************
C=================================
C& USINIT  INITIALIZE 'USERIO' UREAD COMMON
C
      SUBROUTINE USINIT

C-  Modifications

C  19-May-2010  jim.conboy@ccfe.ac.uk
C               String carg_delim in program argument list terminates uread 
C               argument scan ( allowing remaining args to be processed 
C               by the user code )
C               See also ureadsub/uread_arg_count

      use USERIO
#ifdef __NAGWARE
      use f90_unix_proc
      use f90_unix_env
#endif
C
C  980723 Ted Terpstra - Put in check for 0 length zbuff from
C                        Getlog which is 0 for some xterm sessions.
C                        i.e. no USER in detached xterm window!!
C
      CHARACTER*(urdbufl) ZBUFF
      CHARACTER*1 ZTTCMD
      CHARACTER*120 clterm
      character(len=2), parameter  :: carg_delim='-!'
!                                     terminates uread args on command line
C
      LOGICAL STATUS
C
C-----------------------------------------------------------------------
C
      IF(NLUINI) RETURN
      NLUINI=.TRUE.
C
#ifdef _DEBUG
C                Catch unwanted interactive code in debug runs..
      write(0,*) 'USINIT -I- called'
      call errtra()
#endif
C
      call urdprlev(-1)         ! force linkage of block data init...
C
C  SET FLAG FOR ERROR MESSAGE WHEN PROMPT MISMATCH IS DETECTED IN
C  INDIRECT INPUT FILE
      LPMMSG=1
C
C  (JAN 1988) DEFINE PROMPT MATCH = MATCH ON FIRST 3 WORDS IN PROMPT:
      CALL URDPMA(1,3)
C
C  CLEAR BRANCH-TO-MARKER FLAG
      LMARKN=0
C
C  DEFAULT COMMAND INTERPRETATION LEVEL IN EFFECT
      LEVCMD=levdflt
      call uread_cmd_enable
C
C  BATCH OR INTERACTIVE MODE?
      CALL ISBATCH(IBATCH)
C
C  JAVA client mode?
      NLJAVA=.FALSE.
C-----------
C <Eliot, insert environment test here>
C   to set NLJAVA=.TRUE.
      call sget_env('JAVA_CLTERM',clterm)
      if (clterm .ne. ' ') then
	NLJAVA = .TRUE.
      endif
C-----------
C
C  DMC MAY 1986 - SET LENGTH OF UREAD LANGUAGE ELEMENTS
C
      LBUFF=LEN(CBUFF)
      LFILN=LEN(XFILE(1))
      LPNAM=LEN(PGLNAM(1))
      LPVAL=LEN(PGLVAL(1))
C
C  DEFAULT -- NO USER PUNCTUATION
C
      LPUNCT=0
C
C  FROM HHT [NBEAM.TERMCTL]TERMCTL LIBRARY
C  MOD DMC -- SEE USET_TTY SUBROUTINE
C
C  USER CAN SUPPRESS TTY PARTS OF GFLIB WITH A "CALL USET_TTY('NONE')"
C  *PRIOR* TO CALL UINITA OR CALL USINIT ***
C
      IF((NTTYP.NE.-1).OR.(UTTYP(1:5).NE.'NONE ')) THEN
        UTTYP='        '
        CALL TERM_CHECK(UTTYP,ZTTCMD)
        CALL USET_TTY(UTTYP)
      ENDIF
C  CLEAR GRAPHICS PAGE COUNT
      NPLOTD=0
C  CLEAR UPAUSE INPUT CHARACTER
      UPCHAR=' '
C  LOGICAL SWITCHES
      NLEDIT=.FALSE.
      NLECHO=.FALSE.
C  DEFAULT EDITOR BREAK STRING-- BREAK AT EVERY COMMAND
      NLSKIP=.FALSE.
      NLINDO=.FALSE.
      NLXOUT=.TRUE.
      NLXPER=.FALSE.
C  DEFAULT REVERSE VIDEO PROMPTING ON IF TTY SUPPORTS IT...
      CALL UPRSET('R')
C  # OF CHARACTERS PER SINGLE PRECISION VAX WORD
      NCPWD=4
      NLINDI=.FALSE.
C
      NPRBUF=0
C
      NSAVED=0
C  DEFAULT INDIRECT INPUT FILE EXTENSION-- "IND"
      CALL URDEXT('ind')
C  TERMINAL - READ, AND INDIRECT INPUT FILE LUNS
      LUNTIN(1)=5
C  DMC OCT 1990 -- IF SYS$INPUT NOT A FILE, USE VIRTUAL KEYBOARD INPUT
C  ** DMC OCT 1991 -- THIS IS VAXONLY CODE ***
C
C  INDIRECT FILE LUNS:
      IF((LUNTIN(2).LT.10).OR.(LUNTIN(2).GT.91)) LUNTIN(2)=10
      DO IL=3,10
        LUNTIN(IL)=LUNTIN(2)+IL-2
      ENDDO
C  MAX NO. OF OPEN CHANNELS:
      MAXLIN=10
C  CURRENTLY OPEN CHANNEL
      NLUNIN=1
C  NUMBER OF ACTIVE OUTPUT CHANNELS *** OUTPUT OF INDIRECT FILES
      NLUNIO=0
C  TERMINAL - WRITE LUN
      LUNTRM=6
C   INDIRECT FILE *OUTPUT* LUN -- FOR CREATION OF NEW INDIRECT FILES
      LUNIDO=0
C  TRACEBACK INFO-- COMMAND COUNTS AND
C  INPUT FILENAMES --
      XFILE(1)=
     >'SYS$INPUT (W/O UREAD OUTPUT)                                    '
      NCMND(1)=0
      DO 10 I=2,MAXLIN
        XFILE(I)=
     >'                                                                '
        NCMND(I)=0
 10   CONTINUE
C
C  NUMBER OF PREVIOUS INPUT LINES SAVED TO DUMP IN CASE OF ERROR:
      NCBUFP=3
C  STRING PARAMETER INFO
      NLSSUB=.FALSE.
      NPGMAX=1500
      NPLMAX=300
      NPGC=0
      DO 20 I=1,MAXLIN
        NPLC(I)=0
 20   CONTINUE
C
      DO 30 I=1,NPGMAX
        PGLNAM(I)='                '
        PGLVAL(I)='                                                '
 30   CONTINUE
C
      DO 40 IL=1,MAXLIN
        DO 41 I=1,NPLMAX
         PLCNAM(I,IL)='                '
         PLCVAL(I,IL)=
     1	'                                                '
 41     CONTINUE
 40   CONTINUE
C
C  PROMPTING OPTIONS
C
      CALL UBLINE(0)  ! NO LEADING BLANK LINES
C
C  INPUT INTERPRETATION SWITCHES--
C  COMMAND MODE
C   LEFT JUSTIFIED CAPITALIZED INPUT, ALL UREAD FCNS, NO NULL LINES
C   TYPEAHEAD ENABLED
C
      CALL URDCRI(0)  ! DEFAULT -- NO NULL LINES, COMMAND MODE
      CALL URDCH0     ! DEFAULT CHARACTER SET
      CALL URDMOD(1)  ! ESTABLISH COMMAND MODE AS INITIAL MODE (for URDCMI)
C
C  (TEXT MODE ALSO AVAILABLE)
C
C  CLEAR TYPEAHEAD BUFFER AND STACK
      CALL UCLEAR
      DO IL=1,MAXLIN
        AHDBUF(IL)=CBUFF
      ENDDO
C
C  DEFINE GLOBAL PARAMETERS "$DATE" AND "$LOGIN" AND "$PID"
C
      CALL C9DATE(ZBUFF(1:9))
      CALL URDCMI('/$DATE=='//ZBUFF(1:9),IER)
C
      CALL UGETLOG(ZBUFF)
      ILEN=LEN_TRIM(ZBUFF)
        If (ilen .LE. 0 ) Then
           ilen = 7
           Zbuff = 'UNKNOWN'
      EndIf
 
      CALL URDCMI('/$LOGIN=='//ZBUFF(1:ILEN),IER)
C
      call sget_pid_str(zbuff(1:20),ilen)
      call urdcmi('/$PID=='//ZBUFF(1:ILEN),IER)
C
C  LREADY: FLAG INDICATING READINESS TO ACCEPT COMMAND
      CALL URDCMI('/$MATCH==FALSE',IER)
      CALL UREADY(1)
C
C  CHECK FOR INI COMMAND FILE
C
      ILEN=0
      CALL UTRNLOG(' ','UREAD_INI',ZBUFF,ILEN,ISTAT)
C  EXECUTE INI COMMANDS
      IF(ISTAT.NE.1) ILEN=0
      IF(ILEN.GT.0) THEN
        OPEN(UNIT=LUNTIN(10),FILE=ZBUFF(1:ILEN),STATUS='OLD',
     >         RECL=urdbufl,ERR=50)
 45     CONTINUE
        READ(LUNTIN(10),4501,END=52) ZBUFF
 4501 FORMAT(A)
        CALL URDCMI(ZBUFF,IER)
        GO TO 45
      ENDIF
      GO TO 60
 50   CONTINUE
      WRITE(LUNTRM,9009) ZBUFF(1:ILEN)
 9009 FORMAT(' %USINIT - OPEN FAILURE, UREAD_INI FILE: ',A)
 52   CONTINUE
      CLOSE(UNIT=LUNTIN(10),ERR=60)
 60   CONTINUE
c
      call urdmod(levdflt)  ! now set user specified initial mode.
c
C  USE GETARG TO BUILD UP COMMAND LINE
C
      insrt=1
      call get_arg_count(iargn)
      l_arg: do iarg=1,iargn
        call get_arg(iarg,zbuff)
        ilarg=len_trim(zbuff)
        if( zbuff(1:ilarg) == carg_delim )  exit l_arg
        CBUFF(insrt:insrt+ilarg+1)=zbuff(1:ilarg)//' '
        insrt=insrt+ilarg+1
      end do l_arg
      NCHARC=insrt-1
#ifdef _DEBUG
      print *,'usinit -D- CBUFF :'
      print *,' "',cbuff(:ncharc),'"'
#endif
C
      CALL UDECOD
      IF(NCHARC.GT.0) CALL UPSINL(IER)
C
C  IF ANYTHING IS LEFT SILENCE OUTPUT UNTIL INTERPRETED
      CALL URXOUT
C
C--------------------------------------------------------------
      if(NLJAVA) then
         write(luntrm,*) ' %USINIT -- NLJAVA=T, JAVA_CLTERM active.'
      endif
C
      RETURN
C
      END
C******************** END FILE USINIT.FOR ; GROUP USINIT ***************

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function idescr_short(i)
      implicit none
      integer*2 i
      idescr_short = 0
      return
      end
 
      integer function idescr_long(i)
      implicit none
      integer i
      idescr_long = 0
      return
      end
 
      integer function idescr_float(f)
      implicit none
      real f
      idescr_float = 0
      return
      end
 
      integer function idescr_double(d)
      implicit none
      real*8 d
      idescr_double = 0
      return
      end
 
      integer function idescr_cstring(c)
      implicit none
      character c*(*)
      idescr_cstring = 0
      return
      end
 
      integer function idescr_longarr(i, idims, n)
      implicit none
      integer i
      integer idims(*), n
      idescr_longarr = 0
      return
      end
 
      integer function idescr_shortarr(i, idims, n)
      implicit none
      integer*2 i
      integer idims(*), n
      idescr_shortarr = 0
      return
      end
 
      integer function idescr_floatarr(f, idims, n)
      implicit none
      real f
      integer idims(*), n
      idescr_floatarr = 0
      return
      end
 
      integer function idescr_doublearr(d, idims, n)
      implicit none
      real*8 d
      integer idims(*), n
      idescr_doublearr = 0
      return
      end
 
      integer function idescr_cstringarr(c, idims, n)
      implicit none
      character *(*) c
      integer idims(*), n
      idescr_cstringarr = 0
      return
      end
#else
 
      integer function idescr_short(i)
      implicit none
      integer*2 i
      integer descr, mds__short
      idescr_short = descr(mds__short(), i, 0)
      return
      end
 
      integer function idescr_long(i)
      implicit none
      integer i
      integer descr, mds__long
      idescr_long = descr(mds__long(), i, 0)
      return
      end
 
      integer function idescr_float(f)
      implicit none
      real f
      integer descr, mds__float
      idescr_float = descr(mds__float(), f, 0)
      return
      end
 
      integer function idescr_double(d)
      implicit none
      real*8 d
      integer descr, mds__double
      idescr_double = descr(mds__double(), d, 0)
      return
      end
 
      integer function idescr_cstring(c)
      implicit none
      character c*(*)
      integer descr, mds__cstring, l
      idescr_cstring = descr(mds__cstring(), c, 0, len(c))
      return
      end
 
      integer function idescr_shortarr(i, idims, n)
      implicit none
      integer*2 i
      integer idims(*), n
      integer descr, mds__short
      integer j, jdims(8), num
      num = min(n,8)
      do j=1,num
         jdims(j) = idims(j)
      end do
      do j=num+1,8
         jdims(j) = 0
      end do
      idescr_shortarr = descr(mds__short(), i,
     $     jdims(1), jdims(2), jdims(3), jdims(4),
     $     jdims(5), jdims(6), jdims(7), jdims(8), 0)
      return
      end
 
      integer function idescr_longarr(i, idims, n)
      implicit none
      integer i
      integer idims(*), n
      integer descr, mds__long
      integer j, jdims(8), num
      num = min(n,8)
      do j=1,num
         jdims(j) = idims(j)
      end do
      do j=num+1,8
         jdims(j) = 0
      end do
      idescr_longarr = descr(mds__long(), i,
     $     jdims(1), jdims(2), jdims(3), jdims(4),
     $     jdims(5), jdims(6), jdims(7), jdims(8), 0)
      return
      end
 
      integer function idescr_floatarr(f, idims, n)
      implicit none
      real f
      integer descr, mds__float
      integer idims(*), n
      integer j, jdims(8), num
      num = min(n,8)
      do j=1,num
         jdims(j) = idims(j)
      end do
      do j=num+1,8
         jdims(j) = 0
      end do
      idescr_floatarr = descr(mds__float(), f,
     $     jdims(1), jdims(2), jdims(3), jdims(4),
     $     jdims(5), jdims(6), jdims(7), jdims(8), 0)
      return
      end
 
      integer function idescr_doublearr(d, idims, n)
      implicit none
      real*8 d
      integer descr, mds__double
      integer idims(*), n
      integer j, jdims(8), num
      num = min(n,8)
      do j=1,num
         jdims(j) = idims(j)
      end do
      do j=num+1,8
         jdims(j) = 0
      end do
      idescr_doublearr = descr(mds__double(), d,
     $     jdims(1), jdims(2), jdims(3), jdims(4),
     $     jdims(5), jdims(6), jdims(7), jdims(8), 0)
      return
      end
 
      integer function idescr_cstringarr(c, idims, n)
      implicit none
      character*(*) c
      integer descr, mds__cstring
      integer idims(*), n
      integer j, jdims(10), num
      num = min(n,8)
      do j=1,num
         jdims(j) = idims(j)
      end do
      jdims(num+1) = 0
      jdims(num+2) = len(c)
      idescr_cstringarr = descr(mds__cstring(), c,
     $     jdims(1), jdims(2), jdims(3), jdims(4),
     $     jdims(5), jdims(6), jdims(7), jdims(8),
     $     jdims(9), jdims(10))
      return
      end
#endif
 
 
 
 

C******************** START FILE URDSPC.FOR ; GROUP UREAD5 ******************
C--------------------------------------------------------------------
C&  URDSPC-- PROCESS UREAD SPECIAL CHARACTERS
C
      SUBROUTINE URDSPC(ISELEC,IRET,IEOFL,IERC)
C
C  PREVIOUSLY PART OF UREAD SUBROUTINE
C
      USE USERIO
C
C  PARAMETER DEFN TEST
      CHARACTER*16 ZTNAM
      CHARACTER*96 ZTVAL
      character*1 zchar
C
C  TYPEAHEAD CLEAR FLAG
      IF(NLHOLD.OR.NLSKIP) THEN
        ICLEAR=1
      ELSE
        ICLEAR=0
      ENDIF
C  INITIALLY ASSUME SUCCESS ***
      IERC=0
C  BRANCH ACCORDING TO COMMAND/ SPECIAL CHARACTER TYPE
      GO TO (410,420,430,440,450,460,470) ISELEC
C-----------------------------------------------------------
C  ";" = COMMENT
 410  CONTINUE
C  COMMENT CARDS CAN COME ONLY ON INPUT CHANNEL
      IF(LCMDIN.EQ.2) THEN
        IF(NLINDO) THEN
          WRITE(LUNIDO,2001) CBUFF(1:NCHARC)
 2001 FORMAT(A)
        ELSE
          IF(NLECHO) WRITE(LUNTRM,2002) CBUFF(1:NCHARC)
 2002 FORMAT(1X,A)
        ENDIF
        ICLEAR=1
        GO TO 499
      ENDIF
C
C  NO TYPEAHEAD PAST A COMMENT
C
      ICLEAR=1
C
C  IS A COMMENT CARD; CHECK FOR MATCH WITH PROMPT
C   (INDIRECT FILES ONLY; THIS IS TO MAKE SURE THAT
C    INDIRECT FILE COMMAND SEQUENCE MESHES WITH CALLING
C    PROGRAM STRUCTURE)
C  IS A CHECK REQUIRED?
      IF(LREADY.EQ.1) GO TO 499
C  IF NLSKIP IS SET AND LOOKING FOR MARKER, DONT CHECK PROMPTS
      IF(NLSKIP.AND.(LMARKN.GT.0)) GO TO 499
C  CHECK FOR PROMPT MATCH
      CALL UCMPPR
      GO TO 499
C----------------------------------------------------------------
 420  CONTINUE
C  "@" SYMBOL ENCOUNTERED -- ESTABLISH COMMUNICATIONS WITH NAMED
C  INDIRECT INPUT FILE (IF POSSIBLE)
C    ... IGNORE IF NLSKIP IS SET
      IF(NLSKIP) GO TO 499
C
C  TYPEAHEAD PAST FILE INDIRECT FILE INVOCATION IS POSSIBLE BUT
C  MUST BE DEFERRED UNTIL AFTER THE INDIRECT FILE IS READ AND CLOSED
      ICLEAR=1
C
C  ATTEMPT TO OPEN INPUT FILE
C
      CALL UINDIN(URFILE,0,IER)
C
      IF(NLINDI.AND.(IER.NE.0)) THEN
        CALL URDERR(2)
      ENDIF
      IF(IER.NE.0) THEN
        IERC=1
        GO TO 499
      ENDIF
C  REQUIRE PROMPT MATCHES FOR INDIRECT INPUT
      IF((NCHARA.GT.0).OR.(LCMDIN.EQ.2)) CALL UREADY(0)
      GO TO 499
C
C---------------------------------------------------------
C  ">" -- CREATE OR CLOSE INDIRECT OUTPUT FILE
C  IGNORE IF READING FROM INDIRECT INPUT FILE
 430  CONTINUE
      IF(NLSKIP) GO TO 499
      CALL UDELIM(CBUFF(2:2),JCODE)
      IF(NLINDI) THEN
C  DMC JAN 1985
C   INDIRECT INPUT FILE IS OPEN
C   ">" IS TREATED AS IN INDIRECT FILE INPUT REFERENCE, IF A
C   FILENAME FOLLOWS; OTHERWISE IT IS END-OF-LINE
C
        ICLEAR=1
        IF(LCMDIN.EQ.2) THEN
          CALL UERMSG(
     >'% CANNOT ACCESS OUTPUT FILE WITH INDIRECT INPUT FILE IN CONTROL',
     >                  ' ',1)
          IERC=1
        ELSE
          IF((JCODE.LT.1).OR.(JCODE.GT.2)) THEN  ! ">" HAS ARGUMENT
            CBUFF(1:1)=MFILI
            GO TO 420
          ENDIF
        ENDIF
      ELSE
C  OPEN OR CLOSE OUTPUT FILE...
        ICLEAR=1
        IF((JCODE.LT.1).OR.(JCODE.GT.2)) THEN  ! ">" HAS ARGUMENT
          CALL UINDIN(URFILE,1,IER)
          IF(IER.NE.0) IERC=1
        ELSE
C  CLOSE...
          IF(NLUNIO.EQ.0) THEN
            CALL UERMSG(' % NO OUTPUT FILES OPEN',' ',1)
          ELSE
            CALL URDEOF(IDUM)
          ENDIF
C  USE TYPEAHEAD POPPED FROM STACK (IF ANY)
          ICLEAR=0
        ENDIF
      ENDIF
      GO TO 499
C-----------------------------------------------------------
C  SPECIAL COMMAND FUNCTIONS INVOKED -- FIRST CHARACTER IS "*"
C
 440  CONTINUE
      IF(NLSKIP) GO TO 499
C
      CALL URDSPF(IER)
      IF(IER.NE.0) THEN
C  USER/PROGRAM DEFINED COMMAND?
        IRET=3
        GO TO 500
      ENDIF
      GO TO 499
C------------------------------------------------------------
C  "/" PARAMETER DEFINITION OR SUBSTITUTION LINE
C
 450  CONTINUE
      IF(NLSKIP) GO TO 499
      ISTART=1
      CALL USPCHK(DBUFF,LBUFF,ISTART,IFIN,INDEQ,IDUM)
      IF(IFIN.EQ.1) THEN
        CALL UROTOR(1)
        GO TO 499
      ENDIF
      IF(INDEQ.EQ.0) GO TO 455
C  PARAMETER DEFINITION (LINE OF FORM "/NAME=VALUE")
      INDSL=1
      CALL UPMASG(DBUFF,INDSL,IFIN,IERC)
      CALL UROTOR(IFIN)
C
      GO TO 499
C  PRE-DEFINED PARAMETER IS INVOKED
C  SUBSTITUTE PARAMETER VALUE FOR PARAMETER NAME
C  AND INTERPRET THROUGH UREAD LOGIC
 455  CONTINUE
C  MUST BE FILE INPUT
      IF(LCMDIN.EQ.2) THEN
C  SUBSTITUTION NOT MEANINGFUL...
          IF((CBUFF(1:5).NE.'/$LIS').AND.(CBUFF(1:5).NE.'/$DEL')) THEN
          ICLEAR=1
          IERC=1
          GO TO 499
        ENDIF
      ENDIF
C
      IF(NLSSUB) then
         !  a substitution was already performed; return to caller
         IRET=3
         GO TO 500
      endif
C
      CALL UPSSUB(DBUFF,IFIN,IFLAG,ZTVAL)
      IF(IFLAG.NE.0) GO TO 499
C  INSERT SUBSTITUTED VALUE
      CALL UROTOR(IFIN)
      CALL URDTTI(ZTVAL//' ')
      CALL UDECOD
      CALL UTTECH
      NLSSUB = .TRUE.
C  INTERPRET
      IRET=1
      RETURN
C
C--------------------------------------------------------------
C  "?" BRANCHING AND CONDITIONAL COMMAND EXECUTION
C
 460  CONTINUE
      IF(NLSKIP) GO TO 499
C
C  DMC 12/87
C  LONE "?" RETURNED TO CALLER - TIC APPLICATIONS COMPATIBILITY
      IF(NCHARC.EQ.1) THEN
        IRET=3
        GO TO 500
      ENDIF
C
C  MUST BE FILE INPUT
      IF(LCMDIN.EQ.2) THEN
        ICLEAR=1
        IERC=1
        GO TO 499
      ENDIF
C
      CALL URDQCD(INTRP)
C  INTERPRET INLINE CONDITIONAL COMMAND
      IF(INTRP.EQ.1) THEN
        CALL UTTECH
        IRET=1
        RETURN
      ENDIF
C  BRANCH TO MARKER; NO TYPEAHEAD
      ICLEAR=1
      IF(LMARKN.LE.0)  GO TO 499
      IEOFL=0
      NLSKIP=.TRUE.
      GO TO 499
C--------------------------------------------------------------
C  ":" MARKER LINE DETECTED
 470  CONTINUE
C  MAKES NO SENSE AS A CALLED COMMAND...
      IF(LCMDIN.EQ.2) THEN
        ICLEAR=1
        IERC=1
        GO TO 499
      ENDIF
C  IGNORE IF NOT LOOKING FOR MARKER
      IF(LMARKN.LE.0) GO TO 475
C
C  IS IT THE MARKER SOUGHT?
      DO 472 I=1,LMARKN
        IP1=I+1
        zchar=CBUFF(IP1:IP1)
        call uspcap(zchar)
        IF(zchar.NE.URMARK(I:I)) GO TO 475
 472  CONTINUE
      IP1=IP1+1
      IF(CBUFF(IP1:IP1).NE.' ') GO TO 475
C  MARKER FOUND
      IMARKN=LMARKN+1
      LMARKN=0
      NLSKIP=.FALSE.
      IF(NLECHO) WRITE(LUNTRM,3047) NCMND(NLUNIN)
 3047 FORMAT(' MARKER FOUND - RESUMING CONTROL AT RECORD ',I4)
      IEOFL=0
C
C ROTATE MARKER OUT
      IF(.NOT.NLHOLD) CALL UROTOR(IMARKN)
C
      GO TO 499
C  MARKER NOT CORRECT OR NONE SOUGHT-- ROTATE MARKER OUT
 475  CONTINUE
      CALL URWORD(CBUFF,1,ILENM,ILENR)
      CALL UROTOR(ILENR)
      GO TO 499
C
C
C------------------
C  CLEAR BUFFER, RESET TYPE-AHEAD, AND GET A NEW LINE
 499  CONTINUE
      IRET=2
 500  CONTINUE
      IF((IRET.LT.3).AND.(ICLEAR.EQ.1)) CALL UCLEAR
      RETURN
C------------------
      END
C******************** END FILE URDSPC.FOR ; GROUP UREAD5 ******************

C******************** START FILE GSCGDF.FOR ; GROUP GSCALE ******************
C-------------
C  GSCGDF
C   NON-INTERACTIVE FETCH OF SCALING DEFAULTS
C
C  IAX=1:  X-AXIS SCALING;  IAX=2:  Y-AXIS SCALING
C   ISEL:  1,2,3,4, OR 5 TO SELECT OPTION AS IN SUBROUTINE GSCDEF
C    IF ISEL=3, ZARG1 AND ZARG2 ARE THE LOWER AND UPPER FIXED LIMITS
C    IF ISEL=4 OR 5, ZARG1 IS THE MULTIPLIER
C   FOR OTHER VALUES OF ISEL ZARG1 AND ZARG2 ARE IGNNORED
C
      SUBROUTINE GSCGDF(IAX,ISEL,ZARG1,ZARG2)
C
      INCLUDE 'GSCALE_BLK'
C
      IF(IGSINI.EQ.0) CALL GSCINI
C
      GO TO (100,200) IAX
C  X AXIS
 100  CONTINUE
      ISEL=NOPTX
      GO TO (500,500,110,120,120) ISEL
C
 110  CONTINUE
      ZARG1=XMIN00
      ZARG2=XMAX00
      GO TO 500
C
 120  CONTINUE
      ZARG1=XRAT00
      GO TO 500
C  Y AXIS
 200  CONTINUE
      ISEL=NOPTY
      GO TO (500,500,210,220,220) ISEL
C
 210  CONTINUE
      ZARG1=YMIN00
      ZARG2=YMAX00
      GO TO 500
C
 220  CONTINUE
      ZARG1=YRAT00
      GO TO 500
C----
C EXIT
 500  CONTINUE
      RETURN
      END
C******************** END FILE GSCGDF.FOR ; GROUP GSCALE ******************

C******************** START FILE UFOPWR.FOR ; GROUP UFILES *************
C------------------------------------------------------------
C  UFOPWR
C  OPEN FILE FOR WRITE
C   ARGUMENTS-- ILUN=FILE LOGICAL UNIT NUMBER
C     ISHOT-- DATA SHOT NUMBER (5 DIGITS)
C     IER-- (OUTPUT) ERROR RETURN CODE
C      0=NORMAL
C
      SUBROUTINE UFOPWR(ILUN,ISHOT,IER)
C
      USE UFILES
C
      CHARACTER*128 ZFILE
C
#include "fpreproc/byte_declare.h"
      byte_declare ibhdr(12)
C
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
#ifdef __CRAY
      data ibhdr/char(0),char(127),char(0),char(127),
     >          char(0),char(127),char(0),char(127),
     >          char(0),char(0),char(0),char(2)/
#elif __SX
      data ibref/'00'x, '7F'x,'00'x, '7F'x,'00'x,'7F'x,'00'x,'7F'x,
     >           '00'x, '00'x,'00'x, '02'x,/
#else
      data ibhdr/0,127,0,127,0,127,0,127,0,0,0,2/
#endif
C
C-----------------------------------------------------------------------
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UFOPWR    ',ICHAN,IER)
      IF(IER.NE.0) RETURN
      IF(UFSTAT(ICHAN).NE.0) THEN
        CALL UERSTA(ICHAN,'UFOPWR    ')
        GO TO 190
      ENDIF
C
      CALL UFSNAM(ISHOT,ZFILE,IER,ILUN)
      IF(IER.NE.0) RETURN
C
      IF((UFILEV-10*(UFILEV/10)).GE.1)
     >     CALL UFSND0(UFELUN,'NAMED FILE',ZFILE)
C
C MDSplus
      if(ufcprs(ichan).eq.-1) then
         call ufopen_mds(ichan,ishot,ier,2)
         if (ier .eq. 0) then
            UFSTAT(ICHAN)=1
         endif
         go to 190
      endif
C
 
C  Unix systems -- if file already exists, move it out of the way!
C
      OPEN(UNIT=UFLUN(ICHAN),FILE=ZFILE,
     >       STATUS='OLD',IOSTAT=IOS)
      CLOSE(UNIT=UFLUN(ICHAN),ERR=99)
 99   CONTINUE
      IF(IOS.EQ.0) THEN
        ILNB=INDEX(ZFILE,' ')-1
        IF(ILNB.LE.0) ILNB=LEN(ZFILE)
        WRITE(UFELUN,8001) ZFILE(1:ILNB),ZFILE(1:ILNB)
 8001   FORMAT(/' %UFOPWR:  FILE ',A,' ALREADY EXISTS'/
     >  '  ** old file is renamed to --> ',a,'~'/)
        call frename(zfile(1:ilnb),zfile(1:ilnb)//'~',istat)
        IF(ISTAT.NE.0) WRITE(UFELUN,8002) ISTAT
 8002   FORMAT(' %UFOPWR:  file rename call returned ISTAT=',i10)
      ENDIF
C
      CALL UFOPEN(UFLUN(ICHAN),ZFILE,2,IER,UFCPRS(ICHAN))
      IF(IER.NE.0) GO TO 100
C If netCDF : ufopen does not open it
      if (UFCPRS(ICHAN) .eq. 4) then
         call cdfopen(UFLUN(ICHAN),zfile,1,ios)
         IF(IER.NE.0) GO TO 100
      end if
C
	
      niobuf(ichan)=0
      nchbuf(ichan)=0
      if(ufcprs(ichan).eq.2) then
C  write 12 byte fixed header
         call ubufo(uflun(ichan),uiobuf(1,ichan),niobuf(ichan),
     >                ibhdr,12)
      endif
C
C  ok, ready.
      UFSTAT(ICHAN)=1
C
      RETURN
C--
C  ERROR
 100  CONTINUE
      CALL UFSND0(UFELUN,'UFOPWR:  FAILED TO OPEN FILE',ZFILE)
      WRITE(UFELUN,9001) IER
 9001 FORMAT(
     >  '  IOSTAT CODE: ',1X,I3,' - HIT CARRIAGE RETURN')
      IER=1
      CLOSE(UNIT=UFLUN(ICHAN),ERR=190)
 190  CONTINUE
      CALL UFPAUS(1)
      RETURN
      	END
C******************** END FILE UFOPWR.FOR ; GROUP UFILES ***************

C******************** START FILE FDCOD.FOR ; GROUP URDUTS ******************
C&  FDCOD  UREAD FLOATING PT DECODE AND ERROR CHECK W/MESSAGE
C   FRONT FOR FDCODE -- CALL AFTER UREAD WITHOUT NEEDING TO
C  INCLUDE COMMON VARIABLES
C
      REAL FUNCTION FDCOD(IER)
C  IER - RETURN CODE .NE. 0 IF DECODING REAL FAILED
      USE USERIO
      FDCOD=FDCODE(DBUFF,IER)
      RETURN
      END
C******************** END FILE FDCOD.FOR ; GROUP URDUTS ******************

C******************** START FILE ISCMP0.FOR ; GROUP URDUTS ******************
C-------------
C&  ISCMP0 - ISCOMP FUNCTION WITHOUT USERIO INCLUDE COMMON BLOCKS
C
      INTEGER FUNCTION ISCMP0(DBUFF,ABLIS,N,NMAX,ND2)
C
      implicit NONE
C
      integer LMAX
      PARAMETER (LMAX=512)
C
      integer N,NMAX,ND2
      CHARACTER*(*) ABLIS(N)
      CHARACTER*1 DBUFF(LMAX)
C
C-----------------------------------
C
      CHARACTER*1 ZBUFF(LMAX),MMINUS,MPLUS,MBLANK
C
      integer imax,imaxp1,imul,i,ij,id,iz
      integer num,nd1,numz,nz1,nz2,ilena
C
      DATA MBLANK/' '/
      DATA MMINUS/'-'/
      DATA MPLUS/'+'/
C
C-----------------------------------
      ISCMP0=0
      IMAX=MIN(NMAX,LMAX)
      IMAXP1=MIN(NMAX+1,LMAX)
      ilena=min(lmax,len(ablis(1)))
      IMUL=1
C
      CALL NUMFLD(DBUFF,ND1,ND2,NUM)
      IF(ND1.LE.0) GO TO 5
      IF((DBUFF(ND1).NE.MPLUS).AND.(DBUFF(ND1).NE.MMINUS)) GO TO 5
      IF(DBUFF(ND1).EQ.MMINUS) IMUL=-1
      ND1=ND1+1
      NUM=NUM-1
 5    CONTINUE
      IF(NUM.LE.0) RETURN
C  DECODE LIST ELEMENTS AND COMPARE
      DO 20 I=1,N
          DO 10 IJ=1,IMAXP1
             ZBUFF(IJ)=MBLANK
 10       CONTINUE
C
          do ij=1,ilena
             zbuff(ij)=ablis(i)(ij:ij)
          enddo
C
12        continue
          CALL FLDLIM(ZBUFF,NZ1,NZ2,NUMZ)
C
          IF(NUM.NE.NUMZ) GO TO 20
          DO 15 IJ=1,NUM
             ID=ND1+IJ-1
             IZ=NZ1+IJ-1
             IF(ZBUFF(IZ).NE.DBUFF(ID)) GO TO 20
 15       CONTINUE
          GO TO 50
 20   CONTINUE
C
C  NOT FOUND
C
      RETURN
C
C  FOUND
C
 50   CONTINUE
      ISCMP0=IMUL*I
      RETURN
      	END
C******************** END FILE ISCMP0.FOR ; GROUP URDUTS ******************

!--------------------------
real(fp) FUNCTION SVRC_JANEV(ZTE)
!  ZTE IN EV
!  SVRC_JANEV IN CM**3/SEC
!
!  JANEV-LANGER-EVANS, ELEMENTARY PROCESSES IN HYDROGEN/HELIUM PLASMAS
!     (Springer Verlag 1987) p. 32
!
!  MAXWELLIAN AVG  summed over states (1,2p,2s,3...10)
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : zero,half,one,two
  USE expint1
  IMPLICIT NONE
  INTEGER i
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) zte
!============
  real(fp) AS(3),CHIS(3),ZNFAC(3)
  real(fp) zbeta,ze1
!
  DATA AS/3.92e-14_fp,2.47e-14_fp,6.22e-14_fp/
                                        ! Anl in reference:  1s, 2s, 2p
  DATA CHIS/0.35_fp,0.12_fp,0.61_fp/
                                        ! chi(nl) in reference:  1s, 2s, 2p
  DATA ZNFAC/one,half,half/
                                        ! sqrt(En(ion)/Ry) = 1/n, cf reference
!
  SVRC_JANEV=zero
  do i=1,3
     ZBETA=ZNFAC(i)*ZNFAC(i)*13.58_fp/ZTE
     SVRC_JANEV=SVRC_JANEV+&
          AS(i)*ZNFAC(i)*ZBETA**1.5_fp/(ZBETA+CHIS(i))
  enddo
!
  do i=3,10
     ZBETA=13.58_fp/(i*i*ZTE)
     ZE1=EXPI1S(ZBETA)   ! r8slatec-derived exponential integral eval.
     SVRC_JANEV=SVRC_JANEV+&
          5.201e-14_fp*ZBETA**1.5_fp*ZE1*EXP(ZBETA)
  enddo
!
  RETURN
END FUNCTION SVRC_JANEV
!--------------------------
real(fp) FUNCTION SVEIH_JANEV(ZTE)
  use iso_c_binding, only: fp => c_double
!  ZTE IN EV
!  SVEIH_JANEV IN CM**3/SEC
!
!  JANEV-LANGER-EVANS, PPPL-TM-368 P.281, REACTION A1.5
!  IONIZATION OF H(1S) QUANTUM STATE
!  BY ELECTRON IMPACT, MAXWELLIAN AVG
!
!  results match <sigma*v> data shown at:
!  JANEV-LANGER-EVANS, ELEMENTARY PROCESSES IN HYDROGEN/HELIUM PLASMAS
!     (Springer Verlag 1987) p. 27
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  IMPLICIT NONE
  INTEGER i
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) zte,zlt,zls
!============
  real(fp) A15(9)
  DATA A15/&
       -3.271397e+01_fp, 1.353656e+01_fp,-5.739329_fp,&
       1.563155_fp,-2.877056e-01_fp, 3.482560e-02_fp,&
       -2.631976e-03_fp, 1.119544e-04_fp,-2.039150e-06_fp/
!
  ZLT=log(ZTE)
!
  ZLS=A15(9)
  DO I=8,1,-1
     ZLS=ZLS*ZLT+A15(I)
  enddo
!
  SVEIH_JANEV=EXP(ZLS)
!
  RETURN
END FUNCTION SVEIH_JANEV
!--------------------------
real(fp) FUNCTION SVEIHE_JANEV(ZTE)
  use iso_c_binding, only: fp => c_double
!  ZTE IN EV
!  SVEIHE_JANEV IN CM**3/SEC
!
!  JANEV-LANGER-EVANS, PPPL-TM-368 P.288, REACTION A3.9
!  IONIZATION OF ATOMIC HE(1S2|1S) QUANTUM STATE
!  BY ELECTRON IMPACT, MAXWELLIAN AVG
!
!  results match <sigma*v> data shown at:
!  JANEV-LANGER-EVANS, ELEMENTARY PROCESSES IN HYDROGEN/HELIUM PLASMAS
!     (Springer Verlag 1987) p. 91
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  IMPLICIT NONE
  INTEGER i
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) zte,zlt,zls
!============
  real(fp) A39(9)
  DATA A39/&
       -4.409865e+01_fp, 2.391597e+01_fp,-1.075323e+01_fp,&
       3.058039_fp,-5.685119e-01_fp, 6.795391e-02_fp,&
       -5.009056e-03_fp, 2.067236e-04_fp,-3.649161e-06_fp/
!
  ZLT=log(ZTE)
!
  ZLS=A39(9)
  DO I=8,1,-1
     ZLS=ZLS*ZLT+A39(I)
  enddo
!
  SVEIHE_JANEV=EXP(ZLS)
!
  RETURN
END FUNCTION SVEIHE_JANEV
!-----------------------------
! 22Jun2001 fgtok -s r8_precision.sub "r8con.csh conversion"
! 22Jun2001 fgtok

C******************** START FILE GRFUF1.FOR ; GROUP GRFUF1 ******************
C----------------------GRFUF1 SUBMODULE-----------------------
C
C  REWRITTEN DMC FEB 1986 TO USE GRAFX1 SUBROUTINE
C   PART OF PROJECT TO STANDARDIZE GFLIB 2D PLOTTING ROUTINES
C
C  PLOT Y VS. X - UFILES STYLE LABELING
C
C
      SUBROUTINE GRFUF1(X,Y,N,IPROC,LBLY,
     1                 LBLX,ISHOT,IDEV,ZDATE,NXTR,XTRVAL,XTRLAB)
C
C  X(N),Y(N)  DATA TO BE PLOTTED
C   IPROC - UFILES PROCESS CODE (AS IN UF1DRD/WR CF UFILES MANUAL)
C   LBLX,LBLY 30 CHAR UFILES STYLE LABELS FOR X AND Y
C   ISHOT - SHOT NUMBER
C   IDEV - 4 CHAR "DEVICE" I.E. TOKAMAK CODE
C   ZDATE - 10 CHAR LABEL FOR DATE OF ORIGIN OF DATA
C   NXTR - .GT.0 SIGNALS PRESENCE OF "ATTACHED SCALAR DATA ITEM"
C   XTRVAL - SCALAR DATA ITEM TO BE WRITTEN AS A PLOT LABEL
C   XTRLAB - LABEL FOR SCALAR DATA ITEM
C
C
      DIMENSION X(N),Y(N)
      CHARACTER*4 IDEV
      CHARACTER*10 LBLY(3),LBLX(3),ZDATE,XTRLAB(3)
      character*15 zshot
      CHARACTER*10 LNSMOO,LYSMOO,LYAVER,LOTHER
      CHARACTER*25 ZLPROC
      CHARACTER*12 ZSCVAL
C
      DATA LNSMOO/'          '/
      DATA LYSMOO/' SMOOTHED.'/
      DATA LYAVER/' AVERAGED.'/
      DATA LOTHER/' PROCESSED'/
C
C  PREPARE CERTAIN LABELS
      ZLPROC='                         '
      IF((IPROC.EQ.1).OR.(IPROC.EQ.3)) ZLPROC(2:11)=LYAVER
      IF((IPROC.EQ.2).OR.(IPROC.EQ.3)) ZLPROC(14:23)=LYSMOO
      IF(IPROC.EQ.4) ZLPROC(2:11)=LOTHER
C
      WRITE(ZSHOT,7701) IDEV,ISHOT
 7701 FORMAT(A4,I11)
C
C  CALL COMMON PLOTTING/INTERFACE SUBROUTINE - CONSTRUCT LABELS
C   ENCODE ATTACHED SCALAR DATA ITEM IF NECESSARY
C
      IF(NXTR.EQ.0) THEN
        CALL GRAFX1(X,Y,N,LBLX(3),LBLY(3),' ',
     >      ZSHOT//' '//ZDATE//' '//ZLPROC,
     >      LBLY(1)//LBLY(2)//' VS. '//LBLX(1)//LBLX(2) )
      ELSE
C
        WRITE(ZSCVAL,1003) XTRVAL
        IF(ZSCVAL(1:1).EQ.' ') ZSCVAL(1:1)='+'
 1003 FORMAT(1PE12.5)
C
        CALL GRAFX1(X,Y,N,LBLX(3),LBLY(3),
     >      ZSHOT//' '//ZDATE//' '//ZLPROC,
     >      '['//ZSCVAL//'] '//XTRLAB(1)//XTRLAB(2)//' '//XTRLAB(3),
     >      LBLY(1)//LBLY(2)//' VS. '//LBLX(1)//LBLX(2) )
      ENDIF
C
      RETURN
      	END
C******************** END FILE GRFUF1.FOR ; GROUP GRFUF1 ******************

C----------------------------------------------------------------------
C  URDPMA  SET UREAD PROMPT MATCHING TEST CONTROLS
C
      SUBROUTINE URDPMA(IW1,IW2)
C
C  IW1  -- NO. OF 1ST WORD TO CHECK
C  IW2  -- NO. OF LAST WORD TO CHECK
C   WHEN DOING PROMPT MATCH CHECKING
C
C  E.G. AFTER "      CALL URDPMA(1,3)" PROMPT MATCH IS DEFINED IF
C  THE 1ST 3 WORDS IN THE PROMPT RECORD IN THE INPUT FILE MATCH THE
C  1ST 3 WORDS OF THE PROGRAM PROMPT
C
C  IF IW2.LT.IW1, PROMPT MATCH CHECKING IS DISABLED-- ALL PROMPTS ARE
C  ASSUMED TO MATCH
C
      USE USERIO
C
      NCPRM(1)=IW1
      NCPRM(2)=IW2
C
      RETURN
      END

C******************** START FILE GRFLBL.FOR ; GROUP GRFLBL ******************
C--------------------------------------------------------------
C  GRFLBL - PUT A LABEL ON THE GRAPH SCREEN
C
      SUBROUTINE GRFLBL(IX,IY,STR,ILEN,IFLAG,IVERT)
C
      implicit none
      CHARACTER*(*) STR
      integer       IX,IY,ILEN,IFLAG,IVERT,inb
C
C  IX,IY - RASTER COORDS AT WHICH TO START STRING
C          THE LOWER LEFT HAND CORNER OF THE FIRST CHARACTER OF
C          THE OUTPUT STRING IS AT (IX,IY)
C
C  STR - THE TEXT STRING TO DISPLAY
C
C  ILEN - (OPTIONAL) NOMINAL LENGTH OF STR.  IF DEFAULTED THE
C        ACTUAL LENGTH OF STR IS USED
C
C  IFLAG - -1 TO LEFT JUSTIFY, 0 TO CTR, 1 TO RIGHT JUSTIFY THE
C        LABEL IN ITS FIELD (FIELD LENGTH SPECIFIED VIA ILEN)
C
C  IVERT = 1 FOR VERTICAL TEXT STRING OUTPUT
C
C  LOCAL BUFFERS
C
      CHARACTER*256 BUF1,BUF2
      integer       ils, il
C
C------------------------
C
      ILS=min(LEN(STR),LEN(BUF1))
C
      IF(ILEN.LE.0) THEN
        IL=ILS
      ELSE
        IL=min(ILEN,len(buf1))
      ENDIF
C
      BUF1=STR(1:min(len(str),il))
      BUF2=' '
C
      CALL GRFMBC(BUF1(1:IL))
C
      CALL GFPAKS(BUF1,BUF2,IL,IFLAG)
C
C  FIND LAST NONBLANK
C
      DO 10 INB=IL,1,-1
        IF(BUF2(INB:INB).NE.' ') GO TO 20
 10   CONTINUE
C
C  NO NONBLANKS - EXIT W/O OUTPUT
C
      RETURN
C
C  OUTPUT THE LABEL
C
 20   CONTINUE
C
      IF(IVERT.EQ.1) THEN
        CALL AGTMVS(IX,IY,BUF2,INB)
      ELSE
        CALL AGTMHS(IX,IY,BUF2,INB)
      ENDIF
C
      RETURN
      END
C******************** END FILE GRFLBL.FOR ; GROUP GRFLBL ******************

C---------------------------------------------------------------
C  GRFNEX - FIND NEXT PT. .GT. SPECIFIED INPUT VALUE
C
      SUBROUTINE GRFNEX(X,NX,XNEXT,ISTART)
C
C  X(NX)  DATA ARRAY TO CHECK  *DATA IN ASCENDING ORDER*
C
C  MODIFIED ON OUTPUT--
C   XNEXT - ON INPUT - FIND FIRST X(J) .GT. XNEXT
C           ON OUTPUT - X(J) FOUND
C   ISTART - ON INPUT PT *AFTER* WHICH TO START SEARCH
C           ON OUTPUT - J= INDEX TO PT X(J) FOUND
C
      REAL X(NX)
C
      I0=ISTART+1
      IF((I0.GT.NX).OR.(XNEXT.GT.X(NX))) THEN
        ISTART=NX+1
        XNEXT=X(NX)
      ELSE
        DO 10 IX=I0,NX
          IF(X(IX).GE.XNEXT) GO TO 15
 10     CONTINUE
        IX=NX
 15     CONTINUE
        XNEXT=X(IX)
        ISTART=IX
      ENDIF
C
      RETURN
      END

!------------------------------------------------------------------------------
!
!  COMPTABL_Z  -- COMPUTE SIGMA*V INTEGRAL TABLE
!
!  DMC SEPT 1988
!
SUBROUTINE COMPTABL_Z(VTR,MTX,DOM1,DOM2,N1,N2,IER)
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod   
  use physconst_mod, only : zero,one,mp_g
  IMPLICIT NONE
  INTEGER ier,iterbt,ix,jfun,iy,iadr,ierr
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) dummy,svth_z,epsbt,zv2kev,zcuns,svthe_z,tfun_z,&
       sigma_z,zy,zx,zfac,ztiev,zans1,zans2
!============
  INTEGER N1,N2
  real(fp) VTR(N1),MTX(N1,N2),DOM1(N1),DOM2(N2)
!
!  COMPUTE INTEGRAL TABLES AT USER GRID POINTS WHICH HAVE ALREADY BEEN
!  SET UP (CF X,Y, NXPTS, NYPTS)
!
!  THEN COMPUTE INTEGRALS AT MIDPOINTS OF GAPS IN USER GRID, AND COMPARE
!  RESULTS TO TABLE LOOKUP AND INTERPOLATION.  THIS "GAP GRID" USED FOR
!  ESTIMATING INTERPOLATION ERRORS IN USE OF THE TABLE, HAS ALSO BEEN
!  SET UP (XERR,YERR, NXM1=NXPTS-1, NYM1=NYPTS-1)
!
!  WHEN INTEGRALS ARE DONE USER MAY PLOT RESULTS, EITHER THE INTEGRALS
!  THEMSELVES OR THE INTERPOLATION ERRORS IN PER-CENT.
!
!  METHOD OF INTEGRATION VARIES WITH TYPE OF REACTION, TYPE OF INTEGRAL.
!
!  TYPE OF REACTION IS IDENTIFIED BY COMMON VARS. KREACT, KK
!    E.G. KREACT=-1 DENOTES ATOMIC CHARGE-EXCHANGE
!         KREACT=4  DENOTES D-->T (KK=0) OR T-->D (KK=1)
!    IF KREACT.GT.0 WE ARE DEALING WITH A FUSION REACTION AND KREACT, KK
!    ARE ARGUMENTS TO HARRY TOWNER'S SIGMA ROUTINE
!
!  TYPE OF INTEGRATION IS IDENTIFIED BY COMMON VARIABLE KEY, E.G.
!         KEY=1 FOR THERMONUCLEAR <SIGMA*V>
!         KEY=2 FOR BEAM TARGET <SIGMA*V>, ... ETC.
!
!------------------------------------------------------------------------------
!
!  REVISIONS
!  =========
!    DMC 2 OCT 1988 -- ADDED CALLS TO ATOMIC PHYSICS INTEGRATOR (DOINT,
!  PIRATED FROM OLD TESZIG PROGRAM)
!
!    DMC 7 OCT 1988 -- ADDED CALLS TO ROUTINES FROM BOB MCCANN'S OLD
!  BBCX PROGRAM, TO SUPPORT TRANSP BEAM-BEAM FUSION REACTION RATE GYRO
!  INTEGRALS.  NOTE UNITS ARE FUNNY HERE.
!    ** ALSO ** THE PRIMITIVE CROSS SECTIONS ARE HARD CODED IN THE
!  INTEGRAND ROUTINE.  THESE WERE CAREFULLY CHECKED AGAINST THE CURRENT
!  FUSION CROSS SECTIONS IN HHT'S SIGMA ROUTINE, IN SEPT 1988.
!    ** BUT ** IF FUSION CROSS SECTION FITS CHANGE, BOB'S ROUTINE
!  SIGVBB SHOULD BE UPDATED AND TESTED IN TANDEM
!
!    PCR 13 JUN 2000 -- REMOVED ERROR COMPUTATIONS
!
!------------------------------------------------------------------------------
!  FOR ATOMIC PHYSICS ROUTINES (DOINT ET AL)
!
  EXTERNAL TFUN_Z
!
  LOGICAL ICHEX
!
!------------------------------------------------------------------------------
!  FOR BEAM BEAM FUSION GYRO INTEGRAL
!
!CXX	EXTERNAL SIGVBB_Z  ! CALLED AS SUBROUTINE FROM INTEG_Z NOW !
!
!------------------------------------------------------------------------------
!
  IER=0
!
!  INITIALIZE INTEGRATIONS
!    SEE ALSO SUBROUTINE SIGPREP_Z (CALLS TO RMASS_Z DONE THERE)
!
  IF(KEY.EQ.1) THEN
     DUMMY = SVTH_Z(10._fp,1.e-4_fp,64,KREACT,0,6)
  ENDIF
!
  IF(KEY.EQ.2) THEN
     EPSBT=1.e-4_fp
     ITERBT=256
  ENDIF
!
  ICHEX=.FALSE.
  IF(KREACT.LT.0) THEN
! ATOMIC PHYSICS ROUTINES  -- CHARGE EXCHANGE ??
     IF((KREACT.EQ.-1).OR.(KREACT.EQ.-3).OR.(KREACT.EQ.-6).or.&
          (KREACT.EQ.-20).OR.(KREACT.EQ.-21).OR.(KREACT.EQ.-22))&
          ICHEX=.TRUE.
     IF((KREACT.EQ.-8).OR.(KREACT.EQ.-10).OR.(KREACT.EQ.-14))Then
        ICHEX=.TRUE.           ! tbt 12/20/94 for Lithium
     EndIf
     VCFAC=1.e-6_fp
     IFUN=0
     ZV2KEV=0.5e-3_fp*mp_g/1.6029e-12_fp
     IF(.NOT.ICHEX) THEN
        IF(KEY.EQ.2) IFUN=3
        IF(KEY.EQ.2) ZCUNS=1.e-6_fp
     ELSE
        IF(KEY.EQ.2) IFUN=2
        IF(KEY.EQ.2) ZCUNS=1.e-6_fp
        IF(KEY.EQ.3) IFUN=4
        IF(KEY.EQ.3) ZCUNS=1.0_fp
        IF(KEY.EQ.4) IFUN=6
        IF(KEY.EQ.4) ZCUNS=1.0_fp
     ENDIF
!
     IF(IFUN.EQ.0) THEN
        IER=1
        RETURN
     ENDIF
  ENDIF
!
!  INTEGRATION LOOPS
!
!==============================================================================
!  PRIMARY COMPUTATION OF NUMERICAL RESULT
!==============================================================================
!
!  1D TABLE
!
  IF(N2.EQ.0) THEN
!
!
     IF(KEY.EQ.1) THEN
        do ix=1,n1
           VTR(ix)=SVTHE_Z(DOM1(ix))
        enddo
     ENDIF
!
  ELSE
!
!  2D TABLE
!
!------------------------------------------------------------------------------
!  INSERT CALLS HERE TO EXTERNAL INTEGRATION LOOP ROUTINES
!------------------------------------------------------------------------------
!
     IF(KREACT.LT.0) THEN
!  ATOMIC PHYSICS -- LOOPS INSIDE DOINT_Z ROUTINE
        CALL DOINT_Z(TFUN_Z,MTX,N1,N2,DOM1,DOM2)
        IF((KEY.EQ.3).OR.(KEY.EQ.4)) THEN
!  NORMALIZING INTEGRAL FOR <EAV> OR < VB DOT VTARG / VB * VTH >
           JFUN=IFUN
           IFUN=2
           CALL DOINT_Z(TFUN_Z,ARRAY3,N1,N2,DOM1,DOM2)
           IFUN=JFUN
        ENDIF
     ENDIF
!
!  TRANSP BEAM BEAM GYRO INTEGRALS (DMC OCT 1988)
!
     IF(KEY.EQ.5) THEN
        DUMMY=SIGMA_Z(KREACT,0,6,100.0_fp)    ! set parameters for SIGE_Z
        ARRAY3(1:n2)=DOM2(1:n2)
        CALL INTEG_Z(DOM1,N1,ARRAY3,N2,MTX,KREACT)
     ENDIF
!
!------------------------------------------------------------------------------
!  LOOP OVER ALL INDEPENDENT COORDINATES.  CALL INTEGRATOR ROUTINE
!  *OR* NORMALIZE RESULTS FROM EXTERNAL INTEGRATION LOOP ROUTINE
!------------------------------------------------------------------------------
!
     DO  IY=1,N2
        ZY=DOM2(IY)
        DO IX=1,N1
           ZX=DOM1(IX)
           IADR=(IY-1)*N1+IX
!
           IF(KREACT.LT.0) THEN
!  ATOMIC PHYSICS-- NORMALIZE "DOINT_Z" RESULTS
              IF(KEY.GT.2) THEN
                 IF(KEY.EQ.3) THEN
                    ZFAC=ZV2KEV
                 ELSE
                    ZTIEV=ZY*1.e+3_fp
                    ZFAC=one/(SQRT(1.6029e-12_fp*ZTIEV/mp_g))
                 ENDIF
                 IF(ARRAY3(IADR).GT.zero) THEN
                    MTX(IX,IY)=ZFAC*MTX(IX,IY)/ARRAY3(IADR)
                 ELSE
                    MTX(IX,IY)=zero
                 ENDIF
              ENDIF
              MTX(IX,IY)=ZCUNS*MTX(IX,IY)
           ELSE
!  NUCLEAR PHYSICS-- DO INTEGRALS
              IF(KEY.EQ.2) THEN
!  <SIGMA*V> BEAM-TARGET FUSION
                 CALL DELTA_BEAM_Z(ZX,AMASS2,ZY,AMASS1,EPSBT,ITERBT,&
                      KREACT,KK,IERR,ZANS1,ZANS2)
!      	  IF(IERR.GT.1) WRITE(ILUNT,2901) IERR,ZX,ZY
! 2901 FORMAT(' DELTA_BEAM_Z:  IERR=',I6,', EB=',1PE12.5,' TI=',
!     >		    1PE12.5,' KEV')
                 MTX(IX,IY)=ZANS1
              ENDIF
           ENDIF
        enddo
     enddo
  ENDIF
!
END SUBROUTINE COMPTABL_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

      subroutine charopts(nopts,opts,present,value)
C
C  set flag(s) and fetch value(s) if character argument option(s) is(are)
C  present in the command line, otherwise clear flag(s), set value(s) blank.
C
C  all options are expected, as per the unix convention, to start with "-".
C
C  example:  nopts=1, opts='-file', command line contains "-file xyz.dat"
C     then this routine will return present(1)=.TRUE., value(1)="xyz.dat".
C
C  input:
      integer nopts                     ! number of defined Boolean options
      character*(*) opts(nopts)         ! the option strings-- "-xyz opt_arg"
C
C output:
      logical present(nopts)            ! T if option is found, F otherwise
      character*(*) value(nopts)        ! value of option argument
C
C---------------------
C
      character*128 zarg,zargval
C
C---------------------
C
      do i=1,nopts
         present(i)=.false.
         value(i)=' '
         if(opts(i)(1:1).ne.'-') then
            write(6,*) ' %charopts:  call error, opts(',i,')=',
     >         opts(i),' does not start with "-".'
         endif
      enddo
C
      call get_arg_count(inum)
C
      do ii=1,inum
         call get_arg(ii,zarg)
         if(zarg(1:1).eq.'-') then
            do i=1,nopts
               if(zarg.eq.opts(i)) then
                  present(i)=.true.
                  ip1=ii+1
                  call get_arg(ip1,zargval)
                  if(zargval(1:1).ne.'-') then
                     value(i)=zargval
                  endif
               endif
            enddo
         endif
      enddo
C
      return
      end

!******************** START FILE ZKBOLT.FOR ; GROUP KAPAI ******************
!
!
!@@@
!  BOLTONS KI(NU-HAT,EPS) FUNCTION (THESIS PP 74--78)
!
real(fp) FUNCTION ZKBOLT(ZNUHAT,ZEPS)
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: zeps,znuhat
  real(fp) :: zse,zeps32,ztanc,ztbnc,ztcnc,ztdnc,znh,zkinc,ztaps
  real(fp) :: ztbps,ztcps,ztdps,zkips
  real(fp), dimension(3) :: zanc,zbnc,zcnc,zdnc ! N-C COEFFICIENTS FROM TABLE VI
  real(fp), dimension(3) :: zaps,zbps,zcps,zdps ! P-S COEFFICIENTS FROM TABLE VI
  !
  DATA ZANC/2.441_fp,-3.87_fp,2.19_fp/
  DATA ZBNC/.9362_fp,-3.109_fp,4.087_fp/
  DATA ZCNC/.241_fp,3.40_fp,-2.54_fp/
  DATA ZDNC/.2664_fp,-.352_fp,.44_fp/
  !
  DATA ZAPS/.364_fp,-2.76_fp,2.21_fp/
  DATA ZBPS/.553_fp,2.41_fp,-3.42_fp/
  DATA ZCPS/1.18_fp,.292_fp,1.07_fp/
  DATA ZDPS/.0188_fp,.180_fp,-.127_fp/
  !
  ZSE=SQRT(ZEPS)
  ZEPS32=ZSE*ZSE*ZSE
  ZTANC=.66_fp+((ZANC(3)*ZSE+ZANC(2))*ZSE+ZANC(1))*ZSE
  ZTBNC=((ZBNC(3)*ZEPS+ZBNC(2))*ZEPS+ZBNC(1))/(ZEPS**.75_fp)
  ZTCNC=((ZCNC(3)*ZEPS+ZCNC(2))*ZEPS+ZCNC(1))/(ZEPS32)
  ZTDNC=((ZDNC(3)*ZEPS+ZDNC(2))*ZEPS+ZDNC(1))/(ZEPS32)
  !
  !  N-C PART
  !
  ZNH=SQRT(ZNUHAT)
  ZKINC=ZTANC/(1._fp+ZTBNC*ZNH+ZTCNC*ZNUHAT+ZTDNC*ZNUHAT*ZNUHAT)
  !
  ZTAPS=((ZAPS(3)*ZSE+ZAPS(2))*ZSE+ZAPS(1))*ZEPS32
  ZTBPS=((ZBPS(3)*ZSE+ZBPS(2))*ZSE+ZBPS(1))*ZEPS32
  ZTCPS=((ZCPS(3)*ZSE+ZCPS(2))*ZSE+ZCPS(1))
  ZTDPS=((ZDPS(3)*ZSE+ZDPS(2))*ZSE+ZDPS(1))
  !
  !  P-S PART
  !
  ZKIPS=1.57_fp*ZEPS32 + (ZTAPS+ZTBPS*ZNH)/ &
       (1._fp+ZTCPS*ZNUHAT**1.5_fp+ZTDPS*ZNUHAT**2.5_fp)
  !
  ZKBOLT=ZKINC+ZKIPS
  !
  RETURN
END FUNCTION ZKBOLT

      subroutine urdopen(ilun,zfile,iaccs,ierr)
C
C  UREAD open routine
C
C    input:  ilun -- fortran LUN to use
C           zfile -- filename
C           iaccs -- 1 for read, 2 for write
C
C   output:  ierr -- 0, normal, 1, error
C
      character*(*) zfile       ! nominal filename
C
      character*256 zfilu       ! actual filename
C
      character*20 zprog
C---------------------------------------
C
      if((iaccs.lt.1).or.(iaccs.gt.2)) then
         call uermsi(' ?urdopen:  argument error, iaccs:',iaccs,0)
         ierr=1
         return
      endif
C
C  unix only:  if slash is found in name, allow syntax
C    <env-var-name>/<filename>
C    where <env-var-name> gets translated (for unix environments)
C
      zfilu=zfile
C
      indsl=index(zfile,'/')
      if(indsl.gt.1) then
         call ufilnam(zfile(1:indsl-1),zfile(indsl+1:),zfilu)
      endif
C
      call ufopen(ilun,zfilu,iaccs,ierr,0)
C
      if(ierr.ne.0) then
         call urd_getprog(zprog)
         if((iaccs.eq.1).and.(zfile(1:1).ne.'/')) then
            call ufilnam('TRANSP_LOCATION',
     >           trim(zprog)//'/'//trim(zfile),zfilu)
            write(lnout(0),*) ' %urdopen: trying: '//trim(zfilu)
            call ufopen(ilun,zfilu,iaccs,ierr,0)
            if(ierr.ne.0) then
               call ufilnam('TRANSPROOT',
     >              'codesys/tmi/'//trim(zprog)//'/'//trim(zfile),zfilu)
               write(lnout(0),*) ' %urdopen: trying: '//trim(zfilu)
               call ufopen(ilun,zfilu,iaccs,ierr,0)
            endif
         endif
      endif
C
      return
      end

C------------------------------------------------------------------------------
C
C  Peter Richter (prichter@princeton.edu)
C  Princeton Plasma Physics Laboratory
C  August 2000
C
C  icode_preact.for - Return integer code associated with a
C            particular reaction.
C
C------------------------------------------------------------------------------
C
      integer function icode_preact(tag)
C
      implicit none
      character*(*) tag
C
      if (tag.eq.'recombine') then
 
         icode_preact=0
 
      else if ((tag.eq.'H->H(cx)').or.(tag.eq.'H->H(ii)')
     >      .or.(tag.eq.'D->D(n)').or.(tag.eq.'C+6->H')
     >      .or.(tag.eq.'i:e->H0')) then
 
         icode_preact=1
 
      else if ((tag.eq.'H+->He0x').or.(tag.eq.'H+->He0i')
     >      .or.(tag.eq.'D->D(p)').or.(tag.eq.'C+6->He')
     >      .or.(tag.eq.'i:e->He0')) then
 
         icode_preact=2
 
      else if ((tag.eq.'He++>Hex').or.(tag.eq.'He++>H0i')
     >      .or.(tag.eq.'D->T')   .or.(tag.eq.'C+6->Li')
     >      .or.(tag.eq.'i:e->Li0')) then
 
         icode_preact=3
 
      else if ((tag.eq.'H+->Li0x').or.(tag.eq.'He++>Hei')
     >      .or.(tag.eq.'T->D')   .or.(tag.eq.'O+8->H')) then
 
         icode_preact=4
 
      else if ((tag.eq.'He++>Lix').or.(tag.eq.'H+->Li0i')
     >      .or.(tag.eq.'D->He3') .or.(tag.eq.'O+8->He'))  then
 
         icode_preact=5
 
      else if ((tag.eq.'Li+++>Lx').or.(tag.eq.'He++>Lii')
     >      .or.(tag.eq.'He3->D') .or.(tag.eq.'O+8->Li'))  then
 
         icode_preact=6
 
      else if ((tag.eq.'Li+++->H').or.(tag.eq.'T->T'))    then
 
         icode_preact=7
 
      else if ((tag.eq.'Li+++>He').or.(tag.eq.'T->He3'))  then
 
         icode_preact=8
 
      else if ((tag.eq.'Li+++>Li').or.(tag.eq.'He3->T'))  then
 
         icode_preact=9
 
      else if ((tag.eq.'Li+++->H').or.(tag.eq.'dpcT->T'))    then
 
         icode_preact=10
 
      else
         icode_preact=-1                 ! Error - invalid tag
      endif
C
      return
      end
C
C------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!
!  ISIGIND_Z -- RETURN REACTION INDEX GIVEN REACTION ALADDIN LABEL
!
INTEGER FUNCTION ISIGIND_Z(ZLBL)
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod   
  IMPLICIT NONE
  INTEGER ians,i
!============
  CHARACTER*(*) ZLBL
!
  IANS=0
!
  DO I=1,NUMALAD
     IF(ZLBL.EQ.ALADRLBL(I)) THEN
        IANS=I
        exit
     ENDIF
  enddo
!
  ISIGIND_Z=IANS
!
  RETURN
END FUNCTION ISIGIND_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

!--------------------------------------------------------------------
!
! Convert string to integer
!
FUNCTION atoi(string,i_in) RESULT (value)
  IMPLICIT NONE
  CHARACTER (len=*),intent(in) :: string
  INTEGER,intent(in) :: i_in
  INTEGER :: i, ii, max, sign, value
  CHARACTER (len=10), PARAMETER :: digit = '0123456789'
  i=i_in
  max = len(trim(string))
  value = 0
  sign = 1
  CALL skipbl(string,i)
  IF (string(i:i)=='-') THEN
    sign = -1
    i = i + 1
  END IF
  DO 
    ii = index(digit,string(i:i))
    if(ii==0) exit
    value = (value*10) + (ii-1)
    i=i+1
  END DO
  value = sign*value
END FUNCTION atoi

!--------------------------------------------------------------------
!
! Skip blanks in a string, used by ATOI
!
SUBROUTINE skipbl(string,i)
  IMPLICIT NONE
  CHARACTER(len=*) :: string
  INTEGER :: i, max

  max = len(string)

  IF (string(i:)==' ') THEN
    i = max
  ELSE
    DO i = i, max
      IF (string(i:i)/=' ') EXIT
    END DO
  END IF
  return
END SUBROUTINE skipbl

C******************** START FILE ISCOMP.FOR ; GROUP URDUTS ******************
C
C=========================================================
C&  ISCOMP  UREAD COMPARE INPUT STRING WITH LIST, SIGN FEATURE
C
C  COMPARE INPUT STRING WITH LIST, LOOK FOR A MATCH
C   SPECIAL CHARACTERS-- '+' AND '-' ALGEBRAIC
C    MULTIPLY ANSWER BY +/- 1
C
C  FUNCTION VALUE RETURNED POINTS TO LOCATION OF MATCH
C  IN LIST; NO MATCH ==> 0 RETURNED AS FCN VALUE
C
C
      INTEGER FUNCTION ISCOMP(ABLIS,N,NMAX)
C  ABLIS-- LIST OF STRINGS
C  N    -- # OF ELEMENTS IN LIST
C  NMAX -- MAX # OF CHARACTERS PER ELEMENT IN LIST
C
C
      USE USERIO
      CHARACTER*(*) ABLIS(N)
      character*(urdbufl) zcbuff
      character*1 zdbuff(urdbufl)
      integer ilen

C  REV. JULY 1982 -- USE SUBFUNCTION WHICH DOESNT INCLUDE
C  USERIO COMMON
      zcbuff=cbuff
      call uspcap(zcbuff)

      zdbuff=' '
      ilen=max(1,len_trim(zcbuff))
      do i=1,ilen
         zdbuff(i)=zcbuff(i:i)
      enddo
C
      ISCOMP=ISCMP0(ZDBUFF,ABLIS,N,NMAX,ILC)
      IF(ISCOMP.NE.0) CALL UROTOR(ILC)
      RETURN
C
      END
C******************** END FILE ISCOMP.FOR ; GROUP URDUTS ******************

      subroutine ufmds_rhdr(ichan,idev,zsdate,ishot,idim,znode,iln,
     >           iproc, ier)
C
C  read MDS+ "Ufile" header
C
C---------------------------------
C History:
C 10/22/01 CAL: get iproc
C 11/18/99 CAL: new calling arguments for mds_value
C
C------------------------------
      use UFILES
      implicit none
C  input:
      integer ichan             ! Ufiles channel id
C  output:
      character*(*) idev        ! 4 character tokamak id
      character*(*) zsdate      ! 10 character shot date label
      integer ishot             ! shot number
      integer idim              ! dimensionality of data signal
      character*(*) znode       ! full node path
      integer iln               ! nonblank length of znode
      integer iproc             ! proc code
      integer ier               ! status
C
      character*128 zerrmsg
      character*128 zstr, zpath
C
      integer     idescr_long,  idescr_cstring, mds_value
      integer     iretl, iyy,   ilt,   ios
      integer     nsca,  istat, ilm, ilns
      logical     tr_run
C
C----------------------------------
C
C      write(ufelun,7701)
C 7701 format(' %UFMDS_RHDR MDS+ data access.'/
C     +     '  Labels may be incorrect.')
      NSCA=0
      idev='MDS+'
      zsdate='MDS+:date?'
      ishot=ufshot(ichan)
C
      istat=0
      if (mds_tree(ichan)(1:6).eq.'TRANSP') then
C     >   mds_tree(ichan)(1:3).eq.'JET' .or.
C     >   mds_tree(ichan)(1:5).eq.'BEAST') then
         tr_run = .true.
      else
         tr_run = .false.
      endif
C
C make path:node -> znode
      call ufsnmd_nod0(mds_path(ichan),mds_node(ichan),znode,iln)
C
      ilns=len_trim(mds_server(ichan))
      if(mds_server(ichan)(ilns-6:ilns).eq.'MIT.EDU') then
         idev='CMOD'
         call uf_cmod_sdate(ishot,zsdate)
C
C      else if(mds_tree(ichan).eq.'TFTR') then
C         idev='TFTR'
C      else if(mds_tree(ichan).eq.'NSTX') then
C         idev='NSTX'
      else if(tr_run .or.
     >       mds_tree(ichan)(1:3).eq.'TRW') then
C Get DEVICE
         if (tr_run) then
            zpath = ':DEVICE'
         else
            zpath = znode(1:iln)//':DEVICE'
         endif
         istat=mds_value(zpath,idescr_cstring(zstr),iretl)
         if(mod(istat,2).eq.1) then
            idev=zstr
         else
            call ufmds_err('UFMDS_RHDR',istat,ier,zerrmsg,ilm)
            write(ufelun,7703) zerrmsg(1:ilm)
 7703       format('  seeking MDS+ device: ',/2x,a)
         endif
         if (tr_run) then
C Get date
            istat=mds_value(':date_began',idescr_cstring(zsdate),iretl)
C            istat=mds_value(':shot_idate',idescr_long(iyy),iretl)
C            if(mod(istat,2).eq.1) then
C               write(zsdate,'(a4,''.'',i2.2)',iostat=ios) idev,iyy
C            endif
 
         else
            iln = index(mds_node(ichan),' ')-1
            istat=mds_value(mds_node(ichan)(1:iln)//':DATE',
     >            idescr_cstring(zsdate),iretl)
         endif
         if(mod(istat,2).eq.0) then
            call ufmds_err('UFMDS_RHDR',istat,ier,zerrmsg,ilm)
            write(ufelun,7702) zerrmsg(1:ilm)
 7702       format('  seeking MDS+ date: ',/2x,a)
         endif
 
C Get proc_code
            iproc=0
            istat=mds_value(znode(1:iln)//':PROC_CODE',
     >            idescr_long(iproc),iretl)
C           ignore error for now
      endif
C
C
      call ufmds_rank(znode(1:iln),idim,ier)
C
      return
      end
C------------------------
      subroutine uf_cmod_sdate(ishot,sdate)
C
C  translate CMOD yymmddnnn shot# into 10 char date
C
      integer ishot             ! CMOD 9 digit shot # (input)
      character*10 sdate        ! date string (output)
C
C  date string format:  ddmon-yyyy
C
      character*3 mons(12),month
      data mons/'jan','feb','mar','apr','may','jun','jul','aug',
     >     'sep','oct','nov','dec'/
C
C-------------------
C
      idate=ishot/1000
      iyear=idate/10000
      imond=idate-10000*iyear
C
C  possible note Y2K issue here -- IF CMOD runs past 2080!
C
      if(iyear.le.80) then
         iyear=2000+iyear
      else
         iyear=1900+iyear
      endif
C
      imon=imond/100
      iday=imond-100*imon
C
      month='???'
      if((imon.ge.1).and.(imon.le.12)) then
         month=mons(imon)
      endif
C
      write(sdate,'(i2,a3,''-'',i4)') iday,month,iyear
C
      return
      end

C******************** START FILE MLSCCK.FOR ; GROUP GRFMP1 ******************
C------------------------------------------------------------
C  MLSCCK
C
C  CHECK THE SCALE PAIR (ZMIN,ZMAX)
C
      SUBROUTINE MLSCCK(ZMIN,ZMAX)
C
      IF(ZMIN.GT.ZMAX) THEN
        ZTEMP=ZMIN
        ZMIN=ZMAX
        ZMAX=ZTEMP
      ENDIF
C
C  EQUALITY DISALLOWED
C
      IF(ZMIN.EQ.ZMAX) THEN
        IF(ZMIN.EQ.0.0) THEN
          ZMIN=-0.1
          ZMAX=0.1
        ELSE IF(ZMIN.LT.0.0) THEN
          ZMIN=1.01*ZMIN
          ZMAX=0.99*ZMAX
        ELSE IF(ZMIN.GT.0.0) THEN
          ZMIN=0.99*ZMIN
          ZMAX=1.01*ZMAX
        ENDIF
      ENDIF
C
      RETURN
      END
C******************** END FILE MLSCCK.FOR ; GROUP GRFMP1 ******************

c-----------------------------------------------------------------------
c mds__leniftrim
c return length of string if trimmed of rightmost blanks
c
c 03/11/1999 ler
c-----------------------------------------------------------------------
      integer function mds__leniftrim(string)
      implicit none
 
      character*(*) string
      integer i, l
 
      l = len(string)
      mds__leniftrim = l
      do i=l,1,-1
         if (string(i:i).ne.' ') then
            goto 100
         else
            mds__leniftrim = mds__leniftrim - 1
         end if
      end do
 100  continue
 
      return
      end

subroutine r4dft(f,n)

  !  compute the Discrete Fourier Transform of a real sequence; return
  !  the transform in Hermetian form.  Replacement for NAG c06eae; may
  !  be less efficient.  DMC 15 Oct 2002

  use iso_c_binding, only: fp => c_float
  implicit none

  integer, intent(in) :: n
  real(fp), intent(inout) :: f(0:n-1)

  integer i,ib,j
  real(fp) :: f0(0:n-1)
  real(fp) :: zsin(n-1),zcos(n-1)

  real(fp), parameter :: C2PI = 6.2831853071795862_fp
  real(fp), parameter :: ZERO = 0.0_fp
  real(fp), parameter :: ONE = 1.0_fp

  real(fp) :: zang0, znorm

  !---------------------------

  znorm=ONE/sqrt(ONE*n)

  f0(0)=f(0)
  do i=1,n-1
    f0(i)=f(i)
    f(0)=f(0)+f(i)  ! form a0
  enddo

  do i=1,n/2
    ib=n-i
    f(i)=f0(0)
    if(ib.gt.(n/2)) f(ib)=ZERO

    zang0=i*C2PI/n
    call sincos(zang0,n-1,zsin,zcos)
    do j=1,n-1
      f(i)=f(i)+f0(j)*zcos(j)
      if(ib.gt.(n/2)) f(ib)=f(ib)-f0(j)*zsin(j)
    enddo
  enddo

  f=znorm*f

  return
end subroutine r4dft

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_errstr(ierr, str)
      implicit none
      integer ierr
      character*(*) str
      str = ' '
      mds_errstr = 0
      return
      end
#else
c-----------------------------------------------------------------------
c mds_errstr
c get error string
c
c 03/16/1999 ler Converting to unix usable
c                Get rid of null end of string before returning
c-----------------------------------------------------------------------
        integer function mds_errstr(ierr, str)
        implicit none
 
        integer ierr
        character*(*) str
	
        integer dsc, size, status
        character*19 cmd
 
        integer descr, MdsValue, mds__cstring
 
        str=' '
        write(cmd, '(''GETMSG('',I11,'')'')') ierr
        dsc = descr(mds__cstring(), str, 0, len(str))
        status = MdsValue(cmd //char(0), dsc, 0, size)
        call mds_addblanks(str)
 
        mds_errstr = status
 
        return
        end
#endif
 
 

C******************** START FILE ufiget.FOR ; GROUP UREAD5 ******************
c---------------------------------------------------------------
c& ufiget  GET UREAD INPUT FROM FILE(S) - BUFFERING SCHEME
C
c  two barrelled buffered line fetcher for subroutine uread
c  version 3, [transp]uread3.for on the VAX
c  by D. Mc Cune 7 Jan 1981 pppl
c
c  this routine controls the passage of asci lines
c  buffered out of an indirect input file,
c  from the input device through uread to the interactive
c  applications program.  this routine controls the opening and
c  closing of indirect input files and manages the buffers
 
 
      subroutine ufiget(zfile,ICODE0,ier,ieof)
 
      use USERIO
 
      parameter (isiz00=250)
c
c  this parameter gives the size in 128 character asci lines of
c  each of the two buffers.  The buffers are for indirect input
c  files only.  Two buffers allows the buffering of two levels of
c  indirect input.  If an indirect input file fits entirely inside
c  the buffer then it may perform a tight loop without having to
c  reopen/reread the file.  Or one file may loop as a subroutine
c  of another buffered file which is looping.
c     isiz00 size pages of indirect input file are paged into
c  one of the two buffer barrels each time an old page runs out
c  or when a new input file is opened.  see subroutine ugbuf0 below.
c    5 functions are supported by this routines
c    (1) open an indirect input file
c    (2) read in a line from an indirect input file.
c    (3) close an indirect input file
c        reestablish communications with higher level input file
c    (4) rewind the current buffer-- set the line pointer to the
c        beginning of the current buffer
c    (5) rewind the file and load the buffer with the first page
c
C  Modified:
C
C  05/15/95  TBT - IOncrease length of zfile to 130 from 64.

      character*130 zfile        ! 130 is arbitrary  tbt
c
c  zfile - 130 char filename
c  icode-- function select 1,2,3,4,5
c  ier - error flag
c  ieof - end-of-file flag
c
c  local symbols
c
      character*(urdbufl) zbufr(isiz00,2)
      integer ilun(2), ilunin(2), ilasl(2), iendl(2), ipt(2),
     >          isiz(2), istat(2)
      logical iopen(2),iavail(2),itotal(2)
      character*130 zfilep(2)      ! 130 is arbitrary  tbt
c
      save zbufr,ilasl,iendl,ipt,istat,iavail
c
c  zbufr: 2 barrelled buffer
c  ilun: lun of file read into each buffer
c  ilunin: stack location of file (bigger number --> more nested input)
c  ilasl: last line of buffer containing data line from file
c  iendl: location of end of file 0= not known
c         i==> i-1 is last line in file
c         iendl=1 would be an error
c  ipt:   points to current line from buffer
c  isiz:  size of each buffer
c  istat: flag for determining if file fits in buffer
c  zfilep:  name of file read into each buffer
c
c  iopen: .true.==>file for buffer is open
c  itotal: .true.==> entire file fits into buffer
c
      data ilun/2*0/
      data ilunin/2*0/
      data iopen/2*.false./
      data itotal/2*.false./
      data isiz/2*isiz00/
      data zfilep/2*' ? ? ? ? ? ? ? ? ? ? ? ? ? ? ?'/
      data icur/2/
c
c  local variable icur points to the currently active buffer
c  this statement function toggles the current buffer ptr.
c
      lswich(icur)=3-icur
c
c
C  MOD DMC DEC 1989 -- PASSED NAME CHANGED FROM ICODE TO ICODE0
C  ICODE=IABS(ICODE0) SIGN OF ICODE0 ALLOWS EXTRA CONTROL -- E.G.
C  FOR ICODE0=-1, A DISK READ OF THE INPUT FILE IS FORCED; THE
C  INTERNAL BUFFER IS NOT USED.
C
c  start of executable code
c
      IF(ICODE0.LT.0) THEN
        ISIGN=-1
      ELSE
        ISIGN=1
      ENDIF
c
      icode=ISIGN*ICODE0
c
      ieof=0
      ier=0

      if(nljava) then
         ! this suppresses buffering, in JAVA mode
         !   --necessary because JAVA code can be used to manipulate
         !     scripts between invocations.
         zfilep(1) = ' ? ? ? '
         zfilep(1) = ' ? ? ? '
      endif
c
      go to (100,200,300,400,500) icode
c
c  open indirect file
 100  continue
cx	write(6, 7001)
cx 7001	format('     ... open file')
c  switch to new buffer
      iprev=icur
      icur=lswich(icur)
      if(itotal(icur).and.
     >     (zfile.eq.zfilep(icur)).and.(isign.eq.1)) then
c  buffer already loaded -- reuse
        if(ibatch.eq.0) then
         if(nlecho.or.(.not.nlindi)) then
          ilfiln=index(zfile,' ')-1
          if(ilfiln.le.0) ilfiln=len(zfile)
          write(luntrm,2001) zfile(1:ilfiln)
         endif
        endif
        call uindop(zfile,ier,2)
        if(ier.ne.0) go to 190
        ilun(icur)=luntin(nlunin)
        ilunin(icur)=nlunin
        go to 400
 2001 format(/' @FILENAME=',a,' [INTERNAL]'/)
      endif
c
c  rewritten dmc may 1986.  If a file in the input file stack and
c  buffer is about to be replaced in the buffer by a lower level input
c  file, make sure that the file pointer is up to date
c
      if(ilunin(icur).lt.ilunin(iprev)) then
        if(ipt(icur).lt.ilasl(icur)) then
c  fix dmc may 1986
          if(ilun(icur).eq.0) then
            call uermsi('%ufiget:  uread buffer error',nlunin,1)
            go to 190
          endif
c
          if(.not.iopen(icur)) then
            CALL URDOPEN(ILUN(ICUR),ZFILEP(ICUR),1,IERR)
            IF(IERR.NE.0) GO TO 190
          else
            rewind ilun(icur)
          endif
c
          do 110 i=1,ipt(icur)
            read(ilun(icur),5001,END=110) zbufr(1,icur)
            call urd_cln_input(zbufr(1,icur))
 5001       format(a)
 110      continue
c
        endif
      endif
c
c  open indirect file
      call uindop(zfile,ier,1)
c  check for error exit
      if(ier.ne.0) go to 190
c  initialize and read first bufferfull
      iendl(icur)=0
      itotal(icur)=.false.
      iopen(icur)=.true.
      istat(icur)=1
      ilun(icur)=luntin(nlunin)
      ilunin(icur)=nlunin
      zfilep(icur)=zfile
      ilasl(icur)=0
c
      call ugbuf0(istat(icur),zbufr(1,icur),isiz(icur),ilasl(icur),
     >              itotal(icur),iendl(icur))
      if(iendl(icur).eq.1) then
        write(luntrm,9001) zfile
        go to 190
      endif
 9001 format(' % null file:  ',a)
c  all done-- initialize buffer and exit
      go to 400
c
c  error exit
 190  continue
      ier=1
      icur=lswich(icur)
      return
c---------------------------------
 200  continue
cx	write(6, 7002) icur,ipt(icur)
cx 7002	format('     ... read a line icur=',i2,' ip=',i2)
c  read a line from the buffer- check for e-o-f marker
      ip=ipt(icur)+1
      if(ip.eq.iendl(icur)) go to 280
      ncmnd(nlunin)=ncmnd(nlunin)+1
c  check for end of buffer
      if(ip.le.ilasl(icur)) go to 240
c  reset pointer if at end of buffer page
      if(ilasl(icur).eq.isiz(icur)) then
        ip=1
        istat(icur)=2
      endif
c  end-of-buffer: refill, or complete buffer page after break to
c  subsidiary indirect file
      call ugbuf0(istat(icur),zbufr(1,icur),isiz(icur),ilasl(icur),
     >              itotal(icur),iendl(icur))
      if(ip.eq.iendl(icur)) go to 280
c
 240  continue
c  transfer line from buffer and exit
      cbuff=zbufr(ip,icur)
      ipt(icur)=ip
      return
c  end-of-file marker encountered
 280  continue
      ieof=1
      return
c----------------------------------------------------------
 300  continue
cx	write(6, 7003)
cx 7003	format('     ... close file')
c  close the input file and establish communications with the next
c  level up
      if(iopen(icur)) close(unit=luntin(nlunin))
      iopen(icur)=.false.
      ilun(icur)=0
c
c  switch to other buffer
c
      icur=lswich(icur)
c  done if other buffer has input file page in core or if higher
c  level file is user - direct i/o
      if(nlunin.le.max0(2,(nlunio+1))) return
      if(ilun(icur).eq.luntin(nlunin-1)) return
c  reestablish link to higher level file
      ilun(icur)=luntin(nlunin-1)
      ilunin(icur)=nlunin-1
c  restart buffered input for file on unit ilun(icur)
 350  continue
      ipt(icur)=0
      ilasl(icur)=0
      iendl(icur)=0
      iopen(icur)=.true.
      itotal(icur)=.false.
      istat(icur)=2
c  buffer will be refilled with next isiz00 lines from file open on
c  unit luntin(nlunin-1), on the next call to read a line
      return
c---------------------------------------------------------
 400  continue
      if(icode.eq.1) ncmnd(nlunin)=0
      if(icode.eq.4) ncmnd(nlunin)=ncmnd(nlunin)-ipt(icur)
cx	write(6, 7004)
cx 7004	format('     ... initialize buffer pointer; buffer rewind')
c  initialize/re-initialize or rewind already filled buffer
      ipt(icur)=0
      return
c
 500  continue
cx	write(6, 7005)
cx 7005	format('     ... rewind file')
c  rewind file
      rewind luntin(nlunin)
      ncmnd(nlunin)=0
      go to 350
      end
C******************** END FILE ufiget.FOR ; GROUP UREAD5 ******************

      subroutine urd_cln_input(zstr)

      !  remove control characters, e.g. DOS \r, from input line

      implicit NONE

      character*(*) zstr

      integer :: ilen,ic,icc

      ilen = len(trim(zstr))

      do ic=1,ilen
         icc=ichar(zstr(ic:ic))
         if((icc.eq.127).or.((icc.ne.9).and.(icc.lt.32))) then
            zstr(ic:ic)=' '
         endif
      enddo

      return
      end

C-----------------------------------------------------------------------
C  URPUNC  -- RETURN CURRENTLY SET USER PUNCTUATION STRING
C
      SUBROUTINE URPUNC(ZPUNCT)
C
      USE USERIO
C
      CHARACTER*16 ZPUNCT
C
C------------------------------------
C
      ZPUNCT=' '
      IF(LPUNCT.GT.0) ZPUNCT(1:LPUNCT)=UPUNCT(1:LPUNCT)
C
      RETURN
      END

real(fp) FUNCTION frantic_zh3x(zxx)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, two
  implicit none
  ! Argument variables:
  real(fp), intent(in) :: zxx
  ! Local variables
  real(fp), parameter :: zpio2 = 1.570796327_fp
  !
  !  AVOID UNDERFLOW ON VAX-- FCN VALUE SET TO ZERO if ZXX .GT. 77
  !  CORRESPONDING TO A FCN VALUE OF ABOUT 1.E-34
  !
  if(ZXX.LE.TWO) then
    frantic_zh3x=EXP(-ZXX)*ZEEE1(ZXX)
  else if(ZXX.LE.77.0_fp) then
    frantic_zh3x=EXP(-ZXX)*ZEEE2(ONE/ZXX)
  else
    frantic_zh3x=ZERO
  end if
  !
  return

contains

  !
  !  STATEMENT FCNS
  !
  real(fp) function zeee1(y)
    real(fp), intent(in) :: y
    zeee1 =  ZPIO2 - Y*(0.4292037_fp - Y*(0.3561945_fp - Y*(0.462238_fp - &
         Y*(0.404604_fp - Y*(0.178267_fp - Y*0.030169_fp)))))
    return
  end function zeee1

  real(fp) function zeee2(y)
    real(fp), intent(in) :: y
    zeee2 = SQRT(Y)*(2.50663_fp - Y*(4.18947_fp - Y*(13.9212_fp - &
         Y*(46.3264_fp - Y*(92.7633_fp-Y*73.3359_fp)))))
    return
  end function zeee2

end FUNCTION frantic_zh3x

C******************** START FILE UfSwXY2.FOR ; GROUP UfSwXY2 ******************
C-------------------------------------------------------------
C  UfSwXY2
C  SWITCH X AND Y INDEP. VARIABLE DIMENSIONS OF 2D ARRAY
C  AND REVERSE INDEXING OF DATA ARRAY  Version 2 - 10/93 tbt
 
C
      SUBROUTINE UfSwXY2(F,FB,ISIZ,X,NX,Y,NY,XLAB,YLAB,
     1                     Xunits, Yunits)
 
C
C  F-- 2D FUNCTION ARRAY TO BE REINDEXED
C  FB-- WORKSPACE SAME SIZE AS F
C  ISIZ- SIZE OF F, FB
C  X(NX) X INDEPENDANT VARIABLE ARRAY
C  Y(NY) Y INDEPENDANT VARIABLE ARRAY
C  XLAB X LABEL
C  YLAB Y LABEL
C
      REAL F(ISIZ),FB(ISIZ),X(ISIZ),Y(ISIZ)
      Character*30 Zltem
      CHARACTER*(*) XLAB,YLAB
      CHARACTER*(*) XUNITS, YUNITS
C
C  CLEAR FB
C
      DO 10 I=1,ISIZ
      FB(I)=0.0
 10   CONTINUE
C
C  INVERT F
C
      DO 20 IY=1,NY
      DO 20 IX=1,NX
      IP1=(IY-1)*NX+IX
      IP2=(IX-1)*NY+IY
      FB(IP2)=F(IP1)
 20   CONTINUE
C  COPY BACK
      CALL UCOPYF(FB,F,ISIZ)
C  SWITCH X,Y ARRAYS
      IMAX=MAX0(NX,NY)
      DO 30 I=1,IMAX
      ZTEM=X(I)
      X(I)=Y(I)
      Y(I)=ZTEM
 30   CONTINUE
      ITEM=NX
      NX=NY
      NY=ITEM
 
 
C  SWITCH LABELS
 
      Zltem = Xlab
      Xlab  = Ylab
      Ylab  = Zltem
 
      Zltem = Xunits
      Xunits= Yunits
      Yunits= Zltem
 
      RETURN
      END
C******************** END FILE UfSwXY2.FOR ; GROUP UfSwXY2 ******************

subroutine zstop_sigv(izneut,izimp,eova,n,sigv)
 
  use hatom_mod
  implicit NONE
 
  !  neutral stopping rate coefficient (cx + ii) for neutral atom
  !  (Z=izneut) striking an impurity population with relative energy
  !  per amu EovA (KeV/nucleon) -- or mp*vrel**2/2 expressed in KeV
  !  via table lookup
  !
  !  tables provided for H,He,Li
  !         interacting with C and O
  !         other Zimp => interpolation or scaling by Z of C and/or O
  !         rate coefficients
 
  integer, intent(in) :: izneut   ! Z of neutral atom (1, 2 or 3)
  integer, intent(in) :: izimp    ! Z of (fully stripped light) impurity ion
  integer, intent(in) :: n        ! vector size
  real*8, intent(in) :: EovA(n)   ! rel. energy / nucleon, KeV/AMU
 
  real*8, intent(out) :: sigv(n)  ! <sigma*v> value(s) returned  m**3/sec
 
  real*8, parameter :: out_of_range=0.0  ! sigv to use when out of range

  !
  !  if iZneut is out of range, sigv(:)=out_of_range is returned...
  !
  !-----------------------
  ! local
 
  real*8 zimp
 
  !-----------------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  if(izimp.eq.6) then
 
     if(izneut.eq.1) then
 
        call sv_coldtarget_sigmatimesv(Lst_H0_C6,eova,sigv,n)
 
     else if(izneut.eq.2) then
 
        call sv_coldtarget_sigmatimesv(Lst_He0_C6,eova,sigv,n)
 
     else if(izneut.eq.3) then
 
        call sv_coldtarget_sigmatimesv(Lst_Li0_C6,eova,sigv,n)
 
     else
        sigv = out_of_range
     endif
 
  else if(izimp.eq.8) then
 
     if(izneut.eq.1) then
 
        call sv_coldtarget_sigmatimesv(Lst_H0_O8,eova,sigv,n)
 
     else if(izneut.eq.2) then
 
        call sv_coldtarget_sigmatimesv(Lst_He0_O8,eova,sigv,n)
 
     else if(izneut.eq.3) then
 
        call sv_coldtarget_sigmatimesv(Lst_Li0_O8,eova,sigv,n)
 
     else
        sigv = out_of_range
     endif
 
  else
     zimp = izimp
     call zstop_sigvz(izneut,zimp,eova,n,sigv)
  endif
 
end subroutine zstop_sigv

program sigtab
      !  updated June 2009
      !  call up uread/sglib program to plot preact and adas data via fpreact calls
      !  dmc Nov 2002 -- this replaces the defunct sigtab that referred
      !  to $SIGTABLDIR data that was replaced by preact some time ago.

  call uinitg("SIGTAB")
  
  call plot_fpreact
  
  call uexita(0)
  
  stop
  
end program sigtab

      subroutine ubw3int(ilun,ivalue)
C
C  UFILES low level i/o routine
C  write 3 byte unsigned integer
C
      use UFILES
C
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(4)    ! small local buffer
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
C
C-----------------------------------------------------
C
      CALL UFLCHK(ILUN,'ubw3int   ',ICHAN,IER)
      IF(IER.NE.0) go to 999
C
      call ubcflush(ichan)   ! flush compressed character output buffer
C
#ifdef __CRAY
      ilbuf(1)=char(1)
#else
      ilbuf(1)=1
#endif
      call ubi3ncod(ivalue,ilbuf,2)
      ilenb=4
C
C  transfer the buffer
C
      call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,ilenb)
C
      go to 1000
C
C  errors
C
 999  continue
      write(6,'('' ?UFLIB:  ubw3int low level i/o routine:  error.'')')
C
C  exit
C
 1000 continue
      return
      end

      subroutine sset_cwd(dir,ierr)
      character*(*) dir                 ! directory to cd to...
      integer ierr                      ! error status code, 0 = normal
 
#include "fpreproc/byte_declare.h"
      byte_declare dirbuf(256)
 
      integer chdir
      integer ild
C
      ild=max(1,len_trim(dir))
 
#ifdef __CRAY
      call pxfchdir(dir,0,ierr)
#elif __HP || __IBM || __RS6000
      ierr = chdir(dir(1:ild)//char(0))
#else
      if(ild.le.255) then
         call cstring(dir(1:ild),dirbuf,'2C')
         ierr = linux_chdir(dirbuf)
      else
         write(6,*) ' ?sset_ccwd:  directory path too long:'
         write(6,*) dir(1:ild)
         ierr=1
      endif
#endif
 
      return
      end

C---------------------------------------------------------------------
C  GRF3OP   GRAPHICS OPTION MENU FOR DISPLAY OF F(X,T) DATA
C
C  DMC JUNE 1988 -- EXTRACTED FROM THE OLD GRF3 SUBROUTINE
C
      SUBROUTINE GRF3OP(ZLABEL,ZTITLE,XLAB,ZLAB,ZLAB2,YLAB,
     >    CNTRL,IMAIN,ISUB,NFCN,IFCN)
C
      LOGICAL, EXTERNAL :: LCHAR,LXOUT,LYES,LYESC
C
      CHARACTER*(*) ZLABEL,ZTITLE   ! GENERIC LABELS
C
      CHARACTER*(*) XLAB    ! X INDEP COORDINATE LABEL
      CHARACTER*(*) ZLAB    ! DEPENDENT COORDINATE LABEL
      CHARACTER*(*) ZLAB2   ! 2ND DEPENDENT COORDINATE LABEL (OPTIONAL)
      CHARACTER*(*) YLAB    ! Y INDEP COORDINATE LABEL
C
      CHARACTER*(*) CNTRL   ! EXTRA CONTROL OPTIONS
C
      INTEGER IMAIN	      ! USER MAIN OPTION CHOSEN *OUTPUT*
      INTEGER ISUB	      ! USER SUBSIDIARY OPTION CHOSEN *OUTPUT*
C
      INTEGER NFCN	      ! NO. OF DEPENDENT COORDS (1 OR 2)
      INTEGER IFCN	      ! WHICH FCN TO PLOT *OUTPUT* (1 OR 2)
C
C------------------------------------------
C
      ILXL=ILNURD(XLAB)
      ILYL=ILNURD(YLAB)
      ILZL=ILNURD(ZLAB)
      ILZL2=ILNURD(ZLAB2)
      ILTIT=ILNURD(ZTITLE)
C
      IMAIN=4
      ISUB=0
C
      LUNTRM=LNOUT(0)
C
 10   CONTINUE
      CALL NEUPAG
C
 11   CONTINUE
      IF(LXOUT(0)) THEN
        WRITE(LUNTRM,1000) ZLAB(1:ILZL),ZLABEL,ZTITLE(1:ILTIT)
 1000   FORMAT(/
     >           '   FUNCTION:  ',A/
     >           '  SOURCE ID:  ',A/
     >           '      TITLE:  ',A/
     >)
        IF(NFCN.EQ.2)
     >      WRITE(LUNTRM,'('' FUNCTION 2:  '',A)') ZLAB2(1:ILZL2)
C
        IF(INDEX(CNTRL,'S').NE.0) WRITE(LUNTRM,1001)
        IF(INDEX(CNTRL,'U').NE.0) WRITE(LUNTRM,1002)
        if(index(cntrl,'X').ne.0) write(luntrm,1003)
C
 1001 FORMAT(' **> ENTER "S" TO SMOOTH PLOT DATA')
 1002 FORMAT(' **> ENTER "U" TO WRITE PLOT DATA TO UFILE')
 1003 format(' **> ENTER "X" FOR ERROR BAR PLOTTING OPTIONS')
C
        WRITE(LUNTRM,1008)
     >      XLAB(1:ILXL),YLAB(1:ILYL),XLAB(1:ILXL),YLAB(1:ILYL),
     >      YLAB(1:ILYL),XLAB(1:ILXL),XLAB(1:ILXL),YLAB(1:ILYL)
C
 1008 FORMAT(' GRAPHICS OPTIONS:'/
     >  '   (1) 3-D GRAPH OF FUNCTION VS. ',A,' AND ',A/
     >  '   (2) 2-D GRAPH VS. ',A,' AT FIXED ',A/
     >  '   (3) 2-D GRAPH VS. ',A,' AT FIXED ',A/
     >  '   (4)  (OR "Q")  QUIT GRAPHICS'/
     >  '   (5) CONTOUR PLOT; FOR "FAST" PLOT ENTER "5F"'/
     >  '   (6) CHANGE DEFAULT PLOT TYPE FOR 2D PLOTS'/
     >  '   (7) CHANGE SCALING DEFAULTS FOR 2D PLOTS'/
     >  '   (8) ',A,' OR ',A,' - SLICE MULTIPLOT'/
     >  ' >ENTER CHOICE NUMBER BETWEEN 1 AND 8<')
C
      ENDIF
C
      CALL UREAD(' GRF3SG:  ENTER OPTION #:$')
C
      ISTD=1
C  CHECK FOR SPECIAL OPTIONS
      IF(INDEX(CNTRL,'S').NE.0) THEN
C  SMOOTHING
        IF(LCHAR('S')) THEN
          IMAIN=-1
          ISTD=0
        ENDIF
      ENDIF
C
      if((istd.eq.1).and.(index(cntrl,'X').ne.0)) then
        if(lchar('X')) then
           if(NFCN.ne.2) then
      	call uermsg(
     >'?grf3op programming error, X option expects NFCN=2',' ',0)
      	goto 10
           else
      	istd=0
      	imain=-3
      	if(lxout(0)) write(luntrm,1005)
 1005 	format(/
     >' enter "0" to disable error bar plotting on f(x) plots'/
     >' enter "1" to designate fcn #1 as error bars for fcn #2'/
     >' enter "2" to designate fcn #2 as error bars for fcn #1')
      	call uread('grf3op:  enter error bar option 0 1 or 2:$')
      	if(lchar('Q')) goto 10
      	if(lchar('0')) then
      	   isub=0
      	else if(lchar('1')) then
      	   isub=1
      	else if(lchar('2')) then
      	   isub=2
      	else
      	   call uermsg('%grf3op:  invalid option code.',' ',0)
      	   goto 10
      	endif
           endif
        endif
      endif
C
      IF((ISTD.EQ.1).AND.(INDEX(CNTRL,'U').NE.0)) THEN
C  UFILES
        IF(LCHAR('U')) THEN
          IMAIN=-2
          ISTD=0
          CALL UREAD(
     >'GRF3OP:  ENTER "A" FOR ASCII OR "B" FOR BINARY UFILE OUTPUT:$$')
          IF(LCHAR('A')) THEN
            ISUB=1
          ELSE IF(LCHAR('B')) THEN
            ISUB=2
          ELSE IF(LCHAR('Q')) THEN
            GOTO 10
          ELSE
            CALL UERMSG('%GRF3OP-- ILLEGAL CHOICE',' ',1)
            GOTO 10
          ENDIF
        ENDIF
      ENDIF
C
      IF(ISTD.EQ.1) THEN
C  CHECK FOR STANDARD OPTIONS
        IF(LCHAR('Q')) THEN
          IMAIN=4
        ELSE
          IMAIN=IXUOPC('12345678$')
        ENDIF
      ENDIF
C
      IF(IMAIN.GE.0) CALL UCHKOP(IMAIN,0,1,100,-1,*11)
C
      IF(IMAIN.EQ.5) THEN
        IF(LCHAR('F')) ISUB=1
      ENDIF
C
      IFCN=1
      IF(NFCN.EQ.2) THEN
        IF((IMAIN.EQ.1).OR.(IMAIN.EQ.5).OR.(IMAIN.EQ.8)) THEN
 55       CONTINUE
          IF(LXOUT(0)) WRITE(LUNTRM,5505) ZLAB(1:ILZL),ZLAB2(1:ILZL2)
 5505 FORMAT(/'  >> CHOICE OF FUNCTIONS:'/
     >   '  (1)  ',A/
     >   '  (2)  ',A/)
          CALL UREAD(' SUB:GRF3X2 >> ENTER "1" OR "2"$')
          IF(LCHAR('Q')) GOTO 10
          IFCN=IXUOPC('12$')
          IF(IFCN.EQ.0) THEN
            CALL UCLEAR
            GO TO 55
          ENDIF
        ENDIF
      ENDIF
C
      RETURN
      END

	subroutine jc_day(weekday,day)	                           !12/07/84
	character*(*) weekday,day
	character*9 today,days(7),cdate
	data days /'Sunday','Monday','Tuesday',
     >		'Wednesday','Thursday','Friday','Saturday'/
c	call idate(im,id,iy)
c	write(today,'(i2.2,1h/,i2.2,1h/,i2.2)')im,id,iy
	call c9date(cdate)
	write(today,'(a9)') cdate
	day=today
	end
	subroutine jc_trnlog(ctabl,clogical,ctrans,nc,igood) 
	character ctabl*(*),clogical*(*),ctrans*(*)
	igood=usr_trnlog(ctabl,clogical,ctrans,nc,igood)  !   
	end
	subroutine jc_malloc(kbytes,jxx)
#ifdef __f90
	real, pointer :: jxx
#else
	real xx(*)
	pointer (jxx,xx)
#endif
	igood=lib_get_vm(kbytes,jxx)  !   
	if(jxx.eq.0) then  !   
	  call at_msg('**Cant get more memory')  !   
	  call good_exit  !   
	endif  !   
	end
	subroutine jc_mfree(kbytes,jxx)
#ifdef __f90
	real, pointer :: jxx
#else
	real xx(*)
	pointer (jxx,xx)
#endif
	if(kbytes.le.0) return
	call lib_free_vm(kbytes,jxx)  !   
	end

Module sigtabl_mod
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
!----------------------------------------------------------------------
!  SIGTAB -- COMMON FOR SIGTAB PROGRAM
!    INTEGRATION OF ATOMIC AND NUCLEAR REACTION CROSS SECTIONS FOR
!  OBTAINING REACTION RATES OF INTEREST
!
  SAVE
  integer :: KREACT,KK
  real(fp) :: AMASS1,AMASS2,AMASS3,AMASS4
!MG LREACT
  CHARACTER*8 LBLREACT
  CHARACTER*20 TTLREACT
  CHARACTER*6 FILREACT
!
! HEADER RECORD IMAGE COMMON -- 512 BYTES  !!
!
!    KEY-- HEADER KEY
!     OR ZERO IF THERE ARE NO MORE BLOCKS
!    XMIN,XMAX,NXPTS -- RANGE AND NO. OF PTS FOR 1ST INDEP. COORDINATE
!     KXTYP = 1 IF PTS ARE SPACED EVENLY LINEARLY
!     KXTYP = 2 IF PTS ARE SPACED EVENLY LOGARITHMICALLY
!
!    YMIN,YMAX,NYPTS,KYTYP -- DITTO FOR SECOND INDEP. COORDINATE
!
!
  integer :: KEY,NXPTS,KXTYP,NYPTS,KYTYP 
  real(fp) ::     XMIN,XMAX,YMIN,YMAX
  integer,parameter ::  NAMAX=32768
  real(fp),dimension(namax) :: ARRAY3
!----------------------------------------------------------------------
!  ** NEW DMC 30 NOV 1990 **
!  ALADDIN INTERFACE BLOCK
!
  integer, PARAMETER :: MAXALADR=24
  integer, PARAMETER :: MAXALCF=100
  real(fp) :: ALEOVA,ALSIGMA,ALPCF(MAXALCF,MAXALADR)
  integer :: NALPCF(MAXALADR)   ! FIT COEFFICIENTS
  logical :: ALADFLAG
  integer :: LUNALAD,NUMALAD
  real(fp) :: ALEMIN(MAXALADR),ALEMAX(MAXALADR),&  ! FIT ENERGY LIMITS
       ALAMIN(MAXALADR),ALAMAX(MAXALADR),&  ! SIGMA AT FIT LIMITS
       ALSMIN(MAXALADR),ALSMAX(MAXALADR)   ! D(LN(SIGMA))/D(LN(E))
!
  CHARACTER*96 ALADFILE
  CHARACTER*64 ALADRLBL(MAXALADR)
  CHARACTER*80 ALERRMSG
  real(fp) VCFAC
  integer IFUN
!
!FROM CSV
!  COMMON/CSV/VI,T,B2
!
!	COMMON PARAMETERS
!	VI - SPEED OF INJECTED PARTICLE (CM/SEC)
!	T=.5E00*TMASS/C**2
!	B2 - BMASS(2)/(2.E00*TEMP(2))
  real(fp) VI,T,B2
!
!FROM CSTH
!      COMMON /CSVTH/ A,B,CON,EPS,ITER,IW
!
!	E - THE INTEGRATION VARIABLE.
!	PARAMETER LIST FOR COMMON BLOCK CSVTH.
!	A - =RMASS/TMASS.  (SEE SVTH)
!	B - = A/TEMP.  (SEE SVTHE)
!       CON - =SQRT(8/PI)*C (m/sec)
!	CON1 - =CON*A**1.5/SQRT(TMASS).  (SEE SVTH)
!	EPS - THE DESIRED RELATIVE ERROR IN THE REACTIVITY
!	ITER - THE MAXIMUM NUMBER OF ITERATIONS TO BE TAKEN IN ORDER
!	IW - THE LOGICAL UNIT USED FOR PRINTING.
  real(fp) a,b,con,eps
  integer ITER,IW
end Module sigtabl_mod

module csigma_mod
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) :: A1,A2,A3,A4,A5,FE
  real(fp) :: BG,EFAC,ELOW,EMID,EHI,SLOPE
  real(fp):: ALOW(5),BLOW(4),AHI(6),BHI(5)
  logical :: LBOSCH,LFUN,LDPC
end module csigma_mod

 
real(fp) function sigv_zstop(ErelA,iZneut,iZimp)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : two,zcm2tom2 ,zkev2ev,mp_g
  implicit NONE
 
  real(fp) ErelA   ! E/A of collision interaction  *KEV*
  integer iZneut  ! Z of neutral atom (H/HE/LI)
  integer iZimp   ! Z of impurity (C/O)
 
  !  stopping cross section for neutral atom interaction with fully
  !  stripped light impurity ions
 
  !  ouput rate coefficient sigma*v, sigv_zstop, in M**3/sec
 
  real(fp) psglsa8   !  cross-section function
  real(fp) Vrel
 
  Vrel=0.01_fp*SQRT(two*1.6029e-12_fp*ErelA*zkev2ev/mp_g)
 
  sigv_zstop = Vrel * zcm2tom2 * psglsa8(zkev2ev*ErelA, iZneut, iZimp)
 
end function sigv_zstop

      subroutine ufmds_err(clbl,istat,ier,zerrmsg,ilm)
C
      use UFILES
C
      integer istat,ier,ilm
      character*(*) clbl,zerrmsg
C
C  get information on an MDS+ error
C
C  input:  clbl -- name of calling routine
C         istat -- MDS+ status code
C
C output:   ier -- error code:  0 if istat is a message, 1 if an error
C       zerrmsg -- the message string returned by the MDS+ server
C           ilm -- non-blank length of zerrmsg
C
C--------------------------------
C
      if((2*(istat/2)).eq.istat) then
         ier=1
         write(ufelun,9001) clbl
 9001    format(' %',a,' MDS+ error:')
      else
         ier=0
         write(ufelun,9002) clbl
 9002    format(' %',a,' MDS+ message:')
      endif
      itmp=mds_errstr(istat,zerrmsg)
      ilm=max(1,len_trim(zerrmsg))
C
      return
      end
 

      subroutine add_pretr(lun, mds_shot, runid, opt, stat)
C
C Add extra nodes to TRANSP Tree
C 12/11/02: C.Ludescher
C
      implicit none
C Input
      integer         lun           ! for error messages
      integer         mds_shot      ! Pulse number
      character*(*)   runid         ! runid
      integer         opt           ! 1 = TF_PLN
C Return
      integer         stat
C Functions
      integer ilnurd   ! VAXONLY
      integer         mds_add_node,  MdsValue,   idescr_long
C Local
      integer         nid,           size,        l
      integer         dsc,           mdsstat,     ier,   ios
      character*100   expr
      character*10    cshot
      character*64    zdate
      integer         MdsPut,       idescr_cstring, idescr_float
      real            time
C-------------------------------------------------------------------------
C
C add TF.PLN to node :CONTENTS
      if (opt .eq. 1) then
C Create node, if it does not exist
         nid = mds_add_node('CONTENTS','text',mdsstat)
         print*,'nid =',nid
         if (nid .le. 0) then
            call mdsmsg(lun,
     >      '?add_pretr: creating CONTENTS - stat:',mdsstat)
            go to 9100
         else
            call add_file(lun,runid,'CONTENTS',
     >           ' ',' ',0,' ',stat)
            stat=1
         endif
C add dates to :DATE_RUN and :DATE_EXEFILE
      else if (opt .eq. 2) then
C Create node, if it does not exist
         nid = mds_add_node('DATE_RUN','text',mdsstat)
         if (nid .le. 0) then
            call mdsmsg(lun,
     >      '?add_pretr: creating DATE_RUN - stat:',mdsstat)
            go to 9100
         else
            open (12,file=runid//'.DATE_RUN',iostat=ios,
     >            status='old')
            if (ios .ne. 0) then
               print*,'?error opening '//runid//'.DATE_RUN' 
               zdate = 'unknown'
            else
               read (12,'(a)')zdate
               close(12)
            endif
            stat=MdsPut('DATE_RUN'//CHAR(0),'$'//CHAR(0),
     >           idescr_cstring(zdate),0,size)
            if (mod(stat,2).ne.1) then
               call mdsmsg(lun,
     >              '?add_pretr: put DATE_RUN - stat:  ',stat)
               goto 9100
            end if
            open (12,file=runid//'.DATE_EXEFILE',iostat=ios,
     >            status='old')
            if (ios .ne. 0) then
               print*,'?error opening '//runid//'.DATE_EXEFILE' 
               zdate='unknown'
            else
               read (12,'(a)')zdate
               close(12)
            endif
            stat=MdsPut('DATE_EXEFILE'//CHAR(0),'$'//CHAR(0),
     >           idescr_cstring(zdate),0,size)
            if (mod(stat,2).ne.1) then
               call mdsmsg(lun,
     >              '?add_pretr: put DATE_EXEFILE - stat:  ',stat)
               goto 9100
            end if
            stat=1
         endif
      else if (opt .eq. 4 .or. opt .eq. 24 ) then
C Create node, if it does not exist
         nid = mds_add_node('MRK_TIME','numeric',mdsstat)
         if (nid .le. 0) then
            call mdsmsg(lun,
     >      '?add_pretr: creating MRK_TIME - stat:',mdsstat)
            go to 9100
         else
            open (12,file=runid//'.MRK_TIME',iostat=ios,
     >            status='old')
            if (ios .ne. 0) then
               print*,'?error opening '//runid//'.MRK_TIME' 
               goto 9100
            else
               read (12,'(G20.0)')time
               close(12)
            endif
            stat=MdsPut('MRK_TIME'//CHAR(0),'$'//CHAR(0),
     >           idescr_float(time),0,size)
            if (mod(stat,2).ne.1) then
               call mdsmsg(lun,
     >              '?add_pretr: put MRK_TIME - stat:  ',stat)
               goto 9100
            end if
         endif
         nid = mds_add_node('SRC_TIME','numeric',mdsstat)
         if (nid .le. 0) then
            call mdsmsg(lun,
     >      '?add_pretr: creating SRC_TIME - stat:',mdsstat)
            go to 9100
         else
            open (12,file=runid//'.SRC_TIME',iostat=ios,
     >            status='old')
            if (ios .ne. 0) then
               print*,'?error opening '//runid//'.SRC_TIME' 
               goto 9100
            else
               read (12,'(G20.0)')time
               close(12)
            endif
            stat=MdsPut('SRC_TIME'//CHAR(0),'$'//CHAR(0),
     >           idescr_float(time),0,size)
            if (mod(stat,2).ne.1) then
               call mdsmsg(lun,
     >              '?add_pretr: put SRC_TIME - stat:  ',stat)
               goto 9100
            end if
         endif
         if ( opt .eq. 24) then
C Add nubeam Namelist
C Create node, if it does not exist
            nid = mds_add_node('NB_NAMELIST','text',mdsstat)
            print*,'nid =',nid
            if (nid .le. 0) then
               call mdsmsg(lun,
     >              '?add_pretr: creating NB_NAMELIST - stat:',mdsstat)
               go to 9100
            else
               call add_file(lun,runid,'NB_NAMELIST',
     >              ' ',' ',0,' ',stat)
               stat=1
            endif
         endif
      endif
 
C Write/Close Tree
 
      expr = 'tcl("WRITE")' // CHAR(0)
      l=ilnurd(expr)
      dsc = idescr_long(mdsstat)
      print*,expr(1:l)
      stat = MdsValue(expr, dsc, 0, size)
      print*,'stat =',stat
      if(mod(mdsstat,2).ne.1) go to 9000
      expr = 'tcl("CLOSE")' // CHAR(0)
      l=ilnurd(expr)
      dsc = idescr_long(mdsstat)
      stat = MdsValue(expr, dsc, 0, size)
      if(mod(mdsstat,2).ne.1) go to 9000
      return
C
 9000 call mdsmsg(lun,'?add_pretr: '//expr(1:l)//
     >   ' mdsstat:  ',mdsstat)
 9100 stat = 0
      return
      end

      subroutine add_ufnodes(lunerr,runid,tr_socket,
     >           tr_tree,tr_pulse,device,ierr)
C
C Tree must be open for edit
C
C trtmp_rd
C Read output from trdat = <runid>TRDAT.TMP (which must have been
C previously run ) to get list of TRANSP input files and also location
C of input files.
C
C
C trtmp_add
C read ufiles and write to MDSplus
C
      implicit none
 
      integer       lunerr
      character*(*) runid
      integer       tr_socket         ! socket of TRANSP-run tree
      character*(*) tr_tree           ! name of TRANSP-run tree
      integer       tr_pulse          ! TRANSP-run pulse number
      character*(*) device            ! tokamak
      integer       ierr
C
      integer maxfiles
      parameter (maxfiles=50)
 
      character*150  uflist(maxfiles)    ! full encodes ufiles path
      character*150  ufalt(maxfiles)     ! full encodes ufiles path
      character*5    lbls(maxfiles)      ! uf_Lable = tr_node
      character*20   trlbls(maxfiles)    ! tr Label
      integer        nfiles
      character*20   trpath              ! tr Path
      real           toff
 
      integer        i

C * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 
      call trtmp_rd(runid,maxfiles,uflist,ufalt,lbls,
     .     nfiles,trlbls,trpath,toff,device,ierr)
      if (ierr .ne. 0) return
 
      print *,'add_ufnodes: ',nfiles,' files'
      call trtmp_add(lunerr,runid,tr_socket,tr_tree, tr_pulse,
     >               device,maxfiles,uflist,ufalt,lbls,
     >               nfiles,trlbls,trpath,toff,ierr)
      end
 
C----------------------------------------------------------/read_trtmp
 
      subroutine trtmp_rd(runid,
     .     maxfiles,
     .     uflist,     ! full encodes ufiles path
     .     ufalt,      ! full encodes ufiles path (fallback)
     .     lbls,       ! uf_Lable = tr_node
     .     nfiles,
     .     trlbls,     ! tr Label
     .     trpath,     ! tr Path
     .     toff,
     .     device,     ! tokamak
     .     ierr)
 
      implicit none
      integer maxfiles
      character*150 uflist(maxfiles), ufalt(maxfiles)
      character*5   lbls(maxfiles)
      character*20  trlbls(maxfiles), trpath
      character*(*) runid
      character*(*) device
      integer       nfiles
      real          toff
      integer       ierr
 
                                     ! local
      character*80  dummystr         ! for skipping lines
      character*5   lbl              ! uf_Lable = tr_node
      character*20  trlbl            ! tr Label
      character*50  prefix           ! uf prefix / uf Server
      character*50  altpre           ! uf prefix for fallback
      character*50  extension, path  ! uf suffix / uf Tree
      character*120 dirname          ! uf directory / uf node
      character*6   ashotused        ! uf shot number
      character*10  pulse            ! uf mds pulse number
      character*12  node             ! uf mds node name
      character*60  fname            ! uf name
 
      integer       i, ios, status
      logical       gotlbl, ex, delete
 
      character*120 trtmpfile
      character*150 zpath
      integer       ldir,   ldisk, istart, lf, lp
      logical       ismds
C--------------------------------------------------------------------------
C assume <runid>TRDAT.TMP file is in local directory
      ismds=.false.
      delete=.true.
      trtmpfile = runid // 'TRDAT.TMP'
      inquire(file=trtmpfile,exist=ex,iostat=ierr)
      if (.not. ex) then
         ierr = 1
         print *, '? add_ufnodes: can not find ',trtmpfile
         return
      else
         delete=.false.
      end if
 
      open (unit=29,file=trtmpfile,status='old',iostat=ierr)
      if (ierr .ne. 0) then
         print *, '? add_ufnodes: can not find ',trtmpfile
         return
      end if
	! read known format *TR.TMP file
 776  format(a8,A)
 777  format(8X,F14.6)
 778  format(a8,A20)
 779  format(8X,A)
 
      read (29,'(A)', END=999, iostat=ierr) dummystr ! runid and file label
                                                     ! or Inputdir, if MDSplus
      if (dummystr(1:10) .eq. ' Inputdir:') then
         dirname = dummystr(11:)
         ldir = index(dirname,' ')-1
         if (ldir .gt. 1) then
            if (dirname(ldir:ldir) .ne. '/') then
               ldir=ldir+1
               dirname(ldir:ldir)='/'
            endif
         endif            
         read (29,779, END=999) ashotused
         if (ashotused(1:1).eq.' ') ashotused =
     .        ashotused(2:len_trim(ashotused))
         read (29,'(A)', END=999, iostat=ierr) dummystr ! runid and file label
      endif
      if (dummystr(1:8) .ne. ' TrPath:') then
         trpath = '.INPUTS:'      ! default for TRANSP run Tree
      else
         trpath = dummystr(9:)   ! if Ufile copy
      endif
      read (29,777, END=999, iostat=ierr) toff
      print *, 'read_trtmp: toff: ',trtmpfile,toff
      i = 0
      lbl=' '
      gotlbl = .true.
      do while (.TRUE.)         ! exit via EOF on file
         if (gotlbl) read (29,'(A)', END=999) dummystr ! dashes
         read (29,779, END=999,iostat=ios) lbl
         read (29,776, END=999) dummystr,prefix ! max 10 char, I think
         call uupper(prefix)
         if (dummystr(1:8) .eq. ' Server:') then
            ismds = .true.
            read (29,779, END=999) altpre
            call uupper(altpre)
         endif
         read (29,779, END=999) extension ! normally 3 char
         call uupper(extension)
         if (ismds) then
            read (29,779, END=999) path
            read (29,779, END=999) node
            read (29,779, END=999) pulse
         else
            read (29,779, END=999) dirname
            read (29,779, END=999) ashotused
         endif
         read (29,778, END=999) dummystr,trlbl ! 20 char
         print *,dummystr(1:8),trlbl
         if (dummystr(2:6) .ne. 'TrLbl') then ! is TRDAT label missing ?
            gotlbl = .false.
            trlbl = ' '
            print *,'no TRDAT label'
         else
            gotlbl = .true.
         endif
         if (i.lt.maxfiles) then
            i = i + 1
         else
            ierr = 1
            print *, 'read_trtmp: more than maxfiles files', i
            return
         endif
! copy into corresponding arrays
 
         lbls(i) = lbl
         trlbls(i) = trlbl
 
C MDSplus
         if (ismds) then
             if (pulse .ne. ' ' .and.
     >       pulse .ne. '         0' .and.
     >       path(1:5) .ne. 'PPPL@') then
                 uflist(i) = 'MDS+::' //
     .           prefix(1:len_trim(prefix)) // '/' //       ! Server
     .           extension(1:len_trim(extension)) //        ! Tree
     .            '(' // pulse // ')/' //                  ! encode shot
     .           path(1:len_trim(path)) // '/' //
     .           node(1:len_trim(node))
             else
                 uflist(i) = 'MDS+::' //
     .           prefix(1:len_trim(prefix)) // '/' //       ! Server
     .           extension(1:len_trim(extension)) // '/' // ! Tree
     .           path(1:len_trim(path)) // '/' //
     .           node(1:len_trim(node))
             endif
C Generate "alternate" list for fallback
             if (ldir .gt. 1) then
                ufalt(i) = dirname(1:ldir)
                istart = ldir+1
             else
                istart=1
             endif
             fname = altpre(1:len_trim(altpre)) //
     .            ashotused(1:len_trim(ashotused)) //
     .            '.' //node(1:len_trim(node))
             lf = len_trim(fname)
             ufalt(i)(istart:) = fname(1:lf)
         else
C parse filename
             ldir = index(dirname,' ')-1
             ldisk = 0
             if (ldir .gt. 1) then
                 if (dirname(ldir:ldir) .ne. '/') then
                     ldir=ldir+1
                     dirname(ldir:ldir)='/'
                 endif
                 uflist(i) = dirname(1:ldir)
                 istart = ldir+1
             else
                 istart=1
             endif
             if (ashotused(1:1).eq.' ') ashotused =
     .       ashotused(2:len_trim(ashotused))
             if (ashotused(1:5).ne.'None.') then
                fname = prefix(1:len_trim(prefix)) //
     .           ashotused(1:len_trim(ashotused)) //
     .           '.' //extension(1:len_trim(extension))
             else
                 fname = prefix(1:len_trim(prefix)) //
     .           '.' // extension(1:len_trim(extension))
             endif
             lf = len_trim(fname)
             uflist(i)(istart:) = fname(1:lf)
             lp = len_trim(uflist(i))
C check if path is okay or need fix directory
             zpath=uflist(i)
             call ck_ufpath(uflist(i),device,
     >       dirname(1:ldir),fname(1:lf),ierr)
             if (ierr .ne. 0) then
                print *, '? add_ufnodes:  ' //
     >               uflist(i)(1:lp) //' does not exist'
                if (extension(1:len_trim(extension)) .eq. 'RPL') then
                   fname = prefix(1:len_trim(prefix)) //
     .                  '.' // extension(1:len_trim(extension))
                   lf = len_trim(fname)
                   uflist(i)=zpath
                   uflist(istart:) = fname(1:lf)
                   lp = len_trim(uflist(i))
                   call ck_ufpath(uflist(i),device,
     >                  dirname(1:ldir),fname(1:lf),ierr)
                   if (ierr .ne. 0) then
                      print *, '? add_ufnodes:  ' //
     >                     uflist(i)(1:lp) //' does not exist'
                   endif
                endif
             endif
C 06/05/08 CLF: Return error if file is missing
             if (ierr .ne. 0) then
                close (unit=29)
                return
             endif
         endif
C on EOF last line read will really be "Ierr:  <code>", with code in
C                                       prefix variable
 
      enddo
 999  continue  ! jump here on end-of-file
      if(delete) then
C         close (unit=29,='delete')
         close (unit=29)
      else
         close (unit=29)
      endif
      nfiles = i
      ierr = 0
      return
      end
 
 
C---------------------------------------------------------------------------
      subroutine trtmp_add(lun,runid,tr_socket,tr_tree, tr_pulse,
     <                     device,maxfiles,uflist,ufalt,nodes,
     >                     nfiles,trlbls,trpath,toff,ierr)
 
      implicit none
 
C Input
      integer       lun                ! lun for error messages
      character*(*) runid              ! TRANSP runid
      integer       tr_socket          ! TRANSP-run mds_socket
      character*(*) tr_tree            ! TRANSP-run Tree name
      integer       tr_pulse           ! TRANSP-run pulse number
      character*(*) device             ! Tokamak
      integer       maxfiles
      character*150 uflist(maxfiles)   ! ufiles name/path
      character*150 ufalt(maxfiles)    ! ufiles name/path (fallback)
      character*5   nodes(maxfiles)    ! node name in Tree
      character*20  trlbls(maxfiles)   ! Label in Tree
      character*20  trpath             ! path in Tree
      integer       nfiles
      real          toff
      integer       ierr
C Local
      integer       i, sts, opt
      integer       ilp, ln, lf, la
      character*150 ufsource
C mdsplus
      integer       idescr_long
      integer       dsc,       mdsstat
 
! * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
      print *,nfiles,' files'
      ilp = len_trim(trpath)
      if (ilp .gt. 1) then
         if (trpath(ilp:ilp) .ne. ':') then
            ilp=ilp+1
            trpath(ilp:ilp) = ':'
         endif
      endif
      opt = 1
      do i=1,nfiles
         ln = len_trim(nodes(i))
         lf = len_trim(uflist(i))
C Read ufiles and write to MDSplus
         call mds_rdwr(lun,tr_socket,tr_tree,tr_pulse,
     >        trpath(1:ilp)//nodes(i)(1:ln),
     >        uflist(i)(1:lf),device,opt,ierr)
C If MDS failed, try local disk
         if (ierr .eq. -77) then
            write(lun,*) '...will try local disk'
            la = len_trim(ufalt(i))
            call mds_rdwr(lun,tr_socket,tr_tree,tr_pulse,
     >           trpath(1:ilp)//nodes(i)(1:ln),
     >           ufalt(i)(1:la),device,opt,ierr)
            ufsource=ufalt(i)(1:la)
            lf=la
         else
            ufsource=uflist(i)(1:lf)
         endif
C Write T_OFFSET and COMMENT
         if (ierr .eq. 0 .or. ierr .eq. 4) then
            call mds_whdr(lun,trpath(1:ilp),nodes(i)(1:ln),
     >           trlbls(i)(1:20),ufsource(1:lf),toff,ierr)
         endif
         opt = 0
 
      enddo
      return
      end
 

subroutine frantic_input_save(filename,ierr)

  !  save the state of a frantic calcution -- i.e. just before
  !  executing the calculation

  !  saved netcdf file can be used to reproduce the calculation in
  !  the standalone code `frantic_test.f90'.

  use ezcdf
  implicit none

  character(len=*), intent(in) :: filename ! NetCDF filename
  integer, intent(out) :: ierr             ! completion code, 0=OK

  !-----------------------------------------------

  integer :: ncid

  !-----------------------------------------------
  !  create file & write frantic module contents

  call frantic_module_write(filename,ierr)
  if(ierr.ne.0) then
    ierr=1
    return
  end if

  return
end subroutine frantic_input_save

C******************** START FILE CONCTS.FOR ; GROUP CONCTR *************
C============================================================
C  CONCTS    D. MC CUNE MAY 21 1980 -- NON-INTERACTIVE MAIN
C
C  CONTROL GENERATION OF CONTOUR PLOT OF 2D GRID
C  FUNCTION
C
C  PROGRAM CONTROLS GENERATION OF A QUICK DEFAULT CONTOUR PLOT
C  AND EXITS -- NO USER I/O
C
C  ARGUMENTS:
C    X(NX)    INDEP. VAR ALONG 1ST DIMENSION OF FUNCTION
C    Z(NZ1,NY)  2D FUNCTION TO BE PLOTTED
C    Y(NY)    INDEP VAR. ALONG 2ND DIMENSION OF FUNCTION
C    XLAB     10 CHAR LABEL FOR X
C    ZLAB(2)  20 CHAR LABEL FOR Z
C    YLAB     10 CHAR LABEL FOR Y
C    XUN      10 CHAR. PHYS. UNITS FOR X TERMINATED WITH "$"
C    ZUN      DITTO FOR Z
C    YUN      DITTO FOR Y
C    RLAB     10 CHAR. RUN LABEL , E.G. "RUN # 1234"
C             (SHOULDNT BE TERMINATED WITH "$")
C    IINT     FCN INTEGRATION CODE:
C             0 -- NOT INTEGRATED
C             1 -- VOL. INTEGRATED
C             2 -- FLUX. INTEGRATED
C             3 -- AREA INTEGRATED
C    ISMOO    IF ISMOO=1, DATA HAS BEEN SMOOTHED
C                (FOR LABELING)
C    NPAGE  INCREMENTS BY ONE TO YIELD PAGE # OF GRAPH TO BE
C           DRAWN; PAGE # IS ADDL LABEL ON GRAPH
C
      SUBROUTINE CONCTS(X,Z,Y,NX,NZ1,NY,XLAB,ZLAB,YLAB,
     >                    XUN,ZUN,YUN,RLAB,IINT,ISMOO,NPAGE,
     >                    ITYPX,ITYPY,ILOGC)
C
C  ITYPX-- =1 FOR LINEAR X AXIS, 2 FOR LOG X AXIS
C  ITYPY-- =1 FOR LINEAR Y AXIS, 2 FOR LOG Y AXIS
C  ILOGC-- =1 FOR LINEAR CONTOUR SPACING, 2 FOR LOG CONTOURS
C  DECLARATIONS
C   PARAMETER:  MAX # OF CONTOURS
C    LIMITED BY CONTOUR LABELING, SPACE IN KEY
      PARAMETER (NCMAX0=18)
C
C  PASSED ARGS
C
      DIMENSION X(NX),Z(NZ1,NY),Y(NY)
      CHARACTER*(*) XLAB,ZLAB,YLAB,RLAB,XUN,YUN,ZUN
C
C   LOCAL
C
C  ARRAY OF CONTOUR VALUES
      DIMENSION ZCNTR1(NCMAX0)
C  CONTOUR ID CHARACTERS
      CHARACTER*1 ACNTR1(NCMAX0)
C
      DATA ACNTR1/'A','B','C','D','E','F','G','H','J','K',
     >              'L','M','N','P','Q','R','S','T'/
C
      CHARACTER*10 FLAB,CLAB
      DATA FLAB/'FUNCTION  '/
      DATA CLAB/'CONTOUR   '/
C  INITIAL DEFAULT FLAG VALUES--
C   SET MIN,MAX CONTOUR LIMITS TO FUNCTION MIN,MAX
C
      LOGICAL NLZMMX,ILZMMX
      DATA NLZMMX/.TRUE./
C   SET  DOMAIN TO ENTIRE DOMAIN OF FUNCTION
      LOGICAL NLXMMX
      DATA NLXMMX/.TRUE./
      LOGICAL NLYMMX
      DATA NLYMMX/.TRUE./
C   SET EQUAL SPACING OF CONTOURS
      LOGICAL NLLOGC
C
      LOGICAL LXOUT
C
C  SET MAX # OF CONTOURS INITIALLY TO PROGRAM LIIMIT
      DATA NCMAX/NCMAX0/
C
C  START OF EXECUTABLE CODE-- PRESENT USER OPTIONS
C
      LUNTRM=LNOUT(0)
      if(luntrm.eq.0) LUNTRM=6
C
C  CHECK FOR MIN. NX, NY
      IF((NX.GT.1).AND.(NY.GT.1)) GO TO 10
        WRITE(LUNTRM,9009) NX,NY
 9009   FORMAT('  NX=',I3,'  NY=',I3/
     >	  '  TOO FEW X OR Y PTS FOR CONTOUR PLOTTING ***')
        CALL UPAUST(1)
        RETURN
 10   CONTINUE
C
C  MAKE PLOT
C
 100  CONTINUE
C  SET DEFAULTS
C  SET CURRENT MAX # OF CONTOURS
      NCTRY=NCMAX
C  SET DOMAIN LIMITS
      IF(NLXMMX) GO TO 140
        XMIN=0.0 !XMIN0
        XMAX=0.0 !XMAX0
        GO TO 150
C  TO MIN,MAX OF X
 140  CONTINUE
        XMIN=X(1)
        XMAX=X(NX)
        CALL SPREDM(XMIN,XMAX,XMIN,XMAX)
 150  CONTINUE
C
      IF(NLYMMX) GO TO 160
        YMIN=0.0 !YMIN0
        YMAX=0.0 !YMAX0
        GO TO 170
C
 160  CONTINUE
        YMIN=Y(1)
        YMAX=Y(NY)
        CALL SPREDM(YMIN,YMAX,YMIN,YMAX)
 170  CONTINUE
C  CONTOUR LIMITS
      IF(NLZMMX) GO TO 110
        CMIN=0.0 !CMIN0
        CMAX=0.0 !CMAX0
        GO TO 130
 110  CONTINUE
C  SET TO MIN,MAX OF FCN
        IFND=0
        DO 120 IY=1,NY
          IF((Y(IY).LT.YMIN).OR.(Y(IY).GT.YMAX)) GO TO 120
          DO 119 IX=1,NX
            IF((X(IX).LT.XMIN).OR.(X(IX).GT.XMAX)) GO TO 119
            IFND=IFND+1
            IF(IFND.EQ.1) CMIN=Z(IX,IY)
            IF(IFND.EQ.1) CMAX=Z(IX,IY)
            CMIN=AMIN1(CMIN,Z(IX,IY))
            CMAX=AMAX1(CMAX,Z(IX,IY))
 119      CONTINUE
 120    CONTINUE
        CALL SPREDM(CMIN,CMAX,CMIN,CMAX)
C
 130  CONTINUE
C
C
C  DRAW CONTOURS
C
 180  CONTINUE
      CALL CONPLT(X,Z,Y,NX,NZ1,NY,XLAB,ZLAB,YLAB,
     >       XUN,ZUN,YUN,RLAB,IINT,ISMOO,ITYPX,ITYPY,
     >       XMIN,XMAX,CMIN,CMAX,YMIN,YMAX,NCTRY,ILOGC,NLZMMX,
     >       ZCNTR1,ACNTR1,NPAGE)
C
      RETURN
      END
C******************** END FILE CONCTS.FOR ; GROUP CONCTR ***************

C ucdfcom - Read/Write CDF - Ufile Comment
C
      subroutine ucdfcom(lun,zbuf,ilen,rw,loop,retn)
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Input:
      integer      lun      !
      integer      rw       ! 0: read
C                           ! 1: write
      integer      loop     ! 1: Start
C                           ! >1: Loop
C                           !
      integer      ilen     ! length of comment if Write
C Return:
      integer      retn
C     integer      ilen     ! length of comment if Read
      character*(*) zbuf    ! buffer with comments
C
C Definitions for processing
      integer ichan, file_id
      integer dim_id, com_id, dim_l
      integer start,  icnt
C
      character*1     cnt  ! Length of comment passed to netCDF
C
C---------------------------------------------------------------------------
C
C get file name
         call uflchk(lun,'ucdfcom',ichan,retn)
         if (retn .ne. 0) return
         file_id = ufid(ichan)
C
C Read
C------
      if (rw .eq. 0) then       ! Read
C
         if (loop .eq. 1) then
 
            retn = nf_inq_unlimdim(file_id, dim_id)
            if (retn .ne. 0) then
               write(ufelun,*) 'no comment'
               return
            end if
            retn = nf_inq_dimlen(file_id, dim_id, dim_l)
            if (retn .ne. 0) then
               write(ufelun,9007)  NF_STRERROR(retn)
 9007          format(' ? UCDFCOM: - error getting comment length'/a)
               return
            end if
            retn = nf_inq_varid(file_id, 'COMMENT', com_id)
            if (retn .ne. 0) then
               write(ufelun,9005)  NF_STRERROR(retn)
 9005          format(' ? UCDFCOM: - error getting comment id'/a)
               return
            end if
            start = 1
         end if
C
         if (start .gt. dim_l) then    ! end of comment
            ilen = 0
            return
         end if
C Read Record length
         retn = nf_get_vara_text(file_id, com_id, start, 1, cnt)
         if (retn .ne. 0) then
            ilen = 0
            write(ufelun,9009)  loop, NF_STRERROR(retn)
 9009       format(' ? UCDFCOM: - error reading comment length',i4/a)
            return
         end if
C Read Record
         start = start + 1
         icnt=ichar(cnt)
         retn = nf_get_vara_text(file_id, com_id, start, icnt, zbuf)
         if (retn .ne. 0) then
            ilen = 0
            write(ufelun,9006)  loop, NF_STRERROR(retn)
 9006       format(' ? UCDFCOM: - error reading comment',i4/a)
            return
         end if
         ilen = icnt
         start = start + ilen
      else
C Write Comment
C==============
C
C Enter Define Mode
C------------------
         if (loop .eq. 1) then
            retn = nf_redef(file_id)
            if (retn .ne. 0) then
               write(ufelun,9000)  NF_STRERROR(retn)
 9000          format(' ? UCDFCOM: - nf_redef '/a)
               return
            end if
            retn = nf_def_dim(file_id,'text',NF_UNLIMITED, dim_id)
            if (retn .ne. 0) then
               write(ufelun,9001)  NF_STRERROR(retn)
 9001          format(
     >            ' ? UCDFCOM: - error defining unlimited dimension',
     >            /a)
               return
            end if
            retn = nf_def_var(file_id, 'COMMENT', NF_CHAR, 1, dim_id,
     >                        com_id)
            if (retn .ne. 0) then
               write(ufelun,9002)  NF_STRERROR(retn)
 9002          format(' ? UCDFCOM: - error defining comment'/a)
               go to 9100
            end if
 
            retn = nf_enddef(file_id)
            if (retn .ne. 0) then
               write(ufelun,9003)  NF_STRERROR(retn)
 9003          format(' ? UCDFCOM: - nf_enddef'/a)
               go to 9100
            end if
            start = 1
         end if
C
C Write comment to file
C-----------------------
C Write record length
         cnt = char(ilen)
         retn = nf_put_vara_text(file_id, com_id, start, 1,
     >                        cnt)
         if (retn .ne. 0) then
            write(ufelun,9008)  loop, NF_STRERROR(retn)
 9008       format(' ? UCDFCOM: - error writing comment count',i4/a)
            go to 9100
         end if
C Write record
         start = start + 1
         retn = nf_put_vara_text(file_id, com_id, start, ilen,
     >                        zbuf)
         if (retn .ne. 0) then
            write(ufelun,9004)  loop, NF_STRERROR(retn)
 9004       format(' ? UCDFCOM: - error writing comment',i4/a)
            go to 9100
         end if
         start = start + ilen
      end if
 
      return
 
 9100 continue
      return
      end
 
 
 
 
 
 

!------------------------------------------------------------------------------
!
SUBROUTINE RMASS_Z(NREACT,KK,AM1,AM2,AM3,AM4)
!
!...5/10/76
!...This subroutine was written by Harry H. Towner of the Princeton
!...Plasma Physics lab.  This routine will return the masses for
!...a given reaction.  The reaction is assumed to be in the form of:
!		AM1(AM2,AM3)AM4
!...PARAMETERS:
!...NREACT - Specifies the reaction.
!		1)	T(D,N)HE4	2)   HE3(D,P)HE4
!		3)	D(D,P)T		4)   D(D,N)HE3
!		5)	T(T,2N)HE4 	6)   T(HE3,X)Y
!		12)	T(T,2N)HE4 (same as 5) !DPC fit 06/2018
!...KK - If KK=1 then the above reaction is reversed.
!...AM1-4 - The mass for the given reaction.  (keV/C**2)
!...Note that indeterminate masses are given a value of -1.e00.
!...All masses have the units of kev/c**2.
!
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER kk,nreact,nreact_use
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) :: am1,am2,am3,am4
  real(fp), dimension(6) :: a1,a2,a3,a4
!============
  DATA A1/2.80888259e+6_fp,2.808352957e+6_fp,2*1.875587331e+6_fp,&
       2*2.80888259e+6_fp/
  DATA A2/4*1.875587331e+6_fp,2.80888259e+6_fp,2.808352957e+6_fp/
  DATA A3/9.395526709e+5_fp,2*9.382592233e+5_fp,9.395526709e+5_fp,2*-1.0_fp/
  DATA A4/2*3.727327439e+6_fp,2.80888259e+6_fp,2.808352957e+6_fp,&
       3.727327439e+6_fp,-1.0_fp/
!
!******************************************************************************
!
  NREACT_USE=NREACT
  if(NREACT.eq.12) then
     NREACT_USE=5
  endif
  IF (KK .EQ. 0) THEN
     AM1=A1(NREACT_USE)
     AM2=A2(NREACT_USE)
  ELSE IF (KK .EQ. 1) THEN
     AM1=A2(NREACT_USE)
     AM2=A1(NREACT_USE)
  ELSE
     WRITE(6,10)
10   FORMAT(T2,I2,' is an illegal value for KK!')
     call bad_exit
  END IF
!
  AM3=A3(NREACT_USE)
  AM4=A4(NREACT_USE)
  RETURN
END SUBROUTINE RMASS_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C******************** START FILE UCSEND.FOR ; GROUP UFILES ******************
C-----------------------------------------
C  UCSEND
C    SEND COMMENTS FROM TEMPORARY TO PERMANENT FILE
C
      SUBROUTINE UCSEND(ILUNT,ILUNF)
C
C  ILUNT-- UFILES TEMPORARY FILE
C  ILUNF-- UFILES PERMANENT FILE
C
      USE UFILES
C
      CALL UFINIT
      CALL UFLCHK(ILUNF,'UCSEND    ',ICHANF,IER)
      IF(IER.NE.0) RETURN
C
      ICHANT=IUXCHA(ILUNT)
      IF(ICHANT.EQ.0) THEN
        IER=1
      ELSE IF(UFSTAT(ICHANT).NE.4) THEN
        IER=1
      ENDIF
C
      IF(IER.NE.0) THEN
        WRITE(UFELUN,9901) ILUNT
 9901 FORMAT(' ? UCSEND - TEMPORARY COMMENTS FILE LUN INCORRECT:',
     >    I6)
        CALL UFPAUS(1)
        RETURN
      ENDIF
C
      REWIND ILUNT
      CALL USPOOL(ILUNT,ILUNF)
C
      RETURN
      END
C******************** END FILE UCSEND.FOR ; GROUP UFILES ******************

C-------------------------------------------------------------------
C  GRF3F1  CONTROL ROUTINE, VARIOUS PLOTS OF F(X,T)
C
C  BASED ON OLD GRF3, WITH STREAMLINED INTERFACE, CHARACTER*(*)
C  LABEL PASSING MECHANISM, AND GRF3OP MENU SUBROUTINE
C
      SUBROUTINE GRF3F1(X,Z,Y,WK,NX,NY,NZ1,
     >                    XLAB,ZLAB,YLAB,
     >                    XUN,ZUN,YUN,
     >                    ZTITLE,ZLABEL,IPROC)
      implicit none
C
      LOGICAL, EXTERNAL :: LCHAR,LXOUT,LYES,LYESC
C
      integer npagec
      COMMON/GRF3PG/ NPAGEC
C
      integer NX,NY,NZ1
      REAL X(NX)	! 1ST INDEP. COORD OF FCN TO BE PLOTTED
      REAL Z(NZ1,NY)	! FCN TO BE PLOTTED
      REAL Y(NY)	! 2ND INDEP. COORD OF FCN TO BE PLOTTED
      REAL WK(NY)	! ** WORKSPACE ** MUST BE PROVIDED
C
C  X AND Y MUST BE IN ASCENDING ORDER.
C  CAREFULLY NOTE DIMENSIONING OF Z
C
C  WK WILL BE OVERWRITTEN ON CALL TO THIS ROUTINE
C
C  RECOMMENDED NOT LONGER THAN CA. 30 CHARACTERS...
      CHARACTER*(*) XLAB  ! LABEL FOR 1ST INDEP. COORDINATE
      CHARACTER*(*) ZLAB  ! LABEL FOR FCN BEING PLOTTED
      CHARACTER*(*) YLAB  ! LABEL FOR 2ND INDEP. COORDINATE
C
C  RECOMMENDED NOT LONGER THAN CA. 20 CHARACTERS...
      CHARACTER*(*) XUN   ! UNITS LABEL FOR 1ST INDEP COORDINATE
      CHARACTER*(*) ZUN   ! UNITS LABEL FOR FCN BEING PLOTTED
      CHARACTER*(*) YUN   ! UNITS LABEL FOR 2ND INDEP. COORDINATE
C
C  RECOMMENDED NOT LONGER THAN CA. 45 CHARACTERS...
      CHARACTER*(*) ZTITLE	! TITLE LABEL FOR PLOTS
C
C  RECOMMENDED NOT LONGER THAN CA. 15 CHARACTERS
      CHARACTER*(*) ZLABEL	! GENERIC LABEL FOR PLOTS
C
C  PROCESSING FLAG (FOR LABELING ONLY)
      INTEGER IPROC	    ! 0=NOTHING, 1=AVG'D, 2=SMOOTHED, ETC...
C
      logical :: lxvt = .FALSE.
C---------------------------------
C
C  THIS ROUTINE PRESENTS AN INTERACTIVE (UREAD) MENU VIA SUBROUTINE
C  GRF3OP, ALLOWING THE USER TO SELECT
C    1)  3D ISOMETRIC PLOTS
C    2)  2D SIMPLE SLICE PLOTS
C    3)  CONTOUR PLOTS
C    4)  2D SLICE MULTIPLOTS
C  OF THE PASSED LABELED DATA.
C
C  NOTE THE WORKSPACE ARRAY IS NEEDED TO BUILD SOME SLICE PLOTS AND
C  WILL BE OVERWRITTEN ON CALL TO THIS ROUTINE
C
C  ALL OTHER ARGUMENTS TO THIS ROUTINE ARE INPUT ONLY
C
C  ALL LABELS ARE OF ELASTIC LENGTH; HOWEVER, FOR SOME NONBLANK LENGTH
C  THE LABELS WILL START TO NOT FIT IN THE GENERATED TEKTRONIX DISPLAYS
C  WITHOUT LINE WRAPPING
C
C---------------------------------
C  LOCAL
C
      CHARACTER*25 ZLPROC
C
      CHARACTER*132 MNLAB(3)
C
      CHARACTER*12 ZENCOD
C
      integer LUNTRM,LNOUT, IMAIN,ISUB,IFUN, IRET, IMIN
      integer isel,  iert,  i
      real    YFIX, XFIX, FDCOD, DYMIN, DY, dxmin, dx  
C
C---------------------------------
C  EXECUTABLE CODE -- SET UP PROCESSING LABEL
C
      ZLPROC=' '
      IF(IPROC.EQ.1) THEN
        ZLPROC(2:)='(AVERAGED)'
      ELSE IF(IPROC.EQ.2) THEN
        ZLPROC(2:)='(SMOOTHED)'
      ELSE IF(IPROC.EQ.3) THEN
        ZLPROC(2:)='(AVERAGED, SMOOTHED)'
      ELSE IF(IPROC.EQ.4) THEN
        ZLPROC(2:)='(PROCESSED)'
      ENDIF
C
C  TTY LUN
C
      LUNTRM=LNOUT(0)
C
C-------------------
#ifdef __DEBUG
      write(6,*) ' ===>(trgraf debug)'
      write(6,*) ' nx= ',nx,' ny= ',ny,' nz1= ',nz1
      write(6,*) ' x(1)=',x(1),' x(nx)=',x(nx)
      write(6,*) ' y(1)=',y(1),' y(ny)=',y(ny)
      write(6,*) ' z(1,1)=',z(1,1),' z(nx,ny)=',z(nx,ny)
      write(6,*) ' (end trgraf debug)'
#endif
C
C  USER OPTION MENU
C
 10   CONTINUE
C
      CALL GRF3OP(ZLABEL,ZTITLE,
     >    XLAB,ZLAB,' ',YLAB,' ',IMAIN,ISUB,1,IFUN)
C
C  BRANCH
C
      GO TO (100,200,300,400,500,600,700,800) IMAIN
C
C-------------------
C
 100  CONTINUE
C
C  3D ISOMETRIC PLOT
C
      CALL TGRF3D(X,Z,Y,NX,NY,NZ1,
     >    XLAB,YLAB,ZLAB,
     >    XUN,YUN,ZUN,
     >    ZTITLE,IPROC,
     >    ZLABEL,0,' ',
     >    NPAGEC,' ',' ',0.0,IRET)
C
      IF(IRET.EQ.1) GO TO 400
C
      GO TO 10
C
C-------------------
C
C  2D GRAPH OF VARIABLE VS. 1ST INDEPENDANT VARIABLE, 2ND IN-
C  DEPENDANT VARIABLE HELD CONSTANT TO USER SPECIFIED
C  VALUE.
C
 200  CONTINUE
C
C  GET USER SPECIFIED Y VALUE
C
 1200 FORMAT('  ...PLOT VS ',A/'  AT FIXED ',A,', ',A)
C
      IF(LXOUT(0)) WRITE(LUNTRM,1200) XLAB,YLAB,YUN
      CALL UREAD(' GRF3SG:  ENTER FIXED PARAMETER:$$')
      IF(LCHAR('Q')) GOTO 10
C
      YFIX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 200
C
      DYMIN=ABS(YFIX-Y(1))
      IMIN=1
C
      DO 210 I=1,NY
        DY=ABS(YFIX-Y(I))
        IF(DY.GT.DYMIN) GO TO 210
        IMIN=I
        DYMIN=DY
 210  CONTINUE
C
C  SPECIFY FIXED PT DATA IN PLOT LABEL
C
      WRITE(ZENCOD,'(1PE12.5)') Y(IMIN)
C
C  MAKE GRAPH  (GRFAH0 WILL SET SCALE, ETC.)
C
      CALL GRAFX1(X,Z(1,IMIN),NX,XUN,ZUN,
     >    trim(ZLABEL)//' '//trim(ZTITLE),
     >    'FIXED: '//trim(YLAB)//' = '//trim(ZENCOD)//' '//trim(YUN),
     >    trim(ZLAB)//' '//trim(ZLPROC)//' VS '//trim(XLAB))
C
      GO TO 10
C
C------------------
C
C  2D GRAPH OF DEPENDANT VARIABLE VS. 2ND INDEPENDANT VARIABLE
C  WITH USER SPECIFYING FIXED VALUE FOR 1ST INDEPENDANT VARIABLE.
C
 300  CONTINUE
C
C   GET USER SPECIFIED X VALUE
C
      IF(LXOUT(0)) WRITE(LUNTRM,1200) YLAB,XLAB,XUN
      CALL UREAD(' GRF3SG:  ENTER FIXED PARAMETER:$$')
      IF(LCHAR('Q')) GOTO 10
C
      XFIX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 300
C
      DXMIN=ABS(X(1)-XFIX)
      IMIN=1
C
      DO 310 I=1,NX
        DX=ABS(X(I)-XFIX)
        IF(DX.GT.DXMIN) GO TO 310
        DXMIN=DX
        IMIN=I
 310  CONTINUE
C
C  WILL PLOT COLUMN OF Z POINTS CLOSEST TO SPECIFIED X
C  VALUE.  USE WK ARRAY: GRFADH REQUIRES POINTS BEING GRAPHED
C  TO BE IN CONTIGUOUS CORE SPACE
C
      DO 315 I=1,NY
        WK(I)=Z(IMIN,I)
 315  CONTINUE
C
C  SPECIFY FIXED PT DATA IN PLOT LABEL
C
      WRITE(ZENCOD,'(1PE12.5)') X(IMIN)
C
C  MAKE GRAPH  (GRFAH0 WILL SET SCALE, ETC.)
C
      CALL GRAFX1(Y,WK,NY,YUN,ZUN,
     >    trim(ZLABEL)//' '//trim(ZTITLE),
     >    'FIXED: '//trim(XLAB)//' = '//trim(ZENCOD)//' '//trim(XUN),
     >    trim(ZLAB)//' '//trim(ZLPROC)//' VS '//trim(YLAB))
C
C
      GO TO 10
C
C------------------------------
C  ** EXIT
 400  CONTINUE
C
      RETURN
C
C------------------------------
C  ** CONTOUR PLOTTING
C
 500  CONTINUE
C
      IF(ISUB.EQ.0) THEN
        CALL CONCTR(X,Z,Y,NX,NZ1,NY,
     >           XLAB,ZLAB,YLAB,XUN,ZUN,YUN,ZLABEL,
     >           0,IPROC,NPAGEC)
      ELSE
        CALL CONCTS(X,Z,Y,NX,NZ1,NY,
     >           XLAB,ZLAB,YLAB,XUN,ZUN,YUN,ZLABEL,
     >           0,IPROC,NPAGEC,1,1,1)
      ENDIF
C
      GO TO 10
C
C------------------------------
C  CHANGE DEFAULT PLOT TYPE
C
 600  CONTINUE
      CALL GAXSET(ISEL,1)
      GO TO 10
C
C------------------------------
C  CHANGE SCALING DEFAULTS
C
 700  CALL GSCDEF
      GO TO 10
C
C------------------------------
C
C  SLICE MULTIPLOTS--
C
 800  CONTINUE
C
      MNLAB(1)=ZLABEL//' '//ZLPROC
C
      MNLAB(2)=ZTITLE
C
      MNLAB(3)=' '
C
C  USER CHOOSE X AXIS, SET OF FIXED Y, AND MAKE GRAPH
      CALL G3MSEL(Z,NZ1,X,NX,Y,NY,WK,
     >     XLAB,XUN,YLAB,YUN,ZLAB,ZUN,MNLAB)
C
      GO TO 10
C
      	END

C---------------------------------------------------------------------
C  UDELIM  -- CHECK IF CHARACTER IS A UREAD WORD DELIMITER CHARACTER
C
      SUBROUTINE UDELIM(CHAR,ISTAT)
C
      USE USERIO
C
      CHARACTER*1 CHAR
      INTEGER ISTAT
C
C  MOD DMC 3/89 -- DOUBLE QUOTE IS NO LONGER CONSIDERED A DELIMITER.
C
C  CHAR -- CHARACTER UNDER TEST (INPUT)
C  ISTAT -- RESULT (OUTPUT)
C   =0  NOT A DELIMITER CHARACTER
C   =1  BLANK OR TAB
C   =2  COMMA (ONLY IF THERE IS *NO* USER SPECIFIED PUNCTUATION)
CXXX   =3  DOUBLE QUOTE CHARACTER  *NO MORE*  DMC 3/89
C   =4  USER SPECIFIED PUNCTUATION CHARACTER
C
C  NOTE -- USER SPECIFIED PUNCTUATION CHARACTERS ARE NONBLANK,
C   NONTAB, NONALPHANUMERIC AND NOT DOUBLEQUOTE.  IF COMMA IS A
C   USER SPECIFIED PUNCTUATION CHARACTER, ISTAT=3 IS RETURNED, NOT
C   ISTAT=2.
C
C  COMMAS ARE FLAGGED AS DELIMITERS ONLY IF THERE IS NO USER SPECIFIED
C   USER PUNCTUATION -- AS PER THE OLD UREAD
C
C  THIS ROUTINE CREATED DMC FEB 1989 AS A MEANS TO CHANGE UREAD TO
C  BE COMPATIBLE WITH THE LOCUS USER INTERFACE
C
C--------------------------
C
      ISTAT=0
      IF((CHAR.EQ.' ').OR.(CHAR.EQ.'	')) ISTAT=1
C
      IF(LPUNCT.GT.0) THEN
        IF(INDEX(UPUNCT(1:LPUNCT),CHAR).GT.0) ISTAT=4
      ELSE
        IF(CHAR.EQ.',') ISTAT=2
      ENDIF
C
      RETURN
      END

C-----------------------------------------------------------------
C  GSCSV0 - SAVE INITIALLY COMPUTED AUTOSCALE
C
      SUBROUTINE GSCSV0
C
      INCLUDE 'GSCALE_BLK'
C
      GMINX0=GMINX
      GMAXX0=GMAXX
C
      GMINY0=GMINY
      GMAXY0=GMAXY
C
      GMNXP0=GMINXP
      GMNYP0=GMINYP
C
      RETURN
      END

C******************** START FILE GAXSET.FOR ; GROUP GAXES ******************
C----------------------------------------------------------
C  GAXSET
C  MODIFY PLOT TYPE (LOG/LINEAR FOR EITHER/BOTH AXES)
C
      SUBROUTINE GAXSET(ISEL,IDEF)
C
C  IDEF (INPUT) =1 TO MODIFY DEFAULT AXIS SELECTION
C  ISEL (OUTPUT) AXIS SELECTION (1,2,3, OR 4)
C
C
      INCLUDE 'GAXES_BLK'
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR,lxout
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      luntrm=lnout(0)
C
      IF(IGXINI.EQ.0) CALL GAXES0
 5    CALL NEUPAG
      IF(LXOUT(0)) WRITE(LUNTRM,1001)
      DO 10 IC=1,4
      IF(LXOUT(0)) WRITE(LUNTRM,1002) IC,IAXNAM(IC)
 10   CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1003)
 1001 FORMAT(' GAXSET (MODIFY PLOT AXIS TYPES) OPTIONS:')
 1002 FORMAT('  -',I1,'- SET PLOT TYPE TO ',A10)
 1003 FORMAT('  -Q- QUIT (DO NOTHING)')
      CALL UREAD('GAXSET:  ENTER ONE LETTER/NUMERAL OPTION CODE:$')
      IF(LCHAR('Q')) RETURN
      IANS=IDCOD(IERT)
      IF((IERT.NE.0).OR.(IANS.LE.0).OR.(IANS.GT.4)) THEN
        CALL UERMSG('% ILLEGAL INTEGER OPCODE',' ',1)
        GO TO 5
      ENDIF
C  SELECTION MADE
      ISEL=IANS
      IF(IDEF.EQ.1) IAXSEL=ISEL
      RETURN
      END
C******************** END FILE GAXSET.FOR ; GROUP GAXES ******************

C******************** START FILE UREADF.FOR ; GROUP UREADT ******************
C---------------------------------------------------------------
C  UREADT
C
C  COLLECTION OF SUBROUTINES TO USE UREAD TO GET DATA OF
C  VARIOUS TYPES FROM THE TTY
C
C   UREADF - GET A FLOATING PT NUMBER
C   UREADI - GET AN INTEGER
C   UREADC - GET A CHARACTER
C   UREADW - GET A WORD (MAX LENGTH DETERMINED BY PASSED CHARACTER
C                        ARGUMENT, SPACE OR COMMA DELIMITTED)
C   UREADL - GET A LINE (MAX LENGTH DETERMINED BY PASSED CHARACTER
C                        ARGUMENT)
C
C  EACH ROUTINE IS CALLED VIA
C    CALL UREAD_('PROMPT STRING $-TERMINATED',ARGUMENT RETURNED)
C
C  THE PROMPT STRING MUST BE $-TERMINATED
C
C  FOR UREADI AND UREADF,
C  THE ARGUMENT VALUE IS A DEFAULT WHICH CAN BE KEPT BY THE USER
C  TYPING "Q" OR "X" OR "," IN RESPONSE TO THE PROMPT
C
C  FOR UREADC AND UREADW,
C  THE ARGUMENT VALUE IS A DEFAULT WHICH CAN BE KEPT BY THE USER
C  TYPING "," IN RESPONSE TO THE PROMPT
C
C  UREADL DOES NOT RECOGNIZE A DEFAULT-- USER MUST TYPE A NEW LINE
C----------------------------------------------------------
C& UREADF  ISSUE UREAD PROMPT, RETURN FLOATING PT NUMBER
C
      SUBROUTINE UREADF(PROMPT,F)
C
      USE USERIO
C
      CHARACTER*(*) PROMPT
      REAL F
C
      IF(NLXOUT) WRITE(LUNTRM,1001) F
 1001 FORMAT(' [OLD VALUE:  ',1PE12.5,']')
C  SAVE DEFAULT VALUE
      ZF=F
C
 10   CONTINUE
C  RESTORE DEFAULT VALUE AFTER ERROR
      F=ZF
C
      CALL UREAD(PROMPT)
C
C  ACCEPT DEFAULT (OLD VALUE)?
      IDFLT=IXUOPC('QX,$')
      IF(IDFLT.NE.0) THEN
        IF(NLXOUT) WRITE(LUNTRM,1002)
 1002 FORMAT(' % OLD VALUE RETAINED')
        GO TO 20
      ENDIF
C
      F=FDCOD(IER)
      IF(IER.NE.0) GO TO 10
C
 20   CONTINUE
      RETURN
      END
C******************** END FILE UREADF.FOR ; GROUP UREADT ******************

subroutine ps_namrd_slist_chk(listname,nmax,iAMU,iZatom,iZion,nfound,iout,ierr)

  ! determine length of species list by number elements in the list
  ! with positive atomic weight (iAMU).

  ! perform sanity check on Z values.  If Zatom is defined but not Zion,
  ! set Zion=Zatom; if Zion is defined but not Zatom, set Zatom=Zion.

  use iso_c_binding, only: fp => c_double
  implicit none

  !-----------------
  ! arguments:

  character(len=*), intent(in) :: listname   ! name of list (for error message)
  integer, intent(in) :: nmax             ! size of list arrays

  integer, intent(in) :: iAMU(nmax)       ! AMU of species

  ! these can be corrected, hence intent(inout):
  integer, intent(inout) :: iZatom(nmax)     ! Atomic number of species
  integer, intent(inout) :: iZion(nmax)      ! Ionic charge number of species

  integer, intent(out) :: nfound          ! address of last non-blank element

  integer, intent(in) :: iout             ! I/O unit for error messages
  integer, intent(out) :: ierr            ! exit status (0=OK)

  !------------------
  ! local:

  integer :: ii,iblank
  !------------------

  nfound=0
  ierr=0

  iblank=0
  do ii=1,nmax
    if(iAMU(ii).le.0) then
      if(iblank.eq.0) iblank=ii
    else
      if(iblank.gt.0) then
        write(iout,*) ' ?ps_namrd_slist_chk: in list "'//trim(listname)//'":'
        write(iout,*) '  non-empty species element #',ii, &
             ' follows empty element #',iblank
        ierr=1
        exit
      endif
    endif
  enddo

  if(ierr.eq.0) then
    nfound = iblank - 1
  else
    return
  endif

  do ii=1,nfound
    if(iZatom(ii).le.0) iZatom(ii)=iZion(ii)
    if(iZion(ii).le.0) iZion(ii)=iZatom(ii)

    if(iZatom(ii).le.0) then
      write(iout,*) ' ?ps_namrd_slist_chk: in list "'//trim(listname)//'":'
      write(iout,*) '  species element #',ii,' has non-zero mass ', &
           ' but atomic number is not positive:'
      ierr=1
      exit
    endif

    if((iZion(ii).lt.1).or.(iZion(ii).gt.iZatom(ii))) then
      write(iout,*) ' ?ps_namrd_slist_chk: in list "'//trim(listname)//'":'
      write(iout,*) '  species element #',ii,' atomic number: ',iZatom(ii)
      write(iout,*) '  species ionic charge: ',iZion(ii), &
           ' should be in range between 1 and the atomic number, but:'
      ierr=1
      exit
    endif

    if((iAMU(ii).lt.iZatom(ii)).or.(iAMU(ii).gt.3*iZatom(ii))) then
      write(iout,*) ' ?ps_namrd_slist_chk: in list "'//trim(listname)//'":'
      write(iout,*) '  species element  #',ii,' fails sanity check:'
      ierr=1
      exit
    endif
  enddo

  if(ierr.ne.0) then
    write(iout,*) '  iAMU=',iAMU(ii),' iZatom=',iZatom(ii),' iZion=',iZion(ii)
  endif

  return
end subroutine ps_namrd_slist_chk

C******************** START FILE NUMCLR.FOR ; GROUP URDUTS ******************
C------------------------------------------------------------
C&  NUMCLR  UREAD INTERNAL - TYPEAHEAD BUFFER POP
C
C  CLEAR ENTRY ENDING AT SPECIFIED INDEX FROM INPUT LINE BUFFER
C  IF ANYTHING IS LEFT SUPPRESS FUTURE OUTPUT TO ALLOW SILENT
C  INTERPRETATION OF STACKED INPUT
C
C  MOD DMC JAN 1988-- CONTENTS EXTRACTED FROM TYPEAHEAD BUFFER ARE
C  STASHED IN UWORD(1:LUWORD)
C
C  MOD DMC APR 1988-- COMMA DELIMITER ROTATED OUT *ONLY* IF IT
C  IMMEDIATELY FOLLOWS FIELD BEING CLEARED
C
C  I.E. "stuff,"  and "stuff ," NOW TREATED DIFFERENT; THE LEADING
C  BLANK BEFORE THE COMMA IS ASSUMED SIGNIFICANT AND THE COMMA
C  WILL BE SEEN AS THE NEXT FIELD...
C  ... by popular demand
C
C---------------------------
C
      SUBROUTINE NUMCLR(J)
C
      USE USERIO
C
C---------------------------
C
      IJ=MAX0(1,J)
C
      IDELIM=0
C  IS THIS A DELIMITER CHARACTER?
      CALL UDELIM(CBUFF(IJ:IJ),IDELIM)
C
      ICT=0
      ICTI=0
C
      DO 10 I=1,IJ
        ICT=ICT+1
        UWORD(ICT:ICT)=CBUFF(I:I)
        IF(CBUFF(I:I).NE.' ') ICTI=ICT
        CBUFF(I:I)=' '
 10   CONTINUE
C
C  ALSO CLEAR A FOLLOWING DELIMITER IF NECESSARY
      IF((IDELIM.EQ.1).OR.(IDELIM.EQ.2)) GO TO 30
      IF(IJ.GE.NCHARC) GO TO 30
C
      IJP1=IJ+1
C
      ICOMMA=0
      DO 20 I=IJP1,NCHARC
        CALL UDELIM(CBUFF(I:I),JDELIM)
        IF((JDELIM.LT.1).OR.(JDELIM.GT.2)) GO TO 30
        IF(JDELIM.EQ.2) THEN
          IF(I.GT.IJP1) GO TO 30 ! COMMA SIGNIFICANT AFTER LEADING " "
          ICOMMA=1
        ENDIF
        ICT=ICT+1
        UWORD(ICT:ICT)=CBUFF(I:I)
        IF(CBUFF(I:I).NE.' ') ICTI=ICT
        CBUFF(I:I)=' '
        IF(ICOMMA.EQ.1) GO TO 30
 20   CONTINUE
C
 30   CONTINUE
C
      ICT=MIN(LBUFF,(ICTI+1))
      IF(ICTI.LT.LBUFF) UWORD(ICT:ICT)=' '
      LUWORD=ICT
C
C  LEFT-JUSTIFY RESULT (WHICH MAY BE EMPTY)
      CALL UDECOD
C  IF ANYTHING IS LEFT SILENCE OUTPUT UNTIL INTERPRETED
      CALL URXOUT
C
      RETURN
C
      END
C******************** END FILE NUMCLR.FOR ; GROUP URDUTS ******************

!
!  real*8 interface -- beam target fusion
!
!  collection of functions for evaluating fusion reaction rate coefficients
!  <sigma*v> from pretabulated data
!
!  for all functions:  input beam energy, KeV, target temperature, KeV,
!  receive <sigma*v>, m**3/sec
!
subroutine fusn_btsigv_DDp(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_DDp, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_DDp
!
subroutine fusn_btsigv_DDn(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_DDn, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_DDn
!
subroutine fusn_btsigv_DT(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_DT, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_DT
!
subroutine fusn_btsigv_TD(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_TD, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_TD
!
subroutine fusn_btsigv_TT(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_TT, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_TT

subroutine fusn_btsigv_dpcTT(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_dpcTT, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_dpcTT
!
subroutine fusn_btsigv_D3(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_D3, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_D3
!
subroutine fusn_btsigv_3D(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_3D, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_3D
!
subroutine fusn_btsigv_T3(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_T3, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_T3
!
subroutine fusn_btsigv_3T(ebeam,ttarget,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: ebeam(n),ttarget(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_warmtarget_sigmatimesv(Lfs_3T, ebeam, ttarget, answer, n)
 
end subroutine fusn_btsigv_3T

C******************** START FILE PUTCHR.FOR ; GROUP PUTCHR ******************
C====================================================
C  PUTCHR    D. MC CUNE  21-MAY-80
C
C  PUT A CHARACTER (A1) CENTERED AT X,Y LOCATION
C  ON SCREEN (IN AG4010 WINDOW)
C
      SUBROUTINE PUTCHR(X,Y,CHAR)
C
C-----------------------------------
C
      CHARACTER*1 CHAR
C
      INCLUDE 'PLOT1MMX'
C
C  ! SAVE LAST RASTER COORD WRITE (initialize to way-off-screen)
C
      integer, save :: IXPREV = -10000
      integer, save :: IYPREV = -10000
C
C   2 CHARS NEED TO FIT IN ZBUF
C  CHARACTER HALF WIDTH,HEIGHT IN SCREEN RASTER UNITS
C
      DATA IHY/7/
      DATA IHX/5/
C
C-----------------------------------
C
C  SKIP IF OUTSIDE RANGE
      IF( (X.GT.XMAX) .OR. (X.LT.XMIN) .OR.
     >      (Y.GT.YMAX) .OR. (Y.LT.YMIN)  ) RETURN
C
C  GENERATE LABEL IF FAR ENOUGH FROM PREVIOUS LABEL
      CALL WINCOT(X,Y,IX,IY) ! TRANSL TO SCREEN COORDS
      IF(MAX0(ABS(IXPREV-IX),ABS(IYPREV-IY)).LT.80) RETURN
C
      IXPREV=IX
      IYPREV=IY
C
      CALL MOVEA(X,Y)
C
      JHX=-IHX
      JHY=-IHY
C
      CALL MOVREL(JHX,JHY)
C
      CALL AGTHS(CHAR)
C
      RETURN
      	END
C******************** END FILE PUTCHR.FOR ; GROUP PUTCHR ******************

C******************** START FILE USPLNM.FOR ; GROUP USPARM ******************
C---------------------------------------------------------------
C&  USPLNM  CHECK LEGALITY AND PACK UREAD PARAMETER NAME
C   INPUT-- ZLINE:  UNPACKED DATA LINE (1 CHAR PER WORD)
C           LLINE:  LENGTH THEREOF
C           IND1:  1ST INDEX OF NAME FIELD
C           IND2:  LAST INDEX OF NAME FIELD
C      (IND1,IND2 MODIFIED ON OUTPUT)
C   OUTPUT- ZNAME:  16 CHAR RIGHT-JUSTIFIED PACKED ALPHANUMERIC NAME
C           IER     =0: NORMAL SUCCESSFUL COMPLETION
C                   =1: ILLEGAL SYNTAX IN NAME FIELD (E.G IMBEDDED
C                       BLANKS)
C                   =2: ILLEGAL CHARACTER IN NAME FIELD
C
C
      SUBROUTINE USPLNM(ZLINE,LLINE,IND1,IND2,ZNAME,IER)
      USE USERIO
      PARAMETER (NLEGLC=38)
      CHARACTER*1 ZLINE(LLINE)
      CHARACTER*16 ZNAME
      CHARACTER*1 ZBLANK,ZLEGAL(NLEGLC),ZUT(16)
      DATA ZBLANK/' '/
      DATA ZLEGAL/'A','B','C','D','E','F','G','H','I','J'
     >             ,'K','L','M','N','O','P','Q','R','S','T'
     >             ,'U','V','W','X','Y','Z','1','2','3','4'
     >             ,'5','6','7','8','9','0','_','$'/
C
C  START OF EXECUTABLE CODE.  IGNORE LEADING AND TRAILING BLANKS
C
      IER=0
C
      ILENMX=LEN(ZNAME)
C
 10   CONTINUE
        IF(IND1.GT.IND2) GO TO 500
        CALL UDELIM(ZLINE(IND1),JCODE)
        IF((JCODE.LT.1).OR.(JCODE.GT.2)) GO TO 20
        IND1=IND1+1
      GO TO 10
C
 20   CONTINUE
        IF(IND2.LT.IND1) GO TO 500
        CALL UDELIM(ZLINE(IND2),JCODE)
        IF((JCODE.LT.1).OR.(JCODE.GT.2)) GO TO 40
        IND2=IND2-1
      GO TO 20
C
 40   CONTINUE
      INDIB=IND1
C  CHECK FOR IMBEDDED BLANKS
      CALL UFCHAR(ZLINE,ZBLANK,INDIB,LLINE)
      IF((IND1.LT.INDIB).AND.(IND2.GT.INDIB)) GO TO 500
C  CHECK LENGTH
      ILEN=IND2-IND1+1
      IF(ILEN.GT.ILENMX) GO TO 500
C  CHECK LEGALITY OF EACH CHARACTER
      DO 50 I=IND1,IND2
        CALL USPCAP(ZLINE(I))
        DO 45 J=1,NLEGLC
          IF(ZLINE(I).EQ.ZLEGAL(J)) GO TO 50
 45     CONTINUE
        GO TO 1000
 50   CONTINUE
C  PACK NAME
      DO 60 I=1,ILENMX
        ZUT(I)=ZBLANK
        IF(I.GT.ILEN) GO TO 60
        IND=IND1+I-1
        ZUT(I)=ZLINE(IND)
 60   CONTINUE
      WRITE(ZNAME,1001) (ZUT(I),I=1,ILENMX)
 1001 FORMAT(80A1)
      RETURN
C
C  ERRORS *********
C
 500  CONTINUE
      WRITE(LUNTRM,9001) ILENMX
 9001 FORMAT(' % ILLEGAL SYNTAX IN PARAMETER NAME FIELD:'/
     >  '   NULL NAME, NAME TOO LONG (MAX ',I2,' CHARS), OR'/
     >  '   NAME CONTAINS IMBEDDED BLANKS'/)
      CALL UCLEAR
      CALL UPAUST(1)
      IER=1
      RETURN
C
 1000 CONTINUE
      WRITE(LUNTRM,9002) ZLINE(I)
 9002 FORMAT(' % ILLEGAL CHARACTER "',A1,'" IN PARAMETER'/
     >  '   NAME FIELD; ONLY LETTERS, DIGITS, OR "_" ARE LEGAL'/)
      CALL UCLEAR
      CALL UPAUST(1)
      IER=2
      RETURN
C
      	END
C******************** END FILE USPLNM.FOR ; GROUP USPARM ******************

      subroutine ufmds_read(arg,array,numa,ier)
C
C  read data at expression (arg) into array (array)
C  return error code ier, 0 = normal
C
C---------------------------------
C History:
C 11/18/1999 CAL: new calling arguments for mds_value
C 04/05/2010 DMC: NaN scan added
C------------------------------
      use UFILES
C
      character*(*) arg
      real array(numa)
      integer ier
C
      character*128 zerrmsg
C
      integer     idescr_floatarr, iretl, icount
C
C----------------------------------
C
      ier=0
      ila=max(1,len_trim(arg))
C
      istat=mds_value(arg(1:ila),idescr_floatarr(array,numa,1),iretl)
      if(mod(istat,2).ne.1) then
         call ufmds_err('UFMDS_READ',istat,ier,zerrmsg,ilm)
         write(ufelun,9510) arg(1:ila),zerrmsg(1:ilm)
 9510    format('  reading MDS+ signal data: ',a/2x,a)
      else

         ! MDS+ can hold NaNs; check...

         icount=0
         call nanscan_r4(ufelun,arg(1:ila),numa,array,icount)
         if(icount.gt.0) ier=100

      endif
C
      return
      end

C******************** START FILE UERMSF.FOR ; GROUP URDUTS ******************
C
C& UERMSF UREAD ERROR MESSAGE WITH FLOATING PT VALUE ECHO
      SUBROUTINE UERMSF(MSG,FNUM,ICOD)
C
      CHARACTER*(*) MSG
      CHARACTER*15 FBUF
C
      WRITE(FBUF,1001,ERR=10) FNUM
 1001 FORMAT(1PE15.8)
      GO TO 20
C
 10   CONTINUE
      FBUF='**.GT.E15******'
C
 20   CALL UERMSG(MSG,FBUF,ICOD)
      RETURN
      END
C******************** END FILE UERMSF.FOR ; GROUP URDUTS ******************

      SUBROUTINE GEOTRN(MODE, XIN, EIN, DIN, EOUT, DOUT)
C***********************************************************************
C*****GEOTRN TRANSFORMS ELONGATION AND TRIANGULARITY FROM A MOMENTS TO *
C*****A GEOMETRICAL REPRESENTATION AND VICE VERSA.                     *
C*****REFERENCES:                                                      *
C*****L.L.LAO,S.P.HIRSHMAN,R.M.WIELAND,ORNL/TM-7616 (1981).            *
C*****L.L.LAO,R.M.WIELAND,W.A.HOULBERG,S.P.HIRSHMAN,ORNL/TM-7871 (1981)*
C*****LAST REVISION: 6/81 L.L.LAO, R.M.WIELAND, AND W.A.HOULBERG ORNL. *
C*****CALCULATED PARAMETERS:                                           *
C*****EOUT-OUTPUT ELONGATION.                                          *
C*****DOUT-OUTPUT TRIANGULARITY.                                       *
C*****INPUT PARAMETERS:                                                *
C*****MODE-DESIGNATES DIRECTION OF TRANSFORMATION.                     *
C*****    =1 GEOMETRICAL => MOMENTS.                                   *
C*****    =2 MOMENTS => GEOMETRICAL.                                   *
C*****XIN-INPUT REDUCED MINOR RADIUS                                   *
C*****EIN-INPUT ELONGATION.                                            *
C*****DIN-INPUT TRIANGULARITY.                                         *
C***********************************************************************
      IF (XIN.LE.0.0) GO TO 30
      IF (MODE.EQ.2) GO TO 20
C*****GEOMETRICAL ==> MOMENTS REPRESENTATION.
      DOUT = DIN/4.0
      CTC = 0.0
      DO 10 I=1,10
           CTC = 4.0*DOUT/(SQRT(XIN**2+32.0*DOUT**2)+XIN)
           DOUT = XIN*DIN/(4.0-6.0*CTC**2)
   10 CONTINUE
      EOUT = XIN*EIN/(SQRT(1.0-CTC*CTC)*(XIN+2.0*DOUT*CTC))
      RETURN
C*****MOMENTS ==> GEOMETRICAL REPRESENTATION.
   20 CTC = 4.0*DIN/(SQRT(XIN**2+32.0*DIN**2)+XIN)
      STC = SQRT(1.0-CTC*CTC)
      S2TC = 2.0*STC*CTC
      C2TC = 2.0*CTC*CTC - 1.0
      EOUT = EIN*(XIN*STC+DIN*S2TC)/XIN
      DOUT = DIN*(1.0-3.0*C2TC)/XIN
      RETURN
   30 EOUT = EIN
      DOUT = DIN
      RETURN
      END

C******************** START FILE FNEXC.FOR ; GROUP CONCTR **************
C-----------------------------
C  FNEXC    FIND NEXT CONTOUR INTERCEPT
C
C
      SUBROUTINE FNEXC(X,F,N,C,NC,X0,F0,IRET)
C
C  X(N)  INDEP. VARIABLE
C  F(N)  DEPENDANT VARIABLE
C  C(NC) CONTOUR VALUES
C  N,NC  ARRAY DIMENSIONS
C
C  X0,F0-- CURRENT LOCATION, UPDATED BY CALLS TO THIS ROUTINE
C  IRET -- =0==> NO CONTOUR FOUND
C  IRET -- =N==> CONTOUR #N INTERCEPT FOUND
C
C
C    27 JAN 1992
C  DMC -- IMPROVE SPEED BY REMEMBERING RECENT SEARCH START POINT
C
      DATA IPREV/-1/
C
      SAVE IPREV
C
      DIMENSION X(N),F(N),C(NC)
C
C-----------------------------------------------------------------------
C
      IRET=0
      NM1=N-1
      IF(N.GT.1) GO TO 5
        X0=AMAX1(1.0E30,1.1*X(N))
        F0=F(1)
        RETURN
 5    CONTINUE
C
      IF(IPREV.LT.1) THEN
        IPREV=1
      ELSE IF(IPREV.GE.N) THEN
        IPREV=NM1
      ENDIF
C
      ICYC=0
      DO 10 IJ=1,NM1
        J=IPREV+IJ-1-NM1*ICYC
        JNEX=J+1
        IF(J.GT.NM1) THEN
          ICYC=1
          J=J-NM1
          JNEX=JNEX-NM1
        ENDIF
C
        IF((X0.GE.X(J)).AND.(X0.LT.X(JNEX))) GO TO 20
C
 10   CONTINUE
      RETURN
C
 20   CONTINUE
      IPREV=J
C
C  MAX NEXT X IS X(JNEX)
      DELX=X(JNEX)-X0
      DELF=F(JNEX)-F0
      IF(DELF.EQ.0.0) GO TO 890
      S=DELF/DELX
      IF(S.GT.0.0) INC=+1
      IF(S.LT.0.0) INC=-1
C  FIND POINTER TO NEXT CONTOUR
      INEXC=NC-1
      IF((S.LT.0.0).AND.(F0.EQ.C(NC))) GO TO 50
      INEXC=0
      NCM1=NC-1
      DO 30 I=1,NCM1
        IF(F0.NE.C(I)) GO TO 25
        INEXC=I+INC
        GO TO 50
 25     CONTINUE
        IP1=I+1
        IF(.NOT.((F0.GT.C(I)).AND.(F0.LT.C(IP1)))) GO TO 30
        INC2=MAX0(0,INC)
        INEXC=I+INC2
        GO TO 50
 30   CONTINUE
      IF((S.LT.0.0).AND.(F0.GT.C(NC))) INEXC=NC
      IF((S.GT.0.0).AND.(F0.LT.C(1))) INEXC=1
      GO TO 50
C
 50   CONTINUE
      IF(INEXC.EQ.0) GO TO 890
      IF((S.GT.0.0).AND.(F(JNEX).LT.C(INEXC))) GO TO 890
      IF((S.LT.0.0).AND.(F(JNEX).GT.C(INEXC))) GO TO 890
C  CONTOUR IN RANGE
      IRET=INEXC
      X0=(C(INEXC)-F0)/S + X0
      F0=C(INEXC)
C
      RETURN
C  NO CONTOUR IN RANGE
 890  CONTINUE
      X0=X(JNEX)
      F0=F(JNEX)
      IRET=0
      RETURN
      	END
C******************** END FILE FNEXC.FOR ; GROUP CONCTR ****************

C******************** START FILE UF3DRD.FOR ; GROUP UFILES *************
C--------------------------------------------------------------
C  UF3DRD
C  READ 3-DIMENSIONAL DATA FROM ASCII FILE
C
 
      SUBROUTINE UF3DRD(ILUN,IDEV,ZSDATE,
     >     F,NF1,NF2,X,NX,Y,NY,Z,NZ,IPROC,
     >     NXACT,NYACT,NZACT,IFLAG,
     >     FLAB,XLAB,YLAB,ZLAB,
     >     NSCD,NSCA,SCVAL,SCLAB,
     >     IER)
 
 
C  Updated:
C   02/07/01 CAL - support MDSplus
C   08/05/97 CAL - Add HDF / netCDF file options
C   08/24/93 TBT - Added UFAHED2 and updated format.
 
C
C*  ILUN-- FILE LOGICAL UNIT NUMBER
C   IDEV-- TOKAMAK DEVICE CODE (4 LETTERS E.G. "PLT ")
C  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
C  X(NX),F(NF1,NY),Y(NY),Z(N)-- REAL NUMERIC DATA TO BE READ
C   ARRAYS AND DIMENSIONS
C  IPROC-- PROCESS CODE 0= RAW, 1 = AVERAGED
C   2= SMOOTHED, 3= AVERAGED AND SMOOTHED
C*   NX,NF1,NF2,NY,NZ ARE INPUT
C  NXACT,NYACT,NZACT ARE THE ACTUAL DIMENSIONS OF THE
C  X AND Y AND Z ARRAYS IN THE FILE ***
C*  IFLAG:
C   ---> IF IFLAG=1 THE DATA IS READ CONSECUTIVELY INTO THE
C   F ARRAY; IF IFLAG .NE. 1, THE DATA IS READ BY
C   READ (((F(IJ,IK,IL),IJ=1,NXACT),IK=1,NYACT),IL=1,NZACT)
C  XLAB-- 30 CHARACTER LABEL FOR X
C   FIRST 20 CHARACTERS-- NAME OF X
C   LAST 10 CHARACTERS--  PHYSICAL UNITS OF X
C     E.G. XLAB = 'MAJOR RADIUS        CM        '
C  FLAB-- 30 CHARACTER LABEL FOR F - SAME FORMAT AS XLAB
C  YLAB-- 30 CHARACTER LABEL FOR Y - SAME FORMAT AS XLAB
C  ZLAB-- 30 CHARACTER LABEL FOR Z - SAME FORMAT AS XLAB
C
C*  NSCD-- SPACE ALLOCATED FOR ASSOCIATED SCALARS
C  NSCA-- RETURNED ACTUAL NUMBER OF SCALARS IN FILE
C    ** NOTE ** NSCD MAY = 0 IN WHICH CASE THESE ARE DUMMIES:
C  SCVAL-- LIST OF ASSOCIATED SCALAR VALUES READ
C  SCLAB-- LIST OF ASSOCIATED SCALAR KEYWORD/LABELS READ
C    FORMAT OF SCLAB: 30 CHARS, 10 CHAR KEYWORD BLOCK, 10 CHAR LABEL,
C      10 CHAR PHYS. UNITS-- SEE SUBROUTINE UF0WRT, FILE UFILS0.FOR
C
C  IER=0 ON RETURN IF READ WAS SUCCESSFUL
C
C* DENOTES INPUT VARIABLE
      USE UFILES
C
      REAL X(NX),F(NF1,NF2,NZ),Y(NY),Z(NZ),SCVAL(*)
      CHARACTER*10 ZSDATE,ZWDATE
      CHARACTER*30 XLAB,YLAB,ZLAB,FLAB,SCLAB(*)
      CHARACTER*4 IDEV
C
      character*128 znode
      integer       iln
C
      CHARACTER*64 ERRSTR
C
      Integer Iformat
C
C$r8real_output: f,x,y,z,scval
C-----------------------------------------------------------------------
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF3DRD    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.3) THEN
        CALL UERSTA(ICHAN,'UF3DRD    ')
        GO TO 9000
      ENDIF
C
C  SWITCH FOR COMPRESSED BINARY OR ASCII READ DETERMINED AT OPEN TIME
C
C
      KMPRS=UFCPRS(ICHAN)
C
      ERRSTR='UFILE HEADER DATA'
      if(KMPRS.eq.-1) then
         ikmprs=-1
C----------------------------------------
C  MDS+ data access
C
         call ufmds_rhdr(ichan,idev,zsdate,ishot,idim,znode,iln,
     >        iproc, ier)
         if(ier.eq.1) go to 9000
 
      else IF(KMPRS.EQ.0) THEN
        IKMPRS=0
        CALL UFAHED2(ILUN,ISHOT,IDEV,IDIM,KMPRS,ZWDATE,ZSDATE,0,
     1                 Iformat,IERH)
        IF(IERH.NE.0) GO TO 8999
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999)
     >       ISHOT,IDEV,IDIM,IKMPRS,ZWDATE,ZSDATE
        IF((UFILEV-10*(UFILEV/10)).GE.1) WRITE(UFELUN,8001) ZWDATE
 8001   FORMAT(' % READING 3D COMPRESSED BINARY DATA WRITTEN ',A)
      else if(kmprs.eq.2) then
        call ufbhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
        if(ierh.ne.0) go to 8999
C      else if(kmprs. eq. 3) then
C         call uhdfhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
C         if(ierh.ne.0) go to 8999
      else if(kmprs. eq. 4) then
         call ucdfhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
         if(ierh.ne.0) go to 8999
      ENDIF
C
      IF(KMPRS.NE.IKMPRS) THEN
        WRITE(UFELUN,9008) KMPRS,IKMPRS
 9008   FORMAT(' % UF3DRD INTERNAL FLAG ERROR KMPRS, IKMPRS =',
     >       2(I2,1X))
      ENDIF
C
C  SHOT CHECK
C
      if(lshotn(ichan)) then
         IF(ISHOT.NE.UFSHOT(ICHAN)) THEN
            IF((UFILEV/10).GE.1)
     >          WRITE(UFELUN,9011) ISHOT,UFSHOT(ICHAN)
 9011       FORMAT(
     >           ' % SHOT NUMBER ',I6,
     >           ' IN FILE NOT SAME AS SHOT NUMBER ',I6,
     >           ' IN FILENAME')
          ENDIF
      endif
C
C  DIMENSION CHECK
C
      IF(IDIM.NE.3) THEN
        WRITE(UFELUN,9010) IDIM
 9010   FORMAT(
     >       ' ? DIMENSIONALITY OF INPUT FILE = ',I1,' IS INCORRECT',
     >       ' FOR UF3DRD')
        IER=1
        GO TO 9000
      ENDIF
C
C    READ ASSOCIATED SCALAR QUANTITIES
      ERRSTR='ASSOCIATED SCALAR DATA'
      if (KMPRS.EQ.-1) then            ! MDSplus
         call ufmds_0rd(ICHAN,SCVAL,SCLAB,NSCD,NSCA,znode(1:iln),IER)
         IF(IER.NE.0) GO TO 8999
      else if (KMPRS.EQ.4) then
         call ucdf0r(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
         IF(IER.NE.0) GO TO 8999
C      else if (KMPRS.EQ.3) then
C         call uhdf0r(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
C         IF(IER.NE.0) GO TO 8999
      else
         CALL UFNSRD(KMPRS,ILUN,NSCA,IERR)
         IF(IERR.NE.0) GO TO 8999
         IF(NSCA.GT.0) THEN
            CALL UF0RDR(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
            IF(IER.NE.0) GO TO 8999
         ENDIF
      end if
 
      if(nsca.gt.0) call ufsclab_ck(sclab,nsca)
 
      IF(NSCD.GT.0 .AND. NSCD.LT.NSCA) THEN
         WRITE(UFELUN,9052) NSCD,NSCA
 9052 FORMAT(' % UF3DRD WARNING-- INSUFFICIENT SPACE FOR SCALARS:'/
     >        '   SPACE ALLOCATED=',I3,' NEED:',I3/)
      ENDIF
C
      ERRSTR='DATA COORDINATE LABELS'
      if(kmprs.eq.-1) then
C----------------------------------------
C  MDS+ data access -- labels
C
         call ufmds_lbl(ichan,znode(1:iln),flab,1,znode(1:iln),ier)
         if(ier.ne.0) go to 9000
C
         call ufmds_lbl(ichan,'dim_of('//znode(1:iln)//',0)',xlab,0,
     1	'(dim 0)',ier)
         if(ier.ne.0) go to 9000
C
         call ufmds_lbl(ichan,'dim_of('//znode(1:iln)//',1)',ylab,0,
     1	'(dim 1)',ier)
         if(ier.ne.0) go to 9000
C
         call ufmds_lbl(ichan,'dim_of('//znode(1:iln)//',2)',zlab,0,
     1	'(dim 2)',ier)
         if(ier.ne.0) go to 9000
C
C----------------------------------------
      else IF(KMPRS.EQ.0) THEN
        READ(ILUN,3003,END=8999,ERR=8999) XLAB
 3003 FORMAT(1X,A30)
C
        READ(ILUN,3003,END=8999,ERR=8999) YLAB
C
        READ(ILUN,3003,END=8999,ERR=8999) ZLAB
C
        READ(ILUN,3003,END=8999,ERR=8999) FLAB
C
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999) XLAB,YLAB,ZLAB,FLAB
      else if(kmprs.eq.2) then
        call ubrchar(ilun,xlab,ier)
        if(ier.ne.0) go to 8999
        call ubrchar(ilun,ylab,ier)
        if(ier.ne.0) go to 8999
        call ubrchar(ilun,zlab,ier)
        if(ier.ne.0) go to 8999
        call ubrchar(ilun,flab,ier)
        if(ier.ne.0) go to 8999
      ENDIF
C
      ERRSTR='DATA PROCESSING CODE + NUMBER OF POINTS'
      if(kmprs.eq.-1) then
C----------------------------------------
C  MDS+ data access -- labels
C
         call ufmds_3rd(1,znode(1:iln),f,nf1,nf2,nz,x,y,z,
     >       nxact,nyact,nzact,iflag,ier)
         if(ier.ne.0) go to 8999
      else IF(KMPRS.EQ.0) THEN
        READ(ILUN,3006,END=8999,ERR=8999) IPROC
 3006 FORMAT(1X,I1)
        READ(ILUN,3017,END=8999,ERR=8999) NXACT,NYACT,NZACT
 3017   FORMAT(1X,I10/1X,I10/1X,I10)
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999) IPROC,NXACT,NYACT,NZACT
      else if(kmprs.eq.2) then
        call ubr3int(ilun,iproc,ier)
        if(ier.ne.0) go to 8999
        call ubr3int(ilun,nxact,ier)
        if(ier.ne.0) go to 8999
        call ubr3int(ilun,nyact,ier)
        if(ier.ne.0) go to 8999
        call ubr3int(ilun,nzact,ier)
        if(ier.ne.0) go to 8999
C      else if(kmprs .eq. 3) then
C         call uhdf3r(ilun,1,
C     &            f,nf1,nf2,x,nx,y,ny,z,nz,iproc,
C     &            nxact, nyact, nzact, iflag,
C     &            flab,xlab,ylab,zlab,ier)
C         if(ier.ne.0) go to 8999
      else if(kmprs .eq. 4) then
         call ucdf3r(ilun,1,
     &            f,nf1,nf2,x,nx,y,ny,z,nz,iproc,
     &            nxact, nyact, nzact, iflag,
     &            flab,xlab,ylab,zlab,ier)
         if(ier.ne.0) go to 8999
      ENDIF
C
C  CHECK FEASIBILITY OF DIMENSIONS
C  CHECK NXACT,NYACT INDIVIDUALLY
C
      IER=0
      IF(NX.LT.NXACT) THEN
        WRITE(UFELUN,9903) NX,NXACT
 9903   FORMAT(' ? UF3DRD - X ARRAY TOO SMALL:  SIZE=',I10,
     >       ' NEED=',I10)
        IER=1
      ENDIF
C
      IF(NY.LT.NYACT) THEN
        WRITE(UFELUN,9904) NY,NYACT
 9904   FORMAT(' ? UF3DRD - Y ARRAY TOO SMALL:  SIZE=',I10,
     >       ' NEED=',I10)
        IER=1
      ENDIF
C
      IF(NZ.LT.NZACT) THEN
        WRITE(UFELUN,9914) NZ,NZACT
 9914   FORMAT(' ? UF3DRD - Z ARRAY TOO SMALL:  SIZE=',I10,
     >       ' NEED=',I10)
        IER=1
      ENDIF
C
      IF(IFLAG.NE.1) THEN
C
        IF(NF1.LT.NXACT) THEN
          WRITE(UFELUN,9905) NF1,NXACT
 9905     FORMAT(' ? UF3DRD - 1ST DIMENSION OF F ARRAY TOO SMALL'/
     >         '   SIZE = ',I10,' NEED = ',I10)
          IER=1
        ENDIF
C
        IF(NF2.LT.NYACT) THEN
          WRITE(UFELUN,9915) NF2,NYACT
 9915     FORMAT(' ? UF3DRD - 2ND DIMENSION OF F ARRAY TOO SMALL'/
     >         '   SIZE = ',I10,' NEED = ',I10)
          IER=1
        ENDIF
C
      ELSE
        ITOTA=NF1*NF2*NZ
        ITOTD=NXACT*NYACT*NZACT
        IF(ITOTA.LT.ITOTD) THEN
          WRITE(UFELUN,9906) ITOTA,ITOTD
 9906     FORMAT(' ? UF3DRD - F ARRAY TOO SMALL'/
     >         '   TOTAL WORDS = ',I10,' NEED = ',I10)
          IER=1
        ENDIF
      ENDIF
C
      IF(IER.NE.0) THEN
C
        WRITE(UFELUN,9907)
 9907   FORMAT(
     >     /' ? UF3DRD - ARRAYS PROVIDED TOO SMALL FOR DATA REQUESTED'/)
        GO TO 9000
      ENDIF
C
      if(kmprs.eq.-1) then
C----------------------------------------
C  MDS+ data access
C
         if (iflag .ne. 1) then
            call ufmds_3rd(2,znode(1:iln),f,nf1,nf2,nz,x,y,z,
     >          nxact,nyact,nzact,iflag,ier)
         else
            call ufmds_read(znode(1:iln),f,itotd,ier)
            if(ier.ne.0) go to 8999
            call ufmds_3rd(3,znode(1:iln),f,nf1,nf2,nz,x,y,z,
     >           nxact,nyact,nzact,iflag,ier)
         endif
         if(ier.ne.0) go to 8999
      else if(kmprs.eq.4) then         ! netCDF
         call ucdf3r(ilun,2,
     >       f,nf1,nf2, x,nx, y,ny, z,nz,
     >       iproc, nxact, nyact, nzact, iflag,
     >       flab, xlab, ylab, zlab, ier)
         if(ier.ne.0) go to 8999
C      else if(kmprs.eq.3) then         ! HDF
C         call uhdf3r(ilun,2,
C     >                 f,nf1,nf2, x,nx, y,ny, z,nz,
C     >                 iproc, nxact, nyact, nzact, iflag,
C     >                 flab, xlab, ylab, zlab, ier)
C         if(ier.ne.0) go to 8999
      else if(kmprs.eq.2) then
         call ubcprd(ilun,x,'x',nxact,1,1,nxact,1,ier)
         if(ier.ne.0) go to 8999
         call ubcprd(ilun,y,'y',nyact,1,1,nyact,1,ier)
         if(ier.ne.0) go to 8999
         call ubcprd(ilun,z,'z',nzact,1,1,nzact,1,ier)
         if(ier.ne.0) go to 8999
         if(iflag.eq.1) then
            inx1=nxact
            inx2=nyact
         else
            inx1=nf1
            inx2=nf2
         endif
         ERRSTR='DEPENDENT COORDINATE (F) DATA'
         call ubcprd(ilun,f,'f',inx1,inx2,nzact,nxact,nyact,ier)
         if(ier.ne.0) go to 8999
      else IF(KMPRS.EQ.1) THEN
C
C  READ COMPRESSED ARRAYS, DECOMPRESS, AND CONVERT TO REAL
        ERRSTR='INDEPENDENT COORDINATE (X) DATA'
        CALL UFCPRD(ILUN,X,NXACT,1,1,NXACT,1,IERR)
        IF(IERR.NE.0) GO TO 8999
C
        ERRSTR='INDEPENDENT COORDINATE (Y) DATA'
        CALL UFCPRD(ILUN,Y,NYACT,1,1,NYACT,1,IERR)
        IF(IERR.NE.0) GO TO 8999
C
        ERRSTR='INDEPENDENT COORDINATE (Z) DATA'
        CALL UFCPRD(ILUN,Z,NZACT,1,1,NZACT,1,IERR)
        IF(IERR.NE.0) GO TO 8999
C
        IF(IFLAG.EQ.1) THEN
          INX1=NXACT
          INX2=NYACT
        ELSE
          INX1=NF1
          INX2=NF2
        ENDIF
        ERRSTR='DEPENDENT COORDINATE (F) DATA'
        CALL UFCPRD(ILUN,F,INX1,INX2,NZACT,NXACT,NYACT,IERR)
        IF(IERR.NE.0) GO TO 8999
C
      ELSE IF(KMPRS.EQ.0) THEN
C
C  READ UNCOMPRESSED DATA
          ErrStr = 'ASCII Data Format'
        if ((iformat.lt.0).or.(iformat.gt.1)) go to 8999
 
        ERRSTR='INDEPENDENT COORDINATE (X) DATA'
        if(iformat.eq.0) then
           READ(ILUN,3008,END=8999,ERR=8999) (X(IJ),IJ=1,NXACT)
        else
           call ufascio(ilun,x,nxact,'R',iend,ierr)
           if((iend.ne.0).or.(ierr.ne.0)) go to 8999
        endif
 
        ERRSTR='INDEPENDENT COORDINATE (Y) DATA'
        if(iformat.eq.0) then
           READ(ILUN,3008,END=8999,ERR=8999) (Y(IJ),IJ=1,NYACT)
        else
           call ufascio(ilun,y,nyact,'R',iend,ierr)
           if((iend.ne.0).or.(ierr.ne.0)) go to 8999
        endif
 
        ERRSTR='INDEPENDENT COORDINATE (Z) DATA'
        if(iformat.eq.0) then
           READ(ILUN,3008,END=8999,ERR=8999) (Z(IJ),IJ=1,NZACT)
        else
           call ufascio(ilun,z,nzact,'R',iend,ierr)
           if((iend.ne.0).or.(ierr.ne.0)) go to 8999
        endif
C
        ERRSTR='DEPENDENT COORDINATE (F) DATA'
        IF(IFLAG.NE.1) THEN
          if(iformat.eq.0) then
             READ(ILUN,3008,END=8999,ERR=8999)
     >           (((F(IJ,IK,IL),IJ=1,NXACT),IK=1,NYACT),IL=1,NZACT)
          else
            call ufascio3(ilun,f,nf1,nf2,nxact,nyact,nzact,
     >           'R',iend,ierr)
             if((iend.ne.0).or.(ierr.ne.0)) go to 8999
          endif
 3008   FORMAT(6(1X,1PE11.4))
        ELSE
          CALL UF2RUT2(ILUN,F,ITOTD,Iformat,IERR)
          IF(IERR.NE.0) GO TO 8999
        ENDIF
      ENDIF
C
C  READ PAST DUMMY LINE AT END ("--END-OF-DATA--...")
      ERRSTR='TRAILER RECORD'
      IF(KMPRS.EQ.0) READ(ILUN,3099,END=8999,ERR=8999) IDUMMY
 3099 FORMAT(A1)
C
      UFSTAT(ICHAN)=5
      IER=0
      RETURN
C----------
C  ERRORS
C
 8999 CONTINUE
      WRITE(UFELUN,9899) ERRSTR
 9899 FORMAT(' ? *FATAL* END OF FILE OR READ ERROR ON UFILE READ:'/
     >     6X,A)
C
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ? DATA NOT READ DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      IER=1
      UFSTAT(ICHAN)=5
      RETURN
      	END
C******************** END FILE UF3DRD.FOR ; GROUP UFILES ***************

C******************** START FILE USPCLR.FOR ; GROUP USPARM ******************
C---------------------------------------------------------------
C&  USPCLR   DELETE UREAD GLOBAL AND CURRENT LEVEL LOCAL PARAMETERS
C
      SUBROUTINE USPCLR
C
      CALL USPCLL
      CALL USPCLG
C
      RETURN
      END
C******************** END FILE USPCLR.FOR ; GROUP USPARM ******************

      subroutine ubwfi2(ilun,ichan,i2array,ilbl,inum,zrat)
C
C  compress and write an integer*2 stream
C  write uncompressed if compression does not help
C
      use UFILES
C
C-------------------------------
C
 
      integer ilun                      ! i/o unit
      integer ichan                     ! ufiles channel no.
      integer*2 i2array(inum)           ! i2 data, dimensioned.
      character*(*) ilbl                ! label (for debugging)
      integer inum                      ! array dimension
C
C  local:
C
      logical ipkd
C
#include "fpreproc/byte_declare.h"
      byte_declare ilbuf(4)
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
C
C-------------------------------
C
C  attempt compression
C
      ibytes2=2*inum
C
      call cmprs2(i2array,inum,ufpack,ufmaxr,ibitu,ierr)
      if(ierr.ne.0) then
cx         write(6,1002) ilbl,ierr
cx 1002    format(' %ubwfi2:  ',a,' data did not compress, ierr=',i2)
         ipkd=.false.
         zrat=1.0
      else
         iwords=ibitu/32+1
         ibytes=4*iwords
         ipkd=ibytes.lt.ibytes2
         zrat=min(1.0,(float(ibytes)/float(ibytes2)))
cx         write(6,1003) ilbl,zrat
cx 1003    format(' %ubwfi2:  ',a,' compression ratio:  ',1pe11.4)
      endif
C
C  write
C
      if(ipkd) then
#ifdef __CRAY
         ilbuf(1)=char(1)
#else
         ilbuf(1)=1
#endif
         call ubi3ncod(iwords,ilbuf,2)
         call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,4)
         call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ufpack,ibytes)
      else
#ifdef __CRAY
         ilbuf(1)=char(0)
#else
         ilbuf(1)=0
#endif
         call ubi3ncod(ibytes2,ilbuf,2)
         call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,4)
         call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),i2array,ibytes2)
      endif
C
      return
      end
 

C-------------------------------------------------------------------
C  GSCSMG - AUTOSCALE EVALUATION FOR MULTIPLOT DATA
C
C   USE GSCALE SUBROUTINES TO EVALUATE SCALE FOR UPCOMING 2D
C   MULTIPLOT - CF IN PARTICULAR SUBROUTINE GSCSM0
C   MODELED AFTER GSCSET WHICH WORKS FOR SIMPLE F(X) TYPE PLOTS
C
C
      SUBROUTINE GSCSMG(XDATA,YDATA,NDATAX,NDATAY,
     >     IPTRX,IINCX,IPTRY,IINCY,LPTR,NPTR)
C
C
      REAL XDATA(NDATAX),YDATA(NDATAY)
C
C   XDATA(NDATAX)  STORAGE FOR "X" DATA IN (X,Y) PAIRS
C   YDATA(NDATAY)  STORAGE FOR "Y" DATA IN (X,Y) PAIRS
C
      INTEGER IPTRX(NPTR),IPTRY(NPTR),LPTR(NPTR)
C
C   LPTR(I)  NUMBER OF (X,Y) PTS IN I'TH CONTOUR
C   IPTRX(I)  ADDRESS IN XDATA OF 1ST X PT, I'TH CONTOUR
C   IINCX     SPACING BTW. SUCCESSIVE PTS OF X DATA
C   IPTRY(I)  ADDRESS IN YDATA OF 1ST Y PT, I'TH CONTOUR
C   IINCY     SPACING BTW. SUCCESSIVE PTS OF Y DATA
C
C   FOR I = 1 TO NPTR
C
C  AXIS TYPES COMMON--
C
      INCLUDE 'GAXES_BLK'
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
C
      INCLUDE 'PLOT1MMX'
C
C  START OF EXECUTABLE CODE
C
      DATA ZINFIN/1.E38/
C
C  FIND MIN/MAX OF DATA X, Y (FOR AUTOSCALING)
C
      IF(IGSINI.EQ.0) CALL GSCINI
      IF(IGXINI.EQ.0) CALL GAXES0
C
C  COMPUTE AUTOSCALE
C
      ZINFNN=-ZINFIN
C
      CALL GSCSM0(XDATA,YDATA,NDATAX,NDATAY,IPTRX,IINCX,IPTRY,IINCY,
     >     LPTR,NPTR,ZINFNN,ZINFIN,0)
C
C  SAVE AUTOSCALE
C
      CALL GSCSV0
C
C  SET X AXIS SCALE
C
      CALL GSCXDF(0)
C
C  IF SCALE WAS REDUCED FROM X AXIS MIN/MAX, RESET VERT AUTOSCALE
C  DATA
C
      IF((XMIN.NE.GMINX).OR.(XMAX.NE.GMAXX))
     >    CALL GSCSM0(XDATA,YDATA,NDATAX,NDATAY,IPTRX,IINCX,IPTRY,IINCY,
     >    LPTR,NPTR,XMIN,XMAX,1)
C
C  SET Y AXIS SCALE
C
      CALL GSCYDF(0)
C
      RETURN
      END

C----------------------------------------------------------------
C  GFTICS - SET SG TIC OPTIONS CONTROLLED FROM GFTIC BLOCK
C
      SUBROUTINE GFTICS
C
C  EXECUTE AFTER BINITT CALL; BEFORE CHECK/DISPLAY
C
      INCLUDE 'GFTIC'
C
      if(.not.init_gftic) call gftic0
C
      CALL XFRM(KFRAMX)
      CALL YFRM(KFRAMY)
C
      CALL XMFRM(KFRMMX)
      CALL YMFRM(KFRMMY)
C
      CALL XNEAT(KNEATX)
      CALL YNEAT(KNEATY)
C
      RETURN
      END

Module alcom_mod
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  public
  SAVE
!------------------------------------------------------------------------------
! FROM ALCOM
!------------------------------------------------------------------------------
!
!     COMMON BLOCK FOR ALADDIN INTERACTIVE PROGRAM
!
!     ORIGINAL STRUCTURE DEFINED BY  R. A. HULSE, PRINCETON UNIVERSITY,
!     PLASMA PHYSICS LABORATORY.
!     (PAPER TO BE SUBMITTED TO THE JOURNAL OF COMPUTATIONAL PHYSICS
!      COMMUNICATIONS)
!
!------------------------------------------------------------------------------
!
!     REV: 2/02/89 BY J.J. SMITH IAEA ATOMIC AND MOLECULAR DATA UNIT
!          ALL LABEL LENGTHS INCREASED FROM 20 CHARACTERS TO 40
!          THE COEFFICIENT ARRAY CF IS DEFINED IN DOUBLE PRECISION
!          THE FLAG FEXN HAS BEEN ADDED TO COMUNICATE WHETHER
!          COEFFICIENTS CAN BE PRINTED IN 1PE13.6 FORMAT
!
!------------------------------------------------------------------------------
!
!     NOTE: CHARACTER VARIABLES ARE IN A SEPARATE COMMON BLOCK TO ACCOMODATE
!           FORTRAN COMPILERS WHICH REQUIRE THIS SEPARATION OF VARIABLE TYPES
!
!     NSLMX   DIMENSIONED MAXIMUM NUMBER OF SEARCH LABELS
!     NCFMX   DIMENSIONED MAXIMUM NUMBER OF COEFFICIENTS
!
!     LUTIN   LOGICAL UNIT FOR TERMINAL INPUT
!     LUTOUT  LOGICAL UNIT FOR TERMINAL OUTPUT
!     LUDF    LOGICAL UNIT FOR INPUT DATA FILE
!     DFNAME  NAME OF INPUT DATA FILE
!     LUOF    LOGICAL UNIT FOR OUTPUT DATA FILE
!     OFNAME  NAME OF OUTPUT DATA FILE
!     LUQF    LOGICAL UNIT FOR QUERY FILE
!     QFNAME  NAME OF QUERY FILE
!     LUEF    LOGICAL UNIT FOR EVALUATED DATA OUTPUT FILE
!     EFNAME  NAME OF EVALUATED DATA OUTPUT FILE
!     CMND    INPUT COMMAND LINE
!     LABEL   BUFFER ARRAY FOR LABELS
!     NCHLBL  NUMBER OF CHARACTERS IN LABEL
!     HSL     HIERARCHICAL SEARCH LABELS
!     BASL    BOOLEAN .AND. SEARCH LABELS
!     BNSL    BOOLEAN .NOT. SEARCH LABELS
!     NHSL    NUMBER OF HIERARCHICAL SEARCH LABELS
!     NBASL   NUMBER OF BOOLEAN .AND. SEARCH LABELS
!     NBNSL   NUMBER OF BOOLEAN .NOT. SEARCH LABELS
!     CF      COEFFICIENTS CONVERTED TO REAL NUMBERS
!     NCF     NUMBER OF COEFFICIENTS
!     OK      GENERAL PURPOSE STATUS FLAG
!     EOF     .TRUE. IF END OF FILE
!     MATCH   .TRUE./.FALSE. RETURN FROM SEARCH LABEL COMPARISON
!     ERRMSG  ERROR MESSAGE STRING RETURNED FROM VARIOUS SUBROUTINES

!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER, PARAMETER :: nslmx=100,ncfmx=100
  integer lutin,lutout,ludf,luof,luqf,luef,nchlbl,&
       nhsl,nbasl,nbnsl,ncf
  CHARACTER*128 DFNAME, OFNAME, QFNAME, EFNAME, CMND, ERRMSG
  CHARACTER*40 LABEL, HSL(NSLMX), BASL(NSLMX), BNSL(NSLMX)
  LOGICAL OK, EOF, MATCH
  real(fp) CF(NCFMX)
! COMMON /ALCOM/CF,LUTIN,LUTOUT,LUDF,LUOF,LUQF,LUEF,NCHLBL,NHSL,NBASL,NBNSL,NCF,
!    &OK,EOF,MATCH
! COMMON /ALCOML/DFNAME,OFNAME,QFNAME,EFNAME,CMND,ERRMSG,
!    & LABEL,HSL,BASL,BNSL
!
!------------------------------------------------------------------------------
end Module alcom_mod

C--------------------------------------------------------------------
      LOGICAL FUNCTION LDQUOT(IDUM)
C
C  RETURN .TRUE. IF TYPEAHEAD BUFFER LEAD ITEM IS A DBL QUOTE STRING,
C  OTHERWISE .FALSE.
C
      USE USERIO
C
      IF(CBUFF(1:1).EQ.'"') THEN
        LDQUOT=.TRUE.
      ELSE
        LDQUOT=.FALSE.
      ENDIF
C
      RETURN
      END

C******************** START FILE NUMFLD.FOR ; GROUP URDUTS *************
C------------------------------
C&   NUMFLD  OLD UREAD - NUMERIC FIELD LIMITS, UNPACKED LINE BUFFER
C
C   INDENTIFY LIMITS OF A NUMERIC FIELD
C  COMMAS AND BLANKS ARE LEGIT DELIMITTERS
C
      SUBROUTINE NUMFLD(DBUFF,NID1,NID2,NUM)
C
      implicit NONE
C
      integer NID1,NID2,NUM
      CHARACTER*1 DBUFF(512),MCOMMA
C
      integer i
C
      DATA MCOMMA/','/
C
C  FIND BLANK-DELIMITTERS
C
      CALL FLDLIM(DBUFF,NID1,NID2,NUM)
      IF(NUM.EQ.0) RETURN
C  CHECK FOR COMMAS
      DO 10 I=NID1,NID2
      IF(DBUFF(I).NE.MCOMMA) GO TO 12
 10   CONTINUE
      NUM=0
      NID2=NID1
      RETURN
C
 12   CONTINUE
      NID1=I
      DO 20 I=NID1,NID2
      IF(DBUFF(I).EQ.MCOMMA) GO TO 22
 20   CONTINUE
C  NO COMMAS
      GO TO 30
 22   CONTINUE
      NID2=I-1
 30   CONTINUE
      NUM=NID2-NID1+1
      RETURN
      END
C******************** END FILE NUMFLD.FOR ; GROUP URDUTS ***************

      MODULE sgnco_mod
      implicit none
      integer   :: nlm
      parameter (nlm=40)
      real, dimension(:), allocatable :: am, pl1, pl2
      real, dimension(:), pointer     :: lax,lay
      integer :: jufxy, uufxy

      logical :: iss, linx, liny
      real    :: xorg, xrang, xscal, yorg, yrang, yscal, cv
      integer :: ix, iy, is, inir, nir, kir, mir
      integer :: lam, igr, iar, ilft, irgt, npl, mpl, kfill
      integer :: nxs, nys, npu, nsym
      integer, dimension(nlm) :: kmap, ksym, kdsh
      END MODULE sgnco_mod

!               ********************************
!               * ALEV AND SUPPORTING ROUTINES *
!               ********************************
!
!                  VERSION 1.0    30/04/1989
!
!     THESE SUBROUTINES SUPPORT THE "EV" COMMAND IN ALADDIN.  "ALEV"
!     MUST BE MODIFIED BY THE USER IF THIS COMMAND IS TO RECOGNIZE NEW
!     EVALUATION LABELS (FITTED DATA FORMS).
!
!     ORIGINAL VERSION DESIGNED AND WRITTEN BY R. A. HULSE, OF THE
!     PRINCETON UNIVERSITY, PLASMA PHYSICS LABORATORY.
!     (PAPER TO BE SUBMITTED TO THE JOURNAL OF COMPUTATIONAL PHYSICS
!      COMMUNICATIONS)
!
!-------------------------------------------------------------------------------
!
!      REV: 21/4/88 BY R. A. HULSE.
!           RE-ORGANIZE TABULAR OUTPUT AND ALLOW OUTPUT TO FILE
!
!      REV: 15/4/88 BY R. A. HULSE.
!            BREAKOUT CODE FOR EACH DATA TYPE TO SUBROUTINES;
!            GENERATE MULTI-POINT TABULAR OUTPUT;
!            ADD ORNL CHEBYSHEV POLYNOMIAL DATA TYPE
!
!      REV: 7/4/88 BY R. A. HULSE.
!            BASIC VERSION WITH #MEWE AND #TAB1D TYPES
!
!      REV: 1/03/89 BY J.J.SMITH IAEA ATOMIC AND MOLECULAR DATA UNIT
!            SUBROUTINE ALREVD INTRODUCED TO CONTROL THE READING AND
!            PASSING OF INPUT PARAMETERS TO BE USED IN GENERATING
!            TABLES FROM ALEV. SUBROUTINE ALTB1D ADDED TO GENERATE
!            LINEARLY INTERPOLABLE TABLES FOR FITTED DATA FORMS TO
!            REPRODUCE THE FUNCTION TO A INPUT SPECIFIED PERCENTAGE
!            ACCURACY. FUNCTION ALRND6 ADDED TO ROUND REAL NUMBERS TO
!            SIX DECIMAL PLACES FOR OUTPUT FROM THE SUBROUTINE ALTB1D.
!
!#######################################################################
!
SUBROUTINE ALEV
!
!-------------------------------------------------------------------
!
!          EV = EVALUATE DATA VALUE FOR CURRENT ENTRY
!
!-------------------------------------------------------------------
!
!          IN ORDER TO ADD A NEW DATA TYPE TO THE "EV" COMMAND, ADD AN
!          ADDITIONAL "ELSE IF(...)" STATEMENT TO THE MAIN IF...THEN...
!          ELSE CHAIN THAT CHECKS THE "#..." EVALUATION LABEL. THE
!          SUBROUTINE CALLS AND OTHER CODING EXECUTED ON THIS BRANCH ARES
!          USED TO INTERACTIVELY EVALUATE THIS DATA ENTRY TYPE FOR
!          DISPLAY TO THE TERMINAL OR A FILE. FOR EACH DATA TYPE A
!          CALL MUST BE INCLUDED TO READ THE REQUIRED PERCENTAGE
!          ACCURACY AND LIMITS FOR GENERATION OF THE LINEAR DATA POINT
!          SERIES. THE SUBROUTINE ALTB1D REQUIRES THE NUMBER OF
!          INTERVALS AND THE EXTENTS OF EACH INTERVAL. FOR FITTED DATA
!          FORMS SPECIFIED OVER ONE INTERVAL THE EXTENTS CAN BE PASSED
!          DIRECTLY FROM THE VALUES FROM THE CALL TO ALREVD. FOR FITTED
!          DATA FORMS WHICH ARE DEFINED OVER MULTIPLE INTERVALS,
!          ADDITIONAL STATEMENTS HAVE TO BE ADDED TO CONSTRUCT THE
!          ARRAY OF INTERVALS FOR THE SUBROUTINE ALTB1D. A MAXIMUM OF
!          TEN INTERVALS FOR FITTED DATA FORMS HAS BEEN DEFINED.
!          (SEE RELEVANT CODING AND FURTHER COMMENTS BELOW).
!
!          SPECIAL NOTE: IF THE 1-DIMENSIONAL DATA EVALUATION LOOP
!          ROUTINE ALTB1D(AL----) IS TO BE USED, THE NEW EVALUATION
!          SUBROUTINE NAME **MUST** BE ADDED TO THE EXTERNAL STATEMENT
!          AT THE BEGINNING OF ALEV, AND THIS EVALUATION ROUTINE
!          **MUST** BE IN STANDARD FORM !!!
!          (AGAIN, SEE RELEVANT CODING BELOW FOR MORE DETAIL AND
!          EXAMPLE)
!
!-------------------------------------------------------------------
!
  use iso_c_binding, only: fp => c_double
  use alpcom_mod
  use alcom_mod
  implicit none
  EXTERNAL ALMEWE_Z, ALCHEB_Z, ALKING_Z, ALPHACX_Z
  EXTERNAL ALJAN1_Z , ALBELI_Z, RTABSQ_Z, ETABSQ_Z
  real(fp) PERUNC, ZX1, ZX2
  real(fp) ETH
  integer nrange, inpts, ios
!
!-----  GAMMA, CLINE, CTARGT, CION ARE VARIABLES
!-----         FOR FUNCTION TABSPY
!
  real(fp) GAMMA
  CHARACTER*2  CTARGT, CION
!
!-----  Q, ELOW AND EHIGH ARE VARAIABLES FOR FUNCTION ALPHACX
!
  real(fp) Q, ELOW, EHIGH
!
  real(fp) XRANGE(10)
!
!-------------------------------------------------------------------
!
  IF(LESEQN .EQ. 0) THEN
     WRITE(LUTOUT, '(/'' NO ENTRY CURRENTLY READ IN'')' )
     RETURN
  ENDIF
!
!-------------------------------------------------------------------
!
!      BEGIN SUBROUTINE SWITCH TO SELECT CORRECT SUBROUTINE TO CALL
!      IN ORDER TO EVALUATE THIS ENTRY, BASED ON THE EVALUATION
!      FUNCTION LABEL FROM THE ENTRY.  THIS LABEL IS STORED AS THE
!      LAST BOOLEAN LABEL.
!
!-------------------------------------------------------------------
!
  IF(BL(NBL) .EQ. '#MEWE') THEN
     WRITE(LUTOUT,&
     '(/'' MEWE SPECTRAL LINE EXCITATION RATE COEFFICIENT (cm3/s),'',/'' AS FUNCTION OF ELECTRON TEMPERATURE (keV)'')')
!
!--------------  RETREIVE NUMERIC COEFFICIENTS
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(NCF .NE. 8 .AND. ERRMSG .EQ. ' ')&
          ERRMSG = 'INCORRECT NUMBER OF COEFFICIENTS'
     IF (ERRMSG .NE.  ' ') THEN
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
!--------------  READ PERCENTAGE UNCERTAINTY AND RANGE FOR EVALUATION
!
     CALL ALREVD_Z(PERUNC,XRANGE(1),XRANGE(2))
     IF (PERUNC .EQ. 0.0_fp) RETURN
!
     NRANGE=1
!
!--------------  GENERATE TABLE OF VALUES OF FUNCTION
!
     CALL ALTB1D_Z(PERUNC,ALMEWE_Z,NRANGE,XRANGE)
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#BELI') THEN
     WRITE(LUTOUT,&
          '(/'' ELECTRON IMPACT IONIZATION CROSS SECTION cm[2], '',&
          /'' AS FUNCTION OF ELECTRON ENERGY (eV)'')')
!
!--------------  RETREIVE NUMERIC COEFFICIENTS
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(NCF.EQ.0) THEN
        WRITE(LUTOUT,'(/'' NO FITTING PARAMETERS   EV FUNCTION TERMINATED'')' )
        RETURN
     ENDIF
     IF(ERRMSG .EQ. ' ') THEN
        WRITE(LUTOUT, '(/'' (INPUT VALID RANGE FROM THRESHOLD OF'',&
             1PE12.4, '' (eV) )'')') CF(1)
     ELSE
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
!--------------  READ PERCENTAGE UNCERTAINTY AND RANGE FOR EVALUATION
!
     CALL ALREVD_Z(PERUNC,ZX1,ZX2)
     IF (PERUNC .EQ. 0.0_fp) RETURN
!
!------      DEFINE EXTENT AND NUMBER OF INTERVALS FOR TABLE
!------ (SEE ROUTINE ALBELI FOR DETAILS OF INTERPRETATION OF PARAMETERS)
!
     XRANGE(1) = ZX1
     IF (NCF .GT. 7 ) THEN
        IF (ZX2 .LT. CF(8) .OR. ZX1 .GT. CF(8)) THEN
!
!------      RANGE ZX1 YTO ZX2 OUTSIDE OF AUTOIONIZATION THRESHOLD
!
           XRANGE(2) = ZX2
           NRANGE=1
        ELSE
!
!------      RANGE ZX1 YTO ZX2 BOUNDS THE AUTOIONIZATION THRESHOLD
!
           XRANGE(2) = CF(8)
           XRANGE(3) = ZX2
           NRANGE=2
        ENDIF
     ELSE
!
!------      NO AUTOIONIZATION STRUCTURE
!
        XRANGE(2) = ZX2
        NRANGE = 1
     ENDIF
!
!--------------  GENERATE TABLE OF VALUES OF FUNCTION
!
     CALL ALTB1D_Z(PERUNC,ALBELI_Z,NRANGE,XRANGE)
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#CHEB') THEN
     WRITE(LUTOUT,'(/'' ORNL:CFADC CHEBYSHEV POLYNOMIAL FIT'')' )
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
!
     IF(NCF .NE. 11 .AND. ERRMSG .EQ. ' ')&
          ERRMSG = 'INCORRECT NUMBER OF COEFFICIENTS'
     IF(ERRMSG .EQ. ' ') THEN
        WRITE(LUTOUT, '(/'' (INPUT VALID RANGE FROM'',&
             1PE10.2, '' TO'', 1PE10.2, '')'')' ) CF(10), CF(11)
     ELSE
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
     CALL ALREVD_Z(PERUNC,XRANGE(1),XRANGE(2))
     IF (PERUNC .EQ. 0.0_fp) RETURN
     NRANGE=1
!
     CALL ALTB1D_Z(PERUNC,ALCHEB_Z,NRANGE,XRANGE)
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#KINGEX') THEN
     WRITE(LUTOUT,&
          '(/'' POLYNOMIAL FIT OF EXCITATION RATE COEFFICIENT (cm3/s),'',&
          /'' AS FUNCTION OF ELECTRON TEMPERATURE (eV)'')')
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(ERRMSG .EQ. ' ') THEN
        WRITE(LUTOUT, '(/'' (INPUT VALID RANGE FROM'',&
             1PE12.4, '' TO'', 1PE12.4, '')'')' ) CF(2), CF(3)
     ELSE
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
     CALL ALREVD_Z(PERUNC,XRANGE(1),XRANGE(2))
     IF (PERUNC .EQ. 0.0_fp) RETURN
     NRANGE=1
!
     CALL ALTB1D_Z(PERUNC,ALKING_Z,NRANGE,XRANGE)
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#PHACX') THEN
     WRITE(LUTOUT,&
          '(/'' CHARGE EXCHANGE CROSS SECTION (cm[2]),'',&
          /'' AS FUNCTION OF PROJECTILE ENERGY (eV/amu)'')')
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(ERRMSG .NE. ' ') THEN
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
!-------   READ THE CHARGE STATE OF THE ION AND THEN DETERMINE THE
!-------   ENERGY RANGE OF VALIDITY FROM THE SCALED ENERGY
!
10   WRITE(LUTOUT, '(/'' INPUT THE CHARGE STATE OF THE ION,'',&
          '' (TO EXIT INPUT ,) ? '')' )
!
     INPTS = 0
     READ(LUTIN, *, IOSTAT=IOS) Q
     IF (Q .EQ. 0.0_fp ) RETURN
     IF (IOS .NE. 0) THEN
        WRITE(LUTOUT, '('' INVALID INPUT'')')
        GO TO 10
     ENDIF
!
!-------   THE SCALED CROSS SECTION APPLIES TO CHARGE STATES FROM
!-------   5 TO 26.
!
     IF(Q.LT.5.OR.Q.GT.26) THEN
        WRITE(LUTOUT,&
             '(/'' INVALID INPUT, THE CHARGE STATE (Q) MUST '',&
             ''BE A VALUE IN THE RANGE 5 <= Q <= 26 '')')
        GO TO 10
     ENDIF
!
!-------   PASS Q IN THE COEFFICIENT ARRAY TO EVALUATION FUNCTION
!-------   ALPHACX. THERE ARE SIX COEFFICIENTS FOR THESE ENTRIES
!
     CF(7) = Q
!
     ELOW = CF(1)*DSQRT(Q)
     EHIGH = CF(2)*DSQRT(Q)
     WRITE(LUTOUT, '(/'' (INPUT VALID RANGE FROM'',&
          1PE11.3, '' TO'', 1PE11.3, '' (eV/amu))'')' ) ELOW, EHIGH
!
     CALL ALREVD_Z(PERUNC,XRANGE(1),XRANGE(2))
     IF (PERUNC .EQ. 0.0_fp) RETURN
     NRANGE=1
!
     CALL ALTB1D_Z(PERUNC,ALPHACX_Z,NRANGE,XRANGE)
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#JAN1') THEN
     WRITE(LUTOUT,&
          '(/'' LOG(N) POLYNOMIAL FIT '')' )
!
     CALL ALRECF_Z(CF, NCF, NCFMX, ERRMSG)
     IF(NCF .NE. 11 .AND. ERRMSG .EQ. ' ')&
          ERRMSG = 'INCORRECT NUMBER OF COEFFICIENTS'
     IF(ERRMSG .EQ. ' ') THEN
        WRITE(LUTOUT, '(/'' (INPUT VALID RANGE FROM'',&
             1PE10.2, '' TO'', 1PE10.2, '')'')' ) CF(1), CF(2)
     ELSE
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!
     CALL ALREVD_Z(PERUNC,XRANGE(1),XRANGE(2))
     IF (PERUNC .EQ. 0.0_fp) RETURN
     NRANGE=1
!
     CALL ALTB1D_Z(PERUNC,ALJAN1_Z,NRANGE,XRANGE)
!
!------
!
  ELSE IF(BL(NBL) .EQ. '#'.AND. BL(1) .EQ. '$TABSPY') THEN
     WRITE(LUTOUT,&
          '(/'' SPUTTERING YIELDS (ATOMS/ION) OF MONATOMIC SOLIDS),'',&
          /'' AS FUNCTION OF INCIDENT ION ENERGY (eV)'')')
!
!------  THE INCIDENT ION AND TARGET PAIR MUST BE SPECIFIED
!
100  WRITE(LUTOUT,&
          '(/'' ENTER THE INCIDENT ION, TARGET PAIR '',&
          ''(WITH 2 CHARACTERS FOR EACH REACTANT)'',&
          /'' EXAMPLE H ,Cu  . (TO EXIT INPUT ,,) ? '')' )
!
     READ(LUTIN, '(A2,1X,A2)', IOSTAT=IOS) CION,CTARGT
     INPTS = 0
!
!------  CHECK RETURNED VALUES FOR THE INCIDENT ION AND TARGET
!
     IF (CION .EQ. ',,') RETURN
     IF (CION .EQ. ' ' .AND. CTARGT .EQ. ' ') RETURN
     IF(IOS .NE. 0 .OR. CION .EQ. ' ' .OR. CTARGT .EQ. ' ')  THEN
        WRITE(LUTOUT, '('' INVALID INPUT'')')
        GO TO 100
     ENDIF
!
!--  CALL RTABSQ TO READ DATA FOR CALCULATION OF SPUTTERING YIELDS
!--  CHECK THE TARGET, ION COMBINATION AND PASS BACK ARRAY CF FOR
!--  ROUTINE ETABSQ TO PRODUCE THE SPUTTERING YIELD.
!
     CALL RTABSQ_Z(CION,CTARGT,CF,ERRMSG)
     IF(ERRMSG .NE. ' ') THEN
        WRITE(LUTOUT, '(/1X,A)') ERRMSG
        RETURN
     ENDIF
!-----
!-----  DETERMINE AND PRINT THE THRESHOLD ENERGY FOR THE REACTION
!-----  (ROUNDED UP TO THE NEXT .1 EV).
!-----  CF(2) = ATOMIC MASS OF ION   CF(4) = ATOMIC MASS OF TARGET
!-----  CF(5) = SUBLIMATION ENERGY.
!
     GAMMA= 4.0_fp * CF(2)* CF(4) / (CF(2) + CF(4))**2.0_fp
     IF (CF(2) .GE. CF(4))    THEN
        ETH = (4.0_fp / 3.0_fp)**6.0_fp * CF(5) / GAMMA
     ELSE
        ETH = (CF(5) / GAMMA) *&
             ((2.0_fp * (CF(2) + CF(4))) / (CF(2) + 2.0_fp * CF(4)))**6.0_fp
     ENDIF
     ETH = ETH + 0.0999_fp 
     WRITE(LUTOUT, '(/'' (INPUT VALID RANGE FROM THRESHOLD OF'',&
          1PE10.2, '' (eV) )'')') ETH
!
     CALL ALREVD_Z(PERUNC,XRANGE(1),XRANGE(2))
     IF (PERUNC .EQ. 0.0_fp) RETURN
     NRANGE=1
!
     CALL ALTB1D_Z(PERUNC,ETABSQ_Z,NRANGE,XRANGE)
!
!------
!
!      OTHER EVALUATION LABELS GO HERE IN STRUCTURE OF THE FORM:
!
!      ELSE IF(BL(NBL) .EQ. '#{EVALUATION LABEL}') THEN
!             CALL {APPROPRIATE SUBROUTINE TO DO INTERACTIVE
!                    EVALUATION}
!
!      FOR 1-D DATA TYPES WITH SUBROUTINES IN PROPER FORM, ALTB1D CAN
!      BE USED TO CALL THE EVALUATION SUBROUTINE DIRECTLY BY NAME, WITH NO
!      NO SEPARATE ROUTINE NEEDED FOR ALEV TO INTERACT WITH THE
!      TERMINAL ETC.
!
!      IF ALTB1D CANNOT BE USED, THE TYPICAL STRUCTURE OF SUBROUTINE
!      CALLED BY ALEV FOR INTERACTIVE EVALUATION OF A DATA ENTRY CON
!      CONTAINS:
!
!          {CODING TO CONVERT COEFFICIENT FIELD AS REQUIRED}
!          {CODING TO OBTAIN REQUIRED INDEPENDENT VARIABLE(S) FOR THIS
!           DATA TYPE}
!          {CODING TO CALL EVALUATION FUNCTION SUBROUTINE}
!          {CODING TO OUTPUT RESULTING DATA POINT VALUE(S)}
!          {LOOP BACK FOR MORE EVALUATIONS OR RETURN}
!
!------
!
!          CATCH-ALL FOR ENTRIES WITH EVALUATION LABELS NOT CURRENTLY IN
!          THIS VERSION OF ALADDIN
!
  ELSE
     WRITE(LUTOUT,&
          '(/'' THIS EVALUATION LABEL CURRENTLY UNAVAILABLE'')')
!
!------
!
  ENDIF
!
  RETURN
END SUBROUTINE ALEV
!
SUBROUTINE ALTB1D_Z(PERUNC,EVSUB,NRANGE,XRANGE)
  use iso_c_binding, only: fp => c_double
  use alcom_mod
  implicit none
  EXTERNAL EVSUB
!
!     CONSTRUCT A LINEARLY INTERPOLABLE TABLE OF VALUES OF A FUNCTION
!     OF A SINGLE CONTINUOUS VARIABLE.
!
!     THE ROUTINE WILL CONSTRUCT A TABLE OF VALUES (X,Y) WHERE THE
!     TABULATED (X,Y) PAIRS WILL BE EXACTLY REPRODUCE THE FUNCTION
!     AND LINEAR INTERPOLATION BETWEEN THE TABULATED PAIRS WILL BE
!     WITHIN THE FRACTIONAL UNCERTAINTY (PERUNC).  THE FUNCTION CAN
!     BE DEFINED OVER A NUMBER OF X INTERVALS.
!
!     THE PASSED VARIABLE "EVSUB" IS THE NAME OF THE SUBROUTINE TO
!     TO EVALUATE THE DATA POINT.  THIS SUBROUTINE MUST HAVE AN
!     ARGUMENT LIST IN STANDARD FORM, AND USE TYPE REAL DOUBLE PRECISION
!     COEFFICIENTS, FOR ALTB1D TO BE USED.
!     OTHERWISE, A SEPARATE ROUTINE FOR THAT DATA TYPE WILL HAVE TO BE
!     TO BE WRITTEN.
!
!     THE PARAMETERS REQUIRED BY SUBROUTINE ALTB1D ARE:
!
!       PERCUNC = FRACTIONAL PERCENTAGE UNCERTAINTY FOR GENERATION OF
!                 THE TABLE.
!       EVSUB = NAME OF EVALUATION SUBROUTINE
!              THE REQUIRED FORM FOR AN EVALUATION SUBROUTINE CALLABLE
!              USING ALTB1D IS:
!
!           SUBROUTINE {EVSUB} (PX, PCF, KNCF, PY, KERMSG)
!
!             WHERE PX = INDEPENDENT VARIABLE
!             PCF = ARRAY OF REAL DOUBLE PRECISION COEFFICIENTS
!                   (E.G., ALEVID USES ALRECF)
!             KNCF = NUMBER OF COEFFICIENTS IN PCF
!             PY = RETURNED DOUBLE PRECISION VALUE CORRESPONDING TO PX
!             KERMSG = CHARACTER ARRAY RETURNING ERROR MESSAGE (BLANK =
!                      NO ERROR)
!       NRANGE  = NUMBER OF RANGES/INTERVALS USED IN REPRESENTING THE
!                 FUNCBTION
!       XRANGE  = ARRAY OF RANGES USED FOR FUNCTION WHERE THE RANGES ARE
!                 DEFINED AS
!
!                         XRANGE(1) TO XRANGE(2)   WITH NRANGE = 1
!                     AND XRANGE(2) TO XRANGE(3)   WITH NRANGE = 2 ETC
!
!      ON SUCCESFUL COMPLETION OF THE GENERATION OF THE LINEARLY
!      INTERPOLABLE TABLE THE NUMBER OF (X,Y) PAIRS REPRESENTING THE
!      FUNCTION IS OUTPUT. OTHERWISE EITHER CONVERGENCE HAS FAILED DUE
!      TO THE FUNCTIONAL  FORM OF THE EXPRESSION OR BECAUSE MORE THAN
!      THE MAXIMUM NUMBER OF POINTS IN A TABLE HAS BEEN EXCEDDED.
!
  CHARACTER*4, dimension(6) ::  KSIGN
  real(fp) XNOW,YNOW,XLAST,YLAST,XEND,&
       YEND,XMID,YMID,YLIN,XFINAL,YFINAL,PERUNC,&
       DX,DXSTEP,RATLST,RATNOW,XNOWL,DYMID,XNOW1,XNOW2,ALRND6
!
  real(fp) ZERO,HUNDRD,HALF,TEN,SMALLR,SMALLX
!
  real(fp) XRANGE(*)
  real(fp) XTAB(5000),YTAB(5000),XNORM(6),KEXP(6),&
       MARKER(5000)
  integer nrange, iptmax, maxlp1, maxlp2, kpt, irange, myway, ipt
  integer loop, npt, inow, jmin, jmax, itop, j, i
!
!------DEFINE DIMENSION OF TABLES (TO PREVENT MEMORY OVERFLOW)
!
  DATA IPTMAX/5000/
  DATA MAXLP1/20/
  DATA MAXLP2/40/
  DATA ZERO/0.0_fp/
  DATA HALF/5.0e-01_fp/
  DATA TEN/1.0e+01_fp/
  DATA HUNDRD/1.0e+02_fp/
  DATA SMALLR/9.99e-01_fp/
  DATA SMALLX/1.0e-07_fp/
!
!------INITIALIZE TOTAL POINT COUNT (ALL X REGIONS COMBINED).
!
  KPT=0
!
!          TREAT EACH X RANGE OF FUNCTION SEPARATELY.
!
  DO IRANGE=1,NRANGE
!
!------- DETERMINE FUNCTION AT START AN END OF INTERVAL
!
     XNOW=XRANGE(IRANGE)
     IF (IRANGE .NE. 1) XNOW = XNOW + (SMALLX * XNOW)
     CALL EVSUB (XNOW, CF, NCF, YNOW, ERRMSG)
     IF (ERRMSG .NE. ' ')       GO TO 370
     XEND=XRANGE(IRANGE+1)
     CALL EVSUB (XEND, CF, NCF, YEND, ERRMSG)
     IF (ERRMSG .NE. ' ')       GO TO 370
!
!          SELECT LINEAR OR LOG INTERVALS.
!
     IF(XNOW.LE.ZERO) GO TO 10
     IF(XEND.LT.TEN*XNOW) GO TO 10
!
!------LOG INTERVALS.
!
     MYWAY=2
     DXSTEP=DLOG(XEND/XNOW)/HUNDRD
     DXSTEP=DEXP(DXSTEP)
     XNOW1=ALRND6(XNOW*DXSTEP)
     GO TO 20
!
!------LINEAR INTERVALS.
!
10   MYWAY=1
     DXSTEP=(XEND-XNOW)/HUNDRD
     XNOW1=ALRND6(XNOW+DXSTEP)
!
!         START CONSTRUCTING TABLE.
!
!------INITIALIZE TABLE TO CONTAIN START OF INTERVAL.
!
20   IPT=1
     XTAB(IPT)=XNOW
     YTAB(IPT)=YNOW
     MARKER(IPT)=0
!
!------NO LINEARIZING IF ALLOWABLE ERROR IS NOT POSITIVE OR CURRENT
!------INTERVAL IS OF ZERO LENGTH.
!
     IF(PERUNC.GT.ZERO.AND.XEND.GT.XNOW) GO TO 30
     IPT=2
     XTAB(IPT)=XEND
     YTAB(IPT)=YEND
     MARKER(IPT)=1
     GO TO 240
!
!          START NEXT X INTERVAL.
!
!------DEFINE BEGINNING OF SUB-INTERVAL.
!
30   XLAST=XNOW
     YLAST=YNOW
!
!------INITIALIZE TABLE TO CONTAIN START OF INTERVAL.
!
     IF(XNOW.LT.XNOW1) GO TO 80
!
!------SAVE UNROUNDED VALUE TO SKIP VERY SHORT INTERVALS.
!
40   XNOWL=XNOW1
!
!------DEFINE END OF SUB-INTERVAL.
!
     IF(MYWAY.EQ.2) GO TO 50
!
!------LINEAR INTERVALS.
!
     XNOW1=ALRND6(XNOW1+DXSTEP)
     XNOW2=XNOW1+DXSTEP
!
!------SPECIAL TREATMENT FOR 0.0.
!
     IF(XLAST.LT.ZERO.AND.XNOW1.GT.ZERO) XNOW1=ZERO
     GO TO 60
!
!------LOG INTERVALS.
!
50   XNOW1=ALRND6(XNOW1*DXSTEP)
     XNOW2=XNOW1*DXSTEP
!
!------AVOID ROUNDOFF NEAR END OF INTERVAL.
!
60   IF(XNOW2.GE.XEND) GO TO 90
!
!------STOP AT END OF INTERVAL.
!
     IF(XNOW1.GE.XEND) GO TO 90
!
!------IGNORE INTERVALS THAT CANNOT BE SUB-DIVIDED AT LEAST ONCE.
!
     XMID=HALF*(XNOW1+XNOW)
     XMID=ALRND6(XMID)
     IF(XMID.LE.XNOW.OR.XMID.GE.XNOW1) GO TO 70
     GO TO 80
70   XNOW1=XNOWL+DXSTEP
     GO TO 40
80   XNOW=XNOW1
!
!------INITIALIZE COUNT OF NUMBER OF TIMES INTERVAL HAS BEEN SUB-DIVIDED
!
     LOOP=0
     IF(XNOW.LT.XEND) GO TO 100
90   XNOW=XEND
     YNOW=YEND
     XNOW1=XEND
     GO TO 110
100  CALL EVSUB (XNOW, CF, NCF, YNOW, ERRMSG)
     IF (ERRMSG .NE. ' ')       GO TO 370
!
!          SUB-DIVIDE INTERVAL AND CHECK FOR CONVERGENCE.
!
!------INCREMENT COUNT OF NUMBER OF TIMES INTERVAL HAS BEEN SUB-DIVIDED
!------AND CHECK FOR MAXIMUM NUMBER OF SUB-DIVISIONS.
!
110  LOOP=LOOP+1
     IF(LOOP.GT.MAXLP2) GO TO 150
!
!------COMPARE EXACT FUNCTION TO LINEAR INTERPOLATION OVER CURRENT
!------SUBINTERVAL.
!
     XMID=HALF*(XLAST+XNOW)
     XMID = ALRND6(XMID)
!
!------CHECK FOR MINIMUM X INTERVAL.
!
     IF(XMID.LE.XLAST.OR.XMID.GE.XNOW) GO TO 150
     CALL EVSUB (XMID, CF, NCF, YMID, ERRMSG)
     IF (ERRMSG .NE. ' ')  GO TO 370
     YLIN=((XMID-XLAST)*YNOW+(XNOW-XMID)*YLAST)/(XNOW-XLAST)
!
!------CHECK FOR CONVERGENCE.
!
     DYMID=YMID-YLIN
     IF(DABS(DYMID).LE.DABS(PERUNC*YMID)) GO TO 140
!
!------IF POSSIBLE SAVE CURRENT AND LAST RATIO AND CHECK TO SEE IF
!------METHOD IS CONVERGING.
!
     IF(YMID.EQ.ZERO) GO TO 130
     RATNOW=DABS((YMID-YLIN)/(PERUNC*YMID))
     IF(LOOP.LT.MAXLP1) GO TO 120
!
!------STOP SUB-DIVIDING IF METHOD IS NOT CONVERGING.
!
     IF(RATNOW.GE.SMALLR*RATLST) GO TO 150
120  RATLST=RATNOW
!
!------NO CONVERERENCE...HALF SUBINTERVAL AND CONTINUE.
!
130  XNOW=XMID
     YNOW=YMID
     GO TO 110
!
!------CONVERGENCE...SAVE MIDPOINT AND ENDPOINT FOR LATER THINNING.
!
140  IF(IPT.GE.IPTMAX) GO TO 170
     IPT=IPT+1
     XTAB(IPT)=XMID
     YTAB(IPT)=YMID
     MARKER(IPT)=0
     IF(IPT.GE.IPTMAX) GO TO 170
     IPT=IPT+1
     XTAB(IPT)=XNOW
     YTAB(IPT)=YNOW
     MARKER(IPT)=0
     GO TO 160
!
!------MINIMUM X INTERVAL OR MAXIMUM NUMBER OF SUB-DIVISIONS...SAVE
!------ENDPOINT AND MARK AS UNCONVERGED.
!
150  IF(IPT.GE.IPTMAX) GO TO 170
     IPT=IPT+1
     XTAB(IPT)=XNOW
     YTAB(IPT)=YNOW
     MARKER(IPT)=1
!
!------CONTINUE UNTIL END OF X INTERVAL.
!
160  IF(XNOW.LT.XEND) GO TO 30
     GO TO 180
!
!          OVER 5000 POINTS REQUIRED. SAVE END OF X RANGE AND INDICATE N
!          CONVERGENCE...TOO MANY POINTS REQUIRED.
!
170  XTAB(IPT)=XEND
     YTAB(IPT)=YEND
     MARKER(IPT)=2
!
!          THIN RESULTS.
!
!------INITIALIZE ORIGINAL POINT COUNT, FINAL POINT COUNT AND POINTE
!------BEGINNING OF THINNING INTERVAL.
!
180  NPT=IPT
     IPT=1
     INOW=1
!
!------DEFINE X AND Y AT BEGINNING OF THINNING INTERVAL.
!
190  XLAST=XTAB(INOW)
     YLAST=YTAB(INOW)
!
!------INITIALIZE THINNING INDICES TO TRY TO THIN 1 POINT ABOVE INOW
!
     JMIN=INOW+1
     JMAX=INOW+1
!
!------FINISHED IF NO MORE POINTS TO THIN.
!
200  IF(JMAX.GE.NPT) GO TO 230
!
!------SAVE POINT IF NO CONVERGENCE OR X = 0.0.
!
     IF(MARKER(JMAX).NE.0.OR.XTAB(JMAX).EQ.ZERO) GO TO 220
!
!------DEFINE INDEX TO END OF THINNING INTERVAL.
!
     ITOP=JMAX+1
!
!------DEFINE X AND Y AT END OF THINNING INTERVAL AND X INTERVAL.
!
     XNOW=XTAB(ITOP)
     YNOW=YTAB(ITOP)
     DX=XNOW-XLAST
!
!------SEE IF POINTS JMIN TO JMAX CAN BE APPROXIMATED BY LINEAR
!------INTERPOLATION BETWEEN ENDS OF THINNING INTERVAL.
!
     DO J=JMIN,JMAX
        XMID=XTAB(J)
        YMID=YTAB(J)
        YLIN=((XMID-XLAST)*YNOW+(XNOW-XMID)*YLAST)/DX
        IF(DABS(YMID-YLIN).GE.DABS(PERUNC*YMID)) GO TO 220
     enddo
!
!------CAN ELIMINATE ALL POINTS JMIN TO JMAX. INCREMENT JMAX AND TRY
!------ELIMINATE MORE POINTS.
!
     JMAX=JMAX+1
     GO TO 200
!
!------MUST KEEP POINT JMAX.
!
220  IPT=IPT+1
     XTAB(IPT)=XTAB(JMAX)
     YTAB(IPT)=YTAB(JMAX)
     MARKER(IPT)=MARKER(JMAX)
!
!------RESET INDEX TO RESTART THINNING AT JMAX
!
     INOW=JMAX
     GO TO 190
!
!------END OF THINNING SAVE LAST POINT.
!
230  IPT=IPT+1
     XTAB(IPT)=XTAB(NPT)
     YTAB(IPT)=YTAB(NPT)
     MARKER(IPT)=MARKER(NPT)
!
!          PRINT RESULTS AFTER THINNING
!
!------IGNORE FIRST POINT IF AT BOUNDARY BETWEEN X RANGES AND FUNCTION
!------IS CONTINUOUS.
!
240  NPT=1
     IF(IRANGE.EQ.1) GO TO 250
     IF(XTAB(1).EQ.XFINAL.AND.YTAB(1).EQ.YFINAL) NPT=2
!
!------OUTPUT TABULATED VALUES
!
250  DO I=NPT,IPT
!
!------INCREMENT TOTAL POINT COUNT AND CONVERT TO OUTPUT FORM.
!
        KPT=KPT+1
!
!     IF MARKER FOR THE INTERVAL LINEARISATION HAS FAILED A MESSAGE
!     IS DISPLAYED AMD LINEARISATION TERMINATED
!
        IF(MARKER(I).NE.0) GO TO 350
!
!------CONVERGENCE - WRITE DATA TO LUEF OR LUTOUT
!
        IF(EFNAME .NE. '**NONE**') THEN
           WRITE(LUEF,'(2(1PE12.5))') XTAB(I),YTAB(I)
        ELSE
           WRITE(LUTOUT,'(2(1PE12.5))') XTAB(I),YTAB(I)
        ENDIF
     enddo
!
!------SAVE VALUE FROM END OF X REGION (TO CHECK FOR DISCONTINUITY).
!
     XFINAL=XEND
     YFINAL=YEND
!
!------END OF RANGE.
!
  enddo !end DO IRANGE=1,NRANGE
!
!------LINEARIZING IS COMPLETED.
!
  WRITE(LUTOUT, '('' LINEAR DATA POINT SERIES  '', I4,&
       '' VALUES IN TABLE'')') KPT
  IF(EFNAME .NE. '**NONE**')&
       WRITE(LUEF, '(25X,'' LINEAR DATA POINT SERIES  '', I4,&
       '' VALUES IN TABLE'')') KPT
  RETURN
!
350 IF(MARKER(I).EQ.2) GO TO 360
!
!------NO CONVERGENCE.
!
  WRITE(LUTOUT,'(I6,(2(1PE12.5)),'' NO CONVERGENCE OF ALTB1D'')')&
       KPT,XTAB(J),YTAB(J)
!
  IF(EFNAME .NE. '**NONE**')&
       WRITE(LUEF,'(I6,(2(1PE12.5)),'' NO CONVERGENCE OF ALTB1D'')')&
       KPT,XTAB(J),YTAB(J)
  GO TO 380
!
!------TOO MANY POINTS.
!
360 WRITE(LUTOUT,'(I6,2(1PE12.5),&
         '' CONVERGENCE FAILED TOO MANY POINTS'')') KPT,XTAB(J),YTAB(J)
!
  IF(EFNAME .NE. '**NONE**')&
       WRITE(LUEF,'(I6,2(1PE12.5),&
       '' CONVERGENCE FAILED TOO MANY POINTS'')') KPT,XTAB(J),YTAB(J)
  GO TO 380
!
!------ PRINT FINAL ERROR MESSAGE ON LUTOUT
!
370 WRITE(LUTOUT,'('' LINEARISING TERMINATED : '',A)' ) ERRMSG
380 RETURN
END SUBROUTINE ALTB1D_Z
!
!####################################################################
!
SUBROUTINE ALREVD_Z(PERUNC,ZX1,ZX2)
!
  use iso_c_binding, only: fp => c_double
  use alcom_mod
  implicit none
!
  integer ios
  real(fp) PERUNC, ZX1, ZX2
!
  PERUNC=0.0_fp
!
!      READ DATA FOR FUNCTION EVALUATION
!
100 WRITE(LUTOUT,&
         '(/'' EV OUTPUT DATA CURRENTLY DIRECTED TO FILE: '', A,&
         /'' (TO CHANGE OUTPUT FILE, USE EF COMMAND AFTER'',&
         '' EXITING AT NEXT PROMPT)'')') EFNAME
!
!      DETERMINE VALUES OF INDEPENDENT VARIABLE TO BE EVALUATED
!
  WRITE(LUTOUT,&
       '(/''$LINEAR DATA POINT SERIES, INPUT  '')' )
!
  WRITE(LUTOUT,&
       '(/''$% UNCERTAINTY, FIRST, LAST VALUE (,,, TO EXIT) ? '')' )
  READ(LUTIN, *, IOSTAT=IOS) PERUNC, ZX1, ZX2
  IF (PERUNC .EQ. 0.0_fp) RETURN
  IF(IOS .NE. 0 .OR. PERUNC .LT. 0.0_fp&
       .OR. (PERUNC .GT. 0.0_fp .AND. ZX2 .LE. ZX1) ) THEN
     WRITE(LUTOUT, '('' INVALID INPUT'')')
     GO TO 100
  ENDIF
  PERUNC = PERUNC*0.01_fp
!
!          BEFORE DATA OUTPUT, WRITE APPROPRIATE HEADER LINE
!
  IF(EFNAME .NE. '**NONE**') THEN
     WRITE(LUTOUT, '('' ENTER HEADER LINE FOR THIS DATA ?'')')
     READ(LUTIN, '(A)') CMND
     WRITE(LUTOUT, '(1X,''DATA IS BEING WRITTEN TO   '',A)') EFNAME
     WRITE(LUEF, '(A)') CMND
  ENDIF
  RETURN
END SUBROUTINE ALREVD_Z
!
!####################################################################
!
real(fp) FUNCTION ALRND6(X)
!
!          ROUND NUMBER TO 6 DIGITS ACCURACY.
!
  use iso_c_binding, only: fp => c_double
  real(fp) X,ABSX,XR,OFFSET,ZERO,HALF,ONE,TEN
  DATA ZERO/0.0_fp/
  DATA HALF/5.0e-01_fp/
  DATA ONE/1.0e+00_fp/
  DATA TEN/1.0e+01_fp/
  DATA NMAX/1000000_fp/
!
!------AVOID TRYING TO TAKE THE LOG OF 0.0 OR NEGATIVE NUMBERS.
!
  ABSX=DABS(X)
  IF(ABSX.GT.ZERO) GO TO 10
  ALRND6=ZERO
  RETURN
!
!------DEFINE EXPONENT TO ROUND TO NORMAL FORM (1.00.. TO 9.99....).
!
10 I=DLOG10(ABSX)
  IF(ABSX.LT.ONE) I=I-1
!
!------ROUND TO 6 DIGIT INTEGER (TREAT -, 0 AND + EXPONENTS SEPARATE
!------TO AVOID ROUNDOFF WITH NEGATIVE POWERS OF 10..E.G., 10E-1 IS
!------A BINARY MULTIPLE).
!
  I=I-5
  IF(I) 20,40,60
!
!          NEGATIVE EXPONENT.
!
!------ROUND TO 6 DIGIT INTEGER.
!
20 OFFSET=TEN**(-I)
  N=ABSX*OFFSET+HALF
!
!------CHECK FOR CHANGE IN EXPONENT DUE TO ROUNDING.
!
  IF(N.LT.NMAX) GO TO 30
  OFFSET=OFFSET/TEN
  N=ABSX*OFFSET+HALF
!
!------CONVERT TO 6 DIGIT ACCURACY FLOATING POINT NUMBER AND RE-NORM
!
30 XR=N
  XR=XR/OFFSET
  GO TO 80
!
!          ZERO EXPONENT.
!
!------ROUND TO 6 DIGIT INTEGER.
!
40 OFFSET=ONE
  N=ABSX+HALF
!
!------CHECK FOR CHANGE IN EXPONENT DUE TO ROUNDING.
!
  IF(N.LT.NMAX) GO TO 50
  I=-1
  OFFSET=TEN
  N=ABSX/OFFSET+HALF
!
!------CONVERT TO 6 DIGIT ACCURACY FLOATING POINT NUMBER AND RE-NORM
!
50 XR=N
  XR=XR*OFFSET
  GO TO 80
!
!          POSITIVE EXPONENT.
!
!------ROUND TO 6 DIGIT INTEGER.
!
60 OFFSET=TEN**I
  N=ABSX/OFFSET+HALF
!
!------CHECK FOR CHANGE IN EXPONENT DUE TO ROUNDING.
!
  IF(N.LT.NMAX) GO TO 70
  OFFSET=TEN*OFFSET
  N=ABSX/OFFSET+HALF
!
!------CONVERT TO 6 DIGIT ACCURACY FLOATING POINT NUMBER AND RE-NORM
!
70 XR=N
  XR=XR*OFFSET
!
!------DEFINE SIGN OF RESULT.
!
80 IF(X.LT.ZERO) XR=-XR
  ALRND6=XR
  RETURN
END FUNCTION ALRND6

C******************** START FILE UDISP1.FOR ; GROUP UEDTS2 ******************
C===========================================================
C&  UDISP1   UREAD ROUTINE - DISPLAY SWITCH SETTINGS
C    D. MC CUNE   MAY 1980
C
C  DISPLAY SWITCH SETTING
C
C   INIT=0:  PRINT HEADING; OTHERWISE DONT
C   INUM     NUMBER IDENTIFYING SWITCH
C   AVAL     VALUE OF SWITCH
C   ALOCK    WHETHER OR NOT VALUE IS LOCKED
C   AUSE     "$" TERMINATED STRING DESCRIBING SWITCH
C
      SUBROUTINE UDISP1(INIT,INUM,AVAL,ALOCK,AUSE)
C
      USE USERIO
      CHARACTER*3 AVAL,ALOCK
      CHARACTER*50 AUSE
C
      IF(INIT.EQ.0) WRITE(LUNTRM,1001)
1001  FORMAT(/1X,'#  VALUE LOCK? USAGE'/
     >          1X,'-- ----- ----- ------------------------------')
      NCDISP=MIN0(50,(INDEX(AUSE,MDOLLR)-1))
      WRITE(LUNTRM,1002) INUM,AVAL,ALOCK,AUSE
 1002 FORMAT(1X,I2,1X,A3,3X,A3,3X,A)
      RETURN
      	END
C******************** END FILE UDISP1.FOR ; GROUP UEDTS2 ******************

C----------------------------------------------------------------------
C  URDPMB  RETURN CURRENT UREAD PROMPT MATCHING TEST CONTROLS
C
      SUBROUTINE URDPMB(IW1,IW2)
C
C RETURNED FROM COMMON:
C  IW1  -- NO. OF 1ST WORD TO CHECK
C  IW2  -- NO. OF LAST WORD TO CHECK
C   WHEN DOING PROMPT MATCH CHECKING
C
C SEE SUBROUTINE URDPMA TO RESET CONTROLS!
C
C THIS CALL SEQUENCE COULD BE USED TO TEMPORARILY DISABLE PROMPT
C MATCH CHECKING:
C
C  CALL URDPMB(IW1,IW2)
C  CALL URDPMA(0,0)       ! DISABLE PROMPT CHECKING
C   ...
C  CALL URDPMA(IW1,IW2)   ! RESTORE PROMPT CHECKING TO FORMER STATE
C
      USE USERIO
C
C------------------------------
C
      IW1=NCPRM(1)
      IW2=NCPRM(2)
C
      RETURN
      END

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SIGE_Z(E)
  use iso_c_binding, only: fp => c_double
  use csigma_mod
  IMPLICIT NONE
  real(fp) ::  e,b,fun,fbosch
  real(fp) ::  energy,einput,zs,add,e_input
  real(fp) ::  fdpc,fendf
!...This function is used to calculate the fusion cross section
!...after a call to sigma has been made.  The functional form of
!...the fusion cross sections is given in the paper by B. H. Duane
!...in BNWL-1685.  The value of the cross section is returned by
!...SIGE and has the units of m**2.
!
!---------------------------
!  MOD DMC 11 SEP 1991 -- SUPPORT BOSCH NEW BOSCH FITS.
!  SEE COMMENTS IN SUBROUTINE SIGMA (SIGMA.F90) FOR FULL EXPLANATION
!
!******************************************************************************
!
  IF(LBOSCH) THEN
!-----------------------
!  BEGINNING OF NEW BOSCH FIT CODE -- DMC 11 SEP 1991
!
     SIGE_Z=0.0_fp
     ENERGY=EFAC*E  ! CONVERT TO CTR OF MASS FRAME
!
     EINPUT=MIN(ENERGY,EHI)
     IF(EINPUT.GE.ELOW) THEN
        IF(EINPUT.LE.EMID) THEN
           ZS=FBOSCH(EINPUT,ALOW(1),ALOW(2),ALOW(3),ALOW(4),ALOW(5),&
                BLOW(1),BLOW(2),BLOW(3),BLOW(4))
        ELSE
           ZS=FBOSCH(EINPUT,AHI(1),AHI(2),AHI(3),AHI(4),AHI(5),&
                BHI(1),BHI(2),BHI(3),BHI(4))
        ENDIF
        IF(ENERGY.GT.EHI) ZS=ZS+SLOPE*(ENERGY-EHI)
        SIGE_Z=1.e-31_fp*(ZS*EXP(-BG/SQRT(ENERGY))/ENERGY)
     ENDIF
!
!  END OF NEW BOSCH FIT CODE
!-----------------------
  endif
  IF(LDPC) THEN
!  BEGINNING OF DPC FIT 06/2018
     SIGE_Z = 0.0_fp
     IF (E .GT. 1.e-3_fp) THEN
        EINPUT=E*FE
!...Note that the energy has been corrected for a possible reverse
!...reaction.
        ADD=BG/SQRT(EINPUT)
        B=EXP(-ADD)
        e_input=min(EINPUT,10000.0_fp*FE) !suggestion by David Coster, 07/09/2018
            ! The problem is that I (DC) have no data for the T-T cross-section beyond 10MeV, 
            ! and so can't work out what the S-function does beyond that.
            ! I suspect a workable solution would be not to extrapolate the S-function
            ! beyond 10 MeV but use its value at 10 MeV, but then apply the other
            ! factors after that ...
               
        ZS=FDPC(E_INPUT,AHI(1),AHI(2),AHI(3),AHI(4),AHI(5),AHI(6),&
             BHI(1),BHI(2),BHI(3),BHI(4),BHI(5))
        SIGE_Z=ZS*B/EINPUT*1.e-31_fp
     endif
  endif
  IF(LFUN) THEN
!-----------------------
!  BEGINNING OF OLD FIT CODE
     IF (E .GT. 1.e-3_fp) THEN
        ENERGY=E*FE*1.e+3_fp
!...Note that the energy has been corrected for a possible reverse
!...reaction.
        ADD=A1/SQRT(ENERGY)
!
        IF (ADD .LT. 87.5_fp) THEN
           B=EXP(-ADD)
           SIGE_Z=FUN(B,A2,A3,A4,A5,ENERGY)
!
           IF (SIGE_Z .GT. 1.e-10_fp) THEN
              SIGE_Z = SIGE_Z*1.e-28_fp
           ELSE
              SIGE_Z = 0.0_fp
           END IF
!     
        ELSE
           SIGE_Z = 0.0_fp
        END IF
!
     ELSE
        SIGE_Z = 0.0_fp
     END IF
!
!  END OF OLD FIT CODE
!-----------------------
  ENDIF
!
  RETURN
END FUNCTION SIGE_Z

!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

!
!  real*8 interface -- gyro-averaged beam-beam fusion
!
!  collection of functions for evaluating fusion reaction rate coefficients
!  <sigma*v> from pretabulated data
!
!  these are gyro-averages over pairs of contributing ptcls "df"
!  each characterized by energy E, and pitch (vpll/v), in the lab frame.
!
!  each contribution to a beam-beam fusion integral can be characterized
!  in terms of an average interaction energy and a variational fraction
!  between zero and one, between pairs of ptcls.  details are developed
!  in the commments below (copied from the old TRANSP BBNEUT package).
!
!  the "average energy" is A, the variational fraction is B/A, the latter
!  always between zero and one.
!
!C	THIS CALCULATES THE NEUTRON PRODUCTION FROM BEAM-BEAM
!C   COLLISION REACTIONS USING THE BEAM DISTRIBUTION FUNCTION
!C   WHICH IS A FUNCTION OF BEAM PARTICLE ENERGY AND PITCH
!C   ANGLE.  IT ALSO USES THE COLLISION CROSS-SECTION ALREADY
!C   INTEGRATED OVER PHASE ANGLE.  THE ARGUMENTS OF THIS
!C   FUNCTION ARE A = VP1**2 + VP2**2 + (VPAR2-VPAR1)**2 AND
!C   B = 2*VP1*VP2, WERE VP1 AND VP2 ARE THE PERPENDICULAR
!C   COMPONENTS OF THE FIRST AND SECOND PARTICLE VELOCITY AND
!C   VPAR1 AND VPAR2 ARE THE PARALLEL COMPONENTS.  THE DISTRIBU-
!C   TION FUNCTION MAY EQUIVALENTLY BE THOUGHT OF AS HAVING
!C   V**2 AND CHI AS ARGUMENTS INSTEAD OF E AND CHI.  IN THESE
!C   TERMS WE HAVE THE FOLLOWING
!C
!C	VP1**2 = V1**2(1 - CHI1**2)
!C	VPAR1 = V1*CHI1
!C
!C	VP2**2 = V2**2(1 - CHI2**2)
!C	VPAR2 = V2*CHI2
!C
!C	A = V1**2*(1-CHI1**2) + V2**2*(1-CHI2**2) +
!C		(V2*CHI2 - V1*CHI1)**2
!C   OR
!C	A = V1**2 + V2**2 - 2.0*V1*CHI1*V2*CHI2
!C
!C	B = 2*SQRT(V1**2*(1-CHI1**2)*V2**2*(1-CHI2**2) )
!C
!C   IN COMPUTING THE GYROPHASE INTEGRAL, E = A-B*COS(PHI), BUT
!C   FOR CONVENIENCE I HAVE USED  E = A*(1-BF*COS(PHI)) AND IT
!C   IS A AND BF WHICH ARE WRITTEN INTO THE DATA FILE WHERE
!C   BF VARIES FROM 0.0 TO 1.0.
!C   (A IS CALLED BBA IN TRANS.COM AND BF IS CALLED BBB)
!C
!C	For cases where the target and projectile species are different,
!C   there is a minor change in A, which is basically the kinetic energy
!C   of the projectile in the target's rest frame.  Let V1 be the velocity
!C   of the target in the lab frame, and let V2 be the velocity of the
!C   projectile in the lab frame.  Also let R = SQRT(m2/m1), where m1 and m2
!C   are the masses (atomic numbers) of the target and projectile species
!C   respectively.  Then, in the target's rest frame,
!C
!C	A = V2*V2 + R*V1*R*V1 - 2.0*R*V1*COS1*V2*COS2
!C
!C	B = 2.0*V1*R*SIN1*V2*SIN2
!C
!C   That is, we replace V1 by R*V1.  B is still an evenly spaced fraction.
!C
!
!  in all the routines, input arrays are the "A" energy eav(1:n), KeV
!  and the variational fraction "B/A", dimensionless, in fvar(1:n).
!  the answer(1:n) is returned in m**3/sec
!
!-----------------------------------------------------
subroutine fusn_bbsigv_DDp(eav,fvar,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: eav(n),fvar(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_gyroavg_sigmatimesv(Lfs_DDp, eav, fvar, answer, n)
 
end subroutine fusn_bbsigv_DDp
!-----------------------------------------------------
subroutine fusn_bbsigv_DDn(eav,fvar,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: eav(n),fvar(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_gyroavg_sigmatimesv(Lfs_DDn, eav, fvar, answer, n)
 
end subroutine fusn_bbsigv_DDn
!-----------------------------------------------------
subroutine fusn_bbsigv_TT(eav,fvar,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: eav(n),fvar(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_gyroavg_sigmatimesv(Lfs_TT, eav, fvar, answer, n)
 
end subroutine fusn_bbsigv_TT
!-----------------------------------------------------
subroutine fusn_bbsigv_dpcTT(eav,fvar,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: eav(n),fvar(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_gyroavg_sigmatimesv(Lfs_dpcTT, eav, fvar, answer, n)
 
end subroutine fusn_bbsigv_dpcTT
!-----------------------------------------------------
subroutine fusn_bbsigv_DT(eav,fvar,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: eav(n),fvar(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_gyroavg_sigmatimesv(Lfs_DT, eav, fvar, answer, n)
 
end subroutine fusn_bbsigv_DT
!-----------------------------------------------------
subroutine fusn_bbsigv_D3(eav,fvar,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: eav(n),fvar(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_gyroavg_sigmatimesv(Lfs_D3, eav, fvar, answer, n)
 
end subroutine fusn_bbsigv_D3
!-----------------------------------------------------
subroutine fusn_bbsigv_T3(eav,fvar,answer,n)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: n
  real*8, intent(in) :: eav(n),fvar(n)
  real*8, intent(out) :: answer(n)
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  call fs_gyroavg_sigmatimesv(Lfs_T3, eav, fvar, answer, n)
 
end subroutine fusn_bbsigv_T3

C******************** START FILE URSTAT.FOR ; GROUP URDUTS ******************
C---------------------------------------------
C&  URSTAT  UREAD STATUS SUMMARY DISPLAY ON TERMINAL
C
      SUBROUTINE URSTAT
C
      USE USERIO
C
      CHARACTER*7 ZMODE(2)
      DATA ZMODE/'COMMAND','TEXT   '/
      CHARACTER*8 UCNTRL
      LOGICAL ILNHLD,ILPMMR
C
      CALL NEUPAG
C
      CALL URCSTR(UCNTRL)
C
      ILPMMR=.TRUE.
      IF(LPMMSG.NE.1) ILPMMR=.FALSE.
      ILNHLD=.NOT.NLHOLD
C
      WRITE(LUNTRM,1000) ZMODE(max(1,LEVCMD)),ILNHLD,NLXPER,NLECHO,
     >     ILPMMR,MAXLIN,LUNTRM,LUNTIN(2),LUNTIN(MAXLIN)
 1000 FORMAT(/' UREAD STATUS:'/
     >' INPUT MODE: ',A7,T40,' TYPEAHEAD ENABLE: ',L1/
     >' EXPERT MODE: ',L1,T40,' ECHO/DEBUG MODE: ',L1/
     >' PROMPT MISMATCH ERROR REPORTING: ',L1/
     >' MAXIMUM NO. OF I/O CHANNELS: ',I2,T40,' TTY CHANNEL (LUN):',I2/
     >' FIRST UREAD FILE LUN: ',I2,T40,' LAST UREAD FILE LUN: ',I2/
     >)
C
      CALL UTRACE
C
      RETURN
      END
C******************** END FILE URSTAT.FOR ; GROUP URDUTS ******************

C******************** START FILE UFSNMD.FOR ; GROUP UFILES *************
C------------------------------------------------------------
C  UFGETR  -- RETURN THE PARTS OF A UFILES FILENAME
C
      SUBROUTINE UFGETR(LUNF,ZPRE,ZEXT,ZDEVI,ZFDIR,ILSHOT,IER)
C
      USE UFILES
C
C  INPUT:
      INTEGER LUNF
C  LUNF -- UFILES LOGICAL UNIT NUMBER-- UFSETR NEEDS TO HAVE BEEN CALLED
C    also, UFNSHO should have been called first
C
C  OUTPUT (READ FROM UFILES COMMON):
      CHARACTER*(*) ZPRE  ! FILENAME PREFIX
      CHARACTER*(*) ZEXT  ! FILENAME .EXT SUFFIX
      CHARACTER*(*) ZDEVI ! ASSOCIATED DISK DEVICE
      CHARACTER*(*) ZFDIR ! ASSOCIATED DIRECTORY NAME
      LOGICAL ILSHOT      ! .TRUE. IF SHOT NO. IS EXPECTED TO COMPLETE
C                           ! THE FILENAME
C  OUTPUT (ERROR SIGNAL):
      INTEGER IER         ! =0 MEANS SUCCESS
C
C-----------------------------------------------------------------------
C
      CALL UFINIT
      IER=0
      CALL UFLCHK(LUNF,'UFGETR    ',ICHAN,IER)
      IF(IER.NE.0) RETURN
C
      ILSHOT=LSHOTN(ICHAN)
C
      ZPRE=UPRFIX(ICHAN)
      ZEXT=UEXTND(ICHAN)
      ZDEVI=UDEV(ICHAN)
      ZFDIR=UFDIR(ICHAN)
C
      RETURN
      END
C******************** END FILE UFSNMD.FOR ; GROUP UFILES ***************

C******************** START FILE UFSTEP.FOR ; GROUP UFCMPR *************
C-----------------------------------------------------------------------
C  UFSTEP
C
C  OUTPUT DEPENDENT VARIABLE AS START AND STEP SIZE IF POSSIBLE
C
      SUBROUTINE UFSTEP(ILUN,ARRAY,ANAME,NAR,IERR)
C
C  ILUN-- LOGICAL UNIT NUMBER ON WHICH TO WRITE
C  ARRAY-- 1D ARRAY CONTAINING DATA TO BE COMPRESSED AND WRITTEN
C  ANAME-- TEXT IDENTIFYING ARRAY (X,Y,F)
C  NAR--   NUMBER OF VALUES IN ARRAY
C  IERR--  RETURNED ERROR CODE; 0 IF OK
C
      REAL*4 ARRAY(*)
      CHARACTER*1 ANAME
C
C  DUMMY FLAG (FOR POSSIBLE FUTURE USE IN FILE)
C
      DATA IDUMF/0/
C
      IF(NAR.LE.1) GO TO 110
C
      ZSTART = ARRAY(1)
      ZDELT = (ARRAY(NAR) - ZSTART)/(NAR-1)
      IF(ABS(ZDELT).LT.1.E-34) GO TO 110
C
      DO II=2,NAR
        ATEST = ABS(1.0 - (ARRAY(II)-ARRAY(II-1))/ZDELT)
        IF(ATEST .GT. 1.5E-3) GO TO 110
      ENDDO
C
CX	WRITE(ILUN,3012) ZSTART,ZDELT,ANAME
CX 3012	FORMAT(1X,2(E14.7),T32,';-START, DELTA FOR ',A)
      WRITE(ILUN) ZSTART,ZDELT,IDUMF
C
      ICOMP = 0
      IWRDS = 2
CX	WRITE(ILUN,3014) ICOMP, IWRDS,IDUMF
CX 3014	FORMAT(1X,2I10,T32,';-FLAG INDICATING VALUES ARE START AND DELTA')
      WRITE(ILUN) ICOMP,IWRDS,IDUMF
C
      IERR = 0
      RETURN
C
 110  IERR = 1
      RETURN
      END
C******************** END FILE UFSTEP.FOR ; GROUP UFCMPR ***************

!------------------------------------------------------------------------------
!  ALAD_EVXY_Z  -- EVALUATE ALADDIN FUNCTION ON ARRAY OF PTS
!
SUBROUTINE ALAD_EVXY_Z(EVSUB,ZX,ZY,INUM)
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use alpcom_mod
  use alcom_mod
  IMPLICIT NONE
  INTEGER inum,i
!============
  EXTERNAL EVSUB   ! EVALUATION ROUTINE
!
  real(fp) ZX(INUM)    ! INDEP. COORDS (INPUT)
  real(fp) ZY(INUM)    ! RESULTS (OUTPUT)
!
  real(fp) ZZX,ZZY
!
  CHARACTER*80 ZERMSG
!------------------------------------------------------------------------------
!
  ZERMSG=' '
!
  DO I=1,INUM
!
     ZZX=ZX(I)
!
     CALL EVSUB(ZZX,CF,NCF,ZZY,ERRMSG)
!
     IF(ERRMSG.EQ.' ') THEN
        ZY(I)=ZZY
     ELSE
        IF(ERRMSG.NE.ZERMSG) THEN
           WRITE(LUTOUT,1001) ZX(I),ERRMSG
1001       FORMAT(' ALAD_EVXY_Z @X=',1PE11.4,': EVSUB MSG:  ',A)
        ENDIF
        ZY(I)=0.0_fp
        ZERMSG=ERRMSG
     ENDIF
  enddo
!
  RETURN
END SUBROUTINE ALAD_EVXY_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C-----------------------------------------------------------------------
C  GRADUM -- DUMMY GRAOPT CONTROL SUBROUTINE
C    THIS SUBROUTINE IS PASSED AS AN ADDRESS BY MOST GRAOPT CALLERS
C    IT SHOULDN'T REALLY BE CALLED -- BUT IT COMPLETES THE GRAOPT
C    ARGUMENT LIST
C
      SUBROUTINE GRADUM(ICALL,CTRL,IOPCOD)
C
      CHARACTER*(*) CTRL
C
C-----------------------------------------------------------------------
C
      LUNTRM=LNOUT(0)
      IL=MIN0(40,LEN(CTRL))
      WRITE(LUNTRM,9901) ICALL,CTRL(1:IL)
 9901 FORMAT(/' ?? PROGRAMMING ERROR:  IMPROPER CALL TO GRADUM'/
     >    '    ICALL=',I20/'    CTRL="',A,'"'/)
C
      RETURN
      END

C******************** START FILE USPLOC.FOR ; GROUP USPARM ******************
C===============================================================
C&  USPLOC  LOCATE TYPE AND # OF UREAD STRING PARAMETER, GIVEN NAME
C    ARGS:
C    ZNAME:  16 CHAR. LEFT-JUSTIFIED PARAMETER NAME
C    ITYPE:  (OUTPUT) PARAMETER TYPE:
C           =0:  PARAMETER NOT RECOGNIZED
C           =1:  LOCAL PARAMETER (@CURRENT LEVEL)
C           =2:  GLOBAL PARAMETER
C    INUM:   (OUTPUT) PARAMETER INDEX:
C           =0 IF PARAMETER NOT FOUND
C
      SUBROUTINE USPLOC(ZNAME,ITYPE,INUM)
C
      USE USERIO
      CHARACTER*16 ZNAME
C
      CALL USPCAP(ZNAME)
      ITYPE=0
      INUM=0
C
C  CHECK LOCAL PARAMETERS
C
      NP=NPLC(MAX0(NLUNIN,NLUNIO))
      DO 10 J=1,NP
        IF(ZNAME.EQ.PLCNAM(J,MAX0(NLUNIN,NLUNIO))) GO TO 20
 10   CONTINUE
      GO TO 50
C  FOUND
 20   CONTINUE
      ITYPE=1
      INUM=J
      RETURN
C
C  CHECK GLOBAL PARAMETERS
C
 50   CONTINUE
      NP=NPGC
      DO 60 J=1,NP
        IF(ZNAME.EQ.PGLNAM(J)) GO TO 70
 60   CONTINUE
      GO TO 100
C  FOUND
 70   CONTINUE
      ITYPE=2
      INUM=J
      RETURN
C  NOT FOUND
 100  CONTINUE
      RETURN
C
      	END
C******************** END FILE USPLOC.FOR ; GROUP USPARM ******************

      subroutine ubwchcmp(ilun,zchar)
C
C  buffer input string for eventual compression and output
C    error if string is too long for empty buffer;
C    if string exceeds partially full buffer, flush buffer and
C    try again.
C
C  buffer consists of byte sequence: <string><del><string><del>...
C    input string is expected to be one line of printable data; all
C    control characters (except ^I, tab) will be suppressed; trailing
C    blanks are suppressed.  <del> = ascii(127).
C
      use UFILES
C
      character*(*) zchar
C
#include "fpreproc/byte_declare.h"
      byte_declare ibyte
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
      integer iz
c
C-----------------------------------------------------
C
      CALL UFLCHK(ILUN,'ubwchar   ',ICHAN,IER)
      IF(IER.NE.0) go to 999
C
C  determine length of input string, not counting trailing blanks
C
      ilen=len(zchar)
      do i=ilen,1,-1
#ifdef __CRAY
         iz=ichar(zchar(i:i))
         if(iz.ne.127) then
            if((iz.eq.9).or.(iz.gt.32)) go to 10
#else
         ibyte=ichar(zchar(i:i))
         if(ibyte.ne.127) then
            if((ibyte.eq.9).or.(ibyte.gt.32)) go to 10
#endif
         endif
      enddo
C
      i=0
 10   continue
      ilenb=i+1    ! allow for the 127 = string terminator
C
      if(ilenb.gt.UFCBUF) then
         write(6,'('' ?ubwchcmp:  input string exceeds buffer size'')')
         go to 999
      endif
C
      if(ilenb+nchbuf(ichan).gt.ufcbuf) then
         call ubcflush(ichan)     ! flush buffer
      endif
C
C  copy the string
C
      do i=1,ilenb-1
#ifdef __CRAY
         iz=ichar(zchar(i:i))
         if(iz.eq.127) iz=32
         if((iz.ne.9).and.(iz.lt.32)) iz=32
         ia=nchbuf(ichan)+i
         uchbuf(ia,ichan)=char(iz)
      enddo
C  terminating character (ascii code 127):
      ia=nchbuf(ichan)+ilenb
      uchbuf(ia,ichan)=char(127)
#else
         ibyte=ichar(zchar(i:i))
         if(ibyte.eq.127) ibyte=32
         if((ibyte.ne.9).and.(ibyte.lt.32)) ibyte=32
         ia=nchbuf(ichan)+i
         uchbuf(ia,ichan)=ibyte
      enddo
C  terminating character (ascii code 127):
      ia=nchbuf(ichan)+ilenb
      uchbuf(ia,ichan)=127
#endif
C
C  this much of buffer now in use:
      nchbuf(ichan)=ia
C
      go to 1000
C
 999  continue
C
 1000 continue
      return
      end

C******************** START FILE CONRDF.FOR ; GROUP CONCTR *************
C=============================================================
C  SUBROUTINE CONRDF
C    D. MC CUNE  22 MAY 1980
C
C  REDEFINE CONTROLS FOR CONTOUR PLOT
C
      SUBROUTINE CONRDF(X,Z,Y,NX,NZ1,NY,ITYPX,ITYPY,
     >         XLAB,XUN,YLAB,YUN,ZUN,NLZMMX,
     >     XMIN,XMAX,CMIN,CMAX,YMIN,YMAX,NCTRY,ILOGC,
     >     ZCNTR1,ZWRK,NCMAX0)
C
      CHARACTER*(*) XLAB,YLAB,XUN,YUN,ZUN
      DIMENSION X(NX),Z(NZ1,NY),Y(NY),ZCNTR1(NCMAX0),ZWRK(NCMAX0)
      LOGICAL NLZMMX
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LYESC
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C---------------------------
C
      LUNTRM=LNOUT(0)
 1001 CONTINUE
C
      CALL NEUPAG
      IF(LXOUT(0)) WRITE(LUNTRM,3001) XLAB,XUN,YLAB,YUN,ZUN,
     >   XMIN,XMAX,YMIN,YMAX,CMIN,CMAX
 3001 FORMAT(/'  "XMIN, XMAX" ARE IN ',A,'; UNITS:  ',A/
     >          '  "YMIN, YMAX" ARE IN ',A,'; UNITS:  ',A/
     >  '  "CMIN, CMAX" ARE CONTOUR LIMITS IN FUNCTION UNITS:  ',A/
     > /'  XMIN, XMAX = ',2(1PE11.4,1X)/
     >  '  YMIN, YMAX = ',2(1PE11.4,1X)/
     >  '  CMIN, CMAX = ',2(1PE11.4,1X)/
     > /'  >>> ENTER "X" NOT TO CHANGE THE VALUE OF A VARIABLE'/)
C
 321  CALL UREAD(' SUB:CONRDF >> ENTER NEW XMIN:$')
      IERT=0
      if(lchar('Q')) return
      ZMIN=XMIN
      IF(.NOT.LCHAR('X')) ZMIN=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 321
C
 322  CALL UREAD(' SUB:CONRDF >> ENTER NEW XMAX:$')
      IERT=0
      if(lchar('Q')) goto 1001
      ZMAX=XMAX
      IF(.NOT.LCHAR('X')) ZMAX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 322
C
      CALL SPREDM(ZMIN,ZMAX,XMIN,XMAX)
C
 323  CALL UREAD(' SUB:CONRDF >> ENTER NEW YMIN:$')
      IERT=0
      if(lchar('Q')) goto 1001
      ZMIN=YMIN
      IF(.NOT.LCHAR('X')) ZMIN=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 323
C
 324  CALL UREAD(' SUB:CONRDF >> ENTER NEW YMAX:$')
      IERT=0
      if(lchar('Q')) goto 1001
      ZMAX=YMAX
      IF(.NOT.LCHAR('X')) ZMAX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 324
C
      CALL SPREDM(ZMIN,ZMAX,YMIN,YMAX)
C
 325  CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,3003)
 3003 FORMAT(' *ENTER "L" TO ENTER LIST OF CONTOUR VALUES FOR PLOT')
      CALL UREAD(' SUB:CONRDF >> ENTER NEW CMIN:$')
      IERT=0
      IF(LCHAR('L')) GOTO 330
      IF(LCHAR('Q')) GOTO 1001
      ZMIN=CMIN
      IF(LCHAR('X')) GO TO 326
      ZMIN=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 325
      NLZMMX=.FALSE.
C
 326  CALL UREAD(' SUB:CONRDF >> ENTER NEW CMAX:$')
      IERT=0
      IF(LCHAR('L')) GOTO 330
      IF(LCHAR('Q')) GOTO 1001
      ZMAX=CMAX
      IF(LCHAR('X')) GO TO 327
      ZMAX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 326
      CMAX=ZMAX
      NLZMMX=.FALSE.
C
 327  CONTINUE
      IF(NLZMMX) GO TO 328
      CALL SPREDM(ZMIN,ZMAX,CMIN,CMAX)
      ZDC=CMAX-CMIN
      CMAX=CMAX+.0001*ZDC
      CMIN=CMIN-.0001*ZDC
      GO TO 328
C
C  GET USER LIST OF CONTOUR VALUES
 330  CONTINUE
      CMIN=0.0
      CMAX=0.0
      IRET=0
      CALL INORD(ZCNTR1,ZWRK,NCMAX0,IRET,'CONTOUR TEST VALUES',0)
      IF(IRET.EQ.0) GO TO 325
      NCTRY=IRET
      NLZMMX=.FALSE.
C
 328  CONTINUE
      IF((CMIN.NE.0.0).OR.(CMAX.NE.0.0)) THEN
        CALL UREAD(
     >	  ' SUB:CONRDF >> ENTER "Y" FOR LOG-SPACING OF CONTOURS:$')
        IF(LCHAR('Q')) RETURN
        IF(.NOT.LCHAR('X')) THEN
          ILOGC=1
          IF(LYESC('Y')) ILOGC=2
        ENDIF
      ENDIF
C
      ILMIN=2
      ILMAX=NCMAX0
 320  CONTINUE
      IF((CMIN.NE.0.0).OR.(CMAX.NE.0.0)) THEN
        IF(LXOUT(0)) WRITE(LUNTRM,2021) ILMIN,ILMAX,NCTRY
 2021   FORMAT(/' PROGRAM''S MIN # OF CONTOURS =',I3/
     >		  ' PROGRAM''S MAX # OF CONTOURS =',I3/
     >		  ' CURRENT    MAX # OF CONTOURS =',I3)
        CALL UREAD(
     >	  ' SUB:CONRDF >> ENTER MAX # OF CONTOURS YOU WANT TO SEE:$')
        ICTRY=NCTRY
        IERT=0
        IF(LCHAR('Q')) RETURN
        IF(.NOT.LCHAR('X')) ICTRY=IDCOD(IERT)
        IF(IERT.NE.0) GO TO 320
        IF(ICTRY.LT.ILMIN) GO TO 320
        ICTRY=MIN(ILMAX,ICTRY)
        NCTRY=ICTRY
      ENDIF
C
      IF(.NOT.NLZMMX) GO TO 121
      IFND=0
C
      DO 120 IY=1,NY
        IF((Y(IY).LT.YMIN).OR.(Y(IY).GT.YMAX)) GO TO 120
        DO 119 IX=1,NX
          IF((X(IX).LT.XMIN).OR.(X(IX).GT.XMAX)) GO TO 119
          IFND=IFND+1
          IF(IFND.EQ.1) CMIN=Z(IX,IY)
          IF(IFND.EQ.1) CMAX=Z(IX,IY)
          CMIN=AMIN1(CMIN,Z(IX,IY))
          CMAX=AMAX1(CMAX,Z(IX,IY))
 119    CONTINUE
 120  CONTINUE
C
      CALL SPREDM(CMIN,CMAX,CMIN,CMAX)
C
C  AXES TYPES
 121  CONTINUE
 282  CONTINUE
      CALL NEUPAG
      IF(LXOUT(0)) WRITE(LUNTRM,2025) ITYPX,ITYPY
 2025 FORMAT(/' AXES TYPE CODES: 1-- LINEAR, 2-- LOG'/
     >  ' CURRENT SETTINGS:  X AXIS:  ',I1/
     >  '                    Y AXIS:  ',I1/)
C
 283  CALL UREAD(
     >  ' SUB:CONCTR >> ENTER NEW X AXIS TYPE:$')
      IF(LCHAR('Q')) RETURN
      IF(LCHAR('X')) GO TO 284
      IANS=IDCOD(IERT)
      CALL UCHKOP(IANS,IERT,1,2,1,*282)
      ITYPX=IANS
C
 284  CALL UREAD(
     >  ' SUB:CONCTR >> ENTER NEW Y AXIS TYPE:$')
      IF(LCHAR('Q')) RETURN
      IF(LCHAR('X')) GO TO 289
      IANS=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 284
      IF((IANS.LE.0).OR.(IANS.GT.2)) GO TO 284
      ITYPY=IANS
 289  CONTINUE
C
      RETURN
      	END
C******************** END FILE CONRDF.FOR ; GROUP CONCTR ***************

C******************** START FILE UTRACE.FOR ; GROUP URDUTS ******************
C=============================================
C&  UTRACE  UREAD INDIRECT INPUT FILE RECORD TRACEBACK AFTER ERROR
C       D. MC CUNE MAY 8 1980
C   PROVIDE TRACEBACK ON INDIRECT FILES AFTER ERROR
C
C  INPUT:  UREAD COMMON
C
C   OUTPUT:  TRACEBACK TABLE ON UNIT LUNTRM
C
C
      SUBROUTINE UTRACE
C
      USE USERIO
C
      WRITE(LUNTRM,1001)
 1001 FORMAT(/' UREAD SUBROUTINE UTRACE ** INDIRECT FILES TRACEBACK'/
     >  ' FILENAME                   RECORD COUNT')
        IMAX=MAX0(NLUNIN,NLUNIO)
        DO 10 J=IMAX,1,-1
          IF(J.EQ.IMAX) THEN
            CALL UTRAHD(CBUFF(2:LBUFF))
          ELSE
            CALL UTRAHD(AHDBUF(J))
          ENDIF
C
          ILFILN=INDEX(XFILE(J),' ')-1
          IF(ILFILN.LE.0) ILFILN=LFILN
C
          IF(J.GT.NLUNIO) THEN
            IF(ILFILN.LE.30) THEN
              WRITE(LUNTRM,1002) XFILE(J),NCMND(J)
            ELSE
      	WRITE(LUNTRM,1012) XFILE(J),NCMND(J)
            ENDIF
 1002 FORMAT(1X,A,T32,I4,1X,' @INPUT FILE CALLED FROM:')
 1012 FORMAT(1X,A/T32,I4,1X,' @INPUT FILE CALLED FROM:')
          ELSE IF(J.GT.1) THEN
            IF(ILFILN.LE.30) THEN
              WRITE(LUNTRM,1003) XFILE(J),NCMND(J)
            ELSE
      	WRITE(LUNTRM,1013) XFILE(J),NCMND(J)
            ENDIF
 1003 FORMAT(1X,A,T32,I4,1X,' >OUTPUT FILE CALLED FROM:')
 1013 FORMAT(1X,A/1X,T32,I4,1X,' >OUTPUT FILE CALLED FROM:')
          ELSE
            IF(ILFILN.LE.30) THEN
              WRITE(LUNTRM,1004) XFILE(J),NCMND(J)
            ELSE
      	WRITE(LUNTRM,1014) XFILE(J),NCMND(J)
            ENDIF
 1004 FORMAT(1X,A,T32,I4)
 1014   FORMAT(1X,A/1X,T32,I4)
          ENDIF
 10     CONTINUE
      RETURN
      	END
C******************** END FILE UTRACE.FOR ; GROUP URDUTS ******************

subroutine plot_fp_ei(n1,tvec1,fvec1)

  ! plot EI data from fpreact
  use iso_c_binding, only: fp => c_double
  use adas_mod, only : adas_sigvte_ioniz
  use fpreact_parameters

  implicit NONE

  ! data buffers -- uninitialized!

  integer, intent(in) :: n1     ! dimension info

  real(fp) :: fvec1(n1)             ! for f(T) plot
  real(fp) :: fvec1_adas(n1)             ! for f(T) plot
  real(fp) :: tvec1(n1)             ! T-vector for f(T) plot
 !----------------------------------
  integer luntrm,lnout
  logical lxout,lchar

  integer izneut,ihandle,idum1,idum2,ierr

  real(fp) :: trange1,trange2

  character*60 zlbl1,zlbl2,zlbl3

  !----------------------------------

  zlbl1='preact/fpreact "EI" database'
  zlbl2='Maxwellian averaged <sigma*v>'

  luntrm=lnout(0)
  write(luntrm,1001)
1001 format(/ &
          'plot of electron-impact ionization of selected neutral specie'/ &
          'as a function of electron temperature (hit "," to exit)'/)

  if(lxout(0)) write(luntrm,*) &
       ' A -- ADAS [sigma*v](E/A,T/A,Ne) impurity stopping rate coefficient' 
  if(lxout(0)) write(luntrm,*) &
       ' P -- PREACT [sigma*v](E/A) impurity stopping rate coefficient' 
  if(lxout(0)) write(luntrm,*) &
       ' C -- COMPARE ADAS and PREACT impurity stopping rate coefficient' 
  if(lxout(0)) write(luntrm,*) &
       ' X -- ADAS/Excited state [sigma*v](E/A,T/A,Ne) impurity stopping rate coefficient' 
  if(lxout(0)) write(luntrm,*) &
       ' hit "," to exit' 
  call uread('select option:$')

  if(lchar('P')) then !PREACT DATA
     zlbl1='PREACT "EI" database'
     do
        izneut=0
        call ureadi('select neutral specie: 1 for H, 2 for He:$',izneut)
        if(izneut.eq.0) exit

        izneut=max(1,min(2,izneut))
      
        call sigvte_ioniz_handle(izneut,ihandle)
        call ei_sigvte_trange(ihandle,trange1,trange2,idum1,idum2)

        call plot_fp_mkvec(trange1,trange2,n1,tvec1)

        call sigvte_ioniz(izneut,tvec1,n1,fvec1)

        if(izneut.eq.fpreact_Z_H) then
           zlbl3='ionization of H0 by e- impact, vs. Te(KeV)'
        else
           zlbl3='ionization of He0 by e- impact, vs. Te(KeV)'
        endif

        call gaxspc(3) ! log-log
        call r8_grafx1(tvec1,fvec1,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
        call gaxspc(1) ! restore default
        
     enddo
  elseif(lchar('A')) then !ADAS DATA
     zlbl1='ADAS "EI" database'
     do
        izneut=0
        call ureadi('select neutral specie: 1 for H, 2 for He:$',izneut)
        if(izneut.eq.0) exit
        
        izneut=max(1,min(2,izneut))
        
        trange1=1.0e-3_fp ![KeV]
        trange2=200.0_fp  ![KeV]
        call plot_fp_mkvec(trange1,trange2,n1,tvec1)
        call adas_sigvte_ioniz(izneut,tvec1,n1,fvec1,ierr)
        if(izneut.eq.fpreact_Z_H) then
           zlbl3='ionization of H0 by e- impact, vs. Te(KeV)'
        else
           zlbl3='ionization of He0 by e- impact, vs. Te(KeV)'
        endif
        call gaxspc(3) ! log-log
        call r8_grafx1(tvec1,fvec1,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
        call gaxspc(1) ! restore default
     enddo
  elseif(lchar('C')) then !ADAS vs PREACT  DATA
     zlbl1='PREACT/ADAS "EI" database'
     fvec1=0.0_fp
     fvec1_adas=0.0_fp
     do
        izneut=0
        call ureadi('select neutral specie: 1 for H, 2 for He:$',izneut)
        if(izneut.eq.0) exit

        izneut=max(1,min(2,izneut))
      
        trange1=1.0e-3_fp ![KeV]
        trange2=200.0_fp  ![KeV]
        call plot_fp_mkvec(trange1,trange2,n1,tvec1)
        call sigvte_ioniz(izneut,tvec1,n1,fvec1)
        call adas_sigvte_ioniz(izneut,tvec1,n1,fvec1_adas,ierr)
        
        if(izneut.eq.fpreact_Z_H) then
           zlbl3='ionization of H0 by e- impact, vs. Te(KeV)'
        else
           zlbl3='ionization of He0 by e- impact, vs. Te(KeV)'
        endif
        call gaxspc(3) ! log-log
        call r8_grafx2(tvec1,fvec1,fvec1_adas,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
        call gaxspc(1) ! restore default
     enddo
  endif

end subroutine plot_fp_ei

C******************** START FILE IUFTRM.FOR ; GROUP UFILES ******************
C-----------------------------------------------------------
C  IUFTRM
C  INTEGER FUNCTION, RETURN LENGTH OF STRING NOT INCLUDING
C  TRAILING BLANKS.
C  GENERATE LABELED ERROR MESSAGES IF
C   (A) INPUT STRING IS NOT LEFT JUSTIFIED
C   (B) INPUT STRING HAS IMBEDDED BLANKS
C
C  STRING WITH NO NONBLANKS IS OK
C
      INTEGER FUNCTION IUFTRM(ZSTR,ZERMSG,IER)
C
      USE UFILES
C
      CHARACTER*(*) ZSTR
      CHARACTER*(*) ZERMSG
C
      IER=0
      ILEN0=LEN(ZSTR)
C
      DO 10 IC=ILEN0,1,-1
        IF(ZSTR(IC:IC).NE.' ') GO TO 20
 10   CONTINUE
C  BLANK STRING
      IUFTRM=0
      RETURN
C
 20   CONTINUE
      IUFTRM=IC
C
C  ERROR CHECKING
C
      DO 30 IL=1,IC
        IF(ZSTR(IL:IL).EQ.' ') GO TO 90
 30   CONTINUE
C  NO ERROR:
      RETURN
C  ERROR:
 90   CONTINUE
      IER=1
      WRITE(UFELUN,9001) ZERMSG,ZSTR(1:IC)
 9001 FORMAT(' %',A,' STRING: "',A,'" ERROR:'/
     >'   NOT LEFT JUSTIFIED OR CONTAINS IMBEDDED BLANKS')
      RETURN
      END
C******************** END FILE IUFTRM.FOR ; GROUP UFILES ******************

!-----------------------------------------------------------------------------
!
real(fp) FUNCTION SIGMA_Z(N,KK,IPUNIT,E)
  use iso_c_binding, only: fp => c_double
  use csigma_mod
  IMPLICIT NONE
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER n,kk,ipunit
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) :: e
  real(fp) :: fbosch,am1,am2,am3,am4,ze2,ze1,zs1,zs2,sige_z
!  10/09/94 TBT
!           Add Lithium reactions 7-11
 
!...3/08/77
!...This  function was written by Harry H. Towner of the
!...Princeton Plasma Physics Lab. This function will initialize
!...parameters in common block csigma and then call function
!...SIGE to calculate the desired fusion cross-section (m**2).
!...if the only parameter which varies is e then SIGE should
!...be used after an initializing call to sigma is made.
!
!-----------------------
! UPGRADE - DMC - 11 SEP 1991
!  CODE IS ADDED TO USE THE NEW BOSCH FITTING PROCEDURE FOR THE
!  REACTIONS 1--4, SUPERSEDING THE OLDER DUANE/JARMIE FITS USED
!  HERETOFORE.  HOWEVER, THE OLD DUANE FITTING CODE IS RETAINED
!  AND MAY BE REVIVED BY CHANGING THE WAY THE LOGICAL VARIABLE
!  LBOSCH IS SET.
!
! THE BOSCH FITS AND FORMULAE ARE GIVEN IN THE PAPER
!
!  "Review of Data and Formulas for Fusion Cross-Sections"
!  by Hans-Stephan Bosch   IPP I/252, Garching, September 1990
!
! The Gamov factor "BG", sqrt(KeV), formula is on p. 2.
! A conversion to center-of-mass frame is required, cf. p. 2.
! The fit coefficients are on p. 29.
!
! Note that for D-T and D-He3 the fitting is split into two
! energy ranges; for simplicity the code supports two energy
! ranges for all reactions
!
! the call to SIGMA sets up COMMON block CSIGMA2 for subsequent
! calls to SIGE to actually evaluate the cross-sections, as before.
!
! NEW DATA:
!
  real(fp) :: BGDATA(4)   ! GAMOV FACTORS
  real(fp) :: ERDATA(3,4) ! ENERGY FIT RANGES
  real(fp) :: ALDATA(5,4),AHDATA(5,4),BLDATA(4,4),BHDATA(4,4) !COEFFS
  real(fp),dimension(6)::A_DPC ! A<nn> coefficient DPC fit 0/2018
  real(fp),dimension(5)::B_DPC ! B<nn> coefficient DPC fit 0/2018
  real(fp),parameter:: BG_DPC=38.4224306526e+00_fp ! GAMOV FACTORS, DPC fit 0/2018
  data A_DPC/1.83514616e+05_fp,-3.17779782e+02_fp,3.76709752e+00_fp,&
       -2.60896847e-03_fp,1.21563195e-06_fp,6.78016367e-11_fp/
  data B_DPC/3.36105299e-05_fp,1.86611385e-05_fp,-2.88648569e-08_fp,&
       1.45561737e-11_fp,-5.27692243e-16_fp/
! ENDF
  real(fp),dimension(4)::A_ENDF ! A<nn> coefficient ENDF fit 0/2018
  real(fp),dimension(4)::B_ENDF ! B<nn> coefficient ENDF fit 0/2018
  real(fp),parameter:: BG_ENDF=38.4224306526_fp
  data A_ENDF/2.86867049e-11_fp, -1.26581396e-02_fp, &
       6.31775307e-03_fp, -3.93623787e-03_fp/
  data B_ENDF/-6.68347948e-01_fp, 1.44900887e-01_fp,&
       1.74153264e-02_fp, 1404460.50227_fp/
!
!  DATA STATEMENTS BELOW...
!
!-----------------------
!
  integer, parameter :: NREACTS=11
!...PARAMETERS:
!...N - Tells what reaction you want
!	  =1 you get the cross section for the reaction  T(D,N)HE4
!	  =2 you get the cross section for the reaction  HE3(D,P)HE4
!	  =3 you get the cross section for the reaction  D(D,P)T
!	  =4 you get the cross section for the reaction  D(D,N)HE3
!	  =5 you get the cross section for the reaction  T(T,2N)HE4
!	  =12 you get the cross section for the reaction  T(T,2N)HE4 DPC fit 06/2018
!	  =6 you get the cross section for the reaction  T(HE3,X)Y
!         =7 Li
!         =8 Li    fudge tbt
!         =9 Li
!         =10Li
!         =11Li
!...KK - If KK=1 then you get the reverse reaction ie if N=1 and
!	 KK=1 you get the cross section for the reaction D(T,N)HE4
!...IPUNIT - the logical unit used for printing.
!...E - The energy of the incident particle.  (KEV)
!
  real(fp),dimension(nreacts) :: AA1,AA2,AA3,AA4,AA5,FFE
 
!       Lithium Fudge tbt (last 5 repeated.
  DATA AA1/1453.0_fp,2823.0_fp,1457.70_fp,1514.0_fp,1214.0_fp,&
       3893.0_fp,&
       2823.0_fp,1457.70_fp,1514.0_fp,1214.0_fp,&
       3893.0_fp/      ! tbt
 
  DATA AA2/502.e+5_fp,259.e+5_fp,372.e+3_fp,482.e+3_fp,448.e+3_fp,1125.e+4_fp,&
       259.e+5_fp,372.e+3_fp,482.e+3_fp,448.e+3_fp,1125.e+4_fp/
  DATA AA3/1368.e-8_fp,398.e-8_fp,436.e-9_fp,308.e-9_fp,102.e-8_fp,0.0_fp,&
       398.e-8_fp,436.e-9_fp,308.e-9_fp,102.e-8_fp,0.0_fp/
  DATA AA4/1.0760_fp,1.2970_fp,1.2200_fp,1.1770_fp,2.090_fp,0.0_fp,&
       1.2970_fp,1.2200_fp,1.1770_fp,2.090_fp,0.0_fp/
 
  DATA AA5/409.e+3,647.e+3_fp,0.0_fp,0.0_fp,0.0_fp,0.0_fp,&
       647.e+3_fp,0.0_fp,0.0_fp,0.0_fp,0.0_fp/
 
  DATA FFE/1.4974660_fp,1.4974560_fp,1.0_fp,1.0_fp,1.0_fp,1.0000070_fp,&
       1.4974560_fp,1.0_fp,1.0_fp,1.0_fp,1.0000070_fp/
 
!-----------------------------
!  DATA STATEMENTS FOR FIT COEFFS FOR NEW BOSCH FITS
!  DMC 11 SEP 1991 -- SEE COMMENTS, ABOVE...
!
  DATA BGDATA/34.3827_fp,68.7508_fp,31.3970_fp,31.3970_fp/
  DATA ERDATA/&
       0.5_fp, 550.0_fp, 4700.0_fp,&
       0.3_fp, 900.0_fp, 4800.0_fp,&
       0.5_fp, 5000.0_fp, 5000.0_fp,&
       0.5_fp, 4900.0_fp, 4900.0_fp/
  DATA ALDATA/&
       6.9270e+04_fp, 7.4540e+08_fp, 2.0500e+06_fp, 5.2002e+04_fp, 0.0_fp,&
       5.7501e+06_fp, 2.5226e+03_fp, 4.5566e+01_fp, 0.0_fp, 0.0_fp,&
       5.5576e+04_fp, 2.1054e+02_fp,-3.2638e-02_fp, 1.4987e-06_fp, 1.8181e-10_fp,&
       5.3701e+04_fp, 3.3027e+02_fp,-1.2706e-01_fp, 2.9327e-05_fp,-2.5151e-09_fp/
  DATA BLDATA/&
       6.3800e+01_fp,-9.9500e-01_fp, 6.9810e-05_fp, 1.728e-04_fp,&
       -3.1995e-03_fp,-8.5530e-06_fp, 5.9014e-08_fp, 0.0_fp,&
       0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp,&
       0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp/
  DATA AHDATA/&
       -1.4714e+06_fp, 0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp,&
       -8.3993e+05_fp, 0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp,&
       0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp,&
       0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp/
  DATA BHDATA/&
       -8.4127e-03_fp, 4.7983e-06_fp,-1.0748e-09_fp,8.5184e-14_fp,&
       -2.6830e-03_fp, 1.1633e-06_fp,-2.1332e-10_fp,1.4250e-14_fp,&
       0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp,&
       0.0_fp, 0.0_fp, 0.0_fp, 0.0_fp/
!******************************************************************************
!
!
  LBOSCH=.FALSE.
  LFUN=.FALSE.
  LDPC=.FALSE.
  IF (N .GE. 1 .AND. N .LE. NREACTS+1) THEN
!
!  DMC 11 SEP 1991 -- DECIDE BTW OLD DUANE FITS AND NEW BOSCH FITS
!
     IF(N.LE.4) THEN
!  SET UP NEW BOSCH FITS
        LBOSCH=.TRUE.
        BG=BGDATA(N)
        CALL RMASS_Z(N,KK,AM1,AM2,AM3,AM4)
        EFAC=AM1/(AM1+AM2)
        ELOW=ERDATA(1,N)
        EMID=ERDATA(2,N)
        EHI=ERDATA(3,N)
        ALOW(1:5)=ALDATA(1:5,N)
        AHI(1:5)=AHDATA(1:5,N)
        BLOW(1:4)=BLDATA(1:4,N)
        BHI(1:4)=BHDATA(1:4,N)
!
!  COMPUTE SLOPE FOR HIGH ENERGY EXTRAPOLATION
!  I HAVE TESTED THESE TO 25 MeV USING TREXE:NUKTEST.EXE
!  DMC 12 SEP 1991
!
        ZE2=EHI
        ZE1=0.99_fp*EHI
        IF(EHI.GT.EMID) THEN
           ZS1=FBOSCH(ZE1,AHI(1),AHI(2),AHI(3),AHI(4),AHI(5),&
                BHI(1),BHI(2),BHI(3),BHI(4))
           ZS2=FBOSCH(ZE2,AHI(1),AHI(2),AHI(3),AHI(4),AHI(5),&
                BHI(1),BHI(2),BHI(3),BHI(4))
        ELSE
           ZS1=FBOSCH(ZE1,ALOW(1),ALOW(2),ALOW(3),ALOW(4),ALOW(5),&
                BLOW(1),BLOW(2),BLOW(3),BLOW(4))
           ZS2=FBOSCH(ZE2,ALOW(1),ALOW(2),ALOW(3),ALOW(4),ALOW(5),&
                BLOW(1),BLOW(2),BLOW(3),BLOW(4))
        ENDIF

        SLOPE=(ZS2-ZS1)/(ZE2-ZE1)
!  MODIFICATION SEEMS BEST FOR D-T (DMC 12 SEP)
        IF(N.EQ.1) SLOPE=0.15_fp*SLOPE
!
     endif
     IF(N.EQ.12) THEN         !DPC fit 06/2018  
        LDPC=.TRUE. 
        CALL RMASS_Z(N,KK,AM1,AM2,AM3,AM4)
        FE=AM1/(AM1+AM2)
        BG=BG_DPC
        ahi(1:6)=a_dpc(1:6)
        bhi(1:5)=b_dpc(1:5)
     endif
     IF(N.lt.12.and.N.gt.4) THEN 
        LFUN=.TRUE.
        FE=1.0_fp
        IF(KK.EQ.1) FE=1.0_fp/FFE(N)
        A1=AA1(N)
        A2=AA2(N)
        A3=AA3(N)
        A4=AA4(N)
        A5=AA5(N)
     ENDIF
!
     SIGMA_Z=SIGE_Z(E)
     RETURN
!
  ELSE
!  ERROR CHECK
     WRITE(IPUNIT,10) N
10   FORMAT(1X,'This value of n is not allowed ',I3,&
          ' returned from function sigma_z')
     call bad_exit
  ENDIF
!
END FUNCTION SIGMA_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

!-----------------------------------------------------------------------
!  PSGHOI -- CROSS SECTION OF O+8 + H --> O+8 + H+
!
real(fp)FUNCTION psghoi8(ZE)
!
! INPUT
!  ZE -- COLLISION ENERGY **PER NUCLEON**  EV/AMU
!
! OUTPUT
!  PSGHOI -- CROSS SECTION, CM**2
!
! REFERENCE
!  ORNL-6090/V5, ATOMIC DATA FOR FUSION, VOLUME V,
!    "COLLISIONS OF CARBON AND OXYGEN IONS WITH ELECTRONS, H, H2, & He"
!    R.A. PHANEUF, R.K. JANEV, M.S. PINDZOLA
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp)ze,emin,emax,zans,psgchvx8
!============
  real(fp)CCHEV(9)
!
  DATA EMIN/2.7e+4/
  DATA EMAX/1.0e+7/
!
  DATA CCHEV/&
       -7.01884e+01_fp,-4.69898e-01_fp,-1.15453e+00_fp,&
       4.10684e-01_fp,-5.42218e-02_fp,-5.69946e-02_fp,&
       3.88663e-02_fp, 9.45188e-03_fp,-2.07197e-02_fp/
!
  ZANS=psgchvx8(2,ZE,EMIN,EMAX,CCHEV)
      psghoi8=ZANS
!
      RETURN
    END FUNCTION psghoi8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

        SUBROUTINE USET_TTY(ZTTYP)
C
C  UREAD SET TTY TYPE
C
      USE USERIO
C
        CHARACTER*8 ZBLANK
        CHARACTER*(*) ZTTYP
C
        INTEGER IL
C
      DATA ZBLANK/'        '/
C
      IL=MIN0(8,LEN(ZTTYP))
      UTTYP(1:IL)=ZTTYP(1:IL)
      IF(IL.LT.8) UTTYP(IL+1:8)=ZBLANK(IL+1:8)
C
      CALL USPCAP(UTTYP)
C
      IF(UTTYP.NE.'NONE    ') THEN
        CALL GET_TERM_INT(UTTYP,NTTYP)
        IF(UTTYP(1:4).EQ.'TK40') NTTYP=0
      ELSE
        NTTYP=-1
      ENDIF
C
      RETURN
      END
 

      subroutine mds_getufnames(lun,fname,ier)
C Extract ufile names from MDSplus and write into file
C
      implicit none
C Input
      integer        lun
      character*(*)  fname     ! file name (to be written)
C return
      integer        ier       !  0 = success
C                              ! -1 = Node does not exist
C                              !  1 = any other error
C MDSplus
      integer       Mds_Value, idescr_long, idescr_cstringarr
      integer       ndsc
C Local
      integer, dimension(2) :: idims
      integer :: l,  ilz, retl
      integer :: nfiles  ! #of Ufiles
      character(200), dimension(:), allocatable :: ztext
      integer :: ialloc, iline
C
      integer        stat,  ios
      character*100  expr
C
      integer        ilnurd
C----------------------------------------------------------------
!
! Get number of Ufiles
      nfiles=0
      expr='size(getnci(".INPUTS:*:FILENAME","NID_NUMBER"))'
      l=ilnurd(expr)
      stat = Mds_Value(expr(1:l),idescr_long(nfiles),retl)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun, 'Mds_Value('//expr//')', stat)
         ier=1
         goto 9000
      else if(nfiles.le.0) then
         write(lun,*)
     &     ' ?mds_getufnames: Mds_Value returned non-positive length: ',
     &     nfiles
         ier=-1
         goto 9000
      else
! Allocate array
         print *,'nfiles = ',nfiles
         if(allocated(ztext)) deallocate(ztext)
         allocate(ztext(nfiles), STAT=ialloc)
         if(ialloc  /=  0) then
            write(lun,*)
     >      '?mds_getufnames: ERROR allocating ztext'
         endif
!
         idims(1)=nfiles
         idims(2)=0
! Read array
         expr='getnci(".INPUTS:*:FILENAME","RECORD")'
         l=ilnurd(expr)
         stat = Mds_Value(expr(1:l),
     &        idescr_cstringarr(ZTEXT,idims,1),retl)
         if (mod(stat,2).ne.1) then
            call mdsmsg(lun, 'Mds_Value('//expr(1:l)//')',
     &           stat)
            ier=1
            go to 9000
         else
cxx            print*,'write ',fname
! Write file
            open(7,STATUS='replace',iostat=ier,
     >           file=fname)
            if(ier.eq.0) then
               do iline=1,nfiles
                  ilz = len_trim(ztext(iline))
C                 print *,ztext(iline)(1:ilz)
                  write(7,'(A)',iostat=ier) ztext(iline)(1:ilz)
               enddo
               if (ier .ne. 0) then
                  close(7,status='delete')
               else
                  close(7)
               endif
            else
               print*,'%mds_getufnames: Error writing '//fname
               go to 9000
            endif
            CLOSE(7)	
         endif
      endif
      ier = 0
      return
C
 9000 continue
      return
      end

C******************** START FILE USPCLG.FOR ; GROUP USPARM ******************
C---------------------------------------------------------------
C&  USPCLG  DELETE ALL UREAD GLOBAL STRING PARAMETERS
C
      SUBROUTINE USPCLG
C
      USE USERIO
C
      NPT=NPGC
      DO 10 J=NPT,1,-1
      CALL USPDGL(J)
 10   CONTINUE
C
      RETURN
      END
C******************** END FILE USPCLG.FOR ; GROUP USPARM ******************

C******************** START FILE UFP2DA.FOR ; GROUP UFCMPR ******************
C-------------------------------------------------------------------
C  UFP2DA
C    -- OPPOSITE OF UFG2DA - MOD TO 3D DMC APR 1986 ***
C
C  TRANSFER WORDS FROM 1D ARRAY TO 3D ARRAY FOR PROCESSING
C
      SUBROUTINE UFP2DA(A3D,NA3D1,NA3D2,NZ,NX,NY,INUM0,A1D,N)
C
      REAL A3D(NA3D1,NA3D2,NZ),A1D(N)
C
C  ARGUMENTS
C   A3D - 3D OUTPUT DATA ARRAY
C     NOTE 1ST DIMENSION NA3D1  2ND DIM NA3D2
C
C   NX,NY-- NUMBER OF ROWS AND COLUMNS IN A3D TO CONTAIN "USEFUL" DATA.
C     NX MAY BE .LT. NA3D1 ... SIMILARLY NY, NA3D2
C
C   A1D - 1D INPUT DATA ARRAY
C     N = A1D DIMENSION = NUMBER OF DATA WORDS TO TRANSFER
C
C   INUM0 - PTS TO THE WORD PRECEDING THE FIRST WORD TO TRANSFER.
C
      IL=INUM0
C
      DO II=1,N
        IL=IL+1
        I3=(IL-1)/(NX*NY)+1
        ILI=IL-(I3-1)*NX*NY
        I2=(ILI-1)/NX+1
        I1=ILI-(I2-1)*NX
C
        A3D(I1,I2,I3)=A1D(II)
C
      ENDDO
C
      RETURN
      END
C******************** END FILE UFP2DA.FOR ; GROUP UFCMPR ******************

C******************** START FILE GMMSEL.FOR ; GROUP GMMSEL *************
C----------------------------------------------------------------
C  GMMSEL
C   BASED ON G3MSEL
C
C  GENERATE PLOT OF MULTIPLE CONTOURS (R,Y), INDEXED BY Z
C
      SUBROUTINE GMMSEL(R,Y,ND1,NC,Z,NZ,
     >     RUN,YUN,ZLAB,ZUN,MNLAB,KYLAB,FZLAB)
C
C  R(ND1,NZ)
C  Y(ND1,NZ)  SEQUENCES OF ORDERED PAIRS (R,Y) TO BE PLOTTED
C             R MAPPED ALONG HORIZONTAL AXIS, Y ALONG VERTICAL AXIS
C             ND1= 1ST DIMENSION OF R,Y ARRAYS
C
C  NC         NUMBER OF PTS IN EACH CONTOUR (.LE. ND1)
C             (R(1,J),Y(2,J)), (R(2,J),Y(2,J)), ..., (R(NC,J),Y(NC,J))
C
C  Z(NZ)      CONTOUR INDEXING  JTH CONTOUR IS ASSOCIATED WITH Z(J)
C
C  RUN        10 CHAR LABEL PHYSICAL UNITS OF R
C  YUN        10 CHAR LABEL PHYSICAL UNITS OF Y
C
C  ZLAB       10 CHAR LABEL FOR Z
C  ZUN        10 CHAR LABEL UNITS OF Z
C
C  MNLAB      3 60 CHAR "MAIN" LABELS FOR MULTIPLOT
C    MNLAB(1),MNLAB(2) APPEAR ABOVE PLOT  MNLAB(3) APPEARS BELOW
C
C  ** CALLER SUPPLIES ALL OF THE ABOVE **
C
C  KYLAB      5 17 CHAR "KEY" LABELS FOR MULTIPLOT
C
C  ** KYLAB(3) THRU KYLAB(5) MAY BE SET BY CALLER.  THESE LABELS APPEAR
C  AT THE BOTTOM OF THE KEY BOX IN THE PLOT
C
C  FZLAB      15 12-character FIXED PT. (Z) LABELS FOR MULTIPLOT
C
C  KEY LABELS 1 AND 2, AND
C  ALL FIXED Z LABELS SET UP HERE.
C
C  SEE SUBROUTINES GRFMM1 AND MULCDR
C
      REAL R(ND1,NZ),Y(ND1,NZ),Z(NZ)
C
      CHARACTER*(*) RUN,YUN,ZLAB,ZUN,FZLAB(15)
C
      INTEGER ISELF(15)
      REAL ZSELF(15)
      INTEGER NCA(1)
C
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) KYLAB(5)
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C  EXECUTABLE CODE
C
      LUNTRM=LNOUT(0)
 10   CONTINUE
C
      KYLAB(1)=ZLAB
      KYLAB(2)=ZUN
C
      ZZ1=Z(1)
      ZZ2=Z(NZ)
C
 50   CONTINUE
      CALL NEUPAG
 51   IF(LXOUT(0)) WRITE(LUNTRM,1002) MNLAB(1),NZ,ZLAB,ZZ1,ZZ2,ZUN
 1002 FORMAT(/' PLOTTING:'/1X,A/
     >  1X,I4,' CONTOURS AVAILABLE AT FIXED VALUES OF ',A,' FROM'/
     >  1X,1PE11.4,' TO ',1PE11.4,1X,A,' NO INTERPOLATIONS.'//
     >  ' OPTIONS--'/
     >  '  A:  SPECIFY ALL CONTOURS'/
     >  '  B:  SPECIFY STARTING CONTOUR, SPACING INTERVAL AND NUMBER'/
     >  '  C:  SPECIFY STARTING CONTOUR INDEX, NUMBER AND INCREMENT'/
     >  '  Q:  QUIT'/)
C
      CALL UREAD('GMMSEL:  ENTER CONTOUR OPCODE (A/B/C/X/Q):$')
      IANS=IXUOPC('ABCQ$')
      CALL UCHKOP(IANS,0,1,100,-1,*51)
      GO TO (100,200,300,500) IANS
C
C  ALL CONTOURS SPECIFIED
C
 100  CONTINUE
      NSEL=0
 101  CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1003) ZLAB,ZUN
 1003 FORMAT(' SPECIFY ',A,' VALUES IN ',A)
      IF(LXOUT(0)) WRITE(LUNTRM,1004)
 1004 FORMAT(
     >  ' ENTER LIST OF VALUES, TERMINATE WITH AN "X"'/
     >  ' NEAREST AVAILABLE CONTOUR WILL BE TAKEN'/)
 105  CALL UREAD('$')
      IF(LCHAR('X')) GO TO 190
      if(lchar('Q')) goto 50
      ZVAL=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 101
C
      CALL G3INX1(ZVAL,1,Z,NZ,Z,NZ,ISELF,ZSELF,15,NSEL)
      GO TO 105
C
 190  CONTINUE
      IF(NSEL.EQ.0) GO TO 50
      GO TO 1000
C-----
 200  CONTINUE
      IF(LXOUT(0)) WRITE(LUNTRM,1003) ZLAB,ZUN
      CALL UREAD('GMMSEL:  ENTER START VALUE:$')
      if(lchar('Q')) goto 50
      ZV1=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 200
 210  CONTINUE
      CALL UREAD('GMMSEL:  ENTER INTERVAL:$')
      IF(LCHAR('Q')) GO TO 50
      ZVI=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 210
 220  CONTINUE
      CALL UREAD('GMMSEL:  ENTER NUMBER OF CONTOURS (INTEGER):$')
      IF(LCHAR('Q')) GO TO 50
      INSEL=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 220
      INSEL=MAX0(1,MIN0(15,INSEL))
C
      ZV=ZV1-ZVI
      NSEL=0
      DO 230 I=1,INSEL
        ZV=ZV+ZVI
        CALL G3INX1(ZV,1,Z,NZ,Z,NZ,ISELF,ZSELF,15,NSEL)
 230  CONTINUE
      GO TO 1000
C-----
 300  CONTINUE
      CALL UREAD('GMMSEL:  ENTER START INDEX:$')
      IF(LCHAR('Q')) GO TO 50
      ISTART=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 50
C
 310  CONTINUE
      CALL UREAD('GMMSEL:  ENTER NO. OF CONTOURS TO PLOT (MAX 15):$')
      IF(LCHAR('Q')) GO TO 50
      INSEL=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 310
      INSEL=MAX0(1,MIN0(15,INSEL))
C
 320  CONTINUE
      CALL UREAD(
     >  'GMMSEL:  ENTER INTERVAL (E.G. 2 FOR ALTERNATE CONTOURS):$')
      IF(LCHAR('Q')) GO TO 50
      INTVL=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 320
      INTVL=MAX0(1,INTVL)
C
      IND=ISTART-INTVL
      NSEL=0
      DO 350 I=1,INSEL
        IND=IND+INTVL
        ZV=Z(MAX0(1,MIN0(NZ,IND)))
        CALL G3INX1(ZV,1,Z,NZ,Z,NZ,ISELF,ZSELF,15,NSEL)
 350  CONTINUE
      GO TO 1000
C
 500  CONTINUE
      RETURN
C
 1000 CONTINUE
      DO 1010 I=1,NSEL
        IF(ZSELF(I).LE.0.0) WRITE(FZLAB(I),2001) ZSELF(I)
        IF(ZSELF(I).GT.0.0) WRITE(FZLAB(I),2002) ZSELF(I)
 1010 CONTINUE
C
 2001 FORMAT(1PE11.4)
 2002 FORMAT(1PE11.5)
C
      NCA = NC  ! formally an array is needed for arg. 4:
      CALL GRFMM1(R,Y,ND1,NCA,1,Z,NZ,ISELF,NSEL,
     >     RUN,YUN,MNLAB,KYLAB,FZLAB)
C
      GO TO 50
      END
C******************** END FILE GMMSEL.FOR ; GROUP GMMSEL ***************

#include "fpreproc/f77_dcomplx.h"
!------------------------------------------------------------------------------
!
!  SIGPREP_ADAS_Z -- SET ARGUMENTS FOR HARRY'S SIGMA ROUTINE FROM SIGTAB
!               REACTION NUMBER, SET KEY FOR TYPE OF INTEGRATION
!
SUBROUTINE SIGPREP_ADAS_Z(IREACT,iz1,iz2,ikey)
!
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod     
  IMPLICIT NONE
!
!  29/06/09
!  This routine can be used to converte from ADAS reaction names to 
!  THE
!  CONVENTION USED IN HARRY TOWNER'S FUSION CROSS SECTION ROUTINES
!
! and set key for the
! KEY=1 FOR THERMONUCLEAR <SIGMA*V>
! key  = 2  for FOR BEAM TARGET <sig*v>
! key  = 3 for <E/A>
! key = 4 for <fd>
! key = 5  TRANSP BEAM BEAM GYRO INTEGRALS  See: preact/comptabl_z.for
!     react    : reaction type (
!                               1 = single ion impact ionisation (e.g. H +0 + H +1 => H +1 + H +1 + e)
!                               2 = full   ion impact ionisation (e.g. He+0 + H +1 => He+2 + H +1 + 2e)
!                               3 = single charge exchang        (e.g. He+0 + H +1 => He+1 + H +0)
!                               4 = full   charge exchang        (e.g. He+0 + He+2 => He+2 + He+0)
!                              )
! KREACT MUST be consistent with calls in sigsub/sigall_z.for
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER ireact !1 and 2 ='II', 3and 4 = 'CX'
  integer :: iZ1, iZ2 !     iZ1       : atomic charge of primary   particle {1, 2}
                          !     iZ2       : atomic charge of secondary particle {1, ..., 10}
  INTEGER ikey
!
!============
  IF(IREACT.EQ.2) THEN
     if(iZ1.eq.1) then
        if(iZ2.eq.1) then
           KREACT=-16        ! H0,H+ ii !ADAS: csIndex(2,1,1)=11. For the same reaction in PREACT KREACT=-2 
           KK=-1
        elseif(iZ2.eq.2) then
           KREACT=-17        ! He++,H0 ii !ADAS:csIndex(2,1,2)=12. For the same reaction in PREACT KREACT=-5
           KK=-1
        elseif(iZ2.eq.3) then
           KREACT=-24        ! Li+3 H0 ii !ADAS:csIndex(2,1,3)=13. 
           KK=-1
        elseif(iZ2.eq.4) then
           KREACT=-25        ! Be+4,H0 ii !ADAS:csIndex(2,1,4)=14. 
           KK=-1
        elseif(iZ2.eq.5) then
           KREACT=-26        ! B+5,H0 ii !ADAS:csIndex(2,1,5)=15. 
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-27        ! C+6,H0 ii !ADAS:csIndex(2,1,6)=16. 
           KK=-1
        elseif(iZ2.eq.7) then
           KREACT=-28        ! N+7,H0 ii !ADAS:csIndex(2,1,7)=17. 
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-29        ! O+8,H0 ii !ADAS:csIndex(2,1,8)=18. 
           KK=-1
        elseif(iZ2.eq.9) then
           KREACT=-30        ! F+9,H0 ii !ADAS:csIndex(2,1,9)=19. 
           KK=-1
        elseif(iZ2.eq.10) then
           KREACT=-31        ! Ne+10,H0 ii !ADAS:csIndex(2,1,10)=20. 
           KK=-1
        endif
     elseif(iZ1.eq.2) then
        if(iZ2.eq.1) then
           KREACT=-18        ! H+,He0 ii !ADAS: csIndex(2,2,1)=43. For the same reaction in PREACT KREACT=-4
           KK=-1
        elseif(iZ2.eq.2) then
           KREACT=-19        ! He++,He0 ii!ADAS: csIndex(2,2,2)=46. For the same reaction in PREACT KREACT=-7
           KK=-1
        elseif(iZ2.eq.3.or.iZ2.eq.5.or.iZ2.eq.7.or.iZ2.eq.9.or.iZ2&
             .ge.10) then
           call errmsg_exit('?sigprep_adas_z: invalid ZIMP value!')
        elseif(iZ2.eq.4) then
           KREACT=-32        ! Be+4,He0 ii!ADAS: csIndex(2,2,4)=48.
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-33        ! C+6,He0 ii!ADAS: csIndex(2,2,6)=50.
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-34        ! O+8,He0 ii!ADAS: csIndex(2,2,8)=52.
           KK=-1
        endif
     endif
  elseIF(IREACT.EQ.4) THEN
     if(iZ1.eq.1) then
        if(iZ2.eq.1) then
           KREACT=-20        ! H0,H+ cx !ADAS: csIndex(4,1,1)=1. For the same reaction in PREACT KREACT=-1 
           KK=-1
        elseif(iZ2.eq.2) then
           KREACT=-35        ! H0,He+2 cx !ADAS: csIndex(4,1,2)=2. 
           KK=-1
        elseif(iZ2.eq.3) then
           KREACT=-36        ! H0,Li+3 cx !ADAS: csIndex(4,1,3)=3. 
           KK=-1
        elseif(iZ2.eq.4) then
           KREACT=-37        ! H0,Be+4 cx !ADAS: csIndex(4,1,4)=4. 
           KK=-1
        elseif(iZ2.eq.5) then
           KREACT=-38        ! H0,B+5 cx !ADAS: csIndex(4,1,5)=5. 
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-39        ! H0,C+6 cx !ADAS: csIndex(4,1,6)=6. 
           KK=-1
        elseif(iZ2.eq.7) then
           KREACT=-40        ! H0,N+7 cx !ADAS: csIndex(4,1,7)=7. 
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-41        ! H0,O+8 cx !ADAS: csIndex(4,1,8)=8. 
           KK=-1
        elseif(iZ2.eq.9) then
           KREACT=-42        ! H0,F+9 cx !ADAS: csIndex(4,1,9)=9. 
           KK=-1
        elseif(iZ2.eq.10) then
           KREACT=-43        ! H0,Ne+10 cx !ADAS: csIndex(4,1,10)=10. 
           KK=-1
        endif
     elseif(iZ1.eq.2) then
        if(iZ2.eq.1) then
           KREACT=-21        ! H+,He0 cx !ADAS: csIndex(4,2,1)=1. For the same reaction in PREACT KREACT=-3
           KK=-1
        elseif(iZ2.eq.2) then
           KREACT=-22        ! He++,He0 cx !ADAS: csIndex(4,2,2)=20.For the same reaction in PREACT KREACT=-6
           KK=-1
        elseif(iZ2.eq.3.or.iZ2.eq.5.or.iZ2.eq.7.or.iZ2.eq.9.or.iZ2&
             .ge.10) then
           call errmsg_exit('?sigprep_adas_z: invalid ZIMP value!')
        elseif(iZ2.eq.4) then
           KREACT=-44        ! Be+4,He0 cx !ADAS: csIndex(4,2,4)=21.
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-45        ! C+6,He0 cx !ADAS: csIndex(4,2,6)=22.
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-46        ! O+8,He0 cx !ADAS: csIndex(4,2,8)=23.
           KK=-1
        endif
     endif
  elseIF(IREACT.EQ.1) THEN 
     if(iZ1.eq.1) then
        if(iZ2.eq.1) then
           KREACT=-16        ! H0,H+ ii !ADAS: csIndex(2,1,1)=11. For the same reaction in PREACT KREACT=-2 
           KK=-1
        elseif(iZ2.eq.2) then
           KREACT=-17        ! He++,H0 ii !ADAS:csIndex(2,1,2)=12. For the same reaction in PREACT KREACT=-5
           KK=-1
        elseif(iZ2.eq.3) then
           KREACT=-24        ! Li+3 H0 ii !ADAS:csIndex(2,1,3)=13. 
           KK=-1
        elseif(iZ2.eq.4) then
           KREACT=-25        ! Be+4,H0 ii !ADAS:csIndex(2,1,4)=14. 
           KK=-1
        elseif(iZ2.eq.5) then
           KREACT=-26        ! B+5,H0 ii !ADAS:csIndex(2,1,5)=15. 
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-27        ! C+6,H0 ii !ADAS:csIndex(2,1,6)=16. 
           KK=-1
        elseif(iZ2.eq.7) then
           KREACT=-28        ! N+7,H0 ii !ADAS:csIndex(2,1,7)=17. 
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-29        ! O+8,H0 ii !ADAS:csIndex(2,1,8)=18. 
           KK=-1
        elseif(iZ2.eq.9) then
           KREACT=-30        ! F+9,H0 ii !ADAS:csIndex(2,1,9)=19. 
           KK=-1
        elseif(iZ2.eq.10) then
           KREACT=-31        ! Ne+10,H0 ii !ADAS:csIndex(2,1,10)=20. 
           KK=-1
        endif
     elseif(iZ1.eq.2) then
        if(iZ2.eq.2) then
           KREACT=-23       ! He+2,He0 ii !ADAS: csIndex(1,2,2)=28. For the same reaction in PREACT KREACT=-7
           KK=-1
        elseif(iZ2.eq.1) then
           KREACT=-48       ! He+,He0 ii !ADAS: csIndex(1,2,1)=24
           KK=-1
        elseif(iZ2.eq.4) then
           KREACT=-49       ! Be+4,He0 ii !ADAS: csIndex(1,2,4)=31
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-50       ! C+6,He0 ii !ADAS: csIndex(1,2,6)=34
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-51       ! 0+8,He0 ii !ADAS: csIndex(1,2,8)=37
           KK=-1
        endif
     endif
  elseIF(IREACT.EQ.3) THEN 
     if(iZ1.eq.1) then
        if(iZ2.eq.1) then
           KREACT=-20        ! H0,H+ cx !ADAS: csIndex(4,1,1)=1. For the same reaction in PREACT KREACT=-1 
           KK=-1
        elseif(iZ2.eq.2) then
           KREACT=-35        ! H0,He+2 cx !ADAS: csIndex(4,1,2)=2. 
           KK=-1
        elseif(iZ2.eq.3) then
           KREACT=-36        ! H0,Li+3 cx !ADAS: csIndex(4,1,3)=3. 
           KK=-1
        elseif(iZ2.eq.4) then
           KREACT=-37        ! H0,Be+4 cx !ADAS: csIndex(4,1,4)=4. 
           KK=-1
        elseif(iZ2.eq.5) then
           KREACT=-38        ! H0,B+5 cx !ADAS: csIndex(4,1,5)=5. 
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-39        ! H0,C+6 cx !ADAS: csIndex(4,1,6)=6. 
           KK=-1
        elseif(iZ2.eq.7) then
           KREACT=-40        ! H0,N+7 cx !ADAS: csIndex(4,1,7)=7. 
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-41        ! H0,O+8 cx !ADAS: csIndex(4,1,8)=8. 
           KK=-1
        elseif(iZ2.eq.9) then
           KREACT=-42        ! H0,F+9 cx !ADAS: csIndex(4,1,9)=9. 
           KK=-1
        elseif(iZ2.eq.10) then
           KREACT=-43        ! H0,Ne+10 cx !ADAS: csIndex(4,1,10)=10. 
           KK=-1
        endif
     elseif(iZ1.eq.2) then
        if(iZ2.eq.2) then
           KREACT=-47       ! He+2,He0 non neutr. CX !ADAS: csIndex(3,2,2)=5
           KK=-1
        elseif(iZ2.eq.4) then
           KREACT=-52       ! Be+4,He0 non neutr. CX !ADAS: csIndex(3,2,4)=8
           KK=-1
        elseif(iZ2.eq.5) then
           KREACT=-53       ! B+5,He0 non neutr. CX !ADAS: csIndex(3,2,5)=11
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-54       ! C+6,He0 non neutr. CX !ADAS: csIndex(3,2,6)=12
           KK=-1
        elseif(iZ2.eq.7) then
           KREACT=-55       ! N+7,He0 non neutr. CX !ADAS: csIndex(3,2,7)=15
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-56       ! O+8,He0 non neutr. CX !ADAS: csIndex(3,2,8)=16
           KK=-1
        elseif(iZ2.eq.10) then
           KREACT=-57       ! Ne+10,He0 non neutr. CX !ADAS: csIndex(3,2,10)=19
           KK=-1
        endif
     endif
     
  elseIF(IREACT.EQ.5) THEN  ! Impact ionization = single II + full II + non-neutralaizing CX
     if(iZ1.eq.1) then
        if(iZ2.eq.1) then
           KREACT=-58        ! H0,H+ ii
           KK=-1
        elseif(iZ2.eq.2) then
           KREACT=-59       ! He++,H0 ii 
           KK=-1
        elseif(iZ2.eq.3) then
           KREACT=-60        ! Li+3 H0 ii . 
           KK=-1
        elseif(iZ2.eq.4) then
           KREACT=-61        ! Be+4,H0 ii  
           KK=-1
        elseif(iZ2.eq.5) then
           KREACT=-62        ! B+5,H0 ii  
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-63        ! C+6,H0 ii 
           KK=-1
        elseif(iZ2.eq.7) then
           KREACT=-64        ! N+7,H0 ii  
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-65        ! O+8,H0 ii  
           KK=-1
        elseif(iZ2.eq.9) then
           KREACT=-66        ! F+9,H0 ii  
           KK=-1
        elseif(iZ2.eq.10) then
           KREACT=-67        ! Ne+10,H0 ii  
           KK=-1
        endif
     elseif(iZ1.eq.2) then
        if(iZ2.eq.1) then
           KREACT=-68       ! He+,He0  ii 
           KK=-1
        elseif(iZ2.eq.2) then
           KREACT=-69       ! He+2,He0 ii 
           KK=-1
        elseif(iZ2.eq.4) then
           KREACT=-70       ! Be+4,He0 ii 
           KK=-1
        elseif(iZ2.eq.6) then
           KREACT=-71       ! C+6,He0 ii 
           KK=-1
        elseif(iZ2.eq.8) then
           KREACT=-72       ! 0+8,He0 ii 
           KK=-1
        endif
     endif
     
  ELSE
     call errmsg_exit('?sigprep_adas_z: invalid IREACT argument value!')
  ENDIF
  call adas_setkey_z(ikey)
  RETURN
END SUBROUTINE SIGPREP_ADAS_Z
!------------------------------------------------------------------------------
!
!  Peter Richter (prichter@princeton.edu)
!  Princeton Plasma Physics Laboratory
!  August 2000
!
!  setkey_z.for - Set variable KEY in common block 'SIGTABL_Z'.
!
!------------------------------------------------------------------------------
!
SUBROUTINE ADAS_SETKEY_Z(IKEY)
!
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod, only: key
  IMPLICIT NONE
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER, intent(in) :: ikey
!============
  KEY=IKEY
!
END SUBROUTINE ADAS_SETKEY_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C----------------------------------------------------------------------
C  UWORDL -- FIND LIMITS OF NEXT SYNTACTIC "WORD" IN STRING
C
C  A WORD IS A BLANK OR COMMA DELIMMETED STRING, OR ANY STRING IMBEDDED
C  IN DBL QUOTES.  DBL QUOTE STRINGS WORK LIKE THIS:
C
C  "" TRANSLATES TO THE NULL WORD
C  "hello" TRANSLATES TO hello (LOWER CASE)
C  """" TRANSLATES TO A SINGLE DOUBLE QUOTE
C  """this is a test"" END OF TEST" TRANSLATES TO
C         "this is a test" END OF TEST
C  AS ONE WORD
C
C  THIS ROUTINE SIMPLY RETURNS THE INDEX LIMITS OF THE NEXT WORD STRING
C  IN THE PASSED STRING
C
      SUBROUTINE UWORDL(STR,ISTART,IL1,IL2,ICODE)
      USE USERIO
C
C  INPUT STRING:
      CHARACTER*(*) STR
C
C  ISTART-- INCREMENT TO WHERE TO START SEARCH FOR A WORD
C    NB if ISTART=-1, treat as if ISTART=0 but add uppercase conversion
C  OUTPUT
C  IL1,IL2  LIMITS OF WORD FOUND
C  ICODE    FLAG INDICATING TYPE OF END-DELIMITER
C   =0 MEANS END OF LINE
C   =1 MEANS A BLANK OR TAB
C   =2 MEANS A COMMA
C   =4 MEANS USER PUNCTUATION
C
      ISI=max(0,ISTART)

      iup=0
      if(istart.lt.0) iup=1

      ILEN=LEN(STR)
C
      ICODE=0
C
      IL1=0
      IL2=0
C
C  1.  FIND START OF WORD
 10   CONTINUE
      ISI=ISI+1
      IF(ISI.GT.ILEN) GO TO 500  ! **WITHOUT FINDING WORD**
C
      CALL UDELIM(STR(ISI:ISI),JCODE)
      IF(JCODE.EQ.1) GO TO 10
C
      IF(JCODE.EQ.2) THEN  ! OLD STYLE UREAD COMMA DELIMITER
        IL1=ISI
        ICODE=2
        GO TO 500  ! **NULL WORD**
      ENDIF
C
      IL1=ISI
C
      IF(STR(ISI:ISI).EQ.'"') GO TO 100  ! QUOTE STRING DETECTED
C
      IF(JCODE.EQ.4) THEN    ! USER PUNCTUATION SYMBOL DETECTED
        ICODE=4
        IL2=IL1
        GO TO 500
      ENDIF
C
      if(iup.eq.1) call uspcap(str(isi:isi))
C
C  2.  FIND END OF STRING (NOT A QUOTE STRING)
 20   CONTINUE
      ISI=ISI+1
      IF(ISI.GT.ILEN) THEN
        IL2=ILEN
        GO TO 500
      ENDIF
C
      IF(STR(ISI:ISI).EQ.'"') GO TO 100  ! QUOTE STRING DETECTED
C
      CALL UDELIM(STR(ISI:ISI),ICODE)
      IF(ICODE.EQ.0) then
         if(iup.eq.1) call uspcap(str(isi:isi))
         GO TO 20
      endif
C
      IL2=ISI-1
      GO TO 500
C
C  3.  FIND END OF STRING (QUOTE STRING)
 100  CONTINUE
C
C  END OF QUOTE STRING IS WHEN AN EVEN NO.'D DBL QUOTE CHARACTER IS
C  FOUND NOT IMMEDIATELY FOLLOWED BY ANOTHER DBL QUOTE CHARACTER
C
      IEVEN=0
 110  CONTINUE
      ISI=ISI+1
      IF(ISI.GT.ILEN) THEN
        ILX=MIN0(72,ILNURD(STR))
        WRITE(LUNTRM,9001) STR(1:ILX)
 9001   FORMAT(
     >' %UREAD (SR UWORDL):  TRYING TO INSERT MISSING "-DELIMITER:'/
     >1X,A)
        CALL UPAUST(0)
        IF((IL1.GT.(ILEN-2)).OR.(STR(ILEN:ILEN).NE.' ')) THEN
          IL2=ILEN
          GO TO 500
        ELSE
          DO 220 IC=ILEN,IL1+2,-1
            IF(STR(IC:IC).NE.' ') GO TO 222
 220      CONTINUE
          IC=IL1+1
 222      CONTINUE
          IC=IC+1
          STR(IC:IC)='"'
          ISI=IC
        ENDIF
      ENDIF
      IF(STR(ISI:ISI).NE.'"') GO TO 110
      IEVEN=1-IEVEN
      IF(IEVEN.EQ.1) THEN
        IF(ISI.EQ.ILEN) THEN
          IL2=ILEN
          GO TO 500
        ELSE
          ISP1=ISI+1
C  EVEN QUOTE ENDS STRING UNLESS ANOTHER QUOTE FOLLOWS...
          IF(STR(ISP1:ISP1).NE.'"') THEN
            GO TO 20
          ENDIF
        ENDIF
      ENDIF
      GO TO 110
C
C-------------------
C  EXIT
C
 500  CONTINUE
      RETURN
      END

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
        integer function mds_open(tree, shot)
        implicit none
        character*(*) tree
        integer*4     shot
        character(len=*),parameter  :: cr='mds_open'

        print *,cr,' -D__NOMDSPLUS > dummy mdstransp/mds_open '
        mds_open = 0

        end
#else
c-----------------------------------------------------------------------
c mds_open
c open a tree
c
c 03/03/1999 ler Converting to unix usable
c-----------------------------------------------------------------------
      integer function mds_open(tree, shot)
      implicit none
 
      character*(*) tree
      integer       shot
 
      integer l, status
      character*4097 strarg
 
      integer MdsOpen
 
      call mds__copywnull(strarg, tree)
      status = MdsOpen(strarg, shot)
 
      mds_open = status
 
      return
      end
#endif

subroutine plot_fp_mkvec(zrange1,zrange2,n,vec)

  ! generate logarithmically spaced ascending vector, from endpt values

  use iso_c_binding, only: fp => c_double
  real(fp), intent(in) :: zrange1,zrange2  ! min and max of range for vec
  integer, intent(in) :: n  ! size of vec

  real(fp), intent(out) :: vec(n)

  !------------------

  real(fp) :: zmin,zmax,zv
  integer i

  !------------------

  zmin=log(min(zrange1,zrange2))
  zmax=log(max(zrange1,zrange2))

  vec(1)=min(zrange1,zrange2)
  vec(n)=max(zrange1,zrange2)

  do i=2,n-1
     zv=((n-i)*zmin+(i-1)*zmax)/(n-1)
     vec(i)=exp(zv)
  enddo

end subroutine plot_fp_mkvec

	block data atcomblk
        include 'jcticcom'
        data lcrok /.false./, lechi /.false./
        data ltext /.false./
        data lmacro /-1/
        data ofile /' '/
        data cfeed /' '/

	end

        subroutine at_char(prompt,word)                         !04/05/85
c
c 07/06/98 CAL modify for f90
c              readonly,shared,   ->  action='read' via sed in Make.AIX
c              type -> at_msg

c 01/21/98 CAL modified for TRANSP
c 04/28/99 CAL general port
c
	implicit none
        include 'jcticcom'
        character word*(*),c*1,cn*1,prompt*(*)
        character*2 tabc 
        integer itab
        logical nil
        integer glyf
        character*130  zstr

	external atcomblk
	integer kp, jp, ios, ierr, ngot, jptr, ls
	integer jc_trim

#ifdef __f90
        data itab/Z'09'/       ! TAB =HT = x09
#else
        data itab/'09'x/       ! TAB =HT = x09
#endif

        tabc(1:1) = char(itab)
        tabc(2:2) = '!'

        if(level.eq.0) call at__input(prompt,word)
        c=' '
        nil=.true.
        do while(nil)           !Loop til you get something
          kp=ip(level)
          if(kp.ge.ll) go to 200        !Cycle
          jp=kp                         !Find first non-blank
          do while (line(level)(jp:jp).eq.' ' .and. jp.lt.ll)
            jp=jp+1
          enddo
          if(jp.le.ll) c=line(level)(jp:jp)     !Get character
          if(c.eq.'!') c=' '            !Ignore comments
          if(c.eq.' ') then
            kp=ll                       !Skip to end of line
            if(lcrok) nil=.false.       !Blank line ok
            go to 200
          endif
          ip(level)=jp                  !Start of glyph
          kp=jp+1                       !Pointer to end of glyph
          if(c.eq.''''.or.c.eq.'"') then        !quote string
            jp=kp                       !start of quote
            kp=index(line(level)(jp:ll),c)+jp-1 !Find matching quote
            if(kp.le.jp) then
              call at_msg('** need matching quote')
              c=' '
            elseif(kp.gt.jp) then
              word=line(level)(jp:kp-1)
            else
              word=' '                  !Allow null string
            endif
            kp=kp+1
            if(kp.le.ll .and. line(level)(kp:kp).eq.',') kp=kp+1
c
          elseif(c.eq.'@') then         !indirect file
            glyf=0
            do while(kp.lt.ll .and. glyf.eq.0)
              cn=line(level)(kp:kp)
              glyf=index(' !/;',cn)     !Glyph goes to blank,comment
              if(glyf.eq.0) kp=kp+1
            enddo
            ip(level)=kp                !save place
            if(kp-1.lt.jp+1) then
              call at_msg('** no indirect file after @')
              c=' '
            elseif(level.ge.8) then
              call at_msg('** more than 8 levels of indirect file')
              call at_reset             !Back to level 1
            else
              level=level+1             !Bounce up a level
              iun(level)=90+level
              open(iun(level),file=line(level-1)(jp+1:kp-1),

#ifdef __f90 || __xlf
     >          action='read',   
#else  
     >          readonly,        
#endif
     >          status='old',iostat=ios)
              if(ios.ne.0) then
                if(ios.eq.29) then
                call at_msg('** '//line(level-1)(jp+1:kp-1)//' missing')
                else
               call at_error(ios,'cant open '//line(level-1)(jp+1:kp-1))
c                   zstr = 'cant open '//line(level-1)(jp+1:kp-1)
                call at_error(ios,zstr)
                endif
                call at_reset           !Close all files
              else
                rewind iun(level)
              endif
              kp=ll             !Force reading of new line
              c=' '
            endif
c
          elseif(ltext) then            !Text string
            if(index('>/',c).ne.0) then         !check for file or exit
              call at_switch(word,line(level)(jp:),jp,ngot)
              c=word(1:1)
            endif
            word=line(level)(jp:)
            kp=jp+jc_trim(word)
c
          elseif(c.ne.',' .and. c.ne.' ') then  !normal string
            glyf=0
            do while(kp.lt.ll .and. glyf.eq.0)
              cn=line(level)(kp:kp)
              glyf=index(', !/;',cn)    !Glyph goes to blank,comma,comment
              if(glyf.eq.0) kp=kp+1
            enddo
            if(index('>/{;',c).ne.0) then       !output file or switch
              call at_switch(word,line(level)(jp:kp-1),jp,ngot)
              if(ngot.eq.0) then
                c=' '
              else
                c=word(1:1)
              endif
              if(c.eq.' ') goto 200     !skip upcase if comment
            else
              call at__upcase(word,line(level)(jp:kp-1))
            endif
            if(kp.le.ll .and. line(level)(kp:kp).eq.',') kp=kp+1
          endif
 200      ip(level)=kp
          if(c.ne.' ') nil=.false.
          if(kp.ge.ll) call at__input(prompt,word)
        enddo
c
        if(ofile.ne.' ' .and. iun(level).ne.0) then
          if(word.ne.' ') then
             write(90,'(a)',iostat=ierr)
     >		(word(1:jc_trim(word)))//tabc//prompt
c             zstr = word(1:jc_trim(word))//tabc//prompt
c             write(90,'(a)',iostat=ierr) zstr
          endif
        endif
        end
c
        subroutine at_switch(so,si,jptr,ngot)
	implicit none
        include 'jcticcom'
        character*(*) si,so
	integer jptr
        integer ngot            !0=>null output, 1=>'so' ok
        character c*1,str*32
        character*80 etext
        logical setsw
	integer kt, kv, knt, knv
	integer is, ierr, ls 
	integer jc_trim

        call at__upcase(str,si)         !copy to temp in case si a constant
        if(str(1:1).eq.';') str='/B'
        c=str(1:1)
        ls=jc_trim(str)
        setsw=.true.
        ngot=1          !dont change <so> unless we have something
        if(c.eq.'{' .and. str(ls:ls).eq.'}') then
          str(1:1)='/'
          call at__param(str,ls-1,so)
          return
        endif
        if(c.eq.'/' .and. ls.gt.4) then         !check for parameter
          call at__param(str,ls,so)
          return
        elseif(c.eq.'/' .and. ls.ge.2) then     !Check for switches
          c=str(2:2)
          if(c.eq.'N') then             !Strip off N or NO
            setsw=.false.
            c=str(3:3)
            if(c.eq.'O') c=str(4:4)
          endif
          is=index('ABCERSXZPH',c)
                !many switches must begin line
          if(index('CERSPH',c).ne.0 .and. jptr.gt.1) then
            ngot=0
            return
          endif
          if(is.gt.0) ngot=0            !most switches return nothing
          if(is.eq.10) then             !/H = help
            if(lhelp) then
              so=str                    !if enabled, return /H
              ngot=1
            else
              call at_msg('** help not enabled')
            endif
          elseif(is.eq.9) then          !/P = pause
            call at_pause
          elseif(is.eq.8) then          !/Z is no-op
          elseif(is.eq.7) then          !/X calls user_end
cx          call user_end
          elseif(is.eq.5) then          !/R = rewind
            if(level.gt.1) rewind iun(level)
          elseif(is.eq.4) then          !/E = echo user input
            lechi=setsw
            ngot=0
          elseif(is.eq.3) then          !/C = treat CR same as blank
            lcrok=setsw
          elseif(is.eq.2) then          !/B returns '/B'/
            so=str
            ngot=1
          elseif(is.eq.1) then          !/A aborts task
            call good_exit  !   
          else
            call at_msg('** invalid switch: '//str)
          endif
c
        elseif(c.eq.'/') then
          so=c
          ngot=1
        elseif(c.eq.'>') then
c* note: line is written after parameter is translated.
          ofile=si(2:)
          if(ofile.eq.' ') then
            close(90,iostat=ierr)
          else
            open(90,file=ofile,
     >        status='new',iostat=ierr)
            if(ierr.ne.0) then
            call at_error(ierr,'** cant open output file')
            ofile=' '
            endif
          endif
        endif
        end

        subroutine at__param(str,ns,so)
	implicit none
	integer ns, mtext
        character str*(*),so*(*)
        parameter (mtext=128)
        character texts*(mtext),values*(mtext)
        logical lstor
        character*130 zstr
!?put nt,nv in common or have entry to re-init
        integer nt, nv
        save nt,nv
	
	integer lq, lt, ls, kt, kv, knt, knv

	data nt/0/,nv/0/

        ls=ns           !local copy, length of string
        lq=index(str,'=')
        lt=ls           !length of text part
        if(lq.gt.0) lt=lq-1
        kt=1            !index in texts (/param)
        kv=1            !index in values (=value)
        lstor=.false.   !search for param in texts
        do while (kt.lt.nt .and. .not.lstor)
          knt=index(texts(kt:),char(0))+kt-1
          knv=index(values(kv:),char(0))+kv-1
cx        if(knt.le.kt) go to 200       !leave
          if(str(2:lt).eq.texts(kt:knt-1)) then
            lstor=.true.        !found it
          else
            kt=knt+1
            kv=knv+1
          endif
        enddo
        so=' '
        if(lstor .and. lq.eq.0) then    !/param returns value
          so=values(kv:knv-1)
        elseif(lstor) then              !redefine param
          values(kv:knv-1)=str(lq+1:ls)
        elseif(lq.gt.0) then            !not there, new param
          if(nt+lq-1.gt.mtext) then
            call at_msg('[too many parameters]')
            return
          endif
          nt=nt+1
          texts(nt:)=str(2:lt)  !store param text
          nt=nt+lt-1
          texts(nt:nt)=char(0)          !null terminate
          nv=nv+1
          values(nv:)=str(lq+1:ls)      !store param value
          nv=nv+ls-lq
          values(nv:nv)=char(0)
        else            !not there on get
	  call at_msg(' ** '//str(2:ls)//' undefined')
c           zstr = ' ** '//str(2:ls)//' undefined'
c          call at_msg(zstr)
        endif
        end
c
        subroutine at__input(prompt,word)       !Input a line           !!04/03/85
	implicit none
        character prompt*(*),word*(*)
        include 'jcticcom'              !8 lines, 8 pointers
        integer klass
        logical search
        integer idummy
	integer nw, lp, idum, narg, nww, ios, ierr, idumy, nc, i
	integer jc_trim

	data klass /-1/

        if(level.le.1) then
          nw=jc_trim(word)              !Measure size of default word
          lp=jc_trim(prompt)            !Returns len>=1
        endif
        search=.true.
        do while (search)               !Loop until you get results
c
          ip(max(1,level))=1            !Point at beginning of line
          if(level.eq.0) then           !At start, input from command buffer

            call lib_get_foreign(line(1),narg,idumy)  !   
            search=narg.eq.0  !   
            iun(1)=-1                   !not a macro
            level=1
c                                       !Next try the input stream
          elseif(level.eq.1 .and. iun(1).ne.0) then
c                !lib_get_input doesnt do Fortran carriage control
            if(lp+nw.gt.72) then
               write(*,'(1x,a)') prompt(:lp)
               nww=min(nw,74)
#ifdef __f90
               write(*,'(1x,a)') '['//word(:nww)//']? '
#else
               write(*,'(1x,a,$)') '['//word(:nww)//']? '
#endif
            else
#ifdef __f90
               write(*,'(1x,a)') prompt(:lp)//'['//word(:nw)//']? '
#else
               write(*,'(1x,a,$)') prompt(:lp)//'['//word(:nw)//']? '
#endif
            endif
            if(cfeed.ne.' ') then
              line(1)=cfeed
              ios=0
            else
              read(*,'(a)',iostat=ios) line(1)
            endif
            if(ios.eq.-1) line(1)='/A'  !abort on EOF
            search=ios.gt.0             !Try again on error
c
          else          !Input from an indirect file
            if(iun(level).ne.0) then    !Read if not macro
              read(iun(level),'(a)',iostat=ios) line(level)
              if(ios.ne.0) close(iun(level),iostat=ierr)
              if(ios.gt.0)              !error msg unless eof
     >          call at_error(ios,'error reading indirect file')
            else                        !macros are one line
              ios=-1
            endif
            if(ios.ne.0) then
              level=level-1             !Return to prior line
              lmacro=-1
            endif
            search=.false.
c?          if(nc.eq.0) search=.true.
            if(level.eq.0) search=.true.
          endif
          nc=jc_trim(line(level))
c         if(lechi) type *, line(level)(1:nc)
          if(lechi) call at_msg(line(level)(1:nc))
        enddo
c
        if(ip(level).eq.1) then
          do i=1,ll                     !Replace tabs,etc, with blanks
            if(line(level)(i:i).lt.' ') line(level)(i:i)=' '
          enddo
        endif
        end
c
        subroutine at_reset
	implicit none
        include 'jcticcom'
	
        do while (level.gt.1)
          if(iun(level).gt.0) close(iun(level))
          level=level-1
        enddo
        level=1
        iun(1)=-1
        line(1)=' '
        ip(1)=1
        ltext=.false.
        end
c
c...Force feed the tic input buffer
        subroutine at_text(prompt,word) !Get entire line        !06/20/88
	implicit none
        include 'jcticcom'
        character word*(*),prompt*(*)
        ltext=.true.
        call at_char(prompt,word)
        ltext=.false.
        end
c
c...return next glyph from input stream
        subroutine at_macro(mline)
	implicit none
        character*(*) mline
        include 'jcticcom'
	integer i

        lmacro=level            !level to return to
        if(level.lt.8) level=level+1
        iun(level)=0
        line(level)=mline
        do i=1,ll               !replace tabs,etc, with blanks
          if(line(level)(i:i).lt.' ') line(level)(i:i)=' '
        enddo
        ip(level)=1
        end
c
        subroutine at_mend
	implicit none
        include 'jcticcom'
        if(lmacro.ge.0) then
cx        close(iun(level),iostat=ierr)
          level=lmacro
          lmacro=-1
        endif
        end
c
        subroutine at__upcase(stro,stri)
	implicit none
        character*(*) stro,stri
        integer quo
	integer hex5f
	integer i, ich, ls

#ifdef __f90
	data hex5f /Z'5f'/
#else
	data hex5f /'5f'X/
#endif
        ls=len(stro)
        quo=0
        i=1
        do while (i.le.min(len(stri),ls))
          ich=ichar(stri(i:i))
          if(quo.ne.0) then
            if(ich.eq.quo) quo=0
          elseif(ich.eq.ichar('"') .or. ich.eq.ichar('''')) then
            quo=ich
          elseif(ich.ge.ichar('a') .and. ich.le.ichar('z')) then
C            ich=iand(ich,'5f'x)         !mask out '40'x
            ich=iand(ich,hex5f)         !mask out '40'x
          endif
          stro(i:i)=char(ich)
          i=i+1
        enddo
        if(i.le.ls) stro(i:)=' '
        end
c
        subroutine user_end             !dummy user_end         03/30/88
        call good_exit                    !   
        end

        subroutine at_stkln(nrem)       !Return length of "stack" line  !89
	implicit none
	integer nrem
        include 'jcticcom'
	integer kp, jp
	integer jc_trim            ! function

        nrem=0
        if(level.eq.0) return           !before first input
        kp=ip(level)
        if(kp.ge.ll) return             !pointer past end of line
        jp=kp                   !skip over any blanks
        do while (line(level)(jp:jp).eq.' ' .and. jp.le.ll)
          jp=jp+1
        enddo
        if(line(level)(jp:jp).eq.'!') jp=ll+1   !ignore comments
        if(jp.le.ll) then
          nrem=jc_trim(line(level)(jp:))        !non-blank chars remaining
        endif
        end
        subroutine at_force(str)
	implicit none
        character*(*) str
        include 'jcticcom'
        cfeed=str
        end
        subroutine at_wipe
	implicit none
        include 'jcticcom'
        if(level.eq.0) return
        ip(level)=ll            !force next line
        end

        subroutine lib_get_foreign(line,narg,ll)  !   
	implicit none
	integer narg, ll
        character line*(*)  !
	integer i, la
	integer jc_len     ! function

        line=' '  !   
        call get_arg_count(narg)  !   
        la=0  !   
        do i=1,narg  !   
          call get_arg(i,line(la+1:))  !   
          la=jc_len(line)+1  !   
        enddo  !   
        end  !   

C----------------------------------------------------------------
C  GMMSELB
C   BASED ON GMMSEL -- key list removed, limit of 15 contours removed
C             JFS  23 Aug 95
C
C  GENERATE PLOT OF MULTIPLE CONTOURS (R,Y), INDEXED BY Z
C
      SUBROUTINE GMMSELB(R,Y,ND1,NC,Z,NZ,
     >     RUN,YUN,ZLAB,ZUN,MNLAB)
C
C  R(ND1,NZ)
C  Y(ND1,NZ)  SEQUENCES OF ORDERED PAIRS (R,Y) TO BE PLOTTED
C             R MAPPED ALONG HORIZONTAL AXIS, Y ALONG VERTICAL AXIS
C             ND1= 1ST DIMENSION OF R,Y ARRAYS
C
C  NC         NUMBER OF PTS IN EACH CONTOUR (.LE. ND1)
C             (R(1,J),Y(2,J)), (R(2,J),Y(2,J)), ..., (R(NC,J),Y(NC,J))
C
C  Z(NZ)      CONTOUR INDEXING  JTH CONTOUR IS ASSOCIATED WITH Z(J)
C
C  RUN        10 CHAR LABEL PHYSICAL UNITS OF R
C  YUN        10 CHAR LABEL PHYSICAL UNITS OF Y
C
C  ZLAB       10 CHAR LABEL FOR Z
C  ZUN        10 CHAR LABEL UNITS OF Z
C
C  MNLAB      3 60 CHAR "MAIN" LABELS FOR MULTIPLOT
C    MNLAB(1),MNLAB(2) APPEAR ABOVE PLOT  MNLAB(3) APPEARS BELOW
C
C  ** CALLER SUPPLIES ALL OF THE ABOVE **
C
C  ALL FIXED Z LABELS SET UP HERE.
C
C  SEE SUBROUTINES GRFMM1B AND MULCDRB
C
      REAL R(ND1,NZ),Y(ND1,NZ),Z(NZ)
C
      CHARACTER*(*) RUN,YUN,ZLAB,ZUN
C
        Parameter  ( jmsurf = 201 )
      INTEGER ISELF(jmsurf)
      REAL ZSELF(jmsurf)
C
      CHARACTER*(*) MNLAB(3)
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C  EXECUTABLE CODE
C
      LUNTRM=LNOUT(0)
 10   CONTINUE
C
      ZZ1=Z(1)
      ZZ2=Z(NZ)
C
      istart = 1
      insel  = NZ
      If ( insel .gt. jmsurf )  then
         Write ( luntrm, '(/'' Too many surfaces to plot''/)' )
         Call bad_exit
      End if
      intvl = 1
C
      IND=ISTART-INTVL
      NSEL=0
      DO 350 I=1,INSEL
        IND=IND+INTVL
        ZV=Z(MAX0(1,MIN0(NZ,IND)))
        CALL G3INX1(ZV,1,Z,NZ,Z,NZ,ISELF,ZSELF,jmsurf,NSEL)
 350  CONTINUE
C
      CALL GRFMM1B(R,Y,ND1,NC,1,Z,NZ,ISELF,NSEL,
     >     RUN,YUN,MNLAB)
C
      Return
      END

C-----------------------------------------------------------------------
C  STR_CBC -- UNIX PORTABLE REPLACEMENT FOR STR$CASE_BLIND_COMPARE
C
      INTEGER FUNCTION STR_CBC(STRING1,STRING2)
C
      implicit NONE
C
      CHARACTER*(*) STRING1,STRING2
C
C  RETURN STR_CBC = -1 IF STRING1 < STRING2
C  RETURN STR_CBC = 0  IF STRING1 = STRING2
C  RETURN STR_CBC = +1 IF STRING1 > STRING2
C
      CHARACTER*1 CHAR1,CHAR2
C
      CHARACTER*26 ALPHAB(2)
C
      LOGICAL LXASC
C
      integer il1,il2,ilnurd,imaxl,ic,ia1,ia2
C
      DATA ALPHAB/'abcdefghijklmnopqrstuvwxyz',
     >              'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C
C  LENGTHS W/O TRAILING BLANKS ...
C
      IL1=ILNURD(STRING1)
      IL2=ILNURD(STRING2)
C
      IMAXL=MAX(IL1,IL2)
C
      STR_CBC=0
      IF(IMAXL.EQ.0) GO TO 100
C
C  LOOP THROUGH CHARACTERS
C
      DO IC=1,IMAXL
        IF(IC.LE.IL1) THEN
          CHAR1=STRING1(IC:IC)
        ELSE
          CHAR1=' '
        ENDIF
        IF(IC.LE.IL2) THEN
          CHAR2=STRING2(IC:IC)
        ELSE
          CHAR2=' '
        ENDIF
C  CAPITALIZE IF NECESSARY
        IA1=INDEX(ALPHAB(1),CHAR1)
        IA2=INDEX(ALPHAB(1),CHAR2)
C
        IF(IA1.GT.0) CHAR1=ALPHAB(2)(IA1:IA1)
        IF(IA2.GT.0) CHAR2=ALPHAB(2)(IA2:IA2)
C
        IF(LXASC(CHAR1,'GT',CHAR2)) THEN
          STR_CBC=1
          GO TO 100
        ENDIF
C
        IF(LXASC(CHAR1,'LT',CHAR2)) THEN
          STR_CBC=-1
          GO TO 100
        ENDIF
C
      ENDDO
C
C  STRINGS ARE EQUAL IF WE FALL THROUGH THE LOOP
C
 100  CONTINUE
      RETURN
      END

C******************** START FILE UFSNAM.FOR ; GROUP UFILES ******************
C-----------------------------------------------------------
C  UFSNAM
C  NAME FILE FROM SHOT NUMBER, RETURN NONZERO ERROR
C  CODE IF THERE IS AN ERROR IN THE SHOT NUMBER
C
C  nb dmc 15 Dec 1998 -- Ufiles MDS+ data access -- this routine
C   cannot form a complete "filename", since actual object is
C   a server/tree/path combination.  Use UFSNAM_MDS to test if
C   ILUN is on an MDS+ channel.
C
      SUBROUTINE UFSNAM(ISHOT,ZFILE,IER,ILUN)
C
C  ISHOT-- 5 DIGIT SHOT NUMBER
C  ZFILE - OUTPUT FULL FILENAME W/ DEVICE, DIRECTORY (IF IT FITS)
C  IER-- ERROR RETURN CODE 0= SUCCESS
C  ILUN-- L.U.N. NUMBER TO ASSOCIATE WITH NAMED FILE
C
C
      USE UFILES
      CHARACTER*(*) ZFILE
      CHARACTER*10 ASHOT
 
      integer iln, ilt
C
      CALL UFINIT
      IER=0
C  FIND CHANNEL NUMBER; CHECK UNIT NUMBER
      CALL UFLCHK(ILUN,'UFSNAM    ',ICHAN,IER)
      IF(IER.NE.0) RETURN
C
      idx=6
C
C  CHECK SHOT NO. IF USED IN FILENAME
      IF(LSHOTN(ICHAN)) THEN
        if(ufcprs(ichan).eq.-1) then
           id=1
           idx=10
           write(ashot,'(i10.10)') ishot
        else
           IF (ISHOT.LT.0 .OR. ISHOT.GT.999999) THEN
              WRITE(UFELUN,9001) ISHOT
 9001         FORMAT(' ? UFSNAM:  ILLEGAL SHOT NUMBER: ',I10)
              id=1
              ashot='******'
           else
C
              ISH = ISHOT
C  BREAK UP SHOT NUMBER INTO 5 CONSTITUENT DIGITS
C  INCL. LEADING ZEROES
              DO 10 II=6,1,-1
                 IDIG = MOD(ISH,10)
                 ASHOT(II:II) = CHAR(IDIG+48) ! INT ASCII CODE CONV.
                 ISH = ISH/10
 10           CONTINUE
C  DETERMINE WHETHER 5 OR 6 DIGIT SHOT NUMBER
              ID = 2
              IF(ASHOT(1:1).NE.'0') ID = 1
           endif
        endif
      ELSE
         ASHOT='      '
         ID=6
      ENDIF
C
      if(ufcprs(ichan).eq.-1) then
         ilt=len_trim(mds_tree(ichan))
         iln=len_trim(mds_node(ichan))
         zfile=' '
         write(zfile, '( ''MDS+:'',a,'':'',a,'':'',a)')
     1	mds_tree(ichan)(1:ilt),mds_node(ichan)(1:iln),ashot(id:idx)
      else
 
         CALL UFSNM0(ZFILE,
     >        UDEV(ICHAN),UFDIR(ICHAN),UPRFIX(ICHAN),ASHOT(ID:idx),
     >        UEXTND(ICHAN))
      endif
C  SAVE SHOT NUMBER
      UFSHOT(ICHAN)=ISHOT
      RETURN
      	END
C******************** END FILE UFSNAM.FOR ; GROUP UFILES ******************
C******************** START FILE UFSNAM.FOR ; GROUP UFILES ******************
C-----------------------------------------------------------
C  UFSNAM
C  NAME FILE FROM SHOT NUMBER, RETURN NONZERO ERROR
C  CODE IF THERE IS AN ERROR IN THE SHOT NUMBER
C
      SUBROUTINE UFSNAM_MDS(ILUN,imds)
C
C input:
C  ILUN-- L.U.N. NUMBER TO ASSOCIATE WITH NAMED FILE
C
C output:
C  imds=0 -- normal Ufile
C  imds=1 -- MDS+ data
C
      USE UFILES
C
      CALL UFINIT
      IER=0
C  FIND CHANNEL NUMBER; CHECK UNIT NUMBER
      CALL UFLCHK(ILUN,'UFSNAM    ',ICHAN,IER)
      IF(IER.NE.0) RETURN
C
      if(ufcprs(ichan).eq.-1) then
         imds=1
      else
         imds=0
      endif
C
      return
      end
 

      subroutine uread_cmd_enable
      use USERIO

      nlcmd = .TRUE.

      return
      end

      subroutine uread_cmd_disable
      use USERIO

      nlcmd = .FALSE.

      return
      end


C--------------------------------------------------------------------
C&  URCSTR  GENERATE UREAD SPECIAL CONTROL CHARACTER STRING
C
      SUBROUTINE URCSTR(UCNTRL)
C
      USE USERIO
C
      CHARACTER*(*) UCNTRL
C
      if(nlcmd) then
C              comment // input file // output file // command //
         UCNTRL=MCOMMT  //  MFILI  //  MFILO  //  MCMD //
     >        MPARAM  //  MBRNCH //  MTARGT //  MDOLLR
C         parameter defn// branch // target label// terminator
C
      else
         UCNTRL=MCOMMT  //  MFILI  //  MFILO  //  MCOMMT //
     >        MPARAM  //  MBRNCH //  MTARGT //  MDOLLR
      endif
C
      RETURN
      END
C******************** END FILE URCSTR.FOR ; GROUP UREAD5 ******************

C******************** START FILE USPLWR.FOR ; GROUP USPARM *************
C-----------------------------------------------------------------
C  D. MC CUNE NOV 12 1981
C& USPLWR   SET ALL LETTERS IN PASSED STRING TO LOWER CASE
C	    CONVERT TABS TO BLANKS
C
C  DMC 1988 -- **DO NOT** CONVERT STUFF BTW DBL QUOTES " xxx "
C
      SUBROUTINE USPLWR(ZSTR)
C
      CHARACTER*(*) ZSTR
C
      CHARACTER*2 ZFDLIM
      CHARACTER*52 ZCAP
C
      DATA ZFDLIM/'  '/  	! TAB AND SPACE
      DATA ZCAP/
     >  'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'/
C
      IUP=1  ! used for quote checking
      zfdlim(2:2)=char(9) ! make sure it is a tab
C
      ILEN=LEN(ZSTR)
      IF(ILEN.EQ.0) RETURN
      DO 101 I=1,ILEN
C  CHECK FOR DBL QUOTE TO SUPPRESS CAPITALIZATION
         IF(ZSTR(I:I).EQ.'"') IUP=1-IUP
         IF(IUP.NE.1) GO TO 101
C  CHECK FOR TAB
         IF(ZSTR(I:I).EQ.ZFDLIM(2:2)) THEN
            ZSTR(I:I)=ZFDLIM(1:1)
         ELSE
C  CHECK FOR LOWER CASE LETTER
            DO 100 IC=1,26
               IF(ZSTR(I:I).NE.ZCAP(IC:IC)) GO TO 100
               ICP=IC+26
               ZSTR(I:I)=ZCAP(ICP:ICP)
               GO TO 101
 100        CONTINUE
         ENDIF
 101  CONTINUE
      RETURN
      END
C******************** END FILE USPLWR.FOR ; GROUP USPARM ***************

C******************** START FILE GRFMF1.FOR ; GROUP GRFMF1 *************
C----------------------GRFMF1 SUBMODULE-----------------------
C  D. MC CUNE 15 MAY 1982
C  SET SCALE AND
C  PLOT MULTIPLOT VIA CALL TO MULFDR AND ALLOW REPEAT OF PLOT
C  ON DIFFERENT SCALE
C
C  DMC 12/87 -- LABEL ARGUMENTS DECLARATIONS GENERALIZED --
C
C  PLOT 1 GRAPH IMMEDIATELY ON CALL WITH ESTABLISHED DEFAULTS
C  THEN GIVE OPPORTUNITY TO USER TO CHANGE SCALING/AXIS DEFAULTS
C  OR JUST ON THE FUNCTION BEING PLOTTED WITHOUT AFFECTING DEFAULTS
C  ON FUTURE CALLS.
C  USE UREAD I/O SUBROUTINE
C
C  AUTO/NON-AUTO SCALING/USER-INTERFACE ROUTINES IN "GSCALE.FOR"
C  ARE USED
C  AXES SELECTION (LOG/LINEAR FOR EITHER/BOTH/NEITHER AXES)
C  SOFTWARE IN "GAXES.FOR" IS USED
C
C  MOD DMC FEB 1986 - PLOT SCALE SETTING AND POST-PLOT RESCALE
C  OPTIONS MENU STANDARDIZED VIA NEW GFLIB SUBROUTINE CALLS
C
      SUBROUTINE GRFMF1(F,NF1,X1,NX1,X2,NX2,ZW,
     >     ISELX,ISELF,NSEL,FUNS,XUNS,
     >     MNLAB,KYLAB,LBSEL)
C
C  ARGUMENTS -- SAME AS SUBROUTINE MULFDR (MULFDR.FOR) EXCEPT
C   ARGUMENT "ISEL" IS DETERMINED HERE
C
      implicit NONE
C
      integer :: nf1,nx1,nx2,nsel,iselx
C
      REAL F(NF1,NX2),X1(NX1),X2(NX2),ZW(NX2)
      INTEGER ISELF(NSEL)
C
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) KYLAB(5)
      CHARACTER*(*) LBSEL(NSEL)
      CHARACTER*(*) XUNS
      CHARACTER*(*) FUNS
C
C-------------------------------------------
      real :: zx,zy
      integer :: i,isel,ilocsc,incx,itot,inx,incf,incst
      integer :: icod,iymmx
      integer :: lnout,luntrm
C
      character*11 lbsel_11(nsel)
      character*18 kylab_18(5)
C
      logical :: lbl_adjust
C
      real tshift(nsel)
C
C END DMC 12/87
C
      INTEGER IPTRX(nsel),IPTRY(nsel),LPTR(nsel)
      integer, save :: iopcod=0
C
      DIMENSION ZX(2),ZY(2)
C
      EXTERNAL GRADUM  ! FOR GRAOPT
C
      integer icounter
C
      INCLUDE 'PLOT1MMX'
C
      EQUIVALENCE(ZX,XMIN)
      EQUIVALENCE(ZY,YMIN)
C
C-----------------------------------------------------------------------
C dmc curve selection option Jan 2009
C
      integer :: insel2,insel2_max
      character*11, dimension(:), allocatable :: lbsel2
      integer, dimension(:), allocatable :: iself2
      real, dimension(:), allocatable :: tshift2

C-----------------------------------------------------------------------
C  check for adjustment of key labels...
C
      call grfchk_adjust_lbl(kylab,nsel,lbsel,
     >     lbl_adjust,kylab_18,lbsel_11)
C
      icounter=0
C
      tshift = 0.0
C
C  enable contents editing
C
      call trgraf_slist_num(nsel,insel2)
      insel2_max=insel2
      allocate(iself2(insel2),lbsel2(insel2),tshift2(insel2))
C
      call trgraf_slist_init(nsel,iself,lbsel_11,tshift,
     >     insel2,iself2,lbsel2,tshift2)
C
C  LOCAL DEFAULT OVERRIDE SWITCHES CLEARED:
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
      CALL GAXGDF(ISEL)
C
C  NUMBER OF PTS/ ROW OR COLUMN BEING PLOTTED
      INCX=1
      ITOT=NF1*NX2
C
      IF(ISELX.EQ.1) THEN
        INX=NX1
        INCF=1
        INCST=NF1
      ELSE
        INX=NX2
        INCF=NF1
        INCST=1
      ENDIF
C
C  SET SCALE
      IYMMX=0
      DO 10 I=1,NSEL
        IPTRX(I)=1
        IPTRY(I)=1+(ISELF(I)-1)*INCST
        LPTR(I)=INX
 10   CONTINUE
C
C-------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      icounter=icounter+1
C
C  SET AXES FOR UPCOMING PLOT
C
      CALL GAXCUR(ISEL)
C
      IF(ILOCSC.EQ.0) THEN
C  COMPUTE X Y PLOT SCALE (USE GSCALE DEFAULTS)
        IF(ISELX.EQ.1) THEN
          CALL GSCSMG(X1,F,NX1,ITOT,IPTRX,1,IPTRY,INCF,LPTR,NSEL)
        ELSE
          CALL GSCSMG(X2,F,NX2,ITOT,IPTRX,1,IPTRY,INCF,LPTR,NSEL)
        ENDIF
      ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
        IF(ISELX.EQ.1) THEN
          CALL GSCSM0(X1,F,NX1,ITOT,IPTRX,1,IPTRY,INCF,
     >                  LPTR,NSEL,XMIN,XMAX,1)
        ELSE
          CALL GSCSM0(X2,F,NX2,ITOT,IPTRX,1,IPTRY,INCF,
     >                  LPTR,NSEL,XMIN,XMAX,1)
        ENDIF
        CALL GSCYDF(1)
      ENDIF
C
      CALL GSCSEP(XMIN,XMAX)
      CALL GSCSEP(YMIN,YMAX)
C
      LUNTRM=LNOUT(0)
      CALL GAXCHK(LUNTRM,ISEL,ICOD)
C
      CALL GSCREC  ! RECORD SCALE OF UPCOMING PLOT IN GSCALE COMMON
C
      CALL MULFDR(F,NF1,X1,NX1,X2,NX2,ZW,
     >     ISELX,ISELF2,INSEL2,ICOD,FUNS,XUNS,
     >     MNLAB,KYLAB_18,LBSEL2,tshift2)
C
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SAE',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
         GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
         deallocate(iself2,lbsel2,tshift2)
         RETURN
      else if(iopcod.eq.14) then
         call trgraf_slist_edit(nsel,iself,lbsel_11,tshift,
     >        insel2_max,iself2,lbsel2,tshift2,insel2)
         go to 100
      ENDIF
C
      CALL UERMSI(' ?GRFMF1 *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      END
C******************** END FILE GRFMF1.FOR ; GROUP GRFMF1 ***************

      subroutine grfchk_adjust_lbl(kylab,nsel,lbsel,
     >     lbl_adjust,kylab_18,lbsel_11)

      implicit NONE

      ! routine to provide adjusted (shortened) labels, when
      ! a common prefix allows it

C input:
      character*(*) :: kylab(5)
      integer :: nsel
      character*(*) :: lbsel(nsel)

C output:
      logical :: lbl_adjust
      character*18 kylab_18(5)
      character*11 lbsel_11(nsel)

C-----------------------------------------------

      integer :: ilen_max_kylab
      integer :: ilen_max_lbsel
      integer :: ilen2,ishare
      integer :: ii,i,idiff

C-----------------------------------------------

      ilen_max_kylab=0
      ilen_max_lbsel=0
      do ii=1,5
         ilen_max_kylab=max(ilen_max_kylab,len(trim(kylab(ii))))
      enddo
      do ii=1,nsel
         ilen_max_lbsel=max(ilen_max_lbsel,len(trim(lbsel(ii))))
      enddo
      ilen2=len(trim(kylab(2)))
      ilen2=max(1,ilen2)

C  adjust function labels for fit (a) if necessary; (b) if key labels fit;
C  (c) if the number of curves is .gt.1 (d) if the labels have a common
C  prefix.

      kylab_18=' '
      lbsel_11=' '
      lbl_adjust=.TRUE.

      if(ilen_max_lbsel.le.len(lbsel_11(1))) lbl_adjust=.FALSE.
      if(ilen_max_kylab.gt.len(kylab_18(1))) lbl_adjust=.FALSE.
      if(nsel.eq.1) lbl_adjust=.FALSE.
C
      if(lbl_adjust) then
C
C  see if there is a common prefix in LBSEL
C
         i=0
         do
            i=i+1
            idiff=0
            do ii=2,nsel
               if(lbsel(1)(1:i).ne.lbsel(ii)(1:i)) then
                  idiff=ii
                  exit
               endif
            enddo
            if(idiff.gt.0) then
               i=i-1
               exit
            endif
            if(i.eq.ilen_max_lbsel-3) exit
         enddo
C
         if(i.lt.2) lbl_adjust = .FALSE.   ! insufficient common prefix
         ishare=i
      endif
C
      if(lbl_adjust) then
         ! look for "_"
         do i=1,ishare,1
            if(lbsel(1)(i:i).eq.'_') then
               if(ilen_max_lbsel-i.le.11) then
                  ishare=i
                  exit
               endif
            endif
         enddo

         do i=1,5
            kylab_18(i)=kylab(i)
         enddo
         if(kylab_18(2).eq.' ') then
            if(8+ishare.le.17) then
               kylab_18(2)='prefix: '//lbsel(1)(1:ishare)
            else
               kylab_18(2)=lbsel(1)(1:min(18,ishare))
            endif
         else if(ilen2+1+ishare.le.18) then
            kylab_18(2)=trim(kylab_18(2))//' '//lbsel(1)(1:ishare)
         endif

         do i=1,nsel
            lbsel_11(i)=trim(lbsel(i)(ishare+1:))
         enddo
C
      else
         lbsel_11(1:nsel) = lbsel(1:nsel)
         kylab_18(1:5) = kylab(1:5)
      endif
C
      return
      end

!******************** START FILE FILFAS.FOR ; GROUP FILFAS ******************
!---------------------------------------------------------------
!  FILFAS   D. Mc Cune  pppl 4 dec 1981
!  A FAST MOVING TRIANGULAR WEIGHTED AVERAGE SMOOTHING ROUTINE
!
subroutine R8_FILFAS(F,FSM,N,NWA)
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: n,nwa,inwa,j,k,iw,ipt1,ipt2
  real(fp), dimension(n) :: fsm,f
  real(fp) :: fac,sum
  !
  !  INPUT:
  !   F(N) DATA TO BE SMOOTHED
  !   NWA-- NUMBER OF POINTS ON EITHER SIDE OF F(J) TO AVERAGE
  !         WITH TRIANGULAR WEIGHTING TO COMPUTE FSM(J)
  !
  !  OUTPUT:
  !   FSM(N): SMOOTHED DATA
  !
  !
  !  ALGORITHM:
  !  FSM(J) IS A WEIGHTED AVERAGE OF F(J-NWA),F(J-NWA+1),...,
  !                                  F(J),...,F(J+NWA-1),F(J+NWA)
  !  THE WEIGHTING FACTOR FOR
  !  F(J+K) IS W(K)=(NWA+1-IABS(K))/(NWA+1)**2
  !   NOTE THAT SUM[K= -NWA TO +NWA]W(K) = 1.0 EXACTLY
  !
  !  W(K) IS A STEP FUNCTION APPROXIMATION TO A TRIANGULAR WEIGHTING
  !  FUNCTION
  !
  !  END CONDITIONS:  if THE INDEX (J+K) IS .LT. 1 IT IS
  !   REPLACED BY 1; if (J+K) .GT. N IT IS REPLACED BY N.
  !  THUS THE END POINTS ARE MORE HEAVILY WEIGHTED IN THE REGIONS NEAR THE
  !  ENDPOINTS OF THE DATA BEING SMOOTHED
  !
  !  EXECUTABLE CODE
  !
  if(NWA.LE.0) GO TO 200
  INWA=NWA+1
  FAC=1.0D0/(INWA**2)
  !  START LOOP OVER DATA POINTS
  do J=1,N
    !  INITIATE SUM FOR POINT J
    SUM=F(J)*INWA
    !  LOOP OVER POINTS TO AVERAGE
    do K=1,NWA
      IW=INWA-K
      IPT1=max(1,(J-K))
      IPT2=min(N,(J+K))
      SUM=SUM+IW*(F(IPT1)+F(IPT2))
    end do
    FSM(J)=SUM*FAC
  end do
  return
  !  NWA < 0: JUST COPY DATA
200 continue
  do J=1,N
    FSM(J)=F(J)
  end do
  return
end subroutine R8_FILFAS

c
	subroutine at_menu(prompt,item)		!get user response to menu
        implicit none

	logical jc_isdigits
	external jc_isdigits
	integer  item
	character*(*) prompt,tmatch
	include 'jcticcom'
	integer maxp
	parameter (maxp=20)
	character*40 proms(maxp)
	character*4 tmats(maxp)
	integer ntm(maxp)
	integer nprom
	save nprom,proms
	character aline*48,respons*32
	character back*1
	integer i, ierr, nr, jc_trim, nc
	data ntm/maxp*0/
	data tmats/maxp*'    '/
c
	respons=' '
	back='H'
	item=0
	lhelp=.true.		!bchar treats CR as /H
	lmenu=.true.
	do while (back.eq.'H' .or. item.eq.0)
	  call at_bchar(prompt,respons,back)
	  if(back.eq.'H') then	!output help lines
	    do i=1,nprom
	      write (aline,'(i3,2h) ,a)') i,proms(i)
	      call at_msg(aline)
	    enddo
c
	  else		!check user input
	    if(jc_isdigits(respons)) then	!numeric entry
	      read(respons,'(bn,i20)',iostat=ierr) item
	      if(item.le.0 .or. item.gt.nprom) then
	        item=0
	        ierr=99
	      endif
c
	    else		!match initial string
	      ierr=99
	      nr=jc_trim(respons)	!length of user response
	      do i=1,nprom
		if(nr.ge.ntm(i)) then	!if > minimum length
	        nc=min(nr,ntm(i))
		if(item.eq.0 .or.	!and if no match yet
     >		  ntm(i).gt.ntm(item)) then	! or longer match
		    if(respons(1:nc).eq.tmats(i)(1:nc)) item=i
		endif
		endif
	      enddo
	    endif
	    if(item.eq.0) call at_msg('?Eh')
	  endif
	enddo
	lmenu=.false.
	lhelp=.false.
	return
c
	entry at_imenu		!initialize menu
	nprom=0
	return
c
	entry at_amenu(prompt,tmatch)		!add item to menu
	if(nprom.ge.maxp) then
	  call at_msg('**Too many prompts')
	  return
	endif
	nprom=nprom+1
	proms(nprom)=prompt
	tmats(nprom)=tmatch
	ntm(nprom)=jc_trim(tmatch)
	return
	end
	subroutine at_helpon(back)
        implicit none
	include 'jcticcom'
	character back*1
	lhelp=.true.
	back='H'
	return
	entry at_helpoff
	lhelp=.false.
	end

      program porttest
*.. porttest                            do a hodge podge test of portlib routines -- 
*                                       routines written for portability btw OS / environments
*
*
*     Author                            dmc 9 Apr 1999
*     Version                           1.10,  25Jan2010
*     Modifications
*
*     1.10  25Jan2010                   jim.conboy@ccfe.ac.uk
*                                       Add logmod_test
*                                       Return to original cwd after cd $HOME test
*----_^---------------------------------=========================================|
*
*     use       module
*
*      implicit  none                   << NO, IT ISNT !!
*
*
C
#include "fpreproc/byte_declare.h"
C
      double precision dans,d1mach
C
      real rans
C
      character*10 hname
C
      character*100 value,hvalue,save, 
     +              cinit_dir
      character*5 ttest
C
      character*9 z9date
      character*24 z24date
C
      character*150 tmp_filename,tmp_file2
C
      character*50 ctest1,ctest2
      character(len=128) :: zcmd
C
C
      integer fisatty
C
      integer :: ilun_list(3)
C
      real data1(50),data2(50)
C
 
      byte_declare BUFFER(512,2)
      byte_declare BUFF2(512,2)
C
      data hname/'HOME'/
C
      character(len=*),parameter     :: cPr='porttest'
*     character(len=*),parameter     :: cStop=cPr
*----_^------------------------------::================!.........................|
*
C
      call err_ini
C
      call cpu_time(ztime1)
      call wall_seconds(iwtime1)
c
      call logmod_test('None', 'Df', ier)
C
      call get_arg_count(numargs)
      write(6,1000) numargs
 1000 format(
     >   ' (call get_arg_count(numargs)):',
     >   '  porttest command line: ',i2,' arguments.')
      if(numargs.gt.0) then
         write(6,*) '(call get_arg(i,arg)):  arguments follow:'
      endif
      do i=1,numargs
         call get_arg(i,value)
         ilv=len_trim(value)
         write(6,'(6x,i2,'':  '',a)') i,value(1:ilv)
      enddo
C
      write(6,*) ' '
C
C  test fetching proc. id, & translating env. variable...
      call sget_pid(ipid)
C
      ilhn = len_trim(hname)
      write(6,1001) ipid,hname(1:ilhn)
 1001 format(' ...starting PORTtest...'//
     >' call sget_pid(ipid) ... ipid=',i12//
     >' call sget_env(''',a,''',hvalue) ...'/)
C
      call mpi_sget_env(hname,hvalue,ierr)
      ilv=max(1,len_trim(hvalue))
C
C  test call, no effect:
      call mpi_sset_env(hname,hvalue,ierr)
C
      call mpi_printenv(0,6)  ! proc #0; output on unit #6
C
      write(6,1010) hvalue(1:ilv)
 1010 format(' user login directory:  "',a,'"'/)
      save=hvalue
C
      call sget_user(value)
      ilv=len_trim(value)
      write(6,1012) value(1:ilv)
 1012 format(' (call sget_user(username)) => username = ',a/)
C
      call sget_host(value)
      ilv=len_trim(value)
      write(6,1013) value(1:ilv)
 1013 format(' (call sget_host(hostname)) => hostname = ',a/)
C
      call sget_cwd(value)
      cinit_dir = value
      ilv=len_trim(value)
      write(6,1015) value(1:ilv)
 1015 format(/' (call sget_cwd(dirname)) current working directory:'/
     >   6x,a/)
C
C
      call ufilnam('HOME','foo.test',tmp_file2)
      ilt=len_trim(tmp_file2)
      write(6,1018) tmp_file2(1:ilt)
 1018 format(/' call ufilnam(''HOME'',''foo.test'',xyz) ==>'/
     >        '      xyz = "',a,'"'/)
C
      write(6,'('' ...changing current working directory.'')')
      ils=len_trim(save)
      call sset_cwd(save(1:ils),ierr)
      if(ierr.ne.0) write(6,*) ' *** error changing directory!'
C
      call sget_cwd(value)
      ilv=len_trim(value)
      write(6,1015) value(1:ilv)
C
      call sset_cwd(cinit_dir, ierr )
      call sget_cwd(value)
      write(6,*) 'porttest -I- Reset cwd to ',trim(value)
C
C-------------------------------
C  test date & date/time fetching...
C
      call c9date(z9date)
      call fdate(z24date)
      write(6,1020) z9date,z24date
C
 1020 format(' ...current date and time...'/
     >   ' call c9date(str)  => str="',a,'"'/
     >   ' call fdate(str) => str="',a,'"'/)
C
C------------------------------
C  test c <-> fortran string mapping
      ctest1='this is a test'
      call cstring(ctest1,buffer,'2C')  ! ctest1 => byte array "buffer"
      call cstring(ctest2,buffer,'2F')  ! byte array "buffer" => ctest2
      if(ctest1.eq.ctest2) then
         write(6,*) ' cstring test -- OK'
      else
         write(6,*) ' cstring test -- ERROR: ctest1.ne.ctest2'
         write(6,'(''   ctest1 = "'',a,''"'')') ctest1
         write(6,'(''   ctest2 = "'',a,''"'')') ctest2
      endif
      write(6,*) ' '
C------------------------------
C  test single character input (no echo) from stdin
C  test character stream output to stdout
C
      itty=fisatty(0)
      if(itty.eq.0) then
         write(6,*) ' (fisatty)...stdin is a FILE'
      else if(itty.eq.1) then
         write(6,*) ' (fisatty)...stdin is a TTY'
      else
         write(6,*) ' *** fisatty returned unexpected value: ',itty
      endif
C
      call term_str_out(' *** input 5 characters (no echo)-->')
      do ii=1,5
         call term_char_in(ttest(ii:ii))
      enddo
C
      call term_str_out(' ...echo:  '//ttest)
C
      write(6,'('' <all on one line>''/)')
C
C------------------
C  test fetching of a list of distinct & available fortran I/O unit numbers
C
      call find_io_unit_list(3,ilun_list)
      write(6,'(" 3 available fortran I/O unit numbers: ",3(1x,i4))')
     >     ilun_list(1:3)
C
C------------------
C  test 512-block byte-stream i/o (can be used for simple portable files).
C
      call tempfile('cft_test',tmp_filename,iltmp)
C
      icft_lun=99
C
      do i=1,512
#if __CRAY || __SX
         buffer(i,1)=char(int(50.0*(1.0+sin(float(i)))))
         buffer(i,2)=char(int(50.0*(1.0+cos(float(i)))))
#else
         buffer(i,1)=50.0*(1.0+sin(float(i)))
         buffer(i,2)=50.0*(1.0+cos(float(i)))
#endif
      enddo
C
      write(6,1030) tmp_filename(1:iltmp)
 1030 format(/' testing 512-block byte oriented i/o, filename:'/6x,a)
C
      call cftopen(icft_lun,tmp_filename(1:iltmp),'wb',0,ier)
      if(ier.ne.0) then
         write(6,*) '*** cftopen (write) error, ier=',ier
         go to 50
      endif
C
      call cftwrite(icft_lun,buffer(1,1),ier)
      if(ier.ne.0) then
         write(6,*) '*** cftwrite error (1), ier=',ier
         go to 15
      endif
      call cftwrite(icft_lun,buffer(1,2),ier)
      if(ier.ne.0) then
         write(6,*) '*** cftwrite error (2), ier=',ier
         go to 15
      endif
      write(6,*) '...cft write OK...'
C
 15   continue
      call cftclose(icft_lun)
      if(ier.ne.0) go to 50
C
C---
C
      call cftopen(icft_lun,tmp_filename(1:iltmp),'rb',0,ier)
      if(ier.ne.0) then
         write(6,*) '*** cftopen (read) error, ier=',ier
         go to 50
      endif
C
      ipass=0
 20   continue
      ipass=ipass+1
      call cftread(icft_lun,buff2(1,1),ier)
      if(ier.ne.0) then
         write(6,*) '*** cftread error (1), ier=',ier
         go to 25
      endif
      call cftread(icft_lun,buff2(1,2),ier)
      if(ier.ne.0) then
         write(6,*) '*** cftread error (2), ier=',ier
         go to 25
      endif
C
      ierdif=0
      do i=1,512
         if(buffer(i,1).ne.buff2(i,1)) then
            ierdif=ierdif+1
         endif
         if(buffer(i,2).ne.buff2(i,2)) then
            ierdif=ierdif+1
         endif
      enddo
C
      if(ierdif.gt.0) then
         write(6,*) '*** cft readback buffer .ne. write buffer!'
         go to 25
      else
         write(6,*) '...cft readback successful...'
      endif
C
      if(ipass.eq.1) then
         call cftrewnd(icft_lun,ier)
         if(ier.ne.0) then
            write(6,*) '*** cftrewnd error, ier=',ier
            go to 25
         else
            write(6,*) '...cft rewind OK...'
            go to 20
         endif
      endif
C
 25   continue
      call cftclose(icft_lun)
      write(6,'(''   cft i/o test completed.''/)')
C
 50   continue
C
      call logmod_test( 'porttest', 'info', ier )
C
      write(6,*) '...showing directory listing of file...'
      istat=system_call_echo('ls -l '//tmp_filename(1:iltmp))
      write(6,*) '...system_call_echo (ls/dir) return status: ',istat
C
      call tempfile('port_test',tmp_file2,iltmp2)
      write(6,*) '...file rename test.'
      call frename(tmp_filename(1:iltmp),tmp_file2(1:iltmp2),istat)
      write(6,*) '...frename return status: ',istat
C
      write(6,*) '...showing directory listing of file...'
      istat=system_call_echo('ls -l '//tmp_file2(1:iltmp2))
      write(6,*) '...system_call_echo (ls/dir) return status: ',istat
C
      write(6,*) '...copying file'
      call fcopy(tmp_file2(1:iltmp2),tmp_file2(1:iltmp2)//'2',istat)
      write(6,*) '...fcopy return status: ',istat
      write(6,*) '...deleting files'
      call fdelete(tmp_file2(1:iltmp2),istat)
      write(6,*) '...fdelete return status: ',istat
      call fdelete(tmp_file2(1:iltmp2)//'2',istat)
      write(6,*) '...fdelete return status: ',istat
      write(6,*) ' '
C
      write(6,*) '...showing directory listing of file...'
      istat=system_call_echo('ls -l '//tmp_file2(1:iltmp2))
      write(6,*) '...system_call_echo (ls/dir) return status: ',istat
      write(6,*) ' '
C
      call execsystem_test   ! test jsystem, jexec in execsystem module
C
      ierno=ierfnof(88)
      open(unit=88,file=tmp_file2(1:iltmp2),status='old',iostat=ierno2)
      if(ierno.eq.ierno2) then
         write(6,*) '...ierfnof(lun)=',ierno,' matches iostat',
     >      ' from open of non-existent file'
      else
         write(6,*) '...ierfnof(lun)=',ierno,' DOES NOT MATCH iostat',
     >      ' from open of non-existent file'
      endif
C
C  test ascii max record length routine
C
      write(6,*) ' '
      open(unit=88,file=tmp_file2(1:iltmp2),status='unknown')
      write(88,'(A)') 'this is a test'
      write(88,'(A)') 'this is also a test'
      close(unit=88)
c
      write(6,*) ' testing: portlib/max_reclen.for '
      ians=max_reclen(tmp_file2(1:iltmp2))
      write(6,*) ' max record length test result (should be 19):  ',ians
c
      open(unit=88,file=tmp_file2(1:iltmp2),status='old')
      close(unit=88,status='delete')
C
C------------------
C  test direct access i/o
C
      do i=1,50
         data1(i)=cos(float(i))
      enddo
C
      irecsz=10
      call genopen(88,tmp_file2(1:iltmp2),'NEW','DIRECT',irecsz,ios)
      if(ios.ne.0) then
         write(6,'('' *** genopen (NEW) error *** ios = '',i5)') ios
         close(unit=88,err=100)
         go to 100
      endif
C
      do i=1,5
         ie1=1+10*(i-1)
         ie2=ie1+9
         write(88,rec=i) (data1(ie),ie=ie1,ie2)
      enddo
C
      close(unit=88)
C
      call is_ascii(tmp_file2(1:iltmp2),iascii,ier)
      if(iascii.eq.1) then
         write(6,*) ' ?? porttest:  is_ascii said binary file is ascii!'
      endif
      if(ier.ne.0) then
         write(6,*) ' ?? porttest:  is_ascii returned error code:  ',ier
      endif
C
      call genopen(88,tmp_file2(1:iltmp2),'OLD','DIRECT',irecsz,ios)
      if(ios.ne.0) then
         write(6,'('' *** genopen (OLD) error *** ios = '',i5)') ios
         close(unit=88,err=100)
         go to 100
      endif
C
      i=1
      do j=1,5
         i=i+2
         if(i.gt.5) i=i-5
         ie1=1+10*(i-1)
         ie2=ie1+9
         read(88,rec=i) (data2(ie),ie=ie1,ie2)
      enddo
C
      close(unit=88)
C
      idif=0
      do i=1,50
         if(data1(i).ne.data2(i)) idif=idif+1
      enddo
C
      if(idif.gt.0) then
         write(6,'('' *** direct access data changed on readback!!'')')
         write(6,'(''     recordsize was 10 words:'')')
         do i=1,50
            write(6,'(3x,i2,2(1pe12.5))') i,data1(i),data2(i)
         enddo
      else
         write(6,1090)
 1090    format(/' PortTest:  fortran direct access i/o test OK.'/)
      endif
C
 100  continue
      call fdelete(tmp_file2(1:iltmp2),istat)
      write(6,*) '...fdelete return status: ',istat
      write(6,*) ' '
C
C------------------
      write(6,*) '...call cvtdays(nseconds) tests:'
      write(6,*) ' '
      call cvtd_test(10000)
      call cvtd_test(500000)
C------------------
      write(6,*) ' '
      write(6,*) 'i1mach test...'
      do i = 1,16
         ians=i1mach(i)
         write(6,'('' i1mach('',i2,'')='',i20)') i,ians
      enddo
      write(6,*) ' '
      write(6,*) 'r1mach test...'
      do i = 1,5
         rans=r1mach(i)
         write(6,'('' r1mach('',i1,'')='',1pe14.7)') i,rans
      enddo
      write(6,*) ' '
      write(6,*) 'd1mach test...'
      do i = 1,5
         dans=d1mach(i)
         write(6,'('' d1mach('',i1,'')='',1pd20.13)') i,dans
      enddo
C------------------
      write(6,*) ' ==> portTest:  going to sleep for  2  seconds:'
      write(6,*) '     call gosleep(2)'
      call gosleep(2)
      write(6,*) ' '
C
      call wall_seconds(iwtime2)
      idwall=iwtime2-iwtime1
      write(6,1100) idwall
 1100 format(
     >   ' wall_seconds:  wall clock time elapsed:  ',i3,' seconds.'/)
C------------------
      call cpu_time(ztime2)
      zdtime=ztime2-ztime1
      write(6,1099) zdtime
 1099 format(/'cpu_time:  cpu time used by porttest:  ',1pe10.3,
     >   ' seconds.'/)
C------------------
#ifdef __DEBUG
c
c  (not safe for exported NTCC test)
c
      write(6,*) ' **** gmkdir tests **** '
      write(6,*) '   $HOME/foo/foo and $CWD/foo/foo are created... '
      call gmkdir(' ','~/foo',ier)
      if(ier.ne.0) then
         write(6,*) ' ?? gmkdir (1) returned ier=',ier
      endif
      call gmkdir(' ',trim(hvalue)//'/foo/foo',ier)
      if(ier.ne.0) then
         write(6,*) ' ?? gmkdir (2) returned ier=',ier
      endif
      call gmkdir(' ','foo/foo',ier)
      if(ier.ne.0) then
         write(6,*) ' ?? gmkdir (3) returned ier=',ier
      endif

      zcmd = 'date > '//trim(hvalue)//'/foo/foo/foo1.dat'
      call execute_command_line(zcmd,exitstat=istat)
      zcmd = 'date > '//trim(hvalue)//'/foo/foo/foo2.dat'
      call execute_command_line(zcmd,exitstat=istat)
      zcmd = 'date > '//trim(hvalue)//'/foo/foo/foo2.dat2'
      call execute_command_line(zcmd,exitstat=istat)

      call fwc_delete(trim(hvalue)//'/foo/foo','foo*.dat',istat)
      call fclean_dir(trim(hvalue)//'/foo/foo',istat)
      write(6,*) ' **** gmkdir directories not deleted **** '
#endif
C
C------------------
      write(6,*) '...OK, the following is a test of errmsg_exit'
      write(6,*) '...an exit routine that writes a message and'
      write(6,*) '...calls "bad_exit".  "bad_exit" sets an error'
      write(6,*) '...status code for the parent shell.'
C
      call errmsg_exit('  taking bad_exit now...')
C
C------------------
      stop
      end
C---------------------------
      subroutine cvtd_test(isecs)
      integer isecs                     ! no. of seconds
      integer iarray(4)                 ! days/hours/mins/seconds
C
      call cvt_days(isecs,iarray)
      write(6,1001) isecs,(iarray(i),i=1,4)
 1001 format(' ...',i6,' seconds is:  ',i2,' days, ',
     >   i2,' hours, ',i2,' minutes, ',i2,' seconds.'/)
C
      return
      end

C******************** START FILE SINCOS.FOR ; GROUP TKODE2 ******************
C.............................................................
 
      SUBROUTINE SINCOS(ZTHETA,JANG,SNTHTK,CSTHTK)
 
C
C	THIS SUBROUTINE CALCULATES:
C		SIN(ZTHETA)
C		COS(ZTHETA)
C		SIN(2*ZTHETA)
C		COS(2*ZTHETA)
C	ETC., UP TO JANG*ZTHETA
C
C
C		ZTHETA IS INPUT ANGLE
C		JANG IS HIGHEST N*ZTHETA TO CALCULATE
C		SNTHTK IS THE ARRAY CONTAINING SIN(N*ZTHETA)
C		CSTHTK IS THE ARRAY CONTAINING COS(N*ZTHETA)
C
      DIMENSION SNTHTK(JANG),CSTHTK(JANG)
C
C  LOCAL MEMORY (DMC 6 JUL 1994)
C
      DATA ZTHETAP/0.0/
      DATA ZSINP/0.0/
      DATA ZCOSP/1.0/
C
      SAVE ZTHETAP,ZSINP,ZCOSP
C
C--------------------------------------------------------------------
C
C  DMC -- USE LOCAL MEMORY FOR SPEED
C
      IF(ZTHETA.NE.ZTHETAP) THEN
C
C  EVALUATE SIN,COS
C
        SNTHTK(1)=SIN(ZTHETA)
        CSTHTK(1)=COS(ZTHETA)
        ZTHETAP=ZTHETA
        ZSINP=SNTHTK(1)
        ZCOSP=CSTHTK(1)
      ELSE
C
C  REUSE PREVIOUS RESULTS
C
        SNTHTK(1)=ZSINP
        CSTHTK(1)=ZCOSP
      ENDIF
C
      DO 100 I=2,JANG
        SNTHTK(I)=SNTHTK(I-1)*CSTHTK(1)+CSTHTK(I-1)*SNTHTK(1)
        CSTHTK(I)=CSTHTK(I-1)*CSTHTK(1)-SNTHTK(I-1)*SNTHTK(1)
100   CONTINUE
C
      RETURN
      END
C
C******************** END FILE SINCOS.FOR ; GROUP TKODE2 ******************

C******************** START FILE FLDLIM.FOR ; GROUP URDUTS *************
C------------------------------
C&   FLDLIM OLD UREAD - FIELD LIMITS, UNPACKED CHAR BUFFER
C
C  FIND BEGINNING AND END OF FIRST STRING OF NON-BLANKS IN
C  DBUFF (1 CHAR/WORD)
C
      SUBROUTINE FLDLIM(DBUFF,NID1,NID2,NUM)
C
      implicit none
C
      integer imaxc
      PARAMETER (IMAXC=512)
C
      CHARACTER*1 DBUFF(IMAXC),MBLANK
      integer nid1,nid2,num
C
      integer i
C
      DATA MBLANK/' '/
C
C-------------------------------------------
C
      DO 10 I=1,IMAXC
        IF(DBUFF(I).NE.MBLANK) GO TO 20
 10   CONTINUE
      NUM=0
      NID1=0
      NID2=0
      RETURN
 20   CONTINUE
      NID1=I
      DO 30 I=NID1,IMAXC
        IF(DBUFF(I).EQ.MBLANK) GO TO 40
 30   CONTINUE
      I=IMAXC+1
 40   CONTINUE
      NID2=I-1
      NUM=NID2-NID1+1
      RETURN
      	END
C******************** END FILE FLDLIM.FOR ; GROUP URDUTS ***************

C	****************** START FILE  TRMFLNAM.FOR  ;  GROUP TRREAD_LIB ******
 
 
      SUBROUTINE TRMFLNAM ( DISK, DIR, RUNID, SUFFIX, FILENAME)
C
C  unix-ification -- dmc 6 Jul 1992
c       dmc-- also allow var. length DISK and DIR arguments
C
C       SUBROUTINE TRMFLNAM MAKES A FILE NAME, GIVEN THE DISK, DIRECTORY, THE
C	    RUNID AND THE FILE SUFFIX. "RUNDATA" IS THE ASSUMED LOGICAL
C	    NAME OF THE DISK IF "DISK" = " "
 
C	.LAST CHANGED:
c       aug 1996  dmc  RUNID -> 10 chars
C	04/09/90  TBT  CHANGED RUNID TO C*8 FROM C*6. DEFINED RUNID9 AS C*9 TO
C                      HANDLE AN 8 CHARACTER RUNID.
C		       DEFINED MAXCHARS=64 AS THE MAXIMUM # OF CHARACTERS IN
C                      THE NEW FILENAME.
 
C	ARGUMENTS:
C	    INPUT:  DISK    C*64 DISK     , E.G. RUNDATA (= DEFAULT IF " ")
C		    DIR	    C*64 DIRECTORY, E.G. TRANSP.TFTR.86
C		    RUNID   C*8  RUNID    , E.G. 4321  OR 10000A01
C		    SUFFIX  C*6	 SUFFIX   , E.G. TF.PLN
C
C	    OUTPUT: FILENAME C*64 FILE NAME, E.G.
C		             RUNDATA:[TRANSP.TFTR.86]4321TF.PLN
C
      IMPLICIT NONE
 
      INTEGER    MAXCHARS
      PARAMETER (MAXCHARS=64)
	
      CHARACTER*(*)    DISK
      CHARACTER*(*)	DIR
      CHARACTER*10	RUNID
      CHARACTER*11	RUNID9	    ! ALWAYS HAS RIGHTMOST CHAR BLANK
      CHARACTER*6	SUFFIX
      CHARACTER*64	FILENAME
 
      INTEGER		IPT,      I
      INTEGER		LUOUT
C
      data LUOUT/6/
C	--------------------------------------------------------------
 
      RUNID9 = RUNID              ! MAKE SURE THERE IS ONE BLANK IN VARIABLE
 
      IPT=0
 
      FILENAME=' '
 
      I = INDEX(DIR, ' ') - 1
      IF (I .LE. 0)  i = len(dir)
      IF (IPT+I+1.GT. MAXCHARS)  GO TO 999
      FILENAME(IPT+1:IPT+I) = DIR(1:I)
      IPT = IPT+I
C
      IF(IPT.GT.0) THEN
        IF(FILENAME(IPT:IPT).NE.'/') THEN
          IPT=IPT+1
          FILENAME(IPT:IPT)='/'
        ENDIF
      ENDIF
C
      I = INDEX(RUNID9,' ') - 1
      IF (I .LE. 0) GO TO 300
      IF (IPT+I+6 .GT. MAXCHARS)  GO TO 999
      FILENAME(IPT+1:IPT+I) = RUNID(1:I)
      IPT = IPT+I
 
  300 CONTINUE
      FILENAME(IPT+1:IPT+6) = SUFFIX
 
c  debug write commented out, dmc 22 Jan 1996
cx        WRITE(LUOUT, 9555) IPT+6, filename(1:IPT+6)
cx 9555	Format('TRMFLNAM: filename length =', I6 / ' --->', A, '<---')
 
      RETURN
 
C	-----------------------------------------------------------------
C	.ERROR RETURN - NEW FILENAME TOO LONG.
 
  999   WRITE (LUOUT, 9000, ERR=998) I,DISK,DIR,RUNID,
     1		  SUFFIX, FILENAME
 9000   FORMAT(/ ' ?TRMFLNAM: NEW FILE NAME > 64 ',
     1           'CHARACTERS. LENGTH = ',
     1           I5 / 1X, A64 / 1X, A64 / 1X, A10 / 1X, A6 / 1X, A64//)
  998   CONTINUE
        RETURN
 
C	****************** END FILE  TRMFLNAM.FOR  ;  GROUP TRREAD_LIB ******
 
      END

subroutine chk_extrapolate(zprof,xi,nx)
  !
  !  patch "holes" (zero values) in profile,
  !  then smooth.
  !
  !  done for MC radial profiles that are formed by summing of the
  !  profile itself and its normalization
  !
  !    zprof(j) = [MC sum]f*dw
  !    zwsum(j) = [MC sum]dw
  !
  !  and at normalization time
  !
  !    if (zwsum(j).gt.0.0) then
  !         zprof(j)=zprof(j)/zwsum(j)
  !    else
  !         zprof(j)=0.0
  !    endif
  !
  !  which can leave "holes" in the profile in case of lousy statistics.
  !
  !  *** SO ***
  !  fill these holes with linear extrapolation & linear interpolation
  !
  !-----------------------------
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  implicit none
  real(fp), dimension(nx) :: zprof,xi
  integer :: nx
  !
  !
  real(fp) :: zx1,zf1,zx2,zf2,zx,zf
  !
  integer :: j,jnz,jj,isrch,jsave1,jsave2
  !
  !-----------------------------
  !
  !  1.  fill in from left
  !
  do j=1,nx
    if(zprof(j).ne.zero) go to 10
  enddo
  !
  go to 1000                        ! all zero:  exit now...
  !
10 continue
  jnz=j
  do jj=1,jnz-1
    zprof(jj)=zprof(jnz)+(zprof(jnz+1)-zprof(jnz))*(xi(jj)-xi(jnz))/(xi(jnz+1)-xi(jnz))
    zprof(jj)=max(zero,zprof(jj))
  enddo
  !
  !  2.  fill in from right
  !
  do j=nx,1,-1
    if(zprof(j).ne.zero) go to 20
  enddo
  !
20 continue
  jnz=j
  do jj=nx,jnz+1,-1
    zprof(jj)=zprof(jnz)+(zprof(jnz-1)-zprof(jnz))*(xi(jj)-xi(jnz))/(xi(jnz-1)-xi(jnz))
    zprof(jj)=max(zero,zprof(jj))
  enddo
  !
  !  3.  fill in remaining gaps with linear interpolation
  !
  isrch=1
  do j=1+1,nx-1
    if(isrch.eq.1) then
      !  find start of zeroed section
      if(zprof(j).eq.zero) then
        jsave1=j-1
        zx1=xi(jsave1)
        zf1=zprof(jsave1)
        isrch=2
      endif
    else if(isrch.eq.2) then
      !  find end of zeroed section
      if(zprof(j).ne.zero) then
        jsave2=j
        zx2=xi(jsave2)
        zf2=zprof(jsave2)
        isrch=1
        !  apply patch
        do jj=jsave1+1,jsave2-1
          zx=xi(jj)
          zf=zf1+(zf2-zf1)*(zx-zx1)/(zx2-zx1)
          zprof(jj)=zf
          zprof(jj)=max(zero,zprof(jj))
        enddo
      endif
    endif                          ! isrch mode
  enddo                             ! j loop
  !
1000 continue
  return
end subroutine chk_extrapolate

      real function fhermitd(x,zf0,zs0,zf1,zs1,zdfdx)
C
C  C1 Hermite interpolation:  Using cubic basis functions for
C      point and slope matching.
C
C  also return the derivative as zdfdx
C
C      Interpolation is onto interval [0,1]; x in [0,1]
C  caution -- this may involve a change of variables!  Typically, caller
C  wants to multiply zs0,zs1 by zh for input, and divide zdfdx by zh for
C  output, in addition to transforming to x, to get the slopes right!
C
C      D. McCune 31 Oct 1996
C
C  basis functions:
C     0 at x=0, 1 at x=1, slope 0 at both ends:
C        f1(x)=3*x**2 - 2*x**3
C     1 at x=0, 0 at x=1, slope 0 at both ends:
C        f1(x)=3*xbar**2 - 2*xbar**3
C
      f(x)=x*x*(3.0-2.0*x)
      fd(x)=6.0*x*(1.0-x)               ! df/dx
C
C     0 at endpts, slope 1 at x=0, slope 0 at x=1:
C        f1(x)=x - 2*x**2 + x**3
C     0 at endpts, slope 0 at x=0, slope 1 at x=1:
C        f1(x)=xbar - 2*xbar**2 + xbar**3
C
      s(x)=x*(1.0-x*(2.0-x))
      sd(x)=1.0+x*(3.0*x-4.0)           ! ds/dx
C
C-----------------------------------------
C
      if((x.lt.0.0).or.(x.gt.1.0)) then
         write(6,1001) x
 1001    format(' ?fhermitd:  x=',1pe14.7,' outside interval [0,1]')
         fhermitd=0.0
         return
      endif
C
      xbar=1.0-x                        ! d(xbar)/dx = -1
C
      zans=zf0*f(xbar) + zf1*f(x) + zs0*s(x) - zs1*s(xbar)
C
      zdfdx=zf1*fd(x) - zf0*fd(xbar) +zs0*sd(x) +zs1*sd(xbar)
C
      fhermitd=zans
C
      return
      end

      subroutine addaepuf(lun,signam,nscd,nsca,scval,sclab,ier)
 
C Add AEP as Scalars to MDSplus
C
      implicit none
C
      integer       lun          ! lun for error messages
      character*(*) signam
      integer       nscd,nsca    ! size of array / actual
      real          scval(nscd)  ! Scalar values
      character*30  sclab(3)  ! scalar labels
      integer       ier, S_CVAL(1)
      character*30  s_clab(1),XLAB, YLAB
      integer :: IPROC,IFLAG,ilen
      ier=0
      IPROC=0 !raw data
      IFLAG=0
      S_CVAL(1)=0.0
      s_clab(1)=trim(adjustl(sclab(1)))//','//trim(adjustl(sclab(3)))
      xlab=" "
      ylab=" "
      ilen=len(trim(adjustl(sclab(2))))
      XLAB(21:21+ilen-1)= trim(adjustl(sclab(2)))
      ilen=len(trim(adjustl(sclab(3))))
      YLAB(21:21+ilen-1)=trim(adjustl(sclab(3)))
      call add1duf(lun,signam,
     >     SCVAL,SCVAL,nscd,IPROC,
     >     nsca,IFLAG,
     >     XLAB,YLAB,
     >     1,0,S_CVAL,S_CLAB,
     >     IER)
      return
      end

C----------------------------------------------------------------------
C  UPCGET -- RETURN CHARACTER LAST ENTERED BY USER UPON UPAUSE CALL
C
      SUBROUTINE UPCGET(ZCHAR)
C
      USE USERIO
C
      CHARACTER*1 ZCHAR
C
      ZCHAR=UPCHAR
C
      RETURN
      END

	subroutine coulog(et,at,zt,denb,tempb,ab,zb,cln,nb,Bmag,
     >                    llstix)
C
C (See the warnings below about some (usually small) uncertainties in
C certain parameter regimes.)
C
C calculates the Coulomb logarithm for a test particle of energy et
C (kev), atomic mass at and atomic charge zt, colliding with NB
C maxwellian background species with densities denb (/m**3),
C temperatures tempb (keV), atomic masses ab, atomic charges zb.  The
C electrons should be included as one of the background species, with
C Z=-1 and A=(1./1836.1).  The list of Coulomb logarithms is returned
C in cln.  The magnetic field should be input as bmag (Tesla).
C
C Note that the test particle loglambda's produced by this subroutine
c are not symmetric, i.e. it is not true that
c loglam_alpha_beta=loglam_beta_alpha.  If such symmetry is desired,
c one should set Et=(3/2)T_t and call this routine twice with species
c alpha and beta switched, and take the average value of the log_lambda's
c that are returned.
C
C Written by Greg Hammett, 16-May-1989.
C
C The exact details of the Coulomb logarithm are probably not worth
C worrying about too much.  It has the form
C
C    log(Lambda) = log(r_max/r_min)
C
C For typical values of log(Lambda) ~ 18, a factor of 2 difference in 
C r_max/r_min gives only a 4% correction to log(Lambda).  Since the whole
C assumption of small-angle scattering in the Fokker-Planck approximation
C to the collision operator is only accurate to ~O(1/log(Lambda)), this is
C good enough for most purposes.  Often the most important correction is
C the difference between the classical and quantum r_min, which can give about
C an 18% difference in log(Lambda) at T_e=10 keV and n_e=1.e20/m^3 (using the
C simplified thermal expressions in the NRL formulary).
C
C The recipe I use here is similiar to the
C one given in the NRL plasma formulary.  So it includes the quantum
C mechanics correction which is usually important for collisions with
C electrons.  Rather than completely ignoring the Debye shielding by
C particles with vthermal < v, it contains a smooth transition which I
C have rigorously shown (so I have thought) from the Balescu-Lenard
C to be correct in the limits vthermal>>v and vthermal<<v.
C
C In 1989 I wrote the following, which I now think overstates an issue:
C (However, the Balescu-Lenard
C operator predicts a substantial amount of Cerenkov radiation of
C plasma waves if the particle speed exceeds the electron thermal
C speed.  I am ignoring this Cerenkov radiation (and its associated
C drag).  To look at it properly, Nat Fisch claims that one would have
C to consider the reabsorption of the Cerenkov radiation as well.)
C
C I think it was first in 1991 that I found more accurate ways of
C evaluating the integrals in the Balescu-Lenard operator for energetic
C particles, leading to the comment below:
C
C Warning (usually small): GWH 3/1/91 (updated 4/7/2016): 
C
C The formulas I am using here reduce Debye shielding somewhat and thus
C increase the drag rate somewhat (via a slow logarithmic factor) if the
C test particle is much faster than the *thermal electrons* (like an
C electron tail).  This corresponds to a (usually small) enhancement of
C the effective log(Lambda) factor by Cerenkov radiation.  This fast
C particle limit is not discussed much in the literature or in textbooks,
C but I think the formulas here are at least roughly okay (usually good to
C a few percent), and are fairly consistent with what one gets from the
C Balescu-Lenard collision operator for high velocity particles colliding
C with thermal particles.  At one time I thought that the Balescu-Lenard
C operator blew up in this limit, but I later found how to do the
C complicated asymptotics of the integrals in this regime properly, and
C it asymptotically has the form given here (if I did the calculations
C right).  Comparing with the Perkins 1965 article cited below also
C supports the formulas here, for the case of very fast ions (faster
C than thermal electrons) slowing down on thermal electrons.  (Compare
C with Eqs. 26 and 28 in Perkins 1965.)  The formulas here also agree
C with Perkins 1965 on the energy drag rate for fast electrons slowing
C down on thermal electrons, but there are some differences for the
C electron drag rate (the rate of loss of directed momentum, sometimes
C called dynamical friction), and for slowing down of fast ions or
C electrons on thermal ions (but for high velocity ions, drag on thermal
C ions is weak compared to drag on thermal electrons anyway).
C
C The biggest difference between the formulas here and in Perkins might
C be for the dynamical friction drag rate for runaway electrons in a
C cold plasma.  The formula here says
C
C    b_max ~ (v/v_t) b_max_thermal, 
C
C while Perkins Eq. 28 appears to have
C
C    b_max ~ (v/v_t)^(1/2) b_max_thermal.
C
C So the Perkins formula would reduce the log(Lambda) here by 
C log((v_t/v)^(1/2)).  For a 100 keV electron colliding with 10 eV
C thermal electrons, that would reduce ln(Lambda) by about 2.3, or
C about 20% at ln(Lambda) ~ 10.
C
C End of 2016 comment/warning.

C
C The main references for this stuff are D.V. Sivukhin, Reviews of
C Plasma Physics, Vol. 4 (1966) (especially good on quantum corrections,
C physical insight), Trubnikov, Reviews of Plasma Physics, Vol. 1
C (1963) (simple, complete derivation of Fokker-Planck equation,
C complete with justification for the Coulomb Logarithm in terms of
C deriving the collision operator from the dielectric response of the
C plasma), Rob Goldston's Ph.D. thesis (references on strong magnetic
C field corrections, collisions with multi-electron impurities),
C Krommes' class notes on the derivation of the Landau operator from the
C Balescu-Lenard operator, and my notes on Krommes' notes relating to
C the problem when the test particle is much faster than the thermal
C electron velocity.
C
	real et,at,zt,Bmag
	real denb(nb),tempb(nb),ab(nb),zb(nb),cln(nb)
 
	Logical llstix       ! tbt 7/10/95
 
c
c first calculate the maximum impact parameter, rmax:
c
c rmax=( sum_over_species omega2/vrel2 )**(-1/2)
c
c where,
c omega2 = omega_p**2 + omega_c**2
c vrel2=T/m+2.*E_t/m_t
c
	sum=0.0
	do 100 i=1,nb
 	omega2=1.74*zb(i)**2/ab(i)*denb(i)
	1 +9.18e15*zb(i)**2/ab(i)**2*Bmag**2
	vrel2=9.58e10*(tempb(i)/ab(i) + 2.*et/at)
100	sum=sum+omega2/vrel2
	rmax=sqrt(1./sum)
 
c next calculate rmin, including quantum corrections.  The classical
C rmin is:
c
C rmincl = e_alpha e_beta / (m_ab vrel**2)
C
C where m_ab = m_a m_b / (m_a+m_b) is the reduced mass.
c vrel**2 = 3 T_b/m_b + 2 E_a / m_a
c (Note:  the two different definitions of vrel2 used in this code
c are each correct for their application.)
c
C The quantum rmin is:
C
C rminqu = hbar/( 2 exp(0.5) m_ab vrel)
C
C and the proper rmin is the larger of rmincl and rminqu
C
	do 200 i=1,nb
	vrel2=9.58e10*(3*tempb(i)/ab(i)+2*et/at)
	rmincl=0.13793*abs(zb(i)*zt)*(ab(i)+at)/ab(i)/at/vrel2
	rminqu=1.9121e-8*(ab(i)+at)/ab(i)/at/sqrt(vrel2)
	rmin=max(rmincl,rminqu)
	cln(i)=log(rmax/rmin)
	if(cln(i) .lt. 1.0) then
	    write(6,*) 'warning from COULOG: coulomb logarithms < 1!'
	    cln(i)=1.0
	endif
 
200	continue

! Another 2016 comment:
!
! Comparing with Perkins, 1965,  Phys. Fluids 8, 1361, for v>>v_te, 
! and focussing on just the log(Lambda) for the fast particle energy
! loss rate on thermal electrons (the g_1(v) term in his Eq. 26)
! suggests that the above should be modified from:
!
!    ln(Lambda) = log(r_max/r_min)
!
! to
!
!    ln(Lambda) = ln(exp(0.5)/1.467*r_max/r_min)
!               = ln(1.12*r_max/r_min)
!
! This is only a very minor correction!!! (If I did the calculation right.)
! One could eventually also check other regimes and thus the Pade
! interpolation formulas. 
!
! Could further modify the above formula to be
!
!    ln(Lambda) => ln(sqrt(1+(1.12*r_max/r_min)**2))
! 
! This can be derived from the calculation for the dynamical friction
! drag rate, and gives a positive value for ln(Lambda) for all possible
! r_max/r_min, but it is not correct compared to molecular dynamics
! simulations for small r_max/r_min, where certain correlation effects
! become important.
!
! Expanding for large Lambda, we get
!
!    ln(sqrt(1+(C*Lambda)^2)) = ln(C*Lambda)*ln(sqrt(1+1/(C*Lambda)^2))
!                             ~ ln(C*Lambda) + 0.5/(C*Lambda)^2
! 
! and it is known that there are other corrections of order
! 1/sqrt(Lambda_eff) (see Perkins 1965, if I understand him right).
! Perkins calculates the first order correction C, but no one (I think)
! has tried to go beyond that.  These other terms would dominate over
! the above 0.5/Lambda_eff^2 term.  Also, although one could in 
! principle calculate the dynamical drag rate or the mean energy loss
! rate to arbitrary order in 1/Lambda, the whole assumption that
! small-angle scattering dominates breaks down so that a Fokker-Planck
! form for the collision operator is no longer valid and one should
! use a Boltzmann collision operator and include large-angle
! scattering.
!
! See papers by Baalrud et al. for a better transition to the strongly coupled 
! regime.  An improved fit is if r_max is limited to be no smaller than
! 1/n^(1/3), the average interparticle spacing.  But I think even that does 
! not do as well as empirical fits to molecular dynamics (MD) simulations of
! the strongly-coupled regime.

c debug section:  set all log(lambda)'s to a simple formula for
c log(lambda_e) to benchmark with Stix's solutions:
 
	if(llstix) then
	do 300 i=1,nb
300	cln(i)=24.0-alog(sqrt(denb(1)/1.e6)/(tempb(1)*1000.))	
	endif
 
	return
	end

C******************** START FILE UFINIT.FOR ; GROUP UFILES *************
C-----------------------------------------------------------------
C  UFILES
C  ROUTINES FOR ASCII DATA FILE SYSTEM
C  ASCII FILES TO HANDLE 1- AND 2-D NUMERIC DATA IN A SIMPLE
C  MANNER WITH MINIMAL ASSOCIATED SUPPORT INFORMATION
C
C  SYSTEM IS NOT INSTANTANEOUSLY TRANSPORTABLE FROM COMPUTER TO
C  BUT AIM IS TO KEEP SYSTEM SIMPLE ENOUGH THAT CONVERSION
C  TIME IS SMALL
C
C  CONVERTED FROM DAS-10 ORIGINAL FOR USE ON DAS VAX
C  D. MC CUNE 8 DEC 1981
C-----------------------------------------------------------------
C
      SUBROUTINE UFINIT
C
      USE UFILES
      LOGICAL LFINIT
C
      CHARACTER*80 ZJUNKA
C
      DATA LFINIT/.FALSE./
C
C  INITIALIZE COMMON
C
      IF(LFINIT) RETURN
      LFINIT=.TRUE.
C
      LUFCAP=1  ! default:  Ufile names capitalized.
C
C  SET RECORD SIZE DEFAULT -- dmc Jan 1992 -- maintaining 2000 as
C  the default, while expanding UFMAXR
C
      UFRSIZ=min(2000,UFMAXR)
C
      UFCHAN=UFPACH
      DO 10 I=1,UFCHAN
        LUFSET(I)=.FALSE.
        mds_socket(i)=0
        mds_shot(i)=0
 10   CONTINUE
C
      UDDEV='                '
      LDDEV=0
C  ERROR OUTPUT L.U.N. (DEFAULT TO TTY)
      UFELUN=6
C
      CALL UJUNK('TMPDIR_TR',ZJUNKA,IER)
      ilen=len(zjunka)
      do ic=1,ilen
          if(zjunka(ic:ic).ne.' ') go to 15
      enddo
      ic=1
 15   continue
      ilnb=ic
      ujunka=zjunka(ilnb:ilen)
C
      IF(IER.EQ.1) THEN
        iluj=ilnurd(ujunka)
        WRITE(UFELUN,9001) ujunka(1:iluj)
 9001   FORMAT(/
     >' %UFINIT -- using root directory for temporary files:'/1x,a)
        CALL UFPAUS(1)
      ELSE IF(IER.GT.1) THEN
        WRITE(UFELUN,9002) IER
 9002   FORMAT(/
     >' ?UFINIT -- FATAL ERROR IER=',I4,' DEFINING TEMPORARY FILE AREA')
        CALL UFPAUS(1)
      ENDIF
C
C  COMPRESSION DATA LOSS - ERROR STATS
      UFCLUN=19
C
C  INFORMATIVE MESSSAGE OUTPUT = DEFAULT
C  FULL ERROR MESSAGE OUTPUT = DEFAULT
      UFILEV=21
C
      RETURN
C
      END
C******************** END FILE UFINIT.FOR ; GROUP UFILES ***************

subroutine frantic_lun_set(ilun)

  !  set unit number for messages.  Default is lun6 = 6.

  use frantic_module
  implicit none

  integer, intent(in) :: ilun    ! unit number for messages

  lun6=ilun

  return
end subroutine frantic_lun_set

subroutine frantic_species_za(ing,imp,zzplas,zaplas,insfast,zzbeams)

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  !  Z's are atomic charge, e.g. 1.0 for H
  !  A's are atomic mass, e.g. 2.0 for D

  integer, intent(in) :: ing     ! no. of non-impurity ion thermal species
  integer, intent(in) :: imp     ! no. of impurity thermal species
  integer, intent(in) :: insfast ! no. of fast species (0 OK)
  real(fp), intent(in) :: zzplas(ing+imp)
                                 ! (1): Zimp, (2:ingp1): Z of therm. species
  real(fp), intent(in) :: zaplas(ing+imp)
                                 ! (1): Aimp, (2:ingp1): A of therm. species
  real(fp), intent(in) :: zzbeams(insfast)

  !---------------------------------

  call frantic_species_alloc(ing,imp,insfast)

  if(insfast.gt.0) xzbeams(1:insfast)=zzbeams(1:insfast)
  nsbeam=insfast

  xzplas(1)=-1.0_fp                 ! electrons
  aplas(1)=5.4858026e-4_fp

  xzplas(2)=7.7777777777_fp         ! model impurity -- to be set up later
  aplas(2)=2*xzplas(2)              ! as a profile, if impurity density > 0

  xzplas(3:ing+2)=zzplas(1:ing)     ! non-impurity thermal species
  aplas(3:ing+2)=zaplas(1:ing)

  xzplas(ing+3:ing+imp+2)=zzplas(ing+1:ing+imp)
  aplas(ing+3:ing+imp+2)=zaplas(ing+1:ing+imp)

  nplas=ing+2
  nimp=imp
  
  rmass(1:ing)=aplas(3:ing+2)*1.6726e-24_fp

  epslon=1.0e-34_fp

  lzpflag = .FALSE.                 ! until impurity Z & A profile data given

  return
end subroutine frantic_species_za

subroutine frantic_species_alloc(ing,imp,inbs)

  !  allocate species arrays.  Call this **before** frantic_profile_alloc

  use frantic_module
  implicit none

  integer, intent(in) :: ing    ! no. of non-impurity thermal ion species
  integer, intent(in) :: imp    ! no. of impurity thermal ion species
  integer, intent(in) :: inbs   ! no. of fast ion species

  mig=ing
  mii=mig+1
  mic=mig+2
  mix=ing+imp+2
 
  mibs=max(1,inbs)
 
  allocate(APLAS(mix),XZPLAS(mix)); APLAS=0; XZPLAS=0
  allocate(NSPEC(mig),TWALL(mig),WWALL(mig)); NSPEC=0; TWALL=0; WWALL=0
  allocate(EESCAV(mig),OUTFLX(mig)); EESCAV=0; OUTFLX=0
  allocate(LISPEC(mii)); LISPEC=0
  allocate(FLUXI0(mig),RMASS(mig)); FLUXI0=0; RMASS=0

  allocate(vphi_wall(mig)); vphi_wall=0

  allocate(XZBEAMS(mibs)); XZBEAMS=0
  allocate(npro_set(mix)); npro_set=.FALSE.

  !  set some defaults...

  rcflag = .FALSE.   ! no internally computed recombination

  if(inbs.gt.0) then
    lbflag=.TRUE.
  else
    lbflag=.FALSE.
  end if

  lnflag = .TRUE.

  nneut_s0 = 0       ! no prior neutral source specie...
  nneut_s0p = 0
  nneut_z0p = 0

  msflag = .FALSE.   ! initially...

  return
end subroutine frantic_species_alloc

subroutine frantic_profile_alloc(inzonec)

  !  allocate species arrays.  Call this **after** frantic_species_alloc

  use iso_c_binding, only : fp => c_double
  use frantic_module
  implicit none

  integer, intent(in) :: inzonec  ! no. of radial zones

  integer i

  if(mig.eq.0) then
    write(lun6,*) ' ?frantic_profile_alloc: call out of order.'
    write(lun6,*) '  call  frantic_species_alloc(...) first.'
    call bad_exit
  end if

  nzonec=inzonec
  mj = nzonec+2   ! if this changes see also frantic_module_io (read routine)
  mitrc = nzonec*5

  allocate(RBOUND(mj),RMJRMP(mj),VOL(mj)); RBOUND=0; RMJRMP=0; VOL=0
  allocate(TVOL(mj)); TVOL=0

  allocate(ALPHAX(mj,mj,mig,mig),ALPHAT(mj,mj,mig)); ALPHAX=0; ALPHAT=0
  allocate(BETAX(mj,mig,mig),BETAT(mj,mig)); BETAX=0; BETAT=0
  allocate(PRFLUX(mj,mj,mig,2),PRWFLX(mj,mig,2)); PRFLUX=0; PRWFLX=0
  allocate(TSTOR1(mj,mig)); TSTOR1=0
  allocate(GFUN(mj,mj,mig,mig),dist(mitrc),nzcros(mitrc)); GFUN=0; dist=0; nzcros=0
  allocate(YLOC(mj),WALL(mj,mig)); YLOC=0; WALL=0
  allocate(S0COLD(mj,mig,mig)); S0COLD=0

  allocate(DEN(mj,mic),TEMP(mj,mic),VPHIZ(mj,mic)); DEN=0; TEMP=0; VPHIZ=0
  allocate(BII(mj,mig),BCX(mj,mig),BCXS(mj,mig,mibs)); BII=0; BCX=0; BCXS=0
  allocate(SVRC(mj),VOLSOR(mj,mig)); SVRC=0; VOLSOR=0
  allocate(vsor_mo(mj),vsor_en(mj),vsor_zw(mj)); vsor_mo=0; vsor_en=0; vsor_zw=0
  allocate(XZIMPJ(mj),AIMPJ(mj)); XZIMPJ=0; AIMPJ=0

  allocate(DCOLD(mj,mig),DNEUT(mj,mig)); DCOLD=0; DNEUT=0
  allocate(TNEUT(mj,mig),VPHI0F(mj,mig)); TNEUT=0; VPHI0F=0
  allocate(PRC(mj),PII(mj),PCX(mj),SCX(mj)); PRC=0; PII=0; PCX=0; SCX=0
  allocate(SORI(mj,mig),SORN(mj,mig),SORE(mj)); SORI=0; SORN=0; SORE=0
  allocate(PCXSF(mj),PIISF(mj)); PCXSF=0; PIISF=0
  allocate(TQCX(mj),TQII(mj)); TQCX=0; TQII=0
  allocate(PFLX0M(2,mj),SFLX0M(2,mj),TQFLX0(mj)); PFLX0M=0; SFLX0M=0; TQFLX0=0
  allocate(TQFLX0M(2,mj)); TQFLX0M=0

  allocate(x(nzonec),xb(nzonec+1))
  xb(1)=0
  do i=1,nzonec
    xb(i+1)=(1.0_fp*i)/nzonec
    x(i)=(xb(i)+xb(i+1))/2
  enddo

  return
end subroutine frantic_profile_alloc

subroutine frantic_free
  use frantic_module
  implicit none

  ! deallocate all...

  if(allocated(aplas)) call frantic_free_species
  if(allocated(alphax)) call frantic_free_profiles
  call frantic_free_x_user

  return
end subroutine frantic_free

subroutine frantic_free_species
  use frantic_module
  implicit none

  deallocate(APLAS,XZPLAS,NSPEC,TWALL,WWALL,vphi_wall,npro_set)
  deallocate(EESCAV,OUTFLX)
  deallocate(LISPEC,FLUXI0,RMASS,XZBEAMS)
  mig=0

  return
end subroutine frantic_free_species

subroutine frantic_free_profiles
  use frantic_module
  implicit none

  deallocate(ALPHAX,ALPHAT,BETAX,BETAT)
  deallocate(PRFLUX,PRWFLX,TSTOR1)
  deallocate(GFUN,DIST,NZCROS)
  deallocate(RBOUND,RMJRMP,VOL,TVOL)
  deallocate(YLOC,WALL,S0COLD)
  deallocate(DEN,TEMP,VPHIZ)
  deallocate(BII,BCX,BCXS)
  deallocate(SVRC,VOLSOR,XZIMPJ,AIMPJ)
  deallocate(vsor_mo,vsor_en,vsor_zw)

  deallocate(DCOLD,DNEUT,TNEUT)
  deallocate(VPHI0F,PRC,PII,PCX,SCX)
  deallocate(SORI,SORN,SORE)
  deallocate(PCXSF,PIISF)
  deallocate(TQCX,TQII)
  deallocate(PFLX0M,SFLX0M,TQFLX0,TQFLX0M)
  deallocate(x,xb)

  call frantic_free_x_user

  mj=0

  if(allocated(npro_set)) npro_set = .FALSE.

  nneut_s0 = 0       ! now, no prior neutral source specie...
  nneut_s0p = 0
  nneut_z0p = 0

  msflag = .FALSE.   ! initially...

  return
end subroutine frantic_free_profiles

subroutine frantic_free_x_user
  use frantic_module
  implicit none

  if(allocated(x_user)) then
    deallocate(x_user,xb_user,volxb_user,Rmajxb_user)
  end if

  return
end subroutine frantic_free_x_user

C******************** START FILE UIOTOP.FOR ; GROUP UREAD5 ******************
C=====================================================
C&  UIOTOP  SUBROUTINE TO OPEN INDIRECT OUTPUT FILE
C
C    FILE RECORDS USER/PROGRAM INTERACTION FOR FUTURE
C    REFERENCE.  ALLOWS CREATION OF FILES WHICH
C    GIVE CAPABILITY OF AUTOMATIC CONTROL OF
C    INTERACTIVE MAIN PROGRAM USING "UREAD.FOR" ROUTINES
C
C   BBUFF-- PROGRAM PROMPT *** NOW IN COMMON ***
C   NCHARA-- # OF CHARACTERS IN PROMPT BEFORE "$" DELIMITER
C   ZFILE-- NAME OF FILE TO CREATE
C   IER  -- ERROR RETURN CODE IER=0 = SUCCESS
C                             IER=1 = COULDNT OPEN
 
 
      SUBROUTINE UIOTOP(ZFILE,IER)
C 
      USE USERIO
C
      CHARACTER*(*) ZFILE
C
      character*96 :: zuname,zudate
C
C  START OF EXECUTABLE CODE
C
      IER=0
C
        ILFILN=INDEX(ZFILE,' ')-1
        IF(ILFILN.LE.0) ILFILN=LFILN
C
      INLUN=MAX0(NLUNIN,NLUNIO)+1
      ILUN=LUNTIN(INLUN)
      WRITE(LUNTRM,2001) ZFILE(1:ILFILN)
 2001 FORMAT(' UIOTOP: >CREATING UREAD FILE "',A,'"')
      OPEN(UNIT=ILUN,file=ZFILE,status='OLD',ERR=235)
      WRITE(LUNTRM,9001)
      CLOSE(UNIT=ILUN)
      write(luntrm,*) '(moved to '//trim(zfile)//'~)'
      call frename(trim(zfile),trim(zfile)//'~',istat)
C  OK--  NEW FILE TO BE CREATED
 235  CONTINUE
      CALL URDOPEN(ILUN,ZFILE,2,IERR)
      IF(IERR.NE.0) GO TO 237
      NLINDO=.TRUE.
C
      NLUNIO=INLUN
      LUNIDO=ILUN

      call uspget('$DATE',zudate,idum)
      call uspget('$LOGIN',zuname,idum)
      write(lunido,'(A)') 
     >     '; date: '//trim(zudate)//' username: '//trim(zuname)
      call fort_flush(lunido)

C  SAVE NAME OF OUTPUT INDIRECT FILE
      XFILE(INLUN)=ZFILE
      NCMND(INLUN)=0
C
      RETURN
C  ERROR
 237  CONTINUE
      WRITE(LUNTRM,9002) ZFILE(1:ILFILN)
      IER=1
      RETURN
C
C  FORMATS
C
 9001 FORMAT(' % UIOTOP: WARNING - FILE ALREADY EXISTS')
 9002 FORMAT(' ? UIOTOP: ERROR TRYING TO OPEN INDIRECT FILE : ' / A)
      	END
C******************** END FILE UIOTOP.FOR ; GROUP UREAD5 ******************

!******************* START FILE DOINT_Z.FOR ; GROUP TESZIG ********************
!==============================================================================
!
SUBROUTINE DOINT_Z(FUN,ARRAY,N2,N1,ZL2,ZL1)
!
!  CALL INTEGRATOR (FUNCTION FUN
!  EXTERNAL-DECLARED IN CALLER) AND FILL ARRAY
!
!  FUN(W0,TI)  W0--NEUT ENERGY (KEV)  TI -- ION TEMP (KEV)
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod, only : VCFAC,ifun
  use physconst_mod, only : zero,one,two,mp_g
  IMPLICIT NONE
  INTEGER n2,n1,i2,iwf,i1,ixf,ixf2
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) w0,ti,fun,zf1,zs1,zer,zs,sigall_z,&
       zvr,zsv,zvi2,zx1,zxf,zff,zffp,zsf,zshft,za3,za2,zzx,zans,&
       zansx
!============
  EXTERNAL FUN
  real(fp) :: ARRAY(N2,N1),ZL1(N1),ZL2(N2)
!
!------------------------------------------------------------------------------
!
  DO I2=1,N2  ! neutral ptcl energy
     W0=ZL2(I2)
     IWF=0
     DO I1=N1,1,-1
        TI=ZL1(I1)
        IF((W0.GT.1.e+3_fp*TI).AND.&
             ((I1.GT.2).OR.(IWF.GT.0))) GO TO 7
!-------------------
! ... DO THE INTEGRAL
        ARRAY(I2,I1)=FUN(W0,TI)
        cycle
!-------------------
! ... TRANSFORM FROM INTEGRAL TO APPROXIMATION CONTINUOUSLY
7       CONTINUE
        IF(IWF.GT.0) GO TO 8
        IWF=1
!  USE APPROXIMATIONS WHEN W0 >> TI
        IF(IFUN.EQ.6) THEN
           ZF1=zero
           ZS1=zero
        ELSE
           ZER=1.e+3_fp*W0+1.5e+3_fp*ZL1(1)
           ZS=1.e+4_fp*SIGALL_Z(ZER*1.e-3_fp,ZVR)
           ZVR=ZVR*100.0_fp
!
           ZSV=ZS*ZVR
           ZVI2=1.5e+3_fp*ZL1(1)*two*1.6029e-12_fp/mp_g
           IF(IFUN.LE.3) ZF1=ZSV
           IF((IFUN.EQ.4).OR.(IFUN.EQ.5)) ZF1=ZSV*ZVI2
           ZS1=zero
           IF(IFUN.GE.4) ZS1=ZL1(1)/ZF1*3.e+3_fp*ZSV*1.6029e-12_fp/mp_g
           ZF1=log10(ZF1)
        ENDIF
        ZX1=log10(ZL1(1))
!
        IXF=I1+1
        IXF2=I1+2
!
        ZXF=ZL1(IXF)
        ZXF=log10(ZXF)
!
        IF(IFUN.NE.6) THEN
           ZFF=ARRAY(I2,IXF)
           ZFF=log10(ZFF)
           ZFFP=log10(ARRAY(I2,IXF2))
        ELSE
           ZFF=ARRAY(I2,IXF)/SQRT(ZL1(IXF))
           ZFFP=ARRAY(I2,IXF2)/SQRT(ZL1(IXF2))
        ENDIF
        ZSF=(ZFFP-ZFF)/(log10(ZL1(IXF2))-ZXF)
!
        ZSHFT=ZX1
        ZX1=zero
        ZXF=ZXF-ZSHFT
!
        ZA3=one/(ZXF*ZXF)*((ZSF-ZS1)+two*(ZS1*ZXF+ZF1-ZFF)/ZXF)
        ZA2=one/ZXF*(3.0_fp*(ZFF-ZF1-ZS1*ZXF)/ZXF+(ZS1-ZSF))
!
8       CONTINUE
        ZZX=log10(ZL1(I1))-ZSHFT
        ZANS=((ZA3*ZZX+ZA2)*ZZX+ZS1)*ZZX+ZF1
        IF(IFUN.NE.6) THEN
           ZANSX=10.0_fp**ZANS
        ELSE
           ZANSX=ZANS*SQRT(ZL1(I1))
        ENDIF
        ARRAY(I2,I1)=ZANSX
!
!--------------------------/LOOP END:
!
     enddo
  enddo

!
  RETURN
END SUBROUTINE DOINT_Z
!
!******************* END FILE DOINT_Z.FOR ; GROUP TESZIG **********************
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C-----------------------------------------------------------------------
C  UDBSUB  SUBSTITUTE STR2 FOR STR1 IN LINE -- ALL OCCURRENCES
C
      SUBROUTINE UDBSUB(LINE,STR1,STR2)
C
      implicit NONE
C
      CHARACTER*(*) LINE   ! BUFFER TO MODIFY
      CHARACTER*(*) STR1   ! "FROM" STRING
      CHARACTER*(*) STR2   ! "TO" STRING
C
C---------------
C
      INTEGER IFND(256)
C
      integer iltot,illin,ils1,ils2,inum,ic,ic0,idif,ishift
      integer ic0p,ict,icti,ilim,ilnurd
C---------------
C
      ILTOT=LEN(LINE)
      ILLIN=ILNURD(LINE)  ! LENGTH W/O TRAILING BLANKS
C
      ILS1=ILNURD(STR1)
      ILS2=ILNURD(STR2)
      IF(ILS1.EQ.ILS2) THEN
        IF(STR1.EQ.STR2) RETURN  ! NO CHANGE NEEDED
      ENDIF
C
C  INDEX OCCURRENCES OF STR1 IN LINE
C
      INUM=0
      IC=ILLIN+1
C
 10   CONTINUE
      IC=IC-1
      IC0=IC-ILS1+1
      IF(IC0.LE.0) GO TO 100
C
      IF(LINE(IC0:IC).EQ.STR1(1:ILS1)) THEN
        INUM=INUM+1
        IFND(INUM)=IC0
        IC=IC0
      ENDIF
C
      GO TO 10
C
C  CHECK IF SUBSTITUTIONS CAN BE MADE
C
 100  CONTINUE
C
      IF(INUM.EQ.0) RETURN
C
      IDIF=ILS2-ILS1
      IF((ILLIN+INUM*IDIF).GT.ILTOT) THEN
        write(6,9001) LINE(1:ILLIN),STR1(1:ILS1),STR2(1:ILS2)
 9001   FORMAT(
     >' ?UDBSUB -- BUFFER OVERFLOW, CANNOT PERFORM SUBSTITUTION'/
     >'  BUFFER:  ',A/'  FROM STRING:  ',A/'  TO STRING:  ',A/)
        RETURN
      ENDIF
C
C  DO SUBSTITUTIONS - ALGORITHM DEPENDS ON SIGN OF IDIF
C
      IF(IDIF.LE.0) THEN
C
C  NO SHIFT OR LEFT SHIFT BECAUSE TO STRING IS OF SAME LENGTH OR
C  SHORTER
C
        ISHIFT=0
        ICT=0
 110    CONTINUE
C
        ICT=ICT+1
        IF(ICT.GT.INUM) THEN
          LINE(ILIM+ISHIFT+1:)=' '
          GO TO 500
        ENDIF
C
        ICTI=INUM-ICT+1
        IC0=IFND(ICTI)
        LINE(IC0+ISHIFT:IC0+ISHIFT+ILS2-1)=STR2(1:ILS2)
C
        ISHIFT=ISHIFT+IDIF
C
        IF(ICT.LT.INUM) THEN
          ILIM=IFND(ICTI-1)-1
        ELSE
          ILIM=ILLIN
        ENDIF
C
        IF(ISHIFT.EQ.0) GO TO 110
        DO 120 IC=IC0+ILS1,ILIM
          LINE(IC+ISHIFT:IC+ISHIFT)=LINE(IC:IC)
 120    CONTINUE
C
        GO TO 110
C
      ELSE
C
C  RIGHT SHIFT BECAUSE TO STRING IS LONGER THAN FROM STRING
C
        ISHIFT=INUM*IDIF
        ICT=INUM+1
        IC0=ILLIN+1
C
 210    CONTINUE
C
        ICT=ICT-1
        IF(ICT.EQ.0) GO TO 500
C
        IC0P=IC0
        ICTI=INUM-ICT+1
        IC0=IFND(ICTI)
C
        DO 220 IC=IC0P+ISHIFT-1,IC0+ISHIFT+ILS1,-1
          LINE(IC:IC)=LINE(IC-ISHIFT:IC-ISHIFT)
 220    CONTINUE
C
        ISHIFT=ISHIFT-IDIF
C
        LINE(IC0+ISHIFT:IC0+ISHIFT+ILS2-1)=STR2(1:ILS2)
C
        GO TO 210
C
      ENDIF
C
 500  CONTINUE
C
      RETURN
      END

C******************** START FILE SPLCRD.FOR ; GROUP TKSERVE ************
C.............................................................
 
        SUBROUTINE SPLCRD (ZXI99, IJACI,
     >                     LCENTR, MIMOM, NMOM, MTBL, XIBLO,
     >                     RMB0,RMB0S,RMB2,RMB2S,YMB2,YMB2S,
     >			   ZRMB0X, ZRMB2X, ZYMB2X,
     >		           ZRMB0P, ZRMB2P, ZYMB2P)
 
C
c  dmc 24 Dec 1996:  this version does not depend on TRCOM
c  ** updown symmetric SPLCRD **
c
c  call from MOMRY/MOMRZ; caller does arg error checking!
c
c  input args:
c
c   ZXI99 -- "xi" (radial coordinate) **** must be in range ****
c     ==> interpolate moments set to "xi"
c   IJACI -- IJAC flag as input (see below)
c
c   LCENTR -- 1 + index offset in XIBLO, RMB0, RMB2, YMB2, rel. to.
c      RMB0S,RMB2S,YMB2S
c      (for TRANSP compatibility; set to 1 if all arrays are on
c      the same indexing grid)
c
c   MIMOM -- max no. of moments (array dimension)
c   NMOM  -- actual no. of moments in use
c   MTBL --- max no. of radial points including "bloat" (array dimension)
c
c   XIBLO(..) -- "xi" grid points, including bloat region beyond plasma bdy
c
c   RMB0(..) -- 0'th R moment array
c   RMB0S(..) -- 0'th R moment spline coeffs
c   RMB2(..) -- higher R moments array
c   RMB2S(..) -- higher R moment spline coeffs
c   YMB2(..) -- higher Y moments array
c   YMB2S(..) -- higher Y moment spline coeffs
c
c  output args:
c   ZRMB0X -- interpolated 0'th R moment
c   ZRMB2X(..) -- interpolated higher R moments
c   ZYMB2X(..) -- interpolated higher Y moments
c  (if IJAC set):
c   ZRMB0P -- 0'th R moment dR0/dxi
c   ZRMB2P(..) -- higher R moments derivatives w.r.t. xi
c   ZYMB2P(..) -- higher Y moments derivatives w.r.t. xi
c
C	EVALUATE SPLINE COEFFICIENTS DIRECTLY ... GIVEN A RADIAL
C	COORD "ZXI99", RETURN THE MHD FOURIER COEFFICIENTS (AND THEIR
C	DERIVATIVES) DESCRIBING THE PLASMA SURFACE ON THAT COORD.
C
C  MOD DMC APRIL 1990 -- LINEAR INTERPOLATION OPTION
C
C  IF IJAC=0 OR IJAC=1 USE THE SPLINES
C  IF IJAC=2 OR IJAC=3 DO LINEAR INTERPOLATION INSTEAD
C
C  IF IJAC=1 OR IJAC=3 EVALUATE DATA FOR THE JACOBIAN
C
C   input arrays:
 
        REAL RMB0(MTBL),RMB0S(MTBL,3),XIBLO(MTBL)
        REAL RMB2(MTBL,MIMOM),RMB2S(MTBL,MIMOM,3)
        REAL YMB2(MTBL,MIMOM),YMB2S(MTBL,MIMOM,3)
 
C   output arrays:
 
        DIMENSION ZRMB2X(MIMOM), ZYMB2X(MIMOM)
        DIMENSION ZRMB2P(MIMOM), ZYMB2P(MIMOM)
 
C
C-------------------------------------
C
        IJAC=abs(IJACI)
C
        ZDXII= 1.0 / (XIBLO(LCENTR+1)-XIBLO(LCENTR))
        IS = ZXI99 * ZDXII + 1
C
 20     continue
        ISL1=IS+LCENTR-1
        if(zxi99.le.xiblo(isl1)) then
           is=is-1
           go to 20
        endif
        if(zxi99.gt.xiblo(isl1+1)) then
           is=is+1
           go to 20
        endif
C
        ZDX99 = ZXI99 - XIBLO(ISL1)
C
C  EVALUATE MOMENTS INTERPOLATION
C
        IF(IJAC.LE.1) THEN
 
C	EVALUATE SPLINE
C
C	  R0(X)
C
           ZRMB0X = RMB0(ISL1) + ZDX99*(RMB0S(IS,1) +
     >			    ZDX99*(RMB0S(IS,2) +
     >			    ZDX99*RMB0S(IS,3)))
 
 
           DO 100 J = 1, NMOM
 
C	      RM(X)
            ZRMB2X(J) = RMB2(ISL1,J) + ZDX99*(RMB2S(IS,J,1) +
     >			   ZDX99*(RMB2S(IS,J,2) + ZDX99*RMB2S(IS,J,3)))
C	      YM(X)
            ZYMB2X(J) = YMB2(ISL1,J) + ZDX99*(YMB2S(IS,J,1) +
     >			   ZDX99*(YMB2S(IS,J,2) + ZDX99*YMB2S(IS,J,3)))
 
 100       CONTINUE
 
        ELSE
C
C  EVALUATE BY LINEAR INTERPOLATION
C
           ISP1=ISL1+1
           ZDX99I=ZDX99*ZDXII
C
           ZRMB0X=RMB0(ISL1)+ZDX99I*(RMB0(ISP1)-RMB0(ISL1))
C
           DO 110 J = 1, NMOM
 
            ZRMB2X(J)= RMB2(ISL1,J)+ZDX99I*(RMB2(ISP1,J)-RMB2(ISL1,J))
            ZYMB2X(J)= YMB2(ISL1,J)+ZDX99I*(YMB2(ISP1,J)-YMB2(ISL1,J))
 
 110       CONTINUE
 
        ENDIF
 
C..................................
 
      IF (IJAC.EQ.0) RETURN
      IF (IJAC.EQ.2) RETURN
 
C..................................
 
C
C  EVALUATE DERIVATIVES
C
 
        IF(IJAC.LE.1) THEN
C
C  SPLINES
C
C	  D[R0(X)]/DX
           ZRMB0P = RMB0S(IS,1) + ZDX99*(2.*RMB0S(IS,2) +
     >		     3.*ZDX99*RMB0S(IS,3))
 
           DO 200 J = 1, NMOM
 
C	  D[RM(X)]/DX
            ZRMB2P(J) = RMB2S(IS,J,1) + ZDX99*(2.*RMB2S(IS,J,2) +
     >			   3.*ZDX99*RMB2S(IS,J,3))
C	  D[YM(X)]/DX
            ZYMB2P(J) = YMB2S(IS,J,1) + ZDX99*(2.*YMB2S(IS,J,2) +
     >			   3.*ZDX99*YMB2S(IS,J,3))
 
 200       CONTINUE
 
        ELSE
C
C  LINEAR INTERPOLATION
C
           ZRMB0P=(RMB0(ISP1)-RMB0(ISL1))*ZDXII
C
           DO 210 J = 1, NMOM
 
            ZRMB2P(J) = (RMB2(ISP1,J)-RMB2(ISL1,J))*ZDXII
            ZYMB2P(J) = (YMB2(ISP1,J)-YMB2(ISL1,J))*ZDXII
 
 210       CONTINUE
 
        ENDIF
C
        RETURN
        END
C******************** END FILE SPLCRD.FOR ; GROUP TKSERVE **************

C----------------------------------------------------------------------
C  URDCRI  - SET/CLEAR OPTION TO ACCEPT (CR) BLANK LINE AS VALID INPUT
C
C  UREAD SYSTEM SUBROUTINE
C
      SUBROUTINE URDCRI(IOPT)
C
      USE USERIO
C
      IF(IOPT.EQ.1) THEN
        NLCRI=.TRUE.
      ELSE
        NLCRI=.FALSE.
      ENDIF
C
      IF(LEVCMD.LE.1) NLNULL=NLCRI
C
      RETURN
      END

C******************** START FILE UFOPEN.FOR ; GROUP UFOPEN *************
c
C--------------------------------------------------------------
C  UFOPEN
C  OPEN SEQUENTIAL FILE ON UNIT ILUN
C
      SUBROUTINE UFOPEN(ILUN,ZFILE,ICOD,IER,IBIN)
#ifdef __NAGWARE
      use f90_unix_proc
#endif
c
      implicit NONE
c
#include "fpreproc/byte_declare.h"
c
C  ILUN-- UNIT NUMBER
C  ZFILE- CHARACTER FILENAME
C  ICOD-- =1 FOR READ ACCESS
C         =2 FOR WRITE ACCESS
C  IER--- ERROR RETURN (IOSTAT ON OPEN) CODE 0= NORMAL
C
C-------------------------------------------------------------
C  ** modified DMC ** using new portlib routine, is_ascii, to test
C       whether a file is ASCII or not.  I find the "file" command
C       is not to be trusted for portability...
C
C  ** Modified TBT Dec 2000 ** added check for "commands text" as well
C                                          as    " ascii text".
C                              Failing on uscws8.gat.com where file command
C                              returns "commands text".
C                              Added check for "text"
C                              If file protection has "x" turned on,
C                              file command returns "commands text" rather
C                              than "ascii text".
C  ** MODIFIED CAL Aug 1998 ** use "jsystem" don't use csh/isbinary
C
C  ** MODIFIED CAL Jul 1997 ** Check for HDF, netCDF
C
C  ** MODIFIED DMC SEP 1993 ** FOR PORTABILITY, THE OPEN STATEMENTS
C    HAVE BEEN MOVED TO SUBROUTINES GENOPEN AND IOPEN, WHICH ARE
C    CALLED FROM HERE.
C
C  ** MODIFIED DMC APR 1984 **
C    SUPPORT BINARY SEQUENTIAL ACCESS
C
C  argument IBIN -- input if file is OPEN for WRITE (ICOD=2)
C    IBIN-- 0 FOR ASCII
C           1 FOR BINARY ACCESS (could be netCDF or old Ufiles binary or...)
C           2 For a different binary format (Ufiles loss free compressed)
C           3 For HDF
C           4 For NetCDF
C
C  on OPEN for READ (ICOD=1) set IBIN=-1 to have UFOPEN test
C
C              or binary (return IBIN=1)
C        Ufiles new compressed binary (return IBIN=2)
C                  HDF   (return IBIN=3)
C
C
C  on OPEN for READ if IBIN is NOT -1, assume the caller already
C  knows the file is ascii (IBIN=0) or binary (IBIN=1).
C
C  if open for READ and IBIN = -1, the input file type has to
C  be tested.
C
C
      integer ilun,icod,ier,ibin
C
      CHARACTER*(*) ZFILE
C
      integer str_length
C
      byte_declare btest(512), bref(8), hdf_id(4), cdf_id(4)
C
      integer nf_noerr,nf_nowrite
C
      parameter (nf_noerr = 0)
      parameter (nf_nowrite = 0)
C
      integer ilf,i,ios,iascii,idcdf,nf_open,nf_close,irecl
C
#if __CRAY
      data bref/char(0),char(127),char(0),char(127),
     >          char(0),char(127),char(0),char(127)/
      data hdf_id/char(14), char(3), char(19), char(1)/
#elif __SX
C Doug's portable signature
      data bref/'00'x, '7F'x,'00'x, '7F'x,'00'x,'7F'x,'00'x,'7F'x/
C HDF signature
      data hdf_id/'0e'x, '03'x,'13'x,'01'x/
#else
      data bref/0,127,0,127,0,127,0,127/
      data hdf_id/   14,     3,   19,    1/
#endif
C
C-----------------------------------------------------------------------
C
      ilf=str_length(zfile)
      if(ilf.le.0) then
         write(6,'('' ?UFOPEN:  null filename argument.'')')
         ier=99
         return
      endif
C
C
C  CHECK ARGUMENTS
      IF(ICOD.EQ.1) THEN
C...OPEN for READ
        IF((IBIN.ge.0) .and. (IBIN.le.4)) GO TO 60
        IF(IBIN.EQ.-1) GO TO 10  ! TEST FILE TYPE ASCII OR BINARY
      ELSE IF(ICOD.EQ.2) THEN
C...OPEN for WRITE
         IF((IBIN.ge.0).and.(IBIN.le.4)) GO TO 100
      ENDIF
C
      IER=-1
      WRITE(6,9901) ICOD,IBIN,ZFILE(1:ilf)
 9901   FORMAT(
     >' ?UFOPEN -- INVALID ARGUMENTS, ICOD=',I8,' IBIN=',I8/
     >'  FILE "',A,'" NOT OPENED.')
      RETURN
c-----------------------------------------------------------------------------
C
C-------------------------------
C  TEST FILE TYPE
C
 10   CONTINUE
C
      IBIN=0
C
C ** read access ** determine if file is binary or ascii
C (support binary Ufiles)
C
      call is_ascii(zfile,iascii,ier)
      if(ier.eq.0) then
         if(iascii.eq.1) then
            IBIN=0
         else
            IBIN=1
         endif
      endif
C
C  check for new type of binary Ufile --
C
      if(ibin.eq.1) then
         call cftopen(ilun,zfile(1:ilf),'rb',1,ier)
         if(ier.ne.0) go to 57
         call cftread(ilun,btest,ier)
         if(ier.ne.0) go to 57
         do i=1,8
            if(btest(i).ne.bref(i)) go to 57
         enddo
C
C  OK
         IBIN=2
         go to 58
C
C Check for HDF
 57      do i=1,4
            if(btest(i) .ne. hdf_id(i)) go to 59
         enddo
         IBIN = 3
cxx         type *,'HDF File'
         go to 58
C
C
C     Check for netCDF
 59      continue
         idcdf=-99
         ios = nf_open(zfile(1:ilf),NF_NOWRITE,idcdf)
         if(ios.eq.NF_NOERR) then
            IBIN = 4
            ios=nf_close(idcdf)
cxx            type *,'netCDF File'
         endif
C
 58      continue
         call cftclose(ilun)
      endif
C
C---
C  READ OPEN
C
 60   IOS = 0
C
      IF(IBIN.EQ.0) THEN
        CALL GENOPEN(ILUN,ZFILE,'OLD','ASCII',0,IOS)
      ELSE IF(IBIN.EQ.1) THEN
        CALL GENOPEN(ILUN,ZFILE,'OLD','BINARY',0,IOS)
      ELSE IF(IBIN.EQ.2) THEN
        CALL GENOPEN(ILUN,ZFILE,'OLD','BLOCKD',128,IOS)
      ENDIF
C
      GO TO 500
C
C---
C  WRITE OPEN
C
 100  IOS = 0
C
CCC      write(*,'(a,a)')'In UFOPEN: ZFILE= ',ZFILE
      IF(IBIN.EQ.0) THEN
        CALL GENOPEN(ILUN,ZFILE,'NEW','ASCII',0,IOS)
      ELSE IF(IBIN.EQ.1) THEN
        CALL GENOPEN(ILUN,ZFILE,'NEW','BINARY',0,IOS)
      ELSE IF(IBIN.EQ.2) THEN
        CALL GENOPEN(ILUN,ZFILE,'NEW','BLOCKD',128,IOS)
      ENDIF
C
      GO TO 500
C-------------------------------
 500  CONTINUE
      IER=IOS
      RETURN
      	END
C******************** END FILE UFOPEN.FOR ; GROUP UFOPEN ***************

C******************** START FILE ZFSCC1.FOR ; GROUP CONCTR ******************
C-----------------
C  REAL FUNCTION ZFSCC1
C   NEXT CONTOUR MANTISSA GIVEN CURRENT ONE, AND N= # OF
C   CONTOURS PER DECADE
C
      REAL FUNCTION ZFSCC1(ZCUR,N)
C
      IF(ZCUR.LT.10.0) GO TO 10
      ZFSCC1=10.0
      RETURN
C
 10   CONTINUE
      IF(ZCUR.GE.1.0) GO TO 20
      ZFSCC1=1.0
      RETURN
C
 20   CONTINUE
      DATA NLIM/3/
      IF(N.GT.NLIM) N=NLIM
      IF(N.LT.1) N=1
      IF(ZCUR.NE.1.0) GO TO 30
      GO TO (21,22,23) N
 21   CONTINUE
      ZFSCC1=10.0
      RETURN
 22   ZFSCC1=3.0
      RETURN
 23   ZFSCC1=2.0
      RETURN
 30   CONTINUE
      IF(ZCUR.GT.3.0) GO TO 21
      GO TO (21,21,31) N
 31   CONTINUE
      ZFSCC1=5.0
      RETURN
      	END
C******************** END FILE ZFSCC1.FOR ; GROUP CONCTR ******************

C-----------------------------------------------------------------------
C  URDSTT -- READ FROM VIRTUAL KEYBOARD AND HANDLE ERRORS
C
C    THIS ROUTINE SHOULD BE ONLY CALLED IN AN INTERACTIVE PROCESS
C  THIS DECISION IS THE CALLER'S RESPONSIBILITY
C
      SUBROUTINE URDSTT(ZPROMPT,ZSTR)
      USE USERIO
C
      CHARACTER*(*) ZPROMPT
      CHARACTER*(*) ZSTR
C
C------------------------------------
C
      IECT=0
C
 10   CONTINUE
      CALL URDSTR(ZSTR,IEOF,IERR)
      IF(IEOF.EQ.1) THEN
        WRITE(LUNTRM,'(/'' *** END OF FILE EXIT ***''/)')
        CALL UEXITA(0)
      ELSE IF(IERR.NE.0) THEN
        IECT=IECT+1
        IF(IECT.LE.10) THEN
          WRITE(LUNTRM,'('' _%REPROMPT FOR '',A,'':'')') ZPROMPT
          GO TO 10
        ENDIF
        call bad_exit
      ENDIF
C
      RETURN
      END

      subroutine r4fftsc  (a,n,st,ct,ifail)
c-----------------------------------------------------------------------
c  DMC -- real precision IMSL replacement routine
c         locally allocated, saved workspace objects for each problem
c         size (n) that is seen.  This may not be thread safe;
c         this is only intended to replace copied IMSL routines in some
c         serial TRANSP-related data processing applications.  For codes
c         requiring high performance FFT, use FFTW 2.1.5.
c
c--------------------------------
c   some IMSL comments retained...
c--------------------------------
c                                                                       
c   purpose             - compute the sine and cosine transforms of     
c                           a real valued sequence                      
c                                                                       
c   usage               - call fftsc (a,n,st,ct,iwk,wk,cwk)             
c                                                                       
c   arguments    a      - input real vector of length n which           
c                           contains the data to be transformed.        
c                n      - input number of data points to be transformed.
c                           n must be a positive even integer.          
c                st     - output real vector of length n/2+1            
c                           containing the coefficients of the          
c                           sine transform.                             
c                ct     - output real vector of length n/2+1            
c                           containing the coefficients of the          
c                           cosine transform.                           
c                                         
c              ifail    - 0 on exit: normal
c                       - 1 on exit: could not allocate workspace
c
c   notation            - information on special notation and           
c                           conventions is available in the manual      
c                           introduction or through imsl routine uhelp  
c                                                                       
c   remarks  1.  fftsc computes the sine transform, st, according       
c                to the following formula;                              
c                                                                       
c                  st(k+1) = 2.0 * sum from j = 0 to n-1 of             
c                            a(j+1)*sin(2.0*pi*j*k/n)                   
c                  for k=0,1,...,n/2 and pi=3.1415...                   
c                                                                       
c                fftsc computes the cosine transform, ct, according     
c                to the following formula;                              
c                                                                       
c                  ct(k+1) = 2.0 * sum from j = 0 to n-1 of             
c                            a(j+1)*cos(2.0*pi*j*k/n)                   
c                  for k=0,1,...,n/2 and pi=3.1415...                   
c            2.  the following relationship exists between the data     
c                and the coefficients of the sine and cosine transform  
c                                                                       
c                  a(j+1) = ct(1)/(2*n) + ct(n/2+1)/(2*n)*(-1)**j +     
c                           sum from k = 1 to n/2-1 of                  
c                            (ct(k+1)/n*cos((2.0*pi*j*k)/n) +           
c                             st(k+1)/n*sin((2.0*pi*j*k)/n))            
c                  for j=0,1,...,n-1 and pi=3.1415...                   
c                                                                       
c                                                                       
c-----------------------------------------------------------------------
c
      implicit NONE
c
c                                  specifications for arguments         
      integer            n
      real               a(n),st(*),ct(*)
      integer            ifail
c
c-----------------------------------------------------------------------
c
      type :: fftwk
         integer :: n_size
         real, dimension(:), pointer :: wka => NULL()
      end type fftwk
c
      real, dimension(:), pointer :: wka => NULL()
c
      integer, SAVE :: n_save = 0
c
c  collection of work arrays:
c
      integer, parameter :: nmax=50
      type (fftwk), dimension(nmax), SAVE :: fw
c
c-----------------------------------------------------------------------
      integer :: isize,in2p1,ino2,k1,k2,i,imatch
      real, dimension(:), allocatable :: awk
c-----------------------------------------------------------------------
c
      ifail = 0
c
      if(n.le.0) return
c
      in2p1 = n/2 + 1

      st(1:in2p1) = 0.0
      ct(1:in2p1) = 0.0
c
c-------------------------------
c
      imatch=0
      do i=1,n_save
         if(fw(i)%n_size.eq.n) then
            imatch=i
            exit
         endif
      enddo

      if(imatch.eq.0) then
         if(n_save.eq.nmax) then
            write(6,*) ' ?r4fftsc: nmax exceeded. '
            ifail=1
            return
         endif

         n_save = n_save + 1
         fw(n_save)%n_size = n

         isize = 2*n + 30
         allocate(fw(n_save)%wka(isize)); fw(n_save)%wka = 0.0

         call r4rffti(n,fw(n_save)%wka)

         imatch = n_save
      endif

      wka => fw(imatch)%wka
c
c-------------------------------
c
      allocate(awk(n))
      awk = a
c
      call r4rfftf(n,awk,wka)
c
      ct(1)=awk(1)*2.0
      st(1)=0.0
c
      k1=0
      k2=1
c
      ino2 = (n+1)/2
c
      do i=2,ino2
         k1=k1+2
         k2=k2+2

         ct(i) = awk(k1)*2.0
         st(i) = -awk(k2)*2.0
      enddo
c
      if(ino2.lt.in2p1) then
         k1=k1+2
         ct(i)=awk(k1)*2.0
      endif

      return
      end

c---- tstcon.for	sg demo				21-jan-82
c
c  test sglib contour routines
c
	program contour
	integer   ipole
	character back*1
c
	ipole = 0
	call at_bint('Number of poles plots',ipole,back)
	do n=1,ipole
	  call poles
	enddo
c
	end

	subroutine poles
	USE SGLIB_MOD
c
c---- this contour plot was submitted by hedi selberg.
c
	parameter (mx=51)
	parameter (my=101)
	real*8 x(mx),y(my),th(mx),rr(my)
	real*8 x2(mx,my),y2(mx,my),a(mx,my),c(40)
        real*8 xmax
cx	integer kolors(6) /2,3,4,5,6,7/
	integer icall
	real cfirs
	integer nx, ny
	data icall /1/
	data cfirs /-.05/
	data nx /12/, ny /12/
 
	external polpro
c
c undefined elements in these arrays can cause the wrapper 
c routines to fail when they perform a copy to real*4 arrays
c
	x=0.d0 ; y=0.d0 ; th=0.d0 ; rr=0.d0
	x2=0.d0 ; y2=0.d0 ; a=0.d0 ; c=0.d0
c
	call at_int('Rcontr (1), Contur (2)',icall)
	call at_real('First contour level',cfirs)
	call at_int('Number of x points',nx)
	call at_int('Number of y points',ny)
	p2=6.2831852
	dx=1./nx
	do i=1,nx
	  x(i)=p2*i*dx
	enddo
	dy=1./ny
	do j=1,ny
	  y(j)=p2*j*dy
	enddo
	dr=1./(ny)
	dth=p2/(nx)
	do j=1,ny
	  yy=p2*(j)*dy
	  rr(j)=(j)*dr
	  do i=1,nx+1
	    th(i)=(i-1)*dth
	    xx=p2*(i)*dx
	    a(i,j)=sin(yy)*cos(xx)
	    x2(i,j)=rr(j)*cos(th(i))
	    y2(i,j)=rr(j)*sin(th(i))
	  enddo
	enddo
c
	call initt(120)
cx	call binitt
cx	call slimx(150,750)	!default is 150,900
cx	call slimy(100,500)	!default is 125,700
cx	call agrcfr(x,1,nx,2,y,1,ny,2,1)
	c(1)=cfirs	!first solid (fnc min = -2.05)
	c(2)=.1		!increment
	k1=0		!c(1)=f0, c(2)=df, z<c(1) is dotted
	k2=0
	if(icall.eq.1) then
	  call agraph(150,750,100,500,
     >		x(1),x(nx-1),y(1),y(ny-1),'X','Y')
	  call rcontr(k1,c,k2,a,mx,x,1,nx,2,y,1,ny,2)
	elseif(icall.eq.2) then
	  xmax=rr(ny)*.8
	  call agraph(150,750,100,500,
     >		-xmax,xmax,-xmax,xmax,'X','Y')
	  call contur(k1,c,k2,a,mx,x2,1,nx+1,1,y2,1,ny,1)
	elseif(icall.eq.3) then
	  xmax=rr(ny)*.8*.6
	  call agraph(150,750,100,500,
     >		-xmax,xmax,-xmax,xmax,'X','Y')
	  call contur(k1,c,k2,a,mx,x2,1,nx+1,1,y2,1,ny,1)
	endif
	call agxmhs(350,600,'POLES: A CONTOUR PLOT$')
	call upause(0)
	call finitt(0,0)
	return
	end
	subroutine polpro(x,y,px,py)
	px=y*cos(x)
	py=y*sin(x)
	end

C******************** START FILE TKBRAD.FOR ; GROUP TKBLOAT ******************
C-- END FILE #TKBNDR# ************************************
CFORMFEEDC-- START FILE #TKBRAD# ************************************
C---------------------------------------------------------
C  SUBROUTINE TKBRAD
C
      SUBROUTINE TKBRAD(ZR,ZY,ZR0,ZY0,ZDISTA,ZRAD)
C
      include 'tkbparm.inc'
      REAL ZR(NTK),ZY(NTK),ZDISTA(NTK)
C
C  RETURN AVG DISTANCE TO SURFACE PTS (ZR,ZY) FROM CTR PT (ZR0,ZY0)
C
      ZDIST(ZR1,ZR2,ZY1,ZY2)=SQRT((ZR2-ZR1)**2+(ZY2-ZY1)**2)
C
      ZRAD0=ZDIST(ZR0,ZR(1),ZY0,ZY(1))
      ZDISTA(1)=ZRAD0
C
      ZRADP=ZRAD0
C
      ZL=0.0
      ZRAD=0.0
C
      DO 10 ITH=2,NTK
        ITHM1=ITH-1
        ZDL=ZDIST(ZR(ITH),ZR(ITHM1),ZY(ITH),ZY(ITHM1))
        ZL=ZL+ZDL
        ZRADN=ZDIST(ZR0,ZR(ITH),ZY0,ZY(ITH))
        ZDISTA(ITH)=ZRADN
        ZRAD=ZRAD+ZDL*0.5*(ZRADN+ZRADP)
C
        ZRADP=ZRADN
 10   CONTINUE
C
C COMPLETE LOOP INTEGRAL
C
      ZDL=ZDIST(ZR(NTK),ZR(1),ZY(NTK),ZY(1))
      ZL=ZL+ZDL
      ZRAD=ZRAD+ZDL*0.5*(ZRADP+ZRAD0)
C
      ZRAD=ZRAD/ZL
C
      RETURN
      END
C******************** END FILE TKBRAD.FOR ; GROUP TKBLOAT ******************

C******************** START FILE MULFDR.FOR ; GROUP MULFDR ******************
C------------------------------------------------------------
C  MULFDR
C
C  MODIF D. MC CUNE 26 OCT 1983
C  SUPPORT SINGLE PT. MODE DISPLAY--
C  IF PASSED X COORD FOR PLOTTING CONTAINS ONLY ONE POINT,
C  DATA IS PRINTED, NOT PLOTTED
C
C  DRAW A MULTIPLOT WITH KEY.
C  CALLER SETS SCALE AND AXIS TYPE
C  DATA TO BE PLOTTED IS PASSED IN A 2D ARRAY; INTEGER FLAGS
C  SELECT ALONG WHICH DIMENSION TO PLOT AND WHICH ROWS/ COLUMNS
C  OF THE 2D ARRAY TO PLOT
C
C  NO USER I/O OR CONTROL IS PROVIDED EXCEPT TO CALL UPAUST AFTER
C  THE MULTIPLOT IS COMPLETE
C
      SUBROUTINE MULFDR(F,NF1,X1,NX1,X2,NX2,ZW,
     >     ISELX,ISELF,NSEL,IAXSEL,
     >     FUNS,XUNS,
     >     MNLAB,KYLAB,LBSEL,tshift)
C
      use bottoms_up
C
C  # SYMBOLS PER LINE (MAX)
      PARAMETER (NSYMBS=5)
C
C  ARGUMENTS -- ALL MUST BE SUPPLIED BY CALLER (OUTPUT IS GRAPH)
C
C  IN COMMON/DPLOT1/  XMIN,XMAX,YMIN,YMAX -- THE SCALE OF THE GRAPH
C
C  PASSED:
C   F(NF1,NX2)  DATA BUFFER OF INDICATED DIMENSIONS
C   X1(NX1)     1ST INDEPENDANT VARIABLE OF F - ALONG 1ST DIMENSION
C   X2(NX2)     2ND INDEPENDANT VARIABLE OF F - ALONG 2ND DIMENSION
C     NOTE X1 AND X2 NEED NOT BOTH BE DEFINED (THOUGH A DIMENSION
C     .GT. 0 MUST BE SUPPLIED) -- SEE INTEGER VARIABLE ISELX
C   ZW(NX2)     WORKSPACE.  BIG ENUF TO HOLD ONE SLICE ALONG 2ND
C     DIMENSION OF F  -- USED ONLY IF ISELX=2
C   ISELX       PLOTTING INDEPENDANT VARIABLE SELECT ***
C     ISELX=1 INDICATES X1 IS TO BE PLOTTED ALONG THE X AXIS
C             (HORIZONTAL AXIS OF GRAPH); AND THERE ARE NX1 PTS.
C     ISELX=2 INDICATES X2 AND NX2.
C   ISELF(NSEL) SELECTS WHICH COLUMNS (OR ROWS) OF F ARE TO APPEAR
C     ON THE MULTIPLOT.  ISELX=1 MEANS ROWS ARE PLOTTED (1ST INDEX
C     OF F VARIED IN PLOT CURVE, 2ND INDEX FIXED), ISELX=2 FOR COLUMNS
C     **NSEL** IS THE NUMBER OF CURVES TO APPEAR ON THE MULTIPLOT
C   IAXSEL      SELECTS THE AXIS TYPE:
C     =-11 FOR LINEAR-LINEAR
C     =-15 FOR LINEAR-LOG(Y)
C     =-30 FOR LOG(X)-LOG(Y)
C     =-40 FOR LOG(X)-LINEAR
C   -----------
C   CHARACTER LABELS:
C   ------------
C   FUNS        10 CHARACTER FUNCTION (F) UNITS LABEL
C   XUNS        10 CHARACTER "X" AXIS UNITS LABEL
C   MNLAB       3 60 CHARACTER "MAIN LABELS"-- 1ST TWO APPEAR
C               ABOVE GRAPH, LAST ONE BELOW
C   KYLAB       5 17 CHARACTER KEY LABELS -- 1ST TWO APPEAR
C               AT TOP OF KEY BOX, LAST THREE AT BOTTOM
C   LBSEL(NSEL) NSEL 10 CHARACTER SELECT LABELS-- 10 CHARACTERS
C               TO ID EACH CURVE IN THE MULTIPLOT (1,2,... NSEL)
c
c   tshift(nsel) time displacement (real) -- add to labeling if non-zero
C
C *NOTE LABELS DO *NOT* NEED TO BE TERMINATED WITH "$", BUT A "$" IN
C  THE LABEL WILL CHOP OFF OUTPUT OF THE LABEL AT THAT POINT***
C
      INCLUDE 'PLOT1MMX'
      REAL F(NF1,NX2),X1(NX1),X2(NX2),ZW(NX2)
      INTEGER ISELF(NSEL)
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) KYLAB(5)
      CHARACTER*(*) LBSEL(NSEL),XUNS,FUNS
      real tshift(nsel)
      real zzx(1),zzy(1)
C
      CHARACTER*128 ZBUF
C
C  LOCAL VARIABLES - CONTROL SYMBOL/LINE STYLES OF MULTIPLOT
C
      DIMENSION ZXL(NSYMBS),ZYL(NSYMBS)
      INTEGER IPLOTF(2,15)
C
C  SELECT LINE DASH STYLE / SYMBOL COMBINATIONS
      DATA IPLOTF/1,13,2,14,6,15,4,16,3,13,1,14,2,15,6,16,
     >              4,13,3,14,1,15,2,16,6,13,4,14,3,15/
C
C
C  LOCAL VARIABLES-- DETERMINE LOCATION OF LABELS, LINE STYLES,
C     SIZE OF GRAPH, ETC.
C
      INCLUDE 'MULFDR_BLK'
C
C-------------------------------------------------------
C  START OF EXECUTABLE CODE
C
C  MAX OF 15 FCNS
C
      call bu_eval(mnlab(3),' ',irast)  ! check for multi-line lower label
C
      INSEL=MIN0(15,NSEL)
C  # PTS PER CURVE
      IF(ISELX.EQ.1) THEN
        INUM=NX1
        IF(INUM.GT.1) THEN
          CALL IXMMX(X1,NX1,IXA,IXB)
          INUMS=IXB-IXA-1
        ELSE
          ZX0D=X1(1)
        ENDIF
      ENDIF
      IF(ISELX.EQ.2) THEN
        INUM=NX2
        IF(INUM.GT.1) THEN
          CALL IXMMX(X2,NX2,IXA,IXB)
          INUMS=IXB-IXA-1
        ELSE
          ZX0D=X2(1)
        ENDIF
      ENDIF
C  SYMBOL SPACING VARIABLES
      IF(INUM.GT.1) THEN
C====================================/ PLOT CURVES /=============
      INTVL=MAX0(1,(INUMS+NSYMBS-1)/NSYMBS)
      ISINC=INTVL-1
      IF(INTVL.LT.NSYMBS) GO TO 10
      ISINC=INTVL/NSYMBS
C
 10   CONTINUE
      IST=MAX0(1,(INTVL/2-ISINC))
C  DRAW AXES
      ZZX=XMAX+5.0*(XMAX-XMIN)
      ZZY=YMAX+5.0*(YMAX-YMIN)
      CALL DPLOTM(IXRG,IYRG,ZZX,ZZY,1,IAXSEL)
C
C  PLOT THE CURVES
C
      DO 30 I=1,INSEL
        IND=ISELF(I)
        DO 25 J=1,INUM
C  COPY COL. (2ND DIM. SLICE) INTO WORKSPACE
          IF(ISELX.EQ.2) ZW(J)=F(IND,J)
 25     CONTINUE
C  LINE STYLE CODE
        ICOD=IPLOTF(1,I)
C  PLOT FCN (CURVE)
        IF(ISELX.EQ.1) CALL DPLOTM(IXRG,IYRG,X1,F(1,IND),INUM,ICOD)
        IF(ISELX.EQ.2) CALL DPLOTM(IXRG,IYRG,X2,ZW,INUM,ICOD)
C  PLOT SYMBOLS ON CURVE
        ICT=0
        IST=IST+ISINC
        IF(IST.GT.INTVL) IST=IST-INTVL
        IPT=IXA+IST-INTVL
        DO 26 J=1,NSYMBS
          IPT=IPT+INTVL
          IF(IPT.GT.INUM) GO TO 26
          ICT=ICT+1
          IF(ISELX.EQ.1) ZXL(ICT)=X1(IPT)
          IF(ISELX.EQ.2) ZXL(ICT)=X2(IPT)
          IF(ISELX.EQ.1) ZYL(ICT)=F(IPT,IND)
          IF(ISELX.EQ.2) ZYL(ICT)=ZW(IPT)
 26     CONTINUE
        CALL DPLOTM(IXRG,IYRG,ZXL,ZYL,ICT,IPLOTF(2,I))
 30   CONTINUE
C
C====================================/ OR DISPLAY SINGLE POINTS /====
C
      ELSE
C  DRAW BOX
      CALL UBINIT
      CALL MOVABS(IXRG(1),IYRG(1)+irast)
      CALL DRWABS(IXRG(2),IYRG(1)+irast)
      CALL DRWABS(IXRG(2),IYRG(2))
      CALL DRWABS(IXRG(1),IYRG(2))
      CALL DRWABS(IXRG(1),IYRG(1)+irast)
C  WRITE DISPLAY FROM UPPER LEFT CORNER DOWN
      IX0D=IXRG(1)+30
      IY0D=IYRG(2)-2*IDY0D
C
      CALL GRFLBL(IX0D,IY0D,'SINGLE POINTS DISPLAY: '//FUNS,0,-1,0)
      IY0D=IY0D-IDY0D
C
      WRITE(ZBUF,3002) ZX0D,XUNS
 3002 FORMAT('FIXED COORD: ',1PE12.5,1X,A10,'$')
      CALL GRFLBL(IX0D,IY0D,ZBUF,0,-1,0)
      IY0D=IY0D-IDY0D
C
      IX0DA=IX0D+180
      CALL GRFLBL(IX0D,IY0D,'LABEL',0,-1,0)
      CALL GRFLBL(IX0DA,IY0D,'VALUE',0,-1,0)
      if(nf1.ge.2) call grflbl(ix0da+150,iy0d,'(+/- RMS Var.)',0,-1,0)
      IY0D=IY0D-IDY0D
C
      CALL GRFLBL(IX0D,IY0D,'------------',0,-1,0)
      CALL GRFLBL(IX0DA,IY0D,'-------------------------',0,-1,0)
      IY0D=IY0D-IDY0D
C
C  DISPLAY SINGLE PT VALUES
      DO 60 I=1,INSEL
        IND=ISELF(I)
        iflag2=0
        IF(ISELX.EQ.1) THEN
          ZD0D=F(1,IND)
          if(nf1.ge.2) then
             ZDVAR=F(2,IND)
             iflag2=1
          endif
        ELSE
          ZD0D=F(IND,1)
        ENDIF
C
        ILS=ILNURD(LBSEL(I))
        ZBUF=LBSEL(I)(1:ILS)//':  '
        CALL GRFLBL(IX0D,IY0D,ZBUF,0,-1,0)
C
        ZBUF=' '
        if(iflag2.eq.0) then
           WRITE(ZBUF,3005) ZD0D
        else
           write(zbuf,3006) zd0d,zdvar
        endif
 3005   FORMAT(1PE12.5)
 3006   format(1pe12.5,1x,1pe12.5)
        CALL GRFLBL(IX0DA,IY0D,ZBUF,0,-1,0)
C
        IY0D=IY0D-IDY0D
        if(tshift(i).ne.0) then
           zbuf=' '
           if(tshift(i).gt.0.0) then
              write(zbuf,'("(time shift +",1pe10.4," sec.)")') tshift(i)
           else
              write(zbuf,'("(time shift ",1pe11.4," sec.)")') tshift(i)
           endif
           call grflbl(ix0d+75,iy0d,zbuf,0,-1,0)
           IY0D=IY0D-IDY0D
        endif
 60   CONTINUE
C==============================================================
      ENDIF
C
C  DRAW KEY FRAME
C
      CALL MOVABS(IXRG(2),IYRG(2))
      CALL DRWABS(IXRG(3),IYRG(2))
      CALL DRWABS(IXRG(3),IYRG(1)+irast)
      CALL DRWABS(IXRG(2),IYRG(1)+irast)
      CALL DRWABS(IXRG(2),IYRG(2))
C  KEY LABELS
      DO 100 I=1,5
         ioff=0
         if(i.ge.3) ioff=irast
         CALL GRFLBL(IXRKY,IYRKY(I)+ioff,KYLAB(I),17,0,0)
 100  CONTINUE
C  KEY LINES AND LABELS
      IF(INUM.GT.1) THEN
C============/ ONLY IF CURVES WERE PLOTTED
      IYL=IYRKSL+IDRKY
      IYN=IYRKLA+IDRKY
      DO 110 I=1,INSEL
        IYL=IYL-IDRKY
        IYN=IYN-IDRKY
        CALL DPLOTK(IYL,IXRKSL,IYN,IXRKLA,IPLOTF(1,I),LBSEL(I))
        if(tshift(i).ne.0.0) then
           zbuf=' '
           if(tshift(i).gt.0.0) then
              write(zbuf,'("+",1pe10.4," sec")') tshift(i)
           else
              write(zbuf,'(1pe11.4," sec")') tshift(i)
           endif
           IYL=IYL-IDRKY
           IYN=IYN-IDRKY
           call grflbl(ixrksl,iyn,zbuf,0,-1,0)
        endif
 110  CONTINUE
C  FUNCTION UNITS
      CALL GRFLBL(IXRXU,IYRXU+irast,XUNS,0,-1,0)
      CALL GRFLBL(IXRFU,IYRFU,FUNS,0,-1,1)
      ELSE
C===================================
C  IN SINGLE PT MODE GEN LABEL REFERING TO DISPLAY
      CALL GRFLBL(IXRKSL,IYRKSL,' ID = DATA LABEL ',17,0,0)
C===================================
      ENDIF
C  MAIN GRAPH LABELS
      IJUST=-1
      ioff=0
      DO I=1,3
         if(i.le.2) then
            CALL GRFLBL(IXRMN+ioff,IYRMN(I),MNLAB(I),72,IJUST,0)
         else
            ijust=0
            ioff=-120
            if(ibrk_lbl3.eq.0) then
               CALL GRFLBL(IXRMN+ioff,IYRMN(I),MNLAB(I),72,IJUST,0)
            else
               call grflbl(ixrmn+ioff,iyrmn(i)+irast,
     >              mnlab(i)(1:ibrk_lbl3),72,ijust,0)
               call grflbl(ixrmn+ioff,iyrmn(i),
     >              mnlab(i)(ibrk_lbl3+1:),72,ijust,0)
            endif
         endif
      ENDDO
C ---------
C GRAPH COMPLETED
C
      CALL UPAUST(2)

      call bu_reset

      RETURN
      END
C******************** END FILE MULFDR.FOR ; GROUP MULFDR ******************

!------------------------------------------------------------------------------
!
real(fp) FUNCTION FSVTH_Z(E)
!	3/8/77
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use sigtabl_mod, only :A,B,CON,EPS,ITER,IW
  IMPLICIT NONE
!===========
! idecl:  explicitize implicit REAL declarations:
  real(fp) e,z,sige_z
!============
!	THIS FUNCTION WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
!	PLASMA PHYSICS LAB.  THIS FUNCTION CONTAINS THE INTEGRAND
!	NEEDED IN CALCULATING <SIGMA*V> FOR THERMAL REACTIONS.
!	PARAMERTES:
!	E - THE INTEGRATION VARIABLE.
!	PARAMETER LIST FOR COMMON BLOCK CSVTH.
!	A - =RMASS/TMASS.  (SEE SVTH)
!	B - = A/TEMP.  (SEE SVTHE)
!	CON1 - =CON*A**1.5/SQRT(TMASS).  (SEE SVTH)
!	EPS - THE DESIRED RELATIVE ERROR IN THE REACTIVITY
!	ITER - THE MAXIMUM NUMBER OF ITERATIONS TO BE TAKEN IN ORDER
!	IW - THE LOGICAL UNIT USED FOR PRINTING.
  Z=E*EXP(-B*E)
  FSVTH_Z=SIGE_Z(E)*Z
  RETURN
END FUNCTION FSVTH_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

subroutine frantic_edits
  !
  !-------------------------------
  !
  !  TBT Jun, 1991  Added NINLDX as the pointer to the lightest gas in
  !                 BACKZ for this source.
  !-----------------------------
  
  !  Mod TBT July 25, 1991 - Corrected index to RMASS in RMASS/APLAS.
  !  Mod TBT May,1991 - Added INDX so that ALPHAX would not divide by 0
  !
  !  MOD DMC AUG 1986 - TRANSP VSN UPGRADE TO SUPPORT ROTATION BALANCE
  !    EVALUATE CROSS SURFACE FLUX OF MOMENTUM
  !
  !  MOD DMC JUL 1989 -- UPGRADE TO SUPPORT HELIUM + HYDROGEN MIX
  !    CROSS SURFACE PTCL FLUXES ARE NOW IN UNITS OF NO. OF ELECTRONS
  !    CARRIED.  CHARGE EXCHANGE CAN NOW GIVE AN ELECTRON SOURCE
  !    E.G. HE0 + H+ --> HE+ + H0 --> HE++ + E- + H0 IS ASSUMED
  !    (CONVERSELY, H0 + HE++ --> H+ + HE+ --> H+ + HE++ + E- IS TREATED
  !    AS AN IONIZATION, CF CROSS SECTION ROUTINES ...)
  !
  !    ALSO, MULTISPECIES, MULTIPLE CHARGE STATE BEAMS MAY BE PRESENT.
  !    IN A KLUGE, THE NO. OF ELECTRONS GOING TO FORM BEAM NEUTRALS IS
  !    SUMMED AND STORED IN TSTOR1 AT THE VERY end; THE CALLER MAY USE
  !    THIS TO COMPLETE AN ELECTRON WEIGHTED NEUTRAL PARTICLE BALANCE
  !    AS A CHECK ON THE CODE
  !
  !
  !  THIS ROUTINE WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
  !  PLASMA PHYSICS LAB.  THIS ROUTINE WILL CALCULATE THE NET SOURCES
  !  FOR:
  !  ELECTRONS
  !  HYDROGEN OR HELIUM ISOTOPE IONS
  !  HYDROGEN OR HELIUM NEUTRALS
  !  POWER FLOW DUE TO CHARGE EXCHANGE  (IONS TO NEUTRALS)
  !  POWER FLOW DUE TO IONIZATION  (NEUTRALS TO IONS)
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, half, one
  use frantic_module
  implicit none
  real(fp), parameter :: C3OV2 = 1.5_fp
  real(fp), parameter :: FOUR = 4.0_fp
  real(fp), parameter :: CEPS7 = 1.0e-7_fp
  !
  integer :: i,ik,ikc,inl,inlc,j,isb,idir,jz,jm1
  real(fp) :: zflmin,zelsmg,zvipcx,zvipii,zviprc
  real(fp) :: zvivs,zvipvs,zflxmg,zelosw,zfluxt,zeflux,zfluxw,ztwalk
  real(fp) :: zwarea,zmassf,zjperg,ztka,zvwall,zflxw,zvphik
  real(fp) :: zmassk,zusum1,zpcxmg,zpcxsfmg,ztqcxmg,zpiimg,zpiisfmg
  real(fp) :: ztqiimg,zpcxw,zpcxsfw,ztqcxw,zpiiw,zpiisfw,ztqiiw
  real(fp) :: ztsum3,zts1,zsum,zsum2,zsum2tq,zsum3,zsum3tq,ztsum1
  real(fp) :: ztempi,zvphii,zmassi,ztempj,zvphij,zmassj,zsmg
  real(fp) :: zts8,zts2,zts5,zbsum,zts6,zvoli,zts3,zflb,zfub
  real(fp) :: zpflb,zpfub,ztflb,ztfub,znrm2,zfl,zsum2tqw
  real(fp) :: zvphi0,zmass0
  real(fp) :: zscxw,zscxmg
  real(fp) :: ZSTOR(MJ)  ! TEMP STORAGE -- ELECTRONS TO BEAM NEUTRALS
  !
  !------------------------------------------------------
  !
  real(fp), parameter :: zcon1 = 1.6021892e-16_fp
  real(fp), parameter :: zcon2 = 2.8945365e15_fp
  real(fp), parameter :: ztwopi = 6.2831853071795862_fp
  !
  !  CON1 = JOULES/KEV
  !  CON2 = 3*C*C/(KEV/AMU)
  !-----------------

  !
  !  MINIMUM FLUX TO CONSIDER (AVOID UNDERFLOWS ON VAX):
  !
  ZFLMIN=EPSLON/ZCON1
  !
  ZELSMG=ZERO
  ZVIPCX=ZERO
  ZVIPII=ZERO
  ZVIPRC=ZERO
  ZVIVS=ZERO
  ZVIPVS=ZERO
  ZFLXMG=ZERO
  PLOSS1=ZERO
  ZELOSW=ZERO
  ZFLUXT=ZERO
  ZEFLUX=ZERO
  ZFLUXW=ZERO
  ZTWALK=ZERO
  ZWAREA=ZTWOPI*AMINOR
  !
  do I=1,NZONEC
    ZSTOR(I)=ZERO
  end do
  !  MASS (GRAMS) / AMU  ... FACTOR FOR ROTATION POWER TERMS
  !
  !CC	ZMASSF=RMASS(1)/APLAS(NSPEC(1))
  !CC	ZMASSF=RMASS(NINLDX)/APLAS(NSPEC(NINLDX))            ! TBT 5/91
  ZMASSF=RMASS(NSPEC(NINLDX)-2)/APLAS(NSPEC(NINLDX))   ! TBT 7/91
  ZJPERG=CEPS7 ! JOULES/ERG
  !
  do IK=1,NNEUT
    IKC=NSPEC(IK)
    ZMASSK=APLAS(IKC)*ZMASSF
    !=============
    !  ESCAPE COEFFICIENTS AND AVG ENERGY SUMS FOR TRANSP
    OUTFLX(IK)=ZERO
    EESCAV(IK)=ZERO
    !=============
    if(.NOT.ESFLAG) GO TO 10
    ZTWALK=TWALL(IK)
    ZFLUXT=ZFLUXT+FLUXI0(IK)
    ZEFLUX=ZEFLUX+FLUXI0(IK)*ZTWALK
    WWALL(IK)=FOUR*WWALL(IK)*FLUXI0(IK)/ZWAREA
    ZFLUXW=ZFLUXW+WWALL(IK)
    ZELOSW=ZELOSW+WWALL(IK)*ZTWALK
    !=============
    OUTFLX(IK)=OUTFLX(IK)+WWALL(IK)
    EESCAV(IK)=EESCAV(IK)+ZTWALK*WWALL(IK)*C3OV2*ZCON1 + &
         wwall(ik)*zjperg*half*zmassk*vphi_wall(ik)**2
    !=============
10  continue
    !  KC GIVES THE ION NUMBER OF THE KTH NEUTRAL.
    ZTKA=APLAS(IKC)
    !  I NOW FIND THE WALL VELOCITY FOR THIS NEUTRAL SPECIES.
    ZVWALL=SQRT(ZCON2*ZTWALK/ZTKA)
    !  I NOW LOOP OVER ALL DEATH ZONES.
    do I=1,NZONEC
      ZFLXW=WALL(I,IK)*TSTOR1(I,IK)/ZWAREA
      ZFLXMG=ZFLXMG+ZFLXW
      ZELSMG=ZELSMG+ZFLXW*TEMP(I,IKC)
      !AUG86
      ZVPHIK=VPHIZ(I,IKC)
      !
      !==================
      !  CALCULATE TRANSP ESCAPE COEFFICIENT, SPECIES-RESOLVED,
      !  FOR RENORMALIZATION OF SOURCE
      !  THE TRANSP NEUTRAL SOURCE NUMBER NSRC WILL HAVE BEEN SET
      OUTFLX(IK)=OUTFLX(IK)+ZFLXW
      EESCAV(IK)=EESCAV(IK)+ZFLXW*TEMP(I,IKC)*C3OV2*ZCON1 &
           +ZFLXW*ZJPERG*ZVPHIK**2*HALF*ZMASSK
      !======================================
      ZUSUM1=ZERO
      !  USUM1 WILL CONTAIN THE SOURCE OF ELECTRONS RESULTING FROM
      !  THE INTERACTION OF THE K NEUTRAL SPECIES.
      ZPCXMG=ZERO
      !  PCXMG WILL CONTAIN THE CHARGE EXCHANGE POWER FLOW IN ZONE I
      !  DUE TO MG NEUTRAL PARTICAL K INTERACTING WITH ALL CHARGED
      !  PARTICLES. - THERMAL CONTRIBUTION ONLY

      !dmc06 ..useful to compute net cx reaction rate as well..

      zscxmg=ZERO

      !AUG86
      ZPCXSFMG=ZERO
      !  PCX CONTRIBUTION DUE TO DifFERENCE IN ROT. VELOCITY BTW
      !  BIRTH AND DEATH ZONES (FRICTIONAL TERM)
      ZTQCXMG=ZERO
      !  TORQUE DUE TO CX
      !AUG86_end
      !
      ZPIIMG=ZERO
      !  PIIMG WILL CONTAIN THE IONIZATION POWER FLOW IN ZONE I DUE
      !  TO MG NEUTRAL PARTICLES BEING IONIZED.
      !AUG86
      ZPIISFMG=ZERO
      !  PIONIZ. CONTRIBUTION DUE TO DifFERENCE IN ROT. VELOCITY BTW
      !  BIRTH AND DEATH ZONES (FRICTIONAL TERM)
      ZTQIIMG=ZERO
      !  TORQUE DUE TO IONIZ.
      !AUG86_end
      ZPCXW=ZERO
      !  PCXW WILL CONTAIN THE CHARGE EXCHANGE POWER FLOW IN ZONE I
      !  DUE TO WALL NEUTRAL PARTICAL K INTERACTING WITH ALL CHARGED
      !  PARTICLES.

      !dmc06 ..useful to compute net cx reaction rate as well..

      zscxw=ZERO
      !AUG86
      ZPCXSFW=ZERO
      !  PCX CONTRIBUTION DUE TO DifFERENCE IN ROT. VELOCITY BTW
      !  WALL AND DEATH ZONES (FRICTIONAL TERM)
      ZTQCXW=ZERO
      !  TORQUE DUE TO CX
      !AUG86_end
      ZPIIW=ZERO
      !  PIIW WILL CONTAIN THE IONIZATION POWER FLOW IN ZONE I DUE TO
      !  WALL NEUTRALS.
      !AUG86
      ZPIISFW=ZERO
      !  PII CONTRIBUTION DUE TO DifFERENCE IN ROT. VELOCITY BTW
      !  WALL AND DEATH ZONES (FRICTIONAL TERM)
      ZTQIIW=ZERO
      !  TORQUE DUE TO IONIZ. WALL SCE
      !AUG86_end
      ZTSUM3=ZERO
      !  TSUM3 WILL CONTAIN THE TOTAL MG REACTION RATE/CM**3 FOR THE
      !  K NEUTRAL INTERACTING IN ZONE I.
      ZTS1=DCOLD(I,IK)*ZVWALL
      ZSUM=ZERO
      !  SUM CONTAINS THE WALL SOURCE OF NEUTRALS PRODUCED BY THE K NEUTRAL
      !  INTERACTING WITH ALL CHARGED PARTICLES.
      !
      ZSUM2=ZERO
      !AUG86
      ZSUM2TQ=ZERO
      zsum2tqw=ZERO
      !  SUM2 CONTAINS THE POWER OF THE K MG NEUTRAL SPECIES IN ZONE I
      !  SUMMED OVER ALL BIRTH ZONES AND OVER ALL CHARGED PARTICLES.
      !  AUG86 - RELATED SUM FOR TORQUES ADDED
      !
      ZSUM3=ZERO
      !AUG86
      ZSUM3TQ=ZERO
      !  SUM3 CONTAINS THE POWER OF THE K WALL NEUTRAL SPECIES IN ZONE I
      !  SUMMED OVER ALL CHARGED PARTICLES.
      !  AUG86 - RELATED SUM FOR TORQUES ADDED
      !
      do INL=1,NNEUT
        !
        !  NL REPRESENTS THE CHARGED HYDROGENIC SPECIES
        INLC=NSPEC(INL)
        ZTSUM1=ZERO
        !  TSUM1 WILL CONTAIN THE SOURCE OF ALL CX MG NEUTRALS IN ZONE I
        !  SUMMED OVER ALL BIRTH ZONES FOR THE K NEUTRAL AND THE NLC PLASMA
        !  SPECIE.
        !  SAME AS ABOVE BUT FOR CROSS SPECIES.
        ZTEMPI=TEMP(I,INLC)
        !AUG86
        ZVPHII=VPHIZ(I,INLC)
        ZMASSI=APLAS(INLC)*ZMASSF
        !
        !  TEMPI IS THE TEMPERATURE OF THE NLC PLASMA SPECIES IN ZONE I.
        !  I NOW LOOP OVER THE BIRTH ZONES OF THE MULTI-GENERATION NEUTRALS.
        do J=1,NZONEC
          ZTEMPJ=TEMP(J,IKC)
          !AUG86
          ZVPHIJ=VPHIZ(J,IKC)
          ZMASSJ=ZMASSK
          !
          !  TEMPJ IS THE TEMPERATURE OF THE K NEUTRAL SPECIE BORN IN J.
          !  I NOW FIND THE VELOCITY AT WHICH THE NEUTRAL WAS BORN.
          !WHY?	        ZVNEUT=SQRT(ZCON2*ZTEMPJ/ZTKA)
          !  I NOW FIND THE SOURCE OF NEUTRALS
          ZSMG=-GFUN(I,J,INL,IK)
          if(J.EQ.I.AND.INL.EQ.IK) ZSMG=ZSMG+ONE
          ZSMG=ZSMG*TSTOR1(J,IK)
          !  SMG IS NOW THE SOURCE RATE OF MULTI-GENERATION NEUTRALS OF SPECIES
          !  NL IN ZONE I DUE TO NEUTRALS OF TYPE K BORN IN ZONE J CHARGE
          !  EXCHANGING ON CHARGED PARTICLE L.
          ZTSUM1=ZTSUM1+ZSMG
          !  DMC JUL 1989 - if NEWBORN NEUTRALS HAVE LOWER Z THAN OLD NEUTRALS
          !  K, THEN THERE IS AN ELECTRON SOURCE
          ZUSUM1=ZUSUM1+ZSMG*(XZPLAS(IKC)-XZPLAS(INLC))
          ZPCXMG=ZPCXMG+(ZTEMPI-ZTEMPJ)*ZSMG
          ZSCXMG=ZSCXMG+ZSMG
          ZSUM2=ZSUM2+ZTEMPJ*ZSMG
          !AUG86
          ZPCXSFMG=ZPCXSFMG+ZSMG*ZMASSJ*HALF*(ZVPHIJ-ZVPHIK)**2
          !
          ZTQCXMG=ZTQCXMG+ZSMG* &
               (ZVPHII*ZMASSI-ZVPHIJ*ZMASSJ)
          ZSUM2TQ=ZSUM2TQ+ZSMG*ZVPHIJ*ZMASSJ
          !AUG86_end
          !
          !CC	        if(INL.GT.1) GO TO 20
          if(INL.NE.NINLDX) GO TO 20       ! TBT 5/91
          !  INCLUDE TOTAL MG REACTIONS.
          !CC		  ZTS8=ALPHAT(I,J,IK)*ZSMG/ALPHAX(I,J,1,IK)
          ZTS8=ALPHAT(I,J,IK)*ZSMG/ALPHAX(I,J,NINLDX,IK)  ! TBT 91
          ZTSUM3=ZTSUM3+ZTS8
          !!SOURCE DUE TO MG IONIZATION
          ZUSUM1=ZUSUM1+ZTS8*XZPLAS(IKC)
          ZPIIMG=ZPIIMG+ZTS8*ZTEMPJ
          ZPIISFMG=ZPIISFMG+ZTS8*ZMASSJ*HALF*(ZVPHIJ-ZVPHIK)**2
          ZTQIIMG=ZTQIIMG+ZTS8*ZVPHIJ*ZMASSJ
          ! NOTE THAT THE NEUTRAL POWER (SUM2) WILL BE SUBTRACTED LATER.
20        continue
        end do
        !  NEXT 3 LINES GIVE CONTRIBUTION DUE TO MG NEUTRALS.
        SORI(I,INL)=SORI(I,INL)-ZTSUM1   !SINK DUE TO MG CX
        SORN(I,INL)=SORN(I,INL)+ZTSUM1   !SOURCE DUE TO MG CX
        ZUSUM1=ZUSUM1-ZTSUM1*XZPLAS(IKC) !CORRECTION FOR MG CX
        !
        if(.NOT.ESFLAG) GO TO 40
        ZTS2=S0COLD(I,INL,IK)
        SORI(I,INL)=SORI(I,INL)-ZTS2    !SINK DUE TO WALL CX
        SORN(I,INL)=SORN(I,INL)+ZTS2    !SOURCE DUE TO WALL CX
        !  DMC JUL 1989 - if NEWBORN NEUTRALS HAVE LOWER Z THAN OLD NEUTRALS
        !  K, THEN THERE IS AN ELECTRON SOURCE
        SORE(I)=SORE(I)+ZTS2*(XZPLAS(IKC)-XZPLAS(INLC))
        ZPCXW=ZPCXW+(ZTEMPI-ZTWALK)*ZTS2
        ZSCXW=ZSCXW+ZTS2
        ZSUM3=ZSUM3+ZTS2*ZTWALK
        ZSUM=ZSUM+ZTS2
        ZPCXSFW=ZPCXSFW+ZTS2*HALF*(ZVPHIK-vphi_wall(ik))**2*ZMASSK
        ZTQCXW=ZTQCXW+ZTS2*(ZVPHII*ZMASSI-vphi_wall(iK)*ZMASSK)
        zsum2tqw=zsum2tqw+ zts2*vphi_wall(iK)*ZMASSK
        !  EVALUATE ZSUM3TQ HERE if THE WALLS SPIN
40      continue
      end do
      !  NEXT 5 LINES GIVE CONTRIBUTION DUE TO MG NEUTRALS.
      ZPIIMG=ZPIIMG-ZSUM2
      ZPIISFMG=ZPIISFMG-ZPCXSFMG
      ZTQIIMG=ZTQIIMG-ZSUM2TQ
      SORI(I,IK)=SORI(I,IK)+ZTSUM3  !SOURCE DUE TO MG ION.
      SORN(I,IK)=SORN(I,IK)-ZTSUM3  !SINK DUE TO MG ION.
      !
      if(.NOT.ESFLAG) GO TO 50
      ZTS5=BETAT(I,IK)*ZTS1
      SORI(I,IK)=SORI(I,IK)+ZTS5  !SOURCE DUE TO WALL ION.
      SORN(I,IK)=SORN(I,IK)-ZTS5  !SINK DUE TO WALL ION.
      ZUSUM1=ZUSUM1+ &
           (ZTS5-ZSUM)*XZPLAS(IKC)  !SOURCE DUE TO WALL IONIZATION
      ZPIIW=ZPIIW+ZTS5*ZTWALK-ZSUM3
      ztqiiw=ztqiiw+zts5*vphi_wall(iK)*ZMASSK-zsum2tqw
      ZPIISFW=ZPIISFW+ZTS5*HALF*(ZVPHIK-vphi_wall(ik))**2*ZMASSK - &
           ZPCXSFW
50    continue
      !  THE ELECTRON SOURCE IS NOW CORRECTED FOR BEAM CX.
      if(LBFLAG) then
        ZBSUM=ZERO
        do ISB=1,NSBEAM
          ZBSUM=ZBSUM+BCXS(I,IK,ISB)*XZBEAMS(ISB)* &
               (DCOLD(I,IK)+DNEUT(I,IK))
        end do
        ZUSUM1=ZUSUM1-ZBSUM
        ZSTOR(I)=ZSTOR(I)+ZBSUM
      end if
      SCX(I)=SCX(I)+ZSCXMG+ZSCXW
      PCX(I)=PCX(I)+ZPCXMG+ZPCXW
      PII(I)=PII(I)+ZPIIMG+ZPIIW
      SORE(I)=SORE(I)+ZUSUM1
      PCXSF(I)=PCXSF(I)+ZPCXSFMG+ZPCXSFW
      PIISF(I)=PIISF(I)+ZPIISFMG+ZPIISFW
      !
      TQCX(I)=TQCX(I)+ZTQCXMG+ZTQCXW
      TQII(I)=TQII(I)+ZTQIIMG+ZTQIIW
      if(.NOT.RCFLAG) GO TO 60
      ZTS6=SVRC(I)*DEN(I,IKC)
      SORI(I,IK)=SORI(I,IK)-ZTS6
      SORE(I)=SORE(I)-ZTS6*XZPLAS(IKC)
      SORN(I,IK)=SORN(I,IK)+ZTS6
      PRC(I)=PRC(I)+ZTS6*TEMP(I,IKC)
60    continue
    end do
  end do
  !  I NOW CONVERT POWER TERMS TO WATTS
  !   AUG86 - AND THE TORQUE DENSITIES TO JLES/CM3
  do I=1,NZONEC
    PCX(I)=PCX(I)*ZCON1*C3OV2
    PII(I)=PII(I)*ZCON1*C3OV2
    !AUG86
    PCXSF(I)=PCXSF(I)*ZJPERG
    PIISF(I)=PIISF(I)*ZJPERG
    TQCX(I)=TQCX(I)*ZJPERG
    TQII(I)=TQII(I)*ZJPERG
    !AUG86_end
    ZVOLI=VOL(I)
    ZVIPII=ZVIPII+PII(I)*ZVOLI
    ZVIPCX=ZVIPCX+PCX(I)*ZVOLI
    if(.NOT.RCFLAG) GO TO 80
    PRC(I)=PRC(I)*ZCON1*C3OV2
    ZVIPRC=ZVIPRC+PRC(I)*ZVOLI
    !
80  continue
    vsor_zw(i)=0
    vsor_en(i)=0
    vsor_mo(i)=0
    do IK=1,NNEUT
      IKC=NSPEC(IK)
      PLOSS1=PLOSS1+SORN(I,IK)*ZVOLI
      if(.NOT.VSFLAG) GO TO 90
      ZTS3=VOLSOR(I,IK)*ZVOLI
      ZVIVS=ZVIVS+ZTS3
      ZVIPVS=ZVIPVS+ZTS3*TEMP(I,IKC)

      ZVPHI0=VPHIZ(I,IKC)
      ZMASS0=APLAS(IKC)*ZMASSF
      vsor_zw(i)=vsor_zw(i) + volsor(i,ik)*xZplas(ikc)
      vsor_en(i)=vsor_en(i) + volsor(i,ik)* &
           (TEMP(I,IKC)*C3OV2*ZCON1)
      vsor_mo(i)=vsor_mo(i) + volsor(i,ik)* &
           ZJPERG*ZVPHI0*ZMASS0
90    continue
    end do
!
  end do
  !
  !=============
  !  RENORMALIZE TRANSP ESCAPED NEUTRALS ARRAYS
  !
  do IK=1,NNEUT
    if(OUTFLX(IK).GT.ZERO) then
      EESCAV(IK)=EESCAV(IK)/OUTFLX(IK)
    else
      EESCAV(IK)=1.0_fp
    end if
  end do
  !=============
  PLOSS=ZWAREA*(ZFLXMG+ZFLUXW-ZFLUXT)-ZVIVS
  ELOSS=(ZWAREA*(ZELSMG+ZELOSW-ZEFLUX)-ZVIPVS)*C3OV2*ZCON1
  ELOSS1=ZVIPCX+ZVIPRC-ZVIPII
  !===================
  !  FLUX(R) CALCULATION.
  !  NORMALIZATION IS CORRECT WHEN USED AS TRANSP subroutine WITH
  !  "[TRANSP]SORCE1.FOR" AS DRIVER ***ONLY***
  !  VARIABLES DEFINED ARE TRANSP NEUTRAL FLUX(R) ARRAYS
  !
  !  LOOP OVER IN/OUT FLUX DIRECTION
  do IDIR=1,2
    !  LOOP OVER ZONE WHERE FLUX DIVERGENCES ARE DEFINED
    do J=1,NZONEC
      JZ=J
      JM1=J-1
      !  INITIALIZE SUMS
      if(IDIR.EQ.1) TQFLX0(JZ)=ZERO
      ZFLB=ZERO
      ZFUB=ZERO
      ZPFLB=ZERO
      ZPFUB=ZERO
      ZTFLB=ZERO
      ZTFUB=ZERO
      !  PORTION OF FLUX DUE TO WALL SOURCE
      if(.NOT.ESFLAG) GO TO 130
      do IK=1,NNEUT
        IKC=NSPEC(IK)
        ZNRM2=FLUXI0(IK)
        ZFL=ZNRM2*FOUR*PRWFLX(J,IK,IDIR)
        !  CHECK AGAINST MINIMUM FLUX (UNDERFLOW A POSSIBILITY)
        if(ABS(ZFL).LT.ZFLMIN) ZFL=ZERO
        ZFUB=ZFUB+ZFL*XZPLAS(IKC)
        ZTFUB=ZTFUB+ZFL*APLAS(IKC)*vphi_wall(ik)*ZMASSF
        !AUG86 - ROT - COMPUTE POWER FLUX IN PLASMA FRAME, REL. ZONE J
        ZPFUB=ZPFUB+C3OV2*ZCON1*ZFL*TWALL(IK) &
             +ZFL*ZJPERG*APLAS(IKC)* &
             HALF*(VPHIZ(J,IKC)-vphi_wall(ik))**2*ZMASSF
        if(JM1.EQ.0) GO TO 120
        ZFL=ZNRM2*FOUR*PRWFLX(JM1,IK,IDIR)
        !  CHECK AGAINST MINIMUM FLUX (UNDERFLOW A POSSIBILITY)
        if(ABS(ZFL).LT.ZFLMIN) ZFL=ZERO
        ZFLB=ZFLB+ZFL*XZPLAS(IKC)
        ZTFLB=ZTFLB+ZFL*APLAS(IKC)*vphi_wall(ik)*ZMASSF
        !AUG86 - ROT - COMPUTE POWER FLUX IN PLASMA FRAME
        ZPFLB=ZPFLB+ZFL*C3OV2*ZCON1*TWALL(IK) &
             +ZFL*ZJPERG*APLAS(IKC)* &
             HALF*(VPHIZ(J,IKC)-vphi_wall(ik))**2*ZMASSF
120     continue
      end do
130   continue
      !  PORTION DUE TO VOLUME/MULTIGENERATION SOURCE
      !  LOOP OVER INDEX TO ZONE OF ORIGIN OF NEUTRAL CONTRIBUTING TO
      !  FLUX AT BDY J/JM1, AND OVER SPECIES
      do IK=1,NNEUT
        IKC=NSPEC(IK)
        do I=1,NZONEC
          ZFL=TSTOR1(I,IK)*PRFLUX(I,J,IK,IDIR)
          !  CHECK AGAINST MINIMUM FLUX (UNDERFLOW A POSSIBILITY)
          if(ABS(ZFL).LT.ZFLMIN) ZFL=ZERO
          ZFUB=ZFUB+ZFL*XZPLAS(IKC)
          !AUG86 - ROT - COMPUTE POWER FLUX IN PLASMA FRAME
          !  ** NOT VALID ** if VPHI REALLY A FCN OF PLASMA SPECIES
          !  ** BECAUSE WHAT THEN IS THE PLASMA FRAME?
          ZPFUB=ZPFUB+C3OV2*ZCON1*TEMP(I,IKC)*ZFL &
               +ZFL*ZJPERG*APLAS(IKC)*HALF &
               *(VPHIZ(I,IKC)-VPHIZ(J,IKC))**2*ZMASSF
          !AUG86 - TORQUE FLUX IN LAB FRAME
          ZTFUB=ZTFUB+ZFL* &
               APLAS(IKC)*VPHIZ(I,IKC)*ZMASSF
          if(JM1.EQ.0) cycle
          ZFL=TSTOR1(I,IK)*PRFLUX(I,JM1,IK,IDIR)
          !  CHECK AGAINST MINIMUM FLUX (UNDERFLOW A POSSIBILITY)
          if(ABS(ZFL).LT.ZFLMIN) ZFL=ZERO
          ZFLB=ZFLB+ZFL*XZPLAS(IKC)
          !AUG86 - ROT - COMPUTE POWER FLUX IN PLASMA FRAME
          !  ** NOT VALID ** if VPHI REALLY A FCN OF PLASMA SPECIES
          ZPFLB=ZPFLB+ZFL*C3OV2*ZCON1*TEMP(I,IKC) &
               +ZFL*ZJPERG*APLAS(IKC)*HALF &
               *(VPHIZ(I,IKC)-VPHIZ(J,IKC))**2*ZMASSF
          !AUG86 - TORQUE FLUX IN LAB FRAME
          ZTFLB=ZTFLB+ZFL* &
               APLAS(IKC)*VPHIZ(I,IKC)*ZMASSF
        end do
      end do
!  DEFINE FLUX DIVERGENCES
      SFLX0M(IDIR,JZ)=(ZFUB-ZFLB)/VOL(J)
      PFLX0M(IDIR,JZ)=(ZPFUB-ZPFLB)/VOL(J)
      TQFLX0M(IDIR,JZ)=ZJPERG*(ZTFUB-ZTFLB)/VOL(J)
      !
    end do
  end do
  !================
  !  FINAL KLUGE
  !   force densities (or equiv.) to torque densities
  do I=1,NZONEC
    TSTOR1(I,1)=ZSTOR(I)
    TQFLX0(I)=-TQFLX0M(1,I)+TQFLX0M(2,I)
    TQFLX0(I)=RMJRMP(I)*TQFLX0(I)
    TQFLX0M(1,I)=RMJRMP(I)*TQFLX0M(1,I)
    TQFLX0M(2,I)=RMJRMP(I)*TQFLX0M(2,I)
    tqflx0(i)=tqflx0m(2,i)-tqflx0m(1,i)
    TQII(I)=RMJRMP(I)*TQII(I)
    TQCX(I)=RMJRMP(I)*TQCX(I)
    VSOR_MO(I)=RMJRMP(I)*VSOR_MO(I)
  end do
  !================
  return
end subroutine frantic_edits

C---------------------------------------
C  unpack i*4 stream into two i*2 streams
C  preliminary for IEEE FP compression
C
      subroutine unpki2(iray,i2hi,i2lo,ibuf)
C
      integer*2 i2hi(ibuf),i2lo(ibuf)
      integer*2 iray(2,ibuf)
C
      call packordr(iray,ibuf,1)  ! standardize byte order
C
      do i=1,ibuf
         i2hi(i)=iray(1,i)
         i2lo(i)=iray(2,i)
      enddo
      return
      end
C---------------------------------------

C******************** START FILE UPMASG.FOR ; GROUP USPARM *************
C----------------------------------------------------------------
C&  UPMASG   ASSIGN CHARACTER VALUE TO UREAD STRING PARAMETER
C          CARRY OUT REQUEST TO ASSIGN VALUE TO NEW LOCAL OR
C          GLOBAL PARAMETER, OR DELETE OLD PARAMETER
C
C  ZLINE   INPUT DATA LINE FROM WHICH TO PARSE REQUESTS
C  LLINE   LENGTH OF ZLINE (ZLINE IS 1 CHAR PER WORD UNPACKED)
C  ISTART  INDEX LOCATION AT WHICH TO START PARSE
C
C  MODIFIED D. MC CUNE 4 APR 1983-- ALLOW INTEGER ARITHMETIC
C   /NAME=+VALUE
C  CAUSES THE (INTEGER) VALUE TO BE ADDED TO THE (INTEGER) VALUE
C  ALREADY ASSIGNED TO THE PARAMETER /NAME.  IF /NAME IS NOT DEFINED
C  THIS LINE IS EQUIVALENT TO "/NAME=VALUE".  BUT AN ERROR OCCURS IF
C  EITHER "VALUE" OR /NAME'S OLD DEFINITION CANNOT BE DECODED AS
C  INTEGERS
C   OPERATIONS SUPPORTED: - + * / SUBTRACTION ADDITION MULTIPLY DIVIDE
C
C
      SUBROUTINE UPMASG(ZLINE,ISTART,LLINE,IER)
      USE USERIO
C
      PARAMETER (INOPS=4)
      CHARACTER*1 ZLINE(LLINE)
      CHARACTER*16 ZNAM
      CHARACTER*96 ZVAL,ZVALP
      CHARACTER*4 ZDEL,ZTES
      CHARACTER*1 ZBLANK,ZOPS(INOPS)
      EQUIVALENCE(ZVAL,ZTES)
      DATA ZDEL/'$DEL'/
      DATA ZBLANK/' '/
      DATA ZOPS/'+','-','*','|'/
C
C----------------------------------------------
C
      IER=0
C
      ISEMI=ISTART
      CALL UFCHAR(ZLINE,MSEMI,ISEMI,LLINE)
      IF(ISEMI.GT.0) THEN
        ILINE=ISEMI-1
      ELSE
        ILINE=LLINE
      ENDIF
C
      IST2=ISTART
C  LOOP:  MORE THAN ONE ASSIGN STATEMENT PER LINE PERMITTED
 10   CONTINUE
      ISTART=IST2
C  EXIT TEST
      IF((ISTART.LE.0).OR.(ISTART.GT.ILINE)) GO TO 200
C  FIND NEXT "/"; START OF NEXT ASSIGN
      INDF2=ISTART+1
 12   CALL UFCHAR(ZLINE,MSLASH,INDF2,ILINE)
      IST2=INDF2
      IFIN=IST2-1
      IF(IFIN.LT.0) IFIN=ILINE
      INIT=ISTART+1
C
C  STRING OF FORM "NAME=(=)VALUE" SHOULD BE LOCATED IN ZLINE
C  FROM ZLINE(INIT) TO ZLINE(IFIN)
C
      IEQS=INIT
C  FIND "="
      CALL UFCHAR(ZLINE,MEQS,IEQS,IFIN)
      IF((IEQS.EQ.0).OR.(IEQS.LE.INIT)) GO TO 190
      IEQS2=IEQS
      IGLOBL=0
      IF(IEQS.LT.ILINE) THEN
        IF(ZLINE(IEQS+1).EQ.MEQS) IEQS2=IEQS2+1
      ENDIF
      IF(IEQS2.GT.IEQS) IGLOBL=1
C
C  INTERACTIVE ASSIGNMENT LINES ARE ALSO MADE TO GLOBAL
C  (DMC mod -- applies to all in line -- Apr 2011)
C
      IF(.NOT.NLINDI) IGLOBL=1
C
C  **  CHECK 1ST NON-BLANK FOR INTEGER ARITHMETIC OPERATION
      ITESO=INNBLK(ZLINE,ILINE,IEQS2)
C
C  MOD DMC - CHECK FOR PARAMETER VALUE WHICH ITSELF USES THE
C  PARAMETER DEFINITION/INVOKATION CHARACTER
      IF(ITESO.EQ.IST2) THEN
        ISTFIN=IST2+1
        CALL UFCHAR(ZLINE,MSLASH,ISTFIN,ILINE)
        IST2=ISTFIN
        IFIN=IST2-1
        IF(IFIN.LT.0) IFIN=ILINE
        GO TO 41
      ENDIF
C
      IF(ITESO.GT.(ILINE-1)) GO TO 41
C
      DO 40 IOP=1,INOPS
      IF((ZLINE(ITESO).EQ.'.').AND.(ZLINE(ITESO+1).EQ.ZOPS(IOP)))
     >      GO TO 42
 40   CONTINUE
C  NOT AN ARITHMETIC OPERATOR
 41   CONTINUE
      IOP=0
      GO TO 45
C  INTEGER OPERATION REQUESTED.  ASSIGN DEFAULT PRIOR VALUE TO
C  OPERAND
 42   CONTINUE
      ITESO=ITESO+1
      ZVALP='                              '
      ZVALP(1:1)='0'
      IF(IOP.GT.2) ZVALP(1:1)='1'
      IEQS2=ITESO
 45   CONTINUE
C
C  CHECK NAME AND VALUE
C
      INAMF=IEQS-1
      IVALI=IEQS2+1
      CALL USPLNM(ZLINE,ILINE,INIT,INAMF,ZNAM,IER1)
      CALL USPLVL(ZLINE,ILINE,IVALI,IFIN,ZVAL,IER2)
      IF((IER1.NE.0).OR.(IER2.NE.0)) GO TO 190
C  CHECK FOR DELETION
      IF(ZTES.EQ.ZDEL) GO TO 150
C  NAME AND VALUE LEGAL; CHECK IF PARAMETER NAME ALREADY KNOWN
      CALL USPLOC(ZNAM,ITYP,INUM)
      IF(ITYP.EQ.0) GO TO 100
C  DELETE NAME AFTER WARNING MESSAGE
      IF(NLECHO) WRITE(LUNTRM,4001) ZNAM
 4001 FORMAT(' % PREVIOUS DEFINITION OF PARAMETER "',A16,
     >  '" REPLACED'/)
CX	CALL UPAUST(1)
C  IF GOING TO PERFORM ARITHMETIC OPERATION, SAVE VALUE
      IF(IOP.GT.0) THEN
        IF(ITYP.EQ.1) ZVALP=PLCVAL(INUM,MAX0(NLUNIN,NLUNIO))
        IF(ITYP.EQ.2) ZVALP=PGLVAL(INUM)
      ENDIF
      IF(ITYP.EQ.2) CALL USPDGL(INUM)
      IF(ITYP.EQ.1) CALL USPDLO(INUM)
C  STORE NEW PARAMETER DEFINITION
 100  CONTINUE
C  STRAIGHT PARAMETER DEFINITION:
      IF(IOP.EQ.0) THEN
        IF(IGLOBL.EQ.0) CALL UPSADL(ZNAM,ZVAL)
        IF(IGLOBL.EQ.1) CALL UPSADG(ZNAM,ZVAL)
                   ELSE
C  ARITHMETIC
        CALL UPSART(ZNAM,ZVALP,ZVAL,IOP,IGLOBL)
      ENDIF
      GO TO 10
C  DELETE PARAMETER (IF IT EXISTS)
 150  CONTINUE
      CALL USPLOC(ZNAM,ITYP,INUM)
      IF(ITYP.NE.0) GO TO 160
C  ERROR
      IER=IER+1
      WRITE(LUNTRM,4002) ZNAM
 4002 FORMAT(' % ATTEMPT TO DELETE NON-EXISTANT PARAMETER "',
     >  A16,'" IGNORED.'/)
      CALL UPAUST(1)
      GO TO 10
C
 160  CONTINUE
      IF(ITYP.EQ.1) CALL USPDLO(INUM)
      IF(ITYP.EQ.2) CALL USPDGL(INUM)
      GO TO 10
C-----------------
C  ERROR MESSAGE
 190  CONTINUE
      IER=IER+1
      WRITE(LUNTRM,4005) (ZLINE(I),I=1,MIN(128,ILINE)),INIT,IFIN
 4005 FORMAT(' % ERROR PARSING PARAMETER ASSIGNMENT REQUEST LINE:'/
     >  1X,128A1/'   CHARACTERS # ',I3,' TO ',I3/
     >  '   INTENDED ASSIGNMENTS IN THIS CHARACTER RANGE NOT PERFORMED'
     >  /)
      CALL UPAUST(1)
      CALL UCLEAR
      GO TO 10
C-----------------------------
C  LOOP EXIT
 200  CONTINUE
      RETURN
      	END
C******************** END FILE UPMASG.FOR ; GROUP USPARM ***************

C******************** START FILE UFSNM0.FOR ; GROUP UFILES ******************
C------------------------------------------------------------
C  UFSNM0
C  CONSTRUCT FILENAME FROM NAME ELEMENTS
C   OUTPUT ZFILE - CONSTRUCTED FILENAME
C   INPUT  ZDEV  - DEVICE NAME (INCLUDING ":")
C          ZDIR  - DIRECTORY NAME (NOT INCLUDING BRACKETS "[ ]")
C          ZPRE  - PREFIX
C          ZSHOT - SHOT (CHARACTER ENCODED)
C          ZEXT  - FILENAME .EXT EXTENSION
C
C  IF NOT ALL ELEMENTS FIT AS MANY ARE INSERTED AS POSSIBLE WITH
C  PRIORITY (HIGH TO LOW):  ZSHOT,ZPRE,ZEXT,ZDIR,ZDEV
C
C  CONSTRUCTED FILENAME (IF ALL ELEMENTS FIT):
C   ZDIR//ZPRE//ZSHOT//'.'//ZEXT ... WHERE ZDIR ENDS IN "/" (EG. MCCUNE/)
C
      SUBROUTINE UFSNM0(ZFILE,ZDEV,ZDIR,ZPRE,ZSHOT,ZEXT)
C
      CHARACTER*(*) ZFILE
      CHARACTER*(*) ZDEV
      CHARACTER*(*) ZDIR
      CHARACTER*(*) ZPRE
      CHARACTER*(*) ZSHOT
      CHARACTER*(*) ZEXT
C
      CHARACTER*24 ERRLBL
      DATA ERRLBL/'UFSNM0: FILENAME ELEMENT'/
C
C  GET LENGTH OF ZFILE
C
      ILEN=LEN(ZFILE)
C
C  FIGURE OUT WHAT TO ENCODE
C
      IENCOD=0
      IDEV=0
      IDIR=0
      ISHOT=0
      IPRE=0
      IEXT=0
C
C  CHECK ELEMENTS IN ORDER OF PRIORITY
C
      IL=IUFTRM(ZSHOT,ERRLBL,IER)
      IF(IL.GT.ILEN) GO TO 100
      ISHOT=IL
      IENCOD=IL
C
      IL=IUFTRM(ZPRE,ERRLBL,IER)
      IF((IENCOD+IL).GT.ILEN) GO TO 100
      IPRE=IL
      IENCOD=IENCOD+IL
C
      IL=IUFTRM(ZEXT,ERRLBL,IER)
      ILP1=0
      IF(IL.GT.0) ILP1=IL+1              ! ALLOW FOR "."
      IF((IENCOD+ILP1).GT.ILEN) GO TO 100
      IEXT=IL
      IENCOD=IENCOD+ILP1
C
      IL=IUFTRM(ZDIR,ERRLBL,IER)
      ILP2=0
      IF(IL.GT.0) ILP2=IL
      IF((IENCOD+ILP2).GT.ILEN) GO TO 100
      IDIR=IL
      IENCOD=IENCOD+ILP2
C
      IL=IUFTRM(ZDEV,ERRLBL,IER)
      IF((IENCOD+IL).GT.ILEN) GO TO 100
      IDEV=IL
      IENCOD=IENCOD+IL
C
 100  CONTINUE
      IEND=0
C
C  BUILD FILENAME IN CORRECT SYNTACTIC ORDER
      IF(IDEV.GT.0) THEN
        ISTART=IEND+1
        IEND=IEND+IDEV
        ZFILE(ISTART:IEND)=ZDEV(1:IDEV)
      ENDIF
C
      IF(IDIR.GT.0) THEN
        ISTART=IEND+1
        IEND=IEND+IDIR
        ZFILE(ISTART:IEND)=ZDIR(1:IDIR)
      ENDIF
C
      IF(IPRE.GT.0) THEN
        ISTART=IEND+1
        IEND=IEND+IPRE
        ZFILE(ISTART:IEND)=ZPRE(1:IPRE)
      ENDIF
C
      IF(ISHOT.GT.0) THEN
        ISTART=IEND+1
        IEND=IEND+ISHOT
        ZFILE(ISTART:IEND)=ZSHOT(1:ISHOT)
      ENDIF
C
      IF(IEXT.GT.0) THEN
        ISTART=IEND+1
        IEND=IEND+IEXT+1
        ZFILE(ISTART:IEND)='.'//ZEXT(1:IEXT)
      ENDIF
C
C  PAD WITH BLANKS IF NECESSARY
C
      IF(IENCOD.LT.ILEN) THEN
        IP1=IENCOD+1
        DO 110 IC=IP1,ILEN
          ZFILE(IC:IC)=' '
 110    CONTINUE
      ENDIF
C
      RETURN
      END
C******************** END FILE UFSNM0.FOR ; GROUP UFILES ******************

C******************** START FILE UPPASG.FOR ; GROUP USPARM ******************
C
C-----------------------------------------------------------
C& UPPASG  ASSIGN INLINE PASSED VALUE TO UREAD PARAMETER NAME
C
C  THIS ROUTINE ALLOWS USER PROGRAMS TO ASSIGN VALUES TO
C  STRING PARAMETERS WHICH MAY THEN BE REFERENCED BY THE
C  INTERACTIVE USER OR INDIRECT FILE AS IF THE PARAMETER HAD
C  BEEN DEFINED INTERACTIVELY BY THE USER OR IN HIS INDIRECT
C  INPUT FILE.
C
      SUBROUTINE UPPASG(ZNAM,ZVAL,IGLOBL)
C
C  ZNAM-- UP TO 16 CHAR INPUT NAME, NO IMBEDDED BLANKS, ALPHANUMERIC
C  ZVAL-- UP TO 96 CHAR VALUE
C
C  IGLOBL=1 TO MAKE ASSIGNMENT TO GLOBAL PARAMETERS LIST; LOCAL
C   OTHERWISE
C
      USE USERIO
C
      CHARACTER*1 ZLOCL(96)
      CHARACTER*16 ZNAM
      CHARACTER*96 ZVAL
C  INITIALIZE USER I/O COMMON IF NECESSARY
      CALL USICHK
C  CHECK LEGALITY OF NAME AND VALUE
      READ(1001,ZNAM) (ZLOCL(I),I=1,LPNAM)
 1001 FORMAT(96A1)
      I1=1
      I2=LPNAM
      IL=LPNAM
      CALL USPLNM(ZLOCL,IL,I1,I2,ZNAM,IER)
      IF(IER.NE.0) GO TO 9001
C
      READ(ZVAL,1001) (ZLOCL(I),I=1,LPVAL)
      I1=1
      I2=LPVAL
      IL=LPVAL
      CALL USPLVL(ZLOCL,IL,I1,I2,ZVAL,IER)
      IF(IER.NE.0) GO TO 9002
C  CHECK FOR REPLACEMENT OF ALREADY DEFINED PARAMETER
      CALL USPLOC(ZNAM,ITYPE,INUM)
      IF(ITYPE.EQ.0) GO TO 100
C  WARNING ON FIRST FEW OCCURANCES
      DATA IWARN/5/
      IWARN=IWARN-1
      IF(NLECHO) WRITE(LUNTRM,2001) ZNAM
 2001 FORMAT(' % UPPASG USER PROGRAM ASSIGNMENT REPLACES'/
     >  '   PRIOR DEFINITION OF PARAMETER  "',A16,'"')
      IF(ITYPE.EQ.1) CALL USPDLO(INUM)
      IF(ITYPE.EQ.2) CALL USPDGL(INUM)
C  STORE NEW PARAMETER DEFINITION
 100  CONTINUE
      IF(IGLOBL.EQ.1) CALL UPSADG(ZNAM,ZVAL)
      IF(IGLOBL.NE.1) CALL UPSADL(ZNAM,ZVAL)
      RETURN
C--------
C  ERRORS-- ALL FATAL
C
 9001 CONTINUE
      WRITE(LUNTRM,9901)
 9901 FORMAT(' ? UPPASG:  ILLEGAL NAME, USER PROGRAM ASSIGNMENT')
      GO TO 9005
 9002 CONTINUE
      WRITE(LUNTRM,9902)
 9902 FORMAT(' ? UPPASG:  ILLEGAL VALUE, USER PROGRAM ASSIGNMENT')
      GO TO 9005
 9005 CONTINUE
      WRITE(LUNTRM,9905) trim(ZNAM),trim(ZVAL),IGLOBL
 9905 FORMAT(/' ? ATTEMPT TO ASSIGN VALUE TO STRING PARAMETER'/
     >  '   VIA CALL TO SUBROUTINE "UPPASG" FAILED.  ARGUMENTS:'/
     >  '   ZNAM:  "',A,'"'/
     >  '   ZVAL:  "',A,'"'/
     >  ' IGLOBL:  ',I5/)
      CALL URDABO
      	END
C******************** END FILE UPPASG.FOR ; GROUP USPARM ******************

subroutine plot_fp_fs(n1,n2,evec1,tvec1,fvec1,evec2,tvec2,wkvec,farr)

  ! plot FS data from fpreact

  use iso_c_binding, only: fp => c_double
  use fpreact_parameters

  implicit NONE

  ! data buffers -- uninitialized!

  integer, intent(in) :: n1,n2  ! dimension info

  real(fp) :: evec1(n1)             ! E-vector for f(E) plot
  real(fp) :: tvec1(n1)             ! T-vector for f(T) plot
  real(fp) :: fvec1(n1)             ! for f(E) plot or f(T) plot
  real(fp), dimension(:), allocatable :: fvec1_dpc
  real(fp) :: evec2(n2),tvec2(n2)   ! E,T for f(E,T) plot
  real(fp) :: wkvec(max(n1,n2))
  real(fp) :: farr(n2,n2)           ! for f(E,T) plot

  !----------------------------------
  real(fp) :: xvec2(n2)             ! pitch grid for gyro-avg fusn rate coeff plots

  integer luntrm,lnout
  logical lxout,lchar

  integer ifusn,ihandle,idum1,idum2,iopt,i

  real(fp) erange1,erange2,trange1,trange2,xrange1,xrange2

  character*60 zlbl1,zlbl2,zlbl3

  character*30 flbl
  character*15 funs
  character*10 zbzi

  character*6 rlbl
  real(fp) zamu,zv
  CHARACTER*6 ckxtyp ! log/linear
  integer:: kxtyp,idcod,iert
  real(fp)::zxmin,zxmax,efac
  real*4 :: z_xmin, z_xmax ! do not change real*4 to real(fp)
!----------------------------------

  luntrm=lnout(0)

  zlbl1='preact/fpreact "FS" database'

  luntrm=lnout(0)
  
  !------------------------------
10 continue

  if(lxout(0)) write(luntrm,1001)
1001 format(/ &
          'plot of fusion rate coefficients for select fusion reactions:'/ &
          '  1) DDp -- DD proton branch'/ &
          '  2) DDn -- DD neutron branch'/ &
          '  3) D->T -- DT, D -> T target'/ &
          '  4) T->D -- DT, T -> D target'/ &
          '  5) TT -- TT fusion'/ &
          '  12) TT -- TT fusionm DPC fit 06/2018'/ &
          '  6) D->3 -- D-He3, D -> He3 target'/ &
          '  7) 3->D -- D-He3, He3 -> D target'// &
          '[sigma*v] vs. energy -> cold target'/ &
          'beam-target <sigma*V>(Eb,Ti) table'/ &
          'beam-beam <sigma*V>(Eb,x) table'/ &
          'thermonuclear <<sigma*V>>(Ti) table')

  ifusn=0
  call ureadi('select fusion reaction to look at (1-7) or 12; 0 to quit:$',ifusn)
  if((ifusn.lt.0).or.(ifusn.gt.7.and.ifusn.ne.12)) then
     call uermsi('?plot_fp_fs.f90: unrecognized reaction code.',ifusn,0)
     go to 10
  endif
  if(ifusn.eq.0) then
     return
  else if(ifusn.eq.1) then
     call fusn_handle_ddp(ihandle)
     rlbl='DDp '
     zamu=2  ! AMU of projectile
  else if(ifusn.eq.2) then
     call fusn_handle_ddn(ihandle)
     rlbl='DDn '
     zamu=2  ! AMU of projectile
  else if(ifusn.eq.3) then
     call fusn_handle_dt(ihandle)
     rlbl='D->T'
     zamu=2  ! AMU of projectile
  else if(ifusn.eq.4) then
     call fusn_handle_td(ihandle)
     rlbl='T->D'
     zamu=3  ! AMU of projectile
  else if(ifusn.eq.5) then
     call fusn_handle_tt(ihandle)
     rlbl=' TT '
     zamu=3  ! AMU of projectile
  else if(ifusn.eq.12) then
     call fusn_handle_dpctt(ihandle)
     rlbl='dpcTT '
     zamu=3  ! AMU of projectile
  else if(ifusn.eq.6) then
     call fusn_handle_d3(ihandle)
     rlbl='D->He3'
     zamu=2  ! AMU of projectile 
  else if(ifusn.eq.7) then
     call fusn_handle_3d(ihandle)
     rlbl='He3->D'
     zamu=3  ! AMU of projectile
  endif

  do
     if(lxout(0)) write(luntrm,*) ' "Q" to quit;'
     if(lxout(0)) write(luntrm,*) ' ..."C" for cross-section;'
     if(lxout(0)) write(luntrm,*) ' ..."0" for cold target sigma*v;'
     if(lxout(0)) write(luntrm,*) ' ..."1" for beam-target table;'
     if(lxout(0)) write(luntrm,*) ' ..."2" for beam-beam table;'
     if(lxout(0)) write(luntrm,*) ' ..."3" for thermonuclear table;'
     call uread('enter "0" for cold target plot; "1" for beam-target table:$')

     if(lchar('Q')) then
        exit
     else if(lchar('C')) then
        iopt=-1
     else if(lchar('0')) then
        iopt=0
     else if(lchar('1')) then
        iopt=1
     else if(lchar('2')) then
        iopt=2
     else if(lchar('3')) then
        iopt=3
     else
        call uermsg('plot_fp_fs: invalid option.',' ',0)
        cycle
     endif

     if(iopt.le.0) then
        if(iopt.eq.0) then
           zlbl2='[sigma*v](E) fusion rate coefficient'
           zlbl3 = rlbl//' fusion, cold target, vs. projectile energy'
           funs='m**3/sec'
        else
           zlbl2='[sigma](E) fusion cross section'
           zlbl3 = rlbl//' fusion cross section vs. projectile energy'
           funs='m**2'
        endif

        !  get [sigma*v] table range
        call fs_coldtarget_erange(ihandle,erange1,erange2,idum1,idum2)
        ckxtyp='LOG'
        kxtyp=1
102     CONTINUE        
        IF(LXOUT(0)) WRITE(LUNTRM,1002) erange1,erange2,ckxtyp
        CALL UREAD('plot_fpreact: enter CONTROL OPTION:$$')
        IF(LCHAR('X')) THEN
           Z_XMIN= real(erange1)
           CALL UREADF('plot_fpreact:  ENTER NEW XMIN:$$',Z_XMIN)
           zxmin=z_xmin*1.0_fp
           Z_XMAX= real(erange2)
           CALL UREADF('plot_fpreact:  ENTER NEW XMAX:$$',Z_XMAX)
           zxmax=z_xmax*1.0_fp
           erange1=AMAX1(0.001,AMIN1(ZXMIN,ZXMAX))
           erange2=AMAX1(0.001,ZXMIN,ZXMAX)
           IF(erange2.LE.erange1) erange2=1.1*erange1
           CALL UREAD('plot_fpreact:  ENTER 1 for LOG or 2 for LINEAR:$$')
           kxtyp=idcod(iert)
           if(kxtyp.eq.2) then
              ckxtyp='LINEAR'
           endif
           if(kxtyp.eq.1) then
              ckxtyp='LOG'
           endif
           GO TO 102
        endif
        call plot_fp_mkvec(erange1,erange2,n1,evec1)

        if(ifusn.eq.1) then
           call fusn_coldtarget_DDn(evec1,fvec1,n1)
        else if(ifusn.eq.2) then
           call fusn_coldtarget_DDp(evec1,fvec1,n1)
        else if(ifusn.eq.3) then
           call fusn_coldtarget_DT(evec1,fvec1,n1)
        else if(ifusn.eq.4) then
           call fusn_coldtarget_TD(evec1,fvec1,n1)
        else if(ifusn.eq.5) then
           call fusn_coldtarget_TT(evec1,fvec1,n1)
        else if(ifusn.eq.12) then
           if(allocated(fvec1_dpc)) deallocate(fvec1_dpc)
           allocate(fvec1_dpc(n1))
           fvec1_dpc=0.0
           fvec1=0.0
           if(iopt.lt.0) then
              zlbl2='<<sigma>>,TT--fusn cross section: DPC--solid, old--dashed'
              zlbl3 = ' TT fusion, fusn cross section, vs. projectile energy'
          else
              zlbl2='<<sigma*v>>,TT--fusn rate coeff: DPC--solid, old--dashed'
              zlbl3 = ' TT fusion, cold target, vs. projectile energy'
           endif
           call fusn_coldtarget_dpcTT(evec1,fvec1_dpc,n1)
           call fusn_coldtarget_TT(evec1,fvec1,n1)
        else if(ifusn.eq.6) then
           call fusn_coldtarget_D3(evec1,fvec1,n1)
        else if(ifusn.eq.7) then
           call fusn_coldtarget_3D(evec1,fvec1,n1)
        endif
        efac=1.0
        if(iopt.lt.0) then
           do i=1,n1
              efac=zamu/(zamu+zamu)
              zv=sqrt(1000.0*evec1(i)*efac/zamu)*1.384e4  ! m/sec
              fvec1(i)=fvec1(i)/zv  ! convert to sigma (m**2)
              if(ifusn.eq.12) then
                 fvec1_dpc(i)=fvec1_dpc(i)/zv  ! convert to sigma (m**2)
              endif
           enddo
        endif
        if(ifusn.eq.12) then
           if(kxtyp.eq.1) then
              call gaxspc(3) ! log-log
           else if(kxtyp.eq.2) then
              call gaxspc(2) ! lin-log
           endif
           CALL r8_GRAFX2(evec1,fvec1_dpc,fvec1,n1,'KeV',funs,zlbl1,zlbl2,zlbl3)
        else
           call gaxspc(3) ! log-log
           call r8_grafx1(evec1,fvec1,n1,'KeV',funs,zlbl1,zlbl2,zlbl3)
        endif
        call gaxspc(1) ! restore default

     else if(iopt.eq.1) then
        ! get table range information
        call fs_warmtarget_erange(ihandle,erange1,erange2,idum1,idum2)
        call fs_warmtarget_trange(ihandle,trange1,trange2,idum1,idum2)
        call plot_fp_mkvec(erange1,erange2,n2,evec2)
        call plot_fp_mkvec(trange1,trange2,n2,tvec2)

        flbl=rlbl//' beam-target <sigma*v>'
        funs='m**3/sec'

        do i=1,n2
           wkvec(1:n2)=tvec2(i)
           if(ifusn.eq.1) then
              call fusn_btsigv_ddp(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.2) then
              call fusn_btsigv_ddn(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.3) then
              call fusn_btsigv_dt(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.4) then
              call fusn_btsigv_td(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.5) then
              call fusn_btsigv_tt(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.12) then
              call fusn_btsigv_dpctt(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.6) then
              call fusn_btsigv_d3(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.7) then
              call fusn_btsigv_3d(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           endif
        enddo

        wkvec=0
        call r8_grf3f1(evec2,farr,tvec2,wkvec,n2,n2,n2, &
             'beam Eb',flbl,'target Ti', &
             'KeV(Eb)',funs,'KeV(Ti)',zlbl1,'beam-target',0)

     else if(iopt.eq.2) then
        if(ifusn.eq.4) then
           call uermsg(' %use D->T for all DT beam-beam data.',' ',0)
           cycle
        else if(ifusn.eq.7) then
           call uermsg(' %use D->3 for all D-He3 beam-beam data.',' ',0)
           cycle
        endif
        ! get table range information
        call fs_gyroavg_erange(ihandle,erange1,erange2,idum1,idum2)
        call fs_gyroavg_varrange(ihandle,trange1,trange2,idum1,idum2)
        call plot_fp_mkvec(erange1,erange2,n2,evec2)
        do i=1,n2-1
           tvec2(i)=trange1+(i-1)*(trange2-trange1)/(n2-1)
        enddo
        tvec2(n2)=trange2

        flbl=rlbl//' beam-beam <sigma*v>'
        funs='m**3/sec'

        do i=1,n2
           wkvec(1:n2)=tvec2(i)
           if(ifusn.eq.1) then
              call fusn_bbsigv_ddp(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.2) then
              call fusn_bbsigv_ddn(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.3) then
              call fusn_bbsigv_dt(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.5) then
              call fusn_bbsigv_tt(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.12) then
              call fusn_bbsigv_dpctt(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           else if(ifusn.eq.6) then
              call fusn_bbsigv_d3(evec2,wkvec(1:n2),farr(1:n2,i),n2)
           endif
        enddo

        wkvec=0
        call r8_grf3f1(evec2,farr,tvec2,wkvec,n2,n2,n2, &
             'beam Eb',flbl,'variance', &
             'KeV(Eb)',funs,'fraction',zlbl1,'beam-beam',0)

     else if(iopt.eq.3) then

        zlbl2='<<sigma*v>>(Ti) fusion rate coefficient'
        zlbl3 = rlbl//' thermonuclear fusion vs. Ti'
        funs='m**3/sec'

        !  get [sigma*v] table range
        call fs_thermonuclear_trange(ihandle,trange1,trange2,idum1,idum2)
        ckxtyp='LOG'
        kxtyp=1
101     CONTINUE        
        IF(LXOUT(0)) WRITE(LUNTRM,1002) trange1,trange2,ckxtyp
1002    FORMAT(/&
             &'  A -- except settings'/&
             &'  X -- TO SET ENERGY RANGE (KEV) OF PLOT, CURRENTLY'/&
             &'       XMIN,XMAX=',2(1X,1PE11.4),' TYPE =',A6/&
             &)
        CALL UREAD('plot_fpreact:  CONTROL OPTION:$$')
        IF(LCHAR('X')) THEN
           Z_XMIN= real(trange1)
           CALL UREADF('plot_fpreact:  ENTER NEW XMIN:$$',Z_XMIN)
           zxmin=z_xmin*1.0_fp
           ZXMAX= real(trange2)
           CALL UREADF('plot_fpreact:  ENTER NEW XMAX:$$',Z_XMAX)
           zxmax=z_xmax*1.0_fp
           trange1=AMAX1(0.001,AMIN1(ZXMIN,ZXMAX))
           trange2=AMAX1(0.001,ZXMIN,ZXMAX)
           IF(trange2.LE.trange1) trange2=1.1*trange1
           CALL UREAD('plot_fpreact:  ENTER 1 for LOG or 2 for LINEAR:$$')
           kxtyp=idcod(iert)
           if(kxtyp.eq.2) then
              ckxtyp='LINEAR'
           endif
           if(kxtyp.eq.1) then
              ckxtyp='LOG'
           endif
           GO TO 101
        endif
        call plot_fp_mkvec(trange1,trange2,n1,tvec1)

        if(ifusn.eq.1) then
           call fusn_thermo_DDn(tvec1,fvec1,n1)
        else if(ifusn.eq.2) then
           call fusn_thermo_DDp(tvec1,fvec1,n1)
        else if(ifusn.eq.3) then
           call fusn_thermo_DT(tvec1,fvec1,n1)
        else if(ifusn.eq.4) then
           call fusn_thermo_TD(tvec1,fvec1,n1)
        else if(ifusn.eq.5) then
           call fusn_thermo_TT(tvec1,fvec1,n1)
        else if(ifusn.eq.12) then
           if(allocated(fvec1_dpc)) deallocate(fvec1_dpc)
           allocate(fvec1_dpc(n1))
           fvec1_dpc=0.0
           fvec1=0.0
           zlbl2='<<sigma*v>>,TT--fusn rate coeff: DPC--solid, old--dashed'
           zlbl3 = ' TT thermonuclear fusion vs. Ti'
           call fusn_thermo_dpcTT(tvec1,fvec1_dpc,n1)
           call fusn_thermo_TT(tvec1,fvec1,n1)
        else if(ifusn.eq.6) then
           call fusn_thermo_D3(tvec1,fvec1,n1)
        else if(ifusn.eq.7) then
           call fusn_thermo_3D(tvec1,fvec1,n1)
        endif
        if(ifusn.eq.12) then
           if(kxtyp.eq.1) then
              call gaxspc(3) ! log-log
           else if(kxtyp.eq.2) then
              call gaxspc(2) ! lin-log
           endif
           CALL r8_GRAFX2(tvec1,fvec1_dpc,fvec1,n1,'KeV',funs,zlbl1,zlbl2,zlbl3)
        else
           call gaxspc(3) ! log-log
           call r8_grafx1(tvec1,fvec1,n1,'KeV',funs,zlbl1,zlbl2,zlbl3)
        endif
        call gaxspc(1) ! restore default
     endif
     
  enddo
  go to 10

end subroutine plot_fp_fs

C-----------------------------------------------------------------------
C  URXOUT -- SET UREAD OUTPUT FLAG
C
      SUBROUTINE URXOUT
C
      USE USERIO
C
C  AFTER DEFERRING TO NLXPER (EXPERT MODE) AND NLECHO (ECHO/DEBUG MODE)
C  SWITCHES, SET OUTPUT FLAG TRUE UNLESS
C    A)  THERE IS MORE INPUT IN THE TYPEAHEAD BUFFER, OR,
C    B)  THERE IS MORE INPUT IN THE PRESET LINE BUFFERS, OR,
C    C)  AN INPUT FILE IS OPEN
C
      IF(NLXPER) THEN
        NLXOUT=.FALSE.
      ELSE IF(NLECHO) THEN
        NLXOUT=.TRUE.
      ELSE
        NLXOUT=.TRUE.
        IF(NCHARC.GT.0) NLXOUT=.FALSE.
        IF(NPRBUF.GT.0) NLXOUT=.FALSE.
        IF(NLINDI) NLXOUT=.FALSE.
      ENDIF
C
      RETURN
      END

C-------------------------------------------------------------
C  GSCXDF - BASED ON DATA X,Y MIN MAX INFORMATION STORED IN COMMON,
C   AND OPTION SWITCH SETTINGS, ALSO IN COMMON,
C  DECIDE ON THE SCALE FOR THE X AXIS, UPCOMING PLOT
C  THIS MAY INCLUDE ASKING THE USER FOR INFORMATION
C
      SUBROUTINE GSCXDF(IOPT)
C
C  AXIS TYPES COMMON--
C
      INCLUDE 'GAXES_BLK'
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
C  PLOT1 COMMON
C
      INCLUDE 'PLOT1MMX'
C
C  START OF EXECUTABLE CODE
C
C  MOD DMC - PASSED ARG OVERRIDE OPTION
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR,lxout
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C

      luntrm=lnout(0)

      IF(IOPT.EQ.0) THEN
        JOPTX=NOPTX
        JOPTY=NOPTY
C
        IF((JOPTX.EQ.2).OR.(JOPTY.EQ.2)) CALL NEUPAG
C
      ELSE
        JOPTX=IOPT
      ENDIF
C
 10   CONTINUE
C  DO X AXIS
      GO TO (20,30,40,50,60) JOPTX
C
 20   CONTINUE
      XMIN=GMINX
      XMAX=GMAXX
      IF((IXXMAP(IAXCUR).EQ.1).AND.(GMINXP.GT.0.0)) THEN
        XMIN=GMINXP
        XMAX=AMAX1(XMAX,1.1*XMIN)
      ENDIF
C
      GO TO 90
C
 30   CONTINUE
      IF(lxout(0)) WRITE(LUNTRM,3001) GMINX,GMAXX,GMINY,GMAXY
 3001 FORMAT(//'  DATA:'/
     >  '  MINIMUM X:  ',1PE10.3,' MAXIMUM X:  ',1PE10.3/
     >  '  MINIMUM Y:  ',1PE10.3,' MAXIMUM Y:  ',1PE10.3/
     >  '  ENTER "X" TO USE THE ABOVE LIMITS IN THE PLOT SCALE')
      CALL UREAD(' GSCSET >> ENTER XMIN FOR GRAPH:$')
      IF(.NOT.LCHAR('X')) XMIN=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 30
C
 35   CONTINUE
      CALL UREAD(' GSCSET >> ENTER XMAX FOR GRAPH:$')
      IF(.NOT.LCHAR('X')) XMAX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 35
      GO TO 90
C
 40   CONTINUE
      XMIN=XMIN00
      XMAX=XMAX00
      GO TO 90
C
 50   CONTINUE
      XMAX=GMAXX
      XMIN=XMAX*XRAT00
C
      GO TO 90
C
 60   CONTINUE
      XMIN=GMINX
      XMAX=XMIN*XRAT00
      GO TO 90
C
 90   CONTINUE
      IF(XMAX.LT.XMIN) THEN
        ZTMP=XMAX
        XMAX=XMIN
        XMIN=ZTMP
      ELSE IF(XMAX.EQ.XMIN) THEN
C  XMAX=XMIN
        ZDELX=ABS(.01*XMIN)
        ZXA=XMIN
        IF(ZDELX.EQ.0.0) ZDELX=0.1
        XMIN=ZXA-ZDELX
        XMAX=ZXA+ZDELX
      ENDIF
C
      RETURN
      END

      subroutine ufascio3(lun,f,nf1,nf2,nx,ny,nz,code,iend,ierr)
C
C  ascii read or write of 3d dimensioned array
C    actually reads/writes by ufascio routine via buffer array
C
C    fortran format loop being avoided because of portability issues
C
C  arguments
C
      integer lun                 ! Fortran i/o channel
      real f(nf1,nf2,nz)          ! 3d data array
      integer nx,ny,nz            ! dimensions of data to write in f
      character*1 code            ! 'W' to write, 'R' to read
      integer iend                ! set =1 if EOF encountered on read
      integer ierr                ! set =1 if error encountered on read
C
C---------------------------
C
C  buffer
C
      parameter (inbuf=600)  ! multiple of 6 (cf ufascio)
      common/uscrbufr/ ub(inbuf)
C
C---------------------------
C
      itot=nx*ny*nz
C
      if(code.eq.'W') then
         ibuf=0
         idon=0
      else
C  read first buffer full
         ibuf=min(inbuf,itot)
         call ufascio(lun,ub,ibuf,code,iend,ierr)
         if(iend.gt.0) go to 1999
         if(ierr.gt.0) go to 1999
         idon=ibuf
         icur=1
      endif
C
C  data loop
C
      do iz=1,nz
      do iy=1,ny
         do ix=1,nx
            if(code.eq.'W') then
C  store in buffer
               ibuf=ibuf+1
               ub(ibuf)=f(ix,iy,iz)
               if(ibuf.eq.inbuf) then
C  write full buffer
                  call ufascio(lun,ub,ibuf,code,iend,ierr)
                  idon=idon+ibuf
                  ibuf=0
               endif
            else
C  save from buffer
               f(ix,iy,iz)=ub(icur)
               icur=icur+1
               if(icur.gt.ibuf) then
C  read a buffer full
                  ibuf=min(inbuf,(itot-idon))
                  if(ibuf.gt.0) then
                     call ufascio(lun,ub,ibuf,code,iend,ierr)
                     if(iend.gt.0) go to 1999
                     if(ierr.gt.0) go to 1999
                     idon=idon+ibuf
                     icur=1
                  endif
               endif
            endif   ! R/W
         enddo  ! ix
      enddo  ! iy
      enddo  ! iz
C
      if(ibuf.gt.0) then
         call ufascio(lun,ub,ibuf,code,iend,ierr)  ! write partial
      endif
C
 1999 continue
      return
      end

      FUNCTION EXPI(X)
C
C	THIS SUBROUTINE EVALUATES THE EXPONENTIAL INTEGRAL
C	OF THE FIRST KIND, USING A RATIONAL APPROXIMATION FROM
C	ABRAMOWITZ AND STEGUN
C
      DATA A0/-0.57721566/, A1/0.99999193/, A2/-0.24991055/
      DATA A3/0.05519968/, A4/-0.00976004/, A5/0.00107857/
      DATA AA1/2.334733/, AA2/0.250621/
      DATA BB1/3.330657/, BB2/1.681534/
      IF(X.GT.50.E00) GO TO 30
      IF(X.GT.1.0) GOTO 10
      EXPI=A0+A1*X+A2*X**2+A3*X**3+A4*X**4+A5*X**5-ALOG(X)
      GOTO 20
10    EXPI=(X**2+AA1*X+AA2)/(X**2+BB1*X+BB2)/(X*EXP(X))
20    RETURN
30    EXPI=0.E00
      RETURN
      END

! 05may1999 fgtok -impno -s r8_precision.sub foo.sub "r8con.csh conversion"
C******************** START FILE FDCODE.FOR ; GROUP URDUTS *************
C==========================================================
C&  FDCODE - UREAD DECODE CHARACTER TO REAL - OBSCELESCENT
C
C  DECODE E10.0 INPUT IN UNPACKED BUFFER
C  REV D. MC CUNE 3-JUN-80 ... CHECK FOR ILLEGAL CHARACTERS
C
      REAL*8 FUNCTION r8dcod(IER)
C
C  REVISED D. MC CUNE JULY 14 1980  ADD ERROR CODE
C   IER=0 DENOTES SUCCESSFUL DECODING OF E10 FORMAT
C     IER=1 DENOTES DETECTION OF ILLEGAL CHARACTER OR FORMAT
C      FCN VALUE OF 0.0 RETURNED
C
      USE USERIO
      IMPLICIT NONE
C
C----------------------------------------------------------
C
C============
C idecl:  explicitize implicit INTEGER declarations:
      INTEGER ic,id,icod,ier
C============
C idecl:  explicitize implicit REAL declarations:
      REAL*8 z,ur8dcod
C============
      Z=ur8dcod(CBUFF,IC,ID,ICOD)
C
      IF(ICOD.EQ.-1) THEN
        IER=0
        r8dcod=0.0D0
      ELSE IF(ICOD.EQ.0) THEN
        IER=0
        r8dcod=Z
      ELSE
        GO TO 900
      ENDIF
C  SUCCESSFULLY DECODED
      CALL UROTOR(ID)
      RETURN
C  ERROR
 900  CONTINUE
      r8dcod=0.0D0
      IER=1
      CALL UERMSG(' % FDCODE:  NOT FLOATING POINT:',
     >     CBUFF(1:ID),0)
      IF(NLINDI) CALL UPAUST(1)
      RETURN
      	END
C******************** END FILE FDCODE.FOR ; GROUP URDUTS ***************

      real function qhermitd(xparam,f0,fx0,fxx0,f1,fx1,fxx1,h,hi,
     >                       dfdx,d2fdx2)
C
C  evaluate a quintic Hermite interpolation; compute derivatives as well
C  as function value.
C
C  this routine takes a function and its 1st and 2nd derivatives at two
C  successive points on the grid.
C
C  note that the argument x is a **normalized parameter**, x=0 as at the
C  left end of the interval with fcn value f0, x=1 is at the right end of
C  the interval with fcn value f1.  That is, in the caller, there will
C  be some code like
C
C      xparam = (xwant-x(i))/(x(i+1)-x(i))  ! x(i).le.xwant.le.x(i+1)
C
C      h = x(i+1)-x(i)
C      hi = 1/h
C
C      ans=qhermitd(x,f(i),fd(i),fdd(i),f(i+1),fd(i+1),fdd(i+1),h,hi,
C     >       dfdx,d2fdx2)
C
C  the grid spacing h,hi are necessary due to the implicit transformation
C  of variables from [x(i),x(i+1)] to [0,1]; hi=1/h is provided for speed,
C  to avoid extra floating divides on repeated evaluations in the same
C  width intervals.
C
C  dfdx is in "units of" f/h; d2fdx2 in f/(h*h).
C
C  input:
C
      real xparam                       ! value (in [0,1]) to evaluate at
C
      real f0,fx0,fxx0                  ! fcn value, df/dx, d2fdx2 @ xparam=0
      real f1,fx1,fxx1                  ! fcn value, df/dx, d2fdx2 @ xparam=1
C
      real h,hi                         ! actual and inverse grid spacing
C
C  output:
C
C     (function value)                  ! interpolated value of f
      real dfdx                         ! interpolated value of df/dx
      real d2fdx2                       ! interpolated value of d2f/dx2
C
C----------------------------
C
      x=xparam
      x2=x*x
      x3=x2*x
C
      xb=1.0-x
      xb2=xb*xb
      xb3=xb*xb2
C
C  quintic interpolation is done by summing basis polynomials that have
C  nice properties, e.g. alpha(0)=alpha'(0)=alpha''(0)=0,
C                        alpha(1)=1, alpha'(1)=alpha''(1)=0
C
C  there are six such polynomials, each one having unit value or
C  derivative at 0 or 1, and 0 for all other values & derivatives
C
C  alpha(1)=1   alphabar(0)=1
C  beta'(1)=1   betabar'(0)=1
C  gamma''(1)=1 gammabar''(0)=1
C
      alpha=x3*(10.0-x*(15.0-6.0*x))    ! 6*x**5 -15*x**4 +10*x**3
      alphabar=1.0-alpha                ! alphabar = 1 -alpha  is easy to show
C
      dalpha=x2*(30.0-x*(60.0-30.0*x))  ! 30*x**4 -60*x**3 +30*x**2
      dalphabar=-dalpha
C
      ddalpha=x*(60.0-x*(180.0-120.0*x)) ! 120*x**3 -180*x**2 +60*x
      ddalphabar=-ddalpha
C
C
      beta=x3*(-4.0+x*(7.0-3.0*x))      ! -3*x**5 +7*x**4 -4*x**3
      betabar=xb3*(4.0-xb*(7.0-3.0*xb)) ! betabar(x) = -beta(xb)  easy to show
C
      dbeta=x2*(-12.0+x*(28.0-15.0*x))  ! -15*x**4 +28*x**3 -12*x**2
      dbetabar=xb2*(-12.0+xb*(28.0-15.0*xb)) ! betabar'(x) = beta'(xb)
C
      ddbeta=x*(-24.0+x*(84.0-60.0*x))  ! -60*x**3 +84*x**2 -24*x
      ddbetabar=xb*(24.0-xb*(84.0-60.0*xb))
C
C
      gamma=x3*(0.5-x*(1.0-0.5*x))      ! (1/2)*x**5 -x**4 +(1/2)*x**3
      gammabar=xb3*(0.5-xb*(1.0-0.5*xb)) ! gammabar(x) = gamma(xb) easy to show
C
      dgamma=x2*(1.5-x*(4.0-2.5*x))     ! (5/2)*x**4 -4*x**3 +(3/2)*x**2
      dgammabar=xb2*(-1.5+xb*(4.0-2.5*xb)) ! gammabar'(x) = -gamma'(xb)
C
      ddgamma=x*(3.0-x*(12.0-10.0*x))   ! 10*x**3 -12*x**2 + 3*x
      ddgammabar=xb*(3.0-xb*(12.0-10.0*xb))
C
C
C---------------------------
C
C  evaluate the function
C
      sum = alphabar*f0 + alpha*f1
     >   +h*(betabar*fx0 + beta*fx1)
     >   +h*h*(gammabar*fxx0 + gamma*fxx1)
C
      qhermitd = sum
C
C
C  evaluate the first derivative
C
      dfdx = hi*(dalphabar*f0 +dalpha*f1)
     >   +(dbetabar*fx0 +dbeta*fx1)
     >   +h*(dgammabar*fxx0 +dgamma*fxx1)
C
C  evaluate the second derivative
C
      d2fdx2 = hi*hi*(ddalphabar*f0 +ddalpha*f1)
     >   +hi*(ddbetabar*fx0 +ddbeta*fx1)
     >   +(ddgammabar*fxx0 +ddgamma*fxx1)
C
      return
      end

      MODULE sglib_mod
! 
!===========================================================================
! sgnco.F
      INTERFACE AGCLINS

      SUBROUTINE    R4_AGCLINS(
     > ZDATA,MXD,X,NX,Y,NY,CL,NCL)
      IMPLICIT NONE
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      integer nlm
      parameter(nlm=40)
      INTEGER MXD
      INTEGER NX
      INTEGER NY
      INTEGER NCL
      REAL(KIND=r4) :: ZDATA(:,:)
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      REAL(KIND=r4) :: CL(NLM)
      end subroutine R4_AGCLINS

      SUBROUTINE    R8_AGCLINS(
     > R8_ZDATA,MXD,R8_X,NX,R8_Y,NY,R8_CL,NCL)
      IMPLICIT NONE
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      integer nlm
      parameter(nlm=40)
      INTEGER MXD
      INTEGER NX
      INTEGER NY
      INTEGER NCL
      REAL(KIND=r8) :: R8_ZDATA(:,:)
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      REAL(KIND=r8) :: R8_CL(NLM)
      end subroutine R8_AGCLINS

      END INTERFACE

      INTERFACE AGRAPH
      SUBROUTINE AGRAPH(
     > MINX,MAXX,MINY,MAXY,XMIN,XMAX,YMIN,YMAX,XLABL,YLABL)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER MINX
      INTEGER MAXX
      INTEGER MINY
      INTEGER MAXY
      REAL(KIND=r4):: XMIN
      REAL(KIND=r4):: XMAX
      REAL(KIND=r4):: YMIN
      REAL(KIND=r4):: YMAX
      CHARACTER*(*) XLABL
      CHARACTER*(*) YLABL
      END SUBROUTINE AGRAPH

      SUBROUTINE R8_AGRAPH(
     > MINX,MAXX,MINY,MAXY,R8_XMIN,R8_XMAX,R8_YMIN,R8_YMAX,XLABL,YLABL)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER MINX
      INTEGER MAXX
      INTEGER MINY
      INTEGER MAXY
      REAL(KIND=r8) :: R8_XMIN
      REAL(KIND=r8) :: R8_XMAX
      REAL(KIND=r8) :: R8_YMIN
      REAL(KIND=r8) :: R8_YMAX
      CHARACTER*(*) XLABL
      CHARACTER*(*) YLABL
      END SUBROUTINE R8_AGRAPH
      END INTERFACE
!===========================================================================

       INTERFACE AGCXGET
       SUBROUTINE R4_AGCXGET(
     > XIND,FXX,X,NXS)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: XIND
      REAL(KIND=r4) :: FXX
      INTEGER NXS
      REAL(KIND=r4) :: X(:)
      END SUBROUTINE R4_AGCXGET
      
      SUBROUTINE R8_AGCXGET(
     > R8_XIND,R8_FXX,R8_X,NXS)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_XIND
      REAL(KIND=r8) :: R8_FXX
      INTEGER NXS
      REAL(KIND=r8) :: R8_X(:)
      END SUBROUTINE R8_AGCXGET
      END INTERFACE

      INTERFACE AGCYGET
      SUBROUTINE R4_AGCYGET(
     > YIND,FYY,Y,NYS)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: YIND
      REAL(KIND=r4) :: FYY
      INTEGER NYS
      REAL(KIND=r4) :: Y(:)
      END SUBROUTINE R4_AGCYGET
      SUBROUTINE R8_AGCYGET(
     > R8_YIND,R8_FYY,R8_Y,NYS)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_YIND
      REAL(KIND=r8) :: R8_FYY
      INTEGER NYS
      REAL(KIND=r8) :: R8_Y(:)
      END SUBROUTINE R8_AGCYGET
      END INTERFACE

      INTERFACE AGCPLST
      SUBROUTINE R4_AGCPLST(
     > PL1,PL2,KPL,X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER KPL
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      REAL(KIND=r4) :: PL1(:)
      REAL(KIND=r4) :: PL2(:)
      END SUBROUTINE R4_AGCPLST

      SUBROUTINE R8_AGCPLST(
     > R8_PL1,R8_PL2,KPL,R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER KPL
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      REAL(KIND=r8) :: R8_PL1(:)
      REAL(KIND=r8) :: R8_PL2(:)
      END SUBROUTINE R8_AGCPLST
      END INTERFACE


      INTERFACE AGNCOF
      SUBROUTINE R4_AGNCOF(
     > XCS,YCS,NCS,IAI,IAG,NAI)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER NCS
      INTEGER NAI
      REAL(KIND=r4) :: XCS(:)
      REAL(KIND=r4) :: YCS(:)
      INTEGER IAI(*)
      INTEGER IAG(*)
      END SUBROUTINE R4_AGNCOF

      SUBROUTINE R8_AGNCOF(
     > R8_XCS,R8_YCS,NCS,IAI,IAG,NAI)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER NCS
      INTEGER NAI
      REAL(KIND=r8) :: R8_XCS(:)
      REAL(KIND=r8) :: R8_YCS(:)
      INTEGER IAI(*)
      INTEGER IAG(*)
      END SUBROUTINE R8_AGNCOF
      END INTERFACE

      INTERFACE RCONTR
      SUBROUTINE R4_RCONTR(
     > K1,C,K2,A,MAXA,XARRAY,IMIN,IMAX,ISTEP,YARRAY,JMIN,
     > JMAX,JSTEP)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER K1
      INTEGER K2
      INTEGER MAXA
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
      REAL(KIND=r4) :: C(:)
      REAL(KIND=r4) :: A(:,:)
      REAL(KIND=r4) :: XARRAY(:)
      REAL(KIND=r4) :: YARRAY(:)
      END SUBROUTINE R4_RCONTR

      SUBROUTINE R8_RCONTR(
     > K1,R8_C,K2,R8_A,MAXA,R8_XARRAY,IMIN,IMAX,ISTEP,R8_YARRAY,JMIN,
     > JMAX,JSTEP)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER K1
      INTEGER K2
      INTEGER MAXA
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
      REAL(KIND=r8) :: R8_C(:)
      REAL(KIND=r8) :: R8_A(:,:)
      REAL(KIND=r8) :: R8_XARRAY(:)
      REAL(KIND=r8) :: R8_YARRAY(:)
      END SUBROUTINE R8_RCONTR
      END INTERFACE

      INTERFACE CONTUR
      SUBROUTINE R4_CONTUR(
     > K1,C,K2,A,MAXA,XARRAY,IMIN,IMAX,ISTEP,YARRAY,JMIN,
     > JMAX,JSTEP)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER K1
      INTEGER K2
      INTEGER MAXA
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
      REAL(KIND=r4) :: C(:)
      REAL(KIND=r4) :: A(:,:)
      REAL(KIND=r4) :: XARRAY(:,:)
      REAL(KIND=r4) :: YARRAY(:,:)  
      END SUBROUTINE R4_CONTUR  

      SUBROUTINE R8_CONTUR(
     > K1,R8_C,K2,R8_A,MAXA,R8_XARRAY,IMIN,IMAX,ISTEP,R8_YARRAY,JMIN,
     > JMAX,JSTEP)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER K1
      INTEGER K2
      INTEGER MAXA
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
      REAL(KIND=r8) :: R8_C(:)
      REAL(KIND=r8) :: R8_A(:,:)
      REAL(KIND=r8) :: R8_XARRAY(:,:)
      REAL(KIND=r8) :: R8_YARRAY(:,:)
      END SUBROUTINE R8_CONTUR  
      END INTERFACE

      INTERFACE AGCLXY
      SUBROUTINE R4_AGCLXY(
     > XAR,NX,IMIN)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER NX
      INTEGER IMIN
      REAL(KIND=r4) :: XAR(:)
      END SUBROUTINE R4_AGCLXY

      SUBROUTINE R8_AGCLXY(
     > R8_XAR,NX,IMIN)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER NX
      INTEGER IMIN
      REAL(KIND=r8) :: R8_XAR(:)
      END SUBROUTINE R8_AGCLXY
      END INTERFACE

      INTERFACE AGCUSET
      SUBROUTINE R4_AGCUSET(
     > XARRAY,YARRAY,MAXA,NX,NY)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER MAXA
      INTEGER NX
      INTEGER NY
      REAL(KIND=r4) :: XARRAY(:,:)
      REAL(KIND=r4) :: YARRAY(:,:)
      END SUBROUTINE R4_AGCUSET

      SUBROUTINE R8_AGCUSET(
     > R8_XARRAY,R8_YARRAY,MAXA,NX,NY)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER MAXA
      INTEGER NX
      INTEGER NY
      REAL(KIND=r8) :: R8_XARRAY(:,:)
      REAL(KIND=r8) :: R8_YARRAY(:,:)
      END SUBROUTINE R8_AGCUSET
      END INTERFACE

      INTERFACE AGCULEV
      SUBROUTINE R4_AGCULEV(
     > K1,C,K2,ZAR,NZ,CL,NCL)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER K1
      INTEGER K2
      INTEGER NZ
      INTEGER NCL
      REAL(KIND=r4) :: C(:)
      REAL(KIND=r4) :: ZAR(:)
      REAL(KIND=r4) :: CL(:)
      END SUBROUTINE R4_AGCULEV 

      SUBROUTINE R8_AGCULEV(
     > K1,R8_C,K2,R8_ZAR,NZ,R8_CL,NCL)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER K1
      INTEGER K2
      INTEGER NZ
      INTEGER NCL
      REAL(KIND=r8) :: R8_C(:)
      REAL(KIND=r8) :: R8_ZAR(:)
      REAL(KIND=r8) :: R8_CL(:)
      END SUBROUTINE R8_AGCULEV 
      END INTERFACE

      INTERFACE AGRCFR
      SUBROUTINE R4_AGRCFR(
     > X,IMIN,IMAX,ISTEP,Y,JMIN,JMAX,JSTEP,IGRID)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
      INTEGER IGRID
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      END SUBROUTINE R4_AGRCFR

      SUBROUTINE R8_AGRCFR(
     > R8_X,IMIN,IMAX,ISTEP,R8_Y,JMIN,JMAX,JSTEP,IGRID)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER IMIN
      INTEGER IMAX
      INTEGER ISTEP
      INTEGER JMIN
      INTEGER JMAX
      INTEGER JSTEP
      INTEGER IGRID
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      END SUBROUTINE R8_AGRCFR
      END INTERFACE

      INTERFACE AGCFRAM
      SUBROUTINE R4_AGCFRAM(
     > X,NX,Y,NY,IGRID)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER NX
      INTEGER NY
      INTEGER IGRID
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      END SUBROUTINE R4_AGCFRAM

      SUBROUTINE R8_AGCFRAM(
     > R8_X,NX,R8_Y,NY,IGRID)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER NX
      INTEGER NY
      INTEGER IGRID
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      END SUBROUTINE R8_AGCFRAM
      END INTERFACE

!==============================================================
! sggrf.F

      INTERFACE CHECK

      SUBROUTINE R4_CHECK(X,Y)
      IMPLICIT NONE
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      end subroutine R4_CHECK

      SUBROUTINE    R8_CHECK(R8_X,R8_Y)
      IMPLICIT NONE
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      end subroutine R8_CHECK

      END INTERFACE

      INTERFACE DSPLAY
      SUBROUTINE R4_DSPLAY(X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      END SUBROUTINE R4_DSPLAY

      SUBROUTINE R8_DSPLAY(R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      END SUBROUTINE R8_DSPLAY
      END INTERFACE

      INTERFACE AGDSPL
      SUBROUTINE R4_AGDSPL(X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      END SUBROUTINE R4_AGDSPL

      SUBROUTINE R8_AGDSPL(R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      END SUBROUTINE R8_AGDSPL
      END INTERFACE

      INTERFACE AGMNMX
      SUBROUTINE R4_AGMNMX(ARRAY,AMIN,AMAX,NPTA,ITYPE)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: AMIN
      REAL(KIND=r4) :: AMAX
      INTEGER NPTA
      INTEGER ITYPE
      REAL(KIND=r4) :: ARRAY(:)
      END SUBROUTINE R4_AGMNMX

      SUBROUTINE R8_AGMNMX(
     > R8_ARRAY,R8_AMIN,R8_AMAX,NPTA,ITYPE)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_AMIN
      REAL(KIND=r8) :: R8_AMAX
      INTEGER NPTA
      INTEGER ITYPE
      REAL(KIND=r8) :: R8_ARRAY(:)
      END SUBROUTINE R8_AGMNMX
      END INTERFACE

      INTERFACE MNMX
      SUBROUTINE R4_MNMX(ARRAY,AMIN,AMAX)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: AMIN
      REAL(KIND=r4) :: AMAX
      REAL(KIND=r4) :: ARRAY(:)
      END SUBROUTINE R4_MNMX

      SUBROUTINE R8_MNMX(R8_ARRAY,R8_AMIN,R8_AMAX)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_AMIN
      REAL(KIND=r8) :: R8_AMAX
      REAL(KIND=r8) :: R8_ARRAY(:)
      END SUBROUTINE R8_MNMX

      END INTERFACE

      INTERFACE CPLOT
      SUBROUTINE R4_CPLOT(X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      END SUBROUTINE R4_CPLOT
      SUBROUTINE R8_CPLOT(R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      END SUBROUTINE R8_CPLOT
      END INTERFACE

      INTERFACE AGKEYS
      SUBROUTINE R4_AGKEYS(X,Y,IFASTX,IFASTY,LIMIT)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER IFASTX
      INTEGER IFASTY
      INTEGER LIMIT
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      END  SUBROUTINE R4_AGKEYS

      SUBROUTINE R8_AGKEYS(R8_X,R8_Y,IFASTX,IFASTY,LIMIT)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER IFASTX
      INTEGER IFASTY
      INTEGER LIMIT
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      END  SUBROUTINE R8_AGKEYS
      END INTERFACE

      INTERFACE BSYMS
      SUBROUTINE BSYMS(X,Y,ISYM)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      INTEGER ISYM
      END SUBROUTINE BSYMS
      SUBROUTINE R8_BSYMS(R8_X,R8_Y,ISYM)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      INTEGER ISYM
      END SUBROUTINE R8_BSYMS
      END INTERFACE 

      INTERFACE SYMOUT
      SUBROUTINE SYMOUT(ISYM,FACTR)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER ISYM
      REAL(KIND=r4) :: FACTR
      END SUBROUTINE SYMOUT
      SUBROUTINE R8_SYMOUT(ISYM,R8_FACTR)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER ISYM
      REAL(KIND=r8) :: R8_FACTR
      END SUBROUTINE R8_SYMOUT
      END INTERFACE 

      INTERFACE TEKSYM
      SUBROUTINE TEKSYM(
     > ISYM,AMULT)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER ISYM
      REAL(KIND=r4) :: AMULT
      END SUBROUTINE TEKSYM 
      SUBROUTINE R8_TEKSYM(
     > ISYM,R8_AMULT)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER ISYM
      REAL(KIND=r8) :: R8_AMULT
      END SUBROUTINE R8_TEKSYM 
      END INTERFACE  

!
!============================================================================
! sgext.F

      INTERFACE AGEYA
      SUBROUTINE R4_AGEYA(X,Y,E)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      REAL(KIND=r4) :: E(:)
      END SUBROUTINE R4_AGEYA

      SUBROUTINE R8_AGEYA(R8_X,R8_Y,R8_E)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      REAL(KIND=r8) :: R8_E(:)
      END SUBROUTINE R8_AGEYA
      END INTERFACE

      INTERFACE AGEXA
      SUBROUTINE R4_AGEXA(X,Y,E)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X(:)
      REAL(KIND=r4) :: Y(:)
      REAL(KIND=r4) :: E(:)
      END SUBROUTINE R4_AGEXA

      SUBROUTINE R8_AGEXA(R8_X,R8_Y,R8_E)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X(:)
      REAL(KIND=r8) :: R8_Y(:)
      REAL(KIND=r8) :: R8_E(:)
      END SUBROUTINE R8_AGEXA
      END INTERFACE

      INTERFACE AGEXS
      SUBROUTINE AGEXS(X,Y,E)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      REAL(KIND=r4) :: E
      END SUBROUTINE AGEXS
      SUBROUTINE R8_AGEXS(R8_X,R8_Y,R8_E)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      REAL(KIND=r8) :: R8_E
      END SUBROUTINE R8_AGEXS
      END INTERFACE

      INTERFACE AGEXSR
      SUBROUTINE AGEXSR(X,Y,ELO,EHI)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      REAL(KIND=r4) :: ELO
      REAL(KIND=r4) :: EHI
      END SUBROUTINE AGEXSR
      SUBROUTINE R8_AGEXSR(R8_X,R8_Y,R8_ELO, R8_EHI)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      REAL(KIND=r8) :: R8_ELO
      REAL(KIND=r8) :: R8_EHI
      END SUBROUTINE R8_AGEXSR
      END INTERFACE

      INTERFACE DLIMX
      SUBROUTINE DLIMX(XMIN,XMAX)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4), intent(in) :: XMIN
      REAL(KIND=r4), intent(in) :: XMAX
      END SUBROUTINE DLIMX

      SUBROUTINE R8_DLIMX(R8_XMIN,R8_XMAX)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8), intent(in) :: R8_XMIN
      REAL(KIND=r8), intent(in) :: R8_XMAX
      END SUBROUTINE R8_DLIMX
      END INTERFACE

      INTERFACE DLIMY
      SUBROUTINE DLIMY(XMIN,XMAX)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4), intent(in) :: XMIN
      REAL(KIND=r4), intent(in) :: XMAX
      END SUBROUTINE DLIMY

      SUBROUTINE R8_DLIMY(R8_XMIN,R8_XMAX)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8), intent(in) :: R8_XMIN
      REAL(KIND=r8), intent(in) :: R8_XMAX
      END SUBROUTINE R8_DLIMY
      END INTERFACE

      INTERFACE AGVCUR
      SUBROUTINE AGVCUR(UCH,X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      CHARACTER*1 UCH
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      END SUBROUTINE AGVCUR  
      SUBROUTINE R8_AGVCUR(UCH,R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      CHARACTER*1 UCH
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      END SUBROUTINE R8_AGVCUR  

      END INTERFACE
!=========================================================================
! sgtcs.f

      INTERFACE VCURSR
      SUBROUTINE VCURSR(ICHAR,X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER ICHAR
      REAL(KIND=r4) :: X 
      REAL(KIND=r4) :: Y
      END SUBROUTINE VCURSR
      SUBROUTINE R8_VCURSR(ICHAR,R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER ICHAR
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      END SUBROUTINE R8_VCURSR
      END INTERFACE

      INTERFACE MOVEA
      SUBROUTINE MOVEA(X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      END SUBROUTINE MOVEA
      SUBROUTINE R8_MOVEA(R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      END SUBROUTINE R8_MOVEA
      END INTERFACE

      INTERFACE MOVER
      SUBROUTINE MOVER(X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      END SUBROUTINE MOVER
      SUBROUTINE R8_MOVER(R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      END SUBROUTINE R8_MOVER
      END INTERFACE


      INTERFACE DRAWA
      SUBROUTINE DRAWA(X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      END SUBROUTINE DRAWA
      SUBROUTINE R8_DRAWA(R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      END SUBROUTINE R8_DRAWA
      END INTERFACE

      INTERFACE DRAWR
      SUBROUTINE DRAWR(DX,DY)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: DX
      REAL(KIND=r4) :: DY
      END SUBROUTINE DRAWR
      SUBROUTINE R8_DRAWR(R8_DX,R8_DY)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_DX
      REAL(KIND=r8) :: R8_DY
      END SUBROUTINE R8_DRAWR
      END INTERFACE



      INTERFACE POINTA
      SUBROUTINE POINTA(X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      END SUBROUTINE POINTA
      SUBROUTINE R8_POINTA(R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      END SUBROUTINE R8_POINTA
      END INTERFACE

      INTERFACE DASHA
      SUBROUTINE DASHA(X,Y,LDASH)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      INTEGER LDASH
      END SUBROUTINE DASHA
      SUBROUTINE R8_DASHA(R8_X,R8_Y,LDASH)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      INTEGER LDASH
      END SUBROUTINE R8_DASHA
      END INTERFACE

      INTERFACE WINCOT
      SUBROUTINE WINCOT(X,Y,IX,IY)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      INTEGER IX
      INTEGER IY
      END SUBROUTINE WINCOT
      SUBROUTINE R8_WINCOT(R8_X,R8_Y,IX,IY)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      INTEGER IX
      INTEGER IY
      END SUBROUTINE R8_WINCOT
      END INTERFACE


      INTERFACE REVCOT
      SUBROUTINE REVCOT(IX,IY,X,Y)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER IX
      INTEGER IY
      REAL(KIND=r4) :: X
      REAL(KIND=r4) :: Y
      END SUBROUTINE REVCOT
      SUBROUTINE R8_REVCOT(IX,IY,R8_X,R8_Y)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER IX
      INTEGER IY
      REAL(KIND=r8) :: R8_X
      REAL(KIND=r8) :: R8_Y
      END SUBROUTINE R8_REVCOT
      END INTERFACE


      INTERFACE SEEDW
      SUBROUTINE SEEDW(XMIN,XMAX,YMIN,YMAX)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: XMIN
      REAL(KIND=r4) :: XMAX
      REAL(KIND=r4) :: YMIN
      REAL(KIND=r4) :: YMAX
      END  SUBROUTINE SEEDW
      SUBROUTINE R8_SEEDW(R8_XMIN,R8_XMAX,R8_YMIN,R8_YMAX)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_XMIN
      REAL(KIND=r8) :: R8_XMAX
      REAL(KIND=r8) :: R8_YMIN
      REAL(KIND=r8) :: R8_YMAX
      END  SUBROUTINE R8_SEEDW
      END INTERFACE

!==========================================================================
! sgiso.f

      INTERFACE AGISOC
      SUBROUTINE AGISOC(
     > X,Y,Z,NXDIM,NX,NY,XU,YU,ZU,M)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER NXDIM
      INTEGER NX
      INTEGER NY
      CHARACTER*(*) XU
      CHARACTER*(*) YU
      CHARACTER*(*) ZU
      REAL(KIND=r4) ::  X(NXDIM)
      REAL(KIND=r4) ::  Y(NY)
      REAL(KIND=r4) ::  Z(NXDIM,NY)
      INTEGER M(2,NX,NY)
      END SUBROUTINE AGISOC
      SUBROUTINE R8_AGISOC(
     > R8_X,R8_Y,R8_Z,NXDIM,NX,NY,XU,YU,ZU,M)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER NXDIM
      INTEGER NX
      INTEGER NY
      CHARACTER*(*) XU
      CHARACTER*(*) YU
      CHARACTER*(*) ZU
      REAL(KIND=r8) ::  R8_X(NXDIM)
      REAL(KIND=r8) ::  R8_Y(NY)
      REAL(KIND=r8) ::  R8_Z(NXDIM,NY)
      INTEGER M(2,NX,NY)
      END SUBROUTINE R8_AGISOC
      END INTERFACE

      INTERFACE AGISOM
      SUBROUTINE AGISOM(
     > X,Y,Z,NXDIM,NX,NY,XU,YU,ZU)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      INTEGER NXDIM
      INTEGER NX
      INTEGER NY
      CHARACTER*(*) XU
      CHARACTER*(*) YU
      CHARACTER*(*) ZU
      REAL(KIND=r4) ::  X(NXDIM)
      REAL(KIND=r4) ::  Y(NY)
      REAL(KIND=r4) ::  Z(NXDIM,NY)
      END SUBROUTINE AGISOM  
      SUBROUTINE R8_AGISOM(
     > R8_X,R8_Y,R8_Z,NXDIM,NX,NY,XU,YU,ZU)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      INTEGER NXDIM
      INTEGER NX
      INTEGER NY
      CHARACTER*(*) XU
      CHARACTER*(*) YU
      CHARACTER*(*) ZU
      REAL(KIND=r8) ::  R8_X(NXDIM)
      REAL(KIND=r8) ::  R8_Y(NY)
      REAL(KIND=r8) ::  R8_Z(NXDIM,NY)
      END SUBROUTINE R8_AGISOM  
      END INTERFACE

      INTERFACE AGIDLX
      SUBROUTINE AGIDLX(XMIN,XMAX)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: XMIN
      REAL(KIND=r4) :: XMAX
      END SUBROUTINE AGIDLX
      SUBROUTINE R8_AGIDLX(R8_XMIN,R8_XMAX)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_XMIN
      REAL(KIND=r8) :: R8_XMAX
      END SUBROUTINE R8_AGIDLX
      END INTERFACE
      INTERFACE AGIDLZ
      SUBROUTINE AGIDLZ(ZMIN,ZMAX)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: ZMIN
      REAL(KIND=r4) :: ZMAX
      END SUBROUTINE AGIDLZ
      SUBROUTINE R8_AGIDLZ(R8_ZMIN,R8_ZMAX)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_ZMIN
      REAL(KIND=r8) :: R8_ZMAX
      END SUBROUTINE R8_AGIDLZ
      END INTERFACE
      INTERFACE AGIDLY
      SUBROUTINE AGIDLY(YMIN,YMAX)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) :: YMIN
      REAL(KIND=r4) :: YMAX
      END SUBROUTINE AGIDLY
      SUBROUTINE R8_AGIDLY(R8_YMIN,R8_YMAX)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) :: R8_YMIN
      REAL(KIND=r8) :: R8_YMAX
      END SUBROUTINE R8_AGIDLY
      END INTERFACE

      INTERFACE AGICAU
      SUBROUTINE AGICAU(
     > XXCOOR,YYCOOR,ZZCOOR,IXS,IZS)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      REAL(KIND=r4) ::  XXCOOR
      REAL(KIND=r4) ::  YYCOOR
      REAL(KIND=r4) ::  ZZCOOR
      INTEGER IXS
      INTEGER IZS
      END SUBROUTINE AGICAU
      SUBROUTINE R8_AGICAU(
     > R8_XXCOOR,R8_YYCOOR,R8_ZZCOOR,IXS,IZS)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      REAL(KIND=r8) ::  R8_XXCOOR
      REAL(KIND=r8) ::  R8_YYCOOR
      REAL(KIND=r8) ::  R8_ZZCOOR
      INTEGER IXS
      INTEGER IZS
      END SUBROUTINE R8_AGICAU
      END INTERFACE

      INTERFACE AGCLGEN
      SUBROUTINE AGCLGEN(
     > Z,MXD,NX,NY,CCLO,CHI,CINC,CL,NCL,ICNST)
      integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
      integer   nlm
      parameter (nlm=40)
      INTEGER MXD
      INTEGER NX
      INTEGER NY
      REAL(KIND=r4) ::  CCLO
      REAL(KIND=r4) ::  CHI
      REAL(KIND=r4) ::  CINC
      INTEGER NCL
      INTEGER ICNST
      REAL(KIND=r4) ::  Z(MXD,NY)
      REAL(KIND=r4) ::  CL(NLM)
      END SUBROUTINE AGCLGEN  
      SUBROUTINE R8_AGCLGEN(
     > R8_Z,MXD,NX,NY,R8_CCLO,R8_CHI,R8_CINC,R8_CL,NCL,ICNST)
      integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)
      integer   nlm
      parameter (nlm=40)
      INTEGER MXD
      INTEGER NX
      INTEGER NY
      REAL(KIND=r8) ::  R8_CCLO
      REAL(KIND=r8) ::  R8_CHI
      REAL(KIND=r8) ::  R8_CINC
      INTEGER NCL
      INTEGER ICNST
      REAL(KIND=r8) ::  R8_Z(MXD,NY)
      REAL(KIND=r8) ::  R8_CL(NLM)
      END SUBROUTINE R8_AGCLGEN  
      END INTERFACE


      END MODULE sglib_mod

C******************** START FILE GRFMBC.FOR ; GROUP GRFLBL ******************
C--------------------------------------------------------------------
C  GRFMBC
C  REPLACE TABS AND NULLS AND "$" WITH BLANKS IN THE PASSED STRING
C
      SUBROUTINE GRFMBC(STR)
      implicit none
C
      CHARACTER*(*) STR
C
      CHARACTER*1 NULL,TAB
      integer     il, i
C
      TAB=CHAR(9)
      NULL=CHAR(0)
C
      IL=LEN(STR)
      DO 10 I=1,IL
        IF(STR(I:I).EQ.NULL) THEN
          STR(I:I)=' '
        ELSE IF(STR(I:I).EQ.TAB) THEN
          STR(I:I)=' '
        ELSE IF(STR(I:I).EQ.'$') THEN
          STR(I:I)=' '
        ENDIF
 10   CONTINUE
C
      RETURN
      END
C******************** END FILE GRFMBC.FOR ; GROUP GRFLBL ******************

subroutine r8_coulog(et,at,zt,denb,tempb,ab,zb,cln,nb,Bmag,llstix)
  !
  ! (see the warning below.)
  !
  ! calculates the coulomb logarithm for a test particle of energy et
  ! (kev), atomic mass at and atomic charge zt, colliding with NB
  ! maxwellian background species with densities denb (/m**3),
  ! temperatures tempb (keV), atomic masses ab, atomic charges zb.  The
  ! electrons should be included as one of the background species, with
  ! Z=-1 and A=(1./1836.1).  The list of coulomb logarithms is returned
  ! in cln.  The magnetic field should be input as bmag (Tesla).
  !
  ! Note that the test particle loglambda's produced by this subroutine
  ! are not symmetric, i.e. it is not true that
  ! loglam_alpha_beta=loglam_beta_alpha.  If such symmetry is desired,
  ! one should set Et=(3/2)T_t and call this routine twice with species
  ! alpha and beta switched, and take the average value of log_lambda
  ! which is returned.
  !
  ! Written by Greg Hammett, 16-May-1989.
  !
  ! The exact details of the coulomb logarithm are probably not worth
  ! worrying about too much.  The recipe I use here is similiar to the
  ! one given in the NRL plasma formulary.  So it includes the quantum
  ! mechanics correction which is usually important for collisions with
  ! electrons.  Rather than completely ignoring the Debye shielding by
  ! particles with vthermal < v, it contains a smooth transition which I
  ! have rigorously shown from the Balescu-Lenard operator is correct in
  ! the limits vthermal>>v and vthermal<<v.  However, the Balescu-Lenard
  ! operator predicts a substantial amount of Cerenkov radiation of
  ! plasma waves if the particle speed exceeds the electron thermal
  ! speed.  I am ignoring this Cerenkov radiation (and its associated
  ! drag).  To look at it properly, Nat Fisch claims that one would have
  ! to consider the reabsorption of the Cerenkov radiation as well.
  !
  ! Warning:  GWH 3/1/91:  the formulas I am using here provide very
  ! little Debye shielding if the test particles are much faster than the
  ! thermal electrons.  In that case, one would need to worry about whether or
  ! not this is correct.  There appear to be fundamental problems with
  ! the Balescu-Lenard operator.
  !
  ! The main references for this stuff are D.V. Sivukhin, Reviews of
  ! Plasma Physics, VOl. 4 (1966) (especially good on quantum corrections,
  ! physical insight), Trubnikov, Reviews of Plasma Physics, Vol. 1
  ! (1963) (simple, complete derivation of Fokker-Planck equation,
  ! complete with justification for the Coulomb Logarithm in terms of
  ! deriving the collision operator from the dielectric response of the
  ! plasma), Rob Goldston's Ph.D. thesis (references on strong magnetic
  ! field corrections, collisions with multi-electron impurities),
  ! Krommes' class notes on the derivation of the Landau operator from the
  ! Balescu-Lenard operator, and my notes on Krommes' notes relating to
  ! the problem when the test particle is much faster than the thermal
  ! electron velocity.
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, two
  implicit none
  real(fp), parameter :: C1000 = 1000.0d0
  !
  integer :: nb,i
  !============
  real(fp) :: sum,omega2,vrel2,rmax,rmincl,rminqu,rmin
  !============
  real(fp) :: et,at,zt,Bmag
  real(fp), dimension(nb) :: denb,tempb,ab,zb,cln

  logical :: llstix       ! tbt 7/10/95

  !
  ! first calculate the maximum impact parameter, rmax:
  !
  ! rmax=( sum_over_species omega2/vrel2 )**(-1/2)
  !
  ! where,
  ! omega2 = omega_p**2 + omega_c**2
  ! vrel2=T/m+2.*E_t/m_t
  !
  sum=ZERO
  do i=1,nb
    omega2=1.74d0*zb(i)**2/ab(i)*denb(i) &
         +9.18d15*zb(i)**2/ab(i)**2*Bmag**2
    vrel2=9.58d10*(tempb(i)/ab(i) + TWO*et/at)
    sum=sum+omega2/vrel2
  end do
  rmax=sqrt(ONE/sum)

  ! next calculate rmin, including quantum corrections.  The classical
  ! rmin is:
  !
  ! rmincl = e_alpha e_beta / (m_ab vrel**2)
  !
  ! where m_ab = m_a m_b / (m_a+m_b) is the reduced mass.
  ! vrel**2 = 3 T_b/m_b + 2 E_a / m_a
  ! (Note:  the two different definitions of vrel2 used in this code
  ! are each correct for their application.)
  !
  ! The quantum rmin is:
  !
  ! rminqu = hbar/( 2 exp(0.5) m_ab vrel)
  !
  ! and the proper rmin is the larger of rmincl and rminqu
  !
  do i=1,nb
    vrel2=9.58d10*(3*tempb(i)/ab(i)+2*et/at)
    rmincl=0.13793d0*abs(zb(i)*zt)*(ab(i)+at)/ab(i)/at/vrel2
    rminqu=1.9121d-8*(ab(i)+at)/ab(i)/at/sqrt(vrel2)
    rmin=max(rmincl,rminqu)
    cln(i)=log(rmax/rmin)
    if(cln(i) .lt. ONE) then
      write(6,*) 'warning from COULOG: coulomb logarithms < 1!'
      cln(i)=ONE
    end if
  end do

  ! debug section:  set all log(lambda)'s to a simple formula for
  ! log(lambda_e) to benchmark with Stix's solutions:

  if(llstix) then
    do i=1,nb
      cln(i)=24.0d0-log(sqrt(denb(1)/1.d6)/(tempb(1)*C1000))
    end do
  end if

  return
end subroutine r8_coulog

c  file: sgsys.for      system level routines for sglib
c
c
c  mar-93	split off from sgiof.for.  [met]
c
c-----------------------------------------------------------------/tsend
	subroutine tsend
c  dump disk and terminal buffers
c
	implicit none
c
	include 'sgiof_inc'	!sg_flag, sg_buff
	include 'sgvgds_inc'	!iovgds,xpndsk
c
	character*(*) dsknam
	character*(*) msg
	logical ltrap
c
	include '($ssdef)'
	include '($fabdef)'
	include '($namdef)'
	record /fabdef/ ofab
	record /namdef/ onam
c
	include '($fibdef)'
	include '($iodef)'
	include 'sgfat_inc'
	record /fibdef/ ofib
	record /fatdef/ ofat	!file attributes block
	integer ofibd(2)	!descriptor for ofib
	structure /atrdef/
	  integer*2 atr$w_size		!  size of attribute in bytes
	  integer*2 atr$w_type		!  attribute type code
	  integer*4 atr$l_addr		!  address of attribute text
	  integer*4 end
	endstructure
	record /atrdef/ attb
	integer*2 iosbd(4),iosbt(4),iosbx(4)
	integer kdemp(2)		!size of empty file
c
cx	include '($ttdef)'
cx	include '($tt2def)'
	integer tt$m_mbxdsabl /'00010000'X/
	integer tt$m_nobrdcst /'00020000'X/
	integer tt2$m_brdcstmbx /'00000010'X/
cx	integer ss$_devactive /'02c4'X/
c
	character*64 trmnam,auxnam
	character*64 fibnam /' '/
	integer kxqef /0/
	integer ttset(3)	!tty characteristics during plotting
	integer ttsens(3)	!tty characteristics when assigned
	logical both
	logical usembx /.true./

	integer  maxmsg, maxbuf, kdblk, ioflag
	integer  igood, kdgot, kff, kdb
	integer  maxds, kdput, lvnam, llnam, lmsg, ii, ld
	integer  kdalc, kdpup, lsnam, ltnam
	integer  lib$get_ef, iag_trim
	integer  lib$asn_wth_mbx
        integer  lib$spawn

	parameter (maxmsg=20+120)	!max mailbox msg (20 bytes overhead)
	parameter (maxbuf=maxmsg*10)	!system dynamic memory for mbx msgs
	byte mbox(maxmsg)
	character*4 bsiz		!logical for buffer size
c
	integer i, spawn_sts
	character*200 command
c
	integer sys$parse
	integer sys$assign
	integer sys$qiow,sys$qio,sys$synch
c
	integer*4 msgvec(4)
     >	  /2,0,0,0/
c
	both = .true.
	go to 100
c
c---------------------------------------------------------------/tsend_disk
c
	entry tsend_disk
c
	both = .false.
 100	continue
	if(outdsk.gt.0 .and. kdptr.ne.0) then
c					!disk output
	  if((kdblk+maxds-1).gt.kdalc) then
	    ofib.fib$w_exctl = fib$m_extend .or. fib$m_alconb
	    ofib.fib$l_exsz = maxds
	    ofib.fib$l_exvbn = 0
c				!extend the file
	    ioflag = io$_modify
	    igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
     >		ofibd,,,,,)
c
	    if(igood) igood = iosbd(1)
	    if(.not.igood) then
	      msgvec(2)=igood
	      call sys$putmsg(msgvec,,,)
	    endif
c
	    kdgot = iosbd(3)
	    kdalc = kdalc + kdgot
c				!erase allocated blocks
	    ioflag = io$_writevblk .or. io$m_erase
	    igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
     >		0,%val(kdgot*512),%val(ofib.fib$l_exvbn),,,)
	    if(igood) igood = iosbd(1)
	    if(.not.igood) then
	      msgvec(2)=igood
	      call sys$putmsg(msgvec,,,)
	    endif
c
	  endif
c
	  kdpup=kdptr		!round up to even num of bytes
	  if(kdpup.and.1) then
	    kdpup=kdpup+1
	    dbuff(kdpup)=0
	  endif
c				!write this buffer
	  ioflag = io$_writevblk
	  igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
     >	    dbuff,%val(kdpup),%val(kdblk),,attb,)
c
	  if(igood) igood = iosbd(1)
	  if(.not.igood) then
	    msgvec(2)=igood
	    call sys$putmsg(msgvec,,,)
	  endif
c
	  ofib.fib$w_exctl = 0
	  kff=kdptr+1
	  if(kdptr.eq.maxdb) then
	    kdptr=0
	    kff=0
	    kdblk=kdblk+maxds
	  endif
	  kdb=kdblk
	  do while(kff.ge.512)
	    kff=kff-512
	    kdb=kdb+1
	  enddo
c
	  ofat.fat$w_efblkl = kdb
	  ofat.fat$w_ffbyte = kff
c				!modify file attributes
	  ioflag = io$_modify
	  igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
     >		ofibd,,,,attb,)
c
	  if(igood) igood = iosbd(1)
	  if(.not.igood) then
	    msgvec(2)=igood
	    call sys$putmsg(msgvec,,,)
	  endif
c
	endif
c
	if(.not.both) return
	go to 200
c
c---------------------------------------------------------------/tsend_term
c
	entry tsend_term
c
	both = .false.
 200	continue
	if(outtrm.eq.1 .and. ktptr.ne.0) then
c					!terminal output
	  ioflag = io$_writevblk .or. io$m_noformat
	  igood = sys$qiow(,%val(ktqio),%val(ioflag),iosbt,,,
     >	    tbuff,%val(ktptr),,,,)
c
	  if(igood) igood = iosbt(1)
	  if(.not.igood) then
	    msgvec(2)=igood
	    call sys$putmsg(msgvec,,,)
	  endif
	endif
c
	if(outaux.eq.1 .and. ktptr.ne.0) then
c					!aux term output
	  if(kxqef.ne.0) then
	    igood = sys$synch(%val(kxqef),iosbx)
	    if(igood) igood = iosbx(1)
	    if(.not.igood) then
	      msgvec(2)=igood
	      call sys$putmsg(msgvec,,,)
	    endif
	  else
	    igood = lib$get_ef(kxqef)
	    if(.not.igood) call lib$stop(%val(igood))
	  endif
c
	  ioflag = io$_writevblk .or. io$m_noformat
	  igood = sys$qio(%val(kxqef),%val(kxqio),%val(ioflag),iosbx,,,
     >	    tbuff,%val(ktptr),,,,)
c
cx	  if(igood) igood = iosbx(1)
	  if(.not.igood) then
	    msgvec(2)=igood
	    call sys$putmsg(msgvec,,,)
	  endif
	endif
c
	ktptr=0
	return
c
c---------------------------------------------------------------/tback_disk
c
	entry tback_disk
c
	kdblk = kdsav(1)
	kdptr = kdsav(2)
	if(outdsk.le.0) return
c
	if(kdptr.ne.0) then
	  ioflag = io$_readvblk
	  igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
     >	    dbuff,%val(maxdb),%val(kdblk),,,)
c
	  if(igood) igood = iosbd(1)
	  if(.not.igood) then
	    msgvec(2)=igood
	    call sys$putmsg(msgvec,,,)
	  endif
	endif
c
	ofib.fib$w_exctl = fib$m_trunc
	ofib.fib$l_exsz = 0
	ofib.fib$l_exvbn = kdblk + 1
c
 320	kff = kdptr
	kdb=kdblk
	do while(kff.ge.512)
	  kff=kff-512
	  kdb=kdb+1
	enddo
	if(kff.ne.0) kff = kff+1
c
	ofat.fat$w_efblkl = kdb
	ofat.fat$w_ffbyte = kff
	ioflag = io$_modify
	igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
     >		ofibd,,,,attb,)
c
	if(igood) igood = iosbd(1)
	if(.not.igood) then
	  msgvec(2)=igood
cx	  call sys$putmsg(msgvec,,,)	!ignore eof error
	endif
c
	kdalc = kdalc - ofib.fib$l_exsz
	return
c
c---------------------------------------------------------------/tkeep_disk
c
	entry tkeep_disk
c
	kdsav(1) = kdblk	!update start of frame addr
	kdsav(2) = kdptr
	ofib.fib$w_exctl = 0
	ofib.fib$l_exsz = 0
cx	go to 320
	return
c
c---------------------------------------------------------------/tback_term
c
	entry tback_term
c
	ktptr = 0
	return
c
c---------------------------------------------------------------/tname_disk
c
	entry tname_disk(dsknam)
c
	ofab.fab$b_bid = fab$c_bid
	ofab.fab$b_bln = fab$c_bln
	ofab.fab$l_fna = %loc(dsknam)
	ofab.fab$b_fns = iag_trim(dsknam)
	ofab.fab$w_ifi = 0
	ofab.fab$l_nam = %loc(onam)
c
	onam.nam$b_bid = nam$c_bid
	onam.nam$b_bln = nam$c_bln
	onam.nam$l_esa = %loc(xpndsk)
	onam.nam$b_ess = len(xpndsk)
	onam.nam$b_nop = nam$v_synchk
c
	igood = sys$parse(ofab)
	if(.not.igood) go to 9000
	return
c
c---------------------------------------------------------------/tname_term
c
	entry tname_term(dsknam)
c
	trmnam = dsknam
	return
c
c---------------------------------------------------------------/tname_auxl
c
	entry tname_auxl(dsknam)
c
	auxnam = dsknam
	return
c
c---------------------------------------------------------------/topen_disk
c
	entry topen_disk
c
	lvnam = ichar(onam.nam$t_dvi(1:1))	!length of device id
	igood = sys$assign(onam.nam$t_dvi(2:lvnam+1),kdqio,,)
	if(.not.igood) go to 9000
c
		!deny writes to others
	ofib.fib$l_acctl = fib$m_write .or. fib$m_nowrite
	ofib.fib$w_exctl = 0
	ofib.fib$w_nmctl = fib$m_newver
	ofib.fib$w_did(1) = onam.nam$w_did(1)
	ofib.fib$w_did(2) = onam.nam$w_did(2)
	ofib.fib$w_did(3) = onam.nam$w_did(3)
	ofib.fib$w_fid(1) = 0
	ofib.fib$w_fid(2) = 0
	ofib.fib$w_fid(3) = 0
c
	ofibd(1) = fib$k_length
	ofibd(2) = %loc(ofib)
	attb.atr$w_type = 4	!atr$c_recattr
	attb.atr$w_size = 32
	attb.atr$l_addr = %loc(ofat)
	attb.end = 0
c
	ofat.fat$b_rtype = fat$c_fixed + fat$c_sequential
	ofat.fat$w_rsize = 512
	ofat.fat$w_maxrec = 512
	ofat.fat$w_efblkl = 0
	ofat.fat$w_ffbyte = 0
c
	llnam = onam.nam$b_name + onam.nam$b_type
	lsnam = onam.nam$b_dev  + onam.nam$b_dir + 1
	fibnam = xpndsk(lsnam:)
	ioflag = io$_create .or. io$m_access .or. io$m_create
c			,chan,func,iosbd,,,
	igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
c		p1=fib,p2=file,p3=result length,p4=result string
     >		ofibd,fibnam(1:llnam),,xpndsk(lsnam:),attb,)
	if(igood) igood = iosbd(1)
	if(.not.igood) go to 9000
c
	ofib.fib$w_did(1) = 0	!inhibit lookup subfnc for modify
	ofib.fib$w_did(2) = 0
	ofib.fib$w_did(3) = 0
	ofib.fib$l_acctl = fib$m_writethru
c
	lxnam = index(xpndsk,char(0)) -1
	kdblk=1
	kdptr=0
	kdalc=0
	kdsav(1) = 1		!output file block
	kdsav(2) = 0		!word in file
	kdemp(1) = 0
	kdemp(2) = 0
c
c	if(dbufa.eq.0) then
c	  call usr_trnlog(' ','SG_DISK_BLOKS',bsiz,lb,igood)
c	  if(.not.igood) bsiz=' '
c	  read(bsiz,'(bn,i)',iostat=ios) maxds
c	  if(maxds.le.0) maxds = 30	!default is 30 blocks
	  if(maxds.le.0) maxds = 1	!default is 1 block
	  maxdb = maxds*512		!size in bytes
c	  igood = lib$get_vm(maxdb,dbufa)
c	  if(.not.igood) call lib$signal(%val(igood))
c	endif
	outdsk = 1		!flag file as open
c
cx	call toutpt('37'o)	!first file char for versatec
	return
c
c---------------------------------------------------------------/tmark_disk
c
	entry tmark_disk
c
	if(kdemp(1).eq.0) then
	  kdemp(1) = kdblk
	  kdemp(2) = kdptr
	endif
	return
c
c---------------------------------------------------------------/topen_term
c
	entry topen_term
c
	ltnam = iag_trim(trmnam)
	if(usembx) then
	  igood = lib$asn_wth_mbx(trmnam(1:ltnam),maxmsg,maxbuf,ktqio,
     >		ktmbx)
	endif
	if(.not.usembx .or. igood.eq.ss$_devactive) then
	  call sys$dassgn(%val(ktmbx))
	  ktmbx = 0
	  igood = sys$assign(trmnam(1:ltnam),ktqio,,)
	endif
	if(.not.igood) then
	  msgvec(2) = igood
	  call sys$putmsg(msgvec,,,)
	  type *, 'INITT/RINITT: cant open '//trmnam(:ltnam)
	  call exit(msgvec(2))
	endif
c
c
	if(ktmbx.ne.0) then
	  igood = sys$qio(,%val(ktqio),%val(io$_sensemode),,,,
     >		ttsens,%val(12),,,,)	!12 bytes = 3 longwords
	  if(.not.igood .or. (ttsens(2).and.tt$m_nobrdcst).ne.0) then
	    call sys$dassgn(%val(ktmbx))
	    ktmbx = 0
	    ttset(1) = 0
	  else
	    ttset(1) = ttsens(1)
	    ttset(2) = ttsens(2).or.tt$m_mbxdsabl.or.tt$m_nobrdcst
	    ttset(3) = ttsens(3).or.tt2$m_brdcstmbx
	  endif
	endif
c
	if(ktmbx.ne.0) then
	  igood = sys$qio(,%val(ktqio),%val(io$_setmode),,,,
     >		ttset,%val(12),,,,)
	endif
c
c	if(tbufa.eq.0) then
c	  call usr_trnlog(' ','SG_TERM_BYTES',bsiz,lb,igood)
c	  if(.not.igood) bsiz=' '
c	  read(bsiz,'(bn,i)',iostat=ios) maxtb
c	  if(maxtb.le.0) maxtb = 512	!default is 512 bytes
c	  maxtb = min(maxtb,512)	!don't allow bigger
c	  igood = lib$get_vm(maxtb,tbufa)
c	  if(.not.igood) call lib$signal(%val(igood))
c	endif
	outtrm = 1
	return
c
c---------------------------------------------------------------/topen_auxl
c
	entry topen_auxl
c
	ltnam = iag_trim(auxnam)
	igood = sys$assign(auxnam(1:ltnam),kxqio,,)
	if(.not.igood) then
	  msgvec(2) = igood
	  call sys$putmsg(msgvec,,,)
	  type *, 'INITT/RINITT: cant open '//auxnam(:ltnam)
	  call exit(msgvec(2))
	endif
c
c	if(tbufa.eq.0) then
c	  call usr_trnlog(' ','SG_TERM_BYTES',bsiz,lb,igood)
c	  if(.not.igood) bsiz=' '
c	  read(bsiz,'(bn,i)',iostat=ios) maxtb
c	  if(maxtb.le.0) maxtb = 512	!default is 512 bytes
c	  maxtb = min(maxtb,512)	!don't allow bigger
	maxtb = 512 !default is 512 bytes
c	  igood = lib$get_vm(maxtb,tbufa)
c	  if(.not.igood) call lib$signal(%val(igood))
c	endif
	outaux = 1
	return
c
c---------------------------------------------------------------/tclos_disk
c
	entry tclos_disk
c
	if(outdsk.le.0) return
	kff = kdptr
	kdb=kdblk
	do while(kff.ge.512)
	  kff=kff-512
	  kdb=kdb+1
	enddo
	if(kff.ne.0) kff = kff+1
c
	ofib.fib$w_exctl = 0
	ofat.fat$w_efblkl = kdb
	ofat.fat$w_ffbyte = kff
c				!close the file
	ioflag = io$_deaccess
	igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
     >		ofibd,,,,attb,)
c				!if empty, delete it
	if(kdemp(1).eq.0) then
	  kdemp(1) = 1
	  kdemp(2) = 12
	endif
	if(kdblk.le.kdemp(1) .and. kdptr.le.kdemp(2)) then
	  ofib.fib$w_did(1) = onam.nam$w_did(1)	!delete dir entry
	  ofib.fib$w_did(2) = onam.nam$w_did(2)
	  ofib.fib$w_did(3) = onam.nam$w_did(3)
	  ioflag = io$_delete .or. io$m_delete
	  igood = sys$qiow(,%val(kdqio),%val(ioflag),iosbd,,,
     >		ofibd,xpndsk(lsnam:lxnam),,,,)
	  if(igood) igood = iosbd(1)
	  if(igood) lxnam = 0
	endif
c
	i=index(xpndsk,'.PLT')-1
	command = '@SOURCEROOT:[XTCTEK]TEK2PS_DCL.COM '//xpndsk(1:i)
        if (outps .eq. 1) then
	    igood = lib$spawn(command,,,,,,spawn_sts,,,,,)
	    if(igood .ne. SS$_NORMAL) then
		call lib$signal(%val(igood))
	    endif
	    if(spawn_sts .ne. SS$_NORMAL) then
		call lib$signal(%val(spawn_sts))
	    endif
	endif
	call sys$dassgn(%val(kdqio))
	outdsk = -1		!need to re-open
c
	return
c
c---------------------------------------------------------------/tclos_term
c
	entry tclos_term
c
	if(ktmbx.ne.0) then	!restore terminal characteristics
	  igood = sys$qio(,%val(ktqio),%val(io$_setmode),,,,
     >		ttsens,%val(12),,,,)
	  call sys$dassgn(%val(ktmbx))
	  ktmbx = 0
	endif
c
	if(outtrm.eq.1) then
	  call sys$dassgn(%val(ktqio))
	  outtrm = -1		!need to reopen
	endif
c
	if(outaux.eq.1) then
	  if(kxqef.ne.0) then
	    igood = sys$synch(%val(kxqef),iosbx)
	    call lib$free_ef(kxqef)
	    kxqef = 0
	  endif
	  call sys$dassgn(%val(kxqio))
	  outaux = -1		!need to reopen
	endif
	return
c
c-----------------------------------------------------------------/agtrap
c
	entry agtrap(ltrap)
c
c  enable/disable broadcast message trapping
c
	usembx = ltrap
	return
c
c-----------------------------------------------------------------/agtgbm
c
	entry agtgbm(msg,lmsg)
c  get broadcast messages held by system during broadcast trapping
c
	lmsg = 0
	if(ktmbx.eq.0) return	!no mailbox
c
	ioflag = io$_readvblk .or. io$m_now
	igood = sys$qiow(,%val(ktmbx),%val(ioflag),iosbt,,,
     >		mbox,%val(maxmsg),,,,)
	if(igood) igood = iosbt(1)
	if(igood) then
	  lmsg = mbox(21)	!actually 21:22
	  lmsg = min(len(msg),lmsg)
	  do ii=1,lmsg		!copy bytes 23:(22+lmsg)
	    msg(ii:ii) = char(mbox(22+ii))
	  enddo
	endif
	return
c				errors
 9000	continue
	msgvec(2) = igood
	call sys$putmsg(msgvec,,,)
	ld = iag_trim(dsknam)
	type *, 'INITT/RINITT: cant open disk file '//dsknam(:ld)
	call exit(igood)
c
	end
c
c-----------------------------------------------------------------/tinput
	subroutine tinput(inch)
c
	implicit none
	integer inch
	logical lspurg
c
	include 'sgiof_inc'	!sg_flag, sg_buff
	include 'sgvgds_inc'	!user (xtc)
c
	integer sys$assign,sys$qiow
	include '($iodef)'
	integer ss$_normal /'0001'X/
	integer ss$_partescape /'01fc'X/
	integer ss$_endoffile /'0870'X/
	character trmnam*64
	character xtcgin*64
c
	integer*4 sys$open,sys$connect,sys$get
	integer*2 iosb(4)
	byte tbufi(4)	!allow for 4 char escape sequence
	logical lpurg /.true./
c
	integer igood, iag_trim, ltnam, lsnam, lnam, ix, ierr, mbxout
	integer i, kqii, mbxin, ioflag, ionow
c
	include '($fabdef)'
	include '($rabdef)'
	record /fabdef/ ifab
	record /rabdef/ irab
c
	integer*4 msgvec(4)
     >	  /2,0,0,0/
	integer rms$_eof /'1827a'x/
c
c					!dump tty buffer if any
	if((outtrm.or.outaux).eq.1) call tsend_term
c
	if(inflg.eq.0) then		!first time thru
c				!determine input device
	  call usr_trnlog(' ','TERMINAL_INPUT',trmnam,lnam,igood)
	  if(trmnam.eq.'NONE') then
	    inflg = 3			!no input
	    go to 200
	  endif
	  if(trmnam.eq.' ' .and. xpntrm(1:3).eq.'MBA') then
	    	!try XTC V3 name first
	    call usr_trnlog(' ','XTC_GIN_'//user,trmnam,lnam,igood)
	    if(igood) go to 120
	    ix=index(xpntrm,':')-1
	    read(xpntrm(4:ix),'(i)',iostat=ierr) mbxout
	    do i=0,4
	      xtcgin='XTC_GIN_'//char(i+ichar('0'))//'_'//user
	      call usr_trnlog(' ',xtcgin,trmnam,lnam,igood)
	      if(igood) then
		ix=index(trmnam,':')-1
		read(trmnam(4:ix),'(i)',iostat=ierr) mbxin
		if(mbxin.gt.mbxout .and. mbxin.le.mbxout+2) go to 120
	      endif
	    enddo
	  endif
 120	  continue
	  if(trmnam.eq.' ') then	!translate sys$command
	    call usr_trnlog(' ','SYS$COMMAND',trmnam,lnam,igood)
	  endif
c				check device type
	  call usr$getdvi(trmnam(1:lnam),inflg,igood)
	  if(inflg.eq.0) then
	    inflg = 3
	    go to 200
	  endif
	  if(trmnam(1:3).eq.'MBA') inflg=5
cx  ignore disk name from def/user sys$command sys$input in a com file
cx	  if(inflg.eq.1 .and. index(trmnam(1:lnam),'[').eq.0) inflg=3
c
c				!open the input device
	  if(inflg.eq.1) then
c				device is a disk
	    ifab.fab$b_bid = fab$c_bid
	    ifab.fab$b_bln = fab$c_bln
	    ifab.fab$b_fac = 2**fab$v_get
	    ifab.fab$l_fna = %loc(trmnam)
	    ifab.fab$b_fns = lnam
	    ifab.fab$l_fop = 2**fab$v_sqo
c
	    igood = sys$open(ifab)
	    if(.not.igood) go to 9000
c
	    irab.rab$b_bid = rab$c_bid
	    irab.rab$b_bln = rab$c_bln
	    irab.rab$l_fab = %loc(ifab)
	    irab.rab$b_rac = rab$c_seq
	    irab.rab$l_rop = 2**rab$v_nlk .or. 2**rab$v_tpt
c
	    igood = sys$connect(irab)
	    if(.not.igood) go to 9000
c
	  elseif(inflg.eq.2 .or. inflg.eq.5) then
c				device is a terminal or mailbox
	    igood = sys$assign(trmnam(1:lnam),kqii,,)
	    if(.not.igood) go to 9000
c
	  endif
c
	endif
c
200	continue		!get input character
	if(inflg.eq.1) then
c
	  irab.rab$l_ubf = %loc(tbufi)
	  irab.rab$w_usz = 1
c
	  igood = sys$get(irab)
	  if(igood.eq.rms$_eof) then
	    tbufi(1)=ichar(' ')
	    igood = ss$_normal
	  endif
c
	elseif(inflg.eq.2) then
c
		!io$m_escape permits escape sequence from VersaTerm enter
	  ioflag = io$_readvblk .or. io$m_nofiltr .or. io$m_noecho
     >		.or. io$m_escape
	  if(lpurg) ioflag = ioflag .or. io$m_purge
	  igood = sys$qiow(,%val(kqii),%val(ioflag),iosb,,,
     >	    tbufi,%val(1),,,,)
	  if(igood) igood=iosb(1)
	  if(igood.eq.ss$_partescape) igood = ss$_normal
c
	elseif(inflg.eq.5) then		!XTC mailbox
c
	  ioflag = io$_readvblk .or. io$m_nofiltr
	  if(lpurg) then
	    ionow = ioflag .or. io$m_now
cx	    iosb(1) = ss$_normal
	    do while (iosb(1).ne.ss$_endoffile)	!iosb(1).eq.ss$_normal
	      igood = sys$qiow(,%val(kqii),%val(ionow),iosb,,,
     >		tbufi,%val(1),,,,)
	    enddo
	  endif
	  igood = sys$qiow(,%val(kqii),%val(ioflag),iosb,,,
     >	    tbufi,%val(1),,,,)
	  if(igood) igood=iosb(1)
c
	else	!inflg.eq.3
c
	  tbufi(1) = 13		!cr
	  igood = ss$_normal
	endif
	if(.not.igood) then
	  msgvec(2)=igood
	  call sys$putmsg(msgvec,,,)
	  tbufi(1) = 0
	endif
	lpurg = .true.
c
	inch = tbufi(1)
	return
c
c-----------------------------------------------------------------/agtpurg
	entry agtpurg(lspurg)
c
	lpurg = lspurg
	return
c
 9000	continue
	call agsalf
	msgvec(2)=igood
	call sys$putmsg(msgvec,,,)
	lnam = iag_trim(trmnam)
	type *, 'TINPUT: cant open input device '//trmnam(1:lnam)
	call exit(igood)
	end
c
c-----------------------------------------------------------------/iowait
	subroutine iowait(itenth)
c
	implicit none
c  arguments:
c	itenth - integer duration in tenths of seconds
c
	include 'sgtcs_inc'	!model
	include 'sgiof_inc'	!sg_flag, sg_buff
c
	integer itenth, igood, istat, ltabl
	integer sys$setef,sys$setimr,sys$wfland
	integer deltat(2) /-1,-1/
c
	integer timflg
	parameter (timflg=1)
	integer wflmsk
	parameter (wflmsk=2**1)
c
	integer*4 msgvec(4)
     >	  /2,0,0,0/
c
	if(outtrm.eq.1 .and. model(1:2).eq.'TK') then
c				!ignore if not tektronix
c
	  call tsend_term
	  deltat(1) = itenth * (-1000000)	!100-ns units
	  istat = sys$setef(%val(timflg))
	  istat = sys$setimr(%val(timflg),deltat,,)
	  if(.not.istat) then
	    msgvec(2)=istat
	    call sys$putmsg(msgvec,,,)
	  endif
c
	  istat = sys$wfland(%val(timflg),%val(wflmsk))
	  if(.not.istat) then
	    msgvec(2)=istat
	    call sys$putmsg(msgvec,,,)
	  endif
c
	endif
c
800	return
	end
c
c-------------------------------------------------------------/usr_trnlog
	subroutine usr_trnlog(table,loglnam,physnam,lphys,istat)
c
	implicit none
c  translate logical name to physical name
c
c  arguments:
	character*(*) table	!table to search
	character*(*) loglnam	!logical name to be translated
	character*(*) physnam	!(return) physical name
	integer       lphys	!(return) length of physical name
	integer       istat	!(return) status code
c
c  local variables:
	include '($lnmdef)'
cx	include '($ssdef)'
c
	character*64 holdnam
	character*16 ttabl
	integer*4 lhold		!length of logical name
	integer*4 kattr		!string attributes
c
	structure /itmlst/
	  integer*2 att_leng /4/		!length
	  integer*2 att_code /lnm$_attributes/	!code
	  integer*4 att_addr /0/
	  integer*4 att_desc /0/
	  integer*2 str_leng /64/		!length
	  integer*2 str_code /lnm$_string/	!code
	  integer*4 str_addr /0/
	  integer*4 str_desc /0/
	  integer*4 lnm_end  /0/
	endstructure
	record /itmlst/ trn
	logical more
cx	integer ss$_notran /'0629'X/
	integer sys$trnlnm
	integer ltabl, igood
	integer iag_trim
c
	ttabl = table			!set table name for translation
	if(ttabl.eq.' ') ttabl = 'LNM$FILE_DEV'
	ltabl = iag_trim(ttabl)
	holdnam = loglnam		!copy logical name to local
	lhold = iag_trim(holdnam)	!get length
c
	trn.att_addr=%loc(kattr)	!first item returns attributes
	trn.str_addr=%loc(physnam)	!second item returns name
	trn.str_desc=%loc(lphys)
	physnam=' '
	lphys=0
	istat=0			!no status yet
	more=.true.
c
	do while (more)
	  igood = sys$trnlnm(lnm$m_case_blind,ttabl(1:ltabl),
     >		holdnam(1:lhold),,trn)
c
	  if(igood) then		!if success
	    if(istat.eq.0) istat=1      !need to return 0 or 1
	    holdnam = physnam(1:lphys)	!set up to iterate
	    lhold = lphys
	    if((kattr.and.lnm$m_terminal).ne.0) more=.false.
	  else
	    more=.false.
	  endif
	enddo
c	  	  	  	  check for process perm file
	if(ichar(physnam(1:1)) .eq. '1b'x) then
	  physnam = physnam(5:lphys)	 !adjust length
	  lphys = lphys - 4
	endif
	physnam(lphys+1:) = ' '
c
	return
	end
c
c-------------------------------------------------------------/usr$getdvi
	subroutine usr$getdvi(physnam,klass,istat)
c
	implicit none
c  get device class for a physical device name
c
c  arguments:
	character*(*) physnam	!physical name of device
	integer       klass	!(return) device class
			! 0=unknown, 1=disk, 2=terminal, 5=mailbox(nl:)
	integer       istat	!(return) status code
c
c  local variables:
	include '($dvidef)'
	include '($dcdef)'
c
	integer sys$getdviw
c
	structure /itmlst/
	  integer*2 dvi_leng /4/	!length of response
	  integer*2 dvi_code /dvi$_devclass/	!code for device class
	  integer*4 dvi_bufr /0/	!address of response
	  integer*4 dvi_resl /0/	!address of response length
	endstructure
c
	record /itmlst/ dvi
	integer class		!response buffer
	integer lphys		!length of device name
C
	integer ldot, lcol, igood
c
	lphys = len(physnam)
	lcol = index(physnam(1:lphys),' ')-1
	if(lcol.gt.0) lphys = lcol
	istat = 1		!assume success
	lcol = index(physnam(1:lphys),':')
	ldot = index(physnam(1:lphys),'.')
	if(ldot.ne.0 .and. lcol.eq.0) then
	  klass = 1		!has a dot, but no colon => disk
	  go to 800
	endif
	class = 0		!assume undefined
	dvi.dvi_bufr = %loc(class)
c
	igood = sys$getdviw(,,physnam(1:lphys),dvi,,,,)
cx	if(.not.igood) go to 800
	if(class.eq.0) then
	  klass = 0	!unknown
	elseif(class.eq.dc$_term) then
	  klass = 2	!terminal (on this node)
	elseif(class.eq.dc$_mailbox) then
	  klass = 5	!null device or xtc
	else
	  klass = 1	!disk
	endif
c
	istat = igood
 800	return
	end
c
c-------------------------------------------------------------/ag_info
	subroutine ag_info(mode,ipid,myterm,user)
c
	implicit none
c  get job information
c  mode = 0(other), 1(network), 2(batch), 3(interactive)
c  ipid = process id number
c  myterm = terminal name (char*8)
c  user = user name (char*12)
	character*(*) myterm,user
	structure /itmlst/
	  integer*2 buflen,itmcod
	  integer*4 bufadr,retadr
        end structure
	record  /itmlst/ jpi_list(6)
	include '($jpidef)'
	integer sys$getjpi

	integer lterm, luser, mode, ipid, ii, igood
c
	myterm = ' '
	user = ' '
	lterm=len(myterm)
	luser=len(user)
	jpi_list(1).itmcod = jpi$_mode
	jpi_list(1).buflen = 4
	jpi_list(1).bufadr = %loc(mode)
	jpi_list(2).itmcod = jpi$_pid
	jpi_list(2).buflen = 4
	jpi_list(2).bufadr = %loc(ipid)
	jpi_list(3).itmcod = jpi$_terminal
	jpi_list(3).buflen = lterm
	jpi_list(3).bufadr = %loc(myterm)
	jpi_list(4).itmcod = jpi$_username
	jpi_list(4).buflen = luser
	jpi_list(4).bufadr = %loc(user)
	jpi_list(5).itmcod = 0
c
	igood = sys$getjpi(,,,jpi_list,,,)
	if(.not.igood) then
cx	  stop 'in SGLIB: cant get job information'
	  mode=0
	  ipid=0
	  myterm=' '
	  user=' '
	endif
c
cx	if(mode.ne.jpi$k_interactive) myterm = ' '
	do ii=1,lterm
	  if(ichar(myterm(ii:ii)).eq.0) myterm(ii:ii) = ' '
	enddo
	end

subroutine plot_fp_ii(n1,n2,evec1,fvec1,evec2,tvec2,wkvec,farr)

  ! plot II data from fpreact

  use iso_c_binding, only: fp => c_double
  use adas_mod, only : adas_sigv,adas_btsigv
  use fpreact_parameters

  implicit NONE

  ! data buffers -- uninitialized!

  integer, intent(in) :: n1,n2  ! dimension info

  real(fp) :: evec1(n1)             ! E/A-vector for f(E) plot
  real(fp) :: fvec1(n1)             ! for f(E) plot
  real(fp) :: tevec1(n2)          ! T/A-vector for f(E) or f(E,T) plot
  real(fp) :: evec2(n2),tvec2(n2)   ! E/A,T/A for f(E,T) plot
  real(fp) :: farr(n2,n2)           ! for f(E,T) plot
  real(fp), dimension(:), allocatable :: fvec1_adas
  real(fp), dimension(:,:), allocatable :: farr2

  !----------------------------------
  integer luntrm,lnout
  logical lxout,lchar

  integer izneut,izion,ihandle,idum1,idum2,iopt,i

  real(fp) :: erange1,erange2,trange1,trange2

  character*60 zlbl1,zlbl2,zlbl3

  character*30 flbl,flbl2
  character*15 funs
  character*10 zbzi

  real(fp) :: wkvec(n2,2)
  integer fadas_II,ii
  integer, parameter :: NEUTRAL=1, ION=2 ! beam type: =neutral or =ion

  !----------------------------------

  luntrm=lnout(0)

  zlbl1='preact/fpreact "II" database'
  zlbl2='[sigma*v](E/A) impact ionization rate coefficient'

  luntrm=lnout(0)
  if(lxout(0)) write(luntrm,1001)
1001 format(/ &
         'plot of impact ionization of selected neutral specie as a'/ &
         'function of interaction energy-per-nucleon (E/A), or...'/ &
         'beam target <sigma*V>(Eb/Ab,Ti/Ai) table... (hit "," to exit)'/)

  izion=0
  do
     izneut=0
     call ureadi('select neutral (beam) specie: 1 for H, 2 for He:$',izneut)
     if(izneut.eq.0) exit
     izneut=max(1,min(2,izneut))
     write(luntrm,*)' for PREACT ion specie: 1 for H+, 2 for He++,  only'
     call ureadi('select ion specie: 1 for H+, 2 for He++ or more:$',izion)
!     izion=max(1,min(2,izion))

     call uread('enter "0" for cold target plot; "1" for beam-target table:$')

     iopt=0
     if(lchar('0')) then

        !  get [sigma*v] table range
        call hatom_handle(fpreact_II,izneut,izion,ihandle)
        call cx_coldtarget_erange(ihandle,erange1,erange2,idum1,idum2)

        call plot_fp_mkvec(erange1,erange2,n1,evec1)

        if(lxout(0)) write(luntrm,*) &
             ' A -- ADAS [sigma*v]' 
        if(izion.le.2) then
           if(lxout(0)) write(luntrm,*) &
                ' P -- PREACT [sigma*v]' 
           if(lxout(0)) write(luntrm,*) &
                ' C -- COMPARE ADAS and PREACT ' 
        endif
        if(lxout(0)) write(luntrm,*) &
             ' hit "," to exit' 
        call uread('select option:$')

        if(izneut.eq.1) then
           if(izion.eq.1) then
              zlbl3='impact ionization of H0 by H+, vs. Erel/A'
           else
              zlbl3='impact ionization of H0 by He++, vs. Erel/A'
           endif
        else if(izneut.eq.2) then
           if(izion.eq.1) then
              zlbl3='impact ionization of He0 by H+, vs. Erel/A'
           else
              zlbl3='impact ionization of He0 by He++, vs. Erel/A'
           endif
        endif
        if(lchar('P')) then !PREACT DATA
           zlbl1='preact/fpreact "II" database'
           call hatom_sigv(fpreact_II,evec1,n1,izneut,izion,fvec1,idum1)

           call gaxspc(3) ! log-log
           call r8_grafx1(evec1,fvec1,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
           call gaxspc(1) ! restore default
        elseif(lchar('A')) then !ADAS DATA
           zlbl1='ADAS "II" database'
           fadas_II=2 !II
           call adas_sigv(fadas_II,evec1,n1,izneut,dble(izion),fvec1,idum1)

           call gaxspc(3) ! log-log
           call r8_grafx1(evec1,fvec1,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
           call gaxspc(1) ! restore default
        elseif(lchar('C')) then !ADAS vs PREACT  DATA
           zlbl1='PREACT/ADAS "II" database'
           flbl2='II sigma*v'
           if(allocated(fvec1_adas)) deallocate(fvec1_adas)
           allocate(fvec1_adas(n1))
           fvec1_adas=0.0_fp
           call hatom_sigv(fpreact_II,evec1,n1,izneut,izion, &
                fvec1,idum1)
           fadas_II=2 ! ii full ionization
           call adas_sigv(fadas_II,evec1,n1,izneut,dble(izion),fvec1_adas,idum1)

           call gaxspc(3) ! log-log
           call r8_grafx2(evec1,fvec1,fvec1_adas,n1,'KeV','m**3/sec',zlbl1,zlbl2,zlbl3)
           call gaxspc(1) ! restore default
        endif

     else if(lchar('1')) then

        iopt=fpreact_II  ! ii beam target table

     else
        call uermsg('plot_fp_ii: invalid option.',' ',0)
     endif

     if(iopt.gt.0) then
        ! get table range information
        call hatom_handle(iopt,izneut,izion,ihandle)
        call ii_warmtarget_erange(ihandle,erange1,erange2,idum1,idum2)
        call ii_warmtarget_trange(ihandle,trange1,trange2,idum1,idum2)
        call plot_fp_mkvec(erange1,erange2,n2,evec2)
        call plot_fp_mkvec(trange1,trange2,n2,tvec2)

        flbl='<sigma*v> impact ionization'
        funs='m**3/sec'

        if(lxout(0)) write(luntrm,*) &
             ' A -- ADAS <sigma*v>' 
        if(izion.le.2) then
           if(lxout(0)) write(luntrm,*) &
                ' P -- PREACT <sigma*v>' 
           if(lxout(0)) write(luntrm,*) &
                ' C -- COMPARE ADAS and PREACT ' 
        endif
        if(lxout(0)) write(luntrm,*) &
             ' hit "," to exit' 
        call uread('select option:$')
        if(lchar('P'))then
           zlbl1='PREACT "II" database'
           do i=1,n2
              wkvec(1:n2,1)=tvec2(i)
              call hatom_btsigv(iopt,fpreact_NEUTRAL_BEAM, &
                   evec2,wkvec(1:n2,1),n2,izneut,izion, &
                   farr(1:n2,i),idum1)
           enddo

           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izion
           call r8_grf3f1(evec2,farr,tvec2,wkvec,n2,n2,n2, &
                'beam Eb/Ab',flbl,'target Ti/Ai', &
                'KeV(Eb/Ab)',funs,'KeV(Ti/Ai)',zlbl1,zbzi,0)
           
        else if(lchar('A'))then
           zlbl1='ADAS "II" database'
           fadas_II=2
           wkvec(1:n2,1)=tvec2
           do i=1,n2
              tevec1(1:n2)=tvec2(i)
              call adas_btsigv(fadas_II,NEUTRAL,evec2,tevec1,n2,izneut,dble(izion),farr(1:n2,i),idum1)
              
              !           ikey=2 ! for FOR BEAM TARGET <sig*v>
           enddo

           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izion
           call r8_grf3f1(evec2,farr,tvec2,wkvec,n2,n2,n2, &
                'beam Eb/Ab',flbl,'target Ti/Ai', &
                'KeV(Eb/Ab)',funs,'KeV(Ti/Ai)',zlbl1,zbzi,0)
        else if(lchar('C'))then
           zlbl1='PREACT/ADAS "II" database'
           fadas_II=2
           wkvec(1:n2,2)=evec2
           do i=1,n2
              wkvec(1:n2,1)=tvec2(i)
              call hatom_btsigv(iopt,fpreact_NEUTRAL_BEAM, &
                   evec2,wkvec(1:n2,1),n2,izneut,izion, &
                   farr(1:n2,i),idum1)
           enddo
           if(allocated(farr2)) deallocate(farr2)
           allocate(farr2(n2,n2))
           farr2=0.0_fp
           wkvec(1:n2,1)=tvec2
           do i=1,n2
              tevec1(1:n2)=dble(tvec2(i))
              call adas_btsigv(fadas_II,NEUTRAL,evec2,tevec1,n2,izneut,dble(izion),farr2(1:n2,i),idum1)
!           ikey=2 ! for FOR BEAM TARGET <sig*v>
           enddo

           flbl='PREACT: <sigma*v> II'
           flbl2='ADAS: <sigma*v> II'
           write(zbzi,'(''Zb='',i1,'', Zi='',i1)') izneut,izion
           call r8_grf3f2(evec2,farr,farr2,tvec2,wkvec,n2,n2,n2, &
                'beam Eb/Ab',flbl,flbl2,'target Ti/Ai', &
                'KeV(Eb/Ab)',funs,'KeV(Ti/Ai)',zlbl1,zbzi,0)
           

        endif

     endif

  enddo

end subroutine plot_fp_ii

C------------------------------------------------------------------------------
C
C  Peter Richter (prichter@princeton.edu)
C  Princeton Plasma Physics Laboratory
C  August 2000
C
C  testf77layer.for - Test driver for F77 layer atop PREACT module.
C
C------------------------------------------------------------------------------
C
      program testf77layer
C
      implicit none
      integer icd, ihcx, ihii, ihfs, icode_preact, cx_init, ii_init,
     > fs_init, n
      real*8 f(1), x(1), y(1), z(1), cx_sigma, cx_vrel, ii_sigma,
     >ii_vrel, fs_sigma, fs_vrel
C
      x(1) = 10
      y(1) = 10
      z(1) = 0
      n = 1
C
      write(*,*)'Initializing reactions...'
      icd = icode_preact('H->H(cx)')
      ihcx = cx_init(icd, 1, 2)
      icd = icode_preact('H->H(ii)')
      ihii = ii_init(icd, 1, 2)
      icd = icode_preact('D->D(n)')
      ihfs = fs_init(icd, 1, 2)
C
      write(*,*)'\n***** Charge exchange: H->H(cx) *****************\n'
      write(*,*)'sigma, at E=10 keV/A:                                ',
     >'   ',cx_sigma(ihcx, x(1)),' m^2'
      write(*,*)'vrel, at E=10 keV/A:                                 ',
     >'   ',cx_vrel(ihcx, x(1)),' m/s'
      call cx_coldtarget_sigmatimesv(ihcx, x, f, n)
      write(*,*)'sigma*v (cold target), at E=10 keV/A:                ',
     >'   ',f(1),' m^3/s'
      call cx_warmtarget_sigmatimesv(ihcx, x, y, f, n)
      write(*,*)'<sigma*v> (warm target), at E=10 keV/A, T=10 keV/A:  ',
     >'   ',f(1),' m^3/s'
      call cx_energyavg_peramu(ihcx, x, y, f, n)
      write(*,*)'<E/A> of target reagent, at E=10 keV/A, T=10 keV/A:  ',
     >'   ',f(1),' keV/A'
      call cx_average_vdotnorm(ihcx, x, y, f, n)
      write(*,*)'<Vb dot Vtarg / |Vb|*|Vth|>, at E=10 keV/A, T=10 keV/',
     >'A: ',f(1)
C
      write(*,*)'\n***** Ionization: H->H(ii) **********************\n'
      write(*,*)'sigma, at E=10 keV/A:                                ',
     >'   ',ii_sigma(ihii, x(1)),' m^2'
      write(*,*)'vrel, at E=10 keV/A:                                 ',
     >'   ',ii_vrel(ihii, x(1)),' m/s'
      call ii_coldtarget_sigmatimesv(ihii, x, f, n)
      write(*,*)'sigma*v (cold target), at E=10 keV/A:                ',
     >'   ',f(1),' m^3/s'
      call ii_warmtarget_sigmatimesv(ihii, x, y, f, n)
      write(*,*)'<sigma*v> (warm target), at E=10 keV/A, T=10 keV/A:  ',
     >'   ',f(1),' m^3/s'
C
      write(*,*)'\n***** Fusion: D->D(n) ***************************\n'
      write(*,*)'sigma, at E=10 keV/A:                                ',
     >'   ',fs_sigma(ihfs, x(1)),' m^2'
      write(*,*)'vrel, at E=10 keV/A:                                 ',
     >'   ',fs_vrel(ihfs, x(1)),' m/s'
      call fs_coldtarget_sigmatimesv(ihfs, x, f, n)
      write(*,*)'sigma*v (cold target), at E=10 keV/A:                ',
     >'   ',f(1),' m^3/s'
      call fs_warmtarget_sigmatimesv(ihfs, x, y, f, n)
      write(*,*)'<sigma*v> (warm target), at E=10 keV/A, T=10 keV/A:  ',
     >'   ',f(1),' m^3/s'
      call fs_thermonuclear_sigmatimesv(ihfs, x, f, n)
      write(*,*)'<<sigma*v>> thermonuclear, at T=10 keV/A:            ',
     >'   ',f(1),' m^3/s'
      call fs_gyroavg_sigmatimesv(ihfs, x, z, f, n)
      write(*,*)'<sigma*v> gyro average, at E=10 keV/A, no energy var:',
     >'   ',f(1),' m^3/s','\n'
C
      write(*,*)'Test driver terminated successfully.'
      end
C
C------------------------------------------------------------------------------

subroutine catfus_num(ireact)
  use catfus_mod
  implicit none
 
  integer,intent(out) :: ireact
 
  ireact = nreact            ! number of known reaction categories

  return
end subroutine catfus_num


subroutine catfus_btindx(c3beam,c3target,itypbeam,indx)
  use catfus_mod
  implicit none

  character(len=*), intent(in) :: c3beam   ! "D" "T" or "HE3"
  character(len=*), intent(in) :: c3target ! "D:P" "D:N" "T" or "HE3"
  integer, intent(in) :: itypbeam     ! 1 for beam, 2 for fusion prod, 3 for
                                      ! RF tail; 0 for thermal

  integer, intent(out) :: indx        ! reaction index (or 0 if none found)

  !----------------------------------------------
  character(len=3) :: z3beam,z3target
  integer :: ityptarg = 0
  integer i
  !----------------------------------------------

  indx=0
  if(itypbeam.lt.0) return
  if(itypbeam.gt.3) return

  z3beam=c3beam;     call uupper(z3beam)

  if((z3beam.ne.'D  ').and.(z3beam.ne.'T  ').and. &
       (z3beam.ne.'HE3')) then
    return
  endif

  z3target=c3target; call uupper(z3target)
  if((z3target.ne.'D:P').and.(z3target.ne.'D:N').and.(z3target.ne.'D  ').and. &
       (z3target.ne.'T  ').and.(z3target.ne.'HE3')) then
    return
  endif

  do i=1,nreact
    if((r1(i).eq.z3beam).and.(r2(i).eq.z3target)) then
      if((typmin(i).le.itypbeam).and.(typmax(i).ge.itypbeam)) then
        if(ityptarg.le.typ2max(i)) then
          indx = i
          exit
        endif
      endif
    endif
  enddo

  return
end subroutine catfus_btindx
 
 
subroutine catfus_name(ireact,irtyp1,irtyp2,name)

  !  return a sanitized version of reaction name: first ":" => "_"; any other
  !  punctuation removed.

  !  for original name: use catfus_nam0, same arguments.

  !  mod DMC: if irtyp2=-1, return a "generic" name; pass 0 to catfus_nam0

  integer,intent(in) :: ireact    ! reaction index
  integer, intent(in) :: irtyp1   ! type of 1st reagent
  integer, intent(in) :: irtyp2   ! type of 2nd reagent

  character(len=*), intent(out) :: name   ! name (label string) for reaction

  !------------------------------------
  integer :: j,k,ilen,icolon,irtyp2a
  !------------------------------------

  irtyp2a=irtyp2
  if(irtyp2a.eq.-1) irtyp2a=0

  name=' '
  call catfus_nam0(ireact,irtyp1,irtyp2a,name)

  ilen=len(trim(name))

  icolon=0
  k=0

  do j=1,ilen
    if(name(j:j).eq.':') then
      icolon=icolon+1
      if(icolon.eq.1) then 
        k=k+1
        name(k:k)='_'
      endif

    else if(name(j:j).eq.'-') then
      continue  ! i.e. skip

    else if(name(j:j).eq.'>') then
      continue  ! i.e. skip

    else
      k=k+1
      if(k.lt.j) name(k:k)=name(j:j)
    endif
  enddo

  if(k.lt.ilen) name(k+1:ilen)=' '

  if(irtyp2a.ne.irtyp2) then
    if(name(1:3).eq.'BT_') then
      if(ireact.le.6) then
        name = name(4:)
      endif
    else if(name(1:3).eq.'FT_') then
      name(2:2)='P'
    else if(name(1:3).eq.'RT_') then
      name(2:2)='F'
    endif
  endif

  return
end subroutine catfus_name


subroutine catfus_nam0(ireact,irtyp1,irtyp2,name)

  use catfus_mod
  implicit none

  integer, intent(in) :: ireact   ! reaction index
  integer, intent(in) :: irtyp1   ! type of 1st reagent
  integer, intent(in) :: irtyp2   ! type of 2nd reagent

  !  rule:  irtyp1.ge.irtyp2 .and. irtyp2.le.1 .and. irtyp2.ge.0
  !  additional rules:  see the module data
  !     generally, reaction indices .gt.8 are for FP and RFI ions only.
  !
  !  irtyp1|2 = 0 -- thermal   irtyp1=0, irtyp2=0: thermonuclear reaction
  !
  !     in what follows, "target" means thermal target population.
  !
  !  irtyp1|2 = 1 -- beam ion  irtyp1=1, irtyp2=0: beam-target reaction
  !                            irtyp1=1, irtyp2=1: beam-beam reaction
  !
  !  irtyp1|2 = 2 -- fusion product (FP):  T or He3
  !                            irtyp1=2, irtyp2=0: FP-target reaction
  !                            irtyp1=2, irtyp2=1: FP-beam reaction
  !
  !    (D is not a fusion product; P and He4 are non-reacting fusion products)
  !
  !  irtyp1|2 = 3 -- RF tail ion (RFI)
  !                            irtyp1=3, irtyp2=0: RFI-target reaction
  !                            irtyp1=3, irtyp2=1: RFI-beam reaction
  !    (generally, T or He3 tail ions are of interest).
  !  D tail has been added , MG 08/19/19
  character(len=*), intent(out) :: name   ! name (label string) for reaction

  !----------------------------------------
  character(len=3) :: reagent1,reagent2
  character(len=8) :: combo
  integer ilr1,ilr2
  !----------------------------------------

  name='error'

  if(irtyp1.lt.irtyp2) return
  if(irtyp2.gt.1) return
  if(irtyp2.lt.0) return

  if((ireact.le.0).or.(ireact.gt.nreact)) return
  if((irtyp1.lt.typmin(ireact)).or.(irtyp1.gt.typmax(ireact))) return
  if(irtyp2.gt.typ2max(ireact)) return

  call catfus_reagent(ireact,reagent1,reagent2)
  ilr1=len_trim(reagent1)
  ilr2=len_trim(reagent2)

  if(irtyp1.eq.irtyp2) then

    combo=reagent1(1:ilr1)//'-'//reagent2(1:ilr2)

    if(irtyp1.eq.0) then
      name='TH:'//combo
    else if(irtyp1.eq.1) then
      name='BB:'//combo
    endif

  else

    combo=reagent1(1:ilr1)//'->'//reagent2(1:ilr2)

    if(irtyp1.eq.1) then
      name='BT:'//combo
    else if(irtyp1.eq.2) then
      if(irtyp2.eq.0) then
        name='FT:'//combo
      else if(irtyp2.eq.1) then
        name='FB:'//combo
      endif
    else if(irtyp1.eq.3) then
      if(irtyp2.eq.0) then
        name='RT:'//combo
      else if(irtyp2.eq.1) then
        name='RB:'//combo
      endif
    endif

  endif

  return
end subroutine catfus_nam0


subroutine catfus_mtype(ireact,itypfast)
 
  use catfus_mod
  implicit none
 
  integer,intent(in) :: ireact    ! reaction index
  integer,intent(out) :: itypfast ! fast-ion type
 
  !  generally, the categorization allows fast-ion -- fast-ion reactions
  !  to be considered, but the "second" fast-ion specie must be a beam
  !  ion specie; the "first" specie can be beam-ion (B),
  !  fusion-product-ion (FP), or RF-tail-ion (RFI).
  !
  !  categories for FP-FP, RFI-RFI, and FP-RFI are not supported;
  !  categories B-B, FP-B, and RFI-B *are* supported.
  !
  !----------------------------------------

  itypfast=0
  if((ireact.le.0).or.(ireact.gt.nreact)) return

  itypfast=typmax(ireact)   ! 1=beam, 2=fusion product, 3=RF tail

  return
end subroutine catfus_mtype


subroutine catfus_reagent(ireact,reagent1,reagent2)
  use catfus_mod
  implicit none

  integer,intent(in) :: ireact    ! reaction index

  character(len=*),intent(out) :: reagent1,reagent2    ! reagents

  !----------------------------------------

  reagent1='?'
  reagent2='?'

  if((ireact.le.0).or.(ireact.gt.nreact)) return

  reagent1 = r1(ireact)
  reagent2 = r2(ireact)

  return
end subroutine catfus_reagent

      subroutine getmpa(zrmc,zymc,mimom,imom,zrin,zrout,zymp)
C
C  DMC 18 March 1994:
C  given the updown asymmetric moments of a surface, define an
C  approximate midplane to the surface.  Return the inner and
C  outer R intercepts of this midplane with the surface, and
C  return the height of the surface above y=0.
C
C  rev dmc 25 Mar 1994:  use
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER imom,mimom,inth,imm,ith
!============
! idecl:  explicitize implicit REAL declarations:
      REAL zth,zr,zy
!============
      REAL zrmc(0:mimom,2)  ! R moments
      REAL zymc(0:mimom,2)  ! Y moments
C
C  mimom gives the moments 1st array dimension; imom gives the number
C   of *active* moments; imom.le.mimom ...
C
      REAL zrin            ! inner intercept R (output)
      REAL zrout           ! outer intercept R (output)
      REAL zymp            ! midplane vertical displacement (output)
C
      parameter (inth=400)
      REAL zrcon(inth),zycon(inth)
      REAL zcos(0:imom),zsin(0:imom)
C---------------------------------------------------------------------
C
      zcos(0)=1
      zsin(0)=0
      do ith=1,inth-1
        zth=(6.2831853071795862*(ith-1))/(inth-1)
        zr=0.0
        zy=0.0
        call sincos(zth,imom,zsin(1:imom),zcos(1:imom))
        do imm=0,imom
          zr=zr+zrmc(imm,1)*zcos(imm)+zrmc(imm,2)*zsin(imm)
          zy=zy+zymc(imm,1)*zcos(imm)+zymc(imm,2)*zsin(imm)
        enddo
        zrcon(ith)=zr
        zycon(ith)=zy
      enddo
C
      zrcon(inth)=zrcon(1)
      zycon(inth)=zycon(1)
C
      call getmpa_ry(zrcon,zycon,inth,zrin,zrout,zymp)
C
      return
      end
C---------------------------------------------------------------------
C
      subroutine getmpa_ry(zrcon,zycon,inth,zrin,zrout,zymp)
C
C  find midplane elevation and R intercepts based on centroid, starting
C  from a closed contour of (R,Y) pairs
C
      implicit NONE

      integer, intent(in) :: inth
      real, intent(in) :: zrcon(inth),zycon(inth)  ! closed contour

      real, intent(out) :: zrin,zrout    ! midplane intercepts (approx.)
      real, intent(out) :: zymp          ! midplane elevation (centroid)
C
C  local:
C
      real :: zrmp,zr,zy,zrp,zyp,zytest,zrans
      integer :: ith
C
C  find centroid
C
      call plcentr(zrcon,zycon,inth,zrmp,zymp)
C
C  find approximate midplane intercept locations
C
      zr=zrcon(1)
      zy=zycon(1)
C
      do ith=2,inth
c
        zrp=zr
        zyp=zy
        zr=zrcon(ith)
        zy=zycon(ith)
c
        zytest=(zy-zymp)*(zymp-zyp)
        if(zytest.ge.0.0) then
          zrans=(zr*(zymp-zyp)+zrp*(zy-zymp))/(zy-zyp)
          if(zrans.gt.zrmp) then
            zrout=zrans
          else
            zrin=zrans
          endif
        endif
      enddo
C
      return
      end

C******************** START FILE GRFUF1.FOR ; GROUP GRFUF1 *************
C  dmc 11 Aug 1994
C   plot the bloated coordinate system used in TRANSP / fast ion code
C    use MOMRY for the expansion; this will also test the Fourier Spline
C
C   give user control over the flux coordinate range
C
c   mod dmc -- momry->zmomry, passed external routine
C
      SUBROUTINE GRSFLUX(zmomry,XUN,YUN,LBL1,LBL2,LBL3)
 
      external zmomry
 
C  Modified:
C   04/05/96  TBT  Added Logical Lchar
C
C
C  LABELS:
      CHARACTER*(*) XUN,YUN,LBL1,LBL2,LBL3
C
C  local arrays for contours plotted
C
      parameter(icmax=250)
      real zrlocl(icmax),zylocl(icmax)
C
C  SCALE SETTING COMMON BLOCKS --
C
      INCLUDE 'GSCALE_BLK'
C
      INCLUDE 'PLOT1MMX'
C
      EXTERNAL GRADUM  ! FOR GRAOPT CALL INTERFACE
C
      logical lxout
      Logical Lchar
      integer, save :: iopcod=0
C
      real zjaco(2,2)
C
      integer maxjac
      parameter (maxjac=201)
      real x(maxjac),th(maxjac),jac(maxjac,maxjac),wk(maxjac)
      real gradx(maxjac,maxjac),gradth(maxjac,maxjac)
C
      character*64 wname
      character*40 gname,dname
      integer icounter
      character*15 zext
C
      character*20 zmode(2),altmode(3)
      data zmode/'mesh plot ',' '/
      data altmode/'jacobian plot','|grad(xi)| plot','|grad(th)| plot'/
C----------------------------------------------------------------
C
      icounter=0
C-------------------------------------------------------------
      ialt=1
      zmode(2)=altmode(ialt)
      imode=1
      imodj=0
      inth=40
      inxi=50
C
      zximin=0.0
      zximax=1.0
      zthmin=0.0
      zthmax=6.283185
C
      LUNTRM=LNOUT(0)
C
 10   continue
      if(lxout(0)) write(luntrm,1001) inth,inxi,altmode(ialt),
     >     zximin,zximax,
     >     zthmin,zthmax,zmode(imode),imodj.eq.1
 1001 format(/
     >  ' grsflux options:'/
     >  ' C - change line counts, presently nth=',i3,' nxi=',i3/
     >  ' G - alternate mode definition, currently set to:  ',a/
     >  ' X - change xi range, presently ximin/max =',2(1x,1pe11.4)/
     >  ' T - change th range, presently thmin/max =',2(1x,1pe11.4)/
     >  ' P - proceed to make plot'/
     >  ' M - change plot mode, currently set to:  ',a/
     >  ' J - include Jacobian calculation in spider plots (',L1,')'/
     >  ' S - suppress Jacobian calculation in spider plots'/
     >  ' Q - quit')
C
      call uread('grsflux:  control option:$$')
      if(lchar('Q')) then
         return
      else if(lchar('P')) then
         go to 99
      else if(lchar('M')) then
         imode=3-imode
      else if(lchar('G')) then
         if(lxout(0)) then
            do i=1,3
               write(luntrm,*) ' alt mode #',i,': ',trim(altmode(i))
            enddo
         endif
         call ureadi('grsflux:  alt mode plot selection (choose #):',
     >        ialt)
         ialt=max(1,min(3,ialt))
         zmode(2)=altmode(ialt)
      else if(lchar('C')) then
         if(lxout(0)) then
            write(luntrm,*) ' maximum allowed values: ',maxjac
         endif
         call ureadi('grsflux:  new nxi:$$',inxi)
         inxi=max(2,min(maxjac,inxi))
         call ureadi('grsflux:  new nth:$$',inth)
         inth=max(2,min(maxjac,inth))
      else if(lchar('X')) then
         zximin0=zximin
         zximax0=zximax
         call ureadf('grsflux:  new ximin:$$',zximin0)
         call ureadf('grsflux:  new ximax:$$',zximax0)
         zximin=min(zximin0,zximax0)
         zximax=max(zximin0,zximax0)
      else if(lchar('T')) then
         zthmin0=zthmin
         zthmax0=zthmax
         call ureadf('grsflux:  new thmin:$$',zthmin0)
         call ureadf('grsflux:  new thmax:$$',zthmax0)
         zthmin=min(zthmin0,zthmax0)
         zthmax=max(zthmin0,zthmax0)
      else if (lchar('S')) then
         imodj=0
      else if(lchar('J')) then
         imodj=1
      else
         call uermsg('grsflux:  unrecognized opcode.',' ',0)
      endif
      go to 10
C
C----------------------------------------------------------------
C
 99   continue
C
C  SCALE SET SWITCHE CLEARED:
C
      ILOCSC=0
C
C  GET DEFAULT AXIS SELECTION
C
      CALL GAXGDF(ISEL)
C
C----------------------------------------------------------------
C  AUTOMATIC GENERATION OF PLOT
C
 100  CONTINUE
      if(imode.eq.1) then
         icounter=icounter+1
      endif
C
C  SET AXES
C
      CALL GAXCUR(ISEL)
C
      N=icmax
      N4=icmax/4
      Ntmp=4*N4
C  build a bounding contour, for scale-setting purposes
C
      if(imode.eq.1) then
         zdetmin=1.e30
         zdetmax=-1.e30
         ic=0
         zth=zthmin
         do i4=1,n4
            zxi=zximin+float(i4-1)*(zximax-zximin)/float(n4-1)
            call zmomry(zxi,zth,imodj,zrout,zyout,zjaco)
            ic=ic+1
            zrlocl(ic)=zrout
            zylocl(ic)=zyout
            if(imodj.eq.1) call zjstats(zxi,zth,zjaco,
     >         zdetmin,zdetmax,zxijmin,zxijmax,zthjmin,zthjmax)
         enddo
         do i4=1,n4
            zth=zthmin+float(i4)*(zthmax-zthmin)/float(n4)
            call zmomry(zxi,zth,imodj,zrout,zyout,zjaco)
            ic=ic+1
            zrlocl(ic)=zrout
            zylocl(ic)=zyout
            if(imodj.eq.1) call zjstats(zxi,zth,zjaco,
     >         zdetmin,zdetmax,zxijmin,zxijmax,zthjmin,zthjmax)
         enddo
         do i4=1,n4
            zxi=zximax+float(i4)*(zximin-zximax)/float(n4)
            call zmomry(zxi,zth,imodj,zrout,zyout,zjaco)
            ic=ic+1
            zrlocl(ic)=zrout
            zylocl(ic)=zyout
            if(imodj.eq.1) call zjstats(zxi,zth,zjaco,
     >         zdetmin,zdetmax,zxijmin,zxijmax,zthjmin,zthjmax)
         enddo
         do i4=1,n4
            zth=zthmax+float(i4)*(zthmin-zthmax)/float(n4)
            call zmomry(zxi,zth,imodj,zrout,zyout,zjaco)
            ic=ic+1
            zrlocl(ic)=zrout
            zylocl(ic)=zyout
            if(imodj.eq.1) call zjstats(zxi,zth,zjaco,
     >         zdetmin,zdetmax,zxijmin,zxijmax,zthjmin,zthjmax)
         enddo
C
         IF(ILOCSC.EQ.0) THEN
C  COMPUTE X AND Y PLOT SCALE (USE GSCALE DEFAULTS)
            CALL GSCSET(zrlocl,zylocl,zylocl,0,Ntmp)
         ELSE IF(ILOCSC.EQ.1) THEN
C  COMPUTE Y AUTOSCALE ONLY
            CALL GSCMMX(zrlocl,Ntmp,zylocl,zylocl,0,Ntmp,
     >         1,1,1,1,Ntmp,XMIN,XMAX,1)
            CALL GSCYDF(1)
         ENDIF
C
         CALL GSCSEP(XMIN,XMAX)
         CALL GSCSEP(YMIN,YMAX)
C
         CALL GAXCHK(LUNTRM,ISEL,ICOD)  ! AXIS (LOG/LIN) CHECK
C
         CALL GSCREC                    ! RECORD PLOT SCALE IN MEMORY
      endif                             ! imode
C
C  plot xi lines
      if(imode.eq.1) then
         ict=0
         do ixi=inxi,1,-1
            zxi=zximin+float(ixi-1)*(zximax-zximin)/float(inxi-1)
            do i=1,n
               zth=zthmin+float(i-1)*(zthmax-zthmin)/float(n-1)
               call zmomry(zxi,zth,imodj,zrlocl(i),zylocl(i),zjaco)
               if(imodj.eq.1) call zjstats(zxi,zth,zjaco,
     >            zdetmin,zdetmax,zxijmin,zxijmax,zthjmin,zthjmax)
            enddo
            ict=ict+1
            if(ict.eq.1) then
               call dplot1(zrlocl,zylocl,n,icod)
               call tsend
            else
               call dplot1(zrlocl,zylocl,n,1)
               call tsend
            endif
         enddo
      endif                             !imode
C
      ict=0
      do ith=1,inth
         ict=ict+1
         zth=zthmin+float(ith-1)*(zthmax-zthmin)/float(inth-1)
         if(imode.eq.1) then
            do i=1,n
               zxi=zximin+float(i-1)*(zximax-zximin)/float(n-1)
               call zmomry(zxi,zth,imodj,zrlocl(i),zylocl(i),zjaco)
               if(imodj.eq.1) call zjstats(zxi,zth,zjaco,
     >            zdetmin,zdetmax,zxijmin,zxijmax,zthjmin,zthjmax)
            enddo
            call dplot1(zrlocl,zylocl,n,1)
            call tsend
         else
            th(ith)=zth
            do ixi=1,inxi
               zxi=zximin+float(ixi-1)*(zximax-zximin)/float(inxi-1)
               x(ixi)=zxi
c
               call zmomry(zxi,zth,1,zrdum,zydum,zjaco)
               jac(ixi,ith)=zjaco(1,1)*zjaco(2,2)-zjaco(1,2)*zjaco(2,1)
               if(abs(jac(ixi,ith)).ne.0.0) then
                  gradx(ixi,ith)=sqrt(zjaco(2,1)**2+zjaco(2,2)**2)/
     >                 abs(jac(ixi,ith))
                  gradth(ixi,ith)=sqrt(zjaco(1,1)**2+zjaco(1,2)**2)/
     >                 abs(jac(ixi,ith))
               else
                  gradx(ixi,ith)=0.0
                  gradth(ixi,ith)=0.0
               endif
c
            enddo
         endif
      enddo
C
      if(imode.ne.1) then
         if(ialt.eq.1) then
            call grf3f1(x,jac,th,wk,inxi,inth,maxjac,
     >           'x','2x2 Jacobian','theta','x','J','theta',
     >           'grsflux jacobian debug plot','grsflux',0)
         else if(ialt.eq.2) then
            call grf3f1(x,gradx,th,wk,inxi,inth,maxjac,
     >           'x','|grad(x)|','theta','x','1/m','theta',
     >           'grsflux |grad(x)| debug plot','grsflux',0)
         else if(ialt.eq.3) then
            call grf3f1(x,gradth,th,wk,inxi,inth,maxjac,
     >           'x','|grad(th)|','theta','x','rad/m','theta',
     >           'grsflux |grad(th)| debug plot','grsflux',0)
         endif
         go to 10
      endif
C
      CALL GRALBL(XUN,YUN,LBL1,LBL2,LBL3)  ! LABEL THE PLOT
C
      CALL UPAUST(2)  ! PAUSE AFTER PLOT
c
      if(imodj.eq.1) then
         write(6,*) ' min det(J) = ',zdetmin
         write(6,*) ' ...at (xi,th)=',zxijmin,zthjmin
         write(6,*) ' max det(J) = ',zdetmax
         write(6,*) ' ...at (xi,th)=',zxijmax,zthjmax
      endif
c
      GO TO 200
C
C  POST PLOT OPTIONS
C
 200  CONTINUE
C
C  GENERATE MENU AND FETCH USER REPLY
C
      CALL GRAOPT('SA',ISEL,ILOCSC,IOPCOD,GRADUM)
C
C  ACT ON USER REPLY - REPLOT?
C
      IF(IOPCOD.EQ.1) THEN
        GO TO 100
      ELSE IF(IOPCOD.EQ.2) THEN
        go to 10
      ENDIF
C
      CALL UERMSI(' ?GRFSSYM *FATAL BUG* UNANTICIPATED OPERATION CODE',
     >              IOPCOD,1)
      call bad_exit
C
      contains
         subroutine make_zext(zpre)
         character*(*), intent(in) :: zpre

         zext=' '
         if(ict.le.9) then
            write(zext,'(a,I1)') trim(zpre),ict
         else if(ict.le.99) then
            write(zext,'(a,I2)') trim(zpre),ict
         else if(ict.le.999) then
            write(zext,'(a,I3)') trim(zpre),ict
         else if(ict.le.9999) then
            write(zext,'(a,I4)') trim(zpre),ict
         else if(ict.le.99999) then
            write(zext,'(a,I5)') trim(zpre),ict
         else if(ict.le.999999) then
            write(zext,'(a,I6)') trim(zpre),ict
         endif

         end subroutine make_zext
      END
c------------------------------------------------------------------------
      subroutine zjstats(zxi,zth,zjaco,
     >   zdetmin,zdetmax,zxijmin,zxijmax,zthjmin,zthjmax)
c
c  find min/max jacobian
c
      implicit NONE
c
      real zxi,zth,zjaco(2,2)           ! input
      real zdetmin,zdetmax              ! min, max det (in/out)
      real zxijmin,zxijmax              ! zxi of min, max (in/out)
      real zthjmin,zthjmax              ! zth of min, max
c
c------------------
c
      real zdet
c
c------------------
c
      zdet=zjaco(1,1)*zjaco(2,2)-zjaco(1,2)*zjaco(2,1)
c
      if(zdet.lt.zdetmin) then
         zdetmin=zdet
         zxijmin=zxi
         zthjmin=zth
      endif
c
      if(zdet.gt.zdetmax) then
         zdetmax=zdet
         zxijmax=zxi
         zthjmax=zth
      endif
c
      return
      end

C******************** START FILE UFPAUS.FOR ; GROUP UFILES ******************
C-------------------------------------------------------------
C& UFPAUS  UFILES CONDITIONAL PAUSE AFTER ERROR MESSAGE
C     DMC 16 JAN 1985
C
C     22 Jun 1994 -- replace UPAUST call; remove dependency of
C     some Ufiles programs on ureadsub library.
C
      SUBROUTINE UFPAUS(IDUM)
C
      USE UFILES
C
      character*1 achar
C
      DATA IBELL/7/
C
      IF(((UFILEV/10).GT.1).AND.(UFELUN.EQ.6)) THEN
         CALL ISBATCH(IBATCH)
         IF(IBATCH.EQ.0) THEN
            WRITE(6,9001) IBELL,IBELL
 9001       FORMAT(1X,A1,'[Ufiles USER ACKNOWLEDGE - HIT ANY KEY]',A1)
C
            CALL TERM_CHAR_IN(achar)
C
         ENDIF
      ENDIF
C
      RETURN
      END
C******************** END FILE UFPAUS.FOR ; GROUP UFILES ******************

      subroutine ufmds_rank(arg,idim,ier)
C
C  routine to get rank (dimensionality) of a signal
C
C---------------------------------
C History:
C 11/18/99 CAL: new calling arguments for mds_value
C
C------------------------------
C
      use UFILES
C
      character*(*) arg         ! signal path (input)
      integer idim              ! dimensionality (output)
C
      character*128 zerrmsg
C
      integer     idescr_long, iretl
C--------------------------------
C
      ier=0
      ila=max(1,len_trim(arg))
      istat=mds_value('rank('//arg(1:ila)//')',idescr_long(idim),iretl)
      if(mod(istat,2).ne.1) then
         call ufmds_err('UFMDS_RANK',istat,ier,zerrmsg,ilm)
         write(ufelun,9503) arg(1:ila),zerrmsg(1:ilm)
 9503    format('  seeking dimensionality of MDS+ signal: ',a/2x,a)
      endif
C
      return
      end
 
 
 

      SUBROUTINE TERM_input(jchar)
      implicit none
C
#include "fpreproc/byte_declare.h"
C
C...This routine was written by Harry H. Towner of the Princeton
C...Plasma Physics Lab.
C
C   Get a character from the terminal
C   --> DMC Oct 1991 <-- UNIX code using ordinary FORTRAN i/o
C                        which requires a carriage return
C
C...Parameters:
C*..jchar	- The byte that was input.
C
C***********************************************************************
C
      byte_declare jchar
C
#if __CRAY || __SX
      integer ibuf,zgetc
 
      ibuf = zgetc()
      jchar=char(ibuf)
#elif __UNIX
      integer ibuf,zgetc
 
      ibuf = zgetc()
      jchar=ibuf
#endif
C
      RETURN
      END
C--------------------------------
C
C  read in a single character from the terminal
C
      subroutine term_char_in(achar)
      implicit none
      character*1 achar
C
      byte_declare jchar
C
      call term_input(jchar)
#if __CRAY || __SX
      achar=jchar
#else
      achar=char(jchar)
#endif
C
      return
      end
 

C-----------------------------------------------------------------------
C  PARSID -- PARSE OUT TRANSP RUN ID AND TOKAMAK FROM COMBINED INPUT
C
C History:
C 10/16/96 CAL : Support RunId with 4 - 6 digit shot number
C                                   2 - 3 digit run  number
C
      SUBROUTINE PARSID(STRING,NRUN,TOK)
C
      CHARACTER*(*) STRING	! INPUT STRING E.G. "12345A01PBXM"
C				! COULD BE OLD STYLE "1234TFTR"
C                               ! e.g. 123456A123TFTR
      CHARACTER*(*) NRUN	! OUTPUT RUN ID, "12345A01" OR "1234"
      CHARACTER*(*)  TOK	! OUTPUT TOKAMAKD ID, "PBXM" OR "TFTR"
C
      CHARACTER*10 ZDIGIT
C
C  TWO RUN ID "STYLES" ARE SUPPORTED, THE OLD 4 DIGIT RUN NUMBER STYLE
C  AND THE NEW 8 CHARACTER nnnnnAmm SHOT-TRY NOMENCLATURE
C
C------------------------------------
C
      TOK='????'
C
      if(len(nrun).lt.10) then
         ilen=len(nrun)
         write(6,9901) ilen
 9901    format(
     >       ' ?parsid:  len(rundid)=',i2,
     >       ' incompatible with 6 digit shot number.')
         nrun='len_error'
         return
      endif
C
      ZDIGIT='0123456789'
C
      NRUN='ERROR!!!'
C
      ILEN=INDEX(STRING,' ')-1
      IF(ILEN.LE.0) ILEN=LEN(STRING)
C
C  TEST FOR OLD VS. NEW STYLE IS WHETHER THE 5TH CHARACTER OF THE INPUT
C  STRING IS A DIGIT:  DIGIT INDICATES NEW STYLE
C
      IF(ILEN.LT.5) GO TO 1000
C
      IDIG=INDEX(ZDIGIT,STRING(5:5))
C
      IF(IDIG.EQ.0) THEN
C
C  OLD STYLE
C
C  CHECK LENGTH
C
        IF((ILEN.LT.7).OR.(ILEN.GT.8)) GO TO 1000
C
C  OK, CHECK THAT 1ST FOUR CHARS ARE DIGITS
C
        DO 10 IC=1,4
          IF(INDEX(ZDIGIT,STRING(IC:IC)).EQ.0) GO TO 1000
 10     CONTINUE
C
C  GOOD
C
        NRUN=STRING(1:4)
        TOK=STRING(5:ILEN)
C
      ELSE
C
C  NEW STYLE
C
C  CHECK valid Shot Number
C
        ic = 0
        DO 20 while (idig .ne. 0)
          ic = ic+1
          IDIG = INDEX(ZDIGIT,STRING(IC:IC))
 20     CONTINUE
        i1 = ic - 1
        if (i1 .lt. 5 .or. i1 .gt. 6) go to 1000
          if (i1 .eq. 6 .and. string(1:1) .eq. '0') go to 1000
 
C
C Check valid Run Number
          idig = 1
        DO 21 while (idig .ne. 0)
          ic = ic+1
          IDIG = INDEX(ZDIGIT,STRING(IC:IC))
 21     CONTINUE
        i2 = ic - i1 - 2
        if (i2 .lt. 2 .or. i2 .gt. 3)  go to 1000
 
        NRUN=STRING(1:ic-1)
        TOK=STRING(ic:ILEN)
C
      ENDIF
C
 1000 CONTINUE
      RETURN
      END

subroutine hatom_btsigv(irtype,beamchrg,eabeam,tatarg,n,izbeam,iztarg, &
     btsigv, istat )
 
  use hatom_mod
 
  implicit NONE
 
  !  get maxwellian averaged beam-target <sigma*v> for a charge exchange
  !  or impact ionization reaction between light neutral atoms and light
  !  fully stripped ions [H,HE,LI]x[H+,HE++,LI+++]
  !    ---caution-- as of June 2001, the atomic physics database does
  !                 not have all good data on LI.
  !
  !  this routine can also be used to retrieve <Eav> = average energy,
  !    KeV, of the cx reagent sampled out of the maxwellian target of
  !    a beam-target cx reaction; <Eav> can be used to refine the
  !    calculation of the charge exchange driven power exchange between
  !    the beam and target populations.
  !
  !  this routine can also be used to retrieve the dimensionless
  !
  !    <fd> = < vb.vtarg / (|vb|*|vth|) >
  !
  !  which tells whether the average cx reagent sampled has a velocity
  !  component parallel to (<fd> .gt. 0) or anti-parallel to (<fd> .lt. 0)
  !  the direction of the beam; note vth = sqrt(Ti/mi) of the target
  !  Maxwellian; <fd> can be used to refine the calculation of the
  !  charge exchange driven momentum exchange between the beam and
  !  target populations.
  !
  !  here, "charge exchange" refers to an ion-neutral reaction, in which
  !  charges are exchanged ***and the ion is neutralized***; a reaction
  !  in which an electron is exchanged but the receiving particle is
  !  not neutralized, should be counted as an impact ionization event.
  !  The rationale:  this routine is intended for use in modeling of
  !  high temperature plasmas; a partially stripped light impurity is
  !  quickly fully stripped, so that the net result of a partial
  !  charge exchange reaction is two fully stripped ions, same as
  !  a "pure" impact ionization reaction.
  !
  !  a result of ZERO is returned if there is no neutralizing
  !  charge exchange reaction (e.g He++ cannot be neutralized by cx
  !  with an H neutral beam)
  !
  !  a result of ERROR (-1) is returned if invalid arguments
  !  are passed.
 
  integer, parameter :: CX=1, II=2, EAV=3, FD=4
 
  integer, parameter :: NEUTRAL=1, ION=2
 
  integer, parameter :: H=1, HE=2, LI=3
 
  real*8, parameter :: ZERO=0.0d0, ERROR=-1.0D0
  integer, parameter :: IZERO=-1, IERROR=-2
 
  !--------------------------------------------
  !  **subroutine arguments**
 
  integer, intent(in) :: irtype   ! reaction type: =cx or =ii or =eav or =fd
  integer, intent(in) :: beamchrg ! beam type: =neutral or =ion
 
  ! if the beam is neutral, the target maxwellian contains ions
  ! if it is an ion beam, the target maxwellian contains neutrals
 
  integer, intent(in) :: n        ! **vector size**
  real*8, intent(in) :: eabeam(n)    ! E/A, KeV/nucleon, of beam   **vector**
  real*8, intent(in) :: tatarg(n)    ! T/A, KeV/nucleon, of target **vector**
 
  integer, intent(in)  :: izbeam  ! Z of beam species
  integer, intent(in)  :: iztarg  ! Z of target species
 
  !  **result**
 
  real*8, intent(out) :: btsigv(n)   ! <sigma*v>, m**3/sec  **vector**
                                     ! or <Eav>, KeV
                                     ! or <fd>, dimensionless
 
  integer, intent(out) :: istat      ! completion code; 0 = normal
 
  !  istat = 1:  beamchrg argument invalid
  !  istat = 2:  irtype argument invalid
  !  istat = 3:  izbeam or iztarg invalid
  !
  !--------------------------------------------
  !  local
 
  integer :: lreact   ! reaction handle
  integer :: izneut   ! Z of neutral
  integer :: izchrg   ! Z of charged ptcl
 
  !--------------------------------------------
  !  initialize module, if necessary
 
  if(hatom_flag.eq.0) call hatom_init
 
  !--------------------------------------------
 
  istat = 0
  lreact = IZERO
 
  if(beamchrg.eq.NEUTRAL) then
 
     !  ---------> Neutral Beam, charged particle target
 
     izneut = izbeam
     izchrg = iztarg
 
  else if(beamchrg.eq.ION) then
 
     izneut = iztarg
     izchrg = izbeam
 
  else
 
     istat = 1
     btsigv = ERROR
     return
 
  endif
 
  if((irtype.eq.CX).or.(irtype.eq.EAV).or.(irtype.eq.FD)) then
 
     !  ---------> (neutralizing) charge exchange
 
     if(izneut.eq.H) then
        if(izchrg.eq.H) then
           lreact = Lcx_H0_H
        else if(izchrg.eq.HE) then
           lreact = IZERO          ! cannot neutralize HE
        else if(izchrg.eq.LI) then
           lreact = IZERO          ! cannot neutralize LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else if(izneut.eq.HE) then
        if(izchrg.eq.H) then
           lreact = Lcx_HE0_H
        else if(izchrg.eq.HE) then
           lreact = Lcx_HE0_HE
        else if(izchrg.eq.LI) then
           lreact = IZERO          ! cannot neutralize LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else if(izneut.eq.LI) then
        if(izchrg.eq.H) then
           lreact = Lcx_LI0_H
        else if(izchrg.eq.HE) then
           lreact = Lcx_LI0_HE
        else if(izchrg.eq.LI) then
           lreact = Lcx_LI0_LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else
 
        istat = 3
        lreact = IERROR
 
     endif
 
  else if(irtype.eq.II) then
 
     !  ---------> impact ionization
     !      or, sum of impact ionization and partial charge exchange
 
     if(izneut.eq.H) then
        if(izchrg.eq.H) then
           lreact = Lii_H0_H
        else if(izchrg.eq.HE) then
           lreact = Lii_H0_HE
        else if(izchrg.eq.LI) then
           lreact = Lii_H0_LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else if(izneut.eq.HE) then
        if(izchrg.eq.H) then
           lreact = Lii_HE0_H
        else if(izchrg.eq.HE) then
           lreact = Lii_HE0_HE
        else if(izchrg.eq.LI) then
           lreact = Lii_HE0_LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else if(izneut.eq.LI) then
        if(izchrg.eq.H) then
           lreact = Lii_LI0_H
        else if(izchrg.eq.HE) then
           lreact = Lii_LI0_HE
        else if(izchrg.eq.LI) then
           lreact = Lii_LI0_LI
        else
           istat = 3
           lreact = IERROR
        endif
 
     else
 
        istat = 3
        lreact = IERROR
 
     endif
 
  else
     istat = 2
     lreact = IERROR
  endif
 
  if(lreact.eq.IZERO) then
 
     btsigv = ZERO
 
  else if(lreact.eq.IERROR) then
 
     btsigv = ERROR
 
  else
 
     if(irtype.eq.CX) then
 
        call cx_warmtarget_sigmatimesv(lreact, eabeam, tatarg, btsigv, n)
 
     else if(irtype.eq.EAV) then
 
        call cx_energyavg_peramu(lreact, eabeam, tatarg, btsigv, n)
 
     else if(irtype.eq.FD) then
 
        call cx_average_vdotnorm(lreact, eabeam, tatarg, btsigv, n)
 
     else if(irtype.eq.II) then
 
        call ii_warmtarget_sigmatimesv(lreact, eabeam, tatarg, btsigv, n)
 
     endif
 
  endif
 
end subroutine hatom_btsigv

      subroutine vmsieee(lun_warn,zvals,ilim,ufieee,ieee)
c
c     just copy the numbers
c
c  overflow/underflow check provided.
c
      integer lun_warn                  ! LUN for warning messages
      integer ilim
      real zvals(ilim)                  ! data to convert or recover
      real ufieee(ilim)                 ! converted data (ieee format)
      integer ieee                      ! =1:  convert to ieee
c                                       ! =0:  convert from ieee back
      iwarnuf=0
      iwarnof=0
c
      do i=1,ilim
         if(ieee.eq.1) then
C
C  convert to ieee
C  check for over/underflow
C
            if(zvals(i).ne.0.0) then
               if(abs(zvals(i)).lt.1.1754945e-38) then
                  zvals(i)=0.0
                  if((iwarnuf.eq.0).and.(lun_warn.gt.0)) then
                     write(lun_warn,
     >                  '('' %ubwfcmp:  underflow warning.'')')
                     iwarnuf=1
                  endif
               else if(zvals(i).gt.8.4070587e+37) then
                  zvals(i)=8.4070587e+37
                  if((iwarnof.eq.0).and.(lun_warn.gt.0)) then
                     write(lun_warn,
     >                  '('' %ubwfcmp: +overflow warning.'')')
                     iwarnof=1
                  endif
               else if(zvals(i).lt.-8.4070587e+37) then
                  zvals(i)=-8.4070587e+37
                  if((iwarnof.eq.0).and.(lun_warn.gt.0)) then
                     write(lun_warn,
     >                  '('' %ubwfcmp: -overflow warning.'')')
                     iwarnof=1
                  endif
               endif
            endif
            ufieee(i)=zvals(i)
         else
c
c  convert back *from* ieee; no error check
c
            zvals(i)=ufieee(i)
c
         endif
      enddo
c
      return
      end
 

C------------------------------------------------------------------
C  GSCRST - RESTORE PLOT SCALE TO FULL SCALE OF DATA
C   (AS PREVIOUSLY EVALUATED BY A CALL TO GSCSET)
C
      SUBROUTINE GSCRST
C
      INCLUDE 'GAXES_BLK'
C
      INCLUDE 'GSCALE_BLK'
C
C
C  PLOT1 COMMON
C
      INCLUDE 'PLOT1MMX'
C
C  START OF EXECUTABLE CODE
C
      XMIN=GMINX0
      XMAX=GMAXX0
      IF((IXXMAP(IAXSEL).EQ.1).AND.(GMNXP0.GT.0.0)) THEN
        XMIN=GMNXP0
        XMAX=AMAX1(XMAX,1.1*XMIN)
      ENDIF
C
      YMIN=GMINY0
      YMAX=GMAXY0
      IF((IXYMAP(IAXSEL).EQ.1).AND.(GMNYP0.GT.0.0)) THEN
        YMIN=GMNYP0
        YMAX=AMAX1(YMAX,1.1*YMIN)
      ENDIF
C
      RETURN
      END

!-----------------------------------------------------------------------
!  ALAD_ELIM -- FETCH ENERGY LIMITS OF CROSS SECTION FIT
!
SUBROUTINE ALAD_ELIM(ZEMIN,ZEMAX,IER)
  use iso_c_binding, only: fp => c_double
  use alpcom_mod
  use alcom_mod
  implicit none
!
!  OUTPUT
!   ZEMIN = LOWER LIMIT OF FIT, EV/AMU
!   ZEMAX = UPPER LIMIT OF FIT, EV/AMU
!
!   IER   = 0 IF SUCCESSFUL RETURNING THE FIT LIMITS
!
!-------------------------------------------------------------------
!
  integer ier
  real(fp) ZEMIN,ZEMAX
!
  IER=0
!
  IF(BL(NBL) .EQ. '#MEWE') THEN
     ZEMIN=0.0_fp
     ZEMAX=1.e+38_fp
  ELSE IF(BL(NBL) .EQ. '#BELI') THEN
     ZEMIN=CF(1)
     ZEMAX=1.e+38_fp
  ELSE IF(BL(NBL) .EQ. '#CHEB') THEN
     ZEMIN=CF(10)
     ZEMAX=CF(11)
  ELSE IF(BL(NBL) .EQ. '#KINGEX') THEN
     ZEMIN=CF(2)
     ZEMAX=CF(3)
  ELSE IF(BL(NBL) .EQ. '#JAN1') THEN
     ZEMIN=CF(1)*1.e-3_fp
     ZEMAX=CF(2)*1.e-3_fp
  ELSE
     WRITE(LUTOUT,&
          '(/'' ALAD_ELIM:  EVALUATION LIMITS NOT AVAILABLE'')')
     IER=1
  ENDIF
!
!------------------------------------
!
  RETURN
!
END SUBROUTINE ALAD_ELIM

C******************** START FILE UF0RDR.FOR ; GROUP UFILS0 ******************
C--------------------------------------------------------------
C  UF0RDR
C  READ SCALAR VALUES AND LABELS FROM INPUT FILE
C  PRINT WARNINGS IF INSUFFICIENT ARRAY SPACE TO READ IN VALUES
C
      SUBROUTINE UF0RDR(ILUN,SCVAL,SCLAB,NDIM,NSC,IER)
C  ILUN-- UNIT ON WHICH TO READ
C  SCVAL-- SCALAR VALUES ARRAY, DATA READ IN
C  SCLAB-- SCALAR LABELS ARRAY, READ IN
C  NDIM-- SIZE OF SCVAL,SCLAB
C    MAKE-UP OF SCLAB-- SEE COMMENTS, S.R. "UF0DRD", ABOVE.
C  NSC-- ACTUAL NUMBER OF SCALARS IN FILE
C  IER-- RETURN CODE =0 FOR SUCCESS;
C    IER=1 IF DUPLICATE KEYWORD DETECTED
C
      USE UFILES
C
      REAL SCVAL(*)
      CHARACTER*30 SCLAB(*),ZBUFL
C
C------------------------------------------------------------
C
      IF(NSC.LE.0) RETURN
      ICHAN=IUXCHA(ILUN)
      KMPRS=UFCPRS(ICHAN)
      if(kmprs.eq.-1) then
         write(ufelun,'('' ?UF0RDR:  MDS+ read not supported.'')')
         go to 9000
      endif
C
      IF(NDIM.LT.NSC) THEN
        WRITE(UFELUN,9001)
 9001   FORMAT(' % UF0RDR WARNING-- NOT ENOUGH SPACE FOR SCALAR(S):')
      ENDIF
C
      DO 100 ISC=1,NSC
        IF(KMPRS.EQ.1) THEN
          READ(ILUN,ERR=9000,END=9000) ZVAL,ZBUFL
        ELSE IF(KMPRS.EQ.0) THEN
          READ(ILUN,3019,ERR=9000,END=9000) ZVAL,ZBUFL
 3019     FORMAT(1X,1PE11.4/1X,A30)
        else if (kmprs.eq.2) then
          call ubrfcmp(ilun,zval,1,ier)
          if(ier.ne.0) go to 9000
          call ubrchar(ilun,zbufl,ier)
          if(ier.ne.0) go to 9000
        ENDIF
C
C  CAPITALIZE KEYWORD FIELD
C
        CALL UF0CAP(ZBUFL(1:10))
C
        IF(ISC.GT.NDIM) THEN
          WRITE(UFELUN,9002) ZVAL,ZBUFL
 9002     FORMAT(3X,'VALUE=',1PE11.4,'   LABEL="',A30,'"')
        ELSE
          SCVAL(ISC)=ZVAL
          SCLAB(ISC)=ZBUFL
        ENDIF
 100  CONTINUE
C
      IER=0
      RETURN
C
C---------------------
C  ERROR EXIT
C
 9000 CONTINUE
      IER=1
      RETURN
C
      END
C******************** END FILE UF0RDR.FOR ; GROUP UFILS0 ******************

C-----------------------------------------------------------------------
C  IOPEN -- collection of OPEN statements
C   this routine should not be called directly -- call via subroutine
C   GENOPEN -- the calling arguments are explained there.
C     argument checking is done in GENOPEN.
C
      integer function IOPEN(lun,fname,fstat,ftype,irecsz)
C
      integer lun          ! logical unit number
      character*(*) fname  ! file name
      character*(*) fstat  ! file status 'OLD' or 'NEW'
      character*(*) ftype  ! file type 'ASCII' 'BINARY' or 'DIRECT'
      integer irecsz       ! record size ('DIRECT' files only)
C
      ISTAT=0
C
C           the IOSTAT=ISTAT expression is used in the OPEN
C    statements to capture the error status of the OPEN operation, and
C    this is returned as the function value to the caller.
C
      inb=index(fname,' ')-1
      if(inb.le.0) inb=len(fname)
C
C
      if(ftype.eq.'ASCII') then
C
        if(fstat.eq.'OLD') then
C
          OPEN(unit=lun,file=fname(1:inb),status='OLD',action='READ',
     >            IOSTAT=ISTAT)
C
        else
C
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',IOSTAT=ISTAT)
C
        endif
C
      else if(ftype.eq.'BINARY') then
C
        if(fstat.eq.'OLD') then
C
          OPEN(unit=lun,file=fname(1:inb),status='OLD',action='READ',
     >            access='SEQUENTIAL',form='UNFORMATTED',
     >            IOSTAT=ISTAT)
C
        else
C
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',form='UNFORMATTED',
     >            IOSTAT=ISTAT)
C
        endif
C
      else if(ftype.eq.'DIRECT') then
C
        if(fstat.eq.'OLD') then
C
          OPEN(unit=lun,file=fname(1:inb),status='OLD',action='READ',
     >            access='DIRECT',recl=irecsz,
     >            IOSTAT=ISTAT)
C
        else
C
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='DIRECT',recl=irecsz,
     >            IOSTAT=ISTAT)
C
        endif
C
C
      else if(ftype.eq.'BLOCKD') then
C
        if(fstat.eq.'OLD') then
C
          OPEN(unit=lun,file=fname(1:inb),status='OLD',action='READ',
     >            access='SEQUENTIAL',recl=irecsz,
     >            form='UNFORMATTED',IOSTAT=ISTAT)
C
        else
C
          OPEN(unit=lun,file=fname(1:inb),status=fstat,
     >            access='SEQUENTIAL',recl=irecsz,
     >            form='UNFORMATTED',IOSTAT=ISTAT)
C
        endif
C
      endif
C
      IOPEN=ISTAT
C
      return
      end

subroutine frantic_get_se(zf)
  
  !  get the electron source to the plasma due to ionization of neutrals
  !  #/m**3/sec

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,SORE(1:nzonec),zf,0)

  return
end subroutine frantic_get_se

subroutine frantic_get_seb(zf)
  
  !  get the electron source to the fast ion population (leading to a
  !  fast neutral source) ... #/m**3/sec

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,TSTOR1(1:nzonec,1),zf,0)

  return
end subroutine frantic_get_seb

subroutine frantic_get_scx(zf)
  
  !  get the charge exchange reaction rate  #/m**3/sec 

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,SCX(1:nzonec),zf,0)

  return
end subroutine frantic_get_scx

subroutine frantic_get_pcx(zf)
  
  !  get the charge exchange power  W/m**3  lost to ions

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,PCX(1:nzonec),zf,0)

  return
end subroutine frantic_get_pcx

subroutine frantic_get_pii(zf)
  
  !  get the ionization source power  W/m**3  to ions

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,PII(1:nzonec),zf,0)

  return
end subroutine frantic_get_pii

subroutine frantic_get_tqcx(zf)
  
  !  get the charge exchange torque density  Nt-m/m**3  lost to ions

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,TQCX(1:nzonec),zf,0)

  return
end subroutine frantic_get_tqcx

subroutine frantic_get_tqii(zf)
  
  !  get the ionization source torque density  Nt-m/m**3  to ions

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,TQII(1:nzonec),zf,0)

  return
end subroutine frantic_get_tqii

subroutine frantic_get_pcxsf(zf)
  
  !  get the charge exchange source friction  W/m**3 to ions

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,PCXSF(1:nzonec),zf,0)

  return
end subroutine frantic_get_pcxsf

subroutine frantic_get_piisf(zf)
  
  !  get the ionization source friction  W/m**3 to ions

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,PIISF(1:nzonec),zf,0)

  return
end subroutine frantic_get_piisf


subroutine frantic_get_n0(ik,zf)
  
  !  for neutral species 'ik'
  !  get the neutral density #/cm**3

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  integer, intent(in) :: ik               ! neutral specie index
  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  if(ik.eq.0) then
    zf=0
  else
    call frantic_intrp_out(zconv,DNEUT(1:nzonec,ik)+DCOLD(1:nzonec,ik),zf,1)
  end if

  return
end subroutine frantic_get_n0

subroutine frantic_get_t0(ik,zf)
  
  !  for neutral species 'ik'
  !  get the neutral "temperature", KeV

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  integer, intent(in) :: ik             ! neutral specie index
  real(fp), intent(out) :: zf(nx_user)  ! the output profile.
  real(fp), parameter :: zconv = 1.0_fp ! leave as KeV

  if(ik.eq.0) then
    zf=0
  else
    call frantic_intrp_out(zconv,TNEUT(1:nzonec,ik),zf,1)
  end if

  return
end subroutine frantic_get_t0

subroutine frantic_get_Si(ik,zf)
  
  !  for neutral species 'ik'
  !  get the ionization ion source, #/m**3/sec

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  integer, intent(in) :: ik               ! neutral specie index
  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  if(ik.eq.0) then
    zf=0
  else
    call frantic_intrp_out(zconv,SORI(1:nzonec,ik),zf,0)
  end if

  return
end subroutine frantic_get_Si

subroutine frantic_get_totalSce(ik,zsce)

  !  for neutral species 'ik'
  !  get the total ionization ion source, equiv. flux #/m**2/sec

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  integer, intent(in) :: ik      ! neutral specie index
  real(fp), intent(out) :: zsce

  integer i

  zsce=0
  if(ik.gt.0) then
    do i=1,nzonec
      zsce=zsce+SORI(i,ik)*vol(i)
    end do
    zsce=1.0e4_fp*zsce/(aminor*6.2831853071795862_fp)
  end if

  return
end subroutine frantic_get_totalSce

subroutine frantic_get_Vphi0(ik,zf)
  
  !  for neutral species 'ik'
  !  get the average neutral toroidal velocity, m/sec

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  integer, intent(in) :: ik                ! neutral specie index
  real(fp), intent(out) :: zf(nx_user)     ! the output profile.
  real(fp), parameter :: zconv = 1.0e-2_fp ! MKS conversion

  if(ik.eq.0) then
    zf=0
  else
    call frantic_intrp_out(zconv,VPHI0F(1:nzonec,ik),zf,1)
  end if

  return
end subroutine frantic_get_Vphi0

subroutine frantic_get_sflx01(zf)
  
  !  get the total div(influx) of (electrons carried by) neutral atoms
  !  #/m**3/sec 

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,SFLX0M(1,1:nzonec),zf,0)

  return
end subroutine frantic_get_sflx01

subroutine frantic_get_sflx02(zf)
  
  !  get the total div(outflux) of (electrons carried by) neutral atoms
  !  #/m**3/sec 

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,SFLX0M(2,1:nzonec),zf,0)

  return
end subroutine frantic_get_sflx02

subroutine frantic_get_pflx01(zf)
  
  !  get the total div(influx) of (power carried by) neutral atoms
  !  W/m**3

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,PFLX0M(1,1:nzonec),zf,0)

  return
end subroutine frantic_get_pflx01

subroutine frantic_get_pflx02(zf)
  
  !  get the total div(outflux) of (power carried by) neutral atoms
  !  W/m**3

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,PFLX0M(2,1:nzonec),zf,0)

  return
end subroutine frantic_get_pflx02

subroutine frantic_get_tqflx01(zf)
  
  !  get the total div(influx) of (ang. momentum carried by) neutral atoms
  !  Nt-m/m**3

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,TQFLX0M(1,1:nzonec),zf,0)

  return
end subroutine frantic_get_tqflx01

subroutine frantic_get_tqflx02(zf)
  
  !  get the total div(outflux) of (ang. momentum carried by) neutral atoms
  !  Nt-m/m**3

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,TQFLX0M(2,1:nzonec),zf,0)

  return
end subroutine frantic_get_tqflx02

subroutine frantic_get_tqflx0(zf)
  
  !  get the total div(flux) of momentum of neutral atoms
  !  Nt-m/m**3

  !  for legacy reasons, return of the combined flux is offered for momentum
  !  only...

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,TQFLX0(1:nzonec),zf,0)

  return
end subroutine frantic_get_tqflx0

subroutine frantic_get_vsor_Z(zf)

  !  get the total volume neutral source * Z  #/m^3/sec

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,vsor_zw(1:nzonec),zf,0)

  return
end subroutine frantic_get_vsor_Z

subroutine frantic_get_vsor_en(zf)

  !  get the total volume neutral energy source  W/m^3

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,vsor_en(1:nzonec),zf,0)

  return
end subroutine frantic_get_vsor_en

subroutine frantic_get_vsor_mo(zf)

  !  get the total volume neutral ang. momentum source   Nt-m/m^3

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: zf(nx_user)    ! the output profile.
  real(fp), parameter :: zconv = 1.0e6_fp ! MKS conversion

  call frantic_intrp_out(zconv,vsor_mo(1:nzonec),zf,0)

  return
end subroutine frantic_get_vsor_mo

subroutine frantic_get_dvol(dvols)

  !  return the volume elements on the user grid

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  real(fp), intent(out) :: dvols(nx_user)  ! returned in m^3
  real(fp), parameter :: zconv = 1.0e-6_fp ! MKS conversion

  integer :: ix

  do ix=1,nx_user
    dvols(ix) = (volxb_user(ix+1)-volxb_user(ix))*zconv
  end do

  return
end subroutine frantic_get_dvol

!----------------------------------------------------------------
!  interpolation routine
!

subroutine frantic_intrp_out(zconv,fdata,zf,imethod)

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero
  use ezspline_type, only: ezspline1
  use ezspline_obj, only: ezspline_preinit
  use ezspline, only: ezspline_init, ezspline_free, ezspline_setup, ezspline_interp
  use frantic_module
  implicit none

  !  use Hermite interpolation to map data to the user specified grid

  real(fp), intent(in) :: zconv          ! MKS conversion factor
  real(fp), intent(in) :: fdata(nzonec)  ! data on FRANTIC grid, to interpolate
  real(fp), intent(out) :: zf(nx_user)   ! interpolation results
  integer, intent(in) :: imethod       ! method flag

  !  imethod=0: Spline interpolate integral of profile; take derivative.
  !     (this method guarantees preservation of ptcl/momentum/energy balance).
  ! 
  !  imethod=1: take log of profile, Hermite interpolate, exponentiate result.
  !  imethod=2: direct Hermite interpolation.

  !--------------------

  type(ezspline1) :: zspline

  real(fp) :: zfbuf(nzonec+2),zfbufi(nzonec+1),ztest,zfloor,zlim1,zlim2
  real(fp) :: zfi(nxb_user)

  integer :: i,iok

  !--------------------

  if(imethod.eq.0) then

    zfbufi(1)=0
    do i=1,nzonec
      zfbufi(i+1)=zfbufi(i)+(tvol(i+1)-tvol(i))*fdata(i)
    end do

  else if(imethod.eq.1) then

    ! sanity check, if using log/exp method

    ztest=maxval(fdata)
    if(ztest.le.ZERO) then
      zf=ZERO
      return
    end if

    zfloor=1.0e-30_fp*ztest

    zfbuf(2:nzonec+1)=log(max(zfloor,fdata))

  else if(imethod.eq.2) then

    zfbuf(2:nzonec+1)=fdata

  end if

  call ezspline_preinit(zspline)  ! made a difference to the pathscale compiler
  if(imethod.eq.0) then

    ! form cubic spline of integral

    call ezspline_init(zspline,nzonec+1,(/1, 0/),iok)
    if(iok.ne.0) call errmsg_exit(' ?frantic_output: ezspline_init error.')
    zspline%bcval1min = 0  ! df/dx -> 0 on axis
    zspline%x1 = xb(1:nzonec+1)

    call ezspline_setup(zspline,zfbufi,iok)
    if(iok.ne.0) call errmsg_exit(' ?frantic_output: ezspline_setup error.')

    ! do the interpolation of the integral function

    call ezspline_interp(zspline,nxb_user,xb_user,zfi,iok)
    if(iok.ne.0) call errmsg_exit(' ?frantic_output: ezspline_interp error.')

    ! release spline memory

    call ezspline_free(zspline,iok)
    if(iok.ne.0) call errmsg_exit(' ?frantic_output: ezspline_free error.')

    ! compute user results

    do i=1,nx_user
      zf(i)=(zfi(i+1)-zfi(i))/(volxb_user(i+1)-volxb_user(i))
    end do

  else if(imethod.gt.0) then

    ! axial extrapolation

    if(imethod.eq.1) then
      zlim1=zfbuf(2)-0.2_fp
      zlim2=zfbuf(2)+0.2_fp
    else
      zlim1=min(1.1_fp*zfbuf(2),0.9_fp*zfbuf(2))
      zlim2=max(1.1_fp*zfbuf(2),0.9_fp*zfbuf(2))
    end if

    ztest=1.125_fp*zfbuf(2)-0.125_fp*zfbuf(3)
    zfbuf(1)=max(zlim1,min(zlim2,ztest))

    ! edge extrapolation

    if(imethod.eq.1) then
      zlim1=zfbuf(nzonec+1)-1.0_fp
      zlim2=zfbuf(nzonec+1)+1.0_fp
    else
      zlim1=min(2.0_fp*zfbuf(nzonec+1),0.5_fp*zfbuf(nzonec+1))
      zlim2=max(2.0_fp*zfbuf(nzonec+1),0.5_fp*zfbuf(nzonec+1))
    end if

    ztest=1.5_fp*zfbuf(nzonec+1)-0.5_fp*zfbuf(nzonec)
    zfbuf(nzonec+2)=max(zlim1,min(zlim2,ztest))

    ! form Hermite Spline

    call ezspline_init(zspline,nzonec+2,(/1, 0/),iok)
    if(iok.ne.0) call errmsg_exit(' ?frantic_output: ezspline_init failure.')
    zspline%bcval1min = 0  ! df/dx -> 0 on axis
    zspline%x1(2:nzonec+1) = x
    zspline%x1(1)=xb(1)
    zspline%x1(nzonec+2)=xb(nzonec+1)
    zspline%isHermite = 1

    call ezspline_setup(zspline,zfbuf,iok)
    if(iok.ne.0) call errmsg_exit(' ?frantic_output: ezspline_setup failure.')

    ! do the interpolation

    call ezspline_interp(zspline,nx_user,x_user,zf,iok)
    if(iok.ne.0) call errmsg_exit(' ?frantic_output: ezspline_interp failure.')

    ! release spline memory

    call ezspline_free(zspline,iok)
    if(iok.ne.0) call errmsg_exit(' ?frantic_output: ezspline_free failure.')

    ! re-exponentiate data if necessary

    if(imethod.eq.1) zf=exp(zf)

  end if

  ! units conversion

  zf=zf*zconv

  return
end subroutine frantic_intrp_out

subroutine frantic_get_outflux(ik, zflux, zengy)

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  ! get outflux rate and average energy for species 'ik'

  integer, intent(in) :: ik       ! neutral specie index
  real(fp), intent(out) :: zflux    ! outflux rate (#/m**2/sec)
  real(fp), intent(out) :: zengy    ! average energy (KeV/ptcl)

  if(ik.eq.0) then
    zflux=0
    zengy=0
  else
    zflux=outflx(ik)*1.0e4_fp
    zengy=0.001_fp*eescav(ik)/(1.602e-19_fp)
  end if

  return
end subroutine frantic_get_outflux

subroutine frantic_get_inps(zfluxi)

  use iso_c_binding, only: fp => c_double
  use frantic_module
  implicit none

  ! edge source: return the influx across the boundary, in #atoms/sec
  ! return ZERO for volume source

  real(fp), intent(out) :: zfluxi

  !--------------------
  integer :: ik,ink,iz,ix,inx
  real(fp), dimension(:), allocatable :: dvols,sflx1
  !--------------------

  if(vsflag) then
    zfluxi=0.0_fp
    return
  end if

  ik=nneut_s0
  if(ik.eq.0) then
    zfluxi=0.0_fp
    return
  end if

  ink=nspec(ik)
  iz=xzplas(ink)+0.1_fp

  call frantic_get_nx_user(inx)
  allocate(dvols(inx),sflx1(inx))

  call frantic_get_dvol(dvols)

  call frantic_get_sflx01(sflx1)

  zfluxi=0.0_fp

  do ix=1,inx
    zfluxi = zfluxi + dvols(ix)*sflx1(ix)
  end do

  zfluxi=zfluxi/iz

  deallocate(dvols,sflx1)

  return
end subroutine frantic_get_inps

C******************** START FILE UF1DWR.FOR ; GROUP UFILES *************
C--------------------------------------------------------------
C  UF1DWR
C  COMPRESS AND WRITE 1-DIMENSIONAL DATA TO ASCII FILE
C
 
      SUBROUTINE UF1DWR(ILUN,IDEV_I,ZSDATE_I,
     >     X_I,F_I,N,IPROC,
     >     XLAB_I,FLAB_I,
     >     NSC,SCVAL,SCLAB_I,
     >	   IER)
 
 
C  Updated:
C  10/22/01 CAL - support MDS+
C  08/05/97 CAL - Add HDF
C  08/24/93 TBT - New format E13.6 - UFAHED2.
C
C  ILUN-- LOGICAL UNIT NUMBER ON WHICH TO WRITE
C  IDEV-- TOKAMAK DEVICE -- (4 LETTERS) "PDX ","PLT ", ETC.
C  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
C  X(N),F(N)-- REAL NUMERIC DATA TO BE WRITTEN
C      F[X]-- X THE INDEPENDENT, F THE DEPENDENT VARIABLE
C  IPROC-- PROCESS CODE: 0 = "RAW" DATA,
C     1 = AVERAGED (OVER SEVERAL SHOTS)
C     2 = SMOOTHED
C     3 = AVERAGED AND SMOOTHED
C  XLAB-- 30 CHARACTER LABEL FOR X
C   FIRST 20 CHARACTERS-- NAME OF X
C   LAST 10 CHARACTERS--  PHYSICAL UNITS OF X
C     E.G. XLAB = 'MAJOR RADIUS        CM        '
C  FLAB-- 30 CHARACTER LABEL FOR Y - SAME FORMAT AS XLAB
C  NSC-- NUMBER OF SCALAR QUANTITIES ASSOCIATED WITH DATA TO WRITE
C         NOTE NSC = 0 **IS** ALLOWED; THEN THE FOLLOWING ARE DUMMIES:
C  SCVAL(NSC)-- LIST OF SCALAR QUANTITIES (REAL NOS.)
C  SCLAB(NSC) CHARACTER*30 LIST OF 30 CHARACTER KEYWORD/LABELS
C
C*  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
C
C* DENOTES OUTPUT VARIABLE
 
      USE UFILES
      implicit none
C
      character*(*) IDEV_I,ZSDATE_I,xlab_i(3),flab_i(3)
      CHARACTER*30 SCLAB_I(*)
C
      integer ilun,  n,     nsc
      REAL X_I(N),F_I(N),SCVAL(*)
      CHARACTER*10 ZSDATE,ZDATE
      CHARACTER*30 XLAB,FLAB,SCLAB(max(1,nsc))
      CHARACTER*4 IDEV
      Integer Iformat
      integer l
      integer ilnurd
 
      integer ier,   idim,  kmprs, iproc, iflag, ierh, ilu, iluj
      integer ierr,  ierrw, iendw, ichan, jproc
      real    ztol
C
      real, dimension(:), allocatable :: x,f
C
C$r8real_input: x_i,f_i,scval
C--------------------------------------------------------------------
C  dmc -- guard against ieee underflows... to prevent problems downstream
c
      call ufck_reset
      allocate(x(n),f(n))
      call ufck_under(ufelun,'x',x_i,x,n)
      call ufck_under(ufelun,'f',f_i,f,n)
c
C--------------------------------------------------------------------
C  standardize labels
C
      call ufsc_lbck(zsdate_i,zsdate,idev_i,idev,sclab_i,sclab,nsc)
      if(len(xlab_i(1)).ne.10) then
         call uf_lbck('xlab',xlab_i,xlab)
      else
         call uf_lbck('xlab',xlab_i(1)//xlab_i(2)//xlab_i(3),xlab)
      endif
      if(len(flab_i(1)).ne.10) then
         call uf_lbck('flab',flab_i,flab)
      else
         call uf_lbck('flab',flab_i(1)//flab_i(2)//flab_i(3),flab)
      endif
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF1DWR    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.1) THEN
        CALL UERSTA(ICHAN,'UF1DWR    ')
        GO TO 9000
      ENDIF
C
C  CHANNEL STATUS OK
C
      IDIM=1
      CALL C9DATE(ZDATE)
      KMPRS=UFCPRS(ICHAN)
      if(kmprs.eq.-1) then
         write(ufelun,'('' ?UF1DWR:  MDS+ write '')')
         l=index(mds_node(ichan),' ')-1
         call add1duf(ufelun,mds_node(ichan)(1:l),
     >        x,f,n,iproc,
     >        n,iflag,xlab,flab,
     >        nsc,nsc,scval,sclab,ier)
         if (ier .eq. 0) then
            call uf_fin(ufelun,mds_node(ichan)(1:l),IDEV,ZDATE,
     >           iproc,ier)
            if (ier .eq. 0) go to 1000
         endif
         go to 9000
      endif
C
C  ** MOD ** DMC APR 1984.
C  ALL WRITES SWITCHED ON KMPRS-- SUPPORT COMPRESSED BINARY FORMAT
C
      IF(KMPRS.EQ.0) THEN
        CALL UFAHED2(ILUN,UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE,
     >      1,Iformat,IERH)
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE
      else if(kmprs.eq.2) then
        call ufbhed(ilun,ufshot(ichan),idev,idim,kmprs,zdate,zsdate,
     >                1,ierh)
C      else if (kmprs.eq.3) then
C         call uhdfhed(ILUN,UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE,1,
C     >      IERH)
      else if (kmprs.eq. 4) then
         call ucdfhed(ILUN,UFSHOT(ICHAN),IDEV,IDIM,KMPRS,ZDATE,ZSDATE,1,
     >      IERH)
      ENDIF
C
C    WRITE THE ASSOCIATED SCALARS
      CALL UF0WRT(ILUN,SCVAL,SCLAB,NSC,IER)
      IF(IER.NE.0) GO TO 9000
C
      IF(KMPRS.EQ.0) THEN
        WRITE(ILUN,3003) XLAB
 3003 FORMAT(1X,A30,T32,';-INDEPENDENT VARIABLE LABEL-')
C
        WRITE(ILUN,3004) FLAB
 3004 FORMAT(1X,A30,T32,';-DEPENDENT VARIABLE LABEL-')
C
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) XLAB,FLAB
      else if(kmprs.eq.2) then
        call ubwchar(ilun,xlab)
        call ubwchar(ilun,flab)
C HDF ?
C      else if (kmprs .eq. 3) then
C         call uhdf1w(ilun, f, x, n, iproc,
C     >                 flab, xlab, ier)
C         if (ier .ne. 0) go to 9000
C netCDF ?
      else if (kmprs .eq. 4) then
         call ucdf1w(ilun, f, x, n, iproc,
     >                 flab, xlab, ier)
         if (ier .ne. 0) go to 9000
      ENDIF
C
      IF(KMPRS.EQ.0) THEN
        jproc=max(0,min(9,iproc))
        WRITE(ILUN,3006) jproc
 3006 FORMAT(1X,I1,T32,';-PROC CODE- 0:RAW 1:AVG 2:SM. 3:AVG+SM')
C
        WRITE(ILUN,3007) N
 3007 FORMAT(1X,I10,T32,';-# OF PTS-  X, F(X) DATA FOLLOW:')
      ELSE IF(KMPRS.EQ.1) THEN
        WRITE(ILUN) IPROC,N
      else if(kmprs.eq.2) then
        call ubw3int(ilun,iproc)
        call ubw3int(ilun,n)
      ENDIF
C----
C  NOW THE DATA ...
C
      LFCLUN=.FALSE.
      if(kmprs.eq.2) then
         call ubcpwr(ilun,x,'x',n,1,1,n,1)
         call ubcpwr(ilun,f,'f',n,1,1,n,1)
      else IF(KMPRS.EQ.1) THEN
C--------------------------------------/ * COMPRESSED DATA   WRITES * /
C ERROR LOG FILE--
C
         ILUJ=ILNURD(UJUNKA)
         CALL UFOPEN(UFCLUN,UJUNKA(1:ILUJ)//'ZUFCMPRI.ERR',2,IER,0)
         IF(IER.NE.0) GO TO 9000
         LFCLUN=.TRUE.
C
         ZTOL=UFCTOL(ICHAN)
C  CONVERT INDEPENDENT DATA TO INTEGER*2 AND COMPRESS
         CALL UFSTEP(ILUN,X,'X',N,IERR)
         IF (IERR.NE.0) THEN
            CALL UFCPWR(ILUN,X,'X',N,1,1,N,1,ZTOL,IERR)
         ENDIF
C
C  CONVERT DEPENDENT DATA TO INTEGER*2
         CALL UFCPWR(ILUN,F,'F',N,1,1,N,1,ZTOL,IERR)
C
C--------------------------------------/ * UNCOMPRESSED ASCII WRITES * /
C
      ELSE IF(KMPRS.EQ.0) THEN
C
         LFCLUN=.FALSE.
C
         call ufascio(ilun,x,n,'W',iendw,ierrw)
         call ufascio(ilun,f,n,'W',iendw,ierrw)
C
      ENDIF
C
      IF(KMPRS.EQ.0) WRITE(ILUN,3010)
 3010 FORMAT(' ;----END-OF-DATA-----------------COMMENTS:-----------')
C
 1000 IER=0
      UFSTAT(ICHAN)=2
C
C  IF COMPRESSION WARNING ERRORS OCCURRED, SPOOL TO TTY AND OUTPUT FILE
C
      IF(LFCLUN) THEN
        REWIND UFCLUN
        CALL USPOOL(UFCLUN,ILUN)
        CLOSE(UNIT=UFCLUN,STATUS='DELETE')
      ENDIF
C
      go to 9999
C----------
C  ERRORS
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ? DATA NOT WRITTEN DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      IER=1
      UFSTAT(ICHAN)=2
C
 9999 continue
      deallocate(x,f)
      RETURN
      	END
C******************** END FILE UF1DWR.FOR ; GROUP UFILES ***************

      subroutine ufopen_mds(ichan,ishot,ier,option)
C
C History:
C 10/17/01 CAL: Extracted from ufoprd
C 11/05/01 CAL: Handle TRANSP/Beast
C
C  open MDS+ tree
C
      use UFILES
      implicit none
C
      integer ichan		! Ufiles channel (set by caller, UFOPRD)
      integer ishot		! Shot number (of tree to open)
      integer ier		! (output) completion code, 0 = normal
      integer option            ! 1 = read
C
      integer       ilnurd     ! vaxonly
C
      character*128 zerrmsg
      character*128 znode
      character*128 zserver
      integer       irank
      integer       istat, ilm, ilt, ils, iln
      integer       try,   l,   m1,  m2,  m3,  notree, fnf
C for mdsplus
      integer       MdsSetSocket, mdsfconnect, MdsValue
      integer       mds_open,      mds_value
      integer       dsc,idescr_long
      integer       mdsstat, size,   pulse
      character*100 expr
      character*10  cshot
C
C      notree = -1882091606
#ifndef __NAGWARE
      notree = '8fd18faa'x    ! MDSplus NoTree
#else
      notree = -1882091606
#endif
      fnf    = 98962          ! MDSplus FileNotFound
C-----------------------------------------------------
C  open MDS+ signal; test accessibility.
C
C  steps:  1.  set server
C          2.  open tree
C          3.  fetch signal -- test by accessing rank of signal
C
C 02/01/01: CAL
C If negative ishot: called from trdat or mds_rdwr: Don't connect / open tree
C it's already open
C If ier = 77: called from trdat: mds_socket is not available
C              trdat = TRDATA  --vs-- UFILES
C
      if (ishot .lt. 0) then   ! Tree already open
         if (ier .ne. 77) then
            istat = MdsSetSocket(mds_socket(ichan))
         endif
         ier=0
         go to 2000
      endif
C
C Check if already connected
      ier=0
      if (mds_socket(ichan) .ne. 0) then
         istat = MdsSetSocket(mds_socket(ichan))
      else
C  step 1:  connect to SERVER
         istat = MdsSetSocket(-1)     ! save current setting
         ils=max(1,len_trim(mds_server(ichan)))
         if (mds_server(ichan)(1:ils) .ne. 'local' .and.
     >        mds_server(ichan)(1:ils) .ne. 'LOCAL') then
            write(ufelun,
     >           '('' %UFOPEN_MDS:  connecting to MDS+ server:  '',a)')
     1           mds_server(ichan)(1:ils)
            zserver=mds_server(ichan)(1:ils)
            zserver(ils+1:ils+1) = char(0)
            istat=mdsfconnect(zserver)
            if(istat.lt.0) then
               write(ufelun,9001) mds_server(ichan)(1:ils)
 9001          format(
     1         ' %UFOPEN_MDS:  mdsfconnect:  failed to connect to ',a)
               ier=1
               go to 1000
            endif
            mds_socket(ichan) = istat
            istat = MdsSetSocket(mds_socket(ichan))  ! set new connection
         else
            mds_socket(ichan) = -1
         endif
      endif
C
C  step 2:  open TREE
C
      try = 0
      ilt=max(1,len_trim(mds_tree(ichan)))
C
C If ufile is from TRANSP run .INPUTS, ishot is not mds pulse number
      if(mds_shot(ichan).ne.0) then
          pulse=mds_shot(ichan)
      else
          pulse=ishot
      endif
C
C If Read: open readonly
C -----------------------
      if (option .eq. 1) then
          if (ufdir(ichan)(1:5) .eq. 'PPPL@') then
C Standard TRANSP tree
C ufdir = 'PPPL@<tok.yr>@<runid>
C 01/25/07 CLF: this is obsolete - convert runid to pulse
              m1=index(ufdir(ichan)(6:),'.')+6
              m2=index(ufdir(ichan)(6:),'@')+6
              m3=index(ufdir(ichan),' ')-1
              call mkbeastid(ufdir(ichan)(m2:m3),pulse,cshot)
              if (pulse .gt. 0) then
                 mds_shot(ichan) = pulse
              else
                 ier=1
                 write(ufelun,'('' ?UFOPEN_MDS: error converting '',
     &                 a)') ufdir(ichan)(m2:m3)
                 return
              endif
           endif
C all other Trees
           write(ufelun,'('' %UFOPEN_MDS:  opening tree '',a,
     >          '' shot '',i10)') mds_tree(ichan),pulse
           istat=mds_open(mds_tree(ichan)(1:ilt),pulse)
           if(mod(istat,2).ne.1) then
              call ufmds_err('UFOPEN_MDS',istat,ier,zerrmsg,ilm)
              write(ufelun,9002) mds_tree(ichan)(1:ilt),
     >             zerrmsg(1:ilm)
 9002         format('  while opening MDS+ tree:  ',a/2x,a)
              ier=1
              go to 1000
           endif
 
C
C If write: open tree for edit
C-----------------------------
      else if (option .eq. 2) then
          write(cshot,'(i10)',iostat=ier) pulse
 2001     expr = 'tcl("EDIT '//mds_tree(ichan)(1:ilt) //
     >          '/SHOT=' //cshot// '")' // CHAR(0)
          l=ilnurd(expr)
          print*, '...',expr(1:l)
          mdsstat=0
          dsc = idescr_long(mdsstat)
          istat = MdsValue(expr, dsc, 0, size)
          if (mod(istat,2).ne.1) go to 9000
          if(mod(mdsstat,2).ne.1) then
              if (try .eq. 0 .and.
     >        (mdsstat .eq. notree .or. mdsstat .eq. fnf)) then
C     if tree does not exist create it:
C
C Set Tree:
                  dsc = idescr_long(mdsstat)
                  expr = 'tcl("SET TREE ' // mds_tree(ichan)(1:ilt) //
     >            '")' // CHAR(0)
                  l=ilnurd(expr)
                  print*, '...',expr(1:l)
                  istat = MdsValue(expr, dsc, 0, size)
                  if(mod(istat,2).ne.1) go to 9000
                  if(mod(mdsstat,2).ne.1) go to 9100
C Create it:
                  expr = 'tcl("CREATE PULSE ' // cshot// '")' // CHAR(0)
                  l=ilnurd(expr)
                  print*, '...',expr(1:l)
                  mdsstat=0
                  dsc = idescr_long(mdsstat)
                  istat = MdsValue(expr, dsc, 0, size)
                  if(mod(istat,2).ne.1) go to 9000
                  if(mod(mdsstat,2).ne.1) go to 9100
                  try = try+1
                  go to 2001
              else
                  go to 9100
              endif
          endif                 ! end create pulse
      endif                     ! end open for write
 
C
 
C
 2000 continue
C
C Read:
C     step 3:  get nodename, test by requesting rank of node
      if (option .eq. 1) then
         call ufsnmd_nod0(mds_path(ichan),mds_node(ichan),znode,iln)
         call ufmds_rank(znode(1:iln),irank,ier)
         if(ier.eq.1) go to 1000
         UFSTAT(ICHAN)=3           ! ready for read
C Write:
      else if (option .eq. 2) then
         UFSTAT(ICHAN)=1           ! ready for write
      endif
C
 1000 continue
      UFSHOT(ICHAN)=abs(ishot)
      return
C Errors:
 
 9000 ier=1
      call mdsmsg(ufelun,'%ufopen_mds: '//expr(1:l)//' istat:  ',istat)
      go to 1000
C
 9100 ier=1
      call ufmds_err('UFOPEN_MDS',mdsstat,ier,zerrmsg,ilm)
      write(ufelun,9003) expr(1:l), zerrmsg(1:ilm)
 9003 format('  while opening MDS+ tree:  ',a/2x,a)
      go to 1000
 
 
      end
 
C******************** END FILE UFOPEN_MDS.FOR ; GROUP UFILES ******************
 
 
 

C******************** START FILE UPAUST.FOR ; GROUP UPAUST *************
C---------------------------------------------------------------
C&  UPAUST UREAD TTY DEPENDENT PAUSE AFTER ERROR MESSAGE OR GRAPH
C
C  USER INTERFACE - UPAUST
C  WITH HHT TERMINAL ROUTINES INBETWEEN
C
      SUBROUTINE UPAUST(ICALL0)
C
C  ICALL=0  ACCEPT CARRIAGE RETURN AFTER ERROR MESSAGE
C  ICALL=1  DITTO - THEN CLEAR SCREEN(S)
C  ICALL=2  CALL UPAUST TO ACCEPT CHAR. AFTER GRAPH AND CLEAR PAGE
C
C
      USE USERIO
C
      ICALL=ICALL0
      IF(NTTYP.LT.0) ICALL=0
C
      IF(.NOT.NLUINI) CALL USINIT
      IF(ICALL.GE.2) THEN
C
C  AFTER A GRAPH DISPLAY ...
C
        CALL UPAUSE(0)       ! get user input
        CALL UPAUCH(IUCHAR)  ! get the character the user typed...
C
        UPCHAR=CHAR(IUCHAR)
        CALL USPCAP(UPCHAR)
C
        CALL FINITT(0,0)
C
        NCLEAR=0
        CALL NEUPAG
C
        call f90_delay_r4(0.2,zflops)  ! avoid problems with some XTERMs...
C
      ELSE
C
C  ... AFTER AN ERROR MESSAGE ...
C  HHT PAGE CLEAR AFTER USER HITS CR (INTERACTIVE MODE)
C  OR DO NOTHING - BATCH MODE
C
        IF((IBATCH.EQ.0).and.(.NOT.NLJAVA)) THEN
          CALL UACKNL
          IF(ICALL.EQ.1) THEN
            NCLEAR=0
            CALL NEUPAG
          ENDIF
        ENDIF
      ENDIF
C
      RETURN
      END
C******************** END FILE UPAUST.FOR ; GROUP UPAUST ***************

      INTEGER FUNCTION LKUPR(X,TABLE,N)
C
C Look up a real number X in a TABLE of length N.
C returns the value lkupr such that:
C
C	table(lkupr) <= x < table(lkupr+1)
C
C assumes that table is in increasing order and does a binary search.
C
      REAL X,TABLE(N)
C
C========================================UPPER CASE & PRETTY PRINT RTM MAY 1988
C
      IF(X .LT. TABLE(1))THEN
          LKUPR=0
          GO TO 70000		!DONE
      ENDIF
C
      IF(X .GE. TABLE(N))THEN
          LKUPR=N
          GO TO 70000		!DONE
      ENDIF
C
      N1=1
      N2=N
C
100   CONTINUE	!LOOK AGAIN LOOP
C
      N3=(N2+N1)/2
C
      IF(X .GE. TABLE(N3))THEN
          N1=N3
      ELSE
          N2=N3
      ENDIF
C
      IF(N2 .EQ. N1+1)THEN
          LKUPR=N1
          GO TO 70000	    !DONE
      ELSE
          GOTO 100	    !LOOK AGAIN
      ENDIF
 
70000 CONTINUE	!All returns from here
C
      RETURN
      END

!-----------------------------------------------------------------------
!  PSGHOX -- CROSS SECTION OF O+8 + H --> O+7 + H+
!
real(fp) FUNCTION psghox8(ZE)
!
! INPUT
!  ZE -- COLLISION ENERGY **PER NUCLEON**  EV/AMU
!
! OUTPUT
!  PSGHOX -- CROSS SECTION, CM**2
!
! REFERENCE
!  ORNL-6090/V5, ATOMIC DATA FOR FUSION, VOLUME V,
!    "COLLISIONS OF CARBON AND OXYGEN IONS WITH ELECTRONS, H, H2, & He"
!    R.A. PHANEUF, R.K. JANEV, M.S. PINDZOLA
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) ze,emin,emax,zans,psgchvx8
!============
  real(fp) CCHEV(9)
!
  DATA EMIN/1.5e+2_fp/
  DATA EMAX/2.2e+5_fp/
!
  DATA CCHEV/&
       -6.75708e+01_fp,-7.44247e-01_fp,-1.31873_fp,&
       -4.39377e-01_fp,-3.84417e-01_fp,-1.57858e-01_fp,&
       -8.06534e-02_fp,-6.45421e-03_fp, 1.21750e-02_fp/
  !
  ZANS=psgchvx8(1,ZE,EMIN,EMAX,CCHEV)
  psghox8=ZANS
!
  RETURN
END FUNCTION psghox8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

C******************** START FILE UFEMSG.FOR ; GROUP UFILS0 ******************
C--------------------------------------------------------------------
C  UFEMSG
C   SET ERROR MESSAGE OUTPUT LEVEL
C    =-LUN  *NEW FEB 1986*  IF A NEGATIVE NUMBER IS SPECIFIED,
C      IT IS ASSUMED TO BE THE LUN FOR A FILE TO RECEIVE ALL UFILES
C      INFORMATIONAL AND ERROR MESSAGES; UPAUST CALL IS TURNED OFF
C      ALL MESSAGES ARE TURNED ON
C      *CALLER RESPONSIBILITY TO OPEN A FILE ON UNIT LUN*
C
C    =0:  TURN OFF SWITCHABLE ERROR MESSAGES *** USER BEWARE
C       NOTE, ONLY "FILE NOT FOUND" AND "SHOT NO. INCORRECT" ARE
C       SWITCHABLE.
C    =1:  ALL MESSAGES ** BUT NO UPAUST CALL
C    =2: (DEFAULT) ALL MESSAGES, AND UPAUST REQUIRING TTY INPUT
C        TO ACKNOWLEDGE ERROR, IF JOB IS RUNNING AT A TTY.
C
C
      SUBROUTINE UFEMSG(IARG)
C
      USE UFILES
C
      CALL UFINIT
C
      IF(IARG.GE.0) THEN
        ILEV=IARG
C
C  ONES DIGIT OF UFILEV IS INFORMATIONAL MESSAGE FLAG
C  TENS DIGIT OF UFILEV IS ERROR MESSAGE FLAG
C
C  SET TENS DIGIT
C
        UFILEV=UFILEV - 10*(UFILEV/10) + 10*ILEV
C
      ELSE
        UFILEV=11
        UFELUN=-IARG
      ENDIF
C
      RETURN
      END
C******************** END FILE UFEMSG.FOR ; GROUP UFILS0 ******************

      subroutine ufmds_size2(znode,zbuf,nbuf,zx,nxmax,
     >     nxact,ntact,iskip1,xlab,
     >     ier)
C
      use UFILES
C
C  this routine (called from uf2drd) deals with a situation where a 2d
C  MDS+ structure is accessed which has the structure
C
C  f(nx,nt) varies vs. x & t, but the shape of x is (nx,nt), i.e. the
C  x axis as well as f also varies with t.
C
C  (this is typical e.g. of TRANSP output when the geometry of the
C  experiment is time varying -- i.e. usually).
C
C  Since Ufiles cannot represent the t variation of x, a fallback must
C  be taken;  this is either
C
C    1) replace x with x @t0 only, if x is not "really" changing with t
C    2) replace x with the index vector [1,2, ..., nx] if x really does
C      have time variation.
C
C    in either case a warning message will be displayed, and the iskip1
C  flag will be set.  in the 2nd case the label "xlab" is also changed.
C
C---------------------------------
C History:
C 11/18/99 CAL: new calling arguments for mds_value
C
C---------------------------------
C
C  arguments:
C
      character*(*) znode       ! MDS+ path to signal (input)
      real zbuf(nbuf)           ! buffer to hold time varying x axis
      real zx(nxmax)            ! x axis data (may be set here)
C
      integer nxact             ! x axis size to be used
      integer ntact             ! t axis size
C
      integer iskip1            ! set =1 if x axis has been set here
      character*30 xlab         ! x label:  modified if x redefined as index
C
      integer ier               ! completion code  0 = normal
C
C---------------------------------
C
      character*128 zerrmsg
 
      integer     idescr_long, iretl
      save    itot
C      volatile    itot
C
C---------------------------------
C
C  executable code
C
      ier=0
      iskip1=0
C
      iln=index(znode,' ')-1
      if(iln.le.0) iln=len(znode)
C
      istat=mds_value('size('//znode(1:iln)//')',
     1      idescr_long(itot),iretl)
C
      if(mod(istat,2).ne.1) then
         call ufmds_err('UFMDS_SIZE2',istat,ier,zerrmsg,ilm)
         write(ufelun,9508) znode(1:iln),zerrmsg(1:ilm)
 9508    format('  seeking size of MDS+ signal: ',a/2x,a)
      endif
      if(ier.ne.0) go to 9000
C
C  sizes of dimensions
C
      call ufmds_size(znode(1:iln),1,inumx,ier)
      if(ier.ne.0) go to 9000
C
      call ufmds_size(znode(1:iln),2,inumy,ier)
      if(ier.ne.0) go to 9000
C
      itest=0
      if(min(inumx,inumy,itot).le.0) then
         itest=-1               ! error
      else if((inumx*inumy).eq.itot) then
         itest=1                ! traditional situation
      else if((inumx.eq.itot).and.((itot/inumy)*inumy.eq.itot)) then
         itest=2                ! x varies as fcn of t
C  further tests on x
         irankx=0
         istat=mds_value('rank(dim_of('//znode(1:iln)//',0))',
     >        idescr_long(irankx),iretl)
         if((mod(istat,2).ne.1).or.(irankx.ne.2)) then
            write(ufelun,9509) istat,irankx
 9509       format('?UFMDS_SIZE2:  checking rank of x coordinate:'/
     >           '  istat=',i10,' rank=',i3)
            itest=-2
         else
            call ufmds_size('dim_of('//znode(1:iln)//',0)',2,inumy2,ier)
            if(ier.ne.0) go to 9000
            if(inumy2.ne.inumy) then
               write(ufelun,9511) inumy,inumy2
 9511          format(
     >              ' ?UFMDS_SIZE2:  coordinates shapes inconsistent:'/
     >              '  size(2nd_dim(function data)) = ',i6/
     >              '  size(2nd_dim(1st_dim data))  = ',i6)
               itest=-3
            endif
         endif
      endif
C
      if(itest.le.0) then
         write(ufelun,9520) inumx,inumy,itot
 9520    format(
     >' ?UFMDS_SIZE2:  inconsistent or unanticipated signal component ',
     >'sizes:'/'  nx=',i6,' ny=',i6,' itot=',i8)
         ier=1
      else if(itest.eq.1) then
C  traditional situation:  x axis and t axis are independent
         nxact=inumx
         ntact=inumy
         ier=0
      else
C  x depends on t -- must read and analyze dependence.
         nxact=itot/inumy
         ntact=inumy
         iskip1=1
         ier=0
C
C  if buffer size is exceeded, this will be caught by caller (uf2drd)
         if(itot.gt.nbuf) go to 9000
C
         call ufmds_read('dim_of('//znode(1:iln)//',0)',zbuf,itot,ier)
         if(ier.ne.0) go to 9000
C
         call ufmds_svck(zbuf,nxact,ntact,idif,xlab)
C
         if(idif.eq.0) then
            do ix=1,nxact
               zx(ix)=zbuf(ix)
            enddo
         else
            write(ufelun,9550)
 9550       format(
     >' %UFMDS_SIZE2:  1st independent coordinate not independent'/
     >           '  of 2nd independent coordinate ==> 1st coordinate'/
     >           '  REPLACED with grid index specifier.')
            do ix=1,nxact
               zx(ix)=float(ix)
            enddo
            xlab='grid index          index     '
         endif
      endif
C
 9000 continue
      return
      end
C
C-------------------------
C
      subroutine ufmds_svck(zbuf,inx,iny,idif,xlab)
C
C  compare rows of array for near-equality
C  return idif=1 if different, idif=0 if identical
C
      real zbuf(inx,iny)
C
      character*(*) xlab
C
C-----------------------------
C
      idif=0
C
C  use 1.0e-6 x (the max modulus of the first row of elements)
C  as a minimum difference criterion
C
      iascend=1
      zmindif=1.0e-35
      do ix=1,inx
         zmindif=max(zmindif,1.0e-6*abs(zbuf(ix,1)))
         if(ix.gt.1) then
            if(zbuf(ix,1).le.zbuf(ix-1,1)) iascend=0
         endif
      enddo
C
      do iy=2,iny
         do ix=1,inx
            zdif=abs(zbuf(ix,iy)-zbuf(ix,1))
            if(zdif.gt.zmindif) then
               idif=1
               go to 100
            endif
         enddo
      enddo
C
C  no differences -- if btw 0 and 1 this is "almost certainly" a
C  TRANSP flux surface x axis -- add some code to detect this case.
C
      if((iascend.eq.1).and.(idif.eq.0)) then
         if(xlab.eq.'(dim 0)') then
            zxmin=zbuf(1,1)
            zxmax=zbuf(inx,1)
            if((0.0.le.zxmin).and.(zxmin.le.1.0)) then
               zdx=1.0/float(inx)
               zdx2=0.5*zdx
C
               if(abs(zdx-zxmin).le.zmindif) then
                  if(abs(1.0-zxmax).le.zmindif) then
                     xlab='xb'
                  endif
               else if(abs(zdx2-zxmin).le.zmindif) then
                  if(abs((1.0-zxmax)-zdx2).le.zmindif) then
                     xlab='x'
                  endif
               endif
            endif
         endif
      endif
C
 100  continue
      return
      end
 

subroutine hhb_resis(zneCM3i,zteEVi,zzeffi, &
     deltai,lpolCM,philimWB,rho,dVdrhoCM3,xiotb,vacRBphiTCM, &
     eta_spitzer,eta_nc,iwarn)

  ! 0d CGS implementation of resistivity calculation
  ! This is HHB resistivity as used in TRANSP, magcor/resis.for

  ! Reference:S. P. Hirshman, R. J. Hawryluk, B. Birge,
  ! Nucl. Fusion 17, 611 (1977). ("HHB")).

  ! All information passed through arguments; no modules or COMMON
  ! REAL*8 precision

  ! implemented in TRANSP/NTCC comput library
  ! reference to real(fp) function cloge_r8_fcn, also in comput library

  !----------------------------
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, twopi
  implicit none

  real(fp), parameter :: xmu = 1.25664E-6_fp

  !----------------------------
  ! arguments:

  real(fp) :: zneCM3i  ! electron density, cm**-3, iwarn=1 set if .le. 1 ptcl/cm3
  real(fp) :: zteEVi   ! electron temperature, eV, iwarn=1 set if .le. 1 eV
  real(fp) :: zZeffi   ! Zeff; iwarn=1 set if .le.1

  ! if iwarn=1 is set, a non-zero resistivity is still returned, but it is
  ! likely to be rubbish

  ! for the following, iwarn=2 is set and zero resistivity is returned, if
  ! any of these arguments are zero or negative

  real(fp) :: deltai   ! inverse aspect ratio r/R
  real(fp) :: LpolCM   ! poloidal path length, cm
  real(fp) :: philimWb ! enclosed toroidal flux at plasma boundary, Wb
  real(fp) :: rho      ! flux surface label: sqrt(PhiWB/PhilimWB) where
  ! phiWB is the enclosed toroidal flux at the rho surface
  real(fp) :: dVdrhoCM3    ! dVol/drho at the flux surface, cm**3
  real(fp) :: xiotb    ! iota(bar) = 1/q = dPsi/dPhi
  real(fp) :: vacRBphiTCM  ! toroidal field (R*B_phi) at vacuum boundary, T*cm

  ! output...

  real(fp), intent(out) :: eta_spitzer  ! Spitzer resistivity, Ohm*cm
  real(fp), intent(out) :: eta_nc   ! HHB neoclassical resistivity, Ohm*cm

  integer, intent(out) :: iwarn   ! warning flag, 0=normal

  !----------------------------
  !  local variables (several names taken from TRANSP's magcor/resis.for)

  real(fp) :: zneCM3,zteEV,zZeff

  real(fp) :: cloge_r8_fcn,cloge

  real(fp) :: zgamm,zconst

  real(fp) :: zbpav,zcuror

  real(fp) :: zvstae,zcr,zxi,zd1m,zft,zfmn,zfnc,zte32i

  integer :: jwarn

  !----------------------------

  iwarn = 0
  eta_spitzer = ZERO
  eta_nc = ZERO

  ! check plasma parameter inputs

  if(znecm3i.lt.ONE) then
    zneCM3=ONE
    iwarn=1
  else
    zneCM3=znecm3i
  endif

  if(zteevi.lt.ONE) then
    zteEV=ONE
    iwarn=1
  else
    zteEV=zteevi
  endif

  if(zzeffi.lt.ONE) then
    zZeff=ONE
    iwarn=1
  else
    zZeff=zzeffi
  endif

  ! check field and geometry inputs

  if(deltai.le.ZERO) iwarn=2
  if(LpolCM.le.ZERO) iwarn=2
  if(PhilimWb.le.ZERO) iwarn=2
  if(rho.le.ZERO) iwarn=2

  if(dVdrhoCM3.le.ZERO) iwarn=2
  if(xiotb.le.ZERO) iwarn=2
  if(vacRBphiTCM.le.ZERO) iwarn=2

  if(iwarn.eq.2) return

  !----------------------------------
  ! OK-- get electron Coulomb log

  cloge = cloge_r8_fcn(zneCM3,zteEV,zZeff,jwarn)

  !----------------------------------
  ! Spitzer resistivity

  !  for traditional (HHB) form of Spitzer resistivity
  ZGAMM=ZZEFF*0.581_fp*(2.67_fp+ZZEFF)/(1.13_fp+ZZEFF)
  zconst=5.22E-3_fp

  zte32i = ONE/(zteEV*sqrt(zteEV))

  eta_spitzer = zconst*cloge*ZGAMM*zte32i

  !----------------------------------
  ! NC resistivity 

  ! use Bpol volume average
  ! Bpol = (1/R)*grad(Psi) = (1/R)*grad(rho)*dPsi/drho
  !    dPsi/drho = xiotb*rho*PhilimWb/pi
  ! <Bpol> = [2pi*int(dl*R/grad(rho)*Bpol]/dVdrho
  !        =  2*Lpol*xiotb*rho*PhilimWb/dVdrho

  zBPAV = PhilimWB*2.E4_fp*rho*xiotb*LpolCM/dVdrhoCM3

  ! this formulation uses
  ! mu0*Ip = 2pi*r*<Bpol>; zcuror = Ip/r = 2pi*<Bpol>/mu0; convert to Amps/cm

  zcuror = TWOPI*zBPAV/(100.0_fp*XMU)

  ! code transcribed from magcor/resis.for

  ZVSTAE=3.46E-9_fp*zneCM3*cloge*vacRBPHITCM/(zcuror*zteEV*zteEV*sqrt(deltai))
  ZCR=0.56_fp*(3.0_fp-ZZEFF)/((3.0_fp+ZZEFF)*ZZEFF)
  ZXI=0.58_fp+0.2_fp*ZZEFF
  ZD1M=ONE-deltai
  ZFT=ONE-ZD1M*ZD1M/(SQRT(ONE-deltai*deltai)*(ONE+1.46_fp*SQRT(deltai)))
  ZFMN=ZFT/(ONE+ZXI*ZVSTAE)
  ZFNC=ONE/((ONE-ZFMN)*(ONE-ZCR*ZFMN))

  eta_nc = ZFNC*eta_spitzer

  return
end subroutine hhb_resis

      subroutine jaceval(DR0DRO,DRMDRO,DYMDRO,RMSPL,YMSPL,
     >                    ZSNTHTK,ZCSTHTK,NMOM,ZJAC)
c
c  evaluate 2x2 jacobian using moments and derivatives
c    ** symmetric formula **
c
      real rmspl(nmom),ymspl(nmom)
      real dr0dro,drmdro(nmom),dymdro(nmom)
      real zcsthtk(nmom),zsnthtk(nmom)
c
      real zjac(2,2)
c
c--------------------------------
c
      ZJAC(1,1)=DR0DRO
      ZJAC(1,2)=0.0
C
      ZJAC(2,1)=0.0
      ZJAC(2,2)=0.0
C
      DO 150 IMUL=1,NMOM
C
         ZJAC(1,1)=ZJAC(1,1)+DRMDRO(IMUL)*ZCSTHTK(IMUL)
         ZJAC(1,2)=ZJAC(1,2)-RMSPL(IMUL)*IMUL*ZSNTHTK(IMUL)
C
         ZJAC(2,1)=ZJAC(2,1)+DYMDRO(IMUL)*ZSNTHTK(IMUL)
         ZJAC(2,2)=ZJAC(2,2)+YMSPL(IMUL)*IMUL*ZCSTHTK(IMUL)
C
 150  CONTINUE
c
      return
      end
 

      subroutine ubrchcmp(ilun,zchar,ieod,ier)
C
C  read compressed character data.  Subroutine ubcget actually does the
C  decompression.  This routine reads uncompressed data from a buffer and
C  calls ubcget to get more if needed.
C
C  buffer contains data in form <string><DEL><string><DEL>...
C  as a byte stream.  all characters are printable except <DEL>=127 ascii.
C  ascii 9 (horizontal tab) may occur.
C
C  detect end of file (end of data code => set ieod=1)
C
      use UFILES
C
      character*(*) zchar
C
#include "fpreproc/byte_declare.h"
      byte_declare ibyte
      byte_declare eod2
C
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
#ifdef __CRAY
      integer hex2/z'82'/
      eod2 = char(hex2)
#else
      eod2 = -2
#endif
C-----------------------------------------------------
C
      ier=0
C
      CALL UFLCHK(ILUN,'ubwchar   ',ICHAN,IER)
      IF(IER.NE.0) go to 999
C
      ilenz=len(zchar)
C
      ieod=0
C
      iget=0
      if((nchbuf(ichan).le.0).or.(nchbuf(ichan).gt.UFCBUF)) then
         iget=1
      else
         if(uchbuf(nchbuf(ichan),ichan).eq.eod2) then
            iget=1
         endif
      endif
C
      if(iget.eq.1) then
         call ubcget(ichan,ieod)
         if(ieod.eq.1) go to 1000
      endif
C
C  copy string to output
C
      zchar=' '
      ist=nchbuf(ichan)-1
      i=0
 20   continue
      i=i+1
      ist=ist+1
#ifdef __CRAY
      if(uchbuf(ist,ichan).eq. char(127)) then
#else
      if(uchbuf(ist,ichan).eq.127) then
#endif
         nchbuf(ichan)=ist+1
         go to 1000                     ! line feed detected.
      endif
      if(i.gt.ilenz) then
         write(6,'('' ?ubrchcmp:  string too long for passed arg.'')')
         go to 999
      endif
C
#ifdef __CRAY
      zchar(i:i)=uchbuf(ist,ichan)
#else
      zchar(i:i)=char(uchbuf(ist,ichan))
#endif
C
      go to 20
C-------------------
C
 999  continue
      ier=1
C
 1000 continue
      return
      end

C-------------------------------------------------------------------
C  URDCMC  SET UREAD INDIRECT INPUT FILE COMMENT CHARACTER
C
C  UREAD SYSTEM SUBROUTINE
C
C  **BIZARRE SYMPTOMS COULD RESULT IF A BAD CHOICE OF ZCHAR IS MADE
C  BY THE CALLER**
C
C  THE VALUE OF ZCHAR IS NOT CHECKED
C
C--------------------
C
      SUBROUTINE URDCMC(ZCHAR)
C
      USE USERIO
C
      CHARACTER*1 ZCHAR
C
C--------------------
C
      MCOMMT=ZCHAR
      MSEMI=ZCHAR
C
      RETURN
      END

C-----------------------------------------------------------------------
C UVIDEO -- RETURN USER VT100 VIDEO DISPLAY OPTIONS (UREAD)
C
      SUBROUTINE UVIDEO(ILVID,ZCHVID,ICHVID)
C
      USE USERIO
C
      LOGICAL ILVID  ! RETURN .T IF FEATURE IS ENABLED
      CHARACTER*(*) ZCHVID  ! RETURN CHAR STRING OF SETTING
      INTEGER ICHVID  ! RETURN LENGTH OF CHAR STRING SET
C
C  UREAD COMMON:
C
C-----------------------------------------------------------------------
C
      ILVID=NLRVID
C
      ZCHVID=VIDCHS(1:NVIDCH)
      ICHVID=NVIDCH
C
      RETURN
      END

C******************** START FILE UF0DRD.FOR ; GROUP UFILS0 ******************
C--------------------------------------------------------------
C  UF0DRD
C  READ 0-DIMENSIONAL (SCALAR) DATA ASCII FILE
C
      SUBROUTINE UF0DRD(ILUN,IDEV,ZSDATE,
     >     SCVAL,SCLAB,NDIM,NSC,IER)
 

      USE UFILES
        Integer Idim
 
C
C*  ILUN-- LOGICAL UNIT NUMBER ON WHICH TO READ
C  IDEV-- TOKAMAK DEVICE -- (4 LETTERS) "PDX ","PLT ", ETC.
C  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
C  SCVAL-- A SERIES OF NSC SCALAR NUMBERS - DATA TO BE READ
C  SCLAB-- 30 CHARACTER LABEL FOR EACH ELEMENT OF SCVAL
C    E.G. SCVAL = A TIME IN SECONDS, AND
C         SCLAB = "T0:       ","LASER TIME","SECONDS   "
C  THREE-PART LABEL:  FIRST PART= SCALAR IDENTIFICATION KEYWORD
C    (MAX 10 CHARS INCL. DELIMITTING ":")
C    SECOND PART= DESCRIPTIVE LABEL (10 CHARS)
C    THIRD PART= PHYSICAL UNITS LABEL (10 CHARS)
C
C*  NDIM-- DIMENSION OF ARRAYS TO RECEIVE SCALAR VALUES AND LABELS
C  NSC-- THE NUMBER OF SCALAR ELEMENTS (AND ASSOCIATED LABELS)
C     ACTUALLY RETRIEVED FROM FILE
C
C  IER=0 ON RETURN IF READ WAS SUCCESSFUL (RGA, will now be 0 even if there are no scalars)
C
C* DENOTES INPUT VARIABLE
C
      CHARACTER*10 ZSDATE,ZWDATE
      REAL SCVAL(*)
      CHARACTER*30 SCLAB(*)
      CHARACTER*4 IDEV
C
      CHARACTER*64 ERRSTR
C
C$r8real_output: scval
c
      character*128 znode
c
C-----------------------------------------------------------------------
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF0DRD    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.3) THEN
        CALL UERSTA(ICHAN,'UF0DRD    ')
        GO TO 9000
      ENDIF
C
C  CHANNEL STATUS OK
C
C  ** MOD APR 1984 -- SUPPORT BINARY COMPRESSED DATA FORMAT
C    ASCII/BINARY COMPRESSED SWITCH DETERMINED AT OPEN TIME
C
      KMPRS=UFCPRS(ICHAN)
C
      errstr='header check'
C
      nsc    = 0
      idim   = 0
      ikmprs = kmprs
      if(kmprs.eq.-1) then
C----------------------------------------
C  MDS+ data access
C
         call ufmds_rhdr(ichan,idev,zsdate,ishot,idim,znode,iln,
     >        iproc, ier)
         if(ier.eq.1) go to 9000
C
C----------------------------------------
      endif
	
      IF(KMPRS.EQ.0) THEN
        CALL UFAHED2(ILUN,ISHOT,IDEV,IDIM,KMPRS,ZWDATE,ZSDATE,0,
     >      iformat,IERH)
        IF(IERH.NE.0) GO TO 8999
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999)
     >      ISHOT,IDEV,IDIM,IKMPRS,ZWDATE,ZSDATE
        IF((UFILEV-10*(UFILEV/10)).GE.1) WRITE(UFELUN,8001) ZWDATE
 8001   FORMAT(' % READING SCALAR COMPRESSED BINARY DATA WRITTEN ',A)
      ELSE IF(KMPRS.EQ.2) THEN
         call ufbhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
         if(ierh.ne.0) go to 8999
      ENDIF
C
      IF(KMPRS.NE.IKMPRS) THEN
        WRITE(UFELUN,9006) KMPRS,IKMPRS
 9006   FORMAT(' % UF0DRD INTERNAL FLAG ERROR KMPRS, IKMPRS =',
     >2(I2,1X))
      ENDIF
C
C  CHECK SHOT NO.
C
 3002 FORMAT(1X,A10)
      if(lshotn(ichan)) then
         IF(ISHOT.NE.UFSHOT(ICHAN)) THEN
            IF((UFILEV/10).GE.1)
     >          WRITE(UFELUN,9011) ISHOT,UFSHOT(ICHAN)
 9011       FORMAT(
     >  ' % SHOT NUMBER ',I6,' IN FILE NOT SHOT NUMBER ',I6,
     >  ' IN FILENAME')
         ENDIF
      endif
C
C  DIMENSIONALITY WARNING
C
      IF(IDIM.NE.0) THEN
        WRITE(UFELUN,9010) IDIM
 9010   FORMAT(
     >    ' %UF0DRD:  DIMENSIONALITY OF INPUT FILE = ',I1)
      ENDIF
C
C  READ IN THE NUMBER OF SCALARS TO BE READ IN THE FILE
      ERRSTR='ASSOCIATED SCALAR DATA'
      if(kmprs.eq.-1) then
         call ufmds_0rd(ICHAN,SCVAL,SCLAB,NDIM,NSC,znode(1:iln),IER)
         IF(IER.NE.0) GO TO 8999
      else
         CALL UFNSRD(KMPRS,ILUN,NSC,IERR)
         IF(IERR.NE.0) GO TO 8999
         IF(NSC.LE.0) THEN
            if (idim<=0) then
               WRITE(UFELUN,9008)
 9008          FORMAT(' !UF0DRD: NO SCALARS IN 0-D FILE-- NO DATA')
            end if
            NSC=0
            GO TO 3050
         ENDIF
C  READ IN THE SCALARS AND ASSOCIATED LABELS
         CALL UF0RDR(ILUN,SCVAL,SCLAB,NDIM,NSC,IER)
         IF(IER.NE.0) GO TO 8999
C
C READ PAST "--END-OF-DATA--" LINE
         ERRSTR='TRAILER RECORD'
         IF(KMPRS.EQ.0) READ(ILUN,3010,END=8999,ERR=8999) IDUM
 3010    FORMAT(A1)
      endif
C
 3050 continue
      IER=0
      UFSTAT(ICHAN)=5
      RETURN
C
C-------------------------------
C  ERRORS
C
 8999 CONTINUE
      WRITE(UFELUN,9899) ERRSTR
 9899 FORMAT(' ? *FATAL* END OF FILE OR READ ERROR ON UFILE READ:'/
     >    6X,A)
C
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ?UF0DRD: data read error.')
      CALL UFPAUS(1)
      IER=1
      UFSTAT(ICHAN)=5
      RETURN
      END
C******************** END FILE UF0DRD.FOR ; GROUP UFILS0 ******************

C******************** START FILE GSCINI.FOR ; GROUP GSCALE ******************
C-------------------------------------------------------------
C
      SUBROUTINE GSCINI
C
      INCLUDE 'GSCALE_BLK'
C
      COMMON/GRF3PG/ NPAGEC
C
C  CHECK INITIALIZATION FLAG
      IF(IGSINI.EQ.1) RETURN
      IGSINI=1
      XMIN00=0.1
      XMAX00=1.0
      YMIN00=0.1
      YMAX00=1.0
      XRAT00=10.0
      YRAT00=10.0
C
      NOPTX=1
      NOPTY=1
C
      NPAGEC=0
C
      RETURN
      END
C******************** END FILE GSCINI.FOR ; GROUP GSCALE ******************

C----------------------------------------------------------------
C  UFCREC - SET COMPRESSED UFILES RECORD SIZE
C
      SUBROUTINE UFCREC(ISIZE)
C
      USE UFILES
C
      DATA IMIN/64/
C
      CALL UFINIT
      IF((ISIZE.LT.IMIN).OR.(ISIZE.GT.UFMAXR)) GO TO 900
C
      UFRSIZ=ISIZE
      RETURN
C
 900  CONTINUE
      IMAX=UFMAXR
      WRITE(UFELUN,9001) ISIZE,IMIN,IMAX
 9001 FORMAT(
     >' ?UFCREC - ILLEGAL COMPRESSED UFILE RECORD SIZE  ISIZE=',I8/
     >'  MINIMUM=',I8,'  MAXIMUM=',I8)
C
      call bad_exit
      END

C--------------------------------------------------------------
C  URSHOT - CALL UREAD, GET SHOT NUMBER OR OPCODE
C
      SUBROUTINE URSHOT(ZCALLR,ZTRLR,ZOPS,JSHOT,IOP)
C
C  INPUT ARGUMENTS:
C   ZCALLR - CALLER NAME, E.G. "UGRAF2"
C   ZTRLR -- TRAILING STRING IN UREAD PROMPT, ELG. " OR Q TO QUIT:"
C
C   ZOPS --- LIST OF OPCODE CHARACTERS (NON-NUMERIC, PLEASE)
C    WHICH MAY BE SPECIFIED INSTEAD OF SHOT NUMBER
C
C  OUTPUT ARGUMENTS:
C   JSHOT -- SHOT NUMBER READ IN.  VALUE PASSED IN IS *DEFAULT*,
C     RETAINED IF USER TYPES ",".  JSHOT IS CHANGED ONLY IF
C     AN INTEGER DECODE OF USER INPUT IS TRIED
C
C   IOP -- OPCODE.  CLEARED TO ZERO INITIALLY;
C     SET TO CHARACTER LOCATION IN ZOPS MATCHING USER INPUT (IF ANY)
C
      CHARACTER*(*) ZCALLR,ZTRLR
      CHARACTER*(*) ZOPS
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      IL=LEN(ZOPS)
C
 10   CONTINUE
C
      if(jshot.le.999999) then
         IF(LXOUT(0)) WRITE(LNOUT(0),1001) JSHOT
 1001    FORMAT(' [OLD SHOT NO.:  ',I6,'; ENTER "," TO RETAIN]')
      else
         IF(LXOUT(0)) WRITE(LNOUT(0),1002) JSHOT
 1002    FORMAT(' [OLD SHOT NO.:  ',I9,'; ENTER "," TO RETAIN]')
      endif
C
      IOP=0
C
      CALL UREAD(ZCALLR//':  ENTER 5 DIGIT SHOT #'//ZTRLR//'$')
C
      IF(LCHAR(' ').OR.LCHAR(',')) GO TO 100
C
      DO 20 I=1,IL
        IF(ZOPS(I:I).EQ.' ') GO TO 20
        IF(LCHAR(ZOPS(I:I))) THEN
          IOP=I
          GO TO 100
        ENDIF
 20   CONTINUE
C
      ISHOT=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 10
C
C  GOT NEW SHOT NUMBER
C
      JSHOT=ISHOT
C
 100  CONTINUE
C
      RETURN
      END

subroutine bu_eval(lbl3,lbl4,irast)

  ! compute number of additional lines for labels at bottom of graph:
  !   if len(trim(lbl3)) > 60, add 1
  !   if lbl4 non-blank, add 1

  use bottoms_up
  implicit NONE

  character*(*), intent(in) :: lbl3,lbl4
  integer, intent(out) :: irast  ! raster count for raising items

  !------------------------------
  integer :: indx,indx2,ilen,ii,jj
  character*100 ztest
  character*1 :: ztab
  !------------------------------

  ztab = char(9)

  ibu_raise = 0

  ! check lbl3

  ilen = len(trim(lbl3))
  if(ilen.gt.60) then
     ibu_raise = ibu_raise + 1

     ztest = lbl3(1:min(100,ilen))
     call uupper(ztest)
     indx = index(ztest,' VS ')
     indx2 = index(ztest,' VS. ')
     if(indx.gt.0) then
        ibrk_lbl3 = indx
     else if(indx2.gt.0) then
        ibrk_lbl3 = indx2
     else
        ibrk_lbl3 = 60

        ! try to find blank-delimitted breakpoint

        do ii=61,1,-1
           if((lbl3(ii:ii).eq.' ').OR.(lbl3(ii:ii).eq.ztab)) then
              jj=ii
              exit
           endif
        enddo

        do ii=jj-1,1,-1
           if((lbl3(ii:ii).ne.' ').AND.(lbl3(ii:ii).ne.ztab)) then
              ibrk_lbl3=ii
              exit
           endif
        enddo
     endif
  endif

  ! check lbl4

  if(lbl4.ne.' ') then
     ibu_raise = ibu_raise + 1
  endif

  ! raster measure of the raising of lower edge of graph:

  irast = ibu_raise*idybu

end subroutine bu_eval

subroutine bu_reset

  ! reset the data to zero...

  use bottoms_up
  implicit NONE

  ibu_raise = 0
  ibrk_lbl3 = 0

end subroutine bu_reset

C Open a netCDF Ufile
      subroutine cdfopen(lun,name,option,ierr)
C
      use UFILES
      implicit none
C
      include "netcdf.inc"
C
C Input
      integer       lun
      character*(*) name
      integer       option      ! 0 = read / 1 = write
C
      integer ierr
C
      integer file_id, ichan
C
C---------------------------------------------------------------------
C
      call uflchk(lun,'cdfopen',ichan,ierr)
      if (ierr .ne. 0) return
 
      if (option .eq. 1) then   ! write
         file_id=0
         ierr = nf_create(name,NF_CLOBBER,file_id)
         if (ierr .ne. NF_NOERR) then
            write(ufelun,9000) NF_STRERROR(IERR)
 9000       format(' ? CDFOPEN: nf_create '/,'     ',A)
            return
         end if
C
      else if (option .eq. 0) then    ! open for read
         file_id=0
         ierr = nf_open(name,NF_NOWRITE,file_id)
         if (ierr .ne. NF_NOERR) then
            write(ufelun,9001) NF_STRERROR(IERR)
 9001       format(' ? CDFOPEN: nf_open '/,'     ',A)
            return
         end if
      end if
C
      ufid(ichan) = file_id
      return
      end

C******************** START FILE XINTZC.FOR ; GROUP IXCALC ******************
C-----------------------------------------------------------------
C  XINTZC
C
C  INTERPOLATE ZONE BDY FCN TO VALUES AT ZONE CENTER.
C   ONE SLIGHT EXTRAPOLATION AT CENTER-- ASSUME APPROACHING A ZERO
C   RATE OF CHANGE THERE
 
 
      SUBROUTINE XINTZC(FZB,FZC,N)
 
 
C	Updates:
C	tbt 03/08/94 - Changed Zfactor to .125 from .3333333
 
C	-----------------
      REAL FZC(N),FZB(N)
      Real Zfactor
C	-----------------
 
C       EXTRAPOLATION AT CENTER
      Zfactor = .125          ! Was .33333  - for parabolic fit.
 
      FZC(1)=FZB(1)- Zfactor*(FZB(2)-FZB(1))
C
      DO 20 I=2,N
      IM1=I-1
      FZC(I)=0.5*(FZB(IM1)+FZB(I))
 20   CONTINUE
      RETURN
      END
C******************** END FILE XINTZC.FOR ; GROUP IXCALC ******************

C******************** START FILE FLDXTR.FOR ; GROUP URDUTS ******************
C---------------------------------------------------------
C& FLDXTR  UREAD EXTRACT FIELD LIMITS FROM UNPACKED STRING
C
C  SUPPLY UNPACKED STRING ARRAY, SEARCH LIMITS, START AND
C  STOP DELIMITER CHARACTER
C
C  ROUTINE RETURNS LIMITS OF NONBLANK INFO BETWEEN DELIMITERS
C
      SUBROUTINE FLDXTR(DBUFF,ISTART,IFIN,ICHAR1,ICHAR2,ILOC1,ILOC2)
C
      CHARACTER*1 DBUFF(IFIN),ICHAR1,ICHAR2
C
      DO 10 I=ISTART,IFIN
      IF(DBUFF(I).EQ.ICHAR1) GO TO 15
 10   CONTINUE
 15   CONTINUE
      ILOC1=I+1
C
      DO 20 I=IFIN,ISTART,-1
      IF(DBUFF(I).EQ.ICHAR2) GO TO 25
 20   CONTINUE
 25   CONTINUE
      ILOC2=I-1
C
      IF(ILOC2.LT.ILOC1) RETURN
C  DO NOT COUNT EXTERNAL BLANKS
      DO 30 I=ILOC1,ILOC2
      IF(DBUFF(I).NE.' ') GO TO 35
 30   CONTINUE
      I=ILOC2+1
 35   CONTINUE
      ILOC1=I
      IF(ILOC2.LT.ILOC1) RETURN
C
      DO 40 I=ILOC2,ILOC1,-1
      IF(DBUFF(I).NE.' ') GO TO 45
 40   CONTINUE
 45   CONTINUE
      ILOC2=I
      RETURN
      	END
C******************** END FILE FLDXTR.FOR ; GROUP URDUTS ******************

      subroutine ugetpair(zminv,zmaxv,prompt1,prompt2,zval1,zval2,iflag)
C
C  get a pair of numbers, which may have to be distinct.  Both numbers
C  must be in the range (zminv,zmaxv)
C
      real zminv,zmaxv                  ! validity range (input)
      character*(*) prompt1, prompt2    ! prompts for zval1 & zval2 (input)
      real zval1,zval2                  ! values returned (output, default in)
      integer iflag                     ! processing code...
C
C  iflag= 0 -- just get two numbers
C  iflag= 1 -- min/max pair.  require zval1.ne.zval2 and
C     enforce zval1.lt.zval2
C
C--------------------------------------
C
 10   continue
      zloc1=zval1
      zloc2=zval2
      call ugetrng(zminv,zmaxv,prompt1,zloc1)
      call ugetrng(zminv,zmaxv,prompt2,zloc2)
C
      if(iflag.eq.1) then
C
C  enforce min/max rules...
C
         if(zloc1.eq.zloc2) then
            write(lnout(0),1001) zloc1
 1001       format(' %ugetpair:  both values entered as:  ',1pe13.6/
     >         '  distinct values must be entered.')
            call uclear
            go to 10
         endif
         zval1=min(zloc1,zloc2)
         zval2=max(zloc1,zloc2)
      else
C
C  default rule
C
         zval1=zloc1
         zval2=zloc2
      endif
C
      return
      end

 
module periodic_table_mod
  use iso_c_binding, only: fp => c_double
  implicit none

  ! ****** MODIFICATION ******
  ! DMC July 2008 -- "Atomic Mass" outputs in "AMU" are now returned in units of
  ! Proton Mass -- the numerical value is slightly smaller, (1/1.0079) of the AMU
  ! values used by chemists, which are the numbers stored in the periodic table
  ! below.  AMU(Hydrogen)=1.00000 and all other AMUs are scaled accordingly!
  !
  ! RGA June 2013 -- Table represents isotopic average AMU in (u).  Separate subroutine
  ! atom_amu_to_proton() to convert to proton mass while accounting for charge state.
  ! **************************
  !
  ! --- a structure which describes an element ---
  !
  logical :: ignore_user_AMU = .true.      ! change how to handle a user's AMU request.  Should be consistent 
                                           ! with plasma_state_mod::ignore_user_AMU
                                           !   .true. -> old behaviour, ignore user's AMU when the element does not
                                           !             have known isotopes (Z>3)
                                           !   .false.-> allow user AMU for Z>3

  logical :: ignore_electron_AMU = .true.  ! .true. to adjust neutral atom AMU by electron weight

  logical :: ps_params = .true.            ! .true. to use plasma_state compatible parameters, .false. for more accuracy

  type, private :: ELM
    character(len=2) :: symbol   ! symbol for the element
    integer          :: number   ! atomic number of the element
    real(fp)         :: weight   ! isotopic average atomic weight of the element
    integer          :: isoindex ! index of first isotope in isotope list or 0 if none
  end type ELM

  !
  ! --- a structure which describes an isotope ---
  !
  type, private :: ISO
    character(len=2)  :: symbol  ! symbol for the isotope or blank for element symbol
    character(len=13) :: name    ! name for the isotope or blank for element name
    integer           :: number  ! atomic number of the isotope
    real(fp)          :: weight  ! atomic weight of the isotope
  end type ISO

  !
  ! --- parameters ---
  ! http://physics.nist.gov/cuu/Constants/Table/allascii.txt
  !
  real(fp), parameter, private :: electronCharge = 1.602176565e-19_fp    ! (C), also J/eV
  real(fp), parameter, private :: proton_amu     = 1.007276466812_fp     ! (u)
  real(fp), parameter, private :: electron_amu   = 0.000548579909_fp     ! (u)
  real(fp), parameter, private :: neutron_amu    = 1.00866491600_fp      ! (u)
  real(fp), parameter, private :: speedLight     = 2.99792458e8_fp       ! (m/s)
  real(fp), parameter, private :: protonMass     = 1.672621777e-27_fp    ! (kg)

  integer, parameter,private  :: max_elements = 109 ! number of elements

  !
  ! weights are isotopic average in AMU for neutral atom
  !
  type (elm), dimension(max_elements), parameter, private :: elex = (/ &
       elm('Ac', 89,227.0000_fp,0) , elm('Ag', 47,107.8680_fp,0) , elm('Al', 13, 26.9815_fp,0) ,  &
       elm('Am', 95,243.0000_fp,0) , elm('Ar', 18, 39.9480_fp,0) , elm('As', 33, 74.9216_fp,0) ,  &
       elm('At', 85,210.0000_fp,0) , elm('Au', 79,196.9665_fp,0) , elm('B ',  5, 10.8100_fp,0) ,  &
       elm('Ba', 56,137.3400_fp,0) , elm('Be',  4,  9.0122_fp,0) , elm('Bh',107,262.0000_fp,0) ,  &
       elm('Bi', 83,208.9804_fp,0) , elm('Bk', 97,247.0000_fp,0) , elm('Br', 35, 79.9040_fp,0) ,  &
       elm('C ',  6, 12.0110_fp,0) , elm('Ca', 20, 40.0800_fp,0) , elm('Cd', 48,112.4000_fp,0) ,  &
       elm('Ce', 58,140.1200_fp,0) , elm('Cf', 98,251.0000_fp,0) , elm('Cl', 17, 35.4530_fp,0) ,  &
       elm('Cm', 96,247.0000_fp,0) , elm('Co', 27, 58.9332_fp,0) , elm('Cr', 24, 51.9960_fp,0) ,  &
       elm('Cs', 55,132.9054_fp,0) , elm('Cu', 29, 63.5460_fp,0) , elm('Db',105,262.0000_fp,0) ,  &
       elm('Dy', 66,162.5000_fp,0) , elm('Er', 68,167.2600_fp,0) , elm('Es', 99,252.0000_fp,0) ,  &
       elm('Eu', 63,151.9600_fp,0) , elm('F ',  9, 18.9984_fp,0) , elm('Fe', 26, 55.8470_fp,0) ,  &
       elm('Fm',100,257.0000_fp,0) , elm('Fr', 87,223.0000_fp,0) , elm('Ga', 31, 69.7200_fp,0) ,  &
       elm('Gd', 64,157.2500_fp,0) , elm('Ge', 32, 72.5900_fp,0) , elm('H ',  1,  1.0079_fp,2) ,  &
       elm('He',  2,  4.0026_fp,5) , elm('Hf', 72,178.4900_fp,0) , elm('Hg', 80,200.5900_fp,0) ,  &
       elm('Ho', 67,164.9304_fp,0) , elm('Hs',108,265.0000_fp,0) , elm('I ', 53,126.9045_fp,0) ,  &
       elm('In', 49,114.8200_fp,0) , elm('Ir', 77,192.2200_fp,0) , elm('K ', 19, 39.0980_fp,0) ,  &
       elm('Kr', 36, 83.8000_fp,0) , elm('La', 57,138.9055_fp,0) , elm('Li',  3,  6.9410_fp,7) ,  &
       elm('Lr',103,262.0000_fp,0) , elm('Lu', 71,174.9700_fp,0) , elm('Md',101,258.0000_fp,0) ,  &
       elm('Mg', 12, 24.3050_fp,0) , elm('Mn', 25, 54.9380_fp,0) , elm('Mo', 42, 95.9400_fp,0) ,  &
       elm('Mt',109,265.0000_fp,0) , elm('N ',  7, 14.0067_fp,0) , elm('Na', 11, 22.9898_fp,0) ,  &
       elm('Nb', 41, 92.9064_fp,0) , elm('Nd', 60,144.2400_fp,0) , elm('Ne', 10, 20.1790_fp,0) ,  &
       elm('Ni', 28, 58.7000_fp,0) , elm('No',102,259.0000_fp,0) , elm('Np', 93,237.0482_fp,0) ,  &
       elm('O ',  8, 15.9994_fp,0) , elm('Os', 76,190.2000_fp,0) , elm('P ', 15, 30.9738_fp,0) ,  &
       elm('Pa', 91,231.0359_fp,0) , elm('Pb', 82,207.2000_fp,0) , elm('Pd', 46,106.4000_fp,0) ,  &
       elm('Pm', 61,145.0000_fp,0) , elm('Po', 84,209.0000_fp,0) , elm('Pr', 59,140.9077_fp,0) ,  &
       elm('Pt', 78,195.0900_fp,0) , elm('Pu', 94,244.0000_fp,0) , elm('Ra', 88,226.0254_fp,0) ,  &
       elm('Rb', 37, 85.4678_fp,0) , elm('Re', 75,186.2070_fp,0) , elm('Rf',104,261.0000_fp,0) ,  &
       elm('Rh', 45,102.9055_fp,0) , elm('Rn', 86,222.0000_fp,0) , elm('Ru', 44,101.0700_fp,0) ,  &
       elm('S ', 16, 32.0600_fp,0) , elm('Sb', 51,121.7500_fp,0) , elm('Sc', 21, 44.9559_fp,0) ,  &
       elm('Se', 34, 78.9600_fp,0) , elm('Sg',106,263.0000_fp,0) , elm('Si', 14, 28.0860_fp,0) ,  &
       elm('Sm', 62,150.4000_fp,0) , elm('Sn', 50,118.6900_fp,0) , elm('Sr', 38, 87.6200_fp,0) ,  &
       elm('Ta', 73,180.9479_fp,0) , elm('Tb', 65,158.9254_fp,0) , elm('Tc', 43, 97.0000_fp,0) ,  &
       elm('Te', 52,127.6000_fp,0) , elm('Th', 90,232.0381_fp,0) , elm('Ti', 22, 47.9000_fp,0) ,  &
       elm('Tl', 81,204.3700_fp,0) , elm('Tm', 69,168.9342_fp,0) , elm('U ', 92,238.0290_fp,0) ,  &
       elm('V ', 23, 50.9414_fp,0) , elm('W ', 74,183.5000_fp,0) , elm('Xe', 54,131.3000_fp,0) ,  &
       elm('Y ', 39, 88.9059_fp,0) , elm('Yb', 70,173.0400_fp,0) , elm('Zn', 30, 65.3800_fp,0) ,  &
       elm('Zr', 40, 91.2200_fp,0) &
       /)

  character(len=26), parameter, private :: lower  = 'abcdefghijklmnopqrstuvwxyz'
  character(len=26), parameter, private :: upper  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
  character(len=10), parameter, private :: number = '0123456789'

  !
  ! known isotopes of select elements and electron
  ! weights are in AMU for neutral atom
  ! https://en.wikipedia.org/wiki/Isotopes_of_hydrogen
  !
  integer, parameter, private :: max_isotopes = 8

  type (iso), dimension(max_isotopes), parameter, private :: isox = (/ &
       iso('e', 'Electron', -1, 0.000548579909_fp), &   ! 1
       iso('H', 'Hydrogen',  1, 1.00782503207_fp),  &   ! 2
       iso('D', 'Deuterium', 1, 2.0141017778_fp),   &   ! 3
       iso('T', 'Tritium',   1, 3.0160492777_fp),   &   ! 4
       iso('',  '',          2, 3.016029_fp),       &   ! 5  He3
       iso('',  '',          2, 4.002602_fp),       &   ! 6  He4
       iso('',  '',          3, 6.015122_fp),       &   ! 7  Li6
       iso('',  '',          3, 7.016004_fp)        &   ! 8  Li7
       /)

  ! 
  ! element* arrays indexed by atomic number
  !
  integer, dimension(max_elements), private :: element_index = (/ &  ! index into elex array by atomic number
       39,  40,  &
       51,  11,   9,  16,  59,  67,  32,  63,  &
       60,  55,   3,  90,  69,  85,  21,   5,  &
       48,  17,  87,  99, 103,  24,  56,  33,  &
       23,  64,  26, 108,  36,  38,   6,  88,  15,  49,  &
       79,  93, 106, 109,  61,  57,  96,  84,  &
       82,  72,   2,  18,  46,  92,  86,  97,  45, 105,  &
       25,  10,  50,  19,  75,  62,  73,  91,  &
       31,  37,  95,  28,  43,  29, 101, 107,  &
       53,  41,  94, 104,  80,  68,  47,  76,   8,  42, &
       100,  71,  13,  74,   7,  83,  &
       35,  78,   1,  98,  70, 102,  66,  77,  &
       4,  22,  14,  20,  30,  34,  54,  65,  &
       52,  81,  27,  89,  12,  44,  58 &
       /)

  character(len=2), dimension(max_elements), parameter, private :: element = (/ &
       'H ', 'He', &
       'Li', 'Be', 'B ', 'C ', 'N ', 'O ', 'F ', 'Ne', &
       'Na', 'Mg', 'Al', 'Si', 'P ', 'S ', 'Cl', 'Ar', &
       'K ', 'Ca', 'Sc', 'Ti', 'V ', 'Cr', 'Mn', 'Fe', &
       'Co', 'Ni', 'Cu', 'Zn', 'Ga', 'Ge', 'As', 'Se', 'Br', 'Kr', &
       'Rb', 'Sr', 'Y ', 'Zr', 'Nb', 'Mo', 'Tc', 'Ru', &
       'Rh', 'Pd', 'Ag', 'Cd', 'In', 'Sn', 'Sb', 'Te', 'I ', 'Xe', &
       'Cs', 'Ba', 'La', 'Ce', 'Pr', 'Nd', 'Pm', 'Sm', &
       'Eu', 'Gd', 'Tb', 'Dy', 'Ho', 'Er', 'Tm', 'Yb', &
       'Lu', 'Hf', 'Ta', 'W ', 'Re', 'Os', 'Ir', 'Pt', 'Au', 'Hg', &
       'Tl', 'Pb', 'Bi', 'Po', 'At', 'Rn', &
       'Fr', 'Ra', 'Ac', 'Th', 'Pa', 'U ', 'Np', 'Pu', &
       'Am', 'Cm', 'Bk', 'Cf', 'Es', 'Fm', 'Md', 'No', &
       'Lr', 'Rf', 'Db', 'Sg', 'Bh', 'Hs', 'Mt' &
       /)

  character(len=13), dimension(max_elements), parameter, private :: element_name = (/ &
       'Hydrogen     ', 'Helium       ', &
       'Lithium      ', 'Beryllium    ', 'Boron        ', 'Carbon       ', &
       'Nitrogen     ', &
       'Oxygen       ', 'Fluorine     ', 'Neon         ', &
       'Sodium       ', 'Magnesium    ', 'Aluminum     ', 'Silicon      ', &
       'Phosphorus   ', 'Sulfur       ', 'Chlorine     ', 'Argon        ', &
       'Potassium    ', 'Calcium      ', 'Scandium     ', 'Titanium     ', &
       'Vanadium     ', 'Chromium     ', 'Manganese    ', 'Iron         ', &
       'Cobalt       ', 'Nickel       ', 'Copper       ', 'Zinc         ', &
       'Gallium      ', 'Germanium    ', 'Arsenic      ', 'Selenium     ', &
       'Bromine      ', 'Krypton      ', &
       'Rubidium     ', 'Strontium    ', 'Yttrium      ', 'Zirconium    ', &
       'Niobium      ', 'Molybdenum   ', 'Technetium   ', 'Ruthenium    ', &
       'Rhodium      ', 'Palladium    ', 'Silver       ', 'Cadmium      ', &
       'Indium       ', 'Tin          ', 'Antimony     ', 'Tellurium    ', &
       'Iodine       ', 'Xenon        ', &
       'Cesium       ', 'Barium       ', 'Lanthanum    ', 'Cerium       ', &
       'Praseodymium ', 'Neodymium    ', 'Promethium   ', 'Samarium     ', &
       'Europium     ', 'Gadolinium   ', 'Terbium      ', 'Dysprosium   ', &
       'Holmium      ', 'Erbium       ', 'Thulium      ', 'Ytterbium    ', &
       'Lutetium     ', 'Hafnium      ', 'Tantalum     ', 'Tungsten     ', &
       'Rhenium      ', 'Osmium       ', 'Iridium      ', 'Platinum     ', &
       'Gold         ', 'Mercury      ', &
       'Thallium     ', 'Lead         ', 'Bismuth      ', 'Polonium     ', &
       'Astatine     ', 'Radon        ', &
       'Francium     ', 'Radium       ', 'Actinium     ', 'Thorium      ', &
       'Protactinium ', 'Uranium      ', 'Neptunium    ', 'Plutonium    ', &
       'Americium    ', 'Curium       ', 'Berkelium    ', 'Californium  ', &
       'Einsteinium  ', 'Fermium      ', 'Mendeleev    ', 'Nobelium     ', &
       'Lawrencium   ', 'Rutherfordium', 'Dubnium      ', 'Seaborgium   ', &
       'Bohrium      ', 'Hassium      ', 'Meitnerium   ' &
       /)

  interface to_periodic_table
    module procedure to_periodic_table_r4, to_periodic_table_r8
  end interface to_periodic_table
  interface to_pseudo_periodic_table
    module procedure to_pseudo_periodic_table_r4, to_pseudo_periodic_table_r8
  end interface to_pseudo_periodic_table
  interface   name_periodic_table
    module procedure name_periodic_table_r4 ,name_periodic_table_r8
  end interface name_periodic_table
  interface name_pseudo_periodic_table
    module procedure name_pseudo_periodic_table_r4, name_pseudo_periodic_table_r8
  end interface name_pseudo_periodic_table
  interface inv_periodic_table
    module procedure inv_periodic_table_r4,inv_periodic_table_r8 
  end interface inv_periodic_table
  interface inv_pseudo_periodic_table
    module procedure inv_pseudo_periodic_table_r4,inv_pseudo_periodic_table_r8 
  end interface inv_pseudo_periodic_table
  interface standard_amu  
    module procedure  standard_amu_r4, standard_amu_r8
  end interface standard_amu
  interface tr_species_convert  
    module procedure  tr_species_convert_int, tr_species_convert_r8, tr_species_convert_r4
  end interface tr_species_convert

  !private elindex, use_amu
contains
  !
  !
  ! -------------------------- to_periodic_table ---------------------------
  !
  ! this function returns the periodic table symbol for some element,
  ! if there is an error there will be a ? in the first position of
  ! the returned string followed by a short message
  !
  ! examples:    to_periodic_table(6,0,-1,1)       ->  'C           '
  !              to_periodic_table(6,12.0107,-1,1) ->  'C12         '
  !              to_periodic_table(6,0,4,1)        ->  'C+4         '
  !              to_periodic_table(6,12.0107,4,1)  ->  'C12+4       '
  !              to_periodic_table(6,12.0107,14,1) ->  '?Charge>Z   '
  !
  !   z = atomic number -- must be greater than 0
  !   a = atomic weight or 0
  !   charge = charge on element or -1
  !
  function to_periodic_table_r4(z, a, charge, isymbol) result(out)
    implicit none

    integer, intent(in) :: z       ! the atomic number of the element
    real,    intent(in) :: a       ! the atomic weight of the element
    integer, intent(in) :: charge  ! the charge on the element -- ignore if <0
    integer, intent(in) :: isymbol ! symbol to use to separate element name and charge
    ! 0 -> _  this is an underscore
    ! 1 -> +
    character(len=12)       :: out     ! the symbol returned
    character(len=12)       :: swork   ! working character string
    character(len=1)        :: csymbol ! charge symbol
    real(fp) :: aa
    aa=a
    out=to_periodic_table_r8(z, aa, charge, isymbol)
  end function to_periodic_table_r4

  function to_periodic_table_r8(z, a, charge, isymbol) result(out)
    implicit none

    integer, intent(in) :: z       ! the atomic number of the element
    real(fp),    intent(in) :: a       ! the atomic weight of the element
    integer, intent(in) :: charge  ! the charge on the element -- ignore if <0
    integer, intent(in) :: isymbol ! symbol to use to separate element name and charge
    ! 0 -> _  this is an underscore
    ! 1 -> +
    character(len=12)       :: out     ! the symbol returned
    character(len=12)       :: swork   ! working character string
    character(len=1)        :: csymbol ! charge symbol

    if (z<=0) then
      out = '? Z<=0      '
      return
    end if

    if (z>max_elements) then
      out = '?Z too large'
      return
    end if

    out = element(z)   ! form the symbol
    if (a>0) then
      write(swork, '(I6)') nint(a)
      out = trim(out) // trim(adjustl(swork))
    endif


    ! add in charge state
    if (charge>=0) then
      if (charge>z) then
        out = '?Charge>Z   '
        return
      end if
      write(swork, '(I6)') charge
      if (isymbol > 0) then
        csymbol = '+'
      else
        csymbol = '_'   ! this is an underscore
      end if
      out = trim(out) // csymbol // trim(adjustl(swork))
    end if
  end function to_periodic_table_r8

  !
  ! ------------------------- inv_periodic_table -------------------
  !
  ! this subroutine maps a character string returned by the function
  ! to_periodic_table to the atomic number, atomic weight and charge
  ! or zero if the data is unavailable.
  !
  ! examples:   inv_periodic_table('C',    .true.,  z, a, c) -> z=6,  a=12.0110, c=-1
  !             inv_periodic_table('C',    .false., z, a, c) -> z=6,  a=0.,      c=-1
  !             inv_periodic_table('Mg',   .true.,  z, a, c) -> z=12, a=24.3050, c=-1
  !             inv_periodic_table('C12',  .true.,  z, a, c) -> z=6,  a=12.,     c=-1
  !             inv_periodic_table('C+4',  .true.,  z, a, c) -> z=6,  a=12.0110, c=4
  !             inv_periodic_table('C14+4',.true.,  z, a, c) -> z=6,  a=14,      c=4
  !             inv_periodic_table('C14_4',.true.,  z, a, c) -> z=6,  a=14,      c=4
  !             inv_periodic_table('Q+7',  .true.,  z, a, c) -> z=0,  a=0,       c=-1
  !             inv_periodic_table('',     .true.,  z, a, c) -> z=0,  a=0,       c=-1
  !
  subroutine inv_periodic_table_r4(symbol, default, z, a, charge)
    character(len=*), intent(in) :: symbol   ! string containing element (e.g. 'C12+4 ')
    ! must be left justified
    logical, intent(in)       :: default  ! .true. to return an atomic weight (isotopic average) even
    ! if data is not contained in the string

    integer, intent(out) :: z             ! atomic number of the element
    real,    intent(out) :: a             ! atomic weight of the element in amu
    integer, intent(out) :: charge        ! charge state of the element

    character(len=2) :: as     ! atomic symbol in string
    character(len=10) :: zread ! integer read buffer

    integer :: il         ! length of input string without trailing whitespace
    integer :: is         ! length of atomic symbol part in string
    integer :: j1,j2,j    ! temporary indices into element array

    il = len_trim(symbol)     ! length of string
    if (il == 0) goto 10      ! huh?

    ! --- get 2 character symbol id ---
    is = min(il,2)                                  ! length of symbol part
    as = symbol(1:is)                               ! atomic symbol
    if (index(upper,symbol(1:1)) == 0) goto 10      ! first letter is not upper case
    if (il<2 .or. index(lower,symbol(is:is)) == 0) then  ! lowercase second character?
      is=1           ! symbol has only one character
      as(2:2) = ' '  ! make sure padded with space
    end if

    ! --- search for element ---
    j1 = 1
    j2 = max_elements

    do while ((j2-j1)>1)            ! stop when j2=j1+1
      j = (j1+j2)/2                ! binary section search
      if (as<elex(j)%symbol) then  ! alphabetic ordering
        j2=j
      else
        j1=j
        if (as == elex(j1)%symbol) exit  ! exact match
      end if
    end do
    if (as == elex(j1)%symbol) then        ! matches j1,j2 or nothing
      j = j1
    else if (as == elex(j2)%symbol) then
      j = j2
    else
      goto 10     ! not found in list of elements
    end if

    ! --- found element, set defaults ---
    z = elex(j)%number
    charge = -1
    if (default) then
      a = elex(j)%weight   ! isotopic average
    else
      a = 0.
    end if

    ! --- get atomic weight ---
    j1 = is+1        ! first character of atomic weight
    j2 = j1          ! first character after atomic weight
    do while(j2<=il)
      if (index(number,symbol(j2:j2)) == 0) exit  ! character is not a number
      j2 = j2+1
    end do
    if (j1<j2) then
      zread=' '
      zread(10-(j2-j1)+1:10)=symbol(j1:j2-1)
      read(zread,'(i10)') j               ! convert string to atomic weight
      a = j
    end if

    ! --- get charge ---
    if (j2<il) then
      if (symbol(j2:j2) == '+' .or. symbol(j2:j2) == '_') then
        j1 = j2+1  ! first character of charge
        j2 = j1    ! first character after charge
        do while(j2<=il)
          if (index(number,symbol(j2:j2)) == 0) exit ! not a number
          j2 = j2+1
        end do
        if (j1<j2) then
          zread=' '
          zread(10-(j2-j1)+1:10)=symbol(j1:j2-1)
          read(zread,'(i10)') charge
        end if
      end if
    end if

    return  ! ok

    ! ----- error exit ------
10  continue
    z = 0
    a = 0.
    charge = -1

  end subroutine inv_periodic_table_r4

  subroutine inv_periodic_table_r8(symbol, default, z, a, charge)
    character(len=*), intent(in) :: symbol   ! string containing element (e.g. 'C12+4 ')
    ! must be left justified
    logical, intent(in)       :: default  ! .true. to return an atomic weight (isotopic average) even
    ! if data is not contained in the string

    integer, intent(out) :: z             ! atomic number of the element
    real(fp),    intent(out) :: a             ! atomic weight of the element
    integer, intent(out) :: charge        ! charge state of the element

    character(len=2) :: as      ! atomic symbol in string
    character(len=10) :: zread  ! integer read buffer

    integer :: il         ! length of input string without trailing whitespace
    integer :: is         ! length of atomic symbol part in string
    integer :: j1,j2,j    ! temporary indices into element array

    il = len_trim(symbol)     ! length of string
    if (il == 0) goto 10      ! huh?

    ! --- get 2 character symbol id ---
    is = min(il,2)                                  ! length of symbol part
    as = symbol(1:is)                               ! atomic symbol
    if (index(upper,symbol(1:1)) == 0) goto 10      ! first letter is not upper case
    if (il<2 .or. index(lower,symbol(is:is)) == 0) then  ! lowercase second character?
      is=1           ! symbol has only one character
      as(2:2) = ' '  ! make sure padded with space
    end if

    ! --- search for element ---
    j1 = 1
    j2 = max_elements
    do while ((j2-j1)>1)            ! stop when j2=j1+1
      j = (j1+j2)/2                ! binary section search
      if (as<elex(j)%symbol) then  ! alphabetic ordering
        j2=j
      else
        j1=j
        if (as == elex(j1)%symbol) exit  ! exact match
      end if
    end do
    if (as == elex(j1)%symbol) then        ! matches j1,j2 or nothing
      j = j1
    else if (as == elex(j2)%symbol) then
      j = j2
    else
      goto 10     ! not found in list of elements
    end if

    ! --- found element, set defaults ---
    z = elex(j)%number
    charge = -1
    if (default) then
      a = elex(j)%weight    ! isotopic average weight
    else
      a = 0._fp
    end if

    ! --- get atomic weight ---
    j1 = is+1        ! first character of atomic weight
    j2 = j1          ! first character after atomic weight
    do while(j2<=il)
      if (index(number,symbol(j2:j2)) == 0) exit  ! character is not a number
      j2 = j2+1
    end do
    if (j1<j2) then
      zread=' '
      zread(10-(j2-j1)+1:10)=symbol(j1:j2-1)
      read(zread,'(i10)') j               ! convert string to atomic weight
      a = j
    end if

    ! --- get charge ---
    if (j2<il) then
      if (symbol(j2:j2) == '+' .or. symbol(j2:j2) == '_') then
        j1 = j2+1  ! first character of charge
        j2 = j1    ! first character after charge
        do while(j2<=il)
          if (index(number,symbol(j2:j2)) == 0) exit ! not a number
          j2 = j2+1
        end do
        if (j1<j2) then
          zread=' '
          zread(10-(j2-j1)+1:10)=symbol(j1:j2-1)
          read(zread,'(i10)') charge
        end if
      end if
    end if

    return  ! ok

    ! ----- error exit ------
10  continue
    z = 0
    a = 0._fp
    charge = -1

  end subroutine inv_periodic_table_r8

  !
  !
  ! -------------------------- to_pseudo_periodic_table ---------------------------
  ! return the periodic table symbol except the isotopes of hydrogen
  ! are returned as H,D,T and an electron (z<0) is returned as e if ipseudo/=0
  !
  function to_pseudo_periodic_table_r4(ipseudo, z, a, charge, isymbol) result(out)
    implicit none

    integer, intent(in) :: ipseudo ! 0 -> standard periodic table
    ! 1  -> return H,D,T for hydrogen isotopes
    integer, intent(in) :: z       ! the atomic number of the element
    real,    intent(in) :: a       ! the atomic weight of the element
    integer, intent(in) :: charge  ! the charge on the element
    integer, intent(in) :: isymbol ! symbol to use to separate element name and charge
    ! 0 -> _  this is an underscore
    ! 1 -> +
    character(len=12)        :: cout    ! the symbol returned from to_periodic_table
    character(len=12)        :: out     ! the symbol returned
    character(len=12)        :: swork   ! working character string
    real(fp) :: aa
    aa=a
    out=to_pseudo_periodic_table_r8(ipseudo, z, aa, charge, isymbol)
  end function to_pseudo_periodic_table_r4

  function to_pseudo_periodic_table_r8(ipseudo, z, a, charge, isymbol) result(out)
    implicit none

    integer, intent(in) :: ipseudo ! 0 -> standard periodic table
    ! 1  -> return H,D,T for hydrogen isotopes
    integer, intent(in) :: z       ! the atomic number of the element
    real(fp),    intent(in) :: a       ! the atomic weight of the element
    integer, intent(in) :: charge  ! the charge on the element
    integer, intent(in) :: isymbol ! symbol to use to separate element name and charge
    ! 0 -> _  this is an underscore
    ! 1 -> +
    character(len=12)        :: cout    ! the symbol returned from to_periodic_table
    character(len=12)        :: out     ! the symbol returned
    character(len=12)        :: swork   ! working character string

    if (ipseudo/=0 .and. z<0) then
      out = "e"
    else
      cout = to_periodic_table(z, a, charge, isymbol)
      if (ipseudo/=0.and.cout(1:1) == 'H') then
        if (cout(2:2) == '1') then
          out = 'H'//cout(3:12)//' '
        else if (cout(2:2) == '2') then
          out = 'D'//cout(3:12)//' '
        else if (cout(2:2) == '3') then
          out = 'T'//cout(3:12)//' '
        else
          out = cout
        end if
      else
        out = cout
      end if
    end if
  end function to_pseudo_periodic_table_r8


  !
  ! ---------------------- inv_pseudo_periodic_table --------------------
  ! return the inv_periodic_table data where the hydrogen isotopes
  ! are given by H,D,T and an electron is given by e if ipseudo/=0
  !
  subroutine inv_pseudo_periodic_table_r4(ipseudo, symbol, default, z, a, charge)
    implicit none

    integer, intent(in) :: ipseudo        ! 0 -> standard periodic table
    ! 1 -> use H,D,T for hydrogen isotopes, e for electron
    character(len=*), intent(in) :: symbol   ! string containing element (e.g. 'C12+4 ')
    ! must be left justified
    logical, intent(in)       :: default  ! .true. to return an atomic weight even
    ! if data is not contained in the string

    integer, intent(out) :: z             ! atomic number of the element
    real,    intent(out) :: a             ! atomic weight of the element in AMU
    integer, intent(out) :: charge        ! charge state of the element
    integer              :: k             ! isotope number of hydrogen

    character(len=12)           :: out,lsymbol     ! construct a new symbol string
    character(len=3), parameter :: first  = 'HDT'  ! allowed hydrogen first character
    character(len=3), parameter :: second = ' +_'  ! allowed hydrogen second character

    out = symbol              ! copy, length is at least 12
    if (ipseudo/=0) then
      lsymbol = adjustl(out)          ! left justify
      k = index(first,lsymbol(1:1))   ! look for hydrogen

      if (k/=0 .and. index(second,lsymbol(2:2))/=0) then
        if (k==1) then
          out = 'H1'//lsymbol(2:11)
        else if (k==2) then
          out = 'H2'//lsymbol(2:11)
        else
          out = 'H3'//lsymbol(2:11)
        end if
      else if (lsymbol(1:2)=='e ') then
        z = -1
        a = electron_amu
        charge = -1
        return
      end if
    end if
    call inv_periodic_table(out, default, z, a, charge)

  end subroutine inv_pseudo_periodic_table_r4

  subroutine inv_pseudo_periodic_table_r8(ipseudo, symbol, default, z, a, charge)
    implicit none

    integer, intent(in) :: ipseudo        ! 0 -> standard periodic table
    ! 1 -> use H,D,T for hydrogen isotopes, e for electron
    character(len=*), intent(in) :: symbol   ! string containing element (e.g. 'C12+4 ')
    ! must be left justified
    logical, intent(in)       :: default  ! .true. to return an atomic weight even
    ! if data is not contained in the string

    integer, intent(out) :: z             ! atomic number of the element
    real(fp),    intent(out) :: a             ! atomic weight of the element in AMU
    integer, intent(out) :: charge        ! charge state of the element
    integer              :: k             ! isotope number of hydrogen

    character(len=12)           :: out,lsymbol     ! construct a new symbol string
    character(len=3), parameter :: first  = 'HDT'  ! allowed hydrogen first character
    character(len=3), parameter :: second = ' +_'  ! allowed hydrogen second character

    out = symbol              ! copy, length is at least 12
    if (ipseudo/=0) then
      lsymbol = adjustl(out)          ! left justify
      k = index(first,lsymbol(1:1))   ! look for hydrogen

      if (k/=0 .and. index(second,lsymbol(2:2))/=0) then
        if (k==1) then
          out = 'H1'//lsymbol(2:11)
        else if (k==2) then
          out = 'H2'//lsymbol(2:11)
        else
          out = 'H3'//lsymbol(2:11)
        end if
      else if (lsymbol(1:2)=='e ') then
        z = -1
        a = electron_amu
        charge = -1
        return
      end if
    end if
    call inv_periodic_table(out, default, z, a, charge)

  end subroutine inv_pseudo_periodic_table_r8

  !
  ! ----------------------- name_periodic_table --------------
  ! return the name of the element with atomic number 'z' or
  ! a '?' if it is out of bounds -- add atomic weight to end
  ! if a>0
  ! example:
  !    name_periodic_table(20,0)     -> Calcium
  !    name_periodic_table(20,40.08) -> Calcium40
  !
  function name_periodic_table_r4(z,a) result(out)
    integer, intent(in) :: z       ! the atomic number of the element
    real,    intent(in) :: a       ! the atomic weight of the element
    character(len=16)   :: out     ! name of the element
    integer             :: i       ! length of trimmed name
    character(len=3)    :: as      ! a as a string
    real(fp) :: aa
    aa=a
    out= name_periodic_table_r8(z,aa)
  end function name_periodic_table_r4

  function name_periodic_table_r8(z,a) result(out)
    integer, intent(in)  :: z       ! the atomic number of the element
    real(fp), intent(in) :: a       ! the atomic weight of the element
    character(len=16)    :: out     ! name of the element
    integer              :: i       ! length of trimmed name
    character(len=3)     :: as      ! a as a string

    if (z>0 .and. z<=max_elements) then
      out(1:13) = element_name(z)
      out(14:16) = '   '          ! len_trim fails without this
      if (a>0 .and. a<1000) then
        i = len_trim(out)
        write(as,'(I3)') int(nint(a))
        out(i+1:i+3) = adjustl(as)
      end if
    else
      out = "?"
    end if
  end function name_periodic_table_r8


  !
  ! ----------------------- name_pseudo_periodic_table --------------
  ! return the name of the element with atomic number 'z' or
  ! a '?' if it is out of bounds but return Deuterium, Tritium
  ! as appropriate for hydrogen
  ! example:
  !    name_periodic_table(1,20,0)     -> Calcium
  !    name_periodic_table(1,20,40.08) -> Calcium40
  !    name_periodic_table(1,1,1)      -> Hydrogen
  !    name_periodic_table(1,1,2)      -> Deuterium
  !    name_periodic_table(1,1,3)      -> Tritium
  !    name_periodic_table(0,1,3)      -> Hydrogen3
  function name_pseudo_periodic_table_r4(ipseudo,z,a) result(out)
    integer, intent(in) :: ipseudo ! 0 -> standard periodic table
    ! 1 -> use H,D,T for hydrogen isotopes
    integer, intent(in) :: z       ! the atomic number of the element
    real,    intent(in) :: a       ! the atomic weight of the element
    character(len=16)   :: out     ! name of the element
    integer             :: ia      ! a as an integer
    real(fp) :: aa
    aa=a
    out=name_pseudo_periodic_table_r8(ipseudo,z,aa)
    !
  end function name_pseudo_periodic_table_r4

  function name_pseudo_periodic_table_r8(ipseudo,z,a) result(out)
    integer, intent(in) :: ipseudo ! 0 -> standard periodic table
    ! 1 -> use H,D,T for hydrogen isotopes
    integer,  intent(in) :: z       ! the atomic number of the element
    real(fp), intent(in) :: a       ! the atomic weight of the element
    character(len=16)    :: out     ! name of the element
    integer              :: ia      ! a as an integer

    if (z==1 .and. ipseudo>0) then
      ia = nint(a)
      if (ia==1) then
        out = 'Hydrogen'
      else if (ia==2) then
        out = 'Deuterium'
      else
        out = 'Tritium'
      end if
    else
      out = name_periodic_table_r8(z,a)
    end if
  end function name_pseudo_periodic_table_r8

  !
  ! -------------------- elindex -----------------
  ! private function returns the index into elex by atomic number or 0 if not found
  !
  function elindex(z) result(ii)
    integer, intent(in) :: z    ! atomic number
    integer             :: ii   ! index into elex

    integer :: j,kk  ! temp

    ii = 0
    if (z<1 .or. z>max_elements) return     ! z out of range

    kk = element_index(z)
    if (kk>=1 .and. kk<=max_elements) then
      if (elex(kk)%number==z) then         ! already found
        ii = kk
        return
      end if
    end if

    ! search
    do j=1, max_elements
      if (elex(j)%number==z) then
        ii = j
        element_index(z) = j
        return
      end if
    end do
  end function elindex

  !
  ! ------------------------- standard_amu -------------------
  !
  ! this subroutine maps a charge number (z) to the corresponding
  !  atom's standard mass in amu, A; A=0.0 is returned if z is out
  !  of range.
  !
  ! examples:   call standard_amu(6,A)  --> A=12.011  (carbon)
  !             call standard_amu(26,A) --> A=55.847  (iron)
  !
  subroutine standard_amu_r4(z,a) 
    integer, intent(in) :: z     ! atomic number (in)
    real, intent(out) :: a       ! standard atomic mass, amu (out)

    ! -----------------

    real(fp) :: a8

    ! -----------------
    call standard_amu_r8(z,a8)
    a = real(a8)
  end subroutine standard_amu_r4

  subroutine standard_amu_r8(z,a) 
    integer, intent(in) :: z     ! atomic number (in)
    real(fp), intent(out) :: a     ! standard atomic mass, amu (out)

    integer :: kk 

    kk = elindex(z)
    if (kk<1 .or. kk>max_elements) then
      a = 0._fp
    else
      a = elex(kk)%weight
    end if
  end subroutine standard_amu_r8


  !
  ! -------------------- atom_amu_to_proton -------------------
  ! return the mass of an atom in protons -- account for electrons as if it makes a difference
  ! the only thing missing is the binding energy which would need to be added to the result
  !
  function atom_amu_to_proton(z,ich,a) result(p)
    integer, intent(in) :: z    ! atomic number
    integer, intent(in) :: ich  ! charge state of atom
    real(fp),intent(in) :: a    ! atomic weight in amu of neutral atom

    real(fp) :: p               ! mass in protons

    if (ignore_electron_AMU) then
      p = max(0._fp, a/proton_amu)
    else
      p = max(0._fp, (a-max(0,min(ich,z))*electron_amu)/proton_amu)
    end if

    if (z==1 .and. ich==1) then
      p = p + ((13.6_fp*electronCharge)/speedLight**2)/protonMass  ! add hydrogen binding energy
      if (abs(p-1._fp)<2.e-3_fp) then
        p=1.0_fp   ! so hydrogen comes out exactly as 1, would be 1.000074 using H=1.0079 (isotope avg)
        !          or the more physical 0.9999999854548374 using the more accurate H1= 1.00782503207
        !          and finally get      0.9999999999474358 when the binding energy is added
      end if
    end if
  end function atom_amu_to_proton


  !
  ! --------------------- use_amu -------------------
  ! convert the user requested amu to the one which should be used,
  ! set argument a=0. to get the istopic average amu for the element,
  ! return 0. on an error
  !
  function use_amu(z,a) result(u)
    integer,  intent(in) :: z    ! atomic number
    real(fp), intent(in) :: a    ! atomic weight in amu as requested

    real(fp) :: u    ! atomic weight to use

    integer :: kk   ! index into elex array
    integer :: ii   ! index into isox array of first isotope of element
    integer :: i    ! isox index

    real(fp) :: adiff      ! difference between user amu and isotope amu
    real(fp) :: adiff_min  ! minimum adiff encountered so far

    u = 0._fp    ! default in case of error

    if (a<(z*proton_amu-.1_fp)) then
      call standard_amu_r8(z,u)    ! user amu is too small, use isotopic average
    else
      kk = elindex(z)
      if (kk>=1 .and. kk<=max_elements) then
        ii = elex(kk)%isoindex
        if (ii>0) then
          adiff_min = 1.e20_fp
          do i = ii, max_isotopes
            if (isox(i)%number/=z) exit

            adiff = abs(a-isox(i)%weight)

            if (adiff<adiff_min) then
              u = isox(i)%weight         ! best match so far between a and known isotopes
              adiff_min = adiff
            end if
          end do
        else
          if (ignore_user_AMU) then
            call standard_amu_r8(z,u)     ! ignore user AMU, use isotopic average
          else
            u = max(z*proton_amu,a)       ! element does not have known isotopes so use user supplied amu
          end if
        end if
      end if
    end if
  end function use_amu


  SUBROUTINE tr_species_convert_int(iZatom, iZcharge, iAMU, qatom, qcharge, mass, &
       ierr)

    !--------------------------------
    ! D. McCune Dec. 2007
    !    Convert "integer" species specification
    !      {atomic number, ionic charge number, atomic weight in AMU}
    !    to "floating point" representation
    !      {atomic charge (C), ionic charge (C), atomic mass in kg}
    !
    !    If iZatom=-1 provide output quantites for electrons.
    !
    ! ...to be used during initialization of plasma state system at the
    ! start of a simulation...
    !
    !--------------------------------

    integer, intent(in) :: iZatom    ! atomic number: 1 for H, 2 for He, ...
    !  special: -1 for electrons

    integer, intent(in) :: iZcharge  ! ionic charge btw 1 and iZatom
    !  ignored for electrons

    integer, intent(in) :: iAMU      ! atomic weight in AMU, nearest integer

    real(fp), intent(out) :: qatom    ! charge of fully stripped ion
    real(fp), intent(out) :: qcharge  ! actual charge
    real(fp), intent(out) :: mass     ! mass in kg

    real(fp),parameter::  ps_epslon  = 1.0e-34_fp       ! small number
    real(fp),parameter::  ps_epsinv  = 1.0e+34_fp       ! large number
    integer, intent(out) :: ierr     ! status code, 0=OK

    !---------------------------
    integer  :: iq,iqc
    real(fp) :: a, ps_me, ps_mp, ps_xe
    !---------------------------

    ierr = 0

    qatom   = 0.0_fp
    qcharge = 0.0_fp
    mass    = 0.0_fp

    if (ps_params) then
      ps_me  = 9.1094e-31_fp        ! electron mass, kg
      ps_mp  = 1.6726e-27_fp        ! proton mass, kg
      ps_xe  = 1.6022e-19_fp        ! Joule/ptcl-eV (also, electron charge)
    else
      ps_me  = protonMass*(electron_amu/proton_amu)
      ps_mp  = protonMass
      ps_xe  = electronCharge
    end if

    if(iZatom.eq.-1) then
      qatom   = -ps_xe
      qcharge = -ps_xe
      mass    =  ps_me

    else if((iZatom.eq.0).or.(iZatom.lt.-1)) then
      ierr = 1
      ! ' ?tr_species_convert: atomic number iZatom out of range low:', iZatom

    else
      a = use_amu(iZatom, real(iAmu,fp))

      if (a<0.5_fp) then 
        ierr = 2
        !' ?tr_species_convert: atomic number iZatom out of range high:', iZatom

      else
        iq  = iZatom
        iqc = min(iq,iZcharge)

        qatom   = iq*ps_xe
        qcharge = iqc*ps_xe
        mass    = atom_amu_to_proton(iq,iqc,a)*ps_mp
      endif

    endif
  END SUBROUTINE tr_species_convert_int

  SUBROUTINE tr_species_convert_r4(iZatom, iZcharge, zAMU, qatom, qcharge, mass, &
       ierr)

    !--------------------------------
    ! D. McCune Dec. 2007
    !    Convert "integer" species specification
    !      {atomic number, ionic charge number, atomic weight in AMU}
    !    to "floating point" representation
    !      {atomic charge (C), ionic charge (C), atomic mass in kg}
    !
    !    If iZatom=-1 provide output quantites for electrons.
    !
    ! ...to be used during initialization of plasma state system at the
    ! start of a simulation...
    !
    !--------------------------------

    integer, intent(in) :: iZatom    ! atomic number: 1 for H, 2 for He, ...
    !  special: -1 for electrons

    integer, intent(in) :: iZcharge  ! ionic charge btw 1 and iZatom
    !  ignored for electrons

    REAL, intent(in) :: zAMU      ! atomic weight in AMU, nearest integer

    real(fp), intent(out) :: qatom    ! charge of fully stripped ion
    real(fp), intent(out) :: qcharge  ! actual charge
    real(fp), intent(out) :: mass     ! mass in kg

    real(fp),parameter::  ps_epslon  = 1.0e-34_fp       ! small number
    real(fp),parameter::  ps_epsinv  = 1.0e+34_fp       ! large number
    integer, intent(out) :: ierr     ! status code, 0=OK

    !---------------------------
    integer :: iq,iqc
    REAL(fp) :: a, ps_me, ps_mp, ps_xe
    !---------------------------

    ierr = 0

    qatom   = 0.0_fp
    qcharge = 0.0_fp
    mass    = 0.0_fp

    if (ps_params) then
      ps_me  = 9.1094e-31_fp        ! electron mass, kg
      ps_mp  = 1.6726e-27_fp        ! proton mass, kg
      ps_xe  = 1.6022e-19_fp        ! Joule/ptcl-eV (also, electron charge)
    else
      ps_me  = protonMass*(electron_amu/proton_amu)
      ps_mp  = protonMass
      ps_xe  = electronCharge
    end if

    if(iZatom.eq.-1) then
      qatom   = -ps_xe
      qcharge = -ps_xe
      mass    =  ps_me

    else if((iZatom.eq.0).or.(iZatom.lt.-1)) then
      ierr = 1
      ! ' ?tr_species_convert: atomic number iZatom out of range low:', iZatom

    else
      a = use_amu(iZatom, real(zAmu,fp))

      if (a<0.5_fp) then 
        ierr = 2
        !' ?tr_species_convert: atomic number iZatom out of range high:', iZatom

      else
        iq  = iZatom
        iqc = min(iq,iZcharge)

        qatom   = iq*ps_xe
        qcharge = iqc*ps_xe
        mass    = atom_amu_to_proton(iq,iqc,a)*ps_mp
      endif

    endif
  END SUBROUTINE tr_species_convert_r4

  SUBROUTINE tr_species_convert_r8(iZatom, iZcharge, zAMU, qatom, qcharge, mass, &
       ierr)

    !--------------------------------
    ! D. McCune Dec. 2007
    !    Convert "integer" species specification
    !      {atomic number, ionic charge number, atomic weight in AMU}
    !    to "floating point" representation
    !      {atomic charge (C), ionic charge (C), atomic mass in kg}
    !
    !    If iZatom=-1 provide output quantites for electrons.
    !
    ! ...to be used during initialization of plasma state system at the
    ! start of a simulation...
    !
    !--------------------------------

    integer, intent(in) :: iZatom    ! atomic number: 1 for H, 2 for He, ...
    !  special: -1 for electrons

    integer, intent(in) :: iZcharge  ! ionic charge btw 1 and iZatom
    !  ignored for electrons

    real(fp), intent(in) :: zAMU      ! atomic weight in AMU, nearest integer

    real(fp), intent(out) :: qatom    ! charge of fully stripped ion
    real(fp), intent(out) :: qcharge  ! actual charge
    real(fp), intent(out) :: mass     ! mass in kg

    real(fp), parameter::  ps_epslon  = 1.0e-34_fp       ! small number
    real(fp), parameter::  ps_epsinv  = 1.0e+34_fp       ! large number
    integer, intent(out) :: ierr     ! status code, 0=OK

    !---------------------------
    integer  :: iq,iqc
    real(fp) :: a, ps_me, ps_mp, ps_xe
    !---------------------------

    ierr = 0

    qatom   = 0.0_fp
    qcharge = 0.0_fp
    mass    = 0.0_fp

    if (ps_params) then
      ps_me  = 9.1094e-31_fp        ! electron mass, kg
      ps_mp  = 1.6726e-27_fp        ! proton mass, kg
      ps_xe  = 1.6022e-19_fp        ! Joule/ptcl-eV (also, electron charge)
    else
      ps_me  = protonMass*(electron_amu/proton_amu)
      ps_mp  = protonMass
      ps_xe  = electronCharge
    end if

    if(iZatom.eq.-1) then
      qatom   = -ps_xe
      qcharge = -ps_xe
      mass    =  ps_me

    else if((iZatom.eq.0).or.(iZatom.lt.-1)) then
      ierr = 1
      ! ' ?tr_species_convert: atomic number iZatom out of range low:', iZatom

    else
      a = use_amu(iZatom, zAMU)

      if (a<0.5_fp) then 
        ierr = 2
        !' ?tr_species_convert: atomic number iZatom out of range high:', iZatom

      else
        iq  = iZatom
        iqc = min(iq,iZcharge)

        qatom   = iq*ps_xe
        qcharge = iqc*ps_xe
        mass    = atom_amu_to_proton(iq,iqc,a)*ps_mp

        !if (.false. .and. iq==1 .and. a>1.5_fp .and. a<2.5_fp) then   ! deuterium
        !   print *, 'was = ', mass/1.6726E-27_fp
        !   mass = 1.99831530905844*1.6726E-27_fp        ! old periodic_table
        !   mass = 2.0*1.6726E-27_fp                     ! pre periodic_table
        !   mass = 2.014102*1.6726E-27_fp                ! deuterium neutral atom
        !   mass = 1.9990077004379938_fp*1.6726E-27_fp   ! newer periodic_table
        !   print *, 'now = ', mass/1.6726E-27_fp
        !end if
      endif

    endif
  END SUBROUTINE tr_species_convert_r8
end module periodic_table_mod
 

C******************** START FILE CONSEL.FOR ; GROUP CONCTR *************
C=============================================
C  CONSEL
C   SELECT CONTOUR VALUES FOR CONTOUR PLOTS
C     D. MC CUNE MAY 21 1980
C
C
C   ILOGC: =1==> LINEAR SPACING OF CONTOURS
C          =2==> LOG SPACING OF CONTOURS (IN FCN UNITS)
C
C   CMIN,CMAX--  LOWER,UPPER BND ON CONTOURS
C      IF CMIN OR CMAX .LE. 0, LOG SPACING NOT ALLOWED
C      NMAX:  MAX # CONTOURS
C
C  OUTPUT:
C      ZCNTR  CHOSEN CONTOURS
C      NRET:  # CHOSEN
C
      SUBROUTINE CONSEL(LUNTRM,ILOGC,CMIN,CMAX,NMAX,ZCNTR,NRET)
C
      DIMENSION ZCNTR(NMAX)
C
C  START OF EXECUTABLE CODE
C
      IF(NMAX.GT.2) GO TO 20
        NRET=1
        ZCNTR(1)=0.5*(CMIN+CMAX)
        IF(CMIN.EQ.CMAX) GO TO 190
        GO TO 1000
C
 20   CONTINUE
      GO TO (100,200) ILOGC
C  LINEAR SPACING
 100  CONTINUE
      ITRY=0
C  REVERSE CMIN,CMAX IF NECESSARY
      IF(CMIN.EQ.CMAX) GO TO 190
      IF(CMIN.LT.CMAX) GO TO 110
      ZMIN=CMAX
      CMAX=CMIN
      CMIN=ZMIN
C
 110  CONTINUE
      ZWID=CMAX-CMIN
      ZWPI=ZWID/(NMAX+1)
      Z=ALOG10(ZWPI)
      IWL10=IFIXR(Z)
C
 120  CONTINUE
      ITRY=ITRY+1
      IF(ITRY.EQ.1) ZINTVL=1.0*10.0**IWL10
      IF(ITRY.EQ.2) ZINTVL=2.0*10.0**IWL10
      IF(ITRY.EQ.3) ZINTVL=5.0*10.0**IWL10
      IF(ITRY.LE.3) GO TO 125
      ITRY=0
      IWL10=IWL10+1
      GO TO 120
C
 125  CONTINUE
      IFI0=IFIXR(CMIN/ZINTVL)
      IFI0=IFI0+1
      ZCNTR(1)=IFI0*ZINTVL
      DO 130 INT=2,NMAX
        INTM1=INT-1
        ZNEXT=ZCNTR(INTM1)+ZINTVL
        ZCNTR(INT)=ZNEXT
 130  CONTINUE
      IF(ZCNTR(NMAX).GE.(CMAX-ZINTVL)) GO TO 140
C  TOO MANY INTERVALS
      GO TO 120
C
 140  CONTINUE
      do int=nmax,1,-1
        if(zcntr(int).le.cmax) go to 149
      enddo
      int=1
 149  continue
      nret=int
      GO TO 1000
C
 190  CONTINUE
C  CMIN=CMAX
        NRET=1
        IF(CMIN.EQ.0.0) ZCNTR(1)=1.0E-30
        IF(CMIN.NE.0.0) ZCNTR(1)=0.0
        GO TO 1000
C
C  LOG SPACING
C
 200  CONTINUE
      IF(.NOT.((CMIN.LE.0.0).OR.(CMAX.LE.0.0).OR.
     >          (CMIN.GE.CMAX))) GO TO 210
 205  CONTINUE
      WRITE(LUNTRM,2001)
 2001 FORMAT(
     >  ' % SUB:CONSEL CONTOUR LIMITS NOT SUITABLE FOR LOG-SPACING'/)
      IF(.NOT.((CMIN.LE.0.0).AND.(CMAX.GT.0.0))) GO TO 100
C  STANDARD FIXUP
      WRITE(LUNTRM,20010)
20010 FORMAT(' % SUB:CONSEL STANDARD FIXUP TAKEN')
      CMIN=1.E-4*CMAX
C  PROCEDE
 210  CONTINUE
      Z=ALOG10(CMAX/CMIN)
      IZ=IFIXR(Z)
      IF(IZ.LE.0.0) GO TO 205
C
C  IZ IS A LOWER LIMIT ON THE # OF DECADES RANGED OVER BY CMIN,CMAX
      ZPI=FLOAT(IZ)/(NMAX+1)
      IPI=IFIXR(ZPI)
C
C  IPI= " # OF DECADES PER INTERVAL BETWEEN CONTOURS "
      IPI=IPI-1
C
 225  CONTINUE
      IPI=IPI+1
      IF(IPI.EQ.0) GO TO 250
      IMIN=IFIXR(ALOG10(CMIN))+1
      ZCNTR(1)=10.0**IMIN
      ZMUL=10.0**IPI
      DO 230 INT=2,NMAX
        INTM1=INT-1
        ZNEXT=ZMUL*ZCNTR(INTM1)
        ZCNTR(INT)=ZNEXT
 230  CONTINUE
      ZNEXT=ZNEXT*ZMUL
      IF(ZNEXT.LT.CMAX) GO TO 225
C
 240  CONTINUE
      do int=nmax,1,-1
        if(zcntr(int).le.cmax) go to 249
      enddo
      int=1
 249  continue
      nret=int
      GO TO 1000
C
C  MORE THAN ONE CONTOUR PER DECADE
 250  CONTINUE
      IPDEC=4
C
 255  CONTINUE
      IPDEC=IPDEC-1
      IF(IPDEC.LE.0) GO TO 225
      IEMIN=IFIXR(ALOG10(CMIN))
      ZSCI=1.0
C
 260  CONTINUE
      ZSCI=ZFSCC1(ZSCI,IPDEC)
      ZTES=ZSCI*10.0**IEMIN
      IF((ZSCI.EQ.10.0).OR.(ZTES.GT.CMIN)) GO TO 270
      GO TO 260
C
C  FOUND START POINT
 270  CONTINUE
      ZCNTR(1)=ZTES
      IPNT=1
C
 275  CONTINUE
      IF(ZSCI.NE.10.0) GO TO 278
      ZSCI=1.0
      IEMIN=IEMIN+1
C
 278  CONTINUE
      ZSCI=ZFSCC1(ZSCI,IPDEC)
      ZTES=ZSCI*10.0**IEMIN
      IF(ZTES.GT.CMAX) GO TO 290
      IPNT=IPNT+1
      ZCNTR(IPNT)=ZTES
      IF(IPNT.EQ.NMAX) GO TO 290
      GO TO 275
C
C  CHECK TO SEE IF ENTIRE RANGE IS COVERED
 290  CONTINUE
      IF(IPNT.LT.NMAX) GO TO 295
      ZSCI=ZFSCC1(ZSCI,IPDEC)
      ZTES=ZSCI*10.0**IEMIN
      IF(ZTES.LT.CMAX) GO TO 255
C
 295  CONTINUE
      NRET=IPNT
C
      GO TO 1000
C-----------------------
C  EXIT:
 1000   CONTINUE
      RETURN
C
      	END
C******************** END FILE CONSEL.FOR ; GROUP CONCTR ***************

!
!  "R" routines from fftpack, wrapped in a module
!      converted to real(fp) precision; implicit NONE imposed; DMC Aug 2009
!
!      IMSL fft replacement effort
!
!      test routine included....
!
!--------------------------------------------
subroutine R8RFFTI(N,WSAVE)
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: N
  real(fp), dimension(*) :: WSAVE

  if (N .EQ. 1) return
  CALL R8RFFTI1(N,WSAVE(N+1),WSAVE(2*N+1))

  return
end subroutine R8RFFTI

!--------------------------------------------
subroutine R8RFFTF(N,R,WSAVE)
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: N
  real(fp), dimension(*) :: R, WSAVE

  if (N .EQ. 1) return
  CALL R8RFFTF1(N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))

  return
end subroutine R8RFFTF
 
!--------------------------------------------
subroutine R8RFFTB (N,R,WSAVE)
  use iso_c_binding, only: fp => c_double 
  implicit none
  real(fp), dimension(*) :: R, WSAVE
  integer :: N

  if (N .EQ. 1) return
  CALL R8RFFTB1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))

  return
end subroutine R8RFFTB

!--------------------------------------------
subroutine R8RFFTI1 (N,WA,IFAC)
  use iso_c_binding, only: fp => c_double 
  implicit none

  integer :: N
  real(fp), dimension(*) :: WA
  integer, dimension(*) :: IFAC

  integer :: nl,nf,i,j,ntry,nq,nr,ib,is,l1,nfm1,ip,ld,l2
  integer :: ido,ipm,k1,ii
  real(fp) :: tpi,argh,arg,fi,argld
 
  integer    NTRYH(4)
  DATA NTRYH /4,2,3,5/

  NL = N
  NF = 0
  J = 0
101 J = J+1
  if (J-4) 102,102,103
102 NTRY = NTRYH(J)
  GO TO 104
103 NTRY = NTRY+2
104 NQ = NL/NTRY
  NR = NL-NTRY*NQ
  if (NR) 101,105,101
105 NF = NF+1
  IFAC(NF+2) = NTRY
  NL = NQ
  if (NTRY .NE. 2) GO TO 107
  if (NF .EQ. 1) GO TO 107
  do I=2,NF
    IB = NF-I+2
    IFAC(IB+2) = IFAC(IB+1)
  end do
  IFAC(3) = 2
107 if (NL .NE. 1) GO TO 104
  IFAC(1) = N
  IFAC(2) = NF
  TPI = 6.28318530717959_fp
  ARGH = TPI/(N)
  IS = 0
  NFM1 = NF-1
  L1 = 1
  if (NFM1 .EQ. 0) return
  do K1=1,NFM1
    IP = IFAC(K1+2)
    LD = 0
    L2 = L1*IP
    Ido = N/L2
    IPM = IP-1
    do J=1,IPM
      LD = LD+L1
      I = IS
      ARGLD = (LD)*ARGH
      FI = 0._fp
      do II=3,IDO,2
        I = I+2
        FI = FI+1._fp
        ARG = FI*ARGLD
        WA(I-1) = COS(ARG)
        WA(I) = SIN(ARG)
      end do
      IS = IS+Ido
    end do
    L1 = L2
  end do

  return
end subroutine R8RFFTI1

 
!--------------------------------------------
subroutine R8RFFTF1 (N,C,CH,WA,IFAC)
  use iso_c_binding, only: fp => c_double 
  implicit none

  integer :: N
  real(fp), dimension(*) :: CH, C, WA
  integer, dimension(*) :: IFAC

  !-----------------
  integer :: nf,na,l2,iw,k1,kh,ip,l1,ido,idl1,ix2,ix3,ix4,i
  !-----------------

  NF = IFAC(2)
  NA = 1
  L2 = N
  IW = N
  do K1=1,NF
    KH = NF-K1
    IP = IFAC(KH+3)
    L1 = L2/IP
    Ido = N/L2
    IDL1 = Ido*L1
    IW = IW-(IP-1)*Ido
    NA = 1-NA
    if (IP .NE. 4) GO TO 102
    IX2 = IW+Ido
    IX3 = IX2+Ido
    if (NA .NE. 0) GO TO 101
    CALL R8RADF4 (Ido,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
    GO TO 110
101 CALL R8RADF4 (Ido,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
    GO TO 110
102 if (IP .NE. 2) GO TO 104
    if (NA .NE. 0) GO TO 103
    CALL R8RADF2 (Ido,L1,C,CH,WA(IW))
    GO TO 110
103 CALL R8RADF2 (Ido,L1,CH,C,WA(IW))
    GO TO 110
104 if (IP .NE. 3) GO TO 106
    IX2 = IW+Ido
    if (NA .NE. 0) GO TO 105
    CALL R8RADF3 (Ido,L1,C,CH,WA(IW),WA(IX2))
    GO TO 110
105 CALL R8RADF3 (Ido,L1,CH,C,WA(IW),WA(IX2))
    GO TO 110
106 if (IP .NE. 5) GO TO 108
    IX2 = IW+Ido
    IX3 = IX2+Ido
    IX4 = IX3+Ido
    if (NA .NE. 0) GO TO 107
    CALL R8RADF5 (Ido,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
    GO TO 110
107 CALL R8RADF5 (Ido,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
    GO TO 110
108 if (Ido .EQ. 1) NA = 1-NA
    if (NA .NE. 0) GO TO 109
    CALL R8RADFG (Ido,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
    NA = 1
    GO TO 110
109 CALL R8RADFG (Ido,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
    NA = 0
110 L2 = L1
  end do
  if (NA .EQ. 1) return
  do I=1,N
    C(I) = CH(I)
  end do

  return
end subroutine R8RFFTF1

!--------------------------------------------
subroutine R8RFFTB1 (N,C,CH,WA,IFAC)
  use iso_c_binding, only: fp => c_double 
  implicit none
  integer :: N
  real(fp), dimension(*) :: CH, C, WA
  integer, dimension(*) :: IFAC

  !-----------------
  integer :: nf,na,l2,iw,k1,kh,ip,l1,ido,idl1,ix2,ix3,ix4,i
  !-----------------

  NF = IFAC(2)
  NA = 0
  L1 = 1
  IW = 1
  do K1=1,NF
    IP = IFAC(K1+2)
    L2 = IP*L1
    Ido = N/L2
    IDL1 = Ido*L1
    if (IP .NE. 4) GO TO 103
    IX2 = IW+Ido
    IX3 = IX2+Ido
    if (NA .NE. 0) GO TO 101
    CALL R8RADB4 (Ido,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
    GO TO 102
101 CALL R8RADB4 (Ido,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
102 NA = 1-NA
    GO TO 115
103 if (IP .NE. 2) GO TO 106
    if (NA .NE. 0) GO TO 104
    CALL R8RADB2 (Ido,L1,C,CH,WA(IW))
    GO TO 105
104 CALL R8RADB2 (Ido,L1,CH,C,WA(IW))
105 NA = 1-NA
    GO TO 115
106 if (IP .NE. 3) GO TO 109
    IX2 = IW+Ido
    if (NA .NE. 0) GO TO 107
    CALL R8RADB3 (Ido,L1,C,CH,WA(IW),WA(IX2))
    GO TO 108
107 CALL R8RADB3 (Ido,L1,CH,C,WA(IW),WA(IX2))
108 NA = 1-NA
    GO TO 115
109 if (IP .NE. 5) GO TO 112
    IX2 = IW+Ido
    IX3 = IX2+Ido
    IX4 = IX3+Ido
    if (NA .NE. 0) GO TO 110
    CALL R8RADB5 (Ido,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
    GO TO 111
110 CALL R8RADB5 (Ido,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
111 NA = 1-NA
    GO TO 115
112 if (NA .NE. 0) GO TO 113
    CALL R8RADBG (Ido,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
    GO TO 114
113 CALL R8RADBG (Ido,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
114 if (Ido .EQ. 1) NA = 1-NA
115 L1 = L2
    IW = IW+(IP-1)*Ido
  end do
  if (NA .EQ. 0) return
  do I=1,N
    C(I) = CH(I)
  end do

  return
end subroutine R8RFFTB1


!--------------------------------------------
subroutine R8RADF2 (Ido,L1,CC,CH,WA1)
  use iso_c_binding, only: fp => c_double 
  implicit none

  integer :: Ido,L1
  real(fp) :: CH(Ido,2,L1), CC(IDO,L1,2), WA1(*)

  !-----------------
  integer :: k,ic,i,idp2
  real(fp) :: tr2,ti2
  !-----------------

  do K=1,L1
    CH(1,1,K) = CC(1,K,1)+CC(1,K,2)
    CH(Ido,2,K) = CC(1,K,1)-CC(1,K,2)
  end do
  if (Ido-2) 107,105,102
102 IDP2 = Ido+2
  do K=1,L1
    do I=3,IDO,2
      IC = IDP2-I
      TR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
      TI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
      CH(I,1,K) = CC(I,K,1)+TI2
      CH(IC,2,K) = TI2-CC(I,K,1)
      CH(I-1,1,K) = CC(I-1,K,1)+TR2
      CH(IC-1,2,K) = CC(I-1,K,1)-TR2
    end do
  end do
  if (MOD(Ido,2) .EQ. 1) return
105 continue
  do K=1,L1
    CH(1,2,K) = -CC(Ido,K,2)
    CH(Ido,1,K) = CC(IDO,K,1)
  end do
107 return
end subroutine R8RADF2


!--------------------------------------------
subroutine R8RADF3 (Ido,L1,CC,CH,WA1,WA2)
  use iso_c_binding, only: fp => c_double 
  implicit none

  integer :: Ido,L1
  real(fp) :: CH(Ido,3,L1), CC(IDO,L1,3), WA1(*), WA2(*)
  !-----------------
  integer :: i,ic,k,idp2
  real(fp) :: cr2,ci2,dr2,di2,dr3,di3,tr2,ti2,tr3,ti3
  real(fp) :: TAUR,TAUI
  !-----------------
  DATA TAUR,TAUI /-.5_fp,.866025403784439_fp/

  do K=1,L1
    CR2 = CC(1,K,2)+CC(1,K,3)
    CH(1,1,K) = CC(1,K,1)+CR2
    CH(1,3,K) = TAUI*(CC(1,K,3)-CC(1,K,2))
    CH(Ido,2,K) = CC(1,K,1)+TAUR*CR2
  end do
  if (Ido .EQ. 1) return
  IDP2 = Ido+2
  do K=1,L1
    do I=3,IDO,2
      IC = IDP2-I
      DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
      DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
      DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
      DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
      CR2 = DR2+DR3
      CI2 = DI2+DI3
      CH(I-1,1,K) = CC(I-1,K,1)+CR2
      CH(I,1,K) = CC(I,K,1)+CI2
      TR2 = CC(I-1,K,1)+TAUR*CR2
      TI2 = CC(I,K,1)+TAUR*CI2
      TR3 = TAUI*(DI2-DI3)
      TI3 = TAUI*(DR3-DR2)
      CH(I-1,3,K) = TR2+TR3
      CH(IC-1,2,K) = TR2-TR3
      CH(I,3,K) = TI2+TI3
      CH(IC,2,K) = TI3-TI2
    end do
  end do
  return
end subroutine R8RADF3

!--------------------------------------------
subroutine R8RADF4 (Ido,L1,CC,CH,WA1,WA2,WA3)
  use iso_c_binding, only: fp => c_double 
  implicit none

  integer :: Ido,L1
  real(fp) :: CC(Ido,L1,4), CH(IDO,4,L1), WA1(*), WA2(*), WA3(*)

  !-----------------
  integer :: k,idp2,i,ic
  real(fp) :: tr1,ti1,tr2,ti2,cr2,ci2,cr3,ci3,cr4,ci4
  real(fp) :: tr3,ti3,tr4,ti4
  real(fp) :: hsqt2
  !-----------------
  DATA HSQT2 /.7071067811865475_fp/

  do K=1,L1
    TR1 = CC(1,K,2)+CC(1,K,4)
    TR2 = CC(1,K,1)+CC(1,K,3)
    CH(1,1,K) = TR1+TR2
    CH(Ido,4,K) = TR2-TR1
    CH(Ido,2,K) = CC(1,K,1)-CC(1,K,3)
    CH(1,3,K) = CC(1,K,4)-CC(1,K,2)
  end do
  if (Ido-2) 107,105,102
102 IDP2 = Ido+2
  do K=1,L1
    do I=3,IDO,2
      IC = IDP2-I
      CR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
      CI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
      CR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
      CI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
      CR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
      CI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
      TR1 = CR2+CR4
      TR4 = CR4-CR2
      TI1 = CI2+CI4
      TI4 = CI2-CI4
      TI2 = CC(I,K,1)+CI3
      TI3 = CC(I,K,1)-CI3
      TR2 = CC(I-1,K,1)+CR3
      TR3 = CC(I-1,K,1)-CR3
      CH(I-1,1,K) = TR1+TR2
      CH(IC-1,4,K) = TR2-TR1
      CH(I,1,K) = TI1+TI2
      CH(IC,4,K) = TI1-TI2
      CH(I-1,3,K) = TI4+TR3
      CH(IC-1,2,K) = TR3-TI4
      CH(I,3,K) = TR4+TI3
      CH(IC,2,K) = TR4-TI3
    end do
  end do
  if (MOD(Ido,2) .EQ. 1) return
105 CONTINUE
  do K=1,L1
    TI1 = -HSQT2*(CC(Ido,K,2)+CC(IDO,K,4))
    TR1 = HSQT2*(CC(Ido,K,2)-CC(IDO,K,4))
    CH(Ido,1,K) = TR1+CC(IDO,K,1)
    CH(Ido,3,K) = CC(IDO,K,1)-TR1
    CH(1,2,K) = TI1-CC(Ido,K,3)
    CH(1,4,K) = TI1+CC(Ido,K,3)
  end do
107 return
end subroutine R8RADF4

!--------------------------------------------
subroutine R8RADF5 (Ido,L1,CC,CH,WA1,WA2,WA3,WA4)
  use iso_c_binding, only: fp => c_double 
  implicit none
  integer :: Ido,L1
  real(fp)       CC(Ido,L1,5)           ,CH(IDO,5,L1)           , &
       WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)

  !-----------------
  integer :: i,k,idp2,ic
  real(fp) :: tr11,ti11,tr12,ti12
  real(fp) :: cr2,cr3,cr4,cr5,ci2,ci3,ci4,ci5
  real(fp) :: dr2,dr3,dr4,dr5,di2,di3,di4,di5
  real(fp) :: tr2,tr3,tr4,tr5,ti2,ti3,ti4,ti5
  !-----------------
  DATA TR11,TI11,TR12,TI12 /.309016994374947_fp,.951056516295154_fp, &
       -.809016994374947_fp,.587785252292473_fp/

  do K=1,L1
    CR2 = CC(1,K,5)+CC(1,K,2)
    CI5 = CC(1,K,5)-CC(1,K,2)
    CR3 = CC(1,K,4)+CC(1,K,3)
    CI4 = CC(1,K,4)-CC(1,K,3)
    CH(1,1,K) = CC(1,K,1)+CR2+CR3
    CH(Ido,2,K) = CC(1,K,1)+TR11*CR2+TR12*CR3
    CH(1,3,K) = TI11*CI5+TI12*CI4
    CH(Ido,4,K) = CC(1,K,1)+TR12*CR2+TR11*CR3
    CH(1,5,K) = TI12*CI5-TI11*CI4
  end do
  if (Ido .EQ. 1) return
  IDP2 = Ido+2
  do K=1,L1
    do I=3,IDO,2
      IC = IDP2-I
      DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
      DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
      DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
      DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
      DR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
      DI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
      DR5 = WA4(I-2)*CC(I-1,K,5)+WA4(I-1)*CC(I,K,5)
      DI5 = WA4(I-2)*CC(I,K,5)-WA4(I-1)*CC(I-1,K,5)
      CR2 = DR2+DR5
      CI5 = DR5-DR2
      CR5 = DI2-DI5
      CI2 = DI2+DI5
      CR3 = DR3+DR4
      CI4 = DR4-DR3
      CR4 = DI3-DI4
      CI3 = DI3+DI4
      CH(I-1,1,K) = CC(I-1,K,1)+CR2+CR3
      CH(I,1,K) = CC(I,K,1)+CI2+CI3
      TR2 = CC(I-1,K,1)+TR11*CR2+TR12*CR3
      TI2 = CC(I,K,1)+TR11*CI2+TR12*CI3
      TR3 = CC(I-1,K,1)+TR12*CR2+TR11*CR3
      TI3 = CC(I,K,1)+TR12*CI2+TR11*CI3
      TR5 = TI11*CR5+TI12*CR4
      TI5 = TI11*CI5+TI12*CI4
      TR4 = TI12*CR5-TI11*CR4
      TI4 = TI12*CI5-TI11*CI4
      CH(I-1,3,K) = TR2+TR5
      CH(IC-1,2,K) = TR2-TR5
      CH(I,3,K) = TI2+TI5
      CH(IC,2,K) = TI5-TI2
      CH(I-1,5,K) = TR3+TR4
      CH(IC-1,4,K) = TR3-TR4
      CH(I,5,K) = TI3+TI4
      CH(IC,4,K) = TI4-TI3
    end do
  end do

  return
end subroutine R8RADF5

!--------------------------------------------
subroutine R8RADFG (Ido,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
  use iso_c_binding, only: fp => c_double 
  implicit none
  integer :: Ido,L1,IP,IDL1
  real(fp) :: CH(Ido,L1,IP)          ,CC(IDO,IP,L1)          , &
       C1(Ido,L1,IP)          ,C2(IDL1,IP), &
       CH2(IDL1,IP)           ,WA(*)

  !-----------------
  real(fp) :: tpi,arg,dcp,dsp,ar1,ai1,ar1h,dc2,ds2,ar2,ai2,ar2h
  integer :: ipph,ipp2,idp2,nbd,ik,i,j,k,is,idij,jc,l,lc,j2,ic
  !-----------------
  DATA TPI/6.28318530717959_fp/

  ARG = TPI/(IP)
  DCP = COS(ARG)
  DSP = SIN(ARG)
  IPPH = (IP+1)/2
  IPP2 = IP+2
  IDP2 = Ido+2
  NBD = (Ido-1)/2
  if (Ido .EQ. 1) GO TO 119
  do IK=1,IDL1
    CH2(IK,1) = C2(IK,1)
  end do
  do J=2,IP
    do K=1,L1
      CH(1,K,J) = C1(1,K,J)
    end do
  end do

  if (NBD .GT. L1) GO TO 107
  IS = -Ido
  do J=2,IP
    IS = IS+Ido
    IDIJ = IS
    do I=3,IDO,2
      IDIJ = IDIJ+2
      do K=1,L1
        CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
        CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
      end do
    end do
  end do
  GO TO 111
107 IS = -Ido
  do J=2,IP
    IS = IS+Ido
    do K=1,L1
      IDIJ = IS
      do I=3,IDO,2
        IDIJ = IDIJ+2
        CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
        CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
      end do
    end do
  end do
111 if (NBD .LT. L1) GO TO 115
  do J=2,IPPH
    JC = IPP2-J
    do K=1,L1
      do I=3,IDO,2
        C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
        C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
        C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
        C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
      end do
    end do
  end do
  GO TO 121
115 continue
  do J=2,IPPH
    JC = IPP2-J
    do I=3,IDO,2
      do K=1,L1
        C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
        C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
        C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
        C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
      end do
    end do
  end do
  GO TO 121
119 continue
  do IK=1,IDL1
    C2(IK,1) = CH2(IK,1)
  end do
121 continue
  do J=2,IPPH
    JC = IPP2-J
    do K=1,L1
      C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)
      C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)
    end do
  end do
  !
  AR1 = 1._fp
  AI1 = 0._fp
  do L=2,IPPH
    LC = IPP2-L
    AR1H = DCP*AR1-DSP*AI1
    AI1 = DCP*AI1+DSP*AR1
    AR1 = AR1H
    do IK=1,IDL1
      CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)
      CH2(IK,LC) = AI1*C2(IK,IP)
    end do
    DC2 = AR1
    DS2 = AI1
    AR2 = AR1
    AI2 = AI1
    do J=3,IPPH
      JC = IPP2-J
      AR2H = DC2*AR2-DS2*AI2
      AI2 = DC2*AI2+DS2*AR2
      AR2 = AR2H
      do IK=1,IDL1
        CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)
        CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)
      end do
    end do
  end do
  do J=2,IPPH
    do IK=1,IDL1
      CH2(IK,1) = CH2(IK,1)+C2(IK,J)
    end do
  end do
  !
  if (Ido .LT. L1) GO TO 132
  do K=1,L1
    do I=1,IDO
      CC(I,1,K) = CH(I,K,1)
    end do
  end do
  GO TO 135
132 continue
  do I=1,IDO
    do K=1,L1
      CC(I,1,K) = CH(I,K,1)
    end do
  end do
135 continue
  do J=2,IPPH
    JC = IPP2-J
    J2 = J+J
    do K=1,L1
      CC(Ido,J2-2,K) = CH(1,K,J)
      CC(1,J2-1,K) = CH(1,K,JC)
    end do
  end do
  if (Ido .EQ. 1) return
  if (NBD .LT. L1) GO TO 141
  do J=2,IPPH
    JC = IPP2-J
    J2 = J+J
    do K=1,L1
      do I=3,IDO,2
        IC = IDP2-I
        CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
        CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
        CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
        CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
      end do
    end do
  end do
  return
141 continue
  do J=2,IPPH
    JC = IPP2-J
    J2 = J+J
    do I=3,IDO,2
      IC = IDP2-I
      do K=1,L1
        CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
        CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
        CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
        CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
      end do
    end do
  end do
  return
end subroutine R8RADFG

!--------------------------------------------
subroutine R8RADB2 (Ido,L1,CC,CH,WA1)
  use iso_c_binding, only: fp => c_double 
  implicit none
  integer :: Ido,L1
  real(fp) :: CC(Ido,2,L1), CH(IDO,L1,2), WA1(*)
  !-----------------
  integer :: i,k,ic,idp2
  real(fp) :: tr2,ti2
  !-----------------

  do K=1,L1
    CH(1,K,1) = CC(1,1,K)+CC(Ido,2,K)
    CH(1,K,2) = CC(1,1,K)-CC(Ido,2,K)
  end do
  if (Ido-2) 107,105,102
102 IDP2 = Ido+2
  do K=1,L1
    do I=3,IDO,2
      IC = IDP2-I
      CH(I-1,K,1) = CC(I-1,1,K)+CC(IC-1,2,K)
      TR2 = CC(I-1,1,K)-CC(IC-1,2,K)
      CH(I,K,1) = CC(I,1,K)-CC(IC,2,K)
      TI2 = CC(I,1,K)+CC(IC,2,K)
      CH(I-1,K,2) = WA1(I-2)*TR2-WA1(I-1)*TI2
      CH(I,K,2) = WA1(I-2)*TI2+WA1(I-1)*TR2
    end do
  end do
  if (MOD(Ido,2) .EQ. 1) return
105 do K=1,L1
    CH(Ido,K,1) = CC(IDO,1,K)+CC(IDO,1,K)
    CH(Ido,K,2) = -(CC(1,2,K)+CC(1,2,K))
  end do
107 return
end subroutine R8RADB2

!--------------------------------------------
subroutine R8RADB3 (Ido,L1,CC,CH,WA1,WA2)
  use iso_c_binding, only: fp => c_double 
  implicit none

  integer :: Ido,L1
  real(fp) :: CC(Ido,3,L1), CH(IDO,L1,3), WA1(*), WA2(*)

  !-----------------
  integer :: i,k,ic,idp2
  real(fp) :: tr2,ti2,cr2,ci2,cr3,ci3,dr2,di2,dr3,di3
  real(fp) :: taur,taui
  !-----------------
  DATA TAUR,TAUI /-.5_fp,.866025403784439_fp/

  do K=1,L1
    TR2 = CC(Ido,2,K)+CC(IDO,2,K)
    CR2 = CC(1,1,K)+TAUR*TR2
    CH(1,K,1) = CC(1,1,K)+TR2
    CI3 = TAUI*(CC(1,3,K)+CC(1,3,K))
    CH(1,K,2) = CR2-CI3
    CH(1,K,3) = CR2+CI3
  end do
  if (Ido .EQ. 1) return
  IDP2 = Ido+2
  do K=1,L1
    do I=3,IDO,2
      IC = IDP2-I
      TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
      CR2 = CC(I-1,1,K)+TAUR*TR2
      CH(I-1,K,1) = CC(I-1,1,K)+TR2
      TI2 = CC(I,3,K)-CC(IC,2,K)
      CI2 = CC(I,1,K)+TAUR*TI2
      CH(I,K,1) = CC(I,1,K)+TI2
      CR3 = TAUI*(CC(I-1,3,K)-CC(IC-1,2,K))
      CI3 = TAUI*(CC(I,3,K)+CC(IC,2,K))
      DR2 = CR2-CI3
      DR3 = CR2+CI3
      DI2 = CI2+CR3
      DI3 = CI2-CR3
      CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
      CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
      CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
      CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
    end do
  end do
  return
end subroutine R8RADB3

!--------------------------------------------
subroutine R8RADB4 (Ido,L1,CC,CH,WA1,WA2,WA3)
  use iso_c_binding, only: fp => c_double 
  implicit none
  integer :: Ido,L1
  real(fp) :: CC(Ido,4,L1), CH(IDO,L1,4), WA1(1), WA2(1), WA3(1)
  !-----------------
  integer :: i,k,ic,idp2
  real(fp) :: sqrt2,tr1,tr2,tr3,tr4,ti1,ti2,ti3,ti4
  real(fp) :: cr2,cr3,cr4,ci2,ci3,ci4
  !-----------------
  DATA SQRT2 /1.414213562373095_fp/

  do K=1,L1
    TR1 = CC(1,1,K)-CC(Ido,4,K)
    TR2 = CC(1,1,K)+CC(Ido,4,K)
    TR3 = CC(Ido,2,K)+CC(IDO,2,K)
    TR4 = CC(1,3,K)+CC(1,3,K)
    CH(1,K,1) = TR2+TR3
    CH(1,K,2) = TR1-TR4
    CH(1,K,3) = TR2-TR3
    CH(1,K,4) = TR1+TR4
  end do
  if (Ido-2) 107,105,102
102 IDP2 = Ido+2
  do K=1,L1
    do I=3,IDO,2
      IC = IDP2-I
      TI1 = CC(I,1,K)+CC(IC,4,K)
      TI2 = CC(I,1,K)-CC(IC,4,K)
      TI3 = CC(I,3,K)-CC(IC,2,K)
      TR4 = CC(I,3,K)+CC(IC,2,K)
      TR1 = CC(I-1,1,K)-CC(IC-1,4,K)
      TR2 = CC(I-1,1,K)+CC(IC-1,4,K)
      TI4 = CC(I-1,3,K)-CC(IC-1,2,K)
      TR3 = CC(I-1,3,K)+CC(IC-1,2,K)
      CH(I-1,K,1) = TR2+TR3
      CR3 = TR2-TR3
      CH(I,K,1) = TI2+TI3
      CI3 = TI2-TI3
      CR2 = TR1-TR4
      CR4 = TR1+TR4
      CI2 = TI1+TI4
      CI4 = TI1-TI4
      CH(I-1,K,2) = WA1(I-2)*CR2-WA1(I-1)*CI2
      CH(I,K,2) = WA1(I-2)*CI2+WA1(I-1)*CR2
      CH(I-1,K,3) = WA2(I-2)*CR3-WA2(I-1)*CI3
      CH(I,K,3) = WA2(I-2)*CI3+WA2(I-1)*CR3
      CH(I-1,K,4) = WA3(I-2)*CR4-WA3(I-1)*CI4
      CH(I,K,4) = WA3(I-2)*CI4+WA3(I-1)*CR4
    end do
  end do
  if (MOD(Ido,2) .EQ. 1) return
105 CONTINUE
  do K=1,L1
    TI1 = CC(1,2,K)+CC(1,4,K)
    TI2 = CC(1,4,K)-CC(1,2,K)
    TR1 = CC(Ido,1,K)-CC(IDO,3,K)
    TR2 = CC(Ido,1,K)+CC(IDO,3,K)
    CH(Ido,K,1) = TR2+TR2
    CH(Ido,K,2) = SQRT2*(TR1-TI1)
    CH(Ido,K,3) = TI2+TI2
    CH(Ido,K,4) = -SQRT2*(TR1+TI1)
  end do
107 return
end subroutine R8RADB4

!--------------------------------------------
subroutine R8RADB5 (Ido,L1,CC,CH,WA1,WA2,WA3,WA4)
  use iso_c_binding, only: fp => c_double 
  implicit none
  integer :: Ido,L1
  real(fp) :: CC(Ido,5,L1), CH(IDO,L1,5), WA1(*), WA2(*), WA3(*), WA4(*)

  !-----------------
  integer :: i,k,ic,idp2
  real(fp) :: tr2,tr3,tr4,tr5,ti2,ti3,ti4,ti5
  real(fp) :: cr2,cr3,cr4,cr5,ci2,ci3,ci4,ci5
  real(fp) :: dr2,dr3,dr4,dr5,di2,di3,di4,di5
  real(fp) :: tr11,ti11,tr12,ti12
  !-----------------
  DATA TR11,TI11,TR12,TI12 /.309016994374947_fp,.951056516295154_fp, &
       -.809016994374947_fp,.587785252292473_fp/

  do K=1,L1
    TI5 = CC(1,3,K)+CC(1,3,K)
    TI4 = CC(1,5,K)+CC(1,5,K)
    TR2 = CC(Ido,2,K)+CC(IDO,2,K)
    TR3 = CC(Ido,4,K)+CC(IDO,4,K)
    CH(1,K,1) = CC(1,1,K)+TR2+TR3
    CR2 = CC(1,1,K)+TR11*TR2+TR12*TR3
    CR3 = CC(1,1,K)+TR12*TR2+TR11*TR3
    CI5 = TI11*TI5+TI12*TI4
    CI4 = TI12*TI5-TI11*TI4
    CH(1,K,2) = CR2-CI5
    CH(1,K,3) = CR3-CI4
    CH(1,K,4) = CR3+CI4
    CH(1,K,5) = CR2+CI5
  end do
  if (Ido .EQ. 1) return
  IDP2 = Ido+2
  do K=1,L1
    do I=3,IDO,2
      IC = IDP2-I
      TI5 = CC(I,3,K)+CC(IC,2,K)
      TI2 = CC(I,3,K)-CC(IC,2,K)
      TI4 = CC(I,5,K)+CC(IC,4,K)
      TI3 = CC(I,5,K)-CC(IC,4,K)
      TR5 = CC(I-1,3,K)-CC(IC-1,2,K)
      TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
      TR4 = CC(I-1,5,K)-CC(IC-1,4,K)
      TR3 = CC(I-1,5,K)+CC(IC-1,4,K)
      CH(I-1,K,1) = CC(I-1,1,K)+TR2+TR3
      CH(I,K,1) = CC(I,1,K)+TI2+TI3
      CR2 = CC(I-1,1,K)+TR11*TR2+TR12*TR3
      CI2 = CC(I,1,K)+TR11*TI2+TR12*TI3
      CR3 = CC(I-1,1,K)+TR12*TR2+TR11*TR3
      CI3 = CC(I,1,K)+TR12*TI2+TR11*TI3
      CR5 = TI11*TR5+TI12*TR4
      CI5 = TI11*TI5+TI12*TI4
      CR4 = TI12*TR5-TI11*TR4
      CI4 = TI12*TI5-TI11*TI4
      DR3 = CR3-CI4
      DR4 = CR3+CI4
      DI3 = CI3+CR4
      DI4 = CI3-CR4
      DR5 = CR2+CI5
      DR2 = CR2-CI5
      DI5 = CI2-CR5
      DI2 = CI2+CR5
      CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
      CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
      CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
      CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
      CH(I-1,K,4) = WA3(I-2)*DR4-WA3(I-1)*DI4
      CH(I,K,4) = WA3(I-2)*DI4+WA3(I-1)*DR4
      CH(I-1,K,5) = WA4(I-2)*DR5-WA4(I-1)*DI5
      CH(I,K,5) = WA4(I-2)*DI5+WA4(I-1)*DR5
    end do
  end do
  return
end subroutine R8RADB5

!--------------------------------------------
subroutine R8RADBG (Ido,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
  use iso_c_binding, only: fp => c_double 
  implicit none
  integer :: Ido,L1,IP,IDL1
  real(fp) :: CH(Ido,L1,IP), CC(IDO,IP,L1), &
       C1(Ido,L1,IP), C2(IDL1,IP), CH2(IDL1,IP), WA(1)

  !-----------------
  integer :: nbd,i,k,idp2,ipp2,ipph,j,j2,jc,ic,l,lc,ik,is,idij
  real(fp) :: ar1,ar2,ai1,ai2,ar1h,ar2h,dc2,ds2
  real(fp) :: tpi,arg,dcp,dsp
  !-----------------
  DATA TPI/6.28318530717959_fp/

  ARG = TPI/(IP)
  DCP = COS(ARG)
  DSP = SIN(ARG)
  IDP2 = Ido+2
  NBD = (Ido-1)/2
  IPP2 = IP+2
  IPPH = (IP+1)/2
  if (Ido .LT. L1) GO TO 103
  do K=1,L1
    do I=1,IDO
      CH(I,K,1) = CC(I,1,K)
    end do
  end do
  GO TO 106
103 do I=1,IDO
    do K=1,L1
      CH(I,K,1) = CC(I,1,K)
    end do
  end do
106 do J=2,IPPH
    JC = IPP2-J
    J2 = J+J
    do K=1,L1
      CH(1,K,J) = CC(Ido,J2-2,K)+CC(IDO,J2-2,K)
      CH(1,K,JC) = CC(1,J2-1,K)+CC(1,J2-1,K)
    end do
  end do
  if (Ido .EQ. 1) GO TO 116
  if (NBD .LT. L1) GO TO 112
  do J=2,IPPH
    JC = IPP2-J
    do K=1,L1
      do I=3,IDO,2
        IC = IDP2-I
        CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
        CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
        CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
        CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
      end do
    end do
  end do
  GO TO 116
112 do J=2,IPPH
    JC = IPP2-J
    do I=3,IDO,2
      IC = IDP2-I
      do K=1,L1
        CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
        CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
        CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
        CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
      end do
    end do
  end do
116 AR1 = 1._fp
  AI1 = 0._fp
  do L=2,IPPH
    LC = IPP2-L
    AR1H = DCP*AR1-DSP*AI1
    AI1 = DCP*AI1+DSP*AR1
    AR1 = AR1H
    do IK=1,IDL1
      C2(IK,L) = CH2(IK,1)+AR1*CH2(IK,2)
      C2(IK,LC) = AI1*CH2(IK,IP)
    end do
    DC2 = AR1
    DS2 = AI1
    AR2 = AR1
    AI2 = AI1
    do J=3,IPPH
      JC = IPP2-J
      AR2H = DC2*AR2-DS2*AI2
      AI2 = DC2*AI2+DS2*AR2
      AR2 = AR2H
      do IK=1,IDL1
        C2(IK,L) = C2(IK,L)+AR2*CH2(IK,J)
        C2(IK,LC) = C2(IK,LC)+AI2*CH2(IK,JC)
      end do
    end do
  end do
  do J=2,IPPH
    do IK=1,IDL1
      CH2(IK,1) = CH2(IK,1)+CH2(IK,J)
    end do
  end do
  do J=2,IPPH
    JC = IPP2-J
    do K=1,L1
      CH(1,K,J) = C1(1,K,J)-C1(1,K,JC)
      CH(1,K,JC) = C1(1,K,J)+C1(1,K,JC)
    end do
  end do
  if (Ido .EQ. 1) GO TO 132
  if (NBD .LT. L1) GO TO 128
  do J=2,IPPH
    JC = IPP2-J
    do K=1,L1
      do I=3,IDO,2
        CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
        CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
        CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
        CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
      end do
    end do
  end do
  GO TO 132
128 do J=2,IPPH
    JC = IPP2-J
    do I=3,IDO,2
      do K=1,L1
        CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
        CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
        CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
        CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
      end do
    end do
  end do
132 CONTINUE
  if (Ido .EQ. 1) return
  do IK=1,IDL1
    C2(IK,1) = CH2(IK,1)
  end do
  do J=2,IP
    do K=1,L1
      C1(1,K,J) = CH(1,K,J)
    end do
  end do
  if (NBD .GT. L1) GO TO 139
  IS = -Ido
  do J=2,IP
    IS = IS+Ido
    IDIJ = IS
    do I=3,IDO,2
      IDIJ = IDIJ+2
      do K=1,L1
        C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
        C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
      end do
    end do
  end do
  GO TO 143
139 IS = -Ido
  do J=2,IP
    IS = IS+Ido
    do K=1,L1
      IDIJ = IS
      do I=3,IDO,2
        IDIJ = IDIJ+2
        C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
        C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
      end do
    end do
  end do
143 return
end subroutine R8RADBG

subroutine r8_rfft_test
  !
  !     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
  !
  !                       VERSION 4  APRIL 1985
  !
  !                         A TEST DRIVER FOR
  !          A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE FAST FOURIER
  !           TRANSFORM OF PERIODIC AND OTHER SYMMETRIC SEQUENCES
  !
  !                              BY
  !
  !                       PAUL N SWARZTRAUBER
  !
  !       NATIONAL CENTER FOR ATMOSPHERIC RESEARCH  BOULDER,COLORAdo 80307
  !
  !        WHICH IS SPONSORED BY THE NATIONAL SCIENCE FOUNDATION
  !
  !     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
  !
  !
  !             THIS PROGRAM TESTS THE PACKAGE OF FAST FOURIER
  !     TRANSFORMS FOR BOTH COMPLEX AND REAL PERIODIC SEQUENCES AND
  !     CERTIAN OTHER SYMMETRIC SEQUENCES THAT ARE LISTED BELOW.
  !
  !     1.   RFFTI     INITIALIZE  RFFTF AND RFFTB
  !     2.   RFFTF     FORWARD TRANSFORM OF A REAL PERIODIC SEQUENCE
  !     3.   RFFTB     BACKWARD TRANSFORM OF A REAL COEFFICIENT ARRAY
  !
  !
  !
  !---------------------
  !
  use iso_c_binding, only: fp => c_double 
  implicit none

  integer :: ND(10)
  real(fp) :: X(200), Y(200), W(2000), XH(200)

  real(fp) :: sqrt2,fn,tfn,pi,dt,sum1,sum2,arg,arg1
  real(fp) :: rftf,rftb,rftfb,cf,sum
  integer :: nns,nz,n,modn,np1,nm1,i,j,k,ns2

  !---------------------
  DATA ND(1),ND(2),ND(3),ND(4),ND(5),ND(6),ND(7)/120,54,49,32,4,3,2/

  SQRT2 = SQRT(2._fp)
  NNS = 7
  do NZ=1,NNS
    N = ND(NZ)
    MODN = MOD(N,2)
    FN = (N)
    TFN = FN+FN
    NP1 = N+1
    NM1 = N-1
    do J=1,NP1
      X(J) = SIN((J)*SQRT2)
      Y(J) = X(J)
      XH(J) = X(J)
    end do
    !
    !     TEST subroutineS RFFTI,RFFTF AND RFFTB
    !
    CALL R8RFFTI (N,W)
    PI = 3.14159265358979_fp
    DT = (PI+PI)/FN
    NS2 = (N+1)/2
    if (NS2 .LT. 2) GO TO 104
    do K=2,NS2
      SUM1 = 0._fp
      SUM2 = 0._fp
      ARG = (K-1)*DT
      do I=1,N
        ARG1 = (I-1)*ARG
        SUM1 = SUM1+X(I)*COS(ARG1)
        SUM2 = SUM2+X(I)*SIN(ARG1)
      end do
      Y(2*K-2) = SUM1
      Y(2*K-1) = -SUM2
    end do
104 SUM1 = 0._fp
    SUM2 = 0._fp
    do I=1,NM1,2
      SUM1 = SUM1+X(I)
      SUM2 = SUM2+X(I+1)
    end do
    if (MODN .EQ. 1) SUM1 = SUM1+X(N)
    Y(1) = SUM1+SUM2
    if (MODN .EQ. 0) Y(N) = SUM1-SUM2
    CALL R8RFFTF (N,X,W)
    RFTF = 0._fp
    do I=1,N
      RFTF = MAX(RFTF,ABS(X(I)-Y(I)))
      X(I) = XH(I)
    end do
    RFTF = RFTF/FN
    do I=1,N
      SUM = .5_fp*X(1)
      ARG = (I-1)*DT
      if (NS2 .LT. 2) GO TO 108
      do K=2,NS2
        ARG1 = (K-1)*ARG
        SUM = SUM+X(2*K-2)*COS(ARG1)-X(2*K-1)*SIN(ARG1)
      end do
108   if (MODN .EQ. 0) SUM = SUM+.5_fp*((-1)**(I-1))*X(N)
      Y(I) = SUM+SUM
    end do
    CALL R8RFFTB (N,X,W)
    RFTB = 0._fp
    do I=1,N
      RFTB = MAX(RFTB,ABS(X(I)-Y(I)))
      X(I) = XH(I)
      Y(I) = XH(I)
    end do
    CALL R8RFFTB (N,Y,W)
    CALL R8RFFTF (N,Y,W)
    CF = 1._fp/FN
    RFTFB = 0._fp
    do I=1,N
      RFTFB = MAX(RFTFB,ABS(CF*Y(I)-X(I)))
    end do
    WRITE (6,1001) N,RFTF,RFTB,RFTFB
    !
1001 format(' shortened test.f: N=',i5/ &
          '    RFTF = ',1pe11.4/ &
          '    RFTB = ',1pe11.4/ &
          '    RFTFB= ',1pe11.4)
  end do
  return
end subroutine R8_rfft_test

c file: tstopt.for	sglib type, neat, color options
c
c  test sg lin/log, neat, color options; binitt/upause loop
c
	program tstopt
c
	real xpts(16384),ypta(16384),yptb(16384)
	common /xopts/ lxlog,lxform,lxneat,lxtic,lgcolr,lclip,lskip,lxwid
	common /yopts/ lylog,lyform,lyneat,lytic
	common /curv/ isymb(6),iline(6),icolr(6),istar,istep
	common /dats/ ncurv,jform,xlims(2),ylims(2),numxy
	common /text/ itcolr,itsize
	data lxlog/1/, lxform/5/, lxneat/1/, lxtic/1/, lskip/1/
	data lylog/1/, lyform/5/, lyneat/1/, lytic/1/
	data lgcolr/1/, lclip/1/, itcolr/1/, itsize/1/
	data ncurv/2/, jform/2/
	data iline/6*0/, isymb/6*0/, icolr/6*1/
	character cmd*4,c*1
	equivalence (cmd,c)
	character*20 title
	character*3 places(7) /'STD','UPH','LOH','UL4','ur4','LL4','lr4'/
	character*16 legtext(6)
c
	do while(.true.)
	  cmd='C'
	  do while(c.ne.'P')
	  call at_char(' Data,xAxis,Curve,Labels,Terminal,Plot,eXit',cmd)
	  if(c.eq.'X'.or.cmd.eq.'EX') go to 800
	  if(c.eq.'D') call dataop
	  if(c.eq.'A') call xaxiop
	  if(c.eq.'C') call curvop
	  if(c.eq.'L') call lablop
	  if(c.eq.'T') call termop
	  enddo
c
	  call initt(0)
	  call erase
	  call data1(xpts,xmax,ypta,yptb,nx,ny)
c
	  do jj=1,3
	    call binitt
	    if(lclip.eq.0) call agnclp
	    call place(places(3+jj))
	    call xtype(lxlog)
	    call xlab(lxtic)
	    call xneat(lxneat)
	    call yneat(lyneat)
	  call xwdth(lxwid)
	    if(jform.eq.3) then
	      call agnpts(nx,ny)
	    elseif(jform.ge.4) then
	      if(jform.eq.4) call agbasx(1)
	      call npts(nx)
	    endif
	    call xfrm(lxform)
	    call yfrm(lxform)
	    call stepl(lskip)
	    call agcgrid(lgcolr)
	    call line(iline(1))
	    call symbl(isymb(1))
	    call agsteps(istar,istep)
	    call agccurv(icolr(1))
	    call chrsiz(itsize)
	    call agctext(itcolr)
	    call check(xpts, ypta)
	    call dsplay(xpts, ypta)
	    if(lxform.gt.0) call frame
	    call line(iline(2))
	    call symbl(isymb(2))
	    call agccurv(icolr(2))
	    call cplot(xpts, yptb)
	    call seetw(ilft,irit,ibot,itop)
	  legtext(1) = 'line 1'
	  legtext(2) = 'line 2'
	  call aglegnd(2,2,legtext,6,isymb,iline)
	    title = 'LINEAR'
	    if(lylog.ne.1) title = 'LOG'
	    call agtcvs(title)
	    title = 'X LINEAR'
	    if(lxlog.eq.2) then
	      title = 'X LOG'
	    endif
	    call agtchs(title)
	    call chrsiz(1)
	    title = 'extend to data'
	    if(lxneat.eq.1) then
	      title = 'to minor ticks'
	    elseif(lxneat.eq.2) then
	      title = 'to major ticks'
	    endif
	    call agtcgt(0,title)
	    call datai(xpts,xmax)
	  enddo
c
	  call place('LR4')	!7
	  call setwin
	  call seetw(ilft,irit,ibot,itop)
	  title = 'no x labels'	!lxtic = 0
	  if(lxtic.eq.1) then
	    title = 'label ticks'
	  elseif(lxtic.eq.2) then
	    title = 'label ends'
	  endif
	  ihite = linhgt(1)
	  itop = itop-40
	  call agtmhs(ilft,itop,title)
	  imove = linwdt(12)
	  call agtmhs(ilft+imove,itop,'!')
	  itop = itop-ihite
	  if(isymb(1).ne.0) then
	    title = 'symbol'
	    call agtmhs(ilft,itop,title)
	    call movabs(ilft+120,itop+5)
	    call teksym(isymb(1),1.)
	  endif
	  itop = itop-(ihite*3/2)
	  title = '  0deg'
	  call agtmrs(ilft,itop,0,title)
	  title = '270deg'
	  call agtmrs(ilft+80,itop,270,title)
	  title = '180deg'
	  call agtmrs(ilft+80,itop-80,180,title)
	  title = ' 90deg'
	  call agtmrs(ilft,itop-80,90,title)
	  call upause(0)
	  call finitt(0,0)
	enddo
 800	continue
	end
c%
	subroutine dataop
	common /xopts/ lxlog,lxform,lxneat,lxtic,lgcolr,lclip,lskip,lxwid
	common /yopts/ lylog,lyform,lyneat,lytic
	common /curv/ isymb(6),iline(6),icolr(6),istar,istep
	common /dats/ ncurv,jform,xlims(2),ylims(2),numxy
	common /text/ itcolr,itsize
	character cmd*4,c*1
	equivalence (cmd,c)
c
	real x(*),y1(*),y2(*)
	real ypts(7)	/40.,10.,30.,20.,25.,25.,25./
	integer numxy /6/
	integer ncall /0/
c
	call at_int(
     >	  '  form(1=long,2=short/long,3=short/non,4=base/non,5=non-std)',
     >		jform)
	call at_int('  number of points',numxy)
	call at_real('  x start',xfir)
	call at_real('  increment ',xdel)
	call at_real('  y multiplier ',ymag)
	call at_real('  y offset ',yoff)
	return
c
	entry data1(x,xmax,y1,y2,nx,ny)
c
	data xfir /1./, xdel /.8/
	data ymag /1./, yoff /0./
c
	ncall=-1
	xmag=10.**(6*ncall)
	nx=0
	ny=0
	if(jform.ge.3) then
	  jj=0
	  ny=numxy
	else
	  jj=1
	  y1(1)=numxy
	  y2(1)=numxy
	endif
	if(jform.eq.1 .or. jform.eq.5) then
	  do ii=1,numxy
	    kk=ii+jj
	    x(kk)=xfir+xdel*(ii-1)
	    x(kk)=x(kk)*xmag
	  enddo
	  if(jform.eq.1) then
	    x(1)=numxy
	  else	!jform.eq.5
	    nx=numxy
	  endif
	elseif(jform.eq.2 .or. jform.eq.3) then
	  x(1)=-1.
	  x(2)=numxy
	  x(3)=xfir*xmag
	  x(4)=xdel*xmag
	else	!jform=4
	  x(1)=numxy
	  x(2)=xfir*xmag
	  x(3)=xdel*xmag
	  nx=numxy
	endif
	ydel=6./float(numxy)
	n6=numxy/6
	do ii=1,numxy
	  kk=ii+jj
	  iuse=(ii-1)/n6+1
	  ins=mod(ii-1,n6)
	  yval=ypts(iuse)+(ypts(iuse+1)-ypts(iuse))*ydel*(ins)
	  y1(kk)=yoff+yval*ymag
	  y2(kk)=y1(kk)-10.
	enddo
c
	return
c
	entry datai(x,xmax)
c
	ncall=ncall+1
	xmag=10.**(6*ncall)
	if(jform.ge.3) then
	  jj=0
	else
	  jj=1
	endif
	if(jform.eq.1 .or. jform.eq.5) then
	  do ii=1,numxy
	    kk=ii+jj
	    x(kk)=xfir+xdel*(ii-1)
	    x(kk)=x(kk)*xmag
	  enddo
	elseif(jform.eq.2 .or. jform.eq.3) then
	  x(3)=xfir*xmag
	  x(4)=xdel*xmag
	else
	  x(2)=xfir*xmag
	  x(3)=xdel*xmag
	endif
	return
	end
c%
	subroutine xaxiop
	common /xopts/ lxlog,lxform,lxneat,lxtic,lgcolr,lclip,lskip,lxwid
	common /yopts/ lylog,lyform,lyneat,lytic
	common /curv/ isymb(6),iline(6),icolr(6),istar,istep
	common /dats/ ncurv,jform,xlims(2),ylims(2),numxy
	common /text/ itcolr,itsize
	character cmd*4,c*1
	equivalence (cmd,c)
c
	call at_int('  log (1=linear,2=log)',lxlog)
	call at_int(
     >	  '  tic form (2=out,3=in,4=thru,5=long thru,6=long in)',lxform)
	call at_int('  label width',lxwid)
	call at_int('  neat (0=edges,1=minor,2=major)',lxneat)
	call at_int('  tic labels (0=none,1=ticks,2=ends)',lxtic)
	call at_int('  skip factor',lskip)
	call at_int('  axis color',lgcolr)
	return
	end
c%
	subroutine curvop
	common /xopts/ lxlog,lxform,lxneat,lxtic,lgcolr,lclip,lskip,lxwid
	common /yopts/ lylog,lyform,lyneat,lytic
	common /curv/ isymb(6),iline(6),icolr(6),istar,istep
	common /dats/ ncurv,jform,xlims(2),ylims(2),numxy
	common /text/ itcolr,itsize
	character cmd*4,c*1
	equivalence (cmd,c)
c
	do ii=1,ncurv
	  call at_int('  line  ',iline(ii))
	  call at_int('  symbol',isymb(ii))
	  call at_int('  color ',icolr(ii))
	enddo
	call at_int('  symbol start',istar)
	call at_int('  symbol step',istep)
	call at_int('  1 to clip, 0 not to',lclip)
	return
	end
c%
	subroutine lablop
	common /curv/ isymb(6),iline(6),icolr(6),istar,istep
	common /dats/ ncurv,jform,xlims(2),ylims(2),numxy
	common /text/ itcolr,itsize
	character cmd*4,c*1
	equivalence (cmd,c)
c
	call at_int('  text size',itsize)
	call at_int('  text color',itcolr)
	return
	end
	subroutine termop
	character cmd*4,c*1
	equivalence (cmd,c)
c
	data jterm /0/, jsres /1024/
c
	call at_int('  terminal type (0=4014,1=4105)',jterm)
	call at_int('  screen resolution (1024,4096)',jsres)
	call tminit(jterm)
	call term(0,jsres)
	return
	end
	subroutine aglegnd(legtyp,nlines,texts,nchrs,ksymbl,kdashs)
c
c  Put a legend for multiple curves in the top right or left of a plot.
c  Each line of the legend has a short piece of line with one symbol
c  (if any) and a short text describing the line.
c
c  arguments:
c
	integer legtyp	!where to put legend (1=top right, 2=top left)
	integer nlines	!number of lines in legend
	character*16 texts(nlines)	!array of legend texts
	integer nchrs		!text length to output
	integer ksymbl(nlines)		!array of symbol codes
	integer kdashs(nlines)		!array of dash lines codes
c
c  get parameters from sg common
	ltick = comget(ibasey(6))	!tick length
	symsiz = comget(ibasec(7))
	call seetw(lx,mx,ly,my)	!location of min/max x/y
	ihgt=linhgt(1)		!char height
	iwdt=linwdt(1)		!char width
c
c  output legend
	do ndrw=1,nlines
	  if(legtyp.eq.2) then		!inside top right
	    ihorz=mx-iwdt*nchrs-iwdt*3-ltick
	    ivert=my-ihgt*ndrw-ltick
	  elseif(legtyp.eq.1) then	!inside top left
	    ihorz=lx+ltick
	    ivert=my-ihgt*ndrw-ltick
	  endif
	  call movabs(ihorz,ivert+ihgt/2)
	  call dshrel(iwdt*3,0,kdashs(ndrw))
	  if(ksymbl(ndrw).ne.0) then
	    call movrel(-iwdt,0)
	    call symout(ksymbl(ndrw),symsiz)
	    call movrel(iwdt,0)
	  endif
	  call movrel(4,-ihgt/2)
	  call agths(texts(ndrw)(1:nchrs))
	enddo
	return
	end

 
real(fp) function elec_sigv(Te, icode)
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) Te      ! electron temperature, KEV
  integer icode  ! reaction selection (see below)
!  return rate coefficient <sigma*v> , M**3/sec, in elec_sigv
  real(fp) svrc_janev,sveih_janev,sveihe_janev
  if(icode.eq.0) then
     ! H+,e recombination
     elec_sigv = 1.e-6_fp * svrc_janev(1.e+3_fp*Te)
  else if(icode.eq.1) then
 
     ! H0,e impact ionization
 
     elec_sigv = 1.e-6_fp * sveih_janev(1.e+3_fp*Te)
 
  else if(icode.eq.2) then
 
     ! He0,e impact ionization
 
     elec_sigv = 1.e-6_fp * sveihe_janev(1.e+3_fp*Te)
 
  else if(icode.eq.3) then
 
     ! Li0,e impact ionization  ** use H0 formula for now *******
 
     elec_sigv = 1.e-6_fp * sveih_janev(1.e+3_fp*Te)
 
  else
     call errmsg_exit('? sigsub/elec_sigv:  invalid "icode".')
  endif
end function elec_sigv

C******************** START FILE UFCHAR.FOR ; GROUP URDUTS *************
C----------------------------------------------------------------
C&  UFCHAR  OLD UREAD FIND SPECIAL CHARACTER IN INPUT LINE
C
C   ZLINE-- UNPACKED DATA LINE 1 CHAR PER WORD
C   LLINE-- LENGTH OF LINE
C   ZCHAR-- SPECIAL CHARACTER SOUGHT
C   IND  -- (INPUT) LOCATION AT WHICH TO START SEARCH
C           (OUTPUT) LOCATION OF FIRST OCCURANCE OF ZCHAR IN ZLINE
C                    OR 0 IF NOT FOUND
C  Updated:
C	 5/20/92 TBT Ignore special character if preceeded by \.
C
      SUBROUTINE UFCHAR(ZLINE,ZCHAR,IND,LLINE)
C
      CHARACTER*1 ZLINE(LLINE),ZCHAR
      character*1 Backslsh
      Character*1 Lastchar
C
      data Backslsh /'\\'/  ! unix needs escaped backslash
C
      Lastchar = ' '
C
      IND0=IND
      IND=0
      IF(IND0.LT.1) IND0=1
      IF(IND0.GT.LLINE) RETURN
C  MOD DMC 1988 -- IF IN DBL QUOTES IT DOESN'T COUNT
      ICHK=1
      DO 10 I=IND0,LLINE
        IF(ZLINE(I).EQ.'"') ICHK=1-ICHK
        IF(ICHK.NE.1) GO TO 10
        IF(ZLINE(I).EQ.ZCHAR .and. Lastchar .NE. Backslsh) GO TO 20
        Lastchar = Zline(I)
 10   CONTINUE
 
C  CHAR NOT FOUND
      RETURN
 
C  CHAR FOUND
 20   CONTINUE
      IND=I
      RETURN
      	END
C******************** END FILE UFCHAR.FOR ; GROUP URDUTS ***************

C******************** START FILE DPLOTM.FOR ; GROUP DPLOTT *************
C-------------------------------------------------------------
C  DPLOTM
C  PLOT 1 FCN OF A MULTIPLOT VIA DPLOT1; RESTORE DEFAULT 2D
C  WINDOW
C
      SUBROUTINE DPLOTM(IXR,IYR,X,Y,N,M)
C
      INCLUDE 'GFTIC'
C
      INTEGER IXR(2),IYR(2),IXRP(2),IYRP(2)
      REAL X(N),Y(N)
C
      if(.not.init_gftic) call gftic0
C
      IRSET=NRSET
      IXRP(1)=NXR1
      IXRP(2)=NXR2
      IYRP(1)=NYR1
      IYRP(2)=NYR2
C
      NRSET=1
      NXR1=IXR(1)
      NXR2=IXR(2)
      NYR1=IYR(1)
      NYR2=IYR(2)
C
      IN=N
      IF(M.LE.0) IN=1
      CALL DPLOT1(X,Y,IN,M)
C
      NRSET=IRSET
      NXR1=IXRP(1)
      NXR2=IXRP(2)
      NYR1=IYRP(1)
      NYR2=IYRP(2)
C
      RETURN
      END
C******************** END FILE DPLOTM.FOR ; GROUP DPLOTT ***************

      subroutine ufmds_inf(ilun,string,opt,ier)
C
C  get tree information from MDS+ node
C
C---------------------------------
C History:
C 10/23/01 CAL:
C
C------------------------------
      use UFILES
      implicit none
 
      integer       ilun        ! Ufiles LUN
      character*(*) string      ! output
      integer       opt         ! = (-)1 Mds Tree name
C                               ! = (-)2 Node Name
C                               ! if negative: do not return error
                                ! return -77
      integer       ier
C
C
      integer       ichan       ! Ufiles channel id
      integer       ils, l
C-----------------------------------
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UFMDS_INF ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
C
C MDSplus ?
      if ( UFCPRS(ICHAN) .ne. -1) then
         if (opt .lt. 0) then    ! caller does not know
            ier = -77            ! -77 = not MDS+
            return
         else
            write(ufelun,9001) ilun
 9001       format(' ? UFMDS_INF-- lun',i5,' not open for MDS+')
            go to 9000
         endif
      endif
 
      ier=0
      ils=len(string)
      if (abs(opt) .eq. 1) then      ! Tree
         l=lextnd(ichan)
         if (ils .lt. l) then
         write(ufelun,9002) mds_tree(ichan)(1:l),
     >         mds_tree(ichan)(1:ils)
 9002    format(' ? UFMDS_INF-- Tree Name truncated from ',/,
     >          a,' to ',a)
            l=ils
         endif
         string = mds_tree(ichan)(1:l)
      else if (abs(opt) .eq. 2) then      ! Node
         l=lfdir(ichan)
         if (ils .lt. l) then
         write(ufelun,9003) mds_node(ichan)(1:l),
     >         mds_node(ichan)(1:ils)
 9003    format(' ? UFMDS_INF-- Node Name truncated from ',/,
     >          a,' to ',a)
            l=ils
         endif
         string = mds_node(ichan)(1:l)
      endif
      return
C
 9000 ier=1
      return
      end
 
 

!
!  return preact handle for impurity stopping reactions
!  return ihandle=0 if izneut and izimp do not match a known sigma*v
!  table
!
subroutine zstop_handle(izneut,izimp,ihandle)
 
  use hatom_mod
  implicit NONE
 
  integer, intent(in) :: izneut   ! Z of neutral atom (1, 2 or 3)
  integer, intent(in) :: izimp    ! Z of impurity ion (6 or 8)
  integer, intent(out) :: ihandle   ! preact handle
 
  !---------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  ihandle=0
 
  if(izimp.eq.6) then
 
     if(izneut.eq.1) then
 
        ihandle=Lst_H0_C6
 
     else if(izneut.eq.2) then
 
        ihandle=Lst_He0_C6
 
     else if(izneut.eq.3) then
 
        ihandle=Lst_Li0_C6
 
     endif
 
  else if(izimp.eq.8) then
 
     if(izneut.eq.1) then
 
        ihandle=Lst_H0_O8
 
     else if(izneut.eq.2) then
 
        ihandle=Lst_He0_O8
 
     else if(izneut.eq.3) then
 
        ihandle=Lst_Li0_O8
 
     endif
 
  endif
 
end subroutine zstop_handle

C----------------------------------------------------------------------
C  ABORT A JOB AFTER A FATAL ERROR CONDITION IS DETECTED
C    FORCE AN ARITHMETIC ERROR WHICH THE JOB CONTROL CODE SHOULD BE
C    ABLE TO DETECT
C
      SUBROUTINE ZZABORT(ZARG)
C
      write(6,1001)
 1001 FORMAT(//' %ZZABORT:  ** ABORT SUBROUTINE CALLED **'//)
C
      call bad_exit
      stop                              ! this stmt not reached
      end

      subroutine ubcflush(ichan)

      use UFILES
#include "fpreproc/byte_declare.h"
 
C  Modified:
C  04/04/96  TBT  Added Integer ibits becuase
C                  ibits is a reserved word for HP.
C
C  character buffer full:  compress and write.
C
c  dmc 21 June 1999:  moved from UFILES INCLUDE file -- no way
c  to create f77/f90 portable include file using byte_declare on SUNs...
c
      byte_declare uiobuf(ufbbuf,ufpach)  ! i/o buffers
      byte_declare uchbuf(ufcbuf,ufpach)  ! char compression buffers
      common/ufilbyte/ uiobuf,uchbuf
c
      Integer ibits
C
C  local buffer for length information
C
      byte_declare ilbuf(8)
      byte_declare bi2buf(2,ufcbuf)
C
C-----------------------------------------
C
      if(nchbuf(ichan).gt.0) then
C
         do i=1,nchbuf(ichan)
#ifdef __CRAY
            bi2buf(1,i)=char(0)
#else
            bi2buf(1,i)=0
#endif
            bi2buf(2,i)=uchbuf(i,ichan)
         enddo
C
         call cmprs2(bi2buf,nchbuf(ichan),ufpack,UFMAXR,ibits,ierr)
C
         if(ierr.ne.0) then
            write(6,'('' ?ubcflush:  cmprsi error:  '',i3)') ierr
            go to 999
         endif
C
         iwords=ibits/32 + 1
         ibytes=iwords*4
C
#ifdef __CRAY
         ilbuf(1)=char(3)
         call ubi3ncod(nchbuf(ichan),ilbuf,2)
C
         ilbuf(5)=char(1)
         call ubi3ncod(iwords,ilbuf,6)

#else
         ilbuf(1)=3
         call ubi3ncod(nchbuf(ichan),ilbuf,2)
C
         ilbuf(5)=1
         call ubi3ncod(iwords,ilbuf,6)
#endif
C
C  write header
         ilun=uflun(ichan)
         call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ilbuf,8)
C  write data
         call ubufo(ilun,uiobuf(1,ichan),niobuf(ichan),ufpack,ibytes)
C
C  done.
C
         nchbuf(ichan)=0
C
      endif
      go to 1000
C
 999  continue
C
 1000 continue
      return
      end

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SIGION_Z(EREL,ANEUT)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : zero,zcm2tom2
!
!  1/28/80
!  THIS FUNCTION WAS WRITTEN BY HARRY H. TOWNER OF THE PRINCETON
!  PLASMA PHYSICS LAB.	THIS FUNCTION WILL CALCULATE THE PROTON
!  IONIZATION CROSS SECTION AS GIVEN BY FREEMAN AND JONES IN
!  TABLE 2.
!
!  PARAMETER LIST:
!  EREL   - THE RELATIVE ENERGY BETWEEN THE NEUTRAL PARTICLE
!	    AND THE CHARGED PARTICLE.  (KEV)
!	    EG. WNEUT+ANEUT*1.5*TI/APLASMA.
!  ANEUT  - THE ATOMIC WEIGHT OF THE NEUTRAL PARTICLE.
!
!  SIGION_Z HAS UNITS OF M**2.
!
!============
! idecl:  explicitize implicit REAL declarations:
  IMPLICIT NONE
  real(fp) erel,aneut,a0,a1,a2,a3,a4,a5,a6,ee,ale,exp_arg
!============
  DATA A0,A1,A2,A3,A4,A5,A6/-.4203309e+2_fp,.3557321e+1_fp,-.1045134e+1_fp,&
       .3139238_fp,-.7454475e-1_fp,.8459113e-2_fp,-.3495444e-3_fp/
!
!  EE IS THE RELATIVE ENERGY (IN KEV) PER AMU.
  EE=EREL/ANEUT
  ALE=log(EE)
!  THE CROSS-SECTION IS NOW EVALUATED.
  EXP_ARG = ((((((A6*ALE+A5)*ALE+A4)*ALE+A3)*ALE+A2)*ALE+A1)&
       *ALE+A0)
  IF (EXP_ARG .GT. -79.5_fp) THEN
!
     SIGION_Z = zcm2tom2*EXP(EXP_ARG)
!
  ELSE
!
     SIGION_Z = zero
!
  END IF
  RETURN
END FUNCTION SIGION_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

C******************** START FILE USICHK.FOR ; GROUP UREAD5 ******************
C----------------------------------------------------------
C& USICHK   CHECK THAT UREAD COMMON BLOCK HAS BEEN INITIALIZED
C
      SUBROUTINE USICHK
C
      USE USERIO
C
      IF(NLUINI) GO TO 50
      CALL USINIT
      WRITE(LUNTRM,1998)
 1998 FORMAT(/' *USINIT CALLED*'/)
C
 50   CONTINUE
      RETURN
      END
C******************** END FILE USICHK.FOR ; GROUP UREAD5 ******************

C******************** START FILE UERSTA.FOR ; GROUP UFILES ******************
C------------------------------------------------------------------
C  UERSTA
C  REPORT ERROR IN CHANNEL STATUS
C
      SUBROUTINE UERSTA(ICHAN,ZSUB)
C
      USE UFILES
      CHARACTER*10 ZSUB
C
      CHARACTER*30 ZMES(6)
C
      DATA ZMES/'CLOSED                       '
     >           ,'OPEN FOR DATA WRITE          '
     >           ,'OPEN FOR WRITE OF COMMENTS   '
     >           ,'OPEN FOR DATA READ           '
     >           ,'OPEN: TEMPORARY COMMENTS FILE'
     >           ,'OPEN FOR READ OF COMMENTS    '/
C
      IC=UFSTAT(ICHAN)+1
      WRITE(UFELUN,9001) ZMES(IC),ZSUB,UFLUN(ICHAN)
 9001 FORMAT('   LOGICAL UNIT STATUS:  ',A/
     >  ' ? ',A10,' - STATUS INCORRECT;  L.U.N.= ',I5)
      RETURN
      	END
C******************** END FILE UERSTA.FOR ; GROUP UFILES ******************

C******************** START FILE UFSNMD.FOR ; GROUP UFILES ******************
C------------------------------------------------------------
C  UFSNMD
C  DISPLAY UFILES FILENAME FORM ON OUTPUT CHANNEL LUNO
C  WITH LABEL ZLABL (20 CHARS)
C    UFILES FILE I/O LUN LUNF
C
      SUBROUTINE UFSNMD(LUNO,ZLABL,LUNF)
C
      USE UFILES
C
      CHARACTER*(*) ZLABL
      CHARACTER*128 ZFILE
C
      character*128 znode
C
      CALL UFINIT
      IER=0
      CALL UFLCHK(LUNF,'UFSNMD    ',ICHAN,IER)
      IF(IER.NE.0) RETURN
C
      if(ufcprs(ichan).ge.0) then
         IF(LSHOTN(ICHAN)) THEN
            CALL UFSNM0(ZFILE,
     1	   UDEV(ICHAN),UFDIR(ICHAN),UPRFIX(ICHAN),
     2	   '######',UEXTND(ICHAN))
         ELSE
            CALL UFSNM0(ZFILE,
     1	   UDEV(ICHAN),UFDIR(ICHAN),UPRFIX(ICHAN),
     2	   '      ',UEXTND(ICHAN))
         ENDIF
      endif
C  DISPLAY - IGNORE TRAILING, LEADING BLANKS IN LABEL
      ILL=LEN(ZLABL)
C
      DO 11 IL1=1,ILL
         IF(ZLABL(IL1:IL1).NE.' ') GO TO 15
 11   CONTINUE
C
      IL1=ILL
      IL2=ILL
      GO TO 16
C
 15   CONTINUE
C
      DO 13 IL2=ILL,IL1,-1
         IF(ZLABL(IL2:IL2).NE.' ') GO TO 16
 13   CONTINUE
C
 16   CONTINUE
C
      if(ufcprs(ichan).ge.0) then
         CALL UFSND0(LUNO,ZLABL(IL1:IL2),ZFILE)
      else
         call ufsnmd_node(ichan,znode,ilnode)
         ils=len_trim(mds_server(ichan))
         ilt=len_trim(mds_tree(ichan))
         write(luno,1001) mds_server(ichan)(1:ils),
     1	mds_tree(ichan)(1:ilt),znode(1:ilnode)
 1001    format(' mds+ "',a,'" at ',a,' tree: ',a/' path: ',a)
      endif
C
      RETURN
      END
C-------------------
      subroutine ufsnmd_node(ichan,znode,ilnode)
      use UFILES
      character*(*) znode
C
      call ufsnmd_nod0(mds_path(ichan),mds_node(ichan),znode,ilnode)
      return
      end
C
C------------------
C
      subroutine ufsnmd_nod0(mds_path,mds_node,znode,ilnode)
      character*(*) mds_path,mds_node	! path & node strings (input)
      character*(*) znode	! combined string (output)
      integer ilnode		! non-blank string length (output)
C
      if(mds_node(1:1).eq.' ') then
         znode=mds_path
      else if(mds_path(1:1).eq.' ') then
         znode=mds_node
      else
         ilp=len_trim(mds_path)
         iln=len_trim(mds_node)
         icolon=1
         if(mds_path(ilp:ilp).eq.'.') icolon=0
         if(mds_path(ilp:ilp).eq.':') icolon=0
         if(mds_node(1:1).eq.'.') icolon=0
         if(mds_node(1:1).eq.':') icolon=0
         if(icolon.eq.1) then
            znode = mds_path(1:ilp)//':'//mds_node(1:iln)
         else
            znode = mds_path(1:ilp)//mds_node(1:iln)
         endif
      endif
      ilnode = len_trim(znode)
      return
      end

subroutine ezcdf_error(status,nam3,nam1,nam2)
  include "netcdf.inc"
  integer, intent(in) :: status
  character(len=*), intent(in) :: nam1, nam2, nam3
  if (status .eq. nf_noerr) return
  write(*,10) trim(nam1),trim(nam2),trim(nam3)
10 format('% ',a,'--E-- A netCDF error has occurred in: ' ,a/ &
        'while processing: ',a)
  print *, nf_strerror(status)
  return
end subroutine ezcdf_error

subroutine sigvte_ioniz(izneut,te,n,sigv)
 
  use hatom_mod
  implicit NONE
 
  !  e- impact ionization <sigma*v>(Te)
  !  via table lookup
  !  tables provided for H,He,Li
 
  integer, intent(in) :: izneut   ! Z of neutral atom (1, 2 or 3)
  integer, intent(in) :: n     ! vector size
  real*8, intent(in) :: te(n)  ! electron temperature(s)  KeV
 
  real*8, intent(out) :: sigv(n)  ! <sigma*v> value(s) returned  m**3/sec
 
  !  if Z is out of range, sigv(:)=-1.0 is returned...
  !
  !-----------------------
 
  if(hatom_flag.eq.0) call hatom_init
 
  if(izneut.eq.1) then
     call ei_sigvte_sigmatimesv(Lei_H0, te, sigv, n)
 
  else if(izneut.eq.2) then
     call ei_sigvte_sigmatimesv(Lei_HE0, te, sigv, n)
 
  else if(izneut.eq.3) then
     call ei_sigvte_sigmatimesv(Lei_LI0, te, sigv, n)
 
  else
     sigv = -1
  endif
 
end subroutine sigvte_ioniz

C-----------------------------------------------------------------------
C  unixfile -- accept input to determine an arbitray unix filename
 
 
      subroutine unixfile(zlbl,zfile)
 
 
      character*(*) zlbl  ! (input) caller id string
      character*(*) zfile ! (output) a full filename, left justified
C
C  zlbl is used in generating the UREAD prompt for the filename
C
C  nb:  if zlbl is 'init', the default zpath is re-initialized
C   using the value zfile which is then also input
C
 
C  Modifcations:
C  0515/95  tbt   Increase file name length to 130 from 64.
 
 
      character*130  zpath,ztrans,zname       ! 130 arbitrary  tbt
 
      data zpath/' '/
C
      logical lxout
C
C-----------------------------------------------------------------------
C
      if( zlbl.eq.'init' ) then
 
        zpath=zfile
 
      else
 
        luntrm = lnout(0)
 
 5      continue
        if( lxout(0) ) write(luntrm,1001)
 1001   format(
     >' %unixfile:  enter a complete, literal unix file specification,'/
     >' or "r " or "R " to set up a directory path (with environment'/
     >' variable name translation) and then specify a relative file'/
     >' specification.'/)
 
        call ureadLw(
     >      'unixfile ('//zlbl//'):  enter file spec or "r":$',zfile)
 
        if((zfile(1:2).eq.'r ').or.(zfile(1:2).eq.'R ')) then
 
          call unixpath(zpath,ztrans,itrans)
          call ureadLw(
     >      'unixfile ('//zlbl//'):  enter relative file spec or "q":$',
     >        zname)
 
          if((zname(1:2).eq.'q ').or.(zname(1:2).eq.'Q ')) go to 5
 
          inb=index(zname,' ')-1
          if(ztrans(itrans:itrans).eq.'/') then
            zfile=ztrans(1:itrans)//zname(1:inb)
          else
            zfile=ztrans(1:itrans)//'/'//zname(1:inb)
          endif
 
        endif
 
      endif
 
      return
      end

subroutine c8dft(x,y,n)

  !  compute the Discrete Fourier Transform of a complex sequence.
  !  Replacement for NAG c06fcf; may be less efficient.  DMC 15 Oct 2002

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: zero, one, twopi
  implicit none

  integer, intent(in) :: n
  real(fp), intent(inout) :: x(0:n-1)  ! real parts
  real(fp), intent(inout) :: y(0:n-1)  ! imaginary parts

  integer :: i,j
  real(fp) :: x0(0:n-1),y0(0:n-1)
  real(fp) :: zsin(n-1),zcos(n-1)

  real(fp) :: zang0,znorm

  !---------------------------

  znorm=ONE/sqrt(ONE*n)

  x0(0)=x(0)
  y0(0)=y(0)
  do i=1,n-1
    x0(i)=x(i)
    y0(i)=y(i)
    x(0)=x(0)+x(i)    ! form a0
    y(0)=y(0)+y(i)    ! form a0
  enddo

  do i=1,n-1
    x(i)=x0(0)
    y(i)=y0(0)

    zang0=i*twopi/n
    call r8sincos(zang0,n-1,zsin,zcos)
    do j=1,n-1
      x(i)=x(i)+x0(j)*zcos(j)+y0(j)*zsin(j)
      y(i)=y(i)+y0(j)*zcos(j)-x0(j)*zsin(j)
    enddo
  enddo

  x=znorm*x
  y=znorm*y

  return
end subroutine c8dft

C******************** START FILE FLIN1.FOR ; GROUP SIGS2 ******************
C================================================================
C
C  FLIN1
C   INTERPOLATE ON A 1D ARRAY
C
      REAL FUNCTION FLIN1(NOUT,ARRAY,X,IDENT,XMIN,XMAX,XLR,NX)
c
c Interpolates the table ARRAY(NX) to find the value at x.
c If XLR>0, then the X grid is equally spaced on a logarithmic scale:
c
c   X(i) = XMIN * (exp(XLR)) ** ( (i-1)/(NX-1) )
c
c   So X(i) ranges from XMIN to XMIN*exp(XLR), and XLR=log(xmax/xmin).
c
c For XLR<=0, the X grid is equally spaced on a linear scale from
c XMIN to XMAX.
c
c NOUT is the fortran unit to write error messages to.
c IDENT is a code identifying the table ARRAY in error messages.
C
 
C
      DIMENSION ARRAY(NX)
C
      COMMON/ZFLINT/ ZX,ZY,JDENT,IPXL,IPYL,IPXH,IPYH
C
      external zcflnt                   ! block data initialization
C
C  INTERPOLATE TO X  LOGARITHMIC SPACING IN X
C     LINEAR IF XLR .LE. 0.0
C
C
      ZX=X
C
        if(zx .lt. xmin) then
            zzx=0.0
        else
 
      IF(XLR.GT.0.0) THEN
        ZLOGX=ALOG(ZX/XMIN)
        ZZX=1.0+ZLOGX/XLR * (NX-1)
      ELSE
        ZZX=1.0+(ZX-XMIN)/(XMAX-XMIN) * (NX-1)
      ENDIF
 
      endif
C
      IX=ZZX
C
C  CHECK FOR POINT OUT OF BOUNDS OF ARRAY
      IF(IX.GE.1) GO TO 10
C
      IPXL=IPXL-1
      IF(IPXL.GE.0) WRITE(NOUT, 9001) IDENT,X
 9001 FORMAT(///' *************************************'/
     >  '  ATTEMPT TO INTERPOLATE OUT OF BOUNDS    IDENT=',I8/
     >  '  FLIN1 SIGMA*V TABLE LOOKUP, STANDARD FIXUP TAKEN'/
     >  '  ARGUMENT:  X=',1PE10.3/
     >  ' **************************************'///)
      IX=1
      ZZX=1.0
C
 10   CONTINUE
C
      IF(IX.LT.NX) GO TO 30
      IX=NX-1
      ZZX=NX
C
      IF(ZX.GT.XMAX) THEN
        write(nout,9001) ident,x
        call bad_exit
      ENDIF
C
C---------------------------
C  OK
C
 30   CONTINUE
C
      IXP1=IX+1
      ZZX=ZZX-IX
C
C
C  INTERPOLATE
C
      FLIN1=(1.0-ZZX)*ARRAY(IX)+ZZX*ARRAY(IXP1)
C
      RETURN
      	END
C
C******************** END FILE FLIN1.FOR ; GROUP SIGS2 ******************
C-------------------------
C  FLINT LOCAL PERM. MEMORY
C   (CF SIGS2.FOR)
C
      BLOCK DATA ZCFLNT
C
      COMMON/ZFLINT/ ZX,ZY,JDENT,IPXL,IPYL,IPXH,IPYH
C
      DATA ZX/0.0/
      DATA ZY/0.0/
      DATA JDENT/0/
C
      DATA IPXL/1/
      DATA IPYL/1/
C
      DATA IPXH/10/
      DATA IPYH/10/
C
      END

C Write 2 dimensional CDF data
C Called by uf2dwr
C
C 08/14/97 CAL
C
C----------------------------------------------------------------------------
      subroutine ucdf2w(lun,
     &            f,nf1,x,nx,y,ny,iproc,
     &            flab,xlab,ylab,
     &            retn)
 
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Input
      integer       lun, iproc
      integer       nf1,   nx,    ny
      real          x(nx), y(ny), f(nf1,ny)
      character*(*) flab,  xlab,  ylab
C Return
      integer retn
 
C Definitions for CDF
      integer rank
      parameter (rank = 2)
      integer dims(rank)
      character*1 namf, namx, namy
 
C Definitions for processing
      integer       f_id, x_id, y_id
      integer       st(rank), cnt(rank)
      character*20  fl, xl, yl
      character*10  fu, xu, yu
      integer       ichan, file_id
      integer       i, j
C
      data          namf,namx,namy/'F','X','Y'/
C----------------------------------------------------------------------------
C Define 2 Dimensions
      dims(1) = nx
      dims(2) = ny
C
C get file name
      call uflchk(lun,'ucdf2w',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
C
C
      fl = flab(1:20)
      xl = xlab(1:20)
      yl = ylab(1:20)
      fu = flab(21:30)
      xu = xlab(21:30)
      yu = ylab(21:30)
 
C Enter Define Mode
      retn = nf_redef(file_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9005) NF_STRERROR(retn)
 9005    format(' % UCDF2W: nf_redef '/,'     ',a)
         return
      end if
 
C Define Processing factor
      retn = nf_put_att_int(file_id,NF_GLOBAL,'scale_factor',
     &       NF_INT,1,iproc)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9000) NF_STRERROR(retn)
 9000    format(' % UCDF2W: nf_put_att_int - iproc '/,
     >        '     ',a)
         return
      end if
C
C
C Define dimensions
      retn = nf_def_dim(file_id,'X',nx,dims(1))
      if (retn .ne. NF_NOERR) then
         write(ufelun,9008) namx, NF_STRERROR(retn)
 9008    format(' % UCDF2W: nf_def_dim ',a/,'     ',a)
         return
      end if
 
      retn = nf_def_dim(file_id,'Y',ny,dims(2))
      if (retn .ne. NF_NOERR) then
         write(ufelun,9007) namy, NF_STRERROR(retn)
         return
      end if
 
C Define Data Arrays
C------------------
 
C Define dependent variable F
      retn = nf_def_var(file_id, 'F', NF_FLOAT, rank, dims, f_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9001) namf, NF_STRERROR(retn)
 9001    format(' % UCDF2W: nf_def_var ',a/,'     ',a)
         return
      end if
 
      retn = nf_put_att_text(file_id,f_id,'units',10,fu)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9002) fu, NF_STRERROR(retn)
 9002    format(' % UCDF2W: nf_put_att_tex - units ',a/,'     ',a)
         return
      end if
 
      retn = nf_put_att_text(file_id,f_id,'long_name',20,fl)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9003) fl, NF_STRERROR(retn)
 9003    format(' % UCDF2W: nf_put_att_tex - label ',a/,'     ',a)
         return
      end if
 
C Define independent variable X
      retn = nf_def_var(file_id, 'X', NF_FLOAT, 1, dims(1), x_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9001) namx, NF_STRERROR(retn)
         return
      end if
 
      retn = nf_put_att_text(file_id,x_id,'units',10,xu)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9002) xu, NF_STRERROR(retn)
         return
      end if
      retn = nf_put_att_text(file_id,x_id,'long_name',20,xl)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9003) xl, NF_STRERROR(retn)
         return
      end if
 
C Define independent variable Y
      retn = nf_def_var(file_id, 'Y', NF_FLOAT, 1, dims(2), y_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9001) namy, NF_STRERROR(retn)
         return
      end if
      retn = nf_put_att_text(file_id,y_id,'units',10,yu)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9002) yu, NF_STRERROR(retn)
         return
      end if
      retn = nf_put_att_text(file_id,y_id,'long_name',20,yl)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9003) yl, NF_STRERROR(retn)
         return
      end if
C Enter Data Mode
      retn = nf_enddef(file_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9004) NF_STRERROR(retn)
 9004    format(' % UCDF2W: nf_enddef '/,'     ',a)
         return
      end if
C
C
C Write data array
C      retn = nf_put_var_real(file_id, f_id, f)
      st(1) = 1
      cnt(1) = nx
      cnt(2) = 1
      do i=1,ny
         st(2) = i
         retn = nf_put_vara_real(file_id, f_id, st, cnt, f(1,i))
         if (retn .ne. NF_NOERR) then
            write(ufelun,9007) i, NF_STRERROR(retn)
            return
         end if
      end do
 9007 format(' % UCDF2W: nf_put_vara_real y =',i4/,'     ',a)
 9006 format(' % UCDF2W: nf_put_var_real ',a/,'     ',a)
 
C Write X
       retn = nf_put_var_real(file_id, x_id, x)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9006) namx, NF_STRERROR(retn)
         return
      end if
C Write Y
       retn = nf_put_var_real(file_id, y_id, y)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9006) namy, NF_STRERROR(retn)
         return
      end if
      return
      end
 
 
 

C---------------------------------------------------------
C  GRFCNT - COUNT NUMBER OF PTS IN RANGE
C
      SUBROUTINE GRFCNT(X,NX,XL1,XL2,ICNT)
C
      REAL X(NX)
C
      ICNT=0
C
      ZXMIN=AMIN1(XL1,XL2)
      ZXMAX=AMAX1(XL1,XL2)
C
      DO 10 I=1,NX
        IF((X(I).GE.ZXMIN).AND.(X(I).LE.ZXMAX)) ICNT=ICNT+1
 10   CONTINUE
C
      RETURN
      END

C******************** START FILE JXUOPC.FOR ; GROUP URDUTS ******************
C-----------------------------------------------------------
C& JXUOPC UREAD INTERNAL INTEGER FCN CHECK FOR CHAR IN STRING
C
      INTEGER FUNCTION JXUOPC(ZSTRNG,ZCHAR)
C
      implicit NONE
      CHARACTER*(*), intent(in) :: ZSTRNG  ! STRING
      CHARACTER*1, intent(in) :: ZCHAR     ! CHARACTER BEING CHECKED
C
      integer icharl,ic,ichar
      character*1 zzchar,zzzchar
C
      ICHARL=INDEX(ZSTRNG,'$')-1
      IF(ICHARL.LE.0) ICHARL=LEN(ZSTRNG)
      do
         if(icharl.eq.1) exit
         if((zstrng(icharl:icharl).ne.' ').and.
     >      (zstrng(icharl:icharl).ne.char(9))) exit
         icharl=icharl-1
      enddo

      zzzchar=zchar
      call uspcap(zzzchar)

      ICHAR=0
      do ic=1,icharl
         zzchar=zstrng(ic:ic)
         call uspcap(zzchar)
         if(zzchar.eq.zzzchar) then
            ICHAR=ic
            exit
         endif
      enddo
C
      JXUOPC=ICHAR
C
      RETURN
      END
C******************** END FILE JXUOPC.FOR ; GROUP URDUTS ******************

subroutine makedens_gneg(nx,x,f,fout,gfac,inside,iedge,imin_patch,itty,istat)

  ! DMC Dec 2010

  ! some RF codes what density gradients near the edge to always be
  ! negative (i.e. always increasing towards the inside).

  ! this routine patches a profile f(1:nx) to enforce this, i.e. if at the
  ! very edge df/dx is forced to have the expected behavior.

  !  *              *
  !    *              *
  !         *   =>      *  *
  !      *  

  ! (the moved point has slightly higher value than the end point)
  ! (if more than one point is moved, the last moved point is replaced with
  ! an average between the preceding point and the first unmoved point).

  ! a derivative value limit is defined:
  !
  !    dlimit = gfac * (f(iedge)-f(inside))/(x(iedge)-x(inside))
  !
  !       with 0.00001 < gfac <= 0.1 expected & enforced
  !
  !    dlimit < 0 is expected; if not the routine returns fout = f
  !    writes a message and sets a status code
  !
  ! the profile fout(1:nx) is f(1:nx) patched so that df/dx in the
  ! edge region is no less than dlimit.  It does this, marching in until
  ! it encounters a point in the original data that has a higher value
  ! than is necessary to satisfy this condition.  This is supposed to
  ! happen before index (imin_patch) is reached.  If not, a status code
  ! is set, fout = f is returned, and a message is printed.

  use iso_c_binding, only: fp => c_double
  implicit none

  !---------------------
  !  arguments

  integer, intent(in) :: nx   ! array size
  real(fp), intent(in) :: x(nx) ! x grid; for j=inside:iedge-1 expect x(j+1)>x(j)
  real(fp), intent(in) :: f(nx) ! input profile

  real(fp), intent(out) :: fout(nx) ! modified profile

  real(fp), intent(in) :: gfac  ! derivative limit factor

  integer, intent(in) :: inside  ! inside reference point
  integer, intent(in) :: iedge   ! edge reference point

  integer, intent(in) :: imin_patch   ! index of innermost modifiable f value

  !  expected:  inside < imin_patch < iedge

  integer, intent(in) :: itty    ! I/O unit for messages
  integer, intent(out) :: istat  ! status code: 0 = OK

  !---------------------
  !  local

  integer :: ix,ix_stop
  real(fp) :: zgfac,dlimit,dx,fnew,wt,fav

  real(fp), parameter :: gmin = 0.00002_fp
  real(fp), parameter :: gmax = 0.2_fp

  !---------------------
  !  error checks

  istat = 0
  fout = f

  !  check gfac value (warning only, if out of range)
  zgfac = max(gmin,min(gmax,gfac))
  if(zgfac.ne.gfac) then
    write(itty,*) ' %makedens_gneg: local value of gfac modified to satisfy constraints:'
    write(itty,*) '  gfac as input: ',gfac,'; gfac as used: ',zgfac
  endif

  !  check reference indices

  if(iedge.le.inside) then
    istat = 1
    write(itty,*) ' ?makedens_gneg: index inputs error, iedge < inside:'
    write(itty,*) '  iedge = ',iedge,' inside = ',inside
    return
  endif

  if(imin_patch.ge.iedge) then
    istat = 1
    write(itty,*) ' ?makedens_gneg: index inputs error, imin_patch >= iedge:'
    write(itty,*) '  iedge = ',iedge,' imin_patch = ',imin_patch
    return
  endif

  if(imin_patch.le.inside) then
    istat = 1
    write(itty,*) ' ?makedens_gneg: index inputs error, imin_patch <= inside:'
    write(itty,*) '  inside = ',inside,' imin_patch = ',imin_patch
    return
  endif

  !  check x order w/in range of indices

  do ix=inside,iedge-1
    if(x(ix+1).le.x(ix)) then
      istat = 2
      exit
    endif
  enddo

  if(istat.gt.0) then
    write(itty,*) ' ?makedens_gneg: x(inside:iedge) grid not strict ascending:'
    write(itty,*) '  ',x(inside:iedge)
    return
  endif

  ! check f(inside) > f(iedge)

  if(f(inside).le.f(iedge)) then
    istat = 3
    write(itty,*) ' ?makedens_gneg:  f(inside) <= f(iedge):'
    write(itty,*) '  f(inside) = ',f(inside),'; f(iedge) = ',f(iedge)
    return
  endif

  !-------------------------------------------------
  !  OK all checks passed
  !-------------------------------------------------

  dlimit = zgfac * (f(iedge)-f(inside))/(x(iedge)-x(inside))

  ix_stop = imin_patch-1

  do ix=iedge-1,imin_patch-1,-1
    dx = x(ix+1)-x(ix)
    fnew = fout(ix+1) - dx*dlimit
    if(fout(ix).lt.fnew) then
      fout(ix)=fnew
    else
      ! OK: found a high enough value that we can stop
      ix_stop = ix+1
      if(ix_stop.lt.iedge-1) then
        wt = (x(ix_stop)-x(ix_stop-1))/(x(ix_stop+1)-x(ix_stop-1))
        fav = fout(ix_stop-1)*(1.0_fp-wt) + fout(ix_stop+1)*wt
        fout(ix_stop) = (fout(ix_stop) + fav)*0.5_fp
      endif
      exit
    endif
  enddo

  if(ix_stop.lt.imin_patch) then
    istat = 99
    write(itty,*) ' ?makedens_gneg: derivative patch failed, patch region too large.'
    fout = f
    return
  endif

  return
end subroutine makedens_gneg

!------------------------------------------------------------------------------
!
!            ******************************************
!            *            A L F L I B                 *
!            *                                        *
!            * ALADDIN FITTED FORM SUBROUTINE LIBRARY *
!            ******************************************
!
!                  VERSION 1.0    30/04/1989
!
!     ORIGINAL VERSION DESIGNED AND WRITTEN BY R. A. HULSE, OF THE
!     PRINCETON UNIVERSITY, PLASMA PHYSICS LABORATORY.
!     (PAPER TO BE SUBMITTED TO THE JOURNAL OF COMPUTATIONAL PHYSICS
!      COMMUNICATIONS)
!
!------------------------------------------------------------------------------
!
!     REV: 03/12/89 BY J.J.SMITH IAEA ATOMIC AND MOLECULAR DATA UNIT
!          TO DEFINE A STANDARD, ALL ROUTINES RECEIVE AND PASS NUMERIC
!          ARGUMENTS IN DOUBLE PRECISION
!
!##############################################################################
!
SUBROUTINE ALMEWE_Z(PTE, PCF, KNCF, PRATE, KERMSG)
!
!     GENERALIZED GAUNT FACTOR LINE EXCITATION CALCULATION
!
!     REFERENCE: R. MEWE, ASTRON. AND ASTROPHYS. 20, 215 (1972)
!
!
!     PTE = ELECTRON TEMPERATURE (KEV)
!
!     PCF(1) = PWVL = EXCITATION WAVELENGTH (ANGSTROMS)
!     PCF(2) = PEIJ = EXCITATION ENERGY (eV)
!            (IF PEIJ=0, ASSUME A RESONANCE LINE AND CALCULATE EIJ FROM PWVL)
!     PCF(3) = PFIJ = OSCILLATOR STRENGTH
!     PCF(4) = PBIJ = BRANCHING RATIO
!     PCF(5, 6, 7, 8) = PA, PB, PC, PD = COEFFICIENTS FOR GAUNT FACTOR FORMULA
!
!     KNCF = NUMBER OF COEFFICIENTS SUPPLIED IN PCF (MUST BE 8)
!     PRATE = LINE EXCITATION RATE COEFFICIENT (cm[3]/s)
!     KERMSG = ERROR MESSAGE, ' ' IS OK
!
!     WRITTEN BY R. A. HULSE
!
!- Modifications
!     26-May-1999    james.conboy@jet.uk
!                    CHAR*(*) > CHAR*80, pgf90 bug workaround
!==============================================================================
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use alpcom_mod
  use alcom_mod
  implicit none
  INTEGER kncf
!============
  real(fp) PTE,PRATE
  real(fp) ZWVL, ZEIJ, ZFIJ, ZBIJ, ZA, ZB, ZC, ZD, ZY
  real(fp) ZGBAR, ZXCOEF
  real(fp) PCF(*)
  CHARACTER*(*)  KERMSG
!
  IF(PTE .LE. 0.0_fp) THEN
     KERMSG = ' ALMEWE: TE .LE. 0'
     RETURN
  ELSE IF(KNCF .NE. 8) THEN
     KERMSG = ' ALMEWE: INCORRECT NUMBER OF COEFFICIENTS'
     RETURN
  ELSE
     KERMSG = ' '
  ENDIF
!
  ZWVL = PCF(1)
  ZEIJ = PCF(2)
  ZFIJ = PCF(3)
  ZBIJ = PCF(4)
  ZA = PCF(5)
  ZB = PCF(6)
  ZC = PCF(7)
  ZD = PCF(8)
!
  IF(ZEIJ .EQ. 0.0_fp) ZEIJ = 12397.7_fp / ZWVL
!
  ZY = ZEIJ / (1000.0_fp * PTE)
!
!     GAUNT FACTOR
!
  ZGBAR = ZA + (ZB * ZY - ZC * ZY*ZY + ZD) *&
       ( log( (ZY+1.0_fp)/ZY ) - 0.4_fp / ((1.0_fp+ZY)**2)) + ZC * ZY
!
  ZXCOEF = 1.58e-05_fp * ZFIJ * ZGBAR * exp(-ZY)&
       / (sqrt(1000.0_fp*PTE) * ZEIJ)
  PRATE = ZBIJ * ZXCOEF
!
  RETURN
END SUBROUTINE ALMEWE_Z
!
!##############################################################################
!
SUBROUTINE ALBELI_Z(PE, PCF, KNCF, PXS, KERMSG)
!
!     ELECTRON IMPACT IONIZATION CROSS SECTION FITS
!
!     REFERENCE: K. L. BELL ET AL, J. PHYS. CHEM. REF. DATA 12, 891
!                (1983)
!
!     THIS IS AN IAEA SUBROUTINE TO CALCULATE CROSS SECTIONS FOR
!     PROJECTILE ENERGY (eV).
!
!     PE =  ELECTRON ENERGY (EV)
!
!     THE NUMBER OF FITTING PARAMETERS VARIES DEPENDING ON THE
!     NUMBER OF TERMS TAKEN IN THE NUMERICAL FITTING AND ON THE
!     ALLOWANCE FOR EXCITATION AUTOIONIZATION IN THE CROSS SECTION
!     TO FIT CROSS SECTIONS WITH EXCITATION AUTOIONIZATION TWO SEPERATE
!     FITS ARE DEFINED. ONE FROM THE IONIZATION THRESHOLD AND A SECOND
!     FIT FOR ENERGIES ABOVE THE AUTOIONIZATION THRESHOLD.
!     THE NUMBER OF PARAMETERS IN ANY ENTRY IS GIVEN BY KNCF
!
!     PCF(1) = IONIZATION POTENTIAL (eV)
!     PCF(2-7) = FITTING PARAMETERS ( CAN BE LESS THAN 6 PARAMETERS)
!
!     IF CROSS SECTION HAS EXCITATION AUTOIONIZATION STRUCTURE THEN
!     FOR THE SECOND FIT
!
!     PCF(8) = AUTOIONIZATION THRESHOLD (eV)
!     PCF(9) = IONIZATION POTENTIAL (eV)
!     PCF(10-15) = FITTING PARAMETERS FOR THIS FIT (CAN BE LESS THAN
!                  6 PARAMETERS)
!
!     KNCF = NUMBER OF PARAMETERS SUPPLIED IN PCF (MUST BE 8)
!     PXS = IONIZATION CROSS SECTION (CM[2])
!     KERMSG = ERROR MESSAGE, ' ' IS OK
!
!     WRITTEN BY J. J. SMITH , IAEA ATOMIC AND MOLECULAR DATA UNIT
!
!- Modifications
!     26-May-1999    james.conboy@jet.uk
!                    CHAR*(*) > CHAR*80, pgf90 bug workaround
!==============================================================================
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER kncf,istart,iend,i
!============
  real(fp) PE, PXS
  real(fp) ION, POWER, POWER1, XS, A, X, X2
  real(fp) PCF(*)
  CHARACTER*(*) KERMSG   
!
  IF(PE .LT. PCF(1)) THEN
     KERMSG = 'ELECTRON ENERGY BELOW THRESHOLD FOR THE REACTION'
     RETURN
  ELSE
     KERMSG = ' '
  ENDIF
!
!---  DETERMINE PARAMETERS TO BE USED
!
  IF (KNCF .GT. 7 .AND. PE .GT. PCF(8) ) THEN
!
!---      AUTOIONIZATION INCLUDED AND ENERGY > AUTOIONIZATION THRESHOLD
!
     ION = PCF(9)
     A=PCF(10)
     ISTART=11
     IEND=KNCF
  ELSE
     ION = PCF(1)
     A=PCF(2)
     ISTART=3
     IF (KNCF .GT. 7) THEN
        IEND=7
     ELSE
        IEND = KNCF
     ENDIF
  ENDIF
!
!---  GENERATE CROSS SECTION
!
  X=ION/PE
  X2= 1.0_fp/X
!
!---  CONTRIBUTION FROM BETHE TERM
!
  XS = A*log(X2)
  IF ( KNCF .GE. ISTART) THEN
!
!---  CONTRIBUTION FROM LEAST SQUARES FIT TERMS
!
     POWER1 = 1.0_fp - X
     POWER = POWER1
     DO I=ISTART,IEND
        XS = XS + PCF(I)*POWER
        POWER = POWER*POWER1
     enddo
  ENDIF
!
!---  SCALE RESULTS TO CM[2]
!
  PXS= 1.0e-13_fp*XS /(PE*ION)
!
  RETURN
END SUBROUTINE ALBELI_Z
SUBROUTINE ALCHEB_Z(PET, PCF, KNCF, PFIT, KERMSG)
!
!     THIS IS AN ORNL:CFADC SUBROUTINE TO CALCULATE CROSS SECTIONS IN
!     (cm[2]) VERSUS ENERGY IN (EV/AMU) OR RATE COEFFICIENTS IN
!     (cm[3]/s) VERSUS MAXWELLIAN TEMPERATURE IN (eV) FROM CHEBYSHEV
!     POLYNOMIAL FITTING COEFFICIENTS
!
!     THESE FITS ARE VALID ONLY BETWEEN THE LIMITS EMIN AND EMAX,
!     WHICH ARE COEFFICIENTS PCF(10) AND PCF(11) IN THE ENTRY DATA FIELD
!
!     PET = COLLISION ENERGY IN eV/amu OR MAXWELLIAN TEMPERATURE IN eV
!
!     KERMSG = BLANK IF NO ERRORS
!
!     PFIT = CROSS SECTION IN cm[2] OR RATE COEFFICIENT IN cm[3]/s
!
!     WRITTEN BY H. HUNTER, CFADC OAK RIDGE NATIONAL LABORATORY
!     (MODIFIED TO ALADDIN CALLING STRUCTURE 4/21/88 R.A. HULSE)
!
!- Modifications
!     26-May-1999    james.conboy@jet.uk
!                    CHAR*(*) > CHAR*80, pgf90 bug workaround
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER kncf,k
!============
  real(fp) PET, PFIT
  real(fp) EMIN, EMAX, CHEB, EMINL, EMAXL, ENL, XNORM
  real(fp) TWOX, PREV, PREV2
  real(fp) PCF(*)
  CHARACTER*(*)  KERMSG
  EMIN = PCF(10)
  EMAX = PCF(11)
  IF(PET .GE. EMIN .AND. PET .LE. EMAX) THEN
     KERMSG(1:1) = ' '
  ELSE
     KERMSG = 'OUTSIDE RANGE OF FIT IN ALCHEB'
     RETURN
  ENDIF
!
!     CALCULATE POLYNOMIAL USING RECURSION RELATION
!
  K = 9
  CHEB = PCF(K)
  EMINL = log(EMIN)
  EMAXL = log(EMAX)
  ENL= log(PET)
  K = K-1
  XNORM = (ENL-EMINL-(EMAXL-ENL)) / (EMAXL-EMINL)
  TWOX = 2.0_fp *  XNORM
  PREV2 = 0.0_fp
10 PREV = CHEB
  IF(K .NE. 1) THEN
     CHEB = PCF(K) + TWOX*PREV - PREV2
     PREV2 = PREV
     K = K-1
     GO TO 10
  ENDIF
  CHEB = 0.5_fp*PCF(1) + XNORM*PREV - PREV2
  PFIT = exp(CHEB)
  RETURN
!
END SUBROUTINE ALCHEB_Z
SUBROUTINE ALKING_Z(PET, PCF, KNCF, PFIT, KERMSG)
!
!     THIS IS AN IAEA SUBROUTINE TO CALCULATE THE REACTION RATE
!     COEFFICIENT (cm[3]/s) VERSUS ELECTRON TEMPREATURE (eV).
!
!     THESE FITS ARE VALID ONLY BETWEEN THE LIMITS TMIN AND TMAX,
!     WHICH ARE COEFFICIENTS PCF(2) AND PCF(3) IN THE ENTRY DATA FIELD
!     PCF(1) IS THE TRANSITION ENERGY (eV) FOR THE RECACTION
!
!     PET = MAXWELLIAN TEMPERATURE IN eV
!
!     KERMSG = BLANK IF NO ERRORS
!
!     PFIT = RATE COEFFICIENT IN cm[3]/s
!
!     WRITTEN BY J. J. SMITH , IAEA ATOMIC AND MOLECULAR DATA UNIT
!
!- Modifications
!     26-May-1999    james.conboy@jet.uk
!                    CHAR*(*) > CHAR*80, pgf90 bug workaround
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER kncf,i
!============
  real(fp) PET, PFIT
  real(fp) CONV, YTEMP, POWER1, POWER, TEN
  real(fp) EMIN, EMAX, TK, CONT
  real(fp) PCF(*)
  CHARACTER*(*)  KERMSG
  DATA CONV/1.16045e+04_fp/
  DATA TEN/1.0e+01_fp/
!
  EMIN = PCF(2)
  EMAX = PCF(3)
  IF(PET .GE. EMIN .AND. PET .LE. EMAX) THEN
     KERMSG = ' '
  ELSE
     KERMSG = 'OUTSIDE RANGE OF FIT IN ALKING'
     RETURN
  ENDIF
!
!     FORM THE ELECTRON TEMPREATURE IN DEGREES KELVIN
!
  TK = PET*CONV
  YTEMP = PCF(4)
!
!     GENERATE THE RATE COEFFICIENT FROM THE LOG POLYNOMIAL EXPRESSION
!
  POWER1 = log10(TK)
  POWER = POWER1
  DO I=5,KNCF
     CONT=PCF(I)*POWER
     YTEMP = YTEMP+CONT
     POWER = POWER * POWER1
  enddo
  PFIT = TEN**YTEMP
  RETURN
!
END SUBROUTINE ALKING_Z
!
!##############################################################################
!
SUBROUTINE ALPHACX_Z(PE, PCF, KNCF, PFIT, KERMSG)
!
!     THIS IS A SUBROUTINE TO CALCULATE CROSS SECTION FOR
!     PROJECTILE ENERGY (eV/amu).
!
!     THE APPROXIMATE RANGE OF VALIITY OF THE FIT IS GIVEN BY THE
!     PARAMETERS PCF(1) AND PCF(2) WHICH ARE THE SCALED ENERGIES
!     PE/DSQRT(Q) (eV/u), WHERE Q IS THE CHARGE STATE OF THE ION.
!
!     PE = PROJECTILE ENERGY (eV/amu)
!
!     KERMSG = BLANK IF NO ERRORS
!
!     PFIT = CROSS SECTION IN cm[2]
!
!     PCF(1) = LOWER LIMIT OF THE RANGE OF VALIDITY OF THE SCALED
!              PROJECTILE ENERGY IN eV/(u*sqrt(q)).
!     PCF(2) = UPPER LIMIT OF THE RANGE OF VALIDITY OF THE SCALED
!              PROJECTILE ENERGY IN eV/(u*sqrt(q)).
!     PCF(3-6) = A, B, C, D FITTING PARAMETERS
!     PCF(7) = Q, THE CHARGE STATE OF THE PROJECTILE ION. THIS MUST BE
!              INPUT INTO THE COEFFICIENT ARRAY. THIS IS NOT INCLUDED
!              IN THE DATA ENTRIES.
!
!     WRITTEN BY J. J. SMITH , IAEA ATOMIC AND MOLECULAR DATA UNIT
!
!- Modifications
!     26-May-1999    james.conboy@jet.uk
!                    CHAR*(*) > CHAR*80, pgf90 bug workaround
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER kncf
!============
  real(fp) PE, PFIT
  real(fp) PEK, Q, Q2, A, B, C, D, F1, F2, ELOW, EHIGH
  real(fp) PCF(*)
  CHARACTER*(*)  KERMSG
!
  A = PCF(3)
  B = PCF(4)
  C = PCF(5)
  D = PCF(6)
  Q = PCF(7)
  Q2 = sqrt(Q)
!
!---  DETERMINE THE SCALED PROJECTILE ENERGY (E/DSQRT(Q)) IN KeV/amu
!
  PEK = PE*1.0e-03_fp/Q2
!
!---  CHECK THAT THE ENERGY IS WITHIN THE VALID ENERGY RANGES
!
  ELOW = PCF(1)*1.0e-03_fp
  EHIGH = PCF(2)*1.0e-03_fp
!
  KERMSG = ' '
  IF (PEK .LT. ELOW .OR. PEK .GT. EHIGH) THEN
     KERMSG = 'OUTSIDE RANGE OF FIT IN ALPHACX'
     RETURN
  ENDIF
!
  IF(Q .LT. 5 .OR. Q .GT. 26) THEN
     KERMSG =&
          'THE CHARGE STATE (Q) MUST BE IN THE RANGE 5 <= Q <= 26'
     RETURN
  ENDIF
!
  F1 = A * Q * log ( B * Q2 / PEK )
  F2 = ( C * PEK * PEK / Q )  +  D * ( ( PEK / Q2 ) ** 4.5_fp )
  PFIT = F1 / ( 1.0_fp + F2 )
!
  RETURN
!
END SUBROUTINE ALPHACX_Z
!
!##############################################################################
!
SUBROUTINE ALJAN1_Z(PET, PCF, KNCF, PFIT, KERMSG)
!
!     THIS IS A SUBROUTINE TO CALCULATE CROSS SECTIONS (cm[2])
!     VERSUS ENERGY (eV) OR ELECTRON IMPACT REACTION RATE
!     COEFFICIENT (cm[3]/s) VERSUS ELECTRON TEMPREATURE (eV).
!     USING THE LOG NATURAL POLYNOMIAL FIT OF JANEV ET AL.
!
!     THESE FITS ARE VALID ONLY BETWEEN THE LIMITS EMIN AND EMAX,
!     WHICH ARE PARAMETERS PCF(1) AND PCF(2) IN THE ENTRY DATA FIELD
!     THE PARAMETERS PCF(3-11) ARE THE COEFICIENTS FOR THE FIITING
!     FORMULA.
!
!     PET = COLLISION ENERGY IN eV
!
!     KERMSG = BLANK IF NO ERRORS
!
!     PFIT = CROSS SECTION IN cm[2]
!
!     WRITTEN BY J. J. SMITH , IAEA ATOMIC AND MOLECULAR DATA UNIT
!
!- Modifications
!     26-May-1999    james.conboy@jet.uk
!                    CHAR*(*) > CHAR*80, pgf90 bug workaround
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER kncf,i
!============
  real(fp) PET, PFIT
  real(fp) EMIN, EMAX, ALOGE1, ALOGE, XJAN, XCON
  real(fp) PCF(*)
  CHARACTER*(*)  KERMSG
!
  EMIN=PCF(1)
  EMAX = PCF(2)
  IF(PET .GE. EMIN .AND. PET .LE. EMAX) THEN
     KERMSG = ' '
  ELSE
     KERMSG = 'OUTSIDE RANGE OF FIT IN ALJANXS'
     RETURN
  ENDIF
!
!     CALCULATE NATUTRAL LOG POLYNOMIAL
!
  ALOGE1 = log(PET)
  ALOGE = ALOGE1
  XJAN = PCF(3)
  DO I=4,11
     XCON = PCF(I)*ALOGE
     XJAN = XJAN + XCON
     ALOGE=ALOGE * ALOGE1
!MG10   ALOGE=ALOGE * ALOGE1
  enddo
  PFIT = exp(XJAN)
  RETURN
!
END SUBROUTINE ALJAN1_Z
!
!##############################################################################
!
SUBROUTINE ETABSQ_Z(PE, PCF, KNCF, PYIELD, KERMSG)
!
!     THIS IS A SUBROUTINE TO CALCULATE THE YIELDS (ATOMS/ION) OF
!     ION-INDUCED SPUTTERING OF MONATOMIC SOLID
!
!     PE = COLLISION ENERGY IN eV
!
!     KERMSG = BLANK IF NO ERRORS
!
!     PYIELD = YIELD OF ATOMS/IONS PER INCIDENT ION
!
!     PCF(1) = ATOMIC NUMBER OF INCIDENT ION
!     PCF(2) = ATOMIC MASS OF INCIDENT ION
!     PCF(3) = ATOMIC NUMBER OF TARGET
!     PCF(4) = ATOMIC MASS OF TARGET
!     PCF(5) = SUBLIMATION ENERGY OF TARGET (EV)
!     PCF(6) = Q VALUE FOR TARGET
!
!     WRITTEN BY J. J. SMITH , IAEA ATOMIC AND MOLECULAR DATA UNIT
!
!- Modifications
!     26-May-1999    james.conboy@jet.uk
!                    CHAR*(*) > CHAR*80, pgf90 bug workaround
!------------------------------------------------------------------------------
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER kncf
!============
  real(fp) PE, PYIELD
  real(fp) M1, Z1, M2, Z2, Q, ETA, SN, SE, K, ALPHA, US
  real(fp) Z123, Z223, SQRETA, ETH, GAMMA
  real(fp) PCF(*)
  CHARACTER*(*)  KERMSG
!
  Z1 = PCF(1)
  M1 = PCF(2)
  Z2 = PCF(3)
  M2 = PCF(4)
  US = PCF(5)
  Q = PCF(6)
!
  KERMSG = ' '
!
!---- DETERMINE THRESHOLD ENERGY
!
  GAMMA = 4.0_fp * M1 * M2 / ( (M1 + M2) **2 )
  IF (M1 .GE. M2) THEN
     ETH = (4.0_fp/3.0_fp)**6.0_fp * US/GAMMA
  ELSE
     ETH = (US/GAMMA)*((2.0_fp*(M1+M2))/(M1+2.0_fp* M2))**6.0_fp
  ENDIF
  IF (PE .LT. ETH ) THEN
     KERMSG =&
          ' INCIDENT ION ENERGY BELOW THRESHOLD FOR REACTION'
     RETURN
  ENDIF
!
!---- DETERMINE COMPONENTS OF EQUATION FOR YIELD
!
  Z123 = Z1**0.666666_fp
  Z223 = Z2**0.666666_fp
  ETA = 0.03255_fp*M2*PE/(M1+M2)
  ETA = ETA/(Z1 * Z2 * sqrt(Z123 + Z223))
  SQRETA= sqrt(ETA)
!
  SN =  3.441_fp * SQRETA * log (ETA + 2.718_fp)/&
       (1.0_fp + 6.355_fp * SQRETA + ETA * (-1.708_fp + 6.882_fp * SQRETA))
!
  SE =  SQRETA * 0.079_fp * ((M1+M2)**1.5_fp) * Z123 * sqrt(Z2)/&
       (M1**1.5_fp * M2**0.5_fp * ((Z123 + Z223)**0.75_fp))
!
  K = 8.478_fp*Z1*Z2*M1/(sqrt(Z123+Z223) * (M1+M2))
  ALPHA = 0.1_fp+0.155_fp*((M2/M1)**0.730_fp) +&
       0.001_fp*((M2/M1)**1.5_fp)
!
!       IF Q=0 SET Q=ALPHA
!
  IF (Q .EQ. 0.0_fp) Q=ALPHA
!
!     FINALLY DETERMINE THE SPUTTERING YIELD
!
  PYIELD = 0.42_fp * ALPHA * Q * K * SN  *&
       ((1.0_fp - sqrt (ETH/PE))**2.8_fp)  /&
       (US * ( 1.0_fp + (0.35_fp * US * SE)))
  RETURN
!
END SUBROUTINE ETABSQ_Z
!
!##############################################################################
!
SUBROUTINE RTABSQ_Z(CION, CTARGT, RTABCF, KERMSG)
!
!     THIS IS A SUBROUTINE TO READ DATA FOR THE YIELDS (ATOMS/ION) OF
!     ION-INDUCED SPUTTERING OF MONATOMIC SOLIDS
!
!     CION  = THE USER SUPPLIED ATOMIC SPECIES FOR THE INCIDENT ION
!     CTARGT = THE USER SUPPLIED ATOMIC SPECIES OF THE TARGET
!
!     RTABCF = ARRAY OF COEFFICIENT DATA FOR PARTICULAR INCIDENT ION/
!              TARGET PAIR NEEDED BY ROUTINE ETABSQ FOR THE FUNCTION
!              EVALUATION
!
!     RTABCF(1) = ATOMIC NUMBER OF INCIDENT ION
!     RTABCF(2) = ATOMIC MASS OF INCIDENT ION
!     RTABCF(3) = ATOMIC NUMBER OF TARGET
!     RTABCF(4) = ATOMIC MASS OF TARGET
!     RTABCF(5) = SUBLIMATION ENERGY OF TARGET (EV)
!     RTABCF(6) = Q VALUE FOR TARGET
!
!     SELF SPUTTERING DATA IS ONLY AVAILABLE FOR THOSE SOLIDS WITH A
!     '*' IN THE TABLE AS READ IN VARIABLE FSELF.
!
!     WRITTEN BY J. J. SMITH , IAEA ATOMIC AND MOLECULAR DATA UNIT
!
!- Modifications
!     26-May-1999    james.conboy@jet.uk
!                    CHAR*(*) > CHAR*80, pgf90 bug workaround
!------------------------------------------------------------------------------
!
  use iso_c_binding, only: fp => c_double
  use alpcom_mod
  use alcom_mod
  IMPLICIT NONE
!============
! idecl:  explicitize implicit INTEGER declarations:
  INTEGER i,iline,icferr
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) atmno,atmass,subeng,q
!============
  CHARACTER*(*)  KERMSG
  CHARACTER*2 CION, CTARGT, CATOM
  CHARACTER*1 FSELF
  real(fp) RTABCF (*)
!
  KERMSG = ' '
!
!       INITIALISE COEFFICIENT ARRAY ELEMENTS TO ZERO. ON ENTRY THEY
!       MAY BE NON-ZERO FROM LAST CALL
!
  RTABCF(1:5) = 0.0_fp
!
!       READ AND CONVERT DATA IN INPUT TABLE HELD IN BUFFER EBUFF
!       AND LOOK FOR VALID ION AND TARGET COMBINATION MATCHING
!       VALUES IN CION AND CTARGT.
!
!       THE FIRST SIX LINES OF COEFFICIENT BLOCK DESCRIBE THE TABLE
!       FORMAT, THESE SHOULD NOT BE PROCESSED
!
  ILINE = LCFPTR + 6
!
10 READ(EBUFF(ILINE),&
        '(BN,1X,A2,6X,F4.0,7X,F7.2,8X,F5.2,7X,F5.2,13X,A1)',&
        END=100, IOSTAT=ICFERR) CATOM, ATMNO, ATMASS, SUBENG, Q, FSELF
!
!       IF NOT INTERNAL READ ERROR, LOOP BACK FOR NEXT COEFFICIENT
!       OTHERWISE, ERROR RETURN
!
  IF(ICFERR .EQ. 0) GO TO 20
!
  KERMSG = ' READ ERROR IN LINE OF TABLE "'//EBUFF(ILINE)//'"'
  RETURN
!
20 IF ( CATOM .EQ. CION) THEN
     RTABCF(1) = ATMNO
     RTABCF(2) = ATMASS
  ENDIF
  IF ( CATOM .EQ. CTARGT) THEN
!
!       CHECK SUBLIMATION ENERGY ALL TARGETS MUST HAVE A NON-ZERO VALUE
!
     IF ( SUBENG .EQ. 0.0_fp) THEN
        KERMSG = ' NO SUBLIMATION ENERGY FOR TARGET IN INPUT TABLE'
        RETURN
     ENDIF
     RTABCF(3) = ATMNO
     RTABCF(4) = ATMASS
     RTABCF(5) = SUBENG
     RTABCF(6) = Q
  ENDIF
!
!       CHECK IF THE TARGET AND ION  HAVE BOTH BEEN RETREIVED
!
  IF ( (RTABCF(1) .NE. 0.0_fp) .AND. (RTABCF(3) .NE. 0.0_fp)) THEN
!
!         IF TARGET AND ION ARE IDENTICAL (SELF SPUTTERING) THEN
!         CHECK IF THE EMPIRICAL FORMULA IS VALID FOR SELF SPUTTERING
!         (VALID IF FSELF ='*' )
!
     IF (CTARGT .EQ. CION .AND. FSELF .NE. '*')&
          KERMSG =&
          'THERE IS NO DATA FOR SELF SPUTTERING FOR TARGET IN TABLE'
     RETURN
  ENDIF
  ILINE = ILINE + 1
  GO TO 10
!
100  KERMSG = 'END OF TABLE FILE NO ION/TARGET MATCH FOUND'
end SUBROUTINE RTABSQ_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

	integer function jc_trim(string)	!subr Find last blank  !02/06/85
	implicit none
	character string*(*)
	integer i, jl
	jl=1				!Returns length >= 1
	i=len(string)
	do while (i.gt.jl)
	  if(ichar(string(i:i)).gt.ichar(' ')) jl=i
	  i=i-1
	enddo
	jc_trim=jl
	end
	integer function jc_len(string)		!subr Find string length	!12/06/90
	implicit none
	character string*(*)
	integer i, jl
	jl=0				!blank string returns length 0
	i=len(string)
	do while (i.gt.jl)
	  if(ichar(string(i:i)).gt.ichar(' ')) jl=i
	  i=i-1
	enddo
	jc_len=jl
	end
	subroutine jc_term(c)		!Return terminal type		!04/08/85
	implicit none
	character c*(*),cterm*4
	integer i, jl, igood, nn
	call jc_trnlog(' ','TERMINAL_TYPE',cterm,nn,igood)
	c=cterm
	end
	subroutine jc__bs(line) 	!Remove control chars		!11/13/84
	implicit none
C				!original version processed backspaces
	character line*(*)
	integer i
	do i=1,len(line)		!convert CTRL characters to blanks
	  if(ichar(line(i:i)).lt.ichar(' ')) line(i:i)=' '
	enddo
	end
	subroutine jc_upper(string)	!Convert to upper case
	implicit none
	character string*(*)
	integer i, ich
	integer hexdf
	data hexdf/Z'df'/

	do i=1,len(string)
	  ich=ichar(string(i:i))
	  if(ich.ge.ichar('a') .and. ich.le.ichar('z')) then
	     ich=iand(ich,hexdf)
	     string(i:i)=char(ich)
	  endif
	enddo
	end
	subroutine jc__creal(a,c)	!Real-->Shortest string		!10/03/84
	implicit none
	character c*(*),string*16
	real a
	integer n, jc_trim
c	write(string,'(1pg)') a
	write(string,'(bn,1pg16.9)') a
	n=index(string,'E+00')-1	!drop zero exponent
	if(n.le.0) n=jc_trim(string)	!find last blank
	if(index(string(1:n),'E').eq.0) then	!if no exponent
	  do while(string(n:n).eq.'0')	! drop trailing zeros
	    n=n-1
	  end do
	endif
	if (n .lt. len(string)) string(n+1:)=' '
	call jc_left(string,c)		!Left justify the string
	end
	subroutine jc_left(c1,c2)	!Left justify the string	!02/23/85
	implicit none
	character*(*) c1,c2		!Input, output string
	integer j, n
	n=len(c1)
	j=1
	do while(c1(j:j).le.' '.and.j.lt.n)
	  j=j+1
	end do
	c2=c1(j:n)
	end
	subroutine jc__cint(i,c)	!Integer-->Shortest string	!10/03/84
	implicit none
	character c*(*),string*12
	integer i
	write(string,'(i12)') i
	call jc_left(string,c)
	end
	function jc_isdigits(c)		!subr Check for digits		!10/04/89
	implicit none
	character c*(*),c1*1
	logical jc_isdigits
	integer j, nc, jc_len
	jc_isdigits=.false.
	nc=jc_len(c)
	if(nc.eq.0) return
	do j=1,nc
	  c1=c(j:j)
	  if(c1.lt.'0' .or. c1.gt.'9') return
	enddo
	jc_isdigits=.true.
	end
	function jc_isreal(c)		!subr Check for real number	!09/18/94
	implicit none
	character c*(*),c1*1
	logical jc_isreal,isan
	integer j, nc
	integer jc_len
	jc_isreal=.false.
	nc=jc_len(c)
	if(nc.eq.0) return
	do j=1,nc
	  c1=c(j:j)
	  isan=.false.
	  if(c1.ge.'0' .and. c1.le.'9') isan=.true.
	  if(c1.eq.'.' .or.  c1.eq.'-') isan=.true.
	  if(.not.isan) return
	enddo
	jc_isreal=.true.
	end
	function jc_isalnum(c)		!subr Check for alpha-numeric	!04/01/93
	implicit none
	character c*1
	logical jc_isalnum,isan
	isan=.false.
	if(c.ge.'0' .and. c.le.'9') isan=.true.
	if(c.ge.'A' .and. c.le.'Z') isan=.true.
	if(c.eq.'.') isan=.true.
	if(c.eq.'-') isan=.true.
	jc_isalnum=isan
	end

	integer function jc_match(clist,cval,nlist) !subr Match string array	!08/12/90
	implicit none
	character cval*(*),clist(nlist)*(*)
	integer nlist
	integer i
	do i=1,nlist
	  if(cval.eq.clist(i)) then
	    jc_match=i
	    return
	  endif
	enddo
	jc_match=0
	end
	integer function jc_skipc(str,ist,chr)	!subr Skip past chr in str	!01/20/97
	implicit none
	character str*(*),chr*1
	integer ist, iptr, lstr
	integer jc_len
	iptr=ist
	lstr=jc_len(str)
	do while (iptr.le.lstr .and. str(iptr:iptr).eq.chr)
	  iptr=iptr+1
	enddo
	jc_skipc=iptr
	end

C******************** START FILE UGLINE.FOR ; GROUP UFHELP ******************
C-----------------------------
C&  UGLINE  GET ONE LINE FROM INPUT FILE (UREAD HELP)
C
      SUBROUTINE UGLINE(ZLINE,LUN,IEND,IDELIM)
C
      CHARACTER*(*) ZLINE
      CHARACTER*5 ZDELIM,ZTEST
      DATA ZDELIM/'<*=*>'/
C
C  ZLINE-- INPUT LINE BUFFER
C   LUN  INPUT FILE LOGICAL UNIT NUMBER
C   IEND:  SET TO 1 IF END-OF-FILE ON READ
C   IDELIM:  SET TO 1 IF DELIMITER SYMBOL "<*=*>" ENCOUNTERED
C
      IEND=0
      IDELIM=0
      READ(LUN,1000,END=100) ZLINE
 1000 FORMAT(A)
      ZTEST=ZLINE(1:5)
      IF(ZTEST.EQ.ZDELIM) IDELIM=1
      RETURN
 100  CONTINUE
      IEND=1
      RETURN
      	END
C******************** END FILE UGLINE.FOR ; GROUP UFHELP ******************

C******************** START FILE INTUSP.FOR ; GROUP USPARM ******************
C------------------------------------------------------------
C& INTUSP   DECODE UREAD STRING PARAMETER AS INTEGER VALUE
C  RETURN IER=1 IF DECODE ATTEMPT FAILS
C
      INTEGER FUNCTION INTUSP(ZVAL,IER)
C
      CHARACTER*96 ZVAL
C
      I=JIDCOD(ZVAL,IC,ID,ICOD)
C
      IF(ICOD.EQ.1) GO TO 90
C  SUCCESSFULLY DECODED
      IER=0
      INTUSP=I
      RETURN
C  ERROR
 90   CONTINUE
      CALL UERMSG('? ATTEMPTED ARITHMETIC WITH NON-INTEGER PARAMETER',
     >     trim(ZVAL),1)
      IER=1
      INTUSP=0
      RETURN
      END
C******************** END FILE INTUSP.FOR ; GROUP USPARM ******************

subroutine frantic_kernel
  !  THIS subroutine WAS WRITTEN BY HARRY. H. TOWNER OF THE PRINCETON
  !  PLASMA PHYSICS LAB.  THIS ROUTINE WILL FINISH CONSTRUCTING
  !  THE S0COLD AND GFUN ARRAYS.  IT WILL ALSO CONSTRUCT THE KERNEL
  !  FROM GFUN.
  !
  ! UPDATES:
  !
  !  TBT Jun, 1991  Added NINLDX as the pointer to the lightest gas in
  !                 BACKZ for this source.
  !	6/04/91 TBT Switched loop 10 and 20 to fix do 20 INL=NNEUT,1,-1
  !                   bug when we had BACKZ=2,1 which overwrote good value.
  !	5/20/91 TBT Added INDX to handle H and He plasmas.
  !
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: one
  use frantic_module
  implicit none
  real(fp), parameter :: FOUR = 4.0_fp
  !-----------------
  integer :: ik,i,idir,j,inl
  real(fp) :: zts1,zts3,zts2,zts4,zga,zts0
  !-----------------
  !
  ! I NOW LOOP OVER ALL NEUTRAL SPECIES.
  do IK=1,NNEUT
    ZTS1=FOUR*FLUXI0(IK)
    ! I NOW LOOP OVER ALL BIRTH ZONES.
    do I=1,NZONEC
      if(.NOT.MCFLAG) GO TO 50
      ZTS3=ONE/ALPHAT(I,I,IK)
      WALL(I,IK)=WALL(I,IK)*ZTS3
      
      do IDIR=1,2
        do J=1,NZONEC
          PRFLUX(I,J,IK,IDIR)=PRFLUX(I,J,IK,IDIR)*ZTS3
        end do
      end do

50    if(ESFLAG) then             ! TBT 6/91
        ZTS2=BETAT(I,IK)*VOL(I)
        !CC ZTS4=S0COLD(I,1,IK)
        ZTS4=S0COLD(I,NINLDX,IK)      ! TBT 5/91

        !              I NOW LOOP OVER ALL ALLOWED CHARGED PARTICLES.
        do INL=1,NNEUT
          S0COLD(I,INL,IK)=ZTS4*ZTS1*BETAX(I,INL,IK)/ZTS2
        end do
      end if  ! ESFLAG

      if(MCFLAG) then
        do J=1,NZONEC
          !CC ZGA=GFUN(J,I,1,IK)*ZTS3
          ZGA=GFUN(J,I,NINLDX,IK)*ZTS3      ! TBT 5/91

          ! .I NOW LOOP OVER ALL ZONES.
          do INL=1,NNEUT               ! TBT 6/91
            ZTS0=-ALPHAX(J,I,INL,IK)/(ALPHAT(J,I,IK)*VOL(J))
            GFUN(J,I,INL,IK)=ZGA*ZTS0
            if(J.EQ.I.AND.INL.EQ.IK) then
              GFUN(J,I,INL,IK) = GFUN(J,I,INL,IK)+ONE
            end if  ! J=I
          end do
        end do
      end if  ! MCFLAG

    end do
  end do

  return
end subroutine frantic_kernel

!
!-----------------------------------------------------------------------------------------
!
SUBROUTINE linear_interp(x,x_tables,f_tables,fx,ierr)
! 2 points linear interpolation formula
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp), intent(in) :: x ! point where function needed
  real(fp), intent(in) ::x_tables(2),f_tables(2) ! 2 points from tables F_i(x_i), i=1..2
  real(fp), intent(out) :: fx !function value at x f(x)
  integer, intent(out) :: ierr
  real(fp) hx

  ierr=0
  hx=(x_tables(2)-x_tables(1))
  if(hx.eq.0.0_fp) then
     ierr=1
     return
  endif
  fx = f_tables(1)+(x-x_tables(1))/hx*(f_tables(2)-f_tables(1))
  return
  
end SUBROUTINE linear_interp
!
!-----------------------------------------------------------------------------------------
!
SUBROUTINE linear_interp_2d(x,x_tables,f_tables,fx,ierr)
! 4 points 2D linear interpolation formula
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp), intent(in) :: x(2) ! point where function needed
  real(fp), intent(in) ::x_tables(4),f_tables(2,2) ! 2 points from tables F_i(x_i), i=1..2
  real(fp), intent(out) :: fx !function value at x f(x)
  integer, intent(out) :: ierr
  real(fp) hx1,hx2,pe,qn,pe1,qn1

  ierr=0
  hx1=(x_tables(2)-x_tables(1))
  hx2=(x_tables(4)-x_tables(3))
  if((hx1.eq.0.0_fp).or.(hx2.eq.0.0_fp)) then
     ierr=1
     return
  endif
  !pe=(e-e0)/(e1-e0)
  pe=(x(1)-x_tables(1))/hx1
  !qn=(n-n0)/(n1-n0)
  qn=(x(2)-x_tables(3))/hx2
  !1-pe=(e1-e)/(e1-e0)
  pe1=1.0_fp - pe
  !1-qn=(n1-n)/(n1-n0)
  qn1=1.0_fp - qn
  !four points linear extrapolation
  fx = pe1*qn1*f_tables(1,1)+pe*qn1*f_tables(2,1)+qn*pe1*f_tables(1,2)+&
       &pe*qn*f_tables(2,2)
  return
  
end SUBROUTINE linear_interp_2d

C******************** START FILE GAXSPC.FOR ; GROUP GAXES ******************
C----------------------------------------------------------------
C  GAXSPC
C   NON-INTERACTIVE SELECT AXIS TYPE (ITYPE) FOR 2D PLOTS
C
C   ITYPE=1 LINEAR
C         2 LINEAR(X),LOG(Y)
C         3 LOG(X),LOG(Y)
C         4 LOG(X),LINEAR(Y)
C
      SUBROUTINE GAXSPC(ITYPE)
C
      INCLUDE 'GAXES_BLK'
C
      IF(IGXINI.EQ.0) CALL GAXES0
      IAXSEL=ITYPE
      RETURN
      	END
C******************** END FILE GAXSPC.FOR ; GROUP GAXES ******************

subroutine zriddery (ivec, iok0, x1, x2, eps, eta, subr, x, ifail, &
     ivecd,zinput,ninput,zoutput,noutput)
  !
  !  *** see also zridderx.for ***
  !  this is a copy of the zridderx code -- use this instead of zridderx,
  !  if the external routine is itself likely to generate a zridderx call
  !  (avoid seg faults due to inadvertant and unsupported recursion).
  !
  !  **vectorized dmc Apr 2000**
  !  real(fp) root finder -- extended to allow extra arguments to
  !  subr:  zinput(ninput) & zoutput(noutput) [dmc 4 Nov 1999]
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  !
  integer :: ivec                    ! vector size
  integer :: ifail               ! error code
  real(fp), dimension(ivec) :: x1
  real(fp), dimension(ivec) :: x2
  real(fp) :: eps, eta
  real(fp), dimension(ivec) :: x
  logical,  dimension(ivec) :: iok0  ! mask -- .true. to skip element
  external subr
  integer :: ivecd
  integer :: ninput,noutput
  real(fp), dimension(ivecd,ninput)  :: zinput
  real(fp), dimension(ivecd,noutput) :: zoutput
  !
  !     returns an approximate zero for the function (cf subr) given an
  !     initial interval (x1,x2) which brackets a root.
  !     The approximate zero is determined so that x is within the accuracy
  !     of eps or |func(x)| < eta.
  !     The algorithm is based on Ridders' method
  !     see Numerical Recipes 2nd ed. p351
  !
  !  external subroutine header:
  !     subroutine subr(ivec,iok,x,ansr,ivecd,zinput,ninput,zoutput,noutput)
  !        integer ivec
  !        logical iok(ivec)  ! if iok(i) TRUE then SKIP element i of vector
  !        real(fp) x(ivec)     ! input vector {x(i)}
  !        real(fp) ansr(ivec)  ! output vector {f(x(i))}
  !        integer ivecd      ! auxilliary information vector size (.ge.ivec)
  !        integer ninput,noutput
  !        real(fp) zinput(ivecd,ninput),zoutput(ivecd,noutput)
  !
  ! ----------------------------------------------------------------------
  !
  real(fp), dimension(:), allocatable :: xl,xh,fl,fh,xm,fm,xnew,fnew,s
  logical, dimension(:), allocatable :: iok
  !
  integer nc
  !
  integer, parameter :: itermax = 100
  real(fp), parameter :: rbig = 1.024d99
  integer, parameter :: stderr = 6
  integer :: iter,imsg,i,isave
  !
  character(len=80), dimension(3) :: errmsg
  errmsg(1) = 'ZRIDDER: root not bracketed'
  errmsg(2) = 'ZRIDDER: anomalous behavior of func=0.(?)'
  errmsg(3) = 'ZRIDDER: exceeded maximum (100) iterations'
  !
  !---------------------------------------------------------
  allocate(iok(ivec))
  allocate(xl(ivec),xh(ivec),fl(ivec),fh(ivec))
  allocate(xm(ivec),fm(ivec),xnew(ivec),fnew(ivec),s(ivec))
  !
  do i=1,ivec
    iok(i)=iok0(i)
    xl(i) = x1(i)
    xh(i) = x2(i)
  end do
  !
  !  eval at endpts of intervals; check for acceptance of endpts...
  !
  call subr(ivec,iok,xl,fl,ivecd,zinput,ninput,zoutput,noutput)
  do i=1,ivec
    if(.not.iok(i)) then
      if (ABS (fl(i)) .le. eta) then
        iok(i)=.TRUE.
        x(i)     = xl(i)
      end if
    end if
  end do
  !
  call subr(ivec,iok,xh,fh,ivecd,zinput,ninput,zoutput,noutput)
  !
  nc=0
  imsg=0
  do i=1,ivec
    if(.not.iok(i)) then
      if (ABS (fh(i)) .le. eta) then
        iok(i)=.TRUE.
        x(i)     = xh(i)
      else
        x(i) = rbig
        nc=nc+1
        if((fl(i).gt.0.d0).and.(fh(i).gt.0.d0).or. &
             (fl(i).lt.0.d0).and.(fh(i).lt.0.d0)) then
          imsg=1
          isave=i
        end if
      end if
    end if
  end do
  if(imsg.eq.1) go to 9999
  if(nc.eq.0) then
    ifail=0
    go to 10000                    ! all done
  end if
  !
  do iter=1,itermax
    do i=1,ivec
      if(.not.iok(i)) then
        xm(i)=(xl(i)+xh(i))/2.d0
      end if
    end do
    call subr(ivec,iok,xm,fm,ivecd,zinput,ninput,zoutput,noutput)
    do i=1,ivec
      if(.not.iok(i)) then
        s(i)  = SQRT(max(0.d0,(fm(i)**2-fl(i)*fh(i))))
        if (s(i) .eq. 0.d0) then
          isave=i
          imsg = 2
          x(i) = -rbig
        else
          xnew(i)=xm(i)+(xm(i)-xl(i))*fm(i)/s(i) * &
               SIGN (1.d0,fl(i)-fh(i))
        end if
      end if
    end do
    call subr(ivec,iok,xnew,fnew,ivecd,zinput,ninput,zoutput,noutput)
    nc=0
    do i=1,ivec
      if(.not.iok(i)) then
        if (ABS (x(i)-xnew(i)) .le. eps .or. &
             ABS (fnew(i)) .le. eta) then
          iok(i)=.TRUE.
        end if
        x(i) = xnew(i)
      end if
      if(.not.iok(i)) then
        if (SIGN (fm(i),fnew(i)) .ne. fm(i)) then
          xl(i) = xm(i)
          fl(i) = fm(i)
          xh(i) = xnew(i)
          fh(i) = fnew(i)
        else if (SIGN (fl(i),fnew(i)) .ne. fl(i)) then
          xh(i) = xnew(i)
          fh(i) = fnew(i)
        else if (SIGN (fh(i),fnew(i)) .ne. fh(i)) then
          xl(i) = xnew(i)
          fl(i) = fnew(i)
        else
          call errmsg_exit('subroutine ZRIDDERY: programming error')
        end if
        if (ABS (xl(i)-xh(i)) .le. eps) then
          iok(i)=.TRUE.
        else
          nc=nc+1
        end if
      end if
    end do
    if(nc.eq.0) then
      ifail=0
      go to 10000
    end if
  end do
  !
  !  get here if for some point, convergence failed
  !
  imsg = 3
  do i=1,ivec
    if(.not.iok(i)) isave=i
  end do
  !
9999 continue
  if((imsg.gt.0).and.(imsg.le.3)) then
    write (stderr, '(a)')  errmsg(imsg)
    write (stderr, '(a)') 'i xl(i), fl(i), xh(i), fh(i):'
    write (stderr,   *  )  isave, xl(isave), fl(isave), &
         xh(isave), fh(isave)
  else
    call errmsg_exit('subroutine ZRIDDERY: unspecified error')
  end if
  !
  ifail = imsg
  !
10000 continue
  deallocate(xl,xh,fl,fh,xm,fm,xnew,fnew,s,iok)
  return
end subroutine zriddery

C******************** START FILE LYESC.FOR ; GROUP URDUTS ******************
C------------------------------------------------
C&LYESC  UREAD LOGICAL FUNCTION, .TRUE. IF INPUT IS SPECIFIEC CHARACTER
C  FALSE OTHERWISE.
C
      LOGICAL FUNCTION LYESC(ICHAR)
      USE USERIO
      CHARACTER*1 ICHAR
C
      character*1 jchar
C
      CHARACTER*1 ZCHAR
C--------------------------------------
      CALL URCHAR(ZCHAR,1,ID,IER)
      call uupper(zchar)
      jchar=ichar
      call uupper(jchar)
C
      LYESC = zchar.eq.jchar
C
      CALL UROTOR(ID)
C
      RETURN
      END
C******************** END FILE LYESC.FOR ; GROUP URDUTS ******************

C******************** START FILE udecod.FOR ; GROUP URDUTS *************
c-------------------------------------------------
c&  udecod    unpack uread input line
c
c  rev dmc Jan 1985:  common switch LEVCMD=2:  text
c  mode input, no left-justify
c
c  case conversion is *no longer* done by UREAD system -- only by
c  output conversion routines as needed.
c
      subroutine udecod
c
      USE USERIO
c
      CHARACTER*8 UCNTRL
      character*512 zzbuff	! debug
c
      character*1 cchar
c
c--------------------------------------------------
c
      ilev=levcmd
c
c  text mode input is left justified only if it has
c   UREAD command syntax
c  all other input is *always* left justified...
c
      if(ilev.eq.2) then
         ilas=ilnurd(cbuff)
         if(ilas.gt.0) then
            do ic=1,ilas
               if((cbuff(ic:ic).ne.' ').and.(cbuff(ic:ic).ne.char(9)))
     >            go to 20
            enddo
 20         continue
C   GENERATE SPECIAL CHARACTER STRING
            CALL URCSTR(UCNTRL)
            cchar=cbuff(ic:ic)
            call uupper(cchar)
            if(index(ucntrl,cchar).ne.0) ilev=1
         endif
      endif
c
      READ(CBUFF,1002) (dbuff(ij),ij=1,LBUFF)
 1002 format(512A1)
c
      call ulosup(dbuff,LBUFF,INUM,ilev)
c
      WRITE(CBUFF,1002) (dbuff(ij),ij=1,LBUFF)
      NCHARC=INUM
      NCP1C=INUM+1
c
      return
      end
C******************** END FILE udecod.FOR ; GROUP URDUTS ***************

subroutine frantic_module_write(filename,ierr)

  use ezcdf
  use frantic_module
  implicit none

  character(len=*), intent(in) :: filename ! NetCDF filename to write
  integer, intent(out) :: ierr             ! completion code, 0=OK

  !-----------------------
  ! WRITE the contents of the frantic module as a NetCDF file
  ! for debugging purposes
  !-----------------------
  ! local:

  integer :: ncid

  !-----------------------

  call cdf_open(ncid,filename,'w',ierr)
  if(ierr.ne.0) then
    ierr=10
    return
  end if

  !-----------------------
  !  data definitions

  !  array dimensions...

  call cdf_define(ncid,'mj',mj,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'mig',mig,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'mix',mix,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'mibs',mibs,ierr); if (ierr.ne.0) go to 997

  !  user grid stuff...

  call cdf_define(ncid,'nx_user',nx_user,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'nxb_user',nxb_user,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'x_user',x_user,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'xb_user',xb_user,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'volxb_user',volxb_user,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'Rmajxb_user',Rmajxb_user,ierr); if (ierr.ne.0) go to 997

  !  data...

  call cdf_define(ncid,'lun6',lun6,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'npro_set',npro_set,ierr); if (ierr.ne.0) go to 997

  call cdf_define(ncid,'ninldx',ninldx,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'nneut',nneut,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'nplas',nplas,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'nimp',nimp,ierr); if (ierr.ne.0) go to 997
  call cdf_define(ncid,'nneut_s0',nneut_s0,ierr); if (ierr.ne.0) go to 997

  call cdf_define(ncid,'esflag',esflag,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'vsflag',vsflag,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'mcflag',mcflag,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'msflag',msflag,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'lnflag',lnflag,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'rcflag',rcflag,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'lbflag',lbflag,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'lzpflag',lzpflag,ierr); if(ierr.ne.0) go to 997

  call cdf_define(ncid,'aplas',aplas,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'xzplas',xzplas,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'nspec',nspec,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'twall',twall,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'fluxi0',fluxi0,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'vphi_wall',vphi_wall,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'rmass',rmass,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'xzbeams',xzbeams,ierr); if(ierr.ne.0) go to 997

  call cdf_define(ncid,'rbound',rbound,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'rmjrmp',rmjrmp,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'tvol',tvol,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'x',x,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'xb',xb,ierr); if(ierr.ne.0) go to 997

  call cdf_define(ncid,'den',den,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'temp',temp,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'vphiz',vphiz,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'bii',bii,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'bcx',bcx,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'bcxs',bcxs,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'volsor',volsor,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'xzimpj',xzimpj,ierr); if(ierr.ne.0) go to 997
  call cdf_define(ncid,'aimpj',aimpj,ierr); if(ierr.ne.0) go to 997

  !-----------------------
  !  data writes

  !  array dimensions...

  call cdf_write(ncid,'mj',mj,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'mig',mig,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'mix',mix,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'mibs',mibs,ierr); if (ierr.ne.0) go to 998

  !  user grid stuff...

  call cdf_write(ncid,'nx_user',nx_user,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'nxb_user',nxb_user,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'x_user',x_user,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'xb_user',xb_user,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'volxb_user',volxb_user,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'Rmajxb_user',Rmajxb_user,ierr); if (ierr.ne.0) go to 998

  !  data...

  call cdf_write(ncid,'lun6',lun6,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'npro_set',npro_set,ierr); if (ierr.ne.0) go to 998

  call cdf_write(ncid,'ninldx',ninldx,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'nneut',nneut,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'nplas',nplas,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'nimp',nimp,ierr); if (ierr.ne.0) go to 998
  call cdf_write(ncid,'nneut_s0',nneut_s0,ierr); if (ierr.ne.0) go to 998

  call cdf_write(ncid,'esflag',esflag,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'vsflag',vsflag,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'mcflag',mcflag,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'msflag',msflag,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'lnflag',lnflag,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'rcflag',rcflag,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'lbflag',lbflag,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'lzpflag',lzpflag,ierr); if(ierr.ne.0) go to 998

  call cdf_write(ncid,'aplas',aplas,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'xzplas',xzplas,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'nspec',nspec,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'twall',twall,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'fluxi0',fluxi0,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'vphi_wall',vphi_wall,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'rmass',rmass,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'xzbeams',xzbeams,ierr); if(ierr.ne.0) go to 998

  call cdf_write(ncid,'rbound',rbound,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'rmjrmp',rmjrmp,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'tvol',tvol,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'x',x,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'xb',xb,ierr); if(ierr.ne.0) go to 998

  call cdf_write(ncid,'den',den,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'temp',temp,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'vphiz',vphiz,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'bii',bii,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'bcx',bcx,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'bcxs',bcxs,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'volsor',volsor,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'xzimpj',xzimpj,ierr); if(ierr.ne.0) go to 998
  call cdf_write(ncid,'aimpj',aimpj,ierr); if(ierr.ne.0) go to 998

  go to 999

  !-----------------------
  !  error handling section

997 continue
  ierr=21    ! cdf_define error
  goto 999

998 continue
  ierr=22    ! cdf_write error
  goto 999

999 continue

  !-----------------------
  call cdf_close(ncid)

  return
end subroutine frantic_module_write


subroutine frantic_module_read(filename,ierr)

  use ezcdf
  use frantic_module
  implicit none

  character(len=*), intent(in) :: filename ! NetCDF filename to read
  integer, intent(out) :: ierr             ! completion code, 0=OK

  !-----------------------
  ! READ the contents of the frantic module as a NetCDF file
  ! for debugging purposes
  !-----------------------
  ! local:

  integer :: ncid
  integer :: imj,imig,imix,imibs   ! array dimensions to read...
  integer :: isb

  integer :: idims(10)
  character(len=10) :: eztype
  !-----------------------

  call cdf_open(ncid,filename,'r',ierr)
  if(ierr.ne.0) then
    ierr=11
    return
  end if

  !  array dimensions...

  call cdf_read(ncid,'mj',imj,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'mig',imig,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'mix',imix,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'mibs',imibs,ierr); if(ierr.ne.0) go to 998

  !  allocate arrays...
  !  this also sets the dimensioning info in the frantic module

  call frantic_species_alloc(imig,imix-imig,imibs)
  call frantic_profile_alloc(imj-2)     ! cf nzonec = mj-2 in subroutine

  !  user grid stuff...

  call cdf_read(ncid,'nx_user',nx_user,ierr); if (ierr.ne.0) go to 998
  call cdf_read(ncid,'nxb_user',nxb_user,ierr); if (ierr.ne.0) go to 998

  allocate(x_user(nx_user),xb_user(nxb_user))
  allocate(volxb_user(nxb_user),Rmajxb_user(nxb_user))

  call cdf_read(ncid,'x_user',x_user,ierr); if (ierr.ne.0) go to 998
  call cdf_read(ncid,'xb_user',xb_user,ierr); if (ierr.ne.0) go to 998
  call cdf_read(ncid,'volxb_user',volxb_user,ierr); if (ierr.ne.0) go to 998
  call cdf_read(ncid,'Rmajxb_user',Rmajxb_user,ierr); if (ierr.ne.0) go to 998

  !  now read the data...
  !    (lun6 read is skipped -- defaults to 6, may be reset by caller).

  npro_set=.FALSE.
  call cdfInqVar(ncid,'npro_set',idims,eztype)
  call cdf_read(ncid,'npro_set',npro_set(1:idims(1)),ierr)
  if (ierr.ne.0) go to 998

  call cdf_read(ncid,'ninldx',ninldx,ierr); if (ierr.ne.0) go to 998
  call cdf_read(ncid,'nneut',nneut,ierr); if (ierr.ne.0) go to 998
  call cdf_read(ncid,'nplas',nplas,ierr); if (ierr.ne.0) go to 998
  call cdf_read(ncid,'nimp',nimp,ierr); if (ierr.ne.0) go to 998
  call cdf_read(ncid,'nneut_s0',nneut_s0,ierr); if (ierr.ne.0) go to 998

  call cdf_read(ncid,'esflag',esflag,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'vsflag',vsflag,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'mcflag',mcflag,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'msflag',msflag,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'lnflag',lnflag,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'rcflag',rcflag,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'lbflag',lbflag,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'lzpflag',lzpflag,ierr); if(ierr.ne.0) go to 998

  call cdf_read(ncid,'aplas',aplas,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'xzplas',xzplas,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'nspec',nspec,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'twall',twall,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'fluxi0',fluxi0,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'rmass',rmass,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'xzbeams',xzbeams,ierr); if(ierr.ne.0) go to 998

  nsbeam = 0
  do isb=1,mibs
    if(xzbeams(isb).gt.0.0_fp) nsbeam=isb
  enddo

  call cdfInqVar(ncid,'vphi_wall',idims,eztype)
  if(eztype.ne.'??') then
    call cdf_read(ncid,'vphi_wall',vphi_wall,ierr)
    if(ierr.ne.0) go to 998
  else
    vphi_wall=0.0_fp
  end if

  call cdf_read(ncid,'rbound',rbound,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'rmjrmp',rmjrmp,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'tvol',tvol,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'x',x,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'xb',xb,ierr); if(ierr.ne.0) go to 998

  call cdf_read(ncid,'den',den,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'temp',temp,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'vphiz',vphiz,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'bii',bii,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'bcx',bcx,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'bcxs',bcxs,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'volsor',volsor,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'xzimpj',xzimpj,ierr); if(ierr.ne.0) go to 998
  call cdf_read(ncid,'aimpj',aimpj,ierr); if(ierr.ne.0) go to 998

  aminor=rbound(nzonec+1)

  go to 999  ! success

  !-----------------------
  !  error handling section

998 continue
  ierr=32    ! cdf_read error
  goto 999

999 continue

  !-----------------------
  call cdf_close(ncid)

  return
end subroutine frantic_module_read


subroutine frantic_module_io_error(ilun,ierr_in)

  implicit none

  integer, intent(in) :: ilun     ! Fortran LUN where to write error message
  integer, intent(in) :: ierr_in  ! integer code specifying which error.

  !-------------------------------

  if(ierr_in.eq.10) then
    write(ilun,*) ' error opening NetCDF file for write.'
  else if(ierr_in.eq.11) then
    write(ilun,*) ' error opening NetCDF file for read.'
  else if(ierr_in.eq.21) then
    write(ilun,*) ' NetCDF file: cdf_define error.'
  else if(ierr_in.eq.22) then
    write(ilun,*) ' NetCDF file: cdf_write error.'
  else if(ierr_in.eq.32) then
    write(ilun,*) ' NetCDF file: cdf_read error.'
  else
    write(ilun,*) ' EZCDF (NetCDF) error (unspecified).'
  end if

  return
end subroutine frantic_module_io_error

C******************** START FILE UCOPYF.FOR ; GROUP UFSWXY ******************
C----
C  UCOPYF
C  COPY ARRAY 1 INTO ARRAY 2
C
      SUBROUTINE UCOPYF(ARRAY1,ARRAY2,ISIZ)
      DIMENSION ARRAY1(ISIZ),ARRAY2(ISIZ)
C
      DO 10 I=1,ISIZ
      ARRAY2(I)=ARRAY1(I)
 10   CONTINUE
      RETURN
      END
C******************** END FILE UCOPYF.FOR ; GROUP UFSWXY ******************

C---------------------------------------------------------------------
C  URWRDL  -- TRANSFER AN INPUT WORD; PROCESS DBL QUOTES
C
C  THERE ARE NO LEADING AND TRAILING BLANKS IN THE WORD, BUT THERE
C  MAY BE QUOTATION MARKS-- STRIP THESE OFF
C
      SUBROUTINE URWRDL(WORD1,WORD2,IW2)
C
      USE USERIO
C
      CHARACTER*(*) WORD1,WORD2
C
C  WORD1  -- INPUT WORD **WITH NO LEADING OR TRAILING BLANKS**;
C            DBL QUOTE STRING IF FIRST CHARACTER IS '"'
C
C  WORD2  -- OUTPUT WORD, PAD WITH BLANKS
C  IW2    -- LAST NONBLANK CHAR IN WORD2 (OUTPUT)
C
C   TRUNCATION IS AN ERROR!
C
      ILW1=LEN(WORD1)
      ILW2=LEN(WORD2)
C
      IW1=0
      IW2=0
C
      ITRUNC=0
C
      IERR=0
C
      IF((WORD1(1:1).NE.'"').OR.(WORD1(ILW1:ILW1).NE.'"')) THEN
        IW1=MIN0(ILW1,ILW2)
        IW2=IW1
        WORD2(1:IW2)=WORD1(1:IW1)
        IF(IW2.LT.ILW1) ITRUNC=1
      ELSE
C  PROCESS QUOTE STRING; 2 CONSECUTIVE DBL QUOTES RETURNED AS ONE
        IW1=1
        IEVEN=0
C
 10     CONTINUE
        IW1=IW1+1
        ICOPY=0
        IF(WORD1(IW1:IW1).NE.'"') THEN
          IF(IW1.EQ.ILW1) IERR=1
          ICOPY=1
        ELSE
          IF(IW1.EQ.ILW1) GO TO 30
          IEVEN=1-IEVEN
          IF(IEVEN.EQ.1) THEN
            IWP1=IW1+1
            IF(WORD1(IWP1:IWP1).NE.'"') IERR=1
          ELSE
C  TRANSFER DBL QUOTE PAIR AS SINGLE DBL QUOTE
            ICOPY=1
          ENDIF
        ENDIF
C
        IF(ICOPY.EQ.1) THEN
          IW2=IW2+1
          IF(IW2.LE.ILW2) THEN
            WORD2(IW2:IW2)=WORD1(IW1:IW1)
          ELSE
            ITRUNC=1
          ENDIF
        ENDIF
C
        IF(IW1.LT.ILW1) GO TO 10
C
      ENDIF
C
 30   CONTINUE
C
      IF(IERR.EQ.1) THEN
        WRITE(LUNTRM,9999) WORD1
 9999 FORMAT(' %UREAD (URWRDL) ERROR PARSING QUOTE STRING:  '/1X,A)
        CALL UPAUST(0)
      ELSE IF(ITRUNC.EQ.1) THEN
        WRITE(LUNTRM,9901) WORD1,WORD2
 9901 FORMAT(' ?URWRDL(CDCOD/UREAD)-- WORD ["',A,'"]'/
     >       1X,'TRUNCATED TO ["',A,'"]')
        CALL UPAUST(0)
      ENDIF
C
C  PAD OUTPUT WORD WITH BLANKS
      IF(IW2.LT.ILW2) THEN
        DO 40 IC=IW2+1,ILW2
          WORD2(IC:IC)=' '
 40     CONTINUE
      ENDIF
C
      RETURN
C
      END

	
      Subroutine UFstuffY ( F3d, F2d, Imax, Jmax, Kmax, IQ)
 
C	Stuff F3d( 1:Imax, IQ, 1:Kmax) into F2d(1:Imax,1:Kmax)
 
      Real F3d(*)
      Real F2d(*)
 
 
      Do 300 K=1,Kmax
        Do 200 I=1,Imax
 
          Ind3 = I + (Iq-1)*Imax + (K-1)*(Imax*Jmax)
          Ind2 = I + (K-1)*Imax
 
          F2d(Ind2) = F3d(Ind3)
 
  200   Continue
  300   Continue
 
      Return
      End

C******************** START FILE USPGET.FOR ; GROUP USPARM *************
C--------------------------------------------------------------
C&  USPGET   FETCH C*96 VALUE GIVEN 10 CHAR UREAD PARAMETER NAME
C         IER-- =0: SUCCESS
C               =1: FAILED TO LOCATE VALUE
C
      SUBROUTINE USPGET(ZNAM0,ZVAL,IER)
c
      USE USERIO
C
      CHARACTER*(*) ZNAM0
C
      CHARACTER*16 ZNAME
      CHARACTER*96 ZVAL
C
      ZNAME='                '
      IL=MIN0(16,LEN(ZNAM0))
      ZNAME(1:IL)=ZNAM0(1:IL)
C
      IER=0
      CALL USPLOC(ZNAME,ITYPE,INUM)
      IF(ITYPE.EQ.0) GO TO 500
      GO TO (10,20) ITYPE
C  LOCAL PARAMETER VALUE
 10   CONTINUE
      ZVAL=PLCVAL(INUM,MAX0(NLUNIN,NLUNIO))
      RETURN
C  GLOBAL PARAMETER VALUE
 20   CONTINUE
      ZVAL=PGLVAL(INUM)
      RETURN
C  NOT FOUND
 500  CONTINUE
C
C  mod dmc Jan 1990 -- if name begins with "$" then try a DCL symbol
C  translation
C
      IF(ZNAME(1:1).EQ.'$') THEN
        ZVAL=' '
        call sget_env(ZNAME(2:),ZVAL)
        istat=1
        IF(ISTAT.EQ.1) RETURN
      ENDIF
C
      IER=1
      RETURN
      	END
C******************** END FILE USPGET.FOR ; GROUP USPARM ***************

C******************** START FILE IDCODE.FOR ; GROUP URDUTS *************
C=============================================
C&  IDCODE  UREAD DECODE INTEGER INPUT (OBSCELESCENT)
C
C  DECODE UNPACKED LINE TO INTEGER
C
C  LINE WAS READ IN BY SUBROUTINE UREAD, IS UNPACKED 1 CHAR/
C  WORD IN ARRAY DBUFF
C
      INTEGER FUNCTION IDCODE(ZBUFF,IER)
C  REVISED   D. MC CUNE   JULY 14 1980   ADD ERROR CODE "IER"
C    ON RETURN IER=0 IS NORMAL
C         IER=1 INDICATES ILLEGAL FORMAT, FCN VALUE OF ZERO
C          RETURNED.
C
C
C  *** DMC 13 JAN 1985 *** ARGUMENT ZBUFF IS NOT USED
C   ROUTINE IS OBSCELESCENT, MAINTAINED FOR COMPATIBILITY
C   OF OLD ROUTINES-- CHAR STRING FOR DECOD IS CBUFF, UREAD
C   COMMON
C  WORK IS NOW DONE IN JIDCOD
C
      USE USERIO
      CHARACTER*1 ZBUFF(4)  ! NOT USED
C
      I=JIDCOD(CBUFF,IC,ID,ICOD)
C
      IF(ICOD.EQ.-1) THEN
        IDCODE=0
        IER=0
      ELSE IF(ICOD.EQ.0) THEN
        IDCODE=I
        IER=0
      ELSE
        GO TO 900
      ENDIF
C
C  HAVE INTEGER
      CALL UROTOR(ID)
      RETURN
C  ERRORS
 900  CONTINUE
      IDCODE=0
      IER=1
      CALL UERMSG(' % IDCODE:  NOT AN INTEGER:',CBUFF(1:ID),0)
      IF(NLINDI) CALL UPAUST(1)
      RETURN
      	END
C******************** END FILE IDCODE.FOR ; GROUP URDUTS ***************

      subroutine mpi_procname(myid,numprocs,filenam)

#ifdef __MPI
      use mpi
#endif
      implicit NONE

! local communicator

#ifdef __MPI
     integer :: nbi_comm = MPI_COMM_WORLD
#endif

     !-------------------------------------
     character*(*), intent(in) :: filenam
     character*180 hostnam,hostnam1,proc_name
     integer :: istat,myid,numprocs,ierr,jwrite
     integer :: ii,jj,mywid,maxwid,iresult
     integer :: lunout = 77
     integer, dimension(:), allocatable :: iwrite

     integer, dimension(:,:), allocatable :: intbuf,intbufr
     !-------------------------------------
     ! executable code

     open(unit=lunout,file=trim(adjustl(filenam)),status='replace',iostat=istat)

     if (allocated(iwrite))deallocate(iwrite)
     allocate(iwrite(0:numprocs-1))
     iwrite(:)=0

#ifdef __MPI

     call MPI_GET_PROCESSOR_NAME(proc_name,iresult,ierr)
     call ckerr('MPI_GET_PROCESSOR_NAME')
!    write(0,'(1x,i8,1x,a)') myid, trim(proc_name)

     mywid = len(trim(proc_name))

     call MPI_ALLREDUCE(mywid,maxwid,1, &
       MPI_INTEGER,MPI_MAX,nbi_comm,ierr)
     call ckerr('MPI_ALLREDUCE(mywid)')

     allocate(intbuf(maxwid,0:numprocs-1)); intbuf = 0
     allocate(intbufr(maxwid,0:numprocs-1))

     do ii=1,mywid
       intbuf(ii,myid) = ichar(proc_name(ii:ii))
     enddo

     call MPI_ALLREDUCE(intbuf,intbufr,numprocs*maxwid, &
       MPI_INTEGER,MPI_SUM,nbi_comm,ierr)
     call ckerr('MPI_REDUCE(intbuf)')

!    if(myid.eq.0) then
      hostnam1=' '
      do jj=0,numprocs-1
        iwrite(jj)=0
        hostnam=' '
        do ii=1,maxwid
           if(intbufr(ii,jj).eq.0) exit
           hostnam(ii:ii) = char(intbufr(ii,jj))
        enddo
        
        if (trim(hostnam).ne.trim(hostnam1))iwrite(jj)=jj
        if (jj.eq.0) iwrite(jj)=0
        hostnam1=hostnam

        if (jj.eq.myid) then
          jwrite=iwrite(jj)
        else
          jwrite=0
        endif
!       if (myid.eq.0) then
!        write(0,'(1x,i8,1x,a,1x,i8)') jj, trim(hostnam), iwrite(jj)
!       endif
      enddo
!    endif

      write(lunout,'(i8)') iwrite(myid) 

#else
     call sget_host(hostnam)
    
!    write(lunout,'(1x,i8,1x,a,1x,i8)') myid, trim(hostnam),iwrite(myid) 
     write(lunout,'(i8)') iwrite(myid) 
#endif

      close(unit=lunout)
 
      deallocate(iwrite)

CONTAINS

      subroutine ckerr(callnam)

        character*(*) :: callnam

        if(ierr.ne.0) then
         write(0,*) ' error ierr=',ierr,' in call "',trim(callnam), &
            '" on proc #',myid
         call bad_Exit
        endif

       end subroutine ckerr


      end subroutine mpi_procname

C******************** START FILE UF1DRD.FOR ; GROUP UFILES ******************
C--------------------------------------------------------------
C  UF1DRD
C  READ 1-DIMENSIONAL DATA FROM ASCII FILE
C   ...dmc... adding MDS+ access capability ... 17 Dec 1998
C
 
      SUBROUTINE UF1DRD(ILUN,IDEV,ZSDATE,
     >     X,F,NDIM,NACT,IPROC,
     >     XLAB,FLAB,
     >     NSCD,NSCA,SCVAL,SCLAB,IER)
 
C  Updated:
C  08/05/97 CAL - Add HDF file option
C  08/24/93 TBT - Changed call to UFAHED2 fro new format (3009)
C   mod dmc -- use SR ufascio instead (portability)
C
C
C* ILUN-- LOGICAL UNIT NUMBER FOR I/O
C  IDEV-- 4 LETTER TOKAMAK CODE ("PLT ", ETC.)
C  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
C*  NDIM-- DIMENSION OF ARRAYS
C  X(N),F(N)-- REAL NUMERIC DATA TO BE READ
C      F[X]-- X THE INDEPENDENT, F THE DEPENDENT VARIABLE
C  NACT-- ACTUAL NUMBER OF POINTS IN DATA FILE
C  IPROC- PROCESS CODE: 0 = RAW, 1= AVERAGED, 2= SMOOTHED,
C    3= AVERAGED AND SMOOTHED
C  XLAB-- 30 CHARACTER LABEL FOR X
C   FIRST 20 CHARACTERS-- NAME OF X
C   LAST 10 CHARACTERS--  PHYSICAL UNITS OF X
C     E.G. XLAB = 'MAJOR RADIUS        CM        '
C  FLAB-- 30 CHARACTER LABEL FOR Y - SAME FORMAT AS XLAB
C
C*  NSCD-- SPACE ALLOCATED FOR ASSOCIATED SCALARS
C  NSCA-- RETURNED ACTUAL NUMBER OF SCALARS IN FILE
C    ** NOTE ** NSCD MAY = 0 IN WHICH CASE THESE ARE DUMMIES:
C  SCLAB-- LIST OF ASSOCIATED SCALAR KEYWORD/LABELS READ
C    FORMAT OF SCLAB: 30 CHARS, 10 CHAR KEYWORD BLOCK, 10 CHAR LABEL,
C      10 CHAR PHYS. UNITS-- SEE SUBROUTINE UF0WRT, FILE UFILS0.FOR
C
C  IER=0 ON RETURN IF READ WAS SUCCESSFUL
C
C* DENOTES INPUT
      USE UFILES
C
      REAL X(NDIM),F(NDIM),SCVAL(*)
      CHARACTER*10 ZSDATE,ZWDATE
      CHARACTER*30 XLAB,FLAB,SCLAB(*)
      CHARACTER*4 IDEV
C
      character*128 znode
C
      CHARACTER*64 ERRSTR
 
      Integer Iformat
C
C$r8real_output: x,f,scval
C-----------------------------------------------------------------
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UF1DRD    ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.3) THEN
        CALL UERSTA(ICHAN,'UF1DRD    ')
        GO TO 9000
      ENDIF
C
C  CHANNEL STATUS OK
C
C  READ DATA - BINARY COMPRESSED OR ASCII DETERMINED AT OPEN TIME
C
      KMPRS=UFCPRS(ICHAN)
C
      ERRSTR='HEADER DATA'
      if(KMPRS.eq.-1) then
         ikmprs=-1
C----------------------------------------
C  MDS+ data access
C
         call ufmds_rhdr(ichan,idev,zsdate,ishot,idim,znode,iln,
     >        iproc,ier)
         if(ier.eq.1) go to 9000
C
C----------------------------------------
      endif
C
      IF(KMPRS.EQ.0) THEN
        IKMPRS=0
        CALL UFAHED2(ILUN,ISHOT,IDEV,IDIM,KMPRS,ZWDATE,ZSDATE,0,
     1         IFORMAT,IERH)
        IF(IERH.NE.0) GO TO 8999
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,END=8999,ERR=8999)
     >      ISHOT,IDEV,IDIM,IKMPRS,ZWDATE,ZSDATE
        IF((UFILEV-10*(UFILEV/10)).GE.1) WRITE(UFELUN,8001) ZWDATE
 8001   FORMAT(' % READING 1D COMPRESSED BINARY DATA WRITTEN ',A)
      ELSE IF(KMPRS.EQ.2) THEN
        call ufbhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
        if(ierh.ne.0) go to 8999
C      else if(kmprs.eq.3) then
C        call uhdfhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
C        if(ierh.ne.0) go to 8999
      else if(kmprs.eq.4) then
        call ucdfhed(ilun,ishot,idev,idim,ikmprs,zwdate,zsdate,0,ierh)
        if(ierh.ne.0) go to 8999
      ENDIF
C
      IF(KMPRS.NE.IKMPRS) THEN
        WRITE(UFELUN,9008) KMPRS,IKMPRS
 9008   FORMAT(' % UF1DRD INTERNAL FLAG ERROR KMPRS, IKMPRS =',
     >2(I2,1X))
      ENDIF
C
C  CHECK THE SHOT NO.
C
      if(lshotn(ichan)) then
         IF(ISHOT.NE.UFSHOT(ICHAN)) THEN
            IF((UFILEV/10).GE.1)
     >          WRITE(UFELUN,9011) ISHOT,UFSHOT(ICHAN)
 9011       FORMAT(
     >  ' % SHOT NUMBER ',I6,' IN FILE NOT SAME AS SHOT NUMBER ',I6,
     >  ' IN FILENAME')
         ENDIF
      endif
C
C  CHECK DIMENSIONALITY OF DATA
C
      IF(IDIM.NE.1) THEN
        WRITE(UFELUN,9010) IDIM
 9010   FORMAT(
     >  ' ? DIMENSIONALITY OF INPUT FILE = ',I1,' IS INCORRECT',
     >  ' FOR UF1DRD')
        IER=1
        GO TO 9000
      ENDIF
C
C  READ ASSOCIATED SCALAR QUANTITIES
      ERRSTR='ASSOCIATED SCALAR DATA'
      if (KMPRS.EQ.-1) then            ! MDSplus
         call ufmds_0rd(ICHAN,SCVAL,SCLAB,NSCD,NSCA,znode(1:iln),IER)
         IF(IER.NE.0) GO TO 8999
C      else if (KMPRS.EQ.3) then            ! HDF
C         call uhdf0r(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
C         IF(IER.NE.0) GO TO 8999
      else if (KMPRS.EQ.4) then       ! netCDF
         call ucdf0r(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
         IF(IER.NE.0) GO TO 8999
      else
         CALL UFNSRD(KMPRS,ILUN,NSCA,IERR)
         IF(IERR.NE.0) GO TO 8999
         IF(NSCA.GT.0) THEN
            CALL UF0RDR(ILUN,SCVAL,SCLAB,NSCD,NSCA,IER)
            IF(IER.NE.0) GO TO 8999
         ENDIF
      end if
 
      if(nsca.gt.0) call ufsclab_ck(sclab,nsca)
 
      IF(NSCD.GT.0 .AND. NSCD.LT.NSCA) THEN
        WRITE(UFELUN,9052) NSCD,NSCA
 9052   FORMAT(' % UF1DRD WARNING-- INSUFFICIENT SPACE FOR SCALARS:'/
     >  '   SPACE ALLOCATED=',I3,' NEED:',I3/)
      ENDIF
C
C  AXIS LABELS
C
      ERRSTR='DATA COORDINATE LABELS'
      if(kmprs.eq.-1) then
C----------------------------------------
C  MDS+ data access -- labels
C
         call ufmds_lbl(ichan,znode(1:iln),flab,1,znode(1:iln),ier)
         if(ier.ne.0) go to 9000
C
         call ufmds_lbl(ichan,'dim_of('//znode(1:iln)//',0)',xlab,0,
     1	'(dim 0)',ier)
         if(ier.ne.0) go to 9000
C
C----------------------------------------
      else IF(KMPRS.EQ.0) THEN
        READ(ILUN,3003,ERR=8999,END=8999) XLAB
 3003 FORMAT(1X,A30)
C
        READ(ILUN,3003,ERR=8999,END=8999) FLAB
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,ERR=8999,END=8999) XLAB,FLAB
      else if(kmprs.eq.2) then
        call ubrchar(ilun,xlab,ier)
        if(ier.ne.0) go to 8999
        call ubrchar(ilun,flab,ier)
        if(ier.ne.0) go to 8999
      ENDIF
C
      ERRSTR='DATA PROCESSING CODE + NUMBER OF POINTS'
      if(kmprs.eq.-1) then
         iproc=0
         call ufmds_size(znode(1:iln),1,nact,ier) ! size of 1st dim
         if(ier.ne.0) go to 9000
      else IF(KMPRS.EQ.0) THEN
        READ(ILUN,3006,ERR=8999,END=8999) IPROC
 3006 FORMAT(1X,I1)
C
        READ(ILUN,3007,ERR=8999,END=8999) NACT
 3007 FORMAT(1X,I10)
      ELSE IF(KMPRS.EQ.1) THEN
        READ(ILUN,ERR=8999,END=8999) IPROC,NACT
c
      else if(kmprs.eq.2) then
         call ubr3int(ilun,iproc,ier)
         if(ier.ne.0) go to 8999
         call ubr3int(ilun,nact,ier)
         if(ier.ne.0) go to 8999
c
C      else if(kmprs .eq. 3) then
C         call uhdf1r(ilun,1,
C     &            f, x, ndim, nact, iproc,
C     &            flab,xlab,ier)
C         if(ier.ne.0) go to 8999
      else if(kmprs .eq. 4) then
         call ucdf1r(ilun,1,
     &            f, x, ndim, nact, iproc,
     &            flab,xlab,ier)
         if(ier.ne.0) go to 8999
      ENDIF
C
      IF(NACT.LE.NDIM) GO TO 30
C
      WRITE(UFELUN,9012) NACT,NDIM
 9012 FORMAT(' ? UF1DRD-- DATA TO BE READ WILL NOT FIT IN'/
     >  '   PASSED ARRAYS:  NACT= ',I10,' .GT. NDIM= ',I10/)
      GO TO 9000
C
 30   CONTINUE
      if(kmprs.eq.-1) then
C----------------------------------------
C  MDS+ data access
C
         call ufmds_read(znode(1:iln),f,nact,ier)
         if(ier.ne.0) go to 9000
         call ufmds_read('dim_of('//znode(1:iln)//',0)',x,nact,ier)
         if(ier.ne.0) go to 9000
C
C----------------------------------------
      else if(kmprs.eq. 4) then         ! netCDF
         call ucdf1r(ilun,2, f, x, ndim, nact, iproc,
     >                 flab, xlab, ier)
         if(ier.ne.0) go to 8999
C      else if(kmprs.eq.3) then         ! HDF
C         call uhdf1r(ilun,2, f, x, ndim, nact, iproc,
C     >                 flab, xlab, ier)
C         if(ier.ne.0) go to 8999
      else if(kmprs.eq.2) then
        call ubcprd(ilun,x,'x',nact,1,1,nact,1,ier)
        if(ier.ne.0) go to 8999
        call ubcprd(ilun,f,'f',nact,1,1,nact,1,ier)
        if(ier.ne.0) go to 8999
      else IF(KMPRS.EQ.1) THEN
C
C  READ COMPRESSED ARRAYS, DECOMPRESS, AND CONVERT TO REAL
        ERRSTR='INDEPENDENT COORDINATE (X) DATA'
        CALL UFCPRD(ILUN,X,NACT,1,1,NACT,1,IERR)
        IF(IERR.NE.0) GO TO 8999
        ERRSTR='DEPENDENT COORDINATE (F) DATA'
        CALL UFCPRD(ILUN,F,NACT,1,1,NACT,1,IERR)
        IF(IERR.NE.0) GO TO 8999
      ELSE
C
C  READ UNCOMPRESSED DATA
        ErrStr = 'Input Data Format'
        if ((IFORMAT.lt.0).or.(IFORMAT.gt.1)) go to 8999
 
        ERRSTR='INDEPENDENT COORDINATE (X) DATA'
        if(IFORMAT.eq.0) then
           READ(ILUN,3008,ERR=8999,END=8999) (X(IJ),IJ=1,NACT)
        else
           call ufascio(ilun,x,nact,'R',iendr,ierrr)
           if(ierrr.gt.0) go to 8999
           if(iendr.gt.0) go to 8999
        endif
 
        ERRSTR='DEPENDENT COORDINATE (F) DATA'
        if(IFORMAT.eq.0) then
           READ(ILUN,3008,ERR=8999,END=8999) (F(IJ),IJ=1,NACT)
        else
           call ufascio(ilun,f,nact,'R',iendr,ierrr)
           if(ierrr.gt.0) go to 8999
           if(iendr.gt.0) go to 8999
        endif
	
 3008   FORMAT(6(1PE12.4))  ! old format
      ENDIF
C
C  READ DUMMY LINE AT END ("--END-OF-DATA--...")
      ERRSTR='TRAILER RECORD'
      IF(KMPRS.EQ.0) READ(ILUN,3099,ERR=8999,END=8999) IDUMMY
 3099 FORMAT(A1)
C
      IER=0
      UFSTAT(ICHAN)=5
      RETURN
C----------
C  ERRORS
C
 8999 CONTINUE
      WRITE(UFELUN,9899) ERRSTR
 9899 FORMAT(' ? *FATAL* END OF FILE OR READ ERROR ON UFILE READ:'/
     >    6X,A)
C
 9000 CONTINUE
      WRITE(UFELUN,9900)
 9900 FORMAT(' ?UF1DRD: DATA NOT READ DUE TO ERROR - HIT RETURN')
      CALL UFPAUS(1)
      IER=1
      UFSTAT(ICHAN)=5
      RETURN
      	END
C******************** END FILE UF1DRD.FOR ; GROUP UFILES ******************

C******************** START FILE UFAHED2.FOR ; GROUP UFILES ******************
C----------------------------------------------------------------------
C  UFAHED2 - READ/WRITE ASCII FILE HEADER
C
C
      SUBROUTINE UFAHED2(ILUN,ISHOT,IDEV,IDIM,KMPRS,ZDATE,ZSDATE,
     >                    IWRITE,IFORMAT,IERH)
 
 
C  TbT 24 Aug 1993 - Changed from UFAHED to implement E13.6 format write
 
C
C  ILUN - UNIT TO READ/WRITE
C  ISHOT - UP TO 6 DIGIT SHOT NUMBER
C  IDEV - 4 CHAR TOKAMAK CODE
C  IDIM - UFILES FILE DIMENSIONALITY
C  IFORMAT - Returned as  0 on read if "old" data format of E11.4
C            Returned as  1 on read if "new" data format of E13.6
C            Returned as 99 on read if error.
C            Returned as  1 on write.
C  KMPRS - DATA COMPRESSION CODE
C  ZDATE - FILE WRITE DATE
C  ZSDATE - SHOT (DATA ORIGIN) DATE
C
C  IWRITE: = 0 ** READ **
C          = 1 ** WRITE **
C
C  OUTPUT IERH ERROR CODE 0=NORMAL, 1=ERROR
C   ROUTINE NOW CHECKS FOR ERROR ON READ
C
      CHARACTER*4 IDEV
      CHARACTER*10 ZDATE,ZSDATE
      CHARACTER*6 ZZSHOT
      CHARACTER*8 ZZBUF
      Character*1 CFORMAT
      Integer     IFORMAT
C
C-----------------------------------------
C
C  WRITE ***
C
      IFORMAT = 1    ! All writes done in E13.6 format after 8/24/93
      CFORMAT = '6'
      IERH=0
C
      IF(IWRITE.EQ.1) THEN
        WRITE(ILUN,3001) ISHOT,IDEV,IDIM,KMPRS,CFORMAT,IDIM,ZDATE
 3001   FORMAT(1X,I6,A4,1X,I1,1X,I1,1X,A1,T32,
     >    ';-SHOT #- F(X) DATA -UF',I1,'DWR- ',A10)
C
        WRITE(ILUN,3002) ZSDATE
 3002   FORMAT(1X,A10,T32,';-SHOT DATE-  UFILES ASCII FILE SYSTEM')
C
      ELSE IF(IWRITE.EQ.0) THEN
C
C  READ ***
C
        READ(ILUN,3003,ERR=9000,END=9000)
     1         ZZSHOT,IDEV,IDIM,KMPRS,CFORMAT,ZDATE
 3003   FORMAT(1X,A6,A4,1X,I1,1X,I1,1X, A1,42X,A10)
 
        If (CFORMAT .Eq. ' ') Then
          IFORMAT = 0
        Else If (CFORMAT .Eq. '6') Then
          IFORMAT = 1
        Else
C	    .Error - Field is not blank or 6.
          IFORMAT = 99
          Go To 9000
        End If
 
        READ(ILUN,3004,ERR=9000,END=9000) ZSDATE
 3004   FORMAT(1X,A10)
C
C  ** DEAL WITH POSSIBLE 5 OR 6 DIGIT SHOT NO. **
C
        ZZBUF=ZZSHOT//'  '
        IF(ZZSHOT(6:6).EQ.' ') THEN
          READ(ZZBUF,'(I5)',ERR=9000,END=9000) ISHOT
        ELSE
          READ(ZZBUF,'(I6)',ERR=9000,END=9000) ISHOT
        ENDIF
C
      ENDIF
C
      RETURN
C
C-------------------------------
C  ERROR EXIT
C
 9000 CONTINUE
      IERH=1
      RETURN
C
      END
C******************** END FILE UFAHED2.FOR ; GROUP UFILES ******************

C******************** START FILE USPLVL.FOR ; GROUP USPARM *************
C---------------------------------------------------------
C&  USPLVL  CHECK AND PACK UREAD PARAMETER VALUE
C          (STRIP LEADING AND TRAILING BLANKS)
C          VALUE MAY BE ANY NON-NULL ASCII STRING WITH
C          ANY CHARACTERS EXCEPT PARM. DELIMITER "/"
C
C  INPUT-- ZLINE  UNPACKED DATA LINE 1 CHAR PER WORD
C          LLINE  LENGTH OF DATA LINE
C          IND1   START LOCATION OF VALUE FIELD
C          IND2   FINISH LOCATION OF VAUE FIELD
C  OUTPUT-  ZVAL  96 CHARACTER LEFT JUSTIFIED PACKED VALUE
C          IER    =0  NORMAL SUCCESSFUL COMPLETION
C                 =1  ILLEGAL VALUE:  NULL OR TOO LONG
C
C
      SUBROUTINE USPLVL(ZLINE,LLINE,IND1,IND2,ZVAL,IER)
      USE USERIO
      CHARACTER*1 ZLINE(LLINE)
      CHARACTER*1 ZBLANK,ZUT(96)
      CHARACTER*96 ZVAL
      DATA ZBLANK/' '/
C
C  START OF EXECUTABLE CODE.  IGNORE LEADING AND TRAILING BLANKS
C
      IER=0
C
      zval=' '
      ILENMX=LEN(ZVAL)
C
 10   CONTINUE
      IF(IND1.GT.IND2) GO TO 400
      IF(ZLINE(IND1).NE.ZBLANK) GO TO 20
      IND1=IND1+1
      GO TO 10
C
 20   CONTINUE
      IF(IND2.LT.IND1) GO TO 400
      IF(ZLINE(IND2).NE.ZBLANK) GO TO 40
      IND2=IND2-1
      GO TO 20
C
 40   CONTINUE
      ILEN=IND2-IND1+1
      IF(ILEN.GT.ILENMX) GO TO 500
C VAUE OK.  PACK IT
      DO 60 I=1,ILENMX
      ZUT(I)=ZBLANK
      IF(I.GT.ILEN) GO TO 60
      IND=IND1+I-1
      ZUT(I)=ZLINE(IND)
 60   CONTINUE
      WRITE(ZVAL,1001) (ZUT(I),I=1,ILENMX)
 1001 FORMAT(96A1)

      do i=1,ilenmx
         if(zval(i:i).eq."'") go to 510
      enddo
C
      RETURN
C
C  BLANK VALUE FIELD ****
C
 400  CONTINUE
      ZVAL=';NULL'
      IER=0
      RETURN
C
C
C  ERRORS *********
C
 500  CONTINUE
      WRITE(LUNTRM,9001) ILENMX
 9001 FORMAT(' % ILLEGAL SYNTAX IN PARAMETER VALUE FIELD'/
     >  '   NULL NAME OR NAME TOO LONG (MAX ',I2,'  CHARS)'/)
      CALL UCLEAR
      CALL UPAUST(1)
      IER=1
      RETURN
C
 510  continue
      write(luntrm,9002) trim(zval)
 9002 format(' % illegal parameter value: "',a,'":'/
     >   '   (single quote) characters not allowed.'/
     >   '   (necessary to avoid infinite recursive substitution loop)')
      ier=2
      return
C
      	END
C******************** END FILE USPLVL.FOR ; GROUP USPARM ***************

C******************** START FILE URSTOP.FOR ; GROUP URDUTS ******************
C------------------------------------------------
C& URSTOP  UREAD AFTER ERROR, FLUSH INPUT LINE BUFFER AND CALL UPAUST
C
C  ERROR MESSAGE PROVIDED BY CALLER
C
      SUBROUTINE URSTOP(IARG)
C  IARG = 0 : NO UPAUST CALL
C       = 1 : UPAUST(0) (NO PAGE CLEAR)
C       = 2 : UPAUST(1) (PAGE CLEAR)
C
      CALL UCLEAR
      IF(IARG.EQ.0) RETURN
      IP=IARG-1
      CALL UPAUST(IP)
      RETURN
      END
C******************** END FILE URSTOP.FOR ; GROUP URDUTS ******************

C****************** START FILE MULCDR.FOR ; GROUP MULCDR **************
C------------------------------------------------------------
C  MULCDR
C
C  DRAW MULTIPLE (R,Y) CONTOURS  - BASED ON MULFDR - DMC 9/84
C
C  DRAW A MULTIPLOT WITH KEY.
C  CALLER SETS SCALE AND AXIS TYPE
C
C  DATA TO BE PLOTTED IS PASSED IN 2D ARRAYS
C
C  NO USER I/O OR CONTROL IS PROVIDED EXCEPT TO CALL UPAUST AFTER
C  THE MULTIPLOT IS COMPLETE
C
      SUBROUTINE MULCDR(R,Y,ND1,NC,NNC,Z,NZ,ISELF,NSEL,IAXSEL,
     >     RUN,YUN,MNLAB,KYLAB,LBSEL)
C
      use bottoms_up
C
C  # SYMBOLS PER LINE (MAX)
      PARAMETER (NSYMBS=5)
C
C  ARGUMENTS -- ALL MUST BE SUPPLIED BY CALLER (OUTPUT IS GRAPH)
C
C  IN COMMON/DPLOT1/  XMIN,XMAX,YMIN,YMAX -- THE SCALE OF THE GRAPH
C
C  PASSED:
C   R(ND1,NZ)  DATA BUFFER OF INDICATED DIMENSIONS-- HORIZONTAL CONTOUR
C              PARAMETRIZATION
C   Y(ND1,NZ)  DATA BUFFER OF INDICATED DIMENSIONS-- VERTICAL CONTOUR
C              PARAMETRIZATION
C
C     the i'th point in the j'th contour is at (R(i,j),Y(i,j))
C
C  **NC** IS THE ACTUAL NUMBER OF PTS IN EACH CONTOUR (.LE.ND1)
C   NC(NNC) -- NC(1) IS THE NO. OF PTS IN THE 1ST CONTOUR ...
C              NC(MIN(NZ,NNC)) IS THE NO. OF PTS IN THE NZ'TH CONTOUR
C              NOTE THAT BY PASSING NNC=1 ONE MAY SPECIFY THE SAME
C              NO. OF POINTS IN ALL CONTOURS, OR BY SETTING NNC=NZ
C              AND FILLING THE NC INTEGER ARRAY ONE MAY HAVE A DIFFERENT
C              NO. OF POINTS FOR EACH CONTOUR.  HOWEVER,
C                  2 .LE. NC(J) .LE. ND1
C              MUST BE MAINTAINED FOR ALL J BTW 1 AND MIN(NZ,NNC)
C
C   Z(NZ)      CONTOUR INDEXING
C
C   ISELF(NSEL) SELECTS WHICH CONTOURS ARE TO APPEAR
C     ON THE MULTIPLOT.
C   **NSEL** IS THE NUMBER OF CURVES TO APPEAR ON THE MULTIPLOT
C     the contours that appear correspond to
C       Z(iself(1)), Z(iself(2)), ..., Z(iself(NSEL)).
C
C   IAXSEL      SELECTS THE AXIS TYPE:
C     =-11 FOR LINEAR-LINEAR
C     =-15 FOR LINEAR-LOG(Y)
C     =-30 FOR LOG(X)-LOG(Y)
C     =-40 FOR LOG(X)-LINEAR
C   -----------
C   CHARACTER LABELS:
C   ------------
C    RUN        10 CHAR HORIZONTAL AXIS PHYSICAL UNITS LABEL
C    YUN        10 CHAR VERTICAL AXIS PHYSICAL UNITS LABEL
C
C   MNLAB       3 60 CHARACTER "MAIN LABELS"-- 1ST TWO APPEAR
C               ABOVE GRAPH, LAST ONE BELOW
C   KYLAB       5 17 CHARACTER KEY LABELS -- 1ST TWO APPEAR
C               AT TOP OF KEY BOX, LAST THREE AT BOTTOM
C   LBSEL(NSEL) NSEL 10 CHARACTER SELECT LABELS-- 10 CHARACTERS
C               TO ID EACH CURVE IN THE MULTIPLOT (1,2,... NSEL)
C
C *NOTE LABELS DO *NOT* NEED TO BE TERMINATED WITH "$", BUT A "$" IN
C  THE LABEL WILL CHOP OFF OUTPUT OF THE LABEL AT THAT POINT***
C
      INCLUDE 'PLOT1MMX'
      REAL R(ND1,NZ),Y(ND1,NZ),Z(NZ)
      INTEGER ISELF(NSEL)
      INTEGER NC(NNC)
      CHARACTER*(*) MNLAB(3)
      CHARACTER*(*) KYLAB(5)
      CHARACTER*(*) LBSEL(NSEL),RUN,YUN
C
C  LOCAL VARIABLES-- DETERMINE LOCATION OF LABELS, LINE STYLES,
C     SIZE OF GRAPH, ETC.
C
      real :: zzx(1),zzy(1)
      DIMENSION ZXL(NSYMBS),ZYL(NSYMBS)
      INTEGER IPLOTF(2,15)
C
C  SELECT LINE DASH STYLE / SYMBOL COMBINATIONS
      DATA IPLOTF/1,13,2,14,6,15,4,16,3,13,1,14,2,15,6,16,
     >              4,13,3,14,1,15,2,16,6,13,4,14,3,15/
C
C  USE MULFDR INCLUDE FILE FOR DATA RE. RASTER LOCATIONS OF VARIOUS
C  PLOT COMPONENTS, LABELS, ETC.
C
      INCLUDE 'MULFDR_BLK'
C
C
C----------------------------------------------
C  START OF EXECUTABLE CODE
C
      call bu_eval(mnlab(3),' ',irast)  ! check for multi-line lower label
C  MAX OF 15 FCNS
C
      INSEL=MIN0(15,NSEL)
C  # PTS IN FIRST CURVE
      INUM=NC(1)
C  # OF PTS IN PLOT WINDOW
      INUMS=MAX0(1,IMMNB(R(1,ISELF(1)),Y(1,ISELF(1)),INUM))
C  SYMBOL SPACING VARIABLES
      INTVL=MAX0(1,(INUMS+NSYMBS-1)/NSYMBS)
      IF(INTVL.LT.NSYMBS) THEN
        ISINC=INTVL-1
      ELSE
        ISINC=INTVL/NSYMBS
      ENDIF
C
      IST=MAX0(1,(INTVL/2-ISINC))
C
C  DRAW AXES
C
      ZZX=XMAX+5.0*(XMAX-XMIN)
      ZZY=YMAX+5.0*(YMAX-YMIN)
      CALL DPLOTM(IXRG,IYRG,ZZX,ZZY,1,IAXSEL)
C
C  PLOT THE CURVES
C
      iwarn=0
      DO 30 I=1,INSEL
C
        INUM=NC(MIN0(I,NNC))  ! NO. OF PTS THIS CURVE
        if(inum.lt.2) then
           iwarn=iwarn+1
           go to 30
        endif
C
        IND=ISELF(I)          ! INDEX
C
C  LINE STYLE CODE
        ICOD=IPLOTF(1,I)
C  PLOT CONTOUR CURVE
        CALL DPLOTM(IXRG,IYRG,R(1,IND),Y(1,IND),INUM,ICOD)
C  PLOT SYMBOLS ON CURVE
        ICT=0
C  # OF PTS IN PLOT WINDOW
        INUMS=MAX0(1,IMMNB(R(1,IND),Y(1,IND),INUM))
C  SYMBOL SPACING VARIABLES
        INTVL=MAX0(1,(INUMS+NSYMBS-1)/NSYMBS)
        IF(INTVL.LT.NSYMBS) THEN
          ISINC=INTVL-1
        ELSE
          ISINC=INTVL/NSYMBS
        ENDIF
C
        IST=IST+ISINC
C
 24     CONTINUE
        IF(IST.GT.INTVL) THEN
          IST=IST-INTVL
          GO TO 24
        ENDIF
C
        IPT=IST-INTVL
C
        DO 26 J=1,NSYMBS
          IPT=IPT+INTVL
          CALL ISFNDS(ZXL,ZYL,NSYMBS,ICT,R(1,IND),Y(1,IND),INUM,IPT)
 26     CONTINUE
C
        IF(ICT.GT.0) CALL DPLOTM(IXRG,IYRG,ZXL,ZYL,ICT,IPLOTF(2,I))
 30   CONTINUE
C
C  DRAW KEY FRAME
C
      CALL MOVABS(IXRG(2),IYRG(2))
      CALL DRWABS(IXRG(3),IYRG(2))
      CALL DRWABS(IXRG(3),IYRG(1)+irast)
      CALL DRWABS(IXRG(2),IYRG(1)+irast)
      CALL DRWABS(IXRG(2),IYRG(2))
C  KEY LABELS
      DO 100 I=1,5
         ioff=0
         if(i.ge.3) ioff=irast
        CALL GRFLBL(IXRKY,IYRKY(I)+irast,KYLAB(I),17,0,0)
 100  CONTINUE
C  KEY LINES AND LABELS
      IYL=IYRKSL+IDRKY
      IYN=IYRKLA+IDRKY
      DO 110 I=1,INSEL
        IYL=IYL-IDRKY
        IYN=IYN-IDRKY
        CALL DPLOTK(IYL,IXRKSL,IYN,IXRKLA,IPLOTF(1,I),LBSEL(I))
 110  CONTINUE
C  FUNCTION UNITS
      CALL GRFLBL(IXRXU,IYRXU+irast,RUN,0,-1,0)
      CALL GRFLBL(IXRFU,IYRFU,YUN,0,-1,1)
C  MAIN GRAPH LABELS
      IJUST=-1
      DO I=1,3
         if(i.le.2) then
            CALL GRFLBL(IXRMN,IYRMN(I),MNLAB(I),60,IJUST,0)
         else
            ijust=0
            if(ibrk_lbl3.eq.0) then
               CALL GRFLBL(IXRMN,IYRMN(I),MNLAB(I),60,IJUST,0)
            else
               call grflbl(ixrmn,iyrmn(i)+irast,
     >              mnlab(i)(1:ibrk_lbl3),60,ijust,0)
               call grflbl(ixrmn,iyrmn(i),
     >              mnlab(i)(ibrk_lbl3+1:),60,ijust,0)
            endif
         endif
      ENDDO
C ---------
C GRAPH COMPLETED
C
      CALL UPAUST(2)
      if(iwarn.gt.0) then
         write(6,9901) iwarn
 9901    format(
     >   ' %mulcdr warning:  ',i2,' invalid contour lengths detected.')
      endif
C
      call bu_reset
C
      RETURN
      END
C******************** END FILE MULCDR.FOR ; GROUP MULCDR ***************

C--------------------------------------------------------------------
C  UPRSET -- SET UREAD PROMPT STYLE
C
      SUBROUTINE UPRSET(STR)
C
      USE USERIO
C
      CHARACTER*(*) STR
C
      IF((STR.EQ.'V').OR.(STR.EQ.'R')) THEN
        NLRVID=.TRUE.
        VIDCHS='R'
        NVIDCH=1
      ELSE IF(STR.EQ.'B') THEN
        NLRVID=.TRUE.
        VIDCHS='B'
        NVIDCH=1
      ELSE IF(STR.EQ.'U') THEN
        NLRVID=.TRUE.
        VIDCHS='U'
        NVIDCH=1
      ELSE
        NLRVID=.FALSE.
        VIDCHS='N'
        NVIDCH=1
      ENDIF
C
      RETURN
      END

program adas_test
!
! June 2009.
! Program to be used to open up and fill in all tables for available ADAS atomic data.
! Before runnig "adas_test" program, all tables have to be initialized. Call "adasinit" first.
!
  use iso_c_binding, only: fp => c_double
  use adas_mod
  implicit NONE
  real(fp) energy(1) ! [KeV/amu]
  real(fp) temp(1) ![KeV/amu]
  real(fp) density_e(1) ! electron density [1/cm^3]
  real(fp) sigv1(1)    ![m^3/sec]
  real(fp) sigv2(1,1)  ![m^3/sec]
  real(fp) sigv3(1,1,1)![m^3/sec]
  integer, parameter  :: jZimp_lbound = 3 , jZimp_ubound = 74 !3 <= Z impurity <=74  and  58,59,60 has some  
                                                              !problems with neutral radiation numerics,
                                                              !so they are forbidden.
  integer, dimension(2) ::  izneut = (/1,2/)  ! only H, and He are supported
  real(fp) zimp !Z imp
  integer i,ii
  integer, dimension(2,10) :: izchrg 
  integer fadas_type,istat
  real(fp) :: conc(1) ! impurity concentration from 0 to 1
  real(fp) zion(1)  !Z ion
  integer, parameter :: NEUTRAL=1, ION=2 ! beam type: =neutral or =ion
!
  !available reaction for H CX,II see adas_ion 
  !available reaction for He CX,II see adas_ion
  ! atomic charge of secondary particle {1, ..., 10}
  izchrg(1,:)=(/1,2,3,4,5,6,7,8,9,10/)
  izchrg(2,:)=(/1,2,0,4,0,6,0,8,0,0/)
  energy=100.00_fp 
  temp=10.00_fp 
  density_e=5.0e+12_fp ![1/cm^3]
  
  write(6,*) ' '
  write(6,*) ' -->adas_test:  atomic reaction tests...............'
  write(6,*) 'IMPURITY STOPPING CROSS_SECTION'
  !-------------------
  ! test: SV  impurity stopping cross-section
  !
  do i=1,size(izneut)
     do ii=jZimp_lbound, jZimp_ubound
        call adas_zstop_sigvz(izneut(i),dble(ii),energy,1,sigv1,istat)
        if(istat.eq.0) write(6,1001) izneut(i),ii,energy,sigv1
     enddo
  enddo
1001 format(/ &
          ' ** impurity stopping sigma*v ** '/ &
          ' Z(neutral atom) = ',i1,' Z(impurity) = ',i2,' E/A = ',f10.2, &
          ' KeV/AMU'/ &
          ' -->real(fp) sigma*v = ',1pe20.13)  

  !-------------------
  ! test: SV  impurity stopping coefficients from ADAS
  !
  write(6,*) ' '
  write(6,*) ' -->adas_test:  atomic reaction tests...............'
  write(6,*) 'IMPURITY STOPPING COEFFICIENT (EXCITED)'
  conc=1._fp !
  do i=1,size(izneut)
     do ii=1,size(izchrg,2)
        zion=dble(ii)
        call adas_bms(energy,1, i, conc,temp,1,&
             &              zion,density_e,1,&
             &              sigv3,istat)
        if(istat.eq.0) write(6,1014) ' ** impurity stopping coefficient (EXCITED) sigma*v (m**3/sec) **', &
             &i,ii,energy,temp,density_e,sigv3
        
     enddo
  enddo
 1014 format(/,A,/ &
          ' Z(neutral beam) = ',i1,'  Z(ion species) = ',i2/ &
          ' E(beam) = ',f10.2,' KeV/AMU'/ &
          ' temperature = ',f10.2,' KeV/AMU'/&
          ' electron density = ',1pe20.13,' 1/cm**3'/ &
          ' -->real(fp) result = ',1pe20.13)
   
  !-------------------
  ! test:  electron impact ionization
  !
  write(6,*) ' '
  write(6,*) ' '
  write(6,*) 'ELECTRON IMPACT IONOZATION'
  do i=1,size(izneut)
     call adas_sigvte_ioniz(izneut(i),temp,1,sigv1,istat)
     write(6,1002) izneut(i),temp,sigv1
  enddo
1002 format(/ &
          ' ** electron impact ionization <sigma*v> ** '/ &
          ' Z(neutral atom) = ',i1,' electron temperature = ',f10.2,' KeV'/ &
          ' -->real(fp) <sigma*v> = ',1pe20.13)
  energy=100.00_fp ! KeV/amu (beam energy/nucleon)
  temp=10.00_fp    ! KeV/amu (target temperature/nucleon)
  !-------------------
  ! test:  CHARGE EXCHANGE(neutralizing) sigma*v 
  !
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE(neutralizing) sigma*v  COEFFICIENT'
  fadas_type=1 !'CX'
  do i=1,size(izneut)
     do ii=1,size(izneut)
        call adas_sigv(fadas_type,energy,1,i,dble(ii),sigv1,istat)
        if(istat.eq.0) write(6,1013) ' ** charge exchange sigma*v (m**3/sec) **', &
             &i,ii,energy,sigv1
     enddo
  enddo
 1013 format(/,A,/ &
          ' Z(neutral beam) = ',i1,'  Z(ion species) = ',i2/ &
          ' E(beam) = ',f10.2,' KeV/AMU'/ &
          ' -->real(fp) result = ',1pe20.13)
   
  !-------------------
  ! test:  impact ionization sigma*v
  !
  write(6,*)' '
  write(6,*)' '
  write(6,*)' IMPACT IONIZATION sigma*v  COEFFICIENT'
  fadas_type=2 !'II'
  do i=1,size(izneut)
     do ii=1,size(izchrg,2)
        call adas_sigv(fadas_type,energy,1,i,dble(ii),sigv1,istat)
        if(istat.eq.0) write(6,1013) ' ** impact ionization  sigma*v (m**3/sec) **', &
             &i,ii,energy,sigv1
     enddo
  enddo

  !-------------------
  ! test:  charge exchange rate coefficient
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE RATE COEFFICIENT NEUTRAL_BEAM'
  fadas_type=1 !'CX'
  do i=1,size(izneut)
     do ii=1,size(izneut)
        call adas_btsigv(fadas_type,NEUTRAL,energy,temp,1,i,ii,sigv1,istat)
        if(istat.eq.0) write(6,1003) ' ** charge exchange <sigma*v> ** ', &
             &i,izchrg(i,ii),energy,temp,sigv1
     enddo
  enddo
  !-------------------
  ! test:  CHARGE EXCHANGE  <sigma*v>
  !
  write(6,*)' '
  write(6,*)' '
  write(6,*)'CHARGE EXCHANGE RATE COEFFICIENT ION_BEAM'
  fadas_type=1 !'CX'
  do i=1,size(izneut)
     do ii=1,size(izneut)
        call adas_btsigv(fadas_type,ION,energy,temp,1,i,ii,sigv1,istat)
        if(istat.eq.0) write(6,1004) ' ** charge exchange <sigma*v> ** ', &
             &i,izchrg(i,ii),energy,temp,sigv1
     enddo
  enddo
  !-------------------
  ! test:  impact ionization <sigma*v>
  !
  write(6,*)' '
  write(6,*)' '
  write(6,*)'IMPACT IONIZATION NEUTRAL_BEAM '
  fadas_type=2 !'II'
  do i=1,size(izneut)
     do ii=1,size(izchrg,2)
        if(izchrg(i,ii).eq.0) cycle
        call adas_btsigv(fadas_type,NEUTRAL,energy,temp,1,i,ii,sigv1,istat)
        if(istat.eq.0) write(6,1003) ' ** ion impact ionization <sigma*v> ** ', &
             &i,izchrg(i,ii),energy,temp,sigv1
     enddo
  enddo
 1003 format(/,A,/ &
          ' Z(neutral beam) = ',i1,'  Z(target plasma) = ',i2/ &
          ' E(beam) = ',f10.2,' KeV/AMU;  T(target) = ',f10.2,' KeV/AMU'/ &
          ' -->real(fp) result = ',1pe20.13)
  write(6,*)' '
  write(6,*)' '
  write(6,*)'IMPACT IONIZATION ION_BEAM '
  fadas_type=2 !'II'
  do i=1,size(izneut)
     do ii=1,size(izchrg,2)
        if(izchrg(i,ii).eq.0) cycle
        call adas_btsigv(fadas_type,ION,energy,temp,1,i,ii,sigv1,istat)
        if(istat.eq.0) write(6,1004) ' ** ion impact ionization <sigma*v> ** ', &
             &i,izchrg(i,ii),energy,temp,sigv1
     enddo
  enddo
 1004 format(/,A,/ &
          ' Z(ion beam) = ',i1,'  Z(target plasma) = ',i2/ &
          ' E(beam) = ',f10.2,' KeV/AMU;  T(target) = ',f10.2,' KeV/AMU'/ &
          ' -->real(fp) result = ',1pe20.13)
  stop
end program adas_test

      module mmds_access

*.. mmds_access                         manipulate mdsplus access settings
*
*
*     Author                            jim.conboy@jet.uk
*     Version                           1.01,  07Feb2007
*     Modifications
*
*     1.01  07Feb2007                   jim.conboy@jet.uk
*                                       getarg -> get_arg ( lib/portlib.a )
*     1.00  06Apr2006                   jim.conboy@jet.uk
*                                       Written
*----_^---------------------------------=========================================|
*
      implicit  none
*
*..GLOBAL
*
      type tmds_access
                                                      ! mdsplus server access
         character(len=4)             :: cSite        ! site where running 
         character(len=64)            :: cserver      ! server name
         character(len=24)            :: cTree        ! Tree name
         integer                      :: ishot,       ! Tok shot #
     +                                   imds_shot,   ! mds plus shot #
     +                                   imds_option  ! open option
                                                      ! 1 = read output (restore)
                                                      ! 2 = read output (no-wait)
                                                      ! 3 = read (input only)
                                                      ! 4 = edit (no-restore)
                                                      ! 5 = Create
                                                      ! 6 = connect only
*
         character(len=3)             :: cRun         ! transp run extn
         character(len=4)             :: cTok         ! Tokamak name
         character(len=256)           :: cCDFnm       ! Assoc netcdf file
         integer                      :: iyear        ! Shot year
         logical                      :: lConnect     ! is connected
         integer                      :: ierr         ! (last) error
      end type tmds_access

      character(len=1)                :: cgdlm='/'    ! file name delimiter
*
      character(len=*), parameter     :: zcM = 'mmds_access'
      contains

      subroutine mds_acc_def( tmds_acc, cSite, cProg, istat )
*.. mds_acc_def                         Set site specific mdsplus defaults
*
*
*     Author                            jim.conboy@jet.uk
*     Version                           1.00,  06Apr2006
*     Modifications
*
*     1.00  06Apr2006                   jim.conboy@jet.uk
*                                       Written
*----_^---------------------------------=========================================|
      implicit  none
*
*..GLOBAL
*--   variable                       :: name           ! description
*
*..Arguments
*
      type(tmds_access)              :: tmds_acc       ! Access parameters
      character(len=*)               :: cSite,         ! set defaults for site
     +                                  cProg          ! & program
      integer, intent(out)           :: istat          ! return status, 0=OK
*
*..local
      integer                        :: i              ! loop index 
*
*--   JET defaults
*
      character(len=*), parameter    :: cJET_server=
     +                                     'mdsplus.jet.efda.org',
     +                                  cJETRun='   ',
     +                                  cJETTok='JET '
*--
      character(len=*),parameter     :: zcr='mds_acc_def'
*     character(len=*),parameter     :: cStop=cM//cr
*----_^------------------------------::================!.........................|
*
      istat = 1                             ! assume the worst..
      Site: select case( cSite(1:3))
         case('   ')                        ! flag when not used
            tmds_acc%cSite     = '    '
            tmds_acc%cserver   = '    '
            tmds_acc%ctree     = '    '
            tmds_acc%ishot     = 0
            tmds_acc%imds_shot = 0
            tmds_acc%cRun      = cJETRun
            tmds_acc%cTok      = cJETTok 
            tmds_acc%iyear     = -1         ! not used
         case('JET','jet')
            tmds_acc%cSite     = 'JET '
            tmds_acc%cserver   = cJET_server
            tmds_acc%ishot     = 0
            tmds_acc%imds_shot = 0
            tmds_acc%cRun      = cJETRun
            tmds_acc%cTok      = cJETTok 
            tmds_acc%iyear     = -1         ! not used 
            istat              = 0
            if( cProg == 'mdsplot' )   then
                tmds_acc%ctree     = 'trout'
            endif
         case default
            print *,zcr,' -E- No defaults coded for site ',cSite
      end select site
*
      end subroutine mds_acc_def


      subroutine mds_acc_args( tmds_acc, istat )
*.. mds_acc_args                        Parse arguments related to mdsplus
*
*
*     Author                            jim.conboy@jet.uk
*     Version                           1.00,  06Apr2006
*     Modifications
*
*     1.00  06Apr2006                   jim.conboy@jet.uk
*                                       Written
*----_^---------------------------------=========================================|
      implicit  none
*
*..GLOBAL
*--   variable                       :: name           ! description
*
*..Arguments
*
      type(tmds_access)              :: tmds_acc       ! Access parameters
      integer, intent(out)           :: istat          ! error flag
*
*..Local
      integer                        :: nargs,         ! # of arguments
     +                                  iarg           ! Arg count
*
      character(len=64)              :: carg,          ! current arg
     +                                  cargl          ! previous arg
*
      character(len=*),parameter     :: zcr='mds_acc_args'
      character(len=*),parameter     :: cStop=zcM//zcr
*----_^------------------------------::================!.........................|

      call get_arg_count( nargs )
*
      if( nargs < 1 )            then
          carg = '?'
      else
         call get_arg( 1, carg )
      endif
*
      if( nargs < 4 .or. index( carg,'?' ) > 1 )          then
         write(6,600) '-p -s','<pulse>',' '
         write(6,600) '-r ', '<runid>', 'a1i2'
         write(6,600) '-srv','<mds server>', ''
         write(6,600) '-o',  'Open option ', '5 = create'
*
         istat  =  -1 ;                                  return
                                                         endif
 600  format(8x,a,t16,a,t32,a)
*         
      cargl = ''
      l_arg: do iarg=1,nargs
         call get_arg(iarg, carg)

         select case (cargl)

            case ('-P','-S','-p','-s')
               read(carg,'(i9)') tmds_acc%ishot

            case('-SRV', '-srv' )
               tmds_acc%cserver = trim(carg )

            case ('-O','-o')
               read(carg,'(i9)') tmds_acc%imds_option

            case ('-R','-r')
               tmds_acc%cRun = trim( carg )

            case default
         end select
         cargl  =  carg
      end do l_arg
*
      print *,zcr,': Shot, option ',
     +               tmds_acc%ishot, tmds_acc%imds_option
*
      if( tmds_acc%ishot < 1 )     then
         print *,zcr,' -F- Invalid shot number ',tmds_acc%ishot
         call errmsg_exit(cStop)
      endif
*
      if(      tmds_acc%imds_option < 1 
     +    .or. tmds_acc%imds_option > 6 )  then
         print *,zcr,' -F- Invalid option ',tmds_acc%imds_option
         call errmsg_exit(cStop)
      endif
*
      print *,'mds_acc_args not implemented'
      end subroutine mds_acc_args


      subroutine mds_acc_local( tmds_acc, istat )
*.. mds_acc_local                        Parse arguments related to mdsplus
*
*
*     Author                            jim.conboy@jet.uk
*     Version                           1.00,  06Apr2006
*     Modifications
*
*     1.00  06Apr2006                   jim.conboy@jet.uk
*                                       Written
*----_^---------------------------------=========================================|
      implicit  none
*
*..GLOBAL
*--   variable                       :: name           ! description
*
*..Arguments
*
      type(tmds_access)              :: tmds_acc       ! Access parameters
      integer, intent(out)           :: istat          ! error flag
*
*..Local
      integer                        :: nargs,         ! # of arguments
     +                                  iarg           ! Arg count
*
      character(len=64)              :: carg,          ! current arg
     +                                  cargl          ! previous arg
*
      character(len=54)              :: cABC =
     +   ' aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ'
      character(len=*),parameter     :: zcr='mds_acc_local'
      character(len=*),parameter     :: cStop=zcM//zcr
*----_^------------------------------::================!.........................|
*
      select case( tmds_acc%cSite)
         case('JET ')
            if( tmds_acc%cRun /= '   ' )                  then
*--   Fix mds shot #
               read(tmds_acc%cRun(2:3),'(i2)') 
     +                        tmds_acc%imds_shot
                tmds_acc%imds_shot  =
     +             tmds_acc%imds_shot
     +           + tmds_acc%iShot*10000
     +           + 100*(index(cABC, tmds_acc%cRun(1:1))/2)
                                                          endif
*
         case default
      end select

      end subroutine mds_acc_local

      subroutine mds_acc_open( tmds_acc, istat )
*.. mds_acc_open                        open tree ( just calls mds_conopn for now )
*
*
*     Author                            jim.conboy@jet.uk
*     Version                           1.00,  06Apr2006
*     Modifications
*
*     1.00  06Apr2006                   jim.conboy@jet.uk
*                                       Written
*----_^---------------------------------=========================================|
      implicit  none
*
*..GLOBAL
*--   variable                       :: name           ! description
*
*..Arguments
*
      type(tmds_access)              :: tmds_acc       ! Access parameters
      integer, intent(out)           :: istat          ! error flag
*
*..Local
      integer                        :: lunlog = 6,
     +                                  imds_socket    ! not used
*
      character(len=10)              :: cShot
*
      character(len=*),parameter     :: zcr='mds_acc_open'
      character(len=*),parameter     :: cStop=zcM//zcr
*----_^------------------------------::================!.........................|
*
      write(cShot,'(I10)') tmds_acc%ishot
*
      call mds_conopn( lunlog,
     +                 tmds_acc%cserver,
     +                 tmds_acc%ctree,
     +                 trim(cShot)//tmds_acc%crun,
     +                 tmds_acc%cTok,              ! not used
     +                 tmds_acc%iyear,
     +                 tmds_acc%imds_shot,
     +                 imds_socket,
     +                 tmds_acc%imds_option,
     +                 tmds_acc%ierr           )
*
      print *,zcr,': mds_conopn returns ',tmds_acc%ierr
*
      if( tmds_acc%ierr /= 0 )   call errmsg_exit(zcr)
*

      end subroutine mds_acc_open

      subroutine mds_acc_cdfnm( tmds_acc, cdir, istat )
*.. mds_acc_cdfnm                       TEMPORARY - fix up cdf filename ( for testing )
*
*
*     Author                            jim.conboy@jet.uk
*     Version                           1.00,  25May2006
*     Modifications
*
*     1.00  25May2006                   jim.conboy@jet.uk
*                                       Written
*----_^---------------------------------=========================================|
      implicit  none
*
*..GLOBAL
*--   variable                       :: name           ! description
*
*..Arguments
*
      type(tmds_access)              :: tmds_acc       ! mds spec
      character(len=*), intent(in)   :: cdir           ! directory spec
      integer, intent(out)           :: istat          ! return status, 0=OK
*
*..local
*
      character(len=512)             :: cbuf           ! work buffer
      integer                        :: il             ! cbuf index 
*
      character(len=*),parameter     :: zcr='mds_acc_cdfnm'
*     character(len=*),parameter     :: cStop=cM//cr
*----_^------------------------------::================!.........................|
*
      if( cdir(1:1) == '$' )           then
         call sget_env( cdir(2:), cbuf )
      else
         cbuf  =  trim(cdir)
      endif
*
      cbuf  =              trim(cbuf)
     +         // cgdlm // trim(tmds_acc%cTok)
     +         // cgdlm
*
      il  =  len_trim( cbuf ) + 1
      print *,zcr,' :',cbuf(:il)
*
      write(cbuf(il:),'(i5.5)')    tmds_acc%ishot
*
      cbuf  =              trim(cbuf)
     +         // cgdlm // trim(tmds_acc%cRun)
     +         // cgdlm // trim(tmds_acc%cRun) // '.CDF' 
*
      tmds_acc%cCDFnm  =  trim(cbuf)
*
      print *,zcr,' :',tmds_acc%cCDFnm
*
      end subroutine mds_acc_cdfnm


      subroutine mds_acc_get(  tmds_acc, istat, cRunId, cCDFnm )
*.. mds_acc_get                         Return variable(s) from tmds_acc dtatype
*
*
*     Author                            jim.conboy@jet.uk
*     Version                           1.00,  25May2006
*     Modifications
*
*     1.00  25May2006                   jim.conboy@jet.uk
*                                       Written
*----_^---------------------------------=========================================|
      implicit  none
*
*..GLOBAL
*--   variable                       :: name           ! description
*
*..Arguments
*
      type(tmds_access)              ::  tmds_acc
      integer, intent(out)           :: istat
*
      character(len=*), 
     +   optional, intent(out)       :: cRunId,        ! RunID - nnnnnxnn
     +                                  cCDFnm         ! CDF file name
*
*..local
      integer                        :: i              ! loop index 
      character(len=6)               :: cshot
*
      character(len=*),parameter     :: zcr='mds_acc_get'
*     character(len=*),parameter     :: cStop=cM//cr
*----_^------------------------------::================!.........................|
*
      istat  =  1
*     if( .not. associated( tmds_acc ))                 return
      istat  =  0
*
      write(cshot,'(i5.5)')    tmds_acc%ishot
      if( present ( cRunId))            then
         cRunID  =  trim( cshot)//trim( tmds_acc%cRun)//' '
      endif
*
      if( present( cCDFnm ))
     +    cCDFnm  =  trim(  tmds_acc%cCDFnm )//' '
*
      end subroutine mds_acc_get


      end module mmds_access

      integer function iscmp1(zname,ablis,n)
C
C  look for a match of ZNAME in list ABLIS
C  return the index in ablis of a matching name, or 0 if not found
C
      implicit NONE
      integer n
      character*(*) zname
      character*(*) ablis(n)
C
C  local
C
      integer lmax
      parameter (lmax=512)
C
      integer ila,ilz,i,iscmp0,idummy
C
      character*1 dbuff(lmax)
      integer str_length
C
C-----------------------------
C
      iscmp1 = 0
C
      ila=min(lmax,len(ablis(1)))
      ilz=str_length(zname)
C
      if((ilz.eq.0).or.(ilz.gt.ila)) return
C
C  length OK
C
      do i=1,ila
         dbuff(i)=' '
         if(i.le.ilz) then
            dbuff(i)=zname(i:i)
            call uupper(dbuff(i))
         endif
      enddo
C
      iscmp1 = iscmp0(dbuff,ablis,n,ila,idummy)
C
      return
      end

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_put1d(node, expr, dsc_data, units,
     $     dsc_dim0, udim0)
      implicit none
      character*(*) node
      character*(*) expr
      integer       dsc_data
      character*(*) units
      integer       dsc_dim0
      character*(*) udim0
      mds_put1d = 0
      return
      end
#else
c-----------------------------------------------------------------------
c mds_put1d
c
c Input
c   node      -- character  i.e.
c   expr      -- character
c   dsc_data  -- descriptor pointing to array
c   units     -- character string
c   dsc_dim0  -- descriptor pointing to array
c   udim0     -- character string
c
c Returns
c   error code - odd numbers good even numbers bad
c   (odd numbers mapped to 1)
c
c 03/17/1999 ler Converting to unix usable
c-----------------------------------------------------------------------
      integer function mds_put1d(node, expr, dsc_data, units,
     $     dsc_dim0, udim0)
      implicit none
 
      character*(*) node
      character*(*) expr
      integer       dsc_data
      character*(*) units
      integer       dsc_dim0
      character*(*) udim0
 
      character*4097 str_node, str_expr, str_units, str_udim0
      integer ln, le, lu, lu0
      integer dsc_units, dsc_udim0
      integer status
 
      integer descr, MdsPut
      integer mds__leniftrim, mds__cstring
 
      ln  = max(1, mds__leniftrim(node))
      le  = max(1, mds__leniftrim(expr))
      lu  = max(1, mds__leniftrim(units))
      lu0 = max(1, mds__leniftrim(udim0))
 
      call mds__copywnull(str_node, node)
      call mds__copywnull(str_expr, expr)
      call mds__copywnull(str_units, units)
      call mds__copywnull(str_udim0, udim0)
 
      dsc_units = descr(mds__cstring(), str_units, 0, lu)
      dsc_udim0 = descr(mds__cstring(), str_udim0, 0, lu0)
      status = MdsPut(str_node, str_expr, dsc_data, dsc_units,
     $     dsc_dim0, dsc_udim0, 0)
 
      mds_put1d = status
 
      return
      end
#endif

C******************** START FILE DPLOT1.FOR ; GROUP DPLOTT *************
C------------------------------------------------------
C  DPLOT1
C
C	TEKTRONIX GRAPHICS ROUTINE
C
      SUBROUTINE DPLOT1(X,Y,N,M)
C	XXXXX  VERSION  10/05/76    XXXXXX
C    VAX VERSION REV MAY 1982 D. MC CUNE
C
C	THIS PROGRAM GENERATES A QUICK PLOTTING ROUTINE
C	THE ARRAY X(I) IS THE X-AXIS DATA
C	THE ARRAY Y(I) IS THE Y-AXIS DATA
C	N IS THE NUMBER OF POINTS TO BE PLOTTED
C
C
C	THE PARMETER M SPECIFIES WHETHER OR NOT A SET OF
C	AXES IS TO BE DRAWN
C	IF M <= 0 THE AXIS IS DRAWN
C	IF M >= 1 THE AXIS IS NOT DRAWN
C
C	IF M < 0 X AND Y BOUNDS ARE SET
C	IF M = -15 SEMILOG PLOT LOG(Y)  - X AND Y BOUNDS SET
C	IF M = -30 LOG PLOT -- X AND Y BOUNDS SET
C       IF M = -40 LOG(X) SEMILOG PLOT - X AND Y BOUNDS SET
C       ALL OTHER M <=0 : LINEAR PLOT X AND Y BOUNDS SET
C
C	IF M > 1 VARIOUS LINE SYMBOLS CAN BE CHOSEN
C         M=1,2,3,4,...,10
C
C	IF M > 10 INDIVIDUAL POINTS ARE PLOTTED USING VARIOUS SYMBOLS
C         M=13,14,15,16
c
c-------------------------------
c  allow for raising of lower edge (dmc Dec 2009...)
c
      use bottoms_up
c
c-------------------------------
C
      DIMENSION X(N),Y(N)
C  SCALE PRESET BY CALLER
      INCLUDE 'PLOT1MMXB'
C  SCREEN LIMITS
      INCLUDE 'GFTIC'
C
      if(.not.init_gftic) call gftic0
C
      IF(NRSET.GT.0) GO TO 1
C  SET DEFAULT SCREEN LIMITS
      NXR1=150
      NXR2=950
      NYR1=125
      NYR2=700
      NRSET=1
C
 1    CONTINUE
C IF M<=0 SET SCALE AND DRAW AXES
      IF(M.GT.0)GOTO 2
      CALL UBINIT
      CALL GFTICS
      CALL SLIMX(NXR1,NXR2)
      CALL SLIMY(NYR1+idybu*ibu_raise,NYR2)  ! bottoms_up adjust...
      CALL DLIMX(XBND1,XBND2)
      CALL DLIMY(YBND1,YBND2)
      CALL NPTS(N)
      IF(M.EQ.-15 .OR. M .EQ. -30)CALL YTYPE(2)
      IF(M .EQ. -30 .OR. M .EQ. -40) CALL XTYPE(2)
      CALL DPLNST(1,ILINE,ISYM,SIZE)
C  MAKE PLOT
      CALL CHECK(X,Y)
      CALL DSPLAY(X,Y)
      CALL GFTICX
      RETURN
C
C  M>0:  CHOOSE VARIOUS LINE + SYMBOL STYLES TO PLOT NEW CURVE
C   ON OLD PAIR OF AXES
C
 2    CONTINUE
      ISYM=0
      CALL SYMBL(ISYM)
      CALL NPTS(N)
      IF(M.LE.10) CALL DPLNST(M,ILINE,ISYM,SIZE)
      IF(M.GT.10) CALL DPSYST(M,ISYM,SIZE)
      CALL CPLOT(X,Y)
      RETURN
      END
C******************** END FILE DPLOT1.FOR ; GROUP DPLOTT ***************
C same as DPLOT1 but with small size of individual points
      SUBROUTINE DPLOT10(X,Y,N,M)
C	XXXXX  VERSION  10/05/76    XXXXXX
C    VAX VERSION REV MAY 1982 D. MC CUNE
C
C	THIS PROGRAM GENERATES A QUICK PLOTTING ROUTINE
C	THE ARRAY X(I) IS THE X-AXIS DATA
C	THE ARRAY Y(I) IS THE Y-AXIS DATA
C	N IS THE NUMBER OF POINTS TO BE PLOTTED
C
C
C	THE PARMETER M SPECIFIES WHETHER OR NOT A SET OF
C	AXES IS TO BE DRAWN
C	IF M <= 0 THE AXIS IS DRAWN
C	IF M >= 1 THE AXIS IS NOT DRAWN
C
C	IF M < 0 X AND Y BOUNDS ARE SET
C	IF M = -15 SEMILOG PLOT LOG(Y)  - X AND Y BOUNDS SET
C	IF M = -30 LOG PLOT -- X AND Y BOUNDS SET
C       IF M = -40 LOG(X) SEMILOG PLOT - X AND Y BOUNDS SET
C       ALL OTHER M <=0 : LINEAR PLOT X AND Y BOUNDS SET
C
C	IF M > 1 VARIOUS LINE SYMBOLS CAN BE CHOSEN
C         M=1,2,3,4,...,10
C
C	IF M > 10 INDIVIDUAL POINTS ARE PLOTTED USING VARIOUS SYMBOLS
C         M=13,14,15,16
c
c-------------------------------
c  allow for raising of lower edge (dmc Dec 2009...)
c
      use bottoms_up
c
c-------------------------------
C
      DIMENSION X(N),Y(N)
C  SCALE PRESET BY CALLER
      INCLUDE 'PLOT1MMXB'
C  SCREEN LIMITS
      INCLUDE 'GFTIC'
C
      if(.not.init_gftic) call gftic0
C
      IF(NRSET.GT.0) GO TO 1
C  SET DEFAULT SCREEN LIMITS
      NXR1=150
      NXR2=950
      NYR1=125
      NYR2=700
      NRSET=1
C
 1    CONTINUE
C IF M<=0 SET SCALE AND DRAW AXES
      IF(M.GT.0)GOTO 2
      CALL UBINIT
      CALL GFTICS
      CALL SLIMX(NXR1,NXR2)
      CALL SLIMY(NYR1+idybu*ibu_raise,NYR2)  ! bottoms_up adjust...
      CALL DLIMX(XBND1,XBND2)
      CALL DLIMY(YBND1,YBND2)
      CALL NPTS(N)
      IF(M.EQ.-15 .OR. M .EQ. -30)CALL YTYPE(2)
      IF(M .EQ. -30 .OR. M .EQ. -40) CALL XTYPE(2)
      CALL DPLNST(1,ILINE,ISYM,SIZE)
C  MAKE PLOT
      CALL CHECK(X,Y)
      CALL DSPLAY(X,Y)
      CALL GFTICX
      RETURN
C
C  M>0:  CHOOSE VARIOUS LINE + SYMBOL STYLES TO PLOT NEW CURVE
C   ON OLD PAIR OF AXES
C
 2    CONTINUE
      ISYM=0
      CALL SYMBL(ISYM)
      CALL NPTS(N)
      IF(M.LE.10) CALL DPLNST0(M,ILINE,ISYM,SIZE)
      IF(M.GT.10) CALL DPSYST0(M,ISYM,SIZE)
      CALL CPLOT(X,Y)
      RETURN
      END
C******************** END FILE DPLOT1.FOR ; GROUP DPLOTT ***************

program frantic_test

  ! execute a standalone frantic calculation
  ! this works by reading a NetCDF file containing the starting state
  ! of a frantic calculation, and proceding.

  ! this program accepts exactly one argument:  the NetCDF filename.

  ! mod DMC Dec 2008 -- the 2nd argument can contain optionally the wall source
  ! toroidal velocity in cm/sec
  !
  use iso_c_binding, only: fp => c_double
  implicit none

  integer :: nargs
  character(len=100) :: filename,zvel_str
  character(len=20) :: zvel_str0
  real(fp) :: zveloc

  integer :: izones,ierr,istat,ilen

  !-------------------------------
  !  use portlib routines to get command line argument

  call get_arg_count(nargs)
  if((nargs.lt.1).or.(nargs.gt.2)) call frantic_err_exit

  filename=' '
  call get_arg(1,filename)

  if(nargs.eq.2) then

    zvel_str=' '
    call get_arg(2,zvel_str)

    ilen=len(trim(zvel_str))
    if(ilen.gt.20) then
      write(6,*) ' argument too long: '//trim(zvel_str)
      call frantic_err_exit
    end if

    zvel_str0=' '
    zvel_str0(20-ilen+1:20)=zvel_str(1:ilen)

    read(zvel_str0,fmt='(G20.0)',iostat=istat) zveloc
    if(istat.ne.0) then
      write(6,*) ' could not parse as floating point: '//trim(zvel_str)
      call frantic_err_exit
    end if

    write(6,'(1x,a,1pe12.5,a)') ' *** resetting edge v_phi to ',zveloc, &
         ' cm/sec (per 2nd command argument).'

    zveloc = 0.01_fp*zveloc   ! -> m/sec
  end if

  !-------------------------------
  !  re-initialize state of frantic
  !  and re-calculate frantic neutral density, etc...
  !
  !  in the loop, allocate more and more x until there is enough.
  !

  call frantic_input_restore(filename,izones,ierr)
  write(6,*) ' %frantic_test: number of zones in output grid: ',izones


  if(nargs.eq.2) call frantic_edge_vphi(zveloc)


  if(ierr.eq.0) then

    !  now redo calculation

    call frantic_neuts(ierr)

    !  and print results summary

    if(ierr.eq.0) then
      call frantic_prinsum(6)
    end if

  end if

  if(ierr.ne.0) then
    call frantic_errmsg_exit(' ?? frantic_test: error reading NetCDF file: '// &
         filename(1:len_trim(filename)))
  end if

CONTAINS

  subroutine frantic_err_exit
    write(6,*) ' '
    write(6,*) ' ?? syntax:  frantic_test <NetCDF-filename>'
    write(6,*) '    alternate syntax: frantic_test <NetCDF-filename> <vphi_edge_sce(cm/sec)>'
    write(6,*) ' '
    stop
  end subroutine frantic_err_exit

  subroutine frantic_errmsg_exit(msg)
    implicit none
    character(len=*), intent(in) :: msg
    write(6,*) ' '
    write(6,*) trim(msg)
    write(6,*) ' '
    stop
  end subroutine frantic_errmsg_exit

end program frantic_test

      subroutine mds_conopn(lun, mds_server, mds_tree, runid, device,
     >                      year, mds_shot, mds_socket, option, ier)
      implicit none
C
C Input
      integer        lun     ! unit for error messages
      character*(*)  mds_tree   ! Tree name
      character*(*)  mds_server ! Server name
C                          ! either
      character*(*)  runid      ! Runid
      character*(*)  device     ! Tokamak
      integer        year       ! Year
      character*2    zy
C                          ! or
      integer        mds_shot   ! Mdsplus Id Number
C
C Return
      integer        mds_socket ! for repeated calls (not implemented)
 
      integer        option     !   1 = open to read output (restore)
C                               !   2 = open to read output (no-wait)
C                               !   3 = open to read (input only)
C                               !   4 = open for edit (no-restore)
C                               !   5 = Create
C                               !   6 = connect only
C
      integer       ier         !   not 0 = Error
C-----------------------------------------------------------------------
C Local
      character     devyr*7,  cshot*10
      integer       stat, ios
      integer       iln, ilt,  ils, ilr, ild, retlen, l, ls
      character*80  expr
      character*1   copt
      integer       nshot
 
C MDSplus
      integer       Mds_Value, idescr_long
      integer       mdsfconnect, MdsValue
      integer       mds_open
      integer       mdsstat, dsc, size
C
      integer ilnurd
C
      save      mdsstat
C      volatile      mdsstat
C
C---------------------------------------------------------------------------
      print*,'mds_conopn: option =', option,mds_shot,' ',mds_tree
      if (option .eq. 3) then
         copt='3'
      else if ( option .eq. 4) then
         copt='4'
      endif
 
C Connect to server
C------------------
      ils=index(mds_server,' ')-1
      if(ils.le.0) ils=len(mds_server)
      if (mds_server(1:ils) .ne. 'LOCAL' .and.
     >     mds_server(1:ils) .ne. 'local') then
         write(lun,*) ' ...connecting to server:  ',
     >        mds_server(1:ils)
         mds_socket = mdsfconnect(mds_server(1:ils)//char(0))
         if( mds_socket .lt. 0) then
            write(lun,'("?mds_conopn:  mdsfconnect stat: ",i5)')
     >           mds_socket
            ier=-1
            return
         endif
      else
         mds_socket = -1
      endif
C Connect only 
      if (option .eq. 6) then
         ier=0
         return
      endif
C
C Open Tree
C==========
      ilr=index(runid,' ')-1
      if(ilr.le.0) ilr=len(runid)
 
C User Tree TRW_
c     #@! for tree=TRW_*, set the pulse to the shot number
      if (mds_shot .eq. 0 .and. mds_tree(1:4) .eq. 'TRW_') then
C  extract shot from runid
         call checkid(runid,ilr,ls)
         read(runid(1:ls),'(i6)',iostat=ios) nshot
         mds_shot = nshot
      endif
C
C
C Option Create = 5
C==================
      if (option .eq. 5) then
         dsc = idescr_long(mdsstat)
         write(cshot,'(i10)',iostat=ier) mds_shot
         expr = 'tcl("SET TREE ' // mds_tree // '")' // CHAR(0)
         l=ilnurd(expr)
         print*, '...',expr(1:l)
         stat = MdsValue(expr, dsc, 0, size)
         if(mod(stat,2).ne.1) then
            call mdsmsg(lun,'?mds_opncon: '//expr(1:l)//' stat:  ',stat)
            ier = 0
            return
         endif
         if(mod(mdsstat,2).ne.1) then
            call mdsmsg(lun,'?mds_opncon: '//expr(1:l)//
     >                  ' mdsstat:  ',mdsstat)
            ier=1
            go to 9000
         endif

C#@! TCL(Create Pulse @{$4})
C#@create tree $3 mdsplus tree constructed in mds_opncon()
C#@! --------------
         expr = 'tcl("CREATE PULSE ' // cshot// '")' // CHAR(0)
         l=ilnurd(expr)
         print*, '...',expr(1:l)
         mdsstat=0
         dsc = idescr_long(mdsstat)
         stat = MdsValue(expr, dsc, 0, size)
         if(mod(mdsstat,2).ne.1) then
         call mdsmsg(lun,'?mds_opncon: '//expr(1:l)//
     >        ' mdsstat:  ',mdsstat)
            ier=1
            go to 9000
         endif
C
C End Create
C-----------
      else
C Open
C======
            if (mds_shot .eq. 0) then
               write(lun,'("%mds_conopn: no valid mds-pulse nubmer")')
               ier=1
               return
            endif
            ilt=index(mds_tree,' ')-1
            if(ilt.le.0) ilt=len(mds_tree)
            stat=mds_open(mds_tree(1:ilt),mds_shot)
            if(mod(stat,2).ne.1) then
               write(lun,'("%mds_conopn: failed to open ",a)')
     >              mds_tree(1:ilt)
               call mdsmsg(lun,' ?mds_conopn: mds_open '//
     >              mds_tree(1:ilt)//' stat:  ',stat)
               ier=-2
               go to 9000
            endif
         endif
C
C
C Open Tree for edit
      if (option .eq. 4 .or. option .eq. 5) then
         mdsstat=0
         dsc = idescr_long(mdsstat)
         write(cshot,'(i10)',iostat=ier) mds_shot
         expr = 'tcl("EDIT ' // trim(adjustl(mds_tree))
     >        // '/SHOT=' //trim(adjustl(cshot)) //
     >        '")' // CHAR(0)
         l=ilnurd(expr)
         print*, '...',expr(1:l)
         stat = MdsValue(expr, dsc, 0, size)
         if(mod(stat,2).ne.1) then
            call mdsmsg(lun,'?mds_conopn: '//expr(1:l)//' stat:  ',
     >           stat)
            ier = 1
            return
         endif
         if(mod(mdsstat,2).ne.1) then
            call mdsmsg(lun,'?mds_conopn: '//expr(1:l)//' cmdst: ',
     >           mdsstat)
C            if (device .eq. "HL2A") then
C               ier = 0
C            else
              ier = 1
C            endif
            return
         endif
      endif
 
      ier=0
C
 9000 return
C
      end
 
 
 
 

C Write 1 dimensional CDF data
C Called by uf1dwr
C
C 08/14/97 CAL
C
C----------------------------------------------------------------------------
      subroutine ucdf1w(lun,
     &            f, x, nx, iproc,
     &            flab,xlab,
     &            retn)
 
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Input
      integer       lun, iproc
      integer       nx
      real          x(nx), f(nx)
      character*(*) flab,  xlab
C Return
      integer retn
 
C Definitions for CDF
      character*1 namf, namx
      integer rank
      parameter (rank = 1)
      integer dims
 
C Definitions for processing
      integer       f_id, x_id
      character*20  fl, xl
      character*10  fu, xu
      integer       ichan, file_id
      integer       i, j
C
      data          namf,namx/'F','X'/
C----------------------------------------------------------------------------
C
C Define 1 Dimension
      dims = nx
C
C get file name
      call uflchk(lun,'ucdf1w',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
C
C
      fl = flab(1:20)
      xl = xlab(1:20)
      fu = flab(21:30)
      xu = xlab(21:30)
C
C Enter Define Mode
      retn = nf_redef(file_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9005) NF_STRERROR(retn)
 9005    format(' % UCDF1W: nf_redef '/,'     ',a)
         return
      end if
 
C Define Processing factor
      retn = nf_put_att_int(file_id,NF_GLOBAL,'scale_factor',
     &       NF_INT,1,iproc)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9000) NF_STRERROR(retn)
 9000    format(' % UCDF1W: nf_put_att_int - iproc '/,
     >        '     ',a)
         return
      end if
C
C
C Define dimensions
      retn = nf_def_dim(file_id,'X',nx,dims)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9007) namx, NF_STRERROR(retn)
 9007    format(' % UCDF1W: nf_def_dim ',a/,'     ',a)
         return
      end if
C
C Define Data Arrays
C------------------
 
C Define dependent variable F
      retn = nf_def_var(file_id, 'F', NF_FLOAT, rank, dims, f_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9001) namf, NF_STRERROR(retn)
 9001    format(' % UCDF1W: nf_def_var ',a/,'     ',a)
         return
      end if
 
      retn = nf_put_att_text(file_id,f_id,'units',10,fu)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9002) fu, NF_STRERROR(retn)
 9002    format(' % UCDF1W: nf_put_att_tex - units ',a/,'     ',a)
         return
      end if
 
      retn = nf_put_att_text(file_id,f_id,'long_name',20,fl)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9003) fl, NF_STRERROR(retn)
 9003    format(' % UCDF1W: nf_put_att_tex - label ',a/,'     ',a)
         return
      end if
 
C Define independent variable X
      retn = nf_def_var(file_id, 'X', NF_FLOAT, 1, dims, x_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9001) namx, NF_STRERROR(retn)
         return
      end if
      retn = nf_put_att_text(file_id,x_id,'units',10,xu)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9002) xu, NF_STRERROR(retn)
         return
      end if
      retn = nf_put_att_text(file_id,x_id,'long_name',20,xl)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9003) xl, NF_STRERROR(retn)
         return
      end if
C Enter Data Mode
      retn = nf_enddef(file_id)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9004) NF_STRERROR(retn)
 9004    format(' % UCDF1W: nf_enddef '/,'     ',a)
         return
      end if
 
C Write data array
      retn = nf_put_var_real(file_id, f_id, f)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9006) namf, NF_STRERROR(retn)
 9006 format(' % UCDF1W: nf_put_var_real ',a/,'     ',a)
      return
      end if
C
C Write X
      retn = nf_put_var_real(file_id, x_id, x)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9006) namx, NF_STRERROR(retn)
         return
      end if
      return
      end
 
 
 

      subroutine ubufo(lun,obuf,nbuf,out,nout)
C
      implicit NONE
C
#include "fpreproc/byte_declare.h"
C
C  output binary byte stream, with buffering.
C
      integer bufsiz
      parameter (bufsiz=512)  ! see also ubufi, below
C
C  all parameters are input:
C
      integer lun       ! unit of open chanel for i/o
      integer nbuf      ! portion of buffer currently in use
C
      byte_declare obuf(bufsiz) ! output buffer
      byte_declare out(*)       ! output stream segment (any size)
      byte_declare eod
C
      integer nout      ! size of segment to write (> 512 OK).
C                       ! if 0, flush buffer (EOF only)
C
      integer ii,ier,ifree,io,ip,ipl
C
C  contents of obuf and nbuf will be modified by this call.
C
#if __CRAY || __SX
      integer init/0/
      integer hex1/z'81'/
C------------------------------------
      if (init .eq. 0) then
	init = 1
	eod = char(hex1)
      endif
#else
      data eod/-1/
#endif
C
C------------------------------------
C
      if(nout.eq.0) then
C  buffer flush (just before closing file)
         if(nbuf.gt.-1) then
            do ii=nbuf+1,bufsiz
               obuf(ii)=eod
            enddo
         endif
         call cftwrite(lun,obuf,ier)
         nbuf=-1
         go to 1000
      endif
C
C  there is data in out array
C
C  assume there is free space in the buffer also (a full buffer would
C  already have been written).
C
      ifree=bufsiz-nbuf
C
      if(ifree.gt.nout) then
C  add to buffer (no write needed yet)
         do ii=nbuf+1,nbuf+nout
            obuf(ii)=out(ii-nbuf)
         enddo
         nbuf=nbuf+nout
         go to 1000
      else
C  fill and write first bufferfull
         do ii=nbuf+1,bufsiz
            obuf(ii)=out(ii-nbuf)
         enddo
         call cftwrite(lun,obuf,ier)
         nbuf=0
C
C  write subsequent bufferfulls
         do io=ifree+1,nout,bufsiz
            ip=io+bufsiz-1
            ipl=min(nout,ip)
            nbuf=ipl-io+1
            do ii=1,nbuf
               obuf(ii)=out(io+ii-1)
            enddo
C  write now if buffer is full (will loop through again)
            if(nbuf.eq.bufsiz) then
               call cftwrite(lun,obuf,ier)
               nbuf=0
            endif
         enddo
      endif
C
 1000 continue
      return
      end
C=====================================================================
      subroutine ubufi(lun,ibuf,nbuf,in,nin)
C
C  input binary byte stream, with buffering.
C
      implicit NONE
C
      integer bufsiz
      parameter (bufsiz=512)  ! see also ubufo, above
C
C  all parameters are input except "in(*)" which is read in or
C  filled from the buffer on this call.
C
      integer lun       ! unit of open chanel for i/o
      integer nbuf      ! ptr to first unread byte in ibuf.
C
      byte_declare ibuf(bufsiz) ! input buffer
      byte_declare in(*)        ! output stream segment (any size)
C
      integer nin       ! size of segment to read (> 512 OK).
C
C  contents of ibuf and nbuf will be changed by this call.
C
      integer iavail,ii,io,ileft,jleft,ioff,ier
C----------------------------------------
C
      if(nin.eq.0) then
         write(6,9901)
 9901    format(' %ubufi -- nin=0, programming error.')
         go to 1000
      endif
C
      if(nbuf.eq.0) then
         call cftread(lun,ibuf,ier)
         nbuf=1
      endif
C
      iavail=bufsiz-nbuf+1
      if(iavail.gt.nin) then
C
C  desired input already in buffer, just copy it; something still
C  left in buffer.
C
         do ii=1,nin
            in(ii)=ibuf(nbuf+ii-1)
         enddo
         nbuf=nbuf+nin
         go to 1000
C
      else
C
C  copy buffer and do additional reads as needed
C
         do ii=1,iavail
            in(ii)=ibuf(nbuf+ii-1)
         enddo
C
         call cftread(lun,ibuf,ier)
         nbuf=1
C
C  loop over additional buffer fulls.
C
         ileft=nin-iavail
         jleft=ileft+bufsiz
         ioff=iavail-bufsiz
         do io=1,ileft,bufsiz
            ioff=ioff+bufsiz
            jleft=jleft-bufsiz
            if(jleft.lt.bufsiz) then
               do ii=1,jleft
                  in(ii+ioff)=ibuf(ii)
               enddo
               nbuf=jleft+1
               go to 1000
            else
               do ii=1,bufsiz
                  in(ii+ioff)=ibuf(ii)
               enddo
               call cftread(lun,ibuf,ier)
               nbuf=1
            endif
         enddo
C
      endif
 1000 continue
      return
      end

c file: sggrf.for	sglib source (vax)
c		advanced graphing routines except those in sgcom.for
c
c
c  may-79	scientific advanced graphing ii release 3.3
c		without calendar plotting [jane murphy]
c
c  sep-80	rewrite graph routines to support irrational scaling
c
c  mar-82	change aglint, loptim and setwin to correct scaling for
c		second scale. reduce number of digits in labels.
c
c  aug-83	correct ivclip call in bsyms from das copy [jam]
c
c  jun-84	modify remlab to put x axis remote exponent at right end
c		of axis label [jam]
c
c  feb-86	remove eform (e format) option from numset, replace fonly
c		(f format), iform (i format) with fortran write.
c		remove xtent stuff from bppcom common.
c		change x/ydmin/max adjustment if y data range is zero to
c		a percent of y if y is large. [met]
c
c  mar-86	make label placement a function of linhgt for 4096 screen
c		check binitt called in check [met]
c
c  nov-86	speed up teksym by replacing most symbols with line
c		drawings; make x smaller and recenter triangle/del.
c		replace cplot with Tom Gibneys fast plot version.
c		switch sgaxi common to arrays; replace loptim args with
c		 x/y index.
c		replace ibasec calls with integer constant ibase;
c		replace comget calls with comget common. [met]
c
c  mar-87	restore bar/filbox routines to draw bar charts.
c		shrink width/grid by using common x/y code. [met]
c
c  oct-87	fix aglogt for irrational (raw data) endpoints.
c		shrink label to use common x/y code.
c		call linclr from grid/cplot/teksym using new variables
c		 in ibasec common (ccurv,cgrid,ctext,cfill).
c		add marker line (line style -5) to cplot.
c		use fast cplot algorithm for point lines; use same code
c		 for non-std and long std line type.
c		add agdspl - draw grid and axes but no lines.
c		make all tests for infinity use abs(value).
c		replace roundd/roundu from new plot10 code. [met]
c
c  jun-88	change symout to call agths instead of toutpt to get color.
c		adjust for 4096 resolution in bar.
c		call agtxclr in grid to get right color if no initt (only
c		 binitt (may not have fixed problem). [met]
c
c  sep-89	dont set neg values to finfin in cplot; let wincot clip
c		 them. [met]
c
c  jan-90	convert to lower case.
c		dont call term in binitt to set resolution; done by initt.
c		move lwidth into width; fform/iform into numset.
c		close X symbol so filled symbol looks like bowtie.
c		change aglogt to use dmax when user dmax>0, dmin<=0.
c		ignore zeros when finding min/max of log data. [met]
c
c  aug-90	fix bug where no tick labels if data constant < -10.
c		fix bug where top tick of log axis usually missing.
c		move tset into grid; simplify label.
c		do "fast" data access in cplot for short form data. [met]
c
c  oct-90	allow non-standard Y with short form X in mnmx/rgchek/cplot.
c		create solid symbols in teksym using panel fill in 4105 mode
c		 and repeatedly smaller symbols in 4014 mode.
c		add symbol types 12-15; use nint in teksym.
c		add Doug McCunes size adjustment factors for each symbol.
c		allow arbitrary start point for symbols.
c		add agkeys; "fast" data access in cplot for all data.
c		more cleanup in grid and label.
c		error in cplot if more than 1 X base. [met]
c
c  apr-91	move notate into juster; remove notate.
c		convert numset and juster to character variables.
c		rewrite roundd/roundu to fix problem with gran=.1.
c		remove umnmx. [met]
c
c  nov-91	check for dmax/dspan>1.e5 to avoid loop in roundd/u.
c
c  feb-92	add agmnmx with new args; restore mnmx to original.
c		misc fixes from MAC version.
c		output message and return if invalid data type in cplot.
c		remove keyset,datget,uline,upoint. [met]
c
c  feb-93	change texp calculation in aglint to avoid 1.**(-2)=
c		1.0000001e-2, which makes roundd inaccurate.  [met]
c
c  oct-93	fix rmin/rmax in aglint after round; texp calc yields
c		1.**(-2)=1.0000001e-2 and 1./10.**2=9.9999998E-03.
c		convert ibyte to word in juster.  [met]
c
c  aug-97	use x/ywdth value as mininum value of tick remote exponent
c		as well as minimum tick label width; remove users.  [met]
c
c  nov-2002     dmc: added comments to aglint and aglogt; took log10(dmin)
c               and log10(dmax) out of aglogt call
c%
c----------------------------------------------------------------/binitt
c * set initial values in ag common
c
	subroutine binitt
        implicit none
c
	include 'sgcopr_inc'
c
        real cline,csymbl,csteps,
     > cinfin,cnpts,cstepl,cfrsts,csizes,csizel,cnbasx,
     > ccurv,cgrid,ctext,cfill,cnptx,cunused,

     > cxneat,cxzero,cxloc,cxlab,cxden,cxtics,
     > cxlen,cxfrm,cxmtcs,cxmfrm,cxdec,
     > cxdmin,cxdmax,cxsmin,cxsmax,cxtype,
     > cxtrex,cxwdth,cxepon,cxstep,cxstag,cxetyp,
     > cxstrt,cxend,cxmstt,cxmend,cxamin,cxamax,cxlabn,

     > cyneat,cyzero,cyloc,cylab,cyden,cytics,
     > cylen,cyfrm,cymtcs,cymfrm,cydec,
     > cydmin,cydmax,cysmin,cysmax,cytype,
     > cytrex,cywdth,cyepon,cystep,cystag,cyband,
     > cystrt,cyend,cymstt,cymend,cyamin,cyamax,cylabn,
     > unused

	common /bppcom/ cline,csymbl,csteps,
     > cinfin,cnpts,cstepl,cfrsts,csizes,csizel,cnbasx,
     > ccurv,cgrid,ctext,cfill,cnptx,cunused,

     > cxneat,cxzero,cxloc,cxlab,cxden,cxtics,
     > cxlen,cxfrm,cxmtcs,cxmfrm,cxdec,
     > cxdmin,cxdmax,cxsmin,cxsmax,cxtype,
     > cxtrex,cxwdth,cxepon,cxstep,cxstag,cxetyp,
     > cxstrt,cxend,cxmstt,cxmend,cxamin,cxamax,cxlabn,

     > cyneat,cyzero,cyloc,cylab,cyden,cytics,
     > cylen,cyfrm,cymtcs,cymfrm,cydec,
     > cydmin,cydmax,cysmin,cysmax,cytype,
     > cytrex,cywdth,cyepon,cystep,cystag,cyband,
     > cystrt,cyend,cymstt,cymend,cyamin,cyamax,cylabn,

     > unused(6)

        integer i4105,kfac,ic,is
        integer iv, nbase
        integer linhgt         !Function
c *
c * ibasec+0 cline	type of line used in plots
c * ibasec+1 csymbl	symbol used for point plots
c * ibasec+2 csteps	increment between symbols
c * ibasec+3 cinfin	infinity
c * ibasec+4 cnpts	# of y points for non standard arrays
c * ibasec+5 cstepl	increment between points in lines
c * ibasec+6 cfrsts	first point to put a symbol
c * ibasec+7 csizes	symbol size
c * ibasec+8 csizel	line size (bars only)
c * ibasec+9 cnbasx	# of multiple x bases
c * ibasec+10 ccurv	color of all curves
c * ibasec+11 cgrid	color of axes/ticks
c * ibasec+12 ctext	color of text
c * ibasec+13 cfill	color of filled panels
c * ibasec+14 cnptx	# of x points for non-standard arrays
c * ---ibase = common vector pointer
c * nbase+0    c(x/y)neat  neat tick flag
c * nbase+1    c(x/y)zero  zero suppresion flag
c * nbase+2    c(x/y)loc   location of tick marks
c * nbase+3    c(x/y)lab   type of labels
c * nbase+4    c(x/y)den   density of ticks - not used
c * nbase+5    c(x/y)tics  actual number of ticks
c * nbase+6    c(x/y)len   length of tick marks
c * nbase+7    c(x/y)frm   form of tick marks
c * nbase+8    c(x/y)mtcs  number of minor ticks
c * nbase+9    c(x/y)mfrm  form of minor ticks
c * nbase+10   c(x/y)dec   number of decimal places
c * nbase+11   c(x/y)dmin  data minimum
c * nbase+12   c(x/y)dmax  data maximum
c * nbase+13   c(x/y)smin  screen minimum
c * nbase+14   c(x/y)smax  screen maximum
c * nbase+15   c(x/y)type  type of data (lin/log)
c * nbase+16   c(x/y)lsig  least significant digit - not used
c * nbase+16   c(x/y)twid  user set tick label width - not used
c * nbase+16   c(x/y)trex  minimum tick remote exponent
c * nbase+17   c(x/y)wdth  tick label width
c * nbase+18   c(x/y)epon  exponent
c * nbase+19   c(x/y)step  number of label steps
c * nbase+20   c(x/y)stag  staggered tick labels - not used
c * nbase+21   c(x/y)etyp  exponent type format - not used
c * nbase+21   c(  y)band  allowable jitter in y data for fast cplot
c * nbase+22   c(x/y)strt  start location for tick marks - not used
c * nbase+23   c(x/y)end   ending location for tick marks - not used
c * nbase+24   c(x/y)mstt  start location for minor tick marks - not used
c * nbase+25   c(x/y)mend  ending location for minor tick marks - not used
c * nbase+26   c(x/y)amin  calculated data minimum
c * nbase+27   c(x/y)amax  calculated data maximum
c * nbase+28   c(x/y)labn  label end major ticks only
c * ---nbase = x or y parm vector pointer

	call agseet(i4105,kfac,ic,is)	!get screen factor
c
	cline=0.
	csymbl=0.
	csteps=1.
	cinfin=1.e36		!oct92, oct87=1.e32, orig=1.e38
	cnpts=0.
	cnptx=0.
	cnbasx=0.
	cstepl=1.
	csizes=1.
	csizel=1.
	cfrsts=0.
	ccurv=1.
	cgrid=1.
	ctext=1.
	cfill=-1.
c
	iv=linhgt(1)
	cxneat=2.
	cxzero=1.
	cxloc=0.
	cxlab=1.
	cxlabn=0.
	cxtics=0.
	cxlen=iv
	cxfrm=5.
	cxmtcs=0.
	cxmfrm=2.
	cxdec=0.
	cxdmin=0.
	cxdmax=0.
	cxsmin=150*kfac
	cxsmax=900*kfac
	cxtype=1.
	cxtrex=0.
	cxwdth=0.
	cxepon=0.
	cxstep=1.
	cxstrt=0.
	cxend=0.
	cxmstt=0.
	cxmend=0.
	cxamin=0.
	cxamax=0.
c
	cyneat=2.
	cyzero=1.
	cyloc=0.
	cylab=1.
	cylabn=0.
	cytics=0.
	cylen=iv
	cyfrm=5.
	cymtcs=0.
	cymfrm=2.
	cydec=0.
	cydmin=0.
	cydmax=0.
	cysmin=125*kfac
	cysmax=700*kfac
	cytype=1.
	cytrex=0.
	cyband=0.
	cyepon=0.
	cystep=1.
	cywdth=0.
	cystrt=0.
	cyend=0.
	cymstt=0.
	cymend=0.
	cyamin=0.
	cyamax=0.
	call setclp(0)		!set clipping on
	return
	end
c%
c----------------------------------------------------------------/check
c * set flags for grid and label routines
c
	subroutine check(x,y)
        implicit none
	real x(*), y(*)

	integer k1,k2,nmod,ibeg
	real    gran,dtic
	common /sgaxi/ k1(2),k2(2),nmod(2),gran(2),ibeg(2),dtic(2)
        integer nbasex, nbasey, itype  
        integer ibasex, ibasey  ! functions
c
	nbasex=ibasex(0)
	nbasey=ibasey(0)
c
c set data limits
	call rgchek(nbasex,x)
	call rgchek(nbasey,y)
c
c determine parameters for ticks and tick labels
	call loptim(nbasex,1)
	call loptim(nbasey,2)
c
c set the virtual to screen window
	call setwin
c
	return
	end
c%
c----------------------------------------------------------------/dsplay
c * draw axes, ticks, and tick labels; call cplot to draw data curve
c
	subroutine dsplay(x,y)
        implicit none
	real x(*), y(*)
        real comget
	common /bppcom/ comget(80)
        integer ibasex, ibasey  ! functions

c * draw axes and ticks
	call grid
c * label the axes if label type > 0
	call label(ibasex(0))
	call label(ibasey(0))
c * draw curve
	call cplot(x,y)
c
	return
	end
c----------------------------------------------------------------/agdspl
c * draw axes, ticks, and tick labels
c
	subroutine agdspl(x,y)
        implicit none
	real x(*), y(*)
        real comget
	common /bppcom/ comget(80)
        integer ibasex, ibasey  ! functions
c
c * draw axes
	call grid
c * label the axes
	call label(ibasex(0))
	call label(ibasey(0))
c
	return
	end
c%
c----------------------------------------------------------------/rgchek
c * determine the minimum and maximum for the data array
c
	subroutine rgchek(nbase,array)
        implicit none
        integer  nbase
	real array(*)
        real comget
	common /bppcom/ comget(80)
	integer ibasec
	parameter (ibasec=1)
        integer nxbase, npts, itype
        real    finfin, amin,amax, dmin, dmax
        integer ibasex

c * is this an incremental x array for non-standard short x
	nxbase=comget(ibasec+9)
	finfin=comget(ibasec+3)
	amin=comget(nbase+11)
	amax=comget(nbase+12)
c * linear or logarithmic
	itype=comget(nbase+15)
cc	select code itype(1,2)
	if(itype.eq.1) then
c * linear check
	  if(amin.ne.amax) go to 400
	  dmin=finfin
	  if(comget(nbase+1).ne.1.) dmin=0.	!zero include
	  dmax=-dmin
c * find the min + max of the array
	  if(nxbase.gt.0 .and. nbase.eq.ibasex(0)) then
	    call agbmnx(array,dmin,dmax,nxbase)
	  else
	    if(nbase.eq.ibasex(0)) then
	    npts=comget(ibasec+14)
	    else
	    npts=comget(ibasec+4)
	    endif
	    call agmnmx(array,dmin,dmax,npts,itype)
	  endif
c * if min = max, expand data range to prevent one dimensional graph
	  if(dmin.eq.dmax) then
	  if(dmin.gt.10.) then	!(abs(dmin).gt.10.
	    dmin=dmin*0.95	!*(1.-sign(.05,dmin))
	    dmax=dmax*1.05
	  elseif(dmin.lt.-10.) then
	    dmin=dmin*1.05
	    dmax=dmax*0.95
	  else
	    dmin=dmin-.5
	    dmax=dmax+.5
	  endif
	  endif
	else
c * logarithmic check
	  if(amin.gt.0. .and. amax.gt.0.) then
	    if(amin.ne.amax) go to 400
c * min and max both > 0, but =; so, expand range.
	    dmax=amax
	    dmin=dmax/10.
	  else
c * search array for min and max
	    dmin=finfin
	    dmax=-finfin
	    if(nxbase.gt.0 .and. nbase.eq.ibasex(0)) then
	      call agbmnx(array,dmin,dmax,nxbase)
	    else
	      if(nbase.eq.ibasex(0)) then
	      npts=comget(ibasec+14)
	      else
	      npts=comget(ibasec+4)
	      endif
	      call agmnmx(array,dmin,dmax,npts,itype)
	    endif
c * check that both min and max are > 0.
	    if(dmax.le.0.) dmax=10.
	    if(dmin.le.0.) dmin=dmax/10.
	  endif
	endif
c * set data range in common
	call comset(nbase+11,dmin)
	call comset(nbase+12,dmax)
c
400	return
	end
c%
c----------------------------------------------------------------/loptim
c * determine endpoints and # of ticks for each axis
c
	subroutine loptim(nbase,n)
        implicit none
        integer nbase, n
        real comget
	common /bppcom/ comget(80)
        real     gran,dtic
	integer k1,k2,nmod,ibeg
	common /sgaxi/ k1(2),k2(2),nmod(2),gran(2),ibeg(2),dtic(2)
        integer  i4105,kfac,ic,is, ismin, ismax,itype,  iround, nmjtic
        real    dmin, dmax, dslen, slngth, tvsm, tvsb, abeg, aend
        integer nmntic,isbeg, isend, i
        real    roundu,roundd     !Functions 
c
c axis tick selection
	dmin=comget(nbase+11)		!data limits
	dmax=comget(nbase+12)
	ismin=comget(nbase+13)		!screen limits
	ismax=comget(nbase+14)
	itype=comget(nbase+15)		!axis type
	iround=nint(comget(nbase+0))	!tick rounding option
	call agseet(i4105,kfac,ic,is)
	dslen=ismax-ismin
	nmjtic=comget(nbase+5)
	if(nmjtic.gt.0) then
c
c user tick selection
	  nmntic=comget(nbase+8)
	  nmntic=max(nmntic,1)
	  if(itype.eq.2) then
	    dmin=log10(dmin)
	    dmax=log10(dmax)
	  endif
	  gran(n)=(dmax-dmin)/nmjtic/nmntic
	  nmod(n)=nmntic
	  k1(n)=dmin/gran(n) * 1.01
	  k2(n)=dmax/gran(n) * 1.01
	  iround=1
c
	elseif(itype.eq.1) then
c
c linear tick selection
	  slngth=abs(dslen)/kfac
	  call aglint(dmin,dmax,slngth,iround,gran(n),nmod(n),
     >		k1(n),k2(n))
	else
c
c logarithmic tick selection
	  slngth=abs(dslen)/kfac
          dmin=log10(dmin)
          dmax=log10(dmax)
	  call aglogt(dmin,dmax,slngth,iround,gran(n),nmod(n),
     >		k1(n),k2(n))
	endif
c
 	call comset(nbase+26,dmin)	!data limits
	call comset(nbase+27,dmax)	! for labeling
c
c set screen position of first tick and tick spacing
	if(iround.gt.0) then		!extend to ticks
	  if(itype.eq.2 .and. nmjtic.eq.0) then
	    dtic(n)=dslen/(dmax-dmin)	!log
	  else
	    dtic(n)=dslen/(k2(n)-k1(n))	!linear
	  endif
	  ibeg(n)=ismin
	else				!extend to data
c
	  tvsm=dslen/(dmax-dmin)	!user to screen transformation
	  tvsb=float(ismin)-tvsm*dmin
	  abeg=roundu(dmin,gran(n))	!if irrational endpoints
	  aend=roundd(dmax,gran(n))	! find position of first tick
	  if(aend.eq.abeg) aend=abeg+1.
	  isbeg=abeg*tvsm+tvsb+0.5
	  isend=aend*tvsm+tvsb+0.5
  	  if(itype.eq.2) then	!log
	    dtic(n)=float(isend-isbeg)/(aend-abeg)
	  else			!linear
	    dtic(n)=float(isend-isbeg)/(k2(n)-k1(n))
	  endif
	  ibeg(n)=isbeg
	endif
c
	call width(nbase,n)	!?put here
	return
	end
c%
c----------------------------------------------------------------/aglint
c * select linear tick parameters
c
	subroutine aglint(dmin,dmax,slngth,iround,gran,nmod,k1,k2)
        implicit none
c
c arguments:
c
        real, intent(inout) :: dmin,dmax ! min & max of data
c               ...may be extended to match min/max tic marks
        real, intent(in) :: slngth      ! axis length in "rasters"
        integer, intent(in) :: iround   ! neatness control
c               ...iround=0 -- use data min & max, all tic marks inside
c                              this range
c               ...iround=1 -- axes limits at minor tic marks
c               ...iround=2 -- axes limits at major tic marks
c
        real, intent(out) :: gran       ! minor tic mark granularity
        integer, intent(out) :: nmod    ! #tic marks / major tic mark
        integer, intent(out) :: k1,k2   ! tics at k1*gran ... k2*gran
c
c  ticks will be drawn from 0.0 to 1.2 by 0.1 with major
c  ticks at 0.0, 0.5, 1.0.
c
	real spans(4), tgran(3,3)
	integer nmodt(3,3)
	character espan*16
        integer   i, nexp, nden, j
        real  dspan,fmant, texp, rmin, rmax 
        real  roundu,roundd     !Functions         
c
	data (spans(i),i=1,4)	 /10., 20., 50.,100./	!data span
	data (tgran(i,1),i=1,3)  / 1.,  1.,  2./	!tick granularity
	data (nmodt(i,1),i=1,3)  / 5,   5,   5/		!major tick modulus
	data (tgran(i,2),i=1,3)	 / 2.,  2.,  5./
	data (nmodt(i,2),i=1,3)	 / 5,   5,   2/
	data (tgran(i,3),i=1,3)	 / 5.,  5., 10./
	data (nmodt(i,3),i=1,3)	 / 2,   2,   5/
c
c compute data span
	dspan=dmax-dmin
	if(dspan.eq.0 .or. abs(dmax).gt.abs(1.e5*dspan)) then
	  if(abs(dmin).gt.10.) then
	    dmin=dmin*0.95
	    dmax=dmax*1.05
	  else
	    dmin=dmin-.5
	    dmax=dmax+.5
	  endif
	  dspan=dmax-dmin
	endif
	write(espan,100) dspan
  100	format(2pe12.4)
	read(espan,101) fmant,nexp
  101	format(1x,f7.4,1x,i3)
c
c given span select tick option column
	j=1
	do while (fmant.ge.spans(j+1) .and. j.lt.3)
	  j=j+1
	enddo
c
c find suitable number of ticks based on screen length
	texp=10.**nexp
	!texp=1./10.**(-nexp)	!is also inaccurate for nexp=-2
	do nden=1,3
	  gran=tgran(j,nden)*texp	!tick granularity
	  nmod=nmodt(j,nden)
c
	  if(iround.eq.0) then		!0=raw data
	    rmin=roundu(dmin,gran)		!round in to minor ticks
	    rmax=roundd(dmax,gran)		! for irrational axes	
	  elseif(iround.eq.1) then	!1=minor ticks
	    rmin=roundd(dmin,gran)		!round out to
	    rmax=roundu(dmax,gran)		! minor ticks
	  else				!3=major
	    rmin=roundd(dmin,gran*nmod)		!round out to
	    rmax=roundu(dmax,gran*nmod)		! major ticks
	  endif
	  if(iround.gt.0) then
	    rmin=min(rmin,dmin)		!ensure end points are included
	    rmax=max(rmax,dmax)
	  endif
c
	  k1=rmin/gran+sign(0.1,rmin)	!set tick counts s.t. k*gran
	  k2=rmax/gran+sign(0.1,rmax)	! equals tick value
c
	  if(slngth/(k2-k1).gt.20) go to 500
	enddo
c
  500	if(iround.gt.0) then
	  dmin=rmin
	  dmax=rmax
	endif
	return
	end
c%
c----------------------------------------------------------------/aglogt
c * select log tick parameters
c
	subroutine aglogt(dmin,dmax,slngth,iround,gran,nmod,k1,k2)
        implicit none
c
c  nmod=2, 4, or 5	minor and major at decade intervals
c  nmod=3		minor at 2 and 5, major at decades
c  nmod=9		minor at 2 to 9, major at decades
c arguments:
c
        real, intent(inout) :: dmin,dmax ! min & max of log10(data)
c               ...may be extended to match min/max tic marks
        real, intent(in) :: slngth      ! axis length in "rasters"
        integer, intent(in) :: iround   ! neatness control
c               ...iround=0 -- use data min & max, all tic marks inside
c                              this range -- but show a decade.
c               ...iround=1 or 2 -- axes limits at decades.
c
        real, intent(out) :: gran       ! minor tic mark granularity, log(data)
        integer, intent(out) :: nmod    ! #tic marks / major tic mark
        integer, intent(out) :: k1,k2   ! tics at k1*gran ... k2*gran
c
c          actual data values at 10**(k1*gran) to 10**(k2*gran)
c
        real    amin, amax, rmin, rmax, tmin, tmax, beg, end
        integer itint, ntic
        real roundu,roundd     !Functions 

	real tablog(9)
	data tablog /	0.,
     >		0.30103, 0.47712, 0.60206, 0.69897,
     >		0.77815, 0.84510, 0.90309, 0.95424/
c
        amin=dmin
        amax=dmax
	if(iround.eq.0) then		!0=raw data
	  rmin=roundu(amin,1.)		!round in for
	  rmax=roundd(amax,1.)		! irrational endpoints
c
c				(sign(1.,amin).eq.sign(1.,amax))
	  if((int(amin).eq.int(amax)) .and. (amin*amax.gt.0.)) then
	    tmin=roundd(amin,1.)	!must cross a decade
	    tmax=roundu(amax,1.)
	    if(abs(amin-tmin).le.abs(amax-tmax)) then
	      rmin=tmin			!move one end to decade
	      amin=tmin
	    else
	      rmax=tmax
	      amax=tmax
	    endif
	  endif
	  beg=abs(amin-roundd(amin,1.))
c
	else				!1=minor ticks, 2=major
cx	  amin=amin	!+0.000001
cx	  amax=amax	!-0.000001
	  rmin=roundd(amin,1.)		!round out to decades
	  rmax=roundu(amax,1.)
	  amin=rmin
	  amax=rmax
	  beg=0.
	endif
	gran=1.				!tick granularity
	itint=slngth/(amax-amin)	! screen interval of one decade
c
	if(itint.lt.60) then
	  k1=rmin			!minors will
	  k2=rmax			! be at decades
	  nmod=2			!tick modulus
	  if(itint.lt.30) nmod=4
	  if(itint.lt.15) nmod=5
c
	elseif(itint.lt.120) then	!1,2,5 ticks
	  k1=0
	  if(beg.gt.0) then		!.gt.tablog(1)
	  if(beg.le.tablog(5)) k1=2	!k1 = first tick
	  if(beg.le.tablog(2)) k1=1
	  endif
	  k2=int(rmax-rmin)*3		!3 ticks per decade
	  if(k1.ne.0) k2=k2+3-k1
	  end=amax-rmax
	  if(end.ge.tablog(2)) k2=k2+1
	  if(end.ge.tablog(5)) k2=k2+1
	  k2=k1+k2			!k2 = last tick
	  nmod=3
c
	else				!1 to 9 ticks
	  k1=0
	  do while(k1.lt.9 .and. beg.gt.tablog(k1+1))
	    k1=k1+1			!first minor tick
	  enddo
	  ntic=int(rmax-rmin)*9		!9 ticks per decade
	  if(k1.ne.0) ntic=ntic+9-k1
	  end=amax-rmax
	  k2=0
	  do while(k2.lt.8 .and. end.ge.tablog(k2+2))
	    k2=k2+1			!minors past last decade
	  enddo
	  k2=ntic+k2+k1			!last (minor) tick
	  nmod=9
	endif
c
	dmin=amin
	dmax=amax
c
	return
	end
c%
c----------------------------------------------------------------/width
c * set label width and remote exponent
c
	subroutine width(nbase,n)
        implicit none
        integer nbase,n
        real comget
	common /bppcom/ comget(80)
        integer k1,k2,nmod,ibeg
        real    gran, dtic
	common /sgaxi/ k1(2),k2(2),nmod(2),gran(2),ibeg(2),dtic(2)
	character lit*16
	logical logm
        integer labend, itype, igexp, lsig, ndec, iwid, irexp
        integer iexp, mrexp, mwidth, is, ic, kfac, i4105, istep
        real dmin, dmax, granu, rmaj1, rmaj2, ticint, rmax, chspce

        real roundu, roundd     ! Functions
c
	labend=comget(nbase+3)		!which ticks to label
	dmin=comget(nbase+26)
	dmax=comget(nbase+27)
	logm=nmod(n).eq.3 .or. nmod(n).eq.9
	if(.not.logm) then
	  rmaj1=roundu(dmin,gran(n)*nmod(n))	!insure at least
	  rmaj2=roundd(dmax,gran(n)*nmod(n))	! 2 labels
	  if(abs((rmaj1-rmaj2)/gran(n)).lt.1e-3) labend=2	!end only
	endif
	call comset(nbase+28,float(labend))	!work flag vs user request
c
	if(labend.eq.2 .or. logm) then
	  ticint=1000.			!label end ticks only
	  granu=gran(n)			! may be minor
	  if(mod(k1(n),nmod(n)).eq.0 .and. mod(k2(n),nmod(n)).eq.0)
     >		granu=gran(n)*nmod(n)
	else
	  ticint=dtic(n)*nmod(n)	!label major ticks
	  granu=gran(n)*nmod(n)
	endif
c
101	format(1pe12.5)
102	format(9x,i3)
c * calc label width
	rmax=max(abs(dmin),abs(dmax))	!order of larger magnitude
	itype=comget(nbase+15)
	if(itype.eq.1) then	!linear
	  write(lit,101) granu
	  read(lit,102) igexp		!exponent of granularity
	  lsig=4			!least significant digit
	  do while (lsig.gt.0 .and. lit(lsig+3:lsig+3).eq.'0')
	    lsig=lsig-1			!check digits 4,7
	  enddo
	  ndec=max(0,lsig-igexp)	!number of decimal places
	  iwid=ndec+1
	  if(ndec.gt.0) iwid=iwid+1	!allow for point
	  !?irexp=log10(abs(rmax)+.00005)
	  write(lit,101) rmax		!exponent of larger limit
	  read(lit,102) irexp		!number of leading digits
	  if(irexp.ge.0) iwid=iwid+irexp
	  if(dmin.lt.0.) iwid=iwid+1	!allow for sign
	  iexp=0
	  mrexp=comget(nbase+16)
	  if(iwid.gt.max(5,mrexp)) then
	    iexp=irexp			!remote exponent
	    ndec=irexp-igexp+lsig
	    iwid=ndec+1
	    if(ndec.gt.0) iwid=iwid+1	!point
	    if(dmin.lt.0.) iwid=iwid+1	!sign
	  endif
	  mwidth=comget(nbase+16)
	  if (mwidth.ge.5) mwidth=0	!param also width for remote exp
	  if(mwidth.ne.0) then		!user specified width
	    ndec=mwidth-(iwid-ndec)	!decimal places to fill label
	    ndec=max(ndec,0)
	    iwid=mwidth
	  endif
c
	else			!log (itype.eq.2)
 	  iexp=0
	  ndec=0
	  iwid=2			!10
 	  if(rmax.ge.1.) iwid=3		!10 and 1 digit
 	  if(rmax.ge.10.) iwid=4	!10 and 2 digits
	  if(dmin.lt.0.) iwid=iwid+1
	endif
c set label width in common
 	call comset(nbase+17,float(iwid))
	call comset(nbase+10,float(ndec))
	call comset(nbase+18,float(iexp))
c set label spacing
	call agseet(i4105,kfac,ic,is)
	if(n.eq.1) then
	  chspce=iwid*kfac*14	!?ihorz
	else
	  chspce=34		!?ivert*?
	endif
c
	istep=1
	do while(chspce.ge.0.7*ticint*istep .and. istep.le.3)
	  istep=istep+1
	enddo
	call comset(nbase+19,float(istep))
c
	return
	end
c%
c----------------------------------------------------------------/agmnmx
c * determine minimum and maximum values in an array
c
	subroutine agmnmx(array,amin,amax,npta,itype)
        implicit none
        real amin, amax
        integer npta, itype
	real array(*)
        real comget
	common /bppcom/ comget(80)
	integer ibasec
	parameter (ibasec=1)
	logical logs
        real    xmax, finfin
        integer npts, nstart, i
c
	logs=itype.ge.2
	npts=npta
	go to 100
c
	entry mnmx(array,amin,amax)
c
	logs=.false.
	npts=comget(ibasec+4)
 100	continue
c * determine form of data array
	if(npts.gt.0) then	!non-standard long form
	  nstart=1
	else			!standard long/short form
	  npts=nint(array(1))+1
	  nstart=2
	  if(array(1).lt.0.) then
	      xmax=array(3)+(array(2)-1.)*array(4)
	      amin=min(array(3),xmax,amin)
	      amax=max(array(3),xmax,amax)
	    go to 600
	  endif
	endif
c * data value eq to machine infinity considered missing data
c * ignore values <=0 if log scale
	finfin=comget(ibasec+3)
	do i=nstart,npts
	  if(logs .and. array(i).le.0) go to 500	!(2/90)
	  if(abs(array(i)).lt.finfin) then
	    amin=min(array(i),amin)
	    amax=max(array(i),amax)
	  endif
 500	enddo
 600	return
	end
c%
c----------------------------------------------------------------/setwin
c * set the proper virtual space window transformation
c
	subroutine setwin
        implicit none
        real comget
	common /bppcom/ comget(80)
        integer nbase, ixmin, ixmax, itypex, iymin, iymax, itypey
        real dxmin, dxmax, dymin, dymax
        integer ibasex, ibasey    ! Functions

	nbase=ibasex(0)
	ixmin=comget(nbase+13)
	ixmax=comget(nbase+14)
	dxmin=comget(nbase+26)
	dxmax=comget(nbase+27)
	itypex=comget(nbase+15)
	if(itypex.eq.2) then
	  dxmin=10.**dxmin
	  dxmax=10.**dxmax
	endif
	nbase=ibasey(0)
	iymin=comget(nbase+13)
	iymax=comget(nbase+14)
	dymin=comget(nbase+26)
	dymax=comget(nbase+27)
	itypey=comget(nbase+15)
	if(itypey.eq.2) then
	  dymin=10.**dymin
	  dymax=10.**dymax
	endif
c * set linear or log transformation parameters in tcs common
	call aglnlg(itypex,itypey)
c * set the screen window
	call twindo(ixmin,ixmax,iymin,iymax)
	call dwindo(dxmin,dxmax,dymin,dymax)
	return
	end
c%
c----------------------------------------------------------------/grid
c * draw axis lines, tick marks and grid lines
c
	subroutine grid
        implicit none
        real comget
	common /bppcom/ comget(80)

	integer k1,k2,nmod,ibeg
	real    gran,dtic
	common /sgaxi/ k1(2),k2(2),nmod(2),gran(2),ibeg(2),dtic(2)
	integer ibasec
	parameter (ibasec=1)
        integer n, igrid, mbase, ipmin, ipmax, near, nfar, iaxpos
        integer ismin, iymin, iymax, itypey, nbase, lform, iother
        integer ismax, mjbeg, mjend, lmaj, mform, mnbeg, mnend,lmin
        integer ntics, k, i, ixy
        real    dymin, dymax, toff
	logical logm
	real tablog(9)
	data tablog /0, 0.30103, 0.47712, 0.60206, 0.69897,
     >	  0.77815, 0.84510, 0.90309, 0.95424/
        integer ibasey, ibasex          ! Function
c
	igrid=comget(ibasec+11)		!set line/text color - 10/87
	call linclr(igrid)
	call agtxclr(igrid)
	do n=1,2			!x,y
	  if(n.eq.1) nbase=ibasex(0)
	  if(n.eq.2) nbase=ibasey(0)
	  lform=comget(nbase+7)		!major axis form
	  if(lform.eq.0) go to 300	!no axis
c * get the min max of opposite axis
	  mbase=iother(nbase)
	  ipmin=comget(mbase+13)	!other axis screen min
	  ipmax=comget(mbase+14)
	  near=min(ipmin,ipmax)
	  nfar=max(ipmin,ipmax)
	  iaxpos=near+int(comget(nbase+2))	!axis position
c * draw axis lines
	  ismin=comget(nbase+13)	!screen limits
	  ismax=comget(nbase+14)
	  if(n.eq.1) then
	    call movabs(ismin,iaxpos)	!draw axis line
	    call drwabs(ismax,iaxpos)
	  else
	    call movabs(iaxpos,ismin)	!draw axis line
	    call drwabs(iaxpos,ismax)
	  endif
	  if(lform.eq.1) go to 300	!no ticks
c
	  mjbeg=0
	  mjend=0
	  lmaj=comget(nbase+6)		!length of major ticks
	  if(iaxpos.ge.(nfar+near)/2) then
	    lmaj=-lmaj
	    nfar=near
	  endif
c * find end points of tick marks
	  call tset2(iaxpos,nfar,lmaj,lform,mjbeg,mjend)
	  mform=comget(nbase+9)
	  mnbeg=0
	  mnend=0
	  if(mform.gt.1) then
	    lmin=lmaj/2
c * find end points of minor ticks
	    call tset2(iaxpos,nfar,lmin,mform,mnbeg,mnend)
	  endif
c * draw ticks
	  ntics=0
	  logm=nmod(n).eq.3 .or. nmod(n).eq.9
	  do k=k1(n),k2(n)
	    i=mod(k,nmod(n))
	    if(i.eq.0 .or. (.not.logm)) then
c * linear, or logarithmic at major ticks
	      ixy=ibeg(n)+ifix(ntics*dtic(n))
	      ntics=ntics+1
	    else
c * logarithmic at minor ticks
	      if(nmod(n).eq.9) then
		toff=tablog(i+1)
	      elseif(i.eq.1) then
		toff=tablog(2)
	      else
		toff=tablog(5)
	      endif
	      ixy=ibeg(n)+ifix((ntics-1+toff)*dtic(n))
	    endif
	    if(n.eq.1) then		!x axis
	      if(i.eq.0) then		!major tick
		call movabs(ixy,mjbeg)
		call drwabs(ixy,mjend)
	      elseif(mform.gt.1) then	!minor tick
		call movabs(ixy,mnbeg)
		call drwabs(ixy,mnend)
	      endif
	    else			!y axis
	      if(i.eq.0) then		!major tick
		call movabs(mjbeg,ixy)
		call drwabs(mjend,ixy)
	      elseif(mform.gt.1) then	!minor tick
		call movabs(mnbeg,ixy)
		call drwabs(mnend,ixy)
	      endif
	    endif
	  enddo
c
 300	enddo
	return
	end
c%
c----------------------------------------------------------------/tset2
c * utility routine for grid
c
	subroutine tset2(newloc,nfar,nlen,nfrm,kstart,kend)
        implicit none
        integer newloc,nfar,nlen,nfrm,kstart,kend

	kstart=newloc-nlen
	kend=newloc+nlen
	if(nfrm.eq.3 .or. nfrm.eq.6) kstart=newloc
	if(nfrm.eq.2) kend=newloc
	if(nfrm.eq.5 .or. nfrm.eq.6) kend = nfar
cx	call agseet(i4105,if,ic,maxs)
cx	kstart=max(0,min(maxs,kstart))
cx	kend=max(0,min(maxs,kend))
	return
	end
c%
c----------------------------------------------------------------/label
c * display tick mark labels
c
	subroutine label(nbase)
        implicit none
        integer nbase
        real comget
	common /bppcom/ comget(80)

	integer k1,k2,nmod,ibeg
	real gran,dtic
	common /sgaxi/ k1(2),k2(2),nmod(2),gran(2),ibeg(2),dtic(2)
	character clabl*12
	logical logm,putlab
	logical noout(0:6)	!no part of tick outside axis
	data noout /.true.,.true.,.false.,.true.,.false.,.false.,.true./
        integer n, mbase, near, nfar, iaxof, ilbpos, lform, lmaj
        integer itype, ih2, ihorz, ivert, iother, iaxoff, loff
        integer labend, lstep, nmjtic, ntics, iexp, iwidth, k, i
        integer nlab, ixy, len, ismax, irx, iry, idum
        real    dmin, fac, valab
        integer ibasex ! Function
        real    roundu
c
	if(nbase.eq.ibasex(0)) then
	  n=1
	else
	  n=2
	endif
	if(comget(nbase+3).eq.0.) return
	mbase=iother(nbase)
	near=comget(mbase+13)
	nfar=comget(mbase+14)
	iaxoff=comget(nbase+2)
	ilbpos=min(near,nfar)+iaxoff	!axis position
c
	lform=comget(nbase+7)		!major tick form
	lmaj=comget(nbase+6)		!major tick length
	if(noout(lform)) lmaj=7		!?*kfac
	if(ilbpos.lt.(nfar+near)/2) lmaj=-lmaj
	itype=comget(nbase+15)  	!linear/log
	call csize(ihorz,ivert)
	ih2=ihorz/2
	if(n.eq.1) then			!x axis
	  if(lmaj.lt.0) then
	    loff=-ivert*1.1		!x bottom (was 24)
	    if(itype.eq.2) loff=loff-4	!x bottom log
	  else
	    loff=ivert*.46		!x top (10)
	  endif
	else				!y axis
	  if(lmaj.lt.0) then
	    loff=-ih2			!y left (7, was 8)
	  else
	    loff=ih2			!y right (7, was 8)
	  endif
	endif
c * adjust label position by string size and tick length
	ilbpos=ilbpos+lmaj+loff
c
	logm=nmod(n).eq.3 .or. nmod(n).eq.9	!log with minor ticks
	labend=comget(nbase+28)		!label major or end ticks
	lstep=comget(nbase+19)		!label skip
	if(n.eq.2) lstep=1		!ignore for y axis
	if(logm) lstep=1
	nmjtic=comget(nbase+5)		!?user set ticks
	ntics=0
c
	dmin=comget(nbase+26)		!value of first tick
	if(logm) dmin=roundu(dmin,1.)
	iexp=comget(nbase+18)		!remote exponent
	fac=10.**(-iexp)
	iwidth=comget(nbase+17)		!label width
	nlab=0
	do k=k1(n),k2(n)
	  i=mod(k,nmod(n))
	  if(logm) valab=dmin+ntics
c
	  putlab=.false.
	  if(labend.eq.1) then		!label all major
	    putlab=i.eq.0 .and. mod(nlab,lstep).eq.0
	  elseif(labend.eq.2) then	!label ends only
	    if(logm) then
	      putlab=i.eq.0 .and. ((k-k1(n)).lt.nmod(n) .or.
     >		(k2(n)-k).lt.nmod(n))
	    else
	      putlab=k.eq.k1(n) .or. k.eq.k2(n)
	    endif
	  endif
c
	  if(putlab) then
	    ixy=ibeg(n)+ifix(ntics*dtic(n))
	    if(n.eq.2) ixy=ixy-ih2	!?ivert/3 (was 7)
	    if(.not.logm) then
	      if(nmjtic.ne.0) then
	        valab=(dmin+ntics*gran(n))*fac
	      else
	        valab=k*gran(n)*fac
	      endif
	    endif
	    len=iwidth
	    call numset(valab,nbase,clabl,len)
	    if(n.eq.1) then		!x axis
	      call movabs(ixy,ilbpos)
	      call juster(clabl,len,0)
	    else			!y axis
	      call movabs(ilbpos,ixy)
	      call juster(clabl,len,-lmaj)
	    endif
	  endif
	  if(i.eq.0 .or. .not.logm) ntics=ntics+1
	  if(i.eq.0) nlab=nlab+1
 110	enddo
c * put remote exponent
	if(iexp.ne.0) then
	  ismax=comget(nbase+14)
	  if(n.eq.2) then
	    irx=ilbpos
	    iry=ismax+ivert		!(22)
	  else
	    irx=ismax			!move to end of axis (apr84)
	    if(lmaj.lt.0) then
	      iry=ilbpos-ivert*1.8	!x bottom (40)
	    else
	      iry=ilbpos+ivert*1.5	!x top (30)
	    endif
	  endif
	  call remlab(nbase,iaxoff,idum,irx,iry)
	endif
c
	return
	end
c%
c----------------------------------------------------------------/cplot
c * plot a curve
c
	subroutine cplot(x,y)
        implicit none
        
	real x(*),y(*)
        real comget
	common /bppcom/ comget(80)
	real yy(4)		! array of y values to be plotted
	integer iyy(4)		! corresponding y-raster positions
	integer iydelt		! max variation in y raster position
	logical none
	integer ibasec
	parameter (ibasec=1)
        integer line, isym, isteps, istepl, icurv, nbasey, iopt
        integer limit, ifasty, ifastx, lines, iy, ix, ixa, ixd
        integer iydb4, iyd, iylo, iyhi, jnum, ixr, i, j, ibets, linsav
        real    finfin, smin, smax, yband, xfirs, xdelt, xpoint, ypoint
        real    xa, yd, ylo, yhi
        integer icclip, ibasey          ! function
c
c * get params from common
	line=comget(ibasec)		!line style
	isym=comget(ibasec+1)		!symbol type
	if (line.eq.-1 .and. isym.eq.0)  return		! nothing to do
	isteps=comget(ibasec+2)		!step between symbols
	istepl=comget(ibasec+5)		!step between points in line
cx	if(istepl.eq.0) then
cx	  stop 'STOP in sglib cplot: binitt not called'
cx	endif
	finfin=comget(ibasec+3)
cx	nxbase=comget(ibasec+9)
c * set the curve color for 4105
	icurv=comget(ibasec+10)
	call linclr(icurv)
c * get percent wiggle in y; convert to screen units
	nbasey=ibasey(0)
	yband=comget(nbasey+21)		!max variation in %
	smin=comget(nbasey+13)
	smax=comget(nbasey+14)
	iydelt=(smax-smin)*yband*.01
c * set fast plot line type
	if (icclip(0).eq.0) then
	  if (line.eq.0) then
	    iopt = 1			!solid line, clipped
	  else if (line.gt.0) then
	    iopt = 2			! dashed line, clipped
	  endif
	else
	  if (line.eq.0) then
	    iopt = 3			!solid line, not clipped
	  else if (line.gt.0) then
	    iopt = 4			! dashed line, not clipped
	  endif
	endif
c * set up fast data get
	call agkeys(x,y,ifastx,ifasty,limit)
	if(limit.eq.0) return
	if(ifastx.eq.0 .or. ifasty.eq.0) then
C	  type *, 'CPLOT: invalid data form'
	  call at_msg('CPLOT: invalid data form')
	  return
	endif
	if(ifastx.eq.-1) then
	  xfirs=x(3)
	  xdelt=x(4)
	else	!if(ifastx.eq.-2) then
	  xfirs=x(2)
	  xdelt=x(3)
	endif
	lines=1				!solid
	if(line.gt.0)  lines=3		!dashed
	if(line.eq.-1) lines=2		!symbols only
	if(line.eq.-2 .or. line.eq.-3) then
	  lines=5			!bar
	  isym=0			!comget used for shade code
	endif
	if(line.eq.-4) lines=4	!points
	if(line.eq.-5) then
	  lines=4			!marker
	  call agmark(isym)		!set marker type
	  isym=0
	  if(isteps.gt.0) istepl=istepl*isteps	!put point only at symbols
	  isteps=0
	endif
	if(line.lt.-10) lines=6		!user drawn
c * a regular symbol is plotted unless no symbol or bar chart specified
	i=1
	none=.true.
c * get first non-infinite point
	do while (i.le.limit .and. none)
	  if(ifastx.gt.0) then
	    xpoint=x(ifastx)
	    ifastx=ifastx+istepl
cx	  elseif(ifastx.eq.0) then
cx	    xpoint=agbdgt(x,nxbase,i)
	  else	!if(ifastx.lt.0) then
	    xpoint=xfirs+xdelt*float(i-1)
	  endif
	  if(ifasty.gt.0) then
	    ypoint=y(ifasty)
	    ifasty=ifasty+istepl
cx	  elseif(ifasty.eq.0) then
cx	    call uline
	  else	!if(ifasty.lt.0) then
	    ypoint=y(3)+y(4)*float(i-1)
	  endif
	  i=i+istepl
	  if(abs(xpoint).lt.finfin .and. abs(ypoint).lt.finfin)
     >	    none=.false.
	enddo
c * move to first data location
	call movea(xpoint,ypoint)
c * test if can condense y values that have same x screen coordinate
	if(line.lt.0 .or. isym.ne.0) go to 400
	call wincot(xpoint,ypoint,ix,iy)
	ixa = ix		!initialize raster parameters
	ixd = 0			!x direction
	iydb4 = iy		!end of previous raster
	iyy(1) = iy		!start of raster
	iyd = iy		!last y for this raster
	iylo = iy		!low y at this x
	iyhi = iy		!high y at this x
	xa = xpoint
	yy(1) = ypoint
	yd = ypoint
	ylo = ypoint
	yhi = ypoint

	do while(i.le.limit)
	  if(ifastx.gt.0) then
	    xpoint=x(ifastx)
	    ifastx=ifastx+istepl
cx	  elseif(ifastx.eq.0) then
cx	    xpoint=agbdgt(x,nxbase,i)
	  else	!if(ifastx.lt.0) then
	    xpoint=xfirs+xdelt*float(i-1)
	  endif
	  if(ifasty.gt.0) then
	    ypoint=y(ifasty)
	    ifasty=ifasty+istepl
cx	  elseif(ifasty.eq.0) then
cx	    call uline
	  else	!if(ifasty.lt.0) then
	    ypoint=y(3)+y(4)*float(i-1)
	  endif
	  i=i+istepl
	  if (abs(xpoint).ge.finfin .or. abs(ypoint).ge.finfin) goto 380
	  call wincot(xpoint,ypoint,ix,iy)
c				!if new x value, examine iy rasters
	  if(ix.ne.ixa) then
	    jnum = 1		! number of points to plot
	    ixr = (ix-ixa)*ixd	!see if x values change direction
	    ixd = sign(1,ix-ixa)
	    if (iyhi-iylo.gt.iydelt) then
	      if (iyy(1).gt.iyd) then	!end lower than start
		if(iyhi.ne.iyy(1)) then
		jnum = jnum+1	!go high first
		iyy(jnum) = iyhi
		yy(jnum) = yhi
		endif
		jnum = jnum+1	!then low
		iyy(jnum) = iylo
		yy(jnum) = ylo
	      else			!end higher than start
		if(iylo.ne.iyy(1)) then
		jnum = jnum+1	!go low first
		iyy(jnum) = iylo
		yy(jnum) = ylo
		endif
		jnum = jnum+1	!then high
		iyy(jnum) = iyhi
		yy(jnum) = yhi
	      endif
	      if (iyd.ne.iyy(jnum)) then
		jnum = jnum+1
		yy(jnum) = yd
		iyy(jnum) = iyd
	      endif
	    endif

c see if need to plot
	    if (jnum.gt.1 .or. iy.ne.iydb4 .or. iyy(1).ne.iydb4 .or.
     >		ixr.lt.0) then
	      do j=1,jnum
	        go to (341,342,343,344),iopt
341		call drawa(xa,yy(j))	!solid line, clipped
		go to 350
342		call dasha(xa,yy(j),line) !dashed line, clipped
		go to 350
343		call drwabs(ixa,iyy(j))	!solid line, not clipped
		go to 350
344		call dshabs(ixa,iyy(j),line) !dashed line, not clipped
350	      enddo
	      iydb4 = iyd
	    endif
c
	    ixa = ix	    	!initialize new x-raster values
	    iyy(1) = iy
	    iylo = iy
	    iyhi = iy
	    iyd = iy
	    xa = xpoint
	    yy(1) = ypoint
	    ylo = ypoint
	    yhi = ypoint
	    yd = ypoint
c same x screen coordinate as last point
	  else		!(ix.eq.ixa)
	    iyd = iy		!exit point for this raster
	    yd = ypoint
	    if (iy.lt.iylo) then
	      iylo = iy
	      ylo = ypoint
	    else if (iy.gt.iyhi) then
	      iyhi = iy
	      yhi = ypoint
	    endif
	  endif
 380	  enddo
c  plot last raster for this plot segment
	  jnum = 1		!number of points to plot
	  if (iyy(1).gt.iyd) then	!end lower than start
	    if(iyhi.ne.iyy(1)) then
	    jnum = jnum+1	!go high first
	    iyy(jnum) = iyhi
	    yy(jnum) = yhi
	    endif
	    jnum = jnum+1	!then low
	    iyy(jnum) = iylo
	    yy(jnum) = ylo
	  else	    		!end higher than start
	    if(iylo.ne.iyy(1)) then
	    jnum = jnum+1	!go low first
	    iyy(jnum) = iylo
	    yy(jnum) = ylo
	    endif
	    jnum = jnum+1	!then high
	    iyy(jnum) = iyhi
	    yy(jnum) = yhi
	  endif
	  if (iyd.ne.iyy(jnum)) then
	    jnum = jnum+1
	    yy(jnum) = yd
	    iyy(jnum) = iyd
	  endif
	  do j=1,jnum
	    if(iopt.le.2) then
	      call dasha(xa,yy(j),line)		!dash/solid clipped
	    elseif(iopt.le.4) then
	      call dshabs(ixa,iyy(j),line)	!unclipped line
	    endif
	  enddo
	go to 900
c ** original cplot code for symbols and special line types
400	continue
	if(lines.eq.4) call pointa(xpoint,ypoint)
	if(lines.eq.5) call bar(xpoint,ypoint,line)
cx	if(lines.eq.6) call uline(xpoint,ypoint,1)
	ibets=comget(ibasec+6)
	ibets=ibets-1		!could start at 0 or 1
	if(isym.ne.0 .and. ibets.le.0) then
	  call bsyms(xpoint,ypoint,isym)
	  ibets=isteps
	endif
c * save line assignment in event of "missing data"
	linsav=lines
	do while(i.le.limit)
	  if(ifastx.gt.0) then
	    xpoint=x(ifastx)
	    ifastx=ifastx+istepl
cx	  elseif(ifastx.eq.0) then
cx	    xpoint=agbdgt(x,nxbase,i)
	  else
	    xpoint=xfirs+xdelt*float(i-1)
	  endif
	  if(ifasty.gt.0) then
	    ypoint=y(ifasty)
	    ifasty=ifasty+istepl
cx	  elseif(ifasty.eq.0) then
cx	    call uline
	  else
	    ypoint=y(3)+y(4)*float(i-1)
	  endif
	  i=i+istepl
c * allow plots to skip missing data points
	  if(abs(xpoint).ge.finfin .or. abs(ypoint).ge.finfin) then
c * change lines assignment so next data point is a move
	    if(lines.ne.6) lines=2
	    go to 800
	  endif
	  go to (510,520,530,540,550,560), lines
510	  call drawa(xpoint,ypoint)	!draw solid line
	  go to 600
520	  call movea(xpoint,ypoint)	!move to next point
c * restore line assignment after "missing data"
	  lines=linsav
	  go to 600
530	  call dasha(xpoint,ypoint,line)	!draw dashed line
	  go to 600
540	  call pointa(xpoint,ypoint)	!plot point
	  go to 600
550	  call bar(xpoint,ypoint,line)	!draw a bar
	  go to 800
560	  continue
cx	  call uline(xpoint,ypoint,i)	!user written line
c * see if time to put symbol
600	  if(isym.ne.0) then
	    ibets=ibets-1
	    if(ibets.gt.0) go to 800
c * draw symbol at point
	    call bsyms(xpoint,ypoint,isym)
	    ibets=isteps
	  endif
 800	enddo		!end of 400 outer loop
	if(lines.eq.4) call agmark(0)	!clear marker type
 900	continue
	return
	end
c%
c----------------------------------------------------------------/agkeys
c * set index/limit based on type of data
c
	subroutine agkeys(x,y,ifastx,ifasty,limit)
        implicit none
	real x(*),y(*)
        integer ifastx,ifasty,limit
        real comget
	common /bppcom/ comget(80)
	integer ibasec
	parameter (ibasec=1)
        integer nptx, npty, nb, nxbase, limitx, npt, limity
        real    keyx, keyy 
c
	nptx=comget(ibasec+14)		!number of x points
	nxbase=comget(ibasec+9)
c * determine type of line to be used in this plot
	if(nptx.gt.0) then
	  if(nxbase.eq.0) then
	    ifastx=1			!non-standard
	  else
	    ifastx=-2			!basex short form
	  endif
	  limitx=nptx
	else
	  keyx=x(1)
	  if(keyx.gt.0) then
	    ifastx=2			!standard long form
	    limitx=keyx
	  elseif(keyx.eq.-1) then
	    ifastx=-1			!standard short form
	    limitx=x(2)
	  else			!unknown - error
	    ifastx=0
	    limitx=0
cx	    call agseter
	  endif
	endif
c
	npty=comget(ibasec+4)		!number of y points
	if(npty.gt.0) then
	  ifasty=1			!non-standard
	  limity=npty
	else
	  keyy=y(1)
	  if(keyy.gt.0) then
	    ifasty=2			!standard long form
	    limity=keyy
	  elseif(keyy.eq.-1) then
	    ifasty=-1			!standard short form
	    limity=y(2)
	  else			!keyy.eq.4 = user line
	    ifasty=0
	    limity=npty
	  endif
	endif
	limit=min(limitx,limity)
	end
c----------------------------------------------------------------/agbdgt
c * get the ith x given the x base array and the # of bases in x
c
	real function agbdgt(xbase,nxbase,i)
        implicit none
c
        integer nxbase, i
	real xbase(3,nxbase)
        integer ib, nt, nb

	ib=i
	do nb=1,nxbase
	  nt=xbase(1,nb)
	  if(ib.le.nt) then
c x=t0+dt*(i-1) of the nbth base
 	    agbdgt=xbase(2,nb)+xbase(3,nb)*(ib-1)
	    return
	  endif
	  ib=ib-nt
	enddo
c i is outside the defined x bases
	agbdgt=0
	return
	end
c%
c----------------------------------------------------------------/agbmnx
c * find min and max of an incremental x base array
c
	subroutine agbmnx(array,amin,amax,nxbase)
        implicit none
        real    amin,amax
        integer nxbase
	real array(3,nxbase)
        integer nlim
c
	amin=min(amin,array(2,1))
	nlim=array(1,nxbase)-1.
	amax=max(amax,array(2,nxbase)+array(3,nxbase)*nlim)
	return
	end
c%
c----------------------------------------------------------------/roundd
c * round down routine
c
	real function roundd(value,fint)
        implicit none
        real value, fint, test, round
c * determine the number of tick intervals between 0 and value
	test=value/fint
	if(test.gt.0) test=test+1.e-4	!?1./(2**3)
	round=float(ifix(test))*fint
	do while ((round-value).gt.fint*1.e-4)
	  round=round-fint
	enddo
	roundd=round
	return
	end
c%
c----------------------------------------------------------------/roundu
c * round up routine
c
	real function roundu(value,fint)
        implicit none
        real value,fint
        real round, test
c * determine the number of tick intervals between 0 and value
	test=value/fint
	if(test.lt.0) test=test-1.e-4	!?1./(2**3)
	round=float(ifix(test))*fint
	do while ((value-round).gt.fint*1.e-4)
	  round=round+fint
	enddo
	roundu=round
	return
	end
c%
c----------------------------------------------------------------/frame
c * draw a box around the screen window
c
	subroutine frame
        implicit none
        integer  ix, iy, minx, miny, maxx, maxy, igrid
        real comget
	common /bppcom/ comget(80)
	integer ibasec
	parameter (ibasec=1)
        integer ibasex, ibasey               ! functions

	igrid=comget(ibasec+11)
	call linclr(igrid)
	ix=ibasex(0)
	iy=ibasey(0)
	minx=comget(ix+13)
	maxx=comget(ix+14)
	miny=comget(iy+13)
	maxy=comget(iy+14)
	call movabs(maxx,miny)
	call drwabs(maxx,maxy)
	call drwabs(minx,maxy)
	call drwabs(minx,miny)
	call drwabs(maxx,miny)
	return
	end
c%
c----------------------------------------------------------------/bsyms
c * draw symbols for data points
c
	subroutine bsyms(x,y,isym)
        implicit none
        integer isym
        real x, y
        real comget, factr 
	common /bppcom/ comget(80)
	integer ibasec
	parameter (ibasec=1)
        integer icclip, ivclip  ! finctions
        integer ix, iy
c * is clipping desired?
	if(icclip(0).eq.0) then
c * yes, is x,y in range?
	  call wincot(x,y,ix,iy)
	  if(ivclip(ix,iy).ne.0) go to 500
	endif
	factr=comget(ibasec+7)
	if(isym.ge.-15) then	!was .ge.0 (Nov/90)
c * call general symbol routine
	  call symout(isym,factr)
	else
c * user symbols
cx	  call users(x,y,isym)
	endif
	call movea(x,y)
500	return
	end
c%
c----------------------------------------------------------------/symout
c * put out symbols at the current location
c
	subroutine symout(isym,factr)
	character csym*1
c * get current location
	call seeloc(ix,iy)
	if(isym.gt.127) then
	  call softek(isym)
	elseif(isym.ge.33) then
c * put ascii character
	  call csize(ihorz,ivert)
	  ihorz=float(ihorz)*.3572
	  ivert=float(ivert)*.3182
	  call movrel(-ihorz,-ivert)
	  csym(1:1)=char(isym)
	  call agths(csym,1)
	elseif(isym.le.15) then		!was 11 (Nov/90)
	  call teksym(isym,factr)
	endif
c * return beam to original position
400	call movabs(ix,iy)
	return
	end
c%
c----------------------------------------------------------------/teksym
c * draw standard (plot-10) symbol
c
	subroutine teksym(isym,amult)
        real comget
	common /bppcom/ comget(80)
	integer ibasec
	parameter (ibasec=1)
	logical lpanel,lmfill
	real    sadj(15)	!adjustment for proportional sizes
	logical solid(15)	!true if can be filled
	data sadj /1.0,1.25,1.125,1.125,1.25,1.125,1.25,1.25,1.25,1.25,
     >	  1.125,1.0,1.0,1.125,1.125/
	data solid /.true.,.true.,.true.,.true.,.true.,.true.,.false.,
     >	  .true.,.false.,.false.,.true.,.false.,.false.,.false.,.false./
c
	isymb=abs(isym)
	if(isymb.gt.15 .or. isymb.eq.0) return	!was 11 (Nov/90)
	call agseet(i4105,kfac,ic,is)	!kfac = 1 for 1024, 4 for 4096
	rod=8.*amult*kfac
	adjust=sadj(isymb)
	rod=rod*adjust
	ihalf=nint(rod)	!half height/width
	ifull=ihalf+ihalf
c * set line/panel color
	if(i4105.ne.0) then
	  icurv=comget(ibasec+10)
	  call linclr(icurv)
	  call agpnclr(-icurv)
	endif
	lpanel=i4105.ne.0 .and. isym.lt.0 .and. solid(isymb)
	lmfill=i4105.eq.0 .and. isym.lt.0 .and. solid(isymb)
	if(lmfill) call seeloc(ix,iy)
	go to (310,320,330,340,350,360,370,380,390,400,410,420,
     >	  310,340,360),isymb
c * draw circle
 310	ic30=nint(rod*.8660254)		!cos(30)=sin(60)
	is30=nint(rod*.5)		!sin(30)=cos(60)
	call movrel(ihalf,0)		!move right
	if(lpanel) call agbgpnl(1)	!draw panel border
	call drwrel(ic30-ihalf,is30)
	call drwrel(is30-ic30,ic30-is30)
	call drwrel(-is30,ihalf-ic30)
	call drwrel(-is30,ic30-ihalf)
	call drwrel(-ic30+is30,is30-ic30)
	call drwrel(-ihalf+ic30,-is30)
	call drwrel(-ic30+ihalf,-is30)
	call drwrel(-is30+ic30,-ic30+is30)
	call drwrel(is30,-ihalf+ic30)
	call drwrel(is30,-ic30+ihalf)
	call drwrel(ic30-is30,-is30+ic30)
	call drwrel(ihalf-ic30,0+is30)
	if(isymb.eq.13) go to 382	!circle with plus
	if(lmfill.and.ihalf.gt.1) then
	  rod=rod-.7071068
	  ihalf=nint(rod)
	  call movabs(ix,iy)
	  go to 310
	endif
	go to 600
c * draw an x
 320	ic45=nint(rod*.75)		!bit more than cos(45)
	it45=ic45+ic45
	call movrel( ic45, ic45)	!move up,right
	if(lpanel) call agbgpnl(1)	!draw panel border
 322	continue
	call drwrel(-it45,-it45)
	call movrel(0,it45)
	call drwrel(it45,-it45)
	call movrel(0,it45)
	go to 600
c * draw a triangle
 330	ic30=nint(rod*.8660254)		!cos(30)
	is30=nint(rod*.5)		!sin(30)
	call movrel(0,ihalf)		!move up
	if(lpanel) call agbgpnl(1)	!draw panel border
	call drwrel(-ic30,-is30-ihalf)
	call drwrel(ic30+ic30,0)
	call drwrel(-ic30,ihalf+is30)
	if(lmfill.and.ihalf.gt.1) then
	  rod=rod-1.
	  ihalf=nint(rod)
	  call movabs(ix,iy)
	  go to 330
	endif
	go to 600
c * draw a square
 340	ic45=nint(rod*.7071068)	!cos/sin(45)
	it45=ic45+ic45
	call movrel( ic45, ic45)	!move up,right
	if(lpanel) call agbgpnl(1)	!draw panel border
	call drwrel(-it45, 0)
	call drwrel( 0,   -it45)
	call drwrel( it45, 0)
	call drwrel( 0,    it45)
	if(isymb.eq.14) go to 322	!square with x
	if(lmfill.and.ihalf.gt.1) then
	  rod=rod-1.
	  ihalf=nint(rod)
	  call movabs(ix,iy)
	  go to 340
	endif
	go to 600
c * draw a star
 350	ic234=nint(rod*.5878)		!(-)cos(234)
	is234=nint(rod*.8090)		!(-)sin(234)
	ic378=nint(rod*.9511)		!cos(378)
	is378=nint(rod*.3090)		!sin(378)
	call movrel( 0,           ihalf)
	if(lpanel) call agbgpnl(1)	!draw panel border
	call drwrel(-ic234,      -is234-ihalf)
	call drwrel( ic378+ic234, is378+is234)
	call drwrel(-ic378-ic378, 0)
	call drwrel( ic234+ic378,-is234-is378)
	call drwrel(-ic234,       ihalf+is234)
	go to 600
c * draw a diamond
 360	call movrel(ihalf,0)		!move right
	if(lpanel) call agbgpnl(1)	!draw panel border
	call drwrel(-ihalf, ihalf)
	call drwrel(-ihalf,-ihalf)
	call drwrel( ihalf,-ihalf)
	call drwrel( ihalf, ihalf)
	if(isymb.eq.15) go to 382	!diamond with plus
	if(lmfill.and.ihalf.gt.1) then
	  ihalf=ihalf-1
	  call movabs(ix,iy)
	  go to 360
	endif
	go to 600
c * draw a vertical bar
 370	call movrel(0, ihalf)
	call drwrel(0,-ifull)
	go to 600
c * draw a plus
 380	call movrel(ihalf,0)		!move right
	if(lpanel) call agbgpnl(1)	!draw panel border
 382	continue
	call drwrel(-ifull, 0)
	call movrel( ihalf, ihalf)
	call drwrel( 0    ,-ifull)
	call movrel( ihalf, ihalf)
	go to 600
c * draw up arrow
 390	ihead=nint(kfac*amult*adjust)
	call drwrel(-2*ihead,-6*ihead)
	call drwrel( 4*ihead, 0)
	call drwrel(-2*ihead, 6*ihead)
	call drwrel( 0      ,-ifull)
	go to 600
c * draw down arrow
 400	ihead=nint(kfac*amult*adjust)
	call drwrel(-2*ihead, 6*ihead)
	call drwrel( 4*ihead, 0)
	call drwrel(-2*ihead,-6*ihead)
	call drwrel( 0      , ifull)
	go to 600
c * draw a del
 410	ic30=nint(rod*.8660254)		!cos(30)
	is30=nint(rod*.5)		!sin(30)
	call movrel(0,-ihalf)		!move down
	if(lpanel) call agbgpnl(1)	!draw panel border
	call drwrel(ic30,is30+ihalf)
	call drwrel(-ic30-ic30,0)
	call drwrel(ic30,-ihalf-is30)
	if(lmfill.and.ihalf.gt.1) then
	  rod=rod-1.
	  ihalf=nint(rod)
	  call movabs(ix,iy)
	  go to 410
	endif
	go to 600
c * draw MAC (VT-Pro) circle
 420	if(i4105.eq.0) go to 310	!normal circle if not 4105
	call cmdout('DA')
	iff=1
	if(isym.lt.0) iff=3
	call intout(iff)		!1=frame, 2=fill, 3=frame+fill
	call intout(0)
	call intout(360)		!from 0 to 360
	ihalf=nint(rod*4.)
	call intout(ihalf)		!x/y radius (?diam)
	call intout(ihalf)
	call vecmod			!end esc sequence (for XPLOT)
600	if(lpanel) call endpnl
	return
	end
c%
c----------------------------------------------------------------/bar
c * set up barchart params and call filbox to draw bar
c
	subroutine bar(x,y,line)
        real comget
	common /bppcom/ comget(80)
	integer ibasec
	parameter (ibasec=1)
c
	call agseet(i4105,kfac,ic,is)
	if(line.ne.0) then		!need to set up bar
	  isymb=comget(ibasec+1)	!type of shading is symbol type
	  ihalf=comget(ibasec+8)*.5	!width of bar is symbol size
	  if(ihalf.lt.2) ihalf=20*kfac	!default is 40 pixels wise
	  lspace=comget(ibasec+7)	!spacing of line is line size
	  if(lspace.le.1) lspace=20*kfac
	  ivrhor=abs(line)		!bars vertical unless line is 3
	  nbase=ibasex(0)
	  minx=comget(nbase+13)
	  maxx=comget(nbase+14)
	  nbase=ibasey(0)
	  miny=comget(nbase+13)
	  maxy=comget(nbase+14)
	  call wincot(0.,0.,ix,iy)
	  ibegx=ix
	  ibegy=iy
	  it=max(minx,maxx)
	  minx=min(minx,maxx)
	  maxx=it
	  it=max(miny,maxy)
	  miny=min(miny,maxy)
	  maxy=it
	endif
c * find point in screen space
	call wincot(x,y,ix,iy)
	if(ivrhor.eq.2) then
c * vertical bars
	  iyl=min(ibegy,iy)
	  iyh=max(ibegy,iy)
	  ixl=min(ix-ihalf,ix+ihalf)
	  ixh=max(ix-ihalf,ix+ihalf)
	else		!ivrhor.eq.3
c * horizontal bars
	  iyl=min(iy-ihalf,iy+ihalf)
	  iyh=max(iy-ihalf,iy+ihalf)
	  ixl=min(ibegx,ix)
	  ixh=max(ibegx,ix)
	endif
c * adjust sides of bar to be within window
	ixl=max(ixl,minx)
	ixh=min(ixh,maxx)
	iyl=max(iyl,miny)
	iyh=min(iyh,maxy)
c * if bar is too small, return without drawing
	if(ixh-ixl.ge.2 .and. iyh-iyl.ge.2) then
	  call filbox(ixl,iyl,ixh,iyh,isymb,lspace)
	endif
	return
	end
c
c----------------------------------------------------------------/filbox
c * draw a box and fill it with shade lines if desired
c
	subroutine filbox(minx,miny,maxx,maxy,isymb,lspace)
c
	logical hor,ver,dup,dwn
	iminx=min(minx,maxx)
	iminy=min(miny,maxy)
	imaxx=max(minx,maxx)
	imaxy=max(miny,maxy)
c * draw box outline
	call movabs(iminx,iminy)
	call drwabs(imaxx,iminy)
	call drwabs(imaxx,imaxy)
	call drwabs(iminx,imaxy)
	call drwabs(iminx,iminy)
	if(iminx.eq.imaxx .or. iminy.eq.imaxy) return
	if(isymb.gt.15 .or. isymb.lt.0) go to 800
c * decode bar type (bit map)
	hor=btest(isymb,0)	!horizontal lines
	ver=btest(isymb,1)	!vertical lines
	dup=btest(isymb,2)	!diagonal up lines (45 deg)
	dwn=btest(isymb,3)	!diagonal down lines (-45 deg)
c * draw horizontal lines
	if(hor) then
	  il=iminy+lspace
	  do while(il.lt.imaxy)
	    call movabs(iminx,il)
	    call drwabs(imaxx,il)
	    il=il+lspace
	  enddo
	endif
c * draw vertical lines
	if(ver) then
	  il=iminx+lspace
	  do while(il.lt.imaxx)
	    call movabs(il,iminy)
	    call drwabs(il,imaxy)
	    il=il+lspace
	  enddo
	endif
c
	if(.not.dup .and. .not.dwn) go to 800
c * set window/scaling to limits of shading area
	ximin=iminx
	ximax=imaxx
	yimin=iminy
	yimax=imaxy
	call twindo(iminx,imaxx,iminy,imaxy)
	call dwindo(ximin,ximax,yimin,yimax)
	dely=ximax-ximin
	space=lspace
c * diagonal lines up or down
	if(dup) then
	  y=yimin-dely+space
	else	!dwn
	  y=yimin+space
	  yimax=yimax+dely
	  dely=-dely
	endif
	do while(y.lt.yimax)
	  call movea(ximin,y)
	  y2=y+dely
	  call drawa(ximax,y2)
	  y=y+space
	enddo
c * restore window/scaling to variables in common
	call setwin		!twindo/dwindo
800	return
	end
c----------------------------------------------------------------/remlab
c * produce off axis labels for linear scale factors
c
	subroutine remlab(nbase,iloc,labtyp,irx,iry)
	parameter (llabl=8)
	character clabl*(llabl)
        real comget
	common /bppcom/ comget(80)
	iexp=comget(nbase+18)
	if(iexp.eq.0) return
c * set justification according to axis and side
	iposit=-sign(1,iloc-1)		!y axis
	if(nbase.eq.ibasex(0)) iposit=1	!x axis
	call expout(nbase,iexp,clabl,llabl)
c * put out label string
	len=llabl
	call movabs(irx,iry)
	call juster(clabl,len,iposit)
	return
	end
c%
c----------------------------------------------------------------/expout
c * create exponential label
c
	subroutine expout(nbase,iexp,clabl,nchars)
	character clabl*(*)
        real comget
	common /bppcom/ comget(80)
	integer jup
	data jup/-1/

	clabl=' '
	log=comget(nbase+15)
	nexp=iabs(iexp)
	ic=nchars
	if(nexp.eq.0) then	!10**0
	  clabl(ic:ic)='1'
	  go to 800
	endif
	if(iexp.eq.1) go to 380
c * x10 to exponent processing
	if(nexp.ge.100) then
	  clabl(ic-1:ic)='**'
	  ic=ic-2
	else			!exponents between 1 and 99
	  if(nexp.ge.10) then
	    clabl(ic:ic)=char(mod(nexp,10)+ichar('0'))
	    nexp=nexp/10
	    ic=ic-1
	  endif
	  clabl(ic:ic)=char(nexp+ichar('0'))
	  ic=ic-1
	endif
	if(iexp.lt.0) then	!negative exponent
	  clabl(ic:ic)='-'
	  ic=ic-1
	endif
	clabl(ic:ic)=char(jup)	!up shift character
	ic=ic-1
c * times 10
380	clabl(ic-1:ic)='10'
	ic=ic-2
	if(log.ne.2) then	!x if not log
	  clabl(ic:ic)='X'
	  ic=ic-1
	endif
 800	continue
	return
	end
c%
c----------------------------------------------------------------/numset
c * reformat floating point for axis labeling
c
	subroutine numset(fnum,nbase,clabl,iwidth)
	character clabl*12
        real comget
	common /bppcom/ comget(80)
	character cform*8 !c@u
	character stars*12
	data stars /'************'/
	idec=comget(nbase+10)
	itype=comget(nbase+15)
	if(itype.eq.2) then	!log scale
	  iexp=fnum+sign(0.00005,fnum)
	  iwidth=iwidth+1	!increase iwidth to allow for up shift
	  call expout(nbase,iexp,clabl,iwidth)
	else			!linear
	  cform=' ' !c@u
	  if(idec.eq.0) then
	    write(cform,'(2h(i,i2.2,1h))') iwidth !   
	    write(clabl,cform,iostat=ierr) nint(fnum) !   
	  else
	    write(cform,'(2h(f,i2.2,1h.,i1,1h))') iwidth,idec !   
	    write(clabl,cform,iostat=ierr) fnum !   
	  endif
	  if(ierr.ne.0) clabl=stars
	endif
	return
	end
c%
c----------------------------------------------------------------/juster
c * output a string justified right(-1), center(0), or left(1)
c
cx	options /nounderflow
	subroutine juster(clabl,lenchr,iposit)
        implicit none
        integer lenchr,iposit
	character clabl*(*)
        integer*4 jup, jdn, ich, hex00, ibyte
   	integer*4 ilabl(12)	
        integer istart,lentru,i,ioff,linwdt,iv2,linhgt

cx If anstr is ever converted to accept a character string argument
cx instead of an integer array, copying to ilabl can be omitted.
	data jup/-1/,jdn/-2/
        data hex00/z'ffffff00'/

c * bypass fill characters
	istart=1
	do while(istart.le.lenchr .and. clabl(istart:istart).eq.' ')
	  istart=istart+1
	enddo
	lentru=lenchr-istart+1
c * count special (invisible) characters
	i=istart
	do while(i.le.lenchr)
           ich = ichar(clabl(i:i))
	  ibyte=ior(ich,hex00)
	  if(ibyte.eq.jup .or. ibyte.eq.jdn) lentru=lentru-1
   	  ilabl(i)=ibyte	!c@v
	  i=i+1
	enddo
c * adjust offset according to position code
	if(iposit.lt.0) then		!left justify
	  ioff=0
	elseif(iposit.eq.0) then	!center
	  ioff=-linwdt(lentru*7-2)/14
	else				!right justify
	  ioff=-linwdt(lentru*7-2)/7
	endif
c * move to output position
	if(ioff.ne.0) call movrel(ioff,0)
	iv2=linhgt(1)/2
	do i=istart,lenchr
c					!extend sign bit
	  ibyte=ior(ichar(clabl(i:i)),hex00)
	  if(ibyte.eq.jup .or. ibyte.eq.jdn) then
c * when special character found put out preceeding string
	    call anstr(i-istart,clabl(istart:)) !   

c * if jump up move for superscript
	    if(ibyte.eq.jup) call movrel(0,iv2)
c * if jump down move for subscript
	    if(ibyte.eq.jdn) call movrel(0,-iv2)
	    istart=i+1
	  endif
	enddo
	call anstr(lenchr-istart+1,clabl(istart:)) !   

	return
	end
c%
c----------------------------------------------------------------/softek
c * dummy routine for user created symbol
c
	subroutine softek(isym)
	return
	end
c%
cxc----------------------------------------------------------------/users
cxc * dummy routine for user created symbol
cxc
cx	subroutine users(x,y,i)
cx	return
cx	end
cxc%
c----------------------------------------------------------------/ibasec
c * return pointer to parameter in common portion of bppcom
c
	integer function ibasec(ioff)
        integer ioff
        
        real comget
	common /bppcom/ comget(80)
	ibasec=1+ioff	!cvectr+ioff
	return
c%
c----------------------------------------------------------------/ibasex
c * return pointer to parameter in x vector portion of common
c
	entry ibasex(ioff)
	ibasex=17+ioff	!xvectr+ioff
	return
c%
c----------------------------------------------------------------/ibasey
c * return pointer to parameter in y vector portion of common
c
	entry ibasey(ioff)
	ibasey=46+ioff	!yvectr+ioff
	return
	end
c%
c----------------------------------------------------------------/bppblk
        block data bppblk
        real comget
	common /bppcom/ comget(80)
	data comget(13) /1./	!ccurv (in case no binitt)
        end
c----------------------------------------------------------------/iother
c * find the other base
c
	integer function iother(nbase)
        integer nbase
        integer nx,ny
	nx=ibasex(0)
	ny=ibasey(0)
	if(nbase.eq.nx) iother=ny
	if(nbase.eq.ny) iother=nx
	return
	end
c%
c----------------------------------------------------------------/comget
c * read value from common block
c
	real function comget(item)
        real table
	common /bppcom/ table(80)
	comget=table(item)
	return
	end
c%
c----------------------------------------------------------------/comset
c * write value into common block
c
	subroutine comset(item,value)
        implicit none
        integer item
        real    table, value
	common /bppcom/ table(80)
	if(item.ge.1 .and. item.lt.80) table(item)=value
	return
	end

      subroutine get_arg_count(numargs)
C
#if __NAGWARE
      use f90_unix_env
#endif
C
      integer numargs
C
C  return the number of arguments on the command line
C
#if !__CRAY && !__NAGWARE
      integer iargc
#elif __CRAY || __X1
      external ipxfargc
      integer ipxfargc
#endif
 
#if __CRAY || __X1
      numargs = ipxfargc()
#elif __ABS
      numargs = iargc_()
#else
      numargs = iargc()
#endif
 
      return
      end
 
#ifdef __LF95

c
c  this compiler lacks FY-2003 routine -- attempt a patch...
c

      integer function command_argument_count()

      integer :: iargs

      call get_arg_count(iargs)
      command_argument_count = iargs

      return
      end

#endif

C------------------------------------------------------------------   GRAOPT
C  GRAOPT - GENERATE STANDARD MENU AFTER 2D PLOT
C   MENU OPTIONS ALLOW USER TO RESCALE PLOT, CHANGE AXES TYPES
C   CHANGE PLOT OR AXES DEFAULTS, OR QUIT PLOT
 
C
      SUBROUTINE GRAOPT(CTRL,ISEL,ILOCSC,IOPCOD,XOPT)        ! 7/1/91
C
C
C   CALLER DETERMINES WHAT OPTIONS ARE TO BE MADE AVAILABLE AT
C   THIS TIME
C
C  ** THIS ROUTINE IS A USER INTERFACE ONLY **
C  NO COMPUTATION IS DONE-- JUST INPUT USER REQUEST
C
C   mod dmc 6 Nov 1997 -- option for format control of Ufile output
C        has been added; ILOCSC is "reused" -- cf rplot_sub/grfah4.for
C                                               & rplot_sub/mulgrg.for
C
C   Mod TBT July 1, 1991 - Added option W to CTRL and negative IOPCOD.
C   Mod TBT Jun 12, 1991 - Replaced NLXOUT with LXOUT to get printing.
C   Mod TBT May 28, 1991 - Fix bug - reset IOPCOD=1 after wrong option code.
C   MOD TBT Apr  5, 1991 - Clean up menu.
C   MOD TBT Mar 27, 1991 -  Clean up menu.
C   MOD TBT OCT 24, 1989 -- OPTION TO DIFFERENTIATE.
C   MOD DMC FEB 1989 -- OPTION TO RESET SCALE VIA TK CROSS-HAIR
C   CURSOR INPUT OPTION
 
C	----------------------------------------------------------------------
 
      INCLUDE 'PLOT1MMX'
C
      CHARACTER*(*) CTRL
C
      CHARACTER*8 ZWORD
      CHARACTER*1 ZUCHAR
      CHARACTER*64 ZBUFF
C
      EXTERNAL XOPT
C
C  CTRL - STRING DETERMINING OPTIONS TO BE MADE AVAILABLE ON THIS CALL:
C   IF "A" IS IN CTRL, AXES OPTIONS  ARE MADE AVAILABLE
C   if "O" is in CTRL, column-oriented ASCII output is an option
C   IF "S" IS IN CTRL, SCALING OPTIONS  ARE MADE AVAILABLE
C   IF "Q" GEN MSG RE. "SQUARE SCALE" FOR GRFMM1
C   IF "U" IS IN CTRL, UFILES OUTPUT OPTION IS MADE AVAILABLE
C   IF "M" IS IN CTRL, SMOOTHING OPTION IS MADE AVAILABLE
C   IF "X" IS IN CTRL *CALL* PASSED EXTERNAL ROUTINE XOPT
C          (usually XOPT is a dummy but rplot_sub/plxopt is also used; this
C          one uses CTRL values "1", "T", "F",and "K" and UREAD character
C          codes "1", "I", "J", "F", and "K").
C   IF "D" IS IN CTRL, DIFFERENTIATION OPTION IS MADE AVAILABLE.  TBT
C   If "W" is in CTRL, WAIT for "P" command to plot, i.e. do NOT plot
C                      after smoothing or differentiating, etc.  TBT 7/91
C   If "E" is in CTRL, multigraph member edit option offerred.
C
C  ISEL - RETURN AXES CONTROL CODE
C
C  ILOCSC - RETURN SCALE ACTION CODE TO CALLER
C    =-1:  DO NOTHING
C    = 0:  RECOMPUTE PLOT SCALE (X AND Y BOTH)
C    = 1:  RECOMPUTE PLOT SCALE (Y ONLY)
C
C  IOPCOD - RETURN OVERALL ACTION CODE TO CALLER
C    =  1 - REPLOT (WITH POSSIBLE SCALE/AXES MODIFICATIONS)
C    =  2 - QUIT WITHOUT REPLOTTING
C    =  3 - SMOOTH DATA & Replot
C    = -3 - Smooth data & do NOT replot.
C    =  4 - RESTORE ORIGINAL UNSMOOTHED OR UNDIFFERENTIATED DATA & replot
C    = -4 - 4 but do NOT replot.
C    =  5 - UFILES OUTPUT (ASCII)
C    =  6 - UFILES OUTPUT (COMPRESSED BINARY)
C    =  7 - DIFFERENTIATE DATA & replot
C    = -7 - Differentiate data & do NOT replot.
C    =  8 thru 12 - See below. (PLXOPT)
C    = 13 -- Column oriented ASCII output
C
C  WARNING:
C  DMC 10 MAY 1991 -- CAREFUL ABOUT ADDING POSSIBLE VALUES TO IOPCOD
C  OUTPUT!  THE RPLOT ROUTINE PLXOPT IS PASSED TO THIS ROUTINE AS
C  "XOPT" BY RPLOT ROUTINES GRFAH4 AND MULGRG; XOPT OUTPUTS IOPCOD=8
C  THRU IOPCOD=12 SO DON'T REUSE THESE VALUES!
C
C-------------------------------------------------------------------
C
C  SET INTERNAL DEFAULTS
C
      LOGICAL LWAIT     ! T => wait for "P" option before plotting.
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      data iformat/0/
C
C	---------------------------------------------------------------------
C
C       Note:
C           IOPCOD < 0 only if it has been set so before in this routine GRAOPT.
      IF (IOPCOD .LT. 0  .AND.  INDEX(CTRL,'W') .NE. 0) THEN
C          ."W" option has been previously enterred. Keep it on until "P" chosen
         LWAIT  = .TRUE.
         IOPCOD = -1      ! -1 => go right back to GRAOPT menu.
      ELSE
         LWAIT  = .FALSE.
         IOPCOD = 1
      END IF  ! iopcod
 
 
      ILOCSC=-1  ! DO NOT RECOMPUTE SCALE
C
      LUNTRM=LNOUT(0)
C
C-----------------------------------------------------------------
C  FIRST CHECK FOR TEKTRONIX CURSOR INPUT OPTION
C
C  IF NO TYPEAHEAD IS PENDING AND RESCALING OPTIONS ARE AVAILABLE...
C
      IF(LXOUT(0).AND.(INDEX(CTRL,'S').NE.0)) THEN
        CALL UPCGET(ZUCHAR)
        IF((ZUCHAR.NE.'S').and.(ZUCHAR.ne.'s')) GO TO 10
C
C  INPUT NEW SCALE VIA TEKTRONIX CURSOR
        CALL UGMODE
        CALL AGVCUR(ZUCHAR,ZX1,ZY1)
        IF((ZUCHAR.EQ.'q').OR.(ZUCHAR.EQ.'Q')) THEN
          CALL UAMODE
          GO TO 10
        ELSE
C  MARK FIRST CROSS-HAIR POINT ...
          CALL LINCLR(2)
          CALL WINCOT(ZX1,ZY1,IX,IY)
          CALL MOVABS(IX-100,IY)
          CALL DRWABS(IX+100,IY)
          CALL MOVABS(IX,IY-100)
          CALL DRWABS(IX,IY+100)
          CALL LINCLR(1)
          CALL TSEND
        ENDIF
        CALL AGVCUR(ZUCHAR,ZX2,ZY2)
        IF((ZUCHAR.EQ.'q').OR.(ZUCHAR.EQ.'Q')) THEN
          CALL UAMODE
          GO TO 10
        ENDIF
C
C  ENCODE AND INSERT EQUIVALENT COMMAND STRING IN UREAD TYPEAHEAD BUFFER
        ZXMIN=AMIN1(ZX1,ZX2)
        ZXMAX=AMAX1(ZX1,ZX2)
        ZYMIN=AMIN1(ZY1,ZY2)
        ZYMAX=AMAX1(ZY1,ZY2)
C
C  IF BOTH INPUT X ARE OUTSIDE THE OLD RANGE USE INPUT Y ONLY:
        ZBUFF=' '
        IF((ZXMAX.LT.XMIN).OR.(ZXMIN.GT.XMAX)) THEN
          WRITE(ZBUFF,3001) ZYMIN,ZYMAX
 3001       FORMAT('S X X ',2(1PE13.6,1X))
C  IF BOTH INPUT Y ARE OUTSIDE THE OLD RANGE USE INPUT X ONLY
        ELSE IF((ZYMAX.LT.YMIN).OR.(ZYMIN.GT.YMAX)) THEN
          WRITE(ZBUFF,3002) ZXMIN,ZXMAX
 3002     FORMAT('X ',2(1PE13.6,1X))
        ELSE
C  OTHERWISE USE ALL INPUT COORDS
          WRITE(ZBUFF,3003) ZXMIN,ZXMAX,ZYMIN,ZYMAX
 3003     FORMAT('S ',4(1PE13.6,1X))
        ENDIF
        CALL URDTTY(ZBUFF) ! INSERT COMMAND INSTREAM
        IF(LXOUT(0)) CALL UAMODE
      ENDIF
C-----------------------------------------------------------------
C
 10   CONTINUE
      CALL NEUPAG
 11   CONTINUE
C
C  WRITE MENU IF AT TTY...
C
      IF (LXOUT(0))  THEN
          WRITE (LUNTRM,999)
  999     FORMAT(
     1      ' GRAOPT - OPTIONS: ENTER "C" TO SEE THE ENTIRE MENU')
      END IF  ! LXOUT
 
 12   CONTINUE
      CALL UREAD(
     >    'GRAOPT:  ENTER ONE LETTER OPCODE (.C/A/S/X/Z/G/P/Q):$$')
 
C	---------------------------------------------------------------
      IF (LCHAR('C'))  THEN    ! LOOK AT THE ENTIRE MENU.
 
       IF(LXOUT(0)) THEN
        WRITE(LUNTRM,1001)
 1001 FORMAT(/' GRAOPT - OPTIONS AFTER PLOT:')
        IF(INDEX(CTRL,'A').NE.0) THEN
          WRITE(LUNTRM,1002)
 1002 FORMAT(/' *AXIS TYPE CONTROL OPTIONS*'/
     >'  "A" CHANGE AXIS TYPES (LOG/LINEAR) AND PLOT AGAIN'/
     >'  "B" CHANGE AXIS DEFAULTS USED ON ENTRY TO PLOT ROUTINE')
        ENDIF
        IF(INDEX(CTRL,'Q').NE.0) WRITE(LUNTRM,1013)
 1013 FORMAT(/' % CURRENT PLOT TYPE USES "SQUARE SCALE"')
        IF(INDEX(CTRL,'S').NE.0) THEN
          WRITE(LUNTRM,1003)
 1003 FORMAT(/' *PLOT RESCALE OPTIONS* '/
     >'      --> ALSO TRY HITTING "S" ON UPAUSE BEEP'/
     >'  "R" RESTORE SCALE FROM A PREVIOUSLY DRAWN PLOT'/
     >'  "S" CHANGE SCALE OF PLOT (X AND Y) AND PLOT AGAIN'/
     >'  "X" CHANGE X SCALE, AUTO-RESET Y SCALE, AND PLOT AGAIN'/
     >'  "Z" ZOOM IN/OUT IN X, AUTO-RESET Y, AND PLOT AGAIN'/
     >'  "T" CHANGE *DEFAULT SCALING* USED ON ENTRY TO PLOT ROUTINE'/
     >'  "G" MODIFY MISC. PLOT DEFAULTS: GRID/FRAME/TIC/LINE SYTLE')
        ENDIF
        IF(INDEX(CTRL,'U').NE.0) THEN
          WRITE(LUNTRM,1004)
 1004 FORMAT(
     >'  "U" TO WRITE 1D',
     >       ' *PORTABLE BINARY* UFILE OF DATA IN PLOT ROUTINE'/
     >'  "V" TO WRITE 1D *ASCII* UFILE OF DATA IN PLOT ROUTINE'/
     >'  "4" To write 1d Ufile, NetCDF/HDF format options')
        ENDIF
 
        IF(INDEX(CTRL,'M').NE.0) THEN
          WRITE(LUNTRM,1005)
 1005       FORMAT(/'  "M" TO SMOOTH THE PLOT DATA')
          WRITE(LUNTRM,1008)
 1008       FORMAT('  "L" TO RESTORE UNPROCESSED PLOT DATA')
        ENDIF
 
        IF(INDEX(CTRL,'D').NE.0) THEN
          WRITE(LUNTRM,1007)
 1007     FORMAT('  "D" TO DIFFERENTIATE THE PLOT DATA')
          IF (INDEX(CTRL,'M') .EQ. 0) WRITE(LUNTRM,1008)
        ENDIF
 
        IF(INDEX(CTRL,'W').NE.0) THEN
          WRITE(LUNTRM,1009)
 1009     FORMAT('  "W" to WAIT for "P" before plotting')
        ENDIF
 
        if(index(ctrl,'E').ne.0) then
          write(luntrm,1011)
 1011     format('  "+" (plus sign) to edit multigraph plot contents')
        endif

        if(index(ctrl,'O').ne.0) then
          write(luntrm,1010)
 1010     format('  "O" (the letter O) to output 2 column ascii file')
        endif
C  EXTERNAL ROUTINE
        IF(INDEX(CTRL,'X').NE.0) CALL XOPT(1,CTRL,IOPCOD)
 
C  THESE OPTIONS ARE ALWAYS AVAILABLE
        WRITE(LUNTRM,1006)
 1006 FORMAT(/'  "P" JUST PLOT AGAIN (USING NEW DEFAULTS)'/
     >'  "Q" OR "N" TO QUIT PLOTTING (ALTERNATE RETURN CONTROL)')
       ENDIF     ! LXOUT
C       -------------------------
       GO TO 12  ! REPROMPT
 
      END IF   ! LCHAR('C)'
C
C	----------------------------------------------------------------
 
C  CHECK THE OPTIONS WHICH ARE ALWAYS AVAILABLE FIRST
C
      IF(LCHAR('N')) THEN
C  EXIT "N"
        ISEL=1
        IOPCOD=2
        RETURN
      ELSE IF(LCHAR(' ')) THEN
C  EXIT "N" ALSO
        ISEL=1
        IOPCOD=2
        RETURN
      ELSE IF(LCHAR(',')) THEN
C  EXIT "N" ALSO AGAIN
        ISEL=1
        IOPCOD=2
        RETURN
      ELSE IF(LCHAR('Q')) THEN
C  EXIT "Q"
        ISEL=2
        IOPCOD=2
        RETURN
      ELSE IF(LCHAR('P')) THEN
C  REPLOT WITHOUT CHANGES
        IOPCOD=1
        RETURN
      ENDIF
C----------------------------------------------------
C
C       .Wait option                            !TBT 7/91
      IF(INDEX(CTRL,'W').NE.0) THEN
         IF (LCHAR('W')) THEN
         LWAIT = .TRUE.
         GO TO 10
       END IF  ! LCHAR 'W'
      ENDIF    ! INDEX 'W'
C
C  column ascii output option
C
      if(index(CTRL,'O').ne.0) then
         if(lchar('O')) then
            iopcod=13
            return
         endif
      endif
C
C  MG edit option
C
      if(index(CTRL,'E').ne.0) then
         if(lchar('+')) then
            iopcod=14
            return
         endif
      endif
C
C  AXES OPTIONS
      IF(INDEX(CTRL,'A').NE.0) THEN
C
        IRETA=-1
        ISELP=ISEL
C
        IF(LCHAR('A')) THEN
          CALL GAXSET(ISEL,0)
          IRETA=1
        ELSE IF(LCHAR('B')) THEN
          CALL GAXSET(ISEL,1)
          IRETA=0
        ENDIF
C
C  RECOMPUTE SCALE AFTER AXES CHANGE - DMC SEPT 1986
        IF(ISEL.NE.ISELP) THEN
          IF((MAX0(ISEL,ISELP).EQ.2).OR.(MIN0(ISEL,ISELP).EQ.3)) THEN
C  Y AXIS CHANGE ONLY
            ILOCSC=1
          ELSE
            ILOCSC=0
          ENDIF
        ENDIF
C
        IF(IRETA.GE.0) THEN
          IF(IRETA.EQ.1) GO TO 3000
          GO TO 10
        ENDIF
C
      ENDIF
C----------------------------------------------------
C
C  RESCALE OPTIONS
      IF(INDEX(CTRL,'S').NE.0) THEN
        ILOCSP=ILOCSC  ! SAVE PREV. SETTING INCASE OF "Q"
        IXYGET=0
        IF(LCHAR('R')) THEN
          CALL GSCRSC(ISET)
          IF(ISET.GT.0) THEN
            ILOCSC=-1
            GO TO 3000
          ENDIF
          GO TO 10
        ELSE IF(LCHAR('S')) THEN
          IXYGET=1
          ILOCSC=-1
        ELSE IF(LCHAR('X')) THEN
          IXYGET=1
          ILOCSC=1
        ELSE IF(LCHAR('Z')) THEN
 31       CALL UREAD(
     >'GRAOPT: ENTER ZOOM FACTOR (.GT. 1 EXPANDS SCALE):$')
          IF(LCHAR('X')) GO TO 10
          IF(LCHAR('Q')) GO TO 10
          ZOOM=FDCOD(IERT)
          IF(IERT.NE.0) GO TO 31
          IF(ZOOM.LE.0.0) THEN
            CALL UERMSF('% ZOOM FACTOR .GT. 0 REQUIRED, INPUT WAS',
     >                    ZOOM,0)
            GO TO 31
          ENDIF
C
          ZXA=(XMAX+XMIN)*.5
          ZDXA=(XMAX-XMIN)*.5
C
          XMIN=ZXA-ZOOM*ZDXA
          XMAX=ZXA+ZOOM*ZDXA
C  REDO Y SCALE AUTOMATICALLY
          ILOCSC=1
          GO TO 3000
        ELSE IF(LCHAR('T')) THEN
C  CHANGE *DEFAULT SCALE SETTINGS*
          CALL GSCDEF
          ILOCSC=0
          GO TO 10
        ELSE IF(LCHAR('G')) THEN
          CALL GFTICI
          GO TO 10
        ENDIF
C
C  GET NEW X/Y SCALE
C
        IF(IXYGET.NE.0) THEN
          IF(LXOUT(0)) WRITE(LUNTRM,1071) XMIN,XMAX,YMIN,YMAX  ! TBT 6/91
 1071         FORMAT(/
     >           '  XMIN,XMAX:  ',2(1PE11.4,1X)/
     >           '  YMIN,YMAX:  ',2(1PE11.4,1X)/
     >           ' ENTER "X" NOT TO CHANGE A LIMIT ON THE GRAPH'/)
C
 71        CONTINUE
           CALL GSCGT1('GRAOPT','XMIN',ZXMIN,XMIN,IERT,' ')
           IF(IERT) 80,72,71
C
 72        CONTINUE
           CALL GSCGT1('GRAOPT','XMAX',ZXMAX,XMAX,IERT,' ')
           IF(IERT.EQ.-1) GO TO 80
           IF(IERT.EQ.1) GO TO 72
C
C  IF X OPTION IS IN EFFECT EXIT HERE TO REDO Y AUTOMATICALLY
           IF(ILOCSC.EQ.1) THEN
             XMIN=ZXMIN
             XMAX=ZXMAX
             GO TO 3000
           ENDIF
C
           IF(LXOUT(0)) WRITE(LUNTRM,1073)
 1073      FORMAT(' ENTER "R" TO AUTO RESCALE Y USING NEW X SCALE')
 73        CONTINUE
           CALL GSCGT1('GRAOPT','YMIN',ZYMIN,YMIN,IERT,'R')
           IF(IERT.EQ.2) THEN
             ILOCSC=1
             XMIN=ZXMIN
             XMAX=ZXMAX
             GO TO 3000
           ENDIF
           IF(IERT) 80,74,73
C
 74        CONTINUE
           CALL GSCGT1('GRAOPT','YMAX',ZYMAX,YMAX,IERT,' ')
           IF(IERT) 80,75,74
C
C  NEW SCALE HAS BEEN ENTERED
 75        CONTINUE
           XMIN=ZXMIN
           XMAX=ZXMAX
           YMIN=ZYMIN
           YMAX=ZYMAX
           GO TO 3000
C  NEW SCALE ENTRY ABORTED - RE-INITIALIZE
 80        CONTINUE
           ILOCSC=ILOCSP
           GO TO 10
        ENDIF
      ENDIF
C----------------------------------------------------
C
C  UFILES OPTION
      IF(INDEX(CTRL,'U').NE.0) THEN
        IF(LCHAR('U')) THEN
          IOPCOD=6
          ILOCSC=2
          RETURN
        ELSE IF(LCHAR('V')) THEN
          IOPCOD=5
          ILOCSC=0
          RETURN
        else if(lchar('4')) then
          call ufmtsel(iformat)
          ILOCSC=iformat
          if(iformat.eq.0) then
             IOPCOD=5
          else
             IOPCOD=6
          endif
          RETURN
        ENDIF
      ENDIF
C----------------------------------------------------
C
C  SMOOTHING OPTION
      IF(INDEX(CTRL,'M').NE.0) THEN
        IF(LCHAR('M')) THEN
          IOPCOD=3
          GO TO 3000
        ELSE IF(LCHAR('L')) THEN
          ILOCSC=1	! RECOMPUTE Y AXIS.
          IOPCOD=4
          GO TO 3000
        ENDIF
      ENDIF
C
C----------------------------------------------------
C
C  DIFFERENTIATION OPTION
      IF(INDEX(CTRL,'D').NE.0) THEN
        ILOCSC=1	! RECOMPUTE Y AXIS.
        IF(LCHAR('D')) THEN
          IOPCOD=7
          GO TO 3000
        ELSE IF(LCHAR('E')) THEN
          IOPCOD=4
          GO TO 3000
        ENDIF
      ENDIF
C
C----------------------------------------------------
C
C  EXTERNAL OPTION CODES ROUTINE
C
      IF(INDEX(CTRL,'X').NE.0) THEN
        IOPCOD=0
        CALL XOPT(2,CTRL,IOPCOD)
        IF(IOPCOD.NE.0) RETURN
 
C	  .Illegal op code. Print message and ask again.
        IOPCOD = 1               ! TBT 5/91 - reset to stop bomb
      ENDIF
C
C  ILLEGAL INPUT OPTION CODE
C
      CALL CDCOD(ZWORD)
      CALL UERMSG(' %GRAOPT - ILLEGAL OPTION CODE ',ZWORD,1)
      GO TO 11
 
C	-----------------------------------------------------------
C	.Check "Wait" option before returning.  TBT 7/91
 
 3000   CONTINUE
      IF (LWAIT)  THEN
          IOPCOD = -IABS(IOPCOD)
      END IF  ! lwait
 
      RETURN
 
C
      END

!
! This is Russell Hulse's Atomic Data Package.
!
! 12/01 RGA -- make fortran 90 compliant
!              split AD** common blocks into separate adpak_mod module
!              converted data statements to fortran 90 initialization
!              add ad_reset() and ad_erate() subroutines
!
!==================================================================
!
SUBROUTINE ADCE
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     CALCULATE CORONAL EQUILIBRIUM (INCLUDING CHARGE
!     EXCHANGE RECOMBINATION, IF PRESENT) USING THE IONIZATION,
!     RECOMBINATION, AND RADIATION RATES
!     STORED IN THE APPROPRIATE ARRAYS BY PREVIOUS CALLS
!     TO ADSET, ADERC, AND ADBCXR.
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
  real(fp) :: ZIONT(100), ZRECT(100), ZRADT(100)
  real(fp) :: ZFRCMX,ZPSUM
  integer JSPC,JQ,II,ICNTR,IPASS,IQFRAC
!
!     FILL TOTAL IONIZATION, RECOMBINATION, AND RADIATION ARRAYS
!
  DO JSPC = 1, NSPC
!
     ZIONT(JSPC) = RCLION(JSPC)
     ZRECT(JSPC) = RRAREC(JSPC) + RDIREC(JSPC) + RCXREC(JSPC)
     ZRADT(JSPC) = RADRRC(JSPC) + RADDRC(JSPC) + RADCLX(JSPC)&
                                + RADBRM(JSPC) + RADBCX(JSPC)
!
  enddo
!
!
!     FIRST GUESS AT MAXIMUM SPECIES
!
  DO  JQ = 1 , NSPC
     IF(ZRECT(JQ) .GE. ZIONT(JQ))GO TO 21
  enddo
  JQ = NSPC
21 ICNTR = JQ
!W    WRITE(IOUT,23)ICNTR
23 FORMAT(1X,'ICNTR 1ST GUESS =',I3)
  IPASS = 1
!
!     INITIALIZE CEFRAC ARRAY
!
25 CEFRAC(1:NSPC) = 0._fp
  CEFRAC(ICNTR) = 1._fp
!
!     IF ICNTR IS FULLY STRIPPED WORK DOWN IN IONIZ ONLY
!
  IF(ICNTR.EQ.NSPC)GO TO 35
!
!     WORK UP FROM ICNTR SPECIES (TOWARDS HIGHER IONIZ STATES)
!
  II = ICNTR + 1
!
  DO JQ = II,NSPC
     CEFRAC(JQ) = CEFRAC(JQ-1) * ZIONT(JQ-1) / ZRECT(JQ)
     IF(CEFRAC(JQ).LT.1.E-10_fp*CEFRAC(ICNTR)) GO TO 32
  enddo
!
!     IF ICNTR IS NEUTRAL WE'RE DONE
!
32 IF(ICNTR.EQ.1)GO TO 42
!
!     WORK DOWN FROM ICNTR SPECIESccccccccccccccc/ccccccccc/ccccccccc/cc//
!
35 II = ICNTR - 1
  DO J = 1,II
     JQ = II - J + 1
     CEFRAC(JQ) = CEFRAC(JQ+1) * ZRECT(JQ+1) / ZIONT(JQ)
     IF(CEFRAC(JQ).LT.1.E-10_fp*CEFRAC(ICNTR)) exit
  enddo
!
!
42  IF(IPASS.EQ.2)GO TO 49
!
!     END OF FIRST PASS - FIND NEW MAX SPECIES AND ITERATE
!
  IPASS = 2
  ZFRCMXS = 0._fp
  DO JQ = 1, NSPC
     IF(CEFRAC(JQ).LT.ZFRCMX) cycle
     ZFRCMX = CEFRAC(JQ)
     IQFRAC = JQ
  enddo
  ICNTR = IQFRAC
  GO TO 25
!
!
!
49 ZPSUM = 0._fp
  DO JQ = 1, NSPC
     ZPSUM = ZPSUM + CEFRAC(JQ)
  enddo
!
!     NORMALIZE SPECIES FRACTIONS AND COMPUTE RADIATION RATE
!
!
  CERAD = 0._fp
!
  DO JQ = 1, NSPC
     CEFRAC(JQ) = CEFRAC(JQ) / ZPSUM
     IF(ZRADT(JQ) .LE. 0._fp) cycle
     IF(CEFRAC(JQ) .GT. 1.E-37_fp / ZRADT(JQ))&
          CERAD = CEFRAC(JQ) * ZRADT(JQ) + CERAD
!
  enddo
!
!     COMPUTE <Z>
!
  CEAVGZ = 0._fp
  DO JQ = 2,NSPC
     CEAVGZ = CEAVGZ + DBLE(JQ-1) * CEFRAC(JQ)
  enddo
!
!
  RETURN
END SUBROUTINE ADCE
SUBROUTINE ADSET(KNUCZ,IER)
!
!     rev: 12/01 RGA -- added error code as a return value
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     SETUP BASIC ATOMIC STRUCTURE DATA FOR CHOSEN ELEMENT
!     (SHELL POPULATIONS, ENERGIES, ETC.)
!
!     return IER=0 if no errors
!
  use adpak_mod
  save
  integer ier, KNUCZ 
!
  IER=0
  NUCZ = KNUCZ
!
  CALL ADAPN
!
  IF(LADEN .NE. 0 .AND. LADEN .NE. 1) goto 10
  IF(LADEN .EQ. 0) CALL ADMAYR
  IF(LADEN .EQ. 1) CALL ADMORE
!
  IF(LADTIP .NE. 0 .AND. LADTIP .NE. 1) goto 10
  LTIPOK = 0
  IF(LADTIP .EQ. 1) CALL ADTIP(LTIPOK)
!
  CALL ADFNM
!
  RETURN
10 write(LADPOUT,'(A)') "!ADPAK::ADSET(): Argument are incorrect "&
        // "for adpak setup"
  IER=1
  RETURN
END SUBROUTINE ADSET

SUBROUTINE ADAPN
!
!     REV: 10/9/82 FOR NEW AD PACKAGE
!
!     REV: 6/15/78
!
!     INPUT : NUCZ
!     OUTPUT : NSPC, APN, AQN, NVALNC
!
!     ASSIGN THE NUMBER OF ELECTRONS PER SHELL FOR EACH
!     IONIC SPECIES.  APN(JQ,JN) = NUMBER OF ELECTRONS IN
!     SHELL JN FOR SPECIES WITH CHARGE JQ-1, WHILE AQN(JQ,JN) =
!     (2.*JN**2 - APN(JQ,JN))/(2.*JN**2) IS THE FRACTIONAL VACANCY.
!     THE SHELLS ARE FILLED IN SIMPLE CONSECUTIVE ASCENDING ORDER.
!     ALSO, THE PRINCIPAL QUANTUM NUMBER OF THE HIGHEST
!     OCCUPIED ('VALENCE') SHELL FOR EACH SPECIES IS STORED
!     IN NVALNC(JQ).
!
!     NOTE:  FOR THE FULLY IONIZED SPECIES NVALNC IS DEFAULTED TO 1.
!     ALSO: NSPC = NUCZ + 1 IS SET BY THIS ROUTINE
!
!
  use adpak_mod
  save
  integer JQ, ICOUNT, IFULL, ISHELL 
!
!     SET MAXIMUM SPECIES INDEX NSPC = NUCZ + 1
!
  NSPC = NUCZ +1
!
!
  DO JQ = 1,NSPC
     ICOUNT = NUCZ-JQ+1
!
!
     DO JN = 1,10
        IFULL = 2*JN*JN
        ISHELL = MIN0 (ICOUNT,IFULL)
        ICOUNT = ICOUNT - ISHELL
        IF(ISHELL.GT.0) NVALNC(JQ) = JN
        APN(JQ,JN) = DBLE(ISHELL)
        AQN(JQ,JN) = DBLE(IFULL - ISHELL)/DBLE(IFULL)
!
!W    WRITE(LADPOUT,900)JQ,JN,APN(JQ,JN),NVALNC(JQ)
!W  900 FORMAT(1X,'JQ =',I3,' JN =',I3,'  APN=',F4.0,'  NVALNC=',I3)
!
     enddo
!
!
  enddo
!
!
  NVALNC(NSPC) = 1
!
  RETURN
END SUBROUTINE ADAPN
SUBROUTINE ADMORE
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 1 SEPTEMBER 1981
!
!     INPUT : NUCZ, NSPC, APN, NVALNC
!     OUTPUT : EN, EIN, ENM, QN
!
!     EXCITATION ENERGIES AND IONIZATION POTENTIALS ARE
!     TABULATED FOR ALL OCCUPIED SHELLS FOR EACH SPECIES.  ENERGIES
!     ARE IN KEV, JQ = SPECIES INDEX = IONIC CHARGE + 1, AND
!     JN = SHELL INDEX.
!
!     USES THE R. MORE REVISED SHIELDING CONSTANTS (AND NEW
!     CALCULATION PROCEDURE) IN LIEU OF THE ORIGINAL 'XSNQ'
!     TREATMENT BASED ON THE H. MAYER SHIELDING CONSTANTS.
!     (ORIGINAL TREATMENT, REFS. 1-4; PRESENT TREATMENT, REF. 5).
!     CERTAIN ASPECTS OF THE FORMALISM (E.G. QN AND EN ARRAYS) ARE
!     'HISTORICAL' IN NATURE.
!
!
!          SIGMA(JN,JM)   R. MORE SHIELDING CONSTANTS
!
!          QN(JQ,JN)      EFFECTIVE NUCLEAR CHARGE AT SHELL JN
!                         CONSIDERING ALL ELECTRONS IN THE GROUND STATE
!                         ION, NOW COMPUTED FROM ZSEN (RATHER THAN
!                         THAN VICE-VERSA).  THIS IS *NOT* THE
!                         SAME AS QN IN MORE'S NOTATION, WHICH
!                         IS THE SHIELDED CHARGE DUE TO INNER
!                         SHIELDING ONLY.
!
!          EN(JQ,JN)      ENERGY LEVELS FOR RECOMBINATION OF THE
!                         GROUND STATE ION.
!
!          EIN(JQ,JN)     IONIZATION POTENTIAL FOR ELECTRON IN SHELL
!                         JN CALCULATED FROM THE DIFFERENCE IN TOTAL
!                         ION ENERGIES WITH AND WITHOUT AN ELECTRON
!                         REMOVED FROM SHELL JN.
!
!          ENM(JQ,JN,JM)  EXCITATION ENERGY FROM SHELL JN UP TO SHELL
!                         JM CALULATED FROM THE DIFFERENCE IN
!                         THE TOTAL ION ENERGIES OF OF THE GROUND
!                         STATE AND EXCITED STATE ELECTRON POPULATIONS.
!
!          ZBETOT(JQ)     TOTAL BINDING ENERGY FOR EACH ION.
!
!
!     REFERENCES:
!
!     1) POST ET AL., PPPL-1352 (CORRECTED)
!     2) LOKKE AND GRASBERGER, LLL REPORT UCRL-52276 (CORRECTED)
!     3) H. MAYER, 'METHODS OF OPACITY CALCULATIONS', LOS ALAMOS
!        SCIENTIFIC  LABORATORY LA-647 (1947).
!     4) XSNQ LISTING
!     5) R. MORE 'ATOMIC PHYSICS IN INERTIAL CONFINEMENT FUSION -
!        PART I' LLL REPORT UCRL-84991 (1981) (TO APPEAR
!        IN 'APPLIED ATOMIC COLLISION PHYSICS', VOLUME II,
!        ACADEMIC PRESS)
!
!     NOTE: THERE ARE DISCREPANCIES BETWEEN THESE REFERENCES FOR A FEW
!           OF THE H. MAYER SHIELDING CONSTANT VALUES.
!
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
  integer JQ,JJQ,IVALNC,IHOLE,IEXCIT,JN,JM,IIJM,IIJN
!
  real(fp) :: ZSEN(10), ZBETOT(100), ZDUM(10)
  real(fp) :: ZBEIZ,ZBEEX,ZBEREC
!
!
!     MAIN SPECIES LOOP
!
  DO JQ = 1, NSPC
     JJQ = JQ
     IVALNC = NVALNC(JQ)
!
!     COMPUTE ZBETOT AND ZSEN
!
     IHOLE = 0
     IEXCIT = 0
     CALL ADSHEN(JJQ, IHOLE, IEXCIT, ZSEN, ZBETOT(JJQ))
!
!     COMPUTE EIN, ENM, AND EN FROM DIFFERENCES IN TOTAL
!     ION ENERGIES (RATHER FROM ZSEN'S) IN ORDER TO AGREE
!     WITH RESULTS IN MORE'S FIGURE III-7.  COMPUTE
!     QN FROM THE ZSEN IN ORDER TO HAVE THE APPROPRIATE LIMITING
!     INTEGRAL CHARGES AT HIGH N SHELLS.
!
!     CLEAR ARRAYS
!
     DO JN = 1, 5
!
        EIN(JQ,JN) = 0._fp
!
        DO JM = 1, 10
           ENM(JQ,JN,JM) = 0._fp
        enddo
     enddo
!
!     SKIP FULLY STRIPPED STATE
!
     IF(JQ.EQ.NSPC) GO TO 60
!
     DO JN = 1, IVALNC
!
        IHOLE = JN
        IEXCIT = 0
        CALL ADSHEN(JJQ, IHOLE, IEXCIT, ZDUM, ZBEIZ)
        EIN(JQ,JN) = ZBETOT(JQ) - ZBEIZ
!
        IIJM = IVALNC
        IF(JN .EQ. IVALNC .OR. AQN(JQ,IVALNC) .EQ. 0._fp) IIJM = IIJM+1
!
        DO JM = IIJM, 10
           IHOLE = JN
           IEXCIT = JM
           CALL ADSHEN(JJQ, IHOLE, IEXCIT, ZDUM, ZBEEX)
           ENM(JQ,JN,JM) = ZBETOT(JQ) - ZBEEX
        enddo
     enddo
!
!     CLEAR ARRAYS
!
60   EN(JQ,1:10) = 0._fp
     QN(JQ,1:10) = 0._fp
!
!     SKIP NEUTRAL STATE
!
     IF(JQ .EQ. 1) cycle
!
!     COMPUTE EN AND QN
!
     IIJN = IVALNC
     IF(AQN(JQ,IVALNC) .EQ. 0._fp) IIJN = IVALNC+1
!
     DO JN = IIJN, 10
        IHOLE = 0
        IEXCIT = JN
        CALL ADSHEN(JJQ, IHOLE, IEXCIT, ZDUM, ZBEREC)
        EN(JQ,JN) = ZBEREC - ZBETOT(JQ)
        QN(JQ,JN) = DBLE(JN) * SQRT(ZSEN(JN)/0.0136_fp)
     enddo
  enddo
!
  RETURN
END SUBROUTINE ADMORE
!
!---------------------------------------------------------------
!
SUBROUTINE ADSHEN(KQ, KHOLE, KEXCIT, PSEN, PBETOT)
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 1 SEPTEMBER 1981
!
!     INPUT: NUCZ, KQ, KHOLE, KEXCIT, APN
!     OUTPUT: PSEN(10), PBETOT
!
!     COMPUTE SHELL ENERGIES USING NEW SHIELDING CONSTANTS
!     AND METHOD DUE TO R. MORE (UCRL-84991).
!
!     NUCZ = ION NUCLEAR CHARGE
!     KQ = SPECIES INDEX = IONIC CHARGE + 1
!     KHOLE, KEXCIT = ELECTRON REMOVED FROM SHELL KHOLE AND/OR
!                     ADDED (EXCITED) TO SHELL KEXCIT BEFORE
!                     ENERGIES ARE COMPUTED (KHOLE = 0 NO ELECTRON
!                     REMOVED, KEXCIT = 0 NO ELECTRON ADDED)
!     APN(100,10) = ARRAY OF SHELL POPULATIONS
!     PSEN = OUTPUT ARRAY OF SHELL ENERGIES (KEV) (DEFINED POSITIVE)
!     PBETOT = OUTPUT TOTAL ION ENERGY (DEFINED POSITIVE)
!

  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
  integer KQ, KHOLE, KEXCIT,JN,JNM1,JNP1,JM
  real(fp) :: PBETOT
!
  real(fp) :: SIGMOR(10,10) = reshape((/&  
       .3125_fp, 0.9380_fp, 0.9840_fp, 0.9954_fp, 0.9970_fp,&
       .9970_fp, 0.9990_fp, 0.9999_fp, 0.9999_fp, 0.9999_fp,&
       .2345_fp, 0.6038_fp, 0.9040_fp, 0.9722_fp, 0.9979_fp,&
       .9880_fp, 0.9900_fp, 0.9990_fp, 0.9990_fp, 0.9999_fp,&
       .1093_fp, 0.4018_fp, 0.6800_fp, 0.9155_fp, 0.9796_fp,&
       .9820_fp, 0.9860_fp, 0.9900_fp, 0.9920_fp, 0.9999_fp,&
       .0622_fp, 0.2430_fp, 0.5150_fp, 0.7100_fp, 0.9200_fp,&
       .9600_fp, 0.9750_fp, 0.9830_fp, 0.9860_fp, 0.9900_fp,&
       .0399_fp, 0.1597_fp, 0.3527_fp, 0.5888_fp, 0.7320_fp,&
       .8300_fp, 0.9000_fp, 0.9500_fp, 0.9700_fp, 0.9800_fp,&
       .0277_fp, 0.1098_fp, 0.2455_fp, 0.4267_fp, 0.5764_fp,&
       .7248_fp, 0.8300_fp, 0.9000_fp, 0.9500_fp, 0.9700_fp,&
       .0204_fp, 0.0808_fp, 0.1811_fp, 0.3184_fp, 0.4592_fp,&
       .6098_fp, 0.7374_fp, 0.8300_fp, 0.9000_fp, 0.9500_fp,&
       .0156_fp, 0.0624_fp, 0.1392_fp, 0.2457_fp, 0.3711_fp,&
       .5062_fp, 0.6355_fp, 0.7441_fp, 0.8300_fp, 0.9000_fp,&
       .0123_fp, 0.0493_fp, 0.1102_fp, 0.1948_fp, 0.2994_fp,&
       .4222_fp, 0.5444_fp, 0.6558_fp, 0.7553_fp, 0.8300_fp,&
       .0100_fp, 0.0400_fp, 0.0900_fp, 0.1584_fp, 0.2450_fp,&
       .3492_fp, 0.4655_fp, 0.5760_fp, 0.6723_fp, 0.7612_fp/),&
       (/10,10/) )

  real(fp) :: PSEN(*)
  real(fp) :: ZAPN(10), ZQ(10), ZEN0(10)
!
!
  ZAPN(1:10) = APN(KQ,1:10)
!
!     REMOVE ELECTRON FROM SHELL KHOLE
!
  IF(KHOLE .GT. 0 .and. khole.le.10) then
     if(ZAPN(KHOLE) .GT. 0._fp) ZAPN(KHOLE) = ZAPN(KHOLE) - 1.0_fp
  endif
!
!     ADD ELECTRON TO SHELL KEXCIT
!
  IF(KEXCIT .GT. 0) ZAPN(KEXCIT) = ZAPN(KEXCIT) + 1.0_fp
!
!     COMPUTE NUCLEAR CHARGE AS SHIELDED BY INNER ELECTRONS ONLY
!
  DO JN = 1, 10
!
     ZQ(JN) = DBLE(NUCZ) - 0.5_fp * SIGMOR(JN,JN) * ZAPN(JN)
!
     IF(JN .EQ. 1) cycle
     JNM1 = JN - 1
!
     DO JM = 1, JNM1
        ZQ(JN) = ZQ(JN) - SIGMOR(JN,JM) * ZAPN(JM)
     enddo
  enddo
!
!     COMPUTE POTENTIAL DUE TO OUTER ELECTRONS
!
  DO JN = 1, 10
     ZEN0(JN) = 0.0136_fp * SIGMOR(JN,JN) * ZAPN(JN)&
          * ZQ(JN) / (DBLE(JN**2))
!
     IF(JN .EQ. 10) cycle
     JNP1 = JN + 1
!
     DO JM = JNP1, 10
        ZEN0(JN) = ZEN0(JN) + 0.0272_fp * ZAPN(JM) * SIGMOR(JM,JN)&
             * ZQ(JM) / (DBLE(JM**2))
     enddo
  enddo
!
!
!     COMPUTE FINAL SHELL ENERGIES AND TOTAL ION BINDING ENERGY,
!     BOTH DEFINED POSITIVE.
!
  PBETOT = 0._fp
!
  DO JN = 1, 10
     PSEN(JN) = 0.0136_fp * ((ZQ(JN)/DBLE(JN))**2) - ZEN0(JN)
     PBETOT = PBETOT + 0.0136_fp * ZAPN(JN) * ((ZQ(JN)/DBLE(JN))**2) 
  enddo
  RETURN
END SUBROUTINE ADSHEN
SUBROUTINE ADMAYR
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 6/15/78
!
!     INPUT : NUCZ, NSPC, APN
!     OUTPUT : SIGMA, QN, EN, EIN, ENM
!
!     COMPUTES ENERGY LEVELS FOR THE GROUND STATE IONIC SPECIES
!     AND FOR SPECIES WITH SINGLE INNER ELECTRON VACANCIES.
!     EXCITATION ENERGIES AND IONIZATION POTENTIALS ARE THUS
!     TABULATED FOR ALL OCCUPIED SHELLS FOR EACH SPECIES.  ENERGIES
!     ARE IN KEV, JQ = SPECIES INDEX = IONIC CHARGE + 1, AND
!     JN = SHELL INDEX.
!
!     FOR EACH CONFIGURATION AND SHELL OF INTEREST, THE EFFECTIVE
!     NUCLEAR CHARGE IS CALCULATED USING THE H. MAYER SHIELDING
!     CONSTANTS.  THE ENERGY LEVELS ARE THEN FOUND USING THIS EFFECTIVE
!     CHARGE IN THE PAULI APPROXIMATION TO THE DIRAC ENERGY LEVEL
!     FORMULA.  THE SHELL ENERGY IS TAKEN AS THE MEAN OF THE LOWEST
!     AND HIGHEST SUBSHELL ENERGIES FOR THAT N.
!
!
!          SIGMA(JN,JM)   H. MAYER SHIELDING CONSTANTS
!
!          QN(JQ,JN)      EFFECTIVE NUCLEAR CHARGE AT SHELL JN
!                         CONSIDERING ALL ELECTRONS IN THE GROUND STATE ION.
!
!          EN(JQ,JN)      ENERGY LEVELS FOR GROUND STATE ION
!                         (FORMERLY EQN(JQ,JN) IN PREVIOUS VERSIONS)
!
!          EIN(JQ,JN)     IONIZATION POTENTIAL FOR ELECTRON IN SHELL JN;
!                         USES SHIELDED CHARGE CALCULATED WITH ONE
!                         ELECTRON REMOVED FROM SHELL JN.
!
!          ENM(JQ,JN,JM)  EXCITATION ENERGY FROM SHELL JN UP TO SHELL JM;
!                         THE DIFFERENCE BETWEEN THE JN AND JM ENERGY LEVELS
!                         CALCULATED WITH THE JN SHELL ELECTRON REMOVED.
!
!
!
!     REFERENCES:
!
!     1) POST ET AL., PPPL-1352 (CORRECTED)
!     2) LOKKE AND GRASBERGER, LLL REPORT UCRL-52276 (CORRECTED)
!     3) H. MAYER, 'METHODS OF OPACITY CALCULATIONS', LOS ALAMOS
!        SCIENTIFIC  LABORATORY LA-647 (1947).
!     4) XSNQ LISTING
!
!     NOTE: THERE ARE DISCREPANCIES BETWEEN THESE REFERENCES FOR A FEW
!           SHIELDING CONSTANT VALUES.
!
!
!C    DIMENSION ZSIGMA(10,10)       !NOT USED.   M.DIESSO  16 NOV 1994
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
!
  real(fp) :: SIGMAY(10,10) = reshape( (/&
       .625_fp, .938_fp, .981_fp,.987_fp, .994_fp, .997_fp,.999_fp,&
       1.00_fp, 1.00_fp, 1.00_fp,.235_fp, .690_fp, .893_fp,.940_fp,&
       .970_fp, .984_fp, .990_fp,.993_fp, .995_fp, 1.00_fp,.109_fp,&
       .397_fp, .702_fp, .850_fp,.920_fp, .955_fp, .970_fp,.980_fp,&
       .990_fp, 1.00_fp,.0617_fp,.235_fp, .478_fp, .705_fp,.830_fp,&
       .900_fp, .950_fp, .970_fp,.980_fp, .990_fp,.0398_fp,.155_fp,&
       .331_fp, .531_fp, .720_fp,.830_fp, .900_fp, .950_fp,.970_fp,&
       .980_fp,.0277_fp, .109_fp,.239_fp, .400_fp, .580_fp,.735_fp,&
       .830_fp, .900_fp, .950_fp,.970_fp,.0204_fp,.0808_fp,.178_fp,&
       .310_fp, .459_fp, .610_fp,.745_fp, .830_fp, .900_fp,.950_fp,& 
       .0156_fp,.0625_fp, .138_fp,.243_fp, .371_fp, .506_fp,.635_fp,&
       .750_fp, .830_fp, .900_fp,.0123_fp,.0494_fp,.111_fp,.194_fp,&
       .299_fp, .431_fp, .544_fp,.656_fp,  .760_fp,.830_fp,.010_fp,&
       .040_fp, .090_fp, .158_fp,.245_fp, .353_fp ,.460_fp,.576_fp,&
       .670_fp,  .765_fp/),(/10,10/) )
  integer JQ,IVALNC,JN,IN,IIJM,JM,IM
  real(fp) :: ZJN,ZQN,ZQNN,ZQNM
  real(fp) adpali
!
!
!
!
!     START MAIN SPECIES LOOP
!
!
  DO JQ = 1 , NSPC
!
     IVALNC = NVALNC(JQ)
!
!
!     COMPUTE QN AND EN
!
     DO JN = 1 , 10
        ZJN = DBLE(JN)
!
        ZQN = DBLE(NUCZ)
!
        DO JM = 1 , IVALNC
           ZQN = ZQN - SIGMAY(JN,JM) * APN(JQ,JM)
        enddo
!
        ZQN = ZQN + APN(JQ,JN) * SIGMAY(JN,JN) / (2._fp * ZJN**2)
!
        QN(JQ,JN) = ZQN
        IN = JN
        EN(JQ,JN) = ADPALI(ZQN,IN)
     enddo
!
!
!     CLEAR ARRAYS THEN COMPUTE EIN AND ENM
!
!
     EIN(JQ,1:5) = 0._fp
     ENM(JQ,1:5,1:10) = 0._fp
!
!     SKIP IONIZATION AND EXCITATION ENERGIES FOR FULLY STRIPPED ION
!
     IF(JQ .EQ. NSPC) cycle
!
!
     DO JN = 1 , IVALNC
        ZJN = DBLE(JN)
!
!     COMPUTE ZQNN = EFFECTIVE CHARGE AT SHELL JN WITH ONE ELECTRON
!     REMOVED FROM SHELL JN.
!
        ZQNN = QN(JQ,JN) + SIGMAY(JN,JN) * (1._fp - 1._fp/(2._fp*ZJN**2))
!
!     EIN(JQ,JN) = IONIZATION POTENTIAL FOR SHELL JN
!
        IN = JN
        EIN(JQ,JN) = ADPALI(ZQNN,IN)
!
!     COMPUTE ENM(JQ,JN,JM) FROM ZQNM, EFFECTIVE CHARGE AT SHELL
!     JM WITH ONE ELECTRON REMOVED FROM SHELL JN.
!
        IIJM = IVALNC
        IF(JN .EQ. IVALNC .OR.&
             AQN(JQ,IVALNC) .EQ. 0._fp) IIJM = IVALNC + 1
!
        DO JM = IIJM , 10
!
           ZQNM = QN(JQ,JM) + SIGMAY(JM,JN)
!
           IM = JM
           ENM(JQ,JN,JM) = EIN(JQ,JN) - ADPALI(ZQNM,IM)
!
        enddo
     enddo
!
!
!
!
  enddo
!
!
  RETURN
END SUBROUTINE ADMAYR
!
!
!------------------------------------------------------------------
!
!
real(fp) FUNCTION ADPALI(PQ,KN)
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 6/15/78
!
!     EVALUATE THE PAULI APPROXIMATION TO THE
!     THE DIRAC ENERGY LEVEL EQUATION, TAKING THE MEAN OF THE
!     LOWEST AND HIGHEST SUBSHELL ENERGIES TO BE THE SHELL ENERGY.
!     ADPALI(PQ,KN) IS IN KEV,  PQ IS THE EFFECTIVE NUCLEAR
!     CHARGE (IN UNITS OF ELECTRONIC CHARGE) AND KN IS THE PRINCIPAL
!     QUANTUM NUMBER.
!
!
  use iso_c_binding, only: fp => c_double
  implicit none
  save
  real(fp) :: PQ,ZKN,ZALPHA
  integer KN
  ZALPHA = .007298_fp
!
!
  ZKN = DBLE(KN)
!
  ADPALI = .0136_fp * ( (PQ / ZKN)**2 ) *&
       (1._fp + ((ZALPHA*PQ)**2) * (0.5_fp - 1._fp/&
       (4._fp*ZKN))/ZKN)
!
!
  RETURN
END FUNCTION ADPALI
SUBROUTINE ADTIP(KTIPOK)
!
!     SUBSTITUTE TABULATED IONIZATION POTENTIALS FOR THOSE
!     CALCULATED BY SHIELDING CONSTANTS IN SETENM.  NOTE THAT THE
!     'NUMBER OF EQUIVALENT ELECTRONS' IS NOT CORRECTLY RE-DEFINED
!     TO ACCOMPANY THIS PROCEDURE, BUT THE APPROXIMATION IS STILL
!     AN IMPROVEMENT FOR NEAR-NEUTRAL SPECIES.
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
!
  real(fp) :: ZTIP(100)
  integer JSPC,KTIPOK,IVALNC,JSPCP1
!
  ZTIP(1:100) = 0._fp
!
  IF(NUCZ .NE. 2) GO TO 3
!
!     HELIUM
!
  ZTIP(1) = 24.58E-3_fp
  ZTIP(2) = 54.4E-3_fp
!
  GO TO 100
3 IF(NUCZ .NE. 3) GO TO 4
!
!     LITHIUM
!
  ZTIP(1) = 5.4E-3_fp
  ZTIP(2) = 75.6E-3_fp
  ZTIP(3) = 122.4E-3_fp
!
  GO TO 100
!
4 IF(NUCZ .NE. 4) GO TO 5
!
!     BERYLLIUM
!
  ZTIP(1) = 9.32E-3_fp
  ZTIP(2) = 18.2E-3_fp
  ZTIP(3) = 153.9E-3_fp
  ZTIP(4) = 217.6E-3_fp
!
  GO TO 100
!
5 IF(NUCZ .NE. 5) GO TO 6
!
!     BORON
!
  ZTIP(1) = 8.296E-3_fp
  ZTIP(2) = 25.15E-3_fp
  ZTIP(3) = 37.9E-3_fp
  ZTIP(4) = 259.3E-3_fp
  ZTIP(5) = 340.0E-3_fp
!
  GO TO 100
!
6 IF(NUCZ .NE. 6) GO TO 8
!
!     CARBON
!
  ZTIP(1) = 11.3E-3_fp
  ZTIP(2) = 24.4E-3_fp
  ZTIP(3) = 47.9E-3_fp
  ZTIP(4) = 64.5E-3_fp
  ZTIP(5) = 0.392_fp
  ZTIP(6) = 0.490_fp
!
  GO TO 100
8 IF(NUCZ .NE. 8) GO TO 10
!
!     OXYGEN
!
  ZTIP(1) = 13.6E-3_fp
  ZTIP(2) = 35.1E-3_fp
  ZTIP(3) = 54.9E-3_fp
  ZTIP(4) = 77.4E-3_fp
  ZTIP(5) = 0.114_fp
  ZTIP(6) = 0.138_fp
  ZTIP(7) = 0.739_fp
  ZTIP(8) = 0.871_fp
!
  GO TO 100
10 IF(NUCZ .NE. 10) GO TO 13
!
!     NEON
!
  ZTIP(1) = 21.6E-3_fp
  ZTIP(2) = 41.0E-3_fp
  ZTIP(3) = 63.5E-3_fp
  ZTIP(4) = 97.1E-3_fp
  ZTIP(5) = 0.126_fp
  ZTIP(6) = 0.158_fp
  ZTIP(7) = 0.207_fp
  ZTIP(8) = 0.239_fp
  ZTIP(9) = 1.196_fp
  ZTIP(10) = 1.362_fp
!
  GO TO 100
13 IF(NUCZ .NE. 13) GO TO 18
!
!     ALUMINUM
!
  ZTIP(1) = 5.99E-3_fp
  ZTIP(2) = 18.8E-3_fp
  ZTIP(3) = 28.4E-3_fp
  ZTIP(4) = 0.120_fp
  ZTIP(5) = 0.154_fp
  ZTIP(6) = 0.190_fp
  ZTIP(7) = 0.241_fp
  ZTIP(8) = 0.285_fp
  ZTIP(9) = 0.330_fp
  ZTIP(10) = 0.399_fp
  ZTIP(11) = 0.442_fp
  ZTIP(12) = 2.086_fp
  ZTIP(13) = 2.304_fp
!
  GO TO 100
18 IF(NUCZ .NE. 18) GO TO 22
!
!     ARGON
!
  ZTIP(1) = 15.8E-3_fp
  ZTIP(2) = 27.6E-3_fp
  ZTIP(3) = 40.7E-3_fp
  ZTIP(4) = 59.8E-3_fp
  ZTIP(5) = 75.0E-3_fp
  ZTIP(6) = 91.0E-3_fp
  ZTIP(7) = 0.124_fp
  ZTIP(8) = 0.143_fp
  ZTIP(9) = 0.422_fp
  ZTIP(10) = 0.479_fp
  ZTIP(11) = 0.539_fp
  ZTIP(12) = 0.618_fp
  ZTIP(13) = 0.686_fp
  ZTIP(14) = 0.756_fp
  ZTIP(15) = 0.855_fp
  ZTIP(16) = 0.918_fp
  ZTIP(17) = 4.121_fp
  ZTIP(18) = 4.426_fp
!
  GO TO 100
22 IF(NUCZ .NE. 22) GO TO 26
!
!     TITANIUM
!
  ZTIP(1) = 6.82E-3_fp
  ZTIP(2) = 13.6E-3_fp
  ZTIP(3) = 27.5E-3_fp
  ZTIP(4) = 43.3E-3_fp
  ZTIP(5) = 99.2E-3_fp
  ZTIP(6) = 0.119_fp
  ZTIP(7) = 0.141_fp
  ZTIP(8) = 0.169_fp
  ZTIP(9) = 0.193_fp
  ZTIP(10) = 0.216_fp
  ZTIP(11) = 0.265_fp
  ZTIP(12) = 0.292_fp
  ZTIP(13) = 0.787_fp
  ZTIP(14) = 0.861_fp
  ZTIP(15) = 0.940_fp
  ZTIP(16) = 1.042_fp
  ZTIP(17) = 1.131_fp
  ZTIP(18) = 1.220_fp
  ZTIP(19) = 1.342_fp
  ZTIP(20) = 1.425_fp
  ZTIP(21) = 6.249_fp
  ZTIP(22) = 6.626_fp
!
  GO TO 100
26 IF(NUCZ .NE. 26) GO TO 100
!
!     IRON
!
  ZTIP(1) = 7.87E-3_fp
  ZTIP(2) = 16.2E-3_fp
  ZTIP(3) = 30.7E-3_fp
  ZTIP(4) = 54.8E-3_fp
  ZTIP(5) = 75.0E-3_fp
  ZTIP(6) = 99.0E-3_fp
  ZTIP(7) = 0.125_fp
  ZTIP(8) = 0.151_fp
  ZTIP(9) = 0.235_fp
  ZTIP(10) = 0.262_fp
  ZTIP(11) = 0.290_fp
  ZTIP(12) = 0.331_fp
  ZTIP(13) = 0.361_fp
  ZTIP(14) = 0.392_fp
  ZTIP(15) = 0.457_fp
  ZTIP(16) = 0.490_fp
  ZTIP(17) = 1.265_fp
  ZTIP(18) = 1.358_fp
  ZTIP(19) = 1.456_fp
  ZTIP(20) = 1.582_fp
  ZTIP(21) = 1.689_fp
  ZTIP(22) = 1.799_fp
  ZTIP(23) = 1.950_fp
  ZTIP(24) = 2.045_fp
  ZTIP(25) = 8.828_fp
  ZTIP(26) = 9.278_fp
!
!     END OF CURRENT TABULATION; RETURN IF SELECTED
!     ELEMENT NOT PRESENT AND SET FLAG.
!
100 KTIPOK = 0
  IF(ZTIP(1) .EQ. 0._fp) RETURN
!
  KTIPOK = 1
!
  DO JSPC = 1, NUCZ
     IVALNC = NVALNC(JSPC)
     JSPCP1 = JSPC + 1
!
     EIN(JSPC,IVALNC) = ZTIP(JSPC)
     EN(JSPCP1,IVALNC) = ZTIP(JSPC)
  enddo
!
  RETURN
END SUBROUTINE ADTIP
SUBROUTINE ADFNM
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 8/10/79  CORRECT ZEPSNN(59) (4F13) VALUE FROM 3.43E-3
!                   TO 3.43E-2 (ERROR IN POST ET AL.)
!     REV: 6/15/78
!
!     INPUT : NUCZ, APN, AQN, NVALNC, ENM
!     OUTPUT : FNM, FNN, ENN
!
!     CALCULATES ABSORPTION OSCILLATOR STRENGTHS FOR TRANSITIONS
!     FROM SHELL IN TO SHELL IM FOR EACH SPECIES JQ AND STORES THEM
!     IN THE ARRAY FNM(JQ,IN,IM).  F(N,M) = (HYDROGENIC VALUE,
!     TABULATED FOR LOW N,M CALCULATED OTHERWISE) X (CORRECTION
!     FACTOR(S)) X (ELECTRON POPULATION OF SHELL IN) X (VACANY
!     FRACTION OF SHELL IM).
!
!     FOR N - N (E.G. DELTA N EQUAL ZERO) TRANSITIONS WE HAVE
!     F(N,N) = ANN + BNN/ZNUC, WHICH REPRESENTS A FIT TO THE
!     'EQUIVALENT' SINGLE TRANSITION USED TO MODEL ALL THE PHYSICAL
!     N - N TRANSITIONS.  ALSO COMPUTED IS E(N,N), THE 'EQUIVALENT'
!     ENERGY, E(N,N) = EPSILONNN * (ZCHG+1) ** ALPHANN.  THE ZANN, ETC.
!     ARRAYS ARE INDEXED BY THE TOTAL NUMBER OF BOUND ELECTRONS
!     IN THEIR ELECTRONIC CONFIGURATIONS (SEE REFERENCE (1)).
!
!     NOTE THAT HERE, AS IN OTHER ROUTINES, THE FILLING OF SHELLS
!     IN SIMPLE ASCENDING ORDER IS ASSUMED BOTH EXPLICITLY
!     (E.G., IN THE APN ARRAY CONTENTS) AS WELL AS IMPLICITY (THROUGH
!     THE USE OF NVALNC, ETC.).  ALSO, THE ANN, BNN, ETC.
!     COEFFICIENTS ARE DEFINED SPECIFICALLY FOR SUCH STATES.
!
!
!     REFERENCES:
!     1) POST ET AL., PPPL-1352 (WITH CORRECTIONS)
!     2) GRASBERGER, XSNQ - TOKAMAK MEMORANDUM #4, 7/29/76
!     3) GRASBERGER, XSNQ - TOKAMAK MEMORANDUM #10, 1/5/77
!     4) LOKKE & GRASBERGER, 'XSNQ-U A NON-LTE EMISSION AND
!        ABSORPTION COEFFICIENT SUBROUTINE', LLL REPORT UCRL-52276
!     5) MERTS ET AL., 'THE CALCULATED POWER OUTPUT FROM
!        A THIN IRON-SEEDED PLASMA', LOS ALAMOS REPORT LA-6220-MS
!     6) XSNQ FORTRAN LISTING
!
!
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
!
!
!
  integer i
  real(fp) :: ZANN(60) = (/ 0._fp, 0._fp,&
       -.02_fp, -.01_fp, -.04_fp,  .04_fp, -.01_fp, -.01_fp,  .01_fp,&
       0._fp,  .01_fp,   .1_fp,  .25_fp,  .17_fp,  .08_fp, -.02_fp,&
       -.14_fp, -.27_fp, -.29_fp,  -.3_fp,  -.3_fp, -.29_fp, -.27_fp,&
       -.24_fp,  -.2_fp, -.14_fp, -.08_fp,   0._fp,  .97_fp, 1.96_fp,&
       1.92_fp, 1.89_fp, 1.86_fp, 1.83_fp, 1.78_fp, 1.73_fp, 1.41_fp,&
       1.05_fp, .674_fp, .261_fp,-.167_fp,-.637_fp,-1.14_fp,-1.67_fp,&
       -2.26_fp,-2.88_fp, -2.9_fp,-2.83_fp,-2.72_fp,-2.61_fp,-2.45_fp,&
       -2.27_fp,-2.05_fp,-1.81_fp,-1.55_fp,-1.25_fp, -.94_fp, -.63_fp,&
       -.31_fp, 0._fp /)
!
!
  real(fp) :: ZBNN(60) =  (/ 0._fp, 0._fp,&
       2._fp, 4.33_fp, 4.68_fp,  3.6_fp, 2.85_fp,  2.4_fp,&
       1.3_fp,   0._fp, 10.5_fp,  20._fp, 16.4_fp, 24.7_fp,&
       34.1_fp, 44.8_fp, 56.8_fp, 70.3_fp, 68.6_fp, 65.8_fp,&
       61.9_fp, 56.9_fp, 50.7_fp, 45.5_fp, 34.4_fp, 24.2_fp,&
       12.8_fp,   0._fp,-25.8_fp,-53.1_fp,-28.1_fp,-2.97_fp,&
       23._fp, 50.3_fp, 79.1_fp,109.2_fp,141.7_fp, 176._fp,&
       213.9_fp,256.6_fp,299.6_fp,348.2_fp,400.5_fp,456.6_fp,&
       518.1_fp,584.0_fp,571.9_fp,550.7_fp,524.9_fp,496.8_fp,&
       463.4_fp, 427._fp,385.3_fp,339.8_fp,291.3_fp,237.4_fp,&
       181.3_fp,122.9_fp, 62.2_fp,   0._fp /)
!
!
  real(fp) :: ZEPSNN(60) = (/ 0._fp, 0._fp,&
       2.04E-3_fp, 4.49E-3_fp,  6.8E-3_fp, 8.16E-3_fp, 6.80E-3_fp,&
       1.06E-2_fp, 1.31E-2_fp,      0._fp,  2.3E-3_fp, 3.88E-3_fp,&
       5.71E-3_fp, 5.44E-3_fp, 8.16E-3_fp,  6.8E-3_fp,  8.3E-3_fp,&
       4.32E-3_fp, 5.11E-3_fp, 6.04E-3_fp, 7.08E-3_fp,&
       8.12E-3_fp, 9.69E-3_fp, 1.13E-2_fp, 1.37E-2_fp,  1.49E-2_fp,&
       1.71E-2_fp,      0._fp, 1.52E-5_fp, 1.93E-5_fp,&
       5.62E-5_fp, 1.20E-4_fp, 2.13E-4_fp, 3.34E-4_fp,  4.66E-4_fp,&
       6.66E-4_fp, 9.10E-4_fp, 1.25E-3_fp, 1.69E-3_fp,  1.98E-3_fp,&
       3.03E-3_fp, 3.92E-3_fp, 5.19E-3_fp, 6.40E-3_fp,  8.05E-3_fp,&
       9.80E-3_fp, 1.08E-2_fp, 1.19E-2_fp, 1.32E-2_fp,  1.47E-2_fp,&
       1.59E-2_fp, 1.81E-2_fp, 1.92E-2_fp, 2.10E-2_fp,  2.33E-2_fp,&
       2.57E-2_fp, 2.82E-2_fp, 3.10E-2_fp, 3.43E-2_fp,        0._fp /)
!
!
  real(fp) :: ZALPNN(60) = (/ 1.0_fp, 1.0_fp,&
       1.0_fp, .93_fp, .86_fp, .80_fp, .87_fp, .77_fp, .77_fp, 1.0_fp,&
       .99_fp, .90_fp, .83_fp, .87_fp, .77_fp, .82_fp, .79_fp,1.06_fp,&
       1.03_fp,  1._fp, .97_fp, .94_fp, .91_fp, .88_fp, .85_fp,&
       .83_fp, .80_fp, 1.0_fp,2.46_fp, 2.4_fp,2.14_fp,1.96_fp,&
       1.83_fp,1.72_fp,1.64_fp,1.57_fp,1.49_fp,1.41_fp,1.34_fp,&
       1.30_fp,1.19_fp,1.13_fp,1.06_fp,1.01_fp, .95_fp, .91_fp,&
       .89_fp, .87_fp, .85_fp, .83_fp, .82_fp, .80_fp, .78_fp, .76_fp,&
       .74_fp, .72_fp, .70_fp, .68_fp, .66_fp, 1.0_fp/)
!
!
  real(fp) :: ZY0(10) = (/ 1.0_fp, .511_fp, .400_fp,(.230_fp, i=1,7)/)
!
  real(fp) :: ZY1(10) = (/ 0._fp,.116_fp,.0228_fp,(.00844_fp, i=1,7)/)
!
  real(fp) :: ZY2(10) = (/ 0._fp,-.00689_fp,.000596_fp,&
       (.000488_fp, i=1,7) /)

  integer JQ,JN,JM,IBOUND,IVALNC,IIJM,INDEX
  real(fp) :: ZNUC,ZCHG,ZN,ZM,ZRATIO,ZNCHG,ZEHYDR,ZYNPN
!

!
!     *********************************************************
!
!
!     ZERO OSCILLATOR STRENGTH ARRAYS AND ENN ARRAY
!
  FNN(1:100) = 0._fp
  ENN(1:100) = 0._fp
  FNM(1:100,1:5,1:10) = 0._fp
!
  ZNUC = DBLE ( NUCZ )
!
!
!     ******************************************************
!     ***** LOOP FOR ALL SPECIES EXCEPT FULLY STRIPPED *****
!     ******************************************************
!
!
  DO JQ = 1 , NUCZ
!
     ZCHG = DBLE(JQ-1)
     IBOUND = NUCZ - JQ + 1
     IVALNC = NVALNC(JQ)
!
!
!     ********** CALCULATE F(N,M) ( M > N ) **********
!
!
!     BEGIN BY EVALUTING HYDROGENIC F(N,M) EQUATION, WITH
!     EXPLICIT VALUES SUBSTITUTED FOR N < 5, M <= 5.
!
!
     DO JN = 1 , IVALNC
        IIJM = MAX0 ( JN + 1 , IVALNC )
        ZN = DBLE(JN)
!
        DO JM = IIJM , 10
           ZM = DBLE(JM)
           FNM(JQ,JN,JM) = 1.96_fp * ZN * ( ( ZM/(ZM*ZM - ZN*ZN) )**3 )
        enddo
     enddo
!
!     SUBSTITUTE TABLED VALUES FOR LOW N , M AS PER REF #4
!
     FNM(JQ,1,2) = 0.4161_fp
     FNM(JQ,1,3) = 0.0792_fp
     FNM(JQ,1,4) = 0.0290_fp
     FNM(JQ,1,5) = 0.0139_fp
     FNM(JQ,2,3) = 0.6370_fp
     FNM(JQ,2,4) = 0.1190_fp
     FNM(JQ,2,5) = 0.0443_fp
     FNM(JQ,3,4) = 0.8408_fp
     FNM(JQ,3,5) = 0.1499_fp
     FNM(JQ,4,5) = 1.037_fp
!
!     MODIFY NONZERO F(N,N+1) VALUES FOR N > 1 AS PER REF #3
!
     DO J = 1 , 2
        JN = IVALNC + J - 2
        IF(JN .LE. 1) cycle
        JM = JN + 1
        IF(AQN(JQ,JM) .EQ. 0._fp) cycle
!
        ZNCHG = ZCHG + APN(JQ,JM)
        ZEHYDR = .0136_fp * ((ZNCHG+1._fp)**2) *&
             ( 1._fp/DBLE(JN)**2 - 1._fp/DBLE(JM)**2 )
        ZRATIO = ZEHYDR / ENM(JQ,JN,JM)
        IF(ZRATIO .GT. 1.0_fp) ZRATIO = 1.0_fp
        ZYNPN = ZY0(JN) + ZY1(JN) * APN(JQ,JN) + ZY2(JN) * APN(JQ,JN)**2
!
        FNM(JQ,JN,JM) = FNM(JQ,JN,JM) * ZRATIO * ZYNPN
!
     enddo
!
!
!     MULTIPLY BY ELECTRON POPULATION OF SHELL N AND FRACTIONAL
!     VACANCY OF SHELL M
!
!
     DO JN = 1 , 5
        DO JM = 1 , 10
           FNM(JQ,JN,JM) = APN(JQ,JN) * AQN(JQ,JM) * FNM(JQ,JN,JM)
        enddo
     enddo
!
!
!
!     ***** CALCULATE N - N 'EFFECTIVE' OSCILLATOR STRENGTHS *****
!                   ***** AND TRANSITION ENERGIES *****
!
!
!
     INDEX = IBOUND
!     IF MORE THAN 60 BOUND ELECTRONS USE CONSTANTS FOR ION WITH
!     32 FEWER ELECTRONS
     IF(INDEX.GT.60)INDEX = INDEX - 32
     IF(INDEX.GT.60)INDEX = INDEX - 32
!
     FNN(JQ) = ZANN(INDEX) + ZBNN(INDEX) / ZNUC
!
     ENN(JQ) = ZEPSNN(INDEX) * (ZCHG + 1._fp)**ZALPNN(INDEX)
!
!
!
!
!     CHECK TO INSURE ALL F VALUES ARE POSITIVE
!
     IF(FNN(JQ) .GE. 0._fp) GO TO 40
     FNN(JQ) = 0._fp
     write(LADPOUT,'(A)') '! ADPAK::ADFNM()'
     write(LADPOUT,'(A,I2)') '  nuclear Z = ', nucz
     WRITE(LADPOUT,900) JQ , IVALNC , IVALNC
900  FORMAT(1X,26H***** NEGATIVE F VALUE AT ,3I4,6H *****)
40   DO JN = 1 , 5
        DO JM = 1 , 10
           IF(FNM(JQ,JN,JM) .GE. 0._fp) cycle
           FNM(JQ,JN,JM) = 0._fp
           write(LADPOUT,'(A)') '! ADPAK::ADFNM()'
           write(LADPOUT,'(A,I2)') '  nuclear Z = ', nucz
           WRITE(LADPOUT,900) JQ , JN , JM
        enddo
     enddo
!
!     DIAGNOSTIC WRITE STATMENTS TO DISPLAY F VALUES
!
!W    WRITE(LADPOUT,901)JQ,FNN(JQ),ENN(JQ)
!W  901 FORMAT(/1X,'SETFNM: JQ =',I3,'  FNN =',1PE9.2,'  ENN =',E9.2)
!W    WRITE(LADPOUT,902)( JN,(FNM(JQ,JN,JM),JM=1,10),JN=1,5)
!W  902 FORMAT(1X,'JN =',I2,10F6.1)
!
!
!     *************** END OF JQ SPECIES LOOP ***************
!
!
  enddo
!
  RETURN
END SUBROUTINE ADFNM
SUBROUTINE ADERC(PTE,PNE)
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp) :: pte,pne
!
!     CALL ELECTRON RATE COEFFICIENT ROUTINES
!
  CALL ADECI(PTE,PNE)  ! fill RCLION, CIZLOS
  CALL ADDREC(PTE,PNE) ! fill RDIREC, RADDRC
  CALL ADRREC(PTE,PNE) ! fill RRAREC, RADRRC
  CALL ADECEX(PTE,PNE) ! fill RADCLX
  CALL ADBREM(PTE,PNE) ! fill RADBRM
!
  RETURN
END SUBROUTINE ADERC
SUBROUTINE ADECI(PTE, PNE)
!
!     CALCULATE THE ELECTRON COLLISIONAL IONIZATION RATE USING
!     THE FORMULAS SELECTED BY THE LECI SWITCH.  LECIOK RETURNS
!     THE RATE FORMULAS ACTUALLY USED, WHICH MAY DIFFER FROM
!     LECI IF LECI WAS SET INAPPROPRIATELY FOR THE GIVEN ELEMENT.
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
  real(fp) :: pte,pne
  integer ILMAX,IFLAG
!
!     ILMAX = CURRENT MAXIMUM NUMBER OF RATE OPTIONS
!
  ILMAX = 3
!
!     CHECK FOR VALID LECI; RETURN LECI = 1 OPTION IF NOT VALID
!
  IF(LECI .LT. 1 .OR. LECI .GT. ILMAX) GO TO 10
!
  GO TO (10, 20, 30) LECI
!
!     LECI = 1; USE XSNQ DERIVED IONIZATION RATE CALCULATION
!
10 CALL ADXECI(PTE, PNE)
  LECIOK = 1
  RETURN
!
!     LECI = 2; USE BELFAST GROUP LIGHT ELEMENT RATE FITS
!
20 CALL ADBFI(NUCZ, PTE, PNE, RCLION, CIZLOS, IFLAG)
  IF(IFLAG .NE. 0) GO TO 10
  LECIOK = 2
  RETURN
!
!     LECI = 3; USE YOUNGER'S RATES FOR AVAILABLE ELEMENTS AND SHELLS,
!               XSNQ RATES OTHERWISE ON A CHARGE STATE-BY-CHARGE STATE
!               BASIS
!
30 CALL ADXECI(PTE, PNE)
  CALL ADYGR(NUCZ, PTE, PNE, RCLION, CIZLOS, IFLAG)
  LECIOK = 3
  IF(IFLAG .NE. 0) LECIOK = 1
  RETURN
!
!
!
END SUBROUTINE ADECI
SUBROUTINE ADXECI(PTE, PNE)
!
!     REV: 3/30/83 ADECI --> ADXECI TO ACCOMODATE ALTERNATIVE RATES
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 6/15/78
!
!     COMPUTES THE XSNQ-DERIVED COLLISIONAL IONIZATION RATES RCLION
!     AT THE ELECTRON TEMPERATURE PTE (KEV), WHERE JQ=(IONIC CHARGE+1).
!     THESE RATES HAVE THE UNITS (SEC-1).
!
!     NOTES:
!
!     1) ELECTRONS ARE ASSUMED TO FILL IONIC SHELLS IN SIMPLE ASCENDING
!        ORDER.  THIS IS ASSUMED BOTH EXPLICITLY (THE APN ARRAY)
!        AS WELL AS IMPLICITLY THROUGH THE USE OF NVALNC VALUES
!        IN LOOP INDICES, ETC.
!     2) THROUGH USE OF THE FUNCTION EXPUND, EXP(X) IS SET EQUAL TO
!        ZERO IN THE RATE EQUATIONS FOR VALUES OF X < -45.
!     3) RATES FOR THE SPECIES JQ REFER TO TRANSFORMATIONS OF
!        THAT SPECIES INTO ADJACENT IONIZATION STATES, NOT THE
!        RATES AT WHICH THAT SPECIES IS FORMED.
!
!
!     PRINCIPAL PHYSICS REFERENCES:
!
!     1) POST, JENSEN, TARTER, GRASBERGER, LOKKE, 'STEADY STATE
!        RADIATIVE COOLING RATES FOR LOW-DENSITY HIGH-TEMPERATURE
!        PLASMAS', PPPL-1352 (SUB. TO N.F.) (WITH CORRECTIONS)
!     2) LOKKE AND GRASBERGER, 'XSNQ-U A NON-LTE EMISSION AND
!        ABSORPTION COEFFICIENT SUBROUTINE', LLL REPORT UCRL-52276
!        (WITH CORRECTIONS).
!     3) XSNQ FORTRAN LISTING
!
!
!
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  real(fp) :: pte,pne,ZJLKEV,ZTE,ZCHG,ZISUM,ZESUM,ZJN,ZXN,ZY,ZFY
  real(fp) :: ZGAUNT,ZITEMP  
  real(fp) :: EXPUND
  integer JQ,IVALNC,JN
  save
!
!
  ZJLKEV = 1.6021E-16_fp
!
!
  ZTE = PTE
!
  DO JQ = 1 , NUCZ
!
     ZCHG = DBLE(JQ - 1)
     IVALNC = NVALNC(JQ)
!
!
!
!     ******************** IONIZATION RATE ********************
!
!
!     CALCULATE ELECTRON COLLISIONAL IONIZATION RATES PER SHELL
!     AND SUM FOR ALL POPULATED SHELLS. ALSO COMPUTE
!     IONIZATION ENERGY LOSS RATE CIZLOS.
!
     ZISUM = 0._fp
     ZESUM = 0._fp
!
     DO JN = 1 , IVALNC
        ZJN = JN
        ZXN = EIN(JQ,JN)/ZTE
!
        ZY = DLOG10(ZXN/4._fp)
        ZFY = .23_fp + .046_fp * ZY + .1074_fp * ZY**2&
             - .0459_fp * ZY**3 - .01505_fp * ZY**4
        ZGAUNT = 12.18_fp * DEXP(-ZJN /(ZJN+5._fp))*&
             (1._fp + .0335_fp*ZJN)&
             * (1._fp - .622_fp/(ZCHG+1._fp)-&
             .0745_fp/(ZCHG+1._fp)**2) * ABS(ZFY)
        ZITEMP = APN(JQ,JN) * EXPUND(-ZXN,-45._fp) *&
             (1._fp-EXPUND(-ZXN,-45._fp)) * ZGAUNT / EIN(JQ,JN)**2
        ZISUM = ZISUM + ZITEMP
        ZESUM = ZESUM + EIN(JQ,JN) * ZITEMP
     enddo
!
     ZISUM = ZISUM * SQRT(ZTE)
     ZESUM = ZESUM * SQRT(ZTE)
     IF(ZISUM .LT. 1.E-26_fp) ZISUM = 0._fp
     IF(ZESUM .LT. 1.E-26_fp) ZESUM = 0._fp
     RCLION(JQ) = PNE * 3.44E-11_fp * ZISUM
     CIZLOS(JQ) = PNE * ZJLKEV * 3.44E-11_fp * ZESUM
!
!
  enddo
!
!
  RCLION(NUCZ + 1) = 0._fp
  CIZLOS(NUCZ + 1) = 0._fp
!
!
  RETURN
END SUBROUTINE ADXECI
SUBROUTINE ADBFI(KNUCZ, PTE, PNE, PBFI, PBFIL, KFLAG)
!
!     CALCULATE THE ELECTRON COLLISIONAL IONIZATION RATE COEFFICIENTS
!     USING FITTING FORMULAS FROM THE BELFAST GROUP, CULHAM
!     REPORT CLM-R216 (DECEMBER 1981):
!
!          ATOMIC AND MOLECULAR DATA FOR FUSION, PART I
!
!          RECOMMENDED CROSS SECTIONS AND RATES FOR ELECTRON
!          IONISATION OF LIGHT ATOMS AND IONS
!
!          K L BELL, H B GILBODY, J G HUGHES, A E KINGSTON, F J SMITH
!          THE QUEEN'S UNIVERSITY OF BELFAST, BELFAST, N IRELAND
!
!     KNUCZ = ELEMENT ATOMIC NUMBER ( Z=1 TO Z=8 ONLY)
!     PTE = ELECTRON TEMPERATURE (KEV)
!     PNE = ELECTRON DENSITY (CM-3)
!
!     PBFI = IONIZATION RATES FOR THE Z+1 CHARGE STATES (SEC-1)
!     PBFIL = ARRAY OF IONIZATION ENERGY LOSS RATES (WATTS/ION)
!     KFLAG = 0 FOR O.K., = 1 FOR INVALID ELEMENT
!
!
!
  use iso_c_binding, only: fp => c_double
  implicit none
  save
  real(fp)  PBFI(*), PBFIL(*)
  real(fp) :: PTE, PNE
  integer KNUCZ,KFLAG,INSPC,JSPC,alloc_stat
!
!----------------------------------------------------------------------
!
!     HYDROGEN
!
  real(fp) :: EH(1) = 13.60_fp 
  real(fp) :: AH(6) = (/ 2.3742E-8_fp, -3.6866E-9_fp, -1.0366E-8_fp,&
       -3.8010E-9_fp,  3.4159E-9_fp,  1.6834E-9_fp /)
  real(fp) :: AAH = 2.4617E-8_fp 
  real(fp) :: BTH(3) = (/9.5986E-8_fp, -9.2463E-7_fp, 3.9973E-6_fp /)
!
!     HELIUM
!
  real(fp) :: EHE(2) = (/ 24.6_fp, 54.42_fp /)
  real(fp) :: AHE(6,2) = reshape( (/ 1.4999E-8_fp, 5.6656E-10_fp, &
       -6.0821E-9_fp, -3.5894E-9_fp,  1.5529E-9_fp,& 
       1.3207E-9_fp,  3.4356E-9_fp, -1.6865E-9_fp,&
       -6.9236E-10_fp, 9.7863E-11_fp, 1.5591E-10_fp,&
       6.2236E-11_fp /), (/6,2/) )
  real(fp) :: AAHE(2) = (/ 3.1373E-8_fp, 3.0772E-9_fp /)
  real(fp) :: BTHE(3,2) = reshape( (/ 4.7893E-8_fp, -7.7359E-7_fp, &
       3.7366E-6_fp,1.1902E-8_fp, -1.1514E-7_fp, &
       5.0489E-7_fp /), (/3,2/) )
!
!     LITHIUM
!
  real(fp) :: ELI(3) = (/ 5.39_fp, 75.64_fp, 122.45_fp /)
  real(fp) :: ALI(6,3) = reshape((/ 9.9655E-8_fp, -5.5941E-8_fp,&
       -5.5228E-8_fp,4.0589E-8_fp, 1.4800E-8_fp,&
       -1.3120E-8_fp,3.4023E-9_fp, -7.6588E-10_fp,&
       -8.6078E-10_fp,-8.9748E-10_fp, 4.1661E-10_fp,&
       3.3188E-10_fp, 1.1786E-9_fp, -8.7637E-10_fp,&
       -9.3373E-11_fp,2.1137E-10_fp, 1.9017E-11_fp,&
       -4.0679E-11_fp/),(/6,3/))
  real(fp) :: AALI(3) = (/4.5456E-8_fp,7.3504E-9_fp,1.9767E-9_fp/)
  real(fp) :: BTLI(3,3) = reshape((/2.7800E-7_fp, -1.5830E-6_fp,&
       5.4650E-6_fp,5.3459E-10_fp, -5.6387E-8_fp,& 
       2.9577E-7_fp,-1.0926E-9_fp, 8.8700E-10_fp, &
       6.0764E-9_fp/), (/3,3/))
!
!     BERYLLIUM
!
  real(fp) :: EBE(4) = (/ 9.32_fp, 18.21_fp, 153.89_fp, 217.71_fp /)
  real(fp) :: ABE(6,4) = reshape( (/ 7.4206E-8_fp, -1.5520E-8_fp,& 
       -3.9403E-8_fp,&
       7.2155E-9_fp, 1.1098E-8_fp, -2.5501E-9_fp,&
       1.7136E-8_fp, -1.3997E-8_fp, -2.9656E-11_fp,&
       3.0777E-9_fp, -1.1676E-10_fp, -5.1930E-10_fp,&
       1.6039E-9_fp, -6.4336E-10_fp, -7.7804E-10_fp,&
       3.3527E-10_fp, 2.1889E-10_fp, -1.0600E-10_fp,&
       4.9587E-10_fp, -3.6870E-10_fp, -3.9284E-11_fp,&
       8.8928E-11_fp, 8.0007E-12_fp, -1.7114E-11_fp/),&
       (/6,4/) )
  real(fp) :: AABE(4) = (/ 2.1732E-7_fp, 2.7494E-8_fp, 2.7873E-9_fp, &
       8.3163E-10_fp /)
  real(fp) :: BTBE(3,4) = reshape( (/ -2.1649E-7_fp, 2.8120E-7_fp,& 
       5.3031E-7_fp,&
       -1.5900E-8_fp, 2.5911E-8_fp, 2.4061E-8_fp,&
       -2.4333E-10_fp, -9.7973E-9_fp, 5.2094E-8_fp,&
       -4.5966E-10_fp, 3.7317E-10_fp, 2.5564E-9_fp /),&
       (/3,4/) )
!
!     BORON
!
  real(fp) :: EB(5) = (/ 8.3_fp, 25.15_fp, 37.93_fp, 259.37_fp,& 
       340.22_fp /)
  real(fp) :: AB(6,5) = reshape( (/ 5.8365E-8_fp, 1.0047E-8_fp,& 
       -3.6230E-8_fp,&
       -7.3448E-9_fp, 1.0220E-8_fp, 1.6951E-9_fp,&
       2.0590E-8_fp, -9.8899E-9_fp, -6.0949E-9_fp,&
       2.7762E-9_fp, 1.6499E-9_fp, -6.7692E-10_fp,&
       5.7023E-9_fp, -4.6578E-9_fp, -9.8688E-12_fp,&
       1.0242E-9_fp, -3.8855E-11_fp, -1.7281E-10_fp,&
       7.3539E-10_fp, -2.9498E-10_fp, -3.5672E-10_fp,&
       1.5372E-10_fp, 1.0036E-10_fp, -4.8602E-11_fp,&
       2.5458E-10_fp, -1.8930E-10_fp, -2.0169E-11_fp,&
       4.5657E-11_fp, 4.1076E-12_fp, -8.7867E-12_fp/),(/6,5/))
  real(fp) :: AAB(5) = (/3.0952E-7_fp, 4.7980E-8_fp, 9.1493E-9_fp, &
       1.2780E-9_fp, 4.2697E-10_fp/)
  real(fp) :: BTB(3,5) = reshape((/ -4.9240E-7_fp, 1.3750E-6_fp,&
       -2.5387E-6_fp,&
       -4.1361E-8_fp, 5.5259E-8_fp, 9.9841E-8_fp,&
       -5.2910E-9_fp, 8.6226E-9_fp, 8.0067E-9_fp,&
       -1.1156E-10_fp, -4.4920E-9_fp, 2.3885E-8_fp,&
       -2.3600E-10_fp, 1.9159E-10_fp, 1.3125E-9_fp/),&
       (/3,5/))
!
!     CARBON
!
  real(fp) :: EC(6) = (/ 11.26_fp, 24.38_fp, 47.89_fp, 64.49_fp,& 
       392.08_fp, 489.98_fp/)
  real(fp) :: AC(6,6) = reshape((/ 5.9848E-8_fp, 1.1903E-8_fp,&
       -3.0140E-8_fp,&
       -1.3693E-8_fp, 8.3748E-9_fp, 4.0150E-9_fp,&
       2.8395E-8_fp, -1.6698E-8_fp, -2.3557E-9_fp,&
       3.2161E-10_fp, 9.6016E-10_fp, 5.2713E-10_fp,&
       9.0555E-9_fp, -6.3206E-9_fp, -1.3256E-9_fp,&
       1.7441E-9_fp, 3.2680E-10_fp, -3.8303E-10_fp,&
       2.7464E-9_fp, -2.0070E-9_fp, -2.3595E-11_fp,&
       4.2011E-10_fp, -8.1600E-11_fp, -3.9729E-11_fp,&
       3.9495E-10_fp, -1.5842E-10_fp, -1.9158E-10_fp,&
       8.2555E-11_fp, 5.3899E-11_fp, -2.6102E-11_fp,&
       1.4715E-10_fp, -1.0941E-10_fp, -1.1657E-11_fp,&
       2.6389E-11_fp, 2.3742E-12_fp, -5.0786E-12_fp/),&
       (/6,6/))
  real(fp) :: AAC(6) = (/ 3.7442E-7_fp, 6.0150E-8_fp, 1.4501E-8_fp,&
       6.0330E-9_fp, 6.8634E-10_fp, 2.4679E-10_fp /)
  real(fp) :: BTC(3,6) = reshape( (/ -6.5826E-7_fp, 2.0521E-6_fp, &
       -4.4694E-6_fp,&
       -4.0217E-8_fp, -2.7908E-8_fp, 5.5499E-7_fp,&
       -5.3596E-9_fp, -1.0473E-8_fp, 1.0629E-7_fp,&
       -5.7710E-9_fp, 9.9302E-9_fp, 7.4462E-9_fp,&
       -5.9916E-11_fp, -2.4124E-9_fp, 1.2828E-8_fp,&
       -1.3640E-10_fp, 1.1074E-10_fp, 7.5862E-10_fp /),&
       (/3,6/) )
!
!     NITROGEN
!
  real(fp) :: EN(7) = (/ 14.53_fp, 29.60_fp, 47.45_fp, 77.47_fp, & 
       97.89_fp, 552.06_fp,667.03_fp /)
  real(fp) :: AN(6,7) = reshape( (/ 4.6209E-8_fp, 9.2264E-9_fp, &
       -1.2092E-8_fp,&
       -2.4852E-8_fp, 5.1361E-9_fp, 8.3068E-9_fp,&
       2.4369E-8_fp, -2.2155E-9_fp, -1.4805E-8_fp,&
       -4.4218E-10_fp, 4.5211E-9_fp, 1.7874E-10_fp,&
       1.2964E-8_fp, -8.3408E-9_fp, -2.3684E-9_fp,&
       2.2485E-9_fp, 2.6234E-10_fp, -2.6333E-10_fp,&
       4.6322E-9_fp, -3.4645E-9_fp, -3.1014E-10_fp,&
       8.0576E-10_fp, 5.7791E-11_fp, -1.4907E-10_fp,&
       1.5862E-9_fp, -9.8633E-10_fp, 7.5130E-11_fp,&
       3.1005E-11_fp, -8.1970E-12_fp, 2.6759E-11_fp,&
       2.3635E-10_fp, -9.4805E-11_fp, -1.1465E-10_fp,&
       4.9404E-11_fp, 3.2255E-11_fp, -1.5620E-11_fp,&
       9.2653E-11_fp, -6.8892E-11_fp, -7.3402E-12_fp,&
       1.6616E-11_fp, 1.4949E-12_fp, -3.1978E-12_fp /),&
       (/6,7/) )
  real(fp) :: AAN(7) = (/ 2.7367E-7_fp, 4.4690E-8_fp, 1.0243E-8_fp,&
       7.9743E-9_fp, 5.7812E-9_fp, 4.1073E-10_fp,&
       1.5539E-10_fp /)
  real(fp) :: BTN(3,7) = reshape( (/ -4.2976E-7_fp, 9.8352E-7_fp, &
       -9.5745E-7_fp,&
       3.0430E-8_fp, -5.2696E-7_fp, 2.4863E-6_fp,&
       3.4218E-8_fp, -2.9155E-7_fp, 1.2324E-6_fp,&
       -4.9184E-9_fp, 6.3763E-9_fp, 1.4917E-8_fp,&
       -8.5163E-9_fp, 1.8527E-8_fp, -7.8181E-9_fp,&
       -3.5856E-11_fp, -1.4437E-9_fp, 7.6765E-9_fp,&
       -8.5888E-11_fp, 6.9728E-11_fp, 4.7767E-10_fp /),&
       (/3,7/) )
!
!     OXYGEN
!
  real(fp) :: EO(8) = (/ 13.62_fp, 35.12_fp, 54.93_fp, 77.41_fp,&
       113.90_fp, 138.12_fp, 739.32_fp,871.39_fp /)
  real(fp) :: AO(6,8) = reshape( (/ 3.3559E-8_fp, 1.3449E-8_fp, &
       -6.7112E-9_fp,&
       -1.9976E-8_fp, 1.6214E-9_fp, 6.5852E-9_fp,&
       2.4476E-8_fp, -5.3141E-9_fp, -7.3316E-9_fp,&
       -4.4515E-9_fp, 2.4257E-9_fp, 1.9791E-9_fp,&
       1.4741E-8_fp, -8.7905E-9_fp, -8.6099E-10_fp,&
       -2.4143E-10_fp, 1.2598E-10_fp, 6.4901E-10_fp,&
       6.2130E-9_fp, -2.5047E-9_fp, -3.0813E-9_fp,&
       1.3559E-9_fp, 8.6816E-10_fp, -4.3189E-10_fp,&
       2.6145E-9_fp, -2.0276E-9_fp, -1.6569E-10_fp,&
       5.0245E-10_fp, 3.0067E-11_fp, -9.8231E-11_fp,&
       1.0099E-9_fp, -6.5165E-10_fp, 2.8863E-12_fp,&
       3.0336E-11_fp, -1.4065E-11_fp, 4.5106E-12_fp,&
       1.5258E-10_fp, -6.1203E-11_fp, -7.4014E-11_fp,&
       3.1894E-11_fp, 2.0823E-11_fp, -1.0084E-11_fp,&
       6.2090E-11_fp, -4.6167E-11_fp, -4.9189E-12_fp,&
       1.1135E-11_fp, 1.0018E-12_fp, -2.1430E-12_fp /),&
       (/6,8/) )
  real(fp) :: AAO(8) = (/ 3.2721E-7_fp, 4.9003E-8_fp, 1.7523E-8_fp,&
       1.0270E-8_fp, 4.0023E-9_fp, 2.6228E-9_fp,&
       2.6516E-10_fp, 1.0413E-10_fp /)
  real(fp) :: BTO(3,8) = reshape( (/ -6.7484E-7_fp, 2.3938E-6_fp, &
       -6.04388E-6_fp, 2.1747E-8_fp, -5.4612E-7_fp, &
       2.7213E-6_fp,&
       2.8129E-8_fp, -3.1692E-7_fp, 1.4381E-6_fp,&
       4.8134E-10_fp, -4.3936E-8_fp, 2.1924E-7_fp,&
       -1.5957E-9_fp, -7.2485E-10_fp, 1.9724E-8_fp,&
       -2.6662E-9_fp, 2.8968E-9_fp, 1.7246E-8_fp,&
       -2.3148E-11_fp, -9.3201E-10_fp, 4.9557E-9_fp,&
       -5.7557E-11_fp, 4.6727E-11_fp, 3.2010E-10_fp /),&
       (/3,8/) )
!
!----------------------------------------------------------------------
!
  INSPC = KNUCZ + 1
!
  PBFI(1:INSPC) = 0._fp
  PBFIL(1:INSPC) = 0._fp
!
  KFLAG = 0
!
!     ERROR EXIT IF ELEMENT NOT AVAILABLE
!
  IF(KNUCZ .GE. 1 .AND. KNUCZ .LE. 8) GO TO 5
  KFLAG = 1
  RETURN
!
!     BRANCH ON ELEMENT TO CALL FIT EVALUATION ROUTINE WITH PROPER
!     CONSTANTS
!
5 GO TO (10, 20, 30, 40, 50, 60, 70, 80) KNUCZ
!
10 CALL ADBFIT(KNUCZ, PTE, PNE, EH, AH, AAH, BTH, PBFI, PBFIL)
  RETURN
20 CALL ADBFIT(KNUCZ, PTE, PNE, EHE, AHE, AAHE, BTHE, PBFI, PBFIL)
  RETURN
30 CALL ADBFIT(KNUCZ, PTE, PNE, ELI, ALI, AALI, BTLI, PBFI, PBFIL)
  RETURN
40 CALL ADBFIT(KNUCZ, PTE, PNE, EBE, ABE, AABE, BTBE, PBFI, PBFIL)
  RETURN
50 CALL ADBFIT(KNUCZ, PTE, PNE, EB, AB, AAB, BTB, PBFI, PBFIL)
  RETURN
60 CALL ADBFIT(KNUCZ, PTE, PNE, EC, AC, AAC, BTC, PBFI, PBFIL)
  RETURN
70 CALL ADBFIT(KNUCZ, PTE, PNE, EN, AN, AAN, BTN, PBFI, PBFIL)
  RETURN
80 CALL ADBFIT(KNUCZ, PTE, PNE, EO, AO, AAO, BTO, PBFI, PBFIL)
  
  RETURN
END SUBROUTINE ADBFI
!
!#####################################################################
!
SUBROUTINE ADBFIT(KNUCZ, PTE, PNE, PE, PA, PAA, PBT, PBFI, PBFIL)
!
!     EVALUATE THE BELFAST GROUP RATE COEFFICIENT FITTING FORMULAS.
!     NOTE THAT 0 IS RETURNED FOR TE < (IONIZATION POTENTIAL / 10).
!
  use iso_c_binding, only: fp => c_double
  implicit none
  save
  real(fp) :: PE(KNUCZ), PA(6,KNUCZ), PAA(KNUCZ), PBT(3,KNUCZ)
  real(fp) :: PBFI(*), PBFIL(*)
  real(fp) :: PTE, PNE,ZJLEV,ZTE,ZX,ZLOG,ZSUM,ZIRC
  integer KNUCZ,INSPC,JSPC, J
!
  ZJLEV = 1.6021E-19_fp
!
!     CONVERT TE TO EV AND ZERO RETURN ARRAYS
!
  ZTE = 1000._fp * PTE
!
  INSPC = KNUCZ + 1
  PBFI(1:INSPC) = 0._fp
  PBFIL(1:INSPC) = 0._fp
!
!     LOOP OVER ALL SPECIES EXCEPT FULLY STRIPPED
!
  DO JSPC = 1, KNUCZ
!
!     RATE IS ZERO FOR KT < (IP/10)
!
     IF(ZTE .LT. PE(JSPC)/10._fp) cycle
!
!     BRANCH IF HIGH TEMPERATURE FIT IS REQUIRED
!
     IF(ZTE .GT. 10._fp * PE(JSPC)) GO TO 80
!
!     (IP/10) < TE < (10*IP) FITTING FORM
!
     ZX = PE(JSPC) / ZTE
     ZLOG = DLOG10(1.0_fp / ZX)
!
     ZSUM = PA(1,JSPC)
     DO J = 2, 6
        ZSUM = ZSUM + PA(J,JSPC) * (ZLOG**(J-1))
     enddo
!
     ZIRC = DEXP(-ZX) * SQRT(1.0_fp / ZX) * ZSUM
     PBFI(JSPC) = PNE * ZIRC
     PBFIL(JSPC) = ZJLEV * PE(JSPC) * PBFI(JSPC)
     cycle
!
!     HIGH TEMPERATURE FIT FOR TE > 10*IP
!
80   ZX = PE(JSPC) / ZTE
!
     ZIRC = SQRT(ZX) * (PAA(JSPC) * DLOG(1.0_fp/ZX)&
          + PBT(1,JSPC) + PBT(2,JSPC) * ZX + PBT(3,JSPC) * ZX * ZX)
!
     PBFI(JSPC) = PNE * ZIRC
     PBFIL(JSPC) = ZJLEV * PE(JSPC) * PBFI(JSPC)
!
  enddo
!
  RETURN
END SUBROUTINE ADBFIT
SUBROUTINE ADYGR(KNUCZ, PTE, PNE, PYGRI, PYGRL, KFLAG)
!
!     COMPUTE DIRECT ELECTRON IONIZATION RATES FOR HYDROGEN-LIKE
!     THROUGH NEON-LIKE CHARGE STATES OF CERTAIN HEAVY ELEMENTS
!     (PRESENTLY SCANDIUM AND IRON).  USES FORMULAE DUE TO
!     S. YOUNGER, NBS.  (JQSRT 29, 61 (1983) AND PRIVATE
!     COMMUNICATIONS).
!
!     KNUCZ= ELEMENT (Z=21 OR 26 FOR NOW)
!     PTE = ELECTRON TEMPERATURE(KEV)
!     PNE = ELECTRON DENSITY (CM-3)
!
!     PYGRI = ARRAY OF IONIZATION RATES (SEC-1)
!             (ONLY THE 10 STATES FROM H-LIKE TO NE-LIKE WILL BE
!              OVERWRITTEN BY THE SUBROUTINE)
!     PYGRL = ARRAY OF IONIZATION ENERGY LOSS RATES (WATTS/ION)
!     KFLAG = 0 FOR O.K.;
!           = 1 FOR INVALID ELEMENT (NO VALUES ARE RETURNED)
!
!     
  use iso_c_binding, only: fp => c_double
  implicit NONE
  save
  real(fp) :: EION(10,3), RATE(10,3)
  real(fp) :: PYGRI(*), PYGRL(*)
  integer i
!
  integer :: NSS(10,3) = reshape( (/ 1,&
       (2,i=1,9),0,0,1,(2,i=1,7),&
       (0,i=1,4),1,2,3,4,5,6/), (/10,3/) )
!
  real(fp) :: CA(3) = (/7.5E-14_fp, 5.9E-14_fp, 8.4E-14_fp/)
  real(fp) :: CB(3) = (/ -2.605E-14_fp, -1.635E-14_fp, -2.68E-14_fp/)
  real(fp) :: CC(3) = (/ 1.195E-14_fp, 0.82E-14_fp, 0.672E-14_fp/)
  real(fp) :: CD(3) = (/ -6.15E-14_fp, -3.79E-14_fp, -5.08E-14_fp/)
!
  real(fp) :: EIONSC(10,3) = reshape( (/ 6034._fp, 5675._fp,&
       5566._fp, 5491._fp, 5318._fp, 5204._fp, 5095._fp, 4990._fp, &
       4890._fp, 4794._fp,&
       0._fp, 0._fp, 1288._fp, 1213._fp, 1135._fp, 1068._fp, &
       993.3_fp,&
       914.0_fp, 846.3_fp, 769.3_fp, (0._fp,i=1,4), 1090._fp, &
       1004._fp, 922.4_fp,&
       838.6_fp, 761.8_fp, 687.4_fp /), (/10,3/) )
!
  real(fp) :: EIONFE(10,3) = reshape( (/ 9277._fp, 8829._fp,&
       8694._fp, 8521._fp, 8400._fp, 8263._fp, 8118._fp, 7949._fp, &
       7818._fp, 7824._fp,&
       0._fp, 0._fp, 2046._fp, 1950._fp, 1852._fp, 1755._fp,& 
       1679._fp, 1566._fp, 1482._fp,&
       1394._fp, (0._fp,i=1,4), 1789._fp, 1678._fp, 1583._fp, &
       1463._fp, &
       1366._fp, 1266._fp/),&
       (/10,3/) )
!
  real(fp) :: PTE, PNE,TEV,CHI,A,B,C,D
  real(fp) :: fchi
  integer JSS,JBE,KFLAG,ICS,KNUCZ
!
!
  TEV = 1000._fp * PTE
!
  EION(1,1) = 0._fp
  DO JSS = 1, 3
     DO JBE = 1, 10
        IF(KNUCZ .EQ. 21) EION(JBE,JSS) = EIONSC(JBE,JSS)
        IF(KNUCZ .EQ. 26) EION(JBE,JSS) = EIONFE(JBE,JSS)
     enddo
  enddo
!
  KFLAG = 0
  IF(EION(1,1) .NE. 0._fp)GO TO 50
  KFLAG = 1
  RETURN
!
50 DO JBE = 1, 10
     ICS = KNUCZ - JBE +1
     PYGRI(ICS) = 0._fp
     PYGRL(ICS) = 0._fp
!
     DO JSS = 1, 3
        RATE(JBE,JSS) = 0._fp
        IF(NSS(JBE,JSS) .EQ. 0) cycle
!
        CHI = TEV / EION(JBE,JSS)
        A = CA(JSS) * DBLE(NSS(JBE,JSS))
        B = CB(JSS) * DBLE(NSS(JBE,JSS))
        C = CC(JSS) * DBLE(NSS(JBE,JSS))
        D = CD(JSS) * DBLE(NSS(JBE,JSS))
        RATE(JBE,JSS) = FCHI(CHI,A,B,C,D) * (EION(JBE,JSS)**(-1.5_fp)) *&
             2.2E-06_fp * SQRT(CHI) * DEXP(-1.0_fp/CHI)
        PYGRI(ICS) = PYGRI(ICS) + PNE * RATE(JBE,JSS)
        PYGRL(ICS) = PYGRL(ICS) + 1.6021E-19_fp * PNE * EION(JBE,JSS)&
             * RATE(JBE,JSS)
     enddo
  enddo
!
  RETURN
END SUBROUTINE ADYGR
!
real(fp) FUNCTION FCHI(PCHI, PA, PB, PC, PD)
!
  use iso_c_binding, only: fp => c_double
  implicit NONE
  save
  real(fp) :: PCHI, PA, PB, PC, PD
  real(fp) :: Z1,Z2,Z3,ZCHISQ,ZCHICB,ZALPHA,ZBETA
  
  Z1 = PA + PB * (1.0_fp + 1.0_fp / PCHI)
  Z2 = PC - (PA + 2.0_fp*PB + PB/PCHI)/PCHI
  Z3 = PD / PCHI
  ZCHISQ = PCHI * PCHI
  ZCHICB = ZCHISQ * PCHI
  ZALPHA = (.001193_fp + .9764_fp*PCHI +.6604_fp*ZCHISQ +&
       .02590_fp*ZCHICB) / (1.0_fp + 1.488_fp*PCHI +&
       .2972_fp*ZCHISQ + .004925_fp*ZCHICB)
  ZBETA = (-.0005725_fp + .01345_fp*PCHI +.8691_fp*ZCHISQ +&
       .03404_fp*ZCHICB) / (1.0_fp + 2.197_fp*PCHI +&
       .2454_fp*ZCHISQ + .002053_fp*ZCHICB)
  FCHI = (3.0E13_fp / PCHI) * (Z1 + Z2 * ZALPHA + Z3 * ZBETA)
  RETURN
END FUNCTION FCHI
SUBROUTINE ADRREC(PTE, PNE)
!
!     REV: 10/10/82 FOR AD PACKAGE
!
!     REV: 9/9/81, 6/15/78
!
!     COMPUTE RADIATIVE RECOMBINATION RATES RRAREC(JQ) FOR A GIVEN
!     ELECTRON TEMPERATURE PTE (KEV), WHERE JQ = (IONIC CHARGE + 1).
!     THESE RATES HAVE THE UNITS (SEC-1).
!     ALSO COMPUTED ARE THE RADIATION RATES ASSOCIATED WITH
!     THIS PROCESS, RADRRC(JQ).  THESE RATES ARE IN JOULES/SEC.
!
!     NOTES:
!
!     1) ELECTRONS ARE ASSUMED TO FILL IONIC SHELLS IN SIMPLE ASCENDING
!        ORDER.  THIS IS ASSUMED BOTH EXPLICITLY (THE APN ARRAY)
!        AS WELL AS IMPLICITLY THROUGH THE USE OF NVALNC VALUES
!        IN LOOP INDICES, ETC.
!     2) THROUGH USE OF THE FUNCTION EXPUND, EXP(X) IS SET EQUAL TO
!        ZERO IN THE RATE EQUATIONS FOR VALUES OF X < -45.
!     3) RATES FOR THE SPECIES JQ REFER TO TRANSFORMATIONS OF
!        THAT SPECIES INTO ADJACENT IONIZATION STATES, NOT THE
!        RATES AT WHICH THAT SPECIES IS FORMED.
!     4) UPON EVALUATION OF THE FORMULAE IT WILL BE FOUND THAT THE
!        FORMALISM USED IN XSNQ/LOKKE AND GRASBERGER (REFS 6,2)
!        IN FACT LEADS TO THE SAME EQUATIONS GIVEN IN
!        PPPL-1352/SEATON (REFS 1,3) IF THE SHIELDED CHARGE FOR
!        LEVEL N IS USED FOR 'Q'.
!
!
!     PRINCIPAL PHYSICS REFERENCES:
!
!     1) POST, JENSEN, TARTER, GRASBERGER, LOKKE, 'STEADY STATE
!        RADIATIVE COOLING RATES FOR LOW-DENSITY HIGH-TEMPERATURE
!        PLASMAS', CORRECTED PPPL-1352 (SUB. TO N.F.)
!     2) LOKKE AND GRASBERGER, 'XSNQ-U A NON-LTE EMISSION AND
!        ABSORPTION COEFFICIENT SUBROUTINE', LLL REPORT UCRL-52276
!     3) SEATON, 'RADIATIVE RECOMBINATION OF HYDROGENIC IONS',
!        MNRAS:119,81 (1959)
!     4) COX AND TUCKER, 'IONIZATION EQUILIBRIUM AND RADIATIVE
!        COOLING OF A LOW-DENSITY PLASMA', AP.J.:157,1157 (1969)
!     5) GRASBERGER, XSNQ - TOKAMAK MEMORANDUM #1, 2/11/76
!     6) XSNQ FORTRAN LISTING
!
!
!
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
  real(fp) :: PTE, PNE,ZJLKEV,ZTE,ZRSUM,ZRSUMC,ZRSUML,ZXN,ZRTEMP
  real(fp) :: ZRTMPL,ZRTMPC
  integer JQ,IVALNC,IVJQM1,JN
  real(fp) EXPE1

  ZJLKEV = 1.6021E-16_fp
!
!
!
  ZTE = PTE
!
  RRAREC(1) = 0._fp
  RADRRC(1) = 0._fp
!
!     ********** LOOP FOR ALL NON-NEUTRAL SPECIES **********
!
  DO JQ = 2 , NSPC
!
     IVALNC = NVALNC(JQ)
     IVJQM1 = NVALNC(JQ - 1)
!
!
!
!     CALCULATE RADIATIVE RECOMBINATION RATES PER SHELL AND SUM THEM
!     (SUMS (FRACTIONAL VACANCY OF SHELL) * (ALPHAN) ; ALPHAN
!     FROM CORRECTED PPPL-1352).  ALSO SUM CONTINUUM AND LINE
!     RADIATION RATES DUE TO RADIATIVE RECOMBINATIONS TO EACH SHELL.
!
!
!
     ZRSUM = 0._fp
     ZRSUMC = 0._fp
     ZRSUML = 0._fp
!
     DO JN = IVALNC,10
!
!     SKIP VALANCE SHELL IF FULL TO AVOID UNDEFINED EN, QN
!
        IF(AQN(JQ,JN) .EQ. 0._fp) cycle
!
        ZXN = EN(JQ,JN)/ZTE
!
        ZRTEMP = AQN(JQ,JN) * QN(JQ,JN) * (ZXN**1.5_fp) * EXPE1(ZXN)
!
!     HIGH-LYING LEVELS CORRECTION FOR NLVLMX=10 IS 5.13
!
        IF(JN .EQ. 10) ZRTEMP = ZRTEMP * 5.13_fp
        ZRSUM = ZRSUM + ZRTEMP
!
        ZRTMPL = ENM(JQ-1,IVJQM1,JN) * ZRTEMP
        ZRSUML = ZRSUML + ZRTMPL
!
        ZRTMPC = AQN(JQ,JN) * QN(JQ,JN) * SQRT(ZXN) * EN(JQ,JN)
        ZRSUMC = ZRSUMC + ZRTMPC
     enddo
!
     RRAREC(JQ) = PNE * 5.20E-14_fp * ZRSUM
     IF(ZRSUMC .LT. 1.E-07_fp) ZRSUMC = 0._fp
     ZRSUMC = 8.32E-30_fp * ZRSUMC
!
     IF(ZRSUML .LT. 1.E-7_fp) ZRSUML = 0._fp
     ZRSUML = ZJLKEV * 5.20E-14_fp * ZRSUML
     RADRRC(JQ) = PNE * (ZRSUMC + ZRSUML)
!
!
  enddo
!
!
  RETURN
END SUBROUTINE ADRREC
SUBROUTINE ADDREC(PTE, PNE)
!7600      LCM DIEREC
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 11/11/81 ADD CDNN AND CDNM MULTIPLIERS
!
!     REV: 10/23/78 (REMOVE 'C' FROM ZDSUM0 DEFINING STATEMENT TO FIX
!                    N-N DIELECTRONIC RATE BUG)
!     REV: 6/15/78
!
!     COMPUTES DIELECTRONIC RECOMBINATION RATE RDIREC(JQ)
!     FOR A GIVEN ELECTRON TEMPERATURE PTE (KEV) AND ELECTRON
!     DENSITY PNE (CM-3), WHERE JQ = (IONIC CHARGE +1).
!     THESE RATES HAVE THE UNITS (SEC-1).  SINCE
!     THE RATE COEFF DEPEND ON NE, THE TOTAL RECOMBINATION RATE
!     PER ION IS NOT STRICTLY A LINEAR FUNCTION OF NE.  HOWEVER,
!     THE DIELECTRONIC COLLISIONAL-INTERRUPTION CORRECTION IS
!     ONLY WEAKLY DEPENDENT ON THE DENSITY, AND THUS THE NON-LINEARITY
!     IS GENERALLY SMALL.
!
!     ALSO COMPUTED ARE THE RADIATION RATES ASSOCIATED WITH THIS
!     PROCESS, RADDRC(JQ), WHICH INCLUDE CONTRIBUTIONS FROM
!     THE RADIATIVE DECAYS OF BOTH THE EXCITED AND CAPTURED ELECTRONS.
!     THESE RATES ARE IN JOULES/SEC.
!
!     NOTES:
!
!     1) ELECTRONS ARE ASSUMED TO FILL IONIC SHELLS IN SIMPLE ASCENDING
!        ORDER.  THIS IS ASSUMED BOTH EXPLICITLY (THE APN ARRAY)
!        AS WELL AS IMPLICITLY THROUGH THE USE OF NVALNC VALUES
!        IN LOOP INDICES, ETC.
!     2) THROUGH USE OF THE FUNCTION EXPUND, EXP(X) IS SET EQUAL TO
!        ZERO IN THE RATE EQUATIONS FOR VALUES OF X < -45.
!     3) RATES FOR THE SPECIES JQ REFER TO TRANSFORMATIONS OF
!        THAT SPECIES INTO ADJACENT IONIZATION STATES, NOT THE
!        RATES AT WHICH THAT SPECIES IS FORMED.
!
!
!     PRINCIPAL PHYSICS REFERENCES:
!
!     1) POST, JENSEN, TARTER, GRASBERGER, LOKKE, 'STEADY STATE
!        RADIATIVE COOLING RATES FOR LOW-DENSITY HIGH-TEMPERATURE
!        PLASMAS', CORRECTED PPPL-1352 (SUB. TO N.F.)
!     2) BURGESS, 'A GENERAL FORMULA FOR THE ESTIMATION OF
!        DIELECTRONIC RECOMBINATION COEFFICIENTS IN LOW-DENSITY
!        PLASMAS', AP.J. 141, 1588 (1965).
!     3) GRASBERGER, XSNQ - TOKAMAK MEMORANDUM #1, 2/11/76
!     4) GRASBERGER, XSNQ - TOKAMAK MEMORANDUM #4, 7/29/76
!     5) GRASBERGER, XSNQ - TOKAMAK MEMORANDUM #10, 1/5/77
!     6) MERTS, COWAN, MAGEE, 'THE CALCULATED POWER OUTPUT
!        FROM A THIN IRON-SEEDED PLASMA', LOS ALAMOS REPORT LA-6220-MS
!     7) XSNQ FORTRAN LISTING
!     8) ANSARI, ELWERT AND MUCKLICH, 'ON DIELECTRONIC RECOMBINATION',
!        ZEITSCHRIFT NATURFORSCHUNG 25A, 1781 (1970).
!
!
!
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
  real(fp) :: PTE, PNE,ZJLKEV,ZTE,ZNE,ZNUC,ZCHG,ZQ,ZQP1,ZBQ,ZNT,ZDNN,&
       ZZZ,ZDNM,ZZZNN, ZZZNM,ZZZA,ZZZET,ZEIJNN,ZYNN,ZAYNN,ZDSUM0,&
       ZDSUM,ZDSUMR,ZEIJ,ZY,ZAY,ZDTEMP,ZDNNRT,ZDNMRT,ZIQ,ZTEMP
  integer JQ,IVALNC,JN,IIJM,JM,ITEMP
  real(fp) :: EXPUND
!
  ZJLKEV = 1.6021E-16_fp
!
!     CALL ADDRCC TO FILL CDNN AND CDNM MULTIPICATIVE CONSTANT ARRAYS
!
  CALL ADDRCC
!
  ZTE = PTE
  ZNE = PNE
!
  ZNUC = DBLE(NUCZ)
!
  RDIREC(1) = 0._fp
  RADDRC(1) = 0._fp
  RDIREC(NSPC) = 0._fp
  RADDRC(NSPC) = 0._fp
!
  IF(NUCZ .EQ. 1) RETURN
!
!
!     ********** LOOP FOR ALL SPECIES EXCEPT NEUTRAL **********
!              ********** AND FULLY IONIZED **********
!
  DO JQ = 2 , NUCZ
!
!
     ZCHG = DBLE(JQ-1)
     IVALNC = NVALNC(JQ)
!
!
!
!     ************* DIELECTRONIC RECOMBINATION RATE *************
!
!     (EQUATIONS AND VARIABLES FOLLOW PPPL-1352/BURGESS FORMALISM)
!
!
!
     ZQ = ZCHG
     ZQP1 = ZCHG + 1._fp
!
     ZBQ = SQRT(  (ZQ * (ZQ+1._fp)**5) / (ZQ*ZQ + 13.4_fp)  )
     ZNT = (4.77E+18_fp * (ZQ**6) * SQRT(ZTE) / ZNE)**0.142857143_fp
     ZDNN = .0068_fp * ZNT * (1._fp+.001_fp*ZNT) / &
          (1._fp+.00002_fp*ZNT*ZNT)
     ZZZ = .0015_fp * ( (ZQ+1._fp) * ZNT )**2
     ZDNM = ZZZ / (1._fp + ZZZ)
     ZZZNN = 7.59E-14_fp* ZBQ * ZDNN / (ZTE**1.5_fp)
     ZZZNM = 7.59E-14_fp * ZBQ * ZDNM / (ZTE**1.5_fp)
     ZZZA = 1._fp + .015_fp * (ZQ**3) / ( (ZQ+1._fp)**2 )
     ZZZET = ( (ZQ + 1._fp)**2 ) / (73.5_fp * ZZZA * ZTE)
!
!
!     COMPUTE N - N CONTRIBUTION TO SUM FIRST
!
!
     ZEIJNN = ENN(JQ) / (.0136_fp * ZQP1 * ZQP1)
     ZYNN = (ZQ + 1._fp) * ZEIJNN
     ZAYNN = SQRT(ZYNN) / (1._fp + .105_fp * ZYNN + .015_fp * ZYNN**2)
!
     ZDSUM0 = FNN(JQ) * ZAYNN * EXPUND(-ZZZET*ZEIJNN , -45._fp)
!
!
!     SUM OVER N - M TRANSITIONS (NOTE THAT TRANSITIONS FROM
!     INNER SHELLS TO THE VALENCE SHELL AND ABOVE ARE INCLUDED)
!
!
     ZDSUM = 0._fp
     ZDSUMR = 0._fp
!
     DO JN = 1 , IVALNC
        IIJM = IVALNC
        IF(JN .EQ. IVALNC .OR.&
             AQN(JQ,IVALNC) .EQ. 0._fp) IIJM = IVALNC + 1
!
        DO JM = IIJM , 10
!
           ZEIJ = ENM(JQ,JN,JM) / (.0136_fp * ZQP1**2)
           ZY = (ZQ + 1._fp) * ZEIJ
           ZAY = SQRT(ZY) / (2._fp + .420_fp * ZY + .06_fp * ZY**2)
!
           ZDTEMP = FNM(JQ,JN,JM) * ZAY * EXPUND(-ZZZET*ZEIJ , -45._fp)
!
           ZDSUM = ZDSUM + ZDTEMP
           ZDSUMR = ZDSUMR + ENM(JQ,JN,JM) * ZDTEMP
        enddo
     enddo
!
     ZDNNRT = ZZZNN * ZDSUM0
     ZDNMRT = ZZZNM * ZDSUM
!W    WRITE(LADPOUT9,909)JQ,ZDNNRT,ZDNMRT
!W  909 FORMAT(1X,'JQ =',I3,3X,'ZDNNRT =',1PE12.2,'  ZDNMRT =',E12.2)
     RDIREC(JQ) = PNE * (CDNN(JQ) * ZDNNRT + CDNM(JQ) * ZDNMRT)
!
     ITEMP = NVALNC(JQ-1)
     ZIQ = EN(JQ,ITEMP)
     ZTEMP = CDNN(JQ) * (ZIQ + ENN(JQ)) * ZDNNRT +&
          CDNM(JQ) * (ZIQ * ZDNMRT + ZZZNM * ZDSUMR)
     IF(ZTEMP .LT. 1.E-21_fp) ZTEMP = 0._fp
     RADDRC(JQ) = PNE * ZJLKEV * ZTEMP
!
!
!
  enddo
!
!
  RETURN
END SUBROUTINE ADDREC
SUBROUTINE ADDRCC
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     SETUP THE DIELECTRONIC RECOMBINATION RATE COEFFICIENT
!     MULTIPLICATIVE CONSTANT ARRAYS CDNN AND CDNM ACCORDING
!     TO THE LDRMLT SWITCH.
!
!     LDRMLT = 0     USE CDNN, CDNM ARRAYS AS GIVEN
!     LDRMLT = 1     CDNN, CDNM ARRAYS SET TO 1.0
!     LDRMLT = 2     USE Y. HAHN FACTORS TO SETUP CDNN, CDNM
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
  integer JSPC
  real(fp) :: ZNELEC
!
!
  IF(LDRMLT .EQ. 0) RETURN
!
  CDNN(1:100) = 1.0_fp
  CDNM(1:100) = 1.0_fp
!
  IF(LDRMLT .EQ. 1) RETURN
!
!
  DO JSPC = 2, NUCZ
!
     ZNELEC = DBLE(NUCZ - JSPC + 1)
!
     CDNN(JSPC) = YHNNA * DEXP(-YHNNB*SQRT(ZNELEC) ) *&
          (DBLE(NUCZ)**YHNNC)
!
     CDNM(JSPC) = YHNMA * DEXP(-YHNMB*SQRT(ZNELEC)) *&
          (DBLE(NUCZ)**YHNMC)
  enddo
!
  RETURN
END SUBROUTINE ADDRCC
SUBROUTINE ADECEX(PTE, PNE)
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 6/15/78
!
!     COMPUTE RADIATION RATES RADCLX(JQ) (JOULE/SEC) DUE TO
!     COLLISIONAL EXCITATION FOR EACH IONIC SPECIES JQ = (IONIC
!     CHARGE + 1).  ALL EXCITATIONS ARE ASSUMED TO RESULT IN
!     RADIATIVE DECAYS.
!
!     REFERENCES:
!     1) POST ET AL. PPPL-1352 (CORRECTED)
!
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
!
!
  integer i
  real(fp) :: ZDNN(28) = (/ 0._fp, 0._fp,&
       1.2_fp, .91_fp, .89_fp, .92_fp, .86_fp, .87_fp, .85_fp, 0._fp,&
       .72_fp, .78_fp, .76_fp, .78_fp, .75_fp, .70_fp, .68_fp, .65_fp,&
       .65_fp,(.70_fp,i=1,8), 0._fp /)
!
  real(fp) :: ZGAMNN(28) = (/ 0._fp, 0._fp,&
       .54_fp, .77_fp, .58_fp, .57_fp, .41_fp, .63_fp, .66_fp, 0._fp,&
       .97_fp, .96_fp, .88_fp, .86_fp, .87_fp, .85_fp, .83_fp, .81_fp,&
       (.80_fp,i=1,9), 0._fp /)
  real(fp) EXPE1
  real(fp) :: EXPUND
  real(fp) :: PTE, PNE,ZJLKEV,ZTE,ZNUC,ZCHG,ZZNN,ZXNN,ZTEMP,ZGNN,&
       ZNMSUM,ZJN,ZJM,ZXNM,ZGNM,ZZNM
  integer IVALNC,IBOUND,JQ,JN,IIJM,JM
!
  ZJLKEV = 1.6021E-16_fp
!
!
!
  ZTE = PTE
  ZNUC = DBLE(NUCZ)
!
!     ******** LOOP FOR ALL SPECIES EXCEPT FULLY IONIZED ********     
!
  DO JQ = 1 , NUCZ
!
     ZCHG = DBLE(JQ - 1)
     IVALNC = NVALNC(JQ)
     IBOUND = NUCZ - JQ + 1
!
!     ***** N - N RATE *****
!
     ZZNN = 0._fp
     IF(FNN(JQ) .EQ. 0._fp) GO TO 30
!
     ZXNN = ENN(JQ) / ZTE
!
     IF(JQ .NE. 1) GO TO 20
     ZTEMP = .06_fp * (SQRT(ZXNN) - 2._fp) / (1._fp + ZXNN)
     GO TO 22
!
20   IF(IBOUND .LE. 28) GO TO 21
     ZTEMP = .7_fp * (1._fp - .8_fp/ ZCHG)
     GO TO 22
!
21   ZTEMP = ZDNN(IBOUND) * (1._fp - ZGAMNN(IBOUND) / ZCHG)
!
22   ZGNN = ZTEMP + .276_fp * EXPE1(ZXNN)
!
     ZZNN = FNN(JQ) * EXPUND(-ZXNN , -45._fp) * ZGNN
!
!     ***** SUM N - M RATES FROM ALL OCCUPIED SHELLS *****
!
30   ZNMSUM = 0._fp
!
!
     DO JN = 1 , IVALNC
!
        ZJN = DBLE (JN)
        IIJM = IVALNC
        IF(JN .EQ. IVALNC .OR.&
             AQN(JQ,IVALNC) .EQ. 0._fp) IIJM = IVALNC + 1
!
        DO JM = IIJM , 10
           ZJM = DBLE(JM)
!
           ZXNM = ENM(JQ,JN,JM) / ZTE
           ZTEMP = ZJM * (ZJM - ZJN) * (1._fp + (1._fp - 2._fp/ZNUC) * ZXNM)&
                / 20._fp
           ZGNM = .19_fp * (1._fp + .9_fp * (1._fp + ZTEMP) * EXPE1(ZXNM))
!
!     NOTE THAT FNM HAS APN AND AQN FACTORS ALREADY INCLUDED
!
           ZZNM = FNM(JQ,JN,JM) * EXPUND(-ZXNM , -45._fp) * ZGNM
           ZNMSUM = ZNMSUM + ZZNM
        enddo
     enddo
!
!
!
     ZTEMP = (ZZNN + ZNMSUM) / SQRT(ZTE)
     IF(ZTEMP .LT. 1.E-10_fp) ZTEMP = 0._fp
     RADCLX(JQ) = PNE * ZJLKEV * 4.99E-10_fp * ZTEMP
!
  enddo
!
!     ***************END OF JQ SPECIES LOOP ***************
!
  RADCLX(NSPC) = 0._fp
!
  RETURN
END SUBROUTINE ADECEX
SUBROUTINE ADBREM(PTE, PNE)
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 6/15/78
!
!     INPUT : PTE, NUCZ, NSPC
!     OUTPUT : RADBRM
!
!     COMPUTE BREMSSTRAHLUNG RADIATION RADBRM(JQ) (JOULE/SEC)
!     FOR EACH IONIC SPECIES JQ = (IONIC CHARGE + 1).
!
!     REFERENCES:
!     1) POST ET AL. PPPL-1352 (CORRECTED)
!     2) KARZAS AND LATTER
!     3) TUCKER
!
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
  real(fp) :: PTE, PNE,ZTE,ZGFF,ZCHG
  integer JQ
!
!
  ZTE = PTE
!
!     USE FIXED FREE-FREE GAUNT FACTOR ZGFF = 1.2
!
  ZGFF = 1.2_fp
!
  DO JQ = 1 , NSPC
     ZCHG = DBLE(JQ - 1)
     RADBRM(JQ) = PNE * 4.85E-31_fp * ZCHG * ZCHG * SQRT(ZTE) * ZGFF
  enddo
!
  RETURN
END SUBROUTINE ADBREM
real(fp) FUNCTION EXPE1(PX)
!
!     REV: 6/15/78
!
!     CALCULATE EXP(PX) * E1(PX), WHERE THE EXPONENTIAL INTEGRAL
!     E1(X) = INTEGRAL FROM X TO INFINITY OF (EXP(-T)/T)DT.
!
!     REFERENCE: 'HANDBOOK OF MATHEMATICAL FUNCTIONS', ABRAMOWITZ
!     AND STEGUN, NATIONAL BUREAU OF STANDARDS
!
  use iso_c_binding, only: fp => c_double
  implicit NONE
  save
  real(fp) :: PX
  IF(PX.GE.1._fp)GO TO 2
  IF(PX.GT.1.E-4_fp)GO TO 1
!
  EXPE1 = DEXP(PX) * ( - DLOG(PX) - .57721566_fp + PX )
  RETURN
!
!
1 EXPE1 = DEXP(PX) * ( - DLOG(PX) - .57721566_fp + .99999193_fp*PX&
       - .24991055_fp*PX**2 + .05519968_fp*PX**3 &
       - .00976004_fp*PX**4 + .00107857_fp*PX**5 )
!
  RETURN
!
!
2 EXPE1 = (PX + 2.334733_fp  + .250621_fp/PX) /&
       (PX**2 + 3.330657_fp*PX + 1.681534_fp)
!
  RETURN
END FUNCTION EXPE1
!
!
!********************************************************************
!
!
real(fp) FUNCTION EXPUND(PX,PCHK)
!
!     REV: 6/15/78
!
!     PREVENT UNDERFLOWS IN RATE CALCULATIONS BY RETURNING
!     0. FOR EXP(PX) IF PX < PCHK.
!
  use iso_c_binding, only: fp => c_double
  implicit NONE
  save
  real(fp) :: PX,PCHK
  IF( PX - PCHK ) 1 , 1 , 2
1 EXPUND = 0._fp
  RETURN
!
2 EXPUND = DEXP(PX)
  RETURN
!
END FUNCTION EXPUND
SUBROUTINE ADBCXR(PNNEUT, PVNEUT, KNCXB, KCXOPT, KERR, KVUNIT)
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     REV: 7/24/79; ZERO RADBCX BEFORE KNCXB=0 TEST & RETURN
!     REV: 5/10/79; ADD RADIATION DUE TO BEAM CHARGE EXCHANGE VIA
!                   RADBCX AND BEQRAD
!
!     COMPUTE RECOMBINATION RATE DUE TO CHARGE EXCHANGE WITH NEUTRAL
!     BEAM IONS.
!
!          NPSC = NUMBER OF IMPURITY SPECIES (NUCLEAR Z + 1)
!
!          PNNEUT = ARRAY OF ANGULAR AVERAGED NEUTRAL DENSITIES FOR
!                   EACH BEAM ENERGY COMPONENT
!          PVNEUT = ARRAY OF VELOCITIES FOR EACH BEAM COMPONENT (CM/S)
!          KNCXB = NUMBER OF ENERGY COMPONENTS IN THE BEAM
!                 (KNCXB = 0 TURNS OFF RCXREC)
!          KCXOPT = 1, 2, OR 3 TO SELECT CROSS-SECTIONS TO BE USED
!          RCXREC = ARRAY OF CHARGE EXCHANGE RECOMBINATION RATES FOR
!                   EACH SPECIES, SEC-1 UNITS (E.G. RATE PER ION)
!          KERR = ERROR FLAG FROM ADCXXS ROUTINE (0 = O.K.)
!          RADBCX = RADIATION RATE DUE TO CASCADE AFTER
!                   CHARGE EXCHANGE TO EXCITED LEVEL (WATTS / ION)
!
!
  use iso_c_binding, only: fp => c_double
  use adpak_mod
  save
!
  real(fp) :: PNNEUT(*), PVNEUT(*)
  real(fp) :: ZSIGMA(100)
  integer KNCXB, KCXOPT, KERR, KVUNIT,INSPC,JSPC,JB,ITEMP
  real(fp) :: ZJLKEV,ZVCMS,ZNFLUX
!
  ZJLKEV = 1.602E-16_fp
!
  INSPC = NSPC
!
!     ZERO RATE ARRAYS FOR ACCUMULATION OF CONTRIBUTIONS FROM EACH BEAM
!     COMPONENT
!
  RCXREC(1:100) = 0._fp
  RADBCX(1:100) = 0._fp
!
!     KNCXB = 0 OR KCXOPT = 0 TO TURN OFF C-X RECOMBINATION
!
  IF(KNCXB .EQ. 0 .OR. KCXOPT .EQ. 0) RETURN
!
!     OBTAIN CROSS-SECTIONS FOR EACH VELOCITY (ENERGY) COMPONENT
!     IN THE BEAM AND COMPUTE TOTAL RECOMBINATION RATE.
!
  DO JB = 1 , KNCXB
!
     CALL ADCXXS(PVNEUT(JB), KVUNIT, ZVCMS, ZSIGMA, INSPC,&
          KCXOPT, KERR)
     ZNFLUX = ZVCMS * PNNEUT(JB)
!
     DO JSPC = 2 , INSPC
        RCXREC(JSPC) = RCXREC(JSPC) + ZNFLUX * ZSIGMA(JSPC)
     enddo
  enddo
!
  DO JSPC = 2 , INSPC
     ITEMP = NVALNC(JSPC-1)
     RADBCX(JSPC) = ZJLKEV * EN(JSPC,ITEMP) * RCXREC(JSPC)
  enddo
!
  RETURN
END SUBROUTINE ADBCXR
SUBROUTINE ADCXXS(PVEL, KVUNIT, PVCMS, PSIGMA, KNSPC,&
     KOPT, KERR)
!
!     REV: 10/10/82 FOR NEW AD PACKAGE
!
!     SUPPLIES CROSS-SECTIONS FOR CHARGE EXCHANGE BETWEEN NEUTRAL
!     HYDROGEN AND MULTI-CHARGED IONS.  THE VARIABLE KOPT ALLOWS
!     THE SELECTION OF RESULTS FROM ONE OF THE VARIOUS PUBLISHED
!     CALCULATIONS.
!
!     PVEL =  RELATIVE VELOCITY, UNITS AS SELECTED BY KVUNIT
!     KVUNIT = UNITS FLAG FOR INPUT VELOCITY
!                 1 = CM/SEC
!                 2 = KEV/AMU
!                 3 = ATOMIC UNITS
!     PSIGMA = ARRAY OF CROSS-SECTION VALUES RETURNED, CM**2.
!              PSIGMA(I) = CROSS-SECTION FOR ION WITH CHARGE = I-1,
!              FOR 2 <= I <= KNSPC
!     KNSPC = HIGHEST SPECIES NUMBER, = MAX Z + 1
!     KOPT = SWITCH FOR DIFFERENT RESULTS, AS FOLLOWS:
!            1 = OLSON & SALOP, PHYS. REV. A 14, 579 (1976)
!                (ABSORBING SPHERE, V <= 1.E08 CM/SEC)
!            2 = GROZDANOV & JANEV, PHYS. REV. A 17, 880 (1978)
!                (TUNNELING, 2.E06 <= V <= 8.E08 CM/SEC)
!            3 = OLSON & SALOP, PHYS. REV. A 16, 531 (1977)
!                (CLASSICAL, (2 - 7)E08 CM/SEC)
!     KERR = ERROR FLAG. 0 = O.K., <0 = INVALID INPUT, OTHERS IN TEXT
!
!*********************************************************************
!
  use iso_c_binding, only: fp => c_double
  implicit NONE
  save
  real(fp), PARAMETER :: xpi =  3.1415926535897931_fp
  real(fp) :: PSIGMA(*)
!
  real(fp) :: ZFITV(4)  = (/ 2.7E08_fp, 3.0E08_fp, 4.0E08_fp, &
       5.0E08_fp/)
  real(fp) :: ZFITLT(4) = (/1.220988_fp, 1.277249_fp, 1.868400_fp, &
       2.575095_fp/)
  real(fp) :: ZFITGT(4) = (/1.000000_fp, 1.050777_fp, 1.221593_fp, &
       1.668531_fp/)
  real(fp) :: PVEL,PVCMS
  integer KVUNIT,KNSPC,KOPT, KERR,JSPC,ICOUNT,IX,IXP1
  real(fp) :: ZVCMS,ZVKEVM,ZVAU,ZCHG,ZL,ZC,ZR,ZFR,ZSLOPE,Z0,Z3V,&
       ZSIG8,ZALT,ZAGT,ZDIV8
!
!---------------------------------------------------------------------
!
  KERR = 0
!
!     CONVERT INPUT VELOCITY PARAMETER
!
  IF(KVUNIT .NE. 1) GO TO 2
  ZVCMS = PVEL
  ZVKEVM = (ZVCMS / 4.39E07_fp)**2
  ZVAU = ZVCMS / 2.19E08_fp
  GO TO 5
!
2 IF(KVUNIT .NE. 2) GO TO 3
  ZVKEVM = PVEL
  ZVCMS = 4.39E07_fp * SQRT(ZVKEVM)
  ZVAU = ZVCMS / 2.19E08_fp
  GO TO 5
!
3 IF(KVUNIT .NE. 3) GO TO 4
  ZVAU = PVEL
  ZVCMS = 2.19E08_fp * ZVAU
  ZVKEVM = (ZVCMS / 4.39E07_fp)**2
  GO TO 5
!
4 KERR = - 1
  RETURN
!
!     RETURN VELOCITY IN CM/S UNITS
!
5 PVCMS = ZVCMS
!
!     NEUTRAL SPECIES CROSS-SECTION = 0
!
  PSIGMA(1) = 0._fp
!
  GO TO (100, 200, 300), KOPT
  KERR = -2
  RETURN
!
!--------------------------------------------------------------------
!     
!     KOPT = 1 ; OLSON & SALOP LOW - V ABSORBING SPHERE
!     NOMINALLY VALID ONLY FOR V < 1.0E08 CM/SEC
!
100 DO JSPC = 3 , KNSPC
!
!W    WRITE(LADPOUT,198)JSPC
!W  198 FORMAT(1X,/,'JSPC =',I3)
!
     ZCHG = DBLE(JSPC - 1)
     ZL = 2.648_fp / SQRT(ZCHG)
     ZC = 2.864E-04_fp * ZCHG * (ZCHG - 1._fp) * ZVAU
     IF(ZC .LT. .541341133_fp/(ZL**2) ) GO TO 102
     KERR = 1
     RETURN
!
!     ITERATIVE SOLUTION TO EQUATION (10)
!
!     (FIRST GUESS, FROM LINEAR FIT TO FIG. 3)
!
102  ZR = 9._fp + 11._fp * ZCHG / 45._fp
     ZR = - DLOG( ZC / (ZR**2) ) / ZL
     ZFR = ZR * ZR * DEXP(- ZL * ZR)
     ICOUNT = 0
!
105  IF(ZR .LT. 2._fp/ZL) GO TO 180
     IF(ICOUNT .GT. 100) GO TO 181
     ICOUNT = ICOUNT + 1
!
!W    WRITE(LADPOUT,199)ZR
199  FORMAT(1X,'ZR=',F10.2)
!
     ZR = ZR + (ZC/ZFR - 1._fp) / (2._fp/ZR - ZL)
     ZFR = ZR * ZR * DEXP (- ZL * ZR)
!
     IF( ABS(ZFR - ZC)/ZC .GE. .001_fp) GO TO 105
!
!     ITERATION COMPLETE TO 0.1% IN VELOCITY; COMPUTE SIGMA
!
     PSIGMA(JSPC) = xpi * (0.529E-08_fp * ZR)**2
  enddo
!     FILL IN Z = 1 CROSS SECTION WITH Z = 2 VALUE
!
  PSIGMA(2) = PSIGMA(3)
  RETURN
!
180 KERR = 2
  RETURN
181 KERR = 3
  RETURN
!
!----------------------------------------------------------------
!
!     KOPT = 2; GROZDANOV & JANEV
!     RESULTS SHOWN ONLY FOR Z = 10, 20, AND 30, 2.E06 < V < 8.E08
!     CM/SEC; ALL OTHER POINTS BY INTERPOLATION OR EXTRAPOLATION
!
200 DO JSPC = 2 , KNSPC
     ZCHG = DBLE(JSPC - 1)
!
!     EMPIRICAL FIT TO FIGURE 3, CENTERED AT V = 2.0E08 CM/SEC
!
     ZSLOPE = - (.25_fp + .04_fp * ZCHG) * 1.0E-14_fp
     Z0 = .11_fp * ZCHG * 1.0E-14_fp
     PSIGMA(JSPC) = DMAX1(0._fp, Z0 + ZSLOPE * DLOG10(ZVCMS/2.E08_fp))
!
  enddo
  RETURN
!
!----------------------------------------------------------------------
!
!
!     KOPT = 3 ; OLSON & SALOP CLASSICAL TRAJECTORY.  USES A
!     POWER LAW FIT TO FIG. 1 AT 4 VELOCITIES IN THE RANGE
!     2.7E08 < V < 5.E08 CM/SEC.  INPUT VELOCITIES OUTSIDE THIS
!     RANGE YIELD DATA FOR THE APPROPRIATE LIMITING VELOCITY.  THE
!     LAST GIVEN DATA CURVE IS FOR Z=36, HENCE DATA FOR Z>36
!     REPRESENTS AN EXTRAPOLATION.
!
300 CONTINUE
  Z3V = DMAX1(2.7E08_fp, ZVCMS)
  Z3V = DMIN1(5.0E08_fp, Z3V)
!
  IX = IDINT(Z3V/1.E08_fp) - 1
  IF(IX .GT. 3) IX = 3
  IXP1 = IX + 1
!
!     USE LINEAR FIT TO Z=8 CURVE TO FIND X-SECTION FOR Z=8 AT GIVEN
!     VELOCITY
!
  ZSIG8 = 7.43E-15_fp - 1.26E-23_fp * Z3V
!
!     INTERPOLATE TO FIND POWER LAW EXPONENTS FOR THIS VELOCITY; ONE
!     FOR Z<8, THE OTHER FOR Z>8.
!
  ZALT = ZFITLT(IX) + (ZFITLT(IXP1) - ZFITLT(IX)) *&
       ( (Z3V-ZFITV(IX)) / (ZFITV(IXP1) - ZFITV(IX)) )
  ZAGT = ZFITGT(IX) + (ZFITGT(IXP1) - ZFITGT(IX)) *&
       ( (Z3V-ZFITV(IX)) / (ZFITV(IXP1)-ZFITV(IX)) )
!
!     FIT PARAMETERS FOUND FOR THIS VELOCITY; COMPUTE X-SECTIONS
!
  DO JSPC = 2 , KNSPC
     ZDIV8 = DBLE(JSPC - 1) / 8._fp
     IF(ZDIV8 .GE. 1._fp) GO TO 310
     PSIGMA(JSPC) = ZSIG8 * ZDIV8**ZALT
     cycle
310  PSIGMA(JSPC) = ZSIG8 * ZDIV8**ZAGT
  enddo
!
  RETURN
!
!---------------------------------------------------------------------
!
END SUBROUTINE ADCXXS

C******************** START FILE ISFNDS.FOR ; GROUP MULCDR ******************
C----------------------------------------------------------
C
C  FIND THE IPT'TH PT WHICH IS INSIDE THE PLOT WINDOW
C    STORE THE PT IN THE ZXL,ZYL ARRAY AND INCREMENT CTR.
C
      SUBROUTINE ISFNDS(ZXL,ZYL,NSYMBS,ICL,X,Y,N,IPT)
C
      INCLUDE 'PLOT1MMX'
C
      REAL ZXL(NSYMBS),ZYL(NSYMBS),X(N),Y(N)
C
C
      ICT=0
      DO I=1,N
        IF((XMIN.LE.X(I)).AND.(XMAX.GE.X(I)).AND.
     >       (YMIN.LE.Y(I)).AND.(YMAX.GE.Y(I))) ICT=ICT+1
        IF(ICT.EQ.IPT) THEN
C  PT FOUND, STORE IT AND EXIT
          ICL=ICL+1
          ZXL(ICL)=X(I)
          ZYL(ICL)=Y(I)
          RETURN
        ENDIF
C
      ENDDO
C  PT NOT FOUND, EXIT
      RETURN
      END
C******************** END FILE ISFNDS.FOR ; GROUP MULCDR ******************

C******************** START FILE LMVRTI.FOR ; GROUP CONCTR ******************
C---------------------
C  LMVRTI  MAP SERIES OF REALS TO SERIES OF INTEGERS
C          LINEARLY
C
C  X1,X2   LIMITS OF 'FROM' INTERVAL
C   J1,J2  LIMITS OF 'TO' INTERVAL
C    XIN   SERIES TO MAP
C    JOUT  OUTPUT OF MAP
C     N    NUMBER TO MAP
C
      SUBROUTINE LMVRTI(X1,X2,J1,J2,XIN,JOUT,N)
      DIMENSION XIN(N)
      DIMENSION JOUT(N)
C
      YJ1=J1
      YJ2=J2
      DELX=X2-X1
      IF(DELX.EQ.0.0) GO TO 900
      DELY=YJ2-YJ1
      S=DELY/DELX
      DO 10 J=1,N
      JOUT(J)=IFIXR((YJ1+S*(XIN(J)-X1)+0.5))
 10   CONTINUE
      RETURN
 900  CONTINUE
      DO 20 J=1,N
      JOUT(J)=J1
 20   CONTINUE
      RETURN
      	END
C******************** END FILE LMVRTI.FOR ; GROUP CONCTR ******************

module frantic_module

  use iso_c_binding, only: fp => c_double
  implicit none
  SAVE

  ! all stuff used by FRANTIC that used to be in TRCOM is redefined
  ! here, in allocatable real(fp) form.

  ! modifications:  NSRC, constant over a FRANTIC call, was removed;
  !   arrays previously indexed by NSRC had dimensionality reduced by 1.
  ! also: array RMJRMP declared as singly dimensioned, dropping the second
  !   dimension that was always referenced as RMJRMP(...,2).

  ! dmc Oct 2002 -- comments generally copied from port.for (TRANSP).

  ! reviewed dmc Dec 2008 -- added comments; added vphi_wall
  ! Units:  the code is mostly cgs internally but the interface routines
  !         use MKS.  Energies & Temperatures in KeV.

  ! array dimensions:

  integer :: mj = 0    ! number of radial zones + 2
  integer :: mig = 0   ! number of plasma thermal ion species
                       ! not electrons nor impurities

  integer :: mii       ! mig+1
  integer :: mic       ! mig+2
  integer :: mix       ! mig+[no. of impurity species cf NIMP]

  integer :: mibs      ! number of fast ion species
  integer :: mitrc     ! dimension for tracking arrays: 5*(mj-2)

  ! working integer scalars:

  integer :: LUN6 = 6  ! output channel for messages

  integer :: frantic_atomic=1 !
  ! default fratnic_atomic=1 -- legacy of PREACT atomic physics
  ! 2 -- ADAS atomic physics for H and He beams.
  !      He beam -- only ground state model available
  ! 3 -- PREACT ground state atomic physics
  !      ADAS interaction with impurities
  ! 4 -- ADAS ground state atomic physics
  !      PREACT interaction with impurities

  integer :: NZONEC      ! # OF FRANTIC ZONES
  integer :: NBOUND      ! # OF FRANTIC ZONE BOUNDARIES
  integer :: NINLDX      ! INDEX TO LEAST CHARGED ION SPECIES
  integer :: NPLAS       ! CURRENT # OF CHARGED PTCL SPECIES
  integer :: NNEUT       ! NUMBER OF NEUTRAL SPECIES
  integer :: NIMP        ! number of impurity species
  integer :: NNEUT_S0    ! index to initial source neutral specie
  integer :: NNEUT_S0P   ! index to prior initial source neutral specie
  integer :: NNEUT_Z0P   ! Z of prior initial source neutral specie
  integer :: NSBEAM      ! no. of fast ion species.

  integer :: NBCROS      ! NUMBER OF ZONE BOUNDARIES CROSSED
  integer :: MID         ! MIDDLE ZONE ELEMENT OF TRAJECTORY

  ! controls:

  logical :: ESFLAG      ! .TRUE. TO CALCULATE EDGE SOURCE
  logical :: VSFLAG      ! .TRUE. TO CALCULATE VOLUME SOURCE
  logical :: MCFLAG      ! .TRUE. TO CALCULATE TRANSFER MATRIX
  logical :: MSFLAG      ! .TRUE. IF MATRIX HAS BEEN CALCULATED
  logical :: LNFLAG      ! .TRUE. TO INITIALIZE GEOMETRY
  logical :: RCFLAG      ! .TRUE. TO INCLUDE ELECTRON-ION RECOMBINATION
  logical :: LBFLAG      ! .TRUE. IF THERE IS A BEAM SINK OF NEUTRALS

  logical :: LZPFLAG     ! .TRUE. if the impurity Z & A are profiles

  ! scalars:

  real(fp) :: EPSLON     ! a small number
  real(fp) :: AMINOR     ! minor radius, cm

  ! these appear to be superseded, see balance checks in frantic_prinsum.f90...
  real(fp) ::  PLOSS     ! PTCL LOSS A
  real(fp) ::  PLOSS1    ! PTCL LOSS B-- COMPARE WITH PLOSS FOR BAL.
  real(fp) ::  ELOSS     ! ENERGY LOSS A
  real(fp) ::  ELOSS1    ! ENERGY LOSS B- COMPARE WITH ELOSS1, E. BAL.

  ! species information:

  real(fp), dimension(:), allocatable :: APLAS  ! AMU MASSES OF CHARGED SPECIES
  real(fp), dimension(:), allocatable :: XZPLAS ! Species charges (+1 for H+)
  integer,  dimension(:), allocatable :: NSPEC ! neutrals->charged species map
  real(fp), dimension(:), allocatable :: WWALL  ! Species outflux #/cm2/sec
  real(fp), dimension(:), allocatable :: TWALL  ! Edge source temperatures KeV
  real(fp), dimension(:), allocatable :: vphi_wall  ! Edge source v_phi cm/sec
  ! if vphi_wall is never specified by input, assume zero

  real(fp), dimension(:), allocatable :: EESCAV  ! AVG ENERGY/PTCL IN ESCAPE FLUXES, by species, KeV
  real(fp), dimension(:), allocatable :: OUTFLX  ! PTCL ESCAPE FLUX by species

  integer,  dimension(:), allocatable :: LISPEC  ! ion to neutral cross index

  real(fp), dimension(:), allocatable :: FLUXI0  ! wall neutral source #/cm2/sec
  real(fp), dimension(:), allocatable :: RMASS   ! species nucleus mass, g
  real(fp), dimension(:), allocatable :: XZBEAMS ! Z of fast species (1 or 2)

  ! grid:

  real(fp), dimension(:), allocatable :: RBOUND ! boundary radii, cm
  real(fp), dimension(:), allocatable :: RMJRMP ! center of flux surfaces, cm
  real(fp), dimension(:), allocatable :: VOL    ! FRANTIC volume of zones, cm**3
  real(fp), dimension(:), allocatable :: tvol   ! enclosed toroidal volume, cm**3
  real(fp), dimension(:), allocatable :: x, xb  ! radial flux coord label [0:1]

  ! work arrays:

  real(fp), dimension(:,:,:,:), allocatable :: ALPHAX ! CH-EX ABSORBTION COEFFICIENT (1/CM) ARRAY
  real(fp), dimension(:,:,:),   allocatable :: ALPHAT ! CH-EX+IONIZATION COEFFICIENT ARRAY
  real(fp), dimension(:,:,:),   allocatable :: BETAX  ! CH-EX COEFFICIENT FOR WALL-BORN NEUTRALS
  real(fp), dimension(:,:),     allocatable :: BETAT  ! CH-EX+IONIZATION COEFF. FOR 1ST GEN. NEUTS.
  real(fp), dimension(:,:,:,:), allocatable :: PRFLUX ! RADIAL IN/OUTFLUX PROBABLITIES ARRAY
  real(fp), dimension(:,:,:),   allocatable :: PRWFLX ! RADIAL IN/OUTFLUX FROM WALL PROBABILITIES
  real(fp), dimension(:,:),     allocatable :: TSTOR1 ! WORKSPACE

  real(fp), dimension(:,:,:,:), allocatable :: GFUN   ! TRANSFER MATRIX
  real(fp), dimension(:),       allocatable :: DIST   ! TRAJECTORY PATH LENGTHS ARRAY
  integer,  dimension(:),       allocatable :: NZCROS ! INDEX OF ZONES CROSSED BY TRAJECTORY
  real(fp), dimension(:),       allocatable :: YLOC   ! TRAJECTORY LOCATIONS ARRAY
  real(fp), dimension(:,:),     allocatable :: WALL   ! ESCAPE-TO-WALL PROBABILITY
  real(fp), dimension(:,:,:),   allocatable :: S0COLD ! CH-EX SOURCE DRIVEN BY 1ST GEN. NEUTRALS

  ! input profiles:

  real(fp), dimension(:,:),   allocatable :: DEN     ! CHARGED PTCL SPECIES DENSITIES
  real(fp), dimension(:,:),   allocatable :: TEMP    ! CHARGED PTCL SPECIES TEMPERATURES
  real(fp), dimension(:,:),   allocatable :: VPHIZ   ! CHARGED PTCL SPECIES AVG VELOCITIES (PHI)
  real(fp), dimension(:,:),   allocatable :: BII     ! BEAM IMPACT IONIZATION RATE COEFFICIENT
  real(fp), dimension(:,:),   allocatable :: BCX     ! BEAM CH-EX REACTION RATE COEFFICIENT
  real(fp), dimension(:,:,:), allocatable :: BCXS    ! fast ion cx rate coeff., by fast ion species
  real(fp), dimension(:),     allocatable :: SVRC    ! RECOMBINATION COEFFICIENT (1/MFP)
  real(fp), dimension(:,:),   allocatable :: VOLSOR  ! VOLUME SCE OF NEUTRALS

  real(fp), dimension(:), allocatable :: VSOR_ZW   ! Z*[Volume SCE of neutrals]
  real(fp), dimension(:), allocatable :: VSOR_MO   ! momentum VOL SCE OF NEUTRALS
  real(fp), dimension(:), allocatable :: VSOR_EN   ! energy VOL SCE OF NEUTRALS

  real(fp), dimension(:), allocatable :: XZIMPJ    ! impurity Z(r) profile
  real(fp), dimension(:), allocatable :: AIMPJ     ! impurity A(r) profile

  ! output profiles:

  real(fp), dimension(:,:), allocatable :: DCOLD  ! 1ST GEN. NEUTRAL DENSITIES
  real(fp), dimension(:,:), allocatable :: DNEUT  ! NEUTRAL DENSITIES (MULTI-GENERATION)
  real(fp), dimension(:,:), allocatable :: TNEUT  ! NEUTRAL TEMPERATARES (MULTI-GENERATION)
  real(fp), dimension(:,:), allocatable :: VPHI0F ! NEUTRAL SPECIE AVG V'S (CM/SEC ALONG Z, FRANTIC)
  real(fp), dimension(:),   allocatable :: PRC    ! RECOMBINATION POWER (LOSS TO IONS)
  real(fp), dimension(:),   allocatable :: PII    ! IONIZATION POWER (INPUT TO IONS)
  real(fp), dimension(:),   allocatable :: PCX    ! CHARGE EXCHANGE POWER (LOSS TO IONS)
  real(fp), dimension(:,:), allocatable :: SORI   ! NET ION SOURCE FUNCTION
  real(fp), dimension(:,:), allocatable :: SORN   ! MULTI-GENERATION NEUTRAL SOURCE FUNCTION
  real(fp), dimension(:),   allocatable :: SORE   ! NET ELECTRON SOURCE FUNCTION
  real(fp), dimension(:),   allocatable :: PCXSF  ! CX SOURCE FRICTION (INPUT TO IONS)
  real(fp), dimension(:),   allocatable :: PIISF  ! II SOURCE FRICTION (INPUT TO IONS)
  real(fp), dimension(:),   allocatable :: TQCX   ! CX TORQUE (LOSS FROM IONS)
  real(fp), dimension(:),   allocatable :: TQII   ! II TORQUE (INPUT TO IONS)

  ! following have influx and outflux counted separately
  real(fp), dimension(:,:), allocatable :: PFLX0M  ! TOTAL DIVERGENCE OF POWER FLUX IN TH. NEUTRALS
  real(fp), dimension(:,:), allocatable :: SFLX0M  ! TOTAL DIVERGENCE OF PTCL FLUX IN TH. NEUTRALS
  real(fp), dimension(:,:), allocatable :: TQFLX0M ! TOTAL DIVERGENCE OF ANG. MOMENTUM FLUX IN TH.NEUTS

  ! here influx and outflux are combined (backwards compatibility reason)
  real(fp), dimension(:), allocatable :: TQFLX0  ! TOTAL DIVERGENCE OF ANG. MOMENTUM FLUX IN TH.NEUTS

  real(fp), dimension(:), allocatable :: SCX   ! total CX reaction rate

  !-----------------------------------------------
  ! user output grid information

  integer :: nxb_user   ! no. of zone bdys in user grid
  integer :: nx_user    ! no. of zones in user grid, =nxb_user-1

  real(fp), dimension(:), allocatable :: xb_user  ! user grid bdys
  real(fp), dimension(:), allocatable :: x_user   ! user grid zone centers
  real(fp), dimension(:), allocatable :: volxb_user   ! volume inside bdys
  real(fp), dimension(:), allocatable :: Rmajxb_user  ! Rmaj of each bdy

  !  Rmajxb_user(j) gives the midplane center of each bdy flux surface j
  !  volxb_user(j) gives the volume inclused by bdy flux surface j

  !-----------------------------------------------
  ! debug stuff

  logical, dimension(:), allocatable :: npro_set ! profile-set flags

  !-----------------------------------------------

end module frantic_module

C******************** START FILE USPOOL.FOR ; GROUP UFILES ******************
c-----------------------------------------
C  ASCII DTEXT SPOOLING ROUTINE
C   SPOOL LINES OF LENGTH UP TO 120 CHARACTERS FROM OPEN FILE
C   ON LUN1 TO OPEN FILE ON LUN2
c
C Updated:
C 10/12/12 CLF : Comment out HDF option
C 08/01/97 CLF : Add HDF option
C
C  MOD DMC APR 1984 -- BINARY WRITE CAPABILITY ON UFILES CHANNELS
C   MUST CHECK FOR THIS
C
C------------------------------------------------------------------------------
      SUBROUTINE USPOOL(LUN1, LUN2)
C
      USE UFILES
C
      CHARACTER ZBUF*120
        integer   fid          ! hdf file id
C
C  INITIALLY ASSUME BOTH UNITS ASCII
C
      IBIN1=0
      IBIN2=0
C
      IER=0
      fid=0
C
C  CHECK INPUT CHANNEL
C
      ICHAN1=IUXCHA(LUN1)
C  ZERO CHANNEL NUMBER INDICATES NON-UFILES L.U.N. (THIS IS OK)
      IF(ICHAN1.NE.0) THEN
C  UFILES CHANNEL MUST BE OPEN FOR READ/WRITE COMMENTS
        IF((UFSTAT(ICHAN1).NE.5).AND.(UFSTAT(ICHAN1).NE.4)) THEN
          CALL UERSTA(ICHAN1,'USPOOL    ')
          WRITE(UFELUN,9001)
 9001   FORMAT(' % MUST READ UFILES DATA BEFORE SPOOLING COMMENTS')
          IER=1
        ENDIF
C  BINARY INPUT FILE?
        IBIN1=UFCPRS(ICHAN1)
        if(ibin1.eq.-1) then
           write(ufelun,'('' %uspool -- MDS+ read not supported.'')')
        endif
      ENDIF
C
C
C  CHECK OUTPUT CHANNEL
C
      ICHAN2=IUXCHA(LUN2)
C  ZERO CHANNEL NUMBER INDICATES NON-UFILES L.U.N. (THIS IS OK)
      IF(ICHAN2.NE.0) THEN
C  UFILES CHANNEL MUST BE OPEN FOR READ/WRITE COMMENTS
        IF((UFSTAT(ICHAN2).NE.2).AND.(UFSTAT(ICHAN2).NE.4)) THEN
          CALL UERSTA(ICHAN2,'USPOOL    ')
          WRITE(UFELUN,9002)
 9002   FORMAT(' % MUST WRITE UFILES DATA BEFORE SPOOLING COMMENTS')
          IER=1
        ENDIF
C  BINARY OUTPUT FILE?
        IBIN2=UFCPRS(ICHAN2)
        if(ibin2.eq.-1) then
           write(ufelun,'('' %uspool -- MDS+ write not supported.'')')
           ier=1
        endif
      ENDIF
C
      IF(IER.EQ.1) THEN
        CALL UFPAUS(1)
        RETURN
      ENDIF
c
      loop1 = 0
      loop2 = 0
C
 10   CONTINUE
      if(ibin1.eq.-1) then
         if(loop1.eq.0) then
            loop1=1
            zbuf=' %USPOOL:  MDS+ source file -- no comments spooled.'
            nj=51
         else
            go to 800
         endif
      else IF(IBIN1.EQ.0) THEN
        READ(LUN1,1001,END=800) ZBUF
 1001 FORMAT(A)
        DO 12 NJ=120,1,-1
          IF(ZBUF(NJ:NJ).NE.' ') GO TO 20
 12     CONTINUE
        NJ = 1
      ELSE if(ibin1.eq.1) then
        READ(LUN1,ERR=800,END=800) NJ
        NJ=MIN0(120,NJ)
C  READ IN 4 BYTE WORDS
        INJ=((NJ-1)/4+1)*4
        READ(LUN1) ZBUF(1:INJ)
      else if(ibin1.eq.2) then
        call ubrchcmp(lun1,zbuf,ieof,ier)
        if((ieof.gt.0).or.(ier.gt.0)) go to 800
        do nj=120,1,-1
           if(zbuf(nj:nj).ne.' ') go to 20
        enddo
        nj=1
C      else if(ibin1.eq.3) then
C         loop1 = loop1 + 1
C         call uhdfcom(lun1,zbuf,nj,0,loop1,fid,ier)
C         if (ier .lt. 0 .or. nj .eq. 0) go to 800
      else if(ibin1.eq.4) then
         loop1 = loop1 + 1
         call ucdfcom(lun1,zbuf,nj,0,loop1,ier)
         if (ier .lt. 0 .or. nj .eq. 0) go to 800
      ENDIF
C
 20   CONTINUE
c
      IF(IBIN2.EQ.0) THEN
        WRITE(LUN2,1001) ZBUF(1:NJ)
      ELSE if(ibin2.eq.1) then
C  WRITE OUT 4 BYTE WORDS
        INJ=((NJ-1)/4+1)*4
        WRITE(LUN2) NJ
        WRITE(LUN2) ZBUF(1:INJ)
      else if(ibin2.eq.2) then
        call ubwchcmp(lun2,zbuf(1:nj))
C      else if(ibin2 .eq. 3 ) then
C         loop2 = loop2 + 1
C         call uhdfcom(lun2,zbuf(1:nj),nj,1,loop2,fid,ier)
C         if (ier .lt. 0) go to 800
      else if(ibin2 .eq. 4 ) then
         loop2 = loop2 + 1
         call ucdfcom(lun2,zbuf(1:nj),nj,1,loop2,ier)
         if (ier .lt. 0) go to 800
      ENDIF
      GO TO 10
C
 800  CONTINUE
C       if HDF: close file
C      if (ibin1 .eq. 3) call uhdfcom(lun1,' ',0,0,0,fid,ier)
C      if (ibin2 .eq. 3) call uhdfcom(lun2,' ',0,1,0,fid,ier)
      RETURN
      END
C******************** END FILE USPOOL.FOR ; GROUP UFILES ******************

C******************** START FILE LNOUT.FOR ; GROUP URDUTS ******************
C----------------------
C&  LNOUT  RETURN UREAD TERMINAL OUTPUT L.U.N. (FETCH FROM COMMON)
C
      INTEGER FUNCTION LNOUT(IDUM)
C
      USE USERIO
C
C  CHECK THAT COMMON BLOCKS ARE INITIALIZED
      CALL USICHK
C
      LNOUT=LUNTRM
      RETURN
      END
C******************** END FILE LNOUT.FOR ; GROUP URDUTS ******************

module hatom_mod
  !
    SAVE
  !
  !  private module for nubeam (TRANSP MC fast ion code)
  !  modernization/modurization effort -- dmc June 2001
  !
  !  enable use of `preact' NTCC software -- reusable atomic physics
  !  data access package
  !
  !  this contains items for handling H, He, and H/He
  !  neutralizing charge exchange and impact ionization reactions
  !  **and** H/He isotope fusion reactions
  !  **and** impurity stopping rate coeffs for H, He neutral atoms
  !  **and** electron,H recombination and electron impaction ionization
  !          rate coeefficients as functions of Te
  !
  !  *****WARNING*****
  !  some Lithium data also available, but this is not complete.
  !
 
  integer :: hatom_flag = 0    ! flag that module has been initialized...
 
  !  "policy options" for range errors on table lookups.
  !  for each initialization a "policy" must be set for two
  !  conditions:  out-of-range low, and out-of-range high
  !  -- can also modify independently for each dimension of each table...
 
  integer, parameter :: r_ignore=0,r_warn=1,r_halt=2
  integer, parameter :: r_ignore_clear=3,r_warn_clear=4
 
  !
  ! These policies have effect when an energy or temperature argument
  ! is given beyond the range of the table data:
  !
  !  r_ignore means:  ignore range error; use nearest table value
  !  r_warn means:  use nearest table value, but issue a warning message
  !  r_halt means:  issue a warning message and exit
  !  r_ignore_clear means:  set result to zero *silently*
  !  r_warn_clear means:  set result to zero with warning message
  !
  !  actual policies:
  !    default:  ignore if out-of-range low
  !              halt with message if out-of-range high
  !
  !-------------------
  !    for cx reactions energy beam-target tables, (E) dimension only:
  !              ignore if out-of-range low
  !              silently clear to zero if out-of-range high
  !    for T dimension use defaults.
  !
  !      cx table ranges:  E=1e-3 keV/amu -- 1e3 keV/amu
  !                        T=1e-3 kev/amu -- 2e2 keV/amu
  !
  !      ii table ranges:  E=1e-2 keV/amu -- 10e3 keV/amu
  !                        T=1e-3 kev/amu -- 2e2 keV/amu
  !
  !           (so code will halt with message if Ti/A > 200KeV)
  !
  !-------------------
  !    for fusion reactions:
  !
  !      thermonuclear table:  silently clear to zero if T < Tmin,
  !                            halt with error if T > Tmax
  !                               temperature range:  0.1keV -> 200keV
  !
  !      beam-target table:    silently clear to zero if E < Emin
  !                            ignore if T < Tmin
  !                            halt with error if T > Tmax or E > Emax
  !                               temperature range:  0.2keV -> 200keV
  !                               energy range 1keV -> 10000keV
  !
  !      gyro-avg table:       silently clear to zero if E < Emin
  !                            halt with error if var. fraction not in [0,1].
  !
  !-------------------
  !    impurity stopping cross section vs. relative (Erel/A):
  !      range 0.001 KeV/AMU to 10e3 keV/AMU
  !      (use e.g. E0/A0 + 1.5*Ti/Ai for Erel/A, keV/AMU)
  !
  !      ignore if Erel/A < Emin, halt with error if Erel/A > Emax
  !
  !-------------------
  !    <sigma*v>(Te) reactions (recombination; electron impact ionization)
  !      range Te = 0.001 KeV to 200 KeV
  !
  !      issue warning if out of range low;
  !      halt with error message if out of range high.
  !
  !
  !
  !
  !  charge exchange "handles"...
 
  integer :: Lcx_H0_H           ! Hydrogen-Hydrogen
  integer :: Lcx_HE0_HE         ! Helium-Helium double cx
  integer :: Lcx_HE0_H          ! Helium neutral on H+
 
  !  we have some real Li data...
 
  integer :: Lcx_LI0_LI         ! Lithium-Lithium "triple" cx  (set to ~zero)
  integer :: Lcx_LI0_HE         ! Lithium-neutral & He++ double cx
  integer :: Lcx_LI0_H          ! Lithium-neutral & H+
 
  !  impact ionization "handles"...
 
  integer :: Lii_H0_H           ! Hydrogen-Hydrogen
  integer :: Lii_H0_HE          ! Hydrogen neutral on He++ (H0,HE++ ii)
  integer :: Lii_H0_LI          ! Hydrogen neutral on Li+++
                                !   for this using 1.5*(H0,HE++ ii)
 
  integer :: Lii_HE0_H          ! Helium neutral on H+
  integer :: Lii_HE0_HE         ! Helium0-Helium++ impact ioniz. (He0,HE++ ii)
  integer :: Lii_HE0_LI         ! Helium neutral on Li+++
                                !   for this using 1.5*(He0,HE++ ii)
 
  integer :: Lii_LI0_H          ! Lithium neutral on H+
  integer :: Lii_LI0_HE         ! Lithium neutral on He++
  integer :: Lii_LI0_LI         ! Lithium neutral on Li+++
                                !   for this using 1.5*(He0,HE++ ii) (??)
 
  !  impurity stopping rate coefficient tables sigma*v(Erel/A)
 
  integer :: Lst_H0_C6          ! H0 stopped by C+6
  integer :: Lst_HE0_C6         ! HE0 stopped by C+6
  integer :: Lst_LI0_C6         ! LI0 stopped by C+6 (using H0 data)
 
  integer :: Lst_H0_O8          ! H0 stopped by C+8
  integer :: Lst_HE0_O8         ! HE0 stopped by C+8
  integer :: Lst_LI0_O8         ! LI0 stopped by C+8 (using H0 data)
 
  !  electron <sigma*v> reactions
 
  integer :: Lreco_H_e          ! H+,e recombination
 
  integer :: Lei_H0             ! H0 electron impact ionization
  integer :: Lei_HE0            ! He0 electron impact ionization
  integer :: Lei_LI0            ! Li0 electron impact ionization (use H0 data)
 
  !  handles for fusion reactions...
  !  not strictly atomic physics but the numerical methods are the
  !  same so we do it here anyway...
 
  !  note DT & TD -- D beam T target; T beam D target, respectively.
 
  integer :: Lfs_DDn            ! DD neutron branch
  integer :: Lfs_DDp            ! DD proton branch
  integer :: Lfs_DT             ! D-->T
  integer :: Lfs_TD             ! T-->D
  integer :: Lfs_TT             ! TT fusion
  integer :: Lfs_dpcTT        ! TT fusion,DPC data 06/2018
  integer :: Lfs_D3             ! D-->He3
  integer :: Lfs_3D             ! He3-->D
  integer :: Lfs_T3             ! T-->He3
  integer :: Lfs_3T             ! He3-->T
 
contains
 
  subroutine hatom_init
    !
    !  initialize hatom_mod
    !
 
    implicit NONE
 
    real*8 zdum
 
    integer cx_init,ii_init,fs_init,sv_init,ei_init,icode_preact
    external cx_init,ii_init,fs_init,sv_init,ei_init,icode_preact
 
    hatom_flag=1
 
    !-------------------
    ! charge exchange (neutral atom in, neutral atom out)
    Lcx_HE0_H = cx_init(icode_preact('H+->He0x'),r_ignore,r_halt)
    Lcx_H0_H = cx_init(icode_preact('H->H(cx)'),r_ignore,r_halt)
    Lcx_HE0_HE = cx_init(icode_preact('He++>Hex'),r_ignore,r_halt)
    Lcx_LI0_H = cx_init(icode_preact('H+->Li0x'),r_ignore,r_halt)
    Lcx_LI0_HE = cx_init(icode_preact('He++>Lix'),r_ignore,r_halt)
    Lcx_LI0_LI = cx_init(icode_preact('Li+++>Lx'),r_ignore,r_halt)
    call cx_coldtarget_epolicy(Lcx_H0_H,r_ignore,r_ignore_clear)
    call cx_coldtarget_epolicy(Lcx_HE0_HE,r_ignore,r_ignore_clear)
    call cx_coldtarget_epolicy(Lcx_HE0_H,r_ignore,r_ignore_clear)
 
    call cx_coldtarget_epolicy(Lcx_LI0_H,r_ignore,r_ignore_clear)
    call cx_coldtarget_epolicy(Lcx_LI0_HE,r_ignore,r_ignore_clear)
    call cx_coldtarget_epolicy(Lcx_LI0_LI,r_ignore,r_ignore_clear)
 
    call cx_warmtarget_epolicy(Lcx_H0_H,r_ignore,r_ignore_clear)
    call cx_warmtarget_epolicy(Lcx_HE0_HE,r_ignore,r_ignore_clear)
    call cx_warmtarget_epolicy(Lcx_HE0_H,r_ignore,r_ignore_clear)
 
    call cx_warmtarget_epolicy(Lcx_LI0_LI,r_ignore,r_ignore_clear)
    call cx_warmtarget_epolicy(Lcx_LI0_HE,r_ignore,r_ignore_clear)
    call cx_warmtarget_epolicy(Lcx_LI0_H,r_ignore,r_ignore_clear)
 
    call cx_energyavg_peramu_epolicy(Lcx_H0_H,r_ignore,r_ignore_clear)
    call cx_energyavg_peramu_epolicy(Lcx_HE0_HE,r_ignore,r_ignore_clear)
    call cx_energyavg_peramu_epolicy(Lcx_HE0_H,r_ignore,r_ignore_clear)
 
    call cx_energyavg_peramu_epolicy(Lcx_LI0_LI,r_ignore,r_ignore_clear)
    call cx_energyavg_peramu_epolicy(Lcx_LI0_HE,r_ignore,r_ignore_clear)
    call cx_energyavg_peramu_epolicy(Lcx_LI0_H,r_ignore,r_ignore_clear)
 
    call cx_average_vdotnorm_epolicy(Lcx_H0_H,r_ignore,r_ignore_clear)
    call cx_average_vdotnorm_epolicy(Lcx_HE0_HE,r_ignore,r_ignore_clear)
    call cx_average_vdotnorm_epolicy(Lcx_HE0_H,r_ignore,r_ignore_clear)
 
    call cx_average_vdotnorm_epolicy(Lcx_LI0_LI,r_ignore,r_ignore_clear)
    call cx_average_vdotnorm_epolicy(Lcx_LI0_HE,r_ignore,r_ignore_clear)
    call cx_average_vdotnorm_epolicy(Lcx_LI0_H,r_ignore,r_ignore_clear)
 
    !-------------------
    ! impact ionization (H/He/Li)
 
    Lii_H0_H = ii_init(icode_preact('H->H(ii)'),r_ignore,r_halt)
    Lii_H0_HE = ii_init(icode_preact('He++>H0i'),r_ignore,r_halt)
    Lii_H0_LI= ii_init(icode_preact('Li+++->H'),r_ignore,r_halt)
 
    Lii_HE0_H = ii_init(icode_preact('H+->He0i'),r_ignore,r_halt)
    Lii_HE0_HE = ii_init(icode_preact('He++>Hei'),r_ignore,r_halt)
    Lii_HE0_LI = ii_init(icode_preact('Li+++>He'),r_ignore,r_halt)
 
    Lii_LI0_H = ii_init(icode_preact('H+->Li0i'),r_ignore,r_halt)
    Lii_LI0_HE = ii_init(icode_preact('He++>Lii'),r_ignore,r_halt)
    Lii_LI0_LI = ii_init(icode_preact('Li+++>Li'),r_ignore,r_halt)
 
    !-------------------
    ! impurity stopping
 
    Lst_H0_C6 = sv_init(icode_preact('C+6->H'),r_ignore,r_halt)
    Lst_He0_C6 = sv_init(icode_preact('C+6->He'),r_ignore,r_halt)
    Lst_Li0_C6 = sv_init(icode_preact('C+6->Li'),r_ignore,r_halt)
 
    Lst_H0_O8 = sv_init(icode_preact('O+8->H'),r_ignore,r_halt)
    Lst_He0_O8 = sv_init(icode_preact('O+8->He'),r_ignore,r_halt)
    Lst_Li0_O8 = sv_init(icode_preact('O+8->Li'),r_ignore,r_halt)
 
    !-------------------
    ! <sigma*v>(Te)
 
    Lreco_H_e = ei_init(icode_preact('recombine'),r_warn,r_halt)
 
    Lei_H0 = ei_init(icode_preact('i:e->H0'),r_warn,r_halt)
    Lei_He0 = ei_init(icode_preact('i:e->He0'),r_warn,r_halt)
    Lei_Li0 = ei_init(icode_preact('i:e->Li0'),r_warn,r_halt)
 
    !-------------------
    ! fusion
 
    Lfs_DDn = fs_init(icode_preact('D->D(n)'),r_ignore,r_halt)
    Lfs_DDp = fs_init(icode_preact('D->D(p)'),r_ignore,r_halt)
 
    Lfs_DT = fs_init(icode_preact('D->T'),r_ignore,r_halt)
    Lfs_TD = fs_init(icode_preact('T->D'),r_ignore,r_halt)
    Lfs_TT = fs_init(icode_preact('T->T'),r_ignore,r_halt)
    Lfs_dpcTT = fs_init(icode_preact('dpcT->T'),r_ignore,r_halt)
 
    Lfs_D3 = fs_init(icode_preact('D->He3'),r_ignore,r_halt)
    Lfs_3D = fs_init(icode_preact('He3->D'),r_ignore,r_halt)
    Lfs_T3 = fs_init(icode_preact('T->He3'),r_ignore,r_halt)
    Lfs_3T = fs_init(icode_preact('He3->T'),r_ignore,r_halt)
 
    ! cold-target tables:  <sigma*v>=0 if E<Emin
 
    call fs_coldtarget_epolicy(Lfs_DDn,r_ignore_clear,r_halt)
    call fs_coldtarget_epolicy(Lfs_DDp,r_ignore_clear,r_halt)
 
    call fs_coldtarget_epolicy(Lfs_DT,r_ignore_clear,r_halt)
    call fs_coldtarget_epolicy(Lfs_TD,r_ignore_clear,r_halt)
    call fs_coldtarget_epolicy(Lfs_TT,r_ignore_clear,r_halt)
    call fs_coldtarget_epolicy(Lfs_dpcTT,r_ignore_clear,r_halt)
 
    call fs_coldtarget_epolicy(Lfs_D3,r_ignore_clear,r_halt)
    call fs_coldtarget_epolicy(Lfs_3D,r_ignore_clear,r_halt)
    call fs_coldtarget_epolicy(Lfs_T3,r_ignore_clear,r_halt)
    call fs_coldtarget_epolicy(Lfs_3T,r_ignore_clear,r_halt)
 
    ! thermonuclear tables:  <sigma*v>=0 if T<Tmin
 
    call fs_thermonuclear_tpolicy(Lfs_DDn,r_ignore_clear,r_halt)
    call fs_thermonuclear_tpolicy(Lfs_DDp,r_ignore_clear,r_halt)
 
    call fs_thermonuclear_tpolicy(Lfs_DT,r_ignore_clear,r_halt)
    call fs_thermonuclear_tpolicy(Lfs_TD,r_ignore_clear,r_halt)
    call fs_thermonuclear_tpolicy(Lfs_TT,r_ignore_clear,r_halt)
    call fs_thermonuclear_tpolicy(Lfs_dpcTT,r_ignore_clear,r_halt)
 
    call fs_thermonuclear_tpolicy(Lfs_D3,r_ignore_clear,r_halt)
    call fs_thermonuclear_tpolicy(Lfs_3D,r_ignore_clear,r_halt)
    call fs_thermonuclear_tpolicy(Lfs_T3,r_ignore_clear,r_halt)
    call fs_thermonuclear_tpolicy(Lfs_3T,r_ignore_clear,r_halt)
 
    ! beam-target tables:  <sigma*v>=0 if E<Emin
 
    call fs_warmtarget_epolicy(Lfs_DDn,r_ignore_clear,r_halt)
    call fs_warmtarget_epolicy(Lfs_DDp,r_ignore_clear,r_halt)
 
    call fs_warmtarget_epolicy(Lfs_DT,r_ignore_clear,r_halt)
    call fs_warmtarget_epolicy(Lfs_TD,r_ignore_clear,r_halt)
    call fs_warmtarget_epolicy(Lfs_TT,r_ignore_clear,r_halt)
    call fs_warmtarget_epolicy(Lfs_dpcTT,r_ignore_clear,r_halt)
 
    call fs_warmtarget_epolicy(Lfs_D3,r_ignore_clear,r_halt)
    call fs_warmtarget_epolicy(Lfs_3D,r_ignore_clear,r_halt)
    call fs_warmtarget_epolicy(Lfs_T3,r_ignore_clear,r_halt)
    call fs_warmtarget_epolicy(Lfs_3T,r_ignore_clear,r_halt)
 
    ! gyro-Avg tables:  <sigma*v>=0 if E<Emin
 
    call fs_gyroAvg_epolicy(Lfs_DDn,r_ignore_clear,r_halt)
    call fs_gyroAvg_epolicy(Lfs_DDp,r_ignore_clear,r_halt)
 
    call fs_gyroAvg_epolicy(Lfs_DT,r_ignore_clear,r_halt)
    call fs_gyroAvg_epolicy(Lfs_TD,r_ignore_clear,r_halt)
    call fs_gyroAvg_epolicy(Lfs_TT,r_ignore_clear,r_halt)
    call fs_gyroAvg_epolicy(Lfs_dpcTT,r_ignore_clear,r_halt)

    call fs_gyroAvg_epolicy(Lfs_D3,r_ignore_clear,r_halt)
    call fs_gyroAvg_epolicy(Lfs_3D,r_ignore_clear,r_halt)
    call fs_gyroAvg_epolicy(Lfs_T3,r_ignore_clear,r_halt)
    call fs_gyroAvg_epolicy(Lfs_3T,r_ignore_clear,r_halt)
 
    !  require E-variation fraction to be in range [0,1]
 
    call fs_gyroAvg_varpolicy(Lfs_DDn,r_halt,r_halt)
    call fs_gyroAvg_varpolicy(Lfs_DDp,r_halt,r_halt)
 
    call fs_gyroAvg_varpolicy(Lfs_DT,r_halt,r_halt)
    call fs_gyroAvg_varpolicy(Lfs_TD,r_halt,r_halt)
    call fs_gyroAvg_varpolicy(Lfs_TT,r_halt,r_halt)
    call fs_gyroAvg_varpolicy(Lfs_dpcTT,r_halt,r_halt)
 
    call fs_gyroAvg_varpolicy(Lfs_D3,r_halt,r_halt)
    call fs_gyroAvg_varpolicy(Lfs_3D,r_halt,r_halt)
    call fs_gyroAvg_varpolicy(Lfs_T3,r_halt,r_halt)
    call fs_gyroAvg_varpolicy(Lfs_3T,r_halt,r_halt)
 
  end subroutine hatom_init
end module hatom_mod

      subroutine ryevala(rmsplc,ymsplc,rmspls,ymspls,
     >                   zsnthtk,zcsthtk,nmom,zr99,zy99)
c
c  evaluate moments position:  asymmetric eq. moments formula
c
      real rmsplc(0:nmom),ymsplc(0:nmom),rmspls(0:nmom),ymspls(0:nmom)
      real zcsthtk(nmom),zsnthtk(nmom)
c
c--------------------------------
c
      ZR99 = RMSPLC(0)
      ZY99 = YMSPLC(0)
      DO 51 IMUL=1,NMOM
         ZR99 = ZR99 + RMSPLC(IMUL)*ZCSTHTK(IMUL)
     >      + RMSPLS(IMUL)*ZSNTHTK(IMUL)
         ZY99 = ZY99 + YMSPLC(IMUL)*ZCSTHTK(IMUL)
     >      + YMSPLS(IMUL)*ZSNTHTK(IMUL)
 51   CONTINUE
c
      return
      end

C******************** START FILE UERMSG.FOR ; GROUP URDUTS ******************
C-----------------------------------------------------------
C&  UERMSG UREAD WRITE ERROR MESSAGE, FLUSH TYPEAHEAD, ...
C
C  WRITE OUT ERROR MESSAGE
C
      SUBROUTINE UERMSG(TEXT,ITEM,ICOD)
      USE USERIO
      CHARACTER*(*) TEXT
      CHARACTER*(*) ITEM
C
      CHARACTER*72 ZBUFF
C
C  TEXT - TEXT OF MESSAGE
C  ITEM - ITEM CAUSING MESAGE (IF NONBLANK)
C
C  ICOD:  =-1: CLEAR PAGE BEFORE WRITING MESSAGE
C         =0: NO PAGE CLEAR, NO UPAUST CALL
C         =1: CALL UPAUST(0)
C         =2: CALL UPAUST(1)
C
      IF(ICOD.LT.0) CALL NEUPAG
C
      ILT=ILNURD(ITEM)
C
      IF(ITEM(1:ILT).EQ.' ') THEN
        WRITE(LUNTRM,1001) TEXT
 1001 FORMAT(1X,A)
      ELSE
C
        ILTOT=LEN(TEXT)+ILT
        IF(ILTOT.LT.72) THEN
          WRITE(LUNTRM,1002) TEXT,ITEM(1:ILT)
        ELSE
          WRITE(LUNTRM,1004) TEXT,ITEM(1:ILT)
        ENDIF
 1002 FORMAT(1X,A,':  ',A)
 1004 FORMAT(1X,A,':'/1X,A)
      ENDIF
C--------------
      CALL URDBUF(ZBUFF,ILBUF,1)
      IF(NLINDI.AND.(NCHARA.GT.0)) WRITE(LUNTRM,1005) ABUFF(1:NCHARA)
      IF(ILBUF.GT.0) WRITE(LUNTRM,1003) ZBUFF(1:ILBUF)
 1003 FORMAT(' USER TYPEAHEAD BUFFER CONTENTS:'/1X,A)
 1005 FORMAT(' PROGRAM PROMPT WAS:'/1X,A)
C--------------
      IF(ICOD.LE.0) GO TO 100
      IPAUSE=ICOD-1
      CALL UPAUST(IPAUSE)
C  FLUSH BUFFER
 100  CONTINUE
      CALL UCLEAR
      RETURN
      END
C******************** END FILE UERMSG.FOR ; GROUP URDUTS ******************

!
!
!
! This module provides a fortran interface for working with the "C" fwrap<type> 
! opaque pointers.  These pointers have the fortran representation Integer(FW_POINTER).
! There is no distinguishing of type in the pointer and all of the fortran routines are very
! low level by calling the "C" functions directly so there is no type,argument or bounds checking.
! Therefore care should be used when using these methods.  See the function  array<type>  in module
! varcontainer_mod.f90 for obtaining an fwrap<type> pointer from a VarContainer.
!
! A short example
!   use varcontainer_mod
!   integer :: fvar(fw_pointer)    ! will hold fwrap<Float32> instance
!   type(cVarContainer) :: box     ! a cVarContainer instance
!   integer :: ishape(5)           ! will hold shape
!
!   call init_cvc(box)
!   call new_cvc("mybox",box,ier)  ! make a new box
!   call add0Float32(box, "myvar", 2, (/3,5/), ier)   ! add one two dimensional real*4 variable
!
!   call arrayFloat32(box,"myvar",fvar,ier)           ! get an fwrap<Float32> pointer to this variable
!   call setFloat32(fvar,2,4,3.14159)                 ! set value at myvar(2,4)
!   call shapeFloat32(fvar,ishape)                    ! get shape
!   print *, 'rank(fvar)  = ', rankFloat32(fvar)      ! print out rank
!   print *, 'shape(fvar) = ', ishape(1:2)            ! only first two elements were filled
!   print *, 'fvar[2,4]   = ', getFloat32(fvar,2,4)   ! get value at myvar(2,4)
!
! The fortran module routines are defined for each type (Int32, Float32, Float64, Logical32),
!
!   Return the rank
!     int rank<type>(fwrap)
!      fwrap = fwrap<type> opaque pointer as integer(fw_pointer)
!
!   Return the shape
!     shape<type>(fwrap, shape)
!      fwrap = fwrap<type> opaque pointer as integer(fw_pointer)
!      shape = integer array must have at least rank elements (not checked)
!
!   Index into the array and return the <type> value.  You must use the correct number of indices
!   for the rank of the function.
!     <type> get<type>(fwrap)         -> scalar
!     <type> get<type>(fwrap,i)       -> rank 1
!     <type> get<type>(fwrap,i,j)     -> rank 2
!     <type> get<type>(fwrap,i,j,k)   -> rank 3
!     <type> get<type>(fwrap,i,j,k,m) -> rank 4
!        fwrap   = fwrap<type> opaque pointer as integer(fw_pointer)
!        i,j,k,m = indices into array -- like fortran
!
!   Index into the array and set the <type> value.  You must use the correct number of indices
!   for the rank of the function.
!     set<type>(fwrap,value)         -> scalar
!     set<type>(fwrap,i,value)       -> rank 1
!     set<type>(fwrap,i,j,value)     -> rank 2
!     set<type>(fwrap,i,j,k,value)   -> rank 3
!     set<type>(fwrap,i,j,k,m,value) -> rank 4
!        fwrap   = fwrap<type> opaque pointer as integer(fw_pointer)
!        i,j,k,m = indices into array -- like fortran
!        value   = a scalar of type <type>
!
!   You can also access data from the fwrap<type> pointer through the low level "C" functions wich are callable 
!   from fortran. If these functions fail, you will crash.  There is no bounds, shape or type checking on 
!   the "get","set" methods so you should use the method with the right number of arguments for your variable.
!   The <ctype> are the "C" types ip32,fp32,fp64,lp32.  The "get","set" methods starting with "fw_" have the
!   same indexing as fortran.  There are also "get","set" methods starting with "cw_" which have the same index
!   order as fortran but start from 0 instead of 1.  The "cw_" methods avoid the subtraction of 1 from
!   each fortran index which is required when computing an array element.
!       int  fw_<ctype>rank(fwrap) -> returns the rank
!       void fw_<ctype>shape(fwrap, ishape) -> returns the shape in ishape[*]
!       <ctype> fw_<ctype>get(fwrap)        -> return the value in a rank 0 variable
!       <ctype> fw_<ctype>get(fwrap,i)      -> return the value in a rank 1 variable
!       <ctype> fw_<ctype>get(fwrap,i,j)    -> return the value in a rank 2 variable .. and so on to rank 4
!       void    fw_<ctype>set(fwrap, v)     -> set the value in a rank 0 variable
!       void    fw_<ctype>set(fwrap,i, v)   -> set the value in a rank 1 variable
!       void    fw_<ctype>set(fwrap,i,j, v) -> set the value in a rank 2 variable .. and so on to rank 4
!
!
module fwrap_mod
  integer, parameter :: FW_POINTER=2    ! length of the storage for this pointer

  ! -------------- Int32 -------------
  interface rankInt32
     function fw_ip32rank(fwrap) result(rank)
       integer :: fwrap(*)  ! opaque aip_32 pointer
       integer :: rank
     end function fw_ip32rank
  end interface

  interface shapeInt32
     subroutine fw_ip32shape(fwrap,shape)
       integer :: fwrap(*)           ! opaque aip_32 pointer
       integer :: shape(*)           ! shape
     end subroutine fw_ip32shape
  end interface

  interface getInt32
     function fw_ip32get0(fwrap) result(value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer*4 :: value         ! returned result
     end function fw_ip32get0

     function fw_ip32get1(fwrap,i) result(value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer   :: i             ! indices
       integer*4 :: value         ! returned result
     end function fw_ip32get1

     function fw_ip32get2(fwrap,i,j) result(value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer   :: i,j           ! indices
       integer*4 :: value         ! returned result
     end function fw_ip32get2

     function fw_ip32get3(fwrap,i,j,k) result(value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer   :: i,j,k         ! indices
       integer*4 :: value         ! returned result
     end function fw_ip32get3

     function fw_ip32get4(fwrap,i,j,k,m) result(value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer   :: i,j,k,m       ! indices
       integer*4 :: value         ! returned result
     end function fw_ip32get4
  end interface

  interface setInt32
     subroutine fw_ip32set0(fwrap,value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer*4 :: value         ! set value
     end subroutine fw_ip32set0

     subroutine fw_ip32set1(fwrap,i,value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer   :: i             ! indices
       integer*4 :: value         ! set value
     end subroutine fw_ip32set1

     subroutine fw_ip32set2(fwrap,i,j,value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer   :: i,j           ! indices
       integer*4 :: value         ! set value
     end subroutine fw_ip32set2

     subroutine fw_ip32set3(fwrap,i,j,k,value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer   :: i,j,k         ! indices
       integer*4 :: value         ! set value
     end subroutine fw_ip32set3

     subroutine fw_ip32set4(fwrap,i,j,k,m,value)
       integer   :: fwrap(*)      ! opaque aip_32 pointer
       integer   :: i,j,k,m       ! indices
       integer*4 :: value         ! set value
     end subroutine fw_ip32set4
  end interface


  ! -------------- Float32 -------------
  interface rankFloat32
     function fw_fp32rank(fwrap) result(rank)
       integer :: fwrap(*)  ! opaque afp_32 pointer
       integer :: rank
     end function fw_fp32rank
  end interface

  interface shapeFloat32
     subroutine fw_fp32shape(fwrap,shape)
       integer :: fwrap(*)           ! opaque afp_32 pointer
       integer :: shape(*)           ! shape
     end subroutine fw_fp32shape
  end interface

  interface getFloat32
     function fw_fp32get0(fwrap) result(value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       real*4 :: value         ! returned result
     end function fw_fp32get0

     function fw_fp32get1(fwrap,i) result(value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       integer   :: i             ! indices
       real*4 :: value         ! returned result
     end function fw_fp32get1

     function fw_fp32get2(fwrap,i,j) result(value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       integer   :: i,j           ! indices
       real*4 :: value         ! returned result
     end function fw_fp32get2

     function fw_fp32get3(fwrap,i,j,k) result(value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       integer   :: i,j,k         ! indices
       real*4 :: value         ! returned result
     end function fw_fp32get3

     function fw_fp32get4(fwrap,i,j,k,m) result(value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       integer   :: i,j,k,m       ! indices
       real*4 :: value         ! returned result
     end function fw_fp32get4
  end interface

  interface setFloat32
     subroutine fw_fp32set0(fwrap,value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       real*4 :: value         ! set value
     end subroutine fw_fp32set0

     subroutine fw_fp32set1(fwrap,i,value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       integer   :: i             ! indices
       real*4 :: value         ! set value
     end subroutine fw_fp32set1

     subroutine fw_fp32set2(fwrap,i,j,value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       integer   :: i,j           ! indices
       real*4 :: value         ! set value
     end subroutine fw_fp32set2

     subroutine fw_fp32set3(fwrap,i,j,k,value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       integer   :: i,j,k         ! indices
       real*4 :: value         ! set value
     end subroutine fw_fp32set3

     subroutine fw_fp32set4(fwrap,i,j,k,m,value)
       integer   :: fwrap(*)      ! opaque afp_32 pointer
       integer   :: i,j,k,m       ! indices
       real*4 :: value         ! set value
     end subroutine fw_fp32set4
  end interface


  ! -------------- Float64 -------------
  interface rankFloat64
     function fw_fp64rank(fwrap) result(rank)
       integer :: fwrap(*)  ! opaque afp_64 pointer
       integer :: rank
     end function fw_fp64rank
  end interface

  interface shapeFloat64
     subroutine fw_fp64shape(fwrap,shape)
       integer :: fwrap(*)           ! opaque afp_64 pointer
       integer :: shape(*)           ! shape
     end subroutine fw_fp64shape
  end interface

  interface getFloat64
     function fw_fp64get0(fwrap) result(value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       real*8 :: value         ! returned result
     end function fw_fp64get0

     function fw_fp64get1(fwrap,i) result(value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       integer   :: i             ! indices
       real*8 :: value         ! returned result
     end function fw_fp64get1

     function fw_fp64get2(fwrap,i,j) result(value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       integer   :: i,j           ! indices
       real*8 :: value         ! returned result
     end function fw_fp64get2

     function fw_fp64get3(fwrap,i,j,k) result(value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       integer   :: i,j,k         ! indices
       real*8 :: value         ! returned result
     end function fw_fp64get3

     function fw_fp64get4(fwrap,i,j,k,m) result(value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       integer   :: i,j,k,m       ! indices
       real*8 :: value         ! returned result
     end function fw_fp64get4
  end interface

  interface setFloat64
     subroutine fw_fp64set0(fwrap,value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       real*8 :: value         ! set value
     end subroutine fw_fp64set0

     subroutine fw_fp64set1(fwrap,i,value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       integer   :: i             ! indices
       real*8 :: value         ! set value
     end subroutine fw_fp64set1

     subroutine fw_fp64set2(fwrap,i,j,value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       integer   :: i,j           ! indices
       real*8 :: value         ! set value
     end subroutine fw_fp64set2

     subroutine fw_fp64set3(fwrap,i,j,k,value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       integer   :: i,j,k         ! indices
       real*8 :: value         ! set value
     end subroutine fw_fp64set3

     subroutine fw_fp64set4(fwrap,i,j,k,m,value)
       integer   :: fwrap(*)      ! opaque afp_64 pointer
       integer   :: i,j,k,m       ! indices
       real*8 :: value         ! set value
     end subroutine fw_fp64set4
  end interface


  ! -------------- Logical32 -------------
  interface rankLogical32
     function fw_lp32rank(fwrap) result(rank)
       integer :: fwrap(*)  ! opaque alp_32 pointer
       integer :: rank
     end function fw_lp32rank
  end interface

  interface shapeLogical32
     subroutine fw_lp32shape(fwrap,shape)
       integer :: fwrap(*)           ! opaque alp_32 pointer
       integer :: shape(*)           ! shape
     end subroutine fw_lp32shape
  end interface

  interface getLogical32
     function fw_lp32get0(fwrap) result(value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       logical*4 :: value         ! returned result
     end function fw_lp32get0

     function fw_lp32get1(fwrap,i) result(value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       integer   :: i             ! indices
       logical*4 :: value         ! returned result
     end function fw_lp32get1

     function fw_lp32get2(fwrap,i,j) result(value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       integer   :: i,j           ! indices
       logical*4 :: value         ! returned result
     end function fw_lp32get2

     function fw_lp32get3(fwrap,i,j,k) result(value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       integer   :: i,j,k         ! indices
       logical*4 :: value         ! returned result
     end function fw_lp32get3

     function fw_lp32get4(fwrap,i,j,k,m) result(value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       integer   :: i,j,k,m       ! indices
       logical*4 :: value         ! returned result
     end function fw_lp32get4
  end interface

  interface setLogical32
     subroutine fw_lp32set0(fwrap,value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       logical*4 :: value         ! set value
     end subroutine fw_lp32set0

     subroutine fw_lp32set1(fwrap,i,value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       integer   :: i             ! indices
       logical*4 :: value         ! set value
     end subroutine fw_lp32set1

     subroutine fw_lp32set2(fwrap,i,j,value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       integer   :: i,j           ! indices
       logical*4 :: value         ! set value
     end subroutine fw_lp32set2

     subroutine fw_lp32set3(fwrap,i,j,k,value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       integer   :: i,j,k         ! indices
       logical*4 :: value         ! set value
     end subroutine fw_lp32set3

     subroutine fw_lp32set4(fwrap,i,j,k,m,value)
       integer   :: fwrap(*)      ! opaque alp_32 pointer
       integer   :: i,j,k,m       ! indices
       logical*4 :: value         ! set value
     end subroutine fw_lp32set4
  end interface

  private :: fort_getchar0, fort_getchar1, fort_getchar2, fort_getchar3, fort_getchar4
  private :: fort_setchar0, fort_setchar1, fort_setchar2, fort_setchar3, fort_setchar4
  
  !
  ! use name getCharArg where the character result is in the argument list
  ! when fortran 2008 is available, add getChar for a function which returns a character result
  !
  interface getCharArg
    module procedure fort_getchar0, fort_getchar1, fort_getchar2, fort_getchar3, fort_getchar4
  end interface

  interface setChar
    module procedure fort_setchar0, fort_setchar1, fort_setchar2, fort_setchar3, fort_setchar4
  end interface

contains
  
  !
  ! ------------------ frankChar --------------
  ! rank of container Character variable ignoring the first dimension
  !
  function frankChar(fwrap) result(rank)
    interface 
      function fw_charrank(fwrap) result(rank)
        integer :: fwrap(*)  ! opaque alp_32 pointer
        integer :: rank
      end function fw_charrank
    end interface
    
    integer :: fwrap(*)  ! opaque alp_32 pointer
    integer :: rank
    
    rank = max(0,fw_charrank(fwrap)-1)
  end function frankChar

  !
  ! ------------------ flenChar --------------
  ! length of container Character variable which is considered to be the first dimension
  !
  function flenChar(fwrap) result(length)
    interface 
      function fw_charrank(fwrap) result(rank)
        integer :: fwrap(*)  ! opaque alp_32 pointer
        integer :: rank
      end function fw_charrank
    end interface
    
    integer :: fwrap(*)  ! opaque alp_32 pointer
    integer :: length
    integer :: rank
    integer :: ishape(6)          ! raw shape
    
    rank = fw_charrank(fwrap)
    if (rank==0) then
      length=1
    else
      call fw_charshape(fwrap,ishape)
      length = ishape(1)
    end if
  end function flenChar

  !
  ! ------------------ fshapeChar --------------
  ! shape of container Character variable ignoring the first dimension
  !
  subroutine fshapeChar(fwrap,shape)
    interface 
      function fw_charrank(fwrap) result(rank)
        integer :: fwrap(*)  ! opaque alp_32 pointer
        integer :: rank
      end function fw_charrank
    end interface
    
    integer :: fwrap(*)           ! opaque alp_32 pointer
    integer :: shape(*)           ! shape
    integer :: rank               ! rank including length
    integer :: ishape(6)          ! raw shape
    
    rank = fw_charrank(fwrap)
    if (rank<=1) return        ! no string shape
    
    call fw_charshape(fwrap,ishape)
    do i=2,rank
      shape(i-1)=ishape(i)
    end do
  end subroutine fshapeChar

  subroutine fort_getchar0(fwrap,value)
    integer,intent(in)            :: fwrap(*)   ! opaque acp_char pointer
    character(len=*),intent(out)  :: value      ! returned value
    call fw_charget0(fwrap, len(value), value)
  end subroutine fort_getchar0

  subroutine fort_getchar1(fwrap,i,value)
    integer,intent(in)           :: fwrap(*)   ! opaque acp_char pointer
    integer,intent(in)           :: i          ! indices
    character(len=*),intent(out) :: value      ! returned value
    call fw_charget1(fwrap, i, len(value), value)
  end subroutine fort_getchar1

  subroutine fort_getchar2(fwrap,i,j,value)
    integer,intent(in)           :: fwrap(*)   ! opaque acp_char pointer
    integer,intent(in)           :: i,j        ! indices
    character(len=*),intent(out) :: value      ! returned value
    call fw_charget2(fwrap, i, j, len(value), value)
  end subroutine fort_getchar2

  subroutine fort_getchar3(fwrap,i,j,k,value)
    integer,intent(in)           :: fwrap(*)   ! opaque acp_char pointer
    integer,intent(in)           :: i,j,k      ! indices
    character(len=*),intent(out) :: value      ! returned value
    call fw_charget3(fwrap, i, j, k, len(value), value)
  end subroutine fort_getchar3

  subroutine fort_getchar4(fwrap,i,j,k,m,value)
    integer,intent(in)           :: fwrap(*)   ! opaque acp_char pointer
    integer,intent(in)           :: i,j,k,m    ! indices
    character(len=*),intent(out) :: value      ! returned value
    call fw_charget4(fwrap, i, j, k, m, len(value), value)
  end subroutine fort_getchar4
  
  subroutine fort_setchar0(fwrap,value)
    integer,intent(in)            :: fwrap(*)   ! opaque acp_char pointer
    character(len=*),intent(in)   :: value      ! returned value
    call fw_charset0(fwrap, len(value), value)
  end subroutine fort_setchar0

  subroutine fort_setchar1(fwrap,i,value)
    integer,intent(in)           :: fwrap(*)   ! opaque acp_char pointer
    integer,intent(in)           :: i          ! indices
    character(len=*),intent(in)  :: value      ! returned value
    call fw_charset1(fwrap, i, len(value), value)
  end subroutine fort_setchar1

  subroutine fort_setchar2(fwrap,i,j,value)
    integer,intent(in)           :: fwrap(*)   ! opaque acp_char pointer
    integer,intent(in)           :: i,j        ! indices
    character(len=*),intent(in)  :: value      ! returned value
    call fw_charset2(fwrap, i, j, len(value), value)
  end subroutine fort_setchar2

  subroutine fort_setchar3(fwrap,i,j,k,value)
    integer,intent(in)           :: fwrap(*)   ! opaque acp_char pointer
    integer,intent(in)           :: i,j,k      ! indices
    character(len=*),intent(in)  :: value      ! returned value
    call fw_charset3(fwrap, i, j, k, len(value), value)
  end subroutine fort_setchar3

  subroutine fort_setchar4(fwrap,i,j,k,m,value)
    integer,intent(in)           :: fwrap(*)   ! opaque acp_char pointer
    integer,intent(in)           :: i,j,k,m    ! indices
    character(len=*),intent(in)  :: value      ! returned value
    call fw_charset4(fwrap, i, j, k, m, len(value), value)
  end subroutine fort_setchar4
  
end module fwrap_mod

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_value(expr, answer, retlen)
      implicit none
      character*(*) expr
      integer       answer, retlen
      mds_value = 0
      end
#else
c-----------------------------------------------------------------------
c mds_value
c get data
c
c Input
c   expr  -- string containing mds expression
c Output
c   answer -- answer descriptor
c   retlen -- return length
c Returns
c   1            -- success
c   even number  -- error
c
c 03/12/1999 ler Converting to unix usable
c 03/23/1999 ler Get return value by using size
c 04/12/1999 ler mds_value now handles return length
c-----------------------------------------------------------------------
      integer function mds_value(expr, answer, retlen)
      implicit none
      include 'mdslib.inc'
 
      character*(*) expr
      integer       answer, retlen
 
      character*4097 str_expr
      integer status
 
      call mds__copywnull(str_expr, expr)
      status = MdsValue(str_expr, answer, 0, retlen)
 
      mds_value = status
 
      return
      end
#endif
 
 
 
 
 
 

C******************** START FILE UCBUFX.FOR ; GROUP UEDTS2 ******************
C-------------------------------------------
C&  UCBUFX  TYPE OUT LAST THREE LINES OF INPUT TO UREAD SYSTEM
C
C  DUMP OUT LAST FEW LINES OF SAVED INPUT IN EVENT OF ERROR
C  SEE SUBROUTINE UCBUFP ABOVE
C
      SUBROUTINE UCBUFX
C
      USE USERIO
C
      IF(NSAVED.EQ.0) RETURN
C
      WRITE(LUNTRM,1001) NSAVED
 1001 FORMAT(/' PREVIOUS ',I1,' LINES FROM INDIRECT INPUT FILE:'/)
C
      DO 10 I=NSAVED,1,-1
      DO 9 IC=LBUFF,2,-1
      IF(CBUFFP(I)(IC:IC).NE.' ') GO TO 8
 9    CONTINUE
 8    WRITE(LUNTRM,1002) CBUFFP(I)(1:IC)
 10   CONTINUE
 1002 FORMAT(1X,A)
C
      RETURN
      	END
C******************** END FILE UCBUFX.FOR ; GROUP UEDTS2 ******************

#ifdef __NOMDSPLUS
#define STUB
#endif
#ifdef STUB
      integer function mds_setserver(server)
      implicit none
      character*(*) server
      mds_setserver = 0
      return
      end
#else
c-----------------------------------------------------------------------
c mds_setserver
c select remote MDSplus server
c
c Input:
c   server -- MDSplus server name or "local"
c Returns:
c          -- mdsplus status codes
c             odd_number success
c             even_number failure
c
c *** WARNING ***
c o Saved current server name only 256 characters long
c o Assume consistent case in server names
c o Assume "local" in lower case
c
c
c 03/03/1999 ler Converting to unix usable
c 04/12/1999 ler Now: MdsConnect returns socket value
c                     MdsDisconnect exists
c-----------------------------------------------------------------------
      integer function mds_setserver(server)
      implicit none
 
      character*(*) server
      integer     status
 
      character*256 current_server
      data          current_server/' '/
      integer       socket
      data          socket/0/
 
      character*4097 str_server
      integer l
 
      integer  mdsfconnect
      integer mds__leniftrim
 
      save socket
C-----------------------------------------------------------------------
C You might not wish to disconnect
C      if (socket.ne.0) then
C        call mdsfdisconnect()
C      endif
 
      l = max(1, mds__leniftrim(server))
      if (server(1:l).eq.'local' .or.
     >    server(1:l).eq.'LOCAL') then
        socket = 0
        current_server = server(1:l)
        status = 1
      else
        call mds__copywnull(str_server, server)
        socket = mdsfconnect(str_server)
C Error = -1
        if (socket.le.0) then
          current_server = ' '
          status = 0
        else
          current_server = server(1:l)
          status = 1
        end if
      end if
 
      mds_setserver = status
      return
      end
#endif
 

!******************** START FILE UFWRCDF_AEP.F90 ; GROUP UFILES ******************
!--------------------------------------------------------------
!  UFCDFWR_AEP
!  WRITE Multi-DIMENSIONAL DATA TO NetCdf FILE for AEP model (Mario Pdesta)
!
SUBROUTINE UFCDFWR_AEP(filename,ZSDATE,ISHOT,CDEV,iaep_sp,&
  & NK,AAEP,TM,NT,Tstep,demin,demax,nde,dpmin,dpmax,ndp,emin,emax,ne,&
  & pmin,pmax,np,mumin,mumax,nmu,PAEP,ndemax,ndpmax,nemax,npmax,nmumax,ctunits,ceunits,IER)
! 
!  MG  03/13/2014 
!  ISHOT -- ISHOT # ("139048")
!  IDEV-- 4 LETTER TOKAMAK DEV. CODE ("PLT ", ETC.)
!  nk -- terms # in Mario Pdesta series, # of modes
!
!  iaep_sp(NK) -- species code # to which AEP mode will be applied
!  species code #
!  0                   ;ALL fast ion SPECIES in this run (in NUBEAM)
!  1                   ;deuterium
!  2                   ;tritium
!  3                   ;HE3
!  4                   ;HE4
!  5                   ;protons          
!
!  AAEP(NT,NK) -- Mode amplitude. Aaep_k_specie(time)
!  nt -- # of points in time grig TM
!  TM(nt) -- time grid in ms
!  Tstep(nk) -- time step used to investigate AEP mode
!  demin(NK), demax(NK) -- left and right boundaries for a linear grid, function of nk (# of terms in MP series)
!  dpmin(NK), dpmax(NK) -- same as above
!  emin(NK), emax(NK) -- same as above
!  pmin(NK), pmax(NK) -- same as above
!  mumin(NK), mumax(NK) -- same as above
!  PAEP(ndemax,ndpmax,nemax,npmax,nmumax,nk)  -- probability matrix
!  ndemax -- max(1,maxval(nde))
!  ndpmax -- max(1,maxval(ndp))
!  nemax -- max(1,maxval(ne))
!  npmax -- max(1,maxval(np))
!  nmumax -- max(1,maxval(nmu))
!  PROCESS CODE 0 = "RAW" raw data are saved
!  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
!
 
  use iso_c_binding, only: fp => c_double
  use logmod
  use netcdf
  implicit none
  character*(*),intent(in) :: filename !with path
  character*(*),intent(in):: CDEV
  integer,intent(in) :: ishot
  integer,intent(in), dimension(nk) :: iaep_sp
  integer,intent(in) :: nk,nt
  real(fp),intent(in)  :: AAEP(nt,nk)
  real(fp),intent(in)  :: tm(nt)
  integer,intent(in) :: nde(nk), ndp(nk), ne(nk), np(nk), nmu(nk)
  real(fp),intent(in)  :: tstep(nk)
  real(fp),intent(in)  :: demin(nk),demax(nk)
  real(fp),intent(in)  :: dpmin(nk),dpmax(nk)
  real(fp),intent(in)  :: emin(nk),emax(nk)
  real(fp),intent(in)  :: pmin(nk),pmax(nk)
  real(fp),intent(in)  :: mumin(nk),mumax(nk)
  integer,intent(in) :: ndemax,ndpmax,nemax,npmax,nmumax !PAEP dimentions
  real(fp),intent(in)  :: paep(ndemax,ndpmax,nemax,npmax,nmumax,nk)
  CHARACTER*9,intent(in) :: ctunits,ceunits ! units for time axis amd for energy axis
  CHARACTER*10,intent(in) :: ZSDATE !  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
  CHARACTER*10 :: ZDATE  !  ZDATE - FILE WRITE DATE
  integer :: ier
  character*30 :: cvar
  character*10 :: uflabel
  integer :: ilbl,ilbl1 !label length
!netcdf var's IDs bellow
  integer :: icdf, id_lbl, id_lbl1, id_uf, id_dev, id_ishot, id_zsdate, id_zdate        
  integer :: id_iaep_sp, id_nk, id_nt, id_aaep, id_tm,id_tstep
  integer :: id_demin, id_demax, id_dpmin, id_dpmax, id_emin, id_emax, id_pmin, id_pmax
  integer :: id_mumin, id_mumax,id_nde, id_ndp, id_ne, id_np, id_nmu, id_paep
  integer :: id_ndemax,id_ndpmax,id_nemax,id_npmax,id_nmumax
  character :: zbuf*24
!-----------------------------------------
!
!  WRITE ***
!
! sanitary check
  ier=0
  call checkdim
!OK now write netcdf file, raw data
!  IPROC = 0 
!  KMPRS = 4 !CDF file 
  call fdate(zbuf)
  if(zbuf(9:9).eq.' ')zbuf(9:9)=char(48)
  zdate=zbuf(9:10)//zbuf(5:7)//zbuf(21:24)
  call uupper(ctunits)
  call uupper(ceunits)

  call check(nf90_create(path=trim(adjustl(filename)),&
       & cmode=NF90_CLOBBER,ncid=icdf),trim(adjustl(filename)))
  
  cvar='DEVLBL'
  ilbl=4
  call check(nf90_def_dim(icdf,cvar,ilbl,id_lbl),cvar)
  cvar='SHOT'
  call check(nf90_def_var(icdf,cvar,NF90_INT,id_ishot),cvar)
  cvar='DEVICE'
  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl/),id_dev),cvar)
  cvar='UFLBL'
  ilbl1=10
  call check(nf90_def_dim(icdf,cvar,ilbl1,id_lbl1),cvar)
  cvar = 'UFLABEL'  !UF label
  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_uf),cvar)
  cvar = 'ZSDATE'   !SHOT (DATA ORIGIN) DATE
  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_zsdate),cvar)
  cvar = 'ZDATE'    !FILE WRITE DATE
  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_zdate),cvar)
  cvar='NK'
  call check(nf90_def_dim(icdf,cvar,nk,id_nk),cvar)
  cvar='NT'
  call check(nf90_def_dim(icdf,cvar,nt,id_nt),cvar)
  cvar='NDEMAX'
  call check(nf90_def_dim(icdf,cvar,ndemax,id_ndemax),cvar)
  cvar='NDPMAX'
  call check(nf90_def_dim(icdf,cvar,ndpmax,id_ndpmax),cvar)
  cvar='NEMAX'
  call check(nf90_def_dim(icdf,cvar,nemax,id_nemax),cvar)
  cvar='NPMAX'
  call check(nf90_def_dim(icdf,cvar,npmax,id_npmax),cvar)
  cvar='NMUMAX'
  call check(nf90_def_dim(icdf,cvar,nmumax,id_nmumax),cvar)
  cvar = 'IAEP_SP'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_iaep_sp),cvar)
  cvar='TM'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nt/),id_tm),cvar)
  cvar='AAEP'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nt,id_nk/),id_aaep),cvar)
  cvar='TSTEP'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_tstep),cvar)
  cvar='DEMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_demin),cvar)
  cvar='DEMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_demax),cvar)
  cvar='DPMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_dpmin),cvar)
  cvar='DPMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_dpmax),cvar)
  cvar='EMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_emin),cvar)
  cvar='EMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_emax),cvar)
  cvar='PMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_pmin),cvar)
  cvar='PMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_pmax),cvar)
  cvar='MUMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_mumin),cvar)
  cvar='MUMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_mumax),cvar)
  cvar = 'NDE'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_nde),cvar)
  cvar = 'NDP'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_ndp),cvar)
  cvar = 'NE'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_ne),cvar)
  cvar = 'NP'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_np),cvar)
  cvar = 'NMU'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_nmu),cvar)
  cvar='PAEP'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_ndemax,id_ndpmax,id_nemax,&
       & id_npmax,id_nmumax,id_nk/),id_paep),cvar)
! define attributes
  cvar='SHOT'
  call check(nf90_put_att(icdf,id_ishot,cvar,"-SHOT #"),cvar)
  cvar='DEVICE'
  call check(nf90_put_att(icdf,id_dev,cvar,"-DEVICE NAME"),cvar)
  cvar = 'UFLABEL'  !UF label
  call check(nf90_put_att(icdf,id_uf,cvar,"-UF LABEL"),cvar)
  cvar = 'ZSDATE'   !SHOT (DATA ORIGIN) DATE
  call check(nf90_put_att(icdf,id_zsdate,cvar,"-SHOT (DATA ORIGIN) DATE"),cvar)
  cvar = 'ZDATE'    !FILE WRITE DATE
  call check(nf90_put_att(icdf,id_zdate,cvar,"-FILE WRITE DATE"),cvar)
  cvar = 'IAEP_SP'
  call check(nf90_put_att(icdf,id_iaep_sp,cvar,"-FAST ION code #: 0--ALL, 1--D,&
        2--T, 3--HE3, 4--HE4, 5--p"),cvar)
  cvar='NK'
  CALL check(nf90_put_att(icdf,id_nk,cvar,"-# OF TERMS IN MARIO PODESTA AEP OPERATOR"),cvar)
  cvar='NT'
  call check(nf90_put_att(icdf,id_nt,cvar,"-# OF POINTS IN TIME GRID TM FOR AEP MODE AMPLITUDE"),cvar)
  cvar='TM'
  call check(nf90_put_att(icdf,id_tm,cvar,"-TIME GRID TM FOR AEP MODE AMPLITUDE,"//ctunits),cvar)
  cvar='AAEP'
  call check(nf90_put_att(icdf,id_aaep,cvar,"-AEP MODE AMPLITUDE"),cvar)
  cvar='TSTEP'
  call check(nf90_put_att(icdf,id_tstep,cvar,"-TIME STEP USED IN SIMULATION,"//ctunits),cvar)
  cvar='DEMIN'
  call check(nf90_put_att(icdf,id_demin,cvar,"-LEFT BOUNDARY FOR DELTA E GRID,"//ceunits),cvar)
  cvar='DEMAX'
  call check(nf90_put_att(icdf,id_demax,cvar,"-RIGHT BOUNDARY FOR DELTA E GRID,"//ceunits),cvar)
  cvar='EMIN'
  call check(nf90_put_att(icdf,id_emin,cvar,"-LEFT BOUNDARY FOR ENERGY GRID,"//ceunits),cvar)
  cvar='EMAX'
  call check(nf90_put_att(icdf,id_emax,cvar,"-RIGHT BOUNDARY FOR ENERGY GRID,"//ceunits),cvar)
  cvar='DPMIN'
  call check(nf90_put_att(icdf,id_dpmin,cvar,"-LEFT BOUNDARY FOR DELTA P GRID"),cvar)
  cvar='DPMAX'
  call check(nf90_put_att(icdf,id_dpmax,cvar,"-RIGHT BOUNDARY FOR DELTA P GRID"),cvar)
  cvar='PMIN'
  call check(nf90_put_att(icdf,id_pmin,cvar,"-LEFT BOUNDARY FOR P(CANONICAL MOMENTUM) GRID"),cvar)
  cvar='PMAX'
  call check(nf90_put_att(icdf,id_pmax,cvar,"-RIGHT BOUNDARY FOR P(CANONICAL MOMENTUM) GRID"),cvar)
  cvar='MUMIN'
  call check(nf90_put_att(icdf,id_mumin,cvar,"-LEFT BOUNDARY FOR mu(MAGNETIC MOMENT) GRID"),cvar)
  cvar='MUMAX'
  call check(nf90_put_att(icdf,id_mumax,cvar,"-RIGHT BOUNDARY FOR mu(MAGNETIC MOMENT) GRID"),cvar)
  cvar='NDEMAX'
  call check(nf90_put_att(icdf,id_ndemax,cvar,"-# OF POINTS IN DE GRID, MAX(1,MAXVAL(NDE))"),cvar)
  cvar='NDPMAX'
  call check(nf90_put_att(icdf,id_ndpmax,cvar,"-# OF POINTS IN DP GRID, MAX(1,MAXVAL(NDP))"),cvar)
  cvar='NEMAX'
  call check(nf90_put_att(icdf,id_nemax,cvar,"-# OF POINTS IN E GRID, MAX(1,MAXVAL(NE))"),cvar)
  cvar='NPMAX'
  call check(nf90_put_att(icdf,id_npmax,cvar,"-# OF POINTS IN P GRID, MAX(1,MAXVAL(NP))"),cvar)
  cvar='NMUMAX'
  call check(nf90_put_att(icdf,id_nmumax,cvar,"-# OF POINTS IN MU GRID, MAX(1,MAXVAL(NMU))"),cvar)
  cvar = 'NDE'
  call check(nf90_put_att(icdf,id_nde,cvar,"-# OF POINTS IN DE GRID THAT DEPEND ON NK"),cvar)
  cvar = 'NDP'
  call check(nf90_put_att(icdf,id_ndp,cvar,"-# OF POINTS IN DP GRID THAT DEPEND ON NK"),cvar)
  cvar = 'NE'
  call check(nf90_put_att(icdf,id_ne,cvar,"-# OF POINTS IN E GRID THAT DEPEND ON NK"),cvar)
  cvar = 'NP'
  call check(nf90_put_att(icdf,id_np,cvar,"-# OF POINTS IN P GRID THAT DEPEND ON NK"),cvar)
  cvar = 'NMU'
  call check(nf90_put_att(icdf,id_nmu,cvar,"-# OF POINTS IN MU GRID THAT DEPEND ON NK"),cvar)
  cvar='PAEP'
  call check(nf90_put_att(icdf,id_ndp,cvar,"-PAEP probability matrix"),cvar)
  
  ier = nf90_enddef(icdf) ! out of def mode and go to data mode
! WRITE Variables  
  cvar='SHOT'
  call check( nf90_put_var(icdf,id_ishot,ishot),cvar)
  cvar='DEVICE'
  call uupper(cdev)
  call check( nf90_put_var(icdf,id_dev,cdev),cvar)
  cvar = 'UFLABEL'  !UF label
  uflabel="-UF NETCDF"
  call check( nf90_put_var(icdf,id_uf,uflabel),cvar)
  cvar = 'ZSDATE'   !SHOT (DATA ORIGIN) DATE
  call uupper(zsdate)
  call check( nf90_put_var(icdf,id_zsdate,zsdate),cvar)
  cvar = 'ZDATE'    !FILE WRITE DATE
  call uupper(zdate)
  call check( nf90_put_var(icdf,id_zdate,zdate),cvar)
  cvar = 'IAEP_SP'
  call check( nf90_put_var(icdf,id_iaep_sp,iaep_sp(1:nk)),cvar)
  cvar='TM'
  call check( nf90_put_var(icdf,id_tm,tm(1:nt)),cvar)
  cvar='AAEP'
  call check( nf90_put_var(icdf,id_aaep,aaep(1:nt,1:nk)),cvar)
  cvar='TSTEP'
  call check( nf90_put_var(icdf,id_tstep,tstep(1:nk)),cvar)
  cvar='DEMIN'
  call check( nf90_put_var(icdf,id_demin,demin(1:nk)),cvar)
  cvar='DEMAX'
  call check( nf90_put_var(icdf,id_demax,demax(1:nk)),cvar)
  cvar='EMIN'
  call check( nf90_put_var(icdf,id_emin,emin(1:nk)),cvar)
  cvar='EMAX'
  call check( nf90_put_var(icdf,id_emax,emax(1:nk)),cvar)
  cvar='DPMIN'
  call check( nf90_put_var(icdf,id_dpmin,dpmin(1:nk)),cvar)
  cvar='DPMAX'
  call check( nf90_put_var(icdf,id_dpmax,dpmax(1:nk)),cvar)
  cvar='PMIN'
  call check( nf90_put_var(icdf,id_pmin,pmin(1:nk)),cvar)
  cvar='PMAX'
  call check( nf90_put_var(icdf,id_pmax,pmax(1:nk)),cvar)
  cvar='MUMIN'
  call check( nf90_put_var(icdf,id_mumin,mumin(1:nk)),cvar)
  cvar='MUMAX'
  call check( nf90_put_var(icdf,id_mumax,mumax(1:nk)),cvar)
  cvar = 'NDE'
  call check( nf90_put_var(icdf,id_nde,nde(1:nk)),cvar)
  cvar = 'NDP'
  call check( nf90_put_var(icdf,id_ndp,ndp(1:nk)),cvar)
  cvar = 'NE'
  call check( nf90_put_var(icdf,id_ne,ne(1:nk)),cvar)
  cvar = 'NP'
  call check( nf90_put_var(icdf,id_np,np(1:nk)),cvar)
  cvar = 'NMU'
  call check( nf90_put_var(icdf,id_nmu,nmu(1:nk)),cvar)
  cvar='PAEP'
  call check( nf90_put_var(icdf,id_paep,paep(1:ndemax,1:ndpmax,1:nemax,1:npmax,1:nmumax,1:nk)),cvar)
  
  ier = nf90_close( icdf)
  if(ier.ne.0) then
     call errorLog(' UFCDFWR_AEP: NETCDF close failure '//trim(filename))
     call bad_exit("UFCDFWR_AEP:  cannot create file")
  endif

  RETURN

contains 
  
  subroutine check(status,varnam)
    integer, intent ( in) :: status 
    character*(*),intent(in) :: varnam ! dimension name input 
    
    if(status /= nf90_noerr) then 
       call errorLog(' UFCDFWR_AEP: error:'& 
            &// trim(nf90_strerror(status))//' for var.= '//trim(varnam))
       call bad_exit 
    end if
  end subroutine check

  subroutine checkdim
    if(ndemax.ne.maxval(nde)) then
       call errorLog(' UFCDFWR_AEP: error in ndemax')
       ier=1
       call bad_exit 
    endif
    if(ndpmax.ne.maxval(ndp)) then
       call errorLog(' UFCDFWR_AEP: error in ndpmax')
       ier=1
       call bad_exit 
    endif
    if(nemax.ne.maxval(ne)) then
       call errorLog(' UFCDFWR_AEP: error in nemax')
       ier=1
       call bad_exit 
    endif
    if(npmax.ne.maxval(np)) then
       call errorLog(' UFCDFWR_AEP: error in npmax')
       ier=1
       call bad_exit 
    endif
    if(nmumax.ne.maxval(nmu)) then
       call errorLog(' UFCDFWR_AEP: error in nmumax')
       ier=1
       call bad_exit 
    endif
  end subroutine checkdim

END SUBROUTINE UFCDFWR_AEP
!******************** START FILE UFWRCDF_AEP_PACK.F90 ; GROUP UFILES *************!--------------------------------------------------------------
!  UFCDFWR_AEP_PACK
!  WRITE Multi-DIMENSIONAL DATA TO NetCdf FILE for AEP/RBQ model 
!
SUBROUTINE UFCDFWR_AEP_pack(filename,ZSDATE,ISHOT,CDEV,iaep_sp,&
     & NK,AAEP,TM,NT,Tstep,demin,demax,nde,dpmin,dpmax,ndp,emin,emax,ne,&
     & pmin,pmax,np,mumin,mumax,nmu,npack,idiff_map,PAEP,ndemax,ndpmax,nemax,npmax,nmumax,ctunits,ceunits,IER)
! 
!  MG  03/13/2014 
!  ISHOT -- ISHOT # ("139048")
!  IDEV-- 4 LETTER TOKAMAK DEV. CODE ("PLT ", ETC.)
!  nk -- terms # in Mario Pdesta series, # of modes
!
!  iaep_sp(NK) -- species code # to which AEP mode will be applied
!  species code #
!  0                   ;ALL fast ion SPECIES in this run (in NUBEAM)
!  1                   ;deuterium
!  2                   ;tritium
!  3                   ;HE3
!  4                   ;HE4
!  5                   ;protons          
!
!  AAEP(NT,NK) -- Mode amplitude. Aaep_k_specie(time)
!  nt -- # of points in time grig TM
!  TM(nt) -- time grid in ms
!  Tstep(nk) -- time step used to investigate AEP mode
!  demin(NK), demax(NK) -- left and right boundaries for a linear grid, function of nk (# of terms in MP series)
!  dpmin(NK), dpmax(NK) -- same as above
!  emin(NK), emax(NK) -- same as above
!  pmin(NK), pmax(NK) -- same as above
!  mumin(NK), mumax(NK) -- same as above
!  packed -- only non-zeros PAEP(npack)  -- probability matrix
!obsolite  PAEP(ndemax,ndpmax,nemax,npmax,nmumax,nk)  -- probability matrix
!  ndemax -- max(1,maxval(nde))
!  ndpmax -- max(1,maxval(ndp))
!  nemax -- max(1,maxval(ne))
!  npmax -- max(1,maxval(np))
!  nmumax -- max(1,maxval(nmu))
!  PROCESS CODE 0 = "RAW" raw data are saved
!  IER=0 ON RETURN IF WRITE WAS SUCCESSFUL
!
  use iso_c_binding, only: fp => c_double
  use netcdf
  implicit none
  character*(*),intent(in) :: filename !with path
  character*(*),intent(in):: CDEV
  integer,intent(in) :: ishot
  integer,intent(in), dimension(nk) :: iaep_sp
  integer,intent(in) :: nk,nt
  real(fp),intent(in)  :: AAEP(nt,nk)
  real(fp),intent(in)  :: tm(nt)
  integer,intent(in) :: nde(nk), ndp(nk), ne(nk), np(nk), nmu(nk)
  real(fp),intent(in)  :: tstep(nk)
  real(fp),intent(in)  :: demin(nk),demax(nk)
  real(fp),intent(in)  :: dpmin(nk),dpmax(nk)
  real(fp),intent(in)  :: emin(nk),emax(nk)
  real(fp),intent(in)  :: pmin(nk),pmax(nk)
  real(fp),intent(in)  :: mumin(nk),mumax(nk)
  integer,intent(in) :: ndemax,ndpmax,nemax,npmax,nmumax !PAEP dimentions
  integer,intent(in) :: npack,idiff_map(npack)
  real(fp),intent(in)  :: paep(npack)
  CHARACTER*9,intent(in) :: ctunits,ceunits ! units for time axis amd for energy axis
  CHARACTER*10,intent(in) :: ZSDATE !  ZSDATE-- SHOT DATE (10 CHARS, E.G. "10-AUG-81 ")
  CHARACTER*10 :: ZDATE  !  ZDATE - FILE WRITE DATE
  integer :: ier
  character*30 :: cvar
  character*10 :: uflabel
  integer :: ilbl,ilbl1 !label length
!netcdf var's IDs bellow
  integer :: icdf, id_lbl, id_lbl1, id_uf, id_dev, id_ishot, id_zsdate, id_zdate        
  integer :: id_iaep_sp, id_nk, id_nt, id_aaep, id_tm,id_tstep
  integer :: id_demin, id_demax, id_dpmin, id_dpmax, id_emin, id_emax, id_pmin, id_pmax
  integer :: id_mumin, id_mumax,id_nde, id_ndp, id_ne, id_np, id_nmu, id_paep
  integer :: id_ndemax,id_ndpmax,id_nemax,id_npmax,id_nmumax,id_npack,id_idiff_map
  character :: zbuf*24
!-----------------------------------------
!
!  WRITE ***
!
! sanitary check
  ier=0
  call checkdim
!OK now write netcdf file, raw data
!  IPROC = 0 
!  KMPRS = 4 !CDF file 
  call fdate(zbuf)
  if(zbuf(9:9).eq.' ')zbuf(9:9)=char(48)
  zdate=zbuf(9:10)//zbuf(5:7)//zbuf(21:24)

  call check(nf90_create(path=trim(adjustl(filename)),&
       & cmode=NF90_CLOBBER,ncid=icdf),trim(adjustl(filename)))
  
  cvar='DEVLBL'
  ilbl=4
  call check(nf90_def_dim(icdf,cvar,ilbl,id_lbl),cvar)
  cvar='SHOT'
  call check(nf90_def_var(icdf,cvar,NF90_INT,id_ishot),cvar)
  cvar='DEVICE'
  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl/),id_dev),cvar)
  cvar='UFLBL'
  ilbl1=10
  call check(nf90_def_dim(icdf,cvar,ilbl1,id_lbl1),cvar)
  cvar = 'UFLABEL'  !UF label
  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_uf),cvar)
  cvar = 'ZSDATE'   !SHOT (DATA ORIGIN) DATE
  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_zsdate),cvar)
  cvar = 'ZDATE'    !FILE WRITE DATE
  call check(nf90_def_var(icdf,cvar,NF90_CHAR,(/id_lbl1/),id_zdate),cvar)
  cvar='NK'
  call check(nf90_def_dim(icdf,cvar,nk,id_nk),cvar)
  cvar='NT'
  call check(nf90_def_dim(icdf,cvar,nt,id_nt),cvar)
  cvar='NDEMAX'
  call check(nf90_def_dim(icdf,cvar,ndemax,id_ndemax),cvar)
  cvar='NDPMAX'
  call check(nf90_def_dim(icdf,cvar,ndpmax,id_ndpmax),cvar)
  cvar='NEMAX'
  call check(nf90_def_dim(icdf,cvar,nemax,id_nemax),cvar)
  cvar='NPMAX'
  call check(nf90_def_dim(icdf,cvar,npmax,id_npmax),cvar)
  cvar='NMUMAX'
  call check(nf90_def_dim(icdf,cvar,nmumax,id_nmumax),cvar)
  cvar='NPACK'
  call check(nf90_def_dim(icdf,cvar,npack,id_npack),cvar)
  cvar = 'IDIFF_MAP'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_npack/),id_idiff_map),cvar)
  cvar = 'IAEP_SP'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_iaep_sp),cvar)
  cvar='TM'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nt/),id_tm),cvar)
  cvar='AAEP'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nt,id_nk/),id_aaep),cvar)
  cvar='TSTEP'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_tstep),cvar)
  cvar='DEMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_demin),cvar)
  cvar='DEMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_demax),cvar)
  cvar='DPMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_dpmin),cvar)
  cvar='DPMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_dpmax),cvar)
  cvar='EMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_emin),cvar)
  cvar='EMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_emax),cvar)
  cvar='PMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_pmin),cvar)
  cvar='PMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_pmax),cvar)
  cvar='MUMIN'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_mumin),cvar)
  cvar='MUMAX'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_nk/),id_mumax),cvar)
  cvar = 'NDE'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_nde),cvar)
  cvar = 'NDP'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_ndp),cvar)
  cvar = 'NE'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_ne),cvar)
  cvar = 'NP'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_np),cvar)
  cvar = 'NMU'
  call check(nf90_def_var(icdf,cvar,NF90_INT,(/id_nk/),id_nmu),cvar)
   cvar='PAEP'
  call check(nf90_def_var(icdf,cvar,NF90_DOUBLE,(/id_npack/),id_paep),cvar)
! define attributes
  cvar='SHOT'
  call check(nf90_put_att(icdf,id_ishot,cvar,"-SHOT #"),cvar)
  cvar='DEVICE'
  call check(nf90_put_att(icdf,id_dev,cvar,"-DEVICE NAME"),cvar)
  cvar = 'UFLABEL'  !UF label
  call check(nf90_put_att(icdf,id_uf,cvar,"-UF LABEL"),cvar)
  cvar = 'ZSDATE'   !SHOT (DATA ORIGIN) DATE
  call check(nf90_put_att(icdf,id_zsdate,cvar,"-SHOT (DATA ORIGIN) DATE"),cvar)
  cvar = 'ZDATE'    !FILE WRITE DATE
  call check(nf90_put_att(icdf,id_zdate,cvar,"-FILE WRITE DATE"),cvar)
  cvar = 'IDIFF_MAP'
  call check(nf90_put_att(icdf,id_idiff_map,cvar," indecies mapping for non-zeros"),cvar)
  cvar = 'IAEP_SP'
  call check(nf90_put_att(icdf,id_iaep_sp,cvar,"-FAST ION code #: 0--ALL, 1--D,&
        2--T, 3--HE3, 4--HE4, 5--p"),cvar)
  cvar='NK'
  CALL check(nf90_put_att(icdf,id_nk,cvar,"-# OF TERMS IN MARIO PODESTA AEP OPERATOR"),cvar)
  cvar='NT'
  call check(nf90_put_att(icdf,id_nt,cvar,"-# OF POINTS IN TIME GRID TM FOR AEP MODE AMPLITUDE"),cvar)
  cvar='TM'
  call check(nf90_put_att(icdf,id_tm,cvar,"-TIME GRID TM FOR AEP MODE AMPLITUDE,"//ctunits),cvar)
  cvar='AAEP'
  call check(nf90_put_att(icdf,id_aaep,cvar,"-AEP MODE AMPLITUDE"),cvar)
  cvar='TSTEP'
  call check(nf90_put_att(icdf,id_tstep,cvar,"-TIME STEP USED IN SIMULATION,"//ctunits),cvar)
  cvar='DEMIN'
  call check(nf90_put_att(icdf,id_demin,cvar,"-LEFT BOUNDARY FOR DELTA E GRID,"//ceunits),cvar)
  cvar='DEMAX'
  call check(nf90_put_att(icdf,id_demax,cvar,"-RIGHT BOUNDARY FOR DELTA E GRID,"//ceunits),cvar)
  cvar='EMIN'
  call check(nf90_put_att(icdf,id_emin,cvar,"-LEFT BOUNDARY FOR ENERGY GRID,"//ceunits),cvar)
  cvar='EMAX'
  call check(nf90_put_att(icdf,id_emax,cvar,"-RIGHT BOUNDARY FOR ENERGY GRID,"//ceunits),cvar)
  cvar='DPMIN'
  call check(nf90_put_att(icdf,id_dpmin,cvar,"-LEFT BOUNDARY FOR DELTA P GRID"),cvar)
  cvar='DPMAX'
  call check(nf90_put_att(icdf,id_dpmax,cvar,"-RIGHT BOUNDARY FOR DELTA P GRID"),cvar)
  cvar='PMIN'
  call check(nf90_put_att(icdf,id_pmin,cvar,"-LEFT BOUNDARY FOR P(CANONICAL MOMENTUM) GRID"),cvar)
  cvar='PMAX'
  call check(nf90_put_att(icdf,id_pmax,cvar,"-RIGHT BOUNDARY FOR P(CANONICAL MOMENTUM) GRID"),cvar)
  cvar='MUMIN'
  call check(nf90_put_att(icdf,id_mumin,cvar,"-LEFT BOUNDARY FOR mu(MAGNETIC MOMENT) GRID"),cvar)
  cvar='MUMAX'
  call check(nf90_put_att(icdf,id_mumax,cvar,"-RIGHT BOUNDARY FOR mu(MAGNETIC MOMENT) GRID"),cvar)
  cvar='NDEMAX'
  call check(nf90_put_att(icdf,id_ndemax,cvar,"-# OF POINTS IN DE GRID, MAX(1,MAXVAL(NDE))"),cvar)
  cvar='NDPMAX'
  call check(nf90_put_att(icdf,id_ndpmax,cvar,"-# OF POINTS IN DP GRID, MAX(1,MAXVAL(NDP))"),cvar)
  cvar='NEMAX'
  call check(nf90_put_att(icdf,id_nemax,cvar,"-# OF POINTS IN E GRID, MAX(1,MAXVAL(NE))"),cvar)
  cvar='NPMAX'
  call check(nf90_put_att(icdf,id_npmax,cvar,"-# OF POINTS IN P GRID, MAX(1,MAXVAL(NP))"),cvar)
  cvar='NMUMAX'
  call check(nf90_put_att(icdf,id_nmumax,cvar,"-# OF POINTS IN MU GRID, MAX(1,MAXVAL(NMU))"),cvar)
  cvar='NPACK'
  call check(nf90_put_att(icdf,id_npack,cvar,"-# OF NON-ZEROS POINTS IN PROBABILY MATRIX"),cvar)
  cvar = 'NDE'
  call check(nf90_put_att(icdf,id_nde,cvar,"-# OF POINTS IN DE GRID THAT DEPEND ON NK"),cvar)
  cvar = 'NDP'
  call check(nf90_put_att(icdf,id_ndp,cvar,"-# OF POINTS IN DP GRID THAT DEPEND ON NK"),cvar)
  cvar = 'NE'
  call check(nf90_put_att(icdf,id_ne,cvar,"-# OF POINTS IN E GRID THAT DEPEND ON NK"),cvar)
  cvar = 'NP'
  call check(nf90_put_att(icdf,id_np,cvar,"-# OF POINTS IN P GRID THAT DEPEND ON NK"),cvar)
  cvar = 'NMU'
  call check(nf90_put_att(icdf,id_nmu,cvar,"-# OF POINTS IN MU GRID THAT DEPEND ON NK"),cvar)
  cvar='PAEP'
  call check(nf90_put_att(icdf,id_ndp,cvar,"-PAEP packed probability matrix"),cvar)
  
  ier = nf90_enddef(icdf) ! out of def mode and go to data mode
! WRITE Variables  
  cvar='SHOT'
  call check( nf90_put_var(icdf,id_ishot,ishot),cvar)
  cvar='DEVICE'
  call uupper(cdev)
  call check( nf90_put_var(icdf,id_dev,cdev),cvar)
  cvar = 'UFLABEL'  !UF label
  uflabel="-UF NETCDF"
  call check( nf90_put_var(icdf,id_uf,uflabel),cvar)
  cvar = 'ZSDATE'   !SHOT (DATA ORIGIN) DATE
  call uupper(zsdate)
  call check( nf90_put_var(icdf,id_zsdate,zsdate),cvar)
  cvar = 'ZDATE'    !FILE WRITE DATE
  call uupper(zdate)
  call check( nf90_put_var(icdf,id_zdate,zdate),cvar)
  cvar = 'IDIFF_MAP'
  call check( nf90_put_var(icdf,id_idiff_map,idiff_map(1:npack)),cvar)
  cvar = 'IAEP_SP'
  call check( nf90_put_var(icdf,id_iaep_sp,iaep_sp(1:nk)),cvar)
  cvar='TM'
  call check( nf90_put_var(icdf,id_tm,tm(1:nt)),cvar)
  cvar='AAEP'
  call check( nf90_put_var(icdf,id_aaep,aaep(1:nt,1:nk)),cvar)
  cvar='TSTEP'
  call check( nf90_put_var(icdf,id_tstep,tstep(1:nk)),cvar)
  cvar='DEMIN'
  call check( nf90_put_var(icdf,id_demin,demin(1:nk)),cvar)
  cvar='DEMAX'
  call check( nf90_put_var(icdf,id_demax,demax(1:nk)),cvar)
  cvar='EMIN'
  call check( nf90_put_var(icdf,id_emin,emin(1:nk)),cvar)
  cvar='EMAX'
  call check( nf90_put_var(icdf,id_emax,emax(1:nk)),cvar)
  cvar='DPMIN'
  call check( nf90_put_var(icdf,id_dpmin,dpmin(1:nk)),cvar)
  cvar='DPMAX'
  call check( nf90_put_var(icdf,id_dpmax,dpmax(1:nk)),cvar)
  cvar='PMIN'
  call check( nf90_put_var(icdf,id_pmin,pmin(1:nk)),cvar)
  cvar='PMAX'
  call check( nf90_put_var(icdf,id_pmax,pmax(1:nk)),cvar)
  cvar='MUMIN'
  call check( nf90_put_var(icdf,id_mumin,mumin(1:nk)),cvar)
  cvar='MUMAX'
  call check( nf90_put_var(icdf,id_mumax,mumax(1:nk)),cvar)
  cvar = 'NDE'
  call check( nf90_put_var(icdf,id_nde,nde(1:nk)),cvar)
  cvar = 'NDP'
  call check( nf90_put_var(icdf,id_ndp,ndp(1:nk)),cvar)
  cvar = 'NE'
  call check( nf90_put_var(icdf,id_ne,ne(1:nk)),cvar)
  cvar = 'NP'
  call check( nf90_put_var(icdf,id_np,np(1:nk)),cvar)
  cvar = 'NMU'
  call check( nf90_put_var(icdf,id_nmu,nmu(1:nk)),cvar)
  cvar='PAEP'
  call check( nf90_put_var(icdf,id_paep,paep(1:npack)),cvar)
  
  ier = nf90_close( icdf)
  if(ier.ne.0) then
     write(*,*)' UFCDFWR_AEP_PACK: NETCDF close failure '//trim(filename)
     call exit(ier)
  endif

  RETURN

contains 
  
  subroutine check(status,varnam)
    integer, intent ( in) :: status 
    character*(*),intent(in) :: varnam ! dimension name input 
    
    if(status /= nf90_noerr) then 
       write(*,*)' UFCDFWR_AEP_PACK: error:'& 
            &//trim(nf90_strerror(status))//' for var.= '//trim(varnam)
       call exit(ier) 
    end if
  end subroutine check

  subroutine checkdim
    if(ndemax.ne.maxval(nde)) then
       write(*,*)' UFCDFWR_AEP_PACK: error in ndemax'
       ier=1
       call exit 
    endif
    if(ndpmax.ne.maxval(ndp)) then
       write(*,*)' UFCDFWR_AEP_PACK: error in ndpmax'
       ier=1
       call exit(ier) 
    endif
    if(nemax.ne.maxval(ne)) then
       write(*,*)' UFCDFWR_AEP_PACK: error in nemax'
       ier=1
       call exit(ier) 
    endif
    if(npmax.ne.maxval(np)) then
       write(*,*)' UFCDFWR_AEP_PACK: error in npmax'
       ier=1
       call exit(ier) 
    endif
    if(nmumax.ne.maxval(nmu)) then
       write(*,*)' UFCDFWR_AEP_PACK: error in nmumax'
       ier=1
       call exit(ier) 
    endif
  end subroutine checkdim

END SUBROUTINE UFCDFWR_AEP_PACK

!------------------------------------------------------------------------------
!
      SUBROUTINE DELTA_BEAM_Z(E_BEAM, BEAM_SPECIES,TEMP,&
     		THERMAL_SPECIES, EPS, ITER, NREACT, KK, IERR,&
     		SIGV_1, SIGV_2)
!
!...This routine was written by Harry H. Towner of the Princeton Plasma
!...Physics Lab. This routine will calculate the reaction rate between a
!...Delta function beam and a thermal background plasma.
!
!...PARAMETER LIST:
!*..E_BEAM - The energy of the incident beam. (keV)
!*..BEAM_SPECIES - The mass of the beam species. (kev/C**2)
!*..TEMP - The temperature of the thermal species. (keV)
!*..THERMAL_SPECIES - The mass of the thermal species. (keV/C**2)
!*..EPS - The desired relative error.
!*..ITER - The maximum # of iterations to be taken to achieve
!	   relative error EPS.  (see above)
!*..NREACT - Specifies the desired reaction and may have the value:
!     1)   T(D,N)HE4	      2)   HE3(D,P)HE4
!     3)   D(D,P)T	      4)   D(D,N)HE3
!     5)   T(T,2N)HE4	      6)   T(HE3,X)Y
!     12)   T(T,2N)HE4	     !DPC fit, 06/2018
!     7)   3&4 (currently not working)
!*..KK - If 0 reactions are as above. (i.e. D -> T). If KK = 1 then
!	 the reaction is reversed (i.e. T -> D).
!*..IERR - The error code returned.
!		= 1 sucess
!		= 2 maximum iterations reached.
!...SIGV_1 - The value of <sigma*v> (m**3/sec).  If nreact=7 SIGV_1 is
!		 for reaction 4.
!...SIGV_2 - The value of <sigma*v> (m**3/sec).  SIGV_2 = 0.E00 unless
!		nreact=7 then SIGV_2 is for reaction 3.
!
!...Note the the "*" indicates input parameters.
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only : zero,half,two,sqrt_pi=>sqpi,VC,zev2kev
  IMPLICIT NONE
  INTEGER iter,nreact,kk,ierr,j,k,i
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) beam_species,temp,thermal_species,eps,sigv_1,sigv_2,&
       e_beam,c2,v_beam,sigma_z,vmin_cut,&
       vmax_thermal,beta2,beta,anorm,vlow,vhigh,a,b,relative_error,&
       xlow,sigv_1_old,sigv_2_old,sum_1,sum_2,xhigh,c1,c0,z,v,v2,&
       arg_1,arg_2,exp1,exp2,e_incident,fun
  real(fp) :: ecut
!============
  real(fp) :: X(6), W(6), E_CUT(6)
!
  DATA X/-.932469514203152_fp,	-.661209386466265_fp,&
       -.238619186083197_fp,	 .238619186083197_fp,&
       .661209386466265_fp,	 .932469514203152_fp/
!
  DATA W/.171324492379170_fp,	 .360761573048139_fp,&
       .467913934572691_fp,	 .467913934572691_fp,&
       .360761573048139_fp,	 .171324492379170_fp/
  !
  DATA E_CUT/.120_fp,	.470_fp,	.132_fp,&
       .145_fp,	.095_fp,	.920_fp/
!
  C2=VC*VC
!
!...Array X contains the roots of the legendre polynomial.
!...Array W contains the weight factors.
!...Array E_CUT contains the lowest energy cut-off for a given reaction.
!
!******************************************************************************
!
!...Define various velocities.
!
  V_BEAM = SQRT(two*E_BEAM*C2/BEAM_SPECIES)
!
  IF (E_BEAM*zev2kev.GT. TEMP) THEN
     SIGV_1 = SIGMA_Z(NREACT,KK,6,E_BEAM)*V_BEAM
     IERR = 1
  ELSE
     if(nreact.eq.12) then
        ecut=e_cut(5)
     else
        ecut=E_CUT(NREACT)
     endif
     VMIN_CUT = SQRT(two*ECUT*C2/BEAM_SPECIES)
     VMAX_THERMAL = SQRT(two*87.5_fp*TEMP*C2/THERMAL_SPECIES)
!
     BETA2 = half*THERMAL_SPECIES/(TEMP*C2)
     BETA = SQRT(BETA2)
     ANORM = BETA/(V_BEAM*SQRT_PI)
!
!******************************************************************************
!
!...Now find <SIGMA*V> for a delta function beam and a thermal background
!
     VLOW = VMIN_CUT
     VHIGH = V_BEAM + VMAX_THERMAL
!
     A = VLOW
     B = VHIGH
     J = 1
!
!	J tells how meny times to apply quadrature to interval.
!
     SIGV_1 = zero
     SIGV_2 = zero
     RELATIVE_ERROR = 100.0_fp
!
     DO WHILE (RELATIVE_ERROR .GT. EPS)
        XLOW = A
        SIGV_1_OLD = SIGV_1
        SIGV_2_OLD = SIGV_2
        SUM_1 = zero
        SUM_2 = zero
!
        DO K=1,J
           XHIGH = XLOW+(B-A)/J
           C1 = (XHIGH-XLOW)*half
           C0 = C1+XLOW
!
           DO I=1,6
              Z = C1*X(I)
              V = C0 + Z
              V2 = V*V
              ARG_1 = -BETA2*(V_BEAM - V)**2
              ARG_2 = -BETA2*(V_BEAM + V)**2
!
              IF (ARG_1 .GT. -87.5_fp) THEN
                 EXP1 = EXP(ARG_1)
!
                 IF (ARG_2 .GT. -87.5_fp) THEN
                    EXP2 = EXP(ARG_2)
                 ELSE
                    EXP2 = zero
                 END IF
!
                 E_INCIDENT = half*BEAM_SPECIES*(V2/C2)
!
                 FUN = (SIGMA_Z(NREACT,KK,6,E_INCIDENT)*V2*1.e+30_fp)*&
                      (EXP1 - EXP2)
                 SUM_1 = SUM_1 + C1*W(I)*FUN
              END IF
!
           END DO
!
           XLOW = XHIGH
        END DO
!
        IF (SUM_1 .GT. 1.e-8_fp) THEN
           SIGV_1 = (SUM_1*ANORM)*1.e-30_fp
           SIGV_2 = (SUM_2*ANORM)*1.e-30_fp
        ELSE
           SIGV_1 = zero
           SIGV_2 = zero
        END IF
!
!...Test for convergence.
!
        IF (SIGV_1 .EQ. zero) THEN
           IERR = 1
           RETURN
        ELSE
           RELATIVE_ERROR = ABS((SIGV_1 - SIGV_1_OLD)/&
     		SIGV_1)
!
           IF (RELATIVE_ERROR .LE. EPS) THEN
              IERR = 1
              RETURN
           ELSE
              J = J*2
!
              IF (J .GT. ITER) THEN
                 J = J/2
                 IERR = 2
                 RETURN
              END IF
!
           END IF
!
        END IF
!
     END DO
!
  END IF
!
  RETURN
END SUBROUTINE DELTA_BEAM_Z
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"

      subroutine ugetlog(zbuff)
      character*(*) zbuff               ! for username string, output
c
c  return the current username
c
c
      character*80 homedir
      character*150 ztmpfile
      integer ilz,iln,ier
c
      call sget_env('LOGNAME',zbuff)
      if(zbuff.eq.' ') then
         call sget_env('USER',zbuff)
         if(zbuff.eq.' ') then
c
c  (perhaps the C routine getlogin_r() could be used; a portlib C wrapper
c  would have to be added; byte_declare used, etc.)
c
            write(0,*) ' ?ugetlog,sget_user: could not get username.'
            zbuff = 'unknown'

         endif
      endif
      return
      end

C******************** START FILE SPLCRD.FOR ; GROUP TKSERVE ************
C.............................................................
 
        SUBROUTINE SPLCRDA (ZXI99, IJACI,
     >                     LCENTR, MIMOM, NMOM, MTBL, XIBLO,
     >                     RMCX,RMCXS,YMCX,YMCXS,
     >			   ZRMCX1,ZRMCX2,ZYMCX1,ZYMCX2,
     >		           ZRMCXP1,ZRMCXP2,ZYMCXP1,ZYMCXP2)
 
C
C  B.BALET - JET  MAR 1994 : MODIFIED VERSION OF SPLCRD.FOR TO SUPPORT
C                            UP-DOWN ASYMMETRIC CASE; SHOULD BE CALLED
C                            ONLY IF LEVGEO = 6 or 7 or 8 or 9 (NLSYM = F)
c
c  dmc 24 Dec 1996:  this version does not depend on TRCOM:  all args passed.
c  ** updown asymmetric SPLCRDA **
c
c  call from MOMRY/MOMRZ; caller does arg error checking!
c
c  input args:
c
c   ZXI99 -- "xi" (radial coordinate) **** must be in range ****
c     ==> interpolate moments set to "xi"
c   IJACI -- IJAC flag as input (see below)
c
c   LCENTR -- 1 + index offset in XIBLO, RMB0, RMB2, YMB2, rel. to.
c      RMB0S,RMB2S,YMB2S
c      (for TRANSP compatibility; set to 1 if all arrays are on
c      the same indexing grid)
c
c   MIMOM -- max no. of moments (array dimension)
c   NMOM  -- actual no. of moments in use
c   MTBL --- max no. of radial points including "bloat" (array dimension)
c
c   XIBLO(..) -- "xi" grid points, including bloat region beyond plasma bdy
c
c   RMCX(..) -- R moments array
c   RMCXS(..) -- R moments spline coeffs
c   YMCX(..) -- Y moments array
c   YMCXS(..) -- Y moments spline coeffs
c
c  output args:
c   ZRMCX1(..) -- R cos moments interpolated
c   ZRMCX2(..) -- R sin moments interpolated
c   ZYMCX1(..) -- Y cos moments interpolated
c   ZYMCX2(..) -- Y sin moments interpolated
c  (if IJAC set):  derivatives w.r.t. xi:
c   ZRMCXP1(..) -- R cos moments derivative
c   ZRMCXP2(..) -- R sin moments derivative
c   ZYMCXP1(..) -- Y cos moments derivative
c   ZYMCXP2(..) -- Y sin moments derivative
c
C
C	EVALUATE SPLINE COEFFICIENTS DIRECTLY ... GIVEN A RADIAL
C	COORD "ZXI99", RETURN THE MHD FOURIER COEFFICIENTS (AND THEIR
C	DERIVATIVES) DESCRIBING THE PLASMA SURFACE ON THAT COORD.
C
C  MOD DMC APRIL 1990 -- LINEAR INTERPOLATION OPTION
C
C  IF IJAC=0 OR IJAC=1 USE THE SPLINES
C  IF IJAC=2 OR IJAC=3 DO LINEAR INTERPOLATION INSTEAD
C
C  IF IJAC=1 OR IJAC=3 EVALUATE DATA FOR THE JACOBIAN
C
C   input arrays:
 
        REAL XIBLO(MTBL)
        REAL RMCX(MTBL,0:MIMOM,2),RMCXS(MTBL,0:MIMOM,2,3)
        REAL YMCX(MTBL,0:MIMOM,2),YMCXS(MTBL,0:MIMOM,2,3)
 
C   output arrays:
 
        DIMENSION ZRMCX1(0:MIMOM), ZRMCX2(0:MIMOM)
        DIMENSION ZYMCX1(0:MIMOM), ZYMCX2(0:MIMOM)
        DIMENSION ZRMCXP1(0:MIMOM), ZRMCXP2(0:MIMOM)
        DIMENSION ZYMCXP1(0:MIMOM), ZYMCXP2(0:MIMOM)
 
C
C-------------------------------------
C
        IJAC=abs(IJACI)
C
        ZDXII= 1.0 / (XIBLO(LCENTR+1)-XIBLO(LCENTR))
        IS = ZXI99 * ZDXII + 1
C
 20     continue
        ISL1=IS+LCENTR-1
        if(zxi99.le.xiblo(isl1)) then
           is=is-1
           go to 20
        endif
        if(zxi99.gt.xiblo(isl1+1)) then
           is=is+1
           go to 20
        endif
C
        ZDX99 = ZXI99 - XIBLO(ISL1)
C
        IF(IJAC.LE.1) THEN
 
C	EVALUATE SPLINE
C
           DO 100 J = 0, NMOM
 
C	      RM(X) :
C
            ZRMCX1(J) = RMCX(ISL1,J,1) + ZDX99*(RMCXS(IS,J,1,1) +
     >		       ZDX99*(RMCXS(IS,J,1,2) + ZDX99*RMCXS(IS,J,1,3)))
              ZRMCX2(J) = RMCX(ISL1,J,2) + ZDX99*(RMCXS(IS,J,2,1) +
     >                 ZDX99*(RMCXS(IS,J,2,2) + ZDX99*RMCXS(IS,J,2,3)))
C
C	      YM(X) :
C
              ZYMCX1(J) = YMCX(ISL1,J,1) + ZDX99*(YMCXS(IS,J,1,1) +
     >                 ZDX99*(YMCXS(IS,J,1,2) + ZDX99*YMCXS(IS,J,1,3)))
              ZYMCX2(J) = YMCX(ISL1,J,2) + ZDX99*(YMCXS(IS,J,2,1) +
     >                 ZDX99*(YMCXS(IS,J,2,2) + ZDX99*YMCXS(IS,J,2,3)))
 
 100       CONTINUE
 
        ELSE
C
C  EVALUATE BY LINEAR INTERPOLATION
C
           ISP1=ISL1+1
           ZDX99I=ZDX99*ZDXII
C
           DO 110 J = 0, NMOM
 
              ZRMCX1(J)= RMCX(ISL1,J,1) +
     >           ZDX99I*(RMCX(ISP1,J,1)-RMCX(ISL1,J,1))
              ZRMCX2(J)= RMCX(ISL1,J,2) +
     >           ZDX99I*(RMCX(ISP1,J,2)-RMCX(ISL1,J,2))
              ZYMCX1(J)= YMCX(ISL1,J,1) +
     >           ZDX99I*(YMCX(ISP1,J,1)-YMCX(ISL1,J,1))
              ZYMCX2(J)= YMCX(ISL1,J,2) +
     >           ZDX99I*(YMCX(ISP1,J,2)-YMCX(ISL1,J,2))
 
 110       CONTINUE
 
        ENDIF
 
C..................................
 
        IF (IJAC.EQ.0) RETURN
        IF (IJAC.EQ.2) RETURN
 
C..................................
 
        IF(IJAC.LE.1) THEN
C
C  SPLINES
C
           DO 200 J = 0, NMOM
 
C     D[RM(X)]/DX
              ZRMCXP1(J) = RMCXS(IS,J,1,1) + ZDX99*(2.*RMCXS(IS,J,1,2) +
     >           3.*ZDX99*RMCXS(IS,J,1,3))
              ZRMCXP2(J) = RMCXS(IS,J,2,1) + ZDX99*(2.*RMCXS(IS,J,2,2) +
     >           3.*ZDX99*RMCXS(IS,J,2,3))
 
C     D[YM(X)]/DX
              ZYMCXP1(J) = YMCXS(IS,J,1,1) + ZDX99*(2.*YMCXS(IS,J,1,2) +
     >           3.*ZDX99*YMCXS(IS,J,1,3))
              ZYMCXP2(J) = YMCXS(IS,J,2,1) + ZDX99*(2.*YMCXS(IS,J,2,2) +
     >           3.*ZDX99*YMCXS(IS,J,2,3))
 
 200       CONTINUE
 
        ELSE
C
C  LINEAR INTERPOLATION
C
           DO 210 J = 0, NMOM
 
              ZRMCXP1(J) = (RMCX(ISP1,J,1)-RMCX(ISL1,J,1))*ZDXII
              ZRMCXP2(J) = (RMCX(ISP1,J,2)-RMCX(ISL1,J,2))*ZDXII
              ZYMCXP1(J) = (YMCX(ISP1,J,1)-YMCX(ISL1,J,1))*ZDXII
              ZYMCXP2(J) = (YMCX(ISP1,J,2)-YMCX(ISL1,J,2))*ZDXII
 
 210       CONTINUE
 
        ENDIF
C
        RETURN
        END
C******************** END FILE SPLCRD.FOR ; GROUP TKSERVE **************

*DECK TR_SSORT
      SUBROUTINE TR_SSORT (X, Y, N, KFLAG)
C***BEGIN PROLOGUE  TR_SSORT
C***PURPOSE  Sort an array and optionally make the same interchanges in
C            an auxiliary array.  The array may be sorted in increasing
C            or decreasing order.  A slightly modified QUICKSORT
C            algorithm is used.
C***LIBRARY   SLATEC
C***CATEGORY  N6A2B
C***TYPE      SINGLE PRECISION (TR_SSORT-S, DSORT-D, ISORT-I)
C***KEYWORDS  SINGLETON QUICKSORT, SORT, SORTING
C***AUTHOR  Jones, R. E., (SNLA)
C           Wisniewski, J. A., (SNLA)
C***DESCRIPTION
C
C   TR_SSORT sorts array X and optionally makes the same interchanges in
C   array Y.  The array X may be sorted in increasing order or
C   decreasing order.  A slightly modified quicksort algorithm is used.
C
C   Description of Parameters
C      X - array of values to be sorted   (usually abscissas)
C      Y - array to be (optionally) carried along
C      N - number of values in array X to be sorted
C      KFLAG - control parameter
C            =  2  means sort X in increasing order and carry Y along.
C            =  1  means sort X in increasing order (ignoring Y)
C            = -1  means sort X in decreasing order (ignoring Y)
C            = -2  means sort X in decreasing order and carry Y along.
C
C***REFERENCES  R. C. Singleton, Algorithm 347, An efficient algorithm
C                 for sorting with minimal storage, Communications of
C                 the ACM, 12, 3 (1969), pp. 185-187.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   761101  DATE WRITTEN
C   761118  Modified to use the Singleton quicksort algorithm.  (JAW)
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891009  Removed unreferenced statement labels.  (WRB)
C   891024  Changed category.  (WRB)
C   891024  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   901012  Declared all variables; changed X,Y to SX,SY. (M. McClain)
C   920501  Reformatted the REFERENCES section.  (DWL, WRB)
C   920519  Clarified error messages.  (DWL)
C   920801  Declarations section rebuilt and code restructured to use
C           IF-THEN-ELSE-ENDIF.  (RWC, WRB)
C***END PROLOGUE  TR_SSORT
C     .. Scalar Arguments ..
      INTEGER KFLAG, N
C     .. Array Arguments ..
      REAL X(*), Y(*)
C     .. Local Scalars ..
      REAL R, T, TT, TTY, TY
      INTEGER I, IJ, J, K, KK, L, M, NN
C     .. Local Arrays ..
      INTEGER IL(21), IU(21)
C     .. External Subroutines ..
C     .. Intrinsic Functions ..
      INTRINSIC ABS, INT
C***FIRST EXECUTABLE STATEMENT  TR_SSORT
      NN = N
      IF (NN .LT. 1) THEN
         write(6,*) ' ?tr_ssort:  n.gt.0 expected, n = ',n
         RETURN
      ENDIF
C
      KK = ABS(KFLAG)
      IF (KK.NE.1 .AND. KK.NE.2) THEN
         write(6,*) ' ?tr_ssort: kflag = ',kflag,' not in {-2,-1,1,2}'
         RETURN
      ENDIF
C
C     Alter array X to get decreasing order if needed
C
      IF (KFLAG .LE. -1) THEN
         DO 10 I=1,NN
            X(I) = -X(I)
   10    CONTINUE
      ENDIF
C
      IF (KK .EQ. 2) GO TO 100
C
C     Sort X only
C
      M = 1
      I = 1
      J = NN
      R = 0.375E0
C
   20 IF (I .EQ. J) GO TO 60
      IF (R .LE. 0.5898437E0) THEN
         R = R+3.90625E-2
      ELSE
         R = R-0.21875E0
      ENDIF
C
   30 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = X(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (X(I) .GT. T) THEN
         X(IJ) = X(I)
         X(I) = T
         T = X(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than than T, interchange with T
C
      IF (X(J) .LT. T) THEN
         X(IJ) = X(J)
         X(J) = T
         T = X(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (X(I) .GT. T) THEN
            X(IJ) = X(I)
            X(I) = T
            T = X(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
   40 L = L-1
      IF (X(L) .GT. T) GO TO 40
C
C     Find an element in the first half of the array which is greater
C     than T
C
   50 K = K+1
      IF (X(K) .LT. T) GO TO 50
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = X(L)
         X(L) = X(K)
         X(K) = TT
         GO TO 40
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 70
C
C     Begin again on another portion of the unsorted array
C
   60 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
   70 IF (J-I .GE. 1) GO TO 30
      IF (I .EQ. 1) GO TO 20
      I = I-1
C
   80 I = I+1
      IF (I .EQ. J) GO TO 60
      T = X(I+1)
      IF (X(I) .LE. T) GO TO 80
      K = I
C
   90 X(K+1) = X(K)
      K = K-1
      IF (T .LT. X(K)) GO TO 90
      X(K+1) = T
      GO TO 80
C
C     Sort X and carry Y along
C
  100 M = 1
      I = 1
      J = NN
      R = 0.375E0
C
  110 IF (I .EQ. J) GO TO 150
      IF (R .LE. 0.5898437E0) THEN
         R = R+3.90625E-2
      ELSE
         R = R-0.21875E0
      ENDIF
C
  120 K = I
C
C     Select a central element of the array and save it in location T
C
      IJ = I + INT((J-I)*R)
      T = X(IJ)
      TY = Y(IJ)
C
C     If first element of array is greater than T, interchange with T
C
      IF (X(I) .GT. T) THEN
         X(IJ) = X(I)
         X(I) = T
         T = X(IJ)
         Y(IJ) = Y(I)
         Y(I) = TY
         TY = Y(IJ)
      ENDIF
      L = J
C
C     If last element of array is less than T, interchange with T
C
      IF (X(J) .LT. T) THEN
         X(IJ) = X(J)
         X(J) = T
         T = X(IJ)
         Y(IJ) = Y(J)
         Y(J) = TY
         TY = Y(IJ)
C
C        If first element of array is greater than T, interchange with T
C
         IF (X(I) .GT. T) THEN
            X(IJ) = X(I)
            X(I) = T
            T = X(IJ)
            Y(IJ) = Y(I)
            Y(I) = TY
            TY = Y(IJ)
         ENDIF
      ENDIF
C
C     Find an element in the second half of the array which is smaller
C     than T
C
  130 L = L-1
      IF (X(L) .GT. T) GO TO 130
C
C     Find an element in the first half of the array which is greater
C     than T
C
  140 K = K+1
      IF (X(K) .LT. T) GO TO 140
C
C     Interchange these elements
C
      IF (K .LE. L) THEN
         TT = X(L)
         X(L) = X(K)
         X(K) = TT
         TTY = Y(L)
         Y(L) = Y(K)
         Y(K) = TTY
         GO TO 130
      ENDIF
C
C     Save upper and lower subscripts of the array yet to be sorted
C
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+1
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+1
      ENDIF
      GO TO 160
C
C     Begin again on another portion of the unsorted array
C
  150 M = M-1
      IF (M .EQ. 0) GO TO 190
      I = IL(M)
      J = IU(M)
C
  160 IF (J-I .GE. 1) GO TO 120
      IF (I .EQ. 1) GO TO 110
      I = I-1
C
  170 I = I+1
      IF (I .EQ. J) GO TO 150
      T = X(I+1)
      TY = Y(I+1)
      IF (X(I) .LE. T) GO TO 170
      K = I
C
  180 X(K+1) = X(K)
      Y(K+1) = Y(K)
      K = K-1
      IF (T .LT. X(K)) GO TO 180
      X(K+1) = T
      Y(K+1) = TY
      GO TO 170
C
C     Clean up
C
  190 IF (KFLAG .LE. -1) THEN
         DO 200 I=1,NN
            X(I) = -X(I)
  200    CONTINUE
      ENDIF
      RETURN
      END

c   test isometric routines
	program tstiso
	character*1 back
c
	isom=0
	call at_bint('Number of som (no contour) plots',isom,back)
	do ii=1,isom
	  call somplot
	enddo
c
	isoc=0
	call at_bint('Number of soc (contour) plots',isoc,back)
	do ii=1,isoc
	  call socplot
	enddo
c
	end
c
	subroutine somplot
	USE SGLIB_MOD
c
	parameter (nxp=10)
	parameter (nyp=10)
	real*8 xdata(nxp)
	real*8 ydata(nyp)
	real*8 zdata(nxp,nyp),zbase(nxp,nyp)
c
	real*8 xmin, xmax 
	real*8 zmin, zmax	!zmin><0
	real zscale
	integer linc
	character*12 xuns	
	character*12 yuns	
	character*12 zuns
	data xmin /10./, xmax /100./
	data zmin /-20.0/, zmax /60.0/	!zmin><0
	data zscale /1./
	data linc /1/
	data xuns	/'X data$'/
	data yuns	/'Y data$'/
	data zuns	/'Z data$'/
	logical zlog, lhide
	character*1 back
	data (xdata(i),i=1,nxp) /10.,20.,30.,40.,50.,60.,70.,80.,90.,100./
	data ((zbase(i,j),i=1,nxp),j=1,nyp) /
     >		60.,40.,20.,00.,-20.,-20.,00.,20.,40.,60.,
     >		60.,40.,20.,00.,-20.,-20.,00.,20.,40.,60.,
     >		62.,42.,22.,02.,-18.,-18.,02.,22.,42.,62.,
     >		64.,44.,24.,04.,-16.,-16.,04.,24.,44.,64.,
     >		66.,46.,26.,06.,-14.,-14.,06.,26.,46.,66.,
     >		66.,46.,26.,06.,-14.,-14.,06.,26.,46.,66.,
     >		64.,44.,24.,04.,-16.,-16.,04.,24.,44.,64.,
     >		62.,42.,22.,02.,-18.,-18.,02.,22.,42.,62.,
     >		60.,40.,20.,00.,-20.,-20.,00.,20.,40.,60.,
     >		60.,40.,20.,00.,-20.,-20.,00.,20.,40.,60./
	yfact=1.
	call at_breal('Y axis scale',yfact,back)
	do jj=1,nxp		!remote exponent on y axis label
	  ydata(jj) = jj *.5 * abs(yfact)
	enddo
	call at_breal('Z scale',zscale,back)
	zmin = 0.
	zmax = 0.
	do jj=1,nyp
	  do kk=1,nxp
	    zdata(kk,jj) = zbase(kk,jj)*zscale
	    zmin = min(zmin,zdata(kk,jj))
	    zmax = max(zmax,zdata(kk,jj))
	  enddo
	enddo
	zlog=.false.
	call at_log ('Z axis as log',zlog)
	if(zlog .and. zmin.lt.0) zmin = 1.
	lhide=.true.
	call at_log('Remove hidden lines',lhide)
	call at_int('Line color',linc)
	theta=45.
	call at_real('Y angle',theta)
	call initt(120)
	call aginit
	if(linc.ne.1) call agccurv(linc)
c
	call agidlx(xmin,xmax)
cx	call agidly(ymin,ymax)
	call agidlz(zmin,zmax)
	call agixnt(0)
	call agiynt(0)
	call agiznt(0)
	if(theta.gt.90) call agislx(430,870)
	call agisly(theta,0)
	call agiskt(.false.,.true.)
	call agihid(lhide)
	if(zlog) call agizty(2)
c
	call agisom(xdata,ydata,zdata,nxp,nxp,nyp,
     >		xuns,yuns,zuns)
	call upause(0)
	call finitt(0,0)
	end
c
	subroutine socplot
c
	USE SGLIB_MOD
c
	parameter (nxp=10)
	parameter (nyp=10)
	real*8 xdata(nxp)
	real*8 ydata(nyp)
	real*8 zdata(nxp,nyp),zbase(nxp,nyp)
	integer m(2,nxp,nyp)	!only for agisoc
	real    c(nyp)
	logical lhide
	real*8 xmin, xmax
	real*8 zmin, zmax
	real zscale
	integer linc
	character*12 xuns	
	character*12 yuns	
	character*12 zuns	

	data xmin /10./, xmax /100./
	data zmin /-60.0/, zmax /20.0/	!zmin><0
	data zscale /1./
	data linc /1/
	data xuns	/'X data$'/
	data yuns	/'Y data$'/
	data zuns	/'Z data$'/
	data (xdata(i),i=1,nxp) /10.,20.,30.,40.,50.,60.,70.,80.,90.,100./
	data ((zbase(i,j),i=1,nxp),j=1,nyp) /
     >		20.,00.,-20.,-40.,-60.,-60.,-40.,-20.,00.,20.,
     >		20.,00.,-20.,-40.,-60.,-60.,-40.,-20.,00.,20.,
     >		22.,02.,-18.,-38.,-58.,-58.,-38.,-18.,02.,22.,
     >		24.,04.,-16.,-36.,-56.,-56.,-36.,-16.,04.,24.,
     >		26.,06.,-14.,-34.,-54.,-54.,-34.,-14.,06.,26.,
     >		26.,06.,-14.,-34.,-54.,-54.,-34.,-14.,06.,26.,
     >		24.,04.,-16.,-36.,-56.,-56.,-36.,-16.,04.,24.,
     >		22.,02.,-18.,-38.,-58.,-58.,-38.,-18.,02.,22.,
     >		20.,00.,-20.,-40.,-60.,-60.,-40.,-20.,00.,20.,
     >		20.,00.,-20.,-40.,-60.,-60.,-40.,-20.,00.,20./
c
	do jj=1,nxp
	  ydata(jj) = jj *.5
	enddo
	do jj=1,nyp
	  do kk=1,nxp
	    zdata(kk,jj) = zbase(kk,jj)*zscale
	  enddo
	enddo
	lhide=.true.
	call at_log('Remove hidden lines',lhide)
	nc=-1
	call at_int('Contours (-1 for uniform, 0 for none)',nc)
	call at_int('Line color',linc)
	theta=45.
	call at_real('Y angle',theta)
	call initt(120)
	call aginit
	if(linc.ne.1) call agccurv(linc)
c
	call agidlx(xmin,xmax)
cx	call agidly(ymin,ymax)
	call agidlz(zmin,zmax)
	call agixnt(0)
	call agiynt(0)
	call agiznt(0)
	call agiskt(.false.,.true.)
	if(theta.gt.90) call agislx(430,870)
	call agisly(theta,0)
	call agihid(lhide)
	call agiszc(nc,c)
c
	call agisoc(xdata,ydata,zdata,nxp,nxp,nyp,
     >		xuns,yuns,zuns,m)
	call upause(0)
	call finitt(0,0)
	end

C******************** START FILE LWORD.FOR ; GROUP URDUTS ******************
C---------------------------------------------
C&  LWORD   UREAD LOGICAL FCN .TRUE. IF INPUT MATCHES PASSED WORD
C
      LOGICAL FUNCTION LWORD(WORD)
C
      CHARACTER*(*) WORD
C
      IW=IXUOPW(WORD,1)
      IF(IW.EQ.1) THEN
        LWORD=.TRUE.
      ELSE
        LWORD=.FALSE.
      ENDIF
      RETURN
      END
C******************** END FILE LWORD.FOR ; GROUP URDUTS ******************

C******************** START FILE TGRF3D.FOR ; GROUP TGRF3D ******************
C============================================================
C  MOD DMC JUNE 1988
C  VARIABLE LENGTH LABELS.  CLEANUP.
C
C ** SG VERSION ** USES SG PACKAGE 3D ISOMETRIC ROUTINE
C  D. MC CUNE 15 MAR 1982
C
      SUBROUTINE TGRF3D(X,Z,Y,NX,NY,NZ1,
     >                  XLAB,YLAB,ZLAB,
     >                  XUN,YUN,ZUN,
     >                  ZTITLE,IPROC,
     >			ZRNLBL,IINT,ZINT,
     >                  NPAGE,ZLLAB,ZLLUN,ZX0,IRET)
C
C  INTERACTIVE ROUTINE TO CONTROL PRODUCTION OF
C  THREE DIMENSIONAL GRAPHS OF DATA FUNCTION OF TWO
C  INDEPENDANT VARIABLES.
C    3-D GRAPHS:  LABELING AND TITLEING CONTROLLED BY PASSED
C                 VARIABLES
C                 USER MAY SPECIFY SUBSET OF X-Y DOMAIN, AND
C                 # OF LINES OF CONSTANT X AND Y TO DRAW
C                 BY INTERACTIVE I/O.
C
C  INPUT VARIABLES:
C    X       1ST INDEPENDANT VARIABLE VALUES, IN ASCENDING ORDER
C            CORRESPONDS TO FIRST DIMENSION OF Z ARRAY
C    Z       2-D ARRAY OF DEPENDANT VARIABLE VALUES
C    Y       2ND INDEPENDANT VARIABLE VALUES, IN ASCENDING ORDER
C            CORRESNPONDS TO SECOND DIMENSION OF Z ARRAY.
C    Z(I,J) = Z AT (X(I),Y(J))
C
C    NX      # OF X VALUES
C    NY      # OF Y VALUES
C    NZ1     FIRST DIMENSION OF Z
C
C    XLAB    NAME OF FIRST INDEP. VARIABLE (E.G. 'RADIUS    ')
C            N CHARACTERS ASCII.
C    YLAB    NAME OF SECOND INDP. VARIABLE (E.G. 'TIME      ')
C            N CHARACTERS ASCII
C    ZLAB    NAME OF DEPENDANT VARIABLE
C            (E.G. 'ELECTRON TEMPERATURE')
C            N CHARACTERS ASCII
C    XUN     UNITS OF FIRST INDEP. VARIABLE (E.G. 'CM       $')
C            N CHARACTERS ASCII TERMINATED BY '$' REQUIRED BY
C            FS ROUTINES.
C    YUN     UNITS OF SECOND INDEP. VARIABLE (E.G. 'SECONDS  $')
C    ZUN     UNITS OF DEPENDANT VARIABLE (E.G. 'EV       $')
C
C    ZTITLE  N CHARACTER TITLE TO GO ON TOP OF 3-D GRAPH
C
C    IPROC   DATA PROCESSING FLAG FOR LABELING 1=AVG'D, 2=SMOOTH'D
C            ETC.
C
C    ZRNLBL  N CHARACTER PROGRAM LABEL
C
C     IINT - FLAG TO GENERATE INTEGRATION LABEL
C
C     ZINT - N CHARACTER INTEGRATION LABEL
C
C   NPAGE   PAGE # FOR GRAPHS; NPAGE= # ON LAST GRAPH DRAWN PRIOR
C       TO CALL TO THIS ROUTINE
C
C  ZLLAB-- CHAR INTEGRATION LOWER LIMIT LABEL
C  ZLLUN-- CHAR LOWER LIMIT UNITS
C
C----------------------------
C
C  AUTHOR:  D. MC CUNE    15-MAY-79
C
C  REVISIONS:
C
C    JUN-1988  DMC - ELASTIC LABELS ... REPLACE AGX WITH GRFLBL CALLS
C
C    APR-1980  D. MC CUNE-- USING AG ROUTINES TO LABEL 3D GRAPHS
C
C----------------------------
C
C   DECLARATIONS:
C
      DIMENSION X(NX),Y(NY),Z(NZ1,NY)
      CHARACTER*(*) ZLAB,ZTITLE,YLAB,XLAB,XUN,YUN,ZUN
      CHARACTER*(*) ZRNLBL
      CHARACTER*(*) ZINT
      CHARACTER*(*) ZLLAB,ZLLUN
C
      CHARACTER*80 ZBUFF
C
      CHARACTER*10 ZVIEWL(3)
C
      LOGICAL I3LOGX,I3LOGY,I3LOGZ,J3LOGX,J3LOGY,J3LOGZ,IHIDDN
      LOGICAL XSKIRT,YSKIRT,XSKIRT0,YSKIRT0
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
        LOGICAL LCHAR
        LOGICAL LYES
        LOGICAL LYESC
      LOGICAL LXOUT
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
C => TGRF3D               BEGIN DATA BLOCK
C => LISMAK 12-APR-88  MOVED DATA STATEMENTS
C
      DATA XSKIRT0/.TRUE./
      DATA YSKIRT0/.TRUE./
      DATA ITBOT0/0/
      DATA IHIDDN/.TRUE./
      DATA J3LOGX/.FALSE./
      DATA J3LOGY/.FALSE./
      DATA J3LOGZ/.FALSE./
      DATA JSKIPX/-1/
      DATA JSKIPY/-1/
C
      DATA ZVIEWL/'BOTTOM    ','BOTH SIDES','TOP SIDE  '/
C
C => END DATA BLOCK
C ====================
C
C  START OF EXECUTABLE CODE
C
C  (1)  3-D GRAPH
C
      LUNTRM=LNOUT(0)
C
C  LABEL LENGTHS
C
      ILX=ILNURD(XLAB)
      ILY=ILNURD(YLAB)
      ILZ=ILNURD(ZLAB)
C
 100  CONTINUE
C
      I3LOGX=J3LOGX
      I3LOGY=J3LOGY
      I3LOGZ=J3LOGZ
C
      XSKIRT=XSKIRT0
      YSKIRT=YSKIRT0
C
      ITBOT=ITBOT0
C
      IX1=1
      IX2=NX
      NXL=NX
      IXL=NX-1
C
      IF(JSKIPX.GT.0) THEN
        ISKIPX=JSKIPX
      ELSE
        ISKIPX=MAX0(1,IFIX(FLOAT(NXL)/40.0 + 0.5))
      ENDIF
C
      IY1=1
      IY2=NY
      NYL=NY
      IYL=NY-1
C
      IF(JSKIPY.GT.0) THEN
        ISKIPY=JSKIPY
      ELSE
        ISKIPY=MAX0(1,IFIX(FLOAT(NYL)/40.0 + 0.5))
      ENDIF
C
      IZMMX=1
C
 110  CONTINUE
C
      CALL NEUPAG
 115  continue
      IF(LXOUT(0)) then
         WRITE(LUNTRM,1101)
     >        XLAB(1:ILX),I3LOGX,YLAB(1:ILY),I3LOGY,ZLAB(1:ILZ),I3LOGZ
 1101    FORMAT(
     >        ' SET AXIS TYPES FOR 3D ISOMETRIC PLOT (ONLY):'/
     >        '  X AXIS - INDEP VAR. "',A,'" LOG = ',L1,' (T/F)'/
     >        '  Y AXIS - INDEP VAR. "',A,'" LOG = ',L1/
     >        '  Z AXIS - FUNCTION "',A,'" LOG = ',L1/
     >        ' OPTIONS:'/
     >        '  C - CHANGE MISCELLANEOUS PLOT CONTROLS'/
     >        '  M - MODIFY (X,Y,Z) DOMAIN TO BE PLOTTED OVER'/
     >        '  S - SET SKIP COUNT ON DRAWING LINES OF CONST. X, Y'/
     >        '  X - CHANGE X AXIS TYPE (TOGGLE LOG/LINEAR)'/
     >        '  Y - CHANGE Y AXIS TYPE'/
     >        '  Z - CHANGE Z AXIS TYPE'/
     >        '  D - ESTABLISH CURRENT AXIS TYPES AS PERMANENT DEFAULT'/
     >        '  P - PROCEED TO MAKE PLOT'/
     >        '  N or Q - QUIT (RETURN TO GRAPHICS OPTIONS NODE)'/
     >        '  R - QUIT (EXIT GRAPHICS SUBROUTINE)'/)
      endif
      CALL UREAD(
     >     'GRF3SG:  SELECT 3D ISOMETRIC AXIS OPTION (X/Y/Z/D/P):$')
      IANS=IXUOPC('MSXYZDPQNRC$')
      CALL UCHKOP(IANS,0,1,100,-1,*115)
C
      GO TO (20,25,111,112,113,114,119,98,98,99,10) IANS
C
 10   CONTINUE
C-------------------------------------------------------------------
C  MISCELLANEOUS CONTROLS MENU
C
      CALL NEUPAG
      IV=ITBOT+2
      IF(LXOUT(0)) WRITE(LUNTRM,1110) ZVIEWL(IV),XSKIRT,YSKIRT
 1110 FORMAT(/
     >' AGISOM ISOMETRIC SURFACE PLOT MAY BE DRAWN WITH, TOP, BOTTOM,'/
     >' OR BOTH SIDES OF THE SURFACE VISIBLE, CURRENT SETTING = ',A//
     >' MISCELLANEOUS CONTROL OPTIONS:'/
     >'  A - SET AGISOM TO PLOT TOP SIDE ONLY'/
     >'  B - SET AGISOM TO PLOT BOTH SIDES (INITIAL DEFAULT)'/
     >'  C - SET AGISOM TO PLOT BOTTOM SIDE ONLY'/
     >'  D - MAKE CURRENT SETTING THE PERMANENT DEFAULT'//
     >'  X - TOGGLE OPTION TO DRAW "SKIRT" ON X LINES, CURRENTLY = ',L1/
     >'  Y - TOGGLE OPTION TO DRAW "SKIRT" ON Y LINES, CURRENTLY = ',L1/
     >'  Z - MAKE CURRENT SKIRT OPTIONS THE PERMANENT DEFAULT')
C
      CALL UREAD(
     >'TGRF3D:  SPECIFY MISCELLANY OPTION OR "Q" TO QUIT:$$')
C
      IF(LCHAR('A')) THEN
        ITBOT=1
      ELSE IF(LCHAR('B')) THEN
        ITBOT=0
      ELSE IF(LCHAR('C')) THEN
        ITBOT=-1
      ELSE IF(LCHAR('D')) THEN
        ITBOT0=ITBOT
      ELSE IF(LCHAR('X')) THEN
        XSKIRT=.NOT.XSKIRT
      ELSE IF(LCHAR('Y')) THEN
        YSKIRT=.NOT.YSKIRT
      ELSE IF(LCHAR('Z')) THEN
        XSKIRT0=XSKIRT
        YSKIRT0=YSKIRT
      ELSE IF(LCHAR('Q')) THEN
        GO TO 110
      ELSE
        CALL UERMSG('%TGRF3D -- ILLEGAL OPTION',' ',1)
      ENDIF
      GO TO 10
C-------------------------------------------------------------------
C
 98   CONTINUE
      IRET=0
      RETURN
C
 99   CONTINUE
      IRET=1
      RETURN
C
C  RESET DOMAIN
 20   CONTINUE
      CALL NEUPAG
      IF(LXOUT(0))
     >    WRITE(LUNTRM,1002) XLAB(1:ILX),X(1),X(NX),XUN,
     >    YLAB(1:ILY),Y(1),Y(NY),YUN
 1002 FORMAT(/' DATA AVAILABLE OVER THE DOMAIN:'/
     >          ' ',A,' = ',1PE11.4,' TO ',1PE11.4,' ',A/
     >          ' ',A,' = ',1PE11.4,' TO ',1PE11.4,' ',A/
     >          /' >>ENTER 1 TO GRAPH OVER SUBSET OF THIS DOMAIN')
C
 120  CONTINUE
      CALL UREAD('  GRF3SG: SELECT DOMAIN:$')
      X1=X(1)
      X2=X(NX)
      Y1=Y(1)
      Y2=Y(NY)
      	IF(LCHAR('Q')) GOTO 110
      IF(.NOT.LYESC('1')) GO TO 30
C
      IF(LXOUT(0)) WRITE(LUNTRM,1003) XLAB(1:ILX)
 1003 FORMAT(' ENTER "X" NOT TO CHANGE A VALUE'/
     >         ' ENTER NEW FIRST ',A,' (E FORMAT)')
C
      IERT=0
C
 101  CALL UREAD(' GRF3SG:  X(1):$')
        IF(LCHAR('Q')) GOTO 20
      IF(.NOT.LCHAR('X')) X1=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 101
C
      IF(LXOUT(0)) WRITE(LUNTRM,1004) XLAB(1:ILX)
 1004 FORMAT(' ENTER NEW LAST ',A,' (E FORMAT)')
C
 102  CALL UREAD(' GRF3SG:  X(N):$')
      IF(LCHAR('Q')) GOTO 20
      IF(.NOT.LCHAR('X')) X2=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 102
C
      IF(LXOUT(0)) WRITE(LUNTRM,1003) YLAB(1:ILY)
 103  CALL UREAD(' GRF3SG:  Y(1):$')
      IF(LCHAR('Q')) GOTO 20
      IF(.NOT.LCHAR('X')) Y1=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 103
C
      IF(LXOUT(0)) WRITE(LUNTRM,1004) YLAB(1:ILY)
 104  CALL UREAD(' GRF3SG:  Y(N):$')
      IF(LCHAR('Q')) GOTO 20
      IF(.NOT.LCHAR('X')) Y2=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 104
C
 30   CONTINUE
C
C  FIND INDEX LIMITS ON SUBDOMAIN TO BE GRAPHED
C
C  X AXIS
C
      IX1=1
      IX2=NX
      DO 32 I=1,NX
        IF(X(I).GE.X1) GO TO 33
 32   CONTINUE
      GO TO 95
C
 33   CONTINUE
      IX1=I
      DO 34 I=NX,1,-1
        IF(X(I).LE.X2) GO TO 35
 34   CONTINUE
      GO TO 95
C
 35   CONTINUE
      IX2=I
      IF(IX1.GT.IX2) GO TO 95
C
C  Y AXIS
C
      IY1=1
      IY2=NY
      DO 42 I=1,NY
        IF(Y(I).GE.Y1) GO TO 43
 42   CONTINUE
      GO TO 95
C
 43   CONTINUE
      IY1=I
      DO 44 I=NY,1,-1
        IF(Y(I).LE.Y2) GO TO 45
 44   CONTINUE
      GO TO 95
C
 45   CONTINUE
      IY2=I
      IF(IY1.GT.IY2) GO TO 95
C
      NXL=IX2-IX1+1
      IF(JSKIPX.GT.0) THEN
        ISKIPX=JSKIPX
      ELSE
        ISKIPX=MAX0(1,IFIX(FLOAT(NXL)/40.0 + 0.5))
      ENDIF
C
      NYL=IY2-IY1+1
      IF(JSKIPY.GT.0) THEN
        ISKIPY=JSKIPY
      ELSE
        ISKIPY=MAX0(1,IFIX(FLOAT(NYL)/40.0 + 0.5))
      ENDIF
C
      IXL=NXL-1
      IYL=NYL-1
      IF(IXL.LT.1) IXL=1
      IF(IYL.LT.1) IYL=1
C
 21   CONTINUE
C  Z AXIS
      CALL UREAD(
     >  'GRF3SG: ENTER "Y" TO SET Z AXIS MIN AND MAX$')
      IF(LCHAR('Q')) GOTO 110
      IF(.NOT.LYES(0)) GO TO 110
C
      IF(LXOUT(0)) WRITE(LUNTRM,1019)
 1019 FORMAT(' WARNING -- DATA MAY BE CLIPPED.')
C
 105  CALL UREAD('GRF3SG:  ENTER ZMIN:$')
      IF(LCHAR('Q')) GOTO 21
      ZZMIN=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 105
C
 106  CALL UREAD('GRF3SG:  ENTER ZMAX:$')
      IF(LCHAR('Q')) GOTO 21
      ZZMAX=FDCOD(IERT)
      IF(IERT.NE.0) GO TO 106
C
      IF(ZZMAX.GT.ZZMIN) IZMMX=2
      GO TO 110
C
C  GET SKIP COUNT ON DRAWING LINES OF CONSTANT X OR Y
C
 25   CONTINUE
      CALL NEUPAG
C
      IF(LXOUT(0)) WRITE(LUNTRM,1010) NXL,XLAB(1:ILX),IXL
 1010 FORMAT(/' GRAFICS ROUTINE MAY DRAW UP TO ',I3,' LINES OF'/
     >         ' CONSTANT ',A,'.  ENTER SKIP FACTOR '/
     >         ' (BETWEEN 1 AND ',I3,')'/
     >         ' *ENTER "A" TO RESTORE AUTOMATIC SKIP COUNT SETTING')
C
 411  CALL UREAD(' GRF3SG:  ENTER SKIP COUNT:$')
      IF(LCHAR('Q')) GOTO 110
C
      IF(LCHAR('A')) THEN
        JSKIPX=-1
        JSKIPY=-1
        ISKIPX=MAX0(1,IFIX(FLOAT(NXL)/40.0 + 0.5))
        ISKIPY=MAX0(1,IFIX(FLOAT(NYL)/40.0 + 0.5))
        GO TO 110
      ENDIF
C
      ISKIPX=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 411
      IF(ISKIPX.LT.1) ISKIPX=1
      IF(ISKIPX.GT.IXL) ISKIPX=IXL
C
      IF(LXOUT(0)) WRITE(LUNTRM,1010) NYL,YLAB(1:ILY),IYL
 421  CALL UREAD(' GRF3SG:  ENTER SKIP COUNT:$')
      IF(LCHAR('Q')) GOTO 25
      ISKIPY=IDCOD(IERT)
      IF(IERT.NE.0) GO TO 421
      IF(ISKIPY.LT.1) ISKIPY=1
      IF(ISKIPY.GT.IYL) ISKIPY=IYL
C
      CALL UREAD(
     >   'GRF3SG:  MAKE THESE SKIP COUNTS PERMANENT DEFAULTS (Y/N)?$')
      IF(.NOT.LYES(0)) GO TO 110
      IF(LCHAR('Q')) GOTO 25
      JSKIPX=ISKIPX
      JSKIPY=ISKIPY
      GO TO 110
C
C  SET AXES TYPES
C
C  X AXIS
 111  CONTINUE
      I3LOGX=.NOT.I3LOGX
      GO TO 110
C
C  Y AXIS
 112  CONTINUE
      I3LOGY=.NOT.I3LOGY
      GO TO 110
C
C  Z AXIS
 113  CONTINUE
      I3LOGZ=.NOT.I3LOGZ
      GO TO 110
C
C  DEFAULTS CHANGED
 114  CONTINUE
      J3LOGX=I3LOGX
      J3LOGY=I3LOGY
      J3LOGZ=I3LOGZ
      GO TO 110
C
C------------------------------------------
C  DRAW GRAPH
C
 119  CONTINUE
C  SET AXIS TYPES
      CALL UBINIT(0)
C  RESET AG 3D ISOMETRIC COMMON
C
      CALL AGINIT
C  SET ISOMETRIC PLOT WINDOW
      CALL AGISLX(110,510)
      CALL AGISLY(45.,550)
      CALL AGISLZ(95,355)
      INEAT=1
      CALL AGIXNT(INEAT)
      CALL AGIYNT(INEAT)
      CALL AGIZNT(INEAT)
C
      CALL AGISKT(XSKIRT,YSKIRT)
C
      CALL AGISID(ITBOT)
C
      IF(I3LOGX) THEN
        CALL AGIXTY(2)
      ELSE
        CALL AGIXTY(1)
      ENDIF
C
      IF(I3LOGY) THEN
        CALL AGIYTY(2)
      ELSE
        CALL AGIYTY(1)
      ENDIF
C
      IF(I3LOGZ) THEN
        CALL AGIZTY(2)
      ELSE
        CALL AGIZTY(1)
      ENDIF
C
C  HIDDEN LINES ONLY IF STRAIGHT LINEAR PLOT
      CALL AGIHID(IHIDDN)
C  SET INCREMENT BETWEEN X, Y=CONST. CURVES
      CALL AGISTX(ISKIPX)
      CALL AGISTY(ISKIPY)
C  SET Z AXIS LIMITS IF REQUESTED
      IF(IZMMX.EQ.2) CALL AGIDLZ(ZZMIN,ZZMAX)
C  DRAW THE GRAPH
      CALL AGISOM(X(IX1),Y(IY1),Z(IX1,IY1),NZ1,NXL,NYL,
     >     XUN,YUN,ZUN)
C  ADDL LABELS
C
      ILMRG=10
      ITOP=750
      IINC=23
      CALL GRFLBL(ILMRG,ITOP,ZTITLE,72,0,0)
      ITOP=ITOP-IINC
C
      CALL GRFLBL(ILMRG,ITOP,ZLAB,0,-1,0)
      ITOP=ITOP-IINC
C
      IF((IINT.GT.0).AND.(IINT.LE.12)) THEN
C  INTEGRATION LABEL WITH LOWER LIMIT
        CALL GRFLBL(ILMRG,ITOP,' '//ZINT//' FROM:',0,-1,0)
        ITOP=ITOP-IINC
C
        ZBUFF=' '
10221 FORMAT(1X,A,'=',1PE11.4,1X,A)
        WRITE(ZBUFF,10221) ZLLAB,ZX0,ZLLUN
        CALL GRFLBL(ILMRG,ITOP,ZBUFF,0,-1,0)
        ITOP=ITOP-IINC
C
      ELSE IF(IINT.NE.0) THEN
C  DIFFERENTIATION LABEL
        CALL GRFLBL(ILMRG,ITOP,ZINT,0,-1,0)
        ITOP=ITOP-IINC
      ENDIF
C
      CALL GRFLBL(ILMRG,ITOP,'VS. '//XLAB,0,-1,0)
      ITOP=ITOP-IINC
C
      CALL GRFLBL(ILMRG,ITOP,'AND '//YLAB,0,-1,0)
      ITOP=ITOP-IINC
C
      IF(IPROC.EQ.1) THEN
        CALL GRFLBL(ILMRG,ITOP,' AVERAGED DATA ',0,-1,0)
        ITOP=ITOP-IINC
      ELSE IF(IPROC.EQ.2) THEN
        CALL GRFLBL(ILMRG,ITOP,' SMOOTHED DATA ',0,-1,0)
        ITOP=ITOP-IINC
      ELSE IF(IPROC.EQ.3) THEN
        CALL GRFLBL(ILMRG,ITOP,' AVG''D AND SMOOTHED DATA ',0,-1,0)
        ITOP=ITOP-IINC
      ELSE IF(IPROC.EQ.4) THEN
        CALL GRFLBL(ILMRG,ITOP,' PROCESSED DATA ',0,-1,0)
        ITOP=ITOP-IINC
      ENDIF
C
      CALL GRFLBL(ILMRG,ITOP,ZRNLBL,0,-1,0)
      ITOP=ITOP-IINC
C
      NPAGE=NPAGE+1
      WRITE(ZBUFF,10341) NPAGE
10341 FORMAT('PAGE ',I4,'$')
      CALL GRFLBL(800,50,ZBUFF,0,-1,0)
C
      CALL UPAUST(2)
      go to 110
C
C  ERRORS IN SPECIFYING SUBDOMAIN---
C
 95   CONTINUE
      WRITE(LUNTRM,1095)
 1095 FORMAT(' INVALID DOMAIN *****  HIT ANY KEY TO CONTINUE')
      CALL UPAUST(1)
      GO TO 110
C
      END
C******************** END FILE TGRF3D.FOR ; GROUP TGRF3D ******************

C******************** START FILE IXMMX.FOR ; GROUP MULFDR ******************
C----------------------------------------------------------
C  LOCATE INDEX LOCATION OF PTS BEYOND MIN AND MAX IN
C  CPLOT COMMON (X ARRAY ONLY)
C
      SUBROUTINE IXMMX(X,NX,IMIN,IMAX)
C
      INCLUDE 'PLOT1MMX'
C
      DIMENSION X(NX)
C
      IMIN=0
      IMAX=NX+1
C
      IF(X(1).GT.XMIN) GO TO 100
      DO 10 I=2,NX
      IF(X(I).GT.XMIN) GO TO 20
 10   CONTINUE
      I=NX+2
C
 20   CONTINUE
      IMIN=I-1
C
 100  CONTINUE
      IF(X(NX).LT.XMAX) GO TO 200
      IXM1=NX-1
      DO 110 I=IXM1,1,-1
      IF(X(I).LT.XMAX) GO TO 120
 110  CONTINUE
      I=-1
C
 120  CONTINUE
      IMAX=I+1
C
 200  CONTINUE
C  CHECK RESULT
      IF(IMAX.GT.IMIN) RETURN
      IMIN=0
      IMAX=NX+1
      RETURN
      END
C******************** END FILE IXMMX.FOR ; GROUP MULFDR ******************

C******************** START FILE UREADL.FOR ; GROUP UREADT ******************
C------------------------------------------------------------
C& UREADL  ISSUE UREAD PROMPT, RETURN COMPLETE LINE
C
C  READ A LINE FROM THE TTY OR INDIRECT INPUT FILE
C  uppercase forced; left justified, no leading blanks returned.
C
C  see also UREADLL, below...
C
      SUBROUTINE UREADL(PROMPT,LINE)
C
      USE USERIO
C
      CHARACTER*(*), intent(in) :: PROMPT
      CHARACTER*(*), intent(out) ::  LINE
C
      CALL UREAD(PROMPT)
C
      ILEN=MIN0(LEN(CBUFF),LEN(LINE))
C
      line=' '
      line(1:ilen)=cbuff(1:ilen)
      call uspcap(line)
C
      CALL UCLEAR
C
      RETURN
      END
C------------------------------------------------------------
C  go into text mode, read a literal line, then restore mode that
C  was previously in effect.
C
C  LINE returned can be mixed upper/lowercase.  
C  the input buffer is flushed before the user is prompted.
C
      SUBROUTINE UREADLL(PROMPT,LINE)
C
      USE USERIO
C
      CHARACTER*(*), intent(in) :: PROMPT
      CHARACTER*(*), intent(out) ::  LINE
C
C--------------------
C
      ilev=levcmd
C
      call uclear
      call urdmod(2)
C
      CALL UREAD(PROMPT)
      call urdmod(ilev)
C
      ILEN=MIN0(LEN(CBUFF),LEN(LINE))
C
      line=' '
      DO IC=1,ILEN
        LINE(IC:IC)=CBUFF(IC:IC)
      ENDDO
C
      CALL UCLEAR
C
      RETURN
      END
C------------------------------------------------------------
C******************** END FILE UREADL.FOR ; GROUP UREADT ******************

subroutine mpi_share_env(myid_in,ierr)

  use mpi_env_mod
  implicit NONE

  !------------------------------------------------
  ! share environment information btw processes in an MPI job
  !   (non MPI version: do almost nothing)
  !------------------------------------------------

  integer, intent(in) :: myid_in   ! processor id number: 0 for "head node"
  !  if caller does not know, it should set myid_in = -1

  integer, intent(out) :: ierr     ! status code returned: 0 for OK

  !------------------------------------------------
  !  debugging option added, DMC May 22, 2009
  !  extra output of (myid.eq.0) process sees MPI_SHARE_ENV_DEBUG
  !  environment variable-- no effect except in MPI runs.
  !
  !  the communicator in this module is MPI_COMM_WORLD (no option).
  !    mpi_env_comm = MPI_COMM_WORLD
  !------------------------------------------------

#ifdef __MPI
  integer :: isizes(4)
  character, dimension(:), allocatable :: chbuf

  integer :: idbg_lines = 0
  integer, parameter :: max_dbg_lines = 100
  integer :: ilen_test,ilen_use,iolun
  character*80 dbg_lines(max_dbg_lines)
  character*40 :: ftest

  logical :: idebug
#endif
  integer :: idum
  character*30 :: dbg_val

  integer i,j,k,ilen,inumch,icwd
  integer :: myid,mpierr

  integer, save :: icalls = 0

  !------------------------------------------------
  ! clear error code (this is the only action if no __MPI):

  icalls = icalls + 1

  call get_loc_myid
  if(mdebug) write(0,*) ' proc #',loc_myid,' entering mpi_share_env, ', &
       'myid_in = ',myid_in

  ierr = 0

  myid = myid_in
  if(myid.lt.0) myid=loc_myid

  !  serial, or MPI all ranks:
  call mpi_sget_env('PPPLCLUSTER_HOME',dbg_val,idum)
  if(dbg_val.ne.' ') then
     call mpi_set_filesys('PPPLCLUSTER')
  endif

#ifdef __MPI

  if(myid.eq.0) then

     !--------------------------------------------------------
     ! do these first: it can change the isizes(1:3) counts...
     call mpi_sget_env('MPI_SHARE_ENV_DEBUG',dbg_val,idum)
     if(dbg_val.eq.'TRUE') then
        isizes(4) = 1
     else
        isizes(4) = 0
     endif

     !--------------------------------------------------------

     isizes(1)=n_alloc_names
     isizes(2)=n_active_names

     isizes(3)=0
     do i=1,n_active_names
        isizes(3) = isizes(3) + 1 + len(trim(mpi_env_names(i)))
        isizes(3) = isizes(3) + 1 + len(trim(mpi_env_vals(i)))
     enddo
  endif

  ! blocking integer MPI_BCAST:
  call intvec_bcast(isizes, 4, mpi_env_comm)

  idebug = ( isizes(4).eq.1 )
  if(idebug) then
     dbg_lines = ' '
     idbg_lines = 1
     write(dbg_lines(idbg_lines),'(1x,a,i8,a,i8)') &
          ' mpi_share_env debug output: myid = ', &
          myid,'; mpi_env_comm = ',mpi_env_comm
     idbg_lines = 2
     write(dbg_lines(idbg_lines),'(1x,a,4(1x,i5))') &
          ' 1st MPI_BCAST isizes = ',isizes
  endif

  inumch = isizes(3)

  allocate(chbuf(inumch))

  if(myid.gt.0) then
     n_alloc_names=isizes(1)
     n_active_names=isizes(2)

     if(allocated(mpi_env_names)) deallocate(mpi_env_names,mpi_env_vals)
     allocate(mpi_env_names(n_alloc_names),mpi_env_vals(n_alloc_names))
     if(mdebug) write(0,*) ' proc# ',loc_myid, &
          ' n_alloc_names,n_active_names,inumch:',&
          n_alloc_names,n_active_names,inumch

     do i=1,n_alloc_names
        mpi_env_names(i)=' '
        mpi_env_vals(i)=' '
     enddo
  endif

  if(myid.eq.0) then
     j=0
     do i=1,n_active_names
        call trans(mpi_env_names(i))
        call trans(mpi_env_vals(i))
     enddo
  endif

  call MPI_BCAST(chbuf, inumch, MPI_CHARACTER, 0, mpi_env_comm, ierr)
  if(ierr.ne.0) then
     call err('MPI_BCAST(chbuf)')
     return
  endif

  if(idebug) then
     idbg_lines = idbg_lines + 1
     write(dbg_lines(idbg_lines),'(1x,a,1x,10a1)') 'start of chbuf:', &
          chbuf(1:10)
  endif

  if(myid.gt.0) then
     j=0
     do i=1,n_active_names
        call rcv(mpi_env_names(i))
        call rcv(mpi_env_vals(i))
        if(mdebug) write(0,*) myid,loc_myid,' '//trim(mpi_env_names(i))// &
             ' '//trim(mpi_env_vals(i))
     enddo
  endif

  if(idebug) then
     if(mdebug) write(0,*) ' idebug=T in proc #',loc_myid
     do i=1,n_active_names
        if(idbg_lines.lt.max_dbg_lines) then
           idbg_lines = idbg_lines + 1
           ilen_test = 6 + len(trim(mpi_env_names(i))) + len(trim(mpi_env_vals(i)))
           if(ilen_test.le.72) then
              write(dbg_lines(idbg_lines),'(1x,a)') &
                   trim(mpi_env_names(i))//' = "'//trim(mpi_env_vals(i))//'"'
           else
              ilen_test=ilen_test-72  ! excess
              ilen_use=len(trim(mpi_env_vals(i))) - ilen_test - 3
              write(dbg_lines(idbg_lines),'(1x,a)') &
                   trim(mpi_env_names(i))//' = "'// &
                   mpi_env_vals(i)(1:ilen_use)//'..."'
           endif
        endif
     enddo
  endif
#else
  ! check mpi caller is linked with mpi_portlib 
  if (loc_myid .eq. 0 .and. myid_in .gt. 0) then
     write(0,*) ' '
     write(0,*) &
          ' >>>> portlib: non-MPI version of mpi_share_env called by processor # ',&
          loc_myid,' with myid_in =', myid_in
     write(0,*) ' >>> please use mpi_portlib library (not serial portlib) in MPI programs.'
     write(0,*) ' '
     call bad_exit
  endif
#endif

#ifndef __SUN
  !06/24/2011 CLF: 
  ! this section will "always" create a root directory, 
  ! even if the root directory is not writable by a user
  ! and the error is Read-only file system 
  ! 
  ! serial version also...

  if(mdebug) write(0,*) ' call mpi_env_comm_add(mpi_env_comm,...) '
  call mpi_env_comm_add(mpi_env_comm,ierr)

  icwd=0
  do i=1,n_active_names
     if(mpi_env_names(i).eq.'_cwd') icwd=i
  enddo

  if(icwd.gt.0) then
     ! go to directory specified as "cwd"
     ! make sure it exists

     call mpi_mkdir(mpi_env_comm,mpi_env_vals(icwd),ierr)
     if(ierr.ne.0) then
        call err('mpi_mkdir(cwd='//trim(mpi_env_vals(icwd))//')')
        return
     endif

     call sset_cwd(mpi_env_vals(icwd),ierr)
     if(ierr.ne.0) then
        call err('sset_cwd(cwd='//trim(mpi_env_vals(icwd))//')')
        return
     else
        if(icalls.eq.1) then
           write(0,*) ' (mpi_share_env) process myid=',myid,' cwd: ', &
                trim(mpi_env_vals(icwd))
        endif
     endif

  endif
#endif
#ifdef __MPI
  if(idebug) then
     call find_io_unit(iolun)
     ftest=' '
     write(ftest,'("mpi_share_env_debug_",i6.6,".txt")') myid
     open(unit=iolun,file=ftest,status='new',iostat=ierr)
     if(ierr.ne.0) then
        call err('mpi_share_env_debug file open')
        return
     endif
     do i=1,idbg_lines
        write(iolun,'(1x,a)') trim(dbg_lines(i))
     enddo
     close(unit=iolun)
  endif
  call MPI_BARRIER(mpi_env_comm,ierr)
#endif

  if(mdebug) write(0,*) ' proc #',loc_myid,' exiting mpi_share_env ierr=',ierr

CONTAINS

#ifdef __MPI

  subroutine trans(str)
    character*(*), intent(in) :: str

    ! load non-blank part of str into buffer
    ! side effect: j is modified... chbuf becomes concatenated set of
    !   non-blank strings terminated by nulls

    ilen=len(trim(str))
    do k=1,ilen
       j=j+1
       chbuf(j) = str(k:k)
    enddo
    j=j+1
    chbuf(j)=char(0)
  end subroutine trans

  subroutine rcv(str)
    character*(*), intent(inout) :: str

    ! fill in non-blank parts of str from buffer; done when null is found
    ! side effect: j is modified...

    integer :: icv

    k=0
    do 
       j=j+1
       icv = ichar(chbuf(j))
       if(icv.ne.0) then
          k=k+1
          str(k:k) = chbuf(j)
       else
          exit
       endif
    enddo

  end subroutine rcv

#endif

  subroutine err(errstr)

    character*(*), intent(in) :: errstr

    write(0,*) ' ?? mpi_share_env: error on process myid = ',myid
    write(0,*) '    message: '//trim(errstr)

  end subroutine err

end subroutine mpi_share_env

C Read 2D CDF U-file
C Called from uf2drd
C
C 07/25/97 CAL
C
C----------------------------------------------------------------------------
      subroutine ucdf2r(lun,option,
     &            f,n_f1, x,n_x, y,n_y, iproc,
     &            nx, ny, iflag,
     &            flab,xlab,ylab,
     &            retn)
C
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Input:
      integer lun
      integer option   ! 1 = get Dimensions
C                      ! 2 = get data arrays
      integer n_f1, n_x, n_y, iflag
C Return:
      integer      nx, ny, iproc
      character*30 flab, xlab, ylab
      real         x(n_x), y(n_y), f(n_f1,n_y)
      integer retn
 
C Definitions for CDF
      integer   nvars, ngatts, unlimid, nsc
      integer   var_id
      integer   nvdims(2)
      character*10 dimnam(2)
      integer dims(2), st(2), cnt(2)
      integer rank
      integer nxl, nxu
      integer nyl, nyu
      integer nfl, nfu
 
C Definitions for processing
      integer       ichan, file_id
 
      character*20  fl,   xl,   yl
      character*10  fu,   xu,   yu
      integer       i, j
 
      save    rank, dims
C--------------------------------------------------------
C
C
C get file name
      call uflchk(lun,'ucdf2r',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
C
      if (option .eq. 1) then       ! get Dimensions
C Inquire about file
         retn = nf_inq(file_id, rank, nvars, ngatts, unlimid)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9000) NF_STRERROR(retn)
 9000       format(' % UCDF2R: nf_inq'/,
     >           '     ',a)
            return
         end if
C
C Inquire dimensions
         do i=1,2
            retn = nf_inq_dim(file_id,i,dimnam(i),dims(i))
            if (retn .ne. NF_NOERR) then
               write(ufelun,9001) i, NF_STRERROR(retn)
 9001          format(' % UCDF2R: nf_inq_dim',i2/,
     >              '     ',a)
               return
            end if
         end do
         nx = dims(1)
         ny = dims(2)
C-----------------------------------------------------------------------
      else if (option .eq. 2) then
C
C Get data attributes
         nsc = nvars - rank - 1
         var_id = nsc+1
         retn = nf_get_att_text(file_id,var_id,'long_name',fl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
 9002       format(' % UCDF2R: nf_get_att_text id =',i3/,
     >           '     ',a)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',fu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         flab=fl(1:20)//fu(1:10)
 
C Get X attributes
         var_id = var_id + 1
         retn = nf_get_att_text(file_id,var_id,'long_name',xl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',xu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         xlab=xl(1:20)//xu(1:10)
 
C get Y attributes
         var_id = var_id + 1
         retn = nf_get_att_text(file_id,var_id,'long_name',yl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',yu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         ylab=yl(1:20)//yu(1:10)
C
C Read X
         var_id =  nsc+2
         retn = nf_get_var_real(file_id, var_id, x)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
 
C get array data
         var_id = nsc + 1          ! Data is 1st variable after Scalars
         if (iflag .eq. 1) then    ! Read continuously into buffer
            retn = nf_get_var_real(file_id, var_id, f)
            if (retn .ne. NF_NOERR) then
               write(ufelun,9003) var_id, NF_STRERROR(retn)
 9003          format(' % UCDF2R: nf_get_var_real id =',i3/,
     >              '     ',a)
               return
            end if
         else                   ! Read according to dimensions
            st(1) = 1
            cnt(1) = dims(1)      ! x count
            cnt(2) = 1
            do j = 1,dims(2)      ! For each Y : read slab into f
               st(2) = j          ! Start of slab
               retn = nf_get_vara_real(file_id, var_id,st,cnt,f(1,j))
               if (retn .ne. NF_NOERR) then
                  write(ufelun,9004) var_id, NF_STRERROR(retn)
 9004             format(' % UCDF2R: nf_get_vara_real id =',i3/,
     >                 '     ',a)
                  return
               end if
            end do
         end if
C
C Read Y
         var_id = nsc+3
         retn = nf_get_var_real(file_id, var_id, y)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
      end if
 
      return
      end
 
 
 
 
 
 
 
 
 
 

subroutine r8bsmooh(zprof,znorm)
  use iso_c_binding, only: fp => c_double
  implicit none
  real(fp), dimension(*) :: zprof, znorm

  call r8bsmoop(zprof,znorm)   ! patch holes

  call r8bsmoo(zprof,znorm)    ! smooth result
 
  return
end subroutine r8bsmooh

!------------------------------------------------------------
subroutine r8bsmoop(zprof,znorm)
  !
  !  patch "holes" (zero values) in profile,
  !  then smooth.
  !
  !  done for MC radial profiles that are formed by summing of the
  !  profile itself and its normalization
  !
  !    zprof(j) = [MC sum]f*dw
  !    zwsum(j) = [MC sum]dw
  !
  !  and at normalization time
  !
  !    if (zwsum(j).gt.0.0) then
  !         zprof(j)=zprof(j)/zwsum(j)
  !    else
  !         zprof(j)=0.0
  !    end if
  !
  !  which can leave "holes" in the profile in case of lousy statistics.
  !
  !  *** SO ***
  !  fill these holes with flat extrapolation & linear interpolation
  !  before smoothing with "r8bsmoo"
  !
  !-----------------------------
  !
  use iso_c_binding, only: fp => c_double
  use r8bsmoo_mod
  implicit none
  !
  real(fp) :: zprof(MJ)
  real(fp) :: znorm(MJ)
  !
  real(fp) :: z1(mj),zx1,zf1,zx2,zf2,zx,zf
  !
  integer :: j,jnz,jj,isrch,jsave1,jsave2
  !
  !-----------------------------
  !
  !  0.  normalize
  !
  do j=lcentr,ledge
    zprof(j)=zprof(j)/znorm(j)
    z1(j)=1.0_fp
  end do
  !
  !  1.  fill in from left
  !
  do j=lcentr,ledge
    if(zprof(j).ne.0.0_fp) go to 10
  end do
  !
  go to 1000                        ! all zero:  exit now...
  !
10 continue
  jnz=j
  do jj=lcentr,jnz-1
    zprof(jj)=zprof(jnz)
  end do
  !
  !  2.  fill in from right
  !
  do j=ledge,lcentr,-1
    if(zprof(j).ne.0.0_fp) go to 20
  end do
  !
20 continue
  jnz=j
  do jj=ledge,jnz+1,-1
    zprof(jj)=zprof(jnz)
  end do
  !
  !  3.  fill in remaining gaps with linear interpolation
  !
  isrch=1
  do j=lcentr+1,ledge-1
    if(isrch.eq.1) then
      !  find start of zeroed section
      if(zprof(j).eq.0.0_fp) then
        jsave1=j-1
        zx1=xi(jsave1,2)
        zf1=zprof(jsave1)
        isrch=2
      end if
    else if(isrch.eq.2) then
      !  find end of zeroed section
      if(zprof(j).ne.0.0_fp) then
        jsave2=j
        zx2=xi(jsave2,2)
        zf2=zprof(jsave2)
        isrch=1
        !  apply patch
        do jj=jsave1+1,jsave2-1
          zx=xi(jj,2)
          zf=zf1+(zf2-zf1)*(zx-zx1)/(zx2-zx1)
          zprof(jj)=zf
        end do
      end if
    end if                          ! isrch mode
  end do                            ! j loop
  !
  !  un-normalize
  !
  do j=lcentr,ledge
    zprof(j)=zprof(j)*znorm(j)
  end do
  !
1000 continue
  return
end subroutine r8bsmoop

C******************** START FILE IXUOPC.FOR ; GROUP URDUTS ******************
C----------------------------------------------------------
C&  IXUOPC  UREAD INTEGER FCN MATCH 1ST CHAR OF TYPEAHEAD BUFFER
C    NEW D. MC CUNE 81 MAY
C
C  ACCEPT A SEQUENCE OF CHARACTERS TERMINATED BY A "$"
C  FIND FIRST NON-BLANK CHARACTER IN INPUT BUFFER DBUFF
C  RETURN IXUOPC=0 IF INPUT BUFFER CHARACTER NOT FOUND IN INPUT STRING
C  RETURN IXUOPC=J IF BUFFER CHAR MATCHES JTH CHARACTER IN PASSED
C  STRING
C
C  INPUT STRING:  ZSTRING
C
      INTEGER FUNCTION IXUOPC(ZSTRNG)
C
      USE USERIO
C
      CHARACTER*(*) ZSTRNG
C
      CHARACTER*1 ZCHAR
C
      CALL URCHAR(ZCHAR,1,ID,IER)
C
      IF(IER.EQ.0) THEN
        IXUOPC=JXUOPC(ZSTRNG,ZCHAR)
      ELSE
        IXUOPC=0
      ENDIF
C
      IF(IXUOPC.NE.0) CALL UROTOR(ID)
C
      RETURN
      END
C******************** END FILE IXUOPC.FOR ; GROUP URDUTS ******************

integer function LKUPR_R8(X,TABLE,N)
  !
  ! Look up a real number X in a TABLE of length N.
  ! returns the value lkupr_r8 such that:
  !
  !	table(lkupr_r8) <= x < table(lkupr_r8+1)
  !
  ! assumes that table is in increasing order and does a binary search.
  !
  !============
  use iso_c_binding, only: fp => c_double
  implicit none
  integer, intent(in) :: n
  real(fp), intent(in) :: x
  real(fp), dimension(n), intent(in) :: table
  integer :: n1,n2,n3
  !
  if(X .LT. TABLE(1)) then
    LKUPR_R8=0
    GO TO 70000		!done
  end if
  !
  if(X .GE. TABLE(N)) then
    LKUPR_R8=N
    GO TO 70000		!done
  end if
  !
  N1=1
  N2=N
  !
100 continue	!LOOK AGAIN LOOP
  !
  N3=(N2+N1)/2
  !
  if(X .GE. TABLE(N3)) then
    N1=N3
  else
    N2=N3
  end if
  !
  if(N2 .EQ. N1+1) then
    LKUPR_R8=N1
    GO TO 70000	    !done
  else
    GOTO 100	    !LOOK AGAIN
  end if
 
70000 continue	!All returns from here
  !
  return
end function LKUPR_R8

C******************** START FILE UREADW.FOR ; GROUP UREADT ******************
C----------------------------------------------------------
C& UREADW  ISSUE UREAD PROMPT, RETURN BLANK/COMMA-DELIMITTED WORD
C          uppercase forced

      SUBROUTINE UREADW(PROMPT,WORD)
C
      CHARACTER*(*), intent(in) :: PROMPT
      CHARACTER*(*), intent(inout) :: WORD
    
      call ureadwi(prompt,word,1)

      return
      end
C----------------------------------------------------------
C& UREADW  ISSUE UREAD PROMPT, RETURN BLANK/COMMA-DELIMITTED WORD
C          uppercase NOT forced
C
C  dmc -- suppress parsing of "/" "parameter" strings-- usually want 
C         unix file path here...
C

      SUBROUTINE UREADLW(PROMPT,WORD)
C
      USE USERIO
C
      CHARACTER*(*), intent(in) :: PROMPT
      CHARACTER*(*), intent(inout) :: WORD
C
      character*1 zsave
    
      zsave = MPARAM
      MPARAM = char(0)

      call ureadwi(prompt,word,0)

      MPARAM = zsave

      return
      end
C----------------------------------------------------------
C
      SUBROUTINE UREADWI(PROMPT,WORD,iup)
C
      USE USERIO
C
      CHARACTER*(*), intent(in) :: PROMPT
      CHARACTER*(*), intent(inout) :: WORD
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      ILW=LEN(WORD)
      IF(NLXOUT) THEN
        IF(ILW.LE.50) THEN
          WRITE(LUNTRM,1001) WORD
 1001     FORMAT(' [OLD VALUE:  "',A,'"]')
        ELSE
          WRITE(LUNTRM,1003) WORD(1:50)
 1003     FORMAT(' [OLD VALUE:  "',A,'..."]')
        ENDIF
      ENDIF
C
      CALL UREAD(PROMPT)
C
      IF(LCHAR(' ').OR.LCHAR(',')) THEN
        IF(NLXOUT) WRITE(LUNTRM,1002)
 1002 FORMAT(' % OLD VALUE RETAINED')
      ELSE
        CALL CDCODI(WORD,iup)
      ENDIF
C
      RETURN
      END
C******************** END FILE UREADW.FOR ; GROUP UREADT ******************

C******************** START FILE URDQCD.FOR ; GROUP UREAD5 *************
C--------------------------------------------------------
C
C& URDQCD    PARSE INPUT LINE WITH "?" CONDITIONAL BRANCH/ COMMAND
C  EXECUTION CHARACTER
C
C  REMOVED FROM SUBROUTINE UREAD4 JULY 1982
C
      SUBROUTINE URDQCD(INTRP)
C
      USE USERIO
      implicit NONE
C
      integer, intent(out) :: intrp
      CHARACTER*16 ZTEST1
      CHARACTER*96 ZTEST2,ZTEST3
      CHARACTER*1 ZLTEMP(80)
C
      character*(urdbufl) ZCBUFF
C
C  CHECK FOR SPECIAL CODES TO SPECIFY CHECK OF PARAMETERS
C  FOR CONDITIONAL EXECUTION OF A PART OF AN INDIRECT INPUT FILE
C
C  FORMAT:
C   '?<PARM.NAME>="<PARM.VALUE>" SKIPTO <MARKER>'
C    .
C    .
C   ':<MARKER>
C  RESULTS IN THE EXECUTION OF THE LINES (...) BETWEEN THE
C  ?-SKIPTO COMMAND ONLY IF THE PARAMETERS <PARM.NAME>
C  DOESNT HAVE THE VALUE <PARM.VALUE>.  IF THE PARAMETER
C  DOESNT HAVE THE SPECIFIED VALUE THE LINES FROM THE
C  SKIPTO COMMAND TO THE LINE CONTAINING ":<MARKER>" ARE
C  SKIPPED OVER.  IF IN PLACE OF "=" A "#" IS USED THEN THE
C  TEST FOR THE SKIPTO COMMAND IS .NE. INSTEAD OF .EQ.
C
C  NOTE THE DIFFERENCE BETWEEN THIS SYNTAX AND ORDINARY
C  FORTRAN "IF (LOGICAL EXPRESSION) GO TO <LINE #>" SYNTAX:
C  SKIPTO IS INTERPRETIVE IN NATURE AND ONE MAY ONLY SKIP
C  "DOWN" THE INPUT FILE; SKIPPING UP TO A PRIOR LINE IN THE
C  SEQUENTIAL INPUT, WHICH WOULD ALLOW LOOPING, IS NOT PERMITTED,
C  INDEED NOT POSSIBLE SINCE THE INPUT FILE IS READ SEQUENTIALLY
C  AND INTERPRETED LINE-BY-LINE.
c   rev d. mc cune 14 nov 1981.  now looping will be allowed:
c  if end of file without finding <MARKER> is reached the file
c  will be closed and reopened and the process will be repeated once
c  only.  thus looping of sorts is supported
C
C
C  REV-- D. MC CUNE 23 JULY 1981.  IF THE "SKIPTO" AFTER THE
C  TEST CONDITION IS NOT FOUND THEN THE TEXT FOLLOWING THE TEST
C  IS ASSUMED TO BE A COMMAND LINE TO BE RETURNED TO THE MAIN
C  PROGRAM, IF THE TEST CONDITION WAS SATISFIED
C
c  rev dmc 2009 (28 years later)!
c  add this test:  ?DEFINED(<parm.name>) ...
c     TRUE if the argument is a defined parameter name, otherwise FALSE
c  also: ?UNDEFINED(<parm.name>) ...
C
C---------
      integer :: im1,id1,iu1,iarg1,iarg2,ic,indop,i1,i2,iml,imn,im2
      integer :: iper,ilen,iv1,iv2,ivx,ieqs,itest,ians,ii
      integer :: i,ishft,inum,inump1,imst,isemi,iline,iparen
      logical :: iresult
C---------
C  operate on uppercase buffer
      zcbuff=cbuff
      call uspcap(zcbuff)
C
C  CLEAR MARKER AND SUBSTITUTED INTERPRETABLE COMMAND FLAGS
      INTRP=0
      LMARKN=0
C  CHECK FOR SKIPTO BRANCH FORMAT
C  VALID ONLY FOR INPUT FROM OR OUTPUT TO INDIRECT INPUT FILES
      IM1=INDEX(ZCBUFF,'SKIPTO')

C  DMC 5/2009:
C  CHECK for DEFINED/UNDEFINED operators
      CALL chk_op('DEFINED',id1,iarg1,iarg2)
      if(id1.eq.-1) return

      if(id1.eq.0) then
         CALL chk_op('UNDEFINED',iu1,iarg1,iarg2)
         if(iu1.eq.-1) return
      else
         iu1=0
      endif

 9305 FORMAT(' ? ERROR IN "?"-BRANCH LINE, LINE IGNORED')

      if(max(iu1,id1).gt.0) then
         CALL USPLNM(DBUFF,LBUFF,iarg1,iarg2,ZTEST1,IPER)
         IF(IPER.NE.0) THEN
            WRITE(LUNTRM,9305)
            CALL UTRACE
            CALL UCBUFX
            CALL UCLEAR
            RETURN
         ENDIF
      
C     ZTEST1 contains legal parameter name

         CALL USPGET(ztest1,ztest2,itest)  ! itest=0 means: DEFINED.

         if(id1.gt.0) iresult = (itest.eq.0)
         if(iu1.gt.0) iresult = (itest.ne.0)

         if(.NOT.iresult) return  ! condition not satisfied => exit, do nothing

         if(im1.gt.0) go to 350   ! execute SKIPTO

         iparen=0
         do i=iarg2,lbuff
            if(iparen.eq.0) then
               if(dbuff(i).eq.')') iparen=i
            else
               if((dbuff(i).ne.' ').AND.(dbuff(i).ne.char(9))) exit
            endif
         enddo

         go to 344                ! to interpret remainder of line...
      endif

C  RESUME traditional legacy UREAD SKIPTO and ? branch parsing

      IF(.not.((IM1.EQ.0).OR.(NLINDI.OR.NLINDO))) then
         WRITE(LUNTRM,9301)
 9301    FORMAT(' ? "?"/SKIPTO FORMAT NOT VALID IN THIS CONTEXT'/
     >        '   NO INDIRECT INPUT FILE IS OPEN.')
         CALL UCLEAR
         RETURN
      ENDIF
C
      IF(.not.NLINDI) THEN
         IF(IM1.GT.0) WRITE(LUNTRM,9302)
 9302    FORMAT(' % CONDITIONAL SKIPTO INSERTED IN OUTPUT FILE'/
     >        '   SKIPTO DESTINATION MARKER SHOULD BE INSERTED BEFORE'/
     >        '   E-O-F AND IMMEDIATELY FOLLOWING A PROMPT MATCHING'/
     >        '   THE CURRENT PROMPT.  AWAITING INPUT:')
         IF(IM1.GT.0) RETURN
      ENDIF
C
C  PARSE SKIPTO COMMAND; INPUT IS INDIRECT (NLINDI=.TRUE.) (from file)
C
C  CHECK FOR UNCONDITIONAL SKIPTO
C  FORMAT: "?SKIPTO <MARKER>"; CONDITIONAL TEST OMITTED
      IF((IM1.GT.0).AND.(IM1.LE.4)) GO TO 350
C  LOCATION OF OPERATOR SYMBOL "=" OR "#"
      DO IC=2,LBUFF
        IF((CBUFF(IC:IC).EQ.'=').OR.(CBUFF(IC:IC).EQ.'#')) GO TO 326
      ENDDO
      IC=0
 326  INDOP=IC
C
      IF(INDOP.EQ.0) THEN
         WRITE(LUNTRM,9303)
 9303    FORMAT(/
     >      ' ? NO LOGICAL OPERATOR ("=" OR "#") IN "?"-BRANCH LINE.  ',
     >        'LINE IGNORED'/
     >        1X,A)
         CALL UTRACE
         CALL UCBUFX
         CALL UCLEAR
         RETURN
C
      ENDIF
C  GET PARAMTER NAME; CHECK LEGALITY OF NAME
      I1=2
      I2=INDOP-1
      CALL USPLNM(DBUFF,LBUFF,I1,I2,ZTEST1,IPER)
      IF(IPER.NE.0) THEN
         WRITE(LUNTRM,9305)
         CALL UTRACE
         CALL UCBUFX
         CALL UCLEAR
         RETURN
      ENDIF
C  GET PARAMETER VALUE; CHECK FOR EXISTANCE THEREOF
      CALL USPGET(ZTEST1,ZTEST2,IPER)
      IF(IPER.NE.0) THEN
         ILEN=LPVAL+2
         CALL UPQUER(ZTEST1,ZLTEMP,ILEN,ZTEST2)
      ENDIF
C
C  LOCATE COMPARISON-VALUE FIELD, DELIMITTED BY DOUBLE QUOTES
C
      IV1=INDOP+1
      IV2=INDOP
      do ii=iv1,lbuff
         ! find opening quote, must be 1st non-blank character
         if(dbuff(ii).eq.'"') then
            iv1=ii
            iv2=iv1
            exit
         else if(dbuff(ii).ne.' ') then
            exit
         endif
      enddo

      if(iv2.eq.iv1) then
         ! find closing quote -- 1st one taken...
         i1=iv1+1
         iv1=0
         do ii=i1,lbuff
            if(dbuff(ii).eq.'"') then
               iv1=i1
               iv2=ii-1
               exit
            endif
         enddo
         if(iv1.eq.0) then
            IV1=INDOP+1
            IV2=INDOP
         endif
      endif
C
      CALL USPLVL(DBUFF,LBUFF,IV1,IV2,ZTEST3,IPER)
C
      IF(IPER.NE.0) THEN
         WRITE(LUNTRM,9307)
 9307    FORMAT(
     >        ' ? ERROR IN "?"-BRANCH LINE COMPARISON VALUE FIELD')
         CALL UTRACE
         CALL UCBUFX
         CALL UCLEAR
         RETURN
      ENDIF
C
C  PERFORM TEST TO DECIDE WHETHER TO PERFORM SKIP
C
      IEQS=1
      IF(DBUFF(INDOP).EQ.'#') IEQS=-1
C
      ITEST=1
      call uspcap(ztest2)
      call uspcap(ztest3)
      IF(ZTEST2.NE.ZTEST3) ITEST=-1
C
      IANS=IEQS*ITEST
      IF(IANS.NE.1) RETURN
C
C  CONDITIONAL OPERATION IS TO BE PERFORMED.  FIND MARKER FIELD
C
C  SEE ABOVE ***IM1=INDEX(ZCBUFF,'SKIPTO ')
C  IF "SKIPTO" NOT FOUND (IM1=0) DO SUBSTITUTION INSTEAD OF
C  SKIP
C
      IF(IM1.GT.0) GO TO 350
C  CONDITIONAL TEST PASSED; SUBSTITUTE COMMAND INTO LINE AND
C  INTERPRET
      IVX=IV2+2
      DO I=IVX,LBUFF
         IF(CBUFF(I:I).NE.' ') GO TO 344
      ENDDO
C  BLANK LINE
      RETURN

 344  CONTINUE
      ISHFT=I

      INUM=LBUFF-ISHFT+1
      DO I=1,INUM
         I2=I+ISHFT-1
         CBUFF(I:I)=CBUFF(I2:I2)
      ENDDO

      INUMP1=INUM+1
      DO I=INUMP1,LBUFF
         CBUFF(I:I)=' '
      ENDDO
C  PUT IN UNPACKED BUFFER ALSO
      CALL UDECOD
C  STUFF AFTER "?" TEST HAS BEEN SHIFTED TO CONSTITUTE ENTIRE
C  INPUT LINE. PROCEED TO INTERPRET LINE
      INTRP=1
      RETURN
C--
 350  CONTINUE
      IMST=IM1+6
C
C  REV DMC OCT 1990 -- MAKE SURE COMMENT IS EXCLUDED FROM MARKER FIELD
C
      ISEMI=IMST
      CALL UFCHAR(DBUFF,MSEMI,ISEMI,LBUFF)
      IF(ISEMI.GT.0) THEN
         ILINE=ISEMI-1
      ELSE
         ILINE=LBUFF
      ENDIF
C
      CALL FLDXTR(DBUFF,IMST,ILINE,' ',' ',IM1,IM2)
      IMN=IM2-IM1+1
      IF(IMN.LE.0) THEN
         WRITE(LUNTRM,9309) CBUFF
 9309    FORMAT(' ? DESTINATION MARKER MISSING FROM SKIPTO LINE:'/
     >        1X,A/' LINE IGNORED.'/)
         CALL UCLEAR
         RETURN
      ENDIF
C
C  SAVE MARKER
      LMARKN=IMN
      DO I=1,LMARKN
         IML=IM1+I-1
         URMARK(I:I)=DBUFF(IML)
      ENDDO
      call uspcap(urmark)
C
      RETURN

      contains
        subroutine chk_op(opword,ic,ia1,ia2)

          ! check for DEFINED or UNDEFINED operators

          character*(*), intent(in) :: opword  ! operator keyword, uppercase
          integer, intent(out) :: ic   ! location of opword; 0=none; -1=error
          integer, intent(out) :: ia1  ! position of start of operand string
          integer, intent(out) :: ia2  ! position of end of operand string

          !---------------------------
          integer :: iquest,inb,ia,ilenop
          !---------------------------

          ilenop = len(trim(opword))
          ia1=0
          ia2=0

          ic=index(zcbuff,opword)
          if(ic.le.0) then
             ic=0
             return
          endif

          ilen = len(trim(zcbuff))

          iquest=0
          do ia=1,ilen
             if(iquest.eq.0) then
                if(zcbuff(ia:ia).eq.'?') then
                   iquest=ia
                   cycle
                endif
             endif
             if(zcbuff(ia:ia).eq.' ') cycle
             if(zcbuff(ia:ia).eq.char(9)) cycle

             if(zcbuff(ia:ia+ilenop-1).ne.opword) then
                ic=0
             endif
             exit
          enddo

          if(ic.eq.0) return

          ia=ia+ilenop
          if((zcbuff(ia:ia).ne.' ').AND.(zcbuff(ia:ia).ne.char(9)).AND.
     >         (zcbuff(ia:ia).ne.'(')) then
             ! opword is only a substring
             ic=0
             return
          endif

          ! look for 1st non-blank after keyword

          do
             if((zcbuff(ia:ia).ne.' ').AND.
     >            (zcbuff(ia:ia).ne.char(9))) then
                if(zcbuff(ia:ia).ne.'(') ic=-1
                exit
             endif
             if(ia.eq.ilen) then
                ic=-1   ! argument not found
                exit
             endif
             ia=ia+1
          enddo
          if(ic.lt.0) go to 999

          ! dbuff is unpacked vsn of zcbuff
          call fldxtr(dbuff,ia,ilen,'(',')',ia1,ia2)
          if(ia2.lt.ia1) then
             ic=-1
             go to 999
          endif

          return

                                ! error
 999      continue

          write(luntrm,*) ' ?urdqcd: malformed '//
     >         trim(opword)//' operator:'
          write(luntrm,*) trim(zcbuff)
          call uclear
          return

        end subroutine chk_op

      END
C******************** END FILE URDQCD.FOR ; GROUP UREAD5 ***************

!
! Defines more verbose and flexible system like calls.  See porttest/execsystem_test.f90 
! for some examples.
!
#include "fpreproc/byte_declare.h"

module execsystem
  use logmod, only: openlog, infolog, errorlog, setloglevel, &
       enterlog, exitlog

  implicit none

  integer, save :: EXEC_METHOD = 3     ! method for making the jsystem and jexec calls.  Probably best to set this at the
                                       ! beginning of the program and leave it. 
                                       !   0 -> make call within the process using heap arguments
                                       !   1 -> use static memory for child exec() arguments -- a custom
                                       !        environment is not available and there will be no verbose messages from
                                       !        the child.  Also, the full path to the executable is required.  For jsystem(),
                                       !        the string '/bin/' will prepended to SHELL_EXEC.
                                       !   2 -> make call to a shell server.  The shell server must have already been
                                       !        started.  A custom environment is not available.  The shell server working
                                       !        directory will be set to the cwd of the calling process.
                                       !   3 -> call Fortran execute_command_line

  integer, save :: EXEC_VERBOSE = 0    ! set >0 for verbose messages to stdout, <0 to stderr (not buffered?)

  character(len=32), save :: SHELL_EXEC   = "sh"   ! default shell, room for some path
  character(len=8),  save :: SHELL_LAUNCH = "-c"   ! argument for launching inline shell command

  interface jsystem
     module procedure jsystem_env, jsystem_one
  end interface

  interface jexec
     module procedure jexec_env, jexec_one
  end interface

  private jsystem_env, jsystem_one, jexec_env, jexec_one, EXEC_RUNID, EXEC_IS_SERVER

  character(len=16), save :: EXEC_RUNID = "                "   ! filled with runid after connection to shell server

  logical, save :: EXEC_IS_SERVER = .false.   ! .true. if this process is connected to a shell server

  integer, parameter, private :: EXEC_MAX_STR = 257  ! maximum length of a string with 0 terminator 
contains
  !
  ! --------- jconnect_server -------
  ! Connect to a running shell server.  Will attempt to connect to the fifos
  !   <runid>_command.fifo  -> send shell,exec commands as strings to this fifo
  !   <runid>_result.fifo   -> retrieve integer result from this fifo as a string
  !
  ! Only one process can be connected at a time.  A test message will be sent during the open
  ! to check the connection.
  !
  ! For an MPI process, only the ranks in the communicator which have been identified as I/O
  ! ranks for each of the nodes by mpi_proc_data will try to connect to a shell server.  So there
  ! should be one shell server running on each of the nodes.
  !
  ! The shell server should be started with,
  !    shell_server  fifo <verbose> <output> <runid>_command.fifo <runid>_result.fifo
  !        <verbose> = controls verbosity of server to <output>
  !                      -1 verbose output to stderr
  !                       0 no verbose
  !                       1 verbose output to stdout
  !        <output>  = name of file where stdout, stderr for system commands is sent
  !
  !        <runid>_command.fifo = name of fifo for commands.  This is created and read by the 
  !                               shell server
  !        <runid>_result.fifo  = name of fifo used to return the single integer status from the 
  !                               system command.  This is deleted by this subroutine and created
  !                               by the shell server just before returning the test results.
  !
  subroutine jconnect_server(runid, ier, comm, barrier)
    use mpi_proc_data, only: check_mpi_io_node

#ifdef __MPI
    use mpi, only: mpi_comm_world
#endif

    character(len=*), intent(in)  :: runid    ! runid used to identify fifos for the server, empty to close
    integer,          intent(out) :: ier      ! nonzero on error in this process (not all reduced)

    integer, optional, intent(in) :: comm     ! communicator used as basis for opening a connection.  Only the
                                              ! unique ranks on each node associated with this communicator
                                              ! will open a connection.  This communicator must have been added to
                                              ! mpi_proc_data with mpi_proc_data.mpi_env_comm_add().  If not present,
                                              ! MPI_COMM_WORLD will be used.
    logical, optional, intent(in) :: barrier  ! for an mpi call, an mpi_barrier will be called before exiting
                                              ! this subroutine if barrier=.true.

    character(len=32) :: com   ! name of command fifo
    character(len=32) :: res   ! name of result fifo
    character(len=64) :: msg   ! message to use when testing the connection

    byte_declare :: ccom(33), cres(33), cmsg(65)  ! c versions
    
    integer, external :: c_connect_shell_server ! c code

    logical :: try_connect   ! .true. if will try a connection 
    integer :: use_comm      ! communicator to use
    integer :: iber          ! barrier error

    ier = 0

    call enterLog("jconnect_server")

    try_connect = .true.

    EXEC_IS_SERVER = .false.

#ifdef __MPI
    if (present(comm)) then
       use_comm = comm
    else
       use_comm = MPI_COMM_WORLD   
    end if

    try_connect = check_mpi_io_node(use_comm,ier)  ! is this an I/O node?

    if (ier/=0) then
       call errorLog("jconnect_server: unknown communicator =",use_comm)
       ier=1
       try_connect = .false.
    end if
#endif

    if (try_connect) then
       if (len_trim(runid)/=0) then
          if (len_trim(EXEC_RUNID)/=0) then
             call errorLog('jconnect_server: A connection to a shell server has already been made')
             ier=1 ; goto 900
          else
             EXEC_RUNID = adjustl(runid)
             call uupper(EXEC_RUNID)
             
             com = trim(EXEC_RUNID)//"_command.fifo"
             res = trim(EXEC_RUNID)//"_result.fifo"
             msg = "opening server for TRANSP run "//trim(EXEC_RUNID)
             
             call cstring(trim(com),ccom,'2C')
             call cstring(trim(res),cres,'2C')
             call cstring(trim(msg),cmsg,'2C')
             
             call infoLog("jconnect_server: making shell server connection to "//trim(com)//", "//trim(res))

             ier = c_connect_shell_server(0, ccom, cres, cmsg)    ! open the connection

             EXEC_IS_SERVER = ier==0
          end if
       else
          com = " " ; res = " " ; msg = " "
          call cstring(trim(com),ccom,'2C')
          call cstring(trim(res),cres,'2C')
          call cstring(trim(msg),cmsg,'2C')
          
          call infoLog("jconnect_server: closing shell server connection")

          ier = c_connect_shell_server(-1, ccom, cres, cmsg)   ! close the open connection
          
          EXEC_RUNID = " "
       end if
    end if

900 continue

#ifdef __MPI
    if (present(barrier)) then
       if (barrier) then
          call MPI_BARRIER(use_comm, iber)
          if (iber/=0) then
             call errorLog("jconnect_server: barrier error")
             ier=1
          end if
       end if
    end if
#endif

    call exitLog("jconnect_server")
  end subroutine jconnect_server

  !
  ! --------- jsystem ----------
  !
  ! Make a system call with an alternate environment.
  !
  ! For an MPI environment, the communicator (default MPI_COMM_WORLD) must have been added to mpi_proc_data
  ! and only I/O ranks will execute the system call.
  !
  function jsystem_env(str, ne, env, comm, barrier, allcpus, method) result(ier)
    use mpi_proc_data, only:

#ifdef __MPI
    use mpi, only:
#endif

    character(len=*), intent(in) :: str       ! shell command to execute
    integer,          intent(in) :: ne        ! number of environment variables or -1 to use the default
    character(len=*), intent(in) :: env(max(0,ne)) ! list of new NAME=VALUE environment to replace current environment

    integer, optional, intent(in) :: comm     ! communicator used as basis for opening a connection.  Only the
                                              ! unique ranks on each node associated with this communicator
                                              ! will open a connection.  This communicator must have been added to
                                              ! mpi_proc_data with mpi_proc_data.mpi_env_comm_add().  If not present,
                                              ! MPI_COMM_WORLD will be used.
    logical, optional, intent(in) :: barrier  ! for an mpi call, an mpi_barrier will be called before exiting
                                              ! this subroutine if barrier=.true.
    logical, optional, intent(in) :: allcpus  ! .true. if command should be executed for all the cpus
                                              ! .false. if only the io-node cpus should execute the command (default)
    integer, optional, intent(in) :: method   ! if present, use this in place of EXEC_METHOD -- only valid if method=0,1

    character(len=48) :: myshell    ! shell as used here

    integer :: ier             ! returned status code of shell command
    integer :: asmethod        ! exec method to use

    character(len=EXEC_MAX_STR) :: arg(3)  ! exec arguments

    ier = 0

    call enterLog("jsystem_env")

    if (len_trim(adjustl(str))>(EXEC_MAX_STR-1)) then
       call errorLog("jsystem_env: shell command string is too long")
       ier=123 ; goto 900
    end if

    asmethod = EXEC_METHOD
    if (present(method)) then
       if (method==0 .or. method==1) asmethod=method
    end if

    if (asmethod/=1) then
       myshell = adjustl(SHELL_EXEC)           ! using execvp(), path is searched
    else
       myshell = "/bin/"//adjustl(SHELL_EXEC)  ! using execv(), full path to executable is required
    end if

    myshell = adjustl(myshell)
    arg(1)  = adjustl(SHELL_EXEC)
    arg(2)  = adjustl(SHELL_LAUNCH)
    arg(3)  = adjustl(str)


    call infoLog("jsystem_env: executing system call, "//trim(adjustl(str)))

    ier = jexec_env(myshell, 3, arg, ne, env, comm, barrier, allcpus, method, noelog=.true.)

900 continue

    call exitLog("jsystem_env")
  end function jsystem_env

  
  !
  ! --------- jsystem_one ----------
  !
  ! Make a system call with the default environment
  !
  ! For an MPI environment, the communicator (default MPI_COMM_WORLD) must have been added to mpi_proc_data
  ! and only I/O ranks will execute the system call.
  !
  function jsystem_one(str, comm, barrier, allcpus, method) result(ier)
    character(len=*), intent(in) :: str            ! shell command to execute

    integer, optional, intent(in) :: comm     ! communicator used as basis for opening a connection.  Only the
                                              ! unique ranks on each node associated with this communicator
                                              ! will open a connection.  This communicator must have been added to
                                              ! mpi_proc_data with mpi_proc_data.mpi_env_comm_add().  If not present,
                                              ! MPI_COMM_WORLD will be used.
    logical, optional, intent(in) :: barrier  ! for an mpi call, an mpi_barrier will be called before exiting
                                              ! this subroutine if barrier=.true.
    logical, optional, intent(in) :: allcpus  ! .true. if command should be executed for all the cpus
                                              ! .false. if only the io-node cpus should execute the command (default)
    integer, optional, intent(in) :: method   ! if present, use this in place of EXEC_METHOD -- only valid if method=0,1

    integer :: ier    ! returned status code of shell command

    character(len=8) :: env(0)  ! no environment

    ier = jsystem_env(str,-1,env,comm=comm, barrier=barrier, allcpus=allcpus, method=method)
  end function jsystem_one
  

  !
  ! -------------------- jexec_env --------------------
  ! Execute a command on the path in a forked process.
  ! Generally, the first argument should be the name of the command being executed.
  !
  ! For an MPI environment, the communicator (default MPI_COMM_WORLD) must have been added to mpi_proc_data
  ! and only I/O ranks will execute the system call.
  !
  function jexec_env(exe, na, arg, ne, env, comm, barrier, allcpus, method, noelog) result(ier)
    use mpi_proc_data, only: check_mpi_io_node, mpi_proc_info_comm

#ifdef __MPI
    use mpi, only: mpi_comm_world, mpi_status_size, mpi_integer, mpi_max

    integer, parameter :: STATUS_SIZE = MPI_STATUS_SIZE
#else
    integer, parameter :: STATUS_SIZE = 1
#endif

    character(len=*), intent(in) :: exe            ! command to execute, will be searched on path
    integer,          intent(in) :: na             ! number of arguments
    character(len=*), intent(in) :: arg(max(0,na)) ! list of arguments
    integer,          intent(in) :: ne             ! number of environment variables or -1 to use the default
    character(len=*), intent(in) :: env(max(0,ne)) ! list of new NAME=VALUE environment to replace current environment

    integer, optional, intent(in) :: comm     ! communicator used as basis for opening a connection.  Only the
                                              ! unique ranks on each node associated with this communicator
                                              ! will open a connection.  This communicator must have been added to
                                              ! mpi_proc_data with mpi_proc_data.mpi_env_comm_add().  If not present,
                                              ! MPI_COMM_WORLD will be used.
    logical, optional, intent(in) :: barrier  ! for an mpi call, an mpi_barrier will be called before exiting
                                              ! this subroutine if barrier=.true.
    logical, optional, intent(in) :: allcpus  ! .true. if command should be executed for all the cpus
                                              ! .false. if only the io-node cpus should execute the command (default)
    integer, optional, intent(in) :: method   ! if present, use this in place of EXEC_METHOD -- only valid if method=0,1
    logical, optional, intent(in) :: noelog   ! if present and .false. do not execute enterLog,exitLog,warnLog

    integer :: ier    ! returned status code of shell command

    integer :: ks,ka,ke        ! length of strings

    integer, external :: c_execsystem      ! c code

    byte_declare, allocatable :: exes(:)   ! c version of exec name 
    byte_declare, allocatable :: args(:)   ! arguments for exec
    byte_declare, allocatable :: envs(:)   ! enviornment variables

    logical :: try_exec      ! .true. if will try an exec call 
    logical :: try_multi     ! .true. if forwarding system calls to the shell server cpu
    logical :: ielog         ! .true. for enter,exit log messages

    integer :: use_comm      ! communicator to use
    integer :: iber          ! barrier error
    integer :: em            ! bounded exec method
    integer :: asmethod      ! exec method to use
    integer :: mynode        ! node number
    integer :: num_procs     ! number of processors in comm
    integer :: key           ! controls ordering of cpus in splitcomm
    integer :: splitcomm     ! new communicator among cpus on each node
    integer :: mysplit       ! cpu number on splitcomm
    integer :: cer           ! nonzero if splitcomm not ordered correctly
    integer :: aer           ! reduced cer
    integer :: numsplits     ! number of cpus on splitcomm
    integer :: maxna, maxne  ! maximum number of na,ne across all processors
    integer :: maxstr        ! number of strings in imash
    integer :: maxint        ! number of integers needed in imash
    integer :: i,k,ic,j      ! loop variables

    integer :: ixna,ixne,ixcd,ixexe,ixarg,ixenv  ! indices into imash

    integer, allocatable :: imash(:)   ! mash up of arguments and cwd to transfer by mpi    
    integer, allocatable :: iall(:,:)  ! mash up of arguments from each cpu

    character(len=EXEC_MAX_STR) :: mycwd  ! cwd of this cpu

    integer :: fromna, fromne  ! na,ne from other cpu

    character(len=EXEC_MAX_STR) :: fromcwd, fromexe   ! cwd, exe from other cpu

    character(len=EXEC_MAX_STR),allocatable :: fromarg(:), fromenv(:)  ! arg and env from other cpu

    integer :: status(STATUS_SIZE)  ! status from mpi call

    ier = 0
    
    ielog = .true.
    if (present(noelog)) then
       ielog = .not. noelog
    end if

    if (ielog) call enterLog("jexec_env")

    try_exec  = .true.
    try_multi = .false.
    asmethod  = EXEC_METHOD
    mycwd     = ' '            ! considered set if the first character is not a space

    if (present(method)) then
       if (method==0 .or. method==1) asmethod=method
    end if

#ifdef __MPI
    if (present(comm)) then
       use_comm = comm
    else
       use_comm = MPI_COMM_WORLD   
    end if

    try_exec = check_mpi_io_node(use_comm,ier)  ! is this an I/O node?

    if (ier/=0) then
       call errorLog("jexec_env: unknown communicator =",use_comm)
       ier=1
       try_exec = .false.
    else
       if (present(allcpus)) then
          if (asmethod==2 .and. allcpus) then
             ! -- shell server and using all cpus --
             try_exec  = .false.
             try_multi = .true.
          else
             try_exec = try_exec .or. allcpus
          end if
       end if
    end if
#endif

    !
    ! execution of the system call from this cpu
    !
    if (try_exec) then
      if (asmethod == 3) then
        !write(6,*) "System call with Fortran execute_command_line"
        !write(6,*) trim(arg(na)) ; call flush(6)
        call execute_command_line(arg(na),exitstat=ier)
      else
        ks = len_trim(adjustl(exe))

        ka = 0
        do i=1, na
          ka = ka + len_trim(adjustl(arg(i)))+1
        end do
       
        ke = 0
        if (ne>=0) then
          do i=1, ne
            ke = ke + len_trim(adjustl(env(i)))+1
          end do
        end if
       
        allocate(exes(ks+1),args(ka+1),envs(ke+1))  ! room for null termination
       
        exes = 0
        args = 0
        envs = 0
       
        call cstring(trim(adjustl(exe)), exes, '2C')
       
        ka = 1
        do i=1, na
          call cstring(trim(adjustl(arg(i))), args(ka:),'2C')
          ka = ka+len_trim(adjustl(arg(i)))+1
        end do
       
        if (ne>=0) then
          ke = 1
          do i=1, ne
            call cstring(trim(adjustl(env(i))), envs(ke:),'2C')
            ke = ke+len_trim(adjustl(env(i)))+1
          end do
        end if

        call infoLog("jexec_env: executing exec call, "//trim(exe))

        em = max(0, min(2, asmethod))

        ier = c_execsystem(em, EXEC_VERBOSE, exes, na, args, ne, envs)
       
        deallocate(exes, args, envs)
      end if
    else if (.not. try_multi) then
      call infoLog("jexec_env: not an I/O cpu -- no exec()")
    end if

#ifdef __MPI
    !
    ! forward system calls to the cpu on the node connected to the shell server
    !
    if (try_multi) then
       if (asmethod/=2) then
          call errorLog("jexec_env: what am I doing here? -- asmethod=",asmethod)  
          ier=1 ; goto 900
       end if

       !
       ! create a communicator for each node with the shell server cpu at rank 0
       !
       call mpi_proc_info_comm(use_comm, ier, mynode=mynode, num_procs=num_procs)
       if (ier/=0) then
          call errorLog("jexec_env: mpi_proc_info_comm error on use_comm")
          ier=1 ; goto 900
       end if

       if (EXEC_IS_SERVER) then
          key = 0    ! connected to shell server, want this as rank 0
       else
          key = 1   
       end if

       call mpi_comm_split(use_comm, mynode, key, splitcomm, ier)
       if (ier/=0) then
          call errorLog("jexec_env: mpi_comm_split error")
          ier=1 ; goto 900
       end if

       !
       ! have splitcomm, exit through 800 
       !

       ! -- check how ranks are set up --
       call mpi_comm_rank(splitcomm, mysplit, ier)
       if (ier/=0) then
          call errorLog("jexec_env: mpi_comm_rank error on splitcomm")
          ier=1 ; goto 800
       end if

       if (mysplit==0 .and. .not. EXEC_IS_SERVER) then
          call errorLog("jexec_env: cpu is rank 0 in splitcomm but not connected to a shell server")
          cer=1
       else
          cer = 0
       end if
       
       call mpi_allreduce(cer, aer, 1, MPI_INTEGER, MPI_MAX, use_comm, ier)   ! collect error codes from all cpus
       if (ier/=0) aer=1
       if (aer/=0) then
          call errorLog("jexec_env: mpi_allreduce error or there is a rank 0 cpu not connected to a shell server")
          ier=1 ; goto 800
       end if
       
       ! -- mash up input data into imash --
       call mpi_comm_size(splitcomm, numsplits, ier)
       if (ier/=0) then
          call errorLog("jexec_env: mpi_comm_size error on splitcomm")
          ier=1 ; goto 800
       end if

       call sget_cwd(mycwd)    ! fetch working directory
       mycwd = adjustl(mycwd)  ! so first character is not a space to mark as set

       if (ier==0) call mpi_allreduce(na, maxna, 1, MPI_INTEGER, MPI_MAX, splitcomm, ier)
       if (ier==0) call mpi_allreduce(ne, maxne, 1, MPI_INTEGER, MPI_MAX, splitcomm, ier) 
       if (ier/=0 .or. maxna<0) then
          call errorLog("jexec_env: mpi_allreduce error on maxna or maxne or maxna<0")
          ier=1 ; goto 800
       end if

       maxne = max(0,maxne)                 ! maxne<0 possible if no environment variables

       maxstr = maxna + maxne + 2           ! number of strings, args, envs, exe, cwd
       maxint = 2 + EXEC_MAX_STR*maxstr     ! number of integers needed to store arguments -- waste of bytes

       allocate(imash(maxint))
       imash=0                              ! so all strings are zero terminated

       ixna  = 1                            ! set up pointers into imash, actual pointers would have been more clever
       ixne  = 2
       ixcd  = 3
       ixexe = ixcd  + EXEC_MAX_STR
       ixarg = ixexe + EXEC_MAX_STR
       ixenv = ixarg + maxna*EXEC_MAX_STR

       imash(ixna) = na
       imash(ixne) = ne

       if (len_trim(mycwd)>(EXEC_MAX_STR-1)) then                           ! need space for 0 terminator
          call errorLog("jexec_env: working directory string is too long")
          ier=1 ; goto 800
       end if
          
       ic = ixcd
       do i = 1, len_trim(mycwd)
          imash(ic) = ichar(mycwd(i:i)) ; ic=ic+1
       end do
       
       if (len_trim(exe)>(EXEC_MAX_STR-1)) then
          call errorLog("jexec_env: exe string is too long")
          ier=1 ; goto 800
       end if
          
       ic = ixexe
       do i = 1, len_trim(exe)
          imash(ic) = ichar(exe(i:i)) ; ic=ic+1
       end do

       do k=1, na
          if (len_trim(arg(k))>(EXEC_MAX_STR-1)) then
             call errorLog("jexec_env: argument string is too long")
             ier=1 ; goto 800
          end if
          
          ic = ixarg + (k-1)*EXEC_MAX_STR
          do i = 1, len_trim(arg(k))
             imash(ic) = ichar(arg(k)(i:i)) ; ic=ic+1
          end do
       end do

       do k=1, ne
          if (len_trim(env(k))>(EXEC_MAX_STR-1)) then
             call errorLog("jexec_env: environment string is too long")
             ier=1 ; goto 800
          end if
          
          ic = ixenv + (k-1)*EXEC_MAX_STR
          do i = 1, len_trim(env(k))
             imash(ic) = ichar(env(k)(i:i)) ; ic=ic+1
          end do
       end do

       ! -- send imash to rank 0 --
       allocate(iall(maxint,numsplits))

       call infoLog("jexec_env: sending command to rank 0 of split communicator")

       call mpi_gather(imash, maxint, mpi_integer, iall, maxint ,mpi_integer, 0, splitcomm, ier)
       if (ier/=0) then
          call errorLog("jexec_env: mpi_gather error")
          ier=1 ; goto 800
       end if

       cer = 0   ! system call error flag

       if (mysplit==0) then
          !
          ! -- execute system commands in iall --
          !
          allocate(fromarg(maxna), fromenv(maxne))

          call infoLog("jexec_env: starting system calls on behalf of siblings")
          do j=1, numsplits
             !
             ! exits through 700 with ier set
             !
             call infoLog("jexec_env: exec for cpu ",j-1)

             imash = iall(:,j)

             fromna = imash(ixna)
             fromne = imash(ixne)

             if (fromna>maxna .or. fromne>maxne .or. fromna<0) then
                call errorLog("jexec_env: bad na,ne from sibling ranks")   ! assert
                ier=1 ; goto 700
             end if
                
             call tostr(imash(ixcd),  fromcwd) ; if (ier/=0) goto 700
             call tostr(imash(ixexe), fromexe) ; if (ier/=0) goto 700

             call infoLog("jexec_env: cd to '"//trim(adjustl(fromcwd))//"'")

             call sset_cwd(trim(adjustl(fromcwd)),ier)

             if (ier/=0) then
                call errorLog("jexec_env: error changing directory")  
                call errorLog(trim(adjustl(fromcwd))) 
                ier=1 ; goto 700
             end if
                
             do k=1, fromna
                call tostr(imash(ixarg+(k-1)*EXEC_MAX_STR), fromarg(k)) ; if (ier/=0) goto 700
             end do

             do k=1, fromne
                call tostr(imash(ixenv+(k-1)*EXEC_MAX_STR), fromenv(k)) ; if (ier/=0) goto 700
             end do

             ks = len_trim(adjustl(fromexe))

             ka = 0
             do i=1, fromna
                ka = ka + len_trim(adjustl(fromarg(i)))+1
             end do
       
             ke = 0
             if (fromne>=0) then
                do i=1, fromne
                   ke = ke + len_trim(adjustl(fromenv(i)))+1
                end do
             end if
             
             allocate(exes(ks+1),args(ka+1),envs(ke+1))  ! room for null termination
             
             exes = 0
             args = 0
             envs = 0
             
             call cstring(trim(adjustl(fromexe)), exes, '2C')
             
             ka = 1
             do i=1, fromna
                call cstring(trim(adjustl(fromarg(i))), args(ka:),'2C')
                ka = ka+len_trim(adjustl(fromarg(i)))+1
             end do
             
             if (fromne>=0) then
                ke = 1
                do i=1, fromne
                   call cstring(trim(adjustl(fromenv(i))), envs(ke:),'2C')
                   ke = ke+len_trim(adjustl(fromenv(i)))+1
                end do
             end if
             
             call infoLog("jexec_env: executing exec call, "//trim(fromexe))
             
             aer = c_execsystem(asmethod, EXEC_VERBOSE, exes, fromna, args, fromne, envs)
                   
             call infoLog("jexec_env: status of system call =", aer)

             if (j==1) then
                cer = aer   ! record rank 0 result
             else
                call infoLog("jexec_env: sending status to cpu ",j-1)
                call mpi_send(aer, 1, mpi_integer, j-1, 0, splitcomm, ier)
                if (ier/=0) then
                   call errorLog("jexec_env: mpi_send error using splitcomm to cpu ",j-1)
                   ier=0 ; cer=123    ! mark as a rank 0 error
                end if
             end if

             deallocate(exes, args, envs)
             cycle  ! ok

             ! -- loop error exit --
700          continue
             if (j==1) then
                call errorLog("jexec_env: eror setting up system call on rank 0")
                cer = ier
                ier = 0
             else
                call errorLog("jexec_env: eror setting up sibling system call, sending status to cpu ",j-1)
                call mpi_send(ier, 1, mpi_integer, j-1, 0, splitcomm, aer)  ! send loop error to sibling
                if (aer/=0) then
                   call errorLog("jexec_env: mpi_send error after error using splitcomm to cpu ",j-1)
                   ier=0 ; cer=123    ! mark as a rank 0 error
                end if
             end if
          end do
          call infoLog("jexec_env: done with calls on behalf of siblings")
       else
          !
          ! -- siblings just get back the status code --
          !
          call infoLog("jexec_env: waiting for status from rank 0")
          call mpi_recv(cer, 1, mpi_integer, 0, 0, splitcomm, status, ier)
          if (ier/=0) then
             call errorLog("jexec_env: mpi_recv error using splitcomm")
             ier=1 ; goto 800
          end if
          call infoLog("jexec_env: received status =",aer)
       end if

       ier = cer  ! made it through ok, set subroutine error flag to system call error
          
       ! -- done with splitcomm --
800    continue
       if (mysplit==0 .and. mycwd(1:1)/=' ') then
          call sset_cwd(trim(mycwd),aer)  ! restore cwd after being changed to sibling cwd
          if (aer/=0) then
             call errorLog("jexec_env: error restoring rank 0 cwd")
             ier=1 
          end if
       end if

       if (allocated(fromarg)) deallocate(fromarg,fromenv)
       if (allocated(iall))    deallocate(iall)
       if (allocated(imash))   deallocate(imash)

       call mpi_comm_free(splitcomm, aer)
       if (aer/=0) then
          call errorLog("jexec_env: mpi_comm_free error")
          ier=1 
       end if
    end if
#endif

900 continue
    
#ifdef __MPI
    if (present(barrier)) then
       if (barrier) then
          call MPI_BARRIER(use_comm, iber)
          if (iber/=0) then
             call errorLog("jexec_env: barrier error")
             ier=1
          end if
       end if
    end if
#endif
    
    if (ielog) call exitLog("jexec_env")

  contains
    !
    ! --------- tostr ---------
    ! extracts the string in the integer array
    !
    subroutine tostr(iin, str)
      integer,       intent(in)  :: iin(*)   ! part of imash, max length EXEC_MAX_STR including terminating 0
      character(len=*), intent(out) :: str      ! place string here

      integer :: m   ! loop variable

      ier = 0
      str = ' '

      do m=1, EXEC_MAX_STR
         if (iin(m)==0) return
         str(m:m) = char(iin(m))
      end do

      call errorLog("jexec_env.tostr: did not find terminating 0 in integer representation of string")
      ier=1
    end subroutine tostr
  end function jexec_env
  
  !
  ! --------- jexec_one ----------
  !
  ! Make an exec call with the default environment.
  ! Generally, the first argument should be the name of the command being executed.
  !
  ! For an MPI environment, the communicator (default MPI_COMM_WORLD) must have been added to mpi_proc_data
  ! and only I/O ranks will execute the system call.
  !
  function jexec_one(exe, na, arg, comm, barrier, allcpus, method) result(ier)
    character(len=*), intent(in) :: exe            ! command to execute, will be searched on path
    integer,          intent(in) :: na             ! number of arguments
    character(len=*), intent(in) :: arg(na)        ! list of arguments

    integer, optional, intent(in) :: comm     ! communicator used as basis for opening a connection.  Only the
                                              ! unique ranks on each node associated with this communicator
                                              ! will open a connection.  This communicator must have been added to
                                              ! mpi_proc_data with mpi_proc_data.mpi_env_comm_add().  If not present,
                                              ! MPI_COMM_WORLD will be used.
    logical, optional, intent(in) :: barrier  ! for an mpi call, an mpi_barrier will be called before exiting
                                              ! this subroutine if barrier=.true.
    logical, optional, intent(in) :: allcpus  ! .true. if command should be executed for all the cpus
                                              ! .false. if only the io-node cpus should execute the command (default)
    integer, optional, intent(in) :: method   ! if present, use this in place of EXEC_METHOD -- only valid if method=0,1

    integer :: ier    ! returned status code of command

    character(len=8) :: env(0)  ! no environment

    ier = jexec_env(exe,na,arg,-1,env,comm=comm,barrier=barrier,allcpus=allcpus,method=method)
  end function jexec_one
  
end module execsystem

C******************** START FILE UERMSI.FOR ; GROUP URDUTS ******************
C------------------------------------------------------------
C& UERMSI  UREAD ERROR MESSAGE WITH INTEGER VALUE ECHO
      SUBROUTINE UERMSI(MSG,INT,ICOD)
C
      CHARACTER*(*) MSG
      CHARACTER*20 IBUF
C
      WRITE(IBUF,1001,ERR=10) INT
 1001 FORMAT(I20)
      GO TO 20
C
 10   CONTINUE
      IBUF='**.GT.I20*'
C
 20   CALL UERMSG(MSG,IBUF,ICOD)
      RETURN
      END
C******************** END FILE UERMSI.FOR ; GROUP URDUTS ******************

subroutine r8fftsc(a,n,st,ct,ifail)
  !-----------------------------------------------------------------------
  !  DMC -- real(fp) precision IMSL replacement routine
  !         locally allocated, saved workspace objects for each problem
  !         size (n) that is seen.  This may not be thread safe;
  !         this is only intended to replace copied IMSL routines in some
  !         serial TRANSP-related data processing applications.  For codes
  !         requiring high performance FFT, use FFTW 2.1.5.
  !
  !--------------------------------
  !   some IMSL comments retained...
  !--------------------------------
  !
  !   purpose             - compute the sine and cosine transforms of
  !                           a real valued sequence
  !
  !   usage               - call fftsc (a,n,st,ct,iwk,wk,cwk)
  !
  !   arguments    a      - input real vector of length n which
  !                           contains the data to be transformed.
  !                n      - input number of data points to be transformed.
  !                           n must be a positive even integer.
  !                st     - output real vector of length n/2+1
  !                           containing the coefficients of the
  !                           sine transform.
  !                ct     - output real vector of length n/2+1
  !                           containing the coefficients of the
  !                           cosine transform.
  !
  !              ifail    - 0 on exit: normal
  !                       - 1 on exit: could not allocate workspace
  !
  !   notation            - information on special notation and
  !                           conventions is available in the manual
  !                           introduction or through imsl routine uhelp
  !
  !   remarks  1.  fftsc computes the sine transform, st, according
  !                to the following formula;
  !
  !                  st(k+1) = 2.0 * sum from j = 0 to n-1 of
  !                            a(j+1)*sin(2.0*pi*j*k/n)
  !                  for k=0,1,...,n/2 and pi=3.1415...
  !
  !                fftsc computes the cosine transform, ct, according
  !                to the following formula;
  !
  !                  ct(k+1) = 2.0 * sum from j = 0 to n-1 of
  !                            a(j+1)*cos(2.0*pi*j*k/n)
  !                  for k=0,1,...,n/2 and pi=3.1415...
  !            2.  the following relationship exists between the data
  !                and the coefficients of the sine and cosine transform
  !
  !                  a(j+1) = ct(1)/(2*n) + ct(n/2+1)/(2*n)*(-1)**j +
  !                           sum from k = 1 to n/2-1 of
  !                            (ct(k+1)/n*cos((2.0*pi*j*k)/n) +
  !                             st(k+1)/n*sin((2.0*pi*j*k)/n))
  !                  for j=0,1,...,n-1 and pi=3.1415...
  !
  !
  !-----------------------------------------------------------------------
  use iso_c_binding, only: fp => c_double
  implicit none
  !
  !                                  specifications for arguments
  !
  integer :: n
  real(fp) :: a(n),st(*),ct(*)
  integer :: ifail
  !
  !-----------------------------------------------------------------------
  !
  type :: fftwk
    integer :: n_size
    real(fp), dimension(:), pointer :: wka => NULL()
  end type fftwk
  !
  real(fp), dimension(:), pointer :: wka => NULL()
  !
  integer, save :: n_save = 0
  !
  !  collection of work arrays:
  !
  integer, parameter :: nmax=50
  type (fftwk), dimension(nmax), save :: fw
  !
  !-----------------------------------------------------------------------
  integer :: isize,in2p1,ino2,k1,k2,i,imatch
  real(fp), dimension(:), allocatable :: awk
  !-----------------------------------------------------------------------
  !
  ifail = 0
  !
  if(n.le.0) return
  !
  in2p1 = n/2 + 1

  st(1:in2p1) = 0.0_fp
  ct(1:in2p1) = 0.0_fp
  !
  !-------------------------------
  !
  imatch=0
  do i=1,n_save
    if(fw(i)%n_size.eq.n) then
      imatch=i
      exit
    end if
  end do

  if(imatch.eq.0) then
    if(n_save.eq.nmax) then
      write(6,*) ' ?r8fftsc: nmax exceeded. '
      ifail=1
      return
    end if

    n_save = n_save + 1
    fw(n_save)%n_size = n

    isize = 2*n + 30
    allocate(fw(n_save)%wka(isize)); fw(n_save)%wka = 0.0_fp

    call r8rffti(n,fw(n_save)%wka)

    imatch = n_save
  end if

  wka => fw(imatch)%wka
  !
  !-------------------------------
  !
  allocate(awk(n))
  awk = a
  !
  call r8rfftf(n,awk,wka)
  !
  ct(1)=awk(1)*2.0_fp
  st(1)=0.0_fp
  !
  k1=0
  k2=1
  !
  ino2 = (n+1)/2
  !
  do i=2,ino2
    k1=k1+2
    k2=k2+2

    ct(i) = awk(k1)*2.0_fp
    st(i) = -awk(k2)*2.0_fp
  end do
  !
  if(ino2.lt.in2p1) then
    k1=k1+2
    ct(i)=awk(k1)*2.0_fp
  end if

  return
end subroutine r8fftsc

!------------------------------------------------------------------------------
!
real(fp) FUNCTION SGHECX(ZE)
!  ZE IN EV
!  SGHECX IN CM**2
!
!  JANEV-LANGER-EVANS-POST,
!  ELEMENTARY PROCESSES IN HYDROGEN-HELIUM PLASMAS
!  FIT FOR REACTION 6.3.1, HE + HE++ <--> HE++ + HE DBL CHARGE EXCHANGE
!
!  FIT TABLE IN SS 8.1, P. 255
!
!============
! idecl:  explicitize implicit INTEGER declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  INTEGER i
!============
! idecl:  explicitize implicit REAL declarations:
  real(fp) ze,zle,zls
!============
  real(fp) A631(9)
  DATA A631/-3.459818e+01_fp,-8.748942e-02_fp,&
       -2.445604e-02_fp,&
       2.392295e-03_fp, 9.876388e-04_fp,&
       -2.282013e-04_fp,&
       3.598361e-06_fp, 1.940270e-06_fp,&
       -1.105795e-07_fp/
!
  ZLE=log(ZE)
!
  ZLS=A631(9)
  DO I=8,1,-1
     ZLS=ZLS*ZLE+A631(I)
  enddo
!
  SGHECX=EXP(ZLS)
!
  RETURN
END FUNCTION SGHECX
!
!------------------------------------------------------------------------------
! 30Jun2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok -s r8_precision.sub "r8con.csh conversion"
! 02Aug2000 fgtok
 
 

      subroutine mds_whdr(lun,path,signam,comment,ufname,toff,ier)
 
C Write header info to MDSplus
C 02/09/01 CAL
C
      implicit none
C
      integer       lun       ! lun for error messag
      character*(*) path      ! MDS path
      character*(*) signam    ! MDS signal name
      character*(*) comment
      character*(*) ufname    ! Ufile name
      real          toff
      integer       ier
 
C For MDSplus
      integer       MdsPut,   idescr_float
      integer       descr, idescr_cstring, mds__cstring
      character*90  expr
      integer       dscr,      stat
      integer       ilp, l
 
C-------------------------------------------------------------------
 
C Write toff
      if (path .eq. '.INPUTS:') then     ! TRANSP Tree only
C         expr='\TOP:T_OFFSET'//CHAR(0)
         expr='T_OFFSET'//CHAR(0)
         stat=MdsPut(expr,'$'//char(0),
     >        idescr_float(toff),0)
         if (mod(stat,2).ne.1) then
            call mdsmsg(lun,expr//' put status:  ',stat)
            ier=1
         endif
      endif
 
C Write comment
      expr=path//signam//':COMMENT'//CHAR(0)
      dscr = descr(mds__cstring(), comment, 0, len(comment))
      stat=MdsPut(expr,'$'//char(0),
C     >     idescr_cstring(comment),0)
     >     dscr,0)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,expr//' put status:  ',stat)
         if (stat .eq. 265388144) then  !  TreeNNF
            ier=2
         endif
      endif
C Write Ufile Name
      expr=path//signam//':FILENAME'//CHAR(0)
      dscr = descr(mds__cstring(), ufname, 0, len(ufname))
      stat=MdsPut(expr,'$'//char(0),
     >     dscr,0)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun,expr//' put status:  ',stat)
         if (stat .eq. 265388144) then  !  TreeNNF
            ier=2
         endif
      endif
 
      return
      end

C******************** START FILE WKCHK.FOR ; GROUP UTL2D ******************
C--------------------------------------------------------------
C  WKCHK - CHECK ARRAY DIMENSION
C
      SUBROUTINE WKCHK(NWK,NMIN,MSG,IER)
C
      CHARACTER*(*) MSG
C
      IER=0
C
      IF(NWK.LT.NMIN) THEN
        write(6,9001) MSG,NWK,NMIN
 9001 FORMAT(' ? ERROR DETECTED: ',A/
     >'   INADEQUATE WORK ARRAY DIMENSION; NWK=',I6,' NMIN=',I6)
        IER=1/IER
      ENDIF
      RETURN
C
      END
C******************** END FILE WKCHK.FOR ; GROUP UTL2D ******************

C******************** START FILE UFSCOR.FOR ; GROUP UFILS0 ******************
C-----------------------------------------------------------------
C  UFSCOR
C  CALCULATE KEYWORD ALPHABETIC ORDER
C
      SUBROUTINE UFSCOR(NSC,SCLAB,IORDER)
C
      USE UFILES
C
      CHARACTER*30 SCLAB(NSC)
      INTEGER IORDER(*)
C
C  KEYWORD FOR JTH SCALAR IN SCLAB(J)
C
      IORDER(1)=1
      IF(NSC.LE.1) RETURN
C
      DO 10 ISC=2,NSC
C  LOCATE ALPHABETIC POSITION OF NEXT ENTRY
        ILOC=IUFSLO(SCLAB(ISC)(1:10),ISC-1,SCLAB,IORDER,IEQ)
C  IF EQUALS FLAG IS SET THERE IS A DUPLICATE KEYWORD-- FATAL ERROR
        IF(IEQ.EQ.1) GO TO 9000
C  INSERT ENTRY IN ORDER ARRAY
        CALL UFSCIN(ILOC,ISC-1,NSC,IORDER)
 10   CONTINUE
      RETURN
C  FATAL ERROR
 9000 CONTINUE
      WRITE(UFELUN,9001) SCLAB(ISC)
 9001 FORMAT(' ? UFSCOR FATAL ERROR-- DUPLICATE KEYWORD:  "',A,'"'/
     >         '   UF0RDR ERROR CHECKING FAILED')
      call bad_exit
      END
C******************** END FILE UFSCOR.FOR ; GROUP UFILS0 ******************

real(fp) function cloge_r8_fcn(znecm3i,zteevi,zzeffi,iwarn)

  ! compute the electron coulomb log in REAL*8 precision
  ! formula from TRANSP source/magcor/loglam.for
  ! this code 0d, no "trcom".

  ! warning flag set if any values are out of expected range:
  !   zzeffi < 1, zne13i < 1, zteevi < 1

  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: one
  implicit none

  real(fp), intent(in) :: znecm3i  ! input electron density, cm**-3
  real(fp), intent(in) :: zteevi   ! input electron temperature, eV
  real(fp), intent(in) :: zzeffi   ! input Zeff = sum(ni*Zi**2)/ne

  integer, intent(out) :: iwarn  ! 0: normal; 1: input range warning

  !-------------------------------------------
  real(fp) :: zne13,zteev,zzeff
  real(fp) :: zlamde
  !-------------------------------------------

  iwarn = 0

  if(znecm3i.lt.ONE) then
    zne13=ONE
    iwarn=1
  else
    zne13=znecm3i
  endif

  if(zteevi.lt.ONE) then
    zteev=ONE
    iwarn=1
  else
    zteev=zteevi
  endif

  if(zzeffi.lt.ONE) then
    zzeff=ONE
    iwarn=1
  else
    zzeff=zzeffi
  endif

  ! here the actual computation...

  if(zteev.lt.(50.0_fp)) then
    ZLAMDE=1.54e10_fp*zteev*SQRT(zteev)/ &
         (zzeff*sqrt(zne13))
  else
    ZLAMDE=1.09e11_fp*zteev/ &
         (zzeff*sqrt(zne13))
  endif

  cloge_r8_fcn = log(zlamde)

  return
end function cloge_r8_fcn

C******************** START FILE UREADC.FOR ; GROUP UREADT ******************
C& UREADC  ISSUE UREAD PROMPT, RETURN CHARACTER -- UPPER CASE
      subroutine ureadc(prompt,char)
      character*(*), intent(in) :: prompt
      character*1, intent(inout) :: char
c
      call ureadic(prompt,char,1)
c
      return
      end
C
C& UREADLC  ISSUE UREAD PROMPT, RETURN CHARACTER -- Case unchanged
      subroutine ureadLc(prompt,char)
      character*(*), intent(in) :: prompt
      character*1, intent(inout) :: char
c
      call ureadic(prompt,char,0)
c
      return
      end
C
C----------------------------------------------------------
C& UREADC  ISSUE UREAD PROMPT, RETURN CHARACTER -- upper or lower case
C
      SUBROUTINE UREADIC(PROMPT,CHAR,iup)
C
      USE USERIO
C
      CHARACTER*(*), intent(in) :: PROMPT
      CHARACTER*1, intent(inout) :: CHAR
      integer, intent(in) :: iup
C
C
C *LISMAK* 12-APR-88  GENERATED LOGICAL DECLARATIONS
      LOGICAL LCHAR
C *LISMAK* END OF GENERATED LOGICAL DECLARATIONS
C
      IF(NLXOUT) WRITE(LUNTRM,1001) CHAR
 1001 FORMAT(' [OLD VALUE:  "',A,'"]')
C
      CALL UREAD(PROMPT)
C
      IF(LCHAR(' ').OR.LCHAR(',')) THEN
        IF(NLXOUT) WRITE(LUNTRM,1002)
 1002 FORMAT(' % OLD VALUE RETAINED')
      ELSE
        CALL URCHAR(CHAR,iup,ID,IER)
        CALL UROTOR(ID)
        IF(IER.NE.0) CALL UERMSG(
     >'?UREADC:  INPUT STRING NOT VALID AS SINGLE CHARACTER INPUT',
     >UWORD(1:LUWORD),1)
 
      ENDIF
C
      RETURN
      END
C******************** END FILE UREADC.FOR ; GROUP UREADT ******************

      subroutine uf_lbck(lbl_name,lbl_i,lbl)
c
c  convert label-as-passed to label-as-used
c  output warnings if label-as-passed contains apparent garbage
c  (non-printable characters)
c
      use UFILES
c
      character*(*) lbl_name,lbl_i,lbl
c---------------------------------------------
c
      ilen_lbl=len(lbl)
      ilen_i=len(lbl_i)
c
      lbl=' '
      do i=1,ilen_i
         ic=ichar(lbl_i(i:i))
         if((ic.lt.32).or.(ic.ge.127)) then
            write(ufelun,1001) lbl_name,lbl(1:max(1,i-1))
 1001       format(' %uf_lbck: non-ascii character in label "',a,'"'/
     >           '  label starts:  "',a,'" (standard fixup applied).')
            exit
         else if(i.le.ilen_lbl) then
            lbl(i:i)=lbl_i(i:i)
         else
            if(ic.ne.32) then
               write(ufelun,1002) lbl_name
 1002          format(' %uf_lbck:  label "',a,'" truncated.'/
     >              '  label starts:  "',a,'".')
               exit
            endif
         endif
      enddo
c
      return
      end

C******************** START FILE LARCMP.FOR ; GROUP UFILES ******************
C-------------------------------------------------------------
C  LARCMP
C  COMPARE TWO REAL ARRAYS
C  RETURN .TRUE. IF THEY ARE THE SAME WITHIN TOLERANCES:
C   ZABS- ABSOLUTE TOLERANCE
C     COMPARE WITH ABS(X1(J)-X2(J))
C   ZREL- RELATIVE TOLERANCE
C    COMPARE TO ABS( (X1(J)-X2(J))/(.5*(X1(J)+X2(J))) )
C
C  NOTE ZABS IN UNITS OF X; ZREL A DIMENSIONLESS FRACTION
C
C  OUTPUT POINTER IPT POINTS OUT LOCATION OF PROBLEM
C   IPT=0 INDICATES ARRAYS HAVE DIFFERENT SIZES
C
      LOGICAL FUNCTION LARCMP(X1,NX1,X2,NX2,ZABS,ZREL,IPT)
C
      DIMENSION X1(NX1),X2(NX2)
C
c$r8real_input: x1,x2,zabs,zrel
C
      LARCMP=.FALSE.
      IPT=0
      IF(NX1.NE.NX2) RETURN
      IF(NX1.LE.0) RETURN
C
      DO 10 I=1,NX1
      IPT=I
      ZDIV=ABS(X1(I)-X2(I))
      IF(ZDIV.LE.ZABS) GO TO 10
C  POINT MUST DIVERGE BY BOTH CRITERIA TO BE CONSIDERED DIVERGANT
      ZAVG=.5*ABS(X1(I)+X2(I))
      IF(ZAVG.EQ.0.0) RETURN
      IF(ZREL.LT.(ZDIV/ZAVG)) RETURN
 10   CONTINUE
C
      LARCMP=.TRUE.
      RETURN
      	END
C******************** END FILE LARCMP.FOR ; GROUP UFILES ******************

!-----------------------------------------------------------------------
!  PSGHECI -- CROSS SECTION OF C+6 + HE --> C+6 + HE+
!
real(fp) FUNCTION psgheci8(ZE)
!
! INPUT
!  ZE -- COLLISION ENERGY **PER NUCLEON**  EV/AMU
!
! OUTPUT
!  PSGHECI -- CROSS SECTION, CM**2
!
! REFERENCE
!  ORNL-6090/V5, ATOMIC DATA FOR FUSION, VOLUME V,
!    "COLLISIONS OF CARBON AND OXYGEN IONS WITH ELECTRONS, H, H2, & He"
!    R.A. PHANEUF, R.K. JANEV, M.S. PINDZOLA
!
!============
! idecl:  explicitize implicit REAL declarations:
  use iso_c_binding, only: fp => c_double
  IMPLICIT NONE
  real(fp) ze,emin,emax,zans,psgchvx8
!============
  real(fp) CCHEV(9)
!
  DATA EMIN/7.0e+4_fp/
  DATA EMAX/1.0e+7_fp/
!
  DATA CCHEV/&
       -7.14158e+01_fp,-4.33084e-1_fp,-7.87646e-1_fp,&
       2.87762e-1_fp,-6.17663e-2_fp,-1.55591e-2_fp,&
       2.35773e-2_fp,-5.56158e-3_fp,-1.02408e-2_fp/
!
  ZANS=psgchvx8(2,ZE,EMIN,EMAX,CCHEV)
  psgheci8=ZANS
!
  RETURN
END FUNCTION psgheci8
! 21Jun2001 fgtok -s r8_precision.sub foo.tab "r8con.csh conversion"
! 21Jun2001 fgtok

C******************** START FILE URGET1.FOR ; GROUP UREAD5 *************
C
C--------------------------------------------------------------
C
C& URGET1   UREAD: READ ONE INPUT LINE FROM TTY OR FILE
C
C  IF(NLINDI) -- LINE COMES FROM INDIRECT INPUT FILE BUFFER
C     MAIN PROGRAM (CALLER OF UREAD3) IS BEING CONTROLLED AUTOMATICALLY
C     BY INPUT FROM A DISK FILE
C  IF NOT, LINE COMES FROM TERMINAL; PROGRAM IS BEING CONTROLLED
C     INTERACTIVELY
C
C  OUTPUT FLAGS
C   IER=1 IF ERROR ON READ FROM INPUT FILE
C   IEOF=1 IF EOF ON INPUT FILE
C  OTHERWISE, OR IF INPUT IS FROM TTY, BOTH FLAGS =0
C
C  LREADY FLAG IS SET (FLAG THAT UREAD SYSTEM IS READY TO ACCEPT
C  A COMMAND AND RETURN IT TO MAIN PROGRAM) IF TTY IS SOURCE OF INPUT
C
C  MOD DMC FEB 1989 -- ACCEPT COMMAND LEVEL INPUT FROM THE LINE
C  PRE-BUFFER (PREBUF) WHICH MAY BE FILLED FROM THE APPLICATION VIA
C  URDTTY CALLS
C
      SUBROUTINE URGET1(IER,IEOF)
C
      USE USERIO
C
C-------------------------------------------------------------------
C  URFILE-- IND. INPUT FILE NAME (IF ANY)
C
      IER=0
      IEOF=0
C
C  MAINTAIN RECORD OF RECENT INPUT LINES TO DUMP IN CASE OF ERROR
      CALL UCBCLR
      IF(NLINDI) GO TO 210
c
c  read from terminal
c
      CALL UREADY(1)
      IERTRM=0
 9998 IF(IERTRM.GT.0) WRITE(LUNTRM,9999)
 9999 FORMAT(' TTY READ ERROR')
      IERTRM=IERTRM+1
C  STOP IF ERROR COUNT TOO LARGE
      IF(IERTRM.LT.10) GO TO 9996
      WRITE(LUNTRM,9997)
 9997 FORMAT(//' ? TTY ERROR COUNT .GT. 10  ==>  ABORT'//)
      CALL URDABO
 9996 CONTINUE
C
C  USE APPLICATION PRESET LINE BUFFER IF AVAILABLE, OR, READ
C  FROM TERMINAL
C
      IF(NPRBUF.GT.0) THEN
        CBUFF=PREBUF(LPRBUF)
        LPRBUF=LPRBUF+1
        NPRBUF=NPRBUF-1
      ELSE
        CALL URDSTR(CBUFF,IEOF,IERR)
        IF(IEOF.EQ.1) GO TO 9994
        IF(IERR.NE.0) GO TO 9998
CXX	    READ(LUNTIN(1),'(A)',ERR=9998,END=9994) CBUFF
      ENDIF
C
      IL=MAX0(NLUNIN,NLUNIO)
      NCMND(IL)=NCMND(IL)+1
      GO TO 219
C-------------
 9994 CONTINUE
      WRITE(LUNTRM,9995)
 9995 FORMAT(/' *** END OF FILE EXIT ***'/)
      CALL UEXITA(0)
      CALL URDABO
C
C-------------
 210  CONTINUE
c  read buffered from indirect input file
      call ufiget(URFILE,2,ier,ieof)
C-------------
 219  CONTINUE
C
C  RECORD INPUT LINE/TYPEAHEAD BUFFER IN 2NDRY STORAGE FOR
C  DEBUG IF ERROR OCCURS
      CALL UCBUFP
      RETURN
      END
C******************** END FILE URGET1.FOR ; GROUP UREAD5 ***************

      subroutine txtblok_in(lun,filename,txtarray,nmax,ngot,istat,
     >   maxwid)
c
c  read a file into a text array in memory
c
      implicit NONE
C
c input:
      integer lun                       ! input logical unit no.
      character*(*) filename            ! file to open and read
c
      integer nmax                      ! size of text array
c
c output:
      character*(*) txtarray(nmax)      ! array to hold text read
c
      integer ngot                      ! number of text lines read
c
      integer istat                     ! output status code (see below)
c
      integer maxwid                    ! maximum non-blank line width
c
c on exit:
c
c  istat=0  --  normal completion; entire file fits in array.
c   ...ngot=<# of lines read in>
c  istat=1  --  file open error
c   ...ngot=0
c  istat=2  --  file read error
c   ...ngot=<# of lines read in prior to error>
c
c  istat=10 --  error:  txtarray too short to contain entire file
c   ...ngot=nmax
c
c  istat=11 --  warning:  truncation:  text line in file is wider than
c               txtarray array element can store
c   ...ngot=<# of lines read in>
c
      integer ier,iline,ilb,ilnurd
      character*180 ibuff               ! input line buffer
c
c----------------------------
c
      ngot=0
      istat=0
      maxwid=0
c
      call ufopen(lun,filename,1,ier,0)
c
      if(ier.ne.0) then
         istat=1
         go to 1100
      endif
c
      iline=len(txtarray(nmax))
c
c  read loop
c
 10   continue
      read(lun,'(A)',end=80,err=90) ibuff
c
      ilb=ilnurd(ibuff)
      maxwid=max(ilb,maxwid)
      if(ilb.gt.iline) then
         istat=11
      endif
c
      ilb=min(iline,ilb)
c
      if(ngot.eq.nmax) then
         istat=10
         go to 1000
      endif
 
      ngot=ngot+1
      txtarray(ngot)=ibuff(1:ilb)
c
      go to 10
c
c------------------------
c
 80   continue
c
c  end of file (normal)
c
      go to 1000
c
 90   continue
c
c  READ ERROR
c
      istat=2
      go to 1000
c
c---------------------
c
c  exit
c
 1000 continue
      close(unit=lun)
c
 1100 continue
      return
      end

subroutine r8sincos(ZTHETA,JANG,SNTHTK,CSTHTK)
  !
  !	THIS subroutine CALCULATES:
  !		SIN(ZTHETA)
  !		COS(ZTHETA)
  !		SIN(2*ZTHETA)
  !		COS(2*ZTHETA)
  !	ETC., UP TO JANG*ZTHETA
  !
  !
  !		ZTHETA IS INPUT ANGLE
  !		JANG IS HIGHEST N*ZTHETA TO CALCULATE
  !		SNTHTK IS THE ARRAY CONTAINING SIN(N*ZTHETA)
  !		CSTHTK IS THE ARRAY CONTAINING COS(N*ZTHETA)
  !
  use iso_c_binding, only: fp => c_double
  implicit none
  integer :: jang, i
  real(fp) :: ztheta, zthetap, zsinp, zcosp
  real(fp), dimension(jang) :: snthtk, csthtk
  !
  !  LOCAL MEMORY (DMC 6 JUL 1994)
  !
  DATA ZTHETAP/0.0E0_fp/
  DATA ZSINP/0.0E0_fp/
  DATA ZCOSP/1.0E0_fp/
  !
  SAVE ZTHETAP,ZSINP,ZCOSP
  !
  !--------------------------------------------------------------------
  !
  !  DMC -- USE LOCAL MEMORY FOR SPEED
  !
  if(ZTHETA.NE.ZTHETAP) then
    !
    !  EVALUATE SIN,COS
    !
    SNTHTK(1)=SIN(ZTHETA)
    CSTHTK(1)=COS(ZTHETA)
    ZTHETAP=ZTHETA
    ZSINP=SNTHTK(1)
    ZCOSP=CSTHTK(1)
  else
    !
    !  REUSE PREVIOUS RESULTS
    !
    SNTHTK(1)=ZSINP
    CSTHTK(1)=ZCOSP
  end if
  !
  do I=2,JANG
    SNTHTK(I)=SNTHTK(I-1)*CSTHTK(1)+CSTHTK(I-1)*SNTHTK(1)
    CSTHTK(I)=CSTHTK(I-1)*CSTHTK(1)-SNTHTK(I-1)*SNTHTK(1)
  end do

  return
end subroutine r8sincos

C******************** START FILE LOKJAC.FOR ; GROUP TKBLOAT ******************
 
C-- END FILE #BLOAT# ************************************
CFORMFEEDC-- START FILE #LOKJAC# ************************************
       LOGICAL FUNCTION LOKJAC(R0,DR0DXI,RJ,DRJDXI,YJ,DYJDXI,NMOM)
C
C
C       BOB MCCANN, 19-APR-85
C
C
C       --------
C       COMMENTS
C       --------
C
C
C	THIS CHECKS TO SEE IF THE JACOBIAN D(R<Y)/D(XI,XI) CHANGES SIGN
C    AROUND THE GIVEN FLUX SURFACE.  LOKJAC=.T. IF THE SIGN IS UNCHANGED,
C    AND LOKJAC=.F. IF THE SIGN CHANGES
C    (THE TRANSFORMATION WENT SINGULAR).
C
C
C       -------------------
C       GLOBAL DECLARATIONS
C       -------------------
C
C
C***
C
C
C       ---------------
C       INPUT VARIABLES
C       ---------------
C
C
      INTEGER	NMOM		!# OF MOMENTS OF R, Y
C
C    THE FOLLOWING REFER TO A GIVEN FLUX SURFACE:
C
      REAL	R0		!ZEROTH MOMENT
      REAL	DR0DXI		!D(R0)/DXI
      REAL	RJ(NMOM)	!J=1,NMOM MOMENTS OF R
      REAL	DRJDXI(NMOM)	!D(RJ)/DXI
C
      REAL	YJ(NMOM)	!K=1, NMOM MOMENTS OF Y
      REAL	DYJDXI(NMOM)	!D(YJ)/DXI
C
C
C       ----------------
C       OUTPUT VARIABLES
C       ----------------
C
C
C	LOGICAL LOKJAC	!=.T. IF THE TRANSFORMATION IS OK
C			!=.F. IF THE COORDINATES ARE SINGULAR
C
C
C       ------------------
C       LOCAL DECLARATIONS
C       ------------------
C
C
      PARAMETER	(NTH = 127)	!# ANGLES TO USE IN FINDING EXTREMA
C
      REAL	ZC(NTH)		!COS(J*TH) ASSUMING NMOM.LE.NTH
      REAL	ZS(NTH)
C
      REAL	ZR77		!R(TH)
      REAL	ZY77		!Y(TH)
      REAL	ZDRDTH		!DR/DTH
      REAL	ZDYDTH		!DY/DTH
      REAL	ZDRDXI		!DR/DXI
      REAL	ZDYDXI		!DY/DXI
      REAL	ZJ		!JACOBIAN
C
C
C       ---------------
C       DATA STATEMENTS
C       ---------------
C
C
C***
C
C
C       -------------------
C       STATEMENT FUNCTIONS
C       -------------------
C
C
C***
C
C
C=========================================
C
C
C       ----------------------
C       0.1     INITIALIZATION
C       ----------------------
C
C
      ZPI = 4.0*ATAN(1.0)
C
C    LOOP OVER SOME ANGLES FROM 0 TO PI:
C
      DO 69000 I = 1, NTH
C
        ZTH = ZPI*FLOAT(I-1)/FLOAT(NTH-1)
C
        DO 100 J = 1, NMOM
          ZC(J) = COS(J*ZTH)
          ZS(J) = SIN(J*ZTH)
100     CONTINUE
C
C
C	----------------------------------------------
C	1.0	COMPUTE VARIOUS DERIVATIVES OF R AND Y
C	----------------------------------------------
C
C
10000 CONTINUE
C
C    HANDLE ZEROTH MOMENT AND INITIALIZE THE MOMENTS LOOP
C
      ZR77 = R0
      ZDRDXI = DR0DXI
      ZDRDTH = 0.0
C
      ZY77 = 0.0
      ZDYDTH = 0.0
      ZDYDXI = 0.0
C
C    ADD UP THE CONTRIBUTION FROM EACH MOMENT
C
      DO 10100 J = 1, NMOM
C
        ZR77 = ZR77 + RJ(J)*ZC(J)
C
        ZDRDXI = ZDRDXI + DRJDXI(J)*ZC(J)
        ZDRDTH = ZDRDTH - RJ(J)*FLOAT(J)*ZS(J)
C
        ZY77 = ZY77 + YJ(J)*ZS(J)
C
        ZDYDXI = ZDYDXI + DYJDXI(J)*ZS(J)
        ZDYDTH = ZDYDTH + YJ(J)*FLOAT(J)*ZC(J)
C
10100 CONTINUE
C
C
C       -------------------------------------------------
C       2.0     COMPUTE THE JACOBIAN OF THIS FLUX SURFACE
C       -------------------------------------------------
C
C
20000   CONTINUE
C
      ZJ = ZDRDXI*ZDYDTH - ZDRDTH*ZDYDXI	!JACOBIAN
C
C
C	--------------------------------------------------
C	3.0	FIND THE MAXIMA AND MINIMA OF THE JACOBIAN
C	--------------------------------------------------
C
C
30000 CONTINUE
C
      IF(I.EQ.1)	THEN	!INITIALIZE MAX AND MIN
C
        ZJMIN = ZJ
        THJMIN = ZTH
        ZJMAX = ZJ
        THJMAX = ZTH
C
      ELSE			!FIND THE TRUE MIN AND MAX
C
        IF(ZJ.LT.ZJMIN)	THEN
          ZJMIN = ZJ
          THJMIN = ZTH
        ELSEIF(ZJ.GT.ZJMAX)	THEN
          ZJMAX = ZJ
          THJMAX = ZTH
        ENDIF
C
      ENDIF
C
69000 CONTINUE		!END OF ANGLE LOOP
C
C
C       ------------------------
C       7.0     CLEANUP & RETURN
C       ------------------------
C
C
70000   CONTINUE
C
C
      IF(ZJMIN*ZJMAX.GT.0.0)	THEN	!THEY HAVE THE SAME SIGN
          LOKJAC = .TRUE.
      ELSE
          LOKJAC = .FALSE.
      ENDIF
C
C
79000   CONTINUE        !ERROR RETURNS HERE
C
        RETURN
C
C
C       ----------------------
C       8.0     ERROR HANDLING
C       ----------------------
C
C
C***
C
C
        END
C******************** END FILE LOKJAC.FOR ; GROUP TKBLOAT ******************
